//============================================
// ksm 30.03.2004 Объект перечислений
// Олег 01.04.2010 Переделал под v.12
include("objects\\DpGetDat.js")
include("objects\\DpTVars.js");
include("objects\\DpEval.js");
include("objects\\DpAskEx.js");
include("Objects\\DpMsgBox.js");
include("servis\\date.js");
include("servis\\zrp.js");

//Таблица видов (мест) перечислений
var TBL_TRPLACE	= "CL_TRPLACE"
//Таблице сберкасс
var TBL_SBCS	= "CL_SBCS";
//Таблица параметров сберкасс
var TBL_CL_TRP	= "CL_TRP";
//Таблица с приказами для перечисления зарплаты
var TBL_TRPRIK	= "CAS_TR_PR"
//Таблица с приказами для перечисления зарплаты
var TBL_TRALIM = "PRK_AL"


//Сбор отсутствует
var SBTYPE_SBNO	= "NONE";
//Сбор по шкале
var SBTYPE_SBSCALE	= "SCAL"
//Процент от суммы
var SBTYPE_SBPROC	= "PROC"
//Конкретная сумма
var SBTYPE_SBSUM	= "SUMM"

var XML_TRSUM = "transf:l_trsum.xml";

function DpTransfer(mode)
{
	RO("DpTransfer", this);
	//Методы
	//Установить соответствие полей.
	this.setField		= DpTransfer_setField;
	//Установить таблицу для печати.
	this.setTable		= DpTransfer_setTable;
	//Установить значение даты перечислений
	this.setDate		= DpTransfer_setDate;
	//Начать печать.
	this.print			= DpTransfer_print;
	//Функция узнает есть ли в исходной таблице необходимое поле.
	this.isField		= DpTransfer_isField;
	//Согласно выбраным полям формирует запрос
	this.mkSQL			= DpTransfer_mkSQL
	// Запрашивает исходные данные
	this.askData		= DpTransfer_askData;
	//Запрашивает общие данные для печати
	this.askCommonInfo	= DpTransfer_askCommonInfo;
	//Установить форму печати.
	this.setForm		= DpTransfer_setForm;
	//установить метку печати
	this.setPrnPatt		= DpTransfer_setPrnPatt;
	this.printNext		= DpTransfer_printNext;
	//Зделать один цикл печати или экспорта.
	this.doStep			= DpTransfer_doStep;
	//Зделать один цикл печати или экспорта.
	this.prepare		= DpTransfer_prepare;
	//Показать суммы перечислений.
	this.showTrSum		= DpTransfer_showTrSum;
	//нарисовать grid
	//this.toDrawGrid	= DpTransfer_toDrawGrid
	//Создать таблицу с данными из Svzp
	this.mkTblFromSvzp	= DpTransfer_mkTblFromSvzp;
	//Создать таблицу с данными по типу перечисления.
	this.mkTblFromByType= DpTransfer_mkTblFromByType;
	//Получить места перечислений 
	//по указаному таб. № и дате из приказа на перечисление Зп на банки.
	this.getPlaceTR= DpTransfer_getPlaceTR;
	//Установить фильтер
	this.setFilter		= DpTransfer_setFilter;
	//Функция экспорта.
	this.doexport		= DpTransfer_doexport;
	//Установить значение атрибута
	//this.EI_Proc		= DpTransfer_EI_Proc;
	this.setAttr		= DpTransfer_setAttr;
	//Возратить значение атрибута.
	this.getAttr		= DpTransfer_getAttr;
	
	this.setVars 		= DpTransfer_setVars;
	//
	this.pMsgBox		= new DpMsgBox("co!", "Продолжить печать остальных документов?", "Продолжить печать остальных документов?")

	//справочники 
	this.clPers = getPar("CODPERS");
	
	// Поля
	this.mode		= mode;
	this.aFields	= new Array();			//Масив полей соответствий
	this.aAttr		= new Array();			//Массив атрибутов.
	this.prTable	= "";					//Таблица для печати.
	this.dPrdate	= d00;
	this.isSilent		= true;
	this.tblDataPr = null;
	this.oAsk		= new DpAskEx();
	this.tv			= new DpTVars();
	this.mEval		= this.tv.eval;
	this.vars 		= new Array();
	//переменные по умолчанию
	this.mEval.addVar("TRNAME","");
	this.mEval.addVar("TRHEADER","");

	this.filter = "";
	this.dstExpDir = null; //путь експорта куда будет скопирован файл после его создания
	
	//this.expSysDir = getPar("EXPDIR"); //путь експорта который указан в параметрах системы
	//this.printNext = "N";//Флаг можно ли печатать дальше. Y- да N - нет A - прервать.
}
//============================================
function DpTransfer_setFilter(mode){
	this.filter = "";

	oA = new DpAskEx();
	oA.add("T", "Коди категорій", "KOD_KAT", "", 30);
	oA.doAsk();
	if(oA.escape){
		CloseWindow();
		return;
	}	

	KOD_KAT = oA.get("KOD_KAT");
		
	this.filter = isEmpty(KOD_KAT)?"":"inList(RXSHT.FKOD_KAT,"+KOD_KAT+")"
	return true;
}
//============================================
function DpTransfer_setField(szWhat,szFieldname)
{
	szWhat= szWhat.toUpperCase();
	szFieldname= szFieldname.toUpperCase();
	this.aFields[szWhat] = szFieldname;
}

function DpTransfer_setVars(varName, varValue){
	varName = varName.toUpperCase();
	this.vars[varName] = varValue;
}

function DpTransfer_setTable(szTableName)
{
	this.prTable = szTableName;
}

function DpTransfer_setDate(dPrdate,dateTxt)
{

	if (typeof(dPrdate)=="date" )
	{
		this.dPrdate = dPrdate;
	}
	else
	{
		this.oAsk.clear()
		this.oAsk.add("D", isEmpty(dateTxt)?"Дата формування реєстрів перерахуваннь|Дата формирования реестров перечислений":dateTxt, "DAT", new Date());
		this.oAsk.doAsk();
		if (this.oAsk.escape)
		{
			return false;
		}
		this.dPrdate = new Date(this.oAsk.get("DAT"));
	}
	return true
}

function DpTransfer_print(fwids)
{
	//Tori 27.06.2011: возможность печати по отмеченным записям
	if(fwids)
		this.fwids = fwids;
	else
		this.fwids = null;
	//Спросим общие данные
	if (!this.askCommonInfo("PRN"))
	{
		return false;
	}
	this.tv	= new DpTVars();
	this.tv.eval = this.mEval;
	
	if (!this.prepare("PRN"))
	{
		return false;
	}		
	
	this.tv.setOnPrinted(this, "printNext");
	
	for(this.tblCas2Pr.MoveFirst(); !this.tblCas2Pr.IsEOF(); this.tblCas2Pr.MoveNext())
	{
		if(this.doStep("PRN"))
		{
			this.tv.print();
		}
	}
	
}

function DpTransfer_askCommonInfo(mode)
{
	this.oAsk = new DpAskEx();
	
	switch (mode)
	{
		case "EXP":
			this.oAsk.add("D", "Дата формування реєстрів перерахуваннь|Дата формирования реестров перечислений", "DAT", new Date().getVarDate());
			this.oAsk.add("DIR", "Директорія експорту|Директория экспорта", "DIEREXP");
			this.oAsk.doAsk();
			if (this.oAsk.escape){
				return false;
			}
			this.dPrdate	= new Date(this.oAsk.get("DAT"));
			this.dstExpDir	= this.oAsk.get("DIEREXP");
			break;
		case "SVZP":
			this.oAsk.add("D", "Місяць зарплати|Месяц зарплаты","DAT", new Date().getVarDate());
			this.oAsk.doAsk();
			if (this.oAsk.escape){
				return false;
			}
			this.dPrdate = new Date(this.oAsk.get("DAT"));
			break;
		case "PRN":
			this.oAsk.add("D", "Дата формування реєстрів перерахуваннь|Дата формирования реестров перечислений", "DAT", new Date().getVarDate());
			this.oAsk.add("B", "Друк без можливості редагування|Печать без возможности редактирования", "PRNIMDL", false);
			this.oAsk.doAsk();
			if (this.oAsk.escape)
			{
				return false;
			}
			this.dPrdate = new Date(this.oAsk.get("DAT"));
			this.isPrnImdl = this.oAsk.get("PRNIMDL");
		break;
	}
	return true;
}
//============================================
function DpTransfer_doexport(fwids)
{
	//Tori 27.06.2011: возможность экспота по отмеченным записям
	if(fwids)
		this.fwids = fwids;
	else
		this.fwids = null;
	//полный путь к файлу который предварительно создается при експорте
	var path2ExpFile = "";
	
	//Спросим общие данные

	if (!this.askCommonInfo("EXP"))
	{
		return false;
	}
	//Подготовим данные
	if (!this.prepare("EXP"))
	{
		return false;
	}

	this.mEval.setRowTable(this.tblDataPr);
	
	this.tv = new DpTVars();
	this.tv.eval = this.mEval;
	
	
	for(this.tblCas2Pr.MoveFirst(); !this.tblCas2Pr.IsEOF(); this.tblCas2Pr.MoveNext())
	{
		if (this.doStep("EXP"))
		{
			var oExport = new Object();
			
			//формат экспорта 
			//USR - пользовательский
			//PRN - печать в файл 
			var format = String(this.tblCas2Pr.getValue("FEXPTYPE")).toUpperCase();
			
			//из выражения для имени файла узнаем имя файла 
			var fileExpr = this.mEval.eval(String(this.tblCas2Pr.getValue("FFILE")));
			
			//проверяем настроен ли путь в параметрах системы на папку экспорта
			//Tori 02.06.2010: убрал промежуточную директорию экспорта из параметров, будем экспортировать сразу в директорию, указанную пользователем
			//if(!isDir(this.expSysDir))
			if(!isDir(this.dstExpDir))
			{
				msg = "DpTransfer_doexport:";
				alert(msg+"\n"+ru("Директория ","Директорія ")+"\n"+this.dstExpDir+ru("' не существует.","' не існує."), ICON_ERROR);
				return false;
			}
						
			switch (format)
			{
				case "USR":
					var confFileName = String(this.tblCas2Pr.getValue("FEXPFMT")).toLowerCase()+".xml";
					var path2ConfFile = new DpFile(getOrgPath()+"clbank/export/"+confFileName);
					
					//проверка на наличий файла
					if (!isFile(path2ConfFile))
					{
						msg = "DpTransfer_doexport:";
						msg += "\n"+ru("Файл настроки экспорта ", " Файл з налаштуванням для експорту ");
						msg += "\n"+confFileName;
						msg += "\n"+ru(" не существует.", " не існує.");
						alert(msg, ICON_ERROR);
						return false;	
					}
					
					//Объект с параметрами для экспорта
					var xmlConfFile = new DpXMLDOMDocument();
					xmlConfFile.load(path2ConfFile);
					
					var typeEXP = xmlConfFile.getDocumentElement().getAttribute("type").toUpperCase();
					var encodding = xmlConfFile.getDocumentElement().getAttribute("encodding");
					var root = xmlConfFile.getDocumentElement();
					var arrTuning = root.getElementsByTagName("FIELDS")[0].getChildNodes();
				
					switch(typeEXP)
					{
						case "DBF":
							//проверяем если в папке clbank/template шаблон(эталон)
							//ищем по имени(метке) формата экспорта, ну и росширение будет ".dbf"
							var etlFileName = String(this.tblCas2Pr.getValue("FEXPFMT")).toLowerCase()+".dbf"
							var path2Etl = new DpFile(getOrgPath()+"clbank/export/template/"+etlFileName);
							if(!isFile(path2Etl))
							{
								msg = "DpTransfer_doexport:";
								msg += "\nФайл шаблон "+etlFileName+ru(" не существует.", " не існує.")
								msg += "\n"+ru("по пути: ", "за шляхом: ")+path2Etl;
								alert(msg, ICON_ERROR);
								return false;	
							}
							
							//нужно записать в масив типы полей эталонного файла
							tblEtlDBF = OpenTable("f", path2Etl, encodding);
							var fieldList = tblEtlDBF.getFieldsInfo();
							var arrType = new Array();
							for(var i = 0; i < fieldList.length; i++) 
							{
								var type = fieldList[i].getType();
								arrType.push(String(type).toLowerCase());				
							}
							tblEtlDBF.close();		
														
							//копируем эталонный файл в папку экспорта this.dstExpDir
							//с новым именем fileExpr
							if(!copyFile(path2Etl, this.dstExpDir+"/"+fileExpr))
							{
								msg = "DpTransfer_doexport:";
								msg += "\n"+ru("Не удалось скопировать эталонный файл."
											,"Не вдалося скопіювати еталонний файл");
								alert(msg, ICON_ERROR);
								return false;
							}
							
							//полный путь к файлу экспорта
							path2ExpFile = new DpFile(this.dstExpDir+"/"+fileExpr);
														
							//Объект для записи в dbf файл
							var oDBF = lpProxy.getDBManager().getDBFWriter(path2ExpFile);
							oDBF.setCharactersetName(encodding);
							setProgressRange(1, this.tblDataPr.recordCount);

							for(this.tblDataPr.MoveFirst(); !this.tblDataPr.IsEOF(); this.tblDataPr.MoveNext())
							{
								//масив 1 строки для записи в dbf
								var arr2DBF = new Array();
								
								//бежим по полям из масива настройки 
								//выражение которое нужно вычислить  arrTuning[i].getText()
								//и записать в масив arr2DBF
								for(var i in arrTuning)
								{
									//передаем выражение this.mEval
									var val	 = this.mEval.eval(arrTuning[i].getText());
									var type = arrType[i];
									type = (typeof(val) == "undefined" ? typeof(val) : type);							
									
									switch(type)
									{
										case "string":
										case "text":
										case "character":
											val = String(val);
										break;
										case "date":
										case "datetime":
											val = new Date(val).getVarDate();
										break;
										case "integer":
										case "number":
										case "float":
										case "double":
										case "numeric":
											val = Number(val);
										break;
										case "bool":
										case "boolean":
										case "bit":
										case "logical":
											val = Boolean(val);
										break;
										case "undefined":
										default:
											val = null;
										break;
									}									
									arr2DBF.push(val);
								}

								//добавление строки
								oDBF.addRecord(arr2DBF);
								
								k = this.tblDataPr.absolute; //номер текущей строки в таблице
								setProgressPos(k, ru("Экспорт ","Експорт ")+k+"/"+this.tblDataPr.recordCount);
							}
							
							oDBF.write();
							setProgressPos(0);
						break;
						
						default:
							msg = "DpTransfer_doexport:";
							msg += "\n"+ru("Тип экспорта \""+typeEXP+"\" не поддерживается."
									,"Тип экспорту \""+typeEXP+"\" не підтримується.");
							alert(msg, ICON_ERROR);
							return false;	
						break;
					}
				break;
				
				case "PRN": //экспорт при помощи печати
					
					//при експорте создаем файл без предварит. просмотра
					this.tv.eval.addVar("_isExport", true);
					this.tv.print();
					
					var ext = this.tv.ext.toUpperCase();
					switch (ext)
					{
						case "FRM": 
						case "XLS": 							
							//путь к фалу експорта
							path2ExpFile = this.tv.office.file;
						break;
						
						default:
							msg = "DpTransfer_doexport:";
							msg += "\n"+ru("Для типа файла \""+ext+"\" экспорт не предусмотрен."
									,"Для типу фала \""+ext+"\" експорт не передбачено.");
							alert(msg, ICON_ERROR);
						break;
					}
					
					//проверяем наличие файла перед копированием
					if(!isFile(path2ExpFile))
					{
						msg = "DpTransfer_doexport:";
						msg += "\n"+ru("Файл экспорта не создан! Проверьте настройки экспорта."
								,"Файл експорту не створено! Перевірте налаштування для експорту.");
						alert(msg, ICON_ERROR);
						return false;	
					}

					copyFile(path2ExpFile, this.dstExpDir+"/"+fileExpr);
					
				break;
			}
			
			//после создания файла 
			//копируем его из папки експорта в папку которую указал пользоветель 
			//проверим есть ли такая папка 
			if(!isDir(this.dstExpDir))
			{
				msg = "DpTransfer_doexport:";
				msg += "\n"+ru("Вы указали не существующую папку для экспорта."
						,"Ви вказали не існуючу папку для експорту");
				alert(msg, ICON_ERROR);
				return false;
			}
			
			if(isFile(this.dstExpDir+"/"+fileExpr))
			{
				msg = ru("Файл экспорта ", "Файл експорту ")+fileExpr;
				msg += "\n"+ru("для сберкассы ", "для ощад. каси ")+this.tblCas2Pr.getValue("FOTD_BNK");
				msg += "\n"+ru("был успешно экспортирован в папку "
							,"був вдало експортований в папку ");
				msg	+= "\n"+this.dstExpDir;
				alert(msg);				
			}
			else
			{
				msg = "\n"+ru("Не удалось скопировать файл "+fileExpr+" в папку "
							,"Не вдалося скопіювати файл "+fileExpr+" в папку ");
				msg	+= "\n"+this.dstExpDir;
				alert(msg, ICON_WARNING);
				return false;
			}
		}
	}
}

//Функция узнает есть ли в исходной таблице необходимое поле.
function DpTransfer_isField(szField)
{
	for (var iWhat in this.aFields)
	{
		if (iWhat==szField)
		{
			return true
		}
	}
	return false;
}

// Запрашивает исходные данные
function DpTransfer_askData(mode, mFwid)
{
	mode = mode.toUpperCase();
	var caption = ru("Данные для имени файла по банку ", "Дані для ім'я файлу по банку ")
				+this.tblCas2Pr.getValue("FOTD_BNK");
	
	//обнуляем DpAskEx
	this.oAsk = new DpAskEx();
	this.oAsk.setCaption(caption);

	// Достанем настройку параметров
	strSQL = "SELECT * FROM ^"+TBL_CL_TRP
				+" WHERE 1=1"
					+" AND FVID="+sqlTo(mode)
					+" AND FWID_CL ="+sqlTo(mFwid)
				+" ORDER BY FNOM"
	var t = OpenTable(strSQL);

	if(t.IsEmpty())
	{
		// В принципе, возможны случаи, когда будет расчет не требующий
		// ввода исходных данных. Для такого случая сбросим флаг
		this.oAsk.escape = false;
		return true;
	}

	for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
	{
		mFtype = String(t.getValue("FTYPE"));
		mFdescr = String(t.getValue("FDESCR"));
		mFname = String(t.getValue("FNAME"));
		mFisvis = t.getValue("FISVIS");	// будет ли контрол
		
		//vvs 26.11.2003
		mFis0slct = t.getValue("FIS0SLCT");	// Допустимо ли пустое значение

		defVal = null;
		par1 = null;
		par2 = null;

		// Достанем умолчания. Но сначала из типа уберем нули и точки
		var clearType = mFtype.replace(/0|\. /g, "");

		switch(clearType)
		{
			case "B":
				defVal = t.getValue("FBOOL");
				break;
			case "D":
				// vvs 26.11.2003
				// а теперь добавим в тип 0, если допустимо пустое значение
				mFtype = mFtype + (mFis0slct ? "0" : "");

				defVal = new Date(t.getValue("FDATETIME")).getVarDate();
				break;
			case "T":
				// vvs 26.11.2003
				// а теперь добавим в тип 0, если допустимо пустое значение
				mFtype = mFtype + (mFis0slct ? "0" : "");

				defVal = t.getValue("FTEXT");
				// par1 - длина
				par1 = t.getValue("FWIDTH");
				break;
			case "NUM":
				defVal = t.getValue("FNUM");
				// par1 - длина
				// par2 - дробных знаков
				par1 = t.getValue("FWIDTH");
				par2 = t.getValue("FDR");
				break;
			case "NMK":
				// vvs 26.11.2003
				// а теперь добавим в тип 0, если допустимо пустое значение
				mFtype = mFtype + (mFis0slct ? "0" : "");

				defVal = t.getValue("FTEXT");
				break;
			case "CL":
				// vvs 26.11.2003
				// а теперь добавим в тип 0, если допустимо пустое значение
				mFtype = mFtype + (mFis0slct ? "0" : "");

				defVal = t.getValue("FNUM");
				// par1 - номер справочника
				par1 = t.getValue("FCL");
				break;
			case "REL":
				// vvs 26.11.2003
				// а теперь добавим в тип 0, если допустимо пустое значение
				mFtype = mFtype + (mFis0slct ? "0" : "");

				defVal = t.getValue("FNUM");
				// par1 - номер справочника
				// par2 - имя переменной. Должна быть кодом из надсправочника
				par1 = t.getValue("FCL");
				par2 = t.getValue("FNAMEREL");
				break;
			case "C":
			case "CU":
			case "CUT":
			case "CUTX":
			case "CUTXY":
			case "CUTXYZ":
				// vvs 26.11.2003
				// а теперь добавим в тип 0, если допустимо пустое значение
				mFtype = mFtype.substr(0, 1) + (mFis0slct ? "0" : "") + mFtype.substr(1);

				mFsc = t.getValue("FSC");
				mFsu = t.getValue("FSU");
				mFst = t.getValue("FST");
				mFcl_cod1 = t.getValue("FCL_COD1");
				mFcl_cod2 = t.getValue("FCL_COD2");
				mFcl_cod3 = t.getValue("FCL_COD3");
				// Создадим умолчание вида "20|201|0|4567"
				defVal = (mFsc==null ? "0" :
						(String(mFsc) + (mFsu==null ? "0" :
							("|"+String(mFsu) + (mFst==null ? "0" :
								("|"+String(mFst) + (mFcl_cod1==null ? "0" :
									("|"+String(mFcl_cod1) + (mFcl_cod2==null ? "0" :
										("|"+String(mFcl_cod2) + (mFcl_cod3==null ? "0" :
											"|"+String(mFcl_cod3)
										))
									))
								))
							))
						))
					)
				break;
			default:
				strMsg = "передан неизвестный режим:"+mFtype;
				debug(strMsg);
				obj = null;
		}
				
		this.oAsk.add(mFtype+(mFisvis ? "" : "-"), mFdescr, mFname, defVal, par1, par2);
		
		// разберемся с "отношениями"
		mFreltype = t.getValue("FRELTYPE")
		if(mFreltype != "NONE") 
		{
			mFrelvar = t.getValue("FRELVAR");
			this.oAsk.setRel(mFreltype, mFname, mFrelvar);
		}
	}	
	this.oAsk.doAsk();
	
	if (this.oAsk.escape)
	{		
		return false;
	}
	
	if (t)
	{
		t.Close();
		t = null;
	}
	return true;
}

//function DpTransfer_setForm(fshab,fnom,caption)
function DpTransfer_setForm(printForm)
{
	printForm = String(printForm);
	if(isEmpty(printForm))
	{
		msg = "DpTransfer_setForm:\n";
		msg += ru("Не установлена форма печати.", "Не встановлена форма друку.");		
		alert(msg, ICON_ERROR);
		return false;
	}
	
	var name = String(printForm.split(".")[0]); //имя файла - USTR01
	var ext =  String(printForm.split(".")[1]); //росширение - xls
	var label = name.substr(0, name.length-2);
	var file = new DpFile(rootDirectoryEx()+"listPrintForms/"+label+"/"+printForm);	
	var path2File = file.getAbsolutePath();
	
	if(!isFile(path2File))
	{
		msg = "DpTransfer_setForm:\n";
		msg += ru("Нету файла формы печати.", "Не знайдено файлу форми друку.");
		msg += "\n"+file.getAbsolutePath();
		alert(msg, ICON_ERROR);
		return false;
	}
	
	this.tv.form = path2File;
	this.tv.ext = ext;
	this.tv.user = getUser();
	
	return true;
}

function DpTransfer_setPrnPatt(printPatt)
{
	printPatt = String(printPatt);
	if(isEmpty(printPatt))
	{
		msg = "DpTransfer_setPrnPatt:\n";
		msg += ru("Не установлена метка печати.", "Не встановлена мітка друку.");		
		alert(msg, ICON_ERROR);
		return false;
	}
	this.tv.setPatt("LIST",printPatt);
	return true;
}

function DpTransfer_printNext(printComplete)
{
	this.tblCas2Pr.MoveNext();
	if(this.tblCas2Pr.IsEOF())
	{
		Form.PrintComplete();
		this.tv = null;
		this.tblCas2Pr.Close(5652)
		DropTable(this.tblSbcsData);
		DropTable(this.tblInData);
		return false;
	}
	if (typeof(printComplete) == "string" && printComplete.toLowerCase() == "noprint")
	{
		
		switch (this.pMsgBox.ask())
		{
			case "c":
				
				return false;
				break;
		}
	}

	if (this.tblDataPr)
	{
		this.tblDataPr.Close(5652);
		DropTable(this.szTbl2Print);
	}
	this.tv	= new DpTVars();
	this.tv.eval = this.mEval;
	this.tv.setOnPrinted(this, "printNext");
	if (this.doStep("PRN"))
	{
		this.tv.print();
	}
	return true;
}

// mode "PRN"- Печать
// "EXP"- Экспорт
function DpTransfer_doStep(mode)
{
	//Спросим что нам надо.
	//Если на вопросы не отвечаем
	//или форма печати пустая
	//то идем дальше.

	//Установим форму печати.
	mode = mode.toUpperCase();
	var isP = /PRN/.test(mode);
	var isE = /EXP/.test(mode)
	//var formCapt = "Вибір форми друку для  "+this.tblCas2Pr.getValue("FOTD_BNK")+"|Выбор формы печати для  "+this.tblCas2Pr.getValue("FOTD_BNK");
	if (isP)
	{
		//Tori 21.06.2011: если есть метка печати, тогда печатаем по метке
		if(allt(this.tblCas2Pr.getValue("FPRN_LABEL"))!="")
		{
			if(!this.setPrnPatt(allt(this.tblCas2Pr.getValue("FPRN_LABEL"))))
			{
				if (!this.printNext())
				{
					return false;
				}
			}
		}
		else
		{
			if (!this.setForm(this.tblCas2Pr.getValue("FPRN_FRMFILE")))
			{
				if(this.isSilent)
				{
					alert("Для "+this.tblCas2Pr.getValue("FOTD_BNK")+ru(" печать не предусмотрена", " друк  не передбачено"));
				}
				if (!this.printNext())
				{
					return false;
				}
			}
		}
	}
	else if (isE)
	{
		if (this.tblCas2Pr.getValue("FEXPTYPE").toUpperCase() == "PRN" && !this.setForm(this.tblCas2Pr.getValue("FEXP_FRMFILE")))
		{
			if (this.isSilent)
			{
				alert("Для "+this.tblCas2Pr.getValue("FOTD_BNK")+ru(" экспорт не предусмотрен", " експорт не передбачено"));
			}
			if (!this.printNext())
			{
				return false;
			}
		}
	}

	//Если не ответили на вопросы идем дальше.
	if(!this.askData(mode,this.tblCas2Pr.getValue("FWID")))
	{
		if(isP)
		{
			this.printNext(mode);
		}
		
		if(isE)
		{
			return false;
		}
	}
	else
	{
		this.oAsk.getEval("",this.mEval);
	}

	this.szTbl2Print = getTmpTableName("", true);
	strSQL = " SELECT D.* "
			+" INTO "+this.szTbl2Print
			+" FROM "+this.tblInData+" AS D "
			+" WHERE D.FSBCSWID = "+sqlTo(this.tblCas2Pr.getValue("FWID"))
			+" ORDER BY D.FTABN "
	ExecuteSQL(strSQL);
	this.tblDataPr = OpenTable(this.szTbl2Print)
	tieTransf("FT",this.tblDataPr)

	var szOrder = 0;
	//var szOrder = this.tblCas2Pr("FORDER")
	//Порядок сортировки не по табельным
	if(!isEmpty(szOrder))
	{
		this.mEval.setRowTable(this.tblDataPr)
		//Пробежимся и проставим новый порядок.
		for (;!this.tblDataPr.IsEOF(); this.tblDataPr.MoveNext())
		{
			this.tblDataPr.Edit()
			this.tblDataPr.setValue("FORDER", this.mEval.eval(szOrder));
			this.tblDataPr.Update()
		}
		strSQL = " SELECT * "
				+" FROM "
					+this.szTbl2Print
				+" ORDER BY FORDER "
		this.tblDataPr.Requery(strSQL)
	}
	//Добавим необходимые переменные.
	//vvs 03.08.07
	//Надо каждую строку округлять до копеек
	strSQL = " SELECT 1 as F"
				+(this.isField("FTRSUM")?",SUM("+sqlRound("D.FTRSUM", 2)+") AS FTRSUM ":"")
				+(this.isField("FSBSUM")?",SUM("+sqlRound("D.FSBSUM", 2)+") AS FSBSUM":"")
			+" FROM "+this.szTbl2Print+" AS D "
	
	//Добавляем переменные которые нам помогут при печати.
	var oSnap = getSnap(strSQL);
	if (oSnap){
		if (oSnap[1]){
			this.mEval.addVar("TSUM", oSnap[1]);
		}
		if (oSnap[2]){
			this.mEval.addVar("TPSUM", oSnap[2]);
		}
	}
	this.mEval.addVar("COUNTR", this.tblDataPr.recordCount);
	this.mEval.addVar("CASNOM", this.tblCas2Pr.getValue("FNUM"));
	this.mEval.addVar("CASNUM", this.tblCas2Pr.getValue("FNUM"));
	this.mEval.addVar("TRDAT", this.dPrdate);
	this.mEval.addVar("_PRNIMDL", (isP ? this.isPrnImdl : false));
	this.mEval.addFunc("parcefio",parcefio);
	this.mEval.addVar("DATETXT",tmonth(this.dPrdate, 3));
	aDat = d_m_y(this.dPrdate).split('.');
	datetxt = aDat[0]+'/'+aDat[1]+'/'+aDat[2];
	this.mEval.addVar("TRDAT_SLASH", datetxt);
	
	var dt = new Date();
	var d = dt.getDate();
	var m = dt.getMonth()+1;
	var y = dt.getFullYear();
	//Дата текущая
	this.mEval.addVar("CURRTXTDAY", (d<9 ? '0'+String(d) : String(d)));
	this.mEval.addVar("CURRTXTMN", (m<9 ? '0'+String(m) : String(m)));
	this.mEval.addVar("CURRTXTYEAR", String(y));

	dt = new Date(this.dPrdate);
	d = dt.getDate();
	m = dt.getMonth()+1;
	y = dt.getFullYear();

	//Дата перечисления
	this.mEval.addVar("TRTXTDAY", (d<9 ? '0'+String(d) : String(d)));
	this.mEval.addVar("TRTXTMN", (m<9 ? '0'+String(m) : String(m)));
	this.mEval.addVar("TRTXTYEAR", String(y));
	
	this.tv.eval = this.mEval;
	this.rTbl = this.tblDataPr;
	this.hTbl = this.tblCas2Pr;
	this.tv.setRTbl(this.rTbl);
	this.tv.setHTbl(this.hTbl);
	
	return true;
}

function DpTransfer_prepare(mode)
{
	if (!this.prTable)
	{
		debug("Исходная таблица не определена")
	}
	mode = mode.toUpperCase();
	var isP = /PRN/.test(mode);
	var isE = /EXP/.test(mode)
	this.tblInData = getTmpTableName("", true);
	//Формируем таблицу с исходными данными.
	if(DropTable(this.tblInData))
	{
		strSQL = "CREATE TABLE "+this.tblInData
				+" ("
					+" FTABN "+sqlType("LONG")
					+", FSBCSWID "+sqlType("LONG")
					+", FWIDTR "+sqlType("LONG")
					+", FISSLCT "+sqlType("BIT")
					+", FORDER "+sqlType("DOUBLE")
					+", FTRSUM "+sqlType("MONEY")
					+", FSBSUM "+sqlType("MONEY")
					//Tori 21.06.2011: добавил нехватающие в печати и экспорте поля
					+", FTABN_ID "+sqlType("LONG")
					+", FWID_WP "+sqlType("LONG")
					+", FFAM "+sqlType("TEXT")
					+", FNAME "+sqlType("TEXT")
					+", FVATE "+sqlType("TEXT")
					+", FTRDAT "+sqlType("DATE")
					+", FPROC "+sqlType("MONEY")
				+" )"
		ExecuteSQL(strSQL);
	}
	else
	{
		ExecuteSQL("DELETE * FROM "+this.tblInData);
	}	
	
	var strFields = "";
	for(var ii in this.aFields)
	{
		strFields += this.aFields[ii]+",";
	}
	
	var strSELECT = this.mkSQL("SELECT");
	strSQL = "INSERT INTO "+this.tblInData+" ("+strFields+" FSBCSWID, FISSLCT)"
			+" SELECT "
				+strSELECT	
				+", SBCS.FWID"
				+", "+sqlTrue
			+" FROM ("+this.prTable+" AS PR INNER JOIN ^"+TBL_TRPLACE+" AS PLACE ON PR."+this.aFields["FWIDTR"]+" = PLACE.FWID_CL)"
				+" INNER JOIN ^"+ TBL_SBCS+" AS SBCS ON SBCS.FNUM = PLACE.FNUMSB"
			+(this.fwids?" WHERE PR.Fwid "+this.fwids:"")			
	ExecuteSQL(strSQL);
	
	if (!isEmpty(this.filter))
	{
		var tblChek =  OpenTable(this.tblInData);
		tieTransf("F",tblChek);
		this.mEval.setRowTable(tblChek);
		for (; !tblChek.IsEOF(); tblChek.MoveNext())
		{
			if (!this.mEval.eval(this.filter))
			{
				tblChek.Edit()
				tblChek.setValue("FISSLCT", false);
				tblChek.Update();
			}
		}
		tblChek.Close();		
	}
	
	//Удалим строки которые не нужно выбирать
	ExecuteSQL("DELETE FROM "+this.tblInData+" WHERE FISSLCT = "+sqlFalse);
		
	// Выбираем формы печати при печати или
	// файл и пути для экспорта при экспорте
	// для каждой сбер.кассы
	var szCond = " AND FWID IN (SELECT DISTINCT FSBCSWID FROM " +this.tblInData+") "
				+(isP?" AND ((FPRN_FRMFILE IS NOT NULL AND LTRIM(RTRIM(FPRN_FRMFILE)) <> "+SqlEmpStr+") OR (FPRN_LABEL IS NOT NULL AND LTRIM(RTRIM(FPRN_LABEL)) <> "+SqlEmpStr+"))" :"")
				+(isE?" AND FFILE IS NOT NULL":"")
		
	//Смотрим а нужно ли нам вообще что-то спрашивать.
	strSQL = "SELECT *"
			+" FROM ^"+TBL_SBCS
			+" WHERE 1=1 "
				+szCond
			+" ORDER BY FNUM"
	var oSnap = getSnap(strSQL);
	
	// Выбираем сбер.кассы на какие будем перечислять
	if (oSnap!=null)
	{
		par = new Object();
		par.isZaval = true;
		par.escape = true;
		par.retTbl = getTmpTableName("", true);
		par.mCond =  szCond;
		showWindow("l_sbcs.js",SW_MODAL,par);
		if(par.escape)
		{
			return false;
		}
	}
	else
	{
		//Нет таблицы выходим.
		var msg = ru("Не настроены параметры для ", "Не налаштовані параметри ");
		msg += (isP ? ru("печати", "друку") : ru("экспорта", "експорту"));
		
		alert(msg);
		return false;
	}
	
	var tblSbcsData= par.retTbl;
	
	//Удалим не нужные данные	
	strSQL = "DELETE FROM "+this.tblInData
			+" WHERE FSBCSWID NOT IN(SELECT T.FWID FROM "+tblSbcsData+" T)"
	ExecuteSQL(strSQL);
		
	//Таблица с FWIDами касс для печати.
	this.tblCas2Pr = OpenTable(tblSbcsData);	

	return true;
}
function DpTransfer_setAttr(szAttr,Value)
{
	if (typeof(szAttr)=="undefined")
	{
		return false;
	}
	this.aAttr[szAttr] = Value;
}

function DpTransfer_getAttr(szAttr)
{
	if (typeof(this.aAttr[szAttr])=="undefined")
	{
		return null;
	}
	return this.aAttr[szAttr];
}
// Перед вызовом функции должны быть установленны такие атрибуты
// 1.
//	tblFrom	- Таблица с данными для перечислений
//	trType	- Тип перечисления
// 2. Установлена таблица для роботы
// setTable()
// Функция возвращает открытую таблицу с присоединенными
// необходимыми таблицами.
//============================================
function DpTransfer_mkTblFromByType(mode)
{
	var tblFrom	= this.getAttr("tblFrom");
	var trType	= this.getAttr("trType");
	var tbl2mk		= this.prTable;

	if(!tblFrom)
	{
		msg = "DpTransfer_mkTblFromByType: \n";
		msg += ru("Переменная tblFrom не определена", "Змінна tblFrom не визначена");
		alert(msg);
		return;
	}
		
	if(isEmpty(trType))
	{
		msg = "DpTransfer_mkTblFromByType: \n";
		msg += ru("Переменная trType не определена", "Змінна trType не визначена");
		alert(msg);
		return;
	}	
	
	DropTable(tbl2mk);
	var strSelect = this.mkSQL("SELECT",true);
	var strGroup = this.mkSQL("GROUP",true);	
	
	//this.isFwidTr = !isEmpty(this.aFields["FWIDTR"])
		
	if(DropTable(tbl2mk))
	{
		strSQL = "CREATE TABLE "+tbl2mk
				+" ("
					+" FTRSUM "+sqlType("MONEY") //Cумма перечислений
					+", FSBSUM "+sqlType("MONEY") //Сумма сборов с перечислений
					+", FTABN "+sqlType("LONG")
					+", FTABN_ID "+sqlType("LONG")
					+", FWIDTR "+sqlType("LONG")
					+", FFAM "+sqlType("TEXT")
					+", FNAME "+sqlType("TEXT")
					+", FVATE "+sqlType("TEXT")
					+", FTRDAT "+sqlType("DATE")
					+", FWID "+sqlType("COUNTER")
				+" )"
		ExecuteSQL(strSQL);
	}
	else
	{
		ExecuteSQL("DELETE * FROM "+tbl2mk);
	}
	
	var strFields = "";
	for(var ii in this.aFields)
	{
		strFields += ii+",";
	}
	
	//Выберем данные для конкретного приказа.
	strSQL = " INSERT INTO "+tbl2mk+"("+strFields+"FTRDAT)"
			+" SELECT "
				+strSelect
				+", "+sqlTo(new Date(this.dPrdate).getVarDate())
			+" FROM "
				+" ^"+tblFrom+" PR"
			+" GROUP BY "
					+strGroup
			+" ORDER BY PR."+this.aFields["FTABN"]
	ExecuteSQL(strSQL);
		
		
	strSQL = "DELETE FROM "+tbl2mk+" WHERE FTRSUM = 0";
	ExecuteSQL(strSQL);
	
	//если нету FWIDTR 
	this.isFwidTr = !isEmpty(this.aFields["FWIDTR"])
	
	//проставим сами согласно данным в приказе _castr
	if(!this.isFwidTr)
	{
		var tmpTbl2mk = getTmpTableName("", true);
		strSQL = "SELECT "
					+" SUM(FTRSUM) AS FTRSUM"
					+", FTABN"
					+", FTABN_ID"
					+", FWIDTR"					
				+" FROM "+tbl2mk
				+" GROUP BY"
					+" FTABN"
					+", FTABN_ID"
					+", FWIDTR"
		var opTbl = OpenTable(strSQL);
		
		for(; !opTbl.IsEOF(); opTbl.MoveNext())
		{			
			var tabn = Number(opTbl.getValue("FTABN"));
			var sum = Number(opTbl.getValue("FTRSUM"));
			var arrPlace = this.getPlaceTR(tabn, this.dPrdate);
			
			//если по этому таб. № есть места перечислений в приказе _castr то 
			//делаем распредиление суммы аванса согласно %
			if(arrPlace)
			{
				//сначала удаляем старые строки по таб.№
				ExecuteSQL("DELETE FROM "+tbl2mk+" WHERE FTABN = "+sqlTo(tabn));
				
				var m = null;
				var sum2TR = 0;
				
				//записуем в таблицу tbl2mk согласно % и места перечисления
				for(var i in arrPlace)
				{
					m = {};
					m.FTABN = tabn;
					m.FTRSUM = sum2write =round(sum*arrPlace[i].FPROC/100, 2);
					m.FWIDTR = arrPlace[i].FWIDTR;
					updateTable(tbl2mk, m, true);
					
					sum2TR += sum2write;
				}
				
				//смотрим чтобы общая сумма по перечислению не была больше чем сумма аванса
				if(sum < sum2TR && m)
				{
					var sumKor = sum2TR - sum;
					
					//уменьшаем последнюю сумму перечисления на число которое превысило сумму аванса
					strSQL = "UPDATE "+tbl2mk
								+" SET FTRSUM = "+sqlRound("FTRSUM - "+sqlTo(sumKor),2)
							+" WHERE 1=1"
								+" AND FTABN = "+sqlTo(m.FTABN)
								+" AND FWIDTR = "+sqlTo(m.FWIDTR)
					ExecuteSQL(strSQL);
				}
			}
		}
		opTbl.close();
	}

	//проставим Фамилию, Имя, Отчество и  FTABN_ID
	var tblFIO = OpenTable(tbl2mk);
	var Fio;
	var arrEmptyTR = [];
	for(; !tblFIO.IsEOF(); tblFIO.MoveNext())
	{		
		tblFIO.Edit();
		Fio = tcl('CL', 'TXT', this.clPers, tblFIO.getValue("FTABN"));
		tblFIO.setValue("FFAM", fio('F', Fio));
		tblFIO.setValue("FNAME", fio('I', Fio));
		tblFIO.setValue("FVATE", fio('O', Fio));
		tblFIO.setValue("FTABN_ID", getIDFromCod(tblFIO.getValue("FTABN")));
		tblFIO.Update();
		oSnap = null;
		
		//проверка на наличие мест перечислений 
		if(isEmpty(Number(tblFIO.getValue("FWIDTR"))))
		{
			arrEmptyTR.push(tblFIO.getValue("FTABN"));
		}
	}
	tblFIO.Close();
	
	if(arrEmptyTR.length > 0)
	{
		msg = ru("Найдены таб.№ для которых отсутствуют места перечислений"
				, "Знайдені таб.№ для яких відсутні місця перерахувань");
		msg += "\n"+String(arrEmptyTR.join());
		alert(msg, ICON_WARNING);
		return false;
	}
		
	var tblRet =  OpenTable(tbl2mk);
	tieTransf("F", tblRet);
	return 	tblRet;
}

// Перед вызовом функции должны быть установленны такие атрибуты
// 1.
// vidPrkTr	- id приказа
// dateFrom - на какую дату брать данные
// idFldTr	- поле где хранится id перечисления
// tblPrkTr	- таблица с данными приказа.
// isMkSb	- Заполнять поле Сбор
// lsFidSb	- Поле лицевого счета для сборов
// 2. Установлена таблица для роботы
// setTable()
// Функция возвращает открытую таблицу с присоединенными
// необходимыми таблицами.

//============================================
function DpTransfer_mkTblFromSvzp(mode)
{
	var vidPrkTr	= this.getAttr("vidPrkTr");
	var dateFrom	= this.dPrdate;
	var idFldTr	= this.getAttr("idFldTr");
	var tblPrkTr	= this.getAttr("tblPrkTr");
	var isMkSb	= this.getAttr("isMkSb");
	//Этого поля может и не быть.
	var lsFidSb	= this.getAttr("lsFidSb");
	var tbl2mk	= this.prTable;
	
	var isOK = true;
	var JSFunc = "DpTransfer_mkTblFromSvzp:\n";
	
	//проверка переменных
	if(vidPrkTr == null)
	{
		alert(JSFunc+ru("Переменная vidPrkTr не определена"
				,"Змінна vidprktr не визначена"));
		isOK = false;
	}
	if(dateFrom == d00)
	{
		alert(JSFunc+ru("Переменная dateFrom не определена"
				,"Змінна dateFrom не визначена"));
		isOK = false;
	}
	if(idFldTr == null)
	{
		alert(JSFunc+ru("Переменная idFldTr не определена"
				,"Змінна idFldTr не визначена"));
		isOK = false;
	}
	if(tblPrkTr == null)
	{
		alert(JSFunc+ru("Переменная tblPrkTr не определена"
				,"Змінна tblPrkTr не визначена"));
		isOK = false;
	}
	if(isMkSb == null)
	{
		alert(JSFunc+ru("Переменная isMkSb не определена"
				,"Змінна isMkSb не визначена"));
		isOK = false;
	}
	if(tbl2mk == null)
	{
		alert(JSFunc+ru("Переменная tbl2mk не определена"
				,"Змінна tbl2mk не визначена"));
		isOK = false;
	}
	if(!isOK)
	{
		return null;
	}	
	
	var TBL_SVZP =  "SVZP"+month_txt(dateFrom);
	
	if (!IsTableEx("ZRP_RES","ZRP_"+TBL_SVZP))
	{
		alert(ru("Не найдена таблица ", "Не знайдена таблиця ")+TBL_SVZP);
		return null;
	}
	else
	{
		if(DropTable(tbl2mk+"_T"))
		{
			strSQL = "CREATE TABLE "+tbl2mk+"_T"
					+" ("
						+" FTRSUM "+sqlType("MONEY") //Cумма перечислений
						+", FSBSUM "+sqlType("MONEY") //Сумма сборов с перечислений
						+", FTABN_ID "+sqlType("LONG")
						+", FWID_WP "+sqlType("LONG")
						+", FID_PRK "+sqlType("LONG")
						+", FPROC "+sqlType("MONEY")
						+", "+idFldTr+" "+sqlType("LONG")
					+" )"
			ExecuteSQL(strSQL);
		}
		else
		{
			ExecuteSQL("DELETE * FROM "+tbl2mk+"_T");
		}	
	
		//Выберем данные для конкретного приказа.
		strSQL = "INSERT INTO "+tbl2mk+"_T(FTRSUM, FTABN_ID, FID_PRK, FWID_WP, "+idFldTr+", FPROC)"
				+" SELECT" 
					+" SUM(SV.FSUM)" //Cумма перечислений
					+", SV.FTABN_ID"
					+", SV.FID_PRK"
					+", SV.FWID_WP"
					+", PRK."+idFldTr
					+", PRK.FPROC"
				+" FROM "
					+" ^"+TBL_SVZP+" SV INNER JOIN ^"+tblPrkTr+" PRK ON PRK.FWID = SV.FID_PRK"
				+" WHERE 1=1"
					+sqlw0And("SV.FLSFID <> ", lsFidSb) //исключаем суммы почтового сбора 
					+sqlw0And("SV.FVID_PRK = ", vidPrkTr)
					+" AND NOT (SV.Fvp=1 AND SV.Fmn>=" + sqlTo(firstDayMonth(dateFrom))+" ) "//исключаем суммы прошлых месяцев выплаченные в следующих месяцах 
				+" GROUP BY "
					+" SV.FTABN_ID"
					+", SV.FID_PRK"
					+", SV.FWID_WP"
					+", PRK."+idFldTr
					+", PRK.FPROC"
		ExecuteSQL(strSQL);

		if (isMkSb && !isEmpty(lsFidSb))
		{
			//Проставим сборы
			strSQL = " UPDATE "+tbl2mk+"_T "
					+" SET FSBSUM = (SELECT SUM(S.FSUM) FROM ^"+TBL_SVZP+" S"
												+" WHERE 1=1"
													+" AND S.FLSFID = "+sqlTo(lsFidSb)
													+" AND "+tbl2mk+"_T.FTABN_ID = S.FTABN_ID"
													+" AND "+tbl2mk+"_T.FID_PRK = S.FID_PRK)"
			ExecuteSQL(strSQL);
			
			strSQL = "UPDATE "+tbl2mk
							+" SET FTRSUM = FTRSUM - FSBSUM"
			ExecuteSQL(strSQL);			
		}
		
		if(DropTable(tbl2mk))
		{
			strSQL = "CREATE TABLE "+tbl2mk
					+" ("
						+" FTRSUM "+sqlType("MONEY") //Cумма перечислений
						+", FSBSUM "+sqlType("MONEY") //Сумма сборов с перечислений
						+", FTABN_ID "+sqlType("LONG")
						+", FTABN "+sqlType("LONG")
						+", FWID_WP "+sqlType("LONG")
						+", FWIDTR "+sqlType("LONG")
						+", FFAM "+sqlType("TEXT")
						+", FNAME "+sqlType("TEXT")
						+", FVATE "+sqlType("TEXT")
						+", FTRDAT "+sqlType("DATE")
						+", FWID "+sqlType("COUNTER")
						+", FPROC "+sqlType("MONEY")
					+" )"
			ExecuteSQL(strSQL);
		}
		else
		{
			ExecuteSQL("DELETE * FROM "+tbl2mk);
		}
		
		strSQL = "INSERT INTO "+tbl2mk+"(FTRSUM, FTABN_ID, FWID_WP, FSBSUM, FWIDTR, FTRDAT, FPROC)"
				+" SELECT"	
					+" SUM(FTRSUM)" //Cумма перечислений
					+", FTABN_ID"
					+", FWID_WP"
					+", SUM(FSBSUM)" //Сумма сборов с перечислений
					+", FWIDTR"
					+", "+sqlTo(this.dPrdate.getVarDate())
					+", FPROC"
				+" FROM "
					+tbl2mk+"_T "
				+" GROUP BY "
					+" FTABN_ID"
					+", FWID_WP"
					+", FWIDTR"
					+", FPROC"
		ExecuteSQL(strSQL);
		
		//проставим Фамилию, Имя, Отчество
		var tblFIO = OpenTable(tbl2mk);
		var Fio;
		for(; !tblFIO.IsEOF(); tblFIO.MoveNext())
		{
			var m = new Object();
			//Tori 23.06.2011: getTxtFromID() будет работать быстрее
			//Fio = tcl('CL', 'TXT', this.clPers, getClcodByID(this.clPers, tblFIO.getValue("FTABN_ID")));
			Fio = getTxtFromID(tblFIO.getValue("FTABN_ID"));
			m.FFAM = fio('F', Fio);
			m.FNAME = fio('I', Fio);
			m.FVATE = fio('O', Fio);			
			UpdateTable(tbl2mk, m, false, "Fwid="+tblFIO.getValue("Fwid"));
		}
		tblFIO.close();

		var tblRet =  OpenTable(tbl2mk);
		tieTransf("F", tblRet);

		return tblRet;
	}
}
//============================================
function DpTransfer_showTrSum(mode)
{	
	if (!isEmpty(mode))
	{
		mode = mode.toUpperCase();
	}
	var tblToShow = null;
	
	switch (mode)
	{
		case "SVZP":
			tblToShow = this.mkTblFromSvzp();
			break;
		case "TRTYPE":
			tblToShow = this.mkTblFromByType();
			break;
	}
	
	if (tblToShow && !tblToShow.IsEmpty())
	{
		var oPar = new Object();
		//передаем таблицу
		oPar.tblToShow = tblToShow;
		//И если опредилен то процесс.
		oPar.mFproc = this.getAttr("mFproc");
		oPar.tblToName = this.prTable;
		//передаем себя
		oPar.oTransf = this;
		showWindow(XML_TRSUM,SW_NOMODAL,oPar);
	}
	else
	{
		alert(ru("Просмотр сумм прерван!", "Перегляд сум перерваний!"));
	}
}

function DpTransfer_mkSQL(mode,isSum)
{
	if (!isEmpty(mode))
	{
		mode = mode.toUpperCase();
	}
	var strSQL = "";
	switch (mode)
	{
		case "SELECT":
			for (var iWhat in this.aFields)
			{
				switch (iWhat)
				{
					case "FTRSUM":
					case "FSBSUM":
						if (isSum)
						{
							strSQL += ", "+Convert("SUM("+Convert("PR."+this.aFields[iWhat], "DBL")+")", "DBL")
						}
						else
						{
							strSQL += ", "+Convert("PR."+this.aFields[iWhat], "DBL")
						}
						break;
					default:
						strSQL+=", PR."+this.aFields[iWhat]
				}
			}
			strSQL = strSQL.substr(1);
			break;
		case "GROUP":
			for (var iWhat in this.aFields)
			{
				switch (iWhat)
				{
					//Эти пропускаем.
					case "FTRSUM":
					case "FSBSUM":
						break
					default:
						strSQL+=", PR."+this.aFields[iWhat]
				}
			}
			strSQL = strSQL.substr(1);
			break;
	}
	return strSQL;
}

function DpTransfer_EI_Proc(obj,tbl)
{
}

//============================================
/*
function getTieSnap(mode,tbl,alias,obj){
	var e = tbl.getTie(alias);

	for(var i=0; i<e.fields.count; i++){
		label = alias+"."+e.fields.Item(i).name
		obj[label] = tbl(label);
	}
	return obj;
}
*/
//============================================
// по перереданным табельному, ID приказа и двум датам,ID перечисления
// mоde  "TRPLACE" - места перечислений
/*
function getSQL4Transf(mode, mFtabn, mFvid_prk, mBdat, mEdat,mTrType){
	switch (mode){
	case "TRPLACE":
			strSQL = " SELECT A.* "
		+" FROM "
			+"^"+TBL_TRPLACE+" A "
		+" WHERE 1=1 "
			+sqlw0And(" A.FTABN=",mFtabn)
			+sqlw0And(" A.FTRTYPE=",mTrType)
		+" ORDER BY A.FTABN"
	break;
	}
	return strSQL;
}
*/
//============================================
// к таблице с перечислениями присоединяет необходимые таблицы
// F(full) - Полный режим
function tieTransf(mode, tblTransf, list)
{
	if(!this.clPers)
	{
		this.clPers = getPar("CODPERS");
	}
	var obj4Tie;
	var useList;
	if(typeof(list) != "undefined")
	{
		//делаем tie к таблице из листа
		obj4Tie = list;
		useList = true;
	}
	else
	{
		//делаем tie к переданой таблице
		obj4Tie = tblTransf;
		useList = false;
	}		
	//проставим таб. №
	for(; !tblTransf.IsEOF(); tblTransf.MoveNext())
	{
		tblTransf.Edit();
		tblTransf.setValue("FTABN", getClcodByID(this.clPers, Number(tblTransf.getValue("FTABN_ID"))));
		tblTransf.Update();
	}
	tblTransf.MoveFirst();

	obj4Tie.clTie("TABN", "="+sqlTo(this.clPers)+",FTABN");
	
	if(useList)
	{
		obj4Tie.subTie("WORK_PERS", "WP", "FWID", "FWID_WP");
		obj4Tie.subTie(TBL_TRPLACE, "PLACE", "FWID_CL", "FWIDTR"); //места переч.
		obj4Tie.subTie("CL_SBCS", "CAS", "CL_SBCS", "PLACE.FNUMSB"); //Сбер.касса
		obj4Tie.subTie("CL_HOMO", "HOMO", "FWID_CL", "TABN.FWID"); 
	}
	else
	{
		obj4Tie.tie("WORK_PERS", "WP", "FWID", "FWID_WP");
		obj4Tie.tie(TBL_TRPLACE, "PLACE", "FWID_CL", "FWIDTR"); //места переч.
		obj4Tie.tie("CL_SBCS", "CAS", "CL_SBCS", "PLACE.FNUMSB");  //Сбер.касса
		obj4Tie.tie("CL_HOMO", "HOMO", "FWID_CL", "TABN.FWID");
	}
	
	//тип перечислений
	obj4Tie.clTie("TYPE", "="+sqlTo(getPar("CAS_TRTYPE"))+",PLACE.FTRTYPE");	
	
	return tblTransf;
}

//============================================
function createGrid4Transf(mode,bNoCreateGrid)
{
	include("Objects\\DpGrid.js")
	var type = mode
		
	switch (mode)
	{
		case "L_CAS_PR_TR":
		case "L_PRKALTR":
		case "TRSUM":
			with(new DpGrid(bNoCreateGrid?"NOCREATE":""))
			{
				with(page())
				{
					isOnePageMode = false;
					cell("FTABN", "Таб № ", 5);
					cell("TABN.FTXT", "ПІБ|ФИО", 15);
					cell("HOMO.FINDNUM", "Ідент. №|Идент. №", 10);
					
					if(type == "TRSUM")
					{
						cell("FTRSUM", "Сума перерах.|Сумма переч.", 10, null, DP_FORMAT_SUM);
						cell("FPROC", "% перерах.|% переч.", 10, null, DP_FORMAT_SUM);
						cell("FSBSUM", "Сума збору|Сумма сбора", 10, null, DP_FORMAT_SUM);
					}
					else
					{
						cell("FBDAT", "Дата поч.|Дата нач.", 8);
						cell("FEDAT", "Дата зак.|Дата конца", 8);
						cell("FPROC", "%", 5, null, DP_FORMAT_SUM);
						cell("FSUM", "Сума|Сумма", 8, null, DP_FORMAT_SUM);	
					}
					
					if (type == "L_PRKALTR")
					{
						cell("FNUM", "№ Справи|№ Дела", 8);
					}
					
					cell("PLACE.FLICSCH", "Особ. рах.|Лиц. Счет", 10);
					cell("TYPE.FTXT", "Тип перерах.|Тип. переч.", 10);
					with(group("Банк"))
					{
						cell("CAS.FNUM","№\nощадн.каси|№\nсберкассы",8	);
						cell("CAS.FOTD_BNK","Вiддiл.\nбанку|Отдел.\nбанка",14,"w");
						cell("CAS.FR_SCH","Розрах.\nрах.|Расчетн.\nсчет",10);
						cell("CAS.FMFO","МФО|МФО",10);
						cell("CAS.FOKPO","Код\nЗКПО|Код\nОКПО",10);
						cell("=getTxtSb('', ^CAS.FSBTYPE)","Тип збору|Тип сбора",10);
						cell("CAS.FSUM","Сума збору|Сумма сбора",7, null, DP_FORMAT_SUM);
						cell("CAS.FPROC","%",7, null, DP_FORMAT_SUM);
					}
					with(group("Поштові реквізити отримувача|Почтовые реквизиты получателя"))
					{
						cell("PLACE.FFIO", "ПІБ|ФИО", 25);
						cell("PLACE.FZIP", "Індекс|Индекс", 7);
						cell("PLACE.FADDR", "Адреса|Адресс", 20);
					}					
				}
				build();
			}
		break;
	}
}
//============================================
//Валидация двух дат
var canEdatEmpty = true;
function dataRangeValid(mode){

	var currCtrl = getCurCtrl();
	var currCtrlValue = currCtrl.value
	var retval = true;
	if (String(currCtrl.id).toUpperCase() == "FBDAT"){

		if(currCtrlValue>=d00 && currCtrlValue<=d00){
			WAIT(ru("Дата не может быть пустой!","Дата не може бути порожньою!"));
			retval = softInvalid;
		}
	}else if (String(currCtrl.id).toUpperCase() == "FEDAT"){
		if (!canEdatEmpty){
			//Если неободимо что бы реагировало на пустую дату.
			if(currCtrlValue>=d00 && currCtrlValue<=d00 && false){
				WAIT(ru("Дата не может быть пустой!","Дата не може бути порожньою!"));
				retval = softInvalid;
			}
		}
		if (FBDAT.value>FEDAT.value){
			WAIT(ru("Дата конца не меньше даты начала!","Дата кінця не менша за дату початку!"));
			retval = softInvalid;
		}
	}
	return retval;
}
//============================================
// ksm 05.04.2004 Проверяет есть - ли поле с заданым именем в таблице
function isFldinTbl(tbl,fld,szRem,isSilent){
	fld = fld.toUpperCase()
	for(var i=0; i<tbl.fields.count; i++){
		if (tbl.fields.Item(i).name.toUpperCase() == fld){
			return true;
		}
	}
	if (!isSilent){
		alert("Заполните поле "+szRem+" самостоятельно")
	}
	return false;
}
//============================================
function parcefio(mode,sFio)
{
	if (null == sFio)
	{
		return "";
	}
	//Превращаем много пробелов в один.
	sFio  = String(sFio).trim();
	sFio = String(sFio).replace(/ +/g," ")
	var aFio = String(sFio).split(" ")
	switch (mode)
	{
		case "F":
			return aFio[0]
			break;
		case "I":
			return aFio[1]
			break;
		case "O":
			return aFio[2]
			break;
	}
}

function DpTransfer_getPlaceTR(tabn, dt)
{
	var retArr = new Array();
	var ret = false;
	//выбираем таблицу с местами перечислений и на ее основе создаем масив
	strSQL = "SELECT *" 
			+" FROM ^CAS_TR_PR"
			+" WHERE 1=1"
				+" AND FTABN = "+sqlTo(tabn)
				+" AND FBDAT <= "+sqlTo(dt)
				+" AND (FEDAT >= "+sqlTo(dt)+" OR FEDAT = "+sqlD00+")"
	var tbl = OpenTable(strSQL);
	
	if(!tbl.IsEmpty())
	{
		for(; !tbl.IsEOF(); tbl.MoveNext())
		{
			var par = {};
			par.FPROC = Number(tbl.getValue("FPROC"));
			par.FWIDTR = Number(tbl.getValue("FWIDTR"));
			par.FTABN = Number(tbl.getValue("FTABN"));
			
			retArr.push(par);
		}
		ret = retArr;
	}
	
	tbl.close();
	return ret;
}