/*
   Описание объекта "обновления": DpUpdate
   (C) Черкасское представительство ДЕБЕТ Плюс 09.2005

	Методы, которые перенесены под версию 12:
		DpUpdate_addTotals


	Внешние методы:
	.UDD_modiStru(names4Modi) - модификация структур
		names4Modi	- может:
						- не передаваться-модифицируются все таблицы
						- передается строка вида "'табл1', 'табл2', 'табл3'"
						- передается масив имен таблиц
						- передается объект с навешенными на него таблицами
	
	.UDD_modiStru4module(modulName) - модификация структур всех таблиц в переданом модуле
	
	.expCl(mode, par) - экспорт справочника
		mode		- пока не используется
		par.FFILE	- название mdb файла, куда экспортируем справочник
		par.FDIR	- путь к mdb файлу, куда экспортируем справочник
		par.FLABEL	- префикс для экспортированных таблиц справочника
		par.FCL		- номер справочника
		par.toClear - очищать ли в таблице экспорта справочники полностью с данным FLABEL
	
	Пример экспорта 12 справочника:
			include("objects\\DpUpdate.js");
			var oUpd	= new DpUpdate();

			var par		= new Object();
			par.FFILE	= "exp1.mdb";
			par.FDIR	= "..\\export\\";
			par.FLABEL	= "TEST_";
			par.FCL		= 12;
			par.toClear = true;

			oUpd.expCl("", par);
			oUpd.impCl("", par);
	
	.clearAllDb		- очистка баз данных
	
	.addExt(par)	- добавление расширения
		par.mode	- какое расширение добавляем
					"ANALIT_12"	- к справочнику аналитики №12
					"ANALIT"	- к любому справочнику аналитики кроме 12
					"HDOC"		- к заголовку документа
					"RDOC"		- к строке документа
					"NMKL"		- к справочнику номенклатуры

		par.FFORMAT		- формат вывода, разбираемся ниже
						%10.0f
						%10.2f
						%10d
						%10s
						%12.0f
						%14.0f
						и т.п.
		par.FISCHANGE	- использование в изменениях
		par.FISCULC		- способ занесения с помощью калькуляции
		par.FISEXPORT	- использование в экспорте
		par.FISFIRSTPG	- выводить на первой странице
		par.FISSEARCH	- использование в поиске
		par.FISSUM		- использование в суммировании
		par.FLABEL		- метка
		par.FPOS		- номер вывода
		par.FTXT		- название
		par.FTYPE		- смотрим e_extend.htm
							A+номер справочника
							BOOL
							TEXT
							CURRENCY
							DATETIME
							FLOAT
							INT
							SC
							SU
							ST
							TEXT
		par.FWIDTH		- ширина вывода
		
		par.FCL			- номер справочника
		par.FDOC		- документ
		par.FNOP		- операция
		par.FVID		- тип расширения, принимает четыре значения:
							"CL"		- справочник аналитики
							"CL_NMK"	- справочник номенклатуры
							"H"			- заголовок документа
							"R"			- строка документа
	
	.setNoPrihod(fnmkl)
		
	.addMainMenu(par)
		par.mode - "item", "menu"(умолчание - "item")
		par.ru		- русское название
		par.ua		- украинское название
		par.filter	- фильтр, умолчание('BLN_BNK_CAS_MTR_UOS_ZRP_CDR_ADM')
		par.id		- для "menu" идентификатор
		par.type	- для "item"(умолчание "l" (это "L") - файл, "s" - системная команда)
		par.command - для "item" выполняемый файл
		par.par		- для "item" передаваемый параметр типа "CALC", "VIEW"
		par.dist	- id меню, в который вставляем
		par.refresh - обновлять ли меню после добавления(по умолчанию true)
		par.hotkey	- клавиши вызова

	для удаления строк документов используем следующий запрос, где меняем fdoc, и таблицы(сделано для факса)
		1.Зайти в список документов.
		2. Нажать вместе Ctrl+Shift+F2
		3. В появившемся окне набрать следующий текст.

		ExecuteSQL("DELETE  FROM ^HOB WHERE FDOC = 'HM' AND FID_DOC NOT IN (SELECT FWID FROM ^KHP_ZAG WHERE FDOC = 'HM')")

		4. Нажать Enter.
		5. После выполнения операции закрыть окно.

*/
//include("setFwid.js")

var extFWID;
var TEMP_REG;
var TEMP_OP;
var TEMP_CALC;
var TEMP_VARDOC;
var isSilent4Modi;
function DpUpdate(mode)
{
	RO("DpUpdate", this);
	this.UDD_modiStru	= DpUpdate_UDD_modiStru;
	this.UDD_modiStru4module	= DpUpdate_UDD_modiStru4module;
	this.pattInfCopy	= DpUpdate_pattInfCopy;
	this.expCl			= DpUpdate_expCl;
	this.impCl			= DpUpdate_impCl;
	this.copyCl			= DpUpdate_copyCl;
	this.cleanCl		= DpUpdate_cleanCl;
	this.addExt			= DpUpdate_addExt;
	this.clearAllDb	= DpUpdate_clearAllDb;
	this.setNoPrihod	= DpUpdate_setNoPrihod;
	this.addMainMenu	= DpUpdate_addMainMenu;
	this.addTotals		= DpUpdate_addTotals;
	this.mode = mode;
	this.tbl = "CL_PRFRM";	// в "нормальных" версиях
	//this.tbl = "CL_FRM";		// в версиях младше 02.02.2002 года
}


function DpUpdate_UDD_modiStru(names4Modi)
{
	if (typeof(this.isSilent) != "undefined")
	{
		isSilent4Modi = this.isSilent;
	}
	if (typeof(names4Modi) == "undefined")
	{
		modi_tbl();
	}
	else
	{
		modi_tbl(names4Modi);
	}
	return true;
}

function DpUpdate_UDD_modiStru4module(modName)
{
	include("Objects/DpXMLDomDocument.js");
	var xmlDom = new DpXMLDOMDocument();
	xmlDom.load(rootDirectoryEx()+"/modules/"+modName+"/dbstru/dbstru.xml");
	
	var listInfo = xmlDom.getDocumentElement();
	var listTbl = listInfo.getElementsByTagName("table");
	
	//собираем список таблиц из dbstru.xml
	var arrTbl = [];
	for(var nTbl=0; nTbl<listTbl.length; nTbl++)
	{
		var eTbl = listTbl[nTbl];
		if(!eTbl)
			continue;
		arrTbl[nTbl] = String(eTbl.getAttribute("table")).toUpperCase();
	}
	
	//запускаем модификацию
	this.UDD_modiStru(arrTbl);
	return true;
}

function DpUpdate_pattInfCopy(toPatt, fdoc, fnop, fcalc, forg, answer)
{
	var strSQL;
	var fromPrefix	= (toPatt)?"":"U";
	var toPrefix	= (toPatt)?"U":"";
	var newfnop		= fnop;
	var newfcalc	= fcalc;
	var newfsortno  = 0;

	//debug();
	//vvs 12.06.07
	//Не переносило расширения, если в рабочей БД уже было с такими же FLABEL,FTXT,FTYPE
	//var tblDiff_CL_EXT 		= findDiff("CL_EXT", "CL_EXT", "FLABEL,FTXT,FTYPE", fromPrefix);
	var tblDiff_CL_EXT 		= findDiff("CL_EXT", "CL_EXT", "FWID", fromPrefix);
/*
	var tblDiff_CL_EXT_L 	= findDiff("CL_EXT_L", "CL_EXT_L", "FDOC,FNOP,FVID", fromPrefix);
	var tblDiff_EXT 		= findDiff("EXT", "EXT", "FBOOL,FCURRENCY,FFLOAT,FINT,FLONG,FTEXT", fromPrefix);
*/	
//	return false;

	// Новый сортировочный номер
	var tmptbl		= OpenTable("s","SELECT FSORTNO FROM ^" + toPrefix + "CL_LNK WHERE FNOP = 0 AND FDOC = " + sqlTo(fdoc));
	if (!tmptbl.IsEmpty())
		newfsortno = tmptbl("FSORTNO");
	tmptbl = null;
	tmptbl		= OpenTable("s", "SELECT DISTINCT FCALC FROM ^" + toPrefix + "CL_CALC WHERE FCALC > 0 AND FDOC = " + sqlTo(fdoc) + " ORDER BY FCALC");
	// Находим свободный номер калькуляции (если это необходимо)
	// не спрашивая ни у кого
	if (!tmptbl.IsEmpty() && tmptbl.FindFirst("FCALC = " + sqlTo(fcalc)))
	{
		newfcalc = 1;
		for(tmptbl.MoveFirst();!tmptbl.IsEOF() && newfcalc == tmptbl("FCALC"); tmptbl.MoveNext(), newfcalc++);
	}			
	tmptbl = null;
	var noAsk;
	__noWait = true;
		// Проверяем, есть ли такая папка
	tmptbl = OpenTable("s", "SELECT * FROM ^" + toPrefix + "CL_LNK WHERE FDOC = " + sqlTo(fdoc) + " AND FNOP = " + sqlTo(fnop));
	if (!tmptbl.IsEmpty())
	{
			// Если есть делаем запрос (если мы не передали ответ в параметрах)	
		if (!(typeof(answer) == "string" && inList(answer, "z", "*", "c")))
		{
			include("objects\\DpMsgBox.js");
			var strConf;
			if (toPatt)
				strConf = ru("Образец папки документа " + fdoc 
							+ "\nс номером операции " + fnop 
							+ "\nуже существует в справочникe образцов"
							+ "\n(его метка - " + tmptbl("Forg")+ ")."
							+ "\nЗаменить существующий образец \nили исправить номер операции?",
							 "Зразок папки документa " + fdoc
							+ "\nз номером операції " + fnop
							+ "\nвже існує у дoвiдникy зразкiв"
							+ "\n(його мітка - " + tmptbl("Forg") + ")."
							+ "\nЗамінити існуючий зразок \nчи виправити номер операції?"
								 );
			else
				strConf = ru("Папка документа " + fdoc
						 + "\nс номером операции " + fnop
						 + " уже существует."
						 + "\nЗаменить папку или исправить \nномер операции?",
						    "Папка документa " + fdoc
						 + "\nз номером операції " + fnop
						 + " вже існує."
						 + "\nЗамінити папку чи виправити \nномер операції?"
								 );
			var oMsg = new DpMsgBox("&z*c!", strConf, ru("Внимание!","Увага!"));					 
			answer = oMsg.ask();
			noAsk = oMsg.ask_all();// Поскольку DpMsgBox создается при каждом вызове данной функции надо самому запоминать этот флажек
		}
		else
			noAsk = true;
		if (answer == "c")// Отмена
		{
			tmptbl = null;
				// Если выбрано "Для всех" возвратим ответ 
			return (noAsk)?answer:"";
		}
		else if (answer == "z") // Заменить
		{
			ExecuteSQL("DELETE * FROM ^" + toPrefix + "CL_LNK WHERE FDOC = " + sqlTo(fdoc) + " AND FNOP = " + sqlTo(fnop));
			ExecuteSQL("DELETE * FROM ^" + toPrefix + "CL_OP WHERE FDOC = " + sqlTo(fdoc) + " AND FNOP = " + sqlTo(fnop));
			ExecuteSQL("DELETE * FROM ^" + toPrefix + "CL_CALC WHERE FDOC = " + sqlTo(fdoc) + " AND FNOP = " + sqlTo(fnop));
			ExecuteSQL("DELETE * FROM ^" + toPrefix + "PARDOC WHERE FDOC = " + sqlTo(fdoc) + " AND FNOP = " + sqlTo(fnop));
			ExecuteSQL("DELETE * FROM ^" + toPrefix + "VARDOC WHERE FDOC = " + sqlTo(fdoc) + " AND FNOP = " + sqlTo(fnop));
			ExecuteSQL("DELETE * FROM ^" + toPrefix + "CL_REG WHERE FDOC = " + sqlTo(fdoc) + " AND FNOP = " + sqlTo(fnop));
			var tmpName = getUniqName();
			ExecuteSQL("SELECT FWID INTO " + tmpName + " FROM ^" + toPrefix + "CL_EXT_L WHERE FDOC = " + sqlTo(fdoc) + " AND FNOP = " + sqlTo(fnop));

//Begin===============DarkAn 22.12.05================================
			if (!toPatt)
			{
				//vvs 11.07.07
				//!!!П....ц! Удаляло из рабочей базы накладные!

				/*
				// нужно удалить те данные, что соответствуют расширениям, которые будут убиты
				var tmpTNam = getTmpTableName();
				// занесём во временную таблицу FMAINWID тех расширений, которые будут удаляться
				strSQL = " SELECT "
							+" a.FMAINWID"
						+" INTO " + tmpTNam
						+" FROM ^" + toPrefix + "EXT AS a"
							+" INNER JOIN " + tmpName + " AS b ON a.FWID = b.FWID " 
						+ " WHERE a.FWID In (SELECT tD.FWID FROM " + tblDiff_CL_EXT + "_RIGHT tD )"
							+ " AND Not(a.FMAINWID = '')";
				ExecuteSQL(strSQL);

				strSQL = " DELETE"
								+" a.*"
							+" FROM"
								+" ^SCH_ZAG a INNER JOIN " + tmpTNam + " b"
									+" ON a.FWID = b.FMAINWID"
				ExecuteSQL(strSQL);
				DropTable(tmpTNam);
				*/
			}


			// удалять расширения
			strSQL = "DELETE a.* FROM ^" + toPrefix + "CL_EXT AS a INNER JOIN " + tmpName + " AS b ON a.FWID = b.FWID " 
			if (!toPatt)
			{
				strSQL += " WHERE a.FWID In (SELECT tD.FWID FROM " + tblDiff_CL_EXT + "_RIGHT tD )";
			}
			ExecuteSQL(strSQL);

			strSQL = "DELETE a.* FROM ^" + toPrefix + "CL_EXT_L AS a INNER JOIN " + tmpName + " AS b ON a.FWID = b.FWID "
			if (!toPatt)
			{
				strSQL += " WHERE a.FWID In (SELECT tD.FWID FROM " + tblDiff_CL_EXT + "_RIGHT tD )";
			}
			ExecuteSQL(strSQL);
			
			//vvs 11.07.07
			//Удаляем умолчания для расширений
			strSQL = "DELETE a.* FROM ^" + toPrefix + "EXT AS a INNER JOIN " + tmpName + " AS b ON a.FWID = b.FWID ";
			if (!toPatt)
			{
				strSQL += " WHERE a.FWID In (SELECT tD.FWID FROM " + tblDiff_CL_EXT + "_RIGHT tD ) "
					+" AND IsNULL(a.FMAINWID)";
			}
			ExecuteSQL(strSQL);
//END=================DarkAn 22.12.05================================
			
			DropTable(tmpName);
		}
		else // Исправить
		{
			tmptbl = OpenTable("s", "SELECT FNOP FROM ^" + toPrefix + "CL_LNK WHERE FNOP > 0 AND FDOC = " + sqlTo(fdoc) + " ORDER BY FNOP");
			
			if (!tmptbl.IsEmpty())
			{
					// Находим "свободный" номер операции 
				var tmpnop = 1;
				for(;!tmptbl.IsEOF() && tmpnop == tmptbl("FNOP"); tmptbl.MoveNext(), tmpnop++);
				var par		= new Object();
				par.escape	= true;
				par.oldfnop = fnop;
				par.fnop	= tmpnop;
				par.topatt	= toPatt;
				par.fdoc	= fdoc;
					// Спросим упользователя
				showWindow("e_getnop.htm", SW_MODAL, par);
				if (par.escape)
				{
					tmptbl = null;
						// Если выбрано "Для всех" возвратим ответ 
					return (noAsk)?answer:"";
				}
			
				var strWait;
				if (toPatt) 
					strWait = ru("Информация о папках копируется в образцы. Подождите пожалуйста...", "Інформація про папки копіюється у зразки. Зачекайте будь-ласка...");
				else
					strWait = ru("Информация копируется в папки документов. Подождите пожалуйста...", "Інформація копіюється у папки документів. Зачекайте будь-ласка...");
				WAITTIMER(strWait);
				newfnop = par.fnop;
			}
			else
				debug("Не может такого быть");
		}
	}
	tmptbl = null;
		
	/////////////////////////////////////////////////////////////////////////////////
	///////     Переносим расширения 		
	///////////////////////////////////////////////////////////////////////////////////

	
	//oCmp.setKeyFields("", "FLABEL,FTXT,FTYPE");

	__noWait = true;
	ExecuteSQL("INSERT INTO " + extFWID 
			+ " SELECT DISTINCT FWID, FWID AS NEWFWID "
			+ " FROM ^" + fromPrefix + "CL_EXT_L "
			+ " WHERE FNOP = " + sqlTo(fnop) + " AND FDOC = " + sqlTo(fdoc));

//BEGIN===============DarkAn 22.12.05================================
	if (!toPatt)
	{
		// удаляем те FWID, расширения с которыми уже присуствуют
		var strSQL = " DELETE * "
					+" FROM"
						+" " + extFWID + " eW"
					+" WHERE"
						+" Not(eW.FWID in (SELECT tD.FWID FROM " 
											+ tblDiff_CL_EXT + "_LEFT tD ))"
		ExecuteSQL(strSQL);
	}
//END=================DarkAn 22.12.05================================

	tmptbl = OpenTable("s", extFWID);
	for (;!tmptbl.IsEOF(); tmptbl.MoveNext())
	{
		tmptbl.Edit();
		tmptbl("NEWFWID") = GetUID();
		tmptbl.Update();			
	}	
	tmptbl = null;
	
	ExecuteSQL("INSERT INTO ^" + toPrefix + "CL_EXT "
			+ " SELECT b.NEWFWID AS FWID, a.FCOMMENT, a.FFORMAT, a.FISCHANGE, a.FISCULC,"
			+ " a.FISEXPORT, a.FISNAZV, a.FISSEARCH, a.FLABEL, a.FTXT, a.FTYPE, a.FWIDTH" + ((toPatt)?", " + sqlTo(forg) + " AS FORG ":" ")
			+ " FROM ^" + fromPrefix + "CL_EXT AS a INNER JOIN " + extFWID + " AS b ON a.FWID = b.FWID");
	ExecuteSQL("INSERT INTO ^" + toPrefix + "CL_EXT_L "
			+ " SELECT b.NEWFWID AS FWID, a.FCL, a.FDOC, a.FVID, " + sqlTo(newfnop) + " AS FNOP" + ((toPatt)?", " + sqlTo(forg) + " AS FORG ":" ")
			+ " FROM ^" + fromPrefix + "CL_EXT_L AS a INNER JOIN " + extFWID + " AS b ON a.FWID = b.FWID");
	ExecuteSQL("INSERT INTO ^" + toPrefix + "EXT "
			+ " SELECT b.NEWFWID AS FWID, a.FBOOL, a.FCURRENCY, a.FDATE, a.FDATETIME, a.FFLOAT, a.FINT, "
			+ " a.FLONG, a.FMAINWID, a.FTEXT, a.FUSED" + ((toPatt)?", " + sqlTo(forg) + " AS FORG ":" ")
			+ " FROM ^" + fromPrefix + "EXT AS a INNER JOIN " + extFWID + " AS b ON a.FWID = b.FWID "
			+ " WHERE IsNULL(a.FMAINWID)");
	

					
	///////////////////////////////////////////////////////////////////////////////////
	///////     Выбираем схемы регистрации 		
	///////////////////////////////////////////////////////////////////////////////////
//	var TEMP_REG = getUniqName();
	ExecuteSQL("INSERT INTO " + TEMP_REG
				+ " SELECT FWID, FVID, FDOC, FACT, FNOM, FREG, F1VALUE, FEDAT, FBDAT,"
				+ " FTXT, FUSED, FVALUE, FVAR, FNOP" + ((toPatt)?", " + sqlTo(forg) + " AS FORG ":" ")
				+ " FROM ^" + fromPrefix + "CL_REG AS a "
				+ " WHERE FNOP = " + sqlTo(fnop) + " AND FDOC = " + sqlTo(fdoc));
		//     Проставляем FWID'ы 		
	tmptbl = OpenTable("s", TEMP_REG);
	for (;!tmptbl.IsEOF(); tmptbl.MoveNext())
	{
		tmptbl.Edit();
		tmptbl("FNOP") = newfnop;
		tmptbl("FWID") = GetUID();
		tmptbl.Update();			
	}	
	tmptbl = null;
		//     Заносим в образцы
	ExecuteSQL("INSERT INTO ^" + toPrefix + "CL_REG SELECT * FROM " + TEMP_REG);
		
	/////////////////////////////////////////////////////////////////////////////////
	///////     Переносим папку 		
	///////////////////////////////////////////////////////////////////////////////////
	pattFwid = GetUID();
	ExecuteSQL("INSERT INTO ^" + toPrefix + "CL_LNK "
			+ " SELECT " +sqlTo(pattFwid)+ " AS FWID, FDEFA, FDOC, FGRNUM, "
			+ " FISPFOLDER, FISPUSER, FTXT, FNUMNUM, " + sqlTo(newfsortno) + " AS FSORTNO, FSYS, FTXTS, "
			+ " FUSED, " + sqlTo(newfcalc) + " AS FCALC, " + sqlTo(newfnop) + " AS FNOP" + ((toPatt)?", " + sqlTo(forg) + " AS FORG ":" ")
			+ " FROM ^" + fromPrefix + "CL_LNK "
			+ " WHERE FNOP = " + sqlTo(fnop) + " AND FDOC = " + sqlTo(fdoc));
			
	/////////////////////////////////////////////////////////////////////////////////
	///////     Выбираем калькуляции 		
	///////////////////////////////////////////////////////////////////////////////////
//	var TEMP_CALC = getUniqName();
	ExecuteSQL("INSERT INTO " + TEMP_CALC
			+ " SELECT FWID, FACT, FDOC, FDECIMAL, FFILT, "
			+ " FIF, FTXT, FNOM, FVALUE, FVAR, FWEIGHT, FCALC,"
			+ " FNOP" + ((toPatt)?", " + sqlTo(forg) + " AS FORG ":" ")
			+ " FROM ^" + fromPrefix + "CL_CALC "
			+ " WHERE (FNOP = " + sqlTo(fnop) + " OR FNOP = 0) AND FDOC = " + sqlTo(fdoc) + " AND FCALC = " + sqlTo(fcalc));
		//     Проставляем FWID'ы 		
	tmptbl = OpenTable("s", TEMP_CALC);
	for (;!tmptbl.IsEOF(); tmptbl.MoveNext())
	{
		tmptbl.Edit();
		tmptbl("FNOP") = newfnop;
		tmptbl("FCALC") = newfcalc;
		tmptbl("FWID") = GetUID();
		tmptbl.Update();			
	}	
	tmptbl = null;
		//     Заносим в образцы
	ExecuteSQL("INSERT INTO ^" + toPrefix + "CL_CALC SELECT * FROM " + TEMP_CALC);
				
	/////////////////////////////////////////////////////////////////////////////////
	///////     Выбираем операции 		
	///////////////////////////////////////////////////////////////////////////////////
//	var TEMP_OP = getUniqName();
	ExecuteSQL("INSERT INTO " + TEMP_OP
			+ " SELECT FWID, FBDAT, FCOND, FCR_COD1, FCR_COD2, FNPROV, "
			+ " FCR_COD3, FCR_SC, FCR_ST, FCR_SU, FDATE, FDB_COD1, FNSECT,"
			+ " FDB_COD2, FDB_COD3, FDB_SC, FDB_ST, FDB_SU, FDEFA,"
			+ " FDOC, FDOCNUM, FDOCVID, FEDAT, FFILT, FREPEAT, FSUM, "
			+ " FSUMSPR, FTXT, FVAL, FVALSPR, FREF, FNOP" + ((toPatt)?", " + sqlTo(forg) + " AS FORG ":" ")
			+ " FROM ^" + fromPrefix + "CL_OP "
			+ " WHERE FNOP = " + sqlTo(fnop) + " AND FDOC = " + sqlTo(fdoc));
		//     Проставляем FWID'ы 		
	tmptbl = OpenTable("s", TEMP_OP);
	for (;!tmptbl.IsEOF(); tmptbl.MoveNext())
	{
		tmptbl.Edit();
		tmptbl("FNOP") = newfnop;
		tmptbl("FWID") = GetUID();
		tmptbl.Update();			
	}	
	tmptbl = null;
		//     Заносим в образцы
	ExecuteSQL("INSERT INTO ^" + toPrefix + "CL_OP SELECT * FROM " + TEMP_OP);
		
	/////////////////////////////////////////////////////////////////////////////////
	///////     Выбираем переменные 		
	///////////////////////////////////////////////////////////////////////////////////
//	var TEMP_VARDOC = getUniqName();
	ExecuteSQL("INSERT INTO " + TEMP_VARDOC
			+ " SELECT FATTR, FDEFA, FDEFSORT, FDOC, FEXPR, "
			+ " FFIELD, FKOEF, FNOM, FREM, FTYPE, FVAR, FWEXPR,"
			+ " FWID, FNOP" + ((toPatt)?", " + sqlTo(forg) + " AS FORG ":" ")
			+ " FROM ^" + fromPrefix + "VARDOC "
			+ " WHERE FNOP = " + sqlTo(fnop) + " AND FDOC = " + sqlTo(fdoc) + " AND NOT FDEFA");

//Begin===============DarkAn 23.12.05================================
// Захватим также "общие" переменные, кроме тех, имена которых уже есть
	var toPrefix = (fromPrefix == "U" ? "" : "U");

	strSQL = "INSERT INTO " + TEMP_VARDOC
			+ " SELECT" 
				+" a.FATTR"
				+", a.FDEFA"
				+", a.FDEFSORT"
				+", a.FDOC"
				+", a.FEXPR"
				+", a.FFIELD"
				+", a.FKOEF"
				+", a.FNOM"
				+", a.FREM"
				+", a.FTYPE"
				+", a.FVAR"
				+", a.FWEXPR"
				+", a.FWID"
				+", a.FNOP"
				+((toPatt)?", " + sqlTo(forg) + " AS FORG ":" ")
			+" FROM ^" 
				+fromPrefix + "VARDOC a"
			+" WHERE 1=1"
			+" AND a.FNOP = 0"
			+" AND a.FDOC = " + sqlTo(fdoc) 
			+" AND NOT a.FDEFA"
			+" AND Not(FVAR In (SELECT b.FVAR FROM ^" + toPrefix + "VARDOC b WHERE b.FDOC = " + sqlTo(fdoc) + " AND (b.FNOP = " + sqlTo(fnop) + " OR b.FNOP = 0)))";
	ExecuteSQL(strSQL);
//END=================DarkAn 23.12.05================================

		//     Проставляем FWID'ы 		
	tmptbl = OpenTable("s", TEMP_VARDOC);
	for (;!tmptbl.IsEOF(); tmptbl.MoveNext())
	{
		tmptbl.Edit();
		tmptbl("FNOP") = newfnop;
		tmptbl("FWID") = GetUID();
		tmptbl.Update();			
	}	
	tmptbl = null;
		//     Заносим в образцы
	ExecuteSQL("INSERT INTO ^" + toPrefix + "VARDOC SELECT * FROM " + TEMP_VARDOC);
		
	/////////////////////////////////////////////////////////////////////////////////
	///////     Переносим параметры папки		
	///////////////////////////////////////////////////////////////////////////////////
	ExecuteSQL("INSERT INTO ^" + toPrefix + "PARDOC "
			+ " SELECT FDOC, FUSER, FVALUE, FVAR, " + sqlTo(newfnop) + " AS FNOP " + ((toPatt)?", " + sqlTo(forg) + " AS FORG ":" ")
			+ " FROM ^" + fromPrefix + "PARDOC "
			+ " WHERE FNOP = " + sqlTo(fnop) + " AND FDOC = " + sqlTo(fdoc));
	///////////////////////////////////////////////////////////////////////////////////
	__noWait = false;
		// Если выбрано "Для всех" возвратим ответ запроса к пользователю
	return (noAsk)?answer:"";
}

function findDiff(leftTbl, rightTbl, keyFields, fromPrefix)
{
	// сравним расширения
	include("objects\\dpCmp.js");
	var oCmp = new DpCmp();
	// Вытянем таблицы в темп
	DropTable("TMP_"+fromPrefix+leftTbl);
	DropTable("TMP_"+rightTbl);
	
	strSQL = " SELECT *"
			+" INTO "+"TMP_" + fromPrefix + leftTbl
			+" FROM "+"^" + fromPrefix + leftTbl
	ExecuteSQL(strSQL);

	strSQL = " SELECT *"
			+" INTO "+"TMP_"+rightTbl
			+" FROM "+"^"+rightTbl
	ExecuteSQL(strSQL);

	oCmp.tblLeft	= "TMP_"+fromPrefix+leftTbl;	//из pattern.mdb
	oCmp.tblRight	= "TMP_"+rightTbl;				//из Дебета
	oCmp.setKeyFields("", keyFields);
	oCmp.doCmp();

	return oCmp.tblDstName;
}

// IG 13 10.03.2006
// экспорт справочника из Дебета
function DpUpdate_expCl(mode, par)
{
	var retVal = true;
	var strMsg = "";

	// если что-то не передали - ругаемся
	if (isEmpty(par.FDIR))
	{
		strMsg = ru("Отсутствует путь экспорта!", "Відсутній шлях експорту!");
		retVal = false;
	}
	if (isEmpty(par.FFILE))
	{
		strMsg = ru("Отсутствует файл для экспорта!", "Відсутній файл для експорту!");
		retVal = false;
	}
	if (isEmpty(par.FCL))
	{
		strMsg = ru("Отсутствует номер справочника!", "Відсутній номер довіднику!");
		retVal = false;
	}
	if (!retVal)
	{
		alert(strMsg + ru("\nЭкспорт не выполнен.", "\nЕкспорт не виконаний."));
		return retVal;
	}

	// создадим базу данных
	var dbdir = par.FDIR;
	if (dbdir == "" || dbdir == null)
		dbdir = rootDirectory() + "..\\export\\";
	if (!createDirectory(dbdir))
	{
		alert(ru("Неверно указана директория образцов.","Невірно вказано директорію зразків.") + dbdir)
		retVal = false;
		return retVal;
	}
	if (dbdir.charAt(dbdir.length - 1) != "\\")
		dbdir = dbdir + "\\";
	var dbpath = dbdir + par.FFILE;

	var dbLabel = createDatabase(dbpath);

	// умолчание для префикса названия файла справочников
	par.FLABEL = (isEmpty(par.FLABEL) ? "IMPCL_" : par.FLABEL);
	// по умолчанию не чистим
	par.toClear = typeof(par.toClear) == "undefined" ? false : par.toClear;
	// если таблиц в тэмпе нету, то принудительно устанавливаем в полную очистку
	if (!IsTable(par.FLABEL + "CLRELCLCL"))
	{
		par.toClear = true;
	}

	if (par.toClear)
	{
		this.cleanCl("ALL", par.FCL, par.FLABEL, dbLabel)
	}
	this.cleanCl("", par.FCL, par.FLABEL);

	this.copyCl("EXPORT", par.FCL, par.FLABEL, dbpath);

	return retVal;
}

// IG 13 10.03.2006
// импорт справочника в Дебета
function DpUpdate_impCl(mode, par)
{
	var retVal = true;
	var strMsg = "";

	// если что-то не передали - ругаемся
	if (isEmpty(par.FDIR))
	{
		strMsg = ru("Отсутствует путь экспорта!", "Відсутній шлях експорту!");
		retVal = false;
	}
	if (isEmpty(par.FFILE))
	{
		strMsg = ru("Отсутствует файл для экспорта!", "Відсутній файл для експорту!");
		retVal = false;
	}
	if (isEmpty(par.FCL))
	{
		strMsg = ru("Отсутствует номер справочника!", "Відсутній номер довіднику!");
		retVal = false;
	}
	if (!retVal)
	{
		alert(strMsg + ru("\nЭкспорт не выполнен.", "\nЕкспорт не виконаний."));
		return retVal;
	}
	var dbdir = par.FDIR;
	if (dbdir == "" || dbdir == null)
		dbdir = rootDirectory() + "..\\export\\";
	if (dbdir.charAt(dbdir.length - 1) != "\\")
		dbdir = dbdir + "\\";
	var dbpath = dbdir + par.FFILE;

	// умолчание для префикса названия файла справочников
	par.FLABEL = (isEmpty(par.FLABEL) ? "IMPCL_" : par.FLABEL);
	// по умолчанию не чистим
	par.toClear = typeof(par.toClear) == "undefined" ? false : par.toClear;
	// если таблиц в тэмпе нету, то принудительно устанавливаем в полную очистку
	if (!IsTable(par.FLABEL + "CLRELCLCL"))
	{
		par.toClear = true;
	}

	if (par.toClear)
	{
		this.cleanCl("ALL", par.FCL, par.FLABEL)
	}
	this.cleanCl("", par.FCL, "^");

	this.copyCl("IMPORT", par.FCL, par.FLABEL, dbpath);

	return retVal;
}

// IG 13 04.08.2005
// Функция удаляет из заданного справочника fcl строки или убивает все в тэмпе)
function DpUpdate_cleanCl(mode, fcl, flabel, dbLabel)
{
	var retVal = true;
	// если mode == "ALL" 
	var isAll = (mode == "ALL");
	if (isAll)
	{
		// все убиваем
		DropTable(flabel + "CL");
		DropTable(flabel + "CLRELCLCL");
		DropTable(flabel + "CLCL");
		// создаем таблицы
		CreateTable(flabel + "CL", "CL", "*");
		CreateTable(flabel + "CLRELCLCL", "CLRELCLCL", "*");
		CreateTable(flabel + "CLCL", "CLCL", "*");
		if (!isEmpty(dbLabel))
		{
			DropTableEx(dbLabel, flabel + "CL");
			DropTableEx(dbLabel, flabel + "CLRELCLCL");
			DropTableEx(dbLabel, flabel + "CLCL");

			CreateTableEx(dbLabel, flabel + "CL", "CL", "*");
			CreateTableEx(dbLabel, flabel + "CLRELCLCL", "CLRELCLCL", "*");
			CreateTableEx(dbLabel, flabel + "CLCL", "CLCL", "*");
		}
	}
	else
	{
		// Удаляем название справочника
		strSQL = " DELETE CLCL.* "
				+" FROM "
					+flabel + "CLCL CLCL "
				+" WHERE 1 = 1 "
					+" AND CLCL.FCOD =" + sqlTo(fcl)
		ExecuteSQL(strSQL);
		// Удаляем названия
		strSQL = " DELETE N.* "
				+" FROM "
					+flabel + "CL N "
					+", " + flabel + "CLRELCLCL REL "
				+" WHERE 1 = 1 "
					+" AND REL.FCL =" + sqlTo(fcl)
					+" AND N.FWID = REL.FWID_CL"
		ExecuteSQL(strSQL);
		// Удаляем значения в справочнике.
		strSQL = " DELETE REL.* "
				+" FROM "
					+flabel + "CLRELCLCL REL "
				+" WHERE 1 = 1 "
					+" AND REL.FCL ="+sqlTo(fcl)
		ExecuteSQL(strSQL);
	}
	return retVal;
}

// копирование справочника
function DpUpdate_copyCl(mode, fcl, flabel, dbpath)
{
	var retVal = true;
	var exp = (mode == "EXPORT");
	var imp = !exp;

	// Копируем значения в справочнике в тэмпу.
	strSQL = " INSERT INTO "
				+flabel + "CLRELCLCL "
			+" SELECT "
				+" REL.* "
			+" FROM "
				+(exp ? "^CLRELCLCL REL" : (flabel + "CLRELCLCL REL IN " + sqlTo(dbpath)))
			+" WHERE 1 = 1 "
				+" AND REL.FCL = " + sqlTo(fcl)
	ExecuteSQL(strSQL);
	// Копируем названия в тэмпу
	strSQL = " INSERT INTO "
				+flabel + "CL "
			+" SELECT "
				+" N.* "
			+" FROM "
				+(exp ? "^CL N" : (flabel + "CL N "))
				+", " + (exp ? "^CLRELCLCL REL" : (flabel + "CLRELCLCL REL IN " + sqlTo(dbpath)))
			+" WHERE 1 = 1 "
				+" AND REL.FCL = " + sqlTo(fcl)
				+" AND N.FWID = REL.FWID_CL"
	ExecuteSQL(strSQL);
	// Копируем название справочника в тэмпу
	strSQL = " INSERT INTO "
				+flabel + "CLCL "
			+" SELECT "
				+" CLCL.* "
			+" FROM "
				+(exp ? "^CLCL CLCL" : (flabel + "CLCL CLCL IN " + sqlTo(dbpath)))
			+" WHERE 1 = 1 "
				+" AND CLCL.FCOD = " + sqlTo(fcl)
	ExecuteSQL(strSQL);

	// теперь перенесем, куда указано(или в Дебет или в mdb)
	if (imp)
	{
		this.cleanCl("", fcl, "^")
	}

	// Копируем значения в справочнике.
	strSQL = " INSERT INTO "
				+(exp ? (flabel + "CLRELCLCL IN " + sqlTo(dbpath)) : "^CLRELCLCL")
			+" SELECT "
				+" REL.* "
			+" FROM "
				+flabel + "CLRELCLCL REL"
			+" WHERE 1 = 1 "
				+" AND REL.FCL = " + sqlTo(fcl)
	ExecuteSQL(strSQL);
	// Копируем названия
	strSQL = " INSERT INTO "
				+(exp ? (flabel + "CL IN " + sqlTo(dbpath)) : "^CL")
			+" SELECT "
				+" N.* "
			+" FROM "
				+flabel + "CL N "
				+", " + flabel + "CLRELCLCL REL "
			+" WHERE 1 = 1 "
				+" AND REL.FCL = " + sqlTo(fcl)
				+" AND N.FWID = REL.FWID_CL"
	ExecuteSQL(strSQL);
	// Копируем название справочника
	strSQL = " INSERT INTO "
				+(exp ? (flabel + "CLCL IN " + sqlTo(dbpath)) : "^CLCL")
			+" SELECT "
				+" CLCL.* "
			+" FROM "
				+flabel + "CLCL CLCL "
			+" WHERE 1 = 1 "
				+" AND CLCL.FCOD = " + sqlTo(fcl)
	ExecuteSQL(strSQL);

	return retVal;
}

function DpUpdate_addExt(par)
{
	var extFwid = GetUID();

	var CL_EXT		= OpenTable("s", "CL_EXT");
	var CL_EXT_L	= OpenTable("s", "CL_EXT_L");
	var EXT_CL		= OpenTable("s", "EXT_CL");
	var EXT_NMK		= OpenTable("s", "EXT_NMK");
	
	if (par.mode == "ANALIT" || par.mode == "ANALIT_12" || par.mode == "HDOC" || par.mode == "RDOC" || par.mode == "NMKL")
	{
		alert("Пока не реализовано");
		return false;
	}

	// чистим 
	strSQL = "DELETE FROM "
}

function DpUpdate_clearAllDb()
{
	include("servis\\date.js");
	include("month_txt.js");
	
	D1 = new Date(2000,0,1);
	D2 = firstDay(new Date());
	
	// список таблиц, которые не нужно чистить
	var sTables = 
		" 'ORGVARS'"
		+",'P_CODES'"
		+",'PARDOC'"
		+",'PSW'"
		+",'TUNE_BPN'"
		+",'TUNE_RNNP'"
		+",'ZAKRSC'"
		+",'CL'"
		+",'CL_CALC'"
		+",'CL_EXT'"
		+",'CL_EXT_L'"
		+",'CL_FRM'"
		+",'CL_LINKDOC'"
		+",'CL_LINKVARS'"
		+",'CL_LNK'"
		+",'CL_LST'"
		+",'CL_NAL'"
		+",'CL_OP'"
		+",'CL_PLUGFRM'"
		+",'CL_RASSC'"
		+",'CL_REG'"
		+",'CL_SCHET'"
		+",'CL_SCR'"
		+",'CL_TT'"
		+",'CL_TTFLD'"
		+",'CL_TTR'"
		+",'CL_TTSUM'"
		+",'CL_VALUT'"
		+",'CLCL'"
		+",'CLRELCLCL'"
		+",'D_COR'"
		+",'EXT'"
		+",'EXT_CL'"
		+",'REGVID'"
		+",'USED_FRM'"
		+",'VARDCDEF'"
		+",'VARDOC'"
		+",'VARSFRM'"
		+",'CL_EDI'"
		+",'CL_NMK'"
		+",'EXT_NMK'"
		+",'INV_DIAP'"
		+",'CL_FLV'"
		+",'CL_LIC'"
		+",'CL_NVK'"
		+",'CL_SHABR'"
		+",'CONST'"
		+",'NALOG'"
		+",'VSRAZN'"
		+",'NORM_GR'"
		+",'VIDOS'"
		+",'CL_OSV'"
		+",'BALANS'"
		+",'BALANS_U'"

	var aTables = new Array(
		 "AVNS"
		,"DLG"
		,"DLT"
		,"DLTU"
		,"STT"
		,"TBL"
	);

	var aTables2 = new Array(
		"SVZP"
	);

	DropTable("LIST_TABLES");
	strSQL = " SELECT DISTINCT"
				+"  T.FTABLE"
				+", T.FSYS"
				+", T.FPATH"
			+" INTO LIST_TABLES"
			+" FROM ^StruTables T"
				+", ^StruFields F"
			+" WHERE 1=1"
				+" AND F.FPATTERN = T.FTABLE"
				+" AND T.Fpath IN ('ALL_MDB','CL_MDB','update','ZRP_MDB','ZRP_RES')"
				+" AND T.FPATTERN NOT IN ("+sTables+")"
	ExecuteSQL(strSQL);
	
	tbl = OpenTable("s", "LIST_TABLES");
	setProgressRange(0, tbl.recordCount());
	i=0;
	for (; !tbl.IsEOF(); tbl.MoveNext())
	{
		setProgressPos(i, "Шаг №1");
		i++;
		nameTbl = tbl("FTABLE");
		if (IsTableEx(tbl("FPATH"), tbl("FSYS")+"_"+tbl("FTABLE")))
		{
			strSQL = "DELETE FROM ^"+nameTbl
			ExecuteSQL(strSQL);
		}
	}
	setProgressPos(0, "");

	cDate = D1;
	nKolMes = Math.abs((D2.getYear()-D1.getYear())*12-(11-D2.getMonth()));
	
	setProgressRange(0, nKolMes);
	while(cDate<=D2)
	{
		setProgressPos(nKolMes, "Шаг №2");
		for (var i in aTables)
		{
			DropTableEx("ZRP_MDB", "ZRP_"+aTables[i]+month_txt(cDate))
			DropTableEx("ZRP_RES", "ZRP_"+aTables2[i]+month_txt(cDate))
		}
		cDate = goMonth(cDate, 1);
	}
	setProgressPos(0, "");
	
	
	// чистим справочники кроме диапазона 58 до 68, но чистим 60
	for (var numCl = 1; numCl <= 250; numCl++)
	{
		if (numCl >= 58 && numCl <= 68 && numCl != 60) continue;
		strSQL = "DELETE"
			+" CL.*"
		+" FROM"
			+" ^CL AS CL,"
			+" ^CLRELCLCL AS REL"
		+" WHERE "
			+" REL.FCL="+sqlTo(numCl)
			+" AND REL.FWID_CL=CL.FWID"
		ExecuteSQL(strSQL);
		
		strSQL = "DELETE"
			+" REL.*"
		+" FROM"
			+" ^CLRELCLCL AS REL"
		+" WHERE "
			+" REL.FCL="+sqlTo(numCl)
		ExecuteSQL(strSQL);
	}
}

function DpUpdate_setNoPrihod()
{
	include("objects\\DpAskEx.js");
	oA = new DpAskEx();
	oA.add("NMK", "Номенклатура", "NMKL", "");
	oA.doAsk();
	if(oA.escape)
	{
		return;
	}
	var fnmkl = oA.get("NMKL").getCod();

	strSQL = " UPDATE ^ANLTK A "
			+" SET FID_PN = ''"
			+" WHERE 1=1"
				+" AND FNMKL = "+sqlTo(fnmkl)
	ExecuteSQL(strSQL);
}

function DpUpdate_addMainMenu(par)
{
	// проверим все переменные
	//par.delBinMenu = ((typeof(par.delBinMenu) == "undefined" || par.delBinMenu == null) ? true : par.delBinMenu);
	par.mode = isEmpty(par.mode) ? "item" : par.mode.toLowerCase();
	par.filter = isEmpty(par.filter) ? "BLN_BNK_CAS_MTR_UOS_ZRP_CDR_ADM" : par.filter;
	par.type = isEmpty(par.type) ? "l" : par.type;
	par.par = isEmpty(par.par) ? "" : par.par;
	if (isEmpty(par.dist))
	{
		par.dist = "";
	}
	if (par.mode == "menu" && isEmpty(par.id))
	{
		alert(ru("Не задан идентификатор меню, меню " + par.ru + " не добавлено.",
				"Не задано ідентифікатор меню, меню " + par.ua + " не додано."));
		return false;
	}
	//showObject(par)
	if (par.mode == "item" && isEmpty(par.command))
	{
		alert(ru("Не задан исполняемый файл меню " + par.ru + " Меню не добавлено",
				"Не заданий виконуємий файл меню " + par.ua + " Меню не додано."));
		return false;
	}

	// теперь выполним действия перед изменением меню
	var sPath;
	var fileName = "DpMenu.xml";

	distPath = rootDirectory();
	sPath = rootDirectory() + "..\\userData\\";
	if(!isFile(sPath + fileName))
	{
		var sAltPath = rootDirectory()+"..\\";
		copyFile(sPath+fileName, sAltPath+fileName);
	}

	/*
	// перенесем меню в html
	if(isFile(sPath + fileName))
	{
		copyFile(sPath + fileName, distPath + fileName);
		deleteFile(sPath + fileName);
	}
	*/

	// теперь добавим наше меню куда надо
	include("objects\\DpXMLDOMDocument.js");
	var xmlDom = new DpXMLDOMDocument();
	
	var bLoaded = xmlDom.load(sPath + fileName);
	if (!bLoaded) return false;
	var xmlD = xmlDom.getDocumentElement();
	// найдем куда добавлять
	if (par.dist == "")
	{
		var xmlElem = xmlD.selectSingleNode("//menu");
	}
	else
	{
		var xmlElem = xmlD.selectSingleNode("//menu[@id='" + par.dist + "']");
	}
	// проверим, может то что надо уже есть
	switch (par.mode)
	{
		case "menu":
			if (!isEmpty(xmlElem.selectSingleNode("//menu[@id='" + par.id + "']")))
			{
				WAIT(ru("Меню " + par.ru + " уже добавлено.", "Меню " + par.ua + " вже додано."));
				return false;
			}
		break;
		case "item":
		default:
			if (!isEmpty(par.ru.trim()) && !isEmpty(xmlElem.selectSingleNode("//item[@command='" + par.command + "' and @par='" + par.par + "']")))
			{
				WAIT(ru("Пункт меню " + par.ru + " уже добавлен.", "Пункт меню " + par.ua + " вже додано."));
				return false;
			}
		break;
	}
	// значит еще нету... хорошо, продолжаем
	//newD = new DpXMLDOMDocument();
	newEl = xmlDom.createElement(par.mode);
	
	// обвесим аттрибутами
	switch (par.mode)
	{
		case "menu":
			newEl.setAttribute("id", par.id);
			newEl.setAttribute("ru", par.ru);
			newEl.setAttribute("ua", par.ua);
			newEl.setAttribute("filter", par.filter);
		break;
		case "item":
		default:
			newEl.setAttribute("ru", par.ru);
			newEl.setAttribute("ua", par.ua);
			newEl.setAttribute("filter", par.filter);
			newEl.setAttribute("type", par.type);
			newEl.setAttribute("command", par.command);
			if (!isEmpty(par.hotkey))
			{
				newEl.setAttribute("hotkey", par.hotkey);
			}
			if (!isEmpty(par.par))
			{
				newEl.setAttribute("par", par.par);
			}
		break;
	}

	xmlElem.appendChild(newEl);
	xmlDom.save(sPath + fileName);
	switch (par.mode)
	{
		case "menu":
			alert(UR("Mеню успішно додано|Mеню успешно добавленo"));
		break;
		case "item":
		default:
			alert(UR("Пункт меню успішно додано|Пункт меню успешно добавлен"));
		break;
	}


}


/*
<totals>
	<tt label="obr">
		<field name="FLIST" type="text(8)" />
		<field name="FNO" type="short" />
		<field name="FTXT" type="longtext" />
	</tt>

	<ttfld label="obr">
		<field name="FFIELD" type="text(40)" />
		<field name="FLIST" type="text(8)" />
		<field name="FNO" type="short" />
		<field name="FTXT" type="longtext" />
		<field name="FTT" type="text(3)" />
		<field name="FCOND" type="longtext" />
		<field name="FDEFA" type="longtext" />
	</ttfld>

	<ttsum label="obr">
		<field name="FFIELD" type="text(40)" />
		<field name="FNO" type="short" />
		<field name="FLIST" type="text(8)" />
		<field name="FFUNC" type="text(20)" />
		<field name="FTXT" type="longtext" />
	</ttsum>

	<ttr label="obr">
		<field name="FHNO" type="short" />
		<field name="FNO" type="short" />
		<field name="FLIST" type="text(8)" />
		<field name="FITOG" type="text(1)" />
		<field name="FFIELD" type="text(40)" />
	</ttr>
</totals>
*/

function DpUpdate_addTotals()
{

}

include("objects\\DpDbMod.js");
include("sys\\main.js");

//список функций для модификации таблиц
var tmpTblName = "tmpTbl4Mod";
var DONE = false;
var strTable = "";
var tblName, version;
function modi_tbl(tableName){

// alex 28.04.2004
	lpProxy.reloadDBStru();

	var typ = objTypeOf(tableName).toLowerCase();
	switch (typ) 
	{
		case "undefined":		
			break;
		case "string":
			strTable = " AND NOT FTBL IN("+tableName+")"
			break;
		case "array":
			if (tableName.length>0)
			{
				strTable = " AND NOT FTBL IN(";
				for (var i=0; i<tableName.length; i++)
				{
					strTable += "'"+tableName[i]+"'"+","
				}
				strTable = strTable.substring(0, strTable.length-1);
				strTable += ")"; 
			}
			break;
		case "object":
			if (tableName != null)
			{
				strTable = " AND NOT FTBL IN(";
				for (i in tableName)
				{
					strTable += "'"+tableName[i]+"'"+","
				}
				strTable = strTable.substr(0, strTable.length-1);
				strTable += ")"; 			
			}
			break;
	}

	modification();
	
	//CloseWindow();

	return;
}

function gatherTblInfo()
{
	var tblInfo = OpenTable("s","SELECT * FROM " + tmpTblName
							+ " WHERE FDOMOD<>" + sqlTo(false)
							+ " OR FREINDEX<>" + sqlTo(false)
							);
	var arTI = new Array();
	for(tblInfo.MoveFirst();!tblInfo.isEOF();tblInfo.MoveNext())
	{
		var TI = new tableModInfo();
		TI.num = tblInfo.getValue("FWID");
		TI.base = String(tblInfo.getValue("FBASE"));
		TI.sys = String(tblInfo.getValue("FSYS"));
		TI.table = String(tblInfo.getValue("FTBL"));
		TI.pattern = String(tblInfo.getValue("FPATTERN"));
		if (!TI.pattern || TI.pattern == "" || TI.pattern == null)
			TI.pattern = TI.table;
		
		TI.fullName = (TI.sys != ""?TI.sys + "_":"") + TI.table;
		
		TI.exists = tblInfo.getValue("FEXISTS") != false;
		TI.domod = tblInfo.getValue("FDOMOD") != false;
		TI.reindex = tblInfo.getValue("FREINDEX") != false;
		
		arTI.push(TI);
	}
	tblInfo.close();
	return arTI;
}

function getAllTables()
{
	DropTable(tmpTblName);
	ExecuteSQL("CREATE TABLE " + tmpTblName
			   + "("
			   + " FWID " + SqlType("COUNTER")
			   + " ,FBASE " + SqlType("TEXT",20)
			   + " ,FSYS " + SqlType("TEXT",20)
			   + " ,FTBL " + SqlType("TEXT",20)
			   + " ,FPATTERN " + SqlType("TEXT",20)
			   + " ,FDOMOD " + SqlType("LOGICAL")
			   + " ,FREINDEX " + SqlType("LOGICAL")
			   + " ,FEXISTS " + SqlType("LOGICAL")
			   + ")");
	var tables = getStruTables();
	
	if (!isSilent4Modi)
	{
		setProgressRange(1,tables.length);
		var txt = ru("Сбор информации. . .", "Збір інформації. . .");
		setProgressPos(1, txt);
	}
	var batch = lpProxy.getBatch();

	for (var nTbl = 0; nTbl < tables.length; nTbl++)
	{
		var base = String(tables[nTbl].base).toUpperCase();
		var dbPath = getPath(base);
		if (!dbPath || dbPath == null || dbPath == "")
			continue;
		var tblName = (tables[nTbl].sys==""?"":tables[nTbl].sys + "_") + tables[nTbl].table;
		tblName = String(tblName).toUpperCase();
		var exists = IsTableEx(base,tblName) || tblName.indexOf("%LD") != -1;
		var tdomode = false;
		var treindex = false;
		if (String(tables[nTbl].pattern))
		{
		var sSQL = "INSERT INTO " + tmpTblName
				   + " (FBASE,FSYS,FTBL,FDOMOD,FREINDEX,FEXISTS,FPATTERN)"
				   + " VALUES("
				   + sqlTo(base)
				   + "," + sqlTo(String(tables[nTbl].sys).toUpperCase())
				   + "," + sqlTo(String(tables[nTbl].table).toUpperCase())
				   + "," + sqlTo(true)
				   + "," + sqlTo(false)
				   + "," + sqlTo(exists)
				   + "," + sqlTo(tables[nTbl].pattern)
				   + ")";
		batch.addBatch(sSQL);
		}
		if (!isSilent4Modi)
		{
			setProgressPos(nTbl + 1, txt);
		}
	}
	batch.execute(false);
	batch.close();
	if (!isSilent4Modi)
	{
		setProgressPos(0);
	}


}

function modification()
{
	if (!isSilent4Modi)
	{
		if('c'== msgBox("co","Внимание !!! Будут внесены необратимые изменения"
			, "Обновление") )
		{
			//CloseWindow();
			return;
		}
	}

	// Модифицируем таблицы
	getAllTables();
	
	var sSQL = "UPDATE " + tmpTblName + " SET"
			   + " FDOMOD=" + sqlTo(false)
			   + " WHERE"
			   + " FREINDEX=" + sqlTo(true)
			   + " AND FEXISTS<>" + sqlTo(true);
	if (SUBD != DERBY)
		sSQL += " AND FTBL NOT LIKE '%\\%%'";
	else
		sSQL += " AND FTBL NOT LIKE '%\\%%' ESCAPE '\\'";
	ExecuteSQL(sSQL);
	
	if (strTable != "")
	{
		var sSQL = "UPDATE " + tmpTblName + " SET"
				   + " FDOMOD=" + sqlTo(false)
				   + ", FREINDEX=" + sqlTo(false)
				   + " WHERE 1=1"
				   +strTable
				   //+ " NOT FTBL IN (" + sqlTo(tblName)+")"
		ExecuteSQL(sSQL);
	}

	var arTI = gatherTblInfo();
	modTbl(arTI);
	return;
}

function onAfterMod()
{
	sDBVer = lpProxy.getDBManager().getDBVersion();
	if (DpUtils.compareVersion(sDBVer,"11.1.28") < 0)
	{
		ExecuteSQL("DELETE FROM ^archive where fdoc = 'CLS.CL2' ");
	}
	
	if (DpUtils.compareVersion(sDBVer, "11.4.15") < 0)
	{
		include("sys/servis.js");
		extentionsToXML();
		userVarsToXML();		
	}
}

// Процедура модификации таблицы mFtable
// Будет получена версия sVer
function modTbl(arTI)
{
	if (arTI.length>0)
	{
		var dbMod = new DpDbMod();
		if (!isSilent4Modi)
		{
			dbMod.dropViews();
			dbMod.createFunctions();

			setProgressRange(1,arTI.length);
			var txt = ru("Модификация . . . ", "Модифікація . . . ");
			setProgressPos(1, txt);
		}
	
		for (var nTbl = 0; nTbl < arTI.length; nTbl++)
		{
			dbMod.modTable(arTI[nTbl]);
			if (!isSilent4Modi)
			{
				setProgressPos(nTbl, txt);
			}
		}
		if (!isSilent4Modi)
		{
			dbMod.createViews();
		}
		
		var sVersion = lpProxy.getVersion();
		onAfterMod();
		// Net 08.09.2009  добавляем совместимость с SQL Server 2000
		if (SUBD == MSSQL)
		{
			strSQL = " SELECT @@VERSION "
			var sn = getSnap(strSQL);
			var sqlver = sn[0].replace(/\n/gi, " ").replace(/\t/gi, " ").replace(/  /gi, " ");
			sn = null;

			if (strIn("Microsoft SQL Server 2000", sqlver))
			{
				var sBase = getPath("ALL_MDB");
				if (!IsTableEx("ALL_MDB", "DBVERSION"))
				{
					strSQL = " CREATE TABLE " + sBase + "..DBVERSION (FVERSION NVARCHAR(20)) "
					ExecuteSQL(strSQL);
				}

				strSQL = " DELETE FROM " + sBase + "..DBVERSION "
				ExecuteSQL(strSQL);

				strSQL = " INSERT INTO " + sBase + "..DBVERSION VALUES (" + sqlTo(sVersion) + ") "
				ExecuteSQL(strSQL);
			}
			else
			{
				lpProxy.getDBManager().setDBVersion(sVersion);
			}
		}
		else
		{
			lpProxy.getDBManager().setDBVersion(sVersion);
		}

		var updmenu = false;
		var etalon = false;
		var journal = false;
			
		if (journal == true)
		{
			editJournal()
		}
		if (!isSilent4Modi)
		{
			setProgressPos(0);

			alert("Модификация успешно завершена");
		}
		return;
	}
	else
	{
		alert(UR("Така таблиця відсутня|Такая таблица отсутствует"));
	}
}
function editJournal()
{
	include("objects/DpJRegistrator.js");
	oReg = new DpJRegistrator(null,null,"US");
	var allJ = oReg.listJournals();
	for (var jID in allJ)
	{
		var oJ = allJ[jID];
		if (!oJ)
				cuntinue;		
		oJ.commitStructure(true);
	}
}

function editEtaton()
{
	if (updmenu == true)
	{
		lpProxy.updateMenu(null);	
	}

	if (etalon == true)
	{
		var sFileName = rootDirectoryEx() + "Source/itog.xml"
		lpProxy.doItogsIn(sFileName);
		sFileName = rootDirectoryEx() + "Source/orgvars.xml"
		lpProxy.doOrgVarsIn(sFileName);
		
		include ("sys/servis.js");
		refreshDocList();		
	}
}