include("Objects/DpGrid.js");

function listLoad()
{
	with(this)
	{
		accDel = listDel;
	}
}

function listTitle()
{
	var title = UR("Архів операцій по параметрам системи|Архив операций по параметрам системы");
	return title;
}

function listAsk()
{
	include("objects/DpAskEx.js");
	var oA = new DpAskEx();
	oA.add("D", "Дата початку|Дата начала", "BDAT", firstDay(new Date()).getVarDate());
	oA.add("D", "Дата закінчення|Дата конца", "EDAT", lastDay(new Date()).getVarDate());
	oA.setRel(">=", "EDAT", "BDAT");
	oA.doAsk();
	
	return oA;
}

function listSrc()
{
	var bdat = list.objAsk.get("BDAT");
	var edat = list.objAsk.get("EDAT");

	var sWhere = " 1=1 "
				+" AND FMDATE BETWEEN "+sqlTo(bdat)+" AND "+sqlTo(edat)

	// перечислим поля явно без FDATA, т.к. грид не может такое отобразить и дебет зависает
	this.qrySet ("Fields", "FPARAMS, FSYS, FMDATE, FMUSER, FMHOST, FWID"
				, "From", "^PARARCHIVE"
				, "Where", sWhere
				, "Order", "FMDATE DESC, FPARAMS");
}

function listGrid()
{
	var oGrid = new DpGrid("NOCREATE");

	with(oGrid)
	{
		grid.setFilling("FMDATE");
		with(page("Архів|Архив"))
		{
			cell("FPARAMS", "Файл|Файл", 12);
			cell("FSYS", "Підсистема|Подсистема", 12);
			cell("FMDATE", "Дата дії|Дата действия", 12);
			cell("=format(\"HH:MM:SS\",^FMDATE)", "Час дії|Время действия", 12);
			cell("FMUSER", "Корист.|Польз.", 15);
			cell("FMHOST", "Комп.", 15);
			cell("FWID", "FWID", 15);
		}
		build();
	}
}

function listMenuInit()
{
	if (this.dataSrc.getTable().IsRecord())
	{
		this.dataSrc.AddMenuItem("VIEWPARAMS","Перегляд|Просмотр");
		this.dataSrc.AddMenuItem("COMPARE","Порівняти 2 записи|Сравнить 2 записи");
	}
}

function listMenuRun(ID, toObject)
{
	switch(ID)
	{
		case "VIEWPARAMS":
			strSQL = " SELECT COUNT(*) FROM ^PARARCHIVE WHERE "+this.dataSrc.sqlSelected()
			var sn = getSnap(strSQL);
			if (sn[0] != 1)
			{
				alert(UR("Потрібно вибрати 1 запис|Необходимо выбрать 1 запись"));
				return;
			}
			sn = null;

			var tmp = getTmpTableName("", true);
			var m = new Object();
			m.FFIELD = "TEXT";
			m.FVALUE = "TEXT";
			m.FWID = "COUNTER";
			CreateTable(tmp, m);
			createIndex(tmp, "IX_FIELD", "FFIELD");

			var oXml = new DpXMLDOMDocument();
			var sn = getSnap("SELECT FDATA, FMDATE, FPARAMS FROM ^PARARCHIVE WHERE "+this.dataSrc.sqlSelected());
			oXml.loadXML(String(sn[0]));
			var mFdate = !isEmpty(sn[1]) ? sn[1] : sqlD00;
			var mFpar = !isEmpty(sn[2]) ? sn[2] : "";

			var rows = oXml.getDocumentElement().getChildNodes();
			if (!isEmpty(rows))
			{
				for (var i in rows)
				{
					xmlNode2tbl(rows[i], tmp, "");
				}
			}

			var title = UR("Параметри "+mFpar+" на "+format("dd.mm.yyyy HH.MM.SS", new Date(mFdate))+"|"
							+"Параметры "+mFpar+" на "+format("dd.mm.yyyy HH.MM.SS", new Date(mFdate)));
			include("Objects/DpZaval.js");
			var oZaval = new DpZaval(title);
			strSQL = " SELECT *"
					+" FROM "+tmp
					+" ORDER BY FFIELD "
			oZaval.setSQL(strSQL);
			oZaval.FieldEx("FFIELD", "Параметр", 20);
			oZaval.FieldEx("FVALUE", UR("Значення|Значение"), 30);
			oZaval.open();
			oZaval = null;

			DropTable(tmp);
			break;

		case "COMPARE":
			if (this.dataSrc.getSelectedCount() != 2)
			{
				alert(UR("Потрібно вибрати 2 записи|Необходимо выбрать 2 записи"));
				return;
			}

			strSQL = " SELECT DISTINCT FPARAMS "
					+" FROM ^PARARCHIVE "
					+" WHERE "+this.dataSrc.sqlSelected()
			var tblSel = OpenTable(strSQL);
			if (tblSel.recordCount > 1)
			{
				alert(UR("Потрібно вибрати однакові файли|Необходимо выбрать одинаковые файлы"));
				tblSel.close(5652);
				tblSel = null;
				return;
			}
			tblSel.close(5652);
			tblSel = null;
			
			var tmp1 = getTmpTableName("", true);
			var m = new Object();
			m.FFIELD = "TEXT";
			m.FVALUE = "TEXT";
			m.FWID = "COUNTER";
			CreateTable(tmp1, m);
			createIndex(tmp1, "IX_FIELD", "FFIELD");

			var tmp2 = getTmpTableName("", true);
			m.FFIELD = "TEXT";
			m.FVALUE = "TEXT";
			m.FWID = "COUNTER";
			CreateTable(tmp2, m);
			createIndex(tmp2, "IX_FIELD", "FFIELD");
			m = null;
			
			var selIDList = this.dataSrc.getSelectedIDs();
			
			var oXml1 = new DpXMLDOMDocument();
			oXml1.loadXML(String(getSnap("SELECT FDATA FROM ^PARARCHIVE WHERE FWID = "+selIDList[0])[0]));
			var date1 = getSnap("SELECT FMDATE FROM ^PARARCHIVE WHERE FWID = "+selIDList[0])[0];
			
			var oXml2 = new DpXMLDOMDocument();
			oXml2.loadXML(String(getSnap("SELECT FDATA FROM ^PARARCHIVE WHERE FWID = "+selIDList[1])[0]));
			var date2 = getSnap("SELECT FMDATE FROM ^PARARCHIVE WHERE FWID = "+selIDList[1])[0];

			var rows = oXml1.getDocumentElement().getChildNodes();
			if (!isEmpty(rows))
			{
				var progress = new DpProgressMonitor(ru("Чтение файла №1", "Читання файлу №1"), rows.length);
				progress.start();

				for (var i in rows)
				{
					xmlNode2tbl(rows[i], tmp1);
					progress.setPos();
				}
				progress.stop();
			}

			rows = oXml2.getDocumentElement().getChildNodes();
			if (!isEmpty(rows))
			{
				var progress = new DpProgressMonitor(ru("Чтение файла №2", "Читання файлу №2"), rows.length);
				progress.start();
				for (var i in rows)
				{
					xmlNode2tbl(rows[i], tmp2);
					progress.setPos();
				}
				progress.stop();
			}

			// сравним таблицы
			var tmpDiff = getTmpTableName("", true);
			var m = new Object();
			m.FLD1 = "TEXT";
			m.FVAL1 = "TEXT";
			m.FLD2 = "TEXT";
			m.FVAL2 = "TEXT";
			m.FTYPE = "LONG";
			m.FWID = "COUNTER";
			CreateTable(tmpDiff, m);

			// отличающиеся значения в существующих параметрах
			strSQL = " INSERT INTO "+tmpDiff
						+" (FLD1, FVAL1, FLD2, FVAL2, FTYPE) "
					+" SELECT "
						+" T1.FFIELD AS FLD1"
						+", T1.FVALUE AS FVAL1"
						+", T2.FFIELD AS FLD2"
						+", T2.FVALUE AS FVAL2"
						+", 1 AS FTYPE "
					+" FROM "+tmp1+" T1 "
						+" INNER JOIN "+tmp2+" T2 ON T1.FFIELD = T2.FFIELD "
					+" WHERE 1 = 1 "
						+" AND T1.FVALUE <> T2.FVALUE "
			ExecuteSQL(strSQL);

			// отличающиеся по структуре параметры
			strSQL = " INSERT INTO "+tmpDiff
						+" (FLD1, FVAL1, FLD2, FVAL2, FTYPE) "
					+" SELECT "
						+" T1.FFIELD AS FLD1"
						+", T1.FVALUE AS FVAL1"
						+", T2.FFIELD AS FLD2"
						+", T2.FVALUE AS FVAL2"
						+", 2 AS FTYPE "
					+" FROM "+tmp1+" T1 "
						+" FULL JOIN "+tmp2+" T2 ON T1.FFIELD = T2.FFIELD "
					+" WHERE 1 = 1 "
						+" AND (T1.FFIELD IS NULL OR T2.FFIELD IS NULL) "
			ExecuteSQL(strSQL);

			strSQL = " SELECT COUNT(*) FROM "+tmpDiff
			var sn = getSnap(strSQL);
			if (sn[0] == 0)
			{
				alert(ru("Записи идентичны!", "Записи ідентичні!"));
			}
			else
			{
				var title = UR("Відмінности|Отличия");
				include("Objects/DpZaval.js");
				var oZaval = new DpZaval(title);
				strSQL = " SELECT *"
						+" FROM "+tmpDiff
						+" ORDER BY FLD1, FLD2 "
				oZaval.setSQL(strSQL);
				oZaval.FieldEx("FLD1", "Поле "+format("dd.mm.yyyy HH.MM.SS", new Date(date1), 15));
				oZaval.FieldEx("FLD2", "Поле "+format("dd.mm.yyyy HH.MM.SS", new Date(date2), 15));
				oZaval.FieldEx("FVAL1", UR("Значення|Значение")+" "+format("dd.mm.yyyy HH.MM.SS", new Date(date1)), 30);
				oZaval.FieldEx("FVAL2", UR("Значення|Значение")+" "+format("dd.mm.yyyy HH.MM.SS", new Date(date2)), 30);
				oZaval.open();
				oZaval = null;
			}

			DropTable(tmpDiff);
		break;
	}
}

function xmlNode2tbl(node, tblName, parentName)
{
	var m = new Object();
	m.FFIELD = (isEmpty(parentName) ? "" : parentName + "\\") + node.getNodeName();
	m.FVALUE = node.getText();
	updateTable(tblName, m, true);

	var fields = node.getChildNodes();
	for (var i in fields)
	{
		xmlNode2tbl(fields[i], tblName, m.FFIELD);
	}
	m = null;
}

function listDel()
{
	return false;
}

include("sys/DpList.js");