/**функция для отчетов по автотранспорту
// считает фактическое количество топлива и количесто по норме
// передаем:
// открытую таблицу tAvto с информацией по путевому листу
// имя таблицы, с которой брать строки документа
// имя таблицы, с которой брать данные по топливу для документа
*/
include("avto:AVTO_const.js");
var sprWorkType = getPar(const_GETPAR_WORKTYPE);
var sprFuelType = getPar(const_GETPAR_FUELTYPE);
function calcOverRun(tAvto, tbl, tblFuel)
{
	var tblTmp = "TMP_RTABLE_AVTO";
	var tblTmpOb = "TMP_RTABLE_AVTO_SPEC";
	var retPar = new Object(); // объект, который возвращаем
	retPar.Hs = 0;
	retPar.Hob = 0;
	retPar.fuelQty = 0;
	var strWhereAnd = " AND H.FDOC_NUM = " + sqlTo(tAvto.getValue("FNOMPUTL"))
			+" AND H.FDOC_DAT = " + sqlTo(tAvto.getValue("FDATE"))
			+" AND H.FAVTO = " + sqlTo(tAvto.getValue("FNOMAVTO"))
			+" AND H.FDRIVER = " + sqlTo(tAvto.getValue("FDRIVER"))
	// Сначала возьмем кол-во топлива по норме для спецоборудования
	// это было раньше Hob*tob
	strSQL = "SELECT SUM(T.FKOLVYD) AS FKOLVYD FROM (^WAYBILL H INNER JOIN "+tbl+" T ON (H.FWID = T.FID_DOC AND H.FDOC = 'avto:com.debet.avto')) "
			+" INNER JOIN "
			+" (^CLRELCLCL REL INNER JOIN ^CL_WORKTYPE WT ON (REL.FWID_CL = WT.FWID_CL AND REL.FCL = "+sqlTo(sprWorkType)+"))"
			+" ON T.FWORKTYPE = REL.FCOD "
			+" WHERE WT.FWORK = " + sqlTo(AVTO_WORKTYPE_SPEC)
			+" AND T.FTYPE = "+sqlTo(AVTO_WAYBILL_TYPE_FACT)
			+ strWhereAnd
	var sn = getSnap(strSQL);
	var Hob = 0;
	if (sn != null && sn[0] != null)
	{
		Hob = sn[0];
	}
	sn = null;
	DropTable(tblTmp);
	DropTable(tblTmpOb);
	if (IsTable(tblTmp) || IsTable(tblTmpOb))
	{
		return retPar;
	}
	// Спецоборудование может использовать то же топливо что и машина
	// Потому узнаем количество топлива, которое использовалось для езды
	strSQL = "SELECT SUM(T.FKOLVYD) AS FKOL, FT.FFUEL, 0 AS FKOLOB "
			+" INTO " + tblTmp
			+" FROM (^WAYBILL H INNER JOIN "+tbl+" T ON (H.FWID = T.FID_DOC AND H.FDOC = 'avto:com.debet.avto')) INNER JOIN "
			+" ((^CLRELCLCL REL INNER JOIN ^CL_WORKTYPE WT ON (REL.FWID_CL = WT.FWID_CL AND REL.FCL = "+sqlTo(sprWorkType)+"))"
			+" LEFT JOIN (^CLRELCLCL REL2 INNER JOIN ^CL_FUELTYPE FT "
				+" ON (REL2.FWID_CL=FT.FWID_CL AND REL2.FCL = "+sqlTo(sprFuelType)+"))"
					+" ON REL2.FCOD = WT.FFUEL)"
			+" ON T.FWORKTYPE = REL.FCOD "
			+" WHERE WT.FWORK = " + sqlTo(AVTO_WORKTYPE_RUN)
			+" AND T.FTYPE = "+sqlTo(AVTO_WAYBILL_TYPE_FACT)
			+ strWhereAnd
			+" GROUP BY FT.FFUEL"
	ExecuteSQL(strSQL);
	strSQL =" SELECT SUM(T.FKOLVYD) AS FKOLOB, FT.FFUEL"
			+" INTO " + tblTmpOb
			+" FROM (^WAYBILL H INNER JOIN "+tbl+" T ON (H.FWID = T.FID_DOC AND H.FDOC = 'avto:com.debet.avto')) INNER JOIN "
			+" ((^CLRELCLCL REL INNER JOIN ^CL_WORKTYPE WT ON (REL.FWID_CL = WT.FWID_CL AND REL.FCL = "+sqlTo(sprWorkType)+"))"
			+" LEFT JOIN (^CLRELCLCL REL2 INNER JOIN ^CL_FUELTYPE FT "
				+" ON (REL2.FWID_CL=FT.FWID_CL AND REL2.FCL = "+sqlTo(sprFuelType)+"))"
					+" ON REL2.FCOD = WT.FFUEL)"
			+" ON T.FWORKTYPE = REL.FCOD "
			+" WHERE WT.FWORK = " + sqlTo(AVTO_WORKTYPE_SPEC)
			+" AND T.FTYPE = "+sqlTo(AVTO_WAYBILL_TYPE_FACT)
			+ strWhereAnd
			+" GROUP BY FT.FFUEL"
	ExecuteSQL(strSQL);
	strSQL = "UPDATE "+tblTmp+" T  "
			+" SET T.FKOLOB = (SELECT FKOLOB FROM "+tblTmpOb+" T1"
			+" WHERE T.FFUEL = T1.FFUEL)"
			+" WHERE T.FFUEL IN (SELECT FFUEL FROM "+tblTmpOb+" )"
	ExecuteSQL(strSQL);
	var tSum = OpenTable("s", tblTmp);
	var Hs = 0;
	var fuelQty = 0;
	var fuelQtyAll = 0;
	for(; !tSum.IsEOF(); tSum.MoveNext())
	{
		strSQL = "SELECT SUM(T.FBFUEL+T.FFUEL_DESK-T.FEFUEL)"
			+" FROM (^WAYBILL H INNER JOIN "+tblFuel+" T ON (H.FWID = T.FID_DOC AND H.FDOC = 'avto:com.debet.avto')) "
			+" WHERE T.FTYPE = " + sqlTo(AVTO_NMK_FUEL)
			+" AND T.FFUEL = " + sqlTo(tSum.getValue("FFUEL"))
			+ strWhereAnd
		var sn = getSnap(strSQL);
		if (sn != null && sn[0] != null)
		{
			var koef = tSum.getValue("FKOL")/(tSum.getValue("FKOL")+tSum.getValue("FKOLOB"));
			fuelQty += sn[0]*koef;
		}	
		sn = null;		
	}
	if (fuelQty == 0)
	{
		return retPar;
	}
	strSQL = "SELECT SUM(T.FBFUEL+T.FFUEL_DESK-T.FEFUEL)"
			+" FROM (^WAYBILL H INNER JOIN "+tblFuel+" T ON (H.FWID = T.FID_DOC AND H.FDOC = 'avto:com.debet.avto')) "
			+" WHERE T.FTYPE = " + sqlTo(AVTO_NMK_FUEL)
			+ strWhereAnd
	var sn = getSnap(strSQL);
	if (sn != null && sn[0] != null)
	{
		fuelQtyAll = sn[0];
	}
	sn = null;
	if (!tSum.IsEmpty())
	{
		for(tSum.MoveFirst(); !tSum.IsEOF(); tSum.MoveNext())
		{
			strSQL = "SELECT T.FBFUEL+T.FFUEL_DESK-T.FEFUEL "
					+" FROM (^WAYBILL H INNER JOIN "+tblFuel+" T ON (H.FWID = T.FID_DOC AND H.FDOC = 'avto:com.debet.avto')) "
					+" WHERE T.FTYPE = " + sqlTo(AVTO_NMK_FUEL)
					+" AND T.FFUEL = " + sqlTo(tSum.getValue("FFUEL"))
					+ strWhereAnd
			var sn = getSnap(strSQL);
			if (sn != null && sn[0] != null)
			{
				var koef = tSum.getValue("FKOL")/(tSum.getValue("FKOL")+tSum.getValue("FKOLOB"));
				Hs += tSum.getValue("FKOL")*sn[0]*koef/fuelQty;
			}
			sn = null;
		}
	}
	tSum.close(5652);
	tSum = null;

	retPar.Hs = Hs;// количество топлива по норме для пробега
	retPar.Hob = Hob;// количество топлива по норме для спецоборудования
	retPar.fuelQty = fuelQtyAll;// количество топлива, использованное фактически
	return retPar;
}