include("objects/DpCl.js");
include("avto:AVTO_const.js");
include("servis/date.js");

var obj = extPar.dpObj;
var mode = extPar.mode;

function onLoad()
{
	Caption(ru("Аккумулятор", "Акумулятор")	+": "+ modeName(mode));
	var sprAccum = getPar(const_GETPAR_AKKUMUL);

	oClPar = new DpCl("N", sprAccum, extPar.Fcod1);
	oClPar.linkSmartCtrl(FCOD);
	
	ctrlLinker = new DpCtrlLinker(obj);
	ctrlLinker.addClLink("RCOD", oClPar);
	
	ctrlLinker.addLink("RBDAT", FBDAT);
	ctrlLinker.addLink("REDAT", FEDAT);
	ctrlLinker.addLink("RISZAPAS", FISZAPAS);

	setValid(FBDAT, FDAT_Valid);
	setValid(FEDAT, FDAT_Valid);
	
	ctrlLinker.toControls();
	
	if(mode == "ADD")
	{
		FEDAT.setValue(d00);
	}
}

function FDAT_Valid()
{
	var bdat = FBDAT.getValue();
	var edat = FEDAT.getValue();
	var ret = true;
	
	//Дата установки не может быть пустой
	if(isEmpty(bdat))
	{
		strMsg = ru("Укажите дату установки аккумулятора"
			, "Вкажіть дату встановлення акумулятора");
		WAIT(strMsg);
		
		ret = false;
	}
	
	//дата установки не межет быть больше даты снятия
	if(!isEmpty(bdat) && !isEmpty(edat) && (day_difference(bdat, edat) < 1))
	{
		strMsg = ru("Дата установки не может быть больше даты снятия"
			, "Дата встановлення не може бути більшою за  дату зняття");
		WAIT(strMsg);
			
		ret = false;
	}
	
	return ret;
}

function onSave()
{
	ctrlLinker.toVars();
}

include("sys/DpBaseDlg.js");