include("objects/DpCl.js");
include("avto:AVTO_const.js");
include("servis/date.js");

var obj = extPar.dpObj;
var sDir = rootDirectory() + "../modules/avto/scripts/cls/com.debet.clcl.avto/tires/";

var sRunsClass = "RUNS";
var sRunsTbl = extPar.tblRuns;
var sRunsTmpTbl = getTmpTableName();

function onLoad()
{
	Caption(ru("Шины", "Шини")	+": "+ modeName(extPar.mode));
	var sprTires = getPar(const_GETPAR_TIRESIZE);

	oClPar = new DpCl("N", sprTires, extPar.Fcod1);
	oClPar.linkSmartCtrl(FCOD);
	
//	FRUN.mask = "##########.##";
		
	fillCombo();
	
	ctrlLinker = new DpCtrlLinker(obj);
	ctrlLinker.addClLink("RCOD", oClPar);
	ctrlLinker.addLink("RBDAT", FBDAT);
	ctrlLinker.addLink("REDAT", FEDAT);
	ctrlLinker.addLink("RRUN", FALLRUN);
	ctrlLinker.addLink("RSTATE", FCOMBOSTATE);
	ctrlLinker.addLink("RISZAPAS", FISZAPAS);
	ctrlLinker.addLink("RREASON", FREASON);
	ctrlLinker.addLink("RHEIGHTPROT", FHEIGHTPROT);
	ctrlLinker.addLink("RSENTTIRE", FSENTTIRE);

	setValid(FBDAT, FDAT_Valid);
	setValid(FEDAT, FDAT_Valid);
	setValid(FDATERUN, FDATERUN_Valid);
	
	ctrlLinker.toControls();

	if(inList(this.sMode, "ADD", "COPY"))
	{
		FEDAT.setValue(d00);
	}
	
	FDATERUN.setValue(lastDay(new Date()));
	
	//дизейблим  поля 
	//они откроются при установленой дате снятия 
	if(isEmpty(FEDAT.getValue()))
	{
		Disable(FREASON);
		Disable(FHEIGHTPROT);
		Disable(FSENTTIRE);
	}
	Disable(FALLRUN);
	
	loadGrid(sRunsClass);
	FALLRUN.setValue(getAllRuns(FDATERUN.getValue()));
}

function gridMenuInit(grid)
{
	var clas = String(grid.getData())
	
	grid.AddMenuItem("ADD","Додати|Добавить");
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT","Редагувати|Редактировать");
		grid.AddMenuItem("COPY","Копіювати|Копировать");
		grid.AddMenuItem("DEL","Видалити|Удалить");
	}
}

function gridMenuRun(sID, grid)
{
	var tbl = grid.getTable();
	var tName = tbl.getTableName();
	var rowID = tbl.getValue("FWID");
	var clas = String(grid.getData());
		
	switch(sID)
	{
		case "DEL":
			var msg = ru("Подтвердите удаление записи.", "Підтвердіть вилучення запису.");
			var ret = msgBox("^c-", msg, ru("Подтверждение удаления","Підтвердження вилучення"));
			switch(ret)
			{
				case 'c':
					break;
				case '-':
					var rowID = Number(grid.getTable().getRowID());
					obj.deleteRow(clas, rowID);
					grid.getTable().Delete();
					grid.getTable().requery();
					grid.refresh();
					FDATERUN_Valid();
				break;
			}
			break;

		case "__XDEL":
			var delRowCount = grid.getSelectedCount();
	
			if (delRowCount <= 0)
			{
				return;
			}
			
			var selIds = grid.getSelectedIDs();
			var sCapt = ru("Удаление записей", "Видалення записів");
			var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів")+" (" + delRowCount + ").";
			if("c"==msgBox("c-", sMsg, sCapt))
			{
				return;
			}
			
			setProgressRange(0, delRowCount);
			for (var nRow = 0; nRow < selIds.length; nRow++)
			{
				setProgressPos(nRow + 1, sCapt +": "+ (nRow + 1) +"/"+ delRowCount);
				obj.deleteRow(clas, Number(selIds[nRow]));
			}
			
			strSQL = " DELETE FROM " + grid.getTable().getTableName()
					+" WHERE " + grid.sqlSelected()
			ExecuteSQL(strSQL);

			grid.getTable().requery();
			grid.clearSelected();
			grid.refresh();
			setProgressPos(0);
			FDATERUN_Valid();
			break;

		case "ADD":
		case "EDIT":
		case "COPY":
			var oRow;
			if(sID == "ADD")
				oRow = obj.createRow(clas);
			else if(sID == "EDIT")
					oRow = obj.getRow(clas, rowID);
			else if(sID == "COPY")
				oRow = obj.copyRow(clas, rowID);
			if(!oRow)
				break;
			if (!rowEdit(sID, clas, oRow))
				break;
			
			tbl.requery();
			grid.refresh();
			break;
	}
	return true;
}

function loadGrid(clas)
{
	var tmpTbl = "";
	var workTbl = "";
	var xmlFile = "";
	var sMode = this.sMode;
	var gridName = "GRIDRUNS";
	var xmlFile = gridName+".xml";
	
	DropTable(sRunsTmpTbl);
	if(!IsTable(sRunsTbl))
	{
		CreateTable(sRunsTbl, "CL_AVTO_TIRES_RUNS", "*");
	}

	var sSQL = "SELECT *"
			+ " INTO " + sRunsTmpTbl
			+ " FROM ^"+ sRunsTbl;
	switch (sMode)
	{
		case "ADD":
			sWhere = " WHERE 1<>1 ";
			break;
		case "COPY":
			sWhere = " WHERE FWID_CL="+ sqlTo(obj.nOldID);
			break;
		case "EDIT":
		default:
			sWhere = " WHERE FWID_CL="+ sqlTo(obj.getID());
			break;
	}
	sSQL += sWhere;
	ExecuteSQL(sSQL);
	
	strSQL = getSQL4grid(sRunsTmpTbl);
	gridTbl = OpenTable("m", strSQL);
			
	//парметры загрузки грида
	eval(gridName+".setXMLDir(sDir)");
	eval(gridName+".setXMLFile(xmlFile)");
	eval(gridName+".setTable(gridTbl)");
	eval(gridName+".build()");
	eval(gridName+".setData(clas)");
	
	//меню грида
	eval(gridName+".loadMenuHandler(this,'gridMenuInit')");
	eval(gridName+".selectMenuHandler(this,'gridMenuRun')");
	
	//var oGridEdit = new DpGridEdit(eval(gridName));
	//oGridEdit.canEdit = canEditRecord;

	return true;
}

function getSQL4grid(tbl)
{
	var strSQL = " SELECT * FROM " + tbl
				+" WHERE FMONTH <= "+sqlTo(FDATERUN.getValue())
	return strSQL;
}

function rowEdit(sMode, clas, oRow)
{
	var par = new Object();
	var tmpTbl ="";
	
	switch(clas)
	{
		case sRunsClass:
			tmpTbl = sRunsTmpTbl;
			break;
		default:
			break;
	}
	
	par.dpObj = oRow;
	par.mode = sMode;
	par.tblName = tmpTbl;
	par.formFile = "avto:/cls/com.debet.clcl.avto/tires/"+ clas.toLowerCase() +"/form.xml";
	par.dpObj.hasExt = hasExt;
	par.obj = obj;
	showWindow(par.formFile, "XMLDLG", par);
		
	if(par.escape)
		return false;
	
	var id = oRow.getID();
	
	if(inList(sMode, "ADD", "COPY"))
		obj.appendRow(clas, oRow);
		
	obj2DB(id, oRow.jObj, null, tmpTbl);
	
	FDATERUN_Valid();
	return true;
}

function hasExt()
{
	return false;
}

function onSave()
{
	
	ctrlLinker.toVars();
	
	var ID = obj.getID();
	ExecuteSQL("DELETE FROM ^"+ sRunsTbl +" WHERE FWID_CL = " + sqlTo(ID));
	ExecuteSQL("UPDATE " + sRunsTmpTbl + " SET Fwid_cl=" + sqlTo(ID));
	ExecuteSQL("INSERT INTO ^"+ sRunsTbl + " SELECT * FROM " + sRunsTmpTbl);
}

function fillCombo()
{
	var arr = AVTO_STATE_ARR;
	var oCtrl = FCOMBOSTATE;
	var val = AVTO_STATE_NEW;
	
	for (i in arr)
	{
		oCtrl.addItem(i, arr[i]);
	}
	oCtrl.value = val;
}

function FDATERUN_Valid()
{
	FALLRUN.setValue(getAllRuns(FDATERUN.getValue()));
	
	return true;
}

function getAllRuns(date)
{
	var sum  = 0;
	
	var strSQL = " SELECT SUM(FRUN)" 
				+" FROM "+sRunsTmpTbl
				+" WHERE 1=1"
					+" AND FMONTH <="+sqlTo(date)
	var sn  = getSnap(strSQL);
	
	if(sn != null && !isEmpty(sn[0]))
	{
		sum = sn[0];
	}
	
	GRIDRUNS.getTable().requery(getSQL4grid(sRunsTmpTbl));
	GRIDRUNS.refresh();
	
	return sum;
}

function FDAT_Valid()
{
	var bdat = FBDAT.getValue();
	var edat = FEDAT.getValue();
	var ret = true;
	
	//Дата установки не может быть пустой
	if(isEmpty(bdat))
	{
		strMsg = ru("Укажите дату установки шин", "Вкажіть дату встановлення шин");
		WAIT(strMsg);
		
		ret = false;
	}
	
	if(!isEmpty(edat))
	{
		Enable(FREASON);
		Enable(FHEIGHTPROT);
		Enable(FSENTTIRE);
	}
	else
	{
		//если убрали дату снятия то обнуляем значение этих полей
		FREASON.setValue("");
		FHEIGHTPROT.setValue(0);
		FSENTTIRE.setValue("");
		
		//и дизейблим их
		Disable(FREASON);
		Disable(FHEIGHTPROT);
		Disable(FSENTTIRE);
	}
	
	//дата установки не межет быть больше даты снятия
	if(!isEmpty(bdat) && !isEmpty(edat) && (day_difference(bdat, edat) < 1))
	{
		
		strMsg = ru("Дата установки не может быть больше даты снятия", "Дата встановлення не може бути більшою за  дату зняття");
		WAIT(strMsg);
			
		ret = false;
	}
			
	return ret;
}

include("sys/DpBaseDlg.js");