include("objects/DpCl.js");
include("objects/DpShtat.js");
include("objects\\DpShifPZ.js");
include("avto:AVTO_const.js");
include("servis/date.js");

var obj = extPar.dpObj;
var oTabn, oZatr, oUser;
var sprZatr;
var baseSum = extPar.bsum;
var doc_dat = extPar.doc_dat;
var mode = extPar.mode;
var oAvto = extPar.oAvto;

//параметры папки
var _pers_zaval = obj.parent.getPar("_pers_zaval");
var sprPers = obj.parent.getPar("_codpers");
var sprUser = (mode=="ADD" ? obj.parent.getPar("_codconsumer") : obj.getVar("RUSER_CL"));

function onLoad()
{
	Caption(ru("Помощники", "Помічники")	+": "+ modeName(extPar.mode));
	
	sprZatr = getPar(const_GETPAR_ZATR);
	
	//маски
	FWORK.mask = replicate("&", 300);
	FDAY.mask = "##";
	FHOUR.mask = "##.#";
	FPROC.mask = "###.##";
	FGTS.mask = "###.##";
	FSUM.mask = MASK_SUM;
		
	ctrlLinker = new DpCtrlLinker(obj);	
	
	// помошник (какой объект смотрим в настр. папки)
	switch (_pers_zaval)
	{	
		case 0:
			oTabn = new DpShtat("", new Date(doc_dat), new Date(doc_dat));
			oTabn.zavalInAllShtat = true;
			oTabn.linkCtrl("fcod", FTABN);
			setValid(FTABN, FTABN_valid);
			break;
		
		case 1:
			oTabn = new DpCl();
			oTabn.setClcl(sprPers)
			oTabn.linkCtrl(FTABN, FTABN_TXT);
			break;
		default: 
			alert(ru("Этот режим справочника персонала не предусмотрен!"
					, "Цей режим довідника персоналу не передбачено!"));
	}
	ctrlLinker.addClLink("RTABN", oTabn);
	
	oUser = new DpCl("", sprUser, 0);
	if (sprUser == 0)
	{
		oUser.setMode("0");
	}
	oUser.linkSmartCtrl(FUSER);
	ctrlLinker.addClLink("RUSER", oUser);
	
	oZatr = new DpCl("", sprZatr, 0);
	oZatr.linkSmartCtrl(FGALUZ);
	ctrlLinker.addClLink("RGALUZ", oZatr);
		
	ctrlLinker.addLink("RWORK", FWORK);
	ctrlLinker.addLink("RVOPL", FVOPL);
	ctrlLinker.addLink("RDAY", FDAY);
	ctrlLinker.addLink("RHOUR", FHOUR);
	ctrlLinker.addLink("RPROC", FPROC);
	ctrlLinker.addLink("RGTS", FGTS);
	ctrlLinker.addLink("RSUM", FSUM);
	
	ctrlLinker.toControls();
	
	if(oTabn instanceof DpShtat == true)
	{
		Disable(FTABN_TXT);
		FTABN_TXT.setValue(oTabn.getEmployeSurname());
	}
	
	calcSum();
	
	setValid(FVOPL, calcSum)
	setValid(FGTS, calcSum)
	setValid(FPROC, calcSum)
}

function onSave()
{
	ctrlLinker.toVars();
	
	//при сохранении нужно узнать код ШПЗ и записать в таблицу 
	//для этого используем объект DpShifPZ
	var par = {};
		par.clPodr = sprUser;
		par.clGaluz = sprZatr;
		par.clZatr = 3; 		//статьи затрат
		par.clAvto = getPar(const_AVTOTRANSPORT);
		par.codAvto = oAvto.getVar("FAVTO");
	
	var oShpz = new DpShifPZ("",par);
	oShpz.setObj(oZatr);
	oShpz.setObj(oUser);
	
	obj.setVar("RSHPZ", oShpz.save());
	obj.setVar("RUSER_CL", sprUser);
	
	oShpz = null;
}

function calcSum()
{
	var mFsum = 0;
	var mFvopl = String(FVOPL.getValue());
	var ret = true;
	
	switch (mFvopl)
	{
		case "PRC":
			ISPROC.setVisible(true);
			ISGTS.setVisible(false);
			Disable(FSUM);
			
			mFsum = round(baseSum * Number(FPROC.getValue()) /100, 2);
			FSUM.setValue(mFsum);
			break;
		case "FIX":
			ISPROC.setVisible(false);
			ISGTS.setVisible(false);
			Enable(FSUM);
			break;
		case "GTS":
			ISPROC.setVisible(false);
			ISGTS.setVisible(true);
			Disable(FSUM);
			
			//какое время учитывать берем из настройки папки. 
			//0 - часы
			//1 - дни
			if(extPar.time == 1)
			{
				mFtime = Number(FDAY.getValue());
			}
			else
			{
				mFtime = Number(FHOUR.getValue())
			}
			
			mFsum = round(mFtime * Number(FGTS.getValue()), 2);
			FSUM.setValue(mFsum);
			break;
	}
	
	if(isSaving() && isEmpty(Number(FSUM.getValue())))
	{
		FSUM.showErr(ru("Сумма равна нулю...", "Сума рівна нулю..."));
		ret = false;
	}
	
	return ret;
}

function FTABN_valid()
{
	//если oTabn это штатное расписание то сами опдейтим текстовое поле
	if(oTabn instanceof DpShtat == true)
	{
		FTABN_TXT.setValue(oTabn.getEmployeSurname());
	}
	return true;
}

include("sys/DpBaseDlg.js");