﻿include("objects/DpCl.js");
include("objects/DpLicf.js");
include("objects/DpShifPZ.js");
include("sys/mask.js");
include("sys/udfs.js");
include("avto:AVTO_const.js");	// Константы справочников
include("avto:servis\\avto_tools.js");	// сервисные функции
include("getParam.js");

var ctrlLinker;
var sprWorkType, sprUser, sprZatr, sprPers, sprCat;
var oWorkType, oLsKlassn, oZatr;
var oAvto = extPar.oAvto;
var obj = extPar.obj;

var sDir = rootDirectory() + "../modules/avto/scripts/docs/com.debet.traktor/ROW/";
var isKlassn = (isEmpty(getPar(const_AVTO_LIC_KLASSN)) ? false :true);
var codLsKlassn = getPar(const_AVTO_LIC_KLASSN);

var clasDopl = "DOPL";
var tblDopl = extPar.tblDopl;
var tmpTblDopl = getTmpTableName();
var clasHelp = "HELP";
var tblHelp = extPar.tblHelp;
var tmpTblHelp = getTmpTableName();

var useShpz = obj.parent.getPar("_use_spr_shpz");

function Load()
{
	Caption(ru("Строки наряда","Рядки наряду"),extPar.mode);
	sprWorkType = getPar(const_GETPAR_WORKTYPE);
	sprUser = (extPar.mode=="ADD" ? obj.parent.getPar("_codconsumer") : obj.getVar("RUSER_CL"));
	sprZatr = getPar(const_GETPAR_ZATR);
	sprPers = getPar("CODPERS");
	sprCat = getPar(const_GETPAR_CATEGORY);
	
	//проверим есть ли такой код ЛС который указан в настроке класности
	if(isKlassn)
	{
		strSQL = "SELECT FID" 
					+" FROM ^LIC_FLD"
					+" WHERE 1=1"
						+" AND FID = "+sqlTo(codLsKlassn)
		var sn = getSnap(strSQL);
		if(sn)
		{
			codLsKlassn = sn[0];
		}
		else
		{
			alert(ru("Указанный код для классности не найден в справочнике ЛС, "+codLsKlassn
					, "Вказаний код для класності не знайдений в довіднику ОР, "+codLsKlassn));
			isKlassn = false;
		}
	}
	
	oWorkType = new DpCl("", sprWorkType, 0);
	oWorkType.linkSmartCtrl(FWORKTYPE);
	//oWorkType.listCond = listCondWorkType;
	
	if (!useShpz)
	{
		oZatr = new DpCl("0", sprZatr, 0);
		oZatr.linkSmartCtrl(FGALUZ);
	}
	else
	{
		dpShifPZ = new DpShifPZ();
		dpShifPZ.linkCtrl(FGALUZ);
	}

	oCat = new DpCl("", sprCat, 0);
	
	//поле ЛС для класности
	oLsKlassn = new DpLicf("Z");
	oLsKlassn.linkCtrl(FLSFIDKLASSN, FTLSFIDKLASSN);
	oLsKlassn.setFid(codLsKlassn);
	//----
	
	oUser = new DpCl("", sprUser, 0);
	if (sprUser == 0)
	{
		oUser.setMode("0");
	}
	oUser.linkSmartCtrl(FUSER);
	
	Enable(FKOLF, false);
	Disable(FKOLVYD);
	
	Disable(FNORMV);
	Disable(FNORMP);
	Disable(FKOL_ETGA);
	Disable(FSM_NORM);
	
	//ЗП
	Disable(FRASC);
	Disable(FBASESUM);
	Disable(FSUMDOPL);
	Disable(FKLSUM);
	Disable(FKLCTS);
	Disable(FLSFIDKLASSN);
	if(!isKlassn)
	{
		ZAKLASSN.setVisible(false);
	}
	
	Disable(FSUM);
	
	ctrlLinker = new DpCtrlLinker(obj);
			
	if (extPar.mode == "ADD")
	{
		obj.setVar("RBDATE", new Date());
		obj.setVar("REDATE", new Date());
		
		FBDATE.setValue(new Date().getVarDate())
		FEDATE.setValue(new Date().getVarDate())
		FBTIME.setTime(8.00);
		FETIME.setTime(17.00);
		if(useShpz)
		{
			dpShifPZ.setFshpz("");
		}
	}
	else 	if ((extPar.mode == "EDIT" || extPar.mode == "COPY") && useShpz)
	{
		dpShifPZ.setFshpz(obj.getVar("RSHPZ"));
	}

	ctrlLinker.addClLink("RUSER", oUser);

	ctrlLinker.addLink("RNOM",FNOM_STR);
	ctrlLinker.addLink("RKOL_GA", FKOL_GA);
	ctrlLinker.addLink("RKOL_ZGA", FKOL_ZGA);
	ctrlLinker.addLink("RBVIR", FBVIR);
	ctrlLinker.addLink("RKOL_ETGA", FKOL_ETGA);
	ctrlLinker.addLink("RSM_NORM", FSM_NORM);
	ctrlLinker.addLink("RNORMV", FNORMV);
	ctrlLinker.addLink("RNORMP", FNORMP);
	
	ctrlLinker.addDateTimeLink("RBDATE",FBDATE,FBTIME);
	ctrlLinker.addDateTimeLink("REDATE",FEDATE,FETIME);
	
	ctrlLinker.addLink("RDDV", FDDV);
	ctrlLinker.addLink("RCDV", FCDV);
	ctrlLinker.addLink("RMDV", FMDV);
	
	ctrlLinker.addLink("RKOLF", FKOLF);
	ctrlLinker.addLink("RKOLVYD", FKOLVYD);
	ctrlLinker.addLink("RPROCDOP", FPROCDOP);
	ctrlLinker.addLink("RKOLVYDDOP", FKOLVYDDOP);
	ctrlLinker.addClLink("RWORKTYPE", oWorkType);
	
	//ЗП
	ctrlLinker.addLink("RVOPL", FVOPL);
	if(!useShpz)
	{
		ctrlLinker.addClLink("RGALUZ", oZatr);
	}
	ctrlLinker.addLink("RBASESUM", FBASESUM);
	ctrlLinker.addLink("RSUMDOPL", FSUMDOPL);
	
	ctrlLinker.addLink("RRASC", FRASC);
	
	ctrlLinker.addLink("RKLPROC", FKLPROC);
	ctrlLinker.addLink("RKLSUM", FKLSUM);
	ctrlLinker.addLink("RKLCTS", FKLCTS);
	ctrlLinker.addLink("RSUM", FSUM);
	//----
	
	ctrlLinker.updateData(false);
	setMasks();
	
	loadGrid(clasDopl);
	loadGrid(clasHelp);
	
	//при содзании строки возьмем классность у водителя 
	if(isKlassn && extPar.mode == "ADD")
	{
		FKLPROC.setValue(xcl(sprPers, extPar.oPers.getCod(), "PRKL"));
	}
	
	FWORKTYPE_Valid();
	
	setValid(FWORKTYPE	, FWORKTYPE_Valid);
	setValid(FBVIR	, FBVIR_Valid);
	setValid(FKOL_GA	, FKOL_GA_Valid);
		
	setValid(FPROCDOP		, FPROCDOP_Valid);
	setValid(FKOLVYDDOP	, FKOLVYDDOP_Valid);
	
	setValid(FBDATE, Ftime_Valid);
	setValid(FBTIME, Ftime_Valid);
	setValid(FEDATE, Ftime_Valid);
	setValid(FETIME, Ftime_Valid);	
	setValid(FDDV, calcZP);	
	setValid(FCDV, calcZP);	
	setValid(FMDV, calcZP);	
	
	//ЗП
	setValid(FVOPL , calcZP);
	setValid(FKLPROC , calcZP);

	if(useShpz)
	{
		setValid(FGALUZ, FGALUZ_Valid);
	}

	FBVIR_Valid();
	calcWork();
	calcZP();
}

function listCondWorkType()
{
	var strSQL = "FCOD IN("
								+"SELECT W.FCOD"
									+" FROM (^CL_AVTO_WORK W LEFT JOIN ^CL_AVTO A ON W.FWID_CL = A.FWID_CL)"
												+" LEFT JOIN ^CLRELCLCL REL ON A.FWID_CL = REL.FWID_CL"
									+" WHERE 1=1"
										+" AND REL.FCL = "+sqlTo(getPar("AVTOTRANSPORT"))
										+" AND REL.FCOD = "+sqlTo(oAvto.getVar("FAVTO"))
									+")";
	return strSQL;
}

function Ftime_Valid()
{
	if (isSaving())
	{
		return true;
	}
	
	var date = new Date();
	date.setDate(toScriptDate(FBDATE.value).getDate());
	date.setMonth(toScriptDate(FBDATE.value).getMonth());
	date.setFullYear(toScriptDate(FBDATE.value).getFullYear());
	date.setHours(FBTIME.getHours());
	date.setMinutes(FBTIME.getMinutes());
	var date2 = new Date();
	date2.setDate(toScriptDate(FEDATE.value).getDate());
	date2.setMonth(toScriptDate(FEDATE.value).getMonth());
	date2.setFullYear(toScriptDate(FEDATE.value).getFullYear());
	date2.setHours(FETIME.getHours());
	date2.setMinutes(FETIME.getMinutes());

	var diff = day_differencemin(date, date2);
	// shift 1 day
	var diff_min = diff % 60;
	var diff_hours = ((diff - diff_min) / 60) % 24;
	var diff_days = Math.round(diff / (60 * 24) - 0.5);
	
	FDATDIFF.text = diff_days + " д. " +
		diff_hours + " ч. " + 
		diff_min + " мин. ";
	
	FDDV.setValue(diff_days);
	FCDV.setValue(diff_hours);
	FMDV.setValue(diff_min);
	
	return true;
}

function FWORKTYPE_Valid()
{
	if (Number(oWorkType.get("FWORK")) != AVTO_WORKTYPE_TRACTOR)
	{
		FWORKTYPE.showErr(ru("Для этого типа док. вид работы должен быть \"С/Х машина, трактор\"", "Для даного типу док. вид роботи повинен бути \"С\Г машина, трактор\""));
		return false;
	}
	
	//установим код вида работ  
	oAvto.setVar("FCODWORKTYPE", oWorkType.cod);
	
	//получим у oAvto норму выработки и топлива
	FNORMV.setValue(oAvto.getParamWorkType("NORMVYR"));
	FNORMP.setValue(oAvto.getParamWorkType("NORMFUEL"));
	
	//расценка
	switch (oWorkType.get("FQUOTTYPE"))
	{
		case AVTO_QUOTTYPE_QUOT:
			mFcts = oWorkType.get("FQUOT");
			break;
		case AVTO_QUOTTYPE_CAT:
			oCat.setCod(oWorkType.get("FCATEGORY"));
			mFcts = getRascRazr(oCat.getCod(), extPar.doc_dat);
			break;
	}
	
	//FRASC.setValue(oAvto.getParamWorkType("RASC"));
	FRASC.setValue(mFcts);
	
	calcWork();
	calcZP();
	return true;
}
function FKOL_GA_Valid()
{
	if (FBVIR.checked == false)
	{
		FKOL_ZGA.value = FKOL_GA.value;
	}
	
	calcWork();
	calcZP();
	return true;
}

function FBVIR_Valid()
{
	if (FBVIR.checked == false)
	{
		Disable(FKOL_ZGA);
		FKOL_ZGA.value = FKOL_GA.value;
	}
	else
	{
		Enable(FKOL_ZGA);	
	}
	return true;
}

function setMasks()
{
	FKOL_GA.mask = MASK_KOL;
	FKOL_ZGA.mask = MASK_KOL;
	FSM_NORM.mask = "#####.#####";
	FKOL_ETGA.mask = MASK_KOL;
	
	FNOM_STR.mask = "#####";
	FDDV.mask = "#####";
	FMDV.mask = "#####";
	FCDV.mask = "#####";
	FKOLF.mask = MASK_KOL;
	FPROCDOP.mask = "#####.##";
	FKOLVYDDOP.mask = MASK_KOL;
	FKOLVYD.mask = MASK_KOL;
	
	FNORMV.mask	=	MASK_KOL;
	FNORMP.mask	=	MASK_KOL;
	
	//ЗП
	FRASC.mask = "#####.##";
	FBASESUM.mask = MASK_SUM;
	FSUMDOPL.mask = MASK_SUM;
	
	FKLPROC.mask = "###.##";
	FKLSUM.mask = MASK_SUM;
	FKLCTS.mask = "#####.##";
		
	FSUM.mask = MASK_SUM;
}

function loadGrid(clas)
{
	var tmpTbl;
	var workTbl;
	var gridName;
	var sMode = extPar.mode;
	
	switch(clas)
	{
		case clasDopl:
			tmpTbl = tmpTblDopl;
			workTbl = tblDopl;
			gridName = "GRIDDOPL";
			if(!IsTable(workTbl))
			{
				CreateTable(workTbl, "ROWS_DOPL", "*");
			}
			break;
		case clasHelp:
			tmpTbl = tmpTblHelp;
			workTbl = tblHelp;
			gridName = "GRIDHELPER";
			if(!IsTable(workTbl))
			{
				CreateTable(workTbl, "ROWS_HELP", "*");
			}
			break;
	}
	var xmlFile = gridName+".xml";
	
	var sSQL = "SELECT *"
				+" INTO " + tmpTbl
				+" FROM ^"+ workTbl;
	switch (sMode)
	{
		case "ADD":
			sWhere = " WHERE 1<>1 ";
			break;
		case "COPY":
			sWhere = " WHERE FID_DOC="+ sqlTo(obj.nOldID);
			break;
		case "EDIT":
		default:
			sWhere = " WHERE FID_DOC="+ sqlTo(obj.getID());
			break;
	}
	sSQL +=sWhere;
	ExecuteSQL(sSQL);
	
	var gridTbl = OpenTable("m", tmpTbl);
	switch(clas)
	{
		case clasDopl:
			gridTbl.tie("LIC_FLD","LS","FID", "FLSFID");
			break;
		case clasHelp:
			gridTbl.clTie("TABN", "="+sqlTo(getPar("CODPERS"))+", FTABN");
			break;
	}
	
	//парметры загрузки грида
	eval(gridName+".setXMLDir(sDir)");
	eval(gridName+".setXMLFile(xmlFile)");
	eval(gridName+".setTable(gridTbl)");
	eval(gridName+".build()");
	eval(gridName+".setData(clas)");
	
	//меню грида
	eval(gridName+".loadMenuHandler(this,'gridMenuInit')");
	eval(gridName+".selectMenuHandler(this,'gridMenuRun')");
	
	//var oGridEdit = new DpGridEdit(eval(gridName));
	//oGridEdit.canEdit = canEditRecord;
	return true;
}

function gridMenuInit(grid)
{
	grid.AddMenuItem("ADD","Додати|Добавить");
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT","Редагувати|Редактировать");
		grid.AddMenuItem("COPY","Копіювати|Копировать");
		grid.AddMenuItem("DEL","Видалити|Удалить");
	}
}

function gridMenuRun(sID, grid)
{
	var tbl = grid.getTable();
	var tName = tbl.getTableName();
	var rowID = tbl.getValue("FWID");
	var clas = String(grid.getData());
			
	switch(sID)
	{
		case "DEL":
			var msg = ru("Подтвердите удаление записи.", "Підтвердіть вилучення запису.");
			var ret = msgBox("^c-", msg, ru("Подтверждение удаления","Підтвердження вилучення"));
			switch(ret)
			{
				case 'c':
					break;
				case '-':
					var rowID = Number(grid.getTable().getRowID());
					obj.deleteRow(clas, rowID);
					grid.getTable().Delete();
					grid.getTable().requery();
					grid.refresh();
					if(clas == clasDopl)
					{
						calcZP();
					}
				break;
			}
			break;

		case "__XDEL":
			var delRowCount = grid.getSelectedCount();
	
			if (delRowCount <= 0)
			{
				return;
			}
			
			var selIds = grid.getSelectedIDs();
			var sCapt = ru("Удаление записей", "Видалення записів");
			var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів")+" (" + delRowCount + ").";
			if("c"==msgBox("c-", sMsg, sCapt))
			{
				return;
			}
			
			setProgressRange(0, delRowCount);
			for (var nRow = 0; nRow < selIds.length; nRow++)
			{
				setProgressPos(nRow + 1, sCapt +": "+ (nRow + 1) +"/"+ delRowCount);
				obj.deleteRow(clas, Number(selIds[nRow]));
			}
			
			strSQL = " DELETE FROM " + grid.getTable().getTableName()
					+" WHERE " + grid.sqlSelected()
			ExecuteSQL(strSQL);

			grid.getTable().requery();
			grid.clearSelected();
			grid.refresh();
			setProgressPos(0);
			if(clas == clasDopl)
			{
				calcZP();
			}
			break;

		case "ADD":
		case "EDIT":
		case "COPY":
			var oRow;
			if(sID == "ADD")
			{
				oRow = obj.createRow(clas);
				var oSnap = getSnap("SELECT MAX(FNOM_STR) AS NOM FROM " + tName);
				var nNom = 1;
				if (oSnap && oSnap[0])
					nNom = Number(oSnap[0]) + 1;
				oRow.setVar("RNOM",nNom)
			}
			else if(sID == "EDIT")
					oRow = obj.getRow(clas, rowID);
			else if(sID == "COPY")
				oRow = obj.copyRow(clas, rowID);
				var oSnap = getSnap("SELECT MAX(FNOM_STR) AS NOM FROM " + tName);
				var nNom = 1;
				if (oSnap && oSnap[0])
					nNom = Number(oSnap[0]) + 1;
				oRow.setVar("RNOM",nNom)
			if(!oRow)
				break;
			if (!rowEdit(sID, clas, oRow))
				break;
			tbl.requery();
			grid.refresh();
			break;
	}
	return true;
}

function rowEdit(sMode, clas, oRow)
{
	var par = new Object();
	par.doc_dat = extPar.doc_dat;
	var tmpTbl;
	switch (clas)
	{
		case clasDopl:
			tmpTbl = tmpTblDopl;
			break;
		case clasHelp:
			tmpTbl = tmpTblHelp;
			break;
		default:
	}
		
	par.dpObj = oRow;
	par.mode = sMode;
	par.tblName = tmpTbl;
	par.formFile = sDir + clas + "/form.xml";
	par.dpObj.hasExt = new function(){return false};
	par.obj = obj;
	par.isKlassn = isKlassn;
	par.rasc = Number(FRASC.getValue());
	par.kolGa = Number(FKOL_GA.getValue());
	par.ddv = Number(FDDV.getValue());
	par.cdv = Number(FCDV.getValue());
	par.mFzp = Number(FBASESUM.getValue());
	if (!useShpz)
	{
		par.galuz = oZatr.getCod();
	}
	else
	{
		par.galuz = dpShifPZ.getFshpz();
	}
	
	par.bsum = Number(FBASESUM.getValue());
	//что брать для расчета при ЧТС (дни, часы)
	//параметр из настройки папки 
	par.time = obj.parent.getPar("_gts_pom");

	//SAM 19.04.2012 - при сетевом подключении не работает - временно, но работоспособно
	//showWindow(par.formFile, "XMLDLG", par);
	showWindow("../modules/avto/scripts/docs/" + obj.parent.sDocLbl.substr(5)+ "/ROW/" + clas + "/form.xml", "XMLDLG", par);	
		
	if(par.escape)
		return false; 
	
	var id = oRow.getID();
	
	if(inList(sMode, "ADD", "COPY"))
		obj.appendRow(clas, oRow); 
		
	obj2DB(id, oRow.jDocRow, null, tmpTbl);
	if(clas == clasDopl)
	{
		calcZP();
	}
	return true;
}

function calcWork()
{
	var okr = getPar(const_GETPAR_SN_NORM_ROUND);
	var mFsm_norm	= 0;
	var mFkol_etga	= 0;
	var mFework	= 0;
	var mFnormFuel = 0;

	var mFnorma	= Number(FNORMV.getValue());
	if (!isEmpty(mFnorma))
	{
		// кол-во выполненных сменных норм
		mFsm_norm = round(FKOL_GA.getValue() / mFnorma, okr);
			
		// эталонная выработка
		mFet_vir	= oAvto.getVar("FET_VIR");
		
		// Кол-во эталонных гектаров
		mFkol_etga	= round(mFsm_norm * mFet_vir, 2);
	}
	mFnormFuel = FNORMP.getValue() * FKOL_GA.getValue();
		
	FSM_NORM.setValue(mFsm_norm);
	FKOL_ETGA.setValue(mFkol_etga);
	FKOLF.setValue(mFnormFuel);
	FKOLVYD.setValue(Number(FKOLF.getValue())+Number(FKOLVYDDOP.getValue()))
	return true;
}

function calcZP()
{
	var mFbaseSum = 0;
	var mFsum = 0;
	var mFklSum = 0;
	var mFrasc = Number(FRASC.getValue());
	var mFnormv = Number(FNORMV.getValue());
	var mFsumDopl = 0;
	var mFkol_ga = (FBVIR.checked != true ? Number(FKOL_GA.getValue()) : Number(FKOL_ZGA.getValue()));
	var mFtime = 0;
	var mFklcts = 0;
	switch (oWorkType.get("FQUOTTYPE"))
	{
		case AVTO_QUOTTYPE_QUOT:
			mFklcts = oWorkType.get("FQUOT");
			break;
		case AVTO_QUOTTYPE_CAT:
			oCat.setCod(oWorkType.get("FCATEGORY"));
			mFklcts = getRascRazr(oCat.getCod(), extPar.doc_dat);
			break;
	}
		
	//какое время учитывать берем из настройки папки. 
	//0 - часы
	//1 - дни
	//если у нас DTS, всегда берем дни, если же GTS, смотрим на параметр папки
	if(obj.parent.getPar("_gts") == 1 || String(FVOPL.getValue()) == "DTS")
	{
		mFtime = Number(FDDV.getValue());
	}
	else
	{
		mFtime = (Number(FCDV.getValue()) * 60 + Number(FMDV.getValue()))/60;
	}
	
	switch (String(FVOPL.getValue()))
	{
		case "GTS":
		case "DTS":
			mFbaseSum = round(mFrasc * mFtime, 2);
			break;
		
		case "VDR":
		default:
			var mFtypeRasc = oWorkType.get("FTYPERASC");
			mFbaseSum = round(mFrasc * (mFtypeRasc == AVTO_TYPERASC_ED ? mFkol_ga : (mFkol_ga/mFnormv)), 2);
			break;
	}

	//если в настройке указано поле ЛС для классности то считаем сумму  доплаты за класность
	if(isKlassn && !isEmpty(FKLPROC.getValue()))
	{
		var addSum = 0;
		strSQL = "SELECT SUM(FSUM)" 
				+" FROM "+tmpTblDopl
				+" WHERE 1=1"
					+" AND FID_DOC = "+sqlTo(obj.getID())
					+" AND FISKLASSN = "+sqlTo(true)
		var sn = getSnap(strSQL);
		if(sn)
		{
			//суммы доплат которые входят в расчет сумы классности
			addSum = isEmpty(sn[0]) ? 0 : round(sn[0], 2);
		}
		
		mFklSum = round(((mFtime* mFklcts) + addSum) * Number(FKLPROC.getValue()) / 100, 2);
	}
		
	//сумы доплат 
	strSQL = "SELECT SUM(FSUM)" 
				+" FROM "+tmpTblDopl
				+" WHERE 1=1"
					+" AND FID_DOC = "+sqlTo(obj.getID())
	var sn = getSnap(strSQL);
	
	if(sn)
	{
		mFsumDopl = isEmpty(sn[0]) ? 0 : round(sn[0], 2);
	}
	
	//сумма итого
	mFsum = round(mFbaseSum +mFklSum + mFsumDopl, 2);
	
	FSUMDOPL.setValue(mFsumDopl);
	FBASESUM.setValue(mFbaseSum);
	FKLSUM.setValue(mFklSum);
	FSUM.setValue(mFsum);
	FKLCTS.setValue(mFklcts);
	return true;
}

function FPROCDOP_Valid()
{
	var koef  = FPROCDOP.getValue()/100;
	if(!isEmpty(koef))
	{
		FKOLVYDDOP.setValue(FKOLF.getValue() * koef);
		calcWork();
	}
	return true;
}

function FKOLVYDDOP_Valid()
{
	if(!isEmpty(FPROCDOP.getValue()))
	{
		FPROCDOP_Valid()
	}
	
	calcWork();
	return true;
}

function onSave()
{
	ctrlLinker.updateData(true);
	obj.setVar("RTYPE", AVTO_WAYBILL_TYPE_FACT);
	obj.setVar("RUSER_CL", sprUser);
	obj.setVar("RLSFIDKLASSN", oLsKlassn.getFid());
	
	//при сохранении нужно узнать код ШПЗ и записать в таблицу 
	//для этого используем объект DpShifPZ
	var par = {};
		par.clPodr = sprUser;
		par.clGaluz = sprZatr;
		par.clZatr = 3; 		//статьи затрат
		par.clAvto = getPar(const_AVTOTRANSPORT);
		par.codAvto = oAvto.getVar("FAVTO");
	
	if(!useShpz)
	{	
		var oShpz = new DpShifPZ("",par);
		oShpz.setObj(oZatr);
		oShpz.setObj(oUser);
		obj.setVar("RSHPZ", oShpz.save());
	}
	else
	{
		obj.setVar("RSHPZ", dpShifPZ.getFshpz());
	}

	saveRows(clasDopl);
	saveRows(clasHelp);
}

//сохрарение строк для доплат и помощников
function saveRows(clas)
{
	var tmpTbl;
	var workTbl;
	var ID = obj.getID();
	
	switch (clas)
	{
		case clasDopl:
			tmpTbl = tmpTblDopl;
			workTbl = tblDopl;
			break;
		case clasHelp:
			tmpTbl = tmpTblHelp;
			workTbl = tblHelp;
			break;
	}
	
	ExecuteSQL("DELETE FROM "+ workTbl +" WHERE FID_DOC = " + sqlTo(ID));
	ExecuteSQL("UPDATE " + tmpTbl + " SET FID_DOC=" + sqlTo(ID));
	ExecuteSQL("INSERT INTO "+ workTbl + " SELECT * FROM " + tmpTbl);
	return true;
}

function FGALUZ_Valid()
{
	if (isEmpty(dpShifPZ.getFshpz()))
	{
		FWORKTYPE.showErr(ru("Укажите ШПЗ", "Вкажіть ШВВ"));
		return false;
	}
	else
	{
		return true;
	}
	
}

include("sys\\DpBaseDlg.js");