include("objects\\DpVal.js");
include("objects\\DpSc.js");
include("sys\\mask.js");
include("avto:AVTO_const.js");	// Константы справочников
include("getParam.js");
include("objects\\DpEdi.js");

var ctrlLinker;
var sprWorkType;
var oWorkType;
var oAvto = extPar.oAvto;

function Load()
{
	Caption(ru("Строки планирования наряда:","Рядки планування наряду:"),extPar.mode);
	sprWorkType = getPar(const_GETPAR_WORKTYPE);
	sprUser = (extPar.mode=="ADD" ? extPar.obj.parent.getPar("_codconsumer") : extPar.obj.getVar("RUSER_CL"));

	oWorkType = new DpCl("", sprWorkType, 0);
	oWorkType.linkSmartCtrl(FWORKTYPE);
	//oWorkType.listCond = listCondWorkType;
	
	oUser = new DpCl("", sprUser, 0);
	if (sprUser == 0)
	{
		oUser.setMode("0");
	}
	oUser.linkSmartCtrl(FUSER);
	
	Enable(FKOLF, false);
	Disable(FKOLVYD);
	
	Disable(FNORMV);
	Disable(FNORMP);
	Disable(FKOL_ETGA);
	Disable(FSM_NORM);

	ctrlLinker = new DpCtrlLinker(extPar.obj);
	ctrlLinker.addDateTimeLink("RBDATE",FBDATE,FBTIME);
	ctrlLinker.addDateTimeLink("REDATE",FEDATE,FETIME);
		
	ctrlLinker.addClLink("RUSER", oUser);
	ctrlLinker.addLink("RNOM",FNOM_STR);
	ctrlLinker.addLink("RKOL_GA", FKOL_GA);
	
	
	ctrlLinker.addLink("RDDV", FDDV);
	ctrlLinker.addLink("RCDV", FCDV);
	ctrlLinker.addLink("RMDV", FMDV);
	
	ctrlLinker.addLink("RKOLF", FKOLF);
	ctrlLinker.addLink("RKOLVYD", FKOLVYD);
	ctrlLinker.addLink("RKOLVYDDOP", FKOLVYDDOP);
	ctrlLinker.addLink("RPROCDOP", FPROCDOP);
	ctrlLinker.addClLink("RWORKTYPE", oWorkType);
	ctrlLinker.updateData(false);
	setMasks();
	
	if (extPar.mode == "ADD")
	{
		extPar.obj.setVar("RBDATE", new Date());
		extPar.obj.setVar("REDATE", new Date());
		
		FBDATE.setValue(new Date().getVarDate())
		FEDATE.setValue(new Date().getVarDate())
		FBTIME.setTime(8.00);
		FETIME.setTime(17.00);
	}
	
	FWORKTYPE_Valid();
	
	setValid(FWORKTYPE	, FWORKTYPE_Valid);
	setValid(FKOL_GA	, calcAll);
		
	setValid(FPROCDOP		, FPROCDOP_Valid);
	setValid(FKOLVYDDOP	, FKOLVYDDOP_Valid);
	
	
	setValid(FBDATE, Ftime_Valid);
	setValid(FBTIME, Ftime_Valid);
	setValid(FEDATE, Ftime_Valid);
	setValid(FETIME, Ftime_Valid);	
}

function listCondWorkType()
{
	var strSQL = "FCOD IN("
								+"SELECT W.FCOD"
									+" FROM (^CL_AVTO_WORK W LEFT JOIN ^CL_AVTO A ON W.FWID_CL = A.FWID_CL)"
												+" LEFT JOIN ^CLRELCLCL REL ON A.FWID_CL = REL.FWID_CL"
									+" WHERE 1=1"
										+" AND REL.FCL = "+sqlTo(getPar("AVTOTRANSPORT"))
										+" AND REL.FCOD = "+sqlTo(oAvto.getVar("FAVTO"))
									+")";
	return strSQL;
}

function Ftime_Valid()
{
	if (isSaving())
	{
		return true;
	}
	
	var date = new Date();
	date.setDate(toScriptDate(FBDATE.value).getDate());
	date.setMonth(toScriptDate(FBDATE.value).getMonth());
	date.setFullYear(toScriptDate(FBDATE.value).getFullYear());
	date.setHours(FBTIME.getHours());
	date.setMinutes(FBTIME.getMinutes());
	var date2 = new Date();
	date2.setDate(toScriptDate(FEDATE.value).getDate());
	date2.setMonth(toScriptDate(FEDATE.value).getMonth());
	date2.setFullYear(toScriptDate(FEDATE.value).getFullYear());
	date2.setHours(FETIME.getHours());
	date2.setMinutes(FETIME.getMinutes());

	var diff = day_differencemin(date, date2);
	// shift 1 day
	var diff_min = diff % 60;
	var diff_hours = ((diff - diff_min) / 60) % 24;
	var diff_days = Math.round(diff / (60 * 24) - 0.5);
	
	FDATDIFF.text = diff_days + " д. " +
		diff_hours + " ч. " + 
		diff_min + " мин. ";
	
	FDDV.setValue(diff_days);
	FCDV.setValue(diff_hours);
	FMDV.setValue(diff_min);
	
	return true;
}

function FWORKTYPE_Valid()
{
	if (Number(oWorkType.get("FWORK")) != AVTO_WORKTYPE_TRACTOR)
	{
		FWORKTYPE.showErr(ru("Для этого типа док. вид работы должен быть \"С/Х машина, трактор\"", "Для даного типу док. вид роботи повинен бути \"С\Г машина, трактор\""));
		return false;
	}
	
	//установим код вида работ  
	oAvto.setVar("FCODWORKTYPE", oWorkType.cod);
	
	//получим у oAvto норму выработки и топлива
	FNORMV.setValue(oAvto.getParamWorkType("NORMVYR"));
	FNORMP.setValue(oAvto.getParamWorkType("NORMFUEL"));
	
	calcAll();
	return true;
}

function setMasks()
{
	FKOL_GA.mask = MASK_KOL;
	FSM_NORM.mask = "#####.#####";
	FKOL_ETGA.mask = MASK_KOL;
	
	FNOM_STR.mask = "#####";
	FDDV.mask = "#####";
	FMDV.mask = "#####";
	FCDV.mask = "#####";
	FKOLF.mask = MASK_KOL;
	FPROCDOP.mask = "#####.##";
	FKOLVYDDOP.mask = MASK_KOL;
	FKOLVYD.mask = MASK_KOL;
	
	FNORMV.mask	=	MASK_KOL;
	FNORMP.mask	=	MASK_KOL;
}

function calcAll()
{
	var okr = getPar(const_GETPAR_SN_NORM_ROUND);
	var mFsm_norm	= 0;
	var mFkol_etga	= 0;
	var mFework	= 0;
	var mFnormFuel = 0;

	var mFnorma	= FNORMV.getValue();
	if (!isEmpty(mFnorma))
	{
		// кол-во выполненных сменных норм
		mFsm_norm = round(FKOL_GA.getValue() / mFnorma, okr);
				
		// эталонная выработка
		mFet_vir		= oAvto.getVar("FET_VIR");
		
		// Кол-во эталонных гектаров
		mFkol_etga	= round(mFsm_norm * mFet_vir, 2);
	}
	mFnormFuel = FNORMP.getValue() * FKOL_GA.getValue();
		
	FSM_NORM.setValue(mFsm_norm);
	FKOL_ETGA.setValue(mFkol_etga);
	FKOLF.setValue(mFnormFuel);
	FKOLVYD.setValue(Number(FKOLF.getValue())+Number(FKOLVYDDOP.getValue()))
	return true;
}

function FPROCDOP_Valid()
{
	var koef  = FPROCDOP.getValue()/100;
	if(!isEmpty(koef))
	{
		FKOLVYDDOP.setValue(FKOLF.getValue() * koef);
		calcAll();
	}
	return true;
}

function FKOLVYDDOP_Valid()
{
	if(!isEmpty(FPROCDOP.getValue()))
	{
		FPROCDOP_Valid()
	}
	
	calcAll();
	return true;
}

function onSave()
{
	ctrlLinker.updateData(true);
	extPar.obj.setVar("RTYPE", AVTO_WAYBILL_TYPE_TASK);
	extPar.obj.setVar("RUSER_CL", sprUser);
}
include("sys\\DpBaseDlg.js");