include("doc/DpDoc.js");
include("objects/DpCl.js");		// для таб.номера
include("objects/DpShtat.js");
include("sys/mask.js");
include("sys/udfs.js");
include("objects/DpClcl.js");
include("avto:servis/avto_tools.js");
include("avto:AVTO_const.js");
include("avto:objects/DpAvto.js");
include("gridedit.js");

var Validation = true;
var strFwid;
var strMode;
var bReady=false;
var oPers;		//объект - справочник персонала
var Hs;
var Hob;
//var bDist = 0;
var gsm_tbl_name; // имя для временной таблицы для грида с израсходованными ГСМ
var bOneFuelType = true;
var bCreateGrid = true;
var oSc, objPodr, objMol, objAvtom, objDoc, oAvto;
var sTmpTbl = "TMP_RWORKORDER_FACT";
var clasAct = "ROW";
var sTmpTblTask = "TMP_RWORKORDER_TASK";
var clasTask = "ROWTASK";
var sTmpTblFuel = "TMP_RFUEL";
var sprAvto, sprWorkType, sprFuelType, sprAvtopark, sprUser, sprPers;
var oldAvtoCod;

//таблицы доплат 
var tmpTblDopl = getTmpTableName();
var tblDopl = "ROWS_DOPL";

//таблицы помощников 
var tmpTblHelp = getTmpTableName();
var tblHelp = "ROWS_HELP";

//параметры папки
var _pers_zaval = extPar.doc.getPar("_pers_zaval");
var sprPers = extPar.doc.getPar("_codpers");
var sprUser = extPar.doc.getPar("_codconsumer");

function Load()
{
	CreateTable(sTmpTblFuel,"RFUEL","FWID");

	Caption(ru("Наряд на польову роботу", "Наряд на полевую работу") + ": " + modeName(extPar.mode));
	strFwid = extPar.fwid;
	strMode = extPar.mode;
	strMode.toUpperCase();

	oAvto = new DpAvto("");

	sprAvtopark = Number(getPar(const_GETPAR_KOLON));
	sprAvto = getPar("AVTOTRANSPORT");
	sprWorkType = getPar(const_GETPAR_WORKTYPE);
	sprFuelType = getPar(const_GETPAR_FUELTYPE);
	
	bReady=true;
	ctrlLinker = new DpCtrlLinker(extPar.doc);

	// водитель (какой объект смотрим в настр. папки)
	switch (_pers_zaval)
	{	
		case 0:
			oPers = new DpShtat("");
			if(inList(strMode, "COPY", "EDIT"))
			{
				oPers.setPeriod(extPar.doc.getVar("HDAT"), extPar.doc.getVar("HDAT"));
			}
			else
			{
				oPers.setPeriod(new Date(), new Date());
			}
			oPers.zavalInAllShtat = true;
			oPers.linkCtrl("fcod", Fshtat);
			PERS.setVisible(false);
			break;
		
		case 1:
			oPers = new DpCl("", sprPers, 0);
			oPers.linkSmartCtrl(Fdriver);
			oPers.setContAssist();
			SHTAT.setVisible(false);
			break;
		default: 
			alert(ru("Этот режим справочника персонала не предусмотрен!"
					, "Цей режим довідника персоналу не передбачено!"));
	}
	ctrlLinker.addClLink("HDRIVER", oPers);
	
	oAvtopark = new DpCl("", sprAvtopark, 0);
	oAvtopark.linkSmartCtrl(Favtopark);
	ctrlLinker.addClLink("HPODR",oAvtopark);

	oSc = new DpSc();	
	oSc.setMode("c0utxyz");	//c0utxyz456
	oSc.linkCtrl(FSC, FSU, FST, CL1, CL2, CL3);	
	ctrlLinker.addScLink("HPZ_SC","HPZ_SU","HPZ_ST","HPZ_CL1","HPZ_CL2","HPZ_CL3",oSc);
		
	objPodr = new DpCl();
   	objPodr.linkCtrl(FPODR,FPODR_TXT);
	objPodr.setClcl(sprPodr);
	ctrlLinker.addClLink("HPZ_PODR",objPodr);
	
	objMol = new DpCl();
   	objMol.linkCtrl(FMOL,FMOL_TXT);
	objMol.setClcl(sprMol);
	ctrlLinker.addClLink("HPZ_MOL",objMol);

	objAvto = new DpCl();
   	objAvto.linkSmartCtrl(Favto);
	objAvto.setClcl(sprAvto);
	ctrlLinker.addClLink("HAVTO",objAvto);
	ctrlLinker.addLink("HNUM",HNOM);
	ctrlLinker.addLink("HDAT",Fdoc_dat);
	ctrlLinker.addLink("HDOC_SER",FDOC_SER);
	ctrlLinker.addLink("HSMENA",FSMENA);
	ctrlLinker.addDateTimeLink("HBDATE",Fbdate,Fbtime);
	ctrlLinker.addDateTimeLink("HEDATE",Fedate,Fetime);
	ctrlLinker.addLink("HBDISTANCE",FBDISTANCE);
	ctrlLinker.addLink("HEDISTANCE",FEDISTANCE);
	ctrlLinker.addLink("HCALC_KSUM",ksum);
	ctrlLinker.addLink("HCALC_KOB",kob);
	ctrlLinker.addLink("HCALC_KOIL",koil);
	ctrlLinker.addLink("HPZ_NUM",PZ_NUM);
	
   	ctrlLinker.updateData(false);
	
	//если используем штатное то сами устанавливаем текстовку и дизейблим поле 
	if(oPers instanceof DpShtat == true)
	{
		Disable(Fdriver_txt);
		Fdriver_txt.setValue(oPers.getEmployeSurname());
	}
	
	oldAvtoCod = objAvto.getCod();
	tbl_name = getTmpTableName();

	PZ_NUM.setMask(MASK_DOCNUM);
	HNOM.setMask(MASK_DOCNUM);
	
	FEDISTANCE.mask = "##########.##";
	FBDISTANCE.mask = "##########.##";
	ksum.setMask("-#####.#####");
	koil.setMask("-#####.#####");
	kob.setMask("-#####.#####");
	FSMENA.setMask("###");
	
	//----загрузка значений
	Disable(calc_value);
	Disable(PZ_DATE);
	if (strMode == "ADD")
	{
		koil.value = 100;
		//HNOM.setValue("");
	}

	if (strMode=="EDIT" || strMode=="COPY")
	{
		oPers.setCod(extPar.doc.getVar("HDRIVER"));
  		objPodr.setCod(extPar.doc.getVar("HPZ_PODR"));  
   		objMol.setCod(extPar.doc.getVar("HPZ_MOL"));
		oSc.set(extPar.doc.getVar("HPZ_SC"),
   				extPar.doc.getVar("HPZ_SU"),
   				extPar.doc.getVar("HPZ_ST"),
				extPar.doc.getVar("HPZ_CL1"),
   				extPar.doc.getVar("HPZ_CL2"),
   				extPar.doc.getVar("HPZ_CL3"));

   		objAvto.setCod(extPar.doc.getVar("HAVTO"));
				
		if(searchPZ())
		{
			var sTxt = create_doc.getText() +UR(" (УЖЕ СТВОРЕНИЙ)| (УЖЕ СОЗДАН)");
			create_doc.setText(sTxt);
		}
	}
	else
	{
		// при добавлении параметры берем с значений по умолчанию в папке документов 
		if (getPar("AVTO_PZ_NOP","AVTO") != 0)
		{
			objDoc = new DpDoc("PZ", getPar("AVTO_PZ_NOP","AVTO"));
  			objPodr.setCod(objDoc.getVar("HPODR"));   		
   			objMol.setCod(objDoc.getVar("HMOL"));	
			oSc.set(objDoc.getVar("HSC"),
   					objDoc.getVar("HSU"),
   					objDoc.getVar("HST"),
					objDoc.getVar("HA1"),
   					objDoc.getVar("HA2"),
   					objDoc.getVar("HA3"));
		}
	}
	Fdoc_dat_Valid();		
	
	setValid(Favto, Favto_Valid);
	setValid(Fedate, Fwork_Valid);
	setValid(Fetime, Fwork_Valid);
	setValid(koil, updNorm);
	setValid(Fdoc_dat, Fdoc_dat_Valid);
	
	switch (_pers_zaval)
	{	
		case 0:
			setValid(Fshtat, Fdriver_Valid);
		break;
		default:
			setValid(Fdriver, Fdriver_Valid);
		break;
	}
		
	// calc
	setButton(calc, OnCalculate);
	setButton(refresh_grid, updNorm);
	setButton(create_doc, OnCreateDoc);

	
	CreateTable(tmpTblDopl, tblDopl,"*");
	CreateTable(tmpTblHelp, tblHelp,"*");
	
	loadGrid(clasTask);
	loadGrid(clasAct);
	
	dpGridEdit = new DpGridEdit(gridFuel);
	loadGridFuel();
	dpGridEdit.init = addRecord;
	dpGridEdit.canEdit = canEditRecord;

	this.listMenuInitFuel = listMenuInitFuel;
	this.onSelectRowMenuFuel = onSelectRowMenuFuel;
	gridFuel.loadMenuHandler(this,"listMenuInitFuel");
	gridFuel.selectMenuHandler(this,"onSelectRowMenuFuel");

	//dpGridEdit.addValidField("FEFUEL", startEdit_fefuel, endEdit_fefuel);
	dpGridEdit.addValidField("FFUEL_DESK", startEdit_fefuel, endEdit_fefuel);

	if (strMode != "ADD")
		Favto_Valid();
	if (strMode=="COPY")
	{
		var mFid = extPar.doc.getID();
		var mOldFid = extPar.doc.nOldID;
		var sFLD = GetPatternIntersection("RFUEL", "RFUEL");
		
		strSQL = "INSERT INTO "+sTmpTblFuel+"("+sFLD+")"
			+" SELECT "+sFLD+" FROM ^RFUEL WHERE FID_DOC = " + sqlTo(mOldFid)
		ExecuteSQL(strSQL);
		ExecuteSQL("UPDATE " + sTmpTblFuel+" SET FID_DOC = " + sqlTo(mFid))
	}
	calcSalary();
	
	if (inList(strMode, "ADD", "COPY"))
	{
		getMaxSmena();
	}	
}

function getMaxSmena()
{
	strSQL = " SELECT MAX(FSMENA) "
			+" FROM ^WORKORDER "
			+" WHERE 1 = 1 "
				+" AND FDOC_DAT = "+sqlTo(Fdoc_dat.value)
	var sn = getSnap(strSQL);
	if (sn != null && sn[0] != null)
	{
		FSMENA.value = sn[0]+1;
	}
	else
	{
		FSMENA.value = 1;
	}
	sn = null;
}

function UnLoad()
{
   if(!bReady)return;
}

function saveRows()
{
	ExecuteSQL("DELETE FROM ^RWORKORDER "
		+" WHERE fid_doc=" + sqlTo(extPar.doc.getVar("ID"))
		+" AND FTYPE = "+sqlTo(AVTO_WORKORDER_TYPE_FACT));
	var sFLD = GetPatternIntersection("RWORKORDER","RWORKORDER");
	ExecuteSQL("INSERT INTO ^RWORKORDER(" + sFLD + ")"
			  + " SELECT " + sFLD + " FROM " + sTmpTbl);
	ExecuteSQL("DELETE FROM ^RWORKORDER "
		+" WHERE fid_doc=" + sqlTo(extPar.doc.getVar("ID"))
		+" AND FTYPE = "+sqlTo(AVTO_WORKORDER_TYPE_TASK));
	var sFLD = GetPatternIntersection("RWORKORDER","RWORKORDER");
	ExecuteSQL("INSERT INTO ^RWORKORDER(" + sFLD + ")"
			  + " SELECT " + sFLD + " FROM " + sTmpTblTask);
	ExecuteSQL("DELETE FROM ^RFUEL WHERE fid_doc=" + sqlTo(extPar.doc.getVar("ID")));
	var sFLD = GetPatternIntersection("RFUEL","RFUEL");
	ExecuteSQL("INSERT INTO ^RFUEL(" + sFLD + ")"
			  + " SELECT " + sFLD + " FROM " + sTmpTblFuel);
}

function onSave()
{
	//Fdistance_Valid();
	ctrlLinker.updateData(true);
	
	saveRows();	
		
	//строки строк (доплаты, и помощники) 
	saveRowsActs("DOPL");
	saveRowsActs("HELP");
		
	// Обновим показание спидометра у машини
	saveDistance();
}

function saveRowsActs(clas)
{
	var workTbl	= "";
	var tmpTbl	= "";
	switch (clas)
	{
		case "DOPL":
			workTbl = tblDopl;
			tmpTbl = tmpTblDopl;
			break;
		case "HELP":
			workTbl = tblHelp;
			tmpTbl = tmpTblHelp;
			break;
	}
	
	//выберем все FWID строк 
	strSQL = "SELECT T.FWID" 
				+" FROM ^RWORKORDER T"
				+" WHERE 1=1"
					+" AND T.FID_DOC = "+sqlTo(extPar.doc.getID())
		
	//удалим из таблицы все строки по нашему наряду
	//а потом востановим с изменениями из темпа
	var sFld = GetPatternIntersection(workTbl, workTbl);
	ExecuteSQL("DELETE FROM ^"+ workTbl +" WHERE FID_DOC IN ("+strSQL+")");
	ExecuteSQL("INSERT INTO ^"+ workTbl +"("+sFld+") SELECT "+sFld+" FROM " + tmpTbl);
	return true;
}

function saveDistance()
{
	var edistance = Number(FEDISTANCE.getValue());
	if(strMode == "EDIT" && oAvto.getVar("FDISTANCE") >= edistance)
	{
		return;
	}
	
	//проверяем есть ли значение больше текущего
	var oSnap = getSnap("select FEDISTANCE, FDOC_NUM, FDOC_DAT, FDOC, FNOP, FWID "
						+" from ^WORKORDER "
						+" where FAVTO="+ objAvto.getCod()
						+" order by FEDISTANCE desc"
						);
	if(oSnap && Number(oSnap[0])>edistance)
	{
		var sMsg = UR("Знайдено шляховий лист з більшим показанням спідометра: "
						+"\n"+ oSnap[0]
						+"\n№ "+ oSnap[1] +" за "+ StrDat(oSnap[2], "DMY") 
						+"\nПерейти до знайденного листа? "
					+"|Найден путевой лист с бо'льшим показанием спидометра: "
						+"\n"+ oSnap[0]
						+"\n№ "+ oSnap[1] +" за "+ StrDat(oSnap[2], "DMY") 
						+"\nПерейти к найденному листу? "
					);
		if(confirm(sMsg))
		{
			include("doc/DpDocPtn.js");		
			FindDocument(oSnap[3], oSnap[4], oSnap[5]);
		}
		if(!confirm(UR("Зберегти поточне показання "+ edistance +"?|Сохранить текущее показание "+ edistance +"?")))
			return;
	}
	
	ExecuteSQL("UPDATE ^CL_AVTO SET Fdistance = "+ edistance
			+ " WHERE FCOD = " + sqlTo(objAvto.getCod()));
}

function calcSalary()
{
	strSQL = "SELECT SUM(FSUM) FROM "+sTmpTbl
	var sn = getSnap(strSQL);
	if (sn != null && sn[0] != null)
	{
		Fsalary_calc.text = sn[0]+" грн."
	}
	sn = null;
}

//функция сумирует пробег по строкам и устанавливает его на соответствующий контрол
//также устанавливает значения контрола показатели спидометри при приезде 
function calcRuns()
{
	var sumProb = 0;
	var edist = Number(FBDISTANCE.getValue());
	strSQL = "SELECT SUM(FPROB) FROM "+sTmpTbl
	
	var sn = getSnap(strSQL);
	if (sn != null && !isEmpty(sn[0]))
	{
		sumProb = sn[0];
		edist += sumProb;
	}
	
	FEDISTANCE.setValue(edist);
	FDISTANCE_CALC.text = sumProb+" км.";
	return true;
}

function Favto_Valid()
{
	var ret = false;
	oAvto.setVar("FAVTO", objAvto.getCod());

	if (!isEmpty(objAvto.getCod()))
	{
		AvtoFnum.text = oAvto.getVar("FNUM");
		AvtoFgarage_num.text = oAvto.getVar("FGARAGE_NUM");
		AvtoFlicense.text = oAvto.getVar("FLICENSE");
		AvtoFdistance.text = oAvto.getVar("FDISTANCE");
	
		refreshAvtoInfo();
		Fwork_Valid();
		
		if(inList(strMode, "ADD", "COPY"))
		{
			//установим показатели спидометра при отъезде
			FBDISTANCE.setValue(oAvto.getVar("FDISTANCE"));
		}
		
		if (objAvto.getCod() != oldAvtoCod)
		{
			ExecuteSQL("DELETE FROM " + sTmpTblFuel);
			makeFuelTbl();
			oldAvtoCod = objAvto.getCod();
		}
	
		//установим а объект код авто и подтянем другие переменные нашего ТС
		oAvto.setVar("FAVTO", objAvto.getCod());
		oAvto.initPar();
		return true;
	}
	else
	{
		//return Favto_zaval();
	}
}

function Fwork_Valid()
{
	var date = new Date();
	date.setDate(toScriptDate(Fbdate.value).getDate());
	date.setMonth(toScriptDate(Fbdate.value).getMonth());
	date.setFullYear(toScriptDate(Fbdate.value).getFullYear());
	date.setHours(Fbtime.getHours());
	date.setMinutes(Fbtime.getMinutes());
	var date2 = new Date();
	date2.setDate(toScriptDate(Fedate.value).getDate());
	date2.setMonth(toScriptDate(Fedate.value).getMonth());
	date2.setFullYear(toScriptDate(Fedate.value).getFullYear());
	date2.setHours(Fetime.getHours());
	date2.setMinutes(Fetime.getMinutes());

	var diff = day_differencemin(date, date2);
	// shift 1 day
	var diff_min = diff % 60;
	var diff_hours = ((diff - diff_min) / 60) % 24;
	var diff_days = Math.round(diff / (60 * 24) - 0.5);
	
	Fwork_calc.text = diff_days + " д. " +
		diff_hours + " ч. " + 
		diff_min + " мин. ";
	Fsalary_calc.text = Fsalary_calc.text=="" ? "???" + " грн." : Fsalary_calc.text;
	return true;
}

function Ffuel_Valid()
{
	/*Fbfuel_label.text = Fbfuel.value;
	Fbfuel_label2.text = Fbfuel2.value;
	Ffuel_calc.text = String((Fbfuel.value - Fefuel.value) + (Fbfuel2.value - Fefuel2.value)) + " л.";
	*/
	// тут будем считать информацию для топлива
	return true;
}

/*
function Fdistance_Valid()
{
	// Для новых записей берем дистанцию с описания машины
	// а для редактируемых с путевого листа (в справочнике машин хранится только текущее показание спидометра)
	if (strMode == "EDIT")
	{
		bDist = extPar.doc.getVar("HBDISTANCE")
	}
	else
	{
		var oSnap = getSnap("select FDISTANCE "
			+ " from ^CL_AVTO"
			+ " where FCOD = " + sqlTo(objAvto.getCod()));
		if (oSnap == null)
			return;
		else
			bDist = oSnap[0];
	}
	
	Fbdistance.text = bDist + " км.";
	Fdistance_calc.text = String(Fedistance.value - bDist) + " км.";
	
	return true;
}
*/

function OnCalculate()
{
	// Сначала возьмем кол-во топлива по норме для спецоборудования
	// это было раньше Hob*tob
	strSQL = "SELECT SUM(T.FKOLVYD) AS FKOLVYD FROM "+sTmpTbl+" T INNER JOIN "
			+" (^CLRELCLCL REL INNER JOIN ^CL_WORKTYPE WT ON (REL.FWID_CL = WT.FWID_CL AND REL.FCL = "+sqlTo(sprWorkType)+"))"
			+" ON T.FWORKTYPE = REL.FCOD "
			+" WHERE WT.FWORK = " + sqlTo(AVTO_WORKTYPE_SPEC)
	var sn = getSnap(strSQL);
	var Hob = 0;
	if (sn != null && sn[0] != null)
	{
		Hob = sn[0];
	}
	sn = null;
	// Спецоборудование может использовать то же топливо что и машина
	// Потому узнаем количество топлива, которое использовалось для езды
	var tblTmp = getTmpTableName();
	var tblTmpOb = getTmpTableName();
	strSQL = "SELECT SUM(T.FKOLVYD) AS FKOL, FT.FFUEL, 0 AS FKOLOB "
			+" INTO " + tblTmp
			+" FROM "+sTmpTbl+" T INNER JOIN "
			+" ((^CLRELCLCL REL INNER JOIN ^CL_WORKTYPE WT ON (REL.FWID_CL = WT.FWID_CL AND REL.FCL = "+sqlTo(sprWorkType)+"))"
			+" LEFT JOIN (^CLRELCLCL REL2 INNER JOIN ^CL_FUELTYPE FT "
				+" ON (REL2.FWID_CL=FT.FWID_CL AND REL2.FCL = "+sqlTo(sprFuelType)+"))"
					+" ON REL2.FCOD = WT.FFUEL)"
			+" ON T.FWORKTYPE = REL.FCOD "
			+" WHERE WT.FWORK = " + sqlTo(AVTO_WORKTYPE_RUN)
			+" GROUP BY FT.FFUEL"
	ExecuteSQL(strSQL);
	strSQL =" SELECT SUM(T.FKOLVYD) AS FKOLOB, FT.FFUEL"
			+" INTO " + tblTmpOb
			+" FROM "+sTmpTbl+" T INNER JOIN "
			+" ((^CLRELCLCL REL INNER JOIN ^CL_WORKTYPE WT ON (REL.FWID_CL = WT.FWID_CL AND REL.FCL = "+sqlTo(sprWorkType)+"))"
			+" LEFT JOIN (^CLRELCLCL REL2 INNER JOIN ^CL_FUELTYPE FT "
				+" ON (REL2.FWID_CL=FT.FWID_CL AND REL2.FCL = "+sqlTo(sprFuelType)+"))"
					+" ON REL2.FCOD = WT.FFUEL)"
			+" ON T.FWORKTYPE = REL.FCOD "
			+" WHERE WT.FWORK = " + sqlTo(AVTO_WORKTYPE_SPEC)
			+" GROUP BY FT.FFUEL"
	ExecuteSQL(strSQL);
	strSQL = "UPDATE "+tblTmp+" T  "
			+" SET FKOLOB = (SELECT FKOLOB FROM "+tblTmpOb+" T1"
			+" WHERE T.FFUEL = T1.FFUEL)"
			+" WHERE FFUEL IN (SELECT FFUEL FROM "+tblTmpOb+" )"
	ExecuteSQL(strSQL);
	var tSum = OpenTable("s", tblTmp);
	var Hs = 0;
	var Qn;
	var fuelQty = 0;
	var fuelQtyAll = 0;
	var overrun_value;
	for(; !tSum.IsEOF(); tSum.MoveNext())
	{
		strSQL = "SELECT SUM(FBFUEL+FFUEL_DESK-FEFUEL)"
			+" FROM "+sTmpTblFuel+" WHERE FTYPE = " + sqlTo(AVTO_NMK_FUEL)
			+" AND FFUEL = " + sqlTo(tSum.getValue("FFUEL"))
		var sn = getSnap(strSQL);
		if (sn != null && sn[0] != null)
		{
			var koef = tSum.getValue("FKOL")/(tSum.getValue("FKOL")+tSum.getValue("FKOLOB"));
			fuelQty += sn[0]*koef;
		}	
		sn = null;		
	}
	if (fuelQty == 0)
	{
		return;
	}
	strSQL = "SELECT SUM(FBFUEL+FFUEL_DESK-FEFUEL)"
			+" FROM "+sTmpTblFuel+" WHERE FTYPE = " + sqlTo(AVTO_NMK_FUEL)
	var sn = getSnap(strSQL);
	if (sn != null && sn[0] != null)
	{
		fuelQtyAll = sn[0];
	}
	sn = null;
	if (!tSum.IsEmpty())
	{
		for(tSum.MoveFirst(); !tSum.IsEOF(); tSum.MoveNext())
		{
			strSQL = "SELECT FBFUEL+FFUEL_DESK-FEFUEL FROM "+sTmpTblFuel
					+" WHERE FTYPE = " + sqlTo(AVTO_NMK_FUEL)
					+" AND FFUEL = " + sqlTo(tSum.getValue("FFUEL"))
			var sn = getSnap(strSQL);
			if (sn != null && sn[0] != null)
			{
				var koef = tSum.getValue("FKOL")/(tSum.getValue("FKOL")+tSum.getValue("FKOLOB"));
				Hs += tSum.getValue("FKOL")*sn[0]*koef/fuelQty;
			}
			sn = null;
		}
	}
	Qn = Hs * (1 + 0.01 * Number(ksum.value)) + Hob * (1 + 0.01 * Number(kob.value));
	overrun_value = Math.round((fuelQtyAll - Qn) * 1000) / 1000;
	
	calc_value.value = Qn;
	overrun.text = overrun_value + " л.";
	//HsLabel.text = "Hs = " + Hs;
	//HobLabel.text = "Hоб = " + Hob;
}

function refreshAvtoInfo()
{
	var oSnap = getSnap("select b.FWORKING_PETROL"
		+ " from ^CL_AVTO a LEFT JOIN ^CL_AVTO2FUEL_RATE b on a.fmodel = b.fcod"
		+ " where a.FCOD = " + sqlTo(objAvto.getCod()));

	if (oSnap != null)
	{
		Hs = 0//getFuelNorma(objAvto.getCod());
		Hob = oSnap[0];
		
		HsLabel.text = "Hs = " + Hs;
		HobLabel.text = "Hоб = " + Hob;
	}
}

function updNorm()
{
	// посчитаем расход топлива по норме
	strSQL = "UPDATE "+sTmpTblFuel+" SET FFUEL_NORM = 0";
	ExecuteSQL(strSQL);
	var tWorks = OpenTable("s", sTmpTbl);
	for (; !tWorks.IsEOF(); tWorks.MoveNext())
	{
		var mFnorm = tWorks.getValue("FKOLVYD");
		var strFrom = " FROM (^CLRELCLCL REL1 INNER JOIN ^CL_WORKTYPE WT "
									+" ON (REL1.FWID_CL=WT.FWID_CL AND REL1.FCL = "+sqlTo(sprWorkType)+"))"
											+" LEFT JOIN (^CLRELCLCL REL2 INNER JOIN ^CL_FUELTYPE FT "
												+" ON (REL2.FWID_CL=FT.FWID_CL AND REL2.FCL = "+sqlTo(sprFuelType)+"))"
													+" ON REL2.FCOD = WT.FFUEL"
		var strSQL = "SELECT FT.FFUEL, FT.FMOTOR_OIL, FT.FTRANSMISSION_OIL, FT.FSPECIAL_OIL, FT.FPLASTIC_LUBRICATION, "
				+" WT.FMOTOR_OIL, WT.FTRANSMISSION_OIL, WT.FSPECIAL_OIL, WT.FPLASTIC_LUBRICATION"
				+ strFrom
				+" WHERE REL1.FCOD = " + sqlTo(tWorks.getValue("FWORKTYPE"));
		var sn = getSnap(strSQL);
		if (sn != null && sn[0] != null)
		{
			strSQL = "UPDATE "+sTmpTblFuel+" SET FFUEL_NORM = FFUEL_NORM + "+sqlTo(mFnorm)
					+" WHERE FTYPE = " + sqlTo(AVTO_NMK_FUEL)
					+" AND FFUEL = " + sqlTo(sn[0])
			ExecuteSQL(strSQL);
			// Расход масел и смазки
			// Расход в нормах на 100 литров горючего
			var koeff = (mFnorm / 100)*(Number(koil.value)/100);
			strSQL = "UPDATE "+sTmpTblFuel+" SET FFUEL_NORM = FFUEL_NORM + "+sqlTo(koeff*sn[5])
					+" WHERE FTYPE = " + sqlTo(AVTO_NMK_MOTOR)
					+" AND FFUEL = " + sqlTo(sn[1])
			ExecuteSQL(strSQL);
			strSQL = "UPDATE "+sTmpTblFuel+" SET FFUEL_NORM = FFUEL_NORM + "+sqlTo(koeff*sn[6])
					+" WHERE FTYPE = " + sqlTo(AVTO_NMK_TRMIS)
					+" AND FFUEL = " + sqlTo(sn[2])
			ExecuteSQL(strSQL);
			strSQL = "UPDATE "+sTmpTblFuel+" SET FFUEL_NORM = FFUEL_NORM + "+sqlTo(koeff*sn[7])
					+" WHERE FTYPE = " + sqlTo(AVTO_NMK_SPEC)
					+" AND FFUEL = " + sqlTo(sn[3])
			ExecuteSQL(strSQL);
			strSQL = "UPDATE "+sTmpTblFuel+" SET FFUEL_NORM = FFUEL_NORM + "+sqlTo(koeff*sn[8])
					+" WHERE FTYPE = " + sqlTo(AVTO_NMK_PLLUB)
					+" AND FFUEL = " + sqlTo(sn[4])
			ExecuteSQL(strSQL);			
		}
		sn = null;
	}
	tWorks.close(5652);
	tWorks = null;
	switch(extPar.doc.getPar("_modekolfuel"))
	{
		case 0://совпадает с нормой
			strSQL = "UPDATE "+sTmpTblFuel+" SET FEFUEL = FBFUEL + FFUEL_DESK - FFUEL_NORM "
			ExecuteSQL(strSQL);
			break;
		case 1://вводится вручную
			break;
	}
	if (gridFuel.getTable() != null)
	{
		gridFuel.getTable().requery();
		gridFuel.refresh();
	}	
}

function makeFuelTbl()
{
	var nId = (extPar.mode == "COPY") ? extPar.doc.nOldID : extPar.doc.getID();
	var sFLD = GetPatternIntersection("RFUEL","RFUEL");
	oAvto.setVar("FDAT", new Date(Fdoc_dat.value));
	oAvto.setVar("FMOL", oPers.getCod());
	oAvto.setVar("FPODR", oAvtopark.getCod());
	oAvto.setVar("FDOC", extPar.doc.sDocLbl);
	oAvto.setVar("FAVTO", objAvto.getCod());
	strSQL = " SELECT FWID "
				   + " FROM ^RFUEL"
				   + " WHERE fid_doc = " + nId
				   + " AND FDOC = " + sqlTo(extPar.doc.sDocLbl)
	var sn = getSnap(strSQL);
	if (extPar.mode != "ADD" && sn != null)
	{
		var sSQL = "INSERT INTO " + sTmpTblFuel + "(" + sFLD + ")"
				   + " SELECT " + sFLD
				   + " FROM ^RFUEL"
				   + " WHERE fid_doc = " + nId
				   + " AND FDOC = " + sqlTo(extPar.doc.sDocLbl);
		ExecuteSQL(sSQL);
		var tFuel = OpenTable("s",sTmpTblFuel);
		for(; !tFuel.IsEOF(); tFuel.MoveNext())
		{
			oAvto.setVar("FNMKL", tFuel.getValue("FFUEL"));
			switch(extPar.doc.getPar("_ost_fuel"))
			{
				case 0://считать по учету ТМЦ
					var mFost = oAvto.getFuelTMC("nmk");
					break;
				case 1://считать по путевым листам
					var mFost = oAvto.getFuelWB("nmk");
					break;
				case 2://не считать
					var mFost = 0;
					break;
				case 3://считать по путевым листам, а потом добавлять все, что было до нашей даты по учету ТМЦ
					oAvto.setVar("FSMENA", Number(FSMENA.value))
					oAvto.setVar("FID_DOC", extPar.doc.getID())
					if (!isEmpty(extPar.doc.getPar("_load_fuel_podrexpr")))
					{
						var mFpodr = eval(String(extPar.doc.getPar("_load_fuel_podrexpr")));
						oAvto.setVar("FPODR", mFpodr);
					}
					if (!isEmpty(extPar.doc.getPar("_load_fuel_molexpr")))
					{
						var mFmol = eval(String(extPar.doc.getPar("_load_fuel_molexpr")));
						oAvto.setVar("FMOL", mFmol);
					}
					var mFost = oAvto.getFuelWBTMC("nmk");
				break;
			}
			switch(extPar.doc.getPar("_load_fuel"))
			{
				case 0://считать по учету ТМЦ
					oAvto.setVar("FSMENA", Number(FSMENA.value))
					oAvto.setVar("FID_DOC", extPar.doc.getID())
					if (!isEmpty(extPar.doc.getPar("_load_fuel_podrexpr")))
					{
						var mFpodr = eval(String(extPar.doc.getPar("_load_fuel_podrexpr")));
						oAvto.setVar("FPODR", mFpodr);
					}
					if (!isEmpty(extPar.doc.getPar("_load_fuel_molexpr")))
					{
						var mFmol = eval(String(extPar.doc.getPar("_load_fuel_molexpr")));
						oAvto.setVar("FMOL", mFmol);
					}
					var mFload = oAvto.getLoadFuelTMC("nmk");
					break;
				case 1://не считать
					var mFload = 0;
					break;
			}
			tFuel.Edit();
			tFuel.setValue("FBFUEL", mFost);
			tFuel.setValue("FFUEL_DESK", mFload);
			tFuel.Update();
		}
		tFuel.close(5652);
		tFuel = null;
	}
	else
	{
		// соберем виды топлива
		var strFrom = " FROM ((^CL_AVTO_WORK AW INNER JOIN ^CLRELCLCL REL "
							+" ON (REL.FWID_CL=AW.FWID_CL AND REL.FCL = "+sqlTo(sprAvto)+"))"
								+" LEFT JOIN (^CLRELCLCL REL1 INNER JOIN ^CL_WORKTYPE WT "
									+" ON (REL1.FWID_CL=WT.FWID_CL AND REL1.FCL = "+sqlTo(sprWorkType)+"))"
										+" ON AW.FCOD = REL1.FCOD )"
											+" LEFT JOIN (^CLRELCLCL REL2 INNER JOIN ^CL_FUELTYPE FT "
												+" ON (REL2.FWID_CL=FT.FWID_CL AND REL2.FCL = "+sqlTo(sprFuelType)+"))"
													+" ON REL2.FCOD = WT.FFUEL"
								
		var tmpNmk = getTmpTableName();
		// топливо
		strSQL = " SELECT Distinct FT.FFUEL AS FNMKL, "+sqlTo(AVTO_NMK_FUEL)+" AS FTYPE "
					+" INTO "+tmpNmk
					+strFrom
						+" WHERE REL.FCOD = "+sqlTo(objAvto.getCod())
						+" AND NOT FT.FFUEL IS NULL "
		ExecuteSQL(strSQL);
		// масло моторное
		strSQL = "INSERT INTO "+tmpNmk
					+" SELECT Distinct FT.FMOTOR_OIL AS FNMKL, "+sqlTo(AVTO_NMK_MOTOR)+" AS FTYPE "
					+strFrom
						+" WHERE REL.FCOD = "+sqlTo(objAvto.getCod())
						+" AND NOT FT.FMOTOR_OIL IS NULL "
		ExecuteSQL(strSQL);
		// масло трансмиссионное
		strSQL = "INSERT INTO "+tmpNmk
					+" SELECT Distinct FT.FTRANSMISSION_OIL AS FNMKL, "+sqlTo(AVTO_NMK_TRMIS)+" AS FTYPE "
					+strFrom
						+" WHERE REL.FCOD = "+sqlTo(objAvto.getCod())
						+" AND NOT FT.FTRANSMISSION_OIL IS NULL "
		ExecuteSQL(strSQL);
		// масло специальное
		strSQL = "INSERT INTO "+tmpNmk
					+" SELECT Distinct FT.FSPECIAL_OIL AS FNMKL, "+sqlTo(AVTO_NMK_SPEC)+" AS FTYPE "
					+strFrom
						+" WHERE REL.FCOD = "+sqlTo(objAvto.getCod())
						+" AND NOT FT.FSPECIAL_OIL IS NULL "
		ExecuteSQL(strSQL);
		// смазка пластичная
		strSQL = "INSERT INTO "+tmpNmk
					+" SELECT Distinct FT.FPLASTIC_LUBRICATION AS FNMKL, "+sqlTo(AVTO_NMK_PLLUB)+" AS FTYPE "
					+strFrom
						+" WHERE REL.FCOD = "+sqlTo(objAvto.getCod())
						+" AND NOT FT.FPLASTIC_LUBRICATION IS NULL "
		ExecuteSQL(strSQL);
		
		strSQL = "INSERT INTO " + sTmpTblFuel + "(FFUEL, FID_DOC, FDOC, FTYPE)"
					+" SELECT DISTINCT FNMKL AS FFUEL, "+sqlTo(nId)+" AS FID_DOC, "+sqlTo(extPar.doc.sDocLbl)+" AS FDOC, FTYPE "
					+" FROM "+tmpNmk
		ExecuteSQL(strSQL);			

		var tFuel = OpenTable("s",sTmpTblFuel);
		for(; !tFuel.IsEOF(); tFuel.MoveNext())
		{
			oAvto.setVar("FNMKL", tFuel.getValue("FFUEL"));
			switch(extPar.doc.getPar("_ost_fuel"))
			{
				case 0://считать по учету ТМЦ
					var mFost = oAvto.getFuelTMC("nmk");
					break;
				case 1://считать по путевым листам
					var mFost = oAvto.getFuelWB("nmk");
					break;
				case 2://не считать
					var mFost = 0;
					break;
				case 3://считать по путевым листам, а потом добавлять все, что было до нашей даты по учету ТМЦ
					oAvto.setVar("FSMENA", Number(FSMENA.value))
					oAvto.setVar("FID_DOC", extPar.doc.getID())
					if (!isEmpty(extPar.doc.getPar("_load_fuel_podrexpr")))
					{
						var mFpodr = eval(String(extPar.doc.getPar("_load_fuel_podrexpr")));
						oAvto.setVar("FPODR", mFpodr);
					}
					if (!isEmpty(extPar.doc.getPar("_load_fuel_molexpr")))
					{
						var mFmol = eval(String(extPar.doc.getPar("_load_fuel_molexpr")));
						oAvto.setVar("FMOL", mFmol);
					}
					var mFost = oAvto.getFuelWBTMC("nmk");
				break;
			}
			switch(extPar.doc.getPar("_load_fuel"))
			{
				case 0://считать по учету ТМЦ
					oAvto.setVar("FSMENA", Number(FSMENA.value))
					oAvto.setVar("FID_DOC", extPar.doc.getID())
					if (!isEmpty(extPar.doc.getPar("_load_fuel_podrexpr")))
					{
						var mFpodr = eval(String(extPar.doc.getPar("_load_fuel_podrexpr")));
						oAvto.setVar("FPODR", mFpodr);
					}
					if (!isEmpty(extPar.doc.getPar("_load_fuel_molexpr")))
					{
						var mFmol = eval(String(extPar.doc.getPar("_load_fuel_molexpr")));
						oAvto.setVar("FMOL", mFmol);
					}
					var mFload = oAvto.getLoadFuelTMC("nmk");
					break;
				case 1://не считать
					var mFload = 0;
					break;
			}			
			var m = new Object();
			m.FWID = GetUID();
			m.FBFUEL = mFost;
			m.FFUEL_DESK = mFload;
			updateTable(sTmpTblFuel, m, false, "FFUEL = " + sqlTo(tFuel.getValue("FFUEL"))+" AND FTYPE = " + sqlTo(tFuel.getValue("FTYPE")))
		}
		tFuel.close(5652);
		tFuel = null;
	}
	sn = null;
	updNorm();
	if (gridFuel.getTable() != null)
	{
		gridFuel.getTable().requery();
		gridFuel.refresh();
	}
	return sTmpTblFuel;
}

function loadGridFuel()
{
	var n = extPar.doc.sDocLbl.indexOf(":");
	if (n != -1)
	{
		var moduleID = extPar.doc.sDocLbl.substr(0, n);
		this.sDocSourceDir = lpProxy.getModulePath(moduleID) + "/scripts/docs/" + extPar.doc.sDocLbl.substr(n + 1)+ "/";
	}
	else
	{
		this.sDocSourceDir = rootDirectory() + "docs/" + extPar.doc.sDocLbl+ "/";
	}

	makeFuelTbl();

	gridFuel.setXMLDir(this.sDocSourceDir);
	//gridFuel.setXMLFile("fuellist.xml");
	tblFuel = OpenTable("m", sTmpTblFuel);
	tblFuel.tie("cl_nmk", "fuel_nmk", "fwid", "FFUEL");
	gridFuel.setTable(tblFuel);
	//gridFuel.build();
	loadDpGridDefs(gridFuel);
}

function loadDpGridDefs(gridFuel)
{
	include("objects\\DpGrid.js")
	gridFuel = new DpGrid("NOCREATE", gridFuel);
	//gridFuel.onePageMode(false);
	//gridFuel.setViewerID("e_WORKORDER.js");

	with(gridFuel)
	{
		with(page())
		{
			cell("fuel_nmk.ftxts", "ПММ|ГСМ", 15);
			cell("=getAvtoNmk(^FTYPE)", "Тип ПММ|Тип ГСМ", 15);
			switch(extPar.doc.getPar("_ost_fuel"))
			{
				case 0://считать по учету ТМЦ
					cell("FCENA", "Ціна|Цена", 8, "e");
				case 2://не считать
					cell("FBFUEL", "Зал. пал.\nна поч.|Ост. топл.\nна нач.", 9, "e");
				break;
				case 1://считать по путевым листам
				case 3://считать по путевым листам, а потом добавлять все, что было до нашей даты по учету ТМЦ
					strSQL = "SELECT COUNT(FWID) FROM ^WORKORDER "
							+" WHERE FAVTO = "+objAvto.getCod()
							+" AND FDOC_DAT< "+sqlTo(Fdoc_dat.getValue())
					var sn = getSnap(strSQL);
					if (sn != null)
					{
						if (sn[0] != 0)
						{
							cell("FBFUEL", "Зал. пал.\nна поч.|Ост. топл.\nна нач.", 9);
						}
						else
						{
							cell("FBFUEL", "Зал. пал.\nна поч.|Ост. топл.\nна нач.", 9, "e");
						}
					}
					sn = null;
					break;
			}
			switch(extPar.doc.getPar("_load_fuel"))
			{
				case 0:
					cell("FFUEL_DESK", "Заправлено|Заправлено", 9);
					break;
				case 1:
				default:
					cell("FFUEL_DESK", "Заправлено|Заправлено", 9, "e");
			}
			cell("FFUEL_NORM", "Кіл-ть пал.\nза нормою|Кол-во топл.\nпо норме", 9);
			cell("=^FBFUEL + ^FFUEL_DESK - ^FEFUEL", "Кіл-ть пал.\nфакт.|Кол-во топл.\nфакт.", 9);
			switch(extPar.doc.getPar("_modekolfuel"))
			{
				case 0://совпадает с нормой
					cell("FEFUEL", "Зал. пал.\nна кін.|Ост. топл.\nна кон.", 9);
					break;
				case 1://вводится вручную
					cell("FEFUEL", "Зал. пал.\nна кін.|Ост. топл.\nна кон.", 9, "e");
					break;
			}
		}
		build();
	}
}


function addRecord()
{
	return false;
}

function canEditRecord(sMode)
{
	if(!dpGridEdit || sMode == "ADD")
	{
		return false;
	}
	return true;
}

function startEdit_fefuel(oCtrl)
{
}

function endEdit_fefuel(oCtrl)
{
	var num = Number(gridFuel.getTable().getValue("FBFUEL"))+Number(gridFuel.getTable().getValue("FFUEL_DESK"))-Number(gridFuel.getTable().getValue("FFUEL_NORM"));
	dpGridEdit.setValue("FEFUEL", num, true);
}

function listMenuInitFuel()
{
	if (!gridFuel.getTable().isEmpty())
	{
		gridFuel.AddMenuItem("EDIT","Редагування | Редактирование");
	}
}

function onSelectRowMenuFuel(sID)
{
}

function loadGridSM(create_table_only)
{
	// create temp table
	gsm_tbl_name = getTmpTableName();
	var strSQL = "CREATE TABLE "+ gsm_tbl_name +"("
	+" FWID "+ SqlType("INT")
	+", FNUM " + SqlType("INT")
	+", FGSM_TYPE " + SqlType("TEXT", 40)
	+", FGSM " + SqlType("TEXT", 300)
	+", FGSM_ID " + SqlType("INT")
	+", FCENA " + SqlType("DOUBLE")
	+", FKOL " + SqlType("DOUBLE")
	+", FOST " + SqlType("DOUBLE")+")";
	ExecuteSQL(strSQL);
	
	// fill the data
	gsm_tbl = OpenTable("s", "SELECT * FROM " + gsm_tbl_name);
	gsm_tbl.requery();

	if (!create_table_only)	
	{
		// display data
		if (bCreateGrid)
		{
			gridSM.setXMLDir(lpProxy.getModulePath("avto") + "\\scripts\\");
			gridSM.setXMLFile("l_WORKORDER_rows.xml");
			gridSM.setTable(gsm_tbl);	
			gridSM.build();
			
			bCreateGrid = false;
		}
		else
		{
			gridSM.setTable(gsm_tbl);	
			gridSM.refresh();
		}
	}
}

//пока функция умеет загружать только 2 грида (но нужно чтобы умела все)
//GRIDTASK и GRIDACT
function loadGrid(clas)
{
	var tmpTbl;
	var workTbl;
	var type;
	var xmlFile = "";
	var gridName = "";
	
	var n = extPar.doc.sDocLbl.indexOf(":");
	if (n != -1)
	{
		var moduleID = extPar.doc.sDocLbl.substr(0, n);
		this.sDocSourceDir = lpProxy.getModulePath(moduleID) + "/scripts/docs/" + extPar.doc.sDocLbl.substr(n + 1)+ "/";
	}
	else
	{
		this.sDocSourceDir = rootDirectory() + "docs/" + extPar.doc.sDocLbl+ "/";
	}

	switch (clas)
	{
		case clasTask:
			workTbl = "RWORKORDER";
			tmpTbl = sTmpTblTask;
			type = AVTO_WORKORDER_TYPE_TASK;
			xmlFile = "tasklist.xml";
			gridName = "GRIDTASK";
			break;
		
		case clasAct:
			workTbl = "RWORKORDER";
			tmpTbl = sTmpTbl;
			type = AVTO_WORKORDER_TYPE_FACT;
			xmlFile = "rowlist.xml";
			gridName = "GRIDACT";
			break;
		default:
	}
	
	CreateTable(tmpTbl, workTbl,"FWID");
	var nId = (extPar.mode == "COPY") ? extPar.doc.nOldID : extPar.doc.getID();
	var sFLD = GetPatternIntersection(workTbl,workTbl);
	var sSQL = "INSERT INTO " + tmpTbl + "(" + sFLD + ")"
			   + " SELECT " + sFLD
			   + " FROM ^"+workTbl
			   + " WHERE FID_DOC = " + nId
			   + " AND FTYPE = "+sqlTo(type)
			   + " AND FDOC = " + sqlTo(extPar.doc.sDocLbl);
	ExecuteSQL(sSQL);
	
	var tblGrid = OpenTable("m","SELECT * FROM " + tmpTbl + " ORDER BY FNOM_STR");
	
	switch (clas)
	{
		case clasAct:
			if(strMode == "EDIT")
			{
				if(!IsTable(tmpTblDopl))
				{
					CreateTable(tmpTblDopl, tblDopl, "*");
				}
				//подтянем доплаты по строкам которые загрузились на грид
				var sFLDDOPL = GetPatternIntersection(tblDopl, tblDopl);
				strSQL = "INSERT INTO "+tmpTblDopl+"("+sFLDDOPL+")"
							+" SELECT "+sFLDDOPL	
							+" FROM ^"+tblDopl
							+" WHERE 1=1"
								+" AND FID_DOC IN (SELECT FWID FROM "+tmpTbl+" "
													+" WHERE 1=1"
														+" AND FTYPE = "+sqlTo(type)
														+" AND FDOC = "+sqlTo(extPar.doc.sDocLbl)
													+")"
				ExecuteSQL(strSQL);
				
				if(!IsTable(tmpTblHelp))
				{
					CreateTable(tmpTblHelp, tblHelp, "*");
				}
				//подтянем строки по помощникам которые загрузились на грид
				var sFLDHELP = GetPatternIntersection(tblHelp, tblHelp);
				strSQL = "INSERT INTO "+tmpTblHelp+"("+sFLDHELP+")"
							+" SELECT "+sFLDHELP	
							+" FROM ^"+tblHelp
							+" WHERE 1=1"
								+" AND FID_DOC IN (SELECT FWID FROM "+tmpTbl+" "
													+" WHERE 1=1"
														+" AND FTYPE = "+sqlTo(type)
														+" AND FDOC = "+sqlTo(extPar.doc.sDocLbl)
													+")"
				ExecuteSQL(strSQL);
			}
						
			tblGrid.clTie("WT", "="+sprWorkType+",FWORKTYPE");
			tblGrid.tie("CL_WORKTYPE","CL_WT","FWID_CL", "WT.FWID");
			tblGrid.clTie("US", "="+sprUser+",FUSER");
			break;
		case clasTask:
			tblGrid.clTie("WT", "="+sprWorkType+",FWORKTYPE");
			tblGrid.tie("CL_WORKTYPE","CL_WT","FWID_CL", "WT.FWID");
			tblGrid.clTie("US", "="+sprUser+",FUSER");
			break
		default:
	}
	
	//парметры загрузки грида
	eval(gridName+".setXMLDir(this.sDocSourceDir)");
	eval(gridName+".setXMLFile(xmlFile)");
	eval(gridName+".setTable(tblGrid)");
	eval(gridName+".build()");
	eval(gridName+".setData(clas)");
	
	if(extPar.mode=="COPY")
		extPar.doc.resetFnids(tblGrid, "ROW", extPar.doc);
	
	//меню грида
	eval(gridName+".loadMenuHandler(this,'listMenuInit')");
	eval(gridName+".selectMenuHandler(this,'onSelectRowMenu')");
	
	var oGridEdit = new DpGridEdit(eval(gridName));
	oGridEdit.canEdit = canEditRecord;

}

function listMenuInit(grid)
{
	var clas = String(grid.getData());
	switch (clas)
	{
		case clasAct:
			grid.AddMenuItem("TASK","Завантажити із завдань водія|Загрузить из заданий водителю");
		case clasTask:
		default:
			grid.AddMenuItem("ADD","Додавання | Добавление");
			if (!grid.getTable().isEmpty())
			{
				grid.AddMenuItem("EDIT","Редагування | Редактирование");
				grid.AddMenuItem("COPY","Копіювання | Копирование");
				grid.AddMenuItem("DEL","Видалення | Удаление");
			}
		break;
	}
}

function onSelectRowMenu(sID, grid)
{
	var par = new Object();
	var tbl = grid.getTable();
	var tmpTbl = tbl.getTableName();
	par.oAvto = oAvto;
	par.objAvto = objAvto;
	par.oPers = oPers;
	par.tblDopl = tmpTblDopl;
	par.tblHelp = tmpTblHelp;
	par.doc_dat = Fdoc_dat.getValue();
	var clas = String(grid.getData());
			
	if(sID == "DEL")
	{
		extPar.doc.deleteRow(clas,	Number(tbl.getRowID()));
		grid.getTable().Delete();
		grid.getTable().requery();
		grid.refresh();
	}
	else if (inList(sID, "ADD", "COPY", "EDIT"))
	{
		var oDocRow;
		if(sID == "ADD")
		{
			oDocRow = extPar.doc.createRow(clas);
			var oSnap = getSnap("SELECT MAX(FNOM_STR) AS NOM FROM " + tmpTbl);
			var nNom = 1;
			if (oSnap && oSnap[0])
				nNom = Number(oSnap[0]) + 1;
			oDocRow.setVar("RNOM",nNom)
		}
		else if(sID == "EDIT")
		{
			oDocRow = extPar.doc.getRow(clas, Number(tbl.getRowID()));
		}
		else if(sID == "COPY")
		{
			oDocRow = extPar.doc.copyRow(clas, Number(tbl.getRowID()));			
			var oSnap = getSnap("SELECT MAX(FNOM_STR) AS NOM FROM " + tmpTbl);
			var nNom = 1;
			if (oSnap && oSnap[0])
				nNom = Number(oSnap[0]) + 1;
			oDocRow.setVar("RNOM",nNom)		
		}
		
		var bOK = oDocRow.edit(sID, par);

		if (typeOf(FORM) == "DpXMLDialog")
		{		
			FORM.setActive();
		}	
		if (bOK)
		{
			if(inList(sID,"ADD","COPY"))
				extPar.doc.appendRow(clas,oDocRow)
			
			obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,tmpTbl);
			grid.getTable().requery();
			grid.refresh();
			if(clas == clasAct)
			{
				updNorm();
			}
		}
	}
	else if (sID == "__XDEL")
	{
		var delRowCount = DataSource().getSelectedCount();
		
		if (delRowCount <= 0)
		{
			return;
		}
		var selIds = DataSource().getSelectedIDs();
		
		var sCapt = ru("Удаление записей", "Видалення записів");
		var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів")+" (" + DataSource().getSelectedCount() + ").";
		if("c"==msgBox("c-", sMsg, sCapt))
		{
			return;
		}

		setProgressRange(0, delRowCount);
		for (var nRow = 0; nRow < selIds.length; nRow++)
		{
			setProgressPos(nRow + 1, sCapt +": "+ (nRow + 1) +"/"+ delRowCount);
			extPar.doc.deleteRow(clas, Number(selIds[nRow]));
		}
		var sSQL = "DELETE FROM " + tmpTbl
					+ " WHERE " + grid.sqlSelected()
		ExecuteSQL(sSQL);

		grid.clearSelected();
		setProgressPos(0);
		grid.getTable().requery();
		grid.refresh();		
	}
	else if (sID == "TASK")
	{
		var tmpTbl = sTmpTbl;
		if (!grid.getTable().IsEmpty())
		{
			if(!confirm(UR("Таблиця не пуста. Видалити введені рядки?|Таблица не пустая. Удалить введенные строки?")))
			{
				return;
			}
			else
			{
				ExecuteSQL("DELETE FROM "+tmpTbl);
			}
		}
		
		var oDocRow;
		var opTbl = OpenTable("s", sTmpTblTask);
		for(; !opTbl.IsEOF(); opTbl.MoveNext())
		{
			oDocRow = extPar.doc.createRow(clasAct);
			oSnap = getSnap("SELECT MAX(FNOM_STR) AS NOM FROM " + tmpTbl);
			var nNom = 1;
			if (oSnap && oSnap[0])
				nNom = Number(oSnap[0]) + 1;
			
			oDocRow.setVar("RNOM",nNom);
			oDocRow.setVar("par.HDOC", opTbl.getValue("FDOC"));
			oDocRow.setVar("par.ID", opTbl.getValue("FID_DOC"));
			oDocRow.setVar("RKOL_GA", opTbl.getValue("FKOL_GA"));
			oDocRow.setVar("RKOL_ZGA", opTbl.getValue("FKOL_GA"));
			oDocRow.setVar("RBVIR", false);
			oDocRow.setVar("RUSER", opTbl.getValue("FUSER"));
			
			oDocRow.setVar("RCDV", opTbl.getValue("FCDV"));
			oDocRow.setVar("RDDV", opTbl.getValue("FDDV"));
			oDocRow.setVar("RMDV", opTbl.getValue("FMDV"));
			oDocRow.setVar("RGALUZ", opTbl.getValue("FGALUZ"));
			oDocRow.setVar("RPROB0", opTbl.getValue("FPROB0"));
			oDocRow.setVar("RPROBG", opTbl.getValue("FPROBG"));
			oDocRow.setVar("RPROB", opTbl.getValue("FPROB"));
			oDocRow.setVar("RWORKTYPE", opTbl.getValue("FWORKTYPE"));
			oDocRow.setVar("RKOLVYD", opTbl.getValue("FKOLVYD"));
			oDocRow.setVar("RPROCDOP", opTbl.getValue("FPROCDOP"));
			oDocRow.setVar("RKOLVYDDOP", opTbl.getValue("FKOLVYDDOP"));
			oDocRow.setVar("RKOLF", opTbl.getValue("FKOLF"));
			oDocRow.setVar("RBDATE", opTbl.getValue("FBDATE"));
			oDocRow.setVar("REDATE", opTbl.getValue("FEDATE	"));
			oDocRow.setVar("RTYPE", AVTO_WORKORDER_TYPE_FACT);
			oDocRow.setVar("RKLPROC", xcl(sprPers, oPers.getCod(), "PRKL"));
					
			extPar.doc.appendRow(clasAct, oDocRow);
			obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,tmpTbl);
		}
		
		grid.getTable().requery();
		grid.refresh();	
		updNorm();
	}
	
	if(clas == clasAct)
	{
		calcSalary()
	}
}

function Fdoc_dat_Valid()
{
	PZ_DATE.value = Fdoc_dat.value;
	
	//при изменении даты нужно заново установить период для штатного расписания
	if(oPers instanceof DpShtat == true)
	{
		if(isEmpty(Fdoc_dat.getValue()))
			oPers.setPeriod(new Date(), new Date());			
		else
			oPers.setPeriod(new Date(Fdoc_dat.getValue()), new Date(Fdoc_dat.getValue()));
	}
	
	return true;
}

function Fdriver_Valid()
{
	if (sprPers == oSc.getClcl1())
	{
		oSc._setCl(1, oPers.getCod());
	}
	else if (sprPers == oSc.getClcl2())
	{
		oSc._setCl(2, oPers.getCod());
	}
	else if (sprPers == oSc.getClcl3())
	{
		oSc._setCl(3, oPers.getCod());
	}
	
	//если oPers это штатное расписание то сами опдейтим текстовое поле
	if(oPers instanceof DpShtat == true)
	{
		Fdriver_txt.setValue(oPers.getEmployeSurname());
	}
	
	return true;
}

function OnCreateDoc()
{
	if (getPar("AVTO_PZ_NOP","AVTO") != 0)
	{
		if(searchPZ())
		{
			if(!confirm(UR("Документ уже створено. Створити ще один?|Документ уже создан. Создать еще один?")))
				return;
		}
		
		objDoc = new DpDoc("PZ", getPar("AVTO_PZ_NOP","AVTO"));
		
		var pzpar = new Object();		
		pzpar.escape = false;
		pzpar.Fdate = PZ_DATE.value;
		pzpar.Fdoc  = "PZ";
		pzpar.Fnop  = getPar("AVTO_PZ_NOP","AVTO");
		pzpar.Fcalc = 0;
		pzpar.Fdoc_num = String(PZ_NUM.value);
		pzpar.Fpodr = Number(objPodr.getCod());
		pzpar.Fmol = Number(objMol.getCod());
		pzpar.Fsc = Number(oSc.getSc());
		pzpar.Fsu = Number(oSc.getSu());
		pzpar.Fst = Number(oSc.getSt());
		pzpar.Fcl1 = Number(oSc.getCl1());
		pzpar.Fcl2 = Number(oSc.getCl2());
		pzpar.Fcl3 = Number(oSc.getCl3());

		pzpar.escape = true;
		pzpar.submode = "GETORDER";
		
//		makeFuelTbl();
		pzpar.tblFrom = OpenTable("s","select * from " + sTmpTblFuel);

	    if (savePZ(objDoc, pzpar))
	    {
	    	alert("Документ создан!");
	    	create_doc.setText(UR("Створити документ на списання ПММ (УЖЕ СТВОРЕНИЙ)|Создать документ на списание ГСМ (УЖЕ СОЗДАН)"));
	    }
	    else
	    	alert("Ошибка при создании документа!");
	}
}

function savePZ(oDoc, par)
{
	with(oDoc)
	{
		sDocLbl = 'PZ';
		setVar("HDOC", "PZ")
		setVar("HOP", Number(par.Fnop))
		setVar("HNOM", par.Fdoc_num);
		setVar("HDAT", par.Fdate);
		setVar("HPODR", par.Fpodr);
		setVar("HMOL", par.Fmol);
		setVar("HSC", par.Fsc);
   		setVar("HSU", par.Fsu);
   		setVar("HST", par.Fst);
		setVar("HA1", par.Fcl1);
   		setVar("HA2", par.Fcl2);
   		setVar("HA3", par.Fcl3);
		setVar("HP", oDoc.getPar("_pricetyp"));	
		setVar("HPN",oDoc.getPar("_priceuse"));	
	}
	var fnom = 0;
	var fkol = 0;
	var fsum = 0;
	var oRow;	

	for(par.tblFrom.moveFirst(); !par.tblFrom.isEOF(); par.tblFrom.MoveNext())
	{	
		var mFkol = Number(par.tblFrom.getValue("FBFUEL"))
			+Number(par.tblFrom.getValue("FFUEL_DESK"))
			-Number(par.tblFrom.getValue("FEFUEL"));
		//SAM 18.04.2012
		//строки с нулевым количеством списывать нет смысла
		if (mFkol != 0)
		{
			fsum += round(mFkol * Number(par.tblFrom.getValue("Fcena")),2);	
			fkol += mFkol;
			fnom++;
		
			oRow = oDoc.createRow("ROW");
			oDoc.appendRow("ROW", oRow);

			with(oRow)
			{
				setVar("R1ID",	 0);
				setVar("RNOM",	 fnom);
				setVar("RTYPE",	 "7");
				setVar("RKOL",	 mFkol);
				setVar("R1DAT",	 par.Fdate);
				
				setVar("RPCENE", par.tblFrom.getValue("Fcena"));
				setVar("ROCENA", par.tblFrom.getValue("Fcena"));
				setVar("RFOCENA",par.tblFrom.getValue("Fcena"));
				setVar("RTNMK",	 par.tblFrom.getValue("FFUEL"));
				setVar("RPODR",	 oDoc.getVar("HPODR"));
				setVar("RMOL",	 oDoc.getVar("HMOL"));
				setVar("RPOST",	 oDoc.getVar("HPOST"));
					
				setVar("RSC",	 oDoc.getVar("HSC"));
				setVar("RSU",	 oDoc.getVar("HSU"));
				setVar("RST",	 oDoc.getVar("HST"));
				setVar("RSC1",	 oDoc.getVar("HSC1"));
				setVar("RSU1",	 oDoc.getVar("HSU1"));
				setVar("RST1",	 oDoc.getVar("HST1"));
				setVar("REDI",	 0);
				setVar("RKOLSPR",0);
			}	  
			obj2DB(oRow.getID(), oRow.jDocRow, null, "ANLTK");
		}
	}
	var fnds = 20;
	var fsnds = round(fsum*fnds/100,2);
	oDoc.setVar("HPNDS", fnds);
	oDoc.setVar("HSNDS", fsnds);
	oDoc.setVar("HPSUM", fsum);
	oDoc.setVar("HSUM", fsum);
	oDoc.setVar("HKOL", fkol);
	oDoc.setVar("HNR", fnom);
	
	var bRet = oDoc.save(false, "ADD");
	oDoc.saveExtToDB();

	return bRet;
}

function searchPZ()
{
	var oSnap = getSnap("select FWID from ^SCH_ZAG"
						+" where UPPER(FDOC)='PZ'"
							+" and FNOP="+ sqlTo(getPar("AVTO_PZ_NOP","AVTO"))
							+" and FDOC_DAT="+ sqlTo(Fdoc_dat.value)
							+" and FDOC_NUM="+ sqlTo(PZ_NUM.value)
							+" and FPODR="+ sqlTo(objPodr.getCod())
							+" and FMOL="+ sqlTo(objMol.getCod())
							+" and FSC="+ sqlTo(oSc.getSc())
							+" and FSU="+ sqlTo(oSc.getSu())
							+" and FST="+ sqlTo(oSc.getSt())
							+" and FCL_COD1="+ sqlTo(oSc.getCl1())
							+" and FCL_COD2="+ sqlTo(oSc.getCl2())
							+" and FCL_COD3="+ sqlTo(oSc.getCl3())
						);
	if(oSnap && oSnap[0])
		return oSnap[0];
	return 0;
}

include("sys\\DpBaseDlg.js");