include("objects/DpTVars.js");
include("objects/DpGrid.js");
include("sys/udfs.js");
include("avto:servis/avto_tools.js");
include("avto:AVTO_const.js");

var tblName = getTmpTableName();

var sprPodr = 			getPar(const_GETPAR_KOLON);
var sprAvto = 			getPar(const_AVTOTRANSPORT);
var sprWorkType = 	getPar(const_GETPAR_WORKTYPE);
var sprPers = 			getPar("CODPERS");

var isPodr = getPar("AVTO_SVALL_ISPODR");
var label = "AVTO_SV";

function listLoad()
{
	with(list)
	{
		xmlGridFile = "avto:r_avto_svall.xml";
		title = ru("Общий свод по автопарку", "Загальний звіт по автопарку");
		printLabel =  "avto:"+label;
		objTotal.init(label);
	}
	return true;
}

function listAsk()
{
	include("objects/DpAskEx.js");
	var oA = new DpAskEx();
	oA.addItog("0", label);
	
	oA.add("D", "Початок періоду|Начало периода", "BDAT", new Date().getVarDate());
	oA.add("D", "Завершення періоду|Окончание периода", "EDAT", new Date().getVarDate());
	
	oA.add("CL"+(isPodr?"":"0"), "Підрозділ|Подразделение", "PODR", 0, sprPodr);
	oA.add("CL0", "Транспортний засіб|Транспортное средство","AVTO", 0, sprAvto);
	oA.add("CL0", "Вид робіт|Вид робот", "WORKTYPE", 0, sprWorkType);
	oA.add("CL0", "Водій|Водитель","DRIVER", 0, sprPers);
	oA.add("CL0", "Галузь витрат|Отрасль затрат", "GALUZ", 0, 8);
	oA.add("CL_LNK", "Папка документів|Папка документов", "DOC", "avto:com.debet.avto|0");

	oA.doAsk()
	return oA;
}

function listSrc()
{
	with( list )
	{
		qrySet("From", tblName, "Order", "FDOC_DAT, FAVTO, FDRIVER");
		
		clTie("PD", "="+getPar(const_GETPAR_KOLON)+", FPODR");
		clTie("DRV", "="+getPar("CODPERS")+", FDRIVER");
		clTie("GR", "="+getPar(const_GETPAR_GROUPTS)+", FGROUP");
		clTie("MD", "="+getPar(const_GETPAR_MODEL)+", FMODEL");
		clTie("HELPER", "="+getPar("CODPERS")+", FHELPER");
		clTie("AV", "="+getPar(const_AVTOTRANSPORT)+", FAVTO");
		clTie("GLZ", "="+getPar(const_GETPAR_ZATR)+", FGALUZ");
		clTie("WORK", "="+getPar(const_GETPAR_WORKTYPE)+", FWORKTYPE");
		subTie("CL_WORKTYPE","CL_WORK","FWID_CL","WORK.FWID");
		subTie("CL_EDI","ED","COD","CL_WORK.FEDI");
	}
}

function listGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	with (oGrid)
	{
		setColorField("Fttlevel");
		with(page())
		{
			if (list.objAsk.get("DOC").pFdoc.search(".traktor") != -1)
			{
				with(page("Наряд на польові роб.|Наряд на полевые раб."))
				{
					cell("FDOC_DAT","Дата док.|Дата док.",7);
					cell("FDOC_NUM","№ док.|№ док.",6);
					cell("PD.FTXT","Назва підр.|Название подр.", 12)
					cell("FUSER","№ поля|№ поля",4);
					cell("FUSER_TXT","Назва спож.(поля)|Название потр.(поля)", 12)
					
					with(group("Водiй|Водитель"))
					{
						cell("FDRIVER","Код",4)
						cell("DRV.FTXT","ПIБ|ФИО",15)
					}
					
					with(group("Помічник|Помощник"))
					{
						cell("FHELPER","Код",4)
						cell("HELPER.FTXT","ПIБ|ФИО",15)
					}

					with(group("Автотранспортний засіб|Автотранспортное средство"))
					{
						cell("FAVTO","Код",4)
						cell("AV.FTXT","Назва|Название",9)
					}

					with(group("Галузь витрат|Отрасль затрат"))
					{
						cell("FGALUZ","Код",4);
						cell("GLZ.FTXT","Назва|Название",12);
					}

					with(group("Робота|Работа"))
					{
						cell("FWORKTYPE","Код",4)
						cell("FWORKTYPE_TXT","Назва|Название",12)
						cell("ED.FTXTS","Од.вим.|Ед.изм.",6);
						cell("FKOL_GA","К-сть га.|Кол-тво га.",7)
						cell("FKOL_ETGA","К-сть ет. га.|Кол-тво ет. га.",7)
						cell("FSM_NORM","Зм. норм|См. норм",7)
						cell("FNORMV","Норма вир.|Норма выр.",7)
					}

					with(group("Витрата палива|Расход топлива"))
					{
						cell("CL_WORK.FNORM_FUEL","Норм. на 1 вим.|Норме на 1 изм.",6);
						cell("FKOLF","Норма|Норма",7);
						cell("FPROCDOP","Додатково %|Дополнит. %",7);
						cell("FKOLVYDDOP","Додатково л.|Дополнит. л.",7);
						cell("FKOLVYD","Фактичн. витрач.|Фактически потрачено",10);
					}
				
					with(group("Заробітна плата|Заработная плата"))
					{
						cell("FDDV","Днів|Дней",6);
						cell("FCDV","Годин|Часов",6);
						cell("FMDV","Хв.|Мин.",5);
						cell("FVOPL_TXT","Вид опл.|Вид опл.",12);
						cell("FRSD","Розцінка|Расценка",8);
						
						with(group("Суми|Суммы"))
						{
							cell("FBASESUM","За роб.|за раб.",6);
							cell("FKLSUM","За класн.|За классн.",6);
							cell("FSUMDOPL","Доплати|Доплаты",6);
							cell("FSUM","Разом|Всего",8);
						}
					}
				}
			}
			
			if (list.objAsk.get("DOC").pFdoc.search(".avto") != -1)
			{
				with(page("Шлях. лист|Путевой лист"))
				{
					cell("FDOC_DAT","Дата док.|Дата док.",7);
					cell("FDOC_NUM","№ док.|№ док.",6);
					cell("PD.FTXT","Назва підр.|Название подр.", 12)
					with(group("Споживач|Потребитель"))
					{
						cell("FUSER","Код",6);
						cell("FUSER_TXT","Назва спож.(поля)|Название потр.(поля)", 12)
					}
					with(group("Водiй|Водитель"))
					{
						cell("FDRIVER","Код",4)
						cell("DRV.FTXT","ПIБ|ФИО",15)
					}
					
					with(group("Помічник|Помощник"))
					{
						cell("FHELPER","Код",4)
						cell("HELPER.FTXT","ПIБ|ФИО",15)
					}

					with(group("Автотранспортний засіб|Автотранспортное средство"))
					{
						cell("FAVTO","Код",4);
						cell("AV.FTXT","Назва|Название",12);
					}

					with(group("Галузь витрат|Отрасль затрат"))
					{
						cell("FGALUZ","Код",4);
						cell("GLZ.FTXT","Назва|Название",12);
					}
					
					with(group("Робота|Работа"))
					{
						cell("FWORKTYPE","Код",4);
						cell("FWORKTYPE_TXT","Назва|Название",12);
						cell("FGRUZ","Вантаж|Груз",6);
						cell("FHOD","К-сть ход.|К-ство ход.",6);
						with(group("Пробіг|Пробег"))
						{
							cell("FPROBG","з вант.|с груз.",6);
							cell("FPROB0","без вант.|без груза",6);
							cell("FPROB","разом|всего",6);
						}
						
						cell("FTKM","т/км",6);
						
					}
					with(group("Витрата палива|Расход топлива"))
					{
						cell("CL_WORK.FNORM_FUEL","Норм. на 1 вим.|Норм. на 1 изм.",6);
						cell("FKOLF","Норма|Норма",7);
						cell("FPROCDOP","Додатково %|Дополнит. %",7);
						cell("FKOLVYDDOP","Додатково л.|Дополнит. л.",7);
						cell("FKOLVYD","Фактичн. витрач.|Фактически потрачено",10);
					}
					
					with(group("Заробітна плата|Заработная плата"))
					{
						cell("FDDV","Днів|Дней",6);
						cell("FCDV","Годин|Часов",6);
						cell("FMDV","Хв.|Мин.",5);
						cell("FVOPL_TXT","Вид опл.|Вид опл.",12);
						with(group("Розцінки|Расценки"))
						{
							cell("FCTS","ГТС|ЧТС",6);
							cell("FRT","За вант.|За груз",6);
							cell("FRDOP","За дод. роб.|За доп. раб.",6);
							cell("FRSD","Відрядно|Сдельно",6);
							cell("FRTKM","За т/км",6);
						}
						with(group("Суми|Суммы"))
						{
							cell("FCTSSUM","За ГТС|По ЧТС",6);
							cell("FSTKM","За т/км|По т/км",6);
							cell("FSSD","Відрядн.|Сдельн.",6);
							cell("FST","За вант.|За груз",6);
							cell("FSDOP","За дод.р.|За доп.р.",6);
							cell("FKLSUM","За класн.|За классн.",6);
							cell("FSUMDOPL","Доплати|Доплаты",6);
							cell("FSUM","Разом|Всего",8);
						}
					}
				}
			}
		}
		build();
	}
}

function listMenuInit()
{
	with( list.dataSrc )
	{
		if(list.dataSrc.getTable().IsRecord())
		{
			if(!isEmpty(getTable().getValue("Fid_doc")) && !isEmpty(getTable().getValue("Fdoc")))
			{
				DataSource().AddMenuItem("CTRL-D", "Поиск документа");
			}
		}
		//DataSource().AddMenuItem ("WRITEFUEL", "Списання палива|Списание топлива");
	}
	
}

function listMenuRun(ID)
{
	
	var oPar = new Object();
	switch(ID)
	{
		case "CTRL-D":	//поиск документа по проводке
			include("doc/DpDocPtn.js");
			var tbl = list.dataSrc.getTable();
			FindDocument(tbl.getValue("FDOC"), tbl.getValue("FNOP"), tbl.getValue("FID_DOC"));
		break;
	}
	
}

function mkTbl()
{
	DropTable(tblName);
	strSQL = "CREATE TABLE "+tblName
				+" ("
					+" FAVTO "+SqlType("LONG")
					+", FMODEL "+SqlType("LONG")
					+", FGROUP "+SqlType("LONG")
					+", FTRAILER1 "+SqlType("LONG")
					+", FTRAILER2 "+SqlType("LONG")
					+", FDRIVER "+SqlType("LONG")
					+", FHELPER "+SqlType("LONG")
					+", FDOC_DAT "+SqlType("DATE")
					+", FDOC_NUM "+SqlType("TEXT", 255)
					+", FDOC "+SqlType("TEXT", 255)
					+", FNOP "+SqlType("LONG")
					+", FPODR "+SqlType("LONG")
					+", FUSER "+SqlType("LONG")
					+", FUSER_CL "+SqlType("LONG")
					+", FUSER_TXT "+SqlType("LONGTEXT")
					+", FWORKTYPE "+SqlType("LONG")
					+", FWORKTYPE_TXT "+SqlType("LONGTEXT")
					+", FGALUZ "+SqlType("LONG")
					+", FKOL_GA "+SqlType("DOUBLE")
					+", FKOL_ETGA "+SqlType("DOUBLE")
					+", FSM_NORM "+SqlType("DOUBLE")
					+", FNORMV "+SqlType("DOUBLE")
					+", FFROM "+SqlType("LONGTEXT")
					+", FTO "+SqlType("LONGTEXT")
					+", FHOD "+SqlType("LONG")
					+", FGRUZ "+SqlType("DOUBLE")
					+", FGRKL "+SqlType("LONG")
					+", FPROBG "+SqlType("DOUBLE")
					+", FPROB0 "+SqlType("DOUBLE")
					+", FPROB "+SqlType("DOUBLE")
					+", FKOLF "+SqlType("DOUBLE")
					+", FPROCDOP "+SqlType("DOUBLE")
					+", FKOLVYDDOP "+SqlType("DOUBLE")
					+", FKOLVYD "+SqlType("DOUBLE")
					+", FVOPL "+SqlType("TEXT", 10)
					+", FVOPL_TXT "+SqlType("LONGTEXT")
					+", FBASESUM "+SqlType("DOUBLE")
					+", FCTSSUM "+SqlType("DOUBLE")
					+", FSTKM "+SqlType("DOUBLE")
					+", FSSD "+SqlType("DOUBLE")
					+", FST "+SqlType("DOUBLE")
					+", FSDOP "+SqlType("DOUBLE") //За доп.работу используется у док avto
					+", FSUMDOPL "+SqlType("DOUBLE") //суммы доплат
					+", FKLPROC "+SqlType("DOUBLE")
					+", FKLSUM "+SqlType("DOUBLE")
					+", FKLCTS "+SqlType("DOUBLE")
					+", FSUM "+SqlType("DOUBLE")
					+", FCTS "+SqlType("DOUBLE") //ЧТС 
					+", FRT "+SqlType("DOUBLE") //розц за вантаж  
					+", FRDOP "+SqlType("DOUBLE") //розц за дополнительну работу   
					+", FRSD "+SqlType("DOUBLE") //розц за сдельную опл 
					+", FRTKM "+SqlType("DOUBLE") //розц за т/км
					+", FKOLSD "+SqlType("DOUBLE") //кол. сдельной работы
					+", FTKM "+SqlType("DOUBLE") //кол. т/км
					+", FDDV "+SqlType("DOUBLE")
					+", FCDV "+SqlType("DOUBLE")
					+", FMDV "+SqlType("DOUBLE")
					+", FID_DOC "+SqlType("LONG")
					+", FTT "+SqlType("TEXT", 2)
					+", FTTLEVEL "+SqlType("LONG")
					+", FWID "+SqlType("COUNTER")
				+" )";
	ExecuteSQL(strSQL);
	
	WAITTIMER(ru("Идет выполнение запроса...", "Йде виконання запиту..."))
	if (list.objAsk.get("DOC").pFdoc.search(".traktor") != -1)
	{
		//выберем основных сотрудников - водителей
		var strSQL ="INSERT INTO "
					+tblName+"(FAVTO, FDRIVER, FDOC_DAT, FDOC_NUM, FDOC, FNOP, FPODR"
									+", FUSER, FUSER_CL, FWORKTYPE, FGALUZ"
									+",FKOL_GA, FKOL_ETGA, FSM_NORM, FNORMV, FKOLF, FPROCDOP, FKOLVYDDOP, FKOLVYD"
									+",FVOPL, FBASESUM, FSUMDOPL, FKLPROC, FKLSUM, FKLCTS, FRSD, FSUM"
									+",FDDV, FCDV, FMDV"
									+",FID_DOC"
								+" )"
					+"SELECT"
						//из заголовка
						+" H.FAVTO, H.FDRIVER, H.FDOC_DAT, H.FDOC_NUM, H.FDOC, H.FNOP, H.FPODR"
						//строки
						+", R.FUSER, R.FUSER_CL, R.FWORKTYPE, R.FGALUZ"
						//топливо и кол. работы
						+", R.FKOL_GA, R.FKOL_ETGA, R.FSM_NORM, R.FNORMV, R.FKOLF"
						//Дополнительно топлива
						+", R.FPROCDOP, R.FKOLVYDDOP, R.FKOLVYD"
						//зарплата
						+", R.FVOPL, R.FBASESUM, R.FSUMDOPL, R.FKLPROC, R.FKLSUM, R.FKLCTS, R.FRASC, R.FSUM"
						//часы отработанные
						+", R.FDDV, R.FCDV, R.FMDV"
						+", R.FID_DOC"
					+" FROM"
						+" ^WORKORDER H LEFT JOIN ^RWORKORDER R ON H.FWID = R.FID_DOC"
					+" WHERE 1 = 1"
						+" AND H.FDOC_DAT >= "+sqlTo(list.objAsk.get("BDAT"))
						+" AND H.FDOC_DAT <= "+sqlTo(list.objAsk.get("EDAT"))
						+sqlw0And("H.FAVTO = ", list.objAsk.get("AVTO").getCod())
						+sqlw0And("R.FWORKTYPE = ", list.objAsk.get("WORKTYPE").getCod())
						+sqlw0And("H.FDRIVER = ", list.objAsk.get("DRIVER").getCod())
						+sqlw0And("R.FGALUZ = ", list.objAsk.get("GALUZ").getCod())
						+sqlw0And("H.FPODR = ", list.objAsk.get("PODR").getCod())
						+sqlw0And("H.FDOC = ", list.objAsk.get("DOC").pFdoc)
						+sqlw0And("H.FNOP = ", Number(list.objAsk.get("DOC").pFnop))
		ExecuteSQL(strSQL);
		
		//Добавление помощников
		strSQL = "INSERT INTO "+tblName+"("
								+"FAVTO, FDRIVER, FDOC_DAT, FDOC_NUM, FDOC, FNOP, FPODR"
								+", FHELPER, FWORKTYPE_TXT, FDDV, FCDV, FVOPL, FSUM, FGALUZ"
								+", FUSER, FUSER_CL, FID_DOC"
								+")"
					+" SELECT"
								//из заголовка
								+" H.FAVTO, H.FDRIVER, H.FDOC_DAT, H.FDOC_NUM, H.FDOC, H.FNOP, H.FPODR"
								//из табл. помощников
								+", RR.FTABN, RR.FWORK, RR.FDAY, RR.FHOUR, RR.FVOPL, RR.FSUM, RR.FGALUZ"
								+", RR.FUSER, RR.FUSER_CL, R.FID_DOC"
					+" FROM"
						+" (^WORKORDER H LEFT JOIN ^RWORKORDER R ON H.FWID = R.FID_DOC)"
								+" LEFT JOIN ^ROWS_HELP RR ON R.FWID = RR.FID_DOC"
					+" WHERE 1 = 1"
						+" AND H.FDOC_DAT >= "+sqlTo(list.objAsk.get("BDAT"))
						+" AND H.FDOC_DAT <= "+sqlTo(list.objAsk.get("EDAT"))
						+" AND RR.FTABN IS NOT NULL"
						+sqlw0And("H.FAVTO = ", list.objAsk.get("AVTO").getCod())
						+sqlw0And("R.FWORKTYPE = ", list.objAsk.get("WORKTYPE").getCod())
						+sqlw0And("R.FGALUZ = ", list.objAsk.get("GALUZ").getCod())
						+sqlw0And("H.FDRIVER = ", list.objAsk.get("DRIVER").getCod())
						+sqlw0And("H.FPODR = ", list.objAsk.get("PODR").getCod())
						+sqlw0And("H.FDOC = ", list.objAsk.get("DOC").pFdoc)
						+sqlw0And("H.FNOP = ", Number(list.objAsk.get("DOC").pFnop))
		ExecuteSQL(strSQL);
	}
	
	if (list.objAsk.get("DOC").pFdoc.search(".avto") != -1)
	{
		strSQL = " INSERT INTO"
					+" "+tblName+"(FAVTO, FDRIVER, FDOC_DAT, FDOC_NUM, FDOC, FNOP, FPODR"
									+", FUSER, FUSER_CL, FWORKTYPE, FGALUZ"
									+", FFROM, FTO, FHOD, FGRUZ, FGRKL, FPROBG, FPROB0, FPROB"
									+", FKOLF, FPROCDOP, FKOLVYDDOP, FKOLVYD"
									+", FCTS, FRT, FRDOP, FRSD, FRTKM"
									+", FVOPL, FCTSSUM, FSTKM, FST, FSDOP, FSSD, FKLSUM, FSUMDOPL, FSUM"
									+", FKOLSD"
									+", FTKM"
									+", FDDV, FCDV, FMDV"
									+", FID_DOC"
								+" )"
					+" SELECT"
						//из заголовка
						+" H.FAVTO, H.FDRIVER, H.FDOC_DAT, H.FDOC_NUM, H.FDOC, H.FNOP, H.FPODR"
						//строки
						+", R.FUSER, R.FUSER_CL, R.FWORKTYPE, R.FGALUZ"
						//Работа
						+", R.FFROM, R.FTO, R.FHOD, R.FGRUZ, R.FGRKL, R.FPROBG, R.FPROB0, R.FPROB"
						//топливо 
						+", R.FKOLF, R.FPROCDOP, R.FKOLVYDDOP, R.FKOLVYD"
						//зарплата (расценки)
						+", R.FCTS, R.FRT, R.FRDOP, R.FRSD, R.FRTKM"
						//зарплата (сумы)
						+", R.FVOPL, R.FCTSSUM, R.FSTKM, R.FST, R.FSDOP, R.FSSD, R.FKLSUM, R.FSDOPL, R.FSUM"
						//за сдельную работу (кол).
						+", R.FKOLSD"
						//т/км
						+", R.FPROBG/R.FHOD*R.FGRUZ AS FTKM"
						//часы отработанные
						+", R.FDDV, R.FCDV, R.FMDV"
						+", R.FID_DOC"
					+" FROM"
						+" ^WAYBILL H LEFT JOIN ^RWAYBILL R ON H.FWID = R.FID_DOC"
					+" WHERE 1 = 1"
						+" AND H.FDOC_DAT >= "+sqlTo(list.objAsk.get("BDAT"))
						+" AND H.FDOC_DAT <= "+sqlTo(list.objAsk.get("EDAT"))
						+" AND R.FTYPE = "+ sqlTo(AVTO_WAYBILL_TYPE_FACT)
						+sqlw0And("H.FAVTO = ", list.objAsk.get("AVTO").getCod())
						+sqlw0And("R.FWORKTYPE = ", list.objAsk.get("WORKTYPE").getCod())
						+sqlw0And("H.FDRIVER = ", list.objAsk.get("DRIVER").getCod())
						+sqlw0And("R.FGALUZ = ", list.objAsk.get("GALUZ").getCod())
						+sqlw0And("H.FPODR = ", list.objAsk.get("PODR").getCod())
						+sqlw0And("H.FDOC = ", list.objAsk.get("DOC").pFdoc)
						+sqlw0And("H.FNOP = ", Number(list.objAsk.get("DOC").pFnop))
		ExecuteSQL(strSQL);
		
		//Добавление помощников
		strSQL = "INSERT INTO "+tblName+"("
								+"FAVTO, FDRIVER, FDOC_DAT, FDOC_NUM, FDOC, FNOP, FPODR"
								+", FHELPER, FWORKTYPE_TXT, FDDV, FCDV, FVOPL, FSUM, FGALUZ"
								+", FUSER, FUSER_CL, FID_DOC"
								+")"
					+" SELECT"
								//из заголовка
								+" H.FAVTO, H.FDRIVER, H.FDOC_DAT, H.FDOC_NUM, H.FDOC, H.FNOP, H.FPODR"
								//из табл. помощников
								+", R.FTABN, R.FWORK, R.FDAY, R.FHOUR, R.FVOPL, R.FSUM, R.FGALUZ"
								+", R.FUSER, R.FUSER_CL, R.FID_DOC"
					+" FROM"
						+" ^WAYBILL H LEFT JOIN ^ROWS_HELP R ON H.FWID = R.FID_DOC"
					+" WHERE 1 = 1"
						+" AND H.FDOC_DAT >= "+sqlTo(list.objAsk.get("BDAT"))
						+" AND H.FDOC_DAT <= "+sqlTo(list.objAsk.get("EDAT"))
						+" AND R.FTABN IS NOT NULL"
						+sqlw0And("H.FAVTO = ", list.objAsk.get("AVTO").getCod())
						+sqlw0And("H.FDRIVER = ", list.objAsk.get("DRIVER").getCod())
						+sqlw0And("H.FPODR = ", list.objAsk.get("PODR").getCod())
						+sqlw0And("H.FDOC = ", list.objAsk.get("DOC").pFdoc)
						+sqlw0And("H.FNOP = ", Number(list.objAsk.get("DOC").pFnop))
		ExecuteSQL(strSQL);
	}
		
	//проставим название полей (потребителя услуг)
	strSQL = "UPDATE "+tblName+" T"
					+" SET FUSER_TXT = (SELECT CL.FTXT "
											+" FROM ^CLRELCLCL REL LEFT JOIN ^CL CL ON REL.FWID_CL = CL.FWID"
											+" WHERE 1=1"
												+" AND T.FUSER_CL = REL.FCL"
												+" AND T.FUSER = REL.FCOD"
											+")"
	ExecuteSQL(strSQL);
	
	//проставим название вида работы
	//сделано отдельным полем чтобы можна было писать работу помощника 
	strSQL = "UPDATE "+tblName+" T"
					+" SET FWORKTYPE_TXT = (SELECT CL.FTXT "
											+" FROM ^CLRELCLCL REL LEFT JOIN ^CL CL ON REL.FWID_CL = CL.FWID"
											+" WHERE 1=1"
												+" AND T.FWORKTYPE = REL.FCOD"
												+" AND REL.FCL = "+sqlTo(getPar(const_GETPAR_WORKTYPE))
											+")"
				+" WHERE 1=1"
					+" AND FWORKTYPE IS NOT NULL"
					+" AND FWORKTYPE  <> 0"
	ExecuteSQL(strSQL);
	
	//проставим групу и модель авто
	strSQL = "UPDATE "+tblName+" T"
					+" SET FMODEL = (SELECT max(AVTO.FMODEL)"
											+" FROM ^CL_AVTO AVTO"
											+" WHERE 1=1"
												+" AND T.FAVTO = AVTO.FCOD"
											+")"
					+", FGROUP = (SELECT max(AVTO.FGROUP)"
											+" FROM ^CL_AVTO AVTO"
											+" WHERE 1=1"
												+" AND T.FAVTO = AVTO.FCOD"
											+")"
	ExecuteSQL(strSQL);

	//проставим текстовку вида оплаты
	var opTbl = OpenTable(tblName);
	for(; !opTbl.IsEOF(); opTbl.MoveNext())
	{
		opTbl.Edit();
		txt = getVidOpl(opTbl.getValue("FVOPL"));
		opTbl.setValue("FVOPL_TXT", txt);
		opTbl.Update();
	}
	opTbl.Close(5652);
	opTbl = null;

	CLEARWAIT();
	return true;
}

function listMake()
{
	if (extPar==null)
	{
		menumd = GetMenuMode()
	}
	else
	{
		menumd = "CALC";
	}

	if (menumd = "CALC")
	{
		mkTbl();
	}

	var tbl4check = OpenTable("s", tblName);
	if (tbl4check.IsEmpty())
	{
		var msg = ru("По заданным параметрам ничего не найдено!", "По вказаних парметрах нічого не знайдено!")
		alert(msg);
		CloseWindow();
		return false;
	}
	tbl4check.Close(5652);
	tbl4check = null;

	return true;
}

function listOnPrnList(tv)
{
	var h = new Object();
	h.BDAT  = list.objAsk.get("BDAT");
	h.EDAT	= list.objAsk.get("EDAT");
	tv.setHTbl(h);

	return true;
}

include("sys/DpList.js");