DpFiscalRegistrator.prototype.create = emptyFunc;
DpFiscalRegistrator.prototype.dispose = emptyFunc;
DpFiscalRegistrator.prototype.setPassword = emptyFunc;
DpFiscalRegistrator.prototype.openPort = emptyFunc;
DpFiscalRegistrator.prototype.closePort = emptyFunc;

DpFiscalRegistrator.prototype.openFiscalReceipt = emptyFunc;
DpFiscalRegistrator.prototype.addItemToFiscalReceipt = emptyFunc;
DpFiscalRegistrator.prototype.addTextToFiscalReceipt = emptyFunc;
DpFiscalRegistrator.prototype.subTotalFiscalReceipt = emptyFunc;
DpFiscalRegistrator.prototype.totalFiscalReceipt = emptyFunc;
DpFiscalRegistrator.prototype.closeFiscalReceipt = emptyFunc;
DpFiscalRegistrator.prototype.cancelFiscalReceipt = emptyFunc;
DpFiscalRegistrator.prototype.printCheck = DpFiscalRegistrator_printCheck;
DpFiscalRegistrator.prototype.setDateTime = emptyFunc;

DpFiscalRegistrator.prototype.setArticle = emptyFunc;
DpFiscalRegistrator.prototype.delArticle = emptyFunc;
DpFiscalRegistrator.prototype.delAllArticles = emptyFunc;

DpFiscalRegistrator.prototype.checkArticulTable = DpFiscalRegistrator_checkArticulTable; 
DpFiscalRegistrator.prototype.clearArticulTable = DpFiscalRegistrator_clearArticulTable;
DpFiscalRegistrator.prototype.getArticulByNMKL = DpFiscalRegistrator_getArticulByNMKL;  

DpFiscalRegistrator.prototype.openReturnReceipt = emptyFunc;
DpFiscalRegistrator.prototype.addItemToReturnReceipt = emptyFunc;
DpFiscalRegistrator.prototype.addTextToReturnReceipt = emptyFunc;
DpFiscalRegistrator.prototype.subTotalReturnReceipt = emptyFunc;
DpFiscalRegistrator.prototype.totalReturnReceipt = emptyFunc;
DpFiscalRegistrator.prototype.closeReturnReceipt = emptyFunc;
DpFiscalRegistrator.prototype.cancelReturnReceipt = emptyFunc;
DpFiscalRegistrator.prototype.printReturnCheck = DpFiscalRegistrator_printReturnCheck;

DpFiscalRegistrator.prototype.printNullCheck = emptyFunc;


DpFiscalRegistrator.prototype.openNonFiscalReceipt = emptyFunc;
DpFiscalRegistrator.prototype.addTextToNonFiscalReceipt = emptyFunc;
DpFiscalRegistrator.prototype.closeNonFiscalReceipt = emptyFunc;
DpFiscalRegistrator.prototype.printNonFiscalCheck = DpFiscalRegistrator_printNonFiscalCheck;

DpFiscalRegistrator.prototype.printXReport = emptyFunc;
DpFiscalRegistrator.prototype.printZReport = emptyFunc;
DpFiscalRegistrator.prototype.printPerReport = emptyFunc;

DpFiscalRegistrator.prototype.hasError = new Function (" return false;");
DpFiscalRegistrator.prototype.getErrorText = new Function (" return '';");


function DpFiscalRegistrator()
{
	this.checkArticulTable();	
}

function DpFiscalRegistrator_checkArticulTable()
{
	if(!IsTable("ARTICULCASH"))
	{
		var fld = new Object();
		fld.FARTICUL = "INTEGER";
		fld.FNMKL = "INTEGER";
		fld.FPRICE = "currency";
		fld.FNDS = "currency";
		fld.FTXT = "longtext";
		fld.FISSOLID = "bool";
		var idx = new Object();
		idx.FNMKL = "FNMKL";
		CreateTable("ARTICULCASH", fld, idx);
	}
}

function DpFiscalRegistrator_clearArticulTable()
{
	ExecuteSQL("delete from ARTICULCASH", false);
}

function DpFiscalRegistrator_getArticulByNMKL(nmkl)
{
	var oSnap = getSnap("select FARTICUL, FPRICE, FTXT, FISSOLID, FNDS from ARTICULCASH where fnmkl = "  + sqlTo(nmkl));
	var ret = new Object();
	ret.ERROR = false;
	if (oSnap && oSnap[0])
	{
		var ret = new Object();
		ret.ARTICUL = oSnap[0];
		ret.NMKL = nmkl;
		ret.PRICE = oSnap[1];
		ret.TXT = oSnap[2];
		ret.ISSOLID = oSnap[3];
		ret.NDS = oSnap[4];
	}
	else
	{
		var oSnap = getSnap("select FTXTS, FCENAPR, FNDS, FCEDIB  from ^CL_NMK where fwid = "  + sqlTo(nmkl));
		if (!oSnap)
		{
			ret.ERROR = true;
		}
		else
		{
			var artSnap = getSnap("select max(farticul) as maxart from ARTICULCASH");
			var articul = 1;
			if (artSnap && artSnap[0])
				articul = Number(artSnap[0]) + 1;
			var fld = new Object();
			fld.FARTICUL =  ret.ARTICUL = articul;
			fld.FNMKL = ret.NMKL = nmkl;
			fld.FPRICE = ret.PRICE = oSnap[1];
			fld.FTXT = ret.TXT = oSnap[0];
			fld.FISSOLID = ret.ISSOLID = false; //TODOoSnap[4];
			fld.FNDS = ret.NDS = oSnap[2];
			updateTable("ARTICULCASH", fld, true);
			
		}
	}
	
	return ret;
}

function emptyFunc() {};

function DpFiscalRegistrator_printCheck(oDoc, iOperator, iPlaceNumber)
{
	if(!oDoc.gotoFirstRow())
		return;
	var docType = oDoc.sDocLbl; 
	//this.openPort(nPort, nSpeed);
	//alert("1" + this.oleObj.LastErrorText);
	this.openFiscalReceipt(iOperator, iPlaceNumber);
	//alert("2" + this.oleObj.LastErrorText);
	while(oDoc.gotoNextRow())
	{
		var currRow = oDoc.getCurrRow();
		var nCenaWithNDS = currRow.getVar("ROCENA");
		if (docType != "TCS")
		{
			var artInfo = this.getArticulByNMKL(currRow.getVar("RTNMK"));
			if (artInfo.ERROR)
				continue;
			if (artInfo.NDS)
				nCenaWithNDS = (nCenaWithNDS *(100 + artInfo.NDS))/100;
		}
		this.addItemToFiscalReceipt(currRow.getVar("RTNMK"), currRow.getVar("RKOL"), nCenaWithNDS, 0, currRow.getVar("RDISCOUNT"));
		//alert("3" + this.oleObj.LastErrorText);
	}
	this.subTotalFiscalReceipt(0,oDoc.getVar("HDISCOUNT"));
	//alert("4" + this.oleObj.LastErrorText);
	var nSUM = docType == "TCS" ? oDoc.getVar("HSUM") : (oDoc.getVar("HOSUM") + oDoc.getVar("HSNDS"));
	this.totalFiscalReceipt(oDoc.getVar("HTYPE_OPL"),nSUM , " ");
	//alert("5" + this.oleObj.LastErrorText);
	this.closeFiscalReceipt();	
	//alert("6" + this.oleObj.LastErrorText);
	//this.closePort();

}

function DpFiscalRegistrator_printReturnCheck(oDoc, iOperator, iPlaceNumber)
{
	if(!oDoc.gotoFirstRow())
		return;
	//this.openPort(nPort, nSpeed);
	this.openReturnReceipt(iOperator, iPlaceNumber);
	while(oDoc.gotoNextRow())
	{
		var currRow = oDoc.getCurrRow();		
		this.addItemToReturnReceipt(currRow.getVar("RTNMK"), currRow.getVar("RKOL"),  currRow.getVar("ROCENA"),0, currRow.getVar("RDISCOUNT"));		
	}
	this.subTotalReturnReceipt(0,oDoc.getVar("HDISCOUNT"));
	this.totalReturnReceipt(oDoc.getVar("HTYPE_OPL"),oDoc.getVar("HSUM"), " ");
	this.closeReturnReceipt();	
	//this.closePort();

}

function DpFiscalRegistrator_printNonFiscalCheck(arrText)
{
	if (!arrText)
		return;
	if (typeof(arrText) != "array")
	{
		arrText = [String(arrText)];	
	}
	this.openNonFiscalReceipt();
	for (var i = 0; i< arrText.length; i++)
		this.addTextToNonFiscalReceipt(arrText[i]);
	this.closeNonFiscalReceipt();
}

function createFRDriver(className, scriptName)
{
	include (scriptName);
	var ret = null;
	var e;
	try
	{
		ret = eval("new " + className + "()");
	}
	catch(e)
	{
		alert(e);
	}
	return ret;
}