
function DpHelper()
{
	this.init = DpHelper_init;
	this.setTask = DpHelper_setTask;
	this.setType = DpHelper_setType;
	this.setCtrl = DpHelper_setCtrl;
	this.isEnable = DpHelper_isEnable;
	this.getURL = DpHelper_getURL;
	this.getID = DpHelper_getID;
	this.getPath = DpHelper_getPath;
	this.edit = DpHelper_edit;
	this.save = DpHelper_save;
	this.del = DpHelper_del;
	this.run = DpHelper_run;
	this.enable = DpHelper_enable;
	this.infoHtml = DpHelper_infoHtml;
	this.getHtmlParams = DpHelper_getHtmlParams;
		
	this.path = rootDirectoryEx() +"modules/help/Source/html/";
	this.mainPath = rootDirectoryEx() +"userData/help/html/";
	this.userPath = lpProxy.getUserDirectory() +"help/html/";
	this.infoTask = "help_helper";
	this.jHelper = lpProxy.getHelper();
	
	this.init();
}

function DpHelper_init()
{
	this.ID = "";
	this.type = "";
	this.html = "";
	this.url = "";
	this.title = "";
	this.taskType = "";
	this.taskName = "";
	this.task = null;
	this.list = null;
	this.ctrl = null;
	this.module = "";
	this.exist = false;
	this.isuser = false;
	this.isblank = false;
	this.refresh = true;
	this.dir = getPar("HELPER_PATH");
	this.isedit = getPar("HELPER_EDIT");
	this.hint = getPar("HELPER_HINT");
	this.font = getPar("HELPER_FONT");
	this.lang = Number(getPar("LANGUAGE"))==0? "ua" : "";
}

function DpHelper_setTask(task, type)
{
	try
	{
		if(!task)
			return false;
		this.init();
		this.title = task.getCaption();
		var sTask = task.getTaskName();
		var list = task.getList();
		this.task = task;
		this.list = list;
		this.taskName = sTask;
		this.setType(type, sTask);
		if(this.type=="sys")
			sTask = "sys_"+ getSystem();
		trace(">>> DpHelper: type-"+ type +" > task-"+ sTask);
		if(!sTask || sTask=="")
			sTask = this.type;
		sTask = java.lang.String(sTask).trim();
		if(sTask.indexOf(".")!=-1)
			sTask = sTask.substring(0, sTask.lastIndexOf("."));
		var sModule = "";
		if(sTask.indexOf(":")!=-1)
			sModule = sTask.substring(0, sTask.lastIndexOf(":"));
		var sObject = "";
		if(list)
		{
			if(list.Fvid)
				sObject = String(list.Fvid);
			else if(list.m_Doclabel)
				sObject = String(list.m_Doclabel);
			if(sObject && sObject.indexOf(":")!=-1)
				sModule = sObject.substring(0, sObject.lastIndexOf(":"));
			if(sObject)
				sTask += "_"+ sObject;
		}
		sTask = sTask.replace(".", "_");
		sTask = sTask.replace(":", "_");
		//trace(">>> DpHelper: list-"+ list +" > task-"+ sTask +" > module-"+ sModule);
		var sHtml = sTask +".html";
		var sPath = this.path;
		if(isFile(this.userPath + sHtml))
		{
			this.exist = true;
			if(this.dir=="main" && isFile(this.mainPath + sHtml))
			{
				sPath = this.mainPath;
			}
			else
			{
				sPath = this.userPath;
				this.isuser = true;
			}
		}
		else if(isFile(this.mainPath + sHtml))
		{
			sPath = this.mainPath;
			this.exist = true;
			//if(this.dir=="user")
			//	this.exist = false;
		}
		else if(sModule!="")
		{
			var sModuleDir = lpProxy.getModulePath(sModule) +"/Source/help/html/";
			if(isFile(sModuleDir + sHtml))
				sPath = sModuleDir;
			this.module = sModule;
		}
		
		var sFile = sPath + sHtml;
		this.ID = sTask;
		this.html = sFile;
		//trace(">>> DpHelper: dir-"+ this.dir +" > sFile-"+ sFile);
		
		if(!isFile(sFile))
		{
			this.exist = false;
			sTask = this.type;
			if(this.type=="sys")
				sTask = this.infoTask;
			sFile = sPath + sTask +".html";
			this.html = sFile;
			if(!isFile(sFile))
			{
				if(this.type.substring(0,6)=="param_")
					sFile = this.path +"e_param.html";
			}
			if(this.lang && isFile(sPath + sTask +"_"+ this.lang +".html"))
				sFile = sPath + sTask +"_"+ this.lang +".html";
			//trace(">>> DpHelper: sTask-"+ sTask +" > sFile-"+ sFile);
			if(!isFile(sFile))
			{
				sFile = this.path +"blank.html";
				this.isblank = true;
			}
			if(!isFile(sFile))
				return false;
		}
		var file = new DpFile(sFile);
		var url = file.toURI().toString(); 
		//if(IS_WEB)
		//	url = "/help/"+ sTask +".html";
		url += this.getHtmlParams(sTask);
		trace(">>> DpHelper: type-"+ this.type +" > task-"+ sTask +" > url-"+ url);
		this.url = url;
		return true;
	}
	catch(ex)
	{
		return false;
	}
}

function DpHelper_getHtmlParams(sTask)
{
	try
	{
		include("servis/format.js");
		var sPar = "";
		if(sTask==this.infoTask)
		{
			sPar = (this.isedit? "hedit;" : "") +"hrem;";
		}
		else if(sTask=="l_docekz" || sTask=="l_cl")
		{
			var freeM = Math.round(Number(java.lang.Runtime.getRuntime().freeMemory())/1024/1024);
			var totalM = Math.round(Number(java.lang.Runtime.getRuntime().totalMemory())/1024/1024);
			var maxM = Math.round(Number(java.lang.Runtime.getRuntime().maxMemory())/1024/1024);
			var usedM = Number(totalM) - Number(freeM);
			if(usedM/maxM>0.9)
				sPar = "hint;sos";
			
			var start = this.jHelper.getStart();
			var end = this.jHelper.getEnd();
			if(start && end && (end.getTime()-start.getTime())/1000>10)
				sPar = "hint;brake";
			
			var start = this.jHelper.getStartTime();
			var date = new Date();
			var hour = date.getHours();
			var hdif = (date.getTime()-start.getTime())/3600000;
			if(hour>12 && hour<14 && hdif>3.8 && hdif<4.2)
				sPar += "hint;lunch;note:"+ format("HH:MM", new Date());
		}
		if(sPar!="")
			sPar = "?"+ sPar;
		return sPar;
	}
	catch(ex)
	{
		return "";
	}
}

function DpHelper_setCtrl(type, ctrl)
{
	try
	{
		if(type=="grid" && this.taskType=="list")
		{
			this.setTask(this.task, this.type);
			return false;
		}
		this.ctrl = ctrl;
		//this.type = type;
		//this.ID = type;
		//this.isedit = false;
		this.title = "";
		var sHtml = this.path + type +".html";
		if(!isFile(sHtml))
			return false;
		//this.html = sHtml;
		this.url = new DpFile(sHtml).toURI().toString();
		return true;
	}
	catch(ex)
	{
		return false;
	}
}

function DpHelper_setType(sType, sTask)
{
	try
	{
		if(!sType || sType=="null")
			sType = "";
		sType = String(sType).trim();
		this.type = sType;
		switch(sType)
		{
			case "l":
			case "XMLGRID": 
			case "GRIDDLG": 
				if(this.list && this.list.grid)
					this.type = "list";
				break;
			case "d":
			case "m":  
			case "XMLDLG": 
				this.type = "form";
				break;
			case "sys": 
				this.ID = getSystem();
				break;
			case "info":
			case "help_helper":
				this.type = this.infoTask;
				this.ID = "info";
				break;
			default:
				//this.type = "blank";
				break;
		}
		if(!sTask)
			return;
		sTask = String(sTask).trim();
		if(sTask.indexOf("form.xml")!=-1)
			this.type = "form";
		if(!this.type)
		{
			if(this.list && this.list.grid)
				this.type = "list";
			else if(this.task && this.task.isModal())
				this.type = "form";
		}
		if(this.type=="form" && this.list && this.list.sMode=="MASS_EDIT")
			this.type = "form_mass_edit";
		this.taskType = this.type;
		switch(sTask)
		{
			case "l_cl.xml": 
				this.type = "l_cl";
				break;
			case "l_docekz.xml":
				this.type = "l_docekz";
				break;
			case "syspanel.xml":
			case "checkBase.js": 
				this.type = "sys";
				this.ID = getSystem();
				break;
			case "e_param.xml":
			case "EditParams.js":
				this.type = "e_param";
				break;
			case "getdatr.xml":
				this.type = "form";
				break;
			case "showHelper":
			case "help:helper.xml":
			case "help:sys.settings.js": 
			case "desktop.xml":
			case "welcome.xml":
				this.type = this.infoTask;
				this.ID = "info";
				break;
		}
	}
	catch(ex)
	{
		
	}
}

function DpHelper_isEnable(sType, sTask)
{
	if((sType==null && !sTask) || sTask=="showHelper" || sTask=="help:e_helper.xml" || sTask=="help:sys/settings.js")
		return false;
	return true;
}

function DpHelper_getURL()
{
	return this.url;
}

function DpHelper_getID()
{
	return this.ID;
}

function DpHelper_edit()
{
	var par = new Object();
	par.helper = this;
	par.type = this.type;
	par.module = this.module;
	par.name = this.title;
	par.dir = this.dir;
	par.path = this.getPath();
	par.file = this.getPath() + this.ID +".html";
	par.text = "";
	par.arrRef = new Array();
	var sFile = this.html;
	if(isFile(sFile))
	{
		var htmlEditor = lpProxy.openHtml(sFile, "utf-8");
		if(this.exist)
		{
			par.name = htmlEditor.getText("NAME");
			par.text = htmlEditor.getText("TEXT");
		}	
		var arrTag = htmlEditor.parseReferens();
		for(var i=0; i<arrTag.length; i++)
		{
			var tag = arrTag[i];
			if(!tag)
				continue;
			var sRef = tag.getRef();
			if(!sRef || String(sRef).trim()=="#")
				continue;
			var sID = tag.getID();
			if(!sID)
				sID = "REF"+ i;
			var oRef = new DpHelperRef(sID, sRef, tag.getContent());
			par.arrRef[i] = oRef;
			//trace(">>> "+ i +" > "+ oRef.ID +" > "+ oRef.refs +" > "+ oRef.text);
		}
	}
	this.enable(false);
	showWindow("help:e_helper.xml", SW_MODAL, par);
	this.enable(true);
	if(par.escape)
		return false;
	this.save(par);
	this.run();
	return true;
}

function DpHelperRef(sID, sRef, sText)
{
	this.ID = sID;
	this.refs = sRef;
	this.text = sText;
	this.getID = DpHelperRef_getID;
	this.getRef = DpHelperRef_getRef;
	this.getText = DpHelperRef_getText;
	
	function DpHelperRef_getID()
	{
		return this.ID;
	}
	
	function DpHelperRef_getRef()
	{
		return this.refs;
	}
	
	function DpHelperRef_getText()
	{
		return this.text;
	}
}

function DpHelper_del()
{
	if(isFile(this.html))
	{
		deleteFile(this.html);
		this.run();
	}	
}

function DpHelper_save(oPar)
{
	var sName = String(oPar.name).trim();
	var sText = java.lang.String(oPar.text).trim();
	if(sText)
		sText = sText.replace("\n", "\n<br>");
	var sRefs = "";
	if(oPar.arrRef)
	{
		for(var i=0; i<oPar.arrRef.length; i++)
		{
			var oRef = oPar.arrRef[i];
			if(!oRef || !oRef.getRef())
				continue;
			var sID = oRef.getID();
			var sRef = oRef.getRef();
			if(String(sRef).trim()=="#")
				continue;
			var sCont = oRef.getText();
			if(Number(sID)>=0)
				sID = "REF"+ sID;
			else
				sID = "REF"+ i;
			//trace(">>> "+ sID +" > "+ sRef);
			if(!sCont || String(sCont).trim()=="")
				sCont = UR("Посилання |Ссылка ");
			if(sRef.indexOf("Source")!=-1)
				sRef = "source:/"+ sRef.substring(sRef.indexOf("Source")+6);
			if(sRef.indexOf("org.debet.DebetApp.rcp")!=-1)
				sRef = "help:/"+ sRef.substring(sRef.indexOf("html")+4);
			if(sRef.indexOf(".swf")!=-1)
				sRef = "video:/"+ sRef;
			sRefs += "\r\n<a ID=\""+ sID +"\" hRef=\""+ sRef +"\" style=\"color: blue; text-decoration:none;\">"+ sCont +"</a><br>";
		}
	}
	var htmlText = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">"
					+"\r\n<HTML>"
					+"\r\n<HEAD>"
					+"\r\n	<META HTTP-EQUIV=\"CONTENT-TYPE\" CONTENT=\"text/HTML; charset=utf-8\">"
					+"\r\n	<link rel=\"stylesheet\" href=\"helper.css\" type=\"text/css\"/>"
					+"\r\n</HEAD>"
					+"\r\n<BODY BGCOLOR=\"#FFFFE1\" DIR=\"LTR\">"
					+"\r\n<P ID=\"NAME\" style=\"font-weight: bold;\">"+ sName +"</P>"
					+"\r\n<P ID=\"TEXT\">\r\n"+ sText +"\r\n</P>"
					+ sRefs
					+"\r\n</BODY>"
					+"\r\n</HTML>";
	var sTask = String(oPar.task).trim();
	if(!sTask || sTask=="")
		sTask = "temp";
	var sFile = this.getPath() + sTask +".html";
	if(oPar.file)
		sFile = oPar.file;
	//trace("\n>>> DpHelper_save: "+ sFile);
	var sPath = new DpFile(sFile).getParent();
	if(!isDir(sPath))
		createDirectory(sPath);
	lpProxy.writeToFile(htmlText, sFile, "utf8");
}

function DpHelper_getPath()
{
	if(this.dir=="user")
		return this.userPath;
	else if(this.dir=="main")
		return this.mainPath;
}

function DpHelper_infoHtml()
{
	if(this.lang)
		return this.path + this.infoTask +"_"+ this.lang +".html";
	return this.path + this.infoTask +".html";
}

function DpHelper_run()
{
	lpProxy.runHelper(this.type, this.task);
}

function DpHelper_enable(bEnable)
{
	setPar("SHOW_HELPER", bEnable);
}
