include ("fiscalregistrator:Objects/DpFiscalRegistrator.js");
include ("Objects/DpCOMObject.js");

function ArtSoftFPU550OLE()
{
	this.password = "0000";
	derive(this,DpFiscalRegistrator); 
	
	this.create = ArtSoftFPU550OLE_createObject;
	this.dispose = ArtSoftFPU550OLE_dispose;
	this.setPassword = ArtSoftFPU550OLE_setPassword;
	this.openPort = ArtSoftFPU550OLE_openPort;
	this.closePort = ArtSoftFPU550OLE_closePort;
	this.printXReport = ArtSoftFPU550OLE_printXReport;
	this.printZReport = ArtSoftFPU550OLE_printZReport;
	this.setDateTime = ArtSoftFPU550OLE_setDateTime;
	
	this.setArticle = ArtSoftFPU550OLE_setArticle;
	this.delArticle = ArtSoftFPU550OLE_delArticle;
	this.delAllArticles = ArtSoftFPU550OLE_delAllArticles;
	
	this.openFiscalReceipt = ArtSoftFPU550OLE_openFiscalReceipt;
	this.addItemToFiscalReceipt = ArtSoftFPU550OLE_addItemToFiscalReceipt;
	this.addTextToFiscalReceipt = ArtSoftFPU550OLE_addTextToFiscalReceipt;
	this.subTotalFiscalReceipt = ArtSoftFPU550OLE_subTotalFiscalReceipt;
	this.totalFiscalReceipt = ArtSoftFPU550OLE_totalFiscalReceipt;
	this.closeFiscalReceipt = ArtSoftFPU550OLE_closeFiscalReceipt;
	this.cancelFiscalReceipt = ArtSoftFPU550OLE_cancelFiscalReceipt;
	
	
	this.openReturnReceipt = ArtSoftFPU550OLE_openReturnReceipt;
	this.addItemToReturnReceipt = ArtSoftFPU550OLE_addItemToFiscalReceipt;
	this.addTextToReturnReceipt = ArtSoftFPU550OLE_addTextToFiscalReceipt;
	this.subTotalReturnReceipt = ArtSoftFPU550OLE_subTotalFiscalReceipt;
	this.totalReturnReceipt = ArtSoftFPU550OLE_totalFiscalReceipt;
	this.closeReturnReceipt = ArtSoftFPU550OLE_closeFiscalReceipt;
	this.cancelReturnReceipt = ArtSoftFPU550OLE_cancelFiscalReceipt;
	
	
	this.printNullCheck = ArtSoftFPU550OLE_printNullCheck;	
	
	this.openNonFiscalReceipt = ArtSoftFPU550OLE_openNonFiscalReceipt;
	this.addTextToNonFiscalReceipt = ArtSoftFPU550OLE_addTextToNonFiscalReceipt;
	this.closeNonFiscalReceipt = ArtSoftFPU550OLE_CloseNonFiscalReceipt;	
	

	this.hasError = ArtSoftFPU550OLE_hasError;
	this.getErrorText = ArtSoftFPU550OLE_getErrorText;
	/*
	var aaa =  new DpCOMObject("ArtSoft.ExellioFPU-550");
	aaa.OpenPort(1, 19200);

	aaa.OpenFiscalReceipt(1, "0000", 1);
	aaa.RegistrItem(100, 4, 0,0)
	aaa.method("SubTotal",0, 0);
	aaa.Total("Всего", 1, 0.0);
	aaa.CloseFiscalReceipt();
	aaa.PrintNullCheck();
	alert(aaa.LastErrorText);
	aaa.ClosePort()
	aaa.release();
	*/ 
}

function ArtSoftFPU550OLE_setPassword(newPasswd)
{
	this.password = newPasswd;
}


function ArtSoftFPU550OLE_createObject()
{
	this.oleObj = new DpCOMObject("ArtSoft.ExellioFPU-550");
}

function ArtSoftFPU550OLE_dispose()
{
	if (this.oleObj != null)
	{
		this.oleObj.release();
		this.oleObj = null;
	}
}

function ArtSoftFPU550OLE_openPort(nPort, nSpeed)
{
	if (this.oleObj != null)
	{
		this.oleObj.OpenPort(nPort, nSpeed);		
	}
}

function ArtSoftFPU550OLE_closePort()
{
	if (this.oleObj != null)
	{
		this.oleObj.ClosePort();		
	}
}

function ArtSoftFPU550OLE_printNullCheck()
{
	if (this.oleObj != null)
	{
		this.oleObj.PrintNullCheck();		
	}
}

function ArtSoftFPU550OLE_printXReport(obj)
{
	if (this.oleObj == null)
		return false;
	var e;
	try
	{
		if (toScrObj(this.oleObj.isFiscalOpen))
			this.oleObj.CancelReceipt();
		this.oleObj.XReport(this.password);
		if (this.hasError())
		{
			if (obj)
				obj.errorText = this.getErrorText();
			return false;
		}
		else
		{
			if (obj)
			{
				this.oleObj.GetDayInfo();
				obj.checkNum = Number(this.oleObj.s6) + 1; 
				obj.shiftNum = Number(this.oleObj.s5) + 1;
			}
			return true;
		}
	}
	catch(e)
	{
		alert(e);
		return false;
	}
	
}

function ArtSoftFPU550OLE_printZReport(obj)
{
	if (this.oleObj == null)
		return false;
	var e;
	try
	{
		if (toScrObj(this.oleObj.isFiscalOpen))
			this.oleObj.CancelReceipt();
		this.oleObj.ZReport(this.password);
		if (this.hasError())
		{
			if (obj)
				obj.errorText = this.getErrorText();
			return false;
		}
		else
		{
			if (obj)
			{
				this.oleObj.GetDayInfo();
				obj.checkNum = Number(this.oleObj.s6) + 1; 
				obj.shiftNum = Number(this.oleObj.s5) + 1;
			}
			this.clearArticulTable();
			this.delAllArticles();
			return true;
		}
	}
	catch(e)
	{
		alert(e);
		return false;
	}
}

function ArtSoftFPU550OLE_setDateTime(dat)
{
	if (!dat)
		dat = new Date();
	var strdate = format("ddmmyy", dat);
	var strtime = format("th:tm", dat);
	if (this.oleObj != null)
	{
		this.oleObj.SetDateTime(new java.lang.String(strdate), new java.lang.String(strtime));		
	}
}

function ArtSoftFPU550OLE_setArticle(articul, iTax , iGrp, nCena, nmklTxt)
{
	if (!nmklTxt)
		nmklTxt = " ";
	if (nmklTxt.length > 36)
		nmklTxt = nmklTxt.substring(0, 36);
	this.oleObj.SetArticle(articul, iTax, iGrp, nCena, this.password, nmklTxt);
}

function ArtSoftFPU550OLE_delArticle(articul)
{
	this.oleObj.DelArticle(this.password, articul);
}

function ArtSoftFPU550OLE_delAllArticles()
{
	this.oleObj.DelArticle(this.password, 0);
}

function ArtSoftFPU550OLE_openFiscalReceipt(iOperator, iPlaceNumber)
{
	if (toScrObj(this.oleObj.isFiscalOpen))
		this.oleObj.CancelReceipt();
	this.oleObj.OpenFiscalReceipt(java.lang.Integer(iOperator), this.password, java.lang.Integer(iPlaceNumber));
}

function ArtSoftFPU550OLE_openReturnReceipt(iOperator, iPlaceNumber)
{
	this.oleObj.OpenReturnReceipt(iOperator,this.password, iPlaceNumber);
}



function ArtSoftFPU550OLE_addItemToFiscalReceipt(nmkl, nKol,nCena, nPRDisk, nSumDisk)
{
	var nmklID = nmkl;
	var objNmkl = this.getArticulByNMKL(nmkl);
	if (objNmkl.ERROR)
	{
		//TODO
		return false;
	}
	var articul = objNmkl.ARTICUL;
	
	//nmkl = 1;
	this.oleObj.GetArticle(articul);
	//alert("3.1" + this.oleObj.LastErrorText);
	if (this.oleObj.s1 == 'F')
	{
		this.oleObj.SetArticle(articul, 1, 1, nCena, this.password, tfnmk('TXT',nmklID));
		//alert("3.2" + this.oleObj.LastErrorText);
	}
	this.oleObj.ChangeArticlePrice(this.password, articul, nCena);
	//alert("3.3" + this.oleObj.LastErrorText);
	this.oleObj.RegistrItem(articul, nKol, nPRDisk, nSumDisk);
	//alert("3.4" + this.oleObj.LastErrorText);
	
	//this.oleObj.method("SetArticle", [200, 1, 1, 200.89, "0000","Тестовый товар 2"]);	
//obj.method("ChangeArticlePrice",["0000", 200, 150]);
//obj.method("GetArticle", [200]);
	//this.oleObj.OpenFiscalReceipt(iOperator, iPlaceNumber);
}

function ArtSoftFPU550OLE_addTextToFiscalReceipt(txt)
{
	this.oleObj.PrintFiscalText(txt);

}

function ArtSoftFPU550OLE_subTotalFiscalReceipt(nPRDisk, nSumDisk)
{
	this.oleObj.SubTotal(nPRDisk, nSumDisk);
}

function ArtSoftFPU550OLE_totalFiscalReceipt(iPayMode, dSum, txt)
{
	iPayMode = Number(iPayMode) == 0? java.lang.Integer(1):java.lang.Integer(2);  
	this.oleObj.Total(txt, iPayMode, dSum);
}

function ArtSoftFPU550OLE_closeFiscalReceipt()
{
	this.oleObj.CloseFiscalReceipt();
}

function ArtSoftFPU550OLE_cancelFiscalReceipt()
{
	this.oleObj.CancelReceipt();
}

function ArtSoftFPU550OLE_openNonFiscalReceipt()
{
	this.oleObj.OpenNonfiscalReceipt();
}

function ArtSoftFPU550OLE_CloseNonFiscalReceipt()
{
	this.oleObj.CloseNonfiscalReceipt();
}

function ArtSoftFPU550OLE_addTextToNonFiscalReceipt(txt)
{
	this.oleObj.PrintNonfiscalText(txt);
}

function ArtSoftFPU550OLE_CloseNonFiscalReceipt()
{
	this.oleObj.CloseNonfiscalReceipt();
}

function ArtSoftFPU550OLE_hasError()
{
	return Number(this.oleObj.LastError) != 0;
}

function ArtSoftFPU550OLE_getErrorText()
{
	return String(this.oleObj.LastErrorText);
}




