include ("fiscalregistrator:Objects/DpFiscalRegistrator.js");
include ("Objects/DpCOMObject.js");

function OPOS_Dt3541T()
{
	this.password = "0000";
	derive(this,DpFiscalRegistrator); 
	
	this.create = OPOS_Dt3541T_createObject;
	this.dispose = OPOS_Dt3541T_dispose;
	this.setPassword = OPOS_Dt3541T_setPassword;
	this.openPort = OPOS_Dt3541T_openPort;
	this.closePort = OPOS_Dt3541T_closePort;
	this.printXReport = OPOS_Dt3541T_printXReport;
	this.printZReport = OPOS_Dt3541T_printZReport;
	this.printPerReport = OPOS_Dt3541T_printPerReport;
	this.setDateTime = OPOS_Dt3541T_setDateTime;
	
	this.setArticle = OPOS_Dt3541T_setArticle;
	this.delArticle = OPOS_Dt3541T_delArticle;
	this.delAllArticles = OPOS_Dt3541T_delAllArticles;
	
	this.openFiscalReceipt = OPOS_Dt3541T_openFiscalReceipt;
	this.addItemToFiscalReceipt = OPOS_Dt3541T_addItemToFiscalReceipt;
	this.addTextToFiscalReceipt = OPOS_Dt3541T_addTextToFiscalReceipt;
	this.subTotalFiscalReceipt = OPOS_Dt3541T_subTotalFiscalReceipt;
	this.totalFiscalReceipt = OPOS_Dt3541T_totalFiscalReceipt;
	this.closeFiscalReceipt = OPOS_Dt3541T_closeFiscalReceipt;
	this.cancelFiscalReceipt = OPOS_Dt3541T_cancelFiscalReceipt;
	
	
	this.openReturnReceipt = OPOS_Dt3541T_openReturnReceipt;
	this.addItemToReturnReceipt = OPOS_Dt3541T_addItemToFiscalReceipt;
	this.addTextToReturnReceipt = OPOS_Dt3541T_addTextToFiscalReceipt;
	this.subTotalReturnReceipt = OPOS_Dt3541T_subTotalFiscalReceipt;
	this.totalReturnReceipt = OPOS_Dt3541T_totalFiscalReceipt;
	this.closeReturnReceipt = OPOS_Dt3541T_closeFiscalReceipt;
	this.cancelReturnReceipt = OPOS_Dt3541T_cancelFiscalReceipt;
	
	
	this.printNullCheck = OPOS_Dt3541T_printNullCheck;	
	
	this.openNonFiscalReceipt = OPOS_Dt3541T_openNonFiscalReceipt;
	this.addTextToNonFiscalReceipt = OPOS_Dt3541T_addTextToNonFiscalReceipt;
	this.closeNonFiscalReceipt = OPOS_Dt3541T_CloseNonFiscalReceipt;	
	

	this.hasError = OPOS_Dt3541T_hasError;
	this.getErrorText = OPOS_Dt3541T_getErrorText;
	/*
	var aaa =  new DpCOMObject("ArtSoft.ExellioFPU-550");
	aaa.OpenPort(1, 19200);

	aaa.OpenFiscalReceipt(1, "0000", 1);
	aaa.RegistrItem(100, 4, 0,0)
	aaa.method("SubTotal",0, 0);
	aaa.Total("Всего", 1, 0.0);
	aaa.CloseFiscalReceipt();
	aaa.PrintNullCheck();
	alert(aaa.LastErrorText);
	aaa.ClosePort()
	aaa.release();
	*/ 
}

function OPOS_Dt3541T_setPassword(newPasswd)
{
	this.password = newPasswd;
}


function OPOS_Dt3541T_createObject()
{
	this.oleObj = new DpCOMObject("OPOS.FiscalPrinter");
}

function OPOS_Dt3541T_dispose()
{
	if (this.oleObj != null)
	{
		this.oleObj.release();
		this.oleObj = null;
	}
}

function OPOS_Dt3541T_openPort(nPort, nSpeed)
{
	if (this.oleObj != null)
	{
		this.oleObj.Open("FiscPrinter");
		this.oleObj.ClaimDevice(20);
		this.oleObj.DeviceEnabled = true;

	}
}

function OPOS_Dt3541T_closePort()
{
	if (this.oleObj != null)
	{
		//this.oleObj.ClosePort();	
		this.oleObj.ReleaseDevice();
		this.oleObj.Close();
	}
}

function OPOS_Dt3541T_printNullCheck()
{
	if (this.oleObj != null)
	{
		this.oleObj.FiscalReceiptType = 4;
		this.oleObj.BeginFiscalReceipt(true);
		this.oleObj.EndFiscalReceipt (true);
	}
}

function OPOS_Dt3541T_printXReport(obj)
{
	if (this.oleObj == null)
		return false;
	var e;
	try
	{
		this.oleObj.printXReport();		
	}
	catch(e)
	{
		alert(e);
		return false;
	}
	
}

function OPOS_Dt3541T_printZReport(obj)
{
	if (this.oleObj == null)
		return false;
	var e;
	try
	{
		this.oleObj.printZReport();		
	}
	catch(e)
	{
		alert(e);
		return false;
	}
}

function OPOS_Dt3541T_printPerReport(dat1, dat2)
{
	if (this.oleObj == null)
		return false;
	var e;
	try
	{
		var sDat1 = format("ddmmyyyy", dat1) + "0000";
		var sDat2 = format("ddmmyyyy", dat2) + "2359";
		
		this.oleObj.BeginNonFiscal();
		this.oleObj.PrintPeriodicTotalsReport(sDat1, sDat2);
		this.oleObj.EndNonFiscal();
		//this.oleObj.PrintSumPeriodicReport(dat1, dat2);
	}
	catch(e)
	{
		alert(e);
		return false;
	}
}

function OPOS_Dt3541T_setDateTime(dat)
{
	if (!dat)
		dat = new Date();
	var strdate = format("ddmmyy", dat);
	var strtime = format("th:tm", dat);
	if (this.oleObj != null)
	{
		//this.oleObj.SetDateTime(new java.lang.String(strdate), new java.lang.String(strtime));		
	}
}

function OPOS_Dt3541T_setArticle(articul, iTax , iGrp, nCena, nmklTxt)
{
	if (!nmklTxt)
		nmklTxt = " ";
	if (nmklTxt.length > 36)
		nmklTxt = nmklTxt.substring(0, 36);
	//this.oleObj.SetArticle(articul, iTax, iGrp, nCena, this.password, nmklTxt);
}

function OPOS_Dt3541T_delArticle(articul)
{
	//this.oleObj.DelArticle(this.password, articul);
}

function OPOS_Dt3541T_delAllArticles()
{
	//his.oleObj.DelArticle(this.password, 0);
}

function OPOS_Dt3541T_openFiscalReceipt(iOperator, iPlaceNumber)
{
	this.oleObj.FiscalReceiptType = 4;
	this.oleObj.beginFiscalReceipt(true);
}

function OPOS_Dt3541T_openReturnReceipt(iOperator, iPlaceNumber)
{
	this.oleObj.FiscalReceiptType = 7;
	this.oleObj.beginFiscalReceipt(true);
}



function OPOS_Dt3541T_addItemToFiscalReceipt(nmkl, nKol,nCena, nPRDisk, nSumDisk)
{
	var nmklID = nmkl;
	var nmkTxt = tfnmk('TXT',nmklID);
	
	this.oleObj.PrintRecItem(nmkTxt, 0, 1000 * nKol, 192, nCena, "");
	
	
	//alert("3.4" + this.oleObj.LastErrorText);
	
	//this.oleObj.method("SetArticle", [200, 1, 1, 200.89, "0000","Тестовый товар 2"]);	
//obj.method("ChangeArticlePrice",["0000", 200, 150]);
//obj.method("GetArticle", [200]);
	//this.oleObj.OpenFiscalReceipt(iOperator, iPlaceNumber);
}

function OPOS_Dt3541T_addTextToFiscalReceipt(txt)
{
	this.oleObj.PrintRecMessage(txt);

}

function OPOS_Dt3541T_subTotalFiscalReceipt(nPRDisk, nSumDisk)
{
	//this.oleObj.SubTotal(nPRDisk, nSumDisk);
}

function OPOS_Dt3541T_totalFiscalReceipt(iPayMode, dSum, txt)
{
	//iPayMode = Number(iPayMode) == 0? java.lang.Integer(1):java.lang.Integer(2);  
	//this.oleObj.Total(txt, iPayMode, dSum);
	this.oleObj.PrintRecTotal(dSum, dSum, "0");
}

function OPOS_Dt3541T_closeFiscalReceipt()
{
	this.oleObj.EndFiscalReceipt(true);
}

function OPOS_Dt3541T_cancelFiscalReceipt()
{
	this.oleObj.resetPrinter();
}

function OPOS_Dt3541T_openNonFiscalReceipt()
{
	this.oleObj.BeginNonFiscal();
}

function OPOS_Dt3541T_CloseNonFiscalReceipt()
{
	this.oleObj.EndNonFiscal();
}

function OPOS_Dt3541T_addTextToNonFiscalReceipt(txt)
{
	this.oleObj.PrintNormal(2,txt);
}

function OPOS_Dt3541T_hasError()
{
	return Number(this.oleObj.ResultCode) != 0;
}

function OPOS_Dt3541T_getErrorText()
{
	return "";
}




