include("Objects/DpXMLDomDocument.js");

function DpReport(sID, list)
{
	this.rootPath = rootDirectoryEx() +"modules/reports/scripts/";
	this.userPath = rootDirectoryEx() +"userData/reports/";
	this.xmlDom = new DpXMLDOMDocument();
	this.listInfo = null;
	this.xmlQuery = null;
	this.xmlGrid = null;
	this.xmlMenu = null;
	this.xmlParent = null;	
	this.title = "Звіт|Отчет";	
	this.list = list;
	this.grid = null;
	this.parent = null;
	this.arrFunc = new Array();
	this.arrField = new Array();
	this.arrAsk = new Array();	
	this.arrParent = new Array();
	this.ID = sID;
	this.sys = "";
	this.use = true;
	
	this.load = DpReport_load;
	this.init = DpReport_init;
	this.loadXml = DpReport_loadXml;
	this.create = DpReport_create;	
	this.loadParents = DpReport_loadParents;
	this.fillFields = DpReport_fillFields;
	this.fillFuncs = DpReport_fillFuncs;
	this.loadFilter = DpReport_loadFilter;
	this.ask = DpReport_ask;
	this.getTitle = DpReport_getTitle;
	this.queryInit = DpReport_queryInit;	
	this.gridInit = DpReport_gridInit;
	this.getGrid = DpReport_getGrid;
	this.menuInit = DpReport_menuInit;
	this.setTitle = DpReport_setTitle;
	this.setSys = DpReport_setSys;
	this.setUse = DpReport_setUse;
	this.setID = DpReport_setID;
	this.save = DpReport_save;
	
	this.init(sID);
}

function DpReport_init(sID, list)
{
	if(!sID)
		sID = this.ID;
	this.mainPath = this.rootPath + sID +"/";
	if(isDir(this.userPath + sID))
		this.mainPath = this.userPath + sID +"/";	
	this.mainFile = this.mainPath +"main.js";
	this.listFile = this.mainPath +"list.xml";
	this.scriptFile = this.mainPath +"list.js";
	if(list)
		this.list = list;
}

function DpReport_load()
{	
	this.loadXml();
	this.loadParents();
	if(isFile(this.scriptFile))
		include(this.scriptFile);
	if(isFile(this.mainFile))
		include(this.mainFile);
}

function DpReport_loadXml()
{
	try
	{		
		if(!isFile(this.listFile))
			return false;
		if(!this.xmlDom.load(this.listFile))
			return false;
		this.listInfo = this.xmlDom.getDocumentElement();
		if(!this.listInfo)
			return false;
		if(this.listInfo.getAttribute("text"))
			this.title = this.listInfo.getAttribute("text");
		if(this.listInfo.getAttribute("sys"))
			this.sys = this.listInfo.getAttribute("sys");
		var sUse = this.listInfo.getAttribute("use");
		if(sUse && sUse=="false")
			this.use = false;
		this.xmlParent = this.listInfo.getElementsByTagName("parents")[0];
		if(this.xmlParent && this.xmlParent.getChildNodes().length>0)
			this.parent = this.xmlParent.getChildNodes()[0].getAttribute("ID");
		this.xmlQuery = this.listInfo.getElementsByTagName("query")[0];
		this.xmlGrid = this.listInfo.getElementsByTagName("grid")[0];
		if(this.xmlQuery)
		{
			if(this.xmlQuery.getElementsByTagName("fields")[0])
				this.fields = this.xmlQuery.getElementsByTagName("fields")[0].getText();
			if(this.xmlQuery.getElementsByTagName("from")[0])
				this.from = this.xmlQuery.getElementsByTagName("from")[0].getText();
			if(this.xmlQuery.getElementsByTagName("alias")[0])
				this.alias = this.xmlQuery.getElementsByTagName("alias")[0].getText();
			if(this.xmlQuery.getElementsByTagName("where")[0])
				this.where = this.xmlQuery.getElementsByTagName("where")[0].getText();
			if(this.xmlQuery.getElementsByTagName("whereArr")[0])
				this.whereArr = this.xmlQuery.getElementsByTagName("whereArr")[0].getText();
			if(this.xmlQuery.getElementsByTagName("whereArrI")[0])
				this.whereArrI = this.xmlQuery.getElementsByTagName("whereArrI")[0].getText();
			if(this.xmlQuery.getElementsByTagName("order")[0])
				this.order = this.xmlQuery.getElementsByTagName("order")[0].getText();
			if(this.xmlQuery.getElementsByTagName("sql")[0])	
				this.sql = this.xmlQuery.getElementsByTagName("sql")[0].getText();
		}
		this.xmlMenu = this.listInfo.getElementsByTagName("menu")[0];	
		
		this.fillFields(this.xmlGrid);
		
		var xmlFunc = this.listInfo.getElementsByTagName("functions")[0];
		if(xmlFunc)
			this.fillFuncs(xmlFunc);
		
		var xmlFilter = this.listInfo.getElementsByTagName("filter")[0];
		if(xmlFilter)
			this.loadFilter(xmlFilter);
		return true;
	}
	catch(e)
	{
		return false;
	}
}

function DpReport_loadFilter(xmlFilter)
{
	var arrAsk = xmlFilter.getChildNodes();
	for(var i=0; i<arrAsk.length; i++)
	{
		var eAsk = arrAsk[i];
		var oAsk = new Object();
		oAsk.ID = eAsk.getAttribute("ID");
		oAsk.field = eAsk.getAttribute("field");
		oAsk.cond = eAsk.getAttribute("cond");
		oAsk.mode = eAsk.getAttribute("mode");
		oAsk.text = eAsk.getAttribute("text");
		oAsk.def = eAsk.getAttribute("def");
		oAsk.par1 = eAsk.getAttribute("par1");
		oAsk.par2 = eAsk.getAttribute("par2");
		oAsk.par3 = eAsk.getAttribute("par3");
		this.arrAsk[oAsk.ID] = oAsk;
	}
}

function DpReport_ask()
{
	include("Objects/DpAskEx.js");
	var dpAsk = new DpAskEx();
	this.escape = false;
	var oPar = null;
	for(var sID in this.arrAsk)
	{
		oPar = this.arrAsk[sID];
		dpAsk.add(oPar.mode, oPar.text, sID, oPar.def, oPar.par1, oPar.par2, oPar.par3);
	}
	if(!oPar)
		return true;
	this.dpAsk = dpAsk;
	dpAsk.doAsk();
	if(dpAsk.escape)
		return dpAsk;
	var askWhere = "";
	for(var sID in this.arrAsk)
	{
		var oAsk = this.arrAsk[sID];
		var oPar = dpAsk.get(sID);
		var oVal = oPar;
		if(oPar.getCod)
			oVal = oPar.getCod();
		this.arrAsk[sID].val = oVal;
		if(oAsk.field && oVal)
			askWhere += (askWhere==""? "" : (oAsk.cond? oAsk.cond : " and ")) + oAsk.field +"="+ sqlTo(oVal);
	}
	if(askWhere!="")
	{
		this.askWhere = askWhere;
		this.where += (this.where==""? "" : " and ") +" ("+ askWhere +")";
	}
	return dpAsk;
}

function DpReport_fillFuncs(xmlFunc)
{
	var arrFunc = xmlFunc.getChildNodes();
	for(var i=0; i<arrFunc.length; i++)
	{
		var eFunc = arrFunc[i];
		var oFunc = new DpReportFunc();
		oFunc.name = eFunc.getAttribute("name");
		oFunc.sql = eFunc.getAttribute("sql");
		oFunc.par = eFunc.getAttribute("par");
		oFunc.text = eFunc.getAttribute("text");
		oFunc.fullName = eFunc.getAttribute("fullname");
		oFunc.use = eFunc.getAttribute("use");
		oFunc.script = eFunc.getAttribute("script");		
		var arrPar = eFunc.getChildNodes();
		for(var n=0; n<arrPar.length; n++)
		{
			var ePar = arrPar[n];
			var oPar = new DpReportPar();
			oPar.name = ePar.getAttribute("name");
			oPar.val = ePar.getAttribute("val");
			oPar.text = ePar.getAttribute("text");
			oFunc.arrPar[oFunc.arrPar.length] = oPar;
		}
		this.arrFunc[oFunc.name] = oFunc;
	}
}

function DpReport_fillFields(xmlGroup, oGroup)
{
	var arrCol = xmlGroup.getChildNodes();
	for(var i=0; i<arrCol.length; i++)
	{
		var eCol = arrCol[i];
		if(!eCol)
			continue;
		var oField = new DpReportField();
		if(eCol.getNodeName()=="group")
		{			
			oField.isGroup = true;
			oField.text = eCol.getAttribute("text");
			this.fillFields(eCol, oField);
			this.arrField[this.arrField.length] = oField;			
		}
		else if(eCol.getNodeName()=="field")
		{
			oField.ID = this.arrField.length;
			oField.name = eCol.getAttribute("field");
			oField.width = eCol.getAttribute("width");
			oField.text = eCol.getAttribute("text");
			oField.format = eCol.getAttribute("format");
			oField.func = eCol.getAttribute("func");
			oField.dpobject = eCol.getAttribute("dpobject");
			oField.dpobjfld = eCol.getAttribute("dpobjfld");
			oField.attr = eCol.getAttribute("attr");
			oField.image = eCol.getAttribute("image");			
			oField.color = eCol.getAttribute("color");
			if(xmlGroup.getNodeName()=="group")
				oField.group = xmlGroup.getAttribute("text");			
			this.arrField[this.arrField.length] = oField;			
		}
		if(oGroup)
			oGroup.arrField[oGroup.arrField.length] = oField;		
	}
}

function DpReport_loadParents(xmlParent)
{
	if(!xmlParent)
		xmlParent = this.xmlParent;
	if(!xmlParent)
		return;
	var arrParent = xmlParent.getChildNodes();
	for(var i=0; i<arrParent.length; i++)
	{
		var eParent = arrParent[i];
		var sID = eParent.getAttribute("ID");
		var oReport = new DpReport(sID);
		oReport.loadXml();
		this.arrParent[this.arrParent.length] = oReport;
		if(isFile(oReport.mainFile))
			include(oReport.mainFile);
		for(var n=0; n<oReport.arrFunc.length; n++)
		{
			var oFunc = oReport.arrFunc[n];
			this.arrFunc[oFunc.name] = oFunc;
		}
		var parXmlParent = oReport.listInfo.getElementsByTagName("parents")[0];
		if(parXmlParent)
			this.loadParents(parXmlParent);
	}	
}

function DpReport_getTitle()
{
	return UR(this.title);
}

function DpReport_queryInit()
{
	var sSQL = "";
	for(var i=0; i<this.arrField.length; i++)
	{
		var oField = this.arrField[i];
		if(oField && oField.func && this.arrFunc[oField.func]!=null)
		{
			var oFunc = this.arrFunc[oField.func];
			if(oFunc.sql)
			{
				var sField = oField.name;
				sSQL += ", ("+ oFunc.sql +") as "+ sField;
			}
			if(oFunc.script)
				include(oFunc.script);			
		}
	}
	if(sSQL!="")
	{
		var sTmpTbl = getTmpTableName();
		var alias = this.alias;
		if(!alias)
			alias = "t";
		var sWhere = "";
		if(this.where)
			sWhere = " where "+ this.where;
		//if(this.askWhere)
		//	sWhere += " and ("+ this.askWhere +")";
		ExecuteSQL("select "+ alias +".*"+ sSQL +" into "+  sTmpTbl +" from "+ this.from +" as "+ alias + sWhere);
		this.from = sTmpTbl;		
	}
		
	if(this.sql)
	{
		this.list.tbl = OpenTable(this.sql);
	}
	else if(this.from)
	{
		this.list.qrySet("From", "^"+ this.from);
	}
	else
	{
		return false;
	}
	
	if(this.fields)
		this.list.qryFields = this.fields;
	if(this.where)
		this.list.qryWhere = this.where;
	if(this.order)
		this.list.qryOrder = Array(this.order);
	if(this.whereArr)
		this.list.qryWhereArr = Array(this.whereArr);
	if(this.whereArrI)
		this.list.qryWhereArrI = Number(this.whereArrI);
	return true;
}

function DpReport_gridInit(oGrid)
{
	if(!this.xmlGrid)
		return false;
	this.grid = oGrid;
	this.grid.parseXML(this.xmlGrid.xmlNode);
	this.grid.build();
	this.grid.saveFormat(false);
	return true;
}

function DpReport_getGrid()
{
	return this.grid;
}

function DpReport_menuInit()
{
	if(this.xmlMenu)
	{
		var arrMenu = this.xmlMenu.getChildNodes();
		for(var i=0; i<arrMenu.length; i++)
		{
			var eMenu = arrMenu[i];
			var id = eMenu.getAttribute("ID");
			var text = eMenu.getAttribute("text");
			this.grid.AddMenuItem(id, text);
		}
	}	
}

function DpReportField()
{
	this.ID = "";
	this.name = "";
	this.width = "";
	this.text = "";
	this.func = "";
	this.format = "";
	this.dpobject = "";
	this.dpobjfld = "";
	this.image = "";
	this.attr = "";
	this.color = "";
	this.group = "";
	this.isGroup = false;
	this.arrField = new Array();
}

function DpReportFunc()
{
	this.name = "";
	this.par = "";	
	this.fullName = "";
	this.use = "";
	this.text = "";
	this.sql = "";
	this.script = "";
	this.arrPar = new Array();
}

function DpReportPar()
{
	this.name = "";
	this.val = "";	
	this.text = "";
}

function DpReport_setTitle(txt)
{
	this.title = txt;
}

function DpReport_setSys(sys)
{
	this.sys = sys;
}

function DpReport_setUse(use)
{
	this.use = use;
}

function DpReport_setID(sID)
{
	this.ID = sID;
}

function DpReport_create()
{
	this.mainPath = this.userPath + this.ID +"/";	
	this.mainFile = this.mainPath +"main.js";
	this.listFile = this.mainPath +"list.xml";
	this.scriptFile = this.mainPath +"list.js";	
	if(!this.xmlDom)
		this.xmlDom = new DpXMLDOMDocument();
	if(!this.listInfo)
	{
		this.listInfo = this.xmlDom.createElement("list");
		this.xmlDom.appendChild(this.listInfo);
	}
	if(!this.xmlGrid)
	{
		this.xmlGrid = this.xmlDom.createElement("grid");
		this.listInfo.appendChild(this.xmlGrid);
	}
}

function DpReport_save()
{
	this.create();
	if(!isDir(this.mainPath))
		createDirectory(this.mainPath);		
	this.listInfo.setAttribute("text", this.title);
	this.listInfo.setAttribute("sys", this.sys);
	this.listInfo.setAttribute("use", this.use);
	if(this.parent && String(this.parent).trim()!="")
	{
		var oParent = new DpReport(this.parent);
		if(isFile(oParent.scriptFile) && !isFile(this.scriptFile))
			copyFile(oParent.scriptFile, this.scriptFile);		
		if(!this.xmlParent)
		{
			this.xmlParent = this.xmlDom.createElement("parents");
			var eParent = this.xmlDom.createElement("parent");
			eParent.setAttribute("ID", this.parent);
			this.xmlParent.appendChild(eParent);
			this.listInfo.appendChild(this.xmlParent);
		}
	}
	if(!this.xmlQuery)
	{
		this.xmlQuery = this.xmlDom.createElement("query");
		if(this.from)
		{
			var eFrom = this.xmlDom.createElement("from");
			eFrom.setText(this.from);
			this.xmlQuery.appendChild(eFrom);
		}
		this.listInfo.appendChild(this.xmlQuery);
	}	
	var xmlFile = this.userPath + this.ID +"/list.xml";
	this.xmlDom.save(xmlFile);
}
