include("Objects/DpXMLDomDocument.js");
include("reports:DpReport.js");

var tbl = extPar.m_pTable;
var mode = extPar.mode;
var oReport = new DpReport();
var isMain = tbl.getValue("FMAIN")==true;
var arrTbl = null;
var colID = 1;
var TREE_ITEM = 3;
var arrFld = new Object();

function Load()
{
	FNAME.mask = strRepl("&", 255);
	FTEXT.mask = strRepl("&", 255);
	
	fillSys(FSYS);

	if(mode=="ADD")
	{
		FUSE.checked = true;		
	}
	else
	{
		FNAME.value = tbl.getValue("FID");
		FTEXT.value = UR(tbl.getValue("FTXT"));
		FSYS.value = tbl.getValue("FSYS");		
		FUSE.checked = tbl.getValue("FUSE")==true;		
				
		oReport.init(FNAME.value, list);
		oReport.loadXml();		
		if(oReport.from)
			FTABLE.value = oReport.from;		
		if(oReport.parent)
			FPARENT.value = oReport.parent;
		if(String(FTABLE.value).trim()!="")
			Disable(FTABLE);
		Disable(FPARENT);
	}
	if(mode=="EDIT")
	{
		Disable(FNAME);
		if(isMain)
		{
			Disable(FTEXT);			
			Disable(FSYS);
			Disable(FUSE);
			Disable(btnOK);
		}
	}
	if(mode=="COPY")
	{
		FPARENT.value = FNAME.value;
		FNAME.value = tbl.getValue("FID") +"_COPY";		
	}
	loadTree();
	loadMenu();
	
	this.check_name = check_name;
	FNAME.setModifyHandler(this, "check_name");
	setValid(FNAME, valid_name);
	
	this.parentSel = parentSel;
	setButton(FPARENT, this, "parentSel");
	setButton(FTEXT, this, "parentSel");
	
	this.sourceSel = sourceSel;
	setButton(FTABLE, this, "sourceSel");
	setValid(FTABLE, valid_source);
}

function check_name()
{
	var sName = String(FNAME.value).trim().toUpperCase();
	if(sName=="" || !(/^\s*[A-Za-z_][A-Za-z0-9_]*\s*$/.test(sName)))
	{
		FNAME.setBackground(0xFAAAAA);
		var sMsg = UR("Не коректне значення мітки!|Не корректное значение метки!");
		FNAME.showErr(sMsg);
		return false;
	}
	else
	{
		if(mode!="EDIT")
		{
			var oSnap = getSnap("select FTXT from "+ tbl.getTableName() +" where UPPER(FID)="+ sqlTo(sName));
			if(oSnap)
			{
				FNAME.setBackground(0xFAAAAA);
				var sMsg = UR("Звіт з такою міткою вже існує!|Отчет с такой меткой уже существует!");
				FNAME.showErr(sMsg);
				return false;
			}
		}
		FNAME.setBackground(0xFFFFFF);
	}
	return true;
}

function valid_name()
{
	var sName = String(FNAME.value).trim().toUpperCase();	
	FNAME.value = sName;
	return check_name();
}

function valid_source()
{
	var sSource = String(FTABLE.value).trim();
	if(sSource=="")
	{
		var sMsg = UR("Потрібно вказати джерело!|Нужно указать источник!");
		FTABLE.showErr(sMsg);
		return false;
	}
}

function loadTree()
{
	this.treeMenuInit = treeMenuInit;
	this.treeMenuRun = treeMenuRun;
	Tree.loadMenuHandler(this, "treeMenuInit");
	Tree.selectMenuHandler(this, "treeMenuRun");
	
	this.treeDrop = treeDrop;
	this.treeDrag = treeDrag;
	Tree.setDropHandler(this, "treeDrop");
	Tree.setDragHandler(this, "treeDrag");
	
	Tree.addColumn("text", UR("Назва|Название"), 280);
	Tree.addColumn("field", UR("Значення|Значение"), 250);
	Tree.addColumn("width", UR("Ширина|Ширина"), 80);
	
	this.treeCanEdit = new Function ("return false");
	Tree.setCanEditHandler(this, "treeCanEdit");
	
	Tree.setAutoResizeCol("text");
	
	fillTree();
}

function fillTree()
{
	Tree.removeAll();
	if(!oReport || !oReport.xmlGrid)
		return;
	var cols = oReport.xmlGrid.getChildNodes();
	for(var i=0; i<cols.length; i++) 
	{
		var col = cols[i];
		var sNode = String(col.getNodeName());
		if(inList(sNode, "conditions", "bolds", "colors"))
			continue;
		if(sNode=="field")
		{
			var sText = col.getAttribute("text");
			var sWidth = col.getAttribute("width");
			var sFld = col.getAttribute("field");
			var image = col.getAttribute("image");
			var sID = sFld + (colID++);
			Tree.addItem("0", sID, UR(sText), TREE_ITEM);
			Tree.setValue(sID, "field", sFld);
			Tree.setValue(sID, "width", sWidth);
			var ti = Tree.getItem(sID);
			ti.setData("type", "field");
			ti.setData("field", sFld);
			ti.setData("width", sWidth);
			ti.setData("xml", col);			
			ti.setData("parentxml", oReport.xmlGrid);
			if(image)
				ti.setImage(lpProxy.getImage(rootDirectoryEx() +"icons/"+ image +".gif"));
			arrFld[sFld] = sText;
			var func = col.getAttribute("func");
			if(func)
				arrFld[func] = sText;
		}
		else if (sNode=="group")
		{
			var sID = "GRP"+ (colID++);
			var sText = col.getAttribute("text");
			Tree.addItem("0", sID, UR(sText));
			var ti = Tree.getItem(sID);
			ti.setData("type", "group");
			ti.setData("xml", col);			
			ti.setData("parentxml", oReport.xmlGrid);
			parseFields(col, sID);
		}
		else if(sNode=="page" || sNode=="prefix")
		{
			parseFields(col, "0");
		}		
	}
	Tree.setExpanded(true);
}

function parseFields(par, sParID)
{
	var cols = par.getChildNodes();	
	for(var i=0; i<cols.length; i++) 
	{		
		var col = cols[i];
		var sNode = String(col.getNodeName());
		if(sNode=="field")
		{
			var sFld = col.getAttribute("field"); 
			var sID = sFld + (colID++);			
			var sWidth = col.getAttribute("width");
			var sText = col.getAttribute("text");
			var image = col.getAttribute("image");
			Tree.addItem(sParID, sID, UR(sText), TREE_ITEM);
			Tree.setValue(sID, "field", sFld);
			Tree.setValue(sID, "width", sWidth);
			var ti = Tree.getItem(sID);
			ti.setData("type", "field");
			ti.setData("xml", col);						
			ti.setData("parentxml", par);
			if(image)
				ti.setImage(lpProxy.getImage(rootDirectoryEx() +"icons/"+ image +".gif"));
			arrFld[sFld] = sText;
			var func = col.getAttribute("func");
			if(func)
				arrFld[func] = sText;
		}
		else if(sNode=="group")
		{
			var sID = "GRP" + (colID++);
			var sText = col.getAttribute("text");
			Tree.addItem(sParID, sID, UR(sText));
			var ti = Tree.getItem(sID);
			ti.setData("type", "group");
			ti.setData("xml", col);
			ti.setData("parentxml", par);			
			parseFields(col, sID);
		}	
	}
}

function treeDrag(sFunc, obj)
{
	if(sFunc=="dragSetData")
	{
		var curItem = Tree.getSelected();
		obj.data = curItem;
	}
}

function treeDrop(sFunc, obj)
{
	if(!obj.item || sFunc=="dragEnter") 
		return;
	
	var sID = obj.item? String(obj.item.getData()): "";
	var curItem = Tree.getItem(sID);
	if(sFunc=="drop")
	{
		var xml = obj.item.getData("xml")
		var itemFrom = Tree.getItem(obj.data);
		var xmlFrom = itemFrom.getData("xml")
		var xmlNew = xmlFrom.cloneNode(true);
		var xmlParFrom = itemFrom.getData("parentxml");
		
		if(obj.item.getData("type")=="group" || obj.item.getData("type")=="grid")
		{
			xml.appendChild(xmlNew);			
		}
		else
		{
			var xmlParTo = obj.item.getData("parentxml");
			xmlParTo.insertBefore(xmlNew, xml);
		}
		xmlParFrom.removeChild(xmlFrom);
		fillTree();
	}
	
	if(sFunc=="dragOver")
	{
		if(!obj.item)
		{
			obj.detail = 0;
			return;
		}		
		obj.detail = 1;		
		return;
	}
}

function treeMenuInit()
{
	if(isMain && (mode=="EDIT" || mode=="VIEW"))
		return;
	var sID = String(Tree.getSelected());
	var curItem = Tree.getItem(sID);	
	
	Tree.AddMenuItem("ADDGRP", "Додати групу|Добавить групу");	
	Tree.AddMenuItem("ADD", "Додати колонку|Добавить колонку");		
	if(curItem)
	{
		Tree.AddMenuItem("EDIT", "Редагувати|Редактировать");
		if(sID!="0")
			Tree.AddMenuItem("DEL",  "Вилучити|Удалить");
	}
}

function treeMenuRun(sMenuID, obj)
{
	if(isMain && (mode=="EDIT" || mode=="VIEW"))
		return;
	var curItem = Tree.getItem(Tree.getSelected());
	var sCurrId = Tree.getSelected();
	var xmlDom = oReport.xmlDom;
	var xml = null;	
	if(!oReport.xmlGrid)
		oReport.create();
	if(curItem)
		xml = curItem.getData("xml");
	else
		xml = oReport.xmlGrid;
	var par = new Object();
	par.oReport = oReport;
	par.arrFld = arrFld;
	par.mode = sMenuID;
	par.grid_menu = grid_menu;
	par.source = FTABLE.value;
	switch(sMenuID)
	{
	case "ADDGRP":		
		var text = input(UR("Назва|Название"), UR("Група|Группа"), "", 250);
		if(!text)
			return;
		var xmlGrp = xmlDom.createElement("group");
		xmlGrp.setAttribute("text", text);
		if(xml.getNodeName()=="group" || xml.getNodeName()=="grid")
			xml.appendChild(xmlGrp);
		else
			xml.getParentNode().appendChild(xmlGrp);
		fillTree();
		break;
		
	case "ADD":		
		par.xml = xmlDom.createElement("field");
		showWindow("reports:e_report_col.xml", SW_MODAL, par);
		if(par.escape)
			return;
		if(xml.getNodeName()=="group" || xml.getNodeName()=="grid")
			xml.appendChild(par.xml);
		else
			xml.getParentNode().appendChild(par.xml);
		fillTree();
		break;
	
	case "EDIT":
	case "DOUBLECLICK":
		var xml = curItem.getData("xml");
		var type = curItem.getData("type");
		if(type=="group")
		{
			var txt = xml.getAttribute("text");
			var text = input(UR("Назва|Название"), UR("Група|Группа"), txt, 250);
			if(text)
			{
				xml.xmlNode.setAttribute("text", text);
				curItem.setText(UR(text));
			}
		}
		else if(type=="field")
		{
			par.mode = "EDIT";
			par.xml = xml;
			showWindow("reports:e_report_col.xml", SW_MODAL, par);
			if(!par.escape)
				fillTree();
		}
		break;
		
	case "DEL":
		var xml = curItem.getData("xml");
		var parxml = curItem.getData("parentxml");
		var txt = UR(xml.getAttribute("text"));
		if(!confirm(UR("Вилучити колонку |Удалить колонку ") +"'"+ txt +"'?"))
			return;
		Tree.removeItem(Tree.getSelected());
		parxml.removeChild(xml);
		delField(xml);		
		break;
	}
}

function delField(xml)
{
	var sFld = xml.getAttribute("field");
	arrFld[sFld] = null;
	if(xml.getNodeName()=="group")
	{
		var arrChild = xml.getChildNodes();
		for(var i=0; i<arrChild.length; i++)
			delField(arrChild[i]);		
	}
}

function loadMenu()
{
	var tblMenu = createObjectTable();
	if(oReport && oReport.xmlMenu)
	{
		var arrMenu = oReport.xmlMenu.getChildNodes();
		for(var i=0; i<arrMenu.length; i++)
		{
			tblMenu.AddNew();
			tblMenu.setValue("FWID", i);
			var eMenu = arrMenu[i];
			tblMenu.setValue("FID", eMenu.getAttribute("ID"));
			tblMenu.setValue("FTEXT", UR(eMenu.getAttribute("text")));
			tblMenu.Update();
		}
	}
	grid_menu.setTable(tblMenu);
	grid_menu.build();
}

function fillSys(oCtrl)
{
	oCtrl.addItem("COM", UR("Усі|Все"));
	var orgMngr = lpProxy.getOrgManager();
	var sysList = orgMngr.getSysList();
	for(var i=0; i<sysList.size(); i++)
	{
		var sys = sysList.get(i);			
		if(sys)
		{
			var sLabel = sys.label;
			var sName = sys.name;
			var img = sys.iconFile;
			oCtrl.addItem(sLabel, sName);
		}
	}
	oCtrl.value = orgMngr.getSys();
}

function parentSel()
{
	var par = new Object();
	par.use = false;
	par.ret = new Object();
	par.ret.FTXT = "";
	par.ret.FID = "";
	par.ret.FSYS = "";	
	showWindow("reports:list.xml", SW_MODAL, par);
	if(par.escape)
		return;
	if(String(FTEXT.value).trim()=="")
		FTEXT.value = par.ret.FTXT;
	FSYS.value = par.ret.FSYS;
	FPARENT.value = par.ret.FID;
	
	oReport = new DpReport(FPARENT.value, list);
	oReport.loadXml();
	
	FTABLE.value = oReport.from;
	
	fillTree();
	loadMenu();
}

function sourceSel()
{
	var sTmpTbl = "TMP_STRU";
	if(!arrTbl)
	{		
		var sSQL = "create table "+ sTmpTbl 
					+" (FTABLE "+ sqlType("TEXT") 
					+", FSYS "+ sqlType("TEXT")
					+", FTXT "+ sqlType("TEXT")
					+", FPATTERN "+ sqlType("TEXT")
					+", FWID "+ sqlType("COUNTER") 
					+")"
		ExecuteSQL(sSQL, false);
		ExecuteSQL("delete from "+ sTmpTbl, false);
		
		arrTbl = getStruTables();
		for(var i=0; i<arrTbl.length; i++)
		{
			if(!arrTbl[i])
				continue;
			var sTable = String(arrTbl[i].table);
			if(sTable.indexOf("%LD")!=-1)
				continue;
			var m = new Object();
			m.FTABLE = arrTbl[i].table;
			m.FSYS = arrTbl[i].sys;
			m.FPATTERN = arrTbl[i].pattern;
			m.FTXT = UR(arrTbl[i].rem);
			updateTable(sTmpTbl, m, true);
		}
		
		var arrView = getStruViews();
		for(var i=0; i<arrView.length; i++)
		{
			if(!arrView[i])
				continue;
			var m = new Object();
			m.FTABLE = arrView[i].name;
			m.FTXT = UR(arrView[i].rem);
			updateTable(sTmpTbl, m, true);
		}
	}
	
	var par = new Object();
	par.tbl = String(sTmpTbl);
	par.order = "FTABLE";
	par.noSel = true;
	par.title = UR("Джерела|Источники");
	par.ret = new Object();		
	par.ret.FTABLE = "";
		
	par.cells = new Object();	
	par.cells[1] = new Object();
	par.cells[1].name = "FTABLE";
	par.cells[1].width = 20;
	par.cells[1].text = UR("Назва|Название");
	
	par.cells[2] = new Object();
	par.cells[2].name = "FTXT";
	par.cells[2].width = 20;
	par.cells[2].text = UR("Коментар|Комментарий");
			
	showWindow("selection.xml", SW_MODAL, par);
	if(par.escape)
		return;
	
	FTABLE.value = "^"+ par.ret.FTABLE;
}

function onSave()
{
	var m = new Object();
	if(mode=="EDIT")
		m.FWID = tbl.getValue("FWID");
	else
		m.FWID = GetUID();
	m.FID = FNAME.value;
	m.FTXT = FTEXT.value;
	m.FSYS = FSYS.value;
	m.FUSE = FUSE.checked;
	UpdateTable(tbl.getTableName(), m, mode!="EDIT");
	
	if(!oReport)
		oReport = new DpReport(FNAME.value);	
	oReport.setID(FNAME.value);
	oReport.setTitle(FTEXT.value);
	oReport.setSys(FSYS.value);
	oReport.setUse(FUSE.checked);
	oReport.from = FTABLE.value;
	oReport.parent = FPARENT.value;
	oReport.save();
}

include("sys/DpBaseDlg.js");