include("reports:DpReport.js");

var xml = extPar.xml;
var mode = extPar.mode;
var oReport = extPar.oReport;
var arrFld = extPar.arrFld;
var arrCol = new Object();
var image = "";

function Load()
{
	FCOLOR.mask = "###";
	if(mode=="EDIT")
	{
		FTEXT.value = UR(xml.getAttribute("text"));
		FFIELD.value = xml.getAttribute("field");
		FWIDTH.value = Number(xml.getAttribute("width"));
		FORMAT.value = xml.getAttribute("format");
		setImage(xml.getAttribute("image"));		
		var sAttr = xml.getAttribute("attr");
		if(String(sAttr).trim()=="btn")
		{
			ISBUTTON.checked = true;
			var sCommand = String(FFIELD.value);
			if(sCommand.startsWith("='"))
				FBTNID.value = sCommand.substring(2, sCommand.length-1);
		}
		var nColor = xml.getAttribute("color");
		if(nColor)
		{
			FCOLOR.value = Number(nColor);
			color_valid();
		}
	}
	this.fieldSel = fieldSel;
	setButton(FFIELD, this, "fieldSel");
	setButton(FTEXT, this, "fieldSel");
	setButton(BTNIMAGE, imageSel);
	
	setValid(ISBUTTON, isbutton_valid);
	isbutton_valid();
	
	this.menuSel = menuSel;
	setButton(FBTNID, this, "menuSel");
	setValid(FBTNID, btncomand_valid);	
	
	this.color_valid = color_valid;
	this.color_select = color_select;
	FCOLOR.setModifyHandler(this, "color_valid");		
	setButton(FCOLOR, this, "color_select");
}

function onSave()
{
	xml.setAttribute("text", FTEXT.value);
	xml.setAttribute("field", FFIELD.value);
	xml.setAttribute("width", FWIDTH.value);
	var format = String(FORMAT.value).trim();
	xml.setAttribute("format", format);
	if(ISBUTTON.checked)
		xml.setAttribute("attr", "btn");
	else if(String(xml.getAttribute("attr"))=="btn")
		xml.setAttribute("attr", "");
	if(image && image!="")
		xml.setAttribute("image", image);
	var nColor = FCOLOR.value;
	if(Number(nColor) || xml.getAttribute("color"))
		xml.setAttribute("color", nColor);
}

function fillFields(report, tbl)
{
	var arrField = report.arrField;	
	for(var i=0; i<arrField.length; i++)
	{		
		var fld = arrField[i];
		if(!fld || fld.isGroup || arrFld[fld.name]!=null || arrCol[fld.name]!=null)
			continue;		
		arrCol[fld.name] = fld.text;
		if(fld.func)
			arrCol[fld.func] = fld.text;
		tbl.AddNew();
		tbl.setValue("FWID", tbl.recordCount+1);
		var text = UR(fld.text);
		if(fld.group)
			text = UR(fld.group) +": "+ text;
		tbl.setValue("FTEXT", text);
		tbl.setValue("FFIELD", fld.name);
		//tbl.setValue("FFUNC", fld.func);
		tbl.setValue("FWIDTH", fld.width);
		tbl.setValue("FFORMAT", fld.format);		
		tbl.setValue("FCOLOR", fld.color);
		tbl.setValue("FATTR", fld.attr);
		tbl.setValue("FIMAGE", fld.image);		
		tbl.setValue("FDPOBJECT", fld.dpobject);
		tbl.setValue("FDPOBJFLD", fld.dpobjfld);
		tbl.Update();
	}
	
	var arrFunc = report.arrFunc;
	for(var sFanc in arrFunc)
	{		
		var fld = arrFunc[sFanc];
		if(!fld || arrFld[fld.name]!=null || arrCol[fld.name]!=null)
			continue;
		//trace(fld.name +" > "+ arrFld[fld.name])
		arrCol[fld.name] = fld.text;
		tbl.AddNew();
		tbl.setValue("FWID", tbl.recordCount+1);
		tbl.setValue("FTEXT", UR(fld.text));
		tbl.setValue("FFUNC", fld.name);
		var func = fld.name;
		if(fld.use && fld.use!="")
		{
			func = fld.use;
		}
		else if(report.arrFunc[fld.name])
		{
			var oFunc = report.arrFunc[fld.name];
			var arrPar = oFunc.arrPar;
			if(arrPar.length>0)
			{
				var sPar = "";
				for(var n=0; n<arrPar.length; n++)
				{
					var oPar = arrPar[n];
					if(oPar.val)
						sPar += ", "+ oPar.val;
					else if(oPar.text)
						sPar += ", '"+ UR(oPar.text) +"'";
					else if(oPar.name)
						sPar += ", "+ oPar.name;
				}
				if(sPar!="")
					sPar = sPar.substring(2);
				func += "("+ sPar +")";
			}
			else if(oFunc.fullName!="")
			{
				func = oFunc.fullName;
			}			
		}
		arrCol["="+ func] = fld.text;
		tbl.setValue("FFIELD", "="+ func);
		tbl.Update();
	}
	
	if(report.parent)
	{
		var oParent = new DpReport(report.parent);
		oParent.loadXml();
		fillFields(oParent, tbl);
	}
}

function fillTblFields(tbl)
{
	if(!extPar.source)
		return;
	var tblSource = OpenTable("select * from "+ extPar.source +" where 1<>1");
	var arrFlds = tblSource.getFieldsInfo();
	for(var i=0; i<arrFlds.length; i++)
	{
		var fld = arrFlds[i];
		tbl.AddNew();
		tbl.setValue("FWID", tbl.recordCount+1);
		tbl.setValue("FFIELD", fld.getName());
		tbl.Update();
	}
}

function fieldSel()
{
	var tbl = createObjectTable();
	arrCol = new Object();
	fillFields(extPar.oReport, tbl);
	fillTblFields(tbl);
	
	var par = new Object();
	par.tbl = tbl;
	par.noSel = true;
	par.title = UR("Виберіть колонку|Виберите колонку");
	par.ret = new Object();
	par.ret.FFIELD = "";
	par.ret.FTEXT = "";
	par.ret.FWIDTH = "";
	par.ret.FFORMAT = "";
	par.ret.FDPOBJECT = "";
	par.ret.FDPOBJFLD = "";
	par.ret.FCOLOR = "";
	par.ret.FATTR = "";
	par.ret.FIMAGE = "";
		
	par.cells = new Object();
	par.cells[1] = new Object();
	par.cells[1].name = "FTEXT";
	par.cells[1].width = 20;
	par.cells[1].text = UR("Колонка|Колонка");
	
	par.cells[2] = new Object();
	par.cells[2].name = "FFIELD";
	par.cells[2].width = 20;
	par.cells[2].text = UR("Значення|Значение");
			
	showWindow("selection.xml", SW_MODAL, par);
	if(par.escape)
		return;
	
	FFIELD.value = par.ret.FFIELD;
	if(String(FTEXT.value).trim()=="")
		FTEXT.value = par.ret.FTEXT;
	if(Number(par.ret.FWIDTH))
		FWIDTH.value = par.ret.FWIDTH;
	if(par.ret.FFORMAT)
		FFORMAT.value = par.ret.FFORMAT;
	if(Number(par.ret.FCOLOR))
		FCOLOR.value = par.ret.FCOLOR;
	if(String(par.ret.FATTR).trim()=="btn")
		ISBUTTON.checked = true;
	if(par.ret.FIMAGE)
	{
		setImage(par.ret.FIMAGE);
		image = par.ret.FIMAGE;
	}
}

function imageSel()
{
	var sMsg = UR("Вибір іконки|Выбор иконки");
	var sPath = rootDirectoryEx() +"icons/";
	var sImage = askFile("SAVE", sPath, new Array("*.gif"), null, sMsg);
	if(sImage)
	{
		BTNIMAGE.setImage(sImage);
		var file = new java.io.File(sImage);
		sImage = file.getName();
		if(sImage.indexOf(".")!=-1)
			image = sImage.substring(0, sImage.indexOf("."));		
	}
}

function isbutton_valid()
{
	if(ISBUTTON.checked)
	{
		//GRMENU.setVisible(true);
		Enable(FBTNID);
		FBTNID.setMessage(UR("Виберіть команду|Виберите команду"));
	}
	else
	{
		//GRMENU.setVisible(false);
		Enable(FBTNID, false);
		FBTNID.setMessage("");
	}
}

function menuSel()
{
	/*
	var tbl = createObjectTable();
	if(!fillMenu(tbl))
		return;
	*/
	var par = new Object();
	par.tbl = extPar.grid_menu.getTable();
	par.noSel = true;
	par.title = UR("Виберіть команду|Виберите команду");
	par.ret = new Object();		
	par.ret.FID = "";
	par.ret.FTEXT = "";
		
	par.cells = new Object();	
	par.cells[1] = new Object();
	par.cells[1].name = "FID";
	par.cells[1].width = 20;
	par.cells[1].text = UR("Мітка|Метка");
	
	par.cells[2] = new Object();
	par.cells[2].name = "FTEXT";
	par.cells[2].width = 20;
	par.cells[2].text = UR("Назва|Название");
			
	showWindow("selection.xml", SW_MODAL, par);
	if(par.escape)
		return;
	
	FBTNID.value = par.ret.FID;
	FFIELD.value = "='"+ par.ret.FID +"'";
}

function fillMenu(tbl)
{
	if(!oReport || !oReport.xmlMenu)
		return false;
	var arrMenu = oReport.xmlMenu.getChildNodes();
	if(arrMenu.length==0)
		return false;
	for(var i=0; i<arrMenu.length; i++)
	{
		var eMenu = arrMenu[i];
		tbl.AddNew();
		tbl.setValue("FWID", i);		
		tbl.setValue("FID", eMenu.getAttribute("ID"));
		tbl.setValue("FTEXT", UR(eMenu.getAttribute("text")));
		tbl.Update();
	}	
	return true;
}

function btncomand_valid()
{
	if(!ISBUTTON.checked)
		return;
	var sCommand = String(FBTNID.value).trim();
	if(sCommand!="")
		FFIELD.value = "='"+ sCommand +"'";
}

function color_valid()
{
	try
	{
		var nColor = java.lang.Integer(FCOLOR.value);
		var rgb = extPar.grid_menu.colorLevel(nColor, false);		
		var color = org.eclipse.swt.graphics.Color(null, rgb);
		FCOLOR.setBackground(color);		
	}
	catch(e)
	{
		trace(e)
	}
}

function color_select()
{
	var par = new Object();
	par.maxCol = 26;
	par.ret = new Object();
	par.ret.FTYPE = 0;
	showWindow("colors.js", SW_MODAL, par);
	if(par.escape)
		return false;
	var nColor = Number(par.ret.FTYPE);
	FCOLOR.value = nColor;
	color_valid();
}

function setImage(sImage)
{
	if(!sImage || String(sImage).trim()=="")
		return false;
	sImage = String(sImage).trim();	
	if(sImage.indexOf(".")==-1)
		sImage += ".gif";
	sImage = rootDirectoryEx() +"icons/"+ sImage;
	BTNIMAGE.setImage(sImage);	
}

include("sys/DpBaseDlg.js");