//создает текстовый файл для отсылки смс программой Ozeki Message Server
//	sMsg - текст сообщения
//	sTel - телефон или перечень телефонов указанных через запятую
//	bNoAlert - флаг отключения алертов
//	lang - язык для транслитерации: 'uk','ukr','ua','ukrainian' - украинский, в остальных случаях русский
function sendSmsMsgOzeki(sMsg, sTel, bNoAlert, lang)
{
	sMsg = translit(sMsg, lang);
	var curTime = Number(new Date());
	var FileName = "sms"+curTime+".sml";
	var FileLockName = FileName+".lock";
	var dirOut = getPar("SMS_OZEKI_OUT");
	if(!dirOut || allt(dirOut)=="")
	{
		var msg = ru("Не указан параметр в меню '","Не вказаний параметр в меню '")+getParItemPath("SMS_OZEKI_OUT",true)+"'";
		if(bNoAlert)
			trace("ERROR>>"+msg);
		else
			alert(msg,1);
		return false;
	}
	if(!isDir(dirOut))
	{
		var msg = ru("Не существующая директория указана в меню '","Не існуюча директорія вказана в меню '")+getParItemPath("SMS_OZEKI_OUT",true)+"'";
		if(bNoAlert)
			trace("ERROR>>"+msg);
		else
			alert(msg,1);
		return false;
	}
	var sSMS = "";
	var arTel = sTel.split(",");
	for(var i=0; i<arTel.length; i++)
	{
		var tel = new java.lang.String(arTel[i]);
		tel = String(tel.replaceAll("-","").replaceAll(" ",""));//удаляем пробелы и дефисы
		if(isNaN(tel) || tel.length!=10)
		{
			var msg = ru("Некорректный мобильный номер телефона: ","Некоректний мобільний номер телефону: ")+tel;
			if(bNoAlert)
				trace("ERROR>>"+msg);
			else
				alert(msg,1);
			return false;
		}
		tel = "+38"+tel;
		sSMS += tel+" "+sMsg+(arTel.length>1 && i<arTel.length-1?"\r\n":"");
	}
	var sFile = dirOut+"/"+FileName;
	var sFileLock = dirOut+"/"+FileLockName;
	//если файл уже существует, тогда генерируем новое имя
	var k = 0;
	while(isFile(sFile) || isFile(sFileLock))
	{
		FileName = "sms_"+GetUID()+".sml";
		FileLockName = FileName+".lock";
		sFile = dirOut+"/"+FileName;
		sFileLock = dirOut+"/"+FileLockName;
		if(k++>100)//на всякий случай защита от вечного цикла
			break;
	}
	//сперва создаем LOCK-файл, чтобы в момент записи основного не произошла его отсылка, после сохранения основного файла LOCK-файл удаляем
	lpProxy.writeToFile("", sFileLock, "utf8");
	lpProxy.writeToFile(sSMS, sFile, "utf8");
	deleteFile(sFileLock);
	return true;
}

//Транслит перевод кириллицы в латыницу
//в параметре языка можно передавать как текстовое значение, так и числовой параметр текущего языка getPar("LANGUAGE")
function translit(text, lang)
{
	text = String(text);
	var rus = new Array({cyr:"а", lat:"a"}, {cyr:"к", lat:"k"}, {cyr:"х", lat:"h"}, 
						{cyr:"б", lat:"b"}, {cyr:"л", lat:"l"}, {cyr:"ц", lat:"ts"}, 
						{cyr:"в", lat:"v"}, {cyr:"м", lat:"m"}, {cyr:"ч", lat:"ch"}, 
						{cyr:"г", lat:"g"}, {cyr:"н", lat:"n"}, {cyr:"ш", lat:"sh"}, 
						{cyr:"д", lat:"d"}, {cyr:"о", lat:"o"}, {cyr:"щ", lat:"sch"}, 
						{cyr:"е", lat:"e"}, {cyr:"п", lat:"p"}, {cyr:"ь", lat:"'"}, 
						{cyr:"ё", lat:"yo"}, {cyr:"р", lat:"r"}, {cyr:"ъ", lat:'"'}, 
						{cyr:"ж", lat:"zh"}, {cyr:"с", lat:"s"}, {cyr:"ы", lat:"y"}, 
						{cyr:"з", lat:"z"}, {cyr:"т", lat:"t"}, {cyr:"э", lat:"e"}, 
						{cyr:"и", lat:"i"}, {cyr:"у", lat:"u"}, {cyr:"ю", lat:"yu"}, 
						{cyr:"й", lat:"j"}, {cyr:"ф", lat:"f"}, {cyr:"я", lat:"ya"});
	var ukr = new Array({cyr:"а", lat:"a"}, {cyr:"і", lat:"i"}, {cyr:"т", lat:"t"}, 
						{cyr:"б", lat:"b"}, {cyr:"ї", lat:"i'"}, {cyr:"у", lat:"u"}, 
						{cyr:"в", lat:"v"}, {cyr:"й", lat:"j"}, {cyr:"ф", lat:"f"},  
						{cyr:"г", lat:"g"}, {cyr:"к", lat:"k"}, {cyr:"х", lat:"h"}, 
						{cyr:"ґ", lat:"g'"}, {cyr:"л", lat:"l"}, {cyr:"ц", lat:"ts"}, 
						{cyr:"д", lat:"d"}, {cyr:"м", lat:"m"}, {cyr:"ч", lat:"ch"}, 
						{cyr:"е", lat:"e"}, {cyr:"н", lat:"n"}, {cyr:"ш", lat:"sh"}, 
						{cyr:"є", lat:"ye"}, {cyr:"о", lat:"o"}, {cyr:"щ", lat:"sch"},  
						{cyr:"ж", lat:"zh"}, {cyr:"п", lat:"p"}, {cyr:"ь", lat:"'"},  
						{cyr:"з", lat:"z"}, {cyr:"р", lat:"r"}, {cyr:"ю", lat:"yu"}, 
						{cyr:"и", lat:"y"}, {cyr:"с", lat:"s"}, {cyr:"я", lat:"ya"});
	var ar = new Array();
	if(lang == null)//если параметр языка не указан, то берем текущий язык системы
		lang = getPar("LANGUAGE");
	if(lang)
	{
		if(typeOf(lang).toLowerCase()=="string")
			lang = lang.toLowerCase();
		else
		{
			
		}
		switch(lang)
		{
			case 0:
			case "uk":
			case "ukr":
			case "ua":
			case "ukrainian":
			case "укр":
			case "украинский":
			case "українська":
				ar = ukr;
				break;
			case 1:
			case "ru":
			case "rus":
			case "russian":
			case "ру":
			case "рус":
			case "русский":
			case "російська":
				ar = rus;
				break;
			default:
				return text;
		}
	}
	else
		return text;
	var ret = "";
	for(var i=0; i<text.length; i++)
	{
		var ch = text[i];
		for(var j=0; j<ar.length; j++)
		{
			if(ar[j].cyr == ch.toLowerCase())
			{
				if(ch == ch.toUpperCase())
					ch = ar[j].lat.replace(ar[j].lat[0], ar[j].lat[0].toUpperCase());
				else
					ch = ar[j].lat;
				break;
			}
		}
		ret += ch;
	}
	return ret;
}