include("Objects/DpXMLDomDocument.js");
include ("objects/DpGetDat.js");

function ParseOrg(xmlOrgs)
{
	var OrgObjects = xmlOrgs.getElementsByTagName("Object");
	var ArrOrgs = new Array();
	for(var i = 0; i < OrgObjects.length; i++)
	{
		ArrOrgs[i] = new Array();
		var OrgElem = OrgObjects[i];
		var outID = OrgElem.getAttribute("ObjectID");			
		if(outID)
			ArrOrgs[i]["HOUTID"] = outID;
		var DebCod = OrgElem.getAttribute("OutObjectID");			
		if(DebCod)
			ArrOrgs[i]["HCOD"] = DebCod;
		var OrgProps = OrgElem.getElementsByTagName("Property");
		if(!OrgProps)
			continue;
			
		ArrOrgs[i]["HCL"] = 0;
			
		for(var k = 0; k < OrgProps.length; k++)
		{
			var oProp = OrgProps[k];
			var idProp = oProp.getAttribute("ID");
			var value = String(oProp.getText());
			switch(idProp)
			{
			case "1":					
			case "63":
				ArrOrgs[i]["HTXT"] = value; 
				break;
			case "67":
				ArrOrgs[i]["HADDR"] = value;
				break;
			case "71":
				ArrOrgs[i]["HCODCOUNTRY"] = value;
				break;
			case "78":
				ArrOrgs[i]["HPHONE"] = value;
			case "79":
				ArrOrgs[i]["HFAX"] = value;
				break;
			case "123":
				ArrOrgs[i]["HCOD_ST"] = value;
				break;
			case "135":
				ArrOrgs[i]["HCOD_NDS"] = value;
				break;
			case "181":
				ArrOrgs[i]["HREM"] = value;
				break;
			}		
		} 				
	}
	return ArrOrgs;		
}
	
function ParseNmkl(xmlClass)
{
	var xmlObjects = xmlClass.getElementsByTagName("Object");
	var ArrObjs = new Array();
	var j = 0;
	//debug()
	for(var i = 0; i < xmlObjects.length; i++)
	{
		var xmlObj = xmlObjects[i];
		var DebCod = xmlObj.getAttribute("OutObjectID");			
		
		if(DebCod.lastIndexOf(".")==-1)
			continue;
			
		if(DebCod.substr(0,2)=="U.")
		{
			if(DebCod.substr(2).lastIndexOf(".")==-1)
				continue;			
		}
			 
			
		ArrObjs[j] = new Array();
		
		var outID = xmlObj.getAttribute("ObjectID");			
		if(!outID)
			return;
		if(DebCod)
			ArrObjs[j]["HCOD"] = DebCod;
		ArrObjs[j]["HOUTID"] = outID;
		
		var xmlProps = xmlObj.getElementsByTagName("Property");
		if(!xmlProps)
			continue;
		for(var iArr = 0; iArr < xmlProps.length; iArr++)
		{
			var oProp = xmlProps[iArr];
			var idProp = oProp.getAttribute("ID");
			var value = String(oProp.getText());
			switch(idProp)
			{
					case "1":	
						ArrObjs[j]["HTXTS"] = value;
						ArrObjs[j]["HTXT0"] = value;
						break;
					case "44":	
					case "190":
						ArrObjs[j]["HARTICUL"] = value;
						break;
					case "169":	
						ArrObjs[j]["HCEDIB"] = value;
						break;
					case "203":
						ArrObjs[j]["HLINECOD"] = value;
						break;
					case "336":
						ArrObjs[j]["HKVED"] = value;
						break;
			}
		}
		j++; 			
	}
		
	return ArrObjs;		
}

function ParsePodr(xmlClass)
{
	var xmlObjects = xmlClass.getElementsByTagName("Object");
	var ArrObjs = new Array();
	for(var i = 0; i < xmlObjects.length; i++)
	{
		ArrObjs[i] = new Array();
		var xmlObj = xmlObjects[i];
		var outID = xmlObj.getAttribute("ObjectID");			
		if(!outID)
			return;
		ArrObjs[i]["HOUTID"] = outID;
		var xmlProps = xmlObj.getElementsByTagName("Property");
		if(!xmlProps || xmlProps.length == 0)
			continue;
		for(var iArr = 0; iArr < xmlProps.length; iArr++)
		{
			var oProp = xmlProps[iArr];
			var idProp = oProp.getAttribute("ID");
			var value = String(oProp.getText());
			switch(idProp)
			{
					case "1":	
						ArrObjs[i]["txt"] = value;
						break;					
			}
		} 			
	}
	return ArrObjs;		
}
	
function ParseEdi(xmlClass)
{
	var xmlObjects = xmlClass.getElementsByTagName("Object");
	var ArrObjs = new Array();
	for(var i = 0; i < xmlObjects.length; i++)
	{
		ArrObjs[i] = new Array();
		var xmlObj = xmlObjects[i];
		var outID = xmlObj.getAttribute("ObjectID");			
		if(!outID)
			return;
		ArrObjs[i]["HOUTID"] = outID;
		var xmlProps = xmlObj.getElementsByTagName("Property");
		if(!xmlProps || xmlProps.length == 0)
			continue;
		for(var iArr = 0; iArr < xmlProps.length; iArr++)
		{
			var oProp = xmlProps[iArr];
			var idProp = oProp.getAttribute("ID");
			var value = String(oProp.getText());
			switch(idProp)
			{
					case "1":	
						ArrObjs[i]["HTXTF"] = value;
						break;
					case "11":	
						ArrObjs[i]["HTXTS"] = value;
						break;						
			}
		} 			
	}
	return ArrObjs;		
}
	
function ParseVal(xmlClass)
{
		var xmlObjects = xmlClass.getElementsByTagName("Object");
		var ArrObjs = new Array();
		for(var i = 0; i < xmlObjects.length; i++)
		{
			ArrObjs[i] = new Array();
			var xmlObj = xmlObjects[i];
			var outID = xmlObj.getAttribute("ObjectID");			
			if(!outID)
				return;
			ArrObjs[i]["HOUTID"] = outID;
			var xmlProps = xmlObj.getElementsByTagName("Property");
			if(!xmlProps)
				continue;
			for(var iArr = 0; iArr < xmlProps.length; iArr++)
			{
				var oProp = xmlProps[iArr];
				var idProp = oProp.getAttribute("ID");
				var value = String(oProp.getText());
				switch(idProp)
				{
						case "1":	
							ArrObjs[i]["HNAZV"] = value;
							break;
						case "32":	
							ArrObjs[i]["HNAZVS"] = value;
							break;		
				}
				if(ArrObjs[i]["HNAZVS"] == "UAH")
				{
					ArrObjs[i]["HCOD"]=0;
					ArrObjs[i]["HNAZVS"]="ГРН";
				}
			} 			
		}
		return ArrObjs;		
}
function ParseCountry(xmlClass)
{
		var xmlObjects = xmlClass.getElementsByTagName("Object");
		var ArrObjs = new Array();
		for(var i = 0; i < xmlObjects.length; i++)
		{
			ArrObjs[i] = new Array();
			var xmlObj = xmlObjects[i];
			var outID = xmlObj.getAttribute("ObjectID");			
			if(!outID)
				return;
			ArrObjs[i]["HOUTID"] = outID;
			var xmlProps = xmlObj.getElementsByTagName("Property");
			if(!xmlProps)
				continue;
				
			ArrOrgs[i]["HCL"] = getPar("CODCOUNTRY");	
			for(var iArr = 0; iArr < xmlProps.length; iArr++)
			{
				var oProp = xmlProps[iArr];
				var idProp = oProp.getAttribute("ID");
				var value = String(oProp.getText());
				switch(idProp)
				{
						case "1":	
							ArrObjs[i]["txt"] = value;
							break;							
				}
			} 			
		}
		return ArrObjs;		
}



function ParseDoc(xmlDocAll,sClassID)
{
	var xmlDocs = xmlDocAll.getElementsByTagName("Object");
	var sLblDoc;
	
	var bGetdat=false;

	nSu1 = 0;
	
	switch(sClassID)
	{
	case "4351":
		if(GetMenuMode() == "GET_DAT2")
		{
			var gd = new DpGetDat(new Array("p","m","k0"));
			if(!gd.escape)
			{
				bGetdat = true;
				nPodr=gd.fpodr;
				nMol =gd.fmol;
				nSc = gd.fdb_sc;
				nSu = gd.fdb_su;
				nSt = gd.fdb_st;		
				nSc1 = gd.fcr_sc;
				nSu1 = gd.fcr_su;
				nSt1 = gd.fcr_st;		
			}
			else
			{
				return false;
			}
		}
		sLblDoc = "SM";
		break;
	case "4360":
		if(GetMenuMode() == "GET_DAT" || GetMenuMode() == "VRDP")
		{
			var gd = new DpGetDat(new Array("p","m","s:c0ut"));
			if(!gd.escape)
			{
				bGetdat = true;
				nPodr=gd.fpodr;
				nMol =gd.fmol;
				nSc = gd.fsc;
				nSu = gd.fsu;
				nSt = gd.fst;		
			}
			else
			{
				return false;
			}
		}
		sLblDoc = "PN";		
		break;
	case "4370":
		if(GetMenuMode() == "GET_DAT" || GetMenuMode() == "VRDP")
		{
			var gd = new DpGetDat(new Array("p","m","s:c0ut"));
			if(!gd.escape)
			{
				bGetdat = true;
				nPodr=gd.fpodr;
				nMol =gd.fmol;
				nSc = gd.fsc;
				nSu = gd.fsu;
				nSt = gd.fst;		
			}
			else
			{
				return false;
			}
		}
		sLblDoc = "NK";
		break;
	
	}
	
	if(GetMenuMode() == "PN")
		sLblDoc = "PN";	
	
	for(var i = 0; i < xmlDocs.length; i++)
	{
		var xmlDocTo =  XMLDocR.createElement("object");
		var nNop = sClassID
		
		/*
		xmlNop = XMLDocR.createAttribute("NOP");
		xmlNop.value = nNop;
		xmlDocTo.setAttributeNode(xmlNop);
		*/
		
		
			
		var xmlDocHead =  XMLDocR.createElement("Header");
		var xmlDoc = xmlDocs[i];
		xmlDocHead.createChild("HOP", nNop);
			//Header
		var xmlHead = xmlDoc.getElementsByTagName("Header")[0];
		var sDocOutID = xmlDoc.getAttribute("ObjectID");
		if(!sDocOutID)
			continue;
			
		//Устанавливаем вню ид. из ObjectID
		var xmlDocOutID = XMLDocR.createElement("HOUTID");
		xmlDocOutID.setText(sDocOutID);
		xmlDocHead.appendChild(xmlDocOutID); 
		
			
		//Считываем данные заголовка Тетры			
		var oHeadProps = xmlHead.getElementsByTagName("Property");
		//debugger
		var nPost = 0;
		var n224 = 130;
		for(var j = 0; j < oHeadProps.length; j++)
		{
			oHeadProp = oHeadProps[j];
			sIDProp = String(oHeadProp.getAttribute("ID"));
			//alert("sIDProp = "+sIDProp)
			
			switch(sIDProp)
			{
				case "33":
					{
						xmlVal = XMLDocR.createElement("HVAL");
						var oHead = xmlVal.createChild("Header");	
						xmlOutId = XMLDocR.createElement("HOUTID");
						xmlOutId.setText(oHeadProp.getText());
						oHead.appendChild(xmlOutId);
						xmlDocHead.appendChild(xmlVal);						
					}
					break;
				
				case "175":
					{
						if(sLblDoc != "PN")
						{
							if(!bGetdat)
								nPodr = XCLT(nSpr,Number(oHeadProp.getText()),"PODR");
							if(!bGetdat)
								nMol = XCLT(nSpr,Number(oHeadProp.getText()),"MOL");
							if(!bGetdat)
								nSu = XCLT(nSpr,Number(oHeadProp.getText()),"SU");
							nPost = XCLT(nSpr,Number(oHeadProp.getText()),"CONTR");													 
						}
					
					}
					break;
				case "172":
					{
						if (typeof(arrTemplate) != "undefined" && arrTemplate 
									&& arrTemplate[String(oHeadProp.getText())])
							n224 = arrTemplate[String(oHeadProp.getText())]; 								
												
					}
					break;
				case "176":
					{
						if(sLblDoc == "PN")
						{
							if(!bGetdat)
								nPodr = XCLT(nSpr,Number(oHeadProp.getText()),"PODR");
							if(!bGetdat)
								nMol = XCLT(nSpr,Number(oHeadProp.getText()),"MOL");
							if(!bGetdat)
								nSu = XCLT(nSpr,Number(oHeadProp.getText()),"SU");
							if(!bGetdat)
								nSc = XCLT(nSpr,Number(oHeadProp.getText()),"SC");									
						}
						else if(sLblDoc == "SM")
						{
							nPodr1 = XCLT(nSpr,Number(oHeadProp.getText()),"PODR");
							nMol1 = XCLT(nSpr,Number(oHeadProp.getText()),"MOL");
							
							if (!bGetdat || nSu1 == 0)
							{
								nSu1 = XCLT(nSpr,oHeadProp.getText(),"SU");	
							}
						}
					
					}
					break;					
				case "177":
					{
						xmlSum = XMLDocR.createElement(sLblDoc == "SM"?"HOSUM":"HSUM");
						xmlSum.setText(Number(oHeadProp.getText())*5/6);
						xmlDocHead.appendChild(xmlSum);
						xmlNds = XMLDocR.createElement("HSNDS");
						xmlNds.setText(Number(oHeadProp.getText())/6);
						xmlDocHead.appendChild(xmlNds);						
					}
					break;
				case "202":
					{					
						var xmlCOntr;
						
						if(GetMenuMode() == "VRDP")
						{
							xmlCOntr = XMLDocR.createElement("HPOST");
							var oHead = xmlCOntr.createChild("Header");	
							xmlId = XMLDocR.createElement("HCOD");
							xmlId.setText(2048); //Код Днепра
							xmlCOntr.appendChild(xmlId);
							xmlDocHead.appendChild(xmlCOntr);
						}
						else
						{						
						
							if(sLblDoc == "PN")
								xmlCOntr = XMLDocR.createElement("HPOST");
							else if(sLblDoc == "NK")
								xmlCOntr = XMLDocR.createElement("HPLCH");
														
												
							//alert(oHeadProp.text);
							if(sLblDoc == "NK" && nPost != 0 && oHeadProp.getText() == "30057109")
							{
								var oHead = xmlCOntr.createChild("Header");	
								xmlId = XMLDocR.createElement("HCOD");
								xmlId.setText(nPost);
								oHead.appendChild(xmlId);
								xmlDocHead.appendChild(xmlCOntr);
							}
							else if(sLblDoc != "SM")
							{
								var oHead = xmlCOntr.createChild("Header");	
								xmlOutId = XMLDocR.createElement("HOUTID");
								xmlOutId.setText(oHeadProp.getText());
								oHead.appendChild(xmlOutId);
								xmlDocHead.appendChild(xmlCOntr);
							}
						}	
					}
					break;						
				
				}
			}
						
			if(nPodr)
			{
				var xmlPodr = XMLDocR.createElement(sLblDoc == "SM"?"HPODROT":"HPODR");
				var oHead = xmlPodr.createChild("Header");
				var CodPodr = XMLDocR.createElement("HCOD");
				CodPodr.setText(nPodr);
				oHead.appendChild(CodPodr);
				xmlDocHead.appendChild(xmlPodr);
			}
				
			if(nMol)
			{
				var xmlMol = XMLDocR.createElement(sLblDoc == "SM"?"HMOLOT":"HMOL");
				var oHead = xmlMol.createChild("Header");
				var CodMol = XMLDocR.createElement("HCOD");
				CodMol.setText(nMol);
				oHead.appendChild(CodMol);
				xmlDocHead.appendChild(xmlMol);
			}
		
			if(sLblDoc == "SM")
			{
				if(nPodr1)
				{
					var xmlPodrTo = XMLDocR.createElement("HPODRTO");
					var oHead = xmlPodrTo.createChild("Header");
					var CodPodrTo = XMLDocR.createElement("HCOD");
					CodPodrTo.setText(nPodr1);
					oHead.appendChild(CodPodrTo);
					xmlDocHead.appendChild(xmlPodrTo);
				}
				
				if(nMol1)
				{
					var xmlMolTo = XMLDocR.createElement("HMOLTO");
					var oHead = xmlMolTo.createChild("Header");
					var CodMolTo = XMLDocR.createElement("HCOD");
					CodMolTo.setText(nMol1);
					oHead.appendChild(CodMolTo);
					xmlDocHead.appendChild(xmlMolTo);
				}
			}
		
			var xmlSc = XMLDocR.createElement("HSC");
			xmlSc.setText((sLblDoc != "SM")?nSc:nSc1);
			xmlDocHead.appendChild(xmlSc); 
		
			var xmlSu = XMLDocR.createElement("HSU");
			xmlSu.setText((sLblDoc != "SM")?nSu:nSu1);
			xmlDocHead.appendChild(xmlSu);
		
			var xmlSt = XMLDocR.createElement("HST");
			xmlSt.setText((sLblDoc != "SM")?nSt:nSt1);
			xmlDocHead.appendChild(xmlSt); 
			xmlDocTo.appendChild(xmlDocHead);

			if(sLblDoc == "SM")
			{
				var xmlSc = XMLDocR.createElement("HSC1");
				xmlSc.setText(nSc);
				xmlDocHead.appendChild(xmlSc); 
		
				var xmlSu = XMLDocR.createElement("HSU1");
				xmlSu.setText(nSu);
				xmlDocHead.appendChild(xmlSu);
		
				var xmlSt = XMLDocR.createElement("HST1");
				xmlSt.setText(nSt1);
				xmlDocHead.appendChild(xmlSt); 
				xmlDocTo.appendChild(xmlDocHead);
			}
			
			var xmlNdsProc = XMLDocR.createElement("HPNDS");
			xmlNdsProc.setText(20);
			xmlDocHead.appendChild(xmlNdsProc);
						
			var xmlDocRows =  XMLDocR.createElement("rows");
			xmlDocRows.setAttribute("ID", "ROW");
			xmlDocTo.appendChild(xmlDocRows);
			var xmlDetail = xmlDoc.getElementsByTagName("Detail");
			var xmlDetail27 = null;
			var xmlDetail223 = null;
			for(var k = 0; k < xmlDetail.length; k++)
			{
				switch(String(xmlDetail[k].getAttribute("ID"))) {
				case "27":
					xmlDetail27 = xmlDetail[k];
					break;
				case "223":
					xmlDetail223 = xmlDetail[k];
					break;
				}
			}
			
			/*			
			var xmlRowsForNumProp = xmlDetail223.getElementsByTagName("Property");
			var xmlNumDat = null;
			
			for(var k = 0; k < xmlRowsForNumProp.length; k++)
			{
				if(xmlRowsForNumProp[k].getAttribute("ID") == "DefaultValue")
				{
					if(xmlRowsForNumProp[k].getText() == "True")
						xmlNumDat = xmlRowsForNumProp[k].getParentNodeEx();					
				}
											
			}
			*/	
			
			//------- Date Start
			
			
			var oDatArr = parseNumDoc(xmlDetail223);			
			if (oDatArr.length == 0)
				continue;
			
			var oNumDatObj = oDatArr[0]; 	
			
			for (var k = 0; k < oDatArr.length; k++)
			{
					if (oDatArr[k].N224 == n224 )
					{
						oNumDatObj = oDatArr[k];  	
					}
			}
			
			var xmlNum = XMLDocR.createElement("HNOM");
			xmlNum.setText(oNumDatObj.NUM);
			xmlDocHead.appendChild(xmlNum);
			
			var xmlDate = XMLDocR.createElement("HDAT");
			xmlDate.setText(oNumDatObj.DATE);
			xmlDocHead.appendChild(xmlDate);
			
			
			/*
			var isSetDat = false;
			var xmlNumDat = xmlDetail223.selectSingleNode("Row[Property/@ID='224' and Property/text()='" + n224 + "']");
			if (xmlNumDat)
			{
				var xmlDocNum = XMLDocR.createElement("HNOM");
				var xml = xmlNumDat.selectSingleNode("Property[@ID='Value']");
				if (xml)
				{
					xmlDocNum.setText(xml.getText());
					xmlDocHead.appendChild(xmlDocNum);
					isSetDat = true;
				}
				
				var xmlDocDate = XMLDocR.createElement("HDAT");
				var xml = xmlNumDat.selectSingleNode("Property[@ID='DateOD']");
				if (xml)
				{
					xmlDocDate.setText(xml.getText());
					xmlDocHead.appendChild(xmlDocDate);
				}
								
			}
			else
			{
				xmlNumDat = xmlDetail223.selectSingleNode("Row[Property/@ID='DefaultValue' and Property/text()='True']");
				if (xmlNumDat)
				{
					var xmlDocNum = XMLDocR.createElement("HNOM");
					var xml = xmlNumDat.selectSingleNode("Property[@ID='Value']");
					if (xml)
					{
						isSetDat = true;
						xmlDocNum.setText(xml.getText());
						xmlDocHead.appendChild(xmlDocNum);
					}
					
					var xmlDocDate = XMLDocR.createElement("HDAT");
					var xml = xmlNumDat.selectSingleNode("Property[@ID='DateOD']");
					if (xml)
					{
						xmlDocDate.setText (xml.getText());
						xmlDocHead.appendChild(xmlDocDate);
					}
								
				}
				else
					continue;
			}
			  
			  
			  
			 //--------  Date End
			//if(!xmlNumDat) continue;
			var isDate = true; 
			
			if (!isSetDat)
			{
				var xmlNumDatRows = xmlNumDat.getElementsByTagName("Row")
				var xmlNumDatChilds = xmlNumDat.getChildNodes();
				for(var k = 0; k < xmlNumDatChilds.length; k++)
				{
					switch(String(xmlNumDatChilds[k].getAttribute("ID")))
					{
						case "Value":
						{
							var xmlNum = XMLDocR.createElement("HNOM");
							xmlNum.setText(xmlNumDatChilds[k].getText());
							xmlDocHead.appendChild(xmlNum);
							break;
						}
						case "DateOD":
						{
							var xmlDate = XMLDocR.createElement("HDAT");
							
							var sText = xmlNumDatChilds[k].getText();
							
							xmlDate.setText(xmlNumDatChilds[k].getText());
							xmlDocHead.appendChild(xmlDate);
							
							if(!sText)
							{
								isDate = false;
								break
							}
							
							break;
						}
					}											
				}
			}
				
			
			if(!isDate)
				continue;
			*/
			
			if(xmlDetail27)
			{
				var xmlRows = xmlDetail27.getElementsByTagName("Row");
				for(var k = 0; k < xmlRows.length; k++)
				{
					var xmlDocRow = XMLDocR.createElement("object");
					var xmlDocRowHead = XMLDocR.createElement("Header");
					xmlDocRow.appendChild(xmlDocRowHead);
					xmlRowFrom = xmlRows[k];
					
					var oRowProps = xmlRowFrom.getElementsByTagName("Property");
					
					var sNmkOutID;
					for(var j = 0; j < oRowProps.length; j++)
					{
						oRowProp = oRowProps[j];
						sIDProp = String(oRowProp.getAttribute("ID"));
						//alert("sIDProp = "+sIDProp)
						
						switch(sIDProp)
						{
							case "30":
								{
								xmlNmkl = XMLDocR.createElement("RTNMK");
								var oHead = xmlNmkl.createChild("Header");
								xmlOutId = XMLDocR.createElement("HOUTID");
								xmlOutId.setText(oRowProp.getText());
								oHead.appendChild(xmlOutId);
								xmlDocRowHead.appendChild(xmlNmkl);	
								sNmkOutID = oRowProp.getText();						
								}
								break;
							case "Amount":
								{
								xmlKol = XMLDocR.createElement("RKOL");
								xmlKol.setText(oRowProp.getText());
								xmlDocRowHead.appendChild(xmlKol);
								xmlKol1 = XMLDocR.createElement("RKOL1");
								xmlKol1.setText(oRowProp.getText());
								xmlDocRowHead.appendChild(xmlKol1);						
								}
								break;
							case "Price":
								{
									if(sLblDoc=="PN")
									{
										xmlCenapok = XMLDocR.createElement("RPCENE");
										xmlCenapok.setText(oRowProp.getText());
										xmlDocRowHead.appendChild(xmlCenapok);
										xmlCenaotp = XMLDocR.createElement("R1OCENA");
										xmlCenaotp.setText(oRowProp.getText());
										xmlDocRowHead.appendChild(xmlCenaotp);	
									}
									else
									{
										if((sLblDoc=="SM" && nSu1 == 281) || GetMenuMode()=="VRDP")
										{
											xmlCena = XMLDocR.createElement("RUCENA");
											xmlCena.setText(oRowProp.getText());
											xmlDocRowHead.appendChild(xmlCena);
										}
										else
										{
											if (GetMenuMode() != "VP")
											{
												xmlCenapr = XMLDocR.createElement("ROCENA");
												xmlCenapr.setText(oRowProp.getText());
												xmlDocRowHead.appendChild(xmlCenapr);
												xmlCenaotp = XMLDocR.createElement(sLblDoc=="NK"?"RFOCENA":"R0OCENA");
												xmlCenaotp.setText(oRowProp.getText());
												xmlDocRowHead.appendChild(xmlCenaotp);
											}
										}	
									}
								}
								break;
							case "PriceEntry":
								{
									if ((sLblDoc=="SM" && nSu1 == 281) || GetMenuMode()=="VRDP") //VM || VR
									{
										xmlCenapr = XMLDocR.createElement("ROCENA");
										xmlCenapr.setText(oRowProp.getText());
										xmlDocRowHead.appendChild(xmlCenapr);
										xmlCenaotp = XMLDocR.createElement(sLblDoc=="NK"?"RFOCENA":"RPCENE" /*"R0OCENA"*/);
										xmlCenaotp.setText(oRowProp.getText());
										xmlDocRowHead.appendChild(xmlCenaotp);
									}
									else
									{
										xmlCena = XMLDocR.createElement("RUCENA");
										xmlCena.setText(oRowProp.getText());
										xmlDocRowHead.appendChild(xmlCena);
										
										if(GetMenuMode()=="VP")
										{
											xmlCenapr = XMLDocR.createElement("ROCENA");
											xmlCenapr.setText(oRowProp.getText());
											xmlDocRowHead.appendChild(xmlCenapr);
											xmlCenaotp = XMLDocR.createElement("RPCENE");											
											//xmlCenaotp = XMLDocR.createElement(sLblDoc=="NK"?"RFOCENA":"R0OCENA");
											xmlCenaotp.setText(oRowProp.getText());
											xmlDocRowHead.appendChild(xmlCenaotp);
										}
									}							
								}
								break;							
							case "DocGoodID_IN":
								{
									xmlPn1 = XMLDocR.createElement("R1ID");
									var oHead = xmlPn1.createChild("Header");
									xmlOutId = XMLDocR.createElement("HOUTID");
									xmlOutId.setText(oRowProp.getText()+":"+sNmkOutID);
									oHead.appendChild(xmlOutId);
									xmlDocRowHead.appendChild(xmlPn1);							
								}
								break;	
						}					
					}				
					
				var xmlRowOutID = XMLDocR.createElement("ROUTID");
				xmlRowOutID.setText(sDocOutID+":"+sNmkOutID);
				xmlDocRowHead.appendChild(xmlRowOutID);
					
				
				var xmlScFr = XMLDocR.createElement("RSC");
				xmlScFr.setText(nSc);
				xmlDocRowHead.appendChild(xmlScFr); 
				
				var xmlSuFr = XMLDocR.createElement("RSU");
				xmlSuFr.setText(nSu);
				xmlDocRowHead.appendChild(xmlSuFr);
				
				var xmlStFr = XMLDocR.createElement("RST");
				xmlStFr.setText(nSt);
				xmlDocRowHead.appendChild(xmlStFr);
				
				if(sLblDoc == "SM")
				{	
					var xmlScFr = XMLDocR.createElement("RSC1");
					xmlScFr.setText(nSc1);
					xmlDocRowHead.appendChild(xmlScFr); 
				
					var xmlSuFr = XMLDocR.createElement("RSU1");
					xmlSuFr.setText(nSu1);
					xmlDocRowHead.appendChild(xmlSuFr);
				
					var xmlStFr = XMLDocR.createElement("RST1");
					xmlStFr.setText(nSt1);
					xmlDocRowHead.appendChild(xmlStFr);  
				}
				
												
				xmlDocRows.appendChild(xmlDocRow);				
			}
		}
		
		if(sLblDoc == "SM" && nSu1 == 281)
			xmlDocTo.setAttribute("type", "docs.VM");
		else if(GetMenuMode() == "VRDP")
			xmlDocTo.setAttribute("type", "docs.VR");	
		else if(GetMenuMode() == "VP")
			xmlDocTo.setAttribute("type", "docs.VP");	
		else if(GetMenuMode() == "PN")
			xmlDocTo.setAttribute("type", "docs.PN");	
		else
			xmlDocTo.setAttribute("type", "docs." + sLblDoc);		
		
		switch(sLblDoc)
		{
			case "PN":
				ArrDocPN[i] = xmlDocTo;
				break;
			case "NK":
				ArrDocNK[i] = xmlDocTo;
				break;
			case "SM":
				ArrDocSM[i] = xmlDocTo;
				break;
		}		
	}		
}

function parseNumDoc(xmlDetail223)
{
	var nums = new Array();
	
	var xmlNumDatRows = xmlDetail223.getElementsByTagName("Row")
	for (var i = 0 ;i < xmlNumDatRows.length; i++)
	{	
		xmlNumDat = xmlNumDatRows[i];
		var oNum = new Object(); 
		
		var xmlNumDatChilds = xmlNumDat.getChildNodes();
		for(var k = 0; k < xmlNumDatChilds.length; k++)
		{
			switch(String(xmlNumDatChilds[k].getAttribute("ID")))
			{
				case "Value":
				{
					oNum.NUM = xmlNumDatChilds[k].getText();					
					break;
				}
				case "DateOD":
				{
					oNum.DATE = xmlNumDatChilds[k].getText();					
					break;
				}
				case "224":
				{
					oNum.N224 = Number(xmlNumDatChilds[k].getText());					
					break;					
				}
			}														
		}
		nums[nums.length] = oNum
	}
	
	return nums;
		
} 



function createXml(ArrAllObjects,ArrOrders)
{
	var OutXML = new DpXMLDOMDocument();;
	root = OutXML.createElement("root");	
	OutXML.appendChild(root);
	for(var j = 0; j < ArrOrders.length; j++)
	{
		sType = ArrOrders[j];
		ArrObj = ArrAllObjects[sType];
		if(!ArrObj) continue;
		sObType = sType;
		if(sObType.substr(0,6)=="DpNmkl")
			sObType = "cls.nmkl";
		if(sObType.substr(0,5)=="DpVal")
			sObType = "cls.valut";
		if(sObType == "DpCountry")
			sObType = "cls.CL1";
		if(sObType.substr(0,6)=="DpPodr")
			sObType = "cls.CL1";
		if(sObType.substr(0,5)=="DpOrg")
			sObType = "cls.CL2";
		for(var i = 0; i < ArrObj.length; i++)
		{
			var OutEl = OutXML.createElement("object");
			OutEl.setAttribute("type", sObType)
			var xmlHeader = OutXML.createElement("Header");
			OutEl.appendChild(xmlHeader);
			for(sEl in ArrObj[i])
			{
				var xmlProp = OutXML.createElement(sEl);
				if((sObType =="cls.nmkl" && sEl == "HCEDIB") ||
					(sObType =="cls.CL2" && sEl == "HCODCOUNTRY") )
				{
					
					var xmlHead = OutXML.createElement("Header");
					xmlProp.appendChild(xmlHead);
					
					var subEl = OutXML.createElement("HOUTID");
					subEl.setText(ArrObj[i][sEl]);
					xmlHead.appendChild(subEl);			
				}
				else
					xmlProp.setText(ArrObj[i][sEl]);				
				xmlHeader.appendChild(xmlProp);			
				 
			}
			if(sObType == "cls.nmkl" && ArrObj[i]["HARTICUL"])
			{
				var xmlExt = OutXML.createElement("Extentions");
				OutEl.appendChild(xmlExt);
				var xmlArt = OutXML.createElement("ext");				
				xmlArt.setAttribute("type", "text");
				xmlArt.setAttribute("name", "ART");
				xmlArt.setText(ArrObj[i]["HARTICUL"]);
				xmlExt.appendChild(xmlArt);
				
				if(sObType == "cls.nmkl" && ArrObj[i]["HKVED"])
				{
					var xmlExt = OutXML.createElement("Extentions");
					OutEl.appendChild(xmlExt);
					var xmlArt = OutXML.createElement("ext");				
					xmlArt.setAttribute("type", "text");
					xmlArt.setAttribute("name", "KVED");
					xmlArt.setText(ArrObj[i]["HKVED"]);
					xmlExt.appendChild(xmlArt);
				}
			}
			else if(sObType == "cls.nmkl" && ArrObj[i]["HKVED"])
			{
				var xmlExt = OutXML.createElement("Extentions");
				OutEl.appendChild(xmlExt);
				var xmlArt = OutXML.createElement("ext");				
				xmlArt.setAttribute("type", "text");
				xmlArt.setAttribute("name", "KVED");
				xmlArt.setText(ArrObj[i]["HKVED"]);
				xmlExt.appendChild(xmlArt);
			}
			
			if(sObType == "cls.CL2")
			{
				var xmlRows= OutXML.createElement("rows");
				xmlRows.setAttribute("ID", "CLNUM");
				var xmlRow = OutXML.createElement("object");
				xmlRow.setAttribute("type", "CLNUM");
				xmlRows.appendChild(xmlRow);
				
				var xmlHead = OutXML.createElement("Header");
				xmlRow.appendChild(xmlHead);
				
				var xmlCl = OutXML.createElement("HCL");
				xmlCl.setText(sprOrg);
				xmlHead.appendChild(xmlCl);
				
				OutEl.appendChild(xmlRows);				
			}
			root.appendChild(OutEl);		
		}
	}
	for(var nPn = 0; nPn < ArrDocPN.length; nPn++)
	{
		root.appendChild(OutXML.adoptNode(ArrDocPN[nPn].cloneNode(true)));		
	}
	for(var nSM = 0; nSM < ArrDocSM.length; nSM++)
	{
		root.appendChild(OutXML.adoptNode(ArrDocSM[nSM].cloneNode(true)));		
	}
	for(var nNK = 0; nNK < ArrDocNK.length; nNK++)
	{
		root.appendChild(OutXML.adoptNode(ArrDocNK[nNK].cloneNode(true)));			
	}
	
	
	return root;		
}	