/**
	@date 16.08.2006
	@autor draco	

	Объект для быстрого создания формы
	
	Функции для работы:
		- основные:
			setTitle - задание заголовка формы
			getTitle - получение заголовка формы
			addObj - создание контрола (идентификатор, тип, текстовка, массив инициализации, ширина);
			addPanel - создание панели
			getValue - получение значения контрола по ID
			setValue - установка значения контрола по ID
			setFormValid - установка валидности на контрол (аналог из "main.js")
			show - создание и визуализация формы
		- дополнительные:
			addCodPers - будет добавлен объект DpCl - код персонала (если параметр true будет
						 добавлен контрол для вівода текстовки)
	
	
*/

function DpAsk()
{
	this.dpAskFRM = null;
}

DpAsk.prototype.addObj = function addObj(ID, sType, sText, initObj, width)
{
	if (typeof width != "number")
		width = 100;
	var obj = this.dpAskFRM.addObj(ID, sType, sText, width);
	try
	{
		if (objTypeOf(initObj) == "Array")
		{
			for (var i = 0; i < initObj.length; i+=2)
			try
			{
				var ection = String(initObj[i]);
				var val = initObj[i + 1];
				var type = (typeof eval("obj." + ection));
				if (type == "function")
					eval("obj." + ection + "(val)");
				else if (type == "object")
					eval("obj." + ection + "=val");
			}
			catch(x){}
		}
		return obj;	
	}
	catch(x)
	{
		return obj;
	}
}

DpAsk.prototype.addPanel = function addPanel(text, column) {
	return this.dpAskFRM.addPanel(text, column);
}

DpAsk.prototype.show = function show() {
	setFocus(this.dpAskFRM.getObj(0));
	var ret = this.dpAskFRM.show();
	this.escape = !ret;
	if (ret)
	{
		var objMap = this.dpAskFRM.getMapValue();
		var id = objMap.keySet().toArray();
		var value = objMap.values().toArray();
		for (var i in id)
			this[id[i]] = value[i];
	}
	return ret;
}

DpAsk.prototype.getValue = function getValue(ID) {
	return this.dpAskFRM.getValue(ID);
}

DpAsk.prototype.setValue = function setValue(ID, value) {
	return this.dpAskFRM.setValue(ID, value);
}

DpAsk.prototype.setTitle = function setTitle(title) {
	return this.dpAskFRM.setTitle(title);
}

DpAsk.prototype.getTitle = function getTitle() {
	return this.dpAskFRM.getTitle();
}

DpAsk.prototype.addObjCl = function addObjCl(fcl, clmode, toShowTxt, lblTxt)
{
	include("objects/DpCl.js");
	if(clmode)
		var dpCl = new DpCl(clmode, fcl, 0);
	else
		var dpCl = new DpCl(fcl, 0);
	var panel = this.addPanel(lblTxt?lblTxt:"Код: ", 2);
	var cod = panel.addObj("CL_COD", "int", null, 70);
	var text;
	if (toShowTxt === true)
		text = panel.addObj("CL_TXT", "str", null, 200);		
	dpCl.linkCtrl(cod, text);
	return dpCl;
}

DpAsk.prototype.addObjClCombo = function addObjClCombo(fcl, clmode, txt)
{
	include("objects/DpCl.js");
	if(clmode)
		var dpCl = new DpCl(clmode, fcl, 0);
	else
		var dpCl = new DpCl(fcl, 0);
	var panel = this.addPanel(txt?txt:"", 2);
	var cod = panel.addObj("CL", "combo", null, 70);
	dpCl.linkCombo(cod);
	return dpCl;
}

DpAsk.prototype.addCodPers = function addCodPers(fl_zero, bool)
{
	include("objects/DpCl.js");
	if(fl_zero===true)
		var dpPers = new DpCl("0", getPar("CODPERS"), 0);
	else
		var dpPers = new DpCl(getPar("CODPERS"), 0);
	var panel = this.addPanel("Код персонала: ", 2);
	var cod = panel.addObj("CL_COD", "int", null, 70);
	var text;
	if (bool === true)
		text = panel.addObj("CL_TXT", "str", null, 200);		
	dpPers.linkCtrl(cod, text);
	return dpPers;
}

DpAsk.prototype.addCodDol = function addCodDol(fl_zero, bool)
{
	include("objects/DpCl.js");
	if(fl_zero===true)
		var dpDol = new DpCl("0", getPar("CODDOL"), 0);
	else
		var dpDol = new DpCl(getPar("CODDOL"), 0);
	var panel = this.addPanel(ru("Код должности: ","Код посади: "), 2);
	var cod = panel.addObj("CL_COD", "int", null, 70);
	var text;
	if (bool === true)
		text = panel.addObj("CL_TXT", "str", null, 200);		
	dpDol.linkCtrl(cod, text);
	return dpDol;
}

DpAsk.prototype.addCodKat = function addCodKat(fl_zero, bool)
{
	include("objects/DpCl.js");
	if(fl_zero===true)
		var dpKat = new DpCl("0", getPar("CODKAT"), 0);
	else
		var dpKat = new DpCl(getPar("CODKAT"), 0);
	var panel = this.addPanel(ru("Код категории: ","Код категорії: "), 2);
	var cod = panel.addObj("CL_COD", "int", null, 70);
	var text;
	if (bool === true)
		text = panel.addObj("CL_TXT", "str", null, 200);		
	dpKat.linkCtrl(cod, text);
	return dpKat;
}

DpAsk.prototype.addOrg = function addOrg()
{
	include("objects/DpOrg.js");
	var dpOrg = new DpOrg();
	dpOrg.setPeriod(new Date(2006,0,1), new Date(2006,7,1));
	var ctrl = this.addObj("DP_ORG", "string", null, 240);
	dpOrg.linkCtrl(ctrl);
	return 	dpOrg;
}

DpAsk.prototype.addJournal = function addJournal(mode)
{
	include("objects/DpZJournal.js");
	var dpJournal = new DpZJournal(mode);
	var panel = this.addPanel("Журналы: ", 2);
	var ctrl = panel.addObj("DP_JOURNAL", "string", null, 70);
	text = panel.addObj("DP_JOURNAL_TXT", "string", null, 200);
	dpJournal.linkCtrl(ctrl, text);
	return 	dpJournal;
}

DpAsk.prototype.addItog = function addItog(list,fl_zero)
{
	include("objects/DpItogs.js");
	var dpItog = new DpItogs(list);
	if(fl_zero)
		dpItog.canNoItog();
	var panel = this.addPanel(ru("С итогами по","З підсумками по"), 2);
	var cod = panel.addObj("ITOG_COD", "int", null, 70);
	var text = panel.addObj("ITOG_TXT", "string", null, 200);
	dpItog.linkCtrl(cod, text);
	return dpItog;
}

DpAsk.prototype.addContragent = function addContragent(fl_zero, codVal, bool)
{
	include("objects/DpCl.js");
	if(fl_zero)
		var dpCnt = new DpCl("0", getPar("CODPLAT"), codVal);
	else
		var dpCnt = new DpCl(getPar("CODPLAT"), codVal);
	var panel = this.addPanel("Код котрагента: ", 2);
	var cod = panel.addObj("CL_COD", "int", null, 70);
	var text;
	if (bool === true)
		text = panel.addObj("CL_TXT", "string", null, 200);
	dpCnt.linkCtrl(cod, text);
	return dpCnt;
}

DpAsk.prototype.addPodr = function addPodr(fl_zero,dat)
{
	include("Objects/DpStruOrg.js");
	var dpOrg = new DpStruOrg(fl_zero,dat);
	var panel = this.addPanel(ru("Подразделение","Підрозділ"), 1);
	var text = panel.addObj("TXT", "string", null, 200);
	dpOrg.linkCtrl(text);
	return dpOrg;
}

DpAsk.prototype.addSchet = function addSchet(is0,isSC,isSU,isST,isA1,isA2,isA3)
{
	include("objects/DpSc.js");
	dpSc = new DpSc(mode);
	var sc,su,st,a1,a2,a3;
	var mode = "";
	var panelSc = this.addPanel(UR("Рахунок|Счет"),3);
	if(isSC)
	{
		sc = panelSc.addObj("SC", "int", null, 40);
		mode+="c";
	}
	if(isSU)
	{
		su = panelSc.addObj("SU", "int", null, 40);
		mode+="u";
	}
	if(isST)
	{
		st = panelSc.addObj("ST", "int", null, 55);
		mode+="t";
	}
	if(isA1)
	{
		var panelAn = this.addPanel(UR("Аналітика|Аналитика"),3)
		if(isA1)
		{
			a1 = panelAn.addObj("A1", "int", null, 60);
			mode+="x";
		}
		if(isA2)
		{
			a2 = panelAn.addObj("A2", "int", null, 60);
			mode+="y";
		}
		if(isA3)
		{
			a3 = panelAn.addObj("A3", "int", null, 60);
			mode+="z";
		}
	}
	if(is0)
		mode+="0";
	dpSc.setMode(mode);
	dpSc.linkCtrl(sc,su,st,a1,a2,a3);
	return dpSc;
}

//для ЧТГ
//контрол для завала в справочник категорий потребителей
DpAsk.prototype.addKatPotr = function addKatPotr(fl_zero)
{
	include("objects/DpCl.js");
	if(fl_zero===true)
		var dpKP = new DpCl("0", 93, 0);
	else
		var dpKP = new DpCl(93, 0);
	var panel = this.addPanel(UR("Види бюджету|Виды бюджета"), 3);
	var cod = panel.addObj("CL_COD", "int", null, 70);
	var text = panel.addObj("CL_TXT", "str", null, 200);
	dpKP.linkCtrl(cod, text);
	return dpKP;
}

//для ЧТГ контрол для завала в 213 справочник групп товаров для отчётов
DpAsk.prototype.addGrpTovar = function addGrpTovar(fl_zero)
{
	include("objects/DpCl.js");
	if(fl_zero===true)
		var dpGT = new DpCl("0", 213, 0);
	else
		var dpGT = new DpCl(213, 0);
	var panel = this.addPanel(UR("Товарна група|Товарная группа"), 3);
	var cod = panel.addObj("CL_COD", "int", null, 70);
	var text = panel.addObj("CL_TXT", "str", null, 200);
	dpGT.linkCtrl(cod, text);
	return dpGT;
}

DpAsk.prototype.addCL = function addCL(ID, cl, txt, fl_zero)
{
	include("objects/DpCl.js");
	if(fl_zero===true)
		var dpCL = new DpCl("0", cl, 0);
	else
		var dpCL = new DpCl(cl, 0);
	var panel = this.addPanel(UR(txt), 3);
	var cod = panel.addObj(ID, "int", null, 70);
	var text = panel.addObj("CL_TXT", "str", null, 200);
	dpCL.linkCtrl(cod, text);
	return dpCL;
}

//для ЧТГ контрол для завала в 213 справочник групп товаров для отчётов
DpAsk.prototype.addGrpTovar = function addGrpTovar(fl_zero)
{
	include("objects/DpCl.js");
	if(fl_zero===true)
		var dpGT = new DpCl("0", 213, 0);
	else
		var dpGT = new DpCl(213, 0);
	var panel = this.addPanel(UR("Товарна група|Товарная группа"), 3);
	var cod = panel.addObj("CL_COD", "int", null, 70);
	var text = panel.addObj("CL_TXT", "str", null, 200);
	dpGT.linkCtrl(cod, text);
	return dpGT;
}

//справочник областей
DpAsk.prototype.addRegion = function addRegion(fl_zero)
{
	include("objects/DpCl.js");
	if(fl_zero===true)
		var dpRegion = new DpCl("0", getPar("CODREGION"), 0);
	else
		var dpRegion = new DpCl(getPar("CODREGION"), 0);
	var panel = this.addPanel(UR("Вибір області|Выбор области"), 3);
	var cod = panel.addObj("CL_COD", "int", null, 70);
	var text = panel.addObj("CL_TXT", "str", null, 200);
	dpRegion.linkCtrl(cod, text);
	return dpRegion;
}

//справочник районов
DpAsk.prototype.addArea = function addArea(fl_zero)
{
	include("objects/DpCl.js");
	if(fl_zero===true)
		var dpArea = new DpCl("0", getPar("CODAREA"), 0);
	else
		var dpArea = new DpCl(getPar("CODAREA"), 0);
	var panel = this.addPanel(UR("Вибір району|Выбор района"), 3);
	var cod = panel.addObj("CL_COD", "int", null, 70);
	var text = panel.addObj("CL_TXT", "str", null, 200);
	dpArea.linkCtrl(cod, text);
	return dpArea;
}

//справочник экономической деятельности
DpAsk.prototype.addEconomy = function addEconomy(fl_zero)
{
	include("objects/DpCl.js");
	if(fl_zero===true)
		var dpArea = new DpCl("0", 14, 0);
	else
		var dpArea = new DpCl(14, 0);
	var panel = this.addPanel(UR("Вид економ.діяльності|Вид эконом.деятельности"), 3);
	var cod = panel.addObj("CL_COD", "int", null, 70);
	var text = panel.addObj("CL_TXT", "str", null, 200);
	dpArea.linkCtrl(cod, text);
	return dpArea;
}

DpAsk.prototype.addLicf = function addLicf(fl_zero)
{
	include("Objects/DpLicf.js");
	dpLicf = new DpLicf(fl_zero?"Z":null);
	var panel = this.addPanel(UR("Особовий рахунок|Лицевой счет"), 3);
	var cod = panel.addObj("CL_COD", "int", null, 70);
	var text = panel.addObj("CL_TXT", "str", null, 200);
	dpLicf.linkCtrl(cod, text);
	return dpLicf;
}

//справочник МВВ (Укртелеком)
DpAsk.prototype.addClMVV = function addClMVV(fl_zero)
{
	include("objects/DpCl.js");
	if(fl_zero===true)
		var dpMVV = new DpCl("0", 21, 0);
	else
		var dpMVV = new DpCl(21, 0);
	var panel = this.addPanel(UR("Вибір кода місця виникнення витрат|Выбор кода места возникновения затрат"), 3);
	var cod = panel.addObj("CL_COD", "int", null, 70);
	var text = panel.addObj("CL_TXT", "str", null, 200);
	dpMVV.linkCtrl(cod, text);
	return dpMVV;
}

//справочник организаций (Укртелеком)
DpAsk.prototype.addClOrg = function addClOrg(fl_zero)
{
	include("objects/DpCl.js");
	if(fl_zero===true)
		var dpOrg = new DpCl("0", 201, 0);
	else
		var dpOrg = new DpCl(201, 0);
	var panel = this.addPanel(UR("Вибір організації|Выбор организации"), 3);
	var cod = panel.addObj("CL_COD", "int", null, 70);
	var text = panel.addObj("CL_TXT", "str", null, 200);
	dpOrg.linkCtrl(cod, text);
	return dpOrg;
}

//справочник МВВ (Укртелеком для кода орг. - расширения справочника №27)
DpAsk.prototype.addIDOrg = function addIDOrg(fl_zero)
{
	include("objects/DpCl.js");
	if(fl_zero===true)
		var dpOrg = new DpCl("0", 21, 0);
	else
		var dpOrg = new DpCl(21, 0);
	var panel = this.addPanel(UR("Вибір організації|Выбор организации"), 3);
	var cod = panel.addObj("CL_COD", "int", null, 70);
	var text = panel.addObj("CL_TXT", "str", null, 200);
	dpOrg.linkCtrl(cod, text);
	return dpOrg;
}

//справочник календарей
DpAsk.prototype.addCalendar = function addCalendar(fl_zero)
{
	include("objects/DpCalendar.js");
	if(fl_zero===true)
		var dpCal = new dpCalendar("0");
	else
		var dpCal = new dpCalendar();
	var panel = this.addPanel(UR("Вибір календаря|Выбор календаря"), 3);
	var cod = panel.addObj("COD", "int", null, 70);
	var text = panel.addObj("TXT", "str", null, 200);
	dpCal.linkCtrl(cod, text);
	return dpCal;
}

DpAsk.prototype.addRsc = function addRsc(fcl,fcod,frsc)
{
	include("objects/DpCl.js");
	include("Objects/DpPostRs.js");
	oOrg = new DpCl("",(fcl?fcl:getPar("CODPLAT")),fcod);
	var panel1 = this.addPanel(UR("Організація|Организация"), 1);
	var org = panel1.addObj("ORG", "str", null, 250);
	oOrg.linkSmartCtrl(org);
	var oSch = new DpPostRs();
	oSch.setDpCl(oOrg, true);
	var panel2 = this.addPanel(UR("Розрахунковий рахунок|Расчетный счет"), 2);
	var rsc = panel2.addObj("RSC", "str", null, 165);
	var mfo = panel2.addObj("MFO", "str", null, 80);
	var panel3 = this.addPanel(UR("Назва банку|Название банка"), 1);
	var bnk = panel3.addObj("BNK", "str", null, 250);
	oSch.linkCtrl(rsc, mfo, bnk);
	if(frsc)
	{
		rsc.value = frsc;
		oSch.validCl();
		oSch.validCtrl();
	}
	return oSch;
}

DpAsk.prototype.setJavaDpAsk = function setJavaDpAsk(javaDpAsk) {
	this.dpAskFRM = javaDpAsk;
}

DpAsk.prototype.setFormValid = function setFormValid(oCtrl,obj,sFunc) {
	if (typeof obj == "function")
	{
		var funcName = String(obj.name);
		try
		{
			if (eval(funcName) != "undefined")
				return;
			obj = this.addFunction(obj);
		}
		catch(x)
		{
			obj = this.addFunction(obj);	
		}
	}
	setValid(oCtrl,obj,sFunc);
}

DpAsk.prototype.addFunction = function addFunction(func) {
	var funcName = String(func.name);
	eval(String(func));
	return eval(funcName);
}

DpAsk.prototype.validateAll = function validateAll()
{
	var ctrls = new Array();
	if (typeof(FORM.getControls) == "function")
	{
		ctrls = FORM.getControls(); 
	}

	for (var i = 0; i < ctrls.length; i++)
	{
		var oCtrl = eval(String(ctrls[i]));	
		if (typeof(oCtrl) == "undefined" || !oCtrl)
			continue;
	
		if (typeof(oCtrl.isEnabled) != "undefined")
		{
			if (!oCtrl.isEnabled())
				continue;
		}
		
		if (typeof(oCtrl.isVisible) != "undefined")
		{
			if (!oCtrl.isVisible())
				continue;
		}
		
		if (Task.validate(oCtrl) == false)
		{
			setFocus(oCtrl);			
			this.bSaving = false;
			return false;
		}		
	}
	return true;
}

var dpAsk = new DpAsk();