// Шатохин В.В.	08.09.2003
// Объект для формирования диалога запроса данных
// Использует ask_dlg.htm

// 01.10.2003 Добавлена возможность запроса "С итогами по"
// Для сопряжения с DpList'ом пришлось добавить поле fitog
// в котором хранится номер выбранного итога

// 17.11.2003 Добавлена возможность добавить переменную,
// которая не будет запрашиваться у пользователя, а будет возвращать значение
// по умолчанию. За эту функциональность отвечает "-" в mode

// 25.03.2004 Добавлена возможность спросить поле ЛС (зарплата)
// mode=="LS"
// 01.04.2004 Добавлена возможность спросить директорию
// mode=="DIR"
// 01.04.2004 Добавлена возможность спросить файл
// mode=="FILE"
// 06.04.2004 Добавлена возможность вставить строку текста
// mode=="REM"
// 06.04.2004 Добавлена возможность вставить разделитель HR
// mode=="HR"
// 23.06.2004 Добавлена возможность спросить код группы ОС
// mode=="GROS"
// 23.06.2004 Добавлена возможность спросить код нормы амортизации  ОС
// mode=="CODNORM"
// 23.06.2004 Добавлена возможность спросить код вида ОС
// mode=="VIDOS"
// 25.08.2004 Добавлена возможность создать COMBOBOX
// mode=="COMBO"
// 25.08.2004 Добавлена возможность создать RADIOBUTTON
// mode=="RADIO"
// ksm 11.01.2005 Добавлена возможность спросить код справочника аналитики
// mode=="CLCL"
// ksm 19.01.2005 Добавлена возможность спросить код из справочника аналитики c подстановкой
// mode=="SMARTCL"
// 25.01.2005 Добавлена возможность тушить/зажигать контролы по условию
// метод enable()
// 17.02.2005 Добавлена возможность выбора папок документов.
// 13.12.2006 IG 13 Добавлена возможность навешивать валидацию на контролы
// oA.setValid(name, func)

// 09.01.2007 Добавлена возможность завала в справочник рецептов
// mode == "RECEPT"
// 09.01.2007 Добавлена возможность завала в прайслисты
// mode == "PRICE"
// 21.02.2008 Добавлена возможность спросить код единицы измерения
// mode == "EDI"

// 06.01.2009 Добавлена возможность спрашивать параметры для учета ОС
// mode == "UOSEX"

// 03.11.2009 Добавлена возможность спросить код валюты
// mode == "VAL"
// 03.11.2009 Добавлена возможность завала в справочник банков
// mode == "BNK"

// 02.12.2009 Добавлена возможность завала в шифры производственных затрат
// mode == "SHPZ"

// 02.12.2009 Добавлена возможность спросить код подсправочника без указания родителя
// mode == "RELP"

// Схема использования
//	oA = new DpAskEx();
//	oA.add(mode, descr, name, defVal, par1, par2)
//	oA.add(mode2, descr2, name2, defVal2, par1_2, par2_2)
//	oA.setRel("<=", name, name2)
//	oA.addItog(mode, label)
//	oA.enable(varname, sExpr);
//	oA.doAsk();
//	if(!oA.escape){
//		val = oA.get(name);
//		...
//	}

// mode принимает значения
// "B"			BOOL
// "D"			DATETIME
// "T"			TEXT
// "NUM"		Numeric
// "NMK[0][.]"	Код номенклатуры
// "CL[0]"		Код из справочника аналитики
// "REL[0]"		Код из подсправочника
// "RELP[0]"	Код из подсправочника без родителя
// "C[0][U[T[X[Y[Z]]]]]"		Счет. Режим такой же, как у DpSc
// "LS[0]"		код из справочника лицевых счетов
// "DIR[0]"		Директория
// "FILE[0]"	Файл
// "REM"		Комментарий. Просто выводим строку текста на диалоге
// "HR"			Просто выводим HR на диалоге
// "RECEPT"		номер рецепта
// "PRICE"		прайслист
// "EDI"		Код единицы измерения
//
// mode может содержать "-" - признак того, что значение запрашивать
// у пользователя не будем, а воспользуемся умолчанием

// descr - Название, выводимое рядом с контролом, вида "УКР|РУС"

// name  - имя поля на объекте, в котором будет
// содержаться введенное значение

// defVal - значение по умолчанию
// Значение по умолчанию подставляем только для тех "переменных",
// которые невидимы (mode содержит "-")
// В остальных случаях умолчание будет использоваться в ф-ции getParWithDef()

// для par1, par2 смысл зависит от конкретного режима:

// "B"		BOOL
// "D"		DATETIME
// "NMK"	Код номенклатуры
//		oA.add(mode, descr, name, defVal)
// "T"		TEXT
//		oA.add(mode, descr, name, defVal, length, height)
//			length - длина поля
//			height - высота контрола, если нужно создать текстовое поле с переносом строк
// "NUM"	Numeric
//		oA.add(mode, descr, name, defVal, length, fract) 
//			length - кол-во цифр
//			fract - кол-во знаков после запятой
// "CL"		Код из справочника аналитики
//		oA.add(mode, descr, name, defVal, clNum)
//			clNum - номер справочника аналитики
// "REL"	Код из подсправочника
//		oA.add(mode, descr, name, defVal, clNum, parentVar)
//			clNum - номер справочника аналитики
//			parentVar имя переменной - "родителя"()
// "RELP"	Код из подсправочника без родителя
//		oA.add(mode, descr, name, defVal, clNum)
//			clNum - номер справочника аналитики
// "C[0][U[T[X[Y[Z]]]]]"		Счет. Режим такой же, как у DpSc
// text = CUT (счет) - выводить название счета
//		oA.add(mode, descr, name, defVal, text)
//			defVal имеет вид "20|201|0|323"
// "LS"	код из справочника лицевых счетов
//		oA.add(mode, descr, name, defVal)
// "DIR"	Директория
//		oA.add(mode, descr, name, defVal, length)
// "FILE"	Файл
//		oA.add(mode, descr, name, defVal, szExt, szDscr, szDir)
//
//		szExt = "*.doc;*.xls;*.rpt;*.frm"
//
//		szDscr = "Документы MS Word (*.doc)|*.doc|"
//		+ "Документы MS Excel (*.xls)|*.xls|"
//		+ "Отчеты Crystal Reports (*.rpt)|*.rpt|"
//		+ "Формы печати DOS (*.frm)|*.frm|"
//		+ "Все файлы (*.*)|*.*"
//
//		szDir = userDirectory()+"\\office"
//
// "REM"	комментарий. Просто выводим строку текста на диалоге
//		oA.add(mode, descr, name)
// "HR"	Просто выводим HR на диалоге
//		oA.add(mode, null, name)
// "GROS"	код из справочника групп ОС
//		oA.add(mode, descr, name, defVal, dat)
//			dat - дата, на которую показывать справочник.
//				по умолчанию - текущая
// "CODNORM"	код из справочника норм амортизации непроизв.ОС и немат. активов
//		oA.add(mode, descr, name, defVal, dat)
//			dat - дата, на которую показывать справочник.
//				по умолчанию - текущая
// "VIDOS"	код из справочника видов ОС
//		oA.add(mode, descr, name, defVal)
// "COMBO"	COMBOBOX (Выпадающий список)
//		oA.add(mode, descr, name, defVal, szList, txtToVal)
//		defVal - номер варианта по умолчанию (считаем с нуля)
//		szList - "Вариант 1|Вариант 2|Вариант 3"
//		txtToVal - true (необязателен, по умолчанию false)
// "RADIO"	RADIOBUTTON
//		oA.add(mode, descr, name, defVal, szList)
//		defVal - номер варианта по умолчанию (считаем с нуля)
//		szList - "Вариант 1|Вариант 2|Вариант 3"
// ksm 11.01.2005 
// "CLCL"	Код справочника
//		oA.add(mode, descr, name, defVal)

// ksm 19.01.2005 
// "SMARTCL" Код из справочника аналитики c подстановкой
//		oA.add(mode, descr, name, defVal, clNum,isDisableOptimize)
//			clNum - номер справочника аналитики
//			isDisableOptimize  - отключать ли оптимизацию
// "SMARTCLREL" Код из справочника аналитики c подстановкой
//		oA.add(mode, descr, name, defVal, clNum,isDisableOptimize,superCL)
//			clNum - номер справочника аналитики
//			isDisableOptimize  - отключать ли оптимизацию
//			superCL - надсправочник.
// 17.02.2005 
// CL_LNK - Выбор папки документов.
//		oA.add(mode, descr, name, defDoc|defNop, docLimit)
//			defDoc -Папка
//			defNop - № операции.
//			docLimit - перечень папок для отбора через запятую ("'NK','NN'")

// "RECEPT"	Код справочника рецептов
//		oA.add(mode, descr, name, defVal, EditRecept)
// "PRICE"	Прайслист
//		oA.add(mode, descr, name, defVal)

// "EDI"	Код единицы измерения
//		oA.add(mode, descr, name, defVal)

// "UOSEX"
//		oA.add(mode, descr, name, defVal, oCore)
//		mode - режим
//		descr - null
//		name - UOSCORE
//		defVal - null
//		oCore - настроенный объект DpUosexCore
//		oA.add("UOSEX", null, "UOSCORE", null, oUosexCore)

// для использования Enable или style.display:
//	задаем условие через .defCond(cond, alias)
//		cond - само условие, можно использовать this(DpAskEx),
//			this.aQryList['имя контрола'].controls[0] - контрол
//		alias - идентификатор условия
//	обьявляем обьект через .enable(sName, alias)
//	обьявляем объект через .visible(sName, alias)
//		sName - имя контрола
//		alias - идентификатор условия

// "VAL"	Код валюты
//		oA.add(mode, descr, name, defVal)
// "BNK"	Банки
//		oA.add(mode, descr, name, defVal)

// "SHPZ"	Шифры производственных затрат
//		oA.add(mode, descr, name, defVal)

// "CONST"	Спрашивать будет объект констант
//		oA.add(mode, descr, name, oConst)
//		oConst - объект DpConst
//	!!!Устаревшее описание: теперь вместо isDat, isHist, isCause следует использовать oConst.drawMode
//	!!!	oA.add(mode, descr, name, oConst, isDat, isHist, isCause)
//	!!!	oConst - объект DpConst
//	!!!	isDat - показывать дату изменения
//	!!!	isHist - показывать историю изменения
//	!!!	isCause - показывать причину изменения

// "MULTISEL"	Список выбора нескольких элементов из справочника аналитики или номенклатуры
//		oA.add(mode, descr, name, oMultiSelect)
//		oMultiSelect - объект DpMultiSelect

// "CNTRCT" Спрашивать будет объект договоров DpCntrct
//	oA.add(mode, descr, name, defVal, org);
//	org - организация, если надо по конкретной организации
//vlad 16.01.2011
// теперь org может принимать такие значения:
//1) inList(objTypeOf(org), "number", "Number") - org трактуем, 
// как код из справочника контрагентов
//2) inList(objTypeOf(org), "DpCl") - org трактуем, как объект DpCl,
// хранящий код из справочника контрагентов
//3) inList(objTypeOf(org), "string", "String") - org трактуем, как "метку",
// объекта "код из справочника контрагентов", привязанного к нашему объекту DpAskEx,
// например:
//		oA.add("CL", "Организация", "ORG", 0, sprOrg);
//		oA.add("CNTRCT", "Договор", "DOG", 0, "ORG");

// "SBCS" Спрашивать объект сберкасс DpSbcs
// oA.add(mode, descr, name, defVal);

// появилась необходимость использовать умолчания не для всех конролов формы
// а только для некоторых
// в строковую переменную strUseDefsOnly через запятую перечисляем имена контролов
// его как и oAsk.useDefsOnly описываем перед oAsk.add

include("sys\\mask.js");
include("Objects\\DpCl.js");
include("GetParam.js");	// для getParWithDef(), setParWithDef()

function DpAskEx(mode){
	RO("DpAskEx", this);
	// public:
	this.mode			= mode;				// Режим.

	this.sysname		= getSysName();
	this.sysname		= this.sysname.substring(this.sysname.lastIndexOf('|')+1, this.sysname.length);
					
	this.Itog			= null;					// Объект итогов
	this.fitog			= null;					// Номер варианта упорядочивания
	this.showScroll		= false;				// добавлять ли на форму спрашивания скролл

	this.add			= DpAskEx_add;			// Добавить новый элемент в список запроса
	this.addItog		= DpAskEx_addItog;		// Включить запрос варианта упор. и итогов
	this.addStd			= DpAskEx_addStd;		// Добавить стандартные элементы
	this.doAsk			= DpAskEx_doAsk;		// Выполнить запрос
	this.get			= DpAskEx_get;			// вернуть введенное значение параметра

	this.setRel			= DpAskEx_setRel;			// Установить отношение между 2-мя контролами

	this.getEval		= DpAskEx_getEval;			// вернуть объект DpEval, на который будут "навешены" как переменные введенные значения
	
	this.loadFromTbl	= DpAskEx_loadFromTbl		//загрузится из таблицы
	this.save			= DpAskEx_save				//Сохранить параметры расчета.
	this.getDirectValue	= DpAskEx_getDirectValue;	//Функция возвращает точное значение контрола для загрузки.
	this.loadDirectValue= DpAskEx_loadDirectValue;	//Функция загружает прямые значения;
	this.getCtrlType	= DpAskEx_getCtrlType;		//Функция возвращает тип,поле,розделитель(для текстовых)
	this.clear			= DpAskEx_clear;			//Очистить масивы с данными.

	this.setValid		= DpAskEx_setValid;			// установка функции валидации на контрол

	this.defCond		= DpAskEx_defCond;			//Функция задает условие 
	this.enable			= DpAskEx_enable;			//Добавить условие на зажжение контрола
	this.visible		= DpAskEx_visible;			//Добавить условие на видимость контрола
	this.validEnable	= DpAskEx_validEnable		// управляет видимостью контролов
	
	// Возвращает значение из контрола с порядковым номером nIndex 
	// для переменной sName
	// Предназначена для использования в условиях, передаваемых this.enable()
	this.immediate		= DpAskEx_immediate;

	this.load			= DpAskEx_load;

	this.setCaption		= DpAskEx_setCaption; 
	this.getCaption		= DpAskEx_getCaption; 

	//для истории
	this.saveHistory		= DpAskEx_saveHistory; 
	this.delHistory		= DpAskEx_delHistory; 	

	/*
	this.getVarsEval = DpAskEx_getVarsEval;	//ф-ция-заглушка. Вернет this. Нужна для подсправочников
	this.eval = this.get;					//ф-ция-заглушка. Нужна для подсправочников
	*/
	//Есть ли видимые контолы
	this.hasVisibleControls = false;
	this.escape = true;
	this.isDirectLoad	= false;		//Загружать ли точно указаные параметры.
	
	this.useDefsOnly	= false;		//Использовать только значения по умолчанию.
	this.strUseDefsOnly = "";			//перечень контролов для умолчаний
	this.aUseDefsOnly = null;			//масив контролов для умолчаний
	this.useDefsParse = DpAskEx_useDefsParse;	//масив контролов для умолчаний
	
	this.notClearCtrl	= false;		//Не очищать контрол если он задизейблин 

	this.aDirectValues	= new Array();	//Массив прямых значений
	
	this.aValues2Save	= new Array();//Массив значений.
	// private:
	this.aQryList		= new Object();	// Массив, в котором запомним список запрашиваемых данных
	this.aConditions	= new Object();	// Массив, условий.
	this.aEnables		= new Array();	// Массив со списком выражений зажигания/тушения контролов
	this.aVisibles		= new Array();	// Массив со списком выражений видимости контролов
	this.aCtrlValid		= new Array();	// Массив функций валидаций для контролов

	this.aTabIndex		= new Array();	// Массив, в котором запомним порядок запрашиваемых данных

	this.tblParNameDef	= "^ASKDATA";	// Имя таблицы по умолчанию, в которой хранятся параметры
	this.aStdHandlers	= new Array();	//Массив обработчиков стандартных добавлений.
	
	//для названия окна при опросе 
	this.caption		= "Введiть данi для вiдбору iнформацii|Введите данные для отбора информации";
	this.form = null;
}

function DpAskEx_doAsk()
{
	if (this.hasVisibleControls)
	{
		showWindow("ask_dlg.xml", SW_MODAL, this);
	}
	return !this.escape;
}

// Включить запрос варианта упор. и итогов
// mode		если "0", то допустим ввод "без итога"
// label	метка итогов
function DpAskEx_addItog(mode, label,szTable,szHtml){
	include("Objects\\DpItogs.js");
	this.Itog = new DpItogs(label,szTable,szHtml); // Установить текущую задачу
	//Itog.linkCtrl(mItog,mItogText);
	if(mode=="0"){
		this.Itog.canNoItog();
	}
        // Подтянем номер итога из параметров
	var nItog = getParWithDef("FITOG", this.sysname, 0);
	this.Itog.setCod(nItog);
}

// Добавить новый элемент в список запроса
// Описание параметров см. в начале файла
function DpAskEx_add(mode, descr, name, defVal, par1, par2, par3){
	mode = mode.toUpperCase();

	// создаем объект, который будет владеть всем, что касается добавляемого
	// элемента, и добавляем его в массив
	var obj = new Object();
	obj.mode = mode;
	
	// vvs 25.01.2005
	// Массив контролов
	obj.controls = new Array()

	// vvs 18.11.2003
	// Будет ли "видимым"
	obj.visible = !strIn("-", mode);
	this.hasVisibleControls |= obj.visible;

	obj.descr = descr;
	//Обычный порядок загрузки
	if (!this.isDirectLoad)
	{
		// для видимых эл-тов подтянем умолчание из параметров
		//fruckt - добавили возможнось значений по умолчанию для конкретных параметров 
		//if(!isEmpty(name) && obj.visible && this.useDefsOnly == false)
		if(!isEmpty(name) && obj.visible && this.useDefsOnly == false && this.useDefsParse(name) == false)
			obj.defVal = getParWithDef(name, this.sysname, defVal);
		else
			obj.defVal = defVal;
	}
	else
	{
		obj.defVal = this.getDirectValue("", name, obj.visible, defVal)
	}

	obj.par1 = par1;
	obj.par2 = par2;

	// для поддержки "отношений" между переменными
	obj.relations = null;


	// в зависимости от типа или проинициализируем obj.value, или
	// создадим соответствующий объект и проинициализируем его

	// выделим из режима тип - удалим нули и точки
	// vvs 18.11.2003 а также минусы
	//var sType = mode.replace(/0|\./gi, "")
	var sType = mode.replace(/-|0|\./gi, "")

	obj.is0 = strIn("0", mode)

	switch(sType){
	case "B":
		obj.type = sType;
		obj.checked = obj.defVal==null ? false : obj.defVal;
		break;
	case "D":
		obj.type = sType;
		if(typeOf(obj.defVal).toLowerCase()=="string")
			obj.defVal = strToDateFormat(obj.defVal.substr(0,8),"dd.mm.yy");
		obj.value = new Date((!isDateType(obj.defVal) ? d00 : obj.defVal)).getVarDate();
		break;
	case "T":
		obj.type = sType;
		obj.value = isEmpty(obj.defVal) ? "" : obj.defVal;
		// par1 - длина
		len = par1 ? par1 : 10;
		obj.mask = replicate("&", len);
		obj.width = 20;//len;
		if(par2)
			obj.height = par2;
		break;
	case "REM":
		obj.type = sType;
		obj.value = null;
	case "HR":
		obj.type = sType;
		obj.value = null;
		break;
	case "DIR":
		obj.type = sType;
		obj.value = obj.defVal==null ? "" : obj.defVal;
		// par1 - длина
		len = par1 ? par1 : 255;
		obj.mask = replicate("&", len);
		//obj.width = par1;
		obj.width = 57;
		break;
	case "FILE":
		obj.type = sType;
		obj.value = obj.defVal==null ? "" : obj.defVal;
		//len = par1 ? par1 : 255;
		len = 255;
		obj.mask = replicate("&", len);
		//obj.width = par1;
		obj.width = 30;
		obj.ext = par1 ? par1 : "*.*";		//szExt;
		obj.fdescr = par2 ? par2 : "Все файлы (*.*)|*.*";		//szDscr;
		obj.dir = par3 ? par3 : "";		//szDir;
		break;
	case "NUM":
		obj.type = sType;
		obj.value = obj.defVal==null ? 0 : obj.defVal;
		// par1 - длина
		// par2 - дробных знаков
		var dr = par2 ? par2 : 0;
		var dec = (par1 ? par1 : 10) - dr;
		// Защита "от дурака":
		dec = dec<=0 ? 1 : dec
		obj.mask = "-"+replicate("#",dec) + (dr > 0 ? ("." + replicate("#",dr) ) : "") ;
		break;
	case "COMBO":
	case "RADIO":
		obj.type = sType;
		obj.value = obj.defVal == null ? 0 : obj.defVal;
		// par1 - список вариантов, разделенных вертикальной чертой
		obj.options = String(par1).split("|");
		
		//fruckt
		//предусмотрим случай когда нам надо передать не только текстовку но и значения
		var values = false;
		if (!isEmpty(par2))
		{
			var parType = objTypeOf(par2);
			switch (parType)
			{
				case "boolean":
					values = true;
				break;
				case "string":
					values = String(par2).split("|");
				break;
				case "Array":
					values = par2;
				break;
			}
		}
			
		obj.values = values;
	break;
	case "NMK":
		obj.type = sType;
		include("Objects\\DpNmkl.js");
		//var oNmk = new DpNmkl((isEmpty(obj.defVal)?"":String(obj.defVal)),(isEmpty(par1)?"":par1));
		//vvs для того, чтобы считало, что передан FWID
		var oNmk = new DpNmkl((isEmpty(obj.defVal)?0:obj.defVal),(isEmpty(par1)?"":par1));
		oNmk.CanSelectAll = obj.is0;
		oNmk.CanSelectGroup = strIn(".", mode);

		obj.value = oNmk;
		break;
	case "LS":
		obj.type = sType;
		include("Objects\\DpLicf.js");
		var oLs = new DpLicf(obj.is0 ? "Z" : "");
		var cod = obj.defVal ? obj.defVal : 0;  
	    var tLic = OpenTable("s","SELECT * FROM ^LIC_FLD WHERE FID="+sqlTo(cod));
	    if(!tLic.IsEmpty())
		{
			tLic.MoveFirst();
	        oLs.setFnum(tLic.getValue("FFLD_NUM"));
	        oLs.setFtxt(tLic.getValue("FTXT"));
	    }
	    tLic.close(5652);
	    tLic = null;
		
		oLs.setFid(cod)
		obj.value = oLs;
		break;
	case "GROS":
		obj.type = sType;
		//par1 - дата, на к-ю открываем справочник
		if(!par1){
			par1 = today;
		}
		include("Objects\\DpGr.js");
		var oGr = new DpGr(obj.is0?"0":"");
		//MaxKo 31 01 2004
				oGr.setCod(obj.defVal, par1, par1)
//		oGr.setCod(obj.defVal, new Date(), new Date())
//		oGr.setMode(obj.is0?"0!":"")
		obj.value = oGr;
		break;
	case "CODNORM":
		obj.type = sType;
		//par1 - дата, на к-ю открываем справочник
		if(!par1)
		{
			par1 = today;
		}
		
		include("Objects\\DpAm.js");
		var oAm = new DpAm();
		oAm.setMode(obj.is0 ? "0" : "");
		oAm.setCod(obj.defVal)
		obj.value = oAm;
		
		break;
	case "VIDOS":
		obj.type = sType;
		include("Objects\\DpKompl.js");
		var oVid = new DpKompl();
		oVid.allow0 = obj.is0;
		oVid.setCod(obj.defVal)
		obj.value = oVid;
		break;
	case "SMARTCLREL":
		obj.isU = true;
	case "SMARTCL":
		obj.type = sType;
		// par1 - номер справочника
		// par2 - объект надсправочника.
		obj.isDisableOptimize = par2
		oSuperCl = this.aQryList[par3];
		if(oSuperCl){
			// Получим объект DpCl
			oSuperCl = oSuperCl.value;
		}
		var oSmartCl = new DpCl( obj.is0 ? "0!" : "", par1, obj.defVal);
//устаревший код с 2000-й версии
//		include("Objects\\DpSmartCl.js");
//		if (typeof(oSuperCl)=="object")
//		{
//			oSmartCl = new DpSmartCl( (obj.isU?"U":"")+(obj.is0?"0":""),  par1, obj.defVal,oSuperCl);
//		}else{
//			oSmartCl = new DpSmartCl((obj.isU?"U":"")+(obj.is0?"0":""),  par1, obj.defVal);
//		}
//		oSmartCl.isDisableOptimize = obj.isDisableOptimize;
		obj.value = oSmartCl;
		break;
	case "CL":
		obj.type = sType;
		// par1 - номер справочника
		include("Objects\\DpCl.js");
		var oCl = new DpCl( obj.is0 ? "0!" : "", par1, obj.defVal);
		obj.value = oCl;
		break;
	case "CALEND":
		obj.type = sType;
		// par1 - номер справочника
		include("Objects\\dpCalendar.js");
		var oCalend = new dpCalendar();
		oCalend.setCod(Number(obj.defVal));
		obj.value = oCalend;
		break;
	case "CLCL":
		obj.type = sType;
		// par1 - номер справочника
		include("Objects\\DpClCl.js");
		var oClcl = new DpClcl( obj.is0? "0!" : "", obj.defVal);
		obj.value = oClcl;
		break;
	case "EDI":
		obj.type = sType;
		include("Objects\\DpEdi.js");
		var mode = (obj.is0 ? "0" : "");
		var oEdi = new DpEdi(mode);
		oEdi.setCod(obj.defVal);

		var str = "" 
				+"{"
				+ " return this.aQryList['"+name+"'].value.zSetTxts(this.aQryList['"+name+"'].controls[0].value);"
				+"}";
		eval("chk"+name+" = new Function(str)");
		this.setValid(name, "chk"+name);
		
		obj.value = oEdi;
		break;
	case "VAL":
		obj.type = sType;
		include("Objects\\DpVal.js");
		var mode = (obj.is0 ? "0" : "");
		var oVal = new DpVal(mode);
		oVal.setCod(obj.defVal);
		obj.value = oVal;
		break;
	case "BNK":
		obj.type = sType;
		include("Objects\\DpBank.js");
		var mode = !obj.is0;
		var oBnk = new DpBank(mode);
		oBnk.setMFO(obj.defVal);
		obj.value = oBnk;
		break;
	case "SHPZ":
		obj.type = sType;
		include("Objects\\DpShifPZ.js");
		var mode = !obj.is0;
		var oShpz = new DpShifPZ();
		oShpz.setUseZiro(mode);
		oShpz.setFshpz(obj.defVal);
		oShpz.setFtxt("");
		obj.value = oShpz;
		break;
	case "CL_LNK":
		obj.type = sType;
		// задано умолчание вида "PN|20"
		var aDef = String(obj.defVal).split("|");
		// par1 - номер справочника
		include("Objects\\DpzDoc.js");
		var oCllnk = new DpzDoc();
		oCllnk.pFdoc = aDef[0] ? String(aDef[0]) : "";
		oCllnk.pFnop = aDef[1] ? Number(aDef[1]) : 0;
		oCllnk.onlyDoc = isEmpty(obj.par1) ? null : obj.par1;
		oCllnk.zeroIsValid = obj.is0
		obj.value = oCllnk;
		break;
	case "REL":
		obj.type = "REL";
		// par1 - номер справочника
		// par2 - имя переменной. Должна быть кодом из надсправочника
		oSuperCl = this.aQryList[par2];
		if(oSuperCl){
			// Получим объект DpCl
			oSuperCl = oSuperCl.value;
		}

		// Проверка на то, чтобы была переменная par2
		// !!! Нужна проверка построже - на тип объекта DpCl
		if(typeof(oSuperCl)=="object"){
			// Так не заработало
			//var oCl = new DpCl("U"+(is0?"0":""), par1, defVal, this.getVarsEval, par2);
			var oCl = new DpCl("U"+(obj.is0?"0":""), par1, obj.defVal, oSuperCl);
			obj.value = oCl;
		} else {
			// в par2 НЕ имя переменной, являющейся объектом
			obj = null;
		}
		break;
	case "RELP":
		obj.type = sType;
		// par1 - номер справочника
		include("Objects\\DpCl.js");
		var oCl = new DpCl( "P"+(obj.is0 ? "0!" : ""), par1, obj.defVal);
		obj.value = oCl;
		break;
	case "C":
	case "CU":
	case "CUT":
	case "CUTX":
	case "CUTXY":
	case "CUTXYZ":
		obj.type = sType;
		obj.aDef = [0,0,0,0,0,0];
		include("Objects\\DpSc.js");
		
		// Рома 08.09.2010 DpSc сам это сделает
		//mode = mode.replace("0", "0-");
		
		if(objTypeOf(obj.defVal) == "string" || objTypeOf(obj.defVal) == "String")
		{
			// задано умолчание вида "20|201|1"
			var aDef = String(obj.defVal).split("|");
			
			// приведем к числовому типу
			for(var ind in aDef)
			{
				aDef[ind] = parseInt(aDef[ind], 0);
			}

			switch (sType)
			{
				case "C":
					aDef[1] = 0;
				case "CU":
					aDef[2] = 0;
				case "CUT":
					aDef[3] = 0;
				case "CUTX":
					aDef[4] = 0;
				case "CUTXY":
					aDef[5] = 0;
				break;
			}

			var oSc = new DpSc();
			oSc.setMode(mode);
			obj.aDef = aDef;
		}
		else
		{
			var oSc = new DpSc();
			oSc.setMode(mode);
		}
		
		obj.value = oSc;
		obj.value.text = par1;
		break;

	case "RECEPT":
		obj.type = sType;
		include("Objects\\DpRecept.js");
		var oRec = new DpRecept();
		oRec.setCod(obj.defVal);
		oRec.EditRecept = par1;
		oRec.CanZero = obj.is0;
		obj.value = oRec;
		break;

	case "PRICE":
		obj.type = sType;
		include("Objects\\DpPrList.js");
		var oPrice = new DpPrList();
		oPrice.setCod(obj.defVal);
		obj.value = oPrice;
		break;

	case "UOSEX":
		obj.type = sType;
		obj.value = par1;
	break;

	case "CONST":

		obj.type = sType;

		obj.value = defVal;
		
		if (!isEmpty(descr))
		{
			obj.value.setDescription(descr);
		}

		//vlad 13.05.2010
		// obj.isDat, obj.isHist, obj.isCause умерли.
		//теперь используется obj.value.drawMode
		/*
		obj.isDat = false;
		if (!isEmpty(par1))
		{
			obj.isDat = true;
		}
		
		obj.isHist = false;
		if (!isEmpty(par2))
		{
			obj.isHist = true;
		}
		
		obj.isCause = false;
		if (!isEmpty(par3))
		{
			obj.isCause = true;
		}
		*/
/*
		//после установки всех параметров инициализируем обьект контрола константы
		if (!isEmpty(oConst.sup))
		{
			obj.value.obj.setCl(oConst.sup);
		}
*/		
	break;

	case "MULTISEL":
		obj.type = sType;
		obj.value = defVal;
	break;
	
	case "CNTRCT":
		obj.type = sType;
		include("Objects\\DpCntrct.js");
		var md = "+";
		md += obj.is0 ? "0" : "";
		codOrg = par1 ? par1 : null;
		//vlad 16.01.2011
		// теперь org может принимать такие значения:
		//1) inList(objTypeOf(org), "number", "Number") - org трактуем, 
		// как код из справочника контрагентов
		//2) inList(objTypeOf(org), "DpCl") - org трактуем, как объект DpCl,
		// хранящий код из справочника контрагентов
		//3) inList(objTypeOf(org), "string", "String") - org трактуем, как "метку",
		// объекта "код из справочника контрагентов", привязанного к нашему объекту DpAskEx,
		//var oCntrct = new DpCntrct(md, codOrg);		
		var oCntrct = new DpCntrct(md);
		switch (objTypeOf(codOrg))
		{
			case "number":
			case "Number":
				oCntrct.setOrg(codOrg);	// как код из справочника контрагентов
				break;
			case "DpCl":
				oCntrct.setCl(codOrg);	// объект DpCl, хранящий код из справочника контрагентов
				break;
			case "string":
			case "String":
				oCntrct.setCl(this.get(codOrg));// codOrg - "метка" контрола, привязанного к нашему объекту DpAskEx
				break;
		}

		oCntrct.setID(toScrObj(obj.defVal));		
		obj.value = oCntrct;		
	break;
	case "SBCS":
		obj.type = sType;
		include("Objects\\DpSbcs.js");
		var oSbcs = new DpSbcs();
		oSbcs.setCod(obj.defVal);
		
		obj.value = oSbcs;
		break;

	default:
		strMsg = "передан неизвестный режим:"+mode;
		debug(strMsg);
		obj = null;
	break;
	}

	// индекс очередного элемента в списке запроса - это имя параметра
	this.aQryList[name] = obj;
	
	var index = this.aTabIndex.length;
	// порядок вывода очередного элемента в списке запроса
	this.aTabIndex[index] = name;
	
	//for(var i in this.aQryList[name]) alert(i+"="+this.aQryList[name][i])

}
//============================================
// Добавляет стандартные контролы или групу котролов.
// mode - BEDAT	- период
//		- DAT	- Дата
//		- MOL	- МОЛ
//		- TABN	- Таб.номер
//		- PODR	- Таб.номер
//		- SC	- Счет
//		- YEAT
//Есть возможность задать сразу несколько 
// BEDAT|DAT|MOL|TABN|PODR|SC
function DpAskEx_addStd(mode)
{
	actrl2Add = String(mode).split("|")
	// Небольшие сюрпризы для mode
	// В основном для того чтобы разрешить пустой код
	var sDop = ""
	var currType = "";
	var is0;
	for (var n in actrl2Add)
	{
		currType = actrl2Add[n];
		var sType = currType.replace(/-|0|\./gi, "");
		is0 = strIn("0", currType);
		switch (sType)
		{
			case "DAT":
				this.add("D", "Дата", "DAT", new Date().getVarDate());
				break;
			case "BEDAT":
				//Спрашиваем дату начала и дату конца
				this.add("D", "Дата початку|Дата начала", "BDAT", new Date().getVarDate());
				this.add("D", "Дата закінчення|Дата конца", "EDAT", new Date().getVarDate());
				//Не пускаем, если дата начала позже даты конца
				this.setRel(">=", "EDAT", "BDAT");
				break;
			case "MOL":
				this.add("CL"+(is0?"0":""), "МВО|МОЛ", "MOL", 0, sprMol)
				break;
			case "SC":
				this.add("C"+(is0?"0":"")+"UT", "Рахунок|Счет", "SC", "0|0|0");
				break;
			case "TABN":
				this.add("CL"+(is0?"0":""), "Таб.номер|Таб.номер", "TABN", 0, 2);
				break;
			case "NMKL":
				var isGroup = strIn(".", currType);
				this.add("NMK" + (is0 ? "0" : "") + (isGroup ? "." : ""), "Номенклатура|Номенклатура", "NMKL", "");
				break;
			case "PODR":
				this.add("CL"+(is0?"0":""), "Підрозділ|Подразделение", "PODR", 0, sprPodr);
				break;
			case "RESIDENCE":		// Місце зберігання|Место хранения
				this.add("CL" + (is0 ? "0" : ""), "Місце зберігання|Место хранения", "RESIDENCE", 0, sprPodr);
				break;
			case "OWNER":			// Власник|Владелец
				this.add("CL" + (is0 ? "0" : ""), "Власник|Владелец", "OWNER", 0, sprOrg);
				break;
			case "POST":			// Постачальник|Поставщик
				this.add("CL" + (is0 ? "0" : ""), "Постачальник|Поставщик", "POST", 0, sprOrg);
				break;
			case "KEEPTYPE":		// Вид зберігання|Вид хранения
				this.add("CL" + (is0 ? "0" : ""), "Вид зберігання|Вид хранения", "KEEPTYPE", 0, 11);
				break;
			case "REGION":			// Номер району|Номер района
				this.add("CL" + (is0 ? "0" : ""), "Номер району|Номер района", "REGION", 0, 102);
				break;
			case "TYPEOTP":			// Тип відпуску продукції|Тип отпуска продукции
				this.add("CL" + (is0 ? "0" : ""), "Тип відпуску продукції|Тип отпуска продукции", "TYPEOTP", 0, 50);
				break;
			case "YEAR":			// Рік урожаю|Год урожая
				this.add("NUM" + (is0 ? "0" : ""), "Рік урожаю|Год урожая", "YEAR", 0, 4);
				//oA.add(mode, descr, name, defVal, length, fract)
				//oA.add("NUM", "Кiлькiсть|Количество", "KOL", -10, 3,5);
				break;
			default:
				if ("undefined" != this.aStdHandlers[sType])
				{
					this.aStdHandlers[sType]("", sType, this);
				}
				break;
		}
	}
}

function DpAskEx_useDefsParse(mode, par)
{
	//проверим что нам передали
	if (typeof(par) == "undefined" && typeof(mode) != "undefined" && String(typeof(mode)).toLowerCase() == "string")
	{
		var oPar = mode;
	}
	else if (typeof(par) != "undefined" && String(typeof(par)).toLowerCase() == "string")
	{
		var oPar = par;
	}
	else
	{
		return false;
	}

	//проверим есть ли настройки
	if (!isEmpty(this.strUseDefsOnly.trim()))
	{
		if (isEmpty(this.aUseDefsOnly))
		{
			var aCtrl = this.strUseDefsOnly.split(",");
			this.aUseDefsOnly = new Array();

			for (var i = 0; i < aCtrl.length; i++)
			{
				this.aUseDefsOnly[aCtrl[i]] = true;
			}
		}

		return (this.aUseDefsOnly[oPar] ? true : false);
	}

	return false;
}

// вернуть введенное значение параметра.
// Для объектов вернет объект.
function DpAskEx_get(name)
{
	if (typeof(this.aQryList[name]) != "undefined" )
	{		
		if (!isEmpty(this.form))
		{			
			switch (this.aQryList[name].type)
			{
				case "CL":
				case "CLCL":
				case "EDI":
				case "VAL":
				case "CL_LNK":
				case "SMARTCL":
				case "SMARTCLREL":
				case "NMK":
				case "REL":
				case "RELP":
				case "GROS":
				case "CODNORM":
				case "VIDOS":
				case "CALEND":
				case "RECEPT":
				case "PRICE":
				case "SBCS":
					this.aQryList[name].setCod(this.form.getControl(name).getValue());
				break;
				case "LS":
					this.aQryList[name].setFid(this.form.getControl(name).getValue());
				break;
				case "BNK":
					this.aQryList[name].setMFO(this.form.getControl(name).getValue());
				break;
				case "SHPZ":
					this.aQryList[name].setFshpz(this.form.getControl(name).getValue());
				break;
				case "CNTRCT":
					//this.aQryList[name].setID(this.form.getControl(name).getValue());					
					this.aQryList[name].setNum(this.form.getControl(name).getValue());
				break;
				default:
					this.aQryList[name].value = this.form.getControl(name).getValue();
				break;
			}
		}		
		return toScrObj(this.aQryList[name].value);
	}
	else
	{
		return null;
	}
}

//ф-ция-заглушка. Вернет this. Нужна для подсправочников
function DpAskEx_getVarsEval(){
   return this;
}

// Установить отношение между 2-мя контролами
// Например, между датой начала и датой конца
// mode принимает значения
// "<","<=",">",">="
// Проверяться будет только меньшее значение на то, что оно меньше
//vlad 28.04.2010
//Добавлен mode = ":=" ("присвоить")
// пример использования:
// oA.setRel(":=", "OST", "^ORIG-^IZN");
// Означает, что надо в контрол "OST" поместить разницу значений в контролах "ORIG" и "IZN"
function DpAskEx_setRel(mode, name1, name2){
	// приведем все к случаям "<" или "<="
	// с индексом "1" - то, что должно быть меньше

	switch(mode){
	case "<":
	case "<=":
		o1 = this.aQryList[name1];
		relVar = name2
		break;
	case ">":
		o1 = this.aQryList[name2];
		relVar = name1
	   	mode = "<";
		break;
	case ">=":
		o1 = this.aQryList[name2];
		relVar = name1
	   	mode = "<=";
		break;
	case ":=":
		o1 = this.aQryList[name1];
		relVar = name2
	   	mode = ":=";
		break;
	default:
		debug("Неизвестный режим: "+mode);
	}

	if(o1){
		// переменная определена
		if(!o1.relations){
			o1.relations = new Array();
		}
		// Добавляем в массив отношений еще одно
		o1.relations[relVar] = mode;
	}else{
		// не определена какая-то из переменных
		if(!o1){
			debug("Не найдена переменная "+name1);
		}
	}
	
}

// вернуть объект DpEval, на который будут "навешены" как переменные
// введенные значения
// mode - не используется
// oEval - если передан, то переменные будут добавлены в существующий oEval вместо
// создания нового
function DpAskEx_getEval(mode, oEval){
	include("Objects\\DpEval.js");

	if(typeof(oEval)!="object"){
		// Создаем объект DpEval
		oEval = new DpEval();
	}

	// Обойдем все переменные
	for(var i in this.aQryList){
		val = null;
		switch(this.aQryList[i].type){
		case "CL":
		case "CLCL":
		case "EDI":
		case "VAL":
		case "CL_LNK":
		case "SMARTCL":
		case "SMARTCLREL":
		case "NMK":
		case "REL":
		case "RELP":
		case "GROS":
		case "CODNORM":
		case "VIDOS":
		case "CALEND":
		case "RECEPT":
		case "PRICE":
		case "SBCS":
			val = this.get(i).getCod();
			break;
		case "LS":
			val = this.get(i).getFid();
			break;
		case "BNK":
			val = this.get(i).getMFO();
			break;
		case "SHPZ":
			val = this.get(i).getFshpz();
			break;
		case "CNTRCT":
			val = this.get(i).getID();
			break;
		default:
			val = this.get(i);
		}
		//oEval.addExpr(i, this.get(i));
		oEval.addVar(i, val, this.aQryList[i].descr);
	}
	return oEval;
}

function DpAskEx_loadFromTbl(mode,tbl4Load){
	if(tbl4Load.IsEmpty()){
		debug("Отсутствует настройка переменных для расчета ");
		// В принципе, возможны случаи, когда будет расчет не требующий
		// ввода исходных данных. Для такого случая сбросим флаг
		this.escape = false;
		return;
	}
	for(tbl4Load.MoveFirst(); !tbl4Load.IsEOF(); tbl4Load.MoveNext()){
		mFtype = tbl4Load("FTYPE");
		mFdescr = tbl4Load("FDESCR");
		mFname = tbl4Load("FNAME");
		mFisvis = tbl4Load("FISVIS");	// будет ли контрол
		//vvs 26.11.2003
		mFis0slct = tbl4Load("FIS0SLCT");	// Допустимо ли пустое значение

		defVal = null;
		par1 = null;
		par2 = null;

		// Достанем умолчания. Но сначала из типа уберем нули и точки
		var clearType = mFtype.replace(/0|\. /g, "");

		switch(clearType){
		case "B":
			defVal = tbl4Load("FBOOL");
			break;
		case "D":
			// vvs 26.11.2003
			// а теперь добавим в тип 0, если допустимо пустое значение
			mFtype = mFtype + (mFis0slct ? "0" : "");
			defVal = tbl4Load("FDATETIME");
			break;
		case "T":
			// vvs 26.11.2003
			// а теперь добавим в тип 0, если допустимо пустое значение
			mFtype = mFtype + (mFis0slct ? "0" : "");

			defVal = tbl4Load("FTEXT");
			// par1 - длина
			par1 = tbl4Load("FWIDTH");
			break;
		case "NUM":
			defVal = tbl4Load("FNUM");
			// par1 - длина
			// par2 - дробных знаков
			par1 = tbl4Load("FWIDTH");
			par2 = tbl4Load("FDR");
			break;
		case "COMBO":
		case "RADIO":
			defVal = tbl4Load("FNUM");
			break;
		case "NMK":
		case "NMK.":		// alex 12.01.2005
			// vvs 26.11.2003
			// а теперь добавим в тип 0, если допустимо пустое значение
			mFtype = mFtype + (mFis0slct ? "0" : "");

			defVal = tbl4Load("FTEXT");
			break;
		case "GROS":
			// а теперь добавим в тип 0, если допустимо пустое значение
			mFtype = mFtype + (mFis0slct ? "0" : "");
			defVal = tbl4Load("FNUM");
			break;
		case "CODNORM":
		case "EDI":
		case "VAL":
		case "BNK":
		case "SHPZ":
		case "SBCS":
			// а теперь добавим в тип 0, если допустимо пустое значение
			mFtype = mFtype + (mFis0slct ? "0" : "");
			defVal = tbl4Load("FNUM");
			break;
		case "VIDOS":
			// а теперь добавим в тип 0, если допустимо пустое значение
			mFtype = mFtype + (mFis0slct ? "0" : "");
			defVal = tbl4Load("FNUM");
			break;
		case "CLCL":
			// ksm 11.01.2005 
			// а теперь добавим в тип 0, если допустимо пустое значение
			mFtype = mFtype + (mFis0slct ? "0" : "");

			defVal = tbl4Load("FNUM");
			// par1 - номер справочника
			//============================================
			// ksm 11.01.2005   тут нужно другое поле
			par1 = tbl4Load("FCL");
			break;
		case "CL":
		case "RELP":
		case "CALEND"://Нужно потестить
		case "SMARTCL":
		//debug();
			// vvs 26.11.2003
			// а теперь добавим в тип 0, если допустимо пустое значение
			mFtype = mFtype + (mFis0slct ? "0" : "");

			defVal = tbl4Load("FNUM");
			// par1 - номер справочника
			par1 = tbl4Load("FCL");
			break;
		case "SMARTCLREL"://Нужно потестить
		case "REL":
			// vvs 26.11.2003
			// а теперь добавим в тип 0, если допустимо пустое значение
			mFtype = mFtype + (mFis0slct ? "0" : "");

			defVal = tbl4Load("FNUM");
			// par1 - номер справочника
			// par2 - имя переменной. Должна быть кодом из надсправочника
			par1 = tbl4Load("FCL");
			par2 = tbl4Load("FNAMEREL");
			break;
		case "C":
		case "CU":
		case "CUT":
		case "CUTX":
		case "CUTXY":
		case "CUTXYZ":
			// vvs 26.11.2003
			// а теперь добавим в тип 0, если допустимо пустое значение
			mFtype = mFtype.substr(0, 1) + (mFis0slct ? "0" : "") + mFtype.substr(1);

			mFsc = tbl4Load("FSC");
			mFsu = tbl4Load("FSU");
			mFst = tbl4Load("FST");
			mFcl_cod1 = tbl4Load("FCL_COD1");
			mFcl_cod2 = tbl4Load("FCL_COD2");
			mFcl_cod3 = tbl4Load("FCL_COD3");
			// Создадим умолчание вида "20|201|0|4567"
			defVal = (mFsc==null ? "0" :
					(String(mFsc) + (mFsu==null ? "0" :
						("|"+String(mFsu) + (mFst==null ? "0" :
							("|"+String(mFst) + (mFcl_cod1==null ? "0" :
								("|"+String(mFcl_cod1) + (mFcl_cod2==null ? "0" :
									("|"+String(mFcl_cod2) + (mFcl_cod3==null ? "0" :
										"|"+String(mFcl_cod3)
									))
								))
							))
						))
					))
				)
			break;
		case "RECEPT":
			mFtype = mFtype + (mFis0slct ? "0" : "");
			defVal = tbl4Load("FNUM");
			break;
		case "PRICE":
		case "CNTRCT":
			mFtype = mFtype + (mFis0slct ? "0" : "");
			defVal = tbl4Load("FNUM");
			break;
		default:
			strMsg = "передан неизвестный режим:"+mFtype;
			debug(strMsg);
			obj = null;
		}

		this.add(mFtype+(mFisvis ? "" : "-"), mFdescr, mFname, defVal, par1, par2);

		// разберемся с "отношениями"
		mFreltype = tbl4Load("FRELTYPE")
		if(mFreltype && mFreltype!="") {
			mFrelvar = tbl4Load("FRELVAR");
			this.setRel(mFreltype, mFname, mFrelvar);
		}

	}	// end of for(tbl4Load.MoveFirst(); !tbl4Load.IsEOF(); tbl4Load.MoveNext())

}

function DpAskEx_clear(){
	this.aQryList = new Array();
	this.hasVisibleControls = false;
	this.aConditions	= new Array();
	this.aEnables		= new Array();

}

//================SaveLoadApi============================
function DpAskEx_getCtrlType(mode,ctrlType){
	var retObj = new Object();

	switch(ctrlType){
	case "B":
		retObj.type  = "Boolean(^)";
		retObj.field = "FBOOL"
		break;
	case "D":
		retObj.type = "new Date(^).getVarDate()";
		retObj.field = "FDATETIME"
		break;
	case "C":
	case "CU":
	case "CUT":
	case "CUTX":
	case "CUTXY":
	case "CUTXYZ":
	case "CL_LNK":
		retObj.spliter = "|"
	case "T":
	case "DIR":
	case "NMK":
	case "FILE":
	case "BNK":
	case "SHPZ":
	case "SBCS":
		retObj.type = "String(^)";
		retObj.field ="FTEXT"
		break;
	case "NUM":
		retObj.type = "Number(^)";
		// par1 - дробных знаков
		retObj.field =	"FFLOAT";
		break;
	case "COMBO":
	case "RADIO":
	case "LS":
	case "GROS":
	case "CODNORM":
	case "VIDOS":	
	case "CL":
	case "CLCL":
	case "EDI":
	case "VAL":
	case "SMARTCL":
	case "SMARTCLREL":
	case "CALEND":
	case "RECEPT":
	case "PRICE":
	case "CNTRCT":
		retObj.type = "Number(^)";
		retObj.field ="FLONG";
		break;
	default:
		strMsg = "передан неизвестный режим:"+mode;
		debug(strMsg);
		retObj = null;
	}
	return retObj;
}

//mode
//"T" - в таблицу
//"P" - в параметры системы
//frem - название набора параметров, если сохраняем в таблицу
//fnom - номер набора параметров при редактировании, если сохраняем в таблицу
//tbl2Save - имя таблицы, если сохраняем в таблицу
function DpAskEx_save(mode, objFORM, frem, arrSaves, tbl2Save, fnom)
{
	mode = mode.toUpperCase();
	
	var isInTable = (mode == "T");
	var value2Save;//Значение для сохранения
	if (isInTable == true)
	{
		if (isEmpty(tbl2Save))
		{
			tbl2Save = this.tblParNameDef;
		}
		//если добавляем, найдем следующий код
		if (isEmpty(fnom))
		{
			strSQL = "SELECT MAX(FNOM) AS NOM FROM "+tbl2Save
				" WHERE FSYSNAME = "+sqlTo(this.sysname)
			var sn = getSnap(strSQL);
			fnom = (sn != null && sn[0] != null ? sn[0] : 0)+1;
			sn = null;
			var edmode = "ADD";
		}
		else
		{
			var edmode = "EDIT";
		}
	}
	for (var i in this.aQryList)
	{
		var obj = this.aQryList[i];
		if(!obj)
		{
			continue;
		}
		
		if (!isEmpty(arrSaves) && (typeof(arrSaves[i]) == "undefined" || arrSaves[i] == false))
		{
			strSQL = "DELETE FROM "+tbl2Save
				+" WHERE FSYSNAME = "+sqlTo(this.sysname)
				+" AND FNOM = "+sqlTo(fnom)
				+" AND FNAME = "+sqlTo(i)
			ExecuteSQL(strSQL);
			continue;
		}
		
		var type = obj.type;
		
		//Подтянем значение которое талько запомнили.
		//сохраняем всегда с контролов
		if (/*isInTable*/false)
		{
			value2Save = this.aValues2Save[i]//getParWithDef(i, this.sysname, defVal);
		}
		else
		{
			// поместим в obj.value значения из соотв. контролов.
			// Для объектов ничего не делаем - там хранится 
			// соответствующий объект, который уже знает значение
			switch(type)
			{
			case "B":
				if(obj.visible)
				{
					obj.value = objFORM.getControl(i).checked;
				}
				value2Save = obj.value
				break;
			case "D":
				if(obj.visible)
				{
					obj.value = javaDate2Script(objFORM.getControl(i).value).getVarDate();
				}
				
				value2Save = obj.value;
				break;
			case "NUM": 
			case "T":
			case "DIR":
			case "FILE":
				if(obj.visible)
				{
					obj.value = toScrObj(objFORM.getControl(i).value);
				}
				
				value2Save = obj.value;
				break;
			case "COMBO": 
				if(obj.visible)
				{
					//fruckt
					//поменяли режим работы с COMBO
					obj.value =  toScrObj(objFORM.getControl(i).value);
				}
				
				value2Save = obj.value;
			break;
			case "RADIO": 
				if(obj.visible)
				{
					// Обойдем все варианты и определим, который из них выбран
					obj.value =  toScrObj(objFORM.getControl(i).value);
				}
				
				value2Save = obj.value
				break;
			case "NMK":
				value2Save = obj.value.getCod("c")
				//setParWithDef(i, obj.value.getCod(), extPar.sysname);
				break;
			case "CL":
			case "CLCL":
			case "EDI":
			case "VAL":
			case "SMARTCL":
			case "SMARTCLREL":
			case "REL":
			case "RELP":
			case "GROS":
			case "CODNORM":
			case "VIDOS":
			case "CALEND":
			case "RECEPT":
			case "PRICE":
			case "SBCS":
				value2Save =  toScrObj(obj.value.getCod());
				break;
			case "LS":
				value2Save = toScrObj(obj.value.getFid());
				break;
			case "BNK":
				value2Save = toScrObj(obj.value.getMFO());
				break;
			case "SHPZ":
				value2Save = toScrObj(obj.value.getFshpz());
				break;
			case "CNTRCT":
				value2Save = toScrObj(obj.value.getID());
				break;
			case "CL_LNK":
				var oClLnk = obj.value;
					// формируем строку, которую запишем в параметры
					var val = String(oClLnk.pFdoc)
						+ "|" + String(oClLnk.pFnop)
					value2Save =val;
				break;
			case "C":
			case "CU":
			case "CUT":
			case "CUTX":
			case "CUTXY":
			case "CUTXYZ":
				var oSc = obj.value;
				
				// формируем строку, которую запишем в параметры
				var val = String(toScrObj(oSc.getSc()))
					+ "|" + String(toScrObj(oSc.getSu()))
					+ "|" + String(toScrObj(oSc.getSt()))
					+ "|" + String(normalizeResult("number", toScrObj(oSc.getCl1())))
					+ "|" + String(normalizeResult("number", toScrObj(oSc.getCl2())))
					+ "|" + String(normalizeResult("number", toScrObj(oSc.getCl3())))
				value2Save = val;
				break;
			case "CONST":
				value2Save = obj.value.getCtrlValue("VAL");
				obj.value.setValue(value2Save);
			break;
			default:
				break
				// а сюда не должны попасть никогда
			}//end of switch(type){
		}
		//Запомним значения.
		if (!isInTable)
		{
			this.aValues2Save[i] = value2Save;
		}
		//А теперь сохраним значение.
		switch(mode)
		{
		case "P":
			setParWithDef(i, value2Save, this.sysname);
			break;
		case "T":
			objType	= this.getCtrlType("",type);
			if (isEmpty(objType))
				continue
			if (edmode == "EDIT")
			{
				strSQL = "SELECT FWID FROM "+tbl2Save
					+" WHERE FSYSNAME = "+sqlTo(this.sysname)
					+" AND FNOM = "+sqlTo(fnom)
					+" AND FNAME = "+sqlTo(i)
					+" AND FSTYPE = "+sqlTo(type)
				var sn = getSnap(strSQL);
				if (sn != null && sn[0] != null)
				{
					var mFwid = sn[0]
				}
				else
				{
					var mFwid = GetUID();
					edmode = "ADD";
				}
				sn = null;
			}
			else
			{
				var mFwid = GetUID();
			}
			var m = new Object();
			m.FNAME = i;
			m.FTYPE = objType.field;
			m.FSTYPE = type;
			m[objType.field] = value2Save;
			m.FSYSNAME = this.sysname;
			m.FREM = frem;
			m.FNOM = fnom;
			m.FWID = mFwid;

			UpdateTable(tbl2Save, m, (edmode != "EDIT"));
			if (!isEmpty(fnom))
				edmode = "EDIT";
		default:
			break;
		}
	}//end of for (var i in extPar.aQryList){
	if (null != this.Itog)
	{
		this.fitog = this.Itog.getCod();
	}

	this.form = null;
	if (isInTable)
		return fnom;
}

function normalizeResult(mode, result, alternative)
{
	switch (mode)
	{
		case "number":
			if (objTypeOf(result).toLowerCase() != "number")
			{
				if (!isEmpty(alternative))
				{
					result = alternative;
				}
				else
				{
					result = 0;
				}
			}
		break;
		default:
		break;
	}
	
	return result;
}

function DpAskEx_loadDirectValue(mode,tbl2Load)
{
	if (tbl2Load.IsEmpty())
	{
		return false;
	}
	var objType;
	var value;
	//Пробежимся по таблице значений
	for(tbl2Load.MoveFirst(); !tbl2Load.IsEOF(); tbl2Load.MoveNext()){
		//Узнаем свойства
		objType	= this.getCtrlType("",tbl2Load("FSTYPE"));
		//Узнаем значение
		value	= tbl2Load(objType.field)
		//Если оно не  null
		if (value !=null){
			//Попробуем преобразовать его в необходимый тип.
			
			try{
				if (objType.field != "FDATETIME"){
					value = eval(objType.type.replace(/\^/gi,String(value)))
				}
				
			}
			catch(e){
				//Не получилось 
				this.aDirectValues[tbl2Load("FTYPE")] = null;
			}
			 
			this.aDirectValues = value
		}else{
			//Не получилось 
			this.aDirectValues[tbl2Load("FTYPE")] = null;
		}
	}
	return true;
}

function DpAskEx_getDirectValue(mode,ctrlName,isVisible,defVal){
	//Попробуем достать из массива прямых значений
	var val =  this.aDirectValues[ctrlName]
	if (val!=null){
		return val
	}
	// для видимых эл-тов подтянем умолчание из параметров
	if(ctrlName && isVisible && ctrlName!=""){
		val = defVal;
	} else {
		val = getParWithDef(ctrlName, this.sysname, defVal);
	}
	return val
	
}
//============================================
// Дабавить условие.
// cond - выражение, результат вычисления которого будет влиять на 
// горением контрола.
//		false - disabled
//		true - enabled
// Выражение вычисляется в контексте нашего объекта, т.е. доступен "this"
// так можно добраться до значения какого либо объекта DpAskEx
// this.aQryList['USERLABEL'].controls[0].value
function DpAskEx_defCond(cond, alias)
{
	if(!alias)
		alias = cond;
	this.aConditions[alias] = cond;
}

// установка функции валидации для контролов
function DpAskEx_setValid(sName, validFunc)
{
	if (typeof(validFunc) == "string")
	{
		validFunc = eval(validFunc);
	}
	this.aCtrlValid[sName] = validFunc;
	return true;
}

//Добавить условие на зажжение контрола
// sName - имя переменной, контрол которой будет зажигаться
// alias - alias условия по которому будет вычислятся выражение.
function DpAskEx_enable(sName, alias)
{
	if(typeOf(this.aConditions[alias]) == "undefined")
	{
		alert("Условие должно быть объявлено методом defCond");
	}
	else
		this.aEnables[sName] = alias;	// Массив со списком выражений зажигания/тушения контролов
}

//Добавить условие на видимость
// sName - имя переменной, контрол которой будет visible
// alias - alias условия по которому будет вычислятся выражение.
function DpAskEx_visible(sName, alias){
	if(!this.aConditions[alias])
		alert("Условие должно быть объявлено методом defCond");
	else
	{
		this.aVisibles[sName] = alias;	// Массив со списком выражений зажигания/тушения контролов
		this.aEnables[sName] = alias;	// Массив со списком выражений зажигания/тушения контролов
	}
}
// Вызывается при выходе из каждого контрола,
// управляет видимостью контролов
function DpAskEx_validEnable()
{
	// Обойдем массив со списком выражений зажигания/тушения контролов
	for(sName in this.aEnables){
		sExpr = this.aConditions[this.aEnables[sName]];
		bEnable = eval(sExpr);
		sExprVisible = this.aConditions[this.aVisibles[sName]];
		bVisible = eval(sExprVisible);
		if (typeof(bVisible) == "undefined")
		{
			bVisible = true;
		}

		// Net 11.10.2010  теперь можно тушить кнопки на диалоге
		switch (sName)
		{
			case "btnOK":
			case "btnCancel":
				var ctrl = this.form.getControl(sName);
				Enable(ctrl, bEnable);
				ctrl.setVisible(bVisible);
				continue;
		}

		obj = this.aQryList[sName];

		for(i in obj.controls)
		{
			// для счета с аналитиками нужен особый подход
			if ((obj.type == "CUTXYZ" || obj.type == "CUTXY" || obj.type == "CUTX")
				&& i>2 
				&& bEnable
				)
			{
				//trace("ничего делать не будем");
			}
			else
			{
				//trace("БУДЕМ делать");
				Enable(obj.controls[i], bEnable);
			}

			obj.controls[i].setVisible(bVisible);
			
			if ((!bEnable || !bVisible) && !this.notClearCtrl)
			{
				ctrl = obj.controls[i];
				var sType = obj.mode.replace(/-|0|\./gi, "")
				switch(sType){
				case "B":
					ctrl.checked = false;
					break;
				case "D":
					ctrl.value = new Date(d00).getVarDate();
					break;
				case "T":
				case "DIR":
				case "FILE":
				case "NMK":
				case "EDI":
				case "VAL":
				case "BNK":
				case "SHPZ":
				case "SMARTCL":
				case "SMARTCLREL":
				case "SBCS":
					// Это условие нужно для того, чтобы не очищать "..." с кнопочек,
					// служащих для открытия окошек выбора файлов и папок ("DIR" и "FILE")
					if (typeof(ctrl.id) != "undefined")
					{
						if ((ctrl.id).left(4) != "btn_")
						{
							ctrl.value = "";
						}
					}
					break;
				case "C":
				case "CU":
				case "CUT":
				case "CUTX":
				case "CUTXY":
				case "CUTXYZ":
					obj.value.set(0,0,0,0,0,0);
					break;
				case "NUM":
				case "GROS":
				case "CODNORM":
				case "VIDOS":
				case "CALEND":
				case "RECEPT":
				case "PRICE":
				case "CNTRCT":
					ctrl.value = 0;
					break;
				case "CL":
				case "CLCL":
				case "REL":
				case "RELP":
				case "LS":
					obj.value.setCod(0);
					break;				
				case "COMBO":
				case "RADIO":
					break;
				default:
					strMsg = "передан неизвестный режим:"+mode;
					debug(strMsg);
				}
			}
		}
	}

	return true;
}

// Возвращает значение из контрола с порядковым номером nIndex 
// для переменной sName
// Предназначена для использования в условиях, передаваемых this.enable()
function DpAskEx_immediate(sName, nIndex) {
	var retval = false;
	var obj = this.aQryList[sName];
	
	if(typeof(obj)!="object") {
		return false;
	}
	
	if(!obj.visible){
		return obj.value;
	}
	if(typeof(nIndex)=="undefined") {
		nIndex = 0;
		isIndex = false;
	} else {
		isIndex = true;
	}
	
	ctrl = obj.controls[nIndex];
	
	if(typeof(ctrl)=="object") {
		// поместим в obj.value значения из соотв. контролов.
		// Для объектов ничего не делаем - там хранится 
		// соответствующий объект, который уже знает значение
		switch(obj.type){
		case "B":
			retval = ctrl.checked;
			break;
		case "D":
		case "NUM": 
		case "T":
		case "DIR":
		case "FILE":
			retval = ctrl.value;
			break;
		case "COMBO": 
			retval = Number(ctrl.value);
			break;
		case "RADIO": 
			if(isIndex){
				retval = ctrl.checked;
			} else {
			
				// Обойдем все варианты и определим, который из них выбран
				retval = 0;
				var aOpt = obj.controls;
				var nLen = aOpt.length;
				for(var ind = 0; ind < nLen; ind++){
					if(aOpt[ind].checked){
						retval = Number(ind);
						break;
					}
				}
			}
			
			break;
		case "CL":
		case "CLCL":
		case "SMARTCL":
		case "SMARTCLREL":
		case "REL":
		case "RELP":
		case "NMK":
		case "BNK":
		case "SHPZ":
		case "GROS":
		case "CODNORM":
		case "VIDOS":
		case "LS":
		case "C":
		case "CU":
		case "CUT":
		case "CUTX":
		case "CUTXY":
		case "CUTXYZ":
		case "CALEND":
		case "RECEPT":
		case "PRICE":
		case "CNTRCT":
		case "SBCS":
			retval = ctrl.value;
			break;
		case "EDI":
		case "VAL":
			retval = obj.value.getCod();
			break;
		default:
			// а сюда не должны попасть никогда
		}//end of switch(type){
	}
	return retval;
}

function DpAskEx_load(nom, objFORM, tblName)
{
	if (isEmpty(tblName))
	{
		tblName = this.tblParNameDef;
	}
	
	if (isEmpty(objFORM))
	{
		return false;
	}

	for (var j = 0; j < this.aTabIndex.length; j++)
	{
		var i = String(this.aTabIndex[j]);
		var obj = this.aQryList[i];
		if(!obj)
		{
			continue;
		}
		// Достанем настройку параметров
		strSQL = " SELECT * FROM " + tblName
				+" WHERE FSYSNAME = "+sqlTo(this.sysname)
				+" AND FNOM = " + sqlTo(nom)
				+" AND FNAME = "+sqlTo(i)
		var t = OpenTable("s", strSQL);
		if (!t.IsEmpty())
		{
			var mFtype	= t.getValue("FTYPE");
			var sType	= t.getValue("FSTYPE");
			var mFname	= t.getValue("FNAME");
			var defVal	= t.getValue(mFtype);
			defVal = toScrObj(defVal)
			sType = String(sType)
			switch(sType)
			{
				case "B":
				case "T":
				case "DIR":
				case "FILE":
				case "NUM":
				case "COMBO":
				case "RADIO":
					ctrl = objFORM.getControl(mFname);
					ctrl.value = defVal;
					break;
				case "D":
					ctrl = objFORM.getControl(mFname);
					ctrl.value = new Date((!isDateType(defVal) ? d00 : defVal)).getVarDate();
					break;
				case "LS":
					obj.type = sType;
					include("Objects\\DpLicf.js");
					var cod = defVal
					var tLic = OpenTable("s","SELECT * FROM ^LIC_FLD WHERE FID="+sqlTo(cod));
					if(!tLic.IsEmpty())
					{
						tLic.MoveFirst();
						obj.value.setFnum(tLic.getValue("FFLD_NUM"));
						obj.value.setFtxt(tLic.getValue("FTXT"));
					}
					tLic.close(5652);
					tLic = null;
					obj.value.setFid(cod)
					break;
				case "GROS":
				case "CODNORM":
				case "VIDOS":
				case "NMK":
				case "SMARTCLREL":
				case "SMARTCL":
				case "CL":
				case "CALEND":
				case "CLCL":
				case "EDI":
				case "VAL":
				case "REL":
				case "RELP":
				case "RECEPT":
				case "PRICE":
				case "SBCS":
					obj.value.setCod(defVal);
					break;
				case "BNK":
					obj.value.setMFO(defVal);
					break;
				case "SHPZ":
					obj.value.setFshpz(defVal);
					break;
				case "CL_LNK":
					obj.type = sType;
					// задано умолчание вида "PN|20"
					var aDef = String(defVal).split("|");
					obj.value.setCod(aDef[0] ? String(aDef[0]) : "");
					obj.value.setDocNop(aDef[1] ? Number(aDef[1]) : 0);
					break;
				case "C":
				case "CU":
				case "CUT":
				case "CUTX":
				case "CUTXY":
				case "CUTXYZ":
					aDef = [0,0,0,0,0,0];
					if(objTypeOf(defVal) == "string" || objTypeOf(defVal) == "String")
					{
						// задано умолчание вида "20|201|1"
						var aDef = String(defVal).split("|");
						
						// приведем к числовому типу
						for(var ind in aDef)
						{
							aDef[ind] = parseInt(aDef[ind], 0);
						}

						switch (sType)
						{
							case "C":
								aDef[1] = 0;
							case "CU":
								aDef[2] = 0;
							case "CUT":
								aDef[3] = 0;
							case "CUTX":
								aDef[4] = 0;
							case "CUTXY":
								aDef[5] = 0;
							break;
						}
						obj.value.set(aDef[0],aDef[1],aDef[2],aDef[3],aDef[4],aDef[5])
					}
					break;
				case "UOSEX":
				break;
				case "CONST":
				break;
				case "MULTISEL":
				break;
				case "CNTRCT":
					obj.value.setID(toScrObj(defVal));		
				break;
				default:
				break;
			}
		}
		t.Close()
		t = null;		
	}
	this.validEnable()
	return true;
}

function DpAskEx_setCaption(par)
{
	if(typeof(par) == "string")
	{
		this.caption = par;
	}
	
	return true;	
}

function DpAskEx_getCaption()
{
	return UR(this.caption);	
}

//функции для работы с историей
function DpAskEx_saveHistory(objFORM, nom, isUser)
{
	if (!isEmpty(nom))
	{
		strSQL = "SELECT * FROM "+this.tblParNameDef
			+" WHERE FSYSNAME = "+sqlTo(this.sysname)
			+" AND FNOM = "+sqlTo(nom)
			+" AND (FUSER IS NULL OR FUSER = '' OR FUSER = "+sqlTo(getUserName())+")"			
		var tbl = OpenTable(strSQL)
		if (tbl.IsEmpty())
		{
			return false;
		}
		tbl.MoveFirst();
		var mFuser = tbl.getValue("FUSER");
	}
	var askFrm = createForm(ru("Сохранение варианта запроса параметров","Збереження варіанту запиту параметрів"));
	var tf = askFrm.addObj("FREM", "string", UR("Назва:|Название:"), null, 200);
	if (!isEmpty(nom))
	{
		tf.value = tbl.getValue("FREM");
	}
	for (var j = 0; j < this.aTabIndex.length; j++)
	{
		i = String(this.aTabIndex[j]);
		var obj = this.aQryList[i];
		if(!obj)
		{
			continue;
		}
		if (inList(obj.type,"REM","HR"))
		{
			continue;
		}
		var chB = askFrm.addObj(i, "bool", UR("Зберегти: |Сохранить: ")+UR(obj.descr));
		if (!isEmpty(nom))
		{
			strSQL = "SELECT * FROM "+this.tblParNameDef
				+" WHERE FSYSNAME = "+sqlTo(this.sysname)
				+" AND FNOM = "+sqlTo(nom)
				+" AND FNAME = "+sqlTo(i)
				+" AND (FUSER IS NULL OR FUSER = '' OR FUSER = "+sqlTo(getUserName())+")"			
			tbl.requery(strSQL)
			if (tbl.IsEmpty())
			{
				chB.value = false;
			}
			else
			{
				chB.value = true;
			}
		}
		else
		{
			chB.value = true;
		}
	}
	if (!isEmpty(nom))
	{
		tbl.Close();
		tbl = null;
	}
	
	if (!askFrm.show())
		return false;
	var arrSaves = new Array();
	for (var i in this.aQryList)
	{
		var obj = this.aQryList[i];
		if(!obj)
		{
			continue;
		}
		var val = askFrm[i];
		arrSaves[i] = val;
	}
	var mFrem = String(askFrm.FREM)
	var mFnom = this.save("T", objFORM, mFrem, arrSaves, null, nom);
	if (!isEmpty(mFuser) || !isEmpty(isUser))
	{
		strSQL = "UPDATE "+this.tblParNameDef
			+" SET FUSER = "+sqlTo(getUserName())
			+" WHERE FSYSNAME = "+sqlTo(this.sysname)
			+" AND FNOM = "+sqlTo(mFnom)
		ExecuteSQL(strSQL);
	}
	return mFnom
}

function DpAskEx_delHistory(nom)
{
	if (isEmpty(nom))
	{
		alert(ru("Ни один элемент не выбран!","Жоден елемент не вибраний!"))
		return false;
	}
	//удалим все
	if (nom == -1)
	{
		var msg = ru("Удалить все записи истории", "Вилучити всі записи історії");
		var ret = msgBox("^c-", msg, ru("Подтверждение удаления","Підтвердження вилучення"));
		if (ret == '-')
		{
			strSQL = "DELETE FROM "+this.tblParNameDef
				+" WHERE FSYSNAME = "+sqlTo(this.sysname)
			ExecuteSQL(strSQL);
		}
	}
	else
	{
		var msg = ru("Подтвердите удаление записи", "Підтвердіть вилучення запису");
		var ret = msgBox("^c-", msg, ru("Подтверждение удаления","Підтвердження вилучення"));
		if (ret == '-')
		{
			strSQL = "DELETE FROM "+this.tblParNameDef
				+" WHERE FSYSNAME = "+sqlTo(this.sysname)
				+" AND FNOM = "+sqlTo(nom)
			ExecuteSQL(strSQL);
		}
	}
	return true;
}