// JScript source code
include("dbReaderCommon.js");
include("sys/udfs.js");
include("servis/format.js");
include("servis/date.js");

var DpCLB_currDOC = "PP";
var DpCLB_currOKPO = getPar("OOKPO");
var DpCLB_currOMFO  = getPar("OMFO");
var DpCLB_currOFIRM  = getPar("OFIRM");
var MYfilename = "";
var dpRegistry = null;
var DOCNUMBER = 0;//глобальная переменная номера по порядку документа к которой можно обращаться при экспорте

function DpCLB()
{
	this.bnklbl = new String("");
	this.type = new String("");
	this.encodding = new String("");
	this.files4impmap = new Array();	
	this.root = null;
	this.findmaskfiles = DpFindMaskFiles;
	this.init = DpCLBinit;
	this.runImport = DpCLBrunImport;
	this.runExport = DpCLBrunExport;
	this.preparefiles = PrepareFiles;
	this.saveToArchive = saveToArchive;
	this.registryDoc = registryDoc;
	this.checkDupl = DpCLBcheckDupl;//проверка дублей
	this.initBVO = DpCLBinitBVO;//инициализирует банковскую выписку 
	this.setPlatOrgAndBVO = DpCLBsetPlatOrgAndBVO;//устанавливает переменные выписки, связь с платежкой и код контрагента
	this.impRecCount = new Object();
	this.dat = null;//дата на которую можно переопределять дату платежки
	this.bvoDoc = null;//документ общей банковской выписки
	this.bvoID = null;//идентификатор документа общей банковской выписки
	this.isValid = true;//флаг валидности
	this.nDat = null;//индекс переменной HDAT платежки в массиве объекта XMLDBFSTRUobj
	this.hasExt = false;//флаг наличия в настройке расширений, в источнике/приемнике расширение должно быть записано как EXT.<имя расширения>
}

function DpCLBinit(DpBnkName,isExp)
{	 
	if (DpCLB_currOMFO == "")
	{
		var strMsg = UR("Не налагоджений довідник організацій!|Не настроен справочник организаций!");
		alert(strMsg, ICON_WARNING);
		return false;
	}	
	this.bnklbl = DpBnkName;
	include ("objects/DpXMLDomDocument.js");		
	var sClBankFile = getOrgPath() + "clbank/" + (isExp?"export/":"") + this.bnklbl + ".xml";
	//для линукса нужно еще делать проверку в верхнем регистре
	if(!isFile(sClBankFile))
		sClBankFile = getOrgPath() + "clbank/" + (isExp?"export/":"") + this.bnklbl + ".xml";
	var xmlDoc = new DpXMLDOMDocument();					
	xmlDoc.load(sClBankFile);	
	var xmlDocElement = xmlDoc.getDocumentElement();
	var name = xmlDocElement.getNodeName();
	if (name != "CLBANK")
	{//esli не opisanie importa iz k-b
		return false;
	}
	this.root = xmlDocElement;
	var Attr = xmlDocElement.getAttribute("type").toUpperCase();
	var Codding = xmlDocElement.getAttribute("encodding").toLowerCase();
	//атрибут row обозначает характер хранения информации в текстовом файле:
	// VAR - в одной строке файла хранится одно значение переменной документа
	// DOC - в одной строке файла хранится один документ
	// отсутствует - импорт осуществляется с помощью специального скрипта, указаного в тэге <VARDOCEXPR>
	var row = xmlDocElement.getAttribute("row").toUpperCase();
	if (Attr == "TXT")
	{//установим параметр.tyt opisanie importa iz txt
		this.type = "txt";
		this.encodding = String(Codding);
		this.row = row;
		//return false;//zaglyska
	}
	else if (Attr == "DBF")
	{//установим параметр.tyt opisanie importa iz dbf
		this.type = "dbf";	
		this.encodding = String(Codding);	
	}
	else
	{
		if(isExp)
			alertstr = UR("Тип файлу для експорту не вказано. Не існує атрибут для типу."
				+"|Тип файлов для экспорта не указан. Нет атрибута для типа.");
		else
			alertstr = UR("Тип файлу для імпорту не вказано. Не існує атрибут для типу."
				+"|Тип файлов для импорта не указан. Нет атрибута для типа.");		
		alert(alertstr);	
		return false
	}
	//получим пути для нашего формата из bnkconf.xml
	confFile = getOrgPath() + "clbank/"+(isExp?"export/":"")+"bnkconf"+(isExp?"exp":"")+".xml"
	if(!isFile(confFile))
	{
		copyFile(rootDirectoryEx()+"Source/bnkconf.xml",confFile);
	}
	xmlDoc.load(confFile);	
	var xmlDocElement = xmlDoc.getDocumentElement();	
	var name = xmlDocElement.getNodeName();
	var bnkconfnode = null;
	if (name != "BANKCONFIG")
	{
		alertstr = UR("Файл "+ confFile + " зіпсовано. Вузол BANKCONFIG не існує."
		+"|Файл "+ confFile + " испорчен. Нет узла BANKCONFIG.");		
		alert(alertstr);	
		return false;
	}
	else
	{
		isbnkconfnode = false;
		var ElementsVardoc = xmlDocElement.getChildNodes();//все дети				
		for (var i = 0;i < ElementsVardoc.length; i++)
		{
			ChildElement = ElementsVardoc[i];
			if (ChildElement != null)			
				name = ChildElement.getNodeName();		
			else
				return false;	
			if (allt(name) == allt(this.bnklbl))
			{		
				isbnkconfnode = true;	
				bnkconfnode = ChildElement;
				break;
			}			
		}
		if(isbnkconfnode == false || bnkconfnode == null)
		{
			alertstr = ru("В файле "+ confFile + " нет параметров вашего формата.\nУстановите их в меню ",
					"У файлі "+ confFile + " відсутні параметри вашого формату.\nВстановіть їх у меню ")
					+getMenuItemPath("l_clbnk.xml","d");					
			alert(alertstr);	
			return false;
		}
		else
		{		
			loadAttrToObj(bnkconfnode, this);

			if ((this.debdir == "") || (this.debdir == null))
	 			this.debdir = rootDirectoryEx();
		}
	}
	if(isExp)
		return true;
	if (this.findmaskfiles())
	{	
		return true;
	}	
	else 
	{
		if (toScrObj(this.clbdebug))
		{
			alert(UR("Файли за маскою не знайдено. |Файлы по маске не найдены."));
		}
		return false;
	}	
}

function DpFindMaskFiles()
{
	dpRegistry = new DpRegistryImportCLB();
	if (!this.preparefiles(this.clbdir, this.debdir, this.clbmask))	
		return false;
	var tmp = snapDirectory(this.debdir);
	this.files4impmap = new Array();
	var j = 0;
	for (var i in tmp)
		if (isFileEx(this.debdir + tmp[i]))
		{
			this.files4impmap[j++] = tmp[i];
		}
	if (this.files4impmap.length <= 0)
		return false;
	return true;
}

function saveToArchive(sFile)
{
	if (typeOf(sFile).toLowerCase() != "string" || sFile == "")
		return false;
	var archDir = this.debdir + "archive/";
	if (!isDir(archDir))
		createDirectory(archDir);
	if (!isDir(archDir))
		return false;
	copyFile(this.debdir + sFile, archDir + sFile);
	return true;
}

function registryDoc(sFileName, impRecCount)
{
	var dpInfo = dpRegistry.getInfo(sFileName);
	if (dpInfo == "empty" || dpInfo != "undefined")	
	{				
		if (dpInfo == "empty")
		{
			dpInfo = new DpInfoRICLB();
			dpInfo.docName = sFileName;
		}								
		if (this.cimportpppv == true)
			dpInfo[DocType] = createInfoDoc(impRecCount[DocType]);
		else
		{
			dpInfo.PP = createInfoDoc(impRecCount.PP);
			dpInfo.PV = createInfoDoc(impRecCount.PV);
		}
		dpRegistry.setInfo(dpInfo);
	}
}

function createInfoDoc(length)
{
	var result = new DpInfoDoc();
	result.recordcount.value = length;
	result.impdate.value = format("dd.mm.yyyy HH:MM", new Date());
	result.user.value = getUserName();
	return result;
}

function DpCLBrunImport()
{//Здесь имеем корень описания. Список файлов лежит в массиве this.files4impmap. 
 //Пошли импорты файлов по типам.   
	var alertstr = UR("Імпортуємо платіжні доручення: |Импортируем платёжные поручения:");
	var kolDoc = 0;
	if (this.type == "dbf")
	{
		if (this.root == null)
			return false;
		var XMLDBFSTRUobj = new DpDbfCLB();
		if (XMLDBFSTRUobj.xmlparse(this.root) == true)		
		{//normalno polyjili opisanie.		 
			for(var i = 0; i < this.files4impmap.length; i++)
			{
				dbfFileName = this.files4impmap[i];//getOrgPath() + "clbank/" + "ctg1601.dbf";//files[i];
				MYfilename = dbfFileName;	
				var FileName = dbfFileName;
				dbfFileName = this.debdir + dbfFileName;	
				/////////////////
				var alertstr = UR("Імпортуємо "+(i+1)+"-й файл з "+this.files4impmap.length+": |Импортируем "+(i+1)+"-й файл из "+this.files4impmap.length+": ")
							+ new DpFile(dbfFileName).getCanonicalPath();
				if (allt(this.encodding) == "")
					this.encodding = "cp866";
				alertstr += "\n" + UR("Використовуєма кодировка: |Используемая кодировка: ") + this.encodding; 
				if (toScrObj(this.clbdebug))
					trace(alertstr);		
				/////////////////			
				var t = OpenTable("f", dbfFileName, this.encodding);
				var dbfFileLength = t.getRowCount(); 				
				var progressM = new DpProgressMonitor(alertstr + dbfFileName, dbfFileLength);
				progressM.start();
				var progstep = 1;
				this.impRecCount.PP = 0;
				this.impRecCount.PV = 0;
				
				if(this.setDocDatByFormat)//дату документа берем из имени файла
				{
					var im = this.clbmask.indexOf("*")
					if(im <= 0)
						im = 0;
					ib=dbfFileName.lastIndexOf("copy_")
					ie=dbfFileName.lastIndexOf(".")
					dateFromFile = dbfFileName.substring(ib+5+im,ie);
					this.dat = new Date(strToDateFormat(dateFromFile,this.dformat.replace(/\|/g,""))).getVarDate();
				}
				if(this.period)
				{
					var par = new Object();
					par.escape = true;
					par.fileName = MYfilename;
					showWindow("i_period.xml",SW_MODAL,par);
					if (par.escape)
						return false;
					for (var j = 0; j < XMLDBFSTRUobj.fieldarray.length; j++)
					{
						if(XMLDBFSTRUobj.fieldarray[j]=="HDAT")
						{
							this.nDat = j;
						}
					}					
				}
				this.initBVO();
				this.bIgnorDuplic = false;
				while (!t.isEOF())
				{
					var PPPVLbl = XMLDBFSTRUobj.hdocexpr;																				
					var sDocType = t.getValue(PPPVLbl);
					DpCLB_currDOC = sDocType;
					var filterExpr = XMLDBFSTRUobj.hdocfilter;
					var OK = true;
					if(allt(filterExpr)!="")
						OK = toScrObj(t.getValue(filterExpr));
					if (OK && (!this.cimportpppv || (this.cimportpppv == true && DocType == sDocType)))						
					{//if TRUE-Отдельно закачиваем типы документов PP & PV. 
					 //DocType = тип документа в папке,в который мы находимся.
						var platDoc = new DpDoc(sDocType, Noper);
						if(this.period && this.nDat!=null)
						{
							
							this.dat = t.getValue(XMLDBFSTRUobj.funcarray[this.nDat]);
							if(differ(this.dat,d00)==0)
							{
								t.MoveNext();
								continue;
							}
						}
						this.isValid = true;
						for (var fcount = 0; fcount < XMLDBFSTRUobj.fieldarray.length; fcount++)
						{
							if(this.period && !(differ(this.dat,par.bdat)>=0 && differ(this.dat,par.edat)<=0))
							{
								this.isValid = false;
								break;
							}
							var docVar = XMLDBFSTRUobj.fieldarray[fcount].toUpperCase();
							var fieldExpr = XMLDBFSTRUobj.funcarray[fcount];
							var tblValue = t.getValue(fieldExpr);
							//для текстового значения обрезаем пробелы по краям
							if(typeOf(tblValue).toLowerCase()=="string")
								val = allt(tblValue)
							else
								val = tblValue;
							if(docVar.indexOf("EXT.")==0)//определяем docVar как переменную или расширение
							{
								platDoc.setExt(docVar.replace("EXT.",""), val)
								this.hasExt = true;
							}	
							else
								platDoc.setVar(docVar, val);
						}
						platDoc.setVar("HPRDAT", d00);
					
						if (typeOf(platDoc.getVar("HDAT")).toLowerCase() == "string")
							platDoc.setVar("HDAT", StrToDate(platDoc.getVar("HDAT")));

						if (this.dat !=  null)	
							platDoc.setVar("HDAT", this.dat);
						if (this.isValid && toScrObj(this.cduplic) && !this.bIgnorDuplic)//proverka dyblei
						{
							if(platDoc.getVar("HDAT") != null && platDoc.getVar("HNOM") != null && platDoc.getVar("HSUM") != null)
							{
								var sqlStr = "SELECT * from ^RAS_SCH"
									+ " WHERE FDOC_NUM = " + sqlTo(platDoc.getVar("HNOM"))
									+ " AND FDOC_DAT = " + sqlTo(platDoc.getVar("HDAT"))
									+ " AND FDOC = " + sqlTo(sDocType)
									+ " AND FFCR_SC = " + sqlTo(platDoc.getVar("HCRSC"))
									+ " AND FFDB_SC = " + sqlTo(platDoc.getVar("HDBSC"))
									+ " AND FSUM = " + sqlTo(platDoc.getVar("HSUM"))
									+ " AND FTOVAR = " + sqlTo(platDoc.getVar("HTOVAR"));
								var tdup = OpenTable("s", sqlStr);								
								if (tdup.recordCount > 0)
								{										
									var alertStr1 = UR(
									"ЗНАЙДЕНО " + tdup.recordCount + " ДОКУМЕНТІВ З ПАРАМЕТРАМИ:"
										+ "\n   НОМЕР: " + allt(platDoc.getVar("HNOM"))
										+ "\n   ДАТA: " + format("dd.mm.yyyy", tdup.getValue("FDOC_DAT"))
										+ "\n   СУМA: " + platDoc.getVar("HSUM")
										+ "\n   ВИД ДОКУМЕНТУ: " + sDocType
										+ "\n   ПРИЗНАЧЕННЯМ ПЛАТІЖНОГО ДОКУМЕНТУ: " + allt(platDoc.getVar("HTOVAR"))
									+ "|ОБНАРУЖЕНО " + tdup.recordCount + " ДОКУМЕНТ(ОВ) С ПАРАМЕТРАМИ:"
										+ "\n   НОМЕР: " + allt(platDoc.getVar("HNOM"))
										+ "\n   ДАТA: " + format("dd.mm.yyyy", tdup.getValue("FDOC_DAT"))
										+ "\n   СУММA: " + platDoc.getVar("HSUM")
										+ "\n   ТИП ДОКУМЕНТА: " + sDocType
										+ "\n   НАЗНАЧЕНИЕ ПЛАТЕЖА: " + platDoc.getVar("HTOVAR"));
									var alertStr2 = "\n\n" + UR("ДОКУМЕНТ З ІДКНТИЧНИМИ ПАРАМЕТРАМИ ВИ ІМПОРТУЄТЕ."
											+ "|ДОКУМЕНТ С ИДЕНТИЧНЫМИ ПАРАМЕТРАМИ ВЫ ИМПОРТИРУЕТЕ.");
									var alertStr3 = "\n\n"+UR("ІМПОРТУВАТИ ДОКУМЕНТ?|ИМПОРТИРОВАТЬ ДОКУМЕНТ?");
									var bAnswer = msgBox("yni",alertStr1+alertStr2+alertStr3,UR("Перевірка документів|Проверка документов"));
									if (bAnswer=="n")
									{
										progressM.setPos(progstep++);
										t.MoveNext();
										tdup.close();
										continue;
									}
									if(bAnswer=="i")
										this.bIgnorDuplic = true;
								}
								tdup.close();
							}
						}
						if(this.isValid)
						{
							//пытаемся проставить код контрагента и переменные банковской выписки
							this.setPlatOrgAndBVO(platDoc);
							platDoc.save();
							if(this.hasExt)
								platDoc.saveExtToDB()
							kolDoc++;
						}
					}				
					progressM.setPos(progstep++);
					t.MoveNext();
				}
				if(this.bvoDoc)//сохраняем документ общей банковской выписки
					this.bvoDoc.save();								
				progressM.stop();
				t.close();
				this.registryDoc(this.files4impmap[i], this.impRecCount);
				if (this.arhiv === true)
					this.saveToArchive(this.files4impmap[i]);				
				deleteFile(dbfFileName);
				if (toScrObj(this.olddelete))
				{
					var dpInfo = dpRegistry.getInfo(this.files4impmap[i]);
					if (dpInfo.PP != null && dpInfo.PV != null)
					{
						var sFileName = String(this.files4impmap[i]).replace(/copy_/g,"");
						deleteFile(this.clbdir + sFileName);
					}
				}
			}
			alert(ru("Кол-во импортированных платежей: ","Кілкість імпортованих платежів: ")+kolDoc);
		}
	}
	else if (this.type == "txt")//this.type = "txt"
	{	
		if (this.root == null)
			return false;		
		var XMLDBFSTRUobj = new DpTxtCLB();
		if (XMLDBFSTRUobj.xmlparse(this.root) == true)		
		{//normalno polyjili opisanie.		 
		 	ProgressM = getProgressMonitor(this.files4impmap.length*2);				
			ProgressM.beginTask(alertstr,this.files4impmap.length*2);
			var progstep = 1;
			for(var jj = 0; jj < this.files4impmap.length; jj++)
			{
				txtFileName = this.files4impmap[jj];
				MYfilename = txtFileName;	
				txtFileName = this.debdir + txtFileName;	
				if (toScrObj(this.clbdebug))
				{
					alertstr = UR("Імпортуємо файл: |Импортируем файл: ");
					var alertstr = UR("Імпортуємо "+(jj+1)+"-й файл з "+this.files4impmap.length+": |Импортируем "+(jj+1)+"-й файл из "+this.files4impmap.length+": ");
					alert(alertstr+" "+txtFileName);	
				}
				clbdir = getOrgPath() + "clbank/";
				
				if(this.setDocDatByFormat)//дату документа берем из имени файла
				{
					var im = this.clbmask.indexOf("*")
					if(im <= 0)
						im = 0;
					ib=txtFileName.lastIndexOf("copy_");
					ie=txtFileName.lastIndexOf(".")
					dateFromFile = txtFileName.substring(ib+5+im,ie);
					this.clbmask
					this.dat = new Date(strToDateFormat(dateFromFile,this.dformat.replace(/\|/g,""))).getVarDate();
				}
				if(this.period && this.row)//если есть параметр, то запрашиваем период за который импортировать документы
				{
					var par = new Object();
					par.escape = true;
					par.fileName = MYfilename;
					showWindow("i_period.xml",SW_MODAL,par);
					if (par.escape)
						return false;
					for (var j = 0; j < XMLDBFSTRUobj.fieldarray.length; j++)
					{
						if(XMLDBFSTRUobj.fieldarray[j]=="HDAT")
						{
							this.nDat = j;
						}
					}					
				}
				
				switch(this.row)
				{
					//в одной строчке файла хранится одна переменная документа 
					//(в качестве примера можно посмотреть clbanks/_RUS/SBERBANKTXT)
					case "VAR":
						var typeDocExpr = XMLDBFSTRUobj.hdocexpr;//выражение по которому определяется тип платежа
						var typeDocTxtSrch = getTxtSrchFromExpr(XMLDBFSTRUobj.hdocexpr);//текст по которому будем искать значение переменной и подставлять в выражение
						var filterExpr = XMLDBFSTRUobj.hdocfilter;
						
						var sFile	= String(ReadTxtFile(txtFileName,this.encodding));
						nNewLine	= 0,
						sLine		= "";
						if (sFile.length == 0)
							return;
						var sLineBegin = XMLDBFSTRUobj.hdocbegin;
						var sLineEnd =  XMLDBFSTRUobj.hdocend;
						var isReaddingVars = false;//флаг по кторому считываем переменные
						var rowFileDoc;//массив в котором будем хранить строки файла, относящиеся к переменным  экземпляра документа
						this.bIgnorDuplic = false;//флаг игнорирования проверки дублей
						this.initBVO();
						while(sFile.length>0)
						{
							nNewLine = sFile.indexOf('\n');
							if(-1 == nNewLine)
							{
								sLine	= sFile;
								sFile	= "";
							}
							else
							{
								sLine	= sFile.substr(0, nNewLine);
								sFile	= sFile.substr(nNewLine+1);
							}
							//пропускаем пустые строки 
							if ((sLine.length != 0))
							{
								//определяем начало документа и считываем все переменные до конца документа
								if(strIn(sLineBegin, sLine))
								{
									isReaddingVars = true;
									rowFileDoc = new Array();
									continue;
								}
								if(strIn(sLineEnd, sLine))//конец документа: сохраняем документ и обнуляем массив rowFileDoc
								{
									isReaddingVars = false;
									//определяем тип платежки: отфильтруем из массива строк файла строчку по которой определяется тип платежа
									var platType = rowFileDoc.filter(function(item){ return strIn(typeDocTxtSrch,item); });
									var sDocType = evalExprTxt(typeDocExpr,(platType.length==0?null:platType[0])).toUpperCase();
									if(sDocType!="PP" && sDocType!="PV")
									{
										alert(ru("Некоректный тип платежного документа: ","Некоректний тип птлатіжного документу: ")+sDocType);
										continue;
									}
									var OK = true;
									if(allt(filterExpr)!="")
										OK = evalExprTxt(filterExpr,(platType.length==0?null:platType[0]));
									if(!OK)
										continue;
									if(!this.cimportpppv || (this.cimportpppv == true && DocType == sDocType))
									{
										var platDoc = new DpDoc(sDocType,Noper);
										if(this.period && this.nDat!=null)
										{
											//определяем дату документа, чтобы проверить вхождение в период
											var platVarAr = rowFileDoc.filter(
												function(item)
												{
													var txtsearch = XMLDBFSTRUobj.txtsearch[this.nDat];
													if(typeOf(txtsearch).toLowerCase()=="string")
														return strIn(txtsearch,item);
													else
														return txtsearch.some(function(item2){ return strIn(item2,item) });
												}
											);
											var valTxt = platVarAr.length==0?null:getTxtTail(platVarAr,XMLDBFSTRUobj.txtsearch[this.nDat])
											this.dat = evalExprTxt(XMLDBFSTRUobj.funcarray[this.nDat],valTxt);
											if(differ(this.dat,d00)==0)
												continue;
										}
										this.isValid = true;
										platDoc.setVar("HPRDAT", d00);
										for(var i=0; i<XMLDBFSTRUobj.funcarray.length; i++)
										{
											if(this.period && this.row && !(differ(this.dat,par.bdat)>=0 && differ(this.dat,par.edat)<=0))
											{
												this.isValid = false;
												break;
											}
											//определяем переменные платежки
											var platVarAr = rowFileDoc.filter(
												function(item)
												{
													var txtsearch = XMLDBFSTRUobj.txtsearch[i];
trace("txtsearch >> "+txtsearch)
													if(typeOf(txtsearch).toLowerCase()=="string")
														return strIn(txtsearch,item);
													else
														return txtsearch.some(function(item2){ return strIn(item2,item) });
												}
											);
											var valTxt = platVarAr.length==0?null:getTxtTail(platVarAr,XMLDBFSTRUobj.txtsearch[i]);
trace("set var begin")
trace("expression>>"+XMLDBFSTRUobj.funcarray[i])
trace(String(valTxt))
											var docVar = XMLDBFSTRUobj.fieldarray[i].toUpperCase();
											var platVal = evalExprTxt(XMLDBFSTRUobj.funcarray[i],valTxt);
											trace("set vars >> "+docVar+" = "+platVal);
											if(docVar.indexOf("EXT.")==0)//определяем docVar как переменную или расширение
											{
												platDoc.setExt(docVar.replace("EXT.",""), platVal)
												this.hasExt = true;
											}	
											else
												platDoc.setVar(docVar,platVal);
											
										}
										if (this.dat !=  null)	
											platDoc.setVar("HDAT", this.dat);
										if (toScrObj(this.cduplic) && !this.bIgnorDuplic)//проверка дублей
										{
											//проверка дублей
											if (toScrObj(this.cduplic) && !this.bIgnorDuplic)
											{
												if(!this.checkDupl(platDoc))
													continue;
											}
										}
										if(this.isValid)
										{
											//пытаемся проставить код контрагента и переменные банковской выписки
											this.setPlatOrgAndBVO(platDoc);
											platDoc.save();
											if(this.hasExt)
												platDoc.saveExtToDB()
											kolDoc++;
										}
									}
								}
								if(isReaddingVars)
									rowFileDoc[rowFileDoc.length] = sLine; 
							}
						}
					break;
					//в одной строчке файла хранится один документ, переменные которого разделены специальным символом 
					//или комбинацией символов (в качестве примера можно посмотреть clbanks/AVALBANKCSVXML)
					case "DOC_SPLIT":
					//в одной строчке файла хранится один документ, переменные которого записаны в конкретных диапазонах 
					//относительно начала строки (в качестве примера можно посмотреть clbanks/ALFABANKWTXTXML)
					case "DOC_IND":
						var typeDocExpr = XMLDBFSTRUobj.hdocexpr;//выражение по которому определяется тип платежа
						var filterExpr = XMLDBFSTRUobj.hdocfilter;
						var sFile	= String(ReadTxtFile(txtFileName,this.encodding));
						nNewLine	= 0,
						sLine		= "";
						if (sFile.length == 0)
							return;
						this.bIgnorDuplic = false;//флаг игнорирования проверки дублей
						this.initBVO();
						var lineNom = 1;
						if(this.row=="DOC_SPLIT" && XMLDBFSTRUobj.splitter.length==0)
						{
							alert(ru("Не определен разделитель переменных!","Не визначений роздільник змінних!"));
							return false;
						}
						while(sFile.length>0)
						{
							nNewLine = sFile.indexOf('\n');
							if(-1 == nNewLine)
							{
								sLine	= sFile;
								sFile	= "";
							}
							else
							{
								sLine	= sFile.substr(0, nNewLine);
								sFile	= sFile.substr(nNewLine+1);
							}
							//пропускаем пустые строки и строки идущие до указаной в атрибуте rowstart
							if ((sLine.length != 0) && lineNom++>=XMLDBFSTRUobj.rowstart)
							{
								//создаем массив переменных, разпарсив строку файла импорта
								var varAr;
								if(this.row=="DOC_SPLIT")
									varAr = sLine.split(XMLDBFSTRUobj.splitter);
								else
								{
									var strExpr = typeDocExpr;
									for(var i=0; i<XMLDBFSTRUobj.funcarray.length; i++)
										strExpr += XMLDBFSTRUobj.funcarray[i];
									varAr = rangeSplitStr(sLine,strExpr);
								}
								//определяем тип платежки
								var sDocType = evalExprTxt(typeDocExpr,varAr,this.row).toUpperCase();
								if(sDocType!="PP" && sDocType!="PV")
								{
									alert(ru("Некоректный тип платежного документа: ","Некоректний тип птлатіжного документу: ")+sDocType);
									continue;
								}
								var OK = true;
								if(allt(filterExpr)!="")
									OK = evalExprTxt(filterExpr,varAr,this.row);
								if(!OK)
									continue;
								if(!this.cimportpppv || (this.cimportpppv == true && DocType == sDocType))
								{
									var platDoc = new DpDoc(sDocType,Noper);
									if(this.period && this.nDat!=null)
									{
										//определяем дату документа, чтобы проверить вхождение в период
										this.dat = evalExprTxt(XMLDBFSTRUobj.funcarray[this.nDat],varAr,this.row);
										if(differ(this.dat,d00)==0)
											continue;
									}
									this.isValid = true;
									platDoc.setVar("HPRDAT", d00);
									for(var i=0; i<XMLDBFSTRUobj.funcarray.length; i++)
									{
										if(this.period && this.row && !(differ(this.dat,par.bdat)>=0 && differ(this.dat,par.edat)<=0))
										{
											this.isValid = false;
											break;
										}
										//определяем переменные платежки
										var docVar = XMLDBFSTRUobj.fieldarray[i].toUpperCase();
										var platVal = evalExprTxt(XMLDBFSTRUobj.funcarray[i],varAr,this.row);
										trace("set vars >> "+docVar+" = "+platVal);
										if(docVar.indexOf("EXT.")==0)//определяем docVar как переменную или расширение
										{
											platDoc.setExt(docVar.replace("EXT.",""), platVal)
											this.hasExt = true;
										}	
										else
											platDoc.setVar(docVar,platVal);
										
									}
									if (this.dat !=  null)	
										platDoc.setVar("HDAT", this.dat);
									//проверка дублей
									if (toScrObj(this.cduplic) && !this.bIgnorDuplic)
									{
										if(!this.checkDupl(platDoc))
											continue;
									}
									if(this.isValid)
									{
										//пытаемся проставить код контрагента и переменные банковской выписки
										this.setPlatOrgAndBVO(platDoc);
										platDoc.save();
										if(this.hasExt)
											platDoc.saveExtToDB()
										kolDoc++;
									}
								}
							}
						}
					break;
					default://старый импорт с помощью отдельного скрипта
						ImportScrLbl = XMLDBFSTRUobj.hdocexpr;				
						if (!isFile(clbdir+ImportScrLbl))
						{
							alertstr1 = UR("Не знайдено файл для обробки: |Не найден файл файл обработки: ");		
							alertstr2 = clbdir+ImportScrLbl;
							alertstr3 = UR("Імпорт не виконано. Можливо, Ви не маєте повноважень на цю дію. ВИХІД.  |Импорт не выполнен. Возможно, Вы не имеете прав на это действие. ВЫХОД.");
							alert(alertstr1+"\n"+alertstr2+"\n"+alertstr3);	
							return false;
						}
						include(clbdir+ImportScrLbl);
						res = ReadImpFile(txtFileName, Noper, this.cimportpppv, this.cduplic, this.dat);				
						if (!res)
							return false;
					break;
				}
				ProgressM.worked(progstep++);
				this.impRecCount.PP = "неизвестно";
				this.impRecCount.PV = "неизвестно";
				this.registryDoc(this.files4impmap[jj], this.impRecCount);
				if (this.arhiv === true)
					this.saveToArchive(this.files4impmap[jj]);				
				deleteFile(txtFileName);
				if (toScrObj(this.olddelete))
				{
					var dpInfo = dpRegistry.getInfo(this.files4impmap[jj]);
					if (dpInfo.PP != null && dpInfo.PV != null)
					{
						var sFileName = String(this.files4impmap[jj]).replace(/copy_/g,"");
						deleteFile(this.clbdir + sFileName);
					}
				}	
			}//for проход по всем файлам
			if(this.row)
				alert(ru("Кол-во импортированных платежей: ","Кілкість імпортованих платежів: ")+kolDoc);
			if(this.bvoDoc)//сохраняем документ общей банковской выписки
				this.bvoDoc.save();
			ProgressM.worked(this.files4impmap.length*2);					
			ProgressM.done();
		}
	}
}

function DpCLBrunExport(IDs)
{
	var alertstr = UR("Експортуємо платіжні доручення: |Экспортируем платёжные поручения:");
	if (this.root == null)
		return false;
	var XMLDBFSTRUobj = new DpCLBExp();
	if(!XMLDBFSTRUobj.xmlparse(this.root))		
		return false;
	if(this.clbmask.indexOf("*")==-1)
		sFileName = this.clbdir+"/"+this.clbmask;
	else
		sFileName = this.clbdir+"/"+this.clbmask.replace("*",format(this.dformat,new Date()));
	var isAppend = false;
	switch(String(this.type).toLowerCase())
	{
		case "dbf":
			if(!isFile(this.template))
			{
				alert(ru("Не знайдено файл шаблону ","Не найден файл шаблона ")+this.template);
				return false;
			}
			switch(this.existfile)
			{
				case 0://перезаписываем
					copyFile(this.template, sFileName);
				break;
				case 1://дозаписываем
					isAppend = true;
					if(!isFile(sFileName))
						copyFile(this.template, sFileName);
				break;
				case 2://если файл есть, то спрашиваем у пользователя
					if(isFile(sFileName))
					{
						if(confirm(ru("Файл экспорта уже существует, перезаписать его?\nВ противном случае данные будут дозаписаны.",
													"Файл експорту вже існує, перезаписати його?\nВ іншому випадку дані будуть дозаписані.")+"\n"+sFileName))
							copyFile(this.template, sFileName);
						else
							isAppend = true;
					}
					else
						copyFile(this.template, sFileName);
				break;
			}
			if(!isFile(sFileName))
			{
				alert(ru("Помилка! Відсутній файл експорту!","Ошибка! Отсутствует файл экспорта!")+"\n"+sFileName);
				return false;
			}
			
			var oDDBF = lpProxy.getDBManager().getDBFWriter(sFileName);
			oDDBF.setCharactersetName(this.encodding);
			include("doc/DpDoc.js");
			var oDoc = new DpDoc("PP",0);
			setProgressRange(1, IDs.length);
			for(var i=0; i<IDs.length; i++)
			{
				DOCNUMBER = i + 1;
				var DBFarray = new Array();
				oDoc.clear();
				oDoc.loadByID(IDs[i]);
				for(var j=0; j<XMLDBFSTRUobj.funcarray.length; j++)
				{
					if(allt(XMLDBFSTRUobj.funcarray[j])=="")
						XMLDBFSTRUobj.funcarray[j] = null;
					DBFarray[j] = oDoc.eval(XMLDBFSTRUobj.funcarray[j]);
				}
				oDDBF.addRecord(DBFarray);
				k = i+1;
				setProgressPos(k, ru("Экспорт ","Експорт ")+k+"/"+IDs.length);
			}
			oDDBF.write();
			setProgressPos(0);
			if(isAppend)
			{
				t = OpenTable("f",sFileName);
				rowCount = t.rowCount;
				t.close();
			}
			alert(ru("Кол-во експортированных платежей: ","Кіл-ть експортованих платежів: ")+IDs.length
				+(isAppend?"\n"+ru("Общее кол-во платежей в файле: ","Загальна кіл-ть платежів в файлі: ")+rowCount:"")
				+"\nФайл: "+sFileName);
		break;
		case "txt":
			var sWrite = "";
			if(XMLDBFSTRUobj.header)
				sWrite += XMLDBFSTRUobj.header+XMLDBFSTRUobj.endofline;
			switch(this.existfile)
			{
				case 0://перезаписываем
					deleteFile(sFileName);
				break;
				case 1://дозаписываем
					isAppend = true;
				break;
				case 2://если файл есть, то спрашиваем у пользователя
					if(isFile(sFileName))
					{
						if(confirm(ru("Файл экспорта уже существует, перезаписать его?\nВ противном случае данные будут дозаписаны.",
													"Файл експорту вже існує, перезаписати його?\nВ іншому випадку дані будуть дозаписані.")+"\n"+sFileName))
							deleteFile(sFileName);
						else
							isAppend = true;
					}
				break;
			}
			if(isAppend)
			{
				if(!isFile(sFileName))
				{
					alert(ru("Помилка! Відсутній файл експорту!","Ошибка! Отсутствует файл экспорта!")+"\n"+sFileName);
					return false;
				}
				else
				{
					var sFile = String(ReadTxtFile(sFileName,this.encodding));
					//если файл заканчивается специальной строкой, тогда дозаписывать текст нужно до этой строчки
					if(XMLDBFSTRUobj.footer)
					{
						nNewLine = 0,
						footerInd = sFile.indexOf(XMLDBFSTRUobj.footer);
						if (sFile.length != 0 && footerInd>-1)
							sWrite = sFile.substr(0,footerInd);
					}
					else
						sWrite = sFile + XMLDBFSTRUobj.endofline;
				}
			}
			
			include("doc/DpDoc.js");
			var oDoc = new DpDoc("PP",0);
			setProgressRange(1, IDs.length);
			for(var i=0; i<IDs.length; i++)
			{
				DOCNUMBER = i + 1;
				oDoc.clear();
				oDoc.loadByID(IDs[i]);
				switch(this.row)
				{
					case "VAR":
						if(XMLDBFSTRUobj.docbegin)
							sWrite += XMLDBFSTRUobj.docbegin+XMLDBFSTRUobj.endofline;
						for(var j=0; j<XMLDBFSTRUobj.funcarray.length; j++)
						{
							if(allt(XMLDBFSTRUobj.funcarray[j])=="")
								XMLDBFSTRUobj.funcarray[j] = null;
							sWrite += XMLDBFSTRUobj.fieldarray[j]+XMLDBFSTRUobj.splitter+replaceSpecSymbol(oDoc.eval(XMLDBFSTRUobj.funcarray[j]))+XMLDBFSTRUobj.endofline;
						}
						if(XMLDBFSTRUobj.docend)
							sWrite += XMLDBFSTRUobj.docend+XMLDBFSTRUobj.endofline;
						else
							sWrite += XMLDBFSTRUobj.endofline;
					break;
					case "DOC_IND":
						for(var j=0; j<XMLDBFSTRUobj.funcarray.length; j++)
						{
							if(allt(XMLDBFSTRUobj.funcarray[j])=="")
								XMLDBFSTRUobj.funcarray[j] = null;
							var ind1 = Number(XMLDBFSTRUobj.indarray[j].ind1);
							var ind2 = Number(XMLDBFSTRUobj.indarray[j].ind2);
							var val = toScrObj(oDoc.eval(XMLDBFSTRUobj.funcarray[j]));
							var str = replaceSpecSymbol(val);
							var len = ind2-ind1+1;
							//перед записью обрезаем строку до максимально возможной длины, чтобы не было смещений по позициям в выходном файле
							//взависимости от типа выравнивания текста, дополняем с нужной стороны пробелами
							if(XMLDBFSTRUobj.typearray[j].toLowerCase()=="number")
							{
								if(XMLDBFSTRUobj.numberalign == "LEFT")
									sWrite += padr(str.substr(0, len), len, " ");
								else
									sWrite += padl(str.substr(0, len), len, " ");
							}
							else
							{
								if(XMLDBFSTRUobj.textalign == "LEFT")
									sWrite += padr(str.substr(0, len), len, " ");
								else
									sWrite += padl(str.substr(0, len), len, " ");
							}
						}
						sWrite += XMLDBFSTRUobj.endofline;
					break;
					case "DOC_SPLIT":
						for(var j=0; j<XMLDBFSTRUobj.funcarray.length; j++)
						{
							if(allt(XMLDBFSTRUobj.funcarray[j])=="")
								XMLDBFSTRUobj.funcarray[j] = null;
							sWrite += replaceSpecSymbol(oDoc.eval(XMLDBFSTRUobj.funcarray[j]))+(j==XMLDBFSTRUobj.funcarray-1?"":XMLDBFSTRUobj.splitter);
						}
						sWrite += XMLDBFSTRUobj.endofline;
					break;
				}
				k = i+1;
				setProgressPos(k, ru("Экспорт ","Експорт ")+k+"/"+IDs.length);
			}
			if(XMLDBFSTRUobj.footer)
				sWrite += XMLDBFSTRUobj.footer;
			//для досовой кодировки заменяем украинские "і" на латынские
			if(this.encodding == "cp866")
			{
				sWrite = new java.lang.String(sWrite);
				sWrite = sWrite.replaceAll("і", "i");
				sWrite = sWrite.replaceAll("І", "I");
			}
			lpProxy.writeToFile(sWrite, sFileName, this.encodding);
			setProgressPos(0);
			alert(ru("Кол-во експортированных платежей: ","Кіл-ть експортованих платежів: ")+IDs.length
				+"\nФайл: "+sFileName);
		break;
	}
}

//////////
var	bImport	= true;
var DELDIR = false;
var DBformat = new String("");//Opisuvaet tipu formatov//
var debetdir;
var exportdirrectory;
function datatime(Sdebetmask)
{
	stroka = allt(Sdebetmask);
	letter = stroka.charAt(0);
	if (letter == "/")
	{
		stroka = allt(stroka.substring((stroka.indexOf("/")+1),(stroka.lastIndexOf("/"))));
		stroka = stroka.toLowerCase();
		if (stroka == "datatime")
		{		
			DBformat = "datatime";
			return true;
		}
		else
		{
			return false;
		}	
	}
	else 
	{
		return false;
	}
}
function modelword(filename, nomerfile, bankmask, debetmask)
{//Tyt idet SVOEOBRAZNAYA obrabotka maski.Funkcia ispol6zyetsa i pri sravnenii maska!=filename.
 //Ne vse simvolu zapresjenu,a tol6ko neobxodimue.Dobavlyaute tol6ko pod konkretnyu masky.
 //Nekotorue zapresjennue simvolu vurezau sam.Vozmojno,v nekotorou maske oni poyavyatsa,togda zakomentirovat6 stroky.
//debugger;
 filename = String(filename);
 bankmask = String(bankmask);
 debetmask= String(debetmask);
 colq = debetmask.split("?");
 cols = debetmask.split("*");
 var okword = new String(""); 
 var okwordfile = filename;
 //alert(filename+": "+nomerfile+": "+bankmask+": "+debetmask) 
 var ext = filename.split(".");
 if (ext.length == 1)
 {
	WAITTIMEOUT("Файл "+filename+" не имеет расширения.",20);
	return "";//jtob prosto vuiti
 }
 else//est6 rasshirenie
 {
	if	(DBformat == "datatime")
		{	
			if (colq.length>1 || cols.length>1)
			{
				alert("Ошибка: Маска импорта для формата /DATATIME/ не должна содержать метасимволы."
				+"\nИсправьте маску в 'Установки параметров'->'Клиент-банк'.");				
			}			
				d = new Date();
				dat = new String(d.getDate());
				month = new String(d.getMonth()+1);
				god = new String(d.getFullYear());
				year = god.substr(2,2);
				okword = dat + month + year + nomerfile + "." + ext[1];
				return okword;			
		}
	else		
    if	(bankmask==debetmask)
    {
//    alert(bankmask+"=="+debetmask+": "+filename+": "+filename.length)
		//alert(filename+": "+filename.length)
         var parts = new Array(filename.length);                  
         for (var len=0;len<filename.length;len++)
		 {		 
			letter = filename.charAt(len);
			//alert(letter);
            switch (letter)
            {
               case "#":
                 break;
               case "@":
                 break;
               case "_":
                 break;
               case " ":
                 break;
               case "!":
                 break;  
               case "%":                        
                 break;
               case "-":
                 break;  
               case "?":
                 okword += nomerfile;
                 break;
               case "*":
                 okword += nomerfile;
                 break;
               default:
                 okword +=letter;                                                    
            }
         }          
        return okword;
    }     
    else//   
    {
		if (bankmask != debetmask)
		{ 
			debetmasklen = new Array(debetmask.length);
			var vopr = debetmask.split("?");
			var star = debetmask.split("*");            
			for (var len = 0; len < debetmask.length; len++)
			{ 
				letter = debetmask.charAt(len);
				switch (letter)
				{
				case "#":
					break;
				case "@":
					break;
				case "_":
					break;
				case " ":
					break;
				case "!":
					break;  
				case "%":                        
					break;
				case "-":
					break;  
				case "?":
					okword += nomerfile;
					break;
				case "*":
					okword += nomerfile;
					break;
				default:
					okword +=letter;                                                    
				}
			}                         
		}       
		return okword;
	}
 }  
}

function PrepareFiles(impDir, workDir, impMask)
{	
	// подготовка рабочих директорий
    var strMsg = "";
    if (impDir == "" || workDir == "")
    {
    	strMsg = UR("Не встановлено робочі директорії. Встановіть їх в меню "
    		+ "|Не установлены рабочие директории. Установите их в меню ")+getMenuItemPath("l_clbnk.xml","d");
    	alert(strMsg, ICON_ERROR);
    	return false;     
    }
    if (!isDir(impDir))
    {
     	strMsg = UR("Директорії імпорту неіснує. Встановіть її в меню "
    		+ "|Директории импорта несуществует. Установите ее в меню ")+getMenuItemPath("l_clbnk.xml","d");
    	alert(strMsg, ICON_ERROR);
    	return false;     	
    }    
    if (!isDir(workDir))
    {
    	if (!createDirectory(workDir) || !isDir(workDir))
    	{
      		strMsg = UR("Робочої директорії неіснує. Встановіть її в меню "
	    		+ "|Рабочей директории несуществует. Установите ее в меню ")+getMenuItemPath("l_clbnk.xml","d");
	    	alert(strMsg, ICON_ERROR);
	    	return false;      		
    	}	
    }
    impDir = String(getAbsolutePath(impDir) + "/");
    workDir = String(getAbsolutePath(workDir) + "/");
    if (impDir.toLowerCase() == workDir.toLowerCase())
    {
    	strMsg = UR("Робочі директорії співпадають. Змініть їх в меню "
    		+ "|Рабочие директории совпадают. Измените их в меню ")+getMenuItemPath("l_clbnk.xml","d");
    	alert(strMsg, ICON_ERROR);
    	return false;  
    }    
    workDir += this.bnklbl + "/";
   
	this.clbdir = impDir;
	this.debdir = workDir;

    // директории подготовлены	
	
	 // подготовка масок
	 if (impMask == "")
	 {
	 	strMsg = UR(
			"Маска імпорту для даного формату не встановлена.\nВстановіть маску в меню "
			+ "|Маска импорта для данного формата не установлена.\nУстановите маску в меню ")+getMenuItemPath("l_clbnk.xml","d");
    	alert(strMsg, ICON_ERROR);
    	return false;  			
	 }
	// маски подготовлены
	var tmpWorkDirFiles = snapDirectory(workDir);
	for (var i in tmpWorkDirFiles)
		if (isFileEx(workDir + tmpWorkDirFiles[i]))
			deleteFile(workDir + tmpWorkDirFiles[i]);
	tmpWorkDirFiles = snapDirectory(workDir);
	if (tmpWorkDirFiles.length > 0)
		for (var i in tmpWorkDirFiles)
		{
			if (tmpWorkDirFiles[i] == null)
				continue;
			if (isFileEx(tmpWorkDirFiles[i]))
			{
				alert(UR("Невдалося очистити робочу директорію. Будь ласка очистіть її вручну.\nДиректорія : "
					+ "|Неудалось очистить рабучую директорию. Пожалуйста очистите ее вручную.\nДиректория : ")
					+ workDir, ICON_WARNING);
				return false;
			}
		}
	
	if (toScrObj(this.clbdebug))
		alert(
			UR("Імпорт файлів буде проходити з такими налогодженнями:|Импорт файлов будет проходить с такими настройками:")
			+ UR("\nДиректорія імпорту: |\nДиректория импорта: ") + new DpFile(impDir).getCanonicalPath()
			+ UR("\nРобоча директорія: |\nРабочая директория: ") + new DpFile(workDir).getCanonicalPath()			
			+ UR("\nМаска імпорту: |\nМаска импорта: ") + impMask);
	
	
	var allImpTblList =  snapDirectory(impDir);
//	alert(impDir);
	var impTblList = new Array();
	var j = 0;
	var arg;
	if (this.cimportpppv == true)
		arg = DocType;
	for (var i in allImpTblList)
	{
		if (FileFilterAccept(allImpTblList[i],impMask)
			&& FileFilterOnDateAccept(impMask, this.dformat, allImpTblList[i],DATB.getValue(),DATE.getValue()))
		{		
//			alert(Number(this.impalrimp));
			switch (Number(this.impalrimp))
			{
				case 1:
					if (dpRegistry.qryImport(allImpTblList[i], arg))
						impTblList[j++] = allImpTblList[i];
					break;
				case 2:
					impTblList[j++] = allImpTblList[i];				
			}			
		}
	}
		
	if (toScrObj(this.clbdebug))
		alert((this.dformat!=null?UR("Формат дати в імені файлу: |Формат даты в имени файла: ")+this.dformat+"\n"+UR("Період імпорту: |Период импорта: ")
				+format("dd.mm.yy-",DATB.getValue())+format("dd.mm.yy",DATE.getValue())+"\n":"")
			+UR("Кількість файлів для імпортування: |Количество файлов для импортирования: ") + impTblList.length +"\n"+impTblList);	

	if (!isDir(workDir))
		createDirectory(workDir);		
	
	//создаём копии файлов, с которыми будем непосредственно работать и потом перемещать в архивную папку
	for (var i in impTblList)
		 copyFile(impDir + impTblList[i], workDir +"copy_"+ impTblList[i]);
	return true;
}

///////////4 txt banks
function DpTxtCLB()
{//desc. of xml bank structure 4 *.txt
	this.hdocexpr = new String("");//имя скриптового файла для разборок
	this.hdocbegin = new String("");//строка начала документа в файле
	this.hdocend = new String("");//строка конца документа в файле
	this.splitter = new String("");//разделитель переменных в строке файла
	this.rowstart = 1;//номер строки с которой начинать считывать данные в файле
	//this.banklbl = new String("");
	this.funcarray = new Array();//ф-ции вычисления полей документа
	this.fieldarray = new Array();//поля документа
	this.txtsearch = new Array();//текст, который будем искать в строке текстового файла (для файлов где в одной строке хранится одна переменная документа)
	this.xmlparse = XmlParse;
//	this.init = DbfXmlinit;
}

///////////4 DBF banks
function DpDbfCLB()
{//desc. of xml bank structure 4 *.dbf
	this.hdocexpr = new String("");//выражение - PP/PV
	this.hdocfilter = new String("");//фильтр
	this.banklbl = new String("");
	this.funcarray = new Array();//ф-ции вычисления полей документа
	this.fieldarray = new Array();//поля документа
	this.xmlparse = XmlParse;
//	this.init = DbfXmlinit;
}

function XmlParse(xmlDocumentElement)//передаём xmlDocumentElement, заполнится XMLstruObj()
{
	var name = xmlDocumentElement.getNodeName();
	if (name != "CLBANK")
	{
		return false;
	}
	var Attr = xmlDocumentElement.getAttribute("type").toUpperCase();
	if (Attr == "TXT")
	{

		var sTextOfElement = "";
		//var Elvardoc = xmlDocumentElement.getElementsByTagName("VARDOC")[0];		
		var Elvardocexpr = xmlDocumentElement.getElementsByTagName("VARDOCEXPR")[0];
		sTextOfElement = Elvardocexpr.getText();
	    this.hdocexpr = Elvardocexpr.getText();
	    this.hdocfilter = new String("");
	    var Elvardocfilter = xmlDocumentElement.getElementsByTagName("FILTER")[0];
	    if(Elvardocfilter)
			this.hdocfilter = Elvardocfilter.getText();
	    
	    var Elvardoc = xmlDocumentElement.getElementsByTagName("VARDOC")[0];
	    if(Elvardoc)
	    {
		    this.hdocbegin = Elvardoc.getAttribute("docbegin");
			this.hdocend = Elvardoc.getAttribute("docend");
			this.splitter = Elvardoc.getAttribute("splitter");
			this.rowstart = Number(Elvardoc.getAttribute("rowstart"));
			var ElementsVardoc = Elvardoc.getChildNodes();//все дети в VARDOC		
			for (var i = 0;i < ElementsVardoc.length; i++)
			{
				ChildElement = ElementsVardoc[i];
				this.funcarray[i] = ChildElement.getText();
				this.fieldarray[i] = ChildElement.getNodeName();
				this.txtsearch[i] = getTxtSrchFromExpr(this.funcarray[i]);//текст, который будем искать в строке текстового файла (для файлов где в одной строке хранится одна переменная документа)
			}
	    }
		return true;
	}
	else if (Attr == "DBF")			
	{
		var sTextOfElement = "";
		var Elvardoc = xmlDocumentElement.getElementsByTagName("VARDOC")[0];		
		var Elvardocexpr = xmlDocumentElement.getElementsByTagName("VARDOCEXPR")[0];
		sTextOfElement = Elvardocexpr.getText();
	    this.hdocexpr = Elvardocexpr.getText();	
	    this.hdocfilter = new String("");
	    var Elvardocfilter = xmlDocumentElement.getElementsByTagName("FILTER")[0];
		if(Elvardocfilter)
			this.hdocfilter = Elvardocfilter.getText();  		
		var ElementsVardoc = Elvardoc.getChildNodes();//все дети в VARDOC		
		for (var i = 0;i < ElementsVardoc.length; i++)
		{
			ChildElement = ElementsVardoc[i];
			this.funcarray[i] = ChildElement.getText();
			this.fieldarray[i] = ChildElement.getNodeName();
		}
		return true;
	}
	else
	{
		return false;
	}
}

function DpCLBExp()
{
	this.banklbl = new String("");
	this.funcarray = new Array();//ф-ции вычисления полей
	this.fieldarray = new Array();//поля файла
	this.header = "";//заголовок (только для текстовых файлов)
	this.footer = "";//концовка (только для текстовых файлов)
	this.splitter = "";//разделитель (только для текстовых файлов)
	this.docbegin = "";//начало описания документа (только для текстовых файлов)
	this.docend = "";//окончание описания документа (только для текстовых файлов)
	this.endofline = "\n";//конец строки в текстовом файле
	this.indarray = new Array();//позиции переменных в текстовом файле
	this.typearray = new Array();//типы переменных в текстовом файле (позиционном)
	this.xmlparse = XmlParseExp;
}

function XmlParseExp(xmlDocumentElement)
{
	var name = xmlDocumentElement.getNodeName();
	if (name != "CLBANK")
		return false;
	var Attr = String(xmlDocumentElement.getAttribute("type")).toUpperCase();
	var rowType = xmlDocumentElement.getAttribute("row").toUpperCase();
	var sTextOfElement = "";
	var field = xmlDocumentElement.getElementsByTagName("FIELDS")[0];
	if(!field)
	{
		alert(ru("Не найден тэг FIELDS!","Не знайдено тег FIELDS!"));
		return false;
	}
	switch(Attr)
	{
		case "TXT":
			this.splitter = field.getAttribute("splitter");
			this.docbegin = field.getAttribute("docbegin");
			this.docend = field.getAttribute("docend");
			if(String(field.getAttribute("endofline")).toUpperCase()=="CRLF")
				this.endofline = "\r\n";
			else
				this.endofline = "\n";
			var header = xmlDocumentElement.getElementsByTagName("HEADER")[0];
			if(header)
				this.header = header.getText();
			var footer = xmlDocumentElement.getElementsByTagName("FOOTER")[0];
			if(footer)
				this.footer = footer.getText();
		case "DBF":		
			var fieldExpr = field.getChildNodes();//все дети в FIELDS		
			for (var i = 0;i < fieldExpr.length; i++)
			{
				ChildElement = fieldExpr[i];
				this.funcarray[i] = ChildElement.getText();
				this.fieldarray[i] = ChildElement.getNodeName();
				if(rowType == "DOC_IND")
				{
					if(String(field.getAttribute("textalign")).toUpperCase()=="RIGHT")
						this.textalign = "RIGHT";
					else
						this.textalign = "LEFT";
					if(String(field.getAttribute("numberalign")).toUpperCase()=="LEFT")
						this.numberalign = "LEFT";
					else
						this.numberalign = "RIGHT";					
					var ind = new Object();
					ind.ind1 = ChildElement.getAttribute("ind1");
					ind.ind2 = ChildElement.getAttribute("ind2");
					this.indarray[i] = ind;
					this.typearray[i] = ChildElement.getAttribute("type");
				}
			}
		break;
		default:
			alert(ru("Невідомий формат ","Неизвестный формат ")+Attr);
			return false;
		break;
	}
	return true;
}

function getOrgNum(OKPO,MFO,RSCH)
{
	return getOrgNo(OKPO, MFO, RSCH);
	/*	
	if (OKPO == null || MFO == null || RSCH == null)
		return 0;
	var OKPO = allt(String(OKPO));
	var MFO = allt(String(MFO));
	var RSCH = allt(String(RSCH));
	var clKontra = getPar("CODPLAT");
	var findNum = 0;
	var sqlFindStr =
		"SELECT FCOD FROM ^CLRELCLCL r, ^CL_POST p "
		+" WHERE r.FCL = "+ clKontra +" AND r.FWID_CL = p.FWID_CL "
		+" AND p.FCOD_ST = "+ sqlTo(String(OKPO));
	var t = OpenTable("s",sqlFindStr); 
	trace(t.recordCount);
	if (t.recordCount == 1)//return toScrObj(t.getValue("FCOD"))
	{			
		var sqlFindStr =
		"SELECT FCOD FROM ^CLRELCLCL r, ^CL_POST p, ^CL_ORGRS o  WHERE r.FCL = " + clKontra 
		+ " AND r.FWID_CL = p.FWID_CL AND  r.FWID_CL = o.FWID_CL  AND p.FCOD_ST  ="
		+ sqlTo(String(OKPO))+" AND o.FMFO = "+sqlTo(String(MFO))+"  AND o.FRAS_SCH = "+sqlTo(String(RSCH))		
		var snap = OpenTable("s" , sqlFindStr)// getSnap(sqlFindStr)
		if (snap != null)
			return snap.getValue("FCOD"); //snap[0]
	}
	return 0;*/											
}

function getOrgNo(OKPO, MFO, RSCH)
{	
	if (OKPO == null)
		OKPO = "";
	if (MFO == null)
		MFO = "";
	if (RSCH == null)
		RSCH = "";
	var clKontra = getPar("CODPLAT");
	OKPO = allt(String(OKPO));
	MFO = allt(String(MFO));
	RSCH = allt(String(RSCH));
	var speps = new Array();
	switch(modeImport)
	{
		case 0:
			speps[0] = "zmr";
			break;
		case 1:
			speps[0] = "mr";
			break;
		case 2:
			speps[0] = "z";
			break;
		case 3:
			speps[0] = "zmr";
			speps[1] = "mr";
			speps[2] = "z";
			break;		
	}
	var hashOrgNo = new Array();
	for (var i = 0; i < speps.length; i++)
	{
		var strSQL = "";
		switch(speps[i])
		{
			case "zmr":
			strSQL = "SELECT FCOD FROM ^CLRELCLCL r, ^CL_POST p, ^CL_ORGRS o  WHERE r.FCL = " + clKontra
                     	+ " AND r.FWID_CL = p.FWID_CL AND  r.FWID_CL = o.FWID_CL AND p.FCOD_ST = " + sqlTo(String(OKPO))
                        + " AND o.FMFO = " + sqlTo(String(MFO)) + "  AND o.FRAS_SCH = " + sqlTo(String(RSCH));
			break;
		case "mr":
			strSQL = "SELECT FCOD FROM ^CLRELCLCL r, ^CL_ORGRS o "
                     	+ " WHERE r.FCL = " + clKontra + " AND r.FWID_CL = o.FWID_CL "
                        + " AND o.FMFO = " + sqlTo(String(MFO)) + " AND o.FRAS_SCH = " + sqlTo(String(RSCH));
			break;
		case "z":
			strSQL = "SELECT FCOD FROM ^CLRELCLCL r, ^CL_POST p "
                     	+ " WHERE r.FCL = " + clKontra + " AND r.FWID_CL = p.FWID_CL "
                        + " AND p.FCOD_ST = " + sqlTo(String(OKPO));
			break;
		}
		if (strSQL == "")
			continue;
		var tbl = OpenTable("s", strSQL);
		var hash = new Array();
		for (tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
			hash[hash.length] = tbl.getValue("FCOD");
		if (hash.length == 1)
		{
			tbl.close();
			return hash[0];
		}
		hashOrgNo[hashOrgNo.length] = hash;
		tbl.close();
	}
	if (useFirstFind)
	{
		for (var i = 0; i < hashOrgNo.length; i++)
			if (hashOrgNo[i].length > 0)
				return hashOrgNo[i][0];
	}
	return 0;
}

function getOrgBnkName(ORG,MFO,RSCH,VAL)
{
	//т.к. на один и тотже расчетный счет и МФО может быть несколько счетов в разных валютах, то дополнительно проверяем и валюту
	var snap = getSnap("select Fnazv_bnk from ^cl_orgrs where Fwid_cl=(select MAX(r.Fwid_cl) from ^clrelclcl as r "
					+" inner join ^cl_post as p on r.Fwid_cl=p.Fwid_cl where r.Fcod="+ORG+") "
						+" and Fras_sch="+sqlTo(String(RSCH))+" and Fmfo="+sqlTo(String(MFO))+(VAL!=null?" AND Fval="+VAL:""));
	if(snap)
		return snap[0];
	else
		return "";
}

function showListFile(arrFiles)
{
	var tmpTbl = getTmpTableName();
	ExecuteSQL("CREATE TABLE " + tmpTbl + " (fwid " + SqlType("counter") + ", ffile " + SqlType("text")  + ")");
	for (var i in arrFiles)
		ExecuteSQL("INSERT INTO " + tmpTbl + " (ffile) values(" + sqlTo(arrFiles[i]) + ")");
	var obj = new Object();
	obj.caption = "Список файлів імпорту|Список файлов импорта";
	obj.ret = new Object();
	obj.ret.ffile = "";
	obj.cells = new Array();
	obj.cells[0] = new Object();
	obj.cells[0].name = "ffile";
	obj.cells[0].text = "Файл";
	obj.cells[0].width = 60;	
	browse("SELECT * FROM " + tmpTbl + " ORDER BY ffile", obj, SW_MODAL);
	var result = new Array();
	if (allt(String(obj.ret.ffile)) != "")
		result = String(obj.ret.ffile).split(",");
	ExecuteSQL("DROP TABLE " + tmpTbl);
	return result;
}


function DpRegistryImportCLB()
{
	this.fileName = "clbRegistryImp.xml";
	this.fullFileName = getOrgPath() + "clbank/" + this.fileName;
	this.files = new Array();
	this.xmlDoc = null;
	this.init = DpRegistryImportCLB_init;
	this.getInfo = DpRegistryImportCLB_getInfo;
	this.setInfo = DpRegistryImportCLB_setInfo;
	this.createXML = DpRegistryImportCLB_createXML;
	this.qryImport = DpRegistryImportCLB_qryImport;
	this.root = this.init();
}

function DpRegistryImportCLB_init()
{
	include ("objects/DpXMLDomDocument.js");
	if (!isFile(this.fullFileName))
		this.createXML();
	if (!isFile(this.fullFileName))
		return false;
	this.xmlDoc = new DpXMLDOMDocument();	 					
	this.xmlDoc.load(this.fullFileName);	
	return this.xmlDoc.getDocumentElement();
}

function DpRegistryImportCLB_getInfo(sFile)
{
	if (typeof sFile == "undefined")
		return "undefined";		
	if (typeof this.files[sFile] != "undefined")
		return this.files[sFile];
	if (this.root)
	{
		var element = this.root.getElementsByTagName(sFile)[0];
		if (element != null)
		{
			this.files[sFile] = new DpInfoRICLB(element);
			return this.files[sFile];
		}
		else
			return "empty";
	}
	return "undefined";		
}

function DpRegistryImportCLB_setInfo(dpInfo)
{
	if (typeof dpInfo == "undefined")
		return false;
	var node = this.root.getElementsByTagName(dpInfo.docName)[0];
	if (node == null)
	{
		node = this.xmlDoc.createElement(dpInfo.docName);
		this.root.appendChild(node);
	}
	if (dpInfo.PP != null)
	{
		var pp = node.getElementsByTagName("PP")[0];
		if (pp == null)
		{
			pp = this.xmlDoc.createElement("PP");
			node.appendChild(pp);		
		}
		var tmp = new Object();
		for (var i in dpInfo.PP)
			if (i != "type" && i != "init")
				tmp[i] = dpInfo.PP[i].value;
		loadObjToAttr(pp, tmp);
	}
	if (dpInfo.PV != null)
	{
		var pv = node.getElementsByTagName("PV")[0];
		if (pv == null)
		{
			pv = this.xmlDoc.createElement("PV");
			node.appendChild(pv);		
		}
		var tmp = new Object();
		for (var i in dpInfo.PV)
			if (i != "type" && i != "init")
				tmp[i] = dpInfo.PV[i].value;
		loadObjToAttr(pv, tmp);
	}
	this.xmlDoc.save(this.fullFileName);
	this.files[dpInfo.docName] = dpInfo;
}

function DpRegistryImportCLB_createXML()
{
	var document = new DpXMLDOMDocument();
	var mainElement = document.createElement("Registry");
	document.appendChild(mainElement);
	document.save(this.fullFileName);
	return true;
}

function DpRegistryImportCLB_qryImport(sFile, docType)
{
	var dpInfo = this.getInfo(sFile);
	if (dpInfo == "undefined" || dpInfo == "empty")
		return true;
	if (typeOf(docType).toLowerCase() != "string")
		docType = "PP,PV";
	docType = docType.split(",");
	var isImp = false;
	for (var i in docType)
		if (dpInfo[allt(docType[i])] != null)
			isImp = true;
	if (!isImp)
		return true;
			
	var strMsg = UR("Даний файл вже імпортувався!|Данный файл уже импортировался!");
	strMsg += "\nФайл: " + dpInfo.docName;	
	for (var i in docType)
	{			
		var sType = allt(docType[i]);
		if (dpInfo[sType] != null)
		{
			var tmp = new Array();
			tmp[0] = dpInfo[sType].type;
			tmp[1] = dpInfo[sType].impdate;
			tmp[2] = dpInfo[sType].recordcount;
			tmp[3] = dpInfo[sType].user;
			for (var i in tmp)
				strMsg += "\n  " + tmp[i].text + tmp[i].value;
			strMsg += "\n\n";		
		}
	}
	strMsg += UR("Імпортувати його?|Импортировать его?");
	return "y" == msgBox("yn", strMsg, UR("Увага!|Внимание!")); 
}

function DpInfoRICLB(node)
{
	this.docName = "";
	this.PP = null;
	this.PV = null;
	this.init = DpInfoRICLB_init;	
	this.init(node);
}

function DpInfoRICLB_init(node)
{
	if (typeof node == "undefined")
		return;
	this.docName = node.getNodeName();
	var element = node.getElementsByTagName("PP")[0];
	if (element != null)
		this.PP = new DpInfoDoc(element);
	element = node.getElementsByTagName("PV")[0];
	if (element != null)
		this.PV = new DpInfoDoc(element);		
}

function DpInfoDoc(node)
{
	this.type = new Object();
	this.type.text = "Тип документа: ";
	this.impdate = new Object();
	this.impdate.text = UR("Дата імпортуваня: |Дата импортирования: ");
	this.recordcount = new Object();
	this.recordcount.text = UR("Кількість записів: |Количество записей: ");
	this.user = new Object();
	this.user.text = UR("Користувач: |Пользователь: ");
	this.init = DpInfoDoc_init;
	this.init(node);
}

function DpInfoDoc_init(node)
{
	if (typeof node == "undefined")
		return;
	var tmp = loadAttrToObj(node);
	for (var i in tmp)
		if (typeof this[i] != "undefined")
			this[i].value = tmp[i];
	this.type.value = node.getNodeName();
}

function DpCLBcheckDupl(platDoc)
{
	if(!platDoc)
		return false;
	if(platDoc.getVar("HDAT") != null && platDoc.getVar("HNOM") != null && platDoc.getVar("HSUM") != null)
	{
		var sqlStr = "SELECT * from ^RAS_SCH"
			+ " WHERE FDOC_NUM = " + sqlTo(platDoc.getVar("HNOM"))
			+ " AND FDOC_DAT = " + sqlTo(platDoc.getVar("HDAT"))
			+ " AND FDOC = " + sqlTo(platDoc.getVar("HDOC"))
			+ " AND FFCR_SC = " + sqlTo(platDoc.getVar("HCRSC"))
			+ " AND FFDB_SC = " + sqlTo(platDoc.getVar("HDBSC"))
			+ " AND FSUM = " + sqlTo(platDoc.getVar("HSUM"))
			+ " AND FTOVAR = " + sqlTo(platDoc.getVar("HTOVAR"));
		var tdup = OpenTable("s", sqlStr);								
		if (tdup.recordCount > 0)
		{										
			var alertStr1 = UR(
			"ЗНАЙДЕНО " + tdup.recordCount + " ДОКУМЕНТІВ З ПАРАМЕТРАМИ:"
				+ "\n   НОМЕР: " + allt(platDoc.getVar("HNOM"))
				+ "\n   ДАТA: " + format("dd.mm.yyyy", tdup.getValue("FDOC_DAT"))
				+ "\n   СУМA: " + platDoc.getVar("HSUM")
				+ "\n   ВИД ДОКУМЕНТУ: " + platDoc.getVar("HDOC")
				+ "\n   ПРИЗНАЧЕННЯМ ПЛАТІЖНОГО ДОКУМЕНТУ: " + allt(platDoc.getVar("HTOVAR"))
			+ "|ОБНАРУЖЕНО " + tdup.recordCount + " ДОКУМЕНТ(ОВ) С ПАРАМЕТРАМИ:"
				+ "\n   НОМЕР: " + allt(platDoc.getVar("HNOM"))
				+ "\n   ДАТA: " + format("dd.mm.yyyy", tdup.getValue("FDOC_DAT"))
				+ "\n   СУММA: " + platDoc.getVar("HSUM")
				+ "\n   ТИП ДОКУМЕНТА: " + platDoc.getVar("HDOC")
				+ "\n   НАЗНАЧЕНИЕ ПЛАТЕЖА: " + platDoc.getVar("HTOVAR"));
			var alertStr2 = "\n\n" + UR("ДОКУМЕНТ З ІДКНТИЧНИМИ ПАРАМЕТРАМИ ВИ ІМПОРТУЄТЕ."
					+ "|ДОКУМЕНТ С ИДЕНТИЧНЫМИ ПАРАМЕТРАМИ ВЫ ИМПОРТИРУЕТЕ.");
			var alertStr3 = "\n\n"+UR("ІМПОРТУВАТИ ДОКУМЕНТ?|ИМПОРТИРОВАТЬ ДОКУМЕНТ?");
			var bAnswer = msgBox("yni",alertStr1+alertStr2+alertStr3,UR("Перевірка документів|Проверка документов"));
			if (bAnswer=="n")
			{
				tdup.close();
				return false;
			}
			if(bAnswer=="i")
				this.bIgnorDuplic = true;
		}
		tdup.close();
	}
	return true;
}

function DpCLBinitBVO()
{
	if(this.bvo)
	{
		if(confirm(ru("Создать (или связать с уже существующим) документ общей банковской выписки," +
						"\nкоторый будет контролировать дебетовую и кредитовую суммы платежей?",
					"Створити (або зв'язати з вже існуючим) документ загальної банківської виписки," +
						"\nякий буде контролювати дебетову та кредитову суми платежів?")))
		{
			//выбираем номер операции BVO
			var doc = "BVO";
			var oPar = new Object();
			oPar.ret = new Object();
			oPar.onlyDoc = doc;
			oPar.isZaval = true;
			oPar.ret.fnop = null;
			showWindow("l_doclst.js", SW_MODAL, oPar);
			if(oPar.escape)
				return false;
			var nop = oPar.ret.fnop;
			//выбираем документ
			var oPar = new Object();
			oPar.doc = doc;
			oPar.nop = nop;
            oPar.ret = new Object();
            oPar.ret.fwid = 0;
            showWindow("l_docekz.xml", SW_MODAL, oPar);
            if (!oPar.escape && oPar.ret.fwid!=0)
			{
				this.bvoID = oPar.ret.fwid;
				this.bvoDoc = new DpDoc(doc,nop);
				this.bvoDoc.loadByID(this.bvoID);
			}
			else
				return false;
		}
	}
	else
		this.bvoDoc = null;
}

function DpCLBsetPlatOrgAndBVO(platDoc)
{
	var HORG = platDoc.getVar("HORG");
	var HORG0 = Number(platDoc.getVar("HORG0")?platDoc.getVar("HORG0"):getPar("ORGNOM"));
	if (platDoc.getVar("HDOC") == "PP")
	{
		if(!HORG)
			HORG = getOrgNum(platDoc.getVar("HCTO"),platDoc.getVar("HMFOTO"),platDoc.getVar("HCRSC"));//(OKPO,MFO,RSCH)
		if(HORG)//также пытаемся определить название банка контрагента
		{
			var NAZV_BNK = getOrgBnkName(HORG,platDoc.getVar("HMFOTO"),platDoc.getVar("HCRSC"),platDoc.getVar("HVAL"));
			if(allt(NAZV_BNK)!="")
				platDoc.setVar("HBNKTO", NAZV_BNK);
		}
		if(HORG0)//пытаемся определить название нашего банка
		{
			var NAZV_BNK0 = getOrgBnkName(HORG0,platDoc.getVar("HMFOOT"),platDoc.getVar("HDBSC"),platDoc.getVar("HVAL"));
			if(allt(NAZV_BNK0)!="")
				platDoc.setVar("HBNKOT", NAZV_BNK0);
		}
		this.impRecCount.PP++;
		if(this.bvoDoc && this.isValid)//накапливаем кредитовую сумму и сумму НДС
		{
			this.bvoDoc.setVar("HSUM_CR",this.bvoDoc.getVar("HSUM_CR")+platDoc.getVar("HSUM"));
			this.bvoDoc.setVar("HNDS_CR",this.bvoDoc.getVar("HNDS_CR")+platDoc.getVar("HNDS"));
		}
	}
	else
	{
		if(!HORG)
			HORG = getOrgNum(platDoc.getVar("HCOT"),platDoc.getVar("HMFOOT"),platDoc.getVar("HDBSC"));
		if(HORG)//также пытаемся определить название банка
		{
			var NAZV_BNK = getOrgBnkName(HORG,platDoc.getVar("HMFOOT"),platDoc.getVar("HDBSC"),platDoc.getVar("HVAL"));
			if(allt(NAZV_BNK)!="")
				platDoc.setVar("HBNKOT", NAZV_BNK);
		}
		if(HORG0)//пытаемся определить название нашего банка
		{
			var NAZV_BNK0 = getOrgBnkName(HORG0,platDoc.getVar("HMFOTO"),platDoc.getVar("HCRSC"),platDoc.getVar("HVAL"));
			if(allt(NAZV_BNK0)!="")
				platDoc.setVar("HBNKTO", NAZV_BNK0);
		}
		this.impRecCount.PV++;
		if(this.bvoDoc && this.isValid)//накапливаем дебетовую сумму и сумму НДС
		{
			this.bvoDoc.setVar("HSUM_DB",this.bvoDoc.getVar("HSUM_DB")+platDoc.getVar("HSUM"));
			this.bvoDoc.setVar("HNDS_DB",this.bvoDoc.getVar("HNDS_DB")+platDoc.getVar("HNDS"));
		}
	}
	if(this.bvoDoc && this.bvoID)//проставляем идентификатор общей банковской выписки
		platDoc.setVar("HID_BV", this.bvoID);
	if (HORG == null)
		HORG = 0;
	platDoc.setVar("HORG", HORG);
}

//парсит выражение, которое мы получаем из xml настройки банка и возвращает текст, 
//после которого в строке файла импорта содержится значение переменной документа
//текст хранится внутри скобок !{}, если скобки не указаны, значит выражение является искомым текстом, 
//решено было использовать символ ! перед фигурными скобками, т.к. в выражении 
//может присутствовать описание какой-либо функции и дальнейший ее вызов через ;
function getTxtSrchFromExpr(expr)
{
	var fstInd = expr.indexOf("!{");
	if(fstInd==-1)
		var ret = expr;
	else
	{
		//если в выражении несколько переменных, тогда возвращаем массив
		if(fstInd == expr.lastIndexOf("!{"))
		{
			var ret = expr.substr(fstInd+2);
			var lstInd = ret.indexOf("}");
			ret = ret.substr(0,lstInd);
		}
		else
		{
			var ret = new Array();
			var buf = expr;
			while(fstInd>-1)
			{
				buf = buf.substr(fstInd+2);
				var lstInd = buf.indexOf("}");
				ret[ret.length] = buf.substr(0,lstInd);
				buf = buf.substr(lstInd+1);
				fstInd = buf.indexOf("!{");
			}
		}
	}
	return ret;
}

//обрабатывает выражение expr с помощью ф-ии eval()
//в зависимости от режима mode:
//		"VAR" -  заменяет в выражении подстроку !{...} на val
//		"DOC_SPLIT" - заменяет в выражении все подстроки !{...} на соответствующие элементы массива val
function evalExprTxt(expr,val,mode)
{
	if(!mode)
		mode = "VAR";
	var fstInd = expr.indexOf("!{");
	var lstInd = -1;
	var ret = "";
	var repl = "";
	if(fstInd==-1)
	{
		switch(mode)
		{
			case "VAR":
				ret = val;
				trace(">>> not eval "+val+" from "+expr);
			break;
			case "DOC_SPLIT":
			case "DOC_IND":
				ret = expr;
				trace(">>> not eval "+expr)
			break;
		}
	}
	else
	{
		switch(mode)
		{
			case "VAR":
				if(val == null)
					val = "";
				if(typeOf(val).toLowerCase()=="string")
				{
					ret = expr.substr(fstInd);
					lstInd = ret.indexOf("}");
					repl = ret.substr(0,lstInd+1);//текст, который будем заменять на val
					var evalStr = expr.replace(repl,"val");
					trace("evalStr >> "+evalStr)
					ret = eval(evalStr);
					trace("eval result >> "+ret)
				}
				else//если массив
				{
					var evalStr = expr;
					for(var i in val)
					{
						while(evalStr.indexOf("!{"+i+"}")!=-1)
							evalStr = evalStr.replace("!{"+i+"}","val['"+i+"']");
					}
					trace("evalStr >> "+evalStr)
					ret = eval(evalStr);
					trace("eval result>> "+ret)
				}
			break;
			case "DOC_SPLIT":
				while(fstInd>-1)
				{
					ret = expr.substr(fstInd);
					lstInd = ret.indexOf("}");
					repl = ret.substr(0,lstInd+1);//текст, который будем заменять на val[i]
					var i = Number(repl.substring(2,repl.length-1));
					if(i>=0)
					{
						expr = expr.replace(repl,"val["+i+"]");
						fstInd = expr.indexOf("!{");
					}
					else
					{
						trace(">> Invalid array index value: "+i);
						return null;
					}
				}
				trace("expr >> "+expr);
				ret = eval(expr);
				trace("eval >> "+ret);
			break;
			case "DOC_IND":
				while(fstInd>-1)
				{
					ret = expr.substr(fstInd);
					lstInd = ret.indexOf("}");
					repl = ret.substr(0,lstInd+1);//текст, который будем заменять на val[repl]
					expr = expr.replace(repl,"val[repl]");
					fstInd = expr.indexOf("!{");
				}
				trace("expr >> "+expr);
				ret = eval(expr);
				trace("eval >> "+ret);
			break;
		}
	}
	return ret;
}

//возвращает хвост текста после указаной подстроки
function getTxtTail(str,substr)
{
	if(!str || str.length==0)
		return null;
	if(!substr)
		return str[0];
	if(typeOf(substr).toLowerCase()=="string")
	{
		var fstInd = str[0].indexOf(substr);
		if(fstInd==-1)
			return str[0];
		var lng = substr.length;
		return str[0].substr(fstInd+lng);
	}
	else//если массив
	{
		var ret = new Array();
		for(var i=0; i<substr.length; i++)
		{
			var sLine = str.filter(function(item){return strIn(substr[i],item);});
			if(sLine && sLine.length>0)
			{
				var fstInd = sLine[0].indexOf(substr[i]);
				if(fstInd==-1)
				{
					ret[substr[i]]="";
					continue;
				}
			}
			else
			{
				ret[substr[i]]="";
				continue;
				//return null;
			}
			var lng = substr[i].length;
			ret[substr[i]]=sLine[0].substr(fstInd+lng);
		}
		return ret;
	}
}

//проверяет состоит ли выражение из одной переменной
function isOnlyOneVar(expr)
{
	for(var i=0; i<expr.length; i++)
	{
		if(expr[i]!="!" && expr[i]!="{" && expr[i]!= "}" && !isDigit(expr[i]))
			return false;
	}
	return true;
}

//сканирует все диапазоны встречающиеся в строке выражений и по ним парсит строчку в массив
function rangeSplitStr(str,strExpr)
{
	var ret = new Array();
	var fstInd = strExpr.indexOf("!{");
	var j=0;
	while(fstInd>-1)
	{
		strExpr = strExpr.substr(fstInd);
		lstInd = strExpr.indexOf("}");
		repl = strExpr.substr(0,lstInd+1);//вырезаем !{i-j}
		strExpr = strExpr.substr(lstInd+1);
		fstInd = strExpr.indexOf("!{");
		if(ret[repl]!=null)
			continue;
		var ind = repl.substring(2,repl.length-1).split("-");//получаем массив индексов
		if(ind.length==1)
			ret[repl]=str.charAt(ind[0]-1);
		else
			ret[repl]=str.substring(ind[0]-1,ind[1]);	
	}
	return ret;
}

//вырезает спецсимволы новой строки и возврата коретки
function replaceSpecSymbol(sTxt)
{
	if(sTxt==null)
		return "";
	var str = new java.lang.String(sTxt);
	str = str.replaceAll("\n", " ");
	str = str.replaceAll("\r", " ");
	return str;
}