include("objects\\DpCalculations.js")

DpCalcDecoder.prototype.run = DpCalcDecoder_run;

function DpCalcDecoder()
{
}

function DpCalcDecoder_run()
{
	var tbl = OpenTable("s","SELECT "
					 + "FDOC, FCALC, FNOM, FIF, FTXT, FVAR, FVALUE,"
					 + "FWEIGHT, FFILT, FDECIMAL, FACT"
					 + " FROM ^cl_calc"
					 + " ORDER BY FDOC,FCALC,FNOM");
	var prevDoc = "";
	var calcs = null;
	
	for (tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
	{
		var sDocLbl = String(tbl.getValue("FDOC")).toUpperCase();
		if (prevDoc != sDocLbl)
		{
			if (calcs != null)
				calcs.commitChanges();
			calcs = new DpCalculations(sDocLbl);
		}
		
		var nNum = parseInt(tbl.getValue("FCALC"));
		var nCalcNum = parseInt(tbl.getValue("FNOM"));
		var sComment = String(tbl.getValue("FTXT"));
		var sCondition = String((tbl.getValue("FIF")?tbl.getValue("FIF"):""));
		
		if (isNaN(nNum))
			continue;
		if (nCalcNum == 0)
		{
			calcs.addGroup(nNum,sComment,allt(sCondition));
			trace("ADD GRP " + calcs.sClassID + " - " + nNum);
			continue;
		}
		
		var sVAR = tbl.getValue("FVAR");
		var sVALUE = tbl.getValue("FVALUE");
		var sPROPORTION = tbl.getValue("FWEIGHT");
		var sFILTER = tbl.getValue("FFILT");
		var nSIGN = tbl.getValue("FDECIMAL");
		var sACT = tbl.getValue("FACT");
		
		if (!sVAR)
			continue;
		sVAR = String(sVAR);
		sVALUE = String(sVALUE);
		sPROPORTION = (sPROPORTION?String(sPROPORTION):"");
		sFILTER = (sFILTER?String(sFILTER):"");
		nSIGN = (isNaN(parseInt(nSIGN))?2:parseInt(nSIGN));
		sACT = String(sACT);
		
		var dpCalc = new DpCalculation();
		dpCalc.nNum = nCalcNum;
		dpCalc.sComment = sComment;
		dpCalc.sCondition = sCondition;
		dpCalc.sVAR = sVAR;
		dpCalc.sVALUE = sVALUE;
		dpCalc.sPROPORTION = sPROPORTION;
		dpCalc.sFILTER = sFILTER;
		dpCalc.nSIGN = nSIGN;
		dpCalc.sACT = sACT;
		
		var clcGroup = calcs.listGroups()[nNum];
		
		if (clcGroup == null)
		{
			calcs.addGroup(nNum, "", "");
			clcGroup = calcs.listGroups()[nNum];
		}
		
		if (clcGroup.calculations == null)
			clcGroup.calculations = new Array();
		clcGroup.calculations[nCalcNum] = dpCalc;
		
		prevDoc = sDocLbl;
	}
	
	tbl.close();
	if (calcs != null)
		calcs.commitChanges();
}