/*
   Описание объекта "элемент справочника аналитики": DpCl
   (C) ДЕБЕТ Плюс, 1998-1999

   Конструктор DpCl.
      Варианты вызова:
         DpCl(<режим>)
         DpCl(<код справочника>, <код аналитики>)
         DpCl(<режим>, <код справочника>, <код аналитики>)
         DpCl("U", <код подсправочника>, <код аналитики>, <функция getVarsEval>, <переменная>)
			Данний конструктор специально для завала в подсправочник,
			определенный кодом и значением переменной
		 DpCl("U", <код подсправочника>, <код аналитики>, <объект DpCl надсправочника>)
      Возвращает this

   Внешние методы:
   .setMode(mode)    - установить режим
	  mode = ""  - (по-умолчанию) не допустим нулевой код
      mode = "0" - допустим нулевой код
      mode = "0!" - при нулевом коде вернуть "По всем"
      mode = "N" - не допустим нулевой справочник (например, в проводках)
      mode = "U" - подсправочник + при нулевом коде вернуть "По всем"
      mode = "U0" - подсправочник + допустим нулевой код
      mode = "U0-" - подсправочник + не допустим нулевой код
      mode = "C" - в ComboBox выводить код и текстовку разделенные двоеточием
                   Имеется ввиду общий справочник организаций.
      mode = "P" - для отображения справочника который является подсправочником с отображением родителя, даже если папа не задан

   .getMode          - получить режим
   .setClcl(clclCod) - установить код справочника
   .getClcl()        - получить код справочника
   .setCod(cod)      - Установить код элемента справочника
   .getCod()         - Получить код элемента справочника
   .zSetCod(cod)     - Установить код элемента справочника с завалом
   .getIsTCod()      - Определить, редактируется метка или код аналитики
   .getTCod()        - Получить метку аналитики
   .valid()          - Проверка правильности инициализации объект
   .zValid()         - Проверка правильности инициализации c завалом
   .getFWID()        - Получить fwid текущего элемента 
   .getTxt()         - Получить текст элемента справочника аналитики
   .get(field)		 - Получить параметры справочника
   .get2(field)      - Получить параметры справочника вида 2
   .get3(field)      - Получить параметры справочника вида 3
   .linkCtrl()       - Связать с полем ввода
   .linkCtrl2(fld, ctrl)
                     - Связать указанное поле таблицы с полем вывода
                       Параметро fld может принимать след. значения:
                  "ftxt"  - текстовка аналитики,
                  Поле из таблицы CL_POST, если вид справочника 2
   .setValid(obj, method) - Установить дополнительну проверку на код 
                       аналитики.
   Внутренние методы:
   .updateCtrl()     - Обновить связанные поля ввода

   Внутренние свойства:
   .clclCod   - код справочника
      Используется только в методах setClcl и getClcl.
      В остальных случаях пользуйтесь этими методами.
   .cod       - код элемента справочника
      Используется только в методах setCod и getCod.
      В остальных случаях пользуйтесь этими методами.
   .isValid   - флаг, правильно ли установлен код
      Используется в методах:
         setCod - устанавливается в зависимости от правильности кода.
         valid - для получени
   .ftxt      - текстовка аналитики
   .ftxts     - текстовка аналитики сокр.
       Используется в методах:
         setCod - устанавливается в зависимости от кода
         getTxt - для получени
   .ctrlCod   - связанное поле ввода кода аналитики
   .ctrl      - объект-контейнер связанных полей ввода
   .tblClPost - recordset из одной записи, в которой хранится
      связанная информация по справочнику 2-го вида.
      Устанавливается и используется методом .get2();
      Обнуляется методом setCod();
*/
include("Objects/DpPluginObject.js")
include("Objects/DpExtentionBuilder.js");
include("Objects/DpDocumentDecoder.js");
include("Objects/DpClEx.js");

DpCl.prototype.setMode = DpCl_setMode;
DpCl.prototype.getMode = DpCl_getMode;
DpCl.prototype.setClcl = DpCl_setClcl;
DpCl.prototype.getClcl = DpCl_getClcl;
DpCl.prototype.setCod = DpCl_setCod;
DpCl.prototype.getCod = DpCl_getCod;
DpCl.prototype.getTCod = DpCl_getTCod;
DpCl.prototype.getIsTCod = DpCl_getIsTCod;
DpCl.prototype.zSetCod = DpCl_zSetCod;
DpCl.prototype.valid = DpCl_valid;
DpCl.prototype.zValid = DpCl_zValid;
DpCl.prototype.zaval = DpCl_zaval;
DpCl.prototype.getTxt = DpCl_getTxt;
DpCl.prototype.getTxts = DpCl_getTxts;
DpCl.prototype.setFWID = DpCl_setFWID;
DpCl.prototype.getFWID = DpCl_getFWID;
DpCl.prototype.getExt = DpCl_getExt;
DpCl.prototype.get = DpCl_get;
DpCl.prototype.open = DpCl_open;
DpCl.prototype.get2 = DpCl_get2;
DpCl.prototype.get3 = DpCl_get3;
DpCl.prototype.getRegis = DpCl_getRegis;
DpCl.prototype.linkCtrl = DpCl_linkCtrl;
DpCl.prototype.linkCombo = DpCl_linkCombo;
DpCl.prototype.linkCtrlTxt = DpCl_linkCtrlTxt;
DpCl.prototype.linkCtrl2 = DpCl_linkCtrl2;
DpCl.prototype.linkSmartCtrl = DpCl_linkSmartCtrl;
DpCl.prototype.linkExtCtrl = DpCl_linkExtCtrl;
DpCl.prototype.fillSmartAssist = DpCl_fillSmartAssist;
DpCl.prototype.smartSelected = DpCl_smartSelected
DpCl.prototype.blurSmartCtrl = DpCl_blurSmartCtrl;
DpCl.prototype.getSmartTable = DpCl_getSmartTable;
DpCl.prototype.updateCtrl = DpCl_updateCtrl;
DpCl.prototype.validCtrl = DpCl_validCtrl;
DpCl.prototype.validCombo = DpCl_validCombo;
DpCl.prototype.setValid = DpCl_setValid;
DpCl.prototype.setRelFunc = DpCl_setRelFunc;
DpCl.prototype.setVar    = DpCl_setVar;
DpCl.prototype.setCl    = DpCl_setCl;
DpCl.prototype._resetCtrl = DpCl__resetCtrl;
DpCl.prototype.enableUnderCtrl = DpCl_enableUnderCtrl;
DpCl.prototype.setContAssist = DpCl_setContAssist;
DpCl.prototype.addCondition = DpCl_addCondition;
DpCl.prototype.removeCondition = DpCl_removeCondition;
DpCl.prototype.addListCondition = DpCl_addListCondition;
DpCl.prototype.removeListCondition = DpCl_removeListCondition;
DpCl.prototype.validMark = DpCl_validMark;
DpCl.prototype.getSingleCod = DpCl_getSingleCod;
DpCl.prototype.getClTxt = DpCl_getClTxt;
DpCl.prototype.setCtrlLinker = DpCl_setCtrlLinker;
DpCl.prototype.getCtrlLinker = DpCl_getCtrlLinker;
DpCl.prototype.__defineGetter__("value", DpCl_setCod);
DpCl.prototype.__defineSetter__("value", DpCl_getCod);
DpCl.prototype.setDefCod = DpCl_setDefCod;
DpCl.prototype.getDefCod = DpCl_getDefCod;
DpCl.prototype.chkAcc = DpCl_chkAcc;
DpCl.prototype.add = DpCl_add;
DpCl.prototype.addFldSearchSmart = DpCl_addFldSearchSmart;//добавляет в массив поле для поиска в режиме ввода с клавиатуры в смарт контроле помимо кода и текстовки
DpCl.prototype.getFldSearchSmart = DpCl_getFldSearchSmart;//возвращает массив полей для поиска в режиме ввода с клавиатуры в смарт контроле
DpCl.prototype.getFldValue = DpCl_getFldValue;//возвращает значение любого поля
DpCl.prototype.setFldReplaceCodSmart = DpCl_setFldReplaceCodSmart;//устанавливает поле которое будет заменять код в текстовке смарт контрола
DpCl.prototype.getFldReplaceCodSmart = DpCl_getFldReplaceCodSmart;//возвращает поле которое будет заменять код в текстовке смарт контрола

// Конструктор объекта DpCl
function DpCl()
{
//	RO("DpCl", this);
	this.zavalTask = "l_cl.xml";
	this.isContAssist = false;		
	this.setMode("");  // По-умолчанию режим пустой
	this.setClcl(-1);
	this.cond = new Array();	
	this.ctrl = new Object();
	this.listCond = null;
	this.singleCod = 0;
	this.defCod = 0; //код, который предлагается по умолчанию при добавлении
	this.clTxt = null;
	this.ctrlLinker = null;
   	this.CanSelectGroup	= true;
   	this.fldReplaceCodSmart = null;//поле, которое будем выводить в смарт контрол вместо обычного кода записи
   	this.fldSearchSmart = new Array();//массив дополнительных полей по которым следует искать записи в смарт контроле (поля должны быть только текстовые)
   	this.isExactSearchSmart = false; //искать только точное совпадение со значением из смарт контрола
   	this.isStartSearchSmart = false; //искать с начала слова
   	this.isCodeSearchSmart = true;	//искать по коду
   	
   // Разбор аргументов
   var args = DpCl.arguments;
   
   switch(args.length)
   {
      case 0:
         break;
      case 1:  // DpCl(<режим>)
         this.setMode(args[0]);
         break;
      case 2:  // DpCl(<код справочника>, <код аналитики>)
         this.setClcl(args[0]);
         this.setCod(args[1]);
         break;
      case 3:  // DpCl(<режим>, <код справочника>, <код аналитики>)
         this.setMode(args[0]);
         this.setClcl(args[1]);
         this.setCod(args[2]);
         break;
      case 4:
		 this.setMode(args[0]);
         
		 //fruckt
		 //сначала укажем справочник-папу
		 if (typeof(args[3]) == "object")
		 	this.setCl(args[3]);
		 else
			debug("Неверный четвертый аргумент");
			
         this.setClcl(args[1]);
         this.setCod(args[2]);
         break;
      case 5: // DpCl("U", <код подсправочника>, <код аналитики>, <функция getVarsEval>, <переменная>)
         this.setRelFunc(args[3]);
         this.setVar(args[4]);
         this.setMode(args[0]);
         this.setClcl(args[1]);
         this.setCod(args[2]);		 
		 break;
      default:
         alert("Ошибочное число аргументов DpCl: " + args.length);
   }
   
   return this;
}

// Установить режим
function DpCl_setMode(mode)
{
   if (mode.toUpperCase().indexOf("U") != -1)
   {
	  if (mode.toUpperCase().indexOf("0-") != -1)
		mode = "";
	  else if (mode.toUpperCase().indexOf("0") != -1)
		mode = "0";
	  else 
		mode = "0!"	
      this.isUnderCl = true;
   }
   else
      this.isUnderCl = false;
   this.mode = mode;
   
   this.isGroup = (mode.toUpperCase().indexOf("G") != -1)
   
   if(typeof this.getCod()!="undefined")
		this.setCod(this.getCod());

	if (this.mode.indexOf("0") != -1 && this.singleCod)
	{
		this.singleCod = 0;
		this.setCod(0);
	}		
}

function DpCl_open()
{
	var nCod = this.getCod();
	if (nCod <= 0 )
		return;
	
	var sCL = this.vid;
	if (!isNaN(sCL))
	{
		sCL = "CL" + Number(sCL);
	}
	var oCl = new DpClEx(sCL, this.clclCod);
	var t = OpenTable("m", "select * from ^cl c, ^clrelclcl r where c.fwid = r.fwid_cl and r.fcl = " + this.clclCod + " and fcod = " + nCod)
	var nID = Number(t.getValue("FWID"));
	t.close();
	oCl.edit("EDIT",nID, new Object());	
}

// Получить режим
function DpCl_getMode(submode)
{
   if(submode==null)
      return this.mode;
   else
      return (this.mode.indexOf(submode)!=-1)? submode: "";
}

// Установить код справочника
function DpCl_setClcl(clclCod)
{
	clclCod = Number(clclCod);
	
	if(isNaN(clclCod)) clclCod = 0;
	
	if(clclCod==-1)
	{}
	else if(clclCod==0)
	{
		// Если устанавливается нулевой справочник и он не допустим
		// тогда устанавлваем пустой справочник.
		//if(this.getMode("N"))
		//	clclCod = -1;
		//if(!this.getMode("0"))
		//	this.mode += "0";
		this.isTCod = false;
		this.vid = 2;
		this.clTxt = UR("Повний довідник|Полный справочник");
	}
	else
	{
		tblClcl = OpenTable("s", 
			"SELECT *"
			+ " FROM ^clcl"
			+ " WHERE FCOD = " + sqlTo(clclCod)
			);

		if(!tblClcl.isEmpty())
		{
			this.isTCod = toScrObj(tblClcl.getValue("fistcod")) == true//"true";
			this.vid = String(tblClcl.getValue("fvid"));
			this.clTxt = String(tblClcl.getValue("FTXT"));
		}
		else
		{
			alert("Справочник № " + clclCod + " не существует"
				, "Ошибка в данных");
			clclCod = -1;
		}
		tblClcl.close();
		tblClcl = null;
	}
	
   this.clclCod = clclCod;
	this._resetCtrl();
	
	//fruckt
	//установка кода в режиме подсправочника не особо удачна
	if (!this.IsSuperCl)
		this.setCod(this.getSingleCod());

	if (this.isTCod)
	{
		this.setFldReplaceCodSmart("FTCOD")
	}
	return true;
}

// Получить код справочника
function DpCl_getClcl()
{
   return this.clclCod;
}

// Установить код элемента справочника
function DpCl_setCod(cod, isTCod)
{
	
	if (this.singleCod != 0 && this.singleCod == this.cod)
	{
		this.updateCtrl();
		return;
	}
	if(typeof(cod)=="undefined")
		cod = 0;
	//	debug("Попытка установить код аналитики в undefined");
	cod = Number(cod);
	this.isValid = true;
	this.errMsg = "";
	
	if(!cod)  // Если передан нулевой код аналитики
	{
		//trace("1 - DpCl_setCod " + this.getClcl()); 
		if(this.getClcl()!=-1)
		{
			//trace("2 - DpCl_setCod " + this.getMode("0"));
			if(this.getMode("0"))  // допустим ноль
			{
				this.fwid = null;
				if(this.getMode("!"))
					this.ftxt = UR("Для всіх|Для всех");
				else
				{
					if(this.getMode("E"))
					{
						for(i in this.ctrl)
						{	
							if("object" == typeof(this.ctrl[i]))
								Enable(this.ctrl[i]);
						}
					}
					this.ftxt = "";
				}
					
				this.cod = 0;
				this.ftcod = "";
			}
			else
			{
				this.isValid = false;
				this.cod = 0;
				this.errMsg = "Пустое значение недопустимо";
			}
		}
		else
		{
			this.cod = 0
			this.fcod = "";
		}
	}
	else  // передан не нулевой код аналитики
	{
		this.cod = cod;
		
		for(i in this.ctrl)
		{	
			if("object" == typeof this.ctrl[i])
			{
				if (i != "ftxt" || !this.isContAssist)
				Disable(this.ctrl[i]);
			}
		}
//		if("object" == typeof this.ctrl["ftxt"])
//			Disable(this.ctrl["ftxt"]);
			
		if(this.isUnderCl || this.IsSuperCl || isTCod)
		{
			// Запрос выполняется медленнее (раза в 3), чем
			// Seek'и. Но из-за плохой структуры справочников
			// аналитики Seek'ами нельзя достать аналитики из
			// подсправочников, поэтому это делаем запросом
			var cCond = "";
			cCond = (isTCod? "cl.ftcod=": "rel.fcod=") + sqlTo(cod);
			
			this.isValid = true;
			
			if(this.isUnderCl || this.IsSuperCl)
			{
				var nCod1;
				if (this.IsSuperCl)
					nCod1 = this.superCl.getCod();
				else	
				{
					var ev = this.getVarEval();
					nCod1 = ev.eval(this.varExpr);
				}
				if(typeOf(nCod1) != "number")
				{
					alert("Выражение, заданное в расширении подсправочника"
						+ "\nвозвращает недопустимое значение"
						+ "\n" + this.varExpr + "=" + sqlTo(nCod1));
					this.isValid = false;
					
				}
			}
	
			if(this.isValid || this.IsSuperCl)
			{
				if(this.isUnderCl || this.IsSuperCl)
					cCond += " and cl.fcod1 = " + sqlTo(nCod1);
				
				var subCond = (this.listCond!=null? this.listCond() : "");
				if(subCond!=null && subCond!="")
					cCond += " and "+ subCond;
					
				var tbl = OpenTable("s",
					"SELECT "
						//+ " fcod AS fclcl,"
						//+ " fcod1 AS fclcl1,"
						+ " fcod, fcod1,"
						+ " ftcod, ftxt, ftxts,"
						+ " fwid,"
						+ " fcl,"
						+ " fisgrp,fleftkey,frightkey"
					+ " FROM ^cl cl, ^clrelclcl rel"
					+ " WHERE " + cCond
						+ " and cl.fwid = rel.fwid_cl"
						+ " and rel.fcl = " + (this.vid==2? 0 : this.getClcl())
					);
			
				this.isValid = !tbl.isEmpty();
				if(this.isValid)
				{
					this.cod = Number(tbl.getValue("fcod"));
					this.fisgrp = toScrObj(tbl.getValue("fisgrp"));
					this.fleftkey = toScrObj(tbl.getValue("fleftkey"));
					this.frightkey = toScrObj(tbl.getValue("frightkey"));
				}
			}
		}
		else
		{
			var cCond = "";
			var subCond = (this.listCond!=null? this.listCond() : "");
			if(subCond!=null && subCond!="")
				cCond += " and "+ subCond;
			if(!this.CanSelectGroup)
				cCond += " and (FISGRP<>"+ sqlTrue +" or FISGRP IS NULL)" 
						
			var tblClrelclcl;
			
			strSQL = "SELECT * FROM ^clrelclcl as rel WHERE "
						+ " FCL = " +(this.vid==2? 0 : this.getClcl())
						+ " AND FCOD = " +sqlTo(this.getCod())
						+ cCond;			
			tblClrelclcl = OpenTable("s", strSQL);			
			this.isValid = !tblClrelclcl.isEmpty();
				
			if(0!=this.cond.length && this.isValid)
			{
				for(i = 0; i<this.cond.length; i++)
					if(!eval(this.cond[i] + "(" + this.getCod() + ")"))
					{
						this.isValid = false;
						break;
					}
			}
			
			if(this.isValid)
			{
				var tblCl = OpenTable("s", 
					"SELECT *"
					+ " FROM ^cl"
					+ " WHERE fwid = " + sqlTo(tblClrelclcl.getValue("fwid_cl"))
					);
				
				this.isValid = !tblCl.isEmpty();
				var tbl = tblCl;
				this.cod = Number(tblClrelclcl.getValue("fcod"));
				this.fisgrp = toScrObj(tblClrelclcl.getValue("fisgrp"));
				this.fleftkey = toScrObj(tblClrelclcl.getValue("fleftkey"));
				this.frightkey = toScrObj(tblClrelclcl.getValue("frightkey"));
			}
			
			tblClrelclcl.close();
			tblClrelclcl = null;
		}
		if(this.isValid)
		{
			this.ftxt = tbl.getValue("ftxt");
			this.ftxts = tbl.getValue("ftxts");
			this.fwid = tbl.getValue("fwid");
			this.ftcod = tbl.getValue("ftcod");
			//vlad
			this.fcod1 = toScrObj(tbl.getValue("fcod1"));
			var tExtInTable = OpenTable(s = 
					"SELECT *"
					+ " FROM ^cl_ext"
					+ " WHERE (fclass='CL." + this.getClcl() + "'"
						+ (this.vid==2? " OR fclass='CL.0'": "")
						+ ") AND Fisprefix<>''"
					);
			for (; !tExtInTable.IsEOF(); tExtInTable.MoveNext())
			{
				var ext = this.getExt(tExtInTable.getValue("flabel"));
				if (String(tExtInTable.getValue("Fisprefix"))=="(")
					this.ftxt = ext + this.ftxt;
				else
					this.ftxt = this.ftxt + ext;
				
			}
			tExtInTable.close();
		}
	}
	
	this.tblClPost = null;
	this.tblClHomo = null;
	this.tblClPers = null;
	this.tblClHomoMod = null;

	if (this.isValid)
	{
		 
		 this.singleCod = this.getSingleCod();		 
	}
	else
	{
		this.ftxt = this.fwid = null;
	}

	this.updateCtrl();
		
	if (tbl)
	{
		tbl.close();
		tblCl = tbl = null;
	}
	
	return this.isValid;
}

function DpCl_getSingleCod()
{
	if (this.mode == "" && this.clclCod != -1)
	{
		var sql = "SELECT"
					+" COUNT(*), MIN(REL.FCOD) AS FCOD"
				+" FROM"
					+" ^CL C, ^CLRELCLCL REL" 
				+" WHERE C.FWID = REL.FWID_CL AND REL.FCL = " +  this.clclCod;
		
		//fruckt
		var subCond = (this.listCond != null ? this.listCond() : "");
		if (!isEmpty(subCond))
			sql += " AND "+ subCond;
		
		var oSnap = getSnap(sql);			
		if (oSnap[0] == 1)
		{
			this.singleCod = oSnap[1];
			
			//fruckt
			//в случае
			//this.singleCod = this.getSingleCod();
			//this.setCod(cod);
			//получаем дополнительные вызовы this.setCod а соответственно и this.updateCtrl
			//что влечет за собой частый вызов this.AfterUpdate
			//ремим
			//this.setCod(this.singleCod);
			
			return this.singleCod;
		}				
		else
			return 0;
	}
	else
	{
		return 0;
	}
}

// Получить код элемента справочника
function DpCl_getCod()
{
   	if (this.cod)
   		return this.cod;
   	else
   		return 0;
   
}

function DpCl_getIsTCod()
{
	return this.isTCod;
}

function DpCl_getTCod()
{
	return this.ftcod;
}

// Установить код элемента справочника с завалом
function DpCl_zSetCod(cod)
{
   var oldCod = this.getCod();
   this.setCod(cod);
   if(!this.zValid())
      this.setCod(oldCod);
   return this.valid();
}

// Получить описание элемента справочника аналитики
function DpCl_getTxt()
{
   if(!this.ftxt) this.ftxt = "???";
   return (this.valid()? String(this.ftxt): "???");
}

// Получить описание элемента справочника аналитики
function DpCl_getTxts()
{
   return (this.valid()? String(this.ftxts): "???");
}

// Правильно ли инициализирован объект
function DpCl_valid()
{
   return this.isValid;
}

// Проверка правильности инициализации c завалом
function DpCl_zValid()
{
	if(!this.valid())
	{
		var par = new Object();
		par.ret = new Object();
		par.Fcl = par.ret.Fcl = this.getClcl();
		par.ret.Fcod = this.getCod();
		if (this.mode.indexOf("P") != -1)
		{
			strSQL = "SELECT FREL FROM ^CLCL WHERE FCOD = " + sqlTo(par.Fcl);
			var sn = getSnap(strSQL);
			if (sn != null && sn[0] != null && sn[0] != 0)
			{
				par.Fcl1 = sn[0];
				par.Fcod1 = 0;
				if (par.Fcod == 0)
				{
					var sn1 = getSnap("SELECT MIN(FCOD) FROM ^CLRELCLCL WHERE FCL = "+sqlTo(sn[0]));
					if (sn1 != null && sn1[0] != null)
					{
						par.Fcod1 = sn1[0];
					}
					sn1 = null;
				}
				else
				{
					strSQL = "SELECT CL.FCOD1 FROM ^CLRELCLCL REL INNER JOIN ^CL CL "
							+" ON REL.FWID_CL = CL.FWID "
							+" WHERE REL.FCL = " + sqlTo(par.Fcl)
							+" AND REL.FCOD = " + sqlTo(par.Fcod);
					var sn1 = getSnap(strSQL);
					if (sn1 != null && sn1[0] != null)
					{
						par.Fcod1 = sn1[0];
					}
					sn1 = null;
				}
			}
			sn = null;
			par.loadPar = true;
			par.zavalCl = par.Fcl;// чтобы завал был только если мы в нужном справочнике
		}
		if (this.isUnderCl || this.IsSuperCl)
		{
			if (this.IsSuperCl)
				par.Fcod1 = this.superCl.getCod();
			else	
			{
				var ev = this.getVarEval();
				par.Fcod1 = ev.eval(this.varExpr);
			}
			if(!par.Fcod1)
			{
				WAIT("Не указан элемент основного справочника")
				this.setCod(0);
				return this.valid();
			}
		}
		//для возможности навесить дополнительные параметры на par
		if (typeof(this.beforeZaval) == "function")
		{
			this.beforeZaval(par);
		}
//-		showWindow("l_cl.js",SW_MODAL,par,"");
		par.defCod = Number(this.defCod);
		showWindow(this.zavalTask,SW_MODAL,par);
			if(par.escape==false)  // Выбор был
			this.setCod(par.ret.Fcod);
	}
	return this.valid();
}

// Проверка правильности инициализации c завалом
function DpCl_zaval()
{
	var par = new Object();
	par.ret = new Object();
	par.Fcl = par.ret.Fcl = this.getClcl();
	par.Fcod = par.ret.Fcod = this.getCod();
	par.CanSelectGroup = this.CanSelectGroup;
	if(null != this.listCond)
		par.listCond = this.listCond;
	if (this.mode.indexOf("P") != -1)
	{
		strSQL = "SELECT FREL FROM ^CLCL WHERE FCOD = " + sqlTo(par.Fcl);
		var sn = getSnap(strSQL);
		if (sn != null && sn[0] != null && sn[0] != 0)
		{
			par.Fcl1 = sn[0];
			par.Fcod1 = 0;
			if (par.Fcod == 0)
			{
				var sn1 = getSnap("SELECT MIN(FCOD) FROM ^CLRELCLCL WHERE FCL = "+sqlTo(sn[0]));
				if (sn1 != null && sn1[0] != null)
				{
					par.Fcod1 = sn1[0];
				}
				sn1 = null;
			}
			else
			{
				strSQL = "SELECT CL.FCOD1 FROM ^CLRELCLCL REL INNER JOIN ^CL CL "
						+" ON REL.FWID_CL = CL.FWID "
						+" WHERE REL.FCL = " + sqlTo(par.Fcl)
						+" AND REL.FCOD = " + sqlTo(par.Fcod);
				var sn1 = getSnap(strSQL);
				if (sn1 != null && sn1[0] != null)
				{
					par.Fcod1 = sn1[0];
				}
				sn1 = null;
			}
		}
		sn = null;
		par.loadPar = true;
		par.zavalCl = par.Fcl;// чтобы завал был только если мы в нужном справочнике
	}
	/*
	for(i in this.ctrl)
		par.ret = this.ctrl[i].value;
		*/
	if(this.getIsTCod())
		par.Ftcod = par.ret.Ftcod = this.getTCod();
	if (this.isUnderCl || this.IsSuperCl)
	{
		if (this.IsSuperCl)
			par.Fcod1 = this.superCl.getCod();
		else	
		{
			var ev = this.getVarEval();
			par.Fcod1 = ev.eval(this.varExpr);
		}
		
		if(!par.Fcod1)
		{
			WAIT("Не указан элемент основного справочника")
			this.setCod(0);
			return;
		}
//		par.Fcod1 = this.Fcod1;
	}
//-	showWindow("l_cl.js",SW_MODAL,par,"");
	
	if (this.isGroup)
		par.isGroup = true;
	//для возможности навесить дополнительные параметры на par
	if (typeof(this.beforeZaval) == "function")
	{
		this.beforeZaval(par);
	}
	par.defCod = Number(this.defCod);
	showWindow(this.zavalTask,SW_MODAL,par);
	if(par.escape==false)  // Выбор был
	{
		//if(Number(par.ret.Fcl)!=Number(this.getClcl()) && Number(this.vid)==2)
		//	this.setClcl(0);
		this.singleCod = this.getSingleCod();
		this.setCod(par.ret.Fcod);
		//if(this.ctrlCod);
		//runValid(this.ctrlCod);
	}
	
   // думаю, что будет полезно что-то иметь возможность сделать после выбора
   // элемента из справочника
	if (typeof this.AfterLoad == "function")
		this.AfterLoad();
	return par;	
}

function DpCl_get(field)
{	
	field = String(field).toUpperCase();
	
	switch (field)
	{
		case "FTXT":
			return this.getTxt();
		break;
		case "FTXTS":
			return this.getTxts();
		break;
		case "FISGRP":
			return this.fisgrp;
		break;
		case "FLEFTKEY":
			return this.fleftkey;
		break;
		case "FRIGHTKEY":
			return this.frightkey;
		break;
		case "FCOD1":
			return this.fcod1;
		break;
	
		default:
		break;
	}
	
	switch(this.vid)
	{
	case 2:
		return this.get2(field);
		break;
		
	case 3:
		return this.get3(field);
		break;
		
	default:
		if("string" == typeOf(this.vid))
		{
			if (!this.fullFrom || !this.fullFrom[this.vid])
			{
				if (!this.fullFrom)
					this.fullFrom = new Array();
				if (!this.tblMaps)
					this.tblMaps = new Array();
				
				var oDec = new DpDocumentDecoder();
				var sClass = this.vid;
				
				if (!isNaN(parseInt(this.vid)))
					sClass = "CL" + parseInt(this.vid);
				else
					sClass = this.vid;
					
				var oClEx = new DpClEx(sClass,this.getClcl());
				//var tblMap = oDec.fillTableMap(oClEx.jObj.getDefaultMapper());
				var mapper = oClEx.jObj.getDefaultMapperXML();				
				var tblMap = oDec.fillTableMap(mapper.getDocumentElement());
				this.tblMaps[this.vid] = tblMap;
				this.fullFrom[this.vid] = oDec.parseFromForCL(tblMap);
			}
		
			var tblMap = this.tblMaps[this.vid];
			var fullFrom = this.fullFrom[this.vid];
			var sWhere = "^CL.FWID=" + sqlTo(this.fwid);
			var sField = field;
		
			var sSQL = "SELECT " + sField
							  + " FROM " + fullFrom
							  + " WHERE " + sWhere;
		
			
			//trace(sSQL);
			var oSnap = getSnap(sSQL, false);
			return (oSnap == null?null:oSnap[0]);
		}
		break;
	}
}

// Получить поле справочника вида 2
function DpCl_get2(field)
{
	if((field = field.toUpperCase())=="FTXT")
		return this.getTxt();
	if(!this.fwid) return null;
	
	this.tblClPost = getSnap(
		"select " + field 
		+ " from ^cl_post"
		+ " where fwid_cl = "+sqlTo(this.fwid)
		, false);
		
	if(!this.tblClPost) return null;
	
	if (!(field == "FCODCOUNTRY" || field == "FCODREGION" || field == "FCODAREA" || field == "FCODLOCATE"))
		return this.tblClPost[0];

	
	var tblCl

	//tblCl = OpenTable("sn", "SELECT * FROM ^cl WHERE fwid = " + sqlTo(tblCLRELCLCL("FWID_CL")));
		
	
	strSQL = "SELECT FTXT FROM ^clrelclcl r , ^cl c WHERE "
		+ " c.fwid = r.fwid_cl and r.FCL = " +sqlTo(getPar(field.substring(1, field.length)))
		+ " AND r.FCOD = " +sqlTo(this.tblClPost[0])
	tblCl = getSnap(strSQL);
	if (tblCl)
			return tblCl[0];	
			
	return "";		
	
}

// Получить поле справочника вида 3
function DpCl_get3(field)
{
	if((field = field.toUpperCase())=="FTXT")
		return this.getTxt();
	if (!this.fwid)
		return null;
	
	this.tblClHomo = getSnap(
			"SELECT "+ field
			+ " FROM ^cl_homo"
			+ " WHERE fwid_cl=" + sqlTo(this.fwid)
			, false);
	if(!this.tblClHomo)
	{
			trace(ru("У аналитики нет атрибутов физ. лица",
				"У аналітики немає атрибутів фіз. особи"));
	}

	if(this.tblClHomo && this.tblClHomo[0]!=null)
		return this.tblClHomo[0];
	else
	{
		this.tblClPers = getSnap(
				"SELECT "+ field
				+ " FROM ^persfile"
				+ " WHERE fwid_cl=" + sqlTo(this.fwid)
				, false);
		if(this.tblClPers && this.tblClPers[0]!=null)
			return this.tblClPers[0];
		else
			return null;
	}
}

// Получить поле справочника вида 6
function DpCl_get6(field)
{
	if(this.tblClHomoMod==null)
	{
		this.tblClHomoMod = getSnap(
			"SELECT "+ field
			+ " FROM ^cl_homo_mod"
			+ " WHERE fwid_cl=" + sqlTo(this.fwid)
			);
		if(this.tblClHomoMod==null)
			WAIT(ru("У аналитики нет атрибутов физ. лица",
				"У аналітики немає атрибутів фіз. особи"));
	}

	if(this.tblClHomoMod!=null)
		return this.tblClHomoMod[0];
	else
		return null;
}

/*
 * Свидетельства о регистрации юр.лиц можно заносить в отдельную таблицу, чтобы сохранить историю.
 * Вытащить номер свидетельства можно по дате.
 */
function DpCl_getRegis(date, type, fwid_cl)
{
	var regis = "";
	if(!fwid_cl)
		fwid_cl = this.fwid;
	if(!fwid_cl)
		return regis;
	if(date)
	{
		if(type)
			type = String(type).toUpperCase();
		var oSnap = getSnap("select FNUM from ^CL_ORGRC"
							+" where FWID_CL="+ sqlTo(fwid_cl)
								+" and FBDAT<="+ sqlTo(date)
								+" and FEDAT>="+ sqlTo(date)
								+(type? " and UPPER(FTYPE)="+ sqlTo(type) : "")
							, false
							);
		if(oSnap)
			regis = oSnap[0];
	}
	//Если нет записи в истории, тянем номер из карточки контрагента.
	if(!date || regis=="")
	{
		var oSnap = getSnap("select FREGIS from ^CL_POST"
							+" where FWID_CL="+ sqlTo(fwid_cl)
							, false
							);
		if(oSnap)
			regis = oSnap[0];
	}
	return regis;
}

// Связать с полем ввода
function DpCl_linkCtrl(ctrlCod, ctrlTxt)
{
	this.ctrlCod = ctrlCod;
	if(ctrlCod!=null)
	{
		this._resetCtrl();
		setValid(this.ctrlCod, this, "validCtrl");
		//if(this.ctrlCod.DpType == "DpGet")
		//{
			this.ctrlCod.setButton(true);
			this.ctrlCod.buttonHandler(this, "zaval");
			this.ctrlCod.addMenuItem("Просмотреть",this,"open")
		//}
		
		if (this.isUnderCl && this.superCl && this.superCl.ctrlCod)
		{
			setValid(this.superCl.ctrlCod, this, "enableUnderCtrl");
			this.superCl.underCtrl = this.ctrlCod;	//передаем текущий контрол в основной справочник, чтобы подсправочник открывался для завала без табуляции
		}
		this.enableUnderCtrl();		
		
	}

	if(ctrlTxt != null)
	{
		this.linkCtrl2("ftxt", ctrlTxt);
	}
	
	
	this.updateCtrl();
}

//связь с ComboBox
function DpCl_linkCombo(ctrlCombo)
{
	this.ctrlCombo = ctrlCombo;
	setValid(this.ctrlCombo,this,"validCombo");
	if(ctrlCombo!=null)
	{
		var tbl = OpenTable("SELECT fcod, ftxt, ftxts "
					+ " FROM ^cl cl, ^clrelclcl rel"
					+ " WHERE cl.fwid = rel.fwid_cl"
						+ " and rel.fcl = " + (this.vid==2? 0 : this.getClcl())
					+ " ORDER by Fcod");
		
		if(this.getMode("0"))
		{
			if(this.getMode("!"))
			{
				if(this.getMode("C"))
					this.ctrlCombo.addItem(0,"0:"+UR("<Для всiх>|<Для всех>"));
				else
					this.ctrlCombo.addItem(0,UR("<Для всiх>|<Для всех>"));
			}
			else
			{
				this.ctrlCombo.addItem(0,"");
			}
		}
		for(; !tbl.IsEOF(); tbl.MoveNext())
		{
			if(this.getMode("C"))
				this.ctrlCombo.addItem(tbl.getValue("Fcod"),tbl.getValue("Fcod")+":"+UR(String(tbl.getValue("Ftxt"))));
			else
				this.ctrlCombo.addItem(tbl.getValue("Fcod"),UR(String(tbl.getValue("Ftxt"))));
		}
		tbl.close();
	}
	this.updateCtrl();
}

function DpCl_validCombo()
{
	this.setCod(Number(this.ctrlCombo.value));
	//trace(">>"+this.value)
	return true;
}

//связь с полем расширения
function DpCl_linkExtCtrl(ext, ctrl)
{
	this.ctrlExt = ctrl;
	this.nameExt = ext;
	if(ctrl)
		Disable(ctrl);
	this.updateCtrl();
}

function DpCl_linkSmartCtrl(ctrlSmart)
{
	this.ctrlSmart = ctrlSmart;
	
	this.fillContAssist = DpCl_fillContAssist;
	this.ctrlSmart.setContentAssistHandler(this, 
				"fillSmartAssist", "smartSelected");
	setValid(this.ctrlSmart, this, "blurSmartCtrl");     
	setButton(this.ctrlSmart, this, "zaval");
	this.ctrlSmart.addMenuItem("Просмотреть",this,"open");
	this.ctrlSmart.addMenuItem(UR("Додати [Insert]|Добавить [Insert]"), this, "add");
	this.isStartSearchSmart = ReadParameter("FIND_STRFIRST", "FIND")=="true";	//параметр поиска в списке "Поиск с начала слова"
	// 11.9.15 не знает о таком методе
	if (typeof this.ctrlSmart.setInsertHandler == "function")
		this.ctrlSmart.setInsertHandler(this, "add");
	if(this.getMode("!"))
		this.ctrlSmart.setMessage(UR("Для всiх|Для всех"));
	if(lpProxy.getHelper)
		lpProxy.getHelper().setCtrl(ctrlSmart.getCtrl(), "clsmartctrl"); 
	this.updateCtrl();
}

function DpCl_blurSmartCtrl()
{
	var isOk = false;
	
	if (this.smartBeforeChange != String(this.ctrlSmart.value)
		&& String(this.ctrlSmart.value)!=""
		)
	{
		// Если введенное значение - код подставляем его
		var val = String(this.ctrlSmart.value);

		if (String(Number(val)) == val)
		{
			//поиск по дополнительным полям
			if(this.fldSearchSmart.length>0)
			{
				var oDec = new DpDocumentDecoder();
				if (!isNaN(parseInt(this.vid)))
					var sClass = "CL" + parseInt(this.vid);
				else
					var sClass = this.vid;
					
				var oClEx = new DpClEx(sClass,this.getClcl());
				var mapper = oClEx.jObj.getDefaultMapperXML();				
				var tblMap = oDec.fillTableMap(mapper.getDocumentElement());
				var sFrom = oDec.parseFromForCL(tblMap);
				var sWhere = "1<>1";
				var nCod1 = 0;
				if(this.isUnderCl || this.IsSuperCl)
				{
					if(this.IsSuperCl)
					{
						nCod1 = this.superCl.getCod();
					}
					else	
					{
						var ev = this.getVarEval();
						nCod1 = ev.eval(this.varExpr);
					}
					//if(typeOf(nCod1)=="number")
					//	sWhere = " and fcod1="+ sqlTo(nCod1);
				}
				for(var i in this.fldSearchSmart)
				{
					if(this.isExactSearchSmart)
						sWhere += " OR UPPER(" + this.fldSearchSmart[i] + ") = " + sqlTo(val.toUpperCase());
					else if(this.isStartSearchSmart)
						sWhere += " OR UPPER(" + this.fldSearchSmart[i] + ") LIKE " + sqlTo(val.toUpperCase()+"%");
					else
						sWhere += " OR UPPER(" + this.fldSearchSmart[i] + ") LIKE " + sqlTo("%"+val.toUpperCase()+"%");
				}
				var t = OpenTable("SELECT fcod "
					+ " FROM "+sFrom
					+ " WHERE fcl = " + sqlTo(this.clclCod)
						+(Number(nCod1)? " and fcod1="+ nCod1 : "")
						+ " AND (" + sWhere + ")"
					);
				
				if (t.recordCount==1)
				{
					this.setCod(Number(t.getValue("Fcod")));
					isOk = true;
				}
				else
				{
					if (!isNaN(Number(val)) && this.isCodeSearchSmart)
					{
						sWhere = " 1<>1 OR FCOD = " + val
					}
					var t1 = OpenTable("SELECT fcod "
						+ " FROM "+sFrom
						+ " WHERE fcl = " + sqlTo(this.clclCod)
							+ " AND (" + sWhere + ")"
						);
					if (t1.recordCount==1)
					{
						this.setCod(Number(t1.getValue("Fcod")));
						isOk = true;
					}
					t1.close();
				}
				t.close();
			}
			else
			{
				var t = OpenTable("s",
					"SELECT fcod, fwid"
					+ " FROM ^listcl "
					+ " WHERE fcl = " + sqlTo(this.clclCod)
						+ " AND fcod=" + val
					);
				
				if (t.recordCount==1)
				{
					this.setCod(Number(val));
					isOk = true;
				}
				t.close();
			}
		}

		if (!isOk)
		{		
			t = this.getSmartTable();
			
			if (t.recordCount == 1)
			{
				this.setCod(t.getValue("fcod"));
				isOk = true;
			}
			if (t!= null)
				t.close();
		}
	}
	else if (String(this.ctrlSmart.value)=="")
	{
		this.setCod(0);
		isOk = this.isValid;
	}
	else
	{
		isOk = this.isValid;
	}
	
	this.validMark(isOk);
	
	if (!isOk)
	{
		this.isValid = false;
		this.ctrlSmart.showErr(this.errMsg
			? this.errMsg
			: "Такого элемента нет в справочнике. "
				+ " Укажите код существующего элемента или подстроку его названия."
				);
	}
	
	if(isOk && String(this.ctrlSmart.value)=="")
	{
		this.setCod(0);
	}

	if(isOk)
	{
		isOk = this.chkAcc();
	}
	
	return isOk;
}

// Вызывается при изменении свойства isValid
function DpCl_validMark(isOk)
{
	if (this.ctrlSmart)
		this.ctrlSmart.setBackground(isOk? 0xFFFFFF: 0xFFAAAA);
}

function DpCl_getSmartTable(mode)
{
	var str = String(this.ctrlSmart.value);
	
	if (this.smartBeforeChange == String(this.ctrlSmart.value))
	{
		str = "";
		this.ctrlSmart.getCtrl().selectAll();
	}
	
	if(this.fldSearchSmart.length>0)
	{
		var oDec = new DpDocumentDecoder();
		if (!isNaN(parseInt(this.vid)))
			var sClass = "CL" + parseInt(this.vid);
		else
			var sClass = this.vid;
			
		var oClEx = new DpClEx(sClass,this.getClcl());
		var mapper = oClEx.jObj.getDefaultMapperXML();				
		var tblMap = oDec.fillTableMap(mapper.getDocumentElement());
		var sFrom = oDec.parseFromForCL(tblMap);
		var sFlds = "";
		for(var i in this.fldSearchSmart)
			sFlds += ", "+this.fldSearchSmart[i];
		var sSQL = "SELECT fcod ,ftxt, fwid" + sFlds + " FROM " + sFrom
					+ " WHERE fcl = " + (this.vid==2? 0 : this.getClcl());
	}
	else
	{
		var sSQL = "SELECT fcod ,ftxt, fwid FROM " 
			+ (this.vid==2? " ^listcl left join ^cl_post on ^listcl.fwid = ^cl_post.fwid_cl " :" ^listcl ")
				sSQL += " WHERE fcl = " + (this.vid==2? 0 : this.getClcl());
	}
	
	if(this.isUnderCl || this.IsSuperCl)
	{
		var nCod1 = 0;
		if (this.IsSuperCl)
				nCod1 = this.superCl.getCod();
		else	
		{
			var ev = this.getVarEval();
			nCod1 = ev.eval(this.varExpr);
		}
		if(typeOf(nCod1) != "number")
		{
			nCod1 = 0;			
		}		
				
		sSQL += " and fcod1 = " + sqlTo(nCod1);
	}		
	aWords = str.split(" ");
	if(this.isExactSearchSmart)
		aWords = new Array(str);
	for (n in aWords)
	{
		sWord = aWords[n].trim();
		
		if (sWord && sWord != "0" && sWord != "???")	
		{	
			sSQL += " AND ( ";
			
			if (false)
			{
				sSQL += SqlConCat(sqlTo(" "), sqlUpper("ftxt"))
						+ " LIKE " + sqlTo("% " + sWord.toUpperCase()+"%");
				sSQL += " OR " + SqlConCat(sqlTo(" "), sqlUpper("ftxt"))
						+ " LIKE " + sqlTo("%\"" + sWord.toUpperCase()+"%");
				sSQL += " OR " + SqlConCat(sqlTo(" "), sqlUpper("ftxt"))
						+ " LIKE " + sqlTo("%." + sWord.toUpperCase()+"%");
				sSQL += " OR " + SqlConCat(sqlTo(" "), sqlUpper("ftxt"))
						+ " LIKE " + sqlTo("%-" + sWord.toUpperCase()+"%");
			}
			else
			{
				if(this.isExactSearchSmart)
					sSQL += sqlUpper("ftxt") +" = "+ sqlTo(sWord.toUpperCase());
				else if(this.isStartSearchSmart)
					sSQL += sqlUpper("ftxt") +" LIKE "+ sqlTo(sWord.toUpperCase()+"%");
				else
					sSQL += sqlUpper("ftxt") +" LIKE "+ sqlTo("%"+sWord.toUpperCase()+"%");
			}
			
			for(var i in this.fldSearchSmart)
			{
				if(this.isExactSearchSmart)
					sSQL += " OR UPPER(" + this.fldSearchSmart[i] + ") = " + sqlTo(sWord.toUpperCase());
				else if(this.isStartSearchSmart)
					sSQL += " OR UPPER(" + this.fldSearchSmart[i] + ") LIKE " + sqlTo(sWord.toUpperCase()+"%");
				else
					sSQL += " OR UPPER(" + this.fldSearchSmart[i] + ") LIKE " + sqlTo("%"+sWord.toUpperCase()+"%");
			}
				
			if (!isNaN(Number(sWord)) && this.isCodeSearchSmart)
			{
				sSQL += " OR " + Convert("fcod", "NVC") + " LIKE " 
				+ sqlTo(sWord+"%");
				if (this.vid==2)
				{
					sSQL += " or " + sqlUpper("fcod_st") + " LIKE " 
						+ sqlTo(sWord+"%");
				}
			}
				
			sSQL += ")";
		}
	}
	
	sSQL += " order by ftxt "
	
	
	return OpenTable("s", sSQL);
}

function DpCl_fillSmartAssist(ca)
{
	if (this.threadFill)
		this.threadFill.stop();
	//ca.removeAll();

	// Если значение не изменилось - выходим
	if (this.ctrlSmart.value == this.smartBeforeChange)
		return;

	if (String(this.ctrlSmart.value)=="")
		return;

	var tblChoose = this.getSmartTable();
	
	//var nCnt = 1000;
	var n = 0;
	while (!tblChoose.isEOF())
	{
	/*
		nCnt--;
		if (nCnt==0)
			break;
	*/
		n++;
		var sCod = tblChoose.getValue("FCOD");
		var sTxt = tblChoose.getValue("FTXT");
		ca.addItem(sCod, sTxt + " : " + (this.fldReplaceCodSmart?tblChoose.getValue(this.fldReplaceCodSmart):sCod));
	
		tblChoose.MoveNext();
		if (n >=51)
			break;
		
	}	
	
	
	/*
	if (nCnt == 0)
	{
		//this.threadFill = runInThread(fillRun);
	}
	*/
	
	function fillRun()
	{
		//trace("fillRun");
		while (!tblChoose.isEOF())
		{
			var sCod = tblChoose.getValue("FCOD");
			var sTxt = tblChoose.getValue("FTXT");
			Packages.org.eclipse.swt.widgets.Display
				.getDefault().asyncExec(function()
				{
					ca.addItem(sCod, sTxt + " : " + (this.fldReplaceCodSmart?tblChoose.getValue(this.fldReplaceCodSmart):sCod));
				});
			
			tblChoose.MoveNext();
		}	
	}
	
	tblChoose.close()
}



function DpCl_smartSelected(cod)
{
	this.setCod(Number(cod));
}

function DpCl_setContAssist()
{
	if (this.singleCod) return
	ctrlTxt = this.ctrl["ftxt"];
	if (!ctrlTxt) return;
	this.isContAssist = true;
	Enable(ctrlTxt, true);
	this.fillContAssist = DpCl_fillContAssist;
	this.contAssistHandler = DpCl_contAssistHandler;
    ctrlTxt.setContentAssistHandler(this, 
				"fillContAssist", "contAssistHandler");
}

function DpCl_contAssistHandler(nCod)
{
	this.setCod(nCod);
}

function DpCl_fillContAssist(ca)
{
	ctrlTxt = this.ctrl["ftxt"];
	
	//Не вызывать список для пустого текста
	//if (!ctrlTxt) return;
	
	var str = String(ctrlTxt.value);

	if(this.fldReplaceCodSmart)
	{
		var oDec = new DpDocumentDecoder();
		if (!isNaN(parseInt(this.vid)))
			var sClass = "CL" + parseInt(this.vid);
		else
			var sClass = this.vid;
			
		var oClEx = new DpClEx(sClass,this.getClcl());
		var mapper = oClEx.jObj.getDefaultMapperXML();				
		var tblMap = oDec.fillTableMap(mapper.getDocumentElement());
		var sFrom = oDec.parseFromForCL(tblMap);
		var sFlds = "";
		for(var i in this.fldSearchSmart)
			sFlds += ", "+this.fldSearchSmart[i];
		var sSQL = "SELECT fcod ,ftxt" + sFlds + " FROM " + sFrom
	}
	else
	{
		var sSQL = "SELECT fcod ,ftxt FROM ^cl c INNER JOIN ^clrelclcl r "
						+ " ON c.fwid = r.fwid_cl  "
	}
	sSQL += " WHERE fcl = " + (this.vid==2? 0 : this.getClcl())
	if (str && str != "0" && str != "???")	
	{	
		if(this.isExactSearchSmart)
			sSQL += " AND (" +  Convert("ftxt","NVC") +" = " + sqlTo(str);
		else
			sSQL += " AND (" +  Convert("ftxt","NVC") +" LIKE " + sqlTo(str+"%");
		for(var i in this.fldSearchSmart)
		{
			if(this.isExactSearchSmart)
				sSQL += " OR UPPER(" + this.fldSearchSmart[i] + ") = " + sqlTo(str.toUpperCase());
			else
				sSQL += " OR UPPER(" + this.fldSearchSmart[i] + ") LIKE " + sqlTo("%" + str.toUpperCase()+"%");
		}
		sSQL += ")";
	}
	sSQL += " order by ftxt "
	var tblChoose = OpenTable("s",sSQL);
	
	while (!tblChoose.isEOF())
	{
		var sCod = tblChoose.getValue("FCOD");
		var sTxt = tblChoose.getValue("FTXT");
		ca.addItem(sCod, sTxt + " : " + (this.fldReplaceCodSmart?tblChoose.getValue(this.fldReplaceCodSmart):sCod))
		tblChoose.MoveNext();
	}
	tblChoose.close();
}

function DpCl_enableUnderCtrl()
{
	if (this.isUnderCl && this.superCl)
	{
		Enable(this.ctrlCod, this.superCl.getCod()!="0");
	}
	if(this.underCtrl)	//поле для выбора из подсправочника должно открываться после завала в основной без табуляции
	{
		Enable(this.underCtrl, this.getCod()!="0");
	}
}

// Установить полю ввода необходимые атрибуты (маски и т.д.)
// Вызывается один раз при инициализации поля ввода
// и каждый раз при смене справочника
function DpCl__resetCtrl()
{
	if(!this.ctrlCod) return null;
		
	if(this.getClcl()==-1)
	{
		    Disable(this.ctrlCod);
	
			// т.к. некоторые программы берут номер аналитики непосредственно
			// из объекта, то реже будет падать, если там будет ноль.
			// Хотя совсем правильно, чтобы все программы код аналитки
			// получали непосредственно у объекта.
			//this.ctrlCod.mask = "&";
			//this.ctrlCod.value = "";
			this.ctrlCod.mask = "#";
			this.ctrlCod.setValue(0);
	}
	else
	{
		Enable(this.ctrlCod);
		this.ctrlCod.mask = this.isTCod? "&&&&&&&&&&": "-##########";
	}	
}

function DpCl_linkCtrlTxt(ctrlTxt)
{
	if(ctrlTxt!=null)
		this.linkCtrl2("ftxt", ctrlTxt);
}

function DpCl_linkCtrl2(mode, ctrl)
{
	if(typeof(ctrl)!="object")
		return false;

	mode = mode.toLowerCase();

	var oValue =  toScrObj(ctrl.value);
   
//	if(typeof(oValue)=="string" 
//	|| typeof(oValue)=="date"
//  	|| typeOf(oValue)=="Date" )
//	{

		if(this.vid == 3)
		{
			ctrl.value = this.get3(mode);
		}
		else if(this.vid == 2)
		{
			ctrl.value = this.get2(mode);
		}
		else
			ctrl.value = this.get(mode);
		
		this.ctrl[mode] = ctrl;
/*	}
	else
		debug("Попытка связать текст поля " + mode
			+ " c числовым полем ввода " + ctrl.id);
*/			
	
	Disable(ctrl);
   //this.updateCtrl();
   return true;
}

// Обновить связанные поля ввода
function DpCl_updateCtrl()
{
	if(this.ctrlCod && this.getClcl()!=-1)
	{
		this.enableUnderCtrl();
		this.ctrlCod.value = this.isTCod ? this.getTCod(): this.getCod();
	}
	for(var ctrl in this.ctrl)
	{
		if(this.vid == 3)
		{
			this.ctrl[ctrl].value = this.get3(ctrl);
		}
		else if(this.vid == 2)
		{
			this.ctrl[ctrl].value = this.get2(ctrl);
		}
		else
			this.ctrl[ctrl].value = this.get(ctrl);
	
	}
	
	if (this.ctrlSmart)
	{
		if (this.getCod())
		{
			if(this.fldReplaceCodSmart)
				var sText = (getPar("SHOWCLCODE")?(this.getFldValue(this.fldReplaceCodSmart) + ": "):"") + UR(this.get("ftxt"));
			else
				var sText = (getPar("SHOWCLCODE")?(this.getCod() + ": "):"") + UR(this.get("ftxt"));
			this.smartBeforeChange = sText; 
			this.ctrlSmart.value = sText;
			this.ctrlSmart.getCtrl().selectAll();
		}
		else
		{
			this.ctrlSmart.value = "";
		}
		
		if (this.singleCod)
		{
			this.ctrlSmart.setTextEnabled(false);
		}
		else
			this.ctrlSmart.setTextEnabled(true);
		//this.ctrlSmart.setBackground(this.isValid? 0xffffff: 0xFF8C8C);
	}
	if(this.ctrlCombo)
		this.ctrlCombo.value = this.getCod();
	
	if(this.ctrlExt && this.nameExt)
		this.ctrlExt.value = this.getExt(this.nameExt);
	
	this.validMark(this.isValid);
	
	if (typeof this.AfterUpdate == "function")
		this.AfterUpdate();
}

function DpCl_validCtrl()
{
//	debug();
	var retVal = true;
	if(this.isUnderCl || this.IsSuperCl
			|| (this.isTCod && this.ctrlCod && this.getTCod()!=this.ctrlCod.value)
			|| (!this.isTCod && this.ctrlCod && this.getCod()!=this.ctrlCod.value)
			|| !this.valid())
	{
		var oldCod = this.getCod();
		if(this.ctrlCod)
			this.setCod(this.ctrlCod.value, this.isTCod);
		else
			this.setCod(this.getCod(), this.isTCod);
		if(!this.zValid())
		   this.setCod(oldCod);
		retVal = this.valid();
	}
	if(this.ctrlSmart && (this.ctrlSmart.value=="" || this.ctrlSmart.value==this.ctrlSmart.getMessage()))
	{
		this.setCod(0);
		retVal = this.valid();
	}
	if(retVal)
	{
		retVal = this.chkAcc();
	}
	return retVal;
}

function DpCl_setFWID(fwid)
{
	var snap = getSnap(
		"SELECT fcod"
		+ " FROM ^clrelclcl"
		+ " WHERE fwid_cl=" + sqlTo(fwid)
		);
	
	if(null != snap)
		return this.setCod(snap[0]);
	else
		return false;
}

function DpCl_getFWID()
{
	return this.fwid;
}

function DpCl_getExt(nameExt)
{
	var oExt = new DpExtentionBuilder("CL",String(this.clclCod));
	if(oExt.exist())
	{
		var extTblName = oExt.getValueTableName();
		var snap = getSnap(s = "select F"+nameExt+" from "+extTblName+" where Fmainwid="+this.fwid, false);
		if(snap)
			return snap[0];
		else if (this.vid==2)
		{
			var oExt = new DpExtentionBuilder("CL",String(0));
			if(oExt.exist())
				var extTblName = oExt.getValueTableName();
			var snap = getSnap(s = "select F"+nameExt+" from "+extTblName+" where Fmainwid="+this.fwid, false);
			if(snap)
				return snap[0];
			else 
				return null;
		}
	}
}

function DpCl_setValid(obj, method)
{
	if (this.ctrlSmart)
		setValid(this.ctrlSmart, obj, method);
	else if(this.ctrlCod)
		setValid(this.ctrlCod, obj, method);
	else
		debug("Перед вызовом метода setValid свяжите"
			+ " объект с полем ввода при помощи метода"
			+ " linkCtrl.");
}

function DpCl_setRelFunc(func)
{
	this.getVarEval = func;
}

function DpCl_setVar(vars)
{
	this.varExpr = vars;
}

function DpCl_setCl(oCl)
{
	if(oCl)
	{
		this.IsSuperCl	= true;
		this.superCl	= oCl;
	}
	else
	{
		this.IsSuperCl = false;
		this.superCl = null;
	}
}

function DpCl_addCondition(func)
{
	this.cond[this.cond.length] = func;
	return true;
}
function DpCl_removeCondition()
{
	return true;
}

function DpCl_addListCondition(func)
{
	this.listCond = func;
}

function DpCl_removeListCondition()
{
	this.listCond = null;
}

function DpCl_getClTxt()
{
	if(this.clTxt!=null && this.clTxt!="")
		return this.clTxt;
	return UR("Довідник аналітики|Справочник аналитики");
}

function DpCl_setCtrlLinker(ctrlLinker)
{
	this.ctrlLinker = ctrlLinker;	
}

function DpCl_getCtrlLinker()
{
	return this.ctrlLinker;
}

function DpCl_setDefCod(defCod)
{
	this.defCod = defCod;
}

function DpCl_getDefCod()
{
	return this.defCod;
}

//Проверка допустимости ввода кода
//ориентируемся на параметр COD ресурсов PODR и MOL
function DpCl_chkAcc(mFcod)
{
	var retVal = true;
	var nCl = this.getClcl();
	var sRes = "";
	var sTxt = "";
	if(typeof(mFcod)=="undefined")
	{
		mFcod = this.getCod();
	}

	switch(nCl)
	{
		case sprPodr:
			sRes = "VIEW_PODR";
			sTxt = mFcod==0 ? UR("всіх підрозділах|всем подразделениям")
			:UR("підрозділу з кодом "+mFcod+"|подразделению с кодом "+mFcod)
			break;
		case sprMol:
			sRes = "VIEW_MOL";
			sTxt = mFcod==0 ? UR("всіх МВО|всем МОЛ")
			:UR("МВО з кодом "+mFcod+"|МОЛ с кодом "+mFcod)
			break;
		default:
			return true;
	}
	
	retVal = getAccessOnAction(sRes, mFcod, "R");

	if(!retVal)
	{
		
		strMsg = UR("Немає повноважень для доступу\nдо інформації по "
				+"|Нет полномочий для доступа\nк информации по "
			)
			+sTxt
			+UR(".\n\nВкажіть код, до якого\nВам доступ дозволений."
				+"|.\n\nУкажите код, к которому\nВам доступ разрешен."
			)
		//_msgbox(null, strMsg);
		alert(strMsg);
	}
	return retVal;
}

function DpCl_add(oCtrl)
{
	var par = new Object();
	var sName = "";
	if(this.ctrlSmart)
		sName = this.ctrlSmart.value;
	else if(this.ctrlCod)
		sName = this.ctrlCod.value;
	if(Number(sName))
		par.cod = sName;
	else
		par.txt = sName;
	var sClass = this.vid;
	if (!isNaN(parseInt(this.vid)))
		sClass = "CL"+ parseInt(this.vid);
	else
		sClass = this.vid;		
	var newCL = new DpClEx(sClass, this.getClcl());
	var bRet = newCL.edit("ADD", null, par);
	if(bRet)
		this.setCod(newCL.getVar("HCOD"));
	return bRet;
}

function DpCl_addFldSearchSmart(fld)
{
	this.fldSearchSmart[this.fldSearchSmart.length] = fld;
}

function DpCl_getFldSearchSmart()
{
	return this.fldSearchSmart;
}

function DpCl_setFldReplaceCodSmart(fld)
{
	this.fldReplaceCodSmart = fld;
	//сразу добавляем его для поиска
	this.addFldSearchSmart(fld)
}

function DpCl_getFldReplaceCodSmart()
{
	return this.fldReplaceCodSmart;
}

function DpCl_getFldValue(fld)
{
	var oDec = new DpDocumentDecoder();
	if (!isNaN(parseInt(this.vid)))
		var sClass = "CL" + parseInt(this.vid);
	else
		var sClass = this.vid;
		
	var oClEx = new DpClEx(sClass,this.getClcl());
	var mapper = oClEx.jObj.getDefaultMapperXML();				
	var tblMap = oDec.fillTableMap(mapper.getDocumentElement());
	var sFrom = oDec.parseFromForCL(tblMap);
	var snap = getSnap("SELECT "+fld
		+ " FROM "+sFrom
		+ " WHERE fcl = " + sqlTo(this.clclCod) + " AND fcod = " + this.getCod());
	if(snap)
		return snap[0];
	else
		return null;
}