/*
	Объкт для проверки уникальности кода справочника
	mode: режим редактирования +
		"NOINIT" - не инициализировать значение при 
			добавлении новой записи.
		
*/
 
function DpClNo(mode, objGet, cTblName, cFldName, fwid, cClCond, mask, toFindMinFreee)
{
	RO("DpClNo", this);
	// Методы
	this.valid = DpClNo_valid;
	this.findFree = DpClNo_findFree;
	// Свойства
	this.isNew = mode.indexOf("COPY")!=-1
		|| mode.indexOf("ADD")!=-1;
	this.objGet = objGet;
	this.cTblName = "^" + cTblName;
	this.cFldName = cFldName;
	this.fwid = fwid;
	this.cClCond = cClCond;
	this.mask = (typeof mask == "string" ? mask : "i");
	this.parseValueToType = DpClNo_parseValueToType;
	//булевский параметр позволяющий искать минимальный свободный номер, а не максимальный как обычно
	this.toFindMinFreee = toFindMinFreee===true;
	if(objGet)
	{
		if(this.isNew && mode.indexOf("NOINIT")==-1)
			this.objGet.setValue(new java.lang.Integer(this.findFree()));	
		setValid(this.objGet, this, "valid");
	}
}

function DpClNo_findFree()
{
	if(this.toFindMinFreee)
	{
		var snap = getSnap("SELECT MIN(T." + this.cFldName + ") as fmaxno"
						+ " FROM " + this.cTblName + " AS T "
						+ " WHERE not exists(select * from " + this.cTblName + " as T2 where T2." + this.cFldName + "=T." + this.cFldName + "+1) "
							+(this.cClCond?" and "+this.cClCond:""));
	}
	else
	{
		var snap = getSnap("SELECT max(T." + this.cFldName + ") as fmaxno"
						+ " FROM " + this.cTblName + " AS T "
						+ (this.cClCond ? " WHERE " + this.cClCond : ""));
	}
	if (snap == null || snap[0] == null)
		return 1;
	if(Number(snap[0])>=0)
		return parseInt(String(Number(snap[0]) + 1));
	else
		return 0;
}

function DpClNo_valid(oCtrl)
{
	var sSql = "SELECT *"
		+ " FROM " + this.cTblName
		+ " WHERE " + this.cFldName + "=" + this.parseValueToType(this.objGet.getValue())
			+ (this.isNew? "": " AND fwid<>" + sqlTo(Number(this.fwid)))
			+ (this.cClCond? " AND " + this.cClCond: "");
	var t = getSnap(sSql);
	if(t!=null)
	{
/*		WAIT(ru("Такой код уже существует",
			"Такий код вже існує"));
*/
		oCtrl.showErr(ru("Такой код уже существует",
			"Такий код вже існує"));
		return false;
	}
}

function DpClNo_parseValueToType(value)
{
	if (!(this.mask == "i" || this.mask == "f" || this.mask == "s"))
		this.mask = "i";
	switch (this.mask)
	{
		case "i":
			return sqlTo(parseInt(value));
		case "f":
			return sqlTo(parseFloat(value));
		case "s":
			return sqlTo(String(value));
	}
	return sqlTo(value);
}


function findFreeClNo(cTblName, cFldName, cClCond)
{
	return new DpClNo("", null, cTblName, cFldName, null, cClCond).findFree();
}