/*
        Описание объекта "справочник аналитики" DpClcl
*/

var ClclWrk;


function DpClcl(par1, par2)
{
	RO("DpClcl", this);
	par1 = toScrObj(par1);
	par2 = toScrObj(par2);
	this.setCod = DpClcl_setCod;  //Установить код справочника
	this.setMode = DpClcl_setMode;
	this.getCod = DpClcl_getCod;  //Получить код справочника
	this.getVid = DpClcl_getVid;  //Получить вид справочника
	this.getTxt = DpClcl_getTxt;  //Получить текст справочника
	this.getRel = DpClcl_getRel;  //Получить код родительского справочника
	this.getIsTCod = DpClcl_getIsTCod;   //Узнать, используется ли в справочнике метка
	this.getASubCl = DpClcl_getASubCl;   //Получить подсправочник
	this.valid = DpClcl_valid;           //Проверка, существует ли запись по заданному коду вида оплаты 
	this.linkCtrl = DpClcl_linkCtrl;     //Связать с полем ввода
	this.validCtrl = DpClcl_validCtrl;   //Реакция на выход из связанного поля ввода
	this.zaval = DpClcl_zaval;           //Осуществляется завал при нажатии кнопки
	this.updateCtrl = DpClcl_updateCtrl; //обновление поля ввода
	this.setRel = DpClcl_setRel;         //Установить родительский справочник (см. комментарии в самой ф-ии)
    this.fillContAssist = DpClcl_fillContAssist;
    this.__defineGetter__("value", this.getCod);
	this.__defineSetter__("value", this.setCod);
	
	this.setMode("");
	this.setCod(0);
	this.setRel(0);
	
	switch(typeof par1)
	{
	case "string":
		this.setMode(par1);
		if(typeof par2=="number")
			this.setCod(par2);
		break;
	case "number":
		this.setCod(par1);
	}
}


function DpClcl_fillContAssist(ca)
{
	var str = String(this.ctrl.value);
	var sSQL = "SELECT * FROM ^clcl "
	if (str && str != "0")	
	{
		sSQL += " where "+ Convert("fcod","NVC") 
		+ " like " + sqlTo(str+"%");
	}
	
	sSQL += " order by fcod "
	var tblChoose = OpenTable("s",sSQL);
	while (!tblChoose.isEOF())
	{
		var sCod = tblChoose.getValue("FCOD");
		var sTxt = tblChoose.getValue("FTXT");
		ca.addItem(sCod, sCod + " : " + sTxt)
		tblChoose.MoveNext();
	}
	
	tblChoose.close();
	
}

function DpClcl_setCod(cod)
{
	this.cod = cod;	
	if(cod==0)
	{
		this.isValid = strIn("0", this.mode);
		// Если 0 допустим - хорошо
		if(this.isValid)
		{
			this.txt = "";
			this.vid = "2";
			this.rel = 0;
			this.isTCod = false;
		}
	}
	else
	{
		var DpClcl_tblClcl = OpenTable("s","SELECT * FROM ^clcl " +
											" WHERE FCOD=" + sqlTo(cod));
		this.isValid = !toScrObj(DpClcl_tblClcl.IsEmpty());
		

		if(this.isValid)
		{
			var rel = toScrObj(DpClcl_tblClcl.getValue("frel"));
			/*
			if(this.rel===true && !rel)
				// Должент быть подсправочником, а нет
				this.isValid = false;
			else if(typeof(this.rel)=="number" && rel!=this.rel)
				// Подсправочник не того справочника
				this.isValid = false;
			else if(this.rel===false && rel)
				// Справочник является подсправочником, а не должен
				this.isValid = false;
			else
			*/
			{
				this.txt = UR(toScrObj(DpClcl_tblClcl.getValue("ftxt")));
				this.vid = String(DpClcl_tblClcl.getValue("fvid"));
				this.rel = rel;
				this.isTCod = Boolean(toScrObj(DpClcl_tblClcl.getValue("fistcod")));	
			}
		}
		DpClcl_tblClcl.close();
	}
	
	if(!this.isValid)
	{
		this.txt = "???";
		this.rel = 0;
		this.vid = 0;
	}
	
	this.updateCtrl(); 
}

function DpClcl_getCod()
{
	return this.cod;
}

function DpClcl_getVid()
{
	return this.vid;
}

function DpClcl_getTxt()
{
	return this.txt;
}

function DpClcl_getRel()
{
	return this.rel;
}

function DpClcl_setMode(mode)
{
	this.mode = mode;
}

//-----------------

function DpClcl_getASubCl()
{
	var aSubCl = new Array();
	if(!Number(this.getCod()))
		return aSubCl;
		
	var tSubCl = OpenTable("sn",
		"SELECT *"
		+ " FROM ^clcl"
		+ " WHERE frel = " + sqlTo(this.getCod())
		);

	while(!tSubCl.isEOF())
	{
		aSubCl[aSubCl.length] = new DpClcl(Number(tSubCl.getValue("fcod")));
		tSubCl.MoveNext();
	}
	
	tSubCl.close();
	return aSubCl;
}

// Проверка, существует ли запись по заданному коду справочника
function DpClcl_valid()
{  
   return this.isValid;
}

function DpClcl_getIsTCod()
{
	return this.isTCod;
}

// Связать с полем ввода
function DpClcl_linkCtrl(ctrl, ctrlT)
{
	this.ctrl = ctrl;
   if(typeof(ctrl)!="object")
		return;
		
	if(typeof(ctrlT)!="undefined" && typeof(ctrlT)=="object")
	{
		this.ctrlT = ctrlT;
	}

	this.ctrl.mask = "####";
	this.ctrl.setContentAssistHandler(this, 
				"fillContAssist", "setCod");
	setValid(this.ctrl, this, "validCtrl");
	setButton(ctrl, this, "zaval");
	
	this.updateCtrl();
}

function DpClcl_validCtrl()
{
	this.setCod(this.ctrl.value);
	if(!this.valid())
		this.zaval();
	return this.valid();
}

function DpClcl_zaval()
{
	var par = new Object();
	par.ret = new Object();
	par.ret.FCOD = this.ctrl.value
	par.zaval = true;
	
	//if(this.rel)
	if(this.rel != 0)
	{
		par.aFcl = new Array();
		//par.aFcl[0] = "ALL";
		par.aFcl[0] = this.rel;
	}

	showWindow("l_clcl.js",SW_MODAL,par);
	if(!par.escape) 
		this.setCod(par.ret.FCOD);
}

function DpClcl_updateCtrl()
{
	if(this.ctrl)
		this.ctrl.value = this.getCod();
	
	if(this.ctrlT)
		this.ctrlT.value = this.getTxt();
}

// Установить родительский справочник
// .setRel(true) - все подсправочники
// .setRel({номер справ.}) - подсправочники указанного справочника 
// .setRel(false) - справочники, не являющиеся подсправочниками
// .setRel("ALL") - все справочники
function DpClcl_setRel(rel)
{
	this.rel = rel;
}