/*
   Описание объекта "элемент справочника расчетов": DpCntr
   (C) ДЕБЕТ Плюс, 1998-1999

   Конструктор DpCntr.
      Возвращает this

   Внешние методы:
   .setFvid(Fvid)    - Установить код расчета
   .getFvid()        - Получить код расчета
   .setFnazv(Fnazv)  - Установить название расчета
   .getFnazv()       - Получить название расчета
   .setFnum(Fnum)    - Установить номер по порядку
   .getFnum()        - Получить номер по порядку
   .valid()          - Проверка, существует ли запись по заданному номеру п/п
   .linkCtrl(ctrlNum,ctrlNazv,ctrlVopl) - Связать с полем ввода
   .validCtrl()      - Реакция на выход из связанного поля ввода
   .zaval()          - Осуществляется завал при нажатии кнопки.
   .setFproc(Fprocnum) - Установить номер расчета
   .getFproc()         - Получить номер расчета

   Внутренние свойства:
   .Fvid              - код вида оплаты
      Используется только в методах setFvid и getFvid.
      В остальных случаях используйте эти методы.
   .Fnazv             - наименование вида оплаты
      Используется только в методах setFnazv и getFnazv.
      В остальных случаях используйте эти методы.
   .Fnum              - номер по порядку
      Используется только в методах setFnum и getFnum.
      В остальных случаях используйте эти методы.
   .table             - таблица для внутреннего использования в объекте.
   .ctrlNum,ctrlNazv,ctrlVopl  - связь с полями ввода. 
   .isButton          - кнопка для завала.
   .updateCtrl        - обновление полей ввода.
*/

// Конструктор объекта DpCntr
function DpCntr(mode)
{
   RO("DpCntr", this);
   this.setFvid = DpCntr_setFvid;
   this.getFvid = DpCntr_getFvid;
   this.setFnazv = DpCntr_setFnazv;
   this.getFnazv = DpCntr_getFnazv;
   this.setFnum = DpCntr_setFnum;
   this.getFnum = DpCntr_getFnum;
   this.valid = DpCntr_valid;
   this.linkCtrl = DpCntr_linkCtrl;
   this.validCtrl = DpCntr_validCtrl;
   this.updateCtrl = DpCntr_updateCtrl;
   this.zaval = DpCntr_zaval;
   this.setFproc = DpCntr_setFproc;
   this.getFproc = DpCntr_getFproc;
   this.setNamFproc = DpCntr_setNamFproc;
   this.getNamFproc = DpCntr_getNamFproc;
   this.setMode = DpCntr_setMode;
   this.getMode = DpCntr_getMode;
	if(mode)
		this.mode = mode;
	else
		this.mode = "";
   
   return this;
}

// Установить код Fvid
function DpCntr_setFvid(Fvid)
{
   this.Fvid = Fvid;
   return true;
}

// Получить код Fvid
function DpCntr_getFvid()
{
   if (this.valid())
      return this.table.getValue("Fvid")
   else
      return 0;
}

// Установить номер Fprocnum
function DpCntr_setFproc(Fprocnum)
{
   this.Fprocnum = Fprocnum;
   return true;
}

// Получить код Fprocnum
function DpCntr_getFproc()
{
   if (this.valid())
   {
     /* if (this.FprocNam.substring(0,1)==":")
      {
         var par   = new Object();
         par.ret = new Object();
       //  par.ret.Fnum  = this.ctrlNum.value;
         par.ret.Fproc = this.getNamFproc();
         par.Fproc = this.getNamFproc();
         par.ret.Fnum = 0;
         par.zaval = true;
         showWindow("l_clproc.js",SW_MODAL,par);
         if (!par.escape) return par.ret.Fnum; 
      }
      else
      {*/
         return this.Fprocnum;
      //}
   }
   else
   {
      return 0;
   }
}

// Установить номер Fprocnum
function DpCntr_setNamFproc(Fproc)
{
   this.FprocNam = Fproc;
   return true;
}

// Получить код Fprocnum
function DpCntr_getNamFproc()
{
   return this.FprocNam;
}

// Установить название Fnazv
function DpCntr_setFnazv(Fnazv)
{
   this.Fnazv = Fnazv;
   this.updateCtrl();
   return true;
}

// Получить название Fnazv
function DpCntr_getFnazv()
{
   if (this.valid())
      return UR(this.table.getValue("Fnazv"));
   else
      return "";
}

// Установить номер п/п Fnum
function DpCntr_setFnum(Fnum)
{
   this.Fnum = Fnum;
   this.table = OpenTable("s",
         "SELECT * FROM ^cl_prik "
               + " WHERE ( (FIS_SLCT ="+sqlTrue+") "
               + " OR (FDEFA ="+sqlTrue+") ) "
               + " AND (FNUM = "+sqlTo(Fnum)+" )");
   if(!(this.table.IsEmpty()))
   {
      this.setFnazv(UR(this.table.getValue("Fnazv")));
      this.setFvid(this.table.getValue("Fvid"));
      this.setNamFproc(this.table.getValue("Fproc"));
   }
   else 
      this.Fnazv = this.Fvid = null;
   this.updateCtrl();
}

// Получить номер п/п Fnum
function DpCntr_getFnum()
{
   return this.Fnum;
}

// Проверка правильности инициализации
function DpCntr_valid()
{
  var OK = (this.table) && (!(this.table.IsEmpty()));
  return OK
}

//связать с полями ввода
function DpCntr_linkCtrl(ctrlNum,ctrlNazv,ctrlVopl)
{
   this.ctrlNum = ctrlNum;
   this.ctrlNum.isButton = true;
   if (typeOf(this.ctrlNum) != "DpTextEx")
   {
		if (typeof this.ctrlNum != "object")
			return false;
   }
   this.ctrlNum.mask="-####"; //4   
   setValid(this.ctrlNum, this, "validCtrl");
  // if(this.ctrlNum.DpType=="DpGet")
      this.ctrlNum.buttonHandler(this, "zaval");
   this.ctrlNum.value = this.getFnum();
   
   this.ctrlNazv = ctrlNazv;
   if( typeof(this.ctrlNazv)!= "object" )
      return false;
   this.ctrlNazv.mask="&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&";  //60     
   this.ctrlNazv.value = this.getFnazv();
   
   this.ctrlVopl = ctrlVopl;
   if( typeof(this.ctrlVopl)!= "object" )
      return false;
   
   this.updateCtrl();
}

// Обновить связанные поля ввода
function DpCntr_updateCtrl()
{
   if (this.ctrlNum)
      this.ctrlNum.value = this.getFnum();
   if (this.ctrlNazv)
      this.ctrlNazv.value = this.getFnazv();
}

// Реакция на выход из связанного поля ввода
function DpCntr_validCtrl()
{
   this.setFnum(this.ctrlNum.value);
   if ( ((this.ctrlVopl!=null && this.ctrlVopl.value >= 9000) &&
         (this.ctrlNum.value == 0))  ||
         (!this.ctrlNum.enabled) || (this.mode.indexOf("0")!=-1 && this.ctrlNum.value == 0))
      return true;
   
   if (!this.valid())
      return this.zaval();
}

//Осуществляется завал при нажатии кнопки.
function DpCntr_zaval()
{
   var par = new Object();
   par.ret = new Object();
   par.Fnum = par.ret.Fnum = this.ctrlNum.value;
   par.zaval = true;
	var snap = getSnap("select Fproc,Fvid from ^cl_prik where Fnum="+this.ctrlNum.value)
	if(snap)
	{
		par.ret.Fproc = snap[0];
		par.ret.Fvid = snap[1];
	}
	else
	{
		par.ret.Fproc = '';
		par.ret.Fvid = 0;
	}
   showWindow("l_clprik.js",SW_MODAL,par);
   if(!par.escape) 
   { 
      this.setFnum(par.ret.Fnum);
      this.setFnazv(par.ret.Fnazv);
      this.setFvid(par.ret.Fvid);
      this.setNamFproc(par.ret.Fproc);
      this.updateCtrl();
      if (par.ret.Fproc.substring(0,1)==":")
      {
      	 par.Fproc = par.ret.Fproc;
      	 par.ret.Fnum = 0;
         showWindow("l_clproc.js",SW_MODAL,par);
         if (!par.escape) 
         {
         	this.setFproc(par.ret.Fnum);
         }
      }
   } 
   return !par.escape;
}

function DpCntr_setMode(mode)
{
	this.mode = mode;
}

function DpCntr_getMode()
{
	return this.mode;
}