// Объект для конвертирования таблиц зарплаты из старого формата в новый
include("sys/dbase.js");

function DpConvertShtat(strBases, funcWriteLog)
{
	this.run = DpConvertShtat_runProcess;
	this.putLogMessage = (typeof funcWriteLog == "function" ? funcWriteLog : null);
	this.modifyShat = DpConvertShtat_shtat;
	this.modifyBase = DpConvertShtat_runModifyBase;
	this.differType = DpConvertShtat_differType;
	this.convertAll = DpConvertShtat_convertAll;
	this.hasStruField = DpConvertShtat_hasStruField;
	this.getStrFromArr = DpConvertShtat_getStrFromArr;
	this.getArguments = DpConvertShtat_getArguments;
	this.executeRule = DpConvertShtat_executeRule;
	this.getRulesForTables = DpConvertShtat_getRulesForTables;
	this.getRuleForTable = DpConvertShtat_getRuleForTable;
	this.loadRulesForTables = DpConvertShtat_loadRulesForTables;
	this.dropColumn = DpConvertShtat_dropColumn;
	this.addColumn = DpConvertShtat_addColumn;
	this.backUp = DpConvertShtat_backUp;
	this.runModifyBase = DpConvertShtat_runModifyBase;
	this.getListModifyTables = DpConvertShtat_getListModifyTables;
	this.createBackUpTable = DpConvertShtat_createBackUpTable;
	this.endConvertTable = DpConvertShtat_endConvertTable;
	this.prepareModifyCL = DpConvertShtat_prepareModifyCL;
	this.prepareModifyShtat = DpConvertShtat_prepareModifyShtat;
	this.createTmpTable = DpConvertShtat_createTmpTable;
	this.eval = DpConvertShtat_eval;
	this.getDpType = DpConvertShtat_getDpType;
	this.insertNewFields = DpConvertShtat_insertNewFields;
	this.renameTable = DpConvertShtat_renameTable;	
	this.renameField = DpConvertShtat_renameField;	
	this.getFullTableName = DpConvertShtat_getFullTableName;	
	this.prepare = DpConvertShtat_prepare;	
	this.writeLog = DpConvertShtat_writeLog;
	this.getRangeProcess = DpConvertShtat_getRangeProcess;
	this.getMaxPos = DpConvertShtat_getMaxPos;
	this.modifyTabels = DpModifyTabels;//проставляет коректное значение Fwid_wp в таблицах STT1%LD и TBL%LD
	
	this.isModifyCL = false;
	this.isModifyShtat = false;	
	this.tableName = "";
	this.fullTableName = "";
	this.tmpTableName = getTmpTableName();
	this.base = "";
	this.arrRules = null;
	this.backUpTbl = "";
	this.allRecord = 0;
	this.indRecord = 0;
	this.countModTables = 0;
	this.pos = 0;
	this.maxPos = 0;	
	this.arrayBase = null;
	this.arrModBase = null;
	this.arrayTables = null;		
	this.accessGo = false;
	if (typeof strBases != "string")
		return;
	
	this.struTables = new Array();//для коректного переименования таблиц сформируем массив стуктур зарплатных таблиц, название которых оканчивается на %LD
	var struAr = getStruTables();
	for(var i=0; i<struAr.length; i++)
	{
		var sys = struAr[i].sys.toUpperCase();
		var table = struAr[i].table.toUpperCase();
		if(sys == "ZRP" && strIn("%LD",table))
			this.struTables[this.struTables.length] = struAr[i]; 
	}
	
	if (this.prepare(strBases))
		this.writeLog("\r\n\r\nПОДГОТОВКА ЗАВЕРШЕНА УСПЕШНО");
	else
		this.writeLog("\r\n\r\nВОЗНИКЛИ ОШИБКИ ВО ВРЕМЯ ПОДГОТОВКИ! УСТРАНИТЕ ИХ");
}

function DpConvertShtat_prepare(strBases)
{
	this.accessGo = false;
	
	this.writeLog("ПОДГОТОВКА к модифицированию баз(ы) " + strBases + "\r\n\r\n");
	
	if (getPar("CODPERS") == 0)
	{
		this.writeLog("Настройте справочник персонала!");
		return false;
	}
	if (getPar("CODDOL") == 0)
	{
		this.writeLog("Настройте справочник должностей!");
		return false;
	}
	if (getPar("CODKAT") == 0)
	{
		this.writeLog("Настройте справочник категорий!");
		return false;
	}
	
	if (!this.modifyCl)
		this.isModifyCl = this.prepareModifyCL();
	if (!this.isModifyCl)
		return false;
	if (!this.isModifyShtat)
		this.isModifyShtat = this.prepareModifyShtat();
	if (!this.isModifyShtat)
		return false;
	
	this.arrayBase = allt(strBases).split(",");
	this.accessGo = true;
	this.maxPos = this.getRangeProcess();
	this.writeLog("Модификации подлежит:");
	this.writeLog("\tВсего: " + this.arrayTables.length + " таблиц");
	for (var i in this.arrModBase)
			this.writeLog("\tВ базе " + this.arrModBase[i].labelBase + ": "
					+ this.arrModBase[i].listTables.length  + " таблиц");
	return true;
}

function DpConvertShtat_getRangeProcess()
{	
	if (!this.accessGo)
		return 0;
		
	this.maxPos = 0;		
	this.arrModBase = new Array();	
	this.arrayTables = new Array();
	if (this.arrayBase)
	{
		for (var i in this.arrayBase)
		{
			var sBase = allt(this.arrayBase[i]).toUpperCase();
			var basePath = getPath(sBase);
			if (basePath == null)
				continue;
			if (typeof this.arrModBase[basePath] != "undefined")
				continue;
			this.arrModBase[basePath] = new Object();
			this.arrModBase[basePath].labelBase = sBase;
			this.arrModBase[basePath].pathBase = basePath.toUpperCase();
			this.arrModBase[basePath].listTables = this.getListModifyTables(sBase);
			this.maxPos += this.arrModBase[basePath].listTables.length;
			for (var i in this.arrModBase[basePath].listTables)
				this.arrayTables[this.arrayTables.length] = this.arrModBase[basePath].listTables[i];
		}
	}
	return this.maxPos;
}

function DpConvertShtat_getMaxPos()
{
	return this.maxPos;
}


var writeLog_log = "";

function DpConvertShtat_writeLog()
{
	var args = this.writeLog.arguments;

	writeLog_log += "\r\n" + new Date() + ": " + args[0];
	lpProxy.writeToFile(new java.lang.String(writeLog_log), new java.lang.String(Packages.org.eclipse.core.runtime.Platform.getInstallLocation().getURL().getFile()+"DpConvertShtat.log"), "utf-8");

	var pos = null;
	if ((args.length > 0) && (typeof this.putLogMessage == "function"))
	{
		if (typeof args[args.length - 1] == "number")
			pos = args[args.length - 1];
		var to = (pos == null ? args.length : args.length - 1);
		if (args.length == 1 && to == 0)
			this.putLogMessage(pos);
		else
			for (var i = 0; i < to; i++)
				this.putLogMessage(String(args[i]), pos);	
	}
}

function DpConvertShtat_runProcess()
{
	if (!this.accessGo)
		return;
	
	this.pos = 0;

	var system = getSystem();
	if (system != "ZRP")
		lpProxy.getOrgManager().setSys("ZRP", false);

	for (var i in this.arrModBase)
		this.runModifyBase(this.arrModBase[i]);

	if (system != "ZRP")
		lpProxy.getOrgManager().setSys(system, false);
	//+ обнулим Fkod_uv в work_pers для пустых значений
	ExecuteSQL("update ^work_pers set Fkod_uv=0 where Fkod_uv is null");
	return true;	
}

function DpConvertShtat_prepareModifyCL()
{
	var path = getPath("CL_MDB").toUpperCase();
	if (typeof path == "undefined")
	{
		this.writeLog("Не настроена база CL_MDB!", "No");
		return false;	
	}
	
	this.writeLog("Анализ таблицы " + path + ".COM_CLRELCLCL");	
	if (!IsTableEx("CL_MDB", "COM_CLRELCLCL"))
	{
		this.writeLog("Отсутствует таблица " + path + ".COM_CLRELCLCL", "No");
		return false;
	}
	if (this.differType("^clrelclcl", "fwid_cl", "long"))
	{
		this.writeLog("\tПроведите перекодировку fwid-ов!", "No");
		return false;
	}
	this.writeLog("Ok");
		
	this.writeLog("Анализ таблицы " + path + ".COM_CL");	
	if (!IsTableEx("CL_MDB", "COM_CL"))
	{
		this.writeLog("Отсутствует таблица " + path + ".COM_CL", "No");
		return false;
	}
	if (this.differType("^cl", "fwid", "long"))
	{
		this.writeLog("\tПроведите перекодировку fwid-ов!", "No");
		return false;
	}
	this.writeLog("Ok");
	
	return true;
}

function DpConvertShtat_prepareModifyShtat()
{
	include ("Objects/DpDbMod.js");
	var dbMod =  new DpDbMod();
	
	var path = getPath("ZRP_MDB").toUpperCase();
	if (typeof path == "undefined")
	{
		this.writeLog("Не настроена база ZRP_MDB!", "No");
		return false;	
	}
	this.writeLog("Анализ таблицы " + path + ".ZRP_SHTAT");
	if (!IsTableEx("ZRP_MDB", "ZRP_SHTAT"))
	{
		this.writeLog("Отсутствует таблица " + path + ".ZRP_SHTAT", "No");
		return false;
	}
	//проверям наличие персонала, у которых поля Flv1,Flv2,Flv3,Flv4 не соответствуют подразделениям
	if (SUBD==MYSQL)
	{
		DropTable("shtat_temp");
		ExecuteSQL("SELECT * INTO shtat_temp FROM ^shtat");
		snap = getSnap("select count(*) from shtat_temp as s1 where fis_dol="+sqlTrue
				+" and not exists(select * from ^shtat as s2 where s2.fis_dol="+sqlFalse
				+" and s1.flv1=s2.flv1 and s1.flv2=s2.flv2 and s1.flv3=s2.flv3 and s2.flv4=s2.flv4)");
	}
	else
	{
		snap = getSnap("select count(*) from ^shtat as s1 where fis_dol="+sqlTrue
				+" and not exists(select * from ^shtat as s2 where s2.fis_dol="+sqlFalse
				+" and s1.flv1=s2.flv1 and s1.flv2=s2.flv2 and s1.flv3=s2.flv3 and s2.flv4=s2.flv4)");
	}
	if(snap[0]>0)
	{
		//исправления в телекомовских базах
		//если коды персонала (flv1,flv2,flv3,flv4) не соответсвуют подразделениям,
		//то поочерёдно обнуляем их начиная с flv4,
		//усли же не первом уровне нет подразделений соответствующих flv1,
		//тогда ищем не зактрытое подразделение с макисмальным кодом flv1 меньше текущего  
		this.writeLog("Найдено "+snap[0]+" записей персонала с кодами несоответствующими подразделениям!", "No");
		var i = 4;
		this.writeLog("Исправления кодов: ");
		while(snap[0]>0 && i>0)
		{
			this.writeLog("Модификация поля Flv"+i);
			if(i == 1)
			{
				if (SUBD==MYSQL || SUBD==MSSQL || SUBD == POSTGRE)
				{
					ExecuteSQL("update ^shtat set Flv1=(select max(s2.flv1) from shtat_temp as s2 where s2.fis_dol="+sqlFalse
							+" and ^shtat.flv1>s2.flv1 and ^shtat.flv2=s2.flv2 "
							+" and ^shtat.flv3=s2.flv3 and ^shtat.flv4=s2.flv4) "
						+" where fis_dol="+sqlTrue
							+" and not exists(select * from shtat_temp as s2 where s2.fis_dol="+sqlFalse
							+" and ^shtat.flv1=s2.flv1 and ^shtat.flv2=s2.flv2 "
							+" and ^shtat.flv3=s2.flv3 and ^shtat.flv4=s2.flv4)");
					DropTable("shtat_temp");
					ExecuteSQL("SELECT * INTO shtat_temp FROM ^shtat");
				}
				else
				{
					ExecuteSQL("update ^shtat as s1 set Flv1=(select max(s3.flv1) from ^shtat as s3 where s3.fis_dol="+sqlFalse
							+" and s1.flv1>s3.flv1 and s1.flv2=s3.flv2 "
							+" and s1.flv3=s3.flv3 and s1.flv4=s3.flv4) "
						+" where fis_dol="+sqlTrue
							+" and not exists(select * from ^shtat as s2 where s2.fis_dol="+sqlFalse
							+" and s1.flv1=s2.flv1 and s1.flv2=s2.flv2 and s1.flv3=s2.flv3 "
							+" and s2.flv4=s2.flv4)");
				}
				if (SUBD==MYSQL)
				{
					snap = getSnap("select count(*) from shtat_temp as s1 where fis_dol="+sqlTrue
						+" and not exists(select * from ^shtat as s2 where s2.fis_dol="+sqlFalse
						+" and s1.flv1=s2.flv1 and s1.flv2=s2.flv2 and s1.flv3=s2.flv3 and s2.flv4=s2.flv4)");
				}
				else
				{
					snap = getSnap("select count(*) from ^shtat as s1 where fis_dol="+sqlTrue
						+" and not exists(select * from ^shtat as s2 where s2.fis_dol="+sqlFalse
						+" and s1.flv1=s2.flv1 and s1.flv2=s2.flv2 and s1.flv3=s2.flv3 and s2.flv4=s2.flv4)");
				}
				//если ошибочных записей больше нет, тогда выходим из цикла, иначе эти записи попадут в корневое подразделение (0,0,0,0)
				if(snap[0]==0)
					break;
			}
			if (SUBD==MYSQL || SUBD==MSSQL || SUBD == POSTGRE)
			{
				ExecuteSQL("update ^shtat set Flv"+i+"=0 where fis_dol="+sqlTrue
					+" and not exists(select * from shtat_temp as s2 where s2.fis_dol="+sqlFalse
					+" and ^shtat.flv1=s2.flv1 and ^shtat.flv2=s2.flv2 "
					+" and ^shtat.flv3=s2.flv3 and ^shtat.flv4=s2.flv4)");
				DropTable("shtat_temp");
				ExecuteSQL("SELECT * INTO shtat_temp FROM ^shtat");
			}
			else
			{
				
				ExecuteSQL("update ^shtat as s1 set Flv"+i+"=0 where fis_dol="+sqlTrue
					+" and not exists(select * from ^shtat as s2 where s2.fis_dol="+sqlFalse
					+" and s1.flv1=s2.flv1 and s1.flv2=s2.flv2 and s1.flv3=s2.flv3 "
					+" and s2.flv4=s2.flv4)");
			}
			if (SUBD==MYSQL)
			{
				snap = getSnap("select count(*) from shtat_temp as s1 where fis_dol="+sqlTrue
					+" and not exists(select * from ^shtat as s2 where s2.fis_dol="+sqlFalse
					+" and s1.flv1=s2.flv1 and s1.flv2=s2.flv2 and s1.flv3=s2.flv3 and s2.flv4=s2.flv4)");
			}
			else
			{
				snap = getSnap("select count(*) from ^shtat as s1 where fis_dol="+sqlTrue
					+" and not exists(select * from ^shtat as s2 where s2.fis_dol="+sqlFalse
					+" and s1.flv1=s2.flv1 and s1.flv2=s2.flv2 and s1.flv3=s2.flv3 and s2.flv4=s2.flv4)");
			}
			i--;
		}
		this.writeLog("Исправления кодов окончено, кол-во некоректных записей после исправления: "+snap[0]);
	}
	this.writeLog("Ok");

	var path = getPath("CDR").toUpperCase();
	if (typeof path == "undefined")
	{
		this.writeLog("Не настроена база CDR!", "No");
		return false;	
	}
	
	this.writeLog("Анализ таблицы " + path + ".CDR_STRU_ORG");	
	
	if (!IsTableEx("CDR", "CDR_STRU_ORG"))
	{
		dbMod.CreateTable("CDR","CDR", "STRU_ORG")	;	
	}
	
	if (!IsTableEx("CDR", "CDR_STRU_ORG"))
	{
		this.writeLog("Отсутствует таблица " + path + ".CDR_STRU_ORG", "No");
		return false;
	}
	this.writeLog("Ok");
	
	this.writeLog("Анализ таблицы " + path + ".CDR_STRU_DOL");
	if (!IsTableEx("CDR", "CDR_STRU_DOL"))
	{
		dbMod.CreateTable("CDR","CDR", "STRU_DOL")	;	
	}
	
	if (!IsTableEx("CDR", "CDR_STRU_DOL"))
	{
		this.writeLog("Отсутствует таблица CDR_STRU_DOL", "No");
		return false;
	}
	this.writeLog("Ok");
	
	this.writeLog("Анализ таблицы " + path + ".CDR_WORK_PERS");
	
	if (!IsTableEx("CDR", "CDR_WORK_PERS"))
	{
		dbMod.CreateTable("CDR","CDR", "WORK_PERS")	;	
	}
	
	if (!IsTableEx("CDR", "CDR_WORK_PERS"))
	{
		this.writeLog("Отсутствует таблица " + path + ".CDR_WORK_PERS", "No");
		return false;
	}
	var tbl = OpenTable("m", "SELECT * FROM ^work_pers");
	if (tbl.IsEmpty())
	{
		tbl.close();
		if ("y" == msgBox("yn"
			, UR("Таблица персонала пустая! Произвести конвертацию таблицы ZRP_SHTAT?")
			, UR("Внимание!")))
		{
			this.modifyShat();
			buildTreeKeysOnTable("^stru_org", 0, 0, "flv1,flv2,flv3,flv4,flv5", "fwid_par");
			tbl = OpenTable("m", "SELECT * FROM ^work_pers");
			if (tbl.IsEmpty())
			{
				if ("n" == msgBox("yn"
				, UR("Таблица персонала пустая! Продолжить конвертирование?")
				, UR("Внимание!")))
				{
					tbl.close();
					return false;
				}
			}
		}
		else
			return false;
	}
	tbl.close();
	this.writeLog("Ok");
	return true;
}

function DpConvertShtat_differType(tableName, columnName, columnType)
{
	var strSQL = "SELECT " + columnName + " FROM " + tableName + " WHERE 1>1";
	var tbl = OpenTable("m", strSQL);
	var fieldInfo = tbl.getFieldInfo(columnName);
	tbl.close();
	if (fieldInfo != null)
		return String(fieldInfo.dpType) != String(columnType);	
	return true;	
}

function DpConvertShtat_getDpType(tableName, columnName)
{
	var strSQL = "SELECT " + columnName + " FROM " + tableName + " WHERE 1>1";
	var tbl = OpenTable("m", strSQL);
	var fieldInfo = tbl.getFieldInfo(columnName);
	tbl.close();
	if (fieldInfo != null)
		return String(fieldInfo.dpType);
	return null;
}

function DpConvertShtat_shtat()
{
	this.writeLog("Разбитие таблицы штата");
	var strSQL = "SELECT * FROM ^shtat ORDER BY fkod_dol, flv1, flv2, flv3, flv4";
	
	var tbl = OpenTable("s", strSQL);
	var allCount = tbl.getRecordCount();
	setProgressRange(0, allCount);
	setProgressText("Разбитие таблицы штата");
	
	var orgCount = 0;
	var allDolCount = 0;
	var allWpCount = 0;
	var dolCount = 0;
	var wpCount = 0;
		
	var l = 0;
	var org = new Object();
	var dol = new Object();
	var pers = new Object();
	var gS;
	if (!tbl.isEmpty())
	{
		tbl.MoveFirst();
		while(!tbl.isEOF())
		{
			if (tbl.getValue("fis_dol") == false)
			{
				org = new Object();
				dol = new Object();
				org.fwid = GetUID();
				dol.fwid_org = org.fwid;
				dol.fwid = GetUID();
				org.flv1 = tbl.getValue("flv1");
				org.flv2 = tbl.getValue("flv2");
				org.flv3 = tbl.getValue("flv3");
				org.flv4 = tbl.getValue("flv4");
				org.ftxt = tbl.getValue("fnam_levs");
				org.ftxts = tbl.getValue("fnam_levs");
				org.fbdat = tbl.getValue("fbdat");
				org.fedat = tbl.getValue("fedat");
				dol.fbdat = tbl.getValue("fbdat");
				dol.fedat = tbl.getValue("fedat");
				
				if (Number(tbl.getValue("flv1")) != 0)
				{	
					if (Number(tbl.getValue("flv2")) != 0)
					{					
						if (Number(tbl.getValue("flv3")) != 0)
						{
							if (Number(tbl.getValue("flv4")) != 0)
							{
								gS = getSnap("SELECT fwid FROM ^stru_org WHERE flv1=" + sqlTo(org.flv1)
							 							+ " AND flv2=" + sqlTo(org.flv2)
							 							+ " AND flv3=" + sqlTo(org.flv3)
							 							+ " AND flv4=0 "
							 							+ " AND Fedat=(SELECT MAX(Fedat) FROM ^stru_org WHERE flv1="+sqlTo(org.flv1)
							 									+ " AND flv2=" + sqlTo(org.flv2)
							 									+ " AND flv3=" + sqlTo(org.flv3)
							 									+ " AND flv4=0)");
							 	if (gS == null)
							 	{
									gS = getSnap("SELECT fwid FROM ^stru_org WHERE flv1=" + sqlTo(org.flv1)
							 							+ " AND flv2=" + sqlTo(org.flv2)
							 							+ " AND flv3=0"
							 							+ " AND flv4=0"
							 							+ " AND Fedat=(SELECT MAX(Fedat) FROM ^stru_org WHERE flv1="+sqlTo(org.flv1)
							 									+ " AND flv2=" + sqlTo(org.flv2)
							 									+ " AND flv3=0"
							 									+ " AND flv4=0)");
								 	//в телекомовских базах есть подразделения без нулевых flv, поэтому для них будем искать нулевой на одни уровень выше 
								 	if (gS == null)
								 	{
										gS = getSnap("SELECT fwid FROM ^stru_org WHERE flv1=" + sqlTo(org.flv1)
								 							+ " AND flv2=0"
								 							+ " AND flv3=0"
								 							+ " AND flv4=0"
								 							+ " AND Fedat=(SELECT MAX(Fedat) FROM ^stru_org WHERE flv1="+sqlTo(org.flv1)
							 									+ " AND flv2=0"
							 									+ " AND flv3=0"
							 									+ " AND flv4=0)");
								 	}
							 	}
							}
						 	else
						 	{
						 		 gS = getSnap("SELECT fwid FROM ^stru_org WHERE flv1=" + sqlTo(org.flv1)
							 							+ " AND flv2=" + sqlTo(org.flv2)
							 							+ " AND flv3=0"
							 							+ " AND Fedat=(SELECT MAX(Fedat) FROM ^stru_org WHERE flv1="+sqlTo(org.flv1)
							 									+ " AND flv2=" + sqlTo(org.flv2)
							 									+ " AND flv3=0)");
							 	//в телекомовских базах есть подразделения без нулевых flv, поэтому для них будем искать нулевой на одни уровень выше
							 	if (gS == null)
							 	{
							 		 gS = getSnap("SELECT fwid FROM ^stru_org WHERE flv1=" + sqlTo(org.flv1)
							 							+ " AND flv2=0"
							 							+ " AND flv3=0"
							 							+ " AND Fedat=(SELECT MAX(Fedat) FROM ^stru_org WHERE flv1="+sqlTo(org.flv1)
							 									+ " AND flv2=0"
							 									+ " AND flv3=0)");
							 	}
							}
						}
						else
						{
						 		gS = getSnap("SELECT fwid FROM ^stru_org WHERE flv1=" + sqlTo(org.flv1)
							 							+ " AND flv2=0"
							 							+ " AND Fedat=(SELECT MAX(Fedat) FROM ^stru_org WHERE flv1="+sqlTo(org.flv1)
							 									+ " AND flv2=0)");
						}
					}
					else
					{
							gS = getSnap("SELECT fwid FROM ^stru_org WHERE flv1=0");
					}
					if (gS != null)
						org.fwid_par = gS[0];
					else
						org.fwid_par = 0;
				}
				else
					org.fwid_par = 0;
										
				
				UpdateTable("^stru_org",org,true);
				UpdateTable("^stru_dol",dol,true);
				orgCount++;
				allDolCount++;
				dolCount++;
			}
			else
			{
				allDolCount++;
				allWpCount++;
				dol = new Object();
				pers = new Object();
				dol.fwid = GetUID();
				gS = getSnap("SELECT fwid FROM ^stru_org WHERE flv1=" + tbl.getValue("flv1")
											 + " AND flv2=" + tbl.getValue("flv2")
											 + " AND flv3=" + tbl.getValue("flv3")
											 + " AND flv4=" + tbl.getValue("flv4")
											 + " AND Fedat=(SELECT MAX(Fedat) FROM ^stru_org WHERE flv1="+tbl.getValue("flv1")
							 									+ " AND flv2=" + tbl.getValue("flv2")
							 									+ " AND flv3=" + tbl.getValue("flv3")
							 									+ " AND flv4=" + tbl.getValue("flv4") + ")");
				if (gS != null)
					dol.fwid_org = gS[0];
				dol.fcod = tbl.getValue("fkod_dol");
				gS = getSnap("SELECT fwid_cl FROM ^clrelclcl WHERE fcod=" + dol.fcod + " AND fcl=" + getPar("CODDOL"));
				var sIDDol;
				if (gS == null)
				{
					sIDDol = GetUID();
					var m = new Object();
					m.Fwid = sIDDol;
					m.Ftxt = "*"+tbl.getValue("Fnam_levs");
					UpdateTable("^cl", m, true);
					var n = new Object();
					n.Fwid_cl = sIDDol;
					n.Fcod = dol.fcod;
					n.Fcl = getPar("CODDOL");
					UpdateTable("^clrelclcl", n, true);
				}
				else
					sIDDol = gS[0];
				if (true)
				{
					dol.fwid_cl = sIDDol;
					dol.fbdat = tbl.getValue("fbdat");
					dol.fedat = tbl.getValue("fedat");
					dol.foklad = tbl.getValue("foklad");
					dol.fshpz = tbl.getValue("fshpz");
					
					pers.fwid = GetUID();
					pers.fwid_dol = dol.fwid;
					gS = getSnap("SELECT fwid_cl FROM ^clrelclcl WHERE fcod="
							+ tbl.getValue("ftabn") + " AND fcl=" + getPar("CODPERS"));
					var sIDPers;
					if (gS == null)
					{
						sIDPers = GetUID();
						var m = new Object();
						m.Fwid = sIDPers;
						m.Ftxt = "*"+tbl.getValue("Fnam_lev");
						UpdateTable("^cl", m, true);
						var n = new Object();
						n.Fwid_cl = sIDPers;
						n.Fcod = tbl.getValue("ftabn");
						n.Fcl = getPar("CODPERS");
						UpdateTable("^clrelclcl", n, true);
						var o = new Object();
						o.Fwid = GetUID();
						o.Fwid_cl = sIDPers;
						UpdateTable("^cl_homo", o, true)
					}
					else
						sIDPers = gS[0]
					if (true)
					{
						pers.fwid_cl = sIDPers;
						pers.fid = tbl.getValue("fid");
						pers.fbdat = tbl.getValue("fbdat");
						pers.fedat = tbl.getValue("fedat");
						pers.fvopl = tbl.getValue("fvopl");
						pers.favans = tbl.getValue("favans");
						pers.ftable = tbl.getValue("ftable");
						pers.fis_nazn = tbl.getValue("fis_nazn");
						pers.fis_serv = tbl.getValue("fis_serv");
						pers.fis_uv = tbl.getValue("fis_uv");
						pers.fkod_uv = tbl.getValue("fkod_uv");
						pers.finval = tbl.getValue("finval"); 
						pers.fnazn = allt(String(tbl.getValue("fnazn"))) == "+" ;
						gS = getSnap("SELECT fwid_cl FROM ^clrelclcl WHERE fcod="
									+ sqlTo(tbl.getValue("fkod_kat")) + " AND fcl=" + getPar("CODKAT"));						
						pers.fwid_kat = (gS != null ? gS[0] : 0);						
					
						UpdateTable("^stru_dol",dol,true);
						UpdateTable("^work_pers",pers,true);
						dolCount++;
						wpCount++;
					}
				}
			}
			tbl.MoveNext();
			setProgressPos(tbl.getAbsolute());
		}
	}
	setProgressPos(0);
	this.writeLog("Разбитие таблицы штата завершено");
	this.writeLog("\tОбработано записей " + allCount);
	this.writeLog("\tИз них занесено в таблицу организаций " + orgCount + " записи");
	this.writeLog("\tОбнаружено " + allDolCount + " записи должностей. Из них идентифицировано " + dolCount + " записи");
	this.writeLog("\tОбнаружено " + allWpCount + " записи сотрудников. Из них идентифицировано " + wpCount + " записи");
	tbl.close();	
	return true;
}

function DpConvertShtat_convertAll(rule)
{
	var hasFTABN_ID = this.hasStruField(rule.shortName, "ftabn_id");
	var hasFWID_WP = this.hasStruField(rule.shortName, "fwid_wp");
	trace ("convert "  + this.base + " -- " +  this.tableName + " -- " + rule.shortName);
	if (!hasFTABN_ID && !hasFWID_WP)
	{
		this.writeLog("\tОтсутствуют оба поля (ftabn_id, fwid_wp) в WinStru");
		return false;
	}
	
	if (hasFTABN_ID)
	{
		if (!hasField(this.base, this.tableName, "ftabn"))
		{
			this.writeLog("\tВ таблице отсутствует обязательное для обновления поле FTABN");
			return false;
		}
		if (hasField(this.base, this.tableName, "ftabn_id"))
			this.dropColumn(this.fullTableName, "ftabn_id");
		this.writeLog('\tCоздание нового поля ("ftabn_id")');
		if (!this.addColumn(this.fullTableName, "ftabn_id", SqlType("long")))
			return this.backUp("Не удалось создать поле ftabn_id");
		if(rule.isPrk4)
		{
			if (hasField(this.base, this.tableName, "ftabn_id2"))
				this.dropColumn(this.fullTableName, "ftabn_id2");
			this.writeLog('\tCоздание нового поля ("ftabn_id2")');
			if (!this.addColumn(this.fullTableName, "ftabn_id2", SqlType("long")))
				return this.backUp("Не удалось создать поле ftabn_id2");
		}
		this.writeLog("\tOk");

		this.writeLog('\tОбновление нового поля ("ftabn_id")');
		
		if (SUBD == MSSQL || SUBD == POSTGRE)
		{
			if (!ExecuteSQL("UPDATE " + this.fullTableName + " SET ftabn_id = "
				+ " (SELECT MAX(rcl.fwid_cl) FROM ^clrelclcl AS rcl WHERE " + this.fullTableName + ".ftabn = rcl.fcod AND rcl.fcl = "
				+ getPar("CODPERS") +")", false))
			return this.backUp("Не удалось обновить поле ftabn_id");
		}
		else
		{
		
			if (!ExecuteSQL("UPDATE " + this.fullTableName + " AS wt SET wt.ftabn_id = "
				+ " (SELECT MAX(rcl.fwid_cl) FROM ^clrelclcl AS rcl WHERE wt.ftabn = rcl.fcod AND rcl.fcl = "
				+ getPar("CODPERS") +")", false))
			return this.backUp("Не удалось обновить поле ftabn_id");
		}
		if(rule.isPrk4)
		{
			if (SUBD == MSSQL || SUBD == POSTGRE)
			{
				if (!ExecuteSQL("UPDATE " + this.fullTableName + " SET ftabn_id2 = "
					+ " (SELECT MAX(rcl.fwid_cl) FROM ^clrelclcl AS rcl WHERE " + this.fullTableName + ".ftabn2 = rcl.fcod AND rcl.fcl = "
					+ getPar("CODPERS") +")", false))
				return this.backUp("Не удалось обновить поле ftabn_id");
			}
			else
			{
				if (!ExecuteSQL("UPDATE " + this.fullTableName + " AS wt SET wt.ftabn_id2 = "
					+ " (SELECT MAX(rcl.fwid_cl) FROM ^clrelclcl AS rcl WHERE wt.ftabn2 = rcl.fcod AND rcl.fcl = "
					+ getPar("CODPERS") +")", false))
				return this.backUp("Не удалось обновить поле ftabn_id");
			}
		}
		this.writeLog("\tOk");
	}
	
	if (hasFWID_WP)
	{
		if (rule.from != "WP")
		{
			if (!hasField(this.base, this.tableName, "fsht_id"))
			{
				this.writeLog("\tВ таблице отсутствует обязательное для обновления поле FSHT_ID");
				return false;
			}	
			else
			{
				this.writeLog('\tCоздание нового поля ("fwid_wp")');
				if (!this.addColumn(this.fullTableName, "fwid_wp", SqlType("long")))
					return this.backUp("Не удалось создать поле fwid_wp");
				this.writeLog("\tOk");
				
				this.writeLog('\tОбновление нового поля ("fwid_wp")');
				

				if (SUBD == MSSQL || SUBD == POSTGRE)
				{
					if (!ExecuteSQL("UPDATE " + this.fullTableName + " SET fwid_wp="
						+ "(SELECT MAX(wp.fwid) FROM ^work_pers AS wp, ^clrelclcl AS rcl "
						+ " WHERE wp.fwid_cl=rcl.fwid_cl AND rcl.fcod="+ this.fullTableName + ".ftabn "
							+" AND (wp.fid="+ this.fullTableName + ".fsht_id OR "+ this.fullTableName + ".fsht_id=0))",false))
						return this.backUp("Не удалось обновить поле fwid_wp");					
				}
				else
				{
					if (!ExecuteSQL("UPDATE " + this.fullTableName + " AS wt SET wt.fwid_wp="
						+ "(SELECT MAX(wp.fwid) FROM ^work_pers AS wp, ^clrelclcl AS rcl "
						+ " WHERE wp.fwid_cl=rcl.fwid_cl AND rcl.fcod=wt.ftabn"
							+" AND (wp.fid=wt.fsht_id OR wt.fsht_id=0))",false))
						return this.backUp("Не удалось обновить поле fwid_wp");
				}
				this.writeLog("\tOk");
			}
		}
		else
		{
			var isFsht_id = false
			if (hasField(this.base, this.tableName, "fsht_id"))
				isFsht_id = true;
			this.writeLog("\tCоздание временной таблицы");
			if (!this.createTmpTable(this.tmpTableName,rule.isPrk4))
				return this.backUp("Не удалось создать временную таблицу");
			this.writeLog("\tOk");
			
			var bdat = this.executeRule(rule, "bdat");
			var edat = this.executeRule(rule, "edat");
		
			if (typeof bdat == "undefined" || typeof edat == "undefined")
				return this.backUp("Неккоректное правило для модификации");
		
			this.writeLog("\tЗаполнение временной таблицы");	
			
			//для приказа "Доплата в % от оклада другого сотрудника" в PRK4 добавлем табельный номер второго сотрудника
			if(rule.isPrk4)
			{
				if (!ExecuteSQL("INSERT INTO " + this.tmpTableName + " (ftabn, fbdat, fedat, fid, ftabn2, fid2) "
							+ " SELECT DISTINCT wt.ftabn AS ftabn, " + bdat + " AS fbdat, "
							+ edat + " AS fedat, wt.fsht_id AS fid, wt.ftabn2 AS ftabn2, wt.fsht_id2 AS fsht_id2 FROM " + this.fullTableName + " AS wt",false))
						return this.backUp("Не удалось заполнить временную таблицу");
			}
			else
			{
				if (isFsht_id)
				{
					if (!ExecuteSQL("INSERT INTO " + this.tmpTableName + " (ftabn, fbdat, fedat, fid) "
							+ " SELECT DISTINCT wt.ftabn AS ftabn, " + bdat + " AS fbdat, "
							+ edat + " AS fedat, wt.fsht_id AS fid FROM " + this.fullTableName + " AS wt",false))
						return this.backUp("Не удалось заполнить временную таблицу");
				}
				else
				{
					if (!ExecuteSQL("INSERT INTO " + this.tmpTableName + " (ftabn, fbdat, fedat) "
							+ " SELECT DISTINCT wt.ftabn AS ftabn, " + bdat + " AS fbdat, "
							+ edat + " AS fedat FROM " + this.fullTableName + " AS wt",false))
						return this.backUp("Не удалось заполнить временную таблицу");
				}
			}
		
			var addSQL = "";
			if (typeof rule.addsql == "undefined")
			{
					if (SUBD == MSSQL || SUBD == POSTGRE)
					{
						addSQL = " AND ((alltbn.fbdat<=" + this.tmpTableName + ".fbdat AND alltbn.fedat>=" + this.tmpTableName + ".fedat)"
							+ " OR (alltbn.fbdat>=" + this.tmpTableName + ".fbdat AND alltbn.fbdat<=" + this.tmpTableName + ".fedat)"
							+ " OR (alltbn.fedat>=" + this.tmpTableName + ".fbdat AND alltbn.fedat<=" + this.tmpTableName + ".fedat))";	
					}
					else
					{
					addSQL = " AND ((alltbn.fbdat<=tmp.fbdat AND alltbn.fedat>=tmp.fedat)"
							+ " OR (alltbn.fbdat>=tmp.fbdat AND alltbn.fbdat<=tmp.fedat)"
							+ " OR (alltbn.fedat>=tmp.fbdat AND alltbn.fedat<=tmp.fedat))";	
					}
			}			
			else
				addSQL = String(rule[String(rule.addsql)]);
			
			var addStrSQL = "";
			
			if(rule.isPrk4)
			{
				if (SUBD == MSSQL || SUBD == POSTGRE)
				{
					addStrSQL = " AND (alltbn.fid=" + this.tmpTableName + ".fid OR alltbn.fid=0) ";
					addStrSQL2 = " AND (alltbn.fid=" + this.tmpTableName + ".fid2 OR " + this.tmpTableName + ".fid2=0) ";
					ExecuteSQL("UPDATE " + this.tmpTableName + " SET fwid_wp=(SELECT MAX(alltbn.fwid_wp)" 
							+ " FROM " + this.allTabnTable + " AS alltbn WHERE alltbn.ftabn=" 
										+ this.tmpTableName + ".ftabn "+addStrSQL+ addSQL + "),"
								+" fwid_wp2=(SELECT MAX(alltbn.fwid_wp)" 
							+ " FROM " + this.allTabnTable + " AS alltbn WHERE alltbn.ftabn=" 
										+ this.tmpTableName + ".ftabn2 "+addStrSQL2+ addSQL + ")",false);	
				}
				else
				{
					addStrSQL = " AND (tmp.fid=alltbn.fid OR tmp.fid=0) ";
					addStrSQL2 = " AND (tmp.fid2=alltbn.fid OR tmp.fid2=0) ";
					ExecuteSQL("UPDATE " + this.tmpTableName + " AS tmp SET tmp.fwid_wp=(SELECT MAX(alltbn.fwid_wp)" 
							+ " FROM " + this.allTabnTable + " AS alltbn WHERE alltbn.ftabn=tmp.ftabn " 
										+ addStrSQL + addSQL + "),"
								+" fwid_wp2=(SELECT MAX(alltbn.fwid_wp)" 
							+ " FROM " + this.allTabnTable + " AS alltbn WHERE alltbn.ftabn=tmp.ftabn2 " 
										+ addStrSQL2 + addSQL + ")",false);
				}
			}
			else
			{
				if (SUBD == MSSQL || SUBD == POSTGRE)
				{
					if (isFsht_id)
						addStrSQL = " AND (alltbn.fid=" + this.tmpTableName + ".fid OR " + this.tmpTableName + ".fid=0) ";
					ExecuteSQL("UPDATE " + this.tmpTableName + " SET fwid_wp=(SELECT MAX(alltbn.fwid_wp)" 
							+ " FROM " + this.allTabnTable + " AS alltbn WHERE alltbn.ftabn=" 
										+ this.tmpTableName + ".ftabn "+addStrSQL+ addSQL + ")",false);	
				}
				else
				{
					if (isFsht_id)
						addStrSQL = " AND (tmp.fid=alltbn.fid OR tmp.fid=0) ";
					ExecuteSQL("UPDATE " + this.tmpTableName + " AS tmp SET tmp.fwid_wp=(SELECT MAX(alltbn.fwid_wp)" 
							+ " FROM " + this.allTabnTable + " AS alltbn WHERE alltbn.ftabn=tmp.ftabn " 
										+ addStrSQL + addSQL + ")",false);
				}
			}
			
			this.writeLog("\tOk");
			
			this.writeLog('\tCоздание нового поля ("fwid_wp")');	
			if (!this.addColumn(this.fullTableName, "fwid_wp", SqlType("long")))
				return this.backUp("Не удалось создать поле fwid_wp");
			if(rule.isPrk4)
			{
				this.writeLog('\tCоздание нового поля ("fwid_wp2")');	
				if (!this.addColumn(this.fullTableName, "fwid_wp2", SqlType("long")))
					return this.backUp("Не удалось создать поле fwid_wp2");
			}
			this.writeLog("\tOk");	
			
			this.writeLog('\tОбновление нового поля ("fwid_wp")');
			var strSQL = "";
			if (SUBD == MSSQL || SUBD == POSTGRE)
			{
				strSQL = "UPDATE " + this.fullTableName + " SET fwid_wp="
						+ "(SELECT MAX(tmp.fwid_wp) FROM " + this.tmpTableName + " AS tmp WHERE tmp.ftabn=" + this.fullTableName + ".ftabn"
						+ " AND tmp.fbdat=" + bdat + " AND tmp.fedat=" + edat + ")"
				strSQL = strSQL.replace(/wt./g, this.fullTableName+".");
				if (!ExecuteSQL(strSQL,false))
					return this.backUp("Не удалось обновить поле fwid_wp");
			}
			else
			{	
				if (!ExecuteSQL("UPDATE " + this.fullTableName + " AS wt SET wt.fwid_wp="
						+ "(SELECT MAX(tmp.fwid_wp) FROM " + this.tmpTableName + " AS tmp WHERE tmp.ftabn=wt.ftabn"
						+ " AND tmp.fbdat=" + bdat + " AND tmp.fedat=" + edat + ")",false))
					return this.backUp("Не удалось обновить поле fwid_wp");
			}
			if(rule.isPrk4)
			{
				if (SUBD == MSSQL || SUBD == POSTGRE)
				{
					strSQL = "UPDATE " + this.fullTableName + " SET fwid_wp2="
							+ "(SELECT MAX(tmp.fwid_wp2) FROM " + this.tmpTableName + " AS tmp WHERE tmp.ftabn2=" + this.fullTableName + ".ftabn2"
							+ " AND tmp.fbdat=" + bdat + " AND tmp.fedat=" + edat + ")"
					strSQL = strSQL.replace(/wt./g, this.fullTableName+".");
					if (!ExecuteSQL(strSQL,false))
						return this.backUp("Не удалось обновить поле fwid_wp2");
				}
				else
				{	
					if (!ExecuteSQL("UPDATE " + this.fullTableName + " AS wt SET wt.fwid_wp2="
							+ "(SELECT MAX(tmp.fwid_wp2) FROM " + this.tmpTableName + " AS tmp WHERE tmp.ftabn2=wt.ftabn2"
							+ " AND tmp.fbdat=" + bdat + " AND tmp.fedat=" + edat + ")",false))
						return this.backUp("Не удалось обновить поле fwid_wp2");
				}
			}
			//если в 2000-й версии после изменения должности в штатном расписании
			//создали записи в приказах, коды ШР в которых не соответсвуют по временным
			//промежуткам коду из самого штатного расписания, то fwid_wp не проапдейтится,
			//поэтому записываем в дефектную ведомость записи с нулевым fwid_wp,
			//а потом обновляем fwid_wp с учётом правильного кода ШР
			this.writeLog('\tКопирование записей с пустым полем "fwid_wp" в дефектную ведомость');
			if(!IsTableEx("ZRP_MDB", "ZRP_DEFVEDPRIK"))
				CreateTableEx("ZRP_MDB","ZRP_DEFVEDPRIK","DEFVEDPRIK","*");
			var strErr = "несоответсвие кода ШР в приказе коду из штатного расписания"
			if(isFsht_id)
			{
				if(!ExecuteSQL("INSERT INTO ^DEFVEDPRIK(Fdate,Ftxt,Fvid_prk,Fin_table,Fbdat,Fedat,Fsum,Ftabn,Fsht_id)"
							+" (SELECT "+sqlTo(new Date())+" AS Fdate, "+sqlTo(strErr)+" AS Ftxt, Fvid_prk, "
							+ sqlTo(this.tableName)+" AS Fin_table, Fbdat, Fedat, Fsum, Ftabn, Fsht_id "
							+" FROM "+this.fullTableName+" WHERE Fwid_wp IS NULL)",false))
					this.writeLog("\tWARNING: Не удалось скопировать записи с непроставленными fwid_wp в дефектную ведомость");
			}
			else
			{
				if(!ExecuteSQL("INSERT INTO ^DEFVEDPRIK(Fdate,Ftxt,Fvid_prk,Fin_table,Fbdat,Fedat,Fsum,Ftabn)"
							+" (SELECT "+sqlTo(new Date())+" AS Fdate, "+sqlTo(strErr)+" AS Ftxt, Fvid_prk, "
							+ sqlTo(this.tableName)+" AS Fin_table, Fbdat, Fedat, Fsum, Ftabn "
							+" FROM "+this.fullTableName+" WHERE Fwid_wp IS NULL)",false))
					this.writeLog("\tWARNING: Не удалось скопировать записи с непроставленными fwid_wp в дефектную ведомость");
			}
			if(isFsht_id)
			{
				if (SUBD == MSSQL || SUBD == POSTGRE)
				{
					addSQL = " AND ((alltbn.fbdat<=" + this.fullTableName + ".fbdat AND alltbn.fedat>=" + this.fullTableName + ".fedat)"
						+ " OR (alltbn.fbdat>=" + this.fullTableName + ".fbdat AND alltbn.fbdat<=" + this.fullTableName + ".fedat)"
						+ " OR (alltbn.fedat>=" + this.fullTableName + ".fbdat AND alltbn.fedat<=" + this.fullTableName + ".fedat))";	
				}
				else
				{
					addSQL = " AND ((alltbn.fbdat<=tbl.fbdat AND alltbn.fedat>=tbl.fedat)"
						+ " OR (alltbn.fbdat>=tbl.fbdat AND alltbn.fbdat<=tbl.fedat)"
						+ " OR (alltbn.fedat>=tbl.fbdat AND alltbn.fedat<=tbl.fedat))";	
				}
				this.writeLog('\tОбновление дефектных "fwid_wp" с учётом правильного кода ШР');
				if (SUBD == MSSQL || SUBD == POSTGRE)
				{
					if(!ExecuteSQL("UPDATE " + this.fullTableName + " SET fwid_wp=(SELECT MAX(fwid_wp)" 
						+" FROM "+this.allTabnTable+" AS alltbn WHERE alltbn.ftabn=" 
									+this.fullTableName+".ftabn "+addSQL+") "
						+" WHERE fwid_wp IS NULL",false))
						this.writeLog("\tWARNING: Не удалось обновить дефектные 'fwid_wp'");
				}
				else
				{
					if(!ExecuteSQL("UPDATE "+this.fullTableName+" AS tbl SET fwid_wp=(SELECT MAX(fwid_wp)" 
						+" FROM "+this.allTabnTable+" AS alltbn WHERE alltbn.ftabn=tbl.ftabn "+addSQL+") "
						+" WHERE fwid_wp IS NULL",false))
						this.writeLog("\tWARNING: Не удалось обновить дефектные 'fwid_wp'");
				}
				if(rule.isPrk4)
				{
					this.writeLog('\tОбновление дефектных "fwid_wp2" с учётом правильного кода ШР');
					if (SUBD == MSSQL || SUBD == POSTGRE)
					{
						if(!ExecuteSQL("UPDATE " + this.fullTableName + " SET fwid_wp2=(SELECT MAX(fwid_wp)" 
							+" FROM "+this.allTabnTable+" AS alltbn WHERE alltbn.ftabn=" 
										+this.fullTableName+".ftabn2 "+addSQL+") "
							+" WHERE (NOT ftabn2 IS NULL) AND ftabn2<>0 AND fwid_wp2 IS NULL",false))
							this.writeLog("\tWARNING: Не удалось обновить дефектные 'fwid_wp2'");
					}
					else
					{
						if(!ExecuteSQL("UPDATE "+this.fullTableName+" AS tbl SET fwid_wp2=(SELECT MAX(fwid_wp)" 
							+" FROM "+this.allTabnTable+" AS alltbn WHERE alltbn.ftabn=tbl.ftabn2 "+addSQL+") "
							+" WHERE (NOT ftabn2 IS NULL) AND ftabn2<>0 AND fwid_wp2 IS NULL",false))
							this.writeLog("\tWARNING: Не удалось обновить дефектные 'fwid_wp2'");
					}
				}
			}
			this.writeLog("\tOk");	
			
			if (typeof rule.insert != "undefined")
			{				
				if (!this.insertNewFields(this.fullTableName, rule.insert, bdat, edat))
					return this.backUp("Не удалось модифицировать таблицу");
			}
		}
	}
	this.endConvertTable(hasFTABN_ID, hasFWID_WP, rule);	
	return true;
}

function DpConvertShtat_endConvertTable(hasFtabn_id, hasFwid_wp, rule)
{
	var IS_NOT_NULL = "";
	var IS_NULL = "";
	if (hasFtabn_id && hasFwid_wp)
	{
		IS_NOT_NULL = " ftabn_id IS NOT NULL OR fwid_wp IS NOT NULL";
		IS_NULL = " ftabn_id IS NULL AND fwid_wp IS NULL";
	}
	else if (hasFtabn_id)
	{
		IS_NOT_NULL = " ftabn_id IS NOT NULL";
		IS_NULL = " ftabn_id IS NULL";	
	}
	else
	{
		IS_NOT_NULL = " fwid_wp IS NOT NULL";
		IS_NULL = " fwid_wp IS NULL";	
	}
	
	var allCount = getSnap("SELECT COUNT(*) FROM " + this.fullTableName)[0];
	var nnCount = getSnap("SELECT COUNT(*) FROM " + this.fullTableName + " WHERE " + IS_NOT_NULL)[0];
	
	this.allRecord += allCount;
	this.indRecord += nnCount;
	
	this.writeLog("\tИдентифицировано " + nnCount + " записей из " + allCount);	
	if (nnCount < allCount)
	{
		var nullTbl = 
			OpenTable("m", "SELECT DISTINCT ftabn FROM " + this.fullTableName + " WHERE " + IS_NULL);
		var tmpStr = "";
		for (nullTbl.MoveFirst(); !nullTbl.IsEOF(); nullTbl.MoveNext())
			if (tmpStr == "")
				tmpStr += String(nullTbl.getValue("ftabn"));
			else
				tmpStr += ", " + String(nullTbl.getValue("ftabn"));
		nullTbl.close();
		this.writeLog("\tНе идентифицированы таб.ном.: " + tmpStr);			
	}	

	this.writeLog('\tОчистка таблицы от неопределенностей');	
	ExecuteSQL("DELETE FROM " + this.fullTableName + " WHERE " + IS_NULL,false);	
	this.writeLog("\tOk");	
	

	if (typeof rule.refield == "string")
		this.renameField(this.fullTableName, rule.refield);
	
	if (rule.rename)
		this.renameTable(this.fullTableName);
}

function DpConvertShtat_insertNewFields(tblName, strFields, bdat, edat)
{
	var arrFields = String(strFields).split(",");
	var result = true;
	for (var i in arrFields)
	{
		var field = String(allt(arrFields[i]));
		var res = false;
		var dpType = this.getDpType(this.tmpTableName, field);
		if (typeof dpType != "undefined")
		{
			this.writeLog('\tCоздание поля ("' + field + '")');
			if (!this.addColumn(tblName, field, SqlType(dpType)))
				this.writeLog("\tНе удалось создать поле " + field);
			else
			{
				this.writeLog("\tOk");
				this.writeLog('\tОбновление поля ("' + field + '")');
				
				var sSQL = "UPDATE " + tblName + " AS wt SET wt." + field + "="
					+ "(SELECT tmp." + field + " FROM " + this.tmpTableName + " AS tmp WHERE tmp.ftabn=wt.ftabn"
					+ " AND tmp.fbdat=" + bdat + " AND tmp.fedat=" + edat + ")";
				
				if (SUBD == MSSQL || SUBD == POSTGRE)
				{
					var sSQL = "UPDATE " + tblName + " SET " + field + "="
					+ "(SELECT tmp." + field + " FROM " + this.tmpTableName + " AS tmp WHERE tmp.ftabn=" + tblName + ".ftabn"
					+ " AND tmp.fbdat=" + bdat + " AND tmp.fedat=" + edat + ")";
					sSQL = sSQL.replace(/wt./g, tblName+".");
				}
				
				if (!ExecuteSQL(sSQL))
					this.writeLog("\tНе удалось обновить поле " + field);
				else
				{
					res = true;
					this.writeLog("\tOk");
				}
			}						
		}	
		result = result && res;
	}
	return result;
}

function DpConvertShtat_hasStruField(tableName, fieldName)
{
	if (tableName.indexOf("_") == -1 || (tableName.indexOf("_") == tableName.length - 1))
		return false;
	var shortTableName = allt(tableName.substring(tableName.indexOf("_") + 1)).toUpperCase();
	var struFields = getStruFields(shortTableName);
	for (var i in struFields)
		if (String(struFields[i].name).toUpperCase() == String(fieldName).toUpperCase())
			return true;
	return false;
}

function DpConvertShtat_getListModifyTables(sBase)
{	
	var result = new Array();
	var tbls = getTables(sBase);
	var m = -1;
	var l = 0;	
	buildMProgress(1);
	setMProgressRange("p0", 0, tbls.length);
	setMProgressText("p0", "База: " + getPath(sBase) + "\n" +
			UR("Отримання списку таблиць для модифікування...|Получение списка таблиц для модифицирования..."));
	runMProgress();	
	for (var i in tbls)
	{
		var fields = getTableFields(sBase, tbls[i]);
		var flagModify = false;
		var splitFields = fields.split(",");		
		for (var j in splitFields)
		{
			var field = allt(splitFields[j]).toLowerCase();
			if (field == "fwid_wp" || field == "ftabn_id")
			{
				flagModify = false;
				break;
			}					
			if (field == "ftabn")
			{
				flagModify = true;
				continue;
			}
		}
		if (flagModify)
			result[++m] = tbls[i];	
		setMProgressPos("p0", ++l);
	}
	stopMProgress();
	return result;
}

function DpConvertShtat_runModifyBase(objBase)
{
	this.writeLog("МОДИФИКАЦИЯ БАЗЫ " + objBase.pathBase + "\r\n\r\n");
	if (this.arrRules == null)
		this.loadRulesForTables();
	
	this.allTabnTable = getTmpTableName();
	
	this.writeLog("Создание временной таблицы");
	if (!this.createTmpTable(this.allTabnTable))
	{
		this.writeLog("Не удалось создать временную таблицу");
		return;
	}
	this.writeLog("Ok");
	this.writeLog("Заполнение временной таблицы");
	if (!ExecuteSQL("INSERT INTO " + this.allTabnTable + "(fwid_wp, ftabn, fbdat, fedat, fid)"
			+ " SELECT DISTINCT wp.fwid AS fwid_wp, clr.fcod AS ftabn,"
			+ " wp.fbdat AS fbdat, wp.fedat AS fedat, wp.fid AS fid"
			+ " FROM ^work_pers AS wp, ^clrelclcl AS clr"
			+ " WHERE wp.fwid_cl=clr.fwid_cl AND clr.fcl=" + getPar("CODPERS")))
	{
		this.writeLog("Не удалось заполнить временную таблицу");
		DropTable(this.allTabnTable);
		return;
	}
	this.writeLog("Ok");
	
	this.allRecord = 0;
	this.indRecord = 0;
	this.countModTables = 0;	
	this.base = objBase.pathBase;
	
	if (objBase.listTables)
	{
		for (var i in objBase.listTables)
		{			
			var modify = false;
			
			this.tableName = String(objBase.listTables[i]).toUpperCase();
			this.fullTableName = this.getFullTableName(this.base, this.tableName);
			this.backUpTbl = this.getFullTableName(this.base, "OLD_" + this.tableName);
			//this.createBackUpTable(this.backUpTbl, this.fullTableName);
			
			
			this.writeLog("Модификация таблицы : " + this.fullTableName, ++this.pos);		
			var rule = this.getRuleForTable(this.tableName);						
			if (rule != null)
			try
			{
				modify = this.convertAll(rule);
			}
			catch(x)
			{
				this.writeLog("ERROR: " + x.rhinoException.getLocalizedMessage());
				modify = false;
			}
			else
				this.writeLog("\tНет правила для модифицирования");
			if (modify)
				++this.countModTables;
			if (modify == true)
			{
				++this.countModTables;
				this.writeLog("\tМодификация таблицы завершена");				
			}
			else
				this.writeLog("\tТаблица не отмодифицирована");
		}
	}	
	DropTable(this.allTabnTable);
	//обновляем коректный Fwid_wp в табелях после перекодировки
	this.modifyTabels();
		
	this.writeLog("\r\n\r\nВсего таблиц: " + objBase.listTables.length);
	this.writeLog("Модифицировано таблиц: " + this.countModTables);
	this.writeLog("Обнаружено записей: " + this.allRecord);
	this.writeLog("Идентифицировано записей: " + this.indRecord);
	this.writeLog("Итог: " + (this.allRecord == 0 ? "100" : this.indRecord/this.allRecord) + "%");
	this.writeLog("\r\n\r\nМОДИФИКАЦИЯ БАЗЫ " + objBase.pathBase + " ЗАВЕРШЕНА\r\n\r\n");
}

function DpConvertShtat_backUp(error)
{
	this.writeLog("\t" + error);
	if (!ExecuteSQL("DROP TABLE " + this.fullTableName,false))
	{
		this.writeLog("\tFATAL ERROR: DROP " + this.fullTableName + " (BACKUP)");
		return false;
	}
	if (!ExecuteSQL("SELECT * INTO " + this.fullTableName + " FROM " + this.backUpTbl))
	{
		this.writeLog("\tFATAL ERROR: BACKUP TABLE " + this.fullTableName + " (BACKUP)");
		return false;
	}
	if (!ExecuteSQL("DROP TABLE " + this.backUpTbl,false))
	{
		this.writeLog("\tERROR: DROP BACKUP TABLE: " + this.backUpTbl + " (BACKUP)");
		return false;		
	}	
	return false;
}

function DpConvertShtat_createBackUpTable(backUpTableName, tableName)
{
	this.writeLog("\tCоздание таблицы отката ");	
	DropTable(backUpTableName);
	if (!ExecuteSQL("SELECT * INTO " + backUpTableName + " FROM " + tableName,false))
	{
		this.writeLog("\tНе удалось создать таблицу отката");
		return false;
	}
	this.writeLog("\tOk");	
	return true;
}

function DpConvertShtat_addColumn(table, column, typeColumn)
{
	var strSQL = "ALTER TABLE " + table + " ADD ";
	if (SUBD != ORACLE)
		strSQL += "COLUMN ";	
	strSQL += column + " " + typeColumn;
	return ExecuteSQL(strSQL,false);
}

function DpConvertShtat_dropColumn(table, column)
{
	if (SUBD == MSSQL)
	{
		mssqlDropDefaultForField(table, column);
	}
	var strSQL = "ALTER TABLE " + table + " DROP COLUMN " + column;
	return ExecuteSQL(strSQL,false);
}

function DpConvertShtat_getFullTableName(base, table)
{
	return String(base + (SUBD == MSSQL ? ".." : ".") + table).toUpperCase();
}

/*
*
*
*
	Ниже - получение правил для конвертации таблиц
	А также функции для работы с правилами
*
*
*/

function DpConvertShtat_loadRulesForTables()
{
	this.arrRules = this.getRulesForTables();
}

function DpConvertShtat_getRuleForTable(tblName)
{	
	var result = null;
	var tbl = null;	
	var shortName = tblName;
	if (this.arrRules[tblName] != null)	
		tbl = this.arrRules[tblName];
	 for (var i in this.arrRules)
	 	if (tblName.indexOf(String(i)) == 0 && typeof this.arrRules[i].pattern != "undefined")
	 	{
	 		var length = this.arrRules[i].pattern.length;
	 		var tmp0 = tblName.substring(tblName.length - length);
	 		if (String(i + tmp0) == tblName)
	 		{	 		
	 			tbl = this.arrRules[i];
	 			
	 			for (fstInd=shortName.length-1; fstInd>0; fstInd--)
					if(!Number(shortName[fstInd]) && Number(shortName[fstInd])!=0)
						break;	
				shortName = shortName.substring(0,fstInd+1) + "%LD";
	 		} 		
	 	}
	if (tbl != null)
	{
		result = tbl.rule;
		if (typeof result == "undefined")
			result = new Object();
		if (typeof tbl.rename != "undefined" && tbl.rename == "true")
			result.rename = true;
		else
			result.rename = false;
		if (typeof tbl.from != "undefined")
			result.from = String(tbl.from);
		else
			result.from = "WP";
		if (typeof tbl.renamefield != "undefined")
			result.refield = String(tbl.renamefield);
		result.shortName = shortName;
		if(shortName=="ZRP_PRK4")
			result.isPrk4 = true;
		else
			result.isPrk4 = false;
	}
	return result;
}

function DpConvertShtat_getRulesForTables()
{
	include ("Objects/DpXMLDomDocument.js");
	var xml = new DpXMLDOMDocument();
	var result = new Array();
	var rules = new Object();
	if (xml.load(rootDirectory() + "convert_zrp.xml"))
	{
		var xmlEl = xml.getDocumentElement();
		var rulesNode = xmlEl.selectSingleNode("rules");
		if (rulesNode != null)
		{
			var ruleNodes = rulesNode.getChildNodes();
			if (ruleNodes != null)
			{	
				for (var i in ruleNodes)
				{
					var name = ruleNodes[i].getNodeName().toUpperCase();
					rules[name] = new Object();
					var attributes = ruleNodes[i].getAttributes();
					for (var j in attributes)
					{
						rules[name][attributes[j].getName().toLowerCase()] =
												String(attributes[j].getValue());
					}
				}
			}
		}
		var tablesNode = xmlEl.selectSingleNode("tables");
		if (tablesNode != null)
		{
			var sysNodes = tablesNode.getChildNodes();
			if (sysNodes != null)
			{
				for (var i in sysNodes)
				{
					var sys = sysNodes[i].getNodeName().toUpperCase();
					var sysTables = sysNodes[i].getChildNodes();
					if (sysTables != null)
					{
						for (var j in sysTables)
						{
							var attributes = sysTables[j].getAttributes();
							var table = new Object();
							for (var l in attributes)
								table[attributes[l].getName()] = String(attributes[l].getValue());
							if (typeof table["rule"] != "undefined")							
								table["rule"] = rules[table["rule"]];
							result[sys + "_" + sysTables[j].getNodeName()] = table;																				
						}					
					}				
				}
			}		
		}					
	}
	return result;
}

function DpConvertShtat_executeRule(rule, dat)
{	
	var tblName = String(this.tableName);
	if (typeof rule["include"] != "undefined")
	{
		var split = rule["include"].split(",");
		for (var i in split)
			include(allt(split[i]));
	}
	var result = null;
	var execute = rule[dat];
	if (typeof execute == "undefined")
		return null;
	var tmp = allt(execute.substring(0, execute.indexOf("(")));	
	if ((execute.indexOf("(") != -1) && (tmp != ""))
	{
		var nameFunc = tmp;
		if (nameFunc.indexOf(".") == -1) // this is function
		{
			var arguments = this.getArguments(execute);
			var tmpObj = new Object(); 
			for (var i in arguments)
				tmpObj["arg" + i] = this.eval(allt(arguments[i]), rule);
			result = eval(String(nameFunc + "(" + this.getStrFromArr(tmpObj, ",", "tmpObj.") + ")"));
		} 
		else // no function
			result = this.eval(execute, rule);
	}
	else // no function
		result = this.eval(execute, rule);

	if (result != null && (typeof result != "string"))
		return sqlTo(result);
	return result;
}

function DpConvertShtat_eval(execute, rule)
{
	var tblName = String(this.tableName);
	var result;
	try
	{
		if (typeof rule[execute] != "undefined")
			result = eval(String(rule[execute]));
		else
			result = eval(String(execute));		
	}
	catch(e)
	{
		if (typeof rule[execute] != "undefined")
			result = String(rule[execute]);
		else
			result = String(execute);
	}
	return result;
}

function DpConvertShtat_getArguments(func)
{
	var tmp = func.substring(func.indexOf("(") + 1);
	tmp = allt(tmp.substring(0, tmp.indexOf(")")));
	if (tmp == "")
		return new Array();
	return tmp.split(",");
}

function DpConvertShtat_getStrFromArr(arr, razd, add)
{
	var result = "";
	for (var i in arr)
		if (result == "")
			result += add + i;
		else
			result += add + i + razd;
	return result;	
}

function DpConvertShtat_createTmpTable(tblName,isPrk4)
{
	DropTable(tblName);
	if(isPrk4)
	{
		var result =  ExecuteSQL("CREATE TABLE " + tblName
			+ " ( ftabn " + SqlType("long") 
			+ ", ftabn2 " + SqlType("long")
			+ ", fbdat " + SqlType("date") 
			+ ", fedat " + SqlType("date")
			+ ", fwid_wp " + SqlType("long")
			+ ", fwid_wp2 " + SqlType("long")
			+ ", fid " + SqlType("long") 
			+ ", fid2 " + SqlType("long")+")");
	}
	else
	{
		var result =  ExecuteSQL("CREATE TABLE " + tblName
			+ " ( ftabn " + SqlType("long") 
			+ ", fbdat " + SqlType("date") 
			+ ", fedat " + SqlType("date")
			+ ", fwid_wp " + SqlType("long")
			+ ", fid " + SqlType("long") + ")");
	}
	if (result)
	{
		createIndex(tblName, "ftabn", "ftabn");
		createIndex(tblName, "fid", "fid");
		if(isPrk4)
		{
			createIndex(tblName, "ftabn2", "ftabn2");
			createIndex(tblName, "fid2", "fid2");
		}
	}
	return result;
}


function DpConvertShtat_renameTable(fullTblName)
{
	var result = true;
	var rename = false;
	var tmp0 = fullTblName.substring(fullTblName.length - 6);
	var newName = fullTblName.substring(0, fullTblName.length - 6);
	newName += tmp0.substring(2) + tmp0.substring(0, 2);
	this.writeLog("\tПереименование таблицы " + fullTblName + " на " + newName);
	//переделал создание таблиц с пом. CreateTableEx(), чтоб создавались дефолты
	for(var i=0; i<this.struTables.length; i++)
	{
		var base = this.struTables[i].base.toUpperCase();
		var table = this.struTables[i].table.toUpperCase();
		var pattern = this.struTables[i].pattern.toUpperCase();
		var ind = table.indexOf("%LD");
		if(ind == -1)
		{
			this.writeLog("\tERROR: В имени таблицы " + table + " не найдены символы '%LD'");
			this.writeLog("\tНе удалось переименовать таблицу " + fullTblName);
		}
		//обрезаем "%LD"
		table = table.substr(0,ind);
		ind = newName.lastIndexOf("ZRP_");
		if(ind == -1)
		{
			this.writeLog("\tERROR: В имени новой таблицы " + newName + " не найдены символы 'ZRP_'");
			this.writeLog("\tНе удалось переименовать таблицу " + fullTblName);
		}
		//вырезаем короткое имя таблицы
		var shortNewName = newName.substr(ind+4,newName.length).toUpperCase();
		//if(!strIn(table,shortNewName))
		//	continue;
		//вырезаем первые буковки, чтобы сравнить с именем шаблона без циферок
		var sName = shortNewName.substr(0,shortNewName.length-6);
		if(sName=="STT1")	//в некоторых лажовых таблицах 7 циферок, а не 6
			sName = "STT";
		if(table!=sName)
			continue;
		//создаем таблицу через объект с полями, т.к. на этом этапе таблица не отмодифицирована и создавать по паттерну ее нельзя
		var tbl = OpenTable("select * from "+fullTblName+" where 1<>1");
		var fieldList = getFieldNamesList(tbl);
		var dpTypeList = getFieldDpTypesList(tbl);
		var m = new Object();
		for(var j = 0; j < fieldList.length; j++) 
			eval("m."+fieldList[j]+"='"+dpTypeList[j]+"'");
		CreateTableEx(base,"ZRP_"+shortNewName,m);
		rename = ExecuteSQL("INSERT INTO " + newName + " ("+fieldList+") SELECT "+fieldList+" FROM " + fullTblName,false);
		//result = ExecuteSQL("SELECT * INTO " + newName + " FROM " + fullTblName,false);
		tbl.close();
		if (rename)
		{
			this.writeLog("\tOk");
			result = true;
		}
		else
		{
			this.writeLog("\tНе удалось переименовать таблицу " + fullTblName);
			result = false;
		}
	}
	//если чудо свершилось удаляем старую таблицу
	if(rename)
	{
		this.writeLog("\tУдаление таблицы " + fullTblName);
		if(!DropTableEx(fullTblName))
			this.writeLog("\tНе удалось удалить таблицу " + fullTblName);
	}
	return result;			
}

function DpConvertShtat_renameField(fullTblName, strFields)
{
	var split = allt(strFields).split("|");
	if (split.length != 2)
		return false;
	var oldNameField = allt(split[0]).split(",");
	var newNameField = allt(split[1]).split(",");
	if (oldNameField.length != newNameField.length)
		return false;
	for (var i in newNameField)
	{
		var dpType = this.getDpType(fullTblName, allt(oldNameField[i]));
		if (typeof dpType != "undefined")
		{
			if (!this.addColumn(fullTblName, allt(newNameField[i]), SqlType(dpType)))
				continue;
			if (!ExecuteSQL("UPDATE " + fullTblName + " SET " + allt(newNameField[i]) + "=" + allt(oldNameField[i]),false))
				this.dropColumn(fullTblName, allt(newNameField[i]));
		}
	}	
}

function DpModifyTabels()
{
	include("servis/date.js");
	include("servis/format.js");
	this.writeLog("\n\tМОДИФИКАЦИЯ ТАБЕЛЕЙ:");
	this.writeLog("\tОбновление коректных значений Fwid_wp в таблицах STT1%LD и TBL%LD");
	var D1 = firstDayMonth(d00min);
	var D2 = firstDayMonth(new Date());
	while(differ(D1,D2)<=0)
	{
		var STT1 = "STT1"+getDateTag(D1);
		var TBL = "TBL"+getDateTag(D1);
		if(IsTableEx("ZRP_MDB", "ZRP_"+TBL) && IsTableEx("ZRP_MDB", "ZRP_"+STT1))
		{
			this.writeLog(format("\t Обновление табелей за Mmm yyyy",D1));
			TBL = "^"+TBL;
			STT1 = "^"+STT1;
			//обновляем только разбитые табеля
			if(!ExecuteSQL("UPDATE "+TBL+" SET Fwid_wp = (SELECT MAX(wp.Fwid) FROM ^work_pers as wp "
							+" INNER JOIN "+STT1+" as st ON wp.Fwid_cl=st.Ftabn_id and wp.Fid=st.Fid "
							+" WHERE  "+TBL+".Fwid_wp=st.Fwid_wp and "+TBL+".Fbdat=st.Fbdat and "+TBL+".Fedat=st.Fedat) "
						+" WHERE Fwid_wp in (SELECT Fwid_wp FROM "+STT1+" GROUP BY Ftabn_id,Fwid_wp HAVING MIN(Fid)<>MAX(Fid))",false))
				this.writeLog("\tERROR: Не удалось обновить таблицу "+TBL);
			
			if(SUBD==MYSQL)
			{
				var stt1Name = "TMP_STT1"+getDateTag(D1);
				DropTable(stt1Name);
				if(!ExecuteSQL("select * into "+stt1Name+" from "+STT1))
					this.writeLog("\tERROR: Не удалось создать временную таблицу "+stt1Name);
			}
			else
				var stt1Name = STT1;
			if(!ExecuteSQL("UPDATE "+STT1+" SET Fwid_wp = (SELECT MAX(Fwid) FROM ^work_pers as wp "
							+" WHERE wp.Fwid_cl="+STT1+".Ftabn_id "
								+" AND wp.Fid="+STT1+".Fid) "
						+" WHERE Ftabn_id in (SELECT Ftabn_id FROM "+stt1Name+" GROUP BY Ftabn_id HAVING MIN(Fid)<>MAX(Fid))",false))
				this.writeLog("\tERROR: Не удалось обновить таблицу "+STT1);
		}
		D1 = goMonth(D1, 1);
	}
	this.writeLog("\tЗАВЕРШЕНИЕ МОДИФИКАЦИИ ТАБЕЛЕЙ:");
}