// JScript source code

function DpDBSettingsCloner(bases)
{
	this.bases = new Object();
	this.fillBases = DpDBSettingsCloner_fillBases;
	this.run = DpDBSettingsCloner_run;
	this.copyTableSettings = DpDBSettingsCloner_copyTableSettings;
	this.getDestTableName = DpDBSettingsCloner_getDestTableName;
	this.getBase = DpDBSettingsCloner_getBase;
	this.clsClear = DpDBSettingsCloner_clsClear;
	this.fillBases(bases); 
}

function DpDBSettingsCloner_fillBases(bases)
{
	if (typeof(bases) == "string")
	{
		this.bases["ALL_MDB"] = bases;
		this.bases["CL_MDB"] = bases;
		this.bases["PR_MDB"] = bases;
		this.bases["CDR"] = bases;
		this.bases["CDR_RES"] = bases;
		this.bases["ZRP_MDB"] = bases;
		this.bases["ZRPU_MDB"] = bases;
		this.bases["ZRP_RES"] = bases;
	}
	else
	{
		for (var i in bases)
		{
			this.bases[String(i).toUpperCase()] = bases[i];
		}
	}
	
}

function DpDBSettingsCloner_run()
{
	this.copyTableSettings("CL_SCHET");
	this.copyTableSettings("CL_LNK");
}

function DpDBSettingsCloner_copyTableSettings(fromTable, notDel)
{
	var sFld = GetPatternIntersection(fromTable, fromTable);
	
	var selectSQL = "SELECT " + sFld + " from ^" + fromTable;
	
	var toTable = this.getDestTableName(fromTable);
	
	var ret = true;
	BeginTransaction(1);
	
	if(!notDel)
	{
		ret = ExecuteSQL("DELETE FROM " + toTable, false);
		trace("<<<ОЧИСТКА ТАБЛИЦЫ "+toTable+">>>"+ret);
	}
	//если таблицы приемника не существует, тогда создаём её
	if(!ret)
		isIns = copyTable("^"+fromTable, toTable);
	else
	{
		//проверяем относится ли таблица к %LD, если да, то удаляем и копируем
		tag = toTable.substr(toTable.length-6,6);
		if(Number(tag)>0)
		{
			ret = ExecuteSQL("DROP TABLE "+toTable, false);
			trace("<<<УДАЛЕНИЕ ТАБЛИЦЫ "+toTable+">>>"+ret);
			isIns = copyTable("^"+fromTable, toTable);
			trace("<<<СОЗДАНИЕ ТАБЛИЦЫ "+toTable+">>>"+isIns);
		}
		else
		{
			isIns = ExecuteSQL("INSERT INTO " + toTable + "(" + sFld + ") " + selectSQL);
			trace("<<<КОПИРОВАНИЕ ЗАПИСЕЙ В ТАБЛИЦУ "+toTable+">>>"+isIns)
		}
	}
	alert(toTable);
	
	//ret = ret && isIns;
	if(isIns)
		CommitTrans();
	else
		RollbackTrans();
	 
}

function DpDBSettingsCloner_getDestTableName(tblName)
{
	var oTable = null;
	var dbMngr = lpProxy.getDBManager();
	oTable = dbMngr.getStruTableInfo(tblName);
	if (oTable == null)
	{
		return tblName;
	}
	return this.getBase(oTable.getBase())
			 + dbMngr.getDivPoint()
			 + (String(oTable.getSys()) ? (String(oTable.getSys()) + "_") :"")
			 + String(tblName.toLowerCase());
	
	
}

function DpDBSettingsCloner_getBase(sBase)
{
	sBase = String(sBase).toUpperCase();
	return this.bases[sBase];
}

function DpDBSettingsCloner_clsClear()
{
	//получаем номера справочников аналитики в базе приёмнике, которые мы хотим очистить перед копированием
	var par = new Object();
	par.tblName = this.getDestTableName("CLCL");
	par.esc = true;
	showWindow("l_clclear.js",SW_MODAL,par)
	if(par.esc)
		return false;
	var clCods = par.ret;
	var clrelclcl = this.getDestTableName("CLRELCLCL");
	var cl = this.getDestTableName("CL");
	var cl_homo = this.getDestTableName("CL_HOMO");
	var cl_post = this.getDestTableName("CL_POST");
	BeginTransaction(1);
	//удаляем из clreclcl записи относящиеся к отобранным справочникам
	del1 = ExecuteSQL("delete from "+clrelclcl+" where fcl in ("+clCods+")");
	trace("<<<ОЧИСТКА ТАБЛИЦЫ "+clrelclcl+">>>"+del1);
	//удаляем из cl все записи у которых нет связки с clrelclcl
	del2 = ExecuteSQL("delete from "+cl+" where not exists(select * from "+clrelclcl+" where Fwid_cl="+cl+".Fwid)");
	trace("<<<ОЧИСТКА ТАБЛИЦЫ "+cl+">>>"+del2);
	//аналогично очищаем cl_homo cl_post
	del3 = ExecuteSQL("delete from "+cl_homo+" where not exists(select * from "+cl+" where fwid="+cl_homo+".Fwid_cl)");
	trace("<<<ОЧИСТКА ТАБЛИЦЫ "+cl_homo+">>>"+del3);
	del4 = ExecuteSQL("delete from "+cl_post+" where not exists(select * from "+cl+" where fwid="+cl_post+".Fwid_cl)");
	trace("<<<ОЧИСТКА ТАБЛИЦЫ "+cl_post+">>>"+del4);
	if(del1 && del2 && del3 && del4)
	{
		CommitTrans();
		return true;
	}
	else
	{
		RollbackTrans();
		return false;
	}
}