var oPrintStream = null;
include ("sys/udfs.js");

function DpDbMod()
{
		
	this.modTable = DpDbMod_modTable;
	this.add_seq_counter = DpDbMod_add_seq_counter;
	this.putLogMessage = DpDbMod_putLogMessage;
	this.getTblColumns = DpDbMod_getTblColumns;
	this.CompareFields = DpDbMod_CompareFields;
	this.getTname = DpDbMod_getTname;
	this.DropIndexes = DpDbMod_DropIndexes;
	this.CreateIndexes = DpDbMod_CreateIndexes;
	this.ModifyTable = DpDbMod_ModifyTable;
	this.CreateTable = DpDbMod_CreateTable;
	this.CreateTUID = DpDbMod_CreateTUID;
	this.createFunctions = DpDbMod_createFunctions;
	this.dropTempTables = DpDbMod_dropTempTables;
	
	this.doSmartReindex = DpDbMod_doSmartReindex;
	this.compareIndFlds = DpDbMod_compareIndFlds;
	this.DropIndex = DpDbMod_DropIndex;
	this.CreateIndex = DpDbMod_CreateIndex;
	this.dropViews = DpDbMod_dropViews;
	this.createViews = DpDbMod_createViews;
	this.recreateViews = DpDbMod_recreateViews;
	this.getViewWithExtSQL = DpDbMod_getViewWithExtSQL;
	this.createNMKLFullView = DpDbMod_createNMKLFullView;
	this.ModifyTableDERBY = DpDbMod_ModifyTableDERBY;

	this.sPoint = ".";
	if (SUBD == MSSQL)
		this.sPoint  = "..";
		
	if (SUBD == HSQLDB)
		this.sPoint  = "";	
	
	this.FIELD_EXISTS = 0;
	this.FIELD_MODIFY = 1;
	this.FIELD_ABSCENT = 2;
	this.tbl = null;
	this.showErr = false;
	
	if (SUBD == ORACLE)
		this.add_seq_counter();
		
	this.CreateTUID();	//- без этого не заработает переформирование ФВИДОВ
	
}

function DpDbMod_createFunctions()
{
	if (SUBD != DERBY) return;
	ExecuteSQL("CREATE SCHEMA DPFUNC", false);
	
	
	ExecuteSQL("drop function DPFUNC.DATEADD", false);	
	var sSQL = "CREATE FUNCTION DPFUNC.DATEADD(time TIMESTAMP, delta INT, tape VARCHAR(10) ) " +
			"RETURNS  TIMESTAMP PARAMETER STYLE JAVA NO SQL LANGUAGE JAVA " +
			"EXTERNAL NAME 'org.debet.dpderbyfunc.DbFunctions.dateAdd' ";
   	ExecuteSQL(sSQL, false);
   	
   	ExecuteSQL("drop function DPFUNC.GETDIFFERENCEPERIOD", false);
	var sSQL = "CREATE FUNCTION DPFUNC.GETDIFFERENCEPERIOD(time1 TIMESTAMP, time2 TIMESTAMP ) " +
			"RETURNS  INTEGER PARAMETER STYLE JAVA NO SQL LANGUAGE JAVA " +
			"EXTERNAL NAME 'org.debet.dpderbyfunc.DbFunctions.getDifferencePeriod' ";
   	ExecuteSQL(sSQL, false);
	
}

function DpDbMod_dropTempTables()
{
	var base = getPath("ALL_MDB");
	var arrTbl = lpProxy.getDBManager().getTables(base, "TABLE");
	for (var i = 0; i < arrTbl.length; i++)
	{
		var tblName = String(arrTbl[i]).toUpperCase();
		if(tblName.startsWith("TEMP") || tblName.startsWith("TMP_") || tblName.startsWith("OLD_"))
		{
			ExecuteSQL("DROP TABLE " + base + this.sPoint + tblName, false);
		}
	}
}

function DpDbMod_add_seq_counter()
{
	this.putLogMessage("Mod: создание SEQ_COUNTER");

	var arrLablBases = ["ALL_MDB","CL_MDB","ZRP_MDB"];
	
	for (var i = 0; i < arrLablBases.length; i++)
	{
		var base = String(arrLablBases[i]).toUpperCase();
		var sSQL = "SELECT SEQUENCE_NAME FROM "
		+" ALL_SEQUENCES WHERE SEQUENCE_NAME = 'SEQ_COUNTER' and SEQUENCE_OWNER = " 
			+ sqlTo(base)
	                
	    var oSnap = getSnap(sSQL);
	    if (oSnap == null)
	    {
	
		    //vlad
	    	//В случае, когда БД разбита на несколько сегментов, мы создаем SEQ_COUNTER в сегменте getPath("all_mdb")
			
	    	sSQL = "CREATE SEQUENCE " + base + ".SEQ_COUNTER INCREMENT BY 1 START WITH 1";
	    	var isOk = ExecuteSQL(sSQL,this.showErr);
	    	if (!isOk)
	    	{
	   			this.putLogMessage("Mod: создать " + base + ".SEQ_COUNTER не удалось");
				this.putLogMessage(lpProxy.getLastDBErrorMessage());
	   		}
	   		else
	   			this.putLogMessage("Mod: " + base + ".SEQ_COUNTER - создан");
	    }
	    else
	    	this.putLogMessage("Mod: " + base + ".SEQ_COUNTER - уже существует");
	}
    return true;
}

function DpDbMod_putLogMessage(sMsg)
{
//-	WAIT(sMsg);
}

function DpDbMod_modTable(stTbl)
{
	if (stTbl.base == "")
		stTbl.base="sys";
	var database = getPath(stTbl.base);
	var tblName = stTbl.fullName;
	if (tblName.indexOf("%") != -1)
	{
		var pattern = "";
		pattern = tblName.substring(0,tblName.indexOf("%")) + "%";
		var tablesEx = getTablesForPattern(database,pattern);
		if(!tablesEx)
			return;
		for (var nTEx = 0; nTEx < tablesEx.length; nTEx++)
		{
			if (tablesEx[nTEx].substr(tblName.indexOf("%")).search("[0-9]{6}") == -1)
				if (tablesEx[nTEx].substr(tblName.indexOf("%")).search("[0-9]{7}") == -1)
					continue;
			this.putLogMessage("\r\nMod: Модификация таблицы " + tablesEx[nTEx]);
			
			stTbl.fullName = tablesEx[nTEx];
			if (this.tbl != null)
				this.tbl.close();
			this.tbl = OpenTable("s","SELECT * FROM " + database + this.sPoint + tablesEx[nTEx] + " WHERE 1=0");
			if (stTbl.reindex)
			{
				this.DropIndexes(stTbl,"*");
			}
			if (stTbl.domod)
			{
				var modTblName = String(tablesEx[nTEx]).toUpperCase();
				var sys = String(stTbl.sys).toUpperCase();
				if (SUBD == DERBY && modTblName.indexOf(sys) >= 0)
					modTblName = modTblName.substr((sys + "_").length);
				
				this.ModifyTable(stTbl.base,stTbl.sys,stTbl.pattern,modTblName);
			}
			if (stTbl.reindex)
			{
				this.CreateIndexes(stTbl,"*");
			}
		}
		return;
	}
	if(stTbl.exists)
	{
		if (stTbl.reindex)
		{
			this.DropIndexes(stTbl,"*");
		}
		if (stTbl.domod)
		{
			var sSQL = "SELECT * FROM ^" + stTbl.table + " WHERE 1=0";
			if (this.tbl != null)
			{
				this.tbl.close();
				this.tbl = null;
			}
			this.tbl = OpenTable("s",sSQL);			
			this.putLogMessage("Mod: Модификация таблицы " + tblName);
			this.ModifyTable(stTbl.base,stTbl.sys,stTbl.table);
		}
	}
	else
	{
		if (stTbl.domod || stTbl.reindex)
		{
			this.putLogMessage("Mod: Создание таблицы " + tblName);
			this.CreateTable(stTbl.base,stTbl.sys,stTbl.table);
		}
	}
	
	if (stTbl.reindex)
	{
		this.CreateIndexes(stTbl,"*");
		this.putLogMessage("Ok");
	}
	
/*
	trace("--------");
	if (!stTbl.reindex)
		this.doSmartReindex(stTbl);
	trace("--------");
	*/
	if (this.tbl != null)
	{
		this.tbl.close();
		this.tbl = null;
	}
}

function DpDbMod_getTblColumns()
{
	var nFld = this.tbl.fieldCount();
	if (nFld <= 0)
		return null;
	var Fields = new Array();
	for (var i = 1; i < nFld + 1; i++)
	{
		Fields[i - 1] = this.tbl.getFieldInfo(i);
	}
	this.tbl.close();
	return Fields;
}

function DpDbMod_CompareFields(struField,Field)
{
	var struType = allt(struField.getType()).toUpperCase();
	var type = allt(Field.getType());
	if (allt(struField.getName()) != allt(Field.getName()))
		return this.FIELD_ABSCENT;
	
	if ((SUBD == ORACLE || SUBD == MYSQL) && struField.getDpType() == "counter")
		return this.FIELD_MODIFY;
	
	if (struType != type)
	{
		trace(">>>>>>>> S:" + struType + "  R:" + type);
		var i = struType.indexOf(" ");
		if (i != -1)
		{
			if (struType.indexOf("IDENTITY") != -1)
				return this.FIELD_MODIFY;
			struType = allt(struType.substring(0,i));
		}
		
		if (struType != type)
		{
			return this.FIELD_MODIFY;
		}
	}
	return this.FIELD_EXISTS;
}

function DpDbMod_getTname(sSystem,sTblName)
{
	return upper((sSystem == ""?"":sSystem + "_") + sTblName);
}

function DpDbMod_DropIndex(sBaseLbl,tblName,sIndex)
{
	if (sIndex == "KEY" || sIndex == "PRIMARY")
		return;
	var sSQL = "";
	var sBase = getPath(sBaseLbl);
	var isOk = true;
	if (SUBD == MYSQL)
	{
		sSQL = "DROP INDEX " + sIndex + " ON " + sBase + this.sPoint + tblName;
		isOk = ExecuteSQL(sSQL,this.showErr);
	}
	else if (SUBD == ORACLE || SUBD == DERBY || SUBD == POSTGRE || SUBD == H2)
	{
		sSQL = "DROP INDEX " + sBase + "." + sIndex;
		isOk = ExecuteSQL(sSQL,this.showErr);
	}
	else if (SUBD == HSQLDB)
	{
		sSQL = "DROP INDEX "+ sIndex;
		isOk = ExecuteSQL(sSQL,this.showErr);
	}
	else
	{
		sSQL = "DROP INDEX " + tblName + "." + sIndex;
		isOk = ExecuteSQLEx(sBaseLbl,sSQL,this.showErr);
	}
	if (!isOk)
	{
		this.putLogMessage("Mod: ошибка при удалении индекса");
		this.putLogMessage(sSQL);
		this.putLogMessage(lpProxy.getLastDBErrorMessage());
	}
	else
	{
		this.putLogMessage("Mod: индекс " + tblName + "." + sIndex + " удалён");
	}
}

function DpDbMod_DropIndexes(stTbl,arIndNames)
{
	var toDrop;
	if (typeof(arIndNames) == "object")
	{
		toDrop = arIndNames;
	}
	else
	{
		toDrop = getIndexes(getPath(stTbl.base),stTbl.fullName);
		if (toDrop == null)
			toDrop = new Array();
	}
	trace ("index count is " + toDrop.length);
	for (var i = 0; i < toDrop.length; i++)
	{
		this.DropIndex(stTbl.base,stTbl.fullName,toDrop[i]);
	}
}

function DpDbMod_CreateIndex(stTbl,sInd,sFields)
{
	var type = "";
	if (sInd == "KEY" || sInd == "PRIMARY")
		return;
	var indexFields = "";
	if (sFields)
		indexFields = sFields;
	else
	{
		indexFields = getStruIndexFields(stTbl.pattern,sInd);
		type = getStruIndexType(stTbl.pattern,sInd);
		if (type != null)
			type = String(type).toUpperCase();		
		
	}
	if (indexFields == "")
		return;
	var sDatabase = getPath(stTbl.base);
	if (SUBD != ORACLE && SUBD != DERBY && SUBD != DB2 && SUBD != POSTGRE && SUBD != HSQLDB && SUBD != MSSQL && SUBD != H2)
		sSQL = sInd + " ON " + sDatabase + this.sPoint +  stTbl.fullName + " (" + indexFields + ")";
	else if (SUBD == MSSQL)
	{
		sSQL = "[" + sInd + "] ON " + sDatabase + this.sPoint +  stTbl.fullName + " (" + indexFields + ")";
	}
	else if (SUBD == DB2)
	{
		sSQL = sDatabase + "." + stTbl.table 
			   + sInd + " ON " + sDatabase + this.sPoint + stTbl.fullName 
			   + "(" + indexFields + ")";
	}
	else
		sSQL = ((SUBD !=POSTGRE)?sDatabase + this.sPoint : "") + "I_" + stTbl.fullName + "_" 
			   + sInd + " ON " + sDatabase + this.sPoint + stTbl.fullName 
			   + "(" + indexFields + ")";
	
	var isOk = false;
	
	if (type)
	{
		isOk = ExecuteSQL("CREATE " + type + " INDEX " + sSQL,this.showErr);
	}
	
	if (!isOk)
		isOk = ExecuteSQL("CREATE INDEX " + sSQL,this.showErr);
	if (!isOk)
	{
		this.putLogMessage("Mod: ошибка при создании индекса");
		this.putLogMessage(sSQL);
		this.putLogMessage(lpProxy.getLastDBErrorMessage());
	}
	else
	{
		this.putLogMessage("Mod: индекс " + stTbl.fullName + "." + sInd + " создан");
	}
}

function DpDbMod_CreateIndexes(stTbl,arInds)
{
	var toCreate;
	if (typeof(arInds) == "object")
	{
		toCreate = arInds;
	}
	else
	{
		toCreate = getStruIndexes(stTbl.pattern);
	}
	if (toCreate == null || toCreate.length == 0)
		return;
	for (var i = 0; i < toCreate.length; i++)
	{
		this.CreateIndex(stTbl,toCreate[i]);
	}
}

function DpDbMod_ModifyTableDERBY(sDatabase,sSystem,sPatt,sTblName,struFlds,tblColumns,ignoreExistingFields)
{
	var newTblName = this.getTname(sSystem,sTblName);
	var oldTblName = "OLD_" + this.getTname(sSystem,sTblName);
	sDatabase = getPath(sDatabase);
	ExecuteSQL("DROP TABLE " + sDatabase + this.sPoint + oldTblName,false);
	
	var sFields = "";
	var sTOFields = "";
	var bDoMod = false;
	for (var nFld = 0; nFld < struFlds.length; nFld++)
	{
		var SFld = null;
		var bInMod = false;
		for (var nTc = 0; nTc < tblColumns.length; nTc++)
		{
			if (String(struFlds[nFld].getName()).toUpperCase()
			 == String(tblColumns[nTc].getName()).toUpperCase())
			{
				SFld = struFlds[nFld];
				bInMod = (this.CompareFields(SFld,tblColumns[nTc]) != this.FIELD_EXISTS)
				break;
			}
		}
		if (SFld == null)
		{
			bDoMod = true;
			continue;
		}
		if (!bInMod)
		{
			sTOFields = sTOFields + (sTOFields==""?"":",") + SFld.getName();
			sFields = sFields + (sFields==""?"":",") + struFlds[nFld].getName();
		}
		else
		{
			bDoMod = true;
			if (strIn(" IDENTITY",struFlds[nFld].getType() ))
			{
				continue;
			}
			
			if (strIn("NUMERIC",struFlds[nFld].getType())
				|| strIn("INT",struFlds[nFld].getType())
				|| strIn("SMALLINT",struFlds[nFld].getType())
				)
				sFields = sFields + (sFields==""?"":",") + Convert(struFlds[nFld].getName(),"INT");
			else if (strIn("VARCHAR",struFlds[nFld].getType()))
				sFields = sFields + (sFields==""?"":",") + " RTRIM(CHAR(" + struFlds[nFld].getName() + ",254))";
			else if (strIn("LONG VARCHAR",struFlds[nFld].getType()))
				sFields = sFields + (sFields==""?"":",") + " RTRIM(VARCHAR(" + struFlds[nFld].getName() + ",2000))";
			else
				sFields = sFields + (sFields==""?"":",") + struFlds[nFld].getName();
			sTOFields = sTOFields + (sTOFields==""?"":",") + SFld.getName();
		}
	}
	
	for (var nTc = 0; nTc < tblColumns.length; nTc++)
	{
		var bExists = false;
		
		for (var nFld = 0; nFld < struFlds.length; nFld++)
		{
			if (String(struFlds[nFld].getName()).toUpperCase()
		 		== String(tblColumns[nTc].getName()).toUpperCase())
			{
				bExists = true;
				break;
			}
		}
		
		if (!bExists && !ignoreExistingFields) //нужно удалить поле
		{
			bDoMod = true;
			break
		}
	}
		
	if (!bDoMod)
	{
		this.putLogMessage("Таблица " + newTblName + " не нуждается в модификации");
		return;
	}
	
	var sRSQL = "RENAME TABLE "
			   + String(sDatabase).toUpperCase() + this.sPoint + newTblName
			   + " TO " + oldTblName;
	var isOk = ExecuteSQL(sRSQL ,this.showErr);
	
	if (!isOk)
	{
		this.putLogMessage("Ошибка при переименовании таблицы");
		this.putLogMessage(sRSQL);
		this.putLogMessage(lpProxy.getLastDBErrorMessage());
		return;
	}
	
	this.CreateTable(sDatabase,sSystem,sTblName,struFlds);
	
	var sSQL = "INSERT INTO "
			 + String(sDatabase).toUpperCase() + this.sPoint + this.getTname(sSystem,sTblName)
			 + "(" + sTOFields + ")"
			 + " SELECT " + sFields
			 + " FROM " + sDatabase + this.sPoint + oldTblName;
	var isOk = ExecuteSQL(sSQL,false);
	if (!isOk)
	{
		this.putLogMessage("Ошибка при переносе данных(всю инф. можно найти в таблице " + oldTblName + "):");
		this.putLogMessage(sSQL);
		this.putLogMessage(lpProxy.getLastDBErrorMessage());
	}
	else
	{
		this.putLogMessage("Данные перенесены:");
		ExecuteSQL("DROP TABLE " + sDatabase + this.sPoint + oldTblName,false);
	}
}

function DpDbMod_ModifyTable(sDatabase,sSystem,sPatt,sTblName,struFlds,ignoreExistingFields)
{
	if (!sTblName)
	{
		sTblName = sPatt;
	}
	var StruFields;
	if (!struFlds)
		StruFields = getStruFields(sPatt);
	else
		StruFields = struFlds;
	if (StruFields == null || StruFields.length == 0)
		return false;
	var Fields = this.getTblColumns();
	if (Fields == null)		
		Fields = new Array();
	if (SUBD == DERBY || SUBD == DB2)
	{
		return this.ModifyTableDERBY(sDatabase,sSystem,sPatt,sTblName,StruFields,Fields,ignoreExistingFields);
	}
	var modifyFields = new Array();
	var addFields = new Array();
	var dropFields = new Array();
	
	for(var nSFld = 0; nSFld < StruFields.length; nSFld++)
	{
		var SField = StruFields[nSFld];
		if (SField.getType() == "")
			continue;
		var ExField = null;
		for (var i = 0; i < Fields.length; i++)
		{	
			if (Fields[i] && allt(SField.getName()) == allt(Fields[i].getName()))
			{
				ExField = Fields.splice(i,1)[0];
				break;
			}
		}
		if (ExField == null)
		{
			addFields.push(SField);
		}
		else
		{
			if (this.CompareFields(SField,ExField) != this.FIELD_EXISTS)
			{
				modifyFields.push(SField);
			}
		}
	}
	if(!ignoreExistingFields)
		dropFields = Fields;
	
	if (dropFields.length == 0 && addFields.length == 0 && modifyFields.length ==0)
		return true;
	
	var databaseName = upper(getPath(sDatabase));
	var tblName = this.getTname(sSystem,sTblName);
	if (sTblName != sPatt)
	{
		tblName = sTblName
	}
	
	if (SUBD == POSTGRE && (addFields.length > 0 || modifyFields.length > 0))
	{
		var sSQL = "ALTER TABLE " + databaseName + "." + tblName;
		sSQL += " OWNER TO \"" + getDBUserName()+"\"";
		ExecuteSQL(sSQL, false);
	}
	
// -- роняем лишние поля	
	for (var i = 0; i < dropFields.length; i++)
	{
		if(!dropFields[i])
			continue;
			
		if (SUBD == MSSQL)
		{
			var sdc = mssqlGetColumnDefaultConstraint(sDatabase, tblName, dropFields[i].getName());
			if (sdc != null)
			{
				var sSQL = "ALTER TABLE " + databaseName + this.sPoint + tblName;
				sSQL += " DROP CONSTRAINT " + sdc;
				ExecuteSQL(sSQL,this.showErr);
			}
		}
		if (SUBD == H2)
		{
			h2DropConstraintsForField(databaseName + this.sPoint + tblName, dropFields[i].getName());
		}
		
			
		var sSQL = "ALTER TABLE " + databaseName + this.sPoint + tblName;
		sSQL += " DROP COLUMN ";
		sSQL += dropFields[i].getName();
		
		var isOk = ExecuteSQL(sSQL,this.showErr);
		if (!isOk)
		{
			this.putLogMessage("Mod: не удалось удалить поле " + dropFields[i].getName());
			this.putLogMessage(sSQL);
			this.putLogMessage(lpProxy.getLastDBErrorMessage());
		}
		else
			this.putLogMessage("Mod: удалено поле " + dropFields[i].getName());
	}
	dropFields = null;
	
	
// -- добавляем недостающие	
	var counterFields = new Array();
	
	for (var i = 0; i < addFields.length; i++)
	{
		if(!addFields[i])
			continue;
			
		var sSQL = "";
		if (SUBD == MYSQL || SUBD == POSTGRE || SUBD == H2)
		{
			sSQL = "ALTER TABLE " + databaseName + "." + tblName;
			sSQL += " ADD COLUMN ";
			sSQL += addFields[i].getName() + " " + addFields[i].getType() 
				+ " " + addFields[i].getDefault();
		}
		else if (SUBD == ORACLE)
		{
			sSQL = "ALTER TABLE " + databaseName + "." + tblName;
			sSQL += " ADD " + addFields[i].getName() + " " + addFields[i].getType()
				 + " " + addFields[i].getDefault();
			if (addFields[i].getDpType() == "counter")
				counterFields.push(addFields[i]);
		}
		else if (SUBD == MSSQL)
		{
			sSQL = "ALTER TABLE " + databaseName + this.sPoint + tblName
				   + " ADD " + addFields[i].getName() + " " + addFields[i].getType()
				   + " " + addFields[i].getDefault();
		}
		
		var isOk = ExecuteSQL(sSQL,this.showErr);
		if (!isOk)
		{
			this.putLogMessage("Mod: не удалось добавить поле " + addFields[i].getName());
			this.putLogMessage(sSQL);
			this.putLogMessage(lpProxy.getLastDBErrorMessage());
		}
		else
			this.putLogMessage("Mod: добавлено поле " 
						+ addFields[i].getName() + " " + addFields[i].getType());ExecuteSQL()			
		if (SUBD == MSSQL)
		{
			var defValue = addFields[i].getDefault();
			defValue = allt(defValue.substr(7 + defValue.indexOf("DEFAULT")));
			sSQL = "UPDATE " + databaseName + this.sPoint + tblName
			     + " SET " + addFields[i].getName() + "=" + defValue;
			ExecuteSQL(sSQL,this.showErr);
		}
	}
	addFields = null;
// -- модифицируем существующие	
	for (var i = 0; i < modifyFields.length; i++)
	{
		if(!modifyFields[i])
			continue;
			
		if (SUBD == MYSQL || SUBD == POSTGRE || SUBD == H2)
		{
			var sSQL = "ALTER TABLE " + databaseName + this.sPoint + tblName;
			sSQL += ((SUBD == MYSQL)?" MODIFY COLUMN ":" ALTER COLUMN ");
			sSQL += modifyFields[i].getName() 
				+ ((SUBD == MYSQL)?" ":" TYPE ")  
			+ modifyFields[i].getType()
			+ ((SUBD == MYSQL)? modifyFields[i].getDefault() :""); 
			
			var bRte = ExecuteSQL(sSQL,this.showErr);
			
			if (bRte && (SUBD == POSTGRE || SUBD == H2))
			{
				sSQL = "ALTER TABLE " + databaseName + this.sPoint + tblName;
				sSQL += " ALTER COLUMN " + modifyFields[i].getName() ;
				sSQL += " SET " + modifyFields[i].getDefault();
				if (allt(modifyFields[i].getDefault()) != "")
					ExecuteSQL(sSQL,this.showErr);
				
			}
			//для POSTGRE существующие поля, требущие модификации будем пересоздавать, т.к. изменять тип поля в POSTGRE нельзя
			if (!bRte && SUBD == POSTGRE)
			{
				this.putLogMessage("Mod: пересоздание поля "+modifyFields[i].getName()+" типа "+modifyFields[i].getDpType());
				bRte = true;
				sSQL = "ALTER TABLE " + databaseName + "." + tblName + " DROP COLUMN " + modifyFields[i].getName();
				if(!ExecuteSQL(sSQL, this.showErr))
				{
					this.putLogMessage("Mod: не удалось удалить поле "+modifyFields[i].getName());
					this.putLogMessage(sSQL);
					this.putLogMessage(lpProxy.getLastDBErrorMessage());
				}
				//для типа counter будем пересоздавать c типом integer вместе с сиквенсами
				if(modifyFields[i].getDpType() == "counter")
				{
					var seqName = databaseName + "." + tblName + "_" + modifyFields[i].getName() + "_SEQ"
					if(bRte)
					{
						ExecuteSQL("DROP SEQUENCE " + seqName,this.showErr);
		    			sSQL = "CREATE SEQUENCE " + seqName+" INCREMENT BY 1 START WITH 1";
		    			var isOk = ExecuteSQL(sSQL, this.showErr);
		    			if(isOk)
		    			{
		    				sSQL = "ALTER TABLE " + databaseName + "." + tblName + " ADD COLUMN " + modifyFields[i].getName() + " INTEGER DEFAULT NEXTVAL('"+seqName+"') NOT NULL";
							bRte = bRte && ExecuteSQL(sSQL,this.showErr);
		    			}
		    			else
		    			{
		    				this.putLogMessage("Mod: не удалось создать SEQUENCE " + seqName);
		    				this.putLogMessage(sSQL);
							this.putLogMessage(lpProxy.getLastDBErrorMessage());
		    			}
					}
				}
				else
				{
					sSQL = "ALTER TABLE " + databaseName + "." + tblName 
						+ " ADD COLUMN " + modifyFields[i].getName() 
						+ " " + modifyFields[i].getType() 
						+ " " + modifyFields[i].getDefault();
					bRte = bRte && ExecuteSQL(sSQL,this.showErr);
					if(!bRte)
					{
						this.putLogMessage("Mod: не удалось создать поле " + modifyFields[i].getName() + " " + modifyFields[i].getType());
	    				this.putLogMessage(sSQL);
						this.putLogMessage(lpProxy.getLastDBErrorMessage());
					}
				}
			}
			
			if(!bRte)
			{
				bRte = true;
				var sSQL = "";
				//для MySQL поля типа counter будем удалять и добавлять без обновления данных
				var isModCouner = (SUBD == MYSQL && modifyFields[i].getType().indexOf("AUTO_INCREMENT PRIMARY KEY") != -1)
						|| (SUBD == H2 && modifyFields[i].getType() == "IDENTITY");
				
				
				if(!isModCouner)
				{
					sSQL = "ALTER TABLE " + databaseName + "." + tblName + " ADD __TMP_FIELD " + modifyFields[i].getType();
					bRte = bRte && ExecuteSQL(sSQL, this.showErr);
					sSQL = "UPDATE " + databaseName + "." + tblName + " set __TMP_FIELD = " + modifyFields[i].getName();
					bRte = bRte && ExecuteSQL(sSQL, this.showErr);
				}
				
				if (SUBD == H2)
				{
					h2DropConstraintsForField(databaseName + "." + tblName, modifyFields[i].getName());
				}
				
				sSQL = "ALTER TABLE " + databaseName + "." + tblName + " DROP COLUMN " + modifyFields[i].getName();
				bRte = bRte && ExecuteSQL(sSQL, this.showErr);
				sSQL = "ALTER TABLE " + databaseName + "." + tblName + " ADD COLUMN " + modifyFields[i].getName() + " " + modifyFields[i].getType();
				bRte = bRte && ExecuteSQL(sSQL,this.showErr);
				if(!isModCouner)
				{
					sSQL = "UPDATE " + databaseName + "." + tblName + " SET " + modifyFields[i].getName() + "=__TMP_FIELD";
					bRte = bRte && ExecuteSQL(sSQL,this.showErr);
					sSQL = "ALTER TABLE " + databaseName + "." + tblName + " DROP COLUMN __TMP_FIELD";
					bRte = bRte && ExecuteSQL(sSQL,this.showErr);
				}
				
				if (!bRte)
				{
					this.putLogMessage("Mod: не удалось изменить поле " + modifyFields[i].getName() + " " + modifyFields[i].getType());
					this.putLogMessage(sSQL);
					this.putLogMessage(lpProxy.getLastDBErrorMessage());
				}
				
			}
		}
		else if (SUBD == MSSQL)
		{
			if (modifyFields[i].getDpType() == "counter")
			{
				counterFields.push(modifyFields[i]);
			}
			else
			{
				var sSQL = "ALTER TABLE " + databaseName + ".." + tblName 
							+ " ALTER COLUMN " + modifyFields[i].getName() 
							+ " " + modifyFields[i].getType() + modifyFields[i].getDefault() + ";";
				var bRet = ExecuteSQL(sSQL,false);
				if(!bRet)
				{
					bRte = true;
					var sSQL = "";
					sSQL = "ALTER TABLE "+databaseName + ".." + tblName+" ADD __TMP_FIELD " + modifyFields[i].getType();
					bRte &= ExecuteSQL(sSQL, this.showErr);
					sSQL = "update "+databaseName + ".." + tblName+" set __TMP_FIELD = " + modifyFields[i].getName();
					bRte &= ExecuteSQL(sSQL, this.showErr);
					
					var sdc = mssqlGetColumnDefaultConstraint(sDatabase, tblName, modifyFields[i].getName());
					if (sdc != null)
					{
						var sSQL = "ALTER TABLE " + databaseName + ".." + tblName;
						sSQL += " DROP CONSTRAINT " + sdc;
						ExecuteSQL(sSQL,this.showErr);
					}					
					
					sSQL = "ALTER TABLE "+databaseName + ".." + tblName+" drop column "+modifyFields[i].getName();
					bRte &= ExecuteSQL(sSQL, this.showErr);
					sSQL = "EXECUTE " + databaseName + "..sp_rename '" + tblName 
								+ ".__TMP_FIELD', '"+modifyFields[i].getName()+"'"
					bRte &= ExecuteSQL(sSQL, this.showErr);
					
					if (!bRte)
					{
						this.putLogMessage("Mod: не удалось изменить поле " + modifyFields[i].getName() + " " + modifyFields[i].getType());
						this.putLogMessage(sSQL);
						this.putLogMessage(lpProxy.getLastDBErrorMessage());
					}
				}
			}
		}
		else
		{
			var sSQL = "ALTER TABLE " + databaseName + this.sPoint + tblName;
			sSQL += " MODIFY (" + modifyFields[i].getName() + " " + modifyFields[i].getType() + modifyFields[i].getDefault() + ")";
			if (modifyFields[i].getDpType() == "counter")
			{
				counterFields.push(modifyFields[i]);
			}
			var isModifyed = ExecuteSQL(sSQL,this.showErr);
			if (!isModifyed)
			{
				var isOk = true;
//				BeginTransaction();
				strSQL = "ALTER TABLE " + databaseName + "." + tblName + " ADD TMP_FIELD " + modifyFields[i].getType();
				isOk = isOk && ExecuteSQL(strSQL, this.showErr);
				strSQL = "UPDATE " + databaseName + "." + tblName + " SET TMP_FIELD = " + modifyFields[i].getName();
				isOk = isOk && ExecuteSQL(strSQL, this.showErr);
				strSQL = "ALTER TABLE " + databaseName + "." + tblName + " DROP COLUMN " + modifyFields[i].getName();
				isOk = isOk && ExecuteSQL(strSQL, this.showErr);
				strSQL = "ALTER TABLE " + databaseName + "." + tblName + " ADD " + modifyFields[i].getName() + " " + modifyFields[i].getType();
				isOk = isOk && ExecuteSQL(strSQL, this.showErr);
				strSQL = "UPDATE " + databaseName + "." + tblName + " SET " + modifyFields[i].getName() + " = TMP_FIELD ";
				isOk = isOk && ExecuteSQL(strSQL, this.showErr);
				strSQL = "ALTER TABLE " + databaseName + "." + tblName + " DROP COLUMN TMP_FIELD";
				isOk = isOk && ExecuteSQL(strSQL, this.showErr);
//				CommitTransaction();
				if (!isOk)
				{
					this.putLogMessage("Mod: не удалось изменить поле " + modifyFields[i].getName() + " " + modifyFields[i].getType());
					this.putLogMessage(sSQL);
					this.putLogMessage(lpProxy.getLastDBErrorMessage());
				}
			}
		}
	}
	modifyFields = null;
	
	if (SUBD == ORACLE)
	{
		while (counterFields.length > 0)
		{
			var Field = counterFields.pop();
			

			ExecuteSQL("DROP TRIGGER " + databaseName +".TR_" + tblName + "_I", false);
			ExecuteSQL("DROP TRIGGER " + databaseName +"."+ tblName + "_I", false);
			ExecuteSQL("DROP TRIGGER " + databaseName +".TR_" + tblName + "_" + Field.getName() + "_I", false);
			ExecuteSQL("DROP TRIGGER " + databaseName +"."+ tblName + "_" + Field.getName() + "_I", false);

			var sCrTrig = "CREATE OR REPLACE TRIGGER " + databaseName +"." + tblName + "_" + Field.getName() + "_I BEFORE " +
							"INSERT ON " + databaseName + "." + tblName + " FOR EACH ROW BEGIN " +
							"SELECT "+databaseName+".SEQ_COUNTER.Nextval INTO :new." + Field.getName() + " FROM DUAL; END;" 
			var isOk = ExecuteSQL(sCrTrig,this.showErr);
			if (!isOk)
			{
				this.putLogMessage("Mod: не удалось изменить поле " + Field.getName());
				this.putLogMessage(sSQL);
				this.putLogMessage(lpProxy.getLastDBErrorMessage());
			}
		}
	}
	else if (SUBD == MSSQL)
	{
		while (counterFields.length > 0)
		{
			var Field = counterFields.pop();
			var sSQL = "ALTER TABLE " + databaseName + this.sPoint + tblName
						+ " DROP COLUMN " + Field.getName();
			var isOk = ExecuteSQL(sSQL,this.showErr);
			sSQL = "ALTER TABLE " + databaseName + this.sPoint + tblName
					+ " ADD " + Field.getName() + " " + Field.getType();
			isOk = isOk && ExecuteSQL(sSQL,this.showErr);
			if (!isOk)
			{
				this.putLogMessage("Mod: не удалось изменить поле " + Field.getName());
				this.putLogMessage(sSQL);
				this.putLogMessage(lpProxy.getLastDBErrorMessage());
			}
		}
	}
	return true;
}

function DpDbMod_CreateTable(sDatabase,sSystem,sTblName,struFlds)
{
	var tblName = this.getTname(sSystem,sTblName);
	var databaseName = getPath(sDatabase);
	if (databaseName == null)
		databaseName = sDatabase;
	databaseName = upper(databaseName);
	var sSQL = "CREATE TABLE " + databaseName + this.sPoint + tblName + "(";
	var Fields;
	if (!struFlds)
		Fields = getStruFields(sTblName);
	else
		Fields = struFlds;
	var sCounterFld = new Array();
	if (Fields == null)
		return false;
	for (var nFld = 0; nFld < Fields.length; nFld++)
	{
		if (Fields[nFld].getType() == "")
			continue;
		if (nFld == 0)
			sSQL +=" ";
		else
			sSQL += ", ";
		if (SUBD != ORACLE)
		{
			sSQL += Fields[nFld].getName() + " " + Fields[nFld].getType() + Fields[nFld].getDefault();
		}
		else
		{
			sSQL += Fields[nFld].getName() + " " + Fields[nFld].getType() + " " + Fields[nFld].getDefault();
		}
		if (Fields[nFld].getDpType() == "counter")
			sCounterFld.push(Fields[nFld]);
	}
	sSQL += ")";
	var isOk = ExecuteSQL(sSQL,this.showErr);
	if (!isOk)
	{
		this.putLogMessage("Mod: не удалось создать таблицу " + sTblName);
		this.putLogMessage(sSQL);
		this.putLogMessage(lpProxy.getLastDBErrorMessage());
	}
	else
		this.putLogMessage("Mod: таблица " + sTblName + " создана");
	if (SUBD == ORACLE)
	{
		while (sCounterFld.length > 0)
		{
			var divPoint = (SUBD == MSSQL ? ".." : ".");
    
			var Field = sCounterFld.pop();
			var sCrTrig = "CREATE OR REPLACE TRIGGER " + databaseName +".TR_" + tblName + "_I BEFORE " +
							"INSERT ON " + databaseName + "." + tblName + " FOR EACH ROW BEGIN " +
							"SELECT "+databaseName+divPoint+"SEQ_COUNTER.Nextval INTO :new." + Field.getName() + " FROM DUAL; END;" 
			var isOk = ExecuteSQL(sCrTrig,this.showErr);
			if (!isOk)
			{
				this.putLogMessage("Mod: не удалось создать триггер для поля " + Field.getName());
				this.putLogMessage(sSQL);
				this.putLogMessage(lpProxy.getLastDBErrorMessage());
			}
		}
	}
	return true;
}

function DpDbMod_CreateTUID()
{
	this.putLogMessage("создание UIDGEN");
	var sSQL ="";
	var sIns = "";
	var sUIDSys = "UID";	//15.05.2012: UIDы можно хранить в отдельной базе, имя базы указвается в настройке соединения.
	var sUIDPath = getPath(sUIDSys);
	var nUID = 1;
	if(!sUIDPath || sUIDPath=="")
	{
		sUIDSys = "ALL_MDB";
		sUIDPath = getPath(sUIDSys);
	}
	var sUIDTable = sUIDPath + this.sPoint + "TUID";
	if (SUBD == MYSQL)
	{
		if (IsTableEx(sUIDSys,"TUID"))
		return;
		nUID = inputStartUID();
		sSQL = "CREATE TABLE " + sUIDTable
			   + "(FUID " + SqlType("INT",11)
			   + " NOT NULL AUTO_INCREMENT PRIMARY KEY )";
		sIns = "INSERT INTO " + sUIDTable
			   + " VALUES("+ nUID +")";
	}
	else if (SUBD == MSSQL)
	{
		if (IsTableEx(sUIDSys,"TUID"))
		return;
		nUID = inputStartUID();
		sSQL = "CREATE TABLE " + sUIDTable
				+ " (FUID " + SqlType("INT",11) + ")";
		sIns = "INSERT INTO " + sUIDTable
				+ " VALUES("+ nUID +")";
	}
	if (SUBD == ORACLE)
	{
		sSQL = "SELECT SEQUENCE_NAME FROM ALL_SEQUENCES "
	                + " WHERE SEQUENCE_OWNER = '" + String(sUIDPath).toUpperCase() + "' "
	                + " AND SEQUENCE_NAME='SEQ_UID'";
	    var tbl = OpenTable("s",sSQL);
	    if (tbl.isEmpty())
	    {
	    	nUID = inputStartUID();
	    	sSQL = "CREATE SEQUENCE " + sUIDPath + ".SEQ_UID INCREMENT BY 1 START WITH "+ nUID;
	    }
	    else
	    	return;
	}
	if (SUBD == DERBY || SUBD == DB2 || SUBD == POSTGRE || SUBD == H2)
	{
		if (IsTableEx(sUIDSys,"TUID"))
			return;
		nUID = inputStartUID();
		sSQL = "CREATE TABLE " 
			 + sUIDTable
			 + "(FUID " + SqlType("LONG") + ")";
		sIns = "INSERT INTO " + sUIDTable + "(FUID) values ("+ nUID +")";
	}
	var bRet = true;
	var isOk = ExecuteSQL(sSQL,this.showErr);
	if(!isOk)
	{
		var sMsg = UR("Не вдалося сворити таблицю "+ sUIDTable +" !|Не удалось создать таблицу "+ sUIDTable +" !");
		if(SUBD == ORACLE)
			sMsg = UR("Не вдалося сворити лічильник "+ sUIDPath + ".SEQ_UID !|Не удалось создать счетчик "+ sUIDPath + ".SEQ_UID !");
		sMsg += "\n"+ UR("Потрібно перевірити права доступу до "+ sUIDPath +".|Нужно проверить права доступа для "+ sUIDPath +".");
		alert(sMsg);
	}
	else//Tori 06.08.2012: вставлять запись нужно только если таблица создалась, т.к. если она по какой-то причине уже существует, то при добавлении новой записи летят Fwid-ы 
	{
		if (sIns != "")	
			bRet = ExecuteSQL(sIns,this.showErr);
	}
	if(bRet)
	{
		if(isOk)
		{
			var sMsg = UR("Встановлено UID = |Установлен UID = ") + nUID;
			if(nUID<=1)
			{
				sMsg += "\n"+ UR("При такому початковому значенні UID можуть виникнути проблеми!"
								+"|При таком начальном значении UID могут возникнуть проблемы!"
								);
			}
			alert(sMsg);
		}
	}
	else if(isOk)
	{
		var sMsg = UR("Не вдалося встановити початковий UID !"
					+"\nПотрібно перевірити права доступу до "+ sUIDPath +"."
					+"|Не удалось установить начальный UID !"
					+"\nНужно проверить права доступа для "+ sUIDPath +"."
					);
		alert(sMsg);
	}
	if (!isOk)
	{
		this.putLogMessage("Mod: не удалось");
		this.putLogMessage(sSQL);
		this.putLogMessage(lpProxy.getLastDBErrorMessage());
	}
	else
	{
		this.putLogMessage("OK");
	}
}

function inputStartUID()
{
	var sMsg = UR("Для коректної роботи програми\nпотрібно ввести початковий UID: "
				+"|Для корректрой работы программы\nнужно ввести начальный UID: ");
	var uid = input(sMsg, UR("Створення нового UID|Создание нового UID"), "1", 25);
	if(!uid)
		return 1;
	uid = String(uid).trim();
	if(uid=="" || !Number(uid) || Number(uid)<=0)
	{
		alert(UR("Не коректне значення UID!|Не корректное значение UID!"));
		return inputStartUID();
	}
	if(Number(uid)>0)
		return Number(uid);
	return 1;
}

/* сверяет поля индексов - стру и ДБ и возвращает, одинаковые ли они */
function DpDbMod_compareIndFlds(stTbl,struInd)
{
	var struFlds = String(getStruIndexFields(stTbl.table,struInd));
	if (struFlds == null)
		return false;
	struFlds = struFlds.split(",");
	if (SUBD == ORACLE || SUBD == POSTGRE)
		struInd = "I_" + stTbl.fullName + "_" + struInd;
	var dbFlds = getDBIndexFields(getPath(stTbl.base),stTbl.fullName,struInd);
	dbFlds = javaArrToScript(dbFlds);

	if (dbFlds.length != struFlds.length)
		return false;
	
	for(var i = 0; i < struFlds.length; i++)
	{
		var struFld = String(struFlds[i]).toUpperCase();
		struFld = allt(struFld.replace("DESC","")).toUpperCase();;
		for (var j = 0; j < dbFlds.length; j++)
		{
			if (String(dbFlds[j]).toUpperCase() == struFld)
			{
				dbFlds.splice(j,1);
			}
		}
	}
	if (dbFlds.length > 0)
	{
		return false;
	}
	return true;
}

function javaArrToScript(jArr)
{
	var Ret = new Array();
	for (var i = 0; i < jArr.length; i++)
	{
		Ret[i] = jArr[i];
	}
	return Ret;
}

function DpDbMod_doSmartReindex(stTbl)
{
	trace(">>>> smartReindex");
	var struInds = getStruIndexes(stTbl.pattern);
	var dbInds = getIndexes(getPath(stTbl.base),stTbl.fullName);
	if (dbInds == null)
		dbInds = new Array();
	if (struInds == null)
		return;
	struInds = javaArrToScript(struInds);
	dbInds = javaArrToScript(dbInds);
	
	var toCreate = new Array();
	var toDrop = new Array();
	
	for(var i = 0; i < struInds.length; i++)
	{
		var sStruInd = String(struInds[i]);
		var bCreate = true;
		for (var j = 0; j < dbInds.length; j++)
		{
			if (sStruInd.toLowerCase() == String(dbInds[j]).toLowerCase() 
				|| ("I_" + stTbl.table + "_" + sStruInd).toLowerCase() == String(dbInds[j]).toLowerCase())
			{
				bCreate = false;
				trace("no create>>> " + sStruInd);
				dbInds.splice(j,1);
				break;
			}
		}
		
		if (bCreate == false)
		{
			bCreate = !this.compareIndFlds(stTbl,sStruInd);
			if (bCreate)
			{
				toDrop.push(sStruInd);
				toCreate.push(sStruInd);
			}
		}
		else
			toCreate.push(sStruInd);
	}
	for( var i = 0; i < dbInds.length; i++)
	{
		toDrop.push(dbInds[i]);
	}
	for (var a in toDrop)
		trace("drop>>>> " + toDrop[a]);
	for (var a in toCreate)
		trace("create>>>> " + toCreate[a]);
	return;
	this.DropIndexes(stTbl,toDrop);
	this.CreateIndexes(stTbl,toCreate);
}

function tableModInfo()
{
	this.base = "";
	this.sys = "";
	this.table = "";
	this.pattern = "";
	
	this.fullName = "";
	
	this.exists = false;
	this.domod = false;
	this.reindex = false;
}

function FieldInfo(sName,sType,sDef)
{
	this.name = sName;
	this.type = sType;
	this.def = sDef;
	this.dptype = "";
	
	this.getName = new Function("return this.name;");
	this.getType = new Function("return this.type;");
	this.getDefault = new Function("return this.def;");
	this.getDpType = new Function("return this.dptype");
	
	this.setName = FieldInfo_setName;
	this.setType = FieldInfo_setType;
	this.setDefault = FieldInfo_setDefault;
	this.setDpType = FieldInfo_setDpType;
}

function DpDbMod_dropViews()
{
	var arrViews = getStruViews();
	var isDropped;
	
	// Повторяем цикл до тех пор, пока что-то удаляется.
	do
	{
		isDropped = false;
		
		for (var i = arrViews.length - 1; i >= 0; i--)
		{
			var oView = arrViews[i];
			var sName = oView.getName();
			var sQuery =  String(oView.getQuery());
			var sSQL = "drop view ^" + sName;
			
			var bRet;
			if (SUBD == MSSQL)
			{
				bRet = ExecuteSQLEx(oView.getBase(),"drop view " + sName, false);
			}
			else
			{
				if (SUBD == POSTGRE || SUBD == MYSQL || SUBD == H2)
					sSQL += " CASCADE";
				bRet = ExecuteSQL(sSQL, false);
			}
			
			isDropped = isDropped || bRet;
			
			if (SUBD == MYSQL)
			{
				ExecuteSQL("drop table ^" + sName, false);
			}		
		}
		
	} while(isDropped)
}

function DpDbMod_createViews(bShowError)
{
	var arrViews = getStruViews();
	var arrDone = new Array();
	var toRepeate;
	var errMessages;
	if(typeof(bShowError)=="undefined")
		bShowError = true;
	do
	{
		toRepeate = false;
		errMessages = "";
		
		for (var i = 0; i < arrViews.length; i++)
		{
			if (arrDone[i])
				continue;
			
			var oView = arrViews[i];
			var sName = oView.getName();
			var sQuery =  String(oView.getQuery());		
			
			if (!sQuery)
				continue;
			if(arrDone[sName])
				continue;
						
			sQuery = parseQuery(sQuery);
			var sSQL = "create view ^" + sName + " as " + sQuery;
			if (SUBD == MSSQL)
			{
				bRet = ExecuteSQLEx(oView.getBase(),"create view " + sName + " as " + sQuery, false)
			}
			else if (SUBD == ORACLE)
			{
				var sSQL = "create view ^" + sName + " AS " + sQuery.replace(/ AS /gi," ");		
				bRet = lpProxy.ExecuteSQL(sSQL, false)
				//continue;			
			}
			else if (SUBD == MYSQL)
			{
				var sSQL = "create SQL SECURITY INVOKER view ^" + sName + " as " + sQuery;		
				bRet = lpProxy.ExecuteSQL(sSQL, false)
				//continue;			
			}
			
			else
				bRet = ExecuteSQL(sSQL, false);
			
			if (bRet)
			{
				arrDone[sName] = true;
				toRepeate = true;
			}
			else
				errMessages += "\n"
					+ lpProxy.getLastDBErrorMessage()
		}
		
		// this.createNMKLFullView();
	} while (toRepeate)
		
	if (errMessages && bShowError)
		_alert("Ошибки при создании VIEWS:\n" + errMessages)
}

function parseQuery(s)//парсит запросс и заменяет выражение в фигурных скобках {expr} на eval(expr)
{
	var posb = pose = 0;
	var sb,se;
	var k = 0;
	while(s.indexOf("{")!=-1)
	{
		posb=s.indexOf("{");
		pose=s.indexOf("}");
		if(pose==-1)
			break;
		sb = s.substr(0,posb);
		expr = s.substring(posb+1,pose);
		se = s.substr(pose+1);
		s = sb+eval(expr)+se;
		if(k++>100)//на всякий случай выход из цикла
			break;
	}
	return s;
}

function DpDbMod_createNMKLFullView()
{
	var sName = "LISTNMKLFULL";
	var sQuery = this.getViewWithExtSQL("^LISTNMKL", "CL_NMK", null, null);
				
	var sSQL = "create view ^" + sName + " as " + sQuery;
	if (SUBD == MSSQL)
	{
		ExecuteSQLEx("CL_MDB","create view " + sName + " as " + sQuery, true)
		return;					
	}
	if (SUBD == ORACLE)
	{
		var sSQL = "create view ^" + sName + " AS " + sQuery.replace(/ AS /gi," ");		
		lpProxy.ExecuteSQL(sSQL, true);
		return;					
	}
	
	ExecuteSQL(sSQL, true);
	
}



function DpDbMod_getViewWithExtSQL(mainTbl, extType, par1, par2)
{
	var sExtTbl = getPath("EXT") + ".";
	
	if (SUBD == MSSQL)
		sExtTbl += ".";
		
	sExtTbl +=  "CL_NMK";   //TODO 	 
	
	var extTbl = OpenTable("e" + extType, par1, par2);
	
	var extMap = javaHash2Script(extTbl.getExtInfoMap());
	
	var sFields = " m.* "
	var sTables  = mainTbl + " m left join " + sExtTbl + " ext on m.fwid = ext.fmainwid";
	
	var i = 0;
	for (var lbl in extMap)
	{
		var sFld = "ext.F" + lbl;
		var oDefault = extMap[lbl].E_Default;
		var sFullFld = sFld + " as EXT_" + lbl.toUpperCase();
		
		var sType = String(extMap[lbl].getType());
		
		var sExpr = sFld;
		
		if (oDefault != null)
		{
			var sDefault = sqlTo(oDefault);		
			
			
			if (SUBD == ORACLE && typeOf(oDefault).toLowerCase() == "string")
			{
				sExpr = IIF(sFld + " is null", sDefault, "TO_CHAR(" + sFld + ")" );
				sFullFld = sExpr + " as EXT_" + lbl.toUpperCase();
			}
			else
			{
				sExpr = IIF(sFld + " is null", sDefault, sFld);
				sFullFld = sExpr + " as EXT_" + lbl.toUpperCase();
			}
		}
		
		sFields += ", "+ sFullFld;
		
		if (sType == "V")
		{
			sFields += ", "+ " ( SELECT val"+ i + ".FNAZVS " 
					+ "FROM ^CL_VALUT val"+ i + " WHERE val" + i +".FKOD = " + sExpr 
					+ " ) AS EXT_" + lbl.toUpperCase() + "_TXT" ;
		}
		else if (sType.startsWith("A")
			|| sType.startsWith("R0#") )
		{
			var clcl = -1; 
			if (sType.startsWith("A"))
				clcl = parseInt(sType.substring(1));
			else
				clcl = parseInt(sType.substring(3));
				
			var sAlias = "ext" + i;
			
			sFields += ", "+ sAlias + ".FTXT AS EXT_" + lbl.toUpperCase() + "_TXT" ;
			
			sTables += " left join ^LISTCL " + sAlias + " on " + sAlias + ".fcl = " + clcl
					+ " and " + sAlias + ".fcod = " + sExpr;
				
		}
		else if (sType == "NMK")
		{
			var sAlias = "ext" + i;
			
			sFields += ", "+ sAlias + ".FTXTS AS EXT_" + lbl.toUpperCase() + "_TXT, " 
				+ sAlias + ".FCOD AS EXT_" + lbl.toUpperCase() + "_COD" ;
			
			sTables += " left join ^CL_NMK " + sAlias + " on " + sAlias + ".fwid = " + sExpr;
			
		}
		
		i++;			
	}
	
	
	
	return " SELECT " + sFields + " from " + sTables;
	
}



function DpDbMod_recreateViews()
{
	this.dropViews();
	this.createViews();
}

function FieldInfo_setName(sName){ this.name = sName;}
function FieldInfo_setType(sType){ this.type = sType;}
function FieldInfo_setDefault(sDef){ this.def = sDef;}
function FieldInfo_setDpType(sDpType){ this.dptype = sDpType;}