/*
	Объект для ввода выражения для документа: DpDcExpr
	(C) ДЕБЕТ Плюс, 1999

	Конструктор DpDcExpr:
		DpDcExpr(mode, doc, nop)
			mode - режим ввода выражения
				mode = "R" - выражение для чтения
				mode = "W" - выражение для записи
				mode = "XSUB" - выражение для получения элемента
				                основного справочника для расширения
				                по подсправочнику
				mode = "XSUBH" - то же, но для расширений заголовка
			doc - метка документа
			   doc = "CLCL" - справочник аналитики
			nop - номер хоз. операции документа.
	
*/
include("sys\\docinfo.js");

function DpDcExpr(mode, doc, nop, ctrl)
{
	RO("DpDcExpr", this);
	this.linkCtrl = DpDcExpr_linkCtrl;
	this.addCl_schet = DpDcExpr_addCl_schet;
	this.menuInitial = DpClExpr_menuInitial;
	this.menuChoose = DpDcExpr_menuChoose;
	this.setValue = DpDcExpr_setValue;
	this.getValue = DpDcExpr_getValue;
	this.setTxt = DpDcExpr_setValue; // для совместимости
	this.getTxt = DpDcExpr_getValue;
	
	this.getDoc = DpDcExpr_getDoc;
	this.getNop = DpDcExpr_getNop;
	
	this.addPrefix = DpDcExpr_addPrefix;
	this.getPrefix = DpDcExpr_getPrefix;
	this.convertVarType = DpDcExpr_convertVarType;

	this.mode = mode.toUpperCase();
		
	this.doc = String(doc);
	this.isReg = this.getDoc()=="_R";
	this.nop = this.isReg?nop:Number(nop);

	
	
	this.ctrl = new Object();
	this.ctrl.text = "";

	this.linkCtrl(ctrl);

	this.aItems = new Array();
	
	this.prefixes = new Array();
	this.jID = "";
	this.varType = "";
}

function DpDcExpr_addCl_schet(objSc, objSu, objSt)
{
	this.objSc = objSc;
	this.objSu = objSu;
	this.objSt = objSt;
}

function DpDcExpr_addPrefix(sType,sPrefix)
{
	this.prefixes[sType] = sPrefix;
}

function DpDcExpr_getPrefix(sType)
{
	if (this.prefixes[sType])
		return this.prefixes[sType] + ".";
	return "";
}

function DpDcExpr_linkCtrl(ctrl)
{
	if(!ctrl)
		return;

	if(ctrl.DpType!="DpFork" && !JAVA)
	{
		debug("К объекту DpDcExpr можно привязать только поле ввода типа DpFork");
		return;
	}
	
	if(typeof ctrl.MenuHandler != "undefined")
	{
		ctrl.MenuHandler(this, "menuChoose");
		ctrl.MenuInitial(this, "menuInitial");
	}
//-	ctrl.text = this.ctrl.text;

	this.ctrl = ctrl;
}

function DpClExpr_menuInitial()
{
	include ("doc\\DpDoc.js");
	this.aItems.length = 0;
	this.childsId = new Array();
	var Ftype;
	with(this.ctrl)
	{
		this.oDoc = new DpDoc(this.doc,this.nop);
		if (!this.isReg)
		{
			AddItem("DOCVAR", UR("Змінні заголовку (по типу)|Переменные заголовка (по типу)"));
			AddItem("DOCVAR0", UR("Змінні заголовку (всі)|Переменные заголовка (все)"));
			this.childsId = this.oDoc.getChildIDs();
			if (this.childsId.length == 1)
			{
				AddItem("ROWVAR."+this.childsId[0], UR("Змінні рядкiв|Переменные строк"));
			}
			else
				for(var j = 0; j < this.childsId.length; j++)
				{
					AddItem("ROWVAR."+this.childsId[j], UR("Змінні рядкiв|Переменные строк ")+this.childsId[j]);
				}
				
			AddItem("USERVAR", UR("Змінні користувача|Переменные пользователя"));	
				
			if(strIn("XSUB", this.mode))
				AddItem("2", UR("Розширення|Расширения"));
			else
			{
	
				if (this.nop)
					AddItem("2", UR("Розширення заголовку папки " + this.nop + "|Расширения заголовка папки " + this.nop));
				AddItem("HEXTDOCZ", UR("Розширення заголовку загальнi|Расширения заголовка общие"));
				
				var chIDS = this.oDoc.getChildClasses();
				if (chIDS.length > 0)
				{
					if (chIDS.length == 1)
					{
						if (this.nop)
							AddItem("REXT_" + chIDS[0], UR("Розширення рядків документів папки "+ this.nop + "|Расширение строк документов папки " + this.nop));
						AddItem("REXTZ_" + chIDS[0], UR("Розширення рядків документів загальнi|Расширение строк документов общие"));
						
					}
					else
					{
						//AddItem("+++",UR("Розширення рядків документів","Расширение строк документов"));
						for (var nID = 0; nID < chIDS.length; nID++)
						{
							if (this.nop)
								AddItem("REXT_" + chIDS[nID],UR("Розширення рядків | Разширения строк ") + "(" + chIDS[nID] + ") папки "+ this.nop);
							AddItem("REXTZ_" + chIDS[nID],UR("Розширення рядків | Разширения строк ") + "(" + chIDS[nID] + ") " + UR("Загальнi|Общие"));
							
						}
						//AddItem("---","");
					}
				}
				
			}
		}
			
		if(this.objSc)
			AddItem("4", UR("План рахунків|План счетов"));
				
		AddItem("REGVAR", UR("Змінні реєстрації|Переменные регистрации"));	

		if (!this.isReg)
		{
			var bFirst = true;
			var f = new Object();   
			for (var i = 0; i < this.oDoc.getVarsInfo().length;i++)
	     	{
		    	f.Fvar = this.oDoc.getVarsInfo()[i].name;
		    	if (f.Fvar.substr(0,1) != "H")
		    		continue;
		    		
		    	f.Frem = this.oDoc.getVarsInfo()[i].rem;
		    	if (this.oDoc.getVarsInfo()[i].objectType != "")
		    	{
			    	switch (String(this.oDoc.getVarsInfo()[i].objectType).toLowerCase())
			    	{
			    		case "sc": 
			    		case "su":
			    		case "st":
			    		case "cl1":
			    		case "cl2":
			    		case "cl3":
			    			Ftype = String(this.oDoc.getVarsInfo()[i].objectType).toUpperCase();
			    			break;
			    	}
		    	}
		    	else
		    	{
			    	switch (this.oDoc.getVarsInfo()[i].dataType)
			    	{
			    		case 1: 
			    			Ftype = "C";
			    			break;
			    		case 2:
			    			Ftype = "N";
			    			break;
			    		case 3:
			    			Ftype = "D";
			    			break;
			    		case 5:
			    			Ftype = "L";
			    			break;
			    	}
		    	}
		    	
		    	if (Ftype == this.convertVarType(this.varType))
		    	{
		    		if (bFirst)
		    		{
		    			bFirst = false;
		    			AddItem("", "");
		    		}			
					AddItem("SUBMENU_"+ f.Fvar, f.Fvar + " (" + 
						( String(f.Frem).length > 20 ? String(f.Frem).substr(0, 20) + "..." : String(f.Frem)) + ")");			
		    	}	
		    }
		}			
	}	
}

function DpDcExpr_menuChoose(n)
{
	var vName = "";

	var par = new Object();
	par.doc = this.getDoc();
	par.nop = this.getNop();
	par.isZaval = true;
	par.ret = new Object();
	par.ret.fvar = String(this.ctrl.text).trim().toUpperCase(); //"";
	if (par.ret.fvar.startsWith("PAR."))
		par.ret.fvar = par.ret.fvar.substr(4);
		
	for(var j = 0; j < this.childsId.length; j++)
	{
		if (n == "ROWVAR." + this.childsId[j])
		{
			if(this.mode=="W")
				par.writable = true;
			par.WhereI = j+1;
			par.objDoc = this.oDoc;
			par.vars = this.childsId[j];
			par.type = this.varType;
			showWindow("l_vardoc.js", SW_MODAL,par);
			if(par.escape==false)
				vName = this.getPrefix("ROWVAR") + par.ret.fvar;
		}
	}
	
	if (n.substr(0,5) == "REXT_" || n == "2" || n == "HEXTDOCZ" || n.substr(0,6) == "REXTZ_" )
	{
		par.ret = new Object();
		if(strIn("XSUB", this.mode))
			if(this.doc=="CLCL")
			{
				par.vid = "CL";
				par.cl = this.getNop();
			}
			else
			{
				alert("Иерархические справочники реализованы только для расширений аналитики");
				return;
			}	
		else
			par.vid = ((n=="2" || n == "HEXTDOCZ" )?"H":"R");
		par.doc = this.getDoc();
		if (n.substr(0,5) == "REXT_")
			par.doc += "." + n.substr(5,n.length-1);
		else if (n.substr(0,6) == "REXTZ_")
		{
			par.doc += "." + n.substr(6,n.length-1);
		}
		
		if (n == "HEXTDOCZ" || n.substr(0,6) == "REXTZ_")
			par.nop = 0;
		else
			par.nop = this.getNop();
		par.ret.Flabel = "";
		par.isZaval = true; 
		showWindow("l_extent.js", SW_MODAL, par);
		if(par.escape==false)
		{
			if(this.mode=="XSUB")
			{
				vName = "getx('" + par.ret.Flabel + "')";
			}
			else
			{
				var sPref = "";
				if (n == "2" || n == "HEXTDOCZ")
					sPref = this.getPrefix("HEXT");
				else
					sPref = this.getPrefix("REXT");
				vName = sPref + "X" + par.vid + par.ret.Flabel;
			}
		}
		
	}
	if (n.startsWith("SUBMENU_"))
	{
		vName = n.substr(8);
	}
	switch (n)
	{
	case "DOCVAR":
	case "DOCVAR0":
		if(this.mode=="W")
			par.writable = true;
		par.WhereI = 0;
		par.objDoc = this.oDoc;
		par.vars = "H";
		if (n == "DOCVAR")
			par.type = this.varType;
		showWindow("l_vardoc.js", SW_MODAL,par);
		if(par.escape==false)
			vName = this.getPrefix("DOCVAR") + par.ret.fvar;
			
		break;
	case "USERVAR":
		if(this.mode=="W")
			par.writable = true;
		par.WhereI = 0;
		par.objDoc = this.oDoc;
		par.vars = "P";
		par.type = this.varType;
		showWindow("l_vardoc.js", SW_MODAL,par);
		if(par.escape==false)
			vName = this.getPrefix("USERVAR") + par.ret.fvar;
	
		break;
	case "2":
	case "3":
		
		break;
	case "4":
		var par = new Object();

		par.ret = new Object();
		par.ret.Fschet = Number(this.objSc.getValue());
		par.ret.Fschet = isNaN(par.ret.Fschet)? 0: par.ret.Fschet;
		par.ret.Fsubschet = Number(this.objSu.getValue());
		par.ret.Fsubschet = isNaN(par.ret.Fsubschet)? 0: par.ret.Fsubschet;
		par.ret.Fstat = Number(this.objSt.getValue());
		par.ret.Fstat = isNaN(par.ret.Fstat)? 0: par.ret.Fstat;

		showWindow("l_clsch.js", SW_MODAL, par);
		
		if(!par.escape)
		{
			this.objSc.setValue(String(Math.round(Number(par.ret.Fschet))));
			this.objSu.setValue(String(Math.round(Number(par.ret.Fsubschet))));
			this.objSt.setValue(String(Math.round(Number(par.ret.Fstat))));
		}
		return;
	case "REGVAR":
		var par = new Object();
		par.zaval = true;
		par.ret= new Object();
		par.ret.Fvar = "";
		par.jrnl = this.jID;
		if (typeof(GetNumJournal) == "function")
		{
			par.numJournal = GetNumJournal();
		}
		
		showWindow("l_varreg.js", SW_MODAL, par);
		if(par.escape==false)
			vName = par.ret.Fvar;
		break;
	default:
		//if (!String(n).startsWith("ROWVAR."))
		//if (!vName)
		//	vName = n;
		break;
	}
	
	if(vName)
	{
		switch(this.mode)
		{
		case "R":
		case "XSUB":
			this.ctrl.selText = vName;
			break;
		case "W":
			this.ctrl.text = vName;
			break;
		}
	}
}

function DpDcExpr_getDoc()
{
	return typeof(this.doc)=="object"? this.doc.value: this.doc;
}

function DpDcExpr_getNop()
{
	var retNop = this.nop;
	if (typeof(this.nop) == "object")
	{
		retNop = retNop.value;
	}
	return retNop;
}

function DpDcExpr_setValue(newExpr)
{
	this.ctrl.text = newExpr? newExpr: "";
}

function DpDcExpr_getValue()
{
	return this.ctrl.text;
}

function DpDcExpr_convertVarType(varType)
{
	if (varType == "DATE" || varType == "DATETIME")
	{
		return "D";
	}
	else if (String(varType).substr(0, 4) == "TEXT")
	{
		return "C";
	}
	else if (varType == "SHORT" || varType == "LONG" || varType == "DOUBLE" || varType == "CURRENCY" || varType == "BYTE")
	{
		return "N";
	}
	else if (varType == "BIT")
	{
		return "L";
	}
	else 
	{
		return varType;
	}
}