include ("sys\\docinfo.js")
include ("objects\\DpEval.js")
include ("doc\\DpDoc.js")

function DpDocTransformer(sDoc, nNop, sNid)
{
	this.turnNaklRow = true;
	if (objTypeOf(sDoc) == "DpDoc")
	{
		this.oDoc = sDoc;
		this.sDoc = sDoc.sDocLbl;
		this.nNop = sDoc.nNop;
		this.sNID = sDoc.getID();
	}
	else
	{
		this.sDoc = sDoc;
		this.nNop = nNop;
		this.sNID = sNid;
	}
	this.isMass = false;
	this.sLinkId = null;
	this.sNidArray = null;
	this.bSingleton = false;
	this.chooseLink = DpDocTransformer_chooseLink;
	this.transform = DpDocTransformer_transform;
	this.transform2 = DpDocTransformer_transform2;
	this.fillDocVars = DpDocTransformer_fillDocVars;
	this.isDocToExists = DpDocTransformer_isDocToExists;
	this.delLinkedDocs = DpDocTransformer_delLinkedDocs;
	//this.transform();
} 

function DpDocTransformer_transform(sNid, bUsePreviouseLink, bNoAsk)
{
	if(!bNoAsk)
	{
		if(this.isMass)
		{
			var sMsg = ru("Вы уверены, что хотите создать связанные документы?"
						,"Ви впевнені, що бажаєте створити зв'язані документи?"
						);
			if(!confirm(sMsg, null, "DpDocTransformer_transform"))
			{
				WriteParameter(getSysName() +"_DpDocTransformer_transform", "");
				return;
			}
		}
		else
		{
			if(!confirm(ru("Вы уверены, что хотите создать связанные документы?","Ви впевнені, що бажаєте створити зв'язані документи?")))
				return;
		}
	}
	this.sNidArray = null;
	if (typeof(sNid) != "undefined" && sNid != null)
		this.sNID = sNid;
		
	if(!this.chooseLink(bUsePreviouseLink))
		return;
	//var hTbl = docinfo("HFILE",this.sDoc);
	//var sSQL = "select * from "+ hTbl + " where fwid = "+sqlTo(this.sWID);
	//this.hTbl = OpenTable("m",sSQL);
	//this.hTbl.extTie("H",this.sDoc,this.nNop);
	//this.oEval = new DpEval(); 
	//this.oEval.setDoc(this.sDoc, this.nNop);
	//this.oEval.setTable(this.hTbl);	
}

function DpDocTransformer_transform2(sNidArray, bUsePreviouseLink)
{
	if(this.isMass)
	{
		var sMsg = ru("Вы уверены, что хотите создать связанные документы?"
					,"Ви впевнені, що бажаєте створити зв'язані документи?"
					);
		if(!confirm(sMsg, null, "DpDocTransformer_transform2"))
		{
			WriteParameter(getSysName() +"_DpDocTransformer_transform2", "");
			return;
		}
	}
	else
	{
		if(!confirm(ru("Вы уверены, что хотите создать связанные документы?","Ви впевнені, що бажаєте створити зв'язані документи?")))
			return;
	}
	if (typeof(sNidArray) != "undefined" && sNidArray != null)
		this.sNidArray = sNidArray;
		
	if(!this.chooseLink(bUsePreviouseLink))
		return;
	//var hTbl = docinfo("HFILE",this.sDoc);
	//var sSQL = "select * from "+ hTbl + " where fwid = "+sqlTo(this.sWID);
	//this.hTbl = OpenTable("m",sSQL);
	//this.hTbl.extTie("H",this.sDoc,this.nNop);
	//this.oEval = new DpEval(); 
	//this.oEval.setDoc(this.sDoc, this.nNop);
	//this.oEval.setTable(this.hTbl);	
}

function DpDocTransformer_chooseLink(bUsePreviouseLink)
{
	if (typeof(bUsePreviouseLink) == "undefined" || bUsePreviouseLink == null)
		bUsePreviouseLink = false;
		
	this.arrIDParentDoc = new Array();
	var par = new Object();
	par.doc = this.sDoc;
	par.nop = this.nNop;
	this.arrDocs = new Array();
	
	if (!bUsePreviouseLink || this.sLinkId == null)
	{
		par.ret = new Object();
		par.ret.fwid = null;
		par.ret.fdoc = null;
		par.ret.fnop = null;
		par.ret.fissingleton = null;
		par.ret.fissingletontype = null;
		par.ret.ffilt = null;
		showWindow("l_cl_linkdoc.js",SW_MODAL,par);
		if(par.escape) return false;
		
		this.sLinkId = par.ret.fwid;
		this.sDocTo = par.ret.fdoc;
		this.nNopTo = par.ret.fnop;
		this.filter = par.ret.ffilt;
	}
	
	var oCl_linkdoc = getSnap("SELECT fcond, fhaving, fissingleton, fissingletontype, fisfast"
		+ " FROM ^cl_linkdoc WHERE fwid=" + this.sLinkId
		)
	this.fcond = oCl_linkdoc[0];	
	this.fhaving = oCl_linkdoc[1];
	this.bSingleton = oCl_linkdoc[2];
	this.bSingletonType = oCl_linkdoc[3];
	this.bFast = oCl_linkdoc[4];
	
	if (this.sNidArray != null && this.sNidArray.length > 0)
	{
		this.isMass = true;
		var docTo = new DpDoc(this.sDocTo,this.nNopTo);
		this.oDoc = new DpDoc(this.sDoc,this.nNop);
		var nSkip = 0;
		if (this.bSingleton || this.bSingletonType)
		{
			for (var i = 0; i < this.sNidArray.length; i++)
			{				
				if (!this.isDocToExists(this.sNidArray[i], docTo, !this.bSingleton && this.bSingletonType))
					break;
				nSkip++;	
				
			}
			
			if (nSkip == this.sNidArray.length)
			{
				if (!this.isMass)
					alert("Ошибка при создании документа. У всех документов уже есть связанные документы");
				return;
			}
		}
		
		this.oDoc.loadByID(this.sNidArray[nSkip]);
		this.arrDocs[0] = this.oDoc;
		setProgressRange(0, this.sNidArray.length - (nSkip+1));
		var j=0;
		for (var n = nSkip+1; n < this.sNidArray.length; n++)
		{
			
			if (this.isDocToExists(this.sNidArray[n], docTo, !this.bSingleton && this.bSingletonType))
			{
				nSkip++;
				continue;
			}
			
			var oDoc2 = new DpDoc(this.sDoc,this.nNop);			
			oDoc2.loadByID(this.sNidArray[n]);			
			this.arrDocs[this.arrDocs.length] = oDoc2;
			setProgressPos(++j, UR("Читання строк|Чтение строк"));
		}
		setProgressPos(0);
		if (nSkip > 0)
		{
			if (nSkip == this.sNidArray.length)
			{
				if (!this.isMass)
					alert("Ошибка при создании документа. У всех документов уже есть связанные документы");
				return;
			}
			else
			{
				if (!this.isMass)
					alert("Предупреждение. У " + nSkip + " документов уже есть связанные документы. Эти документы пропускаются");
			}
		}
	}
	else if (!this.oDoc || this.sNID != this.oDoc.getID())
	{
		this.oDoc = new DpDoc(this.sDoc,this.nNop);
		this.oDoc.loadByID(this.sNID);
		
		if (this.bSingleton || this.bSingletonType)
		{
			var docTo = new DpDoc(this.sDocTo,this.nNopTo);
			if (this.isDocToExists(this.sNID, docTo, !this.bSingleton && this.bSingletonType))
			{
				if(this.isMass)
				{
					var sMsg = "У текущего документа уже есть один связанный документ"
								+"\nПереформировать этот документ?";
					if(!confirm(sMsg, null, "DpDocTransformer_chooseLink"))
					{
						WriteParameter(getSysName() +"_DpDocTransformer_chooseLink", "");
						return;
					}
				}
				else 
				{
					if (!confirm("У текущего документа уже есть один связанный документ"
							+ "\nПереформировать этот документ?")
							)
					{
						return;
					}
				}
				this.delLinkedDocs(this.sNID, docTo, !this.bSingleton && this.bSingletonType);
			}
		}
		this.arrDocs[0] = this.oDoc;
	}

	
	if (this.filter && String(this.filter).trim() != "")
	{
		for (var i = 0; i < this.arrDocs.length; i++)
		{
			var oDoc = this.arrDocs[i];
			
			if(oDoc.gotoFirstRow())
			{
				while(oDoc.gotoNextRow())
				{
					var oRow = oDoc.getCurrRow();
					var ret = oRow.eval(this.filter);				
					if (!ret)
					{
						oRow.setVar("ISSKIPPED", true);
					}
						
				}
			}
		}
	}

	var oSnap = getSnap("select fgroupby from ^cl_linkdoc where fwid = " + sqlTo(this.sLinkId));	
	if (oSnap != null && oSnap[0] != null && oSnap[0] != "")
	{
		// связь между документами ОДИН-КО-МНОГИМ
		var arrGroupBy = new Array();
		var fields = oSnap[0].split(",");

		
		for (var j = 0; j < this.arrDocs.length; j++)
		{
			var oDoc = this.arrDocs[j];
			if(oDoc.gotoFirstRow())
			{
				while(oDoc.gotoNextRow())
				{
					var oRow = oDoc.getCurrRow();
					if (oRow.getVar("ISSKIPPED"))
						continue;
					var key = "";
					var objVal = new Array();
					for (var i = 0; i < fields.length; i++)
					{
						var value = oRow.eval(allt(fields[i]));
						key += String(value) + "|";
						objVal[allt(fields[i])] =  value;
					}
					arrGroupBy[key] = objVal;	
				}
			}
		}
		
		var nCount = 0;
		for (var i in arrGroupBy)
			nCount++;
		
		if (nCount > 1)
		{
			//setProgressRange(0, nCount);
			var j = 0;
			for (var i in arrGroupBy)
			{
				this.oDocTo = new DpDoc(this.sDocTo,this.nNopTo);
				this.fillDocVars(fields, arrGroupBy[i]);
				//setProgressPos(++j, UR("Формування документiв:|Формирование документов:") + " " + j+ "/" + nCount);
				WAIT(UR("Формування документiв:|Формирование документов:") + " " + j+ "/" + nCount);
			}
			//setProgressPos(0);
			CLEARWAIT();
		}
		else
		{
			this.oDocTo = new DpDoc(this.sDocTo,this.nNopTo);
			this.fillDocVars(null, null);
		}
	}
	else
	{
		if (this.fcond)
		{
			if (!this.arrDocs[0].eval(this.fcond))
			{
				if (!this.isMass)
					alert("Условия для создания связанного документа не выполенно")
				return ;
			}
		}
		
		// связь между документами ОДИН-К-ОДНОМУ
		this.oDocTo = new DpDoc(this.sDocTo,this.nNopTo);
		this.fillDocVars(null, null);
	}		
	
	this.oDocTo.clear();
	this.oDoc.clear();
	
	return true;
}

function DpDocTransformer_fillDocVars(groupby_vars, groupby_vals)
{
	this.arrIDParentDoc = new Array();
	
	if (groupby_vars == null)
	{
	
		if (typeof(this.sNidArray) == "undefined" || this.sNidArray == null)
			this.arrIDParentDoc[Number(this.sNID)] = true;
	}
	
	// Header
	var m = new Object();
	var sSQL = "select fvar,fvalue from " 
		+ "^cl_linkvars where flink_id = " + sqlTo(this.sLinkId)
		+ " AND FISROW = " + sqlFalse;
	var tbl = OpenTable("s",sSQL);
	
	var currDoc = this.arrDocs[0];
	var startRow = null;
	
	var bFindRow = false;
	if(currDoc.hasRows())
	{
		for (var j = 0; j < this.arrDocs.length; j++)
		{
			currDoc = this.arrDocs[j];
			if(currDoc.gotoFirstRow())
			{
				while (currDoc.gotoNextRow())
				{
					var currRow = currDoc.getCurrRow();						
					if (currRow == null || currRow.getVar("ISSKIPPED"))
					{
						continue;
					}
					
					if (groupby_vars != null)
					{
						// - первую строку, удовлетворяющую условиям группировки (если с группировкой) 
						var bSkipRow = false; 
						for (var i = 0; i < groupby_vars.length; i++)
						{
							if (String(currRow.getVar(groupby_vars[i])) != String(groupby_vals[groupby_vars[i]]))
							{
								bSkipRow = true;
								break;						
							}
						}
						
						if (!bSkipRow)
						{
							bFindRow = true;
							startRow = currRow;
							break;
						}
					}
					else
					{
						startRow = currRow;
						bFindRow = true;
						break;
					}
										
				}
			}
			if(bFindRow)
				break;
		}
	}
	
	if(!bFindRow)
	{
		currDoc = this.arrDocs[0];
		if(currDoc.hasRows() && currDoc.gotoFirstRow())
		{
			currDoc.gotoNextRow();
			startRow = this.oDoc.getCurrRow();
		}
	}
	
	while (!tbl.isEOF())
	{		
		var sFld = String(tbl.getValue("FVAR"));
		var sValue = String(tbl.getValue("FVALUE"));
		sFld = sFld.trim();
		if (sValue && sValue != "" && sValue != "null")
		{	
			var oVal = null;
			if (sValue.substr(0,1) == "R")
			{
				if (startRow != null)
					oVal = startRow.eval(String(sValue));
			}
			else
			{
				oVal = currDoc.eval(sValue);
			}
			
			if (sFld.substr(0,4).toLowerCase() == "ext.")
			{
				sFld = sFld.substr(4);
				this.oDocTo.setExt(sFld.toUpperCase(),oVal);
			}
			else if (sFld.indexOf(".") == -1)
			{
				this.oDocTo.setVar(sFld.toUpperCase(),oVal);
			}
		}
		
		tbl.MoveNext();
	}
	tbl.close();
	
	this.oDocTo.autoNo = new dpAutoNo(this.oDocTo);
	var newDocNum = this.oDocTo.autoNo.get();
	this.oDocTo.setVar("HNOM", newDocNum);
	this.oDoc.setVar("NEWNOM", newDocNum);

	// ES: Обработка статических строк (FROWNUM > 0). 
	var sSQL = "select FROWNUM from ^cl_linkvars where flink_id = " + sqlTo(this.sLinkId)
		+ " AND FISROW = " + sqlTrue
		+ " AND FVALUE<>" + sqlEmpStr
		+ " AND FROWNUM > 0"
		+ " GROUP BY FROWNUM";
	var tblRowNums = OpenTable(sSQL);
	for (; !tblRowNums.isEOF(); tblRowNums.MoveNext())
	{
		
		var sSQL = "select fvar,fvalue,FROWNUM from " 
			+ "^cl_linkvars where flink_id = " + sqlTo(this.sLinkId)
			+ " AND FISROW = " + sqlTrue
			+ " AND FVALUE<>" + sqlEmpStr
			+ " AND FROWNUM = " + sqlTo(tblRowNums.getValue("FROWNUM"));
		var tbl = OpenTable("s",sSQL);	

		var oDocRow = null;
		var sRowClass = "";
		// создаем новую строку
		while (!tbl.isEOF())
		{		
			var sFld = String(tbl.getValue("FVAR")).trim();
			if (sFld.indexOf(".") != -1)
			{
				var n = sFld.indexOf(".");
				var sRowClass = sFld.substr(0,n);
				sFld = sFld.substr(n+1);
				
				// добавим строку
				if (oDocRow == null)
					oDocRow = this.oDocTo.createRow(sRowClass);
				
				var oVal = this.oDoc.eval(String(tbl.getValue("FVALUE")));
				if(sFld.toUpperCase().startsWith("EXT."))
					oDocRow.setExt(sFld.substr(4),oVal);
				else
					oDocRow.setVar(sFld.toUpperCase(),oVal);
			}
			
			tbl.MoveNext();
		}
		tbl.close();
		if (oDocRow != null)
		{
			if (groupby_vars == null)
			{
				// добавим последнюю строку если такая есть
				this.oDocTo.appendRow(sRowClass, oDocRow);
			}
			else
			{
				var bSkipRow = false; 
				for (var i = 0; i < groupby_vars.length; i++)
				{
					if (String(oDocRow.getVar(groupby_vars[i])) != String(groupby_vals[groupby_vars[i]]))
					{
						bSkipRow = true;
						break;						
					}
				}
				
				if (!bSkipRow)
				{
					// добавим последнюю строку если такая есть
					this.oDocTo.appendRow(sRowClass, oDocRow);
				}
			}
		}
		
		
	}		
	tblRowNums.close();
	// ES: Обработка строк для документов со строками (FROWNUM = 0). 
	var sSQL = "select fvar,fvalue,FROWNUM from " 
		+ "^cl_linkvars where flink_id = " + sqlTo(this.sLinkId)
		+ " AND FISROW = " + sqlTrue
		+ " AND FVALUE <> " + sqlTo("")
		+ " AND FROWNUM = 0";
	var tbl = OpenTable("s",sSQL);
	var numRow = 0;
	if (tbl.recordCount > 0)
	{
		for (var j = 0; j < this.arrDocs.length; j++)
		{
			var oDoc = this.arrDocs[j];
			if(oDoc.gotoFirstRow())
			{
				while(oDoc.gotoNextRow())
				{
					var currRow = oDoc.getCurrRow();									
					if (currRow.getVar("ISSKIPPED"))
					{
						continue;
					}
					var oDocRow = null;
					var sRowClass = "";
					// создаем новую строку
					while (!tbl.isEOF())
					{		
						var sFld = String(tbl.getValue("FVAR")).trim();
						if (sFld.indexOf(".") != -1)
						{
							var n = sFld.indexOf(".");
							sRowClass = sFld.substr(0,n);
							sFld = sFld.substr(n+1);
							
							// добавим строку
							if (oDocRow == null)
							{
								oDocRow = this.oDocTo.createRow(sRowClass);
								currRow.setVar("NEWROWID", oDocRow.getID());
							}
							
							var oVal = currRow.eval(String(tbl.getValue("FVALUE")));
							if(sFld.toUpperCase().startsWith("EXT."))
								oDocRow.setExt(sFld.substr(4),oVal);
							else
								oDocRow.setVar(sFld.toUpperCase(),oVal);
						}
						
						tbl.MoveNext();
					}
					if (oDocRow != null)
					{
						var parDocID = 0;
						parDocID = currRow.getVar("OLDPARENTID");
						if (!parDocID)
							parDocID = currRow.getVar("par.ID");
						if (groupby_vars == null)
						{
							// добавим последнюю строку если такая есть
							if (parDocID)
								this.arrIDParentDoc[Number(parDocID)] = true;
							numRow++;
							if (oDocRow.getVar("RNOM") == 0)
								oDocRow.setVar("RNOM",numRow);
							this.oDocTo.appendRow(sRowClass, oDocRow);
						}
						else 
						{
							var bSkipRow = false; 
							for (var i = 0; i < groupby_vars.length; i++)
							{
								if (String(currRow.getVar(groupby_vars[i])) != String(groupby_vals[groupby_vars[i]]))
								{
									bSkipRow = true;
									break;						
								}
							}
							
							if (!bSkipRow)
							{
								// добавим последнюю строку если такая есть
								if (parDocID)
									this.arrIDParentDoc[Number(parDocID)] = true;
								numRow++;
								if (oDocRow.getVar("RNOM") == 0)
									oDocRow.setVar("RNOM",numRow);
								this.oDocTo.appendRow(sRowClass, oDocRow);
							}
						}
					}
					tbl.MoveFirst();
				}
			}
		}
	}
	tbl.close();
	
	
	// сворачиваем строки по номенкл, подр, мол, счет, субсчет, стат, пост, fid_pn, цене	
	var oSnap = getSnap("select ftournby, fsumfld from ^cl_linkdoc where fwid = " + sqlTo(this.sLinkId));
	if (oSnap && oSnap[0] && allt(oSnap[0]) != "")
	{
		var arrGRPRow = new Array();
		var oDocRowGRP  = null;
		var key = null;
		var nRowCount = 0;
		if(this.oDocTo.gotoFirstRow())
		{
			var arrfldTourn = allt(oSnap[0]).split(",");
			var arrSumFields = allt(oSnap[1]).split(",");
			while(this.oDocTo.gotoNextRow())
			{
				oDocRowGRP = this.oDocTo.getCurrRow();
				key = "";
				
				for (var i = 0; i < arrfldTourn.length; i++)
				{
					key += " | " + oDocRowGRP.eval(arrfldTourn[i]);
				}
				
				/*
				key = oDocRowGRP.getVar("RSC") + " | " +
					oDocRowGRP.getVar("RSU") + " | " +
					oDocRowGRP.getVar("RST") + " | " +	
					oDocRowGRP.getVar("RPODR") + " | " +
					oDocRowGRP.getVar("RMOL") + " | " +
					oDocRowGRP.getVar("RPOST") + " | " +
					oDocRowGRP.getVar("ROCENA") + " | " +
					oDocRowGRP.getVar("RTNMK");
					*/
				key = String(key);	
				if (!arrGRPRow[key])
				{
					
					nRowCount++;
					arrGRPRow[key] = Number(oDocRowGRP.getID());
					oDocRowGRP.setVar("RNOM", nRowCount);
				}  
				else
				{
					var baseRow = this.oDocTo.getRow("ROW", arrGRPRow[key]);
					if(allt(oSnap[0]) != "")
					{
						for (var i = 0; i < arrSumFields.length; i++)
						{
							var varName = allt(arrSumFields[i]);
							var nSum = Number(oDocRowGRP.getVar(varName));
							if(!isNaN(nSum))
								baseRow.setVar(varName, Number(baseRow.getVar(varName)) + nSum);
							
						}
						//baseRow.setVar("RKOL", Number(baseRow.getVar("RKOL")) + Number(oDocRowGRP.getVar("RKOL")));
					}

					this.oDocTo.deleteRow("ROW", Number(oDocRowGRP.getID()));	
				}
			}
		}
		arrGRPRow = null;
	}
	
	// Применение Фильтра на созданные строки
	if(this.fhaving && this.oDocTo.gotoFirstRow())
	{
		 while (this.oDocTo.gotoNextRow())
		{
			var oDocRow = this.oDocTo.getCurrRow();
			if (!oDocRow.eval(this.fhaving ))
			{
				this.oDocTo.deleteRow("ROW", Number(oDocRow.getID()));	
			}
		}
	}
	
	if (this.bFast)
	{
		 if(this.oDocTo.hasRows())
		 	this.oDocTo.setVar("HNR", this.oDocTo.getChildIDs().length);
		 this.oDocTo.save(true);
		 this.oDocTo.saveExtToDB();
	}
	else
	{
		var oPar = new Object;
		oPar.isTransform = true; 
		oPar.sDoc = this.sDoc;
		oPar.nNop = this.nNop;
		oPar.sNID = this.sNID;
		if (this.isMass)
			oPar.save_after_load = true;
		
		var ret = this.oDocTo.edit("ADD", null, oPar);
		
		//if (par.escape || !par.fwid) return false;
		if (!ret)
			return;
				
		var doProvOnSave = this.oDocTo.getPar("provonsave");
		if (doProvOnSave != 0)
		{
			this.oDocTo.toDo = "-";
			this.oDocTo.exeDocOp(doProvOnSave == 2, false);
			//После формирования проводок по связаному документу 
			//очищаем из памяти настройки проводок 
			//иначе не формируются проводки по родительскому документу
			document.operListMap = new Array();
		}
	}
	
	for (var id in this.arrIDParentDoc)
	{
		var m = new Object(); 
		m.FMAINWID = Number(id);
		m.FDOCWID = this.oDocTo.getID();
		m.Fdoc = this.sDocTo;
		m.Fnop = this.nNopTo;
		m.FISPARENT = true;
		m.FWID = GetUID();
		updateTable("^doc_links", m, true);
		
		var m = new Object(); 
		m.FMAINWID = this.oDocTo.getID();
		m.FDOCWID = Number(id);
		m.Fdoc = this.sDoc;
		m.Fnop = this.nNop;
		m.FISPARENT = false;
		m.FWID = GetUID();
		updateTable("^doc_links", m, true);
	}

}

function DpDocTransformer_isDocToExists(id, docTo, forType)
{
	var sWhere = "";
	if (forType)
		sWhere = " AND fdoc = " + sqlTo(docTo.sDocLbl) + " and fnop = " + Number(docTo.nNop)  
	var oSnap = getSnap("select FDOCWID from ^doc_links "
		+ " where FMAINWID = " + sqlTo(id) + sWhere
		);	
	if (oSnap != null)
	{
		var oSnap2 = getSnap("select * from ^" + docTo.getTableName()
			+ " where FWID = " + sqlTo(oSnap[0])
			);	
		if (oSnap2 != null)
		{
			return true;
		}
	}

	return false;
}

function DpDocTransformer_delLinkedDocs(id, docTo, forType)
{
	var sWhere = "";
	if (forType)
		sWhere = " AND fdoc = " + sqlTo(docTo.sDocLbl) + " and fnop = " + Number(docTo.nNop)  
	var oSnap = getSnap("select FDOCWID from ^doc_links "
		+ " where FMAINWID = " + sqlTo(id) + sWhere
		);
	var fwid = oSnap[0]
	if (oSnap != null)
	{
		var oSnap2 = getSnap("select * from ^" + docTo.getTableName()
			+ " where FWID = " + sqlTo(fwid)
			);	
		if (oSnap2 != null)
		{
			docTo.del(fwid, false, true);
		}
	}

}