include("doc\\DpDoc.js");
include("objects\\DpClEx.js");
include("objects\\DpJRegistrator.js");

DpDocumentDecoder.prototype.fillTableMap = DpDocumentDecoder_fillTableMap;
DpDocumentDecoder.prototype.parseFrom = DpDocumentDecoder_parseFrom;
DpDocumentDecoder.prototype.parseWhere = DpDocumentDecoder_parseWhere;
DpDocumentDecoder.prototype.parseWhereForPrik = DpDocumentDecoder_parseWhereForPrik;
DpDocumentDecoder.prototype.run = DpDocumentDecoder_run;
DpDocumentDecoder.prototype.setAllVars = DpDocumentDecoder_setAllVars;
DpDocumentDecoder.prototype.fillExts = DpDocumentDecoder_fillExts;
DpDocumentDecoder.prototype.fillExtsRow = DpDocumentDecoder_fillExts2;
DpDocumentDecoder.prototype.setProgressRange = DpDocumentDecoder_setProgressRange;
DpDocumentDecoder.prototype.setProgressPos = DpDocumentDecoder_setProgressPos;
DpDocumentDecoder.prototype.parseWhereForCl = DpDocumentDecoder_parseWhereForCl;
DpDocumentDecoder.prototype.runForCl = DpDocumentDecoder_runForCl;
DpDocumentDecoder.prototype.parseFromForCL = DpDocumentDecoder_parseFromForCL;
DpDocumentDecoder.prototype.runForCDR = DpDocumentDecoder_runForCDR;
DpDocumentDecoder.prototype.runForPrik = DpDocumentDecoder_runForPrik;

function DpDocumentDecoder()
{
	this.registersArr = new Object();	//- будем кешировать регистраторы
}

function DpDocumentDecoder_setProgressRange(Min,Max)
{
	if (typeof(NOPROGRESS)== "undefined" || !NOPROGRESS)
	{
		setProgressRangeEx(Min,Max);
	}
	trace("DOCDECODER " + Min + "/" + Max);
}

function DpDocumentDecoder_setProgressPos(nPos,sText)
{
	if (typeof(NOPROGRESS)== "undefined" || !NOPROGRESS)
	{
		setProgressPosEx(nPos,sText);
	}
	trace("DOCDECODER " + nPos + " " + sText);
}

function selectSingleNode(oElement,sPath)
{
	try
	{
		return Packages.com.sun.org.apache.xpath.internal
					.XPathAPI.selectSingleNode(oElement,sPath);
	}
	catch(ex)
	{
		return null;
	}
}

function parseFIELDS(tblMap)
{
	var retStr = "";
	var nTbl = 0;
	for (var sTbl in tblMap)
	{
		var tbl = "TBL" + nTbl;
		
		if (sTbl.toUpperCase() == "CL")
		{
			tbl = "^CL";
		}
		else if (sTbl.toUpperCase() == "CLRELCLCL")
		{
			tbl = "REL";
		}
		
		var oTbl = tblMap[sTbl];
		for (var sFld in oTbl.FIELDS)
		{
			var addStr = tbl + "." + sFld + " AS " + sFld;
			if (retStr != "")
				retStr += ",";
			retStr +=addStr;
		}
		nTbl++;
	}
	return retStr;
}

function selectNodeList(oElement,sPath)
{
	try
	{
		return Packages.com.sun.org.apache.xpath.internal
					.XPathAPI.selectNodeList(oElement,sPath);
	}
	catch(ex)
	{
		return null;
	}
}

function DpDocumentDecoder_fillTableMap(mapper)
{
	var header = selectSingleNode(mapper,"Header");
	if (header == null)
		return null;
	var nlTables = selectNodeList(header,"Tables/table");
	if (nlTables == null)
		return null;
	var retMap = new Array();
	for (var nTbl = 0; nTbl < nlTables.getLength(); nTbl++)
	{
		var currEl = nlTables.item(nTbl);
		var sName = allt(currEl.getAttribute("name"));
		if (sName == "")
			continue;
		var sIDfld = allt(currEl.getAttribute("ID"));
		if (sIDfld == "")
			sIDfld = "FWID";

		var newTbl = new Object();
		newTbl.TABLE = sName;
		newTbl.IDFLD = sIDfld;
		retMap[sName] = newTbl;
		
		var nlFields = selectNodeList(header,"Fields/field[@table='" + sName + "']");
		if (nlFields == null)
			continue;
		var arrFields = new Array();
		for (var nFld = 0; nFld < nlFields.getLength(); nFld++)
		{
			var currFld = nlFields.item(nFld);
//-			trace(" >>>>> " + currFld.getAttribute("name") + " ---------- " + currFld.getAttribute("var"));
			var sFldName = allt(currFld.getAttribute("name"));
			if (sFldName == "")
				continue;
			var sVarName = allt(currFld.getAttribute("var"));
			if (sVarName == "" || sVarName.indexOf(".") >= 0)
				continue;
			var newField = new Object();
			newField.FIELD = sFldName;
			newField.VAR = sVarName;
			arrFields[sFldName] = newField;
		}
		newTbl.FIELDS = arrFields;
	}
	return retMap;
}

function DpDocumentDecoder_runForPrik(sClass,oPar)
{
	var oPrik = lpProxy.createObject("prk." + sClass);
	if (oPrik.isInitialized() == false) 
		return null;
	var mapper = oPrik.getDefaultMapper().getDocumentElement();
	var tblMap = this.fillTableMap(mapper);
	if (tblMap == null)
		return null;
	createDirectory(getOrgPath() + "data/prik/" + sClass);
	
	var sSQL = "SELECT "+parseFIELDS(tblMap)+",TBL0.FWID as FWID FROM ";
	sSQL += this.parseFrom(tblMap);
	if (oPar)
		sSQL += " WHERE " + this.parseWhereForPrik(oPar);
	var tbl = OpenTable(sSQL);
	if (tbl == null || tbl.isEmpty())
		return null;
		
	this.setProgressRange(1, tbl.getRecordCount() + 1);
	this.setProgressPos(1,"Идёт перенос...");
	
	for (tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
	{
		this.setProgressPos(tbl.getAbsolute(),"Идёт перенос...");
		oPrik.Clear();
		oPrik.setObjectID(tbl.getValue("FWID"));
		this.setAllVars(tbl,tblMap,oPrik);
		oPrik.storeToXML();
	}
	
	tbl.close();
	this.setProgressPos(0);
}

function DpDocumentDecoder_runForCl(sClClass,oPar)
{
	var oCl = lpProxy.createObject(sClClass);
	if (oCl.isInitialized() == false) return null;
	var oJSCl = new DpClEx(String(sClClass).substr(4),0);
	oJSCl.jObj = oCl;
	var mapper = oCl.getDefaultMapper();
	if (mapper == null)
	{
		trace("NULL MAPPER " + sClClass);
		return;
	}
	
	mapper = mapper.getDocumentElement();
	var tblMap = this.fillTableMap(mapper);
	if (tblMap == null)
		return null;

	var rowsIDs = oCl.getChildIDs();
	trace("ROWS>>>>> " + rowsIDs.length);
	var rowsMap = new Array();
	for (var nRow = 0; nRow < rowsIDs.length; nRow++)
	{
		var oRow = oCl.createChild(rowsIDs[nRow]);
		var rowMapper = oRow.getDefaultMapper().getDocumentElement();
		var rowMap = this.fillTableMap(rowMapper);
		var rowItem = new Object();
		rowItem.TABLEMAP = rowMap;
		for (var sTbl in rowMap)
		{
			var refTbl = selectSingleNode(mapper,"rows/Tables/table[@name='" + sTbl + "']");
			var refFld = "FWID_CL";
			if (refTbl != null)
			{
				var tRefFld = refTbl.getAttribute("reffield");
				if (tRefFld != "")
					refFld = tRefFld;
			}
			rowItem[sTbl] = new Object();
			rowItem[sTbl].REFFLD = refFld;
//-			trace("----------------- " + sTbl + " --- " + rowItem[sTbl].REFFLD);
		}
		rowsMap[rowsIDs[nRow]] = rowItem;
	}
	
	var sSQL = "SELECT " + parseFIELDS(tblMap) + " FROM ";
	sSQL += this.parseFromForCL(tblMap)
	//	  + " INNER JOIN ^clcl CLCL"
	//	  + " ON FCL=CLCL.FCOD ";
	if (oPar)
		sSQL += " WHERE " + this.parseWhereForCl(oPar);
	var tbl = OpenTable("s",sSQL);
	if (tbl == null || tbl.isEmpty())
		return null;
		
	this.setProgressRange(1, tbl.getRecordCount() + 1);
	this.setProgressPos(1,"Идёт перенос...");
	
	for (tbl.MoveFirst();!tbl.isEOF();tbl.MoveNext())
	{
		this.setProgressPos(tbl.getAbsolute(),"Идёт перенос...");
		oCl.Clear();
		oCl.setObjectID(tbl.getValue("FWID"));		//- пока оставим так
		this.setAllVars(tbl,tblMap,oCl);
		if (sClClass == "CLS.CL2")
		{
			oCl.setVar("HCL", 0);
		}
		this.fillExts(oJSCl);					//- тоже - надо бы

		for (var sRowID in rowsMap)
		{
//-			trace("ROWID >>>>> " + sRowID + " --- " + rowsMap[sRowID].REFFLD);
			var rowPar = new Object();
			//- ща буде тупо
			rowPar.strWhere = /*rowsMap[sRowID].REFFLD + */"FWID_CL=" + sqlTo(oJSCl.getID());
			var rowSQL = "SELECT * FROM ";
			rowSQL += this.parseFrom(rowsMap[sRowID].TABLEMAP);
			rowSQL += " WHERE " + this.parseWhere(rowPar);
			
			var rowTbl = OpenTable("s",rowSQL);
			if (rowTbl == null || rowTbl.isEmpty())
			{
				(rowTbl != null) && rowTbl.close();
				continue;
			}
			for (rowTbl.MoveFirst();!rowTbl.isEOF();rowTbl.MoveNext())
			{
				var rowObj = oJSCl.createRow(sRowID);
				if (rowTbl.getValue("FWID") != null)
					rowObj.setID(rowTbl.getValue("FWID"));
				this.setAllVars(rowTbl,rowsMap[sRowID].TABLEMAP,rowObj);
//-				this.fillExts(rowObj);
				if (sRowID == "CLNUM" && Number(rowObj.getVar("HCL")) == 0)
					continue;
				oJSCl.appendRow(sRowID,rowObj);
			}
			rowTbl.close();
		}
		
		oCl.storeToXML();
		if (oPar.toArchive)
		{
			oJSCl.fillSynchroVars();
			oJSCl.toArchive("ADD");
		}
	}
	tbl.close();
	this.setProgressPos(0);
}

function DpDocumentDecoder_run(sDocLbl, oPar)
{
	var isHExt = true;
	var isRExt = true;
	var oSnap = getSnap("SELECT FCLASS FROM ^CL_EXT where FCLASS = " + sqlTo("H." + sDocLbl));
	if (!oSnap)
		isHExt = false; 
	var oSnap = getSnap("SELECT FCLASS FROM ^CL_EXT where FCLASS = " + sqlTo("R." + sDocLbl));
	if (!oSnap)
		isRExt = false; 
	var nOp = 0;
	var oDoc = lpProxy.createObject(sDocLbl);
	if( oDoc.isInitialized() == false) return null;
	var mapper = oDoc.getDefaultMapper().getDocumentElement();
	var tblMap = this.fillTableMap(mapper);
	if (tblMap == null)
		return null;
	createDirectory(getOrgPath() + "data/docs/" + sDocLbl);
	
	var rowsIDs = oDoc.getChildIDs();
	var rowsMap = new Array();
	for (var nRow = 0; nRow < rowsIDs.length; nRow++)
	{
		var oRow = oDoc.createChild(rowsIDs[nRow]);
		var rowMapper = oRow.getDefaultMapper().getDocumentElement();
		var rowMap = this.fillTableMap(rowMapper);
		var rowItem = new Object();
		rowItem.TABLEMAP = rowMap;
		for (var sTbl in rowMap)
		{
			var refTbl = selectSingleNode(mapper,"rows/Tables/table[@name='" + sTbl + "']");
			var refFld = "FID_DOC";
			if (refTbl != null)
			{
				var tRefFld = refTbl.getAttribute("reffield");
				if (tRefFld != "")
					refFld = tRefFld;
			}
			rowItem[sTbl] = new Object();
			rowItem[sTbl].REFFLD = refFld;
		}
		rowsMap[rowsIDs[nRow]] = rowItem;
	}
	
	var sSQL = "SELECT * FROM ";
	sSQL += this.parseFrom(tblMap);
	if (oPar)
		sSQL += " WHERE " + this.parseWhere(oPar);
	var tbl = OpenTable("s",sSQL);	
	
	if (tbl == null || tbl.isEmpty())
		return null;
	//-	идём по таблице документов
	var nTblRowCount = tbl.getRecordCount();
	if (nTblRowCount > 1)
	{
		this.setProgressRange(1, nTblRowCount + 1);
		this.setProgressPos(1,"Идёт перенос...");
	}
	var scrDoc = new DpDoc(sDocLbl,0);
	scrDoc.create();
	for (tbl.MoveFirst();!tbl.isEOF();tbl.MoveNext())
	{
		var nAbs = Number(tbl.getAbsolute());
		if (nAbs%20==0 && nTblRowCount > 1)
			this.setProgressPos(nAbs,"Идёт перенос... " + sDocLbl + ((oPar && oPar.nop)?(" \ " + oPar.nop):"") );
		try
		{
			scrDoc.clear();
			scrDoc.setDocID(tbl.getValue("FWID"));		//- пока оставим так
			this.setAllVars(tbl,tblMap,scrDoc);
			if (isHExt)
				this.fillExts(scrDoc);
			//-	пройдёмся-ка по строкам
			for (var sRowID in rowsMap)
			{
				var rowPar = new Object();
				rowPar.strWhere = /*rowsMap[sRowID].REFFLD*/"FID_DOC=" + sqlTo(scrDoc.getID());
				var is2Row = false;
				if (sDocLbl == "BILDOG" || sDocLbl == "LICSC")
					rowPar.strWhere = "FID_DOG=" + sqlTo(scrDoc.getID());
				if(inList(sDocLbl, "SM", "PU", "PM", "VM"
						,"MT", "OC",  "MP", "MV" ))
				{
					rowPar.strWhere += " and frtype='8'";
					is2Row = true;
				}
				
				if (sDocLbl == "TZ")
				{
					rowPar.strWhere += " and frtype='7'";
					is2Row = true;
				}
												
				var rowSQL = "SELECT * FROM ";
				if(oDoc.instanceOf("NAKL"))
				{
					var sName = "ANLTK";
					var date = scrDoc.getVar("HDAT");
					var oSnap = getSnap("select FTBLNAME from ^ANLTK_PER"
								+" where FBDATE<="+ sqlTo(date) +" and FEDATE>="+ sqlTo(date)
								, false);
					if(oSnap)
					{
						sName = oSnap[0];
						if(IsTableEx("MTR", "mtr_"+ sName))
							rowSQL += "^"+ sName +" TBL0 ";
					}
					else
					{
						rowSQL += this.parseFrom(rowsMap[sRowID].TABLEMAP);
					}
				}
				else
				{
					rowSQL += this.parseFrom(rowsMap[sRowID].TABLEMAP);
				}
				rowSQL += " WHERE " + this.parseWhere(rowPar);
				
				
				var rowTbl = OpenTable("s",rowSQL);
				if (rowTbl == null || rowTbl.isEmpty())
				{
					(rowTbl != null) && rowTbl.close();
					continue;
				}
				for (rowTbl.MoveFirst();!rowTbl.isEOF();rowTbl.MoveNext())
				{
					var rowObj = scrDoc.createRow(sRowID);
					if (rowTbl.getValue("FWID") != null)
					{
						rowObj.setID(rowTbl.getValue("FWID"));
						
						
					}
					
					this.setAllVars(rowTbl,rowsMap[sRowID].TABLEMAP,rowObj);
					
					if (is2Row)
					{
						if (true)
						{
							rowObj.setVar("R2ID"
								, rowObj.getVar("R1ID"));
							
						}
						else
						{
							rowObj.setVar("R2ID"
									, GetNextUID(rowTbl.getValue("FWID")));
						}
					}
					
					if (isRExt)
						this.fillExts(rowObj);
					scrDoc.appendRow(sRowID,rowObj);
				}
				rowTbl.close();
			}
		}
		catch(ex)
		{
			trace("EX: " + ex)
		}
		fillRegAttrFromTbl(scrDoc, "^PDOCREG");
		fillRegAttrFromTbl(scrDoc, "^MDOCREG");
		scrDoc.jDoc.storeToXML();
		if (!oPar.notRegister)
		{
			if (!this.registersArr[scrDoc.sDocLbl])
				this.registersArr[scrDoc.sDocLbl] = new Object();
			var NOP = parseInt(String(scrDoc.getVar("HOP")));
			if (!this.registersArr[scrDoc.sDocLbl][NOP])
			{
				this.registersArr[scrDoc.sDocLbl][NOP] 
					= new DpJRegistrator(scrDoc.sDocLbl,NOP,oPar.register);
			}
			scrDoc.oReg = this.registersArr[scrDoc.sDocLbl][NOP];
			scrDoc.doRegistration();
		}
		if (oPar.toArchive)
		{
			scrDoc.fillSynchroVars();
			scrDoc.toArchive("ADD");
		}
	}
	tbl.close();
	if (nTblRowCount > 1)
		this.setProgressPos(0);
}



function fillRegAttrFromTbl(oDoc, sTbl)
{
	var sSQLFld = "SELECT HREG, HNKDAT, HISNOV1, HNKNOM, HOPFORM, HPRCOND, HMENEGER, HZONE"
		+ " FROM ";
	var sWhere = " WHERE HID_DOC = " + oDoc.getID();
	
	var tbl = OpenTable(sSQLFld + sTbl + sWhere);
	while (!tbl.isEOF())
	{
		var sReg = String(tbl.getValue("HREG"));
		oDoc.setRegAttr(sReg, "NK_NUM", tbl.getValue("HNKNOM"));
		oDoc.setRegAttr(sReg, "NK_DAT", tbl.getValue("HNKDAT"));
		oDoc.setRegAttr(sReg, "ISNOV1", tbl.getValue("HISNOV1"));
		oDoc.setRegAttr(sReg, "OP_FORM", tbl.getValue("HOPFORM"));
		oDoc.setRegAttr(sReg, "PR_COND", tbl.getValue("HPRCOND"));
		oDoc.setRegAttr(sReg, "MNG", tbl.getValue("HMENEGER"));
		oDoc.setRegAttr(sReg, "ZONE", tbl.getValue("HZONE"));
		
		tbl.moveNext();
	}
}

function DpDocumentDecoder_setAllVars(tbl,tblMap,oObj)
{
	for (var sTbl in tblMap)
	{
		for (var sFld in tblMap[sTbl].FIELDS)
		{
			var varName = tblMap[sTbl].FIELDS[sFld].VAR;
			var varValue = tbl.getValue(sFld);
//-			trace(">>>>>> " + varName + " = " + varValue + " -- " + sFld);
			oObj.setVar(varName ,varValue);
		}
	}
}

function DpDocumentDecoder_parseFromForCL(tblMap)
{
	var nTbl = 0;
	var strFrom = "";
	var prevTbl = null;
	var nPrevTbl = 0;
	
	var nTblCL = -1;
	var nTblREL = -1;
	var tmpNtbl = 0;
	
	
	this.tblCl = "^CL";
	strFrom = "(^CL" 
		    + " INNER JOIN ^CLRELCLCL REL"
		    + " ON ^CL.FWID=REL.FWID_CL)"
	
	for (var sTbl in tblMap)
	{
		sTbl = String(sTbl).toUpperCase();
		if (sTbl != "CL" && sTbl != "CLRELCLCL")
		{
			currFrom = " LEFT JOIN ^" + sTbl + " TBL" + nTbl
					 + " ON ^CL.FWID ="
					 + " TBL" + nTbl + ".FWID_CL";
			strFrom = "( " + strFrom + currFrom + " )";
		}
		nTbl++;
	}
	return strFrom;
}

function DpDocumentDecoder_parseFrom(tblMap)
{
	var nTbl = 0;
	var strFrom = "";
	var prevTbl = null;
	for (var sTbl in tblMap)
	{
		var currFrom = "";
		if(sTbl.toUpperCase()=="PRK_ALL")
			this.prikPattern = "TBL"+nTbl;
		if (prevTbl != null)
		{
			currFrom = " INNER JOIN ^" + sTbl + " TBL" + nTbl
					 + " ON TBL" + (nTbl-1) + "." + prevTbl.IDFLD + "="
					 + " TBL" + nTbl + "." + tblMap[sTbl].IDFLD;
		}
		else
			currFrom = "^" + sTbl + " TBL" + nTbl;
		
		if (SUBD == MSSQL)
			strFrom = " " + strFrom + currFrom + " ";
		else
			strFrom = "( " + strFrom + currFrom + " )";
		nTbl++;
		prevTbl = tblMap[sTbl];
	}
	return strFrom;
}

function DpDocumentDecoder_fillExts(oDoc)
{
	var extMap = oDoc.getExtInfo();
	for (var extLbl in extMap)
		oDoc.setExt(extLbl,oDoc.getExt(extLbl));
}

function DpDocumentDecoder_fillExts2(oDoc, extMap,rTbl)
{
	for (var extLbl in extMap)
	{
		var type = oDoc.getSimpleType(extMap[extLbl].type);
		var oValue = rTbl.getValue("#"+extLbl);
		if (oValue == null)
			oValue = rTbl.getValue("ext0."+extLbl);
		oDocjDoc.setExtType(extLbl,type);
		oDoc.jDoc.setExt(extLbl, oValue);
	}
}

function DpDocumentDecoder_parseWhere(oPar)
{
	var strWhere = " 1=1 ";
	if (oPar.doc)
		strWhere += " AND FDOC=" + sqlTo(oPar.doc);
	if (oPar.nop || oPar.nop == 0)
		strWhere += " AND FNOP=" + sqlTo(oPar.nop);
	if (oPar.bdate)
		strWhere += " AND FDOC_DAT>=" + sqlTo(oPar.bdate);
	if (oPar.edate)
		strWhere += " AND FDOC_DAT<=" + sqlTo(oPar.edate);
	if (oPar.strWhere)
		strWhere += " AND (" + oPar.strWhere + ")";
	if (oPar.fiddoc)
		strWhere += " AND FWID=" + sqlTo(oPar.fiddoc);
	if (!oPar.register)
		oPar.register = "US";
	return strWhere;
}

function DpDocumentDecoder_parseWhereForPrik(oPar)
{
	var strWhere = " 1=1 ";
	if (oPar.fiddoc)
		strWhere += " AND "+this.prikPattern+".FWID=" + sqlTo(oPar.fiddoc);
	return strWhere;
}

function DpDocumentDecoder_parseWhereForCl(oPar)
{
	var strWhere = " 1 = 1";
	if (oPar.nCl)
		strWhere += " AND FCL=" + sqlTo(oPar.nCl);
	//strWhere += " AND FVID=" + sqlTo(oPar.sFvid);
	if (oPar.fid)
		strWhere += " AND " + this.tblCl + ".FWID=" + sqlTo(oPar.fid);
	return strWhere;
}

function DpDocumentDecoder_runForCDR(sDocLbl, oPar)
{
	var tmp = String(sDocLbl).substring(0, String(sDocLbl).lastIndexOf(".")).toUpperCase();
	if (tmp != "COM.DEBET.CDR")
		return false;
	
	var oDoc = lpProxy.createObject(sDocLbl);
	if (oDoc.isInitialized() == false)
		return false;
	var mapper = oDoc.getDefaultMapper().getDocumentElement();
	var tblMap = this.fillTableMap(mapper);	
	if (tblMap == null)
		return false;		
	createDirectory(getOrgPath() + "data/docs/" + sDocLbl);
		
	var sSQL = "SELECT * FROM ";
	sSQL += this.parseFrom(tblMap);
	if (oPar && oPar.fiddoc)
		sSQL += " WHERE tbl0.fwid=" + sqlTo(oPar.fiddoc);
	var tbl = OpenTable("s", sSQL);
	this.setProgressRange(1, tbl.getRecordCount() + 1);
	this.setProgressPos(1, UR("Йде перенесення...|Идёт перенос..."));
		
	
	for (tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
	{

		this.setProgressPos(tbl.getAbsolute(),
			UR("Йде перенесення |Идёт перенос ") + sDocLbl + " (" + tbl.getValue("fwid") + ")...");
		var scrDoc = new DpDoc(sDocLbl, 0);
		scrDoc.setDocID(tbl.getValue("fwid"));
		var varsInfo = scrDoc.getVarsInfo();
		var fillVar = new Array();
		for (var i in varsInfo)
		{
			var fieldName = "F" + varsInfo[i].name.substring(1);
			if (tbl.getValue(fieldName) != null && (typeof fillVar[varsInfo[i].name] == "undefined"))
			{
				fillVar[varsInfo[i].name] = tbl.getValue(fieldName);
				scrDoc.setVar(varsInfo[i].name, fillVar[varsInfo[i].name]);
			}
		}
		scrDoc.save();
		if (sDocLbl.toLowerCase() == "com.debet.cdr.oi")
			continue;
		
		fillVar["RWID_WP"] = scrDoc.getID();;
		scrDoc.setVar("RWID_WP", fillVar["RWID_WP"]);
		
		var tblWP = OpenTable("s", "SELECT * FROM ^work_pers WHERE fwid=" + sqlTo(tbl.getValue("fwid")));
		for (var i in varsInfo)
		{
			var fieldName = "F" + varsInfo[i].name.substring(1);
			if (tblWP.getValue(fieldName) != null && (typeof fillVar[varsInfo[i].name] == "undefined"))
			{
				fillVar[varsInfo[i].name] = tblWP.getValue(fieldName);
				scrDoc.setVar(varsInfo[i].name, fillVar[varsInfo[i].name]);
			}
		}		
		var tblDOL = OpenTable("s", "SELECT * FROM ^stru_dol WHERE fwid=" + sqlTo(tblWP.getValue("fwid_dol")));
		for (var i in varsInfo)
		{
			var fieldName = "F" + varsInfo[i].name.substring(1);
			if (tblDOL.getValue(fieldName) != null && (typeof fillVar[varsInfo[i].name] == "undefined"))
			{
				fillVar[varsInfo[i].name] = tblDOL.getValue(fieldName);
				scrDoc.setVar(varsInfo[i].name, fillVar[varsInfo[i].name]);
			}
		}	
		scrDoc.save();		
	}
	var nRec = Number(tbl.getRecordCount());
	tbl.close();
	this.setProgressPos(0);	
	
	if (nRec > 0 || !oPar || !oPar.fiddoc)
		return true;
		
	var tblName = "";
	if (sDocLbl.toLowerCase() == "com.debet.cdr.in")
		tblName = "prk_in";
	else if (sDocLbl.toLowerCase() == "com.debet.cdr.out")
		tblName = "prk_out";
	if (tblName == "")
		return false;
	if (!ExecuteSQL("INSERT INTO ^" + tblName + " (fwid) values(" + sqlTo(oPar.fiddoc) + ")"))
		return false;
	return this.runForCDR(sDocLbl, oPar);			
}