function DpDol(dpOrg, d1, d2)
{	
	this.fwid = 0;
	this.textObj = null;
	this.useSmallText = false;
	this.findFree = true;
	
	this.dpOrg = null;
	this.dpPers = null;
	
	this.setFWID = DpDol_setFwid;
	this.getFWID = DpDol_getFwid;
	this.getFwidOrg = DpDol_getFwidOrg;
	this.setFindFree = DpDol_setFindFree;
	this.linkCtrl   = DpDol_linkCtrl;
	this.updateCtrl = DpDol_updateCtrl;
	this.validCtrl = DpDol_validCtrl;
	this.zaval = DpDol_zaval;
	this.setPeriod = DpDol_setPeriod;	
	
	this.setDpPers = DpDol_setDpPers;
	this.setDpOrg = DpDol_setDpOrg;
	
	this.getSQL = DpDol_getSQL;
	
	this.findFirstDol = DpDol_findFirstDol;	
	this.findFirstPers = DpDol_findFirstPers;
	
	this.setPeriod(d1, d2);
	this.setDpOrg(dpOrg);
}

function DpDol_setDpOrg(dpOrg)
{
	this.dpOrg = dpOrg;
}

function DpDol_setDpPers(dpPers)
{
	this.dpPers = dpPers;
	this.dpPers.dpDol = this;
}

function DpDol_getFwidOrg()
{
	if (this.dpOrg)
		return this.dpOrg.getFWID();
	return 0;
}

function DpDol_setFwid(fwid)
{
	if (typeof fwid != "undefined")
		this.fwid = Number(fwid);
	else
		this.fwid = 0;
	return this.updateCtrl();
}

function DpDol_getFwid()
{
	return this.fwid;
}

function DpDol_setUseSmallText(bool)
{
	this.useSmallText = Boolean(bool);
}

function DpDol_setFindFree(arg)
{
	this.findFree = arg;
}

function DpDol_setPeriod(d1, d2)
{
	try
	{
		if (typeOf(d1) == "Date")
			this.dat1 = d1;
		else
			this.dat1 = toScriptDate(d1).getVarDate();
		if (typeOf(d2) == "Date")
			this.dat2 = d2;
		else
			this.dat2 =  toScriptDate(d2).getVarDate();
	}
	catch(e)
	{
		this.dat1 = null;
		this.dat2 = null;
	}
	this.updateCtrl();
}

function DpDol_linkCtrl(oCtrl)
{
	if (typeof oCtrl == "undefined")
		return;
	this.textObj = oCtrl;
	this.textObj.isButton = true;
	setValid(this.textObj, this, "validCtrl");	
	setButton(this.textObj, this, "zaval");
	this.updateCtrl();
	
}

function DpDol_updateCtrl()
{
	if (this.dat1 == null || this.dat2 == null)
	{
		this.fwid = 0;
		if (this.textObj != null)
			this.textObj.value = "";
		return false;
	}
	var snap = getSnap("SELECT cl.ftxt AS ftxt, cl.ftxts AS ftxts, dol.fwid_org AS fwid_org "
			+ " FROM ^stru_dol AS dol, ^cl AS cl "
			+ " WHERE dol.fwid=" + sqlTo(Number(this.fwid))
			+ " AND dol.fedat=" + SqlMaxDate
			+ this.getSQL()
			+ " AND ((dol.fbdat<=" + sqlTo(this.dat1) + " AND dol.fedat>=" + sqlTo(this.dat2) + ")"
			+ " OR (dol.fbdat>=" + sqlTo(this.dat1) + " AND dol.fbdat<=" + sqlTo(this.dat2) + ")"
			+ " OR (dol.fedat>=" + sqlTo(this.dat1) + " AND dol.fedat<=" + sqlTo(this.dat2) + "))"
			+ " AND dol.fwid_cl=cl.fwid");
	
	if (snap == null)
	{
		this.fwid = 0;
		if (this.textObj != null)
			this.textObj.value = "";
		return false;
	}
	else
	{
		if (this.textObj != null)
			this.textObj.value = snap[Number(this.useSmallText)];
		return true;
	}	
}

function DpDol_getSQL()
{
	var result = (this.getFwidOrg() > 0 ? " AND dol.fwid_org=" + sqlTo(Number(this.getFwidOrg())) : "");
	if (this.findFree)
		result += " AND (((SELECT MAX(fedat) FROM ^work_pers WHERE fwid_dol=dol.fwid)<>" + SqlMaxDate + ") "
			+ " OR ((SELECT MAX(fedat) FROM ^work_pers WHERE fwid_dol=dol.fwid) IS NULL)) ";			
	else
		result += " AND ((SELECT MAX(fedat) FROM ^work_pers WHERE fwid_dol=dol.fwid)=" + SqlMaxDate + ") ";
	return result;
}

function DpDol_validCtrl()
{	
	if (!this.updateCtrl())
		return this.zaval();
	return true;	
}

function DpDol_zaval()
{
	if (this.dat1 == null || this.dat2 == null)
	{
		include ("Objects/DpGetDat.js");
		var gd = new DpGetDat("dD");
		if (!gd.dat1 || !gd.dat2)
			return false;
		this.setPeriod(gd.dat1, gd.dat2);
	}			
	var par = new Object();
	par.escape = true;
	par.dat1 = this.dat1;
	par.dat2 = this.dat2;
	par.fwidOrg = this.getFwidOrg();
	par.ret = new Object();
	par.ret.fwid = 0;
	showWindow("l_stru_dol.xml", SW_MODAL, par);
	if (!par.escape)
	{
		tyis.findFirstPers();
		return this.setFWID(par.ret.fwid);
	}
	return false;
}

function DpDol_findFirstDol(isZaval)
{
	if (this.getFwidOrg() > 0)
	{
		var snap = getSnap("SELECT dol.fwid "
			+ " FROM ^stru_dol AS dol "
			+ " WHERE dol.fedat=" + SqlMaxDate
			+ (this.dpPers != null && !isZaval ?
		 		" AND dol.fwid IN (SELECT DISTINCT fwid_dol FROM ^work_pers WHERE fwid_cl="
		 								 + sqlTo(this.dpPers.getFWID()) + ")" :
		 		"")
			+ this.getSQL()
			+ " AND ((dol.fbdat<=" + sqlTo(this.dat1) + " AND dol.fedat>=" + sqlTo(this.dat2) + ")"
			+ " OR (dol.fbdat>=" + sqlTo(this.dat1) + " AND dol.fbdat<=" + sqlTo(this.dat2) + ")"
			+ " OR (dol.fedat>=" + sqlTo(this.dat1) + " AND dol.fedat<=" + sqlTo(this.dat2) + "))"
			+ " ORDER BY dol.fwid");
		var fwid = snap != null ? snap[0] : 0;
		return this.setFWID(fwid);
	}
	return false;
}

function DpDol_findFirstPers()
{	
	if (this.dpPers == null)
		return false;
	var snap = getSnap("SELECT fwid_cl FROM ^work_pers "
				+ " WHERE fwid_dol=" + sqlTo(this.getFWID()) + " AND fedat=" + SqlMaxDate);
	if (snap == null)
		return false;
	this.dpOrg.setFWID_CL(snap[0]);
	this.dpPers.setFWID(snap[0]);
	return true;
}