DpDrainPrik.prototype.run = DpDrainPrik_run;
DpDrainPrik.prototype.analize = DpDrainPrik_analize;
DpDrainPrik.prototype.fillMaps = DpDrainPrik_fillMaps;
DpDrainPrik.prototype.fillMapFields = DpDrainPrik_fillMapFields;
DpDrainPrik.prototype.logResultField = DpDrainPrik_logResultField;
DpDrainPrik.prototype.drain = DpDrainPrik_drain;
DpDrainPrik.prototype.parseColumns = DpDrainPrik_parseColumns;
DpDrainPrik.prototype.traceErrorMsg = DpDrainPrik_traceErrorMsg;
DpDrainPrik.prototype.getFieldsResultTable = DpDrainPrik_getFieldsResultTable;
DpDrainPrik.prototype.getStruFieldInfo = DpDrainPrik_getStruFieldInfo;

DpDrainPrik.prototype.getNumberHierarchy = DpDrainPrik_getNumberHierarchy;
DpDrainPrik.prototype.getTextHierarchy = DpDrainPrik_getTextHierarchy;
DpDrainPrik.prototype.getWarningType = DpDrainPrik_getWarningType;
DpDrainPrik.prototype.differType = DpDrainPrik_differType;
DpDrainPrik.prototype.addColumn = DpDrainPrik_addColumn;

var OPEN_MODE = 0;
var STRU_MODE = 1;
var DB_MODE = 2;

function DpDrainPrik(mode)
{
	this.dbmd = lpProxy.getDBManager().getDbMetaData();
	if (!mode || mode <0 || mode >= 3)
		this.mode = OPEN_MODE;
	else
		this.mode = mode;
	this.point = (SUBD == MSSQL ? ".." : ".");
}

function DpDrainPrik_run(tableName)
{
	if (typeof tableName == "undefined")
		this.resultTableName = "PRK_ALL";
	else
		this.resultTableName = tableName;
	this.fillMaps();
	this.drain();	
}

function DpDrainPrik_analize(showDiff)
{
	this.showDiffer = (!showDiff ? false : true);
	this.fillMaps();
	this.logResultField(this.allCount, this.countProcessed);
}

function DpDrainPrik_fillMaps()
{
	this.resultFileds = new Object();
	this.allDrainTables = new Array();
	this.noProcessedTbl = new Array();
	this.mapDrainTables = new Array();
	
	include ("Objects/DpXMLDomDocument.js");
	var xml = new DpXMLDOMDocument();
	this.allCount = 0
	if (xml.load(rootDirectory() + "tbl_drainprik.xml"))
	{
		var xmlEl = xml.getDocumentElement();
		var sysLabelNodes = xmlEl.selectNodes("SYS");
		if (sysLabelNodes != null)
			for (var m in sysLabelNodes)
			{
				try
				{
					var sysLabelNode = sysLabelNodes[m];
					var basePath = getPath(sysLabelNode.getAttribute("label")).toUpperCase();	
					var base = this.mapDrainTables[basePath] = new Array();
					var extentions = sysLabelNode.getChildNodes();
					for (var i in extentions)
					{
						try
						{
							var extention = extentions[i];
							var sExt = extention.getNodeName().toUpperCase();
							aExt = base[extention.getNodeName().toUpperCase()] = new Array();
							var tables = extention.selectNodes("table");
							for (var j in tables)
							{
								try
								{
									var tableName = tables[j].getAttribute("name").toUpperCase();
									if (tableName.equals(""))
										continue;									
									aExt[tableName] = new Array();
										this.allDrainTables[allt(basePath + this.point
																+ sExt+ "_" + tableName)] = true;
										++this.allCount;
								}	
								catch(x)
								{
									this.traceErrorMsg(x, "fillMaps");
								}					
							}
							this.allCount += aExt.length;
						}
						catch(x)
						{
							this.traceErrorMsg(x, "fillMaps");
						}	 
					}
				}
				catch(x)
				{
					this.traceErrorMsg(x, "fillMaps");
				}
			}
	}
	trace("<<INFO>> DpDrainPrik :: fillMapTable -> Слитию подлежит " + this.allCount + " таблицы");
	this.countProcessed = 0;
	this.fieldsTable = this.getFieldsResultTable();
	for (var i in this.mapDrainTables)
		for (var j in this.mapDrainTables[i])
			for (var n in this.mapDrainTables[i][j])
				this.countProcessed += this.fillMapFields(i, j, n, this.mapDrainTables[i][j][n]);
	trace("<<INFO>> DpDrainPrik :: fillMapTable -> Обработано " + this.countProcessed + " таблицы");
}

function DpDrainPrik_fillMapFields(basePath, extention, tableName, objItem)
{
	switch (this.mode)
	{
		case OPEN_MODE:
			trace("<<INFO>> DpDrainPrik :: fillMapFields -> Обрабатывается таблица " + tableName);
			var arrayTable = getTablesByName(tableName);
			if (arrayTable == null || arrayTable.length < 1)
			{
				trace("<<ERROR>> DpDrainPrik :: fillMapFields -> Не найдено ни одной таблицы по паттерну " + tableName);
				return 0;			
			}
			
			var table = OpenTable("m", "SELECT * FROM "
										//+ basePath + this.point + extention + "_" + tableName
										+ arrayTable[0]
										+ " WHERE 1<>1");
			var fieldsInfo = table.getFieldsInfo();
			for (var i in fieldsInfo)
			{
				var colName = fieldsInfo[i].name;
				if (this.fieldsTable != null && !(this.fieldsTable[colName] === true))
					continue;
				var hashName = colName + "_" + fieldsInfo[i].dpType;
				if (objItem != null)				
					objItem[colName] = fieldsInfo[i];
				if (this.resultFileds[colName] == null)
				{
					this.resultFileds[colName] = new Object();
					this.resultFileds[colName]["length"] = 0;
				}
				if (this.resultFileds[colName][hashName] == null)
				{
					this.resultFileds[colName][hashName] = new Object();
					this.resultFileds[colName][hashName]["name"] = colName;
					this.resultFileds[colName][hashName]["type"] = fieldsInfo[i].type;
					this.resultFileds[colName][hashName]["dpType"] = fieldsInfo[i].dpType;
					this.resultFileds[colName][hashName]["size"] = fieldsInfo[i].size;
					if (fieldsInfo[i]["default"] != "")
						this.resultFileds[colName][hashName]["default"] = fieldsInfo[i]["default"];
					else
					{
						var struFieldInfo = this.getStruFieldInfo(tableName, colName);	
						if (struFieldInfo != null)
							this.resultFileds[colName][hashName]["default"] = struFieldInfo["default"];														
					}
					this.resultFileds[colName][hashName]["contain"] = new Array();
					this.resultFileds[colName]["length"] += 1;
				}
				this.resultFileds[colName][hashName].
						contain[this.resultFileds[colName][hashName].
														contain.length] =
																basePath + this.point + extention + "_" + tableName;
			}
			return 1;							
			break;
		case STRU_MODE:
			var fieldsInfo = getStruFields(tableName);
			if (!fieldsInfo)			
				return 0;
			for (var i in fieldsInfo)
			{
				var colName = fieldsInfo[i].name;
				var hashName = colName + "_" + fieldsInfo[i].type;
				if (this.drainTables[tableName] != null)				
					this.drainTables[tableName][colName] = fieldsInfo[i];
				if (this.resultFileds[colName] == null)
				{
					this.resultFileds[colName] = new Object();
					this.resultFileds[colName]["length"] = 0;
				}
				if (this.resultFileds[colName][hashName] == null)
				{
					this.resultFileds[colName][hashName] = new Object();
					this.resultFileds[colName][hashName]["name"] = fieldsInfo[i].name;
					this.resultFileds[colName][hashName]["type"] = fieldsInfo[i].type;
					this.resultFileds[colName][hashName]["dpType"] = fieldsInfo[i].dpType;
					this.resultFileds[colName][hashName]["size"] = fieldsInfo[i].size;
					this.resultFileds[colName][hashName]["default"] = fieldsInfo[i]["default"];
					this.resultFileds[colName][hashName]["contain"] = new Array();
					this.resultFileds[colName]["length"] += 1;
				}
				this.resultFileds[colName][hashName].
							contain[this.resultFileds[colName][hashName].
															contain.length] = 
																	basePath + this.point + extention + "_" + tableName;					
			}
			return 1;
			break;
		case DB_MODE:
			try
			{
				var sTable = extention + "_" + tableName;
				if (!IsTableEx(basePath, extention + "_" + tableName))
					return 0;
				var irs  = null;
				if (SUBD == MSSQL || SUBD == MYSQL)
					rs = this.dbmd.getColumns(basePath, null, sTable, null);
				else
					rs = this.dbmd.getColumns(null, path, sTable, null);
				while (rs.next() == true)
				{
					var colName = String(rs.getString("COLUMN_NAME"));
					var type = String(rs.getString("TYPE_NAME"));
					var size = String(rs.getString("COLUMN_SIZE"));
					var hashName = colName+"_"+type+"_"+size;
					if (this.drainTables[tableName] != null)				
						this.drainTables[tableName][colName] = type + "(" + size + ")";
					
					if (this.resultFileds[colName] == null)
					{
						this.resultFileds[colName] = new Object();
						this.resultFileds[colName]["length"] = 0;
					}
					if (this.resultFileds[colName][hashName] == null)
					{
						this.resultFileds[colName][hashName] = new Object();
						this.resultFileds[colName][hashName]["name"] = colName;
						this.resultFileds[colName][hashName]["type"] = type;
						this.resultFileds[colName][hashName]["size"] = size;
						this.resultFileds[colName][hashName]["contain"] = new Array();
						this.resultFileds[colName]["length"] += 1; 
					}		
					this.resultFileds[colName][hashName].
									contain[this.resultFileds[colName][hashName].
														contain.length] = 
																basePath + this.point + extention + "_" + tableName;								
				}
				if (rs) rs.close();
				return 1;
			}
			catch(x)
			{
				this.noProcessedTbl[this.noProcessedTbl.length] = tableName;
				this.traceErrorMsg(x, "fillMapFields");
			}	
	}
	return 0;
}

function DpDrainPrik_drain()
{
	this.columnsSQL = new Array();
	this.columns = new Array();
	this.ignoreColumns = new Array();
	this.parseColumns(this.columnsSQL, this.columns, this.ignoreColumns);
	var strColumnsSQL = "";
	for (var i = 0; i < this.columnsSQL.length; i++)
		if (i == 0)
			strColumnsSQL += this.columnsSQL[i];
		else
			strColumnsSQL += ", " + this.columnsSQL[i];
	if (strColumnsSQL == "")
		return false;
	for (var i in this.fieldsTable)
		if (typeof this.fieldsTable[i] == "string")
			strColumnsSQL += ", " + i + " " + SqlType(this.fieldsTable[i]);
	if (!IsTableEx("ZRP_MDB", String("ZRP_" + this.resultTableName).toUpperCase()))
	{
		alert("Таблица " + this.resultTableName + " не существует. Проведите модификацию!");
		return false;
	}
	/*DropTable(this.resultTableName);
	if (!ExecuteSQL("CREATE TABLE " + this.resultTableName + "(" + strColumnsSQL + ")"))
		return false;*/
	
	//определим код приказа авансов, чтобы проставить его в PRK_ALL, т.к. в 2000 версии расчет авансов не обращал внимания на вид приказа
	var fvidAvns = 0;
	var snap = getSnap("select Fvid from ^cl_prik where LOWER(Fproc)="+sqlTo("_avns"));
	if(snap)
		fvidAvns = snap[0];
	for (var i in this.mapDrainTables)
		for (var j in this.mapDrainTables[i])
			for (var n in this.mapDrainTables[i][j])
			{
				var insertColumns = "";
				for (var z = 0; z < this.columns.length; z++)
				if (typeof this.mapDrainTables[i][j][n][this.columns[z]] != "undefined")
				{
					if(n.toUpperCase()=="PRK_O" && this.columns[z].toUpperCase()=="FNOM_PRIK")
						continue;
					if (insertColumns.equals(""))
						insertColumns += this.columns[z];
					else
						insertColumns += "," + this.columns[z];
				}
				if (insertColumns.equals(""))
					continue;	
				var fullTableName = i + this.point + j + "_" + n;
				//обрабатываем таблицы AVNS%LD и DLTU%LD
				if(n.toUpperCase().indexOf("%LD") != -1)
				{
					var database = i;
					var tblName = j + "_" + n;
					var pattern = tblName.substring(0,tblName.indexOf("%LD")+1);
					var tablesEx = getTablesForPattern(database,pattern);
					if(tablesEx.length==0)
						continue;
					for (var nTEx = 0; nTEx < tablesEx.length; nTEx++)
					{
						if (tablesEx[nTEx].substr(tblName.indexOf("%")).search("[0-9]{6}") == -1)
							if (tablesEx[nTEx].substr(tblName.indexOf("%")).search("[0-9]{7}") == -1)
								continue;
						var fullTblName = database + this.point + tablesEx[nTEx];
						tblLabel = tablesEx[nTEx].substring(tablesEx[nTEx].indexOf("_")+1)
						ExecuteSQL(" INSERT INTO ^" + this.resultTableName
								+ "(" + insertColumns + ",FIN_TABLE" + ") "
							+ " SELECT " + (n.toUpperCase()=="AVNS%LD" && fvidAvns?insertColumns.toUpperCase().replace("FVID_PRK",fvidAvns+" AS FVID_PRK"):insertColumns) 
								+ "," + sqlTo(tblLabel) + " AS FIN_TABLE "
							+ " FROM " + fullTblName);
					}
				}
				else
				{
					if(n.toUpperCase()!="PRK" && n.toUpperCase()!="PRK_FMPL")//таблицы PRK и PRK_FMPL к приказам не относятся
					{
						ExecuteSQL(
							" INSERT INTO ^" + this.resultTableName
								+ "(" + insertColumns + ",FIN_TABLE" + ") "
							+ " SELECT " + insertColumns + "," + sqlTo(n) + " AS FIN_TABLE "
							+ " FROM " + fullTableName);
						if(n.toUpperCase()=="PRK_O")
						{
							//в dpmapping-е отпускных поля Fdat_prik и Fcalnum теперь берутся из PRK_ALL
							ExecuteSQL("update ^prk_all set "
								+" Fdat_prik=(select MIN(Fdat_prik) from ^prk_o as o1 where ^prk_all.Fwid=o1.Fwid),"
								+" Fcalnum=(select MAX(Fcalnum) from ^prk_o as o2 where ^prk_all.Fwid=o2.Fwid)"
								+" where exists(select Fwid from ^prk_o as o3 where ^prk_all.Fwid=o3.Fwid)")
						}
					}
				}
			}
	ExecuteSQL("UPDATE ^" + this.resultTableName + " SET fwid_prik="
		+ "(SELECT MAX(p.fwid) FROM ^cl_prik AS p WHERE ^" + this.resultTableName + ".fvid_prk=p.fvid)");

	ExecuteSQL("UPDATE ^" + this.resultTableName
		+ " SET fvid_prk=(SELECT MAX(fvid_prk) "
				+ " FROM ^nar_ktu n"
				+ " WHERE n.fwid = ^" + this.resultTableName + ".fid"
				+ ")"
			+ ", fsum = (SELECT fsum+fsum_tar"
				+ " FROM ^ktu_isp n"
				+ " WHERE n.fid = ^" + this.resultTableName + ".fid"
					+ " AND n.fwid = ^" + this.resultTableName + ".fwid"
				+ ")"
		+ " WHERE fin_table='KTU_ISP'"
		)

	ExecuteSQL("UPDATE ^ktu_isp SET fsum_sd = fsum");

	ExecuteSQL("DELETE FROM ^shifrpz");
	ExecuteSQL("INSERT INTO ^shifrpz"
		+ "       (fksprizd, fnsprizd, fshpz, fshpz_txt, fsc, fsu, fst, fcod1, fcod2, fcod3)"
		+ " SELECT fksprizd, fnsprizd, fshpz, fshpz_nam, fsc, fsu, fst, fcod1, fcod2, fcod3"
		+ " FROM ^cl_shpz"
		);
	
	var existsFTABN_ID = false;
	var fieldInfo = OpenTable("m", "SELECT * FROM ^" + this.resultTableName + " WHERE 1<>1")
																				.getFieldInfo("ftabn_id");
	if (fieldInfo == null)
		existsFTABN_ID = this.addColumn(this.resultTableName, "ftabn_id", SqlType("long"));
	else
		existsFTABN_ID = true;
	if (existsFTABN_ID)
	{
		ExecuteSQL("UPDATE ^" + this.resultTableName + " SET ftabn_id= "
					+ "(SELECT MAX(wp.fwid_cl) FROM ^work_pers AS wp WHERE wp.fwid=^" + this.resultTableName + ".fwid_wp) "
				+ " WHERE fwid_wp IS NOT NULL");
	}
	return true;	
}

function DpDrainPrik_parseColumns(arrayToSQL, arrayCorrect, arrayIgnore)
{
	for (var i in this.resultFileds)
	{
		var prior = 0;
		var dpType = null;
		var dpDefault = null;
		var differType = false;
		for (var j in this.resultFileds[i])
		{
			if (j == "length")
				continue;
			var tmp = this.getNumberHierarchy(this.resultFileds[i][j].dpType);
			if (tmp > 0)
			{
				if (tmp > prior)
				{
					prior = tmp;
					dpType = this.resultFileds[i][j].dpType;	
					dpDefault = this.resultFileds[i][j]["default"];								
				}
			}
			else
			{
				dpType = this.resultFileds[i][j].dpType;
				dpDefault = this.resultFileds[i][j]["default"];
			}
		}
		if (differType || dpType == null)
		{
			arrayIgnore[i] = i;
			continue;
		}
		if (arrayToSQL != null)
			arrayToSQL[arrayToSQL.length] = allt(i + " " + SqlType(dpType) + (dpDefault ? dpDefault : "")) ;
		if (arrayCorrect != null)
			arrayCorrect[arrayCorrect.length] = allt(i);		 
	}
}

function DpDrainPrik_getNumberHierarchy(name)
{
	var result = new Array();
	result["bit"] = 0;
	result["byte"] = 1;	
	result["short"] = 2;
	result["long"] = 3;
	result["double"] = 4;
	result["currency"] = 5;
	result["MIN_PRIOR"] = 0;
	result["MAX_PRIOR"] = 5;
	if (name != "MIN_PRIOR" && name != "MAX_PRIOR" && typeof result[name] != "undefined")
		return result[name];
	return -1;
}

function DpDrainPrik_getTextHierarchy(name)
{
	var result = new Array();
	result["text"] = 0;
	result["longtext"] = 1;	
	result["MIN_PRIOR"] = 0;
	result["MAX_PRIOR"] = 1;
	if (name != "MIN_PRIOR" && name != "MAX_PRIOR" && typeof result[name] != "undefined")
		return result[name];
	return -1;	
}

function DpDrainPrik_getWarningType()
{
	var result = new Array();
	result["bit"] = true;
}

function DpDrainPrik_differType()
{
	var result = new Array();
	result["datetime"] = true;
	result["text"] = true;
	result["number"] = true;
}

function DpDrainPrik_getFieldsResultTable()
{
	var result = new Array();
	result["FWID"] = true;
	result["FTABN_ID"] = true;
	result["FWID_WP"] = true;
	result["FVID_PRK"] = true;
	result["FBDAT"] = true;
	result["FEDAT"] = true;
	result["FSUM"] = true;
	result["FPROC"] = true;
	result["FWID_PRIK"] = "long";
	result["FIN_TABLE"] = "text";
	result["FTEXT"] = "longtext";
	
	result["FSUM_IND"] = true;
	result["FCALNUM"] = true;
	result["FDAT_BOL"] = true;
	result["FKOEF"] = true;
	result["FDAT_OTP"] = true;
	result["FMES_VIP"] = true;
	result["FADDR"] = true;
	result["FIND_SV"] = true;
	result["FIO_POL"] = true;
	result["FLAST_DAT"] = true;
	result["FNUM"] = true;
	result["FSBOR"] = true;
	result["FSUM_DO"] = true;
	result["FSUM_POSL"] = true;
	result["FNOM_PRIK"] = true;
	result["FSHPZ"] = true;
	result["FKODIZD"] = true;
	//result["FDAT_PRIK"] = true;
	//result["FSUMN"] = true;
	//result["FSUMOBL"] = true;
	//result["FSUMNAL"] = true;
	//result["FSUMNALN"] = true;
	//result["FVIDNACH"] = true;
	//result["TIN"] = "text";
	result["FID"] = true;
	return result;
}

function DpDrainPrik_getStruFieldInfo(tableName, fieldName)
{
	var fieldsInfo = getStruFields(tableName);
	for (var i in fieldsInfo)
	{		
		if (fieldsInfo[i].name.equalsIgnoreCase(fieldName))
			return fieldsInfo[i];
	}
	return null;
}

function DpDrainPrik_addColumn(table, column, typeColumn)
{
	var strSQL = "ALTER TABLE ^" + table + " ADD ";
	if (SUBD != ORACLE)
		strSQL += "COLUMN ";	
	strSQL += column + " " + typeColumn;
	return ExecuteSQL(strSQL, false);
}

function DpDrainPrik_logResultField(allCount, procCount)
{
	var LOG = "\nОбработано " + procCount + " из " + allCount;
	if (this.noProcessedTbl.length > 0)
	{
		LOG += "\nНе обработаны таблица(ы): ";
		for (var i in this.noProcessedTbl)
			LOG += this.noProcessedTbl[i] + "; "
	}
	for (var i in this.resultFileds)
	{
		if (this.showDiffer && this.resultFileds[i].length == 1)
			continue;
		var str = "\n--------------------------------------------------------------------------------------\n";
		str += "Имя колонки: " + i;		
		str += "\nКоличество вариаций по типу и/или размеру: " +  this.resultFileds[i].length;
		var n = 0;
		for (var z in this.allDrainTables)
			this.allDrainTables[z] = false;
		for (var j in this.resultFileds[i])
		{
			if (j == "length")
				continue;
			str += "\n\tВариант №" + (++n);
			str += "\n\t\tТип: " + this.resultFileds[i][j].type;
			if (this.resultFileds[i][j].fulltype)
				str += "\n\t\tТип БД: " + this.resultFileds[i][j].fulltype;
			if (this.resultFileds[i][j].dpType)
				str += "\n\t\tТип ДП: " + this.resultFileds[i][j].dpType;
			if (this.resultFileds[i][j].size)	
				str += "\n\t\tРазмер : " + this.resultFileds[i][j].size;
			if (this.resultFileds[i][j]["default"])
				str += "\n\t\tТип по умолчанию : " + this.resultFileds[i][j]["default"];		
			if (this.resultFileds[i][j].contain)
				str += "\n\t\tПрисутствует в " + this.resultFileds[i][j].contain.length + " таблице(ах) :";
			else
				str += "\n\t\tПрисутствует в таблице(ах) :";
			for (var m in this.resultFileds[i][j].contain)
			{
					str += "\n\t\t\t- " + this.resultFileds[i][j].contain[m];
					if (typeof this.allDrainTables[this.resultFileds[i][j].contain[m]] != "undefined")
						this.allDrainTables[allt(this.resultFileds[i][j].contain[m])] = true;
			}
		}
		var outAdd = false;
		for (var z in this.allDrainTables)
		{
			if (this.allDrainTables[z] == false)
			{
				if (!outAdd)
				{
					str += "\n\tОтсутствует в таблице(ах) :";
					outAdd = true;
				}
				str += "\n\t\t- " + z;
			}
		}
		str += "\n--------------------------------------------------------------------------------------";
		trace(str);
		LOG += str;
	}
	this.columnsSQL = new Array();
	this.columns = new Array();
	this.ignoreColumns = new Array();
	this.parseColumns(this.columnsSQL, this.columns, this.ignoreColumns);
	if (this.ignoreColumns.length > 0)
	{
		LOG += "\nИз-за несоответствия типов НЕ БУДУТ добавлены такие поля: ";
		for (var i in this.ignoreColumns)
			LOG += i + "; "
		LOG += "\n";
	}
	var endsFileName = "";
	switch (this.mode)
	{
		case OPEN_MODE:
			endsFileName = "open";
			break;
		case STRU_MODE:
			endsFileName = "stru";
		case DB_MODE:
			endsFileName = "db";		
	}		
	lpProxy.writeToFile(LOG, "c:/dpdrainprik_" + endsFileName + ".log", "Cp1251");
}

function DpDrainPrik_traceErrorMsg(error, funcName)
{
	trace("<<ERROR>> DpDrainPrik :: " + funcName + " -> " + error.rhinoException.getLocalizedMessage());
}	