include("Objects/DpXMLDomDocument.js");
include("objects/DpDbMod.js");

DpExtentionBuilder.prototype.buildStubs = DpExtentionBuilder_buildStubs;
DpExtentionBuilder.prototype.commitStructure = DpExtentionBuilder_commitStructure;
DpExtentionBuilder.prototype.getDpType = DpExtentionBuilder_getDpType;
DpExtentionBuilder.prototype.getInfoTableName = DpExtentionBuilder_getInfoTableName;
DpExtentionBuilder.prototype.getValueTableName = DpExtentionBuilder_getValueTableName;
DpExtentionBuilder.prototype.deleteValues = DpExtentionBuilder_deleteValues;
DpExtentionBuilder.prototype.exist = DpExtentionBuilder_exist;
DpExtentionBuilder.prototype.load = DpExtentionBuilder_load;
DpExtentionBuilder.prototype.save = DpExtentionBuilder_save;
DpExtentionBuilder.prototype.del = DpExtentionBuilder_del;
DpExtentionBuilder.prototype.getXmlFile = DpExtentionBuilder_getXmlFile;
DpExtentionBuilder.prototype.getExtElement = DpExtentionBuilder_getExtElement;
DpExtentionBuilder.prototype.getAttr = DpExtentionBuilder_getAttr;
DpExtentionBuilder.prototype.strVal = DpExtentionBuilder_strVal;
DpExtentionBuilder.prototype.objVal = DpExtentionBuilder_objVal;
DpExtentionBuilder.prototype.getTxt = DpExtentionBuilder_getTxt;
DpExtentionBuilder.prototype.getDefault = DpExtentionBuilder_getDefault;
DpExtentionBuilder.prototype.getDpTypeNum = DpExtentionBuilder_getDpTypeNum;

function DpExtentionBuilder(sVid,sDomen,sName)
{
	this.ExtVid = sVid;
	this.ExtDomen = (sDomen?(allt(sDomen)==""?null:sDomen):null);
	this.ExtName = (sName?(sName==""?null:sName):null);
	
	this.FCLASS = this.ExtVid + (this.ExtDomen != null?"." + this.ExtDomen:"");
	this.FSUBCLASS = (this.ExtName != null?String(this.ExtName):null);
	
	this.tblVal = this.FCLASS + (this.FSUBCLASS != null?"." + this.FSUBCLASS:"");
	this.tblVal = this.tblVal.replace(/\./g,"_");
	this.tblVal = this.tblVal.replace(":","_");
	
	this.tblInfo = "^CL_EXT";
	this.tblInfoWhere = "FCLASS=" + sqlTo(this.FCLASS);
	var sqlSubclass = " AND (";
	if (this.FSUBCLASS != null)
	{
		sqlSubclass += " FSUBCLASS=" + sqlTo(this.FSUBCLASS);
		if (this.FSUBCLASS == 0)
			sqlSubclass += " OR FSUBCLASS IS NULL OR FSUBCLASS=" + sqlEmpStr + " OR FSUBCLASS=' '";
	}
	else
	{
		sqlSubclass += " FSUBCLASS IS NULL OR FSUBCLASS=" + sqlEmpStr + " OR FSUBCLASS=' '";
	}
	sqlSubclass += ")";
	this.tblInfoWhere += sqlSubclass;
	
	this.xmlFile = this.getXmlFile(sVid, sDomen, sName);
	this.arrExt = new Object();
	this.type = "";
	this.DpAPI = lpProxy.getDpAPI();
	this.path = getOrgPath() +"settings/extentions/";
	//this.load();
}

function DpExtentionBuilder_getXmlFile(sVid, sDomen, sName)
{
	if(sDomen)
	{
		sDomen = new java.lang.String(String(sDomen));
		sDomen = sDomen.replaceAll(":","_").replaceAll("\\.","_");		
	}
	this.xmlDir = getOrgPath() +"settings/extentions/";
	if(!sVid)
		return null;
	this.xmlFile = this.xmlDir + sVid + (sDomen!=null? "_"+ sDomen : "") + (sName!=null? "_"+ sName : "") +".xml";
	if(sVid=="CL")
	{
		if(!sDomen)
			sDomen = "0";
		this.xmlDir = this.xmlDir +"cls/";
		this.xmlFile = this.xmlDir + sDomen +".xml";
	}
	if(sVid=="H")
	{
		if(!sName)
			sName = "0";
		this.xmlDir = this.xmlDir +"docs/"+ (sDomen!=null? sDomen +"/" : "");
		this.xmlFile = this.xmlDir + sName +".xml";
	}
	if(sVid=="R")
	{
		if(!sName)
			sName = "0";
		if(sDomen.lastIndexOf("_")!=-1)
		{
			//sName += "_"+ sDomen.substring(sDomen.indexOf(".")+1);
			sDomen = sDomen.substring(0, sDomen.lastIndexOf("_"));
		}
		this.xmlDir = this.xmlDir +"docs/"+ (sDomen!=null? sDomen +"/" : "");
		this.xmlFile = this.xmlDir + sName +".xml";		
	}
	
	return this.xmlFile;
}

function DpExtentionBuilder_load(bFillTbl, sTblName, sLabel)
{
	if(sTblName && !IsTable(sTblName))
		CreateTable(sTblName, this.tblInfo);
	if(!sTblName)
		sTblName = this.tblInfo;		
	if(!isFile(this.xmlFile))
		return;
	
	var xmlDom = new DpXMLDOMDocument();
	xmlDom.load(this.xmlFile);
	var root = xmlDom.getDocumentElement();
	var main = root.getElementsByTagName("header")[0];	
	if(this.ExtVid=="R")
	{
		var sRowClass = null;
		if(this.ExtDomen.indexOf(".")!=-1)
			sRowClass = this.ExtDomen.substring(this.ExtDomen.indexOf(".")+1);
		if(sRowClass)
			main = root.getElementsByTagName(sRowClass)[0];
	}
	if(!main)
		return;	
	
	if(bFillTbl)
		ExecuteSQL("delete from "+ sTblName +" where "+ this.tblInfoWhere);
	var vars = main.getChildNodes();	
	for(var i = 0; i < vars.length; i++)
	{
		var eVar = vars[i];
		if(!eVar || (sLabel && String(sLabel)!=String(eVar.getNodeName())))
			continue;		
		var m = new Object();
		m.FWID = GetUID();
		m.FCLASS = this.FCLASS;
		m.FSUBCLASS = this.FSUBCLASS;
		m.FLABEL = eVar.getNodeName();
		m.FTXT = eVar.getText();
		m.FCOMMENT = eVar.getAttribute("comment");
		m.FWIDTH = Number(eVar.getAttribute("width"));
		m.FPOS = Number(eVar.getAttribute("pos"));		
		m.FTYPE = eVar.getAttribute("type");		
		m.FFORMAT = eVar.getAttribute("format");
		m.FUSED = eVar.getAttribute("used")=="true" || eVar.getAttribute("used")=="1";
		m.FISCULC = eVar.getAttribute("isculc")=="true" || eVar.getAttribute("isculc")=="1";
		m.FISCHECK = eVar.getAttribute("ischeck")=="true" || eVar.getAttribute("ischeck")=="1";
		m.FISFIRSTPG = eVar.getAttribute("isfirstpg")=="true" || eVar.getAttribute("isfirstpg")=="1";
		m.FISPREFIX = eVar.getAttribute("isprefix");
		if(bFillTbl)
			UpdateTable(sTblName, m, true);
			
		m.FDEFAULT = this.objVal(eVar.getAttribute("default"));
		this.arrExt[m.FLABEL] = m;
	}
}

function DpExtentionBuilder_save(m)
{
	if(!isDir(this.xmlDir))
		createDirectory(this.xmlDir);
	
	this.type = m.Ftype;
	var def = this.strVal(m.Fdefault);
	
	var xmlDom = new DpXMLDOMDocument();
	var root = xmlDom.createElement("extentions");
	if(this.ExtVid=="R")
	{		
		var sRowClass = "ROW";
		if(this.ExtDomen.indexOf(".")!=-1)
			sRowClass = this.ExtDomen.substring(this.ExtDomen.indexOf(".")+1);
		
		var eRow = null;
		var eVar = null;
		if(isFile(this.xmlFile))
		{
			xmlDom.load(this.xmlFile);
			root = xmlDom.getDocumentElement();			
			var rows = root.getElementsByTagName("rows")[0];
			if(!rows)
			{
				rows = xmlDom.createElement("rows");
				root.appendChild(rows);
			}
			eRow = rows.getElementsByTagName(sRowClass)[0];
			if(!eRow)
			{
				eRow = xmlDom.createElement(sRowClass);
				rows.appendChild(eRow);
			}
			eVar = eRow.getElementsByTagName(m.Flabel)[0];
			if(eVar!=null)						
				eRow.removeChild(eVar);		
		}
		else
		{
			var rows = xmlDom.createElement("rows");
			root.appendChild(rows);
			eRow = xmlDom.createElement(sRowClass);
			rows.appendChild(eRow);
		}		
		eVar = xmlDom.createElement(m.Flabel);
		eVar.setText(m.Ftxt);
		eVar.setAttribute("comment", m.Fcomment);
		eVar.setAttribute("width", m.Fwidth);
		eVar.setAttribute("pos", m.Fpos);
		eVar.setAttribute("used", String(m.Fused));
		eVar.setAttribute("isfirstpg", String(m.Fisfirstpg));
		eVar.setAttribute("ischeck", m.FISCHECK);
		eVar.setAttribute("isprefix", String(m.Fisprefix));
		eVar.setAttribute("type", m.Ftype);
		eVar.setAttribute("isculc", String(m.Fisculc));
		eVar.setAttribute("format", m.Fformat);
		eVar.setAttribute("default", def);
		eRow.appendChild(eVar);
		
		if(!isFile(this.xmlFile))
			xmlDom.appendChild(root);
		xmlDom.save(this.xmlFile);
		this.load(false);
		return;
	}
		
	var header = null;
	var eVar = null;
	if(isFile(this.xmlFile))
	{
		xmlDom.load(this.xmlFile);
		root = xmlDom.getDocumentElement();
		header = root.getElementsByTagName("header")[0];
		if (!header)
		{
			header = xmlDom.createElement("header");
			root.appendChild(header);
		}
		eVar = header.getElementsByTagName(m.Flabel)[0];
		if(eVar!=null)						
			header.removeChild(eVar);		
	}
	else
	{
		header = xmlDom.createElement("header");
		root.appendChild(header);
	}		
	eVar = xmlDom.createElement(m.Flabel);
	eVar.setText(m.Ftxt);
	eVar.setAttribute("comment", m.Fcomment);
	eVar.setAttribute("width", m.Fwidth);
	eVar.setAttribute("pos", m.Fpos);
	eVar.setAttribute("used", m.Fused);
	eVar.setAttribute("ischeck", m.FISCHECK);
	eVar.setAttribute("isfirstpg", m.Fisfirstpg);
	eVar.setAttribute("isprefix", String(m.Fisprefix));
	eVar.setAttribute("type", m.Ftype);
	eVar.setAttribute("isculc", m.Fisculc);
	eVar.setAttribute("format", m.Fformat);
	eVar.setAttribute("default", def);
	header.appendChild(eVar);
	
	if(!isFile(this.xmlFile))
		xmlDom.appendChild(root);
	xmlDom.save(this.xmlFile);
	this.load(false);
}

function DpExtentionBuilder_del(sExtLabel)
{	
	if(!isFile(this.xmlFile))
	{
		return;	
	}
	
	var xmlDom = new DpXMLDOMDocument();
	xmlDom.load(this.xmlFile);
	
	var root = xmlDom.getDocumentElement();
	//fruckt
	//если имеется совпадение имени расширения строк и заголовка документа
	//то при удалении одного из них, удаляется и второе
	//var eVar = root.getElementsByTagName(sExtLabel)[0];
	switch (this.ExtVid)
	{
		case "R":
			var eVar = root.selectSingleNode("rows/ROW/"+sExtLabel);
		break;
		case "H":
			var eVar = root.selectSingleNode("header/"+sExtLabel);
		break;
		default:
			var eVar = root.getElementsByTagName(sExtLabel)[0];
		break;
	}
	
	if (eVar != null)
	{
		var eRow = eVar.getParentNodeEx();
		if(eVar != null)
		{
			eRow.removeChild(eVar);
		}
	}
	
	xmlDom.save(this.xmlFile);
}

function DpExtentionBuilder_getExtElement(sLabel, sClass, sSubclass)
{
	if(!sClass)
		sClass = this.FCLASS;
	if(!sSubclass)
		sSubclass = this.FSUBCLASS;
	if(!this.xmlFile || sClass!=this.FCLASS || sSubclass!=this.FSUBCLASS)
	{
		var sVid = "";
		if(sClass.indexOf(".")!=-1)
		{
			sVid = sClass.substring(0, sClass.indexOf("."));
			sClass = sClass.substring(sClass.indexOf("."));
		}
		this.getXmlFile(sVid, sClass, sSubclass);
	}
	if(!isFile(this.xmlFile))
		return null;	
	var xmlDom = new DpXMLDOMDocument();
	xmlDom.load(this.xmlFile);
	var root = xmlDom.getDocumentElement();
	var eVar = root.getElementsByTagName(sLabel)[0];
	return eVar;
}

function DpExtentionBuilder_getAttr(sLabel, sAttr, sClass, sSubclass)
{
	var ext = this.getExtElement(sLabel, sClass, sSubclass);
	if(!ext)
		return null;
	if(sAttr=="TXT" || sAttr=="FTXT")
		return ext.getText();
	return ext.getAttribute(sAttr);
}

function DpExtentionBuilder_exist()
{
	return IsTableEx("EXT",this.tblVal);
}

function DpExtentionBuilder_buildStubs()
{
	var mod = new DpDbMod();
	
	if (!this.exist())
	{
		var infoFlds = getStruFields("EXT_STUB");
		mod.CreateTable("EXT","",this.tblVal,infoFlds);
		
	}
	var stTbl = new tableModInfo();
	stTbl.base = "EXT";
	stTbl.table = this.tblVal;
	stTbl.pattern = "EXT_STUB";
	stTbl.fullName = this.tblVal;
	mod.CreateIndex(stTbl,"FMAINWID");
}

function DpExtentionBuilder_commitStructure(bIgnoreExisting)
{
	var mod = new DpDbMod();
	var fiArr = new Array();
	var structTbl = OpenTable("s",
							  "SELECT * FROM " + this.getInfoTableName()
							  + " WHERE " + this.tblInfoWhere);
	
	for (structTbl.MoveFirst();!structTbl.isEOF();structTbl.MoveNext())
	{
		var fName = structTbl.getValue("FLABEL");
		if(fName == null)
			continue;
		fName = "F" + String(fName);
		var fDpType = this.getDpType(String(structTbl.getValue("FTYPE")));
		if (SUBD != ORACLE && SUBD != MSSQL && fDpType == "text(255)")
			fDpType = "longtext";
		var dbType = getStruType(fDpType,false);
		var def = getStruDefForType(fDpType);
		var fi = new FieldInfo(fName,dbType,def);
		fi.setDpType(fDpType);
		fiArr[fiArr.length] = fi;
	}
	structTbl.close();
	
	fiArr = concatArray(fiArr, getStruFields("EXT_STUB"));
	
	if (!IsTableEx("EXT",this.tblVal))
	{
		mod.CreateTable("EXT","",this.tblVal,fiArr);
		var stTbl = new tableModInfo();
		stTbl.base = "EXT";
		stTbl.table = this.tblVal;
		stTbl.pattern = "EXT_STUB";
		stTbl.fullName = getPath("EXT") + mod.sPoint + this.tblVal;
		mod.CreateIndex(stTbl,"FMAINWID");
	}
	else
	{
		var sSQL = "SELECT * FROM " + getPath("EXT") + mod.sPoint + this.tblVal
				 + " WHERE 1<>1";
		mod.tbl = OpenTable("s",sSQL);
		mod.ModifyTable("EXT", "", "", this.tblVal, fiArr, bIgnoreExisting);	
		
	}
	
	  lpProxy.getDBManager().clearExtInfoCash();
}

function DpExtentionBuilder_getDpType(sType)
{
	sType = String(sType).toUpperCase();

	//vlad
	//У нас могут быть расширения типа счет - ан.3
	//У них в типе содержится "группа", указанная на этапе настройки.
	//Например, для статьи в группе "qqq" тип будет "STqqq"
	//Кроме того, аналитики имеют тип C1-C3, который никак не обработан (на 24.11.2011)
	switch(sType.substr(0, 2))
	{
		case "SC":
		case "SU":
		case "ST":
		case "C1":
		case "C2":
		case "C3":
			sType = sType.substr(0, 2);
			break;
	}

	switch(sType)
	{
		case "BOOL":
			return "bit";
		case "CURRENCY":
			return "currency";
		case "DATETIME":
			return "datetime";
		case "FLOAT":
			return "single";
		case "INT":
			return "long";
		case "SC":
			return "sc";
		case "SU":
			return "su";
		case "ST":
			return "st";
		case "V":
			return "cval";
		case "NMK":
		case "C1":
		case "C2":
		case "C3":
			return "cid";
		case "TEXT":
			return "longtext";
		case "RS":
			return "text(512)";
		default:
			if ("A" == sType.substring(0,1))
				return "cid";
			if ("R" == sType.substring(0,1))
				return "cid";
			if (sType.startsWith("CNTRCT"))
				return "cid";
		return "text(512)";
	}
}

function DpExtentionBuilder_getInfoTableName()
{
	return this.tblInfo;
}

function DpExtentionBuilder_getValueTableName()
{
	return getPath("EXT")
		   + "." + (SUBD == MSSQL?".":"")
		   + this.tblVal;
}

function DpExtentionBuilder_deleteValues(nID)
{
	ExecuteSQL("DELETE FROM "
			 + this.getValueTableName()
			 + " WHERE FMAINWID=" + sqlTo(Number(nID)),false);
	if (this.ExtName != null && this.ExtName != 0)
	{
		var parBldr = new DpExtentionBuilder(this.ExtVid,this.ExtDomen,null);
		ExecuteSQL("DELETE FROM "
				 + parBldr.getValueTableName()
				 + " WHERE FMAINWID=" + sqlTo(Number(nID),false)
				  );
		parBldr = null;
	}
}

function DpExtentionBuilder_getTxt(sLabel)
{
	if(this.arrExt)
	{
		var oExt = this.arrExt[sLabel];
		if(oExt && oExt.FTXT)
			return oExt.FTXT;
	}
	return "";
}

function DpExtentionBuilder_getDefault(sLabel)
{
	if(this.arrExt)
	{
		var oExt = this.arrExt[sLabel];
		if(oExt && oExt.FDEFAULT)
			return oExt.FDEFAULT;
	}
	return null;
}

function DpExtentionBuilder_strVal(oVal)
{
	var nType = this.getDpTypeNum();
	if(!nType)
		return String(oVal);
	var sVal = this.DpAPI.obj2XmlStr(oVal, nType);	
	return sVal;
}

function DpExtentionBuilder_objVal(sVal)
{
	var nType = this.getDpTypeNum();
	if(!nType)
		return sVal;	
	var oVal = this.DpAPI.str2Obj(sVal, nType);
	return oVal;
}

function DpExtentionBuilder_getDpTypeNum()
{
	var nType = 0;		
	if(!this.type)
		return nType;
	switch(this.type.toUpperCase())
	{
		case "TEXT":
			nType = 1;
			break;
		
		case "DATETIME":
			nType = 6;
			break;
		
		case "BOOL":
			nType = 5;		
			break;
		
		case "C1":
		case "C2":
		case "C3":
		case "NMK":
		case "RS":
		case "ST":
		case "SU":
		case "SC":
		case "V":
		case "R":	
		case "A":
		case "INT":
			nType = 2;
			break;
			
		case "FLOAT":
		case "CURRENCY":
			nType = 4;
			break;
	}
	return nType;
}