include("objects\\DpExtentionBuilder.js");
include("doc\\DpDoc.js");

DpExtentionDecoder.prototype.fillValues = DpExtentionDecoder_fillValues;
DpExtentionDecoder.prototype.run = DpExtentionDecoder_run;
DpExtentionDecoder.prototype.getField = DpExtentionDecoder_getField;

function DpExtentionDecoder()
{
}

function DpExtentionDecoder_getField(sType)
{
	sType = String(sType).toUpperCase();
	if (sType == "BOOL")
		return "FBOOL";
	if (sType == "CURRENCY")
		return "FCURRENCY";
	if (sType == "DATETIME")
		return "FDATETIME";
	if (sType == "FLOAT")
		return "FFLOAT";
	if (sType == "INT")
		return "FINT";
	if (sType == "RS")
		return "FTEXT";
	if (sType.startsWith("SC")
		|| sType.startsWith("SU")
		|| sType.startsWith("ST"))
		return "FLONG";
	if (sType == "TEXT")
		return "FTEXT";
	if (sType == "NMK")
		return "FTEXT";
	if (sType.startsWith("A")
		|| sType.startsWith("R"))
		return "FINT";
	return "F" + sType;
}

function DpExtentionDecoder_fillValues(tblFrom,tblTo,infoTbl,sWhere)
{
	//-1. нужно в таблицу со значениями перегнать все мэйнвиды
	//-1.1 нулевые фвиды - сделать равными 0
	var fwnullSQL = "UPDATE " + tblFrom
				  + " SET FMAINWID=0"
				  + " WHERE FMAINWID IS NULL";
	ExecuteSQL(fwnullSQL,false);
	var sSQL = "INSERT INTO " + tblTo + "(FMAINWID)"
			 + " SELECT FMAINWID"
			 + " FROM " + tblFrom
			 + " WHERE FWID IN "
			 	+ " ("
			 	+ " SELECT L.FWID"
			 	+ " FROM ^cl_ext_l L INNER JOIN ^cl_ext CL"
			 	+ " ON L.fwid=CL.fwid"
			 	+ " WHERE " + sWhere
			 	+ ")"
			 + " GROUP BY FMAINWID";
	ExecuteSQL(sSQL,false);
	//-2. нужно пройтись по расширениям и
	//- в результирующей таблице проапдейтить соответствующие колонки
	var tblInfo = OpenTable("s",infoTbl);
	for (tblInfo.MoveFirst();!tblInfo.isEOF();tblInfo.MoveNext())
	{
		var Fwid = tblInfo.getValue("FWID");	 //- фвид расширения
		var Flabel = "F" + String(tblInfo.getValue("FLABEL")); //- метка
		var Ftype = tblInfo.getValue("FTYPE");	 //- тип
		Ftype = String(Ftype).toUpperCase();
		var fromField = this.getField(Ftype);	 //- поле источник
		//- особое внимание уделяем типам - "валюта" и "номенклатура"
		var selSQL = "";
		if (Ftype == "NMK")
		{
			selSQL =  "SELECT MAX(NMK1.FWID)"
				   + " FROM " + tblFrom + " tblfrom"
				   + " INNER JOIN ^cl_nmk NMK1"
				   + " ON tblfrom.FTEXT=NMK1.FCOD"
				   + " WHERE tblfrom.FWID=" + sqlTo(Number(Fwid))
				   + " AND tblfrom.FMAINWID= " + tblTo + ".FMAINWID";
		} else if (Ftype.startsWith("V"))
		{
			selSQL = "SELECT MAX(VALT1.FKOD)"
				   + " FROM " + tblFrom + " tblfrom"
				   + " INNER JOIN ^cl_valut VALT1"
				   + " ON tblfrom.FTEXT=VALT1.FNAZVS"
				   + " WHERE tblfrom.FWID=" + sqlTo(Number(Fwid))
				   + " AND tblfrom.FMAINWID= " + tblTo + ".FMAINWID";
		}
		else
		{
			if (SUBD == MSSQL)
			{
				selSQL = "SELECT TOP 1 " + fromField + " "
				   + " FROM " + tblFrom + " tblfrom"
				   + " WHERE tblfrom.FWID=" + sqlTo(Number(Fwid))
				   + " AND tblfrom.FMAINWID= " + tblTo + ".FMAINWID";
			}
			else
			{
				selSQL = "SELECT MAX(" + fromField + ")"
				   + " FROM " + tblFrom + " tblfrom"
				   + " WHERE tblfrom.FWID=" + sqlTo(Number(Fwid))
				   + " AND tblfrom.FMAINWID= " + tblTo + ".FMAINWID";
			}
		}
		var updSQL = "UPDATE " + tblTo + " "
				   + " SET " + Flabel + "="
				   + "(" + selSQL + ")";
		ExecuteSQL(updSQL,false);
	}
	//в связи с тем, что при перекодировке с 2000 версии в таблице com_ext часто имеются левые записи (не удалялись при удалении объектов),
	//ссылающиеся на несуществующие объекты, то все дефолты будем удалять (пока не придумаем что-то более умное),
	//т.к. легче потом проставить нужные дефолты, чем исправлять несуществующие
	ExecuteSQL("delete from " + tblTo + " where Fmainwid=0");
	ExecuteSQL("insert into " + tblTo + " (Fmainwid) values(0)");
	tblInfo.close();
}

function DpExtentionDecoder_run(sWhere)
{
	//-1. метки должны быть правильными!!!
/*
	var mtkSQL = "UPDATE ^cl_ext"
				   + " SET FLABEL=" + SqlConCat(sqlTo("M"),"FLABEL")
				   + " WHERE FLABEL LIKE '!_%' ESCAPE '!'";
	ExecuteSQL(mtkSQL);
*/
	var sSQL = "SELECT DISTINCT FVID,FCL,FDOC,FNOP"
			 + " FROM ^cl_ext_l"
			 + " WHERE FVID<>' ' AND FVID IS NOT NULL"
			 + (sWhere?" AND (" + sWhere + ")":"");
	var infTbl = OpenTable("s",sSQL);
	var len = infTbl.getRecordCount();
	setProgressRangeEx(1,len + 1);
	setProgressPosEx(1,"Идёт перекодировка расширений...");
	
	for (infTbl.MoveFirst();!infTbl.isEOF();infTbl.MoveNext())
	{
		var Vid = infTbl.getValue("FVID");
		if (Vid == null)
			continue;
		Vid = allt(Vid);
		if (Vid == "")
			continue;
		if (Vid.equalsIgnoreCase("CL_NMK"))
		{
			setProgressPosEx(infTbl.getAbsolute() + 1,"Идёт перекодировка расширений "
							+ Vid + "...");
			var extBuilder = new DpExtentionBuilder("CL_NMK",null,null);
			extBuilder.buildStubs();
			var inSQL = "UPDATE ^cl_ext"
					  + " SET FCLASS=" + sqlTo("CL_NMK")
					  + ",FSUBCLASS=' '"
					  + " WHERE FWID IN"
					  	+ "("
					  	+ " SELECT FWID FROM ^cl_ext_l"
					  	+ " WHERE FVID=" + sqlTo("CL_NMK")
					  	+ ")";
			ExecuteSQL(inSQL,false);
			extBuilder.commitStructure();
			
			var sWhere = "L.FVID=" + sqlTo("CL_NMK");
			var InfoSQL = "SELECT * FROM " + extBuilder.getInfoTableName()
						+ " WHERE " + extBuilder.tblInfoWhere;
			this.fillValues("^ext_nmk",extBuilder.getValueTableName()
				,InfoSQL,sWhere);
			continue;
		}
		if (Vid.equalsIgnoreCase("CL"))
		{
			var sDomen = infTbl.getValue("FCL");
			if (sDomen == null)
				continue;
			sDomen = parseInt(Number(sDomen));
			if (isNaN(sDomen))
				continue;
			setProgressPosEx(infTbl.getAbsolute() + 1,"Идёт перекодировка расширений "
							+ Vid + " " + sDomen + "...");
			var extBuilder = new DpExtentionBuilder("CL",String(sDomen),null);
			extBuilder.buildStubs();
			var inSQL = "UPDATE ^cl_ext"
					  + " SET FCLASS=" + sqlTo("CL" + "." + sDomen)
					  + ",FSUBCLASS=' '"
					  + " WHERE FWID IN"
					  	+ "("
					  	+ " SELECT FWID FROM ^cl_ext_l"
					  	+ " WHERE FVID=" + sqlTo("CL")
					  	+ " AND FCL=" + sqlTo(sDomen)
					  	+ ")";
			ExecuteSQL(inSQL,false);
			extBuilder.commitStructure();
			
			var InfoSQL = "SELECT * FROM " + extBuilder.getInfoTableName()
						+ " WHERE " + extBuilder.tblInfoWhere;
			var sWhere = "L.FVID='CL'"
					+ " AND FCL=" + sqlTo(Number(sDomen))
			this.fillValues("^ext_cl",extBuilder.getValueTableName()
				,InfoSQL,sWhere);
			continue;
		 }
		 if (Vid == "H")
		 {
		 	var sDomen = infTbl.getValue("FDOC");
		 	if (sDomen == null)
		 		continue;
		 	sDomen = allt(sDomen);
		 	if (sDomen == "")
		 		continue;
		 	var sName = infTbl.getValue("FNOP");
		 	sName = parseInt(Number(sName));
		 	if (isNaN(sName) || sName == 0)
		 		sName = null;
		 	setProgressPosEx(infTbl.getAbsolute() + 1,"Идёт перекодировка расширений "
							+ Vid + " " + sDomen + " " + sName + "...");
		 	var extBuilder = new DpExtentionBuilder(Vid,sDomen,sName);
		 	extBuilder.buildStubs();
		 	var inSQL = "UPDATE ^cl_ext"
		 		 	  + " SET FCLASS=" + sqlTo("H." + String(sDomen))
		 		 	  + ",FSUBCLASS=" + sqlTo((sName!=null?String(sName):' '))
		 			  + " WHERE FWID IN"
		 			  	+ "("
		 			  	+ " SELECT FWID FROM ^cl_ext_l"
		 			  	+ " WHERE FVID=" + sqlTo("H")
		 			  	+ " AND FDOC=" + sqlTo(String(sDomen))
		 			  	+ " AND FNOP=" + sqlTo((sName!=null?Number(sName):0))
		 			  	+ ")";
		 	ExecuteSQL(inSQL,false);
		 	extBuilder.commitStructure();
		 	
			var InfoSQL = "SELECT * FROM " + extBuilder.getInfoTableName()
						+ " WHERE " + extBuilder.tblInfoWhere;
			var sWhere = "L.FVID='H'"
					+ " AND FDOC=" + sqlTo(sDomen)
					+ " AND FNOP=" + sqlTo(sName!=null?Number(sName):0);
			this.fillValues("^ext",extBuilder.getValueTableName()
				,InfoSQL,sWhere);
		 	continue;
		 }
		 if (Vid == "R")
		 {
		 	var sDomen = infTbl.getValue("FDOC");
		 	if (sDomen == null)
		 		continue;
		 	sDomen = allt(sDomen);
		 	if (sDomen == "")
		 		continue;
		 	var sName = infTbl.getValue("FNOP");
		 	if (sName != null) 
			 	sName = parseInt(Number(sName));
		 	if (isNaN(sName) || sName == 0)
		 		sName = null;
		 	var oDoc = new DpDoc(sDomen,0);
		 	var chIDS = oDoc.getChildClasses();
		 	var chID = null;
		 	for (var nID = 0; nID < chIDS.length; nID++)
		 	{
				var currID = chIDS[nID];
				if (!currID)
					continue;
				currID = String(currID).toUpperCase();
				if (currID.startsWith("R"))
				{
					chID = currID;
					break;
				}
		 	}
		 	if (chID == null)
		 		continue;
		 	sDomen = sDomen + "." + chID;
		 	setProgressPosEx(infTbl.getAbsolute() + 1,"Идёт перекодировка расширений "
							+ Vid + " " + sDomen + " " + sName + "...");
		 	var extBuilder = new DpExtentionBuilder("R",sDomen,sName);
		 	extBuilder.buildStubs();
		 	var inSQL = "UPDATE ^cl_ext"
		 			  + " SET FCLASS=" + sqlTo("R." + String(sDomen))
		 			  + ",FSUBCLASS=" + sqlTo((sName!=null?String(sName):' '))
		 			  + " WHERE FWID IN"
		 			  	+ " (SELECT FWID"
		 			  	+ " FROM ^cl_ext_l"
		 			  	+ " WHERE FVID=" + sqlTo("R")
		 			  	+ " AND FDOC=" + sqlTo(String(infTbl.getValue("FDOC")))
		 			  	+ " AND FNOP=" + sqlTo((sName!=null?Number(sName):0))
		 			  	+ ")";
		 	ExecuteSQL(inSQL,false);
		 	extBuilder.commitStructure();
		 	
		 	var InfoSQL = "SELECT * FROM " + extBuilder.getInfoTableName()
						+ " WHERE " + extBuilder.tblInfoWhere;
			var sWhere = "L.FVID='R'"
					+ " AND FDOC=" + sqlTo(String(infTbl.getValue("FDOC")))
					+ " AND FNOP=" + sqlTo((sName!=null?Number(sName):0));
			this.fillValues("^ext",extBuilder.getValueTableName()
				,InfoSQL,sWhere);
		 	
		 	continue;
		 }
	}
	setProgressPosEx(0);
	infTbl.close();	
}