include("objects/DpJournal.js");

DpJRegistrator.prototype.getRegTbl = DpJRegistrator_getRegTbl;
DpJRegistrator.prototype.createRegStub = DpJRegistrator_createRegStub;
DpJRegistrator.prototype.isVarInStruct = DpJRegistrator_isVarInStruct;
DpJRegistrator.prototype.saveReg = DpJRegistrator_saveReg;
DpJRegistrator.prototype.getRegPath = DpJRegistrator_getRegPath;
DpJRegistrator.prototype.listJournals = DpJRegistrator_listJournals;
DpJRegistrator.prototype.listRegJournals = DpJRegistrator_listRegJournals;
DpJRegistrator.prototype.regTo = DpJRegistrator_regTo;
DpJRegistrator.prototype.getVarEl = DpJRegistrator_getVarEl;
DpJRegistrator.prototype.setVar = DpJRegistrator_setVar;
DpJRegistrator.prototype.getVar = DpJRegistrator_getVar;
DpJRegistrator.prototype.getVarList = DpJRegistrator_getVarList;
DpJRegistrator.prototype.unReg = DpJRegistrator_unReg;
DpJRegistrator.prototype.getRegExpr = DpJRegistrator_getRegExpr;
DpJRegistrator.prototype.getDoRegRows = DpJRegistrator_getDoRegRows;
DpJRegistrator.prototype.doRegistration = DpJRegistrator_doRegistration;
DpJRegistrator.prototype.delRegistration = DpJRegistrator_delRegistration;
DpJRegistrator.prototype.getVarListForReg = DpJRegistrator_getVarListForReg;
DpJRegistrator.prototype.listJFiles = DpJRegistrator_listJFiles;
DpJRegistrator.prototype.setRegVar = DpJRegistrator_setRegVar;
DpJRegistrator.prototype.getValue = DpJRegistrator_getValue;
DpJRegistrator.prototype.setValue = DpJRegistrator_setValue;
DpJRegistrator.prototype.fillFields = DpJRegistrator_fillFields;
DpJRegistrator.prototype.isAddRec = DpJRegistrator_isAddRec;

var varListMap = new Array();

//-DpJRegistrator.prototype.JMAX = DpJRegistrator_JMAX;

//------------------- касательно мапинга ДОК<->журнал

function DpJRegistrator(sDoc,nNop,sType)
{
	if (sDoc)
		sDoc = String(sDoc).toUpperCase();
	this.doc = sDoc;
	this.nop = toScrObj(nNop);
/*	
	this.sType = "U";
	if (sType && (sType == "s" || sType == "S"))
		this.sType = "S";
*/
	this.sType = String(sType).toUpperCase();
	this.regDocs = new Array();
	
	this.allJournals = null;
	this.regJournals = null;
	this.varMap = new Array();
}

function DpJRegistrator_setRegVar(jID,sVar,sValue,begDat,endDat)
{
	jID = String(jID).toUpperCase();
	sVar = String(sVar).toUpperCase();
	if (!this.listRegJournals(true)[jID])
	{
		trace("no in reg " + this.doc + " - " + this.nop + " - " + jID);
		return false;
	}
	var varEl = this.getVarEl(jID,sVar);
	if (varEl.periods == null)
	{
		if (!this.setVar(jID,sVar,varEl.txt))
		{
			trace("no var " + this.doc + " - " + this.nop + " - " + jID + " - " + sVar);
			return false;
		}
		varEl = this.getVarEl(jID,sVar);
		if (varEl.periods == null)
		{
			trace("bad set Var " + this.doc + " - " + this.nop + " - " + jID);
			return false;
		}
	}
	varEl.periods.AddNew();
	varEl.periods.setValue("start",begDat);
	varEl.periods.setValue("end",endDat);
	varEl.periods.setValue("text",sValue);
	varEl.periods.Update();
	return true;
}

function DpJRegistrator_listJFiles(oFile)
{
	var ret = new Array();
	if (oFile == null || !oFile.isDirectory())
		return ret;
		
	var files = oFile.listFiles();
	if (files == null)
		return ret;
	for (var i = 0; i < files.length; i++)
	{
		if (!files[i].isDirectory() || files[i].isHidden())
			continue;
		
		if (!isFile(files[i].getAbsolutePath() + "/struct.xml"))
			continue;
		var jFileName = files[i].getName();
		var jType = String(jFileName.substr(0,1)).toUpperCase();
		var jNum = String(jFileName.substr(2)).toUpperCase();
		
		var oJournal = new DpJournal(jType,jNum);
		ret[jNum] = oJournal;
	}
	return ret;
}

function DpJRegistrator_listJournals(bRefresh)
{
	if (!bRefresh && this.allJournals != null)
		return this.allJournals;
	var ret = new Array();
	var fileU = null;
	var fileS = null;
	var arrRetU  = new Array();
	if (strIn("U",this.sType))
	{
		fileU = new DpFile(rootDirectory() + "journals/");
		arrRetU[0] = this.listJFiles(fileU);
				
		var arrModules = lpProxy.getModules();
		for (var i = 0; i < arrModules.length; i++)
		{
		 	fileU = new DpFile(lpProxy.getModulePath(arrModules[i]) + "/scripts/journals");	
		 	arrRetU[arrRetU.length] = this.listJFiles(fileU);	
			
		}	
		
		fileU = new DpFile(getOrgPath() + "settings/journals/user_journals/");
		arrRetU[arrRetU.length] = this.listJFiles(fileU);
	}
	if (strIn("S",this.sType))
		fileS = new DpFile(getOrgPath() + "settings/journals/sys_journals/");
	
	var retS = this.listJFiles(fileS);
	
	for (var i = 0; i < arrRetU.length; i++)
	{
		var retU = arrRetU[i];
		for (var jID in retU)
			ret[jID] = retU[jID];
	}
	
		
	for (var jID in retS)
		ret[jID] = retS[jID];
	
	this.allJournals = ret;
	
	return ret;
}

function DpJRegistrator_listRegJournals(bRefresh)
{
	if (!bRefresh && this.regJournals != null)
		return this.regJournals;
	
	var ret = new Array();
	var file = new DpFile(this.getRegPath());	
	var files = file.listFiles();
	if (files == null)
		return ret;
	
	for (var i = 0; i < files.length; i++)
	{
		if (!files[i].isDirectory() || files[i].isHidden())
		{
			continue;
		}
		
		var jFileName = files[i].getName();
		var jType = String(jFileName.substr(0,1)).toUpperCase();
		var jNum = null;
		if (jType == "S")
			jNum = String(jFileName.substr(2)).toUpperCase();
		else
			jNum = String(jFileName.substr(1)).toUpperCase();
/*		if (strInjType != this.sType)
			continue;
*/
		ret[jNum] = true;
	}
	this.regJournals = ret;
	return ret;
}

function DpJRegistrator_getRegPath()
{
	var sPath = "";
/*	
	if (this.sType == "S")
		sPath = getOrgPath() 
				+ "\\data\\sys_journals\\register\\";
	else
*/
	
	sPath = "settings/journals/register/";
	sPath = sPath + String(this.doc).toUpperCase() + "/" + this.nop + "/";
	sPath = sPath.replace(":", "_");
	
	sPath = getOrgPath() + sPath;
	
	if (!isFile(sPath))
		createDirectory(sPath);
	
	return sPath;
}

function DpJRegistrator_getRegTbl(jID)
{	
	var oTbl = null;
	jID = String(jID).toUpperCase();
	if(typeof(this.regDocs[jID]) == "undefined")
	{
		if (!this.listRegJournals()[jID])
			return null;
		var oJ = this.listJournals()[jID];
		var sFile = String(oJ.getType() + jID).toUpperCase();
		if (!isFile(this.getRegPath() + sFile + "/register.xml"))
		{
			oDoc = this.createRegStub();
			var sPath = this.getRegPath() + sFile;
			createDirectory(sPath);
			//saveXml(this.getRegPath() + sFile + "/register.xml",oDoc);
			oTbl = OpenTable("xml","NOFILE","var");
			oTbl.requery(oDoc);
			oTbl.setDoSave(false);
		}
		else
		{
			oTbl = OpenTable("xml",this.getRegPath() + sFile + "/register.xml","var");
			oTbl.setDoSave(false);
		}
	}
	else
	{
		oTbl = this.regDocs[jID];
	}
	this.regDocs[jID] = oTbl;
	return oTbl;
}

function DpJRegistrator_createRegStub()
{
	var oDoc = createXmlDoc();
	
	var rootEl = oDoc.createElement("DpJRegister");
	rootEl.setAttribute("doc",this.doc);
	rootEl.setAttribute("nop",this.nop);
	oDoc.appendChild(rootEl);
	return oDoc;
}

function DpJRegistrator_regTo(jID,sExpr,bRegRows)
{
	bRegRows = (typeof(bRegRows=="boolean")?bRegRows:false);
	jID = String(jID).toUpperCase();
	var allJ = this.listJournals();
	if (!allJ[jID])
		return false;
	var oJrnl = allJ[jID];
	var regJ = this.listRegJournals();
	var oTbl = null;
	if (!regJ[jID])
	{
		if (this.regJournals == null)
			this.regJournals = new Array();
		this.regJournals[jID] = true;
	}
	oTbl = this.getRegTbl(jID);
	oTbl.getDocument().getDocumentElement().setAttribute("expr",sExpr);
	oTbl.getDocument().getDocumentElement().setAttribute("regRows",String(bRegRows));
	var sDir = String(oJrnl.getType() + jID).toUpperCase();
	saveXml(this.getRegPath() + sDir + "/register.xml",oTbl.getDocument());
	this.regDocs[jID] = oTbl;
	this.listRegJournals(true);
	return true;
}

function DpJRegistrator_getRegExpr(jID)
{
	jID = String(jID).toUpperCase();
	var regJ = this.listRegJournals();
	if (!regJ[jID])
		return null;
	return this.getRegTbl(jID).getDocument().getDocumentElement().getAttribute("expr");
}

function DpJRegistrator_getDoRegRows(jID)
{
	jID = String(jID).toUpperCase();
	var regJ = this.listRegJournals();
	if (!regJ[jID])
		return null;
	var val = allt(this.getRegTbl(jID).getDocument()
					.getDocumentElement().getAttribute("regRows"));
	return val == "true";
}

function DpJRegistrator_isVarInStruct(jID,sVar)
{
	jID = String(jID).toUpperCase();
	var regJ = this.listRegJournals();
	if (!regJ[jID])
		return false;
	var allJ = this.listJournals();
	if (!allJ[jID])
		return false;
	var oJ = allJ[jID];
	
	if (allJ[jID].getImplFieldElement(sVar) != null)
		return true;
	return false;
}



function DpJRegistrator_getVarEl(jID,sVar)
{
	jID = String(jID).toUpperCase();
	sVar = String(sVar).toUpperCase();	
	
	if (!this.listRegJournals()[jID])
		return null;
	var oTbl = this.getRegTbl(jID);
	var fImpl = this.listJournals()[jID].getFieldImpl(sVar);
	var retEl = new Object();
	if (fImpl == null)
	{
//-		trace(sVar + " -- " + jID + " - " + this.isVarInStruct(jID,sVar));
		return false;
	}
	retEl.name = fImpl.FVAR;
	retEl.txt = fImpl.FREM;
	retEl.attr = fImpl.FATTR;
	retEl.def = fImpl.FDEF;
	
	for (oTbl.MoveFirst();!oTbl.isEOF();oTbl.MoveNext())
	{
		if (String(oTbl.getValue("name")) == sVar)
		{
			retEl.name = oTbl.getValue("name");
			retEl.txt = oTbl.getValue("txt");
			retEl.periods = OpenTable("xml","NOFILE","var[@name='" + retEl.name + "']/period");
			retEl.periods.setDoSave(false);
			retEl.periods.requery(oTbl.getDocument());
			break;
			//return retEl;
		}
	}
	return retEl;
}

function DpJRegistrator_setVar(jID,sVar,sText)
{
	jID = String(jID).toUpperCase();
	sVar = String(sVar).toUpperCase();
	if (!this.listRegJournals()[jID])
		return false;
	if (!this.isVarInStruct(jID,sVar))
		return false;
	var curEl = this.getVarEl(jID,sVar);
	if (curEl.periods == null)
	{
		var oTbl = this.getRegTbl(jID);
		oTbl.AddNew();
		oTbl.setValue("name",sVar);
		if (sText)
			oTbl.setValue("txt",sText);
		oTbl.Update();
		return true;
	}
	else
	{
		if (!sText)
			return false;
		var oTbl = this.getRegTbl(jID);
		for (oTbl.MoveFirst();!oTbl.isEOF();oTbl.MoveNext())
		{
			if (oTbl.getValue("name") == sVar)
			{
				oTbl.Edit();
				oTbl.setValue("txt",sText);
				oTbl.Update();
				return true;
			}
		}
		return false;
	}
}
//------------------------------------
/*
function DpJRegistrator_setVar(jID,sVar,sValue,sText,oBDate,oEDate)
{
	jID = String(jID).toUpperCase();
	sVar = String(sVar).toUpperCase();
	if (!this.listRegJournals()[jID])
		return false;
	var curEl = this.getVarEl(jID,sVar);
	if (curEl == null)
	{
		var oJDoc = this.getRegDoc(jID);
		var oRoot = oJDoc.getDocumentElement();
		curEl = oJDoc.createElement("var");
		curEl.setAttribute("name",sVar);
		oRoot.appendChild(curEl);
	}
	if (sText != null)
		curEl.setAttribute("txt",sText);
	if (sValue != null)
		curEl.setTextContent(sValue);
	return true;
}
*/
//--------------------------------------

function DpJRegistrator_getVar(jID,sVar)
{
	jID = String(jID).toUpperCase();
	sVar = String(sVar).toUpperCase();
	if(!this.isVarInStruct(jID,sVar))
		return null;
	var curEl = this.getVarEl(jID,sVar);
	if (curEl == null)
	{
		this.setVar(jID,sVar,"","");
		curEl = this.getVarEl(jID,sVar);
	}
	return curEl;
}

//--------------------------------------
function DpJRegistrator_getVarList(jID,showHidden)
{
	jID = String(jID).toUpperCase();
	var sKey = this.doc + "_" + this.nop + "_" + jID + "_" + showHidden;
	if (varListMap[sKey])
		return varListMap[sKey];
	var regJ = this.listRegJournals();
	if (!regJ[jID])
	{
		return null;
	}
	var var_list = new Array();	
	var fImpl = this.listJournals()[jID].getFieldsImpl();
	for (var i = 0; i < fImpl.length; i++)
	{
		if (!showHidden && strIn("h",fImpl[i].FATTR))
			continue;
		var curVar = this.getVarEl(jID,fImpl[i].FVAR);
		var addVar = new Object();
		addVar.name = fImpl[i].FVAR;
		addVar.text = fImpl[i].FREM;
		addVar.def = fImpl[i].FDEF;
		addVar.attr = fImpl[i].FATTR;
		addVar.periods = null;
		addVar.type = fImpl[i].FTYPE;
		if (curVar != null)
		{
			if (allt(curVar.txt) != "")
				addVar.text = curVar.txt;
			addVar.periods = curVar.periods;
		}
		var_list[var_list.length] = addVar;
	}
	
	varListMap[sKey] = var_list;
	return var_list;
}

function DpJRegistrator_unReg(jID)
{
	jID = String(jID).toUpperCase();
	if (!this.listRegJournals()[jID])
		return true;
	var oJ = this.listJournals()[jID];
	deleteDir(this.getRegPath() + oJ.getType() + jID);
	if (typeof(this.regDocs[jID]) != "undefined")
		this.regDocs[jID] = null;
	return true;
}

function DpJRegistrator_saveReg(jID)
{
	if (!jID)
	{
		for (var jID in this.regDocs)
		{
			var oTbl = this.regDocs[jID];
			if (oTbl == null)
				continue;
			var oJ = this.listJournals()[jID];
			var sDir = String(oJ.getType() + jID).toUpperCase(); 
			createDirectory(this.getRegPath() + sDir);
			saveXml(this.getRegPath() + sDir + "/register.xml",oTbl.getDocument());
		}
	}
	else
	{
		var oTbl = this.regDocs[jID];
		if (oTbl == null)
			return;
		var oJ = this.listRegJournals()[jID];
		var sDir = String(oJ.getType() + jID).toUpperCase();
		createDirectory(this.getRegPath() + sDir);
		saveXml(this.getRegPath() + sDir + "/register.xml",oTbl.getDocument());
	}
}

function DpJRegistrator_getVarListForReg(jID,date)
{
	var arrVars = this.getVarList(jID,true);
	var retArr = new Array();
	for (var nVar = 0; nVar < arrVars.length; nVar++)
	{
		var vObj = new Object();
		vObj.name = arrVars[nVar].name;
		var pTbl = arrVars[nVar].periods;
		var value = null;
		if (pTbl != null)
		{
			for (pTbl.MoveFirst();!pTbl.isEOF();pTbl.MoveNext())
			{
				var start = pTbl.getValue("start");
				var end = pTbl.getValue("end");
				if (start == "")
					start = "01.01.1900";
				if (end == "")
					end = "01.01.3000";
				start = lpProxy.parseDate(start);
				end = lpProxy.parseDate(end);
				if (start != null)
					start = javaDate2Script(start);
				if (end != null)
					end = javaDate2Script(end);
					
				if (differ(start,end) == 0 || differ(start,end) == 1)
					break;
				if (differ(start,date) == -1 && differ(end,date) == 1)
					value = pTbl.getValue("text");
			}
		}
		if (value == null)
		{
			if (allt(arrVars[nVar].def) != "")
				value = allt(arrVars[nVar].def);
		}
		
		if (value == null)
			continue;
		vObj.value = value;
		retArr[retArr.length] = vObj;
	}
	return retArr;
}

function JMAX(sVar,jID)
{
	var oJ = REGISTRATOR.listJournals()[jID];

	if (!oJ)
		return 0;
	
	var oSnap = getSnap("SELECT max(" + sVar + ") FROM " + oJ.getFullTableName());
	if (oSnap != null)
		return oSnap[0];
	return 0;
}

function JDEAL(jID, m)
{
	//m.HIDDEAL = JDEAL(ID, m.HORG, m.HDAT, m.HID_DOC, m.HGROUP);


   var oJ = REGISTRATOR.listJournals()[jID];

	if (!oJ)
		return 0;

	var autolnk = oJ.getAttr("autolnk");
	//var pr_docreg = getPar("PR_DOGREG");
	
	var jVid = strIn("P",oJ.getType())?"+":"-";
	
	
	var andDog = "";
	
	if(autolnk=="-")
	{
		// Не связывать вообще
		return null;
		return 0; //GetUID();
	}
	else if (autolnk == "group")
	{
		andDog = " AND hgroup=" + sqlTo(m.HGROUP);
	}
	else if (autolnk=="dog")
	{
		if (m.HIDCONTR)
			andDog = " AND HIDCONTR=" + sqlTo(m.HIDCONTR);
		else
			andDog = " AND hidcontr=0 AND hgroup=" + sqlTo(String(m.HGROUP));
	}
	else if (autolnk=="org")
	{
		// без связки по договорам (связываем только по организации)
	}

	var tbl = OpenTable(s=
		"SELECT hiddeal"
		+ " FROM " + oJ.getFullTableName()
		+ " WHERE horg=" + sqlTo(m.HORG)
			+ " AND hreg=" + sqlTo(jID)
			+ andDog
			/* не нужно условие - так как не связываются документы, введенные не в хронологическом порядке
			+ " AND ( hdat<" + sqlTo(m.HDAT)
				+ " OR (hdat=" + sqlTo(m.HDAT) + " AND HID_DOC<" + sqlTo(m.HID_DOC) + ")"
				+ ")"
			*/
		+ " ORDER BY hdat DESC, hiddeal DESC"
		);
	
	if (!tbl.IsEOF())
	{
		var ret = tbl.getValue("hiddeal");
		tbl.close();
		return ret;
	}
	tbl.close();	
	
	if(getSystem()=="BIL2")
		return 0;			//В ЧЕРЕДЕ hiddeal=0. Накладные группируются по HGROUP
	return GetUID();		//ЧЕРЕДА и так в шоке, а с этой фигнёй вообще!	
}

function DpJRegistrator_doRegistration(oDoc,jID)
{
	REGISTRATOR = this;
	jID = allt(String(jID).toUpperCase());
	var bRegAll = (jID == "*");
	var regArr = null;
	if (bRegAll)
		regArr = this.listRegJournals(true);
	else
	{
		regArr = new Array();
		regArr[jID] = true;
	}
	var arrJ = this.listJournals(true);
	for (var ID in regArr)
	{
		if (!arrJ[ID])
			continue;
			
		var sRegExpr = String(this.getRegExpr(ID));
		if (sRegExpr == null)
			continue;
			
//---------- заменим JID на значение ИД-журнала
		sRegExpr = String(new java.lang.String(sRegExpr).replaceAll("JID",ID));
		var regRows = this.getDoRegRows(ID);

//--------------- регистрация в журнале ID
		var vList = this.getVarListForReg(ID,oDoc.getVar("HDAT"));		//- получили переменные журнала
		var tblName = arrJ[ID].getFullTableName();
/*
		if (!IsTable(tblName))
			arrJ[ID].commitStructure();
*/
		var sWhere = "HID_DOC=" + sqlTo(oDoc.getID()); //'+ " AND HORG=" + sqlTo(oDoc.getVar("HORG"));
		if (!regRows && !oDoc.tEval("b",sRegExpr,true))
		{
			if (!strIn("S",arrJ[ID].getType()))
			{
				ExecuteSQL("DELETE FROM " + arrJ[ID].getFullTableName()
					 + " WHERE " + sWhere);
			}
			continue;
			
		}
		var sFLD = "FWID"; 
		if (strIn("S",arrJ[ID].getType()))
		{
			sFLD = "FWID, HIDDEAL, HSORT, HORG";
						
			sWhere = sWhere 
					+ " AND (HREG=" + sqlTo(String(ID).toLowerCase())
					+ " OR HREG=" + sqlTo(String(ID).toUpperCase()) + ")"		 
		}
		var sSQL = "SELECT " + sFLD + " FROM " + tblName
						+ " WHERE " + sWhere;
		var oSnap = getSnap(sSQL);
		var m = new Object();
		if (oSnap != null)
			m.FWID = oSnap[0];
		else
			m.FWID = GetUID();
		m.HID_DOC = oDoc.getID();
		
		if (!regRows)
		{
			this.fillFields(vList,m,oDoc,ID);
			if (oSnap != null)
				sWhere = " FWID=" + sqlTo(m.FWID);
			if (strIn("S",arrJ[ID].getType()))			
			{
				//m.HIDDEAL = JDEAL(ID, m.HORG, m.HDAT, m.HID_DOC, m.HGROUP);
            	if (oSnap == null || !oSnap[1] || oDoc.getVar("HORG")!=oSnap[3])
            		m.HIDDEAL = JDEAL(ID, m);
            	else
            		m.HIDDEAL = oSnap[1];

			    if (SUBD==ORACLE && !toScrObj(m.HNKNOM))
					m.HNKNOM = " ";
					            	
            	if (oSnap == null || !oSnap[2])
            		m.HSORT = Number(JMAX("HSORT", ID)) + 1;
            	else
            		m.HSORT = oSnap[2];

			}
		
			if (this.isAddRec(arrJ[ID], m))
			{		
				UpdateTable(tblName, m, oSnap == null,sWhere);
			}
			else
			{
				ExecuteSQL("DELETE FROM " + tblName  + " where " + sWhere);
			}	
		}
		else		//- регистрация строк
		{
			var tmpTbl = getTmpTableName();
			arrJ[ID].commitStructure(true, "temp", tmpTbl, false);
			if (!oDoc.gotoFirstRow())
				continue;
			var bNext = true;
			while(bNext)
			{			
				var currRow = oDoc.getCurrRow();
				bNext = oDoc.gotoNextRow();

				if(!currRow || !currRow.tEval("b",sRegExpr))
					continue;
				
				var updObj = new Object();
				updObj.FWID = GetUID();
				this.fillFields(vList, updObj, currRow, ID);
				updObj.HID_DOC = m.HID_DOC;
				
				if (this.isAddRec(arrJ[ID], updObj))
					UpdateTable(tmpTbl,updObj,true);			
			}
			
			
//---------		вот тут - таблица уже собрана - можно сделать группировку

			ExecuteSQL("DELETE FROM " + arrJ[ID].getFullTableName()
					 + " WHERE HID_DOC=" + sqlTo(m.HID_DOC)
					 + (strIn("S",arrJ[ID].getType())? " AND HREG=" + sqlTo(ID):""));
			var sFields = "FWID";
			for (var nVar = 0; nVar < vList.length; nVar++)
			{
				var vName = allt(String(vList[nVar].name).toUpperCase());
				if (vName == "")
					continue;
				sFields += "," + vName;
			}
			
			var sSQL = "INSERT INTO " + arrJ[ID].getFullTableName()
				     + "(" + sFields + ")"
				     + " SELECT " + sFields
				     + " FROM " + tmpTbl + " t ";
			ExecuteSQL(sSQL);
			DropTable(tmpTbl);
		}
//---------------		
	}
}

function DpJRegistrator_isAddRec(oJ, m)
{
	var sCond = String(oJ.getCondition()).trim();
	
	if (sCond)
	{
		include ("objects/DpEval.js")
		var oEval = new DpEval();
		for (var i in m)
			oEval.addVar(i, m[i]);
		var ret = oEval.tEval("b",sCond,true);		
		//salert(sCond + " = " + ret);
		return ret;
	}
	
	return true;
}

function DpJRegistrator_fillFields(varList,obj,oDoc,JID)
{
	for (var nVar = 0; nVar < varList.length; nVar++)
	{
		var vName = allt(String(varList[nVar].name).toUpperCase());
		if (vName == "")
			continue;
		var vVal = varList[nVar].value;
		vVal = String(new java.lang.String(vVal).replaceAll("JID",JID));
		var oVal = null;
		try
		{
			oVal = oDoc.eval(vVal);
		}
		catch(ex){};
		obj[vName] = oVal;
	}
}

function DpJRegistrator_delRegistration(oDoc,jID)
{
	jID = allt(String(jID).toUpperCase());
	var bRegAll = (jID == "*");
	
	var regArr = null;
	if (bRegAll || jID == "U*")
	{
		var where  =  " WHERE HID_DOC=" + sqlTo(oDoc.getVar("ID"));
		
		if (bRegAll)
		{
			ExecuteSQL("DELETE FROM ^MDOCREG " + where);
			ExecuteSQL("DELETE FROM ^PDOCREG " + where);
		}
		
		var journals = getJavaClass("org.debet.DebetApp.business.DpJournalList")
			.getMethod("getDefault", null).invoke(null, null).getUserJournal();
        for (var i = 0; i < journals.length; i++)
        {
           var tableName = String(journals[i].getTableName());
           if (!tableName.startsWith("^")) //$NON-NLS-1$
        	   tableName = "^" + tableName;
           ExecuteSQL("DELETE FROM " + tableName +  where, false);
        }
		return true;
	}
	else
	{
		regArr = new Array();
		regArr[jID] = true;
	}
	var arrJ = this.listJournals(true);
	
	for (var ID in regArr)
	{
		if (!arrJ[ID])
			continue;
		
		var tblName = arrJ[ID].getFullTableName();
		var sWhere = "HID_DOC=" + sqlTo(oDoc.getVar("ID"));
		if (strIn("S",arrJ[ID].getType()))
		{
			sWhere = sWhere + " AND HREG=" + sqlTo(ID);
		}
		ExecuteSQL("DELETE FROM " + tblName + " WHERE "+ sWhere);
	}
}

function DpJRegistrator_getValue(jID,varID)
{
	jID = String(jID).toUpperCase();
	varID = String(varID).toUpperCase();
	var isOk = this.isVarInStruct(jID,varID);
	if (!isOk)
	{
		isOk = this.isVarInStruct(jID,"F" + varID);
		if (isOk) varID = "F" + varID;
	}
	if (!isOk)
	{
		isOk = this.isVarInStruct(jID,"H" + varID);
		if (isOk) varID = "H" + varID;
	}
	if (!isOk)
		return null;
	var sSQL = "SELECT " + varID
			 + " FROM " + this.listJournals()[jID].getFullTableName()
			 + " WHERE HDOC=" + sqlTo(this.doc)
			 + " AND HNOP=" + sqlTo(this.nop)
			 + " AND HREG=" + sqlTo(jID);
	var oSnap = getSnap(sSQL);
	if (oSnap == null)
		return null;
	return oSnap[0];
}

function DpJRegistrator_setValue(jID,varID,value)
{
	jID = String(jID).toUpperCase();
	varID = String(varID).toUpperCase();
	var isOk = this.isVarInStruct(jID,varID);
	if (!isOk)
	{
		isOk = this.isVarInStruct(jID,"F" + varID);
		if (isOk) varID = "F" + varID;
	}
	if (!isOk)
	{
		isOk = this.isVarInStruct(jID,"H" + varID);
		if (isOk) varID = "H" + varID;
	}
	if (!isOk)
		return null;
	sSQL = "UPDATE " + this.listJournals()[jID].getFullTableName()
		 + " SET " + varID + "=" + sqlTo(value)
		 + " WHERE HDOC=" + sqlTo(this.doc)
		 + " AND HNOP=" + sqlTo(this.nop)
		 + " AND HREG=" + sqlTo(jID);
	return ExecuteSQL(sSQL);
}

function DpJRegistrator_doReReg(sDocLbl)
{
	var path = getOrgPath() + "data/docs/" + sDocLbl + "/";
	var oFile = new DpFile(path);
	if (!oFile.isDirectory())
		return;
	var arrFiles = oFile.listFiles();
	setProgressRange(1,arrFiles.length);
	setProgressPos(1,"Перерегистрация...");
	for (var i = 0; i < arrFiles.length; i++)
	{
		var currF = arrFiles[i];
		var nID = String(currF.getName()).substring(0,currF.getName().length - 4);
		nID = parseInt(nID);
		if (isNaN(nID))
			continue;
		setProgressPos(i,"Перерегистрация " + nID + " ...");
		var oDoc = new DpDoc(sDocLbl,0);
		if (!oDoc.jDoc.loadFromXML(nID))
			continue;
		oDoc.nNop = parseInt(String(oDoc.getVar("HOP")));
		oDoc.doRegistration();
	}
	setProgressPos(0,"");
}