DpJournal.prototype.getJDoc = DpJournal_getJDoc;
DpJournal.prototype.createJStub = DpJournal_createJStub;
DpJournal.prototype.addFieldImpl = DpJournal_addFieldImpl;
DpJournal.prototype.removeFieldImpl = DpJournal_removeFieldImpl;
DpJournal.prototype.getImplFieldElement = DpJournal_getImplFieldElement;
DpJournal.prototype.fillImplTbl = DpJournal_fillImplTbl;
DpJournal.prototype.getFieldsImpl = DpJournal_getFieldsImpl;
DpJournal.prototype.editImpl = DpJournal_editImpl;
DpJournal.prototype.setName = DpJournal_setName;
DpJournal.prototype.getName = DpJournal_getName;
DpJournal.prototype.getModule = DpJournal_getModule;
DpJournal.prototype.save = DpJournal_save;
DpJournal.prototype.setRem = DpJournal_setRem;
DpJournal.prototype.getRem = DpJournal_getRem;
DpJournal.prototype.setCondition = DpJournal_setCondition;
DpJournal.prototype.getCondition = DpJournal_getCondition;
DpJournal.prototype.setTable = DpJournal_setTable;
DpJournal.prototype.getTable = DpJournal_getTable;
DpJournal.prototype.getAttr = DpJournal_getAttr;
DpJournal.prototype.setAttr = DpJournal_setAttr;
DpJournal.prototype.commitStructure = DpJournal_commitStructure;
DpJournal.prototype.rollbackStructure = DpJournal_rollbackStructure;
DpJournal.prototype.getPath = DpJournal_getPath;
DpJournal.prototype.getUJPath = DpJournal_getUJPath;
DpJournal.prototype.remove = DpJournal_remove;
DpJournal.prototype.getTableName = DpJournal_getTableName;
DpJournal.prototype.getFullTableName = DpJournal_getFullTableName;
DpJournal.prototype.getStructDoc = DpJournal_getStructDoc;
DpJournal.prototype.getFieldImpl = DpJournal_getFieldImpl;
DpJournal.prototype.getType = DpJournal_getType;
DpJournal.prototype.getGridDescrFile = DpJournal_getGridDescrFile;

function DpJournal(sUS,nNum)
{
	if (strIn("S",sUS))
		this.sType = sUS;
	else
		this.sType = "U";

	this.Num = String(nNum).toUpperCase();
	this.moduleID = null;
	this.sFile = "struct.xml";
	this.oImplDoc = this.getJDoc();
	this.oImplRoot = this.oImplDoc.getDocumentElement();
	this.oImplFields = this.oImplRoot.getElementsByTagName("fields").item(0);
	if (strIn("S",this.sType))
	{
		this.sType += this.oImplRoot.getAttribute("type");
		this.oImplFields = this.getStructDoc().getDocumentElement()
							.getElementsByTagName("fields").item(0);
	}
	
	this.editImplFile = "l_cl_ujrows.xml";
	
	this.regDocs = new Object();
}

function DpJournal_getStructDoc()
{
	if (this.sType == "U")
		return this.getJDoc();
	if (strIn("P",this.sType))
		return openXmlFile(rootDirectoryEx() + "Source/Pjournal.xml");
	else
		return openXmlFile(rootDirectoryEx() + "Source/Mjournal.xml");
}

function DpJournal_getPath()
{
	this.Num = String(this.Num).toUpperCase();
	if (strIn("S",this.sType))
		return getOrgPath() + "settings/journals/sys_journals/SJ" + this.Num + "/";
	else
		return  this.getUJPath(); //getOrgPath() + "settings/journals/user_journals/UJ" + this.Num + "/";
}

function DpJournal_getUJPath()
{
	var sPath = getOrgPath() + "settings/journals/user_journals/UJ" + this.Num;
	
	if (!isFile(sPath))
	{
		var arrModules = lpProxy.getModules();
		for (var i = 0; i < arrModules.length; i++)
		{
			var mPath = lpProxy.getModulePath(arrModules[i]) + "/scripts/journals/UJ" + this.Num;		
			if (isFile(mPath))
			{
				this.moduleID = arrModules[i];
				return mPath + "/";
			}
		}
	}	
	
	if (!isFile(sPath))
	{
		gPath = rootDirectory() + "journals/UJ" + this.Num;
		if (isFile(gPath))
		{
			return gPath + "/";
		}
	}
	
	return sPath + "/";
}

function DpJournal_getModule()
{
	return this.moduleID;
}

function DpJournal_getGridDescrFile()
{
	var gridFile = this.getPath() + "grid.xml";
	if (isFile(gridFile))
		return gridFile;
	return null;
}

function DpJournal_getJDoc()
{
	if (!isFile(this.getPath() + this.sFile))
	{
		return this.createJStub();
	}
	
	return openXmlFile(this.getPath() + this.sFile);
}

function DpJournal_save()
{
	if (!isFile(this.getPath() + this.sFile))
	{
		createDirectory(this.getPath());
	}
	saveXml(this.getPath() + this.sFile,this.oImplDoc);
}

function DpJournal_createJStub()
{
	var oDoc = null;
	if (this.sType == "U")
		oDoc = openXmlFile(rootDirectoryEx() + "Source/Ujournal.xml");
	else
	{
		if (strIn("S",this.sType))
		{
			oDoc = createXmlDoc();
			oDoc.appendChild(oDoc.createElement("DpJournal"));
		}
	}
	
	var rootEl = oDoc.getDocumentElement();
	rootEl.setAttribute("num",this.Num);
	rootEl.setAttribute("name","");

	if (this.sType == "U")
	{
		fieldsEl = oDoc.createElement("fields");
		rootEl.appendChild(fieldsEl);
	}
	else
	{
		if (strIn("P",this.sType))
		{
			rootEl.setAttribute("type","P");
		}
		else
		{
			rootEl.setAttribute("type","M");
		}
	}
	return oDoc;
}

function DpJournal_getImplFieldElement(sName)
{
	sName = String(sName).toUpperCase();
	var fields = this.oImplFields.getElementsByTagName("field");
	
	for (var i = 0; i < fields.getLength(); i++)
	{
		if (String(fields.item(i).getAttribute("name")) == sName)
			return fields.item(i);
	}
	return null;
}

function DpJournal_addFieldImpl(sName,sType,sRem,sAttr,sDef,bIndex)
{	
	if (this.sType == "U")
	{
		sName = String(sName).toUpperCase();
		if (this.getImplFieldElement(sName) != null)
			return false;
		var fldEl = this.oImplDoc.createElement("field");
		fldEl.setAttribute("name",String(sName).toUpperCase());
		fldEl.setAttribute("type",sType);
		fldEl.setTextContent(sRem);
		if (sAttr)
			fldEl.setAttribute("attr",sAttr);
		if (sDef)
			fldEl.setAttribute("def",sDef);
		if (typeof(bIndex) != "undefined")
			fldEl.setAttribute("index",String(bIndex == true));
		this.oImplFields.appendChild(fldEl);
		return true;
	}
	else
		return false;
}

function DpJournal_removeFieldImpl(sName)
{
	if (this.sType == "U")
	{
		sName = String(sName).toUpperCase();
		var oFld = this.getImplFieldElement(sName);
		if (oFld == null)
			return false;
	
		this.oImplFields.removeChild(oFld);
		return true;
	}
	else
		return false;
}

function DpJournal_fillImplTbl(sTblName)
{
	DropTable(sTblName);
	var sSQL = "CREATE TABLE " + sTblName
			  + "(FWID " + getStruType("cid")
			  + ", FVAR " + getStruType("text(20)")
			  + ", FTYPE " + getStruType("text(25)")
			  + ", FREM " + getStruType("text(100)")
			  + ", FDEF " + getStruType("text(100)")
			  + ", FATTR " + getStruType("text(10)")
			  + ", FROUND " + getStruType("int")
			  + ", FISINDEX " + getStruType("bit")
			  + ")";
	ExecuteSQL(sSQL);
	var aFld = this.getFieldsImpl();
	var batch = createBatch();
	for (var i = 0; i < aFld.length; i++)
	{
		aFld[i].FWID = i;
		var sSQL = getSQLForUpdate(sTblName,aFld[i],true);
		batch.addBatch(sSQL);
		//ExecuteSQL(sSQL);
	}
	batch.execute(false);
}

function DpJournal_getFieldsImpl()
{
	var aRet = new Array();
	var fields = this.oImplFields.getElementsByTagName("field");
	for (var i = 0; i < fields.getLength(); i++)
	{
		var m = new Object();
		m.FVAR = fields.item(i).getAttribute("name");
		m.FTYPE = String(fields.item(i).getAttribute("type")).toUpperCase();
		m.FREM = fields.item(i).getTextContent();
		m.FDEF = fields.item(i).getAttribute("def");
		m.FATTR = fields.item(i).getAttribute("attr");
		m.FROUND = String(fields.item(i).getAttribute("round"));
		if (m.FROUND)
		{
			m.FROUND = Number(m.FROUND);
		}
		else
			m.FROUND = null;
		m.FISINDEX = fields.item(i).getAttribute("index") == "true";
		aRet[i] = m;
	}
	
	return aRet;
}

function DpJournal_getFieldImpl(sFld)
{
	var flds = this.getFieldsImpl();
	sFld = String(sFld).toUpperCase();
	
	for (var i = 0; i < flds.length; i++)
	{
		if (flds[i].FVAR == sFld)
			return flds[i];
	}
	return null;
}

function DpJournal_editImpl(sID)
{
	var tblName = getTmpTableName();
	this.fillImplTbl(tblName);
	
	var oPar = new Object();
	oPar.journal = this;
	oPar.tblName = tblName;
	oPar.sMode = sID;
	showWindow(this.editImplFile,SW_MODAL,oPar);
	
	return oPar.escape;
}

function DpJournal_setName(sName)
{
	this.oImplRoot.setAttribute("name",sName);
}

function DpJournal_getName()
{
	return UR(this.oImplRoot.getAttribute("name"));
}

function DpJournal_setRem(sRem)
{
	this.oImplRoot.setAttribute("rem",sRem);
}

function DpJournal_getRem()
{
	return UR(this.oImplRoot.getAttribute("rem"));
}

function DpJournal_setCondition(sRem)
{
	this.oImplRoot.setAttribute("cond",sRem);
}

function DpJournal_getCondition()
{
	return this.oImplRoot.getAttribute("cond");
}

function DpJournal_setTable(sName)
{
	this.oImplRoot.setAttribute("table", sName);
}

function DpJournal_getTable()
{
	return this.oImplRoot.getAttribute("table");
}

function DpJournal_getAttr(sAttr)
{
	return this.oImplRoot.getAttribute(sAttr);
}

function DpJournal_setAttr(sAttr, sValue)
{
	this.oImplRoot.setAttribute(sAttr, sValue);
}

function DpJournal_commitStructure(bForse,toBase,toTbl,bCreateIndex)
{
	this.save();	
	var tblName = (toTbl?toTbl:this.getTableName());
	if(tblName.indexOf("^")!=-1)
		return true;
		
	if (this.sType != "U" && !bForse)
		return false;
	var fldArr = this.getFieldsImpl();
//-----------------------------
	include("objects/DpDbMod.js");
//-------соберём в массив понятный модификации	
	var fiArr = new Array();
	for (var i = 0; i < fldArr.length; i++)
	{
		var fName = fldArr[i].FVAR;
		var fDpType = fldArr[i].FTYPE;
		var dbType = getStruType(fDpType,false);
		var def = getStruDefForType(fDpType);
		var fi = new FieldInfo(fName,dbType,def);
		fi.setDpType(fDpType);
		fiArr[i] = fi;
	}
//- добавим стандартные поля
	var std_fiArr = null;
		std_fiArr = getStruFields("FWIDPARENT");
		
	fiArr = concatArray(fiArr,std_fiArr);
		
//---------------------------------------	
//-----запустим модификацию
		
	var mod = new DpDbMod();
	var base = (toBase?toBase:"UJ");
	if (strIn("S",this.sType) && !toBase)
		base = "ALL_MDB";
	if (IsTableEx(base,tblName))
	{
		mod.tbl = OpenTable("s"
							,"SELECT * FROM " + getPath(base) + mod.sPoint + tblName
							+ " WHERE 1<>1"
							);
		mod.ModifyTable(base,"","",tblName,fiArr);	
	}
	else
	{
		mod.CreateTable(base,"",tblName,fiArr);
	}
	
	if(bCreateIndex===false)
		return true;
		
//----- снесём все индексы	
	var stTbl = new tableModInfo();
	stTbl.base = base;
	stTbl.table = tblName;
	stTbl.fullName = tblName;
	mod.DropIndexes(stTbl);
//----- создадим
	mod.CreateIndex(stTbl,"FWID", "FWID");
	for (var i = 0; i < fldArr.length; i++)
	{
		if (fldArr[i].FISINDEX != true)
			continue;
		mod.CreateIndex(stTbl,fldArr[i].FVAR,fldArr[i].FVAR);
	}
}

function DpJournal_rollbackStructure()
{
	if (this.sType == "U")
	{
		this.oImplDoc = this.getJDoc();
		this.oImplRoot = this.oImplDoc.getDocumentElement();
		this.oImplFields = this.oImplRoot.getElementsByTagName("fields").item(0);
	}
	else
		return false;
}

function DpJournal_remove()
{
	var isOk = deleteDir(this.getPath());
	if(this.sType == "U")
	{
		DropTable(getPath("UJ") + "." + (SUBD==MSSQL?".":"")
				+ this.getTableName());
	}
	return isOk;
}

function DpJournal_getTableName(num)
{
	if(!num)
		num = this.Num;
	var sTable = this.getTable();
	if(sTable!="" && sTable!=null)
		return sTable;
		
	if (this.sType == "U")
		return this.sType + "J_" + num;
	else
	{
		if (strIn("P",this.sType))
			return "PDOCREG";
		else
			return "MDOCREG";
	}
}

function DpJournal_getFullTableName()
{
	var sTableName = this.getTableName();
	if(sTableName.indexOf("^")!=-1)
		return sTableName;
	if (this.sType == "U")
	{
		return getPath("UJ") + "." + (SUBD==MSSQL?".":"")
				+ this.getTableName();
	}
	else
		return getPath("ALL_MDB") + "." + (SUBD==MSSQL?".":"")
				+ this.getTableName();
			
}

function DpJournal_getType()
{
	if (strIn("S",this.sType))
	{
		if (strIn("P",this.sType))
			return "SP";
		if (strIn("M",this.sType))
			return "SM";
	}
	return "U";
}