// JScript source code
include ("objects/DpXMLDomDocument.js");
function DpLabel(id)
{
	this.getID = DpLabel_getID;
	this.setID = DpLabel_setID; 
	this.getName = DpLabel_getName;
	this.setName = DpLabel_setName;
	this.getRem = DpLabel_getRem;
	this.setRem = DpLabel_setRem;
	this.getVar = DpLabel_getVar;
	this.setVar = DpLabel_setVar;
	this.getNomCl = DpLabel_getNomCl;
	this.setNomCl = DpLabel_setNomCl;
	
	this.loadByID = DpLabel_loadByID;
	this.save = DpLabel_save;
	this.edit = DpLabel_edit;
	this.hasExt = new Function("return false");
	this.ID = "";
	this.name = "";
	this.rem = "";
	this.nomcl = 0;
	
	this.getAllLabels = DpLabel_getAllLabels;
	this.getLabelsForDoc = DpLabel_getLabelsForDoc;
	this.usedForDoc = DpLabel_usedForDoc;
	this.addToDoc = DpLabel_addToDoc;
	
	if (id)
		this.loadByID(id);
	
}


function DpLabel_getID()
{
	return this.ID;
}

function DpLabel_setID(newValue)
{
	this.ID = String(newValue).trim().toLowerCase();
}

function DpLabel_getName()
{
	return this.name
}

function DpLabel_setName(newValue)
{
	this.name = String(newValue).trim();
}

function DpLabel_getNomCl()
{
	return this.nomcl
}

function DpLabel_setNomCl(newValue)
{
	this.nomcl = Number(newValue);
}

function DpLabel_getRem()
{
	return this.rem
}

function DpLabel_setRem(newValue)
{
	this.rem = String(newValue).trim();
}

function DpLabel_getVar(varName)
{
	varName = String(varName).toUpperCase();
	switch(varName)
	{
		case "ID":
		case "HID":
			return this.getID();
		case "NAME":
		case "HNAME":
			return this.getName();
		case "REM":
		case "HREM":
			return this.getRem();
		case "NOMCL":
		case "HNOMCL":
			return this.getNomCl();
		default:
			return null;
	}
	
}

function DpLabel_setVar(varName, varValue)
{
	varName = String(varName).toUpperCase();	
	switch(varName)
	{
		case "ID":
		case "HID":
			this.setID(varValue);
			break;
		case "NAME":
		case "HNAME":
			this.setName(varValue);
			break;
		case "REM":
		case "HREM":
			this.setRem(varValue);
			break;
		case "NOMCL":
		case "HNOMCL":
			this.setNomCl(varValue);
			break;
		
	}
	
}


function DpLabel_loadByID(id)
{
	id = String(id).toLowerCase();	

	include ("objects/DpXMLDomDocument.js");
	var fileName = getOrgPath() + "/settings/labels/def/" + id + ".xml";

	if (!isFile(fileName))
		return false;
		
	var xmlDom = new DpXMLDOMDocument();		
	if(!xmlDom.load(fileName))
		return false;
	
	var root = xmlDom.getDocumentElement();
	if (root == null)
		return false;
		
	
	this.setID(String(root.getAttribute("ID")).trim());
	this.setName(String(root.getAttribute("name")).trim());
	this.setNomCl(String(root.getAttribute("nomcl")).trim());
	this.setRem(root.getText());
	
	return true;
}


function DpLabel_edit(sMode, nID, par)
{
	if(typeof(par) != "object")
		par = new Object();
	par.dpObj = this;
	par.mode = sMode;
	
	if(sMode != "ADD")
	{
		
		if (!this.loadByID(nID))
			return false;
		
	}
	
	par.hasTab = false;

	if (sMode == "VIEW")
		par.isView = true;
	else
		par.isView = false;
	
	showWindow("e_label.xml","XMLDLG",par);
	
	if (!par.escape)
	{
		return this.save();		
	}
	
	return false;
}

function  DpLabel_save()
{
	var dir = getOrgPath() + "/settings/labels/def";
	createDirectory(dir);
	var fileName = dir + "/" + this.ID + ".xml";
	
	var xmlDom = new DpXMLDOMDocument();
	var root = xmlDom.createElement("label");
	
	root.setAttribute("ID", this.ID)
	root.setAttribute("name", this.name);
	root.setAttribute("nomcl", String(this.nomcl));
	root.setText(this.rem);
	
	xmlDom.appendChild(root);
	xmlDom.save(fileName);
}

function DpLabel_getAllLabels()
{
	var ret = new Array();
	var dirName = getOrgPath() + "/settings/labels/def";
	var dir = new DpFile(DpFile(dirName));
	if (!dir.exists() || !dir.isDirectory())
		return ret;
			
	var fileList = dir.listFiles();
	for (var nF = 0; nF < fileList.length; nF++)
	{
		var curF = fileList[nF];
		if (curF.isDirectory())
			continue;
	
		var strName = String(curF.getName()).toLowerCase();
		if (strName.right(4) != ".xml")
			continue;
			
		var oLbl = new DpLabel();
		if (oLbl.loadByID(strName.substring(0, strName.lastIndexOf("."))))
			ret[ret.length] = oLbl;		
	}
	
	return ret;
}

function DpLabel_getLabelsForDoc(sDoc, nNop)
{
	var ret = new Array();
	var fileName = getOrgPath() + "/settings/labels/docs/" +  String(sDoc).toUpperCase().replace(":", "_")+ "/" + nNop +  ".xml";
	
	if (!isFile(fileName))
		return ret;
		
	var xmlDom = new DpXMLDOMDocument();		
	if(!xmlDom.load(fileName))
		return ret;
	
	var root = xmlDom.getDocumentElement();
	if (root == null)
		return ret;
		
	
	var arr = root.getElementsByTagName("label");
	
	for (var i = 0; i < arr.length; i++)
	{
		var xmlLbl = arr[i];
		var id = String(arr[i].getAttribute("ID"));
		
		var oLbl = new DpLabel();
		if (oLbl.loadByID(id))
			ret[ret.length] = oLbl;
	}
	
	return ret;

}

function DpLabel_usedForDoc(sDoc, nNop)
{
	var ret = new Array();
	var fileName = getOrgPath() + "/settings/labels/docs/" +  String(sDoc).toUpperCase().replace(":", "_")+ "/" + nNop +  ".xml";
	
	if (!isFile(fileName))
		return false;
		
	var xmlDom = new DpXMLDOMDocument();		
	if(!xmlDom.load(fileName))
		return false;
	
	var root = xmlDom.getDocumentElement();
	if (root == null)
		return false;
		
	
	var arr = root.getElementsByTagName("label");
	
	for (var i = 0; i < arr.length; i++)
	{
		var xmlLbl = arr[i];
		var id = String(arr[i].getAttribute("ID"));
		if (id.toLowerCase() == this.getID())
			return true;
	}
	
	return false;

}

function DpLabel_addToDoc(sDoc, nNop)
{
	var dirName = getOrgPath() + "/settings/labels/docs/" +  String(sDoc).toUpperCase().replace(":", "_");
	var fileName = dirName + "/" + nNop +  ".xml";
	
	var xmlDom = new DpXMLDOMDocument();		
	
	if (isFile(fileName))
	{
		if(!xmlDom.load(fileName))
			xmlDom = new DpXMLDOMDocument();
	}
	else
	{
		createDirectory(dirName);
	}
	
	var root = xmlDom.getDocumentElement();
	if (root == null)
	{
		root = xmlDom.createElement("labels");
		xmlDom.appendChild(root);
	}
		
	
	var arr = root.getElementsByTagName("label");
	
	for (var i = 0; i < arr.length; i++)
	{
		var xmlLbl = arr[i];
		var id = String(arr.getAttribute("ID"));
		if (id.toLowerCase() == this.getID())
			return true;
	}
	
	var xmlLbl = xmlDom.createElement("label");
	xmlLbl.setAttribute("ID", this.getID());
	root.appendChild(xmlLbl);
	
	return xmlDom.save(fileName);

}

