/*										
   Описание объекта "элемент справочника диц.счетов": DpLicf
   (C) ДЕБЕТ Плюс, 1998-1999

   Конструктор DpLicf.
      Возвращает this

   Внешние методы:
   .setFid(Fid)	 - Установить код лиц.счета
   .getFid()		 - Получить код лиц.счета
   .setFtxt(Ftxt)  - Установить название лиц.счета
   .getFtxt()      - Получить название лиц.счета
   .setFnum(Fnum)  - Установить номер п/п
   .getFnum()		 - Получить номер п/п
   .setFis6()		 - Установить
   .getFis6()		 - Получить
   .valid()			 - Проверка, существует ли запись по заданному номеру
   .linkCtrl(ctrlNum,ctrlTxt,ctrlVopl) - Связать с полем ввода
   .validCtrl()	 - Реакция на выход из связанного поля ввода
   .zaval()			 - Осуществляется завал при нажатии кнопки.

   Внутренние свойства:
   .Fid            - код лиц.счета
      Используется только в методах setFid и getFid.
      В остальных случаях используйте эти методы.
   .Ftxt				 - наименование лиц.счета
      Используется только в методах setFtxt и getFtxt.
      В остальных случаях используйте эти методы.
   .Fnum				 - номер	п/п
      Используется только в методах setFnum и getFnum.
      В остальных случаях используйте эти методы.
   .table			 - таблица для внутреннего использования в объекте.
   .ctrlNum,ctrlTxt,ctrlVopl  - связь с полями ввода. 
   .isButton		 - кнопка для завала.
   .updateCtrl		 - обновление полей ввода.
*/

// Конструктор объекта DpLicf
function DpLicf(par)
{
	RO("DpLicf", this);
   this.setFid = DpLicf_setFid;
   this.getFid = DpLicf_getFid;
   this.setFtxt = DpLicf_setFtxt;
   this.getFtxt = DpLicf_getFtxt;
   this.setFnum = DpLicf_setFnum;
   this.getFnum = DpLicf_getFnum;
   this.setFis6 = DpLicf_setFis6;
   this.getFis6 = DpLicf_getFis6;
   this.valid = DpLicf_valid;
   this.linkCtrl = DpLicf_linkCtrl;
   this.validCtrl = DpLicf_validCtrl;
   this.updateCtrl = DpLicf_updateCtrl;
   this.zaval = DpLicf_zaval;
   
   if (typeof(par)=="string" && par.toUpperCase()=="Z")
		this.isZero = true
   else
		this.isZero = false;   
		
   return this;
}

// Установить код Fid
function DpLicf_setFid(Fid)
{
	this.Fid = Fid;
	var snap;
	if(Fid)
		snap = getSnap("select Ffld_num from ^lic_fld where Fid="+Fid);
	if(snap)
		this.setFnum(snap[0]);
	return true;
}

// Получить код Fid
function DpLicf_getFid()
{
	if (this.valid())
		return this.table.getValue("Fid")
	else  return 0;
}

// Установить название Ftxt
function DpLicf_setFtxt(Ftxt)
{
   this.Ftxt = Ftxt;
   this.updateCtrl();
   return true;
}

// Получить название Ftxt
function DpLicf_getFtxt()
{
	if (this.valid() && !isEmpty(this.table))
		return this.table.getValue("ftxt")
	else  return "";
}

// Установить номер Fnum
function DpLicf_setFnum(Fnum)
{
	this.Fnum = Fnum;
	if(Fnum==null)
		this.table = OpenTable("s", "SELECT * FROM ^lic_fld WHERE FFLD_NUM is null");
	else
		this.table = OpenTable("s", "SELECT * FROM ^lic_fld WHERE FFLD_NUM = " + sqlTo(this.Fnum));
	this.updateCtrl();
	return true;         
 /* 
  if(!(this.table.IsEmpty())) {
		this.setFtxt(this.table("Ftxt"));
		this.setFid(this.table("Fid"));
   }
   else 
      this.Ftxt = this.Fid = null;
   this.updateCtrl();
   */
}

// Получить номер Fnum
function DpLicf_getFnum()
{
   return this.Fnum;
}

// Установить Fis6
function DpLicf_setFis6(Fis6)
{
   this.Fis6 = Fis6;
   return true;
}

// Получить Fis6
function DpLicf_getFis6()
{
	if (this.valid())
		return this.table.getValue("Fis6")
	else  return "";
}


// Проверка правильности инициализации
function DpLicf_valid()
{
  var OK = (this.table) && (!(this.table.IsEmpty()) && (this.table.getValue("Fis_slct")==true));
  return OK
}

//связать с полями ввода
function DpLicf_linkCtrl(ctrlNum,ctrlTxt,ctrlVopl)
{
	this.ctrlNum = ctrlNum;
	this.ctrlNum.isButton = true;	
	
	if (typeOf(this.ctrlNum) != "DpTextEx")
	{
		if (typeof this.ctrlNum != "object")
			return false;
	}
	
	this.ctrlNum.mask="-###";	//3	
	//if(this.ctrlNum.DpType=="DpGet")
	if (typeOf(this.ctrlNum) == "DpTextEx")
	{
		setButton(this.ctrlNum, this, "zaval");
		setValid(this.ctrlNum, this, "validCtrl");
	}	
	
	this.ctrlTxt = ctrlTxt;
	if(this.ctrlTxt)
	{
		this.ctrlTxt.setMask("&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&");	//30
		this.ctrlTxt.setEnabled(false);
	}			
	
	this.ctrlVopl = ctrlVopl;
	
	this.updateCtrl();
}

// Обновить связанные поля ввода
function DpLicf_updateCtrl()
{
   if (this.ctrlNum)
      this.ctrlNum.value = this.getFnum();
   if (this.ctrlTxt)
      this.ctrlTxt.value = this.getFtxt();
}

// Реакция на выход из связанного поля ввода
function DpLicf_validCtrl()
{
	this.setFnum(this.ctrlNum.value);
	if (!this.valid())
	{
		if ( (this.ctrlNum.value == 0) 
				&& (this.isZero || this.ctrlVopl && this.ctrlVopl.value >= 9000)
				|| (!this.ctrlNum.enabled))
		{	
			this.setFtxt("");
			this.setFid(0);
			this.setFis6(0);
		}	
		else
			return this.zaval()
	}	
	else
	{	
		this.setFtxt(this.table.getValue("Ftxt"));
		this.setFid(this.table.getValue("Fid"));
		this.setFis6(this.table.getValue("Fis6"));				
	}	
	this.updateCtrl();
	return true;
}

//Осуществляется завал
function DpLicf_zaval()
{
   var par = new Object();
   par.ret = new Object();
   par.Ffld_num = par.ret.Ffld_num = this.ctrlNum.value;
   par.ret.Ftxt = null;
   par.ret.Fid = null;
   par.ret.Fis6 = null;
   par.zaval = true;
   showWindow("l_zvlicf.js",SW_MODAL,par);
   if(par.escape==false) 
   { 
    
      this.setFnum(par.ret.Ffld_num);
      this.setFtxt(par.ret.Ftxt);
      this.setFid(par.ret.Fid);
	  this.setFis6(par.ret.Fis6);				      
      this.updateCtrl();
   } 
   return !par.escape;
}					  