/**
 * @autor draco
 *  
 * Объект предназначен для вывода информации в виде списка (завал)
 * 
 * 
 * 
 * 
 * 
 */

DpListMaker.prototype.setHead = DpListMaker_setHead;
DpListMaker.prototype.setID = DpListMaker_setID;
DpListMaker.prototype.setColumnWidth = DpListMaker_setColumnWidth;
DpListMaker.prototype.setColumnType = DpListMaker_setColumnType;
DpListMaker.prototype.addRow = DpListMaker_addRow;
DpListMaker.prototype.createXMLForm = DpListMaker_createXMLForm;
DpListMaker.prototype.open = DpListMaker_open;
DpListMaker.prototype.setTitle = DpListMaker_setTitle;

function DpListMaker(width, height, title)
{
	if (typeof width == "string")
	{
		title = width;
		height = 480;
		width = 640;	
	}
	else
	{
		if (typeof height != "number")
			height = 480;
		if (typeof width != "number")
			width = 640;
	}	
	this.height = height;
	this.width = width;
	this.title = title ? title : "DpListMaker";
	this.head = null;
	this.id = null;
	this.columnWidth = null;
	this.columnType = null;
	this.data = null;
	this.columnCount = 0;
	this.ret = new Object();
	this.extPar = new Object();
	this.doc = null;
	this.createXMLForm();
}


function DpListMaker_setHead()
{
	var length = DpListMaker_setHead.arguments.length;
	if (length <= 0)
	{
		this.head = null;
		this.columnCount = 0;
		return;
	}
	if (this.columnCount == 0 || this.head == null)
		this.columnCount = length;
	this.head = new Array();
	for (var i = 0; i < this.columnCount; i++)
		this.head[i] = String(DpListMaker_setHead.arguments[i]);	
}

function DpListMaker_setID()
{
	var length = DpListMaker_setID.arguments.length;
	if (length <= 0)
		return;
	this.id = new Array();
	for (var i = 0; i < length; i++)
		this.id[i] = String(DpListMaker_setID.arguments[i]);	
}

function DpListMaker_setColumnWidth()
{
	var length = DpListMaker_setColumnWidth.arguments.length;
	if (length <= 0)
		return;
	this.columnWidth = new Array();
	for (var i = 0; i < length; i++)
		this.columnWidth[i] = Number(DpListMaker_setColumnWidth.arguments[i]);	
}

function DpListMaker_setColumnType()
{
	
}

function DpListMaker_addRow()
{
	var length = DpListMaker_addRow.arguments.length;
	if (length <= 0)
		return;
	if (this.columnCount == 0 || this.head == null)
		this.columnCount = length;
	if (this.data == null)
		this.data = new Array();
	var row = this.data[this.data.length] = new Array();
	for (var i = 0; i < this.columnCount; i++)
		row[i] = String(DpListMaker_addRow.arguments[i]);
}

function DpListMaker_createXMLForm()
{
	this.doc = lpProxy.createXmlDoc();
	var mElem = this.doc.createElement("Form");
	mElem.setAttribute("height", String(this.height));
	mElem.setAttribute("width", String(this.width));	
    this.doc.appendChild(mElem);
    var eControls = this.doc.createElement("Controls");
   	eControls.setAttribute("col", "1");   	
    mElem.appendChild(eControls);
    var element = this.doc.createElement("grid");
    element.setAttribute("ID", "grid");
    element.setAttribute("align", "fill");
    element.setAttribute("valign", "fill");
    eControls.appendChild(element);
    var button = this.doc.createElement("Buttons");
    button.setAttribute("use", "false");
    mElem.appendChild(button);
    var script = this.doc.createElement("script");
    script.setAttribute("language", "JavaScript");
    script.setAttribute("src", "l_listmakerView.js");
    mElem.appendChild(script);
}

function DpListMaker_open()
{
	var fileName = "DpListMaker_" + new Date().getTime() + ".xml";
	lpProxy.saveXml(this.doc, rootDirectory() + fileName);	
	var par = new Object();
	par.escape = true;
	par.dpListMaker = this;
	if (DpListMaker_open.arguments.length > 0)
	{
		par.ret = new Object();
		for (var i = 0; i < DpListMaker_open.arguments.length; i++)
			par.ret[String(DpListMaker_open.arguments[i])] = "0"; 		
	}
	showWindow(fileName, SW_MODAL, par);
	lpProxy.deleteFile(rootDirectory() + fileName);
	this.escape = par.escape;
	if (!par.escape)
		this.ret = par.ret;
}

function DpListMaker_setTitle(arg)
{
	this.title = String(arg);
}
