//Олег 23.12.2009
//Объкт для работы с массовым вводом

//объект принимает режим mode 
//а на par навешивается другие пареметры 

//mode может состоять из букв FPBS
//для того чтобы отображать только нужные пункты меню 
//
//F - (FIX) Загрузка фиксированной суммы
//P - (PROC) Загрузить % от оклада
//B - (BALANS) Загрузка данных из баланса
//S - (SVOD) Загрузка сумм из свода по ЗП
//пример 
//var oMassSum = new DpMassSum("FB")
//Будут доступны только 
//1.Загрузка фиксированной суммы 
//2.Загрузка данных из баланса

//par.sprPers = номер справочника персонала
//если не передавать то будет взят из параметров системы getPar("CODPERS")

//Дополнительные параметры 
//		par.sprPodr = 10; 	использовать справочник подразделений под №10
//		par.sprSelo = 320;	использовать справочник сел под №320
//		par.sprGaluz = 8;		использовать справочник отраслей затрат под №8
//		par.isUseShtat = true;  использовать справочник ШПЗ
//		par.isUseDay = true;  использовать дни
//		par.isUseHour = true;  использовать часы

//++++++++++++процедура использования++++++++++++
//у функции Load Рождаем объект
//		par = {}
//		par.sprPers = 2;
//		par.sprPodr = 10; 
//		par.sprSelo = 320;
//		par.sprGaluz = 8;
//		par.isUseShpz = true;
//		par.isUseShtat = true;
//		par.isUseDay = true;
//		par.isUseHour = true;
//		oMassSum = new DpMassSum("", par);
//
//у функции menuInit инициализируем пункт меню "Масовый ввод"
//		oMassSum.menuInit();
//
//у функции menuRun получаем готовую таблицу 
//		oMassSum.menuRun(sID);
//		switch
//		{
//			case "LOAD_MASS_SUM":
//				tableName = oMassSum.getTable());
//			break;
//		}
//-----------------процедура использования-----------------

include("Objects/DpAskEx.js");
include("Objects/DpShtat.js");
include("TrnNBln.js");
include("servis/date.js");

function DpMassSum(mode, par)
{
	RO("DpMassSum", this);
		
	this.menuInit = DpMassSum_menuInit;
	this.menuRun = DpMassSum_menuRun;
	this.load = DpMassSum_load;
	this.setMode = DpMassSum_setMode;
	this.setUseShtat = DpMassSum_setUseShtat;
	this.setSprPers = DpMassSum_setSprPers;
	this.setSprPodr = DpMassSum_setSprPodr;
	this.setSprSelo = DpMassSum_setSprSelo;
	this.setSprGaluz = DpMassSum_setSprGaluz;
	this.setUseShpz = DpMassSum_setUseShpz;
	this.setUseDay = DpMassSum_setUseDay;
	this.setUseHour = DpMassSum_setUseHour;
	this.setUseZp = DpMassSum_setUseZp;
	this.getMode = DpMassSum_getMode;
	this.getTable = DpMassSum_getTable;
	this.toApplyOkr = DpMassSum_toApplyOkr;
	this.askDopPar = DpMassSum_askDopPar;
	this.writeDopPar = DpMassSum_writeDopPar;
	
	this.loadFromBln = DpMassSum_loadFromBln;
	this.loadFromCl = DpMassSum_loadFromCl;
	this.loadFromShtat = DpMassSum_loadFromShtat;
	this.loadOklad = DpMassSum_loadOklad;
	this.loadFromSvodZP = DpMassSum_loadFromSvodZP;
	
	//Дополнительно можно спросить и записать в таблицу 
	this.sprPodr = 0;		//подразделение
	this.sprSelo = 0;		//село
	this.sprGaluz = 0;		//Отрасль затр.
	this.isUseShpz = false ;	//ШПЗ
	this.isUseDay = false;
	this.isUseHour = false;
	this.isUseZp = false;
		
	this.mode;
	this.sprPers;
	this.isUseShtat;
	this.table = "DPMASSSUM_TBL";
	
	
	//++++++Чтение переданных параметров++++++ 
		this.setMode(mode);
		
		this.setSprPers(par.sprPers);
			
		//по умолчению используем this.isUseShtat = false;
		//тоисть завал будет в справочник аналитики
		this.setUseShtat(par.isUseShtat);
		
		//дополнительные параметры 
		this.setSprPodr(par.sprPodr); 	//подразделение 
		this.setSprSelo(par.sprSelo);		//село
		this.setSprGaluz(par.sprGaluz);	//отрасль затрат
		this.setUseShpz(par.isUseShpz);	//ШПЗ
		this.setUseDay(par.isUseDay); 	//дни 
		this.setUseHour(par.isUseHour); 	//часы 
	//---------Чтение переданных параметров---------
}

function DpMassSum_menuInit(menuPar)
{
	DataSource().AddMenuItem("LOAD_MASS_SUM","Масовий вибір|Массовый ввод");
}

function DpMassSum_menuRun(ID)
{
	switch (ID)
	{
		case "LOAD_MASS_SUM":
			if(!this.load())
			{
				alert(ru("Загрузка не выполнена!"
					, "Завантаження не виконано!"));
				return false;
			}
			break;
	}
}

function DpMassSum_load()
{
	var arrMode = new Array();
	
	//подготовим таблицу
	if(DropTable(this.table))
	{
		strSQL = "CREATE TABLE "+this.table
				+" ("
					+" FCOD "+SqlType("LONG")			//код из спр. персонала
					+", FSUM "+SqlType("DOUBLE")		//сума
					+", FWID_WP "+SqlType("LONG")		//ID Штатного
					+", FPODR "+SqlType("LONG")			//Код подр.
					+", FSELO "+SqlType("LONG")			//Код села
					+", FGALUZ "+SqlType("LONG")		//Код отрасли 
					+", FSHPZ "+SqlType("TEXT")			//ID ШПЗ
					+", FDAY "+SqlType("DOUBLE")		//дни
					+", FHOUR "+SqlType("DOUBLE")		//часы
					+", FWID "+SqlType("COUNTER")
				+" )"
		ExecuteSQL(strSQL);
	}
	else if(IsTable(this.table))
	{
		ExecuteSQL("DELETE FROM "+this.table);
	}

	
	//спрашиваем режим загрузки
	var oA = new DpAskEx();
	var szList = "";
	
	//собираем масив для определения выбраного пункта меню
	if(this.mode.search("F") != -1)
	{
		arrMode.push("F");
		szList += ru("Загрузка фиксированной суммы", "Завантаження фіксованої суми");
	}
	if(this.mode.search("P") != -1)
	{
		if(arrMode.length != 0)
		{
			szList +="|";
		}
		
		arrMode.push("P");
		szList +=ru("Загрузить % от оклада", "Завантаження % від окладу");
	}
	if(this.mode.search("B") != -1)
	{
		if(arrMode.length != 0)
		{
			szList +="|";
		}
		arrMode.push("B");
		szList +=ru("Загрузка данных из баланса", "Завантаження данних з балансу");
	}
	if(this.mode.search("S") != -1)
	{
		if(arrMode.length != 0)
		{
			szList +="|";
		}
		
		arrMode.push("S");
		szList +=ru("Загрузка сумм из свода по ЗП", "Завантаження сум із зведення по ЗП");
	}
	
	oA.add("RADIO", "Режим завантаження|Режим загрузки", "MODE", 0, szList);
		
	oA.doAsk();
	if(oA.escape)
	{
		return false;
	}
		
	if(arrMode.length == 0)
	{
		alert(ru("Для этого режиме не предусмотрено ни одного пункта меню!"
				, "Для цього режиму не передбачено жодного пункту меню!"));
		return false;
	}
	
	//исходя из выбраного режима еще раз спрашиваем параметры 
	//которые необходимы для загрузки в выбраном режиме 
	var modeNum = oA.get("MODE");
	oA = null;
	oA = new DpAskEx();
	
	switch (arrMode[modeNum])
	{
		case "F":
			oA.setCaption(ru("Загрузка фиксированной суммы", "Завантаження фіксованої суми"));

			//если загрузка из штатного то спрашиваем дату для завала в штатное
			if(this.isUseShtat)
			{
				oA.add("D", "Дата", "DAT", new Date().getVarDate());
			}
			
			oA.add("NUM0", "Сума|Сумма", "SUM", 0, 10, 2);
			
			//спрашиваем дополнительные параметры
			oA = this.askDopPar(oA);
			
			oA.doAsk();
			if(oA.escape)
			{
				return false;
			}
			
			var par = {};
			par.sum = oA.get("SUM");
			if(this.isUseShtat)
			{
				par.dat = new Date(oA.get("DAT"));
			}
			
			if(this.isUseShtat)
			{
				//при работе со штатным справочник персонала всегда берем из настроек системы 
				this.setSprPers(getPar("CODPERS"));
				
				this.loadFromShtat("", par);
			}
			else
			{
				this.loadFromCl("", par);
			}
			break;
		case "P":
			oA.setCaption(ru("Загрузить % от оклада", "Завантаження % від окладу"));
			
			oA.add("D", "Дата розр. штатн. розкл.|Дата расч. штатн. росп.", "DAT", new Date().getVarDate());
			oA.add("NUM", "%", "PROC", 100, 5, 2);
			oA.add("NUM", "Норма часу для ГТС, годин|Норма времени для ЧТС, часов", "NTIME", 0, 5, 2);
			oA.add("B", "Завантаж. рядки з нульовими сум.|Загр. строки с нулевыми сум.", "IS_SUM0", false);
			oA.add("RADIO", " ", "MODE_LOAD", 0, 
						ru("Загрузить всех рабочих", "Завантажити всіх працівників")
					+"|"+ru("Выбрать из штатного", "Вибрати зі штатного"));
			oA.add("RADIO", "Заокруглювати|Округлять", "OKR", 3,
						"до 50 грн."
						+"|до 10 грн."
						+"|до 5 грн."
						+"|до 1 грн."
						+"|"+ ru("не округлять", "не заокруглювати"));
			
			//спрашиваем дополнительные параметры
			oA = this.askDopPar(oA);
			
			oA.doAsk();
			if(oA.escape)
			{
				return false;
			}
			var par = {};
			par.dat = oA.get("DAT");
			par.proc = oA.get("PROC");
			par.nTime = oA.get("NTIME");
			par.isLdSum0 = oA.get("IS_SUM0");
			par.okr = oA.get("OKR");
			var mode = (Number(oA.get("MODE_LOAD")) == 0 ? "ALL" : "ZAVAL");
			
			this.loadOklad(mode, par);
			break;
		case "B":
			oA.setCaption(ru("Загрузка данных из баланса", "Завантаження данних з балансу"));
			
			var szList = ru("Загрузить остаток по счету", "Завантажити залишок по рахунку")
					+"|"+ru("Загрузить обороты по счету", "Завантажити обіги по рахунку")
					+"|"+ru("Загрузить обороты по корреспонденции счетов", "Завантажити обіги по кореспонденції рахунків")
			oA.add("RADIO", "Режим завантаження:|Режим загрузки:", "MODE", 0, szList);
			oA.add("B", "Завантажувати від'ємні суми|Загружать отрицательные суммы", "ISNEGATIVE", false)
			
			oA.add("D", "Дата", "DAT", new Date().getVarDate());
			oA.add("D", "Дата початку|Дата начала", "BDAT", new Date().getVarDate());
			oA.add("D", "Дата закінчення|Дата окончания", "EDAT", new Date().getVarDate());
						
			oA.add("CUT0XYZ", "Рахунок", "SC");
			oA.add("CUT0XYZ", "Дт рах.", "SC_DT", "66|661");
			oA.add("CUT0XYZ", "Кр рах.", "SC_CR", "23|0");
						
			oA.add("RADIO", "Залишок по:|Остаток по:", "SL_DT_CR", 1, "Дебету|Кредиту");
			oA.add("RADIO", "Обіги по:|Обороты по:", "OB_DT_CR", 1, "Дебету|Кредиту");
			oA.add("NUM", "%", "PROC", 100, 5, 2);
			oA.add("RADIO", "Заокруглювати|Округлять", "OKR", 3,
						"до 50 грн."
						+"|до 10 грн."
						+"|до 5 грн."
						+"|до 1 грн."
						+"|"+ ru("не округлять", "не заокруглювати"));

			oA.defCond("this.aQryList['MODE'].controls[0] == 0", "IS_DAT");
			oA.defCond("this.aQryList['MODE'].controls[0] == 1 || this.aQryList['MODE'].controls[0] == 2", "IS_BDAT_EDAT");
			oA.defCond("this.aQryList['MODE'].controls[0] == 0 || this.aQryList['MODE'].controls[0] == 1", "IS_SC");
			oA.defCond("this.aQryList['MODE'].controls[0] == 0", "IS_SL_DT_CR");
			oA.defCond("this.aQryList['MODE'].controls[0] == 1", "IS_OB_DT_CR");
			oA.defCond("this.aQryList['MODE'].controls[0] == 2", "IS_SC_DT_CR");
			
			oA.visible("DAT", "IS_DAT");
			oA.visible("BDAT", "IS_BDAT_EDAT");
			oA.visible("EDAT", "IS_BDAT_EDAT");
			oA.visible("SC", "IS_SC");
			oA.visible("SC_DT", "IS_SC_DT_CR");
			oA.visible("SC_CR", "IS_SC_DT_CR");
			oA.visible("SL_DT_CR", "IS_SL_DT_CR");
			oA.visible("OB_DT_CR", "IS_OB_DT_CR");
			
			// С 2000 версии кусок
			oA.visible("ISKOR", "IS_OB_DT_CR");
			oA.add("B", "Фільтр по корреспондуючій аналітиці|Фильтр по корреспондирующей аналитике", "ISKOR", false)
			oA.add("CLCL", "Довідник|Справочник", "CLNUM");
			oA.setValid("CLNUM", ClNum_Valid);			
			oA.add("CL0", "Код з довідника|Код из справочника", "COD");

			oA.defCond("this.aQryList['ISKOR'].controls[0].checked && this.aQryList['MODE'].controls[0] == 1", "IS_KOR");
			oA.visible("CLNUM", "IS_KOR");
			oA.visible("COD", "IS_KOR");			
			
			//спрашиваем дополнительные параметры
			oA = this.askDopPar(oA);

			if(!oA.doAsk())
			{
				return false;
			}
			
			
			var par = {};
			var mode = Number(oA.get("MODE"))
			//исходя из выбраного режима навешиваем параметры для расчета 
			switch (mode)
			{
				case 0:
					par.dat = oA.get("DAT");
					par.oSc = oA.get("SC");
					par.dt_cr = (oA.get("SL_DT_CR") == 0 ? "DB" : "CR");
					mode = "OST";
					break;
				case 1:
					par.bDat = oA.get("BDAT");
					par.eDat = oA.get("EDAT");
					par.oSc = oA.get("SC");
					par.dt_cr = (oA.get("OB_DT_CR") == 0 ? "DB" : "CR");
					par.isKor = oA.get("ISKOR");
					if(par.isKor)
					{
						par.clCl = oA.get("CLNUM").getCod();
						par.clCod = oA.get("COD").getCod();
						
					}
					mode = "OB";
					break;
				case 2:
					par.bDat = oA.get("BDAT");
					par.eDat = oA.get("EDAT");
					par.oScDt = oA.get("SC_DT");
					par.oScCr = oA.get("SC_CR");
					mode = "OB_CORR"
					break;
				default:
			}
			
			par.proc = oA.get("PROC");
			par.okr = oA.get("OKR");
			par.isNegative = oA.get("ISNEGATIVE");
					
			this.loadFromBln(mode, par);
			break;
		case "S":
			oA.setCaption(ru("Загрузка сумм из свода по ЗП", "Завантаження сум із зведення по ЗП"));
			
			oA.add("D", "Дата зведення|Дата свода", "DAT", new Date().getVarDate());
			oA.add("LS", "Поле ОР|Поле ЛС", "LS", 0);
			oA.add("NUM", "%", "PROC", 100, 5, 2);
			oA.add("RADIO", " ", "MODE_LOAD", 0, 
						ru("Загрузить всех рабочих", "Завантажити всіх працівників")
					+"|"+ru("Выбрать из списка", "Вибрати зі списку")
					+"|"+ru("Выбрать из списка по подразделениям", "Вибрати зі списку по підрозділам"));
			oA.add("RADIO", "Заокруглювати|Округлять", "OKR", 3,
						"до 50 грн."
						+"|до 10 грн."
						+"|до 5 грн."
						+"|до 1 грн."
						+"|"+ ru("не округлять", "не заокруглювати"));

			
			//спрашиваем дополнительные параметры
			oA = this.askDopPar(oA);
						
			oA.doAsk();
			if(oA.escape)
			{
				return false;
			}
			
			var par = {};
			par.dat = oA.get("DAT");
			par.lsFid = oA.get("LS").getFid();
			par.proc = oA.get("PROC");
			par.okr = oA.get("OKR");
			par.mode_load = oA.get("MODE_LOAD");
			
			//при работе со штатным справочник персонала всегда берем из настроек системы 
			this.setSprPers(getPar("CODPERS"));
			
			this.loadFromSvodZP("", par);
			break;
		default:
			break;
	}
	
	//записываем в таблицу доп. парметры 
	this.writeDopPar(oA);
		
	var opTbl = OpenTable(this.table)
	if(opTbl.recordCount == 0)
	{
		alert(ru("За указанными параметрами данные отсутствуют!"
				, "За вказаними параметрами дані відсутні!"));
	}
	opTbl.Close(5652);
	opTbl = null;
	
	return true;
}

function DpMassSum_loadFromBln(mode, par)
{
	switch (mode)
	{
		case "OST":
		case "OB":
		//Загрузить остаток или обороты по счету
			var bDat = (mode == "OST" ? new Date(par.dat) : new Date(par.bDat));
			var eDat = (mode == "OST" ? bDat : new Date(par.eDat));
			var oSc = par.oSc;
			var dt_cr = par.dt_cr;
						
			//Найдем поле, с которого будем снимать код человека - это
	        //та аналитика, к которой привязан справочник this.sprPers
	        var grpByFld = "";
	        if(oSc.getClcl1() == this.sprPers)
	        {
	        	grpByFld = "FCL_COD1";
	        }
	        else if(oSc.getClcl2() == this.sprPers)
	        {
	        	grpByFld = "FCL_COD2";
	        }
	        else if(oSc.getClcl3() == this.sprPers)
	        {
	        	grpByFld = "FCL_COD3";
	        }
			else
	        {
	        	msg = ru("На выбранных счетах отсутствует аналитика №"
							, "На вибраних рахунках відсутня аналітика №");
				alert(msg+this.sprPers)
	        	return false;
	        }
			
			// выполним расчет оборотов
			TrnNBln("3n", "TMP_OBR_4MASS", bDat, eDat, oSc, null);
			
			//Удаляем итоговые строки
			strSQL = "DELETE "
						+" FROM TMP_OBR_4MASS"
						+" WHERE "
							+" FISTOTAL = -1"
			ExecuteSQL(strSQL);
			
			//выберем по какому полю смотреть исходя из режима и оборотов 
			if(dt_cr == "DB")
			{
				//Дебет 
				//FSUM3 - сальдо
				//FSUM5 - обороты
				Fsum = (mode == "OST" ? "FSUM3" : "FSUM5");
			}
			else
			{
				//Кредит
				//FSUM4 - сальдо
				//FSUM6 - обороты
				Fsum = (mode == "OST" ? "FSUM4" : "FSUM6");
			}

			if(!par.isKor)
			{
				strSQL = "INSERT INTO "+this.table+"(FSUM, FCOD)"
							+" SELECT"
								+" SUM("+Fsum+") * "+sqlTo(par.proc/100)
								+", "+grpByFld
							+" FROM TMP_OBR_4MASS"
							+" WHERE 1=1"
								+(par.isNegative?"":" AND "+Fsum+" > 0")
							+" GROUP BY "+grpByFld
							+" ORDER BY "+grpByFld
				ExecuteSQL(strSQL);
			}
			else
			{
				var mode = (dt_cr == "DB" ? "FDB" : "FCR")
				var corrmode = (dt_cr == "DB" ? "FCR" : "FDB")
				var tmpTbl = getTmpTableName("", true);
				strSQL = "SELECT S.*"
					+" INTO "+tmpTbl
					+" from ^SCHET S"
					+ " WHERE fdate BETWEEN " + sqlTo(bDat) + " AND " + sqlTo(eDat)
					+ sqlw0And(mode+"_sc=", oSc.getSc())
					+ sqlw0And(mode+"_su=", oSc.getSu())
					+ sqlw0And(mode+"_st=", oSc.getSt())
					+" AND NOT FWRK IN (15,16)"
				ExecuteSQL(strSQL);
				
				strSQL = "DELETE FROM "+tmpTbl+" T"
					+" WHERE NOT EXISTS (SELECT CL.FSCHET, CL.FSUBSCHET, CL.FSTAT FROM ^CL_SCHET CL"
					+" WHERE CL.FSCHET = T."+corrmode+"_sc"
					+" AND CL.FSUBSCHET = T."+corrmode+"_su"
					+" AND CL.FSTAT = T."+corrmode+"_st"
					+" AND (CL.FCL1 = '"+par.clCl+"' OR CL.FCL2 = '"+par.clCl+"' OR CL.FCL2 = '"+par.clCl+"')"
					+")"
				ExecuteSQL(strSQL);
				
				ExecuteSQL("ALTER TABLE "+tmpTbl+" ADD COLUMN FCLCL" +sqlType("LONG"));
	
				strSQL = "UPDATE "
							+ " " + tmpTbl + " "
							+ " SET FCLCL = "
								+" ("
									+" SELECT "+IIF("S.FCL3 ='"+par.clCl+"'","3",
												IIF("S.FCL2 ='"+par.clCl+"'","2","1")) + " AS FCLCL" 
									+" FROM "
										+" ^CL_SCHET S"
									+" WHERE 1 = 1 "
									+" AND S.FSCHET = "+corrmode+"_sc"
									+" AND S.FSUBSCHET = "+corrmode+"_su"
									+" AND S.FSTAT = "+corrmode+"_st"							
								+" )"
				ExecuteSQL(strSQL);
				
				
				strSQL = "INSERT INTO "+this.table+"(FSUM, FCOD)"
						+"SELECT "
							+" SUM(FSUM) * "+sqlTo(par.proc/100)
							+","+mode+"_cod1"
						+" from "+tmpTbl+" "
						+ " WHERE fdate BETWEEN " + sqlTo(bDat) + " AND " + sqlTo(eDat)
						+ sqlw0And(mode+"_sc=", oSc.getSc())
						+ sqlw0And(mode+"_su=", oSc.getSu())
						+ sqlw0And(mode+"_st=", oSc.getSt())
						+(par.isKor == true && par.clCod!=0? 
						" AND (("+corrmode+"_cod1="+par.clCod+" AND FCLCL = 1)"
						+" OR ("+corrmode+"_cod2="+par.clCod+" AND FCLCL = 2)"
						+" OR ("+corrmode+"_cod3="+par.clCod+" AND FCLCL = 3))" : "" )
						+" GROUP BY "+mode+"_cod1"
						+" ORDER BY "+mode+"_cod1"
				ExecuteSQL(strSQL);
				
				DropTable(tmpTbl)				
			}
			break;

		case "OB_CORR":
		//Загрузить обороты по корреспонденции счетов
			var bDat = new Date(par.bDat);
			var eDat = new Date(par.eDat);
			var oScDt = par.oScDt;
			var oScCr = par.oScCr;
			
			// выполним расчет оборотов
			// Формирование условия для отбора по счету
			var scDt = oScDt.getSc(), suDt = oScDt.getSu(), stDt = oScDt.getSt(),
				cl1Dt = oScDt.getCl1(), cl2Dt=oScDt.getCl2(), cl3Dt=oScDt.getCl3();
			var scCr = oScCr.getSc(), suCr = oScCr.getSu(), stCr = oScCr.getSt(),
				cl1Cr = oScCr.getCl1(), cl2Cr=oScCr.getCl2(), cl3Cr=oScCr.getCl3();

			var condDt = (scDt? " and fdb_sc=" + scDt: (" and "+sqlTrue))
				+ ( suDt? " and fdb_su=" + suDt: "" )
				+ ( stDt? " and fdb_st=" + stDt: "" )
				+ ( cl1Dt? " and fdb_cod1=" + cl1Dt: "" )
				+ ( cl2Dt? " and fdb_cod2=" + cl2Dt: "" )
				+ ( cl3Dt? " and fdb_cod3=" + cl3Dt: "" );
			var condCr = (scCr? " and fcr_sc=" + scCr: (" and "+sqlTrue))
				+ ( suCr? " and fcr_su=" + suCr: "" )
				+ ( stCr? " and fcr_st=" + stCr: "" )
				+ ( cl1Cr? " and fcr_cod1=" + cl1Cr: "" )
				+ ( cl2Cr? " and fcr_cod2=" + cl2Cr: "" )
				+ ( cl3Cr? " and fcr_cod3=" + cl3Cr: "" );
			
			//Найдем поле, с которого будем снимать код человека - это
	        //та аналитика, к которой привязан справочник this.sprPers
	        var grpByFld = "";
	        if(oScDt.getClcl1() == this.sprPers)
	        {
	        	grpByFld = "FDB_COD1";
	        }
	        else if(oScDt.getClcl2() == this.sprPers)
	        {
	        	grpByFld = "FDB_COD2";
	        }
	        else if(oScDt.getClcl3() == this.sprPers)
	        {
	        	grpByFld = "FDB_COD3";
	        }
	        else if(oScCr.getClcl1() == this.sprPers)
	        {
	        	grpByFld = "FCR_COD1";
	        }
	        else if(oScCr.getClcl2() == this.sprPers)
	        {
	        	grpByFld = "FCR_COD2";
	        }
	        else if(oScCr.getClcl3() == this.sprPers)
	        {
	        	grpByFld = "FCR_COD3";
	        }
	        else
	        {
	        	msg = ru("На выбранных счетах отсутствует аналитика №"
							, "На вибраних рахунках відсутня аналітика №");
				alert(msg+this.sprPers)
	        	return false;
	        }
			
			strSQL = "INSERT INTO "+this.table+"(FSUM, FCOD)"
						+" SELECT"
							+" SUM(FSUM)*"+sqlTo(par.proc/100)+", "+grpByFld
						+" FROM ^SCHET"
						+" WHERE 1=1"
							+condDt
							+condCr
							+" AND FDATE >= "+sqlTo(bDat)
							+" AND FDATE <= "+sqlTo(eDat)
							+(par.isNegative?"":" AND FSUM > 0" )
						+" GROUP BY "+grpByFld
						+" ORDER BY "+grpByFld					
			ExecuteSQL(strSQL);
			break;
	}
	
	//округление сум
	this.toApplyOkr(par.okr);
	return true;
}

function DpMassSum_loadFromCl(mode, par)
{
	var parCl = {};
	parCl.ret = {};
	parCl.Fcl = this.sprPers;
	parCl.Fcod = parCl.ret.Fcod = 0;
	parCl.isZaval = true;

	showWindow("l_cl.xml", SW_MODAL, parCl, "");
	
	if(!parCl.escape)
	{
		if (parCl.retArray != null && typeof(parCl.retArray[0]) != "undefined")
		{
			for (var i in parCl.retArray)
			{
				strSQL = "INSERT INTO"
						+" "+this.table
						+" ("
							+" FCOD"
							+", FSUM"
						+" )"
					+" VALUES"
						+" ("
							+" "+sqlTo(parCl.retArray[i].Fcod)
							+", "+sqlTo(par.sum)
						+" )"
				ExecuteSQL(strSQL);	
			}
		}
		else
		{
			//признак того что отмечена только 1 строка 
			strSQL = "INSERT INTO"
						+" "+this.table
						+" ("
							+" FCOD"
							+", FSUM"
						+" )"
					+" VALUES"
						+" ("
							+" "+sqlTo(parCl.ret.Fcod)
							+", "+sqlTo(par.sum)
						+" )"
			ExecuteSQL(strSQL);	
		}
	}
	
	return true;
}

function DpMassSum_loadFromShtat(mode, par)
{
	//параметры завала в штатное
	var parShtat = {};
	parShtat.isZaval = true;
	parShtat.isMass = true;
	parShtat.dat1 = firstDay(par.dat);
	parShtat.dat2  = lastDay(par.dat);
	
	showWindow("l_shtatRasp.xml", SW_MODAL, parShtat);
	if(!parShtat.escape)
	{
		var aFid = parShtat.ftabn_id; //масив id из справочника 
		var aFidShtat = parShtat.ret; //масив id из штатного
		
		//Tori 15.06.2010: Проставляем также ШПЗ из штатного расписания
		if(aFidShtat.length > 0)
		{
			var tbl = OpenTable("select * from ^full_pers where Fwid in ("+aFidShtat+") order by Fcodpers");
			for(; !tbl.IsEOF(); tbl.MoveNext())
			{
				strSQL = "INSERT INTO"
						+" "+this.table
						+" (FCOD, FSUM, FWID_WP, FSHPZ)"
					+" VALUES"
						+" ("
							+" "+sqlTo(tbl.getValue("Fcodpers"))
							+", "+sqlTo(par.sum)
							+", "+sqlTo(tbl.getValue("Fwid"))
							+", "+sqlTo(tbl.getValue("Fshpz"))
						+" )"
				ExecuteSQL(strSQL);
			}
			tbl.close();
		}
		else
		{
			alert(ru("Ошибка отбора данных!","Помилка відбору даних!"));
			return;
		}
		/*//масив aFid это масив с отмечеными строками штатного 
		for(var i in aFid)
		{
			var strSQL = "SELECT FCOD"
								+" FROM ^CLRELCLCL"
								+" WHERE 1=1"
									+" AND FCL = "+sqlTo(this.sprPers)
									+" AND FWID_CL = "+sqlTo(aFid[i])
			var sn = getSnap(strSQL);
			
			if(sn != null && !isEmpty(sn[0]))
			{
				strSQL = "INSERT INTO"
						+" "+this.table
						+" ("
							+" FCOD"
							+", FSUM"
							+", FWID_WP"
						+" )"
					+" VALUES"
						+" ("
							+" "+sqlTo(sn[0])
							+", "+sqlTo(par.sum)
							+", "+sqlTo(aFidShtat[i])
						+" )"
				ExecuteSQL(strSQL);	
			}
			else
			{
				//Сюда не должны попадать 
				alert(ru("Для записи с FWID_CL = "+aFid[i]+" не найден табельный номер у справочнику №"+this.sprPers
						, "Для запису з FWID_CL = "+aFid[i]+" не знайдено табельного номеру у довіднику №"+this.sprPers));
				continue;
			}
		}*/
	}
	return true;
}

function DpMassSum_loadOklad(mode, par)
{
	var bDat = firstDay(par.dat);
	var eDat = lastDay(par.dat);
	switch (mode)
	{
		case "ALL":
			//при формировании таблицы смотрим на поле O.FPRIZN 
			//O.FPRIZN = 2 (это ЧТС) все остальное это оклад
			//Если ЧТС то умножаем на норму времени которую спросили
			strSQL = "INSERT INTO "+this.table+"(FSUM, FCOD, FWID_WP, FSHPZ)"
					+"SELECT" 
						+" "+IIF("O.FPRIZN = 2", "F.FOKLAD*"+sqlTo(par.nTime), "F.FOKLAD")+"*"+sqlTo(par.proc/100)
						+", F.FCODPERS"
						+", F.FWID"
						+", F.FSHPZ"
					+" FROM ^FULL_PERS F LEFT JOIN ^OPL_PRIZ O ON F.FVOPL = O.FVOPL"
					+" WHERE 1=1"
						+" AND F.FBDAT <= "+sqlTo(bDat)
						+" AND F.FEDAT >= "+sqlTo(eDat)
			ExecuteSQL(strSQL);
			break;
		
		case "ZAVAL":
			//сначала делаем завал в штатное 
			var _par = {};
			_par.dat = par.dat;
			_par.sum = 0;
			this.loadFromShtat("", _par)
			
			//когда получили записи из штатного 
			//опдейтим сумы 
			var opTbl = OpenTable(this.table)
			if(opTbl.recordCount > 0)
			{
				for(; !opTbl.IsEOF(); opTbl.MoveNext())
				{
					strSQL  = "SELECT" 
								+" "+IIF("O.FPRIZN = 2", "F.FOKLAD*"+sqlTo(par.nTime), "F.FOKLAD")+"*"+sqlTo(par.proc/100)+" AS FSUM"
								+", F.FCODPERS AS FCOD"
							+" FROM ^FULL_PERS F LEFT JOIN ^OPL_PRIZ O ON F.FVOPL = O.FVOPL"
							+" WHERE 1=1"
								+" AND F.FBDAT <= "+sqlTo(bDat)
								+" AND F.FEDAT >= "+sqlTo(eDat)
								+" AND F.FCODPERS = "+sqlTo(opTbl.getValue("FCOD"))
					var sn = getSnap(strSQL);
					if(sn != null && !isEmpty(sn[1]))
					{
						opTbl.Edit();
						opTbl.setValue("FSUM", sn[0]);
						opTbl.Update();
					}
					else
					{
						//Сюда не должны попадать 
						alert(ru("Для записи с кодом FCOD = "+opTbl.getValue("FCOD")+" не найдена запись в штатном"
								, "Для запису з кодом FCOD = "+opTbl.getValue("FCOD")+" не знайдено запису в штатному"));
					}
					
				}
			}
			opTbl.Close(5652);
			opTbl = null;
			break;
		default:
			break;
	}
	
	if(!par.isLdSum0)
	{
		ExecuteSQL("DELETE FROM "+this.table+" WHERE FSUM <= 0");
	}
	
	this.toApplyOkr(par.okr);
	return true;
}

function DpMassSum_loadFromSvodZP(mode, par)
{
	//проверка на наличие нужной таблицы по своду 
	svzpName = "SVZP"+month_txt(par.dat);
	if (!IsTableEx("ZRP_RES","ZRP_"+svzpName))
	{
		
		alert(ru("Отсутствуют результаты расчета зарплаты за "
				, "Відсутні результати розрахунку заробітної плати за ")
				+tmonth(par.dat, 3)+" "+new Date(par.dat).getFullYear());
		return;
	}
	
	var sWhere = "";
	switch(Number(par.mode_load))
	{
		case 1://загружаем отмеченные из списка
			var objpar = Object();
			objpar.isZaval = true;
			objpar.dat1 = firstDayMonth(par.dat);
			objpar.dat2 = lastDayMonth(par.dat);
	    	objpar.flsfid = par.lsFid;
	    	objpar.flsnum = getLsNum(par.lsFid);
	    	objpar.fshpz = null;
	    	objpar.sFrom = "";
	    	objpar.sWhere = "";
	    	objpar.datkv = firstDayMonth(par.dat);
	   		showWindow("r_svodls.xml",SW_MODAL,objpar);
	   		if(objpar.escape)
	   			return;
			if(objpar.ftabn_id && objpar.ftabn_id.length>0)
				sWhere = " and s.Ftabn_id in ("+objpar.ftabn_id+")";
			else
			{
				alert(ru("Ошибка отбора данных!","Помилка відбору даних!"));
				return;
			}
		break;
		case 2://загружаем отмеченные из списка по конкретным подразделениям
			var objpar = Object();
			objpar.isZaval = true;
			objpar.dat1 = firstDayMonth(par.dat);
			objpar.dat2 = lastDayMonth(par.dat);
	    	objpar.flsfid = par.lsFid;
	    	objpar.flsnum = getLsNum(par.lsFid);
	    	objpar.fshpz = null;
	    	objpar.sFrom = "";
	    	objpar.sWhere = "";
	    	objpar.datkv = firstDayMonth(par.dat);
			
			var oPar = new Object();
			oPar.zaval = true;
			oPar.escape = false;
			oPar.ret = new Object();
			oPar.ret.fwid = 0;
			oPar.ret.fleftkey = 0;
			oPar.ret.frightkey = 0;
			oPar.dat = objpar.dat1;
			showWindow("l_struOrg.js",SW_MODAL,oPar);
			if(!oPar.escape)
			{
				is_rsc_pd = true;
				if(oPar.retArray.length==0)
				{
					fleftkeys = oPar.ret.fleftkey;
					frightkeys = oPar.ret.frightkey;
					objpar.sWhere = " O.Fleftkey>="+fleftkeys+" AND O.Frightkey<="+frightkeys+" ";
				}
				else
				{
					fleftkeys = new Array();
					frightkeys = new Array();
					for(var i=0; i<oPar.retArray.length; i++)
					{
						for(var j in oPar.retArray[i])
						{
							if(j=="fleftkey")
								fleftkeys[i] = oPar.retArray[i][j];
							else
								if(j=="frightkey")
									frightkeys[i] = oPar.retArray[i][j];
						}
					
					}
					for(var i=0; i<fleftkeys.length; i++)
					{
						if(i==0)
							objpar.sWhere = "((O.Fleftkey>="+fleftkeys[i]+" AND O.Frightkey<="+frightkeys[i]+") "
						else
							objpar.sWhere += "OR (O.Fleftkey>="+fleftkeys[i]+" AND O.Frightkey<="+frightkeys[i]+") "
					}
					objpar.sWhere += ") ";
				}
				objpar.sWhere = " AND W.Fedat=(SELECT MAX(Fedat) FROM ^WORK_PERS AS W2 WHERE "
							+"W2.Fbdat<="+sqlTo(objpar.dat2)+" AND W2.Fedat>="+sqlTo(objpar.dat1) +" AND W.Fwid_cl=W2.Fwid_cl)"
						+" AND W.Fbdat<="+sqlTo(objpar.dat2)+" AND W.Fedat>="+sqlTo(objpar.dat1) +" AND "+ objpar.sWhere;
			}
			else
				return false;
			objpar.sFrom = " INNER JOIN ^WORK_PERS AS W ON P.Ftabn_id=W.Fwid_cl "
     						+" INNER JOIN ^STRU_DOL AS S ON W.Fwid_dol=S.Fwid "
	     					+" INNER JOIN ^STRU_ORG AS O ON S.Fwid_org=O.Fwid ";
	     	
	     	showWindow("r_svodls.xml",SW_MODAL,objpar);
	   		if(objpar.escape)
	   			return;
			if(objpar.ftabn_id && objpar.ftabn_id.length>0)
				sWhere = " and s.Ftabn_id in ("+objpar.ftabn_id+")";
			else
			{
				alert(ru("Ошибка отбора данных!","Помилка відбору даних!"));
				return;
			}
		break;
	}
	//Tori 14.06.2010: из лицевых счетов также проставляем ШПЗ, если ШПЗ был жестко указан, то он перебьется при записи доп.параметров
	strSQL = "INSERT INTO "+this.table+"(FSUM, FCOD, FSHPZ)"
				+" SELECT" 
					+" "+sqlRound("SUM(S.FSUM)*"+sqlTo(par.proc/100), 2)
					+", REL.FCOD"
					+", S.FSHPZ"
				+" FROM ^"+svzpName+" S LEFT JOIN ^CLRELCLCL REL ON S.FTABN_ID = REL.FWID_CL"
				+" WHERE 1=1"
					+" AND S.FLSFID = "+sqlTo(par.lsFid)
					+" AND REL.FCL = "+sqlTo(this.sprPers)
					//Взято из свода по ЛС
					+" AND NOT(S.Fvp=1 AND S.Fmn>="+sqlTo(firstDayMonth(par.dat))+") "					
					+sWhere
				+" GROUP BY"
					+" REL.FCOD, S.FSHPZ"
				+" ORDER BY REL.FCOD"
	ExecuteSQL(strSQL);
	
	//проставим FWID_WP если стоит галочка расчеты по ЗП
	if(this.isUseZp)
	{
		var bDat = firstDay(par.dat);
		var eDat = lastDay(par.dat);
		oShtat = new DpShtat("", bDat, eDat);
		
		var opTbl = new OpenTable(this.table)
		for(; !opTbl.IsEOF(); opTbl.MoveNext())
		{
			/*
			oShtat.arrCtrls = new Array();
			oShtat.arrCtrls["fcod"] = new Object(this.value = 0)
			oShtat.arrCtrls["fcod"].value = opTbl.getValue("FCOD");
			if(oShtat.validCod())
			{
				opTbl.Edit();
				opTbl.setValue("FWID_WP", oShtat.getFwid());
				opTbl.Update();
			}
			*/
			oShtat.setEmployeCod(opTbl.getValue("FCOD"));
			
			opTbl.Edit();
			opTbl.setValue("FWID_WP", oShtat.getFwid());
			opTbl.Update();
		}
		opTbl.Close(5652);
		opTbl = null;
	}
	this.toApplyOkr(par.okr);
	return true;
}

function DpMassSum_askDopPar(oA)
{
	//Если есть хоть 1 доп. параметр то рисуем линию
	if(!isEmpty(this.sprPodr) || !isEmpty(this.sprSelo)  || !isEmpty(this.sprGaluz) || this.isUseShpz)
	{
		oA.add("HR");
	}
	
	//спрашиваем 
	if(!isEmpty(this.sprPodr))
	{
		oA.add("CL", "Підрозділ|Подразделение", "PODR", 0, this.sprPodr);
	}
	if(!isEmpty(this.sprSelo))
	{
		oA.add("CL", "Село", "SELO", 0, this.sprSelo);
	}
	if(!isEmpty(this.sprGaluz))
	{
		oA.add("CL", "Галузь витрат|Отрасль затрат", "GALUZ", 0, this.sprGaluz);
	}
	if(this.isUseShpz)
	{
		oA.add("SHPZ", "ШВВ|ШПЗ", "SHPZ", 0);
	}
	if(this.isUseDay)
	{
		oA.add("NUM", "Дні|Дни", "DAY", 0, 5, 2);
	}
	if(this.isUseHour)
	{
		oA.add("NUM", "Години|Часы", "HOUR", 0, 5, 2);
	}
		
	return oA;
}

function DpMassSum_writeDopPar(oA)
{
	var podr = 0;
	var selo = 0;
	var galuz = 0;
	var idShpz = 0;
	var day = 0;
	var hour = 0;
	
	if(!isEmpty(this.sprPodr))
	{
		podr = oA.get("PODR").getCod();
	}
	if(!isEmpty(this.sprSelo))
	{
		selo = oA.get("SELO").getCod();
	}
	if(!isEmpty(this.sprGaluz))
	{
		galuz = oA.get("GALUZ").getCod();
	}
	if(this.isUseShpz)
	{
		idShpz = oA.get("SHPZ").getFshpz();
	}
	if(this.isUseDay)
	{
		day = oA.get("DAY");
	}
	if(this.isUseHour)
	{
		hour = oA.get("HOUR");
	}
	
	strSQL = "UPDATE "+this.table
					+" SET FPODR = "+sqlTo(podr)
					+", FSELO = "+sqlTo(selo)
					+", FGALUZ = "+sqlTo(galuz)
					+(Number(idShpz)!=0 && idShpz!="NaN"?", FSHPZ = "+sqlTo(idShpz):"")
					+", FDAY = "+sqlTo(day)
					+", FHOUR = "+sqlTo(hour)
				+" WHERE 1=1"
	ExecuteSQL(strSQL);
	
	return true;
}

//округляет сумы
function DpMassSum_toApplyOkr(okr)
{
	okr = Number(okr);
	if(IsTable(this.table))
	{
		var opTbl = OpenTable(this.table)
		for(; !opTbl.IsEOF(); opTbl.MoveNext())
		{
			opTbl.Edit();
			sum = opTbl.getValue("FSUM");

			// ОКРУГЛЕНИЕ
			switch(okr)
			{
				case 0:
					sum = Math.floor(sum/50)*50;
					break;
				case 1:
					sum = Math.floor(sum/10)*10;
					break;
				case 2:
					sum = Math.floor(sum/5)*5;
					break;
				case 3:
					sum = Math.floor(sum);
					break;
				case 4:
				default:
					sum = round(sum, 2);
					break;
			}
			if (sum <= 0)
			{
				continue;
			}
			opTbl.setValue("FSUM", sum);
			opTbl.Update();
		}
	}
}

function DpMassSum_setMode(mode)
{
	if(typeof(mode) == "string" && !isEmpty(mode))
	{
		this.mode = mode.toUpperCase();
	}
	else
	{
		//все пункты меню
		this.mode = "FPBS";
	}
}

function DpMassSum_setSprPers(num)
{
	if(typeof(num) == "number" && !isEmpty(num))
	{
		this.sprPers = num;
	}
	else
	{
		this.sprPers = getPar("CODPERS");
	}
	
	return true;
}

function DpMassSum_setSprPodr(num)
{
	if(typeof(num) == "number" && !isEmpty(num))
	{
		this.sprPodr = num;
	}
	else
	{
		this.sprPodr = 0;
	}
	
	return true;
}

function DpMassSum_setSprSelo(num)
{
	if(typeof(num) == "number" && !isEmpty(num))
	{
		this.sprSelo = num;
	}
	else
	{
		this.sprSelo = 0;
	}
	
	return true;
}

function DpMassSum_setSprGaluz(num)
{
	if(typeof(num) == "number" && !isEmpty(num))
	{
		this.sprGaluz = num;
	}
	else
	{
		this.sprGaluz = 0;
	}
	
	return true;
}

function DpMassSum_setUseShpz(bool)
{
	if(typeof(bool) == "boolean")
	{
		this.isUseShpz = bool;
	}
	else
	{
		this.isUseShpz = false;
	}
}

function DpMassSum_setUseDay(bool)
{
	if(typeof(bool) == "boolean")
	{
		this.isUseDay = bool;
	}
	else
	{
		this.isUseDay = false;
	}
}

function DpMassSum_setUseHour(bool)
{
	if(typeof(bool) == "boolean")
	{
		this.isUseHour = bool;
	}
	else
	{
		this.isUseHour = false;
	}
}

function DpMassSum_setUseZp(bool)
{
	if(typeof(bool) == "boolean")
	{
		this.isUseZp = bool;
	}
	else
	{
		this.isUseZp = false;
	}
}

function DpMassSum_setUseShtat(bool)
{
	if(typeof(bool) == "boolean")
	{
		this.isUseShtat = bool;
	}
	else
	{
		this.isUseShtat = false;
	}
}

function DpMassSum_getMode()
{
	return this.mode;
}

function DpMassSum_getTable()
{
	var ret = null;
	if(IsTable(this.table))
	{
		ret = this.table;
	}
	
	return ret;	
}

function ClNum_Valid()
{
	if (this.aQryList["CLNUM"].value.getCod() != this.aQryList["COD"].value.getClcl())
	{
		this.aQryList["COD"].value.setClcl(this.aQryList["CLNUM"].value.getCod());

		this.aQryList["COD"].value.setCod(0);
	}
	return true;
}