/*
   Описание объекта "Message Box": DpMsgBox
   (C) ДЕБЕТ Плюс, 1998-1999

   Конструктор DpMsgBox.

   Внешние методы:
   .set(mode,txt,title)- Установка кнопок
   .ask()              - Вывод сообщения и получение ответа
   .ask_all()          - Установлен ли флажок ДЛЯ ВСЕХ

   Внутренние свойства:
   .buttons            - Массив кнопок
   .title              - Название окна
   .txt                - Текст сообщения
   .all                - Ставить ли строку ДЛЯ ВСЕХ
   .all_check          - Выбран ли пункт ДЛЯ ВСЕХ
   .len                - Количество кнопок
   .mode               - Режим    
   .res                - Что вернул MsgBox
     
   mode:      
      "o" 		- Продолжить
      "c" 		- Отмена
      "r" 		- Повтор
      "i" 		- Игнор.
      "s" 		- Останов
      "q" 		- Выход
      "y" 		- Да
      "n" 		- Нет
      "a" 		- Все
      "+" 		- Добавить
      "-" 		- Удалить
      "*" 		- Исправить
      "k" 		- Пропустить
      "p" 		- Открыть
      "t" 		- Следующий
      "f" 		- Найти
      "z"		- Заменить
      "!"       - возможность проставить флажок "Применить ко всем"
      "&"       - Значок перед буквой, которую следует возвращать по умолчанию 
      "^"       - Значок перед буквой, которую следует возвращать по Escape
*/

// Конструктор объекта DpMsgBox
function DpMsgBox(mode, txt, title)
{
	RO("DpMsgBox", this);
   this.set     = DpMsgBox_set; 
   this.ask     = DpMsgBox_ask;
   this.ask_all = DpMsgBox_ask_all;
   if(mode)
	 this.set(mode, txt, title);
}

function DpMsgBox_set(mode,txt,title)
{
 this.buttons = new Array();
 this.len    = mode.length;
 this.all   = false;
 this.title = title;
 this.txt   = txt;
 this.mode  = mode;
 this.defbut = -1;
 this.escbut = -1;
 this.all_check = false;
 var j = 0;
 
 for(var i = 0; i < mode.length; i++)
  { 
    if((this.defbut < 0) && (mode.substr(i,1) == "&"))
     {
      this.defbut = i;
      i++;
     }
    
    switch(mode.substr(i,1))
     {
		case "o":
            this.buttons[j] = new Object()
            this.buttons[j].sokr = "o"
            this.buttons[j].full = ru("Продолжить","Продовжити")
             break;
		case "c":
            this.buttons[j] = new Object()
            this.buttons[j].sokr = "c"
            this.buttons[j].full = ru("Отмена","Відмінити")
             break;
		case "r":
            this.buttons[j] = new Object()
            this.buttons[j].sokr = "r"
            this.buttons[j].full = "Повтор" 
             break;
		case "i":
            this.buttons[j] = new Object()
            this.buttons[j].sokr = "i"
            this.buttons[j].full = ru("Игнорировать","Ігнорувати")
             break;
		case "s":
            this.buttons[j] = new Object()
            this.buttons[j].sokr = "s"
            this.buttons[j].full = ru("Остановить","Зупинити")
             break;
		case "q":
            this.buttons[j] = new Object()
            this.buttons[j].sokr = "q"
            this.buttons[j].full = ru("Выход","Вихід")
             break;
		case "y":
            this.buttons[j] = new Object()
            this.buttons[j].sokr = "y"
            this.buttons[j].full = ru("Да","Так")
             break;
		case "n":
            this.buttons[j] = new Object()
            this.buttons[j].sokr = "n"
            this.buttons[j].full = ru("Нет","Ні")
             break;
             break;
		case "a":
            this.buttons[j] = new Object()
            this.buttons[j].sokr = "a"
            this.buttons[j].full = ru("Все","Усі")
             break;
		case "+":
            this.buttons[j] = new Object()
            this.buttons[j].sokr = "+"
            this.buttons[j].full = ru("Добавить","Додати")
             break;
		case "-":
            this.buttons[j] = new Object()
            this.buttons[j].sokr = "-"
            this.buttons[j].full = ru("Удалить","Вилучити")
             break;
		case "*":
            this.buttons[j] = new Object()
            this.buttons[j].sokr = "*"
            this.buttons[j].full = ru("Исправить","Виправити")
             break;
		case "k":
            this.buttons[j] = new Object()
            this.buttons[j].sokr = "k"
            this.buttons[j].full = ru("Пропустить","Пропустити")
             break;
		case "p":
            this.buttons[j] = new Object()
            this.buttons[j].sokr = "p"
            this.buttons[j].full = ru("Открыть","Відкрити")
             break;
		case "t":
            this.buttons[j] = new Object()
            this.buttons[j].sokr = "t"
            this.buttons[j].full = ru("Следующий","Наступний")
             break;
        case "z":
			this.buttons[j] = new Object();
            this.buttons[j].sokr = "z";
            this.buttons[j].full = ru("Заменить","Замінити");
             break;
		case "f":
            this.buttons[j] = new Object()
            this.buttons[j].sokr = "f"
            this.buttons[j].full = ru("Найти","Знайти")
             break;
		case "!":
            this.all = true;
            j--;
            break;
       case "^":
            this.escbut = i;
            j--;
             break;
       default:
         debug("Ошибочная буква в режиме: '" + mode.substr(i,1) + "'");
     }
    j++; 
  }
 if(strIn("&", this.mode)) this.len--; 
 if(strIn("!", this.mode)) this.len--; 
 if(strIn("^", this.mode)) this.len--; 
}

function DpMsgBox_ask()
{
  var s = "";
  for(var i = 0;i < this.len; i++)
  s += ",'"+this.buttons[i].full+"'";
  
  if(!this.all_check)
  {
  /* 
   if(!this.all)
    this.res = eval("_msgbox(MSG_T_LEFT|MSG_B_MAX, this.txt, this.title"+ s +")") 
   else
    this.res = eval("_msgboxEx(MSG_T_LEFT|MSG_B_MAX, this.txt, this.title, ru('Для всех','Для всіх')"+ s +")") 
    */
    if (typeOf(FORM) == "DpXMLDialog")
    	this.res = String(lpProxy.msgBox(FORM.getShell(), this.mode,this.txt, this.title));
    else
    	this.res = String(lpProxy.msgBox( this.mode,this.txt, this.title));
   return this.res;
  }
  
  if(this.res != -1)
   if(!this.all)
    return this.buttons[this.res].sokr;
   else
    {
     if(this.res < 10)
      {
       this.all_check = false; 
       return this.buttons[this.res].sokr;
      } 
     else 
      {
       this.all_check = true; 
       return this.buttons[this.res-10].sokr;
      } 
    } 
  else
   {
    //if(this.defbut >= 0) return this.buttons[this.defbut].sokr;
    if(this.escbut >= 0) return this.buttons[this.escbut].sokr;
     
    if(strIn("i", this.mode)) return "i";

    if(strIn("r", this.mode)) return "r";

    if(strIn("c", this.mode)) return "c";

    if(strIn("n", this.mode)) return "n";
   }  
} 

function DpMsgBox_ask_all()
{
  return this.all_check;
} 
