function DpObject(sClassId,jObj)
{
	this.sClassId = sClassId;
	this.jObj = jObj;
	this.getVar = DpObject_getVar;
	this.setVar = DpObject_setVar;
	
	
	this.getCaption = DpObject_getName;
	
	//this.eval = DpObject_eval;
	

	this.createRow = DpObject_createRow;
	this.copyRow = DpObject_copyRow;
	this.appendRow = DpObject_appendRow;
	this.deleteRow = DpObject_deleteRow;
	this.getRow = DpObject_getRow;
	
	this.getVarsInfo = DpObject_getVarsInfo;
	this.getChildIDs = DpObject_getChildIDs;
	this.getChildClasses = DpObject_getChildClasses;
	this.getVarInfo = DpObject_getVarInfo;
	this.getDataDir = DpObject_getDataDir;
	this.getName = DpObject_getName;
	
	this.getID = DpObject_getID;		
	this.setID = DpObject_setID;
	
	this.isAbstract = DpObject_isAbstract;
	this.instanceOf = DpObject_instanceOf;
	
	this.setAttr = DpObject_setAttr;
	this.setAttribute = DpObject_setAttribute;
	this.getAttribute = DpObject_getAttribute;
	this.getJObject = DpObject_getJObject;
	
	this.setCtrlLinker = DpObject_setCtrlLinker;
	this.getCtrlLinker = DpObject_getCtrlLinker;
	this.ctrlLinker = null;	
	
	this.bNew = true;
}

function DpObject_getVar(sVar)
{
	return this.jObj.getVar(sVar);
}

function DpObject_setVar(sVar,oVal)
{
	this.jObj.setVar(sVar,oVal);
}

function DpObject_getChildIDs()
{
	return this.jObj.getChildIDs();
}

function DpObject_getChildClasses()
{
	if (this.jObj)
		return this.jObj.getChildClasses();
	return new Array();
}


function DpObject_getName()
{
	return String(this.jObj.getName());
}


function DpObject_isAbstract()
{
	return this.jObj.isAbstract() == true;
}


function DpObject_getID()
{
	return toScrObj(this.jObj.getObjectID());
}

function DpObject_setID(nID)
{
	this.jObj.setObjectID(nID);
}

function DpObject_getVarInfo(sVar)
{
	return this.jObj.getVarInfo(sVar);
}

function DpObject_getVarsInfo()
{
	return this.jObj.getVarsInfo();
	
}

function DpObject_instanceOf(sClassID)
{
	return toScrObj(this.jObj.instanceOf(sClassID));
}

function DpObject_eval(sExpr)
{
	//return toScrObj(this.jObj.eval(sExpr));
}


function DpObject_getDataDir()
{
	return String(this.jObj.getDataDir());
}

function DpObject_createRow(sClassID)
{
	var jRow = this.jObj.createChild(sClassID);

	if (jRow != null)
		return	new DpObject(this,jRow);
	else
		return null;
}

function DpObject_getRow(sClassID, nObjectID)
{
	var jRow = this.jObj.getChild(sClassID,nObjectID);
	if (jRow != null)
		return	new DpObject(this,jRow);
	else
		return null;
}

function DpObject_copyRow(sClassID,nObjectID)
{
	var jRow = this.jObj.getChild(sClassID,nObjectID);
	if (jRow != null)
		return	new DpObject(this,jRow.clone());
	else
		return null;	
} 

function DpObject_appendRow(sClassId, obj)
{
	return this.jObj.appendChild(sClassId,obj.jObj,obj.getID());
}

function DpObject_deleteRow(sClassId, nObjectID)
{
	return this.jObj.removeChild(sClassId, nObjectID)
}

function DpObject_setAttribute(sAttrName, attrValue)
{
	toScrObj(this.jObj.setAttribute(sAttrName, attrValue));
}

function DpObject_getAttribute(sAttrName)
{
	return toScrObj(this.jObj.getAttribute(sAttrName));
}

function DpObject_getJObject()
{
	return this.jObj;
}

function DpObject_setCtrlLinker(ctrlLinker)
{
	this.ctrlLinker = ctrlLinker;	
}

function DpObject_getCtrlLinker()
{
	return this.ctrlLinker;
}

function DpObject_setAttr(sAttr, oValue)
{
	toScrObj(this.jObj.setAttr(sAttr, oValue));
}
