include("servis/format.js");

DpObjectViewer.prototype.getObject = DpObjectViewer_getObject;
DpObjectViewer.prototype.getExtList = DpObjectViewer_getExtList;
DpObjectViewer.prototype.getVarList = DpObjectViewer_getVarList;
DpObjectViewer.prototype.TREE_canEdit = DpObjectViewer_TREE_canEdit;
DpObjectViewer.prototype.TREE_fill = DpObjectViewer_TREE_fill;
DpObjectViewer.prototype.TREE_parseItemID = DpObjectViewer_TREE_parseItemID;
DpObjectViewer.prototype.TREE_editPrepare = DpObjectViewer_TREE_editPrepare;
DpObjectViewer.prototype.TREE_save = DpObjectViewer_TREE_save;
DpObjectViewer.prototype.linkToTree = DpObjectViewer_linkToTree;
DpObjectViewer.prototype.setFilterCalcVars = DpObjectViewer_setFilterCalcVars;
DpObjectViewer.prototype.linkToTreeNode = DpObjectViewer_linkToTreeNode;
DpObjectViewer.prototype.getObject = DpObjectViewer_getObject;
DpObjectViewer.prototype.getValue = DpObjectViewer_getValue;
DpObjectViewer.prototype.setValue = DpObjectViewer_setValue;
DpObjectViewer.prototype.getChildClasses = DpObjectViewer_getChildClasses;
DpObjectViewer.prototype.getChildIDs = DpObjectViewer_getChildIDs;
DpObjectViewer.prototype.getDescription = DpObjectViewer_getDescription;

function DpObjectViewer(oDpObject)
{
	this.dpObject = oDpObject;
	this.bFilterCalcVars = true;
}

function DpObjectViewer_getObject()
{
	return this.dpObject;
}

function DpObjectViewer_getVarList()
{
	var tmpArr = this.dpObject.getVarsInfo();
	var vArr = new Array();
	for (var nV = 0; nV < tmpArr.length; nV++)
		if (!this.bFilterCalcVars || !tmpArr[nV].isCalc)
			vArr[vArr.length] = tmpArr[nV].name;
	vArr.sort();
	return vArr;
}

function DpObjectViewer_getExtList()
{	
	var retArr = new Array();
	if (typeof(this.dpObject.getExtInfo) != "function")
		return retArr;
	var extArr = this.dpObject.getExtInfo();
	for (var extName in extArr)
		retArr[retArr.length] = extName;
	return retArr.sort();
}

function DpObjectViewer_linkToTree(oTree)
{
	oTree.addColumn("text","",200);
	oTree.addColumn("value","",100);
	
	this.sTREE_prefix = "HEAD";
	
	this.TREE_fill(oTree,"0");
	
	oTree.setCanEditHandler(this,"TREE_canEdit");
	oTree.setPrepareEditorHandler(this,"TREE_editPrepare");
	oTree.setSaveHandler(this,"TREE_save");
}

function DpObjectViewer_linkToTreeNode(oTree,sNodeID)
{
	this.sTREE_prefix = (this.dpObject.sDocLbl?this.dpObject.sDocLbl:this.dpObject.sClassID)
					    + "__" + this.dpObject.getID();
	this.TREE_fill(oTree,sNodeID);
}

function DpObjectViewer_TREE_save(sItem,sCol,nVal)
{
	var ppID = this.TREE_parseItemID(sItem);
	if (ppID.Group == "HEAD")
	{
		if (ppID.SubGroup == "VAR")
			this.dpObject.setVar(ppID.Entry,nVal);
		if (ppID.SubGroup == "EXT")
			this.dpObject.setExt(ppID.Entry,nVal);
		return true;
	}
}

function DpObjectViewer_TREE_editPrepare(sItem,sCol,oCompos,strVal)
{
	var TYPE_TEXT = 1;
	var TYPE_NUMBER = 2;
	var TYPE_DATE = 3;
	var TYPE_DOUBLE = 4;
	var TYPE_BOOLEAN = 5;

	var ppID = this.TREE_parseItemID(sItem);
	if (ppID.Group == "HEAD")
	{
		var etalonValue = null;
		var realValue = null;
		if (ppID.SubGroup == "VAR")
		{
			var vi = this.dpObject.getVarInfo(ppID.Entry);
			if (vi.dataType == TYPE_NUMBER || vi.dataType == TYPE_DOUBLE)
				etalonValue = 0;
			else if (vi.dataType == TYPE_DATE)
				etalonValue = new Date();
			else if (vi.dataType == TYPE_BOOLEAN)
				etalonValue = true;
			else etalonValue = "";
			
			realValue = this.dpObject.getVar(ppID.Entry);
		}
		if (ppID.SubGroup == "EXT")
		{
			realValue = etalonValue = this.dpObject.getExt(ppID.Entry);
		}
		etalonValue = etalonValue;
		var type = typeOf(etalonValue).toLowerCase();
		var dlgBuilder = FORM.getDialogBuilder();
		if (type == "date" || type == "object")
		{
			var dat = dlgBuilder.addDate(oCompos,"","");
			dat.setValue(realValue);
			return dat;
		}
		if (type == "boolean")
		{
			var chk = dlgBuilder.addCheckBox(oCompos,"","");
			chk.setValue(realValue);
			return chk;
		}
		var tx = dlgBuilder.addTextField(oCompos,"","",70);
		if (type == "number" || type == "double" || type == "integer")
			tx.setMask("#.####");
		tx.setValue(realValue);
		return tx;
	}
}

function DpObjectViewer_TREE_fill(oTree,sRootID)
{
	var arrVars = this.getVarList();
	if (arrVars.length > 0)
	{
		oTree.addItem(sRootID,this.sTREE_prefix + "#VARS",UR("Змінні|Переменные"));
		for (var nVar = 0; nVar < arrVars.length; nVar++)
		{
			var vi = this.dpObject.getVarInfo(arrVars[nVar]);
			var sItmID = this.sTREE_prefix + "#VAR#" + arrVars[nVar];
			var sVarRem = (String(vi.getRem()).length > 0?" ( " + vi.getRem() + " )":"");
			oTree.addItem(this.sTREE_prefix + "#VARS",sItmID,arrVars[nVar] + sVarRem,3);
			var value = this.dpObject.getVar(arrVars[nVar]);
			if (typeOf(value) == "Date")
				value = format("dd.mm.yyyy",value);
			oTree.setValue(sItmID,"value",(value == null?"":value));
		}
	}
	
	var arrExt = this.getExtList();
	if (arrExt.length > 0)
	{
		oTree.addItem(sRootID,this.sTREE_prefix + "#EXTS",UR("Розширення|Расширения"));
		for (var nExt = 0; nExt < arrExt.length; nExt++)
		{
			var ei = this.dpObject.getExtInfo()[arrExt[nExt]];
			var sItmID = this.sTREE_prefix + "#EXT#" + arrExt[nExt];
			var sExtRem = (ei.E_FieldText?" ( " + ei.E_FieldText + " ) ":"");
			oTree.addItem(this.sTREE_prefix + "#EXTS",sItmID,arrExt[nExt] + sExtRem,3);
			var value = this.dpObject.getExt(arrExt[nExt]);
			if (typeOf(value) == "Date")
				value = format("dd.mm.yyyy",value);
			oTree.setValue(sItmID,"value",(value == null?"":value));
		}
	}
	
	var jObj = (this.dpObject.jDoc?this.dpObject.jDoc:this.dpObject.jObj);	
	var classes = jObj.getChildIDs();
	if (classes.length > 0)
	{
		for (var nClass = 0; nClass < classes.length; nClass++)
		{
			var rowsIter = jObj.getRowsIterator(classes[nClass]);
			while(rowsIter.hasNext())
			{
				var rowID = rowsIter.next().getObjectID();

				var sItmID = this.sTREE_prefix + "#" + classes[nClass] + "__" + rowID;
				oTree.addItem(sRootID,sItmID,classes[nClass] + " - " + rowID);

				var currRow = this.dpObject.getRow(classes[nClass],rowID);
				var oV = new DpObjectViewer(currRow);
				oV.linkToTreeNode(oTree,sItmID);
			}
		}
	}
}

function DpObjectViewer_TREE_canEdit(sItmID,sColID)
{
	return false;
	if (sColID != "value")
		return false;
	var ppID = this.TREE_parseItemID(sItmID);
	if (ppID.Group == "HEAD")
	{
		if (ppID.SubGroup == "EXT")
			return true;
		if (ppID.SubGroup == "VAR")
			return !this.dpObject.getVarInfo(ppID.Entry).isCalc;
	}
}

function DpObjectViewer_TREE_parseItemID(sItmID)
{
	sItmID = String(sItmID);
	var grpArr = new Array();
	while(sItmID.length > 0 && sItmID.indexOf("#") > 0)
	{
		var nInd = sItmID.indexOf("#");
		grpArr[grpArr.length] = sItmID.substring(0,nInd);
		sItmID = sItmID.substr(nInd + 1);
	}
	grpArr[grpArr.length] = sItmID;
	
	var retObj = new Object();
	retObj.Group = grpArr[0];
	retObj.SubGroup = grpArr[1];
	retObj.Entry = grpArr[2];
	
	return retObj;
}

function DpObjectViewer_setFilterCalcVars(bFilter)
{
	this.bFilterCalcVars = bFilter;
}

function DpObjectViewer_getObject(sGroup,nID)
{
	sGroup = String(sGroup).toUpperCase();
	if (sGroup == "HEAD")
		return this.dpObject;
	return this.dpObject.getRow(sGroup,nID);
}
//ex:  HEAD,null,VAR,HDOC
//ex:  ROW,123,VAR,RSUM
//ex:  ROW,123,null
function DpObjectViewer_getValue(sGroup,nID,sSubGroup,sVar)
{
	var oObj = this.getObject(sGroup,nID);
	if (oObj == null)
		return null;
	if (sSubGroup == "VAR")
		return oObj.getVar(sVar);
	if (sSubGroup == "EXT")
		return oObj.getExt(sVar);
	if (sSubGroup == null)
		return oObj;
	return null;
}

function DpObjectViewer_setValue(sGroup,nID,sSubGroup,sVar,oValue)
{
	var oObj = this.getObject(sGroup,nID);
	if (oObj != null && sSubGroup == "VAR")
	{
		oObj.setVar(sVar,oValue);
		return true;
	}
	if (oObj != null && sSubGroup == "EXT")
	{
		oObj.setExt(sVar,oValue);
		return true;
	}
	if (!sSubGroup && !sVar && sGroup != "HEAD")
	{
		if (oValue == null)
		{
			// remove row
			this.getObject("HEAD").deleteRow(sGroup,nID);
			return true;
		}
		else
		{
			// add row
			if (nID && nID > 0)
			{
				oValue.setID(nID);
			}
			else if (oObj != null)
			{
				oValue.setID(oObj.getID());
			}
			if (oObj != null)
			{
				this.getObject("HEAD").deleteRow(sGroup,oObj.getID());
			}
			
			this.getObject("HEAD").appendRow(sGroup,oValue);
			return true;
		}
	}
	else
		return false;
	
	return false;
}

function DpObjectViewer_getChildClasses()
{
	var jObj = (this.dpObject.jDoc?this.dpObject.jDoc:this.dpObject.jObj);	
	return jObj.getChildIDs();
}

function DpObjectViewer_getChildIDs(sClass)
{
	var retArr = new Array();
	var jObj = (this.dpObject.jDoc?this.dpObject.jDoc:this.dpObject.jObj);
	var rIter = jObj.getRowsIterator(sClass);
	if (rIter == null)
		return retArr;
	while(rIter.hasNext())
		retArr[retArr.length] = rIter.next().getObjectID();
	return retArr;
}

function DpObjectViewer_getDescription(sGroup,nID,sSubGroup,sVar)
{
	var oObj = this.getObject(sGroup,nID);

	if (oObj == null)
		return "";

	if (sSubGroup == "VAR")
	{
		var vi = oObj.getVarInfo(sVar)
		return vi.getRem();
	}

	if (sSubGroup == "EXT")
	{
		var ei = oObj.getExtInfo()[sVar];
		if (!ei)
			return "";
		return ei.E_FieldText;
	}
	if (sSubGroup == null)
	{
		var jObj = (this.dpObject.jDoc?this.dpObject.jDoc:this.dpObject.jObj);	
		return jObj.getName();
	}
	return "";
}