/*
	Объект для вычисления оборотов и остатков по счету
	(С) ДЕБЕТ Плюс, 1999

	Вызов:
	1. Для получения остатков на счете дату
	var sl = new DpObsl(new DpSc(fsc[,fsu[,fst]]), dat);
		sl.dbSl - дебетовый остаток
		sl.crSl - кредитовый остаток

	2. Для получения оборотов и остатков за период
	var sl = new DpObsl(new DpSc(fsc[,fsu[,fst]]), dat1, dat2);
		sl.dbSl1 - дебетовый остаток на начало периода
		sl.crSl1 - кредитовый остаток на начало периода
		sl.dbSl2 - дебетовый остаток на конец периода
		sl.crSl2 - кредитовый остаток на конец периода
		sl.dbOb - обороты по дебету
		sl.crOb - обороты по кредиту
		
   Прим. Суффикс Spr означает, что это сумма СПРАВОЧНО		
*/

include("TrnNBln.js");

function DpObsl(objSc, dat1, dat2, valCod, itog)
{
	RO("DpObsl", this);
	
	if(dat2 == null)
	{
		dat2 = dat1;
	}
	
	//TrnNBln("csR", "tmp_obsl", dat1, dat2, objSc, valCod);
	TrnNBln("cR", "tmp_obsl", dat1, dat2, objSc, valCod);

    //var tbl = OpenTable("s", "tmp_obsl");	
	strSQL = " SELECT"
					+" SUM(T.FSUM1) AS FSUM1"
					+", SUM(T.FSUM2) AS FSUM2"
					+", SUM(T.FSUM3) AS FSUM3"
					+", SUM(T.FSUM4) AS FSUM4"
					+", SUM(T.FSUM5) AS FSUM5"
					+", SUM(T.FSUM6) AS FSUM6"
//SAM 24.04.2012
//TrnNBln расчитывается без справочных сумм
//следовательно они нам не нужны
/*
					+", SUM(T.FSSUM1) AS FSSUM1"
					+", SUM(T.FSSUM2) AS FSSUM2"
					+", SUM(T.FSSUM3) AS FSSUM3"
					+", SUM(T.FSSUM4) AS FSSUM4"
					+", SUM(T.FSSUM5) AS FSSUM5"
					+", SUM(T.FSSUM6) AS FSSUM6"
*/
				+" FROM"
					+" tmp_obsl T"
				+" WHERE 1 = 1"
					+sqlw0And(" T.FSC = ",objSc.getSc())
					+sqlw0And(" T.FSU = ",objSc.getSu())
					+sqlw0And(" T.FST = ",objSc.getSt())
					+" AND T.FCL_COD1 = 0"
					+" AND T.FCL_COD2 = 0"
					+" AND T.FCL_COD3 = 0"
					+sqlw0And(" T.FTT = ", itog)
	var tbl = OpenTable(strSQL);
	if(!tbl.IsEOF())
	{
		this.dbSl = this.dbSl1 = Number(tbl.getValue("fsum1"));
		this.crSl = this.crSl1 = Number(tbl.getValue("fsum2"));
		this.dbSl2 = Number(tbl.getValue("fsum3"));
		this.crSl2 = Number(tbl.getValue("fsum4"));
		this.dbOb = Number(tbl.getValue("fsum5"));
		this.crOb = Number(tbl.getValue("fsum6"));
		this.dbSlSpr = this.dbSl1Spr = Number(tbl.getValue("fssum1"));
		this.crSlSpr = this.crSl1Spr = Number(tbl.getValue("fssum2"));
		this.dbSl2Spr = Number(tbl.getValue("fssum3"));
		this.crSl2Spr = Number(tbl.getValue("fssum4"));
		this.dbObSpr = Number(tbl.getValue("fssum5"));
		this.crObSpr = Number(tbl.getValue("fssum6"));
	}
	else
	{
		this.dbSl = this.dbSl1 =
		this.crSl = this.crSl1 =
		this.dbSl2 = this.crSl2 =
		this.dbOb = this.crOb = 0;
		
		this.dbSlSpr = this.dbSl1Spr =
		this.crSlSpr = this.crSl1Spr =
		this.dbSl2Spr = this.crSl2Spr =
		this.dbObSpr = this.crObSpr = 0;
	}
	
	tbl.close();
	tbl = null;
}