include("objects/DpOperation.js");


DpOperDecoder.prototype.run = DpOperDecoder_run;
DpOperDecoder.prototype.getOper = DpOperDecoder_getOper;
DpOperDecoder.prototype.setProgressRange = DpOperDecoder_setProgressRange;
DpOperDecoder.prototype.setProgressPos = DpOperDecoder_setProgressPos;

function DpOperDecoder()
{
	this.tbl = null;
	this.docList = new Array();
}

function DpOperDecoder_setProgressRange(Min,Max)
{
	setProgressRangeEx(Min,Max);
}

function DpOperDecoder_setProgressPos(nPos,sText)
{
	setProgressPosEx(nPos,sText);
}

function DpOperDecoder_run(sDoc)
{
	var sOpTbl = getPath("CL_MDB") + (SUBD==MSSQL ? ".." : "." ) + "COM_CL_OP"; 
	this.tbl = OpenTable("s","SELECT * FROM " + sOpTbl + " WHERE "
						+ " FDOC IS NOT NULL"
						+ " AND FDOC<>' '"
						+ (sDoc?" AND FDOC=" + sqlTo(sDoc):"")
						+ " ORDER BY Fdoc,Fnop,Fnsect,Fnprov");
	var length = this.tbl.getRecordCount();
	//browse(this.tbl);
	
	this.setProgressRange(1,length + 1);
	this.setProgressPos(1,"Идёт перенос...");
	var nPos = 0;
	
	for (this.tbl.MoveFirst();!this.tbl.isEOF();this.tbl.MoveNext())
	{
		var doc = String(this.tbl.getValue("FDOC")).toUpperCase();
		var nop = parseInt(this.tbl.getValue("FNOP"));
		var sect = parseInt(this.tbl.getValue("FNSECT"));
		var prov = parseInt(this.tbl.getValue("FNPROV"));
		var txt = allt(this.tbl.getValue("FTXT"));

		this.setProgressPos(++nPos,"Идёт перенос " + doc + ":" + nop + " ...");
		
		var oper = this.getOper(doc,nop);
		
		if (sect == 0 && prov == 0)
		{
			if (txt == "")
			{
				var oSnap = getSnap("SELECT FTXT FROM ^cl_lnk"
							+ " WHERE FDOC=" + sqlTo(doc)
							+ " AND FNOP=" + sqlTo(nop));
				if (oSnap != null)
					txt = oSnap[0];
				
			}
			oper.setVar("txt",txt);
			oper.setVar("ref",parseInt(this.tbl.getValue("FREF")));
			oper.setVar("cond",String(this.tbl.getValue("FCOND")));
			oper.save();
			continue;
		}
		
		if (prov == 0)
		{
			oper.addSection(sect);
			var oSect = oper.getSection(sect);
			oSect.setVar("txt",txt);
			oSect.setVar("cond",this.tbl.getValue("FCOND"));
			oSect.setVar("filter",this.tbl.getValue("FFILT"));
			var sGroup = String(this.tbl.getValue("FREPEAT"));
			if (sGroup == null || sGroup.trim() == "")
				sGroup = "";
			else
				sGroup = "*";
			oSect.setVar("group",sGroup);
			oper.save();
			continue;
		}
		
		var oSect = oper.getSection(sect);
		if (oSect == null)
		{
			trace(doc + " - " + nop + " - " + sect);
			continue;
		}
		oSect.addProv(prov);
		oSect.gotoProv(prov);
		oSect.provTbl.Edit();
		oSect.provTbl.setValue("txt",txt);
		oSect.provTbl.setValue("cond",this.tbl.getValue("FCOND"));
		oSect.provTbl.setValue("bdate",this.tbl.getValue("FBDAT"));
		oSect.provTbl.setValue("edate",this.tbl.getValue("FEDAT"));
		oSect.provTbl.setValue("docnum",this.tbl.getValue("FDOCNUM"));
		oSect.provTbl.setValue("docvid",this.tbl.getValue("FDOCVID"));
		oSect.provTbl.setValue("date",this.tbl.getValue("FDATE"));
		oSect.provTbl.setValue("cr_sc",this.tbl.getValue("FCR_SC"));
		oSect.provTbl.setValue("cr_su",this.tbl.getValue("FCR_SU"));
		oSect.provTbl.setValue("cr_st",this.tbl.getValue("FCR_ST"));
		oSect.provTbl.setValue("cr_cod1",this.tbl.getValue("FCR_COD1"));
		oSect.provTbl.setValue("cr_cod2",this.tbl.getValue("FCR_COD2"));
		oSect.provTbl.setValue("cr_cod3",this.tbl.getValue("FCR_COD3"));
		oSect.provTbl.setValue("db_sc",this.tbl.getValue("FDB_SC"));
		oSect.provTbl.setValue("db_su",this.tbl.getValue("FDB_SU"));
		oSect.provTbl.setValue("db_st",this.tbl.getValue("FDB_ST"));
		oSect.provTbl.setValue("db_cod1",this.tbl.getValue("FDB_COD1"));
		oSect.provTbl.setValue("db_cod2",this.tbl.getValue("FDB_COD2"));
		oSect.provTbl.setValue("db_cod3",this.tbl.getValue("FDB_COD3"));
		oSect.provTbl.setValue("sum",this.tbl.getValue("FSUM"));
		oSect.provTbl.setValue("val",this.tbl.getValue("FVAL"));
		oSect.provTbl.setValue("sumspr",this.tbl.getValue("FSUMSPR"));
		oSect.provTbl.setValue("valspr",this.tbl.getValue("FVALSPR"));
		oSect.provTbl.setValue("iskraz",this.tbl.getValue("ISKRAZ"));
		oSect.provTbl.setValue("vkurs",this.tbl.getValue("FVKURS"));
		oSect.provTbl.Update();
		oper.save();
	}
	
	for (var sDoc in this.docList)
	{
		this.docList[sDoc].save();
	}
	this.setProgressPos(0,"");
}

function DpOperDecoder_getOper(doc,nop)
{
	doc = String(doc).toUpperCase();
	nop = parseInt(nop);
	if (!this.docList[doc])
	{
		this.docList[doc] = new DpOperationList(doc);
		this.docList[doc].listOperations(true);
	}
	
	if (!this.docList[doc].listOperations(false)[nop])
		this.docList[doc].addOperation(nop);
	return this.docList[doc].listOperations(false)[nop];
}