/*
 *  ГРУЗИТ И СОХРАНЯЕТ СВОИ СПИСКИ *
 */

include("Objects/DpXMLDomDocument.js");

DpOwnList.prototype.init = DpOwnList_init;
DpOwnList.prototype.load = DpOwnList_load;
DpOwnList.prototype.loadXml = DpOwnList_loadXml;
DpOwnList.prototype.createXml = DpOwnList_createXml;
DpOwnList.prototype.getXmlGrp = DpOwnList_getXmlGrp;
DpOwnList.prototype.initControls = DpOwnList_initControls;
DpOwnList.prototype.initQuery = DpOwnList_initQuery;
DpOwnList.prototype.initTable = DpOwnList_initTable;
DpOwnList.prototype.initTotal = DpOwnList_initTotal;
DpOwnList.prototype.initGrid = DpOwnList_initGrid;
DpOwnList.prototype.initFilter = DpOwnList_initFilter;
DpOwnList.prototype.initOrder = DpOwnList_initOrder;
DpOwnList.prototype.saveList = DpOwnList_saveList;
DpOwnList.prototype.saveXml = DpOwnList_saveXml;
DpOwnList.prototype.save = DpOwnList_save;
DpOwnList.prototype.saveExtPar = DpOwnList_saveExtPar;
DpOwnList.prototype.fillExtPar = DpOwnList_fillExtPar;
DpOwnList.prototype.fillTree = DpOwnList_fillTree;
DpOwnList.prototype.refreshTree = DpOwnList_refreshTree;
DpOwnList.prototype.selTreeItem = DpOwnList_selTreeItem;
DpOwnList.prototype.setTreeItemColor = DpOwnList_setTreeItemColor;
DpOwnList.prototype.validateControls = DpOwnList_validateControls;
DpOwnList.prototype.run = DpOwnList_run;
DpOwnList.prototype.checkSystem = DpOwnList_checkSystem;

function DpOwnList(dpList)
{
	this.xmlFile = lpProxy.getUserDirectory() +"userlists.xml";
	this.xmlDom = null;
	this.xmlDoc = null;
	this.xmlHistory = null;
	this.list = dpList;
	this.grid = null;
	this.form = null;
	this.tree = null;	
	this.init();
}

function DpOwnList_init()
{
	this.title = "";
	this.task = "";	
	this.xmlGrid = null;
	this.xmlGridStruct = null;	
	this.controls = new Object();
	this.par = new Object();
	this.menuMode = "";	
	this.query = "";
	this.qryFrom = "";
	this.qryWhere = "";
	this.order = new Object();	
	this.sqlOrder = "";
	this.sqlFilter = "";
	this.filterState = "";
	this.finder = new Object();
	this.fwids = "";
	this.total = new Object();	
	this.empty = true;
	this.type = "";
	this.name = "";
	this.rate = 0;
	this.image = "";
	this.color = "";
	this.system = "";
	this.base = "";
	this.validation = false;
}

function DpOwnList_load(xmlDoc)
{
	this.init();
	
	if(!this.xmlDom)
		this.loadXml();
	if(xmlDoc)
		this.xmlDoc = xmlDoc;
	
	this.title = UR(String(this.xmlDoc.getAttribute("txt")));
	this.name = this.xmlDoc.getNodeName();
	this.task = this.xmlDoc.getAttribute("task");
	this.type = this.xmlDoc.getAttribute("type");
	this.rate = this.xmlDoc.getAttribute("rate");
	this.image = this.xmlDoc.getAttribute("image");
	this.color = this.xmlDoc.getAttribute("color");
	this.system = this.xmlDoc.getAttribute("system");
	this.base = this.xmlDoc.getAttribute("base");
	if(this.xmlDoc.getAttribute("par"))
		this.menuMode = this.xmlDoc.getAttribute("par");		
	this.xmlGrid = this.xmlDoc.getElementsByTagName("DpGrid")[0];
	this.xmlGridStruct = this.xmlDoc.getElementsByTagName("grid")[0];
		
	var xmlExtPar = this.xmlDoc.getElementsByTagName("extPar")[0];
	if(xmlExtPar)
	{
		this.par = new Object();
		this.fillExtPar(this.par, xmlExtPar);
	}
	
	var xmlControls = this.xmlDoc.getElementsByTagName("Controls")[0];
	if(xmlControls)
	{
		var cntrlList = xmlControls.getChildNodes();
		for(var i=0; i<cntrlList.length; i++)
		{
			var oCntrl = cntrlList[i];
			this.controls[oCntrl.getAttribute("ID")] = oCntrl.getText();
		}
	}
	
	var xmlQuery = this.xmlDoc.getElementsByTagName("query")[0];
	if(xmlQuery)
	{
		if(xmlQuery.getElementsByTagName("sqlquery")[0])
			this.query = xmlQuery.getElementsByTagName("sqlquery")[0].getCDATASection().getText();
		if(xmlQuery.getElementsByTagName("from")[0])
			this.qryFrom = xmlQuery.getElementsByTagName("from")[0].getText();
		if(xmlQuery.getElementsByTagName("where")[0])
			this.qryWhere = xmlQuery.getElementsByTagName("where")[0].getText();
		if(xmlQuery.getElementsByTagName("order")[0])
			this.sqlOrder = xmlQuery.getElementsByTagName("order")[0].getText();			
	}
	
	var xmlOrder = this.xmlDoc.getElementsByTagName("order")[0];
	if(xmlOrder)
	{
		if(xmlOrder.getElementsByTagName("sortcol")[0])
			this.order.col = xmlOrder.getElementsByTagName("sortcol")[0].getText();
		if(xmlOrder.getElementsByTagName("sortname")[0])
			this.order.name = xmlOrder.getElementsByTagName("sortname")[0].getText();
		if(xmlOrder.getElementsByTagName("orderi")[0])
			this.order.num = xmlOrder.getElementsByTagName("orderi")[0].getText();
		if(xmlOrder.getElementsByTagName("sqlorder")[0])
			this.order.sql = xmlOrder.getElementsByTagName("sqlorder")[0].getText();
		this.sqlOrder = this.order.sql;
	}
	
	var xmlTotal = this.xmlDoc.getElementsByTagName("total")[0];
	if(xmlTotal)
	{
		if(xmlTotal.getElementsByTagName("variant")[0])
			this.total.variant = xmlTotal.getElementsByTagName("variant")[0].getText();
		if(xmlTotal.getElementsByTagName("mode")[0])
			this.total.mode = xmlTotal.getElementsByTagName("mode")[0].getText();
	}
	
	var xmlFilter = this.xmlDoc.getElementsByTagName("filter")[0];
	if(xmlFilter)
	{
		if(xmlFilter.getElementsByTagName("sqlfilter")[0])
			this.sqlFilter = xmlFilter.getElementsByTagName("sqlfilter")[0].getText();
		if(xmlFilter.getElementsByTagName("fwids")[0])
			this.fwids = xmlFilter.getElementsByTagName("fwids")[0].getText();
		var xmlFindDataDlg = xmlFilter.getElementsByTagName("finddatadlg")[0];
		if(xmlFindDataDlg)
		{
			this.filterState = xmlFindDataDlg.getText();
			//if(xmlFindDataDlg.getElementsByTagName("state")[0])
			//	this.filterState = xmlFindDataDlg.getElementsByTagName("state")[0].getText();					
		}
				
		var xmlQuickFind = xmlFilter.getElementsByTagName("quickfind")[0];
		if(xmlQuickFind)
		{
			if(xmlQuickFind.getElementsByTagName("column")[0])
				this.finder.column = xmlQuickFind.getElementsByTagName("column")[0].getText();
			if(xmlQuickFind.getElementsByTagName("field")[0])
				this.finder.field = xmlQuickFind.getElementsByTagName("field")[0].getText();
			if(xmlQuickFind.getElementsByTagName("text")[0])
				this.finder.text = xmlQuickFind.getElementsByTagName("text")[0].getText();
		}
	}
}

function DpOwnList_fillExtPar(par, xmlExtPar)
{
	var parList = xmlExtPar.getChildNodes();
	for(var i=0; i<parList.length; i++)
	{
		var xmlPar = parList[i];
		var sPar = xmlPar.getAttribute("ID");
		par[sPar] = xmlPar.getText();		
		if(xmlPar.getChildNodes().length>0)
			this.fillExtPar(par[sPar], xmlPar);		
	}
}

function DpOwnList_loadXml()
{
	this.xmlDom = new DpXMLDOMDocument();
	lpProxy.setData("OWNLIST", this);
	this.xmlDoc = null;
	if (isFile(this.xmlFile))
	{
		if (this.xmlDom.load(this.xmlFile))
		{
			this.xmlDoc = this.xmlDom.getDocumentElement();
		}
		else
		{
			deleteFile(this.xmlFile);
			this.createXml(true);
		}		
	}
	else
	{
		var sSourceFile = rootDirectoryEx() +"Source/userlists.xml";
		if(isFile(sSourceFile))
		{
			if(copyFile(sSourceFile, this.xmlFile))
			{
				this.xmlDom.load(this.xmlFile);
				this.xmlDoc = this.xmlDom.getDocumentElement();
			}
		}
		if(!isFile(this.xmlFile))
			this.createXml(true);	
	}	
	this.xmlHistory = this.xmlDoc.getElementsByTagName("History")[0];
	if(!this.xmlHistory)
	{
		this.xmlHistory = this.xmlDom.createElement("History");
		this.xmlDoc.appendChild(this.xmlHistory);
	}
	return this.xmlDom;
}

function DpOwnList_createXml(bCreateGroups)
{
	if(!this.xmlDom)
		this.xmlDom = new DpXMLDOMDocument();
	this.xmlDoc = this.xmlDom.createElement("root");
	this.xmlDom.appendChild(this.xmlDoc);
	this.xmlHistory = this.xmlDom.createElement("History");
	this.xmlDoc.appendChild(this.xmlHistory);
	if(bCreateGroups)
	{
		this.xmlCLGrp = this.xmlDom.createElement("grp");	
		this.xmlCLGrp.setAttribute("txt", "Довідники аналітики|Справочники аналитики");
		this.xmlCLGrp.setAttribute("ID", GetUID());
		this.xmlCLGrp.setAttribute("type", "cl");	
		this.xmlDoc.appendChild(this.xmlCLGrp);
		
		this.xmlDocGrp = this.xmlDom.createElement("grp");	
		this.xmlDocGrp.setAttribute("txt", "Документи|Документы");
		this.xmlDocGrp.setAttribute("ID", GetUID());
		this.xmlDocGrp.setAttribute("type", "doc");	
		this.xmlDoc.appendChild(this.xmlDocGrp);
		
		this.xmlCalcGrp = this.xmlDom.createElement("grp");	
		this.xmlCalcGrp.setAttribute("txt", "Звіти|Отчеты");
		this.xmlCalcGrp.setAttribute("ID", GetUID());
		this.xmlCalcGrp.setAttribute("type", "calc");		
		this.xmlDoc.appendChild(this.xmlCalcGrp);
	}
	this.xmlDom.save(this.xmlFile);
}

function DpOwnList_getXmlGrp(sType)
{
	try
	{
		var xmlDoc = this.xmlDom.getDocumentElement();
		var xmlGrps = xmlDoc.getElementsByTagName("grp");
		for(var n=0; n<xmlGrps.length; n++)
		{
			var grp = xmlGrps[n];
			if(sType==String(grp.getAttribute("type")))
				return grp;
		}
	}
	catch(e)
	{
		//alert(e);
	}
	return null;
}

function DpOwnList_initControls(form)
{
	if(!form)
		return;
	this.form = form;	
	var dlg = form.getDialogBuilder();
	var arrCtrl = dlg.getControlMap().keySet().toArray();
	for (var i=0; i<arrCtrl.length; i++)
	{
		try
		{
			var sID = String(arrCtrl[i]);
			var oCtrl = dlg.getControlMap().get(sID);
			var oVal = this.controls[sID];			
			if (!oCtrl || typeof(oCtrl)=="undefined" || !oVal)
				continue;			
			switch(typeOf(oCtrl))
			{
				case "DpTextEx":
					if(oVal.indexOf(": ")!=-1)
					{
						var cod = oVal.substring(0, oVal.indexOf(": ")); 
						if(Number(cod))
							oVal = cod;
					}
				case "DpCombo":
				case "DpRate":					
					oCtrl.value = oVal;					
					break;
				
				case "DpDate":
				case "DpDateTime":
					//oCtrl.value = StrToDate(oVal);
					break;
				
				case "DpCheck":
					if(String(oVal)=="true" || String(oVal)=="1")
						oCtrl.checked = true;
					break;
			}
			trace(">>> DpOwnList_initControls: "+ sID +" > "+ this.controls[sID] +" > "+ typeOf(oCtrl) +" > "+ oCtrl.value)
			//form.runValid(oCtrl);
		}
		catch(e)
		{
			//alert(e);
		}
	}
}

function DpOwnList_validateControls(form)
{
	if(form)
		this.form = form;
	if(!this.form || this.validation)
		return;	
	this.validation = true;
	var dlg = this.form.getDialogBuilder();
	var arrCtrl = this.controls;
	for(var sID in arrCtrl)
	{
		var oCtrl = dlg.getControlMap().get(sID);
		var oVal = arrCtrl[sID];
		if(oCtrl && oVal)
			this.form.runValid(oCtrl);
	}
	this.validation = false;	
}

function DpOwnList_initQuery(list)
{
	this.list = list;	
	/*
	if(this.qryWhere!=null && this.qryWhere!="")
		list.qryWhere = this.qryWhere;
	if(this.filter!=null && this.filter!="")
	{
		if(list.qryWhere!="")
			list.qryWhere += " and ";
		list.qryWhere += this.filter;
	}
	if(this.fwids!=null && this.fwids!="" && !this.filterState)
	{
		var sWhere = sqlWhereFwids(this.fwids);
		if(sWhere!="")
		{
			if(list.qryAlias!="")
				sWhere = list.qryAlias +"."+ sWhere;
			if(list.qryWhere!="")
				sWhere = " and "+ sWhere;			
			list.qryWhere += sWhere;
		}
	}	
	*/	
	if(this.sqlOrder && this.sqlOrder!="")
		list.qryOrder[0] = this.sqlOrder;	
}

function DpOwnList_initTable()
{
	/*
	if(this.fwids!=null && this.fwids!="")
	{
		var arrFwids = this.fwids.split(",");
		if(this.list && this.list.tbl)
		{
			var sWhere = sqlWhereFwids(this.fwids);
			this.list.tbl.openSel(sWhere);
		}
	}
	*/	
}

function sqlWhereFwids(fwids)
{	
	var sWhere = "";
	var arrFwids = fwids.split(",");
	var maxIDCount = 1000;
	if(SUBD==MYSQL)
		maxIDCount = 10000;
	if(arrFwids.length<maxIDCount)
	{
		sWhere = "fwid in ("+ fwids +")";
	}
	else
	{
		var sTmpTbl = getTmpTableName();
		ExecuteSQL("create table "+ sTmpTbl +" (fwid_TMP_ "+ sqlType("LONG") +")");
		var batch = createBatch();
		for (var i=0; i<arrFwids.length; i++)
		{
			var sSQL = "insert into "+ sTmpTbl +" values ("+ sqlTo(arrFwids[i]) +")";
			batch.addBatch(sSQL);			
		}
		batch.execute(false);
		batch.close();
		sWhere = "fwid in ( select fwid_TMP_ from " + sTmpTbl + ")";
	}
	return sWhere;
}

function DpOwnList_initGrid(grid)
{	
	if(!this.xmlGridStruct)
		return;
	this.grid = grid;
	grid.saveFormat(false);
	if(this.xmlGridStruct.xmlNode)
	{
		grid.getStructHolder().load(this.xmlGridStruct.xmlNode);
		grid.getStructHolder().refreshGrid();
	}
	//grid.DeletePages();
	//grid.parseXML(this.xmlGrid.xmlNode);	
	//grid.build();
	
	this.initOrder();
	this.initFilter();	
}

function DpOwnList_initTotal()
{
	if(this.total && this.total.variant && !this.validation)
	{
		this.list.objTotal.variantCur = this.total.variant;
		this.list.objTotal.mode = this.total.mode;
		this.list.mnuHandler("TOTAL"+ this.total.variant);
		this.list.objTotal.variantCur = "";
		this.list.stor();
		this.list.objTotal.variantCur = this.total.variant;
	}
}

function DpOwnList_initOrder()
{
	var sOrderID = String(this.order.name);
	var nSortCol = Number(this.order.col);
	if(nSortCol>=0)
	{
		this.list.headerCurSort = sOrderID;
		this.list.lastSortCol = this.grid.getColumn(nSortCol);
		if (sOrderID == "SORT_UP")
			this.grid.setColImage(nSortCol, rootDirectoryEx() + "/icons/arru.gif");
		else if (sOrderID == "SORT_DOWN")
			this.grid.setColImage(nSortCol, rootDirectoryEx() + "/icons/arrd.gif");				
	}
}

function DpOwnList_initFilter()
{
	if(!this.grid)
		return;
	var tbl = this.grid.getTable();
	var sQuery = tbl.getQuery();
	if(this.finder.text!=null && this.finder.text!="")
	{
		var findDlg = this.grid.getFindDlg();
		if(findDlg)
		{
			var findCol = Number(this.finder.column)-1;
			var findText = String(this.finder.text);
			findDlg.getCntrl().setText(findText);
			findDlg.setFindField(findCol);
			this.grid.quikFind(findCol, findText, true);
			if(this.list)
			{
				if(tbl.getFilter()!="")
				{
					if(this.list.qryWhere!="")
						this.list.qryWhere += " and ";
					this.list.qryWhere += tbl.getFilter();
				}
				else if(tbl.getWhereSel()!="")
				{
					this.list.qryWhere = tbl.getWhereSel();
				}
			}
		}
	}
	
	if(this.fwids!=null && this.fwids!="")
	{
		var arrIDs = this.fwids.split(",");
		if(arrIDs.length>0)
		{
			for(var i=0; i<arrIDs.length; i++)
				arrIDs[i] = Number(arrIDs[i]);
			this.grid.setSelectedIDs(arrIDs);
			this.grid.showOnlySelected();
			this.grid.clearSelected();
			this.grid.setFilter(true);			
			if(this.list)
				this.list.qryWhere = tbl.getWhereSel();
		}
	}	
	else if(this.filterState!=null && this.filterState!="")
	{		
		this.grid.runFilterState(this.filterState, false);
		this.grid.clearSelected();
		var sQuerySel = tbl.getQuery();
		/*
		tbl.clearQuery();
		tbl.setQuery(sQuerySel);
		tbl.reParseQuery();
		if(this.list)
			this.list.qryWhere = tbl.getWhere();
		tbl.setQuery(sQuery);
		//this.grid.clearFilter();
		*/
		if(this.list)
			this.list.qryWhere = tbl.getWhereSel();
	}	
}

function DpOwnList_fillTree(xmlDoc, sGroupID, oTree)
{
	if(oTree)
	{
		this.tree = oTree;
		this.tree.removeAll();
		lpProxy.setData("OWNTREE", oTree);
		this.empty = true;
	}
	if(!this.tree || this.tree.getCtrl().isDisposed())
		return;	
		
	if(!this.xmlDom)
		this.loadXml();
	if(!xmlDoc)
		xmlDoc = this.xmlDom.getDocumentElement();
	if(!sGroupID)
		sGroupID = null;	
	var childs = xmlDoc.getChildNodes();
	for(var i=0; i<childs.length; i++) 
	{
		var sName = String(childs[i].getNodeName());
		if(sName=="History")
			continue;
		var txt = String(childs[i].getAttribute("txt"));
		var image = childs[i].getAttribute("image");				
		var color = childs[i].getAttribute("color");
		var base = String(childs[i].getAttribute("base")).trim().toLowerCase();
		var rate = childs[i].getAttribute("rate");
		var sType = String(childs[i].getAttribute("type"));
		var sID = String(childs[i].getAttribute("ID"));
		if(base && base!="")
		{
			var isBase = false;
			var curBase = String(getPath("ALL_MDB")).trim().toLowerCase();
			var arrBase = base.split(",");
			for(var nBase=0; nBase<arrBase.length; nBase++)
			{
				var sBase = String(arrBase[nBase]).trim();
				if(sBase==curBase)
					isBase = true;
			}
			if(!isBase)
				continue;
		}
		if (sID==null || sID=="")
		{
			sID = String(GetUID());
			childs[i].setAttribute("ID", sID);
		}
				
		if(sName=="grp")
		{
			this.tree.addItem(sGroupID, sID, UR(txt));
			var ti = this.tree.getItem(sID);
			ti.setData("canAdd", true);
			ti.setData("name", sName);
			ti.setData("type", sType);
			ti.setData("xml", childs[i]);
			ti.setData("ID", sID);
			this.fillTree(childs[i], sID);
		}
		else
		{
			this.tree.addItem(sGroupID, sID, UR(txt), 3);
			var ti = this.tree.getItem(sID);			
			ti.setData("canAdd", false);
			ti.setData("name", sName);
			ti.setData("type", sType);
			ti.setData("rate", rate);			
			ti.setData("xml", childs[i]);
			ti.setData("ID", sID);
			if(image)
			{
				image = String(image).trim();
				if(image!="" && image.indexOf(".")==-1)
					image += ".gif";
				ti.setData("image", image);
				this.tree.setImage(sID, image);
			}
			if(color)
				this.setTreeItemColor(sID, color);
			this.empty = false;
		}		
	}
}

function DpOwnList_setTreeItemColor(sItemID, sColor)
{
	if(!sItemID || !sColor || String(sColor).trim()=="")
		return;
	var arrCol = String(sColor).split(",");
	var red = parseInt(arrCol[0]);
	var green = parseInt(arrCol[1]);
	var blue = parseInt(arrCol[2]);	
	this.tree.setItemColor(sItemID, red, green, blue);
}

function DpOwnList_saveList(list, form, par)
{
	if(list)
	{
		this.list = list;
		if(!par)
			par = list.par;
	}
	if(form)
		this.form = form;
	
	var title = "";
	if(this.form)
		title = this.form.getCaption();
	else if(this.list)
		title = this.list.title;	
	title = input(UR("Назва|Название"), UR("Уведіть назву списку|Введите название списка"), UR(title), 250);
	if(!title)
		return;
	
	if(!this.xmlDom)
		this.loadXml();
	
	var type = "";
	var task = "";
	if(this.form)
		task = this.form.getTask().getTask();
	
	var xmlList = this.xmlDom.createElement("list");
	var xmlDoc = null;
	if(task=="l_cl.xml")
		type = "cl";
	else if(task=="l_docekz.xml")
		type = "doc";
	else if(task.startsWith("r_") || task.startsWith("ras_"))
		type = "calc";	
	if(type!="")
		xmlDoc = this.getXmlGrp(type);
	if(!xmlDoc)
		xmlDoc = this.xmlDom.getDocumentElement();
	xmlDoc.appendChild(xmlList);
		
	var listID = GetUID();
	xmlList.setAttribute("ID", listID);
	xmlList.setAttribute("txt", title);
	xmlList.setAttribute("task", task);
	xmlList.setAttribute("type", type);
	xmlList.setAttribute("rate", 0);
	xmlList.setAttribute("system", getSystem());
	
	if(par)
	{
		var xmlExtPar = this.xmlDom.createElement("extPar");
		xmlExtPar.setAttribute("text", UR("Програмні параметри|Программные параметры"));
		if(par.menuMode)
			xmlExtPar.setText(par.menuMode);
		xmlList.appendChild(xmlExtPar);
		this.saveExtPar(par, xmlExtPar);		
	}
	
	if(this.form)
	{	
		var xmlControls = this.xmlDom.createElement("Controls");
		xmlControls.setAttribute("text", UR("Елементи управління|Элементы управления"));	
		
		var nCtrl = 0;
		var dlg = this.form.getDialogBuilder();
		var arrCtrl = dlg.getControlMap().keySet().toArray();
		for (var i=0; i<arrCtrl.length; i++)
		{
			try
			{
				var sVal = "";
				var sID = String(arrCtrl[i]);
				var oCtrl = dlg.getControlMap().get(sID);
				var sType = typeOf(oCtrl);
				switch(sType)
				{
					case "DpTextEx":
					case "DpCombo":
					case "DpRate":
						sVal = String(oCtrl.value).trim();
						break;
					
					case "DpDate":
					case "DpDateTime":
						//sVal = StrDat(oCtrl.value, "DMY");
						break;
					
					case "DpCheck":
						if(oCtrl.checked)
							sVal ="true";
						break;				
				}
				
				if(sVal && sVal!="" && sType)
				{
					var xmlCtrl = this.xmlDom.createElement(sType);
					xmlCtrl.setText(sVal);
					xmlCtrl.setAttribute("ID", sID);
					xmlControls.appendChild(xmlCtrl);
					nCtrl++;
				}
			}
			catch(e)
			{
				
			}
		}
		if(nCtrl>0)
			xmlList.appendChild(xmlControls);
	}
	
	if(this.list)
	{
		var tbl = this.list.tbl;
		var oGrid = this.list.grid;
		
		if(tbl)
		{
			var xmlQuery = this.xmlDom.createElement("query");
			xmlQuery.setAttribute("text", UR("Таблиця|Таблица"));
			//xmlQuery.setText(this.list.tbl.getTableName());
			xmlList.appendChild(xmlQuery);
			
			var xmlSQL = this.xmlDom.createElement("sqlquery");
			xmlSQL.setAttribute("text", UR("SQL-запрос|SQL-запрос"));
			var sQuery = tbl.getQuery();
			xmlSQL.appendChild(this.xmlDom.createCDATASection(sQuery));
			xmlQuery.appendChild(xmlSQL);
			
			var xmlFields = this.xmlDom.createElement("fields");
			xmlFields.setAttribute("text", UR("Поля|Поля"));
			xmlFields.setText(tbl.getFields());
			xmlQuery.appendChild(xmlFields);
			
			var xmlFrom = this.xmlDom.createElement("from");
			xmlFrom.setAttribute("text", UR("Таблиця|Таблица"));
			xmlFrom.setText(this.list.qryFrom);
			xmlQuery.appendChild(xmlFrom);
			
			var xmlWhere = this.xmlDom.createElement("where");
			xmlWhere.setAttribute("text", UR("Умова|Условие"));
			xmlWhere.setText(tbl.getWhere());
			xmlQuery.appendChild(xmlWhere);						
		}
						
		if(oGrid)
		{			
			var headerSortI = this.list.headerSortI;
			var sortColInfo = this.list.lastSortCol;
			var sortCol = oGrid.getColumns().indexOf(sortColInfo);
			var sortName = this.list.headerCurSort;
			var qryOrderI = this.list.qryOrderI;
			var qryOrder = this.list.qryOrder;
			var sqlOrder = qryOrder[qryOrderI];
			var sortTxt = "";			
			if(sortColInfo)
				sortTxt = sortColInfo.getCaption();
			if(sortTxt=="" && sortName)
				sortTxt = sortName;
			
			if(headerSortI)
			{
				var xmlOrder = this.xmlDom.createElement("order");
				xmlOrder.setAttribute("text", UR("Сортування|Сортировка"));
				xmlOrder.setText(sortTxt);
				xmlList.appendChild(xmlOrder);
				
				var xmlOrderI = this.xmlDom.createElement("orderi");
				xmlOrderI.setAttribute("text", UR("№|№"));
				xmlOrderI.setText(qryOrderI);
				xmlOrder.appendChild(xmlOrderI);
				
				var xmlSortName = this.xmlDom.createElement("sortname");
				xmlSortName.setAttribute("text", UR("Назва|Название"));
				xmlSortName.setText(sortName);
				xmlOrder.appendChild(xmlSortName);
				
				var xmlSortCol = this.xmlDom.createElement("sortcol");
				xmlSortCol.setAttribute("text", UR("Колонка|Колонка"));
				xmlSortCol.setText(sortCol);
				xmlOrder.appendChild(xmlSortCol);			
				
				var xmlSqlOrder = this.xmlDom.createElement("sqlorder");
				xmlSqlOrder.setAttribute("text", UR("Поле|Поле"));
				xmlSqlOrder.setText(sqlOrder);
				xmlOrder.appendChild(xmlSqlOrder);
			}
			else if(this.list.objTotal.variantCur>0 && this.list.stdItogsAlreadyUsed)
			{
				var nTotal = this.list.objTotal.variantCur;
				var sMode = this.list.objTotal.mode;
				var sCaller = this.list.objTotal.callerName;
				var sTxt = "";
				var oSnap = getSnap("SELECT FTXT"
									+" FROM ^CL_TT"
									+" WHERE UPPER(FLIST)="+ sqlTo(String(sCaller)).toUpperCase()
										+" and FNO="+ sqlTo(nTotal)
									, false
									);
				if(oSnap)
					sTxt = oSnap[0];
				
				var xmlTotal = this.xmlDom.createElement("total");
				xmlTotal.setAttribute("text", UR("Підсумки|Итоги"));
				xmlTotal.setText(sTxt);
				xmlList.appendChild(xmlTotal);		
				
				var xmlVariant = this.xmlDom.createElement("variant");
				xmlVariant.setAttribute("text", UR("№|№"));
				xmlVariant.setText(nTotal);
				xmlTotal.appendChild(xmlVariant);
				
				var xmlMode = this.xmlDom.createElement("mode");
				xmlMode.setAttribute("text", UR("Режим|Режим"));
				xmlMode.setText(sMode);
				xmlTotal.appendChild(xmlMode);
				
				this.list.objTotal.variantCur = "";
				this.list.stor();
				this.list.objTotal.variantCur = nTotal;
			}
			
			var sFilterText = "";
			if(oGrid.getFindDlg())
				sFilterText = oGrid.getFindDlg().getText();
			if(oGrid.isFilter() || !oGrid.isFull() || sFilterText!="")
			{
				var xmlFilter = this.xmlDom.createElement("filter");
				xmlFilter.setAttribute("text", UR("Фільтр|Фильтр"));				
				
				if(tbl && tbl.getFilter()!="")
				{
					var xmlSqlFilter = this.xmlDom.createElement("sqlfilter");
					xmlSqlFilter.setAttribute("text", UR("SQL|SQL"));
					xmlSqlFilter.setText(tbl.getFilter());
					xmlFilter.appendChild(xmlSqlFilter);
				}
								
				if(oGrid.isFilter() || !oGrid.isFull())
				{
					if(oGrid.isUserChecked())
					{
						xmlFilter.setText(UR("Ручний відбір (+/-)|Ручной отбор (+/-)"));
						
						var xmlUserChecked = this.xmlDom.createElement("userchecked");
						xmlUserChecked.setAttribute("text", UR("Ручний відбір (+/-)|Ручной отбор (+/-)"));
						xmlUserChecked.setText("true");
						xmlFilter.appendChild(xmlUserChecked);						
						
						var xmlFwids = this.xmlDom.createElement("fwids");
						xmlFwids.setAttribute("text", UR("ID рядків|ID строк"));
						if(tbl)
							xmlFwids.setText(tbl.getSelIDs().join(","));
						xmlFilter.appendChild(xmlFwids);
					}
					else if(oGrid.getFindDataDlg())
					{
						var stateKey = oGrid.getFindDataDlg().getActiveStateKey();
						//xmlFilter.setText(stateKey);
						
						var xmlFindDataDlg = this.xmlDom.createElement("finddatadlg");
						xmlFindDataDlg.setAttribute("text", UR("Відбір|Отбор"));
						xmlFindDataDlg.setText(stateKey);
						xmlFilter.appendChild(xmlFindDataDlg);						
						/*
						var xmlState = this.xmlDom.createElement("state");
						xmlState.setAttribute("text", UR("Варіант відбору|Вариант отбора"));
						xmlState.setText(stateKey);
						xmlFindDataDlg.appendChild(xmlState);
						*/
					}
				}
				
				if(sFilterText!="")
				{
					var xmlQuickFind = this.xmlDom.createElement("quickfind");
					xmlQuickFind.setAttribute("text", UR("Швидкий пошук|Быстрый поиск"));
					xmlFilter.appendChild(xmlQuickFind);
					if(oGrid.getFindDlg())
					{
						var sFieldTxt = oGrid.getFindDlg().getFindFieldName();
						xmlQuickFind.setText(sFieldTxt +" = "+ sFilterText);
						//xmlFilter.setText(sFieldTxt +" = "+ sFilterText);
						
						var xmlQuickFindField = this.xmlDom.createElement("field");
						xmlQuickFindField.setAttribute("text", UR("Колонка|Колонка"));
						xmlQuickFindField.setText(sFieldTxt);
						xmlQuickFind.appendChild(xmlQuickFindField);
						
						var findCol = oGrid.getFindDlg().getFindField();
						var xmlQuickFindCol = this.xmlDom.createElement("column");
						xmlQuickFindCol.setAttribute("text", UR("№|№"));
						xmlQuickFindCol.setText(findCol);
						xmlQuickFind.appendChild(xmlQuickFindCol);
						
						var xmlQuickFindText = this.xmlDom.createElement("text");
						xmlQuickFindText.setAttribute("text", UR("Текст для відбору|Текст для отбора"));
						xmlQuickFindText.setText(sFilterText);
						xmlQuickFind.appendChild(xmlQuickFindText);
					}
				}
				xmlList.appendChild(xmlFilter);
			}
			
			var xmlDpGrid = this.xmlDom.createElement("DpGrid");
			xmlDpGrid.setAttribute("text", UR("Колонки списку|Колонки списка"));
			xmlList.appendChild(xmlDpGrid);
			var arrGroup = new Object();			
			var arrCol = oGrid.getColumnsArray();
			for(var i=0; i<arrCol.length; i++)
			{
				if(!arrCol[i])
					continue;
				var xmlGroup = xmlDpGrid;
				if(arrCol[i].getGroup())
				{
					if(arrGroup[i])
					{
						xmlGroup = arrGroup[i];
					}
					else
					{
						xmlGroup = this.xmlDom.createElement("group");
						xmlDpGrid.appendChild(xmlGroup);
						xmlGroup.setAttribute("text", arrCol[i].getGroup().getText());
						var arrField = arrCol[i].getGroup().getFieldInd();
						for(var n=0; n<arrField.size(); n++)
						{
							var nCol = arrField.elementAt(n);
							arrGroup[nCol] = xmlGroup;
						}
					}
				}
				
				var xmlField = this.xmlDom.createElement("field");
				xmlGroup.appendChild(xmlField);
				xmlField.setAttribute("field", arrCol[i].getField());
				xmlField.setAttribute("text", arrCol[i].getCaption());
				xmlField.setAttribute("width", arrCol[i].getWidth());
				if(arrCol[i].getFormat()!="")
					xmlField.setAttribute("format", arrCol[i].getFormat());
				if(arrCol[i].getRowspan()>1)
					xmlField.setAttribute("rowspan", arrCol[i].getRowspan());
				if(arrCol[i].getAttributes()!="")
					xmlField.setAttribute("attr", arrCol[i].getAttributes());
				if(arrCol[i].getType()!="")
					xmlField.setAttribute("type", arrCol[i].getType());
				if(arrCol[i].getColor()>0)
					xmlField.setAttribute("color", arrCol[i].getColor());
				if(arrCol[i].getFontColor()>0)
					xmlField.setAttribute("fontcolor", arrCol[i].getFontColor());				
				if(arrCol[i].getAggregate()!="")
					xmlField.setAttribute("aggregate", arrCol[i].getAggregate());
				if(arrCol[i].getDpObject()!="")
					xmlField.setAttribute("dpobject", arrCol[i].getDpObject());
				if(arrCol[i].getDpObjFld()!="")
					xmlField.setAttribute("dpobjfld", arrCol[i].getDpObjFld());
				//xmlField.setAttribute("image", arrCol[i].getImage());			
			}			
			
			var xmlGridStruct = this.xmlDom.createElement("GridStruct");
			xmlGridStruct.setAttribute("text", UR("Структура сітки|Структура сетки"));
			xmlList.appendChild(xmlGridStruct);
			var xmlGrid = oGrid.getStructHolder().getXMLGrid(this.xmlDom.xmlDom);
			if(xmlGrid)
				xmlGridStruct.xmlNode.appendChild(xmlGrid);
		}
	}
	
	this.xmlDom.save(this.xmlFile);
	this.refreshTree(listID);
}

function DpOwnList_saveExtPar(par, xmlExtPar)
{
	for(var sPar in par)
	{
		var xmlPar = this.xmlDom.createElement("par");
		xmlPar.setAttribute("ID", sPar);
		xmlPar.setText(par[sPar]);
		xmlExtPar.appendChild(xmlPar);		
		//if(typeOf(par[sPar])=="object" || typeOf(par[sPar])=="Object" || typeOf(par[sPar])=="Array")
		//	this.saveExtPar(par[sPar], xmlPar);
	}
}

function DpOwnList_refreshTree(sListID)
{
	try
	{
		var ownTree = lpProxy.getData("OWNTREE");
		if(!ownTree || ownTree.getCtrl().isDisposed())
			return;
		this.tree = ownTree;
		ownTree.removeAll();
		this.fillTree();		
		if(sListID)
			this.selTreeItem(sListID);
		if(ownTree.isExpanded()==true)
			ownTree.setExpanded(true);
		//ownTree.getCtrl().setVisible(true);
	}
	catch(e)
	{
		//alert(e);
	}
}

function DpOwnList_selTreeItem(sID)
{
	try
	{
		var item = this.tree.getItem(sID);
		if(item)
			this.tree.setSelected(item);
	}
	catch(e)
	{
		
	}
}

function DpOwnList_save(sItemID)
{
	this.xmlDom.save(this.xmlFile);
	this.refreshTree(sItemID);
}

function DpOwnList_saveXml(xmlDom)
{
	if(xmlDom)
		this.xmlDom = xmlDom;
	this.xmlDom.save(this.xmlFile);	
}

function DpOwnList_run(xmlDoc, par)
{
	if(xmlDoc)
		this.load(xmlDoc);
	if(par)
		this.par = par;
	var oPar = this.par;
	oPar.ownList = this;
	oPar.showTree = false;
	oPar.title = this.title;
	if(getPar("OWNLIST_CHANGE_SYSTEM")==true)
		this.checkSystem();
	if(this.name=="list")
	{
		if(this.task!=null && this.task!="")
			showWindow(this.task, SW_NOMODAL, oPar);
		else
			showWindow("ownlist.xml", SW_NOMODAL, oPar);
	}
	else if(this.name=="menu")
	{
		var sPar = "";
		if(this.menuMode)
			sPar = String(this.menuMode);
		lpProxy.getMenuManager().execute(this.type, this.task, sPar);
	}
}

function DpOwnList_checkSystem()
{
	if(!this.system || this.system=="")
		return true;
		
	var curSys = String(getSystem()).toUpperCase();
	var arrSys = String(this.system).trim().split("_");
	for(var n=0; n<arrSys.length; n++)
	{
		var sys = String(arrSys[n]).trim().toUpperCase();
		if(sys==curSys)
			return true;
	}
	
	var system = getSystem();
	var orgMngr = lpProxy.getOrgManager();
	var sysList = orgMngr.getSysList();
	for(var i=0; i<sysList.size(); i++)
	{
		var oSys = sysList.get(i);			
		if(oSys)
		{
			for(var n=0; n<arrSys.length; n++)
			{
				var sys = String(arrSys[n]).trim().toUpperCase();
				if(sys==String(oSys.label).toUpperCase())
				{
					system = oSys.label;
					break;
				}
			}
		}
	}
	
	if(curSys==String(system).toUpperCase())
		return true;
	
	var oPar = getPar("SHOW_SYS_PANEL");
	setPar("SHOW_SYS_PANEL", false);
	lpProxy.getOrgManager().setSys(system);
	setPar("SHOW_SYS_PANEL", oPar);
}
