include("jrxmlTojrxml.js")

var Header;
var Prefix;
var Shapka;
var Body;
var Suffix;
var Footer;

var lastFieldNum = 1;
var lastTFieldNum = 1;
var generateStatics = false;

DpPSFDecoder.prototype.decode = DpPSFDecoder_decode;
DpPSFDecoder.prototype.parseElement = DpPSFDecoder_parseElement;
DpPSFDecoder.prototype.postProcessShapka = DpPSFDecoder_postProcessShapka;
DpPSFDecoder.prototype.parseItem = DpPSFDecoder_parseItem;
DpPSFDecoder.prototype.buildNSave = DpPSFDecoder_buildNSave;

var lastHeight = 0;

function DpPSFDecoder()
{
	Header = new PrnElement();
	Prefix = new PrnElement();
	Shapka = new PrnElement();
	Body = new PrnElement();
	Body.RowDefs = new PrnElement();
	Suffix = new PrnElement();
	Footer = new PrnElement();
}

function DpPSFDecoder_decode(sFilePSF, sFileJR)
{
	lastFieldNum = 1;
	Task.include(sFilePSF, "cp1251");
	OnLoadPgDef();
	this.buildNSave(sFilePSF, sFileJR);
}

function DpPSFDecoder_buildNSave(sFilePSF, sFileJR)
{
	var builder = lpProxy.getJRBuilder();
	var designe = builder.getDesigne();
	
	var headerBand = builder.createBand();
	lastHeight = 0;
	headerBand.addElementGroup(this.parseElement(Header,builder));
	if (lastHeight > 0)
	{
		designe.setTitle(headerBand);
		headerBand.setHeight(lastHeight);
	}

	var prefixBand = builder.createBand();
	lastHeight = 0;
	prefixBand.addElementGroup(this.parseElement(Prefix,builder));
	if (lastHeight > 0)
	{
		prefixBand.setHeight(lastHeight + 25);
		designe.setPageHeader(prefixBand);
	}
		
	var shapkaBand = builder.createBand();
//	generateStatics = true;
	lastHeight = 0;
	
	this.postProcessShapka(Shapka);	
	shapkaBand.addElementGroup(this.parseElement(Shapka,builder));
	if (lastHeight > 0)
	{
		shapkaBand.setHeight(lastHeight);
		designe.setColumnHeader(shapkaBand);
	}
//	generateStatics = false;

	var bodyBand = builder.createBand();
	lastHeight = 0;
	bodyBand.addElementGroup(this.parseElement(Body,builder));
	if (lastHeight > 0)
	{
		bodyBand.setHeight(lastHeight);
		designe.setDetail(bodyBand);
	}

	var suffixBand = builder.createBand();
	lastHeight = 0;
	suffixBand.addElementGroup(this.parseElement(Suffix,builder));
	if (lastHeight > 0)
	{
		suffixBand.setHeight(lastHeight);
		designe.setPageFooter(suffixBand);
	}
	
	var footerBand = builder.createBand();
	lastHeight = 0;
	footerBand.addElementGroup(this.parseElement(Footer,builder));
	if (lastHeight > 0)
	{
		footerBand.setHeight(lastHeight);
		designe.setLastPageFooter(footerBand);
	}

	if(!sFileJR)
	{
		var file = DpFile(sFilePSF);
		var fn = String(file.getName());
		fn = fn.substring(0,fn.lastIndexOf("."));
		sFileJR = "C:\\" + fn + ".jrxml";
	}
	builder.storeDesignTo(sFileJR, false);
	//jrxmlTojrxml(sFileJR, sFileJR);
}

function DpPSFDecoder_parseElement(element,builder,iHeight,nRowIndex)
{
	var band = builder.createElementGroup();
	var nHeight = 0;
	for (var nItem in element.items)
	{
		var curEl = element.items[nItem];
		if (element.condition)
			curEl.style.printCondition = element.condition
		// save old height
		var oldHeight = curEl.height;
		if (iHeight)
			curEl.height = iHeight;
			
		if ((curEl.top && curEl.top > nHeight)
			||(curEl.height && curEl.height > nHeight))
		{
			nHeight = Number((curEl.top?curEl.top:0))
					 + Number((curEl.height?curEl.height:0));
		}
		// restore old height 
		if (curEl.rowspan && curEl.rowspan == 2)
			curEl.height = Number(oldHeight)
		band.addElement(this.parseItem(curEl,builder));
	}
	for (var nRow in element.rows)
	{
		var curRow = element.rows[nRow];
		var iHeight = false;
		if ((curRow.style && curRow.style.itemsHeight) || curRow.height)
		{
			if (curRow.style.itemsHeight && curRow.style.itemsHeight.indexOf("m") !=-1 )
				curRow.style.itemsHeight = curRow.style.itemsHeight.replace("m", "");

			iHeight = (curRow.style.itemsHeight?curRow.style.itemsHeight:(curRow.height?(curRow.height*3):15));
		}
		var rowBand = this.parseElement(curRow,builder,iHeight,nRow);
		band.addElementGroup(rowBand);
	}
//-	band.setHeight(nHeight);
	lastHeight += nHeight;
	return band;
}

function DpPSFDecoder_postProcessShapka(element,iHeight, nRow)
{
	for (var nRow = 0; nRow < element.rows.length; nRow++)
	{
		var curRow = element.rows[nRow];
		var nCountWithoutRowspan = 0;
		for (var nItem = 0; nItem < curRow.items.length; nItem++)
		{
			var curEl = curRow.items[nItem];
			if (curEl.rowspan == 1)
				nCountWithoutRowspan++;
			if (curEl.rowspan == 2)
			{
				var nextRow = element.rows[Number(nRow) + 1];
				if (typeof(nextRow) != "undefined")
				{
					curEl.height = (Number(curRow.height) + Number(nextRow.height)) * 3;
					
					for (var nNextRowItem = nCountWithoutRowspan; nNextRowItem < nextRow.items.length; nNextRowItem++)
					{
						nextRow.items[nNextRowItem].left += curEl.width; 				
					}
				}
			}
			if (curEl.colspan == 2)
			{
				var nextRow = element.rows[Number(nRow) + 1];
				if (typeof(nextRow) != "undefined" && typeof(nextRow.items[nItem]) != "undefined" && typeof(nextRow.items[Number(nItem) + 1]) != "undefined")
				{
					curEl.width = (Number(nextRow.items[nItem].width) + Number(nextRow.items[Number(nItem) + 1].width));
					
					for (var nItem2 = nItem + 1; nItem2 < curRow.items.length; nItem2++)
					{
						curRow.items[nItem2].left += curEl.width; 		
					}
				}
			}
			
			if (curEl.height <= 0)
				curEl.height = 7 * curEl.rowspan;
			if (curEl.width <= 0)
				curEl.width = 15 * curEl.colspan;
		}
	}
}

var border_thin = 5;

function DpPSFDecoder_parseItem(item,builder)
{
	var oItem = null;
//	if (allt(item.sTxt) == "" || generateStatics || item.type == "pn")
	if (item.type == "pn")
	{
		oItem = builder.createTextField();
		if (item.type == "pn")
		{
			var oPN = builder.createTextField();
			oPN.setStretchWithOverflow(true);
			oPN.setY(item.top);
			oPN.setX(item.left + item.width);
			oPN.setHeight(item.height);
			oPN.setHorizontalAlignment(2);
			var PNExpr = builder.createExpression();
	    	PNExpr.setValueClassName("java.lang.String");
    		PNExpr.setText("java.lang.String.valueOf($V{PAGE_NUMBER})");
    		oPN.setExpression(PNExpr);
    		oItem = oPN;
		}
/*		
		else if (item.type == "c")
		{
			var textExpr = builder.createExpression();
		    textExpr.setValueClassName("java.lang.String");
		    textExpr.setText("$F{TFLD" + lastTFieldNum + "}");
	    	oItem.setExpression(textExpr);

		    var Tfield = builder.createField();
		    Tfield.setName("TFLD" + (lastTFieldNum ++));
	    	Tfield.setValueClassName("java.lang.String");
		    Tfield.setDescription(item.sTxt);
		    builder.getDesigne().addField(Tfield);
		}
		item.type = "c";
*/		    
	}
	else if (item.type == "c")
	{
		oItem = builder.createText();
	}
	else
	{
		oItem = builder.createTextField();
		oItem.setStretchWithOverflow(true);
	    oItem.setBlankWhenNull(true);
	}
    oItem.setPositionType(2);
    if (item.top) oItem.setY(item.top);
    else oItem.setY(lastHeight);
	if (item.left) oItem.setX(item.left);
	if (item.width) oItem.setWidth(item.width);
	if (item.height) oItem.setHeight(item.height);
	oItem.setHorizontalAlignment(2);
	if (item.style.align)
	{
		oItem.setHorizontalAlignment(builder.getHorisontalAlign(item.style.align));
	}
	if (item.style.valign)
	{
		oItem.setVerticalAlignment(builder.getVerticalAlign(item.style.valign));
	}
	if (item.style.fontFace)
        oItem.setFontName(item.style.fontFace);
    if (item.style.fontHeight)
    {
    	var iHeight = Math.abs(item.style.fontHeight);
    	if (iHeight == 0)
    		iHeight = 8;
    	oItem.setFontSize(iHeight);
    }
    
    if (item.style.borders)
    {
    	if (item.style.borders & 1)
    		oItem.setLeftBorder(border_thin);
    	if (item.style.borders & 2)
    		oItem.setTopBorder(border_thin);
    	if (item.style.borders & 4)
    		oItem.setRightBorder(border_thin);
    	if (item.style.borders & 8)
    		oItem.setBottomBorder(border_thin);
    }
    if (item.style.fontWeight && item.style.fontWeight > 700)
    	oItem.setBold(true);
    if (item.style.printCondition && allt(item.style.printCondition) != "")
    {
    	var prnExpr = builder.createExpression();
    	prnExpr.setValueClassName("java.lang.Boolean");
    	prnExpr.setText("$F{FLD" + lastFieldNum + "}");
    	
	    var field = builder.createField();
	    field.setName("FLD" + (lastFieldNum ++));
	    field.setValueClassName("java.lang.Boolean");
	    field.setDescription(item.style.printCondition);
	    builder.getDesigne().addField(field);
	    
    	oItem.setPrintWhenExpression(prnExpr);
    }
    
//	TODO: тоже с размером и весом шрифта
//  TODO: типы итемов
	
	if (item.type == "c")
	{
		if (typeof(oItem.setText) != "undefined")
			oItem.setText(item.sTxt);
/*		else if (typeof(oItem.setStyledText) != "undefined")
			oItem.setStyledText(item.sTxt);
		else
			alert("Can not find setText or setStyledText function for text field");		
*/	}
	else if (allt(item.sTxt) != "")
	{
		item.sTxt = allt(item.sTxt);
		var expr = builder.createExpression();
	    expr.setValueClassName("java.lang.String");
	    expr.setText("$F{FLD" + lastFieldNum + "}");
	    oItem.setExpression(expr);
	    
	    var field = builder.createField();
	    field.setName("FLD" + (lastFieldNum ++));
	    if (item.type == "d")
    		field.setDescription("format(dd mmm yyyy," + item.sTxt + ")");
	    else
		    field.setDescription(item.sTxt);
	    field.setValueClassName("java.lang.String");
	    
	    builder.getDesigne().addField(field);
    }
    else
    {
		var expr = builder.createExpression();
		expr.setValueClassName("java.lang.String");
		expr.setText(" ");
		oItem.setExpression(expr);
    }
    return oItem;
}

function PrnElement()
{
	this.items = new Array();
	this.rows = new Array();
	this.style = new Object();
	this.AddItem = PrnElement_AddItem;
	this.AddRow = PrnElement_AddRow;
	this.lastX = 0;
}

function PrnElement_AddRow(sCond)
{
	var nInd = this.rows.length;
	var obj = new PrnElement();
	if (sCond && sCond.indexOf("height=") != -1)
	{
		obj.height = sCond.substring(sCond.indexOf("height=") + 7,sCond.indexOf("m",sCond.indexOf("height=")));
	}
	else
		obj.condition = sCond;
	this.rows[nInd] = obj;
	return obj;
}

function PrnElement_AddItem(sTxt,prsLocation,sType)
{
	var nInd = this.items.length;
	var obj = new Object();
	obj.sTxt = sTxt;
	parseLocation(obj,prsLocation);
	obj.type = sType;
	obj.style = new Object();
	if (obj.left == 0)
	{
		obj.left = this.lastX;
		this.lastX += obj.width;
	}
	this.items[nInd] = obj;
	return obj;
}

function parseLocation(obj,sLoc)
{
//-	"top=0m,left=140m,width=57m,height=5m"
//	if (!sLoc)
//		sLoc = "top=0m,left=0m,width=50m,height=50m";
	if (!sLoc)
		sLoc = "top=0m,left=0m,width=0m,height=0m";
	var nTop = (sLoc.indexOf("top=")!=-1?sLoc.substring(sLoc.indexOf("top=") + 4,sLoc.indexOf("m",sLoc.indexOf("top="))):0);
	var nLeft = (sLoc.indexOf("left=")!=-1?sLoc.substring(sLoc.indexOf("left=") + 5,sLoc.indexOf("m",sLoc.indexOf("left="))):0);
	var nWidth = (sLoc.indexOf("width=")!=-1?sLoc.substring(sLoc.indexOf("width=") + 6,sLoc.indexOf("m",sLoc.indexOf("width="))):0);
	var nHeight = (sLoc.indexOf("height=")!=-1?sLoc.substring(sLoc.indexOf("height=") + 7,sLoc.indexOf("m",sLoc.indexOf("height="))):0);
	var nRowspan = (sLoc.indexOf("rowspan=")!=-1?sLoc.substring(sLoc.indexOf("rowspan=") + 8,sLoc.indexOf("rowspan=") + 9):0);
	var nColspan = (sLoc.indexOf("colspan=")!=-1?sLoc.substring(sLoc.indexOf("colspan=") + 8,sLoc.indexOf("colspan=") + 9):0);

	nTop = parseInt(nTop);
	nLeft = parseInt(nLeft);
	nWidth = parseInt(nWidth);
	nHeight = parseInt(nHeight);
	nRowspan = parseInt(nRowspan);
	nColspan = parseInt(nColspan);
	
	obj.top = (isNaN(nTop)?0:nTop*3);
	obj.left = (isNaN(nLeft)?0:nLeft*2.79);
	obj.width = (isNaN(nWidth)?0:nWidth*2.79);
	obj.height = (isNaN(nHeight)?0:(nHeight)*3);
	obj.rowspan = (isNaN(nRowspan)?1:nRowspan);
	obj.colspan = (isNaN(nColspan)?1:nColspan);
}

function setCrossTable()
{
}

function setLeftShift()
{
}

var style = new Object();