// JScript source code
function DpPluginObject(sID, sVer)
{
	
	this.sID = sID;
	this.sVersion = sVer;
	this.xmlLibRoot = null;
	this.isOrgPlug = false;
	this.isGlobPlug = false;
	
	this.getPluginLib = DpPluginObject_getPluginLib;
	this.getPluginFileLib = DpPluginObject_getPluginFileLib;
	this.getPluginDir = DpPluginObject_getPluginDir;
	this.getLocaleFile = DpPluginObject_getLocaleFile;
	this.getTableName = DpPluginObject_getTableName;
	this.load = DpPluginObject_load;	
	this.load();
}

function DpPluginObject_load()
{
	include("objects//DpXMLDOMDocument.js")
	var sSQL = "select flib, fdir from ^plugin_objs o, ^plugins p "
		+"where p.fwid = o.fwid_plugin and o.fid = "+sqlTo(this.sID);
	var oSnap = getSnap(sSQL);
	
	if (oSnap)
	{
		this.objFile = rootDirectory() + "plugins\\" 
						+ oSnap[1] + "\\" + oSnap[0];
		this.strLocaleFile = "plugins\\" + oSnap[1] + "\\" + oSnap[0];
		this.sPlugDir = rootDirectory() + "plugins\\" + oSnap[1] + "\\";
		this.isOrgPlug = true;
		
	}
	else
	{
		var sSQL = "select flib, fdir from ^gl_plugin_objs o, ^gl_plugins p "
			+"where p.fwid = o.fwid_plugin and o.fid = "+sqlTo(this.sID);
		var oSnap = getSnap(sSQL);
		if (oSnap)
		{
			this.objFile = rootDirectory() + "plugins\\" 
						+ oSnap[1] + "\\" + oSnap[0];
			this.strLocaleFile = "plugins\\" + oSnap[1] + "\\" + oSnap[0];
			this.sPlugDir = rootDirectory() + "plugins\\" + oSnap[1] + "\\";
			this.isGlobPlug = true;
		}		
	}
	
	if (!this.isOrgPlug && !this.isGlobPlug)
	{
		alert("Отсутствует библиотека объекта");
		this.isLoaded = false;
		return false;
	}
	else
	{
		this.isLoaded = true;
	} 

	this.xmlDom = new DpXMLDOMDocument();
	this.xmlDom.load(this.objFile);
	this.xmlLibRoot = this.xmlDom.getDocumentElement();	
}

function DpPluginObject_getPluginLib()
{
	return this.xmlLibRoot;
}

function DpPluginObject_getPluginFileLib()
{
	return this.objFile;
}

function DpPluginObject_getPluginDir()
{
	return this.sPlugDir;
}

function DpPluginObject_getLocaleFile()
{
	return this.strLocaleFile;
}

function DpPluginObject_getTableName()
{
	var xmlTableElem = this.xmlLibRoot.selectSingleNode("cltable");
	var result = "";
	if(null != xmlTableElem)
		result = xmlTableElem.getAttribute("table");
		
	return result;
}