// JScript source code
function DpPluginRegistrator(doMod,doProgress)
{
	this.registerPlugins = registerPlugins;
	this.register = register;
	this.deRegPlug = deRegPlug;
	this.regPlug = regPlug;
	this.sPlugRoot = rootDirectory()+"plugins";
	this.getText = getText;
	this.setupPlug = setupPlug;
	this.createTable = Plug_createTable;
	this.createFindData = Plug_createFindData;
	this.loadScript = loadScript;
	this.addFieldToStru = addFieldToStru;
	this.defaultSetup = defaultSetup;
	this.sPlugTbl = "^gl_plugins";
	this.sPlugObjsTbl = "^gl_plugin_objs";
	
	this.doMod = false;
	if (doMod)
		this.doMod = true;
	this.doProgress = false;
	if (doProgress)
		this.doProgress = true;
}



function deRegPlug()
{
	ExecuteSQL("DELETE FROM ^cl_plugfrm");
	ExecuteSQL("DELETE FROM ^plugin_objs");
	ExecuteSQL("DELETE FROM ^plugins");
	ExecuteSQL("DELETE FROM ^gl_plugin_objs");
	ExecuteSQL("DELETE FROM ^gl_plugins");
}




function registerPlugins()
{
	this.deRegPlug();
	this.register();
	this.sPlugRoot = getOrgPath()+"plugins";
	this.sPlugTbl = "^plugins";
	this.sPlugObjsTbl = "^plugin_objs";
	
	var files = new DpFile(this.sPlugRoot);
	var progress;
	if (files.isDirectory())
		progress = createProgress(files.listFiles().length);
	this.register(progress);
	if (progress)
		progress.close();
}

function register(progress)
{
	var file = new DpFile(this.sPlugRoot);
	if(file.isDirectory())
	{
		var files = file.listFiles();
		for(var i=0; i<files.length; i++)
		{
			if (progress)
				progress.getProgressMonitor().worked(1);
			var plugDir = files[i];
			if(!plugDir.isDirectory()
			|| plugDir.isHidden())
				continue;
			
			var sPlugFile = plugDir.getAbsolutePath()+ "\\plugin.xml";
			if (isFile(sPlugFile))
				this.regPlug(sPlugFile, plugDir.getName());
		}
	}
}

function regPlug(sFile, sDir)
{
	include("objects\\DpXMLDomDocument.js");
	var xmlDom = new DpXMLDOMDocument();
	xmlDom.load(sFile);
	var plugXML = xmlDom.getDocumentElement();
	var sId = plugXML.getAttribute("id");
	var sVer = plugXML.getAttribute("version");
	var sSQL = "SELECT FVERSION FROM " + this.sPlugTbl + " where fid = " +sqlTo(sId)
	+ " and fversion = "+sqlTo(sVer);
	if(getSnap(sSQL))
		return;
		
	var sFWID = GetUID();
	var sName = plugXML.getAttribute("name");
	if (sName)
		sName = this.getText(sName, sDir);
	
	var sSQL = "INSERT INTO " + this.sPlugTbl 
			+ " (FWID, FID, FVERSION, FNAME, FDIR)"
			+ " VALUES (" + sqlTo(sFWID) 
						+ "," + sqlTo(sId)
						+ "," + sqlTo(sVer) 
						+ "," + sqlTo(sName)
						+ "," +sqlTo(sDir)
						+ ")";
	ExecuteSQL(sSQL);
	
	var objects = plugXML.getElementsByTagName("object")
	for (var i = 0; i < objects.length; i++)
	{
		var sIdObj = objects[i].getAttribute("id");
		if (!sIdObj)
			continue;
			
		var sTypeObj = objects[i].getAttribute("type");
		if (!sTypeObj)
			continue;
			
		var sLibObj = objects[i].getAttribute("lib");
		if(!sLibObj)
			continue;
		
		var sNameObj = objects[i].getAttribute("name");
		if (sNameObj)
			sNameObj = this.getText(sNameObj,sDir);
		
		var sFWIDOBJ = GetUID();
		var sSQL = "INSERT INTO " + this.sPlugObjsTbl 
				+ " (FWID, FID, FNAME, FID_PLUGIN, FWID_PLUGIN, FVERSION, FTYPE, FLIB)"
				+ " VALUES (" + sqlTo(sFWIDOBJ) 
						+ "," + sqlTo(sIdObj)
						+ "," + sqlTo(sNameObj)
						+ "," + sqlTo(sId)
						+ "," + sqlTo(sFWID)
						+ "," + sqlTo(sVer)
						+ "," + sqlTo(sTypeObj)
						+ "," + sqlTo(sLibObj)
						+ ")";
		ExecuteSQL(sSQL);
		this.defaultSetup(objects[i], sDir);		
	}
	
	this.setupPlug(sDir);
}

function defaultSetup(object, sDir)
{
	var sType = object.getAttribute("type")
	switch (sType)
	{
	case "DpFrmRep":
				
		var sSQL = "DELETE FROM ^cl_plugfrm"
				+ " WHERE fid=" + sqlTo(object.getAttribute("id"))
					+ " AND fversion=" + sqlTo(object.getAttribute("version"));
		ExecuteSQL(sSQL);		
		var m = new Object(); 
		m.FWID = GetUID();
		m.FID = object.getAttribute("id");
		m.FNAME = object.getAttribute("name");
		m.FVERSION = object.getAttribute("version");
		updateTable("^cl_plugfrm", m, true);														
		break;
		
	case "DpPopupMenu":
		break;	
		var sSQL = "DELETE FROM ^ucmenu WHERE ffile = "
			+ sqlTo(object.getAttribute("id"));
		ExecuteSQL(sSQL);		
		var m = new Object(); 
		m.FFILE = object.getAttribute("id");
		m.FREM= object.getAttribute("name");
		
		var sFile = this.sPlugRoot+"\\"+sDir+"\\"+object.getAttribute("lib");
		var xmlDom = new DpXMLDOMDocument();
		xmlDom.load(sFile);
		m.FTASK = xmlDom.getDocumentElement().getAttribute("task");	
		
		updateTable("^ucmenu",m,true);														
		break;
	}
}

function getText(sID, sDir)
{
	if (sID.substr(0,3) != "ID_")
		return sID;
	
	var lang = getPar("Language");	
	var slocFile = this.sPlugRoot + "\\" + sDir + "\\lang\\rus\\common.xml";
	var xmlDomLoc = new DpXMLDOMDocument();
	xmlDomLoc.load(slocFile);
	var nodes = xmlDomLoc.getElementsByTagName(sID);
	if(0==nodes.length)
		return sID;
	else
		return nodes[0].getText();
}

function setupPlug(sDir)
{
	var sSetupFile = this.sPlugRoot+"\\"+sDir+"\\setup\\setup.xml";
	if (!isFile(sSetupFile))
		return;
	
	var xmlDomSet = new DpXMLDOMDocument();
	xmlDomSet.load(sSetupFile);
	//Регистрация паттернов в Winstru.xml
	lpProxy.registerPatterns(xmlDomSet.getDocumentElement().xmlNode);
	//Создание(модификация) таблиц
	var tables = xmlDomSet.getDocumentElement().getElementsByTagName("table");
	include("objects\\DpDbMod.js");
	var dbMod = new DpDbMod();
	for (var k = 0; k < tables.length; k++)
	{
//-		this.createTable(tables[k]);
		lpProxy.registerTable(tables[k].xmlNode);
		
		if (this.doMod)
		{
			var tblInfo = new tableModInfo();
			tblInfo.base = tables[k].getAttribute("path");
			tblInfo.sys = tables[k].getAttribute("sys");
			tblInfo.table = tables[k].getAttribute("table");
			tblInfo.pattern = tables[k].getAttribute("pattern");
			if (!tblInfo.sys)
				tblInfo.sys = "PLG";
			tblInfo.domod = true;
			tblInfo.version = "0";
			tblInfo.fullName = (tblInfo.sys==""?"":tblInfo.sys + "_") + tblInfo.table;
			tblInfo.exists = IsTableEx(tblInfo.base,tblInfo.fullName);
			
			dbMod.modTable(tblInfo);
		}
	}
	
	var scripts = xmlDomSet.getElementsByTagName("script");
	for (var k = 0; k < scripts.length; k++)
	{
		this.loadScript(this.sPlugRoot+"\\"+sDir+"\\setup\\",scripts[k]);		
	}
}

function Plug_createTable(xmlTbl)
{
	lpProxy.registerXMLTable(xmlTbl.xmlNode);
	var sBase = xmlTbl.getAttribute("path");
	var sTblName = xmlTbl.getAttribute("table");
	var sSys = xmlTbl.getAttribute("sys");
	if (!sSys)
	{
		sSys = "PLG";
	}
	
	if(!sBase || !sTblName)
	{
		alert(ru("Невозможно создать таблицу для плагина.", "Не можливо створити таблицю для плагіна."));
		return;
	}
	include ("objects\\DpDbMod.js");
	var dbMod = new DpDbMod();
	with (dbMod)
	{	
		initMdb(null, -1, null);
		openSys(sSys);
		openMdb(sBase);
		begModify(sTblName);
		endModify();		
	}
}

function Plug_createFindData(xmlFind)
{
	var sPattern = xmlFind.getAttribute("pattern");
	if (!sPattern) return;
	ExecuteSQL("DELETE FROM ^eta_find where fpattern = " + sqlTo(sPattern));
	var keys = xmlFind.getElementsByTagName("key");
	for (var i = 0; i < keys.length; i++)
	{
		var r = new Object();
		r.fpos = i;
		r.ftype = getFindType(keys[i].getAttribute("type"));
		r.fdptype = getFindDpType(keys[i].getAttribute("type"));
		r.fpattern = sPattern;
		r.ffield = keys[i].getAttribute("field");
		r.ftxt = keys[i].getText();
		updateTable("^eta_find",r,true);
	}
}


function addFieldToStru(xmlFld, sPattern)
{
	sSQL = "INSERT INTO ^strufields (fpattern,ffield,facctype,fwintype) VALUES( "
			+ sqlTo(sPattern) + "," + sqlTo(xmlFld.getNodeName()) + "," 
			+ sqlTo(xmlFld.getAttribute("type")) + "," 
			+ sqlTo(xmlFld.getAttribute("type")) + ")";		
	ExecuteSQL(sSQL);
}

function loadScript(sDir,xmlSrc)
{
	var src = xmlSrc.getAttribute("src");
	if(src)
	{
		include(sDir+src);
	}
	else
	{
		eval(xmlSrc.getText());	
	}		
}

function getFindType(sType)
{
	switch(sType)
	{
	case "TDOC":
	case "TNMK":
	case "text":
		return 10;
	case "TCL":
	case "TST":
	case "long":
		return 4;
	case "TSC":
	case "TSU":
	case "TNOP":
	case "TCALC":
	case "int":
		return 3;
	case "float":
	case "TQNT":
	case "TSUM":
	case "TPRI":
		return 7;
	case "date":
		return 8;
	case "bool":
		return 1;
	default:
		return -1;
	}
}

function getFindDpType(sType)
{
	switch(sType)
	{
	case "TSUM":
		return 256;
	case "TQNT":
		return 257;
	case "TPRI":
		return 257;
	case "TNOP":
		return 259;
	case "TDOC":
		return 260;
	case "TSC":
		return 261;		
	case "TSU":
		return 262;		
	case "TST":
		return 263;		
	case "TCL":
		return 264;	
	case "TNMK":
		return 264;
	case "TCALC":
		return 268;			
	default:
		return -1;
	}
}

function createProgress(nLength)
{
	var progress = new Packages.org.eclipse.jface.dialogs.ProgressMonitorDialog(Packages.org.eclipse.swt.widgets.Display.getCurrent().getActiveShell());
    progress.open();
    progress.getShell().setText("Регистрация плаг-инов...");
    progress.getProgressMonitor().beginTask("", nLength);
    return progress;
}