include ("Objects/DpXMLDomDocument.js");
DpRSS.prototype.parseRSS = DpRSSParser_parseRSS;
DpRSS.prototype.parseXML = DpRSSParser_parseXML; 

function DpRSS()
{
	this.parseChannel = DpRSSParser_parseChannel;
	this.parseItem = DpRSSParser_parseItem;
}

function DpRSSParser_parseRSS(sUrl,timeout)
{
	var oDom = new DpXMLDOMDocument();
	if (!timeout)
		timeout = 10000;
	var ret = oDom.loadFromURL(sUrl, false, timeout);
	if (!ret)
		return false;
	
	return this.parseXML(oDom.getDocumentElement());
}

function DpRSSParser_parseXML(oDoc)
{
	this.xmlChannel = null;
	if (oDoc.getNodeName() == "channel")
	{
		this.xmlChannel = oDoc;
	}
	else
	{
		var channels = oDoc.getElementsByTagName("channel");
		if (channels != null && channels.length > 0)
			this.xmlChannel = channels[0];		
	}
	
	if (this.xmlChannel == null)
		return false;
	
	this.parseChannel();
	return true;
	
}

function DpRSSParser_parseChannel()
{
	this.rssItems = new Array()
	var childs = this.xmlChannel.getChildNodes();
	for(var i = 0; i < childs.length; i++)
	{
		var child = childs[i];
		switch (String(child.getNodeName()))
		{
			case "title":
				this.title = child.getText();
				break;
			case "link":
				this.link = child.getText();
				break;
			case "description":
				this.description = child.getText();
				break;
			case "item":
				var item = this.parseItem(child);
				this.rssItems[this.rssItems.length] = item; 
				break;
			default:
				break;
		} 
	}
}

function DpRSSParser_parseItem(xmlItem)
{
	var ret = new Object();
	var childs = xmlItem.getChildNodes();
	for(var i = 0; i < childs.length; i++)
	{
		var child = childs[i];
		switch (String(child.getNodeName()))
		{
			case "title":
				ret.title = child.getText();
				break;
			case "link":
				ret.link = child.getText();
				break;
			case "description":
				ret.description = child.getText();
				break;
			case "dc:creator":
				ret.creator = child.getText();
				break;
			case "pubDate":
				var sPubDate = child.getText();
				var e;
				try
				{
				ret.pubDate = new Date(sPubDate).getVarDate();
				}
				catch(e)
				{
					
				}
				break;
			case "category":				
				break;	
			default:
				ret[String(child.getNodeName())] = child.getText();
				break;
		} 
	}
	
	return ret;
}


