/*
   Описание объекта "элемент справочника параметры регистраций": DpRegVid
   (C) ДЕБЕТ Плюс, 1998-1999

   Конструктор DpRegVid.
      Возвращает this

   Внешние методы:
   .setVid(cod)   - Установить вид параметра регистрации
   .getVid()      - Получить вид параметра регистрации
   .getText()       - Получить наименование параметра регистрации
   .valid()        - Проверка, существует ли запись по заданному виду параметра регистрации
   .linkCtrl()     - Связать с полем ввода
   .validCtrl()    - Реакция на выход из связанного поля ввода

   Внутренние свойства:
   .RegVid           - вид параметра регистрации
   .Nzv            - наименование вида параметра регистрации
   .ctrl           - связь с полем ввода. 
   
   ВАЖНОЕ ПРИМЕЧАНИЕ:
   Объект НЕ работает с таблицами, хотя изначально это и 
   предполагалось. На данный момент все виды журналов регистраций
   жестко забиты в код данного объекта, но на будущее предполагается
   возможность перенести виды журналов регстраций в таблицу REGVID
   (эта таблица уже даже описана в WinStru.txt, но на данном этапе не
   используется, т.к. не хватало времени для:
   - создание текстового файла с описаниями видов регистраций
   - компиляции этого текстового файла
   - сверки с эталонами
   - HTML для просмотра списка уже есть(!) - l_regvid.htm
   )
*/
// Конструктор объекта DpRegVid
function DpRegVid()
{
	RO("DpRegVid", this);
	this.setVid = DpRegVid_setVid;
	this.getVid = DpRegVid_getVid;
	this.getText = DpRegVid_getText;
	this.linkCtrl = DpRegVid_linkCtrl;
	this.validCtrl = DpRegVid_validCtrl;
	   
	this.aVids = new Array();//(Object);
	this.aVids[""] = ""
	this.aVids["+"] = "покупок";
	this.aVids["-"] = "продаж";
	this.setVid("");
}

// Установить вид параметра регистрации
function DpRegVid_setVid(cod)
{
	this.RegVid = cod;
	
	this.Nzv = this.aVids[cod];
	
	if(!this.Nzv)
		this.Nzv = "";

	if(this.ctrl && this.ctrl.value!=cod)
		this.ctrl.value = cod;
}

// Получить вид параметра регистрации
function DpRegVid_getVid()
{
    return this.RegVid;
}

// Получить наименование вида параметра регистрации
function DpRegVid_getText()
{
    return this.Nzv;
}

// Связать с полем ввода
function DpRegVid_linkCtrl(ctrl)
{
	this.ctrl = ctrl;
	if(typeof(ctrl)!="object")
		return;

	for(var c in this.aVids)
	{
		this.ctrl.addItem(c, this.aVids[c]);
	}
		
	setValid(this.ctrl, this, "validCtrl");
	this.ctrl.value = this.RegVid;
}

function DpRegVid_validCtrl()
{
	this.setVid(this.ctrl.value);
}