/*
   Описание объекта "выбор номера сберкассы в зарплате": DpSbcs
   (C) ДЕБЕТ Плюс, 2006

   Конструктор DpSbcs.

	autor draco (Степанчук Д.В.)
*/

// Конструктор объекта DpSbcs
function DpSbcs(mode)
{
	RO("DpSbcs", this);
	this.setCod = DpSbcs_setCod;
	this.getCod = DpSbcs_getCod;
	this.getRsch = DpSbcs_getRsch;
	this.getMfo = DpSbcs_getMfo;
	this.getBnk  = DpSbcs_getBnk;
	this.getOkpo = DpSbcs_getOkpo;
	this.valid   = DpSbcs_valid;
	this.linkCtrl = DpSbcs_linkCtrl;
	this.validCtrl = DpSbcs_validCtrl;
	this.zavalSbcsRec = DpSbcs_zavalSbcsRec;
	this.updateCtrl = DpSbcs_updateCtrl;
	this.getMode = DpSbcs_getMode;
	this.setMode = DpSbcs_setMode;
	if(mode)
		this.setMode(mode);
	else
		this.setMode("");
	return this;
 }

// Установить номер сберкассы
function DpSbcs_setCod(cod)
{ 
	this.table = OpenTable("s", "SELECT * FROM ^CL_SBCS WHERE fnum = " + sqlTo(String(cod)));
	if (this.table && !this.table.IsEmpty())
	{
		if(this.ctrl)
			this.ctrl.value = String(this.table.getValue("fnum"));
		this.num = String(this.table.getValue("fnum"));
		this.r_sch = this.table.getValue("fr_sch");
		this.nbnk = this.table.getValue("fotd_bnk");
		this.mfo = this.table.getValue("fmfo");
		this.okpo = this.table.getValue("fokpo");
	}
	else
	{
		if(this.ctrl)
			this.ctrl.value = String(cod);
		this.num = String(cod);
		this.r_sch = "";
		this.nbnk = "";
		this.mfo = 0;
		this.okpo = "";
		this.table = null;
	}
	this.updateCtrl();
}

// Получить номер сберкассы
function DpSbcs_getCod()
{
    if (this.num)
    	return this.num;
    return 0;
}

// Получить расчетный счет
function DpSbcs_getRsch()
{
	if (this.r_sch)
		return this.r_sch;
	return "";
}

// Получить МФО
function DpSbcs_getMfo()
{
    if (this.mfo)
    	return this.mfo;
    return 0;
}

// Получить код ОКПО
function DpSbcs_getOkpo()
{
    if (this.okpo)
		return this.okpo;
	return "";
}

// Получить название банка
function DpSbcs_getBnk()
{
	if (this.nbnk)
		return this.nbnk;
	return "";
}

// Проверка, существует ли запись по заданному N сберкассы
function DpSbcs_valid()
{  
	var Ok;
	this.table = OpenTable("s","SELECT * FROM ^CL_SBCS WHERE fnum = " + sqlTo(String(this.ctrl.value)));
	Ok = (this.table && !this.table.IsEmpty()) || (this.getMode().indexOf("0")!=-1 && (this.getCod()==0 || this.ctrl.value == 0));
/*  if (this.table)
  	Ok = !this.table.IsEmpty();
  else
  {
     this.table = OpenTable("s","SELECT * FROM ^CL_SBCS WHERE fnum = " + sqlTo(String(this.ctrl.value)));
     Ok = this.table && !this.table.IsEmpty();
  }*/
	return Ok;
}

// Связать с полем ввода
function DpSbcs_linkCtrl(ctrl, ctrlbnk, ctrlrsch, ctrlmfo)
{  
	if (typeof ctrl == "undefined")
		return;
	this.ctrl = ctrl;
	if (typeof ctrlbnk != "undefined")
	{
   		this.ctrlbnk = ctrlbnk;
   		Disable(this.ctrlbnk);
   	}
   	if (typeof ctrlrsch != "undefined")
   	{
   		this.ctrlrsch = ctrlrsch;
   		Disable(this.ctrlrsch);
   	}
   	if (typeof ctrlmfo != "undefined")
   	{
   		this.ctrlmfo  = ctrlmfo;
   		Disable(this.ctrlmfo);
   	}
   
	this.ctrl.setMask("&&&&&&&&&&");	
	this.ctrl.isButton = true;
	setValid(this.ctrl, this, "validCtrl");
	setButton(this.ctrl, this, "zavalSbcsRec");
	
	if (this.ctrlbnk)
		this.ctrlbnk.setMask("&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&");
	if (this.ctrlrsch)
		this.ctrlrsch.setMask("&&&&&&&&&&&&&&&");
	if (this.ctrlmfo)
		this.ctrlmfo.setMask("######");
	
	//если запись единственная, тогда ее сразу и выбираем
	var snap = getSnap("select count(*), min(fnum) from ^cl_sbcs");
	if(snap && snap[0]==1 && this.getMode().indexOf("0")==-1)
		this.setCod(snap[1]);
	else	
		this.setCod(0);
}

function DpSbcs_validCtrl()
{
    if (!this.valid()) 
    	return this.zavalSbcsRec();
    this.setCod(this.ctrl.value);
    return true;
}

function DpSbcs_zavalSbcsRec()
{
	var par = new Object();
	par.escape = true;
	par.ret = new Object();
	par.ret.fnum = 0;
	showWindow("l_sbcs.js", SW_MODAL, par);
	if (!par.escape) 
		this.setCod(par.ret.fnum);
	return !par.escape;
}

function DpSbcs_updateCtrl()
{   
	if (this.ctrlbnk)
		this.ctrlbnk.value = this.getBnk();
	if (this.ctrlmfo)
		this.ctrlmfo.value = this.getMfo();
	if (this.ctrlrsch)
		this.ctrlrsch.value = this.getRsch();
}

function DpSbcs_getMode()
{
	return this.mode;
}

function DpSbcs_setMode(mode)
{
	this.mode = mode;
}