﻿/*
	Объект для ввода выражения для документа: DpScExpr
	(C) ДЕБЕТ Плюс, 1999

	Конструктор DpScExpr:
		DpScExpr(mode, ctrl)
			mode - режим ввода выражения
				mode = "R" - выражение для чтения
				mode = "W" - выражение для записи
				mode = "XSUB" - выражение для получения элемента
				                основного справочника для расширения
				                по подсправочнику
				mode = "XSUBH" - то же, но для расширений заголовка
	
*/
include("sys\\docinfo.js");
include("sys\\udfs.js");
include("objects/DpNmkl.js");

function DpScExpr(mode, ctrl)
{
	RO("DpScExpr", this);
	this.linkCtrl = DpScExpr_linkCtrl;
	this.addCl_schet = DpScExpr_addCl_schet;
	this.menuInitial = DpClExpr_menuInitial;
	this.menuChoose = DpScExpr_menuChoose;
	this.setValue = DpScExpr_setValue;
	this.getValue = DpScExpr_getValue;
	this.setTxt = DpScExpr_setValue; // для совместимости
	this.getTxt = DpScExpr_getValue;
	
	this.mode = mode.toUpperCase();

	this.ctrl = new Object();
	this.ctrl.text = "";

	this.linkCtrl(ctrl);
	
	this.aItems = new Array();
	this.typeValue = "";
}

function DpScExpr_addCl_schet(objSc, objSu, objSt, objAn1, objAn2, objAn3)
{
	this.objSc = objSc;
	this.objSu = objSu;
	this.objSt = objSt;
	this.objAn1 = objAn1;
	this.objAn2 = objAn2;
	this.objAn3 = objAn3;
}

function DpScExpr_linkCtrl(ctrl)
{
	if(!ctrl)
		return;

	if(ctrl.DpType!="DpFork" && !JAVA)
	{
		alert("К объекту DpScExpr можно привязать только поле ввода типа DpFork");
		return;
	}
	
	if(typeof ctrl.MenuHandler != "undefined")
	{
		ctrl.MenuHandler(this, "menuChoose");
		ctrl.MenuInitial(this, "menuInitial");
	}
	this.ctrl = ctrl;
}

function DpClExpr_menuInitial()
{
	this.aItems.length = 0;
	with(this.ctrl)
	{
		if(this.mode == "SC")
		{
			if(this.objSc)
			{
				mnuTxtSc = UR("План рахунків|План счетов");
				AddItem({mode:"SC"}, mnuTxtSc);
			}
		}
		else
		{
			this.objSchet = new DpSc("cut");
			sc = isNaN(Number(this.objSc.getValue())) ? 0 : Number(this.objSc.getValue());
			su = isNaN(Number(this.objSu.getValue())) ? 0 : Number(this.objSu.getValue());
			st = isNaN(Number(this.objSt.getValue())) ? 0 : Number(this.objSt.getValue());
			
			var isValid = this.objSchet.set(sc, su, st);
			if(!this.objSchet.valid(true))
			{
				AddItem({mode:"CL", oCl:null}, UR("Дов. аналітики |Спр. аналитики"));
				AddItem({mode:"NMKL"}, UR("Номенклатура|Номенклатура"));
				AddItem({mode:"CNTRCT"}, UR("Договір|Договор"));
			}
			else
			{
				//если счет валидный то отображаем только завал в нужный справочник
				var objSchet = new DpSc("cutxyz");
				objSchet.set(sc, su, st);
				var oCl = eval("objSchet.getObjCl"+this.mode.right(1)+"()");
				
				switch (oCl.type.toUpperCase())
				{
					case "NMKL":
						AddItem({mode:"NMKL"}, UR("Номенклатура|Номенклатура"));
					break;
					
					case "CNTRCT":
						AddItem({mode:"CNTRCT"}, UR("Договір|Договор"));
					break;
				
					default:
						AddItem({mode:"CL", oCl:oCl.obj}, UR("Дов. аналітики |Спр. аналитики")+eval("objSchet.getClcl"+this.mode.right(1)+"()"));
					break;
				}	
			}			
		}
	}
}

function DpScExpr_menuChoose(obj)
{
	var vName = "";

	var par = new Object();
	par.isZaval = true;
	
	switch(obj.mode)
	{
		case "SC":
			var par = new Object();

			par.ret = new Object();
			par.ret.Fschet = isNaN(par.ret.Fschet)? 0: Number(par.ret.Fschet);
			par.ret.Fsubschet = isNaN(par.ret.Fsubschet)? 0: Number(par.ret.Fsubschet);
			par.ret.Fstat = isNaN(par.ret.Fstat)? 0: Number(par.ret.Fstat);

			showWindow("l_clsch.js", SW_MODAL, par);
			
			if(!par.escape)
			{
				this.objSc.setValue(String(Math.round(Number(par.ret.Fschet))));
				this.objSu.setValue(String(Math.round(Number(par.ret.Fsubschet))));
				this.objSt.setValue(String(Math.round(Number(par.ret.Fstat))));
			}
		break;
		
		case "CL":
			var objAn = eval("this.objAn"+this.mode.right(1));
			var anVal = (objAn!=null && isNaN(Number(objAn.getValue())) )? 0 : Number(objAn.getValue());
			
			if(obj.oCl == null)
			{
				//спросим справочник
				var par = new Object();
				par.ret = new Object();
				par.ret.FCOD = 0;
				par.zaval = true;				
				showWindow("l_clcl.js",SW_MODAL,par);
				if(!par.escape)
				{				
					obj.oCl = new DpCl();
					obj.oCl.setClcl(par.ret.FCOD);
				}
			}
			//showObject(obj.oCl);
			if(obj.oCl)
			{
				oCl = new DpCl();
				oCl.setCod(anVal);
				oCl.setClcl(obj.oCl.getClcl());
				oCl.zaval();			
				
				if(oCl.isValid)
				{
					objAn.setValue(String(Math.round(Number(oCl.cod))));
					this.typeValue = obj.mode+":"+oCl.getClcl();
				}
				else
					return "";
			}
			else
				return "";
		break;
		
		case "NMKL":
			var objAn = eval("this.objAn"+this.mode.right(1));
			var anVal = (objAn!=null && isNaN(Number(objAn.getValue())) )? 0 : Number(objAn.getValue());
			var oNmkl = new DpNmkl(anVal);
			oNmkl.doZaval();
			if(oNmkl.isChanged())
			{
				objAn.setValue(String(oNmkl.getFwid()));
				this.typeValue = obj.mode;
			}
			else
				return "";
		break;
		
		case "CNTRCT":
			var objAn = eval("this.objAn"+this.mode.right(1));
			var anVal = (objAn!=null && isNaN(Number(objAn.getValue())) )? 0 : Number(objAn.getValue());
			var oCntrct = new DpCntrct("*", "", anVal);
			oCntrct.zaval();
			if(oCntrct.valid())
			{
				objAn.setValue(String(oCntrct.getID()));
				this.typeValue = obj.mode;
			}
			else
				return "";
		break;
	}
}

function DpScExpr_setValue(newExpr)
{
	this.ctrl.text = newExpr? newExpr: "";
}

function DpScExpr_getValue()
{
	return this.ctrl.text;
}