// JScript source code

function DpScannerHandler(ctrl)
{
	this.linecode = "";
	this.deltaTime = IS_WEB?150:40;
	this.lasttime = 0;
	this.ctrl = ctrl;
		
	this.onKeyInput = DpScannerHandler_onKeyInput;
	this.dispose = DpScannerHandler_dispose;
	this.handleLinecode = DpScannerHandler_handleLinecode;
	this.objHandler = null;
	this.handleFunc = null;
	this.setHandler = DpScannerHandler_setHandler;
	this.listener = DpUtils.createListener(Task.getScriptEngine(), this, "onKeyInput");
	Display.addFilter(SWT.KeyDown, this.listener);
}

function DpScannerHandler_onKeyInput(ev)
{
	try
	{
		trace("DpScannerHandler_onKeyInput: ctrl - "+ this.ctrl +" > widget - "+ ev.widget)
		if(this.ctrl)
		{
			trace("DpScannerHandler_onKeyInput: > ctrl - "+ this.ctrl +" > "+ (this.ctrl.isDisposed()))
			if(this.ctrl.isDisposed && this.ctrl.isDisposed())
			{
				ev.doit = false;
				this.dispose();
				return;
			}
			if(typeOf(ev.widget)=="Text" && typeOf(this.ctrl)!="Text")
			{
				return;
			}
		}
	
		var nCode = Number(ev.character);
		if(IS_WEB)
		{
			nCode = Number(RWT.getRequest().getParameter("org.eclipse.swt.events.keyDown.charCode"));
		}
		if (nCode>=48 && nCode <= 57)
		{
			var time = IS_WEB?(new Date().getTime()) : Number(ev.time);
			if (time - this.lasttime <= this.deltaTime)
			{
				this.linecode += String(nCode - 48);
				ev.doit = false;
			}
			else
			{
				this.linecode = String(nCode - 48);
			}
			
			this.lasttime = time;
			
		}
		else if(nCode == 13 && this.linecode.length > 5)
		{
			this.handleLinecode();
			this.linecode = "";
			this.lasttime= 0;
			ev.doit = false;
		}	
		else
		{
			this.linecode = "";
			this.lasttime= 0;
		}
		
		trace(String(ev.character) + " - " + ev.time + " - " + this.linecode);
	}
	catch(ex)
	{
		trace("DpScannerHandler_onKeyInput: "+ ex);
	}
	
}

function DpScannerHandler_dispose()
{
	Display.removeFilter(SWT.KeyDown, this.listener);
	this.listener = null;
	this.objHandler = null;
	this.handleFunc = null;
}

function DpScannerHandler_setHandler(obj, funcName)
{
	this.objHandler = obj;
	if (funcName)
		this.handleFunc = funcName;
}
function DpScannerHandler_handleLinecode()
{
	var linecode = this.linecode;
	this.linecode = "";
	this.lasttime= 0;
	
	trace("DpScannerHandler_handleLinecode: "+ linecode +"\n");
	if(typeof this.objHandler == "function")
		this.objHandler(linecode);
	else if (typeof this.objHandler == "object" && typeof(this.handleFunc) == "string")
		this.objHandler[this.handleFunc](linecode);	
		
}