/*                            
   Описание объекта "элемент справочника шифров производственных затрат": DpShifPZ
   (C) ДЕБЕТ Плюс, 2000

   Конструктор DpShifPZ.
      Возвращает this

   Внешние методы:
   .setFshpz(Fshpz)  - Установить номер шифра произв.затрат
   .getFshpz()    - Получить номер шифра произв.затрат
   .setFtxt(Ftxt)   - Установить название шифра произв.затрат
   .getFtxt()       - Получить название шифра произв.затрат
   .valid()       - Проверка, существует ли запись по заданному номеру
   .linkCtrl(ctrlShpz,ctrlTxtl) - Связать с полем ввода
   .validCtrl()       - Реакция на выход из связанного поля ввода
   .zaval()       - Осуществляется завал при нажатии кнопки.

   Внутренние свойства:
   .Fshpz            - номер шифра произв.затрат
      Используется только в методах setFshpz и getFshpz.
      В остальных случаях используйте эти методы.
   .Ftxt        - название шифра произв.затрат
      Используется только в методах setFtxt и getFtxt.
      В остальных случаях используйте эти методы.
   .table          - таблица для внутреннего использования в объекте.
   .ctrlShpz,ctrlTxt - связь с полями ввода. 
   .isButton       - кнопка для завала.
   .updateCtrl     - обновление полей ввода.
   .isValid        - Проверка, существует ли запись по заданному номеру
*/
include("sys/udfs.js");
include("Objects/DpCl.js");

// Конструктор объекта DpShifPZ
function DpShifPZ(mode, par)
{
	RO("DpShifPZ", this);
	this.setFshpz   = DpShifPZ_setFshpz;
	this.getFshpz   = DpShifPZ_getFshpz;
	this.setFtxt    = DpShifPZ_setFtxt;
	this.getFtxt    = DpShifPZ_getFtxt;
	this.getClIzd   = DpShifPZ_getClIzd;
	this.getCodIzd  = DpShifPZ_getCodIzd;
	this.valid      = DpShifPZ_valid;
	this.linkCtrl   = DpShifPZ_linkCtrl;
	this.validCtrl  = DpShifPZ_validCtrl;
	this.updateCtrl = DpShifPZ_updateCtrl;
	this.zaval      = DpShifPZ_zaval;
	this.setUseZiro = DpShifPZ_setUseZiro;
	this.useZiro = DpShifPZ_useZiro;
   
	this.setObj = DpShifPZ_setObj;
	this.save = DpShifPZ_save;
	this.get = DpShifPZ_get;
	this.release = DpShifPZ_release;

	this.mode		= (typeof(mode) == "undefined" ? "0" : mode);
	
	this.par			= par;
	this.arrObj		= new Array();
	
	this.clPodr = getPar("CODPODR");
	this.clGaluz;	//для умолчания неоткуда брать 
	this.clZatr;		//для умолчания неоткуда брать 
	this.clAvto = getPar("AVTOTRANSPORT");
	this.codZatr = 10;
	this.codNZatr = 15;
	this.clIzd = 0;
	this.codIzd = 0;
	
	//чтение параметров
	if(typeof(par) != "undefined")
	{
		if(typeof(par.clPodr) != "undefined" && par.clPodr)
		{
			this.clPodr = Number(par.clPodr);
		}
		
		if(typeof(par.clGaluz) != "undefined" && par.clGaluz)
		{
			this.clGaluz = Number(par.clGaluz);
		}
		if(typeof(par.clZatr) != "undefined" && par.clZatr)
		{
			this.clZatr = Number(par.clZatr);
		}
		if(typeof(par.clAvto) != "undefined" && par.clAvto)
		{
			this.clAvto = Number(par.clAvto);
		}
		if(typeof(par.codZatr) != "undefined" && par.codZatr)
		{
			this.codZatr = Number(par.codZatr);
		}
		if(typeof(par.codNZatr) != "undefined" && par.codNZatr)
		{
			this.codNZatr = Number(par.codNZatr);
		}
	}
	
	this.isZiro = true;
	this.Fwid = 0;

	return this;
}

// Установить номер шифра Fshpz
function DpShifPZ_setFshpz(Fshpz)
{
	this.Fshpz = String(Fshpz);
	this.table = OpenTable("s", "SELECT * FROM ^SHIFRPZ WHERE FSHPZ=" + sqlTo(this.Fshpz));
	if (!this.table.IsEmpty())
	{
		this.isValid = true;
		this.Fwid = this.table.getValue("Fwid");
		this.clIzd = this.table.getValue("Fnsprizd");
		this.codIzd = this.table.getValue("Fksprizd");
	}
	else
	{
		this.isValid = false;
		this.clIzd = 0;
		this.codIzd = 0;
	}
	if (this.ctrlShpz)
	{
		this.ctrlShpz.setValue(this.Fshpz);	
		if (this.isValid)		
			this.setFtxt(this.table.getValue("fshpz_txt"));
		else
			this.setFtxt("");		
	}
	
	this.updateCtrl();
	return true;            
}

// Получить номер шифра Fshpz
function DpShifPZ_getFshpz()
{
   return this.Fshpz;
}

//Получить код справочника изделий
function DpShifPZ_getClIzd()
{
	return this.clIzd;
}

//Получить код изделия по умолчанию
function DpShifPZ_getCodIzd()
{
	return this.codIzd;
}

// Установить название шифра Ftxt
function DpShifPZ_setFtxt(Ftxt)
{
	this.Ftxt = Ftxt;
	if (this.ctrlTxt)
		this.ctrlTxt.setValue(Ftxt);	
	return true;
}

// Получить название шифра Ftxt
function DpShifPZ_getFtxt()
{
   return this.Ftxt;
}

// Использование нулевого кода
function DpShifPZ_setUseZiro(bol)
{
	this.isZiro = (typeof bol != "boolean" ? false : bol);
}

function DpShifPZ_useZiro()
{
	return this.isZiro;
}

// Проверка правильности инициализации
function DpShifPZ_valid()
{
  return this.isValid;
}

//связать с полями ввода
function DpShifPZ_linkCtrl(ctrlShpz, ctrlTxt)
{
	this.ctrlShpz = ctrlShpz;
	this.ctrlShpz.isButton = true;
	if (typeOf(this.ctrlShpz) != "DpTextEx")
		return false;
	this.ctrlShpz.mask = "&&&&&&&&&&&&&&&";  //15
	//if(this.ctrlShpz.DpType=="DpGet")
		setButton(this.ctrlShpz, this, "zaval");
	setValid(this.ctrlShpz, this, "validCtrl");
   
	this.ctrlTxt = ctrlTxt;
	if(this.ctrlTxt)
	{
		this.ctrlTxt.mask = replicate("&", 60); 
		Disable(this.ctrlTxt); 
	}     

	if (this.valid())
		this.setFtxt(this.table.getValue("fshpz_txt"));
		
	this.updateCtrl();
}

// Обновить связанные поля ввода
function DpShifPZ_updateCtrl()
{
   if (this.ctrlShpz)
      this.ctrlShpz.value = this.getFshpz();
   if (this.ctrlTxt)
      this.ctrlTxt.value = this.getFtxt();
}

// Реакция на выход из связанного поля ввода
function DpShifPZ_validCtrl()
{
   this.setFshpz(this.ctrlShpz.value);
   if (!this.valid())
   {
      if(this.getFshpz() == 0 && this.useZiro())
         this.setFtxt("");
      else  
         return this.zaval();
   }  
   else
   {  
      this.setFtxt(this.table.getValue("Fshpz_txt"));
   }  
   this.updateCtrl();
   return true;
}

//Осуществляется завал
function DpShifPZ_zaval()
{
   var par = new Object();
   par.Fshpz = this.ctrlShpz.value;
   par.zaval = true;
   par.ret = new Object();
   par.ret.Fshpz = null;
   par.ret.Fshpz_txt = null;
   par.ret.Fwid = this.Fwid;//для установки курсора в списке
   showWindow("l_shfrpz.js", SW_MODAL, par);
   if(!par.escape) 
   { 
      this.setFshpz(par.ret.Fshpz);
      this.setFtxt(par.ret.Fshpz_txt);
      this.updateCtrl();
   } 
   return !par.escape;
}                             

// типа linkCtrl
function DpShifPZ_setObj(obj)
{
	if (obj instanceof DpCl == false)
	{
		var str = "DpShifPZ: ";
		str += ru("Объекты данного типа не поддерживаються.","Об'єкти даного типу не підтримуються.");
		alert(str);
		return false;
	}

	var cl = obj.getClcl();
	
	switch (cl)
	{
		case this.clPodr:
			var label = "PODR";
		break;
		case this.clGaluz:
			var label = "GALUZ";
			obj.setMode("");
		break;
		default:
			var str = "DpShifPZ: ";
			str += ru("Справочник "+cl+" не поддерживаеться.","Довідник "+cl+" не підтримується.");
			alert(str);
			return false;
		break;
	}

	this.arrObj[label] = obj;

	return true;
}

//возвращает код ШПЗ
function DpShifPZ_save()
{
	var isClGaluz = (String(this.arrObj["GALUZ"].vid).toLowerCase() == "cl_galuz:com.debet.clcl.galuz" ? true : false);
	if (typeof(this.arrObj["GALUZ"]) == "undefined")
	{
		var str = "DpShifPZ: ";
		str += ru("Объект, для работы с "+this.clGaluz+" справочником не передан.\nСохранение ШПЗ невозможно.",
						"Об'єкт для роботи з "+this.clGaluz+" довідником не переданий.\nЗбереження ШВВ неможливе.");
		alert(str);
		return null;
	}

	var codGaluz = this.arrObj["GALUZ"].getCod();
	
	var sc = 0;
	var su = 0;
	var st = 0;
	
	//проверка вида справочника 
	if(isClGaluz)
	{
		//прочитаем счет в справочнике отраслей
		strSQL = " SELECT"
						+" GL.FSC"
						+", GL.FSU"
						+", GL.FST"
					+" FROM"
						+" ^CL_GALUZ GL INNER JOIN ^CLRELCLCL REL ON GL.FWID_CL = REL.FWID_CL"
					+" WHERE 1 = 1"
						+" AND REL.FCL = "+sqlTo(this.clGaluz)
						+" AND REL.FCOD = "+sqlTo(codGaluz)
		var aSc = getSnap(strSQL);
	
	
		if (isEmpty(aSc))
		{
			//такого быть не должно 
			var str = "DpShifPZ: ";
			str += ru("Код "+codGaluz+" в справочнике "+this.clGaluz+" не связан с планом счетов.\nСохранение ШПЗ невозможно.",
							"Код "+codGaluz+" в довіднику "+this.clGaluz+" не звязаний з планом рахунків.\nЗбереження ШВВ неможливе.");
			alert(str);
			return null;
		}
	
	
		sc = aSc[0];
		su = isEmpty(aSc[1]) ? 0 : aSc[1];
		st = isEmpty(aSc[2]) ? 0 : aSc[2];

		//узнаем какие аналитики используем
		var clAn = new Array();
		clAn[1] = tfsc("CL1", sc, su, st);
		clAn[2] = tfsc("CL2", sc, su, st);
		clAn[3] = tfsc("CL3", sc, su, st);
	
		var codPodr = 0;
		for (var i in clAn)
		{
			if (clAn[i] == this.clPodr)
			{
				if (typeof(this.arrObj["PODR"]) == "undefined")
				{
					var str = "DpShifPZ: ";
					str += ru("Объект, для работы с "+this.clPodr+" справочником не передан.\nСохранение ШПЗ невозможно.",
									"Об'єкт для роботи з "+this.clPodr+" довідником не переданий.\nЗбереження ШВВ неможливе.");
					alert(str);
					return null;
				}

				codPodr = this.arrObj["PODR"].getCod();
				if (isEmpty(codPodr))
				{
					this.arrObj["PODR"].setMode("");
					this.arrObj["PODR"].setCod(codPodr);
					codPodr = this.arrObj["PODR"].getCod();
				}
			}
		}
	}
	
	//ШПЗ типа 231001|1 используем только если у нас справочник отраслей типу cl_galuz:com.debet.clcl.galuz
	var shpz = String(codGaluz)+(!isEmpty(codPodr) && isClGaluz ? ("|"+String(codPodr)) : "");
	if(isClGaluz)
	{
		for (var i in clAn)
		{
			if (clAn[i] == this.clAvto)
			{
				var codAvto = this.par.codAvto;
				shpz += "|"+String(codAvto);
			}
		}
	}
	
	strSQL = "SELECT FWID" 
				+" FROM ^SHIFRPZ"
				+" WHERE 1=1"
					+" AND FSHPZ = "+sqlTo(shpz)
	var sn = getSnap(strSQL);
	
	if(sn != null && !isEmpty(sn[0]))
	{
		sn == null;
		return shpz;
	}

	var an1 = 0;
	var an2 = 0;
	var an3 = 0;

	if(isClGaluz)
	{
		for (var i in clAn)
		{
			switch (Number(clAn[i]))
			{
				case this.clPodr:
					eval("an"+i+" = codPodr");
				break;
				case this.clGaluz:
					eval("an"+i+" = codGaluz");
				break;
				case this.clZatr:
					eval("an"+i+" = this.codZatr");
				break;
				case this.clAvto:
					eval("an"+i+" = codAvto");
				break;
			}
		}
	}

	var shpz_txt = tcl("CL", "TXT", this.clGaluz, codGaluz);
	
	//если есть код подразделения вытянем текст кода 
	if(!isEmpty(codPodr) && isClGaluz)
	{
		switch (this.clPodr)
		{
			case 12:
				var txtPodr = tforg("TXT", codPodr);
				break;
			default:
				var txtPodr = tcl("CL", "TXT", this.clPodr, codPodr);
				break;
		}
		
		shpz_txt += " "+txtPodr;
	}
	
	strSQL = "SELECT MAX(FCOD)" 
				+" FROM ^SHIFRPZ"
				+" WHERE 1=1"
	var sn = getSnap(strSQL);
	var cod = 1;
	if(sn != null && !isEmpty(sn[0]))
	{
		cod = Number(sn[0])+1;
	}
	sn = null;

	var m = {};
	m.FCOD = cod;
	m.FSHPZ = shpz;
	m.FSHPZ_TXT = shpz_txt;
	m.FSC = sc;
	m.FSU = su;
	m.FST = st;
	m.FCOD1 = an1;
	m.FCOD2 = an2;
	m.FCOD3 = an3;
	m.FWID = GetUID();
	updateTable("^SHIFRPZ", m, true);
	
	return shpz;
}

function DpShifPZ_get(mode, shpz)
{
	var ret = 0;
	mode = mode.toUpperCase();
	
	strSQL = "SELECT FWID, FSC, FSU, FST, FCOD1, FCOD2, FCOD3"
				+" FROM ^SHIFRPZ"
				+" WHERE 1=1"
					+" AND FSHPZ = "+sqlTo(shpz)
	var sn = getSnap(strSQL);
	
	
	if(sn != null && !isEmpty(sn[0]))
	{
		switch (mode)
		{
			case "SC":
				ret = sn[1];
			break;
			case "SU":
				ret = sn[2];
			break;
			case "ST":
				ret = sn[3];
			break;
			case "A1":
				ret = sn[4];
			break;
			case "A2":
				ret = sn[5];
			break;
			case "A3":
				ret = sn[6];
			break;
			case "NA1":
				if (tfsc("CL1", sn[1], sn[2], sn[3]) == this.clZatr)
				{
					ret = this.codNZatr;
				}
				else
				{
					ret = sn[4];
				}
			break;
			case "NA2":
				if (tfsc("CL2", sn[1], sn[2], sn[3]) == this.clZatr)
				{
					ret = this.codNZatr;
				}
				else
				{
					ret = sn[5];
				}
			break;
			case "NA3":
				if (tfsc("CL3", sn[1], sn[2], sn[3]) == this.clZatr)
				{
					ret = this.codNZatr;
				}
				else
				{
					ret = sn[6];
				}
			break;
		}
	}

	return ret;
}

function DpShifPZ_release()
{
	this.table.Close();
}