// public
DpSynchroSetting.prototype.loadBy = DpSynchroSetting_loadBy;
DpSynchroSetting.prototype.getDefaultSetting = DpSynchroSetting_getDefaultSetting;
DpSynchroSetting.prototype.getSetting = DpSynchroSetting_getSetting;
DpSynchroSetting.prototype.save = DpSynchroSetting_save;

// private 
DpSynchroSetting.prototype.load = DpSynchroSetting_load;
DpSynchroSetting.prototype.getDefaultAttr = DpSynchroSetting_getDefaultAttr;


// include
include ("Objects/DpXMLDomDocument.js");

function DpSynchroSetting(sMode)
{
	this.sMode = ((sMode != "undefined" && sMode.equals("EDIT")) ? "EDIT" : "LOAD");	
	this.sClassID = null;
	this.nFolder = null;
	this.sType = null;
	this.parentObj = null;
	this.objFolder = "";
	this.setting = null;
	this.defSetting = this.getDefaultSetting();
	this.settingFolder = userDirectory() + "synchro/setting/";	
	this.dpAPI = lpProxy.getDpAPI();
	this.defaultAttr = this.getDefaultAttr();
}

function DpSynchroSetting_loadBy(sClassID, nFolder, sType)
{
	if (typeof sClassID == "undefined")
		return false;
	if (typeof nFolder != "undefined")
		this.nFolder = Number(nFolder);
	if (typeof sType != "undefined")
		this.sType = sType;
	this.sClassID = sClassID;	
	this.parentObj = lpProxy.createObject(this.sClassID);
	this.objFolder = this.parentObj.getClassDescriptionDir();
	var fileName = this.sClassID + "_" + this.nFolder;
	fileName.replace(".", "_");
	fileName.replace(":", "_");
	
	this.settingFile = this.settingFolder + fileName + ".xml";
	this.setting = this.getDefaultSetting();
	this.load(this.setting);
	if (this.sMode.equals("EDIT"))
	{
		var oPar = this.setting;
		showWindow("ask_synchro_stub.xml", SW_MODAL, oPar);
		if (oPar.escape)
			return false;
		this.save();		
	}
	return true;
}

function DpSynchroSetting_getSetting()
{
	if (this.setting != null)
		return this.setting;
	return this.defSetting;
}

function DpSynchroSetting_getDefaultSetting()
{
	var result = new Array();
	result.bDate = new Date();
	result.bDate.setHours(0);
	result.bDate.setMinutes(0);
	result.bDate.setSeconds(0);
	result.eDate = toScriptDate(d00).getVarDate();
	result.eDate.setHours(23);
	result.eDate.setMinutes(59);
	result.eDate.setSeconds(59);
	
	result.syncmode = "AUTOSYNC";
	result.fromsrv = true;
	result.tosrv = false;
	result.conflict = "FROM";
	
	result.selectPars = new Object();
	
	result.sType = this.sType;
	result.sClassID = this.sClassID;
	result.nFolder = this.nFolder;	
	return result;
}

function DpSynchroSetting_load(objSetting)
{
	if (typeof objSetting == "undefined")
		objSetting = new Array();
	if (isFile(this.settingFile))
	{
		var xml = new DpXMLDOMDocument();
		if (xml.load(this.settingFile))
		{
			var xmlEl = xml.getDocumentElement();
			var fields = xmlEl.getChildNodes();
			for (var i in fields)
			{
				var field = fields[i];
				if (field != null)
				{
					var name = field.getNodeName();
					if (typeof this.defaultAttr[name] == "string")
						objSetting[this.defaultAttr[name]] =  this.dpAPI.str2Obj(field.getAttribute("value"));
					else
					{
						var obj = objSetting.selectPars[name] = new Object();
						var attrs = field.getAttributes();
						for (var j in attrs)
							obj[attrs[j].getName()] = this.dpAPI.str2Obj(attrs[j].getValue());
					}
				}
			}
		}
	}
	return objSetting;
}

function DpSynchroSetting_save()
{
	createDirectory(this.settingFolder);
	
	var xml = new DpXMLDOMDocument();
	//if (xml.load(this.settingFile))
	var xmlEl = xml.createElement("setting");		
	xml.appendChild(xmlEl);
	for (var i in this.defaultAttr)
	{
		var objFieldName = this.defaultAttr[i];
		if (typeof this.setting[objFieldName] != "undefined")
		{
			var element = xml.createElement(i);
			xmlEl.appendChild(element);				
			var attr =  this.setting[objFieldName];
			if (objTypeOf(attr) == "Date")
				attr = attr.getVarDate();
			element.setAttribute("value", this.dpAPI.obj2XmlStr(attr));
		}
	}
	for (var i in this.setting.selectPars)
	{
		var element = xml.createElement(i);
		xmlEl.appendChild(element);
		if (element != null)
			for (var j in this.setting.selectPars[i])
				element.setAttribute(String(j), this.dpAPI.obj2XmlStr(this.setting.selectPars[i][j]));
	}
	xml.save(this.settingFile);	
}

function DpSynchroSetting_getDefaultAttr()
{
	var result = new Array();
	result["ALL_BDATE"] = "bDate";
	result["ALL_EDATE"] = "eDate";
	result["ALL_SYNCMODE"] = "syncmode";
	result["ALL_FROMSRV"] = "fromsrv";
	result["ALL_TOSRV"] = "tosrv";
	result["ALL_CONFLICT"] = "conflict";
	return result;
}
