/*
	Объект для печати 
*/
var DpTVars_this;

function DpTVars(sType,sLbl,bNoFrmAsk,nFile,nop,sMode)
{
	include("Objects/DpEval.js");
	include("sys/udfs.js");
	RO("DpTVars", this);
	// Инициализация
	this.setDoc  = DpTVars_setDoc;
	this.setHTbl = DpTVars_setHTbl;
	this.setRTbl = DpTVars_setRTbl;
	this.setJDoc = DpTVars_setJDoc;
	
	this.setVar  = DpTVars_setVar;
	this.isVar   = DpTVars_isVar;
	this.setExpr = DpTVars_setExpr;
	
	this.getHTbl = DpTVars_getHTbl;
	this.getRTbl = DpTVars_getRTbl;

	//for CrystalReport only
	this.getVarsCount	= DpTVars_getVarsCount;
	this.getVarName	= DpTVars_getVarName;
	this.getVarType	= DpTVars_getVarType;
	this.getVarValue= DpTVars_getVarValue;
	
	this.print = DpTVars_print;

	this.getForm = DpTVars_getForm;
	this.setForm = DpTVars_setForm;
	//форма печати выбранная пользователем
	//	эти 3 свойства будут нужны для печати
	//	форм через Word или Excel
	this.form	= "";
	this.ext	= "";
	this.user	= "";
	this.office	= null;
	this.prSelect = null;
	
	this.arrFrm = new Array();
	this.sSavePath = "";
	this.sSaveFile = "";
	this.bSave = false;
	this.bPreview = true;
	this.bPrint = true;
	this.extForm = "";
	this.sCond = "";
	this.mode = sMode;
		
	// Методы, используемые при печати
	this.setPatt = DpTVars_setPatt;
	this.setPattCR = DpTVars_setPattCR;
	this.getPatt = DpTVars_getPatt;
	this.getVar = DpTVars_getVar;
	this.moveFirst = DpTVars_moveFirst;
	this.moveNext = DpTVars_moveNext;
	this.isEOF = DpTVars_isEOF;
	this.getBookmark = DpTVars_getBookmark;
	this.setBookmark = DpTVars_setBookmark;
	this.saveBookmark = DpTVars_saveBookmark
	this.restoreBookmark = DpTVars_restoreBookmark;
	this.getRecordCount = DpTVars_getRecordCount;
	this.printMass = DpTVars_printMass;
	
	// Методы для печати кросс-таблиц
	this.colMoveFirst = DpTVars_colMoveFirst;
	this.colMoveNext = DpTVars_colMoveNext;
	this.colIsEOF = DpTVars_colIsEOF;
	
	// События печати
	this.complete = DpTVars_complete;
	this.setOnPrinted = DpTVars_setOnPrinted;
	
	// Флаг печати

	this.saveState = DpTVars_saveState;
	this.restoreState = DpTVars_restoreState;
	
	this.setChangeSourceHandler = DpTVars_setChangeSourceHandler;
	
	this.setSavePath = DpTVars_setSavePath;
	this.setSaveFile = DpTVars_setSaveFile;

	this.eval = new DpEval();
	
	this.eval.toOptimize = true;
	
	this.eval.addFunc("moveNext", this);
	
	this.eval.addVar("pagenum", 0, false);
	
	this.eval.addVar("OFIRM", getPar("OFIRM"), "Название организации");
	this.eval.addVar("OOKPO", getPar("OOKPO"), "Код ОКПО");
	this.eval.addVar("OADDRES", getPar("OADDRES"), "Адрес");
	this.eval.addVar("OPHONE", getPar("OPHONE"), "Телефон");
	this.eval.addVar("OMFO", getPar("OMFO"), "МФО");
	this.eval.addVar("ORSC", getPar("ORSC"), "Расчетный счет");
	this.eval.addVar("OBANK", getPar("OBANK"), "Название банка");
	this.eval.addVar("OKODNDS", getPar("OKODNDS"), "Код плательщика НДС");
	this.eval.addVar("OREGIS", getPar("OREGIS"), "Номер свид. о регистр. плат. НДС");
	this.eval.addVar("ONADMTXT", getPar("ONADMTXT"), "Название гос. налог. органа");
	this.eval.addVar("ONADMCOD", getPar("ONADMCOD"), "Номер гос. налог. органа");	
	this.eval.addVar("OBOSS", getPar("OBOSS"), "Директор");
	this.eval.addVar("OBUCH", getPar("OBUCH"), "Гл. бухгалтер");
	this.eval.addVar("OCASS", getPar("OCASS"), "Кассир");
	this.eval.addVar("OBOSSID", getPar("OBOSSID"), "Инд. код директора");
	this.eval.addVar("OBUCHID", getPar("OBUCHID"), "Инд. код гл. бухгалтера");
	this.eval.addVar("OBOSSPHONE", getPar("OBOSSPHONE"), "Телефон директора");
	this.eval.addVar("OBUCHPHONE", getPar("OBUCHPHONE"), "Телефон гл. бухгалтера");
	this.eval.addVar("OCASSPHONE", getPar("OCASSPHONE"), "Телефон кассира");
	this.eval.addVar("ORGID", getPar("ORGID"), "Код организации");
	this.eval.addVar("OZIP", getPar("OZIP"), "Zip организации");
	this.eval.addVar("OEMAIL", getPar("OEMAIL"), "E-mail организации");
	this.eval.addVar("OFAX", getPar("OFAX"), "Факс организации");
	
	this.eval.addVar("CODKAT", getPar("CODKAT"), false);
	
	// Текущая дата и время 
	var curDate = d_m_y(new Date());
	var curHourInt = new Date().getHours();
	var curHour = curHourInt < 10 ? "0" + curHourInt.toString() : curHourInt.toString();
	
	var curMinutesInt = new Date().getMinutes();
	var curMinutes = curMinutesInt < 10 ? "0" + curMinutesInt.toString() : curMinutesInt.toString();

	var curSecondsInt = new Date().getSeconds();
	var curSeconds = curSecondsInt < 10 ? "0" + curSecondsInt.toString() : curSecondsInt.toString();
	
	var curTime = curHour+":"+curMinutes+":"+curSeconds;
	var curDateTot = curDate +" "+curTime;
	this.eval.addVar("PRNTIME", curDateTot);	// 14.04.2010 13:51
	this.eval.addVar("CURDAT", curDate);		// 14.04.2010
	this.eval.addVar("CURTIME", curTime);		// 13:51
	
	//подгрузим переменные этой организации
	var tOrgVars = OpenTable("s", "select FVAR,FVAL,FTEXT from ^ORGVARS order by FVAR");
	if(tOrgVars)
		while(!tOrgVars.isEOF()){
			this.eval.addVar(toScrObj(tOrgVars.getValue("FVAR")), toScrObj(tOrgVars.getValue("FVAL")), toScrObj(tOrgVars.getValue("FTEXT")));
			tOrgVars.moveNext();
		}
	tOrgVars.close();

	if (DpTVars.arguments.length == 1)
	{
		sLbl = sType;
		sType = "LIST";
	}
	
	this.aBookmarks = new Array();
	if(sType && sLbl && !bNoFrmAsk)
		this.setPatt(sType,sLbl,sType=="DOC"?Number(nop):null);//номер операции для разграничения печатных форм по папкам документа
	activeDpTVars	= this;
	
	this.nFile = 0;
	if(nFile)
		this.nFile = nFile;
}

function DpTVars_getVarsCount()
{
	return this.eval.getVarsCount();
}
function DpTVars_getVarName(nVar)
{
	return this.eval.getVarName(nVar);
}
function DpTVars_getVarType(nVar)
{
	return this.eval.getVarType(nVar);
}
function DpTVars_getVarValue(v)
{
	return this.eval.getVarValue(v);
}

function DpTVars_setJDoc(jDoc)
{
	include("sys/udfs.js");
	include("Tmoney.js");
	include("servis/initials.js");
	include("Doc\\RegXP.js");
	//include("Servis\\choice.js");
	include("Sys\\dbase.js")
	include("servis\\date.js");

	this.jDoc = jDoc;
	jDoc.setJSEngine(Task.getScriptEngine());
}

//set pattern for Crystal Report
function DpTVars_setPattCR(patt)
{
	this.eval.setForm(patt);
}

function DpTVars_setPatt(sType,sLbl,nop)
{
	if (typeof(sLbl) != "boolean")
	{
		var ret	= this.getForm(sType,sLbl,nop);		
		if(ret)
			this.eval.setForm(sType,sLbl);
		this.prSelectType = sType;
		this.prSelectLbl = sLbl;
	}
	else
	{
		this.form = sType;
		var n  = sType.lastIndexOf(".");
		this.ext = sType.substr(n+1);
		this.bIsPlug = true;		
	}
	return ret;
}

function DpTVars_getPatt()
{
	return this.patt;
}

function DpTVars_print(bMass)
{
	var sv__noWait = __noWait;
	__noWait = true;
	this.sysLang = sysLang;
	sysLang = getPar("PrtLanguage")==1? "RU": "UR";
	
	var bRet = false;
	DpTVars_this = this;
/*	
	scriptFile = printFrmDirectory() + "psf\\" + this.form + ".js";
	scriptFile = scriptFile.replace(/\\/g, "/");
	//include(scriptFile);
*/
	//печать через внешние документы
	if(this.ext==null || this.ext=="")
	{
//		Form.Print(this);
		return false;
	}
	else if(this.arrFrm.length>1)
	{
		this.printMass();
		return true;
	}
	else
	{
		include("Office\\office.js");
		if(!this.office)
			this.office	= new Office();
		var prevLang = getPar("LANGUAGE");
		setPar("LANGUAGE",getPar("PRTLANGUAGE"));
		with(this.office)
		{
			source(this.form, this.ext, this, this.user,this.sScript, this.nFile++);
			bPrint = print(bMass);
			bRet = (bPrint!=false);			
		}
		
		if(this.extForm!="")
		{
			var arrForm = this.extForm.split("|");
			for(nForm=0; nForm<arrForm.length; nForm++)
			{
				this.form = arrForm[0];
				if(this.form)
				{
					this.office.source(this.form, this.ext, this, this.user,this.sScript, this.nFile++);
					this.office.print(bMass);					
				}					
			}
		}		
		setPar("LANGUAGE",prevLang);
	}
	return bRet;
}

function DpTVars_printMass(sType, sLbl)
{
	include("objects\\DpPrintSelect.js");
	
	var arrFrm = this.arrFrm;
	this.arrFrm = new Array();
	var savePath = this.sSavePath;
	for(var i=0; i<arrFrm.length; i++)
	{
		this.setForm(arrFrm[i]);
		this.setSavePath(savePath);
		this.print();		
	}	
}

function DpTVars_setHTbl(tblHeader)
{
	this.eval.setTable(tblHeader);
}

function DpTVars_getHTbl()
{
	return this.eval.getTable();
}

function DpTVars_setRTbl(tblRows, alias)
{
	this.eval.setRowTable(tblRows, alias);
}

function DpTVars_getRTbl(alias)
{
	var tblRows = this.eval.getRowTable(alias)
	//сформируем таблицу строк проводок документа, если она еще не установлена по алиасу PROV
	if(alias && alias.toUpperCase()=="PROV" && !tblRows/* && this.jDoc*/)
	{
		//tblRows = OpenTable("select * from ^schet where Fid_doc="+this.jDoc.eval("HID")+" order by fdate, fwrk, fdocnum, fnsect, fnprov");
		tblRows = OpenTable("select * from ^schet where Fid_doc="+this.getVar("HID")+" order by fdate, fwrk, fdocnum, fnsect, fnprov");
		this.setRTbl(tblRows, alias);
	}
	return tblRows;
}

function DpTVars_setDoc(doc, fnop)
{
	this.eval.setDoc(doc, fnop);
}

function DpTVars_getVar(sVarName)
{
	if (/*isJavaEval && */this.jDoc)
		return this.jDoc.eval(sVarName);
	else
		return this.eval.eval(sVarName);
}

function DpTVars_setVar(varName, varValue)
{
	this.eval.addVar(varName, varValue);
}

function DpTVars_setExpr(varName, varExpr)
{
	this.eval.addExpr(varName, varExpr);
}

function DpTVars_isVar(varName)
{
	return this.eval.isVar(varName);
}

function DpTVars_moveFirst()
{
	if(this.eval.getRowTable() && !this.eval.getRowTable().IsEmpty())
		this.eval.getRowTable().MoveFirst();
}

function DpTVars_moveNext()
{
	if(this.eval.getRowTable() && !this.eval.getRowTable().IsEOF())
		this.eval.getRowTable().MoveNext();
}

function DpTVars_getBookmark()
{
	if(this.eval.getRowTable() && !this.eval.getRowTable().IsEmpty())
		return this.eval.getRowTable().bookmark;
}

function DpTVars_setBookmark(bm)
{
	if(this.eval.getRowTable() && !this.eval.getRowTable().IsEmpty())
		this.eval.getRowTable().bookmark = bm;
}

function DpTVars_saveBookmark(no)
{
	this.aBookmarks[no] = this.getBookmark();
}

function DpTVars_restoreBookmark(no)
{
	if(no<this.aBookmarks.length)
		this.setBookmark(this.aBookmarks[no]);
	else if(this.eval.getRowTable() && !this.eval.getRowTable().IsEmpty())
	{
		this.eval.getRowTable().MoveLast();
		this.eval.getRowTable().MoveNext();
	}
}

function DpTVars_isEOF()
{
	//19.10.01 11:16 новая фича-
	//если таблицы нет, а переменные есть, то нужно эмулировать хотя бы одну запись,
	//чтобы можно было запросить хотя-бы эти переменные
	return (!this.eval.getRowTable()) || this.eval.getRowTable().IsEOF();
}

function DpTVars_setForm(oFrmInfo)
{
	this.ext = oFrmInfo.sFormType;
	this.form = oFrmInfo.sFile;
	this.sScript = oFrmInfo.sScript;
	this.sFormLbl = oFrmInfo.sFormLabel;
	this.sSaveFile = oFrmInfo.sSaveFile;
	this.bSave = oFrmInfo.bSave;
	this.bPreview = oFrmInfo.bPreview;
	this.extForm = oFrmInfo.sExtFile;
	this.sCond = oFrmInfo.sCond;
	this.sText = UR(oFrmInfo.sText);
}

function DpTVars_getForm(sType,sLbl,nop)
{
	this.form	=
	this.ext	=
	this.patt	= "";
	
	include("objects\\DpPrintSelect.js");
	var prSelect = new DpPrintSelect(sType,sLbl,nop);
	this.prSelect = prSelect;
	
	var arrPrnForms = prSelect.getForms(false, true);
	
	if (arrPrnForms.length == 0)
		return false;
	if (arrPrnForms.length == 1)
	{
		var frmInfo = arrPrnForms[0];
		this.ext = frmInfo.sFormType;
		this.form = frmInfo.sFile;
		this.sScript = frmInfo.sScript;
		this.sFormLbl = frmInfo.sFormLabel;
		this.sSaveFile = frmInfo.sSaveFile;
		this.bSave = frmInfo.bSave;
		this.bPreview = frmInfo.bPreview;
		this.extForm = frmInfo.sExtFile;
		this.sCond = frmInfo.sCond;
		this.sText = UR(frmInfo.sText);
		this.arrFrm[0] = frmInfo;
		return true;
	}
	
	this.arrFrm = prSelect.runSelectPrint(this.mode);
	if(!this.arrFrm)
		return false;
	
	//var frmInf = prSelect.runSelectPrint();
	var frmInf = this.arrFrm[0];
	if(frmInf == null) 
		return false;
	
	if( frmInf.sFormType == "RPT" && !getPar("CRYSTAL") )
	{
		alert("В данной версии поддержка Crystal Report не установлена.");
		return false;
	}
	
//-	this.user	= ret.fusers;
	this.ext	= frmInf.sFormType;
//-	this.fiskal = ret.ffiskal;
	this.form = frmInf.sFile;
	this.sScript = frmInf.sScript;
	this.sFormLbl = frmInf.sFormLabel;
	this.sSaveFile = frmInf.sSaveFile;
	this.bSave = frmInf.bSave;
	this.bPreview = frmInf.bPreview;
	this.extForm = frmInf.sExtFile;
	this.sCond = frmInf.sCond;
	this.sText = UR(frmInf.sText);
	return true;
}

function DpTVars_colMoveFirst()
{
	this.eval.colMoveFirst();
}

function DpTVars_colMoveNext()
{
	this.eval.colMoveNext();
}

function DpTVars_colIsEOF()
{
	return this.eval.colIsEOF();
}

function DpTVars_saveState()
{
	this.eval.saveState();
}

function DpTVars_restoreState()
{
	this.eval.restoreState();
}

function DpTVars_getRecordCount()
{
	return this.eval.getRecordCount();
}

function DpTVars_complete()
{
	if(this.sysLang)
		sysLang = this.sysLang;
	switch(typeof this.onPrintedObj)
	{
	case "function":
		this.onPrintedObj();
		break;
	case "object":
		this.onPrintedObj[this.onPrintedMethod](DpTVars_complete.arguments[0].toLowerCase());
		break;
	}
}

function DpTVars_setOnPrinted(obj, method)
{
	this.onPrintedObj = obj;
	this.onPrintedMethod = method;
}

function setVar(name, value, caption)
{
	DpTVars_this.eval.addVar(name, value, caption)
}

function getVar(name)
{
	return DpTVars_this.eval.getVar(name)
}

function DpTVars_setChangeSourceHandler(fnk)
{
	this.changeSourceHandler = fnk;
}

function DpTVars_setSaveFile(sFile)
{
	this.sSaveFile = sFile;
}

function DpTVars_setSavePath(sPath)
{
	this.sSavePath = sPath;
	this.sSaveFile = sPath +"/"+ this.sSaveFile;
}

// Печать форм группированных по условию
/* Пример вызова:
 		printGroupedForm("private_modules\\ukrplastic\\printForms\\docs\\NK\\OT_GRP.xls",
				["RTNMK", "ROCENA", "XRGRP"], // Поля группировки 
				{'XXX': '1'}  // Суммируем выражение '1' в переменную 'XXX' (считаем количество сгруппированных строк)
		);
*/
// В форме печати в строке сумматор можно получить используя ф-ю getSum("RRR")
function printDocGroupedForm(formFile, groupBy, summatorFields)
{
	var oDoc = new DpDoc(list.m_Doclabel, list.m_Nop);
	if (!oDoc.loadByID(list.tbl.getRowID(), false, true))
		return false;
	
	var oDoc2 = new DpDoc(list.m_Doclabel, list.m_Nop);
	xml = oDoc.jDoc.toXML();
	oDoc2.jDoc.fromXML(xml);
	
	oDoc = oDoc2;
	
	var childId = String(oDoc.getChildIDs()[0]);
	var tbl = oDoc.jDoc.getRowTable(childId, "RNOM");

	var nRow = 0;

	// Строки, в которой будут собираться суммы по группировкам
	grpRows = new Array();

	/*********** Сумматор *************/
	var summator = {
		sums: new Array() ,
		
		addSum: function(row, varName, value) {
			id = row.getObjectID();
			if (!this.sums[id]) 
				this.sums[id] = new Array();
			
			if (!this.sums[id][varName])
				this.sums[id][varName] = 0;
			
			this.sums[id][varName] += value;
		},
		
		getSum: function(row, varName) {
			id = this.getRowTable(this.activeRTableAlias).getRow().getObjectID();
			//return "--" + id;
			return this.sums[id][varName];
		}
	}
	/************************/
	
	var oEval = new DpEval();
	oEval.setDoc(list.m_Doclabel, list.m_Nop);
	oEval.setRowTable(tbl);
	
	for (; !tbl.isEOF(); tbl.moveNext())
	{
		var row = tbl.getRow();

		// условие для группировки
		grpCond = "";
		for(i in groupBy)
			grpCond += row.getVar(groupBy[i]) + "-";

		if (!grpRows[grpCond])
		{
			// первая строка по группе, в нее будем собирать сумму
			grpRows[grpCond] = row;
			for (summatorField in summatorFields) {
				summator.addSum(grpRows[grpCond], 
						summatorField, 
						oEval.eval(summatorFields[summatorField])
				);
			}
			continue;
		} 
		
		// Суммируем количество для 2
		grpRows[grpCond].setVar("RKOL", Number(grpRows[grpCond].getVar("RKOL"))
				+ Number(row.getVar("RKOL")));
	

		for (summatorField in summatorFields) {
			summator.addSum(grpRows[grpCond], 
					summatorField, 
					oEval.eval(summatorFields[summatorField])
			);
		}

		oDoc.jDoc.removeChild(childId, row.getObjectID());
	}
	
	var tbl = oDoc.jDoc.getRowTable(childId, "RNOM");
	tbl.requery(false);

	tbl.moveFirst();

	
	n = 0;
	for(; !tbl.IsEOF(); tbl.MoveNext()) {
		n++;
	}

	include("objects\\DpTVars.js");
	include("doc\\DpDoc.js");

	if (true)
	{
		var vars = new DpTVars("DOC", list.m_Doclabel, true);
		vars.ext = "xls";
		vars.form = rootDirectoryEx() + formFile;
	}
	else
	{
		var vars = new DpTVars("DOC", list.m_Doclabel);
	}

	vars.setDoc(list.m_Doclabel, list.m_Nop);
	vars.eval.setJDoc(oDoc);

	vars.eval.setRowTable(tbl);
	vars.eval.getsum = function(varName) {
		id = this.getRowTable(this.activeRTableAlias).getRow().getObjectID();
		return summator.sums[id][varName];
	}

	if (typeof docPrint == "function")
		docPrint(vars);

	vars.print();
}