function DpTableVersion(sBaseLbl,sTblName)
{
	this.sBase = sBaseLbl;
	this.dbPath = getPath(sBaseLbl);
	if (!this.dbPath || this.dbPath == "" || this.dbPath == null)
	{
		return null;
	}
	this.sTblName = String(sTblName).toUpperCase();
	
	this.sPoint = ".";
	if (SUBD == MSSQL)
		this.sPoint  = "..";
	
	this.getVersion = DpTableVersion_getVersion;
	this.setVersion = DpTableVersion_setVersion;
	
	this.createVerTable = DpTableVersion_createVerTable;
	
	this.createVerTable();
}

function DpTableVersion_createVerTable()
{
	if (IsTableEx(this.sBase,"SYS_VERSION"))
		return true;
	
	CreateTable(this.dbPath + this.sPoint + "SYS_VERSION","SYS_VERSION","*");
}

function DpTableVersion_getVersion()
{
	var sSQL = "SELECT FVERSION FROM " + this.dbPath + this.sPoint + "SYS_VERSION"
			   + " WHERE FTABLE=" + sqlTo(this.sTblName);
	var oSnap = getSnap(sSQL);
	if (oSnap == null || oSnap[0] == null)
		return 0;
	return String(oSnap[0]);
}

function DpTableVersion_setVersion(sVer)
{
	if (String(sVer) == String(this.getVersion()))
		return;
	var sSQL = "SELECT FVERSION FROM " + this.dbPath + this.sPoint + "SYS_VERSION"
			   + " WHERE FTABLE=" + sqlTo(this.sTblName);
	var oSnap = getSnap(sSQL);
	if (oSnap == null)
		sSQL = "INSERT INTO " + this.dbPath + this.sPoint + "SYS_VERSION"
			   + "("
			   + "FTABLE"
			   + ",FVERSION)"
			   + " VALUES("
			   + sqlTo(this.sTblName)
			   + "," + sqlTo(String(sVer))
			   + ")";
	else
		sSQL = "UPDATE " + this.dbPath + this.sPoint + "SYS_VERSION"
			   + " SET FVERSION=" + sqlTo(String(sVer))
			   + " WHERE FTABLE=" + sqlTo(this.sTblName);
	ExecuteSQL(sSQL);
}