
/*
Объект автоматизации рабаты с документом MS Word
Параметры конструктора:
	wdPar			- данные для полей документа MS Word
	mode			- маска режимов:
					WDM_TEMPLATE	- загружать шаблон	(по умолчанию)
					WDM_DOCUMENT	- загружать экземпляр документа 	
					
					WDM_NEW			- новый - записывать с помощью SaveAs
					WDM_EXISTED     - cуществующий - записывать с помощью Save (по умолчанию)
					WDM_CREATEDOC   - создание документа по шаблону
	

Интерфейс:
	InitFieldValue	- присваивание значений полям документа MS Word
	Save
	SaveAs
	
Пример создания этого объекта и передачи ему данных можна посмотреть
в файлах l_wdekz.htm и l_wdpatt.htm
 
Интерфейс объекта используется в скриптах к документам Word 
(пример ..\template\wdscript.vbs где Task.sys.arguments и есть данный объект) 
*/
include("objects\\DpEval.js");
include ("doc\\DpDoc.js");

var templateFolder;// = rootDirectory() + "..\\template\\";
var documentFolder;// = getPar("OFFICEDIR");

// Инициализация и проверка на допустимость путей
function ValidWDDir()
{
	documentFolder = getPar("OFFICEDIR");
	templateFolder = rootDirectory() + "../template/";
	if (typeof(documentFolder) != "string"  || documentFolder == "")
	{
		alert(ru("Установите в параметрах системы Дебет Плюс\nпуть на директорию документов Microsoft Office", "Задайте в параметрах системи Дебет Плюс\nшлях на директорію документів Microsoft Office"));
		return false;
	}
	return true;
}
	// Объект параметров для DpWDAuto
	// 
function WDPar()
{
	RO("WDPar", this);
	ValidWDDir();
	this.fileName		= "";
	this.templateName	= "Empty";
	this.tbl			= null;
	this.fwid			= null;
	this.grid			= (typeof(grid) == "object")?grid:null;
	this.fnop			= 0;
	this.arrValues		= null;
	this.fileFolder		= templateFolder;
	this.templateFolder = templateFolder;
	this.mark			= true;
}
/////////////////////////////////////////////////////////////////
	//Режимы
var WDM_TEMPLATE	= 0;
var WDM_DOCUMENT	= 1;
var WDM_NEW			= 2;
var WDM_EXISTED		= 0;
var WDM_CREATEDOC	= 4 | WDM_NEW | WDM_TEMPLATE;

	//"константы"
var FIND_ERROR = -1;

function DpWDAuto(wdPar, isTempl, oDoc)
{
	RO("DpWDAuto", this);
	
//public fields	
	this.isTemplate		= isTempl;
	this.isNeedSaveAs	= false;
	this.isDocCreate	= false;
		
//private fields	
		//Данные (названия полей и их значения), 
		//которые передаются из Дебета в документ Word
	this.FieldValues	= new Array();		
		

	this.fileName		= wdPar.fileName;		//Имя документа (файла)
	this.templateName	= wdPar.templateName;	//Имя шаблона (файла), по которому создается документ
	this.fileFolder		= wdPar.fileFolder;
	this.templateFolder = wdPar.templateFolder;
	this.tbl			= wdPar.tbl;
	this.fwid			= wdPar.fwid;
	this.grid			= wdPar.grid;
	this.fnop			= wdPar.fnop;
	this.oDoc = oDoc;
		
//public methods				
//	this.InitFieldValue = DpWDAuto_InitFieldValue;
	this.Save			= DpWDAuto_Save;
	this.SaveAs			= DpWDAuto_SaveAs;
	this.setField		= DpWDAuto_setField;
		
//private methods
	this.Init			= DpWDAuto_Init;
	this.FindField		= DpWDAuto_FindField;
	this.AddToArr		= DpWDAuto_AddToArr;
	this.getRTable = DpWDAuto_getRTable;
	
			
		// Копирование данных в объект
	this.Init(wdPar)
	var docFile;
		//Запуск Word'а и загрузка нужного файла
	
	if (this.isTemplate)
	{		
		docFile =this.templateFolder + this.templateName + ".doc";
		shellOpen(docFile);
	}
	
	else 
	{
		docFile =  this.fileFolder + "/" + this.fileName;	
		if (!docFile.endsWith(".doc"))
			docFile += ".doc";
		
		if(isFile(docFile))
		{	
			var oWritePrinter = lpProxy.getOfficePrinter("SWriter");
			oWritePrinter.setFormFile(docFile);
			oWritePrinter.setPrintObj(this);
			oWritePrinter.print();
		}
		else
			alert("Файл "+docFile+"\nне существует.");
	}
	//alert(this.setField("FMAN"));
}

function DpWDAuto_getRTable()
{
	return null;
}


function DpWDAuto_Save(MSWord)
{
	MSWord.Application.ActiveDocument.SaveAs(this.fileFolder + this.fileName + ".doc");
}

function DpWDAuto_SaveAs(MSWord, name, format)
{
/*	var validName = typeof(name) == "string" && name != "";
	var rootDir = ((!this.isDocCreate)?Task.sys.rootDirectory + "../":"")
	var fileName = this.fileFolder + ((validName)?name: this.fileName) + ".doc";
	MSWord.Application.ActiveDocument.SaveAs( fileName,
											 (typeof(format)!="undefined")?format:0,
											 false, "", true, "", false, false, false, false, false);
	var CopyVBS = "";
	if (validName)
	{
		if (name != this.fileName)
		{
			if (this.tbl.Seek("=", this.fwid))
			{
				this.tbl.Edit();
				this.tbl("FNAME") = name;
				this.tbl.Update();
				this.grid.RefreshGrid();
			}  
			CopyVBS = name;
		}
	}
	else if (this.fileName != this.templateName)
		CopyVBS = this.fileName;
		//Если создаем шаблон по шаблону, то копируем "родительский" шаблон
	if (CopyVBS != "" && !this.isDocCreate)
		copyFile(this.templateFolder + this.templateName + ".vbs", this.fileFolder + CopyVBS + ".vbs", false);
*/
}

function DpWDAuto_Init(par)
{
	if (this.isTemplate)
		return;
	var ind = 0;
	if (typeof(par) != "object")
		return;
	//this.oDoc = new DpDoc("WD", this.fnop);
	//var oEval = new DpEval();
	//oEval.setDoc("WD", this.fnop);
	if (this.mark)
		var varTable = OpenTable("s", "SELECT * FROM ^VARDOC"
								+ " WHERE FDOC = \"WD\" and fdefa = " + sqlFalse +  " AND (FNOP = 0 OR FNOP = " + sqlTo(this.fnop) + ")");
		// Если в объект были переданы данные, то в документ будут переданы они
	
	if (typeof(par.arrValues) == "object" && par.arrValues != null)
	{
		// Скопируем поля переданные в объект 
		for (var i = 0; i < par.arrValues.length; i++)
			this.AddToArr(this.FieldValues, par.arrValues[i].name, par.arrValues[i].text, par.arrValues[i].value );
	}
		for (var i = 0;i<this.oDoc.getVarsInfo().length;i++)
    	{
    		this.FieldValues[i] = new Object();
    		var sName = this.oDoc.getVarsInfo()[i].name
    		this.FieldValues[i].name = sName;
    		this.FieldValues[i].text = sName + ": " + this.oDoc.getVarsInfo()[i].rem;
    		this.FieldValues[i].value = this.oDoc.getVar(sName);
    	}
    	
    	for (var k in this.oDoc.getExtInfo())
    	{
    		
    		this.FieldValues[i] = new Object();
    		var sExt = this.oDoc.getExtInfo()[k].E_Label;
    		this.FieldValues[i].name = "ext." + sExt;
    		this.FieldValues[i].text ="ext." + sExt + ":" +  this.oDoc.getExtInfo()[k].E_FieldText;
    		this.FieldValues[i].value = this.oDoc.getExt(sExt);
    		i++;
    		this.FieldValues[i] = new Object();
    		sExt = this.oDoc.getExtInfo()[k].E_Label;
    		this.FieldValues[i].name = "XH" + sExt;
    		this.FieldValues[i].text = "XH" + sExt + ":" +  this.oDoc.getExtInfo()[k].E_FieldText;
    		this.FieldValues[i].value = this.oDoc.getExt(sExt);
    		i++;
    	}
    
		
	if (this.mark)
		for(;!varTable.IsEOF(); varTable.MoveNext())
		{
			var value = this.oDoc.eval(String(varTable.getValue("FEXPR")));
			if (value == null)
				value = "";
			this.AddToArr(this.FieldValues, varTable.getValue("FVAR"), varTable.getValue("FVAR")+": " + varTable.getValue("FREM"), value);
		}
	
	
	
	
	par = null;
}
	// Используется для добавления елементов в масив значений полей this.FieldValues
function DpWDAuto_AddToArr(arr, name, text, value)
{
	var i = arr.length;
	arr[i]			= new Object;
	arr[i].name		= name.toUpperCase();
	arr[i].text		= text;
	arr[i].value	= value;
}



// Поиск поля в масиве this.FieldValues
function  DpWDAuto_FindField(name)
{
	for(var i = 0; 
			i < this.FieldValues.length 
			&& this.FieldValues[i].name.toUpperCase() != name.toUpperCase();
			 i++);
	{
	
		return (i < this.FieldValues.length)?i: FIND_ERROR;
	}
}


function DpWDAuto_setField(name)
{
		var res;
		
		//name = String(name.toUpperCase())
		if (name.substr(0,1) == "=")
		{
			
			return String(this.oDoc.eval(name.substr(1)));
		}
		var indField = this.FindField(name);
			// Если нашли поле с таким названием в масиве this.FieldValues
			// переносим его значение в поле Word'а
		if (indField != FIND_ERROR)
			res = String(this.FieldValues[indField].value);
		else
		{
				// Иначе запрашиваем у пользователя: какой из имеющихся параметров выбрать	
				// и переименуем данное поле
		//	doc.FormFields(i).Select();
			var par			= Object;
			par.FieldName	= name;
			par.isDocCreate = this.isDocCreate;
			par.FieldValue	= "";
			par.canditates	= this.FieldValues;
			par.escape		= true;
			showWindow("wd_match.xml", SW_MODAL, par);
			escape = par.escape;
			res = String(par.FieldValue);
		}
	
	
	return res;
}