// JScript source code
var JAVA = typeof(java)!="undefined";

function DpXMLDOMDocument()
{
	if(JAVA)
		this.xmlDom = createXmlDoc();
	else
		this.xmlDom = new ActiveXObject("MSXML2.DomDocument.4.0");
	
	this.load = DpXMLDOMDocument_load;
	this.loadFastInfoset = this.loadFI = DpXMLDOMDocument_loadFI;
	this.loadEx = DpXMLDOMDocument_loadEx;
	this.loadXML = DpXMLDOMDocument_loadXML;
	this.loadFromURL = DpXMLDOMDocument_loadFromURL;
	this.xmlNode = this.xmlDom;
	this.parent = null;
	this.domDoc = this;
	
	this.getDocumentElement = DpXMLDOMDocument_getDocumentElement;
	this.getChildNodes = DpXMLDOMDocument_getChildNodes;
	this.getXML = DpXMLDOMDocument_getXML;
	this.getText = DpXMLDOMDocument_getText;
	this.getCDATASection = DpXMLDOMDocument_getCDATASection;
	this.getNodeName = DpXMLDOMDocument_getNodeName;
	this.getBaseName = DpXMLDOMDocument_getBaseName;
	this.getFirstChild = DpXMLDOMDocument_getFirstChild;
	this.getLastChild = DpXMLDOMDocument_getLastChild;
	this.getNextSibling = DpXMLDOMDocument_getNextSibling;
	this.getNodeType = DpXMLDOMDocument_getNodeType;
	this.getOwnerDocument = DpXMLDOMDocument_getOwnerDocument;
	this.getParentNode = DpXMLDOMDocument_getParentNode;
	this.getParentNodeEx = DpXMLDOMDocument_getParentNodeEx;
	this.getElementsByTagName = DpXMLDOMDocument_getElementsByTagName;
	this.hasChildNodes = DpXMLDOMDocument_hasChildNodes;
	this.applyXSL = DpXMLDOMDocument_applyXSL;
	
	this.selectNodes = DpXMLDOMDocument_selectNodes;
	this.selectSingleNode = DpXMLDOMDocument_selectSingleNode;	
	
	this.cloneNode = DpXMLDOMDocument_cloneNode;
	this.adoptNode = DpXMLDOMDocument_adoptNode;
	this.appendChild = DpXMLDOMDocument_appendChild;
	this.insertBefore = DpXMLDOMDocument_insertBefore;
	this.removeChild = DpXMLDOMDocument_removeChild;
	this.replaceChild = DpXMLDOMDocument_replaceChild;
	this.createChild = DpXMLDOMDocument_createChild;
	this.createAttribute = DpXMLDOMDocument_createAttribute;
	this.createElement = DpXMLDOMDocument_createElement;
	this.createComment = DpXMLDOMDocument_createComent;
	this.createCDATASection = DpXMLDOMDocument_createCDATASection;
	
	this.save = DpXMLDOMDocument_save;
	this.saveFastInfoset = DpXMLDOMDocument_saveFastInfoset;
		
}

function DpXMLDOMDocument_load(sFileName, variable)
{	
	if(JAVA)
	{
		this.xmlDom = openXmlFile(sFileName, variable);
		if (this.xmlDom == null)
		{
			this.xmlDom = createXmlDoc();
			this.xmlNode = this.xmlDom;
			return false;
		}
		return true;		
	}
	this.xmlDom.async = false;
	//this.xmlDom.loadXML(ReadFile(sFileName));
	this.xmlDom.load(sFileName);
	if(this.xmlDom.parseError!=0)
	{
		alert("Ошибка чтения XML:\n "+this.xmlDom.parseError.reason);
		return false;
	}
	
	return true;
}

function DpXMLDOMDocument_loadFI(sFileName, variable)
{	
	this.xmlDom = openFastInfosetFile(sFileName, variable);
	if (this.xmlDom == null)
	{
		this.xmlDom = createXmlDoc();
		this.xmlNode = this.xmlDom;
		return false;
	}
	return true;
}

function DpXMLDOMDocument_loadEx(sFileName, bOrg)
{	
	if (this.loadEx.arguments.length == 1)
	{
		bOrg = sFileName.toLowerCase().startsWith("/settings");
	}
	this.xmlDom = createXmlDoc();
	var node = lpProxy.getClient().getXMLFromFile(sFileName, bOrg);
	var root = this.xmlDom.adoptNode(node.cloneNode(true));
    this.xmlDom.appendChild(root);
}

function DpXMLDOMDocument_loadFromURL(sAddr, showEror, timeout)
{	
    if (typeof(showEror) == "undefined")
    	showEror = true;
    if (!timeout)
    	timeout = -1;
    	
	this.xmlDom = lpProxy.getXMLFromURL(sAddr, showEror, timeout);
	if (this.xmlDom == null)
	{
		this.xmlDom = createXmlDoc();
		this.xmlNode = this.xmlDom;
		return false;
	}
	return true;		
	
}


function DpXMLDOMDocument_loadXML(sXML)
{	
	if (JAVA)
	{
		this.xmlDom = lpProxy.getXMLFromStr(sXML);
		return;
	}
	
	this.xmlDom.async = false;
	this.xmlDom.loadXML(sXML);
	if(this.xmlDom.parseError!=0)
	{
		alert("Ошибка чтения XML:\n "+this.xmlDom.parseError.reason);
		return false;
	}
	
	return true;
}

function DpXMLDOMDocument_save(sFile, encoding)
{
	if (!encoding)
		encoding = "";
		
	if(JAVA)
	{
		lpProxy.saveXml(this.xmlDom,sFile,encoding);	
	}
	else
	{
		lpProxy.saveXml(this.xmlDom.documentElement,sFile,encoding)
	}
}

function DpXMLDOMDocument_saveFastInfoset(sFile)
{
	lpProxy.saveToFI(this.xmlDom,sFile);
}

function DpXMLDOMDocument_getDocumentElement()
{
	if(JAVA)
		var xmlElem = this.xmlDom.getDocumentElement();
	else
		var xmlElem = this.xmlDom.documentElement;
	if (xmlElem == null)
		return null;
	return new DpXMLDOMElement(xmlElem,this.getOwnerDocument(),this);
}

function DpXMLDOMDocument_hasChildNodes()
{
	if(JAVA)
		return this.xmlNode.hasChildNodes();
	else
		return this.xmlNode.hasChildNodes;
}

function DpXMLDOMDocument_getChildNodes()
{
	var nodes = this.xmlNode.getChildNodes();
	var xmlNodes = new Array();
	var k=0;
	for(var n = 0; n < nodes.length; n++)
	{
		//trace(typeOf(nodes.item(n)));
		if(JAVA && !inList(typeOf(nodes.item(n)),"ElementImpl" ,"ElementNode","DeferredElementImpl"))
			continue;
		xmlNodes[k++] = new DpXMLDOMElement(nodes.item(n),this.getOwnerDocument(),this);
	} 
	return xmlNodes;
}

function DpXMLDOMDocument_getXML(encoding)
{
	if(JAVA)
	{
		var t = Packages.javax.xml.transform.TransformerFactory.newInstance().newTransformer();
        var sw = new java.io.StringWriter();
        t.setOutputProperty("encoding",encoding?encoding:"utf8");
        t.transform(new Packages.javax.xml.transform.dom.DOMSource(this.xmlNode), 
        				new Packages.javax.xml.transform.stream.StreamResult(sw));
        return String(sw.getBuffer());  
	}
	else
		return this.xmlNode.xml;
}

function DpXMLDOMDocument_getText()
{
	if(JAVA)
	{
		var text = this.xmlNode.getFirstChild();
		if(text!=null && inList(typeOf(text),"TextNode","DeferredTextImpl", "TextImpl","DeferredCDATASectionImpl")) 
			return String(text.getData());
		else
			return "";
	}
	return this.xmlNode.text;
}

function DpXMLDOMDocument_getCDATASection()
{
	var obj = this.xmlNode.getFirstChild();
	if (obj == null) return null;
	return new DpXMLDOMCDATASection(obj,this.getOwnerDocument(),this);
}

function DpXMLDOMDocument_getNodeName()
{
	if(JAVA)
		return String(this.xmlNode.getNodeName());
	else
		return this.xmlNode.nodeName;
}

function DpXMLDOMDocument_getBaseName()
{
	if(JAVA)
	{
		var baseName = String(this.xmlNode.getNodeName());
		if (baseName.lastIndexOf(":") != -1)
			baseName = baseName.substr(baseName.lastIndexOf(":") + 1, baseName.length)
		return baseName;
	}
	else
		return this.xmlNode.baseName;
}

function DpXMLDOMDocument_getFirstChild()
{
	if(JAVA)
		return new DpXMLDOMElement(this.xmlNode.getFirstChild(),this.getOwnerDocument(),this);
	else
		return new DpXMLDOMElement(this.xmlNode.firstChild,this.getOwnerDocument(),this);
}

function DpXMLDOMDocument_getLastChild()
{
	if(JAVA)
		return new DpXMLDOMElement(this.xmlNode.getLastChild(),this.getOwnerDocument(),this);
	else
		return new DpXMLDOMElement(this.xmlNode.lastChild,this.getOwnerDocument(),this);
}

function DpXMLDOMDocument_getNextSibling()
{
	if(JAVA)
		return new DpXMLDOMElement(this.xmlNode.getNextSibling(),this.getOwnerDocument(),this);
	else
		return new DpXMLDOMElement(this.xmlNode.nextSibling,this.getOwnerDocument(),this);
}

function DpXMLDOMDocument_getNodeType()
{
	if(JAVA)
		return this.xmlNode.getNodeType();
	else
		return this.xmlNode.nodeType;
}

function DpXMLDOMDocument_getOwnerDocument()
{
	return this.domDoc;
}

function DpXMLDOMDocument_getParentNode()
{
	return this.parent;
}

function DpXMLDOMDocument_getParentNodeEx()
{
	return new DpXMLDOMElement(this.xmlNode.getParentNode(),this.getOwnerDocument(), null);
}

function DpXMLDOMDocument_getElementsByTagName(sNodeName)
{
	var nodes = this.xmlNode.getElementsByTagName(sNodeName);
	var xmlNodes = new Array();
	for(var n = 0; n < nodes.length; n++)
	{
		xmlNodes[n] = new DpXMLDOMElement(nodes.item(n),this.getOwnerDocument(),this);
	} 
	return xmlNodes; 
}

function  DpXMLDOMDocument_selectNodes(sNodeName)
{
	var xmlNodes = new Array();
	var node = null;
	if(JAVA) 
		nodes = Packages.com.sun.org.apache.xpath.internal.XPathAPI.selectNodeList(this.xmlNode,sNodeName);
	else
		nodes = this.xmlNode.selectNodes(sNodeName);
	
	for(var n = 0; n < nodes.length; n++)
	{
		xmlNodes[n] = new DpXMLDOMElement(nodes.item(n),this.getOwnerDocument(),this);
	} 
	return xmlNodes; 
}

function  DpXMLDOMDocument_selectNodesJ(sNodeName)
{
	var nodes = this.xmlNode.getElementsByTagName(sNodeName);
	var xmlNodes = new Array();
	
	var k = 0;
	for(var n = 0; n < nodes.length; n++)
	{
		if(nodes.item(n).getParentNode()==this.xmlNode)
			xmlNodes[k++] = new DpXMLDOMElement(nodes.item(n),this.getOwnerDocument(),this);
	} 
	return xmlNodes;  
}

function  DpXMLDOMDocument_selectSingleNodeJ(sNodeName)
{
	var nodes = this.xmlNode.getElementsByTagName(sNodeName);
	for(var n = 0; n < nodes.length; n++)
	{
		if(nodes.item(n).getParentNode()==this.xmlNode)
			return new DpXMLDOMElement(nodes.item(n),this.getOwnerDocument(),this);
	} 
	return null;  
}

function  DpXMLDOMDocument_selectSingleNode(sNodeName)
{
	var node = null;
	if(JAVA) 
		node = Packages.com.sun.org.apache.xpath.internal.XPathAPI.selectSingleNode(this.xmlNode,sNodeName)
	else
		node = this.xmlNode.selectSingleNode(sNodeName);
	if(node == null) return null;	
	return new DpXMLDOMElement(node,this.getOwnerDocument(),this);	
}

function DpXMLDOMDocument_cloneNode(bDeep)
{
	return new DpXMLDOMElement(this.xmlNode.cloneNode(bDeep),this.getOwnerDocument(),this.parent);	
}

function DpXMLDOMDocument_adoptNode(xmlElem)
{
	return new DpXMLDOMElement(this.xmlDom.adoptNode(xmlElem.xmlNode), this,null);		
}

function DpXMLDOMDocument_appendChild(newEl)
{
	this.xmlNode.appendChild(newEl.xmlNode)		
	newEl.parent = this;
}

function DpXMLDOMDocument_insertBefore(newEl,refEl)
{
	var el = refEl?refEl.xmlNode:null;
	this.xmlNode.insertBefore(newEl.xmlNode,el);
	newEl.parent = this;
}

function DpXMLDOMDocument_removeChild(child)
{
	this.xmlNode.removeChild(child.xmlNode);	
}

function DpXMLDOMDocument_replaceChild(newChild,oldChild)
{
	this.xmlNode.replaceChild(newChild.xmlNode,oldChild.xmlNode);
	newChild.parent = oldChild.parent;
}

function DpXMLDOMDocument_createChild(sName, sText, aAttrs, elBeforre)
{
	var oElement = this.getOwnerDocument().createElement(sName);

	if (sText)
	{
		oElement.setText(sText);
	}

	if (aAttrs)
	{
		for (attr in aAttrs)
		{
			oElement.setAttribute(attr, aAttrs[attr])
		}
	}

	if (elBeforre != null)
		this.insertBefore(oElement, elBeforre);
	else
		this.appendChild(oElement);

	return oElement;
}

function DpXMLDOMDocument_createAttribute(sName)
{
	return new DpXMLDOMAttribute(this.xmlDom.createAttribute(sName), this,null);
}

function DpXMLDOMDocument_createElement(sName)
{
	return new DpXMLDOMElement(this.xmlDom.createElement(sName), this,null);
}

function DpXMLDOMDocument_createComent(sData)
{
	return new DpXMLDOMComment(this.xmlDom.createComment(sData), this,null)	
}

function DpXMLDOMDocument_createCDATASection(sData)
{
	return new DpXMLDOMCDATASection(this.xmlDom.createCDATASection(sData), this,null)	
}



/////////////////////////////////////////////////////////////////////

function DpXMLDOMElement(xmlEl, xmlDom,parent)
{
	this.xmlNode = xmlEl;
	this.domDoc = xmlDom;
	this.parent = parent;
	
	this.getChildNodes = DpXMLDOMDocument_getChildNodes;
	this.getXML = xmlDom.getXML;
	this.getText = xmlDom.getText;
	this.getNodeName = xmlDom.getNodeName;
	this.getBaseName = xmlDom.getBaseName;
	this.getFirstChild = xmlDom.getFirstChild;
	this.getCDATASection = xmlDom.getCDATASection;
	this.getLastChild = xmlDom.getLastChild;
	this.getNextSibling = xmlDom.getNextSibling;
	this.getNodeType = xmlDom.getNodeType;
	this.getOwnerDocument = xmlDom.getOwnerDocument;
	this.getParentNode = xmlDom.getParentNode;
	this.getParentNodeEx = xmlDom.getParentNodeEx;
	this.getElementsByTagName = xmlDom.getElementsByTagName;
	this.hasChildNodes = xmlDom.hasChildNodes;
	this.selectNodes =		xmlDom.selectNodes;
	this.selectSingleNode = xmlDom.selectSingleNode;
	this.createChild = xmlDom.createChild;
	
	this.cloneNode = xmlDom.cloneNode;
	this.appendChild = xmlDom.appendChild;
	this.insertBefore = xmlDom.insertBefore;
	this.removeChild = xmlDom.removeChild;
	this.replaceChild = xmlDom.replaceChild;
	
	this.getAttribute = DpXMLDOMElement_getAttribute;
	this.setAttribute = DpXMLDOMElement_setAttribute;
	this.getAttributes = DpXMLDOMElement_getAttributes;
	this.getAttributeNode = DpXMLDOMElement_getAttributeNode;
	this.setAttributeNode = DpXMLDOMElement_setAttributeNode;
	this.setText = DpXMLDOMElement_setText;
}

function DpXMLDOMElement_getAttribute(sAttr)
{
	return String(this.xmlNode.getAttribute(sAttr));
}

function DpXMLDOMElement_setAttribute(sAttr, sValue)
{
	this.xmlNode.setAttribute(sAttr,sValue);
}

function DpXMLDOMElement_getAttributes()
{
	var nodes = this.xmlNode.getAttributes();
	var arr = new Array();
	for(var n = 0; n < nodes.getLength(); n++)
		arr[n]= new DpXMLDOMAttribute(nodes.item(n), this.getOwnerDocument(), this);
	return arr;
}

function DpXMLDOMElement_getAttributeNode(sAttr)
{
	return new DpXMLDOMAttribute(this.xmlNode.getAttributeNode(sAttr),this.getOwnerDocument(),this);	
}

function DpXMLDOMElement_setAttributeNode(Attr)
{
	this.xmlNode.setAttributeNode(Attr.xmlAttr);	
}

function DpXMLDOMElement_setText(sText)
{
	if(JAVA)
	{
		this.xmlNode.setTextContent(sText);
		/*
		var text = this.xmlNode.getFirstChild();
		
		//trace("SET TEXT ON " + typeOf(text));
		if(text && inList(typeOf(text),"TextNode","DeferredTextImpl"))
			text.setData(sText);
		else
		{
			text = this.domDoc.xmlDom.createTextNode(sText);
			this.xmlNode.appendChild(text);
		}
		*/
	}
	else
		this.xmlNode.text = sText;
}

///////////////////////////////////////////////////////////////
function DpXMLDOMAttribute(xmlAttr, xmlDom,parent)
{
	this.xmlAttr = xmlAttr;
	this.xmlNode = parent;
	this.domDoc = xmlDom;
	this.parent = parent;
	
	this.getOwnerDocument = xmlDom.getOwnerDocument;
	this.getParentNode = xmlDom.getParentNode;
	this.getParentNodeEx = xmlDom.getParentNodeEx;
	
	this.getName = 	DpXMLDOMAttribute_getName;
	this.getValue =	DpXMLDOMAttribute_getValue;
	this.setValue =	DpXMLDOMAttribute_setValue;		
}


function DpXMLDOMAttribute_getName()
{
	if(JAVA)
		return String(this.xmlAttr.getName());
	else
		return this.xmlAttr.name;
}

function DpXMLDOMAttribute_getValue()
{
	if(JAVA)
		return String(this.xmlAttr.getValue());
	else
		return this.xmlAttr.value;
}

function DpXMLDOMAttribute_setValue(sVal)
{
	if(JAVA)
		this.xmlAttr.setValue(sVal);
	else
		this.xmlAttr.value = sVal;
}

/////////////////////////////////

function DpXMLDOMComment(xmlComm, xmlDom,parent)
{
	this.xmlNode = xmlComm;
	this.domDoc = xmlDom;
	this.parent = parent;
	this.getData = DpXMLDOMNode_getData;
	this.setData = DpXMLDOMNode_setData;
	this.getOwnerDocument = xmlDom.getOwnerDocument;
	this.getParentNode = xmlDom.getParentNode;
	this.getText = xmlDom.getText;
}

function DpXMLDOMNode_getData()
{
	if(JAVA)
		return String(this.xmlNode.getData());	
	else
		return this.xmlNode.data;
}

function DpXMLDOMNode_setData(sData)
{
	if(JAVA)
		this.xmlNode.setData(sData);
	else
		this.xmlNode.data = sData;	
}

/////////////////////////////////

function DpXMLDOMCDATASection(xmlComm, xmlDom,parent)
{
	this.xmlNode = xmlComm;
	this.domDoc = xmlDom;
	this.parent = parent;
	this.getData = DpXMLDOMNode_getData;
	this.setData = DpXMLDOMNode_setData;
	this.getOwnerDocument = xmlDom.getOwnerDocument;
	this.getParentNode = xmlDom.getParentNode;
	this.getText = xmlDom.getText;
}

function DpXMLDOMDocument_applyXSL(xmlFile, xslFile)
{	
	xmlFile = DpFile(xmlFile).getAbsolutePath();
	xslFile = DpFile(xslFile).getAbsolutePath();
	if(!isFile(xslFile) || !isFile(xmlFile))
	{
		return false;
	}	
	
	//узнаем имя файла
	var arr = String(xmlFile).split("\\");
	var fileName = arr[arr.length-1];
	arr = null;
	
	var transfFile = DpFile(tempDirectory()+"\\"+fileName).getAbsolutePath();

	var tFactory = javax.xml.transform.TransformerFactory.newInstance();
	
	//vlad 03.11.10
	//если сетевой путь, то не могло откомпилировать 
	//var transformer = tFactory.newTransformer(new javax.xml.transform.stream.StreamSource(xslFile));
	var systemID = java.io.File(xslFile).toURL().toExternalForm( );
	var transformer = tFactory.newTransformer(new javax.xml.transform.stream.StreamSource(systemID));
	
	transformer.transform(new javax.xml.transform.stream.StreamSource(xmlFile), new javax.xml.transform.stream.StreamResult(new java.io.FileOutputStream(transfFile)));
	transformer.reset();
	return transfFile;
}
