include("objects/DpJRegistrator.js");

DpZJournal.prototype.linkCtrl = DpZJournal_linkCtrl;
DpZJournal.prototype.zaval = DpZJournal_zaval;
DpZJournal.prototype.updateCtrl = DpZJournal_updateCtrl;
DpZJournal.prototype.valid = DpZJournal_valid;
DpZJournal.prototype.fillContAssist = DpZJournal_fillContAssist;
DpZJournal.prototype.setCod = DpZJournal_setCod;
DpZJournal.prototype.getCod = DpZJournal_getCod;

function DpZJournal(sMode)
{
	this.sType = "SU";
	this.allow_null = false;
	this.sMode = "SU";
	
	if (sMode)
	{
		if (strIn("s",sMode) || strIn("S",sMode))
			this.sType += "S";
		if (strIn("u",sMode) || strIn("U",sMode))
			this.sType += "U";
		if (strIn("0",sMode))
			this.allow_null = true;
		this.sMode = sMode
	}
	this.idCtrl = null;
	this.txtCtrl = null;
	
	this.oReg = new DpJRegistrator(null,null,this.sType);
}

function DpZJournal_linkCtrl(oID,oTx)
{
	if (oID)
	{
		this.idCtrl = oID;
		this.idCtrl.setContentAssistHandler(this, 
				"fillContAssist", "setCod");
		setButton(oID, this, "zaval");
		setValid(oID, this, "valid");
	}
	if (oTx)
	{
		this.txtCtrl = oTx;
		oTx.setEnabled(false);
	}
}

function DpZJournal_fillContAssist(oCa)
{
	var jID = allt(String(this.idCtrl.getValue()).toUpperCase());
	var len = jID.length;
	var arrJ = this.oReg.listJournals();
	for (var __jID in arrJ)
	{
		var jName = String(arrJ[__jID].getName()).toUpperCase();
		
		if (jID == __jID.substr(0,len))
		{
			oCa.addItem(__jID,__jID + " : " + arrJ[__jID].getName());
		}
	}
}

function DpZJournal_zaval()
{
	var oPar = new Object();
	oPar.zaval = true;
	showWindow("l_cl_usrjrnl.xml",SW_MODAL,oPar);
	
	if (!oPar.escape)
	{
		this.jID = oPar.ret.jID;
		this.txt = oPar.ret.txt;
		this.updateCtrl();
		return true;
	}
	else
	{
		return false;
	}
}

function DpZJournal_updateCtrl()
{
	if (this.idCtrl != null)
		this.idCtrl.setValue(this.jID);
	if (this.txtCtrl != null)
		this.txtCtrl.setValue(this.txt);
}

function DpZJournal_valid()
{
	if (this.idCtrl != null)
		this.jID = this.idCtrl.getValue();
	
	this.jID = String(this.jID).toUpperCase();
	if (allt(this.jID) == "" && this.allow_null)
	{
		this.txt = "";
		this.updateCtrl();
		return true;
	}
	if (typeof(this.oReg.listJournals()[this.jID]) == "undefined")
	{
/*
		this.zaval();
		return this.valid();
*/		return false;
	}
	if (this.txtCtrl != null)
	{
		this.txt = this.oReg.listJournals()[this.jID].getName();
		this.updateCtrl();
	}
	return true;
}

function DpZJournal_getCod()
{
	this.valid();
	return this.jID;
}

function DpZJournal_setCod(sCod)
{
	if (this.idCtrl != null)
		this.idCtrl.setValue(sCod);
	this.jID = sCod;
	this.valid();
}