// Объект DpZavalDoc
// Предназначен для завала в список документов
// Конструктор DpZavalDoc:
//		mFdoc - метка документа
//		mFnop - номер операции
//		mFpar - параметры, передаваемые l_docekz при завале
// Функция setTblName устанавливает имя таблицы заголовков. По умолчанию равно ^H+docLabel
// Функция getDocFwid возвращает fwid выбранного документа 

function DpZavalDoc(mFdoc, mFnop, mFpar)
{
	RO("DpZavalDoc", this);

	this.ctrlCod = null;
	this.doc = mFdoc;
	this.nop = mFnop;
	this.par = mFpar;
	this.docfwid = null;
	this.param = new Object();
	this.filter = "";

	this.tblName = "^H" + this.doc;
	this.tbl = null;

	this.setDoc			= DpZavalDoc_setDoc;
	this.setNop			= DpZavalDoc_setNop;
	this.setPar			= DpZavalDoc_setPar;
	this.setTblName		= DpZavalDoc_setTblName;

	this.getDoc			= DpZavalDoc_getDoc;
	this.getNop			= DpZavalDoc_getNop;
	this.getPar			= DpZavalDoc_getPar;
	this.getTblName		= DpZavalDoc_getTblName;
	this.getDocFwid		= DpZavalDoc_getDocFwid;
	this.getTbl			= DpZavalDoc_getTbl;

	this.linkCtrl		= DpZavalDoc_linkCtrl;
	this.doZaval		= DpZavalDoc_doZaval;
	this.funcValid		= DpZavalDoc_funcValid;
	this.funcUpdate		= DpZavalDoc_funcUpdate;
	this.setValid		= DpZavalDoc_setValid;
	this.setUpdate		= DpZavalDoc_setUpdate;
}

function DpZavalDoc_setDoc(mFdoc)
{
	this.doc = mFdoc;
}

function DpZavalDoc_setNop(mFnop)
{
	this.nop = mFnop;
}

function DpZavalDoc_setPar(mFpar)
{
	this.par = mFpar;
}

function DpZavalDoc_setTblName(mFtblName)
{
	this.tblName = mFtblName;
}

function DpZavalDoc_getDoc()
{
	return this.doc;
}

function DpZavalDoc_getNop()
{
	return this.nop;
}

function DpZavalDoc_getPar()
{
	return this.par;
}

function DpZavalDoc_getTblName()
{
	return this.tblName;
}

function DpZavalDoc_getDocFwid()
{
	return this.docfwid;
}

function DpZavalDoc_getTbl()
{
	return this.tbl;
}

function DpZavalDoc_linkCtrl(mFctrlCod)
{
	this.ctrlCod = mFctrlCod;
	Enable(this.ctrlCod, false);
	this.ctrlCod.setButton(true);
	this.ctrlCod.buttonHandler(this, "doZaval");
	setValid(this.ctrlCod, this, "funcValid");
}

function DpZavalDoc_doZaval()
{
	if (this.par == null || typeof(this.par == "undefined"))
	{
		this.par = new Object();
	}
	this.par.doc = this.doc;
	this.par.nop = this.getNop();
	this.par.isZaval = true;
	this.par.filter = this.filter;
	this.par.ret = new Object();
	this.par.ret.fwid = null;
	showWindow("l_docekz.xml", SW_MODAL, this.par);

	if(!this.par.escape)
	{
		this.docfwid = this.par.ret.fwid;
		this.tbl = OpenTable("m", "SELECT * FROM " + this.tblName + " WHERE FWID = " + sqlTo(this.docfwid));

		if (typeof(this.funcUpdate) == "function")
		{
			this.param.tbl = this.tbl;
			this.funcUpdate(this.param);
		}
	}
}

function DpZavalDoc_funcValid()
{
	if (isEmpty(this.ctrlCod.value))
	{
		this.ctrlCod.setBackground(0xFFAAAA);
		return false;
	}
	else
	{
		this.ctrlCod.setBackground(0xFFFFFF);
		return true;
	}
}

function DpZavalDoc_funcUpdate(tbl)
{

}

function DpZavalDoc_setValid(mFfunc)
{
	this.funcValid = mFfunc;
}

function DpZavalDoc_setUpdate(mFfunc)
{
	this.funcUpdate = mFfunc;
}