//Объект для завала в справочник процедур зарплатных расчетов, который формируется на основе скриптов в директории JDebet/scripts/prik/calculate 
//В будущем в этот справочник можно будет также включать в ручном режиме расчеты на основе объекта "Статистики", предложенный черкасскими диллерами, пока же храним только скрипты
//В скрипте расчета JDebet/scripts/prik/calculate/r_<clacname>.js желательно иметь функцию name_<clacname>(), возвращающую имя расчета в формате "<укр>|<рус>", 
//при отсутствии метода и при отсутствии параметра ftabn_id в параметрах функции расчета, расчет не будет включен в список.
//Имя скрипта и функции, возвращающей имя расчета должны быть в нижнем регистре иначе будут проблемы в линуксе

function DpZrpCalc(emptyMode)
{
	RO("DpZrpCalc", this);
	this.isEmptyMode = emptyMode===true?true:false;//флаг, позволяющий указывать пустую метку расчета
	this.calcDirs = new Array(rootDirectoryEx()+"scripts/prik/calculate/");//массив директорий в которых хранятся скрипты расчетов
	this.calcs = new Array();//массив с именами скриптов
	this.tblName = "^CL_ZRP_CALCS";//таблица справочника процедур расчетов
	this.tmpTblName = "TMP_CL_ZRP_CALCS";//временная таблица для синхронизации
	this.calc = "";//метка расчета
	this.calcName = "";//название расчета
	this.type = "";//тип расчета: s - скрипт, d - парные расчеты, o - объект статистики
	this.num = 0;//порядковый номер
	this.comments = "";//коментарии
	this.ctrlCalc = null;//контрол метки расчета
	this.ctrlCalcName = null;//контрол названия расчета
	this.snapCalcDirs = DpZrpCalc_snapCalcDirs;//формирует массив с именами скриптов this.calcs
	this.synchronize = DpZrpCalc_synchronize;//синхронизация справочника процедур расчетов
	this.linkCtrl = DpZrpCalc_linkCtrl;
	this.updateCtrl = DpZrpCalc_updateCtrl;
	this.validCtrl = DpZrpCalc_validCtrl;
	this.zaval = DpZrpCalc_zaval;
	this.setEmptyMode = DpZrpCalc_setEmptyMode;
	this.getEmptyMode = DpZrpCalc_getEmptyMode;
	this.setCalc = DpZrpCalc_setCalc;
	this.getCalc = DpZrpCalc_getCalc;
	this.getCalcName = DpZrpCalc_getCalcName;
	this.getType = DpZrpCalc_getType;
	this.getNum = DpZrpCalc_getNum;
	this.getComments = DpZrpCalc_getComments;
	this.getSmartTable = DpZrpCalc_getSmartTable;
	this.validMark = DpZrpCalc_validMark;
}

function DpZrpCalc_snapCalcDirs()
{
	//проверяем модульные папки расчетов
	var arrModules = lpProxy.getModules();
	for (var i = 0; i < arrModules.length; i++)
	{
		var sDir = lpProxy.getModulePath(arrModules[i]) +"/scripts/prik/calculate/";
		var file = new DpFile(sDir);			
		if (!file.exists())
			continue;
		this.calcDirs[arrModules[i].toLowerCase()] = file.getAbsolutePath()+"/";
	}
	for(var j in this.calcDirs)
	{
		var allFiles = snapDirectory(this.calcDirs[j]);
		for(var i in allFiles)
		{
			//отбираем скрипты по маске
			if(FileFilterAccept(allFiles[i], "r_*.js"))
			{
				var m = new Object();
				m.name = allFiles[i];
				if(j == 0)
					m.module = "";
				else
					m.module = j;
				var file = new DpFile(this.calcDirs[j]+allFiles[i]);
				m.path = file.getAbsolutePath();
				this.calcs[this.calcs.length] = m;
			}
		}
	}
}

function DpZrpCalc_synchronize()
{
	if(!IsTableEx("CL_MDB", "ZRP_" + this.tblName.replace("^","")))
		CreateTableEx("CL_MDB","ZRP_" + this.tblName.replace("^",""),this.tblName.replace("^",""));
	if(this.calcs.length==0)
		this.snapCalcDirs();
	CreateTable(this.tmpTblName, this.tblName.replace("^",""), "*");
	var step = 1;
	setProgressRange(step, this.calcs.length);
	//сперва занесем во временную таблицу расчеты из папки расчетов
	for(var i=0; i<this.calcs.length; i++)
	{
		//var fileCalc = new DpFile(this.calcDirs+this.calcs[i]).getCanonicalPath();
		//var fileCalc = this.calcDirs+this.calcs[i];
		var fileCalc = String(this.calcs[i].path);
		var ind = fileCalc.lastIndexOf("JDebet");
		if(!isFile(fileCalc) || ind == -1)
			continue;
		var b = include(fileCalc);
//trace(b+">>> include "+fileCalc)
		var m = new Object();
		var proc = String(this.calcs[i].name).toLowerCase();
		proc = proc.substr(1,proc.length-1).replace(".js","");
		//пропускаем расчет _tabpr, т.к. сам по себе он не используется
		if(proc=="_tabpr")
			continue;
		m.flabel = this.calcs[i].module==""?proc:this.calcs[i].module+":"+proc;
		setProgressPos(step++, ru("Сверка скриптовых расчетов: ","Звіряння скриптових розрахунків: ")+m.flabel);
		m.ftype = "s";
		m.fpath = fileCalc.substring(ind, fileCalc.length);
		var funcName = "name"+proc;
//trace("funcName>>"+funcName)
		eval("var existFuncName = typeof("+funcName+")=='function'");
//trace("existFuncName>>"+existFuncName)
		//флаг для определения является ли скрипт расчетом з/п
		var isCalc = false;
		if(existFuncName)
		{
			eval("m.fname="+funcName+"();");
			isCalc = true;
		}
		m.fcomments = "";
		//при отсутствии функции имени расчета, пытаемся определить наличие параметра ftabn_id, также считываем комментарии к расчету в начале скрипта
		var sFile = String(ReadTxtFile(fileCalc,"utf8"));
		// флаг для считывания строк комментариев вида /*...*/
		var isOpenComment = false;
		while(sFile.length>0)
		{
			var nNewLine = sFile.indexOf('\n');
			if(-1 == nNewLine)
			{
				var sLine	= allt(sFile);
				var sFile	= "";
			}
			else
			{
				var sLine	= allt(sFile.substr(0, nNewLine));
				var sFile	= sFile.substr(nNewLine+1);
			}
			//ищем комментарии
			var ind = sLine.indexOf("//");
			var indBeg = sLine.indexOf("/*");
			var indEnd = sLine.indexOf("*/");
			if(ind==0 || indBeg==0 || isOpenComment)
			{
				var sComment = sLine.replace(/(\/\/)|(\/\*)|(\*\/)/g, "");
				m.fcomments += String(m.fcomments).length==0?sComment:"\n"+sComment;
				if(indBeg==0)
					isOpenComment = true;
				if(indEnd==0)
					isOpenComment = false;
			}
			else
			{
				//если название расчета и комментарии уже определены, тогда выходим
				if(existFuncName && String(m.fcomments).length>0)
					break;
			}
			//при считывании строки обрезаем все пробелы, чтобы гарантированно определить заголовок функции
			sLine = sLine.replace(/ /g, "");
			//ищем строку заголовка функции расчета
			if(sLine.indexOf("function"+String(this.calcs[i].name).replace(".js","")+"(")!=-1)
			{
				//при наличии параметра ftabn_id добавляем расчет без названия в таблицу
				if(sLine.indexOf(",ftabn_id")!=-1)
					isCalc = true;
				break;
			}
		}
		if(isCalc)
			UpdateTable(this.tmpTblName, m, true);
	}
	setProgressPos(0);
	//также заносим парные процедуры расчетов, которые расчитываются обособленно для почасовиков на окладе и ЧТСников
	var tbl = OpenTable("select Flabel, MIN(Fnazv) as Fnazv from ^cl_proc group by Flabel order by Flabel");
	setProgressRange(1, tbl.rowCount);
	for(; !tbl.IsEOF(); tbl.MoveNext())
	{
		setProgressPos(tbl.bookmark, ru("Сверка парных процедур расчетов: ","Звіряння праних процедур розрахунків: ")+tbl.getValue("Flabel"));
		var m = new Object();
		m.flabel = tbl.getValue("Flabel");
		m.fname = tbl.getValue("Fnazv");
		m.ftype = "d";
		UpdateTable(this.tmpTblName, m, true);
	}
	tbl.close();
	setProgressPos(0);
	//заносим объекты статистики, на основе которых можно выполнять расчеты
	//!!!UNDER CONSTRUCTION!!!
	
	//обновляем имена и пути скриптов имеющихся в справочнике расчетов
	ExecuteSQL("update "+this.tblName+" set Fname=(select MAX(Fname) from "+this.tmpTblName+" as t where "+this.tblName+".Flabel=t.Flabel), "
				+" Fpath=(select MAX(Fpath) from "+this.tmpTblName+" as t where "+this.tblName+".Flabel=t.Flabel), "
				+" Fcomments=(select MAX(Fcomments) from "+this.tmpTblName+" as t where "+this.tblName+".Flabel=t.Flabel)"
			+" where exists (select Fname from "+this.tmpTblName+" as t where "+this.tblName+".Flabel=t.Flabel)");
	var snap = getSnap("select MAX(Fnum)+1 from "+this.tblName);
	var maxNum = 1;
	if(snap && snap[0])
		maxNum = snap[0];
	//добавляем новые
	var tbl = OpenTable("select * from "+this.tmpTblName+" where not exists(select * from "+this.tblName+" as t where "+this.tmpTblName+".Flabel=t.Flabel) order by Flabel");
	setProgressRange(1, tbl.rowCount);
	for(; !tbl.IsEOF(); tbl.MoveNext())
	{
		setProgressPos(tbl.bookmark, ru("Импорт отсутствующих расчетов: ","Імпорт відсутніх розрахунків: ")+tbl.getValue("Flabel"));
		var m = new Object();
		m.fwid = GetUID();
		m.flabel = tbl.getValue("Flabel");
		m.fname = tbl.getValue("Fname");
		m.ftype = tbl.getValue("Ftype");
		m.fpath = tbl.getValue("Fpath");
		m.fcomments = tbl.getValue("Fcomments");
		m.fnum = maxNum++;
		UpdateTable(this.tblName, m, true);
	}
	tbl.close();
	setProgressPos(0);
	//удаляем отсутствующие
	ExecuteSQL("delete from "+this.tblName+" where not exists(select * from "+this.tmpTblName+" as t where "+this.tblName+".Flabel=t.Flabel)");
	//отсортируем по метке и перенумеруем
	var tbl = OpenTable("select * from "+this.tblName+" order by Ftype, Flabel");
	setProgressRange(1, tbl.rowCount);
	for(; !tbl.IsEOF(); tbl.MoveNext())
	{
		setProgressPos(tbl.bookmark, ru("Перенумерація розрахунків: ","Перенумерация расчетов: ")+tbl.bookmark+"/"+tbl.rowCount);
		ExecuteSQL("update "+this.tblName+" set Fnum="+tbl.bookmark+" where Fwid="+tbl.getValue("Fwid"));
	}
	tbl.close();
	setProgressPos(0);
}

function DpZrpCalc_linkCtrl(ctrl, ctrlTxt)
{
	var msg = ru("Справочник процедур расчетов не синхронизирован!\nВыполнить сверку с эталоном?",
				"Довідник процедур розрахунків не синхронізований!\nВиконати звіряння з еталоном?");
	var snap = getSnap("select count(*) from "+this.tblName, false);
	if((!snap || snap[0]==0) && confirm(msg))
		this.synchronize();
	if(typeOf(ctrl)=="DpTextEx")
	{
		this.ctrlCalc = ctrl;
		this.ctrlCalc.mask = strRepl("&", 20);
		this.ctrlCalc.setButton(true);
		this.ctrlCalc.buttonHandler(this, "zaval");
		setValid(this.ctrlCalc, this, "validCtrl");
		//реализация smart выбора
		this.fillContAssist = DpZrpCalc_fillContAssist;
		this.contAssistHandler = DpZrpCalc_contAssistHandler;
        this.ctrlCalc.setContentAssistHandler(this, "fillContAssist", "contAssistHandler");
	}
	if(typeOf(ctrlTxt)=="DpTextEx")
	{
		this.ctrlCalcName = ctrlTxt;
		Disable(this.ctrlCalcName);
	}
}

function DpZrpCalc_updateCtrl()
{
	if(this.ctrlCalc)
		this.ctrlCalc.value = this.getCalc();
	if(this.ctrlCalcName)
		this.ctrlCalcName.value = this.getCalcName();
	this.smartBeforeChange = this.ctrlCalc.value;	
}

function DpZrpCalc_validCtrl()
{
	if(this.setCalc(this.ctrlCalc.value, this.ctrlCalc.value==""?false:true))
	{
		this.validMark(true);
		return true;
	}
	else
	{
		var isOk = true;
		this.errMsg = null;
		if (this.smartBeforeChange != String(this.ctrlCalc.value) && String(this.ctrlCalc.value)!="")
		{
			var isSet = false;
			var sSQL = "SELECT Flabel"
				+ " FROM ^cl_zrp_calcs "
				+ " WHERE Flabel=" +  sqlTo(String(this.ctrlCalc.value))
			var oSnap =  getSnap(sSQL);
			if (oSnap && oSnap[0])
			{
				this.setCalc(String(this.ctrlCalc.value));
				isOk = true;
				isSet = true;
			}
			
			if (!isSet && String(this.ctrlCalc.value).indexOf(":") != -1)
			{
				isSet = this.setCalc(String(this.ctrlCalc.value).split(":")[0]);
			}
			if (!isSet)
			{
				var t = this.getSmartTable();
				
				if (t.recordCount == 1)
				{
					this.setCalc(t.getValue("flabel"));
					isOk = true;
				}
				else
					isOk = false;
				if (t!= null)
					t.close();
			}
		}
		else if (String(this.ctrlCalc.value)=="")
		{
			this.setCalc("");
			isOk = this.isEmptyMode || (this.getCalc() != "" && this.getCalc() != null);
			this.errMsg = ru("Пустое значение недопустимо!","Пусте значення неприпустимо!");
		}
		this.validMark(isOk);
		if (!isOk)
		{
			this.ctrlCalc.showErr(this.errMsg
				? this.errMsg
				: ru("Такого элемента нет в справочнике. Укажите метку расчета или подстроку его названия.",
					"Такого елемента немає у довіднику. Вкажіть мітку розрахунку або підрядок його назви."));
		}
		this.ctrlCalc.getCtrl().selectAll();
		return isOk;
		//return this.zaval();
	}
}

function DpZrpCalc_zaval()
{
	var par = new Object();
	par.zaval = true;
	par.escape = true
	par.ret = new Object();
	par.ret.Flabel = this.getCalc();
	showWindow("l_cl_zrp_calcs.js", SW_MODAL, par);
	if (!par.escape)
		return this.setCalc(par.ret.Flabel);
	else
		return false;
}

function DpZrpCalc_setEmptyMode(mode)
{
	if(mode===true)
		this.isEmptyMode = true;
	else
		this.isEmptyMode = false;
}

function DpZrpCalc_getEmptyMode()
{
	return this.isEmptyMode;
}

function DpZrpCalc_setCalc(calc, toNotRest)
{
	calc = allt(calc).toLowerCase();
	var tbl = OpenTable("select * from ^cl_zrp_calcs where Flabel="+sqlTo(calc));
	if(tbl.rowCount>0)
	{
		this.calc = calc;
		this.calcName = tbl.getValue("Fname");
		this.type = tbl.getValue("Ftype");
		this.num = Number(tbl.getValue("Fnum"));
		this.comments = tbl.getValue("Fcomments");
		this.updateCtrl();
		tbl.close();
		return true;
	}
	else
	{
		tbl.close();
		if(!toNotRest)
		{
			this.calc = "";
			this.calcName = "";
			this.type = "";
			this.num = 0;
			this.comments = "";
			this.updateCtrl();
		}
		if(calc == "" && this.isEmptyMode && !toNotRest)
			return true;
		else
			return false;
	}
}

function DpZrpCalc_getCalc()
{
	return this.calc;
}

function DpZrpCalc_getCalcName(isFull)
{
	if(isFull === true)
		return this.calcName;
	else
		return UR(this.calcName);
}

function DpZrpCalc_getType()
{
	return this.type;
}

function DpZrpCalc_getNum()
{
	return this.num;
}

function DpZrpCalc_getComments()
{
	return this.comments;
}

function DpZrpCalc_fillContAssist(ca)
{
	var str = String(this.ctrlCalc.value);
	if (str == "")
		return;
	
	var tblChoose = this.getSmartTable();
	var n = 0;
	while (!tblChoose.isEOF())
	{
		var sName = tblChoose.getValue("Flabel");
		var sTxt = tblChoose.getValue("Fname");
		ca.addItem(sName, sName + " : " + UR(sTxt));
		tblChoose.MoveNext();
		n++;
		if (n==30)
			break;
	}
	tblChoose.close();
}

function DpZrpCalc_contAssistHandler(calc)
{
	this.setCalc(calc);
}

function DpZrpCalc_getSmartTable(mode)
{
	var str = String(this.ctrlCalc.value);
	var sSQL = "SELECT " + (SUBD==MSSQL?" TOP 30 ":"")+ " flabel, fname FROM ^cl_zrp_calcs ";	
	var sWhere = " where Fnouse = " + sqlFalse;
	var sWord = str.trim();
	if (sWord && sWord != "???" && sWord != "_")	
		sWhere +=  " and (LOWER(flabel) LIKE " + sqlTo((sWord[0]=="_" || sWord[0]==":"?"":"_")+sWord.toLowerCase()+"%")+" or LOWER(fname) LIKE " + sqlTo("%"+sWord.toLowerCase()+"%")+")";
	sSQL += (sWhere + " order by flabel ");
	return OpenTable(sSQL);
}

function DpZrpCalc_validMark(isOk)
{
	if(this.ctrlCalc)
		this.ctrlCalc.setBackground(isOk? 0xFFFFFF: 0xFFAAAA);
}