//Объект для завала в справочник типов приказов, который формируется на основе папок, которые начинаются с символа подчеркивания в директории JDebet/scripts/prik
//Название приказа желательно указывать в файле описания класса class.xml в атрибуте name="<укр>|<рус>"
//Во избежание проблем, связанных с регистром в линуксе, имена папок с описанием приказов нужно заводить в верхнем регистре,
//но в справочнике и в перечне доплат/удержаний они будут отображаться в нижнем регистре, если приказ модульный, то имя модуля нужно заводить в нижнем регистре
include ("objects/DpXMLDomDocument.js");

function DpZrpPrik(emptyMode)
{
	RO("DpZrpPrik", this);
	this.isEmptyMode = emptyMode===true?true:false;//флаг, позволяющий указывать пустую метку приказа
	this.prikDirs = new Array(rootDirectoryEx()+"scripts/prik/");//массив директорий в которых хранятся основные и модульные приказы
	this.priks = new Array();//массив папок приказов
	this.tblName = "^CL_ZRP_PRIKS";//таблица справочника типов приказов
	this.tmpTblName = "TMP_CL_ZRP_PRIKS";//временная таблица для синхронизации
	this.prik = "";//метка приказа
	this.prikName = "";//название приказа
	this.num = 0;//порядковый номер
	this.comments = "";//коментарии
	this.ctrlPrik = null;//контрол метки расчета
	this.ctrlPrikName = null;//контрол названия расчета
	this.snapPrikDirs = DpZrpPrik_snapPrikDirs;//формирует массив с именами папок приказов this.priks
	this.synchronize = DpZrpPrik_synchronize;//синхронизация справочника типов приказов
	this.linkCtrl = DpZrpPrik_linkCtrl;
	this.updateCtrl = DpZrpPrik_updateCtrl;
	this.validCtrl = DpZrpPrik_validCtrl;
	this.zaval = DpZrpPrik_zaval;
	this.setEmptyMode = DpZrpPrik_setEmptyMode;
	this.getEmptyMode = DpZrpPrik_getEmptyMode;
	this.setPrik = DpZrpPrik_setPrik;
	this.getPrik = DpZrpPrik_getPrik;
	this.getPrikName = DpZrpPrik_getPrikName;
	this.getNum = DpZrpPrik_getNum;
	this.getComments = DpZrpPrik_getComments;
	this.getSmartTable = DpZrpPrik_getSmartTable;
	this.validMark = DpZrpPrik_validMark;
}

function DpZrpPrik_snapPrikDirs()
{
	//проверяем модульные папки приказов
	var arrModules = lpProxy.getModules();
	for (var i = 0; i < arrModules.length; i++)
	{
		var sDir = lpProxy.getModulePath(arrModules[i]) +"/scripts/prik";
		var file = new DpFile(sDir);			
		if (!file.exists())
			continue;
		this.prikDirs[arrModules[i].toLowerCase()] = file.getAbsolutePath();
	}
	
	for(var j in this.prikDirs)
	{
		var allDirs = snapDirectory(this.prikDirs[j]);
		for(var i in allDirs)
		{
			//отбираем папки начинающиеся с символа подчеркивания и имеющие class.xml, кроме базового класса
			if(String(allDirs[i]).charAt(0) == "_" && allDirs[i] != "_PRKBASE")
			{
				var m = new Object();
				m.label = (j==0?"":j+":")+allDirs[i].toLowerCase();
				m.path = this.prikDirs[j];
				var classFile = new DpFile(this.prikDirs[j]+"/"+allDirs[i]+"/class.xml");
				if (!classFile.exists())
					continue;
				var xmlDoc = new DpXMLDOMDocument();					
				xmlDoc.load(classFile);	
				var xmlDocElement = xmlDoc.getDocumentElement();
				m.name = xmlDocElement.getAttribute("name");
				//ищем коментарии
				var xmlChildNodes = xmlDocElement.getChildNodes();
				for (var k = 0;k < xmlChildNodes.length; k++)
				{
					var ChildElement = xmlChildNodes[k];
					if (ChildElement != null)
					{			
						var xmlChildNode = ChildElement.getNodeName();
						if(xmlChildNode.toUpperCase() == "COMMENTS")
						{
							m.comments = ChildElement.getText();
							break;
						}
					}
				}
				this.priks[this.priks.length] = m;
			}
		}
	}
}

function DpZrpPrik_synchronize()
{
	if(!IsTableEx("CL_MDB", "ZRP_" + this.tblName.replace("^","")))
		CreateTableEx("CL_MDB","ZRP_" + this.tblName.replace("^",""),this.tblName.replace("^",""));
	if(this.priks.length==0)
		this.snapPrikDirs();
	CreateTable(this.tmpTblName, this.tblName.replace("^",""), "*");
	var step = 1;
	setProgressRange(step, this.priks.length);
	//сперва занесем во временную таблицу все приказы
	for(var i=0; i<this.priks.length; i++)
	{
		setProgressPos(step++, ru("Сверка приказов: ","Звіряння наказів: ")+this.priks[i].label);
		var m = new Object();
		m.flabel = this.priks[i].label;
		m.fname = this.priks[i].name;
		m.fpath = getAbsolutePath(this.priks[i].path);
		m.fcomments = this.priks[i].comments;
		UpdateTable(this.tmpTblName, m, true);
	}
	setProgressPos(0);
	//обновляем имена имеющихся в справочнике расчетов
	ExecuteSQL("update "+this.tblName+" set Fname=(select Fname from "+this.tmpTblName+" as t where "+this.tblName+".Flabel=t.Flabel), "
				+" Fpath=(select Fpath from "+this.tmpTblName+" as t where "+this.tblName+".Flabel=t.Flabel), "
				+" Fcomments=(select Fcomments from "+this.tmpTblName+" as t where "+this.tblName+".Flabel=t.Flabel) "
			+" where exists (select Fname from "+this.tmpTblName+" as t where "+this.tblName+".Flabel=t.Flabel)");
	var snap = getSnap("select MAX(Fnum)+1 from "+this.tblName);
	var maxNum = 1;
	if(snap && snap[0])
		maxNum = snap[0];
	//добавляем новые
	var tbl = OpenTable("select * from "+this.tmpTblName+" where not exists(select * from "+this.tblName+" as t where "+this.tmpTblName+".Flabel=t.Flabel) order by Flabel");
	setProgressRange(1, tbl.rowCount);
	for(; !tbl.IsEOF(); tbl.MoveNext())
	{
		setProgressPos(tbl.bookmark, ru("Импорт отсутствующих приказов: ","Імпорт відсутніх наказів: ")+tbl.getValue("Flabel"));
		var m = new Object();
		m.fwid = GetUID();
		m.flabel = tbl.getValue("Flabel");
		m.fname = tbl.getValue("Fname");
		m.fpath = tbl.getValue("Fpath");
		m.fcomments = tbl.getValue("Fcomments");
		m.fnum = maxNum++;
		UpdateTable(this.tblName, m, true);
	}
	tbl.close();
	setProgressPos(0);
	//удаляем отсутствующие
	ExecuteSQL("delete from "+this.tblName+" where not exists(select * from "+this.tmpTblName+" as t where "+this.tblName+".Flabel=t.Flabel)");
	//отсортируем по метке и перенумеруем
	var tbl = OpenTable("select * from "+this.tblName+" order by Flabel");
	setProgressRange(1, tbl.rowCount);
	for(; !tbl.IsEOF(); tbl.MoveNext())
	{
		setProgressPos(tbl.bookmark, ru("Перенумерація наказів: ","Перенумерация приказов: ")+tbl.bookmark+"/"+tbl.rowCount);
		ExecuteSQL("update "+this.tblName+" set Fnum="+tbl.bookmark+" where Fwid="+tbl.getValue("Fwid"));
	}
	tbl.close();
	setProgressPos(0);
}

function DpZrpPrik_linkCtrl(ctrl, ctrlTxt)
{
	var msg = ru("Справочник типов приказов не синхронизирован!\nВыполнить сверку с эталоном?",
				"Довідник типів наказів не синхронізований!\nВиконати звіряння з еталоном?");
	var snap = getSnap("select count(*) from "+this.tblName, false);
	if((!snap || snap[0]==0) && confirm(msg))
		this.synchronize();
	if(typeOf(ctrl)=="DpTextEx")
	{
		this.ctrlPrik = ctrl;
		this.ctrlPrik.mask = strRepl("&", 20);
		this.ctrlPrik.setButton(true);
		this.ctrlPrik.buttonHandler(this, "zaval");
		setValid(this.ctrlPrik, this, "validCtrl");
		//реализация smart выбора
		this.fillContAssist = DpZrpPrik_fillContAssist;
		this.contAssistHandler = DpZrpPrik_contAssistHandler;
        this.ctrlPrik.setContentAssistHandler(this, "fillContAssist", "contAssistHandler");
	}
	if(typeOf(ctrlTxt)=="DpTextEx")
	{
		this.ctrlPrikName = ctrlTxt;
		Disable(this.ctrlPrikName);
	}
}

function DpZrpPrik_updateCtrl()
{
	if(this.ctrlPrik)
		this.ctrlPrik.value = this.getPrik();
	if(this.ctrlPrikName)
		this.ctrlPrikName.value = this.getPrikName();
	this.smartBeforeChange = this.ctrlPrik.value;
}

function DpZrpPrik_validCtrl()
{
	if(this.setPrik(this.ctrlPrik.value, this.ctrlPrik.value==""?false:true))
	{
		this.validMark(true);
		return true;
	}
	else
	{
		var isOk = true;
		this.errMsg = null;
		if (this.smartBeforeChange != String(this.ctrlPrik.value) && String(this.ctrlPrik.value)!="")
		{
			var isSet = false;
			var sSQL = "SELECT Flabel"
				+ " FROM ^cl_zrp_priks "
				+ " WHERE Flabel=" +  sqlTo(String(this.ctrlPrik.value))
			var oSnap =  getSnap(sSQL);
			if (oSnap && oSnap[0])
			{
				this.setPrik(String(this.ctrlPrik.value));
				isOk = true;
				isSet = true;
			}
			
			if (!isSet && String(this.ctrlPrik.value).indexOf(":") != -1)
			{
				isSet = this.setPrik(String(this.ctrlPrik.value).split(":")[0]);
			}
			if (!isSet)
			{
				var t = this.getSmartTable();
				
				if (t.recordCount == 1)
				{
					this.setPrik(t.getValue("flabel"));
					isOk = true;
				}
				else
					isOk = false;
				if (t!= null)
					t.close();
			}
		}
		else if (String(this.ctrlPrik.value)=="")
		{
			this.setPrik("");
			isOk = this.isEmptyMode || (this.getPrik() != "" && this.getPrik() != null);
			this.errMsg = ru("Пустое значение недопустимо!","Пусте значення неприпустимо!");
		}
		this.validMark(isOk);
		if (!isOk)
		{
			this.ctrlPrik.showErr(this.errMsg
				? this.errMsg
				: ru("Такого элемента нет в справочнике. Укажите метку приказа или подстроку его названия.",
					"Такого елемента немає у довіднику. Вкажіть мітку наказу або підрядок його назви."));
		}
		this.ctrlPrik.getCtrl().selectAll();
		return isOk;
		//return this.zaval();
	}
}

function DpZrpPrik_zaval()
{
	var par = new Object();
	par.zaval = true;
	par.escape = true
	par.ret = new Object();
	par.ret.Flabel = this.getPrik();
	showWindow("l_cl_zrp_priks.js", SW_MODAL, par);
	if (!par.escape)
		return this.setPrik(par.ret.Flabel);
	else
		return false;
}

function DpZrpPrik_setEmptyMode(mode)
{
	if(mode===true)
		this.isEmptyMode = true;
	else
		this.isEmptyMode = false;
}

function DpZrpPrik_getEmptyMode()
{
	return this.isEmptyMode;
}

function DpZrpPrik_setPrik(prik, toNotRest)
{
	prik = allt(prik).toLowerCase();
	var tbl = OpenTable("select * from ^cl_zrp_priks where Flabel="+sqlTo(prik));
	if(tbl.rowCount>0)
	{
		this.prik = prik;
		this.prikName = tbl.getValue("Fname");
		this.num = Number(tbl.getValue("Fnum"));
		this.comments = tbl.getValue("Fcomments");
		this.updateCtrl();
		tbl.close();
		return true;
	}
	else
	{
		tbl.close();
		if(!toNotRest)
		{
			this.prik = "";
			this.prikName = "";
			this.num = 0;
			this.comments = "";
			this.updateCtrl();
		}
		if(prik == "" && this.isEmptyMode && !toNotRest)
			return true;
		else
			return false;
	}
}

function DpZrpPrik_getPrik()
{
	return this.prik;
}

function DpZrpPrik_getPrikName(isFull)
{
	if(isFull === true)
		return this.prikName;
	else
		return UR(this.prikName);
}

function DpZrpPrik_getNum()
{
	return this.num;
}

function DpZrpPrik_getComments()
{
	return this.comments;
}

function DpZrpPrik_fillContAssist(ca)
{
	var str = String(this.ctrlPrik.value);
	if (str == "")
		return;
	
	var tblChoose = this.getSmartTable();
	var n = 0;
	while (!tblChoose.isEOF())
	{
		var sName = tblChoose.getValue("Flabel");
		var sTxt = tblChoose.getValue("Fname");
		ca.addItem(sName, sName + " : " + UR(sTxt));
		tblChoose.MoveNext();
		n++;
		if (n==30)
			break;
	}
	tblChoose.close();
}

function DpZrpPrik_contAssistHandler(prik)
{
	this.setPrik(prik);
}

function DpZrpPrik_getSmartTable(mode)
{
	var str = String(this.ctrlPrik.value);
	var sSQL = "SELECT " + (SUBD==MSSQL?" TOP 30 ":"")+ " flabel, fname FROM ^cl_zrp_priks ";	
	var sWhere = " where Fnouse = " + sqlFalse;
	var sWord = str.trim();
	if (sWord && sWord != "???" && sWord != "_")	
		sWhere +=  " and (LOWER(flabel) LIKE " + sqlTo((sWord[0]=="_"?"":"_")+sWord.toLowerCase()+"%")+" or LOWER(fname) LIKE " + sqlTo("%"+sWord.toLowerCase()+"%")+")";
	sSQL += (sWhere + " order by flabel ");
	return OpenTable(sSQL);
}

function DpZrpPrik_validMark(isOk)
{
	if(this.ctrlPrik)
		this.ctrlPrik.setBackground(isOk? 0xFFFFFF: 0xFFAAAA);
}