include("Objects/DpCntrct.js");
include("doc/DpDoc.js");
include("Objects/DpNmkl.js");
include("Objects/DpCl.js");
include("Objects/DpEdi.js");
include("Objects/DpVal.js");
include("Objects/DpRasSc.js");
include("Objects/DpPostRs.js");

DpzSelect.prototype.linkCtrl = DpzSelect_linkCtrl;
DpzSelect.prototype.zaval = DpzSelect_zaval;
DpzSelect.prototype.updateCtrl = DpzSelect_updateCtrl;
DpzSelect.prototype.valid = DpzSelect_valid;
DpzSelect.prototype.setCod = DpzSelect_setCod;
DpzSelect.prototype.getCod = DpzSelect_getCod;
DpzSelect.prototype.setType = DpzSelect_setType;
DpzSelect.prototype.getType = DpzSelect_getType;
DpzSelect.prototype.setObj = DpzSelect_setObj;
DpzSelect.prototype.setMode = DpzSelect_setMode;
DpzSelect.prototype.setCl = DpzSelect_setCl;
DpzSelect.prototype.getCl = DpzSelect_getCl;
DpzSelect.prototype.setClcl = DpzSelect_setClcl;
DpzSelect.prototype.getClcl = DpzSelect_getClcl;
DpzSelect.prototype.setValid = DpzSelect_setValid;
DpzSelect.prototype.getTxt = DpzSelect_getTxt;

function DpzSelect(sMode, sType)
{
	this.obj = null;
	this.type = "";
	this.cod = 0;
	this.txt = "";
	
	this.ctrlCod = null;
	this.ctrlTxt = null;
	this.mode = "";
		
	if(!sType)
		sType = "";
	this.setType(sType);
	if(sMode)
		this.setMode(sMode);
}

function DpzSelect_setType(sType)
{
	this.type = String(sType).toLowerCase();
	if(this.ctrlCod)
	{
		this.ctrlCod.mask = "&&&&&&&&&&&&&&&&&&&&&&&&&";
		Enable(this.ctrlCod);
	}
	
	if(String(sType).indexOf("docs")!=-1)
	{
		var doc = String(sType).substring(5);
		this.obj = new DpDoc(doc, 0);
		this.type = "docs";
		return;
	}
	
	switch(this.type)
	{
		case "cntrct":
			// eugene 16.02.2012. В проводках нельзя оставлять пустым договор, 
			// иначе зачем его настраивать в плане счетов
			this.obj = new DpCntrct("+");
			break;			
		case "nmkl":
			this.obj = new DpNmkl();
			break;			
		case "edi":
			this.obj = new DpEdi();
			break;			
		case "val":
			this.obj = new DpVal();
			break;
		case "rs":			
			this.obj = new DpPostRs();
			var oOrg = new DpCl("", getPar("CODMYORG"));
			oOrg.setCod(getPar("ORGNOM"));
			this.obj.setDpCl(oOrg, true);
			break;
		default:
			this.obj = new DpCl("N");
			this.obj.ctrlCod = this.ctrlCod;
			if(this.ctrlCod)
				this.ctrlCod.mask = "##########";
			Disable(this.ctrlCod);
			//this.obj.enableUnderCtrl();
			break;
	}
	//this.updateCtrl();
	this.setMode(this.mode);
}

function DpzSelect_getType()
{
	return this.type;
}

function DpzSelect_setObj(obj)
{
	this.obj = obj;
}

function DpzSelect_setMode(sMode)
{
	this.mode = sMode;
	if(this.obj.setMode)
		this.obj.setMode(sMode);
}

function DpzSelect_linkCtrl(ctrlCod, ctrlTxt)
{
	if(ctrlCod)
	{
		if(this.obj)
		{
			this.obj.ctrlCod = this.obj.ctrlNum 
				= this.obj.dpTextCtrl = this.obj.ctrlSc 
				= ctrlCod;
		}
		this.ctrlCod = ctrlCod;
		setButton(ctrlCod, this, "zaval");
		setValid(ctrlCod, this, "valid");
	}
	if(ctrlTxt)
	{
		if(this.obj)
		{
			this.obj.ctrlMFO = ctrlTxt;
		}
		this.ctrlTxt = ctrlTxt;
		ctrlTxt.setEnabled(false);
	}
	this.updateCtrl();
}

function DpzSelect_zaval()
{
	if(this.type=="docs")
	{
		var par = new Object();		
		par.doc = this.obj.sDocLbl;
		par.nop = 0;
		par.isZaval = true;
		par.ret = new Object();
		par.ret.Fdog_num = null;
		par.ret.Fwid = null;
		showWindow("l_docekz.xml", SW_MODAL, par);
		if(par.escape)
			return;
		this.cod = par.ret.Fwid;
		this.ctrlCod.value = par.ret.Fdog_num;
		this.obj.setID(par.ret.Fwid);
		this.obj.setVar("HDOG_NUM", par.ret.Fdog_num);
		return;
	}
	this.obj.zaval();	
	this.cod = this.obj.getCod();	
	this.ctrlCod.value = this.obj.getCod("c");
	if(this.obj.getTxts && this.type!="")
		this.ctrlCod.value = this.obj.getTxts();
	if(this.type=="cntrct")
	{
		this.ctrlCod.value = this.obj.getNum();
	}
	this.updateCtrl();
	//this.valid();
}

function DpzSelect_updateCtrl()
{
	if(this.type=="docs")
	{
		this.ctrlCod.setValue(this.obj.getVar("HDOG_NUM"));
		return;		
	}
	if (this.ctrlCod != null)
	{
		this.ctrlCod.setValue(this.obj.getCod("c"));
		if(this.obj.getNum)
			this.ctrlCod.setValue(this.obj.getNum());
	}
	if(this.obj.getTxt)
		this.txt = this.obj.getTxt();
	if (this.ctrlTxt != null)
		this.ctrlTxt.setValue(this.txt);
	if(this.obj.updateCtrl)
		this.obj.updateCtrl();
	
	if(this.type=="cntrct" && this.ctrlCod)
	{
		this.ctrlCod.setValue(this.obj.getNum());
	}

}

function DpzSelect_valid(isSilenceMode)
{
	var bRet = true;	
	if (this.ctrlCod != null)
	{
		if(this.ctrlCod.isDisposed())
			return true;
		if(this.type=="cntrct")
		{
			this.obj.setNum(this.ctrlCod.value);
		}
		else if(this.type=="")
			this.obj.setCod(this.ctrlCod.value);
	}
	this.updateCtrl();
	if(this.obj.zValid && !isSilenceMode)
		bRet = this.obj.zValid();
	else if(this.obj.valid)
		bRet = this.obj.valid();
	//if(this.obj.updateCtrl)
	//	this.obj.updateCtrl();
	return bRet;
}

function DpzSelect_getCod(mode)
{
	if(this.type=="docs")
		return this.obj.getID();
	return this.obj.getCod(mode);
}

function DpzSelect_setCod(cod)
{
	//vlad нам из расширений приходит код номенклатуры строковый
	//cod = Number(cod);
	cod = toScrObj(cod);
	this.cod = cod;
	if(this.type=="docs")
	{
		this.obj.loadByID(cod);
		if(this.ctrlCod)
			this.ctrlCod.setValue(this.obj.getVar("HDOG_NUM"));
		return;
	}	
	this.obj.setCod(cod);	
	if (this.ctrlCod != null)
	{
		this.ctrlCod.setValue(this.obj.getCod("c"));
		if(this.type=="cntrct")
		{
			this.ctrlCod.value = this.obj.getNum();
		}
		if(this.obj.getTxts && this.type!="")
			this.ctrlCod.value = this.obj.getTxts();
	}
	//this.valid();
	if(this.afterLoad)
		this.afterLoad();
}

function DpzSelect_setCl(oCl)
{
	if(this.obj.setCl)
		this.obj.setCl(oCl);
}

function DpzSelect_getCl()
{
	if(this.obj.getCl)
		return this.obj.getCl();
	return null;
}

function DpzSelect_setClcl(oCl)
{
	if(this.obj.setClcl)
		this.obj.setClcl(oCl);
}

function DpzSelect_getClcl()
{
	if(this.obj.getClcl)
		return this.obj.getClcl();
	return null;
}

function DpzSelect_setValid(obj, sFunc)
{
	if(this.obj.setValid)
		this.obj.setValid(obj, sFunc);
}

function DpzSelect_getTxt()
{
	if(this.obj.getTxt)
		return this.obj.getTxt();
	return "";
}