FRMDecoder.prototype.parseForm = FRMDecoder_parseForm;
FRMDecoder.prototype.parseShab = FRMDecoder_parseShab;
FRMDecoder.prototype.run = FRMDecoder_run;

function FRMDecoder()
{
	this.srcPath = rootDirectoryEx() + "source\\FRM.xml";
	this.toPath = rootDirectoryEx() + "listPrintForms\\";
	this.srcFrom = "O:\\debetHtml_head\\office\\";
}

function FRMDecoder_run()
{
	var frmDoc = openXmlFile(this.srcPath);
	var root = frmDoc.getDocumentElement();
	var shabList = root.getElementsByTagName("SHAB");
	setProgressRangeEx(1,shabList.getLength());
	for (var nShab = 0; nShab < shabList.length; nShab++)
	{
		setProgressPosEx(nShab);
		this.parseShab(shabList.item(nShab));
	}
	setProgressPosEx(0);
}

function FRMDecoder_parseShab(shabEl)
{
	var shabName = shabEl.getAttribute("name");
	var shabSys = shabEl.getAttribute("sys");
	
	if (allt(shabName) == "") return false;
	
	var srcDir = this.toPath + shabName;
	var dir = new DpFile(srcDir);
	createDirectory(srcDir);
	
	var frmEl = shabEl.getElementsByTagName("forms");
	if (frmEl && frmEl.getLength() > 0)
	{
		var forms = frmEl.item(0).getElementsByTagName("form");
		for (var nFrm = 0; nFrm < forms.getLength(); nFrm++)
			this.parseForm(shabSys,srcDir,forms.item(nFrm));
	}
	
	var varEl = shabEl.getElementsByTagName("vars");
	if (varEl && varEl.getLength() > 0)
	{
		var varDoc = createXmlDoc();
		var root = varDoc.createElement("DpFrmVarList");
		root.setAttribute("pattern",shabName);
		varDoc.appendChild(root);
		
		var varList = varEl.item(0).getElementsByTagName("var");
		for (var nVar = 0; nVar < varList.getLength(); nVar++)
		{
			var vrEl = varDoc.createElement("var");
			vrEl.setAttribute("name",varList.item(nVar).getAttribute("name"));
			vrEl.setAttribute("expr",varList.item(nVar).getAttribute("expr"));
			vrEl.setAttribute("type",varList.item(nVar).getAttribute("type"));
			vrEl.setAttribute("system","true");
			vrEl.setTextContent(varList.item(nVar).getTextContent());
			root.appendChild(vrEl);
		}
		saveXml(srcDir + "\\vars.xml",varDoc);
	}
}

function FRMDecoder_parseForm(sys,dir,frmEl)
{
	var text = frmEl.getAttribute("text");
	var lbl = frmEl.getAttribute("file");
	var ext = frmEl.getAttribute("ext");
	if (allt(ext) == "")
		ext = "jrxml";
	else
	{
		var f = new DpFile(this.srcFrom + lbl + "." + ext);
		trace(f.getName() + " -- " + f.exists());
		if (f.exists())
		{
			copyFile(dir + "\\" + lbl + "." + ext,f.getName());
		}
	}
	var fileName = lbl + "." + ext;
	var frmDoc = createXmlDoc();
	var root = frmDoc.createElement("DpPrintForm");
	root.setAttribute("text",text);
	root.setAttribute("type",ext);
	root.setAttribute("file",fileName);
	root.setAttribute("sys",sys);
	frmDoc.appendChild(root);
	saveXml(dir + "\\" + lbl + ".xml",frmDoc);
}