/*
	Расчет оборотного баланса
	(C) ДЕБЕТ Плюс, 1999
	02.02.99-09.03.99 - DAE
	Варианты вызова:
		- oblns(dat1, dat2, outTbl)
			Расчет оборотного баланса в чистом виде
		- oblns(mode, dat1, dat2, outTbl)
			Указание режима расчета
		Режимы:
		"" - оборотный баланс в чистом виде
		"u" - оборотный баланс в разрезе счет/субсчет
		"t" - оборотный баланс в разрезе счет/субсчет/статья
		"_" - общий итог становится внизу за счет того, что
		      счет = sc_sup
		"s" - заполнять поля fssumX справочной суммой
		"v" - заполнять поля fvsumX суммой в переводе на 
		      справочную валюту
      "^" - использовать "фальшивые" план счетов, проводки, остатки.
            Имена "фальшивых" таблиц состоят из оригинального имени таблицы
            с префиксом, равным параметру outTbl.
      "n" - не формировать итоговые записи
      "l" - итоги группируются по аналитике
		      (для обротов по коду)
      "3" - 3 аналитики	  
*/

include("sys\\dpsql.js");

function oblns(mode, dat1, dat2, outTbl, oSc)
{
	// Для поддержки вызова типа oblns(dat1, dat2, outTbl)
	if(typeof(mode)!="string")
	{
		//alert("Передайте в процедура oblns первым параметром режим");
		return oblns("", mode, dat1, dat2);
	}

	if(strIn("^", mode))
	{
		var cl_schet = outTbl + "_cl_schet",
		schet_sl = outTbl + "_schet_sl",
		schet = outTbl + "_schet",
		schet_zr = outTbl + "_schet_zr";
	}
	else
	{
		var cl_schet = "^cl_schet",
		schet_sl = "^schet_sl",
		schet = "^schet",
		schet_zr = "^schet_zr";
	}
   
	var isItog = !strIn("n", mode);
	var isClGroup = strIn("l", mode);
	var is3Cl = strIn("3", mode);
	
	var preGroup = is3Cl? "fcl_cod1, fcl_cod2, fcl_cod3, ": isClGroup? "fcl_cod1, ": "";
	var clField = is3Cl? "fcl_cod1, fcl_cod2, fcl_cod3"
		: (isClGroup? "fcl_cod1": "0 as fcl_cod1") 
			+ ", 0 as fcl_cod2, 0 as fcl_cod3"
			;
	
	var cRazr = ""
	if(strIn("u", mode))
		cRazr = "u";
	else if(strIn("t", mode))
		cRazr = "t";

	if(!outTbl)
		outTbl = "tmp_obln";

	var sqlDat1 = sqlTo(dat1),
		sqlDat2 = sqlTo(dat2);
	
	//фильтр на организацию
	var orgCond = "";
	if(getPar("BLNBYORG"))
		orgCond = " and Forg0="+CURRENT_ORG;

	//setProgressRange(0, 4);

	// Формируем таблицу с датами самых "свежих" начальных остатков
	var s;
	timeBegin("Формируем таблицу с датами самых свежих начальных остатков")
	var tblDateSl = OpenTable("s",
		"SELECT fsc,"
			+ " max(^schet_sl.fdate) as fdate"
		+ " FROM ^schet_sl"
		+ " WHERE fdate<=" + sqlDat1 + orgCond
		+ " GROUP BY fsc"
		+ " ORDER BY 2"
		);
	timeEnd("Формируем таблицу с датами самых свежих начальных остатков")

	var sldCond;	//условие попадания даты в расчет
	if(tblDateSl.IsEOF())	// начальные остатки не найдены
	{
		sldCond = sqlCmpTrue;
	}
	else
	{
		tblDateSl.MoveFirst();
		var fsc = Number(tblDateSl.getValue("fsc")),
			fdate = sqlTo(tblDateSl.getValue("fdate")),
			prevDate = fdate;

		sldCond = "( ((fsc IN (" + fsc;
		var scList = fsc;	// список счетов, по которым найдены остатки

		tblDateSl.MoveNext();
		while( !tblDateSl.IsEOF() )
		{
			fsc = Number(tblDateSl.getValue("fsc"));
			fdate = sqlTo(tblDateSl.getValue("fdate"));
			if (fdate == prevDate)
				sldCond += ", " + fsc;
			else
			{
				sldCond += ")) and fdate>=" + prevDate + ") or ((fsc IN (" + fsc;
				prevDate = fdate;
			}
			scList += "," + fsc;
			tblDateSl.MoveNext();
		}
		sldCond += ")) and fdate>=" + prevDate + ") "
			+ "or (fsc not in (" + scList + "))"
			+ " )";
	}
	
	if(oSc && oSc.getSc())
		sldCond += " AND fsc=" + sqlTo(oSc.getSc());

	//alert(sldCond);

	// Создание таблицы TMP_OBLNS1
	// В ней будут скидываться записи по проводкам и начальным остаткам
	DropTable(outTbl + "_1");
	ExecuteSQL(
		"CREATE TABLE " + outTbl + "_1 ("
			+ " fsc " + SqlType(sqlTSc) + ","
			+ " fsu " + SqlType(sqlTSu) + ","
			+ " fst " + SqlType(sqlTSt) + ","
			+ " fcl_cod1 " + SqlType("INTEGER4") + ","
			+ " fcl_cod2 " + SqlType("INTEGER4") + ","
			+ " fcl_cod3 " + SqlType("INTEGER4") + ","
			+ " fsum1 "+SqlType("MONEY")+","
			+ " fsum2 "+SqlType("MONEY")+","
//			+ " fsum3 "+SqlType("MONEY")+","
//			+ " fsum4 "+SqlType("MONEY")+","
			+ " fsum5 "+SqlType("MONEY")+","
			+ " fsum6 "+SqlType("MONEY")+","
			+ " fval "+SqlType("SHORT")+","
			+ " fvkurs "+SqlType("SINGLE")+","
			+ " fdate "+SqlType("DATE") +")"
		);
	// Таблица TMP_OBLNS2
	// Сюда переносятся суммы из TMP_OBLNS1 переведенные в нац. валюту
	DropTable(outTbl + "_2");
	ExecuteSQL(
		"CREATE TABLE " + outTbl + "_2 ("
			+ " fsc " + SqlType(sqlTSc) + ","
			+ " fsu " + SqlType(sqlTSu) + ","
			+ " fst " + SqlType(sqlTSt) + ","
			+ " fcl_cod1 " + SqlType("INTEGER4") + ","
			+ " fcl_cod2 " + SqlType("INTEGER4") + ","
			+ " fcl_cod3 " + SqlType("INTEGER4") + ","
			+ " fsum1 "+SqlType("MONEY")+","
			+ " fsum2 "+SqlType("MONEY")+","
//			+ " fsum3 "+SqlType("MONEY")+","
//			+ " fsum4 "+SqlType("MONEY")+","
			+ " fsum5 "+SqlType("MONEY")+","
			+ " fsum6 "+SqlType("MONEY")+","
			+ " fkurs "+SqlType("FLOAT")+")"
		);
	var cKurs = IIF("s.fvkurs<>0", "s.fvkurs", IIF("k.fkurs IS NULL", "1"," k.fkurs"));

	// Выборка начальных остатков
	ExecuteSQL(
		"INSERT INTO " + outTbl + "_1 (fsc, fsu, fst, fcl_cod1, fcl_cod2, fcl_cod3,"
			+"fsum1, fsum2, fsum5, fsum6, fdate, fval, fvkurs)"
		+ " SELECT"
			+ " fsc, fsu, fst, fcl_cod1, fcl_cod2, fcl_cod3,"
			+ sqlRound(Convert(cKurs + "*fsumd","MONEY"), prmDecSum) + " AS fsum1,"
			+ sqlRound(Convert(cKurs + "*fsumk","MONEY"), prmDecSum) + " AS fsum2,"
			+ Convert("0","MONEY")+" as fsum5,"
			+ Convert("0","MONEY")+" as fsum6,"
			+ " fdate, 0 AS fval, "+Convert("0","MONEY")+" AS fvkurs"
		+ " FROM ^schet_sl" + " s"
			+ " LEFT JOIN ^kursval k" 
				+ " ON s.fval = k.fkod"
					+ " AND (s.fdate BETWEEN k.fbdat AND k.fedat)"
		+ " WHERE " + sldCond
			+ " and fdate<=" + sqlDat1
			+ " and (fsumd<>0 or fsumk<>0)"
			+ " and fistotal="+sqlFalse
			+ orgCond
		);
	//setProgressPos(1);
	
	trace("sldCond" + typeOf(sldCond));
	// Выборка дебетовых проводок
	ExecuteSQL(
		"INSERT INTO " + outTbl + "_1 (fsc, fsu, fst,fcl_cod1,fcl_cod2,fcl_cod3,fsum1,fsum5,"
			+"fsum2, fsum6, fdate, fval, fvkurs)"
		+ " SELECT"
			+ " fdb_sc as fsc,"
			+ " fdb_su as fsu,"
			+ " fdb_st as fst,"
			+ " fdb_cod1 as fcl_cod1,"
			+ " fdb_cod2 as fcl_cod2,"
			+ " fdb_cod3 as fcl_cod3,"
			+ " sum("
				+ sqlRound(IIF("fdate<" + sqlDat1,Convert(cKurs + "*fsum","MONEY"),"0"), prmDecSum)
				+ ") AS fsum1,"
			+ " sum("
				+ sqlRound(IIF("fdate<" + sqlDat1,"0",Convert(cKurs + "*fsum","MONEY")), prmDecSum)
				+ ") as fsum5,"
			+ Convert("0","MONEY")+" as fsum2, "+Convert("0","MONEY")+" as fsum6,"
			+ " fdate,"
			+ " 0 AS fval, "+Convert("0","MONEY")+" AS fvkurs"
		+ " FROM " + schet + " s"
			+ " LEFT JOIN ^kursval k" 
				+ " ON s.fval = k.fkod"
					+ " AND (s.fdate BETWEEN k.fbdat AND k.fedat)"
		+ " WHERE " + sldCond.replace(/fsc/g,"fdb_sc")
			+ " and fdate<=" + sqlDat2
			+ " and fwrk<>16"
			+ orgCond
		+ " GROUP BY fdb_sc, fdb_su, fdb_st, fdb_cod1, fdb_cod2, fdb_cod3, "
			+ " fdate" // + ", fval, fvkurs"
		);
	//setProgressPos(2);
	
	// Выборка кредитовых проводок
	ExecuteSQL(
		"INSERT INTO " + outTbl + "_1 (fsc, fsu, fst,fcl_cod1,fcl_cod2,fcl_cod3,fsum2,fsum6,fsum1, fsum5,fdate,fval,fvkurs)"
		+ " SELECT"
			+ " fcr_sc as fsc,"
			+ " fcr_su as fsu,"
			+ " fcr_st as fst,"
			+ " fcr_cod1 as fcl_cod1,"
			+ " fcr_cod2 as fcl_cod2,"
			+ " fcr_cod3 as fcl_cod3,"
			+ " sum("
				+ sqlRound(IIF("fdate<" + sqlDat1 ,Convert(cKurs + "*fsum","MONEY"),"0"), prmDecSum)
				+ ") AS fsum2,"
			+ " sum("
				+ sqlRound(IIF("fdate<" + sqlDat1 ,"0",Convert(cKurs + "*fsum","MONEY")), prmDecSum)
				+ ") as fsum6,"
			+ Convert("0","MONEY")+" as fsum1, "+Convert("0","MONEY")+" as fsum5,"
			+ " fdate,"
			+ " 0 AS fval, "+Convert("0","MONEY")+" AS fvkurs"
		+ " FROM " + schet + " s"
			+ " LEFT JOIN ^kursval k" 
				+ " ON s.fval = k.fkod"
					+ " AND (s.fdate BETWEEN k.fbdat AND k.fedat)"
		+ " WHERE " + sldCond.replace(/fsc/g,"fcr_sc")
			+ " and fdate<=" + sqlDat2
			+ " and fwrk<>16"
			+ orgCond
		+ " GROUP BY fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3,"
			+ " fdate" // + " , fval, fvkurs"
		);
	if(op_zakr(dat1, dat2))	// Закрывающие проводки
	{
		// Выборка дебетовых проводок
		ExecuteSQL(
			"INSERT INTO " + outTbl + "_1 (fsc, fsu, fst,fcl_cod1,fcl_cod2,fcl_cod3,fsum1,fsum5,fsum2, fsum6,fdate,fval,fvkurs)"
			+ " SELECT"
				+ " fdb_sc as fsc,"
				+ " fdb_su as fsu,"
				+ " fdb_st as fst,"
				+ " fdb_cod1 as fcl_cod1,"
				+ " fdb_cod2 as fcl_cod2,"
				+ " fdb_cod3 as fcl_cod3,"
				+ " sum("
					+ sqlRound(IIF("fdate<" + sqlDat1 ,Convert(cKurs + "*fsum","MONEY"),"0"), prmDecSum)
					+ ") AS fsum1,"
				+ " sum("
					+ sqlRound(IIF("fdate<" + sqlDat1 ,"0",Convert(cKurs + "*fsum","MONEY")), prmDecSum)
					+ ") as fsum5,"
				+ Convert("0","MONEY")+" as fsum2, "+Convert("0","MONEY")+" as fsum6,"
				+ " fdate,"
				+ " 0 AS fval, "+Convert("0","MONEY")+" AS fvkurs"
			+ " FROM " + schet_zr + " s"
				+ " LEFT JOIN ^kursval k" 
					+ " ON s.fval = k.fkod"
						+ " AND (s.fdate BETWEEN k.fbdat AND k.fedat)"
			+ " WHERE " + sldCond.replace(/fsc/g,"fdb_sc")
				+ " and fdate<=" + sqlDat2
				+ " and fwrk<>16"
				+ orgCond
			+ " GROUP BY fdb_sc, fdb_su, fdb_st, fdb_cod1, fdb_cod2, fdb_cod3,"
				+ " fdate"
			);
		// Выборка кредитовых проводок
		ExecuteSQL(
			"INSERT INTO " + outTbl + "_1 (fsc, fsu, fst,fcl_cod1,fcl_cod2,fcl_cod3,fsum2,fsum6,fsum1, fsum5,fdate,fval,fvkurs)"
			+ " SELECT"
				+ " fcr_sc as fsc,"
				+ " fcr_su as fsu,"
				+ " fcr_st as fst,"
				+ " fcr_cod1 as fcl_cod1,"
				+ " fcr_cod2 as fcl_cod2,"
				+ " fcr_cod3 as fcl_cod3,"
				+ " sum("
					+ sqlRound(IIF("fdate<" + sqlDat1 ,Convert(cKurs + "*fsum","MONEY"),"0"), prmDecSum)
					+ ") AS fsum2,"
				+ " sum("
					+ sqlRound(IIF("fdate<" + sqlDat1 ,"0",Convert(cKurs + "*fsum","MONEY")), prmDecSum)
					+ ") as fsum6,"
				+ Convert("0","MONEY")+" as fsum1, "+Convert("0","MONEY")+" as fsum5,"
				+ " fdate,"
				+ " 0 AS fval, "+Convert("0","MONEY")+" AS fvkurs"
			+ " FROM " + schet_zr + " s"
				+ " LEFT JOIN ^kursval k" 
					+ " ON s.fval = k.fkod"
						+ " AND (s.fdate BETWEEN k.fbdat AND k.fedat)"
			+ " WHERE " + sldCond.replace(/fsc/g,"fcr_sc")
				+ " and fdate<=" + sqlDat2
				+ " and fwrk<>16"
				+ orgCond
			+ " GROUP BY fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3,"
				+ " fdate"
			);
	}

	//setProgressPos(3);
	
	// Подбиваем итоговых сумм по счету-субсчету-статье-первой аналитке
	DropTable(outTbl + "_3_t");
	DropTable(outTbl + "_3");
	
	//21.07.2003 AL: Так как MS SQL не позвлоляет использовать псевдонимы полей в выражениях 
	//(fsum1+fsum5) as fsum3 было заменено на sum(t.fsum1+t.fsum5) as fsum3. Аналогично fsum4
	ExecuteSQL(
//vlad 16.10.08 свернем и на 3-й аналитике тоже
/*
		//vlad 02.06.2010
		//"SELECT fsc, fsu, fst, fcl_cod1, " + (is3Cl? "fcl_cod2, fcl_cod3, ": "0 AS fcl_cod2, 0 AS fcl_cod3,")
		"SELECT fsc, fsu, fst, fcl_cod1, fcl_cod2, fcl_cod3, "
			+ " sum(t.fsum1) as fsum1,"
			+ " sum(t.fsum2) as fsum2,"
			+ " sum(t.fsum1+t.fsum5) as fsum3,"
			+ " sum(t.fsum2+t.fsum6) as fsum4,"
			+ " sum(t.fsum5) as fsum5,"
			+ " sum(t.fsum6) as fsum6,"
			+ emptySt+" as fzero"
		+ " INTO " + outTbl + "_3"
		+ " FROM " + outTbl + "_1 t"
		//vlad 02.06.2010
		//+ " GROUP BY fsc, fsu, fst, fcl_cod1" + (is3Cl? ", fcl_cod2, fcl_cod3": "") 
		+ " GROUP BY fsc, fsu, fst, fcl_cod1, fcl_cod2, fcl_cod3"
		);
*/
		"SELECT fsc, fsu, fst, fcl_cod1, fcl_cod2, fcl_cod3, "
			+ " sum(t.fsum1) as fsum1,"
			+ " sum(t.fsum2) as fsum2,"
			+ " sum(t.fsum1+t.fsum5) as fsum3,"
			+ " sum(t.fsum2+t.fsum6) as fsum4,"
			+ " sum(t.fsum5) as fsum5,"
			+ " sum(t.fsum6) as fsum6,"
			+ emptySt+" as fzero"
		+ " INTO " + outTbl + "_3_t"
		+ " FROM " + outTbl + "_1 t"
		+ " GROUP BY fsc, fsu, fst, fcl_cod1, fcl_cod2, fcl_cod3"
		);
//browse("select * from " + outTbl + "_3_t where FSU=685 AND fcl_cod1=759" )
	ExecuteSQL(
		"SELECT fsc, fsu, fst, fcl_cod1, "
			//vvs 02.03.2004
			+ " fcl_cod2, "
			+ " fcl_cod3, "
			+ turnExpr_oblns("t.fsum1", "t.fsum2", "cl_schet.fvid", 3)+","
			+ turnExpr_oblns("t.fsum3", "t.fsum4", "cl_schet.fvid", 3)+","
			+ " SUM(t.fsum5) AS fsum5,"
			+ " SUM(t.fsum6) AS fsum6,"
			+ " t.fzero"
		+ " INTO " + outTbl + "_3"
		+ " FROM " + outTbl + "_3_t t"
			+ " LEFT JOIN " + cl_schet + " as cl_schet"
			+ " ON t.fsc=cl_schet.fschet"
				+ " AND t.fsu=cl_schet.fsubschet"
				//vlad 16.10.08 Обязательно надо вязать и по статье тоже, иначе не видит привязанных аналитик
				//+ " AND t.fzero=cl_schet.fstat"     // В плане счетов может не быть статьи
				+ " AND t.fST=cl_schet.fstat"
		+ " GROUP BY fsc, fsu, fst, fcl_cod1"
		//vvs 29.02.2004
		+" , fcl_cod2, fcl_cod3,"
			+ " cl_schet.fvid,"
			+ " t.fzero"
			+clScGrpFlds
		);
//browse("select * from " + outTbl + "_3 where FSU=607" )
	
// Сворачивание сумм в зависимости от вида счета
	if(isClGroup)
		var outTblA1 = outTbl;
	else if(cRazr=="u" || cRazr=="t")
		var outTblA1 = outTbl + "_A1";
	else
		var outTblA1 = outTbl

    ////////////////////////////////////////////////////////////
    //vvs 29.02.2004
    // теперь будем сворачивать сальдо начиная с 3-й аналитики
    // делаем по образу и подобию trnnbln.js
	// Свернем на 2-й аналитике
	DropTable(outTbl+"_A2");
	ExecuteSQL(
		"SELECT "
			+ Convert("t.fsc/10","BYTE")+" as fclass"
			+ ", t.fsc, t.fsu, t.fst, t.fcl_cod1"
			+ ", t.fcl_cod2"
			+ ", 0 as fcl_cod3, "
			+ turnExpr_oblns("t.fsum1", "t.fsum2", "cl_schet.fvid", 2)+","
			+ turnExpr_oblns("t.fsum3", "t.fsum4", "cl_schet.fvid", 2)+","
			+ " SUM(t.fsum5) AS fsum5, SUM(t.fsum6) AS fsum6,"
			+  sqlFalse+" as fistotal,"
			+ " 0 as fttlevel,"
			+ " cl_schet.fvid as fvid,"
			+ " t.fzero"
		+ " INTO " + outTbl+"_A2"
		+ " FROM " + outTbl + "_3 t"
			+ " LEFT JOIN " + cl_schet + " as cl_schet"
			+ " ON t.fsc=cl_schet.fschet"
				+ " AND t.fsu=cl_schet.fsubschet"
				//vlad 16.10.08 Обязательно надо вязать и по статье тоже, иначе не видит привязанных аналитик
				//+ " AND t.fzero=cl_schet.fstat"     // В плане счетов может не быть статьи
				+ " AND t.fst=cl_schet.fstat"    // В плане счетов может не быть статьи
		+" GROUP BY "
			+ Convert("t.fsc/10","BYTE")+", "
			+ " t.fsc, t.fsu, t.fst, t.fcl_cod1, "
			+ " t.fcl_cod2, "
			+ " cl_schet.fvid,"
			+ " t.fzero"
			+clScGrpFlds
		);
//browse("select * from " + outTbl + "_A2 where FSU=685 AND fcl_cod1=767" )
    
	// свернем на 1-й аналитике
	DropTable(outTblA1);
		ExecuteSQL(
		"SELECT "
			+ Convert("fsc/10","BYTE")+" as fclass, "
			+ "fsc, fsu, fst, fcl_cod1, "
			+ " 0 as fcl_cod2, "
			+ " 0 as fcl_cod3, "
			+ turnExpr_oblns("t.fsum1", "t.fsum2", "cl_schet.fvid", 1)+","
			+ turnExpr_oblns("t.fsum3", "t.fsum4", "cl_schet.fvid", 1)+","
			+ " SUM(t.fsum5) as fsum5, SUM(t.fsum6) as fsum6,"
			+  sqlFalse+" as fistotal,"
			+ " 0 as fttlevel,"
			+ " cl_schet.fvid as fvid"
		+ " INTO " + outTblA1
		+ " FROM " + outTbl + "_A2 t"
			+ " LEFT JOIN " + cl_schet + " as cl_schet"
			+ " ON t.fsc=cl_schet.fschet"
				+ " AND t.fsu=cl_schet.fsubschet"
				//vlad 16.10.08 Обязательно надо вязать и по статье тоже, иначе не видит привязанных аналитик
				//+ " AND t.fzero=cl_schet.fstat"     // В плане счетов может не быть статьи
				+ " AND t.fst=cl_schet.fstat"     // В плане счетов может не быть статьи
		+" GROUP BY "
			+ Convert("fsc/10","BYTE")+", "
			+ " fsc, fsu, fst, fcl_cod1, "
			+ " cl_schet.fvid"
			+clScGrpFlds
		);

/*	
	DropTable(outTblA1);
	ExecuteSQL(
		"SELECT "
			+ Convert("fsc/10","BYTE")+" as fclass, "
			+ "fsc, fsu, fst, fcl_cod1, fcl_cod2, fcl_cod3, "
			+ turnDbExpr("t.fsum1", "t.fsum2", "fvid") + " as fsum1,"
			+ turnCrExpr("t.fsum1", "t.fsum2", "fvid") + " as fsum2,"
			+ turnDbExpr("t.fsum3", "t.fsum4", "fvid") + " as fsum3,"
			+ turnCrExpr("t.fsum3", "t.fsum4", "fvid") + " as fsum4,"
			+ " fsum5, fsum6,"
			+  sqlFalse+" as fistotal,"
			+ " 0 as fttlevel,"
			+ " cl_schet.fvid as fvid"
		+ " INTO " + outTblA1
		+ " FROM " + outTbl + "_3 t"
			+ " LEFT JOIN " + cl_schet + " cl_schet"
			+ " ON t.fsc=cl_schet.fschet"
				+ " AND t.fsu=cl_schet.fsubschet"
				+ " AND t.fzero=cl_schet.fstat"     // В плане счетов может не быть статьи
		);
*/		
	
	if(isClGroup || is3Cl)
	{
		makeItog(mode, outTbl + "_SU", outTbl, 4);
		makeItog(mode, outTbl + "_SC", outTbl + "_SU", 3);
		//makeItog(mode, outTbl + "_CLS", outTbl + "_SC", 2);
		//makeItog(mode, outTbl + "_TT", outTbl + "_SC", 1);
	
		insertItog(outTbl, outTbl + "_SU");
		insertItog(outTbl, outTbl + "_SC");
		//insertItog(outTbl, outTbl + "_CLS");
		//insertItog(outTbl, outTbl + "_TT");
	}
	else if(cRazr=="u")
	{
		makeItog(mode, outTbl, outTblA1, 4);
		makeItog(mode, outTbl + "_SC", outTbl, 3);
		//makeItog(mode, outTbl + "_CLS", outTbl + "_SC", 2);
		//makeItog(mode, outTbl + "_TT", outTbl + "_SC", 1);
		insertItog(outTbl, outTbl + "_SC");
		//insertItog(outTbl, outTbl + "_CLS");
		//insertItog(outTbl, outTbl + "_TT");
	}
	else if(cRazr=="t")
	{
		makeItog(mode, outTbl, outTblA1, 5);
		makeItog(mode, outTbl + "_SU", outTbl, 4);
		makeItog(mode, outTbl + "_SC", outTbl, 3);
		//makeItog(mode, outTbl + "_CLS", outTbl + "_SC", 2);
		//makeItog(mode, outTbl + "_TT", outTbl + "_SC", 1);
		insertItog(outTbl, outTbl + "_SU");
		insertItog(outTbl, outTbl + "_SC");
		//insertItog(outTbl, outTbl + "_CLS");
		//insertItog(outTbl, outTbl + "_TT");
	}
	else
	{

		makeItog(mode, outTbl + "_ST", outTbl, 5);
		makeItog(mode, outTbl + "_SU", outTbl + "_ST", 4);
		makeItog(mode, outTbl + "_SC", outTbl + "_SU", 3);
		//makeItog(mode, outTbl + "_CLS", outTbl + "_SC", 2);
		//makeItog(mode, outTbl + "_TT", outTbl + "_SC", 1);
		insertItog(outTbl, outTbl + "_ST");
		insertItog(outTbl, outTbl + "_SU");
		insertItog(outTbl, outTbl + "_SC");
		//insertItog(outTbl, outTbl + "_CLS");
		//insertItog(outTbl, outTbl + "_TT");
	}
	
	// Подбивка итога по классу (в таблицу tmp_oblns_cls)
	DropTable(outTbl + "_CLS");
	ExecuteSQL(
		"SELECT fclass,"
			+ emptySc+" as fsc,"			
			+ emptySu+" as fsu,"
			+ emptySt+" as fst,"
			+ " 0 AS fcl_cod1, 0 AS fcl_cod2, 0 AS fcl_cod3,"
			+ " sum(t.fsum1) as fsum1,"
			+ " sum(t.fsum2) as fsum2,"
			+ " sum(t.fsum3) as fsum3,"
			+ " sum(t.fsum4) as fsum4,"
			+ " sum(t.fsum5) as fsum5,"
			+ " sum(t.fsum6) as fsum6,"
			+ sqlTrue+" as fistotal,"
			+ " 2 as fttlevel"
		+ " INTO " + outTbl + "_CLS"
		+ " FROM " + outTbl + "_SC t"
		+ " GROUP BY  fclass"
		);
	
	
	
	insertItog(outTbl, outTbl + "_CLS");
	
	
	var parZabalB = getPar("ZABALB"),
		parZabalE = getPar("ZABALE");
		parZabalB = parZabalB,
		parZabalE = parZabalE,	
		parNZabalB = getPar("NZABALB"),
		parNZabalE = getPar("NZABALE");
		parNZabalB = parNZabalB,
		parNZabalE = parNZabalE;	
	// Подбивка итога всего
	ExecuteSQL(
		"INSERT INTO " + outTbl +" (FCLASS, FSC, FSU, FST, fcl_cod1, fcl_cod2, fcl_cod3, FSUM1,FSUM2,FSUM3,FSUM4,FSUM5,FSUM6, FISTOTAL, FTTLEVEL) "
		+ " SELECT"
			+ " " + (strIn("_", mode)? 99 : 0) + " as fclass,"
			+ emptySc+" as fsc,"
			+ emptySu+" as fsu,"
			+ emptySt+" as fst,"
			+ clField + ","
			+ " sum(t.fsum1) as fsum1,"
			+ " sum(t.fsum2) as fsum2,"
			+ " sum(t.fsum3) as fsum3,"
			+ " sum(t.fsum4) as fsum4,"
			+ " sum(t.fsum5) as fsum5,"
			+ " sum(t.fsum6) as fsum6,"
			+ sqlTrue+" as fistotal,"
			+ " 1 as fttlevel"
		+ " FROM " + outTbl + "_SC t"
		/*
		+" WHERE (t.fsc<"+sqlTo(parNZabalB)
			+") or (t.fsc>"+sqlTo(parNZabalE)+" and t.fsc<"+sqlTo(parZabalB)
			+") or (t.fsc>"+sqlTo(parZabalE)+")"
		*/
		+ " WHERE NOT t.fsc BETWEEN " + sqlTo(parZabalB) + " AND " + sqlTo(parZabalE)
			+ " AND NOT t.fsc BETWEEN " + sqlTo(parNZabalB) + " AND " + sqlTo(parNZabalE)
		+ (is3Cl? " GROUP BY fcl_cod1, fcl_cod2, fcl_cod3": isClGroup? " GROUP BY fcl_cod1": "")
		);



	//setProgressPos(4);

if(false)
{
	if(isItog && cRazr!="u" && !isClGroup)
	{
		outTblSt = outTbl + "_ST";
		makeItog(mode, outTblA1, outTblSt, 5);
	}
	
	if(isItog || strIn("u", mode))
	{
		// Подбивка итогов по счету-субсчету (в таблицу tmp_oblns_su)
		DropTable(outTblSu);
		ExecuteSQL(
			"SELECT t.fclass, fsc, fsu, fst,"
				+ " 0 as fcl_cod,"
				+ clField + ","
				+ turnTot("sum(t.fsum1)", "sum(t.fsum2)", "fvid") + " as fsum1,"
				+ turnTot("sum(t.fsum2)", "sum(t.fsum1)", "fvid") + " as fsum2,"
				+ turnTot("sum(t.fsum3)", "sum(t.fsum4)", "fvid") + " as fsum3,"
				+ turnTot("sum(t.fsum4)", "sum(t.fsum3)", "fvid") + " as fsum4,"
				+ " sum(t.fsum5) as fsum5,"
				+ " sum(t.fsum6) as fsum6, "
				+ First("t.fvid") + " as fvid,"
				+ " (max(t.fst)+max(t.fcl_cod1))>0 as fistotal,"
				+ " 4 as fttlevel"
			+ " INTO " + outTblSu
			+ " FROM " + outTblSt + " t"
			+ " GROUP BY " + preGroup + " fclass, fsc, fsu"
			);
	}

	if(isItog)
	{
		// Если выходная таблица не совпадает с таблицей с
		// итогами по статьям, то перенесем их в выходную 
		// таблицу. Т.к. из выходной таблицы больше выборок
		// не будет, то такой ход ни на что не повлияет.
		if(outTbl!=outTblSu)
		{
			switch(outTbl)
			{
			case outTblA1:
				ExecuteSQL(
					"INSERT INTO " + outTbl
					+ " SELECT * "
					+ " FROM " + outTblSt
					+ " WHERE fistotal="+sqlTrue 
					);
			case outTblSt:
				ExecuteSQL(
					"INSERT INTO " + outTbl
					+ " SELECT * "
					+ " FROM " + outTblSt
					+ " WHERE fistotal="+sqlTrue
					);
				break;
			case outTblA1:
				ExecuteSQL(
					"INSERT INTO " + outTbl
					+ " SELECT * "
					+ " FROM " + outTblSu
					+ " WHERE fistotal="+sqlTrue
					);
			}
			ExecuteSQL(
				"INSERT INTO " + outTbl
				+ " SELECT * "
				+ " FROM " + outTblSu
				+ " WHERE fistotal="+sqlTrue
				);
		}
		// Подбивка итога по счету (в таблицу tmp_oblns_sc)
		DropTable(outTbl + "_SC");
		ExecuteSQL(
			"SELECT fclass, fsc,"
				+ emptySu+" as fsu,"
				+ emptySt+" as fst,"
				+ clField + ","
				+ turnTot("sum(t.fsum1)", "sum(t.fsum2)", "fvid") + " as fsum1,"
				+ turnTot("sum(t.fsum2)", "sum(t.fsum1)", "fvid") + " as fsum2,"
				+ turnTot("sum(t.fsum3)", "sum(t.fsum4)", "fvid") + " as fsum3,"
				+ turnTot("sum(t.fsum4)", "sum(t.fsum3)", "fvid") + " as fsum4,"
				+ " sum(t.fsum5) as fsum5,"
				+ " sum(t.fsum6) as fsum6, "
				+ First("t.fvid") + " as fvid,"
				+ " (max(t.fsu)+max(t.fst)+max(t.fcl_cod1))>0 as fistotal,"
				+ " 3 as fttlevel"
			+ " INTO " + outTbl + "_SC"
			+ " FROM " + outTblSu + " t"
			+ " GROUP BY " + preGroup + " fclass, fsc"
			);
		ExecuteSQL(
			"INSERT INTO " + outTbl
			+ " SELECT * "
			+ " FROM " + outTbl + "_SC"
			+ " WHERE fistotal="+sqlTrue
			);

		// Подбивка итога по классу (в таблицу tmp_oblns_cls)
		DropTable(outTbl + "_CLS");
		ExecuteSQL(
			"SELECT fclass,"
				+ emptySc+" as fsc,"			
				+ emptySu+" as fsu,"
				+ emptySt+" as fst,"
				+ clField + ","
				+ turnTot("sum(t.fsum1)", "sum(t.fsum2)", "fvid") + " as fsum1,"
				+ turnTot("sum(t.fsum2)", "sum(t.fsum1)", "fvid") + " as fsum2,"
				+ turnTot("sum(t.fsum3)", "sum(t.fsum4)", "fvid") + " as fsum3,"
				+ turnTot("sum(t.fsum4)", "sum(t.fsum3)", "fvid") + " as fsum4,"
				+ " sum(t.fsum5) as fsum5,"
				+ " sum(t.fsum6) as fsum6, "
				+ First("t.fvid") + " as fvid,"
				+ " max(t.fsc)>0 as fistotal,"
				+ " 2 as fttlevel"
			+ " INTO " + outTbl + "_CLS"
			+ " FROM " + outTbl + "_SC t"
			+ " GROUP BY " + preGroup + " fclass"
			);

		ExecuteSQL(
			"INSERT INTO " + outTbl
			+ " SELECT * "
			+ " FROM " + outTbl + "_CLS"
			+ " WHERE fistotal="+sqlTrue
			);

		// Подбивка итога всего
		ExecuteSQL(
			"INSERT INTO " + outTbl
			+ " SELECT"
				+ " " + (strIn("_", mode)? 99 : 0) + " as fclass,"
				+ emptySc+" as fsc,"
				+ emptySu+" as fsu,"
				+ emptySt+" as fst,"
				+ clField + ","
				+ " sum(t.fsum1) as fsum1,"
				+ " sum(t.fsum2) as fsum2,"
				+ " sum(t.fsum3) as fsum3,"
				+ " sum(t.fsum4) as fsum4,"
				+ " sum(t.fsum5) as fsum5,"
				+ " sum(t.fsum6) as fsum6,"
				+ sqlTrue+" as fistotal,"
				+ " 1 as fttlevel"
			+ " FROM " + outTbl + "_SC t"
			/*
			+" WHERE (t.fsc<"+sqlTo(parNZabalB)
				+") or (t.fsc>"+sqlTo(parNZabalE)+" and t.fsc<"+sqlTo(parZabalB)
				+") or (t.fsc>"+sqlTo(parZabalE)+")"
			*/
			+ " WHERE NOT t.fsc BETWEEN " + sqlTo(parZabalB) + " AND " + sqlTo(parZabalE)
				+ " AND NOT t.fsc BETWEEN " + sqlTo(parNZabalB) + " AND " + sqlTo(parNZabalE)
			+ (isClGroup? " GROUP BY fcl_cod1": "")
			);
	}
}
	
	ExecuteSQL(s = 
		"DELETE FROM " + outTbl
		+" WHERE " + sqlRound("fsum1", prmDecSum) + "=0"
			+ " AND " + sqlRound("fsum2", prmDecSum) + "=0" 
			+ " AND " + sqlRound("fsum3", prmDecSum) + "=0" 
			+ " AND " + sqlRound("fsum4", prmDecSum) + "=0" 
			+ " AND " + sqlRound("fsum5", prmDecSum) + "=0" 
			+ " AND " + sqlRound("fsum6", prmDecSum) + "=0" 
			);


	// Индекс для вывода строк в порядке, естественном для пользовател
/*	ExecuteSQL(
		"ALTER TABLE " + outTbl
		+ " ADD CONSTRAINT oblns"
			+ " UNIQUE "
				+ (isClGroup
					? "(fclass, fsc, fsu, fst, fcl_cod1, fistotal, fttlevel)"
					: "(fcl_cod1, fclass, fsc, fsu, fst, fistotal, fttlevel)"
					)
		);
*/
// встречаются повторяющиеся значения.
// CONSTRAINT использовать нельзя - Oracle & MsSQL - ругаются. Вот.
	if (SUBD == ORACLE || SUBD == DERBY || SUBD == POSTGRE || SUBD == H2)
	{
		ExecuteSQL("DROP INDEX IND_SHOW",false);
	}
	ExecuteSQL(
				"CREATE INDEX IND_SHOW ON " + outTbl
				+ (isClGroup
					? "(fclass, fsc, fsu, fst, fcl_cod1, fistotal, fttlevel)"
					: "(fcl_cod1, fclass, fsc, fsu, fst, fistotal, fttlevel)"
					)
			   );
   ExecuteSQL(
		"ALTER TABLE " + outTbl
		+ " ADD fwid "+SqlType("COUNTER")
		);
	//setProgressPos(0);

}

function makeItog(cMode, cInto, cFrom, nLevel)
{
	var cFcl_cod1 = strIn("l", cMode)? "fcl_cod1": "0 as fcl_cod1";
	var cFields, cGroupBy, cFisTotal, cWhere = "";

	//vlad 26.03.2012
	//Для подвязки плана счетов на субсчете и счете (nLevel={3,4})
	var cFromEx = "";
	var cVid = First("t.fvid");
	switch(nLevel)
	{
	case 1:
		cFields = (strIn("_", cMode)? 99 : 0) + " as fclass"
			+ ", "+emptySc+" as fsc"
			+ ", "+emptySu+" as fsu"
			+ ", "+emptySt+" as fst"
			+ ", " + cFcl_cod1
		cGroupBy = "";
		var parZabalB = getPar("ZABALB"),
			parZabalE = getPar("ZABALE"),
			parZabalB = Number(parZabalB),
			parZabalE = Number(parZabalE),	
			parNZabalB = getPar("NZABALB"),
			parNZabalE = getPar("NZABALE"),
			parNZabalB = Number(parNZabalB),
			parNZabalE = Number(parNZabalE);	
		cWhere =
			" WHERE NOT t.fsc BETWEEN " + sqlTo(parZabalB)
				+ " AND " + sqlTo(parZabalE)
			+ " AND NOT t.fsc BETWEEN " + sqlTo(parNZabalB)
				+ " AND " + sqlTo(parNZabalE)
		cFisTotal = sqlTrue
		break;
	case 2:
		cFields = "fclass"
			+ ", "+emptySc+" as fsc"
			+ ", "+emptySu+" as fsu"
			+ ", "+emptySt+" as fst"
			+ ", " + cFcl_cod1
			+ ", 0 AS fcl_cod2, 0 AS fcl_cod3"
		cGroupBy = " GROUP BY fclass"
		cFisTotal = sqlTrue
		break;
	case 3:
		cFields = "t.fclass AS fclass, t.fsc AS fsc"
			+ ", "+emptySu+" as fsu"
			+ ", "+emptySt+" as fst"
			+ ", " + cFcl_cod1
			+ ", 0 AS fcl_cod2, 0 AS fcl_cod3"
		cGroupBy = " GROUP BY t.fclass, t.fsc, S.fvid"
		cFisTotal = "max(t.fsu)>0 or max(t.fst)>0 or max(t.fcl_cod1)>0"
		cFromEx = " INNER JOIN ^CL_SCHET S ON T.FSC=S.FSCHET"
		cWhere = " WHERE S.FSUBSCHET="+sqlTo(0)
			+" AND S.FSTAT="+sqlTo(0)
		cVid = "S.fvid";
		break;
	case 4:
		cFields = "t.fclass AS fclass, t.fsc AS fsc, t.fsu AS fsu"
			+ ", "+emptySt+" as fst"
			+ ", " + cFcl_cod1
			+ ", 0 AS fcl_cod2, 0 AS fcl_cod3"
		cGroupBy = " GROUP BY t.fclass, t.fsc, t.fsu, S.fvid"
		cFisTotal= "max(t.fst)>0 or max(t.fcl_cod1)>0"
		cFromEx = " INNER JOIN ^CL_SCHET S ON T.FSC=S.FSCHET AND T.FSU=S.FSUBSCHET"
		cWhere = " WHERE S.FSTAT="+sqlTo(0)
		cVid = "S.fvid";
		break;
	case 5:
		cFields = "t.fclass AS fclass, fsc, fsu, fst"
			+ ", 0 AS fcl_cod1, 0 AS fcl_cod2, 0 AS fcl_cod3"
		cGroupBy = " GROUP BY fclass, fsc, fsu, fst"
		cFisTotal = "max(t.fcl_cod1)>0"
		break;
	}
	
	cFisTotal = IIF(cFisTotal,sqlTrue,sqlFalse);
	
	if(strIn("l", cMode))
		cGroupBy = (cGroupBy? cGroupBy + ",": " GROUP BY ") + "fcl_cod1"
	DropTable(cInto);
	//vlad 26.03.2012
	//Бывают случаи, когда на счете(субсчете) надо получить свернутое сальдо в то время, 
	//как на субсчете(статье) - развернутое. Нам First("t.fvid") не подходит - надо 
	//вид брать непосредственно из плана счетов
	/*
	ExecuteSQL(
		"SELECT " 
			+ cFields + ","
			+ turnTot("sum(t.fsum1)", "sum(t.fsum2)",  First("t.fvid")) + " as fsum1,"
			+ turnTot("sum(t.fsum2)", "sum(t.fsum1)",  First("t.fvid")) + " as fsum2,"
			+ turnTot("sum(t.fsum3)", "sum(t.fsum4)",  First("t.fvid")) + " as fsum3,"
			+ turnTot("sum(t.fsum4)", "sum(t.fsum3)",  First("t.fvid")) + " as fsum4,"
			+ " sum(t.fsum5) as fsum5,"
			+ " sum(t.fsum6) as fsum6,"
			+ cFisTotal + " as fistotal,"
			+ nLevel + " as fttlevel, "
			+ First("t.fvid") + " as fvid"
			+ " INTO " + cInto
		+ " FROM " + cFrom + " t"
		+ cWhere
		+ cGroupBy
		);
	*/
	ExecuteSQL(
		"SELECT " 
			+ cFields + ","
			+ turnTot("sum(t.fsum1)", "sum(t.fsum2)",  cVid) + " as fsum1,"
			+ turnTot("sum(t.fsum2)", "sum(t.fsum1)",  cVid) + " as fsum2,"
			+ turnTot("sum(t.fsum3)", "sum(t.fsum4)",  cVid) + " as fsum3,"
			+ turnTot("sum(t.fsum4)", "sum(t.fsum3)",  cVid) + " as fsum4,"
			+ " sum(t.fsum5) as fsum5,"
			+ " sum(t.fsum6) as fsum6,"
			+ cFisTotal + " as fistotal,"
			+ nLevel + " as fttlevel, "
			+ cVid + " as fvid"
			+ " INTO " + cInto
		+ " FROM " + cFrom + " t "
			+cFromEx
		+ cWhere
		+ cGroupBy
		);
	
}

function insertItog(cInto, cFrom)
{
	ExecuteSQL(
		"INSERT INTO " + cInto+" "+getColumn(cFrom,true)
		+ " SELECT "+getColumn(cFrom)
		+ " FROM " + cFrom
		+ " WHERE fistotal="+sqlTrue
		);

}

// Выражение для сворачивания дебетовой суммы в не итоговых записях
function turnDbExpr(fdb, fcr, fvid)
{
	var s = IIF("fvid=\'+\' or ((fvid=\'%\' or fvid=\'*\') and fdb-fcr>0)", "fdb-fcr", "0");
	return sRepl(s, fdb, fcr, fvid);
}

// Выражение для сворачивания кредитовой суммы в не итоговых записях
function turnCrExpr(fdb, fcr, fvid)
{
	var s = IIF("fvid=\'-\' or ((fvid=\'%\' or fvid=\'*\') and fcr-fdb>0)", "fcr-fdb", "0");
	return sRepl(s, fdb, fcr, fvid);
}

function sRepl(s, fdb, fcr, fvid)
{
	s = s.replace(/fdb/g, fdb);
	s = s.replace(/fcr/g, fcr);
	s = s.replace(/fvid/g, fvid);
	return s;
}

// Выражение для сворачивания сумм в итоговых записях
function turnTot(f1, f2, fvid)
{
	// iif(fvid<>'*', f1, iif(f1>f2, f1-f2, 0))
	return IIF(fvid+"<>\'*\'",f1, IIF(f1+">"+f2,f1+"-"+f2,"0"));
}

var lastt;
function sayTime(txt)
{
	//alert(txt+":" + (new Date().getTime() - lastt)/1000 + " с.");
	lastt = new Date().getTime();
}


var clScGrpFlds = 
	", cl_schet.FTURNLEV"
	+",cl_schet.FCL1"
	+",cl_schet.FCL1_TYPE"
	+",cl_schet.FCL2"
	+",cl_schet.FCL2_TYPE"
	+",cl_schet.FCL3"
	+",cl_schet.FCL3_TYPE"



//vlad 01.03.2004
// по мотивам trnnbln.js
/*
   Возвращает выражения для сворачивания сумм
   Пример:
   turnExpr_oblns("fdb_sum", "fcr_sum", "fvid")
      вернет "fdb_sum = fdb_sum - fcr_sum, fcr_sum = 0"
   fdb, fcr, fvid - имена полей, содержащих соответственно,
   сальдо по Дт, сальдо по Кт, вид счета
*/
function turnExpr_oblns(fdb, fcr, fvid, nLevel){

	// Поле назначения по Дт (отбросим алиас)
	fdbDst = fdb;
	var mpos = fdbDst.indexOf(".");
	if(mpos!=-1){
		fdbDst = fdbDst.substr(mpos+1);
	}

	// Поле назначения по Кт (отбросим алиас)
	fcrDst = fcr;
	var mpos = fcrDst.indexOf(".");
	if(mpos!=-1){
		fcrDst = fcrDst.substr(mpos+1);
	}
	
	// Разница свернутая в дебетовую сторону
	var difDb = "SUM("+fdb + "-" + fcr+")";
	// Разница свернутая в кредитовую сторону
	var difCr = "SUM("+fcr + "-" + fdb+")";
	//vlad 16.10.2008
	//все равно неправильно сворачивает при 3-х уровнях аналитики
	//Дернул из trnnbln
	/*
	// Признак нижнего уровня аналитики
	// Ориентируемся на настройку в плане счетов
	// (поля FCL3, FCL2)
	var isLastAn = " cl_schet.FCL1='0' OR t.FCL_COD3 <> 0"
		+" OR t.FCL_COD2 <> 0 AND cl_schet.FCL3='0'"
		+" OR t.FCL_COD1 <> 0 AND cl_schet.FCL2='0'"
	*/
	// Признак нижнего уровня аналитики
	// Будем сворачивать, если в настройке 
	// плана счетов стоит "свернуть" на уровне "моем"
	// или более высоком
	var isLastAn;
	switch(nLevel)
	{
		case 3:
			var isLastAn = " NOT (cl_schet.FCL3='0' AND "+sqlStrIsEmp("cl_schet.FCL3_TYPE")+")"
			+" OR cl_schet.FTURNLEV IN("+sqlTo("A3")+", "+sqlTo("A2")+", "+sqlTo("A1")+")"
			break;
		case 2:
			var isLastAn = " cl_schet.FCL3='0' AND "+sqlStrIsEmp("cl_schet.FCL3_TYPE")
			+" AND NOT (cl_schet.FCL2='0' AND "+sqlStrIsEmp("cl_schet.FCL2_TYPE")+")"
			+" OR cl_schet.FTURNLEV IN("+sqlTo("A2")+", "+sqlTo("A1")+")"
			break;
		case 1:
			var isLastAn = " cl_schet.FCL2='0' AND "+sqlStrIsEmp("cl_schet.FCL2_TYPE")
			+" AND NOT (cl_schet.FCL1='0' AND "+sqlStrIsEmp("cl_schet.FCL1_TYPE")+")"
			+" OR cl_schet.FTURNLEV IN("+sqlTo("A1")+") OR "+sqlStrIsNull("cl_schet.FTURNLEV")
			//+" OR cl_schet.FTURNLEV IN("+sqlTo("A1")+")"
			break;
	}
	//vlad 26.01.2012
	//Если к счету никаких аналитик не привязано - то на любом уровне  - последняя
	//В противном случае на статьях без аналитик у активно-пассивного счета с разв. сальдо
	//- сальдо не сворачивает
	isLastAn = isLastAn + " OR cl_schet.FCL1='0' AND "+sqlStrIsEmp("cl_schet.FCL1_TYPE")
/*
	isLastAn =  " cl_schet.FCL1='0' AND "+sqlStrIsEmp("cl_schet.FCL1_TYPE")
       	+" OR t.FCL_COD3<>0 AND ("+sqlStrIsEmp("cl_schet.FTURNLEV")+" OR cl_schet.FTURNLEV IN("+sqlTo("A3")+", "+sqlTo("A2")+", "+sqlTo("A1")+"))"
       	+" OR t.FCL_COD2<>0 AND ("+sqlStrIsEmp("cl_schet.FTURNLEV")+" OR cl_schet.FTURNLEV IN("+sqlTo("A2")+", "+sqlTo("A1")+"))"
       	+" OR t.FCL_COD1<>0 AND ("+sqlStrIsEmp("cl_schet.FTURNLEV")+" OR cl_schet.FTURNLEV IN("+sqlTo("A1")+"))"
*/
	// Свернутое сальдо по Дт
	var turnDb = IIF(difDb + ">0", difDb, "0")
	// Свернутое сальдо по Кт
	var turnCr = IIF(difCr + ">0", difCr, "0")
	
	
	// Выражение для остатков по Дт
	sDbExpr = sqlSwitchEx(fvid,
		// Активный счет
		// Дебетовое сальдо
		"+", difDb,

		// Пассивный счет
		// Кредитовое сальдо
		"-", "0", 

		// Активно-пассивный счет
		// со свернутым сальдо
		"*", IIF(difDb + ">0", difDb, "0"),

		// Активно-пассивный счет с развернутым сальдо.
		// Сворачиваем на нижней аналитике и развернутое сальдо выше
		"%", IIF(isLastAn, turnDb, "SUM("+fdb+")"),

		// Неопределенный вид счета - ничего не делаем
		//fdb
		"0"
	)

	// Выражение для остатков по Кт
	sCrExpr = sqlSwitchEx(fvid,
		// Активный счет
		// Дебетовое сальдо
		"+", "0",

		// Пассивный счет
		// Кредитовое сальдо
		"-", difCr,

		// Активно-пассивный счет
		// со свернутым сальдо
		"*", IIF(difCr + ">0", difCr, "0"),

		// Активно-пассивный счет с развернутым сальдо.
		// Сворачиваем на нижней аналитике и развернутое сальдо выше
		"%", IIF(isLastAn, turnCr, "SUM("+fcr+")"),

		// Неопределенный вид счета - ничего не делаем
		//fcr
		"0"
	)
	
	//return "SUM("+sDbExpr+") as "+fdbDst+", SUM(" + sCrExpr+") as "+fcrDst;
	return "("+sDbExpr+") as "+fdbDst+", (" + sCrExpr+") as "+fcrDst;
}


//vlad 
//"старый" вариант ф-ции turnExpr_oblns
//После окончания периода "обкатки" - удалить
function SAVE___turnExpr_oblns___SAVE(fdb, fcr, fvid){

	// Поле назначения по Дт (отбросим алиас)
	fdbDst = fdb;
	var mpos = fdbDst.indexOf(".");
	if(mpos!=-1){
		fdbDst = fdbDst.substr(mpos+1);
	}

	// Поле назначения по Кт (отбросим алиас)
	fcrDst = fcr;
	var mpos = fcrDst.indexOf(".");
	if(mpos!=-1){
		fcrDst = fcrDst.substr(mpos+1);
	}
	
	// Разница свернутая в дебетовую сторону
	var difDb = fdb + "-" + fcr;
	// Разница свернутая в кредитовую сторону
	var difCr = fcr + "-" + fdb;
	//vlad 16.10.2008
	//все равно неправильно сворачивает при 3-х уровнях аналитики
	//Дернул из trnnbln
	/*
	// Признак нижнего уровня аналитики
	// Ориентируемся на настройку в плане счетов
	// (поля FCL3, FCL2)
	var isLastAn = " cl_schet.FCL1='0' OR t.FCL_COD3 <> 0"
		+" OR t.FCL_COD2 <> 0 AND cl_schet.FCL3='0'"
		+" OR t.FCL_COD1 <> 0 AND cl_schet.FCL2='0'"
	*/
	// Признак нижнего уровня аналитики
	// Будем сворачивать, если в настройке 
	// плана счетов стоит "свернуть" на уровне "моем"
	// или более высоком
	var isLastAn = 
         " cl_schet.FCL1='0' AND "+sqlStrIsEmp("cl_schet.FCL1_TYPE")
       	+" OR t.FCL_COD3<>0 AND ("+sqlStrIsEmp("cl_schet.FTURNLEV")+" OR cl_schet.FTURNLEV IN("+sqlTo("A3")+", "+sqlTo("A2")+", "+sqlTo("A1")+"))"
       	+" OR t.FCL_COD2<>0 AND ("+sqlStrIsEmp("cl_schet.FTURNLEV")+" OR cl_schet.FTURNLEV IN("+sqlTo("A2")+", "+sqlTo("A1")+"))"
       	+" OR t.FCL_COD1<>0 AND ("+sqlStrIsEmp("cl_schet.FTURNLEV")+" OR cl_schet.FTURNLEV IN("+sqlTo("A1")+"))"

	// Свернутое сальдо по Дт
	var turnDb = IIF(difDb + ">0", difDb, "0")
	// Свернутое сальдо по Кт
	var turnCr = IIF(difCr + ">0", difCr, "0")
	
	
	// Выражение для остатков по Дт
	sDbExpr = sqlSwitchEx(fvid,
		// Активный счет
		// Дебетовое сальдо
		"+", difDb,

		// Пассивный счет
		// Кредитовое сальдо
		"-", "0", 

		// Активно-пассивный счет
		// со свернутым сальдо
		"*", IIF(difDb + ">0", difDb, "0"),

		// Активно-пассивный счет с развернутым сальдо.
		// Сворачиваем на нижней аналитике и развернутое сальдо выше
		"%", IIF(isLastAn, turnDb, fdb),

		// Неопределенный вид счета - ничего не делаем
		//fdb
		"0"
	)

	// Выражение для остатков по Кт
	sCrExpr = sqlSwitchEx(fvid,
		// Активный счет
		// Дебетовое сальдо
		"+", "0",

		// Пассивный счет
		// Кредитовое сальдо
		"-", difCr,

		// Активно-пассивный счет
		// со свернутым сальдо
		"*", IIF(difCr + ">0", difCr, "0"),

		// Активно-пассивный счет с развернутым сальдо.
		// Сворачиваем на нижней аналитике и развернутое сальдо выше
		"%", IIF(isLastAn, turnCr, fcr),

		// Неопределенный вид счета - ничего не делаем
		//fcr
		"0"
	)
	
	return "SUM("+sDbExpr+") as "+fdbDst+", SUM(" + sCrExpr+") as "+fcrDst;
}