include ("Objects/DpXMLDomDocument.js");

var sClassID;
var obj;

var TYPE_TEXT = 1;
var TYPE_NUMBER = 2;
var TYPE_DATE = 3;
var TYPE_DOUBLE = 4;
var TYPE_BOOLEAN = 5;
var TYPE_DATETIME = 6;

var ctrlsMap = new Array();

function Load()
{
	if (!extPar || !extPar.sClassID)
		return false;
	sClassID = extPar.sClassID;
	ALL_BDATE.setValue(new Date().getVarDate());
	obj = lpProxy.createObject(sClassID);
	var sXmlPath = obj.getClassDescriptionDir() + "synchro/form.xml";
	var sScrPath = obj.getClassDescriptionDir() + "synchro/form.js";
	if (isFile(sXmlPath))
	{
		buildFromFile(sXmlPath,SELECT_PAR)
	}
	else
	{
		buildByDefault(SELECT_PAR);
	}
	
	ALL_FROMSRV.setValue(true);	
	ALL_CONFLICT.setValue("FROM");
		
	fillData();
	
	if (isFile(sScrPath))
		include(sScrPath);
	if (typeof(synchro_onLoad) == "function")
		this.synchro_Load = synchro_onLoad;

	if (typeof(synchro_onSave) == "function")
		this.synchro_Save = synchro_onSave;	
	
	if (this.synchro_Load)
		this.synchro_Load();
		
	setValid(ALL_SYNCMODE, mode_valid);
	var snap = getSnap("SELECT ftxt"
					+ " FROM ^cl_lnk WHERE fdoc=" + sqlTo(sClassID)
					+ (extPar.nFolder ? " AND fnop=" + sqlTo(Number(extPar.nFolder)) : "")
					+ " ORDER BY fdoc, fnop");
	var txt = sClassID;
	if (snap != null && snap[0] != null)
		txt = snap[0];		
	Caption(UR("Синхронізація: | Синхронизация: ") + txt);	
	mode_valid();
}

function mode_valid()
{
	var bEnable = ALL_SYNCMODE.getValue() == "AUTOSYNC";
	ALL_FROMSRV.setEnabled(bEnable);
	ALL_TOSRV.setEnabled(bEnable);
	ALL_CONFLICT.setEnabled(bEnable);
}

function buildFromFile(sPath,oComposite)
{
	var oDoc = openXmlFile(sPath);
	var root = oDoc.getDocumentElement();
	FORM.getDialogBuilder().buildCtrlArea(oComposite, root);
}

function buildByDefault(oComposite)
{
	var varsInfo = obj.getVarsInfo();
	var builder = FORM.getDialogBuilder();
	
	for (var nVar = 0; nVar < varsInfo.length; nVar++)
	{
		var curVar = varsInfo[nVar];
		if (curVar.isCalc == true
			||curVar.name == "HOP"
			||curVar.name == "HDOC"
			||curVar.name == "HID")
			continue;
		var varRec = new VarRecord();
		varRec.name = curVar.name;
		
		builder.addLabel(oComposite,curVar.name);
		varRec.sign = addSignCombo(oComposite);
		var sMask = "&&&&&&&&&&&&&&&&&";
		switch(Number(curVar.dataType))
		{
			
			case TYPE_BOOLEAN:
				varRec.ctrl = builder
					.addCheckBox(oComposite,"CHK_" + varRec.name,"");
				break;
			case TYPE_DATE:
				varRec.ctrl = builder
					.addDate(oComposite,"DAT_" + varRec.name,"");
				break;
			case TYPE_DOUBLE:
				sMask = "###########.#####";
			case TYPE_NUMBER:
				if (Number(curVar.dataType) != TYPE_DOUBLE)
					sMask = "###########"
			default:
				varRec.ctrl = builder
					.addTextField(oComposite,"TXT_" + varRec.name,"",100);
				varRec.ctrl.setMask(sMask);	
				break;
		}
		ctrlsMap[ctrlsMap.length] = varRec;
	}
}

var tmpID = 0;

function addSignCombo(oComposite)
{
	var vals = new Array("=",">","<","<>");
	return FORM.getDialogBuilder()
		.addComboBox(oComposite,vals,vals,"",20,"SGN" + tmpID++)
}

function VarRecord()
{
	this.name = "";
	this.ctrl = null;
	this.sign = "=";
}

function onSave()
{
	var selectPars = new Object();
	for (var nPar = 0; nPar < ctrlsMap.length; nPar++)
	{
		var oPar = ctrlsMap[nPar];
		var sSign = null;
		var sName = "";
		var oVal = null;
		if (typeof(oPar.sign) == "string")
			sSign = oPar.sign;
		else
			sSign = oPar.sign.getValue();
		oVal = oPar.ctrl.getValue();
		sName = oPar.name;
		if (oVal == null || oVal == "" || sSign == null)
			continue;
		
		if (isDateType(oVal) && isEmpty(oVal))
			continue;	
		
		selectPars[sName] = new Object();
		selectPars[sName].sign = sSign;
		selectPars[sName].value = oVal;
	}
	
	if (this.synchro_Save)
		this.synchro_Save(selectPars);	

	extPar.escape = false;
	extPar.selectPars = selectPars;
	extPar.bDate = javaDate2Script(ALL_BDATE.getValue());
	extPar.eDate = javaDate2Script(ALL_EDATE.getValue());
	extPar.eDate.setHours(23);
	extPar.eDate.setMinutes(59);
	
	extPar.syncmode = ALL_SYNCMODE.getValue();
	if (extPar.syncmode == "AUTOSYNC")
	{
		extPar.fromsrv = ALL_FROMSRV.getValue() == true;
		extPar.tosrv = ALL_TOSRV.getValue() == true;
		extPar.conflict = String(ALL_CONFLICT.getValue());
	}
}

function fillData()
{
	if (typeof extPar.bDate != "undefined")
		ALL_BDATE.setValue(extPar.bDate);
	if (typeof extPar.eDate != "undefined")
		ALL_EDATE.setValue(extPar.eDate);
	if (typeof extPar.syncmode != "undefined")
		ALL_SYNCMODE.setValue(extPar.syncmode);	
	if (typeof extPar.fromsrv != "undefined")
		ALL_FROMSRV.setValue(extPar.fromsrv == true);
	if (typeof extPar.tosrv != "undefined")
		ALL_TOSRV.setValue(extPar.tosrv == true);			
	if (typeof extPar.conflict != "undefined")
		ALL_CONFLICT.setValue(extPar.conflict);
	
	for (var i in extPar.selectPars)
	{
		var objName = String(i);
		var obj = FORM.getDialogBuilder().getControl(objName);		
		if (obj == null)
			continue;
		obj.setValue(extPar.selectPars[i].value);
		if (typeof extPar.selectPars[i].sign != "undefined")
		{
			obj = FORM.getDialogBuilder().getControl("CMB_" + objName);	
			if (obj != null)				
				obj.setValue(extPar.selectPars[i].sign);
		}		
	}
}