include("Objects/DpGetDat.js");
include("Objects/DpGrid.js");
include("servis/date.js");
include("sub/bil.js");

var label = "BILL_CHECK";
var tblOut = "TMP_BILL_CHECK";
var sBillTbl = getRegTblName();
var viddog = 0;
var sMode;

function listLoad()
{		
	sMode = GetMenuMode();
	if(!sMode && extPar)
		sMode = extPar.mode;
	if(sMode && sMode.indexOf("PHON")!=-1)
		viddog = 1;		

	this.printLabel = label;	
	
	if(sMode=="VIEW" && !IsTable(tblOut))
		return false;
}

function listTitle()
{
	var sTitle = UR("Перевірка нарахувань|Проверка начислений");
	if(extPar && extPar.title)
		sTitle += ": "+ extPar.title.toLowerCase();
	if(this.objAsk && this.objAsk.dat1 && this.objAsk.dat2)
	{
		var d1 = StrDat(new Date(this.objAsk.dat1), "DMY");
		var d2 = StrDat(new Date(this.objAsk.dat2), "DMY");
		if(d1 && d2)
			sTitle += " "+ d1 +" - "+ d2;
	}
	return sTitle;
}

function listAsk()
{
	if(sMode=="VIEW")
		return true;
	var gd = new DpGetDat(new Array("r", "n0"));	
	return gd;
}

function listSrc()
{
	this.qryAlias = "r";
	this.qrySet("Fields", " r.*"
			, "From", tblOut +" r "
				+" inner join ^CLRELCLCL rel on rel.FCOD=r.FCLIENT and rel.FCL="+ getPar("BILL_CL")
				+" inner join ^CL cl on cl.FWID=rel.FWID_CL"
			, "WhereArr", Array("FTT='FAIL'", "FTT='NULL'")
			, "WhereArrName", Array(UR("Зайві нарахування|Лишние начисления"), UR("Недонараховані|Недоначисленные"))			
			, "Order", new Array("r.FCLIENT,r.FID_DOG,r.FNMKL"
								,"cl.FTXTS,FID_DOG,FNMKL")
			, "OrderName", new Array("Сортувати за кодом|Сортировать по коду"
								,"Сортувати за назвою|Сортировать по названию"));
					
	this.clTie("cl", "="+ getPar("CODPLAT") +", FCLIENT", "clorg");	
	this.subTie("CL_NMK", "nmk", "FWID", "FNMKL");
	this.subTie("CONTRACT", "cnt", "FWID", "FID_DOG");
	this.subTie("BIL_PACK", "dog_row", "FID_DOG", "FID_DOG");
	this.subTie("CL_PACK", "pack", "FWID_CL", "FWID_CL");
	this.subTie("CL_SERV", "serv", "FWID_CL", "FWID_CL");
	this.subTie("CL_PHONE", "phone", "FWID_CL", "dog_row.FPHONE");
	if(extPar && extPar.where)
		this.qryWhere = extPar.where;
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	with(oGrid)
	{
		defCond("=^FTT=='NULL'", "NULL");	
		defCond("=^FTT=='FAIL'", "FAIL");
		color(9, "NULL");
		color(14, "FAIL");
	}
	with(oGrid.page())
	{	
		cell("FCLIENT", "Код", 5);
		cell("cl.FTXTS", "Назва|Название", 14);
		cell("=(^cnt.FDOG_NUM +': '+ ^cnt.FTXT)", "Угода|Договор", 10); 
		cell("phone.FPHONE", "Телефон|Телефон", 10);
		cell("dog_row.FSID", "Ідент.|Идент.", 10);
		cell("=(^pack.FTXT +'  '+ ^serv.FSIZE +'  '+ ^serv.FSPEED)", "Пакет|Пакет", 10);
		cell("nmk.FTXTS", "Послуга|Услуга", 10);
		cell("FDATE", "Дата нарахування|Дата начисления", 12);
		cell("FPAYDAT", "Дата виконання послуги|Дата оказания услуги", 15);
		cell("FEDATE", "Дата боргу|Дата долга", 12);
		cell("FSUM", "Нараховано|Начислено", 10, null, DP_FORMAT_SUM);		
	}	
	oGrid.build();
}

function listMake()
{
	if(sMode=="VIEW")
		return;
			
	var d1 = new Date(this.objAsk.dat1);		
	var d2 = new Date(this.objAsk.dat2);
	var nmk = Number(this.objAsk.fnmk);
	
	createTblOut(tblOut);
		
	var sMsg = UR("Виконується розрахунок...|Выполняется расчет...");
	WAIT(sMsg);
	
	var sFld = GetPatternIntersection("RBILL", "RBILL");
	sFld = sFld.toLowerCase().replace(",fordid", "");
	sFld = sFld.toLowerCase().replace("fordid,", "");
	var sSQL = "insert into "+ tblOut +"("+ sFld +") "
				+" select "+ sFld 
				+" from ^"+ sBillTbl
				+" where FDATE>="+ sqlTo(d1)
					+" and FDATE<="+ sqlTo(d2)
					+" and FDOC='BILL'"
					+sqlw0And("FNMKL=", nmk)
	ExecuteSQL(sSQL);
	ExecuteSQL("alter table "+ tblOut +" add column FTT "+ sqlType("TEXT"), false);
	
	WAIT(sMsg);
	ExecuteSQL("drop table TMP_BILL_CHECK_SUM", false)
	ExecuteSQL("select FCLIENT,FID_DOG,FWID_CL,FNMKL,FDATE,FPAYDAT,sum(FSUM) as FSUM "
				+" into TMP_BILL_CHECK_SUM "
				+" from "+ tblOut
				+" group by FCLIENT,FID_DOG,FWID_CL,FNMKL");
	sSQL = "update "+ tblOut +" c set c.FTT='FAIL' "
			+" where c.FSUM<>(select sum(b.FSUM) as FSUM "
				+" from TMP_BILL_CHECK_SUM b "
				+" where b.FCLIENT=c.FCLIENT "
					+" and b.FID_DOG=c.FID_DOG "
					+" and b.FWID_CL=c.FWID_CL "
					+" and b.FNMKL=c.FNMKL "
					//+" and b.FDATE=c.FDATE "
					//+" and b.FPAYDAT=c.FPAYDAT "
				+" group by b.FCLIENT,b.FID_DOG,b.FWID_CL,b.FNMKL)";
	ExecuteSQL(sSQL);
	
	WAIT(sMsg);
	var sCalcTbl = "TMP_BILL"
	//var date = goMonth(d1, 1);
	make_bill(sCalcTbl, d1, 0, 0, nmk, "1,2", 0, true);
	ExecuteSQL("update "+ sCalcTbl +" set FSUM=FCENA*FKOL where FLIMIT="+ sqlFalse);
	var sSQL = "insert into "+ tblOut +"("+ sFld +",FTT) "
				+" select "+ sFld +",'NULL'"
				+" from ^"+ sCalcTbl
				+" where FSUM>0 "
					+sqlw0And("FNMKL=", nmk)
	ExecuteSQL(sSQL);
	
	CLEARWAIT();
}

function createTblOut(sTblName)
{
	if(!ExecuteSQL("drop table "+ sTblName, false))
		ExecuteSQL("delete from "+ sTblName, false);	
	CreateTable(sTblName, sBillTbl, "*");
}

function listMenuInit(ds)
{
   	var t = ds.getTable();
    if(t.IsEmpty())
		return;
	var fid_doc = t.getValue("FID_DOC");
	var fid_dog = t.getValue("FID_DOG");
	if(fid_doc && IsDblClick())
		listMenuRun("FINDDOC");
    ds.AddMenuItem("FINDDOC", "Знайти документ|Найти документ", (!fid_doc || fid_doc==0));
    ds.AddMenuItem("FINDDOG", "Знайти договір|Найти договор", (!fid_dog || fid_dog==0));
    ds.AddMenuItem("");
}

function listMenuRun(ID)
{
	var t = grid.getTable();
	switch(ID)
	{
		case "FINDDOC":
			var m = new Object();
			m.doc = t.getValue("FDOC");
			m.nop = t.getValue("FNOP");
			m.dat = t.getValue("FDATE");
			m.org = t.getValue("FCLIENT");
			m.fid_doc = t.getValue("FID_DOC");			
			showWindow("l_docekz.xml", SW_NOMODAL, m);
			break;
		
		case "FINDDOG":
			var m = new Object();			
			m.doc = "BILDOG";
			m.nop = getPar("BILL_DOG");
			m.org = t.getValue("FCLIENT");
			m.fid_doc = t.getValue("FID_DOG");			
			showWindow("l_docekz.xml", SW_NOMODAL, m);
			break;
				
		default:
			break;
	}
}

include("sys/DpList.js");