include("Objects/DpGetDat.js");
include("Objects/DpGrid.js");
include("servis/date.js");
include("sub/bil.js");

var tblOut = "TMP_BILL_PV_LIST";

function listLoad()
{
	this.printLabel = "BILL";
}

function listSrc()
{
	this.qrySet("From", tblOut
				, "Order", "FDOC_DAT"
				);	
}

function listInitGetDatParam(par)
{
	if (extPar && extPar.org != null)
		par.forg = extPar.org;
	if (extPar && extPar.dog != null)
		par.fid_dog = extPar.dog;
}

function listTitle()
{
	var sTitle = UR("Реєстр перерахованих коштів|Реестр перечисленных средств");
	if(extPar && extPar.title)
		sTitle += ": "+ extPar.title.toLowerCase();
	if(this.objAsk && this.objAsk.dat1 && this.objAsk.dat2)
	{
		var d1 = StrDat(new Date(this.objAsk.dat1), "DMY");
		var d2 = StrDat(new Date(this.objAsk.dat2), "DMY");
		if(d1 && d2)
			sTitle += "  за "+ d1 +" - "+ d2;
	}
	return sTitle;
}

function listMake()
{
	var sTblFrom = "CRM_DOCS";
	/*
	var askForm = lpProxy.createAskForm(UR("Параметри розрахунку|Параметры расчета"));
	askForm.addObj("DATE1", "DATE", UR("Дата початку|Дата начала"), 0);
	askForm.addObj("DATE2", "DATE", UR("Дата кінця|Дата конца"), 0);	
	askForm.setValue("DATE1", firstDay(today));
	askForm.setValue("DATE2", lastDay(today));	
	if(!askForm.show())
		return false;
	var d1 = new Date(askForm.getValue("DATE1"));
	var d2 = new Date(askForm.getValue("DATE2"));
	*/	
	var gd = new DpGetDat(new Array("r"));	
	if (gd.escape) 
		return false;	
	var d1 = new Date(gd.dat1);	
	var d2 = new Date(gd.dat2);	
	var nOrg = 0;
	var dogID = 0;	
	
	this.objAsk = new Object();
	this.objAsk.dat1 = d1;
	this.objAsk.dat2 = d2;
		
	var sMsg = UR("Виконується розрахунок...|Выполняется расчет...");
	WAIT(sMsg);
			
	createTmpTbl(tblOut);
	
	var sBank = IIF("dog.FPRINT=1", sqlTo("ВТБ Банк"), sqlTo("ПроКредит Банк ЗАТ"));
	var sSFType = IIF("dog.FPRINT=1", sqlTo(UR("квитанція|квитанция")), sqlTo(UR("рахунок|счет")));
	var sCat = IIF("post.FCAT=1", sqlTo(UR("фіз.|физ.")), sqlTo(UR("юр.|юр.")));
	
	var sSQL = "insert into "+ tblOut 
			+" (FCLIENT, FTXT, FCAT_TXT, FSUM, FID_DOC"
				+", FDOC_NUM, FDOC_DAT, FCONTENT, FDOC, FNOP"
				+", FID_DOG, FDOG_NUM, FSFTYPE, FBANK)"
			+" select r.FORG, r.FPR1, "+ sCat +", r.FSUM, r.FWID"
				+", r.FDOC_NUM, r.FDOC_DAT, r.FTOVAR, r.FDOC, r.FNOP"
				+", r.FID_DOG, c.FDOG_NUM, "+ sSFType +", "+ sBank
			+" from ^RAS_SCH r "
				+" inner join ^CLRELCLCL rel on rel.FCOD=r.FORG and rel.FCL="+ getPar("CODPLAT")				
				+" inner join ^CL cl on cl.FWID=rel.FWID_CL "
				+" inner join ^CL_POST post on post.FWID_CL=rel.FWID_CL "
				+" inner join ^BILDOG dog on dog.FID_DOG=r.FID_DOG "
				+" inner join ^CONTRACT c on c.FWID=dog.FID_DOG "
			+" where r.FDOC_DAT>="+ sqlTo(d1) +" and r.FDOC_DAT<="+ sqlTo(d2)
				+ sqlw0And("r.FORG=", nOrg)
				+ sqlw0And("dog.FID_DOG=", dogID)			
	ExecuteSQL(sSQL);		
	ExecuteSQL("update "+ tblOut +" set FSUM_NDS="+ sqlRound("FSUM/6", 2));
		
	var oSnap = getSnap("select sum(FSUM), sum(FSUM_NDS) from "+ tblOut);
	if(oSnap)
	{
		sSQL = "insert into "+ tblOut +" (FTT, FTXT, FDOC_DAT, FSUM, FSUM_NDS) "
			+" values ('SUM', '"+ UR("      РАЗОМ|      ВСЕГО") +"', "+ sqlD00 
				+", "+ Number(oSnap[0]) +","+ Number(oSnap[1]) +")";
		ExecuteSQL(sSQL);
	}
	
	CLEARWAIT();
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	with(oGrid)
	{
		defCond("=^FTT=='SUM'", "SUM");			
		color(1, "SUM");	
	}
	with(oGrid.page())
	{	
		cell("=^FTT=='SUM'? '' : ^ROWNUM", "№ п/п", 8, null, DP_FORMAT_SC);
		cell("FDOC_DAT", "Дата", 12);
		cell("FBANK", "Банк", 12);		
		with(group("Організація|Органиация"))
		{
			cell("FCLIENT", "Код|Код", 8);
			cell("FTXT", "Назва|Наименование", 20);
			cell("FCAT_TXT", "Кат.|Кат.", 5);
		}
		cell("FCONTENT", "Зміст|Содержание", 12);
		cell("FSUM", "Загальна сума|Общая сумма", 12, null, DP_FORMAT_SUM);
		cell("FSUM_NDS", "Сума ПДВ|Сумма НДС", 15, null, DP_FORMAT_SUM);
		cell("=^FSUM-^FSUM_NDS", "Сума без ПДВ|Сумма без НДС", 15, null, DP_FORMAT_SUM);	
	}	
	oGrid.build();	
}

function createTmpTbl(sTblName)
{
	if(!ExecuteSQL("drop table"+ sTblName, false))
		ExecuteSQL("delete from "+ sTblName, false);
	var sSQL = "create table "+ sTblName 
		+" (FCLIENT "+ SqlType("INT")
		+", FCAT "+ SqlType("INT")
		+", FCAT_TXT "+ SqlType("TEXT")
		+", FTXT "+ SqlType("TEXT")
		+", FVID_DOG "+ SqlType("INT")		
		+", FID_DOG "+ SqlType("LONG")		
		+", FDOG_NUM "+ SqlType("TEXT")
		+", FSUM "+ SqlType("CURRENCY")		
		+", FSUM_NDS "+ SqlType("CURRENCY")
		+", FID_DOC "+ SqlType("LONG")
		+", FDOC_NUM "+ SqlType("TEXT")
		+", FDOC_DAT "+ SqlType("DATE")
		+", FBANK "+ SqlType("TEXT")
		+", FSFTYPE "+ SqlType("TEXT")
		+", FCONTENT "+ SqlType("LONGTEXT")
		+", FDOC "+ SqlType("TEXT")
		+", FNOP "+ SqlType("INT")		
		+", FWID "+ SqlType("COUNTER")
		+", FTT "+ SqlType("TEXT")
		+")";
	return ExecuteSQL(sSQL, false);	
}

function listMenuInit(ds)
{
	if(list.tbl.getValue("FID_DOC"))
	{
		if(IsDblClick())
		{
			listMenuRun("FINDDOC");
			return true;
		}				
		ds.AddMenuItem("FINDDOC", "Знайти документ|Найти документ");		
		ds.AddMenuItem("", "");			
	}		
}

function listMenuRun(sID)
{
	if(sID=="FINDDOC")
	{
		var m = new Object();
		m.doc = list.tbl.getValue("FDOC");
		m.nop = list.tbl.getValue("FNOP");
		m.dat = list.tbl.getValue("FDOC_DAT");
		m.org = list.tbl.getValue("FCLIENT");
		m.fid_doc = list.tbl.getValue("FID_DOC");		
		showWindow("l_docekz.xml", SW_NOMODAL, m);
	}
}

include("sys/DpList.js");