include("sys/mask.js");
include("sys/DpBaseDlg.js");
include("sys/udfs.js");

var mode;
var chartType = "";
var isPie = false;
var builder

function Load()
{
	builder = chart.getChartBuilder();
	//builder.setType("Histogram");
	
	chartType = extPar.chartType;
	
	builder.setType(chartType);
	
	var tbl = extPar.tbl;
	var bookmark = tbl.bookmark;
	var i = 0;
	
	
	isPie = chartType.toUpperCase().indexOf("PIE") != -1;
	isXY = chartType.toUpperCase().indexOf("XY") != -1;
	
	if (isPie)
	{
		fillPie(tbl, extPar.keyFld, extPar.valueFld);
	}
	else if (isXY)
	{
		if (extPar.series)
		{
			for (var i = 0; i < extPar.series.length; i++)
			{
				builder.addSeries(extPar.series[i].name);
				fillXYSeries(tbl, extPar.xFld, extPar.series[i].valueFld);
			}
		}
	}
	else if (chartType == "TimeSeriesChart")
	{
		if (extPar.series)
		{
			for (var i = 0; i < extPar.series.length; i++)
			{
				builder.addSeries(extPar.series[i].name);
				fillTimeSeries(tbl, extPar.xFld, extPar.series[i].valueFld);
			}
		}
	}
	else
	{
		if (extPar.series)
		{
			for (var i = 0; i < extPar.series.length; i++)
			{
				var name = extPar.series[i].name;				
				//builder.addSeries(extPar.series[i].name);
				fillCategorySeries(tbl,name,  extPar.series[i].categoryFld, extPar.series[i].valueFld);
			}
		}
	}
	
	if (extPar.chartName)
	{
		Caption(extPar.chartName);
		builder.setTitle(extPar.chartName);
	}
	
	builder.setLegend(extPar.legend ? true: false);
	builder.setHorizontal(extPar.horizontal ? true: false);
	
	
	if (extPar.XAxisLabel)
	{
		builder.setXAxisLabel(extPar.XAxisLabel);
	}
	
	if (extPar.YAxisLabel)
	{
		builder.setYAxisLabel(extPar.YAxisLabel);
	}
	
	
	
	
	tbl.bookmark = bookmark;
	var freechart = builder.buildChart();
	chart.setChart(freechart);
		
}

function fillPie(tbl, keyFld, valueFld)
{
	var bookmark = tbl.bookmark;
	tbl.moveFirst()
	while (!tbl.isEOF())
	{
		builder.setValue(tbl.getValue(keyFld), Number(tbl.getValue(valueFld)));
		tbl.moveNext();
	}
	tbl.bookmark = bookmark;
}

function fillXYSeries(tbl, xFld, yFld)
{
	var bookmark = tbl.bookmark;
	tbl.moveFirst();
	while (!tbl.isEOF())
	{
		var x = Number(tbl.getValue(xFld))
		var y = Number(tbl.getValue(yFld));
		
		if (!isNaN(x) && !isNaN(y))
			builder.setValue(x, y);
		tbl.moveNext();
	}
	tbl.bookmark = bookmark;
}

function fillCategorySeries(tbl, name, categoryFld, valueFld)
{
	var bookmark = tbl.bookmark;
	tbl.moveFirst();
	while (!tbl.isEOF())
	{
		var category = tbl.getValue(categoryFld);
		if (isDateType(category))
			category = format("dd.mm.yyyy", category);
		
		var value = Number(tbl.getValue(valueFld));
		
		if (!isNaN(value))
			builder.setValue(value, name, category);
		tbl.moveNext();
	}
	tbl.bookmark = bookmark;
}


function fillTimeSeries(tbl, xFld, yFld)
{
	var bookmark = tbl.bookmark;
	tbl.moveFirst();
	while (!tbl.isEOF())
	{
		var date = tbl.getValue(xFld);
		if (isDateType(date))
		{
			date = new Date(date).getVarDate();
			var y = Number(tbl.getValue(yFld));
		
			if (!isNaN(y))
				builder.setValue(date, y);
		}
		tbl.moveNext();
	}
	tbl.bookmark = bookmark;
}

function onSave()
{
	
}
