include("checkDump.js");

function main()
{
	checkXMLSource();
	checkBase();
}

function checkXMLSource()
{
	var sXmlFile = rootDirectoryEx() +"Source/import/DPBASE.xml";
	var sInitFile = rootDirectoryEx() +"Source/import/checksource.ini";
	if(!isFile(sInitFile) || !isFile(sXmlFile))
		return true;
	
	var sMsg = UR("Є можливість завантажити данні з файлу "+ sXmlFile 
					+"\nЗапустити майстер імпорту БД?"
				+"|Есть возможность загрузить данные из файла "+ sXmlFile
					+"\nЗапустить мастер импорта БД?"
				);
	if(confirm(sMsg))
	{
		var par = new Object();
		par.source = sXmlFile;		
		showWindow("importer_wizard.xml", "WIZARD", par);		
	}
	
	deleteFile(sInitFile);
	return true;
}

function checkBase()
{
	try
	{
		var host = getHostName();
		var comp = lpProxy.getOrgManager().getComp();
		var server = lpProxy.getOrgManager().getServer();		
		var base = getPath("ALL_MDB");
		var path = getOrgPath();
		var user = getDBUserName();
		var temp = lpProxy.getDBTemp(getUserName());
		if(!temp || temp.trim()=="")
			temp = user;
		
		if(SUBD==DERBY)
			checkDump();
		
		if(SUBD==ORACLE && comp==host)
			checkDump();
		
		if(SUBD==MSSQL && server==host)
			checkDump();
		
		if(SUBD==POSTGRE)	//(comp==host || comp=="localhost")
		{
			include("servis/dump.js");
			var pgsqlPath = exeDir() +"PostgreSQL/pgsql";
			var sPar = String(getPar("POSTGRESQL_PATH")).trim();
			if(!sPar && isDir(pgsqlPath))
				setPar("POSTGRESQL_PATH", pgsqlPath);
			
			if(isBase(base))
			{
				//checkDump();
				return true;
			}
			
			var sMsg = UR("На сервері "+ comp +" не існує бази "+ base +"."
							+"\nСтворити базу "+ base +"?"
						+"|На сервере "+ comp +" нет базы "+ base +"."
							+"\nСоздать базу "+ base +"?");
			if(!confirm(sMsg))
				return true;
			
			var bRet = ExecuteSQL("CREATE SCHEMA "+ base, false);
			if(bRet)
			{
				ExecuteSQL("CREATE SCHEMA "+ temp, false);
				grantPrivileges("ALL PRIVILEGES", user, temp, conn);
				grantPrivileges("ALL PRIVILEGES", user, base, conn);
			}
			else
			{
				var strConn = strForDBConnection();				
				var conn = lpProxy.getDBManager().getConnection(strConn, "postgres", "", false);
				if(conn)
				{
					bRet = ExecSQL(conn, "CREATE SCHEMA "+ base);
					if(bRet)
			    	{	
			    		ExecSQL(conn, "CREATE SCHEMA "+ user, false);
			    		grantPrivileges("ALL PRIVILEGES", user, temp, conn);
						grantPrivileges("ALL PRIVILEGES", user, base, conn);
			    	}
				}
			}
			return bRet;
		}
				
		var sPar = String(getPar("MYSQL_SERVER_PATH")).trim();
		if(SUBD==MYSQL && (server==host || server=="localhost" || sPar))
		{
			include("servis/dump.js");
			var mysqlPath = exeDir() +"MySQL/MySQL Server";			
			if(isDir(mysqlPath) && !sPar)
				setPar("MYSQL_SERVER_PATH", mysqlPath);
			if(isBase(base))
			{
				checkDump();
				return true;
			}
			
			var sMsg = UR("На сервері "+ server +" не існує бази "+ base +"."
							+"\nСтворити базу "+ base +"?"
						+"|На сервере "+ server +" нет базы "+ base +"."
							+"\nСоздать базу "+ base +"?");
			if(!confirm(sMsg))
				return true;
						
			var password = "";
			var strConn = strForDBConnection();			
			var conn = lpProxy.getDBManager().getConnection(strConn, "root", password, false);
			if(!conn)
			{
				var sAsk = UR("Уведіть пароль для root|Введите пароль для root");
				while(!conn)
				{
					password = checkPassword(sAsk);
					if(password==null)
						return true;
					conn = lpProxy.getDBManager().getConnection(strConn, "root", password, false);
				}
			}
			//trace("\ncheckBase: "+ base +" > "+ user +" > "+ password)
			
			if(conn)
	    	{
	    		var bRet = ExecSQL(conn, "CREATE DATABASE IF NOT EXISTS "+ base);
		    	if(bRet)
		    	{	
		    		ExecSQL(conn, "CREATE DATABASE IF NOT EXISTS "+ temp, false);
		    		grantPrivileges("ALL", user, temp, conn, false);
					grantPrivileges("ALL", user, base, conn, false);
		    		
		    		var sXmlFile = rootDirectoryEx() +"Source/import/DPBASE.xml";
		    		
		    		if(base=="dpbase")
					{
						var sXmlFile = rootDirectoryEx() +"Source/import/DPBASE.xml";
						var sMySQLPath = String(getPar("MYSQL_SERVER_PATH")).trim();
						var sArhFile = getOrgPath() +"/dpbase.arh";
						
						var sMsg = UR("Базу "+ base +" створено."
										+"\nДля роботи необхідно виконати імпорт даних з архіву."
										+"\nВиконати імпорт?"
									+"|База "+ base +" создана."
										+"\nДля работи нужно выполнить импорт данных из архива."
										+"\nВыполнить импорт?");
						if(confirm(sMsg))
						{						
							if(isFile(sArhFile) && isDir(sMySQLPath))
							{
								WAIT(UR("Виконується імпорт |Выполняется импорт ") + base);
								var oExec = runDBImport("root", password, base, base, "", sArhFile, conn);
		    					var sError = getExecError(oExec, "cp866");
		    					if(sError && String(sError).trim()!="")
		    						trace(sError);
		    					grantPrivileges("ALL", user, base, conn, false);
		    					CLEARWAIT();
							}
							else if(isFile(sXmlFile))
							{
								var par = new Object();
								par.source = sXmlFile;
								showWindow("importer_wizard.xml", "WIZARD", par);								
							}
							else
							{
								var par = new Object();
								par.login = "root"
								par.password = password;
								par.base = "dpbase";
								par.isAdmin = true;
								par.path = getOrgPath();
								showWindow("restore.xml", SW_MODAL, par);
							}
						}
					}
					else
					{
						var sMsg = UR("Базу "+ base +" створено."
										+"\nДля роботи необхідно завантажити дані у базу."
										+"\nДля цього можна скоритсатися імпортом з меню \"Сервіс\" у системі \"Адміністрування\"."
									+"|База "+ base +" создана."
										+"\nДля работи нужно загрузить данные в базу."
										+"\nДля этого можно воспользоваться импортом из меню \"Сервис\" в системе \"Администрирование\"."
									);
						if(isFile(sXmlFile))
						{
							sMsg += UR("\nЗапустити майстер імпорту БД?|\nЗапустить мастер импорта БД?");
							if(confirm(sMsg))
							{
								var par = new Object();
								par.source = sXmlFile;
								par.oldbase = true;
								showWindow("importer_wizard.xml", "WIZARD", par);
							}
						}
						else
						{										
							sMsg += UR("\nПерейти в систему \"Адміністрування\"?|\nПерейти в систему \"Администрирование\"?");
							if(confirm(sMsg))
								lpProxy.getOrgManager().setSys("ADM");
						}
					}
		    	}
		    	return bRet;
	    	}
		}
	}
	catch(e)
	{
		trace("\ncheckBase: "+ e);
	}
	return true;
}

function isBase(sName)
{
	sName = String(sName).toLowerCase().trim();
	var dbmd = lpProxy.getDBManager().getDbMetaData();	
	if(SUBD==MYSQL || SUBD==MSSQL)
	{
		var rs = dbmd.getCatalogs();	
		while(rs.next())
		{
			var sBase = String(rs.getString("TABLE_CAT")).toLowerCase();		
			if(sBase==sName)
				return true;
		}
	}
	else
	{
		var rs = dbmd.getSchemas();
		while(rs.next())
		{
			var sBase = String(rs.getString("TABLE_SCHEM")).toLowerCase();		
			if(sBase==sName)
				return true;
		}
	}
	return false;
}