include("doc/DpDoc.js");
include("sys/udfs.js");

var sContent = CONTENT.value;
var contentPar = new Object();
if(extPar)
	contentPar = extPar;
var sLinksCaption = UR("Зв'язані документи|Связанные документы");
if(extPar.linksCaption)
	sLinksCaption = UR(extPar.linksCaption);

function load()
{
	Caption("Змiст|Содержание");
	
	if (typeOf(FORM) == "DpViewPart")
	{
		FORM.setMessageHandler(onContentMessage, null);
	}
	
	setWhen(CONTENT, checkFont);
	setWhen(CONTENT, checkEncoding);
	setWhen(ENCODING, checkFont);	
	setValid(FONT, checkFont);
	setValid(ENCODING, checkEncoding);
	
	loadFont();	
	if(extPar && extPar.showLinks)
		loadLinksGroup();		
	else
		LINKS_GROUP.setVisible(false);
	if(extPar && extPar.content)
		CONTENT.value = extPar.content;
}

function onContentMessage(sType, oPar)
{
	try
	{
		if (oPar && oPar.content)
			CONTENT.value = oPar.content;
		else
			CONTENT.value = "";
		sContent = CONTENT.value;
		checkEncoding();
		
		contentPar = oPar;
		refreshLinks();			
	}
	catch(e)
	{
		trace("onContentMessage: "+ e);
	}
}

function refreshLinks()
{
	try
	{
		if(contentPar && gridLinks.getTable() && GRLINKS.isVisible())
		{
			if(!contentPar.docID)
				contentPar.docID = 0;
			var linksWhere = " l.FMAINWID="+ contentPar.docID
			if(contentPar.linksWhere)
				linksWhere = contentPar.linksWhere;
			gridLinks.getTable().openSel(linksWhere, false);
			gridLinks.refresh();
		}
	}
	catch(e)
	{
		trace("refreshLinks: "+ e);
	}
}
	
function checkEncoding()
{
	try
	{
		var encoding = ENCODING.getValue();
		if(!encoding || encoding=="")
			return;
		var txt = java.lang.String(sContent);
		CONTENT.value = java.lang.String(txt.getBytes(encoding));
	}
	catch(e){}
}
	
function checkFont()
{
	try
	{
		var size = Number(FONT.getValue());
		if(!size || size=="")
			return;
		CONTENT.setFontSize(size);
		WriteParameterEx("CONTENT_FONT", String(size));
	}
	catch(e){}		
}

function loadFont()
{
	var font = ReadParameterEx("CONTENT_FONT");
	if(Number(font))
	{
		FONT.setValue(font);
		checkFont();
	}
}

function loadLinksGroup()
{
	try
	{
		LINKSDOWN.getCtrl().setToolTipText(UR("Сховати |Спрятать ") +"'"+ sLinksCaption +"'");
		LINKSUP.getCtrl().setToolTipText(UR("Показати |Показать ") +"'"+ sLinksCaption +"'");
		setButton(LINKSDOWN, hideLinksGroup);
		setButton(LINKSUP, showLinksGroup);
	}
	catch(e)
	{
		trace("loadLinksGroup: "+ e);
	}
			
	loadLinksGrid();
	
	var par = ReadParameterEx("CONTENT_LINKS");
	if(par && String(par)=="false")
		hideLinksGroup();
	else
		showLinksGroup();
}
	
function showLinksGroup()
{
	sash.setWeights(new Array(500, 200));
	LINKS_GROUP.setVisible(true);
	GRLINKSUP.setVisible(false);
	GRLINKS.setVisible(true);
	WriteParameterEx("CONTENT_LINKS", "true");
	refreshLinks();
}

function hideLinksGroup()
{
	sash.setWeights(new Array(500, 20));
	LINKS_GROUP.setVisible(true);
	GRLINKSUP.setVisible(true);
	GRLINKS.setVisible(false);
	WriteParameterEx("CONTENT_LINKS", "false");
}

function loadLinksGrid()
{
	try
	{
		if(!extPar.docID)
			extPar.docID = 0;
		var linksTbl = null;
		if(extPar.linksTbl)
		{
			linksTbl = extPar.linksTbl;
		}
		else
		{			
			linksTbl = OpenTable("select wd.FWID, wd.FNAME, wd.FREM"
									+", l.FDOC, l.FNOP, l.FDOCWID as FID_DOC"
									+", sc.FDOC_NUM, sc.FDOC_DAT"																											
								+" from ^DOC_LINKS l "
									+" left join ^WD_EKZ wd on wd.FWID=l.FDOCWID"
									+" left join ^SCH_ZAG sc on sc.FWID=l.FDOCWID"
								+" where l.FISPARENT="+ sqlTrue
								);
		}
		gridLinks.FieldEx("=linkName(^FNAME, ^FDOC, ^FNOP, ^FDOC_NUM, ^FDOC_DAT)", sLinksCaption, 10);
		gridLinks.setTable(linksTbl);
		gridLinks.build();
		
		this.gridLinksMenuInit = gridLinksMenuInit;
		this.gridLinksMenuRun = gridLinksMenuRun;
		gridLinks.loadMenuHandler(this, "gridLinksMenuInit");
		gridLinks.selectMenuHandler(this, "gridLinksMenuRun");		
	}
	catch(e)
	{
		trace("loadLinksGrid: "+ e);
	}		
}

function linkName(fileName, sDoc, nNop, docNum, docDat)
{
	var txt = "";
	try
	{
		if(fileName && String(fileName).trim()!="")
			return fileName;		
		if(sDoc)
			txt = tdoc(sDoc, nNop);
		if(docNum)
			txt += ": № "+ docNum;
		if(docDat)
			txt += " - "+ StrDat(docDat, "DMY");		
	}
	catch(e)
	{
		
	}	
	return txt;
}

function gridLinksMenuInit(oGrid)
{
	if(extPar && extPar.gridLinksMenuInit)
		return extPar.gridLinksMenuInit(oGrid);
	if(IsDblClick(oGrid))
	{
		this.gridLinksMenuRun("LINK_OPEN", oGrid);
		return true;
	}
	
	oGrid.AddMenuItem("LINK_FIND", "Знайти|Найти");
	oGrid.AddMenuItem("LINK_OPEN", "Відкрити|Открыть");
	oGrid.AddMenuItem("LINK_EDIT", "Редагувати|Редактировать");
}

function gridLinksMenuRun(sID, oGrid)
{
	if(extPar && extPar.gridLinksMenuRun)
		return extPar.gridLinksMenuRun(sID, oGrid);
	
	var tbl = oGrid.getTable();
	var doc = tbl.getValue("FDOC");
	var nop = tbl.getValue("FNOP");
	var docID = tbl.getValue("FID_DOC");
		
	if(sID=="LINK_OPEN")
	{		
		if(tbl.getValue("FNAME"))
		{
			var docID = tbl.getValue("FWID");
			var oSnap = getSnap("select FNAME, FFOLDER from ^WD_EKZ where FWID = " + Number(docID));
			if (oSnap)
				openExtFile(oSnap[0], oSnap[1]);
		}
		else if(tbl.getValue("FDOC"))
		{
			var oDoc = new DpDoc(doc, nop);
			oDoc.edit("VIEW", docID);
		}
	}
	else if(sID=="LINK_FIND")
	{
		include("doc/DpDocPtn.js");		
		FindDocument(doc, nop, docID);
	}
	else if(sID=="LINK_EDIT")
	{
		var oDoc = new DpDoc(doc, nop);
		if(oDoc.edit("EDIT", docID))
		{
			oGrid.getTable().requery();
			oGrid.refresh();
		}		
	}
}
	
load();