
//Проверка соедининия
//Вызывается при первом подключении к базе, если в папке DebetPlusV12 есть файл dbconnection.ini
function main()
{
	if(!initConnection())
		return false;
	dbinit();
}

//подготовка СУБД для работы: 
// создание и импорт базы dpbase, 
// создание пользователя DPADMIN
function dbinit()
{
	try
	{
		java.lang.System.out.println("\n-------------------- dbinit --------------------");
		
		Task.include("sys/main.js");
		include("servis/dump.js");
		include("checkBase.js");
		
		var bImportRun = false;
		var base = null;
		
		if(SUBD==POSTGRE)
		{			
			base = "dpbase";
			var user = "DPADMIN";			
			var superuser = "postgres";
			var exePath = exeDir();
			var pgsqlPath = exeDir() +"PostgreSQL/pgsql";
			var sArhFile = getOrgPath() +"/dpbase.backup";
			
			var sPar = String(getPar("POSTGRESQL_PATH")).trim();
			if(!sPar && isDir(pgsqlPath))
				setPar("POSTGRESQL_PATH", pgsqlPath);
									
			ExecuteSQL("CREATE USER "+ superuser +" WITH SUPERUSER", false);		
			ExecuteSQL("CREATE USER "+ user +" WITH SUPERUSER", false);			
			if(!isBase(base))
			{
				ExecuteSQL("CREATE SCHEMA "+ base, false);
				if(isFile(sArhFile))
				{
					var oExec = runDBImport(superuser, "", base, base, "", sArhFile);
			    	var sError = getExecError(oExec, "cp866"); //ждем...
			    	trace(sError);
			    	bImportRun = true;
				}
			}
			//ExecuteSQL("GRANT ALL ON SCHEMA "+ base +" TO PUBLIC", false);
			
			//создаем подключение под суперюзером
			var strConn = strForDBConnection();			
			var conn = lpProxy.getDBManager().getConnection(strConn, superuser, "", false);
			if(!conn)
				return false;			
		}
		
		if(SUBD==MYSQL)
		{			
			base = "dpbase";
			var user = "DPADMIN";
			var sArhFile = getOrgPath() +"/dpbase.arh";
			var exePath = exeDir();
			var mysqlPath = exeDir() +"MySQL/MySQL Server";
			var sPar = String(getPar("MYSQL_SERVER_PATH")).trim();
			if(!sPar && isDir(mysqlPath))
				setPar("MYSQL_SERVER_PATH", mysqlPath);
			
			//создаем подключение под суперюзером root
			var strConn = strForDBConnection();			
			var conn = lpProxy.getDBManager().getConnection(strConn, "root", "", false);
			if(!conn)
				return false;
			
			//нужно грохнуть анонимного юзера который для Дебета только портит всю малину
			ExecSQL(conn, "DROP USER ''@'localhost'", false);
			//добавляем своего админа
			ExecSQL(conn, "CREATE USER "+ user +" IDENTIFIED BY ''", false);
			//создаем базу для DPADMIN			
			ExecSQL(conn, "CREATE DATABASE IF NOT EXISTS "+ user, false);
			//на всякий случай создаем базу для суперюзера, чтобы можно было подключится под рутом из дебета
			ExecSQL(conn, "CREATE DATABASE IF NOT EXISTS root", false);			
		    //даем права на временную базу
		    grantPrivileges("ALL", user, user, conn, false);		    
		    
		    if(!isBase(base))
			{
				//создаем базу dpbase
				ExecSQL(conn, "CREATE DATABASE IF NOT EXISTS "+ base, false);
				//если есть архив - запускаем импорт
				if(isFile(sArhFile))
				{
					var oExec = runDBImport("root", "", base, base, "", sArhFile, conn);
			    	var sError = getExecError(oExec, "cp866"); //ждем...
			    	trace(sError);
			    	bImportRun = true;
				}			    
			}
			//даем права на dpbase
			grantPrivileges("ALL", user, base, conn, false);		
		}
		
		var sXmlFile = rootDirectoryEx() +"Source/import/DPBASE.xml";
		if(!bImportRun && isFile(sXmlFile))
		{			
			var sMsg = UR("Є можливість завантажити данні з файлу "+ sXmlFile 
							+"\nЗапустити майстер імпорту БД?"
						+"|Есть возможность загрузить данные из файла "+ sXmlFile
							+"\nЗапустить мастер импорта БД?"
						);
			if(confirm(sMsg))
			{
				var par = new Object();
				par.source = sXmlFile;
				par.base = base;				
				showWindow("importer_wizard.xml", "WIZARD", par);
			}
		}
		
		trace("-------------------- dbinit --------------------\n");
	}
	catch(e)
	{
		java.lang.System.out.println(e);
		//Task.getSys().alert(e);		
	}
	return true;
}

//тестовое соединение 
function initConnection()
{
	try
	{
		java.lang.System.out.println("\n-------------------- initConnection --------------------");
		
		var sMainPath = Packages.org.eclipse.core.runtime.Platform.getInstallLocation().getURL().getFile();
		if(sMainPath.startsWith("/"))
    		sMainPath = sMainPath.substring(1);
		var sSUBD = Task.getSys().getOrgManager().getSUBD();
		var dbManager = Task.getSys().getDBManager();
		var sInitFile = sMainPath +"dbconnection.ini";
		var sXmlFile = Task.getSys().getWrkDir() +"Source/import/DPBASE.xml";
		
		if(sSUBD.equalsIgnoreCase("POSTGRE"))
		{
    		var sBase = "dpbase";
    		var sUser = "postgres";
    		var sOrgPath = sMainPath +"base/pgdpbase";
    		var sBinPath = "PostgreSQL\\pgsql\\bin\\";
    		var sDataPath = "\""+ sMainPath +"\"PostgreSQL\\pgsql\\data";
    		if(!dbManager.setConnection(sBase, sUser, "", false))
			{
				var bCreate = false;
				var dataDir = new java.io.File(sMainPath +"PostgreSQL\\pgsql\\data");
				if(!dataDir.isDirectory())
				{
					//инициализация базы - создается папка data
					oExec = exec(sBinPath +"initdb -D "+ sDataPath);
					//err = getExecError(oExec);
					//oExec.waitFor();
					wait(60);	//ждём 60 сек
					bCreate = true;
				}
								
				//запуск PostgreSQL
				exec(sBinPath +"pg_ctl start -l pgsql.log -D "+ sDataPath);				
				wait(60);	//ждём 60 сек пока этот чмырь стартует
				
				//регистрация системного сервиса в винде
				exec(sBinPath +"pg_ctl register -l pgsql.log -D "+ sDataPath);
				
				//if(bCreate)
				{
					exec(sBinPath +"createuser --superuser DPADMIN");			
					exec(sBinPath +"createuser --superuser "+ sUser);
					oExec = exec(sBinPath +"createdb "+ sBase);
					var err = getExecError(oExec);
					java.lang.System.out.println(err);
				
					exec(sBinPath +"psql "+ sBase);
					wait(30);
										
					oExec = exec(sBinPath +"pg_restore --create --dbname="+ sBase +" \""+ sOrgPath +"\"\\dpbase.backup");
					err = getExecError(oExec);
					java.lang.System.out.println(err);				
				}
				
				if(!dbManager.setConnection(sBase, sUser, "", false))
					return false;						
			}
		}
		else if(sSUBD.equalsIgnoreCase("MYSQL"))
		{
			var sBase = "test";
    		var sUser = "root";    		
    	
			if(!dbManager.setConnection(sBase, sUser, "", false))
			{
				//запуск MySQL
				var sCmd = "MySQL\\MySQLS~1\\bin\\mysqld-nt"
							+" --defaults-file=\""+ sMainPath +"MySQL/my.ini\"";
				exec(sCmd);								
				wait(40);	//ждём 40 сек пока стартует MySQL
									
				//удаление анонима
				exec("MySQL\\MySQLS~1\\bin\\mysql -u root --force --execute=\"DROP USER ''@'localhost'\"");
				exec("MySQL\\MySQLS~1\\bin\\mysql -u root --force --execute=\"DROP USER ''\"");
					
				if(!dbManager.setConnection(sBase, sUser, "", false))
				{
					//возможно MySQL еще не стартовал, ждём еще 30 сек
					wait(30);
					exec("MySQL\\MySQLS~1\\bin\\mysql -u root --force --execute=\"DROP USER ''@'localhost'\"");
					exec("MySQL\\MySQLS~1\\bin\\mysql -u root --force --execute=\"DROP USER ''\"");
					
					if(!dbManager.setConnection(sBase, sUser, "", false))
						return false;
				}
				
				//если дебет ставился вместе с мускулом, нужно его установить как службу чтобы не запускать каждый раз после перезагрузки	
				sCmd = "MySQL\\MySQLS~1\\bin\\mysqld-nt "
						+" --install MySQL "
						+" --defaults-file=\""+ sMainPath +"MySQL/my.ini\"";
				exec(sCmd);					    			
			}
		}
		else
		{
			return false;
		}
				
		Task.getSys().deleteFile(sInitFile);
		
		java.lang.System.out.println("-------------------- initConnection --------------------\n");
	}
	catch(e)
	{
		java.lang.System.out.println(e);
		//Task.getSys().alert(e);
		return false;		
	}
	return true;
}

function wait(sec)
{
	java.lang.System.out.println("wait: "+ sec);
	var thread = new java.lang.Thread
	(
	 	function run()
		{
			
		}
	);	
	thread.start();
	thread.sleep(sec*1000);
}

function exec(sCommand)
{
	java.lang.System.out.println("exec: "+ sCommand);
	//Task.getSys().alert("exec: "+ sCommand);
	var ret = false;
	if(Packages.org.eclipse.core.runtime.Platform.getOS()=="linux")
		ret = Packages.java.lang.Runtime.getRuntime().exec(new Array("sh", "-c", sCommand));
	else
		ret = Packages.java.lang.Runtime.getRuntime().exec("cmd /c "+ sCommand);
	return ret;
}

function getExecError(oExec, charset)
{
	var sError = "";
	if(!charset)
		charset = "cp1251";
	try
	{
		var es = oExec.getErrorStream();
		var isr = java.io.InputStreamReader(es, charset);
		var br = java.io.BufferedReader(isr);
		while((str=br.readLine())!=null)
			sError += str +"\r\n";
	}
	catch(e)
	{
		
	}
	return sError;
}