include("doc/DpExeDoc.js");
include("doc/DpDocRow.js");
include("doc/DpDocExt.js");
include("doc/DpAutoNo.js");
include("doc/DpDocRegAttrs.js");
include("doc/DpDocDef.js");
include("doc/DpDocCalculat.js");

//- большая просьба - при внесении изменений в логику сохранения/удаления документа
//- вносить соответствующие изменения в методы serverSave и serverDelete

function DpDoc(sDocLbl, nNop, doclist)
{	
	this.create = DpDoc_createDoc;
	this.edit = DpDoc_edit;
	this.copy = DpDoc_copy;
	
	this.getVar = DpDoc_getVar;
	this.setVar = DpDoc_setVar;
	
	this.del = DpDoc_delete;
	this.delDocLinks = DpDoc_delDocLinks; 
	this.serverDelete = DpDoc_serverDelete;
	this.delProv = DpDoc_delProv;
	this.getCaption = DpDoc_getOName;
	this.docList = doclist;
	this.tEval = DpDoc_tEval;
	this.eval = DpDoc_eval;
	this.substVal = DpDoc_substVal;
	this.toArchive = DpDoc_toArchive;
	this.fillSynchroVars = DpDoc_fillSynchroVars;
	this.fromArchive = DpDoc_fromArchive;
	this.createRow = DpDoc_createRow;
	this.copyRow = DpDoc_copyRow;
	this.appendRow = DpDoc_appendRow;
	this.deleteRow = DpDoc_deleteRow;
	this.getVarsInfo = DpDoc_getVarsInfo;
	this.getChildIDs = DpDoc_getChildIDs;
	this.getChildClasses = DpDoc_getChildClasses;
	this.getVarInfo = DpDoc_getVarInfo;
	this.getDataDir = DpDoc_getDataDir;
	
	this.setCtrlLinker = DpDoc_setCtrlLinker;
	this.getCtrlLinker = DpDoc_getCtrlLinker;
	this.ctrlLinker = null;
	
	this.getPar = DpDoc_getPar;
	this.setPar = DpDoc_setPar;
	this.getSys = DpDoc_getSys;
	this.getName = DpDoc_getName;
	this.getOName = DpDoc_getOName;

	this.getRow = DpDoc_getRow;
	this.getID = DpDoc_getID;
	this.setID = DpDoc_setID;
	this.loadByID = DpDoc_loadByID;
	this.fillFromTemplate = DpDoc_fillFromTemplate;
	this.save = DpDoc_save;
	this.saveRows = DpDoc_saveRows;
	this.serverSave = DpDoc_serverSave;
	
	this.resetFnids = DpDoc_resetFnids;

	this.calculate = DpDoc_calculate;
	this.isAbstract = DpDoc_isAbstract;
	this.instanceOf = DpDoc_instanceOf;
	this.doRegistration = DpDoc_doRegistration;
	this.delRegistration = DpDoc_delRegistration;
	
	this.hasRows = DpDoc_hasRows;
	this.gotoFirstRow = DpDoc_gotoFirstRow;
	this.gotoNextRow = DpDoc_gotoNextRow;
	this.gotoPrevRow = DpDoc_gotoPrevRow;
	this.getCurrRow = DpDoc_getCurrRow;
	this.setDocID = DpDoc_setDocID;
	this.getVars = DpDoc_getVars;
	this.getClassDefPath = DpDoc_getClassDefPath;
	this.clear = DpDoc_clear;
	this.bNew = true;
	this.syncObj  = null;
	
	this.getTableName = DpDoc_getTableName;
	this.getFieldName = DpDoc_getFieldName;
	this.getFieldsByVar = DpDoc_getFieldsByVar;
	this.getOrgField = DpDoc_getOrgField;
	
	this.setEvaluator = DpDoc_setEvaluator;
	this.listTemplate = DpDoc_listTemplate;
	
	this.hasLabel = DpDoc_hasLabel;
	this.getLabel = DpDoc_getLabel;
	this.addLabel = DpDoc_addLabel;
	this.removeLabel = DpDoc_removeLabel;
	this.removeAllLabels = DpDoc_removeAllLabels;
	this.getAllLabels = DpDoc_getAllLabels;
	this.removeLabelsFromDB = DpDoc_removeLabelsFromDB;
	this.getLabelClasses = DpDoc_getLabelClasses;

	this.print = DpDoc_print;

	derive(this,DpExeDocOp);
	derive(this,DpDocExt);
	derive(this,DpDocRegAttrs);
	derive(this,DpDocDef);
	
	this.getJObject = DpDoc_getJObject;
	
	if (!sDocLbl) return;
	
	this.currRowCash = null;
	
	this.sDocLbl = String(sDocLbl);
	this.nNop = Number(nNop);
	
	this.getAutoNo = DpDoc_getAutoNo;
	//this.nID = nID;

	this.doTransform = DpDoc_doTransform;
	
	this.setFormFile = DpDoc_setFormFile;
	this.createTemplate = DpDoc_createTemplate;
	
	this.create();
	
	if (String(this.jDoc.getModuleID()) == "")
	{
		this.sDocPath = rootDirectory()+"docs/"+sDocLbl + "/";
		this.formFile = "docs/" + sDocLbl + "/form.xml";
	}
	else
	{
		this.sDocPath = getModulePath(this.jDoc.getModuleID())+"/scripts/docs/"+ this.jDoc.getShortClassID() + "/";
		this.formFile = this.jDoc.getModuleID() + ":docs/" 
				+ this.jDoc.getShortClassID() + "/form.xml";
	}
	
	this.setAttribute = DpDoc_setAttribute;
	this.getAttribute = DpDoc_getAttribute;
	if("COM.DEBET.CDR.PF" ==String(sDocLbl).toUpperCase())
	{
		this.createRang = DpPers_createRang;
		this.addRang = DpPers_addRang;
		this.removeRang = DpPers_removeRang;
		this.getRang = DpPers_getRang;
		this.createPrk = DpPers_createPrk;
		this.addPrk = DpPers_addPrk;
		this.removePrk = DpPers_removePrk;
		this.getPrk = DpPers_getPrk;
	}
	
	this.oVars = null;
		
	this.__defineGetter__("VARS", DpDoc_getVars);
	this.__defineGetter__("vars", DpDoc_getVars);
}

function DpDoc_getClassDefPath()
{
	return this.sDocPath;
}

function DpDoc_getVars()
{
	if (this.oVars == null)
	{
		include ("Objects/DpInnerVars.js");
		this.oVars = new DpInnerVars(this);
	}		
	return this.oVars;	
}

function DpDoc_getPar(sPar)
{	
/*
	if(!this.param)
		this.param = CreateDocPar(this.sDocLbl, this.nNop);
	if (this.param)
		return this.param.getPar(sPar);
*/
	return toScrObj(this.jDoc.getPar(sPar));
}

function DpDoc_setPar(sPar,oVal)
{
	this.jDoc.setPar(sPar,oVal);
}

function DpDoc_getSys()
{
	return String(this.jDoc.getSys());
}

function DpDoc_getChildIDs()
{
	return this.jDoc.getChildIDs();
}

function DpDoc_getChildClasses()
{
	if (this.jDoc)
		return this.jDoc.getChildClasses();
	return new Array();
}


function DpDoc_getName()
{
	return String(this.jDoc.getName());
}

function DpDoc_fillFromTemplate(idimpl)
{
	var fileName = rootDirectoryEx() + "Source/doctemplates/" + this.sDocLbl.replace(":","_") + "/" + idimpl + ".xml";
	if (!isFile(fileName))
		return;
		
	this.jDoc.loadFromXML(fileName);
	this.setID(-1);
	if (this.nNop)
		this.setVar("HOP", Number(this.nNop))
	this.setVar("HDAT", today.getVarDate());
	this.setVar("HNOM", "");
			
}

function DpDoc_loadByID(nID,bNoErr,bNoBlock)
{
	if (!nID || nID == null) return false;
	this.clear();
	if (this.nNop)
		this.setVar("HOP", Number(this.nNop))
	this.bNew =false;
//	var isCdr = this.sDocLbl.toLowerCase().indexOf("com.debet.cdr")>-1
	if (bNoErr)
	{
		if (!bNoBlock)
			lockObject("DOC." + this.sDocLbl,this.nNop,Number(nID));
		
//		if(isCdr)
//			return this.jDoc.loadFromXML(Number(nID));
//		else 
			return this.jDoc.loadFromDB(Number(nID));
	}

	
//	if (isCdr?!this.jDoc.loadFromXML(Number(nID)):!this.jDoc.loadFromDB(Number(nID)))
	if (!this.jDoc.loadFromDB(Number(nID)))
	{
		var archDat = null;
		
		var sSQL = "SELECT COUNT(*) cnt from ^archive WHERE FDOC = "
				+ sqlTo(this.sDocLbl) + " AND FID_DOC = " + Number(nID);
				
		var oSnap = getSnap(sSQL);
		if (!oSnap || oSnap[0] != 0)
		{
			var conf = msgBox("yn",UR("Не можу загрузити документ."
								+ "\nСпробувати підняти документ з архіву?|"
								+ "Не могу загрузить документ."
								+ "\nПопытаться поднять документ из истории?"),
								UR("Попередження.|Предупреждение."));
			if (conf == "n")
				return false;
			archDat = this.fromArchive(Number(nID));
		
		}
		return false;
/*
		if (archDat == null)
		{
			
			include("objects\\DpDocumentDecoder.js");
			var oDec = new DpDocumentDecoder();
			var oPar = new Object();
			oPar.doc = this.sDocLbl;
			oPar.fiddoc = Number(nID);
			oPar.notRegister = true;
			if (!oDec.runForCDR(this.sDocLbl, oPar))
				oDec.run(this.sDocLbl, oPar);
			var ret = this.jDoc.loadFromXML(getOrgPath()
				   + "data/docs/" + this.sDocLbl + "/" + String(parseInt(nID) + ".xml"));
			return ret;
		}
		else
		{
			var conf = msgBox("yn"
					,UR("Знайдено документ за |Найден документ за ")
					+ format("dd.mm.yyyy th:tm:ts", archDat) + "\n"
					+ UR("Продовжити?|Продолжить?"),
					UR("Редагування документу|Редактирование документа"));
			if (conf == "n")
				return false;
		}
	*/	
	}
	return true;
}

function DpDoc_isAbstract()
{
	return this.jDoc.isAbstract();
}


function DpDoc_getID()
{
	return Number(this.jDoc.getVar("ID"));
	//return this.jDoc.getObjectID();
}

function DpDoc_setID(nID)
{
	if (typeof nID != "number")
		return;		
	this.jDoc.setObjectID(nID);
}

function DpDoc_createDoc()
{			
	this.arrCtrl = new Array();	
	this.jDoc = lpProxy.createObject(this.sDocLbl);
	
	//this.jDoc.setObjectID(this.nID);
	this.jDoc.setVar("HDOC",this.sDocLbl);	
	this.jDoc.setVar("HOP",this.nNop);
	this.jDoc.setVar("HORG0", Number(getPar("ORGNOM")));		
	include("objects\\DpEval.js");
	var eval = new DpEval();
	this.jDoc.setEvaluator(eval);
	this.param = null;
	this.fillUsrVars();
	this.fillDefVars();
}

function DpDoc_setFormFile(fileName)
{
	if (typeof fileName != "string" || fileName == "")
		return;
	this.formFile = "docs/" + this.sDocLbl + "/" + fileName + ".xml";
}

function DpDoc_edit(sMode, nID, par)
{
	if(typeof(par) != "object")
		par = new Object();
	par.doc = this;	
	par.mode = sMode;
	
	if (inList(sMode, "EDIT", "VIEW"))
	{
		var key = this.sDocLbl + "|" + Number(nID);
		var shell = lpProxy.getShellMap().get(key);
		if (shell != null && !shell.isDisposed())
		{
			if (shell.getMinimized())
				shell.setMinimized(false);
			shell.setActive();
			return false;
		}
	}
	
	var ls = null;
	if(sMode == "EDIT")
		ls = getLockState("DOC." + this.sDocLbl,this.nNop,nID);
	if (ls != null && ls.getLockState() == 1)
	{
		var sUser = String(getUserName()).toUpperCase();
		var sHost = String(getHostName()).toUpperCase();
		var lockUser = String(ls.getUserName()).toUpperCase();
		var lockHost = String(ls.getUserHost()).toUpperCase();
		var cnfrm = "y";
		if (sUser != lockUser || sHost != lockHost)
		{
			var msg = UR("Документ редагується іншим користувачем "
						+ "|Документ редактируется другим пользователем ");
			msg += ls.getUserHost() + "@" + ls.getUserName();
			msg += "\n" + UR("Бажаєте продовжити?|Желаете продолжить?");
			cnfrm = msgBox("yn",msg,UR("Блокування|Блокировка"));
		}
		if (cnfrm == "n")
			return false;
		
	}		
	if(sMode == "EDIT")
	{
		lockObject("DOC." + this.sDocLbl,this.nNop,Number(nID));
	}
	
	include ("Objects/DpObjectSyncronizer.js");
	this.syncObj = new DpObjectSyncronizer(this);	
	
	
	if(sMode != "ADD")
	{
		var ret = this.syncObj.sycronize(nID);
		if (ret == DpObjectSyncronizer_DELETED)
			return true;
		
		if (sMode == "VIEW")
		{
			if (!this.loadByID(nID,false,true))
				return false;
		}
		else
		{
			if (!this.loadByID(nID))
				return false;
		}
	}
	else if (par.idtmpl)
	{
		this.fillFromTemplate(par.idtmpl);
	}
	if(this.sDocLbl.toLowerCase().indexOf("com.debet.cdr")==-1 && this.autoNo == null)//удалить это условие, когда ШР отвяжут от кадровых документов
		this.autoNo = new dpAutoNo(this);
	
	if(sMode == "ADD")
	{
		if(differ(this.jDoc.getVar("HDAT"), d00) == 0)
			this.jDoc.setVar("HDAT",today.getVarDate());
		if (!this.getVar("HNOM") || this.getVar("HNOM") == null)
			if(this.sDocLbl.toLowerCase().indexOf("com.debet.cdr")==-1)
				this.jDoc.setVar("HNOM",this.autoNo.get());
	}
	
	
	
	if (sMode == "COPY")
	{
		this.nOldID = this.getID();
		this.jDoc = this.jDoc.clone();
		var eval = new DpEval();
		this.jDoc.setEvaluator(eval);
		if(this.sDocLbl.toLowerCase().indexOf("com.debet.cdr")==-1)//удалить это условие, когда ШР отвяжут от кадровых документов
			this.jDoc.setVar("HNOM",this.autoNo.get());
		if (!this.getPar("copydate"))
			this.jDoc.setVar("HDAT",today.getVarDate());
		
		this.jDoc.setVar("HORG0", Number(getPar("ORGNOM")));
		this.jDoc.setVar("HVER", 0);
		this.jDoc.setVar("HOUTID", "");		
	}
	
	lpProxy.getLog().debug("CHECK PAGES");
	
	/*
	if (this.hasExt() || this.getRegNums().length > 0)
		par.hasTab = true;
*/
	par.hasTab = true;
	if (sMode == "VIEW")
		par.isView = true;
	else
		par.isView = false;
	
	if(this.getPar("_eschandler")==0)
		par.escapeMsg = ru("Выйти без сохранения изменений?"
							,"Вийти без збереження змін?");

	par.isApplyBtn = true;
	lpProxy.getLog().debug("BEFORE SHOW DOCDLG")
	showWindow(this.formFile,"XMLDLG",par);
	
	if (!par.escape || par.apply)
	{
//-		this.toArchive(sMode);
		if (!par.escape)
			this.save(false,par.apply? "EDIT":sMode); 
		if(this.sDocLbl.toLowerCase().indexOf("com.debet.cdr")==-1)//удалить это условие, когда ШР отвяжут от кадровых документов
			this.autoNo.put(String(this.jDoc.getVar("HNOM")));	
	}
	else
	{
		if(this.sDocLbl.toLowerCase().indexOf("com.debet.cdr")==-1)//удалить это условие, когда ШР отвяжут от кадровых документов
			this.autoNo.unGet();
	}
	if(sMode == "EDIT")
		freeObject("DOC." + this.sDocLbl,this.nNop,this.jDoc.getObjectID());

	if((!par.escape || par.apply)  && (sMode == "ADD" || sMode == "COPY" || sMode == "EDIT"))
	{
		this.doTransform();
	}

	return !par.escape;
}

function DpDoc_doTransform(bNoAsk)
{
	try
	{
		strWhere = " FISAUTOCREATE = " + sqlTrue 
				+ " AND (Fdoc1 is null or Fdoc1 = " + sqlTo("") + " or Fdoc1=" + sqlTo(this.sDocLbl) + ")"
				+ ( this.nNop? " AND (Fnop1 = 0 or Fnop1=" + sqlTo(this.nNop) + ")": "" );
		var tblLnk = OpenTable("SELECT * from ^cl_linkdoc WHERE " + strWhere);
		for(tblLnk.MoveFirst();!tblLnk.IsEOF();tblLnk.MoveNext())
		{
			include("Objects\\DpDocTransformer.js");
			var docTransformer = new DpDocTransformer(this.sDocLbl,this.nNop);
			docTransformer.sLinkId = tblLnk.getValue("fwid");
			docTransformer.sDocTo = tblLnk.getValue("fdoc");
			docTransformer.nNopTo = tblLnk.getValue("fnop");
			var ffilt = String(tblLnk.getValue("ffilt"));
			if (ffilt != null && ffilt)
				docTransformer.filter = ffilt;
			docTransformer.transform(this.getID(), true, bNoAsk);
		}
	}
	catch(e)
	{
		alert(e, 2);
	}
}

function DpDoc_getAutoNo()
{
	if (this.autoNo == null)
		this.autoNo = new dpAutoNo(this);
	return this.autoNo;
}

function DpDoc_copy()
{
	var oDoc = new DpDoc(this.sDocLbl,this.nNop);
	oDoc.loadByID(this.getID());
	oDoc.setID(-1);
	return oDoc;
	
}

function  DpDoc_setEvaluator(oEval)
{
	if (!oEval)
	{
		oEval = new DpEval();
	}
	this.jDoc.setEvaluator(oEval);
}

function DpDoc_serverSave(bNotPutToArchive,sMode,sRows)
{
	this.fillSynchroVars();
	this.calculate();
	var isOk = this.jDoc.storeToXML();
	if (!isOk)
		return false;
	if (!bNotPutToArchive)
		this.toArchive(sMode);
	obj2DB(this.jDoc.getObjectID(),this.jDoc);
	this.saveExtToDB();
	this.jDoc.saveLabelsToDB();
	this.saveRows();
	this.doRegistration(true);
	return true;
}

function DpDoc_save(bSaveRows,sMode,bNoErr, bNoCalc)
{
	//запрет на сохранение документов не входящих в период редактирования 
	//документов и проводок (getPar("CLOSEPERIOD")), бок в том, что могут 
	//поднять на редкатирование документ из периода и сохранить его с датой превышающей период
	//исключаем документы использующиеся в штатном расписании для системы кадров
	if(this.sDocLbl.toLowerCase().indexOf("com.debet.cdr")==-1 
		&& this.sDocLbl.toLowerCase().indexOf("hozdog")==-1 
		&& this.sDocLbl.toLowerCase().indexOf("dogovor")==-1	//vlad 18.08.2011 Договора ЧОЕ
		&& !this.instanceOf("COM.DEBET.DOGOVOR")
		&& this.sDocLbl.toLowerCase().indexOf("td")==-1 
//		&& this.sDocLbl.toLowerCase().indexOf("bs")==-1 //AL: BS попросят у администратора
		&& this.sDocLbl.toLowerCase().indexOf("o7")==-1
		&& this.sDocLbl.toLowerCase().indexOf("cdr_")==-1
		&& !canUpdateDate(this.getVar("HDAT"), this.getVar("HID")))
		return false;
	//- gray: не сносить - пока - используется для синхронизации
	this.getID();
	this.fillSynchroVars();
	//------------------------------
	var e;
	try
	{
		if (!bNoCalc)
		{
			this.calculate();
		}
	}
	catch(e)
	{
		
	}
	
	var nVer = Number(this.getVar("HVER"));
	
	
	/*
	var isOk = this.jDoc.storeToXML();
	if (!isOk)
	{
		if (bNoErr)
			return false;
		var conf = msgBox("ync"
						 ,UR("Не можу зберегти документ."
						 + "\nПомістити його до списку синхронізації?|"
						 + "Не могу сохранить документ."
						 + "\nПоместить его в список синхронизации?")
						 ,UR("Збереження|Сохранение"));
		if (conf == "c")
			return false;
		if (conf == "y")
		{
			include("objects\\DpSynchronizer.js");
			var oSync = new DpSynchronizer();
			oSync.putObjectForSynchronize(this.sDocLbl,this.jDoc.getObjectID());
		}
		this.toArchive(sMode);
	}
	else
	{
		this.toArchive(sMode);
	}
	 
	*/
	
	var isCommited = true; 
		
	this.setVar("HVER",nVer + 1);
	
	var bIsSaveToXML = true;
	
	oSaveXMLAttr = this.getVar("ATTR.NOXML");
	
	if (oSaveXMLAttr != null && oSaveXMLAttr)
	{
		bIsSaveToXML = false;	
	}
	
	if (bIsSaveToXML)
	{
		if (this.syncObj == null || this.syncObj.isUpdated)
		{
			isCommited = this.jDoc.storeToXML();
		}
		else if (this.syncObj != null && !this.syncObj.isUpdated)
		{
			isCommited = false;
		}
		if (!isCommited && this.syncObj != null && !this.syncObj.isLocalObject)
		{
			
			var conf = msgBox("ync"
							 ,UR("Не можу зберегти об'єкт."
							 + "\nПомістити його до списку синхронізації?|"
							 + "Не могу сохранить объект."
							 + "\nПоместить его в список синхронизации?")
							 ,UR("Збереження|Сохранение"));
			if (conf == "y")
			{
				this.syncObj.putObjectForSynchronize(this.sDocLbl,this.jDoc.getObjectID());
			}			
		}
			
		this.toArchive(sMode);
	}
	obj2DB(this.jDoc.getObjectID(),this.jDoc, null, null, sMode!="ADD");	//в obj2DB перед инсертом выполняется удаление. чтобы ускорить добавление документа запрос на удаление не выполняется по параметру.
	this.jDoc.saveLabelsToDB();
	if (bSaveRows)
		this.saveRows();
//-------- registration
	this.doRegistration();
//---------------------
	freeObject("DOC." + this.sDocLbl,this.nNop,this.jDoc.getObjectID());
	return true;
}

function DpDoc_saveRows()
{
	if (!this.hasRows())
		return;	
	this.gotoFirstRow(); //загружаем все строки в объект
	delObjChildsFromDB(this.jDoc.getObjectID(),this.jDoc);
	do
	{
		var currChild = this.getCurrRow();
		if (currChild == null)
			continue;
		obj2DB(currChild.jDoc.getObjectID(),currChild.jDoc);
	}
	while(this.gotoNextRow())
}

function DpDoc_doRegistration(bFullReReg)
{
	if (this.oReg == null || bFullReReg)
	{
		include("objects/DpJRegistrator.js");
		this.nNop = this.getVar("HOP");
		this.oReg = new DpJRegistrator(this.sDocLbl,this.nNop,"US");
	}
	this.oReg.delRegistration(this,"U*");
	this.oReg.doRegistration(this,"*");
}

function DpDoc_addLink(sVar, oCtrl)
{
	this.arrCtrl[sVar] = oCtrl;				
}

function DpDoc_getVar(sVar)
{
	sVar = String(sVar);
	if (sVar.substring(0,4) == "EXT.")
		return this.getExt(sVar.substr(4));
	else if (sVar.substring(0,2) == "XH")
		return this.getExt(sVar.substr(2));
	return 	toScrObj(this.jDoc.getVar(sVar));
}
function DpDoc_setVar(sVar,oVal)
{
	if (sVar == "HOP")
	{
		oVal = toScrObj(oVal);		
		if (this.nNop != oVal)
		{
			this.nNop = oVal;
			this.oReg = null;
		}
	}
	if(objTypeOf(oVal)=="Date")
		oVal = new Date(oVal).getVarDate();
	
	this.jDoc.setVar(sVar,oVal);
}

function DpDoc_delete(nID,bNoErr,bDelProv)
{
	var objID = nID;
	
	if (this.jDoc.loadFromDB(Number(nID)))
	{
    	objID = this.jDoc.getObjectID();
   	 	this.nNop = this.jDoc.getVar("HOP");
   	}
   	else
   	{
   		this.jDoc.setObjectID(nID);
   	}
   	 
	this.toArchive("DEL",objID);
	if (!this.jDoc.del() && getPar("ISCLI"))
	{
		var conf = "Y";
		if (!bNoErr)
			conf = msgBox("yn",UR("Не можу видалити документ на сервері.\n"
						+ "Занести документ до списку синхронізації?"
						+ "|Не могу удалить документ на сервере.\n"
						+ "Занести документ в список синхронизации?"));
		if (conf == "y" || bNoErr)
		{
			include("objects\\DpObjectSyncronizer.js");
			var oSync = new DpObjectSyncronizer();
			oSync.putObjectForSynchronize(this.sDocLbl,nID);
		}
	}
	
	BeginTransaction(1);
	this.removeLabelsFromDB();
	this.delDocLinks(nID);	
	this.delRegistration();	
	this.delExts(nID);
	if(bDelProv || getPar("DELPROV"))
		this.delProv(nID, bNoErr);
	delObjFromDB(/*this.jDoc.getObjectID()*/nID,this.jDoc);
	CommitTrans();	
	
}

function DpDoc_delProv(nID, bNoErr)
{
	if(!nID)
		nID = this.getID();
	ExecuteSQL("delete from ^SCHET where FID_DOC="+ nID, !bNoErr);
	provToArhive("D", nID, false);
}

function DpDoc_delDocLinks(nID)
{
	var tbl = OpenTable ("select fdoc, fnop from ^cl_linkdoc where fremovechild = 1 and fdoc1 = " + sqlTo(this.sDocLbl) + " and fnop1 in(0, " + this.nNop + ")");
	for(tbl.MoveFirst();!tbl.IsEOF();tbl.MoveNext())
	{
		var childDoc = String(tbl.getValue("FDOC"));
		var childNop = Number(tbl.getValue("FNOP"));
		var tblDocs = OpenTable ("select FDOCWID from ^DOC_LINKS where FMAINWID = " + nID + " and fisparent = 1 and fdoc = " + sqlTo(childDoc) + " and fnop = " + childNop);
		for(tblDocs.MoveFirst();!tblDocs.IsEOF();tblDocs.MoveNext())
		{
			var oDoc = new DpDoc(childDoc, childNop);
			oDoc.del(Number(tblDocs.getValue("FDOCWID")), true);
			ExecuteSQL("DELETE FROM ^schet WHERE FID_DOC=" + sqlTo(Number(tblDocs.getValue("FDOCWID"))));
		}
		tblDocs.close();
	}
	tbl.close();
	
	
	
	ExecuteSQL("delete from ^DOC_LINKS where FMAINWID = " + nID + " OR FDOCWID = " + nID);
}

function DpDoc_serverDelete(nID)
{
	var objID = (nID?nID:this.jDoc.getObjectID());
	if (nID && !this.jDoc.loadFromXML(Number(objID)))
		return false;
	this.fillSynchroVars();
	objID = this.jDoc.getObjectID();
	this.nNop = this.jDoc.getVar("HOP");
	this.toArchive("DEL");
	if (!this.jDoc.del())
		return false;
	
	BeginTransaction(1);
	this.removeLabelsFromDB();
	this.delRegistration();	
	this.delDocLinks(objID);
	this.delExts(objID);
	delObjFromDB(objID,this.jDoc);
	CommitTrans();
	return true;
}

function DpDoc_delRegistration()
{
	if (this.oReg == null)
	{
		include("objects/DpJRegistrator.js");
		this.nNop = this.getVar("HOP");
		this.oReg = new DpJRegistrator(this.sDocLbl,this.nNop,"US");
	}
	
	
	this.oReg.delRegistration(this,"*");
}

function DpDoc_removeLabelsFromDB()
{
	this.jDoc.removeLabelsFromDB();
}

function DpDoc_tEval(type, expr,def, msgErr)
{
	var emptyVal, errVal, typeName;
	switch(type.toLowerCase())
	{
	case "b":
	case "bool":
	case "boolean":
		typeName = "boolean";
		emptyVal = true;
		errVal = false;
		break;
	case "str":
	case "string":
		typeName = "string";
		emptyVal = errVal = "";
		break;
	case "n":
	case "num":
		typeName = "number";
		emptyVal = errVal = 0;
		break;
	case "date":
		typeName = "date";
		emptyVal = errVal = d00;
		break;
	}

	var value;
	if(expr!=null && expr.search(/\S/)!=-1)	// есть непустые символы
	{
		value = toScrObj(this.eval(expr));
		if (typeName == "number")
		{
			if (!isNaN(value))
				value = Number(value);
		}
			
		if(this.isError || typeOf(value).toLowerCase()!=typeName)
		{
			if (typeName != "date" || !inList(typeOf(value).toLowerCase(), "timestamp","sybtimestamp"))
			{
				value = typeOf(def).toLowerCase()==typeName? def: errVal;
			}
		}
	}
	else
		value = emptyVal;

	return value;	
}

function DpDoc_createRow(sClassID)
{
	var jRow = this.jDoc.createChild(sClassID);
	if (jRow != null)
		return	new DpDocRow(this,jRow);
	else
		return null;
}

function DpDoc_getRow(sClassID, nObjectID)
{
	var jRow = this.jDoc.getChild(sClassID,nObjectID);
	if (jRow != null)
		return	new DpDocRow(this,jRow);
	else
		return null;
}

function DpDoc_copyRow(sClassID,nObjectID)
{
	var jRow = this.jDoc.getChild(sClassID,nObjectID);
	if (jRow != null)
		return	new DpDocRow(this,jRow.clone());
	else
		return null;
	
} 

function DpDoc_appendRow(sClassId, obj)
{
	if(!obj)
		return null;
	return this.jDoc.appendChild(sClassId,obj.jDocRow,obj.getID());
}

function DpDoc_deleteRow(sClassId, nObjectID)
{
	return this.jDoc.removeChild(sClassId, nObjectID)
}


function DpDoc_substVal(strText)
{
	strText = String(strText);
	var words = strText.split(" ");	  // Разбить текст на слова
	var retVal = "", tmpVal;
	for(var i=0; i<words.length; i++) // Цикл по массиву слов
	{
		if(words[i].search(/[a-zA-Z_]/)==0) // Если слово начинается с латинской буквы - это может быть переменна
		{
			this.isError = false;			
			tmpVal = this.eval(words[i]);			
			if(this.isError /*|| typeof(tmpVal)!="string"*/)
				retVal += words[i];
			else
				retVal += tmpVal;
		}
		else
			retVal += words[i];
		retVal += " ";
	}

	return retVal;
}

function DpDoc_eval(sExpr)
{
	return toScrObj(this.jDoc.eval(sExpr));
}

function DpDoc_fillSynchroVars()
{
	if (this.getVar("SYNC_DATE") == null)
		this.setVar("SYNC_DATE",new Date().getVarDate());
	if (!this.getVar("SYNC_USER"))
		this.setVar("SYNC_USER",getUserName());
	if (!this.getVar("SYNC_HOST"))
		this.setVar("SYNC_HOST",getHostName());
}

function DpDoc_toArchive(sMode,nID)
{
	if(bCreateArchive)
	{
		if (!sMode)
		{
			sMode = this.bNew?"ADD":"EDIT";
		}
		
		var m = new Object();
		m.FWID = GetUID();
		m.FDOC = this.sDocLbl;
		m.FNOP = this.jDoc.getVar("HOP");
		m.FNUM = String(this.jDoc.getVar("HNOM"));
		m.FDAT = this.jDoc.getVar("HDAT");
		m.FMACTION = sMode.charAt(0);
		m.FMDATE = (this.getVar("SYNC_DATE")
					?javaDate2Script(this.getVar("SYNC_DATE"),true)
					:new Date().getVarDate());
		m.FMUSER = (this.getVar("SYNC_USER")
					?this.getVar("SYNC_USER")
					:getUserName());
		m.FMHOST = (this.getVar("SYNC_HOST")
					?this.getVar("SYNC_HOST")
					:getHostName());
		m.FID_DOC = (nID?nID:this.jDoc.getObjectID());
		m.FVER = this.jDoc.getVar("HVER");
		
		//var archDir = getOrgPath() + "archive/" + this.sDocLbl.replace(":","_") + "/" + parseInt(this.nNop);
		//createDirectory(archDir);
		//this.jDoc.storeToXML(archDir + "/" + m.FWID + ".xml");
		
		var oDomDoc = this.jDoc.toXML().getOwnerDocument();
		lpProxy.getDBManager().saveXMLToDB("^archive", "fdata", m.FWID, oDomDoc);
		updateTable("^archive", m, false,"",true);
	}
}

function DpDoc_createTemplate()
{
	nameTmpl = input(UR("Назва|Название"), UR("Створення шаблону|Создание шаблона"),"", 50);
	if (!nameTmpl)
		return;
	var templateDir = rootDirectoryEx() + "Source/doctemplates/" + this.sDocLbl.replace(":","_");
	createDirectory(templateDir);
		
	var root = this.jDoc.toXML();	
	root.setAttribute("name", nameTmpl);
	saveXml( templateDir + "/" + GetUID() + ".xml", root.getOwnerDocument());
}

function DpDoc_listTemplate()
{
	var ret = new Array();
	var templateDir = rootDirectoryEx() + "Source/doctemplates/" + this.sDocLbl.replace(":","_");
	if (!isDir(templateDir))
	{
		return ret;
	}
	
	var dir = new DpFile(templateDir); 
	var files = dir.listFiles()
	for (var i = 0; i < files.length; i++)
	{
		var file = files[i];
		if (file.isDirectory() || !file.getName().endsWith(".xml"))
			continue;
		var tmpl = new Object();
		tmpl.ID = parseInt(String(file.getName()));
		
		var dom = openXmlFile(file.getAbsolutePath(), false);
		if (dom == null)
			continue;
		
		root = dom.getDocumentElement();
		
		if (root == null)
			continue;
			
		var name = root.getAttribute("name");
		if (!name)
			continue;
			
		tmpl.name = name;
		
		ret[ret.length] = tmpl;						
	}
		
	return ret;
}

function DpDoc_delTemplate(ID)
{
	var ret = new Array();
	var templateDir = rootDirectoryEx() + "Source/doctemplates/" + this.sDocLbl.replace(":","_");
	if (!isDir(templateDir))
	{
		return ret;
	}
	
	var file = templateDir + "/" + ID + ".xml";
	
	return deleteFile(file);
}

function DpDoc_editTemplate(ID, name)
{
	var ret = new Array();
	var templateDir = rootDirectoryEx() + "Source/doctemplates/" + this.sDocLbl.replace(":","_");
	if (!isDir(templateDir))
	{
		return false;
	}
	
	var file = templateDir + "/" + ID + ".xml";
	
	if (!isFile(file))
		return false;
	
	include ("Objects/DpXMLDomDocument.js");
	var oDom = new DpXMLDOMDocument();
	if(!oDom.load(file))
		return false;
	
	root = oDom.getDocumentElement();
	
	if (root == null)
		return false;
		
	root.setAttribute("name", name);
	oDom.save(file);
	
}

function DpDoc_fromArchive(nID, nIDArch)
{
	var oSnap = getSnap("SELECT FWID,FMDATE,FNOP FROM ^archive"
					  + " WHERE FID_DOC=" + sqlTo(nID)
					  + " AND FDOC=" + sqlTo(this.sDocLbl)
					  + (nIDArch? (" AND FWID = " + nIDArch):"")
					  + " ORDER BY FMDATE DESC");
	if (oSnap == null)
		return null;
	var fwid = oSnap[0];
	var fnop = Number(oSnap[2]);
	
	
	var isLoaded= false;
	
	var oDomDoc = lpProxy.getDBManager().getXMLFromDB("^archive", "fdata", fwid);
	if (oDomDoc)
	{
		isLoaded = this.jDoc.fromXML(oDomDoc.getDocumentElement());   
	}
	
	if(!isLoaded)
	{
		var archDir = getOrgPath() + "archive/" + this.sDocLbl.replace(":","_") + "/" + parseInt(fnop);	
		if (!this.jDoc.loadFromXML(archDir + "/" + fwid + ".xml"))
		{
			return null;
		}
	}
	
	this.nNop = fnop;
	return javaDate2Script(oSnap[1],true);	
}


// Net 10.04.2009  научил возвращать через tblSootv
// таблицу соответствия старых и новых фидов. пригодится, когда 
// кроме таблицы строк документа используются еще куча, например шахматка,
// и требуется перебить фиды еще в нескольких таблицах
// От вызывающей стороны требуется создать таблицу
	// FWID - number(10)
	// NEW_FWID - number(10)
// При "обычном" вызове с 3-мя параметрами отрабатывает по-старому

// Net 16.09.2009  надо научить перебивать, чтобы сохранялась древовидная структура!!!
function DpDoc_resetFnids(tbl,sRowId,oDoc,tblSootv)
{
	if (!oDoc) 
		oDoc = this;
	tbl.MoveFirst();
	var sIDFld = "";

	//Tori 30.09.2010: по умолчанию ставим FID_DOC, но будем определять по reffld из dbmapping.xml
	var sIDFld = "FID_DOC";
	var rowTblAr = oDoc.getJObject().getDefaultMapper().rowsTables.toArray();
	if(rowTblAr.length>0)
		sIDFld = rowTblAr[0].reffld;

	var isSootv = (!(typeof(tblSootv) == "undefined"));

	while(!tbl.isEOF())
	{
		var nID = tbl.getRowID();
		
		oDocRow = oDoc.copyRow(sRowId,nID);
		if(!oDocRow)
			break;
		oDoc.deleteRow(sRowId,nID);
		oDoc.appendRow(sRowId,oDocRow)				
		var rowID = oDocRow.getID();
		tbl.Edit()
		tbl.setValue("FWID", rowID);
		tbl.setValue(sIDFld, oDoc.getID());
		tbl.Update();

		if (isSootv)
		{
			strSQL = " INSERT INTO " + tblSootv
					+" (FWID, NEW_FWID) "
					+" VALUES (" + sqlTo(nID) + ", " + sqlTo(rowID) + ")"
			ExecuteSQL(strSQL);
		}
//		obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,"TMP_EXHIBCOMPS");
		//скопируем расширения строк
		oDocRow.saveExtToDB();
		tbl.MoveNext();
	}
	
	tbl.requery();
}

function DpDoc_getVarInfo(sVar)
{
	return this.jDoc.getVarInfo(sVar);
}

function DpDoc_getVarsInfo()
{
	return this.jDoc.getVarsInfo();
	
}

function DpDoc_instanceOf(sClassID)
{
	return toScrObj(this.jDoc.instanceOf(sClassID));
}


function DpDoc_getDataDir()
{
	return this.jDoc.getDataDir();
}

function resaveAllDoc(sLBL, oPar)
{
    var oDoc = new DpDoc(sLBL);
    if( !oPar) oPar = new Object();
/*
	var file = new DpFile(getOrgPath() + "data\\" + oDoc.getDataDir());
	if (!file.exists()) return;
	var files = file.listFiles();
	for (var i = 0; i < files.length; i++)
*/
	var bDate = (oPar.bdate?oPar.bdate:(new Date()).getTime());
	var eDate = (oPar.edate?oPar.edate:(new Date()).getTime());
/*	
	if 
	{
		var doc = files[i];
		var sName = String(doc.getName());
		if (sName.right(4) != ".xml") continue;
		var nID = Number(sName.substr(0,sName.length - 4));
		
		if(isNaN(nID)) continue;
		var dMod = new Date(doc.lastModified())

		if (oPar.bdate && dMod < oPar.bdate) continue;
		if (oPar.edate && dMod > oPar.edate) continue;
			
		
		//alert(doc.getName() + "\n" + format("dd.mm.yyyy", dMod));
*/
		var arrID = lpProxy.getDocumentIDs(sLBL,bDate,eDate);
	for (var nArr in arrID)
	{
		var nID = arrID[nArr];
		oDoc.loadByID(nID);
		
		obj2DB(nID, oDoc.jDoc);		
		if (oPar.withReg)
			oDoc.doRegistration();
	}
	
}

function DpDoc_hasRows()
{
	return this.jDoc.hasChilds();
}

function DpDoc_gotoFirstRow()
{
	return this.jDoc.gotoFirstChild();
}

function DpDoc_gotoNextRow()
{
	return this.jDoc.gotoNextChild();
}

function DpDoc_gotoPrevRow()
{
	return this.jDoc.gotoPrevChild();
}

function DpDoc_getCurrRow()
{
	var jRow = this.jDoc.getCurrChild();
	if (jRow == null)
		return null;
	if (this.currRowCash == null)
	{
		this.currRowCash = new DpDocRow(this,jRow);
	}
	else
	{
		//this.currRowCash.clear();
		if (this.currRowCash.extTbl!= null)
		{
			this.currRowCash.extTbl.close();
			this.currRowCash.extTbl = null;
		}
		this.currRowCash.sClassId = jRow.getClassID();		
		var eval = new DpEval();
		this.currRowCash.jDocRow = jRow;
		this.currRowCash.jDoc = jRow;
		this.currRowCash.jDocRow.setEvaluator(eval);
		
	}
	
	return this.currRowCash;
}

function DpDoc_setDocID(nID)
{
	if (!isNaN(Number(nID)) && this.jDoc != null)
		this.jDoc.setObjectID(nID);
		
}

function DpDoc_setAttribute(sAttrName, attrValue)
{
	this.jDoc.setAttribute(sAttrName, attrValue);
}

function DpDoc_getAttribute(sAttrName)
{
	return this.jDoc.getAttribute(sAttrName);
}

function DpPers_createRang()
{
	var jRow = this.jDoc.createChild("rang");
	if (jRow != null)
		return	new DpDocRow(this, jRow);
	else
		return null;
}

function DpPers_addRang(obj)
{
	this.jDoc.addRangPosition(obj.getID(), obj.jDocRow);
}

function DpPers_removeRang(sObjectID)
{
	this.jDoc.removeRangPosition(sObjectID)
}

function DpPers_getRang(sObjectID)
{
	var jRow = this.jDoc.getRangPosition(sObjectID);
	if (jRow != null)
		return	new DpDocRow(this, jRow);
	else
		return null;
}

function DpPers_createPrk()
{
	var jRow = this.jDoc.createChild("prk");
	if (jRow != null)
		return	new DpDocRow(this, jRow);
	else
		return null;
}

function DpPers_addPrk(obj, sIdRang)
{
	if(null == sIdRang)
		sIdRang = "";
		
	this.jDoc.addPrk(obj.getID(), obj.jDocRow, sIdRang);
}

function DpPers_removePrk(sObjectID, sIdRang)
{
	if(null == sIdRang)
		sIdRang = "";

	this.jDoc.removePrk(sObjectID, sIdRang);
}

function DpPers_getPrk(sObjectID, sIdRang)
{
	if(null == sIdRang)
		sIdRang = "";

	var jPrk = this.jDoc.getPrk(sObjectID, sIdRang);
	if (jPrk != null)
		return	jPrk;
	else
		return null;
	
}

function DpDoc_clear()
{
	this.bNew = true;
	this.currRowCash = null;
	if (this.jDoc != null)
		this.jDoc.Clear();
		
	this.jDoc.setVar("HDOC",this.sDocLbl);	
	//this.jDoc.setVar("HOP",this.nNop);		
	
	if("COM.DEBET.CDR.PF" == this.sDocLbl.toUpperCase())
		return
	
	this.arrRegNums = null;
	if (this.extTbl != null)
		this.extTbl.close();	
	this.extTbl = null;
	this.fillDefVars();
}

function DpDoc_print(sFormLbl)
{
	if (!this.printSelect)
	{
		include("objects\\DpPrintSelect.js");
		this.printSelect = new DpPrintSelect();
	}
	
	var forms = this.printSelect.getForms(true,true);
	var frmInf = null;
	for (var nFrm = 0; nFrm < forms.length; nFrm++)
	{
		if (sFormLbl == forms[nFrm].sFormLabel)
		{
			frmInf = forms[nFrm];
			break;
		}
	}
	if (frmInf == null)
		return;

	include("objects\\DpTVars.js");
	var vars = new DpTVars("DOC",this.sDocLbl,true);	
	vars.eval.setJDoc(this);
	if (this.hasRows())
	{
		var childId = String(this.getChildIDs()[0]);
		if (this.docList == "DN")
		{	
			vars.eval.setRowTable(this.jDoc.getRowTable(childId, "RSTAT"));
		}					
		else if (this.docList != "AO")
		{	
			if(this.docList == "BILDOG")
				vars.eval.setRowTable(this.jDoc.getRowTable("PACK"));
			else if(this.docList == "RU" || this.docList == "SU")
				vars.eval.setRowTable(this.jDoc.getRowTable(childId, "RORG"));
			else
				vars.eval.setRowTable(this.jDoc.getRowTable(childId, "RNOM"));
		}				
		else
		{
			vars.eval.setRowTable(this.jDoc.getRowTable("AOROW", "RNOM"));
		}
	}
	vars.setForm(frmInf);
	vars.eval.setForm("DOC",this.sDocLbl);
	vars.setDoc(this.sDocLbl,this.getVar("HOP"));
	vars.print();
}

function DpDoc_getOName()
{
	var oSnap = getSnap("select FTXT from ^cl_lnk "
					+" where FDOC="+ sqlTo(this.sDocLbl)
						+" and FNOP="+ sqlTo(this.getVar("HOP"))
					, false);
	if(!oSnap || !oSnap[0] || String(oSnap[0]).trim()=="")
		return this.getName();
	return oSnap[0];
}

function DpDoc_setCtrlLinker(ctrlLinker)
{
	this.ctrlLinker = ctrlLinker;
	if (this.autoNo)
		this.autoNo.setCtrlLinker(ctrlLinker);
}

function DpDoc_getCtrlLinker()
{
	return this.ctrlLinker;
}

function DpDoc_getTableName()
{
	if (this.tableName)
		return this.tableName;  
	
	
	var mapper = this.jDoc.getDefaultMapper();
	if (!mapper)
		return null;
	
	var aTables = mapper.getTables();
	if (aTables.size() == 0)
		return null;
		
	this.tableName = String(aTables.get(0).name); 
	return this.tableName;
}

function DpDoc_getFieldName(sVar, sTable)
{
	var sFldName = "";
	//var varsInfo = this.getVarInfo(sVar);
	var mapper = this.jDoc.getDefaultMapper();
	if(!mapper)
		return sFldName;
	
	var fields = mapper.getFields();
	if(fields.size() == 0)	
		return sFldName;
	
	if(!sTable)
		sTable = this.getTableName();
	
	sTable = String(sTable).toUpperCase();
	sVar = String(sVar).toUpperCase();
	
	for(var i=1; i < Number(fields.size()); i++)
	{			
		var fld = fields.get(i);
		
		var sVarName = String(fld.varName).toUpperCase();		
		sTblName = String(fld.table).toUpperCase();
		if (sVarName == sVar)
		{ 
			sFldName = String(fld.name).toUpperCase();
			if (sTblName == sTable)
				return sFldName;
		}
	}
	return sFldName;
}

function DpDoc_getFieldsByVar(sVarName)
{
	return this.jDoc.getFieldsByVar(sVarName);
}

function DpDoc_getOrgField()
{
	var sOrgVar = this.getVar("attr.FLDORG");
	if(!sOrgVar)
		return "";
	return this.getFieldName(sOrgVar);
}

function DpDoc_getJObject()
{
	return this.jDoc;
}

function restoreDocArchive(docLbl, nNop)
{
	
	var objDoc = new DpDoc(docLbl, nNop)
	
	var sDocTbl = objDoc.getTableName();
	
	var sSQL = "SELECT fver, fwid FROM ^" + sDocTbl + " doc " 
		+ " WHERE fdoc =  " + sqlTo(docLbl)
		+ (nNop ? (" AND FNOP = " + nNop) : " ") 
		+ " AND NOT EXISTS " 
			+ "(SELECT * FROM ^archive a WHERE a.fid_doc = doc.fwid AND doc.fver = a.fver)"; 
	
	var tbl = OpenTable(sSQL);
	
	var progress = getProgressMonitor();
	progress.beginTask(UR("Вiдновлення архiву...|Востановление архива..."),tbl.recordCount);
	while (!tbl.isEOF())
	{
		bLoaded = objDoc.getJObject().loadFromDB(tbl.getValue("FWID"));
		if (bLoaded)
		{
			objDoc.toArchive();
		}
		
		objDoc.clear();
		tbl.MoveNext();
		progress.worked(1);
	}
	progress.done();
}

function DpDoc_hasLabel(lblClass, value)
{
    return this.jDoc.hasLabel(lblClass, value);
}

function DpDoc_getLabel(lblClass, value)
{
    return this.jDoc.getLabel(lblClass, value); 
}

function DpDoc_addLabel(lblClass, value)
{
	this.jDoc.addLabel(lblClass, value);        
}

function DpDoc_removeLabel(lblClass, value)
{
    return this.jDoc.removeLabel(lblClass, value);
}

function DpDoc_removeAllLabels()
{
	this.jDoc.removeAllLabels();
    
}

function DpDoc_getAllLabels()
{
    return this.jDoc.getAllLabels();
    
}

function DpDoc_getLabelClasses()
{
	var ret = new Array();
	include ("Objects/DpLabel.js")
	
	var arrLbl = new DpLabel().getLabelsForDoc(this.getVar("HDOC"), 0);
	var lblIDs = new Array();
	for (var i = 0; i < arrLbl.length; i++)
	{
		var oLbl = arrLbl[i];
		lblIDs[String(oLbl.getID())] = true;
		ret[ret.length] = oLbl;
	}
	
	
	arrLbl = new DpLabel().getLabelsForDoc(this.getVar("HDOC"), this.getVar("HOP"));
	for (var i = 0; i < arrLbl.length; i++)
	{
		var oLbl = arrLbl[i];
		if(!lblIDs[String(oLbl.getID())])
			ret[ret.length] = oLbl;
	}
	
	
	return ret;

}
