
function DpDoc_calculate()
{
	// объект - список калькуляций
	if (!this.calculations)
	{
		include("objects\\DpCalculations.js");
		this.calculations = new DpCalculations(this.sDocLbl);
	}
	
	var mFcalc = this.calculations.getCalculationGroup(this.getVar("HOP"));
	
	if(mFcalc==0)
		return;

	var oCalcGroup = this.calculations.listGroups()[mFcalc];
	
	if (!oCalcGroup)
	{
		trace("!!!!!!!!!! нету калькуляции " + mFcalc + " - " + this.sDocLbl);
		return;
	}
	
	// Проверка условия выполнения группы калькуляций + наличие самих калькуляций
	if (oCalcGroup.getCalculationsCount() > 0 && this.tEval("bool",oCalcGroup.sCondition))
	{
		var isRowChange = false;
		var isRowExtChange = false;
		var isHeaderExtChange = false;
		// Калькуляции отсортированы по номеру калькуляции
		var calcList = oCalcGroup.listCalculationsOrdered();
		for (var iCalc = 0; iCalc < calcList.length; iCalc++)
		{
			//- получаем значения параметров калькуляции (описаны в DpCalculations.js)
			var currCalc = calcList[iCalc];
			var fvar = String(currCalc.sVAR).toUpperCase();
			var fvalue = currCalc.sVALUE;
			var fact = currCalc.sACT;
			var fweight = currCalc.sPROPORTION;
			var ffilt = currCalc.sFILTER;
			var fif = currCalc.sCondition;
			var fnom = currCalc.nNum;
			var fdecimal = currCalc.nSIGN;
			var fkoef = "1";
			
			
			// условие выполнения калькуляции
			if(!this.tEval("b", fif))
				continue;

			var retCode = true;
			// Определение выражения для записи переменной
			// в общем-то сейчас интересуют только стандартные переменные документа
			if(fvar.substr(0,2)=="XH")	// расширение заголовка
			{
				isHeaderExtChange = true;
			}
			else if(fvar.substr(0,2)=="XR")  // расширение строки
			{
				isRowExtChange = true;
			}
			else if (fvar.substr(0,4) == "EXT.")
			{
				isHeaderExtChange = true;
			}
			else	// обычная переменная документа
			{
				// задача - получить коефициент для стандартной переменной документа
				
				if (fvar.substr(0,1) == "H")
				{
					retCode = (this.jDoc.getVarInfo(fvar) != null);
					fkoef = this.getAttr("KOEF." + fvar);
				}
				else if (fvar.substr(0,1) == "R")
				{
					isRowChange = true;
					//fruckt
					//у документа может быть несколько таблиц строк
					//или сроки с id не "ROW"
					//var chld = this.jDoc.createChild("ROW");
					var childIDs = this.jDoc.getChildIDs();
					for (var i in childIDs)
					{
						var chld = this.jDoc.createChild(childIDs[i]);
						if (chld && chld.getVarInfo(fvar) != null)
						{
							retCode = (chld.getVarInfo(fvar) != null);
							fkoef = chld.getAttr("KOEF." + fvar);
							chld = null;
							break;
						}
						chld = null;
					}
				}
				else
					retCode = false;
				if(retCode)
				{
					if(fkoef==null || fkoef=="")
						fkoef = "1";
				}
			}
			if(!retCode)
			{
				alert("Нет переменной, для которой указана калькуляция:"
					+ fvar );
				break;
			}
			
			if(fvar.substr(0,1)=="H" || fvar.substr(0,2)=="XH")
			{
				var value = this.eval(fvalue);
				if(typeof(value)=="number")
					value = round(value, fdecimal);
				varWrite(this,fvar,fact,value);
			}
			else if((fvar.substr(0,1)=="R" || fvar.substr(0,2)=="XR")
					&& (!fweight || fweight == ""))
			{
				if(this.gotoFirstRow())
				{
					while(this.gotoNextRow())
					{
						var currRow = this.getCurrRow();
						if(currRow.tEval("b", ffilt))
						{
							var value = currRow.eval(fvalue);
							if(typeof(value)=="number")
								value = round(value, fdecimal);
							varWrite(currRow,fvar,fact,value);
						}
					}
				}
			}
			// Калькуляция переменных при наличии весов
			// значение (fvalue) не может содержать переменные строк
			else if((fvar.substr(0,1)=="R" || fvar.substr(0,2)=="XR"))
			{
				// Сумма может быть разбросана по строкам
				// только при наличии таковых (строк)
				if (this.gotoFirstRow())
				{
					var sumWeight = 0;
					var fValue = this.tEval("n", fvalue);
					while(this.gotoNextRow())
					{
						var currRow = this.getCurrRow();
						if(currRow.tEval("b", ffilt))
							sumWeight += currRow.eval(fweight);
					}

					var sumValue = 0;
					if(sumWeight!=0)
					{
						var aFound = new Array();
						this.gotoFirstRow();
						while(this.gotoNextRow())
						{
							var currRow = this.getCurrRow();
							if(!currRow.tEval("b", ffilt))
								continue;
							var weight = currRow.eval(fweight);
							var koef = currRow.eval(fkoef);
							// var koef = (fkoef? tblRow(fkoef): 1); - так нельзя
							if(koef==0)
								continue;
							var value = fValue * weight / sumWeight / koef;
							value = round(value, fdecimal);
							sumValue += value * koef;
							varWrite(currRow,fvar,fact,value);
							var rec1 = new Object();
							rec1.bookmark = currRow.getID();
							rec1.value = currRow.eval(fvar);
							if(typeof rec1.value!="number")
								rec1.value = 0;
							rec1.koef = koef;
							aFound[aFound.length] = rec1;
						}
						aFound.sort(new Function("r1", "r2",
							"return r2.value - r1.value"));
						
						for(i=0; fValue!=sumValue && i<aFound.length; i++)
						{
							var addCena = round((fValue-sumValue)/aFound[i].koef, fdecimal);
							if(addCena!=0)
							{
								var currRow = this.getRow("ROW",aFound[i].bookmark);
								varWrite(currRow,fvar,"+",addCena);
								sumValue += addCena * aFound[i].koef;
							}
						}
						if(fValue!=sumValue)
						{
							// Надо бы расшифровать
							WAIT( "Осталась ошибка округления "
								+ round(fValue-sumValue, 6)
								+ " при калькуляции переменной " + fvar
								+ "\n Калькуляция N " + mFcalc
								+ ", строка N " + fnom );
						}
					}
				}
			}
			else
				debug("Переменная " + fvar + " не может быть калькулируемой");
		}
		
		if(isRowExtChange)
		{
			this.gotoFirstRow();
			while(this.gotoNextRow())
			{
				var currRow = this.getCurrRow();
				currRow.saveExtToDB();
			}
		}
		
		if(isRowChange)
		{
			this.saveRows();
		}
		
		if (isHeaderExtChange )
			this.saveExtToDB();
	}
}

function varWrite(obj,sVar,sAct,oVal)
{
	var varValue = null;
	var sExt = null; 
	
	if (sVar.toUpperCase().startsWith("XR") ||  sVar.toUpperCase().startsWith("XH"))
	{
		sExt = sVar.substring(2);
		varValue = obj.getExt(sVar);
	}
	
	//для того, чтоб не приводило к String
	varValue = toScrObj(obj.getVar(sVar));
	oVal = toScrObj(oVal)

	sAct = String(sAct);
	switch(sAct)
	{
		case "+":
			varValue += oVal;
			break;
		case "-":
			varValue -= oVal;
			break;
		case "=":
			varValue = oVal;
			break;
	}
	if (sExt)
	{
		obj.setExt(sExt,varValue);
	}
	else
	{
		obj.setVar(sVar,varValue);
	}
}