var DpAPI = lpProxy.getDpAPI();

function DpDocDef()
{
	this.fixedVars = new Object();
	this.getDefPath = DpDocDef_getDefPath;
	this.fillDefVars = DpDocDef_fillDefVars;
	this.isFixedVar = DpDocDef_isFixedVar;
	this.arrVarDef = new Array();
	
	this.fillUsrVars = DpDocDef_fillUsrVars;
	this.isSetDefault = DpDocDef_isSetDefault;
}

function DpDocDef_fillUsrVars()
{
	/*
	var start = new Date();
	var tbl = OpenTable("s"
			, " SELECT FVAR,FTYPE,FEXPR"
			+ " FROM ^vardoc"
			+ " WHERE FDOC=" + sqlTo(this.sDocLbl)
			+ " AND (FNOP=" + sqlTo(this.nNop)
			+ " OR "
			+ (this.nNop?" FNOP=" + sqlTo(0):"1<>1")
			+ ")"
			+ " AND FDEFA<>" + sqlTo(true));
	for (tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
	{
		var sVAR = tbl.getValue("FVAR");
		var sEXPR = tbl.getValue("FEXPR");
		var sTYPE = String(tbl.getValue("FTYPE"));
		var nType = (sTYPE == "D"?3:(sTYPE == "L"?5:(sTYPE == "N"?2:1)));
		
		this.jDoc.addVar(sVAR,nType,true,sEXPR,null);
	}
	tbl.close();
	*/
	DpDocDef_loadUserVars(this, 0);
	DpDocDef_loadUserVars(this, this.nNop);
	
}

function DpDocDef_loadUserVars(oDoc, nNop)
{
	include ("objects/DpXMLDomDocument.js");
	var sDoc = oDoc.sDocLbl;
	var sPath = getOrgPath() +"settings/docvars/"+ String(sDoc).toUpperCase() +"/";
	var sFile =  sPath + nNop +".xml";
	if(!isFile(sFile))
		return;
		
	var xmlDom = new DpXMLDOMDocument();
	xmlDom.load(sFile);
	var root = xmlDom.getDocumentElement();
	var header = root.getElementsByTagName("header")[0];
	var vars = header.getChildNodes();	
	for(var i = 0; i < vars.length; i++)
	{
		var eVar = vars[i];	
		var sVAR = eVar.getNodeName();
		var sEXPR = eVar.getAttribute("expr");
		var sTYPE = String(eVar.getAttribute("type"));
		var nType = (sTYPE == "D"? 3:(sTYPE == "L"? 5:(sTYPE == "N"? 2:1)));
		
		oDoc.jDoc.addVar(sVAR, nType, true, sEXPR, null);
	}
	
	var row = root.getElementsByTagName("row")[0];
	if(row)
	{
		vars = row.getChildNodes();	
		for(var i = 0; i < vars.length; i++)
		{
			var eVar = vars[i];		
			var sVAR = eVar.getNodeName();
			var sEXPR = eVar.getAttribute("expr");
			var sTYPE = String(eVar.getAttribute("type"));
			var nType = (sTYPE == "D"? 3:(sTYPE == "L"? 5:(sTYPE == "N"? 2:1)));
		
			oDoc.jDoc.addChildVar(sVAR, nType, true, sEXPR, null);
		}
	}
}

function DpDocDef_isFixedVar(sVar)
{
	sVar = String(sVar).toUpperCase();
	return typeof(this.fixedVars[sVar]) != "undefined";
}

function DpDocDef_getDefPath()
{
	var dirs = getOrgPath()
			 + "settings/vardef/" + (this.sDocLbl.toUpperCase().replace(":", "_")) 
			 + "/" + parseInt(this.nNop)+ "/";
	createDirectory(dirs);
	return dirs + "vardef.xml";
}

function DpDocDef_fillDefVars()
{
	this.arrVarDef = new Array();
	var sFile = this.getDefPath();
	if (!isFile(sFile))
		return;
		
	var defDoc = openXmlFile(sFile);
	var root = defDoc.getDocumentElement();
	var varArr = this.getVarsInfo();
	
	for (var nVar = 0; nVar < varArr.length; nVar ++)
	{
		var currVar = varArr[nVar];
		if (currVar.isDef != true)
			continue;
		var sVarName = String(currVar.name).toUpperCase();
		varEl = Packages.com.sun.org.apache.xpath.internal
					.XPathAPI.selectSingleNode(root,sVarName);
		if (varEl == null)
			continue;
		var bCanEdit = "false" != varEl.getAttribute("canedit");
		var sContent = varEl.getTextContent();
		var nVarType = currVar.dataType;
		var oVal = DpAPI.str2Obj(sContent,nVarType);
		this.arrVarDef[sVarName] = true;
		this.setVar(sVarName,oVal);
		if (!bCanEdit)
			this.fixedVars[sVarName] = true;
	}
}

function DpDocDef_isSetDefault(sVarName)
{
	if (this.arrVarDef[sVarName])
		return true;
	return false;
}