include ("objects\\DpXMLDomDocument.js");
include("Objects/DpJRegistrator.js");
function DpDocList(sDocLbl, nNop, list)
{
	this.sDocLbl = sDocLbl;
	if (!nNop) 
		this.nNop = 0;	
	else
		this.nNop = nNop;	
	this.list = list;
	this.getGrid = DpDocList_getGrid;
	this.getAction = DpDocList_getAction;
	
	var n = sDocLbl.indexOf(":");
	if (n != -1)
	{
		var moduleID = sDocLbl.substr(0, n);
		this.sDocPath = lpProxy.getModulePath(moduleID) + "/scripts/docs/" + sDocLbl.substr(n + 1);		
	}
	else
	{
		this.sDocPath = rootDirectory() + "docs/" + sDocLbl;
	}
	
	
	
	this.listInfoFile = this.sDocPath+"/list.xml";
	this.sScriptFile = this.sDocPath+"/list.js";
	if (isFile(this.sScriptFile))
		include(this.sScriptFile);
	
	this.load = DpDocList_load;
	this.buildQuery = DpDocList_buildQuery;
	this.getCaption = DpDocList_getCaption;
	this.subTie = DpDocList_subTie;
	this.loadUserList = DpDocList_loadUserList;
	this.loadSubList = DpDocList_loadSubList;
	this.parseTie = DpDocList_parseTie;
	this.parseGrid = DpDocList_parseGrid;
	this.dat1 =getPar("globDat1");//d00min;
	this.dat2 = getPar("globDat2");//d00;
}

function DpDocList_load()
{
	this.docDataDir = getOrgPath() + "data/docs/" + this.sDocLbl;
	
	if(!isFile(this.docDataDir))
	{
		createDirectory(this.docDataDir)
	}
	this.tblFdr = OpenTable("s","SELECT * FROM ^cl_lnk WHERE fdoc = "
			+ sqlTo(this.sDocLbl) + " AND fnop in (" + this.nNop +")") 
	
	//this.listInfoFile = this.sDocPath+"\\doclist.xml";
	var xmlDom = new DpXMLDOMDocument();
	xmlDom.load(this.listInfoFile);
	this.listInfo = xmlDom.getDocumentElement();
	this.loadUserList();
	return true;
	
}

function DpDocList_buildQuery()
{
	var xmlq = this.listInfo.getElementsByTagName("query")[0];
	if (!xmlq) return false;
	var xmlfrom = xmlq.selectSingleNode("from");
	var sHTbl = xmlfrom.getText();
	var sFields = "*"; 
	xmlFields = xmlq.selectSingleNode("fields");
	if (xmlFields)
	{
		sFields = xmlFields.getText();
	}
	
	//fruckt - проверим какую надо сделать сортировку
	//скорее всего понятие сортировки в настройке папки документов уже не существует
	/*
	var strSQL = " SELECT"
					+" FNUMSORT"
				+" FROM"
					+" ^CL_LNK"
				+" WHERE FDOC = " + sqlTo(this.sDocLbl)
	if (!isEmpty(toScrObj(this.nNop)))
	{
		strSQL += " AND FNOP = " + this.nNop;
	}

	var aSnap = getSnap(strSQL);
	var isNumSort = false;
	if (!isEmpty(toScrObj(aSnap)))
	{
		isNumSort = aSnap[0];
	}
	
	if (isNumSort)
	{
		if (SUBD==ORACLE)
		{
			var sOrder = "FDOC_DAT, decode(translate(trim(FDOC_NUM), '_0123456789', '_'), null, to_number(trim(FDOC_NUM))), trim(FDOC_NUM)";
		}
		else
		{
			var sOrder = "FDOC_DAT, FDOC_NUM"; 
		}
	}
	else
	{
		var sOrder = "FDOC_DAT, FDOC_NUM"; 
	}
	*/
	
	//vlad 06.11.2012
	//Большинству пользователей необходима сортировка по номеру документа "как число", а не "как строка"
	//var sOrder = "FDOC_DAT, FDOC_NUM";
	var sOrder = "FDOC_DAT, "+SqlRight(SqlConCat(sqlTo("0000000000000000000000000"),"FDOC_NUM"), 25);

	xmlOrder = xmlq.selectSingleNode("order");
	if (xmlOrder)
	{
		sOrder = xmlOrder.getText();
	}
	var sWhere = "FDOC = " + sqlTo(this.sDocLbl);
	
	if (this.nNop!=null && this.nNop!=0)	
	{
		sWhere += " AND FNOP in (" + this.nNop +")";
	}
		
	if (this.list.par.arrDocs)
	{
		sWhere += " AND FWID in (" + this.list.par.arrDocs + ") ";
	}
	else if (this.list.par.fid_doc)
	{
		
		sWhere += " AND FWID = " + this.list.par.fid_doc;
	}
	else
	{
		var gd = new Object();
		if (typeof(DOC) != "undefined" && typeOf(DOC) == "DpTextEx")
		{
			gd.dat1 = DATB.value;
			gd.dat2 = DATE.value;
		}
		else
		{
			include ("objects\\DpGetDat.js");
			var gd = new DpGetDat("dD");
			if (gd.escape) return false;	
		}
		if(differ(gd.dat1, d00)<0)		
			sWhere += " AND FDOC_DAT >= " +sqlTo(gd.dat1)
		sWhere += " AND FDOC_DAT <= " +sqlTo(gd.dat2); 
		
		this.dat1 = gd.dat1
		this.dat2 = gd.dat2;
	}
	if (this.list.par.subWhere)
	{
		var subWhere = this.list.par.subWhere;
		if(typeof subWhere == "function")
			subWhere = this.list.par.subWhere();
		sWhere += " AND ("+ subWhere +")";
	}

	if(list.oOrg && list.oOrg.getCod()!=0)
	{
		var fldOrg = "FORG";
		var oDoc = this.list.oDoc;
		if(!oDoc)
			oDoc = new DpDoc(this.sDocLbl, this.nNop);
		var orgVar = oDoc.getAttr("FLDORG");
		if(orgVar)
		{			
			fldOrg = oDoc.getFieldName(orgVar);
		}
		else
		{
			include("sys/docinfo.js");
			fldOrg = docinfo("FLDORG", this.sDocLbl);
		}
		if(fldOrg)		
			sWhere += " AND "+ fldOrg +"="+ sqlTo(list.oOrg.getCod());
	}
	
	var isOnlyMy = false;
	
	if (typeof(ONLYMY) != "undefined" && typeOf(ONLYMY) == "DpCheck")
	{
		if (toScrObj(ONLYMY.checked))
			isOnlyMy = true;
	}
	
	if (String(getAccess(this.sDocLbl)).indexOf("O") == -1)
		isOnlyMy = true;
	
	if (isOnlyMy)
		sWhere += " and fwid in (select fid_doc from ^archive where upper(fmuser) = " + sqlTo(getUserName().toUpperCase()) + ")";
	

	
	this.list.qryFields = sFields;
	this.list.qrySet(
					"From", "^" + sHTbl,
					"Order", new Array(sOrder),
					"Where",sWhere
				);
	/*
	if(this.list.oDoc.instanceOf("COM.DEBET.DOGOVOR"))
	{
		this.list.qrySet(
						"WhereArr", new Array("FCLOSE="+ sqlFalse, "FCLOSE<>"+ sqlFalse),
						"WhereArrName", new Array("Відкриті|Окрытые", "Закриті|Закрытые"),
						"WhereArrI", 0
						);
	}
	*/ 
/*
	var oRegU = new DpJRegistrator(this.sDocLbl,this.nNop,"U");
	var oRegS = new DpJRegistrator(this.sDocLbl,this.nNop,"S");
	var arrJS = oRegS.listJournals(true);
	var arrJU = oRegU.listJournals(true);
	var regJ = oRegU.listRegJournals(true);
	var arrRegJ = new Array();
	for (var jID in regJ)
	{
		arrRegJ.push(jID);
	}
	if (arrRegJ.length > 0)
	{
		for (var jID in regJ)
		{
			if (!arrJS[jID])
			{
				continue;
			}
			this.list.subTie(arrJS[jID].getFullTableName(),"DR"+String(jID),"HID_DOC","FWID");
		}
	}
*/				
	return true;
	 
}

function DpDocList_getCaption()
{
	return this.tblFdr.getValue("FTXT");
}

function DpDocList_subTie()
{
	this.list.extTie("H", this.sDocLbl, this.nNop);
	
	this.list.subTie("CONTRACT", "CNTRCT", "FWID", "FID_DOG");
	this.list.clTie("org0", "="+ getPar("CODMYORG") +",FORG0", "clorg0");
	if (this.nNop != 0)
		this.list.extTieEx("ext0","FWID","H",this.sDocLbl);

	this.parseTie(this.listInfo);
	if(this.subList)
		this.parseTie(this.subList);
	if(getPar("VIEW_CL2_EXT"))	//показывать расширения контрагентов
	{
		var oDoc = this.list.oDoc;
		if(!oDoc)
			oDoc = new DpDoc(this.sDocLbl, this.nNop);
		var sOrgFld = oDoc.getVar(oDoc.getVar("ATTR.FLDORG"));
		if(sOrgFld)
		{
			this.list.subTie("CLRELCLCL", "xrelclcl", "CLCOD", "=0,"+ sOrgFld);
			this.list.extTieEx("xorg", "xrelclcl.FWID_CL", "CL", 0);
		}
	}
}

function DpDocList_parseTie(xmlDoc)
{
	var xmlTies = xmlDoc.getElementsByTagName("ties")[0];
	if(!xmlTies) 
		return;
	var ties = xmlTies.getChildNodes();
	for(var i = 0; i < ties.length; i++)
	{
		var tie = ties[i];
		if (tie.getNodeName() == "cltie")
		{
			var sAlias = tie.getAttribute("alias");
			var sFields = tie.getAttribute("fields");
			var sVspAlias = tie.getAttribute("vspalias");
			if (sVspAlias)
			{
				this.list.clTie(sAlias, sFields, sVspAlias);
			}
			else
			{
				this.list.clTie(sAlias,sFields);
			}
		}
		
		if (tie.getNodeName() == "tie")
		{
			var sTable = tie.getAttribute("table");
			var sAlias = tie.getAttribute("alias");
			var sIndex = tie.getAttribute("index");
			var sFields = tie.getAttribute("fields");
			this.list.subTie(sTable,sAlias,sIndex,sFields);
		}
		
		if (tie.getNodeName() == "exttie")
		{
			var sTable = tie.getAttribute("table");
			var sAlias = tie.getAttribute("alias");
			var sIndex = tie.getAttribute("index");
			var sCod = tie.getAttribute("cod");
			this.list.extTieEx(sAlias, sIndex, sTable, sCod);			
		}
	}
}

function DpDocList_getAction(action)
{
	if (this.list.dataSrc.getTable().getValue("Fwid") == null)
		return "";
	if (SUBD == MSSQL)
	{
		var tbl = OpenTable("EXEC "+ getPath("ALL_MDB") + "..GET_DOC_HISTORY " 
			+ sqlTo(this.list.dataSrc.getTable().getValue("Fwid")));
		if (!tbl.isEmpty())
		{
			var ret = toScrObj(tbl.getValue(action));
			tbl.close();
			return ret;
		}
		return "";	
	}
	
	var oSnap = getSnap("SELECT " + action + " FROM ^archive WHERE fid_doc=" 
		+ sqlTo(this.list.dataSrc.getTable().getValue("Fwid"))
		+ " ORDER BY FMDATE DESC");
	if (oSnap != null)
		return oSnap[0]
	else
		return "";
}

function createLinksField(xmlGrid)
{
	try
	{
		if(!getPar("SHOW_LINKS_FIELD"))
			return;
		var xmlDom = xmlGrid.getOwnerDocument();
		var nextElement = xmlGrid.getChildNodes()[4];
		var xmlFldLinks = xmlDom.createElement("field");
		xmlFldLinks.setAttribute("text", "Зв'язані документи|Связанные документы");		
		xmlFldLinks.setAttribute("field", "=hasLink()");
		xmlFldLinks.setAttribute("width", "3");
		xmlFldLinks.setAttribute("attr", "btn");
		xmlFldLinks.setAttribute("image", "attach");
		xmlGrid.insertBefore(xmlFldLinks, nextElement);
	}
	catch(e)
	{
		//alert(e);
	}
}

function DpDocList_getGrid()
{
	var xmlGrid = this.listInfo.getElementsByTagName("grid")[0];
	xmlDom = xmlGrid.getOwnerDocument();
	
	createLinksField(xmlGrid);
	
	//FISFICTIVE
	
	var oDoc = this.list.oDoc;
	if(!oDoc)
		oDoc = new DpDoc(this.sDocLbl, this.nNop);
	if (oDoc.instanceOf("NAKL"))
	{
		var xmlFldFict = xmlDom.createElement("field");
		xmlFldFict.setAttribute("text", "Фiктивный|Фиктивный");
		xmlFldFict.setAttribute("width", "10");
		xmlFldFict.setAttribute("field", "fisfictive");
		xmlGrid.appendChild(xmlFldFict);
	}

	
	
	//FWID
	var xmlFldDog = xmlDom.createElement("field");
	xmlFldDog.setAttribute("text", "ID документа");	
	xmlFldDog.setAttribute("width", "10");	
	xmlFldDog.setAttribute("field", "fwid");	
	xmlGrid.appendChild(xmlFldDog);


	var xmlFldDog = xmlDom.createElement("field");
	xmlFldDog.setAttribute("text", "Включ. до ЄРПН");	
	xmlFldDog.setAttribute("width", "5");	
	xmlFldDog.setAttribute("field", "FERPN");	
	xmlGrid.appendChild(xmlFldDog);
	
	if (!oDoc.instanceOf("COM.DEBET.DOGOVOR"))
	{
		//Номер договора
		if(this.sDocLbl!="BU" && this.sDocLbl!="BO")	//!!!договор бл@ есть не во всех документах!!!
		{
			var xmlFldDog = xmlDom.createElement("field");
			xmlFldDog.setAttribute("text", "№ договору|№ договора");	
			xmlFldDog.setAttribute("width", "10");	
			xmlFldDog.setAttribute("field", "CNTRCT.Fdog_num");	
			xmlGrid.appendChild(xmlFldDog);
		}
		var jType = "S";
		var jReg = new DpJRegistrator(this.sDocLbl, this.nNop, jType)
		var jRegList = jReg.listRegJournals();
		var allJournals = jReg.listJournals();
		for(var i in jRegList)
		{
			if (!allJournals[i])
				continue;
			var xmlGrNal = xmlDom.createElement("group");
			include("Objects/DpJournal.js")
			oJr = new DpJournal(jType,i)
			xmlGrNal.setAttribute("text", oJr.getName()+" ("+i+")");
			xmlGrid.appendChild(xmlGrNal);
			var xmlFldNal = xmlDom.createElement("field");
			xmlFldNal.setAttribute("text", "Под.нак.|Нал.нак.");	
			xmlFldNal.setAttribute("width", "3");	
			xmlFldNal.setAttribute("field", "=getNalField(^FWID, 'HISNOV1','"+i+"')");	
			xmlGrNal.appendChild(xmlFldNal);
			
			var xmlFldNal = xmlDom.createElement("field");
			xmlFldNal.setAttribute("text", "№ под. нак.|№ нал. нак.");	
			xmlFldNal.setAttribute("width", "10");	
			xmlFldNal.setAttribute("field", "=getNalField(^FWID,null,'"+i+"')");	
			xmlGrNal.appendChild(xmlFldNal);
			
			var xmlFldNal = xmlDom.createElement("field");
			xmlFldNal.setAttribute("text", "Дата под. нак.|Дата нал. нак.");	
			xmlFldNal.setAttribute("width", "10");	
			xmlFldNal.setAttribute("field", "=getNalField(^FWID, 'HNKDAT','"+i+"')");	
			xmlGrNal.appendChild(xmlFldNal);
			
		}

		if (this.nNop == 0)
		{
			var xmlGrNal = xmlDom.createElement("group");
			xmlGrNal.setAttribute("text", "Журнал нал. регистрации)");
			xmlGrid.appendChild(xmlGrNal);
			var xmlFldNal = xmlDom.createElement("field");
			xmlFldNal.setAttribute("text", "Под.нак.|Нал.нак.");	
			xmlFldNal.setAttribute("width", "3");	
			xmlFldNal.setAttribute("field", "=getNalField(^FWID, 'HISNOV1')");	
			xmlGrNal.appendChild(xmlFldNal);
			
			var xmlFldNal = xmlDom.createElement("field");
			xmlFldNal.setAttribute("text", "№ под. нак.|№ нал. нак.");	
			xmlFldNal.setAttribute("width", "10");	
			xmlFldNal.setAttribute("field", "=getNalField(^FWID,null)");	
			xmlGrNal.appendChild(xmlFldNal);
			
			var xmlFldNal = xmlDom.createElement("field");
			xmlFldNal.setAttribute("text", "Дата под. нак.|Дата нал. нак.");	
			xmlFldNal.setAttribute("width", "10");	
			xmlFldNal.setAttribute("field", "=getNalField(^FWID, 'HNKDAT')");	
			xmlGrNal.appendChild(xmlFldNal);
		}
	}

	var xmlFldAction = xmlDom.createElement("field");
	xmlFldAction.setAttribute("text", "Корист.|Польз.");	
	xmlFldAction.setAttribute("width", "7");	
	xmlFldAction.setAttribute("field", "=DpDocList_getAction('Fmuser')");	
	xmlGrid.appendChild(xmlFldAction);
	xmlFldAction = xmlDom.createElement("field");
	xmlFldAction.setAttribute("text", "Дiя|Действ.");	
	xmlFldAction.setAttribute("width", "7");	
	xmlFldAction.setAttribute("field", "=DpDocList_getAction('Fmaction')");	
	xmlGrid.appendChild(xmlFldAction);
	xmlFldAction = xmlDom.createElement("field");
	xmlFldAction.setAttribute("text", "Дата дії|Дата действия");	
	xmlFldAction.setAttribute("width", "7");	
	xmlFldAction.setAttribute("field", "=DpDocList_getAction('Fmdate')");
	xmlFldAction.setAttribute("format", "dd.MM.yyyy HH:mm");	
	xmlGrid.appendChild(xmlFldAction);

	if (this.list.isProv)
	{
		//Наличие проводок
		xmlFldAction = xmlDom.createElement("field");
		xmlFldAction.setAttribute("text", "Наявність проведень|Наличие проводок");	
		xmlFldAction.setAttribute("width", "10");	
		xmlFldAction.setAttribute("field", "=grid_fsch()");	
		xmlGrid.appendChild(xmlFldAction);
	}

/*
	var oRegU = new DpJRegistrator(this.sDocLbl,this.nNop,"U");
	var oRegS = new DpJRegistrator(this.sDocLbl,this.nNop,"S");
	var arrJS = oRegS.listJournals(true);
	var arrJU = oRegU.listJournals(true);
	var regJ = oRegU.listRegJournals(true);
	var arrRegJ = new Array();
	for (var jID in regJ)
	{
		arrRegJ.push(jID);
	}
	if (arrRegJ.length > 0)
	{
		for (var jID in regJ)
		{
			if (!arrJS[jID])
			{
				continue;
			}
			xmlFldAction = xmlDom.createElement("field");
			xmlFldAction.setAttribute("text", "№ под.накл.|№ нал.накл.");	
			xmlFldAction.setAttribute("width", "12");	
			xmlFldAction.setAttribute("field", "DR"+String(jID)+".Hnknom");	
			xmlGrid.appendChild(xmlFldAction);
		}
	}
*/

	var xml = xmlDom.createElement("extention");	
	xmlGrid.appendChild(xml);
	if (this.nNop != 0)
	{
		xml = xmlDom.createElement("extention");
		xml.setAttribute("alias","ext0");
		xmlGrid.appendChild(xml);
	}
	
	xmlFldAction = xmlDom.createElement("field");
	xmlFldAction.setAttribute("text", UR("Організація|Организация"));	
	xmlFldAction.setAttribute("width", "10");	
	xmlFldAction.setAttribute("field", "=!^FORG0? '' : ^FORG0 +': '+ ^org0.FTXT");	
	xmlGrid.appendChild(xmlFldAction);
	
	if(this.subList)
		this.parseGrid(this.subList, xmlGrid);
	
	return xmlGrid;
}

function DpDocList_loadUserList()
{
	var sPath = rootDirectoryEx() + "userData/grid/docs/";
	if(!isDir(sPath))
		return false;
	if(isDir(sPath + this.sDocLbl +"/"))
		return this.loadSubList(sPath + this.sDocLbl +"/");
	var oDoc = this.list.oDoc;
	if(!oDoc)
		oDoc = new DpDoc(this.sDocLbl, this.nNop);
	if(isDir(sPath +"NAKL/") && oDoc.instanceOf("NAKL"))
		return this.loadSubList(sPath +"NAKL/");
	if(isDir(sPath +"DOGOVOR/") && oDoc.instanceOf("com.debet.dogovor"))
		return this.loadSubList(sPath +"DOGOVOR/");
	if(isDir(sPath +"DOC0/") && oDoc.instanceOf("DOC0"))
		return this.loadSubList(sPath +"DOC0/");
}

function DpDocList_loadSubList(sPath)
{
	this.subList = null;
	var sSubXml = sPath +"list.xml";
	var sSubScr = sPath +"list.js";
	if(isFile(sSubScr))
		include(sSubScr);
	if(!isFile(sSubXml))
		return;
	var subXml = new DpXMLDOMDocument();
	subXml.load(sSubXml);
	this.subList = subXml.getDocumentElement().cloneNode(true);
}

function DpDocList_parseGrid(xmlDoc, mainXmlGrid)
{	
	var subGrid = xmlDoc.getElementsByTagName("grid")[0];
	if(!subGrid)
		return;
	var fieldList = subGrid.getChildNodes();
	var mainList = mainXmlGrid.getChildNodes();
	var xmlDom = mainXmlGrid.getOwnerDocument();
	for (var i=0; i<fieldList.length; i++)
	{
		var eFld = fieldList[i];
		var subFld = xmlDom.adoptNode(eFld);
		var mainFld = mainList[1];
		var pos = eFld.getAttribute("pos");
		if(pos && Number(pos)>0)
			mainFld = mainList[Number(pos)];
		var sID = eFld.getAttribute("id");
		if(sID)	//подстановка колонки по ID
		{
			var bReplace = false;
			var fldList = mainXmlGrid.getElementsByTagName("field");
			for (var j=0; j<fldList.length; j++)
			{
				var fld = fldList[j];
				var mainID = fld.getAttribute("id");
				if(!mainID)
					continue;
				if(sID==mainID)	//замена колонки
				{
					var parXml = fld.xmlNode.getParentNode();
					parXml.appendChild(subFld.xmlNode);
					parXml.removeChild(fld.xmlNode);
					bReplace = true;
					break;
				}
			}
			if(bReplace)
				continue;
		}
		mainXmlGrid.insertBefore(subFld, mainFld);
	}
}
