/*
	Описание объекта вызывающего проведение документа
	Позволяет массовое формирование проводок (по нескольким документам)
	
*/


// Коструктор объекта, формирующего проводки
// Ничего не делает. Только инициализация.
function DpExeDocOp()
{
	this.exeDocOp = DpExeDocOp_exeDocOp;   // Процедура вызова ф-ции  exeDocOp 
   	this.exeRegOp = DpExeDocOp_exeRegOp;   // Процедура вызова ф-ции  exeDocOp 
	this.saveAll = DpExeDocOp_savaAll;
	this.setProgress = DpExeDocOp_setProgress;
	this.exeop = DpExeDocOp_exeop;
	this.parseOperation = DpExeDocOp_parseOperation;
	this.parseSection = DpExeDocOp_parseSection;
	this.delProv = DpExeDocOp_delProv; 
	this.getOperationList = DpExeDocOp_getOperationList;
	this.massExeDocOp = DpExeDocOp_massExeDocOp;

	this.nProgress = 0;
	this.nProgressRange = 0;
   //TODO: this.isMas = isMas
   	this.isQuick = false;
   	this.isReg = false;
   	if (document.operListMap == null)
   		document.operListMap = new Array();
   	
   	this.schetTbl = "^schet";

}

function DpExeDocOp_setProgress(nRange)
{
	this.nProgressRange = nRange;
	setProgressRange(0, nRange);
}

// Метод, который надо вызывать, чтоб проводки формировались
// Параметры:
//  docLabel - шаблон документа 
//  nop      - номер операции (сейчас не используется, т.к.
//             при массовом формировании проводок номер операции
//             может быть разным для разных документов)
//  tbl      - объект-таблица заголовка. Правильно открытая (со всеми
//             нужными Tie'ами, расширениями и т.д.)
//  cond     - условие на документы, по которым будут формироваться проводки
function DpExeDocOp_exeDocOp(isQuick,bIsMass,isCheck)
{
	lpProxy.getLog().debug("start")
	include("sys\\dbase.js");
	include("objects\\DpOperation.js");
	include("Objects\\DpMsgBox.js");	
	
	this.isQuick = isQuick;
	
	if (isCheck)
		this.isQuick = true;
	
	
	
	//this.jDoc.loadFromXML();	
	
	// Перегоняем условие на документы в условие на проводки
	var condProv = " fid_doc = " + this.getID();
	// Ищем уже существующие проводки по документам
	var tblProv = OpenTable("s","SELECT *"
		+ " FROM " + this.schetTbl
		+ " WHERE  " + condProv
			+ (this.sDocLbl && this.sDocLbl !="_R" ? " AND fdoc<>'_R'": "")
		);

	if(typeof this.toDo!="string" )
	{
		this.toDo = "+";
		if (!isCheck && !tblProv.isEmpty())
			this.toDo = msgBox("-+c" /*"-*+c"*/
				, "Найдены проводки по отмеченным документам"
				, "Формирование проводок по документам")
	}
	
	tblProv.close();
	
	switch(this.toDo)
	{
	case "*":
		// Выбрали изменение проводок 
		// По этому режиму осуществляется просто редактирование
		// существующих проводок по отмеченным документам.
		var par = new Object;
		par.tbl = OpenTable("s",
			"SELECT *"
			+ " FROM " + this.schetTbl
			+ " WHERE " + condProv
			+ " ORDER BY fdoc, fnop, fdocnum, fwid"
			);
		par.mode = "EDIT";
        	par.protmode = "EDIT";
		par.exeOp = true;
		par.isMas = false;
		par.tname = this.schetTbl;
		showWindow("e_prov.xml", SW_MODAL, par);
		par.tbl.close();
		return;
		
	case "c":
		// Выбрали отмену - до свидания!
		return;
	default:  // на всякий случай
		return;
	case "+":
	case "-":
	}
	lpProxy.getLog().debug("start create prov")
	// Создаем временную таблицу, куда будут формироваться проводки
	CreateTable("tmp_tschet", "sch_exeop");
	CreateTable("tmp_tschet2", "sch_exeop");	

	// Вычисление значений переменных заголовка
	
	
	var svDoc = "", svNop = -1;
	
	
	var escape = false;
	
	

	WAITTIMER("Формирование проводок "
		+ this.sDocLbl + this.nNop
		+ " № " + this.getVar("HNOM")
			);
		
		/*if(Pump())
		{
			if("c"==msgBox("oc", "Продолжить формирование проводок?", "Формирование проводок"))
			{
				escape = true;
				break;
			}
		}*/
		
		lpProxy.getLog().debug("create prov")
	this.exeop("tmp_tschet");
	lpProxy.getLog().debug("create prov 2")
	
	if(this.nProgressRange)
	{
		++this.nProgress;
		setProgressPos(this.nProgress, "Формирование проводок. Документ " + this.nProgress + " из " + this.nProgressRange);
	}
	
	
	var cGroupBy = "fdocnum, fdate, fdocvid"
			+ ", fdb_sc, fdb_su, fdb_st, fdb_cod1, fdb_cod2, fdb_cod3"
			+ ", fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3"
			+ ", fmo, forg0, fval, fvalspr"
			+ ", fid_doc, fdoc, fnop, fnsect, fnprov, fdoc_dat"
			+ ", fvkurs, FISKRAZ, fwrk";
	//		+ ", fmcomp, fmdate, fmuser";
	var par = new Object;
	
	ExecuteSQL(
		"INSERT INTO tmp_tschet2(fwid, fsum, fsumspr, ftxt, " + cGroupBy + ")"
		+ " SELECT " + First("t.fwid") + " AS fwid"
			+ ", " + sqlRound("SUM(t.fsum)", getPar("DECISUM")) + " AS fsum"
			+ ", " + sqlRound("SUM(t.fsumspr)", getPar("DECISUM")) + " AS fsumspr"
			+ ", t.ftxt As ftxt"
			+ "," + cGroupBy
		+ " FROM tmp_tschet t"
//-		+ " GROUP BY " + cGroupBy + ", " + Convert("t.ftxt", "STR")
		+ " GROUP BY " + cGroupBy + ", ftxt"
		+ " HAVING " + sqlRound("SUM(t.fsum)", getPar("DECISUM")) + " <> 0" 
		);
		
		lpProxy.getLog().debug("create prov 3")
	par.tbl = OpenTable("s",
		"SELECT *"
		+ " FROM tmp_tschet2"
		+ " ORDER BY fdoc_dat, fdocnum, fid_doc, fnsect, fnprov, fwid"
		);
	
	par.tblSrc = par.tbl;
	par.mode = "EDIT";
	par.exeOp = true;
	par.isNCapt = true;
	//par.isMas = this.isMas;
	par.isMas = (bIsMass?true:false);
	par.escape = escape;
	par.tname = "tmp_tschet2";
    par.protmode = "ADD";
	
	lpProxy.getLog().debug("create prov 4")
	if(!par.tbl.IsEmpty() && !escape)
	{
		if(!this.isQuick)
			showWindow("e_prov.xml", SW_MODAL, par);
	}

	if(par.escape===false)
	{
		if(this.toDo=="-")
		{
			ExecuteSQL("DELETE FROM " + this.schetTbl 
				+ " WHERE fdoc<> '_R' and fid_doc = " + sqlTo(this.getID()) );			
			
		}
		
		ExecuteSQL(
			"INSERT INTO " + this.schetTbl + "(" + GetPatternIntersection("schet", "sch_exeop") + ")"
			+ " SELECT " + GetPatternIntersection("schet", "sch_exeop")
			+ " FROM tmp_tschet2"
			);
		
		provToArhive("F",this.getID(),false);
			
		WAITTIMEOUT(ru("Формирование проводок завершено. Сформировано " + par.tbl.RecordCount + " проводок" 
			,"Формування проведень закінчено. Сформовано " + par.tbl.recordCount + " проведень"
			), 25);
	}
	else
		WAITTIMEOUT(ru("Формирование проводок прервано пользователем."
			, "Формування проведень зупинено користувачем."
			), 40);
	CLEARWAIT();
	lpProxy.getLog().debug("create prov 5")
	//TODO: Установить в базу 
	var n = par.tbl.getRecordCount();
	par.tbl.close();
	return n;
}

function DpExeDocOp_massExeDocOp(isQuick, arrIDs, sqlSel)
{
	
	lpProxy.getLog().debug("start")
	include("sys\\dbase.js");
	include("objects\\DpOperation.js");
	include("Objects\\DpMsgBox.js");	
	
	this.isQuick = isQuick;
	// Перегоняем условие на документы в условие на проводки	
	//this.jDoc.loadFromXML();

	var condProv = " fdoc <> '_R' and fid_doc " + sqlSel;
	// Ищем уже существующие проводки по документам
	var tblProv = OpenTable("s","SELECT * FROM ^schet"
				+ " WHERE  " + condProv);

	if(typeof this.toDo!="string")
	{
		this.toDo = "+";
		if(!tblProv.isEmpty())
			this.toDo = msgBox("-+c" /*"-*+c"*/
				, "Найдены проводки по отмеченным документам"
				, "Формирование проводок по документам")
	}
	tblProv.close();
	tblProv = null;
	switch(this.toDo)
	{
	case "*":
		// Выбрали изменение проводок 
		// По этому режиму осуществляется просто редактирование
		// существующих проводок по отмеченным документам.
		var par = new Object;
		par.tbl = OpenTable("s",
			"SELECT *"
			+ " FROM ^schet"
			+ " WHERE " + condProv
			+ " ORDER BY fdoc, fnop, fdocnum, fwid"
			);
		par.mode = "EDIT";
        	par.protmode = "EDIT";
		par.exeOp = true;
		par.isMas = false;
		par.tname = "^schet";
		showWindow("e_prov.xml", SW_MODAL, par);
		par.tbl.close();
		return;
		
	case "c":
		// Выбрали отмену - до свидания!
		return;
	default:  // на всякий случай
		return;
	case "+":
	case "-":
	}
	// Создаем временную таблицу, куда будут формироваться проводки
	CreateTable("tmp_tschet", "sch_exeop");
	CreateTable("tmp_tschet2", "sch_exeop");	

	// Вычисление значений переменных заголовка
	
	
	var svDoc = "", svNop = -1;
	
	
	var escape = false;
	
	var monitor = getProgressMonitor();
	monitor.beginTask(UR("Формування проведень...|Формирование проводок..."),arrIDs.length);

	for (var i = 0; i < arrIDs.length; i++)
	{
		this.clear();
		this.loadByID(arrIDs[i]);
		this.nNop = Number(this.jDoc.getVar("HOP"));
		if(this.jDoc.getPar("docprovnotdog")==true && (this.jDoc.getVar("HID_DOG")==null || this.jDoc.getVar("HID_DOG")==0))
		{
			alert(ru("Не проставлений договір для документу №","Не проставлен договор для документа №")+this.jDoc.getVar("HNOM"));
			continue;
		}
		
		WAITTIMER("Формирование проводок "
			+ this.sDocLbl + this.nNop
			+ " № " + this.getVar("HNOM")
			);
		
		/*if(Pump())
		{
			if("c"==msgBox("oc", "Продолжить формирование проводок?", "Формирование проводок"))
			{
				escape = true;
				break;
			}
		}*/
		
		this.exeop("tmp_tschet");		
		monitor.worked(1);
		if(this.nProgressRange)
		{
			++this.nProgress;
			setProgressPos(this.nProgress, "Формирование проводок. Документ " + this.nProgress + " из " + this.nProgressRange);
		}
	}
	
	
	
	monitor.done();
	
	var cGroupBy = "fdocnum, fdate, fdocvid"
			+ ", fdb_sc, fdb_su, fdb_st, fdb_cod1, fdb_cod2, fdb_cod3"
			+ ", fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3"
			+ ", fmo, forg0, fval, fvalspr"
			+ ", fid_doc, fdoc, fnop, fnsect, fnprov, fdoc_dat"
			+ ", fvkurs, FISKRAZ, fwrk";
			//+ ", fmcomp, fmdate, fmuser";
	var par = new Object;
	
	ExecuteSQL(
		"INSERT INTO tmp_tschet2(fwid, fsum, fsumspr, ftxt, " + cGroupBy + ")"
		+ " SELECT " + First("t.fwid") + " AS fwid"
			+ ", " + sqlRound("SUM(t.fsum)", getPar("DECISUM")) + " AS fsum"
			+ ", " + sqlRound("SUM(t.fsumspr)", getPar("DECISUM")) + " AS fsumspr"
			+ ", t.ftxt As ftxt"
			+ "," + cGroupBy
		+ " FROM tmp_tschet t"
//-		+ " GROUP BY " + cGroupBy + ", " + Convert("t.ftxt", "STR")
		+ " GROUP BY " + cGroupBy + ", ftxt"
		+ " HAVING " + sqlRound("SUM(t.fsum)", getPar("DECISUM")) + " <> 0" 
		);
		
		lpProxy.getLog().debug("create prov 3")
	par.tbl = OpenTable("s",
		"SELECT *"
		+ " FROM tmp_tschet2"
		+ " ORDER BY fdoc_dat, fdocnum, fid_doc, fnsect, fnprov, fwid"
		);
	
	par.tblSrc = par.tbl;
	par.mode = "EDIT";
	par.exeOp = true;
	par.isNCapt = true;
	//par.isMas = this.isMas;
	par.isMas = true;
	par.escape = escape;
	par.tname = "tmp_tschet2";
    par.protmode = "ADD";
	
	if(!par.tbl.IsEmpty() && !escape)
	{
		if(!this.isQuick)
			showWindow("e_prov.xml", SW_MODAL, par);
	}

	if(par.escape===false)
	{

		if(this.toDo=="-")
		{
			ExecuteSQL("DELETE FROM " + this.schetTbl + " WHERE " + condProv );			
		}
			
		ExecuteSQL(
			"INSERT INTO " + this.schetTbl + "(" + GetPatternIntersection("schet", "sch_exeop") + ")"
			+ " SELECT " + GetPatternIntersection("schet", "sch_exeop")
			+ " FROM tmp_tschet2"
			);
				
		for (var i = 0; i < arrIDs.length; i++)
			provToArhive("M", arrIDs[i], false);
		
		WAITTIMEOUT(ru("Формирование проводок завершено. Сформировано " + par.tbl.RecordCount + " проводок" 
			,"Формування проведень закінчено. Сформовано " + par.tbl.recordCount + " проведень"
		), 25);
	}
	else
		WAITTIMEOUT(ru("Формирование проводок прервано пользователем."
			, "Формування проведень зупинено користувачем."
			), 40);
	CLEARWAIT();
	//TODO: Установить в базу 
	var n = par.tbl.getRecordCount()
	par.tbl.close();
	par.tblSrc = par.tbl = null;
	return n;
}

function DpExeDocOp_delProv()
{
	ExecuteSQL("DELETE FROM ^SCHET WHERE FDOC <> '_R' and  fid_doc = " + sqlTo(this.getID()) );	
}



// Метод, который надо вызывать, чтоб проводки формировались
// Параметры:
//  docLabel - шаблон документа 
//  nop      - номер операции (сейчас не используется, т.к.
//             при массовом формировании проводок номер операции
//             может быть разным для разных документов)
//  tbl      - объект-таблица заголовка. Правильно открытая (со всеми
//             нужными Tie'ами, расширениями и т.д.)
//  cond     - условие на документы, по которым будут формироваться проводки
function DpExeDocOp_exeRegOp(tbl, isQuick,bIsMass)
{
	include("sys\\dbase.js");
	include("objects\\DpOperation.js");
	include("Objects\\DpMsgBox.js");	
	this.isReg = true;
	this.isQuick = isQuick;
	this.sDocLbl = "_R";
	
	// Перегоняем условие на документы в условие на проводки	
	
	include ("objects/DpEval.js");
	this.oDoc = new DpEval();
	this.oDoc.setTable(tbl);
	this.tbl = tbl;
	this.tEval = Reg_tEval;
	this.hasRows = new Function("return false")
	
	//	this.getID =  new Function("return this.id")
	this.getID = new Function("return this.tbl.getValue('HID_DOC')")

	var condProv = " fdoc='_R' and fid_doc = " + this.getID();
	// Ищем уже существующие проводки по документам
	var tblProv = OpenTable("s","SELECT * FROM ^schet"
				+ " WHERE  " + condProv);

	if(typeof this.toDo!="string")
	{
		this.toDo = "+";
		if(!tblProv.isEmpty())
			this.toDo = msgBox("-+c" /*"-*+c"*/
				, "Найдены проводки по отмеченным документам"
				, "Формирование проводок по документам")
	}
	tblProv.close();
	
	switch(this.toDo)
	{
	case "*":
		// Выбрали изменение проводок 
		// По этому режиму осуществляется просто редактирование
		// существующих проводок по отмеченным документам.
		var par = new Object;
		par.tbl = OpenTable("s",
			"SELECT *"
			+ " FROM ^schet"
			+ " WHERE " + condProv
			+ " ORDER BY fdoc, fnop, fdocnum, fwid"
			);
		par.mode = "EDIT";
        	par.protmode = "EDIT";
		par.exeOp = true;
		par.isMas = false;
		par.tname = "^schet";
		showWindow("e_prov.xml", SW_MODAL, par);
		par.tbl.close();
		return false;
		
	case "c":
		// Выбрали отмену - до свидания!
		return false;
	default:  // на всякий случай
		return false;
	case "+":
	case "-":
	}
	
	// Создаем временную таблицу, куда будут формироваться проводки
	CreateTable("tmp_tschet", "sch_exeop");
	CreateTable("tmp_tschet2", "sch_exeop");	

	// Вычисление значений переменных заголовка
	
	
	var svDoc = "", svNop = -1;
	
	
	var escape = false;
	
	

	WAITTIMER("Формирование проводок ");
		
		/*if(Pump())
		{
			if("c"==msgBox("oc", "Продолжить формирование проводок?", "Формирование проводок"))
			{
				escape = true;
				break;
			}
		}*/
		
	while(!this.tbl.isEOF())
	{
		this.exeop("tmp_tschet");
		
		if(this.nProgressRange)
		{
			++this.nProgress;
			setProgressPos(this.nProgress, "Формирование проводок. Документ " + this.nProgress + " из " + this.nProgressRange);
		}
			
		this.tbl.moveNext();
	}
	
	var cGroupBy = "fdocnum, fdate, fdocvid"
			+ ", fdb_sc, fdb_su, fdb_st, fdb_cod1, fdb_cod2, fdb_cod3"
			+ ", fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3"
			+ ", fmo, forg0, fval, fvalspr"
			+ ", fid_doc, fdoc, fnop, fnsect, fnprov, fdoc_dat"
			+ ", fvkurs, FISKRAZ, fwrk";
	//		+ ", fmcomp, fmdate, fmuser";
	var par = new Object;
	
	ExecuteSQL(
		"INSERT INTO tmp_tschet2(fwid, fsum, fsumspr, ftxt, " + cGroupBy + ")"
		+ " SELECT " + First("t.fwid") + " AS fwid"
			+ ", " + sqlRound("SUM(t.fsum)", getPar("DECISUM")) + " AS fsum"
			+ ", " + sqlRound("SUM(t.fsumspr)", getPar("DECISUM")) + " AS fsumspr"
			+ ", t.ftxt As ftxt"
			+ "," + cGroupBy
		+ " FROM tmp_tschet t"
//-		+ " GROUP BY " + cGroupBy + ", " + Convert("t.ftxt", "STR")
		+ " GROUP BY " + cGroupBy + ", ftxt"
		+ " HAVING " + sqlRound("SUM(t.fsum)", getPar("DECISUM")) + " <> 0" 
		);
		
	par.tbl = OpenTable("s",
		"SELECT *"
		+ " FROM tmp_tschet2"
		+ " ORDER BY fdoc_dat, fdocnum, fid_doc, fnsect, fnprov, fwid"
		);
	
	par.tblSrc = par.tbl;
	par.mode = "EDIT";
	par.exeOp = true;
	par.isNCapt = true;
	//par.isMas = this.isMas;
	par.isMas = (bIsMass?true:false);
	par.escape = escape;
	par.tname = "tmp_tschet2";
    par.protmode = "ADD";
	
	if(!par.tbl.IsEmpty() && !escape)
	{
		if(!this.isQuick)
			showWindow("e_prov.xml", SW_MODAL, par);
	}

	if(par.escape===false)
	{
		if(this.toDo=="-")
		{
			for(this.tbl.MoveFirst(); !this.tbl.isEOF(); this.tbl.MoveNext())
			{
				ExecuteSQL("DELETE FROM ^SCHET WHERE fdoc='_R' and fid_doc = " + sqlTo(this.getID()) );			
			}
		}
		
		ExecuteSQL(
			"INSERT INTO ^schet(" + GetPatternIntersection("schet", "sch_exeop") + ")"
			+ " SELECT " + GetPatternIntersection("schet", "sch_exeop")
			+ " FROM tmp_tschet2"
			);
			
		WAITTIMEOUT(ru("Формирование проводок завершено. Сформировано " + par.tbl.RecordCount + " проводок" 
			,"Формування проведень закінчено. Сформовано " + par.tbl.recordCount + " проведень"
			), 25);
	}
	else
	{
		WAITTIMEOUT(ru("Формирование проводок прервано пользователем."
			, "Формування проведень зупинено користувачем."
			), 40);
			par.tbl.close();
			return false;
	}
	CLEARWAIT();
	//TODO: Установить в базу 
	var n = par.tbl.getRecordCount()
	par.tbl.close();
	return n;
}

function Reg_tEval(sType, sExpr)
{
	return this.oDoc.tEval(sType, sExpr);
}



// Генерация проводок по хоз.операции
// nop - номер хоз.операции
// schetName - имя таблицы для записи проводок
// docLabel - метка документа
// rowTblName - имя таблицы, где хранятся выбранные строки документа
// Возвращает: 0-ok, 1-не было сделано проводок, 2 - прервано по ESC
function DpExeDocOp_exeop(schetName)
{
	include("sys\\dbase.js");
	include("objects\\DpOperation.js");
	include("Objects\\DpMsgBox.js");	
	
	var sSQL = "SELECT * FROM ^cl_lnk WHERE fdoc = "
			+ sqlTo(this.sDocLbl) + " AND fnop = "
			+ (this.isReg == true ? this.oDoc.getVar("HNOP") : sqlTo(this.getVar("HOP")))

	if (this.isReg)
	{
		sSQL = "SELECT * FROM ^cl_lnk WHERE fdoc = "
			+ sqlTo(this.oDoc.getVar("HDOC") ) + " AND fnop = "
			+ sqlTo(this.oDoc.getVar("HNOP"));
	}
	else
	{
		this.nNop = Number(this.getVar("HOP"));
	}
	
	var tblCl_lnk = OpenTable("s", sSQL);
	lpProxy.getLog().debug("exeop 3")
	var sDocOpText = "";
	if (getPar("ExeOpTxt") && !tblCl_lnk.isEmpty())
		sDocOpText = tblCl_lnk.getValue("ftxt") + ": ";
		
	

	//var tblSchet = OpenTable("s", schetName);

	var refOp = this.isReg?("SJ" + this.oDoc.getVar("HREG")): this.getVar("HOP");
	var retCode = 1;
	
/*
	// Объект для формирования проводок
	var entry = new Object();	// объект проводка
	entry.addField = entry_addField;
	entry.setFields = entry_setFields;		
*/	
	do
	{
		//var operList = new DpOperationList(this.sDocLbl);
		//var operation = operList.listOperations(true)[refOp];
		var operation = this.getOperationList()[refOp];				
		
		if (operation)
		{
			refOp = operation.getVar("ref");
			if (!isNaN(refOp))
				refOp = parseInt(refOp);					
		}
		else
			refOp = 0;				
			
		retCode = this.parseOperation(operation, retCode, schetName, sDocOpText);
		
	}
	while(refOp);  // Выполняем пока есть ссылка на след. операцию
	tblCl_lnk.close();
	return retCode;
}

function DpExeDocOp_getOperationList(sDocLbl)
{
	if (document.operListMap[sDocLbl])
		return document.operListMap[sDocLbl];
		
	var operList = new DpOperationList(this.sDocLbl);
	document.operListMap[sDocLbl] = operList.listOperations(true);
	
	return 	document.operListMap[sDocLbl]; 
		
	
}

function DpExeDocOp_parseSection(oSection,code,schetName,sDocOpText)
{
	var retCode = code;
	
	// Объект для формирования проводок
	var entry = new Object();	// объект проводка
	entry.addField = entry_addField;
	entry.setFields = entry_setFields;		

	
	var frepeat = String(oSection.getVar("group"));
	var ffilt = String(oSection.getVar("filter"));
	
	if (this.tEval("b",oSection.getVar("cond"))
		&& (this.hasRows() || this.tEval("b",ffilt))
		)
	{
		var nRepeat;					

		if(frepeat=="*")
		{
			nRepeat = 0;
			
			var provTbl = oSection.getProvTbl();
			for (provTbl.MoveFirst();!provTbl.isEOF();provTbl.MoveNext())
			{
				var bdate = new Date(lpProxy.parseDate(provTbl.getValue("bdate")));
				var edate = new Date(lpProxy.parseDate(provTbl.getValue("edate")));
				if (bdate == null) bdate = d00min;
				if (edate == null) edate = d00;
				var docDat = this.tEval("date", "HDAT");
				var isInTerm = true;
				if (docDat)
					isInTerm = ( differ(bdate,docDat) <=0
								&& differ(docDat,edate) <=0
								);

				if (!isInTerm)
					continue;
				
				var i = 0;
				if (!this.gotoFirstRow())
					break;
				while(this.gotoNextRow())
				{
					var currRow = this.getCurrRow();
					if(!currRow.tEval("b", ffilt) || !currRow.tEval("b", provTbl.getValue("cond")))
						continue;
					
					entry.setFields(null, oSection, this.isReg?this.oDoc:this, sDocOpText,provTbl.getValue("num"), this.getID(), schetName,true);
				}
			}					
		}
/*
		else if(frepeat!="")					
		{
			var groups = frepeat.split("|");
															
			for(var i=0; i<groups.length; i++)
			{
				var posOfAS = groups[i].search(/\Was\W/i);
				if(posOfAS!=-1)
				{
					var varName = groups[i].left(posOfAS+1);
					groups[i] = varName;
				}
			}

			var grVals = new Array();
			var i, j;
			var isNew, is;
			nRepeat = 0;
			
			if (this.gotoFirstRow())
			{
				do
				{
					grVals[nRepeat] = new Array();
					for(j=0; j<groups.length; j++)
						grVals[nRepeat][j] = this.getCurrRow().eval(groups[j]);
	
					for(i=0; i<nRepeat; i++)  // Цикл по уже сформированным значениям групп
					{
						for(j=0; j<groups.length; j++)
							if(grVals[nRepeat][j]!=grVals[i][j]) // хотя бы одно несовпадение
								break;
						if(j==groups.length)   //все совпало
							break;
					}
					if(i==nRepeat)	// Не было совпадающих значений групп
						nRepeat++;
				}
				while(this.gotoNextRow())
			 }

			if(nRepeat>0)
			{

				oEval.addVar("_grVals", grVals);
				var rowFilter = "";
				if(typeof(ffilt)=="string" && ffilt.trim()!="")
					rowFilter = "(" + ffilt + ") && "
				for(j=0; j<groups.length; j++)
				{
					if(j!=0)
						rowFilter += " && ";
					rowFilter += "(" + groups[j] + ")==_grVals[_repeatCnt]["+j+"]";
				}
				oEval.setRowFilter(rowFilter);

			}
			else
			{
			
				while(!tblOp.IsEOF() && tblOp.getValue("fnsect") == fnsect)
					tblOp.MoveNext();

			}
		}
*/
		else
		{
			nRepeat = 1;
			//TODO:
			//oEval.setRowFilter(ffilt);
		}
		
		var repeatCnt=0;
		for(var repeatCnt=0; repeatCnt<nRepeat; repeatCnt++)
		{
			var provTbl = oSection.getProvTbl();
			var i = 0;
			for (provTbl.MoveFirst();!provTbl.isEOF();provTbl.MoveNext())
			{
				var bdate = new Date(lpProxy.parseDate(provTbl.getValue("bdate")));
				var edate = new Date(lpProxy.parseDate(provTbl.getValue("edate")));
				if (bdate == null) bdate = d00min;
				if (edate == null) edate = d00;
				var docDat = this.tEval("date","HDAT");
				var isInTerm = true;
				if (docDat)
					isInTerm = ( differ(bdate,docDat) <=0
								&& differ(docDat,edate) <=0
								);
				if (!isInTerm)
					continue;
				if (retCode == 2)
					break;
				if (this.tEval("b",provTbl.getValue("cond")))
				{
					entry.setFields(/*groups*/null, oSection
						, this.isReg?this.oDoc:this
						, sDocOpText,provTbl.getValue("num")
						, this.getID()
						, schetName
						);
				}
			}
		}
	}
	else	// пропускаем всю секцию (и проводки без секций)
	{
/*		do
			tblOp.MoveNext();
		while(!tblOp.IsEOF() && tblOp.getValue("fnprov")!=0)
*/
	}
}

function DpExeDocOp_parseOperation(oOperation,code,schetName,sDocOpText)
{
	var retCode = code;
	
	if (oOperation && this.tEval("b",oOperation.getVar("cond")))
	{
		var arrSect = oOperation.sectionList;
		
		for (var nSect in arrSect)
//-		while(retCode!=2 && !tblOp.IsEOF())
		{
	
			if (retCode == 2)
				break;
			var oSection = arrSect[Number(nSect)];
			if (!oSection)
				continue;
			retCode = this.parseSection(oSection,retCode,schetName,sDocOpText);
		}
	}
	return retCode;
}


function entry_addField(field,type, descr,bFromRow,oSect)
{
//-	var expr = " " + this.tblOp.getValue(field) + " ";
	var expr = String(this.tblOp.getValue(field));
	if (field == "mo" && oSect)
	{
		if (!expr)
			expr = String(oSect.getVar("mo"));
			
		if (!expr)
			expr = String(oSect.oOper.getVar("mo"));
		//alert(expr)		
	}
	expr = " " + expr + " ";
	if(this.groups)
		for(var i=0; i<this.groups.length; i++)
		{
			var re = new RegExp("(\\W)" + this.groups[i] + "(\\W)", "ig")
			expr = expr.replace(re,"$1_grVals[_repeatCnt]["+i+"]$2");
		}
	if (!bFromRow)
		this["f" + field] =
			this.oDoc.tEval(type, expr, null, this.title + descr);
	else
		this["f" + field] =
			this.oDoc.getCurrRow().tEval(type, expr, null, this.title + descr);

	if(type=="n" && isNaN(this["f" + field]))
	{
		alert("Ошибка в числовом выражении (NaN): " + field + " = " + expr);
		this["f" + field] = 0;
	}
}

function entry_setFields(groups, oSect, oDoc, sDocOpText, fnprov, fid_doc, tblSchet,bFromRow)
{
	if (bUseTrace)
		oEvalTrace.startLevel("Првоводка: Секция=" + fnsect + " Проводка=" + fnprov);
	var entry = this;	
	entry.groups = groups;
	entry.tblOp = oSect.getProvTbl();
	entry.oSection = oSect;
	entry.oDoc = oDoc;
	entry.title = "Проводки к документу " + this.oSection.oOper.doc
		+ ", операция " + this.oSection.oOper.nop
		+ ", секция " + this.oSection.num
		+ ", проводка " + fnprov + ": ";

	entry.fdoc = this.oSection.oOper.doc;
	entry.fnop = this.oSection.oOper.nop;
	if (!isNaN(String(entry.fnop)))
	{
		entry.fnop = parseInt(entry.fnop);	
	}
	else
		entry.fnop = 0;
	

	for (entry.tblOp.MoveFirst();!entry.tblOp.isEOF();entry.tblOp.MoveNext())
		if (entry.tblOp.getValue("num") == fnprov) break;
	
	entry.addField("docnum","str","Номер",bFromRow);
	
	var Pdate = entry.tblOp.getValue("date");
	if (!bFromRow)
	{
		entry.fdate = oDoc.tEval("date",
			Pdate,
			new Date().getVarDate(),
			entry.title + "Дата");
	}
	else
	{
		entry.fdate = oDoc.getCurrRow().tEval("date",
			Pdate,
			new Date().getVarDate(),
			entry.title + "Дата");
	}
//??	

	if (!bFromRow)
		entry.fdocvid = oDoc.substVal(entry.tblOp.getValue("docvid"));
	else
		entry.fdocvid = oDoc.getCurrRow().substVal(entry.tblOp.getValue("docvid"));
	entry.fdocvid = entry.fdocvid.substr(0,8);
	if (!bFromRow)
		entry.ftxt = sDocOpText + oDoc.substVal(entry.tblOp.getValue("txt"));
	else
		entry.ftxt = sDocOpText + oDoc.getCurrRow().substVal(entry.tblOp.getValue("txt"));
//	
	entry.addField("db_sc", "n", "Дебет: счет",bFromRow);
	entry.addField("db_su", "n", "Дебет: субсчет",bFromRow);
	entry.addField("db_st", "n", "Дебет: статья",bFromRow);
	entry.addField("db_cod1", "n", "Дебет: ан.1",bFromRow);
	entry.addField("db_cod2", "n", "Дебет: ан.2",bFromRow);
	entry.addField("db_cod3", "n", "Дебет: ан.3",bFromRow);
	entry.addField("cr_sc", "n", "Кредит: счет",bFromRow);
	entry.addField("cr_su", "n", "Кредит: субсчет",bFromRow);
	entry.addField("cr_st", "n", "Кредит: статья",bFromRow);
	entry.addField("cr_cod1", "n", "Кредит: ан.1",bFromRow);
	entry.addField("cr_cod2", "n", "Кредит: ан.2",bFromRow);
	entry.addField("cr_cod3", "n", "Кредит: ан.3",bFromRow);
	entry.addField("sum", "n", "Сумма",bFromRow);
	// Округляется в самом конце при подбивке общей суммы
	entry.fsum = round(entry.fsum, 5);
	entry.addField("val", "n", "Валюта",bFromRow);
	entry.addField("vkurs", "n", "Курс",bFromRow);
	entry.addField("iskraz", "str", "Участвует в курсовых разницах",bFromRow);
	entry.addField("sumspr", "n", "Сумма справочно",bFromRow);
	if (getPar("CODMO"))
	{
		entry.addField("mo", "n", "МО",bFromRow, oSect);
		if (entry.fmo == 0)
		{
			entry.fmo = getMO(entry.fdb_sc, entry.fdb_su, entry.fdb_st
					, entry.fcr_sc, entry.fcr_su, entry.fcr_st);
		}
	}
	else
		entry.fmo = 0;
	// Округляется в самом конце при подбивке общей суммы
	entry.fsumspr = round(entry.fsumspr, 5);
	entry.addField("valspr", "n", "Валюта справочно",bFromRow);
	entry.fid_doc = fid_doc;
	
	entry.forg0 = oDoc.getVar("HORG0");

	
	if(entry.fsum!=0)
	{
		var m = new Object();
		m.FWID = GetUID();
		m.FDOC_DAT = oDoc.getVar("HDAT");
		m.FNSECT = this.oSection.num;
		m.FNPROV = Number(fnprov);
		
		for(var fld in entry)
		{
			if(fld.charAt(0) == "f")
			{
				m[fld] = entry[fld];
			}
		}
		
		updateTable(tblSchet,m,true);		
	}
	
	if (bUseTrace)
		oEvalTrace.endLevel("");
}

function DpExeDocOp_savaAll()
{	
	var tblSchet = OpenTable("s", 
		"SELECT * "
		+ " FROM tmp_tschet"
		+ " ORDER BY fdate, fdocnum, fwid" 
		);
	
	ExecuteSQL("update tmp_tschet set fsum = " + sqlRound("fsum", 2) + " , fsumspr = " + sqlRound("fsumspr", 2));
	var par = new Object;
	par.mode = "EDIT";
	par.tbl = tblSchet;
	par.exeOp = true;
	par.isMas = this.isMas;
       	par.protmode = "ADD";

	if(!tblSchet.IsEmpty())
	{
		showWindow("e_prov.xml", SW_MODAL, par);	
		if(par.escape===false)
		{			
			/*
			ExecuteSQL(
				"INSERT INTO ^schet" + getColumn("^tmp_tschet", true)
				+ " SELECT " + getColumn("^tmp_tschet", false) 
				+ " FROM ^tmp_tschet WHERE fsum<>0"
				);
			*/
			ExecuteSQL(
			"INSERT INTO ^schet(" + GetPatternIntersection("schet", "sch_exeop") + ")"
			+" SELECT " + GetPatternIntersection("schet", "sch_exeop")
			+" FROM ^tmp_tschet WHERE fsum<>0"
			);				 
		}
	}
	
	// Удалить старые проводки по документам, по которым
	// проводки только-что были сформированы.
	// Перенести новые проводки в SCHET!!!!!
	tblSchet.close();
	return;
	
	par.onEscapeMsg = "Прервать формирование проводок по документу?";
	if(!tblSchet.IsEmpty())
		tblSchet.MoveFirst();	

	while(!tblSchet.IsEOF())
	{
		showWindow("e_prov.xml", SW_MODAL, par);
		tblSchet.MoveNext();
	}
	tblSchet.close();
}

function getMO(db_sc, db_su, db_st, cr_sc, cr_su, cr_st)
{
	var moDb = getSnap(
		"SELECT fmo"
		+ " FROM ^cl_schet"
		+ " WHERE fschet=" + db_sc
			+ " AND fsubschet=" + db_su
			+ " AND fstat=" + db_st
		)[0];

	var moCr = getSnap(
		"SELECT fmo"
		+ " FROM ^cl_schet"
		+ " WHERE fschet=" + cr_sc
			+ " AND fsubschet=" + cr_su
			+ " AND fstat=" + cr_st
		)[0];
		  
	if (moCr<=moDb || moDb==0)
		return moCr;
	else
		return moDb
}

function provToArhive(sMode, idDoc,isReg)
{
	var m = new Object();
	m.FWID = GetUID();	
	m.FMACTION = sMode.charAt(0);
	m.FMDATE = new Date().getVarDate();
	m.FMUSER = getUserName();
	m.FMHOST = getHostName();
	m.FID_DOC = idDoc;
	
	var provXMl = provToXML(idDoc, isReg);
	var oDomDoc = provXMl.getOwnerDocument();
	if (oDomDoc == null)
		return;
	oDomDoc.appendChild(provXMl);
	lpProxy.getDBManager().saveXMLToDB("^provarchive", "fdata", m.FWID, oDomDoc);
	updateTable("^provarchive", m, false,"",true);
	//m.FVER = this.jDoc.getVar("HVER");
}

function provToXML(idDoc, isReg)
{
	var tbl = OpenTable("select * from ^schet where fdoc <> '_R' and fid_doc = " + sqlTo(idDoc)
				+ " and " + idDoc + " >0 "//иначе при нулевом idDoc попадут все проводки без идентификаторов документов и xml и соответственно база быстро разрастутся
			+ " order by Fdate, Fwrk, Fdocnum, FNSECT, FNPROV");
	/*
	if(tbl.isEmpty())
	{
		tbl.close();
		return null;
	}
	*/
	
	var xmlEl = tbl.toXML();
	tbl.close();
	return xmlEl;	
}