/*
	Библиотека для работы с регистрации.
	Аналог RegVars
	13.04.00:
		Пишется независимо от существующей библиотеки как
		попытка ускорить процесс обращения к переменным 
		регистраций.
		
	Объект objDpRegVar - объект для работы с переменными
		регистраци.
		
	objDpRegVar.setFields(tbl)
		Установить запись журнала регистрации, по которой
		будут вычислятся переменные.
	objDpRegVar.getV0(varName)
		Получить значение переменной 
*/

include("doc\\regPar.js")
include("sys\\dpsql.js");

var objDpRegVar = new DpRegVar();
function DpRegVar()
{
	RO("DpRegVar", this);
//	this.tblDocreg = OpenTable("s", "Docreg", "Docreg");
	this.setFields = setFields;
	this.getV0 = getV0;
	this.getS0 = getS0;
	this.getVE = getVE;
	this.getSE = getSE;
	this.getV1 = getV1;
	this.getV2 = getV2;
}

function setFields(tbl)
{
	if(!this.oEval)
	{
		this.oEval = new DpEval();
		this.oEval.oRegVar = this;
	}

	this.tblDocreg = tbl;

	if(false
			|| this.freg!=tbl("freg")
			|| this.fiddeal!=tbl("fiddeal")
			|| this.fid_doc!=tbl("fid_doc")
			|| differ(this.fdoc_dat,tbl("fdoc_dat"))
			|| this.fdoc_lev!=tbl("fdoc_lev")
		)
	{
		this.fdoc     = tbl("fdoc");
		this.fnop     = tbl("fnop");
		this.freg     = tbl("freg");
		this.vid      = jrvid(this.freg);
		this.fiddeal  = tbl("fiddeal");
		this.fid_doc  = tbl("fid_doc");
		this.fdoc_dat = tbl("fdoc_dat");
		this.fdoc_lev = tbl("fdoc_lev");
		this.fisnov1  = tbl("fisnov1");

		this.nSposob	= Number(getRegPar(this.vid, "SPOSOB"));
		
		this.objRegVars = getRegVars(this.vid, 
				SqlInStr("Fattr", "'$'")
					+ " AND NOT "+SqlInStr("Fattr", "'X'")
					+ " AND "+SqlMid("Fvar", 2, 1)+" IN ('D', 'T')"
					+ " AND "+SqlMid("Fvar", 3, 1)+" IN ('P', 'V')"
					+ " AND "+SqlMid("FVar", 1, 1)+" = 'H'"  // не так как в ДОС
				);
		
		this.oEval.setTable(tbl);
		
//		timeBegin("oEval.addExpr");
		for(var i in this.objRegVars)
		{
			this.oEval.addExpr(i, "this.oRegVar.getV0('" + i + "')");
			this.oEval.addExpr("v0" + i, "this.oRegVar.getV0('" + i + "')");
			this.oEval.addExpr("s0" + i, "this.oRegVar.getS0('" + i + "')");
			this.oEval.addExpr("vE" + i, "this.oRegVar.getVE('" + i + "')");
			this.oEval.addExpr("sE" + i, "this.oRegVar.getSE('" + i + "')");
			this.oEval.addExpr("v1" + i, "this.oRegVar.getV1('" + i + "')");
			this.oEval.addExpr("v2" + i, "this.oRegVar.getV2('" + i + "')");
		}
		this.oEval.addExpr("V1DCSUM", "this.oRegVar.getV1('DCSUM')");
		this.oEval.addExpr("V1DCNDS", "this.oRegVar.getV1('DCNDS')");
		
		this.oEval.addExpr("V2DCSUM", "this.oRegVar.getV2('DCSUM')");
		this.oEval.addExpr("V2DCNDS", "this.oRegVar.getV2('DCNDS')");

		this.oEval.addExpr("V1DCSUMV", "this.oRegVar.getV1('DCSUMV')");
		this.oEval.addExpr("V1DCNDSV", "this.oRegVar.getV1('DCNDSV')");
		
		this.oEval.addExpr("V2DCSUMV", "this.oRegVar.getV2('DCSUMV')");
		this.oEval.addExpr("V2DCNDSV", "this.oRegVar.getV2('DCNDSV')");
		
		this.tblS0 = null;
		this.objV1 = null;
//		timeEnd("oEval.addExpr");
	}
}

function getV0(varName)
{
	return this.tblDocreg(
		this.objRegVars[varName.toUpperCase()].FFIELD
		);
}

// Подбитие суммы по предыдущим документам в регисрации
function getS0(varName)
{
	// Если документ не связан ни с кем в регистацию, то
	// сумма любой переменной по предыдущим документам равна 0
	// (в виду отстутствия предыдущих документов)
	if(typeof(this.fiddeal) == "string" && this.fiddeal.trim()==id00.trim())
		return 0;
	
	if(!this.tblS0)
	{
		var sFields = "";
		for(var i in this.objRegVars)
			sFields += ", SUM(A." + this.objRegVars[i].FFIELD + ")"
				+ " AS " + i;
		
		var cCond = "freg=" + sqlTo(this.freg)
				+ " AND fiddeal=" + sqlTo(this.fiddeal);
	
		var dDate = OpenTable("s",
				"SELECT MAX(a.fdoc_dat) AS fdoc_dat"
				+ " FROM ^docreg a"
				+ " WHERE " + cCond
					+ " AND a.fdoc_dat<=" + sqlTo(this.fdoc_dat)
			)("fdoc_dat")
		
		if(dDate)
			cCond += " AND fdoc_dat>=" + sqlTo(dDate)
		
		this.tblS0 = OpenTable("s", 
			"SELECT " + sFields.substr(2)
			+ " FROM ^docreg a"
			+ " WHERE " + cCond
				+ " AND "
					+ sqlCmpVectorsEx("<=", "fdoc_dat", sqlTo(this.fdoc_dat)
						, ">=", " (not fisnov1) ", sqlTo(!this.fisnov1)			//Это не заработает в Oracle!!!
						, "<", "fid_doc", sqlTo(this.fid_doc)
						)
			);
	}
	return this.tblS0(varName);
}

function getVE(varName)
{
	if(this.fisnov1) {
           return 0;
	} else {
		return this.tblDocreg(
			this.objRegVars[varName.toUpperCase()].FFIELD
			);
	}
}

// Подбитие суммы по предыдущим документам в регисрации
function getSE(varName)
{
	// Если документ не связан ни с кем в регистацию, то
	// сумма любой переменной по предыдущим документам равна 0
	// (в виду отстутствия предыдущих документов)
	if(typeof(this.fiddeal) == "string" && this.fiddeal.trim()==id00.trim())
		return 0;
	
	if(!this.tblSE)
	{
		var sFields = "";
		for(var i in this.objRegVars)
			sFields += ", SUM(A." + this.objRegVars[i].FFIELD + ")"
				+ " AS " + i;
		
		var cCond = "freg=" + sqlTo(this.freg)
				+ " AND fiddeal=" + sqlTo(this.fiddeal);
	
		var dDate = OpenTable("s",
				"SELECT MAX(a.fdoc_dat) AS fdoc_dat"
				+ " FROM ^docreg a"
				+ " WHERE " + cCond
					+ " AND a.fdoc_dat<=" + sqlTo(this.fdoc_dat)
			)("fdoc_dat")
		
		if(dDate)
			cCond += " AND fdoc_dat>=" + sqlTo(dDate)
		
		this.tblSE = OpenTable("s", 
			"SELECT " + sFields.substr(2)
			+ " FROM ^docreg a"
			+ " WHERE " + cCond
                                + " AND fisnov1="+SqlFalse
				+ " AND "
					+ sqlCmpVectors("<"
						, "fdoc_dat", sqlTo(this.fdoc_dat)
						, "fdoc_lev", sqlTo(this.fdoc_lev)
						, "fid_doc", sqlTo(this.fid_doc)
						)
			);
	}
	return this.tblSE(varName);
}

function getV1(varName)
{
	return this.fisnov1? 0: this.getV2(varName);
}

function getV2(varName)
{
	if(this.nSposob==2 && !inList(varName,"DCSUM","DCNDS","DCSUMV","DCNDSV"))
	{
		// Вставить проверку - является ли переменная по НДС??
		if(strIn("N", this.objRegVars[varName].FATTR))
			return this.getV0(varName);
	}

	varName = varName.toUpperCase();
	if(!this.objV1)
	{
		this.objV1 = new Object();
		var tblCl_reg = OpenTable("s", 
			"SELECT *"
			+ " FROM ^cl_reg"
			+ " WHERE fdoc=" + sqlTo(this.fdoc)
				+ " AND fnop=" + sqlTo(this.fnop)
				+ " AND freg=" + sqlTo(this.freg)
				+ " AND fnom<>0" 
				+ " AND " + SqlMid("Fvar", 2, 1) + " IN ('D', 'T')"
				+ " AND " + SqlMid("Fvar", 3, 1) + " IN ('P', 'V')"
				+ " AND " + SqlMid("FVar", 1, 1) + " = 'H'"
			);
		
		var exprV1DCNDS = "", exprV1DCSUM = "", exprV1DCSUMV = "", exprV1DCNDSV = "";
		if(!tblCl_reg.IsEmpty())
			tblCl_reg.MoveFirst();
		while(!tblCl_reg.IsEOF())
		{
			var v = this.objRegVars[tblCl_reg("fvar").toUpperCase()];
			if(v)
			{
				var cOp = v.FVAR.charAt(2);
			
				var expr = tblCl_reg("f1value").replace(/~/g, tblCl_reg("fvar").substr(3));
			
				if(strIn("N", v.FATTR) && (cOp=="P" || cOp=="V"))
				{
					if(this.nSposob==2)
						expr = "V0" + v.FVAR;
						
					exprV1DCNDS += "+" + expr;
					if(cOp=="P")
						exprV1DCNDSV += "+" + expr;
					else
						exprV1DCNDSV += "-" + expr;
				}
				else if((strIn("O", v.FATTR) || strIn("B", v.FATTR)) 
						&& (cOp=="P" || cOp=="V"))
				{
					exprV1DCSUM += "+" + expr;
					if(cOp=="P")
						exprV1DCSUMV += "+" + expr;
					else
						exprV1DCSUMV += "-" + expr;
				}
			
				this.objV1[tblCl_reg("fvar").toUpperCase()] = expr;
			}
			else
			{
				alert("В схеме регистрации документа "
					+ this.fdoc + " " + this.fnop 
					+ " (журнал регистрации N" + this.freg + ")"
					+ "\nиспользуется ошибочная переменная " + tblCl_reg("fvar")
					);
			}
			tblCl_reg.MoveNext();
		}
		this.objV1["DCSUM"] = exprV1DCSUM.substr(1);
		this.objV1["DCNDS"] = exprV1DCNDS.substr(1);
		this.objV1["DCSUMV"] = exprV1DCSUMV;
		this.objV1["DCNDSV"] = exprV1DCNDSV;
	}
	
	if(this.objV1[varName])
		return this.oEval.eval(this.objV1[varName]);
	else
		return 0.0;
}

/*
function DpRegVar.prototype.getV2(varName)
{
//	return this.fisnov1? 0: this.getV1(varName);
	varName = varName.toUpperCase();
	if(!this.objV1)
	{
		this.objV1 = new Object();
		var tblCl_reg = OpenTable("s", 
			"SELECT *"
			+ " FROM ^cl_reg"
			+ " WHERE fdoc=" + sqlTo(this.fdoc)
				+ " AND fnop=" + sqlTo(this.fnop)
				+ " AND freg=" + sqlTo(this.freg)
				+ " AND fnom<>0" 
				+ " AND " + SqlMid("Fvar", 2, 1) + " IN ('D', 'T')"
				+ " AND " + SqlMid("Fvar", 3, 1) + " IN ('P', 'V')"
				+ " AND " + SqlMid("Fvar", 1, 1) + " = 'H'"
			);
		
		var exprV1DCNDS = "", exprV1DCSUM = "";
		if(!tblCl_reg.IsEmpty())
			tblCl_reg.MoveFirst();
		while(!tblCl_reg.IsEOF())
		{
			var v = this.objRegVars[tblCl_reg("fvar").toUpperCase()];
			if(v)
			{
				var cOp = v.FVAR.charAt(2);
			
				var expr = tblCl_reg("f1value").replace(/~/g, tblCl_reg("fvar").substr(3));
			
				if(strIn("N", v.FATTR) && (cOp=="P" || cOp=="V"))
					exprV1DCNDS += "+" + expr;
				else if((strIn("O", v.FATTR) || strIn("B", v.FATTR)) 
						&& (cOp=="P" || cOp=="V"))
					exprV1DCSUM += "+" + expr;
			
				this.objV1[tblCl_reg("fvar").toUpperCase()] = expr;
			}
			else
			{
				alert("В схеме регистрации документа "
					+ this.fdoc + " " + this.fnop 
					+ " (журнал регистрации N" + this.freg + ")"
					+ "\nиспользуется ошибочная переменная " + tblCl_reg("fvar")
					);
			}
			tblCl_reg.MoveNext();
		}
		this.objV1["DCSUM"] = exprV1DCSUM.substr(1);
		this.objV1["DCNDS"] = exprV1DCNDS.substr(1);
	}
// super заменим V0 и S0 на VE и SE
         this.objV1["DCSUM"] = this.objV1["DCSUM"].replace(/V0/g,"VE");
         this.objV1["DCSUM"] = this.objV1["DCSUM"].replace(/S0/g,"SE");
         this.objV1["DCNDS"] = this.objV1["DCNDS"].replace(/V0/g,"VE");
         this.objV1["DCNDS"] = this.objV1["DCNDS"].replace(/S0/g,"SE");
// end super
	
	if(this.objV1[varName])
		return this.oEval.eval(this.objV1[varName]);
	else
		return 0.0;
}
*/

// Функция возвращает вид журнала регитрации по номеру
function jrvid(jrno)
{
	var tblCl_reg = getCl_reg();
	if(tblCl_reg.Seek("=", jrno, "", 0, 0))
		return tblCl_reg("fvid");
	else
		return "";
}

// Функция возвращает открытую таблицу справочника схем
// регистрации. Возвращается все время одна и та же таблица,
// таким образом экономим время на повторных открытия.
var getCl_reg_tbl;
function getCl_reg()
{
	if(!getCl_reg_tbl) {
		getCl_reg_tbl = OpenTable("s", "cl_reg", "cl_reg");
		if (SQL)
			getCl_reg_tbl.Index = "FREG,FDOC,FNOP,FNOM";
	}
	return getCl_reg_tbl;
}

var getDocreg_tbl;
function getDocreg()
{
	if(!getDocreg_tbl) {
		getDocreg_tbl = OpenTable("s", "docreg", "docid");
		if (SQL)
			getDocreg_tbl.Index = "FID_DOC,FREG";
	}
	return getDocreg_tbl;
}

// Объект для получения переменных регистраций 
var allRegVars = new Object();
// Получить объект-коллекцию переменных регистраций по 
// указанному виду журнала и по условию
function getRegVars(cVid, cVarCond)
{
	if(!allRegVars[cVid])
		allRegVars[cVid] = new Object();
		
	if(!allRegVars[cVid][cVarCond])
	{
		var obj = new Object();
		
//		timeBegin("OpenTable");
		var tbl = OpenTable("s",
				"SELECT *"
				+ " FROM ^varreg"
				+ " WHERE ( "+SqlInStr("fattr",sqlTo(cVid))
						+ " OR "+SqlInStr("fattr", "'0'")
						+ " OR "+SqlInStr("fattr", "'!'")
						+ ")"
					+ (cVarCond? " AND " + cVarCond: "")
				);
//		timeEnd("OpenTable");
		
		while(!tbl.IsEOF())
		{
			var varDef = new Object();
			varDef.FVAR = allt(tbl("fVar"));
			varDef.FFIELD = allt(tbl("fField"));
			varDef.FREXPR = tbl("fRExpr").replace(/~/g, varDef.FFIELD);
			varDef.FWEXPR = tbl("fWExpr").replace(/~/g, varDef.FFIELD);
			varDef.FATTR = tbl("fAttr");
			
			obj[varDef.FVAR] = varDef;
			
			tbl.MoveNext();
		}
		allRegVars[cVid][cVarCond] = obj;
	}
	
	return allRegVars[cVid][cVarCond];
}

// Вычислить выражение по переменным регистраций
// стоя на нужной строке журнала регистрации.
var jrv_tmp = 0;
function jrv(jrExpr, jrPref)
{
//	timeBegin("function jrv " + jrExpr);
//	timeBegin("setFields");
	objDpRegVar.setFields(this.getTable());
//	timeEnd("setFields");
//	timeBegin("eval " + jrExpr);	
	var retVal = objDpRegVar.oEval.eval(jrExpr)
//	timeEnd("eval " + jrExpr);	
//	timeEnd("function jrv " + jrExpr);
	
	return retVal;
}

// Вычислить выражение по переменным регистраций
// стоя на нужном документе.
function jr_(nReg, sExpr)
{
	var tblDoc = this.getTable();
	var fdoc = tblDoc("fdoc"),
		fwid = tblDoc("fwid");
	var uRet = 0;
	
	var tblDocreg = getDocreg();
	if(tblDocreg.Seek("=", fwid, nReg))
	{
		// Не понял, зачем я написал когда-то нижеследующие строки,
		// занесенные под комментарий.
		// Даже если документ не связан ни с кем в регистрацию, у него
		// могут быть переменные!!!
		//if(tblDocreg("fiddeal"))
		//{
			objDpRegVar.setFields(tblDocreg);
			uRet = objDpRegVar.oEval.eval(sExpr)
		//}
		//else
		//	WAIT("У документа не связанная запись по схеме регистрации "+nReg);
			
	}
	else
		WAIT("У документа нет записи по схеме регистрации "+nReg);
	
	return uRet;
}

function jrvar(cVar, jrno)
{
	return jr_(jrno, cVar);
}

function sumreg(reg, expr, filter)
{
	var fdoc = this.getVar("fdoc"),
		fid_doc = this.getVar("fwid");
	var sum = 0;
	
	reg = this.tEval("n", reg);  // номер журнала регистрации передается выражением

	var tblDocReg = OpenTable("s", "docreg", "docid");
	if (SQL)
		tblDocReg.Index = "FID_DOC,FREG";
	if(!tblDocReg.Seek("=", fid_doc, reg))
	{
		WAIT("У документа нет схем регистрации");
	}
	else
	{
		var fiddeal = tblDocReg("fiddeal");
		
		var bm = tblDocReg.bookmark;
		tblDocReg.Index = "orgreg";
		if (SQL)
			tblDocReg.Index = "FORG,FREG,FIDDEAL,FDOC_DAT,FDOC_LEV,FID_DOC";
			
		tblDocReg.bookmark = bm;
		
		tblDocReg.MovePrev();
		while(!tblDocReg.IsBOF() && tblDocReg("fiddeal")==fiddeal)
		{
			if(this.tEval("b", filter))
				sum += this.eval("expr");
			tblDocReg.MovePrev();
		}
	}
	return sum;
}

function reg_ob(reg, expr, dat1, dat2)
{
	tblDocReg = OpenTable("s"
		, "SELECT *"
		+ " FROM ^docreg"
		+ " WHERE freg=" + reg
			+ " AND fdoc_dat BETWEEN" + sqlTo(dat1)
				+ " AND " + sqlTo(dat2)
		);

	var nSum = 0;
	
	for(; !tblDocReg.IsEOF(); tblDocReg.MoveNext())
	{
		objDpRegVar.setFields(tblDocReg);
		nSum += objDpRegVar.oEval.eval(expr);
	}
	
	return nSum;
}

// Сумма всех сделок, у которых оплата и отгрузка была
// совершена за укаазнный период.
function reg_2way(reg, dat1, dat2, cWay1Expr, cWay2Expr)
{
	var tblDocReg = OpenTable("s",
		"SELECT *"
		+ " FROM ^docreg"
		+ " WHERE freg=" + reg
			+ " AND fdoc_dat BETWEEN" + sqlTo(dat1)
				+ " AND " + sqlTo(dat2)
		);

	var aSums1 = new Object()
		, aSums2 = new Object();
	
	
	for(; !tblDocReg.IsEOF(); tblDocReg.MoveNext())
	{
		objDpRegVar.setFields(tblDocReg);	
		
		fiddeal = tblDocReg("fiddeal");
		
		if(!aSums1[fiddeal])
			aSums1[fiddeal] = 0;
		if(!aSums2[fiddeal])
			aSums2[fiddeal] = 0;
		
		aSums1[fiddeal] += objDpRegVar.oEval.eval(cWay1Expr);
		aSums2[fiddeal] += objDpRegVar.oEval.eval(cWay2Expr);
	}
	
	var nSum = 0;
	for(fiddeal in aSums1)
	{
		nSum += Math.min(aSums1[fiddeal], aSums2[fiddeal]);
	}
	
	return nSum;
}
