include("doc\\DpDoc.js");
include("sys\\docinfo.js");
include("sys\\udfs.js");
include("sys\\kolr.js");
include("sys\\dbase.js");
include("sub\\mtr.js");
include("sys\\ListApi.js");
include("Objects/DpScannerHandler.js");

var fields2copy = null;
var ROW_PTN = "ANLTK";						//шаблон таблицы из которой идут строки
var BUF_PTN = "NAKL_BUF";				 	//шаблон буфера для строк
var pocketName = "TMP_POCKET_FOR_NAKL"; 	// Карман

function DpNakl(objDoc, dlg)
{			
	this.oDoc = objDoc;
	this.dlg = dlg;		
	this.mode = dlg.sMode;	
	this.sTmpTbl = getTmpTableName();
	this.rowsName = null;
	this.tbl4Grid = null;
	this.bufName = null;
	this.where = null;
	this.orderBy = null;	
	this.fwid = null;
	this.fields2copy = null;
	this.pocketName = pocketName;
	this.nds = 20;	
	this.old = false;		//старый документ со строками в АNLTK_%LD, не редактируется
	this.remote = false;	//очень старый документ, строки удалены и забыты
	
	this.WithoutWND = false;
	this.load = DpNakl_load;
	this.loadMenu = DpNakl_loadMenu;       		// Загрузка меню
	this.gridHeaderMenuInit = DpNakl_HeaderMenuInit;	
	this.processMenu = DpNakl_processMenu; 		// Активизация меню	
	this.gridHeaderMenuRun = DpNakl_HeaderMenuRun
	this.loadBuf = DpNakl_loadBuf;     			// Загрузить буфер срок
	this.loadGrid = DpNakl_loadGrid;			// Загрузить грид
	this.gridTblInit = DpNakl_gridTblInit;
	this.wItog = DpNakl_wItog;  				// Подбивка итогов
	this.save = DpNakl_save;					// Сохранить накладную
	this.saveRows = DpNakl_saveRows;			// Сохранить строки в rowsName
	this.loadFrom = DpNakl_loadFrom;			// Загрузить в буфер строки из таблицы
	this.modifyData = DpNakl_modifyData;		// Обмен данными между двумя таблицами
	this.refreshViewer = DpNakl_refreshViewer;	// Обновить данные 
	this.doMass = DpNakl_doMass;
	this.getCondRows = DpNakl_getCondRows;
	this.loadNDS = DpNakl_loadNDS;
	this.addRowsMassFifo = DpNakl_addRowsMassFifo;
	this.addRowsMass = DpNakl_addRowsMass;
	this.onInputLineCode = DpNakl_onInputLineCode;
	this.dispose = DpNakl_dispose;
	this.validSc = DpNakl_validSc;
	nk = this;
}

function DpNakl_load()
{		
	if(this.rowsName == null)
		this.rowsName = this.getRowsName();
	else
		ROW_PTN = this.rowsName;
	
	fields2copy = GetPatternIntersection(ROW_PTN, ROW_PTN);
	if(this.fields2copy != null)
		fields2copy += this.fields2copy;
	this.fields2copy = fields2copy;
	
	var k = this.oDoc.sDocLbl.indexOf(":");//обрабатываем документы из модулей
	this.sDocLbl = String(k==-1?this.oDoc.sDocLbl:this.oDoc.sDocLbl.substr(k+1)).toUpperCase();
	this.moduleName = (k==-1?null:this.oDoc.sDocLbl.substr(0,k).toLowerCase());
	
	this.bufName = "TMP_BUF" + "_" + this.sDocLbl + "_Org" + iOrg;	
	//this.sTmpTbl = "TMP_BUF" + "_" + this.sDocLbl + "_Org_tttt" + iOrg;	
	this.oDoc.bufName = this.bufName;
	this.fwid = this.oDoc.getID();
		
	this.loadBuf();    		// Создать буфер для редактирования
	if (this.WithoutWND == false)
	{
	this.loadGrid();
	}
	
	var frtype = this.oDoc.getAttr("RTYPE");
	this.where = " FID_DOC = "+ sqlTo(this.fwid);
	if(typeof frtype == "string")
		this.where += " AND FRTYPE = "+ sqlTo(frtype);
		
	this.loadNDS();
	
	if(this.old)
	{
		btnOK.setEnabled(false);
		if (typeof(btnApply) != "undefined")
			btnApply.setEnabled(false);
	}
	
	if(this.mode=="MASS_EDIT")
	{
		if (typeof(btnApply) != "undefined")
			btnApply.setEnabled(false);
	}
	initObjectMenu();
	
	this.oScan = new DpScannerHandler(grid.getTableControl());
	this.oScan.setHandler(this, "onInputLineCode");
}	

function DpNakl_loadBuf()
{	
	if(this.mode=="MASS_EDIT")
	{
		CreateTable(this.bufName, ROW_PTN, "FWID");
		return;
	}
	
	if(typeof docLoadBuf == "function")
	{
		docLoadBuf();
		return;
	}	
	var nId = (this.mode == "COPY") ? this.oDoc.nOldID : this.fwid;
		
	CreateTable(this.bufName, ROW_PTN, "FWID");			
	ExecuteSQL("DELETE FROM "+ this.bufName, false);
	if(this.remote)
		return;
	nk.modifyData("COPY", this.bufName, fields2copy, this.rowsName, nId);
	
	if(this.old)
		return;		
	CreateTable(this.sTmpTbl, ROW_PTN);	
	ExecuteSQL("DELETE FROM "+ this.sTmpTbl, false);
	nk.modifyData("COPY", this.sTmpTbl, fields2copy, this.rowsName, this.fwid);
}

function DpNakl_loadGrid(oGrid)
{		
	var sXmlFileName = "rowlist.xml";		
	if(this.moduleName)
		this.sDocSourceDir = lpProxy.getModulePath(this.moduleName) + "/scripts/docs/" + this.sDocLbl + "/";
	else
		this.sDocSourceDir = rootDirectory() + "docs/" + this.sDocLbl + "/";
	
	if (!oGrid)	
	{
		oGrid = grid;
		this.gridTblInit();
	}		
		
	oGrid.setXMLDir(this.sDocSourceDir);			
	//oGrid.addExtention("#", sXmlFileName);	
	oGrid.setXMLFile(sXmlFileName);
	oGrid.addExtPage();
	if (this.oDoc.nNop != 0)
		oGrid.addExtPage("ext0");
	
	oGrid.build();
	oGrid.setHelp("docs_" + this.sDocLbl);
	//PlatformUI.getWorkbench().getHelpSystem().setHelp(FORM.getShell(), "org.debet.DebetApp.rcp.docs_" + this.oDoc.sDocLbl);
	oGrid.loadMenuHandler(this,"loadMenu");
	oGrid.selectMenuHandler(this,"processMenu");
	oGrid.setHeaderMenuLoader(this,"gridHeaderMenuInit");
	oGrid.setHeaderMenuSelector(this,"gridHeaderMenuRun");
}

function DpNakl_gridTblInit()
{
	include("sys/ListApi.js");
	initGridVars();
	
	var sWhere = '';	
	var frtype = this.oDoc.getAttr("RTYPE");	
	if(this.where != '' && typeof frtype == "string")	
		sWhere = " WHERE FRTYPE = "+ sqlTo(frtype);		
	if(this.qryOrder)
	{
		this.orderBy = this.qryOrder[0];
		for(var i=1; i<this.qryOrder.length; i++)
			this.orderBy += ", "+ this.qryOrder[i];
	}
	var sOrder = " order by fnom_str, fwid";
	var nOrder = Number(objDoc.getPar("_row_order"));
	if(nOrder==2)
		sOrder = " order by FNMKL";
	if(typeof this.orderBy == "string")
		sOrder = " order by "+ this.orderBy;
					
	if (extPar && (extPar.idtmpl || extPar.isTransform))
	{
		this.oDoc.gotoFirstRow(); //загружаем все строки в объект
		
		do
		{
			var currChild = this.oDoc.getCurrRow();
			if (currChild == null)
				continue;
				
			obj2DB(currChild.jDoc.getObjectID(),currChild.jDoc, null, this.bufName);
			currChild.saveExtToDB();
		}
		while(this.oDoc.gotoNextRow())
	}
	
	
	this.tbl4Grid = OpenTable(
		"select *"
		+ " from "+ this.bufName 
		+ sWhere 
		+ sOrder
		);
		
	this.doTie(this.tbl4Grid);
	if(typeof docTblTie == "function")
		docTblTie();
		
	if(this.mode == "COPY" || (extPar && this.mode == "ADD" && extPar.idtmpl))
		this.oDoc.resetFnids(this.tbl4Grid, "ROW", this.oDoc);
		
				

	grid.setTable(this.tbl4Grid);
}

DpNakl.prototype.doTie = function(tbl)
{
	var sExtAlias = "ext0";
	
	tbl.tie("cl_nmk","nmk","fwid","Fnmkl");	
	tbl.tie("cl_edi","edi1","cod","nmk.Fcedib");	
	tbl.tie("cl_edi","edi2","cod","nmk.Fedi1");
	
	tbl.tie("anltk","pn1","FWID","Fid_pn");
	tbl.tie("sch_zag","h","fwid","pn1.fid_doc");
	
	var sClass = this.oDoc.sDocLbl+".ROW";
	tbl.ExtTie("R", sClass, String(this.oDoc.nNop));
	if (this.oDoc.nNop != 0)
		tbl.ExtTieEx(sExtAlias, "FWID", "R", sClass, "");
			
}

function DpNakl_loadMenu()
{		
	if(this.mode=="MASS_EDIT")
		return false;
	//AL: Устанавливаем фокус, чтоб сработала валидность
	//, а то при вызове меню правой кнопкой мыши - нет потери фокуса. 
	grid.setFocus();
	loadObjectMenu(); 
	
	grid.AddMenuItem("+++", "Масове введення|Массовый ввод");
		if (this.sDocLbl == "VR")
		{
			grid.AddMenuItem("MASS_DOC", "За рядками видаткового документа|По строкам расходного документа");
			grid.AddMenuItem("","");
		}
		grid.AddMenuItem("MASS_CL", "За довідником номенклатури|По справочнику номенклатуры");
		grid.AddMenuItem("MASS_VDOST_CALC", "За відомістю залишків (розрахунок)|По ведомости остатков (расчет)");
		grid.AddMenuItem("MASS_VDOST_VIEW", "За відомістю залишків (перегляд)|По ведомости остатков (просмотр)");
		grid.AddMenuItem("MASS_PRICE", "За прайс-листом|По прайс-листу");
	grid.AddMenuItem("---", "");

	
	if (this.mode=="VIEW")
	{
		grid.AddMenuItem("","");
		grid.AddMenuItem("FIND", "Пошук|Поиск");
		grid.AddMenuItem("SELECT", "Відбір|Отбор");
		return true;
	}
	
	if(IsDblClick())
	{
		this.processMenu("EDIT");
		return false;
	}
		
	if(!grid.getTable().isEmpty())
		grid.AddMenuItem("TOPOCKET","Копія в кишеню|Копия в карман");	
		
	if(IsTable(pocketName))	
		grid.AddMenuItem("FROMPOCKET","Вставка з кишені|Вставка из кармана");
	
	grid.AddMenuItem("","");
	
	if(typeof docMenuInit == "function")
		docMenuInit();

	if (getPar("is_debug"))
	{
		grid.AddMenuItem("", "");		
		grid.AddMenuItem("DEBUG_BROWSE","BROWSE");		
	}
	
	if(grid.getTable().isEmpty())
	{
		grid.AddMenuItem("ADD","Додавання | Добавление");
		return;
	}
	if(!grid.getTable().isEmpty() && (this.sDocLbl=="RU" || this.sDocLbl=="SU"))
	{
		grid.AddMenuItem("PRINTAKT","Друк актів прийому-передачі|Печать актов приёма передачи",9);
		grid.AddMenuItem("PRINCONV","Друк конвертів|Печать конвертов",9);
	}
	grid.AddMenuItem("","");
	grid.AddMenuItem("RECALC_OST","Розрахунок залишків|Расчет остатков");	

	grid.AddMenuItem("+++", "Сервіс|Сервис");		
		grid.AddMenuItem("REBUILD_NUM","Переформувати номери|Переформировать номера");
		grid.AddMenuItem("REBUILD_OST","Перерахунок залишків|Перерасчет остатков");
		grid.AddMenuItem("","");
		grid.AddMenuItem("BROWSESREC","Показати середні ціни|Показать средние цены");
		grid.AddMenuItem("","");
		if(typeof docMenuServis == "function")
			docMenuServis();
		grid.AddMenuItem("SETFID_PN", "Встановити поставку з поточного рядка|Установить поставку из текущей строки");
		grid.AddMenuItem("SETPOST", "Встановити постачальника з поставки|Установить поставщика из поставки");
		grid.AddMenuItem("ROUNDSUM", "Розрахувати суму за округленими цінами|Рассчитать сумму по округленным средним ценам");		

		if (this.sDocLbl == "VM")
		{
			grid.AddMenuItem("VMCENA", "Восстановить цены");
		}
		
	grid.AddMenuItem("---", "Сервис");
	
	grid.AddMenuItem("KSU_NMKL","Картка складського обліку|Карточка складского учета");
	
	grid.AddMenuItem("ADD","Додавання | Добавление");
	grid.AddMenuItem("EDIT","Редагування | Редактирование");
	grid.AddMenuItem("COPY","Копіювання | Копирование");
	grid.AddMenuItem("DEL","Видалення | Удаление");	
	
	grid.AddMenuItem("","");
	grid.AddMenuItem("+++","Експорт|Экспорт");
		grid.AddMenuItem("EXPORTCALC","Calc");
		grid.AddMenuItem("EXPORTXLS","Формат xls");
	grid.AddMenuItem("---","");
	
	grid.AddMenuItem("","");
	grid.AddMenuItem("FIND", "Пошук|Поиск");
	grid.AddMenuItem("SELECT", "Відбір|Отбор");
}

function DpNakl_HeaderMenuInit(oCol, toObject)
{
	if(this.mode=="MASS_EDIT")
		return false;
	
	if (this.subHeaderMenuInit)
		this.subHeaderMenuInit(oCol,toObject);
	
	var bCanSort = oCol && !oCol.getField().startsWith("=");
	if (bCanSort)
	{
		var nInd = String(oCol.getField().indexOf("."));
		if (nInd != -1)
		{
			var sAlias = oCol.getField().substring(0,nInd);
			bCanSort = bCanSort && grid.getTable().GetTie(sAlias) == null;
		}
	}
		
	if (bCanSort && !(this.subSortInit && this.subSortInit(oCol,toObject)))
	{
		toObject.addHeaderMenuItem("+++","Сортування |Сортировка ");
		toObject.addHeaderMenuItem("SORT_UP","За збільшенням|По возрастанию");
		toObject.addHeaderMenuItem("SORT_DOWN","За зменшенням|По убыванию");
		toObject.addHeaderMenuItem("","");
		var parArr = grid.getStructHolder().listParams();
		var srtArr = new Array();
		for (var nPar = 0; nPar < parArr.length; nPar++)
		{
			if (String(parArr[nPar]).substr(0,5) == "SORT_")
				srtArr[srtArr.length] = String(parArr[nPar]).substr(5);
		}
		if (srtArr.length > 0)
		{
			toObject.addHeaderMenuItem("+++","Вибрати...|Выбрать...");
			for (var nSrt = 0; nSrt < srtArr.length; nSrt++)
			{
				var srtTxt = srtArr[nSrt];
				if (String(srtTxt).length > 40)
					srtTxt = srtTxt.substr(0,40) + "...";
				toObject.addHeaderMenuItem("SORT_" + srtArr[nSrt],srtTxt,(this.headerCurSort == "SORT_" + srtArr[nSrt]?ICON_RADIO:0));
			}
			toObject.addHeaderMenuItem("","");
		}
		toObject.addHeaderMenuItem("SORT_CUSTOM","Вибрати...|Выбрать...",(this.headerCurSort == "SORT_CUSTOM"?ICON_RADIO:0));
		if (srtArr.length > 0)
			toObject.addHeaderMenuItem("---","");
		toObject.addHeaderMenuItem("SORT_DEFAULT","Стандарт",(this.headerCurSort == "SORT_DEFAULT"?ICON_RADIO:0));
		toObject.addHeaderMenuItem("---","");
	}
}

function DpNakl_HeaderMenuRun(sID, oColInfo, toObject)
{	
	this.qryOrder = new Array();	
	if (sID.substr(0,4) == "SORT")
	{		
		if ("SORT_UP" == sID || "SORT_DOWN" == sID)
		{
			if (!this.headerSortI)
				this.headerSortI = this.qryOrder.length;
			this.qryOrderI = this.headerSortI;
			this.qryOrder[this.headerSortI] = String(oColInfo.getField()) 
												+ ("SORT_DOWN" == sID?" DESC":"") ;
			this.gridTblInit(true);
			if (this.lastSortCol != null)
			{
				var nInd = grid.getColumns().indexOf(this.lastSortCol);
				if (nInd != -1)
					grid.setColImage(nInd, null);
			}
			this.lastSortCol = oColInfo;
			var nInd = grid.getColumns().indexOf(oColInfo);
			if (nInd != -1)
			{
				if (sID == "SORT_UP")
					grid.setColImage(nInd,rootDirectoryEx() + "/icons/arru.gif");
				else
					grid.setColImage(nInd,rootDirectoryEx() + "/icons/arrd.gif");
			}				
		}
		else if ("SORT_DEFAULT" == sID)
		{
			if (this.headerSortI)
			{
				this.qryOrder = this.qryOrder.slice(0,this.qryOrder.length - 1);
				this.qryOrderI = 0;
			}
			this.gridTblInit(true);
			var nInd = grid.getColumns().indexOf(this.lastSortCol);
			if (nInd != -1)
				grid.setColImage(nInd,null);
			this.lastSortCol = null;
		}
		else if ("SORT_CUSTOM" == sID)
		{
			var oPar = new Object();
			oPar.cols = grid.getColumnsArray();
			showWindow("dpGridSort.xml",SW_MODAL,oPar);
			if (oPar.escape)
			{
				sID = this.headerCurSort;
			}
			else
			{
				var ord = "";
				var name = "";
				for (var i = 0; i < oPar.ret.cols.length; i++)
				{
					if (i != 0)
						ord = ord + ", ";
					ord = ord + oPar.ret.cols[i].getField();
					name = name + (name != ""?" + ":"") 
							+ String(oPar.ret.cols[i].getCaption()).replace("\n"," ");
				}
				
				if (grid.getStructHolder().getPar(name) == "")
				{
					grid.getStructHolder().setPar("SORT_" + name,ord);
				}
				
				if (!this.headerSortI)
					this.headerSortI = this.qryOrder.length;
				this.qryOrderI = this.headerSortI;
				this.qryOrder[this.headerSortI] = ord
				this.gridTblInit(true);
				sID = "SORT_" + name;
			}
		}
		else if (grid.getStructHolder().getPar(sID) != "")
		{
			if (!this.headerSortI)
				this.headerSortI = this.qryOrder.length;
			this.qryOrderI = this.headerSortI;
			this.qryOrder[this.headerSortI] = grid.getStructHolder().getPar(sID);
			this.gridTblInit(true);
		}
		this.headerCurSort = sID;
	}
	if (this.subHeaderMenuRun && this.subHeaderMenuRun(sID,oColInfo,toObject) == DpList_exit)
		return;
	
	if (sID == "DOUBLECLICK")
	{
		var bCanSort = oColInfo && !oColInfo.getField().startsWith("=");
		if (bCanSort)
		{
			var nInd = String(oColInfo.getField().indexOf("."));
			if (nInd != -1)
			{
				var sAlias = oColInfo.getField().substring(0,nInd);
				bCanSort = bCanSort && this.tbl.GetTie(sAlias) == null;
			}
		}
		if (!bCanSort)
			return;
		if (this.headerCurSort == "SORT_UP" && this.lastSortCol == oColInfo)
			this.gridHeaderMenuRun("SORT_DOWN",oColInfo,toObject);
		else if (this.headerCurSort == "SORT_DOWN" && this.lastSortCol == oColInfo)
			this.gridHeaderMenuRun("SORT_DEFAULT",oColInfo,toObject);
		else 
			this.gridHeaderMenuRun("SORT_UP",oColInfo,toObject);
		
	}
	grid.refresh();
}

function DpNakl_processMenu(sID)
{
	if(typeof updateData == "function")
		updateData();
	 
	runObjectMenu(sID);
	this.bRefresh = true;
		
	if(typeof docMenuHandler == "function")
	{
		if(docMenuHandler(sID)!=false)
		{
			if(this.bRefresh)
				this.refreshViewer();
			return;
		}
	}
					
	switch(sID)
	{
		case "DEL":
			if("-"!=msgBox("c-"
				, ru("Подтвердите удаление записи", "Підтвердіть вилучення запису")
				, ru("Удаление записи", "Вилучення запису")))
				break;
				
			this.oDoc.deleteRow("ROW", Number(grid.getTable().getRowID()));

			//- понесём записи из буф.
			var fid = grid.getTable().getRowID();
			var dblFid = GetNextUID(fid,false);
			
			var sSQL = "DELETE FROM " + grid.getTable().getTableName()
					 + " WHERE FWID=" + sqlTo(fid)
					 + (dblFid != null?" OR FWID=" + sqlTo(dblFid):"");
			ExecuteSQL(sSQL);
			//-						
			break;
			
		case "__XDEL":	//массовое удаление 
			var delRowCount = DataSource().getSelectedCount();
			if (delRowCount <= 0)
				return;
			var selIds = DataSource().getSelectedIDs();
			var sCapt = ru("Удаление записей", "Видалення записів");
			var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів")+" (" + DataSource().getSelectedCount() + ").";
			var sMsgRet = msgBox("c-", sMsg, sCapt);
			if("c"==sMsgRet || sMsgRet.length==0)
				return;
			setProgressRange(0, delRowCount);
			//findFwidForXDel();
			for (var nRow = 0; nRow < selIds.length; nRow++)
			{
				setProgressPos(nRow + 1, sCapt +": "+ (nRow + 1) +"/"+ delRowCount);
				this.oDoc.deleteRow("ROW", Number(selIds[nRow]));
				
				var fid = Number(selIds[nRow]);
				var dblFid = GetNextUID(fid,false);
				
				var sSQL = "DELETE FROM " + grid.getTable().getTableName()
						 + " WHERE FWID=" + sqlTo(fid)
						 + (dblFid != null?" OR FWID=" + sqlTo(dblFid):"");
				ExecuteSQL(sSQL);				
			}
			var sSQL = "DELETE FROM " + grid.getTable().getTableName()
					 + " WHERE " + grid.sqlSelected()				 
			ExecuteSQL(sSQL);			
			grid.clearSelected();
			setProgressPos(0);
			break;

		case "ADD": case "EDIT": case "COPY":		
			if(this.oDoc.getPar("_gridedit") || this.gridedit)
				break;
			var oDocRow;
			if(sID == "ADD")
				oDocRow = this.oDoc.createRow("ROW");
			else if(sID == "EDIT")
				oDocRow = this.oDoc.getRow("ROW",Number(grid.getTable().getRowID()));
			else if(sID == "COPY")
				oDocRow = this.oDoc.copyRow("ROW",Number(grid.getTable().getRowID()));			
			this.bRefresh = false;
			var bSaveRow = false;										
			if(oDocRow != null)
				bSaveRow = oDocRow.edit(sID)			
			if (bSaveRow)
			{
				this.bRefresh = true;
				if(inList(sID,"ADD","COPY"))
					this.oDoc.appendRow("ROW", oDocRow);				
				
				handleEvent("afterSaveNaklRow", oDocRow);				
				obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, this.bufName);															
			}						
			break;
		
		case "PRINTAKT":
			include("objects/DpTVars.js");
			include ("Objects/DpExtentionBuilder.js");
			var oExt = new DpExtentionBuilder("CL","0",null);
			if(oExt.exist())
			{
				var extTblName = oExt.getValueTableName();
				var sqlWhere = grid.selectedCount>0?" b.Fwid "+grid.sqlSelected(true):" 1=1 ";
				var tbl = OpenTable("SELECT b.*, c.Fdog_num, c.Fdoc_dat AS Fdog_dat, o.Flpu, h.Fru_dat "
									+" FROM " + this.bufName + " AS b INNER JOIN ^contract AS c ON b.Fid_dog=c.Fwid "
										+" INNER JOIN ^clrelclcl AS r ON b.Fclient=r.Fcod "
										+" INNER JOIN "+extTblName+" AS o ON r.Fwid_cl=o.Fmainwid "
										+" LEFT JOIN ^hru AS h ON h.Fwid=b.Fid_doc "
									+" WHERE "+sqlWhere+" AND r.Fcl="+getPar("CODPLAT")
									+" ORDER BY b.Fclient")
				var tv = new DpTVars("AKTPP");
				tv.setRTbl(tbl);
				tv.print();
			}
		break;
		case "PRINCONV":
			include("objects/DpTVars.js");
			include ("Objects/DpExtentionBuilder.js");
			var oExt = new DpExtentionBuilder("CL","0",null);
			if(oExt.exist())
			{
				var extTblName = oExt.getValueTableName();
				var tbl = OpenTable("SELECT b.Fclient as org, o.Flpu as umg FROM " + this.bufName + " AS b "
						+" INNER JOIN ^clrelclcl AS r ON b.Fclient=r.Fcod "
						+" INNER JOIN "+extTblName+" AS o ON r.Fwid_cl=o.Fmainwid AND r.Fcl="+getPar("CODPLAT")
						+" ORDER BY b.Fclient");
				var tv = new DpTVars("CONVERTS");
				tv.setRTbl(tbl);
				tv.print();
			}
		break;
		case "EXPORTCALC":
			var oPar = new Object();
			oPar.grid = grid;
			showWindow("grid_to_scalc.xml", SW_MODAL, oPar);
		break;
		case "EXPORTXLS":
			var sFile = BrowseForFile("*.xls", "Файлы XLS (*.xls)|*.xls|", null, "SAVE");
			if (sFile)
			{
				if (!sFile.endsWith(".xls"))
					sFile = sFile + ".xls";
				grid.exportToXLS(sFile);
			} 
		break;
		
		case "TOPOCKET":
			CreateTable(pocketName, ROW_PTN);			
			var sqlSel = grid.sqlSelected();
			var temp_tbl = OpenTable("SELECT FWID FROM " + this.bufName + " WHERE " + sqlSel);
			var strWhere = String((temp_tbl.IsEOF()) ? " FWID = " + sqlTo(this.fwid) : sqlSel);

			nk.modifyData("COPY", pocketName, fields2copy, this.bufName, strWhere);
			temp_tbl.close();
			temp_tbl = null;
			break;
		
		case "FROMPOCKET":
			if (IsTable(pocketName))
				var temp_tbl = OpenTable("SELECT * FROM "+ pocketName +" ORDER BY fnom_str");
			else
			{
				alert(ru("Карман пустой", "Кишеня порожня"));
				return;
			}
			if (temp_tbl.IsEOF())
				alert(ru("Карман пустой", "Кишеня порожня"));
			else
			{
				//WAITTIMER(ru("Перенос строк из кармана", "Перенесення рядків із карману"))
				nk.loadFrom(temp_tbl);				
				CLEARWAIT();				
			}
			temp_tbl = null;			
			break;						

		case "RECALC_OST":
			include("sys\\dpsql.js");
			tmp_anltk_minost = getTmpTableName();
			tmp_anltk_bal = getTmpTableName();
			tmp_anltk_minost = "tmp_anltk_minost";
			DropTable(tmp_anltk_minost);
			DropTable(tmp_anltk_bal);
			//е: занесем для расчета приходные строки в ANLTK
			if(this.oDoc.getAttr("RTYPE")=='5')
				nk.modifyData("EDIT", this.rowsName, fields2copy, this.bufName, this.where);
		
			// Если не нажат Shift
			if(!askKey(1) || true)
			{		
				ExecuteSQL(
					"SELECT MAX(a.fdoc_dat) AS fdate, fsc"
					+ " INTO " + tmp_anltk_minost
					+ " FROM ^sch_zag a"
					+ " WHERE fdoc='SA'"
						+ " AND a.fdoc_dat<=" + sqlTo(this.oDoc.getVar("HDAT"))
					+ " GROUP BY fsc"
					);
			
				cKey = "a.fwid"
				var strSql =
					"SELECT " + cKey
						+ ", " + sqlRound("SUM(" + sRecSign.replace(/a\./g, "b.") + "*b.Fkol)", 5) + "  AS Fsum"
						+ ", " + sqlRound("SUM(" + sRecSignSF.replace(/a\./g, "b.") + "*b.Fkol)", 5) + " AS Fsumfact"
					+ " INTO " + tmp_anltk_bal
					+ " FROM ((^ANLTK a"
						+ " LEFT JOIN " + tmp_anltk_minost + " sa"
							+ " ON a.fsc=sa.fsc"
						+ ")"
						+ " LEFT JOIN ^ANLTK b"
							+ " ON " + joinKey
								+ " AND (" + sqlCmpVectors("<="
									, "b.Fdate",  "a.Fdate"
									, "b.Frtype", "a.Frtype"
									, "b.fwid",   "a.fwid"
									)
								+ "))"
						+ " LEFT JOIN ^cl_nmk AS nmk"
							+ " ON a.fnmkl=nmk.fwid" 
					+ " WHERE a.fid_doc = "+sqlTo(this.fwid)
						+ " AND (sa.fdate IS NULL OR b.fdate>=sa.fdate)"
						+ " AND (nmk.fvid IS NULL OR nmk.fvid<>'S')" 
					+ " GROUP BY " + cKey;				
				ExecuteSQL(strSql);

				/*strSql = "UPDATE " + this.bufName + " a INNER JOIN " + tmp_anltk_bal + " b ON a.fwid=b.fwid "
							+ " SET a.fost = b.Fsumfact";
				*/		
				strSql = "UPDATE " + this.bufName + 
						" SET fost = (SELECT "+ IIF("b.Fsumfact IS NULL", 0, "b.Fsumfact") 
										+" FROM ^"+ tmp_anltk_bal +" b WHERE "+ this.bufName + ".fwid=b.fwid)";
				
				ExecuteSQL(strSql);		
			}	
			else // при нажатом Shiftе (не работает)
			{
				var dDate = this.oDoc.getVar("HDAT");
				var tAnltk_ost = OpenTable("s", "anltk_ost", "chain");
				var tRows_ost = OpenTable("s", nk.bufName);
				var i=0;
				var nRc = tRows_ost.recordCount;
				for(; !tRows_ost.IsEOF() ; tRows_ost.MoveNext())
				{
					if(i%100==0)
						WAIT(i + " / " + nRc);
					++i;
					tAnltk_ost.FindFirst(
						    " fnmkl="  + tRows_ost.getValue("fnmkl")
						  + ",fcena=" + tRows_ost.getValue("fcena")
						  + ",fpodr=" + tRows_ost.getValue("fpodr")
						  + ",fmol="  + tRows_ost.getValue("fmol")
						  + ",fsc="   + tRows_ost.getValue("fsc")
						  + ",fsu="   + tRows_ost.getValue("fsu")
						  + ",fpost=" + tRows_ost.getValue("fpost")
						  + ",fid_pn="+ tRows_ost.getValue("fid_pn")
						  + ",fdate=" + sqlTo(dDate) );
					for(; !tAnltk_ost.IsEOF() ; tAnltk_ost.MoveNext())
					{
						if(tAnltk_ost.getValue("fnmkl")!= tRows_ost.getValue("fnmkl"))
							break;
						if(differ(tAnltk_ost.getValue("fdate"), dDate) > 0)
							continue;							
						if(differ(tAnltk_ost.getValue("fdateost"), dDate) < 0)
							continue;						
						if(tAnltk_ost.getValue("fnmkl")==tRows_ost.getValue("fnmkl")
							&& tAnltk_ost.getValue("fcena")==tRows_ost.getValue("fcena")
							&& tAnltk_ost.getValue("fpodr")==tRows_ost.getValue("fpodr")
							&& tAnltk_ost.getValue("fmol")==tRows_ost.getValue("fmol")
							&& tAnltk_ost.getValue("fsc")==tRows_ost.getValue("fsc")
							&& tAnltk_ost.getValue("fsu")==tRows_ost.getValue("fsu")
							&& tAnltk_ost.getValue("fpost")==tRows_ost.getValue("fpost")
							&& tAnltk_ost.getValue("fid_pn")==tRows_ost.getValue("fid_pn")
							)		
						{
							tRows_ost.Edit();
							tRows_ost.setValue("fost", tAnltk_ost.getValue("fost"));
							tRows_ost.Update();
							break;
						}
					}
					if (tRows_ost.getValue("fcena") == 0 && tRows_ost.getValue("fost") >= 0)
					{
						/*
						tRows_ost.Edit();
						tRows_ost.getValue("fost") = -999;
						tRows_ost.Update();
						*/
					}
				}	
			}
			//e: возвращаем все как было
			if(this.oDoc.getAttr("RTYPE")=='5')
				nk.modifyData("EDIT", nk.rowsName, fields2copy, nk.sTmpTbl, nk.fwid);			
			break;
		
		case "KSU_NMKL":			
			var oPar = new Object();			
			include("objects/DpGetDat.js");
			oPar.objAsk = new DpGetDat(new Array("r"));
			if(this.tbl4Grid.IsEOF() || oPar.objAsk.escape)
				break;
			oPar.isZaval = true;
			oPar.objAsk.fnmk = this.tbl4Grid.getValue("fnmkl");
			oPar.objAsk.fcena = 0;
			oPar.objAsk.fpodr = this.tbl4Grid.getValue("fpodr");
			oPar.objAsk.fmol = this.tbl4Grid.getValue("fmol");
			oPar.objAsk.fsc = this.tbl4Grid.getValue("fsc");
			oPar.objAsk.fsu = this.tbl4Grid.getValue("fsu");
			oPar.objAsk.fst = this.tbl4Grid.getValue("fst");
			oPar.objAsk.forg = 0;
			showWindow("r_ksu.js", SW_MODAL, oPar);
			break;			
		
		case "REBUILD_OST":
			//include("objects\\DpOst.js");			
			//var ost = new  DpOst();
			include("sys\\dpsql.js");
			var par = new Object();
			var tRows_ost = OpenTable("s", " SELECT * FROM " + this.bufName + " WHERE " + grid.sqlSelected());
			par.tbl = tRows_ost;
			var i=0;
			for(; !tRows_ost.IsEOF() ; tRows_ost.MoveNext())
			{
				WAIT(++i);
				//ost.rebuildNmk(tRows_ost("fnmkl"), tRows_ost("fmol"), tRows_ost("fpodr"));
				rebuildOst(par);
			}
			tRows_ost.close();
			grid.RefreshGrid(RG_SAVEROW);
			break;
			
		case "REBUILD_NUM":
			include("sys\\dpsql.js");			
			var sWhere = "";
			if(grid.getSelectedCount()>0)
				sWhere = " where "+ grid.sqlSelected();
			var tRows = OpenTable("select * from "+ this.bufName + sWhere + " order by FNOM_STR, FWID");
			var num = Number(tRows.getValue("FNOM_STR"));
			var i = 1;
			for(; !tRows.IsEOF(); tRows.MoveNext())
			{
				WAIT((i++) +"/"+ tRows.recordCount);				
				var nID = Number(tRows.getValue("FWID"));
				var oRow = nk.oDoc.getRow("ROW", nID);
				if (oRow != null)
				{
					oRow.setVar("RNOM", num);
					ExecuteSQL("update "+ this.bufName 
								+" set FNOM_STR="+ sqlTo(num) 
								+" where FWID="+ nID
							);
				}
				num++;
			}
			tRows.close();
			grid.getTable().requery();
			grid.RefreshGrid(RG_SAVEROW);
			break;
			
		case "BROWSESREC":			
			var frtype = this.oDoc.getAttr("RTYPE");
			strSql = "select fnmkl as Fnmkl, "+
							"sum(fcena*fkol)/sum(fkol) as Fcena, "+
							"sum(fcena*fkol*1.2)/sum(fkol) as Fcenap, "+
							"sum(fcenapr*fkol)/sum(fkol) as Fcena2, "+
							"sum(fcenapr*fkol*1.2)/sum(fkol) as Fcenap2, "+
							"sum(fkol) as Fkol"
					+ " into SREC"
					+ " from " + this.bufName
					+ (frtype!=null? " where frtype=" + sqlTo(frtype) : "")
					+ " group by fnmkl"
					//+ " order by fnmkl";
			ExecuteSQL(strSql);
			oPar = new Object();			
			//oPar.rtype = this.oDoc.getAttr("RTYPE");			
			showWindow("l_srec.js",SW_MODAL,oPar);
			DropTable("SREC");
			break;
		
		case "SETFID_PN":
			ExecuteSQL(
				"UPDATE " + this.bufName + " a"
		 		+ " SET a.fid_pn = " + sqlTo(this.tbl4Grid.getValue("fid_pn"))
		 			+ ", a.fpost = " + sqlTo(this.tbl4Grid.getValue("fpost"))
		 		+ " WHERE a.fwid="+ sqlTo(this.tbl4Grid.getValue("fwid"))
					+ " AND a.fid_doc=" + sqlTo(this.fwid)
		 		);
			this.isChanged = true;
	 		alert(ru("Запустите перерасчет остатков","Запустіть перерахунок залишків"));
			break;
		
		case "SETPOST":
			/*ExecuteSQL(
				"UPDATE " + this.bufName + " b"
		 			+ " LEFT JOIN ^anltk a"
		 				+ " ON b.fid_pn=a.fwid"
		 		+ " SET b.fpost = a.fpost"
		 		+ " WHERE b.fwid="+ sqlTo(this.tbl4Grid.getValue("fwid"))
					+ " AND NOT (a.fpost IS NULL)"
					+ " AND b.fid_doc=" + sqlTo(this.fwid)
		 		)		 	
	 		*/
	 		ExecuteSQL(
				"UPDATE " + this.bufName + " b"
		 			+ " SET b.fpost = (SELECT a.fpost FROM ^anltk a "
		 		+ " WHERE b.fwid="+ sqlTo(this.tbl4Grid.getValue("fwid"))
					+ " AND a.fpost IS NOT NULL"
					+ " AND b.fid_doc=" + sqlTo(this.fwid)		 			
		 			+ " AND a.fwid=b.fid_pn )")
	 		alert(ru("Запустите перерасчет остатков","Запустіть перерахунок залишків"));
			break;
		
		case "ROUNDSUM":
			DropTable("roundsum_rows");
			ExecuteSQL("SELECT " + sqlRound("SUM(fcena*fkol)/SUM(fkol)",Number(getPar("DECISUM"))) + "*SUM(fkol) AS frsum"
				+ " INTO roundsum_rows" 
				+ " FROM " + this.bufName
				+ " GROUP BY fnmkl"
				);
			var tRSum=OpenTable("s", "SELECT SUM(frsum) AS fsum FROM roundsum_rows")
			var nSum = round(tRSum.getValue("fsum"),Number(getPar("DECISUM")));	
			alert(ru("Сумма по округленным средним ценам = ",
					"Сума за округленими середніми цінами = ") + nSum);	
			tRSum.Close(5652);
			break;

		case "VMCENA":
			//include("objects\\DpDocumentDecoder.js");

			var tErr1 = OpenTable("select *"
				+ " from " + this.bufName + " a"
				+ " WHERE frtype='8'"
			/*		+ " AND (fcena<>(select min(fcena) from ^anltk b "
						+ "where a.fdate=b.fdate "
							+ " and a.fnmkl=b.fnmkl"
							+ " and a.fpodr=b.fpodr"
							+ " and a.fmol=b.fmol"
							+ " and a.fsc=b.fsc"
							+ " and a.fsu=b.fsu"
							+ ")"
						+ ")"
			*/
				);
			//alert("Ошибок в цене в магазине: " + tErr1.recordCount);
			var sAlert = "";
			for(; !tErr1.IsEOF(); tErr1.MoveNext())
			{
				var t4Cena = OpenTable(
					"SELECT *"
					+ " FROM ^anltk a"
					+ " WHERE fdate<" + sqlTo(tErr1.getValue("fdate"))
						+ " and a.fnmkl=" + sqlTo(tErr1.getValue("fnmkl"))
						+ " and a.fpodr=" + sqlTo(tErr1.getValue("fpodr"))
						+ " and a.fmol=" + sqlTo(tErr1.getValue("fmol"))
						+ " and a.fsc=" + sqlTo(tErr1.getValue("fsc"))
						+ " and a.fsu=" + sqlTo(tErr1.getValue("fsu"))
						+ " and fcena<>0"
					+ " ORDER BY fdate DESC, fcena desc"
					);
				if (Number(t4Cena.getValue("fcena")) != Number(tErr1.getValue("fcena")))
				{
					
					sAlert += "\n" + tErr1.getValue("fnmkl") + " " + tErr1.getValue("fcena") 
						+ " на " + t4Cena.getValue("fcena")

					var nkCena = OpenTable(
						"SELECT *"
						+ " FROM ^anltk a"
						+ " WHERE fdate=" + sqlTo(tErr1.getValue("fdate"))
							+ " and fnmkl=" + sqlTo(tErr1.getValue("fnmkl"))
							+ " and fpodr=" + sqlTo(tErr1.getValue("fpodr"))
							+ " and fmol=" + sqlTo(tErr1.getValue("fmol"))
							+ " and fsc=" + sqlTo(tErr1.getValue("fsc"))
							+ " and fsu=" + sqlTo(tErr1.getValue("fsu"))
							+ " and fdoc = 'NK'"			
						);
					if (!nkCena.isEmpty())
					{
					   var nkfcena = nkCena.getValue("fcena");
					   var nkfcena_ord = nkCena.getValue("fcena");
					   var nkfid_pn = nkCena.getValue("fid_pn");
					   var nkfpost = nkCena.getValue("fpost");

					   ExecuteSQL(
						"UPdATE ^anltk"
						+ " SET fcena=" + sqlTo(tErr1.getValue("fcena"))
							+ ", fcena_ord=" + sqlTo(tErr1.getValue("fcena"))
							+ ", fid_pn=" + sqlTo(tErr1.getValue("fid_pn")) 
							+ ", fpost=" + sqlTo(tErr1.getValue("fpost")) 
						+ " WHERE fdate=" + sqlTo(tErr1.getValue("fdate"))
							+ " and fnmkl=" + sqlTo(tErr1.getValue("fnmkl"))
							+ " and fpodr=" + sqlTo(tErr1.getValue("fpodr"))
							+ " and fmol=" + sqlTo(tErr1.getValue("fmol"))
							+ " and fsc=" + sqlTo(tErr1.getValue("fsc"))
							+ " and fsu=" + sqlTo(tErr1.getValue("fsu"))
							+ " and fdoc = 'NK'"			
						)

					  /*
					   var oDec = new DpDocumentDecoder();
					   var oPar = new Object();
					   oPar.doc = "NK";
					   oPar.fiddoc = Number(nkCena.getValue("fid_doc"));
					   oPar.notRegister = true;
					   oDec.run("NK", oPar);	
				*/
					   ExecuteSQL(
						"UPdATE " + this.bufName
						+ " SET fcena=" + sqlTo(nkfcena)
							+ ", fcena_ord=" + sqlTo(nkfcena_ord)
							+ ", fid_pn=" + sqlTo(nkfid_pn) 
							+ ", fpost=" + sqlTo(nkfpost) 
						+ " WHERE fwid=" + sqlTo(tErr1.getValue("fwid"))
						)
					}
					else
					{
					   ExecuteSQL(
						"UPdATE " + this.bufName
						+ " SET fcena=" + sqlTo(t4Cena.getValue("fcena"))
							+ ", fcena_ord=" + sqlTo(t4Cena.getValue("fcena"))
							+ ", fid_pn=" + sqlTo(t4Cena.getValue("fid_pn")) 
							+ ", fpost=" + sqlTo(t4Cena.getValue("fpost")) 
						+ " WHERE fwid=" + sqlTo(tErr1.getValue("fwid"))
						)
					}
				}
				
				if (Number(tErr1.getValue("Fid_pn")))
				{
					var newCenapr = tanf(Number(tErr1.getValue("Fid_pn")), "cena");
					
					ExecuteSQL(
					"UPdATE " + this.bufName
						+ " SET fcenapr=" + sqlTo(newCenapr)
						+ " WHERE fwid=" + sqlTo(tErr1.getValue("fwid"))
						)
						
					ExecuteSQL(
						"UPdATE " + this.bufName
						+ " SET fcena=" + sqlTo(newCenapr)
							+ ", fcena_ord=" + sqlTo(newCenapr)
							+ ", fid_pn=" + sqlTo(tErr1.getValue("fid_pn")) 
							+ ", fpost=" + sqlTo(tErr1.getValue("fpost")) 
							+ ", fcenapr=" + sqlTo(newCenapr)
						+ " WHERE fwid=" + sqlTo(GetNextUID(tErr1.getValue("fwid")))
						)
				}		
			}
			if (sAlert)
				alert(sAlert);
			break;
			
		case "FIND":
			grid.runSelection(8); 
			break;
		
		case "SELECT":
			grid.runSelection(2);
			break;
			
		case "MASS_CL":
			this.doMass("CL");
			break;
		
		case "MASS_VDOST_CALC":
			this.doMass("VDOST", "CALC");
			break;

		case "MASS_VDOST_VIEW":
			this.doMass("VDOST", "VIEW");
			break;

		case "MASS_DOC":
			this.doMass("DOC", "VIEW");
			break;
			
		case "MASS_PRICE":
			this.doMass("PRICE");
			break;
		case "DEBUG_BROWSE":			
			browse(grid.getTable());
			break;

	}
	if(this.bRefresh)
		this.refreshViewer();
		
	grid.setFocus();
	FORM.setActive();
}

//обновляет грид, подбивает итоги, переносит расходные строки в rowsName
function DpNakl_refreshViewer()
{
	if(this.mode=="MASS_EDIT")
		return false;
		
	if (grid.getTable() != null)
	{
		grid.getTable().requery();
		grid.refresh();
	}
	CLEARWAIT();
	
	if (typeof recalcSum == "function")
		recalcSum();
	if(this.old)
		return;
	var frtype = this.oDoc.getAttr("RTYPE");		
	if(typeof docRefreshData == "function")
	{
		docRefreshData();
		if (grid.getTable() != null)
			grid.getTable().requery();
	}
	else if(frtype == "7" || frtype == "8")
	{
		nk.modifyData("EDIT", this.rowsName, fields2copy, this.bufName, this.where);
	}
}

//загружает в буфер строки из таблицы: для вставки из кармана; при формировании накладных.
function DpNakl_loadFrom(tbl, oDocRow)
{	
	include("Objects\\DpClNo.js");									
	
	var sWhere = "";
	if(oDocRow) //при редактировании одной строки
		sWhere = " where fwid = "+ oDocRow.getID();
	
	var isOpenTbl = false;
	if(typeOf(tbl).toLowerCase() == "string")
	{
		var tbl = OpenTable("s","select * from "+ tbl + sWhere);
		isOpenTbl = true;
	}
	
	if(tbl!=undefined && tbl.isEmpty())
	{
		if (isOpenTbl)
			tbl.close();
		return;
	}
	
	for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
	{
		if(!oDocRow)
		{
			var oDocRow = this.oDoc.createRow("ROW");
			this.oDoc.appendRow("ROW", oDocRow);		
		}	
		with(oDocRow)
		{
			setVar("RNOM",	 findFreeClNo(this.bufName, "fnom_str"));
			setVar("R1ID",	 tbl.getValue("Fid_pn"));
			setVar("R0ID",	 tbl.getValue("Fid_pn0"));
			setVar("RSUM",	 tbl.getValue("Fsum"));						
			setVar("RKOL",	 tbl.getValue("Fkol"));
												
			setVar("RUCENA", tbl.getValue("F1cena"));							
			setVar("RCENAORD", tbl.getValue("Fcena_ord"));
			setVar("RPCENE", tbl.getValue("F1cena"));
			setVar("ROCENA", tbl.getValue("F1cena"));
			setVar("R1OCENA",tbl.getValue("Fcenapr"));
			setVar("RFOCENA",tbl.getValue("F1cena"));
			setVar("RVCENA", tbl.getValue("Fvcena"));
				
			setVar("RTNMK",	 tbl.getValue("Fnmkl"));						
			setVar("R1SVAL", tbl.getValue("Fvcod"));
			setVar("R1DAT",	 tbl.getValue("Fdate"));
			setVar("RSC",	 tbl.getValue("Fsc"));
			setVar("RSU",	 tbl.getValue("Fsu"));
			setVar("RST",	 tbl.getValue("Fst"));
			setVar("RSC1",	 tbl.getValue("Fsc1"));
			setVar("RSU1",	 tbl.getValue("Fsu1"));
			setVar("RST1",	 tbl.getValue("Fst1"));
			setVar("RPODR",	 tbl.getValue("FPodr"));
			setVar("RORG",	 tbl.getValue("FCLIENT"));
			setVar("RMOL",	 tbl.getValue("Fmol"));
			setVar("RPOST",	 tbl.getValue("Fpost"));
			setVar("REDI",	 tbl.getValue("FEDI"));
			setVar("RKOLSPR",tbl.getValue("Fkol_spr"));						
			//setVar("ROST",	 tbl.getValue("FOST"));
			setVar("RSNDS",	 tbl.getValue("Fis_nds"));
			setVar("RSOTL",	 tbl.getValue("Fis_otl"));
			setVar("RDISCOUNT",	 tbl.getValue("FDISCOUNT"));
		}
		var docRtype = this.oDoc.getAttr("RTYPE");
		var tblRtype = tbl.getValue("Frtype");
		
		if(docRtype==null)
		{
			oDocRow.setVar("RTYPE",tbl.getValue("Frtype"));
			oDocRow.setVar("RSCENA",tbl.getValue("Fcenapr"));
			oDocRow.setVar("RUCENA",tbl.getValue("Fcena"));
		}
		else if(((docRtype!='5') && (tblRtype!='5')) || docRtype == tblRtype)
		{
			oDocRow.setVar("RUCENA",tbl.getValue("Fcena"));
		}
		
		if(docRtype==7 && tblRtype==5)	//из PN в NK
		{
			oDocRow.setVar("ROCENA", tbl.getValue("Fcenapr"));
			oDocRow.setVar("RFOCENA", tbl.getValue("Fcenapr"));
		}
		
		if(typeof(docLoadRowToBuf)=="function")
		{
			docLoadRowToBuf(oDocRow);
		}
				
		obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, this.bufName);		
		oDocRow = null;			
	}
	grid.getTable().requery();
	if (isOpenTbl)
		tbl.close();
	nk.refreshViewer();
}

function rebuildOst(par, bWait)
{
	if(!getPar("isclost"))
	{
		WAIT(ru("Режим ведения справочника остатков не установлен","Режим ведення довідника залишків не встановлений"));
		//return;
	}
	var i=0;

	if (typeof(bWait) == "undefined")
		bWait = true;
		
	var tbl_chain = par.tbl;		

	if (tbl_chain.IsEmpty())
		return;
	tbl_chain.MoveLast();
	var fnmkl	= tbl_chain.getValue("fnmkl");
	var fis_otl	= tbl_chain.getValue("fis_otl");
	var fcena	= tbl_chain.getValue("fcena");
	var fpodr	= tbl_chain.getValue("fpodr");
	var fmol	= tbl_chain.getValue("fmol");
	var fsc		= tbl_chain.getValue("fsc");
	var fsu		= tbl_chain.getValue("fsu");
	var fst		= tbl_chain.getValue("fst");
	var fpost	= tbl_chain.getValue("fpost");
	var fid_pn	= tbl_chain.getValue("fid_pn");
	var ost = 0;
	var ost1 = 0;
	var ost_spr = 0;
	var dateost = new Date(3000, 0, 1).getVarDate();// максимальная дата
	
	// Первым действием добавляем даты 
	for(tbl_chain.MoveLast(); !tbl_chain.IsBOF(); tbl_chain.MovePrev())
	{
		if (bWait)
			WAIT(++i + " | " + tbl_chain.recordCount + " Корректировка цепочек (действие 1 из 2)");

		if (
			fnmkl	!= tbl_chain.getValue("fnmkl")||
			fis_otl	!= tbl_chain.getValue("fis_otl")||
			fcena	!= tbl_chain.getValue("fcena")||
			fpodr	!= tbl_chain.getValue("fpodr")||
			fmol	!= tbl_chain.getValue("fmol")||
			fsc		!= tbl_chain.getValue("fsc")||
			fsu		!= tbl_chain.getValue("fsu")||
			fst		!= tbl_chain.getValue("fst")||
			fpost	!= tbl_chain.getValue("fpost")||
			fid_pn	!= tbl_chain.getValue("fid_pn")
			)
		{
			fnmkl	= tbl_chain.getValue("fnmkl");
			fis_otl	= tbl_chain.getValue("fis_otl");
			fcena	= tbl_chain.getValue("fcena");
			fpodr	= tbl_chain.getValue("fpodr");
			fmol	= tbl_chain.getValue("fmol");
			fsc		= tbl_chain.getValue("fsc");
			fsu		= tbl_chain.getValue("fsu");
			fst		= tbl_chain.getValue("fst");
			fpost	= tbl_chain.getValue("fpost");
			fid_pn	= tbl_chain.getValue("fid_pn");
			
			dateost = new Date(3000, 0, 1).getVarDate();// максимальная дата
		}
		
		tbl_chain.Edit();
		tbl_chain.setValue("fdateost", dateost);
		tbl_chain.setValue("FREFRESH", 0);		
		dateost = tbl_chain.getValue("fdate");
		dateost.setDate(dateost.getDate()-1);
		tbl_chain.Update();
	}
	
	// Вторым действием рассчитываем остатки
	i = 0;
	for(tbl_chain.MoveFirst(); !tbl_chain.IsEOF(); tbl_chain.MoveNext())
	{
		if (bWait)
			WAIT(++i + " | " + tbl_chain.recordCount + " Корректировка цепочек (действие 2 из 2)");

		if (
			fnmkl	!= tbl_chain.getValue("fnmkl")||
			fis_otl	!= tbl_chain.getValue("fis_otl")||
			fcena	!= tbl_chain.getValue("fcena")||
			fpodr	!= tbl_chain.getValue("fpodr")||
			fmol	!= tbl_chain.getValue("fmol")||
			fsc		!= tbl_chain.getValue("fsc")||
			fsu		!= tbl_chain.getValue("fsu")||
			fst		!= tbl_chain.getValue("fst")||
			fpost	!= tbl_chain.getValue("fpost")||
			fid_pn	!= tbl_chain.getValue("fid_pn")
			)
		{
			fnmkl	= tbl_chain.getValue("fnmkl");
			fis_otl	= tbl_chain.getValue("fis_otl");
			fcena	= tbl_chain.getValue("fcena");
			fpodr	= tbl_chain.getValue("fpodr");
			fmol	= tbl_chain.getValue("fmol");
			fsc		= tbl_chain.getValue("fsc");
			fsu		= tbl_chain.getValue("fsu");
			fst		= tbl_chain.getValue("fst");
			fpost	= tbl_chain.getValue("fpost");
			fid_pn	= tbl_chain.getValue("fid_pn");
			
			ost = 0;
			ost1 = 0;
			ost_spr = 0;
		}
		
		tbl_chain.Edit();
		tbl_chain.setValue("fost", (ost + tbl_chain.getValue("fkol")));
		ost += tbl_chain.getValue("fkol");
		tbl_chain.setValue("fost1", (ost1 + tbl_chain.getValue("fkol1")));
		ost1 += tbl_chain.getValue("fkol1");
		tbl_chain.setValue("fost_spr", (ost_spr + tbl_chain.getValue("fkol_spr")));
		ost_spr += tbl_chain.getValue("fkol_spr");
		tbl_chain.Update();
	}
	tbl_chain.Close(5652);
	tbl_chain = null;
	CLEARWAIT();		
}

function DpNakl_wItog(m)
{
	if(this.mode=="MASS_EDIT")
		return false;
	
	var oSnap;
	var fdoc = this.sDocLbl;
	var frtype = this.oDoc.getAttr("RTYPE");
	var dec = Number(getPar("DECISUM"));
	var roundMethod = toScrObj(nk.oDoc.getPar("_round_method"));
	var decSum = Math.max(Number(getPar("DECIPRI")), Number(getPar("DECIKOL")));
	if(!m)
		m = new Object();	
	
	var rsum;
	var r1sum;
	var rsumpr;
	
	m.hNr  = "COUNT(*)";
	m.hKol = "SUM(a.Fkol)";
	switch (roundMethod)
	{
		case 2:
			rsum = sqlRound("a.Fkol * a.Fcena", dec),
			r1sum = sqlRound("a.Fkol * a.F1cena", dec),
			rsumpr = sqlRound("a.Fkol * a.Fcenapr", dec);
			m.hSum = sqlRound("SUM("+sqlRound("a.Fsum", dec)+")", dec);
			break;
		case 1:
		default:
			rsum = sqlRound("a.Fkol * a.Fcena", decSum),
			r1sum = sqlRound("a.Fkol * a.F1cena", decSum),
			rsumpr = sqlRound("a.Fkol * a.Fcenapr", decSum);
			m.hSum = sqlRound("SUM(a.Fsum)", dec);
			break;
	}

	m.hsumuc  = sqlRound("SUM("+ rsum +")", dec);
	m.hsumu1c = sqlRound("SUM("+ r1sum +")", dec);
	m.hsumoC  = sqlRound("SUM("+ rsumpr +")", dec);	
	m.hIsRasc = "SUM("+IIF("a.Fis_otl="+ sqlTrue,"1", "0")+")";
	
	//fruckt - если указали процент не 20, то всеравно считает 20
	//var sNds = this.nds !=0 ? "nmk.FNDS/100" : "0";
	var sNds = this.nds !=0 ? String(this.nds/100) : "0";
	m.hndsu = sqlRound("SUM("+IIF("a.fnmkvid <> 'O' or a.fnmkvid is null", rsum +"*"+ sNds, "0")+")", dec);
	m.hndso = sqlRound("SUM("+IIF("a.fnmkvid <> 'O' or a.fnmkvid is null", rsumpr +"*"+ sNds, "0")+")", dec);
	m.hndsu1 = sqlRound("SUM("+IIF("a.fnmkvid <> 'O' or a.fnmkvid is null", r1sum +"*"+ sNds, "0")+")", dec);
	
	m.Fseb_tov = sqlRound("SUM("+IIF("sc.fctype = 'o' OR sc.fctype = 't'", rsum, "0")+")", dec);
	m.Fsum_tov = sqlRound("SUM("+IIF("sc.fctype = 'o' OR sc.fctype = 't'", rsumpr, "0")+")", dec);
	m.Fseb_mat = sqlRound("SUM("+IIF("sc.fctype = 'm'", rsum, "0")+")", dec);
	m.Fsum_mat = sqlRound("SUM("+IIF("sc.fctype = 'm'", rsumpr, "0")+")", dec);
	m.Fseb_tar = sqlRound("SUM("+IIF("a.fnmkvid = 'O'", rsum, "0")+")", dec);
	m.Fsum_tar = sqlRound("SUM("+IIF("a.fnmkvid = 'O'", rsumpr, "0")+")", dec);	
		
	sFrom  = " FROM "+ this.bufName +" a " 
				+" INNER JOIN ^CL_NMK nmk ON a.fnmkl = nmk.fwid "
				+" LEFT JOIN ^CL_SCHET sc ON a.Fsc = sc.Fschet "
					+" AND a.Fsu = sc.Fsubschet AND a.Fst = sc.Fstat " 				 							
	sWhere = (frtype==null)? "" : " WHERE frtype = "+ sqlTo(frtype);
	
	for(value in m)
	{
		oSnap = getSnap(" SELECT "+ m[value] +" AS "+ value + sFrom + sWhere, false);		
		if(oSnap != null) 
			m[value] = (oSnap[0]!=null)? oSnap[0] : 0;
		else 
			m[value] = 0;		
	}	
	return m;
}

function DpNakl_modifyData(sMode, tbl, fields, source, sWhere)
{	
	if(!tbl)
		return;
	
	if(typeof sWhere == 'number')
		sWhere = " WHERE fid_doc="+ sqlTo(sWhere);
	else if(typeof sWhere == 'string')
		sWhere = " WHERE " + sWhere;
	else
		sWhere = "";	
	
	sMode = sMode.toUpperCase();
	
	BeginTransaction(1)
	switch(sMode)
	{ 
		case "DEL": 
		case "EDIT":
			ExecuteSQL("DELETE FROM ^"+ tbl + sWhere);
			if (sMode != "EDIT")	
				break;
		case "COPY":
			ExecuteSQL("INSERT INTO ^"+ tbl +"("+ fields +")"+
			  	  	  " SELECT "+ fields +
			  	  	  " FROM ^" + source + sWhere );	
			break;
	}
		
	CommitTrans();	
}

function DpNakl_save(obj, m)
{
	if(this.mode=="MASS_EDIT")
		return false;
	
	if(typeof updateData == "function")
		updateData();
		
	nk.saveRows();
}

function DpNakl_saveRows()
{
	if(nk.oDoc.getVar("HDOC").toLowerCase().indexOf("com.debet.cdr")==-1 
		&& nk.oDoc.getVar("HDOC").toLowerCase().indexOf("hozdog")==-1 
		&& nk.oDoc.getVar("HDOC").toLowerCase().indexOf("td")==-1 
		&& nk.oDoc.getVar("HDOC").toLowerCase().indexOf("o7")==-1
		&& nk.oDoc.getVar("HDOC").toLowerCase().indexOf("cdr_")==-1)
	{
		var fld = new Object();
		fld.fcanupdate = "byte";
		CreateTable("fwid_"+String(nk.oDoc.getVar("HID")), fld);
		var m = new Object();
		if(!canUpdateDate(nk.oDoc.getVar("HDAT"),null,null,true))
		{
			m.Fcanupdate = 0;
			UpdateTable("fwid_"+String(nk.oDoc.getVar("HID")), m, true);
			return false;
		}
		else
		{
			m.Fcanupdate = 1;
			UpdateTable("fwid_"+String(nk.oDoc.getVar("HID")), m, true);
		}
	}
	if(this.mode=="MASS_EDIT")
		return false;
	
	if (nk.oDoc.getVar("HDOC") == "PN")
	{
		if (nk.oDoc.getVar("HVAL"))
		{
			var nKurs = nk.oDoc.getVar("HVKURS");
			var nKurs = sval(nk.oDoc.getVar("HDAT")
				, nk.oDoc.getVar("HVAL"), 1, 0, nk.oDoc.getVar("HVKURS"))
				
			var t = OpenTable("s", nk.bufName)
			//nk.oDoc.gotoFirstRow(); //AL: Для быстрой загрузки объектов
			while (!t.isEOF())
			{
				var nID = Number(t.getValue("FWID"))
				var oRow = nk.oDoc.getRow("ROW", nID);
				if (oRow != null)
				{
					var cena = round(Number(oRow.getVar("RPCENE")) * nKurs, 5);
					var cenaord = Number(oRow.getVar("RCENAORD"));
					if (cenaord)
						cenaord = cena;				
					oRow.setVar("RCENAORD", cena);
					oRow.setVar("RUCENA",  cenaord);	
					
				}
				t.moveNext();
			}
			t.close();
			
			var sSQL = " update " + nk.bufName + " set fcena = "
				+ sqlRound("f1cena * " + nKurs, 5);
			ExecuteSQL(sSQL)
		}

		// Net 08.12.2011
		// обновим учетные цены строкам всех накладных, где есть наш FID_PN,
		// если установлен параметр «Изменять уч. цены в расходах при изменении цены оприходования»
		// трогаем только материалы, которые ведутся по приходам
		if (toScrObj(getPar("NKFROMPN")))
		{
			var tmpChanged = String(getTmpTableName("", true));
			var m = new Object();
			m.FWID = "COUNTER";
			m.FDOC = SqlType("TEXT", 50);
			m.FNOP = "LONG";
			m.FDOC_DAT = "DATE";
			m.FDOC_NUM = SqlType("TEXT", 50);
			m.FID_DOC = "LONG";
			CreateTable(tmpChanged, m);

			strSQL = " SELECT NK.* "
					+" FROM "+nk.bufName +" NK "
						+" INNER JOIN ^ANLTK A ON NK.FID_DOC = A.FID_DOC AND NK.FWID = A.FWID "
						+" INNER JOIN ^CL_NMK CL ON NK.FNMKL = CL.FWID "
					+" WHERE 1 = 1 "
						+" AND CL.FIS_PN1 IN ("+sqlTo("+")+", "+sqlTo("*")+") "
						+" AND NK.FCENA <> A.FCENA "	// обрабатываем строки, где изменилась цена
						+" AND NK.FID_PN<>0"
			var t = OpenTable("s", strSQL);
			for (; !t.IsEOF(); t.MoveNext())
			{
				var nID = toScrObj(t.getValue("FWID"));
				var oRow = nk.oDoc.getRow("ROW", nID);
				if (oRow != null)
				{
					var mFidpn = toScrObj(oRow.getVar("R1ID"));
					var mFucena = toScrObj(oRow.getVar("RUCENA"));

					strSelect = " SELECT DISTINCT "
									+" Z.FDOC, Z.FNOP, Z.FDOC_DAT, Z.FDOC_NUM, Z.FWID "
								+" FROM ^ANLTK A "
									+" INNER JOIN ^SCH_ZAG Z ON A.FID_DOC = Z.FWID "
								+" WHERE 1 = 1 "
									+" AND A.FDOC <> "+sqlTo("PN")							// сами себя не трогаем
									+" AND A.FID_PN = "+sqlTo(mFidpn)
									+" AND Z.FDOC_DAT >= "+sqlTo(nk.oDoc.getVar("HDAT"))	// трогаем только то, что после нас
									+" AND A.FDATE >= "+sqlTo(nk.oDoc.getVar("HDAT"))		// на всякий случай

					strSQL = " INSERT INTO "+tmpChanged
							+" ( "
								+" FDOC "
								+", FNOP "
								+", FDOC_DAT "
								+", FDOC_NUM "
								+", FID_DOC "
							+" ) "
							+strSelect
					ExecuteSQL(strSQL);

					// у нас на руках список fid_pn, по каждому из них известны все строки,
					// а через DISTINCT и все накладные, где эти строки есть.
					// вот эти накладные берем и с помощью DpDoc совершаем акт насилия. меняем строкам цены на нашу.
					var tblNakl = OpenTable(strSelect);
					for (; !tblNakl.IsEOF(); tblNakl.MoveNext())
					{
						var mFdoc = toScrObj(tblNakl.getValue("FDOC"));
						var mFnop = toScrObj(tblNakl.getValue("FNOP"));
						var mFidDoc = toScrObj(tblNakl.getValue("FWID"));
						var mFnom = toScrObj(tblNakl.getValue("FDOC_NUM"));
						var mFdat = toScrObj(tblNakl.getValue("FDOC_DAT"));

						var oDoc = new DpDoc(mFdoc, mFnop);
						if (oDoc.loadByID(mFidDoc))
						{
							// проводки не трогаем. сообщим об измененных накладных, их перепровести вручную
							// если что, это можно навесить на параметр
							oDoc.toDo = "-";

							strSQL = " SELECT A.FWID, A.FNOM_STR, A.FNMKL, NMK.FCOD, NMK.FTXTS "
									+" FROM ^ANLTK A "
										+" LEFT JOIN ^CL_NMK NMK ON A.FNMKL = NMK.FWID "
									+" WHERE 1 = 1 "
										+" AND A.FID_DOC = "+sqlTo(mFidDoc)
										+" AND A.FID_PN = "+sqlTo(mFidpn)
							var tblRows = OpenTable(strSQL);
							for (; !tblRows.IsEOF(); tblRows.MoveNext())
							{
								var mFnmkcod = toScrObj(tblRows.getValue("FCOD"));
								var mFnmktxt = toScrObj(tblRows.getValue("FTXTS"));
								var mFnomstr = toScrObj(tblRows.getValue("FNOM_STR"));

								var oDocRow = oDoc.getRow("ROW", toScrObj(tblRows.getValue("FWID")));
								if (!oDocRow)
								{
									alert(ru("Накладная "+mFdoc+"-"+mFnop+" №"+mFnom+" от "+d_m_y(mFdat)+".\n"
												+"Невозможно загрузить строку №"+mFnomstr+" «"+mFnmkcod+": "+mFnmktxt+"»\n"
												+"Для него цена изменена не будет",
											"Накладна "+mFdoc+"-"+mFnop+" №"+mFnom+" від "+d_m_y(mFdat)+".\n"
												+"Неможливо завантажити рядок №"+mFnomstr+" «"+mFnmkcod+": "+mFnmktxt+"»\n"
												+"Для нього ціну змінено не буде."));
									continue;
								}
								// меняем цену
								oDocRow.setVar("RUCENA", mFucena);
								if(oDocRow.getVar("RCENAORD")!=0)
									oDocRow.setVar("RCENAORD", mFucena);
							}
							tblRows.close(5652);
							tblRows = null;

							oDoc.save(true, "EDIT");
							oDoc.clear();
						}
						else
						{
							alert(ru("Невозможно загрузить документ с идентификатором "+mFidDoc,
									"Неможливо завантажити документ з ідентифікатором "+mFidDoc));
						}
						oDoc = null;
					}
					tblNakl.close(5652);
					tblNakl = null;
				}
			}
			t.close(5652);
			t = null;

			// подготовим данные для журнала об накладных, где проводки устарели
			var tmpChangedDist = String(getTmpTableName("", true));
			strSQL = " SELECT "
						+" MIN(T.FDOC_DAT) AS FDOC_DAT_MIN, "
						+" MAX(T.FDOC_DAT) AS FDOC_DAT_MAX, "
						+" COUNT(*) AS FQTY, "
						+" T.FDOC, "
						+" T.FNOP, "
						+" L.FTXT "
					+" INTO "+tmpChangedDist
					+" FROM "+ tmpChanged+" T "
						+" LEFT JOIN ^CL_LNK L ON T.FDOC = L.FDOC AND T.FNOP = L.FNOP "
					+" GROUP BY "
						+" T.FDOC, "
						+" T.FNOP, "
						+" L.FTXT "
			ExecuteSQL(strSQL);

			strSQL = " ALTER TABLE "+tmpChangedDist+" ADD FWID "+SqlType("COUNTER")
			ExecuteSQL(strSQL);

			// покажем журнал, если что-то изменилось
			strSQL = " SELECT * "
					+" FROM "+tmpChangedDist
					+" ORDER BY FDOC, FNOP "
			var tblChanged = OpenTable(strSQL);
			if (!tblChanged.IsEmpty())
			{
				var par = new Object();
				par.title = ru("Накладные, которые надо перепровести",
								"Накладні, що потребують перепроведення");
				par.isZaval = true;
				par.tbl = tblChanged;
				par.ret = new Object();
				par.ret.FWID = null;
				par.tblName = tmpChangedDist;
				par.strGrid = "	with(page(ru(\"\", \"\")))"
							+"	{"
							+"		cell(\"FDOC\", \"Док.|Док.\", 5);"
							+"		cell(\"FNOP\", \"Опер.|Опер.\", 5);"
							+"		cell(\"FTXT\", \"Назва|Название\", 25);"
							+"		with(group(\"Період|Период\"))"
							+"		{"
							+"			cell(\"FDOC_DAT_MIN\", \"З|С\", 10);"
							+"			cell(\"FDOC_DAT_MAX\", \"По|По\", 10);"
							+"		}"
							+"		cell(\"FQTY\", \"Накладних|Накладных\", 9);"
							+"	}"
				showWindow("l_list4slct.xml", SW_MODAL, par);
			}
			tblChanged.close();
			tblChanged = null;
		}
	}
	// Net 09.12.2011  есть еще и "GP"
	else if (inList(nk.oDoc.getVar("HDOC"), "GP"))
	{
		var nk_issch  = nk.oDoc.getPar("nk_issch")	//параметр "Запрашивать счет приходования в строке"
		var t = OpenTable("s", nk.bufName)
		nk.oDoc.gotoFirstRow();  //AL: Для быстрой загрузки объектов
		
		//fruckt - если строки не содержат счета, то пишем его из заголовка
		//иначе оставляем все как есть
		var isWriteSc;

		while (!t.isEOF())
		{
			var nID = Number(t.getValue("FWID"))
			var oRow = nk.oDoc.getRow("ROW", nID);
			isWriteSc = false;
			if (oRow != null)
			{
				if (oRow.getVar("RTYPE")==RTYPE_PR)
				{
					//Приходная строка
					var gpPodr = nk.oDoc.getVar("HPODRPR");
					var gpMol = nk.oDoc.getVar("HMOLPR");

					var gpRsc = nk.oDoc.getVar("HSCPR");
					var gpRsu = nk.oDoc.getVar("HSUPR");
					var gpRst = nk.oDoc.getVar("HSTPR");
					
					//В приходную строку будем писать счет из заголовка
					isWriteSc = true;
				}
				else
				{
					//расходная строка
					var gpPodr = nk.oDoc.getVar("HPODRRS");
					var gpMol = nk.oDoc.getVar("HMOLRS");
					
					if (nk_issch && !isEmpty(oRow.getVar("RSC")))
					{
						//в параметрах настроено указывать счет в строке и он уже указан
						//Тогда его не трогаем
						isWriteSc = false;
					}
					else
					{
						//счет - из заголовка или в строках не указан
						isWriteSc = true;
						
						var gpRsc = nk.oDoc.getVar("HSCRS");
						var gpRsu = nk.oDoc.getVar("HSURS");
						var gpRst = nk.oDoc.getVar("HSTRS");
					}
				}
				if (gpPodr)
					oRow.setVar("RPODR", gpPodr);
					
				if (gpMol)
					oRow.setVar("RMOL", gpMol);	
				
				if (isWriteSc)
				{
					oRow.setVar("RSC", gpRsc);	
					oRow.setVar("RSU", gpRsu);	
					oRow.setVar("RST", gpRst);
				}
			}
			t.moveNext();
		}
		t.close();


		// расходная
		var setFields = 
			(nk.oDoc.getVar("HPODRRS") ? ", FPODR = " + sqlTo(nk.oDoc.getVar("HPODRRS")) : "") + 
			(nk.oDoc.getVar("HMOLRS")  ? ", FMOL = " + sqlTo(nk.oDoc.getVar("HMOLRS")) : "") +
			(!nk_issch ?
				 ", FSC = " + sqlTo(nk.oDoc.getVar("HSCRS"))
				+", FSU = " + sqlTo(nk.oDoc.getVar("HSURS"))
				+", FST = " + sqlTo(nk.oDoc.getVar("HSTRS"))
					: "")
		setFields = setFields.substr(1)	;				
		
		if (setFields) {
			strSQL = " UPDATE " + nk.bufName 
				+ " SET " + setFields
				+ " WHERE FRTYPE = " +  sqlTo(RTYPE_RS)
					+" AND FID_DOC = "+ sqlTo(this.fwid);
			ExecuteSQL(strSQL);
		}

		// приходная
		strSQL = " UPDATE " + nk.bufName 
				+" SET FPODR = " + sqlTo(nk.oDoc.getVar("HPODRPR"))
				+" , FMOL = " + sqlTo(nk.oDoc.getVar("HMOLPR"))
				+ (!nk_issch ?
				 " , FSC = " + sqlTo(nk.oDoc.getVar("HSCPR"))
				+" , FSU = " + sqlTo(nk.oDoc.getVar("HSUPR"))
				+" , FST = " + sqlTo(nk.oDoc.getVar("HSTPR"))
					: "")
				+" WHERE FRTYPE = " +  sqlTo(RTYPE_PR)
					+" AND FID_DOC = "+ sqlTo(this.fwid);
		ExecuteSQL(strSQL);
	}
	// Net 13.12.2011  VR тоже попадает под этот случай
	else if (inList(nk.oDoc.getVar("HDOC"), "NK", "VP", "VR"))
	{
		var t = OpenTable("s", nk.bufName)
		nk.oDoc.gotoFirstRow();  //AL: Для быстрой загрузки объектов
		
		//fruckt - если строки не содержат счета, то пишем его из заголовка
		//иначе оставляем все как есть
		var isWriteSc;

		while (!t.isEOF())
		{
			var nID = Number(t.getValue("FWID"))
			var oRow = nk.oDoc.getRow("ROW", nID);
			isWriteSc = false;
			if (oRow != null)
			{
				if (toScrObj(nk.oDoc.getVar("HPODR")))
					oRow.setVar("RPODR", nk.oDoc.getVar("HPODR"));
				if (toScrObj(nk.oDoc.getVar("HMOL")))
					oRow.setVar("RMOL", nk.oDoc.getVar("HMOL"));
						
				if (isEmpty(oRow.getVar("RSC")))
				{
					oRow.setVar("RSC", nk.oDoc.getVar("HSC"));	
					isWriteSc = true;
				}
				if (isEmpty(oRow.getVar("RSU")) && isWriteSc)
				{
					oRow.setVar("RSU", nk.oDoc.getVar("HSU"));	
				}
				if (isEmpty(oRow.getVar("RST")) && isWriteSc)
				{
					oRow.setVar("RST", nk.oDoc.getVar("HST"));
				}

				obj2DB(nID, oRow.jDocRow, null, nk.bufName);
			}
			t.moveNext();
		}
		t.close();
	}
	//vlad 27.10.10 Есть еще "PU"
	//else if (inList(nk.oDoc.getVar("HDOC"), "PM", "SM", "VM"))
	else if (inList(nk.oDoc.getVar("HDOC"), "PM", "SM", "VM", "PU", "NM"))
	{
		var nk_issch  = nk.oDoc.getPar("nk_issch")	//параметр "Запрашивать счет приходования в строке"
		
		var t = OpenTable("s", "SELECT * from " + nk.bufName 
			+ " WHERE frtype = " +  sqlTo(RTYPE_PMR)
			+ " and FID_DOC = "+ sqlTo(this.fwid))
		nk.oDoc.gotoFirstRow();  //AL: Для быстрой загрузки объектов
		while (!t.isEOF())
		{
			var nID = Number(t.getValue("FWID"))
			var oRow = nk.oDoc.getRow("ROW", nID);
			if (oRow != null)
			{
				oRow.setVar("RPODR", nk.oDoc.getVar("HPODRTO"));
				oRow.setVar("RMOL", nk.oDoc.getVar("HMOLTO"));
				if(!nk_issch)
				{					
					oRow.setVar("RSC1", nk.oDoc.getVar("HSC"));	
					oRow.setVar("RSU1", nk.oDoc.getVar("HSU"));	
					oRow.setVar("RST1", nk.oDoc.getVar("HST"));
				}
			}
			t.moveNext();
		}
		t.close();
				
		if(!nk_issch)
		{
			var sSQL = "update " + nk.bufName 
					+ " set fPODR = " + sqlTo(nk.oDoc.getVar("HPODRTO"))
					+ " , fMOL = " + sqlTo(nk.oDoc.getVar("HMOLTO"))
					+ " , fSC = " + sqlTo(nk.oDoc.getVar("HSC"))
					+ " , fSU = " + sqlTo(nk.oDoc.getVar("HSU"))
					+ " , fST = " + sqlTo(nk.oDoc.getVar("HST"))
					+ " WHERE frtype = " +  sqlTo(RTYPE_PMP)
					+ " and FID_DOC = "+ sqlTo(this.fwid);
			ExecuteSQL(sSQL);
		
			var sSQL = "update " + nk.bufName 
					+ " set "
					//+ " fSC = " + sqlTo(oRow.getVar("RSC"))
					//+ " , fSU = " + sqlTo(oRow.getVar("RSU"))
					//+ " , fST = " + sqlTo(oRow.getVar("RST"))
					+ "  fSC1 = " + sqlTo(nk.oDoc.getVar("HSC"))
					+ " , fSU1 = " + sqlTo(nk.oDoc.getVar("HSU"))
					+ " , fST1 = " + sqlTo(nk.oDoc.getVar("HST"))
					//vlad 27.10.10
					//В расходных строках понадобилось принудительно проставить МОЛ и Подр
					//в случае, когда документ создается программно из буфера строк "SF"
					+ " , fPODR = " + sqlTo(nk.oDoc.getVar("HPODROT"))
					+ " , fMOL = " + sqlTo(nk.oDoc.getVar("HMOLOT"))
					+ " WHERE frtype = " +  sqlTo(RTYPE_PMR)
					+ " and FID_DOC = "+ sqlTo(this.fwid);
			ExecuteSQL(sSQL);
		}
		else
		{
			var sSQL = "update " + nk.bufName 
				+ " set fPODR = " + sqlTo(nk.oDoc.getVar("HPODRTO"))
				+ " , fMOL = " + sqlTo(nk.oDoc.getVar("HMOLTO"))				
				+ " WHERE frtype = " +  sqlTo(RTYPE_PMP)
				+ " and FID_DOC = "+ sqlTo(this.fwid);
			ExecuteSQL(sSQL);

			//vlad 27.10.10
			//В расходных строках понадобилось принудительно проставить МОЛ и Подр
			//в случае, когда документ создается программно из буфера строк "SF"
			var sSQL = "update " + nk.bufName 
					+ " set "
					//+ " fSC = " + sqlTo(oRow.getVar("RSC"))
					//+ " , fSU = " + sqlTo(oRow.getVar("RSU"))
					//+ " , fST = " + sqlTo(oRow.getVar("RST"))
					+ "  fPODR = " + sqlTo(nk.oDoc.getVar("HPODROT"))
					+ " , fMOL = " + sqlTo(nk.oDoc.getVar("HMOLOT"))
					+ " WHERE frtype = " +  sqlTo(RTYPE_PMR)
					+ " and FID_DOC = "+ sqlTo(this.fwid);
			ExecuteSQL(sSQL);
		}
	}	

	if(nk.oDoc.getVar("HDOC").toUpperCase()!="RU")
	ExecuteSQL(sSQL = "UPDATE " + nk.bufName
		+ " SET fcena_ord = fcena * " 
			+ "(SELECT " + IIF("nmk.fis_sred=0 or nmk.fis_sred is null", "1", "0")
				+ " FROM ^cl_nmk nmk "
				+ " WHERE fnmkl=nmk.fwid"
				+ " )"
		);

	if (this.WithoutWND == false)
	{
		if (!list || !list.isAppplyClick)
			nk.tbl4Grid.close();
	}
	if(this.old)
		return;
	saveRDate();
	nk.modifyData("EDIT", this.rowsName, fields2copy, this.bufName, this.fwid);	
	if(IsTable(nk.sTmpTbl))
		DropTable(nk.sTmpTbl);
	return true;
}

function saveRDate()
{
	var hdat = nk.oDoc.getVar("HDAT");
	if(hdat)
		ExecuteSQL("update "+ nk.bufName +" set FDATE="+ sqlTo(hdat), false);
}

function onEscape()
{		
	nk.tbl4Grid.close();
	if(typeof EscFunc=="function")
	{		
		if(!EscFunc())	
			return false;
		else 
			return true;
	}	
	
	if(this.old)
		return true;
	
	//fruckt
	//для MSSQL таблица sTmpTbl создается с # и не проходит проверку IsTable(nk.sTmpTbl)
	if(SUBD != MSSQL && !IsTable(nk.sTmpTbl))
		return true;
	nk.modifyData("EDIT", nk.rowsName, fields2copy, nk.sTmpTbl, nk.fwid);
	DropTable(nk.sTmpTbl);	
	
	if (this.oScan)
	{
		this.oScan.dispose();	
	}
}

function DpNakl_doMass(mode, mode2)
{
	par = new Object;
	par.isMass = true;
	par.nk = this;
	
	switch(mode)
	{
	case "CL":
		//необходимо чтоб форма для ввода параметров отбора для расчета ведомости остаков бралась из заголовка
		include("objects\\DpMass.js");
		include("GetParam.js");
		setParWithDef("FDAT", this.oDoc.getVar("HDAT"), "r_vdost_mass");
		setParWithDef("FPODR", this.oDoc.getVar("HPODR"), "r_vdost_mass");
		setParWithDef("FMOL", this.oDoc.getVar("HMOL"), "r_vdost_mass");
	
		if (this.sDocLbl == "PZ")
		{
			setParWithDef("FSC", 0, "r_vdost_mass");
			setParWithDef("FSU", 0, "r_vdost_mass");
			setParWithDef("FST", 0, "r_vdost_mass");
		}
		else
		{
			setParWithDef("FSC", this.oDoc.getVar("HSC"), "r_vdost_mass");
			setParWithDef("FSU", this.oDoc.getVar("HSU"), "r_vdost_mass");
			setParWithDef("FST", this.oDoc.getVar("HST"), "r_vdost_mass");
		}

		setParWithDef("FNMK", "", "r_vdost_mass");
		setParWithDef("FPOST", 0, "r_vdost_mass");
		setParWithDef("FCENA", 0, "r_vdost_mass");

		var obj = new DpMass();
		obj.setParentNk(this);
		obj.massMode = "CALC";
		obj.Run();		
		//showWindow("l_clnmktree_mass.xml", SW_MODAL, par);
		break;
		
	case "VDOST":
		par.menuMode = mode2;
		
		include("GetParam.js");
		setParSysOne("GLOBDAT1", this.oDoc.getVar("HDAT"));
		setParWithDef("FDAT", this.oDoc.getVar("HDAT"), "r_vdost_mass");
		setParWithDef("FPODR", this.oDoc.getVar("HPODR"), "r_vdost_mass");
		setParWithDef("FMOL", this.oDoc.getVar("HMOL"), "r_vdost_mass");

		showWindow("r_vdost_mass.xml", SW_MODAL, par);
		break;

	case "DOC":
		showWindow("l_pn_strs_mass.xml", SW_MODAL, par);
		break;
		
	case "PRICE":
		showWindow("l_price_mass.xml", SW_MODAL, par);
		break;
	}
}

function DpNakl_getCondRows(oCond, snapFields)
{
	var sql =
		"SELECT " + (snapFields? snapFields: "*")
		+ " FROM " + this.bufName
		+ " WHERE " + this.where;
			
	for (var fld in oCond)
	{
		sql += sqlw0And(fld + "=", oCond[fld])
	}	
		/*	
			+ sqlw0And("fnmkl=", oCond.fnmkl)
			+ sqlw0And("fcena=", oCond.fcena)
		*/	
	
	if (snapFields)
		return getSnap(sql);
	else
	{ 
		var t = OpenTable(sql);
		this.doTie(t);
		return t;
	}		
}

function DpNakl_loadNDS()
{
	var nds = Number(getPar("NDSPROC"));
	if(!nds)
		nds = 20;
	this.nds = nds;
	
	if(typeof FNDS_PROC!="undefined")
	{
		FNDS_PROC.clear();					
		FNDS_PROC.addItem(nds, UR("З ПДВ|C НДС"));
		FNDS_PROC.addItem(0, UR("Без ПДВ|Без НДС"));
		if(Number(getPar("NDSPROC"))>0)
		FNDS_PROC.value = nds;
		else
			FNDS_PROC.value = 0;
		var parentCtrl = FNDS_PROC.getCtrl().getParent();
		if (parentCtrl.getParent() != null)
			parentCtrl = parentCtrl.getParent();
		parentCtrl.layout(true, true);
	}	
}

DpNakl.prototype.getRowsName = function(date)
{
	if(date)
		date = new Date(date);
	else
		date = new Date(this.oDoc.getVar("HDAT"));
	
	var sName = ROW_PTN;
	var oSnap = getSnap("select FTBLNAME from ^ANLTK_PER"
						+" where FBDATE<="+ sqlTo(date) +" and FEDATE>="+ sqlTo(date)
						, false);
	if(oSnap)
		sName = oSnap[0];

	if(sName.toUpperCase()!=ROW_PTN.toUpperCase())
	{
		this.old = true;
		if(!IsTableEx("MTR", "mtr_"+ sName))
		{
			this.remote = true;
			sName = ROW_PTN;
		}
	}
	
	return sName;
}

function DpNakl_addRowsMassFifo(fnmkl, cena)
{
	cena = cena? cena: 0; 
	
	include("objects\\DpUCena.js");
	var oDocRow;
	var mode;

	var oCond = new Object;
	oCond.fnmkl = fnmkl;

	var fifoPar = new Object();			
	fifoPar.uCena = new Object();
	fifoPar.nk = this;
	fifoPar.isMass = true;
	
	// Если в буфере массового ввода уже есть такая номенклатур, то редактируем ее
	// иначе добавляем новую
	
	var tbl = this.getCondRows(oCond);
	if (tbl.recordCount > 0)
	{
		// в ФИФО при редактировании количество берется не с текущей строки а
		// суммируется по текущей номенклатуре
		var nKol = 0;
		var fwid = -1;
		for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
		{	
			nKol += Number(tbl.getValue("FKOL"));
			if (fwid == -1)
				fwid = Number(tbl.getValue("Fwid"));
		}
		
		mode = "FIFOEDIT";				
		oDocRow = this.oDoc.getRow("ROW", fwid);
		oDocRow.setVar("RKOL", nKol);
	}
	else
	{
		mode = "FIFOADD";
		oDocRow = this.oDoc.createRow("ROW");
		oDocRow.setVar("RTNMK", fnmkl)
		
		oDocRow.setVar("RFOCENA", cena)
		oDocRow.setVar("ROCENA", cena)
	}
	
	if (oDocRow.edit(mode, fifoPar))
	{
		if (mode == "FIFOEDIT")
		{
			// при редактировании мы удаляем старые строки (кроме текущей) и добавляем новые			
			for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
			{
				if (oDocRow.getID() != Number(tbl.getValue("Fwid")))
				{
					this.oDoc.deleteRow("ROW", Number(tbl.getValue("Fwid")));
					ExecuteSQL("DELETE FROM " + this.bufName + " WHERE FWID = " + sqlTo(Number(tbl.getValue("Fwid"))));
				}
			}
		}
		fifoPar.uCena.createFifo(this, oDocRow);				
	}
}

function DpNakl_addRowsMass(fnmkl, cenapr, f1cena, isScaner)
{
	var oDocRow = null;
	var mode;

	var oCond = new Object;
	oCond.fnmkl = fnmkl;
	
	var tbl = this.getCondRows(oCond);
	
	if (tbl.recordCount > 0)
	{
		mode = "EDIT";				
		oDocRow = this.oDoc.getRow("ROW", Number(tbl.getValue("Fwid")));
	}
	else
	{
		mode = "ADD";
		/*
		var oSnap = getSnap("select FWID from "+ this.bufName +" where FNMKL="+ fnmkl);
		if(oSnap && oSnap[0])
		{
			mode = "EDIT";
			oDocRow = this.oDoc.getRow("ROW", Number(oSnap[0]));
		}
		*/
		if(!oDocRow)
			oDocRow = this.oDoc.createRow("ROW");
		oDocRow.setVar("RTNMK", fnmkl)
		if (cenapr)
		{
			oDocRow.setVar("RFOCENA",cenapr);		
			oDocRow.setVar("ROCENA",cenapr);
		}
		if(this.sDocLbl == "PN")
		{
			oDocRow.setVar("RPCENE", f1cena);
		}
	}

	if(isScaner)
		oDocRow.setVar("RKOL", oDocRow.getVar("RKOL")+1);

	var par = new Object;
	par.isMass = true;
	
	if (oDocRow.edit(mode, par))
	{
		this.oDoc.appendRow("ROW", oDocRow);		
		obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, this.bufName);															
		if(isScaner)
		{
			var pos = this.tbl4Grid.absolute;
			this.tbl4Grid.requery();
			this.tbl4Grid.absolute = pos;
			grid.refresh();
		}
	}
	if (tbl)
		tbl.close();
	//else if(isScaner)
	//	oDocRow.setVar("RKOL", oDocRow.getVar("RKOL")-1);
}
function DpNakl_onInputLineCode(linecode)
{
	var oSnap = getSnap("SELECT fwid, fcenapr, f1cena FROM ^cl_nmk "
			+" WHERE flinecod=" + sqlTo(linecode)
			+" AND (Fisgrp<>"+ sqlTrue
			+" OR Fisgrp IS NULL)");
	
	trace("\n>>> DpNakl_onInputLineCode: "+ linecode +" > "+ (oSnap? oSnap[0] : "0"));
	if(!oSnap || !oSnap[0])
		return null;
	
	this.addRowsMass(oSnap[0], oSnap[1], oSnap[2], true);
}

function DpNakl_dispose()
{
	if (this.oScan)
	{
		this.oScan.dispose();	
	}
}

function DpNakl_validSc()
{
	// вешаем валидацию для документов PM и GP, т.к. здесь существует возможность загрузки строк в автоматическом режиме
	if (!inList(this.oDoc.sDocLbl, "PM", "GP"))
	{
		return true;
	}
	
	// количество строк в документе
	var nRcnt = this.oDoc.getAttr("RCNT");
	var sNmk = "";
	isScValid = true;
	var strNum = "";
	if(this.oDoc.gotoFirstRow())
	{
		while(this.oDoc.gotoNextRow())
		{
			var currRow = this.oDoc.getCurrRow();
			sc = currRow.eval("RSC");
			su = currRow.eval("RSU");
			st = currRow.eval("RST");
			
			var oSc = new DpSc("cut");
			isScValid = false;
			oSc.set(0,0,0);
			oSc.set(sc, su, st);
			isScValid = oSc.valid(true);
			isScValid1 = true;

			if (nRcnt == 2)
			{
				sc1 = currRow.eval("RSC1");
				su1 = currRow.eval("RSU1");
				st1 = currRow.eval("RST1");
				
				oSc.set(0,0,0);
				oSc.set(sc1, su1, st1);
				isScValid1 = oSc.valid(true);
			}
			
			isScValid = isScValid && isScValid1;
			if (!isScValid)
			{
				sNmk = tfnmk("TXT", currRow.eval("RTNMK"));
				curSc = currRow.eval("RSC");
				curSu = currRow.eval("RSU");
				curSt = currRow.eval("RST");
				break;
			}
		}
	}
	if (!isScValid)
	{
		alert(ru("Есть строка (номенклатура - \""+sNmk+"\" со счетом "+curSc+"/"+curSu+"/"+curSt+") с некорректными значениями счета/субсчета/статьи. Без исправления сохранение невозможно"
			, "Є рядок (номенклатура - \""+sNmk+"\" з рахунком "+curSc+"/"+curSu+"/"+curSt+") з некоректними значеннями рахунку/субрахунку/статті. Без виправлення збереження неможливе."))
	}
	return isScValid;
}