// Объект для работы со строкой журнала регистрации

// Включается иключительно, чтобы подключились все
// пользовательские функции
include("Objects//DpEval.js");
include("Objects//DpJournal.js");

function regJr(vid)
{
	RO("regJr", this);
   this.vid = vid;

	this.cndVar = SqlInStr("Fattr",sqlTo(this.vid))
		+" AND " + SqlInStr("Fattr","'$'")
		+" AND " + SqlInStr("'DT'", SqlMid("Fvar",2,1))
		+" AND " + SqlInStr("'PV'", SqlMid("Fvar",3,1))

   this.rstVar = null;
   // Выражения для чтения
   this.arVar = new Object();
   this.vaVar = new Object();
   this.s0Var = new Object();
   this.v0Var = new Object();
   this.v1Var = new Object();
   this.v2Var = new Object();
      
   this.init    = regJr_init;
   this.varInit = regJr_varInit;
   this.eval    = regJr_eval;
   this.openTable = regJr_openTable;

	this.varInit();
   
   this.bDat = date(1,1,1900);
   this.eDat = date(1,1,3000);
   
   this.jrJr = "TMP_REGJR";
   this.jrNo = null;
   this.fiddeal = null;
}

function regJr_init()
{
   var strSql
   DropTable(this.jrJr)
   
   if(getRegPar(this.vid, "GRJREG")=='+')
   {
		var cWhere = " b.freg IN ("
			+ "SELECT freg"
			+ " FROM ^cl_reg cvid"
			+ " WHERE cvid.fvid=" + sqlTo(this.vid)
				+ " AND " + sqlStrIsEmp("cvid.fdoc")
			+ ")"
			;
   }
   else
		var cWhere = ' b.FREG='+sqlTo(this.jrNo)
			+ ' AND a.FREG='+sqlTo(this.jrNo);
   
   strSql =
		'SELECT a.*, 1 as FVIDSLD'
		+ ' INTO '+this.jrJr
		+ " FROM ^cl_reg b"
			+ " INNER JOIN ^docreg a"
				+ " ON b.FDOC=a.FDOC"
					+ " AND b.FNOP=a.FNOP"
						+ " AND b.FREG=a.FREG"
		+ " WHERE "+ SqlCmpTrue
			+ " AND b.Fnom=0"
			+ " AND b.Fused="+sqlTrue
			+ ' AND ' + cWhere

	this.nSposob	= Number(getRegPar(this.vid, "SPOSOB"));
	switch(this.nSposob)
	{
	case 1:
		strSql += " AND ("
			+ " ((a.Fnk_dat=" + sqlTo(d00) + " or b.Fvid='-'" + ")"
				+ " AND a.Fdoc_dat <= " + sqlTo(this.eDat) 
				+ ")"
			+ " OR ("
				+ "a.Fnk_dat<>" + sqlTo(d00)
				+ " AND a.Fnk_dat <= " + sqlTo(goDay(this.eDat, getRegPar(this.vid, "DAYNGNK")))
				+ ")"
			+ " OR ("
				+ " a.Fdoc='SR'"
				+ " AND a.Fdoc_dat<=" + sqlTo(this.eDat)
				+ ")"
			+ ")"
		break;
	case 2:
		strSql += " AND a.Fisnov1="+SqlFalse
			+ " AND ("
				+ " ((a.Fnk_dat=" + sqlTo(d00) + " or b.Fvid='-'" + ")"
					+ " AND a.Fdoc_dat BETWEEN "
						+ sqlTo(this.bDat)
						+ " AND " + sqlTo(this.eDat) 
					+ ")"
				+ " OR ("
					+ "a.Fnk_dat<>" + sqlTo(d00)
					+ " AND a.Fnk_dat BETWEEN"
						+ sqlTo(goDay(this.bDat, getRegPar(this.vid, "DAYNGNK")))
						+ " AND " + sqlTo(goDay(this.eDat, getRegPar(this.vid, "DAYNGNK")))
					+ ")"
				+ " OR ("
					+ " a.Fdoc='SR'"
					+ " AND a.Fdoc_dat<=" + sqlTo(this.eDat)
					+ ")"
				+ ")"
	}
	
	if(this.fiddeal)
		strSql += " AND fiddeal=" + sqlTo(this.fiddeal);
	
   ExecuteSQL(strSql);
   
/*
   strSql =
		"INSERT INTO "+this.jrJr + "(" + GetPatternIntersection("DOCREG", "DOCREG") + ", FVIDSLD)"
		+ " SELECT " + GetPatternIntersection("DOCREG", "DOCREG", "a") + ", 0 as FVIDSLD"
		+ " FROM ^DOCREG a"
			+ " INNER JOIN ^"+this.jrJrs+" b"
				+ " ON a.FREG=b.FREG"
		+ " WHERE a.Fdoc="SR""
			+ " AND a.Fdoc_dat<=" + sqlTo(this.eDat)
	ExecuteSQL(strSql);
*/
   
   switch(this.nSposob)
   {
   case 1:
		strSql = "CREATE INDEX TMP ON "+this.jrJr
			+" (FIDDEAL, FORG, FDOC_DAT, FVIDSLD, FISNOV1 DESC, FDOC_LEV, FDOC_NUM, FID_DOC)"
		break;
	case 2:
		strSql = "CREATE INDEX TMP ON "+this.jrJr
			+" (FIDDEAL,FDOC_DAT,FVIDSLD,FORG)"
	}
   ExecuteSQL(strSql);

}

function regJr_varInit()
{
	var j = new DpJournal("S" + (this.vid=="+"? "P": "M"));
	aFlds = j.getFieldsImpl();
	for (var i = 0; i < aFlds.length; i++)
	{
      var varLbl = aFlds[i].FVAR.toUpperCase();
      this.arVar[varLbl] = aFlds[i].FVAR.trim();
      this.vaVar["ATTR"+varLbl] = aFlds[i].FATTR.trim();
      this.v0Var["V0"+varLbl] = 0;
      this.v1Var["V1"+varLbl] = 0;
      this.v2Var["V2"+varLbl] = 0;
      this.s0Var["S0"+varLbl] = 0;
	}
	/*
   var strSQL
   strSQL = "SELECT *"
      +" FROM ^VARREG"
      +" WHERE " + this.cndVar
   this.rstVar = OpenTable("s", strSQL)
   while( !this.rstVar.IsEOF() )
   {
      var varLbl = this.rstVar("fvar").trim().toUpperCase();
      this.arVar[varLbl] = this.rstVar("ffield").trim();
      this.vaVar["ATTR"+varLbl] = this.rstVar("fattr").trim();
      this.v0Var["V0"+varLbl] = 0;
      this.v1Var["V1"+varLbl] = 0;
      this.v2Var["V2"+varLbl] = 0;
      this.s0Var["S0"+varLbl] = 0;
      this.rstVar.MoveNext();
   }*/
}


function regJr_eval(expr)
{
	/* Заменять можнo только когда V0, V1, V2, S0 в начале идентификатора
			expr = expr.replace(/V0/g, "this.v0Var.V0")
			expr = expr.replace(/V1/g, "this.v1Var.V1")
			expr = expr.replace(/V2/g, "this.v2Var.V2")
			expr = expr.replace(/S0/g, "this.s0Var.S0")
	*/
	var lexemas = new Array();
	getLex(expr, lexemas);
	expr = "";
	var chr0;
	var chr1;
	for (var i = 0; i < lexemas.length; i++)
	{
		chr0 = lexemas[i].charAt(0).toUpperCase();
		chr1 = lexemas[i].charAt(1).toUpperCase();
		if(chr0 == "V")
		{
			if(inList(chr1, "0","1","2"))
				lexemas[i] = "this.v" + chr1 + "Var." + lexemas[i].toUpperCase();
		}
		else if (chr0 == "S" && chr1 == "0")
			lexemas[i] = "this.s0Var." + lexemas[i].toUpperCase();
		expr += lexemas[i];
	}
	lexemas = null;

	return eval(expr);
}

function _isLetter(str)
{
	var leters = "_qwertyuiopasdfghjklzxcvbnm";
	if (leters.indexOf(str.toLowerCase()) == -1)
		return false;
	return true;
}

function _isDigit(str)
{
	var leters = "1234567890.";
	if (leters.indexOf(str) == -1)
		return false;
	return true;
}

function getLex(str, array)
{
	for (var i = 0, j = 0; i < str.length;)
	{	
		var substr	   = "";
		while ((i < str.length) && (!_isLetter(str.substring(i,i + 1))))
			substr	  += str.substring(i++,i);
		if (substr != "")
		{
			array[j++] = substr;
			substr	   = "";
		}
		while ((i < str.length) && ((_isLetter(str.substring(i,i + 1))) 
				|| (_isDigit(str.substring(i,i + 1)))))
			substr	  += str.substring(i++,i);
		if (substr != "")
		{
			array[j++] = substr;
			substr	   = "";
		}	
	}
}

function regJr_openTable()
{
	var t = OpenTable("m", this.jrJr, "tmp");
	if (SQL)
	switch(this.nSposob)	
	{
		case 1: t.Index = "FIDDEAL,FORG,FDOC_DAT,FVIDSLD,FISNOV1,FDOC_LEV,FDOC_NUM,FID_DOC";
		break;
		case 2:  t.Index = "FIDDEAL,FDOC_DAT,FVIDSLD,FORG";
	}
	return t;
}