include("doc\\DpDocList.js");
include("objects\\DpVal.js");
include("objects\\DpSc.js");
include("sys\\mask.js");
include("Tmoney.js");

var sTmpTbl = "TMP_RAO";
var ctrlLinker;
var oVal, oSc;
var tbl;
var objDoc;

function Load()
{
	objDoc = extPar.doc;
	
	this.initGrid = _initGrid;
	this.initGrid();
	this.listMenuInit = listMenuInit;
	this.onSelectRowMenu = onSelectRowMenu;
	
	Caption(extPar.doc.getCaption() + ": " + modeName(extPar.mode));
	
	HTN.setMask(MASK_DOCNUM);
	HCITY.setMask("&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&");
	HSUM.setMask(MASK_SUM);
	HSUM_O.setMask(MASK_SUM);
	HSUMK.setMask(MASK_SUM);
	
	oVal = new DpVal();
	oVal.linkCtrl(HVAL);
	
	oSc = new DpSc("cutxyz");
	oSc.linkCtrl(HSC, HSU, HST, HAN1, HAN2, HAN3);
	oSc.linkCtrlTxt(HNAME);
	
	
	ctrlLinker = new DpCtrlLinker(extPar.doc);
	ctrlLinker.addLink("HNOM",HTN);
	ctrlLinker.addLink("HCITY",HCITY);
	ctrlLinker.addLink("HAVAN",HAVAN);
	ctrlLinker.addClLink("HVAL",oVal);
	ctrlLinker.addLink("HSUM",HSUM);
	ctrlLinker.addLink("HSUMK",HSUMK);
	ctrlLinker.addScLink("HSC", "HSU","HST","HA1","HA2","HA3", oSc);
	ctrlLinker.addLink("HSUM_O",HSUM_O);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	
	
	if (extPar.mode != "ADD")
	{
		oVal.setCod(extPar.doc.getVar("HVAL"));
		//oSc.set(extPar.doc.getVar("HSC"),extPar.doc.getVar("HSU"),extPar.doc.getVar("HST"),
		//		extPar.doc.getVar("HA1"),extPar.doc.getVar("HA2"),extPar.doc.getVar("HA3"));
		
	}
	ctrlLinker.updateData(false);
	Disable(HSUM_O);
	Disable(HSUMK);
	refreshSUMK();
	//setValid(FDOC_DAT, FDOC_DAT_Valid);
	
	setValid(HSC, calcSumOst);
	setValid(HSU, calcSumOst);
	setValid(HST, calcSumOst);
	setValid(HAN1, calcSumOst);
	setValid(HAN2, calcSumOst);
	setValid(HAN3, calcSumOst);
	setValid(FDOC_DAT, calcSumOst);
}

/*
function FDOC_DAT_Valid()
{
	extPar.doc.setVar("HDAT", toScrObj(FDOC_DAT.value))
}
*/

function listMenuInit()
{
	if(IsDblClick(grid))
	{
		grid.runGridMenu("EDIT");
		return;
	}
	grid.AddMenuItem("ADD","Додавання | Добавление");
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT","Редагування | Редактирование");
		grid.AddMenuItem("COPY","Копіювання | Копирование");
		grid.AddMenuItem("DEL","Видалення | Удаление");
	}
	grid.AddMenuItem("","");
	grid.AddMenuItem("+++","Експорт|Экспорт");
		grid.AddMenuItem("EXPORTCALC","Open Calc");
		grid.AddMenuItem("EXPORTXLS","Формат xls");
	grid.AddMenuItem("---","");
	grid.AddMenuItem("","");
	grid.AddMenuItem("FIND", "Пошук|Поиск");
	grid.AddMenuItem("SELECT", "Відбір|Отбор");
}

function _initGrid()
{
   	this.sDocSourceDir = rootDirectory() + "docs/" + extPar.doc.sDocLbl + "/";
	CreateTable(sTmpTbl,"RAO","FWID");
	var nId = (extPar.mode == "COPY") ? extPar.doc.nOldID : extPar.doc.getID();
	if(extPar.isTransform)	//для связанных документов
	{
		objDoc.gotoFirstRow();
		do
		{
			var oRow = objDoc.getCurrRow();
			if (oRow == null)
				continue;
			obj2DB(oRow.jDoc.getObjectID(), oRow.jDoc, null, sTmpTbl);
			oRow.saveExtToDB();
		}
		while(objDoc.gotoNextRow())
	}
	else
	{
		var sFLD = GetPatternIntersection("RAO","RAO");
		var sSQL = "INSERT INTO " + sTmpTbl + "(" + sFLD + ")"
				   + " SELECT " + sFLD
				   + " FROM ^RAO"
				   + " WHERE fid_doc = " + nId;
		ExecuteSQL(sSQL);
	}
	grid.setXMLDir(this.sDocSourceDir);
	grid.setXMLFile("rowlist.xml");
	tbl = OpenTable("m","select * from " + sTmpTbl + " order by fnom_str");
	tbl.tie("cl_valut","x_cl_valut","fkod","fvald");
	
	if(extPar.mode=="COPY")
		extPar.doc.resetFnids(tbl, "AOROW", extPar.doc);
	
	grid.setTable(tbl);
//-	grid.getTable().setIdFld("FNID");
	grid.build();
	grid.loadMenuHandler(this,"listMenuInit");
	grid.selectMenuHandler(this,"onSelectRowMenu");
}

function onSelectRowMenu(sID)
{
	if(sID == "DEL")
	{
		var msg = ru("Подтвердите удаление записи.", "Підтвердіть вилучення запису.");
		var ret = msgBox("^c-", msg, ru("Подтверждение удаления","Підтвердження вилучення"));
		switch(ret)
		{
			case 'c':
				break;
			case '-':
				extPar.doc.deleteRow("AOROW",
				Number(grid.getTable().getRowID()));
				grid.getTable().Delete();
				grid.getTable().requery();
				grid.refresh();
			break;
		}		
	}
	else if(sID == "__XDEL")
	{
		var delRowCount = DataSource().getSelectedCount();
		
		if (delRowCount <= 0)
		{
			return;
		}
		var selIds = DataSource().getSelectedIDs();
		
		var sCapt = ru("Удаление записей", "Видалення записів");
		var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів")+" (" + DataSource().getSelectedCount() + ").";
		if("c"==msgBox("c-", sMsg, sCapt))
		{
			return;
		}

		setProgressRange(0, delRowCount);
		for (var nRow = 0; nRow < selIds.length; nRow++)
		{
			setProgressPos(nRow + 1, sCapt +": "+ (nRow + 1) +"/"+ delRowCount);
			extPar.doc.deleteRow("ROW", Number(selIds[nRow]));
		}
		var sSQL = "DELETE FROM " + grid.getTable().getTableName()
					+ " WHERE " + grid.sqlSelected()
		ExecuteSQL(sSQL);

		grid.clearSelected();
		setProgressPos(0);
		grid.getTable().requery();
		grid.refresh();
	}
	else if (sID == "EXPORTCALC")
	{
		var oPar = new Object();
		oPar.grid = grid;
		showWindow("grid_to_scalc.xml", SW_MODAL, oPar);
	}
	else if (sID == "EXPORTXLS")
	{
		var sFile = BrowseForFile("*.xls", "Файлы XLS (*.xls)|*.xls|", null, "SAVE");
		if (sFile)
		{
			if (!sFile.endsWith(".xls"))
				sFile = sFile + ".xls";
			grid.exportToXLS(sFile);
		}
	}
	else if (sID == "FIND")
	{
		grid.runSelection(8);
	}
	else if (sID == "SELECT")
	{
		grid.runSelection(2);
	}
	else
	{
		var oDocRow;
		if(sID == "ADD")
		{
			oDocRow = extPar.doc.createRow("AOROW");
			var oSnap = getSnap("select max(fnom_str) as nom from " + sTmpTbl);
			var nNom = 1;
			if (oSnap && oSnap[0])
				nNom = Number(oSnap[0]) + 1;
			oDocRow.setVar("RNOM",nNom)
				
		}
		else if(sID == "EDIT")
		{
			oDocRow = extPar.doc.getRow("AOROW",Number(grid.getTable().getRowID()));
		}
		else if(sID == "COPY")
		{
			oDocRow = extPar.doc.copyRow("AOROW", 
						Number(grid.getTable().getRowID()));			
		}
		
		var bOK = oDocRow.edit(sID)
		if (typeOf(FORM) == "DpXMLDialog")
		{		
			FORM.setActive();
		}	
		if (bOK)
		{
			if(inList(sID,"ADD","COPY"))
				extPar.doc.appendRow("AOROW",oDocRow)
				
			obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,sTmpTbl);
			grid.getTable().requery();
			grid.refresh();
			refreshSUMK();
		}
	}
}

function refreshSUMK()
{
	var ctbl = OpenTable("s","SELECT SUM(FSUMD) AS sumd FROM " + sTmpTbl);
	if (!ctbl.IsEmpty() && Number(ctbl.getValue("sumd")) > 0)
	{
		HSUMK.value = (Number(ctbl.getValue("sumd")));
	}
	else
	{
		HSUMK.value = 0;
	}
	
	ctbl.close();
}

function saveRows()
{
	ExecuteSQL("DELETE FROM ^RAO WHERE fid_doc=" + sqlTo(extPar.doc.getVar("ID")));
	var sFLD = GetPatternIntersection("RAO","RAO");
	ExecuteSQL("INSERT INTO ^RAO(" + sFLD + ")"
			  + " SELECT " + sFLD + " FROM " + sTmpTbl);
}

function onSave(isApply)
{
	ctrlLinker.updateData(true);
	saveRows();
	if (!isApply)
		tbl.close();
}

function onEscape()
{
	tbl.close();
}

function calcSumOst()
{
	var sl = 0;
	var curCtrl = calcSumOst.arguments[0];
	var doc_dat = toScrObj(FDOC_DAT.getValue());
		
	if (curCtrl != null && !isEmpty(doc_dat))
	{
		doc_dat = new Date(goDay(doc_dat, -1));
		var strWait = ru("Расчет суммы остатка предыдущего аванса проводится на дату "
								, "Розрахунок суми залишку попередньгого авансу проводиться на дату ")+d_m_y(doc_dat);
		sID = String(curCtrl.getData("ID"));
	}
	else
	{
		return false;
	}
	
	switch (sID)
	{
		case "HSC":
		case "HSU":
		case "HST":
			strSQL = "SELECT COUNT(*)" 
						+" FROM ^CL_SCHET"
						+" WHERE 1=1"
							+sqlw0And("FSCHET=", oSc.getSc())
							+sqlw0And("FSUBSCHET=", oSc.getSu())
							+sqlw0And("FSTAT=", oSc.getSt())
			var oSn = getSnap(strSQL);
			
			//если 1 строка и нет на счете аналитик то тогда делаем расчет остатка
			if(oSn[0] == 1 && tfsc("CL1", oSc.getSc(),oSc.getSu(),oSc.getSt()) == 0)
			{
				sl = sl_("D+", doc_dat, "", oSc.getSc(), oSc.getSu(), oSc.getSt());
				HSUM_O.showErr(strWait);				
			}
			oSn = null;
		break;
		
		case "HAN1":
			//если это последняя аналитика и она не пустая то делаем расчет
			if(tfsc("CL2", oSc.getSc(),oSc.getSu(),oSc.getSt()) == 0 && !isEmpty(toScrObj(HAN1.getValue())))
			{
				sl = sl_("D+", doc_dat, "", oSc.getSc(), oSc.getSu(), oSc.getSt(), oSc.getCl1());								
				HSUM_O.showErr(strWait);				
			}
		break;
		
		case "HAN2":
			//если это последняя аналитика и она не пустая то делаем расчет
			if(tfsc("CL3", oSc.getSc(),oSc.getSu(),oSc.getSt()) == 0 && !isEmpty(toScrObj(HAN2.getValue())))
			{
				sl = sl_("D+", doc_dat, "", oSc.getSc(), oSc.getSu(), oSc.getSt(), oSc.getCl1(), oSc.getCl2());
				HSUM_O.showErr(strWait);				
			}
		break;
		
		case "HAN3":
			//если вызвались на 3 аналитике и она не пустая то расчет 
			if(!isEmpty(toScrObj(HAN3.getValue())))
			{
				sl = sl_("D+", doc_dat, "", oSc.getSc(), oSc.getSu(), oSc.getSt(), oSc.getCl1(), oSc.getCl2(), oSc.getCl3());
				HSUM_O.showErr(strWait);				
			}
		break;
		case "FDOC_DAT":
			//если счет введен то считаем сальдо
			if(oSc.getSc() != 0)
			{
				sl = sl_("D+", doc_dat, "", oSc.getSc(), oSc.getSu(), oSc.getSt(), oSc.getCl1());
				HSUM_O.showErr(strWait);
			}
		break;
				
		default:
		break;
	}	
	
	HSUM_O.setValue(sl);
	return true;
}

include("sys\\DpBaseDlg.js");