include("Objects/DpCtrlLinker.js");
include("Objects/DpVal.js");
include("Objects/DpCl.js");
include("doc/DpDoc.js");
include("sub/bil.js");

var sDir = rootDirectory() + "docs/BILDOG/";
var sTmpTbl = getTmpTableName();
var sRowTbl = "BIL_PACK";
var edmode = extPar.mode;
var objDoc;
var codPlat;
var codPack;
var vidDog;
var sRowClass = "PACK";
var ctrlLinker;
var gridTbl;
var sMode;
var oOrg;

function Load()
{
	objDoc = extPar.doc;
	
	Caption(objDoc.getCaption() + ": " + modeName(extPar.mode));

	ctrlLinker = new DpCtrlLinker(objDoc);
		
	codPlat = objDoc.getPar("_codplat");
	codPack = objDoc.getPar("_codpack");
	vidDog = objDoc.getPar("_viddog");
	if(!codPack && vidDog==0)
		codPack = getPar("BILL_PACK");
	else if(!codPack && vidDog==1)
		codPack = getPar("BILTEL_PACK");	
	if(!codPlat && vidDog==0)
		codPlat = getPar("BILL_CL");
	else if(!codPlat && vidDog==1)		
		codPlat = getPar("BILTEL_CL");
	
	sMode = this.sMode;
	
	HDOG_NUM.mask = "&&&&&&&&&&&&&&&";
	HSUM_DOG.mask = MASK_SUM;	
	HSUM.mask = MASK_SUM;
	HINCR.mask = MASK_SUM;
	HGROUP.mask = "###";
	HORDER_NUM.mask = "#######";
		
	loadVid(HVID);
			
	oOrg = new DpCl();
	oOrg.setClcl(codPlat);	
	oOrg.linkSmartCtrl(HORG);
	oOrg.setContAssist();
	oOrg.AfterLoad = setOrg;
	setValid(HORG, num_valid);
	
	var codDistr = getPar("BILL_DISTR");
	oDistr = new DpCl("0");
	oDistr.setClcl(codDistr);	
	oDistr.linkSmartCtrl(HDISTRIB);
	oDistr.setContAssist();
	
	var codOut = getPar("BILL_OUT");
	oOut = new DpCl("0");
	oOut.setClcl(codOut);	
	oOut.linkSmartCtrl(HOUT);
	oOut.setContAssist();
			
	ctrlLinker.addLink("HDAT",	HDAT);     
   	ctrlLinker.addLink("HORG",	HORG);     
  	ctrlLinker.addLink("HTXT",	HTXT);
  	ctrlLinker.addLink("HEDAT",	HEDAT);
  	ctrlLinker.addLink("HBDAT",	HBDAT);
  	ctrlLinker.addLink("HDOG_NUM",HDOG_NUM);  		
  	ctrlLinker.addLink("HSUM_DOG",HSUM_DOG);  
  	//ctrlLinker.addLink("HTYPE_DOG",HTYPE_DOG);
  	//ctrlLinker.addLink("HVID_DOG",HVID_DOG);	
	//ctrlLinker.addLink("HCONDAT",HCON_DAT);
	ctrlLinker.addLink("HINCR",	HINCR);
	ctrlLinker.addLink("HVID_DOG",HVID);
	ctrlLinker.addLink("HGROUP", HGROUP);  	
	ctrlLinker.addLink("HPRINT", HPRINT);  
	ctrlLinker.addLink("HPRINTACT", HPRINTACT);  
	ctrlLinker.addLink("HBILSYS", FBILSYS); 
	ctrlLinker.addLink("HPERSNUM", HPERSNUM);
	//ctrlLinker.addLink("HDISTRIB", HDISTRIB);
	//ctrlLinker.addLink("HOUT", HOUT);
	ctrlLinker.addLink("HMODEM", HMODEM);
	ctrlLinker.addLink("HCONNECT", HCONNECT);
	ctrlLinker.addLink("HORDER_NUM", HORDER_NUM);
	  	
 	ctrlLinker.updateData(false);        
 	 	
 	if (edmode!="ADD")
 	{
 		oOrg.setCod(objDoc.getVar("HORG"));
 		oDistr.setCod(objDoc.getVar("HDISTRIB"));
 		oOut.setCod(objDoc.getVar("HOUT"));
        //oVid.setCod(objDoc.getVar("HVID_DOG")); 
        Disable(HVID);             	
 	}
 	if(edmode=="ADD" || edmode=="COPY")
 	{
 		HDOG_NUM.value = getNextDogNum();
 		HVID.value = vidDog;
 		setOrg();
 		nextOrderNum();
 	}
 	if(edmode=="ADD")
 	{
 		HPRINTACT.checked = true;
 		HEDAT.value = d00;
 		HTXT.value = HVID.getStringValue();
 		HORG.value = "";
 		if(extPar.Forg)
 		{
 			oOrg.setCod(extPar.Forg);
 			setOrg();
 		}
 	}
 	if(ReadParEx("bill_pack_showall")=="1")
 		SHOWALL.checked = true;
 	
 	this.nextOrderNum = nextOrderNum; 	
 	setButton(HORDER_NUM, this, "nextOrderNum");
 	
 	setValid(HINCR, recalcSum);
 	setValid(HVID, vid_valid);
 	setValid(SHOWALL, gridInit);
 	setValid(HDOG_NUM, num_valid);
 	
 	Disable(HSUM_DOG);	 	
 	Disable(HSUM);
 	Disable(HVID);
 	
 	loadGrid(this.sMode);
 	
 	recalcSum();
 	num_valid();
}

function onSave()
{	
	ctrlLinker.updateData(true);
	objDoc.setVar("HORG", oOrg.getCod());
	objDoc.setVar("HOUT", oOut.getCod());
	objDoc.setVar("HDISTRIB", oDistr.getCod());		
	//objDoc.setVar("HVID_DOG", vidDog);
	
	storeToDb(sRowTbl, sTmpTbl);
		
	exit();
}

function loadVid(oCtrl)
{
	oCtrl.addItem(0, UR("Інтернет|Интернет"));
	oCtrl.addItem(1, UR("Телефон|Телефон"));
	oCtrl.addItem(2, UR("Передача даних|Передача данных"));
}

function setOrg()
{
	if(Number(oOrg.get("FCAT"))==0)
		HPRINT.value = 0;
	else
		HPRINT.value = 1;
	num_valid();
}

function vid_valid()
{
	vidDog = HVID.value;
	gridInit();
}

function loadGrid(sMode)
{		
	DropTable(sTmpTbl);	
	var sSQL = "SELECT * "
			+ " INTO " + sTmpTbl
			+ " FROM ^"+ sRowTbl;			
	var sWhere = " WHERE 1<>1 ";
	var nID = (extPar.mode=="COPY") ? objDoc.nOldID : objDoc.getID();
	if (sMode != "ADD")
		sWhere = " WHERE FID_DOG="+ sqlTo(nID);
	sSQL += sWhere;	
	ExecuteSQL(sSQL);
		
	gridInit();
}

function gridInit()
{
	grid.DeletePages();
	var sRowList = "rowlist.xml";
	
	var sWhere = " where FEDAT>"+ sqlTo(new Date());
	if(SHOWALL.checked)
	{
		WriteParEx("bill_pack_showall", "1");
		sWhere = "";
	}
	else
		WriteParEx("bill_pack_showall", "0");
	
	gridTbl = OpenTable("m", "SELECT * FROM "+ sTmpTbl
					+ sWhere
					+" order by FPOINT,FWID_CL,FPHONE,FBDAT,FEDAT DESC");
	gridTbl.tie("cl_pack", "pack", "FWID_CL", "FWID_CL");
	gridTbl.tie("cl_phone", "phon", "FWID_CL", "FPHONE");
	gridTbl.tie("cl", "point", "FWID", "FPOINT");
	gridTbl.tie("cl", "techn", "FWID", "FTECHN");
	
	if(extPar.mode=="COPY")
		objDoc.resetFnids(gridTbl, sRowClass, objDoc);
		
	grid.setXMLDir(sDir);
	grid.setXMLFile(sRowList);
	grid.setTable(gridTbl);
	grid.build();		
	grid.setData(sRowClass);
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRum = gridMenuRum;
	grid.loadMenuHandler(this,"gridMenuInit");
	grid.selectMenuHandler(this,"gridMenuRum");
}

function gridMenuInit(grid)
{
	grid.AddMenuItem("ADD","Додати|Добавить");
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT","Редагувати|Редактировать");
		grid.AddMenuItem("COPY","Копіювати|Копировать");
		grid.AddMenuItem("DEL","Видалити|Удалить");		
	}	
}

function gridMenuRum(sID, grid)
{	
	var tbl = grid.getTable();
	var tName = tbl.getTableName();	
	var rowID = tbl.getValue("FWID");
			
	switch(sID)
	{
		case "DEL":
			var nGridPos = grid.getRowSelected();
			ExecuteSQL("delete From "+ tName 
					+" where Fwid="+ sqlTo(rowID));
			objDoc.deleteRow(sRowClass, rowID);		
			tbl.requery();
			tbl.setAbsolute(nGridPos-1);
			grid.refresh();
			recalcSum();	
			break;
			
		case "ADD": case "EDIT": case "COPY":						
			var oRow;						
			if(sID == "ADD")
				oRow = objDoc.createRow(sRowClass);
			else if(sID == "EDIT")
				oRow = objDoc.getRow(sRowClass, rowID);
			else if(sID == "COPY")
				oRow = objDoc.copyRow(sRowClass, rowID);
			
			if (!oRow || !rowEdit(sID, oRow))
				break;			
			if(inList(sID, "ADD", "COPY"))
				objDoc.appendRow(sRowClass, oRow);
			obj2DB(oRow.getID(), oRow.jDocRow, null, sTmpTbl);
			
			//если закрывается пакет, то нужно закрыть все доп. услуги по точке
			closeAllServ(oRow);
					
			recalcSum();
			tbl.requery();
			grid.refresh();			
			break;
	}
	grid.setFocus();
	FORM.setActive();
		
	return true;	
}

function storeToDb(sTbl, tmpTbl)
{
	var sFld = GetPatternIntersection (sTbl, sTbl);
	ExecuteSQL("DELETE FROM ^"+ sTbl +" WHERE FID_DOG="+ sqlTo(objDoc.getID()));
	ExecuteSQL("UPDATE "+ tmpTbl +" SET FID_DOG="+ sqlTo(objDoc.getID()));
	ExecuteSQL("INSERT INTO ^"+ sTbl +" ("+ sFld +")"
				+" SELECT "+ sFld +" FROM "+ tmpTbl 
				+" where FID_DOG="+ sqlTo(objDoc.getID()));
}

function exit()
{
	gridTbl.close();	
	ExecuteSQL("drop table "+ sTmpTbl, false);
}

function  onEscape()
{
	exit();
}

function rowEdit(sMode, oRow)
{		
	objDoc.setVar("HORG", oOrg.getCod());
	objDoc.setVar("HBDAT", HBDAT.value);
	objDoc.setVar("HEDAT", HEDAT.value);
	objDoc.setVar("HBILSYS", FBILSYS.value);
	
	var par = new Object();
	par.oOrg = oOrg;
	par.objDoc = objDoc;
	return oRow.edit(sMode, par);	
}

function hasExt()
{
	return false;
}

function recalcSum()
{
	var sum = 0;
	var oSnap = getSnap("select sum(p.FCENA) from ^CL_PACK p "
			+" where FWID_CL in (select FWID_CL from "+ sTmpTbl 
				+" where FEDAT>"+ sqlTo(new Date()) +" )");
	if(oSnap)
		sum = oSnap[0];
	HSUM.value = Number(sum);
	
	var incr = Number(HINCR.value);
	var sum = Number(HSUM.value);
	HSUM_DOG.value = sum + sum*incr/100;
}

function getNextDogNum()
{
	var num = "1";
	var sFld = Convert("FDOG_NUM", "INT");
	var oSnap = getSnap("select max("+ sFld +") from ^CONTRACT c "
			+" inner join ^BILDOG d on d.FID_DOG=c.FWID", false);
	if(oSnap)
	{
		var sNum = String(oSnap[0]).replace("/КІ");
		num = Number(sNum)+1;
		num += "/КІ";
	}
	return num;
}

function num_valid()
{
	var sDogNum = HDOG_NUM.value;	
	HPERSNUM.value = getPersNum(sDogNum, oOrg.getCod());
}

//закрыть все доп. услуги по точке
function closeAllServ(oRow)
{
	var nvid = 1;
	var packID = oRow.getVar("RIDCL");
	
	var edat = new Date(oRow.getVar("REDAT"));
	if(differ(edat, new Date(d00))>=0)
		return;	
	/*
	var oSnap = getSnap("select max(FVID) from ^CL_SERV "
			+" where FWID_CL="+ packID, false);
	if(oSnap)
		nvid = Number(oSnap[0]);	
	if(nvid!=1)
		return;
	*/	
	var rowID = oRow.getID();
	var sID = oRow.getVar("RSID");	
	var rowTbl = OpenTable("select * from "+ sTmpTbl +" t "
					+" inner join ^CL_SERV s on t.FWID_CL=s.FWID_CL "
					+" where t.FSID="+ sqlTo(sID)
						+" and t.FEDAT="+ sqlD00
						+" and t.FWID<>"+ rowID
						+" and s.FVID=2");
	
	var sMsg = UR("Закрити усі додаткові послуги?|Закрыть все дополнительные услуги?");
	if(!rowTbl.isEmpty() && !confirm(sMsg))
		return;
	
	for(rowTbl.MoveFirst(); !rowTbl.isEOF(); rowTbl.MoveNext())
	{
		var rowID = Number(rowTbl.getValue("FWID"));
		oRow = objDoc.getRow(sRowClass, rowID);
		if(oRow)
		{
			oRow.setVar("REDAT", edat.getVarDate());
			obj2DB(oRow.getID(), oRow.jDocRow, null, sTmpTbl);
		}
	}	
}

function nextOrderNum()
{
	var orderNum = 1;
	var oSnap = getSnap("select max(FORDER_NUM) from ^BILDOG");
	if(oSnap && Number(oSnap[0]))
		orderNum = Number(oSnap[0])+1;
	HORDER_NUM.value = orderNum;
	return orderNum;
}

include("sys\\DpBaseDlg.js");