include("Objects/DpCntrct.js");
include("Objects/DpCl.js");
include("Objects/DpNmkl.js");
include("Objects/DpSc.js");
include("servis/date.js");
include("sub/bil.js");
include("sys/udfs.js");

var objDoc = extPar.doc;
var sRowTbl = "RBILL";
var sTmpTbl = getTmpTableName();
var sBillTbl = "TMP_BILL";
var sRClass = "ROW";
var ctrlLinker;
var oClient;
var oNmkl;
var gridTbl;
var oBDate;
var oEDate;
var priType;
var codPlat;
var vidDog;
var oCntr;
var eDatEdit = false;

function Load()
{	
	Caption(objDoc.getCaption() +": "+ modeName(extPar.mode));
	
	setPar("bill_to_cl_client", 1);	
	
	codPlat = objDoc.getPar("_codplat");
	codPack = objDoc.getPar("_codpack");
	vidDog  = objDoc.getPar("_viddog");
	priType = getPar("BILL_PRI");
	if(vidDog==1)
		priType = getPar("BILTEL_PRI");	
	if(!codPack && vidDog==0)
		codPack = getPar("BILL_PACK");
	else if(!codPack && vidDog==1)
		codPack = getPar("BILTEL_PACK");	
	if(!codPlat && vidDog==0)
		codPlat = getPar("BILL_CL");
	else if(!codPlat && vidDog==1)		
		codPlat = getPar("BILTEL_CL");

	HNOM.mask = "&&&&&&&&&";
	HSUM.mask = MASK_SUM;

	oClient = new DpCl("0", codPlat, 0);
	oClient.linkSmartCtrl(HCLIENT);
	oClient.setContAssist();	
	oClient.AfterUpdate = setOrg;
	
	oCntr = new DpCntrct("+");
	oCntr.linkCtrl(Fdog, Fdog_txt);
	
	oNmkl = new DpNmkl();
	oNmkl.linkCtrl(HNMKL, HNMKL_TXT);
	//oNmkl.setMode("t");	
	//oNmkl.setContAssist();
	oNmkl.CanEmpty = true;		
	
	oSc = new DpSc();	
	//oSc.linkCtrl(FSC, FSU, FST);	
	oSc.setMode("c0ut");
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",HNOM);	
	ctrlLinker.addLink("HDAT",HDAT);
	ctrlLinker.addLink("HEDAT",HEDAT);
	//ctrlLinker.addLink("HPAYDAT",HPAYDAT);
	ctrlLinker.addLink("HSUM",HSUM);
	//ctrlLinker.addLink("HSC",FSC);
 	//ctrlLinker.addLink("HSU",FSU);
 	//ctrlLinker.addLink("HST",FST);
		
	ctrlLinker.updateData(false);
		
	if(extPar.mode == "ADD")
	{
		oClient.setCod(objDoc.getVar("HCLIENT"));
	}
	
	if(extPar.mode == "EDIT" || extPar.mode == "COPY")
	{
		oClient.setCod(objDoc.getVar("HCLIENT"));
		oCntr.setOrg(objDoc.getVar("HCLIENT"));
		oCntr.setID(objDoc.getVar("HID_DOG"));
		oNmkl.setCod(objDoc.getVar("HNMKL"));
		oSc.set(objDoc.getVar("HSC"),
   				objDoc.getVar("HSU"),
   				objDoc.getVar("HST"));   		
	}
	if(extPar.mode == "EDIT")
	{
		eDatEdit = true;
	}
	
	setButton(btnCALC, form_bill);
	
	setValid(HEDAT, edat_valid);
	setValid(HDAT, dat_valid);
	dat_valid();
	
	//Disable(HPAYDAT);
	Disable(HSUM);
	initGrid();	
	
	recalc_sum();
	
	dlg = this;
}

function edat_valid()
{
	eDatEdit = true;
}

function dat_valid()
{
	var payDat = getPayDat(new Date(HDAT.value));
	//HPAYDAT.value = payDat.getVarDate();
	if(!eDatEdit)
		HEDAT.value = payDat.getVarDate();
}

function initGrid()
{  	
   	this.sDocSourceDir = rootDirectory() +"docs/"+ extPar.doc.sDocLbl +"/";
	
	if(!ExecuteSQL("drop table "+ sTmpTbl, false))
		ExecuteSQL("delete from "+ sTmpTbl, false);
	CreateTable(sTmpTbl, sRowTbl);
	ExecuteSQL("alter table "+ sTmpTbl +" add column FTT "+ SqlType("TEXT"));
	
	var sFLD = GetPatternIntersection(sRowTbl, sRowTbl);
	var sSQL = "INSERT INTO "+ sTmpTbl +"("+ sFLD +")"
			   +" SELECT "+ sFLD
			   +" FROM ^"+ sRowTbl
			   +" WHERE fid_doc = "+ extPar.doc.getID();
	ExecuteSQL(sSQL);
	grid.setXMLDir(this.sDocSourceDir);
	grid.setXMLFile("rowlist.xml");
	
	gridTbl = OpenTable("m","select * from "+ sTmpTbl 
			+" order by FCLIENT");
		
	clTie(gridTbl, "x_cl", "="+ sqlTo(codPlat) +", Fclient");
	gridTbl.tie("CL_HOMO", "homo", "Fwid_cl", "x_cl.FWID");
	gridTbl.tie("CL_NMK", "nmk", "FWID", "FNMKL");
	gridTbl.tie("CL_PACK", "pack", "FWID_CL", "FWID_CL");
	gridTbl.tie("CL_SERV", "serv", "FWID_CL", "FWID_CL");
	gridTbl.tie("CONTRACT", "dog", "FWID", "FID_DOG");
	
	grid.setTable(gridTbl);
	grid.build();
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid.loadMenuHandler(this,"gridMenuInit");
	grid.selectMenuHandler(this,"gridMenuRun");
}

function gridMenuInit()
{	
	var rowID = Number(grid.getTable().getRowID());
	grid.AddMenuItem("BILL", "Сформувати нарахування|Сформировать начисления");
	if(extPar.mode=="EDIT" && !grid.getTable().isEmpty())
		grid.AddMenuItem("CORECT", "Корегувати|Корректировать");
	grid.AddMenuItem("","");
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("FIND_SF", "Знайти рахунок-фактуру|Найти счета-фактуру", !findSF(rowID));
		grid.AddMenuItem("FIND_NK", "Знайти видаткову накладну|Найти расходную накладную", !findNK(rowID));
		grid.AddMenuItem("","");
	}
	grid.AddMenuItem("ADD", "Додавання | Добавление");
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT", "Редагування | Редактирование");
		grid.AddMenuItem("COPY", "Копіювання | Копирование");
		grid.AddMenuItem("DEL", "Видалення | Удаление");
	}
}

function gridMenuRun(sID)
{	
	var tbl = grid.getTable();
	var rowID = Number(tbl.getRowID());
	
	objDoc.setVar("HCLIENT", oClient.getCod());
	objDoc.setVar("HID_DOG", oCntr.getID());
	objDoc.setVar("HNMKL", oNmkl.getCod());
	objDoc.setVar("HDAT", new Date(HDAT.value).getVarDate());
	objDoc.setVar("HEDAT", new Date(HEDAT.value).getVarDate());
	//objDoc.setVar("HPAYDAT", new Date(HPAYDAT.value).getVarDate());
	objDoc.setVar("HSC", oSc.getSc());
	objDoc.setVar("HSU", oSc.getSu());
	objDoc.setVar("HST", oSc.getSt());
		
	switch(sID)
	{
	case "FIND_SF":
	case "FIND_NK":
		var _nopSF = extPar.doc.getPar("_nopsf");
		var fid_doc = extPar.doc.getID();
		var par = new Object();
		par.doc = "SF";
		par.nop = Number(_nopSF);
		if(sID == "FIND_NK")
		{
			par.doc = "NK";
			par.nop = Number(getPar("BILL_NK"));
			if(isCorNakl(fid_doc, "RBILL"))
				par.nop = Number(getPar("BILL_COR"));
		}
		par.bdat = d00min;
		par.FORG = tbl.getValue("FCLIENT");
		par.subWhere = " FWID in (select rel.FID_DOC "
							+" from ^RELBILL rel "
							+" where rel.FID_RBIL="+ rowID +")";
		showWindow("l_docekz.xml", SW_NOMODAL, par);		
		break;
	
	case "DEL":
		var bFindNK = findNK(rowID);
		var bFindSF = findSF(rowID);
		if(bFindNK || bFindSF)
		{
			var sMsg = UR("УВАГА!\nЗа даними нарахуваннями знайдені документи: "
							+(bFindNK? "\n	видаткові накладні" : "")
							+(bFindSF? "\n	рахунки-фактури" : "") 
							+"\nПотрібно спочатку вилучити ці документи."
							+"\nДля пошуку документів можна скористатися контекстним меню: "
							+ (bFindNK? "\n	\"Знайти видаткові накладні\"" : "") 
							+(bFindSF? "\n	\"Знайти рахунки-фактури\"" : "")
							+"\nВідкрити список знайдених документів?"
						+"|ВНИМАНИЕ!\nПо данным начислениям найдены документы:"
							+(bFindNK? "\n	расходные накладные" : "")
							+(bFindSF? "\n	счета-фактуры" : "") 
							+"\nНужно сначала удалить эти документы."
							+"\nДля поиска документов можно воспользоваться контекстным меню: "
							+(bFindNK? "\n	\"Найти расходные накладные\"" : "")
							+(bFindSF? "\n	\"Найти счета-фактуры\"" : "")						
							+"\nОткрыть список найденных документов?"
						);
			if(confirm(sMsg))
			{
				if(bFindNK)
					gridMenuRun("FIND_NK");
				if(bFindSF)
					gridMenuRun("FIND_SF");
			}
			return false;
		}
		else
		{
			if(!confirm(UR("Видалити запис?|Удалить запись?")))
				return false;
		}
		
		extPar.doc.deleteRow(sRClass, rowID);
		grid.getTable().Delete();
		grid.getTable().requery();
		grid.refresh();	
		break;
	
	case "ADD": case "EDIT": case "COPY":
		var oDocRow;
		if(sID == "ADD")
			oDocRow = extPar.doc.createRow(sRClass);
		else if(sID == "EDIT")
			oDocRow = extPar.doc.getRow(sRClass, rowID);
		else if(sID == "COPY")
			oDocRow = extPar.doc.copyRow(sRClass, rowID);			
		
		var par = new Object();
		par.tbl = gridTbl;
		var bOK = oDocRow.edit(sID, par)
		if (bOK)
		{
			if(inList(sID,"ADD","COPY"))
				extPar.doc.appendRow(sRClass, oDocRow)
				
			obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,sTmpTbl);
			grid.getTable().requery();
			grid.refresh();			
		}
		break;	
			
	case "BILL":				
		form_bill();		
		break;
	
	case "CORECT":
		var sWhere = grid.sqlSelected();		
		//var rowTbl = OpenTable("select * from "+ sTmpTbl +" where "+ sWhere);		
		correctBill(null, sWhere);
		//rowTbl.close();
		//CloseWindow();		
		//onEscape();
		dlg.exit();
		if(extPar.grid)
		{
			extPar.grid.getTable().requery();
			extPar.grid.refresh();
		}
		break;
		
	case "FIND":
		grid.runSelection(8);
		break;
	
	case "SELECT":
		grid.runSelection(2);	
		break;
	}
		
	recalc_sum();
	
	grid.setFocus();
	FORM.setActive();		
}

function form_bill()
{
	make_bill(sBillTbl
			,new Date(HDAT.value)
			,oCntr.getID()
			,oClient.getCod()
			,oNmkl.getCod()
			,"1,2"
			,vidDog);
	
	var tableR = OpenTable("m", "select * from "+ sBillTbl);
	loadRows(tableR);		
	tableR.close();
	
	grid.getTable().requery();
	grid.refresh();
}

function findSF(billID)
{		
	if(!billID)
		billID = list.tbl.getValue("FWID");
	var oSnap = getSnap("select FID_DOC from ^RELBILL"
					+" where FID_RBIL="+ billID
						+" and FDOC='SF'"
					, false);
	return oSnap!=null;
}

function findNK(billID)
{
	if(!billID)
		billID = list.tbl.getValue("FWID");
	var oSnap = getSnap("select FID_DOC from ^RELBILL"
					+" where FID_RBIL="+ billID
						+" and FDOC='NK'"
					, false);
	return oSnap!=null;
}

function loadRows(tableR)
{
	if(tableR.isEmpty())
	{
		WAIT(ru("Нет данных для отбора","Немає даних для відбору"));
		return;
	}	
	var nPr = 1;
	var maxPr = tableR.recordCount;
	var sPr = ru("Загрузка строк: ", "Завантаження рядків: ");	
	if(maxPr>10)
		setProgressRange(0, maxPr);
	setProgressText(sPr);

	for(tableR.MoveFirst(); !tableR.IsEOF(); tableR.MoveNext())
	{
		nPr++;
		if(nPr%10 == 1)
		{
			setProgressPos(nPr, sPr + (nPr-1) +"/"+ maxPr);			
		}			
		
		var begDate = new Date(oBDate); 
		var endDate = new Date(oEDate);
		
		//отбор периодов, частично входящих в период расчёта
		var tmpbeg = new Date(tableR.getValue("FDATE"));			
		var tmpend = new Date(tableR.getValue("FEDATE"));
		if(differ(tmpbeg,oBDate)>0)
			begDate = new Date(tmpbeg);			
		if(differ(tmpend,oEDate)<0)
			endDate = new Date(tmpend);
					
		var limit = tableR.getValue("FLIMIT");
		var vid = Number(tableR.getValue("FVID"));
		var sys = Number(tableR.getValue("FBILSYS")); 
		var payDat = new Date(HDAT.value);
		if(!isCorNakl(objDoc.getID(), sTmpTbl))
			payDat = billDate(payDat, vid, limit, sys==1);
		
		var cena = getBillCena(tableR, payDat);
		var nSum = getBillSum(tableR, payDat);	
		/*	
		var nSum = getSum(tableR);		
		var bDatPack = new Date(tableR.getValue("FDATE"));
		var eDatPack = new Date(tableR.getValue("FEDATE"));
		var cena = Number(tableR.getValue("fcena"));
		if(dayInPeriod(bDatPack, payDat) || dayInPeriod(eDatPack, payDat))
		{
			nSum = getSum(tableR, bDatPack, eDatPack);
			var kDay = getDayKoef(Number(tableR.getValue("fvid")), bDatPack, eDatPack); 
			if(kDay>0)
				cena = cena*kDay;
		}
		*/		
		trace("\nsum = "+ nSum +" > "+ StrDat(payDat, "DMY") +"\n")
		if(!nSum || nSum==0)
			continue;		
		
		//если дата завершения пакета меньше даты оказания берем дату из договора		
		if(differ(tmpend,payDat)<0)
			payDat = tmpend;
					
		var oDocRow = objDoc.createRow(sRClass);
		//oDocRow.setVar("RDAT", begDate.getVarDate());
		//oDocRow.setVar("REDAT", endDate.getVarDate());
		oDocRow.setVar("RPAYDAT", payDat.getVarDate());
		oDocRow.setVar("RNMKL", tableR.getValue("fnmkl"));
		oDocRow.setVar("RCLIENT", tableR.getValue("fclient"));
		oDocRow.setVar("RHANDSUM", false);
		oDocRow.setVar("RSUM", nSum);
		oDocRow.setVar("RPHONE", tableR.getValue("fphone"));	
		oDocRow.setVar("RCENA", cena);
		//oDocRow.setVar("RCENAOVER", Number(tableR.getValue("fcenaover")));
		oDocRow.setVar("RKOL", Number(tableR.getValue("fkol")));
		oDocRow.setVar("REKOL", Number(tableR.getValue("fekol")));
		oDocRow.setVar("RLIMIT", limit);
		oDocRow.setVar("RUSEKOL", Number(tableR.getValue("fusekol")));
		oDocRow.setVar("RVID", Number(tableR.getValue("fvid")));
		oDocRow.setVar("RINCR", Number(tableR.getValue("fincr")));
		oDocRow.setVar("RDOGID", Number(tableR.getValue("fid_dog")));
		oDocRow.setVar("RPACKID", Number(tableR.getValue("fwid_cl")));
		
		objDoc.appendRow(sRClass, oDocRow);
		obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
	}
	setProgressPos(0);
}

function recalc_sum()
{
	HSUM.value = 0;
	var oSum = getSnap("SELECT SUM(FSUM) AS sumd FROM "+ sTmpTbl);
	if(oSum)
		HSUM.value = oSum[0];
}	

function saveRows()
{
	var bRet = ExecuteSQL("DELETE FROM ^"+ sRowTbl +" WHERE fid_doc="+ sqlTo(extPar.doc.getID()));
	if(!bRet)
		return false;
	var sFLD = GetPatternIntersection(sRowTbl, sRowTbl);
	sFLD = sFLD.toUpperCase().replace(",FORDID", "");
	sFLD = sFLD.toUpperCase().replace("FORDID,", "");
	bRet = ExecuteSQL("INSERT INTO ^"+ sRowTbl +"("+ sFLD +")"
			  		+" SELECT "+ sFLD 
			  		+" FROM "+ sTmpTbl 
			  		+" WHERE fid_doc="+ sqlTo(extPar.doc.getID())
			  );
	return bRet;
}

function onSave()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HCLIENT", oClient.getCod());
	objDoc.setVar("HID_DOG", oCntr.getID());
	objDoc.setVar("HNMKL", oNmkl.getCod());
	
	var bRet = saveRows();		
	if(!bRet)
	{
		alert(UR("Не вдаэться зберегти рядки документу!\nМожливо документ редагується іншим користувачем."
				+"|Не удается сохранить строки документа!\nВозможно документ редактируется другим пользователем."));
		return false;
	}	
	exit();	
}

function onEscape()
{
	exit();
}

function exit()
{
	setPar("bill_to_cl_client", 0);	
	gridTbl.close();
	ExecuteSQL("drop table "+ sTmpTbl, false);
}

function setOrg()
{
	oCntr.setOrg(oClient.getCod());	
}

include("sys/DpBaseDlg.js");