include("Objects/DpCl.js");
include("servis/barCode.js");
include("servis/date.js");

var sRowTbl = "RBILL";
var sTmpTbl = "RBILLTMP";
var ctrlLinker;
var oClient;
var gridTbl;
var objDoc;
var prevCode = "";
var codPlat;
var codBank;
var vidDog;

function Load()
{
	objDoc = extPar.doc;
	
	Caption(objDoc.getCaption() + ": " + modeName(extPar.mode));
	
	codBank = getPar("bill_bnk");
	codPlat = objDoc.getPar("_codplat");
	vidDog  = objDoc.getPar("_viddog");	
	if(vidDog==1)
		codBank = getPar("BILTEL_BNK");		
	if(!codPlat && vidDog==0)
		codPlat = getPar("BILL_CL");
	else if(!codPlat && vidDog==1)		
		codPlat = getPar("BILTEL_CL");
	
	this.initGrid = _initGrid;
	this.initGrid();
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	
	HTN.mask = "&&&&&&&&&";
	HSUM.mask = MASK_SUM;
	HREM.mask = "&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&";
	//txtCode.mask = "";
	
	oClient = new DpCl();
	oClient.setMode("0");
	oClient.setClcl(codBank);
	oClient.linkCtrl(HCLIENT, HCLIENT_TXT);
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",HTN);	
	ctrlLinker.addLink("HDAT",HDAT);
	ctrlLinker.addLink("HSUM",HSUM);
	ctrlLinker.addLink("HREM",HREM);
	//ctrlLinker.addLink("",txtCode);
	
	ctrlLinker.updateData(false);
	
	if (extPar.mode != "ADD")
	{
		oClient.setCod(objDoc.getVar("HCLIENT"));
	}
	setValid(txtCode, readTxtCode);
		
	Disable(HSUM);
	
	recalc_sum();
}

function _initGrid()
{  	
   	this.sDocSourceDir = rootDirectory() +"docs/"+ extPar.doc.sDocLbl +"/";
	CreateTable(sTmpTbl, sRowTbl, "*");
	var sFLD = GetPatternIntersection(sRowTbl, sRowTbl);
	var nID = (extPar.mode=="COPY") ? objDoc.nOldID : objDoc.getID();
	var sSQL = "INSERT INTO "+ sTmpTbl +"("+ sFLD +")"
			   +" SELECT "+ sFLD
			   +" FROM ^"+ sRowTbl
			   +" WHERE fid_doc = "+ nID;
	ExecuteSQL(sSQL);
	grid.setXMLDir(this.sDocSourceDir);
	grid.setXMLFile("rowlist.xml");
	
	gridTbl = OpenTable("m","select * from "+ sTmpTbl +" order by fnom_str");
	//gridTbl.tie("CLRELCLCL", "clrel", "FWID_CL", "Fclient");
	//gridTbl.tie("CL", "x_cl", "FWID", "Fclient");
	clTie(gridTbl, "x_cl", "="+ codPlat +", Fclient");
	gridTbl.tie("CL_HOMO", "homo", "Fwid_cl", "x_cl.FWID");
	gridTbl.tie("CL_NMK", "nmk", "FWID", "FNMKL");
	if(extPar.mode=="COPY")
		objDoc.resetFnids(gridTbl, "ROW", objDoc);
		
	grid.setTable(gridTbl);
	grid.build();
	
	grid.loadMenuHandler(this,"gridMenuInit");
	grid.selectMenuHandler(this,"gridMenuRun");
}

function gridMenuInit()
{
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("COPY_TO_BAG","Копировать в карман");
		grid.AddMenuItem("CUT_TO_BAG","Вырезать в карман");
	}
	if (IsTable("rbillClipTmp"))
		grid.AddMenuItem("PASTE_FROM_BAG","Вставить из кармана");
	
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("SHOW_HISTORY", ru("Карточка клиента", "Картка кліента") );
		grid.AddMenuItem("","");	
	}
	grid.AddMenuItem("ADD","Додавання | Добавление");
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT","Редагування | Редактирование");
		grid.AddMenuItem("COPY","Копіювання | Копирование");
		grid.AddMenuItem("DEL","Видалення | Удаление");
	}
}

function gridMenuRun(sID)
{
	var sRClass = "ROW";
	var rowID = Number(grid.getTable().getRowID());
	objDoc.setVar("HDAT", HDAT.value);
	switch(sID)
	{
	case "DEL":
		extPar.doc.deleteRow(sRClass, rowID);
		grid.getTable().Delete();
		grid.getTable().requery();
		grid.refresh();	
		break;
	
	case "ADD": case "EDIT": case "COPY":
		var oDocRow;
		if(sID == "ADD")
			oDocRow = extPar.doc.createRow(sRClass);
		else if(sID == "EDIT")
			oDocRow = extPar.doc.getRow(sRClass, rowID);
		else if(sID == "COPY")
			oDocRow = extPar.doc.copyRow(sRClass, rowID);			
		
		var bOK = oDocRow.edit(sID)
		if (bOK)
		{
			if(inList(sID,"ADD","COPY"))
				extPar.doc.appendRow(sRClass, oDocRow)
				
			obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,sTmpTbl);
			grid.getTable().requery();
			grid.refresh();			
		}
		break;	
			
	case "COPY_TO_BAG":
		if(IsTable("rbillClipTmp"))
			DropTable("rbillClipTmp");
		CreateTable("rbillClipTmp","rbill","fwid");
		var fld = GetPatternIntersection("rbill", "rbill");
		ExecuteSQL("INSERT INTO rbillClipTmp ("+ fld +")"
			+" SELECT "+ fld +" FROM rbillTmp " 
			+" WHERE "+ grid.sqlSelected());
		break;
	
	case "CUT_TO_BAG":
		if(IsTable("rbillClipTmp"))
			DropTable("rbillClipTmp");
		CreateTable("rbillClipTmp","rbill","fwid");
		var fld = GetPatternIntersection("rbill", "rbill");
		ExecuteSQL("INSERT INTO rbillClipTmp ("+ fld +")"
			+" SELECT "+ fld +" FROM rbillTmp " 
			+" WHERE " + grid.sqlSelected());		
		ExecuteSQL("DELETE FROM rbillTmp WHERE "+ grid.sqlSelected());
		
		var bagTbl = OpenTable("m", "rbillClipTmp");
		for(; !bagTbl.isEOF(); bagTbl.MoveNext())
		{
			rowID = bagTbl.getValue("FWID");
			extPar.doc.deleteRow(sRClass, rowID);
			//grid.getTable().Delete(rowID);			
		}
		bagTbl.close();
		grid.getTable().requery();
		grid.RefreshGrid();
		break;
	
	case "PASTE_FROM_BAG":
		if (!IsTable("rbillClipTmp"))
		{
			WAIT(ru("Буфер обмена пустой", "Буфер обміну пустий"));
			return;
		}
		var zzz = OpenTable("s", "SELECT * FROM rbillClipTmp");
		for( ; !zzz.IsEOF(); zzz.MoveNext() )
		{
			var oDocRow = objDoc.createRow(sRClass);
			oDocRow.setVar("RDAT", zzz.getValue("FDATE"));
			oDocRow.setVar("RNOM", zzz.getValue("FNOM_STR"));
			oDocRow.setVar("RNMKL", zzz.getValue("FNMKL"));
			oDocRow.setVar("RCLIENT", zzz.getValue("FCLIENT"));
			oDocRow.setVar("REDATE", zzz.getValue("FEDATE"));
			oDocRow.setVar("RHANDSUM", zzz.getValue("FHANDSUM"));
			oDocRow.setVar("RSUM", zzz.getValue("FSUM"));
			oDocRow.setVar("RTYPE", zzz.getValue("FRTYPE"));
			oDocRow.setVar("RREM", zzz.getValue("FREM"));
			
			objDoc.appendRow(sRClass, oDocRow);	
			obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
		}
		zzz.close();
		/*
		ExecuteSQL("INSERT INTO ^rbillTmp "
			+ " SELECT fnmkl, fclient, fdate, fedate, fhandsum "
			+ ", fsum, frtype, frem, fdoc, fid_doc, fm1act "
			+ ", fm1comp, fm1date, fm1user, fmact, fmcomp, fmdate "
			+ ", fmuser, fnom_str, foutid, fwid"
			+ " FROM rbillClipTmp " );//все, кроме fordid
		*/
		grid.getTable().requery();
		grid.RefreshGrid();
		break;
	
	case "SHOW_HISTORY":
		oPar = new Object();
		oPar.fclient = grid.getTable().getValue("FCLIENT");
		showWindow("bill_history.xml", SW_MODAL, oPar);
		break;
	}
	recalc_sum();		
}

function recalc_sum()
{
	HSUM.value = 0;
	var oSum = getSnap("SELECT SUM(FSUM) AS sumd FROM "+ sTmpTbl);
	if(oSum)
		HSUM.value = oSum[0];
}	

function saveRows()
{
	ExecuteSQL("DELETE FROM ^"+ sRowTbl +" WHERE fid_doc="+ sqlTo(extPar.doc.getVar("ID")));
	var sFLD = GetPatternIntersection(sRowTbl, sRowTbl);
	sFLD = sFLD.toUpperCase().replace(",FORDID", "");
	sFLD = sFLD.toUpperCase().replace("FORDID,", "");
	ExecuteSQL("INSERT INTO ^"+ sRowTbl +"("+ sFLD +")"
			  + " SELECT "+ sFLD +" FROM "+ sTmpTbl);
}

function onSave()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HCLIENT", oClient.getCod());
	
	saveRows();
	
	gridTbl.close();
}

function onEscape()
{
	gridTbl.close();
}

function readTxtCode()
{
	/*
	   010000002000915503
	   | |		|		|	
	   | |		|		--------- контрольный разряд((сумма цифр)%10)	
	   | |		------------------ сумма оплаты 	
	   | ------------------------- клиент
	   -------------------------- версия
	*/
	var lenVer = 2;
	var lenClient = 7;
	var lenSum = 8;
	var lenCheckSum = 1;
	var nCurVersion = 01;
	if(!txtCode.value || txtCode.value == "")
	{
		//setFocus(txtCode);
		return true;
	}
	if(txtCode.value == prevCode)
	{
		var sMsg = ru("Вы повторно считываете запись\nПродолжить?"
					, "Ви повторно зчитуєте запис\nПродовжити?");
		if(!confirm(sMsg))
		{
			prevCode = txtCode.value;
			txtCode.value = "";
			setFocus(txtCode);
			return false;
		}
	}
	
	var strCode = new String(txtCode.value);
	if(isNaN(strCode))
	{
		var sMsg = ru("Ошибка:\r\n"
				+"В строке штрих-кода должны быть "
				+" только числа\r\n"
				+"Повторите считывание"
			,"Помилка:\r\n"
				+"В рядку штрих-кода повинні бути "
				+" лише числа\r\n"
				+"Повторіть зчитування");
		alert(sMsg);
		txtCode.value = "";
		setFocus(txtCode);
		return false;
	}
	
	var nCodeLength = lenVer + lenClient + lenSum + lenCheckSum;
	if(strCode.length != nCodeLength)
	{		
		var sMsg = ru("Ошибка:\r\n"
				+"В строке штрих-кода должно быть "
				+ nCodeLength
				+" символов\r\n"
				+"Повторите считывание"
			,"Помилка:\r\n"
				+"В рядку штрих-кода повинно бути "
				+ nCodeLength
				+" символів\r\n"
				+"Повторіть зчитування");
		alert(sMsg);		
		txtCode.value = "";
		setFocus(txtCode);
		return false;
	}
	
	var nVersion = strCode.substr(0, lenVer);
	if(parseInt(nVersion) != nCurVersion)
	{
		var sMsg = ru("Ошибка:\r\n"
				+"Неправильная версия\r\n"
				+"Повторите считывание"
			,"Помилка:\r\n"
				+"Невірна версія\r\n"
				+"Повторіть зчитування");
		alert(sMsg);
		txtCode.value = "";
		setFocus(txtCode);
		return false;
	}
	
	var nClient = strCode.substr(lenVer, lenClient);
	bFound = false;
	var oCl = getSnap("SELECT FWID_CL FROM ^clrelclcl "
				+" WHERE fcl="+ codPlat
					+" and FCOD="+ nClient);
	if(!oCl)
	{
		var sMsg = ru("Ошибка:\r\n"
				+"Не найден клиент\r\n"
				+"Повторите считывание"
			,"Помилка:\r\n"
				+"Не знайдено клиєнта\r\n"
				+"Повторіть зчитування");
		alert(sMsg);
		txtCode.value = "";
		setFocus(txtCode);
		return false;
	}
	
	var nSum = strCode.substr(lenVer + lenClient, lenSum);
	var nCheckSum = strCode.substr(lenVer + lenClient + lenSum, lenCheckSum);
	var nCheckSumCalc = 0;
	var strNumber = strCode.substr(0, lenVer + lenClient + lenSum);
	nCheckSumCalc = sumOfDigitsMod10(strNumber);
	
	if(nCheckSum != nCheckSumCalc)
	{
		var sMsg = ru("Неправильная контрольная сумма\r\n"
				+"Повторите считывание"
			,"Невірна контрольна сума\r\n"
				+"Повторіть зчитування");
		alert(sMsg);
		txtCode.value = "";
		setFocus(txtCode);
		return false;
	}
	/*
	tableR.AddNew();
	tableR("Fwid") = GetUID();
	tableR("FCLIENT") = nClient;
	tableR("FSUM") = Number(nSum)/100;
	window._retArray["FWID"]=tableR("fwid");
	tableR.Update();
	tableR.Requery();
	*/
	var sRClass = "ROW";
	var oDocRow = objDoc.createRow(sRClass);
	oDocRow.setVar("RCLIENT", oCl[0]);
	oDocRow.setVar("RSUM", Number(nSum)/100);	
	objDoc.appendRow(sRClass, oDocRow);	
	obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);	
	grid.getTable().requery();
	grid.refresh();
	//RestoreMarker(tableR);
	
	prevCode = txtCode.value;
	txtCode.value = "";
	recalc_sum();	
	
	setFocus(txtCode);
	
	return false;
}

function getDebt(clnt, nmkl, bdat, edat)
{
	var sumPay = 0;
	var sumDebt = 0;	
	var sWhere = " and FCLIENT="+ sqlTo(clnt)
				+(nmkl? " and FNMKL="+ sqlTo(nmkl) : "")
				+(bdat? " and FDATE>="+ sqlTo(bdat) : "")
				+(edat? " and FDATE<="+ sqlTo(edat) : "");
	var oSnap = getSnap("select FSUM from ^RBILL "
				+" where FDOC='BILL' "
					+ sWhere, false);
	if(oSnap)
		sumDebt = Number(oSnap[0]);
	
	oSnap = getSnap("select FSUM from ^RBILL "
				+" where FDOC='BILPAY' "
					+ sWhere, false);
	if(oSnap)
		sumPay = Number(oSnap[0]);
	
	sumDebt -= sumPay;
	return sumDebt;
}

include("sys/DpBaseDlg.js");