include("Objects/DpCl.js");
include("sys/mask.js");

var obj = extPar.obj;
var ctrlLinker, oSc;
var mode = extPar.mode;
var ndsproc = extPar.ndsproc;

function Load()
{	
	Caption(ru("Строки документа","Рядки документу"), mode);
	
	RSUM.setMask(MASK_SUM);
	RSUM_PDV.setMask(MASK_SUM);
	RNOM.setMask("#####");	
	
	ctrlLinker = new DpCtrlLinker(obj);
	ctrlLinker.addLink("RNOM", RNOM);
	ctrlLinker.addLink("RSUM", RSUM);
	ctrlLinker.addLink("RSUM_PDV", RSUM_PDV);
	ctrlLinker.addLink("RISHAND_PDV", RISHAND_PDV);		
	
	if(inList(mode, "ADD"))
	{
		//RNOM.setValue(getNextNumber());
	}

	//счет
	if(!extPar.isUseSc)
	{
		LBL_RGROUP_SC.setVisible(false);
		RGROUP_SC.setVisible(false);
	}
	else
	{
		oSc = new DpSc("c0utxyz");
		oSc.linkCtrl(RSC, RSU, RST, RCL1, RCL2, RCL3);
		ctrlLinker.addScLink("RSC", "RSU","RST","RCL1","RCL2","RCL3", oSc);
	}
	
	//кекв
	if(!extPar.isUseKekv)
	{
		LBL_RKEKV.setVisible(false);
		RKEKV_GR.setVisible(false);
	}
	else
	{
		oKekv = new DpCl();
		oKekv.setClcl(extPar.clKekv);
		oKekv.linkSmartCtrl(RKEKV);
		oKekv.setContAssist();
		ctrlLinker.addClLink("RKEKV", oKekv);
	}
	
	//примечание
	if(!extPar.isUseRem)
	{
		LBL_RREM.setVisible(false);
		RREM_GR.setVisible(false);
	}
	else
	{
		ctrlLinker.addLink("RREM",RREM);
	}
	
	ctrlLinker.updateData(false);
	
	//Перерисуем окно
	var pnt = FORM.getControlComposite();	
	pnt.pack();
	pnt.redraw();
	pnt.layout(true);
	
	Disable(RNOM);
	setValid(RSUM, RSUM_Valid);	
	setValid(RISHAND_PDV, calcSumPDV);	
	
	calcSumPDV();
}

function RSUM_Valid()
{
	retVal = true;
	if (Number(RSUM.getValue()) == 0)
	{
		RSUM.showErr(ru("Нулевая сумма недопустима!","Нульова сума неприпустима!"));
		retVal = false;
	}
	
	calcSumPDV();
	return retVal;
}

function calcSumPDV()
{
	//расчет суммы ндс
	var isHandPDV = toScrObj(RISHAND_PDV.checked);
	var rsum = toScrObj(RSUM.getValue());
	
	
	if(isHandPDV)
	{
		Enable(RSUM_PDV);
	}
	else
	{
		RSUM_PDV.setValue(round(rsum*ndsproc/(100+ndsproc), 2));
		Disable(RSUM_PDV);
	}
	
	return true;	
}

function onSave()
{
	ctrlLinker.toVars();
}

include("sys\\DpBaseDlg.js");