include("objects/DpAskEx.js");

var grid;
var oA;
var tmpTblRow = getTmpTableName("", true);
var tblName = "RRAS_SCH";

//параметры папки
var isUseSc, isUseKekv, isUseRem, ndsproc;

var clKekv = toScrObj(getPar("CODKEKV"));
var classRowID = "KEKV";
var aRowExts;

function loadKekv()
{	
	if (!isUseRow())
	{
		return;
	}
	
	//читаем параметры папки
	isUseSc = toScrObj(objDoc.getPar("__userowsch"));
	isUseKekv = toScrObj(objDoc.getPar("__userowkekv")) && !isEmpty(clKekv);
	isUseRem = toScrObj(objDoc.getPar("__userowrem"));
	ndsproc = toScrObj(objDoc.getPar("__ndsproc"));
	
	//создадим темповую таблицу строк
	CreateTable(tmpTblRow, tblName, "*");
	var sFld = GetPatternIntersection(tblName, tblName);
	
	var nId = (extPar.mode == "COPY") ? objDoc.nOldID : objDoc.getID();
	
	strSQL = "INSERT INTO "+tmpTblRow+"("+sFld+")"
				+" SELECT "+sFld
				+" FROM ^"+tblName
				+" WHERE 1=1"
					+" AND FID_DOC = "+sqlTo(nId)
	ExecuteSQL(strSQL);	
	
	var ctrl = FORM.addTab(ru("Строки документа", "Рядки документу"));
	grid = FORM.getDialogBuilder().addGrid(ctrl, "BNKDC_ROW");	
	var tblGrig = OpenTable(tmpTblRow);

	var oRow = objDoc.createRow(classRowID);
	aRowExts = oRow.getExtInfo();
	var extTblName = getRowExtTableName(oRow);
	oRow = null;

	tblGrig.tie(extTblName, "XROW", "FMAINWID", "FWID")
	
	//при копировании документа нужно перебить FWID строк и FID_DOC
	if(extPar.mode == "COPY" && !tblGrig.IsEmpty())
	{
		for(; !tblGrig.IsEOF(); tblGrig.MoveNext())
		{
			var m = {};
			m.FWID = GetUID();
			m.FID_DOC = objDoc.getID();
			UpdateTable(tmpTblRow, m, false, "FWID = "+sqlTo(toScrObj(tblGrig.getValue("FWID"))));
		}
		tblGrig.MoveFirst();
	}
	grid.setTable(tblGrig);
	grid.loadMenuHandler(this, "menuInit");
	grid.selectMenuHandler(this, "menuHandler");
	
	with (grid)
	{
		FieldEx("FNOM_STR", "№", 5);
		FieldEx("FSUM", "Сума|Сумма", 14, "r", DP_FORMAT_SUM);
		FieldEx("FSUM_PDV", "Сума ПДВ|Сумма НДС", 12, "r", DP_FORMAT_SUM);
		FieldEx("FISHAND_PDV", "Ручн. введ. ПДВ|Ручн. ввод НДС", 12);
		if(isUseSc)
		{
			FieldEx("FSC", "Рахунок|Счет", 6);
			FieldEx("FSU", "Субрах.|Субсчет", 8);
			FieldEx("FST", "Ст.", 6);
			FieldEx("FCL1", "Ан.1", 7);
			FieldEx("FCL2", "Ан.2", 7);
			FieldEx("FCL3", "Ан.3", 7);
		}
		if(isUseKekv)
		{
			FieldEx("FKEKV", "КЕКВ", 6);
			FieldEx("=getTxtKekv(^FKEKV)", "Назва|Название", 20);
		}
		if(isUseRem)
		{
			FieldEx("FREM", "Зміст операції|Содержание операции", 30);
		}

		// Net  примостим расширения
		for (var i in aRowExts)
		{
			if (String(aRowExts[i].type.toUpperCase())[0] == "A")
			{
				var ccl = aRowExts[i].type.substr(1);
				FieldEx("=^XROW.F"+aRowExts[i].E_Label+"+': '+tcl('CL', 'TXT', "+ccl+", ^XROW.F"+aRowExts[i].E_Label+")", aRowExts[i].E_FieldText, 8);
			}
			else
			{
				FieldEx("XROW.F"+aRowExts[i].E_Label, aRowExts[i].E_FieldText, 8);
			}
		}
		
		
		FieldEx("", "Зміст операції|Содержание операции", 30);
		
		build();
	}
}

function getTxtKekv(cod)
{
	return tcl("CL", "", clKekv, cod);
}

function menuInit()
{
	grid.AddMenuItem("ADD", "Додати|Добавить");
	if(!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT", "Редагувати|Редактировать");
		grid.AddMenuItem("COPY", "Копіювати|Копировать");
		grid.AddMenuItem("DEL","Вилучити|Удалить");
	}
}

function menuHandler(ID)
{
	var tbl = grid.getTable();
	var tblName = grid.getTable().getTableName();
	var thisID = Number(tbl.getRowID());
	
	var par = {};
	par.obj = objDoc;
	par.mode = ID;
	par.isUseSc = isUseSc;
	par.isUseKekv = isUseKekv;
	par.isUseRem = isUseRem;
	par.clKekv = clKekv;
	par.ndsproc = ndsproc;
	
	switch (ID)
	{
		case "DEL":
			var msg = ru("Подтвердите удаление записи.", "Підтвердіть вилучення запису.");
			var ret = msgBox("^c-", msg, ru("Подтверждение удаления","Підтвердження вилучення"));
			switch(ret)
			{
				case 'c':
					break;
				case '-':
					objDoc.deleteRow(classRowID, thisID);
					tbl.Delete();
				break;
			}
		break;
		case "__XDEL":
			var delRowCount = DataSource().getSelectedCount();
			
			if (delRowCount <= 0)
			{
				return;
			}
			var selIds = DataSource().getSelectedIDs();
			
			var sCapt = ru("Удаление записей", "Вилучення записів");
			var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів")+" (" + DataSource().getSelectedCount() + ").";
			if("c"==msgBox("c-", sMsg, sCapt))
			{
				return;
			}

			setProgressRange(0, delRowCount);
			for (var nRow = 0; nRow < selIds.length; nRow++)
			{
				setProgressPos(nRow + 1, sCapt +": "+ (nRow + 1) +"/"+ delRowCount);
				objDoc.deleteRow("ROW", Number(selIds[nRow]));
			}
			var sSQL = "DELETE FROM " + tblName
						+ " WHERE " + grid.sqlSelected()
			ExecuteSQL(sSQL);

			grid.clearSelected();
			setProgressPos(0);
		break;
		case "ADD":
			oDocRow = objDoc.createRow(classRowID);
			oDocRow.setVar("RNOM", getNextNumber(tmpTblRow, "FNOM_STR"));
		break;
		case "EDIT":
			oDocRow = objDoc.getRow(classRowID, thisID);
		break;
		case "COPY":
			oDocRow = objDoc.copyRow(classRowID, thisID);
			oDocRow.setVar("RNOM", getNextNumber(tmpTblRow, "FNOM_STR"));
		break;
	}
	
	if(typeof oDocRow !="undefined")
	{
		oDocRow.setAbsFormFile("docs/"+"BNKDC"+"/"+classRowID+"/form.xml");
	}
	
	if(inList(ID, "ADD", "EDIT", "COPY"))
	{
		if (oDocRow.edit(ID, par))
		{
			if(inList(ID,"ADD","COPY"))
				objDoc.appendRow(classRowID,oDocRow);

			obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,tmpTblRow);
		}
	}	
	
	grid.getTable().requery();
	grid.refresh();
}

function saveRows()
{
	var retSum = 0;
	if (!isUseRow())
	{
		return retSum;
	}
	
	var sFld = GetPatternIntersection(tblName, tblName);
	ExecuteSQL("DELETE FROM ^"+tblName+" WHERE FID_DOC = "+sqlTo(objDoc.getID()));
	
	strSQL = "INSERT INTO ^"+tblName+"("+sFld+")"
			+ " SELECT "+sFld
			+ " FROM "+tmpTblRow			
	ExecuteSQL(strSQL);
	
	var oSnap = getSnap("SELECT SUM(FSUM) FROM "+tmpTblRow);
	if (oSnap && !isEmpty(oSnap[0]))
	{
		retSum = toScrObj(oSnap[0]);
	}
	
	return retSum;
}

//создавать ли грид со строками
function isUseRow()
{
	return extPar.doc.getPar("__userowbnkdc");
}

function getRowExtTableName(oRow)
{
	var oper = objDoc.getVar("HOP");
	if (oper && oper != 0)
	{
		sOper = String(oper);
	}
	include("objects\\DpExtentionBuilder.js");
	var extBuilder = new DpExtentionBuilder("R", oRow.jDoc.getFullClassID(), sOper);
	var retVal = extBuilder.getValueTableName();
	extBuilder = null;
	return retVal;
}