include ("Objects\\DpVal.js");
include ("Objects\\DpCl.js");
include("Objects\\DpCtrlLinker.js");
include("doc\\DpDoc.js");
include("Objects\\DpPostRs.js");

var objDoc = extPar.doc; 
var ctrlLinker = null;
var edmode = extPar.mode;
var Validation = true;
var oVal;
var oOrg;
var oSch;
var param;
var ndsproc;

function Load()
{
	Caption(objDoc.getCaption() + ": " + modeName(extPar.mode));
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	param = CreateDocPar(objDoc.sDocLbl, objDoc.nNop);
	ndsproc = Number(getPar("NDSPROC"));
	if(ndsproc)
	{
		Disable(HNDS_DB);
		Disable(HNDS_CR);
	}
	
   	HOWNRSC.mask = MASK_RS;
   	HOWNMFO.mask = MASK_MFO;
   	HOWNRSC.value = getPar("CUR_RSC");
    HOWNMFO.value = getPar("CUR_RSC_MFO");
    
   	HSUM_DB.mask = MASK_SUM;
   	HSUM_CR.mask = MASK_SUM;
   	HNDS_DB.mask = MASK_SUM;
   	HNDS_CR.mask = MASK_SUM;
   	HSUM_DBCALC.mask = MASK_SUM;
   	HSUM_CRCALC.mask = MASK_SUM;
   	HNDS_DBCALC.mask = MASK_SUM;
   	HNDS_CRCALC.mask = MASK_SUM;
   	
   	oVal = new DpVal();
   	oVal.linkCtrl(HVAL);
 	
	ctrlLinker.addLink("HNOM",HNOM);
   	ctrlLinker.addLink("HDAT",HDAT);
   	ctrlLinker.addLink("HVAL",HVAL); 
 	ctrlLinker.addLink("HTOVAR",HTOVAR);
 	ctrlLinker.addLink("HSUM_DB",HSUM_DB);
 	ctrlLinker.addLink("HSUM_CR",HSUM_CR);
 	ctrlLinker.addLink("HNDS_DB",HNDS_DB);
 	ctrlLinker.addLink("HNDS_CR",HNDS_CR);
 	ctrlLinker.addLink("HSUM_DBCALC",HSUM_DBCALC);
 	ctrlLinker.addLink("HSUM_CRCALC",HSUM_CRCALC);
 	ctrlLinker.addLink("HNDS_DBCALC",HNDS_DBCALC);
 	ctrlLinker.addLink("HNDS_CRCALC",HNDS_CRCALC);
 	ctrlLinker.addLink("HOWNMFO",HOWNMFO);
 	ctrlLinker.addLink("HOWNRSC",HOWNRSC);

 	ctrlLinker.updateData(false);
 	
 	oOrg = new DpCl("");
	oOrg.setClcl(getPar("CODMYORG"));
	oOrg.setCod(getPar("ORGNOM"));
	
	oSch = new DpPostRs();
	oSch.setDpCl(oOrg, true);
	oSch.linkCtrl(HOWNRSC, HOWNMFO);
 	
 	if (extPar.mode != "ADD")
	{  	
		HSUM_DB.value = objDoc.getVar("HSUM_DB");
		HSUM_CR.value = objDoc.getVar("HSUM_CR");
		HNDS_DB.value = objDoc.getVar("HNDS_DB");
		HNDS_CR.value = objDoc.getVar("HNDS_CR");
		if(extPar.mode == "EDIT")
		{
			var snap = getSnap("select Fsum_dbcalc, Fsum_crcalc, Fnds_dbcalc, Fnds_crcalc from ^listbvo where Fwid="+objDoc.getVar("HID"))
			if(snap)
			{
				HSUM_DBCALC.value = snap[0];
				HSUM_CRCALC.value = snap[1];
				HNDS_DBCALC.value = snap[2];
				HNDS_CRCALC.value = snap[3];
			}
		}
		
		HOWNRSC.value = objDoc.getVar("HOWNRSC");
        oVal.setCod(objDoc.getVar("HVAL"));
	}
	else
	{
		var rsc = objDoc.getPar("__rscnom");
		if(!rsc || rsc==0)
			rsc = getPar("ORSC");
		
		var  fwid_cl = 0;
		var oSnap = getSnap("select fwid_cl from ^clrelclcl where fcl = 0 and fcod = " + CURRENT_ORG)
		if (oSnap && oSnap[0])
		{
			fwid_cl = oSnap[0];
			var gs = getSnap("select Fwid from ^CL_ORGRS where FWID_CL="+sqlTo(fwid_cl)+" and Fras_sch="+sqlTo(rsc));
			if(gs && gs[0])
				oSch.setCod(gs[0]);
		}
		//HOWNRSC.value = String(rsc);
		oSch.validCtrl();
		oVal.setCod(0);
		Disable(HSUM_DB);
		Disable(HSUM_CR);
		Disable(HNDS_DB);
		Disable(HNDS_CR);
	}		
   	
   	if(extPar.mode != "ADD" && extPar.mode != "COPY")
   	{
		FNDSDB_onblur();
		FNDSCR_onblur();
   	}
	setValid(HSUM_DB, FNDSDB_onblur);
	setValid(HSUM_CR, FNDSCR_onblur);
	setValid(HDAT, mHDAT_Valid);
}

function onSave()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HVAL",oVal.getCod());
	objDoc.setVar("HNOP",extPar.nop);
}

function mHDAT_Valid() 
{
   return differ(HDAT.value, d00);
}

function FNDSDB_onblur()
{
	if(ndsproc)
		HNDS_DB.value = round(Number(HSUM_DB.value)*ndsproc/(100+ndsproc),2);
	return true;
}

function FNDSCR_onblur()
{
	if(ndsproc)
		HNDS_CR.value = round(Number(HSUM_CR.value)*ndsproc/(100+ndsproc),2);
	return true;
}

include("sys\\DpBaseDlg.js");