include("Objects\\DpCl.js");
include("sys\\mask.js");
include("Objects\\DpSc.js");
include("Objects\\DpCtrlLinker.js");
include("sys\\kursval.js");
include("Objects/DpDocEx.js");
include("Objects/DpClEx.js");

var edmode, t;
var oOrg;
var objDoc = extPar.doc; 
var ctrlLinker = null;
var oCntr;
var objParDocEx;

var codPlat;
var codPers;

function Load() 
{
	if(!objDoc && typeof extPar != "undefined")
		objDoc = new DpDoc(extPar.Fdoc, extPar.Fnop);
	 
  	Caption(objDoc.getCaption() + ": " + modeName(extPar.mode));
  	
  	HTARIF.mask = MASK_SUM;
  	HSUM.mask = MASK_SUM;
  	HTIME.mask = "#######";
   
   	ctrlLinker = new DpCtrlLinker(objDoc);
   	
   	objParDocEx = new DpDocEx(extPar.doc.sDocLbl, extPar.doc.nNop);
	objParDocEx.linkCtrl(GRPNUM);
   	
   	codPlat = getPar("CODPLAT");
   	oOrg = new DpCl();   	
	oOrg.setClcl(codPlat);
   	oOrg.linkSmartCtrl(HORG);
   	oOrg.setContAssist();
   	oOrg.AfterLoad = loadContPers;
   	setValid(HORG, loadContPers);
   	
   	codPers = getPar("CODPERS");
   	oMgr = new DpCl();
   	oMgr.setClcl(codPers);
   	oMgr.linkSmartCtrl(HMANAGER);
   	oMgr.setContAssist();
		
   	ctrlLinker.addLink("HNOM",HNOM);
 	ctrlLinker.addLink("HDAT",HDAT); 
 	ctrlLinker.addClLink("HORG",oOrg); 	
 	ctrlLinker.addLink("HBDAT",HBDAT);      
 	ctrlLinker.addLink("HEDAT",HEDAT); 
 	ctrlLinker.addLink("HADDTIME",HADDTIME);      
 	ctrlLinker.addLink("HCTLDAT",HCTLDAT);
 	ctrlLinker.addLink("HPREDMET_RAZG",HPREDMET_RAZG);
 	ctrlLinker.addClLink("HMANAGER",oMgr);
 	ctrlLinker.addLink("HSUM",HSUM);
 	ctrlLinker.addLink("HTARIF",HTARIF);
 	ctrlLinker.addLink("HRESULT",HRESULT);
 	ctrlLinker.addLink("HTIME",HTIME);
 	ctrlLinker.addLink("HREMIND",HREMIND);
 	ctrlLinker.addLink("HTYPE",HTYPE);

   	ctrlLinker.updateData(false);
	
	
   	if (extPar.mode == "ADD")
   	{
   		HBDAT.setDateValue(new Date()); 
		HEDAT.setDateValue(new Date());
		HADDTIME.setTime(0);
		HCTLTIME.setTime(0);
		HTARIF.value = 2.5;
		//HCTLDAT.value = d00;
		
		if(extPar && extPar.nOrg)
			oOrg.setCod(Number(extPar.nOrg));
		if(extPar && extPar.nMgr)
			oMgr.setCod(Number(extPar.nMgr));
			
		if(oMgr.getCod()==0)
			oMgr.setCod(getPersCod(getUserName()));
			
		HTYPE.value = Number(objDoc.getPar("_type"));		
   	}
   	else
   	{
		objParDocEx.setFwid(objDoc.getVar("HGRPID"));
   		oOrg.setCod(objDoc.getVar("HORG"));
   		oMgr.setCod(objDoc.getVar("HMANAGER"));
  		
   		HCTLTIME.value = objDoc.getVar("HCTLDAT");
   		
   		sum_valid();
   	}
   	loadContPers();
   	if (extPar.mode != "ADD")
   		FCONTPERS.setValue(objDoc.getVar("HCONT"));
   	setValid(FCONTPERS, contPersValid);
   	
   	if(extPar.mode=="EDIT")
		loadResponse();
   	FRESPONSE.getCtrl().setEditable(false);	
	setButton(BTN_ADD_RESPONSE, add_response);
	
   	setValid(HDAT, mHDAT_Valid); 
   	setValid(HBDAT,calcTime);
	setValid(HEDAT,calcTime);
	setValid(HADDTIME,calcTime);
	setValid(HTARIF,sum_valid);
	setValid(HTIME,sum_valid);
	
	Disable(HTIME);
	
}
var escape;


function onSave()
{	
	var ctlDate = getVarTime(HCTLDAT.value, HCTLTIME.value);	
	/*
	if(extPar.mode == "ADD" || extPar.mode == "COPY")
	{
		var d0 = new Date(d00).getVarDate();
		var bdat = new Date(HBDAT.value);
		var edat = new Date(HEDAT.value);
		if(differ(bdat, edat)==0 || differ(d0, edat)==0)
		{
			HEDAT.setDateValue(new Date());
			time();
		}
	}
	*/
	ctrlLinker.updateData(true);
	objDoc.setVar("HCONT", FCONTPERS.value);
	objDoc.setVar("HCTLDAT", ctlDate.getVarDate());
	objDoc.setVar("HGRPID", objParDocEx.fwid);
}

function getPersCod(userName)
{
	var oSnap = getSnap("select rel.FCOD "
							+" from ^CL_PERS p "
							+" inner join ^CLRELCLCL rel on rel.FWID_CL=p.FWID_CL "
							+" where p.FLOGIN="+ sqlTo(userName)
						, false
						);
	if(oSnap)
		return oSnap[0];
	return 0;
}

function contPersValid(persCombo)
{
	var ID = persCombo.value;
	if(String(ID)=="ADDNEW")
	{
		var contID = createNewContact(oOrg.getFWID(), persCombo);
		if(contID)
			persCombo.setValue(String(contID));
		else
			persCombo.setValue("0");
	}
}

function createNewContact(orgID, persCombo)
{
	var orgCL = new DpClEx("CL2", 0);
	if(!orgCL.loadByID(orgID))
		return 0;
	var oRow = orgCL.createRow("OCP");
	var formFile = "cls/"+ orgCL.sClassId +"/ORGCP/form.xml";
	var par = new Object();
	par.dpObj = oRow;
	par.mode = "ADD";
	par.dpObj.hasExt = new Function("return false;");
	par.objCl = orgCL;
	showWindow(formFile, "XMLDLG", par);
	if(par.escape)
		return 0;
	var contID = oRow.getID();
	orgCL.appendRow("OCP", oRow);
	obj2DB(contID, oRow.jObj, null, "^CL_ORGCP");
	
	var txt = oRow.getVar("HFIO");
	var phone = String(oRow.getVar("HPHONE")).trim();
	if(phone!="")
		txt += " ("+ phone +")";
	persCombo.addItem(String(contID), txt);
	persCombo.remove(persCombo.getSelectedIndex());
	persCombo.addItem("ADDNEW", UR("< Додати >|< Добавить >"));
	return contID;
}

function getVarTime(oDat, oTime)
{
	var date = new Date();	
	if(!oDat || !oTime)
		return new date;
	
	date = new Date(oDat);	
	date.setHours(0);
	date.setMinutes(0);
	
	var hours = oTime.getHours();
	var minutes = oTime.getMinutes();
	if(hours)
		date.setHours(hours);
	if(minutes)
		date.setMinutes(minutes);
	return date;
}

function loadContPers()
{
	var curCont = String(FCONTPERS.getValue());
	FCONTPERS.clear();
	var nID = oOrg.getFWID();
	if(!nID)
		return;
	FCONTPERS.addItem("0", "");
	var tPers = OpenTable("s","select * from ^CL_ORGCP "
						+" where FWID_CL="+ nID);
	if(tPers.isEmpty())
	{
		/*WAIT(ru("Нет контактных лиц для '"+ oOrg.getTxt() +"'"
				,"Немає контактних особ для '"+ oOrg.getTxt() +"'")
				);
		*/
	}
	while(!tPers.isEOF())
	{
		var nid = String(tPers.getValue("FWID"));
		var txt = tPers.getValue("FFIO");
		var phone = String(tPers.getValue("FPHONE")).trim();
		if(phone!="")
			txt += " ("+ phone +")";
		FCONTPERS.addItem(nid, txt);			
		tPers.MoveNext();
	}
	tPers.close();
	FCONTPERS.setValue(curCont);
	FCONTPERS.addItem("ADDNEW", UR("< Додати >|< Добавить >"));
}

function mHDAT_Valid() 
{
   return differ(HDAT.value, d00);
}

function getTimeFromObjectVar(tbegin)
{
	var date = new Date();
	var dt = tbegin.getValue();
	date.setHours(dt.getHours())
	date.setMinutes(dt.getMinutes())
	date.setSeconds(dt.getSeconds());
	
	return date;
}

function calcTime()
{	
	var d1 = new Date(HBDAT.getValue());
	var d2 = new Date(HEDAT.getValue());
	d1.setHours(HBDAT.getValue().getHours());
	d1.setMinutes(HBDAT.getValue().getMinutes());
	d2.setHours(HEDAT.getValue().getHours());
	d2.setMinutes(HEDAT.getValue().getMinutes());
	
	var sum = d2 - d1;
							
	var d0 = new Date(HADDTIME.getValue());
	var d3 = new Date(HADDTIME.getValue());
	d3.setHours(HADDTIME.getValue().getHours());
	d3.setMinutes(HADDTIME.getValue().getMinutes());
	d0.setHours(0);
	d0.setMinutes(0);
	
	sum += (d3 - d0);
	
	HTIME.value = round(sum/60000, 0);
	sum_valid();
	return true;
}

function sum_valid()
{
	HSUM.value = HTIME.value * HTARIF.value;
	return true;
}

function add_response()
{
	include("doc/DpDoc.js");
	var doc = "RESPONSE";
	var nop = 1;
	var par = new Object();
	par.subject = HPREDMET_RAZG.value;
	par.org = oOrg.getCod();
	par.contact = FCONTPERS.value;
	par.connect = "CRM.TR";
	var oDoc = new DpDoc(doc, nop);
	var bRet = oDoc.edit("ADD", null, par);
	if(!bRet)
		return null;
	
	loadResponse(oDoc);
	
	var m = new Object(); 
	m.FMAINWID = objDoc.getID();
	m.FDOCWID = oDoc.getID();
	m.FDOC = doc;
	m.FNOP = nop;
	m.FISPARENT = true;
	m.FWID = GetUID();
	updateTable("^DOC_LINKS", m, true);
	
	var m = new Object(); 
	m.FMAINWID = oDoc.getID();
	m.FDOCWID = objDoc.getID();
	m.FDOC = objDoc.sDocLbl;
	m.FNOP = objDoc.nNop;
	m.FISPARENT = false;
	m.FWID = GetUID();
	updateTable("^DOC_LINKS", m, true);
	
	//связь с маркетинговым списком
	var oSnap = getSnap("select FDOCWID, FNOP from ^DOC_LINKS where FDOC='ML' and FMAINWID="+ objDoc.getID());
	if(oSnap && Number(oSnap[0]))
	{
		var m = new Object(); 
		m.FMAINWID = oSnap[0];
		m.FDOCWID = oDoc.getID();
		m.FDOC = doc;
		m.FNOP = nop;
		m.FISPARENT = true;
		m.FWID = GetUID();
		updateTable("^DOC_LINKS", m, true);
		
		var m = new Object(); 
		m.FMAINWID = oDoc.getID();
		m.FDOCWID = oSnap[0];
		m.FDOC = "ML";
		m.FNOP = oSnap[1];
		m.FISPARENT = false;
		m.FWID = GetUID();
		updateTable("^DOC_LINKS", m, true);
	}
		
	return oDoc;
}

function loadResponse(oDoc)
{
	if(!oDoc)
	{
		var oSnap = getSnap("select FDOCWID, FNOP from ^DOC_LINKS where FDOC='RESPONSE' and FMAINWID="+ objDoc.getID());
		if(oSnap && Number(oSnap[0]))
		{
			include("doc/DpDoc.js");
			var doc = "RESPONSE";
			var nop = oSnap[1];			
			oDoc = new DpDoc(doc, nop);
			if(!oDoc.loadByID(oSnap[0]))
				return;
		}
		else
			return;
	}
	if(!oDoc)
		return;
	
	var response = "";
	var conf = Number(oDoc.getVar("HCONFIRM"));
	var answer = String(oDoc.getVar("HANSWER")).trim();
	var comm = String(oDoc.getVar("HCOMMENT")).trim();
	if(conf==1)
		response += UR("Так|Да");
	else if(conf==2)
		response += UR("Ні|Нет");
	if(answer!="")
		response += "\n\n"+ answer;
	if(comm!="")
		response += "\n\n"+ comm;
	FRESPONSE.value = response;
}

include("sys\\DpBaseDlg.js");