include("Objects/DpCl.js");

var oOrg;
var oMgr;
var nOrg = ReadParEx("CUR_TR_ORG");
var nMgr = ReadParEx("CUR_TR_MGR");

loadTask();
function loadTask()
{
	GRTASK.setVisible(true);
	LPROGER.setText(UR("Організація: |Организация:"));
	LFINDER.setText(UR("Менеджер: |Менеджер: "));
	
	oOrg = new DpCl("0", getPar("CODPLAT"), 0);
	oOrg.linkCtrl(FPROGRAMMER, FPROGRAMMER_TXT);

	oMgr = new DpCl("0", getPar("CODPERS"), 0);
	oMgr.linkCtrl(FFINDER, FFINDER_TXT);
	
	if(extPar.org)
		nOrg = extPar.org;
	if(extPar.manager)
		nMgr = extPar.manager;
		
	if(nOrg!=null)
		oOrg.setCod(nOrg);
	if(nMgr!=null)	
		oMgr.setCod(nMgr);
}
	
function docSrc()
{		
	nMgr = oMgr.getCod();
	nOrg = oOrg.getCod();
	WriteParEx("CUR_TR_ORG", String(nOrg));
	WriteParEx("CUR_TR_MGR", String(nMgr));
		
	var strWhere = " (fdoc_dat BETWEEN "+ sqlTo(getPar("GLOBDAT1"))
							    +" AND "+ sqlTo(getPar("GLOBDAT2")) +")";
	if(Number(NOP.value))
		strWhere += " and FNOP="+ NOP.value;
	
	if(nOrg!=0 && nOrg!=null)
		strWhere += " and FORG="+ sqlTo(nOrg);
	if(nMgr!=0 && nMgr!=null)
		strWhere += " and FMANAGER="+ sqlTo(nMgr);
	if(extPar && extPar.fid_doc)
		strWhere += " and FWID="+ sqlTo(extPar.fid_doc);
	if(!list.zaval)
		strWhere += getRemind(strWhere);	
	if(extPar && extPar.subWhere)
		strWhere += " and ("+ extPar.subWhere +")";
		
	this.qrySet("From", "^CRM_TELRAZG",
				"Where", strWhere,
				"Order", "FDOC_DAT, FCTRLDAT");
	return true;		
}

function docMenuInit()
{
	if(!this.dataSrc.getTable().isEmpty())
	{
		this.dataSrc.AddMenuItem("NN", "Отримані податкові накладні|Полученные налоговые накладные");
	}
}

function docMenuHandler(nID)
{		
	var tbl = this.dataSrc.getTable();
	var ds1 = this.dataSrc;		
	
	if (nID == "NN")
	{
		extPar.forg = tbl.getValue("FORG");
		extPar.fdat = tbl.getValue("FDOC_DAT");
	}
}

function listInitEditParam(oPar)
{
	oPar.nOrg = oOrg.getCod();
	oPar.nMgr = oMgr.getCod();
}

function onAfterEdit(oDoc, mode)
{
	updateTreeKeys("^CRM_TELRAZG", oDoc.getID(), new Array("FDOC_DAT", "FDOC_NUM"));
}

function getRemind(sWhere)
{
	if(sWhere && sWhere!="")
		sWhere += " and FREMIND="+ SqlTrue;
	else
		sWhere = " FREMIND="+ SqlTrue;	
	
	var sFwids = "";
	var sMsg = "";
	var tbl = OpenTable("select * from ^CRM_TELRAZG "
						+" where "+ sWhere
						+" order by FCTRLDAT");
	for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
	{		
		var nOrg = tbl.getValue("FORG");		
		var cDat = tbl.getValue("FCTRLDAT");		
		var difTime = getDifTime(cDat);
		if(cDat && (difTime<0 || (difTime==0 && getDifDate(cDat)==0)))
		{
			var sDat = StrDat(new Date(cDat), "DMY");
			var sTime = cDat.getHours() +" : "+ cDat.getMinutes();
			var sOrg = tcl("CL", "TXT", getPar("CODPLAT"), nOrg);
			sMsg += "\n"+ sDat +"   "+ sTime +"   - "+ sOrg;
			sFwids += ", "+ tbl.getValue("FWID");
		}
	}
	if(sMsg=="")
		return "";
	
	sMsg = UR("Передзвонити: |Перезвонить: ") + sMsg;
	var sCapt = UR("Нагадування|Напоминание");
	var ret = msgBox("^oif", sMsg, sCapt);
	
	if(ret=="o" || ret=="" || !ret)
		return "";
	
	sFwids = sFwids.substring(1);
	if(ret=="i")
	{
		ExecuteSQL("update ^CRM_TELRAZG set FREMIND="+ SqlFalse
					+" where FWID in ("+ sFwids +")");
		return "";
	}
	if(ret=="f")
	{
		return " and FWID in ("+ sFwids +")";
	}
}

function isEndTime(ctlDate)
{
	if(!ctlDate)
		return false;
	
	var difTime = getDifTime(ctlDate);
	if(difTime>0)
		return true;

	return false;
}

function getDifDate(ctlDate, curDate)
{
	if(!ctlDate)
		return 0;
		
	ctlDate = new Date(ctlDate);
	if(curDate)
		curDate = new Date(curDate);
	else
		curDate = new Date();
			
	ctlDate = new Date(ctlDate.getFullYear(), ctlDate.getMonth(), ctlDate.getDate());	
	curDate = new Date(curDate.getFullYear(), curDate.getMonth(), curDate.getDate());
	
	return differ(ctlDate, curDate);
}

//разница времени(Тконтр - Ттекущее) в минутах
function getDifTime(ctlDate, curDate)
{
	var difTime = 0;	
	if(!ctlDate)
		return difTime;
	if(!curDate)
		curDate = new Date();
		
	ctlDate = new Date(ctlDate);
	
	var h = ctlDate.getHours();
	var m = ctlDate.getMinutes();
	if(!h && !m)
		return difTime;
	
	if(getDifDate(ctlDate, curDate)>0)
		return difTime;
		
	difTime = (ctlDate.getTime() - curDate.getTime())/60000;

	return difTime;
}