include("objects/DpVal.js");
include("objects/DpSc.js");
include("servis/date.js");
include("doc/DpDoc.js");
include("sys/udfs.js");
include("gridedit.js");

var sTmpTbl = "RDNTMP";
var tableR; 
var objDoc;
var NOMD;

function Load()
{	
   	objDoc = extPar.doc;
   	NOMD = objDoc.getPar("_nomdn");
   	   	
   	HTN.mask = "######";
	HREM.mask = "&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&";
  	HPSUM.mask = MASK_SUM;
  	HRSUM.mask = MASK_SUM;
  	
	Caption(extPar.doc.getCaption() + ": " + modeName(extPar.mode));
	
	ctrlLinker = new DpCtrlLinker(extPar.doc);
	ctrlLinker.addLink("HNOM", HTN);
	ctrlLinker.addLink("HBDAT", FDOC_DAT);
	ctrlLinker.addLink("HEDAT", FDOC_DATE);
	ctrlLinker.addLink("HREM", HREM);
	ctrlLinker.addLink("HSUMP", HPSUM);
	ctrlLinker.addLink("HSUMR", HRSUM);	
	ctrlLinker.updateData(false);
	
	setValid(FDOC_DAT, HBDAT_Valid);
	setValid(FDOC_DATE, HEDAT_Valid);	
	
	gridInit();
	
	if(extPar.mode=="EDIT" || extPar.mode=="COPY")
		refreshSum();
		
	Disable(HPSUM);
	Disable(HRSUM);
	
	setFocus(HTN);
}

function refreshSum(bChange)
{
	var sumP = 0;
	var sumR = 0;
	var oSum = getSnap("select sum(Fsum) from "+ sTmpTbl 
						+" where FPRIX<>"+ SqlFalse);
	if(oSum)
		sumP = Number(oSum[0]);	
	oSum = getSnap("select sum(Fsum) from "+ sTmpTbl 
							+" where FPRIX<>"+ SqlTrue);	
	if(oSum)
		sumR = Number(oSum[0]);
	
	if(bChange)
	{
		HPSUM.value = sumP;
		HRSUM.value = sumR;
	}
	else if(sumP!=Number(HPSUM.value) || sumR!=Number(HRSUM.value))
	{
		WAIT(ru("Проверьте суммы прихода и расхода!"
				,"Перевірте суми прибутків та видатків!"));
	}
}

function gridInit()
{
	if(!ExecuteSQL("DROP TABLE "+ sTmpTbl, false))
		ExecuteSQL("delete from "+ sTmpTbl, false);
	CreateTable(sTmpTbl, "RDN", "FWID");
	this.sDocSourceDir = rootDirectory() + "docs/" + extPar.doc.sDocLbl + "/";
		
	var nId = (extPar.mode == "COPY") ? extPar.doc.nOldID : extPar.doc.getID();
	var sFLD = GetPatternIntersection("RDN","RDN");
	
	if(extPar.mode=="ADD")
	{
		/*var sSQL = "insert into "+ sTmpTbl 
			+" (Fdoc,Fid_doc,Fnom_str,Fis_slct,Fnop,Fprix,Fstat,Fsum,Fval) "
			+" select "+ sqlTo(extPar.doc.sDocLbl) +" as FDOC"
				+", "+ extPar.doc.getID() +" as Fid_doc"
				+", Fcod as Fnom_str, "+ SqlFalse +" as Fis_slct"
				+", "+ extPar.doc.nNop +" as Fnop"
				+", "+ SqlFalse +" as Fprix"
				+", Fcod as Fstat, 0 as Fsum, 0 as Fval"
			+" from ^CLRELCLCL"
			+" where FCL="+ sqlTo(NOMD);			
		*/
		loadRows();
	}
	else
	{
		var sSQL = "INSERT INTO "+ sTmpTbl +"("+ sFLD +")"
			   +" SELECT "+ sFLD
			   +" FROM ^RDN"
			   +" WHERE fid_doc = "+ nId;
		ExecuteSQL(sSQL);
	}	
	
	grid.setXMLDir(this.sDocSourceDir);
	grid.setXMLFile("rowlist.xml");
	tableR = OpenTable("m","select * from "+ sTmpTbl +" order by fnom_str");
	clTie(tableR, "cl", "="+ NOMD +", Fstat");
		
	//if(extPar.mode=="COPY")
	//	extPar.doc.resetFnids(tbl, "RDN", extPar.doc);
	
	grid.setTable(tableR);
	grid.build();
			
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid.loadMenuHandler(this, "gridMenuInit");
	grid.selectMenuHandler(this,"gridMenuRun");
	
	dpGridEdit = new DpGridEdit(grid);
	//dpGridEdit.init = addRecord;
	dpGridEdit.canEdit = canEditRecord;
	dpGridEdit.saveRecord = saveRecord;
}

function canEditRecord(sMenuID)
{	
	if(sMenuID=="ADD")
		return false;
	return true;
}

function saveRecord()
{
	var tblRows = grid.getTable();	
	var rowID = parseInt(tblRows.getValue("fwid"));
	var oDocRow =  objDoc.getRow("RDN", rowID);
	if (oDocRow == null)
	{
		oDocRow = objDoc.createRow("RDN");
		oDocRow.setID(useWID);
		objDoc.appendRow("RDN", rowID);
	}
	with (oDocRow)
	{
		setVar("RNOM", tblRows.getValue("Fnom_str"));
		setVar("RSTAT", tblRows.getValue("Fstat"));
		setVar("RSLCT", tblRows.getValue("Fis_slct"));
		setVar("RTYPE", tblRows.getValue("Fprix"));					 
		setVar("RSUM", tblRows.getValue("FSUM"));			
		setVar("RVAL", tblRows.getValue("Fval"));										
	}
	obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
	grid.getTable().requery();
	
	refreshSum(true);
	return true;
}

function loadRows()
{
	var tblCl = OpenTable("s","SELECT * FROM ^CLRELCLCL"
				+" WHERE FCL="+ sqlTo(NOMD));
	
	var nPr = 0;
	var sPr = ru("Загружаются строки: ", "Загружаються рядки: ");
	setProgressRange(0, tblCl.recordCount);
	
	while (!tblCl.IsEOF())
	{
		setProgressPos(++nPr, sPr + nPr +"/"+ tblCl.recordCount);
		var oDocRow = extPar.doc.createRow("RDN");				
		oDocRow.setVar("RNOM", tblCl.getValue("Fcod"));
		oDocRow.setVar("RSLCT", false);
		oDocRow.setVar("RTYPE", false);
		oDocRow.setVar("RSTAT", tblCl.getValue("Fcod"));			 
		oDocRow.setVar("RSUM", 0);			
		oDocRow.setVar("RVAL", 0);			
		
		extPar.doc.appendRow("RDN", oDocRow);
		obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
		
		tblCl.MoveNext();
	}
	refreshSum(true);
	setProgressPos(0);	
}

function gridMenuInit()
{
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT","Редагування | Редактирование");
		grid.AddMenuItem("DEL","Видалення | Удаление");
	}
}

function gridMenuRun(sID)
{
	var rowID = Number(grid.getTable().getRowID());
	if(sID == "DEL")
	{
		extPar.doc.deleteRow("RDN",	rowID);
		grid.getTable().Delete();
		grid.getTable().requery();
		grid.refresh();
	}
	/*else
	{
		var oDocRow;
		if(sID == "EDIT")
		{
			oDocRow = extPar.doc.getRow("RDN", rowID);
		}
				
		var bOK = false;
		if(oDocRow)
			bOK = oDocRow.edit(sID);
		if (bOK)
		{				
			obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
			grid.getTable().requery();
			grid.refresh();
			refreshSUMK(true);
		}
	}*/	
}

function HBDAT_Valid() 
{
	if (isEmpty(FDOC_DAT.value))
	{
		WAIT(ru("Пустая дата недопустима!", "Порожня дата неприпустима!"));
		return false;
	}
  	return true;
}	

function HEDAT_Valid() 
{
	if (isEmpty(FDOC_DATE.value))
	{
		WAIT(ru("Порожня дата неприпустима!","Пустая дата недопустима!"));
		return false;
	}
	if (differ(FDOC_DATE.value, FDOC_DAT.value)<0)
	{
		WAIT(ru("Дата конца должна быть не меньше даты начала!"
			   ,"Дата кінця має бути не меншою за дату початку!"));
		return false;
	}
  	return true;
}	

function onSave()
{
	ctrlLinker.updateData(true);
	tableR.close();
	saveRows();
}

function saveRows()
{
	ExecuteSQL("DELETE FROM ^RDN WHERE fid_doc="+ extPar.doc.getID());
	var sFLD = GetPatternIntersection("RDN","RDN");
	ExecuteSQL("INSERT INTO ^RDN(" + sFLD + ")"
			  + " SELECT " + sFLD + " FROM " + sTmpTbl);
}

function onEscape()
{
   	tableR.close();
}

include("sys/DpBaseDlg.js");