include("doc\\DpDoc.js");
include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpNmkl.js");
include("Objects\\DpRecept.js");
include("Objects\\DpPrList.js");

var objDoc = extPar.doc;
var m = new Object();
var tbl;

function Load()
{
	this.onReceptValid = onReceptValid;

	var _recipe = objDoc.getPar("_recipe"); 	//Рецепт
	var nk_issch = objDoc.getPar("nk_issch"); 	//Запрашивать счет в строке
	var _hidestr = objDoc.getPar("_hidestr");  	//Скрывать расходные строки
	var nmklsel = objDoc.getPar("_nmklsel"); 	//Способ выбора номенклатуры
	var rowmol = objDoc.getPar("_rowmol");		//Позволять списывать со всех МОЛ
	var rowpdr = objDoc.getPar("_rowpdr");		//Позволять списывать со всех подразделений
	//var rowpst = objDoc.getPar("_rowpst");

	objDoc.isBuf = true;

	var nk = new DpNakl(objDoc, this);
	nk.load();

	FDOC_NUM.mask = MASK_DOCNUM;
	FSUM.mask     = FSUM_POK.mask =  MASK_SUM;
	FSUM1.mask    = FSUM_POK1.mask = MASK_SUM;
	PKOL.mask     = MASK_KOL;

	var objNmkl = new DpNmkl();
	nds = Number(objNmkl.getExt("_NDS"));

	oSc = new DpSc();
	oSc.linkCtrl(FSC, FSU, FST);
	var nk_issch = objDoc.getPar("nk_issch");
	var _recipe = objDoc.getPar("_recipe");		// "0" - по рецепту
	
	// проверяем счет в заголовке когда не указан параметр "указывать счет приходования в строке"
	// или указан параметр "по рецепту"
	var scMode = "c0ut";
	if(!nk_issch || _recipe == "0")
	{
		scMode = "cut"
	}
	oSc.setMode(scMode);

	oSc1 = new DpSc();
	oSc1.linkCtrl(FSC1, FSU1, FST1);
	oSc1.setMode("cut");

	objPodr = new DpCl();
   	objPodr.linkCtrl(FPODR,FPODR_TXT);
	objPodr.setClcl(sprPodr);
	objPodr.setContAssist();

	objMol = new DpCl();
   	objMol.linkCtrl(FMOL,FMOL_TXT);
	objMol.setClcl(sprMol);
	objMol.setContAssist();

	objPodr1 = new DpCl();
   	objPodr1.linkCtrl(FPODR1,FPODR1_TXT);
	objPodr1.setClcl(sprPodr);
	objPodr1.setContAssist();

	objMol1 = new DpCl();
   	objMol1.linkCtrl(FMOL1,FMOL1_TXT);
	objMol1.setClcl(sprMol);
	objMol1.setContAssist();

	Fdbkr = new DpRecept();
	Fdbkr.linkCtrl(FDBKR,FDBKR_TXT);
	Fdbkr.setAfterValid(this, "onReceptValid")
	//Fdbkr.setBeforeValid(this, "onBeforeReceptValid")
	if (extPar.mode == "EDIT")
		Fdbkr.bValid = true;

	objMol.setMode( rowmol?	 "0!" : "");
	objPodr.setMode( rowpdr? "0!" : "");
	//Fdbkr.setMode( rowpst? "0!" : "");

	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	ctrlLinker.addLink("HSCRS",FSC);
 	ctrlLinker.addLink("HSURS",FSU);
 	ctrlLinker.addLink("HSTRS",FST);
 	ctrlLinker.addLink("HSCPR",FSC1);
 	ctrlLinker.addLink("HSUPR",FSU1);
 	ctrlLinker.addLink("HSTPR",FST1);
 	ctrlLinker.addLink("HKOL",PKOL);
	ctrlLinker.addLink("HDVDAT",FDOV_DAT);
	ctrlLinker.addLink("HSUM",FSUM);
	ctrlLinker.addLink("HSUMPR",FSUM_POK);
	ctrlLinker.addClLink("HPODRRS",objPodr);
	ctrlLinker.addClLink("HPODRPR",objPodr1);
	ctrlLinker.addClLink("HMOLRS",objMol);
	ctrlLinker.addClLink("HMOLPR",objMol1);
	ctrlLinker.addLink("HDVDAT",FDOV_DAT);
	//ctrlLinker.addLink("",FSUM1);
	//ctrlLinker.addLink("",FSUM_POK1);
	//ctrlLinker.addClLink("HNOREC",Fdbkr);

	ctrlLinker.updateData(false);

	if (extPar.mode != "ADD")
	{
		oSc.set(objDoc.getVar("HSCRS"),
   				objDoc.getVar("HSURS"),
   				objDoc.getVar("HSTRS"));

   		oSc1.set(objDoc.getVar("HSCPR"),
   				 objDoc.getVar("HSUPR"),
   				 objDoc.getVar("HSTPR"));

   		Fdbkr.setDate(objDoc.getVar("HDAT"));
	}
	else
		PKOL.value = 1;

//	if(_hidestr	&& typeof(out)!="undefined")
//		out.style.display = "none";

	FDBKR.setVisible(false);
	Disable(FSUM);
	Disable(FSUM_POK);
	Disable(FSUM1);
	Disable(FSUM_POK1);
	Disable(FDBKR);

	setFocus(FDOC_NUM);
	setValid(FDOC_DAT, onDatChanged);
	recalcSum();

	//Добавим возможность иметь пользовательские пункты в контекстном меню
	//Скрипт ложить в popupmenu/docs.GP.form/
	if(typeof(initUserMenu)=="function")
		initUserMenu();

	if (objDoc.simpleMode2Rasc)
	{
		// ES:
		oSc.set(objDoc.getVar("HSCRS"),
   				objDoc.getVar("HSURS"),
   				objDoc.getVar("HSTRS"));

   		oSc1.set(objDoc.getVar("HSCPR"),
   				 objDoc.getVar("HSUPR"),
   				 objDoc.getVar("HSTPR"));
		if(objDoc.gotoFirstRow())
		{
			while(objDoc.gotoNextRow())
			{
				var currRow = objDoc.getCurrRow();
				var idMain = currRow.getID();

				var oSnap = getSnap("select FHNO from ^cl_rrec " +
						" where frtype = " + sqlTo(RTYPE_PR)
						+ " AND fnmkl = " + sqlTo(currRow.getVar("RTNMK")));
				if (oSnap != null)
				{
					Fdbkr.simpleMode2Rasc = true;
					Fdbkr.setCod(oSnap[0]);
					Fdbkr.fnmkl = currRow.getVar("RTNMK");
					Fdbkr.setKol(currRow.getVar("RKOL"));

//					onReceptValid();
					Fdbkr.validRecept();

					objDoc.deleteRow("ROW", idMain);
				}
			}
			nk.refreshViewer();
		}
	}
	else
	{
		nk.processMenu("RECALC_OST");
	}
}

function recalcSum()
{
	m.ssum  	  = "SUM("+IIF("a.Frtype = '7'", "a.Fkol * a.Fcena", "0")+")";
	m.sum_pok = "SUM("+IIF("a.Frtype = '5'", "a.Fkol * a.Fcena", "0")+")";
	nk.wItog(m);

	FSUM.value = m.ssum;
	FSUM_POK.value = m.sum_pok;
}

function updateData()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HPODR",objPodr.getCod());
	objDoc.setVar("HMOL", objMol.getCod());
	objDoc.setVar("HSC",  oSc.getSc());
	objDoc.setVar("HSU",  oSc.getSu());
	objDoc.setVar("HST",  oSc.getSt());
	objDoc.setVar("HSC1",  oSc1.getSc());
	objDoc.setVar("HSU1",  oSc1.getSu());
	objDoc.setVar("HST1",  oSc1.getSt());
	objDoc.setVar("HDOC", "GP");
	//objDoc.setVar("HP",   objDoc.getPar("_pricetyp"));
	//objDoc.setVar("HPN",  objDoc.getPar("_priceuse"));
}

function onSave()
{
	updateData();

	objDoc.setVar("HSMTOV",	m.Fsum_tov);
	objDoc.setVar("HSBTOV",	m.Fseb_tov);
	objDoc.setVar("HSMMAT",	m.Fsum_mat);
	objDoc.setVar("HSBMAT",	m.Fseb_mat);
	objDoc.setVar("HOSTAR",	m.Fsum_tar);
	objDoc.setVar("HUSTAR",	m.Fseb_tar);
	objDoc.setVar("HTOTL",	m.hIsRasc);
	//objDoc.setVar("HSNDS1",	m.hndsu);
	//objDoc.setVar("HPSUM",	m.hsumuc);
	//objDoc.setVar("HKOL",	m.hKol);
	objDoc.setVar("HNR",	m.hNr);

	nk.saveRows();
}

function docMenuInit()
{

	if (objDoc.getPar("sklad_isuch"))
		grid.AddMenuItem("CHECK_ON_PODR2","Подобрать недостающие элементы на другом складе (по учетной цене)");
	else
		grid.AddMenuItem("CHECK_ON_PODR","Подобрать недостающие элементы на другом складе");
	//grid.AddMenuItem("CHECK_ON_ALL_PODR","Подобрать недостающие элементы на ВСЕХ складах");
	grid.AddMenuItem("ADD_PN","Создать приход для недостающих элементов");
	grid.AddMenuItem("", "");

	if(grid.getTable().isEmpty())
	{
		grid.AddMenuItem("INS_REC","Створити за рецептом|Создать по рецепту");
		return;
	}
	if (askKey(1))
		grid.AddMenuItem("SORT_LINE","Перегрупувати рецепти|Перегруппировать рецепты");

	// grid.AddMenuItem("GP_SET_KOL","Проставити кількість порцій|Проставить количество порций"); - похоже, не работает
	grid.AddMenuItem("", "");
	grid.AddMenuItem("INS_REC","Створити за рецептом|Создать по рецепту");
	grid.AddMenuItem("DEL_REC","Вилучити за рецептом|Удалить по рецепту");
	grid.AddMenuItem("", "");

	if (nk.tbl4Grid.getValue("FRTYPE") == "7")
	{
		grid.AddMenuItem("GP_SET_UCHCENA","Вибір облікової ціни|Выбор учетной цены");
		grid.AddMenuItem("GP_SHOW_UCHCENA","Показати старі облікові ціни|Показать старые учетные цены");
	}
	grid.AddMenuItem("RECALCGP","Перерахувати за рецептом|Пересчитать по рецепту");
	if(typeof(loadUserMenu)=="function")
		loadUserMenu();
}

function docMenuHandler(sID)
{
	tbl = grid.getTable();
	switch(sID)
	{
		case "GP_SET_KOL":
			// ES 20040913 : Пересчитываем все рецепты с новым кол-вом
			// по суте удаляем старый рецепт и заносим новый
			//
			//var num = new Number(PKOL.value);
			kol = input(ru("Введите количество порций","Введіть кількість порцій"), "", PKOL.value, 20, 3);
			if (!kol || kol == Number(PKOL.value))
				break;

			var arr = new Array();
			PKOL.value = kol;
			objDoc.setVar("HKOL", kol);
			// Запоминаем какие рецепты были
			//var tbl = OpenTable("s", "SELECT fid_pn0 from " + nk.bufName + " group by fid_pn0");
			for(; !tbl.IsEOF(); tbl.MoveNext())
			{
				var bSimple = OpenTable("s", "SELECT fnmkl from " + nk.bufName
						+ " where fid_pn0 = " + sqlTo(tbl.getValue("FID_PN0"))+" or fid_pn0 is null "
						+ " group by fnmkl ").recordCount == 1;
				if (bSimple)
				{
					/*ExecuteSQL("UPDATE " + nk.bufName
							+ " SET FKOL = " + kol
							+ ", F1KOL = " + kol
							+ " WHERE FID_PN0=" + sqlTo(tbl.getValue("FID_PN0"))
							);
					*/
					var oDocRow = objDoc.getRow("ROW",Number(tbl.getRowID()));
					if(oDocRow == null)
						continue;
					oDocRow.setVar("RKOL",  round(kol, 5));
//					oDocRow.setVar("RKOLSPR",  kol);
					//oDocRow.setVar("R1KOL", kol);
					obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,nk.bufName);
				}
				else
				{
					arr[arr.length] = tbl.getValue("FID_PN0");
				}
			}
			// Добавляем н\рецепты с новым количеством
			for(var i in arr)
			{
				ExecuteSQL("DELETE FROM " + nk.bufName + " WHERE FID_PN0=" + sqlTo(arr[i]));
//				this.Fdbkr.setFwid(arr[i]);
//				this.Fdbkr.validCtrl(this.getVar("PKOL"));//zaval
			}
//			this.wItog();
			break;

		case "GP_SET_UCHCENA":
			// ES 20040913 : Сейчас тут хитро обрабатывается ситуация с штучным товаром
			// Определяется штучный товар по тому, что у него в приходной и расходной строке
			// одинаковая номенклатура. И если это штучный товар, при выборе предоставляется
			// вся номенклатура, а после выбора прописывается код выбранной номенклатуры
			// и в приходной и в расходной строке рецепта
			// Так как в одном док-те может быть несколько рецептов то мы их отличаем по
			// полю FID_PN0
			//
			/*
			!!!!!!!!!!
			вопрос вылез после того как "FID_PN0" стал проставляться из
			рецепта, потому для рецепта "Штцчный товар" нужно что-то придумать
			так как приведенный ниже код будет работать только если в документе есть один штучный товар
			!!!!!!!!!!
			*/
			var bSimple = OpenTable("s", "SELECT fnmkl from " + nk.bufName
					+ " where fid_pn0 = " + sqlTo(tbl.getValue("FID_PN0"))
					+ " group by fnmkl ").recordCount == 1;

			//var m = new Object();
			onReceptGetCena(tbl, tbl.getRowID(), bSimple);
			/*this.tbl4Grid.Edit();
			this.tbl4Grid("FCENA") = m.FCENA;
			this.tbl4Grid("F1CENA") = m.F1CENA;
			this.tbl4Grid("FNMKL") = m.FNMKL;
			this.tbl4Grid.Update();
			*/
/*			if (bSimple)
			{
				ExecuteSQL("UPDATE " + this.bufName + " SET FNMKL = " + sqlTo(m.FNMKL)
					+ " where fid_pn0 = " + sqlTo(this.tbl4Grid("FID_PN0")));
			}
*/
			onReceptRefreshTotal(nk.tbl4Grid.getValue("FID_PN0"));
			break;

		case "GP_SHOW_UCHCENA":
			var par = new Object();
			par.fdata1 = objDoc.getVar("HDAT");
			par.fnmkl = tbl.getValue("fnmkl");
			par.escape = true;
			showWindow("l_anltk.js",SW_MODAL,par);
			if (!par.escape)
			{
				var oDocRow = objDoc.getRow("ROW",Number(tbl.getRowID()));
				oDocRow.setVar("RUCENA", par._fcena);
				//oDocRow.setVar("ROCENA", par._fcena);
				obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,nk.bufName);

				onReceptRefreshTotal(nk.tbl4Grid.getValue("FID_PN0"));
			}
			break;

		case "INS_REC":
			Fdbkr.bValid = false;
			Fdbkr.validCtrl(PKOL.value);//zaval
			break;

		case "DEL_REC":
			if(confirm(ru("Удалить этот рецепт?", "Видалити цей рецепт?")))
			{
				ExecuteSQL("DELETE FROM " + nk.bufName
						+ " WHERE FID_PN0=" + sqlTo(nk.tbl4Grid.getValue("FID_PN0"))
								+ " AND NOT (FID_PN0 IS NULL)");
				//this.wItog();
			}
			break;

		case "SORT_LINE":
			tbl_sort = OpenTable("s","SELECT * FROM " + nk.bufName
									+ " WHERE "+ grid.sqlSelected());

			if (tbl_sort.recordCount != 2)
			{
				alert(ru("Операция не выполнена. Выделите только две позиции",
						"Операція не виконана. Виділіть лише дві позиції"));
				break;
			}
			// get current values
			tbl_sort.MoveFirst();
			var row_num1 = tbl_sort.getValue("fnom_str");
			var row1 = tbl_sort.getValue("fid_pn0");
			var rtype1 = tbl_sort.getValue("frtype");
			tbl_sort.MoveNext();
			var row_num2 = tbl_sort.getValue("fnom_str");
			var row2 = tbl_sort.getValue("fid_pn0");
			var rtype2 = tbl_sort.getValue("frtype");

			if ( rtype1 != "5" || rtype2 != "5")
			{
				alert(ru("Операция не выполнена. Выделите "+" строки рецептов",
						"Операція не виконана. Виділіть "+" рядки рецептів"));
				break;
			}

			// update values
			// FIRST ROW
			tbl_sort.MoveFirst();
			tbl_sort.Edit();
			tbl_sort.setValue("fnom_str", row_num2);
			tbl_sort.Update();
			// SECOND ROW
			/*tbl_sort.MoveNext();
			tbl_sort.Edit();
			tbl_sort("fnom_str") = row_num1;
			tbl_sort.Update();
			*/
			ExecuteSQL("UPDATE " + nk.bufName
				+ " SET fnom_str = fnom_str + " + (row_num2 - row_num1)
				+ " where fid_pn0 = " + sqlTo(row1)
					+ " and NOT (fid_pn0 IS NULL)"
					+ " and FRTYPE <> " + sqlTo("5"));
			var val = getSnap("select min(fnom_str) as fmin FROM " + nk.bufName
					+ " where fid_pn0 = " + sqlTo(row1))[0] - 1;
			ExecuteSQL("UPDATE " + nk.bufName
						+ " SET fnom_str = fnom_str + " + ( val - row_num2 )
				+ " where fid_pn0 = " + sqlTo(row2)
					+ " and NOT (fid_pn0 IS NULL)"
					//+ " and FRTYPE <> " + sqlTo(RTYPE_PR)
				);
			break;

		case "RECALCGP":
			var oSnap = getSnap("select Fhno from ^CL_RREC "
								+"where fwid="+ tbl.getValue("FID_PN0"));
			if(oSnap)
				Fdbkr.setCod(oSnap[0]);
			var nRecept = Fdbkr.getCod();

			if (!tbl.IsEmpty() && nRecept!=0 && nRecept!=null)
			{
				if (!confirm(ru("Все существующие строки будут удалены. Продолжить?",
							    "Всi iснуючi рядки будуть видаленi. Продовжити?")))
				{
					return;
				}
	            //Найдем осн.номенклатуру в рецепте
				// Ищем основную строку по рецепту
				var tMain = OpenTable("s",
					"SELECT *"
					+ " FROM ^CL_RREC"
					+ " WHERE fhno = " + sqlTo(nRecept)
					+ " AND fmain = "+ sqlTrue
				);

				if(tMain.IsEmpty())
				{
					alert(ru("В рецепте отсутствует основная строка",
							"В рецепті відсутній основний рядок"));
					return;
				}

				tMain.MoveFirst();
				var sMainNmk = tMain.getValue("Fnmkl");

				// В накладной ищем кол-во основной номенклатуры
				var tBuf = OpenTable("s",
					"SELECT *"
					+ " FROM "+ nk.bufName
					+ " WHERE FNMKL="+ sqlTo(sMainNmk? sMainNmk : 0)
				);
				if(tBuf.IsEmpty())
				{
					alert(ru("В накладной отсутствует основная строка",
							"В накладній відсутній основний рядок"));
					return;
				}
				Fdbkr.kolToDo = tBuf.getValue("FKOL");
				tBuf.close(5652);
				tBuf = null;

				ExecuteSQL("DELETE FROM " + nk.bufName);
				tbl.requery();

				Fdbkr.isRecalc = true;
				Fdbkr.validCtrl();
			}
			break;
		case "CHECK_ON_PODR":
			checkOnPodr(objDoc, "SM");
			break;

		case "CHECK_ON_PODR2":
			checkOnPodr(objDoc, "PM");

			break;
		case "CHECK_ON_ALL_PODR":
			do
			{
			}
			while (checkOnPodr(objDoc))
			break;

		case "ADD_PN":
			var oPnDoc = new DpDoc("PN", 1);
			oPnDoc.setVar("HDAT", objDoc.getVar("HDAT"));

			var autono = new dpAutoNo(oPnDoc);
			oPnDoc.setVar("HNOM", autono.get());

			var bEmpty = true;
			tbl = OpenTable("SELECT MAX(-FOST) as ost, FNMKL,FSC,FSU,FST,"
				+ First("FEDI") + " as EDI," + First("FCENA") + " as CENA "
				+ " FROM " + nk.bufName
				+ " WHERE FOST < 0"
				+ " GROUP BY FNMKL,FSC,FSU,FST"
				);
			for (tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
			{
				{
					var oDocRow = oPnDoc.createRow("ROW");
					oDocRow.setVar("RTNMK", toScrObj(tbl.getValue("FNMKL")));
					oDocRow.setVar("RKOL", round(Number(tbl.getValue("ost")), 5));
//					oDocRow.setVar("RKOLSPR", Number(tbl.getValue("ost")));
					oDocRow.setVar("REDI", toScrObj(tbl.getValue("EDI")));
					/*
					oDocRow.setVar("RSC", objDoc.getVar("HSC"));
					oDocRow.setVar("RSU", objDoc.getVar("HSU"));
					oDocRow.setVar("RST", objDoc.getVar("HST"));
					oDocRow.setVar("RPODR", gd.fpodr);
					oDocRow.setVar("RMOL", gd.fmol);
					*/
					oDocRow.setVar("RTYPE", RTYPE_PR);
					var oSnap = getSnap("SELECT F1CENA FROM ^cl_nmk "
						+ " WHERE FWID=" + sqlTo(Number(tbl.getValue("Fnmkl"))));
				 	if (oSnap != null && oSnap[0] != null && oSnap[0] > 0)
				 	{
						cena = oSnap[0];
						oDocRow.setVar("RUCENA", Number(cena));
						oDocRow.setVar("RCENAORD", Number(cena));
						oDocRow.setVar("RPCENE", Number(cena));
				 	}
					oDocRow.setVar("R1OCENA", Number(tbl.getValue("CENA")));
					oDocRow.setVar("R1ID", toScrObj(oDocRow.getID()));

					oPnDoc.appendRow(oDocRow.sClassId, oDocRow);
					//obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, null);
					bEmpty = false;
				}
			}

			if (bEmpty)
				alert("Нет записей в документе");
			else
			{
				oPnDoc.edit("ADD", null, {isTransform:true});

				include("doc\\Nakl\\DpDocRasc.js")
				include("doc\\Nakl\\DpHonr.js")

				var oRasc2 = new DpDocRasc(objDoc);
				oRasc2.rasc();

				var id = objDoc.getID()
				objDoc.clear();
				objDoc.loadByID(id);
				nk.loadBuf();
				grid.getTable().requery();
				grid.refresh();

				nk.processMenu("RECALC_OST");
				checkMinus(" fwid = " + sqlTo(objDoc.getID()));
			}
			break;
		default:
			if(typeof(callUserMenu)=="function")
			{
				var ret = callUserMenu(sID);
				return ret;
			}
	}
}

function onReceptRefreshTotal(fid_pn0)
{
/*	//if (baseFdoc == "GP")
	{
		// Обновляем сумму приходных строк в рецептах
		var tbl = OpenTable("s", "SELECT " + sqlRound("sum(fkol*fcena)", __decisum) + " as summ, fid_pn0 "
				+ " FROM " + nk.bufName
				+ " WHERE "
					+ " frtype = " + sqlTo("7")
					+ sqlw0And("fid_pn0=", fid_pn0)
				+ " GROUP BY fid_pn0"
				);

		for(; !tbl.IsEOF(); tbl.MoveNext())
		{
			ExecuteSQL(s = "UPDATE " + nk.bufName
					+ " SET fcena = " + sqlRound(tbl.getValue("summ") + " / fkol ", prmDecPri)
					+ ", f1cena = " + sqlRound(tbl.getValue("summ") + " / fkol ", prmDecPri)
					//+ ", fcenapr = " + sqlRound(tbl.getValue("summ") + " / fkol ", __decisum)
					+ " WHERE frtype = " + sqlTo("5")
					+ " AND fid_pn0 = " + sqlTo(fid_pn0)
					);
		}
	}
*/
}

function onReceptGetCena(rtbl, id, bSimple)
{
	sWhere = " fid_doc="+ nk.fwid +" and frtype="+ sqlTo("7");
	nk.modifyData("EDIT", nk.rowsName, nk.fields2copy, nk.bufName, sWhere);

	//var tbl = grid.getTable();
	if (rtbl.getValue("FRTYPE") == "5") // для приходных строк только  ручной выбор
		return 0;
	var gp_extraWhere = "";
	tNmk = OpenTable("m","select * from ^cl_nmk "
						+"where fwid="+ sqlTo(rtbl.getValue("fnmkl"))
						+" AND (Fisgrp<>"+ sqlTo(true)
						  +" OR Fisgrp IS NULL)");

	var cena = 0;
	var t; // таблица остатков и результат
	//WAITTIMER("рассчитываются остатки ...");
	//расчет остатков и выбор
	include("mtr_ost.js");
	var oOb = new DpMtrOb()
	with(oOb)
	{
		//tblName = getOstName();
		tblName = "TMP_RAS_OST";
		bufName = tblName;
		fdate = objDoc.getVar("HDAT");
		/*if (!bSimple)
		{
			if (gp_extraWhere == "")
				fnmkl = rtbl.getValue("fnmkl");
			else
				extraWhere = gp_extraWhere;
		}
		*/
		fnmkl = rtbl.getValue("fnmkl");
		fsc = objDoc.getVar("HSCRS");
		fsu = objDoc.getVar("HSURS");
		fpodr = objDoc.getVar("HPODRRS");
		fmol = objDoc.getVar("HMOLRS");
		isFostsum = false;
		//pattern = PTN_OST_BUF;
		pattern = "RAS_OST";
		doCalc();
		t = getTbl();
	}
	//УЧТЕМ БУФЕР НАКЛАДНОЙ
	//include("sys\\ras_ost.js");
	//checkOst(nk.tbl4Grid, t, rtbl.getValue("Fnmkl"));

	if(typeOf(id) != "number")
		id = Number(tbl.getRowID());
	var oDocRow = objDoc.getRow("ROW", id);
	//var kol = m.FKOL;
	var kol = rtbl.getValue("FKOL");

	var cenamode = objDoc.getPar("_uchsel");

	//проверим, что хоть одна запись есть
	if(t.IsEmpty())
	{
		t.Close();
		t = null;
		__noWait = false;
		CLEARWAIT();
		//var num = new Number();

		var oSnap = getSnap("SELECT FCENAPR FROM ^cl_nmk "
			+ " WHERE FWID=" + sqlTo(Number(rtbl.getValue("Fnmkl"))));
	 	if (oSnap != null && oSnap[0] != null && oSnap[0] > 0)
	 	{
			cena = oSnap[0];
	 	}
	 	else
	 	{
			if (cenamode == 1 || cenamode == 2)
			{
				// LIFO, FIFO
				cena = 0;
			}
			else
			{
				include ("sys/udfs.js");
				var nmklTxt = tfnmk("TXT+", rtbl.getValue("Fnmkl"));
				cena = input(ru("Остатков для ","Залишків для ")
								+ nmklTxt
								+ ru(" нет. Введите цену вручную."," немає. Введіть ціну вручну.")
							, '', 0, 10, 3);

				if(cena == null)
					return 0;
			}
	 	}

		oDocRow.setVar("RUCENA", Number(cena));
		oDocRow.setVar("RTNMK",  rtbl.getValue("Fnmkl"));
		obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,nk.bufName);
		return 0;
	}
	else
	{
		__noWait = false;
		CLEARWAIT();

		var p = new Object();			//объекта параметров для завала
										//переменные для корректировки цепочек
		var kf	= 1;
		//1.Определяем параметры нашей цепочки
		p.Fnmkl	= Number(tNmk.getValue("FCOD"));
		p.Txt	= tNmk.getValue("Ftxts");
		p.Fpodr	= objDoc.getVar("HPODRRS");
		p.Fmol	= objDoc.getVar("HMOLRS");
		p.oOb	= oOb;
		if(!t.IsBOF())
			t.MoveFirst();
		p.tbl	=t;
		p.kf	=kf;
		p.bViewUch=true;
		p.noneg = true;
		p.tblName = oOb.tblName;

		p.ret = new Object();
		p.ret.Fnmkl = null;
		p.ret.Fcena = null;
		p.ret.Fsc = null;
		p.ret.Fsu = null;
		p.ret.Fst = null;
		p.ret.Fpost = null;
		p.ret.Fid_pn = null;
		p.ret.Fmol = null;
		p.ret.Fpodr = null;
		p.ret.Fcenapr = null;
		p.ret.Fost = null;

		//3.Запуск процедуры выбора
		tCena = OpenTable("select * from " + p.tblName);

		if (cenamode == 1 || cenamode == 2)
		{
			// LIFO, FIFO
			// Для LIFO, FIFO мы не показываем диалог выбора учетной цены, вместо этого документ просто расценивается
			if (tCena.recordCount >= 1)
			{
				p.escape = false;
				p.ret.Fnmkl = toScrObj(tCena.getValue("Fnmkl"));
				p.ret.Fcena = toScrObj(tCena.getValue("Fcena"));
				p.ret.Fsc = toScrObj(tCena.getValue("Fsc"));
				p.ret.Fsu = toScrObj(tCena.getValue("Fsu"));
				p.ret.Fst = toScrObj(tCena.getValue("Fst"));
				p.ret.Fpost = toScrObj(tCena.getValue("Fpost"));
				p.ret.Fid_pn = toScrObj(tCena.getValue("Fid_pn"));
				p.ret.Fmol = toScrObj(tCena.getValue("Fmol"));
				p.ret.Fpodr = toScrObj(tCena.getValue("Fpodr"));
				p.ret.Fcenapr = toScrObj(tCena.getValue("Fcenapr"));
				p.ret.Fost = toScrObj(tCena.getValue("Fost"));

				cena = p.ret.Fcena;
				var fkol = (p.ret.Fost < kol ? p.ret.Fost : kol);
				oDocRow.setVar("RKOL",   round(kol, 5));
//				oDocRow.setVar("RKOLSPR",   kol);
				oDocRow.setVar("RUCENA", Number(cena));
				oDocRow.setVar("RCENAORD", Number(cena));
				oDocRow.setVar("RTNMK",  p.ret.Fnmkl);
				oDocRow.setVar("RPODR",  p.ret.Fpodr);
				oDocRow.setVar("RMOL",   p.ret.Fmol);
				oDocRow.setVar("RPOST",  p.ret.Fpost);
				oDocRow.setVar("RSC",    p.ret.Fsc);
				oDocRow.setVar("RSU",    p.ret.Fsu);
				oDocRow.setVar("RST",    p.ret.Fst);
				oDocRow.setVar("R1ID",   p.ret.Fid_pn);
				obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,nk.bufName);
				t.Close();
			}
			else
			{
				//var num = new Number();
				cena = 0;
				oDocRow.setVar("RUCENA", Number(cena));
				oDocRow.setVar("RCENAORD", Number(cena));
				oDocRow.setVar("RTNMK",  rtbl.getValue("Fnmkl"));
				oDocRow.setVar("RPODR",  p.Fpodr);
				oDocRow.setVar("RMOL",   p.Fmol);
				oDocRow.setVar("RSC",    objDoc.getVar("HSCRS"));
				oDocRow.setVar("RSU",    objDoc.getVar("HSURS"));
				oDocRow.setVar("RST",    objDoc.getVar("HSTRS"));
				obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,nk.bufName);
				t.Close();
				return 0;
			}
		}
		else
		{
			if (tCena.recordCount == 1)
			{
				p.escape = false;
				p.ret.Fnmkl = toScrObj(tCena.getValue("Fnmkl"));
				p.ret.Fcena = toScrObj(tCena.getValue("Fcena"));
				p.ret.Fsc = toScrObj(tCena.getValue("Fsc"));
				p.ret.Fsu = toScrObj(tCena.getValue("Fsu"));
				p.ret.Fst = toScrObj(tCena.getValue("Fst"));
				p.ret.Fpost = toScrObj(tCena.getValue("Fpost"));
				p.ret.Fid_pn = toScrObj(tCena.getValue("Fid_pn"));
				p.ret.Fmol = toScrObj(tCena.getValue("Fmol"));
				p.ret.Fpodr = toScrObj(tCena.getValue("Fpodr"));
				p.ret.Fcenapr = toScrObj(tCena.getValue("Fcenapr"));
				p.ret.Fost = toScrObj(tCena.getValue("Fost"));
			}
			else
			{
				showWindow("l_ucena.js",SW_MODAL,p,"");
			}

			t.Close();

			if(!p.escape)
			{
				cena = p.ret.Fcena;
				var fkol = (p.ret.Fost < kol ? p.ret.Fost : kol);
				oDocRow.setVar("RKOL",   round(kol, 5));
				//oDocRow.setVar("RKOLSPR",   kol);
				oDocRow.setVar("RUCENA", Number(cena));
				oDocRow.setVar("RCENAORD", Number(cena));
				oDocRow.setVar("RTNMK",  p.ret.Fnmkl);
				oDocRow.setVar("RPODR",  p.ret.Fpodr);
				oDocRow.setVar("RMOL",   p.ret.Fmol);
				oDocRow.setVar("RPOST",  p.ret.Fpost);
				oDocRow.setVar("RSC",    p.ret.Fsc);
				oDocRow.setVar("RSU",    p.ret.Fsu);
				oDocRow.setVar("RST",    p.ret.Fst);
				oDocRow.setVar("R1ID",   p.ret.Fid_pn);
				obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,nk.bufName);
			}
			else
			{
				//var num = new Number();
				cena = input(ru("Введите цену","Введіть ціну"), "", 0, 10, 3);
				if(!cena)
					return 0;
				oDocRow.setVar("RUCENA", Number(cena));
				oDocRow.setVar("RCENAORD", Number(cena));
				oDocRow.setVar("RTNMK",  rtbl.getValue("Fnmkl"));
				oDocRow.setVar("RPODR",  p.Fpodr);
				oDocRow.setVar("RMOL",   p.Fmol);
				oDocRow.setVar("RSC",    objDoc.getVar("HSCRS"));
				oDocRow.setVar("RSU",    objDoc.getVar("HSURS"));
				oDocRow.setVar("RST",    objDoc.getVar("HSTRS"));
				obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,nk.bufName);
				return 0;
			}
		}
	}
	//return kol - oDocRow.getVar("RKOL");
	return p.ret.Fost - kol;
}

// реакция на выбор рецепта (перенос его строк в документ)
// данная функция передается в DpRecept и вызывается в конце его
// Valid'а, если введен правильный рецепт
function onReceptValid(subRecept)
{
	include("Objects\\DpClNo.js");
	var recept = (subRecept ? subRecept : Fdbkr);
	var rtbl = recept.getRTable();     // строки рецепта
	var RetVal = false;
	var fnom_str = getSnap("SELECT max(FNOM_STR) FROM " + nk.bufName)[0] + 1;

	var oSnap = getSnap("select Fwid from ^CL_RREC where Fhno="+ rtbl.getValue("Fhno")
		+" and Fmain="+ sqlTrue, false);
//	var recId = (oSnap? oSnap[0] : 0);
//	var main_wid = (recId==0? Fdbkr.getFwid() : recId);
	var main_wid = GetUID(); //Fdbkr.getFwid();
	var idRec = Fdbkr.getFwid();

	//Достанем из рецепта кол-во по "основной" строке рецепта
	var sn = getSnap("select FKOL from ^CL_RREC where Fhno="+ rtbl.getValue("Fhno")
		+" and Fmain="+ sqlTrue, false);
	var mainKol = (sn? sn[0] : 0);
	var main_sum = 0;

	var nRecept = recept.getCod();

	//Добавили возможность вызова пользовательской функции
	//загрузки строк по рецепту. Если она отработала корректно, то
	//должна вернуть true.
	//Для этого в редактировании рецепта в поле fvalid "Процедура обработки"
	//пишется примерно следующее:
	//include("hz:Recept00.js");userReceptValid(nk, recept, rtbl, mainKol)
	fvalid = recept.getValid();
	if (eval(String(fvalid)) == true)
	{
		//Здесь раньше проставляли учетную цену в приходной строке.
		//Теперь этим должен заведовать пользовательский скрипт

		//Наша процедура выполнилась успешно, значит дальнейшая обработка не требуется
		return true;
	}


	/*if(cValid)
	{
		try
		{
			var RetVal = eval(cValid);
		}
		catch(sMess)
		{
			ShowOutputEx(sMess.message);
		}

		if(RetVal)
		{
			nk.refreshViewer();
			//nk.wItog();
			return RetVal;
		}
	}
	*/

	if (rtbl && (!(rtbl.IsEOF() && rtbl.IsBOF())))
	{
		// выбор учетной цены
		var cenamode = objDoc.getPar("_uchsel");

		// РУЧНОЙ ВЫБОР
		if (cenamode == 0 || true)
		{
			/*
			this.tblRows = OpenTable("m", nk.bufName);

			if(!SQL)
			{
				var t1 = this.tblRows.tie("cl_nmk","nmk","Fwid","Fnmkl");
				t1.tie("cl_edi","edi1","cod","Fcedib");
				t1.tie("cl_edi","edi2","cod","Fedi1");
			}
			else
			{
				var t1 = this.tblRows.tie("cl_nmk","nmk","Fwid","Fnmkl");
				t1.tie("cl_edi","edi1","FCOD","Fcedib");
				t1.tie("cl_edi","edi2","FCOD","Fedi1");
			}
			*/
			var p = Object();
			// fill "-" row
			for (rtbl.MoveFirst(); !rtbl.IsEOF(); rtbl.MoveNext())
			{
				if( !( rtbl.getValue("FRTYPE")=="5" && rtbl.getValue("FMAIN") ) )
				{
					var fkol = p.FKOL = p.F1KOL = rtbl.getValue("FKOL");
					var ret = 0;
					//do
					{
						var oDocRow = objDoc.createRow("ROW");
						objDoc.appendRow("ROW", oDocRow);
						with(oDocRow)
						{
							setVar("RNOM",	 findFreeClNo(nk.bufName, "fnom_str"));
							if (typeof(tbl) != "undefined")
								setVar("R1ID",	 tbl.getValue("Fid_pn"));
							else
								setVar("R1ID", 0);
							setVar("R0ID",	 main_wid);
							setVar("RIDREC",	 idRec);
							setVar("RTYPE",	 rtbl.getValue("FRTYPE"));
							setVar("REDI",	 rtbl.getValue("FEDI"));
							setVar("RTNMK",	 rtbl.getValue("FNMKL"));
							setVar("RSC",	 objDoc.getVar("HSCPR"));
							setVar("RSU",	 objDoc.getVar("HSUPR"));
							setVar("RST",	 objDoc.getVar("HSTPR"));
							setVar("RPODR",	 objDoc.getVar("HPODRPR"));
							setVar("RMOL",	 objDoc.getVar("HMOLPR"));

							//setVar("RKOL",	 fkol);
						}
						//obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, nk.bufName);
//						if (!objDoc.simpleMode2Rasc)
							ret = onReceptGetCena(rtbl, oDocRow.getID());
						Fdbkr.main_cena += round(fkol * oDocRow.getVar("RUCENA"), 5);
						//oDocRow.setVar("RKOL", ret);
						oDocRow.setVar("RKOL", round(fkol, 5));
//						oDocRow.setVar("RKOLSPR", fkol);

						obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, nk.bufName);
						grid.getTable().requery();
					}
					//while(ret > 0)
				}
			}
			// fill "+" row
			if (!subRecept)
			{
				for (rtbl.MoveFirst(); !rtbl.IsEOF(); rtbl.MoveNext())
				{
					if( rtbl.getValue("FRTYPE")=="5" && rtbl.getValue("FMAIN") )
					{
						fkol = p.FKOL = p.F1KOL = rtbl.getValue("FKOL");
						var cena = round(Number(Fdbkr.main_cena) / (fkol==0? 1 : fkol), Number(getPar("DECIPRI")))
						var oDocRow = objDoc.createRow("ROW");
						objDoc.appendRow("ROW", oDocRow);

						with(oDocRow)
						{
							setVar("RNOM",	 findFreeClNo(nk.bufName, "fnom_str"));
							setVar("RKOL",	 round(rtbl.getValue("FKOL"), 5));
//							setVar("RKOLSPR",	 rtbl.getValue("FKOL"));
							setVar("RUCENA", cena);
							setVar("RCENAORD", cena);
							setVar("RSCENA", cena);
							setVar("RTYPE",	 rtbl.getValue("FRTYPE"));
							setVar("RTNMK",	 rtbl.getValue("FNMKL"));
							setVar("REDI",	 rtbl.getValue("FEDI"));
							setVar("RSC",	 objDoc.getVar("HSCPR"));
							setVar("RSU",	 objDoc.getVar("HSUPR"));
							setVar("RST",	 objDoc.getVar("HSTPR"));
							setVar("RPODR",	 objDoc.getVar("HPODRPR"));
							setVar("RMOL",	 objDoc.getVar("HMOLPR"));
							setVar("R0ID",	 main_wid);
							setVar("RIDREC", idRec);
							setVar("R1ID",	 oDocRow.getID());
						}
						obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, nk.bufName);
						grid.getTable().requery();
					}
				}
			}
			return;
		}

		// LIFO FIFO !!!ПОКА НЕ ФУРЫЧИТ. НУЖЕН МАССОВЫЙ ВВОД. 01.12.2005!!!
		var t = null;
		// ES 20050131. Переменная percent была введена для нового вида рецептов - "карта замен"
		// Карта замен это тоже рецепт в котором есть одна приходная строка и несколько расходных строк.
		// Отличие в том, что для нужно создавать не все расходные строки а только одну из них
		// в том порядке в каком они идут в рецепте. То есть если хватает первой составляющией
		// то берем ее и следующие расходные строки не трогаем, если не хватает первой составляющей
		// то оставшуюся часть нужно заместить второй составляющей, а переменная "percent" показывает
		// сколько процентов прихода еще нужно возместить.
		// Для обычных рецептов percent всегда = 100

		var percent = 100;
		for (rtbl.MoveFirst(); !rtbl.IsEOF(); rtbl.MoveNext())
		{
			var rt_kol = rtbl.getValue("FKOL");

			/*var nmk_formula = xnmk( rtbl.getValue("FNMKL"), "FORMULA" );
			if(false  && typeof nmk_formula=="string" && nmk_formula)
			{
				var oEval = new DpEval;
				oEval.setTable(fillFields());
				var exprval = oEval.eval(nmk_formula);
				if (typeof(exprval) == "number")
					rt_kol = rtbl.getValue("FKOL") * Number(exprval);
			}
			*/
			// Указываем какой процент осталось списать
			// (только для рецептов которые являются картами замен)
			rt_kol = round(rt_kol * percent / 100, prmDecKol);
			//var m = Object();
			switch(cenamode)
			{
				case 1://LIFO
				case 2://FIFO
					t = getRLifoFifo(rtbl, cenamode == 1, rt_kol); // eugene
					if (t && !t.IsEmpty())       // для приходных строк t = null;
						t.MoveFirst();
					break;
				default:
				{
					// отложенное расценивание и ручной выбор
					// при ручном выборе просто копируем без цены
					if (p.FRTYPE == "7")
						var fis_otl = p.FIS_OTL = cenamode == 3;
				}
			}
			var kol = 0;
			var kolToSave = 0;
			var isOst = true;
			// если LIFO, FIFO, то строки могут "множится"
			// иначе выполняется ровно 1 раз
			do
			{
				if (t && !t.IsEOF())//LIFO, FIFO
				{
					// Ищем валидные записи, пропуская невалидные
					for (;!t.IsEOF() && (t.getValue("fkol") <= 0 || t.getValue("fcena") <= 0); t.MoveNext())
					{
						// Ничего не делаем, нам нужно только дойти до валидной записи
						;
					}
					// нашли, считываем значения
					if (!t.IsEOF())
					{
						p = scatter(t, fields2copy);
						cena = p.F1CENA  = p.FCENA;
						kolToSave = p.FKOL;
						isOst = true;
						t.MoveNext();
					}
					else
					{
						isOst = false;
					}
				}
//				else
//					isOst = false;
				// Если не нашли не одной валидной записи, то обругаемся,
				// или для "карты замен" ищем по другому расходу недостающее кол-во.
				if (!isOst)
				{
					// запишем остаток для LIFO, FIFO, или все количество
					kolToSave = Number(rt_kol) - Number(kol);
					cena = p.F1CENA  = p.FCENA = 0;
					if( !( rtbl.getValue("FRTYPE")=="5" && rtbl.getValue("FMAIN") ) )
					{
						// Для карты замен это нормальная ситуация, не хватило одного составляющего
						// заменяем недостачу другим.
						if (recept.isReplaceMap())
						{
							// Но если просмотрели уже все что было возможно, то тогда тоже ругаемся
							rtbl.MoveNext();
							if (rtbl.IsEOF())
							{
								rtbl.MoveLast();
								alert(ru("Остатков для " + rtbl.getValue("Fnmkl") + " нет.\nПерерасход на " + round(kolToSave, 3) + " единиц",
										"Залишків для " + rtbl.getValue("Fnmkl") + " немає.\nПеревибуток на " + round(kolToSave, 3) + " одиниць"));
							}
							else
							{
								rtbl.MovePrev();
								break;
							}
						}
						else
						{
							alert(ru("Остатков для " + rtbl.getValue("Fnmkl") + " нет.\nПерерасход на " + round(kolToSave, 3) + " единиц",
									"Залишків для " + rtbl.getValue("Fnmkl") + " немає.\nПеревибуток на " + round(kolToSave, 3) + " одиниць"));
						}
					}
				}
				// если не основной приход
				if( !( rtbl.getValue("FRTYPE")=="5" && rtbl.getValue("FMAIN") ) )
				{

					fkol = p.FKOL = p.F1KOL = Number(kolToSave);
					kol += Number(kolToSave);

					var oDocRow = objDoc.createRow("ROW");
					objDoc.appendRow("ROW", oDocRow);
					with(oDocRow)
					{
						setVar("RNOM",	 findFreeClNo(nk.bufName, "fnom_str"));
						setVar("RKOL",	 round(fkol, 5));
//						setVar("RKOLSPR",	 fkol);
						setVar("RTYPE",	 rtbl.getValue("FRTYPE"));
						setVar("RTNMK",	 rtbl.getValue("FNMKL"));
						setVar("REDI",	 rtbl.getValue("FEDI"));
						setVar("R1ID",	 oDocRow.getID());
						setVar("R0ID",	 main_wid);
					}
					obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, nk.bufName);
					Fdbkr.main_cena += round(fkol * oDocRow.getVar("RUCENA"), 2);
				}
				else
					kol += Number(kolToSave);
			}
			while (kol != Number(rt_kol)) //eugene rtbl("FKOL"))//LIFO, FIFO - иначе t = null
			// ES 20050128 Если этот рецепт это карта замен, то тогда нужно выбрать
			// только одну расходную запись, но так, чтобы полностью покрыть нужное кол-во
			// Для этого мы вводим процент того что мы уже подобрали, и подбераем
			// только оставшуюсь часть
			if (recept.isReplaceMap() && rtbl.getValue("FRTYPE") != "5")
			{
				percent -= Number(percent) * round(Number(kol) / Number(rt_kol), prmDecKol);
				if (percent <= 0)
				{
					break;
				}
			}
			t = null;
		}

		// Если это подрецепт, то для него не надо создавать приходную строку
		// все уже учтено в главной приходной строке.
		if (!subRecept)
		{
			for (rtbl.MoveFirst();!rtbl.IsEOF(); rtbl.MoveNext())
			{
				if( rtbl.getValue("FRTYPE")=="5" && rtbl.getValue("FMAIN") )
				{
					fkol = p.FKOL = p.F1KOL = rtbl.getValue("FKOL");
					fcena = p.FCENA = p.FCENAPR = round(Number(Fdbkr.main_cena) / Number(fkol), 2);

					var oDocRow = objDoc.createRow("ROW");
					objDoc.appendRow("ROW", oDocRow);
					with(oDocRow)
					{
						setVar("RNOM",	 findFreeClNo(nk.bufName, "fnom_str"));
						setVar("RKOL",	 round(fkol, 5));
//						setVar("RKOLSPR",	 fkol);
						setVar("RUCENA", fcena);
						setVar("RSCENA", fcena);
						setVar("RTYPE",	 rtbl.getValue("FRTYPE"));
						setVar("RTNMK",	 rtbl.getValue("FNMKL"));
						setVar("REDI",	 rtbl.getValue("FEDI"));
						setVar("RSC",	 objDoc.getVar("HSCPR"));
						setVar("RSU",	 objDoc.getVar("HSUPR"));
						setVar("RST",	 objDoc.getVar("HSTPR"));
						setVar("RPODR",	 objDoc.getVar("HPODRPR"));
						setVar("RMOL",	 objDoc.getVar("HMOLPR"));
						setVar("R0ID",	 main_wid);
						setVar("R1ID",	 oDocRow.getID());
					}
					obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, nk.bufName);
				}
			}
		}
		this.onReceptRefreshTotal(main_wid);
	}
	return true;
}

function onDatChanged()
{
	Fdbkr.setDate(new Date(FDOC_DAT.getValue()));
}

function checkOnPodr(objDoc, docType)
{
	include("objects\\DpGetDat.js")
	include("mtr_ost.js")
	// запрашиваем дополнительные параметры
	var gd = new DpGetDat(new Array("s:c0ut", "p", "m"));
	if (gd.escape == true)
		return false;

	var oSmDoc = new DpDoc(docType, 1);
	oSmDoc.setVar("HDAT", objDoc.getVar("HDAT"));

	include("doc\\dpAutoNo.js");
	var autono = new dpAutoNo(oSmDoc);
	oSmDoc.setVar("HNOM", autono.get());
//	oSmDoc.setVar("HSC", gd.fsc);
//	oSmDoc.setVar("HSU", gd.fsu);
//	oSmDoc.setVar("HST", gd.fst);
	oSmDoc.setVar("HSC", objDoc.getVar("HSC"));
	oSmDoc.setVar("HSU", objDoc.getVar("HSU"));
	oSmDoc.setVar("HST", objDoc.getVar("HST"));
	oSmDoc.setVar("HMOLOT", gd.fmol);
	oSmDoc.setVar("HPODROT", gd.fpodr);
	oSmDoc.setVar("HMOLTO", objDoc.getVar("HMOLRS"));
	oSmDoc.setVar("HPODRTO", objDoc.getVar("HPODRRS"));

	var bEmpty = true;
	tbl = OpenTable("SELECT MAX(-FOST) as ost, FNMKL,FSC,FSU,FST,FEDI,FCENA "
		+ " FROM " + nk.bufName
		+ " WHERE FOST < 0"
		+ " GROUP BY FNMKL,FSC,FSU,FST,FEDI,FCENA"
		);
	for (tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
	{
		var o;
		with(o=new DpMtrOb())
		{
			date1   = objDoc.getVar("HDAT");
			pattern = "obr";
			date2   = objDoc.getVar("HDAT");
			fnmkl   = tbl.getValue("FNMKL");
			fpodr   = gd.fpodr;
			fmol    = gd.fmol;
			fsc     = gd.fsc;
			fsu     = gd.fsu;
			fst     = gd.fst;
			fis_otl = false;
			doCalc();
		}

//browse("SELECT fcena, f1cena, fcenapr from " + o.tblName)
		var oSnap = getSnap("select SUM(FEKOL) as kol, MAX(FCENA) as cena, MAX(FID_PN) as ID_PN from " + o.tblName
				+ " WHERE FEKOL>0");
		if (oSnap != null && oSnap[0] > 0)
		{
			var oDocRow = oSmDoc.createRow("ROW");
			oDocRow.setVar("RTNMK", toScrObj(tbl.getValue("FNMKL")));
			oDocRow.setVar("RKOL", round(Number(oSnap[0] < tbl.getValue("ost") ? oSnap[0] : tbl.getValue("ost")), 3));
			//oDocRow.setVar("RKOLSPR", round(Number(oSnap[0] < tbl.getValue("ost") ? oSnap[0] : tbl.getValue("ost")), 3));
			oDocRow.setVar("REDI", toScrObj(tbl.getValue("FEDI")));
			oDocRow.setVar("RSC", gd.fsc);
			oDocRow.setVar("RSU", gd.fsu);
			oDocRow.setVar("RST", gd.fst);
			oDocRow.setVar("RSC1", objDoc.getVar("HSCPR"));
			oDocRow.setVar("RSU1", objDoc.getVar("HSUPR"));
			oDocRow.setVar("RST1", objDoc.getVar("HSTPR"));
			oDocRow.setVar("RPODR", gd.fpodr);
			oDocRow.setVar("RMOL", gd.fmol);
			oDocRow.setVar("RTYPE", RTYPE_PMP);
			oDocRow.setVar("RUCENA", Number(oSnap[1]));
			oDocRow.setVar("RCENAORD", Number(oSnap[1]));
			oDocRow.setVar("R1ID", toScrObj(oSnap[2]));
			if (docType == "PM")
				oDocRow.setVar("R1OCENA", Number(oSnap[1]));
			else
			{
				var oSnap = getSnap("SELECT FCENAPR FROM ^cl_nmk "
					+ " WHERE FWID=" + sqlTo(Number(tbl.getValue("Fnmkl"))));

			 	if (oSnap != null && oSnap[0] != null && oSnap[0] > 0)
			 	{
					oDocRow.setVar("ROCENA", Number(oSnap[0]));
					oDocRow.setVar("R0OCENA", Number(oSnap[0]));

			 	}
				else
					oDocRow.setVar("ROCENA", Number(tbl.getValue("FCENA")));
			}

			oSmDoc.appendRow(oDocRow.sClassId, oDocRow);
			bEmpty = false;
//			obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, null);
		}
	}

	if (bEmpty)
	{
		alert("Невозможно ничего подобрать на указанном складе");
	}
	else if (oSmDoc.edit("ADD", null, {isTransform:true}))
	{
		include("doc\\Nakl\\DpDocRasc.js")
		include("doc\\Nakl\\DpHonr.js")

		var oRasc = new DpDocRasc(oSmDoc);
		oRasc.rasc();

		var oRasc2 = new DpDocRasc(objDoc);
		oRasc2.rasc();

		var id = objDoc.getID()
		objDoc.clear();
		objDoc.loadByID(id);
		nk.loadBuf();
		grid.getTable().requery();
		grid.refresh();

		nk.processMenu("RECALC_OST");
		checkMinus(" fwid = " + sqlTo(objDoc.getID()));
	}

	return true;
}

include("sys\\DpBaseDlg.js");