include("doc\\DpDocList.js");
include("Objects\\DpSc.js");
include("Objects\\DpCl.js");
include("Objects\\DpNmkl.js");
include("gridedit.js");
include("Objects/DpScannerHandler.js");

var sTmpTbl = getTmpTableName();
var objDoc = extPar.doc;
var m = new Object();
var oScan; 

function Load()
{
	FDOC_NUM.mask = MASK_DOCNUM;
	
	FKOL.mask     = MASK_KOL;
	FKOL_OBL.mask     = MASK_KOL;
	FSUM.mask  = MASK_SUM;
	FSUM_OBL.mask  = MASK_SUM;
	
	objPodr = new DpCl();
   	objPodr.linkSmartCtrl(FPODR);
	objPodr.setClcl(sprPodr);
	
	objMol = new DpCl();
   	objMol.linkSmartCtrl(FMOL);
	objMol.setClcl(sprMol);
	
	oSc = new DpSc();	
	oSc.linkCtrl(FSC, FSU, FST);
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	ctrlLinker.addLink("HTYPE",FTYPE);
	ctrlLinker.addLink("HSUM",FSUM);	
	ctrlLinker.addLink("HKOL",FKOL);
	ctrlLinker.addLink("HSUM_OBL",FSUM_OBL);	
	ctrlLinker.addLink("HKOL_OBL",FKOL_OBL);
	ctrlLinker.addClLink("HMOL",objMol);
	ctrlLinker.addClLink("HPODR",objPodr);
	ctrlLinker.addScLink("HSC", "HSU","HST","","","", oSc);
	
	
	ctrlLinker.updateData(false);
	
	this.onIMInputLineCode = onIMInputLineCode;
	oScan = new DpScannerHandler(grid.getTableControl());
	oScan.setHandler(this, "onIMInputLineCode");
	
	this.initGrid = _initGrid;
	this.initGrid();	
	
	Disable(FSUM);
	Disable(FKOL);
	Disable(FSUM_OBL);
	Disable(FKOL_OBL);
		
	if (this.sMode == "ADD")
		setFocus(FDOC_NUM);
	else
		setFocus(grid);
	recalcSum();
}

function _initGrid()
{
   	
	include ("sys/ListApi.js");
	initGridVars(grid);
	this.sDocSourceDir = rootDirectory() + "docs/" + extPar.doc.sDocLbl + "/";
	CreateTable(sTmpTbl,"RIM","FWID");
	var nId = (extPar.mode == "COPY") ? extPar.doc.nOldID : extPar.doc.getID();
	var sFLD = GetPatternIntersection("RIM","RIM");
	var sSQL = "INSERT INTO " + sTmpTbl + "(" + sFLD + ")"
			   + " SELECT " + sFLD
			   + " FROM ^RIM"
			   + " WHERE fid_doc = " + nId;
	ExecuteSQL(sSQL);
	grid.noInPlaceAdd = true;
	grid.setXMLDir(this.sDocSourceDir);
	grid.setXMLFile("rowlist.xml");
	grid.addImage(1,rootDirectoryEx() + "icons/arru.gif");
	grid.addImage(2,rootDirectoryEx() + "icons/arrd.gif");	
	grid.setImageField("=^fdelta>0?1:(^fdelta<0?2:0)");
	
	grid.setCycleEdit(true);
	var tbl = OpenTable("m","select  " + sTmpTbl + ".*, fkol-fkol_obl as fdelta, fkol*fcenapr as fsum, fkol_obl* fcena as fsum_obl from " + sTmpTbl + " order by fnom_str");
	tbl.tie("cl_nmk","nmk","fwid","fnmkl");
	tbl.tie("anltk","pn1","FWID","Fid_pn");
	tbl.tie("sch_zag","h","fwid","pn1.fid_doc");
	
	if(extPar.mode=="COPY")
		extPar.doc.resetFnids(tbl, "ROW", extPar.doc);
	
	grid.setTable(tbl);
//-	grid.getTable().setIdFld("FNID");
	
	grid.build();
	this.listMenuInit = docMenuInit;
	this.onSelectRowMenu = docMenuHandler;
	grid.loadMenuHandler(this,"listMenuInit");
	grid.selectMenuHandler(this,"onSelectRowMenu");
	
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.addValidField("fkol", recalcSum, recalcSum);
	//dpGridEdit.addValidField("fsum", recalcSum, recalcSum);
	
	grid.afterEditHandler(recalcSum, null);
}

function recalcSum()
{	
	var nSUM = nKOL = nKolObl = nSumObl = 0;
	var sSQL = "select sum(fkol) as fkol_sum, sum(fkol_obl) as fkol_obl_sum, sum(fcenapr * fkol) as fsum, sum(fcena * fkol_obl) as fsum_obl from " + sTmpTbl;
	var oSnap = getSnap(sSQL);
	if(oSnap && oSnap[0])
		nKOL = oSnap[0];
	if(oSnap && oSnap[1])
		nKolObl = oSnap[1];
	if(oSnap && oSnap[2])
		nSUM = oSnap[2];
	if(oSnap && oSnap[3])
		nSumObl = oSnap[3];
	FKOL.value = nKOL;
	FKOL_OBL.value = nKolObl;
	FSUM.value = nSUM;
	FSUM_OBL.value = nSumObl;
	
	return true;
}

function updateData()
{
	ctrlLinker.updateData(true);
	
}

function onSave()
{
	updateData();
	
	var sFLD = GetPatternIntersection("RIM","RIM");
	var sSQL = " DELETE FROM ^RIM"
			   + " WHERE fid_doc = " + objDoc.getID();
	ExecuteSQL(sSQL);
	var sSQL = "INSERT INTO ^RIM (" + sFLD + ")"
			   + " SELECT " + sFLD
			   + " FROM " + sTmpTbl;	
	ExecuteSQL(sSQL);
	onClose();
}

function onEscape()
{
	onClose();
}

function onClose()
{
	try
	{
		oScan.dispose();
	}
	catch(e)
	{
		
	}
}

function docMenuInit()
{
	if(IsDblClick(grid))
	{
		grid.runGridMenu("EDIT");
		return;
	}
	grid.AddMenuItem("ADD","Додати|Добавить");
	grid.AddMenuItem("EDIT","Редагувати|Редактировать");
	grid.AddMenuItem("LOADOSTPM","Завантажити залишки|Загpузить остатки");
	if(grid.getTable().getValue("FCENAPR")==0)
		grid.AddMenuItem("LOADCENAPR","Завантажити ціни|Загpузить цены");
	grid.AddMenuItem("","");
	grid.AddMenuItem("+++","Експорт|Экспорт");
		grid.AddMenuItem("EXPORTCALC","Open Calc");
		grid.AddMenuItem("EXPORTXLS","Формат xls");
	grid.AddMenuItem("---","");
	grid.AddMenuItem("","");
	grid.AddMenuItem("FIND", "Пошук|Поиск");
	grid.AddMenuItem("SELECT", "Відбір|Отбор");
}

function docMenuHandler(id)
{
	switch(id)
	{
		case "LOADOSTPM":
			if (!grid.getTable().IsEmpty() )
			{
				if (!confirm(ru("При формировании остатков все существующие\nстроки будут удалены. Продолжить?", "При формуваннi залишкiв всi iснуючi\nрядки будуть видаленi. Продовжити?")))
					return;
				ExecuteSQL("DELETE FROM " + sTmpTbl);
				grid.getTable().requery();
				grid.refresh();				
			}
			var cTblName;
			__noWait = true;
			WAITTIMER(ru("Рассчитываются остатки...", "Розpаховуються залишки..."))

			include("mtr_ost.js");
			oOb = new DpMtrOb();
			with( oOb )
			{
				fdate = FDOC_DAT.value;
				fsc = oSc.getSc();
				fsu = oSc.getSu();
				fst = oSc.getSt();
				fpodr = objPodr.getCod();
				fmol = objMol.getCod();

				doCalc();				
			}
			cTblName = oOb.tblName;
			var temp_tbl = null
			if (FTYPE.value == 0)				
			{
				temp_tbl = OpenTable("s", "SELECT * FROM "+ cTblName +" ORDER BY FNMKL, fsc, fsu, fst, fid_pn");
			}
			else
			{
				var sql =  "SELECT FNMKL, fsc, fsu, fst" 
					 	 + " , sum(FOST) as FOST, " + sqlRound("sum(FCENA*FOST)/sum(fost)", 5) + " as fcena" 
						 + " ,0 as fid_pn, 0 as fpost, 0 as fedi "	
						 + " from "+ cTblName 
						 + " group by FNMKL, fsc, fsu, fst "
						 +	"ORDER BY FNMKL, fsc, fsu, fst ";
				temp_tbl = OpenTable("s", sql);
			}
			if(temp_tbl.IsEmpty())
			{
				temp_tbl.close(5652);
				temp_tbl = null;
				CLEARWAIT();
				grid.refresh();
				recalcSum();
				alert(UR("Залишків немає!|Остатков нет!"))
				return;
			}
			var _price = Number(objDoc.getPar("_price"));
			var _pricetyp = String(objDoc.getPar("_pricetyp")).trim();
			var _priceuse = String(objDoc.getPar("_priceuse")).trim();
			include("Objects\\DpClNo.js");
			var nom = 0;
			for (temp_tbl.MoveFirst(); !temp_tbl.IsEOF(); temp_tbl.MoveNext())
			{
				oDocRow = objDoc.createRow("ROW");
				objDoc.appendRow("ROW", oDocRow);					
				id = oDocRow.getID();
				var nmkl = temp_tbl.getValue("Fnmkl");
				var cena = Number(temp_tbl.getValue("Fcena"));
				if(_price==0)
					cena = cenapric(_priceuse, _pricetyp, FDOC_DAT.value, nmkl);
				else if(_price==2)
					cena = Number(nmkTxt(nmkl, "FCENAPR"));
				with(oDocRow)
				{
					//m.FNMKVID 	= temp_tbl.getValue("FNMKVID");
					//m.FVAL		= 0;				
					setVar("RNOM",	++nom);					
					setVar("RKOL_OBL",	Number(temp_tbl.getValue("FOST")));
					setVar("RKOL",	0);
					setVar("RSC",	temp_tbl.getValue("Fsc"));
					setVar("RSU",	temp_tbl.getValue("Fsu"));
					setVar("RST",	temp_tbl.getValue("Fst"));
					//setVar("RCTYPE",temp_tbl.getValue("FCTYPE"));					
					setVar("RTNMK",	temp_tbl.getValue("Fnmkl"));
					setVar("REDI",	Number(temp_tbl.getValue("FEDI")));
					setVar("RCENA", Number(temp_tbl.getValue("Fcena")));
					setVar("RCENAPR", cena);					
					setVar("R1ID",	Number(temp_tbl.getValue("Fid_pn")));
					setVar("RPOST",	Number(temp_tbl.getValue("Fpost")));					
				}
				obj2DB(id,oDocRow.jDocRow,null,sTmpTbl);				
			}
			CLEARWAIT();
			__noWait = false;
			temp_tbl.close();
			grid.getTable().requery();
			grid.refresh();
			var sMsg = UR("Встановити кількість рівною обліковій?|Установить количество равное учетному?");
			if(confirm(sMsg))
			{
				ExecuteSQL("update "+ sTmpTbl +" set FKOL=FKOL_OBL");
				grid.getTable().requery();
				grid.refresh();
			}
			recalcSum();
			break;
		case "DEL":
		{
			if("-"==msgBox("c-"
					, ru("Подтвердите удаление записи", "Підтвердіть вилучення запису")
					, ru("Удаление записи", "Вилучення запису")))
			{
				var tbl = grid.getTable();
			
				if(tbl.isEmpty())
					return;
				
				objDoc.deleteRow("ROW",Number(tbl.getRowID()));
				tbl.Delete();
				tbl.requery();
				grid.refresh();
				recalcSum();	
			}
			break;
		}
		case "ADD":
		{
			oDocRow = objDoc.createRow("ROW");
			var oSnap = getSnap("select max(fnom_str) as nom from " + sTmpTbl);
			var nNom = 1;
			if (oSnap && oSnap[0])
				nNom = Number(oSnap[0]) + 1;
			oDocRow.setVar("RNOM", nNom);
			//oDocRow.setVar("RKOL", 1);
			oDocRow.setVar("RSC", oSc.getSc());
			oDocRow.setVar("RSU", oSc.getSu());
			oDocRow.setVar("RST", oSc.getSt());
			var bOK = oDocRow.edit(id);
			
			FORM.setActive();
			grid.setFocus();
				
			if (bOK)
			{
				objDoc.appendRow("ROW",oDocRow)
					
				obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,sTmpTbl);
				grid.getTable().requery();
				grid.refresh();
				recalcSum();	
			}
			break;
				
		}
		case "EXPORTCALC":
			var oPar = new Object();
			oPar.grid = grid;
			showWindow("grid_to_scalc.xml", SW_MODAL, oPar);
		break;
		case "EXPORTXLS":
			var sFile = BrowseForFile("*.xls", "Файлы XLS (*.xls)|*.xls|", null, "SAVE");
			if (sFile)
			{
				if (!sFile.endsWith(".xls"))
					sFile = sFile + ".xls";
				grid.exportToXLS(sFile);
			} 
		break;
		case "FIND":
			grid.runSelection(8); 
			break;
		
		case "SELECT":
			grid.runSelection(2);
			break;
		
		case "LOADCENAPR":
			var _price = Number(objDoc.getPar("_price"));
			if(_price==0)
			{
				var _pricetyp = String(objDoc.getPar("_pricetyp")).trim();
				var _priceuse = String(objDoc.getPar("_priceuse")).trim();
				var tPrice = pName(_pricetyp, FDOC_DAT.value);
				ExecuteSQL("update "+ sTmpTbl +" set FCENAPR=(select max(n.FCENA"+ (_priceuse=="0"? "" : _priceuse) +")"
							+" from "+ tPrice +" n where n.FNMKL="+ sTmpTbl +".FNMKL)"
							+" where FCENAPR=0 and exists (select n.FCENA from "+ tPrice +" n where n.FNMKL="+ sTmpTbl +".FNMKL)"
							);
			}
			else if(_price==2)
			{
				ExecuteSQL("update "+ sTmpTbl +" set FCENAPR=(select max(n.FCENAPR)"
							+" from ^CL_NMK n where n.FWID="+ sTmpTbl +".FNMKL)"
							+" where FCENAPR=0 and exists (select n.FCENAPR from ^CL_NMK n where n.FWID="+ sTmpTbl +".FNMKL)"
							);
			}
			else
			{
				ExecuteSQL("update "+ sTmpTbl +" set FCENAPR=FCENA where FCENAPR=0");
			}
			grid.getTable().requery();
			grid.refresh();
			recalcSum();
			break;
		default: 
			return false;	
	}
}

function onIMInputLineCode(linecode)
{
	try
	{
		var oSnap = getSnap("SELECT fwid, fcenapr, f1cena, fcod FROM ^cl_nmk "
							+" WHERE flinecod=" + sqlTo(linecode)
							+" AND (Fisgrp<>"+ sqlTrue
								+" OR Fisgrp IS NULL)"
							);
		trace("\n>>> onIMInputLineCode: "+ linecode +" > "+ (oSnap? oSnap[3] : "0"));
		if(!oSnap || !oSnap[0])
			return null;
		var oDocRow = null;
		var bEdit = false;
		var nmk = oSnap[0];
		var rowID = 0;
		var oSnap = getSnap("select FWID from "+ sTmpTbl +" where FNMKL="+ nmk +" order by FCENA desc, FNMKL");
		if(oSnap && oSnap[0])
		{
			rowID = oSnap[0];
			oDocRow = objDoc.getRow("ROW", rowID);
			if(oDocRow)
			{
				var kol = Number(oDocRow.getVar("RKOL"))+1;
				oDocRow.setVar("RKOL", kol);
				bEdit = oDocRow.edit("EDIT");
				if(bEdit)
				{
					var m = new Object();
					m.FWID = oDocRow.getID();
					m.FPOST = oDocRow.getVar("RPOST");
					m.FNMKL = oDocRow.getVar("RTNMK");
					m.FKOL = oDocRow.getVar("RKOL");
					m.FCENA = oDocRow.getVar("RCENA");
					m.FSC = oDocRow.getVar("RSC");
					m.FSU = oDocRow.getVar("RSU");
					m.FST = oDocRow.getVar("RST");
					updateTable(sTmpTbl, m, false);
				}
				else
				{
					return null;
				}
			}
		}
		if(!oDocRow)
		{
			oDocRow = objDoc.createRow("ROW");
			var oSnap = getSnap("select max(FNOM_STR) as nom from "+ sTmpTbl);
			var nNom = 1;
			if (oSnap && oSnap[0])
				nNom = Number(oSnap[0]) + 1;
			oDocRow.setVar("RNOM", nNom);
			oDocRow.setVar("RTNMK", nmk);
			oDocRow.setVar("RKOL", 1);
			oDocRow.setVar("RKOL_OBL", 0);
			oDocRow.setVar("RSC", oSc.getSc());
			oDocRow.setVar("RSU", oSc.getSu());
			oDocRow.setVar("RST", oSc.getSt());
			bEdit = oDocRow.edit("ADD");
			if(bEdit)
				objDoc.appendRow("ROW", oDocRow);
			else
				return null;
			obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
		}
		grid.getTable().requery();
		grid.getTable().FindFirst("FWID="+ oDocRow.getID());
		grid.refresh();
		recalcSum();
		return;
		/*
		var tbl = grid.getTable();
		if(!tbl)
			return null;
		var bEdit = tbl.FindFirst("FNMKL="+ nmk);
		grid.refresh();
		var oDocRow = null;
		if(bEdit)
		{
			var rowID = tbl.getValue("FWID");
			if(!rowID)
				return null;
			oDocRow = objDoc.getRow("ROW", rowID);
			if(oDocRow)
			{
				var kol = Number(oDocRow.getVar("RKOL"))+1;
				oDocRow.setVar("RKOL", kol);
			}
		}
		if(!oDocRow)
		{
			oDocRow = objDoc.createRow("ROW");
			var oSnap = getSnap("select max(FNOM_STR) as nom from "+ sTmpTbl);
			var nNom = 1;
			if (oSnap && oSnap[0])
				nNom = Number(oSnap[0]) + 1;
			oDocRow.setVar("RNOM", nNom);
			oDocRow.setVar("RTNMK", nmk);
			oDocRow.setVar("RKOL", 1);
			oDocRow.setVar("RSC", oSc.getSc());
			oDocRow.setVar("RSU", oSc.getSu());
			oDocRow.setVar("RST", oSc.getSt());
			bEdit = oDocRow.edit("ADD");
			if(bEdit)
				objDoc.appendRow("ROW", oDocRow);
			else
				return null;
		}
		obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
		tbl.requery();
		tbl.FindFirst("FWID="+ oDocRow.getID());
		grid.refresh();
		recalcSum();
		*/
	}
	catch(e)
	{
		trace(">>> onInputLineCode ERROR: "+ e +"\n");
		return null;
	}
}
			
include("sys\\DpBaseDlg.js");