include("doc\\DpDoc.js");
include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpNmkl.js");
include("Objects\\DpPrList.js");

var objDoc = extPar.doc;
var m = new Object();

function Load()
{	
	var nmklsel = objDoc.getPar("_nmklsel");
	var otpsel = objDoc.getPar("_otpsel");
	
	var rowmol = objDoc.getPar("_rowmol");
	var rowpdr = objDoc.getPar("_rowpdr");
	var rowpst = objDoc.getPar("_rowpst"); 
	
	objDoc.isBuf = false;
		
	var nk = new DpNakl(objDoc, this);	
	nk.where = '';
	nk.load();	 
		
	FDOC_NUM.mask = MASK_DOCNUM;
	Fsum.mask = MASK_SUM;
		
	var objNmkl = new DpNmkl();
	nds = Number(objNmkl.getExt("_NDS"));
	
	oVal = new DpVal();
	oVal.linkCtrl(TFVAL);
	//oVal.linkCtrlKurs(FVKURS);
	
	oSc = new DpSc();	
	oSc.linkCtrl(FSC, FSU, FST);	
	oSc.setMode("c0ut");
	
	objPodr = new DpCl();
   	objPodr.linkCtrl(FPODR,FPODR_TXT);
	objPodr.setClcl(sprPodr);
	
	objMol = new DpCl();
   	objMol.linkCtrl(FMOL,FMOL_TXT);
	objMol.setClcl(sprMol);
	
	objMol.setMode( rowmol?	 "0!" : "");
	objPodr.setMode( rowpdr? "0!" : "");	
		
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);	
	ctrlLinker.addLink("HSC",FSC);
 	ctrlLinker.addLink("HSU",FSU);
 	ctrlLinker.addLink("HST",FST);		
	ctrlLinker.addLink("HDVDAT",FDOV_DAT);	
	ctrlLinker.addLink("HSUM",Fsum);		
	ctrlLinker.addClLink("HMOL",objMol);
	ctrlLinker.addClLink("HPODR",objPodr);		
		
	ctrlLinker.updateData(false);
	
	if (extPar.mode != "ADD")	
	{		
		oVal.setCod(objDoc.getVar("HVAL"));			
		
   		objPodr.setCod(objDoc.getVar("HPODR"));   		
   		objMol.setCod(objDoc.getVar("HMOL"));	
		
		oSc.set(objDoc.getVar("HSC"),
   				objDoc.getVar("HSU"),
   				objDoc.getVar("HST"));
	}		
	
	setFocus(FDOC_NUM);	
	setValid(FDOC_DAT, recalcSum);	
	setValid(TFVAL, recalcSum);	
	recalcSum();
}

function recalcSum()
{		
	nk.wItog(m);	
		
	Fsum.value = m.hsumuc;
	
	var sum = m.hndso;	
	var dt = FDOC_DAT.value;
	var kod1 = oVal.getNazv();	
	if (sum != null)
		var hndso = _nv2nv("", dt, kod1, sum, 0, 0, 1);
		
	m.hndsu = round((m.hndsu * nds)/100,2);	
	m.hndso = round((hndso * nds)/100,2);		
}

function updateData()
{	
	ctrlLinker.updateData(true);
	objDoc.setVar("HVAL", oVal.getCod());
	objDoc.setVar("HP",   objDoc.getPar("_pricetyp"));	
	objDoc.setVar("HPN",  objDoc.getPar("_priceuse"));	
	//objDoc.setVar("HPOST",objPost.getCod());
	//objDoc.setVar("HPODR",objPodr.getCod());
	//objDoc.setVar("HMOL",objMol.getCod());		
}		

function onSave()
{		
	updateData();
		
	objDoc.setVar("HSMTOV",	m.Fsum_tov);
	objDoc.setVar("HSBTOV",	m.Fseb_tov);
	objDoc.setVar("HSMMAT",	m.Fsum_mat);
	objDoc.setVar("HSBMAT",	m.Fseb_mat);	
	objDoc.setVar("HOSTAR",	m.Fsum_tar);
	objDoc.setVar("HUSTAR",	m.Fseb_tar);	
	objDoc.setVar("HTOTL",	m.hIsRasc);	
	
	objDoc.setVar("HOSUM",	m.hsumoC);
	objDoc.setVar("HSNDS",	m.hndsu);
	objDoc.setVar("HSNDS1",	m.hndso);
	objDoc.setVar("HKOL",	m.hKol);	
	objDoc.setVar("HNR",	m.hNr);
		
	nk.saveRows();			
}

function docRefreshData()
{
	var sWere = " fid_doc="+ objDoc.getID() +" and frtype='7'"; 
	nk.modifyData("EDIT", nk.rowsName, nk.fields2copy, nk.bufName, sWere);
}
			
include("sys\\DpBaseDlg.js");