include("Objects/DpCtrlLinker.js");
include("Objects/DpDocEx.js");
include("Objects/DpNmkl.js");
include("Objects/DpCl.js");

var objDoc = extPar.doc; 
var ctrlLinker = null;
var sServTbl = "SC_SERV";		//услуги
var sTmpServTbl = getTmpTableName();
var sMenTbl = "SC_MEN";			//жильцы
var sTmpMenTbl = getTmpTableName();
var sPrivTbl = "SC_PRIV";		//льготы
var sTmpPrivTbl = getTmpTableName();
var sPrivMenTbl = "SC_PRIVMEN";	//льготники
var sTmpPrivMen = getTmpTableName();
var sGrantTbl = "SC_GRANTS";	//субсидии
var sTmpGrTbl = getTmpTableName();
var sSupTbl = "SC_SUPPORT";		//адресная помощь
var sTmpSupTbl = getTmpTableName();
var sCntTbl = "SC_COUNTERS";	//счетчики
var sTmpCntTbl = getTmpTableName();
var sRefTbl = "SC_REFERENCE";	//справка
var sTmpRefTbl = getTmpTableName();
var sPayTbl = "CONTRACT_ROW";	//плательщики
var sTmpPayTbl = getTmpTableName();
var oOrg;						//плательщик
var oStreet;					//улица
var oHouse;						//дом
var oApt;						//квартира
var oNmkServ;
var oNmkSub;
var oNode;						//узел
var oObject;					//объект
var oCat;						//категория плательщика
var oParDog;
var isVDK = getSystem()=="VDK";

function Load()
{
	Caption(objDoc.getCaption() + ": " + modeName(extPar.mode));
	
	ctrlLinker = new DpCtrlLinker(objDoc);

	FDOC_NUM.mask = "&&&&&&&&&&&&&";
	FPERSKOL.mask = "###";
	FLGTKOL.mask = "###";
	//FSUB.mask = MASK_SUM;
	//FSUBSUM.mask = MASK_SUM;
	FSUP_PERC.mask = MASK_SUM;
	FLOT.mask = "##.####";
	FROOF.mask = "##.####";
	FGREENFIELD.mask = "##.####";
	FASPHALT.mask = "##.####";
	FSPRINKLOT.mask = "##.####";
	FAREA.mask = MASK_KOL;
	FHNORM.mask = MASK_KOL;
	
	if(isVDK)
	{
		GRAREA.setVisible(false);
		//GRNORM.setVisible(true);
	}
	
	oParDog = new DpDocEx("LICSC", 1);
	oParDog.linkCtrl(FID_DOG);
	setValid(FID_DOG, parDogValid);
	
	oNode = new DpCl("0");
	oNode.setClcl(getPar("CODNODE"));
	oNode.linkSmartCtrl(FNODE);
	oNode.setContAssist();
	oNode.AfterLoad = nodeValid;
	setValid(FNODE, nodeValid);
	if(!getPar("CODNODE"))
		GRNODE.setVisible(false);
		
	oCat = new DpCl("0");
	oCat.setClcl(getPar("CODORGCAT"));
	oCat.linkSmartCtrl(FORGCAT);
	oCat.setContAssist();
	if(!getPar("CODORGCAT"))
		GRORGCAT.setVisible(false);
		
	oObject = new DpCl("0");
	oObject.setClcl(getPar("CODORGOBJECT"));
	oObject.linkSmartCtrl(FOBJECT);
	oObject.setContAssist();
	//oObject.AfterLoad = fillObjectData;
	if(!getPar("CODORGOBJECT"))
		GROBJECT.setVisible(false);
		
	oOrg = new DpCl();
	oOrg.setClcl(getPar("CODPLAT"));	
	oOrg.linkSmartCtrl(FORG);
	oOrg.setContAssist();
	this.oOrg = oOrg;
	
	oStreet = new DpCl();
	oStreet.setClcl(getPar("CODSTREET"));
	oStreet.linkSmartCtrl(FSTREET);
	oStreet.setContAssist();
		
	oHouse = new DpCl("", getPar("CODHOUSE"), 0, oStreet);
	oHouse.linkSmartCtrl(FHOUSE);
	oHouse.setContAssist();
	oHouse.addFldSearchSmart("FNOM");
	oHouse.isExactSearchSmart = true;
	oHouse.isCodeSearchSmart = false;
	oHouse.AfterLoad = loadHouse;
	setValid(FHOUSE, loadHouse);
		
	oApt = new DpCl("0", getPar("CODAPT"), 0, oHouse);
	oApt.AfterLoad = fillServ;
	setValid(FAPMT, fillServ);
	oApt.linkSmartCtrl(FAPMT);
	oApt.setContAssist();
	
	oNmkServ = new DpNmkl();
	oNmkServ.linkSmartCtrl(FSERV_NMKL);
	oNmkServ.CanEmpty = true;
	oNmkServ.afterLoad = servValid;
	
	var oRespons = new DpCl("0");
	oRespons.setClcl(getPar("CODPERS"));
	oRespons.linkSmartCtrl(FRESPONS);
	
	var oRoute = new DpCl("0");
	oRoute.setClcl(getPar("CODROUTE"));
	oRoute.linkSmartCtrl(FROUTE);
	
	var oPump = new DpCl("0");
	oPump.setClcl(getPar("CODPUMP"));
	oPump.linkSmartCtrl(FPUMP);
	
	var oPoint = new DpCl("0");
	oPoint.setClcl(getPar("CODPOINT"));
	oPoint.linkSmartCtrl(FPOINT);
	
	ctrlLinker.addLink("HNOM", FDOC_NUM);
	ctrlLinker.addLink("HDAT", FDAT);
	ctrlLinker.addLink("HBDAT", FBDAT);
	ctrlLinker.addLink("HEDAT", FEDAT);
	ctrlLinker.addLink("HORGGROUP", FORGGROUP);
	ctrlLinker.addLink("HPERSKOL", FPERSKOL);
	ctrlLinker.addLink("HTXT", FTXT);
	ctrlLinker.addLink("HPREM", FPREM);
	ctrlLinker.addLink("HLOT", FLOT);
	ctrlLinker.addLink("HROOF", FROOF);
	ctrlLinker.addLink("HGREENFIELD", FGREENFIELD);
	ctrlLinker.addLink("HASPHALT", FASPHALT);
	ctrlLinker.addLink("HSPRINKLOT", FSPRINKLOT);
	//ctrlLinker.addLink("HDOGNUM", FDOGNUM);
	ctrlLinker.addLink("HDOGDAT1", FDOGDAT1);
	ctrlLinker.addLink("HDOGDAT2", FDOGDAT2);
	//ctrlLinker.addLink("HNORMDAT1", FNORMDAT1);
	//ctrlLinker.addLink("HNORMDAT2", FNORMDAT2);
	ctrlLinker.addLink("HSUBNUM", FSUBNUM);
	ctrlLinker.addLink("HHEATNUM", FHEATNUM);
	ctrlLinker.addLink("HPROJECTNUM", FPROJECTNUM);
	ctrlLinker.addLink("HPROJECTDATE", FPROJECTDATE);
	ctrlLinker.addLink("HLEGITIMATION", FLEGITIMATION);
	ctrlLinker.addClLink("HNODE", oNode);
	ctrlLinker.addClLink("HORGCAT", oCat);
	ctrlLinker.addClLink("HOBJECT", oObject);
	ctrlLinker.addClLink("HRESPONS", oRespons);
	ctrlLinker.addClLink("HROUTE", oRoute);
	ctrlLinker.addClLink("HPUMP", oPump);
	ctrlLinker.addClLink("HPOINT", oPoint);
	
	ctrlLinker.updateData(false); 	 	
 	
 	if (extPar.mode == "ADD")
 	{
 		if(extPar.org)
 			oOrg.setCod(extPar.org);
 		if(extPar.node)
 			oNode.setCod(extPar.node);
 		if(extPar.street)
 			oStreet.setFWID(extPar.street);
 		if(extPar.house)
 			oHouse.setFWID(extPar.house);
 		FBDAT.value = FDAT.value;
 		FEDAT.value = d00;
 		var oSnap = getSnap("select count(*) as cnt from ^CL_HOUSE");
 		if(oSnap && Number(oSnap[0])==1)
 		{
 			oSnap = getSnap("select FWID_CL from ^CL_HOUSE");
 			if(oSnap && Number(oSnap[0]))
 				oHouse.setFWID(oSnap[0]);
 		}
 	}
 	else
 	{
 		if(extPar.mode=="COPY" && extPar.tbl)
 			FDOC_NUM.value = extPar.tbl.getValue("FDOC_NUM");
 		oParDog.setFwid(objDoc.getVar("HGRPID"));
 		oOrg.setCod(objDoc.getVar("HORG"));
 		if(objDoc.getVar("HSTREET")) 		
 			oStreet.setFWID(objDoc.getVar("HSTREET")); 	
 		if(objDoc.getVar("HHOUSE"))
 			oHouse.setFWID(objDoc.getVar("HHOUSE"));
 		if(Number(objDoc.getVar("HAPMT")))
	 		oApt.setFWID(objDoc.getVar("HAPMT"));
	 	loadHouse();
 		fillServ();
 		nodeValid();
 	}
 	
 	setWhen(FPERSKOL, showMen);
 	setWhen(FLGTKOL, showPriv);
 	//setWhen(FSUB, showSub);
 	//setWhen(FSUPPORT, showSupport);
 	
 	setButton(ADDMAN, add_man);
 	setButton(ADDSERV, add_serv);
 	//setButton(ADDSUB, add_sub);
 	setButton(ADDSUP, add_sup);
 	setButton(ADDCNT, add_cnt);
 	setButton(REGCNT, reg_cnt);
 	
 	this.fioValid = fioValid;
 	FFIO.setModifyHandler(this, "fioValid");
 	
 	//this.subValid = subValid;
 	//FSUBSUM.setModifyHandler(this, "subValid");
 	
 	this.supValid = supValid;
 	FSUP_PERC.setModifyHandler(this, "supValid");
 	
 	setValid(FSERV, servValid);
 	setValid(FCNT_SERV, cntValid);
 	
 	Disable(FPERSKOL);
 	Disable(FLGTKOL);
 	Disable(FDOGDAT1);
 	Disable(FDOGDAT2);
 	 	 	 	
 	loadServ();
 	loadMen();
 	loadPriv();
 	loadGrants();
 	loadSupport();
 	loadCounters();
 	loadReference();
 	//loadPay();
 	
 	fioValid();
 	servValid();
 	supValid();
 	cntValid();
 	calc_men();
}

function onAfterLoad()
{
	if(this.oCntr)
		this.oCntr.subUpdate = setCntrct;
}

function setCntrct(nID)
{
	var dogID = this.getID();
	if(!dogID)
		return;
	var oSnap = getSnap("select FDOG_NUM, FBDAT, FEDAT from ^CONTRACT where FWID="+ dogID);
	if(oSnap && oSnap[0])
	{
		objDoc.setVar("HDOGNUM", oSnap[0]);
		FDOGDAT1.value = oSnap[1];
		FDOGDAT2.value = oSnap[2];
	}
}

function fillObjectData()
{
	var objectID = oObject.getFWID();
	if(!objectID)
		return true;
	var oSnap = getSnap("select FSTREET, FHOUSE from ^CL_FACTORY where FWID_CL="+ objectID);
	if(!oSnap)
		return true;
	if(oSnap[0] && !oStreet.getCod())
		oStreet.setFWID(oSnap[0]);
	if(oSnap[1] && !oHouse.getCod())
		oHouse.setFWID(oSnap[1]);
}

function parDogValid()
{
	var dog = String(FID_DOG.value).trim();
	if(!dog || dog=="")
		oParDog.fwid = 0;
	//loadParentCounters();
}

function loadParentCounters()
{
	if(!oParDog.fwid)
		return;
	var tbl = OpenTable("select * from ^SC_COUNTERS where FID_DOG="+ oParDog.fwid);
	for(; !tbl.isEOF(); tbl.MoveNext())
	{
		var type = Number(tbl.getValue("FTYPE"));
		if(type==3)	//коммунальный счетчик
		{
			
		}
	}
}

function nodeValid()
{
	var node = oNode.getCod();
	if(node)
	{
		//oOrg.setMode("0");
		oStreet.setMode("0");
		oHouse.setMode("0");
	}
	else
	{
		//oOrg.setMode("");
		oStreet.setMode("");
		oHouse.setMode("");
	}
}

function fioValid()
{
	var fio = String(FFIO.value).trim();
	if(fio=="")
		Disable(ADDMAN);
	else
		Enable(ADDMAN);
}

function servValid()
{
	var serv = FSERV.value;
	if(!serv || serv=="")	// || !oNmkServ.getCod()
		Disable(ADDSERV);
	else
		Enable(ADDSERV);
}

function cntValid()
{
	var serv = FCNT_SERV.value;
	if(!serv || serv=="")
		Disable(ADDCNT);
	else
		Enable(ADDCNT);
}

function subValid()
{
	var sub = Number(FSUBSUM.value);
	if(sub==0)
		Disable(ADDSUB);
	else
		Enable(ADDSUB);
}

function supValid()
{
	var sub = Number(FSUP_PERC.value);
	if(sub==0)
		Disable(ADDSUP);
	else
		Enable(ADDSUP);
}

function loadPay()
{
	var sRowClass = "PAY";
	
	if(!ExecuteSQL("drop table "+ sTmpPayTbl, false))
		ExecuteSQL("delete from "+ sTmpPayTbl, false);
	CreateTable(sTmpPayTbl, sPayTbl);
	
	var sFld = GetPatternIntersection(sPayTbl, sPayTbl);
	var sSQL = "INSERT INTO "+ sTmpPayTbl +"("+ sFld +")"
				+" SELECT "+ sFld 
				+" FROM ^"+ sPayTbl
				+" WHERE FID_DOG="+ objDoc.getID();	
	ExecuteSQL(sSQL);	
	
	var tbl = OpenTable("m", "select * from "+ sTmpPayTbl +" order by FNUM");	
		
	grid_pay.setData("ROWCLASS", sRowClass);	
	grid_pay.setTable(tbl);
	grid_pay.build();	
		
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid_pay.loadMenuHandler(this, "gridMenuInit");
	grid_pay.selectMenuHandler(this, "gridMenuRun");
}

function loadReference()
{
	var sRowClass = "REF";
	
	if(!ExecuteSQL("drop table "+ sTmpRefTbl, false))
		ExecuteSQL("delete from "+ sTmpRefTbl, false);
	CreateTable(sTmpRefTbl, sRefTbl);
	
	var sFld = GetPatternIntersection(sRefTbl, sRefTbl);
	var sSQL = "INSERT INTO "+ sTmpRefTbl +"("+ sFld +")"
				+" SELECT "+ sFld 
				+" FROM ^"+ sRefTbl
				+" WHERE FID_DOG="+ objDoc.getID();	
	ExecuteSQL(sSQL);	
	
	var tbl = OpenTable("m", "select * from "+ sTmpRefTbl +" order by FDATE");	
		
	grid_ref.setData("ROWCLASS", sRowClass);	
	grid_ref.setTable(tbl);
	grid_ref.build();	
		
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid_ref.loadMenuHandler(this, "gridMenuInit");
	grid_ref.selectMenuHandler(this, "gridMenuRun");
}

//счетчики
function loadCounters()
{
	var sRowClass = "CNT";
	
	if(!ExecuteSQL("drop table "+ sTmpCntTbl, false))
		ExecuteSQL("delete from "+ sTmpCntTbl, false);
	CreateTable(sTmpCntTbl, sCntTbl);
	
	var sFld = GetPatternIntersection(sCntTbl, sCntTbl);
	var nID = (extPar.mode=="COPY")? objDoc.nOldID : objDoc.getID();
	var sSQL = "INSERT INTO "+ sTmpCntTbl +"("+ sFld +")"
				+" SELECT "+ sFld 
				+" FROM ^"+ sCntTbl
				+" WHERE FID_DOG="+ nID;	
	ExecuteSQL(sSQL);	
	
	var tbl = OpenTable("m", "select * from "+ sTmpCntTbl +" order by FNUM");	
	if(extPar.mode=="COPY")
		objDoc.resetFnids(tbl, sRowClass, objDoc);
	
	grid_cnt.setData("ROWCLASS", sRowClass);	
	grid_cnt.setTable(tbl);
	grid_cnt.build();	
		
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid_cnt.loadMenuHandler(this, "gridMenuInit");
	grid_cnt.selectMenuHandler(this, "gridMenuRun");
}

//адресная помощь для малообеспеченных семей
function loadSupport()
{
	var sRowClass = "SUP";
	
	if(!ExecuteSQL("drop table "+ sTmpSupTbl, false))
		ExecuteSQL("delete from "+ sTmpSupTbl, false);
	CreateTable(sTmpSupTbl, sSupTbl);
	
	var sFld = GetPatternIntersection(sSupTbl, sSupTbl);
	var nID = (extPar.mode=="COPY")? objDoc.nOldID : objDoc.getID();
	var sSQL = "INSERT INTO "+ sTmpSupTbl +"("+ sFld +")"
				+" SELECT "+ sFld 
				+" FROM ^"+ sSupTbl
				+" WHERE FID_DOG="+ nID;	
	ExecuteSQL(sSQL);	
	
	var tbl = OpenTable("m", "select * from "+ sTmpSupTbl +" order by FWID");	
	if(extPar.mode=="COPY")
		objDoc.resetFnids(tbl, sRowClass, objDoc);
		
	grid_sup.setData("ROWCLASS", sRowClass);
	//grid_sup.setXMLDir(extPar.doc.getClassDefPath() + sRowClass +"/");
	//grid_sup.setXMLFile("list.xml");
	grid_sup.setTable(tbl);
	grid_sup.build();	
	
	//calc_sup();
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid_sup.loadMenuHandler(this, "gridMenuInit");
	grid_sup.selectMenuHandler(this, "gridMenuRun");
}

function showSupport()
{
	TAB.setSelection(2);
}

function calc_sup()
{
	var sSupport = "";
	//FSUPPORT.value = "";
	var tbl = OpenTable("select * from "+ sTmpSupTbl 
						+" where FEDAT>="+ sqlTo(today)
							+" and (FBDAT<="+ sqlTo(today)+" or FBDAT>="+ sqlD00 +")"
						);	
	for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
		sSupport += tbl.getValue("FPERC") +"%  ";
	tbl.close();
	//FSUPPORT.value = sSupport;	
}

function add_sup()
{
	var sRowClass = "SUP";
	var sTmpTbl = grid_sup.getTable().getTableName();
	var oDocRow = objDoc.createRow(sRowClass);
	oDocRow.setVar("RSERV", FSUP_SERV.value);
	oDocRow.setVar("RPERC", FSUP_PERC.value);
	oDocRow.setVar("RBDAT", new Date(FBDAT.value).getVarDate());
	oDocRow.setVar("REDAT", d00);
		
	objDoc.appendRow(sRowClass, oDocRow)
	obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
	
	grid_sup.getTable().requery();			
	grid_sup.getTable().findByID(oDocRow.getID());
	grid_sup.refresh();
	
	FSUP_SERV.value = "";
	FSUP_PERC.value = 0;
	//calc_sup();
}

function add_cnt()
{
	var sRowClass = "CNT";
	var sTmpTbl = grid_cnt.getTable().getTableName();
	var oDocRow = objDoc.createRow(sRowClass);
	oDocRow.setVar("RSERV", FCNT_SERV.value);
	oDocRow.setVar("RNUM", nextCntNum());
	oDocRow.setVar("RSERIAL", FCNT_SERIAL.value);
	oDocRow.setVar("RMARK", FCNT_MARK.value);
	oDocRow.setVar("RBDAT", new Date(FBDAT.value).getVarDate());
	oDocRow.setVar("REDAT", d00);
		
	objDoc.appendRow(sRowClass, oDocRow)
	obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
	
	grid_cnt.getTable().requery();			
	grid_cnt.getTable().findByID(oDocRow.getID());
	grid_cnt.refresh();
	
	FCNT_SERV.value = "";
	FCNT_MARK.value = "";
	FCNT_SERIAL.value = "";
}

function nextCntNum()
{
	var sTmpTbl = grid_cnt.getTable().getTableName();
	var oSnap = getSnap("select max(FNUM) from "+ sTmpTbl);
	if(oSnap && Number(oSnap[0]))
		return Number(oSnap[0])+1;
	return 1;
}

function reg_cnt()
{
	var par = new Object();
	par.date = today;
	par.node = oNode.getCod();
	par.org = oOrg.getCod();
	par.street = oStreet.getFWID();
	par.house = oHouse.getFWID();
	par.mode = "ADD";
	showWindow("reg_counters.xml", SW_MODAL, par);
}

function add_man()
{
	var sRowClass = "MEN";
	var oDocRow = objDoc.createRow(sRowClass);
	oDocRow.setVar("RBDAT", new Date(FBDAT.value).getVarDate());
	oDocRow.setVar("REDAT", d00);
	oDocRow.setVar("RCOD", nextMenCod());
	oDocRow.setVar("RFIO", FFIO.value);
		
	objDoc.appendRow(sRowClass, oDocRow)
	obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpMenTbl);
	
	grid_men.getTable().requery();			
	grid_men.getTable().findByID(oDocRow.getID());
	grid_men.refresh();
	
	FFIO.value = "";
	
	calc_men();
}

function nextMenCod()
{
	var oSnap = getSnap("select max(FCOD) from "+ sTmpMenTbl);
	if(oSnap && Number(oSnap[0]))
		return Number(oSnap[0])+1;
	return 1;
}

function calc_men()
{
	FPERSKOL.value = 0;
	var oSnap = getSnap("select count(*) as cnt "
						+" from "+ sTmpMenTbl 
						+" where FBDAT<="+ sqlTo(today) 
							+" and FEDAT>="+ sqlTo(today)
						,false);
	if(oSnap && oSnap[0])
		FPERSKOL.value = oSnap[0];
	calc_priv();
}

function calc_priv()
{
	FLGTKOL.value = 0;
	var oSnap = getSnap("select count(distinct pm.FID_MEN) as cnt "
						+" from "+ sTmpMenTbl +" m"
							+" inner join ^"+ sPrivMenTbl +" pm on pm.FID_MEN=m.FWID"
							+" inner join ^"+ sTmpPrivTbl +" p on p.FWID=pm.FID_PRIV"
						+" where m.FBDAT<="+ sqlTo(today) 
							+" and m.FEDAT>="+ sqlTo(today)
							+" and p.FBDAT<="+ sqlTo(today)
							+" and p.FEDAT>="+ sqlTo(today)
						,false);
	if(oSnap && oSnap[0])
		FLGTKOL.value = oSnap[0];
}

function showMen()
{
	TAB.setSelection(2);
}

function showPriv()
{
	TAB.setSelection(3);
}

function add_serv()
{
	var sRowClass = "SERV";
	var oDocRow = objDoc.createRow(sRowClass);
	oDocRow.setVar("RNMKL", oNmkServ.getCod());
	oDocRow.setVar("RSERV", FSERV.value);
	oDocRow.setVar("RBDAT", new Date(FBDAT.value).getVarDate());
	oDocRow.setVar("REDAT", d00);
	oDocRow.setVar("RKOL", 0);
	oDocRow.setVar("RBILL", true);
			
	objDoc.appendRow(sRowClass, oDocRow)
	obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpServTbl);
	
	grid_serv.getTable().requery();			
	grid_serv.getTable().findByID(oDocRow.getID());
	grid_serv.refresh();	
}

function add_sub()
{
	var sRowClass = "SUB";
	var sTmpTbl = grid_sub.getTable().getTableName();
	var oDocRow = objDoc.createRow(sRowClass);
	oDocRow.setVar("RNMKL", oNmkSub.getCod());
	oDocRow.setVar("RSUM", FSUBSUM.value);
	oDocRow.setVar("RBDAT", new Date(FBDAT.value).getVarDate());
	oDocRow.setVar("REDAT", d00);
			
	objDoc.appendRow(sRowClass, oDocRow)
	obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
	
	grid_sub.getTable().requery();			
	grid_sub.getTable().findByID(oDocRow.getID());
	grid_sub.refresh();
	
	calc_sub();
}

function calc_sub()
{
	//FSUB.value = getSubSum();
}

function getSubSum()
{
	var sTmpTbl = grid_sub.getTable().getTableName();
	var oSnap = getSnap("select sum(FSUM) as FSUM "
						+" from "+ sTmpTbl
						+" where FEDAT>="+ sqlTo(today)
							+" and (FBDAT<="+ sqlTo(today)+" or FBDAT>="+ sqlD00 +")"
						,false);
	if(oSnap && oSnap[0])
		return Number(oSnap[0]);
	return 0;
}

function onSave(isApply)
{
	objDoc.setVar("HID_DOG", oParDog.fwid);
	objDoc.setVar("HGRPID", oParDog.fwid);
	objDoc.setVar("HORG", oOrg.getCod());
	objDoc.setVar("HSTREET", oStreet.getFWID());
	objDoc.setVar("HHOUSE", oHouse.getFWID());
	objDoc.setVar("HAPMT", oApt.getFWID());
	objDoc.setVar("HEXTKOL", FLGTKOL.value);
	//objDoc.setVar("HSUB", FSUB.value);
	objDoc.setVar("HSUB", getSubSum());
	ctrlLinker.updateData(true);
	
	var recDate = recalcDate();
	
	storeToDb(sServTbl, sTmpServTbl);
	storeToDb(sGrantTbl, sTmpGrTbl);
	storeToDb(sSupTbl, sTmpSupTbl);
	storeToDb(sRefTbl, sTmpRefTbl);
	//storeToDb(sPayTbl, sTmpPayTbl);
	saveCounters();
	saveMen();
	
	//if(recDate)
	//	recalc(recDate);
	if(!isApply)
		exit();
}

function storeToDb(sTbl, sTmpTbl)
{
	ExecuteSQL("DELETE FROM ^"+ sTbl +" WHERE FID_DOG="+ objDoc.getID());
	var sFld = GetPatternIntersection(sTbl, sTbl);
	var sSql = "INSERT INTO ^"+ sTbl +"("+ sFld +")"
				+" SELECT "+ sFld +" FROM "+ sTmpTbl;
	ExecuteSQL(sSql);			
}

function recalcDate()
{
	var date = null;
	var oSnap = getSnap("select count(*) as cnt, min(t.FBDAT)"
						+" from "+ sTmpMenTbl +" t"
						+" left join ^SC_MEN m on m.FWID=t.FWID"
						+" where t.FBDAT<>m.FBDAT"
						);
	if(oSnap && Number(oSnap[0])>0)
	{
		oSnap = getSnap("select min(FDOC_DAT) from ^RAS_SKU where FID_DOG="+ objDoc.getID() +" and FDOC_DAT>="+ sqlTo(oSnap[1]));
		if(oSnap && oSnap[0])
			date = oSnap[0];
	}
	else
	{
		oSnap = getSnap("select count(*) as cnt, min(t.FEDAT)"
							+" from "+ sTmpMenTbl +" t"
							+" left join ^SC_MEN m on m.FWID=t.FWID"
							+" where t.FEDAT<>m.FEDAT"
							);
		if(oSnap && Number(oSnap[0])>0)
		{
			oSnap = getSnap("select min(FDOC_DAT) from ^RAS_SKU where FID_DOG="+ objDoc.getID() +" and FDOC_DAT>="+ sqlTo(oSnap[1]));
			if(oSnap && differ(oSnap[0], date)<0)
				date = oSnap[0];
		}
	}
	return date;
}

function recalc(recDate)
{	
	var sMsg = UR("Виконати перерахунок?|Выполнить перерасчет?");
	if(!confirm(sMsg))
		return true;
	var par = new Object();
	par.date = recDate;
	par.mode = "RECALC";
	par.org = oOrg.getCod();
	par.fid_dog = objDoc.getID();
	//par.tblCnt = sTmpCntTbl;
	par.tblMen = sTmpMenTbl;
	showWindow("e_sku.xml", SW_MODAL, par);
	return !par.escape;
}

function saveMen()
{
	storeToDb(sMenTbl, sTmpMenTbl);
	storeToDb(sPrivTbl, sTmpPrivTbl);
	ExecuteSQL("delete from ^"+ sPrivMenTbl +" where FID_DOG="+ objDoc.getID() 
				+" and not exists (select p.FWID from ^"+ sTmpPrivTbl +" p"
					+" where p.FWID=^"+ sPrivMenTbl +".FID_PRIV)"
				);
}

function saveCounters()
{
	storeToDb(sCntTbl, sTmpCntTbl);
	
	//регистрация стартовых показаний счетчиков
	var sSQL = "delete from ^COUNTERS "
				+" where FID_DOG="+ objDoc.getID()
					+" and FINIT="+ sqlTrue
					+" and FDIFFERENCE=0";
	ExecuteSQL(sSQL);
	
	sSQL = "INSERT INTO ^COUNTERS (FCOUNTER,FNUM,FTYPE,FSERIAL,FPLACE,FSERV"
					+",FID_DOG,FID_PAR,FORG,FNODE,FSTREET,FHOUSE,FAPMT"
					+",FDATE,FREGDATE,FYEAR,FMONTH,FCURRENT,FPREVIOUS,FDIFFERENCE,FINIT)"
				+" SELECT FWID,FNUM,FTYPE,FSERIAL,FPLACE,FSERV"
					+",FID_DOG,"+ oParDog.fwid +","+ oOrg.getCod() 
					+","+ oNode.getCod() +","+ oStreet.getFWID() 
					+","+ oHouse.getFWID() +","+ oApt.getFWID() 
					+",FBDAT,FBDAT,"+ sqlYear("FBDAT")+","+ sqlMonth("FBDAT")
					+",FINDICE,0,0,"+ sqlTrue
				+" FROM "+ sTmpCntTbl
				+" where FINDICE>0"
					+" and FID_CNT=0";
	ExecuteSQL(sSQL);
}

//грид для жильцов
function loadMen()
{		
	var sRowClass = "MEN";
	CreateTable(sTmpMenTbl, sMenTbl);
	var sFld = GetPatternIntersection(sMenTbl, sMenTbl);
	var nID = (extPar.mode=="COPY")? objDoc.nOldID : objDoc.getID();
	var sSQL = "INSERT INTO "+ sTmpMenTbl +"("+ sFld +")"
				+" SELECT "+ sFld +" FROM ^"+ sMenTbl
				+" WHERE FID_DOG="+ nID;	
	ExecuteSQL(sSQL);	
	
	ExecuteSQL("select m.FWID, pm.FID_MEN, p.FID_LG, p.FBDAT, p.FEDAT, p.FCONFIRMDAT"
				+" into "+ sTmpPrivMen 
				+" from "+ sTmpMenTbl +" m"
				+" inner join ^"+ sPrivMenTbl +" pm on pm.FID_MEN=m.FWID"
				+" inner join ^"+ sPrivTbl +" p on p.FWID=pm.FID_PRIV"
				+" where p.FBDAT<"+ sqlTo(today)
					+" and p.FEDAT>"+ sqlTo(today)
				);
	
	var tbl = OpenTable("m", "select *"
						+" from "+ sTmpMenTbl
						+" order by FCOD, FBDAT, FEDAT"
						);
	tbl.tie(sTmpPrivMen, "priv", "FWID", "FWID");
	//tbl.tie(sPrivMenTbl, "pm", "FID_MEN", "FWID");
	//tbl.tie(sTmpPrivTbl, "priv", "PRIV", "pm.FID_PRIV");
	tbl.tie("CLRELCLCL", "rel", "FWID_CL", "priv.FID_LG");
	tbl.tie("CL_EXEMPT", "cl", "FWID_CL", "priv.FID_LG");
	if(extPar.mode=="COPY")
		objDoc.resetFnids(tbl, sRowClass, objDoc);
	//browse("select * from "+ sTmpPrivMen)
	//browse("select * from "+ sTmpMenTbl)
	
	grid_men.setData("ROWCLASS", sRowClass);
	grid_men.setXMLDir(objDoc.getClassDefPath() + sRowClass +"/");
	grid_men.setXMLFile("list.xml");
	grid_men.setTable(tbl);
	grid_men.build();	
	
	calc_men();
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid_men.loadMenuHandler(this, "gridMenuInit");
	grid_men.selectMenuHandler(this, "gridMenuRun");	
}

//льготы
function loadPriv()
{		
	var sRowClass = "PRIV";
	
	CreateTable(sTmpPrivTbl, sPrivTbl);
	var sFld = GetPatternIntersection(sPrivTbl, sPrivTbl);
	var nID = (extPar.mode=="COPY")? objDoc.nOldID : objDoc.getID();
	var sSQL = "INSERT INTO "+ sTmpPrivTbl +"("+ sFld +")"
				+" SELECT "+ sFld +" FROM ^"+ sPrivTbl
				+" WHERE FID_DOG="+ nID;	
	ExecuteSQL(sSQL);	
	
	var tbl = OpenTable("m", "select * from "+ sTmpPrivTbl +" order by FCOD, FBDAT, FEDAT");
	tbl.tie("CL_EXEMPT", "cl", "FWID_CL", "FID_LG");
	tbl.tie(sTmpMenTbl, "men", "FWID", "FID_MEN");
	tbl.tie("CLRELCLCL", "rel", "FWID_CL", "FID_LG");
	if(extPar.mode=="COPY")
		objDoc.resetFnids(tbl, sRowClass, objDoc);
		
	grid_priv.setData("ROWCLASS", sRowClass);
	grid_priv.setXMLDir(objDoc.getClassDefPath() + sRowClass +"/");
	grid_priv.setXMLFile("list.xml");
	grid_priv.setTable(tbl);
	grid_priv.build();	
	
	calc_men();
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid_priv.loadMenuHandler(this, "gridMenuInit");
	grid_priv.selectMenuHandler(this, "gridMenuRun");	
}

//услуги
function loadServ()
{
	var sRowClass = "SERV";
	
	if(!ExecuteSQL("drop table "+ sTmpServTbl, false))
		ExecuteSQL("delete from "+ sTmpServTbl, false)	
	CreateTable(sTmpServTbl, sServTbl);
	
	var sFld = GetPatternIntersection(sServTbl, sServTbl);
	var nID = (extPar.mode=="COPY")? objDoc.nOldID : objDoc.getID();
	var sSQL = "INSERT INTO "+ sTmpServTbl +"("+ sFld +")"
				+" SELECT "+ sFld +" FROM ^"+ sServTbl
				+" WHERE FID_DOG="+ nID;	
	ExecuteSQL(sSQL);	
	/*
	var tbl = OpenTable("m", "select s.*, t.FCENA, "+ IIF("s.FNORM=0", "t.FNORM", "s.FNORM") +" as FNORMA"
						+" from "+ sTmpServTbl +" s"
						+" left join ^TARIF t on t.FNMKL=s.FNMKL"
							+" and t.FBDAT<="+ sqlTo(today) +" and t.FEDAT>="+ sqlTo(today)
						+" order by FEDAT, FSERV, FWID"
						);
	*/
	var tbl = OpenTable("m", "select * from "+ sTmpServTbl +" order by FINPUT, FEDAT, FSERV, FWID");
	tbl.tie("CL_NMK", "nmk", "FWID", "FNMKL");
	if(extPar.mode=="COPY")
		objDoc.resetFnids(tbl, sRowClass, objDoc);
	
	if(isVDK)
	{
		tbl.tie("CL_INPUT", "inp", "FWID", "FINPUT");
		grid_serv.FieldEx("=^FNORM==0? tnorm(^FSERV, ^FNMKL, ^FBDAT, ^FEDAT) : ^FNORM", "Норма|Норма", 8);
		grid_serv.FieldEx("=hnorm(^FSERV, ^FNMKL, ^FBDAT, ^FEDAT)", "Будинкова норма|Домовая норма", 8);
		grid_serv.FieldEx("=tcena(^FSERV, ^FNMKL, ^FBDAT, ^FEDAT)", "Тариф|Тариф", 8);
		grid_serv.FieldEx("=^FINPUT? ^inp.FCOD +' - '+ ^inp.FPLACE : ''", "Ввід|Ввод", 10);
	}
	
	grid_serv.setData("ROWCLASS", sRowClass);
	//grid_serv.setXMLDir(extPar.doc.getClassDefPath() + sRowClass +"/");
	//grid_serv.setXMLFile("list.xml");
	grid_serv.setTable(tbl);
	grid_serv.build();
			
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid_serv.loadMenuHandler(this, "gridMenuInit");
	grid_serv.selectMenuHandler(this, "gridMenuRun");
}

function tcena(serv, nmk, bdat, edat)
{
	var cena = "";
	var oSnap = getSnap("select FCENA"
						+" from ^TARIF"
						+" where FNMKL="+ nmk
							+" and FBDAT<="+ sqlTo(edat) 
							+" and FEDAT>="+ sqlTo(bdat)
						+" order by FEDAT desc"
						, false
						);
	if(oSnap && oSnap[0])
		cena = oSnap[0];
	return cena;
}

function hnorm(serv, nmk, bdat, edat)
{
	var norm = "";
	var oSnap = getSnap("select sum(FNORM)"
						+" from ^WATER where FHOUSE="+ oHouse.getFWID() 
							+" and FSERV="+ sqlTo(serv)
							+" and FBDAT<="+ sqlTo(today) 
							+" and FEDAT>="+ sqlTo(today)
						, false
						);
	if(oSnap && oSnap[0])
	{
		norm = oSnap[0];
	}
	return norm;
}

function tnorm(serv, nmk, bdat, edat)
{
	var norm = "";
	var oSnap = getSnap("select "+ IIF("s.FNORM=0", "t.FNORM", "s.FNORM") +" as FNORM"
						+" from "+ sTmpServTbl +" s"
						+" left join ^TARIF t on t.FNMKL=s.FNMKL"
						+" where s.FNMKL="+ nmk
							+" and s.FSERV="+ sqlTo(serv)
							+" and t.FBDAT<="+ sqlTo(today) 
							+" and t.FEDAT>="+ sqlTo(today)
						, false
						);
	if(oSnap && oSnap[0])
		norm = oSnap[0];
	return norm;
}

//грид для субсидий
function loadGrants()
{
	var sRowClass = "SUB";
	
	if(!ExecuteSQL("drop table "+ sTmpGrTbl, false))
		ExecuteSQL("delete from "+ sTmpGrTbl, false)	
	CreateTable(sTmpGrTbl, sGrantTbl);
	
	var sFld = GetPatternIntersection(sGrantTbl, sGrantTbl);
	var nID = (extPar.mode=="COPY")? objDoc.nOldID : objDoc.getID();
	var sSQL = "INSERT INTO "+ sTmpGrTbl +"("+ sFld +")"
				+" SELECT "+ sFld +" FROM ^"+ sGrantTbl
				+" WHERE FID_DOG="+ nID;	
	ExecuteSQL(sSQL);	
	
	var tbl = OpenTable("m", "select * from "+ sTmpGrTbl +" order by FNMKL");	
	tbl.tie("CL_NMK", "nmk", "FWID", "FNMKL");
	if(extPar.mode=="COPY")
		objDoc.resetFnids(tbl, sRowClass, objDoc);
	
	grid_sub.setData("ROWCLASS", sRowClass);
	grid_sub.setXMLDir(extPar.doc.getClassDefPath() + sRowClass +"/");
	grid_sub.setXMLFile("list.xml");
	grid_sub.setTable(tbl);
	grid_sub.build();
	
	calc_sub();
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid_sub.loadMenuHandler(this, "gridMenuInit");
	grid_sub.selectMenuHandler(this, "gridMenuRun");
}

function gridMenuInit(oGrid)
{
	var tbl = oGrid.getTable();
	var sRowClass = oGrid.getData("ROWCLASS");
	//if(sRowClass=="SERV")
	//	oGrid.AddMenuItem("LOADSERV", "Завантажити послуги|Загрузить услуги");
	if(sRowClass=="CNT" && oObject.getCod())
		oGrid.AddMenuItem("FILLCOUNTERS", "Завантажити лічильники|Загрузить счетчики");
	//if(sRowClass=="MEN" && tbl.getValue("FID_LG"))
	//	oGrid.AddMenuItem("CLOSEPRIV", "Закрити пільгу|Закрыть льготу");
	if(sRowClass=="PAY" && oOrg.getCod() && tbl.isEmpty())
		oGrid.AddMenuItem("LOADPAY", "Завантажити платника|Загрузить плательщика");
	oGrid.AddMenuItem("ADD", "Додати | Добавить");
	if (!tbl.isEmpty())
	{
		oGrid.AddMenuItem("EDIT", "Редагувати | Редактировать");
		oGrid.AddMenuItem("COPY", "Копіювати | Копировать");
		if(extPar.mode!="EDIT" || sRowClass=="PAY")
			oGrid.AddMenuItem("DEL", "Видалити | Удалить");
	}
}

function gridMenuRun(sID, oGrid)
{
	var sRowClass = oGrid.getData("ROWCLASS");
	var tbl = oGrid.getTable();
	var rowID = Number(tbl.getValue("FWID"));
	var sTmpTbl = tbl.getTableName();
	if(sRowClass=="SERV")
		sTmpTbl = sTmpServTbl;
	else if(sRowClass=="MEN")
		sTmpTbl = sTmpMenTbl;
		
	objDoc.setVar("HORG", oOrg.getCod());
	objDoc.setVar("HBDAT", FBDAT.value);
	objDoc.setVar("HEDAT", FEDAT.value);
	objDoc.setVar("HHOUSE", oHouse.getFWID());
	objDoc.setVar("HOBJECT", oObject.getCod());
	
	switch(sID)
	{
	case "LOADSERV":
		reLoadServ();
		break;
		
	case "FILLCOUNTERS":
		fillCounters();
		break;
	
	case "LOADPAY":
		var oDocRow = objDoc.createRow(sRowClass);
		oDocRow.setVar("RNUM", 1);
		oDocRow.setVar("RBDAT", FBDAT.value);
		oDocRow.setVar("REDAT", d00);
		oDocRow.setVar("RFIO", oOrg.getTxt());
		oDocRow.setVar("RADR", tforg("FADR", oOrg.getCod()));
		oDocRow.setVar("RTEL", oOrg.get2("FPHONE"));
		oDocRow.setVar("RIDENT", oOrg.get2("FCOD_NDS"));
		oDocRow.setVar("RPAS", oOrg.get2("FDOCSER") + oOrg.get2("FDOCNOM"));
		objDoc.appendRow(sRowClass, oDocRow)
		obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
		oGrid.getTable().requery();			
		oGrid.getTable().findByID(oDocRow.getID());
		oGrid.refresh();
		gridMenuRun("EDIT", oGrid);
		break;
		
	case "CLOSEPRIV":
		closePriv(tbl.getValue("FID_LG"), rowID);
		oGrid.getTable().requery();
		oGrid.refresh();
		break;	
	
	case "DEL":
		if(!__isRazv)
		{
			if(sRowClass=="CNT")
				alert(UR("Не можна вилучати лічильники!|Нельзя удалять счетчики!"));
			return true;
		}
		
		var sMsg = UR("Видалити запис?|Удалить запись?");
		if(!confirm(sMsg))
			return true;
		objDoc.deleteRow(sRowClass, rowID);
		//oGrid.getTable().Delete();
		ExecuteSQL("DELETE FROM "+ sTmpTbl +" WHERE FWID="+ rowID);
		oGrid.getTable().requery();
		oGrid.refresh();
		break;
		
	case "__XDEL":	//массовое удаление 
		if(!__isRazv)
			return true;
		var delRowCount = oGrid.getSelectedCount();
		if (delRowCount<=0)
			return;
		var selIds = oGrid.getSelectedIDs();
		var sCapt = ru("Удаление записей", "Видалення записів");
		var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів") +" ("+ delRowCount +").";
		if("c"==msgBox("c-", sMsg, sCapt))
			return;
		setProgressRange(0, delRowCount);		
		for (var nRow=0; nRow<selIds.length; nRow++)
		{
			setProgressPos(nRow + 1, sCapt +": "+ (nRow + 1) +"/"+ delRowCount);
			var rowID = Number(selIds[nRow]);
			objDoc.deleteRow(sRowClass, rowID);			
			ExecuteSQL("DELETE FROM "+ sTmpTbl +" WHERE FWID="+ rowID);				
		}		
		oGrid.clearSelected();
		oGrid.getTable().requery();
		oGrid.refresh();
		setProgressPos(0);
		break;

	case "ADD": case "EDIT": case "COPY":
		var oDocRow;
		if(sID == "ADD")
			oDocRow = objDoc.createRow(sRowClass);
		else if(sID == "EDIT")
			oDocRow = objDoc.getRow(sRowClass, rowID);
		else if(sID == "COPY")
			oDocRow = objDoc.copyRow(sRowClass, rowID);			
		
		var par = new Object();
		par.tblName = sTmpTbl;
		par.tblMen = sTmpMenTbl;
		var bOK = false;
		if(oDocRow)
			bOK = oDocRow.edit(sID, par);
		if (bOK)
		{
			if(inList(sID,"ADD","COPY"))
				objDoc.appendRow(sRowClass, oDocRow)
				
			obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
			
			oGrid.getTable().requery();			
			oGrid.getTable().findByID(oDocRow.getID());
			oGrid.refresh();			
		}
		break;
	}
			
	if(sRowClass=="MEN")
	{
		calc_men();
		grid_priv.getTable().requery();			
		grid_priv.refresh();
	}
	else if(sRowClass=="PRIV")
	{
		calc_priv();
		grid_men.getTable().requery();			
		grid_men.refresh();
	}
	else if(sRowClass=="SUB")
	{
		calc_sub();
	}
}

function fillCounters()
{
	var sRowClass = "CNT";
	var sTmpTbl = grid_cnt.getTable().getTableName();
	var objectID = oObject.getFWID();
	if(objectID)
	{
		var num = 1;
		var tbl = OpenTable("select * from ^CL_INPUT where FWID_CL="+ objectID +" and FISCOUNTER="+ sqlTrue);
		for(; !tbl.isEOF(); tbl.MoveNext())
		{
			var inputID = tbl.getValue("FWID");
			var oSnap = getSnap("select FWID from "+ sTmpTbl +" where FINPUT="+ inputID);
			if(oSnap)
				continue;
			var oDocRow = objDoc.createRow(sRowClass);
			oDocRow.setVar("RBDAT", tbl.getValue("FBDAT"));
			oDocRow.setVar("REDAT", tbl.getValue("FEDAT"));
			oDocRow.setVar("RSERV", tbl.getValue("FSERV"));
			oDocRow.setVar("RPLACE", tbl.getValue("FPLACE"));
			oDocRow.setVar("RDIAMETER", tbl.getValue("FDIAMETER"));
			oDocRow.setVar("RINPUT", inputID);
			oDocRow.setVar("RNUM", num++);
			objDoc.appendRow(sRowClass, oDocRow);
			obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
		}
	}
	grid_cnt.getTable().requery();
	grid_cnt.refresh();
}

function closePriv(privID)
{
	var date = input(UR("Дата закриття|Дата закрытия"), "", today);
	if(!date)
		return false;
	var sRowClass = "MEN";
	var tbl = OpenTable("select * from "+ sTmpMenTbl +" where FID_LG="+ privID +" and FEDAT>"+ sqlTo(date));
	for(; !tbl.isEOF(); tbl.MoveNext())
	{
		var menID = tbl.getValue("FWID");
		var bRet = ExecuteSQL("update "+ sTmpMenTbl +" set FEDAT="+ sqlTo(date) +" where FWID="+ menID);
		var oDocRow = objDoc.copyRow(sRowClass, menID);
		oDocRow.setVar("RBDAT", goday(date, 1));
		oDocRow.setVar("REDAT", d00);
		oDocRow.setVar("RLGID", 0);
		objDoc.appendRow(sRowClass, oDocRow);
		obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpMenTbl);
	}
	return true;
}

function getStreet()
{
	var streetID = 0;
	var sSql = "select FSTREET from ^cl_house where fwid_cl="+ oHouse.getFWID();
	var oHs = getSnap(sSql, false);
	if(oHs!=null)
		streetID = oHs[0];
	return streetID;
}

//отбор домов по указанной улице
function getWhereStreet()
{
	var sWhere = "";
	var streerID = oStreet.getFWID();
	if(streerID!=0 && streerID!=null)
		sWhere = "FWID_CL in (select fwid_cl from ^cl_house "
						+" where fstreet="+ streerID +")";
	return sWhere;
}

//отбор квартир по указанному дому
function getWhereHouse()
{
	var sWhere = "";
	var houseID = oHouse.getFWID();
	if(houseID!=0 && houseID!=null)
		sWhere = "FWID_CL in (select fwid_cl from ^cl_apartment "
						+" where fhouse="+ houseID +")";
	return sWhere;
}


function reLoadServ()
{
	if(!grid_serv.getTable().isEmpty())
	{
		var sMsg = UR("Перезавантажити послуги?|Перезагрузить услуги?");
		if(!confirm(sMsg))
			return;
	}
	fillServ();
}

function loadHouse()
{
	/*if(isVDK)
	{
		var oSnap = getSnap("select sum(FNORM+FNORM2)"
							+" from ^WATER where FHOUSE="+ oHouse.getFWID() 
								+" and FSERV='HWATER'"
								+" and FBDAT<="+ sqlTo(today) 
								+" and FEDAT>="+ sqlTo(today)
							, false);
		if(oSnap)
			FHNORM.value = oSnap[0];
	}*/
	fillHouseServ();
}

function fillHouseServ()
{
	if(extPar.mode!="ADD" || !grid_serv.getTable().isEmpty())
		return;
	var sSQL = "select count(*) from ^CL_APARTMENT where FHOUSE="+ oHouse.getFWID();
	var oSnap = getSnap(sSQL, false);
	if(oSnap && Number(oSnap[0])>0)
		return;
	fillServ(null, true);
}

function fillServ(oCtrl, bHouse)
{
	var oSnap = null;
	if(bHouse)
	{
		var sSQL = "select rel.FCOD, a.FNOM, a.FWID_CL, a.FTYPE"	
				+" from ^CL_HOUSE a "
				+" inner join ^CLRELCLCL rel on rel.FWID_CL=a.FWID_CL "
				+" where a.FWID_CL="+ oHouse.getFWID();
		oSnap = getSnap(sSQL, false);
	}
	else
	{
		FAREA.value = 0;
		FPROPERTY.value = 0;
		var curNom = oApt.getCod();
		var sWhere = " where a.fwid_cl="+ oApt.getFWID();
		if(oCtrl!=null && curNom!=0 && curNom!=null && curNom!="")
			sWhere = " where rel.fcod="+ sqlTo(curNom);
		var sSql = "select rel.fcod, a.fnom, a.fwid_cl, a.flivarea, a.FPROPERTY"	
					+" from ^cl_apartment a "
					+" inner join ^clrelclcl rel on rel.fwid_cl=a.fwid_cl "
					+ sWhere;
		oSnap = getSnap(sSql, false);	
		if(oSnap)
		{
			FAREA.value = oSnap[3];
			FPROPERTY.value = tcl("CL", "txt", getPar("CODPROP"), oSnap[15]);
		}
	}
	
	if(extPar.mode!="ADD" || !oSnap || !grid_serv.getTable().isEmpty())
		return;
	
	var sRowClass = "SERV";
	var clID = oApt.getFWID();
	if(bHouse)
		clID = oHouse.getFWID();
	var tbl = OpenTable("select * from ^CL_SERV where FWID_CL="+ clID);
	for(; !tbl.IsEOF(); tbl.MoveNext())
	{
		var oRow = objDoc.createRow(sRowClass);
		oRow.setVar("RSERV", tbl.getValue("FSERV"));
		oRow.setVar("RNMKL", tbl.getValue("FNMKL"));			
		oRow.setVar("RBDAT", FBDAT.value);
		oRow.setVar("REDAT", d00);
		oRow.setVar("RKOL", 0);
		oRow.setVar("RBILL", true);
		objDoc.appendRow(sRowClass, oRow);
		obj2DB(oRow.getID(), oRow.jDocRow, null, sTmpServTbl);
	}
	tbl.close();
	
	grid_serv.getTable().requery();
	grid_serv.refresh();
}

function currentVol(counter)
{
	var oSnap = getSnap("select FCURRENT from ^COUNTERS where FCOUNTER="+ counter +" order by FDATE DESC");
	if(oSnap)
		return oSnap[0];
	return 0;
}

function onExit()
{
	exit();
}

function exit()
{
	grid_serv.getTable().close();
	grid_men.getTable().close();
	grid_priv.getTable().close();
	grid_sub.getTable().close();
	grid_sup.getTable().close();
	grid_ref.getTable().close();
	//grid_pay.getTable().close();
	runInThread(dropTmp);
}

function dropTmp()
{
	ExecuteSQL("drop table "+ sTmpServTbl, false);
	ExecuteSQL("drop table "+ sTmpMenTbl, false);
	ExecuteSQL("drop table "+ sTmpPrivMen, false);
	ExecuteSQL("drop table "+ sTmpPrivTbl, false);
	ExecuteSQL("drop table "+ sTmpGrTbl, false);
	ExecuteSQL("drop table "+ sTmpSupTbl, false);
	ExecuteSQL("drop table "+ sTmpRefTbl, false);
	ExecuteSQL("drop table "+ sTmpPayTbl, false);
	ExecuteSQL("drop table "+ sTmpCntTbl, false);
}

include("sys\\DpBaseDlg.js");