include("Objects/DpJRegistrator.js");
include("Objects/DpGetDat.js");
include("Objects/DpCl.js");

loadFilter();
function loadFilter()
{
	GRGEK.setVisible(true);
	GRDOC.setVisible(false);
	
	list.oOrg = new DpCl("0", getPar("CODPLAT"), 0);
	list.oOrg.linkSmartCtrl(FPLAT);
	list.oOrg.setContAssist();
	list.oOrg.addFldSearchSmart("FOUTID");
	list.oOrg.isExactSearchSmart = true;
	if(getPar("VDKORGCAT")!=null)
		FPLATCAT.value = Number(getPar("VDKORGCAT"));
	if(extPar.orgcat!=null)
		FPLATCAT.value = Number(extPar.orgcat);
	setValid(FPLATCAT, orgcatValid);
	orgcatValid();
	if(extPar.org)
		list.oOrg.setCod(extPar.org);
	list.oOrg.AfterUpdate = filter;
	
	list.oNode = new DpCl("0");
	list.oNode.setClcl(getPar("CODNODE"));
	list.oNode.linkSmartCtrl(FNODE);
	list.oNode.setContAssist();
	//if(!getPar("CODNODE"))
		GRNODE.setVisible(false);
	//list.oNode.AfterUpdate = filter;
		
	list.oStreet = new DpCl("0");
	list.oStreet.setClcl(getPar("CODSTREET"));
	list.oStreet.linkSmartCtrl(FSTREET);
	list.oStreet.setContAssist();
	if(extPar.street)
		list.oStreet.setFWID(extPar.street);
	list.oStreet.AfterUpdate = filter;
	
	list.oHouse = new DpCl("0", getPar("CODHOUSE"), 0, list.oStreet);
	list.oHouse.linkSmartCtrl(FHOUSE);
	list.oHouse.setContAssist();
	list.oHouse.addFldSearchSmart("FNOM");
	list.oHouse.isExactSearchSmart = true;
	list.oHouse.isCodeSearchSmart = false;
	if(extPar.house)
		list.oHouse.setFWID(extPar.house);
	list.oHouse.AfterUpdate = filter;
	
	list.accDel = licscDel;
	
	grid.addAccel(GA_CTRL, "G", "SKU_REG_COUNTERS0");
	grid.addAccel(GA_CTRL, "Y", "SKU_CALC0");
}

function showLicPointView()
{
	var par = new Object();
	par.Fcl = getPar("CODPOINT");
	var view = lpProxy.getView("licpoint");
	if(view==null)
		lpProxy.showView("licpoint", "l_cl.xml", par);
	docRunViews();
}

function docRunViews()
{
	var view = lpProxy.getView("licpoint");
	if(view!=null)
	{
		var par = new Object();
		par.Fcl = getPar("CODPOINT");
		par.fid_dog = Number(list.tbl.getValue("FWID"));
		view.sendMessage("point", par);	
	}
}

function orgcatValid()
{
	if(FPLATCAT.value=="0" && getPar("VDKCODORG"))
		list.oOrg.setClcl(getPar("VDKCODORG"));
	else
		list.oOrg.setClcl(getPar("CODPLAT"));
}

function filter()
{
	list.qryWhere = currWhere();
	list.tblInit();
}

function listInitEditParam(oPar)
{
	oPar.node = list.oNode.getCod();
	oPar.org = list.oOrg.getCod();
	oPar.street = list.oStreet.getFWID();
	oPar.house = list.oHouse.getFWID();
	oPar.tbl = list.tbl;
	oPar.isApplyBtn = false;
}

function currWhere()
{
	var sWhere = "1=1";
	if(list.oNode.getCod())
		sWhere += " and FNODE="+ list.oNode.getCod();
	if(list.oOrg.getCod())
		sWhere += " and FORG="+ list.oOrg.getCod();
	if(list.oStreet.getCod())
		sWhere += " and FSTREET="+ list.oStreet.getFWID();
	if(list.oHouse.getCod())
		sWhere += " and FHOUSE="+ list.oHouse.getFWID();
	if(FPLATCAT.value && Number(FPLATCAT.value)!=2)
		sWhere += " and FCAT="+ Number(FPLATCAT.value);
	if(extPar.subWhere)
		sWhere += " and ("+ extPar.subWhere +")";
	return sWhere;
}

function docSrc()
{	
	this.qrySet("From","^LISTLICSC"
			, "Where", currWhere()
			, "Order", "FSTREET_TXT, FHOUSE_IND, FAPT_IND, FORG, FID_DOG"
			, "WhereArr", new Array("FCLOSE="+ sqlFalse, "FCLOSE<>"+ sqlFalse)
			, "WhereArrName", new Array("Відкриті|Окрытые","Закриті|Закрытые")
			//, "WhereArrI",0
			);
	this.subTie("CL_OWNER", "clowner", "FPROP", "FAPMT, ="+ sqlD00);
	this.clTie("owner", "=0, clowner.FORG", "owner");
	//this.clTie("prop", "="+ getPar('CODPROP') +", FPROPERTY", "prop");
	//this.clTie("par", "=0, FPAR_ORG", "par");
	if(getPar('CODORGOBJECT'))
		this.clTie("obj", "="+ getPar('CODORGOBJECT') +", FOBJECT", "obj");
	if(getPar('CODPOINT'))
		this.clTie("point", "="+ getPar('CODPOINT') +", FPOINT", "point");
}

function docMenuInit()
{
	var ds1 = this.dataSrc;
	var tbl = ds1.getTable();
	if(!tbl.isEmpty())
	{
		ds1.AddMenuItem("SHOWCLOSE", "Список відключених|Список отключенных");
		ds1.AddMenuItem("LOADSERV", "Завантажити послуги|Загрузить услуги");
		if(__isRazv)
			ds1.AddMenuItem("CALCMEN", "Порахувати кількість мешканців|Подсчитать количесвто жильцов");
		if(getSystem()=="VDK")
			ds1.AddMenuItem("LISTPOINT", "Точки підключення|Точки подключения");
		ds1.AddMenuItem("COUNTERS", "Показники лічильників|Показания счетчиков");
		ds1.AddMenuItem("BALANCE", "Баланс витрат по вузлу|Баланс расходов по узлу");
		ds1.AddMenuItem("SKUCALC", "Сформувати нарахування|Сформировать начисления");
		ds1.AddMenuItem("RECALC", "Перерахунок|Перерасчет");
		ds1.AddMenuItem("", "");
	}
}

function docMenuHandler(sID)
{
	var ds = this.dataSrc;
	var tbl = ds.getTable();
	if(sID=="LISTPOINT")
	{
		showLicPointView();
	}
	if(sID=="LOADSERV")
	{
		loadApartmentServ();
	}
	if(sID=="CALCMEN")
	{
		var date = sqlTo(today);
		var sWhere = "";
		if(grid.getSelectedCount()>0)
			sWhere = " where FID_DOG "+ grid.getSqlSelected(true);
		ExecuteSQL("update ^LICSC set FPERSKOL=(select count(*) from ^SC_MEN m"
					+" where m.FID_DOG=^LICSC.FID_DOG"
						+" and m.FBDAT<="+ date 
						+" and m.FEDAT>="+ date 
						+")"
					+ sWhere
					);
		ExecuteSQL("update ^LICSC set FEXTKOL=("
					+"select count(distinct m.FWID) as cnt from ^SC_MEN m"
						+" inner join ^SC_PRIVMEN pm on pm.FID_MEN=m.FWID"
						+" inner join ^SC_PRIV p on p.FWID=pm.FID_PRIV"
					+" where m.FID_DOG=^LICSC.FID_DOG"
						+" and m.FBDAT<="+ date 
						+" and m.FEDAT>="+ date 
						+" and p.FBDAT<="+ date 
						+" and p.FEDAT>="+ date 
						+")"
					+ sWhere
					);
		list.tbl.requery();
		grid.refresh();
	}
	if(sID=="COUNTERS")
	{
		var par = new Object();		
		par.org = tbl.getValue("FORG");
		par.fid_dog = tbl.getValue("FID_DOG");
		par.street = list.tbl.getValue("FSTREET");
		par.house = list.tbl.getValue("FHOUSE");
		showWindow("l_counters.xml", SW_NOMODAL, par);
		return true;
	}
	if(sID=="BALANCE")
	{
		var par = new Object();
		par.mode = sID;
		//par.org = tbl.getValue("FORG");
		par.node = tbl.getValue("FNODE");
		//par.fid_dog = tbl.getValue("FID_DOG");
		par.fid_par = Number(tbl.getValue("FID_PAR"));
		par.street = list.tbl.getValue("FSTREET");
		par.house = list.tbl.getValue("FHOUSE");
		showWindow("reg_counters.xml", SW_MODAL, par);
	}
	if(sID=="SKUCALC")
	{
		var par = new Object();		
		par.org = tbl.getValue("FORG");
		par.fid_dog = tbl.getValue("FID_DOG");
		//par.street = list.tbl.getValue("FSTREET");
		//par.house = list.tbl.getValue("FHOUSE");
		par.mode = "ADD";	
		showWindow("e_sku.xml", SW_MODAL, par);
	}
	if(sID=="RECALC")
	{
		//var recDate = input(UR("Дата початку|Дата начала"), UR("Перерахунок|Перерасчет"), today);
		//if(!recDate)
		//	return;
		var par = new Object();
		par.date = today;
		par.mode = "RECALC";
		par.org = tbl.getValue("FORG");
		par.fid_dog = tbl.getValue("FID_DOG");
		showWindow("e_sku.xml", SW_MODAL, par);
	}
	if(sID=="SHOWCLOSE")
	{
		var oSnap = getSnap("select count(*) as cnt from ^LISTLICSC where FCLOSE="+ sqlTrue);
		if(!oSnap || Number(oSnap[0])==0)
		{
			alert(UR("Немає відключених абонентів!|Нет отключенных абонентов!"));
			return;
		}
		var par = new Object();
		par.doc = "LICSC";
		par.nop = 1;
		par.bdat = getPar("GLOBDAT1");;
		par.edat = getPar("GLOBDAT2");
		showWindow("e_period.xml", SW_MODAL, par);
		if(par.escape)
			return;
		par.subWhere = " FCLOSE="+ sqlTrue +" and FCLOSE_DATE between "+ sqlTo(par.bdat) +" and "+ sqlTo(par.edat);
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
}

function onAfterEdit(oDoc, sMode)
{
	/*
	var grpID = Number(oDoc.getVar("HGRPID"));
	var par = new Object();
	par.fwidField = "FID_DOG";
	updateTreeKeys("^LICSC", oDoc.getID(), new Array("FID_DOG"), par);
	if(grpID>0)
		ExecuteSQL("update ^LICSC set FISGRP="+ sqlTrue +" where FID_DOG="+ grpID);
	*/
}

function isSubsid(dogID, sServ)
{
	var oSnap = getSnap("select count(*) as cnt"
						+" from ^SC_GRANTS"
						+" where FID_DOG="+ dogID 
							+(sServ? " and FSERV="+ sqlTo(sServ) : "")
						,false
						);
	if(oSnap && Number(oSnap[0])>0)
		return true;
	return false;
}

function isServ(dogID, sServ)
{
	var oSnap = getSnap("select FNMKL"
						+" from ^SC_SERV "
						+" where FID_DOG="+ dogID
							+" and FSERV="+ sqlTo(sServ)
							+" and FBDAT<="+ sqlTo(today)
							+" and FEDAT>="+ sqlTo(today)
						, false
						);
	if(oSnap)
		return true;
	return false;
}

function loadApartmentServ()
{
	var ds = list.dataSrc;
	var tbl = ds.getTable();
	var rowCount = 1;
	if(ds.getSelectedCount()>1)
		rowCount = ds.getSelectedCount();
	var sWhere = "FID_DOG="+ tbl.getRowID();
	if(rowCount>1)
		sWhere = "FID_DOG "+ ds.getSqlSelected(true);
	var oSnap = getSnap("select count(*) as cnt from ^SC_SERV where "+ sWhere);
	if(oSnap && Number(oSnap[0])>0)
	{
		var sMsg = UR("Для виділених особових рахунків ("+ rowCount +")"
						+" будуть перезавантажені усі послуги із квартир."
						+"\nПродовжити?"
					+"|Для выделенных лицевых счетов ("+ rowCount +")"
						+" будут перезагружены все услуги из квартир."
						+"\nПродолжить?"
					);
		if(!confirm(sMsg, UR("Увага!|Внимание!")))
			return;
	}
	
	var sTmpLicTbl = getTmpTableName();
	ExecuteSQL("create table "+ sTmpLicTbl 
				+" (FWID "+ sqlType("COUNTER") 
				+", FID_DOG "+ sqlType("LONG")
				+", FAPMT "+ sqlType("LONG")
				+", FBDAT "+ sqlType("DATE") +")"
				);
	createIndex(sTmpLicTbl, "FID_DOG", "FID_DOG");
	createIndex(sTmpLicTbl, "FAPMT", "FAPMT");
	ExecuteSQL("insert into "+ sTmpLicTbl +" (FID_DOG, FAPMT, FBDAT)"
				+" select l.FID_DOG, l.FAPMT, c.FBDAT"
				+" from ^LICSC l inner join ^CONTRACT c on c.FWID=l.FID_DOG"
				+" where l."+ sWhere
				);
	
	var sTmpServ = getTmpTableName();
	var sSQL = "create table "+ sTmpServ 
				+" (FSERV "+ sqlType("TEXT", 25)
				+", FNMKL "+ sqlType("LONG")
				+", FKOL "+ sqlType("DOUBLE") +" default 0"
				+", FID_DOG "+ sqlType("LONG")
				+", FBDAT "+ sqlType("DATE")
				+", FWID "+ sqlType("COUNTER") +")"
	ExecuteSQL(sSQL);
	//addCounter(sTmpServ, "FWID", GetUID());
		
	ExecuteSQL("insert into "+ sTmpServ +" (FSERV, FNMKL, FID_DOG, FBDAT, FKOL)"
				+" select 'SUBSERV' as FSERV, s.FNMKL, l.FID_DOG, l.FBDAT, 1"
				+" from ^CL_SERV s "
				+" inner join "+ sTmpLicTbl +" l on l.FAPMT=s.FWID_CL"
				);
	ExecuteSQL("insert into "+ sTmpServ +" (FSERV, FNMKL, FID_DOG, FBDAT)"
				+" select 'RENT' as FSERV, s.FRENT, l.FID_DOG, l.FBDAT"
				+" from ^CL_APARTMENT s "
				+" inner join "+ sTmpLicTbl +" l on l.FAPMT=s.FWID_CL"
					+" where s.FRENT>0"
				);
	ExecuteSQL("insert into "+ sTmpServ +" (FSERV, FNMKL, FID_DOG, FBDAT)"
				+" select 'HEAT' as FSERV, s.FHEAT, l.FID_DOG, l.FBDAT"
				+" from ^CL_APARTMENT s "
				+" inner join "+ sTmpLicTbl +" l on l.FAPMT=s.FWID_CL"
					+" where s.FHEAT>0"
				);
	ExecuteSQL("insert into "+ sTmpServ +" (FSERV, FNMKL, FID_DOG, FBDAT)"
				+" select 'CWATER' as FSERV, s.FCWATER, l.FID_DOG, l.FBDAT"
				+" from ^CL_APARTMENT s "
				+" inner join "+ sTmpLicTbl +" l on l.FAPMT=s.FWID_CL"
					+" where s.FCWATER>0"
				);
	ExecuteSQL("insert into "+ sTmpServ +" (FSERV, FNMKL, FID_DOG, FBDAT)"
				+" select 'HWATER' as FSERV, s.FHWATER, l.FID_DOG, l.FBDAT"
				+" from ^CL_APARTMENT s "
				+" inner join "+ sTmpLicTbl +" l on l.FAPMT=s.FWID_CL"
					+" where s.FHWATER>0"
				);
	ExecuteSQL("insert into "+ sTmpServ +" (FSERV, FNMKL, FID_DOG, FBDAT)"
				+" select 'DRAIN' as FSERV, s.FWREMOVAL, l.FID_DOG, l.FBDAT"
				+" from ^CL_APARTMENT s "
				+" inner join "+ sTmpLicTbl +" l on l.FAPMT=s.FWID_CL"
					+" where s.FWREMOVAL>0"
				);
	ExecuteSQL("insert into "+ sTmpServ +" (FSERV, FNMKL, FID_DOG, FBDAT)"
				+" select 'GAS' as FSERV, s.FGAS, l.FID_DOG, l.FBDAT"
				+" from ^CL_APARTMENT s "
				+" inner join "+ sTmpLicTbl +" l on l.FAPMT=s.FWID_CL"
					+" where s.FGAS>0"
				);
	ExecuteSQL("insert into "+ sTmpServ +" (FSERV, FNMKL, FID_DOG, FBDAT)"
				+" select 'ELECTRIC' as FSERV, s.FELECTRIC, l.FID_DOG, l.FBDAT"
				+" from ^CL_APARTMENT s "
				+" inner join "+ sTmpLicTbl +" l on l.FAPMT=s.FWID_CL"
					+" where s.FELECTRIC>0"
				);
	ExecuteSQL("insert into "+ sTmpServ +" (FSERV, FNMKL, FID_DOG, FBDAT)"
				+" select 'RADIO' as FSERV, s.FRADIO, l.FID_DOG, l.FBDAT"
				+" from ^CL_APARTMENT s "
				+" inner join "+ sTmpLicTbl +" l on l.FAPMT=s.FWID_CL"
					+" where s.FRADIO>0"
				);
	ExecuteSQL("insert into "+ sTmpServ +" (FSERV, FNMKL, FID_DOG, FBDAT)"
				+" select 'OTHER' as FSERV, s.FOTHER, l.FID_DOG, l.FBDAT"
				+" from ^CL_APARTMENT s "
				+" inner join "+ sTmpLicTbl +" l on l.FAPMT=s.FWID_CL"
					+" where s.FOTHER>0"
				);
	
	var oSnap = getSnap("select count(*) as cnt from "+ sTmpServ);
	if(oSnap && Number(oSnap[0])>0)
	{
		GetUID(false, Number(oSnap[0]));
		oSnap = getSnap("select max(FWID) as FWID from ^SC_SERV");
		if(oSnap && Number(oSnap[0]))
			ExecuteSQL("update "+ sTmpServ +" set FWID=FWID+"+ oSnap[0]);
	}
	else
	{
		sMsg = UR("Немає послуг для завантаження!|Нет услуг для загрузки!");
		alert(sMsg);
		return;
	}	
	
	ExecuteSQL("drop table TMP_SC_SERV", false);
	ExecuteSQL("select * into TMP_SC_SERV from ^SC_SERV where "+ sWhere);
	ExecuteSQL("delete from ^SC_SERV where "+ sWhere);
	ExecuteSQL("insert into ^SC_SERV (FID_DOG, FBDAT, FSERV, FNMKL, FKOL, FWID, FBILL)"
				+" select FID_DOG, FBDAT, FSERV, FNMKL, FKOL, FWID, "+ sqlTrue 
				+" from "+ sTmpServ
				);
	ExecuteSQL("drop table "+ sTmpLicTbl);
	ExecuteSQL("drop table "+ sTmpServ);
}

function licscDel(fid_doc)
{
	if(__isRazv)
		return true;
	return false;
}

function docFilterMode(sID)
{
	if(sID=="DEL" || sID=="XDEL" || sID=="__XDEL")
		return licscDel(); 
	return true;
}
