include("Objects/DpCtrlLinker.js");
include("Objects/DpCl.js");

var objDoc = null;
var sRowTbl = "RML";
var sActTbl = "MLACT";
var sRespTbl = "RESPONSE";
var sTmpTbl = getTmpTableName();
var sTmpAct = getTmpTableName();
var sTmpResp = getTmpTableName();
var oManager;

function Load()
{	
   	objDoc = extPar.doc;
   	//Caption(objDoc.getCaption() +": "+ modeName(extPar.mode));
	FORM.setImage(rootDirectoryEx() +"/icons/notebook 3.gif");
	
	oManager = new DpCl("0", getPar("CODPERS"), 0);
	oManager.linkSmartCtrl(FMANAGER);
	oManager.setContAssist();
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM", FDOC_NUM);
	ctrlLinker.addLink("HDAT", FDOC_DAT);
	ctrlLinker.addLink("HEDAT", FEDAT);
	ctrlLinker.addLink("HTXT", FTXT);
	ctrlLinker.addLink("HREM", FREM);
	ctrlLinker.addLink("HSTATE", FSTATE);
	ctrlLinker.addClLink("HMANAGER", oManager);
	ctrlLinker.updateData(false);
	
	if(extPar.mode=="ADD")
	{
		FEDAT.value = d00;
		oManager.setCod(getPersCod(getUserName()));
	}
	
	FORGCOUNT.mask = "#########";
	FACTCOUNT.mask = "#########";
	FEXECOUNT.mask = "#########";
	FRESPONSECOUNT.mask = "#########";
	FNEGATIVECOUNT.mask = "#########";
	
	Disable(FORGCOUNT);
	Disable(FACTCOUNT);
	Disable(FEXECOUNT);
	Disable(FRESPONSECOUNT);
	Disable(FNEGATIVECOUNT);
	
	setWhen(FORGCOUNT, showOrgs);
	setWhen(FACTCOUNT, showActs);
	setWhen(FEXECOUNT, showActs);
	setWhen(FRESPONSECOUNT, showResponses);
	setWhen(FNEGATIVECOUNT, showResponses);
	
	loadOrgs();
	gridInit();
	
	loadAct();
	loadResponse();
	
	calcRows();
}

function showOrgs()
{
	TAB.setSelection(0);
}

function showActs()
{
	TAB.setSelection(1);
}

function showResponses()
{
	TAB.setSelection(2);
}

function loadOrgs()
{
	CreateTable(sTmpTbl, sRowTbl, "FWID");
	var sFLD = GetPatternIntersection(sRowTbl, sRowTbl);
	var nID = (extPar.mode == "COPY") ? extPar.doc.nOldID : extPar.doc.getID();	
	if(extPar.mode=="ADD")
	{
		if(extPar && extPar.arrOrg)
			loadRows();
	}
	else
	{
		var sSQL = "insert into "+ sTmpTbl +"("+ sFLD +")"
				   +" select "+ sFLD
				   +" from ^"+ sRowTbl
				   +" where FID_DOC="+ nID;
		ExecuteSQL(sSQL);
	}
}

function gridInit()
{	
	var tbl = OpenTable("m", "select cl.*, t.FWID as FID, t.FORG, t.FID_DOC"
						+" from "+ sTmpTbl +" t"
						+" inner join ^LISTCLORG cl on cl.FCOD=t.FORG and cl.FCL=0"
						+" order by t.FORG"
						);
	//clTie(tbl, "cl", "=0, FORG");
	if(extPar.mode=="COPY")
		objDoc.resetFnids(tbl, "ROW", objDoc);
	grid.setTable(tbl);
	/*
	include ("objects/DpXMLDomDocument.js");
	var xmlDom = new DpXMLDOMDocument();
	xmlDom.load(rootDirectory() +"cls/CL2/list.xml");
    var root = xmlDom.getDocumentElement();
    var xmlGrid = root.getElementsByTagName("grid")[0];	
	grid.parseXML(xmlGrid.xmlNode);
	*/
	grid.setXMLDir(rootDirectory() +"docs/ML/ROW/");
	grid.setXMLFile("list.xml");
	grid.build();
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid.loadMenuHandler(this, "gridMenuInit");
	grid.selectMenuHandler(this, "gridMenuRun");
}

function loadRows()
{
	var sCLs = "";
	var codPlat = getPar("CODPLAT");	
	if(extPar.nCL!=null)
	{
		sCLs = String(extPar.nCL);
	}
	else if(codPlat!=0)
	{
		sCLs = codPlat;
	}
	else
	{
		var oSnap = getSnap("select count(*) from ^CLCL "
							+" where FVID='2'"
								+" and FCOD<>"+ sqlTo(getPar("CODMYORG"))
							);
		if(oSnap && Number(oSnap[0])==1)
		{
			oSnap = getSnap("select FCOD from ^CLCL where FVID='2' and FCOD<>"+ sqlTo(getPar("CODMYORG")));
			if(oSnap)
				sCLs = oSnap[0];
		}
	}	
	if(sCLs=="")
	{
		var par = new Object();
		par.title = UR("Виберіть довідник|Выберите справочник");
		par.sWhere = "FVID=2";
		par.ret = new Object();
		par.ret.FCOD = 0;
		showWindow("l_clcl.js", SW_MODAL, par);
		if(!par.escape)
		{
			if(par.retArray)
			{
				for(var i=0; i<par.retArray.length; i++)
				{
					sCLs += ","+ par.retArray[i].FCOD;
				}
			}
			if(par.ret.FCOD)
			{
				sCLs += ","+ par.ret.FCOD;
			}
			if(sCLs!="")
				sCLs = sCLs.substring(1);
		}
	}
	if(sCLs=="")
		sCLs = "-999";
	var sWhere = "where FCL in ("+ sCLs +")";	
	if(extPar && extPar.arrOrg)
		sWhere += "and FWID_CL in ("+ extPar.arrOrg +")";
	else
		sWhere += "and FWID_CL>0";
	var tblCl = OpenTable("select * from ^CLRELCLCL "+ sWhere);
	if(tblCl.isEmpty())
		return;
	var sRowClass = "ROW";
	var sPr = UR("Завантажуються рядки: |Загружаются строки: ");
	var nPr = 0;	
	setProgressRange(0, tblCl.recordCount);	
	while (!tblCl.IsEOF())
	{
		setProgressPos(++nPr, sPr + nPr +"/"+ tblCl.recordCount);
		var oRow = objDoc.createRow(sRowClass);
		oRow.setVar("RNOM", tblCl.getValue("FCOD"));
		oRow.setVar("RORG", tblCl.getValue("FCOD"));
		objDoc.appendRow(sRowClass, oRow);
		obj2DB(oRow.getID(), oRow.jDocRow, null, sTmpTbl);
		tblCl.MoveNext();
	}
	setProgressPos(0);
}

function gridMenuInit()
{
	if(!grid.getTable().isEmpty())
	{
		if(IsDblClick())
		{
			gridMenuRun("FULLINFO", grid);
			return false;
		}
		grid.AddMenuItem("FULLINFO", "Зведена інформація|Сводная информация");
		grid.AddMenuItem("", "");
		grid.AddMenuItem("RESPONSE", "Додати відгук|Добавить отклик");
		grid.AddMenuItem("FORMDOCS", "Створити документи для усіх|Создать документы для всех");
		var nSelRows = grid.getSelectedCount();
		grid.AddMenuItem("FORMDOCS_SEL", "Створити документи для відмічених ("+nSelRows+")|Создать документы для отмеченных ("+nSelRows+")", nSelRows==0);
	}
	grid.AddMenuItem("", "");
	grid.AddMenuItem("ADD", "Додати|Добавить");
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("DEL", "Видалити|Удалить");		
	}
}

function gridMenuRun(sID, oGrid)
{
	var sRowClass = "ROW";
	var tbl = oGrid.getTable();
	var sTable = tbl.getTableName();
	var rowID = Number(tbl.getValue("FID"));
	if(sID=="FULLINFO")
	{
		var par =  new Object()
		par.org = tbl.getValue("FORG");	
		par.Fcl = 0;	
		//par.grid = grid;
		showWindow("l_cl_info.xml", SW_MODAL, par);
		if(!par.escape)
		{
			oGrid.getTable().requery();			
			oGrid.getTable().findByID(rowID);
			oGrid.refresh();
		}
	}
	else if(sID=="RESPONSE")
	{
		var par = new Object();
		par.org = tbl.getValue("FORG");
		editResponse("ADD", null, par);
	}
	else if(sID=="FORMDOCS" || sID=="FORMDOCS_SEL")
	{
		include("docs/ML/list.js");
		var sWhere = "";
		if(sID=="FORMDOCS_SEL")
			sWhere = " where cl."+ oGrid.getSqlSelected();
		var tblRows = OpenTable("select * from "+ sTable + sWhere);
		var nop = Number(extPar.doc.nNop);
		var fid_doc = extPar.doc.getID();
		var txt = FDOC_NUM.value +": "+ FTXT.value;
		var mainDoc = formDocs(tblRows, fid_doc, nop, txt, false, true);
		if(!mainDoc)
			return;
		
		var oRow = objDoc.createRow("ACT");
		oRow.setVar("HDAT", new Date().getVarDate());
		oRow.setVar("HEDAT", d00);
		oRow.setVar("HACT", mainDoc.sDocLbl);
		oRow.setVar("HTXT", mainDoc.getName());
		var manager = getPersCod(getUserName());
		if(!manager)
			manager = oManager.getCod();
		oRow.setVar("HMANAGER", manager);
		objDoc.appendRow("ACT", oRow);
		obj2DB(oRow.getID(), oRow.jDocRow, null, sTmpAct);
		
		grid_act.getTable().requery();			
		grid_act.refresh();
	}
	else if(sID == "ADD")
	{
		var par = new Object();
		par.Fvid = 2;
		par.Fcl = 0;
		par.ret = new Object();
		par.ret.FCOD = 0;
		showWindow("l_cl.xml", SW_MODAL, par);
		if(par.escape)
			return;		
		var oDocRow = null;
		if(par.retArray)
		{
			for(var i=0; i<par.retArray.length; i++)
			{
				var cod = par.retArray[i].FCOD;
				var oSnap = getSnap("select FWID from "+ sTmpTbl +" where FORG="+ cod);
				trace(">>> "+ cod +" > "+ (oSnap))
				if(oSnap)
					continue;
				oDocRow = objDoc.createRow(sRowClass);
				oDocRow.setVar("RNOM", cod);
				oDocRow.setVar("RORG", cod);
				objDoc.appendRow(sRowClass, oDocRow);
				obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
			}
		}
		
		if(par.ret.FCOD)
		{
			var cod = par.ret.FCOD;
			var oSnap = getSnap("select FWID from "+ sTmpTbl +" where FORG="+ cod);
			if(!oSnap)
			{
				oDocRow = objDoc.createRow(sRowClass);
				oDocRow.setVar("RNOM", cod);
				oDocRow.setVar("RORG", cod);
				objDoc.appendRow(sRowClass, oDocRow);
				obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
			}
		}
		oGrid.getTable().requery();			
		if(oDocRow)
			oGrid.getTable().findByID(oDocRow.getID());
		oGrid.refresh();
		calcRows();
	}
	else if(sID == "DEL")
	{
		var sMsg = UR("Видалити запис?|Удалить запись?");
		if(!confirm(sMsg))
			return true;
		extPar.doc.deleteRow(sRowClass,	rowID);
		ExecuteSQL("DELETE FROM "+ sTmpTbl +" WHERE FWID="+ rowID);
		//oGrid.getTable().Delete();
		oGrid.getTable().requery();
		oGrid.refresh();
		calcRows();
	}
	else if(sID == "__XDEL")
	{
		var delRowCount = oGrid.getSelectedCount();
		if (delRowCount<=0)
			return;
		var selIds = oGrid.getSelectedIDs();
		var sCapt = ru("Удаление записей", "Видалення записів");
		var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів") +" ("+ delRowCount +").";
		if("c"==msgBox("c-", sMsg, sCapt))
			return;
		setProgressRange(0, delRowCount);		
		for (var nRow=0; nRow<selIds.length; nRow++)
		{
			setProgressPos(nRow + 1, sCapt +": "+ (nRow + 1) +"/"+ delRowCount);
			var rowID = Number(selIds[nRow]);
			objDoc.deleteRow(sRowClass, rowID);			
			ExecuteSQL("DELETE FROM "+ sTmpTbl +" WHERE FWID="+ rowID);				
		}		
		oGrid.clearSelected();
		oGrid.getTable().requery();
		oGrid.refresh();
		calcRows();
		setProgressPos(0);
	}
}

function onSave()
{
	ctrlLinker.updateData(true);
	saveRows();
	ExecuteSQL("drop table "+ sTmpTbl, false);
}

function saveRows()
{
	ExecuteSQL("delete from ^"+ sRowTbl +" where FID_DOC="+ objDoc.getID());
	var sFLD = GetPatternIntersection(sRowTbl, sRowTbl);
	ExecuteSQL("insert into ^"+ sRowTbl +" ("+ sFLD +")"
			  +" select "+ sFLD +" from "+ sTmpTbl
			  );
			  
	ExecuteSQL("delete from ^"+ sActTbl +" where FID_DOC="+ objDoc.getID());
	var sFLD = GetPatternIntersection(sActTbl, sActTbl);
	ExecuteSQL("insert into ^"+ sActTbl +" ("+ sFLD +")"
			  +" select "+ sFLD +" from "+ sTmpAct
			  );
}


function loadAct()
{
	CreateTable(sTmpAct, sActTbl, "FWID");
	var sFLD = GetPatternIntersection(sActTbl, sActTbl);
	var nID = (extPar.mode == "COPY") ? extPar.doc.nOldID : extPar.doc.getID();	
	var sSQL = "insert into "+ sTmpAct +"("+ sFLD +")"
			   +" select "+ sFLD
			   +" from ^"+ sActTbl
			   +" where FID_DOC="+ nID;
	ExecuteSQL(sSQL);
	
	var tbl = OpenTable("m", "select * "
						+" from "+ sTmpAct
						+" order by FBDAT, FEDAT, FWID"
						);
	clTie(tbl, "cl", "=getPar('CODPERS'), FMANAGER");
	if(extPar.mode=="COPY")
		objDoc.resetFnids(tbl, "ACT", objDoc);
	grid_act.setTable(tbl);
	grid_act.build();
	
	this.gridActMenuInit = gridActMenuInit;
	this.gridActMenuRun = gridActMenuRun;
	grid_act.loadMenuHandler(this, "gridActMenuInit");
	grid_act.selectMenuHandler(this, "gridActMenuRun");
}

function gridActMenuInit()
{
	if(!grid_act.getTable().isEmpty())
	{
		if(IsDblClick(grid_act))
		{
			gridActMenuRun("EDIT", grid_act);
			return false;
		}
		grid_act.AddMenuItem("RUN", "Виконати|Выполнить");
		grid_act.AddMenuItem("","");
	}
	grid_act.AddMenuItem("ADD","Додати|Добавить");
	if (!grid_act.getTable().isEmpty())
	{
		grid_act.AddMenuItem("EDIT", "Редагувати|Редактировать");
		grid_act.AddMenuItem("COPY", "Копіювати|Копировать");
		grid_act.AddMenuItem("DEL", "Видалити|Удалить");		
	}
}

function gridActMenuRun(sID, oGrid)
{
	var sRowClass = "ACT";
	var tbl = oGrid.getTable();
	var sTable = tbl.getTableName();
	var rowID = Number(tbl.getValue("FWID"));
	if(sID == "RUN")
	{
		var act = String(tbl.getValue("FACT")).trim();
		if(act!="")
		{
			var sMsg = UR("Сформувати документи для усіх контрагентів?|Сформировать документы для всех контрагентов?");
			if(confirm(sMsg))
			{
				include("docs/ML/list.js");				
				var tblRows = OpenTable("select * from "+ sTmpTbl);
				var nop = Number(extPar.doc.nNop);
				var fid_doc = extPar.doc.getID();
				var txt = FDOC_NUM.value +": "+ FTXT.value;
				formDocs(tblRows, fid_doc, nop, txt, false, false, act);				
			}
		}
		var oDocRow = objDoc.getRow(sRowClass, rowID);
		oDocRow.setVar("HSTATE", 2);
		//oDocRow.save();
		obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpAct);		
		oGrid.getTable().requery();			
		oGrid.getTable().findByID(oDocRow.getID());
		oGrid.refresh();
		calcRows();
	}
	else if(sID=="ADD" || sID=="EDIT" || sID=="COPY")
	{
		var oDocRow;
		if(sID == "ADD")
			oDocRow = objDoc.createRow(sRowClass);
		else if(sID == "EDIT")
			oDocRow = objDoc.getRow(sRowClass, rowID);
		else if(sID == "COPY")
			oDocRow = objDoc.copyRow(sRowClass, rowID);
		var par = new Object();
		par.manager = oManager.getCod();
		var bRet = oDocRow.edit(sID, par);
		if(!bRet)
			return;
		if(inList(sID, "ADD", "COPY"))
			objDoc.appendRow(sRowClass, oDocRow);
		obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpAct);		
		oGrid.getTable().requery();			
		oGrid.getTable().findByID(oDocRow.getID());
		oGrid.refresh();
		calcRows();
	}
	else if(sID == "DEL")
	{
		var sMsg = UR("Видалити запис?|Удалить запись?");
		if(!confirm(sMsg))
			return true;
		extPar.doc.deleteRow(sRowClass,	rowID);
		ExecuteSQL("DELETE FROM "+ sTmpAct +" WHERE FWID="+ rowID);		
		oGrid.getTable().requery();
		oGrid.refresh();
		calcRows();
	}
	else if(sID == "__XDEL")
	{
		var delRowCount = oGrid.getSelectedCount();
		if (delRowCount<=0)
			return;
		var selIds = oGrid.getSelectedIDs();
		var sCapt = ru("Удаление записей", "Видалення записів");
		var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів") +" ("+ delRowCount +").";
		if("c"==msgBox("c-", sMsg, sCapt))
			return;
		setProgressRange(0, delRowCount);		
		for (var nRow=0; nRow<selIds.length; nRow++)
		{
			setProgressPos(nRow + 1, sCapt +": "+ (nRow + 1) +"/"+ delRowCount);
			var rowID = Number(selIds[nRow]);
			objDoc.deleteRow(sRowClass, rowID);			
			ExecuteSQL("DELETE FROM "+ sTmpAct +" WHERE FWID="+ rowID);				
		}		
		oGrid.clearSelected();
		oGrid.getTable().requery();
		oGrid.refresh();
		calcRows();
		setProgressPos(0);
	}
}

function getPersCod(userName)
{
	var oSnap = getSnap("select rel.FCOD "
							+" from ^CL_PERS p "
							+" inner join ^CLRELCLCL rel on rel.FWID_CL=p.FWID_CL "
							+" where p.FLOGIN="+ sqlTo(userName)
						, false
						);
	if(oSnap)
		return oSnap[0];
	return 0;
}

function loadResponse()
{
	/*
	CreateTable(sTmpResp, sRespTbl, "FWID");
	var sFLD = GetPatternIntersection(sRespTbl, sRespTbl);
	var sSQL = "insert into "+ sTmpResp +"("+ sFLD +")"
			   	+" select "+ sFLD
			   	+" from ^"+ sRespTbl
			   	+" where FORG in (select FORG from "+ sTmpTbl +")"
			   		+" and FWID in (select FDOCWID from ^DOC_LINKS"
			   					+" where FMAINWID="+ extPar.doc.getID() 
			   					+")";
	ExecuteSQL(sSQL);	
	var tbl = OpenTable("m", "select * "
						+" from "+ sTmpResp
						+" order by FORG"
						);
	*/
	var tbl = OpenTable("m", "select * "
						+" from ^"+ sRespTbl
					   	+" where FORG in (select FORG from "+ sTmpTbl +")"
					   		+" and FWID in (select FDOCWID from ^DOC_LINKS"
					   					+" where FMAINWID="+ extPar.doc.getID() 
					   					+")"
						+" order by FORG"
						);
	clTie(tbl, "pers", "=getPar('CODPERS'), FMANAGER");
	clTie(tbl, "org", "=0, FORG");
	tbl.tie("CL_ORGCP", "cont", "FWID_CL", "FCONTACT");	
	grid_resp.setTable(tbl);
	grid_resp.build();
	
	this.gridRespMenuInit = gridRespMenuInit;
	this.gridRespMenuRun = gridRespMenuRun;
	grid_resp.loadMenuHandler(this, "gridRespMenuInit");
	grid_resp.selectMenuHandler(this, "gridRespMenuRun");	
}

function gridRespMenuInit(oGrid)
{
	if(!oGrid.getTable().isEmpty())
	{
		if(IsDblClick(oGrid))
		{
			gridRespMenuRun("EDIT", oGrid);
			return false;
		}
	}
	oGrid.AddMenuItem("ADD","Додати|Добавить");
	if (!oGrid.getTable().isEmpty())
	{
		oGrid.AddMenuItem("EDIT", "Редагувати|Редактировать");
		oGrid.AddMenuItem("COPY", "Копіювати|Копировать");
		//oGrid.AddMenuItem("DEL", "Видалити|Удалить");		
	}
}

function gridRespMenuRun(sID)
{
	var oGrid = grid_resp;
	var tbl = oGrid.getTable();
	var sTable = tbl.getTableName();
	var rowID = Number(tbl.getValue("FWID"));
	if(sID=="ADD" || sID=="EDIT" || sID=="COPY")
	{
		editResponse(sID, rowID);
	}
}

function editResponse(sMode, nID, par)
{
	include("doc/DpDoc.js");
	var doc = "RESPONSE";
	var nop = 1;
	if(!par)
		par = new Object();
	par.subject = FTXT.value;
	var oDoc = new DpDoc(doc, nop);
	var bRet = oDoc.edit(sMode, nID, par);
	if(!bRet)
		return null;
	
	var m = new Object(); 
	m.FMAINWID = extPar.doc.getID();
	m.FDOCWID = oDoc.getID();
	m.FDOC = doc;
	m.FNOP = nop;
	m.FISPARENT = true;
	m.FWID = GetUID();
	updateTable("^DOC_LINKS", m, true);
	
	var m = new Object(); 
	m.FMAINWID = oDoc.getID();
	m.FDOCWID = extPar.doc.getID();
	m.FDOC = "ML";
	m.FNOP = NOP_COMBO.value;
	m.FISPARENT = false;
	m.FWID = GetUID();
	updateTable("^DOC_LINKS", m, true);
		
	grid_resp.getTable().requery();
	grid_resp.getTable().findByID(oDoc.getID());
	grid_resp.refresh();
	grid.refresh();
	calcRows();
	return oDoc;
}

function calcRows()
{
	FORGCOUNT.value = grid.getTable().recordCount;
	FACTCOUNT.value = grid_act.getTable().recordCount;
	FRESPONSECOUNT.value = grid_resp.getTable().recordCount;
	FEXECOUNT.value = 0;
	var oSnap = getSnap("select count(*) from "+ sTmpAct +" where FSTATE=2");
	if(oSnap)
		FEXECOUNT.value = Number(oSnap[0]);
	FNEGATIVECOUNT.value = 0;
	oSnap = getSnap("select count(*) from ^"+ sRespTbl
					+" where FCONFIRM=2"
						+" and FWID in (select FDOCWID from ^DOC_LINKS"
									+" where FMAINWID="+ extPar.doc.getID() 
					   				+")"
					);	
	if(oSnap)
		FNEGATIVECOUNT.value = Number(oSnap[0]);
}

function isResponse(org)
{
	var oSnap = getSnap("select * from ^"+ sRespTbl
					   	+" where FWID in (select FDOCWID from ^DOC_LINKS"
					   					+" where FMAINWID="+ extPar.doc.getID() 
					   					+")"
						+" and FORG="+ org
						,false
						);
	return oSnap!=null;
}

include("sys/DpBaseDlg.js");