include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpSc.js");
include("Objects\\DpCl.js");
include("Objects\\DpNmkl.js");

var objDoc = extPar.doc;
var m = new Object();

function Load()
{
	objDoc.isBuf = true;	
	
	nk = new DpNakl(objDoc, this);
	nk.load();
	
	var objNmkl = new DpNmkl();
	var nds = Number(objNmkl.getExt("_NDS"));
	
	FDOC_NUM.mask = MASK_DOCNUM;
	HSUMU0.mask   = HSUMO0.mask = HNDSO.mask = MASK_SUM;	
	
	oSc = new DpSc();	
	oSc.linkCtrl(FSC, FSU, FST);
	oSc.setMode("cut");
	
	objPodr = new DpCl();
   	objPodr.linkCtrl(FPODR,FPODR_TXT);
	objPodr.setClcl(sprPodr);
	
	objMol = new DpCl();
   	objMol.linkCtrl(FMOL,FMOL_TXT);
	objMol.setClcl(sprMol);
	
	objPodr1 = new DpCl();
   	objPodr1.linkCtrl(FPODR1,FPODR1_TXT);
	objPodr1.setClcl(sprPodr);
	
	objMol1 = new DpCl();
   	objMol1.linkCtrl(FMOL1,FMOL1_TXT);
	objMol1.setClcl(sprMol);
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	ctrlLinker.addLink("HSC",FSC);
 	ctrlLinker.addLink("HSU",FSU);
 	ctrlLinker.addLink("HST",FST);
 	ctrlLinker.addLink("HUSUM",HSUMU0);	
 	ctrlLinker.addLink("HSUM",HSUMO0);	
	ctrlLinker.addLink("HSNDS",HNDSO);
	ctrlLinker.addLink("HPNDS",FNDS_PROC);
	
	ctrlLinker.updateData(false);	
	
	if (extPar.mode == "ADD")
		FNDS_PROC.value = nds;
	else
	{			
		objPodr.setCod(objDoc.getVar("HPODROT"));   		
   		objMol.setCod(objDoc.getVar("HMOLOT"));
   		objPodr1.setCod(objDoc.getVar("HPODRTO"));   		
   		objMol1.setCod(objDoc.getVar("HMOLTO"));	
		
		oSc.set(objDoc.getVar("HSC"),
   				objDoc.getVar("HSU"),
   				objDoc.getVar("HST"));
   		
   		if(objDoc.getVar("HPNDS")!=0)
   			FNDS_PROC.value = nds;		
	}
	
	setValid(FNDS_PROC, recalcSum);
	
	Disable(HSUMU0);
	Disable(HSUMO0);	
	Disable(HNDSO);
		
	setFocus(FDOC_NUM);
	recalcSum();
}

function recalcSum()
{	
	nk.nds = Number(FNDS_PROC.value);
	nk.wItog(m);	
			
	//m.hndsu = round((m.hndsu * nds)/100,2);
	//m.hndso = round((m.hndso * nds)/100,2);
	
	HSUMU0.value = m.hsumuc;
	HSUMO0.value = m.hsumoC;
	HNDSO.value  = m.hndso;	
}

function updateData()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HPODR",objPodr.getCod());
	objDoc.setVar("HMOL",objMol.getCod());
	objDoc.setVar("HPODRTO",objPodr1.getCod());
	objDoc.setVar("HMOLTO",objMol1.getCod());	
}

function onSave()
{
	updateData();
	
	objDoc.setVar("HPODROT",objPodr.getCod());
	objDoc.setVar("HMOLOT", objMol.getCod());
	
	objDoc.setVar("HSMTOV",	m.Fsum_tov);
	objDoc.setVar("HSBTOV",	m.Fseb_tov);
	objDoc.setVar("HSMMAT",	m.Fsum_mat);
	objDoc.setVar("HSBMAT",	m.Fseb_mat);	
	objDoc.setVar("HOSTAR",	m.Fsum_tar);
	objDoc.setVar("HUSTAR",	m.Fseb_tar);		
	//objDoc.setVar("HSNDS1",	m.hndsu);
	objDoc.setVar("HKOL",	m.hKol);
	objDoc.setVar("HNR",	m.hNr);
	
	nk.saveRows();
}

function docMenuServis()
{
	grid.AddMenuItem("SETFCENAPRUMT","Встановити ціну постачальника = обліковій ціні|Установить цену поставщика = учетной цене");	
}

function docMenuHandler(sID)
{
	var tbl = grid.getTable();
	
	switch(sID)
	{
		case "SETFCENAPRUMT":
			var tblSel = OpenTable("select * from ^"+ nk.bufName +" where "+ grid.sqlSelected());
			while (!tblSel.isEOF())
			{
				var oDocRow = objDoc.getRow("ROW",Number(tblSel.getRowID()));
				var cena = oDocRow.getVar("RUCENA");
				if (cena != 0)
				{
					oDocRow.setVar("ROCENA", cena);
					oDocRow.setVar("RPCENE", cena);
					oDocRow.setVar("RCENAORD", cena);
					obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,nk.bufName);
				}
					
				tblSel.moveNext();		
			}			
			break;
		
		default: 
			return false;
	}
}

include("sys\\DpBaseDlg.js");