include("doc\\DpDoc.js");
include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpNmkl.js");
include("Objects\\DpPrList.js");
include("Objects\\DpVal.js");
include("Objects\\DpSc.js");

var objDoc = extPar.doc;
var m = new Object();
var nds;

function Load()
{		
	if(!objDoc && typeof extPar != "undefined")
		objDoc = new DpDoc(extPar.Fdoc, extPar.Fnop);

	var pricetyp = objDoc.getPar("_pricetyp");
	var priceuse = objDoc.getPar("_priceuse");
	var nmklsel = objDoc.getPar("_nmklsel");
	var otpsel = objDoc.getPar("_otpsel");
	
	var rowmol = objDoc.getPar("_rowmol");
	var rowpdr = objDoc.getPar("_rowpdr");
	var rowpst = objDoc.getPar("_rowpst"); 
	
	objDoc.isBuf = false;
		
	var nk = new DpNakl(objDoc, this);	
	nk.load();	 
		
	FDOC_NUM.mask = MASK_DOCNUM;
	HSUMOC.mask   = HNDSO.mask    
				  = HSUMSNDSO.mask 
				  = FSUM_AKC.mask 
				  = MASK_SUM;
	FKOL.mask     = MASK_KOL;
	FPCENANO.mask = "#";	
	FPTYPE.mask   = "&";
	FDISCOUNT.mask = MASK_SUM;
	
	var objNmkl = new DpNmkl();
	
	//fruckt - надо чтобы брало процент из умолчаний или системный
	//	nds = Number(objNmkl.getExt("_NDS"));
	nds = nk.nds;
	
	oVal = new DpVal();
	oVal.linkCtrl(TFVAL);
	oVal.linkCtrlKurs(FVKURS);
	
	oSc = new DpSc();	
	oSc.linkCtrl(FSC, FSU, FST);	
	oSc.setMode("c0ut");	
	
	objPost = new DpCl();
   	//objPost.linkCtrl(FDBKR,FDBKR_TXT);
   	objPost.linkSmartCtrl(FDBKR);
	objPost.setClcl(getPar("CODPLAT"));	
	objPost.setContAssist();
	objPost.AfterUpdate = afterUpdateOrg;
	
	objPodr = new DpCl();
   	//objPodr.linkCtrl(FPODR,FPODR_TXT);
   	objPodr.linkSmartCtrl(FPODR);
	objPodr.setClcl(sprPodr);
	objPodr.setContAssist();
	
	objMol = new DpCl();
   	//objMol.linkCtrl(FMOL,FMOL_TXT);
   	objMol.linkSmartCtrl(FMOL);
	objMol.setClcl(sprMol);
	objMol.setContAssist();
	
	objMol.setMode( rowmol?	 "0!" : "");
	objPodr.setMode( rowpdr? "0!" : "");
	objPost.setMode( rowpst? "0!" : "");
	
	objPr = new DpPrList();
	objPr.linkCtrl(FPTYPE);
		
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	ctrlLinker.addLink("HVKURS",FVKURS);
	ctrlLinker.addScLink("HSC", "HSU","HST","","","", oSc);
 	ctrlLinker.addLink("HFIO",FIO_POL);	
	ctrlLinker.addLink("HDVNOM",FDOV_NUM);
	ctrlLinker.addLink("HDVDAT",FDOV_DAT);
	//ctrlLinker.addLink("HP",FPTYPE);	
	ctrlLinker.addLink("HPN",FPCENANO);
	ctrlLinker.addLink("HPNDS",FNDS_PROC);
	ctrlLinker.addLink("HSNDS",HNDSO);
	ctrlLinker.addLink("HSUM",HSUMOC);
	ctrlLinker.addLink("HSAKC",FSUM_AKC);	
	ctrlLinker.addLink("HKOL",FKOL);	
	ctrlLinker.addClLink("HPLCH",objPost);
	ctrlLinker.addClLink("HMOL",objMol);
	ctrlLinker.addClLink("HPODR",objPodr);
	ctrlLinker.addLink("HDISCOUNT", FDISCOUNT);			
		
	ctrlLinker.updateData(false);
	
	if (extPar.mode == "ADD")
	{
		objPr.setCod(pricetyp);
		FPCENANO.value = priceuse;	
		//FNDS_PROC.value = nds;		
		
		if(extPar.org)
			objPost.setCod(extPar.org);		
	}
	else
	{
		objPr.setCod(objDoc.getVar("HP"));
		
		oVal.setCod(objDoc.getVar("HVAL"));
		oVal.setKurs(objDoc.getVar("HVKURS"));	
		/*
		objPost.setCod(objDoc.getVar("HPLCH"));
   		objPodr.setCod(objDoc.getVar("HPODR"));   		
   		objMol.setCod(objDoc.getVar("HMOL"));	
*/
		if(objDoc.getVar("HPNDS")!=0)
   			FNDS_PROC.value = nds;
	}
	
	//при формировании по счет-фактуре или для услуг
	if(extPar.submode == "GETORDER")
	{
		this.sMode = "COPY";
		if(extPar.Fdate)
			FDOC_DAT.value = extPar.Fdate;
		if(extPar.Fpost && extPar.Fdate)
			FDOC_NUM.value = extPar.Fpost +"/"+ extPar.Fdate.getMonth();
		objPost.setCod(extPar.Fpost);
   		objPodr.setCod(extPar.Fpodr);   		
   		objMol.setCod(extPar.Fmol);
   		if(extPar.Fid_dog!=null && extPar.Fid_dog!="")
   			extPar.doc.setVar("HID_DOG", extPar.Fid_dog);
   		if(extPar.Fval)
   			oVal.setCod(extPar.Fval);
   		nk.loadFrom(extPar.tblFrom);
   		if(Number(extPar.discount))
   		{
   			FDISCOUNT.value = extPar.discount;
   			setDiscount();
   		}
	}

	if(nmklsel == 1 || otpsel == 1)
	{
		objPr.setMode("0");
		Enable(FPTYPE);
		Enable(FPCENANO);
	}
	else
	{
		objPr.setMode("");
		Disable(FPTYPE);
		Disable(FPCENANO);
	}
	
	Disable(HSUMOC);
	Disable(HNDSO);
	Disable(HSUMSNDSO);
	Disable(FSUM_AKC);
	Disable(FKOL);
		
	setFocus(FDOC_NUM);	
	setValid(FNDS_PROC, recalcSum);
	setValid(FDOC_DAT, recalcSum);
	setValid(FVKURS, recalcSum);
	setValid(TFVAL, recalcSum);
	setButton(SETDISCOUNT, setDiscount);
	
	this.initGridEdit = E_NK_initGridEdit;
	if(objDoc.getPar("_gridedit"))
		this.initGridEdit();
	
	if(extPar.mode != "ADD"  || extPar.idtmpl || extPar.isTransform)
	{
		recalcSum();
	}
}

function E_NK_initGridEdit()
{
	include("gridedit.js");
	var rowpst = (objDoc.getPar("_rowpst") == true);
	this.dpGridEdit = new DpGridEdit(grid);
	this.dpGridEdit.init = DpNakl_addRecord;
	this.dpGridEdit.saveRecord = DpNakl_saveRecord;
	this.dpGridEdit.addValidField("nmk.Fcod", DpNakl_startEdit_fnmkl, DpNakl_endEdit_fnmkl);
	this.dpGridEdit.addValidField("=(^Fedi==1? (^Fkol/^nmk.Fedikf1) : ^Fkol)", DpNakl_startEdit_fkol, DpNakl_endEdit_fkol);
	this.dpGridEdit.addValidField("=(^Fedi==1? ^nmk.Fedikf1 : 1)*^Fcenapr", DpNakl_startEdit_f1cena, DpNakl_endEdit_f1cena);
	this.dpGridEdit.addValidField("=(^Fedi==1? ^Fcena*^nmk.Fedikf1 : ^Fcena)", DpNakl_startEdit_fcena, DpNakl_endEdit_fcena);
	this.dpGridEdit.addValidField("=(^Fedi==0? ^edi1.Ftxts : ^edi2.Ftxts)", DpNakl_startEdit_fedi, DpNakl_endEdit_fedi);
	this.dpGridEdit.addValidField("FDISCOUNT", DpNakl_startEdit_fdiscount, DpNakl_endEdit_fdiscount);
	var ci = grid.getColumn("=(^Fedi==0? ^edi1.Ftxts : ^edi2.Ftxts)");
	ci.addEditOption(0,"");
	
	grid.afterEditHandler(this, "afterEditHandler");
	this.afterEditHandler = e_nk_afterEditHandler;
}

function DpNakl_saveRecord()
{
	var tblRows = grid.getTable();
	var useWID = parseInt(tblRows.getValue("fwid"));
	var docRow =  objDoc.getRow("ROW", useWID);
	if (docRow == null)
	{
		docRow = objDoc.createRow("ROW");
		docRow.setID(useWID);
		objDoc.appendRow("ROW", docRow);
	}
	with (docRow)
	{
		setVar("RNOM",  tblRows.getValue("fnom_str"));
		setVar("RSC", tblRows.getValue("fsc"));
		setVar("RSU", tblRows.getValue("fsu"));
		setVar("RST", tblRows.getValue("fst"));
		setVar("RPODR", tblRows.getValue("fpodr"));
		setVar("RMOL", tblRows.getValue("fmol"));
		
		
		setVar("RSUM", tblRows.getValue("fsum"));
		setVar("REDI", tblRows.getValue("fedi"));		
		setVar("RUCENA", tblRows.getValue("fcena"));
		setVar("RFOCENA", tblRows.getValue("f1cena"));
		setVar("ROCENA",tblRows.getValue("fcenapr"));
		setVar("RPOST", tblRows.getValue("fpost"));
		setVar("RKOL", tblRows.getValue("fkol"));		
		setVar("RTNMK",	 tblRows.getValue("fnmkl"));
		
		var oNmkl = new DpNmkl();
		oNmkl.setCod(Number(tblRows.getValue("fnmkl")));
		setVar("RPOST",  oNmkl.Fis_post?tblRows.getValue("fpost"):0);
		setVar("R1ID",	  oNmkl.Fis_pn1 == '+'? tblRows.getValue("fid_pn") : 0);	
		setVar("R1SVAL", tanf(getVar("R1ID"), 'VCOD'));
		setVar("RCENAORD",oNmkl.Fis_sred==false? getVar("RUCENA") : 0);	
		setVar("RCTYPE",sctype(getVar("RSC"),getVar("RSU"), getVar("RST")));
		setVar("RTYPE","7");					
	}
	return true;
}

function DpNakl_addRecord()
{
	include("Objects\\DpClNo.js");
	
	with (this)
	{	
		var nom = findFreeClNo(nk.bufName, "fnom_str");
		initValue("fnom_str", new java.lang.Integer(nom));
		initValue("fkol", 0);
		initValue("fcena", 0);
		initValue("fcenapr", 0);
		initValue("f1cena", 0);
		initValue("Fedi", 0);
		initValue("Fdate", FDOC_DAT.value);
		initValue("F1val", oVal.getCod());
		initValue("Frtype", "7");
	}
}

function e_nk_afterEditHandler()
{
	var tblRows = grid.getTable();
	var useWID = parseInt(tblRows.getValue("fwid"));
	var docRow =  objDoc.getRow("ROW", useWID);
	if (docRow == null)
		return;
	handleEvent("afterSaveNaklRow", docRow);				
	obj2DB(docRow.getID(), docRow.jDocRow, null, nk.bufName);
	tblRows.requery();
	recalcSum();	
}

function DpNakl_startEdit_fnmkl(oCtrl)
{
	var sCod = String(oCtrl.getValue());	
	objNmkl = new DpNmkl();   		
	objNmkl.linkCtrl(oCtrl);	
	objNmkl.setCod(sCod);
}

function DpNakl_endEdit_fnmkl(oCtrl)
{
	trace("endEdit_fnmkl");
	if (!objNmkl.setCod(String(oCtrl.getValue())))
	{	
		if (!objNmkl.doZaval())
			return false;
	}	
	oCtrl.setValue(objNmkl.getCod("c"));
	list.dpGridEdit.setValue("fnmkl", objNmkl.getFwid());
	var ci = grid.getColumn("=(^Fedi==0? ^edi1.Ftxts : ^edi2.Ftxts)");
	ci.removeAllEditOptions();
	ci.setAttributes("e");
	ci.addEditOption(0,objNmkl.tFcedib);
	if(objNmkl.tFedi1!=null)
	{
		//ci.setAttributes("e");
		//ci.addEditOption(0,objNmkl.tFcedib);
		ci.addEditOption(1,objNmkl.tFedi1);
	}
	else
	{
		//ci.setAttributes("");
		grid.getTable().setValue("fedi", 0);	
	}
	trace("endEdit_fnmkl 2");
	return true;
}

function DpNakl_startEdit_fedi(oCtrl)
{
	objNmkl = new DpNmkl();
	var nID =  Number(grid.getTable().getValue("fnmkl"));
	if (!nID)
		return;
	
	objNmkl.setCod(nID);
	oCtrl.clear();
	oCtrl.addItem(0,objNmkl.tFcedib);
	if(objNmkl.tFedi1 != null)
		oCtrl.addItem(1,objNmkl.tFedi1);
	oCtrl.setValue(Number(grid.getTable().getValue("fedi")));
}


function DpNakl_endEdit_fedi(oCtrl)
{
	list.dpGridEdit.setValue("fedi", Number(oCtrl.getValue()));	
}


var nKol;
function DpNakl_startEdit_fkol(oCtrl)
{
	nKol = Number(oCtrl.getValue());
}

function DpNakl_endEdit_fkol(oCtrl)
{
	var newKol = Number(oCtrl.getValue());
	list.dpGridEdit.setValue("fkol", Number(oCtrl.getValue()));
}

var n1Cena;
function DpNakl_startEdit_f1cena(oCtrl)
{
	n1Cena = Number(oCtrl.getValue());
	oCtrl.setValue(grid.getTable().getValue("F1cena"));
}

function DpNakl_endEdit_f1cena(oCtrl)
{
	var newCena = Number(oCtrl.getValue());
	var nDisc = Number(grid.getTable().getValue("FDISCOUNT"));
	
	list.dpGridEdit.setValue("Fcenapr", newCena - newCena*nDisc/100 );	
	list.dpGridEdit.setValue("F1cena", newCena);
}


function DpNakl_startEdit_fdiscount(oCtrl)
{
	
}

function DpNakl_endEdit_fdiscount(oCtrl)
{
	var newCena = Number(grid.getTable().getValue("F1CENA"));
	var nDisc = Number(grid.getTable().getValue("FDISCOUNT"));	
	list.dpGridEdit.setValue("Fcenapr", newCena - newCena*nDisc/100 );
}

var oCena ;
var Fcena = null;
function DpNakl_startEdit_fcena(oCtrl)
{
	var tblRows = grid.getTable();
	var useWID = parseInt(tblRows.getValue("fwid"));
	var docRow =  objDoc.getRow("ROW", useWID);
	if (docRow == null)
	{
		docRow = objDoc.createRow("ROW");
		docRow.setID(useWID);
		//objDoc.appendRow("ROW", docRow);
	}
	docRow.setVar("R1ID",parseInt(tblRows.getValue("fid_pn")));
	docRow.make_Otpcena = new Function();
	include ("Objects/DpUCena.js");
	include ("doc/nakl/DpNkGridRow.js");
	rnk = new DpNkGridRow(docRow, grid);
	Fcena = oCtrl;
	oCena = new DpUCena(docRow);
	oCena.linkCtrl(oCtrl);
}

function DpNakl_endEdit_fcena(oCtrl)
{
	oCena.validCtrl();
	var newCena = Number(oCtrl.getValue());
	list.dpGridEdit.setValue("Fcena", newCena);
	//if (Fis_otl)
	//	grid.getTable().setValue("Fis_otl", Fis_otl);
	if (Fid_pn)
	{
		grid.getTable().setValue("Fid_pn", Fid_pn);		
	}
	
}


function recalcSum()
{		
	nk.nds = Number(FNDS_PROC.value);
	nk.wItog(m);	
	
	var hsumoC = m.hsumoC;			//сумма в валюте
	var hndso = m.hndso;			//сумма НДС	
	var dt = FDOC_DAT.value;
	var kod1 = oVal.getNazv();
	var kurs = FVKURS.value;
	if (m.hsumoC != null)
		hsumoC = _nv2nv("", dt, kod1, m.hsumoC, 0, kurs, 1);
	if(m.hndso)	
		hndso = _nv2nv("", dt, kod1, m.hndso, 0, kurs, 1);
	
	FKOL.value = m.hKol;
	HSUMOC.value = hsumoC;						//сумма без НДС
	//HNDSO.value = round((hsumoC * nds)/100, 2);	//НДС
	HNDSO.value = round(hndso, Number(getPar("DECISUM")));
	HSUMSNDSO.value = Number(HNDSO.value) + Number(HSUMOC.value); //сумма с НДС	
}

function updateData()
{	
	ctrlLinker.updateData(true);
	objDoc.setVar("HVAL",	oVal.getCod());	
	objDoc.setVar("HPOST",	objPost.getCod());
	objDoc.setVar("HPODR",	objPodr.getCod());
	objDoc.setVar("HMOL",	objMol.getCod());
	objDoc.setVar("HP",		objPr.getCod());			
}		

function onSave()
{		
	updateData();
		
	objDoc.setVar("HSMTOV",	m.Fsum_tov);
	objDoc.setVar("HSBTOV",	m.Fseb_tov);
	objDoc.setVar("HSMMAT",	m.Fsum_mat);
	objDoc.setVar("HSBMAT",	m.Fseb_mat);	
	objDoc.setVar("HOSTAR",	m.Fsum_tar);
	objDoc.setVar("HUSTAR",	m.Fseb_tar);	
	objDoc.setVar("HTOTL",	m.hIsRasc);	
	objDoc.setVar("HSNDS1",	m.hndsu);
	objDoc.setVar("HPSUM",	m.hsumuc);
	//objDoc.setVar("HSUM",	m.hsumoC);	
	objDoc.setVar("HNR",	m.hNr);
	
	var rowpdr = (objDoc.getPar("_rowpdr") == true);
	var rowmol = (objDoc.getPar("_rowmol") == true);
	
	if (!rowpdr || !rowmol)
	{
		var sSQL = "";
		
		if (!rowpdr)
		{
			sSQL += ", FPODR = " + sqlTo(objDoc.getVar("HPODR"));
		}
		if (!rowmol)
		{
			sSQL += ", FMOL = " + sqlTo(objDoc.getVar("HMOL"));					
		}
		var sSQL = "UPDATE " + nk.bufName + " SET " + sSQL.substr(1);
		ExecuteSQL(sSQL);
		
		var t = OpenTable("s", nk.bufName)
		while (!t.isEOF())
		{
			var nID = Number(t.getValue("FWID"))
			var oRow = objDoc.getRow("ROW", nID);
			if (oRow != null)
			{
				if (!rowpdr)
				{
					oRow.setVar("RPODR", objDoc.getVar("HPODR"));						
				}
				if (!rowmol)
				{
					oRow.setVar("RMOL", objDoc.getVar("HMOL"));						
				}
			}
			t.moveNext();
		}
		t.close();
	}	
	nk.saveRows();			
}

function onAfterSave()
{
	var isCalc = objDoc.getPar("_sumdlg");
	if (isCalc)
	{
		objDoc.calculate();
		var par = new Object();
		par.Fsum = Number(objDoc.getVar("HOSUM") + objDoc.getVar("HSNDS"));
		par.nk = objDoc;
		//par.noFirstSave = noFirstSave;
		par.escape = true;		
		showWindow("e_tc_sav.xml", SW_MODAL, par );
	}
	
}

function docMenuInit()
{
	if(getSystem()=="BIL2")
	{
		grid.AddMenuItem("", "");
		grid.AddMenuItem("FIND_BILL", "Знайти нарахування|Найти начисления");
	}
}

function docMenuHandler(sID)
{
	if(sID=="FIND_BILL")
	{
		var par = new Object();
		var fid_doc = nk.tbl4Grid.getValue("FID_DOC");
		var fwid = nk.tbl4Grid.getValue("FWID");
		par.doc = "BILL";
		par.nop = 1;
		par.bdat = d00min;
		par.FORG = nk.tbl4Grid.getValue("FCLIENT");
		par.subWhere = " FWID in (select rel.FID_BIL "
						+" from ^RELBILL rel "
						+" where rel.FID_ROW="+ fwid +")";
		showWindow("l_docekz.xml", SW_NOMODAL, par);
		return true;
	}
	return false;
}

function setDiscount()
{
	var discount = Number(FDISCOUNT.value);
	var sWhere = "";
	//if(grid.getSelectedCount()>0)
	//	sWhere = " where "+ grid.getSqlSelected();
	var t = nk.tbl4Grid;
	objDoc.gotoFirstRow();
	for(t.MoveFirst(); !t.isEOF(); t.MoveNext())
	{
		var nID = Number(t.getValue("FWID"))
		var oRow = objDoc.getRow("ROW", nID);
		if (oRow != null)
		{			
			var cena = Number(oRow.getVar("RFOCENA"));
			var otpCena = cena - (cena*discount/100);
			oRow.setVar("RDISCOUNT", discount);
			oRow.setVar("ROCENA", otpCena);
			ExecuteSQL("update "+ nk.bufName +" set FDISCOUNT="+ discount +" where FWID="+ nID);
			ExecuteSQL("update "+ nk.bufName +" set FCENAPR="+ otpCena +" where FWID="+ nID);
		}
	}
	nk.refreshViewer();
}

function afterUpdateOrg()
{
	if(objPost.getCod())
		loadOrgPrice()
}

//грузит тип прайса и номер цены из расширений контрагента (для сервисного центра)
function loadOrgPrice()
{
	if(objPost.getExt("PRICE1")!=null)
		objPr.setCod(objPost.getExt("PRICE1"));
	if(objPost.getExt("PRICEN1")!=null)
		FPCENANO.value = objPost.getExt("PRICEN1");
}

function onChangeNop()
{
	objDoc = extPar.doc;
	
	var pricetyp = objDoc.getPar("_pricetyp");
	var priceuse = objDoc.getPar("_priceuse");
	var nmklsel = objDoc.getPar("_nmklsel");
	var otpsel = objDoc.getPar("_otpsel");	
	
	var rowmol = objDoc.getPar("_rowmol");
	var rowpdr = objDoc.getPar("_rowpdr");
	var rowpst = objDoc.getPar("_rowpst");
	
	objMol.setMode( rowmol?	 "0!" : "");
	objPodr.setMode( rowpdr? "0!" : "");
	objPost.setMode( rowpst? "0!" : "");	
	
	if (extPar.mode == "ADD")
	{
		objPr.setCod(pricetyp);
		FPCENANO.value = priceuse;		
	}
	
	if(nmklsel == 1 || otpsel == 1)
	{
		objPr.setMode("0");
		Enable(FPTYPE);
		Enable(FPCENANO);
	}
	else
	{
		objPr.setMode("");
		Disable(FPTYPE);
		Disable(FPCENANO);
	}
	loadOrgPrice();
	
	grid.DeletePages();
	nk.loadGrid();
}

function docLoadRowToBuf(oDocRow)
{
	include("doc\\nakl\\DpNkRow.js");
	var rnk = new DpNkRow(oDocRow);
	var cena = oDocRow.getVar("ROCENA");
	var discount = oDocRow.getVar("RDISCOUNT");
	var otpCena = rnk.calc_discount(cena, discount);
	oDocRow.setVar("ROCENA", otpCena);
}

function onExit()
{
	if (nk)
	{
		nk.dispose();	
	}
}
			
include("sys\\DpBaseDlg.js");