include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpSc.js");
include("Objects\\DpCl.js");
include("Objects\\DpNmkl.js");

var objDoc = extPar.doc;
var m = new Object();
var Fsum_pok;
var Fnrows;
var Fkol;
var nds;

function Load()
{
	objDoc.isBuf = true;
		
	nk = new DpNakl(objDoc, this);
	nk.load();
	
	FDOC_NUM.mask = MASK_DOCNUM;
	HSUMUC.mask   = HSUMOC.mask = MASK_SUM;
		
	var objNmkl = new DpNmkl();
	nds = Number(objNmkl.getExt("_NDS"));
	
	objSc1 = new DpSc();	
	objSc1.linkCtrl(FSC1, FSU1);
	//objSc1.setMode("cu0");
	
	objSc = new DpSc();	
	objSc.linkCtrl(FSC, FSU, FST);
	objSc.setMode("cu0");
	
	objPodr = new DpCl();
   	objPodr.linkCtrl(FPODR,FPODR_TXT);
	objPodr.setClcl(sprPodr);
	
	objMol = new DpCl();
   	objMol.linkCtrl(FMOL,FMOL_TXT);
	objMol.setClcl(sprMol);
	
	objPodr1 = new DpCl();
   	objPodr1.linkCtrl(FPODR1,FPODR1_TXT);
	objPodr1.setClcl(sprPodr);
	
	objMol1 = new DpCl();
   	objMol1.linkCtrl(FMOL1,FMOL1_TXT);
	objMol1.setClcl(sprMol);
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	ctrlLinker.addLink("HSC",FSC);
 	ctrlLinker.addLink("HSU",FSU);
 	ctrlLinker.addLink("HST",FST);
 	ctrlLinker.addLink("HSC1",FSC1);
 	ctrlLinker.addLink("HSU1",FSU1); 	
 	ctrlLinker.addLink("HUSUM",HSUMUC);
	ctrlLinker.addLink("HOSUM",HSUMOC);	
	
	ctrlLinker.updateData(false);
	
	if (extPar.mode == "COPY" || extPar.mode == "EDIT")
	{			
		objPodr.setCod(objDoc.getVar("HPODROT"));   		
   		objMol.setCod(objDoc.getVar("HMOLOT"));
   		objPodr1.setCod(objDoc.getVar("HPODRTO"));   		
   		objMol1.setCod(objDoc.getVar("HMOLTO"));	
		
		objSc.set(objDoc.getVar("HSC"),
   				  objDoc.getVar("HSU"),
   				  objDoc.getVar("HST"));
   		objSc1.set(objDoc.getVar("HSC1"),
   				   objDoc.getVar("HSU1"));
	}
		
	Disable(HSUMUC);
	Disable(HSUMOC);
			
	setFocus(FDOC_NUM);		
	recalcSum();
}

function recalcSum()
{		
	nk.wItog(m);

	Fkol = m.hKol;
	Fnrows = m.hNr;
	//Fsum_pok = m.hsumoC;
	
	HSUMUC.value = m.hSum;
	HSUMOC.value = m.hsumoC;
	
	m.hndso = round((m.hndso*nds)/100,2);	
}

function updateData()
{
	objDoc.setVar("HPODR",objPodr.getCod());
	objDoc.setVar("HMOL",objMol.getCod());		
	objDoc.setVar("HPODRTO",objPodr1.getCod());
	objDoc.setVar("HMOLTO",objMol1.getCod());
	ctrlLinker.updateData(true);
}

function onSave()
{
	updateData();
	objDoc.setVar("HPODROT",objPodr.getCod());
	objDoc.setVar("HMOLOT",objMol.getCod());
	
	objDoc.setVar("HSMTOV",	m.Fsum_tov);
	objDoc.setVar("HSBTOV",	m.Fseb_tov);
	objDoc.setVar("HSMMAT",	m.Fsum_mat);
	objDoc.setVar("HSBMAT",	m.Fseb_mat);	
	objDoc.setVar("HOSTAR",	m.Fsum_tar);
	objDoc.setVar("HUSTAR",	m.Fseb_tar);
		
	objDoc.setVar("HSNDS1",	m.hndso);
	objDoc.setVar("HKOL",	Fkol);
	objDoc.setVar("HNR",	Fnrows);
	nk.saveRows();
}

include("sys\\DpBaseDlg.js");