include("Objects\\DpCtrlLinker.js");
include("doc\\nakl\\DpNkRow.js");
include("Objects\\DpCl.js");

var obj = extPar.obj;
var oNmkl, oRem;

function Load()
{
	Caption(ru("Редактирование накладной","Редагування накладної"));

	rnk = new DpNkRow(obj);

	RSUM20.mask = RSUM00.mask = RSUMA0.mask = RSUME0.mask = MASK_SUM;
	RSUM.mask = MASK_SUM;
	RKOL.mask = MASK_KOL;
	ROCENA.mask = MASK_CENA;
	
	RKOLCOR.mask = MASK_KOL;
	RCENACOR.mask = MASK_CENA;
	
	RNOM.mask = "######";

	oNmkl = new DpNmkl();
	oNmkl.SetNakl(obj.parent);
	oNmkl.CanEmpty = false;
	oNmkl.linkSmartCtrl(RTNMK,tFedi);
	fillStavka();

	oRem = new DpCl("0");
	mode = "";
	oRem.setMode(mode);
	oRem.setClcl(extPar.cod_reason);
	if (!extPar.FISCOR)
	{
		oRem.setMode("0");
	}
	oRem.linkSmartCtrl(RCODREM);

	ctrlLinker = new DpCtrlLinker(obj);
	ctrlLinker.addLink("RNOM", RNOM);
	ctrlLinker.addLink("RDATE", RDATE);
	ctrlLinker.addLink("RSUM20", RSUM20);
	ctrlLinker.addLink("RSUM00", RSUM00);
	ctrlLinker.addLink("RSUMA0", RSUMA0);
	ctrlLinker.addLink("RSUME0", RSUME0);
	ctrlLinker.addLink("RSUM", RSUM);
	ctrlLinker.addLink("ROCENA", ROCENA);
	ctrlLinker.addLink("RKOL", RKOL);
	ctrlLinker.addLink("RKOLCOR", RKOLCOR);
	ctrlLinker.addLink("RCENACOR", RCENACOR);
	ctrlLinker.addClLink("RCODREM", oRem);
	ctrlLinker.addClLink("RTNMK", oNmkl);
	ctrlLinker.updateData(false);

	if(extPar.mode=="EDIT" || extPar.mode=="COPY")
	{
		rnk.Fedi = oNmkl.Fedi = Number(rnk.obj.getVar("REDI"));
		oNmkl.setCod(obj.getVar("RTNMK"));
		
		if (Number(obj.getVar("RSUM00")))
			stavka.value = 1;
		else if (Number(obj.getVar("RSUME0")))
			stavka.value = 2;
		else if (Number(obj.getVar("RSUMA0")))
			stavka.value = 3;
	}
	else
		RDATE.value = obj.parent.getVar("HDAT")

	setValid(stavka, recalcSum);
	setValid(RKOL, recalcSum);
	setValid(RKOLCOR, recalcSum);
	setValid(RCENACOR, recalcSum);
	setValid(ROCENA, recalcSum);
	Enable(RSUM20, false);
	Enable(RSUM00, false);
	Enable(RSUME0, false);
	Enable(RSUMA0, false);
	Enable(RSUM, false);

	CORR.setVisible(extPar.FISCOR);
	
	if (extPar.FISCORDOC && extPar.mode != "ADD")
	{
		// тушим количество и цену только в том случае, если был 
		// выбран документ, по которому производится корректировка И режим добавления
		Disable(RKOL);
		Disable(ROCENA);
	}
	recalcSum();

	rnk.check_Fedi();
	rnk.getNextRowNum();
	setFocus(RTNMK);
}

function fillStavka()
{
	var aStavkaNames = new Array(
		ru("20%", "20%")
		, ru("0% (реал.на там. тер. Украины)", "0% (реал.на мит. тер. України)")
		, ru("0% (экспорт)", "0% (експорт)")
		, ru("Освоб.от НДС (ст.5)", "Звілньн.від ПДВ (ст.5)")
	)
	for(var ind in aStavkaNames)
	{
			ComboBox_AddItem(stavka, aStavkaNames[ind], ind);
	}
	ComboBox_SetIndex(stavka, 0);
}

function onSave()
{
	ctrlLinker.updateData(true);
	obj.setVar("RTNMK",  oNmkl.getCod());
	obj.setVar("REDI",   rnk.Fedi>0? rnk.Fedi : 0);
}

function recalcSum()
{
	var mFkol = Number(RKOL.value);
	var mFcena = Number(ROCENA.value);

	var mFiscor = extPar.FISCOR;
	var mFsum = 0;
	if(mFiscor)
	{
		var mFkolcor = Number(RKOLCOR.value);
		var mFcenacor = Number(RCENACOR.value);
		mFsum = round(mFkol*mFcenacor, 2) + round(mFcena*mFkolcor, 2);
	}
	else
	{
		mFsum = round(mFkol*mFcena, 2);
	}
	RSUM.value = mFsum;

	//Обнулим все и поставим там, где надо
	RSUM20.value = 0;
	RSUM00.value = 0;
	RSUME0.value = 0;
	RSUMA0.value = 0;
	var nIndex = ComboBox_GetIndex(stavka);

	switch(nIndex)
	{
		case  0:
			RSUM20.value = mFsum;
			break;
		case  1:
			RSUM00.value = mFsum;
			break;
		case  2:
			RSUME0.value = mFsum;
			break;
		case  3:
			RSUMA0.value = mFsum;
			break;
	}
	return true;
}

function getNextNum(sTbl)
{
	var num = 1;
	var tNum = getSnap("select max(FNUM) from "+ sTbl);
	if(tNum!=null)
		num = Number(tNum[0])+1;
	return num;
}

include("sys\\DpBaseDlg.js");