include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpSc.js");
include("Objects\\DpCl.js");
include("Objects\\DpNmkl.js");

var objDoc = extPar.doc;
var m = new Object();
var showsc = objDoc.getPar("_showsc");

function Load()
{
	objDoc.isBuf = true;	
	
	nk = new DpNakl(objDoc, this);
	nk.load();
	
	var objNmkl = new DpNmkl();
	nds = Number(objNmkl.getExt("_NDS"));
	
	if(showsc)
	{
		oSc = new DpSc();
		oSc.setMode("cut00xyz");
		oSc.linkCtrl(FSC, FSU, FST, FCL_COD1, FCL_COD2, FCL_COD3);
	}
	else
	{
		GroupSC.setVisible(false);
	}

	FDOC_NUM.mask = MASK_DOCNUM;
	HSUMUC.mask   = HSUMOC.mask  = MASK_SUM;
				
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	ctrlLinker.addLink("HSUMOLD",HSUMUC);
 	ctrlLinker.addLink("HSUMNEW",HSUMOC);	
	
	if(showsc)
	{
		ctrlLinker.addLink("HSC",	 FSC);
		ctrlLinker.addLink("HSU", 	 FSU);
		ctrlLinker.addLink("HST",	 FST);	
		ctrlLinker.addLink("HA1",	 FCL_COD1);	
		ctrlLinker.addLink("HA2",	 FCL_COD2);	
		ctrlLinker.addLink("HA3",	 FCL_COD3);	
	}

	ctrlLinker.updateData(false);	
		
	if (extPar.mode == "ADD")
	{
	}
	else
	{
		if(showsc)
		{
			oSc.set(
					objDoc.getVar("HSC"),
   				objDoc.getVar("HSU"),
   				objDoc.getVar("HST"),
   				objDoc.getVar("HA1"),
   				objDoc.getVar("HA2"),
   				objDoc.getVar("HA3")
   				);
		}
		else
		{
			FSC.value = 0;
			FSU.value = 0;
			FST.value = 0;
			FCL_COD1.value = 0;
			FCL_COD2.value = 0;
			FCL_COD3.value = 0;
		}
	}

	switch (getPar("NKSCSHOW"))
	{
	case "disable":
		if(!showsc)
		{
			Disable(FSC)
			Disable(FSU)
			Disable(FST)
			Disable(FCL_COD1);
			Disable(FCL_COD2);
			Disable(FCL_COD3);
		}
		break;
	case "hide":
		GroupSC.setVisible(false);
		break;
	default:
		if(!showsc)
		{
			GroupSC.setVisible(false);
		}
	}

	Disable(HSUMUC);
	Disable(HSUMOC);
			
	setFocus(FDOC_NUM);
	recalcSum();

	var pnt = FORM.getControlComposite();
	pnt.redraw();
	pnt.layout(true);
}

function recalcSum()
{	
	nk.wItog(m);
	
	m.hndsu = round((m.hndsu * nds)/100,2);
	m.hndso = round((m.hndso * nds)/100,2);
	
	HSUMUC.value = m.hsumuc;	
	HSUMOC.value = m.hsumoC;	
}

function updateData()
{
	ctrlLinker.updateData(true);		
	objDoc.setVar("HP", objDoc.getPar("_pricetyp"));	
	objDoc.setVar("HPN",objDoc.getPar("_priceuse"));
}

function onSave()
{
	updateData();		
		
	objDoc.setVar("HOSTAR",	m.Fsum_tar);
	objDoc.setVar("HUSTAR",	m.Fseb_tar);	
	objDoc.setVar("HTOTL",	m.hIsRasc);
	objDoc.setVar("HSNDS1",	m.hndsu);
	objDoc.setVar("HSNDS",	m.hndso);			
	objDoc.setVar("HNR",	m.hNr);
	objDoc.setVar("HKOL",	m.hKol);
	
	nk.saveRows();
}

include("sys\\DpBaseDlg.js");