include("doc/nakl/DpNakl.js");
include("Objects/DpNmkl.js");
include("Objects/DpCl.js");
include("sys/kursval.js");
include("gridedit.js");

var objDoc = extPar.doc;
var dpGridEdit = null;
var tblRows;
var objNmkl;
var oOrg;
var oVal;
var oValP;

function Load()
{
	objDoc.isBuf = true;
	
	nk = new DpNakl(objDoc, this);	
	nk.rowsName = "RORDER";	
	nk.load();	
			
	FDOC_NUM.mask = MASK_DOCNUM;
	FKOL.mask = MASK_KOL;
	FSUM.mask = MASK_SUM;
	FSUMP.mask = MASK_SUM;
	
	oVal = new DpVal();
	oVal.linkCtrl(FVAL);	
	setValid(FVAL, onChangeVal);
	setValid(FVAL, recalcSum);
	
	oValP = new DpVal();
	oValP.linkCtrl(FVALP);
	setValid(FVALP, recalcSum);
	
	oOrg = new DpCl("0", getPar("CODPLAT"), 0);	
	oOrg.linkSmartCtrl(FORG);
	oOrg.setContAssist();
	oOrg.AfterUpdate = setOrg;
		
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM", FDOC_NUM);
	ctrlLinker.addLink("HDAT", FDOC_DAT);
	ctrlLinker.addLink("HSUM", FSUMP);
	ctrlLinker.addLink("HSTATUS", FSTATUS);
	ctrlLinker.addClLink("HORG", oOrg);
	ctrlLinker.updateData(false);
	
	if(extPar.mode!="ADD")
	{
		oVal.setCod(objDoc.getVar("HVAL"));
		oValP.setCod(objDoc.getVar("HVALP"));
	}
	
	setFocus(FDOC_NUM);
	
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.init = addRecord;
	dpGridEdit.canEdit = canEditRecord;
	dpGridEdit.saveRecord = saveRecord;	
	dpGridEdit.addValidField("nmk.fcod", startEdit_fnmkl, endEdit_fnmkl);
	
	this.recalcSum = recalcSum;
	grid.afterEditHandler(this, "recalcSum");
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid.loadMenuHandler(this, "gridMenuInit");
	grid.selectMenuHandler(this, "gridMenuRun");
	
	tblRows = grid.getTable();
	
	Disable(FSUM);
	Disable(FKOL);
	Disable(FSUMP);
	
	recalcSum();
}

function setOrg()
{
	if(extPar.oCntr)
		extPar.oCntr.setOrg(oOrg.getCod());		
}

function addRecord()
{
	with(this)
	{	
		initValue("fkol", 0);
		initValue("fcena", 0);					
	}
}

function saveRecord()
{
	var useWID = parseInt(grid.getTable().getValue("fwid"));
	var docRow =  objDoc.getRow("ROW", useWID);
	if (docRow == null)
	{
		docRow = objDoc.createRow("ROW");
		docRow.setID(useWID);
		objDoc.appendRow("ROW", docRow);
	}
	with (docRow)
	{
		setVar("RNUM", tblRows.getValue("FNOM_STR"));
		setVar("RSUM", tblRows.getValue("FSUM"));
		setVar("REDI", tblRows.getValue("FEDI"));		
		setVar("RCENA", tblRows.getValue("FCENA"));	
		setVar("RKOL", tblRows.getValue("FKOL"));		
		setVar("RTNMK",	 tblRows.getValue("FNMKL"));
	}
	return true;
}

function canEditRecord()
{	
	return true;
}

function startEdit_fnmkl(oCtrl)
{
	var sCod = String(oCtrl.getValue());	
	objNmkl = new DpNmkl();   		
	objNmkl.linkCtrl(oCtrl);	
	objNmkl.setCod(sCod);
}

function endEdit_fnmkl(oCtrl)
{
	if (!objNmkl.setCod(String(oCtrl.getValue())))
	{	
		if (!objNmkl.doZaval())
			return false;
	}	
	oCtrl.setValue(objNmkl.getCod("c"));
	dpGridEdit.setValue("FNMKL", objNmkl.getFwid());
	return true;
}

function recalcSum()
{	
	ExecuteSQL("update "+ nk.bufName +" set FSUM=FCENA*FKOL, F1CENA=FCENA, FCENAPR=FCENA");
		
	grid.getTable().requery();
	grid.refresh();
	
	var result = new Object();
	result.nRows = 0;
	result.sum = 0;
	result.kol = 0;
		
	var oSnap = getSnap("select count(*) from "+ nk.bufName);
	if (oSnap)
		result.nRows = oSnap[0];
	if (result.nRows == 0)
		return result;
			
	oSnap = getSnap("select sum(FCENA*FKOL), sum(FKOL) from "+ nk.bufName);		
	if (oSnap == null)
		return result;
		
	result.sum = oSnap[0];
	result.kol = oSnap[1];
	FSUM.value = result.sum;
	FKOL.value = result.kol;
	
	var kod1 = oVal.getCod();
	var kod2 = oValP.getCod();
	var date = FDOC_DAT.value;
	FSUMP.value = _nv2nv("", date, kod1, result.sum, kod2, 0);

	return result;
}

function onSave()
{
	ctrlLinker.updateData(true);
	var obj = recalcSum();
	objDoc.setVar("HNR", obj.nRows);
	objDoc.setVar("HKOL", Number(obj.kol));
	objDoc.setVar("HSUM", Number(obj.sum));
	objDoc.setVar("HVAL", oVal.getCod());
	objDoc.setVar("HVALP", oValP.getCod());
	
	ExecuteSQL("DELETE FROM ^RORDER WHERE fid_doc=" + sqlTo(objDoc.getID()));
	if (obj.nRows > 0)
	{
		ExecuteSQL("UPDATE "+ nk.bufName +" SET fid_doc="+ sqlTo(objDoc.getID()));
		saveRows("RORDER", nk.bufName);
	}
}

function saveRows(toTbl, fromTbl, strFields, strWhere)
{
	if(typeof fromTbl!="string" || typeof toTbl!="string")
		return false;
	if(typeof strFields == "undefined")
		strFields = GetPatternIntersection(toTbl, toTbl);
	if(typeof strWhere == "string")
		strWhere = " WHERE " + strWhere;
	else
		strWhere = "";
	var sSQL = "INSERT INTO ^"+ toTbl +"("+ strFields +")"
			  	+" SELECT " + strFields
			  	+" FROM " + fromTbl + strWhere
	return ExecuteSQL(sSQL);		
}

function onChangeVal()
{
	if (objDoc.getVar("HVAL") != oVal.getCod())
	{
		var tRow = objDoc.jDoc.getRowTable("ROW");
		if (!tRow.IsEmpty() && confirm("Изменилась валюта. Перевести цены со старой в новую валюту"))
		{
			var kurs = _nv2nv("", FDOC_DAT.value, objDoc.getVar("HVAL"), 1, oVal.getCod());
			for (; !tRow.IsEOF(); tRow.MoveNext())
			{
				tRow.setValue("RCENA", tRow.getValue("RCENA") * kurs);				
			}
			ExecuteSQL("UPDATE "+ nk.bufName +" SET fcena=fcena*"+ kurs);
			recalcSum();				
		}
		objDoc.setVar("HVAL", oVal.getCod());
	}
}

function gridMenuInit()
{
	if(!tblRows.isEmpty())
	{
		if(IsDblClick())
		{
			gridMenuRun("EDIT");
			return true;
		}
		
		grid.AddMenuItem("MAKE_PN", "Сформувати прибуткову накладну|Сформировать приходную накладную");
		grid.AddMenuItem("","");
	}
	nk.loadMenu(grid);	
}

function gridMenuRun(ID)
{
	switch(ID)
	{
		case "EDIT":
		case "COPY":
			grid.runGridMenu(ID);
			return true;
		
		case "MAKE_PN":
			if(extPar.mode!="EDIT")
			{
				alert(ru("Необходимо сохранить документ перед формированием накладных.\n" 
							+ "Сохраните документ и зайдите в режиме редактирования",
						"Необхідно зберегти документ перед формуванням накладних.\n" 
							+ "Збережіть документ и зайдіть у режимі редагування")
						);
				return;
			}
			make_PN();
			break;
		
		default:
			nk.processMenu(ID, grid);
			return true;
	}
}

function make_PN()
{	
	/*
	var oSnap = getSnap("select s.FDOC_NUM, s.FDOC_DAT "
						+" from ^DOC_LINKS l "
							+" inner join ^SCH_ZAG s on s.FWID=l.FDOCWID"
						+" where l.FMAINWID="+ objDoc.getID()
						);
	if(oSnap)
	{
		var sMsg = UR("Для цього замовлення вже сформована прихідна накладна "
						+"№ "+ oSnap[0] +" на дату "+ StrDat(oSnap[1], "DMY") 
						+"!\nЗформувати повторно?"
					+"|Для этого заказа уже сформирована приходная накладная "
						+"№ "+ oSnap[0] +" на дату "+ StrDat(oSnap[1], "DMY") 
						+"!\nСформировать повторно?"
					);
		if(!confirm(sMsg))
			return false;
	}
	*/
	var post = oOrg.getCod();
	
	var par = new Object();
	par.isZaval = true;
	par.doc     = "PN";
	par.nop     = 0;
	par.calc    = 0;
	par.escape  = true;
	par.mode = "GETORDER";
	par.ret = new Object();
	par.ret.fnop = null;
	par.title = UR("Виберіть папку|Выберите папку");
	showWindow("l_cl_lnk.xml", SW_MODAL, par);	
	if(par.escape)
		return;
	
	var nop = par.ret.fnop;
	var doc = par.doc;
	var calc = par.calc;
	
	var par = new Object();
	par.Fnop   = par.nop = nop;
	par.escape = true;
	par.Fdoc   = doc;
	par.Fcalc  = calc;
	par.submode= "GETORDER";
	par.Fpost  = post;
	par.val = oVal.getCod();
	
	var rowID = grid.getTable().getRowID();
	var sWhere = " FWID="+ sqlTo(rowID);
	if(grid.getSelectedCount()>0)
		sWhere = grid.getSqlSelected();
	var tbl = OpenTable("SELECT * FROM "+ nk.bufName +" WHERE "+ sWhere);
	par.tblFrom = tbl;
			
	var oDocPN = new DpDoc(doc, nop);
	var ret = oDocPN.edit("ADD", null, par);	
	if (ret)
	{
		var m = new Object(); 
		m.FMAINWID = objDoc.getID();
		m.FDOCWID = oDocPN.getID();
		m.Fdoc = doc;
		m.Fnop = nop;
		m.FISPARENT = true;
		m.FWID = GetUID();
		updateTable("^DOC_LINKS", m, true);
		
		var m = new Object(); 
		m.FMAINWID = oDocPN.getID();
		m.FDOCWID = objDoc.getID();
		m.Fdoc = objDoc.sDocLbl;
		m.Fnop = Number(objDoc.nNop);
		m.FISPARENT = false;
		m.FWID = GetUID();
		updateTable("^DOC_LINKS", m, true);
	}
}

include("sys\\DpBaseDlg.js");