include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpNmkl.js");
include("Objects\\DpPrList.js");

var objDoc = extPar.doc;
var m = new Object();

function Load()
{		
	var pricetyp = objDoc.getPar("_pricetyp");
	var priceuse = objDoc.getPar("_priceuse");
	var nmklsel = objDoc.getPar("_nmklsel");
	var otpsel = objDoc.getPar("_otpsel");
	
	var rowmol = objDoc.getPar("_rowmol");
	var rowpdr = objDoc.getPar("_rowpdr");
	var rowpst = objDoc.getPar("_rowpst"); 
	
	objDoc.isBuf = false;
		
	nk = new DpNakl(objDoc, this);	
	nk.load();
		
	FDOC_NUM.mask = MASK_DOCNUM;
	HSUMOC.mask   = HNDSO.mask    
				  = HSUMSNDSO.mask 
				  = FSUM_AKC.mask 
				  = MASK_SUM;
	FKOL.mask     = MASK_KOL;
	FPCENANO.mask = "#";	
	FPTYPE.mask   = "&";
	
	var objNmkl = new DpNmkl();
	nds = Number(objNmkl.getExt("_NDS"));
	
	oVal = new DpVal();
	oVal.linkCtrl(TFVAL);
	oVal.linkCtrlKurs(FVKURS);
	
	oSc = new DpSc();	
	oSc.linkCtrl(FSC, FSU, FST);	
	oSc.setMode("c0ut");	
	
	objPost = new DpCl();
   	objPost.linkCtrl(FDBKR,FDBKR_TXT);
	objPost.setClcl(getPar("CODPLAT"));	
	
	objPodr = new DpCl();
   	objPodr.linkCtrl(FPODR,FPODR_TXT);
	objPodr.setClcl(sprPodr);
	
	objMol = new DpCl();
   	objMol.linkCtrl(FMOL,FMOL_TXT);
	objMol.setClcl(sprMol);
	
	objMol.setMode( rowmol?	 "0!" : "");
	objPodr.setMode( rowpdr? "0!" : "");
	objPost.setMode( rowpst? "0!" : "");
	
	objPr = new DpPrList();
	objPr.linkCtrl(FPTYPE);
		
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	ctrlLinker.addLink("HVKURS",FVKURS);
	ctrlLinker.addLink("HSC",FSC);
 	ctrlLinker.addLink("HSU",FSU);
 	ctrlLinker.addLink("HST",FST);
	ctrlLinker.addLink("HFIO",FIO_POL);	
	ctrlLinker.addLink("HDVNOM",FDOV_NUM);
	ctrlLinker.addLink("HDVDAT",FDOV_DAT);
	//ctrlLinker.addLink("HP",FPTYPE);	
	ctrlLinker.addLink("HPN",FPCENANO);
	ctrlLinker.addLink("HPNDS",FNDS_PROC);
	ctrlLinker.addLink("HSNDS",HNDSO);
	ctrlLinker.addLink("HSUM",HSUMOC);
	ctrlLinker.addLink("HSAKC",FSUM_AKC);	
	ctrlLinker.addLink("HKOL",FKOL);	
	ctrlLinker.addClLink("HPLCH",objPost);	
		
	ctrlLinker.updateData(false);
	
	if (extPar.mode == "ADD")
	{
		objPr.setCod(pricetyp);
		FPCENANO.value = priceuse;	
		FNDS_PROC.value = nds;
	}
	else
	{
		objPr.setCod(objDoc.getVar("HP"));
		
		oVal.setCod(objDoc.getVar("HVAL"));
		oVal.setKurs(objDoc.getVar("HVKURS"));	
		
		objPost.setCod(objDoc.getVar("HPLCH"));
   		objPodr.setCod(objDoc.getVar("HPODR"));   		
   		objMol.setCod(objDoc.getVar("HMOL"));	
		
		oSc.set(objDoc.getVar("HSC"),
   				objDoc.getVar("HSU"),
   				objDoc.getVar("HST"));
   				
   		if(objDoc.getVar("HPNDS")!=0)
   			FNDS_PROC.value = nds;
	}		

	if(nmklsel == 1 || otpsel == 1)
	{
		objPr.setMode("0");
		Enable(FPTYPE);
		Enable(FPCENANO);
	}
	else
	{
		objPr.setMode("");
		Disable(FPTYPE);
		Disable(FPCENANO);
	}
	
	Disable(HSUMOC);
	Disable(HNDSO);
	Disable(HSUMSNDSO);
	Disable(FSUM_AKC);
	Disable(FKOL);
		
	setFocus(FDOC_NUM);	
	setValid(FNDS_PROC, recalcSum);
	setValid(FDOC_DAT, recalcSum);
	setValid(FVKURS, recalcSum);
	setValid(TFVAL, recalcSum);	
	recalcSum();
}

function recalcSum()
{		
	nk.nds = Number(FNDS_PROC.value);
	nk.wItog(m);	
	
	var hsumoC = m.hsumoC;			//сумма в валюте
	var hndso = m.hndso;			//сумма НДС	
	var dt = FDOC_DAT.value;
	var kod1 = oVal.getNazv();
	var kurs = FVKURS.value;
	if (m.hsumoC != null)
		hsumoC = _nv2nv("", dt, kod1, m.hsumoC, 0, kurs, 1);
	if(m.hndso)	
		hndso = _nv2nv("", dt, kod1, m.hndso, 0, kurs, 1);
	
	FKOL.value = m.hKol;
	HSUMOC.value = hsumoC;						//сумма без НДС
	//HNDSO.value = round((hsumoC * nds)/100, 2);	//НДС
	HNDSO.value = round(hndso, 2);
	HSUMSNDSO.value = Number(HNDSO.value) + Number(HSUMOC.value); //сумма с НДС	
}

function updateData()
{	
	ctrlLinker.updateData(true);
	objDoc.setVar("HVAL",	oVal.getCod());
	objDoc.setVar("HPOST",	objPost.getCod());
	objDoc.setVar("HPLCH",	objPost.getCod());
	objDoc.setVar("HPODR",	objPodr.getCod());
	objDoc.setVar("HMOL",	objMol.getCod());	
	objDoc.setVar("HP",		objPr.getCod());		
}		

function onSave()
{		
	updateData();
	
	objDoc.setVar("HSMTOV",	m.Fsum_tov);
	objDoc.setVar("HSBTOV",	m.Fseb_tov);
	objDoc.setVar("HSMMAT",	m.Fsum_mat);
	objDoc.setVar("HSBMAT",	m.Fseb_mat);	
	objDoc.setVar("HOSTAR",	m.Fsum_tar);
	objDoc.setVar("HUSTAR",	m.Fseb_tar);	
	objDoc.setVar("HTOTL",	m.hIsRasc);	
	objDoc.setVar("HSNDS1",	m.hndsu);
	objDoc.setVar("HPSUM",	m.hsumuc);
	objDoc.setVar("HKOL",	m.hKol);
	objDoc.setVar("HNR",	m.hNr);
	
	nk.saveRows();		
}
			
include("sys\\DpBaseDlg.js");