include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpSc.js");
include("Objects\\DpCl.js");
include("Objects\\DpNmkl.js");

var objDoc = extPar.doc;
var m = new Object();
var nk_issch  = objDoc.getPar("nk_issch")// "Запрашивать счет приходования в строке"

function Load()
{
	objDoc.isBuf = true;	
	
	nk = new DpNakl(objDoc, this);
	nk.load();
	
	var objNmkl = new DpNmkl();
	nds = Number(objNmkl.getExt("_NDS"));
	
	FDOC_NUM.mask = MASK_DOCNUM;
	HSUMUCV.mask  = MASK_SUM;
	FKOL.mask     = MASK_KOL;
	
	oSc = new DpSc();	
	oSc.linkCtrl(FSC, FSU, FST);
	if(!nk_issch)
		oSc.setMode("cut");
	
	objPodr = new DpCl();
   	objPodr.linkSmartCtrl(FPODR);
	objPodr.setClcl(sprPodr);
	
	objMol = new DpCl();
   	objMol.linkSmartCtrl(FMOL);
	objMol.setClcl(sprMol);
	
	objPodr1 = new DpCl();
   	objPodr1.linkSmartCtrl(FPODR1);
	objPodr1.setClcl(sprPodr);
	
	objMol1 = new DpCl();
   	objMol1.linkSmartCtrl(FMOL1);
	objMol1.setClcl(sprMol);
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addScLink("HSC", "HSU","HST","","","", oSc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	ctrlLinker.addLink("HSC",FSC);
 	ctrlLinker.addLink("HSU",FSU);
 	ctrlLinker.addLink("HST",FST);
 	ctrlLinker.addLink("HUSUM",HSUMUCV);	
	ctrlLinker.addLink("HKOL",FKOL);
	ctrlLinker.addClLink("HMOLOT",objMol);
	ctrlLinker.addClLink("HPODROT",objPodr);
	ctrlLinker.addClLink("HPODRTO",objPodr1);
	ctrlLinker.addClLink("HMOLTO",objMol1);
	
	ctrlLinker.updateData(false);
	
	if (extPar.mode == "COPY" || extPar.mode == "EDIT")
	{			
/*		objPodr.setCod(objDoc.getVar("HPODROT"));   		
   		objMol.setCod(objDoc.getVar("HMOLOT"));
   		objPodr1.setCod(objDoc.getVar("HPODRTO"));   		
   		objMol1.setCod(objDoc.getVar("HMOLTO"));	
		
		oSc.set(objDoc.getVar("HSC"),
   				objDoc.getVar("HSU"),
   				objDoc.getVar("HST"));
*/ 
	}

	//при формировании по счет-фактуре или для услуг
	if(extPar.submode == "GETORDER")
	{
		this.sMode = "COPY";
		if(extPar.Fdate)
			FDOC_DAT.value = extPar.Fdate;
		if(extPar.FDOC_NUM)
			FDOC_NUM.value = extPar.FDOC_NUM;
		objPodr.setCod(extPar.Fpodr);
		objMol.setCod(extPar.Fmol);
		objPodr1.setCod(extPar.Fpodr1);
		objMol1.setCod(extPar.Fmol1);
		//nk.modifyData("COPY", nk.bufName, nk.fields2copy, extPar.tblFrom, objDoc.nOldID);
		nk.loadFrom(extPar.tblFrom);
	}
	
	Disable(HSUMUCV);
	Disable(FKOL);	
		
	setFocus(FDOC_NUM);
	nk.refreshViewer();
	//recalcSum();
}

function recalcSum()
{	
	nk.wItog(m);
	
	//m.hndsu = round((m.hndsu * nds)/100,2);
	//m.hndso = round((m.hndso * nds)/100,2);
	
	FKOL.value = m.hKol;
	HSUMUCV.value = m.hsumoC;	
}

function updateData()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HPODROT",objPodr.getCod());
	objDoc.setVar("HMOLOT",objMol.getCod());
	objDoc.setVar("HPODR",objPodr.getCod());
	objDoc.setVar("HMOL",objMol.getCod());
	objDoc.setVar("HPODRTO",objPodr1.getCod());
	objDoc.setVar("HMOLTO",objMol1.getCod());
	objDoc.setVar("HP",   objDoc.getPar("_pricetyp"));	
	objDoc.setVar("HPN",  objDoc.getPar("_priceuse"));	
}

function onSave()
{
	updateData();	
	
	objDoc.setVar("HSMTOV",	m.Fsum_tov);
	objDoc.setVar("HSBTOV",	m.Fseb_tov);
	objDoc.setVar("HSMMAT",	m.Fsum_mat);
	objDoc.setVar("HSBMAT",	m.Fseb_mat);	
	objDoc.setVar("HOSTAR",	m.Fsum_tar);
	objDoc.setVar("HUSTAR",	m.Fseb_tar);	
	objDoc.setVar("HTOTL",	m.hIsRasc);
	objDoc.setVar("HSNDS",	m.hndso);	
	objDoc.setVar("HPSUM",	m.hsumuc);
	objDoc.setVar("HSUM",	m.hsumuc);		
	objDoc.setVar("HSNDS1",	m.hndsu);		
	objDoc.setVar("HNR",	m.hNr);
	
	nk.saveRows();
}

function docMenuInit()
{
	grid.AddMenuItem("LOADOSTPM","Завантажити залишки|Загpузить остатки");	
}

function docMenuHandler(id)
{
	switch(id)
	{
		case "LOADOSTPM":
			//vvs 17.12.2007
			//Запросим счет, с которого перемещаем
			include("objects\\DpAskEx.js");
			oA = new DpAskEx();
			oA.strUseDefsOnly = "SC";
			var defVal = objDoc.getVar("HSC") + "|" + objDoc.getVar("HSU") + "|" + objDoc.getVar("HST");
			oA.add("C0UT", "Рахунок, з якого переміщуємо|Счет, с которого перемещаем", "SC", defVal);
			if(!oA.doAsk())
			{
				return;
			}
			var oScFrom = oA.get("SC");

			if (!nk.tbl4Grid.IsEmpty() )
			{
				if (!confirm(ru("При формировании остатков все существующие\nстроки будут удалены. Продолжить?",
								"При формуваннi залишкiв всi iснуючi\nрядки будуть видаленi. Продовжити?")))
					return;
				
				var tbl = OpenTable(nk.bufName);
				for (; !tbl.IsEOF(); tbl.MoveNext())
				{
					objDoc.deleteRow("ROW", toScrObj(tbl.getValue("FWID")));
				}
				tbl.close(5652);
				tbl = null;
				ExecuteSQL("DELETE FROM " + nk.bufName);

				nk.tbl4Grid.requery();
			}
			
			__noWait = true;
			WAITTIMER(ru("Рассчитываются остатки...", "Розpаховуються залишки..."))

			include("mtr_ost.js");
			oOb = new DpMtrOb();
			with( oOb )
			{
				fdate = objDoc.getVar("HDAT");

				//fruckt
				/*
				fsc = objDoc.getVar("HSC");
				fsu = objDoc.getVar("HSU");
				fst = objDoc.getVar("HST");
				*/
				
				fsc = oScFrom.getSc();
				fsu = oScFrom.getSu();
				fst = oScFrom.getSt();

				fpodr = objDoc.getVar("HPODR");
				fmol = objDoc.getVar("HMOL");

				doCalc();				
			}

			strSQL = " UPDATE "+oOb.tblName
					+" SET  FSC1 = "+sqlTo(oScFrom.getSc())
						+", FSU1 = "+sqlTo(oScFrom.getSu())
						+", FST1 = "+sqlTo(oScFrom.getSt())
			ExecuteSQL(strSQL);
			
			strSQL = " SELECT OST.* "
					+" FROM "+ oOb.tblName +" OST "
						+" LEFT JOIN ^CL_NMK CL ON OST.FNMKL = CL.FWID "
					+" ORDER BY "
						+" CL.FCOD "
			var temp_tbl = OpenTable(strSQL);

			oOb = null;

			// Net 09.12.2011  может здесь не только на пустоту проверять?
			// а то если будут отрицательные остатки, загрузит строки все равно.
			if(temp_tbl.IsEmpty())
			{
				temp_tbl.close(5652);
				temp_tbl = null;
				CLEARWAIT();
				alert(ru("Остатков нет!", "Залишків немає!"));
				return;
			}

			include("Objects\\DpClNo.js");
			for (temp_tbl.MoveFirst(); !temp_tbl.IsEOF(); temp_tbl.MoveNext())
			{
				oDocRow = objDoc.createRow("ROW");
				objDoc.appendRow("ROW", oDocRow);					

				oDocRow.setVar("R1DAT",	objDoc.getVar("HDAT"));
				oDocRow.setVar("RNOM",	findFreeClNo(nk.bufName, "fnom_str"));
				oDocRow.setVar("R1KOL",	temp_tbl.getValue("FOST1"));
				oDocRow.setVar("RKOLF",	temp_tbl.getValue("FKOL_FAS"));
				oDocRow.setVar("RSC",	temp_tbl.getValue("Fsc"));
				oDocRow.setVar("RSU",	temp_tbl.getValue("Fsu"));
				oDocRow.setVar("RST",	temp_tbl.getValue("Fst"));
				oDocRow.setVar("RCTYPE",temp_tbl.getValue("FCTYPE"));
				oDocRow.setVar("RSOTL",	temp_tbl.getValue("Fis_otl"));
				oDocRow.setVar("RTNMK",	temp_tbl.getValue("Fnmkl"));
				oDocRow.setVar("REDI",	temp_tbl.getValue("FEDI"));
				oDocRow.setVar("RUCENA",temp_tbl.getValue("Fcena"));
				oDocRow.setVar("RPCENE",temp_tbl.getValue("F1cena"));
				oDocRow.setVar("RKOL",	temp_tbl.getValue("FOST"));
				oDocRow.setVar("RKOLSPR",temp_tbl.getValue("Fkol_spr"));
				oDocRow.setVar("RPODR",	temp_tbl.getValue("FPodr"));
				oDocRow.setVar("RMOL",	temp_tbl.getValue("Fmol"));
				oDocRow.setVar("R1OCENA",temp_tbl.getValue("Fcena"));
				oDocRow.setVar("RVCENA",temp_tbl.getValue("Fvcena"));
				oDocRow.setVar("R1ID",	temp_tbl.getValue("Fid_pn"));
				oDocRow.setVar("RPOST",	temp_tbl.getValue("Fpost"));

				//vlad 28.10.10
				//По образцу DpNakl::loadFrom()
				oDocRow.setVar("R0ID",	temp_tbl.getValue("Fid_pn0"));
				oDocRow.setVar("RSUM",	temp_tbl.getValue("Fsum"));
				oDocRow.setVar("RCENAORD",	temp_tbl.getValue("Fcena_ord"));
				oDocRow.setVar("ROCENA",	temp_tbl.getValue("Fcena"));
				oDocRow.setVar("RFOCENA",	temp_tbl.getValue("Fcena"));
				oDocRow.setVar("R1SVAL",	temp_tbl.getValue("Fvcod"));
				oDocRow.setVar("RSC1",	oSc.getSc());
				oDocRow.setVar("RSU1",	oSc.getSu());
				oDocRow.setVar("RST1",	oSc.getSt());
				oDocRow.setVar("RORG",	temp_tbl.getValue("FCLIENT"));
				oDocRow.setVar("RSNDS",	temp_tbl.getValue("Fis_nds"));
				oDocRow.setVar("RDISCOUNT",	temp_tbl.getValue("FDISCOUNT"));
				oDocRow.setVar("RTYPE",	objDoc.getAttr("RTYPE"));
				
				//fruckt
				var par_ispn1 = toScrObj(objDoc.getPar("_ispn1"));
				var r2id = oDocRow.getVar("R1ID");
				if (par_ispn1 == true)
				{
					r2id = GetNextUID(oDocRow.getID(), false);
				}
				oDocRow.setVar("R2ID", r2id);

				obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, nk.bufName);				
			}
			
			temp_tbl.close(5652);
			temp_tbl = null;
			CLEARWAIT();
			__noWait = false;
		break;
		
		default: 
			return false;	
	}
}

function onChangeNop()
{
	objDoc = extPar.doc;
	
	nk_issch  = objDoc.getPar("nk_issch");
	if(!nk_issch)
		oSc.setMode("cut");
		
	grid.DeletePages();
	nk.loadGrid();
}
			
include("sys\\DpBaseDlg.js");