//include("doc\\nakl\\DpNkRow.js");
include("objects\\DpNmkl.js");
include("Objects\\DpClNo.js");
include("Objects\\DpSc.js");

var objDoc = extPar.objDoc;
var sTmpTbl = "TMP_BUF_SN";	
var gridTbl;
var oNmkl;
var oSc = new DpSc("cut");

function Load()
{		
	Caption(ru("Редактирование приходной накладной","Редагування прибуткової накладної"));			
	
	oNmkl = new DpNmkl();
	oNmkl.SetNakl(objDoc);
	oNmkl.linkCtrl(Fnmkl, tFnmkl, tFedi);
	oNmkl.setContAssist();
					
	Fcena.mask = MASK_CENA;
	Fsum.mask = MASK_CENA;
	Fkol.mask = MASK_KOL;
	
	setFocus(Fsn);
		
	Disable(Fsum);
	Disable(Fkol);
	
	gridInit();
	
	this.addRow = addRow;
	setButton(btnAdd, this, "addRow");
	Fsn.setEnterHandler(enterSN);
	
}

function enterSN()
{
	if (Fsn.value == "") return;
	addRow();
	Fsn.value = "";
	setFocus(Fsn);	
}

function gridInit()
{
	createTbl(sTmpTbl);
	
	gridTbl = OpenTable("select * from "+ sTmpTbl +" order by fnmkl,fsn");
	gridTbl.tie("CL_NMK", "nmk", "FWID", "FNMKL");
	grid.setTable(gridTbl);	
	
	grid.FieldEx("FNMKL", "Номенклатура|Номенклатура", 15);
	grid.FieldEx("FSN", "Сер.номер", 10);
	grid.FieldEx("FCENA", "Ціна|Цена", 10);
	grid.build();
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid.loadMenuHandler(this,"gridMenuInit");
	grid.selectMenuHandler(this,"gridMenuRun");
}

function gridMenuInit()
{
	if(!grid.getTable().isEmpty())
		grid.AddMenuItem("DEL", "Видалення|Удаление");	
}

function gridMenuRun(sID)
{	
	if(sID=="DEL")
	{
		var sSQL = "DELETE FROM "+ sTmpTbl
				+" WHERE FWID="+ gridTbl.getValue("FWID");
		ExecuteSQL(sSQL);
		gridTbl.requery();
		grid.refresh();
		recalcSum();
	}
}

function createTbl(sTblName)		
{
	ExecuteSQL("drop table "+ sTblName, false);
	sSql = "create table "+ sTblName 
			+"(FNMKL "+ SqlType("INT") 
			+", FSN "+ SqlType("TEXT")
			+", FCENA "+ SqlType("CURRENCY")
			+", FWID "+ SqlType("COUNTER")
			+")";
	ExecuteSQL(sSql, false);
}

function addRow()
{
	var m = new Object();
	m.FNMKL = oNmkl.getCod();
	m.FSN = Fsn.value;
	m.FCENA = Fcena.value;
	
	UpdateTable(sTmpTbl, m, true);
	
	gridTbl.requery();
	grid.refresh();	
	recalcSum();
}

function recalcSum()
{
	Fsum.value = 0;
	Fkol.value = 0;
	var oSnap = getSnap("select sum(FCENA) from "+ sTmpTbl);
	if(oSnap)
		Fsum.value = oSnap[0];
	oSnap = getSnap("select count(*) as Fkol from "+ sTmpTbl);
	if(oSnap)
		Fkol.value = oSnap[0];
}

function onSave()
{			
	var nom = findFreeClNo(extPar.bufName, "fnom_str");
	for(gridTbl.MoveFirst(); !gridTbl.isEOF(); gridTbl.MoveNext())
	{
		var oRow = objDoc.createRow("ROW");		
		with(oRow)	
		{
			setVar("RNOM",	 nom++);
			oSc.set(objDoc.getVar("HSC"), objDoc.getVar("HSU"), objDoc.getVar("HST"));
			setVar("RCTYPE", oSc.getType());
			if(oNmkl.Fis_pn1 == '+')
				setVar("R1ID",	 oRow.getID());
			setVar("RCENAORD", oNmkl.Fis_sred==false? gridTbl.getValue("Fcena") : 0);			
			setVar("RSUM",	 gridTbl.getValue("Fcena"));
			setVar("RSN",	 gridTbl.getValue("Fsn"));						
			setVar("RKOL",	 1);												
			setVar("RUCENA", gridTbl.getValue("Fcena"));							
			setVar("RPCENE", gridTbl.getValue("Fcena"));
			setVar("R1OCENA",gridTbl.getValue("Fcena"));							
			setVar("RTNMK",	 gridTbl.getValue("Fnmkl"));						
			setVar("R1DAT",	 objDoc.getVar("HDAT"));
			setVar("RSC",	 objDoc.getVar("HSC"));
			setVar("RSU",	 objDoc.getVar("HSU"));
			setVar("RST",	 objDoc.getVar("HST"));			
			setVar("RPODR",	 objDoc.getVar("HPODR"));
			setVar("RORG",	 objDoc.getVar("HORG"));
			setVar("RMOL",	 objDoc.getVar("HMOL"));
			setVar("RPOST",	 objDoc.getVar("HPOST"));			
		}
		objDoc.appendRow("ROW", oRow);
		obj2DB(oRow.getID(), oRow.jDocRow, null, extPar.bufName);
	}
	extPar.nk.refreshViewer();
	//extPar.grid.getTable().requery();
	//extPar.grid.refresh();
	return false;
}

include("sys\\DpBaseDlg.js");