include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpNmkl.js");
include("sys\\kursval.js");

var objDoc = extPar.doc;
var m = new Object();
var calcnds = objDoc.getPar("_calcnds"); //Способ рассчёта НДС
var Fnds, nds;
var oVal;
var nk_isschanalit;

function Load()
{
	if(!objDoc && typeof extPar != "undefined")
		objDoc = new DpDoc(extPar.Fdoc, extPar.Fnop);
		
	var handnds = objDoc.getPar("_handnds");		
	var nk_issch = objDoc.getPar("nk_issch");
	nk_isschanalit = objDoc.getPar("_showan");
	
	objDoc.isBuf = true;	
	
	nk = new DpNakl(objDoc, this);	
	nk.load();	
	
	FDOC_NUM.mask  = MASK_DOCNUM;
	HSUMU0V.mask   = HSUMUC.mask = HNDSU.mask  = MASK_SUM;
	FKOL.mask      = MASK_KOL;
	
	//var objNmkl = new DpNmkl();
	//nds = Number(objNmkl.getExt("_NDS"));
	
	oVal = new DpVal();
	oVal.linkCtrl(TFVAL);
	oVal.linkCtrlKurs(FVKURS);
	
	oSc = new DpSc();
	
	if(nk_issch)
		oSc.setMode(nk_isschanalit?"cut00xyz":"cut00");
	else
		oSc.setMode(nk_isschanalit?"cutxyz":"cut");
	
	if (nk_isschanalit)
	{
		GroupSCAN.visible = true;		
		GroupSC.pack();
		oSc.linkCtrl(FSC, FSU, FST, FAN1, FAN2, FAN3);
	}
	else
	{
		GroupSCAN.visible = false;
		oSc.linkCtrl(FSC, FSU, FST);
	}
	
	
	objPost = new DpCl();
   	//objPost.linkCtrl(FDBKR,FDBKR_TXT);
   	objPost.linkSmartCtrl(FDBKR);
	objPost.setClcl(getPar("CODPLAT"));
	objPost.setContAssist();
	
	objPodr = new DpCl();
   	//objPodr.linkCtrl(FPODR,FPODR_TXT);
   	objPodr.linkSmartCtrl(FPODR)
	objPodr.setClcl(sprPodr);
	objPodr.setContAssist();
	
	objMol = new DpCl();
   	//objMol.linkCtrl(FMOL,FMOL_TXT);
   	objMol.linkSmartCtrl(FMOL);
	objMol.setClcl(sprMol);
	objMol.setContAssist();
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",	 FDOC_NUM);
	ctrlLinker.addLink("HDAT", 	 FDOC_DAT);
	if (nk_isschanalit)
		ctrlLinker.addScLink("HSC", "HSU","HST","HA1","HA2","HA3", oSc);
	else
		ctrlLinker.addScLink("HSC", "HSU","HST","","","", oSc);
	//ctrlLinker.addLink("HSC",	 FSC);
 	//ctrlLinker.addLink("HSU", 	 FSU);
 	//ctrlLinker.addLink("HST",	 FST);	
	
 	ctrlLinker.addLink("HPNDS",	 FNDS_PROC);
	ctrlLinker.addLink("HSNDS",	 HNDSU);
	ctrlLinker.addLink("HANDNDS",FHANDNDS);
	ctrlLinker.addLink("HSUM",	 HSUMU0V);
	ctrlLinker.addLink("HPSUM",	 HSUMUC);	
	ctrlLinker.addLink("HKOL", 	 FKOL);
	ctrlLinker.addLink("HVKURS", FVKURS);
	ctrlLinker.addClLink("HPOST",objPost);	
	ctrlLinker.addClLink("HMOL", objMol);
	ctrlLinker.addClLink("HPODR",objPodr);				

	ctrlLinker.updateData(false);
	
	if (extPar.mode == "ADD")
	{
		if (handnds)
			FHANDNDS.checked = true;
		FNDS_PROC.value = nds;
				
		//если есть значения по умолчанию для папки - ставим их!!!		
		var defSC = Number(oSc.ctrlSc.value);
		var defSU = Number(oSc.ctrlSu.value);
		var defST = Number(oSc.ctrlSt.value);		
		if(defSC || defSU || defST)
			oSc.set(defSC, defSU, defST);			
		else
			oSc.set(getPar("DEF_NK_SC"), getPar("DEF_NK_SU"), getPar("DEF_NK_ST"));
		
	}
	else
	{
		oVal.setCod(objDoc.getVar("HVAL"));
		oVal.setKurs(objDoc.getVar("HVKURS"));	
		
		objPost.setCod(objDoc.getVar("HPOST"));
   		objPodr.setCod(objDoc.getVar("HPODR"));   		
   		objMol.setCod(objDoc.getVar("HMOL"));	
		
		if (nk_isschanalit)
			oSc.set(objDoc.getVar("HSC"),
   				objDoc.getVar("HSU"),
   				objDoc.getVar("HST"),
   				objDoc.getVar("HA1"),
   				objDoc.getVar("HA2"),
   				objDoc.getVar("HA3"));
		else
			oSc.set(objDoc.getVar("HSC"),
	   				objDoc.getVar("HSU"),
	   				objDoc.getVar("HST"));
   				
   		//if(objDoc.getVar("HPNDS")!=0)
   		//	FNDS_PROC.value = objDoc.getVar("HPNDS");
	}
	
	//при формировании накладной
	if(extPar.submode == "GETORDER")
	{
		objPost.setCod(extPar.Fpost);
   		objPodr.setCod(extPar.Fpodr);   		
   		objMol.setCod(extPar.Fmol);
   		if(extPar.val)
   			oVal.setCod(extPar.val);
   		nk.loadFrom(extPar.tblFrom);
	}
	
	Disable(HSUMU0V);
	Disable(HSUMUC);
	Disable(FKOL);
	
	switch (getPar("NKSCSHOW"))
	{
	case "disable":
		Disable(FSC)
		Disable(FSU)
		Disable(FST)
		if (nk_isschanalit)
		{
			Disable(FAN1);
			Disable(FAN2);
			Disable(FAN3);
		}
		break;
	case "hide":
		GroupSC.setVisible(false);
	}
	
	setValid(FHANDNDS, recalcSum);
	setValid(FNDS_PROC, recalcSum);	
	setValid(FDOC_DAT, recalcSum);	
	setValid(FVKURS, recalcSum);
	setValid(TFVAL, recalcSum);	
	
	this.initGridEdit = E_PN_initGridEdit;
	
	if(objDoc.getPar("_gridedit"))
		this.initGridEdit();
	
	if (extPar.mode == "EDIT")
	{
		grid.setFocus();
	}
	else
		setFocus(FDOC_NUM);	
	
	if(extPar.mode!="ADD")
		recalcSum();	
}

function E_PN_initGridEdit()
{
	include("gridedit.js");
	var rowpst = (objDoc.getPar("_rowpst") == true);
	this.dpGridEdit = new DpGridEdit(grid);
	this.dpGridEdit.init = DpNakl_addRecord;
	this.dpGridEdit.saveRecord = DpNakl_saveRecord;
	this.dpGridEdit.addValidField("nmk.fcod", DpNakl_startEdit_fnmkl, DpNakl_endEdit_fnmkl);
	this.dpGridEdit.addValidField("=^Fedi==1? (^Fkol/^nmk.Fedikf1) : ^Fkol", DpNakl_startEdit_fkol, DpNakl_endEdit_fkol);
	this.dpGridEdit.addValidField("=^Fedi==1? (^F1cena*^nmk.Fedikf1) : ^F1cena", DpNakl_startEdit_f1cena, DpNakl_endEdit_f1cena);
	//this.dpGridEdit.addValidField("=(^Fedi==1? ^Fcena*^nmk.Fedikf1 : ^Fcena)", DpNakl_startEdit_fcena, DpNakl_endEdit_fcena);
	this.dpGridEdit.addValidField("=^Fedi==0? ^edi1.Ftxts : ^edi2.Ftxts", DpNakl_startEdit_fedi, DpNakl_endEdit_fedi);
	var ci = grid.getColumn("=^Fedi==0? ^edi1.Ftxts : ^edi2.Ftxts");
	ci.addEditOption(0,"");
	
	var issch = (objDoc.getPar("nk_issch") == true);
	if (issch)
	{
		var ci = grid.getColumn("fsc");
		ci.setAttributes("e")
		var ci = grid.getColumn("fsu");
		ci.setAttributes("e")
		var ci = grid.getColumn("fst");
		ci.setAttributes("e");
		
		if (nk_isschanalit)
		{
			var ci = grid.getColumn("Fcod1");
			ci.setAttributes("e");
			var ci = grid.getColumn("Fcod2");
			ci.setAttributes("e");
			var ci = grid.getColumn("Fcod3");
			ci.setAttributes("e");
		}
		
		this.dpGridEdit.addValidField("fsc", DpNakl_startEdit_fsc, DpNakl_endEdit_fsc);
		this.dpGridEdit.addValidField("fsu", DpNakl_startEdit_fsu, DpNakl_endEdit_fsu);
		this.dpGridEdit.addValidField("fst", DpNakl_startEdit_fst, DpNakl_endEdit_fst);
		this.dpGridEdit.addValidField("fcod1", DpNakl_startEdit_fcod1, DpNakl_endEdit_fcod1);
		this.dpGridEdit.addValidField("fcod2", DpNakl_startEdit_fcod2, DpNakl_endEdit_fcod2);
		this.dpGridEdit.addValidField("fcod3", DpNakl_startEdit_fcod3, DpNakl_endEdit_fcod3);
	}
	
	
	var rowpdr = (objDoc.getPar("_rowpdr") == true);
	if (rowpdr)
	{
		var ci = grid.getColumn("fpodr");
		ci.setAttributes("e");
		this.dpGridEdit.addValidField("fpodr", DpNakl_startEdit_fpodr, DpNakl_endEdit_fpodr);
	}
	var rowmol = (objDoc.getPar("_rowmol") == true);
	if (rowmol)
	{
		var ci = grid.getColumn("fmol");
		ci.setAttributes("e");
		this.dpGridEdit.addValidField("fmol", DpNakl_startEdit_fmol, DpNakl_endEdit_fmol);
	}
	
	grid.afterEditHandler(this, "afterEditHandler");
	this.afterEditHandler = e_pp_afterEditHandler;
}
var objNmkl;

function DpNakl_addRecord()
{
	include("Objects\\DpClNo.js");
	
	with (this)
	{	
		var nom = findFreeClNo(nk.bufName, "fnom_str");
		initValue("fnom_str", new java.lang.Integer(nom));
		initValue("fkol", 0);
		initValue("fcena", 0);
		initValue("f1cena", 0);
		initValue("Fedi", 0);
		initValue("Fdate", FDOC_DAT.value);
		initValue("F1val", oVal.getCod());
		initValue("Frtype", "5");
		initValue("Fsc", new java.lang.Integer(oSc.getSc()));	
		initValue("Fsu", new java.lang.Integer(oSc.getSu()));
		initValue("Fst", new java.lang.Integer(oSc.getSt()));
		initValue("Fpodr", new java.lang.Integer(objPodr.getCod()));
		initValue("Fmol", new java.lang.Integer(objMol.getCod()));
				
	}
}


function DpNakl_saveRecord()
{
	var tblRows = grid.getTable();
	var useWID = parseInt(tblRows.getValue("fwid"));
	var docRow =  objDoc.getRow("ROW", useWID);
	if (docRow == null)
	{
		docRow = objDoc.createRow("ROW");
		docRow.setID(useWID);
		objDoc.appendRow("ROW", docRow);
	}
	with (docRow)
	{
		setVar("RNOM",  tblRows.getValue("fnom_str"));
		setVar("RSC", tblRows.getValue("fsc"));
		setVar("RSU", tblRows.getValue("fsu"));
		setVar("RST", tblRows.getValue("fst"));
		setVar("RPODR", tblRows.getValue("fpodr"));
		setVar("RMOL", tblRows.getValue("fmol"));
		
		
		setVar("RSUM", tblRows.getValue("fsum"));
		setVar("REDI", tblRows.getValue("fedi"));		
		setVar("RUCENA", tblRows.getValue("fcena"));
		setVar("RPCENE", tblRows.getValue("f1cena"));
		setVar("R1OCENA",tblRows.getValue("fcenapr"));
		setVar("RPOST", tblRows.getValue("fpost"));
		setVar("RKOL", tblRows.getValue("fkol"));		
		setVar("RTNMK",	 tblRows.getValue("fnmkl"));
		
		var oNmkl = new DpNmkl();
		oNmkl.setCod(Number(tblRows.getValue("fnmkl")));
		setVar("RPOST",  oNmkl.Fis_post?objPost.getCod():0);
		setVar("R1ID",	  oNmkl.Fis_pn1 == '+'? useWID : 0);	
		setVar("RCENAORD",oNmkl.Fis_sred==false? getVar("RUCENA") : 0);	
		setVar("RCTYPE",sctype(getVar("RSC"),getVar("RSU"), getVar("RST")));
		setVar("RTYPE","5");
		
												
	}
	
	return true;
}

function e_pp_afterEditHandler()
{
	var tblRows = grid.getTable();
	var useWID = parseInt(tblRows.getValue("fwid"));
	var docRow =  objDoc.getRow("ROW", useWID);
	if (docRow == null)
		return;
	handleEvent("afterSaveNaklRow", docRow);				
	obj2DB(docRow.getID(), docRow.jDocRow, null, nk.bufName);
	tblRows.requery();
	recalcSum();
}

function DpNakl_startEdit_fnmkl(oCtrl)
{
	var sCod = String(oCtrl.getValue());	
	objNmkl = new DpNmkl();   		
	objNmkl.linkCtrl(oCtrl);	
	objNmkl.setCod(sCod);
}

function DpNakl_endEdit_fnmkl(oCtrl)
{
	trace("endEdit_fnmkl");
	if (!objNmkl.setCod(String(oCtrl.getValue())))
	{	
		if (!objNmkl.doZaval())
			return false;
	}	
	oCtrl.setValue(objNmkl.getCod("c"));
	list.dpGridEdit.setValue("fnmkl", objNmkl.getFwid());
	var ci = grid.getColumn("=^Fedi==0? ^edi1.Ftxts : ^edi2.Ftxts");
	ci.removeAllEditOptions();
	ci.addEditOption(0,objNmkl.tFcedib);
	if(objNmkl.tFedi1!=null)
		ci.addEditOption(1,objNmkl.tFedi1);
	trace("endEdit_fnmkl 2");
	return true;
}

function DpNakl_startEdit_fedi(oCtrl)
{
	objNmkl = new DpNmkl();
	var nID =  Number(grid.getTable().getValue("fnmkl"));
	if (!nID)
		return;
	
	objNmkl.setCod(nID);
	oCtrl.clear();
	oCtrl.addItem(0,objNmkl.tFcedib);
	if(objNmkl.tFedi1 != null)
		oCtrl.addItem(1,objNmkl.tFedi1);
	oCtrl.setValue(Number(grid.getTable().getValue("fedi")));
}


function DpNakl_endEdit_fedi(oCtrl)
{
	list.dpGridEdit.setValue("fedi", Number(oCtrl.getValue()));	
}


var nKol;
function DpNakl_startEdit_fkol(oCtrl)
{
	nKol = Number(oCtrl.getValue());
}

function DpNakl_endEdit_fkol(oCtrl)
{
	var newKol = Number(oCtrl.getValue());
	list.dpGridEdit.setValue("fkol", Number(oCtrl.getValue()));
}

var n1Cena;
function DpNakl_startEdit_f1cena(oCtrl)
{
	n1Cena = Number(oCtrl.getValue());
}

function DpNakl_endEdit_f1cena(oCtrl)
{
	var newCena = Number(oCtrl.getValue());
	list.dpGridEdit.setValue("f1cena", newCena);
	//if(Number(grid.getTable().getValue("fcena")) == 0)
	
	var kod1 = oVal.getNazv();
	if(!kod1)
		kod1 = 0;
	var kurs = FVKURS.value;
	if(!kurs || kurs==0)
		kurs = 1;
	
	var nCena = _nv2nv("", FDOC_DAT.value, kod1, newCena, 0, kurs, 1);
	list.dpGridEdit.setValue("fcena", nCena);
}

function DpNakl_startEdit_fpodr(oCtrl)
{
	objPodrRow = new DpCl();   	
	objPodrRow.setClcl(getPar("CODPODR"));	
	objPodrRow.setCod(Number(oCtrl.getValue()));
	objPodrRow.linkCtrl(oCtrl);
}

function DpNakl_endEdit_fpodr(oCtrl)
{
	if (!objPodrRow.validCtrl())
		return false;
	oCtrl.setValue(Number(objPodrRow.getCod()));
	return true;
}

function DpNakl_startEdit_fmol(oCtrl)
{
	objMolRow = new DpCl();   	
	objMolRow.setClcl(getPar("CODPODR"));	
	objMolRow.setCod(Number(oCtrl.getValue()));
	objMolRow.linkCtrl(oCtrl);
}

function DpNakl_endEdit_fmol(oCtrl)
{
	if (!objMolRow.validCtrl())
		return false;
	oCtrl.setValue(Number(objMolRow.getCod()));
	return true;
}

function DpNakl_startEdit_fsc(oCtrl)
{
	oScRow = new DpSc();	
	oScRow.setMode("cut");
	oScRow.linkCtrl(oCtrl);
	var tbl = grid.getTable();
	oScRow.set(Number(tbl.getValue("fsc")),Number(tbl.getValue("fsu")),Number(tbl.getValue("fst")));
}

function DpNakl_startEdit_fsu(oCtrl)
{
	oScRow = new DpSc();	
	oScRow.setMode("cut");
	oScRow.linkCtrlSu(oCtrl);
	var tbl = grid.getTable();
	oScRow.set(Number(tbl.getValue("fsc")),Number(tbl.getValue("fsu")),Number(tbl.getValue("fst")));
}

function DpNakl_startEdit_fst(oCtrl)
{
	oScRow = new DpSc();	
	oScRow.setMode("cut");
	oScRow.linkCtrlSt(oCtrl);
	var tbl = grid.getTable();
	oScRow.set(Number(tbl.getValue("fsc")),Number(tbl.getValue("fsu")),Number(tbl.getValue("fst")));
}

function DpNakl_startEdit_fcod1(oCtrl)
{
	oScRow = new DpSc();	
	oScRow.setMode("cutx");
	oScRow.linkCtrl(null, null, null, oCtrl);
	var tbl = grid.getTable();
	oScRow.set(Number(tbl.getValue("fsc")),Number(tbl.getValue("fsu")),Number(tbl.getValue("fst")),Number(tbl.getValue("fcod1")));
}

function DpNakl_startEdit_fcod2(oCtrl)
{
	oScRow = new DpSc();	
	oScRow.setMode("cutxy");
	oScRow.linkCtrl(null, null, null, null, oCtrl);
	var tbl = grid.getTable();
	oScRow.set(Number(tbl.getValue("fsc")),Number(tbl.getValue("fsu")),Number(tbl.getValue("fst")),Number(tbl.getValue("fcod1")),Number(tbl.getValue("fcod2")));
}

function DpNakl_startEdit_fcod3(oCtrl)
{
	oScRow = new DpSc();	
	oScRow.setMode("cutxyz");
	oScRow.linkCtrl(null, null, null, null, null, oCtrl);
	var tbl = grid.getTable();
	oScRow.set(Number(tbl.getValue("fsc")),Number(tbl.getValue("fsu")),Number(tbl.getValue("fst")),Number(tbl.getValue("fcod1")),Number(tbl.getValue("fcod2")),Number(tbl.getValue("fcod3")));
}

function DpNakl_endEdit_fsc(oCtrl)
{
	oScRow._validSc();
	oCtrl.setValue(oScRow.getSc());
	grid.getTable().setValue("fsu", new java.lang.Integer(oScRow.getSu()));	
	grid.getTable().setValue("fst", new java.lang.Integer(oScRow.getSt()));
	oScRow.Release();
	return true;	
}

function DpNakl_endEdit_fsu(oCtrl)
{
	oScRow._validSu();
	oCtrl.setValue(oScRow.getSu());	
	grid.getTable().setValue("fsc", new java.lang.Integer(oScRow.getSc()));
	grid.getTable().setValue("fst", new java.lang.Integer(oScRow.getSt()));
	oScRow.Release();
	return true;	
}

function DpNakl_endEdit_fst(oCtrl)
{
	oScRow._validSt();
	oCtrl.setValue(oScRow.getSt());	
	grid.getTable().setValue("fsc", new java.lang.Integer(oScRow.getSc()));
	grid.getTable().setValue("fsu", new java.lang.Integer(oScRow.getSu()));
	oScRow.Release();
	return true;	
}

function DpNakl_endEdit_fcod1(oCtrl)
{
	oScRow.cl[0].valid();
	oCtrl.setValue(oScRow.getCl1());
	oScRow.Release();
	return true;	
}

function DpNakl_endEdit_fcod2(oCtrl)
{
	oScRow.cl[1].valid();
	oCtrl.setValue(oScRow.getCl2());
	oScRow.Release();
	return true;	
}

function DpNakl_endEdit_fcod3(oCtrl)
{
	oScRow.cl[2].valid();
	oCtrl.setValue(oScRow.getCl3());
	oScRow.Release();
	return true;	
}

function recalcSum()
{		
	nk.nds = Number(FNDS_PROC.value);
	nk.wItog(m);
	
	var hsumu1c = m.hsumu1c;
	var hndsu1 = m.hndsu1;	
		
	FKOL.value = m.hKol;	
	HSUMU0V.value = hsumu1c;	
		
	dt = FDOC_DAT.value;
	kod1 = oVal.getNazv();
	if(!kod1)
		kod1 = 0;
	kurs = FVKURS.value;
	//if(kurs==0)
	//	kurs = 1;
	kod2 = 0;
	kurs_2 = 1;
	HSUMUC.value = 0;
	if (m.hsumu1c != null)
		HSUMUC.value = _nv2nv("", dt, kod1, m.hsumu1c, kod2, kurs, kurs_2);	
	if(m.hndsu1)
		hndsu1 = _nv2nv("", dt, kod1, m.hndsu1, kod2, kurs, kurs_2);	
	/*	
	nds = Number(FNDS_PROC.value);
	m.hndso = round((m.hndso * nds)/100,2);				
	Fnds = round((hndsu1 * nds)/100, 2);
	if(calcnds == 1) //НДС - по учётной цене
		Fnds = round((m.hndsu * nds)/100, 2);	
	*/	
	Fnds = round(hndsu1, 2);
	if(calcnds == 1) 
		Fnds = round(m.hndsu, 2);	//НДС по учётной цене
	Fhandnds_Valid();
}

function Fhandnds_Valid()
{	
	Enable(HNDSU, FHANDNDS.checked);		
	if (!FHANDNDS.checked)
		HNDSU.value = Fnds;			
}

function updateData()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HVAL", oVal.getCod());
	objDoc.setVar("HPOST",objPost.getCod());
	objDoc.setVar("HPODR",objPodr.getCod());
	objDoc.setVar("HMOL", objMol.getCod());
	objDoc.setVar("HP",   objDoc.getPar("_pricetyp"));	
	objDoc.setVar("HPN",  objDoc.getPar("_priceuse"));	
}

function onSave()
{	
	updateData();
		
	objDoc.setVar("HSMTOV",	m.Fsum_tov);
	objDoc.setVar("HSBTOV",	m.Fseb_tov);
	objDoc.setVar("HSMMAT",	m.Fsum_mat);
	objDoc.setVar("HSBMAT",	m.Fseb_mat);	
	objDoc.setVar("HOSTAR",	m.Fsum_tar);
	objDoc.setVar("HUSTAR",	m.Fseb_tar);
	
	objDoc.setVar("HTOTL",	m.hIsRasc);
	objDoc.setVar("HSNDS1",	m.hndso);	
	objDoc.setVar("HUSUM",	m.hsumuc);
	objDoc.setVar("HNR",	m.hNr);
	
	var issch = (objDoc.getPar("nk_issch") == true);
	
	var rowpst = (objDoc.getPar("_rowpst") == true);
	var rowpdr = (objDoc.getPar("_rowpdr") == true);
	var rowmol = (objDoc.getPar("_rowmol") == true);
	
	var sWhere = " where fid_pn <> 0 and (fid_pn <> fwid)";
	var t = OpenTable("s", "select fwid from " + nk.bufName + sWhere);
	while (!t.isEOF())
	{
		var nID = Number(t.getValue("FWID"))
		var oRow = objDoc.getRow("ROW", nID);
		if (oRow)
			oRow.setVar("R1ID", nID);
		
		t.moveNext();
	}
	t.close();
	var sSQL = "UPDATE " + nk.bufName + " SET FID_PN = FWID " + sWhere;
	ExecuteSQL(sSQL);
	
	
	if (!issch || !rowpst || !rowpdr || !rowmol)
	{
		var sSQL = ""
		var nk_isschanalit;
		if (!issch)
		{
			sSQL += ", FSC = " + sqlTo(objDoc.getVar("HSC"))
			sSQL += ", FSU = " + sqlTo(objDoc.getVar("HSU"))
			sSQL += ", FST = " + sqlTo(objDoc.getVar("HST"))
			
			nk_isschanalit = objDoc.getPar("_showan");
			if(nk_isschanalit)
			{
				sSQL += ", Fcod1 = " + sqlTo(objDoc.getVar("HA1"))
				sSQL += ", Fcod2 = " + sqlTo(objDoc.getVar("HA2"))
				sSQL += ", Fcod3 = " + sqlTo(objDoc.getVar("HA3"))
			}
		}
		if (!rowpst)
		{
			//если номенклатура не ведется по поставщикам - FPOST=0
			var fis_post = "(select nmk.FIS_POST from ^CL_NMK nmk where nmk.FWID=FNMKL)";
			sSQL += ", FPOST = "+ IIF(fis_post +"="+ sqlTrue, sqlTo(objDoc.getVar("HPOST")), 0);				
		}
		if (!rowpdr)
		{
			sSQL += ", FPODR = " + sqlTo(objDoc.getVar("HPODR"));
		}
		if (!rowmol)
		{
			sSQL += ", FMOL = " + sqlTo(objDoc.getVar("HMOL"));					
		}
		var sSQL = "UPDATE " + nk.bufName + " SET " + sSQL.substr(1);
		ExecuteSQL(sSQL);
		
		var t = OpenTable("s", nk.bufName)
		while (!t.isEOF())
		{
			var nID = Number(t.getValue("FWID"))
			var oRow = objDoc.getRow("ROW", nID);
			if (oRow != null)
			{
				if (!issch)
				{
					oRow.setVar("RSC", objDoc.getVar("HSC"));	
					oRow.setVar("RSU", objDoc.getVar("HSU"));	
					oRow.setVar("RST", objDoc.getVar("HST"));	
					if(nk_isschanalit)
					{
						oRow.setVar("RA1", objDoc.getVar("HA1"));	
						oRow.setVar("RA2", objDoc.getVar("HA2"));	
						oRow.setVar("RA3", objDoc.getVar("HA3"));	
					}
				}
				if (!rowpst)
				{
					oRow.setVar("RPOST", t.getValue("FPOST"));						
				}
				if (!rowpdr)
				{
					oRow.setVar("RPODR", objDoc.getVar("HPODR"));						
				}
				if (!rowmol)
				{
					oRow.setVar("RMOL", objDoc.getVar("HMOL"));						
				}
			}
			t.moveNext();
		}
		t.close();
	}
	
	nk.saveRows();
}

function docMenuInit()
{
	grid.AddMenuItem("SN","Введення за серійними номерами|Ввод по серийным номерам");
}

function docMenuHandler(sID)
{
	if(sID=="SN")
	{
		var par = new Object();
		par.objDoc = objDoc;
		par.bufName = nk.bufName;
		par.grid = grid;
		par.nk = nk;
		showWindow("docs/PN/ROW/form_sn.xml", SW_MODAL, par);
		if(!par.escape)
			nk.refreshViewer();
		return true;
	}
	return false;
}

function onChangeNop()
{
	objDoc = extPar.doc;
	
	calcnds = objDoc.getPar("_calcnds");	
	handnds = objDoc.getPar("_handnds");
	if (extPar.mode=="ADD" && handnds)
		FHANDNDS.checked = true;
	
	nk_issch = objDoc.getPar("nk_issch");
	var nk_isschanalit = objDoc.getPar("_showan");
	
	if (nk_isschanalit)
	{
		GroupSCAN.visible = true;
		oSc.linkCtrl(FSC, FSU, FST, FAN1, FAN2, FAN3);
	}
	else
	{
		GroupSCAN.visible = false;
		oSc.linkCtrl(FSC, FSU, FST);
	}
	
	if(nk_issch)
	{
		oSc.setMode(nk_isschanalit?"cut00xyz":"cut00");
	}
	else
	{
		oSc.setMode(nk_isschanalit?"cutxyz":"cut");
	}
		
	grid.DeletePages();
	nk.loadGrid();
}


function getHVKURS()
{
	if (typeof FVKURS=="object")
		return Number(FVKURS.value)
	else
		return 0;
}

function onExit()
{
	if (nk)
	{
		nk.dispose();	
	}
}
	
			
include("sys\\DpBaseDlg.js");