include("Objects/DpDocEx.js");
include("Objects/DpCl.js");
include("doc/DpDoc.js");

var sTmpTbl = getTmpTableName();
var sDoc = extPar.doc;
var nNop = extPar.nop;
var oStreet;
var oHouse;
var oApart;
var oOrg;
var oLicsc;

function listLoad()
{
	this.title = UR(extPar.oDoc.getCaption()) + UR(": масове введення|: массовый ввод");
	this.save = onSave;
	this.escape = onCancel;
	
	oStreet = new DpCl("0");
	oStreet.setClcl(getPar("CODSTREET"));
	oStreet.linkSmartCtrl(FSTREET);
	//oStreet.AfterUpdate = loadStreet;
	
	oHouse = new DpCl("0", getPar("CODHOUSE"), 0, oStreet);
	oHouse.linkSmartCtrl(FHOUSE);
	oHouse.setContAssist();
	oHouse.addFldSearchSmart("FNOM");
	oHouse.isExactSearchSmart = true;
	oHouse.isCodeSearchSmart = false;
	//oHouse.AfterUpdate = loadHouse;
	
	oApart = new DpCl("0", getPar("CODAPT"), 0, oHouse);
	oApart.linkSmartCtrl(FAPART);
	oApart.setContAssist();
	
	oOrg = new DpCl("0");
	oOrg.setClcl(getPar("CODPLAT"));
	oOrg.linkSmartCtrl(FORG);
	oOrg.setContAssist();
	oOrg.AfterUpdate = loadOrg;
	oOrg.beforeZaval = orgZaval;
	
	oLicsc = new DpDocEx("LICSC", 1);
	oLicsc.linkCtrl(FLICSC);
	oLicsc.beforeZaval = licscZaval;
	oLicsc.subUpdate = loadLicsc;
	setValid(FLICSC, loadLicsc);
	
	setButton(BTNADD, insertSum);
	
	createSrcTable();
	
	FDATE.value = today;
	FSUM.mask = MASK_SUM;
	FFSUM.mask = MASK_SUM;
	Disable(FFSUM);
	
	setFocus(FSTREET);
}

function createSrcTable()
{
	var sSQL = "create table "+ sTmpTbl 
				+" (FWID "+ SqlType("COUNTER") 
				+", FDATE "+ SqlType("DATE") 
				+", FORG "+ SqlType("LONG") 
				+", FORG_TXT "+ SqlType("TEXT", 255) 
				+", FID_DOG "+ SqlType("LONG") 
				+", FDOG_NUM "+ SqlType("TEXT", 25) 
				+", FSTREET "+ SqlType("LONG") 
				+", FSTREET_TXT "+ SqlType("TEXT", 255) 
				+", FHOUSE "+ SqlType("LONG") 
				+", FHOUSE_NUM "+ SqlType("TEXT", 25) 
				+", FAPART "+ SqlType("LONG") 
				+", FAPART_NUM "+ SqlType("TEXT", 25) 
				+", FSUM "+ SqlType("CURRENCY") 
				+")";
	ExecuteSQL(sSQL);
}

function listSrc()
{
	this.qrySet("From", sTmpTbl);
}

function listDpGrid()
{
	grid.build();
}

function orgZaval(p)
{
	if(oApart.getFWID())
		p.subWhere = " FCOD in (select c.FORG from ^CONTRACT c inner join ^LICSC l on l.FID_DOG=c.FWID where l.FAPMT="+ oApart.getFWID() +")";
	else if(oHouse.getFWID())
		p.subWhere = " FCOD in (select c.FORG from ^CONTRACT c inner join ^LICSC l on l.FID_DOG=c.FWID where l.FHOUSE="+ oHouse.getFWID() +")";
	else if(oStreet.getFWID())
		p.subWhere = " FCOD in (select c.FORG from ^CONTRACT c inner join ^LICSC l on l.FID_DOG=c.FWID where l.FSTREET="+ oStreet.getFWID() +")";
}

function licscZaval(p)
{
	if(oApart.getFWID())
		p.subWhere = " FAPMT="+ oApart.getFWID();
	else if(oHouse.getFWID())
		p.subWhere = " FHOUSE="+ oHouse.getFWID();
	else if(oStreet.getFWID())
		p.subWhere = " FSTREET="+ oStreet.getFWID();
}

function insertSum()
{
	if(!oOrg.getCod())
		return false;
	
	var m = new Object();
	m.FWID = GetUID();
	m.FID_DOG = oLicsc.fwid;
	m.FDOG_NUM = FLICSC.value;
	m.FDATE = FDATE.value;
	m.FSTREET = oStreet.getFWID();
	m.FSTREET_TXT = oStreet.getTxt();
	m.FHOUSE = oHouse.getFWID();
	m.FHOUSE_NUM = oHouse.getTxt();
	m.FAPART = oApart.getFWID();
	m.FAPART_NUM = oApart.getTxt();
	m.FORG = oOrg.getCod();
	m.FORG_TXT = oOrg.getTxt();
	m.FSUM = FSUM.value;
	UpdateTable(sTmpTbl, m, true);
	
	oStreet.setCod(0);
	oHouse.setCod(0);
	oApart.setCod(0);
	oOrg.setCod(0);
	oLicsc.fwid = 0;
	FLICSC.value = "";
	FSUM.value = 0;
	
	list.tbl.requery();
	list.grid.refresh();
	recalc_sum();
	
	setFocus(FSTREET);
}

function loadOrg()
{
	var dat1 = firstday(FDATE.value);
	var dat2 = lastday(FDATE.value);
	var oSnap = getSnap("select count(*) as cnt, FID_DOG, FDOG_NUM, FORG, FSTREET, FHOUSE, FAPMT"
						+" from ^LISTLICSC"
						+" where FORG="+ sqlTo(oOrg.getCod())
							+" and FBDAT<="+ sqlTo(dat2)
							+" and FEDAT>="+ sqlTo(dat1)
						);
	if(oSnap && Number(oSnap[0])==1)
	{
		var licsc = String(FLICSC.value).trim();
		if(licsc!="")
		{
			if(licsc==oSnap[2])
				return;
		}
		oLicsc.fwid = oSnap[1];
		FLICSC.value = oSnap[2];
		oStreet.setFWID(oSnap[4]);
		oHouse.setFWID(oSnap[5]);
		oApart.setFWID(oSnap[6]);
	}
}

function loadLicsc()
{
	var dat1 = firstday(FDATE.value);
	var dat2 = lastday(FDATE.value);
	var licsc = String(FLICSC.value);
	if(licsc==oLicsc.num)
		return;
	oLicsc.num = licsc;
	var oSnap = getSnap("select FID_DOG, FORG, FSTREET, FHOUSE, FAPMT, FSTREET_TXT, FHOUSE_NOM, FAPT_NOM"
						+" from ^LISTLICSC"
						+" where FDOG_NUM="+ sqlTo(licsc)
							+" and FBDAT<="+ sqlTo(dat2)
							+" and FEDAT>="+ sqlTo(dat1)
						);
	if(oSnap)
	{
		oLicsc.fwid = oSnap[0];
		oOrg.setCod(oSnap[1]);
		oStreet.setFWID(oSnap[2]);
		oHouse.setFWID(oSnap[3]);
		oApart.setFWID(oSnap[4]);
	}
}

function recalc_sum()
{
	FFSUM.value = 0;
	var oSnap = getSnap("SELECT SUM(FSUM) FROM "+ sTmpTbl);
	if(oSnap)
		FFSUM.value = oSnap[0];
}

function onSave()
{
	var row = 1;
	var sum = 0;
	var nDoc = 0;
	var oDoc = extPar.oDoc;
		
	var tbl = OpenTable("select * from "+ sTmpTbl);	
	var rowCount = tbl.recordCount;
	WAIT(UR("Збереження: |Сохранение: ") + (row +"/"+ rowCount));
	for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
	{
		if(row%10==0)
			WAIT(UR("Збереження: |Сохранение: ") + (row +"/"+ rowCount));
		row++;
		
		var oDoc = new DpDoc(sDoc, nNop);
		oDoc.setVar("HNOM", oDoc.getAutoNo().get());
		oDoc.setVar("HDAT", tbl.getValue("FDATE"));    	
    	oDoc.setVar("HSUM", tbl.getValue("FSUM"));
    	oDoc.setVar("HID_DOG", tbl.getValue("FID_DOG"));
		oDoc.setVar("HORG", tbl.getValue("FORG"));
    	oDoc.setVar("HTOT", tbl.getValue("FORG_TXT"));
    	oDoc.setVar("HORG0", getPar("ORGNOM"));
    	oDoc.setVar("HCTO", getPar("OOKPO"));    	
    	oDoc.setVar("HBNKTO", getPar("OBANK"));
    	oDoc.setVar("HMFOTO", getPar("OMFO"));
    	oDoc.setVar("HCRSC", getPar("ORSC"));
    	var bRet = oDoc.save();
    	if(bRet)
    	{
    		nDoc++;
    		sum += Number(tbl.getValue("FSUM"));
    	}
	}
	tbl.close();
	CLEARWAIT();
	extPar.escape = false;
	exit();
	
	var sMsg = UR("Додано документів: "+ nDoc +"\nна загальну суму: "+ sum 
				+"|Добавлено документов: "+ nDoc +"\nна общую сумму: "+ sum
				);
	alert(sMsg);
}

function onCancel()
{
	exit();
}

function exit()
{
	list.tbl.close();
	ExecuteSQL("drop table "+ sTmpTbl, false);
	CloseWindow();
}

include("sys/DpList.js");