include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
//include("Objects\\DpNmkl.js");
include("sys\\kursval.js");

var objDoc = extPar.doc;
var m = new Object();
var _deny_an_h = objDoc.getPar("_an_h");

function Load()
{
	objDoc.isBuf = false;	
		
	nk = new DpNakl(objDoc, this);
	nk.load();	
	
	FDOC_NUM.mask = MASK_DOCNUM;
	HSUMOC.mask   = HSUMOC.mask = MASK_SUM;
		
	nds = getPar("NDSPROC");
	
	oSc = new DpSc();	
	if (_deny_an_h)
	{
		oSc.setMode("cutxyz");	//c0utxyz456
	}
	else
	{
	    oSc.setMode("c0utxyz");	//c0utxyz456
	}

	oSc.linkCtrl(FSC, FSU, FST, CL1, CL2, CL3);	
		
	objPodr = new DpCl();
	objPodr.setClcl(sprPodr);
   	objPodr.linkSmartCtrl(FPODR);   	
	objPodr.setContAssist();
	
	objMol = new DpCl();
	objMol.setClcl(sprMol);
   	objMol.linkSmartCtrl(FMOL);	
	objMol.setContAssist();
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	//ctrlLinker.addLink("HSC",FSC);
 	//ctrlLinker.addLink("HSU",FSU);
 	//ctrlLinker.addLink("HST",FST);
	//ctrlLinker.addLink("HA1",CL1);
 	//ctrlLinker.addLink("HA2",CL2);
 	//ctrlLinker.addLink("HA3",CL3);
 	ctrlLinker.addLink("HFIO",FIO_POL);
 	ctrlLinker.addLink("HOSUM",HSUMOC);
 	
	ctrlLinker.addClLink("HMOL",objMol);
	ctrlLinker.addClLink("HPODR",objPodr);
	ctrlLinker.addScLink("HSC", "HSU","HST","HA1","HA2","HA3", oSc);
 	
		
	ctrlLinker.updateData(false);
	
	Disable(HSUMOC);	
	//Disable(FSC_TXT);
	
	//setValid(FSC, sc_valid);
	//setValid(FSU, sc_valid);
	//setValid(FST, sc_valid);
	setFocus(FDOC_NUM);	
	recalcSum();	
}

function sc_valid()
{
	//FSC_TXT.value = oSc.txt;
}

function recalcSum()
{		
	nk.wItog(m);
	
	m.hndsu = round((m.hndsu * nds)/100,2);
	m.hndso = round((m.hndso * nds)/100,2);
		
	HSUMOC.value = m.hsumuc;
}

function updateData()
{
	ctrlLinker.updateData(true);
	/*
	objDoc.setVar("HPODR",objPodr.getCod());
	objDoc.setVar("HMOL", objMol.getCod());
	objDoc.setVar("HSC",  oSc.getSc());
	objDoc.setVar("HSU",  oSc.getSu());
	objDoc.setVar("HST",  oSc.getSt());	
	objDoc.setVar("HA1",  oSc.getCl1());	
	objDoc.setVar("HA2",  oSc.getCl2());	
	objDoc.setVar("HA3",  oSc.getCl3());
	*/	
	objDoc.setVar("HP",   objDoc.getPar("_pricetyp"));	
	objDoc.setVar("HPN",  objDoc.getPar("_priceuse"));
}

function onSave()
{
	updateData();
	
	objDoc.setVar("HSMTOV",	m.Fsum_tov);
	objDoc.setVar("HSBTOV",	m.Fseb_tov);
	objDoc.setVar("HSMMAT",	m.Fsum_mat);
	objDoc.setVar("HSBMAT",	m.Fseb_mat);	
	objDoc.setVar("HOSTAR",	m.Fsum_tar);
	objDoc.setVar("HUSTAR",	m.Fseb_tar);
	//objDoc.setVar("HSUMAKC",	m.hEquAkc);
	objDoc.setVar("HTOTL",	m.hIsRasc);
	objDoc.setVar("HPNDS",	nds);
	objDoc.setVar("HSNDS",	m.hndsu);
	objDoc.setVar("HSNDS1",	m.hndso);
	objDoc.setVar("HUSUM",	m.hsumoC);
	objDoc.setVar("HKOL",	m.hKol);
	objDoc.setVar("HNR",	m.hNr);
		
	var _issch = objDoc.getPar("_issch");
	if (!_issch)
	{
		var t = OpenTable("s", nk.bufName)
		while (!t.isEOF())
		{
			var nID = Number(t.getValue("FWID"))
			var oRow = objDoc.getRow("ROW", nID);
			if (oRow != null)
			{
				oRow.setVar("RSC1", objDoc.getVar("HSC"));
				oRow.setVar("RSU1", objDoc.getVar("HSU"));
				oRow.setVar("RST1", objDoc.getVar("HST"));
				oRow.setVar("RA1", objDoc.getVar("HA1"));
				oRow.setVar("RA2", objDoc.getVar("HA2"));
				oRow.setVar("RA3", objDoc.getVar("HA3"));
				strSQL = "UPDATE "+nk.bufName
					+" SET FSC1 = "+objDoc.getVar("HSC")
					+" , FSU1 = "+objDoc.getVar("HSU")
					+" , FST1 = "+objDoc.getVar("HST")
					+" , FCOD1 = "+objDoc.getVar("HA1")
					+" , FCOD2 = "+objDoc.getVar("HA2")
					+" , FCOD3 = "+objDoc.getVar("HA3")
					+" WHERE FWID = "+nID
				ExecuteSQL(strSQL);
			}
			t.moveNext();
		}
		t.close();
	}
	nk.saveRows();
}

function onChangeNop()
{
	objDoc = extPar.doc;			
	grid.DeletePages();
	nk.loadGrid();
}

include("sys\\DpBaseDlg.js");