include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpNmkl.js");
include("sys\\kursval.js");

var objDoc = extPar.doc;
var m = new Object();

function Load()
{
	objDoc.isBuf = false;	
		
	nk = new DpNakl(objDoc, this);
	nk.load();	
	
	FDOC_NUM.mask = MASK_DOCNUM;
	HSUMOC.mask = MASK_SUM;
	FSKYDKAW.mask = MASK_SUM;
	FSN.mask = "&&&&&&&&&&&&&&&&&&&&&";
	FSN.value = "";
		
	var objNmkl = new DpNmkl();
	nds = Number(objNmkl.getExt("_NDS"));
	
	oSc = new DpSc();	
	oSc.setMode("c0utxyz");	//c0utxyz456
	oSc.linkCtrl(FSC, FSU, FST, CL1, CL2, CL3);	
		
	objPodr = new DpCl();
   	objPodr.linkCtrl(FPODR,FPODR_TXT);
	objPodr.setClcl(sprPodr);
	
	objMol = new DpCl();
   	objMol.linkCtrl(FMOL,FMOL_TXT);
	objMol.setClcl(sprMol);
	
	oClient = new DpCl("0");
	oClient.linkSmartCtrl(FCLIENT);
	oClient.setClcl(objDoc.getPar("_client"));
	oClient.setContAssist();
	
	oClerk = new DpCl("0");
	oClerk.linkSmartCtrl(FCLERK);
	oClerk.setClcl(objDoc.getPar("_clerk"));
	oClerk.setContAssist();
	
	oRtype = new DpCl("0");
	oRtype.linkSmartCtrl(FRTYPE);
	oRtype.setClcl(objDoc.getPar("_rtype"));
	oRtype.setContAssist();
	
	//oModel = new DpCl("0");
	//oModel.linkSmartCtrl(FMODEL);
	//oModel.setClcl(objDoc.getPar("_model"));
	//oModel.setContAssist();
	
	oNmkl = new DpNmkl();	
	oNmkl.linkCtrl(FMODEL,FMODEL_TXT,Fedi);
	
	oSympt = new DpCl("0");
	oSympt.linkSmartCtrl(FSYMPT);
	oSympt.setClcl(objDoc.getPar("_sympt"));
	oSympt.setContAssist();
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	ctrlLinker.addLink("HSC",FSC);
 	ctrlLinker.addLink("HSU",FSU);
 	ctrlLinker.addLink("HST",FST);
	ctrlLinker.addLink("HA1",CL1);
 	ctrlLinker.addLink("HA2",CL2);
 	ctrlLinker.addLink("HA3",CL3);
 	ctrlLinker.addLink("HOSUM",HSUMOC);
 	
 	ctrlLinker.addLink("HDATEP",FDATEP);
 	ctrlLinker.addLink("HDATEV",FDATEV);
 	ctrlLinker.addLink("HSN",FSN);
 	ctrlLinker.addLink("HSTAN",FSTAN);
	ctrlLinker.addLink("HKOMPL",FKOMPL);
 	ctrlLinker.addLink("HCOMENT",FCOMENT);
 	ctrlLinker.addLink("HSKYDKAW",FSKYDKAW);
 	ctrlLinker.addLink("HSUMCL",FSUMCL);
 
 	ctrlLinker.updateData(false);
	
	if (extPar.mode != "ADD")	
	{		
   		objPodr.setCod(objDoc.getVar("HPODR"));   		
   		objMol.setCod(objDoc.getVar("HMOL"));	
		oClient.setCod(objDoc.getVar("HCLIENT"));
		oClerk.setCod(objDoc.getVar("HCLERK"));
		oRtype.setCod(objDoc.getVar("HRTYPE"));
		//oModel.setCod(objDoc.getVar("HMODEL"));
		oNmkl.setCod(Number(oNmkl.getCod()))
		oSympt.setCod(objDoc.getVar("HSYMPT"));
		oSc.set(objDoc.getVar("HSC"),
   				objDoc.getVar("HSU"),
   				objDoc.getVar("HST"),
				objDoc.getVar("HA1"),
   				objDoc.getVar("HA2"),
   				objDoc.getVar("HA3"));
   		//FSC_TXT.value = oSc.txt;
   		
	}	
	
	Disable(HSUMOC);	
	Disable(FSUMCL);
	
	//setValid(FSC, sc_valid);
	//setValid(FSU, sc_valid);
	setValid(FSKYDKAW, FSKYDKAW_valid);
	setFocus(FDOC_NUM);	
	recalcSum();	
}

function FSKYDKAW_valid()
{
	recalcSum();
	return true;
}

function recalcSum()
{		
	nk.wItog(m);
	
	m.hndsu = round((m.hndsu * nds)/100,2);
	m.hndso = round((m.hndso * nds)/100,2);
		
	HSUMOC.value = m.hsumuc;
	FSUMCL.value = m.hsumuc - m.hsumuc*Number(FSKYDKAW.value)/100;
	
	
}

function updateData()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HPODR",objPodr.getCod());
	objDoc.setVar("HMOL", objMol.getCod());
	objDoc.setVar("HSC",  oSc.getSc());
	objDoc.setVar("HSU",  oSc.getSu());
	objDoc.setVar("HST",  oSc.getSt());	
	objDoc.setVar("HP",   objDoc.getPar("_pricetyp"));	
	objDoc.setVar("HPN",  objDoc.getPar("_priceuse"));
	objDoc.setVar("HCLIENT",oClient.getCod());
	objDoc.setVar("HCLERK",oClerk.getCod());
	objDoc.setVar("HRTYPE",oRtype.getCod());
	objDoc.setVar("HMODEL",Number(oNmkl.getCod()));
	objDoc.setVar("HSYMPT",oSympt.getCod());
}

function onSave()
{
	updateData();
	
	objDoc.setVar("HSMTOV",	m.Fsum_tov);
	objDoc.setVar("HSBTOV",	m.Fseb_tov);
	objDoc.setVar("HSMMAT",	m.Fsum_mat);
	objDoc.setVar("HSBMAT",	m.Fseb_mat);	
	objDoc.setVar("HOSTAR",	m.Fsum_tar);
	objDoc.setVar("HUSTAR",	m.Fseb_tar);
	//objDoc.setVar("HSUMAKC",	m.hEquAkc);
	objDoc.setVar("HTOTL",	m.hIsRasc);
	objDoc.setVar("HPNDS",	nds);
	objDoc.setVar("HSNDS",	m.hndsu);
	objDoc.setVar("HSNDS1",	m.hndso);
	objDoc.setVar("HUSUM",	m.hsumoC);
	objDoc.setVar("HKOL",	m.hKol);
	objDoc.setVar("HNR",	m.hNr);
	
	nk.saveRows();
}

include("sys\\DpBaseDlg.js");