include("Objects\\DpCl.js");

var objDoc = extPar.doc; 
var ctrlLinker = null;
var oOrg;
var oManager;

function Load() 
{
	Caption(objDoc.getCaption() + ": " + modeName(extPar.mode));
  	
  	FSUBJECT.mask = strRepl("&", 250);
  	FANSWER.mask = strRepl("&", 250);
  	
   	oOrg = new DpCl();   	
	oOrg.setClcl(getPar("CODPLAT"));
   	oOrg.linkSmartCtrl(FORG);
   	oOrg.setContAssist();
   	oOrg.AfterLoad = loadContPers;
   	setValid(FORG, loadContPers);
   	
   	oManager = new DpCl();
   	oManager.setClcl(getPar("CODPERS"));
   	oManager.linkSmartCtrl(FMANAGER);
   	oManager.setContAssist();
	
	ctrlLinker = new DpCtrlLinker(objDoc);		
   	ctrlLinker.addLink("HNOM", FDOC_NUM);
 	ctrlLinker.addLink("HDAT", FDOC_DAT); 
 	ctrlLinker.addClLink("HORG", oOrg); 	
 	//ctrlLinker.addLink("HCONTACT", FCONTACT);
 	ctrlLinker.addClLink("HMANAGER", oManager);
 	ctrlLinker.addLink("HCONNECT", FCONNECT);
 	ctrlLinker.addLink("HRATING", FRATING);
 	ctrlLinker.addLink("HSUBJECT", FSUBJECT);
 	ctrlLinker.addLink("HCONFIRM", FCONFIRM);
 	ctrlLinker.addLink("HANSWER", FANSWER);
 	ctrlLinker.addLink("HCOMMENT", FCOMMENT);
   	ctrlLinker.updateData(false);	
	
   	if(extPar.mode=="ADD")
   	{
   		if(extPar.subject)
   			FSUBJECT.value = extPar.subject;
   		if(extPar.org)
			oOrg.setCod(Number(extPar.org));
		if(extPar.manager)
			oManager.setCod(Number(extPar.manager));			
		if(oManager.getCod()==0)
			oManager.setCod(getPersCod(getUserName()));
		if(extPar.connect)
			FCONNECT.setValue(String(extPar.connect));
   	}
   	else
   	{
		oOrg.setCod(objDoc.getVar("HORG"));
   		oManager.setCod(objDoc.getVar("HMANAGER"));  		
   	}
   	loadContPers();
   	if(extPar.mode=="ADD")
   	{
   		if(extPar.contact)
   			FCONTACT.setValue(Number(extPar.contact));
   	}
   	else
   	{
   		FCONTACT.setValue(objDoc.getVar("HCONTACT"));
   	}
}

function onSave()
{	
	ctrlLinker.updateData(true);
	objDoc.setVar("HCONTACT", FCONTACT.value);	
}

function getPersCod(userName)
{
	var oSnap = getSnap("select rel.FCOD "
							+" from ^CL_PERS p "
							+" inner join ^CLRELCLCL rel on rel.FWID_CL=p.FWID_CL "
							+" where p.FLOGIN="+ sqlTo(userName)
						, false
						);
	if(oSnap)
		return oSnap[0];
	return 0;
}

function loadContPers()
{
	var curCont = String(FCONTACT.getValue());
	FCONTACT.clear();	
	var nID = oOrg.getFWID();
	if(!nID)
		return;	
	var tPers = OpenTable("select * from ^CL_ORGCP "
							+" where FWID_CL="+ nID
							);
	while(!tPers.isEOF())
	{
		var txt = tPers.getValue("FFIO");
		var nid = String(tPers.getValue("FWID"));
		FCONTACT.addItem(nid, txt);			
		tPers.MoveNext();
	}
	FCONTACT.setValue(curCont);	
	if(tPers.isEmpty())
	{
		WAIT(ru("Нет контактных лиц для '"+ oOrg.getTxt() +"'"
				,"Немає контактних особ для '"+ oOrg.getTxt() +"'")
				);
	}
	tPers.close();
}

include("sys\\DpBaseDlg.js");