include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpNmkl.js");
include("Objects\\DpClNo.js");	

var objDoc = extPar.doc;
var Fnrows = 0;
var objNmkl;

function Load()
{
	objDoc.isBuf = true;	
	
	var sRowOrder = "FNOM_STR, FCLIENT, FNMKL";
	var nRowOrder = Number(objDoc.getPar("_row_order"));
	if(nRowOrder==1)
		sRowOrder = "FNOM_STR, FCLIENT, FNMKL";
	else if(nRowOrder==2)
		sRowOrder = "FCLIENT, FNMKL";
	else if(nRowOrder==3)
		sRowOrder = "FNMKL";
		
	nk = new DpNakl(objDoc, this);	
	nk.rowsName = "RRU";	
	nk.orderBy = sRowOrder;
	//nk.fields2copy = ",FCLIENT AS FPODR"	
	nk.load();	
			
	FDOC_NUM.mask = MASK_DOCNUM;
	FSUM.mask     = MASK_SUM;
	FKOL.mask	  = MASK_KOL;
		
	objNmkl = new DpNmkl(null, null, "S");
	objNmkl.CanSelectAll = true;
	objNmkl.linkCtrl(FNMKL,tFNMKL);
	nds = Number(objNmkl.getExt("_NDS"));
		
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);	 	
 	ctrlLinker.addLink("HSUM",FSUM);
	ctrlLinker.addLink("HKOL",FKOL);	
	
	ctrlLinker.updateData(false);
	
	if (extPar.mode == "ADD")
		objNmkl.setCod(0);
	else
		objNmkl.setCod(objDoc.getVar("HNMK"));
		
	Disable(FSUM);
	Disable(FKOL);			
	
	setFocus(FDOC_NUM);	
	recalcSum();
}

function docLoadBuf()
{
	var nId = (nk.mode == "COPY") ? nk.oDoc.nOldID : nk.fwid;
		
	CreateTable(nk.bufName, nk.rowsName, "FWID");			
	ExecuteSQL("DELETE FROM "+ nk.bufName, false);
	nk.modifyData("COPY", nk.bufName, fields2copy, nk.rowsName, nId);

	CreateTable(nk.sTmpTbl, ROW_PTN);	
	ExecuteSQL("DELETE FROM "+ nk.sTmpTbl, false);
	nk.modifyData("COPY", nk.sTmpTbl, fields2copy, nk.rowsName, nk.fwid);
	
	ExecuteSQL("ALTER TABLE " + nk.bufName + " ADD FOST "	+ SqlType("LONG"));
	ExecuteSQL("ALTER TABLE " + nk.bufName + " ADD FCENAPR "+ SqlType("LONG"));
	ExecuteSQL("ALTER TABLE " + nk.bufName + " ADD FPOST "	+ SqlType("LONG"));
	ExecuteSQL("ALTER TABLE " + nk.bufName + " ADD FID_PN "	+ SqlType("LONG"));
}

function docTblTie()
{
	clTie(nk.tbl4Grid,"cl","=" + sqlTo(getPar("CODPLAT"))+",FCLIENT");	
	nk.tbl4Grid.tie("CL_POST", "cl_p", "FWID_CL", "cl.FWID");	
	nk.tbl4Grid.tie("CL_ORGRS", "cl_bank", "FWID_CL", "cl_p.FWID_CL,="+SqlTrue);
	nk.tbl4Grid.tie("CONTRACT", "dog", "FWID", "FID_DOG");
	/*
	clTie(nk.tbl4Grid, "coun", "=" + getPar("codCountry") + ",post.FcodCountry", "clc");
	clTie(nk.tbl4Grid, "regi", "=" + getPar("codRegion") + ",post.FcodRegion", "clr");
	clTie(nk.tbl4Grid, "area", "=" + getPar("codArea") + ",post.FcodArea", "cla");
	clTie(nk.tbl4Grid, "loca", "=" + getPar("codLocate") + ",post.FcodLocate", "cll");
	*/
}

function recalcSum()
{		
	oSnap = getSnap("SELECT COUNT(*) FROM "+ nk.bufName);
	if(oSnap)
		Fnrows = oSnap[0];
			
	oSnap = getSnap("SELECT SUM(" + sqlRound("Fcena * Fkol",getPar('PRINTDECISUM')) + "), SUM(FKOL) FROM "+ nk.bufName);		
			 
	FSUM.value = oSnap!=null? round(oSnap[0],getPar('PRINTDECISUM')) : 0;			
	FKOL.value = oSnap!=null? oSnap[1] : 0;
}

function updateData()
{	
	objDoc.setVar("HNMK",objNmkl.getCod());
	ctrlLinker.updateData(true);
}

function onSave()
{
	updateData();	
	objDoc.setVar("HNR",Fnrows);	
	
	nk.saveRows();
}

function docMenuInit()
{		
	grid.AddMenuItem("IMPORT","Імпорт|Импорт");
	grid.AddMenuItem("MASS","Масове введення|Масовый ввод");
	grid.AddMenuItem("GETRUROW", "Завантаження рядків за умовою|Загрузка строк по условию");
}

function docMenuHandler(id)
{		
	switch(id)
	{
		case "IMPORT":
			ruImport();			
			break;
		
		case "GETRUROW":
			getRURow();
			break;
		
		case "MASS":
			
			if (objNmkl.getCod() == 0)
			{
				alert(UR("Введить номенклатуру|Введите номенклатуру"));
				break;
			}
			/*include("Objects/DpExFilt.js");
			var fltName = null;
			if (this.oDoc.getPar("filter"))
			{
				var filter	= new DpExFilt("CL",sprOrg, getTblAttr());
				fltName = filter.getFilterTable();
			}*/
			var par = new Object();
			par.fnmk = objNmkl.getCod();
			par.dat = objDoc.getVar("HDAT");
		//	par.FltName = fltName;
			par.rowName = nk.bufName;
			par.tblName = getTmpTableName();
			
			par.escape = true;
			showWindow("l_rumass.js", SW_MODAL, par);
			
			var tbl = OpenTable("m", "select * from "+ par.tblName + " where fkol <> 0 and FEXIST<>"+ SqlTrue);
			if(!tbl.isEmpty())	
				for(tbl.MoveFirst(); !tbl.isEOF(); tbl.moveNext())
				{	
					
						oDocRow = objDoc.createRow("ROW");
						objDoc.appendRow("ROW", oDocRow);					
						id = oDocRow.getID();
		
					oDocRow.setVar("RNOM",	findFreeClNo(nk.bufName, "fnom_str"));
					oDocRow.setVar("RTNMK",	objNmkl.getCod());
					oDocRow.setVar("RUCENA",tbl.getValue("FCENA"));
					oDocRow.setVar("RORG",	tbl.getValue("FCOD"));
					oDocRow.setVar("RKOL",tbl.getValue("FKOL"));
					oDocRow.setVar("RDOG",tbl.getValue("FID_DOG"));
							
					obj2DB(id,oDocRow.jDocRow,null,nk.bufName);
					grid.getTable().requery();		
				}
			DropTable(par.tblName);
			
			
			break;	
		default: 
			return false;
	}	
}

function getRURow()
{
	var sqlFrom	= "^SERV_PR a ";
	/*include("objects\\DpExFilt.js");
	if (this.param("filter"))
	{
		var filter	= new DpExFilt("CL", sprOrg, getTblAttr());
		var FltName	= filter.getFilterTable();
		if (FltName != null)
			sqlFrom += " INNER JOIN " + FltName + " b ON a.FCLIENT = b." + filter.mainField + " ";
	}*/
		
	var nmkl = objNmkl.getCod();
	var date = objDoc.getVar("HDAT");
	date = new Date().getVarDate();	
	
	ExecuteSQL("SELECT DISTINCT a.FNMKL, a.FCENA, a.FCLIENT "
			+ " INTO TMP_RU_ROW "
			+ " FROM (" + sqlFrom + ") "
				+ " LEFT JOIN " + nk.bufName + " c ON a.FCLIENT = c.FCLIENT AND a.FNMKL = c.FNMKL AND a.FCENA = c.FCENA "
			+ " WHERE a.FBDATE <= " + sqlTo(date)
			+ " AND a.FEDATE >= " + sqlTo(date)
			+ " AND (c.FCLIENT IS NULL)"
			+ ((nmkl != null && nmkl != "")?" AND a.FNMKL = " + sqlTo(nmkl): "")
			);	
	
	var tbl = OpenTable("m", "TMP_RU_ROW");
	if(!tbl.isEmpty())	
	for(tbl.MoveFirst(); !tbl.isEOF(); tbl.moveNext())
	{	
		oDocRow = objDoc.createRow("ROW");
		objDoc.appendRow("ROW", oDocRow);					
		id = oDocRow.getID();
		
		oDocRow.setVar("RNOM",	findFreeClNo(nk.bufName, "fnom_str"));
		oDocRow.setVar("RTNMK",	tbl.getValue("FNMKL"));
		oDocRow.setVar("RUCENA",tbl.getValue("FCENA"));
		oDocRow.setVar("RORG",	tbl.getValue("FCLIENT"));
		
		obj2DB(id,oDocRow.jDocRow,null,nk.bufName);
		grid.getTable().requery();		
	}
	tbl = null;
	DropTable("TMP_RU_ROW");
	return true;	
}

function ruImport()
{
	var sFileName = askFile();
	if(!sFileName)
		return;
	if(sFileName.endsWith(".csv") || sFileName.endsWith(".txt"))
		importCSV(sFileName);
}

function importCSV(sFileName)
{
	var txt = lpProxy.readFile(sFileName, "cp1251");
	txt = txt.replaceAll("\"", "");
	var arr = lpProxy.csvParse(txt);
	
	var hCodNmk = objNmkl.getCod();	
	var sTr = "";			
	var i = 0;
	var nRow = 0;	
	var nError = 0;
	var sError = "";
	var nRowKol = Number(arr.length);
	var nom = findFreeClNo(nk.bufName, "fnom_str");	
	
	var sPrTxt = UR("Завантаження рядків: |Загрузка строк: ");
	setProgressRange(0, nRowKol);
	setProgressPos(nom, sPrTxt + nom +"/"+ arr.length);
	var sErrorTbl = "TMP_BILL_ERROR";
	ExecuteSQL("drop table "+ sErrorTbl, false);
	ExecuteSQL("create table "+ sErrorTbl 
				+" (FNUM "+ SqlType("INT") 
				 +",FID "+ SqlType("TEXT") 
				 +",FNAME "+ SqlType("TEXT") 
				 +",FKOL "+ SqlType("TEXT")
				 +",FTIME "+ SqlType("TEXT")
				 +",FWID "+ SqlType("COUNTER")  
				 +")");
	
	while(i<arr.length)
	{		
		var oPar = arr[i++];
		if(!oPar)
			break;
		
		var sID = oPar[1];
		var sName = oPar[2];
		var sKol = oPar[5];
		var sTime = oPar[11];
		var nKB = 1024;
		var nKol = Number(sKol)/(nKB*nKB);
				
		if(nom%10==0)
			setProgressPos(nom, sPrTxt + nom +"/"+ arr.length);	
		var oSnap = getSnap("select s.FNMKL,d.FID_DOG,c.FORG,p.FPHONE,s.FRATE,s.FKOL "
					+" from ^BILDOG d "
						+" inner join ^CONTRACT c on c.FWID=d.FID_DOG "
						+" inner join ^BIL_PACK p on p.FID_DOG=d.FID_DOG "
						+" inner join ^CL_SERV s on s.FWID_CL=p.FWID_CL "
					+" where p.FSID="+ sqlTo(sID)
						+" and s.FLIMIT="+ sqlTrue, false);
		
		if(!oSnap)
		{			
			nError++;
			sName = String(sName).trim();
			if(sName.length>50)
				sName = sName.substring(0, 50);
			//if(nError<21)
				sError += "\n"+ (nError) +". "+ sID +"		- "+ sName +" |		";
			//if((i+1)==arr.length)
			//	sError += "\n...\n"+ (nError) +". "+ sID +"		- "+ sName;
			ExecuteSQL("insert into "+ sErrorTbl +" (FNUM,FID,FNAME,FKOL,FTIME) "
						+" values("+ sqlTo(nError) 
							+", "+ sqlTo(sID) 
							+", "+ sqlTo(sName) 
							+", "+ sqlTo(sKol)
							+", "+ sqlTo(sTime)
							+")");
			continue;
		}
		
		var nRate = Number(oSnap[4]);
		if(nRate==1)//время. в файле указано превышение времени, поэтому добавляем время из пакета
		{			
			var nTime = Number(oSnap[5]);
			nKol = Number(sTime) + nTime;
		}	
		
		var nmk = Number(oSnap[0]);		
		sTr += "\nnom: "+ nom +" > sID: "+ sID +" > sName: "+ sName +" > nRate: "+ nRate +" > sKol: "+ sKol +" > nmk: "+ nmk +" > hCodNmk: "+ hCodNmk +" > nRowKol: "+ nRowKol;	
		if(hCodNmk && hCodNmk!=nmk)
		{
			nRowKol--;
			continue;
		}
		var oDocRow = objDoc.createRow("ROW");
		objDoc.appendRow("ROW", oDocRow);					
		var id = oDocRow.getID();		
		
		oDocRow.setVar("RNOM",	nom++);
		oDocRow.setVar("RKOL",	nKol);		
		oDocRow.setVar("RTNMK",	nmk);
		oDocRow.setVar("RDOG",	Number(oSnap[1]));
		oDocRow.setVar("RORG",	Number(oSnap[2]));		
		oDocRow.setVar("RPHONE",Number(oSnap[3]));
		oDocRow.setVar("RUCENA",0);		
		
		obj2DB(id, oDocRow.jDocRow, null, nk.bufName);
		
		nRow++;
	}
	setProgressPos(0);
	
	var sMsg = UR("Завантажено рядків "+ nRow +" з "+ nRowKol +"|Загружено строк "+ nRow +" из "+ nRowKol);
	trace(sTr +"\n\n"+ sError);
	if(sError!="")
	{
		//if(sError.length>1000)
		//	sError = sError.substr(0, 1000) +"\n...";
		//sMsg += "\n\n"+ UR("Не знайдено дані для |Не обнаружены данные для ") 
		//	+ nError +": "+ sError;
		sError = UR("Не знайдено дані для |Не обнаружены данные для ") 
					+ nError +": \n"+ sError
		//lpProxy.writeToFile(sError, "ERROR.txt", "cp1251");
	}	
	if(nRow!=nRowKol)
	{
		//alert(sMsg);
		sMsg += ".\n"+ UR("Відкрити список пропущених послуг?|Открыть список пропущенных услуг?");
		var sCmd = new Array("notepad", "ERROR.txt");
		if(confirm(sMsg))
		{
			//Packages.java.lang.Runtime.getRuntime().exec(sCmd);
			browse(sErrorTbl);
		}
	}
}

function getTariff(nmkl)
{	
	var nTariff = 0;	
	var oPri = getPri();
	if(!oPri || !nmkl)
		return 0;			
	
	include("sub/mtr.js");
	var priName = pName(priType, oPri[1], oPri[0]);
	oPri = getSnap("select FCENA,FCENA1 from "+ priName
					+" where FNMKL="+ nmkl, false);	
	if(oPri)
		nTariff = Number(oPri[0]);		
	return nTariff;
}

function getPri()
{
	var priType = getPar("BILL_PRI");		
	var mFbdate = new Date();
	var mFedate = new Date();
	
	var sSql = "select FWID, FDAT from ^CL_PRI"
					+" where FCOD="+ sqlTo(priType)
						+" and FISGRP<>"+ SqlTrue
						+" and fdat>="+ sqlTo(mFbdate) 
						+" and fdat<="+ sqlTo(mFedate) 
					+" order by FDAT desc"
	var oPri = getSnap(sSql);
	if(!oPri)
	{	
		sSql = "select FWID, FDAT from ^CL_PRI"
					+" where FCOD="+ sqlTo(priType)
						+" and FISGRP<>"+ SqlTrue						 
					+" order by FDAT desc"
		oPri = getSnap(sSql);
	}
	return oPri;
}

function isCorectLPU(cod)
{
	if(objDoc.getVar("HOP")==xcl("0",cod,"LPU"))
		return true;
	else
	{
		WAIT(ru("У контрагента №"+cod+" код ЛВУМГ не соответсвует номеру папки!",
				"У контрагента №"+cod+" код ЛВУМГ не відповідає номеру папки!"));
		return false;
	}
}

function isDog(id_dog,cod)
{
	if(Number(id_dog)==0)
	{
		WAIT(ru("Существуют записи с непроставленными договорами!","Існують записи з непроставленими договорами!"));
		return false;
	}
	var snap = getSnap("select fwid from ^contract where fwid="+id_dog);
	if(snap!=null)
		return true;
	else
	{
		WAIT(ru("У контрагента №"+cod+" отсутствует договор (ID="+id_dog+")","У контрагента №"+cod+" відсутній договір (ID="+id_dog+")"));
		return false;
	}
}

include("sys\\DpBaseDlg.js");