include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpNmkl.js");
include("Objects\\DpPrList.js");

var objDoc = extPar.doc;
var m = new Object();

function Load()
{			
	objDoc.isBuf = true;
		
	nk = new DpNakl(objDoc, this);	
	nk.orderBy = " fsc, fsu, fpodr, fmol";
	nk.where = '';	
	nk.load();
		
	FDOC_NUM.mask = MASK_DOCNUM;
	HSUMUOV.mask  = HSUMUO.mask = MASK_SUM;
	FKOL.mask     = MASK_KOL;
	
	var objNmkl = new DpNmkl();
	nds = Number(objNmkl.getExt("_NDS"));
	
	oVal = new DpVal();
	oVal.linkCtrl(TFVAL);
		
	oSc = new DpSc();	
	oSc.linkCtrl(FSC, FSU, FST);
	oSc.setMode("cu0");	
			
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	ctrlLinker.addLink("HSC",FSC);
 	ctrlLinker.addLink("HSU",FSU);
 	ctrlLinker.addLink("HST",FST);
	ctrlLinker.addLink("HPNDS",FNDS_PROC);
	ctrlLinker.addLink("HSUM",HSUMUOV);
	//ctrlLinker.addLink("HUSUM",HSUMUO);
	ctrlLinker.addLink("HKOL",FKOL);	
		
	ctrlLinker.updateData(false);
	
	if (extPar.mode == "COPY" || extPar.mode == "EDIT")
	{
		oVal.setCod(objDoc.getVar("HVAL"));
		
		oSc.set(objDoc.getVar("HSC"),
   				objDoc.getVar("HSU"),
   				objDoc.getVar("HST"));
   		
   		if(objDoc.getVar("HPNDS")!=0)
   			FNDS_PROC.value = nds;
	}
	if (extPar.mode == "ADD")
	{		
		FNDS_PROC.value = nds;
	}	
	
	Disable(HSUMUOV);
	Disable(HSUMUO);	
	Disable(FKOL);
		
	setFocus(FDOC_NUM);	
	setValid(FNDS_PROC, recalcSum);	
	recalcSum();
}

function docLoadBuf()
{
	var nId = (nk.mode == "COPY") ? nk.oDoc.nOldID : nk.fwid;
		
	CreateTable(nk.bufName, ROW_PTN, "FWID");			
	ExecuteSQL("DELETE FROM "+ nk.bufName, false);
	nk.modifyData("COPY", nk.bufName, nk.fields2copy, nk.rowsName, nId);
	ExecuteSQL("ALTER TABLE "+ nk.bufName +" ADD COLUMN FTT "+ SqlType("TEXT", 2));
	
	CreateTable(nk.sTmpTbl, ROW_PTN);
	ExecuteSQL("DELETE FROM "+ nk.sTmpTbl, false);	
	nk.modifyData("COPY", nk.sTmpTbl, nk.fields2copy, nk.rowsName, nk.fwid);
}

function recalcSum()
{		
	//m.hndsu1 = "SUM("+IIF("a.fnmkvid <> 'O' or a.fnmkvid is null", "a.Fkol * a.F1cena", "0")+")";
	nk.nds = Number(FNDS_PROC.value);
	nk.wItog(m);
		
	FKOL.value = m.hKol;	
	HSUMUOV.value = m.hsumu1c;
		
	dt = FDOC_DAT.value;
	kod1 = oVal.getNazv();
	kurs = 0;
	kod2 = 0;
	kurs_2 = 1;
	HSUMUO.value = 0;
	if (m.hsumu1c != null)
		HSUMUO.value = _nv2nv("", dt, kod1, m.hsumu1c, kod2, kurs, kurs_2);		
		
	m.hndsu1 = _nv2nv("", dt, kod1, m.hndsu1, kod2, kurs, kurs_2);
	m.hndso = round(m.hndso, 2);	
}

function updateData()
{	
	ctrlLinker.updateData(true);
	objDoc.setVar("HVAL",oVal.getCod());
	objDoc.setVar("HP",  objDoc.getPar("_pricetyp"));	
	objDoc.setVar("HPN", objDoc.getPar("_priceuse"));
	objDoc.setVar("HDOC", "SA");			
}		

function onSave()
{		
	updateData();	
	
	objDoc.setVar("HSMTOV",	m.Fsum_tov);
	objDoc.setVar("HSBTOV",	m.Fseb_tov);
	objDoc.setVar("HSMMAT",	m.Fsum_mat);
	objDoc.setVar("HSBMAT",	m.Fseb_mat);	
	objDoc.setVar("HOSTAR",	m.Fsum_tar);
	objDoc.setVar("HUSTAR",	m.Fseb_tar);	
	objDoc.setVar("HTOTL",	m.hIsRasc);
	objDoc.setVar("HSNDS",	m.hndsu1);
	objDoc.setVar("HSNDS1",	m.hndso);	
	objDoc.setVar("HUSUM",	m.hsumuc);
	objDoc.setVar("HNR",	m.hNr);		
	
	ExecuteSQL("DELETE FROM "+ nk.bufName 
		+" WHERE FTT='SC' OR FTT='SU' OR FTT='PD' OR FTT='ML'", false);
	
	nk.saveRows();
}

function docMenuInit()
{
	grid.AddMenuItem("SAMAKEOST", "Сформувати кількісні залишки|Сформировать количественные остатки");
	if(!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("SAITOGS", "Сформувати підсумки|Сформировать итоги");
		grid.AddMenuItem("KILLPLUSMINUS", "Згорнути від'ємні та додатні залишки|Свернуть отриц.и полож.остатки");
		grid.AddMenuItem("SETFID_PN_FROM_FWID", "Встановити рядки першим приходом|Установить строки первым приходом");

	}
}

function docMenuHandler(id)
{
	include("mtr_ost.js");
	include("Objects\\DpClNo.js");	
	switch(id)
	{
		case "SAMAKEOST":
			nk.tbl4Grid.requery();
			if (!nk.tbl4Grid.isEmpty())
			{
				if (!confirm(ru("При формировании остатков все существующие\nстроки будут удалены. Продолжить?", 
								"При формуванні залишків всі ісруючі\nрядки будуть видалені. Продовжити?")))
					return;
				ExecuteSQL("DELETE FROM " + nk.bufName);
				nk.tbl4Grid.requery();
			}
			var cTblName;
			WAITTIMER(ru("Формирование количественных остатков...", "Формування кількісних залишків..."));
			with(new DpMtrOb)
			{				
				var dt = objDoc.getVar("HDAT");
				//fdate = goDay(objDoc.getVar("FDOC_DAT"),-1);
				fdate = new Date(dt.getYear()+1900, dt.getMonth(),dt.getDate()-1)

				fsc = objDoc.getVar("HSC");
				fsu = objDoc.getVar("HSU");
				fst = objDoc.getVar("HST");				
				doCalc();
				cTblName = tblName;
			}			
			temp_tbl = OpenTable("m",cTblName);
			if(!temp_tbl.isEmpty())
				WAITTIMER(ru("Инициализация идентификаторов","Ініціалізація ідентифікаторів"));				

			for(temp_tbl.MoveFirst(); !temp_tbl.isEOF(); temp_tbl.MoveNext())
			{
				var oDocRow = objDoc.createRow("ROW");
				objDoc.appendRow("ROW", oDocRow);					
				with(oDocRow)
				{
					setVar("RNOM",	findFreeClNo(nk.bufName, "fnom_str"));					
					setVar("RSC",	temp_tbl.getValue("Fsc"));
					setVar("RSU",	temp_tbl.getValue("Fsu"));
					setVar("RST",	temp_tbl.getValue("Fst"));
					setVar("RTNMK",	temp_tbl.getValue("Fnmkl"));						
					setVar("R1DAT",	temp_tbl.getValue("Fdate"));
					setVar("RPODR",	temp_tbl.getValue("FPodr"));
					setVar("RMOL",	temp_tbl.getValue("Fmol"));														
					setVar("RKOL",	temp_tbl.getValue("Fost"));
					setVar("R1KOL",	temp_tbl.getValue("Fost"));
					setVar("RUCENA",temp_tbl.getValue("Fcena"));
					setVar("RPCENE",temp_tbl.getValue("Fcena"));
					setVar("RPOST",	temp_tbl.getValue("Fpost"));
					setVar("R1ID",	temp_tbl.getValue("Fid_pn"));
				}
				obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,nk.bufName);			
			}
			temp_tbl = null;
			break;
		
		case "SAITOGS":
			nk.tbl4Grid.requery();
			if(nk.tbl4Grid.isField("FTT"))
				ExecuteSQL("DELETE FROM "+ nk.bufName 
							+" WHERE FTT='SC' OR FTT='SU' OR FTT='PD' OR FTT='ML'");
						
			ExecuteSQL("UPDATE " + nk.bufName
					+ " SET fsum = fkol*f1cena");
			
			if(!this.calcTotal)
			{
				include("objects\\DpTotals.js");
				this.calcTotal = new DpTotals();	//объект для подсчета итогов
				this.orderBy = this.calcTotal.getOrderBy();
			}
			this.calcTotal.ResetTotals();
			this.calcTotal.AddGroup("fsc", "+", "0", "SC", "TRUE");
			this.calcTotal.AddGroup("fsu", "+", "0", "SU", "TRUE");
			this.calcTotal.AddGroup("fpodr", "+", "0", "PD", "TRUE");
			this.calcTotal.AddGroup("fmol", "+", "0", "ML", "TRUE");
			this.calcTotal.AddItog("fsum", "SUM");
			this.calcTotal.AddItog("fkol", "SUM");
			this.calcTotal.MkTotals("", nk.bufName, "", 0, null, null, null);
			this.calcTotal.setOrderBy(null);
			this.orderBy = this.calcTotal.getOrderBy();	
			break;
			
		case "KILLPLUSMINUS":
			var tMinuses = OpenTable("s",
				"SELECT fnmkl, fcena, fpodr, fmol, fsc, fsu, fst"
				+ " FROM " + nk.bufName
				+ " GROUP BY fnmkl, fcena, fpodr, fmol, fsc, fsu, fst"
				+ " HAVING min(fkol)<0"
				)
			var nMinuses = tMinuses.recordCount;
			setProgressRange(0, nMinuses);
			
			var nCount = 0;
			for(; !tMinuses.isEOF(); tMinuses.MoveNext())
			{
				++nCount;
				setProgressPos(nCount, nCount+"/"+nMinuses);

				
				var t = OpenTable("s", "SELECT SUM(fkol) AS ftotkol"
					+ " FROM " + nk.bufName
					+ " WHERE fnmkl=" + sqlTo(tMinuses.getValue("fnmkl"))
						//+ " AND fcena=" + sqlTo(tMinuses("fcena"))
						+ " AND fpodr=" + sqlTo(tMinuses.getValue("fpodr"))
						+ " AND fmol=" + sqlTo(tMinuses.getValue("fmol"))
						+ " AND fsc=" + sqlTo(tMinuses.getValue("fsc"))
						+ " AND fsu=" + sqlTo(tMinuses.getValue("fsu"))
						+ " AND fst=" + sqlTo(tMinuses.getValue("fst"))
					);
				if(t.getValue("ftotkol")>=0)
				{
					var t2Kill = OpenTable("s", "SELECT *"
						+ " FROM " + nk.bufName
						+ " WHERE fnmkl=" + sqlTo(tMinuses.getValue("fnmkl"))
							//+ " AND fcena=" + sqlTo(tMinuses("fcena"))
							+ " AND fpodr=" + sqlTo(tMinuses.getValue("fpodr"))
							+ " AND fmol=" + sqlTo(tMinuses.getValue("fmol"))
							+ " AND fsc=" + sqlTo(tMinuses.getValue("fsc"))
							+ " AND fsu=" + sqlTo(tMinuses.getValue("fsu"))
							+ " AND fst=" + sqlTo(tMinuses.getValue("fst"))
						+ " ORDER BY "
							+ IIF("fcena=" + sqlTo(tMinuses.getValue("fcena")),0,1)
							+ ", fkol"
						)
					
					var nTotkol =0;
					for(; !t2Kill.isEOF(); t2Kill.MoveNext())
					{
						nTotkol += Number(t2Kill.getValue("fkol"));
						if(nTotkol<0)
						{
							t2Kill.Delete()
						}
						else if(nTotkol==0)
						{
							t2Kill.Delete()
							break;
						}
						else if(nTotkol>0)
						{
							t2Kill.Edit();
							t2Kill.setValue("fkol", nTotkol);
							t2Kill.Update();
							break;
						}
					}
				}
			}
			setProgressPos(0);
			break;
			
		case "SETFID_PN_FROM_FWID":
			ExecuteSQL(
					"UPDATE " + nk.bufName + " a"
			 		+ " SET a.fid_pn = fwid"
			 		+ " WHERE " + grid.sqlSelected()
			 		);
			
			this.isChanged = true;
			break;
			
		default: 
			return false;
	}
}
			
include("sys\\DpBaseDlg.js");