include("Objects\\DpPostRs.js");
include("Objects\\DpPrList.js");
include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpNmkl.js");
include("sys\\kursval.js");
include("gridedit.js");

var objDoc = extPar.doc;
var pricetyp = objDoc.getPar("_pricetyp");
var priceuse = objDoc.getPar("_priceuse");
var nmklsel = objDoc.getPar("_nmklsel");
var otpsel = objDoc.getPar("_otpsel");

var naklCreate = false;
var viewOst = false;

var m = new Object();
var nds;

var oValP;
var oVal;

var dpGridEdit = null;

function docLoadBuf()
{
	var nId = (extPar.mode == "COPY") ? objDoc.nOldID : objDoc.getID();
	
	CreateTable(nk.sTmpTbl, ROW_PTN);
	CreateTable(nk.bufName, ROW_PTN, "FWID");
	ExecuteSQL("DELETE FROM "+ nk.bufName, false);
	ExecuteSQL("DELETE FROM "+ nk.sTmpTbl, false);
	ExecuteSQL("ALTER TABLE " + nk.bufName + " ADD FINSCH_FAK "+ SqlType("BYTE"));
	ExecuteSQL("ALTER TABLE " + nk.bufName + " ADD FSFOST "+ SqlType("BIT"));
	ExecuteSQL("ALTER TABLE " + nk.sTmpTbl + " ADD FINSCH_FAK "+ SqlType("BYTE"));
	
	nk.modifyData("COPY", nk.bufName, fields2copy, nk.rowsName, nId);				
	ExecuteSQL("UPDATE "+ nk.bufName +" SET FINSCH_FAK = 0, FSFOST = "+ sqlTo(false));		
	nk.modifyData("COPY", nk.bufName, nk.fields2copy, "^SCH_FAK", nId);

	if(extPar.mode != "COPY")
		ExecuteSQL("UPDATE "+ nk.bufName +" SET FINSCH_FAK = 1 WHERE FINSCH_FAK IS NULL");
	else
		return;
	
	nk.modifyData("COPY", nk.sTmpTbl, fields2copy, nk.rowsName, objDoc.getID());	
	ExecuteSQL("UPDATE "+ nk.sTmpTbl +" SET FINSCH_FAK = 0");
	nk.modifyData("COPY", nk.sTmpTbl, nk.fields2copy, "^SCH_FAK", objDoc.getID());		
	ExecuteSQL("UPDATE "+ nk.sTmpTbl +" SET FINSCH_FAK = 1 WHERE FINSCH_FAK IS NULL");
}

function Load()
{	
	objDoc.isBuf = false;	
	nk = new DpNakl(objDoc, this);
	nk.load();
				
	FDOC_NUM.mask = MASK_DOCNUM;
	FDAY.mask = "####";
	HSUMP.mask = MASK_SUM;
	HSUMOV.mask = MASK_SUM;
	HNDSOV.mask = MASK_SUM;
	HNDSP.mask = MASK_SUM;
	HSUMSNDSP.mask = MASK_SUM;
	HSUMSNDSO.mask = MASK_SUM;
	FDISCOUNT.mask = MASK_SUM;
	FKOL.mask     = MASK_KOL;
	HSUM0.mask = MASK_SUM;
	FPCENANO.mask = "#";
	FPTYPE.mask   = "&";
	
	var objNmkl = new DpNmkl();
	nds = Number(objNmkl.getExt("_NDS"));
	
	oVal = new DpVal();
	oVal.linkCtrl(TFVAL);	
	setValid(TFVAL, onChangeCena);
	
	oValP = new DpVal();
	oValP.linkCtrl(HVALP);
	setValid(HVALP, refreshViewer);

	objPlat = new DpCl();
   	objPlat.setClcl(getPar("CODPLAT"));		 
   	objPlat.linkSmartCtrl(FDBKR);	 
	objPlat.setContAssist();
	objPlat.AfterUpdate = afterUpdateOrg;
		
	objPodr = new DpCl("", sprPodr, 0);
   	//objPodr.linkCtrl(FPODR,FPODR_TXT);
   	objPodr.linkSmartCtrl(FPODR);
	objPodr.setContAssist();	
	
	objMol = new DpCl("", sprMol, 0);
	//objMol.linkCtrl(FMOL,FMOL_TXT);
	objMol.linkSmartCtrl(FMOL);
	objMol.setContAssist();	
	
	objPr = new DpPrList();
	objPr.linkCtrl(FPTYPE);
			
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);	
	ctrlLinker.addLink("HDAY",FDAY);
	//ctrlLinker.addLink("HP",FPTYPE);	
	ctrlLinker.addLink("HPN",FPCENANO);	
	ctrlLinker.addLink("HSUM",HSUMP);	
	ctrlLinker.addLink("HSNDS",HNDSP);	
	ctrlLinker.addLink("HPNDS",FNDS_PROC);	
	//ctrlLinker.addLink("HSAKC",FSUM_AKC);	
	ctrlLinker.addLink("HKOL",FKOL);
	ctrlLinker.addClLink("HPLCH",objPlat);
	ctrlLinker.addClLink("HMOL",objMol);
	ctrlLinker.addClLink("HPODR",objPodr);
	ctrlLinker.addLink("HDISCOUNT", FDISCOUNT);
	
	var rowmol = objDoc.getPar("_rowmol");
	var rowpdr = objDoc.getPar("_rowpdr");
	var rowpst = objDoc.getPar("_rowpst"); 
	objMol.setMode( rowmol?	 "0!" : "");
	objPodr.setMode( rowpdr? "0!" : "");
	
	
	ctrlLinker.updateData(false);
	
	
	if (extPar.mode == "ADD")
	{
		/*
		objPr.setCod(pricetyp);
		FPCENANO.value = priceuse;	
		*/
		FNDS_PROC.value = nds;
		if(extPar.org)
			objPlat.setCod(extPar.org);
		
	}
	else
	{
		objPr.setCod(objDoc.getVar("HP"));
		oVal.setCod(objDoc.getVar("HVAL"));
		oValP.setCod(objDoc.getVar("HVALP"));
		/*
		objPlat.setCod(objDoc.getVar("HPLCH"));
   		objPodr.setCod(objDoc.getVar("HPODR"));   		
   		objMol.setCod(objDoc.getVar("HMOL"));
   		*/
		
		if(objDoc.getVar("HPNDS")!=0)
   			FNDS_PROC.value = nds;	
	}
		
	//objPlatRs = new DpPostRs();
	//objPlatRs.setDpCl(objPlat, objPlat.getCod() != 0);
	//objPlatRs.linkCtrl(FDBKR_RAS_SCH,FDBKR_MFO,FDBKR_BNK);
	
	if(nmklsel == 1 || otpsel == 1)
	{
		objPr.setMode("0");
		Enable(FPTYPE);
		Enable(FPCENANO);
	}
	else
	{
		objPr.setMode("");
		Disable(FPTYPE);
		Disable(FPCENANO);
	}
	
	Disable(HSUMOV);
	Disable(HSUMSNDSO);
	//Disable(FSUM_AKC);
	Disable(FKOL);
	Disable(HNDSOV);
	
	Disable(HSUMP);
	Disable(HNDSP);
	Disable(HSUMSNDSP);
	
	Disable(HSUM0);
		
	setFocus(FDOC_NUM);
		
	setValid(FNDS_PROC, recalcSum);
	setValid(FDOC_DAT, recalcSum);
	setValid(TFVAL, recalcSum);
	setButton(SETDISCOUNT, setDiscount);
	
	if(extPar.mode != "ADD" || extPar.submode=="GETORDER")
		refreshViewer();
	//recalcSum();
	
	grid.addAccel(GA_CTRL, "Q", "EDIT_KOL");
	grid.addAccel(GA_CTRL, "P", "EDIT_CENA");

	if (extPar.mode == "ADD")
	{
		onChangeNop();
	}
}

function afterUpdateOrg()
{
	if(objPlat.getCod())
		loadOrgPrice()
}

//грузит тип прайса и номер цены из расширений контрагента (для сервисного центра)
function loadOrgPrice()
{
	if(objPlat.getExt("PRICE1")!=null)
		objPr.setCod(objPlat.getExt("PRICE1"));
	if(objPlat.getExt("PRICEN1")!=null)
		FPCENANO.value = objPlat.getExt("PRICEN1");
}

function onChangeNop()
{
	objDoc = extPar.doc;
		
	rowmol = objDoc.getPar("_rowmol");
	rowpdr = objDoc.getPar("_rowpdr");	
	objMol.setMode( rowmol?	 "0!" : "");
	objPodr.setMode( rowpdr? "0!" : "");
	
	pricetyp = objDoc.getPar("_pricetyp");
	priceuse = objDoc.getPar("_priceuse");
	nmklsel = Number(objDoc.getPar("_nmklsel"));
	otpsel = Number(objDoc.getPar("_otpsel"));
	
	FPTYPE.value = pricetyp;
	FPCENANO.value =priceuse;
	loadOrgPrice();
	
	if(nmklsel == 1 || otpsel == 1)
	{
		objPr.setMode("0");
		Enable(FPTYPE);
		Enable(FPCENANO);
	}
	else
	{
		objPr.setMode("");
		Disable(FPTYPE);
		Disable(FPCENANO);
	}
	
	grid.DeletePages();
	nk.loadGrid();
}

function addRecord()
{
	return false;
}

function canEditRecord(sMode)
{	
	if(!dpGridEdit || sMode=="ADD")
		return false;
	return true;
}

function startEdit_kol()
{
	
}

function endEdit_kol()
{	
	grid.onEndEditRow();	
}

function saveRecord()
{
	var tbl = grid.getTable();
	var kol = tbl.getValue("FKOL");
	var cena = tbl.getValue("FCENAPR");
	var rowID = parseInt(grid.getTable().getValue("fwid"));
	var oRow =  objDoc.getRow("ROW", rowID);
	if(!oRow)
		return false;
	oRow.setVar("RKOL",  kol);
	oRow.setVar("ROCENA",  cena);	
	//oRow.setVar("RFOCENA",  cena);	//после редактирования этой цены повторно применяется скидка!
	//tbl.setValue("F1CENA", cena);
	return true;
}

function editKol(isMouseClick)
{
	if(!dpGridEdit || isMouseClick)
		return;
	var tbl = grid.getTable();
	grid.getTable().MoveNext();
	var editRow = tbl.getAbsolute()+1;
	var editCol = grid.getColumnIndexByName("FKOL");	
	recalcSum();
	if(grid.getTable().isEOF())
	{
		dpGridEdit.grid = null;
		dpGridEdit = null;
		return;
	}
	grid.getTableControl().setSelection(editCol+1, editRow, true);
	grid.runGridMenu("EDIT");		
}

function editCena(isMouseClick)
{
	if(!dpGridEdit || isMouseClick)
		return;
	var tbl = grid.getTable();
	grid.getTable().MoveNext();
	var editRow = tbl.getAbsolute()+1;
	var editCol = grid.getColumnIndexByName("FCENAPR");	
	recalcSum();
	if(grid.getTable().isEOF())
	{
		dpGridEdit.grid = null;
		dpGridEdit = null;
		return;
	}	
	grid.getTableControl().setSelection(editCol+1, editRow, true);
	grid.runGridMenu("EDIT");	
}

function docRefreshData()
{
	//при добавлении новой строки устанавливаем FINSCH_FAK = 0
	ExecuteSQL("UPDATE "+ nk.bufName +" SET FINSCH_FAK = 0 WHERE FINSCH_FAK IS NULL");	
	
	//если запрещено выписывать с разных МОЛ, проставляем из заголовка
	var rowpdr = (objDoc.getPar("_rowpdr") == true);
	var rowmol = (objDoc.getPar("_rowmol") == true);
	if (!rowpdr || !rowmol)
	{
		var sSQL = "";
		if (!rowpdr)
			sSQL += ", FPODR = " + sqlTo(objDoc.getVar("HPODR"));
		if (!rowmol)
			sSQL += ", FMOL = " + sqlTo(objDoc.getVar("HMOL"));					
		ExecuteSQL("UPDATE " + nk.bufName + " SET " + sSQL.substr(1));
		
		var t = OpenTable("s", nk.bufName);
		while (!t.isEOF())
		{
			var nID = Number(t.getValue("FWID"))
			var oRow = objDoc.getRow("ROW", nID);
			if (oRow != null)
			{
				if (!rowpdr)
					oRow.setVar("RPODR", objDoc.getVar("HPODR"));						
				if (!rowmol)
					oRow.setVar("RMOL", objDoc.getVar("HMOL"));						
			}
			t.moveNext();
		}
		t.close();
	}
	
	ExecuteSQL("DELETE FROM ^ANLTK WHERE "+ nk.where);
	nk.modifyData("COPY", nk.rowsName, nk.fields2copy, nk.bufName, nk.where +" AND FINSCH_FAK = 0");
	
	ExecuteSQL("DELETE FROM ^SCH_FAK WHERE "+ nk.where);
	nk.modifyData("COPY", "^SCH_FAK", nk.fields2copy, nk.bufName, nk.where +" AND FINSCH_FAK = 1");	
	nk.tbl4Grid.requery();
}

function recalcSum()
{			
	nk.nds = Number(FNDS_PROC.value);
	nk.wItog(m);	
	
	var hsumoC = m.hsumoC;			//сумма в валюте
	var hndso = m.hndso;			//сумма НДС	
	var dt = FDOC_DAT.value;
	var kod1 = oVal.getCod();
	var kod2 = oValP.getCod();
	var kurs = 0;

	HNDSOV.value = hndso;
	
	if (m.hsumoC != null)
		hsumoC = _nv2nv("", dt, kod1, m.hsumoC, kod2, kurs);

	if(m.hndso)	
		hndso = _nv2nv("", dt, kod1, m.hndso, kod2, kurs);
	
	FKOL.value = m.hKol;
	HSUMP.value = hsumoC;						//сумма без НДС
	//HNDSO.value = round((hsumoC * nds)/100, 2);	//НДС
	HNDSP.value = round(hndso, 2);
	
	HSUMSNDSP.value = hsumoC + round(hndso, 2);
	
	HSUMOV.value = m.hsumoC;
	HSUMSNDSO.value = Number(HNDSOV.value) + Number(HSUMOV.value); //сумма с НДС
	
	HSUM0.value = round(m.hsumu1c, getPar("DECISUM"));		
}

function refreshViewer()
{
	if(extPar.mode=="MASS_EDIT")
		return;
		
	nk.refreshViewer();
	
	if(Number(FDISCOUNT.value)>0)
		GR_SUM_0.setVisible(true);
	else
		GR_SUM_0.setVisible(false);
		
	var oSnap = getSnap("select FINSCH_FAK from "+ nk.bufName +" where FINSCH_FAK=1");
	if(oSnap)
	{
		Enable(FDISCOUNT, false);
		Enable(SETDISCOUNT, false);
	}
	else
	{
		Enable(FDISCOUNT);
		Enable(SETDISCOUNT);
	}
}

function updateData()
{	
	ctrlLinker.updateData(true);
	objDoc.setVar("HVAL",	oVal.getCod());
	objDoc.setVar("HPODR",	objPodr.getCod());
	objDoc.setVar("HMOL",	objMol.getCod());	
	objDoc.setVar("HPOST",	objPlat.getCod());
	objDoc.setVar("HPLCH",	objPlat.getCod());
	objDoc.setVar("HP",		objPr.getCod());
	objDoc.setVar("HPN",	FPCENANO.value);	
}

function onSave()
{	
	updateData();
	
	objDoc.setVar("HSMTOV",	m.Fsum_tov);
	objDoc.setVar("HSBTOV",	m.Fseb_tov);
	objDoc.setVar("HSMMAT",	m.Fsum_mat);
	objDoc.setVar("HSBMAT",	m.Fseb_mat);	
	objDoc.setVar("HOSTAR",	m.Fsum_tar);
	objDoc.setVar("HUSTAR",	m.Fseb_tar);	
	objDoc.setVar("HTOTL",	m.hIsRasc);	
	objDoc.setVar("HSNDS1",	m.hndsu);
	objDoc.setVar("HPSUM",	m.hsumuc);
	//objDoc.setVar("HSUM",	m.hsumoC);	
	objDoc.setVar("HNR",	m.hNr);
	
	DropTable(nk.sTmpTbl);
}

function docMenuInit()
{		
	if(dpGridEdit)
	{
		dpGridEdit.grid = null;
		dpGridEdit = null;
	}
	
	if (!nk.tbl4Grid.IsEmpty())
	{		
		grid.AddMenuItem("GETORDER-","Cформувати накладну без урахування залишків|Сформировать накладную без учета остатков");
		if (nk.tbl4Grid.isField("FINSCH_FAK") && nk.tbl4Grid.getValue("FINSCH_FAK")==0)
		{
			grid.AddMenuItem("DIVROW-","Розбити рядок|Разбить строку");
			grid.AddMenuItem("DIVROW+","Розбити рядок за залишком|Разбить строку по остатку");
		}
		grid.AddMenuItem("GETORDER+","Cформувати накладну з урахуванням залишків|Сформировать накладную с учетом остатков");
		grid.AddMenuItem("VIEW+","Перегляд залишків|Просмотр остатков");
		
		grid.AddMenuItem("","");
		grid.AddMenuItem("EDIT_KOL", "Редагувати кількість	CTRL + Q|Редактировать количество	CTRL + Q");
		grid.AddMenuItem("EDIT_CENA", "Редагувати ціну	CTRL + P|Редактировать цену	CTRL + P");
	}
}

function docMenuHandler(id)
{		
	if(dpGridEdit)
	{
		dpGridEdit.grid = null;
		dpGridEdit = null;
	}
	
	switch(id)
	{
		case "EDIT_KOL":
			dpGridEdit = new DpGridEdit(grid);
			dpGridEdit.saveRecord = saveRecord;
			dpGridEdit.canEdit = canEditRecord;
			dpGridEdit.init = addRecord;
			
			dpGridEdit.afterEdit = editKol;
			grid.afterEditHandler(dpGridEdit, "afterEdit");
			//dpGridEdit.addValidField("Fkol", startEdit_kol, endEdit_kol);
			
			var editRow = grid.getTable().getAbsolute();
			var editCol = grid.getColumnIndexByName("FKOL");		
			grid.getTableControl().setSelection(editCol+1, editRow+1, true);
			grid.runGridMenu("EDIT");
			nk.bRefresh = false;			
			break;
		
		case "EDIT_CENA":
			dpGridEdit = new DpGridEdit(grid);
			dpGridEdit.saveRecord = saveRecord;
			dpGridEdit.canEdit = canEditRecord;
			dpGridEdit.init = addRecord;
			
			dpGridEdit.afterEdit = editCena;
			grid.afterEditHandler(dpGridEdit, "afterEdit");
			
			var editRow = grid.getTable().getAbsolute();
			var editCol = grid.getColumnIndexByName("Fcenapr");		
			grid.getTableControl().setSelection(editCol+1, editRow+1, true);
			grid.runGridMenu("EDIT");
			nk.bRefresh = false;			
			break;
		
		case "DIVROW-":
			DivRow(nk.tbl4Grid.getValue("FKOL"), 0);		    
			break;
		
		case "DIVROW+":
			var t = GetOst(nk.tbl4Grid);
			var ost = (t.IsEmpty() || t.getValue("FOST") < 0)? 0 : t.getValue("FOST");
			DivRow(ost, nk.tbl4Grid.getValue("FKOL") - ost, true);
			break;

		case "GETORDER-":
			GetOrder(nk.bufName);			
 			break;
 		
 		case "GETORDER+":
				// Буфер для отката
			var TMP_NAME = "TMP_FOR_GETORDER";
			CreateTable(TMP_NAME, nk.rowsName, "*");
				// Поля счет-фактуры
			ExecuteSQL("ALTER TABLE " + TMP_NAME + " ADD FINSCH_FAK " + SqlType("BYTE"));
			ExecuteSQL("ALTER TABLE " + TMP_NAME + " ADD FSFOST "+SqlType("BIT"));
				// FWID1 - FWID строки которая пойдет в расходную накладную 
				// (при откате она "сливается" с данной)
			ExecuteSQL("ALTER TABLE " + TMP_NAME + " ADD FWID1 "+SqlType("TEXT",12));
			
			if (!nk.tbl4Grid.IsEmpty())
			while(!nk.tbl4Grid.IsEOF())
			{
				var tblfwid = getSnap("SELECT FWID FROM " + nk.bufName 
									+ " WHERE FINSCH_FAK = 0 AND Fwid="+ nk.tbl4Grid.getValue("FWID"));
				//var bFind = tblfwid.FindFirst("FWID = " + sqlToFind(nk.tbl4Grid.getValue("FWID")));
				var bFind = tblfwid!=null;
				if (bFind)
				{	
						//Определение "следующей" записи
					var fwid = null;
					nk.tbl4Grid.MoveNext();
					if (!nk.tbl4Grid.IsEOF())
						fwid = nk.tbl4Grid.getValue("FWID");
					nk.tbl4Grid.MovePrev();
					
						// Получим остатки
					var t = GetOst(nk.tbl4Grid);
					var ost = (t.IsEmpty() || t.getValue("FOST") < 0)? 0 : t.getValue("FOST");

						// Получаем сумарное количество для уже "выписанных" строк 
						// чтобы количество не перевалило через остатки
					var tmpost = getSnap("SELECT SUM(a.FKOL) as FKOL FROM " + nk.bufName + " a"
										+ " WHERE FWID in (SELECT b.FWID1 AS FWID FROM " + TMP_NAME + " b"
														+ " WHERE b.FMOL = " + sqlTo(nk.tbl4Grid.getValue("FMOL")) 
														+ " AND b.FPODR = " + sqlTo(nk.tbl4Grid.getValue("FPODR"))
														+ " AND b.FNMKL = " + sqlTo(nk.tbl4Grid.getValue("FNMKL"))
														+")"
										);
						// 	Разбиваем строку по остатку и получаем FWID'ы новых строк			
						//  FWID1 - (стоки с FKOL <= ost) заносим в новую накладную, FWID2 - (FKOL = (FKOL - ost)) в накладную не входят 

					var sumKol   = tmpost[0]==null? 0 : tmpost[0];
					var bufKol = nk.tbl4Grid.getValue("FKOL");

					var fwidost = DivRow(ost - sumKol, bufKol - (ost - sumKol), true, true);

					if (typeof(fwidost) == "object")
					{													
						fwidost.FWID1 = Number(fwidost.FWID1);
						fwidost.FWID2 = Number(fwidost.FWID2);
						// Сохраним данные для отката
						ExecuteSQL("INSERT INTO " + TMP_NAME + "(" + getColumn(nk.bufName,false) + ",FWID1) "
								+ " SELECT " + getColumn(nk.bufName,false, "a") + ", " + sqlTo(fwidost.FWID1) + " as FWID1 "
								+ " FROM " + nk.bufName + " a "
								+ " WHERE a.FWID = " + sqlTo(fwidost.FWID2));

						if (fwidost.FWID1 == fwidost.FWID2)
							ExecuteSQL("UPDATE " + TMP_NAME
										+ " SET FKOL = 0, FWID = 0"
										+ " WHERE FWID = " + sqlTo(fwidost.FWID2)
									   );
					}
			
						// Нахождение следующей записи
					if (fwid != null)
						nk.tbl4Grid.FindFirst("FWID="+fwid);						
					else 
						nk.tbl4Grid.MoveNext();
				}
				else
					nk.tbl4Grid.MoveNext();
			}
					
			var buftmptbl = getSnap("SELECT * FROM " + TMP_NAME + " WHERE FWID <> FWID1");

			var tmptbl = OpenTable("s", TMP_NAME);
			if (tmptbl.IsEmpty() || buftmptbl==null)
			{
				//tmptbl = null;
				//buftmptbl = null;
				alert(ru("Остатков нет", "Залишків нема"));
			}
			else
			{
				//for(tmptbl.MoveFirst(); !tmptbl.IsEOF(); tmptbl.MoveNext())
					//if ((tmptbl.getValue("FWID") != 0) && (tmptbl.getValue("FWID") != tmptbl.getValue("FWID1")) && (tmptbl.getValue("FWID") != ""))
						//if (tmptbl.isField("FINSCH_FAK") && tmptbl.getValue("FINSCH_FAK")==0)
							//kolr("DEL", tmptbl.getValue("FWID"));
				//tmptbl = null;
				//buftmptbl = null;

				//ExecuteSQL("DELETE FROM " + nk.bufName + " WHERE FWID in (SELECT FWID FROM " + TMP_NAME + ")");
				ExecuteSQL("UPDATE " + nk.bufName + " SET FINSCH_FAK = 1 WHERE FWID in (SELECT FWID FROM " + TMP_NAME + ")");
				GetOrder(TMP_NAME, true); 		
			}
			tmptbl.close();
			//ExecuteSQL("DELETE FROM " + TMP_NAME);
			//DropTable(TMP_NAME);
			if (!nk.tbl4Grid.IsEmpty())
				nk.tbl4Grid.MoveFirst()									
 			break;
 			
 		case "VIEW+":			
			if (!nk.tbl4Grid.IsEmpty())
			{				
				var retFwid = nk.tbl4Grid.getValue("FWID");
				for(nk.tbl4Grid.MoveFirst();!nk.tbl4Grid.IsEOF();nk.tbl4Grid.MoveNext())
				{
					if (nk.tbl4Grid.isField("FINSCH_FAK") && nk.tbl4Grid.getValue("FINSCH_FAK") == 0)
					{				
						var t = GetOst(nk.tbl4Grid);
						nk.tbl4Grid.Edit();				
						if (!t.IsEmpty())
							nk.tbl4Grid.setValue("FOST", t.getValue("FOST"));
						else
							nk.tbl4Grid.setValue("FOST", 0);
						nk.tbl4Grid.setValue("FSFOST", true);
						nk.tbl4Grid.Update();
					}
				}				
				if (!nk.tbl4Grid.IsEmpty())
					nk.tbl4Grid.MoveFirst();
				
				nk.tbl4Grid.FindFirst("FWID = " + sqlToFind(retFwid));								
				if(!viewOst)
				{
					grid.FieldEx("Fost","Остатки",10);
					grid.build();
				}
				viewOst = true;								
			}
			break;
		
		default: 
			return false;
	}
	return true;	
}

function GetOst(tbl)
{
	var t;
	include("mtr_ost.js");
	oOb = new DpMtrOb();
	with (oOb)
	{
		//tblName = getOstName();		
		tblName = "TMP_RAS_OST";
		fdate = new Date().getVarDate();
		fnmkl = tbl.getValue("FNMKL");
		fpodr = tbl.getValue("FPODR");
		fmol = tbl.getValue("FMOL");
		/*
			остатки считаются с исключением
			текущего fwid'а
		*/
		//fwid = tbl.getValue("FWID");
		doCalc();
		t = getTbl();
	}
	return t;
}

// Разделить строку на две (по количеству) прямо в буфере накладной
function DivRow(kol1, kol2, disable, noshowalert)
{
	var tbl;	
//	if (noshowalert)
//		tbl = OpenTable("s", nk.bufName);
//	else
	tbl = nk.tbl4Grid;
	
	var fcena   = tbl.getValue("F1cena");	
	retCod = "";
	var par     = new Object()
	par.escape  = true;
	par.Fkol    = tbl.getValue("FKOL");
	par.Fkol1   = kol1 = Number(kol1);
	par.Fkol2   = kol2 = Number(kol2);

	if (!disable) // Выбор количества пользователем
	{
		showWindow("e_divstr.xml", SW_MODAL, par);
	}
	else // Количесво было определено остатками
	{		
		if (kol1 == 0)
		{	
			// Разбивать не надо (Остатков нет)
			if (!noshowalert)
				alert(ru("Остатков нет", "Залишків нема"));
			retCod = new Object();
			retCod.FWID1 = 0; 
			retCod.FWID2 = tbl.getValue("FWID");
		}
		else if ((kol1 >= par.Fkol ) && !noshowalert)			
			alert(ru("Остатки больше чем количество", "Залишки більші за кількість"));
		else if (kol1 < par.Fkol )
			par.escape = false;
		else
		{
			// При формировании расходной накладной по счет фактуре
			// если Остатки больше за количество, то все количество переходит в новую строку
			retCod = new Object();
			retCod.FWID1 = tbl.getValue("FWID");
			retCod.FWID2 = tbl.getValue("FWID");
		}			
	}	
	if (!par.escape)
	{		
		retCod = new Object();
		var oDocRow;		
		oDocRow = objDoc.getRow("ROW",Number(grid.getTable().getRowID()));
		oDocRow.setVar("RKOL",  par.Fkol1);
		oDocRow.setVar("R1KOL", par.Fkol1);
		oDocRow.setVar("RSUM", par.Fkol1*fcena);
		var fwid = retCod.FWID1 = id = oDocRow.getID();
		obj2DB(id, oDocRow.jDocRow, null, nk.bufName);
				
		oDocRow = objDoc.copyRow("ROW",Number(grid.getTable().getRowID()));		
		oDocRow.setVar("RKOL", par.Fkol2);
		oDocRow.setVar("R1KOL", par.Fkol2);
		oDocRow.setVar("RSUM", par.Fkol2*fcena);		
		objDoc.appendRow("ROW", oDocRow);
		retCod.FWID2 = id = oDocRow.getID();
		obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, nk.bufName);	
		if(disable)
			docRefreshData();			
	}
	return retCod;
}

// Формирует расходную накладную по счет-фактуре
function GetOrder(tblName, withOst)
{
	var strSql =  "SELECT  FMOL, FPODR, F1VAL"
	            + " FROM " + tblName + " WHERE FINSCH_FAK = " + sqlTo(0)
	            + " GROUP BY FMOL, FPODR, F1VAL";
	var tmptbl = OpenTable("s", strSql);       
	   
	if (tmptbl.IsEmpty())
	{
		alert(ru("Данная счет-фактура не имеет неоплаченных строк.\nСоздание накладной невозможно.",
	    		"Рахунок-фактура не має неоплачених рядків.\nСтворення накладної неможливе."));
	    return;
	}
	
	var par = new Object();
	par.ret = new Object();
	par.ret.fnop = null;
	
	par.isZaval = true;
	par.doc     = "NK";
	par.nop     = 0;
	par.calc    = 0;
	par.escape  = false;
	par.submode = "GETORDER";
	par.simple = true;
	showWindow("l_cl_lnk.xml", SW_MODAL, par);
	if (par.escape)
	{
		if (withOst)
			getOrderBack(tblName)
	}
	else
	{
		for (tmptbl.MoveFirst(); !tmptbl.IsEOF(); tmptbl.MoveNext())
		{        
	    	var sfpar = new Object()
	        sfpar.escape = true;
	        sfpar.Fnop   = par.ret.fnop;
	        sfpar.Fwid   = objDoc.getID();	         	         
	        sfpar.Fpodr  = tmptbl.getValue("FPODR");
	        sfpar.Fmol   = tmptbl.getValue("FMOL");
	        sfpar.Fval   = tmptbl.getValue("F1VAL");
	        sfpar.discount = FDISCOUNT.value;
	        sfpar.submode = "GETORDER";
	        if (typeof list.oCntr.getID() == "number")
	        	sfpar.Fid_dog = list.oCntr.getID();
	        //sfpar.FnopSF = objDoc.nNop;
	        	         			 
			var whereMol = " FMOL = " + sqlTo(tmptbl.getValue("FMOL"))
					  + " AND FPODR = " + sqlTo(tmptbl.getValue("FPODR"));
	        	         			 
			var whereFak = whereMol +" AND FINSCH_FAK<>"+ sqlTo(1);
			var sWhere = " WHERE "+ whereFak;
			var oSnap = getSnap("SELECT Fpost FROM " + nk.bufName + sWhere);		         
			var docNK;
			
	        if(oSnap != null)
	        {
	        	sfpar.Fpost = objPlat.getCod();
	        	var sTbl4NK = "TMP_RSF_4NK";
	        	CreateTable(sTbl4NK, nk.rowsName);	         
	        	nk.modifyData("COPY", sTbl4NK, nk.fields2copy, nk.bufName, whereFak);
	        	
	        	sfpar.tblFrom = sTbl4NK;
	        	docNK = new DpDoc(par.doc, par.ret.fnop);
	        	docNK.edit("ADD",null,sfpar);
	        }

			if (docNK && !sfpar.escape)
	        {				
				whereMol +=" AND FID_DOC = " + sqlTo(objDoc.getID());
				
				nk.modifyData("COPY", "^SCH_FAK", nk.fields2copy, nk.rowsName, whereMol);				
				ExecuteSQL("UPDATE " + nk.bufName +" SET FINSCH_FAK = 1 "+ sWhere);				
				
				ExecuteSQL("DELETE FROM ^ANLTK WHERE "+ whereMol);
				
				// Сохранение связи между счет-фактурой и накладной
				ExecuteSQL("INSERT INTO ^SFRELNK (FID_SF, FID_NK) VALUES (" 
							+ sqlTo(objDoc.getID()) + ", " + sqlTo(docNK.getID()) +")");
				//				
				naklCreate = true;
				if (withOst)
				{
					sWhere = " WHERE "+ whereMol +"  AND FKOL <> 0";
					//var tblotkat = OpenTable("s", "SELECT * FROM " + tblName + sWhere);
					
					var fwid = null;
					oSnap = getSnap("select Fwid from "+ tblName + sWhere);					
					if(oSnap)
						fwid = oSnap[0];
					nk.modifyData("EDIT", nk.bufName, nk.fields2copy, tblName, "FWID="+fwid);
					nk.modifyData("COPY", "^ANLTK", nk.fields2copy, tblName, whereMol +" AND FKOL <> 0");			

					//if (!tblotkat.IsEmpty())
					//for (tblotkat.MoveFirst(); !tblotkat.IsEOF(); tblotkat.MoveNext())
						//if (tblotkat.isField("FINSCH_FAK") && tblotkat.getValue("FINSCH_FAK")==0)
							//kolr("EDIT", tblotkat.getValue("FWID"), 0, false);
					//tblotkat = null;
				}
	        }
	        else if (withOst)
				getOrderBack(tblName, tmptbl.getValue("FMOL"), tmptbl.getValue("FPODR"))
		}	
		DropTable(sTbl4NK);
		tmptbl.close();
		tmptbl = null;	    	
	}
}

// Откат для отмены сохранения сформированой по счет-фактуре расходной накладной 
function getOrderBack(tblName, fmol, fpodr)
{
	var tblotkat = OpenTable("s", "SELECT * FROM " + tblName
								+ " WHERE " + ((fmol)? "FMOL = " + sqlTo(fmol)
								+ " AND FPODR = " + sqlTo(fpodr)
								+ " AND ":"") + " FKOL <> 0"
							);
	var tmpantbl   = OpenTable("s", "SELECT * FROM ^ANLTK "
								+ " WHERE FID_DOC = " + sqlTo(objDoc.getID())
								+ ((fmol)?" AND FMOL = " + sqlTo(fmol)
								+ " AND FPODR = " + sqlTo(fpodr):"")
								);
	var buftmptbl = OpenTable("s", "SELECT * FROM " + nk.bufName
								+ " WHERE " + ((fmol)?"FMOL = " + sqlTo(fmol)
								+ " AND FPODR = " + sqlTo(fpodr)
								+ " AND ":"") + " FINSCH_FAK = 0"
								);

	if (!buftmptbl.IsEmpty())
		for (buftmptbl.MoveFirst(); !buftmptbl.IsEOF(); buftmptbl.MoveNext())
		{
			if (tblotkat.FindFirst("FWID1 = " + sqlToFind(buftmptbl.getValue("FWID"))))			
			if (nk.tbl4Grid.FindFirst("FWID = " + sqlToFind(buftmptbl.getValue("FWID"))))
			{
				id1  = tblotkat.getValue("FWID1");
				id2  = tblotkat.getValue("FWID");				
				kol1 = Number(buftmptbl.getValue("FKOL"));
				kol2 = Number(tblotkat.getValue("FKOL"));

				oDocRow = objDoc.getRow("ROW",id1);	
				oDocRow.setVar("RKOL", kol1 + kol2);
				obj2DB(id1,oDocRow.jDocRow,null,nk.bufName);
				objDoc.deleteRow("ROW", id2);
				ExecuteSQL("delete from "+ nk.bufName +" where fwid = " + id2);

				tmpantbl.FindFirst("FWID = " + sqlToFind(buftmptbl.getValue("FWID")))
				tmpantbl.Edit();
				tmpantbl.setValue("FKOL", buftmptbl.getValue("FKOL"));
				tmpantbl.Update();
				//if (tblotkat.isField("FINSCH_FAK") && tblotkat.getValue("FINSCH_FAK")==0)
					//kolr("EDIT", tmpantbl);
			}
		}				
	/*	
	if (!tblotkat.IsEmpty())
		for (tblotkat.MoveFirst(); !tblotkat.IsEOF(); tblotkat.MoveNext())
			if(tblotkat.getValue("FWID1") == "" || tblotkat.getValue("FWID1") == 0)
				if (tblotkat.isField("FINSCH_FAK") && tblotkat.getValue("FINSCH_FAK")==0)
					kolr("EDIT", tblotkat.getValue("FWID"));
	*/
	tblotkat.close();
	tmpantbl.close();
	buftmptbl.close();
	tblotkat = null;
}

function EscFunc()
{
	if(naklCreate)
	{	
		alert(ru(
			"В текущем сеансе по данному счету-фактуре были созданы накладные.\n"
				+ "Отменить действие не возможно!", 
			"В поточному сеансі за даним рахунком-фактурою були створені накладні.\n"
				+ "Відмінити дію не можливо!"
				));
		return false;
	}	
	ExecuteSQL("DELETE FROM ^ANLTK WHERE "+ nk.where);
	nk.modifyData("COPY", nk.rowsName, fields2copy, nk.sTmpTbl, nk.where + " AND FINSCH_FAK = 0");
	ExecuteSQL("DELETE FROM ^SCH_FAK WHERE "+ nk.where);
	nk.modifyData("COPY", "^SCH_FAK", fields2copy, nk.sTmpTbl, nk.where + " AND FINSCH_FAK = 1");
	DropTable(nk.sTmpTbl);
	return true;
}
			
function onChangeCena()
{
	if (objDoc.getVar("HVAL") != oVal.getCod())
	{
		var tRow = objDoc.jDoc.getRowTable("ROW");
		if (!tRow.IsEmpty() && confirm("Изменилась валюта. Перевести цены со старой в новую валюту"))
		{
			var crossKurs = _nv2nv("", FDOC_DAT.value, objDoc.getVar("HVAL"), 1, oVal.getCod());
			
			for (; !tRow.IsEOF(); tRow.MoveNext())
			{
				tRow.setValue("R1CENA", tRow.getValue("R1CENA") * crossKurs);
				tRow.setValue("ROCENA", tRow.getValue("ROCENA") * crossKurs);
			}
			ExecuteSQL("UPDATE " + nk.bufName
				+ " SET f1cena=f1cena*" + crossKurs
					+ ", fcenapr=fcenapr*" + crossKurs
				);
			refreshViewer()				
		}
		objDoc.setVar("HVAL", oVal.getCod());
	}
}
			
function psum(sum)
{
	if(oVal)
		return _nv2nv("", FDOC_DAT.value, oVal.getCod(), sum, oValP.getCod());
	return 0;
}

function pval()
{
	if(oValP)
		return oValP.getTxts();
	return "";
}

function setDiscount()
{
	var discount = Number(FDISCOUNT.value);
	var sWhere = "";
	//if(grid.getSelectedCount()>0)
	//	sWhere = " where "+ grid.getSqlSelected();
	var sum0 = 0;
	var t = nk.tbl4Grid;
	objDoc.gotoFirstRow();
	for(t.MoveFirst(); !t.isEOF(); t.MoveNext())
	{
		var nID = Number(t.getValue("FWID"))
		var oRow = objDoc.getRow("ROW", nID);
		if (oRow != null)
		{			
			var kol = Number(oRow.getVar("RKOL"));
			var cena = Number(oRow.getVar("RFOCENA"));
			var otpCena = cena - (cena*discount/100);
			oRow.setVar("RDISCOUNT", discount);
			oRow.setVar("ROCENA", otpCena);			
			sum0 += (kol*cena);
			ExecuteSQL("update "+ nk.bufName +" set FDISCOUNT="+ discount +" where FWID="+ nID);
			ExecuteSQL("update "+ nk.bufName +" set FCENAPR="+ otpCena +" where FWID="+ nID);
		}
	}
	refreshViewer();
			
	HSUM0.value = round(sum0, getPar("DECISUM"));	
}

function docLoadRowToBuf(oDocRow)
{
	include("doc\\nakl\\DpNkRow.js");
	var rnk = new DpNkRow(oDocRow);
	var cena = oDocRow.getVar("ROCENA");
	var discount = oDocRow.getVar("RDISCOUNT");
	var otpCena = rnk.calc_discount(cena, discount);
	oDocRow.setVar("ROCENA", otpCena);
}

function onExit()
{
	if (nk)
	{
		nk.dispose();	
	}
}

include("sys\\DpBaseDlg.js");