include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpNmkl.js");

var objDoc = extPar.doc;
var Fnrows = 0;
var bufCoName = "TMP_COBUF_"+ objDoc.sDocLbl +"_Org"+ iOrg;
var tmpTbl = "TMP_SU";	
var tblCoRows;
var ruRow;

function Load()
{	
	objDoc.isBuf = true;	
	objNmkl = new DpNmkl(null, null, "S");
		
	nk = new DpNakl(objDoc, this);	
	nk.rowsName = "RRU";
	nk.where = '';
	nk.orderBy = "FCLIENT, FNMKL";
	nk.load();	
	
	FDOC_NUM.mask = MASK_DOCNUM;
	FSUM.mask     = FSUMU.mask   = FRUSUM.mask = MASK_SUM;
	FKOL.mask	  = MASK_KOL;
			
	objNmkl.CanSelectAll = true;
	objNmkl.linkCtrl(FNMKL,tFNMKL);
	nds = Number(objNmkl.getExt("_NDS"));
		
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	ctrlLinker.addLink("HDATRU",FRU_DAT);	 	
 	ctrlLinker.addLink("HSUM",FSUM);
	ctrlLinker.addLink("HKOL",FKOL);	
	
	ctrlLinker.updateData(false);
	
	if (extPar.mode == "ADD")
	{
		objNmkl.setCod(0);
		FDOC_NUM.value = "";
	}
	else
		objNmkl.setCod(objDoc.getVar("HNMK"));
		
	Disable(FSUM);
	Disable(FKOL);			
	Disable(FRUSUM);
	Disable(FSUMU);
	
	setFocus(FDOC_NUM);		
	
	//if(extPar.mode != "ADD")
	//	getSURows();
	
	loadHistory();	
	
	recalcSum();
}

function docLoadBuf()
{
	var nId = (extPar.mode == "COPY") ? objDoc.nOldID : objDoc.getID();
		
	CreateTable(nk.bufName, ROW_PTN, "FWID");			
	ExecuteSQL("DELETE FROM "+ nk.bufName, false);
	nk.modifyData("COPY", nk.bufName, fields2copy, nk.rowsName, nId);
	
	CreateTable(nk.sTmpTbl, ROW_PTN);	
	ExecuteSQL("DELETE FROM "+ nk.sTmpTbl, false);
	nk.modifyData("COPY", nk.sTmpTbl, fields2copy, nk.rowsName, objDoc.getID());
	
	ExecuteSQL("ALTER TABLE " + nk.bufName + " ADD FOST "	+ SqlType("LONG"), false);
	ExecuteSQL("ALTER TABLE " + nk.bufName + " ADD FCENAPR "+ SqlType("LONG"), false);
	ExecuteSQL("ALTER TABLE " + nk.bufName + " ADD FPOST "	+ SqlType("LONG"), false);
	ExecuteSQL("ALTER TABLE " + nk.bufName + " ADD FID_PN "	+ SqlType("LONG"), false);
	ExecuteSQL("ALTER TABLE " + nk.bufName + " ADD FCENA_ORD "+ SqlType("LONG"), false);
}

function docTblTie()
{
	clTie(nk.tbl4Grid,"cl","=" + sqlTo(getPar("CODPLAT"))+",FCLIENT");	
	nk.tbl4Grid.tie("CL_POST", "cl_p", "FWID_CL", "cl.FWID");	
	nk.tbl4Grid.tie("CL_ORGRS", "cl_bank", "FWID_CL", "cl_p.FWID_CL,="+SqlTrue);
	/*
	clTie(nk.tbl4Grid, "coun", "=" + getPar("codCountry") + ",post.FcodCountry", "clc");
	clTie(nk.tbl4Grid, "regi", "=" + getPar("codRegion") + ",post.FcodRegion", "clr");
	clTie(nk.tbl4Grid, "area", "=" + getPar("codArea") + ",post.FcodArea", "cla");
	clTie(nk.tbl4Grid, "loca", "=" + getPar("codLocate") + ",post.FcodLocate", "cll");
	*/
}

function recalcSum()
{		
	oSnap = getSnap("SELECT COUNT(*) FROM "+ nk.bufName);
	if(oSnap)
		Fnrows = oSnap[0];
			
	oSnap = getSnap("SELECT SUM(buf.FKOL), SUM("+sqlRound("buf.Fcena * buf.Fkol",getPar('PRINTDECISUM'))+") "
					+", SUM(tmp.Fcena * tmp.Frukol), SUM(tmp.Fcena * tmp.FKOL)"
				+" FROM "+ nk.bufName +" buf "
					+" inner join "+ tmpTbl +" tmp "
						+" on tmp.FCLIENT=buf.FCLIENT"
							+" and tmp.FCENA=buf.FCENA");		
	if(oSnap)
	{
		FKOL.value = oSnap[0];
		FSUM.value = oSnap[1];
		FRUSUM.value = oSnap[2];
		if(Number(oSnap[3])==0)
			FSUMU.value  = oSnap[2];
		else
			FSUMU.value  = oSnap[3];		
	}
	
	oSnap = getSnap("SELECT SUM(buf.FKOL), SUM("+sqlRound("buf.Fcena * buf.Fkol",getPar('PRINTDECISUM'))+") "
						+" FROM "+ nk.bufName +" buf ");
	if(oSnap)
	{
		FKOL.value = oSnap[0];
		FSUM.value = oSnap[1];
	}	
	
	FSUMU.value = Number(FSUMU.value) + Number(FSUM.value);
}

function updateData()
{	
	objDoc.setVar("HNMK",objNmkl.getCod());
	ctrlLinker.updateData(true);
}

function onSave()
{
	if(!checkOrg())
		return false;
	updateData();	
	objDoc.setVar("HNR", Fnrows);	
	
	nk.saveRows();
}

function checkOrg()
{
	var oSnap = getSnap("select FCLIENT,count(*) as cnt from "+ nk.bufName 
						+" group by FCLIENT order by cnt desc");
	if(oSnap && Number(oSnap[1])>1)
	{
		var sMsg = UR("Для контрагента "+ oSnap[0] 
						+" введено декілька рядків!"
						+"\nПродовжити збереження?"
					+"|Для контрагента "+ oSnap[0] 
						+" введено несколько строк!"
						+"\nПродожить сохранение?");
		if(!confirm(sMsg))
		{
			nk.tbl4Grid.FindFirst("FCLIENT="+ oSnap[0]);
			grid.setFocus();
			grid.refresh();			
			return false;
		}		
	}
	return true;
}

function docMenuInit()
{		
	grid.AddMenuItem("MASS","Масове введення|Масовый ввод");
	grid.AddMenuItem("GETSUROW", "Завантаження рядків за умовою|Загрузка строк по условию");
	grid.AddMenuItem("GETHISTORY", "Історія коригувань|История изменений");	
}

function docMenuHandler(sID)
{		
	switch(sID)
	{
		case "GETSUROW":
			getSURows();
			break;
		
		case "GETHISTORY":
			showHistory();
			break;
			
		case "MASS":			
			if (objNmkl.getCod() == 0)
			{
				alert(UR("Введить номенклатуру|Введите номенклатуру"));
				setFocus(FNMKL);
				return;
			}
			if(!findRU())
				return;
			
			var par = new Object();
			
			showWindow("i_filter.xml",SW_MODAL,par);
			if(par.escape)		
				return false;
				
			par.fnmk = objNmkl.getCod();
			par.tnmk = objNmkl.getTCod();
			par.dat = objDoc.getVar("HDAT");
			par.rowName = nk.bufName;
			par.tblName = getTmpTableName();
			par.Frudate	= objDoc.getVar("HDATRU");
			
			//par.escape = true;
			showWindow("l_sumass.xml", SW_MODAL, par);
			if(par.escape)
				return false;
				
			include("Objects\\DpClNo.js");	
			var tbl = OpenTable("m", "select * from "+ par.tblName 
							+" where FDIFKOL>0 or FDIFKOL<0");
			for(tbl.MoveFirst(); !tbl.isEOF(); tbl.moveNext())
			{	
				oDocRow = objDoc.createRow("ROW");
				objDoc.appendRow("ROW", oDocRow);					
				rowID = oDocRow.getID();				
				var cena = Number(tbl.getValue("FCENA"));
				//cena = round(cena, 2);
				
				oDocRow.setVar("RNOM",	findFreeClNo(nk.bufName, "fnom_str"));
				oDocRow.setVar("RTNMK",	objNmkl.getCod());
				oDocRow.setVar("RUCENA",cena);
				oDocRow.setVar("RORG",	tbl.getValue("FCOD"));
				oDocRow.setVar("RKOL",	tbl.getValue("FDIFKOL"));
				oDocRow.setVar("RDOG",	tbl.getValue("FID_DOG"));
							
				obj2DB(rowID, oDocRow.jDocRow, null, nk.bufName);
				grid.getTable().requery();		
			}	
			tbl.close();
			DropTable(par.tblName);	
			
			loadHistory();
			recalcSum();
			break;
		
		default: 
			return false;
	}	
}

function showHistory()
{
	loadHistory();
	
	var tmpTableStr = getUniqName();
	//tmpTableStr = "TMP_SU_STR";
	DropTable(tmpTableStr);
	var sSql = "SELECT FDATE, Fcena, Fkol, "
				+ IIF("FID_DOC<>" + sqlTo(objDoc.getID()), "1", "2")+" AS FRU "
			+" INTO " + tmpTableStr
			+" FROM " + bufCoName
			+" WHERE Fclient = " + sqlTo(nk.tbl4Grid.getValue("Fclient"))
				+" AND Fnmkl = " + nk.tbl4Grid.getValue("Fnmkl")
				+" AND Fcena = " + nk.tbl4Grid.getValue("Fcena")
	ExecuteSQL(sSql);
	/*	
	var sSql = "INSERT INTO "+ tmpTableStr +" (FDATE, Fcena, Fkol, Fru) "
			+" VALUES (" + sqlTo(objDoc.getVar("HDATRU")) + ", "
				+ sqlTo(nk.tbl4Grid.getValue("Fcena")) + ", "
				+ sqlTo(nk.tbl4Grid.getValue("Fkol")) + ", "
				+ "0 )"
	ExecuteSQL(sSql);
	*/
	var tblStr = OpenTable("SELECT * FROM "+ tmpTableStr +" ORDER BY FRU, Fdate");
	var par		= new Object();
	par.tbl	= tblStr;
	par.tblName	= tmpTableStr;
	par.Fclient	= nk.tbl4Grid.getValue("Fclient");
	par.Fnmkl	= Number(nk.tbl4Grid.getValue("Fnmkl"));
	par.Frudate	= objDoc.getVar("HDATRU");
	showWindow("l_su_str.xml", SW_MODAL, par);
			
	tblStr.close();
	DropTable(tmpTableStr);
}

function getSURows(par)
{
	if(!findRU())	
		return;	
	nk.loadFrom(tmpTbl); //загружаем строки
}

function loadHistory(nmkl)
{		
	if(!nmkl)
		nmkl = objNmkl.getCod();
	
	ExecuteSQL("drop table "+ bufCoName, false);
	CreateTable(bufCoName, nk.rowsName);
	var sSql = "INSERT INTO ^"+ bufCoName 
					+" (FDATE, FNMKL, FCENA, FKOL, FNOM_STR, FCLIENT, FID_DOC, FWID, FDOC) "
				+" SELECT FDATE, a.FNMKL, "+ sqlRound("FCENA", 2) +", a.FKOL, FNOM_STR, FCLIENT, FID_DOC, a.FWID, a.FDOC"
				+" FROM ^" + nk.rowsName + " a "
					+" INNER JOIN ^HRU b ON a.Fid_doc = b.Fwid "
				+" WHERE b.Fdoc='SU' "
					+" AND b.Fdoc_dat<="+ sqlTo(objDoc.getVar("HDAT"))
					+" AND b.FRU_DAT="+ sqlTo(objDoc.getVar("HDATRU"))
					+" AND a.Fnmkl="+ nmkl
	ExecuteSQL(sSql);
	
	ExecuteSQL("drop table "+ tmpTbl, false);
	CreateTable(tmpTbl, nk.rowsName);	
	ExecuteSQL("ALTER TABLE "+ tmpTbl +" ADD FRUKOL "+ SqlType("DOUBLE"));	
	var sSql = "INSERT INTO "+ tmpTbl 
					+" (FDATE, FNMKL, FCENA, FDOC, FRUKOL, FWID, FID_DOC, FCLIENT) "
				+" SELECT FDATE, FNMKL, "+ sqlRound("FCENA", 2) +", FDOC, SUM(a.FKOL) AS FRUKOL, "
					+ "MAX(a.FWID) AS FWID, MAX(a.FID_DOC) AS FID_DOC, FCLIENT"
				+" FROM ^"+ nk.rowsName +" a "
				+" WHERE Fdoc = 'RU' "
					+" AND Fdate="+ sqlTo(objDoc.getVar("HDATRU"))
					+" AND Fnmkl="+ nmkl
				+" GROUP BY FCLIENT, FNMKL, FCENA, FDOC, FDATE ";
	ExecuteSQL(sSql);	

	sSql = "UPDATE "+ tmpTbl
			+" SET FKOL=FRUKOL + (SELECT sum(b.Fkol) FROM "+ bufCoName +" b "
				+" WHERE "+tmpTbl+".FCLIENT = b.FCLIENT "
					+" AND "+tmpTbl+".Fnmkl = b.Fnmkl "
					+" AND "+tmpTbl+".Fcena = b.Fcena "
				+" GROUP BY b.FCLIENT, b.Fnmkl, b.Fcena)"
	ExecuteSQL(sSql);	
}

function findRU(date)
{
	if(!date)
		date = objDoc.getVar("HDATRU");
	
	var oSnap = getSnap("SELECT * FROM ^HRU "
					+" WHERE Fdoc = 'RU' "
					+" AND Fdoc_dat = "+ sqlTo(date));
	if(!oSnap)
	{
		alert(ru("Не найдена реализация услуг на дату ", "Не знайдено реализацию послуг на дату ") 
				+ StrDat(date, "DMY"));
		setFocus(FRU_DAT);
		return false;
	}
	return true;
}

function isCorectLPU(cod)
{
	if(objDoc.getVar("HOP")==xcl("0",cod,"LPU"))
		return true;
	else
	{
		WAIT(ru("У контрагента №"+cod+" код ЛВУМГ не соответсвует номеру папки!",
				"У контрагента №"+cod+" код ЛВУМГ не відповідає номеру папки!"));
		return false;
	}
}

function isDog(id_dog,cod)
{
	if(Number(id_dog)==0)
	{
		WAIT(ru("Существуют записи с непроставленными договорами!","Існують записи з непроставленими договорами!"));
		return false;
	}
	var snap = getSnap("select fwid from ^contract where fwid="+id_dog);
	if(snap!=null)
		return true;
	else
	{
		WAIT(ru("У контрагента №"+cod+" отсутствует договор (ID="+id_dog+")","У контрагента №"+cod+" відсутній договір (ID="+id_dog+")"));
		return false;
	}
}

include("sys\\DpBaseDlg.js");