include("doc/DpDocList.js");
include("doc/nakl/DpNakl.js");
include("Objects/DpNmkl.js");
include("Objects/DpLNop.js");
include("Objects/DpClNo.js");
include("gridedit.js");

var cRowTbl = "TMP_RSZ";
var sTbl4NK = "TMP_RSZ_4NK";
var sTbl4PN = "TMP_RSZ_4PN";

var objDoc = extPar.doc;
var oDocRow = null;
var tblRows;
var dpGridEdit = null;

function Load()
{
	objDoc.isBuf = true;
	
	nk = new DpNakl(objDoc, this);	
	nk.rowsName = "RSZ";	
	nk.load();	
		
	CreateTable(sTbl4PN, "RSZ", "fwid");	
	CreateTable(sTbl4NK, "RSZ", "fwid");
	
	FDOC_NUM.mask = MASK_DOCNUM;
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT); 		
	ctrlLinker.updateData(false);
			
	setFocus(FDOC_NUM);

	//recalcSum();	
	
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.init = addRecord;
	dpGridEdit.canEdit = canEditRecord;
	dpGridEdit.saveRecord = saveRecord;
	dpGridEdit.addValidField("fpodr", startEdit_fpodr, endEdit_fpodr);
	dpGridEdit.addValidField("nmk.fcod", startEdit_fnmkl, endEdit_fnmkl);
	dpGridEdit.addValidField("fpost", startEdit_fpost, endEdit_fpost);
	dpGridEdit.addValidField("fnop_nk", startEdit_fnop_nk, endEdit_fnop_nk);
	dpGridEdit.addValidField("fnop_pn", startEdit_fnop_pn, endEdit_fnop_pn);
	
	tblRows = grid.getTable();	
}

function addRecord()
{
	with (this)
	{	
		initValue("fkol", 0);
		initValue("fcena", 0);
		initValue("fvcena", 0);				
	}
}

function saveRecord()
{
	var useWID = parseInt(grid.getTable().getValue("fwid"));
	var docRow =  objDoc.getRow("ROW", useWID);
	if (docRow == null)
	{
		docRow = objDoc.createRow("ROW");
		docRow.setID(useWID);
		objDoc.appendRow("ROW", docRow);
	}
	with (docRow)
	{
		setVar("RNOM",  tblRows.getValue("fnom_str"));
		setVar("RSUM", tblRows.getValue("fsum"));
		setVar("REDI", tblRows.getValue("fedi"));
		setVar("RKOLSPR", tblRows.getValue("fkol_spr"));
		setVar("RUCENA", tblRows.getValue("fcena"));
		setVar("RVCENA", tblRows.getValue("fvcena"));
		setVar("RMOL", tblRows.getValue("fmol"));
		setVar("RPODR", tblRows.getValue("fPodr"));
		setVar("RPOST", tblRows.getValue("fpost"));
		setVar("RORG", tblRows.getValue("fclient"));
		setVar("RKOL", tblRows.getValue("fkol"));		
		setVar("RTNMK",	 tblRows.getValue("fnmkl"));			 			 
		setVar("RTT", tblRows.getValue("ftt"));
		setVar("RNKNOP", tblRows.getValue("fnop_nk"));
		setVar("RPNNOP", tblRows.getValue("fnop_pn"));	
		setVar("RISNK", tblRows.getValue("fisnk"));
		setVar("RISPN", tblRows.getValue("fispn"));	
		setVar("RTYPE",tblRows.getValue("frtype"));	
		setVar("RSCENA",tblRows.getValue("fcenapr"));										
	}
	return true;
}

function canEditRecord()
{	
	return true;
}

function startEdit_fpodr(oCtrl)
{
	objPodr = new DpCl();   	
	objPodr.setClcl(getPar("CODPLAT"));	
	objPodr.setCod(Number(oCtrl.getValue()));
	objPodr.linkCtrl(oCtrl);
}

function endEdit_fpodr(oCtrl)
{
	if (!objPodr.validCtrl())
		return false;
	oCtrl.setValue(Number(objPodr.getCod()));
	return true;
}

function startEdit_fnmkl(oCtrl)
{
	var sCod = String(oCtrl.getValue());	
	objNmkl = new DpNmkl();   		
	objNmkl.linkCtrl(oCtrl);	
	objNmkl.setCod(sCod);
}

function endEdit_fnmkl(oCtrl)
{
	trace("endEdit_fnmkl");
	if (!objNmkl.setCod(String(oCtrl.getValue())))
	{	
		if (!objNmkl.doZaval())
			return false;
	}	
	oCtrl.setValue(objNmkl.getCod("c"));
	dpGridEdit.setValue("fnmkl", objNmkl.getFwid());
	trace("endEdit_fnmkl 2");
	return true;
}

function startEdit_fpost(oCtrl)
{
	objPost = new DpCl();
   	objPost.setClcl(getPar("CODPLAT"));
   	objPost.setCod(Number(oCtrl.getValue()));
	objPost.linkCtrl(oCtrl);
}

function endEdit_fpost(oCtrl)
{
	if (!objPost.validCtrl())
		return false;
	oCtrl.setValue(Number(objPost.getCod()));
	return true;

}

function startEdit_fnop_nk(oCtrl)
{
	oNopNK = new DpLNop();
	oNopNK.setDoc("NK");
	oNopNK.setCod(Number(oCtrl.getValue()));
	oNopNK.linkCtrl(oCtrl);
}

function endEdit_fnop_nk(oCtrl)
{
	if (!oNopNK.validCtrl())
		return false;
	oCtrl.setValue(Number(oNopNK.getCod()));
	return true;
}

function startEdit_fnop_pn(oCtrl)
{
	oNopPN = new DpLNop();
	oNopPN.setDoc("PN");
	oNopPN.setCod(Number(oCtrl.getValue()));
	oNopPN.linkCtrl(oCtrl);
}

function endEdit_fnop_pn(oCtrl)
{
	if (!oNopPN.validCtrl())
		return false;
	oCtrl.setValue(Number(oNopPN.getCod()));
	return true;
}

function docTblTie()
{
	clTie(nk.tbl4Grid,"cl","=" + sqlTo(getPar("CODPLAT")) + ",fpodr", "CLREL1");	
	clTie(nk.tbl4Grid,"cl1","=" + sqlTo(getPar("CODPLAT")) + ",fpost", "CLREL2");	
}

function recalcSum()
{	
	var result = new Object();
	result.nRows = 0;
	result.sum = 0;
	result.kol = 0;
		
	var oSnap = getSnap("SELECT COUNT(*) FROM "+ nk.bufName);	
	if (oSnap)
		result.nRows = oSnap[0];
	if (result.nRows == 0)
		return result;	
			
	oSnap = getSnap("SELECT SUM(fcena * fkol), SUM(fkol) FROM " + nk.bufName);		
	if (oSnap == null)
		return result;
		
	result.sum = oSnap[0];
	result.kol = oSnap[1];		 
	return result;	
}

function onSave()
{
	var obj = recalcSum();
		
	objDoc.setVar("HP", objDoc.getPar("_pricetyp"));	
	objDoc.setVar("HPN", objDoc.getPar("_priceuse"));
	ctrlLinker.updateData(true);

	objDoc.setVar("HNR", obj.nRows);
	objDoc.setVar("HKOL", Number(obj.kol));
	objDoc.setVar("HSUM", Number(obj.sum));
	
	//if (extPar.mode == "EDIT")
		ExecuteSQL("DELETE FROM ^rsz WHERE fid_doc=" + sqlTo(objDoc.getID()));
	if (obj.nRows > 0)
	{
		ExecuteSQL("UPDATE " + nk.bufName +  " SET fid_doc=" + sqlTo(objDoc.getID()));
		CopyIntoFrom("^rsz", nk.bufName);
	}
}

function CopyIntoFrom(intoName, fromName, strFields, strWhere)
{
	if (typeof fromName != "string" || typeof intoName != "string")
		return false;
	if (typeof strFields == "undefined")
	{
		if (intoName[0] == "^")
			strFields = GetPatternIntersection(intoName.substring(1), intoName.substring(1));
		else
			strFields = GetPatternIntersection(intoName, intoName);
	}	
	if (typeof strWhere != "string")
		strWhere = "";
	else
		strWhere = " WHERE " + strWhere;
		
	return ExecuteSQL("INSERT INTO " + intoName + "(" + strFields + ")" +
			  	  	  " SELECT " + strFields +
			  	  	  " FROM " + fromName + strWhere);	
}

function docMenuInit()
{	
	if(tblRows.isEmpty())
		return;
	
	with (grid)
	{		
		if(tblRows.getValue("FTT")=="NM")
			AddMenuItem("SET_POST","Встановити постачальника і ціну|Установить поставщика и цену");
		AddMenuItem("MAKE_NK_ALL","Зформувати видаткову накл. за всіма покупцями" 
								+"|Сформировать расх. накл. по всем покупателям");
		AddMenuItem("MAKE_NK","Зформувати видаткову накл. за поточним покупцем"
								+"|Сформировать расх. накл. по текущему покупателю");
		AddMenuItem("MAKE_NK_BYPOST","Зформувати видаткову накл. за поточним покупцем і постачальником"
								+"|Сформировать расх. накл. по текущему покупателю и поставщику");
		AddMenuItem("","");
		AddMenuItem("MAKE_PN_ALL","Зформувати приб. накл. за всіма постачальниками"
								+"|Сформировать прих. накл. по всем поставщикам");
		AddMenuItem("MAKE_PN","Зформувати приб. накл. за поточним постачальником"
								+"|Сформировать прих. накл. по текущему поставщику");
		AddMenuItem("","");
	}
}

function docMenuHandler(ID)
{		
	switch(ID)
	{
		case "SET_POST":
			gd =  new DpGetDat(new Array("t","c0","c_spr0"));
			if (gd.escape != true)
			{
				ExecuteSQL("UPDATE " + nk.bufName 
					+ " SET FPOST = " + gd.fpost + ", FCENA = " + gd.fcena
					+ " , FVCENA = " + gd.fvcena
					+ " WHERE FNMKL = " + sqlTo(tblRows.getValue("Fnmkl")));
			}
			break;
		
		case "MAKE_NK_ALL":
		case "MAKE_NK":
		case "MAKE_NK_BYPOST":	
			if (extPar.mode!="EDIT")
			{
				alert(ru("Необходимо сохранить документ перед формированием накладных\n" 
					+ "Сохраните документ и зайдите в режиме редактирования",
						"Необхідно зберегти документ перед формуванням накладних\n" 
					+ "Збережіть документ и зайдіть у режимі редагування"));
				return;
			}
			make_NK(tblRows
				, (ID == "MAKE_NK_ALL" ? true : false)
				, (ID == "MAKE_NK_BYPOST" ? true : false));
		break;
		
		case "MAKE_PN_ALL":
		case "MAKE_PN":
			if (extPar.mode!="EDIT")
			{
				alert(ru("Необходимо сохранить документ перед формированием накладных\n" 
					+ "Сохраните документ и зайдите в режиме редактирования",
						"Необхідно зберегти документ перед формуванням накладних\n" 
					+ "Збережіть документ и зайдіть у режимі редагування"));
				return;
			}
			make_PN(tblRows, (ID == "MAKE_PN_ALL" ? true : false));
		break;
		
		default: 
			return false;
	}	
}

// Формируем прих. накладную 
function make_PN(tblRows, bAll)
{	
	var mol = 1,
		podr = 1,
		post = tblRows.getValue("FPOST");
	
	var par = new Object();
	par.isZaval = true;
	par.doc     = "PN";
	par.nop     = 0;
	par.calc    = 0;
	par.escape  = true;
	par.mode = "GETORDER";
	
	par.ret = new Object();
	par.ret.fnop = null;
		
	//if (bAll)
		//WAIT("Выберете номер опер. по умолчанию (для тех, кот. не указаны)");
	
	showWindow("l_cl_lnk.xml", SW_MODAL, par);
	
	if (par.escape)
		return;
	
	var sfpar = new Object();
	sfpar.Fnop   = par.nop = par.ret.fnop;
	sfpar.escape = true;
	sfpar.Fdoc   = par.doc;
	sfpar.Fcalc  = par.calc;	
	//sfpar.Fwid   = mFid;
	sfpar.Fpodr  = podr;
	sfpar.Fmol   = mol;
	//sfpar.mode   = "COPY";
	sfpar.submode= "GETORDER";
	sfpar.FnopSF = 0;
	sfpar.Fpost  = post;
	sfpar.sz2pn  = true;
	//sfpar.tblFrom = nk.bufName;

	if (bAll)
	{
		/*	формирование PN по всем поставщикам:
			1 - формирование в разрезе поставщиков	
			2 - формирование в разрезе поставщиков + номер папки		
		*/
		// сначала выбираем всех разных поставщиков
		var tbl2PN = OpenTable("s", "SELECT DISTINCT(FPOST) FROM " + nk.bufName);
		for (tbl2PN.MoveFirst(); !tbl2PN.IsEOF(); tbl2PN.MoveNext())
		{
			sfpar.Fpost = tbl2PN.getValue("FPOST");
			// теперь вырираем разные номера папок у этих поставщиков
			var tbl2PN_NOP = OpenTable("s", "SELECT DISTINCT(FNOP_PN) FROM " + nk.bufName
									+ " WHERE FPOST = " + sqlTo(sfpar.Fpost)
									+ " AND FNOP_PN <> 0"
									);
			// bZeroHandled - обработаны ли строки с нулевыми номерами папок
			var bZeroHandled = false;
			for (tbl2PN_NOP.MoveFirst(); !tbl2PN_NOP.IsEOF(); tbl2PN_NOP.MoveNext())
			{
				sfpar.Fnop = tbl2PN_NOP.getValue("FNOP_PN");
				if (tbl2PN_NOP.getValue("FNOP_PN")==par.nop)
					bZeroHandled = true;
				/*	Выборка по поставщику и номеру папки, и если номер папки совпадает
					с номером по умолчанию(номер который ввели в диалоге запроса)
					то тогда в эту выборку включаем и строки с нулевыми папками
				*/
				ExecuteSQL("DELETE FROM " + sTbl4PN);
				ExecuteSQL("INSERT INTO " + sTbl4PN + getColumn(nk.bufName,true)
								+" SELECT " + getColumn(nk.bufName,false) + " FROM " + nk.bufName
								+ " WHERE FPOST = " + sqlTo(sfpar.Fpost) 
								+ " AND (FNOP_PN = " + tbl2PN_NOP.getValue("FNOP_PN")
									+ (tbl2PN_NOP.getValue("FNOP_PN")==par.nop ? " OR FNOP_PN=0)":")")
								);
				ExecuteSQL("UPDATE " + sTbl4PN + " SET "
					+ " F1CENA = FCENA, FCENAPR = FCENA");
				sfpar.tblFrom = sTbl4PN;
				
				var tblControl = OpenTable("s", "SELECT * FROM " + sTbl4PN);
								
				if (tblControl.IsEmpty())
					return;
				
				docPN = new DpDoc(par.doc, par.ret.fnop);
				ret = docPN.edit("ADD", null, sfpar);
				
				if (!ret)
				{
					return;
				}
				else
				{
					ExecuteSQL("UPDATE " + nk.bufName
							+ " SET FISPN = " + sqlTo(true)
							+ " WHERE FPOST = " + sqlTo(sfpar.Fpost)
							+ " AND FNOP_PN = " + sqlTo(sfpar.Fnop)
							);					
				}
			}
			// Если не обработаны строки с нулевыми номерами папок, то обрабатываем
			if (!bZeroHandled)
			{
				sfpar.Fnop = par.nop;
				ExecuteSQL("DELETE FROM " + sTbl4PN);
				ExecuteSQL("INSERT INTO " + sTbl4PN + getColumn(nk.bufName,true)
								+ " SELECT " + getColumn(nk.bufName,false) + " FROM " + nk.bufName
								+ " WHERE FPOST = " + sqlTo(sfpar.Fpost) 
								+ " AND FNOP_PN = 0"
								);
									
				
				ExecuteSQL("UPDATE " + sTbl4PN + " SET "
					+ " F1CENA = FCENA, FCENAPR = FCENA");
				
				sfpar.tblFrom = sTbl4PN;				
				
				var tblControl = OpenTable("s", "SELECT * FROM " + sTbl4PN);
				
				if (tblControl.IsEmpty())
					return;
				
				docPN = new DpDoc(par.doc, par.ret.fnop);
				ret = docPN.edit("ADD", null, sfpar);
	        		
				if (ret)
				{
					ExecuteSQL("UPDATE " + nk.bufName
							+ " SET FISPN = " + sqlTo(true)
							+ " WHERE FPOST = " + sqlTo(sfpar.Fpost)
							+ " AND FNOP_PN = 0"
							);
				}
			}
		}
	}
	else //по выбранному поставщику
	{
		if(tblRows.getValue("FISPN")==true 
			&& !confirm(ru("Приходная накладная по данной строке уже сформирована.\nВсе равно продолжить?",
							"Прибуткова накладна за данним рядком вже сформована.\nПродовжити?")))
		{
			return;
		}
		
		ExecuteSQL("UPDATE " + nk.bufName + " SET "
					+ " F1CENA = FCENA, FCENAPR = FCENA"
					+ " WHERE FPOST = " + sqlTo(sfpar.Fpost));
					
		var tblControl = OpenTable("s", "SELECT * FROM " + nk.bufName
					+ " WHERE FPOST = " + sqlTo(sfpar.Fpost));
		
		if (tblControl.IsEmpty())
			return;
			
		sfpar.tblFrom = tblControl;		
		docPN = new DpDoc(par.doc, par.ret.fnop);
		ret = docPN.edit("ADD", null, sfpar);
		
		if (ret)
		{
			ExecuteSQL("UPDATE " + nk.bufName
					+ " SET FISPN = " + sqlTo(true)
					+ " WHERE FPOST = " + sqlTo(sfpar.Fpost)
					);
		}
	}
}

// Формируе расходную накладную 
// bPodrPost - Сформировать расх. накл. по текущему покупателю и поставщику
function make_NK(tblRows, bAll, bPodrPost)
{
	var par = new Object();	
	par.isZaval = true;
	par.doc     = "NK";
	par.nop     = 0;
	par.calc    = 0;
	par.escape  = true;
	par.mode = "GETORDER";
	
	par.ret = new Object();
	par.ret.fnop = null;
	
	//if (bAll)
		//WAIT("Выберете номер опер. по умолчания (для тех, кот. не указаны)");
	
	showWindow("l_cl_lnk.xml", SW_MODAL, par);
	
	if (par.escape)
		return;

	var sfpar = new Object()
	sfpar.escape = true;
	sfpar.Fdoc   = par.doc;
	sfpar.Fcalc  = par.calc;
	sfpar.Fnop   = par.nop = par.ret.fnop;
	//sfpar.Fwid   = mFid;
	sfpar.Fpodr  = 1;
	sfpar.Fmol   = 1;
	//sfpar.mode   = "COPY";
	sfpar.submode= "GETORDER";
	sfpar.FnopSF = 0;
	sfpar.Fpost  = tblRows.getValue("FPODR");
	sfpar.sz2nk  = true;
	sfpar.Fdate = new Date();
	sfpar.tblFrom = nk.bufName;

	if (bAll)
	{
		/*	формирование NK по всем покупателям:
			1 - формирование в разрезе покупателей	
			2 - формирование в разрезе покупателей + номер папки		
		*/
		// сначала выбираем всех разных покупателей
		var tbl2NK = OpenTable("s", "SELECT DISTINCT(FPODR) FROM " + nk.bufName);
		for (tbl2NK.MoveFirst(); !tbl2NK.IsEOF(); tbl2NK.MoveNext())
		{
			sfpar.Fpost = tbl2NK.getValue("FPODR");
			// теперь вырираем разные номера папок у этих покупателей
			var tbl2NK_NOP = OpenTable("s", "SELECT DISTINCT(FNOP_NK) FROM " + nk.bufName
									+ " WHERE FPODR = " + sqlTo(sfpar.Fpost)
									+ " AND FNOP_NK <> 0"
									);
			// bZeroHandled - обработаны ли строки с нулевыми номерами папок
			var bZeroHandled = false;
			for (; !tbl2NK_NOP.IsEOF(); tbl2NK_NOP.MoveNext())
			{
				sfpar.Fnop = tbl2NK_NOP.getValue("FNOP_NK");
				if (tbl2NK_NOP.getValue("FNOP_NK")==par.nop)
					bZeroHandled = true;
				/*	Выборка по покупателю и номеру папки, и если номер папки совпадает
					с номером по умолчанию(номер который ввели в диалоге запроса)
					то тогда в эту выборку включаем и строки с нулевыми папками
				*/
				ExecuteSQL("DELETE FROM " + sTbl4NK);
				ExecuteSQL("INSERT INTO " + sTbl4NK + getColumn(nk.bufName,true)
								+ " SELECT " + getColumn(nk.bufName,false) + " FROM " + nk.bufName
								+ " WHERE FPODR = " + sqlTo(sfpar.Fpost) 
								+ " AND (FNOP_NK = " + tbl2NK_NOP.getValue("FNOP_NK")
									+ (tbl2NK_NOP.getValue("FNOP_NK")==par.nop ? " OR FNOP_NK=0)":")")
								);
				
				ExecuteSQL("UPDATE " + sTbl4NK + " SET "
					+ " F1CENA = FVCENA, FCENAPR = FVCENA,"
					+ " FIS_OTL = "+sqlTrue);
				
				sfpar.tblFrom = sTbl4NK;
				var tblControl = OpenTable("s", "SELECT * FROM " + sTbl4NK);
				
				if (tblControl.IsEmpty())
					return;
				
				docNK = new DpDoc(par.doc, par.ret.fnop);	        	
				ret = docNK.edit("ADD", null, sfpar);
					
				if (!ret)
				{
					return;
				}
				else
				{
					ExecuteSQL("UPDATE " + nk.bufName
							+ " SET FISNK = " + sqlTo(true)
							+ " WHERE FPODR = " + sqlTo(sfpar.Fpost)
							+ " AND FNOP_NK = " + sqlTo(sfpar.Fnop)
							);
				}
			}
			// Если не обработаны строки с нулевыми номерами папок, то обрабатываем
			if (!bZeroHandled)
			{
				sfpar.Fnop = par.nop;

				ExecuteSQL("DELETE FROM " + sTbl4NK);
				ExecuteSQL("INSERT INTO " + sTbl4NK + getColumn(nk.bufName,true)
								+ " SELECT " + getColumn(nk.bufName,false) + " FROM " + nk.bufName
								+ " WHERE FPODR = " + sqlTo(sfpar.Fpost) 
								+ " AND FNOP_NK = 0"
								);
				ExecuteSQL("UPDATE " + sTbl4NK + " SET "
					+ " F1CENA = FVCENA, FCENAPR = FVCENA,"
					+ " FIS_OTL = "+sqlTrue);
				
				sfpar.tblFrom = sTbl4NK;				
				var tblControl = OpenTable("s", "SELECT * FROM " + sTbl4NK);
				
				if (tblControl.IsEmpty())
					return;
				
				docNK = new DpDoc(par.doc, par.ret.fnop);
				ret = docNK.edit("ADD", null, sfpar);					
				
				if (ret)
				{
					ExecuteSQL("UPDATE " + nk.bufName
							+ " SET FISNK = " + sqlTo(true)
							+ " WHERE FPODR = " + sqlTo(sfpar.Fpost)
							+ " AND FNOP_NK = 0"
							);
				}
			}
		}
	}
	else
	{
		if(tblRows.getValue("FISNK")==true 
			&& !confirm(ru("Расходная накладная по данной строке уже сформирована.\nВсе равно продолжить?",
							"Видаткова накладна за данним рядком вже сформована.\nПродовжити?")))
		{
			return;
		}
		
		ExecuteSQL("DELETE FROM " + sTbl4NK);
		ExecuteSQL("INSERT INTO " + sTbl4NK + getColumn(nk.bufName,true)
						+ " SELECT " + getColumn(nk.bufName,false) + " FROM " + nk.bufName
							+ " WHERE FPODR = " + sqlTo(tblRows.getValue("FPODR"))
							+ (bPodrPost ? " AND FPOST = " + sqlTo(tblRows.getValue("FPOST")) : "")
						);
		ExecuteSQL("UPDATE " + sTbl4NK + " SET "
					+ " F1CENA = FVCENA, FCENAPR = FVCENA,"
					+ " FIS_OTL = "+sqlTrue);
				
		sfpar.tblFrom = sTbl4NK;
		
		var tblControl = OpenTable("s", "SELECT * FROM " + sTbl4NK);
		
		if (tblControl.IsEmpty())
			return;
			
		docNK = new DpDoc(par.doc, par.ret.fnop);	        	
		ret = docNK.edit("ADD", null, sfpar);
		
		if (ret)
		{
			ExecuteSQL("UPDATE " + nk.bufName
					+ " SET FISNK = " + sqlTo(true)
					+ " WHERE FPODR = " + sqlTo(sfpar.Fpost)
						+ (bPodrPost ? " AND FPOST = " + sqlTo(tblRows.getValue("FPOST")) : "")
					);
		}
	}
}

include("sys\\DpBaseDlg.js");