include("Objects/DpCl.js");
include("Objects/DpDocEx.js");
include("sub/crm.js");

var typeCl = null;
var programmerCl = null;
var testerCl = null;
var customerCl = null;
var statusCl = null;
var finderCl = null;

var objDoc;

var objParDocEx ;

function Load()
{
	Caption(UR("Завдання", "Задание") + ": " + modeName(this.sMode));
	
	objParDocEx = new DpDocEx(extPar.doc.sDocLbl, extPar.doc.nNop);
	objParDocEx.linkCtrl(GRPNUM);
	
	objDoc = extPar.doc;
	
	mFTIMEVIPOLN.mask = "#######.##";
	mFPROCENTVIPOLN.mask = "###";
	mFPRIORITY.mask = "###";
		
	typeCl = new DpCl("", getPar("CODTYPE"), 1);
	typeCl.linkSmartCtrl(mFTYPE_TXT);
	typeCl.setContAssist();
	
	programmerCl = new DpCl("0", getPar("CODPERS"), 0);
	programmerCl.linkSmartCtrl(mFPROGRAMMER_TXT);
	programmerCl.setContAssist();
	
	testerCl = new DpCl("0", getPar("CODPERS"), 0);
	testerCl.linkSmartCtrl(mFTESTER_TXT);
	testerCl.setContAssist();
	
	finderCl = new DpCl("0", getPar("CODPERS"), 0);
	finderCl.linkSmartCtrl(mFFINDER_TXT);
	finderCl.setContAssist();
	
	customerCl = new DpCl("0", getPar("CODPLAT"), 0);
	customerCl.linkSmartCtrl(mFCUSTOMER_TXT);
	customerCl.setContAssist();
	customerCl.AfterUpdate = fillContacts;
	
	statusCl = new DpCl("", getPar("CODSTATUS"), 1);
	statusCl.linkSmartCtrl(mFSTATUS_TXT);
	statusCl.setContAssist();
	
	ctrlLinker = new DpCtrlLinker(objDoc);	
	ctrlLinker.addLink("HNOM", mFNUMBER);
	ctrlLinker.addLink("HDAT", mFDATE);
	ctrlLinker.addLink("HCAPTION", mFCAPTION);
	ctrlLinker.addClLink("HTYPE", typeCl);
	ctrlLinker.addClLink("HFINDER", finderCl);
	ctrlLinker.addLink("HCONTROLDATE", mFCONTROLDATE);
	ctrlLinker.addClLink("HCUSTOMER", customerCl);
	ctrlLinker.addLink("HCONTENT", mFCONTENT);
	ctrlLinker.addClLink("HSTATUS", statusCl);
	ctrlLinker.addClLink("HPROGRAMMER", programmerCl);
	ctrlLinker.addClLink("HTESTER", testerCl);
	
	ctrlLinker.addLink("HPRIORITY", mFPRIORITY);
	ctrlLinker.addLink("HNAZNACHDATE", mFNAZNACHDATE);
	ctrlLinker.addLink("HENDDATE", mFENDDATE);
	ctrlLinker.addLink("HTIMEVIPOLN", mFTIMEVIPOLN);	
	ctrlLinker.addLink("HPROCENTVIPOLN", mFPROCENTVIPOLN);
	ctrlLinker.addLink("HUNIT", mFUNIT);
	ctrlLinker.addLink("HCONT", mFCONT);
	ctrlLinker.addLink("HSOLUTION", FSOLUTION);
	
	ctrlLinker.updateData(false);
	
	if(extPar.mode=="EDIT" || extPar.mode=="COPY")
	{
		typeCl.setCod(objDoc.getVar("HTYPE"));
		customerCl.setCod(objDoc.getVar("HCUSTOMER"));
		statusCl.setCod(objDoc.getVar("HSTATUS"));
		programmerCl.setCod(objDoc.getVar("HPROGRAMMER"));
		testerCl.setCod(objDoc.getVar("HTESTER"));
		finderCl.setCod(objDoc.getVar("HFINDER"));
		objParDocEx.setFwid(objDoc.getVar("HGRPID"));
		
		var sUnit = String(mFUNIT.value).trim().toLowerCase();
		if(sUnit=="d")
			mFTIMEVIPOLN.value = Number(mFTIMEVIPOLN.value)/8;
		else if(sUnit=="m")
			mFTIMEVIPOLN.value = round(Number(mFTIMEVIPOLN.value)*60, 0);
			
		fillContacts();
		mFCONT.value = objDoc.getVar("HCONT");
	}
	
	if(extPar.mode=="ADD")
	{
		typeCl.setCod(1);
		statusCl.setCod(1);
		if(extPar)
		{
			if(extPar.org)
				customerCl.setCod(extPar.org);
			if(extPar.cntID)
				mFCONT.setValue(extPar.cntID);
			if(extPar.programmer)
				programmerCl.setCod(extPar.programmer);
			if(extPar.finder)
				finderCl.setCod(extPar.finder);
		}
	}
	if(extPar.mode=="EDIT")
		loadResponse();
		
	FSOLUTION.getCtrl().setEditable(false);	
	setButton(BTN_SEARCH_SOLUTION, search_solution);
	
	FRESPONSE.getCtrl().setEditable(false);	
	setButton(BTN_ADD_RESPONSE, add_response);
	
	setValid(mFUNIT, unit_valid);
	unit_valid();
}

function onSave()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HTYPE", typeCl.getCod());
	objDoc.setVar("HPROGRAMMER", programmerCl.getCod());
	objDoc.setVar("HTESTER", testerCl.getCod());
	objDoc.setVar("HFINDER", finderCl.getCod());
	objDoc.setVar("HCUSTOMER", customerCl.getCod());
	objDoc.setVar("HSTATUS", statusCl.getCod());
	objDoc.setVar("HGRPID", objParDocEx.fwid);
	
	var time = convertTimeToHours(mFTIMEVIPOLN.value, mFUNIT.value);
	objDoc.setVar("HTIMEVIPOLN", time);
}

function fillContacts()
{
	var cont = Number(mFCONT.value);
	mFCONT.clear();
	mFCONT.addItem("0", "");
	if(!customerCl.getFWID())
		return;
	var tblCont = OpenTable("select * from ^CL_ORGCP where FWID_CL="+ customerCl.getFWID());
	for(; !tblCont.isEOF(); tblCont.MoveNext())
	{
		var contID = tblCont.getValue("FWID");
		var contTxt = tblCont.getValue("FFIO");
		var sPost = tblCont.getValue("FPOST");
		if(String(sPost).trim()!="")
			contTxt += " ("+ sPost +")";
		if(contID && contTxt)
			mFCONT.addItem(contID, contTxt);
	}
	tblCont.close();
	mFCONT.setValue(cont);
}

function unit_valid()
{
	mFTIMEVIPOLN.mask = "#######.##";
	if(String(mFUNIT.value).toLowerCase()=="m")
		mFTIMEVIPOLN.mask = "#######";
}

function convertTimeToHours(oVal, sUnit)
{
	oVal = Number(oVal);
	sUnit = String(sUnit).trim().toLowerCase();
	switch(sUnit)
	{
		case "d":
			return oVal*8;
			break;
			
		case "h":
			return oVal;
			break;
		
		case "m":	
			return oVal/60;
			break;
	}
	return oVal;
}

function search_solution()
{
	var sKeyWords = "";
	var sTopic = String(mFCAPTION.value).trim();
	var sContent = String(mFCONTENT.value).trim();
	var oPar = searchSolution(sTopic +" "+ sContent);
	if(oPar.TEXT)
		FSOLUTION.value = oPar.TEXT;
	var solutionID = oPar.FWID;	
	var sMsg = UR("Прикріпити вибране рішення до завдання?|Прикрепить выбранное решение к заданию?");
	if(solutionID && confirm(sMsg))
		saveSolutionLink(solutionID, objDoc.sDocLbl, objDoc.nNop, objDoc.getID());		
}

function add_response()
{
	include("doc/DpDoc.js");
	var doc = "RESPONSE";
	var nop = 1;
	var par = new Object();
	par.subject = mFCAPTION.value;
	par.org = customerCl.getCod();	
	var oDoc = new DpDoc(doc, nop);
	var bRet = oDoc.edit("ADD", null, par);
	if(!bRet)
		return null;
	
	loadResponse(oDoc);
	
	var m = new Object(); 
	m.FMAINWID = objDoc.getID();
	m.FDOCWID = oDoc.getID();
	m.FDOC = doc;
	m.FNOP = nop;
	m.FISPARENT = true;
	m.FWID = GetUID();
	updateTable("^DOC_LINKS", m, true);
	
	var m = new Object(); 
	m.FMAINWID = oDoc.getID();
	m.FDOCWID = objDoc.getID();
	m.FDOC = objDoc.sDocLbl;
	m.FNOP = objDoc.nNop;
	m.FISPARENT = false;
	m.FWID = GetUID();
	updateTable("^DOC_LINKS", m, true);
	
	//связь с маркетинговым списком
	var oSnap = getSnap("select FDOCWID, FNOP from ^DOC_LINKS where FDOC='ML' and FMAINWID="+ objDoc.getID());
	if(oSnap && Number(oSnap[0]))
	{
		var m = new Object(); 
		m.FMAINWID = oSnap[0];
		m.FDOCWID = oDoc.getID();
		m.FDOC = doc;
		m.FNOP = nop;
		m.FISPARENT = true;
		m.FWID = GetUID();
		updateTable("^DOC_LINKS", m, true);
		
		var m = new Object(); 
		m.FMAINWID = oDoc.getID();
		m.FDOCWID = oSnap[0];
		m.FDOC = "ML";
		m.FNOP = oSnap[1];
		m.FISPARENT = false;
		m.FWID = GetUID();
		updateTable("^DOC_LINKS", m, true);
	}
		
	return oDoc;
}

function loadResponse(oDoc)
{
	if(!oDoc)
	{
		var oSnap = getSnap("select FDOCWID, FNOP from ^DOC_LINKS where FDOC='RESPONSE' and FMAINWID="+ objDoc.getID());
		if(oSnap && Number(oSnap[0]))
		{
			include("doc/DpDoc.js");
			var doc = "RESPONSE";
			var nop = oSnap[1];			
			oDoc = new DpDoc(doc, nop);
			if(!oDoc.loadByID(oSnap[0]))
				return;
		}
		else
			return;
	}
	if(!oDoc)
		return;
	
	var response = "";
	var conf = Number(oDoc.getVar("HCONFIRM"));
	var answer = String(oDoc.getVar("HANSWER")).trim();
	var comm = String(oDoc.getVar("HCOMMENT")).trim();
	if(conf==1)
		response += UR("Позитивний|Положительный");
	else if(conf==2)
		response += UR("Негативний|Отрицательный");
	if(answer!="")
		response += "\n\n"+ answer;
	if(comm!="")
		response += "\n\n"+ comm;
	FRESPONSE.value = response;
}

include("sys/DpBaseDlg.js");