include("Objects\\DpCl.js");
include("sys\\mask.js");
include("Objects\\DpSc.js");
include("Objects\\DpCtrlLinker.js");
include("sys\\kursval.js");

var edmode, t;
var oOrg;
var objDoc = extPar.doc; 
var ctrlLinker = null;
var oCntr;

var codPlat;
var codPers;

function Load() 
{
	if(!objDoc && typeof extPar != "undefined")
		objDoc = new DpDoc(extPar.Fdoc, extPar.Fnop);
	 
  	Caption(objDoc.getCaption() + ": " + modeName(extPar.mode));
  	
  	HTARIF.mask = MASK_SUM;
  	HSUM.mask = MASK_SUM;
  	HTIME.mask = "#######";
   
   	ctrlLinker = new DpCtrlLinker(objDoc);
   	
   	codPlat = getPar("CODPLAT");
   	oOrg = new DpCl();   	
	oOrg.setClcl(codPlat);
   	oOrg.linkSmartCtrl(HORG);
   	oOrg.setContAssist();
   	oOrg.AfterLoad = loadContPers;
   	setValid(HORG, loadContPers);
   	
   	codPers = getPar("CODPERS");
   	oMgr = new DpCl();
   	oMgr.setClcl(codPers);
   	oMgr.linkSmartCtrl(HMANAGER);
   	oMgr.setContAssist();
		
   	ctrlLinker.addLink("HNOM",HNOM);
 	ctrlLinker.addLink("HDAT",HDAT); 
 	ctrlLinker.addClLink("HORG",oOrg); 	
 	ctrlLinker.addLink("HBDAT",HBDAT);      
 	ctrlLinker.addLink("HEDAT",HEDAT); 
 	ctrlLinker.addLink("HADDTIME",HADDTIME);      
 	ctrlLinker.addLink("HCTLDAT",HCTLDAT);
 	ctrlLinker.addLink("HPREDMET_RAZG",HPREDMET_RAZG);
 	ctrlLinker.addClLink("HMANAGER",oMgr);
 	ctrlLinker.addLink("HSUM",HSUM);
 	ctrlLinker.addLink("HTARIF",HTARIF);
 	ctrlLinker.addLink("HRESULT",HRESULT);
 	ctrlLinker.addLink("HTIME",HTIME);
 	ctrlLinker.addLink("HREMIND",HREMIND); 

   	ctrlLinker.updateData(false);
	
	
   	if (extPar.mode != "ADD")
   	{
   		oOrg.setCod(objDoc.getVar("HORG"));
   		oMgr.setCod(objDoc.getVar("HMANAGER"));
  		
   		HCTLTIME.value = new Date(objDoc.getVar("HCTLDAT")).getVarDate();   		
   	}
   	else
   	{
		HBDAT.setDateValue(new Date()); 
		HEDAT.setDateValue(new Date());
		HADDTIME.setTime(0);
		HCTLTIME.setTime(0);
		HTARIF.value = 2.5;
		
		if(extPar && extPar.nOrg)
			oOrg.setCod(Number(extPar.nOrg));
		if(extPar && extPar.nMgr)
			oMgr.setCod(Number(extPar.nMgr));
			
		sum_valid();		
   	}
   	loadContPers();
   	if (extPar.mode != "ADD")
   		FCONTPERS.setValue(objDoc.getVar("HCONT"));
   	
   	setValid(HDAT, mHDAT_Valid); 
   	setValid(HBDAT,time);
	setValid(HEDAT,time);
	setValid(HADDTIME,time);
	setValid(HTARIF,sum_valid);
	setValid(HTIME,sum_valid);
	
}
var escape;


function onSave()
{	
	var ctlDate = getVarTime(HCTLDAT.value, HCTLTIME.value);
	if(extPar.mode == "ADD" || extPar.mode == "COPY")
	{
		var d0 = new Date(d00).getVarDate();
		var bdat = new Date(HBDAT.value);
		var edat = new Date(HEDAT.value);
		if(differ(bdat, edat)==0 || differ(d0, edat)==0)
		{
			HEDAT.setDateValue(new Date());
			time();
		}
	}
	
	ctrlLinker.updateData(true);
	objDoc.setVar("HCONT", FCONTPERS.value);
	objDoc.setVar("HCTLDAT", ctlDate);	
}

function getVarTime(oDat, oTime)
{
	var date = new Date();	
	if(!oDat || !oTime)
		return new date;
	
	date = new Date(oDat).getVarDate();	
	date.setHours(0);
	date.setMinutes(0);
	
	var hours = new Date(oTime).getHours();
	var minutes = new Date(oTime).getMinutes();
	if(hours)
		date.setHours(hours);
	if(minutes)
		date.setMinutes(minutes);
	
	return date;
}

function loadContPers()
{
	var curCont = FCONTPERS.getValue();	
	FCONTPERS.clear();
	
	var nID = oOrg.getFWID();
	if(!nID)
		return;	
	var tPers = OpenTable("s","select * from ^CL_ORGCP "
						+" where FWID_CL="+ nID);
	while(!tPers.isEOF())
	{
		var txt = tPers.getValue("FFIO");
		var nid = String(tPers.getValue("FWID"));
		FCONTPERS.addItem(nid, txt);			
		tPers.MoveNext();
	}
	FCONTPERS.setValue(curCont);	
	if(tPers.isEmpty())
		WAIT(ru("Нет контактных лиц для '"+ oOrg.getTxt() +"'"
				,"Немає контактних особ для '"+ oOrg.getTxt() +"'"));
	tPers.close();
}

function mHDAT_Valid() 
{
   return differ(HDAT.value, d00);
}

function getTimeFromObjectVar(tbegin)
{
	var date = new Date();
	var dt = tbegin.getValue();
	date.setHours(dt.getHours())
	date.setMinutes(dt.getMinutes())
	date.setSeconds(dt.getSeconds());
	
	return date;
}

function time()
{	
	var sum = new Date(HEDAT.getValue())
			- new Date(HBDAT.getValue())						
	var d0 = new Date(HADDTIME.getValue());
	d0.setHours(0);
	d0.setMinutes(0);	
	sum += (new Date(HADDTIME.getValue()) - d0);
	HTIME.value = round(sum/60000, 0);
	sum_valid();
	return true;
}

function sum_valid()
{
	HSUM.value = HTIME.value * HTARIF.value;
	return true;
}
include("sys\\DpBaseDlg.js");