include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpNmkl.js");
include("Objects\\DpPrList.js");

var objDoc = extPar.doc;
var m = new Object();

function Load()
{		
	var pricetyp = objDoc.getPar("_pricetyp");
	var priceuse = objDoc.getPar("_priceuse");	
	var otpsel = objDoc.getPar("_otpsel");
		
	objDoc.isBuf = true;
		
	nk = new DpNakl(objDoc, this);	
	nk.load();
		
	FDOC_NUM.mask  = FDOV_NUM.mask = "#######";
	HNDSU.mask = HNDSO.mask    
				= HSUMU0V.mask = HSUMU0.mask
				= HSUMOCV.mask = HSUMOC.mask 
				= MASK_SUM;
	HKOL.mask      = MASK_KOL;	
	
	var objNmkl = new DpNmkl();
	nds = Number(objNmkl.getExt("_NDS"));
	
	oVal = new DpVal();
	oVal.linkCtrl(TFVAL);
	oVal1 = new DpVal();
	oVal1.linkCtrl(TFVAL1);
	
	oSc = new DpSc();	
	oSc.linkCtrl(FSC, FSU, FST);	
	oSc.setMode("cu0");	
	
	objPost = new DpCl();
   	objPost.linkCtrl(FDBKR,FDBKR_TXT);
	objPost.setClcl(getPar("CODPLAT"));	
	objPost1 = new DpCl();
   	objPost1.linkCtrl(FDBKR1,FDBKR_TXT1);
	objPost1.setClcl(getPar("CODPLAT"));	
	
	objPodr = new DpCl();
   	objPodr.linkCtrl(FPODR,FPODR_TXT);
	objPodr.setClcl(sprPodr);
	
	objMol = new DpCl();
   	objMol.linkCtrl(FMOL,FMOL_TXT);
	objMol.setClcl(sprMol);
			
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	ctrlLinker.addLink("HPNOM",FDOV_NUM);
	ctrlLinker.addLink("HPDAT",FDOV_DAT);
	ctrlLinker.addLink("HSC",FSC);
 	ctrlLinker.addLink("HSU",FSU);
 	ctrlLinker.addLink("HST",FST);
	ctrlLinker.addLink("HRFIO",FIO_POL);		
	ctrlLinker.addLink("HRPNDS",FNDS_PROC);	
	//ctrlLinker.addLink("HSUM",HSUMU0V);
	ctrlLinker.addLink("HRSNDS",HNDSU);
	ctrlLinker.addLink("HSUM",HSUMOCV);
	ctrlLinker.addLink("HPSNDS",HNDSO);	
	ctrlLinker.addLink("HKOL",HKOL);	
		
	ctrlLinker.updateData(false);
	
	if (extPar.mode == "COPY" || extPar.mode == "EDIT")
	{
		oVal.setCod(objDoc.getVar("HRVAL"));
		oVal1.setCod(objDoc.getVar("HPVAL"));
		
		objPost.setCod(objDoc.getVar("HPORG"));
		objPost1.setCod(objDoc.getVar("HRORG"));
   		
   		objPodr.setCod(objDoc.getVar("HPODR"));   		
   		objMol.setCod(objDoc.getVar("HMOL"));	
		
		oSc.set(objDoc.getVar("HSC"),
   				objDoc.getVar("HSU"),
   				objDoc.getVar("HST"));
   				
   		if(objDoc.getVar("HPNDS")!=0)
   			FNDS_PROC.value = nds;
	}
	if (extPar.mode == "ADD")
	{
		FNDS_PROC.value = nds;
	}	
	
	Disable(HSUMU0V);
	Disable(HSUMU0);
	Disable(HNDSU);
	Disable(HSUMOCV);
	Disable(HSUMOC);
	Disable(HNDSO);
	Disable(HKOL);
	
	setFocus(FDBKR);
	setValid(FNDS_PROC, recalcSum);	
	setValid(TFVAL, recalcSum);	
	setValid(TFVAL1, recalcSum);	
	recalcSum();
}

function recalcSum()
{	
	nk.nds = Number(FNDS_PROC.value);
	nk.wItog(m);
		
	HKOL.value = m.hKol;
	HSUMU0V.value = sump = m.hsumu1c;
	HSUMOCV.value = summ = m.hsumoC;
	
	dt = FDOC_DAT.value;	
	kod1 = oVal.getNazv();
	HSUMU0.value = 0;
	if (sump != null)
		HSUMU0.value = _nv2nv("", dt, kod1, sump, 0, 0, 1);	
	
	HNDSU.value = 0;
	hndsu = _nv2nv("", dt, kod1, m.hndsu, 0, 0, 1);	
	if(hndsu != null)
		HNDSU.value = round(hndsu, 2);	
		
	kod1 = oVal1.getNazv();
	HSUMOC.value = 0;
	if (summ != null)
		HSUMOC.value = _nv2nv("", dt, kod1, summ, 0, 0, 1);	
	
	HNDSO.value = 0;	
	hndso = _nv2nv("", dt, kod1, m.hndso, 0, 0, 1);	
	if(hndso != null)
		HNDSO.value = round(hndso, 2);
}

function updateData()
{	
	ctrlLinker.updateData(true);
	objDoc.setVar("HRVAL",oVal.getCod());
	objDoc.setVar("HPVAL",oVal1.getCod());
	objDoc.setVar("HPORG",objPost.getCod());
	objDoc.setVar("HRORG",objPost1.getCod());
	objDoc.setVar("HPODR",objPodr.getCod());
	objDoc.setVar("HMOL", objMol.getCod());
	objDoc.setVar("HP",   objDoc.getPar("_pricetyp"));	
	objDoc.setVar("HPN",  objDoc.getPar("_priceuse"));		
}		

function onSave()
{		
	updateData();
	
	objDoc.setVar("HSMTOV",	m.Fsum_tov);
	objDoc.setVar("HSBTOV",	m.Fseb_tov);
	objDoc.setVar("HSMMAT",	m.Fsum_mat);
	objDoc.setVar("HSBMAT",	m.Fseb_mat);	
	objDoc.setVar("HOSTAR",	m.Fsum_tar);
	objDoc.setVar("HUSTAR",	m.Fseb_tar);	
	objDoc.setVar("HTOTL",	m.hIsRasc);	
	objDoc.setVar("HPSUM",	m.hsumuc);	
	objDoc.setVar("HNR",	m.hNr);
	
	nk.saveRows();		
}
			
include("sys\\DpBaseDlg.js");