include("Objects/DpCl.js");
include("Objects/DpShifPZ.js");
include("sys/mask.js");

var sprPodr;
var obj = extPar.obj;
var oParent = obj.parent;

var oClMol, oCntr;
var oClPodr, oSelo, oGaluz, oShpz, oPodr, oPlaceTr;
var ctrlLinker;
var mode = extPar.mode;

//Снимаем параметры папки
var isPay = extPar.isPay;
var isDog = extPar.isDog;
var isNaturOp = extPar.isNaturOp;
var isPlaseTransf = extPar.isPlaseTransf;
var isVisblDay = extPar.isVisblDay;
var isVisblHour = extPar.isVisblHour;
var mFcl = extPar.mFcl;
var sprPodr = extPar.sprPodr;
var sprGaluz = extPar.sprGaluz;
var sprPlaseTransf = extPar.sprPlaseTransf;

var modePodr = extPar.modePodr;
var modeSelo = extPar.modeSelo;
var modeShpz = extPar.modeShpz;
var modeGaluz = extPar.modeGaluz;

//параметры касающиеся только строк
var isUnderCl = oParent.getPar("_isUnderCl");

function Load()
{
	Caption(ru("Ведомость","Відомість"), mode);
	if(isPay)
	{
		include("pay:PAY_const.js");
	}

	RSUM.setMask(MASK_SUM);
	RNOM.setMask("#####");

	if (isUnderCl)
	{
		oClPodr = new DpCl();
		oClPodr.setClcl(sprPodr);
		oClPodr.setCod(oParent.getCtrlLinker().arrCL.HPODR.getCod());
		oClMol = new DpCl("U0-", mFcl, 0, oClPodr);
		oClMol.linkSmartCtrl(RCOD);
		oClMol.setContAssist();
	}
	else
	{
		oClMol = new DpCl();
		oClMol.setClcl(mFcl);
		oClMol.linkSmartCtrl(RCOD);
		oClMol.setContAssist();
	}
	
	ctrlLinker = new DpCtrlLinker(obj);
	ctrlLinker.addLink("RNOM",RNOM);
	ctrlLinker.addLink("RSUM",RSUM);
	ctrlLinker.addClLink("RCOD", oClMol);
	
	//В зависимости от параметров папки нарисуем нужные контролы
	
	//Дни и часы
	if(isVisblDay)
	{
		RDAY.setMask("###.#");
		ctrlLinker.addLink("RDAY", RDAY);
	}
	else
	{
		GR_TIME_TXT.setVisible(false);
		GR_TIME.setVisible(false);
		GR_DAY.setVisible(false);		
	}
	if(isVisblHour)
	{
		GR_TIME_TXT.setVisible(true);
		GR_TIME.setVisible(true);
		RHOUR.setMask("###.#");
		ctrlLinker.addLink("RHOUR", RHOUR);
	}
	else
	{
		GR_HOUR.setVisible(false);		
	}

	if(isDog)
	{
		oCntr = new DpCntrct("+", sys_DpCntrct_getOrg);
		oCntr.linkCtrl(RDOG);
		if (mode != "ADD")
		{		
			oCntr.setOrg(obj.getVar("RCOD"));
			oCntr.setID(obj.getVar("RID_DOG"));
		}
	}
	else
	{
		GR_DOG_TXT.setVisible(false);
		GR_DOG.setVisible(false);
	}
	
	//Количество нужно только для натуроплаты
	if(isNaturOp)
	{
		RKOL.setMask(MASK_KOL);
		ctrlLinker.addLink("RKOL", RKOL);
		Disable(RSUM);
	}
	else
	{
		GR_KOL_TXT.setVisible(false);
		GR_KOL.setVisible(false);			
	}
	
	//село
	if(inList(modeSelo, 1, 2, 3))
	{
		if(!isPay)
		{
			alert("Для работы контрола \"Село\" нужно включить в параметрах расчет по паям!");
		}
		else
		{
			oSelo = new DpCl();
			oSelo.setMode("");
			oSelo.setClcl(sprSelo);
			oSelo.linkSmartCtrl(RSELO);
			ctrlLinker.addClLink("RSELO", oSelo);
			if(modeSelo == 2)
			{
				Disable(RSELO);
			}
		}
	}
	else
	{
		GR_SELO_TXT.setVisible(false);
		GR_SELO.setVisible(false);
	}
	
	//подр.
	if(inList(modePodr, 1, 2, 3))
	{
		oPodr = new DpCl();
		oPodr.setMode("");
		oPodr.setClcl(sprPodr);
		oPodr.linkSmartCtrl(RPODR);
		oPodr.setContAssist();
		ctrlLinker.addClLink("RPODR", oPodr);
		if(modePodr == 2)
		{
			Disable(RPODR);
		}
	}
	else
	{
		GR_PODR_TXT.setVisible(false);
		GR_PODR.setVisible(false);
	}

	//ШПЗ
	if(inList(modeShpz, 1, 2, 3))
	{
		oShpz = new DpShifPZ();
		oShpz.setUseZiro(false);
		oShpz.linkCtrl(RSHPZ, RTSHPZ);
		ctrlLinker.addLink("RSHPZ", RSHPZ);
		
		oShpz.setFshpz(obj.getVar("RSHPZ"));
		if(modeShpz == 2)
		{
			Disable(RSHPZ);
			Disable(RTSHPZ);
		}
		setWhen(RSHPZ,shpzWhen);
	}
	else
	{
		GR_SHPZ_TXT.setVisible(false);
		GR_SHPZ.setVisible(false);
	}
	
	//Отрасль затрат
	if(inList(modeGaluz, 1, 2, 3))
	{
		oGaluz = new DpCl();
		oGaluz.setMode("");
		oGaluz.setClcl(sprGaluz);
		oGaluz.linkSmartCtrl(RGALUZ);
		ctrlLinker.addClLink("RGALUZ", oGaluz);
		if(modeGaluz == 2)
		{
			Disable(RGALUZ);
		}
	}
	else
	{
		GR_GALUZ_TXT.setVisible(false);
		GR_GALUZ.setVisible(false);
	}
	
	//место перечисления
	if(isPlaseTransf)
	{
		oPlaceTr = new DpCl("U0-", sprPlaseTransf, 0, oClMol);
		//oPlaceTr = new DpCl();
		//oPlaceTr.setMode("");
		//oPlaceTr.setClcl(sprPlaseTransf);
		oPlaceTr.linkSmartCtrl(RPLTR);
		ctrlLinker.addClLink("RPLTR", oPlaceTr);
		oPlaceTr.listCond = listCondPlaceTr;
	}
	else
	{
		GR_PLTR_TXT.setVisible(false);
		GR_PLTR.setVisible(false);
	}
	//-----------------
	ctrlLinker.updateData(false);
	
	//для режимов 2 и 3 подтянем значение контролов 
	//oPodr,oSelo,oGaluz,oShpz с заголовка
	if(inList(mode, "ADD", "COPY"))
	{
		if(inList(modePodr, 2, 3))
		{
			oPodr.setCod(extPar.codPodr)
		}
		if(inList(modeSelo, 2, 3) && isPay)
		{
			oSelo.setCod(extPar.codSelo)
		}
		if(inList(modeGaluz, 2, 3))
		{
			oGaluz.setCod(extPar.codGaluz)
		}
		if(inList(modeShpz, 2, 3))
		{
			oShpz.setFshpz(extPar.codShpz)
		}
	}
	
	if(inList(modeShpz, 2, 3))
	{
		RSHPZ.setValue(oShpz.getFshpz());
	}
	
	//Перерисуем окно
	var pnt = FORM.getControlComposite();
	pnt.pack();
	pnt.redraw();
	pnt.layout(true);
	
	setValid(RNOM, RNOM_Valid);
	setValid(RSUM, RSUM_Valid);	
	if(isNaturOp)
	{
		setValid(RKOL, RKOL_Valid);
	}

	setValid(RCOD, RCOD_Valid);

}

function sys_DpCntrct_getOrg()
{
	return oClMol.getCod();
}

function RSUM_Valid()
{
	if (Number(RSUM.getValue()) == 0)
	{
		RSUM.showErr(ru("Нулевая сумма недопустима!","Нульова сума неприпустима!"));
		return false;
	}

	return true;
}

function RNOM_Valid()
{
	var val = parseInt(RNOM.getValue());
	if (!val || val > 32766)
	{
		RNOM.showErr(ru("Слишком большое значение","Надто велике значення"));
		return false;
	}
	return true;
}

function RKOL_Valid()
{
	var kol = Number(RKOL.getValue());
	var ret = true;
	if(isEmpty(kol))
	{
		RKOL.showErr(ru("Нулевое кол-во недопустимо!","Нульова кіл-сть неприпустима!"));
		ret = false;
	}
	else
	{
		sum = round(kol * extPar.cena , 2);
		RSUM.setValue(sum);
	}
	return ret;
} 

function RCOD_Valid()
{	
	//Tori 11.04.2011: принудительно проставляем минимальный код места перечисления и только если он не указан
	if(isPlaseTransf && Number(oPlaceTr.getCod())==0)
	{		
		var D1 = firstDay(new Date(oParent.getCtrlLinker().arrCtrl.HDAT.value));
		var D2 = lastDay(D1);

		strSQL = " SELECT REL.FCOD"
				+" FROM ^CLRELCLCL REL "
					+" INNER JOIN ^CL_TRPLACE PLACE ON REL.FWID_CL = PLACE.FWID_CL"
					+" INNER JOIN ^CAS_TR_PR CAS ON REL.FWID_CL = CAS.FWIDTR"
					+" INNER JOIN ^PRK_ALL P ON CAS.FWID = P.FWID"
				+" WHERE 1 = 1 "
					+" AND PLACE.FTABN = "+sqlTo(oClMol.getCod())
					+" AND PLACE.FTRTYPE = "+sqlTo(extPar.codTypeTr)
					+" AND P.FBDAT<=" + sqlTo(D2)+ " AND P.FEDAT>=" + sqlTo(D1)
		var sn = getSnap(strSQL);
		
		var trplace = 0;
		if(sn != null && !isEmpty(sn[0]))
		{
			trplace = sn[0];
		}
		else
		{
			strSQL = "SELECT"
						+" MIN(REL.FCOD) AS FCOD"
						+", T.FTABN AS FTABN" 
					+" FROM ^CLRELCLCL REL LEFT JOIN ^CL_TRPLACE T ON REL.FWID_CL = T.FWID_CL"
					+" WHERE REL.FCL = "+sqlTo(sprPlaseTransf)
						+" AND T.FTABN = "+sqlTo(oClMol.getCod())
						+" AND T.FTRTYPE = "+sqlTo(extPar.codTypeTr)
					+" GROUP BY REL.FCL, T.FTABN, T.FTRTYPE";
			var sn = getSnap(strSQL);
			if (sn != null && sn[0] != null)
			{
				trplace = sn[0];
			}
		}
				
		//Олег
		//если изменился родительський код то нужно изменить 
		//singleCod  обекта ребенка внутри самого DpCl 
		//так как он этого не делает а надо бы чтобы делал
		var singleCod = oPlaceTr.getSingleCod();
		oPlaceTr.setCod(singleCod);
			
		//если есть места перечислений то берем первую строку 
		if(sn != null && !isEmpty(sn[0]))
		{			
			oPlaceTr.setCod(Number(trplace));
		}
		else
		{
			//если нету строк то код 0
			oPlaceTr.setCod(0);
			RPLTR.showErr(ru("Для этого табельного номера нету мест перечислений."
									, "Для цього табельного номеру не існує місць перерахувань."));
		}
		
		sn = null;
	}
	//Проверим есть ли уже такой табельный в строках
	if (!isSaving())
	{
		strSQL = "SELECT"
						+" FCOD"
					+" FROM "
						+ extPar.sTmpTbl
					+" WHERE 1=1"
						+" AND FCOD = "+sqlTo(oClMol.getCod())
						+" AND FWID <> " + sqlTo(extPar.doc.getID())
		var sn = getSnap(strSQL);

		if(sn != null && !isEmpty(sn[0]))
		{
			if(!confirm(ru("Запись с таким кодом уже существует. Продолжить?","Запис з таким кодом вже існує. Продовжити?")))
			{
				return false;
			}
			else
			{
				setFocus(GR_DAY);
			}
		}
	}
	return true;
}


function listCondPlaceTr()
{
	//при завале  будут отображатся только свои коды 
	//тоисть "T.FTABN = "+sqlTo(oClMol.getcod())
	var strSQL = "FCOD IN(SELECT REL.FCOD"
								+" FROM ^CLRELCLCL REL LEFT JOIN ^CL_TRPLACE T ON REL.FWID_CL = T.FWID_CL"
								+" WHERE 1=1"
									+" AND REL.FCL = "+sqlTo(sprPlaseTransf)
									+" AND T.FTABN = "+sqlTo(oClMol.getCod())
									+" AND T.FTRTYPE = "+sqlTo(extPar.codTypeTr)
								+")"
	return strSQL;
}

function onSave()
{
	if (extPar.obj.parent.getPar("_UseMassZaval") == 0)
	{
		var dat = toScrObj(extPar.obj.parent.getCtrlLinker().arrCtrl["HDAT"].getValue());
		
		include("Objects/DpShtat.js");
		var oShtat = new DpShtat("" , dat, dat);

		oShtat.setEmployeCod(oClMol.getCod());
		oShtat.arrCtrls = new Array();
		oShtat.arrCtrls["fcod"] = new Object(this.value = 0)
		oShtat.arrCtrls["fcod"].value = oClMol.getCod();

		if(oShtat.validCod())
		{
			mFwid_wp = oShtat.getFwid();
		}
		else
		{
			msg = ru("Для таб.№"+oClMol.getCod()+" нет записи в штатном расписании."
						, "Для таб.№"+oClMol.getCod()+" нема запису в штатному розкладі.");
			oShtat = null;
			return false;
		}
		oShtat = null;
		
		extPar.obj.setVar("RWID_WP", mFwid_wp);
	}
	
	ctrlLinker.toVars();
	if (isDog)
		obj.setVar("RID_DOG",oCntr.getID());
}

function shpzWhen()
{
	// Tori 14.06.2010: по умолчанию предлагаем ШПЗ из штатного расписания
	// eugene 03.01.2012 В параметрах папки можем и не указывать даты начала и окончания,
	// их функция другая. А вот для определения начала и конца используем дату документа
	var D1 = new Date()
	var D2 = new Date();
	if (typeof(oParent.getCtrlLinker().arrCtrl.HBDAT) == "undefined" 
		|| !isEmpty(oParent.getCtrlLinker().arrCtrl.HBDAT.value))
	{
		D1 = firstDay(new Date(oParent.getCtrlLinker().arrCtrl.HDAT.value));
		D2 = lastDay(D1);
	}
	else
	{
		D1 = new Date(oParent.getCtrlLinker().arrCtrl.HBDAT.value);
		D2 = new Date(oParent.getCtrlLinker().arrCtrl.HEDAT.value);
	}
	
	if(oClMol.getCod() && Number(oShpz.getFshpz()) == 0)
	{
		var snap = getSnap("select Fshpz from ^full_pers where Fwid_cl = "+oClMol.getFWID()
					+" and Fbdat <= "+sqlTo(D2)
					+" and Fedat >= "+sqlTo(D1)
					+" order by fbdat desc")
		if(snap)
		{
			oShpz.setFshpz(snap[0])
		}
	}
	return true;
}

include("sys\\DpBaseDlg.js");