include("doc/DpDocList.js");
include("Objects/DpVal.js");
include("Objects/DpSc.js");
include("Objects/DpCl.js");
include("Objects/DpLicf.js");
include("Objects/DpShifPZ.js");
include("Objects/DpNmkl.js");
include("Objects/DpMassSum.js");
include("vd_api.js");

include("sys/mask.js");
include("sys/udfs.js");
include("servis/date.js");

var sRowClass = "ROW";
var mainTblR = "RVD";
var sTmpTbl = mainTblR+"_TMP";
var tbl4Grid;
var oSc, oPodr, oVal, oSelo, oPay, oLicf, oShpz, oGaluz, oNmkl, oPlTr;
var objDocVD = extPar.doc;
var oMassSum;
var mode = extPar.mode;
var mFcl;

//читаем параметры папки
var sprPodr = Number(objDocVD.getPar("_sprPodr"));
var sprMol = Number(objDocVD.getPar("_sprMol"));
var sprGaluz = Number(objDocVD.getPar("_sprGaluz"));
var sprTypeTransf = Number(objDocVD.getPar("_sprTypeTransf"));
var sprPlaseTransf = Number(objDocVD.getPar("_sprPlaseTransf"));

var isVisblDat = objDocVD.getPar("_isDat");
var isVisblRem = objDocVD.getPar("_isRem");
var isVisblSc = objDocVD.getPar("_isSc");
var isVisblDay = objDocVD.getPar("_isDay");
var isVisblHour = objDocVD.getPar("_isHour");
var isZP = objDocVD.getPar("_isZP");
var isPay = objDocVD.getPar("_isPay");
var isDog = objDocVD.getPar("_isDog");
var isNaturOp = objDocVD.getPar("_isNaturOp");
var isPlaseTransf = objDocVD.getPar("_isPlaseTransf");
var UseMassZaval = objDocVD.getPar("_UseMassZaval");

var modePodr = Number(objDocVD.getPar("_modePodr"));
var modeSelo = Number(objDocVD.getPar("_modeSelo"));
var modeShpz = Number(objDocVD.getPar("_modeShpz"));
var modeGaluz = Number(objDocVD.getPar("_modeGaluz"));
var isUseShpz = (inList(modeShpz, 1, 2, 3) ? true : false);

function Load()
{
	mFcl = sprMol;
	if(isPay)
	{
		isPay = false;
		//проверка на существование модуля 
		var aModules = getModules();
		for(var i in aModules)
		{
			if(String(aModules[i]).toLowerCase() == "pay")
			{
				isPay = true;
				break;
			}
		}
		aModules = null;
		
		//если модуль установлен инклудим файлы 
		if(isPay)
		{
			include("pay:Objects/DpPay.js");
			include("pay:PAY_const.js");
			mFcl = sprPay;
		}
		else
		{
			modeSelo = 0;
			alert(ru("Вы не можете использовать расчеты по паям\nтак как у вас не установлен этот модуль."
					, "Ви не можете використовувати розрахунки по паях\nтому, що у вас не встановлений відповідний модуль."));
		}
	}
	
	var par = {};
	//навешиваем необходимые параметры
	par.sprPers = mFcl;
	par.isUseShtat = (UseMassZaval == 0 ? true : false);
	par.sprPodr = (inList(modePodr, 1) ? sprPodr : 0);
	par.sprSelo = (inList(modeSelo, 1) ? sprSelo : 0);
	par.sprGaluz = (inList(modeGaluz, 1) ? sprGaluz : 0);
	par.isUseShpz = isUseShpz;
	par.isUseDay = isVisblDay;
	par.isUseHour = isVisblHour;
	
	oMassSum = new DpMassSum("", par);
	
	HSUM.setMask(MASK_SUM);
	HKOL.setMask(MASK_KOL);
	HCENA.setMask("##########.#####");

	this.initGrid = _initGrid;
	this.initGrid();
	this.listMenuInit = listMenuInit;
	this.onSelectRowMenu = onSelectRowMenu;

	Caption(objDocVD.getCaption() + ": " + modeName(mode));

	oVal = new DpVal();
	oVal.linkCtrl(HVAL);
	oVal.linkCtrlKurs(HVKURS);

	ctrlLinker = new DpCtrlLinker(objDocVD);
	ctrlLinker.addLink("HNOM",HNOM);
	ctrlLinker.addLink("HDAT",HDAT);
	ctrlLinker.addLink("HVKURS",HVKURS);
	ctrlLinker.addClLink("HVAL",oVal);
	ctrlLinker.addLink("HKOL", HKOL);
	ctrlLinker.addLink("HSUM", HSUM);
	
	//для апдейта даты в строках
	setValid(HDAT, dat_valid);
	
	if(isPay)
	{
		oPay = new DpPay();
	}	
	
	//В зависимости от параметров папки нарисуем нужные контролы
	//село
	if(inList(modeSelo, 2, 3))
	{
		if(!isPay)
		{
			msg = ru("Для отображения поля \"Село\" нужно включить в параметрах расчет по паям!"
						, "Для відображення поля \"Село\" потрібно включити в параметрах розрахунок по паях!");
			alert(msg);
		}
		else
		{
			oSelo = new DpCl();
			var modeCl = (modeSelo == 3 ? "0" : "");
			oSelo.setMode(modeCl);
			oSelo.setClcl(sprSelo);
			oSelo.linkSmartCtrl(HSELO);
			ctrlLinker.addClLink("HSELO", oSelo);
			
			setValid(HSELO, SELO_valid);
		}
	}
	
	else
	{
		GR_SELO_TXT.setVisible(false);
		GR_TSELO.setVisible(false);
	}
	
	//подр.
	if(inList(modePodr, 2, 3))
	{
		var modeCl = (modePodr == 3 ? "0" : "");
		oClPodr = new DpCl();
		oClPodr.setMode(modeCl);
		oClPodr.setClcl(sprPodr);
		oClPodr.linkSmartCtrl(HPODR);
		oClPodr.setContAssist();
		ctrlLinker.addClLink("HPODR", oClPodr);
		
		setValid(HPODR, PODR_valid);
	}
	else
	{
		GR_PODR_TXT.setVisible(false);
		GR_PODR.setVisible(false);
	}

	//ШПЗ
	if(inList(modeShpz, 2, 3))
	{
		oShpz = new DpShifPZ();
		var isUseZiro = (modeShpz == 3 ? true : false);
		oShpz.setUseZiro(isUseZiro);
		oShpz.linkCtrl(HSHPZ, HTSHPZ);
		ctrlLinker.addLink("HSHPZ", HSHPZ);
		
		oShpz.setFshpz(objDocVD.getVar("HSHPZ"));
		
		setValid(HSHPZ, SHPZ_valid);
	}
	else
	{
		GR_SHPZ_TXT.setVisible(false);
		GR_SHPZ.setVisible(false);
	}
	
	//Отрасль затрат
	if(inList(modeGaluz, 2, 3))
	{
		oGaluz = new DpCl();
		var modeCl = (modeGaluz == 3 ? "0" : "");
		oGaluz.setMode(modeCl);
		oGaluz.setClcl(sprGaluz);
		oGaluz.linkSmartCtrl(HGALUZ);
		ctrlLinker.addClLink("HGALUZ", oGaluz);
		
		setValid(HGALUZ, GALUZ_valid);
	}
	else
	{
		GR_GALUZ_TXT.setVisible(false);
		GR_GALUZ.setVisible(false);
	}
		
	//Даты
	if(isVisblDat)
	{
		ctrlLinker.addLink("HBDAT",HBDAT);
		ctrlLinker.addLink("HEDAT",HEDAT);
	}
	else
	{
		GR_DAT.setVisible(false);
	}
			
	//Комментарий
	if(isVisblRem)
	{
		HTXT.mask = replicate("&", 255);
		ctrlLinker.addLink("HTXT",HTXT);
	}
	else
	{
		GR_REM_TXT.setVisible(false);
		GR_TXT.setVisible(false);
	}
	
	//счет
	if(isVisblSc)
	{
		oSc = new DpSc("cutxyz");
		oSc.linkCtrl(HSC, HSU, HST, HAN1, HAN2, HAN3);
		ctrlLinker.addScLink("HSC", "HSU","HST","HA1","HA2","HA3", oSc);
	}
	else
	{
		GR_SC_TXT.setVisible(false);
		GROUP_SC.setVisible(false);
	}
		
	//лиц. счет
	if(isZP)
	{
		oLicf = new DpLicf();
		oLicf.linkCtrl(HLICF, HTLICF);
		ctrlLinker.addLink("HLSFID", HLICF);
		if (mode == "ADD")
		{
			oLicf.setFid(0);
		}
		else
		{
			oLicf.setFid(objDocVD.getVar("HLSFID"));
		}
		setValid(HLICF, licf_valid)
	}
	else
	{
		GR_LICSC_TXT.setVisible(false);
		GROUP_LICSC.setVisible(false);
	}
	
	//место перечисления
	if(isPlaseTransf && !isEmpty(sprTypeTransf) && !isEmpty(sprPlaseTransf))
	{
		oPlTr = new DpCl();
		oPlTr.setMode("");
		oPlTr.setClcl(sprTypeTransf);
		oPlTr.linkSmartCtrl(HTYPE_TR);
		ctrlLinker.addClLink("HTYPE_TR", oPlTr);
		
		setValid(HTYPE_TR, HTYPE_TR_valid);
	}
	else
	{
		isPlaseTransf = false;
		GR_TYPE_TR_TXT.setVisible(false);
		GR_TYPE_TR.setVisible(false);
	}
		
	if(isNaturOp)
	{
		oNmkl = new DpNmkl();	
		oNmkl.CanEmpty = true;
		oNmkl.mode = "";
		oNmkl.linkSmartCtrl(HNMKL);
		ctrlLinker.addClLink("HNMKL", oNmkl);
		ctrlLinker.addLink("HCENA", HCENA);
		
		setValid(HNMKL, nmkl_valid);
		setValid(HCENA, cena_valid);
	}
	else
	{
		GR_NATUROPL_TXT.setVisible(false);
		GR_NATUROPL.setVisible(false);
	}

	ctrlLinker.updateData(false);
	
	if(inList(modeShpz, 2, 3))
	{
		HSHPZ.setValue(oShpz.getFshpz());
	}
	
	//нужно перебивать номер поля  потому как он поднимает с базы код 
	//и навешивает его на контрол
	if(inList(mode, "EDIT", "COPY"))
	{
		if(isZP)
		{
			HLICF.setValue(oLicf.getFnum());
		}
	}
		
	if(mode == "ADD" && isVisblDat) 
	{
		//Дата окончания выплаты должна быть на 3 дня больше от даты нач. выплаты 
		edat = goDay(new Date(HBDAT.getValue()), 3);
		HEDAT.setValue(new Date(edat).getVarDate());
	}
		
	/*Tori 19.05.2011: для корректного растягивания грида по вертикали лучше обновить форму и востановить ее прежний размер
	//Перерисуем окно
	var pnt = FORM.getControlComposite();
	pnt.pack();
	pnt.redraw();
	pnt.layout(true);*/
	var shell = FORM.getShell();
	var size = shell.getSize();
	FORM.Refresh();
	shell.setSize(size)
	
	Enable(HKOL, false);
	Enable(HSUM, false);
	
	
}

function listMenuInit()
{
	var par = new Object();
	oMassSum.setMode("FBSP");
	oMassSum.menuInit();
	oMassSum.setUseZp(isZP);
	if(isPay)
	{
		par.isPay = isPay;
		oPay.menuInit(par);
	}
	
	if (!grid.getTable().isEmpty())
	{
		if(isPlaseTransf)
		{
			grid.AddMenuItem("SET_PLTR","Проставити місця перерахувань|Проставить места перечислений");
			grid.AddMenuItem("SET_PLTR_NUM","Проставити місця перерахувань по номеру ощадкаси|Проставить места перечислений по номеру сберкассы");
		}
		
		if (isUseShpz && isZP)
		{
			grid.AddMenuItem("SET_SHPZ","Проставити ШВВ|Проставить ШПЗ");
		}
		
		grid.AddMenuItem("+++", "Сортування|Сортировка");
			grid.AddMenuItem("SORT_TABN", "За таб.№|По таб.№");
			grid.AddMenuItem("SORT_FIO", "За ПІБ|По ФИО");
		grid.AddMenuItem("---", "");
		grid.AddMenuItem("", "");
	}
	
	grid.AddMenuItem("ADD","Додавання|Добавление");
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT","Редагування|Редактирование");
		grid.AddMenuItem("COPY","Копіювання|Копирование");
		grid.AddMenuItem("DEL","Видалення|Удаление");
	}
	if (getPar("is_debug"))
	{
		grid.AddMenuItem("DEBUG_BROWSE","BROWSE");
	}
	
}

function _initGrid()
{
	this.sDocSourceDir = rootDirectory() + "docs/" + objDocVD.sDocLbl + "/";

	var nId = (mode == "COPY") ? objDocVD.nOldID : objDocVD.getID();

	DropTable(sTmpTbl);
	var sSQL = "SELECT *"
				+ " INTO " + sTmpTbl
				+ " FROM ^"+mainTblR
				+ " WHERE FID_DOC = " + nId;
	ExecuteSQL(sSQL);

	tbl4Grid = OpenTable("m","SELECT * FROM "+sTmpTbl+" ORDER BY FNOM_STR");

	clTie(tbl4Grid, "x_cl_mol", "="+mFcl+", FCOD");

	if(mode=="COPY")
		objDocVD.resetFnids(tbl4Grid, sRowClass, objDocVD);

	grid.setTable(tbl4Grid);
	loadDpGridDefs(grid, tbl4Grid);

	grid.loadMenuHandler(this,"listMenuInit");
	grid.selectMenuHandler(this,"onSelectRowMenu");
}

function loadDpGridDefs(grid, gridTbl)
{
	include("Objects/DpGrid.js")
	grid = new DpGrid("NOCREATE");
	
	//таим с проверкой на контрол
	if(inList(modePodr, 1, 2, 3))
	{
		gridTbl.clTie("PODR", "="+sqlTo(sprPodr)+", FPODR");
	}
	
	if(inList(modeSelo, 1, 2, 3) && isPay)
	{
		gridTbl.clTie("SELO", "="+sqlTo(sprSelo)+", FSELO");
	}
	
	if(inList(modeGaluz, 1, 2, 3))
	{
		gridTbl.clTie("GALUZ", "="+sqlTo(sprGaluz)+", FGALUZ");
	}
	
	if(inList(modeShpz, 1, 2, 3))
	{
		gridTbl.tie("SHIFRPZ", "SHPZ", "SHIFRPZ", "FSHPZ");
	}
	
	if (isPlaseTransf)
	{
		gridTbl.clTie("TRANSF", "="+sqlTo(sprPlaseTransf)+", FPLTR");
		gridTbl.tie("CL_TRPLACE", "TRPLACE", "FWID_CL", "TRANSF.FWID");
		
		//Сбер.касса
		gridTbl.tie("CL_SBCS", "CAS", "FNUM", "trplace.FNUMSB");
		//Тип перечислений
		//this.tie("TR", "="+getPar("CAS_TRTYPE")+", trplace.FTRTYPE");	
	}

	if (isDog)
	{
		gridTbl.tie("CONTRACT", "CNT", "FWID", "FID_DOG");
	}
		
	gridTbl.clTie("FIO", "="+sqlTo(mFcl)+", FCOD");
	with(grid)
	{
		with(page())
		{
			cell("FNOM_STR", "№ п.п.|№ п.п.", 6);
			cell("FCOD", "Код|Код", 6);
			cell("FIO.FTXT", "ПІБ|ФИО", 20);
			if(isVisblDay)
			{
				cell("FDAY", "Дні|Дни", 6);
			}
			if(isVisblHour)
			{
				cell("FHOUR", "Години|Часы", 6);
			}
			
			cell("FSUM", "Сума|Сумма", 10,null,DP_FORMAT_SUM);
			
			if(isNaturOp)
			{
				cell("FKOL", "Кількість|Количество", 10);
			}
			
			
			if(inList(modePodr, 1, 2, 3))
			{
				with(group("Підрозділ|Подразделение"))
				{
					cell("FPODR", "Код|Код", 6);
					cell("PODR.FTXT", "Назва|Наименование", 15);
				}
			}
			
			if(inList(modeSelo, 1, 2, 3))
			{
				with(group("Село|Село"))
				{
					cell("FSELO", "Код|Код", 6);
					cell("SELO.FTXT", "Назва|Наименование", 15);
				}
			}

			if(isDog)
			{
				with(group("Договір|Договор"))
				{
					cell("CNT.FDOC_NUM", "№|№", 5);
					cell("CNT.FDOC_DAT", "Дата|Дата", 8);
				}
			}
			
			if(inList(modeGaluz, 1, 2, 3))
			{
				with(group("Галузь витрат|Отрасль затрат"))
				{
					cell("FGALUZ", "Код|Код", 9);
					cell("GALUZ.FTXT", "Назва|Наименование", 15);
				}
			}
			
			if(inList(modeShpz, 1, 2, 3))
			{
				with(group("ШВВ|ШПЗ"))
				{
					cell("FSHPZ", "Код|Код", 6);
					cell("SHPZ.FSHPZ_TXT", "Назва|Наименование", 15);
				}
			}
			
			if(isPlaseTransf)
			{
				with(group("Від.банку/Сбер.каса|Отд. банка/Сбер.касса"))
				{
					cell("FPLTR", "Код м.перерах.|Код м.перечисл.", 10);
					cell("TRPLACE.FNUMSB", "Код банку|Код банка", 5);
					cell("CAS.FOTD_BNK", "Вiддiл.банку|Отдел.банка", 10);
					cell("TRPLACE.FLICSCH", "Ос.рах|Лиц.счет", 10);
				}
			}
		}
		build();
	}
}

function onSelectRowMenu(sID)
{
	var par = new Object();
	par.mFcl = mFcl;
	par.isPay= isPay;
	par.isDog= isDog;
	par.isNaturOp = isNaturOp;
	par.isVisblDay = isVisblDay;
	par.isVisblHour = isVisblHour;
	par.isPlaseTransf = isPlaseTransf;
	par.sprPodr = sprPodr;
	par.sprGaluz = sprGaluz;
	par.sprPlaseTransf = sprPlaseTransf;
	par.sTmpTbl = sTmpTbl;
	if(isPlaseTransf)
	{
		par.codTypeTr = oPlTr.getCod();
	}
	
	par.modePodr = modePodr;
	par.modeSelo = modeSelo;
	par.modeShpz = modeShpz;
	par.modeGaluz = modeGaluz;
	
	if(isNaturOp)
	{
		par.cena = Number(HCENA.getValue());
	}
	
	//если есть объекты oPodr,oSelo,oGaluz,oShpz
	//то навешиваем их коды, они нужны строкам 
	if(typeof(oClPodr) == "object")
	{
		par.codPodr = oClPodr.getCod();
	}
	
	if(typeof(oGaluz) == "object")
	{
		par.codGaluz = oGaluz.getCod();
	}
	
	if(typeof(oShpz) == "object")
	{
		par.codShpz = oShpz.getFshpz();
	}
	
	if(isPay && typeof(oSelo) == "object")
	{
		par.codSelo = oSelo.getCod();
		oPay.setUseSelo(true);
	}
	else if(isPay)
	{
		oPay.setUseSelo(false);
	}
	
	oMassSum.menuRun(sID);
		
	if(isPay)
	{	
		oPay.menuRun(sID);
	}
		
	var oDocRow;
	switch (sID)
	{
		case "DEL":
			var msg = ru("Подтвердите удаление записи.", "Підтвердіть вилучення запису.");
			var ret = msgBox("^c-", msg, ru("Подтверждение удаления","Підтвердження вилучення"));
			switch(ret)
			{
				case 'c':
					break;
				case '-':
					objDocVD.deleteRow(sRowClass, Number(grid.getTable().getRowID()));
					grid.getTable().Delete();
				break;
			}
		break;
		case "__XDEL":
			var delRowCount = DataSource().getSelectedCount();
			
			if (delRowCount <= 0)
			{
				return;
			}
			var selIds = DataSource().getSelectedIDs();
			
			var sCapt = ru("Удаление записей", "Видалення записів");
			var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів")+" (" + DataSource().getSelectedCount() + ").";
			if("c"==msgBox("c-", sMsg, sCapt))
			{
				return;
			}

			setProgressRange(0, delRowCount);
			for (var nRow = 0; nRow < selIds.length; nRow++)
			{
				setProgressPos(nRow + 1, sCapt +": "+ (nRow + 1) +"/"+ delRowCount);
				objDocVD.deleteRow("ROW", Number(selIds[nRow]));
			}
			
			var sSQL = "DELETE FROM " + grid.getTable().getTableName()
						+ " WHERE " + grid.sqlSelected()
			ExecuteSQL(sSQL);
			
			grid.clearSelected();
			setProgressPos(0);
		break;
		case "ADD":
			oDocRow = objDocVD.createRow(sRowClass);
			var oSnap = getSnap("SELECT MAX(FNOM_STR) AS NOM FROM " + sTmpTbl);
			var nNom = 1;
			if (oSnap && oSnap[0])
			{
				nNom = Number(oSnap[0]) + 1;
			}
			oDocRow.setVar("RNOM",nNom)
		break;
		case "EDIT":
			oDocRow = objDocVD.getRow(sRowClass,Number(grid.getTable().getRowID()));
		break;
		case "COPY":
			oDocRow = objDocVD.copyRow(sRowClass, Number(grid.getTable().getRowID()));
		break;
		
		case "LOAD_MASS_SUM":
			//открываем таблицу масового ввода
			var opTbl = OpenTable(oMassSum.getTable());
			var oSnap = getSnap("SELECT MAX(FNOM_STR) AS NOM FROM " + sTmpTbl);
			var nNom = 1;
			var numStr = 1;
			if (oSnap && oSnap[0])
			{
				nNom = Number(oSnap[0]) + 1;
			}
			
			var txt = ru("Идет загрузка данных ", "Йде завантаження даних ");
			setProgressRange(0, opTbl.recordCount);
			for (; !opTbl.IsEOF(); opTbl.MoveNext())
			{
				oDocRow = objDocVD.createRow(sRowClass);
				oDocRow.setVar("RNOM", nNom++);
				oDocRow.setVar("RCOD", opTbl.getValue("FCOD"));
				oDocRow.setVar("RSUM", opTbl.getValue("FSUM"));
				oDocRow.setVar("RWID_WP", opTbl.getValue("FWID_WP"));
				oDocRow.setVar("RDAY", opTbl.getValue("FDAY"));
				oDocRow.setVar("RHOUR", opTbl.getValue("FHOUR"));
				
				//Если пареметр "Использовать только в строках" код - 1
				//то нужно снять параметры с таблицы
				if(inList(modePodr, 1, 2, 3))
				{
					if(modePodr == 1)
					{
						oDocRow.setVar("RPODR", opTbl.getValue("FPODR"));
					}
					else
					{
						oDocRow.setVar("RPODR", oClPodr.getCod());
					}
				}
				if(inList(modeSelo, 1, 2, 3) && isPay)
				{
					if(modeSelo == 1)
					{
						oDocRow.setVar("RSELO", opTbl.getValue("FSELO"));
					}
					else
					{
						oDocRow.setVar("RSELO", oSelo.getCod());
					}
				}
				if(inList(modeGaluz, 1, 2, 3))
				{
					if(modeGaluz == 1)
					{
						oDocRow.setVar("RGALUZ", opTbl.getValue("FGALUZ"));
					}
					else
					{
						oDocRow.setVar("RGALUZ", oGaluz.getCod());
					}
				}
				if(inList(modeShpz, 1, 2, 3))
				{
					if(modeShpz == 1)
					{
						oDocRow.setVar("RSHPZ", opTbl.getValue("FSHPZ"));
					}
					else
					{
						//Tori 15.06.2010: если для режима использования ШПЗ в строках и в заголовке, в заголовке не указан ШПЗ, тогда берем по дефолту из таблицы строк
						if(modeShpz==3 && (Number(oShpz.getFshpz())==0 || oShpz.getFshpz()=="NaN"))
							oDocRow.setVar("RSHPZ", opTbl.getValue("FSHPZ"));
						else
							oDocRow.setVar("RSHPZ", oShpz.getFshpz());
					}
				}
				
				if(isPlaseTransf)
				{
					// Данные по местам перечислений берем из приказа, а если в приказе нет записи - тогда первое из справочника мест перечислений
					var D1 = firstDay(new Date(HBDAT.getValue()));
					var D2 = lastDay(D1);

					strSQL = "SELECT REL.FCOD"
								+" FROM ^CLRELCLCL REL INNER JOIN ^CL_TRPLACE PLACE ON REL.FWID_CL = PLACE.FWID_CL"
									+" INNER JOIN ^CAS_TR_PR CAS ON REL.FWID_CL = CAS.FWIDTR"
									+" INNER JOIN ^PRK_ALL P ON CAS.FWID = P.FWID"
								+" WHERE PLACE.FTABN = "+sqlTo(opTbl.getValue("FCOD"))
									+" AND PLACE.FTRTYPE = "+sqlTo(oPlTr.getCod())
									+" AND P.FBDAT<=" + sqlTo(D2) + " AND P.FEDAT>=" + sqlTo(D1)
					
					var sn = getSnap(strSQL);
					if(sn != null && !isEmpty(sn[0]))
					{
						oDocRow.setVar("RPLTR", sn[0]);
					}
					else
					{
						strSQL = "SELECT MIN(REL.FCOD)"
									+" FROM ^CLRELCLCL REL LEFT JOIN ^CL_TRPLACE T ON REL.FWID_CL = T.FWID_CL"
									+" WHERE REL.FCL = "+sqlTo(sprPlaseTransf)
										+" AND T.FTABN = "+sqlTo(opTbl.getValue("FCOD"))
										+" AND T.FTRTYPE = "+sqlTo(oPlTr.getCod())
									+" GROUP BY REL.FCL, T.FTABN, T.FTRTYPE";
						var sn = getSnap(strSQL);
						
						if(sn != null && !isEmpty(sn[0]))
						{
							oDocRow.setVar("RPLTR", sn[0]);
						}
					}
					sn = null;
				}
				
				objDocVD.appendRow(sRowClass, oDocRow);
				obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
				setProgressPos(numStr, txt+(numStr-1) +"/"+ opTbl.recordCount);
			}

			setProgressPos(0);
			opTbl.Close();
			opTbl = null;
		break;
		case "SET_PLTR_NUM":
			include("Objects/DpAskEx.js");
			var oAsk = new DpAskEx();
			//oAsk.useDefsOnly = true;
			oAsk.add("SBCS","Ощадкаса|Сберкасса","SBERCAS")
			oAsk.doAsk()
			if(oAsk.escape)
				return false;
			var numsb = oAsk.get("SBERCAS").getCod();
		case "SET_PLTR":
			var opTbl = OpenTable(sTmpTbl);
			for(; !opTbl.IsEOF(); opTbl.MoveNext())
			{
				//находим первое попавшееся место перечисления по указаному типу
				tabn = opTbl.getValue("FCOD");
				var D1 = firstDay(new Date(HBDAT.getValue()));
				var D2 = lastDay(D1);

				strSQL = " SELECT REL.FCOD"
						+" FROM ^CLRELCLCL REL "
							+" INNER JOIN ^CL_TRPLACE PLACE ON REL.FWID_CL = PLACE.FWID_CL"
							+" INNER JOIN ^CAS_TR_PR CAS ON REL.FWID_CL = CAS.FWIDTR"
							+" INNER JOIN ^PRK_ALL P ON CAS.FWID = P.FWID"
						+" WHERE 1 = 1 "
							+" AND PLACE.FTABN = "+sqlTo(tabn)
							+" AND PLACE.FTRTYPE = "+sqlTo(oPlTr.getCod())
							+" AND P.FBDAT<=" + sqlTo(D2)+ " AND P.FEDAT>=" + sqlTo(D1)
							+(numsb?" AND PLACE.FNUMSB="+sqlTo(numsb):"")
				var sn = getSnap(strSQL);
				
				if(sn != null && !isEmpty(sn[0]))
				{
					opTbl.Edit();
					opTbl.setValue("FPLTR", sn[0]);
					opTbl.Update();
				}
				else
				{
					strSQL = "SELECT MIN(REL.FCOD)" 
						+" FROM ^CL_TRPLACE TR "
							+" INNER JOIN ^CLRELCLCL REL ON TR.FWID_CL = REL.FWID_CL"
						+" WHERE 1 = 1 "
							+" AND REL.FCL = "+sqlTo(sprPlaseTransf)
							+" AND TR.FTABN = "+sqlTo(tabn)
							+" AND TR.FTRTYPE = "+sqlTo(oPlTr.getCod())
							+(numsb?" AND TR.FNUMSB="+sqlTo(numsb):"")
						+" GROUP BY REL.FCL, TR.FTABN, TR.FTRTYPE"
					var sn = getSnap(strSQL);
					
					if(sn && !isEmpty(sn[0]))
					{
						opTbl.Edit();
						opTbl.setValue("FPLTR", sn[0]);
						opTbl.Update();
					}
				}
				sn = null;
			}
			opTbl.close();
		break;
		case "SORT_TABN":
			var t = OpenTable("select * from "+sTmpTbl+" order by Fcod");
		case "SORT_FIO":
			if(sID=="SORT_FIO")
				var t = OpenTable("select t.* from "+sTmpTbl+" as t inner join ^listcl as l on l.Fcl="+sprMol+" and t.Fcod=l.Fcod order by l.Ftxt");
			setProgressRange(1, t.rowCount);
			for(; !t.IsEOF(); t.MoveNext())
			{
				setProgressPos(t.bookmark, ru("Сортировка ","Сортування ")+t.bookmark+"/"+t.rowCount);
				var m = new Object();
				m.Fnom_str = t.bookmark;
				UpdateTable(sTmpTbl, m, false, "Fwid="+t.getValue("Fwid"));
			}
			setProgressPos(0);
			t.close();
		break;
		
		case "SET_SHPZ":
			setShpz("ALL");
		break;
		
		case "DEBUG_BROWSE":
			browse(grid.getTable());
		break;
	}

	switch (sID)
	{
		case "ADD":
		case "COPY":
		case "EDIT":
			var bOK = oDocRow.edit(sID, par);

			if (bOK)
			{
				if(inList(sID,"ADD","COPY"))
					objDocVD.appendRow(sRowClass,oDocRow)

				obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,sTmpTbl);
			}
		break;
		default:
		break;
	}

	grid.getTable().requery();
	if (!isEmpty(oDocRow))
	{
		_retArray["FWID"] = oDocRow.getID();
		RestoreMarker(grid.getTable());	
	}
	else
	{
		grid.refresh();
	}
	updateKol();
}

function createDpAskEx(mode)
{
	include("Objects/DpAskEx.js");
	var oA = new DpAskEx();
	oA.useDefsOnly = true;	//без этого ругается при считывании значений из параметров
	
	switch (mode)
	{
		case "LDFROMBLN":
			oA.add("D", "Дата", "FBDAT", new Date(HDAT.value).getVarDate());
			oA.add("B", "Враховувати авансовий звіт|Учитывать авансовый отчет", "IS_AO", false);
			oA.add("D0", "Дата початку|Дата начала", "FBDAT_AO", new Date().getVarDate());
			oA.add("D0", "Дата закінчення|Дата конца", "FEDAT_AO", new Date().getVarDate());
			oA.add("C0UT", "Рахунок", "SC", "0|0|0");
			oA.add("RADIO", "Залишок:", "FOBOR", 1, "дебет|кредит");
			oA.add("RADIO", "Заокруглювати|Округлять", "OKRUGL", 3, "до 10 грн.|до 5 грн.|до 1 грн.|" + UR("не заокруглювати|не округлять"));
			oA.defCond("this.aQryList['IS_AO'].controls[0].checked == true", "COND_IS_AO");
			oA.enable("FBDAT_AO", "COND_IS_AO");
			oA.enable("FEDAT_AO", "COND_IS_AO");
			break;
		default:
			break;
	}
	
	//Если рижим контролов 1 то навешиваем на DpAskEx 
	//так как при этом режиме в строках обязательно должно быть значение 
	if(inList(modePodr, 1))
	{
		oA.add("CL", "Підрозділ|Подразделение", "PODR", 0, sprPodr);
	}
	if(inList(modeSelo, 1) && isPay)
	{
		oA.add("CL", "Село", "SELO", 0, sprSelo);
	}
	if(inList(modeGaluz, 1))
	{
		oA.add("CL", "Галузь витрат|Отрасль затрат", "GALUZ", 0, sprGaluz);
	}
	if(inList(modeShpz, 1))
	{
		oA.add("SHPZ", "ШВВ|ШПЗ", "SHPZ", 0);
	}
	
	//если в параметрах стоит дата и время то спрашиваем 
	if(isVisblDay)
	{
		oA.add("NUM", "Дні|Дни", "DAY", 0.0, 3, 2);
	}
	if(isVisblHour)
	{
		oA.add("NUM", "Години|Часы", "HOUR", 0.0, 3, 2);
	}
	
	oA.doAsk();
	if(oA.escape){
		return false;
	}
		
	return oA;
}


function updateKol()
{
	HSUM.setValue(getSum("SUM", sTmpTbl, "FSUM"));
	HKOL.setValue(getSum("COUNT", sTmpTbl, "FSUM"));
}

function getSum(mode, tbl, fld, cond, nOkr)
{
	retVal = 0;
	strSQL = "SELECT "
				+(mode == "SUM" ? " SUM("+fld+") " : " COUNT("+fld+") ")
			+" FROM "+tbl
			+" WHERE 1=1 "
				+(isEmpty(cond) ? "" : cond)
	s = getSnap(strSQL);
	if (s != null)
	{
		if (!isEmpty(s[0]))
		{
			retVal = s[0];
		}
	}

	if (typeof(nOkr) == "undefined")
	{
		return retVal;
	}
	else
	{
		return round(retVal, nOkr);
	}
}

function saveRows()
{
	// Проверим на задвоенные записи
	strSQL = "SELECT"
					+" FCOD"
					+", COUNT(*)"
				+" FROM "
					+ sTmpTbl
				+" WHERE 1=1"
				+" GROUP BY FCOD"
				+" HAVING COUNT(*) > 1"
	var sn = getSnap(strSQL);

	if(sn != null && !isEmpty(sn[0]))
	{
		if(!confirm(ru("Количество записей с кодом "+sn[0]+" = "+sn[1]+". Продолжить?",
					"Кількість записів з кодом "+sn[0]+" = "+sn[1]+". Продовжити?")))
		{
			return false;
		}
	}

	if(!isZP)
	{
		strSQL = " UPDATE "+sTmpTbl
				+" SET  FRTYPE = 0 "
					+", FLSFID = 0 "
		ExecuteSQL(strSQL);
	}
	
	// при сохранении установим ШПЗ, если это определено параметрами
	if (isUseShpz)
	{	
		setShpz("");
	}
	
	BeginTransaction();
	var isOk = true;

	isOk = isOk && ExecuteSQL("DELETE FROM ^"+mainTblR+" WHERE fid_doc=" + sqlTo(objDocVD.getVar("ID")));

	strSQL = " INSERT INTO"
					+" ^"+mainTblR
				+" SELECT"
					+" *"
				+" FROM"
					+" "+sTmpTbl
	isOk = isOk && ExecuteSQL(strSQL);

	if (isOk)
	{
		CommitTrans();
	}
	else
	{
		RollbackTrans();
	}

	//DropTable(sTmpTbl);
	return true;
}

function onSave()
{
	ctrlLinker.toVars();
	if(isZP)
	{
		objDocVD.setVar("HLSFID", oLicf.getFid());
	}
	else
	{
		objDocVD.setVar("HLSFID", 0);
	}
	if(!saveRows())
	{
		return false;
	}
	tbl4Grid.close();
}

function onEscape()
{
	tbl4Grid.close();
}

function nmkl_valid()
{
	var ret = true;
	if (isEmpty(oNmkl.getCod()))
	{
		ret = false;
		HNMKL.showErr(ru("Поле не может быть пустым."
								, "Поле не може бути пустим"));
		setFocus(HNMKL);
		oNmkl.doZaval();
	}
	return ret;
}

function cena_valid()
{
	var ret = true;
	if (isEmpty(Number(HCENA.getValue())))
	{
		ret = false;
		HCENA.showErr(ru("Поле не может быть пустым."
								, "Поле не може бути пустим"));
		setFocus(HCENA);
	}
	return ret;
}

function PODR_valid()
{
	var sWhere = "";
	var ret = true;
	if(modePodr == 3)
	{
		//опдейтим только те которые пустые
		sWhere = " AND FPODR = 0"
					+" OR FPODR IS NULL";
	}

	//при режиме modePodr == 2 опдейтим все строки
	//так как строки не могут отличатся от заголовка 
	if(!isSaving())
	{
		strSQL = "UPDATE "+sTmpTbl
						+" SET FPODR = "+sqlTo(oClPodr.getCod())
					+" WHERE 1=1"
						+sWhere
		ExecuteSQL(strSQL);
	}
	else
	{
		strSQL = "SELECT FWID" 
					+" FROM "+sTmpTbl
					+" WHERE 1=1"
						+" AND FPODR = 0 OR FPODR IS NULL"
		var sn = getSnap(strSQL);		
		if(sn != null)
		{		
			alert(ru("Сохранение документа не возможно\nпотому что строки документа имеют нулевое значения подразделения."
					,"Збереження документа не можливе\nтому що рядки документа мають нульове значення підрозділу."));
			ret = false;
		}
		sn = null;
	}
	
	grid.getTable().requery();
	grid.refresh();
	return ret;
}

function SELO_valid()
{
	var sWhere = "";
	var ret = true;
	if(modeSelo == 3)
	{
		//опдейтим только те которые пустые
		sWhere = " AND FSELO = 0"
					+" OR FSELO IS NULL";
	}

	//при режиме modeSelo == 2 опдейтим все строки
	//так как строки не могут отличатся от заголовка 
	if(!isSaving())
	{
		strSQL = "UPDATE "+sTmpTbl
						+" SET FSELO = "+sqlTo(oSelo.getCod())
					+" WHERE 1=1"
						+sWhere
		ExecuteSQL(strSQL);
	}
	else
	{
		strSQL = "SELECT FWID" 
					+" FROM "+sTmpTbl
					+" WHERE FSELO = 0 OR FSELO IS NULL"
		var sn = getSnap(strSQL);		
		if(sn != null)
		{		
			alert(ru("Сохранение документа не возможно \nпотому что строки документа имеют нулевое значения села."
					,"Збереження документа не можливе \nтому що рядки документа мають нульове значення села."));
			ret = false;
		}
		sn = null;
	}
	
	grid.getTable().requery();
	grid.refresh();
	return ret;
}

function GALUZ_valid()
{
	var sWhere = "";
	var ret = true;
	if(modeGaluz == 3)
	{
		//опдейтим только те которые пустые
		sWhere = " AND FGALUZ = 0"
					+" OR FGALUZ IS NULL";
	}

	//при режиме modeGaluz == 2 опдейтим все строки
	//так как строки не могут отличатся от заголовка 
	if(!isSaving())
	{
		strSQL = "UPDATE "+sTmpTbl
						+" SET FGALUZ = "+sqlTo(oGaluz.getCod())
					+" WHERE 1=1"
						+sWhere
		ExecuteSQL(strSQL);
	}
	else
	{
		strSQL = "SELECT FWID" 
					+" FROM "+sTmpTbl
					+" WHERE FGALUZ = 0 OR FGALUZ IS NULL"
		var sn = getSnap(strSQL);		
		if(sn != null)
		{		
			alert(ru("Сохранение документа не возможно \nпотому что строки документа имеют нулевое значения отрасли затрат."
					,"Збереження документа не можливе \nтому що рядки документа мають нульове значення галузі витрат."));
			ret = false;
		}
		sn = null;
	}
	
	grid.getTable().requery();
	grid.refresh();
	return ret;
}

function licf_valid()
{
	//Установим Вид строк
	var type;
	var modeIs6 = String(oLicf.getFis6());
	var fid = oLicf.getFid();
	
	switch (modeIs6)
	{
		case "+":
			type = VDTYPE_NACH;
			break;
		default:
			type = VDTYPE_CASSA;
			break;
	}
	
	strSQL = "UPDATE "+sTmpTbl
					+" SET FRTYPE = "+sqlTo(type)
					+", FLSFID = "+sqlTo(fid)
				+" WHERE 1=1"
	ExecuteSQL(strSQL);
	return true;
}

function dat_valid()
{
	//опдейт даты строк 
	//вызываем только при сохранении
	if(isSaving())
	{
		strSQL = "UPDATE "+sTmpTbl
					+" SET FDATE = "+sqlTo(new Date(HDAT.getValue()))
				+" WHERE 1=1"
		ExecuteSQL(strSQL);
	}
	return true;
}

function SHPZ_valid()
{
	var sWhere = "";
	var ret = true;
	if(modeShpz == 3)
	{
		//опдейтим только те которые пустые
		sWhere = " AND FSHPZ = '0'"
					+" OR FSHPZ IS NULL OR FSHPZ = " + SqlEmpStr;
	}

	//при режиме modeShpz == 2 опдейтим все строки
	//так как строки не могут отличатся от заголовка 
	if(!isSaving())
	{
		strSQL = "UPDATE "+sTmpTbl
						+" SET FSHPZ = "+sqlTo(oShpz.getFshpz())
					+" WHERE 1=1"
						+sWhere
		ExecuteSQL(strSQL);
	}
	else
	{
		strSQL = "SELECT FWID" 
					+" FROM "+sTmpTbl
					+" WHERE FSHPZ = '0' OR FSHPZ IS NULL OR FSHPZ = " + SqlEmpStr;
		var sn = getSnap(strSQL);		
		if(sn != null)
		{		
			alert(ru("Сохранение документа не возможно \nпотому что строки документа имеют нулевое значения ШПЗ."
					,"Збереження документа не можливе \nтому що рядки документа мають нульове значення ШВВ."));
			ret = false;
		}
		sn = null;
	}
	
	grid.getTable().requery();
	grid.refresh();
	return ret;
}

function HTYPE_TR_valid()
{
	var ret = true;
	
	if(isSaving())
	{
		strSQL = "SELECT *" 
					+" FROM "+sTmpTbl
					+" WHERE 1=1"
						+" AND FPLTR = 0"
		var sn  = getSnap(strSQL);
		if(sn != null)
		{
			alert(ru("Сохранение не возможно.\nИмеются строки с пустыми местами перечислений."
					, "Збереження не можливе.\nІснують рядки з пустими місцями перерахувань"));
			ret = false;
		}
		sn = null;
	}
	return ret;
}

function setShpz(mode)
{
	if(!oLicf)
		return;
	// если не установлен ШПЗ, то устанавливаем при условии что выбрано начисление и в парамерах папки используется ШПЗ
	var isUseShpz = (inList(modeShpz, 1, 2, 3) ? true : false);
	if (isUseShpz)
	{
		// тип вибранного поля ЛС
		strSQL = "SELECT FIS6 FROM ^LIC_FLD WHERE FID = "+sqlTo(oLicf.getFid())
		var s = getSnap(strSQL);
		var isNach = false;
		if (s != null && !isEmpty(s[0]))
		{
			isNach = s[0] == "+" ? true : false;
		}
		
		//if (isUseShpz && isNach)
		if (isNach)
		{
			// проставим ШПЗ
			strSQL = "UPDATE "+sTmpTbl
					+" SET FSHPZ = ("
						+" SELECT SD.FSHPZ FROM ^WORK_PERS WP inner join ^STRU_DOL SD ON WP.FWID_DOL = SD.FWID"
							+" WHERE WP.FWID = "+sTmpTbl+".FWID_WP"
					+" )"
					+" WHERE 1=1 "
					+(mode.toUpperCase() == "ALL" ? "" : " AND FSHPZ IS NULL OR FSHPZ = '' OR FSHPZ = '0'")
			ExecuteSQL(strSQL);
		}
	}
	return true;
}

include("sys/DpBaseDlg.js");