include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpSc.js");
include("Objects\\DpCl.js");
include("Objects\\DpNmkl.js");

var objDoc = extPar.doc;
var m = new Object();

function Load()
{
	objDoc.isBuf = true;
		
	nk = new DpNakl(objDoc, this);
	nk.load();
	
	FKOL.mask     = MASK_KOL;
	FDOC_NUM.mask = MASK_DOCNUM;
	HSUMUC.mask   = HSUMOC.mask = MASK_SUM;
		
	var objNmkl = new DpNmkl();
	nds = Number(objNmkl.getExt("_NDS"));
	
	oSc = new DpSc();	
	oSc.linkCtrl(FSC, FSU, FST);
	oSc.setMode("cu0");
	
	objPodr = new DpCl();
   	objPodr.linkCtrl(FPODR,FPODR_TXT);
	objPodr.setClcl(sprPodr);
	
	objMol = new DpCl();
   	objMol.linkCtrl(FMOL,FMOL_TXT);
	objMol.setClcl(sprMol);
	
	objPodr1 = new DpCl();
   	objPodr1.linkCtrl(FPODR1,FPODR1_TXT);
	objPodr1.setClcl(sprPodr);
	
	objMol1 = new DpCl();
   	objMol1.linkCtrl(FMOL1,FMOL1_TXT);
	objMol1.setClcl(sprMol);
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	ctrlLinker.addLink("HSC",FSC);
 	ctrlLinker.addLink("HSU",FSU);
 	ctrlLinker.addLink("HST",FST);
 	ctrlLinker.addLink("HUSUM",HSUMUC);
	ctrlLinker.addLink("HOSUM",HSUMOC);
	ctrlLinker.addLink("HKOL",FKOL);	
	
	ctrlLinker.updateData(false);
	
	if (extPar.mode == "COPY" || extPar.mode == "EDIT")
	{			
		objPodr.setCod(objDoc.getVar("HPODROT"));   		
   		objMol.setCod(objDoc.getVar("HMOLOT"));
   		objPodr1.setCod(objDoc.getVar("HPODRTO"));   		
   		objMol1.setCod(objDoc.getVar("HMOLTO"));	
		
		oSc.set(objDoc.getVar("HSC"),
   				objDoc.getVar("HSU"),
   				objDoc.getVar("HST"));
	}
		
	Disable(HSUMUC);
	Disable(HSUMOC);
	Disable(FKOL);
			
	setFocus(FDOC_NUM);		
	recalcSum();
}

function recalcSum()
{		
	nk.wItog(m);
	
	//m.hndsu = round((m.hndsu * nds)/100,2);
	m.hndso = round((m.hndso * nds)/100,2);
	
	HSUMUC.value = m.hsumuc;
	HSUMOC.value = m.hsumoC;
	FKOL.value = m.hKol;			
}

function updateData()
{
	objDoc.setVar("HP",   objDoc.getPar("_pricetyp"));	
	objDoc.setVar("HPN",  objDoc.getPar("_priceuse"));
	objDoc.setVar("HPODR",objPodr.getCod());
	objDoc.setVar("HMOL", objMol.getCod());		
	objDoc.setVar("HPODRTO",objPodr1.getCod());
	objDoc.setVar("HMOLTO",objMol1.getCod());
	ctrlLinker.updateData(true);
}

function onSave()
{
	updateData();
	objDoc.setVar("HPODROT",objPodr.getCod());
	objDoc.setVar("HMOLOT",objMol.getCod());
	
	objDoc.setVar("HSMTOV",	m.Fsum_tov);
	objDoc.setVar("HSBTOV",	m.Fseb_tov);
	objDoc.setVar("HSMMAT",	m.Fsum_mat);
	objDoc.setVar("HSBMAT",	m.Fseb_mat);	
	objDoc.setVar("HOSTAR",	m.Fsum_tar);
	objDoc.setVar("HUSTAR",	m.Fseb_tar);	
	objDoc.setVar("HTOTL",	m.hIsRasc);
	objDoc.setVar("HSNDS",	m.hndsu);
	objDoc.setVar("HSNDS1",	m.hndso);	
	objDoc.setVar("HKOL",	m.hKol);
	objDoc.setVar("HNR",	m.hNr);
	
	nk.saveRows();
}

function docMenuServis()
{
	grid.AddMenuItem("SETFCENAPR","Установити кінцеву ціну = вихідній|Установить конечную цену = исходной");	
}

function docMenuHandler(sID)
{
	switch(sID)
	{
		case "SETFCENAPR":	 		
			tbl = grid.getTable();
			for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
			{	
				var fcena = 0;
				var oSnap = getSnap("select fcena from ^ANLTK where fwid = "+ tbl.getValue("fid_pn"));
				if(oSnap == null)
					continue;
				fcena = oSnap[0];
				var oDocRow = objDoc.getRow("ROW",Number(tbl.getRowID()));
				oDocRow.setVar("R1OCENA", fcena);
				oDocRow.setVar("RPCENE",  fcena);							
				obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,nk.bufName);								
				
				ExecuteSQL(
	 				"UPDATE " + nk.bufName +
		 			 + " SET fcena 		=" + fcena
		 				+ ", f1cena 	=" + fcena
		 				+ ", fcena_ord	=" + fcena
		 			+ " WHERE frtype='6'"
	 					);
			}			
	 		alert(ru("Запустите перерасчет остатков","Запустіть перерахунок залишків"));
	 		break;		
		
		default: 
			return false;
	}
}
			
include("sys\\DpBaseDlg.js");