include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpNmkl.js");
include("sys\\kursval.js");

var objDoc = extPar.doc;
var m = new Object();

function Load()
{	
	var nmklsel = objDoc.getPar("_nmklsel");
	var otpsel = objDoc.getPar("_otpsel");
	
	var rowmol = objDoc.getPar("_rowmol");
	var rowpdr = objDoc.getPar("_rowpdr");
	var rowpst = objDoc.getPar("_rowpst"); 
	
	objDoc.isBuf = false;	
		
	nk = new DpNakl(objDoc, this);
	nk.load();	
	
	FDOC_NUM.mask = FDOV_NUM.mask = MASK_DOCNUM;
	HSUMOC.mask   = HNDSO.mask 
				  = HSUMSNDSO.mask = MASK_SUM;
	FKOL.mask     = MASK_KOL;
	
	var objNmkl = new DpNmkl();
	nds = Number(objNmkl.getExt("_NDS"));
	
	oVal = new DpVal();
	oVal.linkCtrl(TFVAL);
		
	oSc = new DpSc();	
	oSc.linkCtrl(FSC, FSU, FST);
	oSc.setMode("cu");
	
	objPost = new DpCl();
   	objPost.linkCtrl(FDBKR,FDBKR_TXT);
	objPost.setClcl(getPar("CODPLAT"));
	
	objPodr = new DpCl();
   	objPodr.linkCtrl(FPODR,FPODR_TXT);
	objPodr.setClcl(sprPodr);
	
	objMol = new DpCl();
   	objMol.linkCtrl(FMOL,FMOL_TXT);
	objMol.setClcl(sprMol);
	
	objMol.setMode( rowmol?	 "0!" : "");
	objPodr.setMode( rowpdr? "0!" : "");
	objPost.setMode( rowpst? "0!" : "");
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	ctrlLinker.addLink("HSC",FSC);
 	ctrlLinker.addLink("HSU",FSU);
 	ctrlLinker.addLink("HST",FST);	
	ctrlLinker.addLink("HPNDS",FNDS_PROC);
	ctrlLinker.addLink("HSNDS1",HNDSO);
	//ctrlLinker.addLink("HOSUM",HSUMOC);
	ctrlLinker.addLink("HKOL",FKOL);
	ctrlLinker.addLink("HDVDAT",FDOV_DAT);
	ctrlLinker.addLink("HDVNOM",FDOV_NUM);
	ctrlLinker.addClLink("HPLCH",objPost);	
		
	ctrlLinker.updateData(false);
	
	if (extPar.mode == "ADD")
	{		
		FNDS_PROC.value = nds;
	}
	else
	{
		oVal.setCod(objDoc.getVar("HVAL"));
		
		objPost.setCod(objDoc.getVar("HPLCH"));
   		objPodr.setCod(objDoc.getVar("HPODR"));   		
   		objMol.setCod(objDoc.getVar("HMOL"));	
		
		oSc.set(objDoc.getVar("HSC"),
   				objDoc.getVar("HSU"),
   				objDoc.getVar("HST"));
   				
   		if(objDoc.getVar("HPNDS")!=0)
   			FNDS_PROC.value = nds;
	}	
	
	Disable(HSUMSNDSO);
	Disable(HSUMOC);
	Disable(HNDSO);
	Disable(FKOL);

	setValid(FNDS_PROC, recalcSum);	
	setValid(FDOC_DAT, recalcSum);	
	setValid(TFVAL, recalcSum);		
		
	setFocus(FDOC_NUM);	
	recalcSum();	
}

function recalcSum()
{		
	nk.nds = Number(FNDS_PROC.value);	
	nk.wItog(m);
		
	FKOL.value = m.hKol;
	HSUMOC.value = m.hsumoC;
	HNDSO.value = m.hndso;
	HSUMSNDSO.value = Number(HSUMOC.value) + Number(HNDSO.value);	
	//m.hndsu = round((Number(m.hndsu) * nds)/100,2);	
}

function updateData()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HVAL", oVal.getCod());
	objDoc.setVar("HPOST",objPost.getCod());
	objDoc.setVar("HPLCH",objPost.getCod());
	objDoc.setVar("HPODR",objPodr.getCod());
	objDoc.setVar("HMOL", objMol.getCod());
	objDoc.setVar("HP",   objDoc.getPar("_pricetyp"));	
	objDoc.setVar("HPN",  objDoc.getPar("_priceuse"));	
}

function onSave()
{
	updateData();
	
	objDoc.setVar("HSMTOV",	m.Fsum_tov);
	objDoc.setVar("HSBTOV",	m.Fseb_tov);
	objDoc.setVar("HSMMAT",	m.Fsum_mat);
	objDoc.setVar("HSBMAT",	m.Fseb_mat);	
	objDoc.setVar("HOSTAR",	m.Fsum_tar);
	objDoc.setVar("HUSTAR",	m.Fseb_tar);	
	objDoc.setVar("HTOTL",	m.hIsRasc);	
	
	objDoc.setVar("HSNDS",	m.hndsu);	
	objDoc.setVar("HSUM",	m.hsumu1c);
	objDoc.setVar("HUSUM",	m.hsumuc);	
	objDoc.setVar("HNR",	m.hNr);
	
	nk.saveRows();
}

function docMenuServis()
{
	grid.AddMenuItem("SETFCENAPRVP","Встановити ціну постачальника = ціні поставки|Установить цену поставщика = цене поставки");
	grid.AddMenuItem("SETFCENAPRUVP","Встановити ціну постачальника = обліковій ціні|Установить цену поставщика = учетной цене");	
}

function docMenuHandler(sID)
{
	var tbl = grid.getTable();
	var fcena = 0;
	
	switch(sID)
	{
		case "SETFCENAPRVP":	 		
	 		/*ExecuteSQL(
	 			"UPDATE " + nk.bufName + " b"
			 		+ " LEFT JOIN ^anltk a"
	 					+ " ON b.fid_pn=a.fwid"
		 		+ " SET b.fcenapr = a.fcena"
		 			+ ", b.f1cena = a.fcena"
		 		+ " WHERE b." + grid.sqlSelected()
					+ " AND NOT (a.fcena IS NULL)"
					+ " AND b.fid_doc=" + sqlTo(nk.nId)
	 			);*/			
			
			var oSnap = getSnap("select fcena from ^ANLTK where fwid = "+ sqlTo(tbl.getValue("fid_pn")) + " AND fcena IS NOT NULL");
			if(oSnap == null)
				return;				
			fcena = oSnap[0];
			var oDocRow = objDoc.getRow("ROW",Number(tbl.getRowID()));
			oDocRow.setVar("ROCENA", fcena);
			oDocRow.setVar("RPCENE", fcena);							
			obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,nk.bufName);						
			break;
			
		case "SETFCENAPRUVP":
	 		/*var sSQL = "UPDATE " + nk.bufName
			 		+ " SET fcenapr = fcena"
		 			+ ", f1cena = fcena"
		 		+ " WHERE " + grid.sqlSelected()
					+ " AND NOT (fcena IS NULL)"
					+ " AND fid_doc=" + sqlTo(nk.nId);
				ExecuteSQL(sSQL)			
			*/			
			var oSnap = getSnap("select fcena from ^"+ nk.bufName +" where "+ grid.sqlSelected()+ " AND fcena IS NOT NULL");
			if(oSnap == null)				
				return;
			fcena = oSnap[0];			
			var oDocRow = objDoc.getRow("ROW",Number(tbl.getRowID()));
			oDocRow.setVar("ROCENA", fcena);
			oDocRow.setVar("RPCENE", fcena);							
			obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,nk.bufName);		
			break;
		
		default: 
			return false;
	}
}

function onChangeNop()
{
	objDoc = extPar.doc;
	
	rowmol = objDoc.getPar("_rowmol");
	rowpdr = objDoc.getPar("_rowpdr");
	rowpst = objDoc.getPar("_rowpst");
	objMol.setMode( rowmol?	 "0!" : "");
	objPodr.setMode( rowpdr? "0!" : "");
	objPost.setMode( rowpst? "0!" : "");
	
	grid.DeletePages();
	nk.loadGrid();
}
		   				
include("sys\\DpBaseDlg.js");