include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpNmkl.js");
include("sys\\kursval.js");

var objDoc = extPar.doc;
var m = new Object();

function Load()
{
	var pricetyp = objDoc.getPar("_pricetyp");
	var priceuse = objDoc.getPar("_priceuse");

	objDoc.isBuf = true;	
		
	nk = new DpNakl(objDoc, this);
	nk.load();	
	
	FDOC_NUM.mask = FDOV_NUM.mask = MASK_DOCNUM;
	HSUMOC.mask   = HNDSO.mask = FSUM_AKC.mask = MASK_SUM;
	FKOL.mask     = MASK_KOL;
	
	var objNmkl = new DpNmkl();
	nds = Number(objNmkl.getExt("_NDS"));
	
	oVal = new DpVal();
	oVal.linkCtrl(TFVAL);
		
	oSc = new DpSc();	
	oSc.linkCtrl(FSC, FSU, FST);
	oSc.setMode("c0u");
	
	objPost = new DpCl();
   	objPost.linkSmartCtrl(FDBKR);
	objPost.setClcl(getPar("CODPLAT"));
	
	objPodr = new DpCl("0");
   	objPodr.linkSmartCtrl(FPODR);
	objPodr.setClcl(sprPodr);
	
	objMol = new DpCl("0");
   	objMol.linkSmartCtrl(FMOL);
	objMol.setClcl(sprMol);
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",FDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	//ctrlLinker.addLink("HSC",FSC);
 	//ctrlLinker.addLink("HSU",FSU);
 	//ctrlLinker.addLink("HST",FST);	
	ctrlLinker.addLink("HPNDS",FNDS_PROC);
	ctrlLinker.addLink("HSNDS",HNDSO);
	ctrlLinker.addLink("HOSUM",HSUMOC);
	ctrlLinker.addLink("HKOL",FKOL);
	ctrlLinker.addLink("HDVDAT",FDOV_DAT);
	ctrlLinker.addLink("HDVNOM",FDOV_NUM);
	ctrlLinker.addClLink("HPOST",objPost);
	ctrlLinker.addClLink("HPODR",objPodr);
	ctrlLinker.addClLink("HMOL",objMol);
	ctrlLinker.addScLink("HSC","HSU","HST",null,null,null,oSc);	
	ctrlLinker.updateData(false);
	
	if (extPar.mode == "COPY" || extPar.mode == "EDIT")
	{
		oVal.setCod(objDoc.getVar("HVAL"));
		
		/*
		objPost.setCod(objDoc.getVar("HPOST"));
   		objPodr.setCod(objDoc.getVar("HPODR"));   		
   		objMol.setCod(objDoc.getVar("HMOL"));	
		*/
		
		oSc.set(objDoc.getVar("HSC"),
   				objDoc.getVar("HSU"),
   				objDoc.getVar("HST"));
   		
   				
   		if(objDoc.getVar("HPNDS")!=0)
   			FNDS_PROC.value = nds;
	}
	if (extPar.mode == "ADD")
	{		
		FNDS_PROC.value = nds;
	}
	
	Disable(FSUM_AKC);
	Disable(HSUMOC);
	Disable(HNDSO);
	Disable(FKOL);

	setValid(FNDS_PROC, recalcSum);	
	setValid(FDOC_DAT, recalcSum);	
	setValid(TFVAL, recalcSum);		
		
	setFocus(FDOC_NUM);	
	recalcSum();	
}

function recalcSum()
{		
	nk.nds = Number(FNDS_PROC.value);
	nk.wItog(m);
	
	FKOL.value = m.hKol;
	HSUMOC.value = m.hsumoC;
	
	var dt = FDOC_DAT.value;
	var kod1 = oVal.getNazv();
	var kurs = 0;	
	if (m.hndso != null)
		m.hndso = _nv2nv("", dt, kod1, m.hndso, 0, kurs, 1);
			
	//m.hndsu = round((m.hndsu * nds)/100,2);	
	HNDSO.value = m.hndso;	
}

function docTblTie()
{
	nk.tbl4Grid.tie("anltk","pn0","FWID","Fid_pn0");
	nk.tbl4Grid.tie("sch_zag","h0","FWID","pn0.FID_DOC");
}

function updateData()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HVAL", oVal.getCod());
	objDoc.setVar("HPOST",objPost.getCod());
	objDoc.setVar("HPODR",objPodr.getCod());
	objDoc.setVar("HMOL", objMol.getCod());
	objDoc.setVar("HP",   objDoc.getPar("_pricetyp"));	
	objDoc.setVar("HPN",  objDoc.getPar("_priceuse"));	
}

function onSave()
{
	updateData();
	
	objDoc.setVar("HSMTOV",	m.Fsum_tov);
	objDoc.setVar("HSBTOV",	m.Fseb_tov);
	objDoc.setVar("HSMMAT",	m.Fsum_mat);
	objDoc.setVar("HSBMAT",	m.Fseb_mat);	
	objDoc.setVar("HOSTAR",	m.Fsum_tar);
	objDoc.setVar("HUSTAR",	m.Fseb_tar);	
	objDoc.setVar("HTOTL",	m.hIsRasc);	
	objDoc.setVar("HSNDS1",	m.hndsu);
	objDoc.setVar("HUSUM",	m.hsumuc);
	objDoc.setVar("HKOL",	m.hKol);
	objDoc.setVar("HNR",	m.hNr);
		
	nk.saveRows();
}

function docMenuServis()
{
	grid.AddMenuItem("SETFIDPNVR","Підібрати партію з видатку|Подобрать партию из расхода");
	//grid.AddMenuItem("SETFIDPNVR2","Підібрати партію без врахування повернення|Подобрать партию без учета возврата");
	//grid.AddMenuItem("SETFIDPNVRORG","Підібрати партію з видатку в іншій організації|Подобрать партию из расхода в другой организации");
	//grid.AddMenuItem("SETFIDPNVRORG2","Підібрати партію без врахування повернення в іншій організації|Подобрать партию без учета возврата в другой организации");				
	
	grid.AddMenuItem("SETFID_PN_NK", "Встановити поставку з видатку|Установить поставку из расхода");
}

function docMenuHandler(sID)
{
	switch(sID)
	{
		case "SETFIDPNVR":			
		case "SETFIDPNVR2":
		//case "SETFIDPNVRORG":			
		//case "SETFIDPNVRORG2":
			var tblVR = OpenTable("s","select * from "+ nk.bufName +" where " + grid.sqlSelected()+ " and fid_pn = 0");
			var i = 0;
			sSuffix = "";
			//if (sID == "SETFIDPNVRORG" || sID == "SETFIDPNVRORG2")
				//sSuffix = "("+input("Номер организации:","",iOrg,1,6)+")"
						
			while(!tblVR.isEOF())
			{
				var sumKOl = " SUM("+IIF("FDOC = 'NK'","FKOL","0")+") as fsumkol ";
				if(sID =="SETFIDPNVR" || sID =="SETFIDPNVRORG")
					sumKOl = " SUM("+IIF("FDOC = 'NK'","FKOL","(-1)*FKOL")+") as fsumkol ";
				var sSQL = " select fid_pn, fcena, fpost, "+ sumKOl 
						+" from ^anltk"+ sSuffix
						+" where (fdoc = 'NK' or fdoc = 'VR') "
						+" and fnmkl = " + sqlTo(tblVR.getValue("fnmkl"))
						+" and fcenapr = " + sqlTo(round(tblVR.getValue("fcenapr"),5))
						+" and fpodr = " + sqlTo(tblVR.getValue("fpodr"))
						+" and fsc = " + sqlTo(tblVR.getValue("fsc"))
						+" and fsu = " + sqlTo(tblVR.getValue("fsu"))
						+" and fid_pn <> '' and fid_pn <> 0"
						+" group by fid_pn, fcena, fpost ";
				
				if(sID =="SETFIDPNVR" || sID =="SETFIDPNVRORG")
					sSQL += " having SUM("+IIF("FDOC = 'NK'","FKOL","(-1)*FKOL")+") > 0";
				else
					sSQL += " having SUM("+IIF("FDOC = 'NK'","FKOL","0")+") > 0";
				
				var oTbl = OpenTable("s",sSQL);
				var nKol = tblVR.getValue("fkol") 

				if(!oTbl.isEOF())
				{				
					nVip = Math.min(nKol,oTbl.getValue("fsumkol"))
					nKol -= nVip;
					
					tblVR.Edit();
					tblVR.setValue("fid_pn", oTbl.getValue("fid_pn"));
					tblVR.setValue("fcena", oTbl.getValue("fcena"));
					tblVR.setValue("fcena_ord", oTbl.getValue("fcena"));
					tblVR.setValue("fpost", oTbl.getValue("fpost"));
					tblVR.setValue("fkol", nVip);
					tblVR.setValue("f1kol", nVip);
					tblVR.Update();

					if(nKol > 0)
					{
						var obj = scatter(tblVR);
						obj["fid_pn"] = 0;
						obj["fpost"] = 0;
						obj["fkol"] = nKol;
						obj["f1kol"] = nKol;
						obj["fwid"] = GetUID();
						tblVR.AddNew();
						gather(tblVR,obj,"NEW");
						tblVR.Update();						
					}					
				}
				i++;
				tblVR.MoveNext();
				if(i%10==0)
					WAITTIMER(ru("Обработано строк "+i,"Оброблено рядків "+i));	
			}
			break;
			
		case "SETFID_PN_NK":
	 		/*ExecuteSQL(
	 			"UPDATE " + nk.bufName + " b"
		 				+ " LEFT JOIN ^anltk a"
		 				+ " ON b.fid_pn0 = a.fwid"
		 		+ " SET b.fid_pn = a.fid_pn"
		 		+ " WHERE b." + grid.sqlSelected()
		 			+ " AND b.fid_doc=" + sqlTo(nk.nId)
		 			+ " AND a.fid_pn <> 0"
	 			);
			*/
			var tbl = grid.getTable();
			var fid_pn = 0;
			var oSnap = getSnap("select fid_pn from ^ANLTK where fwid = "+ tbl.getValue("fid_pn0") +" AND fid_pn <> 0");
			if(oSnap == null)				
				return;
			fid_pn = oSnap[0];			
			var oDocRow = objDoc.getRow("ROW",Number(grid.getTable().getRowID()));
			oDocRow.setVar("R1ID", fid_pn);									
			obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,nk.bufName);
	   		break;
		
		default: 
			return false;
	}
}

function onChangeNop()
{
	objDoc = extPar.doc;			
	grid.DeletePages();
	nk.loadGrid();
}

include("sys\\DpBaseDlg.js");