include("objects/dpcl.js");
include("objects/DpOrg.js");
include("objects/DpVopl.js");

var obj = extPar.doc; 
var param = extPar.param;
var lowDat = toScriptDate(new Date());
var ctrlLinker = null;
var dpVopl = null;
var dpKodKat = null;
var dpPers = null;
var dpOrg = null;
var dpDol = null;

function Load() 
{
   	Caption(UR("Наказ: призначення на посаду |Приказ: назначение на должность "));
   	
   	ctrlLinker = new DpCtrlLinker(obj);
 	ctrlLinker.addLink("RBDAT", RBDAT);
 	ctrlLinker.addLink("RTERM", RTERM);
 	ctrlLinker.addLink("RREASON", RREASON);
 	ctrlLinker.addLink("RAVANS", RAVANS);
 	ctrlLinker.addLink("RTABLE", RTABLE);
 	ctrlLinker.addLink("RNAZN", RNAZN);
 	ctrlLinker.addLink("RINVAL", RINVAL);
 	ctrlLinker.addLink("RPRIEM", RPRIEM);
 	ctrlLinker.addLink("RZAPIS", RZAPIS);
  	ctrlLinker.updateData(false);
  	
	dpPers = new DpCl("", getPar("CODPERS"), 0);
	dpPers.linkCtrl(RTABN, RTABNTXT);
	dpPers.addCondition("condition");
	
	dpVopl = new DpVopl();
	dpVopl.linkCtrl(RVOPL, RVOPLTXT);	
	
	dpKodKat = new DpCl("", getPar("CODKAT"), 0);
	dpKodKat.linkCtrl(RKODKAT, RKODKATTXT);	
	
	if (extPar.mode != "ADD")
	{
		dpPers.setFWID(obj.getVar("RWID_CL"));
		dpVopl.setVopl(obj.getVar("RVOPL"));
		dpKodKat.setFWID(obj.getVar("RWID_KODKAT"))
	}

	/*dpOrg = new DpOrg();		
  	dpOrg.linkCtrl(RORG, RDOL);*/
  	 
  	RAVANS.setMask("########.##");
  	RTABLE.setMask("#");
  	RTERM.setMask("###"); 	 	

	if (param != null)
	{
		/*dpOrg.setPeriod(param.bdat, param.edat);
		dpOrg.setFWID(param.fwid_org);
  		dpOrg.getDpDol().setFWID(param.fwid_dol);*/
		if (param.dat_prk != null)
		{
			RBDAT.value = param.dat_prk;
			lowDat = toScriptDate(RBDAT.value);
		}
	}
	
	setValid(RBDAT, bdatValid);
}

function onSave()
{
	ctrlLinker.updateData(true);
	obj.setVar("RWID_CL", dpPers.getFWID());
	obj.setVar("RWID_KODKAT", dpKodKat.getFWID());
	obj.setVar("RWID_DOL", param.fwid_dol);
	obj.setVar("RVOPL", dpVopl.getVopl());
		
    if (extPar.mode == "ADD" ||  extPar.mode == "COPY")
    {
		var snap = getSnap("SELECT MAX(fid) FROM ^work_pers WHERE fwid_cl=" + sqlTo(obj.getVar("RWID_CL")));
		if (snap != null)
			obj.setVar("RID", snap[0] + 1);
		else
			obj.setVar("RID", 1);			
		obj.setVar("RWID_WP", GetUID());
    }
    
	var m = new Object();
	m.FWID = obj.getVar("RWID_WP");
	m.FWID_CL = obj.getVar("RWID_CL");
	m.FWID_DOL = obj.getVar("RWID_DOL");
	m.FWID_KAT = obj.getVar("RWID_KODKAT");
	m.FID = obj.getVar("RID");
	m.FBDAT =  obj.getVar("RBDAT");
	m.FVOPL = obj.getVar("RVOPL");
	m.FAVANS = obj.getVar("RAVANS");
	m.FTABLE = obj.getVar("RTABLE");
	m.FNAZN = obj.getVar("RNAZN");
	m.FINVAL = obj.getVar("RINVAL");
	m.FIS_NAZN = obj.getVar("RPRIEM");
	m.FIS_SERV = obj.getVar("RZAPIS");

	updateTable("^work_pers", m, extPar.mode != "EDIT");
}

function bdatValid()
{
	var newdat = toScriptDate(RBDAT.value)
	if (differ(lowDat, newdat) == 1)
	{
		WAIT(UR("Дата наказу не може бути менша |Дата приказа не может быть меньше ") + StrDat(lowDat, "DMY"));
		return false;
	}
	//dpOrg.setPeriod(newdat, param.edat);
	return true;
}

function condition(cod)
{
	var strSQL = "SELECT MAX(fedat)"
				+ " FROM ^work_pers"
				+ " WHERE fwid_cl=(SELECT fwid_cl FROM ^clrelclcl"
								+ " WHERE fcod=" + sqlTo(cod) 
									+  " AND fcl=" + sqlTo(getPar("CODPERS")) + ")";
	var snap = getSnap(strSQL);
	if (snap == null || snap[0] == null || snap[0] != d00)
		return true;		
	return false;
}

include("sys\\DpBaseDlg.js");