include ("Objects\\DpCl.js");
include("Objects\\DpCtrlLinker.js");
//include("Objects\\DpPostRs.js");

var objDoc = extPar.doc; 
var ctrlLinker = null;
var oOrg;
var param;
var oOrgRs;
var edmode = extPar.mode;
var sRowTbl = "CONTRACT_ROW";
var sTmpTbl = getTmpTableName();
var sServTbl = "CONTRACT_SERV";
var sTmpServ = getTmpTableName();

function Load()
{
	Caption(objDoc.getCaption() + ": " + modeName(extPar.mode));
	
	ctrlLinker = new DpCtrlLinker(objDoc);

	HDOG_NUM.mask = "&&&&&&&&&&&&&";
	HSUM.mask = MASK_SUM;
	HMONTHPAY.mask = MASK_SUM;
	HDISCOUNT.mask = MASK_SUM;
	
	oOrg = new DpCl();
	oOrg.setClcl(getPar("CODPLAT"));
	oOrg.linkSmartCtrl(HORG);
	oOrg.setContAssist();
	
	oVid = new DpCl("0");
	oVid.setClcl(getPar("CODCONTRACTVID"));
	oVid.linkSmartCtrl(HVID_DOG);
	
   	ctrlLinker.addLink("HDAT",HDAT); 
 	ctrlLinker.addClLink("HORG",oOrg);     
 	ctrlLinker.addClLink("HVID_DOG",oVid);     
  	ctrlLinker.addLink("HSUM_DOG",HSUM); 
  	ctrlLinker.addLink("HTXT",HTXT);
  	ctrlLinker.addLink("HEDAT",HEDAT);
  	ctrlLinker.addLink("HBDAT",HBDAT);
  	ctrlLinker.addLink("HDOG_NUM",HDOG_NUM);
  	ctrlLinker.addLink("HPREM",HPREM);
  	ctrlLinker.addLink("HDISCOUNT", HDISCOUNT);   
  	
 	ctrlLinker.updateData(false);        
 	
 	if(extPar && extPar.org)
		oOrg.setCod(extPar.org);
 	 	
 	if (edmode == "ADD")
 	{
 		HTXT.value = objDoc.getOName();
 	}
 	else
 	{
 		//oOrg.setClcl(getPar("CODPLAT"));
        oOrg.setCod(objDoc.getVar("HORG"));
 	}
 	
 	setButton(BTNPARTI, partiSum);
 	setValid(HBDAT, HBDAT_Valid);
 	
 	gridInit();
 	loadServ();
}

function onSave()
{	
	ctrlLinker.updateData(true);
	saveRows();
}

function saveRows()
{
	ExecuteSQL("UPDATE "+ sTmpTbl +" SET FID_DOG="+ sqlTo(objDoc.getID()));
	ExecuteSQL("UPDATE "+ sTmpTbl
			+" SET FDOC="+ sqlTo(objDoc.sDocLbl) 
				+", FNOP="+ Number(objDoc.nNop)
				+", FORG="+ Number(oOrg.getCod())
				);
	ExecuteSQL("DELETE FROM ^"+ sRowTbl +" WHERE FID_DOG="+ sqlTo(objDoc.getID()));
	var sFld = GetPatternIntersection (sRowTbl, sRowTbl);
	ExecuteSQL("INSERT INTO ^"+ sRowTbl +" ("+ sFld +")"
				+" SELECT "+ sFld +" FROM "+ sTmpTbl
				);
	
	ExecuteSQL("UPDATE "+ sTmpServ +" SET FID_DOG="+ sqlTo(objDoc.getID()));
	ExecuteSQL("DELETE FROM ^"+ sServTbl +" WHERE FID_DOG="+ sqlTo(objDoc.getID()));
	var sFld = GetPatternIntersection (sServTbl, sServTbl);
	ExecuteSQL("INSERT INTO ^"+ sServTbl +" ("+ sFld +")"
				+" SELECT "+ sFld +" FROM "+ sTmpServ
				);
}

function loadServ()
{
	include("Objects/DpNmkl.js");
	oNmkServ = new DpNmkl();
	oNmkServ.linkSmartCtrl(FNMKL);
	oNmkServ.CanEmpty = true;
	setButton(ADDSERV, addServ);
		
	var nID = (extPar.mode=="COPY") ? objDoc.nOldID : objDoc.getID();
	var sSQL = "SELECT * INTO " + sTmpServ
			+" FROM ^"+ sServTbl
			+" WHERE FID_DOG="+ sqlTo(nID);	
	ExecuteSQL(sSQL);
	
	var tbl = OpenTable("SELECT * FROM "+ sTmpServ +" order by FBDAT, FEDAT, FNMKL");
	if(extPar.mode=="COPY")
		objDoc.resetFnids(tbl, "SERV", objDoc);
	tbl.tie("CL_NMK", "nmk", "FWID", "FNMKL");
	
	grid_serv.setXMLDir(objDoc.getClassDefPath() +"SERV/");
	grid_serv.setXMLFile("list.xml");
	grid_serv.setTable(tbl);
	grid_serv.build();		
	grid_serv.setData("SERV");
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid_serv.loadMenuHandler(this, "gridMenuInit");
	grid_serv.selectMenuHandler(this, "gridMenuRun");
}

function addServ()
{
	if(!oNmkServ.getCod())
		return;
	var sRowClass = "SERV";
	var sTbl = grid_serv.getTable().getTableName();
	var oDocRow = objDoc.createRow(sRowClass);
	oDocRow.setVar("RNMKL", oNmkServ.getCod());
	oDocRow.setVar("RBDAT", new Date(HBDAT.value).getVarDate());
	oDocRow.setVar("REDAT", d00);
	oDocRow.setVar("RKOL", 1);
				
	objDoc.appendRow(sRowClass, oDocRow)
	obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTbl);
	
	grid_serv.getTable().requery();			
	grid_serv.getTable().findByID(oDocRow.getID());
	grid_serv.refresh();
	
	oNmkServ.setCod(0);
}

function gridInit()
{
	var nID = (extPar.mode=="COPY") ? objDoc.nOldID : objDoc.getID();
	var sSQL = "SELECT * INTO " + sTmpTbl
			+" FROM ^"+ sRowTbl
			+" WHERE FID_DOG="+ sqlTo(nID);	
	ExecuteSQL(sSQL);
	
	var tbl = OpenTable("SELECT * FROM "+ sTmpTbl +" order by FDATE, FREM");
	
	if(extPar.mode=="COPY")
		objDoc.resetFnids(tbl, "ROW", objDoc);
		
	grid.setXMLDir(extPar.doc.getClassDefPath() +"ROW/");
	grid.setXMLFile("list.xml");
	grid.setTable(tbl);
	grid.build();		
	grid.setData("ROW");
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid.loadMenuHandler(this,"gridMenuInit");
	grid.selectMenuHandler(this,"gridMenuRun");
}

function gridMenuInit(oGrid)
{
	oGrid.AddMenuItem("ADD", "Додавання | Добавление");
	if (!oGrid.getTable().isEmpty())
	{
		oGrid.AddMenuItem("EDIT", "Редагування | Редактирование");
		oGrid.AddMenuItem("COPY", "Копіювання | Копирование");
		oGrid.AddMenuItem("DEL", "Видалення | Удаление");
	}
}

function gridMenuRun(sID, oGrid)
{
	var sRClass = oGrid.getData();
	var rowID = Number(oGrid.getTable().getRowID());
	var sTbl = oGrid.getTable().getTableName();
		
	switch(sID)
	{
	case "DEL":
		objDoc.deleteRow(sRClass, rowID);
		oGrid.getTable().Delete();
		oGrid.getTable().requery();
		oGrid.refresh();	
		break;
	
	case "ADD": case "EDIT": case "COPY":
		var oDocRow;
		if(sID == "ADD")
			oDocRow = objDoc.createRow(sRClass);
		else if(sID == "EDIT")
			oDocRow = objDoc.getRow(sRClass, rowID);
		else if(sID == "COPY")
			oDocRow = objDoc.copyRow(sRClass, rowID);			
		
		var bOK = oDocRow.edit(sID)
		if (bOK)
		{
			if(inList(sID,"ADD","COPY"))
				objDoc.appendRow(sRClass, oDocRow)
				
			obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTbl);
			oGrid.getTable().requery();
			
			oGrid.getTable().findByID(oDocRow.getID());
			oGrid.refresh();			
		}
		break;
	}
}

function partiSum()
{
	include("servis/date.js");
	var dat1 = HBDATPAY.value;
	var dat2 = HEDATPAY.value;
	if(differ(HBDATPAY.value, d00)!=-1)
	{
		if(differ(HBDAT.value, d00)!=-1)
			HBDAT.value = today;
		HBDATPAY.value = HBDAT.value;
		dat1 = HBDATPAY.value;
	}
	if(differ(HEDATPAY.value, d00)!=-1)
	{
		if(differ(HEDAT.value, d00)==-1)
			HEDATPAY.value = HEDAT.value;
		dat2 = HEDATPAY.value;
	}
	var payDat = dat1;
	var sumDog = Number(HSUM.value);
	var sumPart = Number(HMONTHPAY.value);
	var sumPay = 0;
	var sRClass = "ROW";
	var sTmpTbl = grid.getTable().getTableName();
	if(sumDog>0)
	{
		var nMonth = month_difference(dat1, dat2);
		if(nMonth>0 && differ(dat2, d00)==-1)
		{
			sumPart = round(sumDog/nMonth, 2);
			HMONTHPAY.value = sumPart;
			for(var i=0; i<nMonth; i++)
			{
				sumPay += sumPart;
				if(sumPay > sumDog)
					sumPart -= (sumPay - sumDog);
				else if((sumDog-sumPay) < sumPart && i==(nMonth-1))
					sumPart += (sumDog-sumPay);
				payDat = goMonth(dat1, i);
				var oDocRow = objDoc.createRow("ROW");
				oDocRow.setVar("RDATE", payDat);
				oDocRow.setVar("RSUM", sumPart);
				objDoc.appendRow("ROW", oDocRow);
				obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
			}
		}
		else
		{
			if(sumPart<=0)
			{
				setFocus(HEDATPAY);
				return;
			}
			for(var i=0; sumPay<sumDog; i++)
			{
				sumPay += sumPart;
				if(sumPay > sumDog)
					sumPart -= (sumPay - sumDog);
				//else if((sumDog-sumPay) < sumPart)
				//	sumPart += (sumDog-sumPay);
				payDat = goMonth(dat1, i);
				var oDocRow = objDoc.createRow("ROW");
				oDocRow.setVar("RDATE", payDat);
				oDocRow.setVar("RSUM", sumPart);
				objDoc.appendRow("ROW", oDocRow);
				obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
			}
			HEDATPAY.value = payDat;
		}
	}
	else
	{
		if(sumPart<=0)
		{
			setFocus(HMONTHPAY);
			return;
		}
		if(differ(dat2, d00)!=-1)
		{
			setFocus(HEDATPAY);
			return;
		}
		var nMonth = month_difference(dat1, dat2);
		for(var i=0; i<nMonth; i++)
		{
			sumPay += sumPart;
			payDat = goMonth(dat1, i);
			var oDocRow = objDoc.createRow("ROW");
			oDocRow.setVar("RDATE", payDat);
			oDocRow.setVar("RSUM", sumPart);
			objDoc.appendRow("ROW", oDocRow);
			obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
		}
		HSUM.value = sumPay;
	}
	if(differ(HBDAT.value, d00)!=-1)
		HBDAT.value = HBDATPAY.value;
	if(differ(HEDAT.value, d00)!=-1)
		HEDAT.value = HEDATPAY.value;
	grid.getTable().requery();
	grid.refresh();
}

function HBDAT_Valid()
{
	if (isEmpty(HBDAT.getValue()))
	{
		WAIT(ru("Введите дату начала действия договора", "Введіть дату початку дії договору"));
		return false;
	}
	return true;
}
include("sys\\DpBaseDlg.js");