// JScript source code
include ("objects/DpXMLDomDocument.js")

function setDocRem(sDoc, sParent)
{
	var sDir = rootDirectory() + "docs/" + sDoc + "/";
	if (sParent)
		sDir = rootDirectory() + "docs/" + sParent + "/" + sDoc + "/";
	var classFile = sDir + "class.xml";
	trace("file = " + classFile);
	if (!isFile(classFile)) return;
	
	var xmlDom = new DpXMLDOMDocument();
	if (!xmlDom.load(classFile)) return;
	var oDoc = xmlDom.getDocumentElement();
	var vars = oDoc.getElementsByTagName("var");
	var sShabDoc = getDoc(sDoc, sParent);
	
	var isChange = false;
	for(var i = 0; i < vars.length; i++)
	{
		var oVar = vars[i];
		var sVar = String(oVar.getAttribute("name")).trim();
		var rem = String(oVar.getText());
		if (rem && rem != "null")
			continue;
		
		rem = getVarRem(sVar, sShabDoc)
		//alert(sVar + "\n" + rem)
		if (rem != "")
		{		
			isChange = true;
			oVar.setText(rem);
		}		
	}
	
	if (!sParent)
	{
		var fDir = new DpFile(sDir);
		var files = fDir.listFiles();
		for(var i = 0; i < files.length; i++) 
		{
			if (!files[i].isDirectory()) continue;
			
			setDocRem(String(files[i].getName()), sDoc);
			
		}
	} 
	if (isChange)
		xmlDom.save(classFile);
}

function getDoc(sDoc, sParent)
{
	if (sDoc == "NAKL" || sDoc == "NAKLROW")
		return "NK";
	
	if (sDoc == "CASDC")
		return "CP";	
		
	if (sDoc == "BNKDC")
		return "PP";
	
	if (sDoc == "UOSDC")
		return "O1";
		
	if (sParent)
		return sParent;
		
	return sDoc;	
}

function setAllDocRem()
{
	var sDir = rootDirectory() + "docs/"
	var fDir = new DpFile(sDir);
	var files = fDir.listFiles();
	for(var i = 0; i < files.length; i++) 
	{
		if (!files[i].isDirectory()) continue;			
		setDocRem(String(files[i].getName()));
			
	}
}


function getVarRem(sVar, sDoc)
{
	var sSQL = "select frem from ^vardoc where fdoc = " + sqlTo(sDoc) 
		+ " and fvar = " + sqlTo(sVar);
	trace(sSQL)	
	var oSnap = getSnap(sSQL);
	if (oSnap && oSnap[0])
		return String(oSnap[0]).trim();
	return ""; 
}