// JScript source code

include("Objects/DPXMLDomDocument.js");
var oXmlDom = new DpXMLDOMDocument();
var oXMLDoc = null;
var sGridFile = "";
var gridStruct = new DpGridStruct();
var ID = 0;
function listLoad()
{
	with( this )
	{
		title = "";
		editTask = "e_list.xml";
		printLabel = "LIST";
		//xmlGridFile = "l_clsch.xml";
	}
	
	if (!extPar || !extPar.gridfile) return false;
	sGridFile = extPar.gridfile; 
	if (!isFile(sGridFile)) return false;
	
	this.title = new DpFile(sGridFile).getName(); 
	
	sGridFile = extPar.gridfile;
	oXmlDom.load(sGridFile);
	oXMLDoc = oXmlDom.getDocumentElement(); 
	this.Tree_mnuHandler = Tree_mnuHandler;
	this.Tree_mnuInit = Tree_mnuInit;
	//this.onTreeSelected = onTreeSelected;
	
	this.treeDrop = treeDrop;
	this.treeDrag = treeDrag;
	Tree.setDropHandler(this, "treeDrop");
	Tree.setDragHandler(this, "treeDrag");
	
	Tree.selectMenuHandler(this, "Tree_mnuHandler");
	Tree.loadMenuHandler(this, "Tree_mnuInit");
	Tree.addItem("", "0", "grid");
	var ti = Tree.getItem("0");
	ti.setData("xml", oXMLDoc);
	ti.setData("type", "grid");
	ti.setData("parentxml", oXmlDom);
	buildTree()
	Tree.expandAll();
	
	this.save = onSave;
	this.escape = onEscape;
}

function onSave()
{
	oXmlDom.save(sGridFile);
	FORM.close();
}

function onEscape()
{
	FORM.close();	
}

function listGrid()
{
	grid.parseXML(oXMLDoc.xmlNode);
	//grid.setColorField("=grid_fsch()");
	//grid.setNOFixedCol(true); 
	grid._build();
}

function buildTree()
{
	var childs = oXMLDoc.getChildNodes();
	for(var i=0; i<childs.length; i++) 
	{
		var child = childs[i];
		var sNode = String(child.getNodeName());
		if (inList(sNode, "conditions", "bolds", "colors"))
			continue;
		if (sNode == "field")
		{
			var sFld = child.getAttribute("field");
			var sID = sFld + (ID++); 	
			var sFormat = child.getAttribute("format");
			var sWidth = child.getAttribute("width");
			var sText = child.getAttribute("text");
			Tree.addItem("0", sID, UR(sText), TREE_ITEM);
			var ti = Tree.getItem(sID);
			ti.setData("xml", child);
			ti.setData("type", "field");
			ti.setData("parentxml", oXMLDoc);
		}
		
		if (sNode == "page" || sNode == "prefix")
		{
			parseFields(child, "0")			
		}
		
		if (sNode == "group")
		{
			var sID = "GRP" + (ID++);
			var sText = child.getAttribute("text");
			Tree.addItem("0", sID, UR(sText));
			var ti = Tree.getItem(sID);
			ti.setData("xml", child);
			parseFields(child, sID)	
			ti.setData("type", "group");
			ti.setData("parentxml", oXMLDoc);		
		}
			
		
	}
}


function parseFields(par, sParId)
{
	var childs = par.getChildNodes();
	
	for(var i=0; i<childs.length; i++) 
	{
		
		var child = childs[i];
		var sNode = String(child.getNodeName());
		if (sNode == "field")
		{
			var sFld = child.getAttribute("field"); 
			var sID = sFld + (ID++); 		
			var sFormat = child.getAttribute("format");
			var sWidth = child.getAttribute("width");
			var sText = child.getAttribute("text");
			Tree.addItem(sParId, sID, UR(sText), TREE_ITEM);
			var ti = Tree.getItem(sID);
			ti.setData("type", "field");
			ti.setData("xml", child);
			ti.setData("parentxml", par);
		}
		
		if (sNode == "group")
		{
			var sID = "GRP" + (ID++);
			var sText = child.getAttribute("text");
			Tree.addItem(sParId, sID, UR(sText));
			var ti = Tree.getItem(sID);
			ti.setData("xml", child);
			ti.setData("parentxml", par);
			ti.setData("type", "group");
			parseFields(child, sID)				
		}		
			
		
	}
}

function listSrc()
{
	this.qrySet	(
					"From", "^CL_SCHET",					
				"Where", " 1<>1 ");
}

function Tree_mnuInit(toObject)
{
	var sID = String(Tree.getSelected());
	var curItem = Tree.getItem(sID);	
		
	if (sID == "0" || sID.startsWith("GRP"))
	{
		Tree.AddMenuItem("ADDGRP", "Додати групу|Добавить групу");	
		Tree.AddMenuItem("ADDFLD", "Додати поле|Добавить поле");
	}
	
	Tree.AddMenuItem("EDIT", "Властивостi|Свойства");
	if (sID != "0")
		Tree.AddMenuItem("DEL",  "Вилучити|Удалить");
	
	
}

function Tree_mnuHandler(sID,toObject)
{
	var curItem = Tree.getItem(Tree.getSelected());
	var sCurrId = Tree.getSelected();
	
	switch(sID)
	{
	case "ADDGRP":		
		var par = new Object();
		showWindow("gridgroup.xml", SW_MODAL, par)
		if (!par.escape)
		{
			var xml = curItem.getData("xml");
			var xmlGrp = oXmlDom.createElement("group");
			xmlGrp.setAttribute("text", par.text);
			xml.appendChild(xmlGrp);
			Tree.removeAllIn(sCurrId)
			if (sCurrId == "0")
				buildTree();
			else
				parseFields(xml, sCurrId)
				
			Tree.expand(sCurrId);
			refreshGridBLD();
			
		}
		break;
	case "ADDFLD":		
		var par = new Object();
		par.xmlEl = oXmlDom.createElement("field");
		showWindow("dpgridfldedit.xml", SW_MODAL, par)
		if (!par.escape)
		{
			var xml = curItem.getData("xml");
			xml.appendChild(par.xmlEl);
			Tree.removeAllIn(sCurrId)
			if (sCurrId == "0")
				buildTree();
			else
				parseFields(xml, sCurrId)
				
			Tree.expand(sCurrId);
			refreshGridBLD();
			
		}			
		break;
	
	case "EDIT":
	case "DOUBLECLICK":
		var xml = curItem.getData("xml");
		var type = curItem.getData("type");
		if (type == "group")
		{
			var par = new Object();
			par.text = xml.getAttribute("text");
			showWindow("gridgroup.xml", SW_MODAL, par)
			if (!par.escape)
			{
				xml.xmlNode.setAttribute("text",par.text);
				curItem.setText(UR(par.text));
				refreshGridBLD();			
			}
			
		}
		
		if (type == "field")
		{
			var par = new Object();
			par.xmlEl = xml;
			showWindow("dpgridfldedit.xml", SW_MODAL, par)
			if (!par.escape)
			{
				curItem.setText(UR(xml.getAttribute("text")));
				refreshGridBLD();			
			}
		}
		
		if (type == "grid")
		{
			var par = new Object();
			par.xmlEl = xml;
			showWindow("dpgridpropedt.xml", SW_MODAL, par);			
		}
		
		break;
		
		break;
	case "DEL":
		var curItem = Tree.getItem(Tree.getSelected());
		var xml = curItem.getData("xml");
		var parxml = curItem.getData("parentxml");
		
		if (!confirm(ru("Удалить", "Вилучити")  + "?")) return;
		
		Tree.removeItem(Tree.getSelected());
		parxml.removeChild(xml);
		refreshGridBLD();		
		break;
	
	}
}

function treeDrag(sFunc, obj)
{
	//Packages.org.eclipse.swt.dnd.DND.DROP_COPY
	if (sFunc == "dragSetData")
	{
		var curItem = Tree.getSelected();
		obj.data = curItem;
	}	
}

function treeDrop(sFunc, obj)
{
	if (!obj.item) 
	{
		return;
	}

	var sID = obj.item? String(obj.item.getData()): "";
	var curItem = Tree.getItem(sID);
	
	//var dragItem = Tree.getItem(obj.data);
	
	if (sFunc == "dragEnter")
	{
		return;
	}
	
	trace(sFunc);
	
	if (sFunc == "drop")
	{
		var xml = obj.item.getData("xml")
		var itemFrom = Tree.getItem(obj.data);
		var xmlFrom = itemFrom.getData("xml")
		var xmlNew = xmlFrom.cloneNode(true);
		var xmlParFrom = itemFrom.getData("parentxml");
		
		if (obj.item.getData("type") == "group" || obj.item.getData("type") == "grid")
		{
			xml.appendChild(xmlNew);			
		}
		else
		{
			var xmlParTo = obj.item.getData("parentxml");
			xmlParTo.insertBefore(xmlNew, xml);
		}
		xmlParFrom.removeChild(xmlFrom);		
		Tree.removeAllIn("0")
		buildTree();
	    Tree.expandAll();
	    refreshGridBLD();
	}
	
	if (sFunc = "dragOver")
	{
		if (!obj.item)
		{
			obj.detail = 0;
			return;
		}
		
		obj.detail = 1;		
		return;
	}
		
}
function refreshGridBLD()
{
	grid.DeletePages();
	list.init();	
}

function filterMode(s)
{
	return true;		
}

function DpGridStruct()
{
	this.conditions = new Array();
	this.colors = new Array();
	this.bolds = new Array();
	this.fields = new Array();	
}

function DpGridField()
{
	this.text = "";
	this.isGroup = false;
	this.field = "";
	this.format = "";
	this.attr = "";
	this.rowspan = "";
}

function DpGridGroup()
{
	this.fields = new Array();
	this.text = "";
	this.isGroup = true;
}

include("sys\\DpList.js");