include("sys/mask.js");
include("gridedit.js");

var mode;

var condMap = new Array();
var colorMap = new Array();
var boldMap = new Array();
var xmlEl = extPar.xmlEl; 

function Load()
{
	Caption(ru("Свойства", "Властивостi"));
	mode = extPar.mode;
	this.tbl = createObjectTable();
	this.tbl.setIdFld("FWID"); 
	
	var cond = xmlEl.getElementsByTagName("conditions");
	
	if (cond.length != 0)
	{		
		var conds = cond[0].getElementsByTagName("condition");
		if (conds.length == 0) return;
		
		for (var i=0; i < conds.length; i++) 
		{
			var ID = conds[i].getAttribute("ID");
			var sCond = conds[i].getText();
			if (ID)
				condMap[ID] = sCond;				
		}
		
		var colors = xmlEl.getElementsByTagName("color");
		for(var i=0; i<colors.length; i++) 
		{
				var sCondID = colors[i].getAttribute("cond");
				var nColor = colors[i].getText();
				if (condMap[sCondID])
				{
					colorMap[sCondID] = nColor;
				}
						
		}
		
		var bolds = xmlEl.getElementsByTagName("bold");
		
		for(var i=0; i < bolds.length; i++) 
		{
				var sCondID = bolds[i].getText();
				if (condMap[sCondID])
					boldMap[sCondID] = true;
		}
		
		
		for (var ID in condMap)
		{
			this.tbl.AddNew();
			var sExpr = condMap[ID];
			this.tbl.setValue("FWID", ID);
			this.tbl.setValue("EXPR", sExpr);
			
			if (colorMap[ID])
			{
				this.tbl.setValue("COLOR", colorMap[ID]);
			}
			
			if (boldMap[ID])
			{
				this.tbl.setValue("BOLD", true);
			}
			else
			{
				this.tbl.setValue("BOLD", false);
			}
			
			this.tbl.Update(); 
		}
	}
	
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.init = addRecord;
	
	grid.setXMLFile("dpgridpropgrd.xml");
	grid.setTable(this.tbl);
	grid._build();
	
}

function addRecord()
{
	this.initValue("FWID", "NEWID");
	this.initValue("EXPR", "");
	this.initValue("COLOR", "");
	this.initValue("BOLD", false);
}

function onSave()
{
	var xmlDom = xmlEl.getOwnerDocument();
	var xmlConds = xmlDom.createElement("conditions");
	var xmlColors = xmlDom.createElement("colors");
	var xmlBolds = xmlDom.createElement("bolds");
	
	this.tbl.moveFirst();
	while(!this.tbl.isEOF())
	{
		var sID = String(this.tbl.getValue("FWID"));
		var sExpr = String(this.tbl.getValue("EXPR"));
		var xmlCond = xmlDom.createElement("condition");
		xmlCond.setAttribute("ID", sID);		
		xmlCond.setText(sExpr);
		xmlConds.appendChild(xmlCond);
		
		var sColor = allt(String(this.tbl.getValue("COLOR")));
		
		if (sColor)
		{
			var xmlColor = xmlDom.createElement("color");
			xmlColor.setAttribute("cond", sID);		
			xmlColor.setText(sColor);
			xmlColors.appendChild(xmlColor);
			
		}
		
		var isBold = this.tbl.getValue("BOLD");
		
		if (isBold == true)
		{
			var xmlBold = xmlDom.createElement("bold");					
			xmlBold.setText(sID);
			xmlBolds.appendChild(xmlBold);
		}
		
		this.tbl.MoveNext();
	}
	
	var xmlDel = xmlEl.getElementsByTagName("conditions");
	if (xmlDel.length > 0)
	{
		xmlEl.removeChild(xmlDel[0]);
	}
	
	var xmlDel = xmlEl.getElementsByTagName("colors");
	if (xmlDel.length > 0)
	{
		xmlEl.removeChild(xmlDel[0]);
	}
	
	var xmlDel = xmlEl.getElementsByTagName("bolds");
	if (xmlDel.length > 0)
	{
		xmlEl.removeChild(xmlDel[0]);
	}	
	
	xmlEl.appendChild(xmlConds);
	xmlEl.appendChild(xmlColors);
	xmlEl.appendChild(xmlBolds);
			
}