include("servis/format.js");
include("servis/dump.js");

var sTxt = UR("Архівація даних|Архивация данных");
var sBatFile = dumpDir() + "export.bat";		//батник можно создать для MySQL и ORACLE
var sDumpDir = dumpDir();					//путь для сохранения архивов
var sDumpName;								//имя архива базы данных
var fileEdit = false;						//если =true (при срабатывании валидности) можно использовать любое имя архива
var running = false;						//при автоматической архивации =true и окно диалога не открывается
var tblTask;								//таблица с текущими задачами
var taskManager;
var isTask = false;
var sTaskDir = getUserDirectory() +"tasks/";
var statusTask = Number(getValueFromClass("com.debet.TaskManager.DpTaskDistributor", "CURRENT"));
var sAllBaseTxt = UR("усі|все");
var oThread = null;
var startTime;
var sOrgZip = null;
var sJDebetZip = null;
var oExec = null;
var sError = "";
var sInfo = "";

//в параметрах можно передать: login,password,base,path,packOrg,packJdebet
//  login - имя пользователя (администратор СУБД)
//  password - пароль
//  base - база (например dpbase), по умолчанию берется из настройки соединения =getPath("ALL_MDB")
//  path - путь для сохранения архивов, по умолчанию /DebetPlusV12/dump/
// 	packOrg - если =true будет создан архив с настройками организации
//	packJdebet - если =true будет создан архив со скриптами
//!!! если передается хотя бы логин архивация выполняется автоматом и окно диалога не открывается !!!

runDump();
function runDump()
{
	try
	{
		var oPar = GetMenuMode();
		if(!oPar)
			return;
			
		oPar = oPar.split(",");
		
		if(!oPar[0] || oPar[0]=="" || oPar[0]=="login")
			return;
		
		var sLogin = oPar[0];
		var sPassword = oPar[1];
		var sBase = oPar[2];	
		var sPath = oPar[3];
			
		//архивация базы данных
		running = runDBExport(sLogin, sPassword, sBase, null, sPath, sDumpName);
				
		//архивация настроек организации
		if(oPar[4]==true || oPar[4]=="true")
			packOrg(sPath);
			
		//архивация скриптов
		if(oPar[5]==true || oPar[5]=="true")
			packJdebet(sPath);
	}
	catch(e)
	{
		trace("ERROR - runDump: "+ e); 
	}	
}

function onLoad()
{
	if(running)
		return false;
		
	FORM.setImage(rootDirectoryEx() +"/icons/disk_blue.gif");
	
	Caption(sTxt);
		
	fillDBCombo(FBASE);
			
	FLOGIN.value = getDBUserName();
	DJDEBET.setValue(rootDirectoryEx());
	DORG.setValue(getOrgPath());
	DIR.value = DpFile(dumpDir()).getAbsolutePath();
	FBAT.value = DpFile(sBatFile).getAbsolutePath();
	CBASE.checked = true;
	
	var host = getHostName();
	var comp = lpProxy.getOrgManager().getComp();
	var server = lpProxy.getOrgManager().getServer();
	
	Disable(FCONSOLE);	
	Disable(DJDEBET);
	Disable(DORG);
	Disable(FBAT);
	
	//для DERBY создается архив с каталогом, содержащим базу
	//поля для логина и пароля можно не заполнять
	//путь к базе берется из настроек соединения (=сервер)
	if(SUBD==DERBY || SUBD==H2)
	{
		GBASE.setVisible(false);
		GDERBY.setVisible(true);
		//если путь к базе совпадает с путем настроек организации, отключаем архивацию настроек чтобы не архивировать повторно один каталог
		var sOrgPath = DpFile(getOrgPath()).getAbsolutePath();
		var sBaseDir = DpFile(lpProxy.getOrgManager().getServer()).getAbsolutePath();
		if(String(sBaseDir)==String(sOrgPath) && SUBD==DERBY)
		{
			FORG.checked = false;
			Disable(FORG);
		}		
		CBASE = CBASE_DERBY;
		FBASE_DERBY.value = sOrgPath;
		Disable(FBASE_DERBY);
	}
	
	//Disable(BAT);
	if(isWin() && (SUBD==MYSQL || SUBD==ORACLE))
		GRBAT.setVisible(true);
	else
		GRBAT.setVisible(false);
	
	if(SUBD==MSSQL)
	{
		Disable(FTABLES);
		var par = getPar("MYSQL_SERVER_PATH");
		if(!par && server!=host && server!="localhost")
			GSETTINGS.setVisible(false);
	}
			
	if(SUBD==ORACLE && comp!=host)
		GSETTINGS.setVisible(false);
	if(SUBD==MSSQL && server!=host)
		GSETTINGS.setVisible(false);
		
	this.selectTables = selectTables;
	
	if(typeof(btnOK)!="undefined")
		btnOK.setText(UR("Виконати|Выполнить"));
	if(typeof(btnCancel)!="undefined")
		btnCancel.setText(UR("Вийти|Выйти"));
	
	//setButton(RUNTASK, startTaskManager);
	setButton(FTABLES, this, "selectTables");
	setButton(BBASE, selectBases);
	
	setValid(FORG, org_valid);
	setValid(FJDEBET, jdebet_valid);
	setValid(BAT, bat_valid);
	setValid(FILE, file_valid);
	setValid(FBASE, base_valid);
	setValid(CBASE, base_valid);
	
	loadParam();	
	base_valid();
	
	if(!DpFile(sTaskDir).isDirectory())
		createDirectory(sTaskDir);
	taskManager = lpProxy.getTaskManager();	
	loadTaskGrid();
	
	loadHistoryGrid();
	FORM.Refresh();
}

var tmpTblBases = "TMP_DUMP_BASES";

function selectBases()
{
	ExecuteSQL("drop table "+ tmpTblBases, false);
	var sSQL = "CREATE TABLE " + tmpTblBases +"("
					+ " FWID "+ SqlType("LONG")
					+ ",FNAME"+ SqlType("TEXT",254)
				+ ")";
	ExecuteSQL(sSQL);
	
	var batch = createBatch();
	var arrBase = lpProxy.getDBManager().getDatabases();
	for (var nB = 0; nB < arrBase.length; nB++)
	{
		var sBase = String(arrBase[nB]).toLowerCase();
		var insSQL = "INSERT INTO "+ tmpTblBases
				   	+ " VALUES ("
				   		+ sqlTo(nB+1)
				   		+ "," + sqlTo(sBase)
				   	+ ")";
		batch.addBatch(insSQL);
	}	
	batch.execute(false);
	
	var par = new Object();
	par.ret = new Object();
	par.ret.FNAME = "";
	
	par.cells = new Object();
	par.cells[1] = new Object();
	par.cells[1].name = "FNAME";
	par.cells[1].width = 15;
	par.cells[1].text = UR("Назва|Название");
	
	var title = UR("Схеми|Схемы");
	var tbl = OpenTable("select * from "+ tmpTblBases +" order by FNAME");
	par = selection(tbl, title, par);
	tbl.close();	
	if(par.escape)
		return;
	
	FBASE.value = "  ";
	
	if(par.retArray && par.retArray.length>0)
	{
		for(var i=0; i<par.retArray.length; i++)
		{
			var oRet = par.retArray[i];
			if(oRet && oRet.FNAME)
				insertBaseName(oRet.FNAME)
		}
		return;
	}
	
	if(par.ret && par.ret.FNAME)
		insertBaseName(par.ret.FNAME);
}

function insertBaseName(sName)
{
	var sBase = String(FBASE.value).trim();
	if(sBase && sBase!="")
		sBase += ", ";
	FBASE.value = sBase + sName;
}

var tmpTblDump = "TMP_DUMP_TABLES";

function selectTables()
{
	if(!IsTable(tmpTblDump))
	{
		var sSQL = "CREATE TABLE " + tmpTblDump
				 + "("
				 	+ " FWID "+ SqlType("LONG")
				 	+ ",FNAME"+ SqlType("TEXT",254)
				 + ")";
		ExecuteSQL(sSQL);
		fillTables(FBASE.value);		
	}	
	
	var par = new Object();
	par.ret = new Object();
	par.ret.FNAME = "";
	
	par.cells = new Object();
	par.cells[1] = new Object();
	par.cells[1].name = "FNAME";
	par.cells[1].width = 15;
	par.cells[1].text = UR("Таблиця|Таблица");
	
	var title = UR("Вибір таблиць|Выбор таблиц");
	var tbl = OpenTable("select * from "+ tmpTblDump +" order by FNAME");
	par = selection(tbl, title, par);
	tbl.close();	
	if(par.escape)
		return;
	
	if(par.retArray && par.retArray.length>0)
	{
		for(var i=0; i<par.retArray.length; i++)
		{
			var oRet = par.retArray[i];
			if(oRet && oRet.FNAME)
				insertTalbeName(oRet.FNAME)
		}
		return;
	}
	
	if(par.ret && par.ret.FNAME)
		insertTalbeName(par.ret.FNAME);
}

function insertTalbeName(sName)
{
	var sTbl = String(FTABLES.value).trim();
	if(sTbl)
		sTbl += ", ";
	if(SUBD==ORACLE)
		FTABLES.value = sTbl + FBASE.value +"."+ sName;
	else
		FTABLES.value = sTbl + sName;
}

function fillTables(sBase)
{
	ExecuteSQL("DELETE FROM "+ tmpTblDump, false);
	if (sBase == null || sBase == "")
		sBase = getPath("ALL_MDB");
	var tblArr = lpProxy.getDBManager().getTables(sBase, "TABLE");
	var batch = createBatch();
	for (var nTbl = 0; nTbl < tblArr.length; nTbl++)
	{
		var insSQL = "INSERT INTO "+ tmpTblDump
				   	+ " VALUES ("
				   		+ sqlTo(nTbl)
				   		+ "," + sqlTo(tblArr[nTbl])
				   	+ ")";
		batch.addBatch(insSQL);
	}
	batch.execute(false);
}

function loadParam()
{
	CHECK_DUMP.value = getPar("CHECK_DUMP")==true;
	var par = getPar("RUN_DUMP_ONCONNECT");
	RUN_DUMP_ONCONNECT.value = (par==true || par=="true");
	
	var sTbl = dumpTblName(FBASE.value);
	var oSnap = getSnap("select FLOGIN,FPASSWORD,FBASE,FPATH"
						+" from "+ sTbl	
						+" where FEXPORT="+ sqlTrue					
						+" order by FDATE desc"
						, false
					);
	if(!oSnap)
	{
		if(SUBD==MYSQL)
			FLOGIN.value = "root";
		return false;
	}
	
	if(oSnap[0])
		FLOGIN.value = oSnap[0];
	//if(oSnap[1])
	//	FPASSWORD.value = oSnap[1];
	//if(oSnap[2])
	//	FBASE.value = oSnap[2];
	if(oSnap[3] && isDir(oSnap[3]))
		DIR.value = oSnap[3];
				
	jdebet_valid();
	org_valid();
}

function onSave()
{	
	sBatFile = null;
	if(BAT.checked==true)
		sBatFile = FBAT.value;
	
	if(isWin())
	{
		if(SUBD==POSTGRE)
		{
			var pgPath = postgreSQLPath();
			if(!pgPath || !isDir(pgPath))
			{
				var sMsg = UR(" Для архівації в Postgre необхідно вказати шлях до системної папки PostgreSQL,"
								+"\n наприклад \"C:\\Program Files\\PostgreSQL\\9.0\""
							+"| Для архивации в Postgre необходимо указать путь к системной папке PostgreSQL,"
								+"\n например \"C:\\Program Files\\PostgreSQL\\9.0\""
							);
				pgPath = askDirectory(null, sMsg, UR("Вкажіть шлях до папки PostgreSQL|Укажите путь к папке PostgreSQL"));
				if(!pgPath)
					return false;
				setPar("POSTGRESQL_PATH", pgPath);
			}
			var pgDump = pgPath +"/bin/pg_dump.exe";
			//if(!isFile(pgDump))
			//	return false;
		}
		if(SUBD==MYSQL)
		{
			//для MySQL нужен mysqldump.exe 
			var sExeDir = exeDir();
			var mySqlExe = "mysqldump.exe";
			if(sBatFile)
			{
				sExeDir = DpFile(sBatFile).getParent();
				mySqlExe = sExeDir +"/"+ mySqlExe;
			}		
			else
			{
				mySqlExe = sExeDir + mySqlExe;
			}
			
			if(!isFile(mySqlExe))
			{
				var mySqlPath = String(getPar("MYSQL_SERVER_PATH")).trim();
				if(!mySqlPath || mySqlPath=="" || !isFile(mySqlPath +"/bin/mysqldump.exe"))
				{
					var sMsg = UR(" Для архівації в MySQL необхідно вказати шлях до MySQL Server,"
									+"\n наприклад \"C:\\Program Files\\MySQL\\MySQL Server 5.0\""
								+"| Для архивации в MySQL необходимо указать путь к MySQL Server,"
									+"\n например \"C:\\Program Files\\MySQL\\MySQL Server 5.0\""
								);
					mySqlPath = askDirectory(null, sMsg, UR("Вкажіть шлях до MySQL Server|Укажите путь к MySQL Server"));
					if(!mySqlPath)
					{
						var sMsg = UR("	Для архівації в MySQL необхідний файл "+ mySqlExe +"."
									+"\nЙого можна знайти у каталозі \\Program Files\\MySQL\\MySQL Server 5.0\\bin"
									+"\nі скопіювати у папку "+ sExeDir +"." 
									+"\n	Якщо Дебет запускається з ярлика на робочому столі,"
									+"\nпотрібно у властивостях ярлика для робочої папки прописати шлях "+ exeDir()
									+"\nі перезапустити Дебет."
									+"\n	Якщо не вдається знайти папку MySQL Server 5.0, значить потрібно установити MySQL."
									+"\n	Продовжити архівацію?"
								+"|	Для архивации в MySQL необходим файл "+ mySqlExe +"."
									+"\nЕго можно найти в каталоге \\Program Files\\MySQL\\MySQL Server 5.0\\bin"
									+"\nи скопировать в папку "+ sExeDir +"." 
									+"\n	Если Дебет запускается с ярлыка на рабочем столе,"
									+"\nнужно в свойствах ярлыка для рабочей папки прописать путь "+ exeDir()
									+"\nи перезапустить Дебет."
									+"\n	Если не удается найти папку MySQL Server 5.0, значит нужно установить MySQL."
									+"\n	Продолжить архивацию?"
								);
						if(!confirm(sMsg))
							return false;
					}
					setPar("MYSQL_SERVER_PATH", mySqlPath);
				}			
			}
		}
	}	
	
	if(!checkDBConnection(FLOGIN.value, FPASSWORD.value))
	{
		alert(UR("Перевірте логін і пароль.|Проверте логин и пароль."));
		setFocus(FLOGIN);
		return false;
	}
	
	
	if(oThread)
		oThread.stop();
	
	startTime = new Date();	
	
	var sBase = String(FBASE.value).replace(sAllBaseTxt, "").trim();
	var sTables = String(FTABLES.value).trim();
	var sServer = lpProxy.getOrgManager().getServer();
	if(SUBD==POSTGRE)
		sServer = lpProxy.getOrgManager().getComp();
					
	var sDir = DIR.value;
	if(!sDir || sDir=="")
		sDir = dumpDir();
		
	sDumpName = FILE.value;
	if(!sDumpName || sDumpName=="")
		sDumpName = dumpName(sBase);
	
	
	INFO.setText(sTxt +" . . .");	
	WAIT(sTxt);
		
	sInfo = FCONSOLE.value;
	divider = "----------------------------------------------------";
	if(sInfo!="")
		sInfo += "\r\n\r\n";
	sInfo += "\r\n"+ divider +" "+ format("dd.mm.yyyy   HH:MM", startTime) +" "+ divider;
	sInfo += "\r\n"+ sTxt;
	if(CBASE.checked==true)
	{
		if(sServer!="")
			sInfo += "\r\n"+ UR("Сервер|Сервер") +" \t\t"+ sServer;
		if(sBase!="")
			sInfo += "\r\n"+ UR("Схема|Схема") +" \t\t"+ sBase;
		if(sTables!="")
			sInfo += "\r\n"+ UR("Таблиці|Таблицы") +" \t\t"+ sTables;			
	}
	
	if(FORG.checked==true)
		sInfo += "\r\n"+ UR("Налагодження|Настройки") +"\t"+ DORG.value;
	
	if(FJDEBET.checked==true)
		sInfo += "\r\n"+ UR("JDebet|JDebet") +" \t\t"+ DJDEBET.value;
	
	sInfo += "\r\n";
	
	FTAB.setSelection(1);
	
	FCONSOLE.value = sInfo;
	setFocus(FCONSOLE);
	FCONSOLE.getCtrl().setSelection(sInfo.length);
	saveExportLog(sInfo);
	
	sOrgZip = null;	
	if(FORG.checked==true)
		sOrgZip = packOrg(sDir, null, DORG.value);			
	
	sJDebetZip = null;
	if(FJDEBET.checked==true)
		sJDebetZip = packJdebet(sDir, null, DJDEBET.value);		
	
	oExec = null;
	if(CBASE.checked==true)
		oExec = runDBExport(FLOGIN.value, FPASSWORD.value, sBase, sTables, sDir, sDumpName, sBatFile);
	
	oThread = runInThread(waitDump, oExec);
	if(oExec)
		runInThread(readExec, oExec);		
	//if(isTask)
	//	startTaskManager();
	loadHistory();
	
	if(typeof(btnOK)!="undefined")
		Enable(btnOK, false);
	if(typeof(btnCancel)!="undefined")
		Enable(btnCancel, false);
	
	return false;
}

function readExec()
{	
	try
	{		
		sError = getErrors();
		oExec.waitFor();
		oExec = null;
	}
	catch(e)
	{
		
	}
}

function waitDump()
{		
	var sMsg = UR("Виконується архівація|Выполняется архивация");	
	var stt = "";
	var run = true;	
	while(run)
	{		
		display.asyncExec
		(
			function runWait()
			{						
				try
				{		
					run = false;
					var sDumpFile = getDumpFile();
					
					if(SUBD==MYSQL || SUBD==ORACLE)
					{
						if(oExec && !isExit(oExec))
							run = true;
					}
					if(SUBD==DERBY || SUBD==MSSQL)
					{
						if(oExec && !isFile(sDumpFile))
							run = true;
					}
					
					if(sOrgZip && !isFile(sOrgZip))
						run = true;
					
					if(sJDebetZip && !isFile(sJDebetZip))
						run = true;

					var time = new Date(new Date()-startTime);	
					var stt = ": "+ format("00:MM:SS", time);
					//stt = (stt.length>5? "" : stt +" .");					
					INFO.setText(sMsg + stt);
					WAIT(sMsg + stt);				
				}
				catch(e)
				{
					trace(e)
				}				
			}
		);
				
		oThread.sleep(500);		
	}
	
	display.asyncExec
	(
		function end()
		{
			try
			{
				stopDump();
			}
			catch(e)
			{
				
			}			
		}
	);	
}

function onEscape()
{
	onStop();
	saveParam();
	
	if(grid.getTable())
		grid.getTable().close();
	if(grid_history.getTable())
		grid_history.getTable().close();
}

function saveParam()
{
	setPar("CHECK_DUMP", CHECK_DUMP.value==true);
	setPar("RUN_DUMP_ONCONNECT", RUN_DUMP_ONCONNECT.value==true);
}

function onStop()
{
	try
	{
		if(oExec)
		{
			sError = getErrors();
			oExec.destroy();
			oExec = null;			
		}
		if(sError)
			printInfo(sError);		
		
		if(oThread)
			oThread.stop();		
		oThread = null;
		
		INFO.setText("");
		CLEARWAIT();
	}
	catch(e)
	{
		
	}
}

function stopDump()
{	
	try
	{		
		onStop();
		
		var sMsg = resultMsg();
		sInfo = FCONSOLE.value +"\r\n"+ sMsg;	
				
		var time = new Date(new Date()-startTime);	
		var sTime = format("00:MM:SS", time);
		sInfo += "\r\n"+ UR("Час виконання: |Время выполнения: ") + sTime;
		sInfo += "\r\n"+ divider +" "+ format("dd.mm.yyyy   HH:MM", new Date()) +" "+ divider +"\r\n";
		
		FCONSOLE.value = sInfo;
		FCONSOLE.getCtrl().setSelection(sInfo.length);
		
		saveExportLog(sInfo);		
				
		alert(sMsg);
		
		if(typeof(btnOK)!="undefined")
			Enable(btnOK);
		if(typeof(btnCancel)!="undefined")
			Enable(btnCancel);		
	}
	catch(e)
	{
		
	}
}

function getErrors()
{
	if(oExec)
	{
		var charset = "cp1251";
		if(SUBD==MYSQL)
			charset = "cp866";			
		return getExecError(oExec, charset);			
	}
	return "";
}

function resultMsg()
{
	try
	{
		var sMsg = UR("Архівацію завершено.|Архивация завершена.");
		if(CBASE.checked==true)
		{
			var sDumpFile = getDumpFile();
			if(isFile(sDumpFile))
			{
				var file = DpFile(sDumpFile);
				var size = round(file.length()/1000000, 3);
				sMsg += "\r\n"+ UR("Архів|Архив") +":   \t\t"+ sDumpFile +" \t"+ size +" MB";				
			}
			else
			{
				sMsg += "\r\n"+ UR("Архів|Архив") +":   \t\t???";
			} 
		}
		
		if(sOrgZip)
		{
			if(isFile(sOrgZip))
			{
				var file = DpFile(sOrgZip);
				var size = round(file.length()/1000000, 2);
				sMsg += "\r\n"+ UR("Налагодження|Настройки") +": \t"+ sOrgZip +" \t"+ size +" MB";
			}
			else
			{
				sMsg += "\r\n"+ UR("Налагодження|Настройки") +": \t???";
			}			
		}
		
		if(sJDebetZip)
		{
			if(isFile(sJDebetZip))
			{
				var file = DpFile(sJDebetZip);
				var size = round(file.length()/1000000, 2);
				sMsg += "\r\nJDebet:  \t\t"+ sJDebetZip +" \t"+ size +" MB";
			}
			else
			{
				sMsg += "\r\nJDebet:  \t\t???";
			}
		}
		return sMsg;
	}
	catch(e)
	{
		
	}
}

function printInfo(sError)
{
	if(!sError)
		return;
	try
	{					
		trace(sError);
		sInfo = FCONSOLE.value;
		sInfo += "\r\n"+ sError;
		FCONSOLE.value = sInfo;
		FCONSOLE.getCtrl().setSelection(sInfo.length);
		saveExportLog(FCONSOLE.value);
	}
	catch(e)
	{
		
	}	
}

function isExit(oExec)
{
	try
	{
		var exitVal = oExec.exitValue();
		//return exitVal==1;
		return true;
	}
	catch(e)
	{
		return false;
	}
}

function bat_valid()
{
	Disable(FBAT);
	if(BAT.checked==true)
		Enable(FBAT);
}

function org_valid()
{
	Disable(DORG);
	if(FORG.checked==true)
		Enable(DORG);
}

function jdebet_valid()
{
	Disable(DJDEBET);
	if(FJDEBET.checked==true)
		Enable(DJDEBET);
}

function file_valid()
{
	fileEdit = true;
}

function base_valid()
{
	loadHistory();
	
	if(SUBD==DERBY)
		return true;
		
	var sBase = String(FBASE.value).replace(sAllBaseTxt, "").trim();
	sBase = java.lang.String(sBase).replaceAll(",", "_");
	sBase = java.lang.String(sBase).replaceAll(" ", "_");
	if(CBASE.checked==true)
	{
		Enable(FILE);
		Enable(FBASE);
		Enable(BBASE);		
		if(SUBD!=MSSQL && sBase)
		{
			Enable(FTABLES);
		}
		else
		{
			FTABLES.value = "";
			Enable(FTABLES, false);			
		}		
	}
	else
	{
		Enable(FBASE, false);
		Enable(BBASE, false);
		Enable(FTABLES, false);
		Enable(FILE, false);
		return;
	}
	
	ExecuteSQL("drop table "+ tmpTblDump, false);
	
	if(fileEdit && FILE.value!=null && FILE.value!="")
		return;
	FILE.value = dumpName(sBase);	
}

function fillDBCombo(oCtrl)
{
	if(SUBD==MYSQL || SUBD==ORACLE)
		oCtrl.addItem("", sAllBaseTxt);
	var arrBase = lpProxy.getDBManager().getDatabases();
	for (var nB = 0; nB < arrBase.length; nB++)
	{
		var sBase = String(arrBase[nB]).toLowerCase();
		oCtrl.addItem(sBase, arrBase[nB]);
	}
	oCtrl.value = String(getPath("ALL_MDB")).toLowerCase();
}


//история архивации
function loadHistory()
{
	try
	{
		var sBase = String(FBASE.value).replace(sAllBaseTxt, "").trim();
		if(sBase.indexOf(",")!=-1 || sBase.indexOf(" ")!=-1)
			sBase = getPath("ALL_MDB");
		var sTbl = dumpTblName(sBase);
		if(!lpProxy.getDBManager().testSQL("select FDATE from "+ sTbl +" where 1<>1"))
			return false;
		var tbl = OpenTable("select * from "+ sTbl 
						+" where FEXPORT="+ sqlTrue
						+" order by FDATE desc"
						);
		grid_history.setTable(tbl);
		grid_history.refresh();
		return true;
	}
	catch(e)
	{
		return false;
	}
}

function loadHistoryGrid()
{
	try
	{
		if(!loadHistory())
			return;
			
		grid_history.FieldEx("FDATE", "Дата|Дата", 12);
		grid_history.FieldEx("FTIME", "Час|Время", 8);
		grid_history.FieldEx("FBASE", "Схема|Схема", 10);
		grid_history.FieldEx("FPATH", "Шлях|Путь", 15);
		grid_history.FieldEx("FARCH", "Архів|Архив", 15);	
		grid_history.FieldEx("FUSER", "USER|USER", 10);
		grid_history.FieldEx("FHOST", "HOST|HOST", 8);
		
		grid_history.build();
		
		this.gridHistoryMenuInit = gridHistoryMenuInit;
		this.gridHistoryMenuRun = gridHistoryMenuRun;
		grid_history.loadMenuHandler(this, "gridHistoryMenuInit");
		grid_history.selectMenuHandler(this, "gridHistoryMenuRun");
	}
	catch(e)
	{
		
	}
}

function gridHistoryMenuInit()
{
	if(grid_history.getTable().isEmpty())
		return;
	if(IsDblClick(grid_history))
	{
		gridHistoryMenuRun("REDUMP");
		return true;
	}
	grid_history.AddMenuItem("REDUMP", "Повторити|Повторить");
	grid_history.AddMenuItem("CLEAR", "Очистити історію|Очистить историю");
}

function gridHistoryMenuRun(sID)
{
	var tbl = grid_history.getTable();
	var sTblName = tbl.getTableName();
	if(sID=="REDUMP")
	{
		FBASE.value = tbl.getValue("FBASE");
		DIR.value = tbl.getValue("FPATH");
		if(FPASSWORD.value=="")
			setFocus(FPASSWORD);
	}
	else if(sID=="CLEAR")
	{
		var sMsg = UR("Очистити історію архівації?|Очистить историю архивации?");
		if(!confirm(sMsg))
			return;
		sMsg = UR("Уведіть пароль для доступу до налаштувань|Введите пароль для доступа к настройкам");
		var pass = checkPassword(sMsg);
		if(!pass || String(pass).trim()!="150301")
			return;
		ExecuteSQL("delete from "+ sTblName +" where FEXPORT="+ sqlTrue);
		tbl.requery();
		grid_history.refresh();
	}
}


//-------- Мэнеджер задач для расписания --------
//package com.debet.TaskManeger: class DpTaskDistributor

function startTaskManager()
{
	lpProxy.startTaskManager();
}

function loadTaskGrid()
{	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid.loadMenuHandler(this, "gridMenuInit");
	grid.selectMenuHandler(this, "gridMenuRun");
	
	tblTask = loadTaskTable();
	//grid.setXMLFile("l_tasker.xml");
	grid.FieldEx("FBDAT", "Дата|Дата", 12);
	grid.FieldEx("FTIME", "Час|Время", 8);
	grid.FieldEx("FNAME", "Назва|Название", 10);
	grid.FieldEx("FREPIT", "Повтор|Повтор", 6);
	grid.FieldEx("FPERIOD", "Період|Период", 8);
	grid.setTable(tblTask);
	grid.build();
}

//создается таблица с расписанием и заполняется текущими задачами из папки /tasks/
function loadTaskTable()
{	
	var tbl = createObjectTable();
	if(!taskManager)
		return tbl;	
	var listTask = taskManager.getTasks(statusTask);
	var arrKey = listTask.keySet().toArray();
	for (var i = 0; i < arrKey.length; i++)
	{			
		var tasks = listTask.get(arrKey[i]);
		for (var j = 0; j < tasks.size(); j++)
		{
			var task = tasks.get(j);			
			insertRecord(task, tbl);			
		}
	}
	return tbl;
}

function insertRecord(task, tbl)
{
	if(!taskManager)
		return false;
	var bdat = taskManager.getLocalTaskManager().getActualExecTime(task);
	var sName = task.getName();
	var sCommand = String(task.getTaskContent().getCommand());
	if(!sCommand || sCommand.toLowerCase().indexOf("dump")==-1)
		return false;
	tbl.AddNew();
	tbl.setValue("ID", task.getID());
	tbl.setValue("FBDAT", format("dd.mm.yyyy", toScriptDate(bdat)));
	tbl.setValue("FTIME", format('HH:MM', toScriptDate(bdat)));
	tbl.setValue("FSDAT", task.getTime());
	tbl.setValue("FNAME", sName);
	tbl.setValue("FREPIT", task.isCyclic());
	tbl.setValue("FPERIOD", getPeriodAsText(task.getPeriod()));
	tbl.setValue("FTO", task.getTo());
	tbl.setValue("FFROM", task.getFrom());	
	tbl.setValue("FSTATUS", statusTask);		
	tbl.Update();
	isTask = true;
	return true;
}

function gridMenuInit(ds)
{
	grid.AddMenuItem("ADD","Додати задачу|Добавить задачу");
	if (!grid.getTable().isEmpty())
	{
		//grid.AddMenuItem("EDIT","Редагувати|Редактировать");
		//grid.AddMenuItem("COPY","Копіювати|Копировать");
		grid.AddMenuItem("DEL","Видалити|Удалить");		
	}
}

function gridMenuRun(sID, grid)
{	
	var tbl = grid.getTable();	
	var rowID = tbl.getValue("ID");
			
	switch(sID)
	{
		case "DEL":
			if(!taskManager)
				return;
			var task = getDpMTask(tblTask.getValue("ID"));
			if(!task)
				return;
			taskManager.addTask(task, "DEL");
			tblTask = loadTaskTable();
			grid.setTable(tblTask);
			grid.refresh();
			break;
			
		case "ADD": //case "EDIT": case "COPY":
			var par = new Object();
			par.mode = sID;
			par.type = "r";
			par.command = "dump.js";
			par.m_pTable = tblTask;
			par.name = sTxt;
			par.taskManager = lpProxy.getTaskManager();
			var sPass = FPASSWORD.value;
			par.param = FLOGIN.value 
				 +","+ (sPass==""? null : sPass)
				 +","+ FBASE.value
				 +","+ DIR.value
				 +","+ (FORG.checked==true)
				 +","+ (FJDEBET.checked==true);	
			
			showWindow("e_tasker.xml", SW_MODAL, par);
			if(par.escape)	
				return true;
			
			addTask(par.task);
			insertRecord(par.task, tblTask);			
			//tblTask = loadTaskTable();
			//grid.setTable(tblTask);
			grid.refresh();
			startTaskManager();
			break;
	}
	return true;	
}

function getDpMTask(ID)
{
	var tmp = taskManager.getTasks(statusTask);
	if (tmp == null)
		return null;
	var tasks = tmp.get(ID);
	if (!tasks || tasks.size() <= 0)
		return null;	
	return tasks.get(0);
}

function addTask(task)
{	
	var mapTask = taskManager.getTasks(statusTask);
	if (mapTask == null)
		return;
	var id = task.getID();
	if (!mapTask.containsKey(id))
		mapTask.put(id, new java.util.Vector());
	mapTask.get(id).add(task);
}

function getPeriodAsText(period)
{
	var result = "";
	if (period == 0)
		return result;
	var hour = 60;
	var day = 24 * hour;
	var week = 7 * day;
	var month = 4 * week;
	var year = 12 * month;
	var tmp = parseInt(period / year);
	if (tmp > 0)
		result += tmp + UR(" р. | г. ");
	period -= tmp;
	tmp = parseInt(period / month);
	if (tmp > 0)
		result += tmp + UR(" міс. | мес. ");
	period -= tmp;
	tmp = parseInt(period / week);
	if (tmp > 0)
		result += tmp + UR(" тижд. | нед. ");
	period -= tmp;
	tmp = parseInt(period / day);
	if (tmp > 0)
		result += tmp + " дн. ";
	period -= tmp;	
	tmp = parseInt(period / hour);
	if (tmp > 0)
		result += tmp + UR(" год. | час. ");
	period -= tmp;
	if (period > 0)
		result += period + UR(" хв. | мин. ");
	return result;	
}