include("Objects/DbImporter.js");
include("Objects/DpClEx.js");
include("Objects/DpNmkl.js");
include("Objects/DpCntr.js");
include("doc/DpDoc.js");
include("prik/DpPrik.js");
include("sub/mtr.js")

var oImporter = extPar.importer;
var arrSourceFld = new Object();
var arrObjVars = new Object();
var tmpTblVars;
var sourceType;
var source;
var rec;
var obj;
var type;
var tbl;
var base = extPar.base;
var file = extPar.file;
var objCntr;

function listLoad()
{
	this.title = ru("Импорт: параметры","Імпорт: параметри");	
	
	this.xmlGridFile = "importvars.xml";
	this.editTask = "e_import_var.xml";
	this.escape = escape;
	this.save = save;
	
	oImporter = new DbImporter();
	tmpTblVars = oImporter.varsTblName;
	tbl = extPar.m_pTable;
	
	FSOURCE.setFilterExtensions(new Array("*.xls", "*.dbf", "*.txt", "*.*"));
	FROW_START.mask = "##########";
	FROW_END.mask = "##########";
	FNUM.mask = "##########";
	FCONDITION_MODE.addItem(">", ">");	
	FCONDITION_MODE.addItem(">=", ">=");
	FCONDITION_MODE.addItem("<", "<");
	FCONDITION_MODE.addItem("<=", "<=");
	
	if(file)
	{
		var sName = new DpFile(file).getName();
		sName = sName.substring(0, sName.length()-4);
		FNAME.value = sName;
	}
				
	fillObjType();
			
	if(extPar.mode=="EDIT" || extPar.mode=="COPY")
	{		
		oImporter.source = tbl.getValue("FSOURCE");
		oImporter.fillVars(arrSourceFld);		
		fillSourceCombo(FGROUP_FIELD);
		fillSourceCombo(FLINKSOURCE);
		fillSourceCombo(FCONDITION_COL);
		
		FNUM.value = tbl.getValue("FNUM");
		FSOURCE.value = tbl.getValue("FSOURCE");
		CENCOD.value = tbl.getValue("FENCODING");
		CDELIM.value = tbl.getValue("FDELIMITER");
		FROW_START.value = tbl.getValue("FSTART");
		FROW_END.value = tbl.getValue("FEND");				
		FCOD.value = tbl.getValue("FOBJCOD");		
		CTYPE.value = tbl.getValue("FTYPE");		
		FREC.value = tbl.getValue("FREC");		
		FREPLACE.checked = tbl.getValue("FREPLACE")==true;
		ADDNOTEXIST.checked = tbl.getValue("FADDNOTEXISTING")==true;
		FPASSEXIST.checked = tbl.getValue("FPASSEXISTING")==true;		
		GROUPROW.value = tbl.getValue("FGROUPROW");
		GROUP_COND.value = tbl.getValue("FGROUPCOND");
		FGROUP_FIELD.value = tbl.getValue("FGROUPFIELD");
		FGROUP_KEY.value = tbl.getValue("FGROUPKEY");
		CMODE.value = tbl.getValue("FMODE");
		FLINKNAME.value = tbl.getValue("FLINKNAME");
		FLINKSOURCE.value = tbl.getValue("FLINKSOURCE");
		FCONDITION.value = tbl.getValue("FCONDITION");
		FCONDITION_MODE.value = tbl.getValue("FCONDITION_MODE");
		FCONDITION_COL.value = tbl.getValue("FCONDITION_COL");
		FPREVIEW.checked = tbl.getValue("FPREVIEW")==true;
		oImporter.objID = tbl.getValue("FOBJID");
		
		Disable(FNUM);
	}
		
	FLINKNAME.getCtrl().setToolTipText(UR("Приймач|Приемник"));
	FLINKSOURCE.getCtrl().setToolTipText(UR("Джерело|Источник"));
	FPREVIEW.getCtrl().setToolTipText(UR("Джерело|Источник"));
	
	sourceType = oImporter.getSourceType(FSOURCE.value);
	oImporter.init(FSOURCE.value, file, CENCOD.value, CDELIM.value);
	oImporter.loadVars(file, FSOURCE.value, FNUM.value, tmpTblVars);
				
	if(extPar.mode=="EDIT" || extPar.mode=="COPY")
	{		
		fillLinksCombo();
		FLINKNAME.value = tbl.getValue("FLINKNAME");
		FLINKSOURCE.value = tbl.getValue("FLINKSOURCE");
		source_valid();
		
		if(sourceType=="XML")
		{
			GRSOURCE.setVisible(false);
			GRSETTINGS.setVisible(false);		
			FREPLACE.checked = true;
			Disable(CTYPE);
			Disable(FREC);
			Disable(BTN_LOAD_VARS);
			Disable(FREPLACE);
			Disable(CMODE);	
		}		
	}
	
	if(extPar.mode!="EDIT")
		FNUM.value = getNextNum();
				
	this.obj_select = obj_select;
	this.rec_selected = rec_selected;	
	setButton(FREC, this, "rec_selected");
	setButton(FCOD, this, "rec_selected");
	setButton(FDOCNUM, this, "obj_select");
	setButton(BTN_LOAD_DATA, loadData);
	setButton(BTN_LOAD_VARS, loadObjVars);
	setButton(BTN_OPEN_SOURCE, openSource);
	setButton(BTN_CLEAR, clearData);
	
	setValid(FREC, rec_valid);
	setValid(CMODE, mode_valid);
	setValid(CTYPE, type_valid);
	setValid(GROUPROW, row_group_valid);
	setValid(GROUP_COND, group_cond_valid);
	setValid(FSOURCE, source_valid);
	setValid(CENCOD, settings_valid);
	setValid(CDELIM, settings_valid);
	setValid(FNUM, num_valid);
	setValid(FCONDITION_COL, condValid);
	setValid(FPASSEXIST, passExistValid);
	
	Disable(FTXT);	
	setFocus(FSOURCE);
	//setFocus(FREC);
		
	source = FSOURCE.value;
	rec = FREC.value;	
		
	type_valid();
	mode_valid();		
	row_group_valid();
	
	if(extPar.mode=="ADD")
	{
		FCONDITION_COL.addItem("", "");
		ExecuteSQL("delete from "+ tmpTblVars);
	}
	else
	{
		rec_valid();		
	}
	condValid();
}

function listAfterLoad()
{
	if(grid.getTable().isEmpty())
	{
		oImporter.fillVars(arrSourceFld, tmpTblVars);		
		fillVarsCombo();
	}
	
	grid.getTable().requery();
	grid.refresh();
}

function num_valid()
{
	var oSnap = getSnap("select FSOURCE from "+ tbl.getTableName()
				+" where FNUM="+ sqlTo(FNUM.value)
					+" and FWID<>"+ tbl.getValue("FWID")
				, false);
	if(oSnap)
	{
		WAIT(UR("Такий номер вже існує!|Такой номер уже существует!"));
		setFocus(FNUM);
		return false;
	}
	return true;
}

function getNextNum()
{
	var oSnap = getSnap("select max(FNUM) from "+ tbl.getTableName(), false);
	if(oSnap && Number(oSnap[0]))
		return Number(oSnap[0])+1;
	return 1;
}

function fillObjType()
{
	CTYPE.addItem("tbl", UR("таблиця|таблица"));	
	CTYPE.addItem("pri", UR("прайс-лист|прайс-лист"));
	CTYPE.addItem("cl", UR("довідник аналітики|справочник аналитики"));
	CTYPE.addItem("nmk", UR("довідник номенклатури|справочник номенклатуры"));
	CTYPE.addItem("doc", UR("папка документів|папка документов"));
	CTYPE.addItem("docrow", UR("рядки документу|строки документа"));
	CTYPE.addItem("prk", UR("наказ з/п|приказ з/п"));
	CTYPE.value = "tbl";
}

function listSrc()
{
	this.qrySet("From", tmpTblVars
			//, "Where", "FREC<>'' and FREC is not NULL"
			, "Order", "FWID");	
}

function save()
{
	if(!num_valid() || !check_rec())
		return false;
	
	var nSourceNum = Number(FNUM.value);
	
	var m = new Object();
	//if(extPar.mode!="EDIT")
	//	m.FWID = GetUID();	
	m.FNUM = oImporter.sourceNum = nSourceNum;
	m.FSOURCE = oImporter.source = FSOURCE.value;
	m.FENCODING = oImporter.encoding = CENCOD.value;
	m.FDELIMITER = oImporter.delimiter = CDELIM.value;
	m.FSTART = Number(FROW_START.value);
	m.FEND = Number(FROW_END.value);
	m.FREC = oImporter.recipient = FREC.value;
	m.FTYPE = oImporter.objType = CTYPE.value;
	m.FOBJCOD = oImporter.objCod = String(FCOD.value);
	m.FOBJID = Number(oImporter.objID);
	m.FMODE = oImporter.mode = CMODE.value;
	m.FREPLACE = oImporter.replace = false;//FREPLACE.checked;
	m.FADDNOTEXISTING = oImporter.addNotExisting = ADDNOTEXIST.checked;
	m.FPASSEXISTING = oImporter.passExisting = FPASSEXIST.checked;
	if(FLINKNAME.value)	
		m.FLINKNAME = oImporter.linkName = String(FLINKNAME.value);
	if(FLINKSOURCE.value)
		m.FLINKSOURCE = oImporter.linkSource = String(FLINKSOURCE.value);
	m.FGROUPROW = oImporter.groupRow = GROUPROW.checked;
	m.FGROUPCOND = oImporter.groupCond = GROUP_COND.value;
	oImporter.groupField = "";
	if(FGROUP_FIELD.value)
		m.FGROUPFIELD = oImporter.groupField = String(FGROUP_FIELD.value);
	if(FGROUP_KEY.value)
		m.FGROUPKEY = oImporter.groupKey = FGROUP_KEY.value;
	if(FCONDITION.value)
		m.FCONDITION = oImporter.condition = FCONDITION.value;
	if(FCONDITION_MODE.value)
		m.FCONDITION_MODE = oImporter.conditionMode = FCONDITION_MODE.value;
	if(FCONDITION_COL.value)
		m.FCONDITION_COL = oImporter.conditionCol = String(FCONDITION_COL.value);
	m.FPREVIEW = oImporter.preview = FPREVIEW.checked==true;
	
	UpdateTable(tbl.getTableName(), m, extPar.mode!="EDIT");
	
	saveSourceField(m.FGROUPFIELD);
	tbl.requery();
	
	var sName = String(FNAME.value);
	if(sName)
	{
		var path = new DpFile(file).getParent();
		if(sName.indexOf(".")==-1)
			sName += ".xml";
		file = path +"/"+ sName;
		oImporter.sFileParam = file;
		extPar.file = DpFile(file).getAbsolutePath();
	}	
		
	oImporter.saveParam(file, nSourceNum, "", extPar.mode);
	
	grid.getTable().close();
	FORM.close();
	
	extPar.grid.refresh();
	
	exit();
}

function saveSourceField(sFld)
{
	if(!sFld || sFld=="")
		return;
	var oSnap = getSnap("select FREC from "+ tmpTblVars 
					+" where FSOURCE="+ sqlTo(sFld) 
						+" or FSOURCE="+ sqlTo("F"+ sFld)
				, false);
	if(oSnap==null)
	{
		var m = new Object();
		m.FSOURCE = sFld;
		m.FREC = "";
		m.FTYPE = "text";
		m.FWID = GetUID();		
		UpdateTable(tmpTblVars, m, true);
	}
}

function loadData()
{
	oImporter.init(FSOURCE.value, file, CENCOD.value, CDELIM.value);
	oImporter.loadVars(file, FSOURCE.value, FNUM.value, tmpTblVars);	
	
	FROW_END.value = oImporter.getRowCount(FSOURCE.value, CENCOD.value, CDELIM.value);
	FROW_START.value = 1;	
	
	grid.getTable().requery();
	if(grid.getTable().isEmpty())
	{
		oImporter.init(FSOURCE.value, file, CENCOD.value, CDELIM.value);
		oImporter.fillVars(arrSourceFld, tmpTblVars);
	}
	else
	{
		arrSourceFld = oImporter.fillVars(arrSourceFld);
	}
		
	fillVarsCombo();
	
	grid.getTable().requery();
	grid.refresh();	 
}

function fillVarsCombo()
{
	fillSourceCombo(FGROUP_FIELD);	
	fillSourceCombo(FCONDITION_COL);
	fillLinksCombo();
}

function clearData()
{
	ExecuteSQL("delete from "+ tmpTblVars);
	grid.getTable().requery();
	grid.refresh(); 
}

function listInitEditParam(oPar)
{
	oPar.importer = oImporter;
	oPar.importMode = CMODE.value;
	oPar.objType = CTYPE.value;
	oPar.rec = FREC.value;
	oPar.base = extPar.base;		
	oPar.obj = obj;
}

function canEditRecord()
{	
	return true;
}

function escape()
{
	grid.getTable().close();
	FORM.close();
	exit();	
}

function exit()
{
	//ExecuteSQL("drop table "+ tmpTblVars, false);
}

function openSource()
{
	if(checkSource() && isFile(FSOURCE.value))
		shellOpen(FSOURCE.value);
}

function settings_valid()
{
	oImporter.delimiter = CDELIM.value;
	oImporter.encoding = CENCOD.value;
}

function source_valid()
{
	if(checkSource())
		Enable(BTN_LOAD_DATA);
	else
		Disable(BTN_LOAD_DATA);	
	
	if(!FSOURCE.value)
		return false;
	
	oImporter.init(FSOURCE.value, file, CENCOD.value, CDELIM.value);	
	sourceType = oImporter.getSourceType(FSOURCE.value);	
	
	Enable(FROW_START);
	Enable(FROW_END);
	Enable(FCONDITION_COL);
	Disable(CDELIM);
	if(sourceType=="CSV")
	{
		Enable(CDELIM);
	}
	else if(sourceType=="DBF")
	{
		//Enable(FROW_START, false);
		//Enable(FROW_END, false);
		Enable(FCONDITION_COL, false);
	}
	
	if(sourceType=="XML")
		GRMODE.setVisible(false);
	else		
		GRMODE.setVisible(true);
}

function checkSource()
{
	FSOURCE.setBackground(0xFFFFFF);
	if(!sourceType || sourceType=="XML")
		return true;
	if(!FSOURCE.value || !isFile(FSOURCE.value))
	{
		WAIT(ru("Не верно указан файл-источник","Не вірно вказаний файл-джерело"));
		FSOURCE.setBackground(0xFFAAAA);
		setFocus(FSOURCE);
		return false;
	}
	return true;
}

function mode_valid()
{
	if(String(CMODE.value)=="edit")
	{
		//GRREPLACE.setVisible(false);
		GRPASSEXIST.setVisible(false);
		GRLINK.setVisible(true);
		GRADDNOTEXIST.setVisible(true);
		//LLINK.setText(UR("  Зв'язка: |  Связка: "));		
	}
	else
	{
		//GRLINK.setVisible(false);
		//GRREPLACE.setVisible(true);
		GRADDNOTEXIST.setVisible(false);
		GRPASSEXIST.setVisible(true);
		passExistValid();
		//LLINK.setText(UR(" Умова: | Условие: "));
	}
}

function fillLinksCombo()
{
	var linkName = FLINKNAME.value;
	var linkSource = String(FLINKSOURCE.value);
	FLINKNAME.clear();
	FLINKSOURCE.clear();
	fillSourceCombo(FLINKSOURCE);
	
	loadObjVars();
	for(var sVar in arrObjVars)
	{
		var sTxt = arrObjVars[sVar];
		if(!sTxt || String(sTxt).trim()=="")
			sTxt = sVar;
		else
			sTxt = sVar +" - "+ sTxt;
		FLINKNAME.addItem(sVar, sTxt);
	}
	if(FLINKNAME.getLength()<=0)
	{
		var arrVars = oImporter.varMap;
		for(var sVar in arrVars)
		{
			//var sSource = arrVars[sVar];		
			FLINKNAME.addItem(sVar, sVar);
		}
	}
	if(obj && FLINKNAME.getLength()==0)
	{
		var varsInfo = obj.getVarsInfo();
		for(var i=0; i<varsInfo.length; i++)
		{
			var sVar = varsInfo[i].name;
			var sTxt = String(varsInfo[i].rem).trim();
			if(!sTxt || sTxt=="")
				sTxt = sVar;
			else
				sTxt = sVar +" - "+ sTxt;
			FLINKNAME.addItem(sVar, sTxt);
		}
	}
		
	if(linkName)
		FLINKNAME.value = linkName;
	if(linkSource)
		FLINKSOURCE.value = linkSource;
}

function rec_selected()
{
	var type = CTYPE.value;
	if(!type)
		return;
	switch(String(type).toLowerCase())
	{		
		case "cl":
			cl_selected();
			break;		
		
		case "docrow":
		case "doc":
			doc_selected();		
			break;
		
		case "pri":
			pri_selected();		
			break;
			
		case "nmk":
			nmk_selected();	
			break;
		
		case "prk":
			prk_selected();		
			break;
		default:
			tbl_selected();
			break;		
	}
}

function pri_selected()
{
	var par = new Object();
	par.zaval = true;
	par.ret = new Object();
	par.ret.fwid = null;
	par.ret.fcod = null;
	par.ret.fdate = null;
	showWindow("l_cl_pri.xml", SW_MODAL, par)
	if(par.escape)
		return;
	
	var priName = pName(par.ret.fcod, new Date(par.ret.fdate), par.ret.fwid);
	FREC.value = "MTR_"+ priName.substring(1);
}

function tbl_selected()
{
	var par = new Object();
	par.zaval = true;
	par.type = "...TABLES";
	par.ret = new Object();
	showWindow("dbmd.xml", SW_MODAL, par)
	if(par.escape)
		return;
	var sRet = par.ret.data;
	var sName = sRet.substring(sRet.indexOf(par.type)+par.type.length+3);
	FREC.value = sName;
}

function doc_selected()
{
	var par = new Object();
	par.zaval = true;
	par.ret = new Object();
	showWindow("docfdr.xml", SW_MODAL, par)
	if(par.escape)
		return;
	
	FREC.value = par.ret.doc;
	FCOD.value = par.ret.nop;	
	rec_valid();
}

function cl_selected()
{
	var par = new Object();
	par.zaval = true;
	par.ret = new Object();
	par.ret.FCOD = 0;
	par.ret.FVID = 0;
	showWindow("l_clcl.js", SW_MODAL, par);
	if(par.escape)
		return;
	
	FREC.value = par.ret.FVID;
	FCOD.value = par.ret.FCOD;
	rec_valid();
}

function nmk_selected()
{
	var oGroup = new DpNmkl();			
	oGroup.GroupOnly = true;
	oGroup.CanEmpty = true;
	oGroup.zaval();
	FCOD.value = oGroup.getCod("c");
	FTXT.value = oGroup.getTCod();
}

function prk_selected()
{
	objCntr = new DpCntr();
	objCntr.linkCtrl(FCOD,FTXT);
	objCntr.zaval();
	FREC.value = objCntr.getFvid();
}

function obj_select()
{
	if(!obj)
		return;
	var par = new Object();	
	par.doc = FREC.value;
	par.nop = FCOD.value;
	par.ret = new Object();
	par.ret.FDOC_NUM = null;
	par.ret.FWID = null;
	showWindow("l_docekz.xml", SW_MODAL, par);
	if(par.escape)
		return;
	FDOCNUM.value = par.ret.FDOC_NUM;
	oImporter.objID = par.ret.FWID;
}

function check_rec()
{
	var sRec = String(FREC.value).trim();
	if(!FREC.value || sRec=="")
	{
		var sMsg = UR("Не вказаний приймач!|Не указан приемник!");
		setFocus(FREC);
		FREC.showErr(sMsg);
		return false;
	}
	return true;
}

function rec_valid()
{
	check_rec();
	
	var type = CTYPE.value;
	if(!type)
		return;
		
	switch(String(type).toLowerCase())
	{		
		case "nmk":
			var oGroup = new DpNmkl();			
			oGroup.GroupOnly = true;
			oGroup.CanEmpty = true;
			oGroup.setCod(String(FCOD.value));
			FTXT.value = UR(oGroup.getTCod());
			break;
			
		case "cl":			
			GROBJROW.setVisible(false);
			var sCl = String(FREC.value);
			if(!sCl && Number(FCOD.value))
			{
				var oSnap = getSnap("select FVID from ^CLCL where FCOD="+ sqlTo(Number(FCOD.value)));
				if(oSnap && oSnap[0])
					sCl = oSnap[0];
				FREC.value = sCl;
			}			
			if(!sCl.toUpperCase().startsWith("CL") && Number(sCl))
				sCl = "CL"+ sCl;
			obj = new DpClEx(sCl, FCOD.value);
			FTXT.value = UR(obj.getClTxt(FCOD.value));
			//loadObjVars();	
			break;
		
		case "doc":	
		case "docrow":
			obj = new DpDoc(FREC.value, FCOD.value);
			FTXT.value = UR(obj.getOName());
			//loadObjVars();
			if(obj.getJObject().hasChilds())
			{
				GROBJROW.setVisible(true);				
				//FORM.getParent().update();
			}
			else
				GROBJROW.setVisible(false);
			break;
		case "prk":
				objCntr = new DpCntr();
				objCntr.linkCtrl(FCOD,FTXT);
				var snap = getSnap("select Fnum,Fedit from ^cl_prik where Fvid="+FREC.value)
				if(snap)
				{
					objCntr.setFnum(snap[0]);
					obj = new DpPrik(snap[1].toUpperCase(), FREC.value);
				}
			break;
				
		default:
			GROBJROW.setVisible(false);
			obj = null;
			//loadTblFields();
			break;		
	}
}

function loadObjVars(bFillVarsTbl)
{		
	arrObjVars = new Object();
	
	if(!check_rec())
		return;	
	
	if(bFillVarsTbl)
		ExecuteSQL("delete from "+ tmpTblVars, false);
	
	var type = CTYPE.value;
	if(type=="tbl" || type=="nmk" || type=="pri")
	{
		loadTblFields(bFillVarsTbl);
		if(bFillVarsTbl)
		{
			grid.getTable().requery();
			grid.refresh();
			grid.setFocus();
		}
		return;
	}
	
	rec_valid();	
	if(!obj)
		return;	
	
	if(type!="docrow")
	{
		var varsInfo = obj.getVarsInfo();
		for(var i=0; i<varsInfo.length; i++)
		{
			var m = new Object();
			m.FCOD = String(i+1);			
			m.FREC = varsInfo[i].name;
			m.FTYPE = oImporter.getDpType(varsInfo[i].dataType);
			//m.FLENGTH = oImporter.getVarLength(m.FREC, m.FTYPE);
			m.FTXT = varsInfo[i].rem;
			if(bFillVarsTbl)
				UpdateTable(tmpTblVars, m, true);
			arrObjVars[m.FREC] = m.FTXT;
		}
		
		var extInfo = obj.getExtInfo();
		for(var sExt in extInfo)
		{
			var m = new Object();
			m.FCOD = String(sExt);			
			m.FREC = "X_"+ sExt;
			m.FTYPE = oImporter.getDpType(extInfo[sExt].getType());
			m.FLENGTH = extLength(extInfo[sExt].E_Format, m.FTYPE);
			m.FTXT = UR("Розширення: |Расширение: ") + extInfo[sExt].E_FieldText;			
			if(bFillVarsTbl)
				UpdateTable(tmpTblVars, m, true);
			//arrObjVars[m.FREC] = m.FTYPE;
		}
	}
	
	if(obj.getJObject().hasChilds())
	{
		var arrClass = obj.getJObject().getChildIDs();
		for(var n=0; n<arrClass.length; n++)	
		{
			var sRowClass = arrClass[n];
			if(!sRowClass || sRowClass=="CLNUM")
				continue;
			var oRow = obj.createRow(sRowClass);			
			if(!oRow)
				continue;
			var varsInfo = oRow.getVarsInfo();
			for(var i=0; i<varsInfo.length; i++)
			{
				var m = new Object();
				m.FCOD = String(i+1);			
				m.FREC = varsInfo[i].name;
				m.FTYPE = oImporter.getDpType(varsInfo[i].dataType);				
				m.FROW = true;
				m.FROWCLASS = sRowClass;
				var txt = varsInfo[i].rem;
				txt = UR("Рядок: |Строка: ") + sRowClass +" "+ txt;
				m.FTXT = txt;
				if(bFillVarsTbl)
					UpdateTable(tmpTblVars, m, true);
			}			
		}
	}
	if(bFillVarsTbl)
	{
		grid.getTable().requery();
		grid.refresh();
		grid.setFocus();
	}
}

function loadTblFields(bFillVarsTbl)
{	
	var base = extPar.base;
	var sTblName = FREC.value;	
	
	if(!sTblName || !IsTableEx(base, sTblName))
		return;
	//if(type==CTYPE.value && rec==FREC.value)
	//	return;
		
	type = CTYPE.value;
	rec = FREC.value;
		
	if(base)
	{
		if(SUBD==MSSQL)
			sTblName = base +".."+ sTblName;
		else
			sTblName = base +"."+ sTblName;
	}
	
	include("objects/DpXMLDomDocument.js");
	var xmlDom = new DpXMLDOMDocument();
	xmlDom.load(rootDirectoryEx() + "dbstru.xml");
	var listInfo = xmlDom.getDocumentElement();
	var struTbl = sTblName;
	if(struTbl.indexOf("_")!=-1)
		struTbl = struTbl.substring(struTbl.indexOf("_")+1);
	if(type=="pri")
		struTbl = "PRICE";
	var xmlTbl = listInfo.getElementsByTagName(struTbl)[0];
		
	var tbl = OpenTable(sTblName);	
	var i=1;
	for(i=1; i<=tbl.fieldCount(); i++)
	{
		var fInfo = tbl.getFieldInfo(i);
		if(!fInfo)
			continue;
		var m = new Object();
		m.FCOD = String(i);			
		m.FREC = fInfo.getName();
		m.FTYPE = fInfo.getDpType();
		m.FTXT = "";
		if(xmlTbl)
		{
			var xmlFld = xmlTbl.getElementsByTagName(m.FREC)[0];
			if(xmlFld)
				m.FTXT = UR(xmlFld.getText());
		}		
		if(bFillVarsTbl)
			UpdateTable(tmpTblVars, m, true);
		arrObjVars[m.FREC] = m.FTXT;
	}
	
	if(type=="nmk")
	{
		var extBuilder = new DpExtentionBuilder("CL_NMK");
		extBuilder.load();			
		for(sLabel in extBuilder.arrExt)
		{
			var m = new Object();
			m.FCOD = String(++i);			
			m.FREC = "X_F"+ sLabel;
			m.FTYPE = oImporter.getDpType(extBuilder.arrExt[sLabel].FTYPE);
			m.FLENGTH = extLength(extBuilder.arrExt[sLabel].FFORMAT, m.FTYPE);
			m.FTXT = extBuilder.arrExt[sLabel].FTXT;
			m.FTXT = UR("Розширення: |Расширение: ") + m.FTXT;
			if(bFillVarsTbl)
				UpdateTable(tmpTblVars, m, true);
			arrObjVars[m.FREC] = m.FTXT;
		}
	}
}

function extLength(sFormat, sType)
{
	var nLength = 0;
	if(!sFormat)
		return nLength;
	sFormat = String(sFormat);
	if(sFormat && sType && sType.toLowerCase()=="text")
		nLength = Number(sFormat.substring(1, sFormat.length-1));
	if(!nLength)
		nLength = 0;
	return nLength;
}

function type_valid()
{
	var type = CTYPE.value;
	if(!type)
		return;
	GRNUM.setVisible(false);
	GROBJROW.setVisible(false);
	switch(String(type).toLowerCase())
	{		
		case "cl":			
			LCOD.setText(UR("Код довідника|Код справочника"));
			GROBJ.setVisible(true);	
			FCOD.mask = "######";
			FREPLACE.checked = false;
			//Disable(FCOD);
			break;
		
		case "doc":	
			LCOD.setText(UR("Номер операції|Номер операции"));
			GROBJ.setVisible(true);
			GROBJROW.setVisible(true);	
			FCOD.mask = "######";
			FREPLACE.checked = false;
			//Disable(FCOD);
			break;
		
		case "docrow":	
			LCOD.setText(UR("Номер операції|Номер операции"));
			GROBJ.setVisible(true);
			GRNUM.setVisible(true);		
			FCOD.mask = "######";
			FREPLACE.checked = false;
			//Disable(FCOD);
			break;
		
		case "nmk":
			LCOD.setText(UR("Група|Группа"));
			GROBJ.setVisible(true);			
			FREPLACE.checked = false;
			Disable(FREPLACE);
			//Disable(CMODE);
			//Enable(FCOD);
			FREC.value = "MTR_CL_NMK";
			FCOD.mask = "&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&";
			break;
		
		case "pri":			
			GROBJ.setVisible(false);
			FREPLACE.checked = false;
			Disable(FREPLACE);
			//Disable(CMODE);		
			break;
		case "prk":
			GROBJ.setVisible(true);
			LCOD.setText(UR("Наказ|Приказ"));
			FREC.mask = "####";
			break;
		default:
			//LCOD.setVisible(false);
			//FCOD.setVisible(false);
			GROBJ.setVisible(false);
			//Enable(FREC);
			//Enable(FREPLACE);
			Enable(CMODE);
			break;		
	}
}

function row_group_valid()
{
	if(GROUPROW.checked==true)
	{		
		Enable(GROUP_COND);
		Enable(FGROUP_FIELD);
		Enable(FGROUP_KEY);		
	}
	else
	{		
		Enable(GROUP_COND, false);
		Enable(FGROUP_FIELD, false);
		Enable(FGROUP_KEY, false);		
	}
	group_cond_valid();
}

function group_cond_valid()
{
	var sCond = String(GROUP_COND.value);
	if(sCond=="GROUP_FIELD")
	{
		LGROUPCOND.setVisible(false);
		FGROUP_KEY.setVisible(false);
	}
	else
	{
		LGROUPCOND.setVisible(true);
		FGROUP_KEY.setVisible(true);
	}
}

function fillSourceCombo(oCtrl)
{
	var sSource = String(oCtrl.value);
	oCtrl.clear();	
	oCtrl.addItem("", "");
	for(var fld in arrSourceFld)
	{
		if(oImporter.type=="DBF")
		{
			oCtrl.addItem(fld, fld);
		}
		else
		{
			var nCol = oImporter.getColNum(fld);
			if(nCol)
				oCtrl.addItem(String(nCol), UR("Стовпчик |Столбец ") + nCol);
		}
	} 
	if(sSource)
		oCtrl.value = sSource;
}

function isExpr(str)
{
	return oImporter.isExpr(str);
}

function isEmpty(str)
{	
	str = String(str).trim();
	return str=="" || str==null;
}

function isObject(sType)
{
	return oImporter.isObject(sType);
}

function condValid()
{
	if(FCONDITION_COL.value && String(FCONDITION_COL.value)!="")
	{
		Enable(FCONDITION_MODE);
		Enable(FCONDITION);
	}
	else
	{
		Enable(FCONDITION_MODE, false);
		Enable(FCONDITION, false);
	}
}

function passExistValid()
{
	if(FPASSEXIST.checked==true)
	{
		GRLINK.setVisible(true);
	}
	else
	{
		GRLINK.setVisible(false);
	}
	//FORM.Refresh();
}

function listAfterMenuHandler(sID)
{
	fillVarsCombo();
}

include("sys/DpList.js");