include("Objects/DpObjectComparer.js");
include("doc/DpDoc.js");
include("servis/format.js");

var cmpObj;
var CMP_EQUAL = 0;
var CMP_NOTEXISTS_LEFT = 2;
var CMP_NOTEXISTS_RIGHT = 4;
var CMP_NOTEQUAL = 8;

var usedFilter = 14;
/*
	CMP_EQUALS;
	CMP_NOTEXISTS_LEFT
	CMP_NOTEXISTS_RIGHT
	CMP_NOTEQUAL
	CMP_ANY_CONFLICT = CMP_NER | CMP_NEL | CMP_NE
*/

var sSelID = "0";
var canWriteLeft = false;
var canWriteRight = false;

function Load()
{
	if (!extPar)
	{
		alert(UR("Недостатньо параметрів|Недостаточно параметров"));
		return false;
	}

	var obj1 = extPar.obj1;
	var obj2 = extPar.obj2;
	
	if (extPar.canWriteRight)
		canWriteRight = true;
	if (extPar.canWriteLeft)
		canWriteLeft = true;

	if (extPar.caption)
		Caption(extPar.caption);
	else
		Caption(UR("Порівняння об'єктів |Сравнение объектов "));

	cmpObj = new DpObjectComparer(obj1,obj2);
	
	this.Tree_mnuHandler = Tree_mnuHandler;
	this.Tree_mnuInit = Tree_mnuInit;
	this.Tree_select = Tree_select;

	Tree.selectMenuHandler(this, "Tree_mnuHandler");
	Tree.loadMenuHandler(this, "Tree_mnuInit");
	Tree.setTreeSelHandler(this, "Tree_select");	
	
	initTree();
	fillTree();
	
	setButton(btnCancel,this,"escape");
	setButton(btnSave1,save1);
	setButton(btnSave2,save2);
	
	if (!canWriteLeft)
		Disable(btnSave1);
	if (!canWriteRight)
		Disable(btnSave2);
}

function save1()
{
	var dpObj = cmpObj.getLeftObject();
	save(dpObj);
	CloseWindow();
}

function save(oObj)
{
	if (oObj != null)
	{
		if (objTypeOf(oObj) == "DpDoc")
			oObj.save(true,"EDIT");
		else
			oObj.save("EDIT");
	}
}

function save2()
{
	var dpObj = cmpObj.getRightObject();
	save(dpObj);
	CloseWindow();
}

function Tree_select(sID)
{
	sSelID = String(sID);
}

function Tree_mnuInit(toObject)
{
//-	toObject.AddMenuItem("TST","TST");
	toObject.AddMenuItem("+++","Відібрати|Отобрать");
	toObject.AddMenuItem("FLT_-1","всі елементи|все элементы");
	toObject.AddMenuItem("FLT_0","(=) рівні елементи|(=) равные элементы");
	toObject.AddMenuItem("FLT_8","(<>) нерівні елементи|(<>) неравные элементы");
	toObject.AddMenuItem("FLT_2","(?/=) відсутні елементи зліва|(?/=) отсутствующие элементы слева");
	toObject.AddMenuItem("FLT_4","(=/?) відсутні елементи справа|(=/?) отсутствующие элементы справа");
	toObject.AddMenuItem("FLT_14","(?) всі невідповідності|(?) все несоответствия");
	toObject.AddMenuItem("---","");
	toObject.AddMenuItem("","");
	
	var cmpRes = Tree.getItem(sSelID).getData("CMP_DATA");
	var ppID = parseID(sSelID);
	var bIsChldGroup = false;
	var childClsList = cmpObj.getChildClasses();
	for (var nC = 0; nC < childClsList.length; nC++)
		if (childClsList[nC] == ppID.SubGroup)
		{
			bIsChldGroup = true;
			break
		}
	
	if (cmpRes == null
		&& (
			ppID.SubGroup == "VARS"
			|| ppID.SubGroup == "EXTS"
			|| ppID.SubGroup == "CHILDS"
			|| bIsChldGroup
			)
	   )
	{
		var parID = ppID.Group + (ppID.ID > 0?"@" + ppID.ID:"");
		if (parID == "HEAD")
		{
			cmpRes = new CMPRowInfo();
			cmpRes.CMPStatus = CMP_NOTEQUAL;
		}
		else
		{
			var ti = Tree.getItem(parID);
			if (ti != null)
				cmpRes = ti.getData("CMP_DATA");
		}
	}
	if (cmpRes != null)
	{
		if (cmpRes.CMPStatus != CMP_NOTEXISTS_LEFT && canWriteRight)
			toObject.AddMenuItem("COMTO","Внести зміни зліва|Внести изменения слева","LCOK");
		if (cmpRes.CMPStatus != CMP_NOTEXISTS_RIGHT && canWriteLeft)
			toObject.AddMenuItem("COMFROM","Внести зміни справа|Внести изменения справа","RCOK");
		toObject.AddMenuItem("","");
	}
	toObject.AddMenuItem("EXPAND","Розгорнути все|Развернуть всё");
	toObject.AddMenuItem("COLLAPSE","Згорнути все|Свернуть всё");
}

function Tree_mnuHandler(sID,sItmID)
{
	sID = String(sID);
	if (sID.substring(0,3) == "FLT")
	{
		usedFilter = parseInt(sID.substr(4));
		setPar("OBJECT.COMPARE.FILTER",usedFilter);
		Tree.removeAll();
		fillTree();
		return;
	}
	if (sID == "COLLAPSE")
	{
		Tree.colapseAll();
		return;
	}
	if (sID == "EXPAND")
	{
		Tree.expandAll();
		return;
	}
	if (sID == "TST")
	{
		var ppID = parseID(sSelID);
//-		alert(sSelID);
		alert(ppID.Group + " - " + ppID.ID + " - " + ppID.SubGroup + " - " + ppID.Entry);
	}
	if (sID == "COMTO")
	{
		makeMerge(sSelID,2)
		return;
	}
	if (sID == "COMFROM")
	{
		makeMerge(sSelID,4);
		return;
	}
}

function makeMerge(sItemID,nDirection)
{
	var ppID = parseID(sItemID);
	// group,id,sub,var
	if (ppID.Entry)
	{
		var ret = setVar(ppID.Group,ppID.ID,ppID.SubGroup,ppID.Entry,nDirection);
		return ret;
	}
	if (ppID.SubGroup == "VARS")
	{
		// все переменные
//-		alert("all vars");
		setAllVars(ppID.Group,ppID.ID,"VAR",nDirection);
		return;
	}
	else if (ppID.SubGroup == "EXTS")
	{
		// все расширения
//-		alert("all exts");
		setAllVars(ppID.Group,ppID.ID,"EXT",nDirection);
		return;
	}
	else if (ppID.SubGroup == "CHILDS")
	{
		// все строки
//-		alert("all childs");
		setAllObjects(nDirection);
		return;
	}
	else if (ppID.SubGroup)
	{
		// все строки типа 
//-		alert("all rows " + ppID.SubGroup);
		setAllObjectsByClass(ppID.SubGroup,nDirection);
		return;
	}
	
	if (ppID.ID > 0)
	{
		// строка целиком
		setObject(ppID.Group,ppID.ID,nDirection);
		return;
	}
	
	if (ppID.Group == "HEAD")
	{
		// всё подряд
		alert("all");
		return;
	}
	alert(sItemID);
}

var doAlert = true;

/*
	direction = 2 ->
	direction = 4 <-
*/
function setAllObjects(direction)
{
	var classList = cmpObj.getChildClasses();
	for (var nCl = 0; nCl < classList.length; nCl++)
	{
		setAllObjectsByClass(classList[nCl],direction);
	}
	return true;
}

function setAllObjectsByClass(sGroup,direction)
{
	var objCMPList = cmpObj.getCMPChildsList(sGroup);
	var oldAlert = doAlert;
	doAlert = false;
	for (var chldIDX in objCMPList)
	{
		var cmpRes = objCMPList[chldIDX];
		if (cmpRes.CMPStatus == CMP_NOTEXISTS_LEFT && direction == 2)
			continue;
		if (cmpRes.CMPStatus == CMP_NOTEXISTS_RIGHT && direction == 4)
			continue;
		var obj = null;
		if (direction == 2)
			obj = cmpRes.objComparer.getLeftObject();
		else
			obj = cmpRes.objComparer.getRightObject();
		if (obj == null)
			continue;
		setObject(sGroup,obj.getID(),direction);
	}
	doAlert = oldAlert;
	return true;
}

function setObject(sGroup,nId,direction)
{
	if (!sGroup
		|| (nId < 0 && sGroup != "HEAD"))
		return false;
	
	var fromViewer;
	var toViewer;
	
	var fromObj;
	var toObj;
	
	if (direction == 2)
	{
		fromViewer = cmpObj.getLeftViewer();
		toViewer = cmpObj.getRightViewer();
	}
	else
	{
		fromViewer = cmpObj.getRightViewer();
		toViewer = cmpObj.getLeftViewer();
	}
	
	fromObj = fromViewer.getObject(sGroup,nId);
	toObj = toViewer.getObject(sGroup,nId);
	
	if (fromObj == null)
	{
		if (doAlert)
		{
			var txObj = sGroup + (nId > 0?"@" + nId:"");
			if (direction == 2)
				alert(UR("Об'єкт " + txObj + " зліва не існує|Объект " + txObj + " слева не существует"));
			else
				alert(UR("Об'єкт " + txObj + " справа не існує|Объект " + txObj + " справа не существует"));
		}
		return false;
	}
	
	var ret = toViewer.setValue(sGroup,nId,null,null,fromObj);
	
	if (ret)
	{
		var itmID = sGroup + (nId > 0?"@" + nId:"");
		var ti = Tree.getItem(itmID);
		if (!ti)
			return ret;
		Tree.Lock();
		var cmpRes = cmpObj.getCMPChild(sGroup,nId);
		if ((cmpRes.CMPStatus & usedFilter) == 0
		&& (cmpRes.CMPStatus + usedFilter) != 0
		&& usedFilter >= 0)
		{
			Tree.removeItem(itmID);
		}
		else
		{
			Tree.removeAllIn(itmID);
			appendObject(itmID,itmID,cmpRes.objComparer);
			Tree.setValue(itmID,"status",getCMPStatusText(cmpRes.CMPStatus));
			setItemColor(itmID,cmpRes.CMPStatus,true);
			ti.setData("CMP_DATA",cmpRes);
		}
		Tree.Unlock();
	}
	
	return ret;
}

function setAllVars(sGroup,nId,sSub,direction)
{
	if (!sGroup
		|| (nId < 0 && sGroup != "HEAD")
		|| !sSub
	   )
	return false;
	
	var cmpRes = cmpObj.getCMPChild(sGroup,nId);
	
	var objFrom = null;
	var objTo = null;
	
	if (direction == 2)
	{
		objFrom = cmpRes.objComparer.getLeftObject();
		objTo = cmpRes.objComparer.getRightObject();
	}
	else
	{
		objFrom = cmpRes.objComparer.getRightObject();
		objTo = cmpRes.objComparer.getLeftObject();
	}
	
	if (objFrom == null)
	{
		if (doAlert)
		{
			var txObj = sGroup + (nId > 0?"@" + nId:"");
			if (direction == 2)
				alert(UR("Об'єкт " + txObj + " зліва не існує|Объект " + txObj + " слева не существует"));
			else
				alert(UR("Об'єкт " + txObj + " справа не існує|Объект " + txObj + " справа не существует"));
		}
		return false;
	}
	
	var vList = cmpRes.objComparer.getCMPList(sSub);
	var ret = true;
	Tree.Lock();
	var oldAlert = doAlert;
	doAlert = false;
	for (var sVar in vList)
		ret = setVar(sGroup,nId,sSub,vList[sVar].varName,direction) && ret;
	Tree.Unlock();
	doAlert = oldAlert;
	return ret;
}

function setVar(sGroup,nId,sSub,sVar,direction)
{
	if (!sGroup
		||(nId < 0 && sGroup != "HEAD")
		|| !sSub
		|| !sVar
	   )
	return false;
	
	var viwerFrom = null;
	var viewerTo = null;
	
	var objFrom = null;
	var objTo = null;
	
	if (direction == 2)
	{
		viewerFrom = cmpObj.getLeftViewer();
		viewerTo = cmpObj.getRightViewer();
	}
	else
	{
		viewerFrom = cmpObj.getRightViewer();
		viewerTo = cmpObj.getLeftViewer();
	}
	
	objFrom = viewerFrom.getObject(sGroup,nId);
	objTo = viewerTo.getObject(sGroup,nId);
	
	if (objFrom == null)
	{
		if (doAlert)
		{
			var txObj = sGroup + (nId > 0?"@" + nId:"");
			if (direction == 2)
				alert(UR("Об'єкт " + txObj + " зліва не існує|Объект " + txObj + " слева не существует"));
			else
				alert(UR("Об'єкт " + txObj + " справа не існує|Объект " + txObj + " справа не существует"));
		}
		return false;
	}
	
	if (objTo == null)
	{
		var cnfrm = msgBox("yn"
						,UR("Об'єкт-приймач не існує.\nПеренести цілий об'єкт?|"
						+ "Объект-приёмник не существует.\nПеренести целый объект?")
						,UR("Попередження|Предупреждение"));
		if (cnfrm == "y")
		{
			return setObject(sGroup,nId,direction);
		}
		return false;
	}
	
	viewerTo.setValue(sGroup,nId,sSub,sVar,viewerFrom.getValue(sGroup,nId,sSub,sVar));
	
	var cmpRes = cmpObj.getCMPVar(sGroup,nId,sSub,sVar);
	var itmID = sGroup + (nId > 0?"@" + nId:"") + "#" + sSub + "#" + sVar;
	
	if (!Tree.getItem(itmID))
		return true;
	
	if ((cmpRes.CMPStatus & usedFilter) == 0
		&& (cmpRes.CMPStatus + usedFilter) != 0
		&& usedFilter >= 0)
	{
		Tree.removeItem(itmID);
	}
	else
	{
		Tree.setValue(itmID,"value_left",getTextValue(cmpRes.value1));
		Tree.setValue(itmID,"value_right",getTextValue(cmpRes.value2));
		Tree.setValue(itmID,"status",getCMPStatusText(cmpRes.CMPStatus));
		setItemColor(itmID,cmpRes.CMPStatus,false);
	}
	
	return true;
}

function initTree()
{
	Tree.addColumn("main","",250);
	Tree.addColumn("value_left",UR("Значення 1|Значение 1"),100);
	Tree.addColumn("status","",30);
	Tree.addColumn("value_right",UR("Значення 2|Значение 2"),100);
	
	var objHandler = new Object();
	objHandler.canEdit = function(){return false;}
	
	Tree.setCanEditHandler(objHandler,"canEdit");
}

function fillTree()
{
	Tree.Lock();
	Tree.addItem("0","HEAD",
				cmpObj.getLeftObject().getName() + " (" + cmpObj.getLeftObject().getID() + ") - "
			  + cmpObj.getRightObject().getName() + " (" + cmpObj.getRightObject().getID() + ")");
	appendObject("HEAD","HEAD",cmpObj);
	Tree.Unlock();
}

function appendObject(rootID,sPrefix,oComparer)
{
	Tree.addItem(rootID,sPrefix + "#VARS",UR("Змінні|Переменные"));
	appendVars(sPrefix + "#VARS",sPrefix,oComparer);
	
	Tree.addItem(rootID,sPrefix + "#EXTS",UR("Розширення|Расширения"));
	appendExts(sPrefix + "#EXTS",sPrefix,oComparer);
	
	var chldClasses = oComparer.getChildClasses();
	if (chldClasses.length > 0 /*&& sPrefix == "HEAD"*/)
	{
		Tree.addItem(rootID,sPrefix + "#CHILDS",UR("Строки"));
		for (var nClass = 0; nClass < chldClasses.length; nClass++)
		{
			var sClass = chldClasses[nClass];
			Tree.addItem(sPrefix + "#CHILDS",sPrefix + "#" + sClass,sClass);
			var chldList = oComparer.getCMPChildsList(sClass);// cmpObj.getCMPChildsList(sClass);
			var bAnyAdded = false;
			for (var chIDX in chldList)
			{
				var cmpStatus = chldList[chIDX].CMPStatus;
				if ((cmpStatus & usedFilter) == 0 && (cmpStatus + usedFilter) != 0 && usedFilter >= 0)
					continue;
				bAnyAdded = true;
				Tree.addItem(sPrefix + "#" + sClass,chIDX,chIDX);
				if (chldList[chIDX].CMPStatus == CMP_NOTEXISTS_LEFT
					|| chldList[chIDX].CMPStatus == CMP_NOTEXISTS_RIGHT)
					setItemColor(chIDX,cmpStatus,true);
				appendObject(chIDX,chIDX,chldList[chIDX].objComparer);
				Tree.setValue(chIDX,"status",getCMPStatusText(cmpStatus));
				Tree.getItem(chIDX).setData("CMP_DATA",chldList[chIDX]);
			}
			if (!bAnyAdded)
				Tree.removeItem(sPrefix + "#" + sClass);
		}
	}
}

function appendVars(nodeID,sPrefix,oComparer)
{
	var cmpVarList = oComparer.getCMPVarList();
	var bAnyAdded = false;
	for (var sVar in cmpVarList)
	{
		var cmpStatus = cmpVarList[sVar].CMPStatus;
		if ((cmpStatus & usedFilter) == 0 && (cmpStatus + usedFilter) != 0 && usedFilter >= 0)
			continue;
		bAnyAdded = true;
		var itmID = sPrefix + "#VAR#" + cmpVarList[sVar].varName;
		var varText = cmpVarList[sVar].varName + (String(cmpVarList[sVar].varText).length > 0?"(" + cmpVarList[sVar].varText + ")":"");
		Tree.addItem(nodeID,itmID,varText,3);
		Tree.setValue(itmID,"value_left",getTextValue(cmpVarList[sVar].value1));
		Tree.setValue(itmID,"value_right",getTextValue(cmpVarList[sVar].value2));
		Tree.setValue(itmID,"status",getCMPStatusText(cmpStatus));
		setItemColor(itmID,cmpStatus,false);
		Tree.getItem(itmID).setData("CMP_DATA",cmpVarList[sVar]);
	}
	if (!bAnyAdded)
		Tree.removeItem(nodeID);
}

function appendExts(nodeID,sPrefix,oComparer)
{
	var cmpExtList = oComparer.getCMPExtList();
	var bAnyAdded = false;
	for (var sExt in cmpExtList)
	{
		var cmpStatus = cmpExtList[sExt].CMPStatus;
		if ((cmpStatus & usedFilter) == 0 && (cmpStatus + usedFilter) != 0 && usedFilter >= 0)
			continue;
		bAnyAdded = true;
		var itmID = sPrefix + "#EXT#" + cmpExtList[sExt].varName;
		var varText = cmpExtList[sExt].varName + "(" + cmpExtList[sExt].varText + ")"
		Tree.addItem(nodeID,itmID,varText,3);
		Tree.setValue(itmID,"value_left",getTextValue(cmpExtList[sExt].value1));
		Tree.setValue(itmID,"value_right",getTextValue(cmpExtList[sExt].value2));
		Tree.setValue(itmID,"status",getCMPStatusText(cmpStatus));
		setItemColor(itmID,cmpStatus,false);
		Tree.getItem(itmID).setData("CMP_DATA",cmpExtList[sExt]);
	}
	if (!bAnyAdded)
		Tree.removeItem(nodeID);
}

function getTextValue(oVal)
{
	if (oVal == null)
		return "";
	if (typeof(oVal) == "date" || typeof(oVal.getTime) == "function")
	{
		return format("dd.mm.yyyy",oVal);
	}
	return String(oVal);
}

function setItemColor(sItemID,nCompareStatus,bRow)
{
	var oColor = null;
	switch(nCompareStatus)
	{
		case CMP_EQUAL:
			oColor = (bRow?CRow_equal:CVar_equal);
			break;
		case CMP_NOTEQUAL:
			oColor = (bRow?CRow_notEqual:CVar_notEqual);
			break;
		case CMP_NOTEXISTS_LEFT:
			oColor = (bRow?CRow_notExistLeft:CVar_notExistLeft);
			break;
		case CMP_NOTEXISTS_RIGHT:
			oColor = (bRow?CRow_notExistRight:CVar_notExistRight);
			break;
	}
	if (oColor != null)
		Tree.setItemColor(sItemID,oColor.red,oColor.green,oColor.blue);
}

function getCMPStatusText(nStatus)
{
	switch(nStatus)
	{
		case CMP_EQUAL:
			return "=";
		case CMP_NOTEQUAL:
			return "<>";
		case CMP_NOTEXISTS_LEFT:
			return "?/=";
		case CMP_NOTEXISTS_RIGHT:
			return "=/?"
	}
}

function parseID(sItmID)
{
	sItmID = String(sItmID);
	var grpArr = new Array();
	while(sItmID.length > 0 && sItmID.indexOf("#") > 0)
	{
		var nInd = sItmID.indexOf("#");
		grpArr[grpArr.length] = sItmID.substring(0,nInd);
		sItmID = sItmID.substr(nInd + 1);
	}
	grpArr[grpArr.length] = sItmID;
	
	var retObj = new Object();
	retObj.Group = grpArr[0];
	retObj.SubGroup = grpArr[1];
	retObj.Entry = grpArr[2];
	retObj.ID = -1;
	
	if (retObj.Group.indexOf("@") > 0)
	{
		var nInd = retObj.Group.indexOf("@");
		retObj.ID = retObj.Group.substr(nInd + 1);
		retObj.Group = retObj.Group.substring(0,nInd);
	}
	
	return retObj;
}

var CVar_equal = {red:255,green:255,blue:255};
var CVar_notEqual = {red:255,green:153,blue:153};
var CVar_notExistRight = CVar_notEqual;
var CVar_notExistLeft = CVar_notEqual;

var CRow_equal = CVar_equal;
var CRow_notEqual = CVar_notEqual;
var CRow_notExistRight = CVar_notExistRight;
var CRow_notExistLeft = CVar_notExistLeft;