﻿include("Objects/DpScExpr.js");

var oDoplat;
var Validation = true;

function Load()
{
	edmode = extPar.mode;
	Caption(ru("Настройки для метода DISTR", "Налаштування для метода DISTR"), edmode);
	table = extPar.m_pTable;

	createObjects();
	setMasks();
	enableFields();
	
	setValid(Fbdat, mFbdat_Valid);
	setValid(Fedat, mFedat_Valid);	
}

function createObjects()
{
	objFdb_sc =		new DpScExpr("SC", mFsc_to);
	objFdb_su = 	new DpScExpr("SC", mFsu_to);
	objFdb_st = 	new DpScExpr("SC", mFst_to);

	objFdb_cod1 =   new DpScExpr("AN1", mFcl1_to);
	objFdb_cod2 =   new DpScExpr("AN2", mFcl2_to);
	objFdb_cod3 =   new DpScExpr("AN3", mFcl3_to);

	objFdb_sc.addCl_schet(objFdb_sc, objFdb_su, objFdb_st, objFdb_cod1, objFdb_cod2, objFdb_cod3);
	objFdb_su.addCl_schet(objFdb_sc, objFdb_su, objFdb_st, objFdb_cod1, objFdb_cod2, objFdb_cod3);
	objFdb_st.addCl_schet(objFdb_sc, objFdb_su, objFdb_st, objFdb_cod1, objFdb_cod2, objFdb_cod3);

	objFdb_cod1.addCl_schet(objFdb_sc, objFdb_su, objFdb_st, objFdb_cod1, objFdb_cod2, objFdb_cod3);
	objFdb_cod2.addCl_schet(objFdb_sc, objFdb_su, objFdb_st, objFdb_cod1, objFdb_cod2, objFdb_cod3);
	objFdb_cod3.addCl_schet(objFdb_sc, objFdb_su, objFdb_st, objFdb_cod1, objFdb_cod2, objFdb_cod3);
}

function enableFields()
{
	switch (extPar.sposob)
	{
		case "DISTR":
			expr.setVisible(true);
			proc.setVisible(false);
		break;
		case "TRANSF":
			expr.setVisible(false);
			proc.setVisible(true);
		break;
		default:
		break;
	}
	
	
	switch(edmode)
	{
		case "EDIT":
		case "COPY":
			objFdb_sc.setValue(toScrObj(table.getValue("FSC_TO")));
			objFdb_su.setValue(toScrObj(table.getValue("fSU_TO")));
			objFdb_st.setValue(toScrObj(table.getValue("fST_TO")));

			objFdb_cod1.setValue(toScrObj(table.getValue("FCOD1_TO")));
			objFdb_cod2.setValue(toScrObj(table.getValue("FCOD2_TO")));
			objFdb_cod3.setValue(toScrObj(table.getValue("FCOD3_TO")));
			
			objFdb_cod1.typeValue = toScrObj(table.getValue("FCOD1_TYPE"));
			objFdb_cod2.typeValue = toScrObj(table.getValue("FCOD2_TYPE"));
			objFdb_cod3.typeValue = toScrObj(table.getValue("FCOD3_TYPE"));

			Fbdat.setValue(toScrObj(table.getValue("Fbdat")));
			Fedat.setValue(toScrObj(table.getValue("Fedat")));
			//mFgroup.value = table.getValue("Fgroup");
			mFexpr.setValue(toScrObj(table.getValue("Fexpr")));
			mFproc.setValue(toScrObj(table.getValue("Fproc")));
		break;
		case "ADD":
			switch (extPar.sposob)
			{
				case "TRANSF":
					Fbdat.setValue(d00);
					Fedat.setValue(d00);
				break;
				default:
					Fbdat.setValue(extPar.bdat);
					Fedat.setValue(extPar.edat);
				break;
			}

			//mFgroup.value = 0;
			mFexpr.setValue("1");
			mFproc.setValue("0");
		break;
	}
}

function setMasks()
{
	mFexpr.setMask(replicate("&", 255));
	mFproc.setMask("#####.#####");
}

function mFedat_Valid()
{
	if (inList(extPar.sposob, "DISTR") && toScrObj(Fedat.getValue()) >= d00 && toScrObj(Fedat.getValue()) <= d00)
	{
		return true;
	}

	if (differ(toScrObj(Fedat.getValue()), toScrObj(Fbdat.getValue())) < 0)
	{
		WAIT(ru("Дата конца периода не может быть меньше даты начала", "Дата закінчення періоду не може бути меншою за дату початку"));
		Fedat.setValue(toScrObj(Fbdat.getValue()));
		return false;
	}
	
	return true;
}


function mFbdat_Valid()
{
	if (inList(extPar.sposob, "DISTR") && toScrObj(Fbdat.getValue()) >= d00 && toScrObj(Fbdat.getValue()) <= d00)
	{
		WAIT(ru("Введите дату начала периода", "Введіть дату початку періоду"));
		return false;
	}

	if (differ(toScrObj(Fedat.getValue()), toScrObj(Fbdat.getValue())) < 0)
	{
		WAIT(ru("Дата окончания периода не может быть меньше даты начала", "Дата закінчення періоду не може бути меншою за дату початку"));
		Fedat.setValue(toScrObj(Fbdat.getValue()));
		return false;
	}
	
	return true;
}

function onSave()
{
	var m = new Object();
	switch(edmode)
	{
		case "EDIT":
			m.FWID = toScrObj(table.getValue("FWID"));
		break;
		case "ADD":
		case "COPY":
			m.FWID = GetUID();
		break;
		default:
		break;
	}

	m.FID_DOC 	= extPar.id_doc;
	m.FBDAT 	= toScrObj(Fbdat.getValue());
	m.FEDAT 	= toScrObj(Fedat.getValue());
	//m.FGROUP 	= mFgroup.value;
	m.FEXPR 	= toScrObj(mFexpr.getValue());
	m.FPROC 	= toScrObj(mFproc.getValue());

	m.Fsc_to 	= toScrObj(objFdb_sc.getValue());
	m.Fsu_to 	= toScrObj(objFdb_su.getValue());
	m.Fst_to 	= toScrObj(objFdb_st.getValue());
	m.Fcod1_to 	= toScrObj(objFdb_cod1.getValue());
	m.Fcod2_to	= toScrObj(objFdb_cod2.getValue());
	m.Fcod3_to 	= toScrObj(objFdb_cod3.getValue());
	m.Fcod1_type 	= toScrObj(objFdb_cod1.typeValue);
	m.Fcod2_type	= toScrObj(objFdb_cod2.typeValue);
	m.Fcod3_type 	= toScrObj(objFdb_cod3.typeValue);
	
	UpdateTable(extPar.tbl, m, edmode != "EDIT");
	CloseWindow();
}

function onEscape()
{
	CloseWindow();
}

include("sys/DpBaseDlg.js");