include("Objects/DpCl.js");
include("Objects/DpClcl.js");
include("Objects/DpNmkl.js");
include("Objects/DpSc.js");

var mode = extPar.mode;
var pnt = FORM.getControlComposite();
var tbl = extPar.tbl;
var fwid_cl = extPar.fwid_cl;
var vid = extPar.vid;
var Fwid;

var oCl, oClCl, oNmkl, oSc;

function Load()
{
	Caption(ru("",""), modeName(mode));
		
	FNOM.setMask(replicate("#", 12));
	FNAME.setMask(replicate("&", 50));
	FDESCR.setMask(replicate("&", 255));
	FWIDTH.setMask(replicate("#", 4));
	FDR.setMask(replicate("#", 4));
	FREM.setMask(replicate("&", 255));
	
	FNUM.setMask("##########.#####");
	FTEXT.setMask(replicate("&", 255));
	
	FRELVAR.setMask(replicate("&", 50));
	FSCRLEN.setMask(replicate("#", 12));
		
	strSQL = "SELECT MAX(FNOM)" 
				+" FROM "+tbl.getTableName()
				+" WHERE 1=1"
	var sn = getSnap(strSQL);
	var nom = 1;
	if(sn != null && !isEmpty(sn[0]))
	{
		nom = sn[0]+1;
	}
		
	//справочник
	oClCl = new DpClcl();
	oClCl.linkCtrl(FCLCL);
	oClCl.mode = "0";
	oCl = new DpCl();
	oCl.setMode("0");
	oCl.linkSmartCtrl(FCL);
	
	//номенклатура
	oNmkl = new DpNmkl();	
	oNmkl.CanEmpty = true;	
	oNmkl.mode = "";
	oNmkl.linkSmartCtrl(FNMKL);
	
	//счет
	oSc = new DpSc();
		
	if(inList(mode, "EDIT", "COPY"))
	{
		FNOM.setValue(tbl.getValue("FNOM"));
		FNAME.setValue(tbl.getValue("FNAME"));
		FDESCR.setValue(tbl.getValue("FDESCR"));
		FTYPE.setValue(tbl.getValue("FTYPE"));
		FWIDTH.setValue(tbl.getValue("FWIDTH"));
		FREM.setValue(tbl.getValue("FREM"));
		FIS0SLCT.setValue(tbl.getValue("FIS0SLCT"));
		FISGROUP.setValue(tbl.getValue("FISGROUP"));
		FISVIS.setValue(tbl.getValue("FISVIS"));
		FNUM.setValue(tbl.getValue("FNUM"));
		FDATETIME.setValue(tbl.getValue("FDATETIME"));
		FTEXT.setValue(tbl.getValue("FTEXT"));
		FBOOL.setValue(tbl.getValue("FBOOL"));
		FCL.setValue(Number(tbl.getValue("FCL")) == 0 ? "" : Number(tbl.getValue("FCL")));
		FSC.setValue(tbl.getValue("FSC"));
		FSU.setValue(tbl.getValue("FSU"));
		FST.setValue(tbl.getValue("FST"));
		FCL_COD1.setValue(tbl.getValue("FCL_COD1"));
		FCL_COD2.setValue(tbl.getValue("FCL_COD2"));
		FCL_COD3.setValue(tbl.getValue("FCL_COD3"));
		FRELTYPE.setValue(tbl.getValue("FRELTYPE"));
		FRELVAR.setValue(tbl.getValue("FRELVAR"));
		FSCRLEN.setValue(tbl.getValue("FSCRLEN"));
		Fwid = Number(tbl.getValue("FWID"));
	}

	if(inList(mode, "ADD", "COPY"))
	{
		if(mode == "ADD")
		{
			FIS0SLCT.setValue(true);
			FISVIS.setValue(true);
		}
		FNOM.setValue(nom);
	}
	
	FTYPE_valid();
	FRELTYPE_valid();
	setValid(FTYPE, FTYPE_valid);
	setValid(FCLCL, FCLCL_valid);
	setValid(FISGROUP, FISGROUP_valid);
	setValid(FRELTYPE, FRELTYPE_valid);
	setValid(FNAME, FNAME_valid);
	setValid(FDESCR, FDESCR_valid);
}


function FISGROUP_valid()
{
	if(FISGROUP.checked)
	{
		oNmkl.CanSelectGroup = true;
	}
	else
	{
		oNmkl.CanSelectGroup = false;
	}
	
	return true;
}

function FRELTYPE_valid()
{
	if(String(FRELTYPE.getValue()) == "NONE")
	{
		Disable(FRELVAR);
	}
	else
	{
		Enable(FRELVAR);
	}
	return true;
}

function FCLCL_valid()
{
	var ret = false;
	var nSpr = oClCl.getCod();
	if(!isEmpty(nSpr))
	{
		oCl.setClcl(nSpr);
		//oCl.setCod(0);
		ret = true;
	}
	return ret;
}

function FTYPE_valid()
{
	FDEF_NUMBER_GR.setVisible(false);
	FDEF_DATE_GR.setVisible(false);
	FDEF_TEXT_GR.setVisible(false);
	FDEF_NMK_GR.setVisible(false);
	FDEF_BOOL_GR.setVisible(false);
	FDEF_CL_GR.setVisible(false);
	FDEF_C_GR.setVisible(false);
	FSU.setVisible(false);
	FST.setVisible(false);
	FCL_COD1.setVisible(false);
	FCL_COD2.setVisible(false);
	FCL_COD3.setVisible(false);
	FISGROUP_GR.setVisible(false);
	Disable(FWIDTH);
	Disable(FDR);
	
	var type = String(FTYPE.getValue()).trim();
	switch (type)
	{
		case "D":
			FDEF_DATE_GR.setVisible(true);
			break;
		case "T":
			FDEF_TEXT_GR.setVisible(true);
			Enable(FWIDTH);
			break;
		case "NUM":
			FDEF_NUMBER_GR.setVisible(true);
			Enable(FWIDTH);
			Enable(FDR);
			break;
		case "B":
			FDEF_BOOL_GR.setVisible(true);
			break;
		case "CL":
			FDEF_CL_GR.setVisible(true)
			break;
		case "REL":
			break;
		case "NMK":
			FDEF_NMK_GR.setVisible(true)
			FISGROUP_GR.setVisible(true);
			break;
		case "C":
			FDEF_C_GR.setVisible(true)
			
			oSc.setMode("c0");
			oSc.linkCtrl(FSC);
			break;
		case "CU":
			FDEF_C_GR.setVisible(true)
			FSU.setVisible(true)
			
			oSc.setMode("c0u");
			oSc.linkCtrl(FSC, FSU);
			break;
		case "CUT":
			FDEF_C_GR.setVisible(true)
			FSU.setVisible(true)
			FST.setVisible(true)
			
			oSc.setMode("c0ut");
			oSc.linkCtrl(FSC, FSU, FST);
			break;
		case "CUTX":
			FDEF_C_GR.setVisible(true)
			FSU.setVisible(true)
			FST.setVisible(true)
			FCL_COD1.setVisible(true)
			
			oSc.setMode("c0utx");
			oSc.linkCtrl(FSC, FSU, FST, FCL_COD1);
			break;
		case "CUTXY":
			FDEF_C_GR.setVisible(true)
			FSU.setVisible(true)
			FST.setVisible(true)
			FCL_COD1.setVisible(true)
			FCL_COD2.setVisible(true)
			
			oSc.setMode("c0utxy");
			oSc.linkCtrl(FSC, FSU, FST, FCL_COD1, FCL_COD2);
			break;
		case "CUTXYZ":
			FDEF_C_GR.setVisible(true)
			FSU.setVisible(true)
			FST.setVisible(true)
			FCL_COD1.setVisible(true)
			FCL_COD2.setVisible(true)
			FCL_COD3.setVisible(true)
			
			oSc.setMode("c0utxyz");
			oSc.linkCtrl(FSC, FSU, FST, FCL_COD1, FCL_COD2, FCL_COD3);
			break;
		default:
			break;
	}
	
	pnt.pack();
	pnt.getShell().pack();
	pnt.redraw();
	pnt.layout(true);
	return true;
}

function FNAME_valid()
{
	var ret = true;
	if(isEmpty(String(FNAME.getValue())))
	{
		ret = false;
		FNAME.showErr(ru("Имя не может быть пустым."
								, "Ім'я не може бути пустим."));
		setFocus(FNAME);
	}
	return ret;
}

function FDESCR_valid()
{
	var ret = true;
	if(isEmpty(String(FDESCR.getValue())))
	{
		ret = false;
		FDESCR.showErr(ru("Назва не может быть пустым."
								, "Наименование не може бути пустим."));
		setFocus(FDESCR);
	}
	return ret;
}

function onSave()
{
	var m = new Object();
	
	m.FWID = (mode != "EDIT" ? GetUID() : Fwid);
	__SaveFWID(tbl);
	   
	m.FNOM = FNOM.getValue();
	m.FNAME = FNAME.getValue();
	m.FDESCR = FDESCR.getValue();
	m.FTYPE = FTYPE.getValue();
	m.FWIDTH = FWIDTH.getValue();
	m.FDR = FDR.getValue();
	m.FREM = FREM.getValue();
	m.FIS0SLCT = FIS0SLCT.checked;
	m.FISGROUP = FIS0SLCT.checked;
	m.FISVIS = FISVIS.checked;
	m.FDATETIME = FDATETIME.getValue();
	m.FBOOL = FBOOL.getValue();
	m.FCL = oClCl.getCod();
	m.FSC = oSc.getSc();
	m.FSU = oSc.getSu();
	m.FST = oSc.getSt();
	m.FCL_COD1 = oSc.getCl1();
	m.FCL_COD2 = oSc.getCl2();
	m.FCL_COD3 = oSc.getCl3();
	m.FRELTYPE = FRELTYPE.getValue();
	m.FRELVAR = FRELVAR.getValue();
	m.FSCRLEN = FSCRLEN.getValue();
	m.FVID = vid;
	
	switch (String(m.FTYPE))
	{
		case "NUM":
			m.FNUM = FNUM.getValue();
			break;
		case "CL":
			m.FNUM = oCl.getCod();
			break;
		case "T":
			m.FTEXT = FTEXT.getValue();
			break;
		case "NMK":
			m.FTEXT = oNmkl.getCod();
			break;
		default:
			break;
	}
					 
	UpdateTable(tbl.getTableName(), m);
}

include("sys\\DpBaseDlg.js");