include("Objects/DpDbMod.js");
var dbMod;
function Load()
{
	if (extPar.actionType == "EXPORT")
		runExport();
	if (extPar.actionType == "IMPORT")
		runImport();
}

var PROGRESS_STEP_TYPE_TBLEXPORT = 1;
var PROGRESS_STEP_TYPE_ROWEXPORT_START = 2;
var PROGRESS_STEP_TYPE_ROWEXPORT = 3;

var PROGRESS_STEP_TYPE_TBLIMPORT = 1;
var PROGRESS_STEP_TYPE_ROWIMPORT = 2;
var PROGRESS_STEP_TYPE_PREPARSE = 3;


function runImport()
{
	Caption(UR("Імпорт бази даних|Импорт базы данных"));
	TXT_COM.setEnabled(false);
	TXT_COM.setValue(UR("Імпорт з |Импорт из ") + (extPar.jdbcConnectString?UR("джерела JDBC|источника JDBC"):extPar.sFile) + UR(" до | в ") + extPar.sBase);
	TXT_TBL.setEnabled(false);
	TXT_ROW.setEnabled(false);
	
	var importer = extPar.importer;
	
	dbMod = new DpDbMod();
	if(!extPar.otherBase)
		dbMod.dropViews();
	
	importer.setProgressListener
	(
		lpProxy.getUtils().getProgressAdapter
		(	
			{
				processStarted: function(par1){imp_processStarted(par1);},
				processStep: function(par1,par2){imp_processStep(par1,par2);},
				processEnded: function(){imp_processEnded();}
			}
		)
	);
	
	if(extPar.jdbcConnectString)
	{
		importer.setUser(extPar.jdbcUser);
		importer.setPassword(extPar.jdbcPassword);
		importer.setConnection(getDBConnectionEx(extPar.jdbcConnectString, extPar.jdbcUser, extPar.jdbcPassword));
	}
	
	var impThread = new java.lang.Thread
	(
		function ()
		{
			try
			{
				if(extPar.jdbcConnectString)
				{
					importer.runImport(extPar.sBase,extPar.jdbcConnectString,extPar.tables,true);
				}
				else
				{
					importer.runImport(extPar.sBase,extPar.sFile,extPar.tables,true);
				}
			}
			catch(ex)
			{
				Packages.org.eclipse.swt.widgets.Display
					.getDefault().syncExec
				(
					function ()
					{
						alert( UR("Помилка при імпорті |Ошибка при импорте ") + ex);
						FORM.close();
					}
				);
			}
		}
	);
	
	impThread.start();
}

function imp_processStarted(processLength)
{
	Packages.org.eclipse.swt.widgets.Display
		.getDefault().syncExec
	(
		function ()
		{
			TXT_TBL.setValue(UR("Підготовка до імпорту..."
							+ "|Подготовка к импорту..."));
			PR_TBL.setMinimum(0);
			PR_TBL.setMaximum(processLength);
			PR_TBL.setSelection(0);
		}
	);
}

function imp_processEnded()
{
	Packages.org.eclipse.swt.widgets.Display
		.getDefault().syncExec
	(
		function ()
		{
			//для нулевой версии базы представления не создаем, т.к. при последующей перекодировке могут быть проблемы
			sDBVer = lpProxy.getDBManager().getDBVersion()
			if(DpUtils.compareVersion(sDBVer,"0.0.0")!=0 && !extPar.otherBase)
				dbMod.createViews(false);
			FORM.close();
		}
	);
}

var impRowCount = 0;

function imp_processStep(stepType,info)
{
	if (stepType == PROGRESS_STEP_TYPE_TBLIMPORT)
	{
		Packages.org.eclipse.swt.widgets.Display
		.getDefault().syncExec
		(
			function ()
			{
				TXT_TBL.setValue(UR("Імпорт |Импорт ") + info[0]);
				PR_TBL.setSelection(PR_TBL.getSelection() + 1);
				PR_ROW.setMinimum(0);
				PR_ROW.setMaximum(info[1]);
				PR_ROW.setSelection(0);
				TXT_ROW.setValue("0/" + parseInt(info[1]));
				impRowCount = 0;
			}
		);
	}
	else if (stepType == PROGRESS_STEP_TYPE_PREPARSE)
	{
		Packages.org.eclipse.swt.widgets.Display
		.getDefault().syncExec
		(
			function()
			{
				TXT_TBL.setValue(UR("Збір інформації... | Сбор информации..."));
				PR_TBL.setSelection(PR_TBL.getSelection() + 1);
				PR_ROW.setMinimum(0);
				PR_ROW.setMaximum(0);
				PR_ROW.setSelection(0);
				TXT_ROW.setValue("???");
				impRowCount = 0;
			}
		);
	}
	else if (stepType == PROGRESS_STEP_TYPE_ROWIMPORT)
	{
		impRowCount++;
		if ((impRowCount % 500) == 0)
		{
			Packages.org.eclipse.swt.widgets.Display
			.getDefault().syncExec
			(
				function()
				{
					PR_ROW.setSelection(impRowCount);
					TXT_ROW.setValue(impRowCount + "/" + PR_ROW.getMaximum());
				}
			);
		}
	}
}

function runExport()
{
	Caption(UR("Експорт бази даних |Экспорт базы данных ") + extPar.base);
	TXT_COM.setEnabled(false);
	TXT_COM.setValue(UR("Експорт бази даних |Экспорт базы данных ") + extPar.base);
	TXT_TBL.setEnabled(false);
	TXT_ROW.setEnabled(false);
	
	var exporter = String(extPar.file).endsWith(".mdb")?lpProxy.getUtils().getMDBExporter():lpProxy.getUtils().getDBExporter();
	
	exporter.setProgressListener(
	lpProxy.getUtils().getProgressAdapter({
			processStarted: function(par1){processStarted(par1);},
			processStep: function(par1,par2){processStep(par1,par2);},
			processEnded: function(){processEnded();}
		})
		);
	var exportThread = new java.lang.Thread
	(
		function run()
		{
			try
			{
				exporter.exportToXML(extPar.base,extPar.file,extPar.tables,true);
			}
			catch(ex)
			{
				Packages.org.eclipse.swt.widgets.Display
					.getDefault().syncExec
				(
					function ()
					{
			
						alert(UR("Помилка при експорті |Ошибка при экспорте ") + ex);
						FORM.close();
					}
				);
			}
		}
	);
	
	exportThread.start();
}

function processEnded()
{
	Packages.org.eclipse.swt.widgets.Display
		.getDefault().syncExec
	(
		function ()
		{
			FORM.close();
		}
	);
}


function processStarted(processLength)
{
	Packages.org.eclipse.swt.widgets.Display
		.getDefault().syncExec
	(
		function ()
		{
			TXT_TBL.setValue(UR("Підготовка до експорту..."
							+ "|Подготовка к экспорту..."));
			PR_TBL.setMinimum(0);
			PR_TBL.setMaximum(processLength);
			PR_TBL.setSelection(0);
		}
	)
}

function processStep(stepType,someInfo)
{
	Packages.org.eclipse.swt.widgets.Display
		.getDefault().syncExec
	(
		function ()
		{
			if (stepType == PROGRESS_STEP_TYPE_TBLEXPORT)
			{
				TXT_TBL.setValue(UR("Експорт |Экспорт ") + someInfo);
				PR_TBL.setSelection(PR_TBL.getSelection() + 1);
				PR_ROW.setSelection(0);
				TXT_ROW.setValue("");
			}
			else if (stepType == PROGRESS_STEP_TYPE_ROWEXPORT_START)
			{
				if (someInfo == -1)
				{
					TXT_ROW.setValue("???");
					PR_ROW.setSelection(0);
					PR_ROW.setMinimum(0);
					PR_ROW.setMaximum(0);
				}
				else
				{
					TXT_ROW.setValue("0/" + parseInt(someInfo));
					PR_ROW.setMinimum(0);
					PR_ROW.setMaximum(someInfo);
					PR_ROW.setSelection(0);
				}
			}
			else if (stepType == PROGRESS_STEP_TYPE_ROWEXPORT)
			{
				if ((someInfo % 10 == 0) && PR_ROW.getMaximum() != 0)
				{
					TXT_ROW.setValue(parseInt(someInfo)
							+ "/" + parseInt(PR_ROW.getMaximum()));
					PR_ROW.setSelection(someInfo);
				}
			}
		}
	);
}