include("doc/DpDoc.js");
include("sys/udfs.js");
include ("iCalApi.js");
var codCategory =  getPar("CRM_EVENT_CAT");
var doc = "EVENT";
var nop = 0;
var dayCount = 7;

function gadgetLoad()
{		
	if(Task.getMenuMode())
		nop = Number(Task.getMenuMode());
	/*
	var tbl = OpenTable("select * from ^LISTEVENT"
						+" where FBDATE>="+ sqlTo(today)
						+(nop? " and FNOP="+ nop : "")
						+" order by FBDATE"
						);
	*/					
	var tbl = fillEventsTableTable();
	grid.setTable(tbl);
	grid.build();
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid.loadMenuHandler(this, "gridMenuInit");
	grid.selectMenuHandler(this, "gridMenuRun");
}

function fillEventsTableTable()
{
	this.tbl = createObjectTable();
	this.tbl.setIdFld("FWID"); 
	
	var source = getJavaClass("org.debet.utils.DpiCalSource").newInstance();
	var iCalDir = userDirectory() + "iCals";
	createDirectory(iCalDir);
	var dir = new DpFile(iCalDir);
	var files = dir.listFiles();
	for (var i = 0; i < files.length; i++)
	{
		if (files[i].isDirectory() || !files[i].getName().endsWith(".ics"))
			continue;
		source.addCalendar(files[i].getAbsolutePath());		
	}
	var dat1 = today.getVarDate();
	var dat2 = new Date(goDay(dat1, dayCount - 1)).getVarDate();
	
	var listEvent = new Array();
	
	var arrEvents = source.getEventsForPeriod(dat1, dat2);	
	
	
	for ( var i = 0; i < arrEvents.length; i++)
	{
		var event = arrEvents[i];		
		var periods = event.getDatesForPeriod(dat1, dat2);
		
		for ( var j = 0; j < periods.size(); j++)
		{
			var period = periods.get(j);
			var row = new Object();
			row.FWID = event.getUID();
			row.FSUBJECT = event.getSummury();
			
			row.FBDATE = new Date(period.start.getTime()).getVarDate();
			row.FEDATE = new Date(period.end.getTime()).getVarDate();
			row.FISALLDAY = event.isAllDayEvent();
			row.FISDOC = false;
			row.FEVENT = event;
			listEvent[listEvent.length] = row;
			
		}
	}
	
	var dbsource = getJavaClass("org.debet.utils.DpDocEventSource").newInstance();
	var arrEvents = dbsource.getEventsForPeriod(dat1, dat2);
	
	for ( var i = 0; i < arrEvents.length; i++)
	{
		var event = arrEvents[i];		
		var periods = event.getDatesForPeriod(dat1, dat2);
		for ( var j = 0; j < periods.size(); j++)
		{
			var period = periods.get(j);
			var row = new Object();
			row.FWID = event.getUID();
			row.FSUBJECT = event.getSummury();
			row.FBDATE = new Date(period.start.getTime()).getVarDate();
			row.FEDATE = new Date(period.end.getTime()).getVarDate();
			row.FISALLDAY = event.isAllDayEvent();
			row.FISDOC = true;
			listEvent[listEvent.length] = row;
			
		}
	}
	
	listEvent.sort(sortEvents);
	
	for (var i = 0; i < listEvent.length; i++)
	{
		this.tbl.AddNew();
		for (var j in listEvent[i])
		{
			this.tbl.setValue(j, listEvent[i][j]);
		}
		this.tbl.Update();
	}
	
	return this.tbl;
}

function sortEvents(e1, e2)
{
	if(Number(e1.FBDATE.getTime()) < Number(e2.FBDATE.getTime()))
		return -1;
	else
		return 1;
}

function getEventDateTxt(date, isAllDay)
{
	var ret = "";
	if (isAllDay)
		ret = (dayCount > 1 ? (format("dd.mm.yyyy", date) + " ") : "") + UR("Весь день|Весь день");
	else
		ret = format(dayCount > 1?"dd.mm.yyyy th:tm":"th:tm", date);
	return ret;
}

function getEventsCategory()
{
	var ret = "";
	if (codCategory == 0)
		return ret;
	var tblGrid = grid.getTable();
	var isDoc = tblGrid.getValue("FISDOC");
	if (isDoc == true)
	{
		var nID = String(tblGrid.getValue("FWID"));
		nID = Number(nID.substring(2));
		if (isNaN(nID))
			return;
		
		var tbl = OpenTable ("select cl.ftxt as ftxt  from ^revcateg r inner join ^listcl cl " +
				" on r.fcategory = cl.fcod and  cl.FCL = " + codCategory + " where r.fid_doc = " + sqlTo(nID));		
		while (!tbl.isEOF())
		{
			if (ret != "")
				ret += ",";
			ret +=  String(tbl.getValue("ftxt"));
			tbl.moveNext();
		}
		tbl.close();
	}
	else
	{
		var event = tblGrid.getValue("FEVENT");
		if (event == null)
			return "";
		var ve = event.getVEvent();
		if (ve == null)
			return "";

		var props = ve.getProperties("CATEGORIES");
		for ( var i = 0; i < props.size(); i++)
		{
			var propCategories = props.get(i);
			var lists = propCategories.getCategories();
			var iter = lists.iterator();
			while (iter.hasNext())
			{
				var obj = iter.next();
				var categorName = String(obj);
				if (categorName.endsWith("\\"))
					categorName = categorName.substring(0,
							categorName.length - 1);
				if (ret != "")
					ret += ",";
				ret += categorName;

			}

		}

	}
	
	return ret;
}



function gadgetRefresh()
{
	var nGridPos = grid.getRowSelected();
	// grid.getTable().requery();
	var tbl = fillEventsTableTable();
	grid.setTable(tbl);
	grid.getTable().setAbsolute(nGridPos);
	grid.refresh();	
}

function gadgetExpand()
{
	var par = new Object();
	par.isFull = true;
	showWindow("gadgets/EVENT/full.xml", SW_MODAL, par);
}

function gridMenuInit()
{
	grid.AddMenuItem("ORGANIZER", "Відкрити органайзер|Открыть органайзер");
	grid.AddMenuItem("FULL", "Перейти до списку подій|Перейти к списку событий");
	grid.AddMenuItem("", "");
	//grid.AddMenuItem("ADD", "Додати|Добавить");
	if(!grid.getTable().isEmpty())
	{
		if(IsDblClick())
		{
			gridMenuRun("VIEW", grid);
			return false;
		}
		//grid.AddMenuItem("EDIT", "Редагувати|Редактировать");
		grid.AddMenuItem("VIEW", "Перегляд|Просмотр");		
	}	
}

function gridMenuRun(sID)
{
	var tbl = grid.getTable();
	var tName = tbl.getTableName();	
	var rowID = String(tbl.getValue("FWID"));
	if(false && (sID=="ADD" || sID=="EDIT"))
	{
		if(sID=="ADD")
			rowID = null;
		var oDoc = new DpDoc(doc, nop);
		var bRet = oDoc.edit(sID, rowID);
		if(bRet)
		{
			tbl.requery();
			tbl.FindFirst("FWID="+ oDoc.getID());
			grid.refresh();
		}
	}
	else if(sID=="VIEW")
	{
		var isDoc = tbl.getValue("FISDOC");
		if (isDoc == true)
		{
			var nID = String(tbl.getValue("FWID"));
			nID = Number(nID.substring(2));
			if (isNaN(nID))
				return;
		
			var oDoc = new DpDoc(doc, nop);
			oDoc.edit(sID, nID);
		}
		else
		{
			var event = tbl.getValue("FEVENT");
			oDoc = vEventToDoc(event.getVEvent(), "ASK");
			var par = new Object();
			par.doc = oDoc;	
			par.mode = "VIEW";
			par.isView = true;
			par.isApplyBtn = false;
			par.idtmpl = true;
			par.isiCal = true;
			//par.iCalArr =  getiCalsArray();
			var fileName = event.getCalID();
			par.iCalName = String(new DpFile(fileName).getName());
			par.iCalArr =  new Array();
			par.iCalArr[0] = par.iCalArr; 
			var oldiCal = par.iCalName; 
			showWindow(oDoc.formFile,"XMLDLG",par);
		}
	}
	if(sID=="FULL")
	{
		var par = new Object();
		par.doc = doc;
		par.nop = nop;		
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
	
	if(sID=="ORGANIZER")
	{
		showWindow("organizer.xml", SW_NOMODAL, new Object());
	}
}

function repitTxt(oVal)
{
	if(!oVal)
		return "";
	oVal = String(oVal).trim().toLowerCase();
	switch(oVal)
	{
		case "d":	return UR("щодня|каждый день");
		case "w":	return UR("щотижня|каждую неделю");
		case "m":	return UR("щомісяця|каждый месяц");
		case "y":	return UR("щороку|каждый год");
		default:	return UR("без повтору|без повтора");
	}
	return "";
}

function gridCond(oGrid)
{
	for(var nColor=1; nColor<=26; nColor++)
	{
		oGrid.defCond(nColor, "=^FCOLOR=="+ nColor);
		oGrid.color(nColor, nColor);
	}	
}

include("gadgets/DpGadget.js");