include("Objects/DpXMLDomDocument.js");

var sPath = rootDirectoryEx() +"userData/gadgets/";
var sFileName = "gadgets.xml";
var sFile = "gadgets.xml";
var xmlDom = null;
var xmlDoc = null;
var sTmpTbl = getTmpTableName();

function listLoad()
{	
	this.title = UR("Список пристроїв|Список устройств");
	
	loadXML();
	loadGrid();
	
	this.save = onSave;
	this.escape = onExit;
}

function listSrc()
{
	this.qrySet("From", sTmpTbl, "Order", "FNUM");
}

function loadXML()
{
	sFile = rootDirectory() +"/gadgets/"+ sFileName;
	if(isFile(lpProxy.getUserDirectory() + sFileName))
		sFile = lpProxy.getUserDirectory() + sFileName;
	else if(isFile(sPath + sFileName))
		sFile = sPath + sFileName;
	xmlDom = new DpXMLDOMDocument();
	xmlDom.load(sFile);
	var doc = xmlDom.getDocumentElement();
	xmlDoc = doc.getElementsByTagName("GadgetBox")[0];
}

function onSave()
{
	if(extPar && extPar.ret)
	{
		var tbl = grid.getTable();
		extPar.ret.FTEXT = tbl.getValue("FTEXT");
		extPar.ret.FTASK = tbl.getValue("FTASK");
		extPar.ret.FPAR = tbl.getValue("FPAR");
		extPar.ret.FWIDTH = tbl.getValue("FWIDTH");		
		onExit();
		extPar.escape = false;
		return;
	}
	
	if(!isDir(sPath))
		createDirectory(sPath);	
	var sWhere = " FWID="+ grid.getTable().getRowID();
	if(grid.getSelectedCount()>1)
		sWhere = grid.getSqlSelected();
	var tbl = OpenTable("select * from "+ sTmpTbl +" where "+ sWhere +" order by FNUM");
	for(; !tbl.IsEOF(); tbl.MoveNext())
	{
		var xmlGadget = xmlDom.createElement("gadget");		
		xmlGadget.setAttribute("ID", tbl.getValue("FID"));
		xmlGadget.setAttribute("task", tbl.getValue("FTASK"));
		xmlGadget.setAttribute("text", tbl.getValue("FTEXT"));
		if(String(tbl.getValue("FPAR")).trim()!="")
			xmlGadget.setAttribute("par", tbl.getValue("FPAR"));
		if(Number(tbl.getValue("FWIDTH"))>0)
			xmlGadget.setAttribute("width", tbl.getValue("FWIDTH"));
		xmlDoc.appendChild(xmlGadget);
	}
	tbl.close();	
	//sFile = sPath + sFileName;
	sFile = lpProxy.getUserDirectory() + sFileName;
	var xmlFile = new DpFile(sFile);
	xmlDom.save(xmlFile);
	onExit();
}

function onExit()
{
	FORM.close();
}

function loadGrid()
{
	ExecuteSQL("create table "+ sTmpTbl 
				+" (FNUM "+ SqlType("SHORT")
				+", FID "+ SqlType("TEXT", 50)
				+", FPAR "+ SqlType("TEXT", 50)
				+", FTEXT "+ SqlType("LONGTEXT") 
				+", FTASK "+ SqlType("TEXT", 250)
				+", FWIDTH "+ SqlType("INT")
				+", FVISIBLE "+ SqlType("BIT") 
				+", FWID "+ SqlType("COUNTER") +")"
				);
		
	loadGadgets(sPath);
	loadGadgets(rootDirectory() +"gadgets/");
	var arrModules = lpProxy.getModules();
	for(var i=0; i<arrModules.length; i++)
		loadGadgets(lpProxy.getModulePath(arrModules[i]) +"/scripts/gadgets/", arrModules[i]);
	
	var tbl = OpenTable("select * from "+ sTmpTbl +" order by FNUM");	
	grid.setTable(tbl);	
	grid.build();	
}

function loadGadgets(path, module)
{
	var dir = new DpFile(path);	
	if(!dir.exists())
		return;
	var listGad = dir.listFiles();
	if(!listGad || listGad.length==0)
		return;
	var num = 1;
	var oSnap = getSnap("select max(FNUM)  from "+ sTmpTbl);
	if(oSnap && Number(oSnap[0]))
		num = Number(oSnap[0])+1;
	for(var n=0; n<listGad.length; n++)
	{
		var gadgetName = listGad[n].getName();
		var gadgetPath = listGad[n].getAbsolutePath();
		if(!isDir(gadgetPath))
			continue;
		var gadgetFile = gadgetPath +"/gadget.xml";		
		if(!isFile(gadgetFile))
			continue;
		if(module)
			gadgetName = module +":"+ gadgetName;
		var oSnap = getSnap("select FID from "+ sTmpTbl +" where FTASK="+ sqlTo(gadgetName));
		if(oSnap)
			continue;
		var dom = new DpXMLDOMDocument();
		dom.load(gadgetFile);
		var doc = dom.getDocumentElement();
		var text = doc.getAttribute("text");
		var id = doc.getAttribute("ID");
		var width = Number(doc.getAttribute("width"));
		if(width>100)
			width = width/10;
		if(!id || id=="")
			id = gadgetName;
		ExecuteSQL("insert into "+ sTmpTbl 
					+" (FNUM, FID, FTEXT, FTASK, FWIDTH, FVISIBLE) "
					+" values ("+ (num++) 
						+","+ sqlTo(id)
						+","+ sqlTo(UR(text)) 
						+","+ sqlTo(gadgetName)
						+","+ sqlTo(width)  
						+","+ sqlFalse 
						+")"
					);
	}
}

function listMenuInit()
{
	var tbl = grid.getTable();
	if(!tbl.isEmpty())
	{
		if(IsDblClick())
		{
			listMenuRun("SAVE");
			return false;
		}
		grid.AddMenuItem("SAVE", "Вибрати|Выбарть");		
	}
}

function listMenuRun(sID)
{
	var tbl = grid.getTable();
	if(!tbl)
		return;
	var tblName = tbl.getTableName();	
	var rowID = Number(tbl.getValue("FWID"));
	if(sID=="SAVE")
	{
		onSave();
	}	
}

include("sys/DpList.js");