include("Objects/DpXMLDomDocument.js");

var sPath = rootDirectoryEx() +"userData/gadgets/";
var sFileName = "gadgets.xml";
var sFile = "";
var xmlDom = null;
var xmlDoc = null;
var sTmpTbl = getTmpTableName();

function Load()
{	
	loadXML();
	loadGrid();
	
	AUTOSTART.checked = getPar("SHOW_GADGETS")==true;
	AUTOREFRESH.checked = xmlDoc.getAttribute("autorefresh")=="true";
	PERIOD.value = Number(xmlDoc.getAttribute("refreshperiod"));
	COLUMN.value = Number(xmlDoc.getAttribute("col"));
	
	setButton(LOADDEFAULTLIST, loadDefaultList);
}

function loadXML()
{
	sFile = rootDirectory() +"/gadgets/"+ sFileName;
	if(isFile(lpProxy.getUserDirectory() + sFileName))
		sFile = lpProxy.getUserDirectory() + sFileName;
	else if(isFile(sPath + sFileName))
		sFile = sPath + sFileName;
	xmlDom = new DpXMLDOMDocument();
	xmlDom.load(sFile);
	var doc = xmlDom.getDocumentElement();
	xmlDoc = doc.getElementsByTagName("GadgetBox")[0];
}

function onSave()
{
	setPar("SHOW_GADGETS", AUTOSTART.checked);
	
	if(!isDir(sPath))
		createDirectory(sPath);	
	var autorefresh = AUTOREFRESH.checked? "true" : "false";
	var doc = xmlDom.getDocumentElement();
	var root = doc.getElementsByTagName("Controls")[0];
	root.removeChild(xmlDoc);
	xmlDoc = xmlDom.createElement("GadgetBox");
	xmlDoc.setAttribute("ID", "GadgetBox");
	xmlDoc.setAttribute("col", COLUMN.value);
	xmlDoc.setAttribute("autorefresh", autorefresh);
	xmlDoc.setAttribute("refreshperiod", PERIOD.value);	
	var tbl = OpenTable("select * from "+ sTmpTbl +" where FVISIBLE="+ sqlTrue +" order by FNUM");
	for(; !tbl.IsEOF(); tbl.MoveNext())
	{
		var xmlGadget = xmlDom.createElement("gadget");
		xmlDoc.appendChild(xmlGadget);
		xmlGadget.setAttribute("ID", tbl.getValue("FID"));
		xmlGadget.setAttribute("task", tbl.getValue("FTASK"));
		xmlGadget.setAttribute("text", tbl.getValue("FTEXT"));
		if(String(tbl.getValue("FPAR")).trim()!="")
			xmlGadget.setAttribute("par", tbl.getValue("FPAR"));
		if(Number(tbl.getValue("FWIDTH"))>0)
			xmlGadget.setAttribute("width", tbl.getValue("FWIDTH"));
		if(tbl.getValue("FVISIBLE")==false)
			xmlGadget.setAttribute("visible", false);
	}
	tbl.close();
	root.appendChild(xmlDoc);
	sFile = lpProxy.getUserDirectory() + sFileName;	
	var xmlFile = new DpFile(sFile);
	xmlDom.save(xmlFile);
	if(SAVEASDEFAULT.checked)
	{
		xmlFile = new DpFile(sPath + sFileName);
		xmlDom.save(xmlFile);
	}		
}

function loadDefaultList()
{
	ExecuteSQL("delete from "+ sTmpTbl);
	
	var file = sPath + sFileName;
	if(!isFile(file))
		file = rootDirectory() +"/gadgets/"+ sFileName;	
	var dom = new DpXMLDOMDocument();
	dom.load(file);
	var doc = dom.getDocumentElement();
	var xml = doc.getElementsByTagName("GadgetBox")[0];
	var gadgets = xml.getChildNodes();
	for (var i=0; i<gadgets.length; i++)
	{
		var gadget = gadgets[i];
		var task = gadget.getAttribute("task");
		var text = gadget.getAttribute("text");
		var par = gadget.getAttribute("par");
		var visible = gadget.getAttribute("visible")!="false";
		var id = gadget.getAttribute("ID");
		var width = Number(gadget.getAttribute("width"));
		ExecuteSQL("insert into "+ sTmpTbl 
					+" (FNUM, FID, FTEXT, FTASK, FPAR, FWIDTH, FVISIBLE) "
					+" values ("+ (i+1) 
						+", "+ sqlTo(id) 
						+","+ sqlTo(UR(text)) 
						+","+ sqlTo(task) 
						+","+ sqlTo(par)
						+","+ sqlTo(width)
						+","+ sqlTo(visible) 
						+")"
					);
	}
	grid.getTable().requery();
	grid.refresh();
}

function loadGrid()
{
	ExecuteSQL("create table "+ sTmpTbl 
				+" (FNUM "+ SqlType("SHORT")
				+", FID "+ SqlType("TEXT", 50)
				+", FPAR "+ SqlType("LONGTEXT")
				+", FTEXT "+ SqlType("LONGTEXT") 
				+", FTASK "+ SqlType("TEXT", 250)
				+", FWIDTH "+ SqlType("INT")
				+", FVISIBLE "+ SqlType("BIT") 
				+", FWID "+ SqlType("COUNTER") +")"
				);
	var gadgets = xmlDoc.getChildNodes();
	for (var i=0; i<gadgets.length; i++)
	{
		var gadget = gadgets[i];
		var task = gadget.getAttribute("task");
		var text = gadget.getAttribute("text");
		var par = gadget.getAttribute("par");
		var visible = gadget.getAttribute("visible")!="false";
		var id = gadget.getAttribute("ID");
		var width = Number(gadget.getAttribute("width"));
		ExecuteSQL("insert into "+ sTmpTbl 
					+" (FNUM, FID, FTEXT, FTASK, FPAR, FWIDTH, FVISIBLE) "
					+" values ("+ (i+1) 
						+", "+ sqlTo(id) 
						+","+ sqlTo(UR(text)) 
						+","+ sqlTo(task) 
						+","+ sqlTo(par)
						+","+ sqlTo(width)
						+","+ sqlTo(visible) 
						+")"
					);
	}
	
	loadGadgets(sPath);
	loadGadgets(rootDirectory() +"gadgets/");
	var arrModules = lpProxy.getModules();
	for(var i=0; i<arrModules.length; i++)
		loadGadgets(lpProxy.getModulePath(arrModules[i]) +"/scripts/gadgets/", arrModules[i]);
	
	var tbl = OpenTable("select * from "+ sTmpTbl +" order by FNUM");
	grid.setTable(tbl);
	grid.build();
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid.loadMenuHandler(this, "gridMenuInit");
	grid.selectMenuHandler(this, "gridMenuRun");
}

function loadGadgets(path, module)
{
	var dir = new DpFile(path);	
	if(!dir.exists())
		return;
	var listGad = dir.listFiles();
	if(!listGad || listGad.length==0)
		return;
	var num = 1;
	var oSnap = getSnap("select max(FNUM)  from "+ sTmpTbl);
	if(oSnap && Number(oSnap[0]))
		num = Number(oSnap[0])+1;
	for(var n=0; n<listGad.length; n++)
	{
		var gadgetName = listGad[n].getName();
		var gadgetPath = listGad[n].getAbsolutePath();
		if(!isDir(gadgetPath))
			continue;
		var gadgetFile = gadgetPath +"/gadget.xml";		
		if(!isFile(gadgetFile))
			continue;
		if(module)
			gadgetName = module +":"+ gadgetName;
		var oSnap = getSnap("select FID from "+ sTmpTbl +" where FTASK="+ sqlTo(gadgetName));
		if(oSnap)
			continue;
		var dom = new DpXMLDOMDocument();
		dom.load(gadgetFile);
		var doc = dom.getDocumentElement();
		var text = doc.getAttribute("text");
		var id = doc.getAttribute("ID");
		var width = Number(doc.getAttribute("width"));
		if(width>100)
			width = width/10;
		if(!id || id=="")
			id = gadgetName;
		ExecuteSQL("insert into "+ sTmpTbl 
					+" (FNUM, FID, FTEXT, FTASK, FWIDTH, FVISIBLE) "
					+" values ("+ (num++) 
						+","+ sqlTo(id)
						+","+ sqlTo(UR(text)) 
						+","+ sqlTo(gadgetName)
						+","+ sqlTo(width)  
						+","+ sqlFalse 
						+")"
					);
	}
}

function gridMenuInit()
{
	var tbl = grid.getTable();
	if(!tbl.isEmpty())
	{
		var visible = tbl.getValue("FVISIBLE");
		if(visible==false)
			grid.AddMenuItem("ON", "Включити|Включить");
		else
			grid.AddMenuItem("OFF", "Виключити|Выключить");
		grid.AddMenuItem("", "");
	}
	
	grid.AddMenuItem("ADD", "Додати|Добавить");
	if(!tbl.isEmpty())
	{
		grid.AddMenuItem("EDIT", "Редагувати|Редактировать");
		grid.AddMenuItem("DEL", "Видалити|Удалить");
	}
}

function gridMenuRun(sID)
{
	var tbl = grid.getTable();
	var tblName = tbl.getTableName();	
	var rowID = Number(tbl.getValue("FWID"));
	if(sID=="ON")
	{
		ExecuteSQL("update "+ tblName +" set FVISIBLE="+ sqlTrue +" where FWID="+ rowID);
		tbl.requery();
		grid.refresh();
	}
	else if(sID=="OFF")
	{
		ExecuteSQL("update "+ tblName +" set FVISIBLE="+ sqlFalse +" where FWID="+ rowID);
		tbl.requery();
		grid.refresh();
	}
	else if(sID=="ADD")
	{
		var par = new Object();
		par.tbl = tbl;
		par.mode = sID;
		showWindow("gadgets/e_gadget.xml", SW_MODAL, par);
		if(!par.escape)
		{
			tbl.requery();
			grid.refresh();
		}
	}
	else if(sID=="EDIT")
	{
		var par = new Object();
		par.tbl = tbl;
		par.mode = sID;
		showWindow("gadgets/e_gadget.xml", SW_MODAL, par);
		if(!par.escape)
		{
			tbl.requery();
			grid.refresh();
		}
	}
	else if(sID=="DEL")
	{
		ExecuteSQL("delete from "+ tblName +" where FWID="+ rowID);
		tbl.requery();
		grid.refresh();
	}
}

include("sys/DpBaseDlg.js");