//функция возвращает сумму для указаной постоянной
//величины и даты, если указан параметр типа, тогда считываем значение с соответствующего поля,
//если тип не указан, тогда тип определяется по полю Ftype в таблице
//Tori 17.12.2010: если есть выражение, то значение константы расчитываем с помощью функции constEval()
include("servis/zrp.js");

function get_cnst(vConst, constDate, type, isSilent)
{
	vConst=allt(vConst).toUpperCase()
	var result = 0;
	
	var strSQL = "SELECT Ftype, Fsum, Fdate, Fbool, Ftext, Fexpr "
				+" FROM ^const "
				+" WHERE Fbdat<=" + sqlTo(constDate) 
   										+ " AND Fedat>=" + sqlTo(constDate)
   										+ " AND "+sqlUpper("Fconst_nam")+"=" + sqlTo(vConst);
	var snap = getSnap(strSQL);
	if(!snap)
	{
		var sMsg = ru("Нет данных по константе", "Немає даних по константі") 
					+" '"+ vConst +"' на "+ StrDat(constDate, "DMY");
		if(!isSilent)
			WAIT(sMsg);
		trace("get_cnst: "+ sMsg)	
		return result;		
	}
	
	//обрабатываем выражение
	if(allt(snap[5]).length>0)
	{
		if(allt(snap[5]).toUpperCase()!="^"+vConst) 	//исключаем рекурсию: некоторые умники умудряются в выражение вписывать имя самой константы
			return constEval(snap[5], constDate);
	}
	
	if(type != null)
		type = allt(type).toUpperCase();
	else
		type = allt(snap[0]).toUpperCase();
	
	switch(type)
	{
		case "DATE":
		case "DATETIME":
			result = snap[2];
		break;
		case "BOOL":
		case "BOOLEAN":
		case "BIT":
			result = snap[3];
		break;
		case "TEXT":
		case "TXT":
		case "STRING":
			result = snap[4];
		break;
		default:
			result = snap[1];
		break;
	}
	return toScrObj(result);
} 