// JScript source code
var codCategory = getPar("CRM_EVENT_CAT");
var iCalApi = getJavaClass("org.debet.utils.DpiCalApi").newInstance();
function vEventToDoc(ve, categoryPar, attendyPar)
{
	include ("doc/DpDoc.js");
	var oDoc = new DpDoc("EVENT", 0);
	var sdf = new java.text.SimpleDateFormat("yyyyMMdd");	
	
	oDoc.setVar("HOUTID",  ve.getUid().getValue());
    var value = String(ve.getStartDate().getValue());
    var start = ve.getStartDate().getDate();
    
    //event.setTimeZone(ve.getStartDate().getTimeZone());
    
    if (value != null && String(value).length == 8)
    {
        var e;
    	try
        {
            start = sdf.parse(String(value));
            oDoc.setVar("HFULLDAY",true);
            event.setAllDayEvent(true);
        }
        catch (e)            
        {                
        }
    }
    
    oDoc.setVar("HBDATE", start);
    
    var end = ve.getEndDate().getDate();
    value = ve.getEndDate().getValue();
    if (value != null && String(value).length == 8)
    {
       var e;
    	try
        {
            end = sdf.parse(String(value));            
        }
        catch (e)            
        {   
        	alert(e)
        }
    }
    oDoc.setVar("HEDATE", end); 
    
    oDoc.setVar("HSUBJECT", ve.getSummary().getValue());    
    
    var prop = ve.getProperty("RRULE");
   
    if (prop != null)
    {
        oDoc.setVar("HREPIT", prop.getValue());
    }
    
    
    var props =  ve.getProperties("EXDATE");
    var sExtDates = "";
    for (var i = 0; i < props.size(); i++)
    {
        var propDate = props.get(i);
        if (propDate != null)
        {
            var exDate = props.get(i);
            var listDate = exDate.getDates();
            for (var j = 0; j < listDate.size(); j++)
            {
                if (sExtDates != "")
                	sExtDates +=",";
                sExtDates += format("yyyymmdd",listDate.get(j));                
            }
        }
    }
    if (sExtDates)
    {
    	oDoc.setVar("HEXDATES", sExtDates);
    }
    
    var prop = ve.getClassification();
    if (prop)
    	 oDoc.setVar("HCONFIDENCE", String(prop.getValue())); 
    
    var alarmList = ve.getAlarms();
    for (var i = 0; i < alarmList.size(); i++)
    {
        var va = alarmList.get(i);
        var oAlarm = oDoc.createRow("ALARM");
        var obj = va.getAction();
        if (obj)
        	oAlarm.setVar("RACTION", obj.getValue());
        var trigger = va.getTrigger();        
        if(trigger != null)
        {
        	oAlarm.setVar("RTRIGGER", trigger.getValue());
        	var obj = trigger.getParameter("RELATED")
        	if (obj)
            	oAlarm.setVar("RRELATED", obj.getValue());
        }
        
        
        var obj = va.getDuration();
        if (obj)
        	oAlarm.setVar("RDURATION", obj.getValue());
        
        var obj = va.getRepeat();
        if (obj)
        	oAlarm.setVar("RREPEAT", obj.getCount());
        
        var obj = va.getDescription();
        if (obj)        
        	oAlarm.setVar("RDESCRIPTION", obj.getValue());
        var obj = va.getAttachment();
        if (obj)
        	oAlarm.setVar("RATTACH", obj.getValue());
        
        oDoc.appendRow("ALARM",oAlarm);
        
    }
    
    
    var props = ve.getProperties("CATEGORIES");
    for (var i = 0; i < props.size(); i++)
    {
        var propCategories = props.get(i);
        var lists = propCategories.getCategories();
        var iter = lists.iterator();
        while (iter.hasNext())
        {
        	var obj = iter.next();
        	var categorName = String(obj);
        	if (categorName.endsWith("\\"))
        		categorName = categorName.substring(0, categorName.length - 1);
        	var nCod = iCal_getCategoryCod(categorName);
        	if (nCod == -1)
        	{
        		var rusMsg = "Категории " + categorName + " нет в справочнике добавить?";
        		var ukrMsg = "Категорii " + categorName + " нема в довiднику додати?";
        		if(categoryPar == "ADD"  || (categoryPar == "ASK" && confirm(ru(rusMsg, ukrMsg))))
        		{
        			nCod = iCal_addCategory(categorName);
        		}
        	}
        	
        	if (nCod != -1)
        	{
        		var oCategor = oDoc.createRow("CATEGORY");
        		oCategor.setVar("RCATEGORY",nCod);
        		oDoc.appendRow("CATEGORY",oCategor);
        	}
        }
        
    }
     
    	
    
    var propsAttendee =  ve.getProperties("ATTENDEE");
    for (var i = 0; i < propsAttendee.size(); i++)
    {
        var attendee = propsAttendee.get(i);
        var calAddress = attendee.getCalAddress();
        if (calAddress == null)
        	calAddress = "";
        else
        	calAddress = String(calAddress);
        if(calAddress.toLowerCase().startsWith("mailto:"))
        	calAddress = calAddress.substr(7);
        
        var oAttendee = oDoc.createRow("ATTENDEE");
        oAttendee.setVar("RCALADDRESS", calAddress);
        
        var obj = attendee.getParameter("CN")
    	if (obj)
    	{
        	oAttendee.setVar("RCODPERS", iCal_getAttendeeCod(String(obj.getValue())));
    	}
        
        var obj = attendee.getParameter("ROLE");
    	if (obj)
    	{
        	oAttendee.setVar("RROLE", obj.getValue());
    	}
        
        oDoc.appendRow("ATTENDEE",oAttendee);
        
        
    }
    
   
	
	return oDoc;
}

function iCal_getCategoryCod(nameCat)
{
	var oSnap = getSnap("select fcod from ^listcl where FCL = " + codCategory + " AND " 
			+ sqlUpper("ftxt") + " =  " + sqlTo(nameCat.toUpperCase()));
	
	if (oSnap && oSnap[0])
		return oSnap[0];
	return -1;
}

function iCal_getCategoryName(codCat)
{
	var oSnap = getSnap("select ftxt from ^listcl where FCL = " + codCategory + " AND " 
			+ "fcod =  " + sqlTo(codCat));
	
	if (oSnap && oSnap[0])
		return oSnap[0];
	return null;
}

function iCal_getAttendeeCod(CN)
{
	var oSnap = getSnap("select fcod from ^listcl where FCL = " + getPar("CODPERS") + " AND " 
			+ sqlUpper("ftxt") + " =  " + sqlTo(CN.toUpperCase()));
	
	if (oSnap && oSnap[0])
		return oSnap[0];
	return -1;
}

function iCal_getAttendeeTxt(cod)
{
	var oSnap = getSnap("select ftxt from ^listcl where FCL = " + getPar("CODPERS") + " AND " 
			+ " fcod =  " + sqlTo(Number(cod)));
	
	if (oSnap && oSnap[0])
		return oSnap[0];
	return null;
}

function iCal_addCategory(nameCat)
{
	var oSnap = getSnap("select max(fcod) from ^listcl where FCL = " + codCategory );
	
	var nCod = 0;
	if (oSnap && oSnap[0])
		nCod = oSnap[0];
	nCod++;
	
	include ("Objects/DpClEx.js");
	var oCl = new DpClEx("CL1", codCategory);
	oCl.setVar("HCOD", nCod);
	oCl.setVar("HTXT", nameCat);
	oCl.setVar("HCL", codCategory);
	oCl.save();
	
	return nCod;
}

function docToVEvent(oDoc)
{
	var propertyList = getJavaClass("net.fortuna.ical4j.model.PropertyList").newInstance();
	
	var sUID = oDoc.getVar("HOUTID");
	var Uid = null;
	if (!sUID)
		Uid = iCalApi.generateUID();
	else
		Uid = iCalApi.getUID(sUID);
		
	propertyList.add(Uid);
	
	var propDtStamp =  getJavaClass("net.fortuna.ical4j.model.property.DtStamp").newInstance();
	var datCreate = iCalApi.toICalDateTime(new Date().getVarDate())
	datCreate.setUtc(true);
	propDtStamp.setDate(datCreate);
	propertyList.add(propDtStamp);
	
	var dateB = oDoc.getVar("HBDATE");
	var dateE = oDoc.getVar("HEDATE");
	
	var isFullDay = oDoc.getVar("HFULLDAY");
	var iCalDateB = isFullDay?iCalApi.toICalDate(dateB):iCalApi.toICalDateTime(dateB);
	var iCalDateE = isFullDay?iCalApi.toICalDate(dateE):iCalApi.toICalDateTime(dateE);
	var propStart = getJavaClass("net.fortuna.ical4j.model.property.DtStart").newInstance();
	propStart.setDate(iCalDateB);
	propertyList.add(propStart);
	var propEnd = getJavaClass("net.fortuna.ical4j.model.property.DtEnd").newInstance();
	propEnd.setDate(iCalDateE);
	propertyList.add(propEnd);
	
	var summury = oDoc.getVar("HSUBJECT");
	var propSummary = getJavaClass("net.fortuna.ical4j.model.property.Summary").newInstance();
	propSummary.setValue(summury);
	propertyList.add(propSummary);
	
	var confid = oDoc.getVar("HCONFIDENCE");
	var propClazz = getJavaClass("net.fortuna.ical4j.model.property.Clazz").newInstance();
	propClazz.setValue(confid);
	propertyList.add(propClazz);
	
	var repit = oDoc.getVar("HREPIT");
	if (repit)
	{
		var propRRule = getJavaClass("net.fortuna.ical4j.model.property.RRule").newInstance();
		propRRule.setValue(repit);
		propertyList.add(propRRule);
	}
	
	
	var sExtDates = oDoc.getVar("HEXDATES");
	if (sExtDates)
    {
    	var arrDates = String(sExtDates).split(",");
    	for (var i = 0; i < arrDates.length; i++ )
    	{
    		var dat = arrDates[i];
    		var iCalDate = iCalApi.toICalDate(dat);
    		if (iCalDate == null)
    			continue;
    		
    		
    		var dList = iCalApi.createDateList("DATE");
    		dList.add(iCalDate);
    		var propExDate = iCalApi.createExDate(dList);
    		propertyList.add(propExDate);
    	}
    }
	
	oDoc.gotoFirstRow(); //загружаем все строки в объект
	
	var categories = null;
	do
	{
		var currChild = oDoc.getCurrRow();
		if (currChild == null || currChild.sClassId != "CATEGORY")
			continue;				
		
		var idCat = currChild.getVar("RCATEGORY");
		var nameCat = iCal_getCategoryName(idCat);
		if (!nameCat)
			continue;
		
		if (categories == null)
			categories = getJavaClass("net.fortuna.ical4j.model.property.Categories").newInstance();
		categories.getCategories().add(nameCat);
		
	}
	while(oDoc.gotoNextRow())
		
	
		
	if (categories != null)
		propertyList.add(categories);
	
	
	oDoc.gotoFirstRow(); //загружаем все строки в объект
	do
	{
		var currChild = oDoc.getCurrRow();		
		if (currChild == null || String(currChild.sClassId) != "ATTENDEE")
			continue;
		var vAttendee = getAttendeeFromDoc(currChild);		
		if (vAttendee != null)
		{		
			propertyList.add(vAttendee);
		}
		
		
	}
	while(oDoc.gotoNextRow())
	
	var vEvent = iCalApi.createVEvent(propertyList);
	
	
	
	oDoc.gotoFirstRow(); //загружаем все строки в объект
	do
	{
		var currChild = oDoc.getCurrRow();		
		if (currChild == null || String(currChild.sClassId) != "ALARM")
			continue;
		var vAlarm = getVArarmFromDoc(currChild);		
		if (vAlarm != null)
		{		
			vEvent.getAlarms().add(vAlarm);
		}
		
		
	}
	while(oDoc.gotoNextRow())
		
	return vEvent;
	
}

function getAttendeeFromDoc(oDocRow)
{
	var vAttendee = getJavaClass("net.fortuna.ical4j.model.property.Attendee").newInstance();
	var eMail = oDocRow.getVar("RCALADDRESS");
	if (!eMail)
		eMail = "";
	vAttendee.setValue("mailto:" + eMail);
	var role = oDocRow.getVar("RROLE");
	
	if(role != null)
	{
		var parRole = iCalApi.getRole(role);
		if(parRole != null)
			vAttendee.getParameters().add(parRole);
	}
	var codCn  = oDocRow.getVar("RCODPERS");
	if (codCn && Number(codCn) > 0)
	{
		var cn = iCal_getAttendeeTxt(codCn);
		if (cn != null && allt(String(cn)) != "")
		{
			var parCN = iCalApi.getCn(cn);
			if(parCN != null)
				vAttendee.getParameters().add(parCN);
		}
	}
		
	return vAttendee;
}

function getVArarmFromDoc(oDocRow)
{
	var vAlarm = getJavaClass("net.fortuna.ical4j.model.component.VAlarm").newInstance();
	
	var sAction = oDocRow.getVar("RACTION");
	if (sAction)
	{	
		var propAction = getJavaClass("net.fortuna.ical4j.model.property.Action").newInstance();
		propAction.setValue(sAction);
		vAlarm.getProperties().add(propAction);
		
	}
	
	var sTrigger = oDocRow.getVar("RTRIGGER");
	
	if (sTrigger && allt(String(sTrigger)) != "")
	{	
		var propTrigger = getJavaClass("net.fortuna.ical4j.model.property.Trigger").newInstance();
		propTrigger.setValue(sTrigger);		
		var rRelated = oDocRow.getVar("RRELATED");
		if (rRelated && allt(String(rRelated)) != "")
		{
			var oRelated = iCalApi.getRelated(allt(String(rRelated)).toUpperCase());
			propTrigger.getParameters().add(oRelated);
		}
		vAlarm.getProperties().add(propTrigger);
		
	}
	
	var sDuration = oDocRow.getVar("RDURATION");
	if (sDuration && allt(String(sDuration)) != "")
	{	
		var propDuration = getJavaClass("net.fortuna.ical4j.model.property.Duration").newInstance();
		propDuration.setValue(sDuration);
		vAlarm.getProperties().add(propDuration);
		
	}
	
	var sDescription = oDocRow.getVar("RDESCRIPTION");
	if (sDescription == null || allt(String(sDescription)) == "")
		sDescription = UR("Нагадування події|Напоминание события");
	if (sDescription && allt(String(sDescription)) != "")
	{	
		var propDescription = getJavaClass("net.fortuna.ical4j.model.property.Description").newInstance();
		propDescription.setValue(sDescription);
		vAlarm.getProperties().add(propDescription);
		
	}
	
	var sAttach = oDocRow.getVar("RATTACH");
	if (sAttach && allt(String(sAttach)) != "")
	{	
		var propAttach = getJavaClass("net.fortuna.ical4j.model.property.Attach").newInstance();
		propAttach.setValue(sAttach);
		vAlarm.getProperties().add(propAttach);
		
	}
	var sRepeat = oDocRow.getVar("RREPEAT");
	if (sRepeat && allt(String(sRepeat)) != "")
	{	
		var propRepeat = getJavaClass("net.fortuna.ical4j.model.property.Repeat").newInstance();
		propRepeat.setCount(Number(sRepeat));
		vAlarm.getProperties().add(propRepeat);
		
	}
	return vAlarm;
}