include("Objects/DpCl.js");
include("Objects/DpzDoc.js");
include("Objects/DpItogs.js");
include("servis/date.js");

var oStreet;
var oHouse;
var oExempt;

function onLoad()
{
	extPar.escape = true;
	Caption("Параметри розрахунку|Параметры расчета");
	
	oStreet = new DpCl("0!");
	oStreet.setClcl(getPar("CODSTREET"));
	oStreet.linkSmartCtrl(FSTREET);
	
	oHouse = new DpCl("0!", getPar("CODHOUSE"), 0, oStreet);
	oHouse.linkSmartCtrl(FHOUSE);
	oHouse.setContAssist();
	oHouse.addFldSearchSmart("FNOM");
	oHouse.isExactSearchSmart = true;
	oHouse.isCodeSearchSmart = false;
	
	oExempt = new DpCl("0!");
	oExempt.setClcl(getPar("CODLGT"));
	oExempt.linkSmartCtrl(FEXEMPT);
	oExempt.setContAssist();
		
	setValid(FBDAT, date_valid);
	setValid(TYPEPER, onChangePeriod);
		
	loadPar();
	setHouse();
}

function loadPar()
{
	FBDAT.value = firstDayMonth(new Date());
	FEDAT.value = lastDayMonth(new Date());
}

function onSave()
{
	extPar.escape = false;	
	extPar.idat1 = firstDayMonth(FBDAT.getValue());
	extPar.idat2 = lastDayMonth(FEDAT.getValue());
	extPar.rdate = FBDAT.getValue();
	extPar.istreet = oStreet;
	extPar.ihouse = oHouse;
	extPar.iexempt = oExempt;
	extPar.iexempt_type = "";
	if(FEXEMPTTYPE.value)
		extPar.iexempt_type = String(FEXEMPTTYPE.value).trim().toUpperCase();
	return true;
}

function date_valid()
{
	TYPEPER.value="-";
	idat1 = firstDayMonth(FBDAT.getValue());
	idat2 = lastDayMonth(FEDAT.getValue());
	return true;
}

function onChangePeriod()
{
	var per = String(TYPEPER.value);
	switch (per)
	{
		case "TD":
			FBDAT.value = today.getVarDate();
			FEDAT.value = today.getVarDate();
			break;
		case "YTD":
			FBDAT.value = goDay(today, -1);
			FEDAT.value = goDay(today, -1);
			break;
		case "TW":
			FBDAT.value = goDay(today, -today.getDay());
			FEDAT.value = goDay(today,6 - today.getDay());
			break;
		case "TM":
			FBDAT.value = firstDayMonth(today);
			FEDAT.value = lastDayMonth(today);
			break;
		case "LM":
			FBDAT.value = firstDayMonth(_dateTrans(today, "M+", -1));
			FEDAT.value = lastDayMonth(_dateTrans(today, "M+", -1));
			break;
		case "2M":
			FBDAT.value = firstDayMonth(_dateTrans(today, "M+", -1));
			FEDAT.value = lastDayMonth(today);
			break;		
		case "TY":
			FBDAT.value = jan01(today);
			FEDAT.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "2Y":
			var bdat = new Date(today.getFullYear()-1, today.getMonth());
			FBDAT.value = jan01(bdat);
			FEDAT.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "ALL":
			FBDAT.value = d00min;
			FEDAT.value = d00;
			break;
		default:
			break;
	}
}

function getWhereStreet()
{
	var sWhere = "";
	var streerID = oStreet.getFWID();
	if(streerID!=0 && streerID!=null)
		sWhere = "FWID_CL in (select fwid_cl from ^cl_house "
						+" where fstreet="+ streerID +")";
	return sWhere;
}

function setHouse(oCtrl)
{
	var curNom = FHOUSE.value;
	if(oCtrl!=null && (curNom==0 || curNom==null || curNom==""))
	{
		oHouse.setCod(0);
		return;
	}
	var sWhere = " where h.fwid_cl="+ oHouse.getFWID();
	if(oCtrl!=null && curNom!=0 && curNom!=null && curNom!="")
		sWhere = " where h.fnom="+ sqlTo(curNom);	
	var sWhereStreet = getWhereStreet();
	if(sWhereStreet!="" && sWhereStreet!=null)
		sWhere += " and rel."+ sWhereStreet;
	var sSql = "select rel.fcod, h.fnom, h.fwid_cl from ^cl_house h "
				+" inner join ^clrelclcl rel on rel.fwid_cl=h.fwid_cl "
				+ sWhere
	var oHs = getSnap(sSql, false);
	if(oHs==null)
	{
		if(oCtrl!=null && curNom!=0 && curNom!=null && curNom!="")
			oHouse.zaval();
		return;
	}
	oHouse.setCod(oHs[0]);	
	FHOUSE.value = oHs[1];
	
	oStreet.setFWID(getStreet());
}

function getStreet()
{
	var streetID = 0;
	var sSql = "select FSTREET from ^cl_house where fwid_cl="+ oHouse.getFWID();
	var oHs = getSnap(sSql, false);
	if(oHs!=null)
		streetID = oHs[0];
	return streetID;
}

include("sys/DpBaseDlg.js");