
function installHoc()
{
	//справочники аналитики
	var sParName = "CODSTREET";
	var sVid = "1";
	var sText = ru("Улицы","Вулиці");
	installCL(sParName, sVid, sText);
	
	sParName = "CODHOUSE";
	sVid = "clhouse";
	sText = ru("Дома","Будинки");
	installCL(sParName, sVid, sText);
	
	sParName = "CODAPT";
	sVid = "clapartment";
	sText = ru("Квартиры","Квартири");
	installCL(sParName, sVid, sText);
	
	sParName = "CODLGT";
	sVid = "clexempt";
	sText = ru("Льготы","Пільги");
	installCL(sParName, sVid, sText);
	
	//документы
	var sDoc = "LICSC"
	var nNop = "1"
	var sTxt = ru("Лицевые счета","Особові рахунки");
	var sTxts = ru("лиц.сч.","ос.рах.");
	addDocOper(sDoc, nNop, sTxt, sTxts);
	
	var sDoc = "SKU"
	var nNop = "1"
	var sTxt = ru("Счета за коммунальные услуги","Рахунки за комунальні послуги");
	var sTxts = ru("ком.усл.","ком.посл.");
	addDocOper(sDoc, nNop, sTxt, sTxts);
	
	installNorm();	
	installLgt();
	installNom();
}

//нормы
function installNorm()
{	
	var bDat = new Date(2007, 01, 01);
	var eDat = new Date(2008, 01, 01);
	var sSys = "HOC";
	
	sVar = "NORMAREA1";
	sValue = 21;
	sComment = "Норма площі на одну особу";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMAREA2";
	sValue = 10.5;
	sComment = "Норма площі на сім'ю";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMCWATER1";
	sValue = 3.5;
	sComment = "Хол. вода. Без гарячого водопостач.";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMCWATER2";
	sValue = 5.7;
	sComment = "Хол. вода. З ваннами і газовими колонками";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMCWATER3";
	sValue = 4.5;
	sComment = "Хол. вода. З дров'яними колонками";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMCWATER4";
	sValue = 2.85;
	sComment = "Хол. вода. З водопроводом і каналізацією";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMCWATER5";
	sValue = 1.8;
	sComment = "Хол. вода. В гуртожитках";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMCWATER6";
	sValue = 1.5;
	sComment = "Хол. вода. Інші випадки";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMELECTRIC11";
	sValue = 75;
	sComment = "Електроенергія. Крім будинків, які обладнані електричними плитами";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMELECTRIC12";
	sValue = 100;
	sComment = "Електроенергія. Для будинків, які обладнані електричними плитами";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMELECTRIC21";
	sValue = 15;
	sComment = "Електроенергія на кожного члена сім'ї. Крім будинків, які обладнані електричними плитами";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMELECTRIC22";
	sValue = 25;
	sComment = "Електроенергія на кожного члена сім'ї. Для будинків, які обладнані електричними плитами";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMELECTRIC3";
	sValue = 28;
	sComment = "Електроенергія (кВт/год на 1 кв.м). Для будинків, які обладнані електроопалювальними установками";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMELECTRICMAX1";
	sValue = 150;
	sComment = "Електроенергія. Крім будинків, які обладнані електричними плитами";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMELECTRICMAX2";
	sValue = 200;
	sComment = "Електроенергія. Для будинків, які обладнані електричними плитами";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMGAS1";
	sValue = 11;
	sComment = "Газ. На опалення житла";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMGAS2";
	sValue = 9.8;
	sComment = "Газ. У разі користування газовою плитою за наявності централізованого гарячого водопостачання";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMGAS3";
	sValue = 23.6;
	sComment = "Газ. У разі користування газовою плитою та водонагрівачем";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMGAS4";
	sValue = 18.3;
	sComment = "Газ. У разі користування газовою плитою за відсутності централізованого гарячого водопостачання та газового нагрівача";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMHWATER1";
	sValue = 3.5;
	sComment = "Гаряча вода";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
	
	sVar = "NORMHWATER2";
	sValue = 1.2;
	sComment = "Гаряча вода в гуртожитках";
	setOrgVars(sVar, sValue, sComment, sSys, bDat, eDat);
}

//льготы
function installLgt()
{	
	var sVid = "clexempt";
	var nCl = getPar("CODLGT");
	
	var mVar = new Object();	
	mVar.HCL = nCl;
		
	cod = 1;
	mVar.HTYPE = "Учасник бойових дій";
	mVar.HPERC = 75;
	mVar.HNORM =  1 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 2;
	mVar.HTYPE = "Учасник ВВВ";
	mVar.HPERC = 50;
	mVar.HNORM =  1 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 3;
	mVar.HTYPE = "Інвалід ВВВ";
	mVar.HPERC = 100;
	mVar.HNORM =  1 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 4;
	mVar.HTYPE = "Учасник ЧАЕС 1, 2 категорій";
	mVar.HPERC = 50;
	mVar.HNORM =  1 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 9;
	mVar.HTYPE = "Вдови Героїв СРСР, Соц. праці";
	mVar.HPERC = 100;
	mVar.HNORM =  0 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 10;
	mVar.HTYPE = "Герої СРСР";
	mVar.HPERC = 100;
	mVar.HNORM =  0 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 11;
	mVar.HTYPE = "Сім'я загиблого";
	mVar.HPERC = 50;
	mVar.HNORM =  1 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 12;
	mVar.HTYPE = "Вдова, діти, батьки загиблого війсковослужбовця";
	mVar.HPERC = 50;
	mVar.HNORM =  1 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 14;
	mVar.HTYPE = "Реабілітовані";
	mVar.HPERC = 50;
	mVar.HNORM =  1 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 17;
	mVar.HTYPE = "Ветеран війскової служби";
	mVar.HPERC = 50;
	mVar.HNORM =  1 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 18;
	mVar.HTYPE = "Інвалід дитинства ЧАЕС";
	mVar.HPERC = 50;
	mVar.HNORM =  1 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 27;
	mVar.HTYPE = "Вдова ветерана війск. служби";
	mVar.HPERC = 50;
	mVar.HNORM =  1 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 28;
	mVar.HTYPE = "Вдова (-ець) ЧАЕС 3 кат., опікун";
	mVar.HPERC = 50;
	mVar.HNORM =  1 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 29;
	mVar.HTYPE = "Вдова (-ець) ЧАЕС, опікун";
	mVar.HPERC = 50;
	mVar.HNORM =  1 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 30;
	mVar.HTYPE = "Інші особи ВВВ";
	mVar.HPERC = 30;
	mVar.HNORM =  1 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 33;
	mVar.HTYPE = "Ветеран СБУ";
	mVar.HPERC = 50;
	mVar.HNORM =  1 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 34;
	mVar.HTYPE = "Вдова ветерана СБУ";
	mVar.HPERC = 50;
	mVar.HNORM =  1 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 35;
	mVar.HTYPE = "Пенсіонер СБУ";
	mVar.HPERC = 50;
	mVar.HNORM =  1 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 37;
	mVar.HTYPE = "Ветеран органів МВС";
	mVar.HPERC = 50;
	mVar.HNORM =  1 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 38;
	mVar.HTYPE = "Вдова ветерана органів МВС";
	mVar.HPERC = 50;
	mVar.HNORM =  1 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 39;
	mVar.HTYPE = "Пенсіонер органів МВС";
	mVar.HPERC = 50;
	mVar.HNORM =  0 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 43;
	mVar.HTYPE = "Діти загиблих пожежників";
	mVar.HPERC = 50;
	mVar.HNORM =  0 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 44;
	mVar.HTYPE = "Пенсіонер пожежник";
	mVar.HPERC = 50;
	mVar.HNORM =  0 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 47;
	mVar.HTYPE = "Діти загиблих міліціонерів";
	mVar.HPERC = 50;
	mVar.HNORM =  0 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 48;
	mVar.HTYPE = "Пенсіонер прокуратури";
	mVar.HPERC = 50;
	mVar.HNORM =  0 ;
	addCL(sVid, nCl, cod, mVar);
	
	cod = 49;
	mVar.HTYPE = "Судді у відставці";
	mVar.HPERC = 50;
	mVar.HNORM =  0 ;
	addCL(sVid, nCl, cod, mVar);	

}

//услуги
function installNom()
{	
	var m = new Object();
	
	//--------Комунальні послуги---------
	var mainGrpID = GetUID();
	m.FCOD = "001.";
	m.FTXTS = "Комунальні послуги";	
	m.FTXT0 = "Комунальні послуги";	
	m.FCEDIB = 0;
	m.FVID = "";
	m.FWID = mainGrpID;
	m.FGRPID = 0;
	m.FISGRP = sqlTrue;	
	UpdateTable("^CL_NMK", m, true);
	
		m.FVID = "S";
		m.FCEDIB = 1;
		m.FISGRP = sqlFalse;	
		m.FGRPID = mainGrpID;
		
		m.FCOD = "001.0001";
		m.FTXTS = "Радіоточка";
		m.FTXT0 = "Радіоточка";
		m.FWID = GetUID();
		UpdateTable("^CL_NMK", m, true);
		
		m.FCOD = "001.0002";
		m.FTXTS = "Центральне опалення";
		m.FTXT0 = "Центральне опалення";
		m.FWID = GetUID();
		UpdateTable("^CL_NMK", m, true);
	
	
		//-----------Квартплата-------------
		var grpID = GetUID();
		m.FCOD = "001.001.";
		m.FTXTS = "Квартплата";
		m.FTXT0 = "Квартплата";
		m.FCEDIB = 0;
		m.FVID = "";
		m.FWID = grpID;
		m.FGRPID = mainGrpID;
		m.FISGRP = sqlTrue;	
		UpdateTable("^CL_NMK", m, true);
		
			m.FVID = "S";
			m.FCEDIB = 1;
			m.FISGRP = sqlFalse;	
			m.FGRPID = grpID;	
			
			m.FCOD = "001.001.0001";
			m.FTXTS = "5-поверхівки, 1 поверх 9-поверхівок готельного типу";
			m.FTXT0 = "5-поверхівки, 1 поверх 9-поверхівок готельного типу";
			m.FWID = GetUID();	
			UpdateTable("^CL_NMK", m, true);
			
			m.FCOD = "001.001.0002";
			m.FTXTS = "Будинки не обладнані ліфтами, 1 поверх будинків до 12 пов. з ліфтом";
			m.FTXT0 = "Будинки не обладнані ліфтами, 1 поверх будинків до 12 пов. з ліфтом";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
			
			m.FCOD = "001.001.0003";
			m.FTXTS = "Будинки обладнані ліфтами готельного типу";
			m.FTXT0 = "Будинки обладнані ліфтами готельного типу";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
			
			m.FCOD = "001.001.0004";
			m.FTXTS = "Будинки обладнані ліфтами до 12 поверхів";
			m.FTXT0 = "Будинки обладнані ліфтами до 12 поверхів";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
			
			m.FCOD = "001.001.0005";
			m.FTXTS = "Будинки обладнані ліфтами 12 поверхів і більше";
			m.FTXT0 = "Будинки обладнані ліфтами 12 поверхів і більше";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
			
			m.FCOD = "001.001.0006";
			m.FTXTS = "В т.ч. 1 поверх";
			m.FTXT0 = "В т.ч. 1 поверх";	
			m.FWID = GetUID();	
			UpdateTable("^CL_NMK", m, true);
		//-----------Квартплата-------------
	
		//-----Холодна вода та водовідведення-----
		var grpID = GetUID();
		m.FCOD = "001.002.";
		m.FTXTS = "Холодна вода та водовідведення";
		m.FTXT0 = "Холодна вода та водовідведення";
		m.FCEDIB = 0;
		m.FVID = "";
		m.FWID = grpID;
		m.FGRPID = mainGrpID;
		m.FISGRP = sqlTrue;	
		UpdateTable("^CL_NMK", m, true);
		
			m.FVID = "S";
			m.FISGRP = sqlFalse;	
			m.FGRPID = grpID;
			m.FCEDIB = 4;
			
			m.FCOD = "001.002.0001";
			m.FTXTS = "З центральнім гарячим водопостачанням";
			m.FTXT0 = "З центральнім гарячим водопостачанням";	
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
			
			m.FCOD = "001.002.0002";
			m.FTXTS = "Без гарячого водопостачання";
			m.FTXT0 = "Без гарячого водопостачання";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
			
			m.FCOD = "001.002.0003";
			m.FTXTS = "З ваннами та газовтими колонками";
			m.FTXT0 = "З ваннами та газовтими колонками";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
			
			m.FCOD = "001.002.0004";
			m.FTXTS = "З дров'яними колонками";
			m.FTXT0 = "З дров'яними колонками";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
			
			m.FCOD = "001.002.0005";
			m.FTXTS = "З водопроводом та каналізацією";
			m.FTXT0 = "З водопроводом та каналізацією";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
			
			m.FCOD = "001.002.0006";
			m.FTXTS = "В гуртожитках";
			m.FTXT0 = "В гуртожитках";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
			
			m.FCOD = "001.002.0007";
			m.FTXTS = "В інших випадках";
			m.FTXT0 = "В інших випадках";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
		//-----Холодна вода та водовідведення-----
	
		//--------------Гаряча вода---------------
		var grpID = GetUID();
		m.FCOD = "001.003.";
		m.FTXTS = "Гаряча вода";
		m.FTXT0 = "Гаряча вода";
		m.FCEDIB = 0;
		m.FVID = "";
		m.FWID = grpID;
		m.FGRPID = mainGrpID;
		m.FISGRP = sqlTrue;	
		UpdateTable("^CL_NMK", m, true);
		
			m.FVID = "S";
			m.FISGRP = sqlFalse;	
			m.FGRPID = grpID;
			m.FCEDIB = 4;
			
			m.FCOD = "001.003.0001";
			m.FTXTS = "На 1 особу";
			m.FTXT0 = "На 1 особу";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
			
			m.FCOD = "001.003.0002";
			m.FTXTS = "В гуртожитках";
			m.FTXT0 = "В гуртожитках";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
			
			m.FCOD = "001.003.0003";
			m.FTXTS = "При наявності в квартирі лічильника гарячої води";
			m.FTXT0 = "При наявності в квартирі лічильника гарячої води";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
			
			m.FCOD = "001.003.0004";
			m.FTXTS = "Водовідведення гарячої води при наявності в квартирі лічильника гарячої води";
			m.FTXT0 = "Водовідведення гарячої води при наявності в квартирі лічильника гарячої води";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);	
		//--------------Гаряча вода---------------
		
		//------------------Газ-------------------
		var grpID = GetUID();
		m.FCOD = "001.005.";
		m.FTXTS = "Газ";
		m.FTXT0 = "Газ";
		m.FCEDIB = 0;
		m.FVID = "";
		m.FWID = grpID;
		m.FGRPID = mainGrpID;
		m.FISGRP = sqlTrue;	
		UpdateTable("^CL_NMK", m, true);
		
			m.FVID = "S";
			m.FISGRP = sqlFalse;	
			m.FGRPID = grpID;
			m.FCEDIB = 4;
			
			m.FCOD = "001.005.0001";
			m.FTXTS = "В квартирах з газ. плитами та горячим водопостачанням";
			m.FTXT0 = "В квартирах з газ. плитами та горячим водопостачанням";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
		
			m.FCOD = "001.005.0002";
			m.FTXTS = "В квартирах з газ. плитами без горячого водопостачання водою";
			m.FTXT0 = "В квартирах з газ. плитами без горячого водопостачання водою";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
		
			m.FCOD = "001.005.0003";
			m.FTXTS = "В квартирах з газ. плитами та колонками без горячого водопостач";
			m.FTXT0 = "В квартирах з газ. плитами та колонками без горячого водопостач";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
		
			m.FCOD = "001.005.0004";
			m.FTXTS = "На опалення буд-ків в опалюв.період при нормі спож.11 куб.м на міс.";
			m.FTXT0 = "На опалення буд-ків в опалюв.період при нормі спож.11 куб.м на міс.";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
		
			m.FCOD = "001.005.0005";
			m.FTXTS = "Для побутових потреб та опалення при наявності лічильника";
			m.FTXT0 = "Для побутових потреб та опалення при наявності лічильника";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
		//------------------Газ-------------------
		
		//--------------Електроенергія-------------
		var grpID = GetUID();
		m.FCOD = "001.006.";
		m.FTXTS = "Електроенергія";
		m.FTXT0 = "Електроенергія";
		m.FCEDIB = 0;
		m.FVID = "";
		m.FWID = grpID;
		m.FGRPID = mainGrpID;
		UpdateTable("^CL_NMK", m, true);
		
			m.FVID = "S";
			m.FCEDIB = 5;	
			m.FISGRP = sqlFalse;	
			m.FGRPID = grpID;	
			
			m.FCOD = "001.006.0001";
			m.FTXTS = "Електроенергія";
			m.FTXT0 = "Електроенергія";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
		
			m.FCOD = "001.006.0002";
			m.FTXTS = "Для сільської місцевості";
			m.FTXT0 = "Для сільської місцевості";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
		
			m.FCOD = "001.006.0003";
			m.FTXTS = "Для будинків, обладнаних електроплитами";
			m.FTXT0 = "Для будинків, обладнаних електроплитами";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
		//--------------Електроенергія-------------
		
		//--------------Плата за тварин-------------
		var grpID = GetUID();
		m.FCOD = "001.007.";
		m.FTXTS = "Плата за тварин";
		m.FTXT0 = "Плата за тварин";
		m.FCEDIB = 0;
		m.FVID = "";
		m.FWID = grpID;
		m.FGRPID = mainGrpID;	
		m.FISGRP = sqlTrue;	
		UpdateTable("^CL_NMK", m, true);
		
			m.FVID = "S";
			m.FCEDIB = 1;	
			m.FISGRP = sqlFalse;	
			m.FGRPID = grpID;	
			
			m.FCOD = "001.007.0001";
			m.FTXTS = "Малі породи собак до 45 см";
			m.FTXT0 = "Малі породи собак до 45 см";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
		
			m.FCOD = "001.007.0002";
			m.FTXTS = "Середні породи собак до 65 см";
			m.FTXT0 = "Середні породи собак до 65 см";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
		
			m.FCOD = "001.007.0003";
			m.FTXTS = "Великі породи собак більше 65 см";
			m.FTXT0 = "Великі породи собак більше 65 см";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
		
			m.FCOD = "001.007.0004";
			m.FTXTS = "Породи собак згідно з додатками 2 та 3";
			m.FTXT0 = "Породи собак згідно з додатками 2 та 3";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);
		
			m.FCOD = "001.007.0005";
			m.FTXTS = "Хижі тварини";
			m.FTXT0 = "Хижі тварини";
			m.FWID = GetUID();
			UpdateTable("^CL_NMK", m, true);	
		//--------------Плата за тварин-------------
	
	//--------Комунальні послуги---------
}