include("Objects\\DpGetDat.js");
include("doc\\dpDocPtn.js");
include("objects\\DpGrid.js");
include("sys\\udfs.js");
include("doc\\DpDoc.js");

//__CreateGrid();
var gr;

var ds,t;
var zmbDate;
var zmeDate;
var nPodr;
var tblSource;

var oDoc = new DpDoc("BrNk", 0);

function listAsk()
{
	var gd=new DpGetDat(new Array("r","p0"));
	zmbDate = gd.dat1;
	zmeDate = gd.dat2;
	nPodr = gd.fpodr;
	
	return gd;
}

function listDpGrid()
{
	with(new DpGrid("NOCREATE"))
	{
		with(page())
		{
			with(group("Подразделение"))
			{
				cell("fpodr", "Код", 5);
				cell("=^PD.FTXT", "Наименование", 9);
			}
			with(group("Кассовый аппарат"))
			{
				cell("FCAS_COD", "Код", 5);
				cell("=^CAS.FTXT", "Наименование", 9);
				cell("=xcl(" + oDoc.getPar("_brnk_codmag") +", ^FCAS_COD, 'RRO_MOD')", "Модификация РРО", 7);
				cell("=xcl(" + oDoc.getPar("_brnk_codmag") +", ^FCAS_COD, 'RRO_N')", "Фискальный номер РРО", 7);
			}
			cell("FSUM_VITORG_S", "Выторг (Обіг А)", 11, "", DP_FORMAT_SUM);
			cell("FSUM_V2POK_S", "Возврат д. покупат.", 11, "", DP_FORMAT_SUM);
			cell("=^FSUM_VITORG_S - ^FSUM_V2POK_S - ^FSUM_CRED_S + ^FSUM_VCRED_S", "Инкасация (Гроші)", 11, "", DP_FORMAT_SUM);
			cell("FSUM_CRED_S", "Кредитные карточки", 11, "", DP_FORMAT_SUM);
			cell("FSUM_VCRED_S", "Возврат по кредитным карточкам", 11, "", DP_FORMAT_SUM);
			cell("FSUM_KRK_S", "Показ. термин. по кр/к", 11, "", DP_FORMAT_SUM);
		}
		build();
	}
}

function listTitle()
{
	return "Продажи по магазинам по кассовым аппаратам";
}

function listSrc()
{
	if(zmbDate && zmeDate)
		cWhere = "a.FDATE BETWEEN "
				+ sqlTo(zmbDate)+" AND "+sqlTo(zmeDate);
	else
		cWhere = sqlCmpTrue;
	cWhere += sqlw0And("b.fpodr=", nPodr);

	tblSource = getTmpTableName();
	ExecuteSQL("SELECT a.FCAS_COD, b.fpodr, "
		+ " sum(a.FSUM_VITORG) FSUM_VITORG_S, sum(a.FSUM_V2POK) as FSUM_V2POK_S, sum(a.FSUM_CRED) as FSUM_CRED_S, sum(a.FSUM_VCRED) as FSUM_VCRED_S, sum(a.FSUM_KRK) as FSUM_KRK_S "
		+ " INTO " + tblSource + " FROM ^RBRNK a "
		+ " left join ^HBRNK b on a.fid_doc = b.fwid WHERE FTT=0 AND "
			+ cWhere
			+ " and b.fwid is not null "
		+ " GROUP BY b.fpodr, a.FCAS_COD")
	ExecuteSQL("ALTER TABLE " + tblSource +" ADD FWID "+ SqlType("COUNTER"));
	
	this.qrySet("From", tblSource,
   				"Order", new Array("fpodr,FCAS_COD")
   				);
	// подр
	this.subTie("clrelclcl","CLRELPD","CLCOD","="+sqlTo(sprPodr)+",FPODR");
	this.subTie("cl","PD","FWID","CLRELPD.FWID_CL",null,TIE_NOSEARCH);
	// кассовый аппарат
	this.subTie("clrelclcl","CLRELCAS","CLCOD","="+sqlTo(oDoc.getPar("_brnk_codmag"))+",FCAS_COD");
	this.subTie("cl","CAS","FWID","CLRELCAS.FWID_CL",null,TIE_NOSEARCH);
	
	this.printLabel = "brnk_rows"; 
}

function getTblR()
{
	t = OpenTable("select FCAS_COD, sum(FSUM_VITORG_S) FSUM_VITORG, sum(FSUM_V2POK_S) as FSUM_V2POK, sum(FSUM_CRED_S) as FSUM_CRED, sum(FSUM_VCRED_S) as FSUM_VCRED, sum(FSUM_KRK_S) as FSUM_KRK"
			+" from "+tblSource
			+" where Fwid "+grid.sqlSelected(true)
			+" group by FCAS_COD"
			+" order by FCAS_COD");
	return t;
}

function getTblH()
{
	var obj = new Object();
	
    obj.FD1  = zmbDate;
    obj.FD2  = zmeDate;
	obj.FCAPTION1 = "Продажи по кассовым аппаратам " + String(nPodr == 0 ? "по всем магазинам" : tcl("CL", "TXT", sprPodr, nPodr));
	return obj;
}

include("sys\\DpList.js");