include("Objects/DpCtrlLinker.js");
include("Objects/DpzDoc.js");
include("Objects/DpClEx.js");
include("sys/udfs.js");
include("Objects/DpCl.js");
include("doc/DpDocList.js");
include("doc/DpDoc.js");
include("doc/regJr.js");
include("sys/ListApi.js");

var sDir = rootDirectory() + "cls/CL2/";
var tmp_ORG_RS = getTmpTableName();
var tmp_ORG_CP = getTmpTableName();
var nCl = getPar("CODPLAT");
var oCl;
var rsTbl;
var cpTbl;
var arrCtrlNum = new Array();
var arrSF = null;
var arrPV = null;
var actIsCalc = false;

function onLoad()
{
	FCOD.setMask("########");
	FCALLCOD.mask = "&&&&&&&&";
	FZIP.mask = "&&&&&&";
	FCOD_ST.mask = "&&&&&&&&&&";
	//FCOD_STF.mask = "&&&&&&&&&&";
	FCOD_NDS.mask = "&&&&&&&&&&&&&&&";
	FREGIS.mask = "&&&&&&&&&&&&&&&";
	FBLD.mask = "&&&&&&&&&&&&&&&&&&&&";
	FAPART.mask = "&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&";
	
	if(extPar.Fcl)
		nCl = extPar.Fcl;
	
	oCl = new DpClEx("CL2", nCl);
	
	this.oOrg = new DpCl("0", nCl, 0);
	this.oOrg.linkSmartCtrl(FORG);
	this.oOrg.setContAssist();
	if(extPar.org)
		this.oOrg.setCod(extPar.org);		
	this.oOrg.AfterUpdate = loadCl;	
				
	DOC.value = "";
	NOP.mask = "###########";
		
	this.dpzDoc = new DpzDoc("", 0);	
	this.dpzDoc.linkCtrl(DOC);
	this.dpzDoc.linkCtrlNop(NOP);
	this.dpzDoc.sMode == "allsys";
	this.dpzDoc.subUpdate = loadDocs;
	this.dpzDoc.canEmpty = true;
		
	this.rowMenuInit = rowMenuInit;
	this.rowMenuRun = rowMenuRun;
	
	this.gridHeaderMenuInit = gridHeaderMenuInit;
	this.gridHeaderMenuRun = gridHeaderMenuRun;
	
	FORM.getDialogBuilder().setToolItemSelection(btnAddOrg, this.oOrg, "add");
	
	setValid(FORG, loadCl);		
	setButton(btnFind, findCl);
		
	setButton(btnOK, onSave);
	setButton(btnCancel, onCancel);
	
	setButton(btnFILTER_DOCS, loadDocs);
	setValid(TYPEPER_DOCS, onChangePeriod);
	
	setButton(btnCALC_ACT, act_recalc);
	setValid(TYPEPER_ACT, onChangePeriod);
	
	setButton(btnFILTER_TASK, loadTasks);
	setValid(TYPEPER_TASK, onChangePeriod);
	
	setButton(btnFILTER_PHONE, loadPhone);
	setValid(TYPEPER_PHONE, onChangePeriod);
	
	setButton(btnFILTER_MAIL, loadMail);
	setValid(TYPEPER_MAIL, onChangePeriod);
	
	setButton(btnFILTER_EVENT, loadEvent);
	setValid(TYPEPER_EVENT, onChangePeriod);
	
	this.tab_listener = tab_listener;
	TAB.setSelectionHandler(this, "tab_listener");
	
	setButton(EMAILTO, sendMail);
	setButton(WEBTO, openWeb) ;	
	setValid(FCAT, kat_valid);
	
	setButton(NAL, nal_click);		
	setValid(FPLATNDS, Fplatnds_valid);	
	setValid(FCOD, Fcod_valid);	
	
	//buildExtTab();
		
	BDAT_DOCS.value = getPar("GLOBDAT1");
	EDAT_DOCS.value = getPar("GLOBDAT2");
	BDAT_ACT.value = getPar("GLOBDAT1");
	EDAT_ACT.value = getPar("GLOBDAT2");
	BDAT_TASK.value = getPar("GLOBDAT1");
	EDAT_TASK.value = getPar("GLOBDAT2");
	BDAT_PHONE.value = getPar("GLOBDAT1");
	EDAT_PHONE.value = getPar("GLOBDAT2");
	BDAT_MAIL.value = getPar("GLOBDAT1");
	EDAT_MAIL.value = getPar("GLOBDAT2");
	BDAT_EVENT.value = getPar("GLOBDAT1");
	EDAT_EVENT.value = getPar("GLOBDAT2");
		
	loadCl();
	
	loadJournals();
	listGrid();
	loadGridDocs();
	loadGridAct();
	loadGridTasks();
	loadGridPhone();
	loadGridMail();
	loadGridEvent();
	loadGridResponse();
}

function listTitle()
{
	var sTitle = UR("Зведена інформація|Сводная информация");
	sTitle += ": "+ list.oOrg.getCod() +" - "+ list.oOrg.getTxt();
	Caption(sTitle);
	return sTitle;
}

function tab_listener(tabItem)
{
	if(tabItem.equals(TAB_ACT))
	{
		if(!actIsCalc)
			act_recalc();
	}
}


function buildExtTab()
{
	try
	{
		extPar.dpObj = oCl;
		list.isObj = true;
		list.extCtrlMap = new Array();
		var extInfo = oCl.getExtInfo();	
		for(var sExt in extInfo)
		{		
			var FI = extInfo[sExt];		
			list.addCtrl(GREXT, FI, "#");
		}
	}
	catch(e)
	{
		alert(e, 2);
	}
}

function loadExt()
{
	try
	{
		var arrExtCtrl = GREXT.getChildren();
		for(var i=0; i<arrExtCtrl.length; i++)
		{
			if(arrExtCtrl[i])
				arrExtCtrl[i].dispose();
		}
		buildExtTab();
	}
	catch(e)
	{
		alert(e, 2);
	}	
}

function loadCl()
{
	toolbarOrg.setVisible(false);
	if(list.oOrg.ctrlSmart.value!="" && !list.oOrg.valid())
		toolbarOrg.setVisible(true);
	if(oCl.getID() == list.oOrg.getFWID())
		return true;
	
	var bLoad = oCl.loadByID(list.oOrg.getFWID());
	//if(!bLoad)
	//	return false;
	listTitle();	
	
	loadExt();
	
	ctrlLinker = new DpCtrlLinker(oCl);
	
	ctrlLinker.addLink("HCOD", FCOD);
	ctrlLinker.addLink("HTXT", FTXT);	
	ctrlLinker.addLink("HTXTS", FTXTS);
				
	oClCountry = new DpCl("0", getPar("CODCOUNTRY"), 0);
	oClCountry.linkCtrl(FCOUNTRY, TFCOUNTRY);
	oClCountry.setContAssist();
	oClRegion = new DpCl("U0", getPar("CODREGION"), 0, oClCountry);
	oClRegion.linkCtrl(FREGION, TFREGION);
	
	oClArea = new DpCl("U0", getPar("CODAREA"), 0, oClRegion);
	oClArea.linkCtrl(FAREA, TFAREA);
	
	oClLocate = new DpCl("U0", getPar("CODLOCATE"), 0, oClArea);
	oClLocate.linkCtrl(FLOCATE, TFLOCATE);	
	
	oPred = new DpCl("0");
	oPred.setClcl(getPar("CODPLAT"));
	oPred.linkCtrl(Fpred);
	oPred.linkCtrl2("Ftxt", Fprtxt);
	oPred.setContAssist();
	
	ctrlLinker.addLink("HREM", FREM);
	ctrlLinker.addLink("HCALLCOD", FCALLCOD);
	ctrlLinker.addLink("HPHONE", FPHONE);
	ctrlLinker.addLink("HFAX", FFAX);
	ctrlLinker.addLink("HZIP", FZIP);
	ctrlLinker.addClLink("HCODCOUNTRY", oClCountry);
	ctrlLinker.addClLink("HCODREGION", oClRegion);
	ctrlLinker.addClLink("HCODAREA", oClArea);
	ctrlLinker.addClLink("HCODLOCATE", oClLocate);
	ctrlLinker.addLink("HADDR",		FADDR);
	ctrlLinker.addLink("HYURADDR", 	FYURADDR);
	ctrlLinker.addLink("HNDSADDR",  FNDSADDR);
	ctrlLinker.addLink("HCOD_ST", 	FCOD_ST);
	ctrlLinker.addLink("HPLATNDS", 	FPLATNDS);
	ctrlLinker.addLink("HREGIS", 	FREGIS);
	ctrlLinker.addLink("HCOD_NDS", 	FCOD_NDS);
	ctrlLinker.addLink("HEMAIL", 	FEMAIL);
	ctrlLinker.addLink("HWEB", 	    FWEB);	
	ctrlLinker.addLink("HRECVD", 	FRECVD);	
	ctrlLinker.addClLink("HPRED", 	oPred);		
	ctrlLinker.addLink("HNADMCOD", 	FNADMCOD);
	ctrlLinker.addLink("HNADMTXT", 	FNADMTXT);
	ctrlLinker.addLink("HCAT", 		FCAT);
	ctrlLinker.addLink("HDOCTXT", 	FDOCTXT);
	ctrlLinker.addLink("HDOCSER", 	FDOCSER);
	ctrlLinker.addLink("HDOCNOM", 	FDOCNOM);
	ctrlLinker.addLink("HDOCDAT", 	FDOCDAT);
	ctrlLinker.addLink("HDOCOWN", 	FDOCOWN);
	//ctrlLinker.addLink("HINDNUM", 	FINDNUM);
	ctrlLinker.addLink("HDOCNOTE",	FDOCNOTE);
	ctrlLinker.addLink("HNOTE", 	FNOTE);
	ctrlLinker.addLink("HBLD", 		FBLD);
	ctrlLinker.addLink("HAPART", 	FAPART);
		
	ctrlLinker.toControls();	
	
	oClRegion.validCtrl();
	oClArea.validCtrl();
	oClLocate.validCtrl();
	
	Fplatnds_valid();
	show_nal();	
	
	loadGridRs();	
	loadGridCp();
	loadGRNum();
			
	kat_valid();
	
	FCOD_ST.value = String(FCOD_ST.value).trim();	
	//FCOD_STF.value = String(FCOD_STF.value).trim();
	FCOD_NDS.value = String(FCOD_NDS.value).trim();
	FREGIS.value = String(FREGIS.value).trim();
		
	//if(grid.getTable())
	//	list.init();
		
	loadDogs();
	loadDocs();
	loadAct();
	loadTasks();
	loadPhone();
	loadMail();
	loadEvent();
	loadResponse();
}

function findCl()
{
	var par = new Object();		
	par.Fcl = 0;
	par.Fcod = list.oOrg.getCod();
	par.ret = new Object();
	par.ret.Fcod = par.Fcod;	
	showWindow("l_cl.xml", SW_NOMODAL, par);
}

function loadGRNum()
{
	var dlgBuilder = FORM.getDialogBuilder();
	
	var tbl = OpenTable("select * from ^CLCL "
					+" where FVID="+ sqlTo("2")
						+" and FCOD<>0 "
					+" order by FCOD");	
	for(; !tbl.isEOF(); tbl.MoveNext())
	{		
		var cod = Number(tbl.getValue("FCOD"));
		if(arrCtrlNum[cod])
		{
			arrCtrlNum[cod].value = false;
			continue;
		}
		var txt = tbl.getValue("FTXT");
		var ctrlName = "FNUM_"+ cod;
		var ctrl = dlgBuilder.addCheckBox(GRNUM, ctrlName, txt);
		arrCtrlNum[cod] = ctrl;		
	}
	tbl.close();
		
	var arrCLS = oCl.jObj.getChilds("CLNUM");
	for(var i=0; i<arrCLS.length; i++)
	{
		if(arrCLS[i])
		{
			var nCL = Number(arrCLS[i].getVar("HCL"));		
			if(arrCtrlNum[nCL])
				arrCtrlNum[nCL].value = true;
		}
	}
}

function nal_click()
{	
	var par = new Object();
	par.ret = new Object();
	par.fwid_cl = oCl.getID();
	showWindow("l_cl_nal.js", SW_MODAL, par); 
	
	show_nal();
}

function Fplatnds_valid()
{
	if(!FPLATNDS.checked && (FREGIS.value != "" || FCOD_NDS.value != ""))
	{
		WAIT(ru("Не плательщик НДС не может иметь код плат. НДС или № свид. регистр."
			   ,"Не платник ПДВ не може мати код плат. ПДВ або № посв. регістр."))
		return true;
	}
	
	Enable(FREGIS, FPLATNDS.checked);
	Enable(FCOD_NDS, FPLATNDS.checked);
}

function show_nal()
{	
	var t = getSnap("SELECT FNAL"
					+ " FROM ^cl_nal"
					+ " WHERE fwid_cl=" + oCl.getID()
					+ " ORDER BY fbdate DESC"
				);	
	var cNal;
	
	if(t == null)
		cNal = nal_name(0);
	else
		cNal = nal_name(t[0])
		
	Disable(NAL_TEXT);
	NAL_TEXT.value = cNal;
}

function nal_name(nal)
{
	if(nal)
		return ru("единый налог","єдиний податок");
	else
		return ru("на общих основаниях","на загальних підставах");
}

function loadGridRs()
{
	if(rsTbl)
		rsTbl.close();
	if(!ExecuteSQL("drop table "+ tmp_ORG_RS, false))
		ExecuteSQL("delete from "+ tmp_ORG_RS, false);		
	var sWhere = " WHERE 1<>1 ";
	if (this.sMode != "ADD")
		sWhere = " WHERE FWID_CL = " + sqlTo(oCl.getID())
	var sSQL = "SELECT * "
			+ " INTO " + tmp_ORG_RS
			+ " FROM ^CL_ORGRS "
			+ sWhere;	
	ExecuteSQL(sSQL, false);
		
	rsTbl = OpenTable("m", "SELECT * FROM " + tmp_ORG_RS +" ORDER BY FNOMRR");
	rsTbl.tie("cl_valut", "val", "fkod", "fval");
	
	gridRS.DeletePages();
	gridRS.setXMLDir(sDir);
	gridRS.setXMLFile("gridrs.xml");
	gridRS.setTable(rsTbl);
	gridRS.build();		
	gridRS.setData("ORS");	
	
	gridRS.loadMenuHandler(this, "rowMenuInit");
	gridRS.selectMenuHandler(this, "rowMenuRun");	
}

function loadGridCp()
{
	if(cpTbl)
		cpTbl.close();
	if(!ExecuteSQL("drop table "+ tmp_ORG_CP, false))
		ExecuteSQL("delete from "+ tmp_ORG_CP, false);	
				
	var sWhere = " WHERE 1<>1 ";
	if (this.sMode != "ADD")
		sWhere = " WHERE FWID_CL = " + sqlTo(oCl.getID())
	var sSQL = "SELECT * "
			+ " INTO " + tmp_ORG_CP
			+ " FROM ^CL_ORGCP "
			+ sWhere;	
	ExecuteSQL(sSQL, false);
	
	cpTbl = OpenTable("s", "SELECT * FROM " + tmp_ORG_CP);
	gridCP.DeletePages();
	gridCP.setXMLDir(sDir);
	gridCP.setXMLFile("gridcp.xml");
	gridCP.setTable(cpTbl);	
	gridCP.build();
	gridCP.setData("OCP");	
	
	gridCP.loadMenuHandler(this, "rowMenuInit");
	gridCP.selectMenuHandler(this, "rowMenuRun");	
}

function rowMenuInit(oGrid)
{
	var tbl = oGrid.getTable();
	if(!tbl.isEmpty() && oGrid.equals(gridRS))
		oGrid.AddMenuItem("MAKE_CURRENT", "Встановити поточним|Установить текущим");
	oGrid.AddMenuItem("ADD", "Додавання|Добавление");
	if (!tbl.isEmpty())
	{
		oGrid.AddMenuItem("EDIT", "Редагування|Редактирование");
		oGrid.AddMenuItem("DEL", "Видалення|Удаление");		
	}
}

function rowMenuRun(sID, oGrid)
{
	var tbl = oGrid.getTable();
	var tName = tbl.getTableName();	
	var rowID = Number(tbl.getValue("FWID"));
	var sRowClass = "ORS";
	if(oGrid.equals(gridCP))
		sRowClass = "OCP";
			
	switch(sID)
	{
		case "ADD": case "EDIT": case "COPY":
			var oRow;						
			if(sID == "ADD")
				oRow = oCl.createRow(sRowClass);
			else if(sID == "EDIT")
				oRow = oCl.getRow(sRowClass, rowID);
			else if(sID == "COPY")
				oRow = oCl.copyRow(sRowClass, rowID);										
			bSaveRow = false;								
			if(!oRow)
				break;			
			if(oGrid.equals(gridCP))
				bSaveRow = cpEdit(sID, rowID, oRow);
			else
				bSaveRow = rsEdit(sID, rowID, oRow);			
			gridRefresh(oGrid, oRow.getID());	
			break;
		
		case "MAKE_CURRENT":			
			resetMainRs(rowID)
			var oRow = oCl.getRow(sRowClass, rowID);
			if(oRow)
				oRow.setVar("HMAIN", true);
			ExecuteSQL("UPDATE "+ tmp_ORG_RS 
						+" SET Fmain="+ sqlTrue 
						+" WHERE Fwid="+ rowID);	
			gridRefresh(oGrid, rowID);		
			break;
	
		case "DEL":
			var nGridPos = oGrid.getRowSelected();
			ExecuteSQL("delete from "+ tName
						+" where FWID="+ sqlTo(rowID)
					);
			oCl.deleteRow(sRowClass, rowID);
			
			tbl.requery();
			tbl.setAbsolute(nGridPos-1);
			oGrid.refresh();
			break;
	}	
	return true;
}

function rsEdit(sMode, nID, oRow)
{	
	var par = new Object();
	par.dpObj = oRow;
	par.mode = sMode;
	par.tblName = tmp_ORG_RS;
	par.formFile = "cls/"+ oCl.sClassId +"/ORGRS/form.xml"; 	
	par.dpObj.hasExt = new Function("return false");
		
	showWindow(par.formFile, "XMLDLG", par);
		
	if(par.escape)
		return false;
	
	var id = oRow.getID();	
	if(inList(sMode, "ADD", "COPY"))
		oCl.appendRow("ORS", oRow);

	if(oRow.getVar("HMAIN")==true)
		resetMainRs(id);
	obj2DB(id, oRow.jObj, null, tmp_ORG_RS);
	
	return true;
}

function cpEdit(sMode, nID, oRow)
{	
	var par = new Object();
	par.dpObj = oRow;
	par.mode = sMode;
	par.formFile = "cls/"+ oCl.sClassId +"/ORGCP/form.xml"; 	
	par.dpObj.hasExt = new Function("return false");
	par.objCl = oCl;
		
	showWindow(par.formFile, "XMLDLG", par);
		
	if(par.escape)
		return false;
	
	var id = oRow.getID();	
	if(inList(sMode, "ADD", "COPY"))
		oCl.appendRow("OCP", oRow);
	
	obj2DB(id, oRow.jObj, null, tmp_ORG_CP);
	
	return true;
}

function resetMainRs(nID)
{
	var sWhere = " where FMAIN<>"+ sqlFalse;
	if(nID)
		sWhere += " and FWID<>"+ nID;
	var oMain = getSnap("select FWID from "+ tmp_ORG_RS + sWhere);
	if(!oMain)
		return false;		
	
	var nID = oMain[0];
	var oRow = oCl.getRow("ORS", nID);
	if(oRow)
		oRow.setVar("HMAIN", sqlFalse);					
	ExecuteSQL("UPDATE "+ tmp_ORG_RS +" SET Fmain="+ sqlFalse);
	return true;	
}

function gridRefresh(oGrid, rowID)
{
	oGrid.getTable().requery();
	if(rowID)
		oGrid.getTable().findByID(rowID);		
	oGrid.setFocus();
	oGrid.refresh();
}

function sendMail()
{
	var mail = FEMAIL.value;
	var fio = FTXT.value;
	var nNop = getPar("SMTP_DOC");
	if(!nNop)
		nNop = 2;
	
	include("doc/DpDoc.js");
	var oDoc = new DpDoc("MMSG", nNop);		
	oDoc.setVar("HNOM", oDoc.getAutoNo().get());
			
	var oRow = oDoc.createRow("MCNT");	
	oRow.setVar("HMAIL", mail);
	oRow.setVar("HFIO", fio);
	oRow.setVar("HIDCP", oCl.getID());
	oDoc.appendRow("MCNT", oRow);
	obj2DB(oRow.getID(), oRow.jDocRow, null, "MAIL_CNT");
	
	bRet = oDoc.edit("ADD");	
	return bRet;
}

function openWeb()
{
	if (FWEB.value == "") 
		return;	
	lpProxy.displayURL(FWEB.value);
}

function kat_valid()
{
	return;
	if(FCAT.value==1)
	{
		if(TRS.getControl().equals(GPAS))
			return;
		GPAS.setParent(TRS.getControl().getParent());
		TRS.setControl(GPAS);
		TRS.setText(UR("Паспортні дані|Паспортные данные"));
		
		ctrlLinker.addLink("HCOD_ST", 	FCOD_STF);	
		FCOD_STF.value = oCl.getVar("HCOD_ST");
		FINDNUM.value = oCl.getVar("HCOD_NDS");
	}
	else
	{
		if(TRS.getControl().equals(GRS))
			return;
		GRS.setParent(TRS.getControl().getParent());
		TRS.setControl(GRS);
		TRS.setText(UR("Банківські рахунки|Банковские счета"));
		
		ctrlLinker.addLink("HCOD_ST", 	FCOD_ST);
		FCOD_ST.value = oCl.getVar("HCOD_ST");		
	}
}

function Fcod_valid()
{	
	var s = "SELECT a.* FROM ^CL a"
		+" INNER JOIN ^CLRELCLCL b ON a.FWID=b.FWID_CL"
		+" WHERE b.FCOD=" + FCOD.getValue()			
			+" AND b.FCL=0" 
			+" AND a.fwid <> "+ oCl.getID();
	ts = getSnap(s);
	if(ts!=null)
	{
		strError = ru("Контрагент с таким кодом уже существует."
					 ,"Контрагент із таким кодом вже існує.");		
		WAIT(strError);
		setFocus(FCOD);
		return false;
	}
}

function onSave()
{
	ctrlLinker.toVars();
		
	storeToDb("CL_ORGRS", tmp_ORG_RS);
	storeToDb("CL_ORGCP", tmp_ORG_CP);
	saveNum();
	
	//if(FCAT.value==1)	
	//	oCl.setVar("HCOD_NDS", FINDNUM.value);
	
	oCl.save("EDIT");	
	list.saveExt();
	
	if(extPar && extPar.grid)
	{
		var tbl = extPar.grid.getTable();
		if(tbl)
		{
			tbl.requery();
			tbl.findByID(oCl.getID());
		}
		extPar.grid.refresh();
	}
	exit();
	if(extPar)
		extPar.escape = false;
}

function saveNum()
{
	for(var nCL in arrCtrlNum)
	{
		var ctrl = arrCtrlNum[nCL];
		if(!ctrl)
			continue;
		if(ctrl.value==true)
		{
			oCl.addTOCL(nCL);			
		}
		else
		{
			oCl.removeFromCL(nCL);	
		}
	}
}

function storeToDb(sTbl, tmpTbl)
{
	var sFld = GetPatternIntersection(sTbl, sTbl);
	ExecuteSQL("DELETE FROM ^"+ sTbl +" WHERE FWID_CL = " + sqlTo(oCl.getID()));
	ExecuteSQL("UPDATE " + tmpTbl + " SET Fwid_cl=" + sqlTo(oCl.getID()));
	ExecuteSQL("INSERT INTO ^"+ sTbl +" ( " + sFld + ")"
		+" SELECT "+ sFld + " FROM " + tmpTbl);
}

function exit()
{
	rsTbl.close();
	cpTbl.close();
	DropTable(tmp_ORG_RS);
	DropTable(tmp_ORG_CP);	
	CloseWindow();
}

function onCancel()
{
	exit();
}

function onChangePeriod(oCtrl)
{
	var sType = String(oCtrl.value);
	if(oCtrl.equals(TYPEPER_ACT))
	{
		changePeriod(sType, BDAT_ACT, EDAT_ACT);
		loadAct();
		act_recalc();		
	}
	else if(oCtrl.equals(TYPEPER_DOCS))
	{
		changePeriod(sType, BDAT_DOCS, EDAT_DOCS);
		loadDocs();
	}
	else if(oCtrl.equals(TYPEPER_TASK))
	{
		changePeriod(sType, BDAT_TASK, EDAT_TASK);
		loadTasks();
	}
	else if(oCtrl.equals(TYPEPER_PHONE))
	{
		changePeriod(sType, BDAT_PHONE, EDAT_PHONE);
		loadPhone();
	}
	else if(oCtrl.equals(TYPEPER_MAIL))
	{
		changePeriod(sType, BDAT_MAIL, EDAT_MAIL);
		loadMail();
	}
}

function changePeriod(sType, oBDatCtrl, oEDatCtrl)
{
	switch (sType)
	{
		case "TD":
			oBDatCtrl.value = today.getVarDate();
			oEDatCtrl.value = today.getVarDate();
			break;
		case "YTD":
			oBDatCtrl.value = goDay(today, -1);
			oEDatCtrl.value = goDay(today, -1);
			break;
		case "TW":
			oBDatCtrl.value = goDay(today, -today.getDay());
			oEDatCtrl.value = goDay(today,6 - today.getDay());
			break;
		case "TM":
			oBDatCtrl.value = firstDayMonth(today);
			oEDatCtrl.value = lastDayMonth(today);
			break;
		case "LM":
			oBDatCtrl.value = firstDayMonth(_dateTrans(today, "M+", -1));
			oEDatCtrl.value = lastDayMonth(_dateTrans(today, "M+", -1));
			break;
		case "2M":
			oBDatCtrl.value = firstDayMonth(_dateTrans(today, "M+", -1));
			oEDatCtrl.value = lastDayMonth(today);
			break;		
		case "TY":
			oBDatCtrl.value = jan01(today);
			oEDatCtrl.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "2Y":
			var bdat = new Date(today.getFullYear()-1, today.getMonth());
			oBDatCtrl.value = jan01(bdat);
			oEDatCtrl.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "ALL":
			oBDatCtrl.value = d00min;
			oEDatCtrl.value = d00;
			break;
		default:
			break;
	}
}


function listSrc()
{
	var dat1 = DATB.value;
	var dat2 = DATE.value;
			
	var sWhere = " 1=1 ";
	if(differ(dat1, d00)<0)
		sWhere += " and FEDAT>"+ sqlTo(dat1);
	if(differ(dat2, d00)<0)
		sWhere += " and FBDAT<"+ sqlTo(dat2);
	if(list.oOrg)
		sWhere += " and FORG="+ sqlTo(list.oOrg.getCod());
	
	this.qrySet("From", "^CONTRACT", "Where", sWhere, "Order", "FDOC_DAT");
	this.clTie("x_cl", "=0, FORG");
}

function loadDogs()
{
	var dat1 = DATB.value;
	var dat2 = DATE.value;
			
	var sWhere = " 1=1 ";
	if(differ(dat1, d00)<0)
		sWhere += " and FEDAT>"+ sqlTo(dat1);
	if(differ(dat2, d00)<0)
		sWhere += " and FBDAT<"+ sqlTo(dat2);
	if(list.oOrg)
		sWhere += " and FORG="+ sqlTo(list.oOrg.getCod());	
	var sOrder = getGridOrder(grid);
	if(!sOrder)
		sOrder = "FDOC_DAT";	
	var tbl = OpenTable("select * from ^CONTRACT "
						+" where "+ sWhere 
						+" order by "+ sOrder
						);
	var sTxt = UR(TAB.getItem(2).getText());
	if(sTxt.indexOf("(")!=-1)
		sTxt = sTxt.substring(0, sTxt.indexOf("("));
	sTxt += "("+ tbl.recordCount +") ";
	TAB.getItem(2).setText(sTxt);
	grid.setTable(tbl);
	grid.refresh();
}


function listGrid()
{
	grid.DeletePages();
	with(grid)
	{
		FieldEx("FDOG_NUM", "№ договору|№ договора", 10);
		FieldEx("FDOC_DAT", "Дата", 12);		
		FieldEx("FTXT", "Назва договору|Название договора", 12);
		FieldEx("Fbdat", "Дата начала|Дата начала", 12);
		FieldEx("Fedat", "Дата кінця|Дата конца", 12);
		FieldEx("FDOC", "Документ|Документ", 10);
		FieldEx("FNOP", "Операція|Операция", 8);			
	}
	grid.build();
	
	this.listMenuInit = listMenuInit;
	this.listMenuRun = listMenuRun;
	grid.loadMenuHandler(this, "listMenuInit");
	grid.selectMenuHandler(this, "listMenuRun");
	
	grid.setHeaderMenuLoader(this, "gridHeaderMenuInit");
	grid.setHeaderMenuSelector(this, "gridHeaderMenuRun");
}

function listMenuInit(oGrid)
{	
	if(oGrid.getTable().getValue("FDOC"))
	{
		if(IsDblClick(oGrid))
		{
			listMenuRun("EDIT", oGrid);
			return true;
		}		
		oGrid.AddMenuItem("FINDDOC", "Знайти документ|Найти документ");
		oGrid.AddMenuItem("", "");
	}
	
	var tbl = OpenTable("select * from ^CL_LNK where FIS_DOG="+ sqlTrue);
	oGrid.AddMenuItem("+++", "Додати|Добавить");
	for(; !tbl.isEOF(); tbl.MoveNext())
	{
		var doc = tbl.getValue("FDOC");
		var txt = UR(tbl.getValue("FTXT"));
		oGrid.AddMenuItem("ADD_"+ doc, txt);
	}
	oGrid.AddMenuItem("---", "Додати|Добавить");
	tbl.close();
	
	if(!oGrid.getTable().isEmpty())
	{
		oGrid.AddMenuItem("COPY", "Скопіювати|Копировать");
		oGrid.AddMenuItem("EDIT", "Редагувати|Редактировать");
		oGrid.AddMenuItem("VIEW", "Перегляд|Просмотр", 1002);
	}
}

function listMenuRun(sID, oGrid)
{	
	var tbl = oGrid.getTable();
	var doc = tbl.getValue("FDOC");
	if(sID.indexOf("ADD_")!=-1)
	{
		doc = sID.substring(4);
		sID = "ADD";		
	}
	switch(sID)
	{
		case "ADD":
		case "COPY":
		case "EDIT":	   
		case "VIEW":			
			var nop = Number(tbl.getValue("FNOP"));
			var id = Number(tbl.getValue("FWID"));
			if(!doc)
				doc = "com.debet.dogovor";
			if(!nop)
				nop = 1;
			var par = new Object();
			par.org = list.oOrg.getCod();
			var oDoc = new DpDoc(doc, nop);
			var bRet = oDoc.edit(sID, id, par);
			if(bRet)
			{
				tbl.requery();
				oGrid.refresh();
			}
			break;
			
		case "FINDDOC":			
			var tbl = oGrid.getTable();
			var par = new Object();
			par.FORG = list.oOrg.getCod();
			par.org = list.oOrg.getCod();
			par.doc = tbl.getValue("FDOC");
			par.nop = tbl.getValue("FNOP");
			par.fid_doc = tbl.getValue("FWID");
			showWindow("l_docekz.xml", SW_NOMODAL, par);
			break;
			
		case "FIND":
			oGrid.runSelection(8);
			break;
	
		case "SELECT":
			oGrid.runSelection(2);	
			break;
	}
	return true;
}

function listDel()
{
	var tbl = list.tbl;
	var doc = tbl.getValue("FDOC");
	var nop = Number(tbl.getValue("FNOP"));
	var id = Number(tbl.getValue("FWID"));
	var oDoc = new DpDoc(doc, nop);
	oDoc.del(id);
}

function listInitEditParam(par)
{
	par.org = list.oOrg.getCod();	
}



function loadDocs()
{
	var dat1 = BDAT_DOCS.value;
	var dat2 = EDAT_DOCS.value;
	var doc = String(DOC.value).trim();
	var nop = Number(NOP.value);
				
	var sWhere = " 1=1 ";
	if(doc)
		sWhere += " and UPPER(HDOC)="+ sqlTo(doc.toUpperCase());
	if(nop)
		sWhere += " and HNOP="+ nop;
	if(differ(dat1, d00)<0)
		sWhere += " and HDAT >= "+ sqlTo(dat1);
	if(differ(dat2, d00)<0)
		sWhere += " and HDAT <= "+ sqlTo(dat2);	
	if (list.oOrg)
		sWhere += " and HORG = " + list.oOrg.getCod();
	if(extPar && extPar.dog!=null)
		sWhere += " and HDOG = " + extPar.dog;
	var sOrder = getGridOrder(grid_DOCS);
	if(!sOrder)
		sOrder = " HDAT desc, HDOC, HNOP";	
	var tbl = OpenTable("select * from ^LISTDOCCRM "
						+" where "+ sWhere 
						+" order by "+ sOrder
						);
	var sTxt = UR(TAB.getItem(3).getText());
	if(sTxt.indexOf("(")!=-1)
		sTxt = sTxt.substring(0, sTxt.indexOf("("));
	sTxt += "("+ tbl.recordCount +") ";
	TAB.getItem(3).setText(sTxt);
	grid_DOCS.setTable(tbl);
	grid_DOCS.refresh();
}

function loadGridDocs()
{
	with(grid_DOCS)
	{
		FieldEx("HDAT", "Дата документу|Дата документа", 12);
		FieldEx("HNOM", "Номер документу|Номер документа", 12);		
		FieldEx("HDOC", "Клас документу|Класс документа", 10);		
		FieldEx("HNOP", "Операція|Операция", 8);
		FieldEx("FDOC_TXT", "Назва документу|Название документа", 10);
		FieldEx("HSUM", "Сума документу|Сумма документа", 10);
		FieldEx("FSUM_VYK", "Сума виконана|Сумма выполнена", 10);
		FieldEx("FSUM_OPL", "Сума оплачена|Сумма оплачена", 10);
		FieldEx("FML", "Маркетинговий список|Маркетинговый список", 17);	
		FieldEx("HID_DOC", "ІД документу|ИД документа", 10);	
		FieldEx("HUSER", "Користувач|Пользователь", 10);
		FieldEx("HREM", "Примітка|Примечание", 12);				
	}
	grid_DOCS.build();
	
	this.docsMenuInit = docsMenuInit;
	this.docsMenuRun = docsMenuRun;
	
	grid_DOCS.loadMenuHandler(this, "docsMenuInit");
	grid_DOCS.selectMenuHandler(this, "docsMenuRun");	
	grid_DOCS.setHeaderMenuLoader(this, "gridHeaderMenuInit");
	grid_DOCS.setHeaderMenuSelector(this, "gridHeaderMenuRun");
	
	fillDocsArr();
}

function fillDocsArr()
{
	arrSF = new Array();
	arrPV = new Array();
	var tblDoc = OpenTable("select FDOC,FNOP,FTXT from ^CL_LNK where UPPER(FDOC)='SF' or UPPER(FDOC)='PV'");
	for(; !tblDoc.isEOF(); tblDoc.MoveNext())
	{
		var doc = String(tblDoc.getValue("FDOC")).trim().toUpperCase();
		var nop = tblDoc.getValue("FNOP");
		var txt = UR(tblDoc.getValue("FTXT"));
		if(doc=="SF" && Number(nop))
			arrSF[nop] = nop +": "+ txt;
		else if(doc=="PV" && Number(nop))
			arrPV[nop] = nop +": "+ txt;
	}
	tblDoc.close();
}

function docsMenuInit(oGrid)
{
	var tbl = oGrid.getTable();
	var doc = tbl.getValue("HDOC");
	if(doc)
	{
		if(IsDblClick(oGrid))
		{		
			docsMenuRun("EDIT", oGrid);
			return true;
		}
		oGrid.AddMenuItem("FINDDOC", "Знайти документ|Найти документ");
		oGrid.AddMenuItem("", "");
	}
	
	if(doc || arrSF || arrPV)
	{
		oGrid.AddMenuItem("+++", "Додати документ|Добавить документ");
		if(doc)
		{
			var nop = Number(tbl.getValue("HNOP"));
			var txt = UR(tbl.getValue("FDOC_TXT")) +" ("+ doc +")";
			oGrid.AddMenuItem("ADD_"+ doc +"_"+ nop, txt);
		}
		if(arrSF)
		{
			oGrid.AddMenuItem("+++", "Рахунок (SF)|Счет (SF)");
			for(nop in arrSF)
				oGrid.AddMenuItem("ADD_SF_"+ nop, arrSF[nop]);
			oGrid.AddMenuItem("---", "Рахунок (SF)|Счет (SF)");
		}
		if(arrPV)
		{
			oGrid.AddMenuItem("+++", "Оплату (PV)|Оплату (PV)");
			for(nop in arrPV)
				oGrid.AddMenuItem("ADD_PV_"+ nop, arrPV[nop]);
			oGrid.AddMenuItem("---", "Оплату (PV)|Оплату (PV)");									
		}
		oGrid.AddMenuItem("", "");
		oGrid.AddMenuItem("ADD_DOC", "Інший|Другой");
		oGrid.AddMenuItem("---", "Додати документ|Добавить документ");
	}
	else
	{
		oGrid.AddMenuItem("ADD_DOC", "Додати документ|Добавить документ");
	}
	
	var sDoc = String(DOC.value).trim().toUpperCase();
	if(sDoc!="" && Number(NOP.value))
		oGrid.AddMenuItem("ADD", "Додати |Добавить "+ sDoc +"-"+ NOP.value);
	
	if(doc)
	{	
		oGrid.AddMenuItem("COPY", "Скопіювати|Копировать");
		oGrid.AddMenuItem("EDIT", "Редагувати|Редактировать");
		oGrid.AddMenuItem("VIEW", "Перегляд|Просмотр", 1002);
	}
}

function docsMenuRun(sID, oGrid)
{	
	var doc = String(DOC.value).trim();
	var nop = Number(NOP.value);
	if(sID.indexOf("ADD_")!=-1)
	{
		var sDoc = sID.substring(4);
		if(sDoc.indexOf("_")!=-1)
		{
			sID = "ADD";
			doc = sDoc.substring(0, sDoc.indexOf("_"));
			nop = Number(sDoc.substring(sDoc.indexOf("_")+1));
		}
		else
		{
			doc = "";
			nop = 0;
		}
	}
	
	switch(sID)
	{
		case "FINDDOC":			
			var tbl = oGrid.getTable();
			var par = new Object();
			par.FORG = list.oOrg.getCod();
			par.doc = tbl.getValue("HDOC");
			par.nop = tbl.getValue("HNOP");
			par.fid_doc = tbl.getValue("HID_DOC");
			showWindow("l_docekz.xml", SW_NOMODAL, par);
			break;
		
		case "ADD":
		case "ADD_DOC":			
			if(!doc || !nop)
			{
				var par = new Object();
				par.ret = new Object();
				par.zaval = true;
				showWindow("docfdr.xml", SW_MODAL, par);
				if(par.escape)
					break;
				doc = par.ret.doc;
				nop = par.ret.nop;
			}
			var oDoc = new DpDoc(doc, nop);
			var par = new Object();
			par.org = par.nOrg = list.oOrg.getCod();
			par.FORG = list.oOrg.getCod();
			bRet = oDoc.edit("ADD", 0, par);
			if(bRet)
			{
				oGrid.getTable().requery();
				oGrid.refresh();
			}
			break;
			
		case "COPY":
		case "EDIT":	   
		case "VIEW":			
			var tbl = oGrid.getTable();
			var doc = tbl.getValue("HDOC");
			var nop = Number(tbl.getValue("HNOP"));
			var id = Number(tbl.getValue("HID_DOC"));
			if(!doc)
				return true;
			var oDoc = new DpDoc(doc, nop);
			var bRet = oDoc.edit(sID, id);
			if(bRet)
			{
				tbl.requery();
				oGrid.refresh();
			}
			break;
		
		case "FIND":
			oGrid.runSelection(8);
			break;
	
		case "SELECT":
			oGrid.runSelection(2);	
			break;					
	}
	return true;
}



function loadAct()
{	
	var dat1 = BDAT_ACT.value;
	var dat2 = EDAT_ACT.value;
	
	if(grid_ACT.getTable())
		grid_ACT.getTable().close();
	
	ExecuteSQL("drop table TMP_ACTCMP", false);
	var sSql = "create table TMP_ACTCMP (HORG "+ sqlType("LONG")
				+", FTT "+ sqlType("SHORT")
				+", HDOG "+ sqlType("LONG")
				+", HDOC "+ sqlType("TEXT")
				+", HGROUP "+ sqlType("TEXT")
				+", HNOP "+ sqlType("INT")  
				+", HDAT "+ sqlType("DATE")				
				+", FWID "+ sqlType("LONG") 
				+")";
	if(!ExecuteSQL(sSql, false))
		ExecuteSQL("delete from TMP_ACTCMP ", false);	
				
	var sWhere = "1=1";	
	if(differ(dat1, d00)<0)
		sWhere = " HDAT >= "+ sqlTo(dat1);
	if(differ(dat2, d00)<0)
		sWhere += " and HDAT <= "+ sqlTo(dat2);	
	if (list.oOrg)
		sWhere += " and HORG = " + list.oOrg.getCod();
	if(extPar && extPar.dog!=null)
		sWhere += " and HDOG = " + extPar.dog;
	var sOrder = getGridOrder(grid_ACT);
	if(!sOrder)
		sOrder = "HORG, " + IIF("FTT = 2", 0 , 1) + ",HGROUP," + IIF("FTT = 1", 0 , 1) +", HDAT, HDOC, HNOP";
	var tbl = OpenTable("select * from TMP_ACTCMP "
						+" where "+ sWhere 
						+" order by "+ sOrder);
	grid_ACT.setTable(tbl);
	grid_ACT.refresh();
}

function loadJournals()
{
	include("objects/DpJRegistrator.js");	
	var oReg = new DpJRegistrator(null, null, "S");
	var listJornals = oReg.listJournals();
	JOURNAL_ACT.clear();
	JOURNAL_ACT.addItem("CRM", "CRM");
	JOURNAL_ACT.addItem("OPLVYK", UR("Взаєморозрахунки|Взаиморасчеты"));
	for (var jID in listJornals)
	{
		var oJournal = oReg.listJournals()[jID];
		if(!oJournal)
			continue;
		JOURNAL_ACT.addItem(jID +"_"+ oJournal.getType(), jID +" - "+ oJournal.getName());
	}
	JOURNAL_ACT.setSelectedIndex(0);
}


function getDogSaldo(org, dog, dat, tbl_j)
{
	var ret = new Object();
	ret.sumtobi = 0;
	ret.sumdobi = 0;
	
	var sqlOst = "select hdat, hid_doc from  " + tbl_j 
		+" where horg=" + sqlTo(org) + " and fdog = " + dog + " AND FISOST =  " + sqlTrue + " AND hdat<" + sqlTo(dat)
		+ " order by hdat desc";
	
	var ostDate = null;	
	
	var tblOst = OpenTable(sqlOst);
	if (!tblOst.isEmpty())
	{
		ostDate = tblOst.getValue("HDAT");  
	}
	tblOst.close();
	
	var strSQL = "select SUM(fsum_vyk) as fsumtobi, SUM(fsum_opl) as fsumdobi from " + tbl_j 
		+" where horg=" + sqlTo(org) + " and fdog = " + dog + " AND hdat<" + sqlTo(dat);
	
	if (ostDate)
		strSQL += " AND HDAT >= " + sqlTo(ostDate);
	
	var oSnap = getSnap(strSQL)	
	if (oSnap && oSnap[0])
	{
		ret.sumtobi = oSnap[0];		
	}
	
	if (oSnap && oSnap[1])
	{
		ret.sumdobi = oSnap[1];
	}
	
	return ret;
}

function act_recalc(tblOut)
{
	WAIT(UR("Розрахунок акту звірення...|Расчет акта сверки..."));
	
	if(grid_ACT.getTable())
		grid_ACT.getTable().close();
	
	actIsCalc = true;
	var tblOut = "TMP_ACTCMP";
	
	var dat1 = BDAT_ACT.value;
	var dat2 = EDAT_ACT.value;
	var org = list.oOrg.getCod();
	
	if(differ(dat1, d00)>=0)
		dat1 = new Date(1900, 0, 1);
			
	var sumdob="0"
		, sumtob="0"
		, sumdoo="0"
		, sumtoo="0"
		, sumtoe="0"
		, sumdoe="0"
		
	var sReg = String(JOURNAL_ACT.value).trim();
	if (sReg == "CRM" || sReg == "OPLVYK")
	{
		ExecuteSQL("drop table "+ tblOut, false);
		var m = new Object();
		m.FWID = "counter";
		m.HDOC = "text(25)";
		m.HNOP = "int";
		m.HDAT = "date";
		m.HNOM = "text(25)";
		m.HGROUP = "text(50)";
		m.FTT = "short";
		m.HID_DOC = "int";
		m.SUMTOO = m.SUMDOO = m.SUMTOB = m.SUMDOB = m.SUMTOBI = m.SUMDOBI= "money";
		m.HDOG = "int";
		m.horg = "int";
		m.fisost = "bit";
		CreateTable(tblOut, m);
		var tbl_j = sReg == "CRM"?"^UJ_CRM":"^UJ_OPLVYK";
		BeginTransaction(4);
		strSQL = "INSERT INTO "+tblOut + " (ftt, Hdoc, Hdat,Hnop, HNOM, hid_doc, sumtoo, sumdoo,hdog, horg, sumtob, sumdob, fisost, HGROUP )" 
				+ " SELECT 0 as ftt, a.hdoc, a.hdat, a.hnop, a.HNOM, a.hid_doc , a.fsum_vyk as sumtoo, a.fsum_opl as sumdoo, a.fdog, a.horg, " 
				+ " 0, 0, a.fisost, c.fdog_num "				
				+ " FROM " + tbl_j + " a left join ^contract c on a.fdog = c.fwid "
				+ " WHERE a.horg=" + sqlTo(org) + " AND a.hdat>=" + sqlTo(dat1) + " AND a.hdat<=" + sqlTo(dat2);
		ExecuteSQL(strSQL);
		
		ExecuteSQL("update " + tblOut + " set hdog = 0 where hdog is null");
		
		var tbl = OpenTable ("select * from " + tblOut + " order by hdog, hdat,hdoc, hnop");
		var curr_dog_id = -1;
		var nsumtoo = nsumdoo = 0;
		var dogItog = null;
		for (tbl.moveFirst(); !tbl.isEOF(); tbl.moveNext())
		{
			 var dog = Number(tbl.getValue("hdog"));
			 if (dog != curr_dog_id)
			 {
				 var m = new Object();
				 m.hdog = curr_dog_id = dog;
				 m.hgroup = tbl.getValue("hGROUP");
				 m.horg = org;
				 m.hdat = tbl.getValue("hdat");;
				 if (!m.hgroup)
					 m.hgroup = null;
				 
				 var nach_saldo = getDogSaldo(org, curr_dog_id, dat1, tbl_j);				 
				 m.sumtobi = nach_saldo.sumtobi;
				 m.sumdobi = nach_saldo.sumdobi;
				 
				 if (dogItog != null)
				 {
					 dogItog.ftt = 1;
					 dogItog.sumtoo = nsumtoo;
					 dogItog.sumdoo = nsumdoo;
					 updateTable(tblOut, dogItog, true);
				 }
				 nsumtoo = nsumdoo = 0;
				 dogItog = m;
			 }
			 var obj = new Object();
			 
			 if (toScrObj(tbl.getValue("fisost")))
			 {
				 nsumtoo = 0;
				 nsumdoo = 0;
				 
				 obj.sumtob = 0; 
				 obj.sumdob = 0;
				 obj.sumtobi = 0;
				 obj.sumdobi = 0;
				 
				 obj.sumtoo = tbl.getValue("sumtoo");
				 if (!obj.sumtoo)
					 obj.sumtoo = 0;
				 obj.sumdoo = tbl.getValue("sumdoo");
				 if (!obj.sumdoo)
					 obj.sumdoo = 0;
				 dogItog.sumtobi = 0;
				 dogItog.sumdobi = 0;
			 }
			 else
			 {
				 obj.sumtob = dogItog.sumtobi + nsumtoo; 
				 obj.sumdob = dogItog.sumdobi + nsumdoo;
				 obj.sumtobi = dogItog.sumtobi;
				 obj.sumdobi = dogItog.sumdobi;
				 
				 obj.sumtoo = tbl.getValue("sumtoo");
				 if (!obj.sumtoo)
					 obj.sumtoo = 0;
				 obj.sumdoo = tbl.getValue("sumdoo");
				 if (!obj.sumdoo)
					 obj.sumdoo = 0;
			 }
			 updateTable(tblOut, obj, false, "fwid = " + sqlTo(Number(tbl.getValue("FWID"))));
			 nsumtoo += Number(obj.sumtoo);
			 nsumdoo += Number(obj.sumdoo);
			 
		}
		tbl.close();
		
		if (dogItog != null)
		 {
			 dogItog.ftt = 1;
			 dogItog.sumtoo = nsumtoo;
			 dogItog.sumdoo = nsumdoo;
			 updateTable(tblOut, dogItog, true);
		 }
		
		strSQL = "INSERT INTO " + tblOut + "(ftt, sumtoo, sumdoo,sumtobi, sumdobi, horg, hdat, hgroup)"
		+ " SELECT 2 as ftt, SUM(sumtoo) as sumtoo, "
		+ "SUM(sumdoo) as sumdoo, SUM(sumtobi) as sumtobi, SUM(sumdobi) as sumdobi, max(horg), min(hdat), "
		 + sqlTo(UR('Загалом|Всего'))
		+ " FROM " + tblOut
		+ " WHERE ftt = 1";

		ExecuteSQL(strSQL);
		CommitTrans();	
		
		
	}
	else if (sReg == "CRM")
	{
		ExecuteSQL("drop table "+ tblOut, false);
		var m = new Object();
		m.FWID = "counter";
		m.HDOC = "text(25)";
		m.HNOP = "int";
		m.HDAT = "date";
		m.HNOM = "text(25)";
		m.HGROUP = "text(50)";
		m.FTT = "short";
		m.HID_DOC = "int";
		m.SUMTOO = m.SUMDOO = m.SUMTOB = m.SUMDOB = m.SUMTOBI = m.SUMDOBI= "money";
		m.HDOG = "int";
		m.horg = "int";
		CreateTable(tblOut, m);
		var tbl_j = "^UJ_CRM";
		var sWhere = sqlCmpVectors("<"
				, "b.hdat", "a.hdat"
				, "b.hnom", "a.hnom"
				, "b.hid_doc", "a.hid_doc"
				)
		
		strSQL = "INSERT INTO "+tblOut + " (ftt, Hdoc, Hdat,Hnop, HNOM, hid_doc, sumtoo, sumdoo,hdog, horg, sumtob, sumdob )" 
				+ " SELECT 0 as ftt, a.hdoc, a.hdat, a.hnop, a.HNOM, a.hid_doc , a.fsum_vyk as sumtoo, a.fsum_opl as sumdoo, a.fdog, a.horg, " 
				+ "(select SUM(b.fsum_vyk) from " + tbl_j + " as b" 
						+" where b.horg=" + sqlTo(org) + " and b.fdog = a.fdog AND (" + sWhere + ")) as sumtob,"
				+ "(select SUM(b.fsum_opl) from " + tbl_j + " as b" 
						+" where b.horg=" + sqlTo(org) + " and b.fdog = a.fdog AND (" + sWhere + ")) as sumtob"
				+ " FROM " + tbl_j + " a "
				+ " WHERE horg=" + sqlTo(org) + " AND hdat>=" + sqlTo(dat1) + " AND hdat<=" + sqlTo(dat2);
		ExecuteSQL(strSQL);
		
		
		strSQL = "UPDATE " + tblOut
				+ " set SUMTOBI =(select SUM(b.fsum_vyk) from " + tbl_j + " as b" 
				+" where b.horg=" + sqlTo(org) + " and b.fdog = hdog AND b.hdat<" + sqlTo(dat1) +")"
				
		 
		ExecuteSQL(strSQL);
		
		strSQL = "UPDATE " + tblOut
				+ " set SUMDOBI=(select SUM(b.fsum_opl) from " + tbl_j + " as b" 
				+" where b.horg=" + sqlTo(org) + " and b.fdog = hdog AND b.hdat<" + sqlTo(dat1) +")";
		
		ExecuteSQL(strSQL);
		
		
		strSQL = "INSERT INTO " + tblOut + "(ftt, sumtoo, sumdoo,sumtobi, sumdobi, hdog, horg, hdat)"
				+ " SELECT 1 as ftt, SUM(sumtoo) as sumtoo, "
				+ "SUM(sumdoo) as sumdoo, 0 as sumtobi, 0 as sumdobi, hdog, max(horg), min(hdat) "
				+ " FROM " + tblOut
				+ " GROUP BY HDOG";
		
		ExecuteSQL(strSQL);
		
		
		strSQL = "UPDATE " + tblOut
				+ " set SUMTOBI =(select SUM(b.fsum_vyk) from " + tbl_j + " as b" 
				+" where b.horg=" + sqlTo(org) + " and b.fdog = hdog AND b.hdat<" + sqlTo(dat1) +")"
				" where ftt = 1";
		 
				
		
		ExecuteSQL(strSQL);
		
		strSQL = "UPDATE " + tblOut
				+ " set SUMDOBI=(select SUM(b.fsum_opl) from " + tbl_j + " as b" 
				+" where b.horg=" + sqlTo(org) + " and b.fdog = hdog AND b.hdat<" + sqlTo(dat1) +")";
				" where ftt = 1";
		ExecuteSQL(strSQL);
		
		
		strSQL = "INSERT INTO " + tblOut + "(ftt, sumtoo, sumdoo,sumtobi, sumdobi, horg, hdat, hgroup)"
				+ " SELECT 2 as ftt, SUM(sumtoo) as sumtoo, "
				+ "SUM(sumdoo) as sumdoo, SUM(sumtobi) as sumtobi, SUM(sumdobi) as sumdobi, max(horg), min(hdat), "
				 + sqlTo(UR('Загалом|Всего'))
				+ " FROM " + tblOut
				+ " WHERE ftt = 1";
		
		ExecuteSQL(strSQL);
		
		
		
		
		strSQL = "UPDATE " + tblOut
			+ " set HGROUP =(select MAX(FDOG_NUM) from ^contract as dog where dog.fwid = hdog)"
			+ " where hdog != 0 and hdog is not null";
		ExecuteSQL(strSQL);
	}
	else
	{
		var sType = sReg.substring(sReg.length-1);
		sReg = sReg.substring(0, sReg.lastIndexOf("_"));
		
		var sDocregTbl = getPath("ALL_MDB") + "." + (SUBD==MSSQL?".":"") + sType +"DOCREG";
		var sVid = "+";
		if(sType=="M")
			sVid = "-";
		
		var objRegJr = new regJr(sVid);
		
		for( var i in objRegJr.arVar )
		{
		  	sign = ""
		  	switch(i.charAt(2))
		  	{
		  	 case "P":
		  	       sign = "+"
		  	       break;  
		  	 case "V":
		  	       sign = "-"
		  	       break;  
		  	}
	
		  	if(sign != "")
		  	{
		  		var sDT = i.charAt(1).toLowerCase();
		  		var sUO = (i.charAt(3).toLowerCase()=="u"? "u": "o");
		  		
		  		if (inList(sDT, "d", "t") && inList(sUO, "u", "o"))
		  		{
			  		eval("sum"+ sDT+sUO+"o+='"+sign+"abs("+objRegJr.arVar[i]+")'");
			  	}
		  	} 
	    }
	    
	    ExecuteSQL("drop table "+ tblOut, false);
	    
	    // Для всех документов за период посчитаем обороты на начало
	    ExecuteSQL(
	    	"SELECT HDOC, HDAT,HNOM,HID_DOC,HIDDEAL,HNOP,HOPFORM,HNKDAT,HNKNOM"
	    		+ ",HORG,HPRCOND,HREG,HGROUP,HZONE"
		    	+ "," + sumtoo + " AS sumtoo"
		    	+ "," + sumdoo + " AS sumdoo"
		    	+ "," + sumtoo + " AS sumtoei"
		    	+ "," + sumdoo + " AS sumdoei"
		    	+ ", (SELECT SUM(" + sumtoo + ")"
		    		+ " FROM ^" + sDocregTbl + " b"
		    		+ " WHERE a.horg=b.horg"
						+ " AND b.hreg=" + sqlTo(sReg)
		    			+ " AND (" + sqlCmpVectors("<"
		    				, "b.hdat", "a.hdat"
		    				, "b.hnom", "a.hnom"
		    				, "b.hid_doc", "a.hid_doc"
		    				) + ")"
		    		+ ") AS sumtob"
		    	+ ", (SELECT SUM(" + sumdoo + ")"
		    		+ " FROM ^" + sDocregTbl + " b"
		    		+ " WHERE a.horg=b.horg"
						+ " AND b.hreg=" + sqlTo(sReg)
		    			+ " AND (" + sqlCmpVectors("<"
		    				, "b.hdat", "a.hdat"
		    				, "b.hnom", "a.hnom"
		    				, "b.hid_doc", "a.hid_doc"
		    				) + ")"
		    		+ ") AS sumdob"
		    	+ ", " + Convert("0", "MONEY") + " AS sumtobi"
		    	+ ", " + Convert("0", "MONEY") + " AS sumdobi"
		    	+ ", " + sumtoo	+ " + (SELECT SUM(" + sumtoo + ")"
		    		+ " FROM ^" + sDocregTbl + " b"
		    		+ " WHERE a.horg=b.horg"
						+ " AND b.hreg=" + sqlTo(sReg)
		    			+ " AND (" + sqlCmpVectors("<"
		    				, "b.hdat", "a.hdat"
		    				, "b.hnom", "a.hnom"
		    				, "b.hid_doc", "a.hid_doc"
		    				) + ")"
		    		+ ") AS sumtoe"
		    	+ ", " + sumdoo + " + (SELECT SUM(" + sumdoo + ")"
		    		+ " FROM ^" + sDocregTbl + " b"
		    		+ " WHERE a.horg=b.horg"
						+ " AND b.hreg=" + sqlTo(sReg)
		    			+ " AND (" + sqlCmpVectors("<"
		    				, "b.hdat", "a.hdat"
		    				, "b.hnom", "a.hnom"
		    				, "b.hid_doc", "a.hid_doc"
		    				) + ")"
		    		+ ") AS sumdoe, 0 as ftt"	    	
	   		+ " INTO " + tblOut
		    + " FROM ^" + sDocregTbl + " a" 
			+ " WHERE (hdat BETWEEN " + sqlTo(dat1) 
					+ " AND " + sqlTo(dat2) 
					+ ")"
				+ (org? " AND HORG="+sqlTo(org): "")
				+ " AND HREG=" + sqlTo(sReg)
		  	);
	
		ExecuteSQL("ALTER TABLE " + tblOut +" ADD FWID "+ SqlType("COUNTER"));
	
		// Все документы до начала периода - для оборотов 
	    ExecuteSQL(
	    	"INSERT INTO " + tblOut
	    		+" (HDOC, HDAT,HNOM,HID_DOC,HIDDEAL,HNOP,HOPFORM "
	    		+",HNKDAT,HNKNOM,HORG,HPRCOND,HREG,HGROUP,HZONE"
	    		+",sumtoo,sumdoo,sumtoe,sumdoe"
	    		+",sumtobi,sumdobi,sumtoei,sumdoei)"
	    	+ " SELECT HDOC, HDAT,HNOM,HID_DOC,HIDDEAL,HNOP,HOPFORM"
	    		+",HNKDAT,HNKNOM,HORG,HPRCOND,HREG,HGROUP,HZONE"
		    	+ ", 0 AS sumtoo"
		    	+ ", 0 AS sumdoo"	    	
		    	+ ", 0 AS sumtoe"
		    	+ ", 0 AS sumdoe"
		    	+ "," + sumtoo + " AS sumtobi"
		    	+ "," + sumdoo + " AS sumdobi"
		    	+ "," + sumtoo + " AS sumtoei"
		    	+ "," + sumdoo + " AS sumdoei"
		  	+ " FROM ^" + sDocregTbl + " a" 
			+ " WHERE (HDAT < " + sqlTo(dat1) + ")"
				+ (org? " AND HORG="+sqlTo(org): "")
				+ " AND HREG=" + sqlTo(sReg)
		  	);
		 
	}
	grid_ACT.getTable().setScriptEngine(Task.getScriptEngine());
	grid_ACT.getTable().requery();
	grid_ACT.refresh();
	
	CLEARWAIT();
}

function loadGridAct()
{
	with(grid_ACT)
	{
		setColorField("FTT");
		FieldEx("HGROUP", "Угода|Договор", 12);
		var gr = grid_ACT.addGroup("Документ");
		with(gr)
		{
			fld = FieldEx("=tflnk('FTXT', ^HDOC, ^HNOP)", "Вид", 8);
			addField(fld);
			fld = FieldEx("HDAT", "Дата|Дата", 8);
			addField(fld);
			fld = FieldEx("HNOM", "Номер|Номер", 10);
			addField(fld);
		
		}
		//FieldEx("FDOC_TXT", "Назва документу|Название документа", 10);
		//FieldEx("HSUM", "Сума|Сумма", 10);
		var gr = grid_ACT.addGroup("На початок|На начало");
		with(gr)
		{
			fld = FieldEx("=(^ftt && String(^ftt).trim()!='')"
				+ "? (^sumtobi>^sumdobi? ^sumtobi-^sumdobi: 0)"
				+ ": (^sumtob>^sumdob? ^sumtob-^sumdob: 0)"
				,"Вiдвантажено|Отгружено",GRID_SUM_WDT,"z",DP_FORMAT_SUM);
			addField(fld);
			fld = FieldEx("=(^ftt && String(^ftt).trim()!='')"
				+ "? (^sumdobi>^sumtobi? ^sumdobi-^sumtobi: 0)"
				+ ": (^sumdob>^sumtob? ^sumdob-^sumtob: 0)"
				,"Сплачено|Оплачено",GRID_SUM_WDT,"z",DP_FORMAT_SUM);
			addField(fld);
		}
		
		gr = grid_ACT.addGroup("Обiги|Обороты");
		with(gr)
		{
			fld = FieldEx("sumtoo", "Вiдвантажено|Отгружено",GRID_SUM_WDT,"z",DP_FORMAT_SUM);
			addField(fld);
			fld = FieldEx("sumdoo", "Сплачено|Оплачено",GRID_SUM_WDT,"z",DP_FORMAT_SUM);
			addField(fld);
		}
		
		gr = grid_ACT.addGroup("На кiнець|На конец");
		with(gr)
		{
			fld = FieldEx("=(^ftt && String(^ftt).trim()!='')"
				+ "? (^sumtobi + ^sumtoo>^sumdobi + ^sumdoo? (^sumtobi + ^sumtoo)-(^sumdobi + ^sumdoo): 0)"
				+ ": (^sumtob + ^sumtoo>^sumdob + ^sumdoo? (^sumtob + ^sumtoo)-(^sumdob + ^sumdoo): 0)"
				,"Вiдвантажено|Отгружено",GRID_SUM_WDT,"z",DP_FORMAT_SUM);
			addField(fld);
			fld = FieldEx("=(^ftt && String(^ftt).trim()!='')"
				+ "? (^sumdobi + ^sumdoo>^sumtobi + ^sumtoo? (^sumdobi + ^sumdoo)-(^sumtobi + ^sumtoo): 0)"
				+ ": (^sumdob + ^sumdoo>^sumtob + ^sumtoo? (^sumdob + ^sumdoo)-(^sumtob + ^sumtoo): 0)"
				,"Сплачено|Оплачено",GRID_SUM_WDT,"z",DP_FORMAT_SUM);
			addField(fld);
		}
		FieldEx("HDOC", "Клас документу|Класс документа", 10);		
		FieldEx("HNOP", "Операція|Операция", 8);
	}
	
	grid_ACT.build();
	
	this.actMenuInit = actMenuInit;
	this.actMenuRun = actMenuRun;
	grid_ACT.loadMenuHandler(this, "actMenuInit");
	grid_ACT.selectMenuHandler(this, "actMenuRun");
	grid_ACT.setHeaderMenuLoader(this, "gridHeaderMenuInit");
	grid_ACT.setHeaderMenuSelector(this, "gridHeaderMenuRun");
}

function actMenuInit(oGrid)
{
	var tbl = oGrid.getTable();
	if(IsDblClick(oGrid))
	{
		if(tbl.getValue("HDOC"))
			actMenuRun("VIEW", oGrid);
		return true;
	}
	
	if(!tbl.isEmpty())
	{
		if(oGrid.getData("close")=="1")
			oGrid.AddMenuItem("OPEN", "Розгорнути|Развернуть");			
		else
			oGrid.AddMenuItem("CLOSE", "Згорнути|Свернуть");
	}
		
	if(tbl.getValue("HDOC"))
	{
		oGrid.AddMenuItem("FINDDOC", "Знайти документ|Найти документ");
		oGrid.AddMenuItem("", "");
		oGrid.AddMenuItem("VIEW", "Перегляд|Просмотр", 1002);
	}
}

function actMenuRun(sID, oGrid)
{	
	switch(sID)
	{
		case "CLOSE":
			var tbl = oGrid.getTable();			
			oGrid.setData("close", "1");
			oGrid.getTable().openSel("(FTT<>"+ sqlEmpStr +" and FTT is not null)");
			oGrid.refresh();
			break;
			
		case "OPEN":
			var tbl = oGrid.getTable();
			oGrid.setData("close", "0");
			tbl.requery(tbl.getQuery(0));
			oGrid.refresh();
			break;
		
		case "FINDDOC":			
			var tbl = oGrid.getTable();
			var par = new Object();
			par.FORG = list.oOrg.getCod();
			par.doc = tbl.getValue("HDOC");
			par.nop = tbl.getValue("HNOP");
			par.fid_doc = tbl.getValue("HID_DOC");
			showWindow("l_docekz.xml", SW_NOMODAL, par);
			break;
			
		case "COPY":
		case "EDIT":	   
		case "VIEW":			
			var tbl = oGrid.getTable();
			var doc = tbl.getValue("HDOC");
			var nop = Number(tbl.getValue("HNOP"));
			var id = Number(tbl.getValue("HID_DOC"));
			if(!doc)
				return true;
			var oDoc = new DpDoc(doc, nop);
			var bRet = oDoc.edit(sID, id);
			if(bRet)
			{
				tbl.requery();
				oGrid.refresh();
			}
			break;
			
		case "FIND":
			oGrid.runSelection(8);
			break;
	
		case "SELECT":
			oGrid.runSelection(2);	
			break;		
	}
}



function loadTasks()
{
	var dat1 = BDAT_TASK.value;
	var dat2 = EDAT_TASK.value;			
	var sWhere = "1=1";	
	if(differ(dat1, d00)<0)
		sWhere = " FDOC_DAT >= "+ sqlTo(dat1);
	if(differ(dat2, d00)<0)
		sWhere += " and FDOC_DAT <= "+ sqlTo(dat2);	
	if (list.oOrg)
		sWhere += " and FCUSTOMER = " + list.oOrg.getCod();	
	var sOrder = getGridOrder(grid_TASK);
	if(!sOrder)
		sOrder = " FDOC_DAT desc, FNOP";
	var tbl = OpenTable("select * from ^TASK "
						+" where "+ sWhere 
						+" order by "+ sOrder
						);
	var sTxt = UR(TAB.getItem(5).getText());
	if(sTxt.indexOf("(")!=-1)
		sTxt = sTxt.substring(0, sTxt.indexOf("("));
	sTxt += "("+ tbl.recordCount +") ";
	TAB.getItem(5).setText(sTxt);
	grid_TASK.setTable(tbl);
	grid_TASK.refresh();
}

function loadGridTasks()
{
	with(grid_TASK)
	{
		FieldEx("FDOC_NUM", "№|№", 10);
		FieldEx("FDOC_DAT", "Дата", 12);
		FieldEx("=docTxt(^FDOC, ^FNOP)", "Папка|Папка", 12);
		FieldEx("FCAPTION", "Назва|Название", 12);		
		//FieldEx("", "Статус|Статус", 10);
		//FieldEx("", "Виконавець|Исполнитель", 10);			
	}
	grid_TASK.build();
	
	this.taskMenuInit = taskMenuInit;
	this.taskMenuRun = taskMenuRun;
	grid_TASK.loadMenuHandler(this, "taskMenuInit");
	grid_TASK.selectMenuHandler(this, "taskMenuRun");	
	grid_TASK.setHeaderMenuLoader(this, "gridHeaderMenuInit");
	grid_TASK.setHeaderMenuSelector(this, "gridHeaderMenuRun");
}

function taskMenuInit(oGrid)
{	
	var tbl = oGrid.getTable();	
	if(tbl.getValue("FDOC"))
	{
		if(IsDblClick(oGrid))
		{
			taskMenuRun("EDIT", oGrid);
			return true;
		}
		
		oGrid.AddMenuItem("FINDDOC", "Знайти документ|Найти документ");
		oGrid.AddMenuItem("", "");
	}
	oGrid.AddMenuItem("ADD", "Додати|Добавить");	
	if(!oGrid.getTable().isEmpty())
	{
		oGrid.AddMenuItem("COPY", "Скопіювати|Копировать");
		oGrid.AddMenuItem("EDIT", "Редагувати|Редактировать");
		oGrid.AddMenuItem("VIEW", "Перегляд|Просмотр", 1002);
	}
}

function taskMenuRun(sID, oGrid)
{	
	switch(sID)
	{
		case "ADD":
		case "COPY":
		case "EDIT":	   
		case "VIEW":			
			var tbl = oGrid.getTable();
			var doc = tbl.getValue("FDOC");
			var nop = Number(tbl.getValue("FNOP"));
			var id = Number(tbl.getValue("FWID"));
			if(!doc)
				doc = "TASK";
			if(!nop)
				nop = 1;			
			var oDoc = new DpDoc(doc, nop);
			
			var par = new Object();
			par.org = list.oOrg.getCod();
			var bRet = oDoc.edit(sID, id, par);
			if(bRet)
			{
				tbl.requery();
				oGrid.refresh();
			}
			break;
			
		case "FINDDOC":			
			var tbl = oGrid.getTable();
			var par = new Object();
			par.FORG = list.oOrg.getCod();
			par.doc = tbl.getValue("FDOC");
			par.nop = tbl.getValue("FNOP");
			par.fid_doc = tbl.getValue("FWID");
			showWindow("l_docekz.xml", SW_NOMODAL, par);
			break;
		
		case "FIND":
			oGrid.runSelection(8);
			break;
	
		case "SELECT":
			oGrid.runSelection(2);	
			break;
	}
}



function loadPhone()
{
	var dat1 = BDAT_PHONE.value;
	var dat2 = EDAT_PHONE.value;			
	var sWhere = "1=1";	
	if(differ(dat1, d00)<0)
		sWhere = " FDOC_DAT >= "+ sqlTo(dat1);
	if(differ(dat2, d00)<0)
		sWhere += " and FDOC_DAT <= "+ sqlTo(dat2);	
	if (list.oOrg)
		sWhere += " and FORG = " + list.oOrg.getCod();	
	var sOrder = getGridOrder(grid_PHONE);
	if(!sOrder)
		sOrder = "FDOC_DAT desc, FNOP";
	var tbl = OpenTable("select * from ^CRM_TELRAZG "
						+" where "+ sWhere 
						+" order by "+ sOrder);
	var sTxt = UR(TAB.getItem(7).getText());
	if(sTxt.indexOf("(")!=-1)
		sTxt = sTxt.substring(0, sTxt.indexOf("("));
	sTxt += "("+ tbl.recordCount +") ";
	TAB.getItem(7).setText(sTxt);
	grid_PHONE.setTable(tbl);
	grid_PHONE.refresh();
}

function loadGridPhone()
{
	with(grid_PHONE)
	{
		FieldEx("FDOC_NUM", "№|№", 10);
		FieldEx("FDOC_DAT", "Дата", 12);		
		FieldEx("=docTxt(^FDOC, ^FNOP)", "Папка|Папка", 12);
		FieldEx("FPREDMET_RAZG", "Предмет розмови|Предмет разговора", 12);				
	}
	grid_PHONE.build();
	
	this.phoneMenuInit = phoneMenuInit;
	this.phoneMenuRun = phoneMenuRun;
	grid_PHONE.loadMenuHandler(this, "phoneMenuInit");
	grid_PHONE.selectMenuHandler(this, "phoneMenuRun");
	grid_PHONE.setHeaderMenuLoader(this, "gridHeaderMenuInit");
	grid_PHONE.setHeaderMenuSelector(this, "gridHeaderMenuRun");
}

function phoneMenuInit(oGrid)
{	
	var tbl = oGrid.getTable();	
	if(tbl.getValue("FDOC"))
	{
		if(IsDblClick(oGrid))
		{
			phoneMenuRun("EDIT", oGrid);
			return true;
		}
		
		oGrid.AddMenuItem("FINDDOC", "Знайти документ|Найти документ");
		oGrid.AddMenuItem("", "");
	}
	oGrid.AddMenuItem("ADD", "Додати|Добавить");	
	if(!oGrid.getTable().isEmpty())
	{
		oGrid.AddMenuItem("COPY", "Скопіювати|Копировать");
		oGrid.AddMenuItem("EDIT", "Редагувати|Редактировать");
		oGrid.AddMenuItem("VIEW", "Перегляд|Просмотр", 1002);
	}
}

function phoneMenuRun(sID, oGrid)
{	
	switch(sID)
	{
		case "ADD":
		case "COPY":
		case "EDIT":	   
		case "VIEW":			
			var tbl = oGrid.getTable();
			var doc = tbl.getValue("FDOC");
			var nop = Number(tbl.getValue("FNOP"));
			var id = Number(tbl.getValue("FWID"));
			if(!doc)
				doc = "CRM.TR";
			if(!nop)
				nop = 1;			
			var oDoc = new DpDoc(doc, nop);
			
			var par = new Object();
			par.nOrg = list.oOrg.getCod();
			var bRet = oDoc.edit(sID, id, par);
			if(bRet)
			{
				tbl.requery();
				oGrid.refresh();
			}
			break;
			
		case "FINDDOC":			
			var tbl = oGrid.getTable();
			var par = new Object();
			par.FORG = list.oOrg.getCod();
			par.doc = tbl.getValue("FDOC");
			par.nop = tbl.getValue("FNOP");
			par.fid_doc = tbl.getValue("FWID");
			showWindow("l_docekz.xml", SW_NOMODAL, par);
			break;
			
		case "FIND":
			oGrid.runSelection(8);
			break;
	
		case "SELECT":
			oGrid.runSelection(2);	
			break;
	}
}



function loadMail()
{
	var dat1 = BDAT_MAIL.value;
	var dat2 = EDAT_MAIL.value;			
	var sWhere = "1=1";	
	if(differ(dat1, d00)<0)
		sWhere = " FDOC_DAT >= "+ sqlTo(dat1);
	if(differ(dat2, d00)<0)
		sWhere += " and FDOC_DAT <= "+ sqlTo(dat2);	
	
	var orgID = 0;
	if (list.oOrg && list.oOrg.getFWID())
		orgID = list.oOrg.getFWID();		
	var sTblCnt = getPath("ALL_MDB")+".COM_MAIL_CNT";
	if(SUBD==MSSQL)
		sTblCnt = getPath("ALL_MDB")+"..COM_MAIL_CNT";
	var sTblCP = getPath("CL_MDB")+".COM_CL_ORGCP";
	if(SUBD==MSSQL)
		sTblCP = getPath("ALL_MDB")+"..COM_CL_ORGCP";	
	sWhere += " and FWID in (select cnt.FID_DOC "
				+" from "+ sTblCnt +" cnt "
				+" where cnt.FID_CP="+ sqlTo(orgID)
					+" or cnt.FID_CP in (select cp.FWID "
					+" from "+ sTblCP +" cp "
					+" where cp.FWID_CL="+ sqlTo(orgID) 
					+")"					
				+")";	
	var sOrder = getGridOrder(grid_MAIL);
	if(!sOrder)
		sOrder = " FDOC_DAT desc, FNOP";
	var tbl = OpenTable("select * from ^MAIL_MSG "
						+" where "+ sWhere 
						+" order by "+ sOrder);
	var sTxt = UR(TAB.getItem(8).getText());
	if(sTxt.indexOf("(")!=-1)
		sTxt = sTxt.substring(0, sTxt.indexOf("("));
	sTxt += "("+ tbl.recordCount +") ";
	TAB.getItem(8).setText(sTxt);
	grid_MAIL.setTable(tbl);
	grid_MAIL.refresh();
}

function loadGridMail()
{
	with(grid_MAIL)
	{
		FieldEx("FDOC_NUM", "№|№", 10);
		FieldEx("FDOC_DAT", "Дата", 12);
		FieldEx("=docTxt(^FDOC, ^FNOP)", "Папка|Папка", 12);		
		FieldEx("FNAME", "Тема|Тема", 12);				
	}
	grid_MAIL.build();
	
	this.mailMenuInit = mailMenuInit;
	this.mailMenuRun = mailMenuRun;
	grid_MAIL.loadMenuHandler(this, "mailMenuInit");
	grid_MAIL.selectMenuHandler(this, "mailMenuRun");
	grid_MAIL.setHeaderMenuLoader(this, "gridHeaderMenuInit");
	grid_MAIL.setHeaderMenuSelector(this, "gridHeaderMenuRun");
}

function loadGridEvent()
{
	grid_EVENT.build();
	
	this.eventMenuInit = eventMenuInit;
	this.eventMenuRun = eventMenuRun;
	grid_EVENT.loadMenuHandler(this, "eventMenuInit");
	grid_EVENT.selectMenuHandler(this, "eventMenuRun");
	grid_EVENT.setHeaderMenuLoader(this, "gridHeaderMenuInit");
	grid_EVENT.setHeaderMenuSelector(this, "gridHeaderMenuRun");
}

//события
function loadEvent()
{
	var org = 0;
	if (list.oOrg && list.oOrg.getCod())
		org = list.oOrg.getCod();
	var sWhere = " 1<>1 ";
	if(org)
		sWhere = " FORG="+ org;
	var dat1 = BDAT_EVENT.value;
	var dat2 = EDAT_EVENT.value;	
	if(differ(dat2, d00)<0)
		sWhere += " and FBDATE <= "+ sqlTo(dat2);
	if(differ(dat1, d00)<0)
		sWhere += " and FEDATE >= "+ sqlTo(dat1);		
	var sOrder = getGridOrder(grid_EVENT);
	if(!sOrder)
		sOrder = " FBDATE,FEDATE";
	var tbl = OpenTable("select * from ^LISTEVENT "
						+" where "+ sWhere
						+" order by "+ sOrder);
	var sTxt = UR(TAB.getItem(6).getText());
	if(sTxt.indexOf("(")!=-1)
		sTxt = sTxt.substring(0, sTxt.indexOf("("));
	sTxt += "("+ tbl.recordCount +") ";
	TAB.getItem(6).setText(sTxt);
	grid_EVENT.setTable(tbl);
	grid_EVENT.refresh();
}

function eventMenuInit(oGrid)
{	
	var tbl = oGrid.getTable();	
	if(tbl.getValue("FDOC"))
	{
		if(IsDblClick(oGrid))
		{
			mailMenuRun("EDIT", oGrid);
			return true;
		}
	}
	oGrid.AddMenuItem("ADD", "Додати|Добавить");	
	if(!oGrid.getTable().isEmpty())
	{
		oGrid.AddMenuItem("COPY", "Скопіювати|Копировать");
		oGrid.AddMenuItem("EDIT", "Редагувати|Редактировать");
		oGrid.AddMenuItem("VIEW", "Перегляд|Просмотр", 1002);
	}
}

function eventMenuRun(sID, oGrid)
{	
	switch(sID)
	{
		case "ADD":
		case "COPY":
		case "EDIT":	   
		case "VIEW":			
			var tbl = oGrid.getTable();
			var doc = tbl.getValue("FDOC");
			var nop = Number(tbl.getValue("FNOP"));
			var id = Number(tbl.getValue("FWID"));
			if(!doc)
				doc = "EVENT";
			if(!nop)
				nop = 1;
			var oDoc = new DpDoc(doc, nop);
			var par = new Object();
			par.org = list.oOrg.getCod();
			var bRet = oDoc.edit(sID, id, par);
			if(bRet)
			{
				tbl.requery();
				oGrid.refresh();
			}
			break;
			
		case "FINDDOC":			
			var tbl = oGrid.getTable();
			var par = new Object();			
			par.doc = tbl.getValue("FDOC");
			par.nop = tbl.getValue("FNOP");
			par.fid_doc = tbl.getValue("FWID");
			showWindow("l_docekz.xml", SW_NOMODAL, par);
			break;
			
		case "FIND":
			oGrid.runSelection(8);
			break;
	
		case "SELECT":
			oGrid.runSelection(2);	
			break;
	}
}

function docTxt(sDoc, nNop)
{
	if(!sDoc)
		return "";
	if(!nNop)
		nNop = 0;
	sDoc = String(sDoc).toUpperCase();
	nNop = Number(nNop);	
	var oSnap = getSnap("select FTXT from ^cl_lnk "
					+" where UPPER(FDOC)="+ sqlTo(sDoc)
							+" and FNOP="+ sqlTo(nNop)
					, false);
	if(oSnap)
		return UR(oSnap[0]);
	return "";
}

function mailMenuInit(oGrid)
{	
	var tbl = oGrid.getTable();	
	if(tbl.getValue("FDOC"))
	{
		if(IsDblClick(oGrid))
		{
			mailMenuRun("EDIT", oGrid);
			return true;
		}
		
		oGrid.AddMenuItem("FINDDOC", "Знайти документ|Найти документ");
		oGrid.AddMenuItem("", "");
	}
	oGrid.AddMenuItem("ADD", "Додати|Добавить");	
	if(!oGrid.getTable().isEmpty())
	{
		oGrid.AddMenuItem("COPY", "Скопіювати|Копировать");
		oGrid.AddMenuItem("EDIT", "Редагувати|Редактировать");
		oGrid.AddMenuItem("VIEW", "Перегляд|Просмотр", 1002);
	}
}

function mailMenuRun(sID, oGrid)
{	
	switch(sID)
	{
		case "ADD":
		case "COPY":
		case "EDIT":	   
		case "VIEW":			
			var tbl = oGrid.getTable();
			var doc = tbl.getValue("FDOC");
			var nop = Number(tbl.getValue("FNOP"));
			var id = Number(tbl.getValue("FWID"));
			if(!doc)
				doc = "MMSG";
			if(!nop)
				nop = getPar("SMTP_DOC");
			if(!nop)
				nop = 2;		
			var oDoc = new DpDoc(doc, nop);
			
			var par = new Object();
			par.org = list.oOrg.getCod();
			var bRet = oDoc.edit(sID, id, par);
			if(bRet)
			{
				tbl.requery();
				oGrid.refresh();
			}
			break;
			
		case "FINDDOC":			
			var tbl = oGrid.getTable();
			var par = new Object();			
			par.doc = tbl.getValue("FDOC");
			par.nop = tbl.getValue("FNOP");
			par.fid_doc = tbl.getValue("FWID");
			showWindow("l_docekz.xml", SW_NOMODAL, par);
			break;
			
		case "FIND":
			oGrid.runSelection(8);
			break;
	
		case "SELECT":
			oGrid.runSelection(2);	
			break;
	}
}

//отклики
function loadResponse()
{
	var org = 0;
	if (list.oOrg && list.oOrg.getCod())
		org = list.oOrg.getCod();		
	var sOrder = getGridOrder(grid_resp);
	if(!sOrder)
		sOrder = " FDOC_DAT desc, FNOP";
	var tbl = OpenTable("select * from ^RESPONSE "
						+" where FORG="+ org
						+" order by "+ sOrder);
	clTie(tbl, "pers", "=getPar('CODPERS'), FMANAGER");
	var sTxt = UR(TAB.getItem(9).getText());
	if(sTxt.indexOf("(")!=-1)
		sTxt = sTxt.substring(0, sTxt.indexOf("("));
	sTxt += "("+ tbl.recordCount +") ";
	TAB.getItem(9).setText(sTxt);
	grid_resp.setTable(tbl);
	grid_resp.refresh();
}

function loadGridResponse()
{
	grid_resp.build();
	
	this.respMenuInit = respMenuInit;
	this.respMenuRun = respMenuRun;
	grid_resp.loadMenuHandler(this, "respMenuInit");
	grid_resp.selectMenuHandler(this, "respMenuRun");
	grid_resp.setHeaderMenuLoader(this, "gridHeaderMenuInit");
	grid_resp.setHeaderMenuSelector(this, "gridHeaderMenuRun");
}

function respMenuInit(oGrid)
{	
	var tbl = oGrid.getTable();	
	if(tbl.getValue("FDOC"))
	{
		if(IsDblClick(oGrid))
		{
			mailMenuRun("EDIT", oGrid);
			return true;
		}
		
		oGrid.AddMenuItem("FINDDOC", "Знайти документ|Найти документ");
		oGrid.AddMenuItem("", "");
	}
	oGrid.AddMenuItem("ADD", "Додати|Добавить");	
	if(!oGrid.getTable().isEmpty())
	{
		oGrid.AddMenuItem("COPY", "Скопіювати|Копировать");
		oGrid.AddMenuItem("EDIT", "Редагувати|Редактировать");
		oGrid.AddMenuItem("VIEW", "Перегляд|Просмотр", 1002);
	}
}

function respMenuRun(sID, oGrid)
{	
	switch(sID)
	{
		case "ADD":
		case "COPY":
		case "EDIT":	   
		case "VIEW":			
			var tbl = oGrid.getTable();
			var doc = "RESPONSE";
			var nop = Number(tbl.getValue("FNOP"));
			var id = Number(tbl.getValue("FWID"));			
			if(!nop)
				nop = 1;
			var oDoc = new DpDoc(doc, nop);
			var par = new Object();
			par.org = list.oOrg.getCod();
			var bRet = oDoc.edit(sID, id, par);
			if(bRet)
			{
				tbl.requery();
				oGrid.refresh();
			}
			break;
			
		case "FINDDOC":			
			var tbl = oGrid.getTable();
			var par = new Object();			
			par.doc = tbl.getValue("FDOC");
			par.nop = tbl.getValue("FNOP");
			par.fid_doc = tbl.getValue("FWID");
			showWindow("l_docekz.xml", SW_NOMODAL, par);
			break;
			
		case "FIND":
			oGrid.runSelection(8);
			break;
	
		case "SELECT":
			oGrid.runSelection(2);	
			break;
	}
}



function gridHeaderMenuInit(oCol, oGrid)
{			
	var bCanSort = oCol && !oCol.getField().startsWith("=");
	if (bCanSort)
	{
		var nInd = String(oCol.getField().indexOf("."));
		if (nInd != -1)
		{
			var sAlias = oCol.getField().substring(0,nInd);
			bCanSort = bCanSort && oGrid.getTable().GetTie(sAlias) == null;
		}
	}
		
	if (bCanSort && !(this.subSortInit && this.subSortInit(oCol,oGrid)))
	{
		oGrid.addHeaderMenuItem("+++","Сортування |Сортировка ");
		oGrid.addHeaderMenuItem("SORT_UP","За збільшенням|По возрастанию");
		oGrid.addHeaderMenuItem("SORT_DOWN","За зменшенням|По убыванию");
		oGrid.addHeaderMenuItem("","");
		var parArr = oGrid.getStructHolder().listParams();
		var srtArr = new Array();
		for (var nPar = 0; nPar < parArr.length; nPar++)
		{
			if (String(parArr[nPar]).substr(0,5) == "SORT_")
				srtArr[srtArr.length] = String(parArr[nPar]).substr(5);
		}
		if (srtArr.length > 0)
		{
			oGrid.addHeaderMenuItem("+++","Вибрати...|Выбрать...");
			for (var nSrt = 0; nSrt < srtArr.length; nSrt++)
			{
				var srtTxt = srtArr[nSrt];
				if (String(srtTxt).length > 40)
					srtTxt = srtTxt.substr(0,40) + "...";
				oGrid.addHeaderMenuItem("SORT_" + srtArr[nSrt],srtTxt,(this.headerCurSort == "SORT_" + srtArr[nSrt]?ICON_RADIO:0));
			}
			oGrid.addHeaderMenuItem("","");
		}
		oGrid.addHeaderMenuItem("SORT_CUSTOM","Вибрати...|Выбрать...",(this.headerCurSort == "SORT_CUSTOM"?ICON_RADIO:0));
		if (srtArr.length > 0)
			oGrid.addHeaderMenuItem("---","");
		oGrid.addHeaderMenuItem("SORT_DEFAULT","Стандарт",(this.headerCurSort == "SORT_DEFAULT"?ICON_RADIO:0));
		oGrid.addHeaderMenuItem("---","");
	}
}

function gridHeaderMenuRun(sID, oColInfo, oGrid)
{	
	var oList = oList = oGrid.getData("list");
	if(!oList)
	{
		oList = new Object();
		oGrid.setData("list", oList);
	}
	oList.qryOrder = new Array();	
	if (sID.substr(0,4) == "SORT")
	{		
		if ("SORT_UP" == sID || "SORT_DOWN" == sID)
		{
			if (!oList.headerSortI)
				oList.headerSortI = oList.qryOrder.length;
			oList.qryOrderI = oList.headerSortI;
			oList.qryOrder[oList.headerSortI] = String(oColInfo.getField()) 
												+ ("SORT_DOWN" == sID?" DESC":"") ;
			gridTblInit(oGrid);
			if (oList.lastSortCol != null)
			{
				var nInd = oGrid.getColumns().indexOf(oList.lastSortCol);
				if (nInd != -1)
					oGrid.setColImage(nInd, null);
			}
			oList.lastSortCol = oColInfo;
			var nInd = oGrid.getColumns().indexOf(oColInfo);
			if (nInd != -1)
			{
				if (sID == "SORT_UP")
					oGrid.setColImage(nInd,rootDirectoryEx() + "/icons/arru.gif");
				else
					oGrid.setColImage(nInd,rootDirectoryEx() + "/icons/arrd.gif");
			}				
		}
		else if ("SORT_DEFAULT" == sID)
		{
			if (oList.headerSortI)
			{
				oList.qryOrder = oList.qryOrder.slice(0,oList.qryOrder.length - 1);
				oList.qryOrderI = 0;
			}
			gridTblInit(oGrid);
			var nInd = oGrid.getColumns().indexOf(oList.lastSortCol);
			if (nInd != -1)
				oGrid.setColImage(nInd,null);
			oList.lastSortCol = null;
		}
		else if ("SORT_CUSTOM" == sID)
		{
			var oPar = new Object();
			oPar.cols = oGrid.getColumnsArray();
			showWindow("dpGridSort.xml",SW_MODAL,oPar);
			if (oPar.escape)
			{
				sID = oList.headerCurSort;
			}
			else
			{
				var ord = "";
				var name = "";
				for (var i = 0; i < oPar.ret.cols.length; i++)
				{
					if (i != 0)
						ord = ord + ", ";
					ord = ord + oPar.ret.cols[i].getField();
					name = name + (name != ""?" + ":"") 
							+ String(oPar.ret.cols[i].getCaption()).replace("\n"," ");
				}
				
				if (oGrid.getStructHolder().getPar(name) == "")
				{
					oGrid.getStructHolder().setPar("SORT_" + name,ord);
				}
				
				if (!oList.headerSortI)
					oList.headerSortI = oList.qryOrder.length;
				oList.qryOrderI = oList.headerSortI;
				oList.qryOrder[oList.headerSortI] = ord
				gridTblInit(oGrid);
				sID = "SORT_" + name;
			}
		}
		else if (oGrid.getStructHolder().getPar(sID) != "")
		{
			if (!oList.headerSortI)
				oList.headerSortI = oList.qryOrder.length;
			oList.qryOrderI = oList.headerSortI;
			oList.qryOrder[oList.headerSortI] = oGrid.getStructHolder().getPar(sID);
			gridTblInit(oGrid);
		}
		oList.headerCurSort = sID;
	}
		
	if (sID == "DOUBLECLICK")
	{
		var bCanSort = oColInfo && !oColInfo.getField().startsWith("=");
		if (bCanSort)
		{
			var nInd = String(oColInfo.getField().indexOf("."));
			if (nInd != -1)
			{
				var sAlias = oColInfo.getField().substring(0,nInd);
				bCanSort = bCanSort && oGrid.getTable().GetTie(sAlias) == null;
			}
		}
		if (!bCanSort)
			return;
		if (oList.headerCurSort == "SORT_UP" && oList.lastSortCol == oColInfo)
			this.gridHeaderMenuRun("SORT_DOWN",oColInfo,oGrid);
		else if (oList.headerCurSort == "SORT_DOWN" && oList.lastSortCol == oColInfo)
			this.gridHeaderMenuRun("SORT_DEFAULT",oColInfo,oGrid);
		else 
			this.gridHeaderMenuRun("SORT_UP",oColInfo,oGrid);
		
	}
	
	//oGrid.setData("list", oList);
	//oGrid.refresh();
}

function gridTblInit(oGrid)
{
	//initGridVars(oGrid);
	if(oGrid.equals(grid))
		loadDogs();
	else if(oGrid.equals(grid_DOCS))
		loadDocs();
	else if(oGrid.equals(grid_ACT))
		loadAct();
	else if(oGrid.equals(grid_TASK))
		loadTasks();
	else if(oGrid.equals(grid_PHONE))
		loadPhone();	
	else if(oGrid.equals(grid_MAIL))
		loadMail();
}

function getGridOrder(oGrid)
{
	var sOrder = "";
	var oList = oGrid.getData("list");
	if(oList && oList.qryOrder)
	{
		oList.orderBy = oList.qryOrder[0];
		for(var i=1; i<oList.qryOrder.length; i++)
			oList.orderBy += ", "+ oList.qryOrder[i];
		if(oList.orderBy)
			sOrder = oList.orderBy;
	}
	return sOrder;
}

include("sys/DpBaseDlg.js");