include("doc/RegTime.js");
include("doc/DpDoc.js");

var tblName = "cl_reg";
var fromPatt = false;
var strSelectID = "";
var strParentID = null;


function listLoad()
{
	fromPatt=(extPar && typeof(extPar.submode)== "string" && extPar.submode == "FROMPATTERN");
	if(fromPatt)
		tblName = "U" + tblName;    
		
	with(this)
	{
		if(par.menuMode != "CHOICE")
			subAsk = askParam;
		
		editTask = "e_cl_reg";
		printLabel = "CLREG";
		xmlGridFile = "l_cl_reggrid.xml";
	}
	
	this.onTreeSelected = onTreeSelected;
	Tree.setTreeSelHandler(this, "onTreeSelected");	
	buildTree();
	Tree.setSelected(strSelectID);	
	Tree.selectMenuHandler(this, "mnuHandler");
	Tree.loadMenuHandler(this, "mnuInit");
}

function listTitle()
{
	var result = ru("Справочник схем регистрации", "Довідник схем реєстрацій");
	result += (fromPatt?ru(" (образцы)", " (зразки)"):"");
	return result;
}

function askParam()
{
	var gd = new DpGetDat("dD");
	return gd;
}

function buildTree()
{
	var strSQL = "SELECT Freg, Ftxt, Fwid"
				+ " FROM ^cl_reg"
				+ " WHERE Fnom=0 AND Fnop=0"
				+ " ORDER BY Freg";

	var tempTbl = OpenTable("s", strSQL);
	if (tempTbl.isEmpty())
	{
		tempTbl.Close();
		return;
	}

	tempTbl.MoveFirst();
	strSelectID = tempTbl.getValue("Fwid");
	while(!tempTbl.isEOF())
	{
		Tree.addItem("", tempTbl.getValue("Fwid"), tempTbl.getValue("Freg") + ". " + tempTbl.getValue("Ftxt"));
		buildNode(tempTbl.getValue("Freg"), tempTbl.getValue("Fwid"));
		tempTbl.MoveNext();
	}

	tempTbl.Close();
}

function buildNode(parentID, parentFwid)
{
	var strSQL = "SELECT Fdoc, max(Fwid) FROM ^cl_reg WHERE Fnom=0 AND Fnop<>0 AND Freg=" + sqlTo(parentID)
				+ " GROUP BY Fdoc ORDER BY Fdoc";
	var folderTbl = OpenTable("s", strSQL);
	if(folderTbl.isEmpty())
	{
		folderTbl.Close();
		return;
	}
	
	folderTbl.MoveFirst();
	while(!folderTbl.isEOF())
	{
		var folder = folderTbl.getValue("Fdoc");
		var folderFWID = folderTbl.getValue("Fwid");
		var doc = new DpDoc(folder, 0);
		if(doc.isAbstract())
		{
			folderTbl.MoveNext();
			continue;
		}
		
		Tree.addItem(parentFwid, folder, "(" + folder + ") " + doc.getName());
		strSQL = "SELECT reg.Freg, reg.Fdoc, reg.Fnop, reg.Fwid, lnk.Ftxt"
				+ " FROM ^cl_reg AS reg INNER JOIN ^cl_lnk AS lnk"
					+ " ON lnk.Fdoc=reg.Fdoc AND lnk.Fnop=reg.Fnop"
				+ " WHERE reg.Fnom=0 AND reg.Fnop<>0"
					+ " AND reg.Freg=" + sqlTo(parentID)
					+ " AND reg.Fdoc=" + sqlTo(folder)
				+ " ORDER BY reg.Fdoc, reg.Fnop";
		var tempTbl = OpenTable("s", strSQL);
		while(!tempTbl.isEOF())
		{
			var txt = tempTbl.getValue("Fnop") + ". " + tempTbl.getValue("Ftxt");
			Tree.addItem(folder, tempTbl.getValue("Fwid"), txt, TREE_ITEM);
			tempTbl.MoveNext();
		}
	
		tempTbl.Close();
		folderTbl.MoveNext();
	}
}

function onTreeSelected(strCod, strMode)
{
	if("ENTER" != strMode 
	&& strSelectID == Tree.getSelected())
		return;

	strSelectID = strCod;
	strParentID = Tree.getParentCod();
	list.subSrc();
	if (!strMode)
		list.tblInit();
}

function listSrc()
{
	var oSnap = getSnap("SELECT Freg, Fdoc, Fnop FROM ^" + tblName + " WHERE "+  Convert("FWID","CHAR") + "=" + sqlTo(strSelectID));	
	var w;
	var o;
	if(oSnap)
	{
		w = "Fnom<>0 AND Freg=" + sqlTo(oSnap[0]) + " AND Fdoc=" + sqlTo(oSnap[1]) + " AND Fnop=" + sqlTo(oSnap[2]);
		o = new Array("Fnom");
	}
	else
	{
		oSnap = getSnap("SELECT Freg FROM ^" + tblName + " WHERE Fwid=" + sqlTo(strParentID));	
		w = "Fnom<>0 AND Freg=" + sqlTo(oSnap[0]) + " AND Fdoc=" + sqlTo(strSelectID); 
		o = new Array("Fnop, Fnom");
	}
		
	this.qrySet(  "From", "^" + tblName
				, "Where", w
				, "Order", o
				);
}

function listDel(toObject)
{
	with(this)
	{
		var sCl = "DELETE FROM ^CL_REG WHERE FREG="+tbl.getValue("FREG");
		if( tbl.getValue("FNOM") != 0 )
			sCl = sCl + " AND FDOC=" + sqlTo(tbl.getValue("FDOC")) + " AND FNOP=" + sqlTo(tbl.getValue("FNOP")) + " AND FNOM=" + sqlTo(tbl.getValue("FNOM"))
		else 
		{
			var sReg, sTmp, tblReg
			sReg = "SELECT * FROM ^DOCREG WHERE FREG=" + sqlTo(tbl("FREG"))
			if( typeof(tbl("FDOC")) != "string" || tbl.getValue("FDOC").trim() != dc00.trim() )
			{
				sTmp = " AND FDOC=" + sqlTo(tbl.getValue("FDOC")) + " AND FNOP=" + sqlTo(tbl.getValue("FNOP"))
				sReg = sReg + sTmp
				sCl = sCl + sTmp
			}
			
			var tblReg = OpenTable("s", sReg)
			while( !tblReg.IsEOF() )
			{
				sTmp = "SELECT COUNT(*) AS FCNT FROM ^DOCREG WHERE FID_DOC="+sqlTo(tblReg("FID_DOC"))
				if( OpenTable("s", sTmp)("FCNT")==1 )
				{
					sTmp = "DELETE FROM ^RDOCREG WHERE FID_DOC="+sqlTo(tblReg("FID_DOC"))
					ExecuteSQL(sTmp); // Удаление строк записей регистрации
				}
					
				tblReg.MoveNext()
			}
		   
			sReg = sReg.replace("SELECT *", "DELETE");
			ExecuteSQL(sReg); // Удаление записей регистрации
		}   
		
		ExecuteSQL(sCl); // Удаление схемы 
	}
}  

function listMenuInit(toObject)
{
	if("DpRsTree" == typeOf(toObject))
	{
		if(null==toObject.getParentCod())
		{
			toObject.AddMenuItem("NEW","Додати журнал|Добавить журнал");
			toObject.AddMenuItem("REMOVE","Вилучити журнал|Удалить журнал");
			toObject.AddMenuItem("","");
			editAcc = "A";
			return true;
		}
	}

	if (fromPatt)
		return false;

	with(toObject)
	{
		AddMenuItem ("DOC", "Документи|Документы");
		if (this.par.menuMode != "CHOICE" )
			AddMenuItem ("VAR", "Змінні|Переменные");
			
		AddMenuItem("OPERACII", "Операції|Операции");
		AddMenuItem("XLIST","Розширення журналу|Расширения журнала");
		AddMenuItem ("FORMUL_UMOLCH", "Формула за замовченням|Формула по умолчанию");
	}
}

function listMenuRun(ID, toObject)
{
	if (fromPatt)
		return false;
		
	switch(ID)
	{
	case "NEW":
		showWindow("", SW_MODAL, this.objParMenu);
		break;
		
	case "REMOVE":
		toObject.removeItem(toObject.getSelected());
		break;
			
	case "VAR":
		var oPar = new Object();
		oPar.numJournal = this.tbl.getValue("Freg");
		showWindow("l_varreg.htm", SW_NOMODAL, oPar);
		break;
		
	case "DOC":
		this.objParMenu.file = "CL_REG";
		showWindow("l_regekz", SW_NOMODAL, this.objParMenu, "");
		break;
	
	case "XLIST":
		this.objParMenu.vid = "REG";
		this.objParMenu.cl = this.tbl.getValue("Freg");
		showWindow("l_extent.htm", SW_NOMODAL, this.objParMenu);
		break;
		
	case "OPERACII":
		var oPar = new Object();
		oPar.isReg = true;
		oPar.nRegJr = this.tbl.getValue("Freg");
		showWindow("l_clop.htm", SW_NOMODAL, oPar);
		break;
		
	case "ADD":
	case "COPY":
	case "EDIT":
	case "VIEW":
		this.objParMenu.mode = ID;
		if("DpRsTree"==typeOf(toObject))
		{
			var oSnap = getSnap("SELECT Freg, Fdoc, Fnop"
								+ " FROM ^" + tblName 
								+ " WHERE Fwid=" + sqlTo(strSelectID));	
			if(null==oSnap)
			{
				oSnap = getSnap("SELECT Freg"
								+ " FROM ^" + tblName 
								+ " WHERE Fwid=" + sqlTo(strParentID));	
				
				this.objParMenu.nop = 0;
				this.objParMenu.doc = strSelectID;
				this.objParMenu.reg = oSnap[0];
			}
			else
			{
				this.objParMenu.nop = oSnap[2];
				this.objParMenu.doc = oSnap[1];
				this.objParMenu.reg = oSnap[0];
			}
			
		}
		else
		{
			this.objParMenu.nop = this.tbl.getValue("Fnop");
			this.objParMenu.doc = this.tbl.getValue("Fdoc");
			this.objParMenu.reg = this.tbl.getValue("Freg");
			if (ID != "ADD")
				this.objParMenu.fid = this.tbl.getValue("Fwid");
		}
		break;
		
	case "FORMUL_UMOLCH":
/*			__getRetKeys(this.tbl);
				        
			var dop_tbl;
			dop_tbl=OpenTable("s",
				"SELECT *"
				+ " FROM ^CL_REG"
				+ " WHERE " + sqlStrIsNotEmp("FVAR")
					+ " AND " + this.dataSrc.sqlSelected()
				);
			            
			var n_par = new Object();
			n_par.Fvar="";
			n_par.F1value="";

			if (!dop_tbl.IsEmpty())
			   dop_tbl.MoveFirst();
			
			while (!dop_tbl.IsEof())
			{
			   n_par.Fvar = dop_tbl.getValue("Fvar").trim();
			   n_par.F1value = dop_tbl.getValue("F1value").trim();
			   v1DefVal(jrvid(this.tbl.getValue("freg"))=="-"? "-": "+", n_par)
			   dop_tbl.Edit();
			   dop_tbl("Fvar")=n_par.Fvar;
			   dop_tbl("F1value")=n_par.F1value;
			   dop_tbl.Update();
			   dop_tbl.MoveNext();
			}
			dop_tbl.Close();
			            
			this.tbl.requery();
			RestoreMarker(this.tbl);
*/			break;
	}  
}

include("sys\\DpList.js");