//Создание настроечного файла импорта на основе шаблона dbf файла из системы клиент-банк
//	mode - основной режим: создание или редактирование настроечного файла
//	isDbfMode - флаг для определения режима: настройка параметров dbf файла или настройка переменных док-та платежей
//		режим настройки dbf доступен только при создании настроечного файла (mode=="ADD")
//Описание dbf файла сохраняется во временную таблицу с именем по названию формата импорта
include("objects/DpXMLDomDocument.js");
include("sys/mask.js");
include("doc/DpDoc.js");
include("sys/dbase.js");

var mode, sFileName, fldCondType;
var isDbfMode, field, fsource;
var fstFldName = "";
var fstFldVal = null;
var fstCond;
var tblName = "BNK_CONFIG";
var tblDBF;
var fwidSUM = 0;
var fwidNDS = 0;
//число на которое нужно делить сумму с учетом НДС, чтобы получить сумму НДС
var ndspart = String(1+100/getPar("NDSPROC"));
//массив переменных документа платежек (чтоб не выводить избыточные)
var docVarsAr = new Array("HNOM","HDAT","HSUM","HNDS","HCOT","HCTO",
						"HTOT","HTTO","HMFOOT","HMFOTO","HDBSC","HCRSC",
						"HTOVAR","HVAL","HBNKOT","HBNKTO");

function listLoad()
{
	mode = extPar.mode;
	this.title = (mode=="ADD"?ru("Добавление ","Додавання "):ru("Редактирование ","Редагування "))+ru("настройки импорта из клиент-банка","налаштування імпорту з клієнт-банку");
	this.editTask = "e_clbnkdbf.xml";
	this.escape = escape;
	this.save = save;
	isDbfMode = mode=="ADD";
	BTN_LOAD.enabled = false;
	if(mode=="ADD")
	{
		CONF_NAME.value = "NEWBANK";
		NAZN.value = ru("Импорт платежных документов для ","Імпорт платіжних документів для ");
		TOROUND.value = false;
		Disable(ROUND);
		CreateTable(tblName,"BNK_CONFIG");
	}
	else
	if(mode=="EDIT")
	{
		tblConfName = "CLB_"+extPar.bnkLbl
		if(!IsTable(tblConfName))
		{
			alert(ru("Не найдена таблица настройки переменных ",
					"Не знайдено таблицю налаштування змінних ")+tblConfName)
			return false;
		}
		DropTable(tblName);
		ExecuteSQL("select * into "+tblName+" from "+tblConfName);
		CONF_NAME.value = extPar.bnkLbl;
		Disable(CONF_NAME);
		//инициализируем общие данные из настроечного xml файла,
		//а настройки переменных будем подгружать из таблицы CLB_...
		var sPath = getOrgPath() + "clbank/" +extPar.bnkLbl+".xml";
		var xmlDoc = new DpXMLDOMDocument();
		var bLoad = xmlDoc.load(sPath);
		if(!bLoad)
		{
			alert(ru("Ошибка при чтении файла ","Помилка при зчитуванні файлу ")+sPath);
			return false;
		}
		var xmlObj = xmlDoc.getDocumentElement();
		ENCOD.value = String(xmlObj.getAttribute("encodding")).toLowerCase();
		var childs = xmlObj.getChildNodes();
		var nCount = childs.length;
		for(var n = 0;n < nCount; n++)
		{
			var xmlElement = childs[n];
			switch(String(xmlElement.xmlNode.tagName))
			{
				case "NAZN":
					NAZN.value = xmlElement.xmlNode.textContent; 
				break;
				case "REM":
					REM.value = xmlElement.xmlNode.textContent;
				break;
				case "VARDOCEXPR":
					var txt = xmlElement.xmlNode.textContent;
					codIndB = txt.indexOf("^");
					codIndE = txt.indexOf("==");
					if(codIndE == -1)
					{
						codIndE = txt.indexOf("!=");
						COND.value = "!=";
					}
					else
						COND.value = "==";
					q = txt.indexOf("?");
					codFld = txt.substring(codIndB+1, codIndE);
					codVal = txt.substring(codIndE+2, q);
//					if(codVal.indexOf("'")>-1)
//						codVal = codVal[1];
					if(String(Number(codVal))==String(codVal))
						codVal = String(Number(codVal));
					FLDNAME.value = codFld;
					FLDVAL.value = codVal;
				break;
			}
		}
		//определяем округление
		var snap = getSnap("select Fexpr from "+tblName+" where Field="+sqlTo("HSUM"));
		if(snap && snap[0])
		{
			expr = snap[0];
			if(expr.indexOf("round")>-1)
			{
				TOROUND.value = true;
				indB = expr.indexOf(",");
				if(indB>-1)
					ROUND.value = Number(expr.substr(indB+1,1));
			}
		}
		else
		{
			alert(ru("Не найдено поле суммы!","Не знайдено поле суми!"));
		}
		//инициализируем начальные значения переменных
		fstFldName = FLDNAME.value;
		fstFldVal = FLDVAL.value;
		fstCond = COND.value;
	}
	setButton(BTN_OPEN, openDBF);
	setButton(BTN_LOAD, loadSrc);
	setValid(ENCOD, encod_Valid);
	setValid(CONF_NAME, conf_Valid);
	setValid(FLDNAME, fldname_Valid);
	setValid(FLDVAL, fldval_Valid);
	setValid(TOROUND, toround_Valid);
	setValid(ROUND, toround_Valid);
	setValid(COND, cond_Valid);
	FLDVAL.setMask("&&&&&&&&&&&&&&&&&&&&");
	
	Disable(FSOURCE);
	
	if(mode=="ADD")
	{
		FLDVAL.value = "0";
		GRPVCOND.setVisible(false);
		GRPROUND.setVisible(false);
	}
	else
	{
		Disable(BTN_OPEN);
	}
	this.fldnameSelect = fldnameSelect;
	setButton(FLDNAME, this, "fldnameSelect");
	fstCond = COND.value;
	//нужно вызвать валидность значения кода FLDVAL, чтобы инициализировалась fstFldVal
	fldval_Valid();
	setFocus(CONF_NAME);
}

function listSrc()
{
	//для режима редактирования переменных выводим только выбраные переменные
	if(isDbfMode)
		sWhere = "1=1";
	else
		sWhere = "Fissel="+sqlTrue;
	this.qrySet("From", tblName,"Where", sWhere, "Order", "FNUM");
}

function listDpGrid()
{
	with(grid)
	{
		if(!isDbfMode)
			setFilling("=^FGROUP>0?^FGROUP:^FWID");
		FieldEx("FNUM", "№|№", 5);
		FieldEx("FIELD", isDbfMode?"Джерело|Источник":"Приймач|Приемник", 10);
		if(!isDbfMode)
		{
			FieldEx("FSOURCE", "Джерело|Источник", 10);
			FieldEx("FEXPR", "Вираз|Выражение", 10);
		}
		FieldEx("FTYPE", "Тип", 8);
		FieldEx("FTXT", isDbfMode?"Примітка|Примечание":"Опис|Описание", 15);
	}
	grid.build();
}

function listAfterEdit(ID)
{
	switch(ID)
	{
		case "EDIT":
			//с помощью валидности проставляем 20% НДС при редактировании суммы
			switch(field)
			{
				case "HSUM":
					toround_Valid();
				break;
			}
			//проставляем признаки уже выбранных полей dbf-ника
			setIsSel();
		break;
		case "ADD":
			setIsSel();
		break;
	}
}

function openDBF()
{
	sFileName = BrowseForFile("*.dbf", "Файлы  *.dbf");
	if(sFileName)
	{
		loadDBF();
		FSOURCE.value = sFileName;
		BTN_LOAD.enabled = true;
	}
}

function loadDOC()
{
	isDbfMode = false;
	GRPVCOND.setVisible(true);
	GRPROUND.setVisible(true);
	Disable(BTN_OPEN);
	Disable(CONF_NAME);
	Disable(ENCOD);
	//перед загрузкой переменных сохраняем описание dbf в отдельную таблицу
	DropTable("DBF_"+allt(CONF_NAME.value));
	ExecuteSQL("select * into DBF_"+allt(CONF_NAME.value)+" from "+tblName);
	ExecuteSQL("DELETE FROM "+ tblName, false);
	//создадим временную таблицу которую потом будем сортировать по текстовке и возвращать пронумерованную в исходную таблицу
	tmpTblName = "TMP_BNK_CONFIG";
	CreateTable(tmpTblName,"BNK_CONFIG");
	var oDoc = new DpDoc("PP",0);
	var varsInfo = oDoc.getVarsInfo();
	var m = new Object();
	for(var i=0; i<varsInfo.length; i++)
	{
		m.FIELD = varsInfo[i].name;
		m.FTYPE = getType(varsInfo[i].dataType);
		m.FTXT = varsInfo[i].rem;
		//если это основные поля из нашего массива, то проставляем признак,
		//его же будем проставлять потом для добавленных вручную переменных
		if(docVarsAr.some( function(item){ return item==varsInfo[i].name } ) )
			m.FISSEL = true;
		else
			m.FISSEL = false;
		UpdateTable(tmpTblName, m, true);
	}
	//апдейтим группы для взаимозаменяемых полей (плательщик-получатель)
	//	1 - расчетный счет
	//	2 - МФО
	//	3 - ОКПО
	//	4 - название
	ExecuteSQL("update "+tmpTblName+" set Fgroup=1 where Field in ("+sqlTo("HDBSC")+","+sqlTo("HCRSC")+")");
	ExecuteSQL("update "+tmpTblName+" set Fgroup=2 where Field in ("+sqlTo("HCOT")+","+sqlTo("HCTO")+")");
	ExecuteSQL("update "+tmpTblName+" set Fgroup=3 where Field in ("+sqlTo("HTOT")+","+sqlTo("HTTO")+")");
	ExecuteSQL("update "+tmpTblName+" set Fgroup=4 where Field in ("+sqlTo("HMFOOT")+","+sqlTo("HMFOTO")+")");
	ExecuteSQL("update "+tmpTblName+" set Fgroup=5 where Field in ("+sqlTo("HBNKOT")+","+sqlTo("HBNKTO")+")");
	
	i = 0;
	var t = OpenTable("select * from "+tmpTblName+" order by Fgroup desc,Ftxt");
	for(; !t.IsEOF(); t.MoveNext())
	{
		m = scatter(t);
		if(t.getValue("FISSEL")==true)
			m.FNUM = ++i;
		else
			m.FNUM = 0;
		//т.к. FWID типа counter, то удаляем из объекта это поле
		delete(m.FWID);
		UpdateTable(tblName, m, true);
	}
	t.close();
	grid.DeletePages();
	list.init();//чтоб перезапустить listSrc 
//	listDpGrid()
//	grid.getTable().requery();
//	grid.refresh();
}

function loadDBF()
{
	isDbfMode = true;
	GRPVCOND.setVisible(false);
	GRPROUND.setVisible(false);
	Enable(BTN_OPEN);
	Enable(CONF_NAME);
	Enable(ENCOD);
	
	ExecuteSQL("DELETE FROM "+ tblName, false);
	tblDBF = OpenTable("f",sFileName,ENCOD.value);
	
	var fieldList = tblDBF.getFieldsInfo();
	for(var i = 0; i < fieldList.length; i++) 
	{
		var fld = fieldList[i];
		var fldName = String(fld.getName()).toUpperCase();
		if((fldName.indexOf("#") + fldName.indexOf(".")) >= 0)
			continue;
		var m = new Object();
		m.FNUM = i+1;
		m.FIELD = fldName;
		m.FTYPE = fld.getType().toLowerCase();
		m.FTXT = (tblDBF.rowCount==0?"":String(tblDBF.getValue(fldName)));
		UpdateTable(tblName, m, true);
	}
	tblDBF.close();
	grid.DeletePages();
	list.init();//чтоб перезапустить listSrc 
}

function loadSrc()
{
	if(isDbfMode)
	{
		loadDOC();
		BTN_LOAD.text = UR("Повернутись до налаштування dbf|Вернутся к настройке dbf");
		setFocus(FLDNAME);
	}
	else
	{
		loadDBF();
		BTN_LOAD.text = UR("Завантажити змінні документу|Загрузить переменные документа");
	}
}

function encod_Valid()
{
	if(sFileName)
		loadDBF();
}

function conf_Valid()
{
	var sFile = getOrgPath() + "clbank/"+CONF_NAME.value+".xml";
	if(mode=="ADD" && (isFile(sFile) || isFile(sFile.toLowerCase())))
	{
		alert(ru("Настройка с таким именем уже существует!","Налаштування з такою назвою вже існує!"));
		setFocus(CONF_NAME);
		return false;
	}
	if(allt(CONF_NAME.value)=="")
	{
		alert(ru("Пустое название не допустимо!","Неможна вводити порожню назву!"));
		setFocus(CONF_NAME);
		return false;
	}
	if(String(CONF_NAME.value).length>0 && Number(String(CONF_NAME.value)[0])>=0)
	{
		alert(ru("Название не должно начинаться с цифры!","Назва не повинна починатись з цифри!"));
		return false;
	}
	if(!Array.every(String(CONF_NAME.value), isValid))
	{
		alert(ru("В названии допустимо использовать только символы латынского алфавита и цифры!",
				"У назві допустимо використовувати лише символи латинського алфавіту і цифри!"));
		setFocus(CONF_NAME);
		return false;
	}
	return true;
}

function isValid(ch)//принадлежность к латынскому алфавиту и цифрам
{
  return ((ch >= "a" && ch <= "z") || (ch >= "A" && ch <="Z") || (ch >= "0" && ch <= "9") || ch == "_");
}

function fldname_Valid()
{
	if(allt(FLDNAME.value)=="")
	{
		WAIT(ru("Сперва укажите поле определяющее тип платежного поручения!","Спочатку вкажіть поле, яке визначає тип платіжного доручення!"));
		fldnameSelect();
		setFocus(FLDNAME);
		return false;
	}
	var snap = getSnap("select Ftype from DBF_"+allt(CONF_NAME.value)+" where Field="+sqlTo(FLDNAME.value))
	if(snap)
	{
		fldCondType = snap[0];
	}
	else
	{
		WAIT(ru("Такого поля в dbf файле не существует!","Такого поля в dbf файлі не існує!"));
		fldnameSelect();
		setFocus(FLDNAME);
		return false;
	}
	//если поле изменялось, то нужно проапдейтить выражение в FEXPR
	if(fstFldName!="" && fstFldName!=FLDNAME.value)
	{
		var t = OpenTable("select * from "+tblName+" where Fexpr like("+sqlTo("%"+fstFldName+COND.value+"%")+") ");
		for(; !t.IsEOF(); t.MoveNext())
		{
			var m = new Object();
			m.FEXPR = t.getValue("Fexpr").replace(fstFldName,FLDNAME.value);
			UpdateTable(tblName, m, false, "Fwid="+t.getValue("Fwid"));
		}
		grid.getTable().requery();
		grid.refresh();
	}
	fstFldName = FLDNAME.value;
	//проставляем признаки уже выбранных полей dbf-ника
	setIsSel();
	return true;
}

function fldval_Valid()
{
	if(allt(FLDVAL.value)=="")
	{
		alert(ru("Укажите значение которому должно равнятся поле!","Вкажіть значення якому повинне дорівнюватись поле!"));
		setFocus(FLDVAL);
		return false;
	}
	if(fstFldVal!=null && fstFldVal!=FLDVAL.value)
	{
		var t = OpenTable("select * from "+tblName+" where Fexpr like("+sqlTo("%"+FLDNAME.value+COND.value+"%")+") ");
		for(; !t.IsEOF(); t.MoveNext())
		{
			var m = new Object();
			m.FEXPR = t.getValue("Fexpr").replace(getCond(fstFldVal),getCond(FLDVAL.value));
			UpdateTable(tblName, m, false, "Fwid="+t.getValue("Fwid"));
		}
		grid.getTable().requery();
		grid.refresh();
	}
	fstFldVal = FLDVAL.value;
	return true;
}

function toround_Valid()
{
	if(TOROUND.value == true)
	{
		Enable(ROUND);
		var snapSUM = getSnap("select Fwid,Fsource,Fexpr from "+tblName+" where Field="+sqlTo("HSUM"));
		var snapNDS = getSnap("select Fwid,Fsource from "+tblName+" where Field="+sqlTo("HNDS"));
		if(snapSUM)
		{
			fwidSUM = snapSUM[0];
			//округлять сумму не имеет смысла
//			ExecuteSQL("update "+tblName
//					+" set Fexpr="+sqlTo("=round(Number(^"+snapSUM[1]+"),"+ROUND.value+")")
//					+" where Fwid="+fwidSUM);
			if(snapNDS)
			{
				fwidNDS = snapNDS[0];
				if(snapSUM[2].indexOf("=")==-1)
					sumExpr = snapSUM[2];
				else
					sumExpr = snapSUM[2].replace("=","");
				ExecuteSQL("update "+tblName
						+" set Fsource="+sqlTo(snapSUM[1])
						+",Fexpr="+sqlTo("=round("+sumExpr+"/"+ndspart+","+ROUND.value+")")
						+" where Fwid="+fwidNDS);
			}
			else
				fwidNDS = 0;
			grid.getTable().requery();
			grid.refresh();
		}
		else
			fwidSUM = 0;
	}
	else
	{
		Disable(ROUND);
		//округлять сумму не имеет смысла
//		ExecuteSQL("update "+tblName+" set Fexpr="+SqlConCat(sqlTo("=Number(^"),"Fsource",sqlTo(")"))+" where Fwid="+fwidSUM);
		snapSUM = getSnap("select Fwid,Fsource,Fexpr from "+tblName+" where Field="+sqlTo("HSUM"));
		if(snapSUM)//20% НДС входит в сумму
			ExecuteSQL("update "+tblName+" set Fsource="+sqlTo(snapSUM[1])
					+", Fexpr="+sqlTo(snapSUM[2]+"/"+ndspart)+" where Fwid="+fwidNDS);
		grid.getTable().requery();
		grid.refresh();
	}
}

function cond_Valid()
{
	if(fstCond != COND.value)
	{
		var t = OpenTable("select * from "+tblName+" where Fexpr like("+sqlTo("%"+FLDNAME.value+fstCond+"%")+") ");
		for(; !t.IsEOF(); t.MoveNext())
		{
			var m = new Object();
			m.FEXPR = t.getValue("Fexpr").replace(FLDNAME.value+fstCond,FLDNAME.value+COND.value);
			UpdateTable(tblName, m, false, "Fwid="+t.getValue("Fwid"));
		}
		grid.getTable().requery();
		grid.refresh();
	}
	fstCond = COND.value;
	return true;
}

function getType(sType)
{
	sType = String(sType).toLowerCase();
	switch(sType)
	{
		case "5":
			return "bit";		
		case "3":
			return "date";
		case "4":
			return "number";
		case "2":
			return "number";		
		case "1":
			return "string";		
		default:
			return sType;
	}
}

function filterMode(s)
{
	switch(s)
	{
		case "VIEW":
		case "COPY":
			return false;
		case "DEL":
		case "ADD":
		case "EDIT":
			return !isDbfMode;
	}
	return true;		
}

function listInitEditParam(par)
{
	par.tblSource = "DBF_"+allt(CONF_NAME.value);
	par.cond = getCond(FLDVAL.value);
	field = String(this.tbl.getValue("Field"));
	//если редактируется сумма, то определяем и идентификатор ндс, чтоб после редактирования их проапдейтить, используя toround_Valid()
	if(field=="HSUM")
	{
		fwidSUM = this.tbl.getValue("Fwid");
		var snapNDS = getSnap("select Fwid,Fsource from "+tblName+" where Field="+sqlTo("HNDS"));
		if(snapNDS)
			fwidNDS = snapNDS[0];
	}
}

function getCond(val)
{
	val = allt(val);
	if((val[0]=="'" && val[val.length-1]=="'") || (val[0]=="\"" && val[val.length-1]=="\"") || String(val)==String(Number(val)))
		return "=^"+FLDNAME.value+COND.value+val;
	else
		return "=^"+FLDNAME.value+COND.value+"'"+val+"'";
}

function fldnameSelect()
{
	var par = new Object();
	par.ret = new Object();
	par.ret.FIELD = "";
	par.ret.FTXT = "";
	par.ret.FNUM = "";
	
	par.cells = new Object();

	par.cells[1] = new Object();
	par.cells[1].name = "FNUM";
	par.cells[1].width = 3;
	par.cells[1].text = UR("№|№");

	par.cells[2] = new Object();
	par.cells[2].name = "FIELD";
	par.cells[2].width = 10;
	par.cells[2].text = UR("Стовпчик|Столбик");	
	
	par.cells[3] = new Object();
	par.cells[3].name = "FTYPE";
	par.cells[3].width = 10;
	par.cells[3].text = UR("Тип|Тип");
	
	par.cells[4] = new Object();
	par.cells[4].name = "FTXT";
	par.cells[4].width = 10;
	par.cells[4].text = UR("Примітка|Примечание");

	par.caption = UR("Джерело|Источник");
	t = OpenTable("DBF_"+allt(CONF_NAME.value));
	browse(t, par, SW_MODAL);
	t.close();
	if(par.ret.FIELD)
		FLDNAME.value = String(par.ret.FIELD);
}

function save()
{
	if(isDbfMode)
	{
		alert(ru("Сперва откройте dbf файл и закачайте переменные документа!","Спершу відкрийте dbf файл та завантажте змінні документу!"));
		return false;
	}
	var snap = getSnap("select * from "+tblName+" where Fissel="+sqlTrue
			+" and (Fexpr is null or Fexpr="+sqlTo(" ")+")");
	if(snap)
	{
		alert(ru("Отредактируйте все поля с пустыми значениями либо удалите их.",
				"Відредагуйте усі поля з порожніми значенніми або вилучить їх."));
		return false;
	}
	fldname_Valid();
	fldval_Valid();
	//toround_Valid();
	cond_Valid();
	var sPath = getOrgPath() + "clbank/" +allt(CONF_NAME.value)+".xml"
	var xmlDoc = new DpXMLDOMDocument();
	//заносим в исходный xml файл необходимые настройки
	var xmlCLBANK = xmlDoc.createChild("CLBANK", null, {type:"DBF", encodding:ENCOD.value});
	xmlCLBANK.createChild("NAZN", NAZN.value);
	xmlCLBANK.createChild("REM", REM.value);
	var xmlVARDOC = xmlCLBANK.createChild("VARDOC", null);
	for(this.tbl.MoveFirst(); !this.tbl.IsEOF(); this.tbl.MoveNext())
		xmlVARDOC.createChild(this.tbl.getValue("FIELD"), this.tbl.getValue("FEXPR"));
	var fval = String(FLDVAL.value);
	fval = (String(Number(fval))==fval || (fval[0]=="'" && fval[fval.length-1]=="'") || (fval[0]=="\"" && fval[fval.length-1]=="\"")?fval:"\""+fval+"\"")+"?\"PV\":\"PP\"";
	xmlCLBANK.createChild("VARDOCEXPR", "=(^"+FLDNAME.value+COND.value+fval+")");
	xmlDoc.save(sPath);
	//таблицу настроек переменных платежек сохраняем в отдельную таблицу по имени настройки, для дальнейшей возможности редактирования
	var clbTbl = "CLB_"+allt(CONF_NAME.value);
	DropTable(clbTbl);
	ExecuteSQL("select * into "+clbTbl+" from "+tblName);
	FORM.close();
}

function listMenuInit()
{
	if(this.tbl.rowCount>0 && !isDbfMode)
		this.dataSrc.AddMenuItem("EDITEXPR","Редагувати вираз|Редактировать выражение");
}

function listMenuRun(ID)
{
	switch(ID)
	{
		case "EDITEXPR":
			var snap = getSnap("select Fexpr from "+tblName+" where Fwid="+this.tbl.getValue("Fwid"));
			var expr = ""
			if(snap)
				expr = snap[0];
			expr = input("",ru("Редагування виразу","Редактирование выражения"),expr,255);
			if(expr != null)
			{
				ExecuteSQL("update "+tblName+" set Fexpr="+sqlTo(expr)+" where Fwid="+this.tbl.getValue("Fwid"));
				list.tbl.requery();
				grid.refresh();
			}
		break;
	}
}

function escape()
{
	grid.getTable().close();
	FORM.close();
}

function setIsSel()
{
	ExecuteSQL("update DBF_"+allt(CONF_NAME.value)+" set Fissel="+sqlFalse)
	ExecuteSQL("update DBF_"+allt(CONF_NAME.value)+" set Fissel="+sqlTrue
			+" where Field in (select Fsource from "+tblName+") or Field="+sqlTo(FLDNAME.value))
}

function listDel()
{
//	if(docVarsAr.some( function(item){ return item==list.tbl.getValue("FIELD") } ) )
//	{
//		alert(ru("Удалять можно только переменные, добавленные вручную!","Вилучати можна тільки змінні, додані вручну!"));
//		return false;
//	}
	ExecuteSQL("update "+tblName+" set Fissel="+sqlFalse+" where Fwid="+this.tbl.getValue("Fwid"));
	return false;
}