//Создание настроечного файла импорта на основе шаблона текстового файла из системы клиент-банк
//	mode - основной режим: создание или редактирование настроечного файла
//	isTxtMode - флаг для определения режима: настройка параметров текстового файла или настройка переменных док-та платежей
//		режим настройки текстового файла доступен только при создании настроечного файла (mode=="ADD")
//Описание текстового файла сохраняется во временную таблицу с именем по названию формата импорта
include("objects/DpXMLDomDocument.js");
include("sys/mask.js");
include("doc/DpDoc.js");
include("sys/dbase.js");

var mode, sFileName, fldCondType;
var isTxtMode, field, fsource;
var fstFldName = "";
var fstFldVal = null;
var fstCond,fstFilterVal;
var tblName = "BNK_CONFIG";
var tblRangeName = "TXT_RANGE";
var fwidSUM = 0;
var fwidNDS = 0;
var ignorSplitSpace = false;
var rangeLength = 0;
var minVarCount = 6;
//число на которое нужно делить сумму с учетом НДС, чтобы получить сумму НДС
var ndspart = String(1+100/getPar("NDSPROC"));
//массив переменных документа платежек (чтоб не выводить избыточные)
var docVarsAr = new Array("HNOM","HDAT","HSUM","HNDS","HCOT","HCTO",
						"HTOT","HTTO","HMFOOT","HMFOTO","HDBSC","HCRSC",
						"HTOVAR","HVAL","HBNKOT","HBNKTO");

function listLoad()
{
	mode = extPar.mode;
	this.title = (mode=="ADD"?ru("Добавление ","Додавання "):ru("Редактирование ","Редагування "))+ru("настройки импорта из клиент-банка","налаштування імпорту з клієнт-банку");
	this.editTask = "e_clbnktxt.xml";
	this.escape = escape;
	this.save = save;
	isTxtMode = mode=="ADD";
	BTN_LOAD.enabled = false;
	if(mode=="ADD")
	{
		CONF_NAME.value = "NEWBANK";
		NAZN.value = ru("Импорт платежных документов для ","Імпорт платіжних документів для ");
		TOROUND.value = false;
		Disable(ROUND);
		CreateTable(tblName,"BNK_CONFIG");
	}
	else
	if(mode=="EDIT")
	{
		tblConfName = "CLB_"+extPar.bnkLbl
		if(!IsTable(tblConfName))
		{
			alert(ru("Не найдена таблица настройки переменных ",
					"Не знайдено таблицю налаштування змінних ")+tblConfName)
			return false;
		}
		DropTable(tblName);
		ExecuteSQL("select * into "+tblName+" from "+tblConfName);
		CONF_NAME.value = extPar.bnkLbl;
		Disable(CONF_NAME);
		Disable(ROWHEADER);
		Disable(ROWTYPE);
		Disable(BTN_RANGE);
		//инициализируем общие данные из настроечного xml файла,
		//а настройки переменных будем подгружать из таблицы CLB_...
		var sPath = getOrgPath() + "clbank/" +extPar.bnkLbl+".xml";
		var xmlDoc = new DpXMLDOMDocument();
		var bLoad = xmlDoc.load(sPath);
		if(!bLoad)
		{
			alert(ru("Ошибка при чтении файла ","Помилка при зчитуванні файлу ")+sPath);
			return false;
		}
		var xmlObj = xmlDoc.getDocumentElement();
		ROWTYPE.value = String(xmlObj.getAttribute("row")).toUpperCase();
		ENCOD.value = String(xmlObj.getAttribute("encodding")).toLowerCase();
		
		var childs = xmlObj.getChildNodes();
		var nCount = childs.length;
		for(var n = 0;n < nCount; n++)
		{
			var xmlElement = childs[n];
			switch(String(xmlElement.xmlNode.tagName))
			{
				case "NAZN":
					NAZN.value = xmlElement.xmlNode.textContent; 
				break;
				case "REM":
					REM.value = xmlElement.xmlNode.textContent;
				break;
				case "VARDOCEXPR":
					var txt = xmlElement.xmlNode.textContent;
					codIndB = txt.indexOf("!{");
					codIndE = txt.indexOf("==");
					if(codIndE == -1)
					{
						codIndE = txt.indexOf("!=");
						COND.value = "!=";
					}
					else
						COND.value = "==";
					q = txt.indexOf("?");
					codFld = txt.substring(codIndB, codIndE);
					codVal = txt.substring(codIndE+2, q);
					if(String(Number(codVal))==String(codVal))
						codVal = String(Number(codVal));
					FLDNAME.value = codFld;
					FLDVAL.value = codVal;
				break;
				case "FILTER":
					FEXPR_FILTER.value = xmlElement.xmlNode.textContent;
				break;
				case "FLD_FILTER":
					FLD_FILTER.value = xmlElement.xmlNode.textContent;
				break;
				case "VARDOC":
					ROWSTART.value = Number(xmlElement.xmlNode.getAttribute("rowstart"));
					SPLITTER.value = String(xmlElement.xmlNode.getAttribute("splitter"));
					DOCBEGIN.value = String(xmlElement.xmlNode.getAttribute("docbegin"));
					DOCEND.value = String(xmlElement.xmlNode.getAttribute("docend"));
				break;
			}
		}
		//определяем округление
		var snap = getSnap("select Fexpr from "+tblName+" where Field="+sqlTo("HSUM"));
		if(snap && snap[0])
		{
			expr = snap[0];
			if(expr.indexOf("round")>-1)
			{
				TOROUND.value = true;
				indB = expr.indexOf(",");
				if(indB>-1)
					ROUND.value = Number(expr.substr(indB+1,1));
			}
		}
		else
		{
			alert(ru("Не найдено поле суммы!","Не знайдено поле суми!"));
		}
		//инициализируем начальные значения переменных
		fstFldName = FLDNAME.value;
		fstFldVal = FLDVAL.value;
		fstCond = COND.value;
	}
	setButton(BTN_OPEN, openTxt);
	setButton(BTN_LOAD, loadSrc);
	setButton(BTN_RANGE, initRange);
	setValid(ENCOD, encod_Valid);
	setValid(CONF_NAME, conf_Valid);
	setValid(FLDNAME, fldname_Valid);
	setValid(FLD_FILTER, fld_filter_Valid);
	FLD_FILTER.setButton(true);
	setValid(FLDVAL, fldval_Valid);
	setValid(TOROUND, toround_Valid);
	setValid(ROUND, toround_Valid);
	setValid(COND, cond_Valid);
	setValid(ROWTYPE,rowtype_Valid);
	setValid(ROWSTART,rowstart_Valid);
	setValid(ROWHEADER,rowheader_Valid);
	setValid(SPLITTER,splitter_Valid);
	setValid(DOCBEGIN,docbegin_Valid);
	setValid(DOCEND,docend_Valid);
	setWhen(SPLITTER,splitter_When);
//	setWhen(ROWSTART,rowstart_When);
//	setWhen(ROWHEADER,rowheader_When);
	setWhen(DOCBEGIN,docbegin_When);
	setWhen(DOCEND,docend_When);
	FLDVAL.setMask("&&&&&&&&&&&&&&&&&&&&");
	
	Disable(FSOURCE);
	
	if(mode=="ADD")
	{
		FLDVAL.value = "0";
		GRPVCOND.setVisible(false);
		GRPFILTER.setVisible(false);
		GRPROUND.setVisible(false);
	}
	else
	{
		Disable(BTN_OPEN);
	}
	this.fldnameSelect = fldnameSelect;
	setButton(FLDNAME, this, "fldnameSelect");
	this.fldFilterSelect = fldFilterSelect;
	setButton(FLD_FILTER, this, "fldFilterSelect");
	fstCond = COND.value;
	fstFilterVal = FLD_FILTER.value;
	rowtype_Valid();
	//нужно вызвать валидность значения кода FLDVAL, чтобы инициализировалась fstFldVal
	fldval_Valid();
	setFocus(CONF_NAME);
}

function listSrc()
{
	//для режима редактирования переменных выводим только выбраные переменные
	if(isTxtMode)
		sWhere = "1=1";
	else
		sWhere = "Fissel="+sqlTrue;
	this.qrySet("From", tblName,"Where", sWhere, "Order", "FNUM");
}

function listDpGrid()
{
	with(grid)
	{
		if(!isTxtMode)
			setFilling("=^FGROUP>0?^FGROUP:^FWID");
		FieldEx("FNUM", "№|№", 5);
		FieldEx("FIELD", isTxtMode?"Джерело|Источник":"Приймач|Приемник", 10);
		if(!isTxtMode)
		{
			FieldEx("FSOURCE", "Джерело|Источник", 10);
			FieldEx("FEXPR", "Вираз|Выражение", 10);
		}
		FieldEx("FTYPE", "Тип", 8);
		FieldEx("FTXT", isTxtMode?"Примітка|Примечание":"Опис|Описание", 15);
		if(isTxtMode && ROWTYPE.value=="DOC_IND")
		{
			var grp = addGroup(UR("Індекси|Индексы"));
			grp.addField(FieldEx("FIND1", "Перший|Первый", 6, "e", "%10d"));
			grp.addField(FieldEx("FIND2", "Останній|Последний", 6, "e", "%10d"));
		}
	}
	grid.build();
}

function listAfterEdit(ID)
{
	switch(ID)
	{
		case "EDIT":
			//с помощью валидности проставляем 20% НДС при редактировании суммы
			switch(field)
			{
				case "HSUM":
					toround_Valid();
				break;
			}
			//проставляем признаки уже выбранных полей
			setIsSel();
		break;
		case "ADD":
			setIsSel();
		break;
	}
}

function openTxt()
{
	if(ROWTYPE.value == "VAR" && (!splitter_Valid() || !docbegin_Valid() || !docend_Valid()))
		return false;
	sFileName = BrowseForFile("*.*","Все файлы (*.*)|*.*|");
	if(sFileName)
	{
		FSOURCE.value = sFileName;
		//если это csv файл, тогда устанавливаем режим с разделителем, переменные разделяются символом ';'
		if(sFileName.toLowerCase().indexOf(".csv")>-1)
		{
			ROWTYPE.value = "DOC_SPLIT";
			rowtype_Valid();
			SPLITTER.value = ";";
			ROWSTART.value = 2;
			ROWHEADER.value = 1;
			ENCOD.value = "cp1251";
		}
		loadTxt();
		BTN_LOAD.enabled = true;
	}
}

function loadDOC()
{
	isTxtMode = false;
	GRPVCOND.setVisible(true);
	GRPFILTER.setVisible(true);
	GRPROUND.setVisible(true);
	Disable(BTN_OPEN);
	Disable(CONF_NAME);
	Disable(ENCOD);
	Disable(ROWTYPE);
	Disable(ROWSTART);
	Disable(ROWHEADER);
	Disable(SPLITTER);
	Disable(DOCBEGIN);
	Disable(DOCEND);
	Disable(BTN_RANGE);
	//перед загрузкой переменных сохраняем описание txt в отдельную таблицу
	DropTable("TXT_"+allt(CONF_NAME.value));
	ExecuteSQL("select * into TXT_"+allt(CONF_NAME.value)+" from "+tblName);
	ExecuteSQL("DELETE FROM "+ tblName, false);
	//создадим временную таблицу которую потом будем сортировать по текстовке и возвращать пронумерованную в исходную таблицу
	tmpTblName = "TMP_BNK_CONFIG";
	CreateTable(tmpTblName,"BNK_CONFIG");
	var oDoc = new DpDoc("PP",0);
	var varsInfo = oDoc.getVarsInfo();
	var m = new Object();
	for(var i=0; i<varsInfo.length; i++)
	{
		m.FIELD = varsInfo[i].name;
		m.FTYPE = getType(varsInfo[i].dataType);
		m.FTXT = varsInfo[i].rem;
		//если это основные поля из нашего массива, то проставляем признак,
		//его же будем проставлять потом для добавленных вручную переменных
		if(docVarsAr.some( function(item){ return item==varsInfo[i].name } ) )
			m.FISSEL = true;
		else
			m.FISSEL = false;
		UpdateTable(tmpTblName, m, true);
	}
	//апдейтим группы для взаимозаменяемых полей (плательщик-получатель)
	//	1 - расчетный счет
	//	2 - МФО
	//	3 - ОКПО
	//	4 - название
	ExecuteSQL("update "+tmpTblName+" set Fgroup=1 where Field in ("+sqlTo("HDBSC")+","+sqlTo("HCRSC")+")");
	ExecuteSQL("update "+tmpTblName+" set Fgroup=2 where Field in ("+sqlTo("HCOT")+","+sqlTo("HCTO")+")");
	ExecuteSQL("update "+tmpTblName+" set Fgroup=3 where Field in ("+sqlTo("HTOT")+","+sqlTo("HTTO")+")");
	ExecuteSQL("update "+tmpTblName+" set Fgroup=4 where Field in ("+sqlTo("HMFOOT")+","+sqlTo("HMFOTO")+")");
	ExecuteSQL("update "+tmpTblName+" set Fgroup=5 where Field in ("+sqlTo("HBNKOT")+","+sqlTo("HBNKTO")+")");
	
	i = 0;
	var t = OpenTable("select * from "+tmpTblName+" order by Fgroup desc,Ftxt");
	for(; !t.IsEOF(); t.MoveNext())
	{
		m = scatter(t);
		if(t.getValue("FISSEL")==true)
			m.FNUM = ++i;
		else
			m.FNUM = 0;
		//т.к. FWID типа counter, то удаляем из объекта это поле
		delete(m.FWID);
		UpdateTable(tblName, m, true);
	}
	t.close();
	grid.DeletePages();
	list.init();//чтоб перезапустить listSrc 
}

function loadTxt()
{
	isTxtMode = true;
	GRPVCOND.setVisible(false);
	GRPFILTER.setVisible(false);
	GRPROUND.setVisible(false);
	if(!sFileName)
		return false;
	//проверяем вводились ли диапазоны индексов
	if(ROWTYPE.value == "DOC_IND")
	{
		Enable(BTN_RANGE);
		if(!IsTable(tblRangeName) || rangeLength<minVarCount)
			initRange();
	}
	
	Enable(ROWTYPE);
	if(ROWTYPE.value != "VAR")
	{
		Enable(ROWSTART);
		Enable(ROWHEADER);
	}
	Enable(SPLITTER);
	Enable(DOCBEGIN);
	Enable(DOCEND);
	ExecuteSQL("DELETE FROM "+ tblName, false);
	var sFile = String(ReadTxtFile(sFileName,ENCOD.value));
	var nNewLine = 0;
	var sLine = "";
	if (sFile.length == 0)
	{
		alert(ru("Файл пустой!","Файл порожній!"));
		return false;
	}
	var lineNom = 1;
	switch(String(ROWTYPE.value))
	{
		case "DOC_IND":
			var fieldAr = new Array();
			var fieldNameAr = new Array();
			while(sFile.length>0)
			{
				nNewLine = sFile.indexOf('\n');
				if(-1 == nNewLine)
				{
					sLine	= sFile;
					sFile	= "";
				}
				else
				{
					sLine	= sFile.substr(0, nNewLine);
					sFile	= sFile.substr(nNewLine+1);
				}
				//парсим заголовки
				if(lineNom == ROWHEADER.value)
					fieldNameAr = rangeSplitStr(sLine,tblRangeName);
				//пропускаем строки идущие до указаной в ROWSTART
				if (lineNom++ >= ROWSTART.value)
				{
					fieldAr = rangeSplitStr(sLine,tblRangeName);
					break;
				}
			}
			if(sLine.length==0 && ROWSTART.value==lineNom-1)
			{
				alert(ru("Строка №"+ROWSTART.value+" пустая! Попробуйте увеличить номер строчки.","Рядок №"+ROWSTART.value+" порожній! Спробуйте збільшити номер рядка."));
				setFocus(ROWSTART);
				return false;
			}
			for(var i in fieldAr)
			{
				var ind = i.split("-");
				if(ind.length<2)
					continue;
				var m = new Object();
				//m.FNUM = i;
				m.FIND1 = ind[0];
				m.FIND2 = ind[1];
				m.FIELD = (allt(fieldNameAr[i])!=""?allt(fieldNameAr[i]):"FIELD"+"_"+ind[0]+"_"+ind[1]);
				m.FTYPE = "string";
				m.FTXT = fieldAr[i];
				UpdateTable(tblName, m, true);
			}
			var t = OpenTable("select * from "+tblName+" order by Find1,Find2");
			for(; !t.IsEOF(); t.MoveNext())
				ExecuteSQL("update "+tblName+" set Fnum="+(t.bookmark-1)+" where Fwid="+t.getValue("Fwid"));
			t.close();
			BTN_RANGE.text = UR("Редагувати діапазони|Редактировать диапазоны");
		break;
		case "DOC_SPLIT":
			if(!splitter_Valid())
				return false;
			var fieldAr = new Array();
			var fieldNameAr = new Array();
			while(sFile.length>0)
			{
				nNewLine = sFile.indexOf('\n');
				if(-1 == nNewLine)
				{
					sLine	= sFile;
					sFile	= "";
				}
				else
				{
					sLine	= sFile.substr(0, nNewLine);
					sFile	= sFile.substr(nNewLine+1);
				}
				//парсим заголовки
				if(lineNom == ROWHEADER.value)
					fieldNameAr = sLine.split(SPLITTER.value);
				//пропускаем строки идущие до указаной в ROWSTART
				if (lineNom++ >= ROWSTART.value)
				{
					fieldAr = sLine.split(SPLITTER.value);
					break;
				}
			}
			if(sLine.length==0 && ROWSTART.value==lineNom-1)
			{
				alert(ru("Строка №"+ROWSTART.value+" пустая! Попробуйте увеличить номер строчки.","Рядок №"+ROWSTART.value+" порожній! Спробуйте збільшити номер рядка."));
				setFocus(ROWSTART);
				return false;
			}
			if(fieldAr.length<minVarCount)
			{
				alert(ru("Не корректные данные! Проверьте разделитель и номер строчки.",
						"Не коректні дані! Перевірте роздільник і номер рядку."))
			}
			for(var i=0; i<fieldAr.length; i++)
			{
				var m = new Object();
				m.FNUM = i;
				m.FIELD = (fieldNameAr.length>0 && fieldNameAr[i]?fieldNameAr[i]:"FIELD"+i);
				m.FTYPE = "string";
				m.FTXT = fieldAr[i];
				UpdateTable(tblName, m, true);
			}
		break;
		case "VAR":
			if(!splitter_Valid() || !docbegin_Valid() || !docend_Valid())
			{
				alert(ru("Не правильно указан разделитель, или начало, или конец документа!",
						"Не правильно вказаний роздільник, або початок, або кінець документа!"));
				return false;
			}
			var sLineBegin = String(DOCBEGIN.value);
			var sLineEnd = String(DOCEND.value);
			var isReaddingVars = false;//флаг по кторому считываем переменные
			var fieldAr = new Array();
			var fieldNameAr = new Array();
			//пройдемся по всему файлу, т.к. в одном документе могут быть переменные, отсутствующие в другом документе
			while(sFile.length>0)
			{
				nNewLine = sFile.indexOf('\n');
				if(-1 == nNewLine)
				{
					sLine	= sFile;
					sFile	= "";
				}
				else
				{
					sLine	= sFile.substr(0, nNewLine);
					sFile	= sFile.substr(nNewLine+1);
				}
				if(strIn(sLineEnd, sLine))//конец документа
					isReaddingVars = false;
				if(isReaddingVars)
				{
					//парсим заголовки и значения переменных
					var indSplit = sLine.indexOf(SPLITTER.value);
					if(indSplit == -1)
					{
						WAIT(ru("Не удалось найти разделитель в строчке: ","Не вдалося знайти роздільник в рядку: "))+sLine;
						continue;
					}
					var fldName =	sLine.substr(0,indSplit+String(SPLITTER.value).length);
					//проверяем есть ли это поле уже в массиве
					if(fieldNameAr.some( function(item){ return item==fldName } ))
						continue;
					fieldNameAr[fieldNameAr.length] = fldName;
					var fld = sLine.substr(indSplit+String(SPLITTER.value).length);
					fieldAr[fieldAr.length] = fld;
				}
				//определяем начало документа и считываем все переменные до конца документа
				if(strIn(sLineBegin, sLine))
				{
					isReaddingVars = true;
					continue;
				}
			}
			if(fieldAr.length<minVarCount)
			{
				alert(ru("Не корректные данные! Возможно не правильно указана кодировка, или разделитель, или начало, или конец документа.",
						"Не коректні дані! Можливо не правильно вказано кодування, або роздільник, або початок, або кінець документа."))
			}
			for(var i=0; i<fieldAr.length; i++)
			{
				var m = new Object();
				m.FNUM = i;
				m.FIELD = (fieldNameAr.length>0 && fieldNameAr[i]?fieldNameAr[i]:"FIELD"+i);
				m.FTYPE = "string";
				m.FTXT = fieldAr[i];
				UpdateTable(tblName, m, true);
			}
		break;
	}
	grid.DeletePages();
	list.init();//чтоб перезапустить listSrc 
}

function loadSrc()
{
	if(isTxtMode)
	{
		loadDOC();
		BTN_LOAD.text = UR("Повернутись до налаштування текстовго файлу|Вернутся к настройке текстового файла");
		setFocus(FLDNAME);
	}
	else
	{
		loadTxt();
		BTN_LOAD.text = UR("Завантажити змінні документу|Загрузить переменные документа");
	}
}

function encod_Valid()
{
	if(sFileName)
		loadTxt();
	return true;
}

function conf_Valid()
{
	if(ROWTYPE.value == "DOC_IND")
	{
		if(IsTable(tblRangeName))
		{
			var snap = getSnap("select count(*) from "+tblRangeName);
			if(snap)
				rangeLength = snap[0];
		}
	}
	var sFile = getOrgPath() + "clbank/"+allt(CONF_NAME.value)+".xml";
	if(mode=="ADD" && (isFile(sFile) || isFile(sFile.toLowerCase())))
	{
		alert(ru("Настройка с таким именем уже существует!","Налаштування з такою назвою вже існує!"));
		setFocus(CONF_NAME);
		return false;
	}
	if(allt(CONF_NAME.value)=="")
	{
		alert(ru("Пустое название не допустимо!","Неможна вводити порожню назву!"));
		setFocus(CONF_NAME);
		return false;
	}
	if(String(CONF_NAME.value).length>0 && Number(String(CONF_NAME.value)[0])>=0)
	{
		alert(ru("Название не должно начинаться с цифры!","Назва не повинна починатись з цифри!"));
		return false;
	}
	if(!Array.every(String(CONF_NAME.value), isValid))
	{
		alert(ru("В названии допустимо использовать только символы латынского алфавита и цифры!",
				"У назві допустимо використовувати лише символи латинського алфавіту і цифри!"));
		setFocus(CONF_NAME);
		return false;
	}
	return true;
}

function isValid(ch)//принадлежность к латынскому алфавиту и цифрам
{
	return ((ch >= "a" && ch <= "z") || (ch >= "A" && ch <="Z") || (ch >= "0" && ch <= "9") || ch == "_");
}

function fldname_Valid()
{
	if(allt(FLDNAME.value)=="")
	{
		WAIT(ru("Сперва укажите поле определяющее тип платежного поручения!","Спочатку вкажіть поле, яке визначає тип платіжного доручення!"));
		if(!fldnameSelect())
			return false;
	}
	
	var val = allt(FLDNAME.value);
	if(val.indexOf("!{")==-1 || val.indexOf("}")==-1)
	{
		if(!fldnameSelect())
			return false;
		else
			val = allt(FLDNAME.value);
	}
	var i1 = val.indexOf("!{")+2;
	var i2 = val.indexOf("}");
	
	var snap;
	switch(String(ROWTYPE.value))
	{
		case "DOC_IND":
			val = val.substring(i1,i2);
			var ind = val.split("-");
			if(ind.length==2)
				var sWhere = " Find1="+ind[0]+" and Find2="+ind[1];
			else
				var sWhere = " Find1="+ind[0]+" and Find2="+ind[0];
			snap = getSnap("select Fwid from TXT_"+allt(CONF_NAME.value)+" where "+sWhere);
		break;
		case "DOC_SPLIT":
			val = Number(val.substring(i1,i2));
			snap = getSnap("select Fwid from TXT_"+allt(CONF_NAME.value)+" where Fnum="+sqlTo(val));
		break;
		case "VAR":
			val = val.substring(i1,i2);
			var snap = getSnap("select Fwid from TXT_"+allt(CONF_NAME.value)+" where Field="+sqlTo(val));
		break;
	}
	if(!snap)
		return false;
	//если поле изменялось, то нужно проапдейтить выражение в FEXPR
	if(fstFldName!="" && fstFldName!=FLDNAME.value)
	{
		var t = OpenTable("select * from "+tblName+" where Fexpr like("+sqlTo("%"+fstFldName+COND.value+"%")+") ");
		for(; !t.IsEOF(); t.MoveNext())
		{
			var m = new Object();
			m.FEXPR = t.getValue("Fexpr").replace(fstFldName,FLDNAME.value);
			UpdateTable(tblName, m, false, "Fwid="+t.getValue("Fwid"));
		}
		grid.getTable().requery();
		grid.refresh();
	}
	fstFldName = FLDNAME.value;
	//проставляем признаки уже выбранных полей 
	setIsSel();
	return true;
}

function fld_filter_Valid()
{
	if(allt(FEXPR_FILTER.value)=="")
	{
		FEXPR_FILTER.value = FLD_FILTER.value;
		fstFilterVal = FLD_FILTER.value;
	}
	else
	{
		var fld_filter = FLD_FILTER.value;
		if(fstFilterVal!=fld_filter)
		{
			var k = 0;
			while(FEXPR_FILTER.value.indexOf(fstFilterVal)!=-1)
			{
				var fexpr = FEXPR_FILTER.value;
				FEXPR_FILTER.value = fexpr.replace(fstFilterVal,fld_filter);
				if(k++>100)
					break;
			}
			fstFilterVal = FLD_FILTER.value;
		}
	}
	return true;
}

function fldval_Valid()
{
	if(allt(FLDVAL.value)=="")
	{
		alert(ru("Укажите значение которому должно равнятся поле!","Вкажіть значення якому повинне дорівнюватись поле!"));
		setFocus(FLDVAL);
		return false;
	}
	if(fstFldVal!=null && fstFldVal!=FLDVAL.value)
	{
		var t = OpenTable("select * from "+tblName+" where Fexpr like("+sqlTo("%"+FLDNAME.value+COND.value+"%")+") ");
		for(; !t.IsEOF(); t.MoveNext())
		{
			var m = new Object();
			m.FEXPR = t.getValue("Fexpr").replace(getCond(fstFldVal),getCond(FLDVAL.value));
			UpdateTable(tblName, m, false, "Fwid="+t.getValue("Fwid"));
		}
		grid.getTable().requery();
		grid.refresh();
	}
	fstFldVal = FLDVAL.value;
	return true;
}

function toround_Valid()
{
	if(TOROUND.value == true)
	{
		Enable(ROUND);
		var snapSUM = getSnap("select Fwid,Fsource,Fexpr from "+tblName+" where Field="+sqlTo("HSUM"));
		var snapNDS = getSnap("select Fwid,Fsource from "+tblName+" where Field="+sqlTo("HNDS"));
		if(snapSUM)
		{
			fwidSUM = snapSUM[0];
			switch(String(ROWTYPE.value))
			{
				case "DOC_IND":
//					var txtSnap = getSnap("select Find1,Find2 from TXT_"+allt(CONF_NAME.value)+" where Field="+sqlTo(snapSUM[1]));
//					if(txtSnap)
//					{
						//округлять сумму не имеет смысла
//						ExecuteSQL("update "+tblName
//								+" set Fexpr="+sqlTo("round(Number("+getExprInd(txtSnap[0],txtSnap[1])+"),"+ROUND.value+")")
//								+" where Fwid="+fwidSUM);
						if(snapNDS)
						{
							fwidNDS = snapNDS[0];
							ExecuteSQL("update "+tblName
									+" set Fsource="+sqlTo(snapSUM[1])
									+",Fexpr="+sqlTo("round("+snapSUM[2]+"/"+ndspart+","+ROUND.value+")")
									+" where Fwid="+fwidNDS);
						}
						else
							fwidNDS = 0;
						grid.getTable().requery();
						grid.refresh();
//					}
//					else
//						return false;
				break;
				case "DOC_SPLIT":
//					var txtSnap = getSnap("select Fnum from TXT_"+allt(CONF_NAME.value)+" where Field="+sqlTo(snapSUM[1]));
//					if(txtSnap)
//					{
						//округлять сумму не имеет смысла
//						ExecuteSQL("update "+tblName
//								+" set Fexpr="+sqlTo("round(Number(!{"+txtSnap[0]+"}),"+ROUND.value+")")
//								+" where Fwid="+fwidSUM);
						if(snapNDS)
						{
							fwidNDS = snapNDS[0];
							ExecuteSQL("update "+tblName
									+" set Fsource="+sqlTo(snapSUM[1])
									+",Fexpr="+sqlTo("round("+snapSUM[2]+"/"+ndspart+","+ROUND.value+")")
									+" where Fwid="+fwidNDS);
						}
						else
							fwidNDS = 0;
						grid.getTable().requery();
						grid.refresh();
//					}
//					else
//						return false;
				break;
				case "VAR":
					//округлять сумму не имеет смысла
//					ExecuteSQL("update "+tblName
//							+" set Fexpr="+sqlTo("round(Number(!{"+snapSUM[1]+"}),"+ROUND.value+")")
//							+" where Fwid="+fwidSUM);
					if(snapNDS)
					{
						fwidNDS = snapNDS[0];
						ExecuteSQL("update "+tblName
								+" set Fsource="+sqlTo(snapSUM[1])
								+",Fexpr="+sqlTo("round("+snapSUM[2]+"/"+ndspart+","+ROUND.value+")")
								+" where Fwid="+fwidNDS);
					}
					else
						fwidNDS = 0;
					grid.getTable().requery();
					grid.refresh();
				break;
			}
		}
		else
			fwidSUM = 0;
	}
	else
	{
		Disable(ROUND);
		snapSUM = getSnap("select Fwid,Fsource,Fexpr from "+tblName+" where Field="+sqlTo("HSUM"));
		if(snapSUM)
		{
			switch(String(ROWTYPE.value))
			{
				case "DOC_IND":
					var txtSnap = getSnap("select Find1,Find2 from TXT_"+allt(CONF_NAME.value)+" where Field="+sqlTo(snapSUM[1]));
					if(txtSnap)
					{
						//округлять сумму не имеет смысла
//						ExecuteSQL("update "+tblName+" set Fexpr="+sqlTo("Number("+getExprInd(txtSnap[0],txtSnap[1])+")")+" where Fwid="+snapSUM[0]);
						//20% НДС входит в сумму
						ExecuteSQL("update "+tblName+" set Fsource="+sqlTo(snapSUM[1])
								+", Fexpr="+sqlTo(snapSUM[2]+"/"+ndspart)+" where Fwid="+fwidNDS);
					}
					else
						return false;
				break;
				case "DOC_SPLIT":
					var txtSnap = getSnap("select Fnum from TXT_"+allt(CONF_NAME.value)+" where Field="+sqlTo(snapSUM[1]));
					if(txtSnap)
					{
						//округлять сумму не имеет смысла
//						ExecuteSQL("update "+tblName+" set Fexpr="+sqlTo("Number(!{"+txtSnap[0]+"})")+" where Fwid="+snapSUM[0]);
						//20% НДС входит в сумму
						ExecuteSQL("update "+tblName+" set Fsource="+sqlTo(snapSUM[1])
								+", Fexpr="+sqlTo(snapSUM[2]+"/"+ndspart)+" where Fwid="+fwidNDS);
					}
					else
						return false;
				break;
				case "VAR":
					//округлять сумму не имеет смысла
//					ExecuteSQL("update "+tblName+" set Fexpr="+sqlTo("Number(!{"+snapSUM[1]+"})")+" where Fwid="+snapSUM[0]);
					//20% НДС входит в сумму
					ExecuteSQL("update "+tblName+" set Fsource="+sqlTo(snapSUM[1])
							+", Fexpr="+sqlTo(snapSUM[2]+"/"+ndspart)+" where Fwid="+fwidNDS);
				break;
			}
		}
		else
			return false;
		grid.getTable().requery();
		grid.refresh();
	}
	return true;
}

function cond_Valid()
{
	if(fstCond != COND.value)
	{
		var t = OpenTable("select * from "+tblName+" where Fexpr like("+sqlTo("%"+FLDNAME.value+fstCond+"%")+") ");
		for(; !t.IsEOF(); t.MoveNext())
		{
			var m = new Object();
			m.FEXPR = t.getValue("Fexpr").replace(FLDNAME.value+fstCond,FLDNAME.value+COND.value);
			UpdateTable(tblName, m, false, "Fwid="+t.getValue("Fwid"));
		}
		grid.getTable().requery();
		grid.refresh();
	}
	fstCond = COND.value;
	return true;
}

function rowtype_Valid()
{
	if(ROWTYPE.value == "VAR")
	{
		if(mode == "EDIT")
			Disable(SPLITTER);
		Disable(ROWSTART);
		Disable(ROWHEADER);
		LDOCBEGIN.setVisible(true);
		DOCBEGIN.setVisible(true);
		LDOCEND.setVisible(true);
		DOCEND.setVisible(true);
	}
	else
	{
		if(mode == "ADD")
		{
			Enable(ROWSTART);
			Enable(ROWHEADER);
		}
		LDOCBEGIN.setVisible(false);
		DOCBEGIN.setVisible(false);
		LDOCEND.setVisible(false);
		DOCEND.setVisible(false);
	}
	if(ROWTYPE.value != "DOC_IND")
	{
		LSPLITTER.setVisible(true);
		SPLITTER.setVisible(true);
		BTN_RANGE.setVisible(false);
	}
	else
	{
		LSPLITTER.setVisible(false);
		SPLITTER.setVisible(false);
		BTN_RANGE.setVisible(true);
	}
	if(sFileName && mode == "ADD")
		loadTxt();
	return true;
}

function rowstart_Valid()
{
	if(sFileName)
		loadTxt();
	return true;
}

function rowheader_Valid()
{
	if(sFileName)
		loadTxt();
	return true;
}

function splitter_Valid()
{
	if(SPLITTER.value == "")
	{
		WAIT(ru("Не указан разделитель!","Не вказано роздільник!"))
		return false;
	}
	if(SPLITTER.value.indexOf(" ")>-1 && !ignorSplitSpace)
	{
		if(confirm(ru("Разделитель содержит в себе пробелы! Вы уверены, что он коректен?",
					"Роздільник містить в собі пробіли! Ви упевнені, що він коректен?")))
			ignorSplitSpace = true;
		else
			return false;
	}
	return true;
}

function docbegin_Valid()
{
	if(DOCBEGIN.value == "")
	{
		WAIT(ru("Не указан текст начала документа!","Не вказано текст початку документа!"))
		return false;
	}
	return true;
}

function docend_Valid()
{
	if(DOCEND.value == "")
	{
		WAIT(ru("Не указан текст окончания документа!","Не вказано текст закінчення документа!"))
		return false;
	}
	return true;
}

function splitter_When()
{
	switch(String(ROWTYPE.value))
	{
		case "DOC_SPLIT":
			WAITTIMEOUT(ru("Укажите символ (комбинацию символов), разделяющий в строке файла значения переменных",
					"Вкажіть символ (комбінацію символів), що розділяє в рядку файлу значення змінних"),40);
		break;
		case "VAR":
			if(SPLITTER.value == "")
				SPLITTER.value = "=";
			WAITTIMEOUT(ru("Укажите символ (комбинацию символов), после которого в строке файла записано значение переменной",
					"Вкажіть символ (комбінацію символів), після якого в рядку файлу записано значення змінної"),40);
		break;
	}
}

function rowstart_When()
{
	WAITTIMEOUT(ru("Укажите номер строки, с которой начинаются данные в файле",
					"Вкажіть номер рядка, з якого починаються дані у файлі"),40);
}

function rowheader_When()
{
	WAITTIMEOUT(ru("Укажите номер строки, в которой перечислены заголовки переменных",
					"Вкажіть номер рядка, в якому перелічені заголовки змінних"),40);
}

function docbegin_When()
{
	WAITTIMEOUT(ru("Укажите текст, после которого начинается описание экземпляра документа в файле",
					"Вкажіть текст, після якого починається опис екземпляру документа у файлі"),40);
}

function docend_When()
{
	WAITTIMEOUT(ru("Укажите текст, которым заканчивается описание экземпляра документа в файле",
					"Вкажіть текст, яким закінчується опис екземпляру документа у файлі"),40);
}

function getType(sType)
{
	sType = String(sType).toLowerCase();
	switch(sType)
	{
		case "5":
			return "bit";		
		case "3":
			return "date";
		case "4":
			return "number";
		case "2":
			return "number";		
		case "1":
			return "string";		
		default:
			return sType;
	}
}

function filterMode(s)
{
	switch(s)
	{
		case "VIEW":
		case "COPY":
			return false;
		case "DEL":
		case "ADD":
		case "EDIT":
			return !isTxtMode;
	}
	return true;		
}

function listInitEditParam(par)
{
	par.tblSource = "TXT_"+allt(CONF_NAME.value);
	par.cond = getCond(FLDVAL.value);
	par.type = String(ROWTYPE.value);
	par.getExprInd = getExprInd;
	field = String(this.tbl.getValue("Field"));
	//если редактируется сумма, то определяем и идентификатор ндс, чтоб после редактирования их проапдейтить, используя toround_Valid()
	if(field=="HSUM")
	{
		fwidSUM = this.tbl.getValue("Fwid");
		var snapNDS = getSnap("select Fwid from "+tblName+" where Field="+sqlTo("HNDS"));
		if(snapNDS)
			fwidNDS = snapNDS[0];
	}
}

function getCond(val)
{
	val = allt(val);
	if((val[0]=="'" && val[val.length-1]=="'") || (val[0]=="\"" && val[val.length-1]=="\"") || String(val)==String(Number(val)))
		return FLDNAME.value+COND.value+val;
	else
		return FLDNAME.value+COND.value+"'"+val+"'";
}

function fldnameSelect()
{
	var par = new Object();
	par.ret = new Object();
	par.ret.FIELD = "";
	par.ret.FTXT = "";
	par.ret.FNUM = "";
	par.ret.FIND1 = "";
	par.ret.FIND2 = "";
	
	par.cells = new Object();

	par.cells[1] = new Object();
	par.cells[1].name = "FNUM";
	par.cells[1].width = 3;
	par.cells[1].text = UR("№|№");

	par.cells[2] = new Object();
	par.cells[2].name = "FIELD";
	par.cells[2].width = 10;
	par.cells[2].text = UR("Стовпчик|Столбик");	
	
	par.cells[3] = new Object();
	par.cells[3].name = "FTYPE";
	par.cells[3].width = 10;
	par.cells[3].text = UR("Тип|Тип");
	
	par.cells[4] = new Object();
	par.cells[4].name = "FTXT";
	par.cells[4].width = 10;
	par.cells[4].text = UR("Примітка|Примечание");
	
	if(ROWTYPE.value == "DOC_IND")
	{
		par.cells[5] = new Object();
		par.cells[5].name = "FIND1";
		par.cells[5].width = 6;
		par.cells[5].text = UR("Початок|Начало");
		
		par.cells[6] = new Object();
		par.cells[6].name = "FIND2";
		par.cells[6].width = 6;
		par.cells[6].text = UR("Кінець|Конец");
	}

	par.caption = UR("Джерело|Источник");
	t = OpenTable("select * from TXT_"+allt(CONF_NAME.value)+" order by Fnum");
	browse(t, par, SW_MODAL);
	t.close();
	if(par.ret.FIELD)
	{
		switch(String(ROWTYPE.value))
		{
			case "DOC_IND":
				FLDNAME.value = getExprInd(par.ret.FIND1,par.ret.FIND2);
			break;
			case "DOC_SPLIT":
				FLDNAME.value = "!{"+par.ret.FNUM+"}";
			break;
			case "VAR":
				FLDNAME.value = "!{"+par.ret.FIELD+"}";
			break;
		}
		return true;
	}
	else
		return false;
}

function fldFilterSelect()
{
	var par = new Object();
	par.ret = new Object();
	par.ret.FIELD = "";
	par.ret.FTXT = "";
	par.ret.FNUM = "";
	par.ret.FIND1 = "";
	par.ret.FIND2 = "";
	
	par.cells = new Object();

	par.cells[1] = new Object();
	par.cells[1].name = "FNUM";
	par.cells[1].width = 3;
	par.cells[1].text = UR("№|№");

	par.cells[2] = new Object();
	par.cells[2].name = "FIELD";
	par.cells[2].width = 10;
	par.cells[2].text = UR("Стовпчик|Столбик");	
	
	par.cells[3] = new Object();
	par.cells[3].name = "FTYPE";
	par.cells[3].width = 10;
	par.cells[3].text = UR("Тип|Тип");
	
	par.cells[4] = new Object();
	par.cells[4].name = "FTXT";
	par.cells[4].width = 10;
	par.cells[4].text = UR("Примітка|Примечание");
	
	if(ROWTYPE.value == "DOC_IND")
	{
		par.cells[5] = new Object();
		par.cells[5].name = "FIND1";
		par.cells[5].width = 6;
		par.cells[5].text = UR("Початок|Начало");
		
		par.cells[6] = new Object();
		par.cells[6].name = "FIND2";
		par.cells[6].width = 6;
		par.cells[6].text = UR("Кінець|Конец");
	}

	par.caption = UR("Джерело|Источник");
	t = OpenTable("select * from TXT_"+allt(CONF_NAME.value)+" order by Fnum");
	browse(t, par, SW_MODAL);
	t.close();
	if(par.ret.FIELD)
	{
		switch(String(ROWTYPE.value))
		{
			case "DOC_IND":
				FLD_FILTER.value = getExprInd(par.ret.FIND1,par.ret.FIND2);
			break;
			case "DOC_SPLIT":
				FLD_FILTER.value = "!{"+par.ret.FNUM+"}";
			break;
			case "VAR":
				FLD_FILTER.value = "!{"+par.ret.FIELD+"}";
			break;
		}
		fld_filter_Valid();
		return true;
	}
	else
		return false;
}

function save()
{
	if(isTxtMode)
	{
		alert(ru("Сперва загрузите переменные документа!","Спершу завантажте змінні документу!"));
		return false;
	}
	var snap = getSnap("select * from "+tblName+" where Fissel="+sqlTrue
			+" and (Fexpr is null or Fexpr="+sqlTo(" ")+")");
	if(snap)
	{
		alert(ru("Отредактируйте все поля с пустыми значениями либо удалите их.",
				"Відредагуйте усі поля з порожніми значенніми або вилучить їх."));
		return false;
	}
	fldname_Valid();
	fldval_Valid();
	//toround_Valid();
	cond_Valid();
	var sPath = getOrgPath() + "clbank/" +allt(CONF_NAME.value)+".xml"
	var xmlDoc = new DpXMLDOMDocument();
	//заносим в исходный xml файл необходимые настройки
	var xmlCLBANK = xmlDoc.createChild("CLBANK", null, {type:"TXT", encodding:ENCOD.value, row:ROWTYPE.value});
	xmlCLBANK.createChild("NAZN", NAZN.value);
	xmlCLBANK.createChild("REM", REM.value);
	switch(String(ROWTYPE.value))
	{
		case "DOC_IND":
			var xmlVARDOC = xmlCLBANK.createChild("VARDOC", null, {rowstart:ROWSTART.value});
		break;
		case "DOC_SPLIT":
			var xmlVARDOC = xmlCLBANK.createChild("VARDOC", null, {splitter:SPLITTER.value, rowstart:ROWSTART.value});
		break;
		case "VAR":
			var xmlVARDOC = xmlCLBANK.createChild("VARDOC", null, {docbegin:DOCBEGIN.value, docend:DOCEND.value, splitter:SPLITTER.value});
		break;
	}
	for(this.tbl.MoveFirst(); !this.tbl.IsEOF(); this.tbl.MoveNext())
		xmlVARDOC.createChild(this.tbl.getValue("FIELD"), this.tbl.getValue("FEXPR"));
	var fval = String(FLDVAL.value);
	fval = (String(Number(fval))==fval || (fval[0]=="'" && fval[fval.length-1]=="'") || (fval[0]=="\"" && fval[fval.length-1]=="\"")?fval:"\""+fval+"\"")+"?\"PV\":\"PP\"";
	xmlCLBANK.createChild("VARDOCEXPR", FLDNAME.value+COND.value+fval);
	xmlCLBANK.createChild("FILTER", FEXPR_FILTER.value);
	xmlCLBANK.createChild("FLD_FILTER", FLD_FILTER.value);
	xmlDoc.save(sPath);
	//таблицу настроек переменных платежек сохраняем в отдельную таблицу по имени настройки, для дальнейшей возможности редактирования
	var clbTbl = "CLB_"+allt(CONF_NAME.value);
	DropTable(clbTbl);
	ExecuteSQL("select * into "+clbTbl+" from "+tblName);
	FORM.close();
}

function listMenuInit()
{
	if(this.tbl.rowCount>0 && !isTxtMode)
		this.dataSrc.AddMenuItem("EDITEXPR","Редагувати вираз|Редактировать выражение");
}

function listMenuRun(ID)
{
	switch(ID)
	{
		case "EDITEXPR":
			var snap = getSnap("select Fexpr from "+tblName+" where Fwid="+this.tbl.getValue("Fwid"));
			var expr = ""
			if(snap)
				expr = snap[0];
			expr = input("",ru("Редактирование выражения","Редагування виразу"),expr,255);
			if(expr != null)
			{
				ExecuteSQL("update "+tblName+" set Fexpr="+sqlTo(expr)+" where Fwid="+this.tbl.getValue("Fwid"));
				list.tbl.requery();
				grid.refresh();
			}
		break;
	}
}

function escape()
{
	grid.getTable().close();
	FORM.close();
}

function setIsSel()
{
	ExecuteSQL("update TXT_"+allt(CONF_NAME.value)+" set Fissel="+sqlFalse)
	ExecuteSQL("update TXT_"+allt(CONF_NAME.value)+" set Fissel="+sqlTrue
			+" where Field in (select Fsource from "+tblName+") or Field="+sqlTo(FLDNAME.value))
}

function listDel()
{
//	if(docVarsAr.some( function(item){ return item==list.tbl.getValue("FIELD") } ) )
//	{
//		alert(ru("Удалять можно только переменные, добавленные вручную!","Вилучати можна тільки змінні, додані вручну!"));
//		return false;
//	}
	ExecuteSQL("update "+tblName+" set Fissel="+sqlFalse+" where Fwid="+this.tbl.getValue("Fwid"));
	return false;
}

function initRange()
{
	var par = new Object();
	par.tblName = tblRangeName;
	par.minVarCount = minVarCount;
	//найдем первую строчку, с которой можно считывать данные
	var sFile = String(ReadTxtFile(sFileName,ENCOD.value));
	var nNewLine = 0;
	var sLine = "";
	if (sFile.length != 0)
	{
		var lineNom = 1;
		while(sFile.length>0)
		{
			nNewLine = sFile.indexOf('\n');
			if(-1 == nNewLine)
			{
				sLine	= sFile;
				sFile	= "";
			}
			else
			{
				sLine	= sFile.substr(0, nNewLine);
				sFile	= sFile.substr(nNewLine+1);
			}
			//пропускаем строки идущие до указаной в ROWSTART
			if (lineNom++ >= ROWSTART.value)
			{
				par.str = sLine;
				break;
			}
		}
	}
	showWindow("l_txtrange.js", SW_MODAL, par);
	
	while(par.rowCount < minVarCount)
	{
		if(confirm(ru("Введено слишком мало диапазонов. Минимальное кол-во диапазонов: ","Введено дуже мало діапазонів. Мінімальна к-ть діапазонів: ")+minVarCount
			+"\n"+ru("Продолжить ввод данных?","Продовжити введення даних?")))
		{
			showWindow("l_txtrange.js", SW_MODAL, par);
		}
		else
			break;
	}
	rangeLength = par.rowCount;
	BTN_RANGE.text = UR("Редагувати діапазони|Редактировать диапазоны");
	loadTxt();
}

function rangeSplitStr(str,tblRange)
{
	var ret = new Array();
	if(IsTable(tblRange))
	{
		var t = OpenTable("select * from "+tblRange+" order by Find1,Find2");
		for(; !t.IsEOF(); t.MoveNext())
			ret[t.getValue("Find1")+"-"+t.getValue("Find2")] = str.substring(t.getValue("Find1")-1,t.getValue("Find2"));
		t.close();
	}
	return ret;
}

function getExprInd(i1,i2)
{
	if(i1 == i2 || i2 == null)
		return "!{"+i1+"}";
	else
		return "allt(!{"+i1+"-"+i2+"})";
}