include("Objects/DpClEx.js");

var srcTbl = getTmpTableName();

function listLoad()
{
	PROGRESSBAR.setMinimum(0);
	PROGRESSBAR.setMaximum(50);
	PROGRESSBAR.setSelection(1);
	
	this.showComment = showComment;
	grid.setSelHandler(this, "showComment");
	
	var sSQL = "create table "+ srcTbl 
				+" (FWID "+ sqlType("LONG") 
				+", FSYS "+ sqlType("TEXT", 50) 
				+", FMODULE "+ sqlType("TEXT", 250) 
				+", FTYPE "+ sqlType("TEXT", 50) 
				+", FNAME "+ sqlType("TEXT", 250) 
				+", FREM "+ sqlType("LONGTEXT")
				+", FCLCNT "+ sqlType("INT") 
				+", FTT "+ sqlType("TEXT", 25) 
				+")";
	ExecuteSQL(sSQL);
}

function listAfterLoad()
{
	runInThread(loadClVid);
}

function listTitle()
{
	return UR("Види довідників|Виды справочников");
}

function listSrc()
{
	this.qrySet("From", srcTbl,
				"Order", "FTT,FSYS,FMODULE,FTYPE,FNAME"
				);
}

function listDpGrid()
{
	grid.build();
}

function loadClVid()
{
	loadClVidFromDir(rootDirectoryEx()+"scripts/cls/");
	
	var arrModules = lpProxy.getModules();
	for (var i = 0; i < arrModules.length; i++)
	{
		if(arrModules[i])
			loadClVidFromModule(arrModules[i]);
	}
	stopProgress();
}

function loadClVidFromModule(moduleID)
{
	var sPath = lpProxy.getModulePath(moduleID);
	if(moduleID && sPath)
		loadClVidFromDir(sPath +"/scripts/cls/", moduleID);
}

function loadClVidFromDir(sDir, moduleID)
{
	loadProgress();
	var dir = new DpFile(sDir);
	if (!dir.exists()) 
		return;
	var sys = "COM";
	var curSys = getSystem().toUpperCase();
	if(dir.isDirectory())
	{
		var files = dir.listFiles();		
		for(i=0; i<files.length; i++)
		{
			var clFile = files[i];
			if(!clFile.isDirectory() || clFile.isHidden())
				continue;		
			
			var vid = String(clFile.getName())
			var sVid = (moduleID? moduleID +":" : "") + vid;
			if(vid=="nmkl")
				continue;
			
			var oCl = new DpClEx(sVid, 0);			
			if(oCl.isAbstract())
				continue;
			
			sys = oCl.jObj.getSys();
			if(vid.length == 3 && vid.indexOf("CL")!=-1)
				vid = vid.substring(2,3);
			
			var m = new Object();
			m.FWID	= GetUID();
			m.FSYS = (sys? sys : "COM");
			m.FMODULE = (moduleID? moduleID : "");
			m.FTYPE = vid;
			m.FNAME = oCl.getName();
			m.FCLCNT = clclCount(moduleID, vid);
			if(oCl.jObj.getClassAttribute)
				m.FREM = UR(oCl.jObj.getClassAttribute("rem"));
			m.FTT = "9";
			sys = String(sys).trim().toUpperCase();
			if(sys!="COM" && sys.indexOf(curSys)!=-1)
				m.FTT = "1";
			else if(moduleID && moduleID.toUpperCase().indexOf(curSys)!=-1)
				m.FTT = "1";
			else if(sys.indexOf("COM")!=-1)
				m.FTT = "2";
			updateTable(srcTbl, m, true);
		}
	}			
}

function clclCount(sModule, sType)
{
	if(sType)
	{
		if(sModule)
			sType = sModule +":"+ sType;
		sType = String(sType).trim().toUpperCase();
	}
	var oSnap = getSnap("select count(*) as cnt from ^CLCL where UPPER(FVID)="+ sqlTo(sType), false);
	if(oSnap && oSnap[0])
		return Number(oSnap[0]);
	return 0;
}

function loadProgress()
{		
	display.asyncExec
	(
		function runProg()
		{
			try
			{
				sMsg = UR("Завантаження довідників . . .|Загрузка справочников . . .");
				INFO.setText(sMsg);
				var nPr = PROGRESSBAR.getSelection()+1;
				PROGRESSBAR.setSelection(nPr);
				
				grid.getTable().requery();
				grid.getTable().setAbsolute(1);
				grid.refresh();
			}
			catch(e){}
		}
	);
}

function stopProgress()
{
	display.asyncExec
	(
		function stopProg()
		{
			try
			{
				sMsg = UR("Завантажено довідників: |Загружено справочников: ") + grid.getTable().recordCount;
				PROGRESSBAR.setSelection(100);
				INFO.setText(sMsg);
				grid.getTable().requery();
				grid.getTable().setAbsolute(1);
				grid.refresh();
				GRPROGRESS.setVisible(false);
				GRREM.setVisible(true);
			}
			catch(e){}
		}
	);
}

function showComment()
{
	try
	{
		FREM.value = "";
		var tbl = grid.getTable();
		if(!tbl.isEmpty())
			FREM.value = tbl.getValue("FNAME") +"\n"+ tbl.getValue("FREM");
	}
	catch(e){}
}

include("sys\\DpList.js");