include("objects/DpXMLDOMDocument.js");

function Load()
{
	Caption("Форми звітності|Формы отчётности");
	
	TBL.addColumn("num"," ",20);
	TBL.addColumn("name",UR("Назва|Название"),500);
	var mnuHandler = new Object();
	mnuHandler.fillMenu = menuInit;
	mnuHandler.runMenu = menuRun;
	TBL.setMenuFillHandler(mnuHandler,"fillMenu");
	TBL.setMenuRunHandler(mnuHandler,"runMenu");
	setHelp(TBL,"cl_report");
	fillTbl();
}

function fillTbl()
{
	fillFromPath(rootDirectoryEx() + "rpt");
	
	var arrModules = lpProxy.getModules();
	for (var i = 0; i < arrModules.length; i++)
	{
		var sPath = lpProxy.getModulePath(arrModules[i]) + "/rpt";		
		fillFromPath(sPath);
	}	
	
	fillFromPath(getOrgPath() + "/settings/rpt");
}

function fillFromPath(sPath)
{
	var dir = new DpFile(sPath);
	if (!dir.exists() || !dir.isDirectory())
		return;
			
	// enumerate xsd files in dir and create folder for each of them
	var fileList = dir.listFiles();
	for (var nF = 0; nF < fileList.length; nF++)
	{
		var curF = fileList[nF];
		if (curF.isDirectory())
			continue;
			
		//showObject(curF);
		var strName = String(curF.name).toUpperCase();
		if (strName.right(4) != ".XSD" || strName == "TYPES.XSD")
			continue;
			
		// xsd files founded
		var xmlDomXSD = new DpXMLDOMDocument();		
		if(!xmlDomXSD.load(curF.getPath()))
			continue;

		var root = xmlDomXSD.getDocumentElement();
		var nodes = root.getElementsByTagName("xs:documentation");
		if (nodes.length > 0)
		{
			var formName = String(nodes[0].getText());
			var folderName = formName.toLowerCase();
			// Замена кирилических букв на похожие латинские
			folderName = folderName.replace(/а/g, "a");
			folderName = folderName.replace(/б/g, "b");
			folderName = folderName.replace(/в/g, "v");
			folderName = folderName.replace(/г/g, "g");
			folderName = folderName.replace(/д/g, "d");
			folderName = folderName.replace(/е/g, "e");
			folderName = folderName.replace(/ё/g, "e");
			folderName = folderName.replace(/ж/g, "g");
			folderName = folderName.replace(/з/g, "z");
			folderName = folderName.replace(/и/g, "i");
			folderName = folderName.replace(/і/g, "i");
			folderName = folderName.replace(/ы/g, "i");
			folderName = folderName.replace(/й/g, "i");
			folderName = folderName.replace(/к/g, "k");
			folderName = folderName.replace(/л/g, "l");
			folderName = folderName.replace(/м/g, "m");
			folderName = folderName.replace(/н/g, "n");
			folderName = folderName.replace(/о/g, "o");
			folderName = folderName.replace(/п/g, "p");
			folderName = folderName.replace(/р/g, "r");
			folderName = folderName.replace(/с/g, "s");
			folderName = folderName.replace(/т/g, "t");
			folderName = folderName.replace(/у/g, "u");
			folderName = folderName.replace(/ф/g, "f");
			folderName = folderName.replace(/х/g, "x");
			folderName = folderName.replace(/ц/g, "ts");
			folderName = folderName.replace(/ч/g, "ch");
			folderName = folderName.replace(/ш/g, "sh");
			folderName = folderName.replace(/щ/g, "sch");
			folderName = folderName.replace(/э/g, "e");
			folderName = folderName.replace(/є/g, "e");
			folderName = folderName.replace(/ю/g, "u");
			folderName = folderName.replace(/я/g, "ya");
			folderName = folderName.replace(/ /g, "_");
			folderName = folderName.replace(/[а-я'",.:;~!@#$%^&*()?ї\n]/g, "");
			
			if (folderName.length > 50)
				folderName = folderName.left(50);
			folderName = String(input("Введите имя для нового отчета (латиница)", "Дебет Плюс, найден новый отчет в папке отчетов",folderName, 60));
			
			var i = 0;
			var fullFolderName;
			do
			{
				var slesh = "/";
				if (String(sPath).right(1) == "\\" || String(sPath).right(1) == "/")
					slesh = "";
					   
				fullFolderName = sPath + slesh + "com.debet." + folderName + (i == 0 ? "" : String(i));
				i++;
			}
			while (new DpFile(fullFolderName).exists() && i < 50)
			createDirectory(fullFolderName);
			
			var path = String(curF.path)
			strNewName = path.replace(path, fullFolderName + "/" + strName);
			if (copyFile(path, strNewName))
				deleteFile(path);
			// копируем и файл с правилами суммирования (если есть)
			var rulesPath = path.left(path.length - 4) + ".xml";
			var strNewRulesName = strNewName.left(strNewName.length - 4) + ".xml";
			if (new DpFile(rulesPath).exists())
			{
				if (copyFile(rulesPath, strNewRulesName))
					deleteFile(rulesPath);
			}
		}
	}
	
	// parse folders	
	fileList = dir.listFiles();
	for (var nF = 0; nF < fileList.length; nF++)
	{
		var curF = fileList[nF];
		if (!curF.isDirectory())
			continue;
		var repInf = parseRep(curF);
		if (repInf == null)
			continue;
		TBL.addItem(repInf.path);
		TBL.setValue(repInf.path,"name", (repInf.id ? repInf.id + " : " : "") + repInf.name);
	}
}

function parseRep(oDir)
{
	var frmRepPath = oDir.getPath() + "/frmrep.xml";	
	// create frmrep.xml if not exists (new form)
	if (!isFile(frmRepPath))
	{
		var dir = new DpFile(oDir.getPath());
		if (!dir.exists() || !dir.isDirectory())
			return;
				
		var fileList = dir.listFiles();
		for (var nF = 0; nF < fileList.length; nF++)
		{
			var curF = fileList[nF];
			var sName = String(curF.getName());

			if (curF.isDirectory())
				continue;

			if (sName.right(4).toLowerCase() == ".xsd")
			{
				var xmlDomXSD = new DpXMLDOMDocument();
				
				// Load xsd file
				var bLoaded = xmlDomXSD.load(oDir.getPath() + "/" + sName);
				if(!bLoaded)
				{
					alert("ERROR: Can not load file - " + oDir.getPath() + "/" + sName)
					break;
				}
				
				var formName = "Unknown";
				var root = xmlDomXSD.getDocumentElement();
				var nodes = root.getElementsByTagName("xs:documentation");
				if (nodes.length > 0)
					formName = nodes[0].getText();
				
				// Create frmrep.xml file by xsd
				var xmlDom = new DpXMLDOMDocument();
				// DpFrmRep
				var xmlFrmRep = xmlDom.createElement("DpFrmRep");
				xmlFrmRep.setAttribute("name", formName);
				xmlFrmRep.setAttribute("version", "1.0.1");				
				xmlDom.appendChild(xmlFrmRep);
				
				// input
				var xmlInput = xmlDom.createElement("input");
				xmlInput.setAttribute("mode", "r,FrmDocType,FrmDocCnt,FrmDocStan");
				xmlFrmRep.appendChild(xmlInput);
				var xmlDat1 = xmlDom.createElement("dat1");
				xmlDat1.setAttribute("type", "date");
				xmlDat1.setAttribute("rem", "Дата начала");
				xmlDat1.setAttribute("value", "dat1");
				xmlInput.appendChild(xmlDat1);
				var xmlDat2 = xmlDom.createElement("dat2");
				xmlDat2.setAttribute("type", "date");
				xmlDat2.setAttribute("rem", "Дата начала");
				xmlDat2.setAttribute("value", "dat2");
				xmlInput.appendChild(xmlDat2);
				var xmlPar = xmlDom.createElement("DocType");
				xmlPar.setAttribute("rem", "Номер виправного документу");
				xmlPar.setAttribute("value", "FrmDocType");
				xmlInput.appendChild(xmlPar);
				var xmlPar = xmlDom.createElement("DocCnt");
				xmlPar.setAttribute("rem", "Номер документа у періоді");
				xmlPar.setAttribute("value", "FrmDocCnt");
				xmlInput.appendChild(xmlPar);
				var xmlPar = xmlDom.createElement("DocStan");
				xmlPar.setAttribute("rem", "Стан документу");
				xmlPar.setAttribute("value", "FrmDocStan");
				xmlInput.appendChild(xmlPar);
				
				// vars
				var xmlVars = xmlDom.createElement("vars");
				xmlFrmRep.appendChild(xmlVars);
				var nodes = root.getElementsByTagName("xs:element");
				for (var i = 0; i < nodes.length; i++)
				{
					var varName = String(nodes[i].getAttribute("name"));
					varName = varName.toUpperCase();
					if (varName == "DECLAR" || varName == "DECLARHEAD" ||
						varName == "DECLARBODY")
					{
						continue;
					}
					
					var xmlVar = xmlDom.createElement("var");
					xmlVar.setAttribute("name", varName);
					if (isOrgVar(varName))
					{
						xmlVar.setText("getOrgVar('" + varName +"', true)");
						var varRem = getOrgVarRem(varName, true);
						if (varRem != null)
							xmlVar.setAttribute("rem", getOrgVarRem(varName, true));
					}
					
					var attrValue = String(nodes[i].getAttribute("nillable"));
					if (attrValue != "")
						xmlVar.setAttribute("nillable", attrValue);
					attrValue = String(nodes[i].getAttribute("minOccurs"));
					if (attrValue != "")
						xmlVar.setAttribute("minOccurs", attrValue);
					attrValue = String(nodes[i].getAttribute("maxOccurs"));
					if (attrValue != "")
						xmlVar.setAttribute("maxOccurs", attrValue);
					attrValue = String(nodes[i].getAttribute("type"));
					if (attrValue != "")
						xmlVar.setAttribute("type", attrValue);
					attrValue = String(nodes[i].getAttribute("fixed"));
					if (attrValue != "")
						xmlVar.setAttribute("fixed", attrValue);					
					xmlVars.appendChild(xmlVar);
				}
				// forms
				var xmlForms = xmlDom.createElement("forms");
				xmlFrmRep.appendChild(xmlForms);
				// form
				var xmlForm = xmlDom.createElement("form");
				xmlForm.setAttribute("file",sName);
				xmlForms.appendChild(xmlForm);

				// Choices
				var xmlChoices = xmlDom.createElement("choices");
				xmlFrmRep.appendChild(xmlChoices);
				var nodes = root.getElementsByTagName("xs:choice");
				for (var i = 0; i < nodes.length; i++)
				{
					var xmlChoice = xmlDom.createElement("choice");
					xmlChoices.appendChild(xmlChoice);
					
					var choices = nodes[i].getChildNodes();
					for (var k = 0 ; k < choices.length; k++)
					{
						var xmlEl = xmlDom.createElement("element");
						xmlEl.setAttribute("name", String(choices[k].getAttribute("name")));					
						var attrValue = String(choices[k].getAttribute("nillable"));
						if (attrValue != "")
							xmlEl.setAttribute("nillable", attrValue);
						attrValue = String(choices[k].getAttribute("minOccurs"));
						if (attrValue != "")
							xmlEl.setAttribute("minOccurs", attrValue);
						attrValue = String(choices[k].getAttribute("maxOccurs"));
						if (attrValue != "")
							xmlEl.setAttribute("maxOccurs", attrValue);
						attrValue = String(choices[k].getAttribute("type"));
						if (attrValue != "")
							xmlEl.setAttribute("type", attrValue);
						attrValue = String(choices[k].getAttribute("fixed"));
						if (attrValue != "")
							xmlEl.setAttribute("fixed", attrValue);
						xmlChoice.appendChild(xmlEl);
					}
				}
				
				// rules	
				// Load xsd file
				var xmlDomRules = new DpXMLDOMDocument();
				var sRulesFile = sName.left(sName.length - 4) + ".xml";
				if(xmlDomRules.load(oDir.getPath() + "/" + sRulesFile))
				{
					var xmlrules = xmlDom.createElement("rules");
					xmlFrmRep.appendChild(xmlrules);
					var nodes = xmlDomRules.getDocumentElement().getElementsByTagName("rule");
					var arrExpr = new Array();
					for (var i = 0; i < nodes.length; i++)
					{
						var xmlrule = xmlDom.createElement("rule");

						var attrValue = String(nodes[i].getAttribute("rownum"));
						if (attrValue != "")
							xmlrule.setAttribute("rownum", attrValue);
						var attrValue = String(nodes[i].getAttribute("c_doc_rowc"));
						var sExpr = attrValue; 
						if (attrValue != "")
						{
							attrValue = attrValue.replace("^", "");
							xmlrule.setAttribute("c_doc_rowc", attrValue);
						}
						var attrValue = String(nodes[i].getAttribute("sign"));
						if (attrValue != "")
							xmlrule.setAttribute("sign", attrValue);
						var attrValue = String(nodes[i].getAttribute("expression"));
						if (attrValue != "")
						{
							// заменяем все уже распарсенные переменные на их значения
							for (var k in arrExpr)
							{
								if (k != "" && arrExpr[k] != "")
									attrValue = attrValue.replace(k, arrExpr[k]);
							}

							attrValue = attrValue.replace("SUM(", "SUMR(");
							do 
							{
								// Попытаемся найти переменные
								var nIndex1 = attrValue.indexOf("^");
								if (nIndex1 != -1 )
								{
									var nIndex2 = attrValue.indexOf("RXXXX", nIndex1);
									var nIndex3 = attrValue.indexOf("^", nIndex1 + 1);
									// проверяем, строковые переменные или нет 
									if (nIndex2 != -1 && (nIndex3== -1 || nIndex2 < nIndex3)) 
										attrValue = attrValue.substr(0, nIndex1) + "R" + attrValue.substr(nIndex1 + 1);
									else
										attrValue = attrValue.substr(0, nIndex1) + attrValue.substr(nIndex1 + 1);
								}
								else
								{
									break;
								}
							}
							while (true)

							arrExpr[sExpr] = attrValue;
							xmlrule.setAttribute("expression", attrValue);
						}
						var attrValue = String(nodes[i].getAttribute("expression"));
						if (attrValue != "")
						{
							var table_alias = "";

							var nIndex1 = -1;
							do 
							{
								// Попытаемся найти переменные
								nIndex1 = attrValue.indexOf("^", nIndex1 + 1);
								if (nIndex1 != -1 )
								{
									var nIndex2 = attrValue.indexOf("RXXXX", nIndex1);
									var nIndex3 = attrValue.indexOf("^", nIndex1 + 1);
									// проверяем, строковые переменные или нет 
									if (nIndex2 != -1 && (nIndex3== -1 || nIndex2 < nIndex3)) 
									{
										table_alias = attrValue.substring(nIndex1 + 1, nIndex2);
										break;
									}
								}
								else
								{
									break;
								}
							}
							while (true)

							if (table_alias != "")
								xmlrule.setAttribute("table_alias", table_alias);
						}
						
						var attrValue = String(nodes[i].getAttribute("description"));
						if (attrValue != "")
							xmlrule.setAttribute("description", attrValue);
						
						xmlrules.appendChild(xmlrule);
					}
				}

				xmlDom.save(frmRepPath);
				break;
			}
		}
	}
	// chck if file exists
	if (!isFile(frmRepPath))
		return null;
		
	var doc = openXmlFile(frmRepPath);
	var sName = String(doc.getDocumentElement().getAttribute("name"));
	var ret = new Object();
	ret.name = sName;
	ret.path = oDir.getPath();

	// get form id 
	var dir = new DpFile(oDir.getPath());
	if (dir.exists() && dir.isDirectory())
	{
		var fileList = dir.listFiles();
		for (var nF = 0; nF < fileList.length; nF++)
		{
			var sName = String(fileList[nF].getName());
			if (sName.right(4).toLowerCase() == ".xsd")
			{
				ret.id = sName.left(sName.length - 4);
				break;				
			}
		}
	}

	return ret;
}

function menuInit(toObject)
{
	if (TBL.getSelectedIDs().length <= 0)
		return false;
		
	toObject.AddMenuItem("RUN",UR("Виконати|Выполнить"));
	toObject.AddMenuItem("RUNEXISTS",UR("Виконати розраховану|Выполнить рассчитаную"));
	toObject.AddMenuItem("PRINTVARS",UR("Надрукувати змінні|Распечатать переменные"));
	toObject.AddMenuItem("EDITPLUG",UR("Редагувати|Редактировать"));
	toObject.AddMenuItem("LOADFROMSITE",UR("Завантажити з сайта|Загрузить с сайта"));
}

function menuRun(ID)
{
	var selID = TBL.getSelectedIDs();
	if (selID == null || selID.length <= 0)
		return;
	selID = selID[0];
	include("objects\\DpFrmRepPrinter.js");
	var printer = new DpFrmRepPrinter(selID,"1.0");
	if(ID == "RUN" || ID == "RUNEXISTS")
	{		
		printer.print(ID == "RUNEXISTS");
	}
	if(ID == "EDITPLUG")
	{
		printer.editRepDescr();
	}
	if(ID == "PRINTVARS")
	{
		printer.printVars();
	}
	if(ID == "LOADFROMSITE")
	{
		showWindow("siteexplorer.xml",SW_NOMODAL, {type:"rpt"});
	}
}