include("Objects/DpClEx.js");
include("doc/DpDoc.js");

var objCL;
var oRow = null;
var codCL = getPar("CODPLAT");
var clTblName = "CL_ORGCP";
var tblName = "^CL_ORGCP";
var tmpTblName = "TMP_CL_ORGCP";

function listLoad()
{
	this.title = UR("Контактні особи|Контактные лица");
    this.editTask = "cls/CL2/ORGCP/form.xml";      
    this.accEdit = accEdit;
    this.accDel = accDel;
    this.printLabel = "CONT";
    
    objCL = new DpClEx("CL2", codCL);
    
    createSrcTable();
}

function accEdit()
{
	if(list.tbl.getValue("FWID_CL")==list.tbl.getValue("FWID"))
		return "";
	return "AEVF";
}

function accDel()
{
	if(list.tbl.getValue("FWID_CL")==list.tbl.getValue("FWID"))
		return false;
	return true;
}

function createSrcTable()
{
	WAIT(UR("Завантаження даних...|Загрузка данных..."));
	
	if(!ExecuteSQL("drop table "+ tmpTblName, false))
		ExecuteSQL("delete from "+ tmpTblName, false);
		
	var sSQL = "create table "+ tmpTblName 
			+" (FCOD "+ sqlType("LONG") +" default 0"
			+", FTXT "+ sqlType("LONGTEXT")
			+", FOKPO "+ sqlType("TEXT") +" default "+ SqlEmpStr
			+", FCAT "+ sqlType("INT") +" default 0"
			+", FCAT_TXT "+ sqlType("TEXT", 5) +" default "+ SqlEmpStr
			+", FORG_PHONE "+ sqlType("TEXT") +" default "+ SqlEmpStr
			+", FORG_EMAIL "+ sqlType("TEXT") +" default "+ SqlEmpStr
			+", FWID_CL "+ sqlType("LONG") +" default 0"
			+", FFIO "+ sqlType("LONGTEXT")
			+", FPHONE "+ sqlType("TEXT") +" default "+ SqlEmpStr
			+", FEMAIL "+ sqlType("TEXT") +" default "+ SqlEmpStr
			+", FSEX "+ sqlType("TEXT", 3) +" default "+ SqlEmpStr
			+", FTAXNUM "+ sqlType("TEXT") +" default "+ SqlEmpStr
			+", FPOST "+ sqlType("TEXT") +" default "+ SqlEmpStr
			+", FNOTE "+ sqlType("LONGTEXT")
			+", FMANAGER "+ sqlType("LONG") +" default 0"
			+", FMANAGER_TXT "+ sqlType("LONGTEXT")
			+", FBIRTH "+ sqlType("DATE")
			+", FNOTIFY_DOCS "+ sqlType("BIT")
			+", FNOTIFY_DEBT "+ sqlType("BIT")
			+", FNOTIFY_OTHER "+ sqlType("BIT")
			+", FNOTIFY_OTHER_TXT "+ sqlType("TEXT")
			+", FWID "+ sqlType("LONG") +" default 0"
			+")";
	ExecuteSQL(sSQL, false);
	
	//загрузка контрагентов
	sSQL = "insert into "+ tmpTblName +"(FWID,FWID_CL,FCOD,FTXT,FCAT,FCAT_TXT,FORG_EMAIL,FORG_PHONE,FOKPO,FEMAIL,FPHONE,FNOTE) "
				+" select cl.FWID,cl.FWID,rel.FCOD,cl.FTXT,post.FCAT,'юр',post.FEMAIL,post.FPHONE,post.FCOD_ST,post.FEMAIL,post.FPHONE,post.FNOTE "
				+" from ^CL cl "
				+" inner join ^CLRELCLCL rel on rel.FWID_CL=cl.FWID and rel.FCL=0"
				+" inner join ^CL_POST post on post.FWID_CL=cl.FWID "
				+" where cl.FWID>0";
	ExecuteSQL(sSQL);
	
	//загрузка контактов контрагентов
	sSQL = "insert into "+ tmpTblName +"(FWID,FWID_CL,FCOD,FTXT,FCAT,FCAT_TXT,FORG_EMAIL,FORG_PHONE,FOKPO"
					+",FEMAIL, FPHONE, FFIO, FSEX, FPOST, FNOTE, FMANAGER) "
				+" select cp.FWID, cl.FWID,rel.FCOD, cl.FTXT,post.FCAT,'юр',post.FEMAIL,post.FPHONE,post.FCOD_ST"
					+", cp.FEMAIL, cp.FPHONE, cp.FFIO, cp.FSEX, cp.FPOST, cp.FNOTE, cp.FMANAGER"
				+" from ^CL_ORGCP cp "
				+" inner join ^CL cl on cl.FWID=cp.FWID_CL "
				+" inner join ^CLRELCLCL rel on rel.FWID_CL=cl.FWID and rel.FCL=0"
				+" inner join ^CL_POST post on post.FWID_CL=cl.FWID ";
	ExecuteSQL(sSQL);
	
	//загрузка левых контактов, добавленных в список без контрагентов
	sSQL = "insert into "+ tmpTblName +"(FWID, FEMAIL, FPHONE, FFIO, FSEX, FPOST, FNOTE) "
				+" select cp.FWID, cp.FEMAIL, cp.FPHONE, cp.FFIO, cp.FSEX, cp.FPOST, cp.FNOTE"
				+" from ^CL_ORGCP cp "
				+" where FWID_CL=0 or FWID_CL is NULL";
	ExecuteSQL(sSQL);
	
	//категории
	ExecuteSQL("update "+ tmpTblName +" set FCAT_TXT="+ sqlTo(UR("фіз|физ")) +" where FCAT=1");
	
	//менеджер
	if(SUBD==MSSQL || SUBD == POSTGRE)
		ExecuteSQL("update "+ tmpTblName +" set FMANAGER_TXT=("
				+"select cl.FTXT from ^listcl3 cl "
				+" where cl.FCL="+ getPar("CODPERS") 
					+" and cl.FCOD="+ tmpTblName +".FMANAGER)"
				);
	else
		ExecuteSQL("update "+ tmpTblName +" as t set FMANAGER_TXT=("
				+"select cl.FTXT from ^listcl3 cl "
				+" where cl.FCL="+ getPar("CODPERS") 
					+" and cl.FCOD=t.FMANAGER)"
				);		
	
	CLEARWAIT();
}

function listSrc()
{
	var sWhere = "1=1";
	if(extPar && extPar.subWhere)
		sWhere += (" and " + extPar.subWhere);
	this.qrySet("From", tmpTblName
				, "Where", sWhere
				, "WhereArr", new Array("FWID_CL<>FWID")
				, "Order", "FTXT, "+ IIF("FWID_CL=FWID", 0, 1) +", FFIO"
				);
}

function listGrid()
{	
	include("Objects/DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	
	oGrid.defCond("=^FWID_CL==^FWID", "ORG");	
	oGrid.color(2, "ORG");
	
	with(oGrid.page())
	{
		with(group("Контрагент|Контрагент"))
		{
			//FieldEx("FCOD", "Код|Код", 5);
			FieldEx("FCOD", "Код|Код", 5, "", "", "", "CLS.CL2", "FCOD", "");
			FieldEx("FTXT", "Назва|Наименование", 15);
			FieldEx("FCAT_TXT", "Кат.", 5);
			//FieldEx("FOKPO", "Код ЄДРПОУ|Код ОКПО", 10);	//для ЧЕРЕДЫ
			//FieldEx("FORG_PHONE", "Телефон|Телефон", 10);
			//FieldEx("FORG_EMAIL", "E-mail|E-mail", 10);
		}
		FieldEx("FFIO", "Контактна особа|Контактное лицо", 15);		
		FieldEx("FPHONE", "Телефон|Телефон", 12);
		FieldEx("FEMAIL", "E-mail|E-mail", 12);
		FieldEx("FSEX", "Стать|Пол", 5);
		FieldEx("FPOST", "Посада|Должность", 12);
		with(group("Менеджер|Менеджер"))
		{
			FieldEx("FMANAGER", "Код|Код", 5);
			FieldEx("FMANAGER_TXT", "ПІБ|ФИО", 15);			
		}
		FieldEx("FNOTE", "Примітки|Примечания", 12);
	}
	
	oGrid.build();
	
	//oGrid.objGrid.getColumn(0).setColor(2);
	//oGrid.objGrid.getColumn(1).setColor(2); 
}

function listMenuInit(oGrid)
{
	if(!oGrid.getTable().isEmpty())
	{
		oGrid.AddMenuItem("FORM_TASK", "Сформувати завдання|Сформировать задания");
		oGrid.AddMenuItem("", "");
	}
}

function listMenuRun(sID)
{
	var tbl = list.tbl;
	var rowID = tbl.getValue("FWID");
	oRow = null;
	if(inList(sID, "ADD", "COPY", "EDIT"))
	{
		objCL.loadByID(tbl.getValue("FWID_CL"));
		if(sID=="EDIT")
			oRow = objCL.getRow("OCP", rowID);
		if(sID=="COPY")
			oRow = objCL.copyRow("OCP", rowID);	
		
		if(oRow)
			oRow.hasExt = new Function("return false");
		
		list.objParMenu.mode = sID;
		list.objParMenu.objCl = objCL;
		list.objParMenu.dpObj = oRow;
		list.objParMenu.tmpTblName = tmpTblName;
		list.objParMenu.tbl = tbl;
	}
	
	if(sID=="FORM_TASK")
	{
		var doc = "TASK";
		var nop = 1;
		
		var par = new Object();
		par.ret = new Object();
		par.ret.fdoc = doc;
		par.ret.fnop = null;
	
		par.escape = true;
		par.allSys = true;
		par.doc = doc;
		par.mode = "DOCONLY";
		par.title = "Виберіть папку|Выберите папку";
		showWindow("l_cl_lnk.xml", SW_MODAL, par);
		if(par.escape)
			return;
			
		nop = par.ret.fnop;		
		
		if(grid.getSelectedCount())
		{
			var sName = UR("Назва|Название");
			var sCapt = UR("Введіть назву завдання|Введите название задания");
			var sTxt = input(sName, sCapt, "", 254);
			if(sTxt==null)
				return false;
			
			WAIT(UR("Формування завдань|Формирование заданий"));
			var sWhere = " where "+ grid.getSqlSelected();
			var tblCont = OpenTable("select * from "+ tmpTblName + sWhere);
			var nDoc = 0;
			for(; !tblCont.IsEOF(); tblCont.MoveNext())
			{
				WAIT(UR("Формування завдань: |Формирование заданий: ") + (nDoc+1) +"/"+ tblCont.recordCount);
				var oDoc = new DpDoc(doc, nop);
				oDoc.setVar("HNOM", oDoc.getAutoNo().get());
				oDoc.setVar("HCUSTOMER", tblCont.getValue("FCOD"));
				if(tblCont.getValue("FWID_CL")!=tblCont.getValue("FWID"))
					oDoc.setVar("HCONT", tblCont.getValue("FWID"));
				oDoc.setVar("HCAPTION", sTxt);
				oDoc.setVar("HSTATUS", 1);			
				bRet = oDoc.save(false, "ADD");
				if(!bRet && !confirm("Продовжити?|Продолжить?"))
					break;
				nDoc++;
			}
			tblCont.close();
			CLEARWAIT();
			var sMsg = UR("Сформовано завдань: |Сформировано заданий: ") + nDoc;
			sMsg += UR("\nВідкрити список завдань?|\nОткрыть список заданий?");
			par = new Object();
			par.doc = doc;
			par.nop = nop;
			par.bdat = new Date().getVarDate();
			par.edat = d00;
			if(confirm(sMsg))
				showWindow("l_docekz.xml", SW_NOMODAL, par);
			return;
		}
		
		var orgID = this.tbl.getValue("FWID_CL");
		var cntID = this.tbl.getValue("FWID");
		
		var oPar = new Object();
		oPar.org = this.tbl.getValue("FCOD");
		oPar.orgID = orgID;
		if(cntID!=orgID)
			oPar.cntID = cntID;
				
		var oDoc = new DpDoc(doc, nop);
		oDoc.edit("ADD", null, oPar);		
	}
}

function listDel()
{
	var rowID = list.tbl.getValue("FWID");
	if(objCL)
		objCL.deleteRow("OCP", rowID);
	ExecuteSQL("delete from "+ tblName +" where fwid="+ rowID, false);
	ExecuteSQL("delete from "+ tmpTblName +" where fwid="+ rowID, false);
}

function listAfterMenuHandler(sID)
{
	if(inList(sID, "ADD", "COPY", "EDIT", "DEL"))
	{		
		if(oRow)
		{
			obj2DB(oRow.getID(), oRow.jObj, null, tblName);			
			if(objCL)
			{
				if(inList(sID, "ADD", "COPY"))
					objCL.appendRow("OCP", oRow);
				objCL.save(sID, false);		
			}
		}		
	}
}

include("sys/DpList.js");