include("Objects/DpGrid.js");

var oOrg;
var oNode;
var oStreet;
var oHouse;

function listLoad()
{
	//this.editTask = "e_counter.xml";
	this.accEdit = counterEdit;
	this.accDel = counterDel;
	this.xmlGridFile = "l_counters.xml";
	
	oOrg = new DpCl("0", getPar("CODPLAT"), 0);
	oOrg.linkSmartCtrl(FORG);
	oOrg.setContAssist();
	oOrg.addFldSearchSmart("FOUTID");
	oOrg.isExactSearchSmart = true;
	if(getPar("VDKORGCAT")!=null)
		FCAT.value = Number(getPar("VDKORGCAT"));
	setValid(FCAT, orgcatValid);
	orgcatValid();
	if(extPar.org)
		oOrg.setCod(extPar.org);
	//oOrg.AfterUpdate = filter;
		
	oNode = new DpCl("0");
	oNode.setClcl(getPar("CODNODE"));
	/*
	oNode.linkSmartCtrl(FNODE);
	oNode.setContAssist();
	if(extPar.node)
		oNode.setCod(extPar.node);
	oNode.AfterUpdate = filter;
	if(!getPar("CODNODE"))*/
		GRNODE.setVisible(false);
	
	oStreet = new DpCl("0");
	oStreet.setClcl(getPar("CODSTREET"));
	oStreet.linkSmartCtrl(FSTREET);
	oStreet.setContAssist();
	if(extPar.street)
		oStreet.setFWID(extPar.street);
	oStreet.AfterUpdate = filter;
	
	oHouse = new DpCl("0", getPar("CODHOUSE"), 0, oStreet);
	oHouse.linkSmartCtrl(FHOUSE);
	oHouse.setContAssist();
	oHouse.addFldSearchSmart("FNOM");
	oHouse.isExactSearchSmart = true;
	oHouse.isCodeSearchSmart = false;
	if(extPar.house)
		oHouse.setFWID(extPar.house);
	oHouse.AfterUpdate = filter;
	
	DATB.value = firstDay(today);
	DATE.value = lastDay(today);
	if(extPar.date)
	{
		DATB.value = firstDay(extPar.date);
		DATE.value = lastDay(extPar.date);
	}
	if(extPar.bdat)
		DATB.value = extPar.bdat;
	if(extPar.edat)
		DATE.value = extPar.edat;
	if(extPar.type)
		FTYPE.value = extPar.type;
	if(extPar.serv)
		FSERV.value = extPar.serv;
	
	this.filter = filter;
	setButton(BTNFILTER, this, "filter");
	setValid(TYPEPER, onChangePeriod);
	setValid(DATB, date_valid);
	setValid(DATE, date_valid);
}

function orgcatValid()
{
	if(FCAT.value=="0" && getPar("VDKCODORG"))
		oOrg.setClcl(getPar("VDKCODORG"));
	else
		oOrg.setClcl(getPar("CODPLAT"));
}

function counterEdit()
{
	if(canEdit())
		return "AE";
	return "A";
}

function counterDel()
{
	if(getPar("HOCPREVEDIT"))
		return true;
	return false;
}

function canEdit(m)
{
	if(getPar("HOCPREVEDIT"))
		return true;
	if(m=="DEL")
		return false;
	//return true;
	var date = list.tbl.getValue("FREGDATE");
	if(!date)
		return true;
	var d1 = firstDay(goMonth(today, -1));
	var d2 = lastDay(today);
	//if(differ(date,d1)<0)
	//	return false;
	d1 = firstDay(date);
	d2 = lastDay(date);
	var fid_dog = Number(list.tbl.getValue("FID_DOG"));
	if(!fid_dog && !__isRazv)
		return false;
	var oSnap = getSnap("select FWID from ^RAS_SKU"	
				+" where FDOC_DAT>="+ sqlTo(d1) 
					+" and FDOC_DAT<="+ sqlTo(d2) 
					+(fid_dog? " and FID_DOG="+ fid_dog : "")
				, false
				);
	if(oSnap)
		return false;
	return true;
}

function listInitEditParam(par)
{
	par.org = oOrg.getCod();
	par.node = oNode.getCod();
	par.street = oStreet.getFWID();
	par.house = oHouse.getFWID();
}

function listTitle()
{
	return UR("Показники лічильників|Показания счетчиков");
}

function listSrc()
{
	this.qrySet("From", "^COUNTERS"
				, "Where", currWhere()
				, "Order", "FORG, FID_DOG, FREGDATE, FSERV, FCOUNTER, FWID"
				);
	this.clTie("org", "="+ getPar("CODPLAT") +", FORG");
	this.clTie("node", "="+ getPar("CODNODE") +", FNODE");
	this.subTie("CL", "str", "FWID", "FSTREET");
	this.subTie("CL_HOUSE", "house", "FWID_CL", "FHOUSE");
	this.subTie("CL_APARTMENT", "apt", "FWID_CL", "FAPMT");
	this.subTie("CONTRACT", "contr", "FWID", "FID_DOG");
	this.clTie("source", "="+ getPar("CODREGSOURCE") +", FSOURCE");
}

function currWhere()
{
	var dat1 = DATB.value;
	var dat2 = DATE.value;
	var sWhere = "1=1";
	if(differ(dat1, d00)==-1)
		sWhere += " and FREGDATE>="+ sqlTo(dat1);
	if(differ(dat2, d00)==-1)
		sWhere += " and FREGDATE<="+ sqlTo(dat2);
	if(oNode.getCod())
		sWhere += " and FNODE="+ oNode.getCod();
	if(oStreet.getCod())
		sWhere += " and FSTREET="+ oStreet.getFWID();
	if(oHouse.getFWID())
		sWhere += " and FHOUSE="+ oHouse.getFWID();
	if(oOrg.getCod())
		sWhere += " and FORG="+ oOrg.getCod();
	if(FCAT.value && Number(FCAT.value)!=2)
		sWhere += " and FORG in (select FCOD from ^LISTCLORG where FCAT="+ FCAT.value +")";
	var dogNum = String(FDOG_NUM.value).trim();
	if(dogNum!="")
		sWhere += " and FID_DOG in (select FWID from ^CONTRACT where FDOG_NUM="+ sqlTo(dogNum) +")";
	var cntType = Number(FTYPE.value);
	if(cntType)
		sWhere += " and FTYPE="+ cntType;
	if(FSERV.value && String(FSERV.value).trim()!="")
		sWhere += " and FSERV="+ sqlTo(FSERV.value);
	if(extPar.counter)
		sWhere += " and FCOUNTER="+ sqlTo(extPar.counter);
	if(extPar.source!=null)
		sWhere += " and FSOURCE="+ sqlTo(extPar.source);
	return sWhere;
}
/*
function listDpGrid()
{
	grid.build();
}
*/
function listMenuInit(ds)
{
	if(list.tbl.getValue("FID_DOG"))
		ds.AddMenuItem("LICSC", "Особовий рахунок|Лицевой счет");
	ds.AddMenuItem("BALANCE", "Баланс витрат|Баланс расходов");
	ds.AddMenuItem("SOURCETOTAL", "Підсумки по джерелах|Итоги по источникам");
	if(!list.tbl.isEmpty())
		ds.AddMenuItem("RECALC", "Корегувати|Корректировать");
	//ds.AddMenuItem("MASREG", "Масове введення|Массовый ввод");
	ds.AddMenuItem("SETNORM", "Встановити норму|Установить норму");
	ds.AddMenuItem("REINIT", "Завантажити початкові показники|Загрузить начальные показания");
	ds.AddMenuItem("", "");
	ds.AddMenuItem("ADD", "Додати|Добавить");
	if(canEdit())
		ds.AddMenuItem("EDIT", "Редагувати|Редактировать");
	//else
	//	ds.AddMenuItem("VIEW", "Перегляд|Просмотр");
}

function listMenuRun(sMenuID)
{
	var sTblName = list.tbl.getTableName();
	var par = new Object();
	par.mode = sMenuID;
	par.m_pTable = list.tbl;
	par.org = oOrg.getCod();
	par.node = oNode.getCod();
	par.street = oStreet.getFWID();
	par.house = oHouse.getFWID();
	par.serv = FSERV.value;
	if(sMenuID=="ADD")
	{
		showWindow("reg_counters.xml", SW_MODAL, par);
		if(par.escape)
			return DpList_exit;
		//list.tbl.requery();
		//grid.refresh();
		return true;
	}
	
	if(sMenuID=="RECALC")
	{
		par.tbl = list.tbl;
		par.date = list.tbl.getValue("FREGDATE");
		//par.fid_dog = list.tbl.getValue("FID_DOG");
		par.org = list.tbl.getValue("FORG");
		par.where = "FWID="+ list.tbl.getValue("FWID");
		if(grid.getSelectedCount()>0)
			par.where = grid.getSqlSelected();
		showWindow("reg_counters.xml", SW_MODAL, par);
		if(par.escape)
			return DpList_exit;
		list.tbl.requery();
		grid.refresh();
		return true;
	}
	
	if(sMenuID=="EDIT" || sMenuID=="VIEW")
	{
		if(sMenuID=="EDIT" && !canEdit())
			return DpList_exit;
		showWindow("e_counter.xml", SW_MODAL, par);
		if(par.escape)
			return DpList_exit;
	}
	
	if(sMenuID=="BALANCE")
	{
		par.node = list.tbl.getValue("FNODE");
		par.street = list.tbl.getValue("FSTREET");
		par.house = list.tbl.getValue("FHOUSE");
		//par.fid_dog = list.tbl.getValue("FID_DOG");
		par.fid_par = Number(list.tbl.getValue("FID_PAR"));
		par.serv = list.tbl.getValue("FSERV");
		par.date = list.tbl.getValue("FREGDATE");
		par.rdate = list.tbl.getValue("FREGDATE");
		showWindow("reg_counters.xml", SW_MODAL, par);
	}
	
	if(sMenuID=="SOURCETOTAL")
	{
		/*
		par.node = list.tbl.getValue("FNODE");
		par.street = list.tbl.getValue("FSTREET");
		par.house = list.tbl.getValue("FHOUSE");
		par.fid_par = Number(list.tbl.getValue("FID_PAR"));
		par.serv = list.tbl.getValue("FSERV");
		*/ 
		par.date = list.tbl.getValue("FDATE");
		showWindow("r_ku_source.xml", SW_NOMODAL, par);
	}
	
	if(sMenuID=="SETNORM")
	{
		var norm = list.tbl.getValue("FNORM");
		norm = input("Норма", "", norm, 2, 3);
		if(norm==null)
			return;
		var rowID = list.tbl.getValue("FWID");
		var fid_dog = list.tbl.getValue("FID_DOG");
		var house = list.tbl.getValue("FHOUSE");
		var serv = list.tbl.getValue("FSERV");
		var date = list.tbl.getValue("FDATE");
		ExecuteSQL("update "+ sTblName +" set FNORM="+ norm +" where FWID="+ rowID);
		if(Number(fid_dog)==0 && house)
			ExecuteSQL("update "+ sTblName +" set FNORM="+ norm +" where FHOUSE="+ house +" and FSERV="+ sqlTo(serv) +" and FDATE="+ sqlTo(date));
		var nRow = grid.getRowSelected();
		list.tbl.requery();
		grid.setRowSelected(nRow);
		grid.refresh();
	}
	
	if(sMenuID=="LICSC")
	{
		var fid_dog = list.tbl.getValue("FID_DOG");
		if(!fid_dog)
			return DpList_exit;
		include("doc/DpDoc.js");
		var oDoc = new DpDoc("LICSC", 1);
		oDoc.edit("EDIT", fid_dog);
		return DpList_exit;
	}
	
	if(sMenuID=="REINIT")
	{
		ExecuteSQL("delete from ^COUNTERS where FINIT="+ sqlTrue +" and FDIFFERENCE=0");
		ExecuteSQL("INSERT INTO ^COUNTERS (FCOUNTER,FNUM,FTYPE,FSERIAL,FPLACE,FSERV,FID_DOG"
						+",FORG,FNODE,FSTREET,FHOUSE,FAPMT,FDATE,FREGDATE,FYEAR,FMONTH"
						+",FCURRENT,FPREVIOUS,FDIFFERENCE,FINIT)"
					+" SELECT c.FWID,c.FNUM,c.FTYPE,c.FSERIAL,c.FPLACE,c.FSERV,c.FID_DOG"
						+",cnt.FORG,l.FNODE,l.FSTREET,l.FHOUSE,l.FAPMT,c.FBDAT"
						+",c.FBDAT,"+ sqlYear("c.FBDAT") +","+ sqlYear("c.FBDAT") 
						+", FINDICE, 0, 0, "+ sqlTrue
					+"  FROM ^SC_COUNTERS c inner join ^CONTRACT cnt on cnt.FWID=c.FID_DOG"
						+" inner join ^LICSC l on l.FID_DOG=c.FID_DOG"
					+" where FINDICE>0 and FID_CNT=0"
					);
	}
}

function filter()
{
	list.qryWhere = currWhere();
	list.tblInit();
}

function date_valid()
{
	TYPEPER.value = "";
}

function onChangePeriod()
{
	var per = String(TYPEPER.value);
	switch (per)
	{
		case "TD":
			DATB.value = today.getVarDate();
			DATE.value = today.getVarDate();
			break;
		case "YTD":
			DATB.value = goDay(today, -1);
			DATE.value = goDay(today, -1);
			break;
		case "TW":
			DATB.value = goDay(today, -today.getDay());
			DATE.value = goDay(today,6 - today.getDay());
			break;
		case "TM":
			DATB.value = firstDayMonth(today);
			DATE.value = lastDayMonth(today);
			break;
		case "LM":
			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
			DATE.value = lastDayMonth(_dateTrans(today, "M+", -1));
			break;
		case "2M":
			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
			DATE.value = lastDayMonth(today);
			break;		
		case "TY":
			DATB.value = jan01(today);
			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "2Y":
			var bdat = new Date(today.getFullYear()-1, today.getMonth());
			DATB.value = jan01(bdat);
			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "ALL":
			DATB.value = d00min;
			DATE.value = d00;
			break;
		default:
			break;
	}
	filter();
}

include("sys/DpList.js");