include("objects/DpXMLDomDocument.js");
include("Objects/DpGrid.js");

var oRow;
var oDoc;
var docID;
var sDir;
var sTblName;
var sRowClass;
var sFldID = "FID_DOC";
var sRowList = "rowlist.xml";
var varMap = new Object();

function listLoad()
{
	oDoc = extPar.oDoc;
	oRow = extPar.oRow;
	sRowClass = extPar.sRowClass;
	
	if(!extPar.docID)
		extPar.docID = oDoc.getID();
	if(!sRowClass)
		sRowClass = oDoc.getChildIDs()[0];
	if(!oRow)
		oRow = oDoc.jDoc.createChild(sRowClass);	
	
	this.title = UR("Рядки документу|Строки документа");
	if(oDoc)
		this.title += ": "+ oDoc.getOName();
			
	sDir = oDoc.getClassDefPath();	
	
	if(isFile(sDir +"/"+ sRowClass +"/list.xml"))
		sRowList = sRowClass +"/list.xml";
	if(!isFile(sDir +"/"+ sRowList))
		sRowList = sRowClass.toLowerCase() +"list.xml";
	//if(!isFile(sDir +"/"+ sRowList))
	//	return false;
			
	if (typeOf(FORM) == "DpViewPart")
	{
		this.onMessage = onMessage;
		FORM.setMessageHandler(this, "onMessage")
	}
	this.accDel = new Function ("return false");
}

function onMessage(sType, oPar)
{
	extPar.sRowClass = oPar.sRowClass;
	extPar.oRow = oPar.oRow;
	extPar.oDoc = oPar.oDoc;	
	extPar.docID = oPar.docID;
	list.reLoad();
	if(oPar.grid)
		oPar.grid.setFocus();
}

function listSrc()
{
	var docID = extPar.docID;
	if(!docID)
		docID = 0;
	sTblName = getTblName();
	sFld = getListFields();
	
	this.qrySet("Fields", "*"
				,"From", sTblName
				,"Where", sFldID +"="+ docID);
	subTie(list);
	
	oDoc.loadByID(docID);
}

function listDpGrid(grid)
{	
	var oGrid = new DpGrid("NOCREATE");
	
	if(isFile(sDir +"/"+ sRowList))
	{
		oGrid.objGrid.setXMLDir(sDir);
		oGrid.setXMLFile(sRowList);	
	}
	else if(varMap)
	{
		for(sFld in varMap)
			oGrid.page().FieldEx(sFld, sFld, 10);
	}
		
	oGrid.build();
}

function getTblName()
{
	var sTbl = "";
	if(isFile(sDir +"/"+ sRowList))
	{
		var xmlDom = new DpXMLDOMDocument();
		xmlDom.load(sDir + sRowList);
		var listInfo = xmlDom.getDocumentElement();
		var xmlQuery = listInfo.getElementsByTagName("query")[0];
		if(xmlQuery)
		{
			var xmlFrom = xmlQuery.getElementsByTagName("from")[0];
			if(xmlFrom && xmlFrom.getText())
				return xmlFrom.getText();
		}
	}
	//var oRow = oDoc.jDoc.createChild(sRowClass);
	var mapper = oRow.getDefaultMapper()
	var tables = mapper.getTables();
	for(var n = 0; n < Number(tables.size()); n++)
	{
		sTbl += ",^"+ tables.get(n).name;
	}
	if(sTbl!="")
		sTbl = sTbl.substring(1);
	return sTbl;
}

function getListFields()
{
	var sFld = "";
	//var oRow = oDoc.jDoc.createChild(sRowClass);
	var mapper = oRow.getDefaultMapper()
	var fields = mapper.getFields();
	for(var n = 0; n < String(fields.size()); n++)
	{
		var sName = String(fields.get(n).name);
		var sTbl = String(fields.get(n).table);		
		sFld += ","+ sName;
		
		var sVar = String(fields.get(n).varName);
		sVar = sVar.toUpperCase();
		if(sVar=="PAR.ID" || sVar=="PAR.HID")
			sFldID = sName;
		
		varMap[sName.toUpperCase()] = sVar;
	}
	if(sFld=="")
		sFld = "*";
	else
		sFld = sFld.substring(1);
	
	return sFld;
}

function subTie(list)
{
	if(!isFile(sDir +"/"+ sRowList))
		return;
		
	var xmlDom = new DpXMLDOMDocument();
	xmlDom.load(sDir + sRowList);
	var listInfo = xmlDom.getDocumentElement();
	
	list.extTie("H", this.sDocLbl, this.nNop);
	if (this.nNop != 0)
		list.extTieEx("ext0","FWID","H",this.sDocLbl);
	
	var xmlTies = listInfo.getElementsByTagName("ties")[0];
	if(!xmlTies) 
		return;

	var ties = xmlTies.getChildNodes();
	
	for(var i = 0; i < ties.length; i++)
	{
		var tie = ties[i];
		if (tie.getNodeName() == "cltie")
		{
			var sAlias = tie.getAttribute("alias");
			var sFields = tie.getAttribute("fields");
			var sVspAlias = tie.getAttribute("vspalias");
			if (sVspAlias)
				list.clTie(sAlias, sFields, sVspAlias);
			else
				list.clTie(sAlias,sFields);
		}
		
		if (tie.getNodeName() == "tie")
		{
			var sTable = tie.getAttribute("table");
			var sAlias = tie.getAttribute("alias");
			var sIndex = tie.getAttribute("index");
			var sFields = tie.getAttribute("fields");

			list.subTie(sTable, sAlias, sIndex, sFields);
		}
	}
}

function listMenuInit(ds)
{
	grid.AddMenuItem("ADD", "Додавання|Добавление");
	if(!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT", "Редагування|Редактирование");
		grid.AddMenuItem("COPY", "Копіювання|Копирование");
		grid.AddMenuItem("DEL", "Видалення|Удаление");	
	}
}

function listMenuRun(sID)
{
	var tblName = grid.getTable().getTableName();
	var rowID = Number(grid.getTable().getRowID());
	switch(sID)
	{
		case "DEL":
			if("-"!=msgBox("c-"
				, ru("Подтвердите удаление записи", "Підтвердіть вилучення запису")
				, ru("Удаление записи", "Вилучення запису")))
				break;			
			oDoc.deleteRow(sRowClass, rowID);						
			var sSQL = "DELETE FROM "+ tblName +" WHERE FWID="+ rowID;
			ExecuteSQL(sSQL);
			oDoc.save(true, "EDIT");
			break;
			
		case "__XDEL":	//массовое удаление 
			var delRowCount = DataSource().getSelectedCount();
			if (delRowCount <= 0)
				return;
			var selIds = DataSource().getSelectedIDs();
			var sCapt = ru("Удаление записей", "Видалення записів");
			var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів")+" (" + DataSource().getSelectedCount() + ").";
			if("c"==msgBox("c-", sMsg, sCapt))
				return;
			setProgressRange(0, delRowCount);
			for (var nRow = 0; nRow < selIds.length; nRow++)
			{
				setProgressPos(nRow + 1, sCapt +": "+ (nRow + 1) +"/"+ delRowCount);
				oDoc.deleteRow("ROW", Number(selIds[nRow]));				
			}
			var sSQL = "DELETE FROM "+ tblName +" WHERE "+ grid.sqlSelected()				 
			ExecuteSQL(sSQL);			
			grid.clearSelected();
			oDoc.save(true, "EDIT");
			setProgressPos(0);
			break;

		case "ADD": case "EDIT": case "COPY":		
			var oDocRow;
			
			if(sID == "ADD")
				oDocRow = oDoc.createRow(sRowClass);
			else if(sID == "EDIT")
				oDocRow = oDoc.getRow(sRowClass, rowID);
			else if(sID == "COPY")
				oDocRow = oDoc.copyRow(sRowClass, rowID);			
	
			var par = new Object();
			par.objDoc = oDoc;
			
			bSaveRow = false;								
			if(oDocRow != null)
				bSaveRow = oDocRow.edit(sID, par);
			if (bSaveRow)
			{
				if(inList(sID,"ADD","COPY"))
					oDoc.appendRow(sRowClass, oDocRow);
	
				obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, tblName);															
				oDoc.save(true, "EDIT");
			}									
			break;
	}
}

include("sys/DpList.js");