include("Objects/DpShtat.js");
include("Objects/DpShifPZ.js");
include("Objects/DpLicf.js");
include("Objects/DpCl.js");
include("prik/DpPrik.js");
include("get_cnst.js");

var GLOBAL_TABLE = extPar.GLOBAL_TABLE;
var tblName = extPar.tblName;
var dpShtat = null;
var dpShifPZ = null;
var dpLicf = null;
var table = null;
var hpz = 0;
var zat = 0;
var massAdd = false;
var sotrList = "";
var useDefValid = true;
var oPrik = null;
var ctrlIzd, oClIzd;
var prevClIzd = 0;

// private
var bSaveToXML = false;
var globalFields = getGlobalFieldsList();

function Load()
{
	Caption(UR(extPar.fnazv), extPar.mode);
	
	table = extPar.m_pTable;
	
	if (!extPar.mode)
	{		
		include("add_sotr.js");
		massAdd = true;
		extPar.mode = "ADD";
	}

	oPrik = new DpPrik(extPar.priklbl, extPar.fvid);
	this.oPrik = oPrik;
	
	var id = extPar.id;
	if(!id && table)
		id = Number(table.getValue("fwid"));
	
	if (inList(extPar.mode, "COPY", "EDIT", "VIEW"))
	{
		if(extPar.tblName.toUpperCase().indexOf("DLTU")==-1)
			oPrik.loadByID(id);
		else
			oPrik.loadByID(id,null,null,extPar.dat1);
        if (extPar.mode == "COPY")
        {
        	oPrik.clone();
        }
	}
	
	if (typeof prkLoad == "function")
		prkLoad();	
		
	switch (extPar.mode)
	{
		case "ADD":
		 	if (dpShtat != null && !dpShtat.getFwid())
		 	{
		 		dpShtat.setPeriod(extPar.dat1, extPar.dat2);
			 	dpShtat.setFwid(0);
		 	}
		 	if (dpShifPZ != null && !dpShifPZ.getFshpz())
		 		dpShifPZ.setFshpz(0);
		 	if (dpLicf != null && !dpLicf.getFnum())
		 		dpLicf.setFnum(0);
		 	if(extPar.fwid_wp)
		 		dpShtat.setFwid(extPar.fwid_wp);
		 	if(extPar.ffld_num)		 	
		 		dpLicf.setFnum(extPar.ffld_num);
		 	if(extPar.priklbl == "_BLNOBSH")
		 		HBDAT.value = extPar.dat1 = d00;
		 	else
		 	if(extPar.priklbl == "_SUM_2")
		 		HBDAT.value = goMonth(extPar.dat1,-1);
		 	else
		 	{
			 	if(extPar.dat1)
			 		HBDAT.value = extPar.dat1;
			 	else
			 		HBDAT.value = firstDayMonth(today);
		 	}
		break;
		case "EDIT":
		case "COPY":
		case "VIEW":
         	
         	if (!table) break;
         	if (dpShtat != null && !Number(dpShtat.getFwid()))
		 	{
         		if (typeof HBDAT != "undefined" && typeof HEDAT != "undefined"){
        		 	if(extPar.priklbl == "_DF1"){         			
             			dpShtat.setPeriod(firstDayMonth(HBDAT.getValue()), HBDAT.getValue());
        		 	}else{
        		 		dpShtat.setPeriod(HBDAT.getValue(), HEDAT.getValue());
        		 	}
         		}else{
         			if (table.getValue("fbdat") && table.getValue("fedat"))
         				dpShtat.setPeriod(table.getValue("fbdat"), table.getValue("fedat"));
         		}
	            dpShtat.setFwid(table.getValue("fwid_wp")); 
            }  
            if  (dpShifPZ && !dpShifPZ.getFshpz() && table.getValue("fshpz"))	
            {	
          		dpShifPZ.setFshpz(table.getValue("fshpz"));
 			}
           	if (dpLicf && !Number(dpLicf.getFid()) && table.getValue("flsfid"))	
          	{
          		dpLicf.setFid(table.getValue("flsfid"));
          	}
		break;	
	}
	
	//если есть параметр и ШПЗ, то добавляем контрол справочника изделий
	if(getPar("PRIK_IZD") && dpShifPZ)
	{
		var width = 400;
		var ctrlName = "HPRKCLIZD";
		var dlgBuilder = FORM.getDialogBuilder();
		dlgBuilder.addTextField(this.getExtPanel(),ctrlName,UR("Вироб|Изделие"),width);
		oClIzd = new DpCl("0");
		ctrlIzd = eval(ctrlName);
	 	oClIzd.linkSmartCtrl(ctrlIzd);
	 	oClIzd.setClcl(dpShifPZ.getClIzd());
	 	prevClIzd = dpShifPZ.getClIzd();
	 	oClIzd.setContAssist();
	 	setValid(dpShifPZ.ctrlShpz,validShpz);
	 	setWhen(ctrlIzd,whenIzd);
	 	switch (extPar.mode)
		{
			case "EDIT":
			case "COPY":
			case "VIEW":
	         	if (!table)
	         		break;
	         	oClIzd.setCod(table.getValue("fkodizd"));
			break;
		}
		validShpz();
	}
		
	if (useDefValid)
	{
		if (typeof  HBDAT != "undefined")
			setValid(HBDAT, fbdat_Valid);
		if (typeof HBDAT != "undefined" && typeof HEDAT != "undefined")
			setValid(HEDAT, fedat_Valid);	
	}
}

function validShpz()
{
	if(dpShifPZ.getClIzd()>0)
	{
		if(prevClIzd != dpShifPZ.getClIzd())
		{
			Enable(ctrlIzd);
			oClIzd.setClcl(dpShifPZ.getClIzd());
			prevClIzd = dpShifPZ.getClIzd()
		}
	}
	else
	{
		prevClIzd = 0;
		oClIzd.setClcl(0);
		Disable(ctrlIzd);
	}	
	return true;
}

function whenIzd()
{
	if(oClIzd.getCod()==0 && oClIzd.getClcl() && dpShifPZ.getCodIzd())
		oClIzd.setCod(dpShifPZ.getCodIzd());
	return true;
}

function onSave()
{
    //getHPZ();
        
    if (typeof prkSave == "function")
    {
    	var m = new Object();    	
    	var n = new Object();
    	var tName = "";
    	prkSave(m, n, tName);
    	if (!save(m, n, tName)) 
    		return false;
    	/*
    	if (massAdd)
    	{
    		var fields = getAbsenceFields(n, PRK_TXT_FIELDS);
    		if (fields.length == 0)
    		{
    			n.FWID = GetUID(); 
    			UpdateTable("^prk_txt", n, true);
    		}
    		else if (fields.length != PRK_TXT_FIELDS.length)
    			ERROR_PRK_TXT_SAVE(fields);
    	}
    	*/
    }
    /*	
	if (typeof singleSave == "function")
	{
		var m = new Object();
		if (extPar.mode != "EDIT")
			m.FWID = GetUID();
		else
			m.FWID = table.getValue("fwid");
		if (!singleSave(m))
			return false;
		UpdateTable(extPar.tblName, m, extPar.mode != "EDIT");		
		sotrList = m.FWID_WP;
	}
	
	if (massAdd && (typeof multiSave == "function"))
	{
		if (!multiSave())
			return false;
	}
		
	if (sotrList != "" && bSaveToXML === true)
		saveToXml();
		*/
}

function save(m, n)
{	
	var i = 0;
	for (var j in m)
		i++;
	if (i == 0)
	{
		if (sotrList != "")
			return ERROR_SAVE_OBJ();
		else
			return false;
	}
		
	var split = new Array();
	if (massAdd)
	{
		if (sotrList == "")
			return false;
		split = String(sotrList).split(",");
	}
	else
	{	
		split[0] = m.FWID_WP;
		sotrList = m.FWID_WP;
	}
	 
	var toSaveObj = null;
	var step = 1;
	if(split.length>1)
		setProgressRange(step, split.length);
	for (var i in split)
	{
		if(split.length>1)
			setProgressPos(step++, ru("Добавление приказов: ","Додавання наказів: ")+(step-1)+"/"+split.length);
		if (massAdd)
			toSaveObj = new DpPrik(extPar.priklbl, extPar.fvid);
		else
			toSaveObj = oPrik;
		
		if (typeof split[i] != "undefined")
			toSaveObj.setVar("FWID_WP", (typeof split[i] == "number" ? split[i] : Number(split[i].trim())));
		for (var j in m)
			if ((typeof m[j] == "object") && (objTypeOf(m[j]) == "Array"))
				toSaveObj.setVar(j, m[j][Number(toSaveObj.getVar("FWID_WP"))]);
			else
				toSaveObj.setVar(j, m[j]);
		if (typeof split[i] != "undefined")
		{
			toSaveObj.setVar("FSHPZ", getHPZ(toSaveObj.getVar("FWID_WP")))
		}

/*		var toSaveTable = extPar.tblName;
		if (tName && typeof tName == "string" && tName != "")
			toSaveTable = tName;
*/		
		savePrik(toSaveObj, n)
		//UpdateTable(toSaveTable, toSaveObj, extPar.mode != "EDIT");
		/*
		try
		{
			if (saveToGlobalTable(toSaveObj))
				saveToLocalTable(toSaveObj, toSaveTable);
			else
				return false;
		}
		catch(x)
		{
			ExecuteSQL("DELETE FROM " + GLOBAL_TABLE + " WHERE fwid=" + sqlTo(toSaveObj.FWID), false);
			ExecuteSQL("DELETE FROM " + toSaveTable + " WHERE fwid=" + sqlTo(toSaveObj.FWID), false);
			alert(UR("Тип помилки:\n|Тип оштбки:\n") + x.rhinoException.getLocalizedMessage(), ICON_ERROR);
			return false;
		}
		*/
	}
	if(split.length>1)
		setProgressPos(0);
	return true;
}

//параметр n - объект, хранящий дату таблицы в том случае, если
//приказ сохраняется помимо PRK_ALL, ещё в собственную таблицу, 
//название которой зависит от даты (например DLTU200602)
function savePrik(obj, n)
{
	obj.setVar("FIN_TABLE",extPar.sTableName.replace(/^/g,""));
	if(oClIzd)
		obj.setVar("FKODIZD",oClIzd.getCod());
	
	//при массовом добавлении проставлеям код изделия по умолчанию из справочника ШПЗ
	//if(getPar("PRIK_IZD") && sotrList != "")
	if(getPar("PRIK_IZD") && sotrList != "" && massAdd  && (oClIzd && oClIzd.getCod()==0))	
	{
		var snap = getSnap("select Fksprizd from ^SHIFRPZ where Fshpz="+sqlTo(obj.getVar("FSHPZ")));
		if(snap && snap[0])
			obj.setVar("FKODIZD",snap[0]);
	}
	var vid_prk = (toScrObj(obj.getVar("FVID_PRK")) ? toScrObj(obj.getVar("FVID_PRK")) : extPar.fvid);
	obj.setVar("FVID_PRK", vid_prk);
//если нужен будет FWID таблицы cl_prik, то его можно будет получить сджоинив с PRK_ALL по FVID_PRK=FVID
//FWID_PRIK будем использовать для хранения в больничных идентификатора на родительский упрощенный больничный и в упрощенных отпускных
//	var snap = getSnap("SELECT MAX(fwid) FROM ^cl_prik WHERE fvid=" + sqlTo(vid_prk), false);
//	if (snap != null)
//		obj.setVar("FWID_PRIK",snap[0]);
	
	if (!toScrObj(obj.getVar("FTABN_ID")) && toScrObj(obj.getVar("FWID_WP")))
	{
		snap = getSnap("SELECT MAX(fwid_cl) FROM ^work_pers WHERE fwid=" + sqlTo(toScrObj(obj.getVar("FWID_WP"))));
		if (snap != null)
		{
			obj.setVar("FTABN_ID", snap[0]);
			//для приказов на сберкассу проставляем номер счета из справочника и номер сберкассы (банка), если она не указана при массовом добавлении 
			if (typeof(n.FL_SCH) != "undefined")
			{
				var sn = getSnap("select Fschet_bnk, Fnum_bnk from ^cl_homo where Fwid_cl="+snap[0]);
				if(sn)
				{
					obj.setVar("FL_SCH", sn[0]);
					if(obj.getVar("FNUM")==0)
						obj.setVar("FNUM", sn[1]);
				}
			}
			//для приказов на сберкассу по местам перечислений (_castr) подставляем место преречислений с минимальным кодом 
			if (typeof(n.FWIDTR) != "undefined")
			{
				var tabn = getCodByID(obj.getVar("FTABN_ID"));
				obj.setVar("FTABN", tabn);
				var sn = getSnap("select Fwid from ^listcl where fcl="+getPar("CAS_TRPLACE")+" and Fcod1="+tabn
						+" and Fcod=(select MIN(Fcod) from ^listcl as r where r.Fcl="+getPar("CAS_TRPLACE")+" and r.Fcod1="+tabn+")");
				if(sn)
					obj.setVar("FWIDTR", sn[0]);
			}
		}
	}
	if (typeof(n.dateTbl) != "undefined")
		obj.save(null,null, n.dateTbl);
	else
		obj.save();
	
	if (extPar && extPar._retArray)
		extPar._retArray["FWID"]= obj.getID();
}

function saveToGlobalTable(m)
{
	var counter = 0;
	var saveObj = new Object();
	for (var i in m)
	{
		var field = String(i).toUpperCase();
		if (typeof globalFields[field] != "undefined" && globalFields[field] === true)
		{
			++counter;
			saveObj[field] = m[i];
		}			
	}	
	if (counter <= 0)
		return false;
	saveObj.FWID = m.FWID;	
	saveObj.FIN_TABLE = extPar.sTableName.replace(/^/g,"");
	var vid_prk = (saveObj.FVID_PRK ? saveObj.FVID_PRK : extPar.fvid);
//	var snap = getSnap("SELECT MAX(fwid) FROM ^cl_prik WHERE fvid=" + sqlTo(vid_prk));
//	if (snap != null)
//		saveObj.FWID_PRIK = snap[0];
	if (!saveObj.FTABN_ID && saveObj.FWID_WP)
	{
		snap = getSnap("SELECT MAX(fwid_cl) FROM ^work_pers WHERE fwid=" + sqlTo(saveObj.FWID_WP));
		if (snap != null)
			saveObj.FTABN_ID = snap[0];
	}
	UpdateTable(GLOBAL_TABLE, saveObj, extPar.mode != "EDIT");
	return true;
}

function saveToLocalTable(m, toSaveTable)
{
	var saveObj = new Object();
	for (var i in m)
	{
		var field = String(i).toUpperCase();
		if (typeof globalFields[field] == "undefined" || !(globalFields[field] === true))
			saveObj[field] = m[i];		
	}	
	saveObj.FWID = m.FWID;
	UpdateTable(toSaveTable, saveObj, extPar.mode != "EDIT");
	return true;	
}

function saveToXml(m)
{
		var m = new Object();
		if (typeof prkSaveToXml == "function")
			prkSaveToXml(m);
		else
			return;
		if (!m.ID)
		{
			alert(ERROR_SAVE_TO_XML, ICON_ERROR);
			return;
		}
		// BEGIN >> Сохранение приказов в XML
		var strSQL = "SELECT fwid_cl, fwid FROM ^work_pers WHERE fwid IN (" + sotrList + ")";
		var tmpTable = OpenTable("s", strSQL);
		if (!tmpTable.isEmpty())
		{
			var l = 0;
			setProgressRange(0, tmpTable.getRowCount());	
			setProgressText(UR("Збереження в XML...|Сохранение в XML..."));		
			var objDoc = new DpDoc("com.debet.cdr.pf", 0);
			for (tmpTable.MoveFirst(); !tmpTable.isEOF(); tmpTable.MoveNext())
			{
				objDoc.clear();
				objDoc.loadByID(tmpTable.getValue("fwid_cl"));
				var objPrk = objDoc.createPrk();
				objPrk.setID(m.ID);
				for (var i in m)
					if ((typeof m[i] == "object") && (objTypeOf(m[i]) == "Array"))
						objPrk.setAttribute(String(i).toLowerCase(), m[i][Number(tmpTable.getValue("fwid"))]);
					else
						objPrk.setAttribute(String(i).toLowerCase(), m[i]);
				if (String(objPrk.getAttribute(String(i).toLowerCase())) == "")	
					objPrk.setAttribute("prk", extPar.tblName);
				objDoc.addPrk(objPrk, tmpTable.getValue("fwid"));
				objDoc.save();
				setProgressPos(++l);			
			}
		}	
		setProgressPos(0);	
		tmpTable.Close();	
		// END >> Сохранение приказов в XML
}

function getHPZ(fwid_wp)
{
	hpz = 0;
	if (dpShifPZ != null)
    {
	   	hpz = dpShifPZ.getFshpz();

		if((hpz=="" || hpz=="0" || hpz==0) && fwid_wp!=null)
		{
			var snap = getSnap("select sd.Fshpz from ^stru_dol as sd inner join ^work_pers as wp on sd.Fwid=wp.Fwid_dol where wp.fwid="+fwid_wp)
			if(snap)
				hpz = snap[0];
		}
		
		if((extPar.mode!="EDIT" || dpShifPZ.getFshpz()==0) && hpz!=0)
		{
			zat = 0;	
			var strSQL = "SELECT fan FROM ^lic_fld AS f INNER JOIN ^cl_prik AS p ON f.fid = p.flsfid "
					+ " WHERE p.fvid = " + sqlTo(extPar.fvid);
			var snap = getSnap(strSQL);
			if (snap != null)
				zat = snap[0];	
			if (zat != 0 && hpz!=0)
			{
				//*заменить (или добавить в конец) последнюю цифру из ШПЗ на цифру из поля FAN в LIC_FLD
				switch(getPar("PRK_SHPZ"))
				{
					case 1:
						hpz = hpz + allt(String(zat));
					break;
					case 0:
					default:
						hpz = allt(String(hpz)).substring(0, allt(String(hpz)).length - 1) + allt(String(zat));
					break;
				}
			}
		}
	}
	return hpz;
}

function getAbsenceFields(n, fields)
{
	var result = new Array();	
	for (var i in fields)
	{
		var present = false;
		for (var j in n)
			if (String(j).toLowerCase() == fields[i].toLowerCase())
			{
				present = true;
				break;
			}
		if (!present)
			result[i] = fields[i].toLowerCase();
	}
	return result;
}

/** Типовые валидности */
function EMPTY_DATE(obj)
{
	return fbdat_Valid(obj);
}

function fbdat_Valid(obj) 
{
   	if (differ(toScriptDate(obj.getValue()), toScriptDate(d00)) == 0)
	{
		WAIT(UR("Порожня дата неприпустима!|Пустая дата недопустима!"));
		return false;
	}
	return true;
}

function fedat_Valid()
{
	if (differ(toScriptDate(HBDAT.getValue()), toScriptDate(d00)) == 0)
	{
		WAIT(UR("Порожня дата неприпустима!|Пустая дата недопустима!"));
		return false;
	}
	if (differ(toScriptDate(HEDAT.getValue()), toScriptDate(HBDAT.getValue()))==-1)
	{
		WAIT(UR("Дата закінчення не може бути менша за дату початку!|Дата конца не может быть меньше даты начала"));
		return false;
	}
	return true;
}

function getGlobalFieldsList()
{
	var result = new Array();
	result["FTABN_ID"] = true;
	result["FWID_WP"] = true;
	result["FVID_PRK"] = true;
	result["FBDAT"] = true;
	result["FEDAT"] = true;
	result["FSUM"] = true;
	result["FPROC"] = true;
	return result;
}

/** ERROR */
function ERROR_PRK_TXT_SAVE(obj)
{
	var msg = UR("Неможливе збереження в таблицю (PRK_TXT)!\nВідсутні обов'язкові поля:|Невозможно сохранение в таблицу (PRK_TXT)!\nОтсутствуют обязательные поля:");
	for (var i in obj)
		msg += "\n  - " + obj[i];
	alert(msg, ICON_ERROR);
}

function ERROR_SAVE_OBJ()
{
	var msg = UR("Неможливе збереження в таблицю (" + extPar.tblName + ")!\nВідсутні поля для збереження!|Невозможно сохранение в таблицу (" + extPar.tblName + ")!\nОтсутствуют сохраняемые поля!");
	alert(msg, ICON_ERROR);
	return false;
}

/** CONST */
var PRK_TXT_FIELDS = new Array("fvid_prk", "fnazv", "fbdat", "fedat", "fdat_prik", "fnom_prik");
var ERROR_SAVE_TO_XML = UR("Неможливе збереження в XML!\nВідсутнє обов'язкове поле 'ID'.|Невозможно сохранение в XML!\nОтсутствует обязательное поле 'ID'.");

include("sys/DpBaseDlg.js");