include("objects/DpJRegistrator.js");
include("sys/udfs.js");

var jID;
var oReg = null;
var journal = null;
var fidDoc = 0;

function listLoad()
{
	if (!extPar)
		extPar = new Object();
	jID = allt(String(GetMenuMode()).toUpperCase());
	if (jID == "")
		jID = (extPar?extPar.JID?extPar.JID:"":"");
			
	fidDoc = (extPar?extPar.fiddoc?extPar.fiddoc:0:0);
	
	oReg = new DpJRegistrator(null,null,"US");
	
	if (!oReg.listJournals()[jID])
	{
		alert("Журнал " + jID + " не существует");
		return false;
	}
	
	journal = oReg.listJournals()[jID];
	this.printLabel = (journal.getModule()?(journal.getModule()+":"):"") +jID;
	
	var gridFile = journal.getGridDescrFile();
	if (gridFile != null)
	{
		this.xmlGridFile = gridFile;
		grid.setXMLDir("");
	}
	
	var path = journal.getPath();
	if (isFile(path + "list.js"))
		include (path + "list.js");
	
	if (typeof(getJournalTableName) == "function")
		this.getJournalTableName = getJournalTableName;
	else
		this.getJournalTableName = commonGetJournalTableName;
	
	if (typeof(isJournalHasDate) == "function")
		this.isJournalHasDate = isJournalHasDate;
	else
		this.isJournalHasDate = baseJournalHasDate;
	
	if (typeof(getJournalDateFieldName) == "function")
		this.getDateFieldName = getJournalDateFieldName;
	else
		this.getDateFieldName = baseJournalgetDateFieldName;
	
	if (typeof(isJournalHasContr) == "function")
		this.isJournalHasContr = isJournalHasContr;
	else
		this.isJournalHasContr = baseJournalHasContr;
	
	if (typeof(getJournalOrgFieldName) == "function")
		this.getOrgFieldName = getJournalOrgFieldName;
	else
		this.getOrgFieldName = baseJournalgetOrgFieldName;
	
	if (typeof(journalMenuInit) == "function")
		this.journalMenuInit = journalMenuInit;
	else
		this.journalMenuInit = new Function();
	
	if (typeof(journalMenuRun) == "function")
		this.journalMenuRun = journalMenuRun;
	else
		this.journalMenuRun = new Function();
		
	if (typeof(journalQrySet) == "function")
		this.journalQrySet = journalQrySet;
	else
		this.journalQrySet = new Function();
	
	grid.setViewerID("l_journal.js.grid." + jID);
	
	if (typeof(DOC) != "undefined" && typeOf(DOC) == "DpTextEx")
	{
		this.btnChangeClick	= btnChangeClick;
		include ("objects/DpzDoc.js");		
		this.dpzDoc = new DpzDoc (null, null, null, true);
		DOC.value = this.m_Doclabel;
		//this.dpzDoc.linkCtrl(DOC);
		this.dpzDoc.linkCtrlNop(NOP);
		this.dpzDoc.linkSmartCtrl(DOC);
		this.dpzDoc.setContAssist();
		this.dpzDoc.canEmpty = true;
		if (extPar && extPar.doc)
			this.dpzDoc.setCod(extPar.doc);
		if (extPar && extPar.nop)
			this.dpzDoc.setDocNop(extPar.nop);
		
		
		if(this.isJournalHasDate())
		{
			DATB.value = getPar("GLOBDAT1");
			DATE.value = getPar("GLOBDAT2");
			if(extPar && extPar.bdat)
				DATB.value = extPar.bdat;
			if(extPar && extPar.edat)
				DATE.value = extPar.edat;			
			setValid(TYPEPER, onChangePeriod);
			this.datValid = datValid;
			setValid(DATB, this, "datValid");
			setValid(DATE, this, "datValid");
		}
		else
		{
			GRPERIOD.visible = false;
		}
		var nOnlyMy = Number(ReadParEx("ONLYMYDOC"));
		if (!isNaN(nOnlyMy) && nOnlyMy != 0)
			ONLYMY.checked = true;
		if(fidDoc)
			ONLYMY.checked = false;
		
		
		if (this.isJournalHasContr())
		{
			GRORG.setVisible(true);
			this.oOrg = new DpCl("0!", getPar("CODPLAT"), 0);
			//this.oOrg.linkCtrl(FORG, FORG_TXT);
			this.oOrg.linkSmartCtrl(FORG);
			this.oOrg.setContAssist();
			//FORG.setEnterHandler(btnChangeClick);
			if(extPar && extPar.org)
				this.oOrg.setCod(extPar.org);
		}
		
		
		setValid(ONLYMY,this, "btnChangeClick");	
		setButton(butt, this, "btnChangeClick");
	}
	
	if (typeOf(FORM) == "DpViewPart")
	{
		this.onMessage = onMessage;
		FORM.setMessageHandler(this, "onMessage")
	}
}

function baseJournalHasDate()
{
	return journal.getFieldImpl(this.getDateFieldName()) != null;
}

function baseJournalHasContr()
{
	return journal.getFieldImpl(this.getOrgFieldName()) != null;;
}

function baseJournalgetOrgFieldName()
{
	return "HORG"; 
}

function baseJournalgetDateFieldName()
{
	return "HDAT"; 
}



function listTitle()
{
	var capt = UR("Просмотр журнала|Перегляд журналу");
	if (journal == null)
		return capt;
	//capt = capt + " : " + journal.Num + " . " + journal.getName();
	capt = journal.getName();
	return capt;
}

function listGetTotalID()
{	
	return "l_journal_" + jID;
}

function listSrc()
{
	var sWhere = " 1=1 ";
//Скорпио считает реестр из нулевой папки NN, поэтому не нужно отсекать регистрационные записи других документов
//	if(extPar && extPar.doc)
//		sWhere += " and HDOC="+ sqlTo(extPar.doc);
	if(extPar && extPar.nop)
		sWhere += " and HNOP="+ sqlTo(extPar.nop);
	if(extPar && extPar.org)
		sWhere += " and " + this.getOrgFieldName() + "="+ sqlTo(extPar.org);
	if(extPar && extPar.dog)
		sWhere += " and FDOG="+ sqlTo(extPar.dog);
	
	if (this.isJournalHasDate() && typeof(DATB)=="object")
		sWhere += " AND " + this.getDateFieldName() + " >= " +sqlTo(DATB.value);
	else if(extPar.bdat && differ(extPar.bdat, d00)<0)		
		sWhere += " AND " + this.getDateFieldName() + " >= " +sqlTo(extPar.bdat);
	
	if (this.isJournalHasDate() && typeof(DATE)=="object")
		sWhere += " AND " + this.getDateFieldName() + " <= " +sqlTo(DATE.value);
	else if(extPar.edat && differ(extPar.edat, d00)<0)
		sWhere += " AND " + this.getDateFieldName() + " <= " +sqlTo(extPar.edat);
	
	if (typeof(ONLYMY) != "undefined" && typeOf(ONLYMY) == "DpCheck")
	{
		if (toScrObj(ONLYMY.checked))
			sWhere += " and HID_DOC in (select fid_doc from ^archive where upper(fmuser) = " + sqlTo(getUserName().toUpperCase()) + ")";
	}
	this.qrySet("From", this.getJournalTableName()
			, "Where", sWhere);	 
	if (fidDoc != 0)
		this.qrySet("Where","HID_DOC=" + sqlTo(fidDoc));
		
	this.journalQrySet();
	//this.subTie("LISTCLORG","org","Fcod","Horg");
	this.clTie("org", "=0, Horg");
	this.extTieEx("xorg", "org.fwid", "CL", "0");
}

function onMessage(sType, oPar)
{
	extPar.JID = oPar.JID;
	extPar.org = oPar.org;
	extPar.dog = oPar.dog;
	this.reLoad();
}

function commonGetJournalTableName()
{
	return journal.getFullTableName();
}

function listDpGridEx(oGrid)
{
	with(oGrid.page())
	{
		var vList = journal.getFieldsImpl();
		for (var nFld = 0; nFld < vList.length; nFld++)
		{
			var curFld = vList[nFld];
			var fldName = allt(String(curFld.FREM));
			var fldFld = String(curFld.FVAR).toUpperCase();
			if (fldName == "")
			{
				fldName = fldFld;
			}
			var fldWidth = getWdt(curFld.FTYPE);
			
			if (curFld.FTYPE == "CURRENCY")
				FieldEx(fldFld,fldName,fldWidth,"", DP_FORMAT_SUM);
			else
				FieldEx(fldFld,fldName,fldWidth);
				
			
		}
	}
}

function getWdt(type)
{
	type = String(type);
	switch(type)
	{
		case "date":
			return 9;
		case "text(255)":
			return 15;
	}
	return 7;
}


function listMenuInit(toObject)
{
	if (this.tbl.isEmpty())
		return;
	toObject.AddMenuItem("FINDDOC","Пошук документа|Поиск документа");
	toObject.AddMenuItem("VIEW","Перегляд документу|Просмотр документа");
	
	if (typeof(this.journalMenuInit) == "function")
		this.journalMenuInit(toObject);
}

function listMenuRun(sID)
{
	if (sID == "FINDDOC")
	{
		var doc = String(this.tbl.getValue("HDOC"));
		var nop = this.tbl.getValue("HNOP");
		var fid_doc = this.tbl.getValue("HID_DOC");
		include("doc/DpDocPtn.js");
		FindDocument(doc,nop,fid_doc);
		return;
	}
	if (sID == "EDIT")
	{
		include("doc/DpDoc.js");
		var doc = String(this.tbl.getValue("HDOC"));
		var nop = this.tbl.getValue("HNOP");
		var fid_doc = this.tbl.getValue("HID_DOC");
		
		var oDoc = new DpDoc(doc,nop,this);
		oDoc.edit("VIEW",fid_doc);
	}
	else
	{
		if (typeof(this.journalMenuRun) == "function")
			this.journalMenuRun(sID);		
	}
}

function listDelAcc(){return true;}
function onChangePeriod()
{
	var per = String(TYPEPER.value);
	switch (per)
	{
		case "TD":
			DATB.value = today.getVarDate();
			DATE.value = today.getVarDate();
			break;
		case "YTD":
			DATB.value = goDay(today, -1);
			DATE.value = goDay(today, -1);
			break;
		case "TW":
			DATB.value = goDay(today, -today.getDay());
			DATE.value = goDay(today,6 - today.getDay());
			break;
		case "TM":
			DATB.value = firstDayMonth(today);
			DATE.value = lastDayMonth(today);
			break;
		case "LM":
			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
			DATE.value = lastDayMonth(_dateTrans(today, "M+", -1));
			break;
		case "2M":
			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
			DATE.value = lastDayMonth(today);
			break;		
		case "TY":
			DATB.value = jan01(today);
			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "2Y":
			var bdat = new Date(today.getFullYear()-1, today.getMonth());
			DATB.value = jan01(bdat);
			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "ALL":
			DATB.value = d00min;
			DATE.value = d00;
			break;
		default:
			break;
	}
	list.btnChangeClick();
}

function btnChangeClick()
{
	extPar.doc = String(DOC.value).trim();
		////////
	extPar.nop = Number(NOP.value);
	if (isNaN(extPar.nop))
		extPar.nop = 0;
	if (new Date(DATB.value) > new Date(DATE.value))
	{
		alert("Дата начала больше даты конца");
	}			 
	else
	{
		setPar("GLOBDAT1", DATB.value);
		setPar("GLOBDAT2", DATE.value);
		extPar.bdat = DATB.value;
		extPar.edat = DATE.value;
		
	}	
	
	if (this.oOrg)
	{
		extPar.org = this.oOrg.getCod();
	}
	WriteParEx("ONLYMYDOC", ONLYMY.checked?"1":"0");
	grid.DeletePages();
	list.isRefresh = true;	
	if(list.tbl)
		list.tbl.clearQuery();
	list.tblSrc[list.tblSrcNo] = "";
	list.tbl = null;	
	list.init();	
	grid.setFocus();
}

function datValid()
{
	TYPEPER.value="-";
}

function listOnPrnList(tv)
{
    var h = new Object();
    h.FD1  = DATB.value;
    h.FD2  = DATE.value;
    tv.setHTbl(h);
}

function listBeforeGridBuild()
{
	grid.addExtPage("xorg");
}

include("sys/DpList.js");