// JScript source code
include("objects\\DpGrid.js");
include("sys\\DpList.js");

var tblName = "obsch_cor1";

function listLoad()
{
	with( this )
	{
		title = "";
		//editTask = "e_list.xml";
		printLabel = "OBSCH_COR1";
		//xmlGridFile = "l_list.xml";
	}
}

function listSrc()
{
	this.qrySet	(
					"From", tblName			
					, "Order", "fsc, fsu, fst, fcl_cod"
				);
}

function listGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	list.GroupPage(oGrid);
	with (oGrid)
	{
		with(page())
		{
			cell("=^fsc? ^fsc: 'ИТОГО'", "Счет|Рах.", 5);
			cell("=^fsu? ^fsu: ''", "Суб/счет|Суб/рах", 6);
			cell("=^fst? ^fst: ''", "Статья.|Стаття.", 5);
 	
			cell("fcl_cod", "Аналитика", 6)
			with(group("Обороты"))
			{
				cell("fsum_db", "Дт", 10, null, DP_FORMAT_SUM)
				cell("fsum_cr", "Кт", 10, null, DP_FORMAT_SUM)
			}
			with(group("Итого"))
			{
				cell("=^fsum_db>^fsum_cr ? ^fsum_db-^fsum_cr: 0", "Дт", 10, null, DP_FORMAT_SUM)
				cell("=^fsum_cr>^fsum_db ? ^fsum_cr-^fsum_db: 0", "Кт", 10, null, DP_FORMAT_SUM)
			}
			cell("=^fcl_cod? tcl('CL', '', 0, ^fcl_cod): 'ИТОГО'", "Аналитика", 6)
		}
	}
	oGrid.build();
}


function listMake()
{
	var isDb = "fdb_sc=" + extPar.objAsk.fsc 
		+ sqlw0And("fdb_su=", extPar.objAsk.fsu)
		+ sqlw0And("fdb_st=", extPar.objAsk.fst)

	var isCr = "fcr_sc=" + extPar.objAsk.fsc
		+ sqlw0And("fcr_su=", extPar.objAsk.fsu)
		+ sqlw0And("fcr_st=", extPar.objAsk.fst)
	
	var sFields = IIF(isDb, "fdb_sc", "fcr_sc") + " AS fsc"
		+ ", " + IIF(isDb, "fdb_su", "fcr_su") + " AS fsu"
		+ ", " + IIF(isDb, "fdb_st", "fcr_st") + " AS fst" 
		+ ", " + IIF(isDb, "fcr_cod1", "fdb_cod1") + " AS fcl_cod"
	
	DropTable(tblName)
	
	ExecuteSQL(
		"create table " + tblName
			+"("
			+ " Fsc "+ SqlType("INT") 
			+ ", Fsu "+ SqlType("INT") 
			+ ", Fst "+ SqlType("INT") 
			+ ", Fcl_cod "+ SqlType("INT") 
			+ ", Fsum_db "+ SqlType("CURRENCY") 
			+ ", Fsum_cr "+ SqlType("CURRENCY") 
			+")"
		)
	
	//фильтр на организацию
	var orgCond = "";
	if(getPar("BLNBYORG"))
		orgCond = " and Forg0="+CURRENT_ORG;
	
	ExecuteSQL( 
		"INSERT INTO " + tblName
			+ " (fsc, fsu, fst, fcl_cod, fsum_db, fsum_cr)"
		+ "SELECT" + sFields
			+ ", SUM(" + IIF(isDb, "fsum", "0") + ") AS fsum_db"
			+ ", SUM(" + IIF(isCr, "fsum", "0") + ") AS fsum_cr"
		+ " FROM ^schet"
		+ " WHERE ((" + isDb + ") OR (" + isCr + "))"
			+ " AND fdate BETWEEN " + sqlTo(extPar.objAsk.dat1) + " AND " + sqlTo(extPar.objAsk.dat2)
			+ orgCond
			// + " AND fwrk<>15 AND fwrk<>16" // Закрывающие проводки
		+ " GROUP BY " + IIF(isDb, "fdb_sc", "fcr_sc") 		
			+ ", " + IIF(isDb, "fdb_su", "fcr_su")
			+ ", " + IIF(isDb, "fdb_st", "fcr_st")
			+ ", " + IIF(isDb, "fcr_cod1", "fdb_cod1")
		//+ " ORDER BY fcl_cod"
		)

	ExecuteSQL(
		"INSERT INTO " + tblName
			+ " (fsc, fsu, fst, fcl_cod, fsum_db, fsum_cr)"
		+ " SELECT 0, 0, 0, 0"
			+ ", SUM(" + IIF(isDb, "fsum", "0") + ") AS fsum_db"
			+ ", SUM(" + IIF(isCr, "fsum", "0") + ") AS fsum_cr"
		+ " FROM ^schet"
		+ " WHERE ((" + isDb + ") OR (" + isCr + "))"
			+ " AND fdate BETWEEN " + sqlTo(extPar.objAsk.dat1) + " AND " + sqlTo(extPar.objAsk.dat2)
			+ orgCond
			// + " AND fwrk<>15 AND fwrk<>16" // Закрывающие проводки
		);
}

function listMenuInit()
{
}

function listMenuRun(ID)
{
}

function getTblH()
{
	var h = new Object();
	h.FSC = extPar.objAsk.fsc;
	h.FSU = extPar.objAsk.fsu;
	h.FDAT1 = extPar.objAsk.dat1;
	h.FDAT2 = extPar.objAsk.dat2;
	return h;
}

function filterMode(s)
{
	return true;		
}