//обороты и остатки по расчетным счетам
//остатки высчисляем по документам OSTBNK, обороты расчитываются по платежкам PP и PV
include("Objects/DpGrid.js");

var label = "ostbnk";
var menuMode, form;
var total, dat1, dat2, isAll, orgcl, orgnom, rsccod, rsc, mfo;

function listLoad()
{
	menuMode = GetMenuMode();
	total = Number(ReadParEx("total"));
	isAll = (ReadParEx("all")=="false"?false:true);
	orgcl = getPar("CODMYORG");
	orgnom = (Number(ReadParEx("orgnom")>0)?Number(ReadParEx("orgnom")):getPar("ORGNOM"));
	rsccod = (Number(ReadParEx("rsccod"))?Number(ReadParEx("rsccod")):0);
	rsc = (ReadParEx("rsc")?ReadParEx("rsc"):getPar("ORSC"));
	this.title = ru("Обороты и остатки по б/с","Обiги та залишки по б/р");
	list.objTotal.init(label);
	var datTitle = " за "+ReadParEx("dat1")+"-"+ReadParEx("dat2")
	if(!menuMode)
	{
		this.par.menuMode = menuMode = "CALC";
	}
	if(menuMode == "CALC")
	{
		var par = new Object();
		par.totalLbl = label;
		par.total = total;
		par.dat1 = getPar("GLOBDAT1");
		par.dat2 = getPar("GLOBDAT2");
		par.isAll = isAll;
		par.orgcl = orgcl;
		par.orgnom = orgnom;
		par.rsccod = rsccod;
		showWindow("e_rsc.xml", SW_MODAL, par);
		if(par.escape)
			return false;
		
		total = par.total;
		dat1 = par.dat1;
		dat2 = par.dat2;
		isAll = par.isAll;
		orgnom = par.orgnom;
		rsccod = par.rsccod;
		mfo = par.mfo;
		rsc = par.rsc;
		setPar("GLOBDAT1", dat1);
		setPar("GLOBDAT2", dat2);
		WriteParEx("total",total);
		WriteParEx("all",isAll);
		WriteParEx("orgnom",orgnom);
		WriteParEx("rsccod",rsccod);
		WriteParEx("rsc",rsc);
		WriteParEx("dat1",format("dd.mm.yy",dat1));
		WriteParEx("dat2",format("dd.mm.yy",dat2));
		datTitle = " за "+format("dd.mm.yy",dat1)+"-"+format("dd.mm.yy",dat2);
	}
	if(!isAll && rsc)
		this.title += ": "+rsc;
	this.title += datTitle;
}

function listSrc()
{
	list.qrySet("From","OSTBNK","Order","Frsc,Fmfo,Fdat");
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	with(gr)
	{
		FieldEx("Fdat", "Дата|Дата", 10);
		FieldEx("Fbost", "Сальдо на початок|Сальдо на начало", 10, "", DP_FORMAT_SUM);
		with(group("Обіги|Обороты"))
		{
			FieldEx("Fdb", "Дебет|Дебет", 10, "", DP_FORMAT_SUM);
			FieldEx("Fcr", "Кредит|Кредит", 10, "", DP_FORMAT_SUM);
		}
		FieldEx("Feost", "Сальдо на кінець|Сальдо на конец", 10, "", DP_FORMAT_SUM);
		FieldEx("Frsc", "Розр.рах.|Расч.счет", 10);
		FieldEx("Fmfo", "МФО|МФО", 10);
		FieldEx("Fbnk", "Назва банку|Название банка", 10);
	}
	oGrid.build();   		
}

function listMake()
{
	CreateTable("OSTBNK", "OSTBNK","*");
	CreateTable("OSTBNK_CR", "OSTBNK","*");
	CreateTable("BOSTBNK", "OSTBNK","*");
	
	//делаем проверку остатков
	var snap = getSnap("select Ffdb_sc,Fdoc_dat from ^ras_sch where Fdoc="+sqlTo("OSTBNK")+" and Fdoc_dat>"+sqlTo(dat1)+" and Fdoc_dat<="+sqlTo(dat2));
	if(snap && snap[0])
	{
		var msg = ru("Найдены остатки по счету: "+snap[0]+" на "+format("dd.mm.yyyy,", snap[1])
					+"\nкоторые лежат внутри периода расчета.\nРезультат расчета может быть некорректным.\nПродолжить расчет?",
					"Знайдені залишки по рахунку: "+snap[0]+" на "+format("dd.mm.yyyy,", snap[1])
					+"\nякі знаходяться всередині періоду розрахунку.\nРезультат розрахунку може бути некоректним.\nПродовжити розрахунок?");
		if(!confirm(msg))
			return false;
	}
	
	//для дебетовых платежей (PV) наш р/с, МФО и название банка хранятся в полях Ffcr_sc и Fcod_bnk2 и Fbnk2 соответственно,
	//а для кредитовых платежей (PP) в полях Ffdb_sc, Fcod_bnk1 и Fbnk1
	if(isAll)
	{
		sWhereDb = " Fdoc="+sqlTo("PV")+" and Fdoc_dat>="+sqlTo(dat1)+" and Fdoc_dat<="+sqlTo(dat2);
		sWhereCr = " Fdoc="+sqlTo("PP")+" and Fdoc_dat>="+sqlTo(dat1)+" and Fdoc_dat<="+sqlTo(dat2);
	}
	else
	{
		sWhereDb = " Fdoc="+sqlTo("PV")+" and Ffcr_sc="+sqlTo(rsc)+" and Fcod_bnk2="+sqlTo(mfo)
				+" and Fdoc_dat>="+sqlTo(dat1)+" and Fdoc_dat<="+sqlTo(dat2);
		sWhereCr = " Fdoc="+sqlTo("PP")+" and Ffdb_sc="+sqlTo(rsc)+" and Fcod_bnk1="+sqlTo(mfo)
				+" and Fdoc_dat>="+sqlTo(dat1)+" and Fdoc_dat<="+sqlTo(dat2);
	}
	sGroupDb = "Fdoc_dat,Ffcr_sc,Fcod_bnk2,Fwid";
	sGroupCr = "Fdoc_dat,Ffdb_sc,Fcod_bnk1,Fwid";
	
	//обороты
	//кредитовую сторону выгрузим в отдельную таблицу, чтобы потом проапдейтить и добавить записи с датами отсутствующими в основной
	ExecuteSQL("insert into OSTBNK(Fdat,Frsc,Fmfo,Fdb,Fid_dbdoc,Fbost,Feost) "
			+" select Fdoc_dat, Ffcr_sc as Frsc, Fcod_bnk2 as Fmfo, SUM(Fsum) as Fdb, Fwid as Fid_dbdoc, 0 as Fbost, 0 as Feost "
			+" from ^ras_sch where "+sWhereDb
			+" group by "+sGroupDb);

	ExecuteSQL("insert into OSTBNK_CR(Fdat,Frsc,Fmfo,Fcr,Fid_crdoc) "
			+" select Fdoc_dat, Ffdb_sc as Frsc, Fcod_bnk1 as Fmfo, SUM(Fsum) as Fcr, Fwid as Fid_crdoc "
			+" from ^ras_sch where "+sWhereCr
			+" group by "+sGroupCr);
	//отбираем дебетовые платежи на дату которых есть кредитовые и в цикле их апдейтим
	var tdb = OpenTable("select * from OSTBNK where exists(select Fwid from OSTBNK_CR as cr "
						+" where OSTBNK.Fdat=cr.Fdat and OSTBNK.Frsc=cr.Frsc and OSTBNK.Fmfo=cr.Fmfo)"
						+" order by Fdat,Frsc,Fmfo");
	var tcr = OpenTable("select * from OSTBNK_CR where exists(select Fwid from OSTBNK as db "
						+" where OSTBNK_CR.Fdat=db.Fdat and OSTBNK_CR.Frsc=db.Frsc and OSTBNK_CR.Fmfo=db.Fmfo)"
						+" order by Fdat,Frsc,Fmfo");
	for(; !tdb.IsEOF(); tdb.MoveNext())
	{
		doc_dbdat = tdb.getValue("Fdat");
		doc_crdat = tcr.getValue("Fdat");
		frsc_db = tdb.getValue("Frsc");
		frsc_cr = tcr.getValue("Frsc")
		if(differ(tdb.getValue("Fdat"),tcr.getValue("Fdat")) == 0 && tdb.getValue("Frsc")==tcr.getValue("Frsc") && tdb.getValue("Fmfo")==tcr.getValue("Fmfo"))
		{
			var m = new Object();
			m.Fcr = tcr.getValue("Fcr");
			m.Fid_crdoc = tcr.getValue("Fid_crdoc");
			UpdateTable("OSTBNK", m, false, "Fwid="+tdb.getValue("Fwid"));
			tcr.MoveNext();
		}
		else if(differ(tdb.getValue("Fdat"),tcr.getValue("Fdat")) > 0)
		{
			while(differ(tdb.getValue("Fdat"),tcr.getValue("Fdat")) > 0 && !tcr.IsEOF())
				tcr.MoveNext();
			if(!tcr.IsEOF() && tdb.getValue("Frsc")==tcr.getValue("Frsc") && tdb.getValue("Fmfo")==tcr.getValue("Fmfo"))
			{
				var m = new Object();
				m.Fcr = tcr.getValue("Fcr");
				m.Fid_crdoc = tcr.getValue("Fid_crdoc");
				UpdateTable("OSTBNK", m, false, "Fwid="+tdb.getValue("Fwid"));
				tcr.MoveNext();
			}
		}
	}
	tdb.close();
	tcr.close();
	/*ExecuteSQL("update OSTBNK set Fcr=(select Fcr from OSTBNK_CR as cr "
						+" where OSTBNK.Fdat=cr.Fdat and OSTBNK.Frsc=cr.Frsc and OSTBNK.Fmfo=cr.Fmfo) "
				+" where exists(select Fwid from OSTBNK_CR as cr "
						+" where OSTBNK.Fdat=cr.Fdat and OSTBNK.Frsc=cr.Frsc and OSTBNK.Fmfo=cr.Fmfo)");*/
	ExecuteSQL("insert into OSTBNK(Fdat,Frsc,Fmfo,Fcr,Fid_crdoc) "
				+" select Fdat,Frsc,Fmfo,Fcr,Fid_crdoc "
				+" from OSTBNK_CR "
				+" where not exists(select Fwid from OSTBNK as o "
					+" where OSTBNK_CR.Fid_crdoc=o.Fid_crdoc)");
	
	
	//сальдо на начало расчитываем в отдельную таблицу как остатки по максимальной дате <= дате начала
	//и обороты за период с последней даты остатка и до даты начала расчета
	//потом это все вставляем в основную таблицу, сгрупировав по дате, счетам и МФО
	var snap = getSnap("select MAX(Fdoc_dat) from ^ras_sch where Fdoc="+sqlTo("OSTBNK")+" and Fdoc_dat<="+sqlTo(dat1));
	if(snap && snap[0])
	{
		var sqlDat = sqlTo(snap[0]);
		
		ExecuteSQL("insert into BOSTBNK (Fdat,Frsc,Fmfo,Fdb,Fcr,Fbost,Feost) "
				+" select "+sqlTo(dat1)+" as Fdoc_dat,Ffdb_sc,Fcod_bnk1,0,0,SUM(Fsum),0 "
				+" from ^ras_sch as r "
				+" where Fdoc="+sqlTo("OSTBNK")+" and Fdoc_dat=(select MAX(Fdoc_dat) from ^ras_sch as r2 "
						+" where r2.Fdoc="+sqlTo("OSTBNK")
							+" and r2.Fdoc_dat="+sqlDat
							+" and r2.Ffdb_sc=r.Ffdb_sc"
							+" and r2.Fcod_bnk1=r.Fcod_bnk1)"
					+(!isAll?" and Ffdb_sc="+sqlTo(rsc)+" and Fcod_bnk1="+sqlTo(mfo):"")
				+" group by Fdoc_dat,Ffdb_sc,Fcod_bnk1");
		
		if(isAll)
		{
			sWhereDb = " Fdoc="+sqlTo("PV")+" and Fdoc_dat>="+sqlDat+" and Fdoc_dat<"+sqlTo(dat1);
			sWhereCr = " Fdoc="+sqlTo("PP")+" and Fdoc_dat>="+sqlDat+" and Fdoc_dat<"+sqlTo(dat1);
		}
		else
		{
			sWhereDb = " Fdoc="+sqlTo("PV")+" and Ffcr_sc="+sqlTo(rsc)+" and Fcod_bnk2="+sqlTo(mfo)
					+" and Fdoc_dat>="+sqlDat+" and Fdoc_dat<"+sqlTo(dat1);
			sWhereCr = " Fdoc="+sqlTo("PP")+" and Ffdb_sc="+sqlTo(rsc)+" and Fcod_bnk1="+sqlTo(mfo)
					+" and Fdoc_dat>="+sqlDat+" and Fdoc_dat<"+sqlTo(dat1);
		}
		//дебетовые начальные остатки
		ExecuteSQL("insert into BOSTBNK (Fdat,Frsc,Fmfo,Fdb,Fcr,Fbost,Feost) "
				+" select "+sqlTo(dat1)+" as Fdoc_dat,Ffcr_sc,Fcod_bnk2,0,0,SUM(Fsum),0 "
				+" from ^ras_sch "
				+" where "+sWhereDb
				+" group by Ffcr_sc,Fcod_bnk2"
				+" having SUM(Fsum) is not null");
		//кредитовые начальные остатки вставляем с минусом
		ExecuteSQL("insert into BOSTBNK (Fdat,Frsc,Fmfo,Fdb,Fcr,Fbost,Feost) "
				+" select "+sqlTo(dat1)+" as Fdoc_dat,Ffdb_sc,Fcod_bnk1,0,0,-SUM(Fsum),0 "
				+" from ^ras_sch "
				+" where "+sWhereCr
				+" group by Ffdb_sc,Fcod_bnk1"
				+" having SUM(Fsum) is not null");
		
		DropTable("BUF_OSTBNK");
		ExecuteSQL("select * into BUF_OSTBNK from OSTBNK");
		//групируем и обновляем начальные остатки в результирующей таблице и вставляем их, если по данному счету+МФО на минимальную дату нет записи в таблице
		DropTable("tmp_fwids")			
		ExecuteSQL("select MIN(Fwid) as Fwid into tmp_fwids from BUF_OSTBNK as t where t.Fdat=(select MIN(Fdat) from BUF_OSTBNK as t2 where t2.Frsc=t.Frsc and t2.Fmfo=t.Fmfo ) group by Frsc,Fmfo")
		ExecuteSQL("update OSTBNK set Fbost=(select SUM(Fbost) from BOSTBNK "
						+" where BOSTBNK.Frsc=OSTBNK.Frsc"
							+" and BOSTBNK.Fmfo=OSTBNK.Fmfo) "
					+" where Fwid in (select Fwid from tmp_fwids)"
						+" and exists (select Fwid from BOSTBNK "
							+" where BOSTBNK.Frsc=OSTBNK.Frsc"
								+" and BOSTBNK.Fmfo=OSTBNK.Fmfo)");
		
		ExecuteSQL("insert into OSTBNK (Fdat,Frsc,Fmfo,Fdb,Fcr,Fbost,Feost) "
				+" select "+sqlTo(dat1)+" as Fdat,Frsc,Fmfo,0,0,SUM(Fbost),0 "
				+" from BOSTBNK "
				+" where 1=1 "
					+(!isAll?" and Frsc="+sqlTo(rsc)+" and Fmfo="+sqlTo(mfo):"")
					+" and not exists(select Fwid from BUF_OSTBNK as o where BOSTBNK.Frsc=o.Frsc and BOSTBNK.Fmfo=o.Fmfo)"
				+" group by Frsc,Fmfo");		
	}
	
	//остатки на конец
	ExecuteSQL("update OSTBNK set Feost=Fbost+Fdb-Fcr");
	//апдейтим название банка
	ExecuteSQL("update OSTBNK set Fbnk=(select MAX(Fnazv_bnk) from ^cl_orgrs as cl where Fwid_cl="
				+getPar("ORGID")+" and cl.Fras_sch=OSTBNK.Frsc and cl.Fmfo=OSTBNK.Fmfo)");
	list.objTotal.variantCur = total;			
}

include("sys/DpList.js");