//ведомость по отпускам
//связь справочника норм с настройкой упрощенных отпускных должна быть 1:1
//ведомость формируется по неуволенным сотрудникам на основной должности,
//если есть необходимость исключить сотрудника из ведомости, 
//то в справочнике персонала можно создать расширение "Исключить из кадровой ведомости по отпускам" 
//логического типа с меткой NOTOTPVD со значением false по умолчанию и проставить галочку для таких сотрудников 
include("Objects/DpGetDat.js");
include("Objects/DpGrid.js");
include("Objects/DpExtentionBuilder.js");
include("servis/date.js");
include("sys/dbase.js");

var tblName, menuMode, gd, otpnorm, otpnormlnk, tblNorm;
var whereMode = "ALL";
var whereStr = "1=1";
var isCalc = false;

function listLoad()
{
	otpnorm = getPar("CDROTPNORM");
	if(!otpnorm)
	{
		alert(ru("Не указан справочник норм отпусков: ","Не вказано довідник норм відпусток: ")+"\n"+getParItemPath("CDROTPNORM", true));
		return false;
	}
	var snap = getSnap("select Fcod from ^clcl where Frel="+otpnorm+" and Fvid="+sqlTo("clnormlnk"));
	if(snap)
		otpnormlnk = snap[0];
	menuMode = GetMenuMode();
	gd = new DpGetDat("dD");
	if(gd.escape)
		return false;
	tblName = "otp_ved"+getDateTag(gd.dat1)+"_"+getDateTag(gd.dat2);
	if(menuMode=="VIEW" && !IsTable(tblName))
	{
		alert(ru("Сначала выполните расчет","Спочатку виконайте розрахунок")+format(" за dd.mm.yyyy", dat1));
		return false;
	}
	this.title = UR("Відомість про невикористані відпустки за |Ведомость по неиспользованным отпускам за ")+format("dd.mm.yy",gd.dat1)+format(" - dd.mm.yy",gd.dat2);
	this.printLabel = "OTP_VED";
	//таблица нормы отпусков
	tblNorm = OpenTable("select n.*, o.Fnom, o.Fnazv as Ftxtotp "
					+ " from ^LISTCLNORM as n left join ^nast_otp as o on o.Fwid=n.Fid_nast"
					+ " where n.Fcl="+otpnorm+" and n.Fbdat<="+sqlTo(gd.dat2)+" and n.Fedat>="+sqlTo(gd.dat1)
					+ " order by n.Fis_regular desc, o.Fnom, n.Fbdat");
}

function listSrc()
{
	this.qrySet("Fields", "t.*,cl.Ftxt",
				"From", tblName+" as t left join ^cl as cl on t.Ftabn_id=cl.Fwid", 
				"Where", whereStr, 
				"Order", "t.Flv1,t.Flv2,t.Flv3,t.Flv4,t.Fcod",
				"Alias", "t");
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	oGrid.defCond("=^Ftt==1", "subtotal")//итог по подразделениям первого уровня
	oGrid.defCond("=^Ftt==2", "total")
	oGrid.color(1, "total");
	oGrid.color(2, "subtotal");
	var gr = oGrid.page();
	with(gr)
	{
		FieldEx("Fcod", "Таб №|Таб №", 3, "zn");
		FieldEx("=^Ftt==2?UR('Загальний підсумок|Общий итог'):(^Ftt==1?UR('Підсумок по підрозділу|Итог по подразделению'):getSmallFIO(^Ftxt))", "ПІБ|ФИО", 15);
		FieldEx("=^Ftt>0?getTxtOrgByLvl(^Flv1,^Flv1==1?^Flv2:0,0,0,0):^Ftxtorg", "Підрозділ|Подразделение", 15);
		FieldEx("Fwrkdat", "Дата прийому на роботу|Дата приема на работу", 8);
		FieldEx("Fperiod", "Дата першого дня періоду|Дата первого дня периода", 8);
		with(group("Баланс|Баланс"))
		{
			FieldEx("Fregular", "Чергова|Очередн.", 8);
			FieldEx("Fadditional", "Додатк.|Дополн.", 8);
			FieldEx("Falldays", "Разом|Вместе", 8);
			FieldEx("Fcorrect", "З урах.поч.періоду|С учетом нач.периода", 8);
		}
		var D1 = firstDayYear(gd.dat1);
		var D2 = firstDayYear(gd.dat2);
		var d = new Date(D1).getVarDate();
		//динамически создаем поля в зависимости от периода расчета и кол-ва записей в справочнике норм отпусков
		while(differ(d,D2)<=0)
		{
			var y = new Date(d).getFullYear();
			with(group(String(y)))
			{
				FieldEx("Fperiod"+y, "Перший день періоду|Первый день периода", 8);
			}
			with(group("Норма|Норма"))
			{
				for(tblNorm.MoveFirst(); !tblNorm.IsEOF(); tblNorm.MoveNext())
					FieldEx("Fnorm"+tblNorm.getValue("Fid_nast")+"_"+y, tblNorm.getValue("Ftxt"), 5, "zn");
				
			}
			with(group(" "))
			{
				for(tblNorm.MoveFirst(); !tblNorm.IsEOF(); tblNorm.MoveNext())
				{
					with(group(String(tblNorm.getValue("Ftxt"))))
					{
						FieldEx("Fplan"+tblNorm.getValue("Fid_nast")+"_"+y, "план", 5, "zn");
						FieldEx("Ffact"+tblNorm.getValue("Fid_nast")+"_"+y, "факт", 5, "zn");
					}
				}
				with(group("корег.на початок періоду|корект.на начало периода"))
				{
					FieldEx("Fplan_cor"+y, "план", 5, "zn");
					FieldEx("Ffact_cor"+y, "факт", 5, "zn");
				}
			}
			d = goMonth(d, 12);
		}
	}
	oGrid.build();		
}

function listMake()
{
	//чтоб не пересчитывать при смене итогов
	if(isCalc)
		return true;
	isCalc = true;
	var usePrkLater = false;
	var snap = getSnap("select * from ^cdr_prk where Fdoc="+sqlTo("CDR_OTP")+" and Fdoc_dat>"+sqlTo(gd.dat2));
	var msg = ru("Учитывать приказы за этот период, введенные позже "+format("dd.mm.yyyy",gd.dat2)+"?",
				"Враховувати накази за цей період, введені пізніше "+format("dd.mm.yyyy",gd.dat2)+"?");
	if(snap && confirm(msg))
		usePrkLater = true;
	var step = 1;
	setProgressRange(step, 4);
	setProgressPos(step++, ru("Отбор сотрудников...","Відбір співробітників..."));
	var fld = new Object();
	fld.FWID = "COUNTER";
	fld.FTABN_ID = "LONG";
	fld.FCOD = "INT";
	fld.FTXTORG = "TEXT";
	fld.FWID_ORG = "LONG";
	fld.FLV1 = "BYTE";
	fld.FLV2 = "BYTE";
	fld.FLV3 = "BYTE";
	fld.FLV4 = "BYTE";
	fld.FLV5 = "BYTE";
	fld.FWRKDAT = "DATE";
	fld.FPERIOD = "DATE";
	fld.FREGULAR = "INT";
	fld.FADDITIONAL = "INT";
	fld.FCORRECT = "INT";
	fld.FALLDAYS = "INT";
	fld.FTT = "BYTE";
	fld.FIS_SETCOMP = "BIT";
	var D1 = firstDayYear(gd.dat1);
	var D2 = firstDayYear(gd.dat2);
	var d = new Date(D1).getVarDate();
	var def = new Object();//дефолты полей
	def.FNORMADAYS = 10;
	//динамически создаем поля в зависимости от периода расчета и кол-ва записей в справочнике норм отпусков
	while(differ(d,D2)<=0)
	{
		var y = new Date(d).getFullYear();
		eval("fld.FPERIOD"+y+" = 'DATE'");
		eval("fld.FPLAN_COR"+y+" = 'INT'");
		eval("fld.FFACT_COR"+y+" = 'INT'");
		for(tblNorm.MoveFirst(); !tblNorm.IsEOF(); tblNorm.MoveNext())
		{
			eval("fld.FNORM"+tblNorm.getValue("Fid_nast")+"_"+y+" = 'INT'");
			//для норм проставим дефолты из справочника норм
			eval("def.FNORM"+tblNorm.getValue("Fid_nast")+"_"+y+" = "+tblNorm.getValue("Fnorma_d"));
			eval("fld.FPLAN"+tblNorm.getValue("Fid_nast")+"_"+y+" = 'INT'");
			eval("fld.FFACT"+tblNorm.getValue("Fid_nast")+"_"+y+" = 'INT'");
		}
		d = goMonth(d, 12);
	}
	var ind = new Object();
	ind.FTABN_ID = "FTABN_ID";
	ind.FCOD = "FCOD";
	CreateTable(tblName, fld, ind, def);
	//отбираем всех сотрудников из периода, основные сотрудники и не служебные записи ШР
	ExecuteSQL("insert into "+tblName+" (Ftabn_id, Fcod, Ftxtorg, Fwid_org, Flv1, Flv2, Flv3, Flv4, Flv5, Fwrkdat, Fperiod) "
			+ " select Fwid_cl, Fcodpers, Ftxtorg, Fwid_org, Flv1, Flv2, Flv3, Flv4, Flv5, Fwrkdat, Fwrkdat "
			+ " from ^full_pers as f where "
				+ " Fwid=(select MAX(Fwid) from ^work_pers as wp where f.Fwid_cl=wp.Fwid_cl and wp.Fbdat<="
					+ sqlTo(gd.dat2)+" and wp.Fedat>="+sqlTo(gd.dat1)+" )"
				+ " and Ftable=1 and Fis_uv="+sqlFalse+" and Fis_serv="+sqlFalse);
	//если есть расширение NOTOTPVD, то таких сотрудников исключаем из расчета
	var oExt = new DpExtentionBuilder("CL",String(getPar("CODPERS")));
	var extTblName = oExt.getValueTableName();
	if(oExt.exist() && hasField(extTblName,"fnototpvd"))
		ExecuteSQL("delete from "+tblName+" where exists(select * from "+extTblName+" as e where e.Fmainwid="+tblName+".Ftabn_id and e.Fnototpvd="+sqlTrue+")");
	setProgressPos(step++, ru("Расчет периодов и норм отпусков...","Розрахунок періодів і норм відпусток..."));
	//перебиваем дату начала периода для отпусков датами из справочника
	var cdrpersdat = getPar("CDRPERSDAT");
	if(cdrpersdat)
	{
		ExecuteSQL("update "+tblName+" set Fperiod=(select MAX(Fdat) from ^listclpersdat as l "
						+" where l.Fcl="+cdrpersdat+" and l.Ftabn_id="+tblName+".Ftabn_id "
							+" and l.Fdat<="+sqlTo(gd.dat2)+")"
					+" where exists(select Fwid from ^listclpersdat as l where l.Fcl="+cdrpersdat
						+" and l.Ftabn_id="+tblName+".Ftabn_id and l.Fdat<="+sqlTo(gd.dat2)+")");
	} 
	d = new Date(D1).getVarDate();
	while(differ(d,D2)<=0)
	{
		var y = String(new Date(d).getFullYear());
		//обновляем даты периода отпусков для каждого года с учетом возможных дат из справочника
		ExecuteSQL("update "+tblName+" set Fperiod"+y+"="+IIF(toSqlDate(y, sqlMonth("Fperiod"), sqlDay("Fperiod"))+">=Fperiod",toSqlDate(y, sqlMonth("Fperiod"), sqlDay("Fperiod")),sqlTo(d00))+" where Fperiod<>"+sqlTo(d00));
		if(cdrpersdat)
		{
			ExecuteSQL("update "+tblName+" set Fperiod"+y+"=(select "+toSqlDate(y, sqlMonth("MAX(Fdat)"), sqlDay("MAX(Fdat)"))+" from ^listclpersdat as l "
								+" where l.Fcl="+cdrpersdat+" and l.Ftabn_id="+tblName+".Ftabn_id "
									+" and l.Fdat<="+sqlTo(lastDayYear(d))+")"
							+" where exists(select Fwid from ^listclpersdat as l "
								+" where l.Fcl="+cdrpersdat+" and l.Ftabn_id="+tblName+".Ftabn_id "
									+" and l.Fdat<="+sqlTo(lastDayYear(d))+")");
		}
//		eval("fld.FPERIOD"+y+" = 'DATE'");
//		eval("fld.FPLAN_COR"+y+" = 'INT'");
//		eval("fld.FFACT_COR"+y+" = 'INT'");

		var tmpTblWP = "tmp_otp_work_pers";
		CreateTable(tmpTblWP, "work_pers", "*");
		var flds = GetPatternIntersection("work_pers","work_pers");
		ExecuteSQL("insert into "+tmpTblWP+" ("+flds+") select "+flds+" from ^work_pers where Fbdat<="+sqlTo(lastDayYear(d))+" and Fedat>="+sqlTo(firstDayYear(d)));
		for(tblNorm.MoveFirst(); !tblNorm.IsEOF(); tblNorm.MoveNext())
		{
			//обновляем приоритетные нормы из иерархического справочника норм связей с другими справочниками
			if(otpnormlnk)
			{
				var tblNormLnk = OpenTable("select * from ^LISTCLNORMLNK where Fcl="+otpnormlnk+" and Fcod1="+tblNorm.getValue("Fcod")+" and Fbdat<="+sqlTo(lastDayYear(d))+" and Fedat>="+sqlTo(lastDayYear(d))+" order by Fcod");
				for(tblNormLnk.MoveFirst(); !tblNormLnk.IsEOF(); tblNormLnk.MoveNext())
				{
					var sWhere = getWhereLnk(tblNormLnk.getValue("Fclcl"),tblNormLnk.getValue("Fclcod"),firstDayYear(d),lastDayYear(d),tmpTblWP);
					ExecuteSQL("update "+tblName+" set Fnorm"+tblNorm.getValue("Fid_nast")+"_"+y+"="+tblNormLnk.getValue("Fnorma_d")+" where "+sWhere);
				}
				tblNormLnk.close();
			}
			//убираем норму тем, у кого первый день периода больше чем год отчета
			ExecuteSQL("update "+tblName+" set Fnorm"+tblNorm.getValue("Fid_nast")+"_"+y+"=0 where Fperiod>"+sqlTo(lastDayYear(d))+" or Fperiod>"+sqlTo(gd.dat2))
//			eval("fld.FNORM"+tblNorm.getValue("Fid_nast")+"_"+y+" = 'INT'");
//			eval("fld.FPLAN"+tblNorm.getValue("Fid_nast")+"_"+y+" = 'INT'");
//			eval("fld.FFACT"+tblNorm.getValue("Fid_nast")+"_"+y+" = 'INT'");
		}
		d = goMonth(d, 12);
	}
	setProgressPos(step++, ru("Расчет фактических и плановых данных...","Розрахунок фактичних і планових даних..."));
	d = new Date(D1).getVarDate();
	var sqlSumFactCor = "(";
	//формируем массив идентификаторов настроек отпускных относящихся к компенсации
	var tComp = OpenTable("select Fwid from ^nast_otp where Fis_comp="+sqlTrue);
	var arComp = new Array();
	for(; !tComp.IsEOF(); tComp.MoveNext())
		arComp[arComp.length] = Number(tComp.getValue("Fwid"));
	while(differ(d,D2)<=0)
	{
		var y = String(new Date(d).getFullYear());
		var year_beg = differ(firstDayYear(d),gd.dat1)<0?gd.dat1:firstDayYear(d);
		var year_end = differ(lastDayYear(d),gd.dat2)>0?gd.dat2:lastDayYear(d);
		var sqlSumNorm = "(";
		//var sqlSumPlan = "(";
		var sqlSumFact = "(";
		//на каждый год обнуляем признак проставления компенсации
		ExecuteSQL("update "+tblName+" set Fis_setcomp="+sqlFalse);
		for(tblNorm.MoveFirst(); !tblNorm.IsEOF(); tblNorm.MoveNext())
		{
			//проставляем плановые дни отпусков
			ExecuteSQL("update "+tblName+" set FPLAN"+tblNorm.getValue("Fid_nast")+"_"+y+"="+
					IIF("FPERIOD"+y+">"+sqlTo(gd.dat2), 0, 
						sqlRound(Convert("FNORM"+tblNorm.getValue("Fid_nast")+"_"+y+"/12*"
							+sqlRound(Convert("("+SqlDaysBWDates("FPERIOD"+y,(new Date(gd.dat2).getFullYear()>Number(y)?
								IIF(sqlTo(gd.dat2)+">FPERIOD"+(Number(y)+1),"FPERIOD"+(Number(y)+1),sqlTo(gd.dat2)):
									//sqlTo(gd.dat2)))+"+1)/30.42","DBL"),0),"DBL"),0))
									sqlTo(gd.dat2)))+")/30.42","DBL"),0),"DBL"),0))
						//+ " where exists(select * from ^cl_homo where Fwid_cl="+tblName+".Ftabn_id and Fwrkdat <="+sqlTo(year_end)+")"
						+ " where Fperiod<="+sqlTo(year_end)
						);
			//для социального отпуска плановые дни не корректируем, а берем строго по норме
			if(tblNorm.getValue("Ftxt").toLowerCase().indexOf("соц")!=-1)
			{
				ExecuteSQL("update "+tblName+" set FPLAN"+tblNorm.getValue("Fid_nast")+"_"+y+"=FNORM"+tblNorm.getValue("Fid_nast")+"_"+y
							//+ " where exists(select * from ^cl_homo where Fwid_cl="+tblName+".Ftabn_id and Fwrkdat <="+sqlTo(year_end)+")"
							+ " where Fperiod<="+sqlTo(year_end));
			}
			
			//проставляем фактические дни непереходящих в пределах года и расчетного периода отпусков
			ExecuteSQL("update "+tblName+" set FFACT"+tblNorm.getValue("Fid_nast")+"_"+y+"="
							+"(select SUM(t.Fdays) from ^otp_type as t inner join "
								+" ^prk_otp as p on t.Fid_doc=p.Fwid "
								+(usePrkLater?"":" inner join ^cdr_prk as cp on cp.Fwid=p.Fwid_prk")
							+" where t.Fwid_type="+tblNorm.getValue("Fid_nast")+" and p.Fwid_cl="+tblName+".Ftabn_id "
								+(usePrkLater?"":" and cp.Fdoc_dat<="+sqlTo(gd.dat2))//не учитываем введенные позже, если нужно
								//+" and p.Fbdat<="+sqlTo(year_end)+" and p.Fedat>="+sqlTo(year_beg)
								//+" and "+IIF("t.Fbperiod<"+sqlTo(d00), "t.Fbperiod", "p.Fbperiod")+" between "+sqlTo(year_beg)+" and "+sqlTo(year_end)+")"
								//т.к. анализируем периоды за который брался отпуск и нет возможности подсчтитать дни по переходящим отпускам, то учитываем лишь год даты начала периода
								+" and "+sqlYear(IIF("t.Fbperiod<"+sqlTo(d00), "t.Fbperiod", "p.Fbperiod"))+"="+sqlTo(new Date(year_beg).getFullYear())+")"
								//+" and "+sqlYear("p.Fbdat")+"="+sqlYear("p.Fedat")+")"
						+" where Fperiod<="+sqlTo(year_end)//не считаем тех, у кого первый день периода больше чем год отчета
							+" and exists(select t.Fwid from ^otp_type as t inner join "
								+" ^prk_otp as p on t.Fid_doc=p.Fwid "
								+(usePrkLater?"":" inner join ^cdr_prk as cp on cp.Fwid=p.Fwid_prk")
							+" where t.Fwid_type="+tblNorm.getValue("Fid_nast")+" and p.Fwid_cl="+tblName+".Ftabn_id "
								+(usePrkLater?"":" and cp.Fdoc_dat<="+sqlTo(gd.dat2))//не учитываем введенные позже, если нужно
								//+" and p.Fbdat>="+sqlTo(year_beg)+" and p.Fedat<="+sqlTo(year_end)+")"
								//+" and "+IIF("t.Fbperiod<"+sqlTo(d00), "t.Fbperiod", "p.Fbperiod")+" between "+sqlTo(year_beg)+" and "+sqlTo(year_end)+")"
								+" and "+sqlYear(IIF("t.Fbperiod<"+sqlTo(d00), "t.Fbperiod", "p.Fbperiod"))+"="+sqlTo(new Date(year_beg).getFullYear())+")"
								);
			//учитываем компенсацию отпуска в фактических днях отпускных не относящихся к очередному отпуску,
			//проставляем в первом попавшемся с ненулевой плановой суммой
			if(arComp.length>0 && !toScrObj(tblNorm.getValue("Fis_regular")))
			{
				ExecuteSQL("update "+tblName+" set FFACT"+tblNorm.getValue("Fid_nast")+"_"+y+"=FFACT"+tblNorm.getValue("Fid_nast")+"_"+y+"+"
							+"(select SUM(t.Fdays) from ^otp_type as t inner join "
								+" ^prk_otp as p on t.Fid_doc=p.Fwid "
							+" where t.Fwid_type in ("+arComp+") and p.Fwid_cl="+tblName+".Ftabn_id "
								//+" and p.Fbdat<="+sqlTo(year_end)+" and p.Fedat>="+sqlTo(year_beg)
								//+" and "+IIF("t.Fbperiod<"+sqlTo(d00), "t.Fbperiod", "p.Fbperiod")+" between "+sqlTo(year_beg)+" and "+sqlTo(year_end)+")"
								//т.к. анализируем периоды за который брался отпуск и нет возможности подсчтитать дни по переходящим отпускам, то учитываем лишь год даты начала периода
								+" and "+sqlYear(IIF("t.Fbperiod<"+sqlTo(d00), "t.Fbperiod", "p.Fbperiod"))+"="+sqlTo(new Date(year_beg).getFullYear())+")"
								//+" and "+sqlYear("p.Fbdat")+"="+sqlYear("p.Fedat")+")"
							+", FIS_SETCOMP="+sqlTrue
						+" where FPLAN"+tblNorm.getValue("Fid_nast")+"_"+y+">0 and Fis_setcomp="+sqlFalse+" and Fperiod<"+sqlTo(year_end)
							+" and exists(select t.Fwid from ^otp_type as t inner join "
									+" ^prk_otp as p on t.Fid_doc=p.Fwid "
								+" where t.Fwid_type in ("+arComp+") and p.Fwid_cl="+tblName+".Ftabn_id "
									//+" and p.Fbdat>="+sqlTo(year_beg)+" and p.Fedat<="+sqlTo(year_end)+")"
									//+" and "+IIF("t.Fbperiod<"+sqlTo(d00), "t.Fbperiod", "p.Fbperiod")+" between "+sqlTo(year_beg)+" and "+sqlTo(year_end)+")"
									+" and "+sqlYear(IIF("t.Fbperiod<"+sqlTo(d00), "t.Fbperiod", "p.Fbperiod"))+"="+sqlTo(new Date(year_beg).getFullYear())+")"
									);
			}
			//формируем сумму норм для плановых корректировок
			sqlSumNorm += "FNORM"+tblNorm.getValue("Fid_nast")+"_"+y+(tblNorm.bookmark==tblNorm.rowCount?")":"+");
			//формируем сумму фактических дней для фактических корректировок
			//sqlSumPlan += "FPLAN"+tblNorm.getValue("Fid_nast")+"_"+y+(tblNorm.bookmark==tblNorm.rowCount?")":"+");
			sqlSumFact += "FFACT"+tblNorm.getValue("Fid_nast")+"_"+y+"+";
		}
		sqlSumFact += "0)";
/*т.к. анализируем мы не фактические периоды отпусков, а периоды за которые они брались, то этот кусок пока закомментируем
		//проставляем фактические дни переходящих из одного года в другой отпусков или переходящих в пределах расчетного периода
		var tblOtpPers = OpenTable("select * from ^prk_otp "
									+" where (Fbdat<"+sqlTo(year_beg)+" and Fedat>="+sqlTo(year_beg)+")"
										+" or (Fbdat<="+sqlTo(year_end)+" and Fedat>"+sqlTo(year_end)+")");
		for(; !tblOtpPers.IsEOF(); tblOtpPers.MoveNext())
		{
			var tblOtpType = OpenTable("select t.*, n.Fid_nast from ^otp_type as t left join ^LISTCLNORM as n on t.Fwid_type=n.Fid_nast"
									+" where t.Fid_doc="+tblOtpPers.getValue("Fwid")
									+" order by t.Fwid");
			var d1 = new Date(tblOtpPers.getValue("Fbdat")).getVarDate();
			var isOutOfRang = false;
			for(; !tblOtpType.IsEOF(); tblOtpType.MoveNext())
			{
				var days = Number(tblOtpType.getValue("Fdays"));
				var alldays = Number(tblOtpType.getValue("Fdays"))+Number(tblOtpType.getValue("Fpdays"));
				//спрева смещаем дату только на кол-во дней отпуска
				d2 = goDay(d1,days-1);
				//если отпуск выходит за окончание периода
				if(differ(new Date(tblOtpPers.getValue("Fedat")).getVarDate(),year_end)>0)
				{
					//если данный отпуск переходит в следующий год или выходит за границу окончания периода, то расчитываем дни пересекающиеся с периодом
					if(differ(d2,year_end)>0)
					{
						days = day_difference(d1,year_end);
						isOutOfRang = true;
					}
				}
				else
				{
					//если данный отпуск переходит из прошлого года или начала периода, то расчитываем дни относящиеся к текущему периоду
					if(differ(d1,year_beg)<0 && differ(d2,year_beg)>0)
						days = day_difference(year_beg,d2);
				}
				//проставляем только если эта настройка присутсвует в справочнике норм
				if(tblOtpType.getValue("Fid_nast")>0)
					ExecuteSQL("update "+tblName+" set FFACT"+tblOtpType.getValue("Fwid_type")+"_"+y+"="+days
						+" where Ftabn_id="+tblOtpPers.getValue("Fwid_cl"))
				//если перешли в следующий год или вышли за границы окончания периода, то выходим из цикла
				if(isOutOfRang)
					break;
				//теперь смещаем с учетом праздничных дней
				d2 = goDay(d1,alldays-1);
				d1 = goDay(d2,1);
			}
			tblOtpType.close();
		}
		tblOtpPers.close();*/
		
		//проставляем плановые корректировки на начало периода
		ExecuteSQL("update "+tblName+" set FPLAN_COR"+y+"="+
					IIF(y+">"+sqlYear(sqlTo(gd.dat1)), 0, 
						sqlRound(Convert(sqlSumNorm+"/12*"
							+IIF(sqlTo(gd.dat1)+">FPERIOD"+y,
								sqlRound(Convert("("+SqlDaysBWDates("FPERIOD"+y,sqlTo(gd.dat1))+"+1)/30.42","DBL"),0),0),"DBL"),0))
					+ " where exists(select * from ^cl_homo where Fwid_cl="+tblName+".Ftabn_id and Fwrkdat <="+sqlTo(year_end)+")");
		//проставляем фактические корректировки на начало периода
		ExecuteSQL("update "+tblName+" set FFACT_COR"+y+"=FPLAN_COR"+y+"-"+sqlSumFact
					+" where "+sqlSumFact+"<FPLAN_COR"+y);
		d = goMonth(d, 12);
		sqlSumFactCor += "FFACT_COR"+y+(differ(d,D2)>0?")":"+");
	}
	setProgressPos(step++, ru("Расчет итогов...","Розрахунок підсумків..."));
	var sqlSumPlan = "(";
	var sqlSumFact = "(";
	var sqlSumPlanReg = "(";
	var sqlSumFactReg = "(";
	tblNorm2 = OpenTable("select n.*, o.Fnom, o.Fnazv as Ftxtotp "
					+ " from ^LISTCLNORM as n inner join ^nast_otp as o on o.Fwid=n.Fid_nast"
					+ " where n.Fcl="+otpnorm+" and n.Fbdat<="+sqlTo(gd.dat2)
						+" and n.Fedat>="+sqlTo(gd.dat1)+" and n.Fis_regular="+sqlTrue
					+ " order by  o.Fnom, n.Fbdat");
	for(tblNorm2.MoveFirst(); !tblNorm2.IsEOF(); tblNorm2.MoveNext())
	{
		d = new Date(D1).getVarDate();
		while(differ(d,D2)<=0)
		{
			var y = String(new Date(d).getFullYear());
			sqlSumPlanReg += "FPLAN"+tblNorm2.getValue("Fid_nast")+"_"+y+"+";
			sqlSumFactReg += "FFACT"+tblNorm2.getValue("Fid_nast")+"_"+y+"+";
			d = goMonth(d, 12);
		}
	}
	sqlSumPlanReg += "0)";
	sqlSumFactReg += "0)";
	tblNorm2 = OpenTable("select n.*, o.Fnom, o.Fnazv as Ftxtotp "
					+ " from ^LISTCLNORM as n inner join ^nast_otp as o on o.Fwid=n.Fid_nast"
					+ " where n.Fcl="+otpnorm+" and n.Fbdat<="+sqlTo(gd.dat2)
						+" and n.Fedat>="+sqlTo(gd.dat1)+" and n.Fis_regular="+sqlFalse
					+ " order by  o.Fnom, n.Fbdat");
	for(tblNorm2.MoveFirst(); !tblNorm2.IsEOF(); tblNorm2.MoveNext())
	{
		d = new Date(D1).getVarDate();
		while(differ(d,D2)<=0)
		{
			var y = String(new Date(d).getFullYear());
			sqlSumPlan += "FPLAN"+tblNorm2.getValue("Fid_nast")+"_"+y+"+";
			sqlSumFact += "FFACT"+tblNorm2.getValue("Fid_nast")+"_"+y+"+";
			d = goMonth(d, 12);
		}
	}
	sqlSumPlan += "0)";
	sqlSumFact += "0)";
	//проставляем баланс очередного отпуска
	ExecuteSQL("update "+tblName+" set Fregular="+sqlSumPlanReg+"-"+sqlSumFactReg
				+" where "+sqlSumPlanReg+"-"+sqlSumFactReg+">0");
	//проставляем баланс дополнительного отпуска
	ExecuteSQL("update "+tblName+" set Fadditional="+sqlSumPlan+"-"+sqlSumFact
				+" where "+sqlSumPlan+"-"+sqlSumFact+">0");
	//проставляем баланс всего
	ExecuteSQL("update "+tblName+" set Falldays=Fregular+Fadditional");
	//проставляем баланс с учетом начала периода
	ExecuteSQL("update "+tblName+" set Fcorrect=Falldays-"+sqlSumFactCor);
	tblNorm2.close();
	setProgressPos(0);
	//подобьем итоги
	createTotals();
}

function listMenuInit()
{
	with(this.dataSrc)
    {
		AddMenuItem ("","");
		switch(whereMode)
		{
			case "ONLYTOTAL":
				AddMenuItem("ONLYTOTAL", "Згорнути підсумки|Свернуть итоги",ICON_RADIO);
				AddMenuItem("NOTOTAL", "Без підсумків|Без итогов");
				AddMenuItem("ALL", "Розгорнути|Развернуть");
			break;
			case "NOTOTAL":
				AddMenuItem("ONLYTOTAL", "Згорнути підсумки|Свернуть итоги");
				AddMenuItem("NOTOTAL", "Без підсумків|Без итогов",ICON_RADIO);
				AddMenuItem("ALL", "Розгорнути|Развернуть");
			break;
			case "ALL":
			default:
				AddMenuItem("ONLYTOTAL", "Згорнути підсумки|Свернуть итоги");
				AddMenuItem("NOTOTAL", "Без підсумків|Без итогов");
				AddMenuItem("ALL", "Розгорнути|Развернуть",ICON_RADIO);
			break;
		}
    }
}

function listMenuRun(ID)
{
	switch(ID)
	{
		case "ONLYTOTAL":
		case "NOTOTAL":
		case "ALL":
			whereStr = (ID=="ONLYTOTAL"?"Ftt>0":(ID=="NOTOTAL"?"Ftt=0":"1=1"));
			whereMode = ID;
			grid.DeletePages();
			list.init();
		break;
	}
}

function filterMode(s)
{
	switch(s)
	{

	}
	return true;		
}

//формируем условие для последующего формирования звязей со справочниками
function getWhereLnk(fcl,fcod,fbdat,fedat,tmpTbl)
{
	var tblExtName;
	var sWhere = "1<>1";
	if(fcl==getPar("CODPERS"))
		sWhere += " or "+tblName+".Fcod="+fcod;
	if(fcl==getPar("CODDOL"))
		sWhere += " or exists (select * from ^full_pers as f where f.Fwid_cl="+tblName+".Ftabn_id and f.Fcoddol="+fcod+" and f.Fwid=(select MAX(Fwid) from "+tmpTbl+" as wp "
							+ " where wp.Fwid_cl="+tblName+".Ftabn_id))";
	if(fcl==getPar("CODKAT"))
		sWhere += " or exists (select * from ^full_pers as f where f.Fwid_cl="+tblName+".Ftabn_id and f.Fcodkat="+fcod+" and f.Fwid=(select MAX(Fwid) from "+tmpTbl+" as wp "
							+ " where wp.Fwid_cl="+tblName+".Ftabn_id))";
	//учитываем также справочники из расширений ШР
	var t = OpenTable("select * from ^cl_ext where Fclass="+sqlTo("SHTATEXT")+" and Ftype = "+sqlTo("A"+fcl));
	if(t.rowCount>0)
	{
		var oExt = new DpExtentionBuilder("SHTATEXT");
		if(oExt.exist())
		{
			tblExtName = oExt.getValueTableName();
			sWhere += " or exists (select * from "+tblExtName+" as e where e.F"+t.getValue("Flabel")+"="+fcod+" and f.Fwid=(select MAX(Fwid) from "+tmpTbl+" as wp "
							+ " where wp.Fwid=e.Fmainwid and wp.Fwid_cl="+tblName+".Ftabn_id and wp.Fbdat<="+sqlTo(fedat)+" and wp.Fedat>="+sqlTo(fbdat)+"))";
		}
	}
	t.close();
	return "("+sWhere+")";
}

function listUnLoad()
{
	if(tblNorm)
		tblNorm.close();
}

function getTblH()
{
	var h = new Object();
	h.HDAT1 = gd.dat1;
	h.HDAT2 = gd.dat2;
	return h;
}

function listDel()
{
	ExecuteSQL("delete from "+tblName+" where Fwid="+this.tbl.getValue("Fwid"));
	createTotals();
	return false;
}

function listMassDel()
{
	ExecuteSQL("delete from "+tblName+" where Fwid "+DataSource().sqlSelected(true));
	createTotals();
	return false;
}

function createTotals()
{
	ExecuteSQL("delete from "+tblName+" where Ftt>0");
	var D1 = firstDayYear(gd.dat1);
	var D2 = firstDayYear(gd.dat2);
	var d = new Date(D1).getVarDate();
	//формируем SQL для динамических полей
	var sFlds = "";
	while(differ(d,D2)<=0)
	{
		var y = new Date(d).getFullYear();
		for(tblNorm.MoveFirst(); !tblNorm.IsEOF(); tblNorm.MoveNext())
		{
			sFlds += ", SUM(Fplan"+tblNorm.getValue("Fid_nast")+"_"+y+") as Fplan"+tblNorm.getValue("Fid_nast")+"_"+y;
			sFlds += ", SUM(Ffact"+tblNorm.getValue("Fid_nast")+"_"+y+") as Ffact"+tblNorm.getValue("Fid_nast")+"_"+y;
			sFlds += ", 0 as Fnorm"+tblNorm.getValue("Fid_nast")+"_"+y;
		}
		sFlds += ", SUM(Fplan_cor"+y+") as Fplan_cor"+y;
		sFlds += ", SUM(Ffact_cor"+y+") as Ffact_cor"+y;
		d = goMonth(d, 12);
	}
	//общий итог
	var t = OpenTable("select SUM(Fregular) as Fregular, SUM(Fadditional) as Fadditional, SUM(Falldays) as Falldays, SUM(Fcorrect) as Fcorrect"+sFlds+" from "+tblName);
	if(t.rowCount>0)
	{
		var m = new Object();
		m = scatter(t);
		//delete(m.FWID);
		m.FTT = 2;
		UpdateTable(tblName, m, true);
	}
	t.close();
	//итоги по подразделениям первого уровня
	/*var t = OpenTable("select Flv1, SUM(Fregular) as Fregular, SUM(Fadditional) as Fadditional, SUM(Falldays) as Falldays, SUM(Fcorrect) as Fcorrect"+sFlds+" from "+tblName+" where Ftt=0 group by Flv1");
	for(; !t.IsEOF(); t.MoveNext())
	{
		var m = new Object();
		m = scatter(t);
		//delete(m.FWID);
		m.FTT = 1;
		UpdateTable(tblName, m, true);
	}
	t.close();*/
	//кадровики просят первое подразделение разбивать на итоги второго уровня, а в остальных оставить итоги первого уровня
	var t = OpenTable("select Flv1, Flv2, SUM(Fregular) as Fregular, SUM(Fadditional) as Fadditional, SUM(Falldays) as Falldays, SUM(Fcorrect) as Fcorrect"+sFlds+" from "+tblName+" where Ftt=0 and Flv1=1 group by Flv1,Flv2");
	for(; !t.IsEOF(); t.MoveNext())
	{
		var m = new Object();
		m = scatter(t);
		//delete(m.FWID);
		m.FTT = 1;
		UpdateTable(tblName, m, true);
	}
	var t = OpenTable("select Flv1, SUM(Fregular) as Fregular, SUM(Fadditional) as Fadditional, SUM(Falldays) as Falldays, SUM(Fcorrect) as Fcorrect"+sFlds+" from "+tblName+" where Ftt=0 and Flv1<>1 group by Flv1");
	for(; !t.IsEOF(); t.MoveNext())
	{
		var m = new Object();
		m = scatter(t);
		//delete(m.FWID);
		m.FTT = 1;
		UpdateTable(tblName, m, true);
	}
	t.close();
}
include("sys/DpList.js");