
var title = UR("Параметри системи|Параметры системы");
var tbl = createObjectTable();
var arrPar = new Array();
var sys = getSystem();

function onLoad()
{
	Caption(title);
	if(extPar && extPar.sys)
		sys = extPar.sys;
	sash.setWeights(new Array(600, 100));
	this.showComment = showComment;
	grid.setSelHandler(this, "showComment");
	loadParamList();
}

function showComment()
{
	try
	{
		FREM.value = "";
		var tbl = grid.getTable();
		if(!tbl.isEmpty())
			FREM.value = tbl.getValue("FREM");
	}
	catch(e){}
}

function loadParamList()
{
	var xmldoc = openXmlFile(rootDirectoryEx() +"syspar.xml");
	if(xmldoc)
		fillParams(xmldoc.getDocumentElement(), 0);
	var arrModules = lpProxy.getModules();
	for (var i=0; i<arrModules.length; i++)
	{
		var sFile = lpProxy.getModulePath(arrModules[i]) + "/syspar.xml";		
		var xmlDoc = openXmlFile(sFile, false);
		if(xmlDoc)
			fillParams(xmlDoc.getDocumentElement(), 0);
	}
	
	if(__isRazv)
	{
		grid.FieldEx("FTEXT", "Назва|Название", 20);
		grid.FieldEx("FPAR", "Мітка|Метка", 15);
		grid.FieldEx("FVAL", "Значення|Значение", 15);
		grid.FieldEx("FVID", "Вид|Вид", 6);
		grid.FieldEx("FSYS", "Підсистема|Подсистема", 10);
		grid.FieldEx("FREM", "Примітка|Примечание", 25);
	}
	else
	{
		grid.FieldEx("FTEXT", "Назва|Название", 20);
		grid.FieldEx("FVAL", "Значення|Значение", 15);
		grid.FieldEx("FREM", "Примітка|Примечание", 25);
	}
	grid.setTable(tbl);
	grid.build();
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid.loadMenuHandler(this, "gridMenuInit");
	grid.selectMenuHandler(this, "gridMenuRun");
}

function fillParams(xmldoc, nGrp)
{
	var nodes = xmldoc.getChildNodes();
	for(var i=0; i<nodes.getLength(); i++)
	{
		var node = nodes.item(i);
		var sPar = node.getNodeName();
		if(sPar.substring(0,1)=="#")
			continue;
		trace(i +" - "+ xmldoc.getNodeName() +" - "+ sPar +" > "+ node);
		var sSys = String(node.getAttribute("sys")).trim();
		if(sSys=="")
			sSys = String(xmldoc.getAttribute("sys")).trim();
		if(sys && sSys!="" && sSys.indexOf(sys)==-1)
			continue;
		var sType = String(node.getAttribute("type")).trim().toLowerCase();
		var sText = UR(String(node.getAttribute("text")).trim());
		var sParType = String(node.getAttribute("partype")).trim();
		arrPar[arrPar.length] = sPar;
		var sVal = "";
		if(sType=="group")
		{
			sPar = "";
			sText = str_repeat("   ", nGrp) + sText;
		}
		else
		{
			sVal = getPar(sPar);
			if(sVal==true)
				sVal = UR("так|да");
			if(sVal==false)
				sVal = UR("ні|нет");
			if(typeOf(sVal)=="Date")
				sVal = StrDat(sVal, "DMY");
			sVal = String(sVal);
			//if(sType && sType.indexOf("u")!=-1)
			//	sType = UR("user|user");
			sText = str_repeat("   ", (nGrp? nGrp : 1)) + sText;
		}
		tbl.AddNew();
		tbl.setValue("FWID", arrPar.length);
		tbl.setValue("FPAR", sPar);
		tbl.setValue("FVAL", sVal);
		tbl.setValue("FTEXT", sText);
		tbl.setValue("FTYPE", sType);
		tbl.setValue("FPARTYPE", sParType);
		tbl.setValue("FGROUP", xmldoc.getNodeName());
		tbl.setValue("FVID", node.getAttribute("vid"));
		tbl.setValue("FSYS", sSys);
		tbl.setValue("FDEF", node.getAttribute("default"));
		tbl.setValue("FREM", UR(node.getAttribute("rem")));
		tbl.setValue("FNODE", node.getNodeName());
		tbl.Update();
		if(sType=="group")
			fillParams(node, (nGrp+1));
	}
}

function gridMenuInit(oGrid)
{
	var tbl = oGrid.getTable();
	if(IsDblClick(oGrid))
	{
		if(extPar && extPar.ret)
		{
			extPar.ret.FPAR = tbl.getValue("FPAR");
			extPar.ret.FGROUP = tbl.getValue("FGROUP");
			CloseWindow();
			return true;
		}
		oGrid.runGridMenu("EDIT");
		return;
	}
	oGrid.AddMenuItem("EDIT", "Встановлення параметрів|Установка параметров");
}

function gridMenuRun(sID, oGrid)
{
	var tbl = oGrid.getTable();
	var rowID = Number(tbl.getValue("FWID"));
	switch(sID)
	{
	case "EDIT":
		var sSys = String(tbl.getValue("FSYS")).trim();
		if(sSys!="" && sSys.indexOf(getSystem())==-1)
		{
			alert(UR("Необхідно перейти у відповідну підсистему!|Нужно перейти в соответствующую подсистему!"));
			return false;
		}
		var par = new Object();
		par.sel = tbl.getValue("FGROUP");
		if(tbl.getValue("FTYPE")=="group")
			par.sel = tbl.getValue("FNODE");
		showWindow("e_param.xml", SW_MODAL, par);
		if(par.escape)
			return false;
		break;
	}
}

include("sys/DpBaseDlg.js");