include("Objects/DpXMLDomDocument.js");

var sInfoFile = "info.xml";
var arrPatterns = new Object();
var tbl;

function onLoad()
{
	Caption(UR("Шаблони|Шаблоны"));
			
	tbl = createObjectTable();
	var sPath = extPar.path;	
	var sDoc = extPar.doc;	
	if(!isDir(sPath))
		return tbl;
	if(sDoc)
	{
		loadPatterns(sPath, sDoc);
	}
	else
	{
		var dir = new DpFile(sPath);
		var listPatterns = dir.listFiles();
		if(!listPatterns)
			return;	
		for(var n=0; n<listPatterns.length; n++)
		{
			var sDoc = listPatterns[n].getName();
			if(isDir(sPath))
				loadPatterns(sPath, sDoc);
		}
	}		
		
	loadGrid();
}

function loadGrid()
{	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid.loadMenuHandler(this, "gridMenuInit");
	grid.selectMenuHandler(this, "gridMenuRun");
	
	grid.FieldEx("FDOC", "Документ|Документ", 10);	
	grid.FieldEx("FPATTERN", "Шаблон|Шаблон", 12);
	grid.FieldEx("FTXT", "Назва|Название", 20);
	//grid.FieldEx("FCALC", "Калькуляція|Калькуляция", 8);		
	grid.setTable(tbl);
	grid.build();
}

function loadPatterns(sPath, sDoc)
{
	var dir = new DpFile(sPath +"/"+ sDoc);
	var listPatterns = dir.listFiles();
	if(!listPatterns)
		return;	
	for(var n=0; n<listPatterns.length; n++)
	{
		var sName = listPatterns[n].getName();
		var sPath = listPatterns[n].getAbsolutePath();
		if(isDir(sPath))
		{
			addPattern(sDoc, sName, sPath);
		}
		else if(isFile(sPath) && sPath.indexOf(".zip")!=-1)
		{
			var sZipName = sPath;
			sPath = sPath.substring(0, sPath.indexOf(".zip"));
			if(isDir(sPath))
				continue;
			sPath = dir.getAbsolutePath();
			extract(sZipName, sPath);
			
			sName = sName.substring(0, sName.indexOf(".zip"));
			sPath += "/"+ sName;			
			addPattern(sDoc, sName, sPath);
		}
	}
}

function addPattern(sDoc, sName, sPath)
{
	var oPattern = getPattern(sPath);
	if(oPattern)		
		insertRecord(sDoc, sName, sPath, oPattern.txt, oPattern.calc);
	return oPattern;
}

function getPattern(sPath)
{
	var oPattern = new Object();
	var sTxt = "";
	var nCalc = 0;
	var sName = "";
	var infoXml = sPath + "/"+ sInfoFile;
	if(isFile(infoXml))
	{
		var xmlDom = new DpXMLDOMDocument();
		xmlDom.load(infoXml);
		var root = xmlDom.getDocumentElement();
		var eTxt = root.getElementsByTagName("txt")[0];
		if(eTxt)
			sTxt = UR(eTxt.getText());
		var eCalc = root.getElementsByTagName("calc")[0];
		if(eCalc)
			nCalc = eCalc.getText();
		var ePattern = root.getElementsByTagName("pattern")[0];
		if(ePattern)
			sName = ePattern.getText();				
	}			
		
	oPattern.name = sName;
	oPattern.txt = sTxt;
	oPattern.calc = nCalc;
	oPattern.path = sPath;
	return oPattern;
}

function insertRecord(sDoc, sName, sPath, sTxt, nCalc)
{	
	tbl.AddNew();
	tbl.setValue("ID", sName);
	tbl.setValue("FDOC", sDoc);
	tbl.setValue("FPATTERN", sName);
	tbl.setValue("FPATH", sPath);			
	tbl.setValue("FTXT", sTxt);
	tbl.setValue("FCALC", nCalc);			
	tbl.Update();
}

function gridMenuInit(ds)
{
	if(IsDblClick(ds))
	{
		gridMenuRun("SEL");
		return true;
	}
	
	var tbl = grid.getTable();
	if(tbl.isEmpty())
		return;
	
	if(extPar && extPar.ret)
		grid.AddMenuItem("SEL", "Вибрати\tENTER|Выбрать\tENTER");
	grid.AddMenuItem("DEL", "Видалити|Удалить");
}

function gridMenuRun(sID)
{
	switch(sID)
	{
		case "SEL":
			onSave();		
			CloseWindow();
			extPar.escape = false;
			break;
		
		case "DEL":
			var tbl = grid.getTable();
			var doc = tbl.getValue("FDOC");
			var nop = tbl.getValue("FPATTERN");
			var path = tbl.getValue("FPATH");
			var sMsg = UR("Знищити шаблон "+ doc +":"+ nop +"?|Уничтожить шаблон "+ doc +":"+ nop +"?");
			if(confirm(sMsg))
			{
				deleteDir(path);
				deleteFile(path +".zip");
				tbl.Delete();
				grid.refresh();
			}
			break;
	}
}

function onSave()
{
	if(extPar.ret)
	{
		extPar.ret.FPATTERN = tbl.getValue("FPATTERN");
		extPar.ret.FTXT = tbl.getValue("FTXT");
		extPar.ret.FDOC = tbl.getValue("FDOC");
		extPar.ret.FCALC = tbl.getValue("FCALC");
		extPar.ret.FPATH = tbl.getValue("FPATH");
	}
}