include("Objects\\DpTVars.js");
include("Objects\\DpGetDat.js");
include("Objects\\DpGrid.js");
include("sys\\servis.js");
include("sys\\udfs.js");
include("sub\\mtr.js");
include("GetParam.js");

var oGrid = new DpGrid("NOCREATE");
var tblName = getTmpTableName();
//var tblName = "TMP_REPORT_PZ";
var oTblMain = null,	
	oTblCol	= null,
	oDS = null,
	prnPatt = "REPPZ",
	bdat = null,
	edat = null,
	mol = null,
	moltxt = null;

function listLoad()
{	
	var globPar = new DpGetDat(new Array("r", "p0", "m0", "s:c0utx"));
	if(globPar.escape)
		return false;
		
	list.subUnLoad = close;
	
	bdat = globPar.dat1;
	edat = globPar.dat2;
	mol  = globPar.fmol;
	podr = globPar.fpodr;
	sc   = globPar.fsc;
	su   = globPar.fsu;
	st   = globPar.fst;
	sx   = globPar.fcl1? globPar.fcl1 : 0;
	moltxt = tcl("CL", "", getPar("CODMOL"), mol);
	
	strCaptionRU = "Материальный отчёт по списанию ТМЦ за период с "
					+ StrDat(bdat, "DMY") + " по " + StrDat(edat, "DMY") 
					//+ " для МОЛ: " + moltxt;
	strCaptionUA = "Матеріальний звіт по ТМЦ, що списано, за період з "
					+ StrDat(bdat, "DMY") + " до " + StrDat(edat, "DMY") 
					//+ " для МВО: " + moltxt;
	list.title = ru(strCaptionRU, strCaptionUA);
		
	//исходная таблица
	var strSQL = "SELECT a.fnmkl, a.fsc1, a.fsu1, a.fst1, "+ IIF("b.fcl_cod1 is NULL", "0", "b.fcl_cod1")+" as Fcl_cod1"
					+ ", SUM(a.fkol) AS famount, SUM(a.fcena*a.fkol) AS fsum, 0 as frowid"
				+ " INTO " + tblName 
				+ " FROM ^anltk AS a INNER JOIN ^sch_zag AS b ON (a.FID_DOC=b.FWID)"
				+ " WHERE (a.fdoc='PZ')"
					+ " AND (a.fdate BETWEEN " + sqlTo(bdat) + " AND " + sqlTo(edat) + ")"
					+ ((mol!=0)?  (" AND (a.fmol=" + sqlTo(mol) + ")")   : "")
					+ ((podr!=0)? (" AND (a.fpodr=" + sqlTo(podr) + ")") : "")
					+ ((sc!=0)?   (" AND (a.fsc1=" + sqlTo(sc) + ")")    : "")
					+ ((su!=0)?   (" AND (a.fsu1=" + sqlTo(su) + ")")    : "")
					+ ((st!=0)?   (" AND (a.fst1=" + sqlTo(st) + ")")    : "")
					//+ ((sx!=0)?   (" AND (b.fcl_cod1=" + sqlTo(sx) + ")"): "")
				+ " GROUP BY a.fnmkl, a.fsc1, a.fsu1, a.fst1, b.fcl_cod1, a.fcena"
				+ " ORDER BY a.fnmkl, a.fsc1, a.fsu1, a.fst1, b.fcl_cod1";
	ExecuteSQL(strSQL);

	var oSnap = getSnap("select fnmkl from "+ tblName);
	if(oSnap == null)
	{
		alert(ru("По указанным параметрам данных нет","По вказаних параметрах даних немає"));
		return false;
	}

	//таблица с итогами
	strSQL = "SELECT 0 as fnmkl, a.fsc1, a.fsu1, a.fst1, a.fcl_cod1, Sum(a.famount) AS famount, "
				+" Sum(a.fsum) AS fsum "
			+ " INTO "+ tblName +"_all"
			+ " FROM "+ tblName +" AS a "
			+ " GROUP BY a.fsc1, a.fsu1, a.fst1, a.fcl_cod1";
	ExecuteSQL(strSQL);
		
	strSQL = "ALTER TABLE "+ tblName +"_all ADD frowid "+ sqlType("COUNTER");
	ExecuteSQL(strSQL);	
	
	ExecuteSQL("UPDATE " + tblName + " SET frowid = (select a.Frowid from "+ tblName +"_all a "
					+" where a.Fsc1=" + tblName + ".Fsc1 and a.Fsu1=" + tblName + ".Fsu1 and a.Fst1=" + tblName + ".Fst1 and a.Fcl_cod1=" + tblName + ".Fcl_cod1)");

	//итоговая запись
	ExecuteSQL("INSERT INTO "+ tblName +" (fnmkl,fsc1,fsu1,fst1,fcl_cod1,famount,fsum,frowid) "
				+" VALUES (9999999,0,0,0,0,0,0, (select max(Frowid) from "+ tblName +"_all)+1)");
}

function listSrc()
{		
	//list.qrySet("Cross", tblName);
	//list.setFwidSrc("FROWID");
	
	list.qrySet("From", tblName, "Order", "Fnmkl, Frowid");	
	list.subTie("cl_nmk", "nmk", "Fwid", "Fnmkl");	
}

function listDpGrid()
{	
	var colSc = 0, colSu = 0, colSt = 0, colCl = 0, kol = 0, sum = 0;
	oTblCol = OpenTable("s", "select famount,fsum,fsc1,fsu1,fst1,fcl_cod1,frowid "
							+"from "+ tblName +"_all "
							+"order by frowid");
	var oGrid = new DpGrid("NOCREATE");
	
	oGrid.defCond("=^Fnmkl==9999999", "ITOG");
	oGrid.color(1, "ITOG");
	oGrid.bold("ITOG");		
	
	with (oGrid.prefix())
	{
		cell("=^Fnmkl!=9999999? ^nmk.Fcod : UR('Всього|Итого')", "Код\nноменклатури|Код\nноменклатуры", 5);
		cell("=^nmk.ftxts", "Назва\nноменклатури|Название\nноменклатуры", 20);
	}
	
	var oPage = oGrid.page();
	var oGroup = null;
	oTblCol.MoveFirst();
	while (!oTblCol.IsEOF())
	{
		colID = oTblCol.getValue("FROWID");
		colSc = oTblCol.getValue("Fsc1");
		colSu = oTblCol.getValue("Fsu1");
		colSt = oTblCol.getValue("Fst1");
		colCl = oTblCol.getValue("Fcl_cod1");
		kol = oTblCol.getValue("Famount");
		sum = oTblCol.getValue("Fsum");
				
		strCaptionGroup = colSc +"/"+ colSu +"/"+ colSt +"/"+ colCl;
		oGroup = oPage.group(String(strCaptionGroup));
		
		strCaptionCell = "Кіл-сть|Кол-во";
		sField ="=^Fnmkl==9999999? "+ kol +" : " 
				+"^Frowid=="+ colID +"? ^famount : ''";
		oGroup.cell(sField, strCaptionCell, 7);
		
		strCaptionCell = "Сума|Сумма";
		sField ="=^Fnmkl==9999999? "+ sum +" : " 
				+"^Frowid=="+ colID +"? ^fsum : ''";
		oGroup.cell(sField, strCaptionCell, 7);
		
		oTblCol.MoveNext();		
	}	
	oGrid.build();
}

function close()
{
	DropTable(tblName+ "_all");
	DropTable(tblName+ "_R");
	DropTable(tblName+ "_C");
	DropTable(tblName+ "_S");
	DropTable(tblName);
}

include("sys\\DpList.js");