include("Objects\\DpEval.js");
include("Objects\\DpGetDat.js");
include("Objects\\DpJournal.js");

var sTblName = "tmp_rnnp";
var gd;

function listTitle()
{
	return ru("Полученные налоговые накладные", "Отримані податкові накладні");
}

function listLoad()
{
	this.printLabel = "RNNP";
	gd = new DpGetDat("dD");
	if(gd.escape)	
		return false;

	DropTable(sTblName);
	
	var j = new DpJournal("U", "NN");

	//чтоб можно было из нулевой папки считать реестр и по другим зарегистрированным документам кроме NN
	var fdoc = extPar.fnop==0?"":extPar.fdoc;
	
	if (SUBD == MSSQL)
	{
		ExecuteSQL(
			"SELECT *"
			+ " INTO " + sTblName
			+ " FROM " + j.getFullTableName() + " "
			+ " WHERE n2 BETWEEN " + sqlTo(gd.dat1) + " AND " + sqlTo(gd.dat2)
				+ sqlw0And("hdoc=", fdoc)
				+ sqlw0And("hnop=", Number(extPar.fnop))
			+ " ORDER by n2 "
			);
		ExecuteSQL("ALTER TABLE " + sTblName + " ADD COLUMN N1 int default 0");
		ExecuteSQL("UPDATE " + sTblName + " set N1 = 0");
	}
	else
	{
		ExecuteSQL(
			"SELECT 0 as N1, j.*"
			+ " INTO " + sTblName
			+ " FROM " + j.getFullTableName() + " j"
			+ " WHERE n2 BETWEEN " + sqlTo(gd.dat1) + " AND " + sqlTo(gd.dat2)
				+ sqlw0And("j.hdoc=", fdoc)
				+ sqlw0And("j.hnop=", Number(extPar.fnop))
			+ " ORDER by n2 "
			);
	}

	
	ExecuteSQL(
		"INSERT INTO "+ sTblName+ "("
			+ "N1, N4,N6,N7,N8,N9,N10,"
			+ "N11,N12,N13,N14)"
		+ " SELECT 1 as N1, 'ВСЬОГО' AS N4"
			+ ", SUM(a.N6) AS N6"
			+ ", SUM(a.N7) AS N7"
			+ ", SUM(a.N8) AS N8"
			+ ", SUM(a.N9) AS N9"
			+ ", SUM(a.N10) AS N10"
			+ ", SUM(a.N11) AS N11"
			+ ", SUM(a.N12) AS N12"
			+ ", SUM(a.N13) AS N13"
			+ ", SUM(a.N14) AS N14"

		+ " FROM " + sTblName + " a"
		);	
	
//	setProgressPos(0);	
}

function listSrc()
{			
	this.qrySet("From", sTblName, "Order", "N1");		
}

function listDpGrid()
{
	include("Objects\\DpGrid.js");	
	var oGrid = new DpGrid("NOCREATE");
	with(oGrid)
	{
//		defCond("=^F_01=0", "TOT");
//		color(1, "TOT");
		with(page())
		{
			cell("ROWNUM", "№\nп/п", 3, null, "%10d")//.subCaption("1");
			with(group("Податкова накладна (вантажна митна декларація, чек, тощо)|"
					  +"Налоговая накладная (грузовая таможенная декларация, чек и т.п.)"))
			{
				cell("N2", "Дата\nотримання|Дата получения", 12)//.subCaption("2");
				cell("HVYP_DATE", "Дата\nвиписки|Дата выписки", 12)//.subCaption("2");
				cell("N3", "Номер", 10)//.subCaption("3");
				cell("HVID_DOC", "Вид док.", 3)
				with(group("Постачальник|Поставщик"))
				{
					cell("HORG", "Код", 5);
					cell("N4", "Назва|Название", 20)//.subCaption("4");
					cell("N5", "Індивідуальний\nподат.номер|Индивидуальный\nналог.номер"
						, 10)//.subCaption("5");
				}
			}
			cell("N6", "Загальна сума,\nвключаючи\nПДВ|Общая сумма,\nвключая\nНДС", 8)//.subCaption("6");
			with(group("Придбання, імпорт товарів (послуг, включаючи одержання від нерезидента)|"
					  +"Приобретение, импорт товаров (услуг, включая получение от нерезидента)"))
			{
				with(group("з метою їх використання у межах господарської діяльності|"
						  +"с цельлю их использования в пределах хозяйственной деятельности"))
				{
					with(group("підляг.оподат.за ставкою 20%,0%|подлежат налогообл.по ставке 20%,0%"))
					{
						fieldEx("N7", "вартість без ПДВ|стоимость (без НДС)", 12,"e",DP_FORMAT_SUM)//.subCaption("7");
						fieldEx("N8", "сума ПДВ|сумма НДС", 12,"e",DP_FORMAT_SUM)//.subCaption("8");
					}
					with(group("звільнені від оподаткування|освобождены от налогообложения"))
					{
						fieldEx("N9","вартість без ПДВ|стоимость (без НДС)",12,"e",DP_FORMAT_SUM)//.subCaption("9");
						fieldEx("N10","сума ПДВ|сумма НДС",12,"e",DP_FORMAT_SUM)//.subCaption("10");
					}					
				}
				with(group("не призначаються для їх використ.\nу господарській діяльності|"
						  +"не предназначены для их использ.\nв хозяйственной деятельности"))
				{
					fieldEx("N11","вартість без ПДВ|стоимость (без НДС)",12,"e",DP_FORMAT_SUM)//.subCaption("11");
					fieldEx("N12","сума ПДВ|сумма НДС",12,"e",DP_FORMAT_SUM)//.subCaption("12");
				}
				
				with(group("для поставки послуг,місце поставки\nвизнач. відпов.до п.6.5 ст.6 Закону|"
						  +"для поставки услуг,место поставки\nопред. в соотв.с п.6.5 ст.6 Закона"))
				{
					fieldEx("N13","вартість без ПДВ|стоимость (без НДС)",12,"e",DP_FORMAT_SUM)//.subCaption("13");
					fieldEx("N14","сума ПДВ|сумма НДС",12,"e",DP_FORMAT_SUM)//.subCaption("14");
				}								
			}
			cell("HISCOR", "Коррект.|Кориг.", 5)	
			cell("HSTAT", "Стаття|Статья", 5)		
		}			
		build();
	}
}

function numRow()
{
	return list.tbl.absolute;
}

function listMenuInit()
{
	list.dataSrc.AddMenuItem("DEBET2XSD",
			"Подготовить для электронной отчетности (Додаток №5)");
	list.dataSrc.AddMenuItem("REESTR2XSD",
			"Подготовить для электронной отчетности (Реестр налоговых накладных)");
			
	list.dataSrc.AddMenuItem("PRINT_DODATOK5_1", "Друк Додатку № 5 (II - 1)")
	list.dataSrc.AddMenuItem("PRINT_DODATOK5_2", "Друк Додатку № 5 (II - 2)")
}

function listMenuRun(ID)
{
	if (ID == "DEBET2XSD")
	{
			strName = "DODATOK5_CR";
			DropTable(strName);
			strSQL = "CREATE TABLE " + strName
					+ " ( FSUM "+SqlType("CURRENCY")
					+ " , FNDS "+SqlType("CURRENCY")
					+ " , FDATE "+SqlType("DATE")
					+ " , FINDNUM "+SqlType("TEXT", 20)
					+ " , FORG "+SqlType("LONG")
					+ " , FWID " + SqlType("COUNTER") + ")";
			ExecuteSQL(strSQL); 			

			// copy data to tmp table and set date			
			var tblName = getTmpTableName();
			ExecuteSQL("SELECT N7, N8, HORG as FORG, N2 as FDATE, FWID"
					+ ", HID_DOC AS FID_DOC, hnop AS fnop"
				+ " INTO " + tblName 
				+ " FROM tmp_rnnp"
				+ " WHERE HORG<>0"
					//+ " and " + DataSource().sqlSelected()
				);
				
			var tbl = OpenTable("s", tblName);
			
			for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
			{
				
				//var dat = xh_("NALDAT", null, "NN", tbl.getValue("HNOP"), tbl.getValue("HID_DOC"));
				var dat = getSnap("SELECT fvyp_date FROM ^hnn WHERE fwid=" + tbl.getValue("fID_DOC"))[0];
				if (isEmpty(dat))
					dat = tbl.getValue("FDATE");
				dat = firstDay(dat);
				ExecuteSQL("UPDATE " + tblName 
					+ " SET FDATE = " + sqlTo(dat) 
					+ " WHERE fwid = " + sqlTo(tbl.getValue("fwid")));
			}
			
			// Сгруппируем суммы по организации и дате
			var tbl = OpenTable("s", "SELECT "
				+ "SUM(N7) as FSUM, SUM(N8) as FNDS, FORG, FDATE"
					+ " FROM " + tblName
					+ " GROUP BY FORG, FDATE"
					+ " ORDER BY FORG, FDATE")
			for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
			{
				var m = new Object()
				m.FNDS = round(tbl.getValue("FNDS"), 2);
				m.FSUM = round(tbl.getValue("FSUM"), 2);
				m.FORG = tbl.getValue("FORG");
				m.FDATE = tbl.getValue("FDATE");
				m.FINDNUM = tcl("ORG", "CODNDS", m.FORG);
				if (Number(m.FINDNUM) == 0)
					m.FINDNUM = "X";
				
				updateTable(strName, m, true);
			}
			
			
			// 2-я часть
			strName = "DODATOK5_CR2";
			DropTable(strName);
			strSQL = "CREATE TABLE " + strName
					+ " ( FSUM "+SqlType("CURRENCY")
					+ " , FNDS "+SqlType("CURRENCY")
					+ " , FDATE "+SqlType("DATE")
					+ " , FINDNUM "+SqlType("TEXT", 20)
					+ " , FORG "+SqlType("LONG")
					+ " , FWID " + SqlType("COUNTER") + ")";
			ExecuteSQL(strSQL);			

			// copy data to tmp table and set date			
			var tblName = getTmpTableName();
			ExecuteSQL("SELECT n9, n10, n11, n12, n13, n14, hORG, n2 as hDATE, FWID, hID_DOC, hNOP INTO " + tblName
				+ " FROM tmp_rnnp"
				+ " WHERE horg<>0"
						+ " AND ( n10>0"
						+ " OR n12>0"
						+ " OR n14>0"
					+ ")"
					+ " and " + DataSource().sqlSelected()
				);
			/*
			var tbl = OpenTable("s", tblName);
			for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
			{
				var dat = xh_("NALDAT", null, "NN", tbl.getValue("hNOP"), tbl.getValue("hID_DOC"));
				if (isEmpty(dat))
					dat = tbl.getValue("hDATE");
				dat = firstDay(dat);

				ExecuteSQL("UPDATE " + tblName 
					+ " SET hDATE = " + sqlTo(dat) 
					+ " WHERE fwid = " + sqlTo(tbl.getValue("FWID")));
			}
			*/
			
			// Сгруппируем суммы по организации и дате
			var tbl = OpenTable("s", s = "SELECT "
				+ "SUM(n9+n11+n13) as hSUM, SUM(n10+n12+n14) as hNDS, hORG, hDATE"
					+ " FROM " + tblName
					+ " GROUP BY hORG, hDATE"
					)
		
			for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
			{
				var m = new Object()
				//m.FNDS = round(tbl.getValue("FNDS"), 0);
				//m.FSUM = round(tbl.getValue("FSUM"), 0);
				m.FNDS = tbl.getValue("hNDS");
				m.FSUM = tbl.getValue("hSUM");
				m.FORG = tbl.getValue("hORG");
				m.FDATE = tbl.getValue("hDATE");
				m.FINDNUM = tcl("ORG", "CODNDS", m.FORG);
				if (Number(m.FINDNUM) == 0)
					m.FINDNUM = "X";
				
				updateTable(strName, m, true);
			}
			
			
			
			
			
			alert(ru("Расчет окончен.", "Розрахунок завершено."))
	}
	else if(ID=="REESTR2XSD")
	{
		DropTable("REESTR_CR");
		
		strName = "REESTR_CR_NN";
		DropTable(strName);
		ExecuteSQL(
			"SELECT *"
			+ " INTO REESTR_CR_NN"
			+ " FROM tmp_rnnp"
				+ " WHERE HORG<>0"
			);
		alert(ru("Расчет окончен.", "Розрахунок завершено."))
	}	
	else if(ID=="PRINT_DODATOK5_1")
	{
		createD5();

		var tDodatok5 = OpenTable("s",
			"SELECT n4 as F_04, n5 as F_05"
				+ ", SUM(t.n7) AS F_07"
				+ ", SUM(t.n8) AS F_08"
				+ ", MAX(t.FWID) AS FWID"
				+ ", fdatnal"
			+ " FROM tmp_d5 t"
			+ " WHERE n7>0"
				+ " AND n8>0"
			+ " GROUP BY n4, n5, fDatNal"
			);

		include("Objects\\DpTVars.js");
		var tv = new DpTVars("LIST",this.printLabel);      
		   
		if(typeof getTblH=="function")
			tv.setHTbl(getTblH());
				
		tv.setRTbl(tDodatok5);
		
		tv.print();    
	}
	else if(ID=="PRINT_DODATOK5_2")
	{
		createD5();

		var tDodatok5 = OpenTable("s",
			"SELECT n4 as F_04, n5 as F_05"
				+ ", SUM(t.n9) AS F_09"
				+ ", SUM(t.n10) AS F_10"
				+ ", SUM(t.n11) AS F_11"
				+ ", SUM(t.n12) AS F_12"
				+ ", SUM(t.n13) AS F_13"
				+ ", SUM(t.n14) AS F_14"
				+ ", MAX(t.FWID) AS FWID"
				+ ", fdatnal"
			+ " FROM tmp_d5 t"
			+ " WHERE n10>0"
					+ " OR n12>0"
					+ " OR n14>0"
					+ ""
			+ " GROUP BY n4, n5, fdatnal"
			);

		include("Objects\\DpTVars.js");
		var tv = new DpTVars("LIST",this.printLabel);      
		   
		if(typeof getTblH=="function")
			tv.setHTbl(getTblH());
				
		tv.setRTbl(tDodatok5);
		
		tv.print();    
	}
	
}

function listOnPrnList(tv)
{
    var h = new Object();
    h.FD1  = gd.dat1;
    h.FD2  = gd.dat2;
    tv.setHTbl(h);
}


function createD5()
{
		DropTable("tmp_d5")
	
		var fldDatNal = "(select MAX(hnn.fvyp_date)"
				+ " FROM ^hnn hnn"
				+ " WHERE fwid=t.hid_doc"
			+ ")";
		fldDatNal = Convert(fldDatNal,"DATE");
	
	
		ExecuteSQL(
			"SELECT n1, n2, n4, n5, n7, n8"
				+ ", n9, n10, n11, n12, n13, n14"
				+ ", Fwid,"
				+ fldDatNal + " as fdatnal"
			+ " INTO tmp_d5"
			+ " FROM " + sTblName+ " t"
			+ " WHERE horg<>0"
			)
		var t5 = OpenTable("s", "tmp_d5")
		for(; !t5.IsEOF(); t5.MoveNext())
		{
			var datnal;
			
			if (!isEmpty(toScrObj(t5.getValue("fdatnal"))))
				datnal = firstDay(toScrObj(t5.getValue("fdatnal")))
			else
				datnal = firstDay(toScrObj(t5.getValue("n2")));
				
			ExecuteSQL(
				"UPDATE tmp_d5"
				+ " SET fdatnal=" + sqlTo(datnal)
				+ " WHERE fwid=" + sqlTo(t5.getValue("fwid"))
				)
		}

		t5.Close();


}
include("sys\\DpList.js")	