include("Objects/DpGrid.js");
include("Objects/DpCl.js");

var oNode;
var oStreet;
var oHouse;

function listLoad()
{
	this.editTask = "e_sku.xml";
	this.accEdit = accEdit;
	//this.accDel = accDel;
	
	oNode = new DpCl("0");
	oNode.setClcl(getPar("CODNODE"));
	oNode.linkSmartCtrl(FNODE);
	oNode.setContAssist();
	if(extPar.node)
		oNode.setCod(extPar.node);
	if(!getPar("CODNODE"))
		GRNODE.setVisible(false);
	oNode.AfterUpdate = filter;
	
	oStreet = new DpCl("0");
	oStreet.setClcl(getPar("CODSTREET"));
	oStreet.linkSmartCtrl(FSTREET);
	oStreet.setContAssist();
	if(extPar.street)
		oStreet.setFWID(extPar.street);
	oStreet.AfterUpdate = filter;
	
	oHouse = new DpCl("0", getPar("CODHOUSE"), 0, oStreet);
	oHouse.linkSmartCtrl(FHOUSE);
	oHouse.setContAssist();
	oHouse.addFldSearchSmart("FNOM");
	oHouse.isExactSearchSmart = true;
	oHouse.isCodeSearchSmart = false;
	if(extPar.house)
		oHouse.setFWID(extPar.house);
	oHouse.AfterUpdate = filter;
	
	DATB.value = getPar("GLOBDAT1");
	DATE.value = getPar("GLOBDAT2");
	
	this.filter = filter;
	setButton(BTNFILTER, this, "filter");
	setValid(TYPEPER, onChangePeriod);
	setValid(DATB, date_valid);
	setValid(DATE, date_valid);
}

function accEdit()
{
	return "ADV";
}

function filterMode(sMode)
{
	if(sMode=="COPY")
		return false;
	return true;
}

function accDel()
{
	if(skuCount(list.tbl.getRowID())>0)
		return false;
	return true;
}

function listDel()
{
	if(skuCount(list.tbl.getRowID())>0)
	{
		var sMsg = UR("Спочатку потрібно видалити відповідні рахунки!|Сначала нужно удалить соответствующие счета!");
		alert(sMsg);
		return false;
	}
	ExecuteSQL("delete from ^PRIVILEGE where FID_SKU="+ list.tbl.getRowID());
	return true;
}

function listTitle()
{
	return UR("Нарахування|Начисления");
}

function listSrc()
{
	this.qrySet("From", "^SKU", "Where", currWhere(), "Order", "FDOC_DAT");
	this.subTie("CL_HOUSE", "house", "FWID_CL", "FHOUSE");
	this.subTie("CL", "str", "FWID", "FSTREET");
	this.clTie("node", "="+ getPar("CODNODE") +", FNODE");
}

function listDpGrid()
{
	grid.build();
}

function currWhere()
{
	var dat1 = DATB.value;
	var dat2 = DATE.value;
	var sWhere = "1=1";
	if(differ(dat1, d00)==-1)
		sWhere += " and FDOC_DAT>="+ sqlTo(dat1);
	if(differ(dat2, d00)==-1)
		sWhere += " and FDOC_DAT<="+ sqlTo(dat2);
	if(oNode.getCod())
		sWhere += " and FNODE="+ oNode.getCod();
	if(oStreet.getFWID())
		sWhere += " and FSTREET="+ oStreet.getFWID();
	if(oHouse.getFWID())
		sWhere += " and FHOUSE="+ oHouse.getFWID();
	return sWhere;
}

function skuCount(fid_sku)
{
	var oSnap = getSnap("select count(*) as cnt from ^RAS_SKU where FID_SKU="+ fid_sku, false);
	if(oSnap && Number(oSnap[0]))
		return oSnap[0];
	return 0;
}

function skuSum(fid_sku)
{
	var oSnap = getSnap("select sum(FSUM) as FSUM from ^RAS_SKU where FID_SKU="+ fid_sku, false);
	if(oSnap && Number(oSnap[0]))
		return oSnap[0];
	return 0;
}

function listMenuInit(ds)
{
	if(!list.tbl.isEmpty())
	{
		if(IsDblClick())
		{
			ds.runGridMenu("VIEW");
			return;
		}
		ds.AddMenuItem("FIND_SKU", "Знайти рахунки|Найти счета");
		ds.AddMenuItem("CLEAREMPTY", "Вилучити нульові нарахування|Удалить нулевые начисления");
	}
	ds.AddMenuItem("REGCOUNTERS", "Ввести показники лічильників|Ввести показания счетчиков");
	ds.AddMenuItem("RECALC", "Перерахунок|Перерасчет");
	//ds.AddMenuItem("", "");
	//ds.AddMenuItem("ADD", "Сформувати нарахування|Сформировать начисления");
	//ds.AddMenuItem("VIEW", "Перегляд|Просмотр");
}

function listMenuRun(sMenuID)
{
	var fid_sku = list.tbl.getRowID();
	var date = list.tbl.getValue("FDOC_DAT");
	if(sMenuID=="FIND_SKU")
	{
		var par = new Object();
		par.doc = "SKU";
		par.nop = 1;
		par.fid_sku = fid_sku;
		par.bdat = firstDay(date);
		par.edat = lastDay(date);
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
	if(sMenuID=="REGCOUNTERS")
	{
		var par = new Object();
		par.date = today;
		showWindow("reg_counters.xml", SW_MODAL, par);
	}
	if(sMenuID=="RECALC")
	{
		var par = new Object();
		par.mode = sMenuID;
		par.date = list.tbl.getValue("FDOC_DAT");
		showWindow("e_sku.xml", SW_MODAL, par);
		if(!par.escape)
		{
			list.tbl.requery();
			list.grid.refresh();
		}
	}
	if(sMenuID=="CLEAREMPTY")
	{
		ExecuteSQL("delete from ^SKU where not exists (select r.FID_SKU from ^RAS_SKU r where r.FID_SKU=^SKU.FWID)");
		list.tbl.requery();
		list.grid.refresh();
	}
	/*
	if(sMenuID=="ADD" || sMenuID=="VIEW")
	{
		var par = new Object();
		par.mode = sMenuID;
		showWindow("e_sku.xml", SW_MODAL, par);
		if(sMenuID=="ADD" && !par.escape)
		{
			list.tbl.requery();
			list.grid.refresh();
		}
	}
	*/ 
}

function listInitEditParam(par)
{
	//par.org = oOrg.getCod();
	par.node = oNode.getCod();
	par.street = oStreet.getFWID();
	par.house = oHouse.getFWID();
}

function filter()
{
	list.qryWhere = currWhere();
	list.tblInit();
}

function date_valid()
{
	TYPEPER.value = "";
}

function onChangePeriod()
{
	var per = String(TYPEPER.value);
	switch (per)
	{
		case "TD":
			DATB.value = today.getVarDate();
			DATE.value = today.getVarDate();
			break;
		case "YTD":
			DATB.value = goDay(today, -1);
			DATE.value = goDay(today, -1);
			break;
		case "TW":
			DATB.value = goDay(today, -today.getDay());
			DATE.value = goDay(today,6 - today.getDay());
			break;
		case "TM":
			DATB.value = firstDayMonth(today);
			DATE.value = lastDayMonth(today);
			break;
		case "LM":
			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
			DATE.value = lastDayMonth(_dateTrans(today, "M+", -1));
			break;
		case "2M":
			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
			DATE.value = lastDayMonth(today);
			break;		
		case "TY":
			DATB.value = jan01(today);
			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "2Y":
			var bdat = new Date(today.getFullYear()-1, today.getMonth());
			DATB.value = jan01(bdat);
			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "ALL":
			DATB.value = d00min;
			DATE.value = d00;
			break;
		default:
			break;
	}
	filter();
}

include("sys/DpList.js");