include("Objects/DpGrid.js");

var isVDK = getSystem()=="VDK";

function listLoad()
{
	
}

function listTitle()
{
	if(extPar.title)
		return extPar.title;
	var txt = extPar.txt;
	return UR("Послуги|Услуги") + (txt? ": "+ txt : "");
}

function listSrc()
{
	var sWhere = "FID_DOC="+ extPar.fid_doc;
	if(extPar.fid_dog)
	{
		sWhere = "FID_DOG="+ extPar.fid_dog;
		if(extPar.date)
			sWhere += " and FDATE="+ sqlTo(extPar.date);
	}
	this.qrySet("From", extPar.tblName
				, "Where", sWhere
				, "Order", "FINPUT, FSERV"
				);
	this.subTie("CL_NMK", "nmk", "FWID", "FNMKL");
	if(isVDK)
		this.subTie("CL_INPUT", "inp", "FWID", "FINPUT");
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	with(oGrid.page())
	{	
		if(isVDK)
		{
			var oSnap = getSnap("select FINPUT from "+ extPar.tblName +" where FINPUT<>0");
			if(oSnap && Number(oSnap[0])!=0)
			{
				with(group("Ввід|Ввод"))
				{
					FieldEx("inp.FCOD", "Код", 5);
					FieldEx("inp.FPLACE", "Місце розташування|Место расположения", 10);
				}
			}
		}
		FieldEx("="+ lpProxy.getEnum("gek_serv").getEvalExp("^FSERV"), "Послуга|Услуга", 12);
		FieldEx("nmk.FTXTS", "Номенклатура|Номенклатура", 15);
		FieldEx("=^FID_COUNTER>0", "Ліч.|Сч.", 4);
		FieldEx("FNORM", "Норма|Норма", 8, "", DP_FORMAT_KOL);
		FieldEx("FKOL", "Кільк.|Колич.", 8, "", DP_FORMAT_KOL);
		//FieldEx("=^FKOL-^FPRIVKOL", "Без пільг|Без льгот", 8);
		FieldEx("FCENA", "Тариф|Тариф", 8, "", DP_FORMAT_PRI);
		FieldEx("FSUM", "Нараховано|Начислено", 8, "", DP_FORMAT_SUM);
		with(group("Пільги|Льготы"))
		{
			FieldEx("FPRIVKOL", "Кільк.|Колич.", 6, "", DP_FORMAT_KOL);
			FieldEx("FPRIVSUM", "Сума|Сумма", 6, "", DP_FORMAT_SUM);
		}
		FieldEx("FRECALC", "Перерахунок|Перерасчет", 8, "", DP_FORMAT_SUM);
		FieldEx("=^FSUM-^FPRIVSUM+^FRECALC", "Сума\nдо сплати|Сумма\nк оплате", 8, "", DP_FORMAT_SUM);
	}	
	oGrid.build();
}

function listMenuInit(ds)
{
	if(!list.tbl.isEmpty())
	{
		if(IsDblClick())
		{
			listMenuRun("DETAIL");
			return DpList_exit;
		}
		ds.AddMenuItem("DETAIL", "Об'єми|Объемы");
		if(list.tbl.getValue("FID_COUNTER")>0)
			ds.AddMenuItem("COUNTERS", "Показники лічильників|Показания счетчиков");
		if(Number(list.tbl.getValue("FPRIVSUM"))!=0)
			ds.AddMenuItem("LISTPRIV", "Пільги|Льготы");
	}
}

function listMenuRun(sID)
{
	if(sID=="DETAIL")
	{
		var par = new Object();
		par.tblName = extPar.sCountersTbl;
		par.fid_dog = list.tbl.getValue("FID_DOG");
		par.serv = list.tbl.getValue("FSERV");
		showWindow("l_sku_details.js", SW_MODAL, par);
	}
	else if(sID=="COUNTERS")
	{
		var par = new Object();
		par.org = list.tbl.getValue("FORG");
		par.fid_dog = list.tbl.getValue("FID_DOG");
		par.serv = list.tbl.getValue("FSERV");
		par.date = list.tbl.getValue("FDATE");
		showWindow("l_counters.xml", SW_MODAL, par);
	}
	else if(sID=="LISTPRIV")
	{
		var par = new Object();
		par.org = list.tbl.getValue("FORG");
		par.fid_dog = list.tbl.getValue("FID_DOG");
		par.serv = list.tbl.getValue("FSERV");
		par.date = list.tbl.getValue("FDATE");
		par.tblName = extPar.sPrivTbl;
		showWindow("l_sku_priv.js", SW_MODAL, par);
	}
}

include("sys/DpList.js");