include("Objects/DpAskEx.js");
include("Objects/DpGrid.js");
include("get_const.js");

var oAsk;
var tblName = "tmp_sprind";//результирующая таблица с итоговыми суммами
var tblRowsName = "tmp_rows_sprind";//таблица строк по месяцам, которую будем использовать при печати subReports
var D1, D2, flsfid, ftabn_id, isPens;

function listLoad()
{
	this.title = UR("Довідка про заробіток для обчислення індексації пенсії|Справка о заработке для вычисления индексации пенсии");
	this.printLabel = "SPRIND";
	oAsk = new DpAskEx();
	//oAsk.useDefsOnly = true;	//без этого ругается при считывании значений из параметров
	oAsk.add("D", "Дата початку|Дата начала", "BDAT", new Date().getVarDate());
	oAsk.add("D", "Дата закінчення|Дата конца", "EDAT", new Date().getVarDate());
	oAsk.add("LS", "Поле ОР індексації|Поле ЛС индексации", "INDLS", 0);
	oAsk.add("CL0", "Таб.№ (0 для всіх)|Таб.№ (0 для всех)", "TABN", 0, getPar("CODPERS"));
	oAsk.add("B", "Пенсіонери|Пенсионеры", "IS_PENS", false);
	oAsk.setValid("EDAT",edatValid)
	oAsk.defCond("this.aQryList['IS_PENS'].controls[0].checked == false", "COND_IS_PENS");
	oAsk.enable("TABN", "COND_IS_PENS");
	oAsk.doAsk();
	if(oAsk.escape)
		return false;
	D1 = new Date(oAsk.get("BDAT")).getVarDate();
	D2 = new Date(oAsk.get("EDAT")).getVarDate();
	flsfid = oAsk.get("INDLS").getFid();
	ftabn_id = oAsk.get("TABN").getFWID();
	isPens = oAsk.get("IS_PENS");
	this.title += format(" за dd.mm.yy-",D1)+format("dd.mm.yy",D2);
}

function listSrc()
{
	this.qrySet("From",tblName,"Order","Fcod");
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	with(gr)
	{
		FieldEx("Fcod", "Таб №|Таб №", 4);
		FieldEx("=getSmallFIO(^Ftxt)", "ПІБ|ФИО", 15);
		with(group("Сума|Сумма"))
		{	
			FieldEx("Fsumbase", "оплати праці|оплаты труда", 6, "", DP_FORMAT_SUM);
			FieldEx("Fsumogr", "проіндексована|проиндексированная", 6, "", DP_FORMAT_SUM);
			FieldEx("Fsum", "індексації|индексации", 6, "", DP_FORMAT_SUM);
		}
		FieldEx("Findnum", "Ідент.№|Идент.№", 10);
		FieldEx("Ftxtdol", "Посада|Должность", 15);
		FieldEx("Fadr", "Адреса|Адрес", 15);
		FieldEx("Fvopl", "Вид оплати|Вид оплаты", 10);
	}
	oGrid.build();   		
}

function listMake()
{
	var fld = new Object();
	fld.FWID = "COUNTER";
	fld.FCOD = "LONG";
	fld.FTABN_ID = "LONG";
	fld.FINDNUM = "TEXT";
	fld.FTXT = "TEXT";
	fld.FTXTDOL = "TEXT";
	fld.FADR = "TEXT";
	fld.FSUMBASE = "MONEY";
	fld.FSUMOGR = "MONEY";
	fld.FSUM = "MONEY";
	fld.FVOPL = "INT";
	
	var ind = new Object();
	ind.FTABN_ID = "FTABN_ID";
	CreateTable(tblName, fld, ind);
	
	delete(fld.FCOD);
	delete(fld.FINDNUM);
	delete(fld.FTXT);
	delete(fld.FTXTDOL);
	delete(fld.FADR);
	delete(fld.FVOPL);
	fld.FDATE = "DATE";
	ind.FDATE = "FDATE";
	CreateTable(tblRowsName, fld, ind);
	
	var d = new Date(D1).getVarDate();
	var md = month_difference(new Date(D1),new Date(D2));
	var step = 1;
	setProgressRange(step, md+3);
	while(differ(d,D2)<=0)
	{
		var tblSVZPName = "SVZP"+getDateTag(d);
		var prmin = get_cnst("prmin", d);
		if(!prmin)
		{
			setProgressPos(0);
			alert(ru("Не определена константа прожиточного минимума prmin за ","Не визначена константа прожиткового мінімуму prmin за ")+format("Mmm yyyy",d).toLowerCase())
			return false;
		}
		setProgressPos(step++, UR("Індексація за |Индексация за ")+format("Mmm yyyy",d).toLowerCase());
		if(IsTableEx("ZRP_RES", "ZRP_"+tblSVZPName))
		{
			//вычисляем сумму подлежащую индексации
			ExecuteSQL("insert into "+tblRowsName+" (Fdate, Ftabn_id, Fsumbase) "
						+" select "+sqlTo(d)+" as Fdate, s.Ftabn_id, SUM(s.Fsum)as Fsumbase "
						+" from ^"+tblSVZPName+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
						+" where l.Fis7="+sqlTo("+")+" and (s.Fvp=0 or (s.Fvp=2 and s.Fmn<"+sqlTo(d)+"))"
							+(ftabn_id?" and s.Ftabn_id="+ftabn_id:"")
								+(isPens ?" and exists(select Fwid from ^work_pers as wp where wp.Fwid_cl=s.Ftabn_id and wp.Fbdat<="+sqlTo(lastDayMonth(d))
									+"  and wp.Fedat>="+sqlTo(firstDayMonth(d))+" and wp.Fpens="+sqlTrue+")":"")
						+" group by s.Ftabn_id");
			//вычисляем сумму индексации
			ExecuteSQL("update "+tblRowsName+" set Fsum=(select SUM(s.Fsum) as Fsum "
							+" from ^"+tblSVZPName+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
							+" where s.Ftabn_id="+tblRowsName+".Ftabn_id and s.Flsfid="+flsfid+" and (s.Fvp=0 or (s.Fvp=2 and s.Fmn<"+sqlTo(d)+"))"
							+" group by s.Ftabn_id)"
						+" where Fdate="+sqlTo(d));
		}
		d = goMonth(d, 1);
	}
	setProgressPos(step++, UR("Обчислення суми, що індексується...|Вычисление индексируемой суммы..."));
	ExecuteSQL("update "+tblRowsName+" set Fsum=0 where Fsum is null");
	//вычисляем индексируемую сумму с учетом ограничения прожиточного минимума
	ExecuteSQL("update "+tblRowsName+" set Fsumogr="+IIF("Fsumbase<"+prmin, "Fsumbase", prmin));
	setProgressPos(step++, UR("Обчислення підсумків...|Вычисление итогов..."));
	//итоговые суммы
	ExecuteSQL("insert into "+tblName+" (Ftabn_id, Fsumbase, Fsumogr, Fsum) "
				+" select Ftabn_id, SUM(Fsumbase) as Fsumbase, SUM(Fsumogr) as Fsumogr, SUM(Fsum) as Fsum "
				+" from ^"+tblRowsName
				+" group by Ftabn_id");
	setProgressPos(step++, UR("Обробка особистих даних співробітників...|Обработка личных данных сотрудников..."));
	ExecuteSQL("update "+tblName+" set Fcod=(select Fcod from ^listcl as l where "+tblName+".Ftabn_id=l.Fwid_cl) where exists(select Fwid from ^listcl as l where "+tblName+".Ftabn_id=l.Fwid_cl)");
	ExecuteSQL("update "+tblName+" set Ftxt=(select Ftxt from ^listcl as l where "+tblName+".Ftabn_id=l.Fwid_cl) where exists(select Fwid from ^listcl as l where "+tblName+".Ftabn_id=l.Fwid_cl)");
	ExecuteSQL("update "+tblName+" set Findnum=(select Findnum from ^listcl3 as l where "+tblName+".Ftabn_id=l.Fwid_cl) where exists(select Fwid from ^listcl3 as l where "+tblName+".Ftabn_id=l.Fwid_cl)");
	ExecuteSQL("update "+tblName+" set Fadr=(select Faddr from ^listcl3 as l where "+tblName+".Ftabn_id=l.Fwid_cl) where exists(select Fwid from ^listcl3 as l where "+tblName+".Ftabn_id=l.Fwid_cl)");
	ExecuteSQL("update "+tblName+" set Ftxtdol=(select Ftxtdol from ^full_pers as f where "+tblName+".Ftabn_id=f.Fwid_cl and f.Fwid=(select MAX(Fwid) from ^work_pers as wp where f.Fwid_cl=wp.Fwid_cl and wp.Fbdat<="+sqlTo(D2)+" and wp.Fedat>="+sqlTo(D1)+")) where exists(select Fwid from ^full_pers as f where "+tblName+".Ftabn_id=f.Fwid_cl)");
	ExecuteSQL("update "+tblName+" set Fvopl=(select Fvopl from ^full_pers as f where "+tblName+".Ftabn_id=f.Fwid_cl and f.Fwid=(select MAX(Fwid) from ^work_pers as wp where f.Fwid_cl=wp.Fwid_cl and wp.Fbdat<="+sqlTo(D2)+" and wp.Fedat>="+sqlTo(D1)+")) where exists(select Fwid from ^full_pers as f where "+tblName+".Ftabn_id=f.Fwid_cl)");
	setProgressPos(0);
}

function edatValid()
{
	if(differ(oAsk.get("EDAT"),oAsk.get("BDAT"))<0)
	{
		WAIT(UR("Дата закінчення не може бути меньшою за дату початку!|Дата окончания не может быть меньше даты начала!"))
		return false;
	}
	return true;
}

include("sys/DpList.js");