include("Objects/DpNmkl.js");
include("Objects/DpCl.js");
include("doc/DpDoc.js");
include("gridedit.js");

var tmpName = getTmpTableName();
var workTbl; 
var par = Object();
var bSave = false;
var oLpu;
var oBud;
var sFilter;
var dpGridEdit;

function listLoad()
{	
	this.title = "Сторнування послуг|Сторнирование услуг";
	if(extPar.tnmk)
		this.title += ": "+ extPar.tnmk;
	if(extPar.Frudate)
		this.title += ru(" от "," від ")+ StrDat(extPar.Frudate, "DMY");
	this.subUnLoad = onExit;

	oLpu = new DpCl("0");
	oLpu.linkSmartCtrl(FLPU);
	oLpu.setClcl(getPar("CODPLAT"));
	oLpu.setContAssist();
	if(extPar.oLpu)
		oLpu.setCod(extPar.oLpu);
	
	oBud = new DpCl("0");
	oBud.setClcl(93);
	oBud.linkCtrl(FBUD, FBUD_TXT);
	if (extPar.oBud)
		oBud.setCod(extPar.oBud);
	/*
	oNmkl = new DpNmkl();
	oNmkl.linkCtrl(Fnmkl, Fnmkl_txt);
	oNmkl.setContAssist();
	if(extPar.fnmk)
		oNmkl.setCod(Number(extPar.fnmk));
	Disable(Fnmkl);
	*/	
	Fkol.mask = MASK_KOL;
	Fsum.mask = MASK_SUM;
	Fkol_cor.mask = MASK_KOL;
	Fsum_cor.mask = MASK_SUM;
	
	Disable(Fkol);
	Disable(Fsum);
	Disable(Fkol_cor);
	Disable(Fsum_cor);
		
	this.save = onSave;
	this.escape = onEscape;
	this.changePar = changePar;
	setButton(btnChange, this, "changePar");	
	
	loadRU();
	recalcSum();	
}

function listSrc()
{	
	var sWhere = "1 = 1";	
	if (extPar.oObl != null && extPar.oObl != 0)
		sWhere += " AND FREGION=" + sqlTo(extPar.oObl);
	if (extPar.oArea != null && extPar.oArea != 0)
		sWhere += " AND FAREA=" + sqlTo(extPar.oArea);
	if (extPar.oBud != null && extPar.oBud != 0)
		sWhere += " AND FBUDJET=" + sqlTo(extPar.oBud);
	sFilter = sWhere;
	if (extPar.oLpu != null && extPar.oLpu != 0)
		sWhere += " AND FLPU=" + sqlTo(extPar.oLpu);
		
	this.qrySet("From", workTbl
				,"Where", sWhere
				,"WhereArr", new Array("FCORKOL>0 or FCORKOL<0")
				,"WhereArrName", Array(ru("Корректировки","Коригування"))
				,"Order", "Fcod"
				);	
	this.clTie("cl","=" + sqlTo(getPar("CODPLAT"))+", Fcod");	
}

function changePar()
{
	var sWhere = sFilter;
	if(FLPU.value!="")
		sWhere += " AND FLPU="+ oLpu.getCod();
	if(FBUD.value!="" && FBUD.value!=0)	
		sWhere += " AND FBUDJET="+ oBud.getCod();
	list.qryWhere = sWhere;
	list.tblInit();
	recalcSum();
}

function listDpGrid()
{	
	//include("Objects/DpGrid.js");
	//var oGrid = new DpGrid("NOCREATE");
	//var page = oGrid.page();
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.saveRecord = saveRecord;
	dpGridEdit.canEdit = canEditRecord;
	
	grid.defCond("EXIST", "=^FEXIST=="+ sqlTrue);	
	grid.color(2, "EXIST");
	
	with(grid)
	{
		FieldEx("Fdog", "Договор №|Договор №", 8);
		with(addGroup("Контрагент|Контрагент"))
		{
			FieldEx("Fcod", "Код|Код", 8);
			FieldEx("cl.Ftxt", "Назва|Наименование", 10);
		}
		FieldEx("Fdifkol", "Змін.|Изм.", 8, "e", DP_FORMAT_KOL);
		FieldEx("Fcorkol", "Кориг.(+/-)|Коррект.(+/-)", 8, "", DP_FORMAT_KOL);
		FieldEx("Fkol", "Кільк.|Кол-во", 8, "", DP_FORMAT_KOL);
		FieldEx("Fcena", "Ціна|Цена", 8, "", DP_FORMAT_PRI);	
		FieldEx("=(^Fkol!=null)?round(^Fkol*^Fcena,2):''", "Сума|Сумма", 8, "", DP_FORMAT_SUM);
		FieldEx("Fdoc_num", "№ док.|№ док.", 8);
	}	
	grid.build();
}

function listMenuInit()
{
	var tbl = grid.getTable();
	var isCor = tbl.getValue("FCORKOL")<0 || tbl.getValue("FCORKOL")>0;
	if (!tbl.isEmpty() && isCor)
		grid.AddMenuItem("SU_HISTORY", "Історія |История ");
}

function listMenuRun(sID)
{
	if(sID=="SU_HISTORY")
	{
		showHistory();
		return true;
	}
}

function saveRecord()
{
	var rowID = parseInt(grid.getTable().getValue("FWID"));
	var nDifKol = Number(grid.getTable().getValue("FDIFKOL"));
	var sNewKol = IIF("FCORKOL is NULL", nDifKol, "FCORKOL+"+ nDifKol);
	if(nDifKol==0)
		sNewKol = 0;
	ExecuteSQL("update "+ workTbl +" set FCORKOL="+ sNewKol
				+" where FWID="+ rowID);
	recalcSum();
	return true;
}

function canEditRecord()
{
	var exist = grid.getTable().getValue("FEXIST");
	if(exist==true)
	{
		var sMsg = UR("Данні по цьому контрагенту вже введені!\nПродовжити редагування?|Данные по этому контрагенту уже введены!\nПродолжить редактирование?");
		if(!confirm(sMsg))
			return false;
	}
	return true;
}

function loadRU()
{
	workTbl = (extPar.tblName)?extPar.tblName:getTmpTableName();
	
	tblName = (extPar.FltName)?extPar.FltName:"CLRELCLCL";
	
	ExecuteSQL("CREATE TABLE " + workTbl + "("
				+ "FCOD " + SqlType("LONG") + ", "
				+ "FDATE " + SqlType("DATE") + ", "
				+ "FDOC_NUM " + SqlType("TEXT") + ", "
				+ "FCOUNTRY " + SqlType("LONG") + ", "
				+ "FREGION " + SqlType("LONG") + ", "
				+ "FAREA " + SqlType("LONG") + ", "
				+ "FLOCATE " + SqlType("LONG") + ", "
				+ "FLPU " + SqlType("LONG") + ", " 
				+ "FBUDJET " + SqlType("LONG") + ", " 
				+ "FDOG " + SqlType("TEXT",25)+ ", "
				+ "FID_DOG " + SqlType("LONG")+ ", "
				+ "FNMKL " + SqlType("LONG")+ ", "
				+ "FZONE " + SqlType("LONG") + ", "
				+ "FCENA " + SqlType("CURRENCY") + ", "
				+ "FKOL " + SqlType("CURRENCY") + ", "
				+ "FDIFKOL " + SqlType("CURRENCY") + ", "
				+ "FCORKOL " + SqlType("CURRENCY") + ", "
				+ "FOLDKOL " + SqlType("CURRENCY") + ", "
				+ "FEXIST " + SqlType("BYTE") + " default "+ SqlFalse +", "
				+ "FWID " + SqlType("COUNTER")
				+ ")"
			);
	createIndex(workTbl, "SUMASS", "FNMKL,FID_DOG,FCOD,FCENA");
	
	var dat = new Date(extPar.dat.getYear()+1900,0,0);
	include ("Objects\\DpExtentionBuilder.js");
	var oBujet = new DpExtentionBuilder("CL","0",null);
	var tblBudName = oBujet.getValueTableName();

	ExecuteSQL("INSERT INTO " + workTbl + "(FCOD,FCOUNTRY,FREGION,FAREA,FLOCATE"
				+",FLPU,FDOG,FID_DOG,FZONE,FCENA,FDATE,FNMKL,FKOL,FOLDKOL,FDOC_NUM) "
			+" SELECT c.forg,td.fcountry,td.fregion,td.farea,td.flocate,td.flpu"
				+",c.fdog_num,ru.FID_DOG,td.fzone,"+ sqlRound("ru.FCENA", 2)
				+",ru.FDATE,ru.FNMKL,ru.FKOL,ru.FKOL,h.FDOC_NUM"
			+" from ^RRU as ru "
				+" inner join ^HRU h on h.FWID=ru.FID_DOC"
				+" inner JOIN ^contract as c ON c.FWID=ru.FID_DOG "
				+" inner join ^htd as td on c.FWID=td.FID_DOG "				
				//+" INNER JOIN ^CLRELCLCL as cl ON c.Forg=cl.Fcod "				
				//+" LEFT JOIN "+ tblBudName +" as ext ON ext.Fmainwid=cl.fwid_cl "  
			+" where ru.FDOC='RU'"
				//+" and c.fbdat>=" + sqlTo(dat) 
				//+" and cl.Fcl="+ getPar("CODPLAT")
				+" and ru.FNMKL="+ extPar.fnmk
				+" and ru.FDATE="+ sqlTo(extPar.Frudate)
			);
/*				
	var oDoc = new DpDoc("TD",0);
	var tf = oDoc.getPar("__tarif");
	if (tf == 0)
	{
		alert(UR("Виконайте налагодження документу TD|Настройте документ TD"));
		return false;
	}
	var oExt = new DpExtentionBuilder("CL",tf,null);
	var tblEName = oExt.getValueTableName();

	ExecuteSQL("update " + workTbl+ " as a "
			+" set Fcena=(select FTARIF from " + tblEName 
				+ " where FBDAT = (select MAX(FBDAT) from " + tblEName 
					+ " where fzona = a.fzone"
			 			+ " and FBDAT<=" + sqlTo(extPar.dat) 
			 		+ " group by fzona)"
			 	+" and fzona = a.fzone )" );
*/	
	ExecuteSQL("update "+ workTbl
			+" set FCORKOL=(select sum(r.FKOL) as FKOL from ^RRU as r "
				+" inner join ^HRU h on h.FWID=r.FID_DOC"
				+" where r.FDOC='SU'"
					+" and r.FNMKL="+ workTbl +".FNMKL "
					+" and r.FCENA="+ workTbl +".FCENA "
					+" and r.FID_DOG="+ workTbl +".FID_DOG"
					+" and r.FCLIENT="+ workTbl +".FCOD"	
					+" and h.FRU_DAT="+ sqlTo(extPar.Frudate)				
				+" group by r.FID_DOG, r.FNMKL, r.FCLIENT, r.FCENA)");
	extPar.tblName = workTbl;
	
	var sRowTbl = extPar.rowName;
	if(sRowTbl)
	{
		ExecuteSQL("update "+ workTbl +" w set w.FEXIST="+ SqlTrue 
				+" where w.FCOD in (select r.FCLIENT from "+ sRowTbl +" r )");
	}
}

function onExit()
{
	/*
	if(!bSave)
		bSave = confirm(ru("Сохранить введенные данные?","Зберегти введені дані?"));
	*/
	if (!bSave)
		ExecuteSQL("update "+ workTbl +" set FDIFKOL=0");
	extPar.tblName = workTbl;	
}

function onSave()
{
	bSave = true;			
	CloseWindow();
	extPar.escape = false;		
}

function onEscape()
{
	CloseWindow();
	extPar.escape = true;	
}

function recalcSum()
{
	Fkol.value = 0;
	Fsum.value = 0;
	Fkol_cor.value = 0;
	Fsum_cor.value = 0;
	var sWhere = "";
	if(list.qryWhere!="" && list.qryWhere!=null)
		sWhere = " where "+ list.qryWhere;
	var sKol = IIF("Foldkol is NULL", 0, "Foldkol");
	var oSnap = getSnap("select sum("+ sKol +")"
					+", sum(Fcena*"+ sKol +")"
					+", sum(Fcorkol)"
					+", sum(Fcena*Fcorkol)"
				+" from "+ workTbl + sWhere, false);
	if(oSnap)
	{
		Fkol.value = oSnap[0];
		Fsum.value = oSnap[1];
		Fkol_cor.value = oSnap[2];
		Fsum_cor.value = oSnap[3];
	}
}

function showHistory()
{		
	var tbl = grid.getTable();
	var nmkl = tbl.getValue("FNMKL");
	var date = extPar.dat;
	var ruDate = tbl.getValue("FDATE");
	var client = tbl.getValue("FCOD");
	var cena = tbl.getValue("FCENA");
	
	var bufCoName = "TMP_SU_HISTORY";
	ExecuteSQL("drop table "+ bufCoName, false);
	//CreateTable(bufCoName, "RRU");
	var sSql = "create table "+ bufCoName 
			+" (FDATE "+ SqlType("DATE") 
			+", FCENA "+ SqlType("CURRENCY")
			+", FKOL "+ SqlType("DOUBLE")
			+", FNMKL "+ SqlType("INT") 
			+", FRU "+ SqlType("INT") +")";
	ExecuteSQL(sSql);
	
	var sFru = IIF("FDATE<>"+ sqlTo(date), 1, 2);
	var sSql = "INSERT INTO ^"+ bufCoName 
					+" (FDATE, FNMKL, FCENA, FKOL, FRU) "
				+" SELECT FDATE, a.FNMKL, FCENA, a.FKOL, "+ sFru
				+" FROM ^RRU a "
					+" INNER JOIN ^HRU b ON a.Fid_doc = b.Fwid "
				+" WHERE b.Fdoc='SU' "
					+" AND b.Fdoc_dat<=" + sqlTo(date)
					+" AND b.FRU_DAT = "+ sqlTo(ruDate)
					+" AND a.Fnmkl="+ nmkl
					+" AND a.Fclient="+ sqlTo(client)
					+" AND a.FCENA="+ cena
	ExecuteSQL(sSql);
		
	var tblStr = OpenTable("SELECT * FROM "+ bufCoName +" ORDER BY FRU, Fdate");
	var par		= new Object();
	par.tbl	= tblStr;
	par.tblName	= bufCoName;
	par.Fclient	= client;
	par.Fnmkl	= Number(nmkl);
	par.Frudate	= ruDate;
	showWindow("l_su_str.xml", SW_MODAL, par);
			
	tblStr.close();
}

include ("sys/DpList.js");