//расчёт свода по категориям (шахматного)
include("objects/DpGetDat.js");
include("servis/format.js");
include("servis/date.js");
include("get_cnst.js");
include("objects/DpGrid.js");

var D1;
var D2;
var tblName = getTmpTableName("", true);
var keySnap;

function listLoad()
{
	with(this)
	{
		title = ru("Просмотр свода по категориям","Перегляд зведення по категоріях");
		printLabel = "SVKAT";
	}

	menuMode = GetMenuMode();
	if(menuMode.toUpperCase() == "VIEW")
	{
		var gd = new DpGetDat("d");
		D1 = new Date(gd.dat1);
		D2 = new Date(lastDayMonth(D1));
	}
	else
	{
		D1 = new Date(extPar.dat1); // дата начала
		D2 = new Date(extPar.dat2); // дата конца
	}
	this.title += " за "+format("dd.mm.yyyy",D1);

	// достаем цифры к названию файла
	szTag = getDateTag(D1);
	siName = "^svzp"+szTag;
	if(!IsTableEx("zrp_res", "zrp_svzp"+szTag))
	{
		alert(ru("Сперва выполните расчет заработной платы за ","Спочатку виконайте розрахунок заробітної платні за ")+format("mm/yyyy",D1));
		return false;
	}
}

function listSrc()
{
	this.qrySet("Cross", tblName, "Order", "FFLD_NUM");
	this.setFwidSrc("FROWID");
}

function listDpGrid()
{
	if (IsTable(tblName+"_S") && IsTable(tblName+"_R") && IsTable(tblName+"_C"))
	{
		tbl = OpenTable( "c", tblName);
		col = tbl.GetCol();
		row = tbl.GetRow();

		var oGrid = new DpGrid("NOCREATE");
		var gr = oGrid.page();
		
		with(oGrid)
		{
			defCond("=^FTT==\"!!\"", "1");
			color(1, "1")
			bold("1");
			
			with(page())
			{
				with(group("Поле ОР|Поле ЛС"))
				{
					cell("=^FTT==\"!!\" ? \"\" : String(^FFLD_NUM)", "Номер|Номер", 4);
					cell("FTXT", "Назва|Название", 17);
				}
			}
		}
		
		//подгружаем динамически поля используя шахматку
		col.MoveFirst();
		while (!col.IsEOF())
		{
			var ColTxt = String(col.getValue("FTXT_KAT"));
			var ColId = String(col.getValue("fcolid"));
			gr.FieldEx(ColId, typeof(ColTxt)=="string"? ColTxt: "???",10, null, DP_FORMAT_SUM);
			col.MoveNext();
		}
		oGrid.build();
	}
}

function listMake()
{
	DropTable(tblName+"_S");
	DropTable(tblName+"_C");
	DropTable(tblName+"_R");
	
	oFld = new Object();
	oFld.FLSFID 	= "LONG";
	oFld.FFLD_NUM 	= "LONG";
	oFld.FTXT 		= "TEXT";
	oFld.FWID_KAT	= "LONG";
	//oFld.FKOD_KAT	= "LONG";
	oFld.FTXT_KAT	= "TEXT";
	oFld.FVALUE 	= "CURRENCY";
	oFld.FTT 		= "TEXT";
	oFld.FROWID 	= "TEXT";
	oFld.FCOLID 	= "TEXT";
	oFld.FCSECT 	= "LONG";
	oFld.FRSECT 	= "LONG";
	oFld.FWID 		= "COUNTER";
	CreateTable(tblName+"_S", oFld);
	
	if(extPar.fwid != null)
	{
		fwid = extPar.fwid;
	}
	else
		return false;

	keySnap = getSnap("SELECT FLEFTKEY,FRIGHTKEY FROM ^STRU_ORG WHERE FWID = "+sqlTo(fwid));
	if(!keySnap)
		return false;

	var SVZPFILE = "SVZP"+month_txt(D1);
	strSQL = "INSERT INTO "+tblName+"_S "
				+"(FLSFID, FFLD_NUM, FTXT, FWID_KAT, FVALUE, FTT, FROWID, FCOLID, FCSECT, FRSECT)"
			+" SELECT"
				+" S.FLSFID"
				+", L.FFLD_NUM"
				+", L.FTXT"
				+", WP.FWID_KAT"
				+", SUM(S.FSUM) AS FVALUE"
				+", 'LS' AS FTT"
				+", "+SqlConCat("'LS'", "'@'", Convert("S.FLSFID", "NVC"))+" AS FROWID"
				+", "+SqlConCat("'KT'", "'@'", Convert("WP.FWID_KAT", "NVC"))+" AS FCOLID"
				+", "+Convert(1, "INT")+" AS FCSECT"
				+", "+Convert(1, "INT")+" AS FRSECT"
			+" FROM ((((^"+SVZPFILE+" S LEFT JOIN ^WORK_PERS AS WP ON S.FTABN_ID = WP.FWID_CL AND S.FWID_WP = WP.FWID)"
					+" INNER JOIN ^STRU_DOL SD ON WP.FWID_DOL = SD.FWID)"
					+" INNER JOIN ^STRU_ORG SO ON SD.FWID_ORG = SO.FWID)"
					+" INNER JOIN ^LIC_FLD L ON L.FID = S.FLSFID AND L.FIS6 = '+')"
			+" WHERE NOT(S.FVP = 1 AND S.FMN > "+sqlTo(D2)+") "
				+" AND SO.FLEFTKEY >= "+sqlTo(keySnap[0])+" AND SO.FRIGHTKEY <= "+sqlTo(keySnap[1])
			+" GROUP BY "
				+" S.FLSFID"
				+", L.FFLD_NUM"
				+", L.FTXT"
				+", WP.FWID_KAT"
	ExecuteSQL(strSQL);

	//проставим код категории
/*
	strSQL = "update TZWSVOD set fwid_kat=(select max(Fwid_kat) from ^work_pers as wp where wp.Fwid_cl=TZWSVOD.Ftabn_id "
					+" AND wp.Fbdat<="+mdt2+" AND wp.Fedat>="+mdt1+")"
					+" where Fwid_kat=0" 
	ExecuteSQL(strSQL);
*/
	strSQL = "UPDATE "+tblName+"_S"
			+" SET FTXT_KAT = (SELECT FTXT"
							+" FROM ^CL"
								//+" LEFT JOIN ^CLRELCLCL REL ON CL.FWID=REL.FWID_CL"
							+" WHERE 1=1"
								+" AND "+tblName+"_S.FWID_KAT = FWID"
							+")"
	ExecuteSQL(strSQL);

	//Добавим колонку "Всего"
	var strSQL = "INSERT INTO "+tblName+"_S (FLSFID, FFLD_NUM, FTXT"
					+", FTXT_KAT"
					+", FVALUE, FTT, FROWID, FCOLID, FCSECT, FRSECT)"
				+" SELECT "
					+" S.FLSFID"
					+", S.FFLD_NUM"
					+", S.FTXT"
					+", 'Всього' AS FTXT_KAT"
					+", SUM(S.FVALUE) AS FVALUE"
					+", 'LS' AS FTT"
					+", S.FROWID"
					+", 'TT' AS FCOLID"
					+", 0 AS FCSECT"
					+", S.FRSECT"
				+" FROM "
					+tblName+"_S S"
				+" WHERE "
					+" S.FTT = 'LS'"
				+" GROUP BY "
					+" S.FLSFID"
					+", S.FFLD_NUM"
					+", S.FTXT"
					+", S.FROWID"
					+", S.FRSECT"
	ExecuteSQL(strSQL);

	//Добавим строку "Всего"
	var strSQL = "INSERT INTO "+tblName+"_S "
					+"(FLSFID, FFLD_NUM, FTXT, FTXT_KAT, FVALUE, FTT, FROWID, FCOLID, FCSECT, FRSECT)"
				+" SELECT "
					+" 999999 AS FLSFID"
					+", 999999 AS FFLD_NUM"
					+", 'Всього' AS FTXT"
					+", S.FTXT_KAT"
					+", SUM(S.FVALUE) AS FVALUE"
					+", '!!' AS FTT"
					+", '!!' AS FROWID"
					+", S.FCOLID"
					+", S.FCSECT"
					+", 2 AS FRSECT"
				+" FROM "
					+tblName+"_S S"
				+" WHERE "
					+" S.FTT='LS'"
				+" GROUP BY "
					+" S.FTXT_KAT"
					+", S.FCOLID"
					+", S.FCSECT"
	ExecuteSQL(strSQL);

	oFld = new Object();
	oFld.FLSFID 	= "LONG";
	oFld.FFLD_NUM 	= "LONG";
	oFld.FTXT 		= "TEXT";
	oFld.FTT 		= "TEXT";
	oFld.FRSECT 	= "LONG";
	oFld.FROWID 	= "TEXT";
	oFld.FWID 		= "COUNTER";
	CreateTable(tblName+"_R", oFld)

	//формируем таблицу строк
	strSQL = "INSERT INTO "+tblName+"_R "
				+"(FLSFID, FFLD_NUM, FTXT, FTT, FROWID, FRSECT)"
			+" SELECT "
				+" DISTINCT S.FLSFID, S.FFLD_NUM, S.FTXT, S.FTT, S.FROWID, S.FRSECT"
			+" FROM "+tblName+"_S S"
	ExecuteSQL(strSQL);

	oFld = new Object();
	oFld.FTXT_KAT 	= "TEXT";
	oFld.FCOLID 	= "TEXT";
	oFld.FCSECT 	= "LONG";
	CreateTable(tblName+"_C", oFld)
	
	//формируем таблицу колонок
	strSQL = "INSERT INTO "+tblName+"_C "
				+"(FTXT_KAT, FCOLID, FCSECT)"
			+" SELECT "
				+" DISTINCT S.FTXT_KAT, S.FCOLID, S.FCSECT"
			+" FROM "+tblName+"_S S"
			+" ORDER BY "
				+" S.FCSECT"
				+", S.FTXT_KAT"
	ExecuteSQL(strSQL);

	return;
}

function getTblH()
{
	h = new Object();
	h.HFBDAT = D1.getVarDate();
	h.HFD1 = D1.getVarDate();
	h.HFD2 = D2.getVarDate();
	strSQL = "SELECT FTXT FROM ^STRU_ORG WHERE FWID = "+sqlTo(extPar.fwid)
	var sn = getSnap(strSQL);
	var podrTxt = "";
	if (sn != null && !isEmpty(sn[0]))
	{
		podrTxt = sn[0];
	}
	h.HFPODRTXT = podrTxt;
	return h;
}

function listMenuInit()
{
}

function listMenuRun(ID)
{
}
include("sys/DpList.js");