include("sub\\synchro.js");
include("doc\\DpDoc.js");
include("objects\\DpClEx.js");

var tempTbl = "tmpSynchro";
var objSelector = null;
var sClassID;
var nFolder;
var sObjType;

var COMPARE_LOCAL_ADD = 1;
var COMPARE_REMOTE_ADD = 2;
    
var COMPARE_LOCAL_CHANGES_OK = 3;
var COMPARE_REMOTE_CHANGES_OK = 4;
    
var COMPARE_LOCAL_DEL_OK = 5;
var COMPARE_REMOTE_DEL_OK = 6;
    
var COMPARE_CONFLICT = 7;
var COMPARE_UNKNOWN = 8;
var COMPARE_NO_CHANGES = 9;


function listLoad()
{
	if (!extPar || !extPar.sClassID)
	{
		alert(UR("Недостатньо параметрів|Недостаточно параметров"));
		return false;
	}
	sClassID = extPar.sClassID;
	nFolder = (typeof(extPar.nFolder) != "undefined"?extPar.nFolder:null);
	sObjType = (extPar.sType?extPar.sType:null);
	objSelector = lpProxy.getObjectSelector(sClassID);
		
	if (isFile(objSelector.getObject()
			.getClassDescriptionDir() + "synchro/list.js"))
		include(objSelector.getObject()
			.getClassDescriptionDir() + "synchro/list.js");
	if (typeof(buildGrid) == "function")
		this.buildGrid = buildGrid;
	else
		this.buildGrid = default_buildGrid;
	Sync_nFolder = nFolder;
//-	если в extPar не хватает параметров - я - не виноват
}

function listMake()
{
	tblCreate();
	tblFill();
	if (extPar.syncmode == "AUTOSYNC")
	{
		if (run_Autosync())
		{
			return false;
		}
	}
	return true;
}

function run_Autosync()
{
	autoSynchronize(nFolder,tempTbl
				,extPar.fromsrv
				,extPar.tosrv
				,extPar.conflict
				,true);
	var oSnap = getSnap("SELECT count(*) FROM " + tempTbl);
	if (oSnap == null || oSnap[0] == 0)
		return true;
	return false;
}

function listMenuInit(toObject)
{
	var fCompare = this.tbl.getValue("FCOMPARE");
	var bLocalView = false;
	var bRemoteView = false;
	var bLocalCommit = false;
	var bRemoteCommit = false;
	
	bLocalView = (fCompare != COMPARE_REMOTE_ADD && fCompare != COMPARE_LOCAL_DEL_OK);
	bRemoteView = (fCompare != COMPARE_LOCAL_ADD && fCompare != COMPARE_REMOTE_DEL_OK);
	bLocalCommit = (fCompare != COMPARE_REMOTE_ADD);
	bRemoteCommit = (fCompare != COMPARE_LOCAL_ADD);
	
	bLocalView && toObject.AddMenuItem("VIEW_LOCAL","Перегляд локального об'єкта|Просмотр локального объекта");
	bLocalCommit && toObject.AddMenuItem("APLY_LOCAL","Зафіксувати локальні зміни|Зафиксировать локальные изменения");
	(bLocalView || bLocalCommit) && toObject.AddMenuItem("","");
	bRemoteView && toObject.AddMenuItem("VIEW_REMOTE","Перегляд об'єкта з сервера|Просмотр объекта с сервера");
	bRemoteCommit && toObject.AddMenuItem("APLY_REMOTE","Отримати зміни з сервера|Получить изменения с сервера");
}

function listMenuRun(sID)
{
	var fclass = String(this.tbl.getValue("FCLASS"));
	var nObjID = parseInt(this.tbl.getValue("FWID"));
	if (isNaN(nObjID))
		return;
	var bDelete = false;
	
	if (sID == "VIEW_LOCAL")
	{
		var obj = null;
		if ("CLS." == fclass.substring(0,4))
		{
			obj = new DpClEx(fclass.substr(4),nFolder);
			if (obj.jObj.loadFromDB(nObjID) != null)
			{
				var oPar = new Object();
				oPar.dpObj = obj;
				oPar.mode = "VIEW";
				oPar.isView = true;
				if (obj.hasExt())
					oPar.hasTab = true;
				showWindow(obj.formFile,"XMLDLG",oPar);
				return;
			}
		}
		else
		{
			obj = new DpDoc(fclass,nFolder);
			if (obj.jDoc.loadFromDB(nObjID) != null)
			{
				var oPar = new Object();
				oPar.doc = obj;
				oPar.mode = "VIEW";
				oPar.isView = true;
				showWindow(obj.formFile,"XMLDLG",oPar);
				return;
			}
		}
		alert(UR("Не можу знайти локальний об'єкт|Не могу найти локальный объект"));
		return ;
	}
	else if (sID == "VIEW_REMOTE")
	{
		if (fclass.substring(0,4) == "CLS.")
		{
			var obj = new DpClEx(fclass.substr(4),nFolder);
			if (!obj.jObj.loadRemote(nObjID))
			{
				alert(UR("Не можу знайти віддалений об'єкт|Не могу найти объект на сервере"));
			}
			else
			{
				var oPar = new Object();
				oPar.dpObj = obj;
				oPar.mode = "VIEW";
				oPar.isView = true;
				if (obj.hasExt())
					oPar.hasTab = true;
				showWindow(obj.formFile,"XMLDLG",oPar);
			}
		}
		else
		{
			var doc = new DpDoc(fclass,nFolder);
			if (!doc.jDoc.loadRemote(nObjID))
			{
				alert(UR("Не можу знайти віддалений об'єкт|Не могу найти объект на сервере"));
			}
			else
			{
				var oPar = new Object();
				oPar.doc = doc;
				oPar.mode = "VIEW";
				oPar.isView = true;
				oPar.isTransform = true; //AL: NEED TO TEST - VERY DANGEROUS FOR NK
				showWindow(doc.formFile,"XMLDLG",oPar);
			}
		}
		return ;
	}
	else if (sID == "APLY_LOCAL")
	{
		var fLaction = this.tbl.getValue("FLACTION");
		if ("D" == fLaction)
		{
			bDelete = deleteLocal(fclass,nObjID);
		}
		else
		{
			bDelete = commitLocal(fclass,nObjID);
		}
	}
	else if (sID == "APLY_REMOTE")
	{
		trace(">>>>>>>>> AR>>>" + fclass + ":" + nObjID);
		var fRaction = this.tbl.getValue("FRACTION");
		if ("D" == fRaction)
		{
			bDelete = deleteRemote(fclass,nObjID);
		}
		else
		{
			var fRMode = String(this.tbl.getValue("FRACTION"));
			var fRUser = String(this.tbl.getValue("FRUSER"));
			var fRDate = javaDate2Script(this.tbl.getValue("FRDATE"),true);
			bDelete = replaceLocal(fclass,nObjID,fRMode,fRUser,fRDate);
		}
	}
	
	if (bDelete)
	{
		var sSQL = "DELETE FROM " + tempTbl + " WHERE FWID=" + sqlTo(nObjID);
		ExecuteSQL(sSQL);
		oSync.delObjectFromSynchro(fclass,nObjID);
		this.tbl.requery()
		grid.refresh();
	}
}

function listDelAcc(){return false;}

function default_buildGrid(oGrid)
{
	var arrVars = objSelector.getMappingVars();
	with(oGrid.page("ADTN").group("Додатково(локальна інформація)|Дополнительно(локальная информация)"))
	{
		for (var nVar = 0; nVar < arrVars.length; nVar++)
		{
			if ("HID" == arrVars[nVar]
				|| "HOP" == arrVars[nVar]
				|| "HDOC" == arrVars[nVar])
				continue;
			cell(arrVars[nVar],arrVars[nVar],10);
		}
	}
}

function tblCreate()
{
	DropTable(tempTbl);
	
	var sSQL = "CREATE TABLE " + tempTbl
			 + "("
			 + " FWID " + SqlType("LONG")			//- ID объекта
			 + ",FCLASS " + SqlType("TEXT",254)		//-класс
			 + ",FCOMPARE " + SqlType("SHORT")		//-статус сравнения
			 + ",FLACTION " + SqlType("TEXT",254)	//-лок.действие
			 + ",FLUSER " + SqlType("TEXT",254)		//-лок.юзер
			 + ",FLDATE " + SqlType("DATETIME")		//-лок.дата
			 + ",FLVER " + SqlType("INT")		    //-лок. версия
			 + ",FLINLIST " + SqlType("LOGICAL")	//-в синх.списке
			 + ",FLARCHID " + SqlType("LONG")		//-лок.арх.ИД
			 + ",FRACTION " + SqlType("TEXT",254)	//-рем.действие
			 + ",FRUSER " + SqlType("TEXT",254)		//-рем.юзер
			 + ",FRDATE " + SqlType("DATETIME")		//-рем.дата
			 + ",FRVER " + SqlType("INT")		    //-рем. версия
			 + ")"
	ExecuteSQL(sSQL);
}

function tblFill()
{
	if (sObjType != "CLS")
	{
		objSelector.addVariableValue("HDOC",sClassID,"=");
		objSelector.addVariableValue("HOP",Number(nFolder),"=");
	}
	else
	{
		objSelector.addVariableValue("HCL",Number(nFolder),"=");
	}
	
	for (var sPar in extPar.selectPars)
	{
		objSelector.addVariableValue
			(sPar
			,extPar.selectPars[sPar].value
			,extPar.selectPars[sPar].sign);
	}
	var intersect = objSelector.getInersected(extPar.bDate,extPar.eDate);
	var oBatch = createBatch();
	for (var nRec = 0; nRec < intersect.length; nRec++)
	{
		var oSyncInf = intersect[nRec];
		var m = new Object();
		m.FWID = oSyncInf.nObjID;
		m.FCLASS = oSyncInf.sClassID;
		m.FCOMPARE = oSyncInf.compareStatus;
		if (!m.FWID || m.FCOMPARE == COMPARE_NO_CHANGES)
			continue;
		
		if (oSyncInf.localArchiveInfo != null)
		{
			m.FLACTION = oSyncInf.localArchiveInfo.sArchiveAction;
			m.FLUSER = oSyncInf.localArchiveInfo.sUser;
			m.FLDATE = javaDate2Script(oSyncInf.localArchiveInfo.dArchDate,true);
			m.FLINLIST = oSyncInf.localArchiveInfo.bInSynchroList == true;
			m.FLARCHID = oSyncInf.localArchiveInfo.nArchID;
			m.FLVER = oSyncInf.localArchiveInfo.version;
		}
		if (oSyncInf.remoteArchiveInfo != null)
		{
			m.FRACTION = oSyncInf.remoteArchiveInfo.sArchiveAction;
			m.FRUSER = oSyncInf.remoteArchiveInfo.sUser;
			m.FRDATE = javaDate2Script(oSyncInf.remoteArchiveInfo.dArchDate,true);
			m.FRVER = oSyncInf.remoteArchiveInfo.version;
		}
		var sSQL = getSQLForUpdate(tempTbl,m,true,false,true);
		oBatch.addBatch(sSQL);
		//ExecuteSQL(sSQL);
	}
	oBatch.execute(false);
}

function listSrc()
{
	this.qrySet("Fields",
				  " SYNC.FWID,"
				+ " SYNC.FCLASS,"
				+ " SYNC.FCOMPARE,"
				+ " SYNC.FLACTION,"
				+ " SYNC.FLUSER,"
				+ " SYNC.FLDATE,"
				+ " SYNC.FLINLIST,"
				+ " SYNC.FLVER,"
				+ " SYNC.FLARCHID,"
				+ " SYNC.FRACTION,"
				+ " SYNC.FRUSER,"
				+ " SYNC.FRDATE,"
				+ " SYNC.FRVER,"
				+ objSelector.getFIELDSString(),
				"From",
				objSelector.getFROMString()
				+ " RIGHT JOIN " + tempTbl + " SYNC"
				+ " ON " + objSelector.getIDField() + " =SYNC.FWID"
				);
}

function listDpGridEx(oGrid)
{
	oGrid.objGrid.addImage(COMPARE_CONFLICT,rootDirectoryEx() + "icons/CONF.gif");
	oGrid.objGrid.addImage(COMPARE_LOCAL_ADD,rootDirectoryEx() + "icons/LAOK.gif");
	oGrid.objGrid.addImage(COMPARE_LOCAL_CHANGES_OK,rootDirectoryEx() + "icons/LCOK.gif");
	oGrid.objGrid.addImage(COMPARE_LOCAL_DEL_OK,rootDirectoryEx() + "icons/LDOK.gif");
	oGrid.objGrid.addImage(COMPARE_REMOTE_ADD,rootDirectoryEx() + "icons/RAOK.gif");
	oGrid.objGrid.addImage(COMPARE_REMOTE_CHANGES_OK,rootDirectoryEx() + "icons/RCOK.gif");
	oGrid.objGrid.addImage(COMPARE_REMOTE_DEL_OK,rootDirectoryEx() + "icons/RDOK.gif");
	oGrid.objGrid.setImageField("FCOMPARE");
	
	with(oGrid.page("Main").group("Порівняння|Сравнение"))
	{
		cell("FWID","ID",10);
		cell("FCOMPARE","compare",10);
		cell("FLACTION","лок.дія|лок.действ.",10);
		cell("FLUSER","лок.користув.|лок.пользов.",10);
		cell("FLDATE","лок.дата|лок.дата",13,"","dd.MM.yyyy HH:mm:ss");
		cell("FLVER","лок.версiя|лок.версия.",10);
		cell("FRACTION","відд.дія|уд.действ.",10);
		cell("FRUSER","відд.користув.|уд.пользов.",10);
		cell("FRDATE","відд.дата|уд.дата",13,"","dd.MM.yyyy HH:mm:ss");
		cell("FRVER","відд.версiя|уд.версия.",10);
	}
	
	this.buildGrid(oGrid);
	return oGrid;
}

include("sys/DpList.js");