//расчитывает отработанное время по табелям, 
//время больничных, отпускных, командировочных берем из лицевых счетов,
//поэтому расчет производиться после того, как расчитаем з/п,
//в отпускных должны быть проставлены кол-ва рабочих дней,
//готовые суммы больничных, отпускных, командировочных, учтутся только если в них будут проставлены дни/часы
include("Objects/DpGetDat.js");
include("servis/date.js");
include("servis/format.js");

var tblName, sttTableName, tblTableName, svzpTableName, menuMode, gd, szTag, D1, D2, toCalcHours;


function listLoad()
{
	//параметр, если истина, то нулевы часы, у которых проставлены дни будем апдейтить по этим дням = дни*норма_часов/норма_дней
	toCalcHours = getPar("TBL_CHECK_HR");
	menuMode = GetMenuMode();
	gd = new DpGetDat("d");
	if(gd.escape)
		return;
	D1 = new Date(firstDayMonth(gd.dat1));
	D2 = new Date(lastDayMonth(gd.dat1));
	szTag = getDateTag(gd.dat1);
	tblName = "TBLCHECK"+szTag;
	sttTableName = "STT1"+szTag;
	tblTableName = "TBL"+szTag;
	svzpTableName = "SVZP"+szTag;
	with(this)
	{
		title = ru("Проверка табелей за ","Перевірка табелів за ")+format("Mmm yyyy",D1).toLowerCase();
		xmlGridFile = "l_tblcheck.xml";
	}
	if(menuMode == "VIEW" && !IsTableEx("ZRP_RES", "ZRP_"+tblName))
	{
		alert(ru("Сначала выполните расчет","Спочатку виконайте розрахунок"));
		return false;
	}
}

function listSrc()
{
	this.qrySet("Fields", "r.Fcod, t.*",
				"From", "^"+tblName+" as t left join ^clrelclcl as r on t.Ftabn_id=r.Fwid_cl",
				"Order", "Fcod");
}

function listMake()
{
	if(gd.escape == true) 
		return false;
	if(menuMode == "CALC")
	{
		if(!IsTableEx("ZRP_MDB", "ZRP_"+sttTableName))
		{
			alert(ru("Отсутствуют табеля за ","Відсутні табеля за ")+format("Mmm yyyy",D1).toLowerCase());
			return false;
		}
		if(!IsTableEx("ZRP_RES", "ZRP_"+svzpTableName))
		{
			alert(ru("Расчитайте сперва зарплату за ","Розрахуйте спершу зарплату за ")+format("Mmm yyyy",D1).toLowerCase());
			return false;
		}
		if(IsTableEx("ZRP_RES", "ZRP_"+tblName))
			ExecuteSQL("delete from ^"+tblName);
		else
			CreateTableEx("ZRP_RES","ZRP_"+tblName,"TBLCHECK","*");
		setProgressRange(1, 12);
		msg = ru("Поиск табелей...","Пошук табелів...")
		setProgressPos(1, msg);
		//сперва вставляем только табельные номера в еденичном экземпляре
		ExecuteSQL("insert into ^"+tblName+" (Ftabn_id)"
				+" select DISTINCT Ftabn_id from ^"+sttTableName);
		//проставляем вид оплаты по самой свежей записи из ШР в месяце расчета
		ExecuteSQL("update ^"+tblName+" set Fvopl=(select Fvopl from ^work_pers as wp "
				+" where wp.Fwid_cl=^"+tblName+".Ftabn_id and wp.Fbdat="
					+"(select MAX(Fbdat) from ^work_pers as wp2 where wp2.Fwid_cl=^"+tblName+".Ftabn_id "
					+" and wp2.Fbdat<="+sqlTo(D2)+" and wp2.Fedat>="+sqlTo(D1)+"))");
		//теперь удаляем те виды оплаты, которых нет в табелях (пенсионеры и т.п.)
		ExecuteSQL("delete from ^"+tblName+" where not exists"
					+" (select * from ^tbl_ini as ti where ti.Fvopl=^"+tblName+".Fvopl "
						+" and ti.Fbdat="+sqlTo(D1)+")");
		msg = ru("Расчет нормы дней...","Розрахунок норми днів...")
		setProgressPos(2, msg);
		//проставляем норму дней
		ExecuteSQL("update ^"+tblName+" set Fnorma_d=(select "
					+ IIF("tb.Fday_nvk IS NULL", "ti.Fnorma_d", "MIN(tb.Fday_nvk)")
				+" from ^work_pers as wp "
					+" left join ^"+tblTableName+" as tb on tb.Fwid_wp=wp.Fwid and tb.Fkod_nvk=1 "
					+" inner join ^tbl_ini as ti on ti.Fvopl=wp.Fvopl and ti.Fbdat="+sqlTo(D1)
				+" where ^"+tblName+".Ftabn_id=wp.Fwid_cl and "
					+" wp.Fbdat=(select MAX(Fbdat) from ^work_pers as wp2 "
							+" where wp2.Fwid_cl=^"+tblName+".Ftabn_id and wp2.Fbdat<="
								+sqlTo(D2)+" and wp2.Fedat>="+sqlTo(D1)+")"
				+" group by ti.Fnorma_d, tb.Fday_nvk)");
		msg = ru("Расчет нормы часов...","Розрахунок норми годин...")
		setProgressPos(3, msg);
		//проставляем норму часов
		ExecuteSQL("update ^"+tblName+" set Fnorma_ch=(select "
					+ IIF("tb.Fchasnvk IS NULL", "ti.Fnorma_ch", "MIN(tb.Fchasnvk)")
				+" from ^work_pers as wp "
					+" left join ^"+tblTableName+" as tb on tb.Fwid_wp=wp.Fwid and tb.Fkod_nvk=1 "
					+" inner join ^tbl_ini as ti on ti.Fvopl=wp.Fvopl and ti.Fbdat="+sqlTo(D1)
				+" where ^"+tblName+".Ftabn_id=wp.Fwid_cl and "
					+" wp.Fbdat=(select MAX(Fbdat) from ^work_pers as wp2 "
							+" where wp2.Fwid_cl=^"+tblName+".Ftabn_id and wp2.Fbdat<="
								+sqlTo(D2)+" and wp2.Fedat>="+sqlTo(D1)+")"
				+" group by ti.Fnorma_ch, tb.Fchasnvk)");
				
		msg = ru("Расчет фактически дней...","Розрахунок фактично годин...")
		setProgressPos(4, msg);
		//проставляем фактически дней для табелей по умолчанию (*)
		ExecuteSQL("update ^"+tblName+" set Fday=(select DISTINCT ti.Fvsego_d "
				+" from ^work_pers as wp "
					+" left join ^"+tblTableName+" as tb on tb.Fwid_wp=wp.Fwid and tb.Fkod_nvk=2 "
					+" inner join ^tbl_ini as ti on ti.Fvopl=wp.Fvopl and ti.Fbdat="+sqlTo(D1)
				+" where ^"+tblName+".Ftabn_id=wp.Fwid_cl and tb.Fday_nvk IS NULL and "
					+" wp.Fbdat<="+sqlTo(D2)+" and wp.Fedat>="+sqlTo(D1)+")");
		//проставляем фактически дней для табелей, которые редактировались вручную
		ExecuteSQL("update ^"+tblName+" set Fday=(select SUM(tb.Fday_nvk)"
				+" from ^work_pers as wp "
					+" inner join ^"+tblTableName+" as tb on tb.Fwid_wp=wp.Fwid and tb.Fkod_nvk=2 "
				+" where ^"+tblName+".Ftabn_id=wp.Fwid_cl and "
					+" wp.Fbdat<="+sqlTo(D2)+" and wp.Fedat>="+sqlTo(D1)
				+" group by wp.Fwid_cl)"
				+" where Fday is null");
		
		msg = ru("Расчет фактически часов...","Розрахунок фактично годин...")
		setProgressPos(5, msg);
		//проставляем фактически часов для табелей по умолчанию (*)
		ExecuteSQL("update ^"+tblName+" set Fchas=(select DISTINCT ti.Fvsego_ch "
				+" from ^work_pers as wp "
					+" left join ^"+tblTableName+" as tb on tb.Fwid_wp=wp.Fwid and tb.Fkod_nvk=2 "
					+" inner join ^tbl_ini as ti on ti.Fvopl=wp.Fvopl and ti.Fbdat="+sqlTo(D1)
				+" where ^"+tblName+".Ftabn_id=wp.Fwid_cl and tb.Fchasnvk IS NULL and "
					+" wp.Fbdat<="+sqlTo(D2)+" and wp.Fedat>="+sqlTo(D1)+")");
		//проставляем фактически часов для табелей, которые редактировались вручную
		ExecuteSQL("update ^"+tblName+" set Fchas=(select SUM(tb.Fchasnvk)"
				+" from ^work_pers as wp "
					+" inner join ^"+tblTableName+" as tb on tb.Fwid_wp=wp.Fwid and tb.Fkod_nvk=2 "
				+" where ^"+tblName+".Ftabn_id=wp.Fwid_cl and "
					+" wp.Fbdat<="+sqlTo(D2)+" and wp.Fedat>="+sqlTo(D1)
				+" group by wp.Fwid_cl)"
				+" where Fchas is null");
		//проставляем фактически часов по дням (для тех у кого часы = 0) 
		if(toCalcHours)
			ExecuteSQL("update ^"+tblName+" set Fchas="+sqlRound("Fday*Fnorma_ch/Fnorma_d",2)+" where Fday>0 and Fchas=0");
		
		//пытаемся определить код лицевого счета командировочных
		var snap = getSnap("select Fid from ^lic_fld where Ffzp="+sqlTo("к"))
		if(snap)
		{
			msg = ru("Расчет времени командировочных...","Розрахунок часу відрядних...")
			setProgressPos(6, msg);
			//проставляем дни/часы командировочных, только за текущий месяц
			//т.к. теоретически полей ЛС для командировочных может быть несколько,
			//то джоиним с lic_fld и ищем по признаку Ffzp=к
			ExecuteSQL("update ^"+tblName+" set Fcmnd_d=(select "+IIF("SUM(s.Fday)>0","SUM(s.Fday)","0")
					+" from ^"+svzpTableName+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
					+" where ^"+tblName+".Ftabn_id=s.Ftabn_id and l.Ffzp="+sqlTo("к")+" and s.Fvp=0),"
				+" Fcmnd_ch=(select "+IIF("SUM(Fchas)>0","SUM(Fchas)","0")
					+" from ^"+svzpTableName+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
					+" where ^"+tblName+".Ftabn_id=s.Ftabn_id and l.Ffzp="+sqlTo("к")+" and s.Fvp=0)");
			//проставляем часы командировочных по дням (для тех у кого часы = 0) 
			if(toCalcHours)
				ExecuteSQL("update ^"+tblName+" set Fcmnd_ch="+sqlRound("Fcmnd_d*Fnorma_ch/Fnorma_d",2)+" where Fcmnd_d>0 and Fcmnd_ch=0");
		}
		else
			alert(ru("Не возможно определить код поля ЛС для командировочных!\nВ формировании перечня полей ЛС в признаке вхождения в ФОТ должно быть значение 'командировки'",
					"Не можливо визначити код поля ОР для відряджень!\nУ формуванні переліку полів ОР в ознаці входження у ФОП має бути значення 'відрядження'"));
		//пытаемся определить код лицевого счета больничных за счет предприятия
		var snap = getSnap("select Fid from ^lic_fld where Ffzp="+sqlTo("b"))
		if(snap)
		{
			msg = ru("Расчет времени больничных за счет предприятия...","Розрахунок часу лікарняних за рахунок підприємства...")
			setProgressPos(7, msg);
			ExecuteSQL("update ^"+tblName+" set Fblnp_d=(select "+IIF("SUM(s.Fday)>0","SUM(s.Fday)","0")
					+" from ^"+svzpTableName+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
					+" where ^"+tblName+".Ftabn_id=s.Ftabn_id and l.Ffzp="+sqlTo("b")+" and s.Fvp=0 and s.Fmn="+sqlTo(d00)+"),"
				+" Fblnp_ch=(select "+IIF("SUM(Fchas)>0","SUM(Fchas)","0")
					+" from ^"+svzpTableName+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
					+" where ^"+tblName+".Ftabn_id=s.Ftabn_id and l.Ffzp="+sqlTo("b")+" and s.Fvp=0 and s.Fmn="+sqlTo(d00)+")");
			//проставляем часы больничных за счет предприятия по дням (для тех у кого часы = 0) 
			if(toCalcHours)
				ExecuteSQL("update ^"+tblName+" set Fblnp_ch="+sqlRound("Fblnp_d*Fnorma_ch/Fnorma_d",2)+" where Fblnp_d>0 and Fblnp_ch=0");
		}
		else
			alert(ru("Не возможно определить код поля ЛС для больничных за счет предприятия!\nВ формировании перечня полей ЛС в признаке вхождения в ФОТ должно быть значение 'явл.полем больн.предпр.'",
					"Не можливо визначити код поля ОР для лікарняних за рахунок підприємства!\nУ формуванні переліку полів ОР в ознаці входження у ФОП має бути значення 'є полем лікарн.підпр.'"));
		//пытаемся определить код лицевого счета больничных за счет с/с
		var snap = getSnap("select Fid from ^lic_fld where Ffzp="+sqlTo("б"))
		if(snap)
		{
			msg = ru("Расчет времени больничных за счет соцстарха...","Розрахунок часу лікарняних за рахунок соцстраху...")
			setProgressPos(8, msg);
			ExecuteSQL("update ^"+tblName+" set Fblns_d=(select "+IIF("SUM(s.Fday)>0","SUM(s.Fday)","0")
					+" from ^"+svzpTableName+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
					+" where ^"+tblName+".Ftabn_id=s.Ftabn_id and l.Ffzp="+sqlTo("б")+" and s.Fvp=0 and s.Fmn="+sqlTo(d00)+"),"
				+" Fblns_ch=(select "+IIF("SUM(Fchas)>0","SUM(Fchas)","0")
					+" from ^"+svzpTableName+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
					+" where ^"+tblName+".Ftabn_id=s.Ftabn_id and l.Ffzp="+sqlTo("б")+" and s.Fvp=0 and s.Fmn="+sqlTo(d00)+")");
			//проставляем часы больничных за счет с/с по дням (для тех у кого часы = 0) 
			if(toCalcHours)
				ExecuteSQL("update ^"+tblName+" set Fblns_ch="+sqlRound("Fblns_d*Fnorma_ch/Fnorma_d",2)+" where Fblns_d>0 and Fblns_ch=0");
		}
		else
			alert(ru("Не возможно определить код поля ЛС для больничных за счет соцстарха!\nВ формировании перечня полей ЛС в признаке вхождения в ФОТ должно быть значение 'явл.полем больн.с/с'",
					"Не можливо визначити код поля ОР для лікарняних за рахунок соцстраху!\nУ формуванні переліку полів ОР в ознаці входження у ФОП має бути значення 'є полем лікарн.с/с'"));

		//пытаемся определить код лицевого счета больничных по беременности и родам и по уходу за больным
		var snap = getSnap("select Fid from ^lic_fld where Ffzp="+sqlTo("&"))
		if(snap)
		{
			msg = ru("Расчет времени больничных по беременности и родам...","Розрахунок часу лікарняних по вагітності і пологах...")
			setProgressPos(9, msg);
			ExecuteSQL("update ^"+tblName+" set Fblnb_d=(select "+IIF("SUM(s.Fday)>0","SUM(s.Fday)","0")
					+" from ^"+svzpTableName+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
					+" where ^"+tblName+".Ftabn_id=s.Ftabn_id and l.Ffzp="+sqlTo("&")+" and s.Fvp=0 and s.Fmn="+sqlTo(d00)+"),"
				+" Fblnb_ch=(select "+IIF("SUM(Fchas)>0","SUM(Fchas)","0")
					+" from ^"+svzpTableName+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
					+" where ^"+tblName+".Ftabn_id=s.Ftabn_id and l.Ffzp="+sqlTo("&")+" and s.Fvp=0 and s.Fmn="+sqlTo(d00)+")");
			//проставляем часы больничных по берем.и родам по дням (для тех у кого часы = 0) 
			if(toCalcHours)
				ExecuteSQL("update ^"+tblName+" set Fblnb_ch="+sqlRound("Fblnb_d*Fnorma_ch/Fnorma_d",2)+" where Fblnb_d>0 and Fblnb_ch=0");
		}
		else
			alert(ru("Не возможно определить код поля ЛС для больничных по беременности и родам!\nВ формировании перечня полей ЛС в признаке вхождения в ФОТ должно быть значение 'по берем.,уход за реб.'",
					"Не можливо визначити код поля ОР для лікарняних по вагітності і родах!\nУ формуванні переліку полів ОР в ознаці входження у ФОП має бути значення 'по вагітн.,догляд за дит.'"));
		
		
		//пытаемся определить код лицевого счета отпускных
		var snap = getSnap("select Fid from ^lic_fld where Ffzp="+sqlTo("о"))
		if(snap)
		{
			msg = ru("Расчет времени отпускных...","Розрахунок часу відпусток...")
			setProgressPos(10, msg);
			ExecuteSQL("update ^"+tblName+" set Fotp_d=(select "+IIF("SUM(p.Fproc)>0","SUM(p.Fproc)","0")
					+" from ^"+svzpTableName+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
						+" left join ^prk_all as p on s.Fid_prk=p.Fwid "
					+" where ^"+tblName+".Ftabn_id=s.Ftabn_id and l.Ffzp="+sqlTo("о")+" and s.Fvp=0)");
			if(toCalcHours)
				ExecuteSQL("update ^"+tblName+" set Fotp_ch="+sqlRound("Fotp_d*Fnorma_ch/Fnorma_d",2)+" where Fotp_d>0");
		}
		else
			alert(ru("Не возможно определить код поля ЛС для отпускных!\nВ формировании перечня полей ЛС в признаке вхождения в ФОТ должно быть значение 'отпускные'",
					"Не можливо визначити код поля ОР для відпусток!\nУ формуванні переліку полів ОР в ознаці входження у ФОП має бути значення 'відпускні'"));
		
		//пытаемся определить код лицевого счета для гос.обязанностей
		var snap = getSnap("select Fid from ^lic_fld where Ffzp="+sqlTo("н"))
		if(snap)
		{
			msg = ru("Расчет времени гос.обязанностей...","Розрахунок часу держ.обов'язків...")
			setProgressPos(11, msg);
			ExecuteSQL("update ^"+tblName+" set Fgos_d=(select "+IIF("SUM(s.Fday)>0","SUM(s.Fday)","0")
					+" from ^"+svzpTableName+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
					+" where ^"+tblName+".Ftabn_id=s.Ftabn_id and l.Ffzp="+sqlTo("н")+" and s.Fvp=0),"
				+" Fgos_ch=(select "+IIF("SUM(Fchas)>0","SUM(Fchas)","0")
					+" from ^"+svzpTableName+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
					+" where ^"+tblName+".Ftabn_id=s.Ftabn_id and l.Ffzp="+sqlTo("н")+" and s.Fvp=0)");
			//проставляем часы гос.обязанностей по дням (для тех у кого часы = 0) 
			if(toCalcHours)
				ExecuteSQL("update ^"+tblName+" set Fgos_ch="+sqlRound("Fgos_d*Fnorma_ch/Fnorma_d",2)+" where Fgos_d>0 and Fgos_ch=0");
		}
		else
			WAIT(ru("Не возможно определить код поля ЛС гос.обязанностей",
					"Не можливо визначити код поля ОР для держ.обов'язків"));
		
		msg = ru("Расчет итогов...","Розрахунок підсумків...")
		setProgressPos(12, msg);
		//подсчитываем всего дней
		ExecuteSQL("update ^"+tblName+" set Full_d=Fcmnd_d+Fblnp_d+Fblns_d+Fblnb_d+Fotp_d+Fgos_d");
		//подсчитываем всего часов
		ExecuteSQL("update ^"+tblName+" set Full_ch=Fcmnd_ch+Fblnp_ch+Fblns_ch+Fblnb_ch+Fotp_ch+Fgos_ch");
		//подсчитываем всего дней + фактически
		ExecuteSQL("update ^"+tblName+" set Full_fact_d=Full_d+Fday");
		//подсчитываем всего часов + фактически
		ExecuteSQL("update ^"+tblName+" set Full_fact_ch=Full_ch+Fchas");
		setProgressPos(0);
	}
	return true;
}

//function listMenuInit()
//{
//}
//
//function listMenuRun(ID)
//{
//}

function filterMode(s)
{
	if(strIn("DEL",s))
		return false;
	else
		return true;
}

include("sys\\DpList.js");