//список диапазонов позиций переменных в текстовом файле импорта из клиент-банка
include("gridedit.js");

var tblName = extPar.tblName;
var dpGridEdit, minVarCount;

function listLoad()
{
	this.title = "Список діапазонів позицій змінних|Список диапазонов позиций переменных";
	if(extPar.minVarCount == null)
		minVarCount = 0;
	else
		minVarCount = extPar.minVarCount;
	if(!IsTable(tblName))
	{
		var m = new Object();
		m.Find1 = "INTEGER";
		m.Find2 = "INTEGER";
		m.Fwid = "COUNTER";
		CreateTable(tblName,m);
	}
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.init = gridAddRecord;
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
	dpGridEdit.addValidField("Find1", find1StartValid, find1SaveValid);
	dpGridEdit.addValidField("Find2", find2StartValid, find2SaveValid);
}

function listSrc()
{
	this.qrySet("From", tblName, "Order", "Find1,Find2");
}

function listDpGrid()
{
	include("Objects/DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	
	var gr = oGrid.page();
	var grp = grid.addGroup(UR("Індекси|Индексы"));
	grp.addField(gr.FieldEx("Find1", "Перший|Первый", 6, "e", "%10d"));
	grp.addField(gr.FieldEx("Find2", "Останній|Последний", 6, "e", "%10d"));
	gr.FieldEx("=getRem(^Find1,^Find2)", "Примітка|Примечание", 30);
	oGrid.build();
}

function listMenuInit()
{
	this.dataSrc.AddMenuItem("ADD","Додати|Добавить");
	this.dataSrc.AddMenuItem("EDIT","Редагувати|Редактировать");
	this.dataSrc.AddMenuItem("CLOSE","Завершити введення даних|Закончить ввод данных");
}

function listMenuRun(ID)
{
	switch(ID)
	{
		case "CLOSE":
			CloseWindow();
		break;
	}
}

function listUnLoad()
{
	extPar.rowCount = list.tbl.rowCount;
}

function gridAddRecord()
{
	with (this)
	{	
		var snap = getSnap("select MAX(Find2)+1 from "+tblName);
		if(snap)
		{
			initValue("find1", snap[0]);
			initValue("find2", snap[0]);
		}
		else
		{
			initValue("find1", 1);
			initValue("find2", 1);
		}
	}
}

function gridEdit(modeID)
{
	if(modeID=="COPY")
		return false;
	return true;
}

function saveRecord(sMode)
{
	if(list.tbl.getValue("Find2")<list.tbl.getValue("Find1"))
	{
		WAIT(ru("Последний индекс не может быть меньше первого","Останній індекс не може бути меншим за перший!"));
		return false;
	}
	var snap = getSnap("select Fwid from "+tblName+" where Find1="+list.tbl.getValue("Find1")+" and Find2="+list.tbl.getValue("Find2"));
	if(snap && snap[0]!=list.tbl.getValue("Fwid"))
	{
		WAIT(ru("Запись с такими индексами уже существует!","Запис з такими індексами вже існує!"));
		return false;
	}
	return true;
}

function find1StartValid(oCtrl)
{
	oCtrl.setMask("####");
}

function find2StartValid(oCtrl)
{
	oCtrl.setMask("####");
	if(oCtrl.getValue() < list.tbl.getValue("Find1"))
		oCtrl.setValue(list.tbl.getValue("Find1"));
}

function find1SaveValid(oCtrl)
{
	if(oCtrl.getValue() < 1)
	{
		WAIT(ru("Индекс не может быть меньше 1!","Індекс не може бути меншим за 1!"))
		return false;	
	}
	return true;
}

function find2SaveValid(oCtrl)
{
	if(oCtrl.getValue() < 1)
	{
		WAIT(ru("Индекс не может быть меньше 1!","Індекс не може бути меншим за 1!"))
		return false;	
	}
	return true;	
}

function getRem(ind1,ind2)
{
	if(extPar.str)
		return extPar.str.substring(ind1-1,ind2);
	else
		return "";
}

include("sys/DpList.js");