include("Objects/DpExtentionBuilder.js");
include("doc/DpDoc.js");

var varMap = new Object();
var id = extPar.id;
var obj = extPar.obj;
var tblOut;

function listLoad()
{	
	if(!obj && extPar.doc && extPar.nop)
		obj = new DpDoc(extPar.doc, extPar.nop);
	if(!obj)
		return false;
	if(id)
		obj.loadByID(id);
	else
		id = obj.getID();
		
	Caption(UR("Змінні|Переменные"), obj.getName() +"  № "+ obj.getVar("HNOM"));
	
	this.checkVars = checkVars;
	setButton(BCHECK, this, "checkVars");
	this.checkNewVar = checkNewVar;
	setButton(BGET, this, "checkNewVar");
	this.checkRow = checkRow;
	setButton(BCHECKROW, this, "checkRow");
	
	FNEWVAR.setToolTipText(UR("Уводь вираз і тисни 'ENTER'|Вводи выражение и жми 'ENTER'"));
	FNEWVAR.setEnterHandler(checkNewVar);	
	Disable(FNEWVAL);
			
	loadRows();
	
	tblOut = "TMP_VARCHECK_"+ obj.getID();
	checkVars(true);
}

function listSrc()
{
	this.qrySet("From", tblOut
				,"Where", "FVID='H'"
				,"Order", "FVAR, FTYPE"
				);
}

function listDpGrid()
{	
	//var tbl = OpenTable("select * from "+ tblOut +" where FVID='H' order by FVAR, FTYPE");
	initGrid(grid);
	
	tbl = OpenTable("select * from "+ tblOut +" where FVID='R' order by FVAR, FTYPE");
	initGrid(gridr, tbl);
	
	tbl = OpenTable("select * from "+ tblOut +" where FVID='U' order by FVAR, FTYPE");
	initGrid(gridu, tbl);
	
	tbl = OpenTable("select * from "+ tblOut +" where FVID='EH' order by FVAR, FTYPE");
	initGrid(grideh, tbl);
	
	tbl = OpenTable("select * from "+ tblOut +" where FVID='ER' order by FVAR, FTYPE");
	initGrid(grider, tbl);
}

function initGrid(oGrid, tbl)
{
	oGrid.DeletePages();
	
	with(oGrid)
	{
		FieldEx("FVAR", "Ім'я|Имя", 10);		
		FieldEx("FVALUE", "Значення|Значение", 10);
		FieldEx("FTYPE", "Тип|Тип", 5);				
		FieldEx("FEXPR", "Вираз|Выражение", 10);
		FieldEx("FREM", "Коментар|Комментарий", 10);
	}
	
	this.menuInit = menuInit;
	this.menuRun = menuRun;
	oGrid.loadMenuHandler(this,"menuInit");
	oGrid.selectMenuHandler(this,"menuRun");
	
	if(tbl)
		oGrid.setTable(tbl);
	oGrid.build();
}

function refreshGrid()
{
	grid.getTable().requery();
	gridr.getTable().requery();
	gridu.getTable().requery();
	grideh.getTable().requery();
	grider.getTable().requery();
	
	grid.refresh();
	gridr.refresh();
	gridu.refresh();
	grideh.refresh();
	grider.refresh();
}

function menuInit(ds)
{		
	var tbl = ds.getTable();
	if(tbl.isEmpty())
		return false;
	if(IsDblClick(ds) && !tbl.isEmpty())
	{
		var sVar = tbl.getValue("FVAR");		
		FNEWVAR.getCtrl().insert(sVar);
		setFocus(FNEWVAR);
		return false;
	}
	if(ds.getMouseAction()==2)	//ENTER
	{
		menuRun("CHECKVAR", ds);
		return false;
	}
	ds.AddMenuItem("CHECKVAR", "Визначити|Определить");
}

function menuRun(sID, ds)
{
	var tbl = ds.getTable();
	if(sID=="CHECKVAR")
	{
		FNEWVAR.value = tbl.getValue("FVAR");
		checkNewVar();
	}
}

function checkVars(bLoad)
{
	var nPr = 1;
	var sPr = UR("Завантаження|Загрузка");
	setProgressRange(0, 7);
	setProgressPos(nPr++, sPr);
	
	createTblOut(tblOut);
	
	if(bLoad!=true && id)	
		obj.loadByID(id);
		
	var sDoc = obj.getVar("HDOC");
	var nNop = obj.getVar("HOP");
	
	setProgressPos(nPr++, sPr + UR(" змінних заголовку...| переменных заголовка..."));	
	checkObjVars(obj);
	
	setProgressPos(nPr++, sPr + UR(" змінних рядка...| переменных строки..."));
	checkRow();
	/*
	if(obj.hasRows())
	{		
		if(obj.gotoFirstRow() && obj.getCurrRow())
			checkObjVars(obj.getCurrRow());
		else if(obj.gotoNextRow() && obj.getCurrRow())
			checkObjVars(obj.getCurrRow());		
		
		var sRowClass = obj.getChildClasses()[0];
		checkExtVars(obj.getCurrRow(), "R", sDoc +"."+ sRowClass, nNop);
	}
	*/
	
	setProgressPos(nPr++, sPr + UR(" змінних користувача...| пользовательских переменных..."));
	checkUserVars();
	
	setProgressPos(nPr++, sPr + UR(" розширень...| расширений..."));
	checkExtVars(obj, "H", sDoc, nNop);	
	
	if(bLoad!=true)
		refreshGrid();		
	setProgressPos(0);
	
	grid.setFocus();	
}

function checkObjVars(obj, sTmpTbl)
{
	if(!sTmpTbl)
		sTmpTbl = tblOut;
	
	var m = new Object();
	var batch = createBatch();
	var varsInfo = obj.getVarsInfo();
	
	for(var i=0; i<varsInfo.length; i++)
    {
    	m.Fexpr = varsInfo[i].expr;
	    m.Frem = varsInfo[i].rem;
	    m.Fvar = varsInfo[i].name;    	    
	    	    	    
	    if (m.Fvar.substr(0,1) == "H")
	    	m.Fvid = "H";
	    else if (m.Fvar.substr(0,1) == "R")
	    	m.Fvid = "R";
	    else
	    	continue;
	    	
	    switch (varsInfo[i].dataType)
	    {
	    	case 1: 
	    		m.Ftype = "C";
	    		break;
	    	case 2:
	    		m.Ftype = "N";
	    		break;
	    	case 3:
	    		m.Ftype = "D";
	    		break;
	    	case 5:
	    		m.Ftype = "L";
	    		break;
	    }
	    m.Fvalue = getObjVar(obj, m.Fvar);
				
    	addVar(m, batch);
    }
	batch.execute(false);
   	batch.close();
}

function checkUserVars()
{	
	var tbl = OpenTable("select * from ^VARDOC "
					+" where fdefa="+ sqlFalse 
						+" and FDOC="+ sqlTo(obj.getVar("HDOC"))
						+" and FNOP="+ sqlTo(obj.getVar("HOP"))
						);
	
	var m = new Object();
	var batch = createBatch();
	m.Fvid = "U";
	
	for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
	{
		m.Fexpr = tbl.getValue("FEXPR");
	    m.Frem = tbl.getValue("FREM");
	    m.Ftype = tbl.getValue("FTYPE");
		m.Fvar = tbl.getValue("FVAR");    	    
	    
	    m.Fvalue = getObjVar(obj, m.Fvar);
	    	   	    
	    addVar(m, batch);
	}
	batch.execute(false);
   	batch.close();
   	tbl.close();
}

function checkExtVars(obj, sVid, sDoc, nNop)
{
	if(!sVid)
		sVid = "H";
	
	var extInfoMap = obj.getExtInfo();
	
	var i = 1;
	var arrSort = new Array();
	for (var extLbl in extInfoMap)
	{
		var ext = extInfoMap[extLbl];
		arrSort[i++] = ext;
	}
	//arrSort.sort(sortExt);	
	
	/*
	if(!sDoc)
		sDoc = obj.getVar("HDOC");
	if(!nNop)
		nNop = obj.getVar("HOP");
	var extBuilder = new DpExtentionBuilder(sVid, sDoc, nNop);
	extBuilder.load(true);
   	extBuilder.buildStubs();
   	
   	var sTblName = extBuilder.getInfoTableName();
   	var sWhere = extBuilder.tblInfoWhere;
   	
   	var tbl = OpenTable("select * from ^"+ sTblName
						+" where "+ sWhere
						);
		
	*/					
	
	var m = new Object();
	var batch = createBatch();
	
	if(sVid=="H")
		m.Fvid = "EH";
	else
		m.Fvid = "ER";
	
	for(var i in arrSort)
	{
		var eInfo = arrSort[i];
		m.Fexpr = "";
	    m.Frem = eInfo.E_FieldText;
	    m.Ftype = String(eInfo.getType());;
		m.Fvar = String(eInfo.E_Label);	    
	    m.Fvalue = obj.getExt(m.Fvar);	   
	   	    
	    addVar(m, batch);
	}
	batch.execute(false);
   	batch.close();
   	//tbl.close();
}

function sortExt(e1, e2)
{
	if(e1.E_Pos < e2.E_Pos)
		return -1;
	else
		return 1;
}

function getObjVar(obj, sVar)
{
	var oVal = "";
	try
	{		
		oVal = obj.getVar(sVar);		
	}
	catch(e){}
	
	if(!oVal || oVal=="")
		oVal = obj.eval(sVar);	
	
	return oVal;
}

function getValue(oVal, sType)
{	
	if(!sType)
		return String(oVal);
		
	sType = sType.toUpperCase();
	if(sType=="D" || sType.indexOf("DATE")!=-1)
		oVal = StrDat(new Date(oVal), "DMY");
	
	return String(oVal);
}

function addVar(m, batch, sTmpTbl)
{
	if(!sTmpTbl)
		sTmpTbl = tblOut;
	
	var oVal = getValue(m.Fvalue, m.Ftype)
	var sVar = m.Fvar;
	eval("varMap."+ sVar +"=oVal"); 
	
	var sSQL = "INSERT INTO " + sTmpTbl
    				+"(FVAR,FREM,FEXPR,FVID,FTYPE,FVALUE)"
    			+" VALUES ("
    			 	+ sqlTo(m.Fvar)
    			 	+","+ sqlTo(m.Frem)
    			 	+","+ sqlTo(m.Fexpr)
    			 	+","+ sqlTo(m.Fvid)
    			 	+","+ sqlTo(m.Ftype)
    			 	+","+ sqlTo(oVal)
    			 	+")";
    if(batch)
 		batch.addBatch(sSQL);
	else
		ExecuteSQL(sSQL);
}

function createTblOut(sTblName)
{
	if(!sTblName)
		sTblName = tblOut;
	
	if(!ExecuteSQL("drop table "+ sTblName, false))
		ExecuteSQL("delete from "+ sTblName, false);
	
	var sSQL = "create table "+ sTblName
			+" (FWID "+ SqlType("COUNTER") 
			+" ,FVAR "+ SqlType("TEXT")		
			+" ,FREM "+ SqlType("TEXT")
			+" ,FEXPR "+ SqlType("TEXT")
			+" ,FVID "+ SqlType("TEXT",15)
			+" ,FTYPE "+ SqlType("TEXT",25)
			+" ,FVALUE "+ SqlType("TEXT")						
			+")";
	return ExecuteSQL(sSQL, false);
}

function checkNewVar()
{	
	FNEWVAL.value = "";
	if(id)	
		obj.loadByID(id);	
	var oVal = "";
	var curObj = obj;
	var sVar = FNEWVAR.value;			
	
	var bRowExt = TAB.getSelection()[0] == T5 ;
	var bRowVar = (bRowExt || TAB.getSelection()[0] == T2);	
	
	if(bRowVar && obj.hasRows())
		curObj = getRow();
	if(!curObj)
		return;
		
	if(bRowExt || TAB.getSelection()[0] == T4)
		oVal = curObj.getExt(sVar);
	else
		oVal = getObjVar(curObj, sVar);

	FNEWVAL.value = getValue(oVal);
}

function isExt(sVar, sRowClass)
{
	var sDoc = obj.getVar("HDOC");
	var sNop = String(obj.getVar("HOP"));
	var oExt = getSnap("select FLABEL from ^CL_EXT "
					+" where FCLASS="+ sqlTo("H."+ sDoc)
						+" and FSUBCLASS="+ sqlTo(sNop)
						+" and FLABEL="+ sqlTo(sVar), false);
	return oExt!=null;
}

function isRowExt(sVar, sRowClass)
{
	if(!sRowClass)		
		sRowClass = obj.getChildIDs()[0];
	if(!sRowClass)	
		sRowClass = "ROW";
	var sDoc = obj.getVar("HDOC");
	var sNop = String(obj.getVar("HOP"));
	var oExt = getSnap("select FLABEL from ^CL_EXT "
					+" where FCLASS="+ sqlTo("R."+ sDoc +"."+ sRowClass)
						+" and FSUBCLASS="+ sqlTo(sNop)
						+" and FLABEL="+ sqlTo(sVar), false);
	return oExt!=null;
}

function loadRows()
{
	if(!obj.hasRows())
		return;
		
	var arrClass = obj.getChildIDs();
	for(var i=0; i<arrClass.length; i++)
		FROWCLASS.addItem(arrClass[i], arrClass[i]);
	
	obj.gotoFirstRow();
	while(obj.gotoNextRow())
	{
		var currRow = obj.getCurrRow();
		if(currRow)
			FROWID.addItem(currRow.getID(), currRow.getID());
	}
	
	FROWCLASS.value = arrClass[0];
	FROWID.setSelectedIndex(0);
	ROWKOL.setText(UR("Кількість рядків: |Количество строк: ") + FROWID.length);
}

function checkRow()
{
	var sClass = FROWCLASS.value;
	var nID = Number(FROWID.value);
	
	var oRow = getRow();
	if(!oRow)
		return;
	
	ExecuteSQL("delete from "+ tblOut +" where FVID='R' or FVID='ER'");	
	checkObjVars(oRow);
	if(gridr.getTable())
	{
		gridr.getTable().requery();
		gridr.refresh();
	}
	
	checkExtVars(oRow, "R", obj.getVar("HDOC") +"."+ sClass, obj.getVar("HOP"));	
	if(grider.getTable())
	{
		grider.getTable().requery();
		grider.refresh();
	}
}

function getRow()
{
	var sClass = FROWCLASS.value;
	var nID = Number(FROWID.value);
	if(!sClass || sClass=="" || !nID)
		return null;		
	var oRow = obj.getRow(sClass, nID);
	return oRow;
}

include("sys/DpList.js");