include("Objects/DpMsgBox.js");
include("doc/DpDoc.js");
include("gridedit.js");

var tblName = "TMP_VAR_DOC_DEF";
getdef = getDef 
var oDocument;
var DpAPI = lpProxy.getDpAPI();
var TYPE_TEXT = 1;
var TYPE_NUMBER = 2;
var TYPE_DATE = 3;
var TYPE_DOUBLE = 4;
var TYPE_BOOLEAN = 5;

var dpGridEdit = null;

function listLoad()
{
	this.xmlGridFile = "l_vardcdef.xml";
	var sFolder = (extPar.folder ? extPar.folder : "");
	var nop = extPar.nop ? extPar.nop : 0;
	var fldr =  "   Папка:  ";
	fldr += sFolder;
	
	this.title = ru("Значения по умолчанию", "Значення за замовченням") + "   Документ:  " + extPar.doc + fldr;
	
	oDocument = new DpDoc(extPar.doc,nop);
	
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridCanEdit;
	//dpGridEdit.saveRecord = saveRecord;
	//dpGridEdit.addValidField("=getDef(^fdef,^ftype)", start_fdef, save_fdef);
	dpGridEdit.addValidField("fedit", null, save_fedit);	
	dpGridEdit.addValidField("fdef", start_fdef, save_fdef);
	
	this.exit = this.escape = onEscape;
	this.save = onSave;
	this.mnuHandler = listMenuRun;
	
	fillTable();
}

function onEscape()
{
	FORM.close();
}

function onSave()
{
	dpGridEdit.grid.onEndEditRow();
	//saveRecord(grid.getTable().getValue("FWID"));
		
	var defVarsPath = oDocument.getDefPath();
	var xml = createXmlDoc();
	var root = xml.createElement("DefaultVariables");
	xml.appendChild(root);
	
	var tbl = OpenTable(tblName);
	for (tbl.MoveFirst();!tbl.IsEOF();tbl.MoveNext())
	{
		var sName = tbl.getValue("FVAR");
		var nType = tbl.getValue("FTYPE");
		var sValue = tbl.getValue("FDEF");
		var bEdit = tbl.getValue("FEDIT");
		if (sValue == null
		|| sValue == ""
		|| (nType == 2 && isNaN(sValue))
		|| (nType == 4 && isNaN(Number(sValue)))
		|| (nType == 3 && sValue == "01.01.3000"))
			continue;
		var elVar = xml.createElement(sName);
		elVar.setTextContent(sValue);
		elVar.setAttribute("canedit",(bEdit == false?"false":"true"));
		root.appendChild(elVar);
	}
	saveXml(defVarsPath,xml);
	tbl.close();
	FORM.close();
}

var lastDefVal = "";
var lastFedit = true;

function gridCanEdit(sID)
{
	lastDefVal = grid.getTable().getValue("FDEF");
	lastFedit = grid.getTable().getValue("FEDIT");
	if ("EDIT" == sID)
		return true;
	return false;
}

function start_fdef(oCtrl)
{
	try
	{		
		var nType = parseInt(list.tbl.getValue("ftype"));
		switch (nType)
		{
			case TYPE_NUMBER:
				oCtrl.setMask("######")
				break;
			case TYPE_DOUBLE:
				oCtrl.setMask("###.##")
				break;
		}
		/*
		var bEdit = list.tbl.getValue("fedit");
		if(bEdit==false || bEdit=="false")
			oCtrl.setEnabled(false);		
		else
			oCtrl.setEnabled(true);
		*/
	}
	catch(x){}
	
	return true;
}

function save_fdef(oCtrl)
{
	//return true;
	
	var oValue = oCtrl.getValue();
	var nType = parseInt(list.tbl.getValue("FTYPE"));
	lastDefVal = DpAPI.obj2XmlStr(oValue, nType);
	lastFedit = grid.getTable().getValue("FEDIT");
	//list.tbl.setValue("FDEF", lastDefVal);
	return true;
}

function save_fedit(oCtrl)
{
	lastDefVal = grid.getTable().getValue("FDEF");
	lastFedit = oCtrl.getValue();
	return true;
}
/*
function saveRecord(fwid)
{
	if(!fwid)
		fwid = list.tbl.getValue("fwid");
	var m = new Object();
	m.FDEF = String(lastDefVal);
	m.FEDIT = lastFedit;
	m.FWID = fwid;
	UpdateTable(tblName, m, false);
	return true;
}
*/
function getDef(sDef,nType)
{
	if (sDef == null
		|| sDef == ""
		|| (TYPE_NUMBER == nType && parseInt(sDef) == 0)
		|| (TYPE_DOUBLE == nType && isNaN(Number(sDef)))
		|| (TYPE_DATE == nType && sDef == "01.01.3000"))
	{
		nType = parseInt(nType);
		switch (nType)
		{
			case TYPE_BOOLEAN:
				return false;
			case TYPE_DATE:
				return (new Date("01/01/3000")).getVarDate();
			case TYPE_NUMBER:
			case TYPE_DOUBLE:
				return 0;
			case TYPE_TEXT:
				return "";
		}
	}
	
	var ret = DpAPI.str2Obj(sDef,nType);
	return ret;
}

function fillTable()
{
	DropTable(tblName);
	var sSQL = " CREATE TABLE "+ tblName +"("
			 + " FWID " + SqlType("LONG")
			 + ",FVAR " + SqlType("TEXT",254)
			 + ",FDEF " + SqlType("TEXT",254)
			 + ",FNAZV " + SqlType("TEXT",254)
			 + ",FTYPE " + SqlType("INT")
			 + ",FEDIT " + SqlType("LOGICAL")
			 + ")";
	ExecuteSQL(sSQL);
	var oBatch = createBatch();
	var varArr = oDocument.getVarsInfo();
	var root = null;
	if (isFile(oDocument.getDefPath()))
	{
		var xml = openXmlFile(oDocument.getDefPath());
		root = xml.getDocumentElement();
	}
	
	for (var nVar = 0; nVar < varArr.length; nVar++)
	{
		var currVar = varArr[nVar];
		if (varArr[nVar].isDef != true)
			continue;
		var m = new Object();
		m.FWID = nVar;
		m.FVAR = currVar.name;
		var defEl = null;
		if (root != null)
			defEl = Packages.com.sun.org.apache.xpath.internal
					.XPathAPI.selectSingleNode(root,currVar.name);
		if (defEl == null)
		{
			m.FDEF = "";
			m.FEDIT = true;
		}
		else
		{
			m.FDEF = defEl.getTextContent();
			m.FEDIT = "false" != defEl.getAttribute("canedit");
		}
		
		m.FNAZV = currVar.getRem();
		m.FTYPE = currVar.dataType;
		var sUpdSQL = getSQLForUpdate(tblName, m, true);
		oBatch.addBatch(sUpdSQL);
	}
	oBatch.execute(false);
}

function listSrc()
{
	this.qrySet("From", tblName, "Order", "FVAR");
}

function listMenuInit()
{
	if (!(this.tbl.IsEOF() && this.tbl.IsBOF()))
    {
		this.dataSrc.AddMenuItem ("EDIT","Редагування|Редактирование");
		this.dataSrc.AddMenuItem ("DEL"," Знищення значення за замовченням|Удаление значения по умолчанию");
	}
	
	return false;
}

function listMenuRun(nID)
{
	switch (nID)
	{
		case "DEL":
			ExecuteSQL("UPDATE "+ tblName +" set FDEF=''"
					 + " WHERE FWID=" + sqlTo(this.tbl.getValue("FWID")));
		var b = list.tbl.absolute;
		list.tbl.requery();
		list.tbl.absolute = b;
		this.dataSrc.refresh();
		break;
	}
}

function getTypeText(nType)
{
	nType = parseInt(nType);
	switch(nType)
	{
		case TYPE_TEXT:
			return "Текст";
		case TYPE_DATE:
			return "Дата";
		case TYPE_NUMBER:
		case TYPE_DOUBLE:
			return "Число";
		case TYPE_BOOLEAN:
			return UR("Логічний|Логический");
	}
}

include("sys\\DpList.js");