include("Objects/DpGetDat.js");
include("Objects/DpGrid.js");
include("Objects/DpAskEx.js");
include("servis/zrp.js");
//include("Objects/DpAskEx.js");
var tblName, dat1, menuMode;
var sortMode = ReadParEx("VISL_SORT_MODE");

function listLoad()
{
	menuMode = GetMenuMode();
	var gd = new DpGetDat("d");
	if(gd.escape)
		return false;
	dat1 = firstDayMonth(gd.dat1);
	tblName = "visl_ved"+getDateTag(dat1);
	this.title = UR("Відомість за стажем на |Ведомость по стажу на ")+format("dd.mm.yyyy", dat1);
	if(menuMode=="VIEW" && !IsTable(tblName))
	{
		alert(ru("Сначала выполните расчет","Спочатку виконайте розрахунок")+format(" за dd.mm.yyyy", dat1));
		return false;
	}
	this.printLabel = "VISL_VED";
}

function listSrc()
{
	this.qrySet("Fields", "t.*,cl.Ftxt",
				"From", tblName+" as t left join ^cl as cl on t.Ftabn_id=cl.Fwid", 
				"Order", getOrder(sortMode),
				"Alias", "t");
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
//	oGrid.defCond("=^Ftxtpers==null", "err")
//	oGrid.color(17, "err");
	var gr = oGrid.page();
	with(gr)
	{
		FieldEx("Fcod", "Таб №|Таб №", 3);
		FieldEx("Ftxt", "ПІБ|ФИО", 15);
		FieldEx("Ftxtorg", "Підрозділ|Подразделение", 15);
		FieldEx("Ftxtdol", "Посада|Должность", 15);
		FieldEx("Fwrkdat", "Дата прийому на роботу|Дата приема на работу", 8);
		FieldEx("Fdatcor", "Скоригована дата|Скорректированная дата", 8);
		FieldEx("Fdatvisl", "Дата для загального стажу|Дата для общего стажа", 8);
		with(group("Стаж|Стаж"))
		{
			FieldEx("Fyears", "Років|Лет", 8);
			FieldEx("Fmonths", "Місяців|Месяцев", 8);
			FieldEx("Fdays", "Днів|Дней", 8);
		}
		FieldEx("Fis_prk", "Існує нак.в з/п|Сущ.прик.в з/п", 5);
	}
	oGrid.build();		
}

function listMake()
{
	var fld = new Object();
	fld.FWID = "COUNTER";
	fld.FTABN_ID = "LONG";
	fld.FCOD = "INT";
	fld.FTXTORG = "TEXT";
	fld.FTXTDOL = "TEXT";
	fld.FWRKDAT = "DATE";
	fld.FDATCOR = "DATE";
	fld.FDATVISL = "DATE";
	fld.FYEARS = "INT";
	fld.FMONTHS = "INT";
	fld.FDAYS = "INT";
	fld.FIS_PRK = "BIT";
	var ind = new Object();
	ind.FTABN_ID = "FTABN_ID";
	ind.FCOD = "FCOD";
	ind.FWID = "FWID";
	CreateTable(tblName, fld, ind);
	
	//отбираем всех сотрудников из периода
	ExecuteSQL("insert into "+tblName+" (Ftabn_id, Fcod, Ftxtorg, Ftxtdol, Fwrkdat, Fdatcor) "
			+ " select Fwid_cl, Fcodpers, Ftxtorg, Ftxtdol, Fwrkdat, Fvisldat "
			+ " from ^full_pers as f where Fbdat<="+sqlTo(dat1)+" and Fedat>="+sqlTo(dat1)
				+ " and Fwid=(select MAX(Fwid) from ^work_pers as wp where f.Fwid_cl=wp.Fwid_cl and wp.Fbdat<="
					+ sqlTo(dat1)+" and wp.Fedat>="+sqlTo(dat1)+" and wp.Fis_serv="+sqlFalse+" and wp.Ftable=1)");
	//проставляем окончательную дату выслуги
	ExecuteSQL("update "+tblName+" set Fdatvisl="+IIF("Fdatcor="+sqlTo(d00)+" or Fdatcor is null", "Fwrkdat", "Fdatcor"));
	//проставляем признак наличие приказа в учете з/п
	ExecuteSQL("update "+tblName+" set Fis_prk="+sqlTrue
				+" where exists(select Fwid from ^prk_all as p where Fvid_prk in (select Fvid from ^cl_prik as c where LOWER(Fedit)="+sqlTo("_visl")+") "
					+" and p.Ftabn_id="+tblName+".Ftabn_id and p.Fbdat<="+sqlTo(dat1)+" and p.Fedat>="+sqlTo(dat1)+")");
	//проставляем сроки выслуги
	var t = OpenTable("select * from "+tblName+" where Fdatvisl<>"+sqlTo(d00));
	var step = 1;
	setProgressRange(step, t.rowCount);
	for(; !t.IsEOF(); t.MoveNext())
	{
		setProgressPos(step++, ru("Обработка записей: ","Обробка записів: ")+t.bookmark+"/"+t.rowCount);
		var sTerm = getVislTerm(dat1,t.getValue("Fdatvisl"));
		if(sTerm.length>0)
		{
			var m = new Object();
			var ar = sTerm.split("/");
			if(ar.length==3)
			{
				m.Fyears = Number(ar[0]);
				m.Fmonths = Number(ar[1]);
				m.Fdays = Number(ar[2]);
				UpdateTable(tblName, m, false, "Fwid="+t.getValue("Fwid"));
			}
		}
	}
	setProgressPos(0);
	t.close();
}

function listMenuInit()
{
	with(this.dataSrc)
    {
		switch(sortMode)
		{
			case "FIO":
				AddMenuItem("SORTTABN", "Сортувати за таб.№|Сортировать по таб.№");
				AddMenuItem("SORTFIO", "Сортувати за ПІБ|Сортировать по ФИО",ICON_RADIO);
				AddMenuItem("SORTSTAGE", "Сортувати за стажем|Сортировать по стажу");
			break;
			case "STAGE":
				AddMenuItem("SORTTABN", "Сортувати за таб.№|Сортировать по таб.№");
				AddMenuItem("SORTFIO", "Сортувати за ПІБ|Сортировать по ФИО");
				AddMenuItem("SORTSTAGE", "Сортувати за стажем|Сортировать по стажу",ICON_RADIO);
			break;
			case "TABN":
			default:
				AddMenuItem("SORTTABN", "Сортувати за таб.№|Сортировать по таб.№",ICON_RADIO);
				AddMenuItem("SORTFIO", "Сортувати за ПІБ|Сортировать по ФИО");
				AddMenuItem("SORTSTAGE", "Сортувати за стажем|Сортировать по стажу");
			break;
		}
    }
}

function listMenuRun(ID)
{
	switch(ID)
	{
		case "SORTTABN":
		case "SORTFIO":
		case "SORTSTAGE":
			sortMode = ID.replace("SORT","");
			WriteParEx("VISL_SORT_MODE",sortMode);
			grid.DeletePages();
			list.init();
		break;
	}
}

function filterMode(s)
{
	return true;		
}

function getOrder(mode)
{
	var sOrder;
	switch(String(mode))
	{
		case "FIO":
			sOrder = "cl.Ftxt";
		break;
		case "STAGE":
			sOrder = "t.Fyears,t.Fmonths,t.Fdays";
		break;
		case "TABN":
		default:
			sOrder = "t.Fcod";
		break;
	}
	return sOrder;
}

function getTblH()
{
	var h = new Object();
	h.HDAT = dat1;
	return h;
}

include("sys/DpList.js");