/*
	Библиотека для расчета оборотов и остатков по номенклатуре.
	
	Описание параметров в комментариях в функции DpMtrOb
	Вызов:
		
	var o = new DpMtrOb();
	o.параметр1 = значение1;
	o.параметр2 = значение2;
	...
	o.Calc();
*/
include("sub\\mtr.js");
include("sys\\dpSQL.js");

var tmpTblName = "TMP_ANOST"
function DpMtrOb(mode)
{
	this.doCalc = DpMtrOb_doCalc;   // Вызвать расчет
	this.getTbl = DpMtrOb_getTbl;   // Метод, которым вызывающая строна может получить объект-таблицу результата

	// Перечень используемых параметров
	this.mode = mode;               // режим - не используется
	this.fdate  = null;             // Если задано, то расчитываются остатки на конец указанной даты
	this.date1 = null;              // Если заданы date1 и date2, то рассчитвыаются обороты за период и остаки на начало периода и на конец периода
	this.date2 = null;
	this.tblName = tmpTblName;      // название таблицы, куда будет положен результат расчета (если не указана - будет использоваться значение по-умолчанию, которое можно узнать из этого же свойства)
	this.pattern = null;            // шаблон (из WINSTRU.TXT), по каторому должна быть создана таблица результа. Можно не указывать
	this.indexes = "fwid";             // списко индексов шаблона
	this.union = false;             // если установить union в true, то результат будет объединен с существующими записами в таблице, иначе - таблица будет создана заново
	this.isFostsum = true;          // добавлять ли колонку с остатком в суммовом (денежном) эквиваленте
	this.isSprKol = false;          // необходимо ли расчитывать обороты и остатки таже по справочному количеству
	this.isFinDate = false;         // добавлять ли колонку "дата окончания" из строки первого прихода
	this.finDated = false;          // показывать только записи с истекшим строком
	this.finDateExists = false;     // расчитывать только по записям, для который в первом приходе просавлена дата окончания (обороты/остатки по малоценке)
	this.isFid_pndoc = false;       // добавлять ли колонку fwid документа прихода
	this.sumCenaPost = false		// суммировать по ценам поставщика
	this.sumCenaPostUch = false		// суммировать по учетным ценам поставки (ценам поставщика в ГРН + наценка)
	this.pn1_date1  = null;         // минимальная дата первого прихода
	this.pn1_date2 = null;          // максимальная дата первого прихода 
	this.codv   = null;             // Не используется
	this.fnmkl = null;              // Фильтр по номенклатуре
	this.fis_otl = null;            // Фильтр по отложенному расцениванию
	this.fsn = null;              	// Фильтр по серифному номеру
	this.fcena = null;              // Фильтр по учетной цене
	this.fpodr = null;              // Фильтр по подразделеню
	this.fmol  = null;              // Фильтр по МОЛ
	this.fsc   = null;              // Фильтр по счету
	this.fsu   = null;              // Фильтр по субсчету
	this.fst   = null;              // Фильтр по статье
	this.fpost = null;              // Фильтр по поставщику
	this.fid_pn = null;             // Фильтр по приходу
	this.fwid  = null;              // ИСКЛЮЧИТЬ (игнорировать) запись с этим идентификатором в расчете оборотов и остатков.
	this.update = null;
	this.extraFlds = "";            // Дополнительные поля, которые вызывающая сторона хочет видеть в результирующцей таблице
	this.extraWhere = "";
	this.groupby = null;
	this.extraGroupBy = "";            // Дополнительные поля, по которым вызывающая сторона хочет группировать в результирующцей таблице	
	
	// Внутренние переменные
	this.query = null;
	this.query1 = null;
	this.query2 = null;
}


// Расчет остатков (и оборотов)
function DpMtrOb_doCalc()
{
	var nSumDec = 5;
	var nKolDec = 5;

	with(this)
	{
		var selFrom;
		if(finDated)
			isFinDate = true;
		
		// Перечень полей, по которым группируются все движения
		var chainFlds = "";
		var chainFldsGr = "";
		var kursExpr = " * " + IIF("k.fkurs is null","1","k.fkurs");
		chainFlds = "a.fnmkl, MIN(cl.fcod) AS fnmklcod, (case when cl.fis_sred = 1 then 0 else a.fcena end) as fcena_ord, 0 as fis_otl, a.fpodr, a.fmol"
					//+ ", a.fsc, a.fsu, a.fst, a.fpost, a.fid_pn, " + Convert("' '","NVC") + " AS fsn";
					+ ", a.fsc, a.fsu, a.fst, a.fpost, a.fid_pn, MAX(a.fsn) AS fsn";
		/*					
		chainFldsGr = "a.fnmkl, a.fis_otl, a.fcena_ord, a.fpodr, a.fmol"
					+ ", a.fsc, a.fsu, a.fst, a.fpost, a.fid_pn, a.fsn";
		*/
		chainFldsGr = "a.fnmkl, (case when cl.fis_sred = 1 then 0 else a.fcena end), a.fpodr, a.fmol"
					+ ", a.fsc, a.fsu, a.fst, a.fpost, a.fid_pn, cl.fis_sred";
		
		/*	
		ExecuteSQL("DROP TABLE tmp_anltkost", false);		
		
		ExecuteSQL(
			"SELECT max(a.fdoc_dat) AS fdate"
				+ ", fsc, fsu"
			+ " INTO tmp_anltkost"
                        + " FROM ^sch_zag a"
			+ " WHERE fdoc='SA'"
				+ sqlw0And("a.fsc=", fsc)
				+ "AND fdoc_dat<=" + sqlTo(fdate!=null? fdate: date1)
			+ " GROUP BY fsc, fsu"
			);
					
		// Удаляем все остатки по субсчетам, датой раньше, чем остатки по
		// этому же счету. Например, если 1.1.2004 был остаток по счету 21/1
		// а на 1.2.2004 был остатко по счету 21/0, то первый остаток не должен
		// участвовать в оборотах

		if (SUBD != MYSQL)
		{
			if (SUBD == ORACLE)
				ExecuteSQL(
					"DELETE "
					+ " FROM tmp_anltkost as a"
					+ " WHERE exists (SELECT * FROM tmp_anltkost as b WHERE a.fsc=b.fsc "
					+ " and a.fsu=0 AND a.fdate<b.fdate)"
					);
			else if(SUBD == MSSQL)
				ExecuteSQL(
					"DELETE a"
					+ " FROM tmp_anltkost as a"
					+ " WHERE exists (SELECT * FROM tmp_anltkost b WHERE a.fsc=b.fsc "
						+ " and ((a.fsu=0 and b.fsu<>0)OR (a.fsu<>0 and b.fsu=0))"
							+ " AND a.fdate<b.fdate)"
					);
					
			else if(SUBD == DERBY || SUBD == DB2)
			{
				ExecuteSQL("SELECT * INTO tmp_anltkost_1 FROM tmp_anltkost")
				ExecuteSQL(
					"DELETE "
					+ " FROM tmp_anltkost"
					+ " WHERE exists (SELECT * FROM tmp_anltkost_1 b WHERE tmp_anltkost.fsc=b.fsc "
					+ " and tmp_anltkost.fsu=0 AND tmp_anltkost.fdate<b.fdate)"
					);
					
				DropTable("tmp_anltkost_1");
			}
		}
		else
		{
			ExecuteSQL(
						"DELETE FROM a"
						+ " using tmp_anltkost a, tmp_anltkost b "
						+ "WHERE a.fsc=b.fsc"
						+ " AND a.fdate<b.fdate"
						+ " AND a.fsu=0"
					   );
		}
		
		//browse("tmp_anltkost")
			
		// На скорость, похоже, не влияет
		//ExecuteSQL("CREATE INDEX sc ON tmp_anltkost (fsc, fsu)");
		 */
		//fnmkl = String(fnmkl);		
		//var isPolyNmkl = !fnmkl || fnmkl.charAt(fnmkl.length-1)==".";
		var isPolyNmkl = !fnmkl;		
		var whereNmk = '';
		
		// Объект - условие
		var oCond = new Object();
		oCond.isPolyNmkl = isPolyNmkl;
		oCond.fnmkl = fnmkl;
		oCond.fsc = fsc;
		oCond.fpodr = fpodr;
		oCond.fmol = fmol;
		oCond.date2 = (fdate!=null? fdate: date2);
		
		if(!isPolyNmkl)
		{			
			whereNmk = sqlwNmk("a.fnmkl", fnmkl);
		}
		
		var perSnap = getSnap(
			"SELECT ftblname"
			+ " FROM ^anltk_per"
			+ " WHERE " + (fdate!=null
				? sqlTo(fdate) + " BETWEEN fbdate AND fedate"
				: sqlTo(date1) + " BETWEEN fbdate AND fedate"
					+ " AND " + sqlTo(date2) + " BETWEEN fbdate AND fedate"
				)
			);
		
		var sAnltkName = (perSnap != null ? "^" + perSnap[0] : "^anltk");
	
		// Таблицы, участвующие в расчете
		selFrom = sAnltkName + " a"
		
		selFrom +=
			" LEFT JOIN ^cl_nmk cl"
					+ " ON a.fnmkl=cl.fwid"

		// Расчет оборотв		
		if(fdate==null)
		{
			/*
			if(selFrom.search("JOIN")!=-1) //AL: Возьмем в скобки только если есть LEFT JOIN
				selFrom = "(" + selFrom + ")";
                        selFrom += " LEFT JOIN tmp_anltkost c ON a.fsc=c.fsc "
			*/			             
		}

		if (this.sumCenaPost)
		{
			if(selFrom.search("JOIN")!=-1) //AL: Возьмем в скобки только если есть LEFT JOIN	
				selFrom = "(" + selFrom + ")";
			selFrom += " LEFT JOIN " + sAnltkName + " as a_cp ON a.fid_pn=a_cp.fwid";
			if (!this.sumCenaPostUch)
			{
				selFrom = "(" + selFrom + ")";
				selFrom += " LEFT JOIN ^kursval as k " 
								+ " ON (a_cp.f1val = k.fkod"
									+ " AND (a_cp.fdate BETWEEN k.fbdat AND k.fedat))"
			}
		}
		
		// Условие расчета
		//var selWhere = "1=1"
		var selWhere = "(a.fisfictive = 0 or a.fisfictive is null)"
						+ (isPolyNmkl? " AND " + " (cl.fvid<>'S' or cl.fvid is null) ": "")
						+ sqlw0And("a.fwid<>", fwid);
		selWhere += sqlw0And("a.fis_otl=", fis_otl)
			+ (fsn!=""? sqlw0And("a.fsn=", fsn) : "")
			+ (fcena!=0?sqlw0And("a.fcena=", fcena):(SUBD==ORACLE?' ':''))
			+ sqlw0And("a.fpodr=", fpodr)
			+ sqlw0And("a.fmol=", fmol)
			+ sqlw0And("a.fsc=", fsc)
			+ sqlw0And("a.fsu=", fsu)
			+ sqlw0And("a.fst=", fst)
			+ sqlw0And("a.fpost=", fpost)
			+ sqlw0And("a.fid_pn=", fid_pn)
			+ (finDated? (" AND pn1.ffindate<=" + sqlTo(fdate!=null? fdate: date2)): "")
			+ (this.finDateExists? " AND (pn1.ffindate IS NOT NULL) AND pn1.ffindate<>" + sqlTo(d00): "") 
			+ whereNmk
			//+ ((fnmkl==null || fnmkl==0)? "" : sqlwNmk("a.fnmkl", fnmkl))
			;

		// Группировка
		var selGroupBy;
		if(this.groupby)
			selGroupBy = this.groupby;
		else
			selGroupBy = chainFldsGr;			
		selGroupBy += this.extraGroupBy;		
				// + ", a.fis_otl" // для отложенного расценивания
		// Базовый список полей для отбора
		var selFlds = chainFlds
			// Учетная цена определяется как средняя цена по цепочке.
			// Имеет значение для номенклатуры, которая ведется по средним ценам.
			// В этом случае учетная цена должна быть средней по цепочке.
			// Для обычной номенклатуры в цепочке все учетные цены
			// равны, и средняя цена будет совпадать с ценой в цепочке.
			// Для номенклатур, которые ведутся по средним быстрый расчет не подходит
			
		+ ", "+IIF("cl.fis_sred <> 1 ", "MAX(a.fcena)", 
					IIF(sqlRound("sum(" + sRecSign + "*a.fkol)", 6)+ "=0",
					"0", 
					"sum(" + sRecSign + "*a.fkol*a.fcena)"
							+ "/sum(" + sRecSign + "*a.fkol)"
					)
				  ) + " AS fcena"  + extraFlds;
		
		// SQL-Выражение для расчета количественного итога без учета счетов-фактур
		var fostExpr = sqlRound("sum(" + sRecSign + "*a.fkol)", nKolDec);
		// SQL-Выражение для расчета количественного итога с учететом счетов-фактур
		var fost1Expr = sqlRound("sum(" + sRecSignSF + "*a.fkol)", nKolDec);
		// SQL-Выражение для расчета количественного итога по справочному количеству
		var fost_sprExpr = sqlRound("sum(" + sRecSign + "*a.fkol_spr)", nKolDec);
		
		// SQL-Выражение для расчета суммового итога без учета счетов-фактур
		var fostsumExpr = sqlRound( "sum(" + sRecSign + "*a.fkol*a.fcena)", nSumDec);
		
		// SQL-Выражение для расчета суммового итога без учета счетов-фактур (по ценам поставщика)
		var f1ostsumExpr = sqlRound( "sum(" + sRecSign + "*a.fkol*a_cp.f1cena"+kursExpr+")", nSumDec);
		if (this.sumCenaPostUch)
			f1ostsumExpr = sqlRound( "sum(" + sRecSign + "*a.fkol*"+IIF("a_cp.fdoc='SA' and a_cp.fsu=282","a_cp.f1cena","a_cp.fcena")+")", nSumDec);
		
		// SQL-Выражение для расчета суммового итога с учетом счетов-фактур
		var fostsum1Expr = sqlRound( "sum(" + sRecSignSF + "*a.fkol*a.fcena)", nSumDec);

		// SQL-Выражение для расчета суммового итога с учетом счетов-фактур (по ценам поставщика)
		var f1ostsum1Expr = sqlRound( "sum(" + sRecSignSF + "*a.fkol*a_cp.f1cena"+kursExpr+")", nSumDec);
		if (this.sumCenaPostUch)
			f1ostsum1Expr = sqlRound( "sum(" + sRecSignSF + "*a.fkol*"+ IIF("a_cp.fdoc='SA' and a_cp.fsu=282", "a_cp.f1cena", "a_cp.fcena")+")", nSumDec);
	
		var bostExprs = ""

		// Атрибуты первого прихода
		if(this.isFinDate || this.isFid_pndoc || this.pn1_date1 || this.pn1_date1 || this.finDateExists)
		{
			selFlds = selFlds
				+ (this.isFinDate? ", pn1.ffindate AS ffindate": "")
				+ (this.isFid_pndoc? ", pn1.fid_doc AS fid_pndoc": "")
			selGroupBy = selGroupBy	
				+ (this.isFinDate? ", pn1.ffindate": "")
				+ (this.isFid_pndoc? ", pn1.fid_doc": "")
			
			if(selFrom.search("JOIN")!=-1) //AL: Возьмем в скобки только если есть LEFT JOIN	
				selFrom = "(" + selFrom + ")";
                        selFrom +=" LEFT JOIN " + sAnltkName + " pn1 ON a.fid_pn=pn1.fwid";
			
			selWhere += sqlw0And("pn1.fdate>=", this.pn1_date1)
				+ sqlw0And("pn1.fdate<=", this.pn1_date2)
		}
		
		if(extraWhere)
			selWhere = "(" + selWhere + ") AND (" + extraWhere + ")";
			
		//showObject(this);
		if(fdate!=null)  // Расчет на дату
		{
			// Здесь нам надо посчитать остаки на указанную дату.
			// Остатки считаются на конец дня (обороты за день включаются)
			if(!pattern)
				pattern = "vdost";
			
			timeBegin("CreateTable");
			if(!union)
			{
				DropTable(tblName);
				CreateTable(tblName, pattern, indexes);
			}
			timeEnd("CreateTable");
			//debug();
			cAnothers = "";
			cScCond = "";

			/*
			tOstDate = OpenTable("s", "tmp_anltkost");
			var batch = createBatch();
			//browse(tOstDate)
			while(!tOstDate.IsEOF())
			{
				oCond.date1 = tOstDate.getValue("fdate");
				oCond.fsc = toScrObj(tOstDate.getValue("fsc"));
				oCond.fsu = toScrObj(tOstDate.getValue("fsu"));
				var sSQL = "INSERT INTO " + tblName + "(" + getOnlyFields(selFlds) 
					+ ",fost,fost1"
						+ (isFostsum ? ",fostsum,fostsum1": "")
						+ (isSprKol? ", fost_spr)": ")")
					+ " SELECT " + selFlds
						+ "," + fostExpr + " as fost"
						+ "," + fost1Expr + " as fost1"
						+ (isFostsum?
							"," + fostsumExpr + " as fostsum"
							+ "," + fostsum1Expr + " as fostsum1"
							: "")
						+ (isSprKol? ", " + fost_sprExpr + " as fost_spr": "")
					+ " FROM " + selFrom
					+ " WHERE " + getOptimCond(oCond)
						+ " AND " + selWhere
					+ " GROUP BY " + selGroupBy
					+ " HAVING " + fostExpr + "<>0"
						+ (isSprKol? " or " + fost_sprExpr + "<>0": "");
				//batch.addBatch(sSQL);
				ExecuteSQL(sSQL)
				if(cAnothers)
					cAnothers += " AND "
					
				cAnothers += " NOT (a.fsc=" + tOstDate.getValue("fsc") //е: <a.fsc> проверить!!!
					+ sqlw0And("a.fsu=", toScrObj(tOstDate.getValue("fsu")))
					+ ")"
					
				cScCond += "OR (a.fsc=" + sqlTo(tOstDate.getValue("fsc"))
					+ sqlw0And("a.fsu=" + toScrObj(tOstDate.getValue("fsu")))
					+ "AND fdate>=" + sqlTo(tOstDate.getValue("fdate"))
					+ ")";
				
				tOstDate.MoveNext();
				
			//	browse(tblName)
			}
			tOstDate.Close(5652);
			batch.execute(false);
			oCond.date1 = null;
			oCond.fsc = null;
			*/
			
			//if (fsu == 0 || cAnothers=="")
			{
				if(cAnothers)
					cAnothers = " AND (" + cAnothers + ")"
				ExecuteSQL(s=
					"INSERT INTO " + tblName + "(" + getOnlyFields(selFlds) 
					+ ",fost,fost1"
						+ (isFostsum?",fostsum,fostsum1": "")
						+ (isSprKol? ", fost_spr)": ")")
					+ " SELECT " + selFlds
						+ "," + fostExpr + " as fost"
						+ "," + fost1Expr + " as fost1"
						+ (isFostsum?
							"," + fostsumExpr + " as fostsum"
							+ "," + fostsum1Expr + " as fostsum1"
							: "")
						+ (isSprKol? ", " + fost_sprExpr + " as fost_spr": "")
					+ " FROM " + selFrom
					+ " WHERE " + selWhere
						+ " AND " + getOstDateSQL(fdate)
						+ " AND a.fdate<=" + sqlTo(fdate)
						//+ cAnothers
					+ " GROUP BY " + selGroupBy
					+ " HAVING " + fostExpr + "<>0"
						+ " or " + fost1Expr + "<>0"
						+ (isSprKol? " or " + fost_sprExpr + "<>0": "")
					);
			}
		}
		else  // Если расчет по периоду (обороты и остатки)
		{


			// Здесь нам надо посчитать обороты за период
			// и остатки на начало периода и на конец периода
			// Остатки на дату начала периода вычисляются на начало дня (без учета оборотов за день)
			// Остатки на дату конца периода вычисляюься на конец дня (с учетом оборотов за день)
		
			// Как учитываются записи в обороте
			// Начальные остатки, встречающиеся внутри периода не попадают в обороты (игнорирются)
			var sObSignSF =
				IIF(sRecIncR
						+ " OR " + sRecIncV
						+ " OR (a.Frtype='"+RTYPE_OST+"'"
							//+ " AND a.Fdate="+sqlTo(date1)+""
							//+ " AND a.Fdate=c.Fdate"
							+ ")"
							, "1", 
						IIF(sRecDec,"-1", "0")
					)
			var sObSign = IIF("a.Fdoc='SF'", "0",sObSignSF)
			
			var fostExpr = sqlRound("sum(" + sObSign + "*a.fkol)", nKolDec);
			var fost1Expr = sqlRound("sum(" + sObSignSF + "*a.fkol)", nKolDec);
			var fost_sprExpr = sqlRound("sum(" + sObSign + "*a.fkol_spr)", nKolDec);
		
			// Заменим выражение с учетом того, что внутри цепочке могут различаться цены
			var fostsumExpr = sqlRound( "sum(" + sObSign + "*a.fkol*a.fcena)", nSumDec);
		
			var fostsum1Expr = sqlRound( "sum(" + sObSignSF + "*a.fkol*a.fcena)", nSumDec);
			
			//Тоже самое но по ценам поставщика
			var f1ostsumExpr = sqlRound( "sum(" + sObSign + "*a.fkol*a_cp.f1cena"+kursExpr+")", nSumDec);
			if (this.sumCenaPostUch)
				f1ostsumExpr = sqlRound( "sum(" + sObSign + "*a.fkol*"+ IIF("a_cp.fdoc='SA' and a_cp.fsu=282", "a_cp.f1cena", "a_cp.fcena")+")", nSumDec);
			var f1ostsum1Expr = sqlRound( "sum(" + sObSignSF + "*a.fkol*a_cp.f1cena"+kursExpr+")", nSumDec);
			if (this.sumCenaPostUch)
				f1ostsum1Expr = sqlRound( "sum(" + sObSignSF + "*a.fkol*"+ IIF("a_cp.fdoc='SA' and a_cp.fsu=282", "a_cp.f1cena", "a_cp.fcena")+")", nSumDec);
			
/*	15.01.2010 при субд DERBY не подхватывало RTYPE_PMP и RTYPE_PMR
			// Коэффициент для расчета остатков на начало периода
			var cBOst1Sign = 
				IIF("((a.Frtype=" + sqlTo(RTYPE_PR)            // приходы
							+ " OR a.Frtype=" + sqlTo(RTYPE_PMP)  // и приходы по внутреннему перемещению
							+ ") AND a.Fdate <" + sqlTo(date1)      // суммируются до первой даты не включительно
						+ ")"
						+ " OR ( a.Frtype=" + sqlTo(RTYPE_OST)   // начальные остатки 
							+ " AND a.Fdate <=" + sqlTo(date1)      // суммируются до первой даты включительно
							+ ")", 
						"1", 
					IIF("(a.Frtype="	+ sqlTo(RTYPE_RS)    // расходы
						+ " OR a.Frtype=" + sqlTo(RTYPE_PMR)  // и расходы по внутреннему перемещению
						+ ") AND a.Fdate <" + sqlTo(date1),      // вычитаются до первой даты не включительно
						"-1", 
						"0"
						)
					)*/

			// Коэффициент для расчета остатков на начало периода
			var cBOst1Sign = 
				IIF("((a.Frtype=" + sqlTo(RTYPE_PR)+" AND (a.Fdate <" + sqlTo(date1)+"))"            // приходы
							+ " OR (a.Frtype=" + sqlTo(RTYPE_PMP)+" AND (a.Fdate <" + sqlTo(date1)+"))"  // и приходы по внутреннему перемещению
						+ ")"		// суммируются до первой даты не включительно
						+ " OR ( a.Frtype=" + sqlTo(RTYPE_OST)   // начальные остатки 
							+ " AND a.Fdate <=" + sqlTo(date1)      // суммируются до первой даты включительно
							+ ")", 
						"1", 
					IIF("((a.Frtype="	+ sqlTo(RTYPE_RS)+" AND (a.Fdate <" + sqlTo(date1)+"))"    // расходы
						+ " OR (a.Frtype=" + sqlTo(RTYPE_PMR)+"AND (a.Fdate <" + sqlTo(date1)+"))"  // и расходы по внутреннему перемещению
						+ " )",      // вычитаются до первой даты не включительно
						"-1", 
						"0"
						)
					)
			var cBOstSign = IIF("a.Fdoc='SF'", "0", cBOst1Sign )
		
			// Условие на попадение документа в период
			var cDateIn = "a.fdate between " + sqlTo(date1)
				+ " and " + sqlTo(date2)
			
			// Количественный остаток на начало периода
			var fbostExpr = sqlRound(
				"sum(" + cBOstSign + "*a.fkol" + ")"
				, nKolDec
				);
			// Суммовой остаток на начало периода
			var fbsumExpr = sqlRound(
				"sum(" + cBOstSign + "*a.fkol*a.fcena" + ")"
				, nSumDec
				);

			// Суммовой остаток на начало периода (по ценам поставщика)
			if (this.sumCenaPost)
			{
				var f1bsumExpr = sqlRound(
				"sum(" + cBOstSign + "*a.fkol*a_cp.f1cena" + kursExpr + ")"
				, nSumDec
				);
				if (this.sumCenaPostUch)
					f1bsumExpr = sqlRound(
					"sum(" + cBOstSign + "*a.fkol*"+IIF("a_cp.fdoc='SA' and a_cp.fsu=282", "a_cp.f1cena", "a_cp.fcena")+")"
					, nSumDec
					);

			}

			// Количественный остаток на начало периода без учета счетов-фактур
			var fbost1Expr = sqlRound(
				"sum(" + cBOst1Sign + "*a.fkol" + ")"
				, nKolDec
				);
			
			// Количественный остаток на начало периода в справочный
			var fbost_sprExpr = sqlRound(
				"sum(" + cBOstSign + "*a.fkol_spr" + ")"
				, nKolDec
				);
			
			// Приход по внутреннему перемещению
			var fpkolvExpr = sqlSumCond("a.fkol"
				, cDateIn + " and " + sRecIncV
				, "", nKolDec
				);
			
			// Сумма прихода по внутреннему перемещению
			var fpsumvExpr = sqlSumCond("a.fkol*a.fcena"
				, cDateIn + " and " + sRecIncV
				, "", nSumDec
				);
			

			if (this.sumCenaPost)
			{
				// Сумма прихода по внутреннему перемещению по ценам поставщика
				var f1psumvExpr = sqlSumCond("a.fkol*a_cp.f1cena"+kursExpr
					, cDateIn + " and " + sRecIncV
					, "", nSumDec
					);
				if (this.sumCenaPostUch)
					f1psumvExpr = sqlSumCond("a.fkol*"+ IIF("a_cp.fdoc='SA' and a_cp.fsu=282", "a_cp.f1cena", "a_cp.fcena")
						, cDateIn + " and " + sRecIncV
						, "", nSumDec
						);
			}
			
			// Количество прихода из вне
			var fpkolrExpr = sqlSumCond("a.fkol"
				, cDateIn + " and " + sRecIncR
				, "", nKolDec
				);
			
			// Сумма прихода из вне
			var fpsumrExpr = sqlSumCond("a.fkol*a.fcena"
				, cDateIn + " and " + sRecIncR
				, "", nSumDec
				);
			
			if (this.sumCenaPost)
			{
				// Сумма прихода из вне по ценам поставщика
				var f1psumrExpr = sqlSumCond("a.fkol*a_cp.f1cena" + kursExpr
					, cDateIn + " and " + sRecIncR
					, "", nSumDec
					);
				if (this.sumCenaPostUch)
					f1psumrExpr = sqlSumCond("a.fkol*"+ IIF("a_cp.fdoc='SA' and a_cp.fsu=282", "a_cp.f1cena", "a_cp.fcena")
						, cDateIn + " and " + sRecIncR
						, "", nSumDec
						);
			}
			
			// Количество расхода наружу
			var frkolrExpr = sqlSumCond("a.fkol"
				, cDateIn + " and " + sRecDecR
				, "", nKolDec
				);
			
			// Сумма расхода наружу
			var frsumrExpr = sqlSumCond("a.fkol*a.fcena"
				, cDateIn + " and " + sRecDecR
				, "", nSumDec
				);
			
			if (this.sumCenaPost)
			{
				// Сумма расхода наружу по ценам поставщика
				var f1rsumrExpr = sqlSumCond("a.fkol*a_cp.f1cena" + kursExpr
					, cDateIn + " and " + sRecDecR
					, "", nSumDec
					);
				if (this.sumCenaPostUch)
					f1rsumrExpr = sqlSumCond("a.fkol*"+ IIF("a_cp.fdoc='SA' and a_cp.fsu=282", "a_cp.f1cena", "a_cp.fcena")
						, cDateIn + " and " + sRecDecR
						, "", nSumDec
						);
			}
			
			// Количество расхода по внутреннему перемещению
			var frkolvExpr = sqlSumCond("a.fkol"
				, cDateIn + " and " + sRecDecV
				, "", nKolDec
				);
			
			// Сумма расхода по внутреннему перемещению
			var frsumvExpr = sqlSumCond("a.fkol*a.fcena"
				, cDateIn + " and " + sRecDecV
				, "", nSumDec
				);
			
			if (this.sumCenaPost)
			{
				// Сумма расхода по внутреннему перемещению по ценам поставщика
				var f1rsumvExpr = sqlSumCond("a.fkol*a_cp.f1cena" + kursExpr
					, cDateIn + " and " + sRecDecV
					, "", nSumDec
					);
				if (this.sumCenaPostUch)
					f1rsumvExpr = sqlSumCond("a.fkol*"+ IIF("a_cp.fdoc='SA' and a_cp.fsu=282", "a_cp.f1cena", "a_cp.fcena")
						, cDateIn + " and " + sRecDecV
						, "", nSumDec
						);
			}
			
			// Первая часть SQL-запроса
			query1 = 
				" " + selFlds
				+ "," + fostExpr + " as fekol"         // остаток на конец фактический
//				+ "," + fost1Expr + " as fekol1"       // - / - / -  с учетом счетов-фактур
				+ "," + fostsumExpr + " as fesum"    // ост. на конец в сумовом выражении
//				+ "," + fostsum1Expr + " as fesum1"  // - / - / -  с учетос с.-ф.
				+ "," + fbostExpr + " AS fbkol"
//				+ "," + fbost1Expr + " AS fbkol1"
//				+ "," + sqlRound( "(" + fbostExpr + ")*c.fcena", nSumDec ) + " AS fbsum"
				+ "," + fbsumExpr + " AS fbsum"
				// + "," + sqlRound( "(" + fbost1Expr + ")*c.fcena", nSumDec )
//					+ " AS fbostsum1"
				+ "," + fpkolrExpr + " AS fpkolr"
				+ "," + fpsumrExpr + " AS fpsumr"
				+ "," + fpkolvExpr + " AS fpkolv"
				+ "," + fpsumvExpr + " AS fpsumv"
				+ "," + frkolvExpr + " AS frkolv"
				+ "," + frsumvExpr + " AS frsumv"
				+ "," + frkolrExpr + " AS frkolr" 
				+ "," + frsumrExpr + " AS frsumr";
				if (this.sumCenaPost)
				{
					query1 += "," + f1psumrExpr  + " AS f1psumr"
					+ "," + f1psumvExpr  + " AS f1psumv"
					+ "," + f1rsumvExpr  + " AS f1rsumv"
					+ "," + f1rsumrExpr  + " AS f1rsumr"
					+ "," + f1ostsumExpr + " as f1esum"
					+ "," + f1bsumExpr   + " AS f1bsum";
				}

			
			if(this.isSprKol)
				query1 = query1 
					+ "," + fost_sprExpr + " as fekol_spr"
					+ "," + fbost_sprExpr + " as fbkol_spr";
					
			// Вторая часть SQL-запроса
			query2 = " FROM " + selFrom
				+ " WHERE "
					+ selWhere
					//+ " AND (c.fdate IS NULL OR a.fdate>=c.fdate)"
					+ " AND a.fdate<=" + sqlTo(date2)
					//+ " AND (c.fsu IS NULL OR c.fsu=0 OR (c.fsu=a.fsu))"
					+ " AND " + getOstDateSQL(date1)
					
				+ " GROUP BY " + selGroupBy
				+ (pattern && pattern.toUpperCase() == "OBR" ? "" : "")
				+ " HAVING (" + fbostExpr + ") <> 0 "
					+ " OR (" + fpkolrExpr + ") <> 0 "
					+ " OR (" + fpkolvExpr + ") <> 0 "
					+ " OR (" + frkolvExpr + ") <> 0 "
					+ " OR (" + frkolrExpr + ") <> 0 "
					+ " OR (" + fostsumExpr + ") <> 0 "
					+ " OR (" + fpsumrExpr + ") <> 0 "
					+ " OR (" + fpsumvExpr + ") <> 0 "
					+ " OR (" + frsumvExpr + ") <> 0 "
					+ " OR (" + frsumrExpr + ") <> 0 ";
					if (this.sumCenaPost)
					{
						query2 += " OR (" + f1psumrExpr + ") <> 0 "
						+ " OR (" + f1psumvExpr + ") <> 0 "
						+ " OR (" + f1rsumvExpr + ") <> 0 "
						+ " OR (" + f1rsumrExpr + ") <> 0 ";
					}
			if (pattern && pattern.toUpperCase() == "OBR")
			{
				fVostsumExpr = String(fostsumExpr).toUpperCase().replace(/FCENA/gi, "FVCENA");
				fVbsumExpr	 = String(fbsumExpr).toUpperCase().replace(/FCENA/gi, "FVCENA");
				fVpsumrExpr	 = String(fpsumrExpr).toUpperCase().replace(/FCENA/gi, "FVCENA");
				fVpsumvExpr	 = String(fpsumvExpr).toUpperCase().replace(/FCENA/gi, "FVCENA");
				fVrsumvExpr	 = String(frsumvExpr).toUpperCase().replace(/FCENA/gi, "FVCENA");
				fVrsumrExpr	 = String(frsumrExpr).toUpperCase().replace(/FCENA/gi, "FVCENA");
				query1 += "," + fVostsumExpr + " as FVESUM"    
							+ "," + fVbsumExpr + " AS FVBSUM"
							+ "," + fVpsumrExpr + " AS FVPSUMR"
							+ "," + fVpsumvExpr + " AS FVPSUMV"
							+ "," + fVrsumvExpr + " AS FVRSUMV"
							+ "," + fVrsumrExpr + " AS FVRSUMR"
			}
			if(DropTable(tblName))
			{
				if(pattern)
				{
					// Если задан шаблон для таблицы
					// то вначале создадим таблицу по шаблону
					CreateTable(tblName, pattern, "-");
					// и добавим в нее записипо запросу
					ExecuteSQL("INSERT INTO " + tblName + "(" + getOnlyFields(query1) + ") "
									+ " SELECT " + query1 + query2);
				}
				else
				{
					// Если не задан шаблон для таблицы
					// то просто создаем ее по запросу
					ExecuteSQL("SELECT " + query1 + " INTO " + tblName + " " + query2);
				}
			}
			else
			{
				// Если таблица не удалилась
				ExecuteSQL("DELETE FROM " + tblName);
				ExecuteSQL("INSERT INTO " + tblName + "(" + getOnlyFields(query1) + ") "
								 + " SELECT " + query1 + query2);
			}
			
		}
	}
}

function DpMtrOb_getTbl()
{
	return OpenTable("m", this.tblName);
}

// Получить SQL-выражение для расчета суммы по с условием на записи
// Параметры:
// cSumExpr  - Выражение 
// cCondExpr - Условие на строки
// cAddExpr  - Дополнительное слагаемое к общей сумме
// nRound    - До какого знака округлять
function sqlSumCond(cSumExpr, cCondExpr, cAddExpr, nRound)
{
	// Если запись удовлетворяет условию - берем выражение,
	// если не удовлетворяет - берем 0
	var cExpr = "sum("
			+ IIF(
				cCondExpr,
				cSumExpr,
				"0"
					)
		+ ")";
	if(cAddExpr)
		cExpr = cAddExpr + "+" + cExpr;
	if(typeof nRound=="number")
		cExpr = sqlRound(cExpr, nRound);
	return cExpr;
}

// Получить условия, оптимизированное под индексы для SQL
function getOptimCond(oCond)
{
	var cOCond = "";
	if(!oCond.isPolyNmkl && oCond.fnmkl && oCond.fsc!=null && oCond.fpodr && oCond.fmol)
	{
		cOCond = "1=1 " + sqlwNmk("a.fnmkl",oCond.fnmkl)
			+ " AND a.fsc=" + sqlTo(oCond.fsc)
			+ sqlw0And("a.fsu=", oCond.fsu)
			+ " AND a.fpodr=" + sqlTo(oCond.fpodr)
			+ " AND a.fmol=" + sqlTo(oCond.fmol)
			+ sqlw0And("a.fdate>=", oCond.date1)
			+ sqlw0And("a.fdate<=", oCond.date2)
	}
	else if(!oCond.isPolyNmkl && oCond.fnmkl && oCond.fsc!=null)
	{
		cOCond = "1=1 " + sqlwNmk("a.fnmkl",oCond.fnmkl)
			+ " AND a.fsc=" + sqlTo(oCond.fsc)
			+ sqlw0And("a.fsu=", oCond.fsu)
			+ sqlw0And("a.fdate>=", oCond.date1)
			+ sqlw0And("a.fdate<=", oCond.date2)
			+ sqlw0And("a.fpodr=", oCond.fpodr)
			+ sqlw0And("a.fmol=", oCond.fmol)
	}
	else if(oCond.fsc!=null)
	{
		cOCond = "a.fsc=" + oCond.fsc
			+ sqlw0And("a.fdate>=", oCond.date1)
			+ sqlw0And("a.fdate<=", oCond.date2)
			+ sqlwNmk("a.fnmkl", oCond.fnmkl)
			+ sqlw0And("a.fsc=", oCond.fsc)
			+ sqlw0And("a.fsu=", oCond.fsu)
			+ sqlw0And("a.fpodr=", oCond.fpodr)
			+ sqlw0And("a.fmol=", oCond.fmol)
	}
	else 
	{
		cOCond = SqlTrue;
			+ sqlwNmk("a.fnmkl", oCond.fnmkl)
			+ sqlw0And("a.fsc=", oCond.fsc)
			+ sqlw0And("a.fsu=", oCond.fsu)
			+ sqlw0And("a.fpodr=", oCond.fpodr)
			+ sqlw0And("a.fmol=", oCond.fmol)
			+ sqlw0And("a.fdate>=", oCond.date1)
			+ sqlw0And("a.fdate<=", oCond.date2)
	}
	return cOCond;
}

function getOstDateSQL(date)
{
	return " NOT EXISTS ("
		+ "SELECT * "
		+ " FROM ^sch_zag ost1"
		+ " WHERE ost1.fdoc='SA'"
			+ " AND ost1.fdoc_dat<=" + sqlTo(date)
			+ " AND (ost1.fdoc_dat>a.fdate)"
			+ " AND ost1.fsc=a.fsc"
			+ " AND (ost1.fsu=a.fsu OR ost1.fsu=0)"
		+ ")"
}