//импорт ШР для МВД (Кривой Рог) из DBF, основные справочники (персонал, категории, подразделения) 
//предварительно закачиваются с помощью стандартного импорта базы данных
include("Objects/DpExtentionBuilder.js");

function importShtat()
{
	//массив званий, где код из справочника соответсвует номеру элемента массива
	var zvanAr = new Array("","Полковник","п.полковн.","Майор","Капитан","ст.лейтен.","Лейтенант","мл.лейтен.","ст.прапор.","прапорщик","старшина","ст.сержант","сержант","мл.сержант","рядовой");
	//массив Fwid-ов записей справочника званий
	var zvanFwidAr = new Array();
	var codzvan = getPar("CODZVAN");
	if(!codzvan)
	{
		alert("Не указан справочник званий!")
		return false;
	}
	var t = OpenTable("select * from ^clrelclcl where Fcl="+codzvan)
	for(; !t.IsEOF(); t.MoveNext())
		zvanFwidAr[zvanAr[t.getValue("Fcod")]] = t.getValue("Fwid_cl");
	t.close();
	//определяем имя таблицы расширений справочника персонала, из которой будем брать ранги и звания
	var oExt = new DpExtentionBuilder("CL",String(getPar("CODPERS")));
	if(oExt.exist())
		var extTblName = oExt.getValueTableName();
	else
	{
		alert("Сперва создайте в справочнике персонала текстовые расширения RANG и ZVAN!");
		return false;
	}
	oExt = new DpExtentionBuilder("SHTATEXT");
	if(oExt.exist())
		var extShtatTblName = oExt.getValueTableName();
	else
	{
		alert("Сперва создайте в штатном расписании расширение справочника аналитики рангов RANG!");
		return false;
	}
	var nullDat = new Date(1899,11,30);
	var lastDir = ReadParEx("sDir");
	var sDir = BrowseForDir(lastDir, "Импорт штатного расписания", "Укажите директорию в которой находятся файлы podr.DBF и shtat.DBF");
	if(!sDir)
		return false;
	WriteParEx("sDir",sDir);
	url = "jdbc:odbc:DRIVER=Microsoft Visual FoxPro Driver;SourceType=DBF;SourceDB=" + sDir;
	var podrFile = sDir+"//podr.DBF";
	if(!isFile(podrFile))
	{
		alert("Не найден файл подразделений:\n"+podrFile);
		return false;
	}
	var shtatFile = sDir+"//shtat.DBF";
	if(!isFile(shtatFile))
	{
		alert("Не найден файл штатного расписания:\n"+shtatFile);
		return false;
	}
	var url = "jdbc:odbc:DRIVER=Microsoft Visual FoxPro Driver;SourceType=DBF;SourceDB=" + sDir;
	var conn = getDBConnection(url, "", "");
	var tblPodr = OpenExtTable(conn, "SELECT * FROM PODR ORDER BY FKOD_PAR,FBDAT DESC,FKOD");
	var tblShtat = OpenExtTable(conn, "SELECT * FROM SHTAT ORDER BY FTABN, FID");

	if(!confirm("Текущее штатное расписание будет удалено.\nПродолжить?"))
		return false;
	ExecuteSQL("delete from ^stru_org");
	ExecuteSQL("delete from ^stru_dol");
	ExecuteSQL("delete from ^work_pers");
	//вставляем корневое подразделение
	var fwidMainOrg = GetUID();
	ExecuteSQL("insert into ^stru_org(fwid,ftxt,ftxts,fbdat) "
			+" values("+fwidMainOrg+","+sqlTo(getPar("OFIRM"))+","+sqlTo(getPar("OFIRM"))+","+sqlTo(new Date(2004,0,1))+")")
	var wasAddedZeroOrg = false;
	setProgressRange(1, tblPodr.rowCount);
	var ok = true;
	var p = 0;
	for(tblPodr.MoveFirst(); !tblPodr.IsEOF(); tblPodr.MoveNext())
	{
		setProgressPos(tblPodr.bookmark, "Импорт подразделений "+tblPodr.bookmark+"/"+tblPodr.rowCount);
		//в дбфнике несколько организаций с нулевым кодом, добавлять будем только одну
		if(tblPodr.getValue("Fkod")==0)
		{
			if(wasAddedZeroOrg)
				continue;
			else
				wasAddedZeroOrg = true;
		}
		var m = new Object();
		m.Fwid = GetUID();
		m.Fwid_par = fwidMainOrg;//т.к. ШР одноуровневое, то идентификатор родительского подразделения сразу проставляем корневым
		m.Flv1 = p+1;
		m.Ftxt = allt(tblPodr.getValue("Ftxt"));
		m.Ftxts = allt(tblPodr.getValue("Ftxts"));
		m.Fbdat = tblPodr.getValue("Fbdat");
		m.Fedat = (differ(nullDat,new Date(tblPodr.getValue("Fedat")))==0?d00:tblPodr.getValue("Fedat"));
		m.Foutid = String(tblPodr.getValue("Fkod"));//код подразделения записываем во внешний идентификатор
		ok = UpdateTable("^stru_org", m, true);
		if(!ok)
			break;
		else
			p++;
	}
	setProgressPos(0);
	//перестраиваем ключи
	buildTreeKeysOnTable("^stru_org", 0, 0, "flv1, flv2, flv3, flv4, flv5", "fwid_par");
	setProgressRange(1, tblShtat.rowCount);
	var k=0;
	var defCodDol = 0;//должность которую будем назначать неопределенным
	if(ok)
	{
		for(tblShtat.MoveFirst(); !tblShtat.IsEOF(); tblShtat.MoveNext())
		{
			setProgressPos(tblShtat.bookmark, "Импорт штатного расписания "+tblShtat.bookmark+"/"+tblShtat.rowCount);
			var codPers = tblShtat.getValue("Ftabn");
			if(codPers==0)//в криворожском ШР была одна сотрудница с нулевым табельным номером, стандартный импорт ей присвоит код 1, поэтому ищем еденицу 
				codPers = 1;
			var d = new Object();
			d.Fwid = GetUID();
			var codDol = tblShtat.getValue("Fkoddol");
			if(codDol == 0)
			{
				if(defCodDol==0)
				{
					if(confirm("Для таб.№"+codPers+" не указана должность.\nНазначить ему должность?" +
							"\nЕсли выбирите да, то эта должность будет впоследдствии автоматически присваиваться всем неназначенным сотрудником." +
							"\nЕсли выбирите нет, то импорт прервется."))
					{
						setProgressPos(0);
						var form = createForm("Укажите либо должность");
						oDol = form.addCodDol(false,true);
						form.show();
						if(form.escape)
							break;
						defCodDol = oDol.getCod();
						codDol = defCodDol;
						setProgressRange(1, tblShtat.rowCount);
						setProgressPos(tblShtat.bookmark, "Импорт штатного расписания "+tblShtat.bookmark+"/"+tblShtat.rowCount);
					}
					else
						break;
				}
				else
					codDol = defCodDol;
			}
			d.Fcod = codDol;
			var snap = getSnap("select Fwid_cl from ^clrelclcl where Fcl="+getPar("CODDOL")+" and Fcod="+codDol);
			if(!snap)
			{
				alert("Не удалось определить идентификатор должности с кодом "+codDol);
				break;
			}
			d.Fwid_cl = snap[0];
			var codPodr = tblShtat.getValue("Fkodpodr");
			var snap = getSnap("select Fwid from ^stru_org where Foutid="+sqlTo(String(codPodr)));
			if(!snap)
			{
				alert("Не удалось определить идентификатор подразделения с кодом "+codPodr);
				break;
			}
			d.Fwid_org = snap[0];
			d.Foklad = tblShtat.getValue("Foklad");
			d.Fbdat = tblShtat.getValue("Fbdat");
			d.Fedat = (differ(nullDat,new Date(tblShtat.getValue("Fedat")))==0?d00:tblShtat.getValue("Fedat"));
			ok = UpdateTable("^stru_dol", d, true);
			if(!ok)
				break;
			var w = new Object();
			w.Fwid = GetUID();
			w.Fid = tblShtat.getValue("Fid");
			w.Fwid_dol = d.Fwid;
			w.Fbdat = d.Fbdat;
			w.Fedat = d.Fedat;
			w.Fvopl = tblShtat.getValue("Fvopl");
			w.Favans = tblShtat.getValue("Favans");
			w.Ftable = tblShtat.getValue("Ftable");
			w.Fis_nazn = tblShtat.getValue("Fis_nazn");
			w.Fis_uv = tblShtat.getValue("Fis_uv");
			w.Finval = tblShtat.getValue("Finval");
			var codKat = tblShtat.getValue("Fkodkat");
			var snap = getSnap("select Fwid_cl from ^clrelclcl where Fcl="+getPar("CODKAT")+" and Fcod="+codKat);
			if(!snap)
			{
				alert("Не удалось определить идентификатор категории с кодом "+codKat);
				break;
			}
			w.Fwid_kat = snap[0];
			var snap = getSnap("select c.Fwid_cl, e.Frang, e.Fzvan from ^clrelclcl as c left join "
					+extTblName+" as e on c.Fwid_cl=e.Fmainwid where c.Fcl="+getPar("CODPERS")+" and c.Fcod="+codPers);
			if(!snap)
			{
				alert("Не удалось определить идентификатор сотрудника с кодом "+codPers);
				break;
			}
			w.Fwid_cl = snap[0];
			var rang = allt(snap[1]);
			if(rang!="")
			{
				var m = new Object();
				m.Fwid = GetUID();
				m.Fmainwid = w.Fwid;
				if(rang.indexOf("13")!=-1)
					m.Frang = 13;
				if(rang.indexOf("14")!=-1)
					m.Frang = 14;
				if(rang.indexOf("15")!=-1)
					m.Frang = 15;
				if(m.Frang)
					ok = UpdateTable(extShtatTblName,m,true);
				else
					ok = false;
				if(!ok)
				{
					alert("Не удалось добавить расширение ранга в ШР, импорт будет прерван.")
					break;
				}
			}
			var zvan = allt(snap[2]);
			if(zvan.length>0)
			{
				 w.Fwid_zvan = zvanFwidAr[zvan];
				 //атестованных выделяем на отдельный вид оплаты 2000
				 w.Fvopl = 2000;
			}
			ok = UpdateTable("^work_pers", w, true);
			if(!ok)
			{
				alert("Не удалось добавить запись в ШР, импорт будет прерван.")
				break;
			}
			k++;
		}
		setProgressPos(0);
	}
	tblPodr.close();
	tblShtat.close();
	
	alert("Кол-во импортированных подразделений :"+p+"\nКол-во импортированных записей ШР: "+k);
}

function corectOrgTxt()
{
	var t = OpenTable("select * from ^stru_org");
	setProgressRange(1, t.rowCount);
	for(; !t.IsEOF(); t.MoveNext())
	{
		setProgressPos(t.bookmark, t.bookmark+"/"+t.rowCount);
		var txt = new java.lang.String(t.getValue("Ftxt"));
		var txtS = new java.lang.String(t.getValue("Ftxts"));
		var ind = txt.indexOf("_"); 
		var indS = txtS.indexOf("_");
		var m = new Object();
		if(ind!=-1)
		{
			if(ind == 0)
				m.Ftxt = "І"+txt.replaceAll("_", "і").substr(1,txt.length());
			else
				m.Ftxt = txt.replaceAll("_", "і");
		}
		if(indS!=-1)
		{
			
			if(indS == 0)
				m.Ftxts = "І"+txtS.replaceAll("_", "і").substr(1,txtS.length());
			else
				m.Ftxts = txtS.replaceAll("_", "і");
		}
		if(ind!=-1)
			UpdateTable("^stru_org", m, false, "Fwid="+t.getValue("Fwid"));
	}
	setProgressPos(0);
	t.close();
}

function corectClTxt()
{
	var t = OpenTable("select * from ^listcl where Fcl in (2,25,24) order by fcl,fcod");
	setProgressRange(1, t.rowCount);
	for(; !t.IsEOF(); t.MoveNext())
	{
		setProgressPos(t.bookmark, t.getValue("Fcl")+":  "+t.bookmark+"/"+t.rowCount);
		var txt = new java.lang.String(t.getValue("Ftxt"));
		var ind = txt.indexOf("_"); 
		var m = new Object();
		if(ind!=-1)
		{
			if(ind == 0)
				m.Ftxt = "І"+txt.replaceAll("_", "і").substr(1,txt.length());
			else
				m.Ftxt = txt.replaceAll("_", "і");
		}
		if(ind!=-1)
			UpdateTable("^cl", m, false, "Fwid="+t.getValue("Fwid"));
	}
	setProgressPos(0);
	t.close();
}

function setExtTabn()
{
	oExt = new DpExtentionBuilder("SHTATEXT");
	var tblShtat = OpenTable("select * from ^full_pers order by Fwid_cl, Fid")
	if(oExt.exist())
	{
		var extShtatTblName = oExt.getValueTableName();
		setProgressRange(1, tblShtat.rowCount);
		for(tblShtat.MoveFirst(); !tblShtat.IsEOF(); tblShtat.MoveNext())
		{
			setProgressPos(tblShtat.bookmark, "Импорт таб.№ в расширения "+tblShtat.bookmark+"/"+tblShtat.rowCount);
			var snap = getSnap("select Fwid from "+extShtatTblName+" where Fmainwid="+tblShtat.getValue("Fwid"))
			var m = new Object();
			var fwid = 0;
			if(!snap)
			{
				m.Fwid = GetUID();
				m.Fmainwid = tblShtat.getValue("Fwid");
			}
			else
				fwid = snap[0];
			m.Ftabn = tblShtat.getValue("Fcodpers");
			UpdateTable(extShtatTblName,m,!snap,"Fwid="+fwid);
		}
		setProgressPos(0);
	}
	tblShtat.close();
}