include("office/ExcelWrappers/xlsConst.js");
include("office/ExcelWrappers/xlsCell.js");
include("office/ExcelWrappers/xlsBandParent.js");
/**
Класс "Бенд". Предназначен для хранения и печати коллекции ячеек, 
логически связанных друг с другом и занимающих прямоугольную область.
(если более точно - то несколько смежных строк)
Используется в чистом виде и является предком для специфических бендов 
типа "таблица", "Заголовок таблицы", "описатель строки таблицы" и т.п.

@param parent ссылка на владельца, который создал данный бенд. может быть либо объектом 
класса xlsSheet, либо xlsBand, либо класса-потомка xlsBand

@param nStartRow номер строки, с которой начинается тело бенда (
т.е. следующая строка после строки-маркера начала бенда вида "*=", "*+" )

@param name Необязательный параметр. "Человеческое имя" данного экземпляра объекта
Используется в this.trace()
*/
function xlsBand(parent, nStartRow, name)
{
	derive(this, xlsParent);
	derive(this, xlsBandParent);
	this.storeParent(parent);
	this.p_band = this;

	this.trace("xlsBand(nStartRow = "+nStartRow+"): start");

	//Номер строки начала xlsBand'a (после загрузки здесь будет номер 1-й "содержательной"
	//строки, т.е. строки после "*=", "*+", "*-" и т.п.)
	this.nStartRow = nStartRow;
	//"имя" пригодится для отладки
	this.name = name;
	this.trace("xlsBand("+nStartRow+"): end");
}
