include("office/ExcelWrappers/xlsBandParent.js");

//Класс для работы с коменнтариями ячеек
function xlsComment(parent)
{
	derive(this, xlsParent);
	this.storeParent(parent);
	
	this.sComment = "";	//комментарий текстом

	this.aAttributes = new Array();	//массив атрибутов

	this.oEval = this.p_office.vars.eval;

	this.setAttribute = xlsComment_setAttribute;
	this.getAttribute = xlsComment_getAttribute;
	this.parse = xlsComment_parse;
	this.release = xlsComment_release;
}

function xlsComment_setAttribute(szAttr, Value)
{
	if (isEmpty(szAttr))
	{
		return false;
	}
	this.aAttributes[szAttr] = Value;
	this.trace("xlsComment_setAttribute(szAttr=\""+szAttr+"\", Value=\""+Value+"\")")
}

function xlsComment_getAttribute(szAttr)
{
	if (isEmpty(this.aAttributes[szAttr]) ||
		typeof(this.aAttributes[szAttr]) == "function")
	{
		return "";
	}

	return this.aAttributes[szAttr];
}

/**
разбор комментария

@param 	value необязательный параметр. Строка, которую разбираем.
Если не передан, то возьмем this.sComment

Формат комментария:
fields:"<список полей таблицы колонок ч-з запятую>";
order:"<список полей таблицы колонок ч-з запятую, для ORDER BY>";
filter:"<условие на поля таблицы колонок, для WHERE>";

Если отсутствует раздел "fields" то в запросе будет "SELECT * "
Разделы "order" и "filter" можно опускать

Описание значений для каждого из разделов берется в кавычки и оканчивается
точкой с запятой (т.е. ";")

Меняет:
	this.sComment
	this.aAttributes
*/
function xlsComment_parse(value)
{
	if (value!=undefined)
	{
		this.sComment = String(value);
	}

	//Обрежем пробелы
	var szComment = this.sComment.replace("/(^\s*)|(\s*$)/gi","");
	szComment = szComment.replace("\n","");
	
	//Разберем по точкам с запятыми
	var aPar1 = szComment.match(/(('[^']*;*[^']*')|("[^"]*;*[^"]*")|[^;])+/ig);

	var aPar2 = new Array();

	//Разберем по двоеточиям
	if (aPar1!=null)
	{
		for (var nIndex = 0; nIndex < aPar1.length; nIndex++)
		{
			aPar2[nIndex] = aPar1[nIndex].match(/(('[^']*:*[^']*')|("[^"]*:*[^"]*")|[^:])+/ig)
		}
	}
	
	var aRetval = new Array();

	//По всем параметрам.
	for (var nIndex in aPar2)
	{
		if (aPar2[nIndex][1] == null && aPar2[nIndex][0].toLowerCase().replace(/(^\s*)|(\s*$)/gi,"")==xlsConst.MERGE)
		{
			aRetval[aPar2[nIndex][0].toLowerCase().replace(/(^\s*)|(\s*$)/gi,"")] = aPar2[nIndex][0].toLowerCase().replace(/(^\s*)|(\s*$)/gi,"");
		}
		else
		{
			aRetval[aPar2[nIndex][0].toLowerCase().replace(/(^\s*)|(\s*$)/gi,"")] = this.oEval.eval(aPar2[nIndex][1]);
		}
	}
	for (index in aRetval)
	{
		this.setAttribute(index, aRetval[index]);
	}
}

function xlsComment_release()
{
	this.p_workBook = null;
	this.p_office = null;
	this.workBook = null;
	this.p_parent = null;
    this.p_sheet = null;
	this.p_band = null;
	for (var nIndex in this.aAttributes)
	{
		this.aAttributes[nIndex] = null;
	}
	this.aAttributes = null;
}