include("office/ExcelWrappers/xlsParent.js");
include("office/ExcelWrappers/xlsBand.js");
include("office/ExcelWrappers/xlsBandTable.js");

// Класс, инкапсулирующий лист книги
function xlsSheet(parent, nSheetNumber)
{
	derive(this, xlsParent);
	this.storeParent(parent);

	this.trace("xlsSheet("+nSheetNumber+"): start");

	this.p_sheet = this;

	this.nSheetNumber = nSheetNumber;	//Номер текущего листа
	
	this.oSheet = new Array();
	this.oSheet[0] = this.p_workBook.workBook.getSheetAt(this.nSheetNumber);//Текущий HSSFSheet

	//Текущая обрабатываемая строка
	this.nCurrentRow = 0;

	//Номер строки, в которой встретился "*CROSSH"
	this.nCrosshRow = -1;
	
	//Для обработки "PAGE BREAK="
	this.pageBreakType = xlsConst.PBT_NONE;	//Тип - одна из констант xlsConst.PBT_xxx
	this.nPageBreak = 0;	//Кол-во строк (при this.pageBreakType = xlsConst.PBT_NUM)
	this.sPageBreakCond  = "";	//Выражение для условия вставки разрыва(при this.pageBreakType = xlsConst.PBT_COND)
	
	//Это номер строки, ниже которой ничего из настройки формы нет.
	//Нужна, т.к. после звезд есть строки типа "EDIT DOCUMENT" или "PAGE BREAK30"
	this.nLastFormRow = -1;
	
	//Здесь будет храниться номер последней колонки с "*****"
	//Инициализируем отрицательным значением, чтобы в первый раз
	//this.getLastColumn пробежалась по 1-й строке и нашла номер колонки
	this.nLastColumn = -1;				

	this.maxCellNum = 255;			//Максимальное количество колонок (если отсутствует "*****")
	this.maxRowNum = 65535;			//Максимальное количество строк (если отсутствует "*****")

	this.aBands = new Array();			//Массив xlsBand'ов
	this.aRegions = new Array();		//Массив всех  Region'ов, которые присутствуют на текущем HSSFSheet
	
	//Методы
	this.getLastColumn = xlsSheet_getLastColumn;
	
	this.getBandObj = xlsSheet_getBandObj;
	this.getHSSFSheet = xlsSheet_getHSSFSheet;
	this.getRow = xlsSheet_getRow;
	this.createRow = xlsSheet_createRow;
	
	this.findAllRegions = xlsSheet_findAllRegions;
	
	this.load = xlsSheet_load;
	this.parse = xlsSheet_parse;
	this.print = xlsSheet_print;
	this.release = xlsSheet_release;
	
	this.getRealSheetNum = xlsSheet_getRealSheetNum;
	this.getRealColNum = xlsSheet_getRealColNum;

	//метод для конвертации формы в формат jrxml;
	this.convert2Jrxml = xlsSheet_convert2Jrxml;
	
	this.trace("xlsSheet("+nSheetNumber+"): end");
}

function xlsSheet_getRealSheetNum(nCol)
{
	var nSht = 0;
	
	if (!isEmpty(nCol))
		nSht = Math.floor(nCol/(this.maxCellNum + 1));
	
	return nSht;
}

function xlsSheet_getRealColNum(nCol)
{
	var nSht = this.getRealSheetNum(nCol);
	return nCol - (nSht * this.maxCellNum + nSht);
}

//fruckt
//если кол-во колонок в результате больше this.maxCellNum (например шахматка)
//то динамически добавляем листы
//function xlsSheet_getHSSFSheet()
function xlsSheet_getHSSFSheet(nCol)
{
	var nSht = this.getRealSheetNum(nCol);
	if (isEmpty(this.oSheet[nSht]))
	{
		this.oSheet[nSht] = this.p_workBook.workBook.createSheet(this.oSheet[0].getSheetName()+"("+String(nSht + 1)+")");
	}
	
	//return this.oSheet;
	return this.oSheet[nSht];
}

//fruckt
//function xlsSheet_getRow(nRow)
function xlsSheet_getRow(nRow, nCol)
{
	//return this.oSheet.getRow(nRow);
	return this.getHSSFSheet(nCol).getRow(nRow);
}

//fruckt
//function xlsSheet_createRow(nRow)
function xlsSheet_createRow(nRow, nCol)
{
	//return this.oSheet.createRow(nRow);
	return this.getHSSFSheet(nCol).createRow(nRow);
}

/**
Функция найдет все регионы(объединенные ячейки) на листе
*/
function xlsSheet_findAllRegions()
{	
	this.trace("xlsSheet_findAllRegions: start");
	
	//fruckt
	//var nMergedRegions = this.oSheet.getNumMergedRegions();
	var nMergedRegions = this.oSheet[0].getNumMergedRegions();
	for(var nIndex = 0; nIndex < nMergedRegions; nIndex++)
	{
		//fruckt
		//this.aRegions[nIndex] = this.oSheet.getMergedRegionAt(nIndex);
		this.aRegions[nIndex] = this.oSheet[0].getMergedRegionAt(nIndex);
	}
	
	this.trace("xlsSheet_findAllRegions: end  ("+this.aRegions.length+" regions found)");
}


/**
Функция вернет объект-band определенного класса, основываясь на значении в 1-й ячейке строки nCurrentRow
*/
function xlsSheet_getBandObj(nCurrentRow)
{
	this.trace("xlsSheet_getBandObj(nCurrentRow = "+nCurrentRow+"): start");
	var oBand = null;
	
	//Обработаем случай CROSSH
	if (nCurrentRow == this.nCrosshRow)
	{
		this.trace(" xlsSheet_getBandObj("+nCurrentRow+"): У нас CROSSH, return new xlsBandTable");
		oBand = new xlsBandTable(this, nCurrentRow);
		return oBand;
	}
	
	//fruckt
	//var fssfRow = this.oSheet.getRow(nCurrentRow);
	var fssfRow = this.oSheet[0].getRow(nCurrentRow);
	var cellValue = null;
	if(fssfRow == null)
	{
		this.trace("xlsSheet_getBandObj: стоим на пустой строке (строка "+nCurrentRow+") - исправьте форму");
		cellValue = null;
	}
	else
	{
		var fssfCell = fssfRow.getCell(0);
		if(fssfCell == null)
		{ 
			cellValue = "";
		}
		else 
		{
			if(fssfCell.getCellType() == fssfCell.CELL_TYPE_STRING)
			{
				cellValue = String(fssfCell.getStringCellValue().trim());

				if(cellValue != xlsConst.START_END_TEMPLATE)
				{
					cellValue = cellValue.substr(0,2);
				}
			}
			else
			{
				//в ячейке - либо число, либо еще что-нибудь. нам все равно
				cellValue = "";
			}
		}
	}

	fssfCell = null;
	fssfRow = null;
	
	switch(cellValue)
	{
		case xlsConst.START_BAND_HEADER:	// "*="
		case xlsConst.START_BAND_ROWS:		// "*+"
			this.trace(" xlsSheet_getBandObj("+nCurrentRow+"): new xlsBandTable");
			oBand = new xlsBandTable(this, nCurrentRow);
			break;
		case null:
		case xlsConst.START_END_TEMPLATE:	// "*****"
			this.nLastRow = nCurrentRow;
			oBand = null;
			break;
		default:
			oBand = new xlsBand(this, nCurrentRow);
			break;
	}

	var bandName = "null";
	if (oBand!=null)
	{
		bandName = objTypeOf(oBand)+" at "+nCurrentRow;
		oBand.name = bandName;
	}
	this.trace("xlsSheet_getBandObj("+nCurrentRow+"): end return "+bandName);
	return oBand;
}

function xlsSheet_load()
{	
	this.trace("xlsSheet_load: start (лист № "+(this.nSheetNumber)+")");
	var oBand = null;

	//Получаем правую границу шаблона
	var lastColumn = this.getLastColumn();
	if (lastColumn==0)
	{
		//не нашли в верхней строке маркера с 5-ю звездами,
		//значит на данном листе настройка формы отсутствует
		//и нечего по нему бегать
		this.trace("xlsSheet_load: end Пропускаем(лист № "+(this.nSheetNumber)+")");
		return;
	}

	//загрузим все имеющиеся на листе регионы
	this.findAllRegions();

	//загружаем все бенды
	while((oBand = this.getBandObj(this.nCurrentRow)) != null)
	{
		this.nCurrentRow = oBand.load();
		this.aBands[this.aBands.length] = oBand;
	}
	
	//по окончании мы стоим на последней строке ("со звездами")
	this.nLastRow = this.nCurrentRow;
	this.nLastFormRow = this.nCurrentRow;
	
	//Проверяем PageBreak
	//Форматов описания - 2 шт.
	//1) Константа
	//Пример: после печати каждой 5-й строки таблицы строк вставлять PageBreak
	//PAGE BREAK=5
	//2) Условие
	//Пример: вставлять PageBreak, если RFLEVEL==5
	//PAGE BREAK=*(RFLEVEL==5)
	for (var nRow = this.nLastRow+1; nRow <=this.nLastRow+5; nRow++)
	{
		var strValue = this.getCellValueAt(nRow, 0)
		if (strValue.startsWith(xlsConst.PAGE_BREAK))
		{
			var strPageBreak = strValue.substr(xlsConst.PAGE_BREAK.length).trim();	
			if (strPageBreak.startsWith(xlsConst.ASTERISK))
			{
				//выражение начинается на "*" - значит условие
				this.pageBreakType = xlsConst.PBT_COND;
				this.sPageBreakCond = strPageBreak.substr(1);
				this.trace("   xlsSheet_load: this.sPageBreakCond="+this.sPageBreakCond);
			}
			else if (!isNaN(strPageBreak))
			{
				//Число
				this.pageBreakType = xlsConst.PBT_NUM;
				this.nPageBreak = Number(strPageBreak);
				this.trace("   xlsSheet_load: this.nPageBreak="+this.nPageBreak);
			}
			this.nLastFormRow = nRow;
			this.trace("   xlsSheet_load: this.nLastFormRow="+this.nLastFormRow);
			break;
		}
		else if (strValue==xlsConst.EDIT_DOCUMENT)
		{
			this.p_workBook.setPostProcessAction(xlsConst.PPA_EDIT_DOCUMENT);
			this.nLastFormRow = nRow;
		}
	}
		
	this.trace("xlsSheet_load: end (лист № "+(this.nSheetNumber)+")");
}

/**
Получить номер колонки-правой границы формы (ячейки в первой строке, в которой находится *****)
При первом вызове пробегается по колнокам, при всех последующих
возвращает this.nLastColumn
*/
function xlsSheet_getLastColumn()
{
	this.trace("xlsSheet_getLastColumn: start (лист № "+(this.nSheetNumber)+")");
	
	//если значение уже было установлено, то вернем его
	if (this.nLastColumn >= 0)
	{
		this.trace("xlsSheet_getLastColumn: return this.nLastColumn="+this.nLastColumn);
		return this.nLastColumn;
	}
	
	//В первый раз найдем последнюю колонку
	var cellValue = "";
	
	//берем 1-ю строку
	//fruckt
	//var hssfRow = this.oSheet.getRow(0);
	var hssfRow = this.oSheet[0].getRow(0);
	if (hssfRow==null)
	{
		//в 1-й строке ничего нет. Форма настроена некорректно.
		//поинициализируем максимальным значением
		this.nLastColumn = 0;
		this.trace("xlsSheet_getLastColumn: ОШИБКА!!! в 1-й строке нет \"*****\" return this.nLastColumn="+this.nLastColumn);
	}
	else
	{
		var fssfCell;
		for (var nIndex = 0; nIndex < this.maxCellNum; nIndex++)
		{
			fssfCell = hssfRow.getCell(nIndex);
			if (fssfCell == null)
			{
				continue;
			}
			
			cellValue = this.getCellValue(fssfCell);
			
			if(cellValue == xlsConst.START_END_TEMPLATE)
			{
				break;
			}
		}

		this.nLastColumn = nIndex;
	}
	this.trace("xlsSheet_getLastColumn: end (лист № "+(this.nSheetNumber)+";  return "+this.nLastColumn+")");
	
	return this.nLastColumn;
}

function xlsSheet_parse()
{
	this.trace("xlsSheet_parse: start (лист № "+(this.nSheetNumber)+")");
	for(index in this.aBands)
	{
		 this.aBands[index].parse();
	}
	this.trace("xlsSheet_parse: end (лист № "+(this.nSheetNumber)+")");
}

function xlsSheet_print()
{
	this.trace("xlsSheet_print: start (лист № "+(this.nSheetNumber)+")");
	var nPrintStartRow = this.nLastFormRow + 1;
	
	//напечатаем все бенды
	for(index in this.aBands)
	{
		nPrintStartRow = this.aBands[index].print(nPrintStartRow) + 1;
		//нужно нам знать, где мы начали печатать таблицу
		if (objTypeOf(this.aBands[index]) == "xlsBandTable" && !isEmpty(this.aBands[index].printFirstTableRow))
		{
			this.printFirstTableRow = this.aBands[index].printFirstTableRow-this.nLastFormRow-1;
		}
		this.trace("xlsSheet_print: nPrintStartRow="+nPrintStartRow);
	}
	
	//fruckt
	//установим высоту строк
	for(index in this.aBands)
	{
		this.aBands[index].setRowHeights();
	}

	//На данном этапе у нас имеется на листе сверху - настройка формы,
	//а ниже - результат печати.
	//Нам следует очистить строки с настройкой и результат поднять вверх
	//удаляем регионы в настройке
	var nMergedRegions = this.oSheet[0].getNumMergedRegions();
	for(var nIndex = nMergedRegions-1; nIndex >=0; nIndex--)
	{
		this.trace("xlsSheet_print: this.oSheet.getMergedRegionAt(nIndex="+nIndex+")");
		//fruckt
		//var oR = this.oSheet.getMergedRegionAt(nIndex);
		var oR = this.oSheet[0].getMergedRegionAt(nIndex);
		if(oR.getRowFrom() <= this.nLastFormRow)
		{
			this.trace("xlsSheet_print: this.oSheet.removeMergedRegion(nIndex="+nIndex+")");
			//fruckt
			//this.oSheet.removeMergedRegion(nIndex);
			this.oSheet[0].removeMergedRegion(nIndex);
		}
	}

	//Удаляем строки настройки
	if (this.nLastFormRow >= 0)
	{
		//fruckt
		for (var nSht in this.oSheet)
		{
			//чистим
			for (var nRow = 0; nRow <= this.nLastFormRow; nRow++)
			{
				//fruckt
				//var hssfRow = this.oSheet.getRow(nRow);
				var hssfRow = this.oSheet[nSht].getRow(nRow);
				if (hssfRow != null)
				{
					//удаляем комментарии в ячейках строки
					for (var nCell = 0; nCell <= this.nLastColumn; nCell++)
					{
						var hssfCell = hssfRow.getCell(nCell);
						if (hssfCell != null)
						{
							hssfCell.removeCellComment();
						}
					}
					//удаляем саму строку
					//fruckt
					//this.oSheet.removeRow(hssfRow);
					this.oSheet[nSht].removeRow(hssfRow);
				}
			}

			this.trace("xlsSheet_print: this.oSheet.shiftRows("+(this.nLastFormRow+1)+", "+(nPrintStartRow-1)+", "+(-this.nLastFormRow)+")");
			//fruckt
			//this.oSheet.shiftRows(this.nLastFormRow+1, nPrintStartRow-1, -(this.nLastFormRow+1), true, false);
			this.oSheet[nSht].shiftRows(this.nLastFormRow+1, nPrintStartRow-1, -(this.nLastFormRow+1), true, false);
		}
	}

	// поставим курсор на A:1
	//fruckt
	//var row = this.oSheet.getRow(0);
	var row = this.oSheet[0].getRow(0);
	if (row == null)
	{
		//fruckt
		//row = this.oSheet.createRow(0);
		row = this.oSheet[0].createRow(0);
	}

	var cell = row.getCell(0);
	if (cell == null)
	{
		cell = row.createCell(0);
	}
	cell.setAsActiveCell();
	this.trace("xlsSheet_print: end (лист № "+(this.nSheetNumber)+")");
}

function xlsSheet_release()
{
	this.p_workBook = null;
	this.p_office = null;
	this.workBook = null;
	this.p_parent = null;
    this.p_sheet = null;
	this.p_band = null;
	
	//"отпустим" все свои бенды
	for (var nBand in this.aBands)
	{
		this.aBands[nBand].release();
		this.aBands[nBand] = null;
	}
	this.aBands = null;			//Массив xlsBand'ов

	this.oSheet[0] = null;
}

/**
метод для конвертации формы в формат jrxml;
Методика позаимствована в DpPSFDecoder.js
@param oPar имет поля:
	.builder
	.designe
*/
function xlsSheet_convert2Jrxml(oPar)
{
	// TODO: определить ориентацию в параметрах страницы
	//var orientation = 2;//"Landscape";	//1
	var orientation = 1;//"Portrait";	//0
	oPar.designe.setOrientation(orientation);
	
	JRXML_setMargins(orientation, oPar.designe);

	//обойдем все бенды
	var isTableDone = false;
	for (nIndex in this.aBands)
	{
		oPar.lastHeight = 0;
		var oXlsBand = this.aBands[nIndex];
		switch (oXlsBand.bandType)
		{
			case xlsConst.BT_TABLE:
				if (isTableDone)
				{
					var strMsg = "Внимание!"
					+"\nНа листе имеется больше одной табличной части."
					+"\n"
					+"\nРезультаты конвертации будут некорректными."
					alert(strMsg);
				}
				
				isTableDone = true;
				if (oXlsBand.bandHeader != null)
				{
					var oBand = oPar.builder.createBand();
					oBand.addElementGroup(oXlsBand.bandHeader.convert2Jrxml(oPar));
					oBand.setHeight(oPar.lastHeight);
					oPar.designe.setColumnHeader(oBand);
				}
				
				oPar.lastHeight = 0;
				//а теперь добавим настройку описателей строк
				for (var nRowIndex in oXlsBand.aBandRows)
				{
					var oBandRow = oXlsBand.aBandRows[nRowIndex];
					var oBand = oPar.builder.createBand();
					oBand.addElementGroup(oBandRow.convert2Jrxml(oPar));
					oBand.setHeight(oPar.lastHeight);
					oPar.designe.setDetail(oBand);
				}
				break;
			case xlsConst.BT_GENERIC:
			default:
				var oBand = oPar.builder.createBand();
				oBand.addElementGroup(oXlsBand.convert2Jrxml(oPar));
				oBand.setHeight(oPar.lastHeight);
				if (isTableDone)
				{
					oPar.designe.setSummary(oBand);
				}
				else
				{
					oPar.designe.setTitle(oBand);
				}
				break;
		}
		//при конвертации xls-форм можно попытаться обработать колонтитулы и сделать
		//oPar.designe.setPageHeader(headerBand);
		//oPar.designe.setPageFooter(footerBand);
	}
}

function JRXML_setMargins(nOrientation, designe)
{
	switch (nOrientation)
	{
		case 2:	//"Landscape"
			designe.setPageWidth(842);
			designe.setPageHeight(595);
			designe.setColumnWidth(802);
			designe.setLeftMargin(15);
			designe.setRightMargin(15);
			designe.setTopMargin(20);
			designe.setBottomMargin(20);
			break;
		case 1:	//"Portrait"
		default:
			designe.setPageWidth(595);
			designe.setPageHeight(842);
			designe.setColumnWidth(555);
			designe.setLeftMargin(15);
			designe.setRightMargin(15);
			designe.setTopMargin(20);
			designe.setBottomMargin(20);
			break;

		}
}
