function Office_printXML()
{
	this.initVars = Office_initVars;
	this.fillElements = Office_fillElements;
	this.fillElementsRows = Office_fillElementsRows;
	include("objects/DpXMLDOMDocument.js");
	this.xmlDom = new DpXMLDOMDocument();	
	var bLoaded = this.xmlDom.load(this.file)
	if (!bLoaded) return false;
	this.initVars();
	
	
	var root = this.xmlDom.getDocumentElement();
	this.fillElements(root);	
	
	var sReg = Number(this.vars.getVar("C_REG"));
	var sRaj = Number(this.vars.getVar("C_RAJ"));
	var sName = format("00",sReg)+format("00",sRaj);
	var sOkpo =  String(this.vars.getVar("OOKPO"));
	sOkpo = replicate("0",10 - sOkpo.length) + sOkpo;
	
	sName += (sOkpo + this.form+"001.xml");
	var sDir = getPar("EXPDIR")
	if (!sDir) 
	{
		alert("Установите директорию экспорта");
		return false;		
	}
	var sFile = sDir + sName;
	this.xmlDom.save(sFile);
}


function Office_initVars()
{
	this.vars.setVar("TIN",this.vars.getVar("OOKPO"));
	this.vars.setVar("C_DOC",this.form.substr(0,3).toUpperCase());
	this.vars.setVar("C_DOC_SUB",this.form.substr(3,3).toUpperCase());
	this.vars.setVar("C_DOC_VER",Number(this.form.substr(6,2)));
	this.vars.setVar("C_DOC_TYPE",String(0));
	this.vars.setVar("C_DOC_CNT",1);
	this.vars.setVar("D_FILL",format("ddmmyyyy",today));
	
}

function Office_fillElements(xmlElem)
{
	var nodes = xmlElem.getChildNodes();
	for (var i = 0 ; i < nodes.length; i++)
	{
		var sNodeName = nodes[i].getNodeName();
		if (sNodeName == "DECLARHEAD"
				|| sNodeName == "DECLARBODY")
		{
			this.fillElements(nodes[i])
		}
		else if(sNodeName == "FRMROWS")
		{
			this.fillElementsRows(xmlElem, nodes[i])
		}
		else
		{
			if (nodes[i].hasChildNodes())
			{
				this.fillElements(nodes[i]);
			}
			else
			{
				var oValue = this.setField(sNodeName);
				if (typeof(oValue) == "undefined" 
					|| typeof(oValue) == "unknown"  || oValue  == null 
					|| (typeof(oValue) != "string" && oValue  == 0))
				{
					if (xmlElem.getNodeName() != "DECLARHEAD")
						xmlElem.removeChild(nodes[i]);
					continue;
				}
				if(isDateType(oValue))
				{
					oValue = format("ddmmyyyy",oValue);
					
				}
				if (!oValue)
				{
					xmlElem.removeChild(nodes[i]);
				}
				else
				{
					nodes[i].setText(oValue);
				}
				
			}
		}
	}			
}


function Office_fillElementsRows(xmlPar, xmlRows)
{
	var rTbl = this.vars.getRTbl();
	if (rTbl)
	{
		rTbl.MoveFirst();
		var nodes = xmlRows.getChildNodes();
		var nRow = 1;
		while (!rTbl.isEOF())
		{
			bAddRow = true;
			var sFilter = xmlRows.getAttribute("filter");
			if (sFilter)
			{
				bAddRow = this.vars.eval.eval(sFilter)
			}
			if (bAddRow)
			{
				for(var i = 0; i < nodes.length; i++)
				{
					var sVar = nodes[i].getNodeName();
					var xmlEl = this.xmlDom.createElement(sVar);
					xmlEl.setAttribute("ROWNUM",nRow);
					var oValue = this.setField(sVar);
					if (typeof(oValue) == "undefined" 
						|| typeof(oValue) == "unknown"  || oValue  == null 
						|| (typeof(oValue) != "string" && oValue  == 0))
						continue;
					if(objTypeOf(oValue) == "Date" || objTypeOf(oValue) == "date")
					{
						oValue = format("ddmmyyyy",oValue);					
					}
					xmlEl.setText(oValue);
					if(oValue)
						xmlPar.insertBefore(xmlEl,xmlRows);
				}
				nRow++;
			}
			rTbl.MoveNext();
		}
	}
	else
	{
		var sFixRow = xmlRows.getAttribute("fixrow");
		if (sFixRow)
		{
			var nMaxRow = Number(sFixRow);
			var nodes = xmlRows.getChildNodes();
			var nRow = 1;
			for(nRow = 1; nRow <= nMaxRow; nRow++)
			{
				for(var i = 0; i < nodes.length; i++)
				{
					var sVar = nodes[i].getNodeName();
					var xmlEl = this.xmlDom.createElement(sVar);
					xmlEl.setAttribute("ROWNUM",nRow);
					var oValue = this.setField(sVar+nRow);
					if (typeof(oValue) == "undefined" 
						|| typeof(oValue) == "unknown"  || oValue  == null 
						|| (typeof(oValue) != "string" && oValue  == 0))
						continue;
					if(objTypeOf(oValue) == "Date" || objTypeOf(oValue) == "date")
					{
						oValue = format("ddmmyyyy",oValue);					
					}
					xmlEl.setText(oValue);
					if(oValue)
						xmlPar.insertBefore(xmlEl,xmlRows);
				}
			}
		}
	}
	xmlPar.removeChild(xmlRows);
}