include("objects/DpXMLDOMDocument.js");

function Office_printXSD()
{
	this.initVars = Office_initVars;
	this.fillElements = Office_fillElements;
	//this.fillElementsRows = Office_fillElementsRows;
	this.createXMLFromXSD = Office_createXMLFromXSD;
	this.createElementFromXSD = Office_createElementFromXSD;
	//this.createSequenceFromXSD = Office_createSequenceFromXSD;		

	this.xmlDomXSD = new DpXMLDOMDocument();
	this.xmlDom = new DpXMLDOMDocument();	

	var bLoaded = this.createXMLFromXSD(this.file)
	if (!bLoaded) return false;
	this.initVars();	
	
	var root = this.xmlDom.getDocumentElement();
	this.fillElements(root);	
	
	var sReg = Number(this.vars.getVar("C_REG"));
	var sRaj = Number(this.vars.getVar("C_RAJ"));
	var sName = format("00",sReg)+format("00",sRaj);
	var sOkpo =  String(this.vars.getVar("OOKPO"));
	sOkpo = replicate("0",10 - sOkpo.length) + sOkpo;
	var sNameSuffix = String(this.vars.getVar("DocStan")) + format("00", Number(this.vars.getVar("DocType")))
		+ "000" + "01" + format("00", Number(this.vars.getVar("PERIOD_MONTH"))) + Number(this.vars.getVar("PERIOD_YEAR")); 
	
	sName += (sOkpo + this.form+sNameSuffix +".xml");
	var sDir = getPar("EXPDIR")
	if (!sDir) 
	{
		alert("Установите директорию экспорта");
		return false;		
	}
	var sFile = sDir + sName;
	this.xmlDom.save(sFile, "windows-1251");
//	this.xmlDom.save(sFile);
}

function Office_initVars()
{
	this.vars.setVar("TIN",this.vars.getVar("OOKPO"));
	this.vars.setVar("C_DOC",this.vars.getVar("C_DOC"));
	this.vars.setVar("C_DOC_SUB",this.vars.getVar("C_DOC_SUB"));
	this.vars.setVar("C_DOC_VER",Number(this.vars.getVar("C_DOC_VER")));
	//this.vars.setVar("C_DOC",this.form.substr(0,3).toUpperCase());
	//this.vars.setVar("C_DOC_SUB",this.form.substr(3,3).toUpperCase());
	//this.vars.setVar("C_DOC_VER",Number(this.form.substr(6,2)));
	this.vars.setVar("C_DOC_TYPE",this.vars.getVar("DocType"));
	this.vars.setVar("C_DOC_CNT",this.vars.getVar("DocCnt"));
	this.vars.setVar("C_DOC_STAN",this.vars.getVar("DocStan"));
	this.vars.setVar("D_FILL",format("ddmmyyyy",today));	
}

function Office_fillElements(xmlElem)
{
	var nodes = xmlElem.getChildNodes();
	for (var i = 0 ; i < nodes.length; i++)
	{
		var sNodeName = nodes[i].getNodeName();
		if (sNodeName == "DECLARHEAD"
				|| sNodeName == "DECLARBODY")
		{
			this.fillElements(nodes[i])
		}
		/*
		else if(sNodeName == "FRMROWS")
		{
			this.fillElementsRows(xmlElem, nodes[i])
		}
		*/
		else
		{
			if (this.vars.frmPrinter != null)
			{
				
				if (this.vars.frmPrinter.falseChoices[sNodeName] != null)
				{
					xmlElem.removeChild(nodes[i]);
					continue;
				}
			}
			
			if (nodes[i].hasChildNodes())
			{
				this.fillElements(nodes[i]);
			}
			else
			{
				if (sNodeName.indexOf("RXXXX")!=-1)
				{
					// Поле из таблицы
					var currNode = nodes[i];
					var nRowNum = 1;
					sTableName = sNodeName.substring(0, sNodeName.indexOf("RXXXX"));
					var rTbl = this.vars.getRTbl(sTableName);
					if (rTbl)
					{
						var oldRTblAlias = this.vars.eval.activeRTableAlias;
						this.vars.eval.activeRTableAlias = sTableName;
						
						rTbl.MoveFirst();
						if (rTbl.IsEOF())
						{
							currNode.setAttribute("ROWNUM", nRowNum);
							currNode.setAttribute("xsi:nil", "true");
						}
						else
						{
							for(; !rTbl.IsEOF(); rTbl.MoveNext(), nRowNum++)
							{
								// получаем текущий элемент
								if (nRowNum > 1)
								{
									if (i + 1 < nodes.length)
										currNode = xmlElem.createChild(sNodeName, "", null, nodes[i + 1])
									else
										currNode = xmlElem.createChild(sNodeName)
								}						
								currNode.setAttribute("ROWNUM", nRowNum);
								
								var oValue;
								// проверяем, может это поле есть у нас в Rules
								if (this.vars.frmPrinter.isRulesRVar(sNodeName))
								{					
									oValue = this.vars.frmPrinter.getRulesVar(sNodeName);
								}
								else if (!rTbl.IsField(sNodeName))
								{
									// добавлям пустые непромапенные поля
									currNode.setAttribute("xsi:nil", "true");
									continue;
								}
								else
								{
									oValue = rTbl.getValue(sNodeName);		
								}
	
								// если значение пустое - проставляем null							
								if (typeof(oValue) == "undefined" 
									|| typeof(oValue) == "unknown"  || oValue  == null 
									//|| (typeof(oValue) != "string" && oValue  == 0)
									)
								{
									currNode.setAttribute("xsi:nil", "true");
									continue;
								}
								
								if(isDateType(oValue))
									oValue = format("ddmmyyyy",oValue);					
								if (!oValue)
									currNode.setAttribute("xsi:nil", "true");
								else
									currNode.setText(oValue);
							}
						}
						
						this.vars.eval.activeRTableAlias = oldRTblAlias;
					}
					else
					{
						currNode.setAttribute("ROWNUM", nRowNum);
						currNode.setAttribute("xsi:nil", "true");
					}
				}
				else
				{
					var oValue;
					
					if (this.vars.frmPrinter.isRulesVar(sNodeName))
						oValue = this.vars.frmPrinter.getRulesVar(sNodeName);
					else
					{
						
						oValue = this.setField(sNodeName);
						//if (sNodeName=="HY")
							
					}
					
					//TODO: Проверить тип
					if (oValue == "-")
						oValue = "0";
					
					if (typeof(oValue) == "undefined" 
						|| typeof(oValue) == "unknown"  || oValue  == null 
						|| (typeof(oValue) != "string" && oValue  == 0))
					{
						nodes[i].setAttribute("xsi:nil", "true");
						continue;
					}
					
					if(isDateType(oValue))
						oValue = format("ddmmyyyy",oValue);					
					if (!oValue)
					{
						nodes[i].setAttribute("xsi:nil", "true");
					}
					else
					{
						nodes[i].setText(oValue);
					}
				}				
			}
		}
	}			
}

/*
function Office_fillElementsRows(xmlPar, xmlRows)
{
	var rTbl = this.vars.getRTbl();
	if (rTbl)
	{
		rTbl.MoveFirst();
		var nodes = xmlRows.getChildNodes();
		var nRow = 1;
		while (!rTbl.isEOF())
		{
			bAddRow = true;
			var sFilter = xmlRows.getAttribute("filter");
			if (sFilter)
			{
				bAddRow = this.vars.eval.eval(sFilter)
			}
			if (bAddRow)
			{
				for(var i = 0; i < nodes.length; i++)
				{
					var sVar = nodes[i].getNodeName();
					var xmlEl = this.xmlDom.createElement(sVar);
					xmlEl.setAttribute("ROWNUM",nRow);
					var oValue = this.setField(sVar);
					if (typeof(oValue) == "undefined" 
						|| typeof(oValue) == "unknown"  || oValue  == null 
						|| (typeof(oValue) != "string" && oValue  == 0))
						continue;
					if(objTypeOf(oValue) == "Date" || objTypeOf(oValue) == "date")
					{
						oValue = format("ddmmyyyy",oValue);					
					}
					xmlEl.setText(oValue);
					if(oValue)
						xmlPar.insertBefore(xmlEl,xmlRows);
				}
				nRow++;
			}
			rTbl.MoveNext();
		}
	}
	else
	{
		var sFixRow = xmlRows.getAttribute("fixrow");
		if (sFixRow)
		{
			var nMaxRow = Number(sFixRow);
			var nodes = xmlRows.getChildNodes();
			var nRow = 1;
			for(nRow = 1; nRow <= nMaxRow; nRow++)
			{
				for(var i = 0; i < nodes.length; i++)
				{
					var sVar = nodes[i].getNodeName();
					var xmlEl = this.xmlDom.createElement(sVar);
					xmlEl.setAttribute("ROWNUM",nRow);
					var oValue = this.setField(sVar+nRow);
					if (typeof(oValue) == "undefined" 
						|| typeof(oValue) == "unknown"  || oValue  == null 
						|| (typeof(oValue) != "string" && oValue  == 0))
						continue;
					if(objTypeOf(oValue) == "Date" || objTypeOf(oValue) == "date")
					{
						oValue = format("ddmmyyyy",oValue);					
					}
					xmlEl.setText(oValue);
					if(oValue)
						xmlPar.insertBefore(xmlEl,xmlRows);
				}
			}
		}
	}
	xmlPar.removeChild(xmlRows);
}
*/

function Office_createXMLFromXSD(fileName)
{
	this.xmlDomXSD.async = false;
	var bLoaded = this.xmlDomXSD.load(fileName);
	if(!bLoaded)
		alert("ERROR: Can not load file - " + fileName)

	var root = this.xmlDomXSD.getDocumentElement();
	// hash map for Complex Types
	var complexTypeMap = new Array(); 
	var nodes = root.getElementsByTagName("xs:complexType");
	for (var i = 0; i < nodes.length; i++)
	{
		complexTypeMap[String(nodes[i].getAttribute("name"))] = nodes[i];
	}
	
	// Enumerate all nodes
	nodes = root.getChildNodes();
	for (var i = 0; i < nodes.length; i++)
	{
		if (nodes[i].getBaseName() == "element")
			this.createElementFromXSD(this.xmlDom, nodes[i], complexTypeMap);
	}
	
	return true;
}

function Office_createElementFromXSD(parEl,xsdEl, complexTypeMap)
{
	var sName = xsdEl.getAttribute("name");	
	var sType = xsdEl.getAttribute("type");	
	var xmlEl = this.xmlDom.createElement(sName);
	parEl.appendChild(xmlEl);
	if (sName.toUpperCase() == "DECLAR")
	{
		xmlEl.setAttribute("xmlns:xsi","http://www.w3.org/2001/XMLSchema-instance");
		xmlEl.setAttribute("xsi:noNamespaceSchemaLocation", this.form + ".xsd");
	}
	
	var xsd = complexTypeMap[sType];
	if (!xsd) 
		return;
	
	var Seq = xsd.getElementsByTagName("xs:sequence")[0];
	if (!Seq) 
		return;
	var nodes  = Seq.getChildNodes();
	for (var i = 0; i < nodes.length; i++)
	{
		if (nodes[i].getBaseName() == "element")
			this.createElementFromXSD(xmlEl,nodes[i], complexTypeMap);
		else if (nodes[i].getBaseName() == "choice")
		{
			var choices = nodes[i].getChildNodes();
			for (var k = 0; k < choices.length; k++)
			{
				if (choices[k].getBaseName() == "element")
					this.createElementFromXSD(xmlEl,choices[k], complexTypeMap);
			}
		}
		else if (nodes[i].getBaseName() == "sequence")
		{
			alert("sequence in sequence ERROR")
			// this.createSequenceFromXSD(xmlEl,nodes[i]);
		}
	}	
}
/*
function Office_createSequenceFromXSD(parEl,xsdEl)
{
	 var xmlRows = this.xmlDom.createElement("FRMROWS");
	 parEl.appendChild(xmlRows);
	 var nodes = xsdEl.selectNodes("xs:element")
	
}
*/