//импорт позволяющий переводить сотрудника из одной базы в другую
include("Objects/DpGrid.js");
include("Objects/DpExtentionBuilder.js");
include("Objects/DpClEx.js");
include("Objects/DpStruOrg.js");
include("sys/dbase.js");
include("servis/date.js");
include("gridedit.js");

var tblName = "TBL_IMP_PERS";
var tblPref = "";
var dpGridEdit;
var fwidAr = new Array();

function listLoad()
{
	this.title = ru("Импорт сотрудников из другой БД","Імпорт співробітників з іної БД");
	fillDBCombo(FBASE);
	
	var m = new Object();
	m.Fcod = "LONG";
	m.Ftxt = "TEXT";
	m.Fcod_new = "LONG";
	m.Fwid_cl = "LONG";
	m.Fwid = "COUNTER";
	CreateTable(tblName, m);
	
	FCL.value = getPar("CODPERS");
	setButton(BTN_APPLY, onApply);
	setButton(BTN_SAVE, onSave);
	setValid(FSHTAT, shtatValid);
	//setValid(FDAT_IMP, dat_impValid);
	shtatValid()
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	//dpGridEdit.saveRecord = saveRecord;
	dpGridEdit.addValidField("Fcod_new", codStartValid, codSaveValid);
}

function fillDBCombo(oCtrl)
{
	if(SUBD==MYSQL || SUBD==ORACLE)
		oCtrl.addItem("", "");
	var arrBase = lpProxy.getDBManager().getDatabases();
	for (var nB = 0; nB < arrBase.length; nB++)
	{
		var sBase = String(arrBase[nB]).toLowerCase();
		oCtrl.addItem(sBase, arrBase[nB]);		
	}
	oCtrl.value = "";	
}

function listSrc()
{
	this.qrySet("From", tblName, "Order", "Fcod");
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	oGrid.defCond("=isExistTabn(^Fcod_new)", "err")
	oGrid.color(17, "err");
	var gr = oGrid.page();
	with(gr)
	{
		with(group("Табельний №|Табельный №"))
		{
			FieldEx("Fcod", "Джерело|Источник", 6);
			FieldEx("Fcod_new", "Приймач|Приемник", 6, "e");
		}
		FieldEx("Ftxt", "П.І.Б.|Ф.И.О.", 25);
	}	
	oGrid.build();
}

function listMenuInit()
{
	if(list.tbl.rowCount>0)
	{
		this.dataSrc.AddMenuItem("EDIT","Редагувати|Редактировать");
		this.dataSrc.AddMenuItem("IMPORT","Імпортувати|Импортировать");
	}
}

function listMenuRun(ID)
{
	if(ID == "IMPORT")
		onSave();
}

function onApply()
{
	if(allt(FBASE.value)=="")
	{
		alert(ru("Укажите базу-источник!","Вкажіть базу-джерело!"))
		return false;
	}
	tblPref = allt(FBASE.value) + (SUBD==MSSQL?"..":".");
	ExecuteSQL("delete from "+tblName);
	ExecuteSQL("insert into "+tblName+" (Fcod, Fcod_new, Fwid_cl, Ftxt) "
			+" select r.Fcod, r.Fcod, r.Fwid_cl, cl.Ftxt "
			+" from "+tblPref+"com_cl as cl inner join "+tblPref+"com_clrelclcl as r on cl.Fwid=r.Fwid_cl and r.Fcl="+FCL.value);
	list.tbl.requery();
	grid.refresh();
}

function onSave()
{
//	if(!dat_impValid())
//		return false;
	if(list.tbl.rowCount == 0)
	{
		alert(ru("Сперва укажите базу и номер справочника и нажмите кнопку 'Применить'","Спершу вкажіть базу та номер довідника та натисніть кнопку 'Застосувати'"))
		return false;
	}
	if(grid.selectedCount==0)
	{
		if(confirm(ru("Не отмечено ни одной записи! Импортировать все?","Не відмічено жодного рядку! Імпортувати усі?")))
			var t = OpenTable("select * from "+tblName+" order by Fcod_new");
		else
			return false;
	}
	else
	{
		var t = OpenTable("select * from "+tblName+" where "+grid.sqlSelected()+" order by Fcod_new");
	}
	//сперва проверяем табельные номера
	setProgressRange(1, t.rowCount);
	for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
	{
		setProgressPos(t.bookmark, ru("Проверка ","Перевірка ")+t.bookmark+"/"+t.rowCount);
		if(isExistTabn(t.getValue("Fcod_new")))
		{
			alert(ru("Сотрудник с табельным номером "+t.getValue("Fcod_new")+" уже существует в базе-приемнике!",
					"Співробітник з тебельним номером "+t.getValue("Fcod_new")+" вже існує в базі-приймачі!"))
			setProgressPos(0);
			return false;
		}
	}
	setProgressPos(0);
	//проверяем соответствия полей таблиц
	var ok = true;
	if(!comparFields("CL",tblPref+"com_cl"))
		ok = false;
	if(!comparFields("CLRELCLCL",tblPref+"com_clrelclcl"))
		ok = false;
	if(!comparFields("CL_HOMO",tblPref+"com_cl_homo"))
		ok = false;
	if(!comparFields("PERSFILE",tblPref+"cdr_persfile"))
		ok = false;
	//проверяем соответствия расширений
	if(toScrObj(FIS_EXT.value))
		ok = comparExt();
	if(toScrObj(FIS_STAT.value))
	{
		if(!comparFields("SRED_INI",tblPref+"zrp_sred_ini"))
			ok = false;
		if(!comparFields("TIME_OTP",tblPref+"zrp_time_otp"))
			ok = false;
		if(!comparFields("TIME_WR2",tblPref+"zrp_time_wr2"))
			ok = false;
		if(!comparFields("TIME_GO",tblPref+"zrp_time_go"))
			ok = false;
		if(!comparFields("TIME_KL",tblPref+"zrp_time_kl"))
			ok = false;
		if(!comparFields("WT_LBL_PR",tblPref+"zrp_wt_lbl_pr"))
			ok = false;
		if(!comparFields("WT_LBL_O",tblPref+"zrp_wt_lbl_o"))
			ok = false;
		if(!comparFields("WT_LBL_B",tblPref+"zrp_wt_lbl_b"))
			ok = false;
		if(!comparFields("PRK_FMPL",tblPref+"zrp_prk_fmpl"))
			ok = false;
	}
	if(!ok)
		return false;
	//теперь импортируем
	setProgressRange(1, t.rowCount);
	var k = 0;
	if(toScrObj(FIS_EXT.value))
		var oClEx =  new DpClEx("CL3",getPar("CODPERS"))
	for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
	{
		setProgressPos(t.bookmark, ru("Импорт сотрудников ","Імопрт співробітників ")+t.bookmark+"/"+t.rowCount);
		var Fcod_old = t.getValue("Fcod");
		var Fcod_new = t.getValue("Fcod_new");
		var Fio = t.getValue("Ftxt");
		var clrelTbl = OpenTable("select * from "+tblPref+"com_clrelclcl where Fcl="+FCL.value+" and Fcod="+Fcod_old);
		var Fwid_old = clrelTbl.getValue("Fwid_cl");
		var Fwid_new = GetUID();
		var clTbl = OpenTable("select * from "+tblPref+"com_cl where Fwid="+Fwid_old);
		var homoTbl = OpenTable("select * from "+tblPref+"com_cl_homo where Fwid_cl="+Fwid_old);
		var persTbl = OpenTable("select * from "+tblPref+"cdr_persfile where Fwid_cl="+Fwid_old);
		var oCl = scatter(clTbl);
		var oHomo = scatter(homoTbl);
		var oPers = scatter(persTbl);
		
		var oRel = new Object();
		oRel.FWID_CL = Fwid_new;
		oRel.FCL = getPar("CODPERS");
		oRel.FCOD = Fcod_new;
		oCl.FWID = Fwid_new;
		oCl.FVER = 0;
		oHomo.FWID_CL = Fwid_new;
		oPers.FWID_CL = Fwid_new;
		
		BeginTransaction();
		//справочник
		var ok = UpdateTable("^cl", oCl, true);
		if(ok)
			ok = UpdateTable("^clrelclcl", oRel, true);
		if(ok)
			ok = UpdateTable("^cl_homo", oHomo, true);
		if(ok)
			ok = UpdateTable("^persfile", oPers, true);
		
		//расширения
		if(toScrObj(FIS_EXT.value))
		{
			var tblRecExt = OpenTable("select * from ^cl_ext where Fclass="+sqlTo("CL."+getPar("CODPERS")))
			if(tblRecExt.rowCount == 0)
			{
				alert(ru("Не найдены расширения справочника аналитики "+getPar("CODPERS")+" в базе-приемнике!",
					+"Не знайдено розширення довідника аналітики "+getPar("CODPERS")+" в базі-приймачі!"))
				ok = false;
			}
			var oClExt =  new DpClEx("CL3", getPar("CODPERS"));
			for(; !tblRecExt.IsEOF(); tblRecExt.MoveNext())
			{
				var lbl = tblRecExt.getValue("Flabel");
				var snap = getSnap("select F"+lbl+" from "+tblPref+"cl_"+FCL.value+" where Fmainwid="+Fwid_old);
				if(snap)
				{
					oClExt.clear();
					oClExt.loadByID(Fwid_new);
					oClExt.setExt(lbl,snap[0]);
					oClExt.saveExtToDB();
				}
				else
				{
					WAIT(ru("Не найдено значение расширения "+lbl+" в базе-источнике для записи с идентификатором "+Fwid_old,
							"Не знайдено значення розширення "+lbl+" в базі-джерелі для запису з ідентифікатором "+Fwid_old));
//					ok = false;
//					break;
				}
			}
			tblRecExt.close();
		}
		
		//статистика
		if(toScrObj(FIS_STAT.value))
		{
			if(ok)
			{
				var flds = GetPatternIntersection("SRED_INI","SRED_INI");
				flds = flds.replace(/(fwid\s*,)|(,\s*fwid\s*$)/gi,"");
				flds = flds.replace(/(ftabn\s*,)|(,\s*ftabn\s*$)/gi,"");
				flds = flds.replace(/(ftabn_id\s*,)|(,\s*ftabn_id\s*$)/gi,"");
				ok = ExecuteSQL("insert into ^sred_ini ("+flds+", Ftabn_id) "
						+" select "+flds+", "+Fwid_new+" as Ftabn_id "
						+" from "+tblPref+"zrp_sred_ini where Ftabn_id="+Fwid_old);
			}
			if(ok)
			{
				var tbl = OpenTable("select * from "+tblPref+"zrp_time_otp where Ftabn_id="+Fwid_old);
				for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
				{
					if(!ok)
						break;
					var m = scatter(tbl);
					delete(m.FTABN);
					m.FWID = GetUID();
					m.FTABN_ID = Fwid_new;
					ok = UpdateTable("^time_otp", m, true);
				}
				tbl.close();
			}
			if(ok)
			{
				var tbl = OpenTable("select * from "+tblPref+"zrp_time_wr2 where Ftabn_id="+Fwid_old);
				for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
				{
					if(!ok)
						break;
					var m = scatter(tbl);
					delete(m.FTABN);
					m.FWID = GetUID();
					m.FTABN_ID = Fwid_new;
					ok = UpdateTable("^time_wr2", m, true);
				}
				tbl.close();
			}
			if(ok)
			{
				var tbl = OpenTable("select * from "+tblPref+"zrp_time_go where Ftabn_id="+Fwid_old);
				for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
				{
					if(!ok)
						break;
					var m = scatter(tbl);
					delete(m.FTABN);
					m.FWID = GetUID();
					m.FTABN_ID = Fwid_new;
					ok = UpdateTable("^time_go", m, true);
				}
				tbl.close();
			}
			if(ok)
			{
				var tbl = OpenTable("select * from "+tblPref+"zrp_time_kl where Ftabn_id="+Fwid_old);
				for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
				{
					if(!ok)
						break;
					var m = scatter(tbl);
					delete(m.FTABN);
					m.FWID = GetUID();
					m.FTABN_ID = Fwid_new;
					ok = UpdateTable("^time_kl", m, true);
				}
				tbl.close();
			}
			if(ok)
			{
				var tbl = OpenTable("select * from "+tblPref+"zrp_wt_lbl_pr where Ftabn_id="+Fwid_old);
				for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
				{
					if(!ok)
						break;
					var m = scatter(tbl);
					delete(m.FTABN);
					m.FWID = GetUID();
					m.FTABN_ID = Fwid_new;
					ok = UpdateTable("^wt_lbl_pr", m, true);
				}
				tbl.close();
			}
			if(ok)
			{
				var tbl = OpenTable("select * from "+tblPref+"zrp_wt_lbl_o where Ftabn_id="+Fwid_old);
				for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
				{
					if(!ok)
						break;
					var m = scatter(tbl);
					delete(m.FTABN);
					m.FWID = GetUID();
					m.FTABN_ID = Fwid_new;
					ok = UpdateTable("^wt_lbl_o", m, true);
				}
				tbl.close();
			}
			if(ok)
			{
				var tbl = OpenTable("select * from "+tblPref+"zrp_wt_lbl_b where Ftabn_id="+Fwid_old);
				for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
				{
					if(!ok)
						break;
					var m = scatter(tbl);
					delete(m.FTABN);
					m.FWID = GetUID();
					m.FTABN_ID = Fwid_new;
					ok = UpdateTable("^wt_lbl_b", m, true);
				}
				tbl.close();
			}
			if(ok)
			{
				var flds = GetPatternIntersection("PRK_FMPL","PRK_FMPL");
				flds = flds.replace(/(fwid\s*,)|(,\s*fwid\s*$)/gi,"");
				flds = flds.replace(/(ftabn_id\s*,)|(,\s*ftabn_id\s*$)/gi,"");
				ok = ExecuteSQL("insert into ^prk_fmpl ("+flds+", Ftabn_id) "
						+" select "+flds+", "+Fwid_new+" as Ftabn_id "
						+" from "+tblPref+"zrp_prk_fmpl where Ftabn_id="+Fwid_old);
			}
		}
		//штатное расписание
		if(Number(FSHTAT.value) == 2)
		{
			//при вызове диалоговых окон, закрываем прогресс
			setProgressPos(0);
			var form = createForm(Fio+" таб.№"+Fcod_new+(Fcod_new==Fcod_old?"":"("+Fcod_old+")"))
			var oPodr = form.addPodr(true,today);
			form.show();
			if(!form.escape)
			{
				var par = new Object();
				var param = new Object();
				param.fwid_podr = oPodr.getID();
				param.fwid_old = Fwid_old;
				param.fwid_new = Fwid_new;
				xmlForm = "e_prk_zrp_in.xml";
				par.mode = "ADD";
				par.tblPref = tblPref;
				par.param = param;
				showWindow(xmlForm, SW_MODAL, par);
				if(par.escape)
					ok = false;
			}
			else
				ok = false;
			setProgressPos(t.bookmark, ru("Импорт сотрудников ","Імопрт співробітників ")+t.bookmark+"/"+t.rowCount);
			if(ok && toScrObj(FIS_UV.value))
			{
				if(!par.bdat || differ(par.bdat,d00)==0)
				{
					alert(ru("Не удалось уволить "+Fio+" таб.№"+Fcod_new+(Fcod_new==Fcod_old?"":"("+Fcod_old+")")+" из штатного расписания базы-источника!\nНе определена дата увольнения.",
							"Не вдалося звільнити "+Fio+" таб.№"+Fcod_new+(Fcod_new==Fcod_old?"":"("+Fcod_old+")")+" з штатного розкладу бази-джерела!\nНе визначена дата звыльнення."));
					ok = false;
				}
				else
				{
					var dat_uv = goDay(par.bdat,-1);
            		if(!uvolFromSrc(Fwid_old,dat_uv))
            		{
            			alert(ru("Возникла ошибка при попытке увольнения "+Fio+" таб.№"+Fcod_new+(Fcod_new==Fcod_old?"":"("+Fcod_old+")")+" из базы-источника!",
            					"Виникла помилка при спробі звільнення "+Fio+" таб.№"+Fcod_new+(Fcod_new==Fcod_old?"":"("+Fcod_old+")")+" з бази-джерела!"));
            			ok = false;
            		}
				}
			}
		}
		if(ok)
		{
			CommitTrans();
			k++;
			//формируем массив Fwid-ов для массового добавления в ШР и для увольнения из базы-источника
			if(Number(FSHTAT.value)!=0)
			{
				var j = fwidAr.length;
				fwidAr[j] = new Array();
				fwidAr[j]["fwid"] = Fwid_new;
				fwidAr[j]["fwid_old"] = Fwid_old;
			}
		}
		else
			RollbackTrans();
		
		clrelTbl.close();
		clTbl.close();
		homoTbl.close();
		persTbl.close();
	}
	setProgressPos(0);
	t.close();
	//массовое добавление в штатное расписание
	if(ok && Number(FSHTAT.value)==1)
	{
		var form = createForm(ru("Укажите подразделение для импорта","Вкажіть підрозділ для імпорту"))
		var oPodr = form.addPodr(true,today);
		form.show();
		if(!form.escape)
		{
			BeginTransaction();
			var par = new Object();
			var param = new Object();
			param.fwid_podr = oPodr.getID();
			xmlForm = "e_prk_zrp_in.xml";
			par.mode = "MASS_ADD";
			par.retArray = fwidAr;
			par.param = param;
			showWindow(xmlForm, SW_MODAL, par);
			ok = !par.escape;
			if(ok)
				CommitTrans();
			else
			{
				RollbackTrans();
				alert(ru("Не удалось добавить сотрудников в штатное расписание!",
						"Не вдалося додати співробітників в штатний розклад!"));
			}
			//увольняем сотрудников в базе-источнике
			if(ok && toScrObj(FIS_UV.value))
			{
				if(!par.bdat || differ(par.bdat,d00)==0)
				{
					alert(ru("Не удалось уволить сотрудников из штатного расписания базы-источника!\nНе определена дата увольнения.",
							"Не вдалося звільнити співробітників з штатного розкладу бази-джерела!\nНе визначена дата звыльнення."));
				}
				else
				{
					BeginTransaction();
					var dat_uv = goDay(par.bdat,-1);
					setProgressRange(1, fwidAr.length);
					for(var i=0; i<fwidAr.length; i++)
					{
						setProgressPos(i+1, ru("Увольнение сотрудников из базы-источника ","Звільнення співробітників за бази-джерела ")+(i+1)+"/"+fwidAr.length);
						if(ok)
						{
							for(var j in fwidAr[i])
							{
								if(j=="fwid_old")
			                	{
			                		if(!uvolFromSrc(fwidAr[i][j],dat_uv))
			                		{
			                			alert(ru("Возникла ошибка при попытке увольнения сотрудника из базы-источника!",
			                					"Виникла помилка при спробі звільнення працівника з бази-джерела!"));
			                			ok = false;
			                		}
								}
							}
						}
						else
							break;
					}
					setProgressPos(0);
					if(ok)
						CommitTrans();
					else
					{
						RollbackTrans();
						alert(ru("Не удалось уволить сотрудников из базы-источника!",
								"Не вдалося звільнити співробітників за бази-джерела!"));
					}
				}
			}
		}
	}
	if(!confirm(ru("Импорт окончен. Кол-во импортированных сотрудников: "+k+"\nЖелаете еще импортировать сотрудников?",
				"Іморт завершено. Кіл-сть імпортованих співробітників: "+k+"\nБажаєте ще імпортувати співробітників?")))
		CloseWindow();
}

function shtatValid()
{
	if(FSHTAT.value==0)
	{
		//Disable(FDAT_IMP);
		Disable(FIS_UV);
	}
	else
	{
		//Enable(FDAT_IMP);
		Enable(FIS_UV);
	}
	return true;
}

//function dat_impValid()
//{
//	if(differ(FDAT_IMP.value,d00)==0)
//	{
//		WAIT(ru("Укажите дату.","Вкажіть дату."));
//		setFocus(FDAT_IMP);
//		return false;
//	}
//	return true;
//}

function gridEdit(modeID)
{
	if(modeID=="COPY" || modeID=="ADD")
		return false;
	return true;
}

function codStartValid(oCtrl)
{
	if(isExistTabn(oCtrl.getValue()))
	{
		DropTable("buf_tbl_tabn");
		ExecuteSQL("select Fcod into buf_tbl_tabn from ^clrelclcl where Fcl="+getPar("CODPERS"));
		ExecuteSQL("insert into buf_tbl_tabn(Fcod) select Fcod_new from "+tblName
				+" where not exists(select Fcod from buf_tbl_tabn as b where b.Fcod="+tblName+".Fcod_new) ");
		//ищем минимальный свободный табельный номер
		var snap = getSnap("select MIN(Fcod)+1 from ^clrelclcl where Fcl="+getPar("CODPERS")
					+" and not exists (select Fcod from buf_tbl_tabn as b where b.Fcod=^clrelclcl.Fcod+1)");
		if(snap && snap[0])
			oCtrl.setValue(snap[0]);
	}
	return true;
}

function codSaveValid(oCtrl)
{
	if(oCtrl.getValue()==0)
	{
		WAIT(ru("Нулевой номер не допустим!",
				"Нульовий номер не допустимо!"))
		DropTable("buf_tbl_tabn");
		ExecuteSQL("select Fcod into buf_tbl_tabn from ^clrelclcl where Fcl="+getPar("CODPERS"));
		ExecuteSQL("insert into buf_tbl_tabn(Fcod) select Fcod_new from "+tblName
				+" where not exists(select Fcod from buf_tbl_tabn as b where b.Fcod="+tblName+".Fcod_new) ");
		//ищем минимальный свободный табельный номер
		var snap = getSnap("select MIN(Fcod)+1 from ^clrelclcl where Fcl="+getPar("CODPERS")
					+" and not exists (select Fcod from buf_tbl_tabn as b where b.Fcod=^clrelclcl.Fcod+1)");
		if(snap && snap[0])
			oCtrl.setValue(snap[0]);
		return true;
	}
	if(isExistTabn(oCtrl.getValue()))
	{
		WAIT(ru("Сотрудник с табельным номером "+oCtrl.getValue()+" уже существует в базе-приемнике!",
				"Співробітник з тебельним номером "+oCtrl.getValue()+" вже існує в базі-приймачі!"))
		return false;
	}
	if(isExistTabn(oCtrl.getValue(),true,list.tbl.getValue("Fwid")))
	{
		WAIT(ru("Табельный номер "+oCtrl.getValue()+" уже зарезервирован для базы-приемника!",
				"Табельний номер "+oCtrl.getValue()+" вже зарезервовано для бази-приймача!"))
		return false;
	}
	return true;
}

function isExistTabn(tabn,serchNew,fwid)
{
	if(serchNew==true)
		var snap = getSnap("select Fcod_new from "+tblName+" where Fcod_new="+tabn+(fwid?" and Fwid<>"+fwid:""));
	else
		var snap = getSnap("select Fcod from ^clrelclcl where Fcl="+getPar("CODPERS")+" and Fcod="+tabn);
	if(snap && snap[0])
		return true;
	else
		return false;
}

function comparFields(ptrn,tblSrcName)
{
	var recFields = GetPatternIntersection(ptrn,ptrn).split(",");
	var srcFields = new Array();
	var tbl = OpenTable("select * from "+tblSrcName);
	var listSrcFields = tbl.getFieldsInfo();
	tbl.close();
	for(var i = 0; i < listSrcFields.length; i++)
		srcFields[i] = String(listSrcFields[i].getName()).toUpperCase();
	var recLng = recFields.length;
	var srcLng = srcFields.length;
	var notExistsFields = new Array();
	if(recLng>srcLng)
	{
		for(var i = 0; i < recLng; i++)
		{
			if(!srcFields.some( function(item){ return item==recFields[i]} ))
				notExistsFields[notExistsFields.length] = recFields[i];
		}
		if(notExistsFields.length>0)
		{
			alert(ru("В таблице "+ptrn+" базы-источника отсутствуют следующие поля:\n"+notExistsFields+"\nОтмодифицируйте эту таблицу в обеих базах к одной версии.",
					"В таблиці "+ptrn+" бази-джерела відсутні наступні поля:\n"+notExistsFields+"\nВідмодифікуйте цю таблицю в обидвах базах до єдиної версії."));
			return false;
		}
	}
	else
	{
		for(var i = 0; i < srcLng; i++)
		{
			if(!recFields.some( function(item){ return item==srcFields[i]} ))
				notExistsFields[notExistsFields.length] = srcFields[i];
		}
		if(notExistsFields.length>0)
		{
			alert(ru("В таблице "+ptrn+" базы-приемника отсутствуют следующие поля:\n"+notExistsFields+"\nОтмодифицируйте эту таблицу в обеих базах к одной версии.",
					"В таблиці "+ptrn+" бази-приймача відсутні наступні поля:\n"+notExistsFields+"\nВідмодифікуйте цю таблицю в обидвах базах до єдиної версії."));
			return false;
		}
	}
	return true;
}

function comparExt()
{
	var oExt = new DpExtentionBuilder("CL",String(getPar("CODPERS")),null);
	var tblRecExt = OpenTable("select * from ^cl_ext where Fclass="+sqlTo("CL."+getPar("CODPERS")))
	if(tblRecExt.rowCount==0)
	{
		alert(ru("Не найдены расширения справочника аналитики "+getPar("CODPERS")+" в базе-приемнике!",
			+"Не знайдено розширення довідника аналітики "+getPar("CODPERS")+" в базі-приймачі!"))
		return false;
	}
	var tblSrcExt = OpenTable("select * from "+tblPref+"com_cl_ext where Fclass="+sqlTo("CL."+FCL.value))
	if(tblSrcExt.rowCount==0)
	{
		alert(ru("Не найдены расширения справочника аналитики "+FCL.value+" в базе-источнике!",
				+"Не знайдено розширення довідника аналітики "+FCL.value+" в базі-джерелі!"))
		return false;
	}
	var recExt = new Array();
	for(; !tblRecExt.IsEOF(); tblRecExt.MoveNext())
		recExt[recExt.length] = tblRecExt.getValue("Flabel").toUpperCase();
	tblRecExt.close();

	var srcExt = new Array();
	for(; !tblSrcExt.IsEOF(); tblSrcExt.MoveNext())
		srcExt[srcExt.length] = tblSrcExt.getValue("Flabel").toUpperCase();
	tblSrcExt.close();
	
	var recLng = recExt.length;
	var srcLng = srcExt.length;
	var notExistsExt = new Array();
//	if(recLng>srcLng)
//	{
//		for(var i = 0; i < recLng; i++)
//		{
//			if(!srcExt.some( function(item){ return item==recExt[i]} ))
//				notExistsExt[notExistsExt.length] = recExt[i];
//		}
//		if(notExistsExt.length>0)
//		{
//			alert(ru("� ����������� ��������� "+FCL.value+" ����-��������� ����������� ��������� ����������:\n"+notExistsExt+"\n������� ������������ � ����������� ��������� "+getPar("CODPERS")+" ����-���������.",
//					"� �������� �������� "+FCL.value+" ����-������� ������ ������� ����������:\n"+notExistsExt+"\n���� � � �������� � �������� ��������"+getPar("CODPERS")+" ����-��������."));
//			return false;
//		}
//	}
//	else
//	{
	if(recLng>srcLng)
	{
		for(var i = 0; i < recLng; i++)
		{
			if(!srcExt.some( function(item){ return item==recExt[i]} ))
				notExistsExt[notExistsExt.length] = recExt[i];
		}
		if(notExistsExt.length>0)
		{
			alert(ru("В справочнике аналитики "+FCL.value+" базы-источника отсутствуют следующие расширения:\n"+notExistsExt+"\nкоторые присутствуют в справочнике аналитики "+getPar("CODPERS")+" базы-приемника.",
					"В довіднику аналітики "+FCL.value+" бази-джерела відсутні наступні розширення:\n"+notExistsExt+"\nкотрі є в наявності в довіднику аналітики"+getPar("CODPERS")+" бази-приймача."));
			return false;
		}
	}
	else
	{
		for(var i = 0; i < srcLng; i++)
		{
			if(!recExt.some( function(item){ return item==srcExt[i]} ))
				notExistsExt[notExistsExt.length] = srcExt[i];
		}
		if(notExistsExt.length>0)
		{
			alert(ru("В справочнике аналитики "+getPar("CODPERS")+" базы-приемника отсутствуют следующие расширения:\n"+notExistsExt+"\nкоторые присутствуют в справочнике аналитики "+FCL.value+" базы-источника.",
					"В довіднику аналітики "+getPar("CODPERS")+" бази-приймача відсутні наступні розширення:\n"+notExistsExt+"\nкотрі є в наявності в довіднику аналітики"+FCL.value+" бази-джерела."));
			return false;
		}
	}
	return true;
}

function uvolFromSrc(fwid,dat)
{
	var snap = getSnap("select Fwid,Fwid_dol from "+tblPref+"cdr_work_pers where Fwid_cl="+fwid+" and Fedat="+sqlTo(d00));
	if(snap && snap[0])
	{
		var m = new Object();
		m.FIS_UV = true;
		m.FEDAT = dat;
		m.FREASON_UV = ru("Перенос сотрудников в другую базу данных: ","Перенесення співробітників в іншу базу даних: ")+getPath("CL_MDB");
		if(!UpdateTable(tblPref+"cdr_work_pers", m, false, "Fwid="+snap[0]))
			return false;
		
		var m = new Object();
		m.FEDAT = dat;
		return UpdateTable(tblPref+"cdr_stru_dol", m, false, "Fwid="+snap[1]);
	}
	return true;
}