include("l_eprkekz.js");
include("Objects/DpShtat.js");
include("Objects/DpCl.js");
include("Objects/DpSbcs.js");

var oShtat, oPlace, oSbcs;
var clTrPl = getPar("CAS_TRPLACE");
var clTrType = getPar("CAS_TRTYPE");
var clPers = getPar("CODPERS");
var saveTabn;

function prkLoad()
{
	HPROC.setMask("###.##");
	HSUM.setMask(MASK_SUM);
	HNUM.setMask(replicate("&", 12));
	HSHPZ.setMask("&&&&&&&&&&&&&&&");
		
	dpShifPZ = new DpShifPZ();
	dpShifPZ.linkCtrl(HSHPZ, HSHPZ_TXT);
	
	//Объект штатного
	oShtat = new DpShtat("", extPar.dat1, extPar.dat2);
	oShtat.linkCtrl("FCOD", HTABN);
	oShtat.linkCtrl("WCL.FTXT", HTABN_TXT); 
 	
	//Объект места перечислений
	oPlace = new DpCl("");
	oPlace.setClcl(clTrPl);
	oPlace.linkSmartCtrl(HTPLACE);
	oPlace.addListCondition(listCondTabn);
	
	//Объект сберегательной кассы
	oSbcs = new DpSbcs();
	oSbcs.linkCtrl(HSBKSNUM, HSBKSNAME)
 		
	switch (extPar.mode)
	{
		case "ADD":
			HBDAT.setValue(extPar.dat1);			
		break;
		case "EDIT":
		case "COPY":
		case "VIEW":
			//достанем значения из таблицы ^PRK_AL
			strSQL = ("SELECT FTABN, FWIDTR"
						+" FROM "+extPar.tblName
						+" WHERE FWID = "+sqlTo(table.getValue("FWID")));
			var sn = getSnap(strSQL);
			if(sn)
			{
				//Tori 01.06.2010: код устанавливать нельзя, т.к. за период в ШР могут быть несколько записей по данному коду
				//oShtat.setCod(sn[0]);
				oShtat.setFwid(table.getValue("FWID_WP"));
				oPlace.setCod(getClcodByID(clTrPl, sn[1]));
			}
			sn = null;
			
			saveTabn = oShtat.getCod();
			
			HBDAT.setValue(table.getValue("FBDAT"));
			HEDAT.setValue(table.getValue("FEDAT"));
			HPROC.setValue(table.getValue("FPROC"));
			HSUM.setValue(table.getValue("FSUM"));
			HNUM.setValue(table.getValue("FNUM"));
			
			//Обновим контролы места перечисления и сберкассы
			HTPLACE_Valid();			
		break;
	}	
	HPROC_Valid();
	HSUM_Valid();
	
	setValid(HBDAT, DAT_Valid);
	setValid(HTABN, HTABN_Valid);
	setValid(HPROC, HPROC_Valid);
	setValid(HTPLACE, HTPLACE_Valid);
	setValid(HSUM, HSUM_Valid);	
	
	Disable(HSBKSNUM);
	Disable(HSBKSNAME);
	Disable(HLICSCH);
	Disable(HTRTYPE);
	Disable(HFIO);
	Disable(HADDR);
	setFocus(HTABN);
}
function prkSave(m)
{	
	var arrParPlace = getParPlace(oPlace.getCod());
	m.FBDAT = HBDAT.getValue();
	m.FEDAT = HEDAT.getValue();
	m.FPROC = HPROC.getValue();
	m.FSUM = HSUM.getValue();
	m.FNUM = HNUM.getValue();
	m.FTABN = oShtat.getCod();//getClcodByID(clPers, oShtat.getEmployeFwid());
	m.FSHT_ID = oShtat.getFwid();
	m.FWIDTR = (arrParPlace ? arrParPlace[4] : 0);
	m.FVID_PRK = extPar.fvid;
	m.FSHPZ = dpShifPZ.getFshpz();
	
	//для таблицы PRK_ALL
	m.FIN_TABLE = extPar.sTableName;
	m.FTABN_ID = oShtat.getEmployeFwid();
	m.FWID_PRIK = extPar.fwid;
	
	arrParPlace = null;
}

function DAT_Valid()
{
	var bdat = javaDate2Script(HBDAT.getValue());
	var edat = javaDate2Script(HEDAT.getValue());
	var ret = true;
	
	if(differ(bdat, d00obj) == 0)
	{
		HBDAT.showErr(ru("Пустое значение не допустимо!"
						, "Порожнє значення не можливе!"));
		ret = false;
	}	
	else
	{
		oShtat.setPeriod(bdat, edat);
	}
	return ret;	
}

function HPROC_Valid()
{
	var proc = Number(HPROC.getValue());
	
	if(!isEmpty(proc))
	{
		//если ввели процент то суммы быть не должно
		HSUM.setValue(0);
		Disable(HSUM);
	}
	else
	{
		Enable(HSUM);
	}
	return true;	
}

function HSUM_Valid()
{
	var sum = Number(HSUM.getValue());
	var proc = Number(HPROC.getValue());
	var ret = true;
	
	if(!isEmpty(sum))
	{
		//если ввели сумму то процента быть не должно
		HPROC.setValue(0);
		Disable(HPROC);
	}
	else
	{
		Enable(HPROC);
	}
	
	if(isEmpty(sum+proc))
	{
		HPROC.showErr(ru("Введите процент или сумму удержания!"
								, "Введіть відсоток або суму утримання!"));
		//Tori 02.06.2010: из-за оттянутого фокуса срабатывает валидность табельного номера при добавлении и сразу идет завал в ШР
		//setFocus(HPROC);
		ret = false;
	}
	return ret;
}

function HTABN_Valid()
{
	var ret = false;
	
	//если произошло изменение в контроле HTABN обнуляем контрол мест перечислений
	if(!isSaving() && saveTabn != oShtat.getCod())
	{
		oPlace.setCod(0);
		saveTabn = oShtat.getCod();
	}
	
	if(oShtat.validCtrl())
	{
		ret = true;	
	}
	
	return ret;
}

function HTPLACE_Valid()
{
	//Установим значения в контролы места перечисления
	var arrPar = getParPlace(oPlace.getCod());
	
	if(arrPar)
	{
		oSbcs.setCod(arrPar[0]);
		HLICSCH.setValue(arrPar[1]);
		HTRTYPE.setValue(tcl("CL", "", clTrType, arrPar[2]));
		HFIO.setValue(arrPar[3]);	
		HADDR.setValue(arrPar[5]);	
	}
	arrPar =  null;
	return true;	
}	

/*    Функция getParPlace
	возвращает масив с значениями места перечисления по заданому коду  
	0. № сберкассы
	1. № лиц счета
	2. код типа перечислений
	3. ФИО получателя
	4. FWID
	5. Адрес
*/
function getParPlace(codPlace)
{
	strSQL = "SELECT"
			+" TRPL.FNUMSB"
			+", TRPL.FLICSCH" 
			+", TRPL.FTRTYPE"
			+", TRPL.FFIO"
			+", REL.FWID_CL"
			+", TRPL.FADDR"
		+" FROM ^CLRELCLCL REL INNER JOIN ^CL_TRPLACE TRPL ON REL.FWID_CL = TRPL.FWID_CL"
		+" WHERE 1=1"
			+" AND REL.FCL = "+sqlTo(clTrPl)
			+" AND REL.FCOD = "+sqlTo(codPlace)	
	return getSnap(strSQL);
}

function listCondTabn()
{
	//условия для отбора только тех мест перечислений
	//которы связаны с выбраным табельным номером
	var strSQL = "SELECT REL1.FWID_CL"
			+" FROM ^CLRELCLCL REL1"
				+", ^CL_TRPLACE TRPL"
			+" WHERE 1=1"
				+" AND REL1.FWID_CL = TRPL.FWID_CL"
				+" AND REL1.FCL = "+sqlTo(clTrPl)
				+" AND TRPL.FTABN IN(SELECT REL2.FCOD"
									+" FROM ^CLRELCLCL REL2"
									+" WHERE 1=1"
										+" AND REL2.FWID_CL = "+sqlTo(oShtat.getEmployeFwid())
										+" AND REL2.FCL = "+sqlTo(clPers)
									+")"
	return "FWID_CL IN("+strSQL+")";
}