include("l_eprkekz.js");
include("Objects/DpShtat.js");
include("Objects/DpCl.js");
include("Objects/DpSbcs.js");

var oShtat, oPlace, oSbcs;
var clTrPl = getPar("CAS_TRPLACE");
var clTrType = getPar("CAS_TRTYPE");
var clPers = getPar("CODPERS");
var saveTabn;

function prkLoad()
{
	HPROC.setMask("###.##");
			
	//Объект штатного
	oShtat = new DpShtat("", extPar.dat1, extPar.dat2);
 	oShtat.linkCtrl("FCOD", HTABN);
 	oShtat.linkCtrl("WCL.FTXT", HTABN_TXT); 
 	
	//Объект места перечислений
	oPlace = new DpCl("");
	oPlace.setClcl(clTrPl);
	oPlace.linkSmartCtrl(HTPLACE);
	oPlace.addListCondition(listCondTabn);
	
	//Объект сберегательной кассы
	oSbcs = new DpSbcs();
	oSbcs.linkCtrl(HSBKSNUM, HSBKSNAME)
 		
	switch (extPar.mode)
	{
		case "ADD":
			HBDAT.setValue(extPar.dat1);
			HEDAT.setValue(extPar.dat2);
			HPROC.setValue(100);
		break;
		case "EDIT":
		case "COPY":
		case "VIEW":
			//достанем значения из таблицы ^CAS_TR_PR
			strSQL = ("SELECT"
						+" FTABN"
						+", FWIDTR"
					+" FROM "+extPar.tblName
					+" WHERE FWID = "+sqlTo(table.getValue("FWID")));
			var sn = getSnap(strSQL);
			if(sn)
			{
				oShtat.setCod(sn[0]);
				oPlace.setCod(getClcodByID(clTrPl, sn[1]));
			}
			sn = null;
			
			saveTabn = oShtat.getCod();
			
			HBDAT.setValue(table.getValue("FBDAT"));
			HEDAT.setValue(table.getValue("FEDAT"));
			HPROC.setValue(table.getValue("FPROC"));
			
			//Обновим контролы места перечисления
			HTPLACE_Valid();			
		break;
	}	
	setValid(HBDAT, DAT_Valid);
	setValid(HTABN, HTABN_Valid);
	setValid(HPROC, HPROC_Valid);
	setValid(HTPLACE, HTPLACE_Valid);
	
	Disable(HSBKSNUM);
	Disable(HSBKSNAME);
	Disable(HLICSCH);
	Disable(HTRTYPE);
	Disable(HFIO);
	setFocus(HTABN);
}
function prkSave(m)
{	
	var arrParPlace = getParPlace(oPlace.getCod());
	m.FBDAT = HBDAT.getValue();
	m.FEDAT = HEDAT.getValue();
	m.FPROC = HPROC.getValue();
	m.FTABN = getClcodByID(clPers, oShtat.getEmployeFwid());
	m.FWID_WP = oShtat.getFwid();
	m.FWIDTR = (arrParPlace ? arrParPlace[4] : 0);
	m.FVID_PRK = extPar.fvid;
	
	//для таблицы PRK_ALL
	m.FIN_TABLE = extPar.sTableName;
	m.FTABN_ID = oShtat.getEmployeFwid();
	m.FWID_PRIK = extPar.fwid;
	arrParPlace = null;
}

function DAT_Valid()
{
	var bdat = javaDate2Script(HBDAT.getValue());
	var edat = javaDate2Script(HEDAT.getValue());
	var ret = true;
	
	if(differ(bdat, d00obj) == 0)
	{
		HBDAT.showErr(ru("Пустое значение не допустимо!"
						, "Порожнє значення не можливе!"));
		ret = false;
	}
	else
	{
		oShtat.setPeriod(bdat, edat);
	}
	return ret;	
}

function HPROC_Valid()
{
	var proc = Number(HPROC.getValue());
	var ret = true;
	
	if(isEmpty(proc))
	{
		HPROC.showErr(ru("Пустое значение не допустимо!"
						, "Порожнє значення не можливе!"));
		ret = false;
	}	
	return ret;	
}

function HTABN_Valid()
{
	var ret = false;
	
	//если произошло изменение в контроле HTABN обнуляем контрол мест перечислений
	if(!isSaving() && saveTabn != oShtat.getCod())
	{
		oPlace.setCod(0);
		saveTabn = oShtat.getCod();
	}
	
	if(oShtat.validCtrl())
	{
		ret = true;	
	}
	
	return ret;
}

function HTPLACE_Valid()
{
	//Установим значения в контролы места перечисления
	var arrPar = getParPlace(oPlace.getCod());
	
	if(arrPar)
	{
		oSbcs.setCod(arrPar[0]);
		HLICSCH.setValue(arrPar[1]);
		HTRTYPE.setValue(tcl("CL", "", clTrType, arrPar[2]));
		HFIO.setValue(arrPar[3]);	
	}
	arrPar =  null;
	return true;	
}	

/*    Функция getParPlace
	возвращает масив с значениями места перечисления по заданому коду  
	0. № сберкассы
	1. № лиц счета
	2. код типа перечислений
	3. ФИО получателя
	4. FWID
*/
function getParPlace(codPlace)
{
	strSQL = "SELECT"
			+" TRPL.FNUMSB"
			+", TRPL.FLICSCH" 
			+", TRPL.FTRTYPE"
			+", TRPL.FFIO"
			+", REL.FWID_CL"
		+" FROM ^CLRELCLCL REL INNER JOIN ^CL_TRPLACE TRPL ON REL.FWID_CL = TRPL.FWID_CL"
		+" WHERE 1=1"
			+" AND REL.FCL = "+sqlTo(clTrPl)
			+" AND REL.FCOD = "+sqlTo(codPlace)	
	return getSnap(strSQL);
}

function listCondTabn()
{
	//условия для отбора только тех мест перечислений
	//которы связаны с конкрытным табельным номером
	var strSQL = "SELECT REL1.FWID_CL"
			+" FROM ^CLRELCLCL REL1"
				+", ^CL_TRPLACE TRPL"
			+" WHERE 1=1"
				+" AND REL1.FWID_CL = TRPL.FWID_CL"
				+" AND REL1.FCL = "+sqlTo(clTrPl)
				+" AND TRPL.FTABN IN(SELECT REL2.FCOD"
									+" FROM ^CLRELCLCL REL2"
									+" WHERE 1=1"
										+" AND REL2.FWID_CL = "+sqlTo(oShtat.getEmployeFwid())
										+" AND REL2.FCL = "+sqlTo(clPers)
									+")"
	return "FWID_CL IN("+strSQL+")";
}