include("Objects/DpShtat.js");
include("Objects/DpShifPZ.js");
include("add_sotr.js");
include("get_const.js");
include("doc/DpDoc.js");
include("prik/DpPrik.js");

var tblName = extPar.global.tblname;
var tblISP = extPar.global.tblisp;
var dpShifPZ = null;
var table = null;

function onLoad()
{
	Caption(extPar.title, extPar.mode);

	table = extPar.m_pTable;

	dpShifPZ = new DpShifPZ();
	dpShifPZ.linkCtrl(HSHPZ, HSHPZ_TXT);

	HSUM.setMask("######.##");
	HNAR.setMask("######");
	HSHPZ.setMask("&&&&&&&&&&&&&&&");
	
	if (!extPar.mode)
		extPar.mode = "ADD";
	
	switch (extPar.mode)
	{
		case "ADD":
			HBDAT.value = d00;
			HDAT_ZAKR.value = d00;
			HSUM.value = 0;
			HNAR.value = 0;
			dpShifPZ.setFshpz(0);
		break;
		case "EDIT":
		case "COPY":
		case "VIEW":
			HBDAT.value = table.getValue("fbdat");
			HDAT_ZAKR.value = table.getValue("fdat_zakr");
			HSUM.value = table.getValue("fsum");
			HNAR.value = table.getValue("fnar");
			dpShifPZ.setFshpz(table.getValue("fshpz"));
		break;	
	}
	
	setValid(HBDAT, Fbdat_Valid);
	setValid(HDAT_ZAKR, Fdat_zakr_Valid);
	setFocus(HNAR);
}

function onSave()
{
	var sotrList = "";
	if (extPar.sMode != "EDIT")
		sotrList = AddSotrPrk(HBDAT.value, HDAT_ZAKR.value);
	if (sotrList == "")
		return false;	
	
	var hpz = dpShifPZ.getFshpz();	
	var zat = 0;	
	var strSQL = "SELECT fan FROM ^lic_fld AS f INNER JOIN ^cl_prik AS p ON f.fid = p.flsfid "
				+ " WHERE p.fvid = " + sqlTo(extPar.fvid);
	var snap = getSnap(strSQL);
	if (snap != null)
		zat = snap[0];
	if (zat != 0)
		//*заменить последнюю цифру из ШПЗ на цифру из поля FAN в LIC_FLD
		hpz = allt(hpz).substring(0, allt(hpz).length - 1) + allt(String(zat));	

	var mFwid;
	var oPrik = new DpPrik(extPar.priklbl, extPar.fvid);
	if(extPar.mode == "EDIT")
		oPrik.loadByID(Number(table.getValue("Fwid")));
	oPrik.setVar("FVID_PRK", extPar.fvid);
	oPrik.setVar("FNAR", HNAR.value);
	oPrik.setVar("FBDAT", HBDAT.value);
	oPrik.setVar("FDAT_ZAKR", HDAT_ZAKR.value);
	oPrik.setVar("FSUM", HSUM.value);
	oPrik.setVar("FSHPZ", hpz);
	oPrik.setVar("FIN_TABLE", tblName.substr(1));
	oPrik.save();
	
	mFwid = oPrik.getID();

	/*var m = Object();
	if (extPar.mode == "EDIT")
		m.FWID = table.getValue("fwid");
	else
		m.FWID = GetUID();
    m.FVID_PRK = extPar.fvid;
    m.FNAR = HNAR.value;
    m.FBDAT = HBDAT.value;
    m.FDAT_ZAKR = HDAT_ZAKR.value;
    m.FSUM = HSUM.value;
    m.FSHPZ = hpz;

    updateTable(tblName, m, extPar.mode != "EDIT");*/
	// BEGIN >> Сохранение приказов в XML 
	var mFproc = get_cnst("proc_pr", HBDAT.value);

	/*var strSQL = "SELECT fwid_cl, fwid FROM ^work_pers WHERE fwid IN (" + sotrList + ")";
	var tmpTable = OpenTable("s", strSQL);
	if(!tmpTable.isEmpty())
	{
		var objDoc = new DpDoc("com.debet.cdr.pf", 0);
		for(tmpTable.MoveFirst(); !tmpTable.isEOF(); tmpTable.MoveNext())
		{
			objDoc.clear();
			objDoc.loadByID(tmpTable.getValue("fwid_cl"));
			var objPrk = objDoc.createPrk();
			objPrk.setID(HNOM_PRIK.value);
			objPrk.setAttribute("ID", HNOM_PRIK.value);
			objPrk.setAttribute("dat_prk", StrDat(HDAT_PRIK.value, "DMY"));
			objPrk.setAttribute("vid", extPar.fvid);
			objPrk.setAttribute("bdat", StrDat(HBDAT.value, "DMY"));
			objPrk.setAttribute("edat", StrDat(HDAT_ZAKR.value, "DMY"));
			objPrk.setAttribute("ktu", 1);
			objPrk.setAttribute("proc_prem", mFproc);
			objPrk.setAttribute("proc", 100);
			objPrk.setAttribute("prk", tblISP);
			objDoc.addPrk(objPrk, tmpTable.getValue("fwid"));
			objDoc.save();
		}
	}
	// END >> Сохранение приказов в XML*/
		
	strSQL = "INSERT INTO " + tblISP + "(fid, fktu, fproc_prem, fproc, fshpz, fwid_wp)"
		+ " SELECT " //+ sqlTo(extPar.fvid) + " AS fvid_prk"
			+ sqlTo(mFwid) + " AS fid"
//			+ ", " + sqlTo(HBDAT.value) + " AS fbdat"
//			+ ", " + sqlTo(HDAT_ZAKR.value) + " AS fedat"		
			+ ", " + sqlTo(1) + " AS fktu"				
			+ ", " + sqlTo(mFproc) + " AS fproc_prem"
			+ ", " + sqlTo(100) + " AS fproc"
			+ ", " + IIF( zat + "=0"
						, IIF(sqlTo(hpz) + "='0'", "d.fshpz", sqlTo(hpz))
						//, SqlConCat("LEFT(" + IIF(sqlTo(hpz) + "=0", "d.fshpz", sqlTo(hpz))
						//			+ ", LENGTH(" + IIF(sqlTo(hpz) + "=0", "d.fshpz", sqlTo(hpz)) + ")-1)"
						//			, Convert(zat, "STR"))) + " AS fshpz"
						, SqlConCat("SUBSTR(" + IIF(sqlTo(hpz) + "='0'", "d.fshpz", sqlTo(hpz))
									+ ", 0, length(" + IIF(sqlTo(hpz) + "='0'", "d.fshpz", sqlTo(hpz)) + ")-1)"
									, Convert(zat, "STR"))) + " AS fshpz"
			+ ", w.fwid AS fwid_wp"
		+ " FROM ^work_pers AS w RIGHT JOIN ^stru_dol AS d ON w.fwid_dol=d.fwid"
		+ " WHERE w.fwid IN (" + sotrList + ")";			
	ExecuteSQL(strSQL);
}

function Fbdat_Valid()
{
	var result = !isEmpty(HBDAT.value);
	return result;
}

function Fdat_zakr_Valid()
{
	var result = !isEmpty(HDAT_ZAKR.value);
	if(true == result)
	{
		result = 1!= differ(HBDAT.value, HDAT_ZAKR.value);
	}
	
	return result;
}

include("sys\\DpBaseDlg.js");