//используется в паре с приказом _alim20
//расчет сбора подключается отдельной процедурой расчета _sbtr

include("get_const.js");
include("objects/dpCalendar.js");
include("servis/date.js");
// SEV 18.02.2004
// расчет алиментов предполагающий наличие "красного" поля ЛС - "почтовый сбор"
// с отключенным сравнением
// поле FPR в ^SVZPXXXXX не используется.

// SEV 24.03.2005
// добавлена возможность расчета алиментов
// пропорционально датам, заведенным в приказе
// т.е. за количество календарных дней за исключением 
// нерабочих или праздничных

// Теперь при перерасчете сумма почтового сбора за предыдущий месяц
// (месяца) не изменяется при изменении суммы алиментов,
// ведь почтовый сбор уже удержан и уплачен на почте :-)

function name_alim20()
{
	return "Аліменти з урахуванням місць перерахувань|Алименты с учетом мест перечислений"
}
function r_alim20 (mdat, mvvopl, mvvprk, mvvlsfid, mvvdpl, ftabn_id, svzpName)
{	
	var strSQL, str_alert, txt;

	var C9000 = 9000;
	var C8999 = 8999;

	var tbl_prk = new Object();
	var tbl_svzp = new Object();

	var min_zp = get_cnst("min_zp" , mdat);

	var NLG_STSUM = Array(60);
	var NLG_NSM = Array(60);
	var NLG_PROC = Array(60);

	// дата начала
	D1 = firstDay(mdat);
	D2 = lastDay(mdat);
	
	// нужно ли пользоваться календарем
	var bNeedCalend = false;
	
	// Номер календаря, которым будем пользоваться
	var nCalCod = 1000;
	var snap = getSnap("select MIN(Fcod) from ^cl_calend");
	if(snap)
		nCalCod = snap[0];

	var NulDate = new Date(3000,0,1);
	var alim_table=OpenTable("SELECT * FROM ^PROC_AL"
							+" WHERE FBDAT <= " + sqlTo(D2) + " AND FEDAT >= " + sqlTo(D1)
							+" ORDER BY F_STSUM");

	if (alim_table.IsEmpty())
	{
		txt = ru("Справочник ставок пуст. Расчет алиментов не выполнен."
				, "Довідник ставок порожній. Розрахунок аліментів не виконано.");
		writeToLog(txt, "w", mvvopl, mvvprk, mvvlsfid);
		return;
	}

	//* загрузка спр-ка налогов в массив
	alim_table.MoveLast();
	i = 0;

	while ((!alim_table.IsBOF()) && (i<60))
	{
		NLG_STSUM[i] = Number(alim_table.getValue("F_STSUM"));
		NLG_NSM[i]  = Number(alim_table.getValue("F_BASNL"));
		NLG_PROC[i]  = Number(alim_table.getValue("F_PROC"))/100;
		alim_table.MovePrev();
		i = i + 1;
	}
	alim_table.close();
	sch = i;

	DropTable("TMP_PRK_AL");	
	strSQL= "SELECT *"
				+" INTO TMP_PRK_AL"
				+" FROM ^PRK_AL"
				+" WHERE 1=1"
					+" AND FVID_PRK = " + sqlTo(mvvprk)
					+" AND FBDAT <= "+sqlTo(D2)
					+" AND FEDAT >= "+sqlTo(D1)
					+(typeof(ftabn_id) != "undefined" && !isEmpty(ftabn_id) ? " AND FTABN_ID IN("+ftabn_id+")" : "")
	if(mvvopl < C9000)
	{
		strSQL += " AND FVOPL = " + sqlTo(mvvopl)
	}
	strSQL += " ORDER BY FTABN";
	ExecuteSQL(strSQL);	
	
	var m = new Object();
	m.FBDAT = D1;
	var sWhere = "FBDAT < "+sqlTo(D1);
	updateTable("TMP_PRK_AL", m, false, sWhere);
	
	var m = new Object();
	m.FEDAT = D2;
	sWhere = "FEDAT > "+sqlTo(D2);
	updateTable("TMP_PRK_AL", m, false, sWhere);
	
	// подключаем календарь и используем № nCalCod	
	var oCalend = new dpCalendar();
	oCalend.setCod(nCalCod);
	
	if(!oCalend.isCalend("", D1))
	{
		txt = ru("Не заведен календарь № ", "Не заведено календар № ");
		txt += nCalCod;
		txt += " на дату "+d_m_y(D1)+".";
		txt += ru(" Расчет алиментов будет выполнен за весь месяц."
					, " Розрахунок аліментів буде виконано за повний місяць.");
		
		writeToLog(txt, "w", mvvopl, mvvprk, mvvlsfid);		
	}

	// проверяем, нужно ли пользоваться календарем
	strSQL = " SELECT"
				+" MAX(T.FBDAT) AS FBDAT"
				+", MIN(T.FEDAT) AS FEDAT"
			+" FROM TMP_PRK_AL T"
	var s = getSnap(strSQL);
	if(s != null)
	{
		if(oCalend.getCalDays("В|Р", new Date(s[0]), D1) - oCalend.getCalDays("В|Р", new Date(s[1]), D2) != 0)
		{
			bNeedCalend = true;
		}
	}

	tbl_prk = OpenTable("TMP_PRK_AL");	

	if (tbl_prk.IsEmpty())
	{
		tbl_prk.close();
		return;
	}

	strSQL = "SELECT FID, FFLD_NUM" 
				+" FROM ^LIC_FLD"
				+" WHERE 1=1"
					+" AND FIS5 = 'а'"
	var oSn = getSnap(strSQL);
	
	if(oSn && !isEmpty(oSn[0]))
	{
		var nach_lsfid = oSn[0];
		var nach_lsnum = oSn[1];
	}
	else
	{
		txt = ru("Обнаружена серьезная ошибка функционирования системы. "
				, "Виявлена серйозна помилка функціонування системи. ");
		txt += ru("Hевозможно идентифицировать поле ЛС: алименты. "
				, "Hеможливо ідентифікувати поле ОР: аліменти. ");
		txt += ru("Расчет алиментов не выполнен."
				, "Розрахунок аліментів не виконано.");
							
		writeToLog(txt, "e", mvvopl, mvvprk, mvvlsfid);		
		tbl_prk.close();
		return;
	}
	oSn = null;

	var monthtxt=month_txt(mdat);
	var SVZPFILE=(svzpName?svzpName:"svzp")+monthtxt;

	if(!IsTableEx("ZRP_RES", "ZRP_"+SVZPFILE))
	{
		CreateTableEx("ZRP_RES","ZRP_"+SVZPFILE,"SVZP","*");
	}
			
	var max_offset = 12;
	var ssum = new Array(max_offset);
	var ssum_nlg = new Array(max_offset);
	var sum_proc;

//---------------------- полный пересчет --------------------------------

	tbl_prk.MoveFirst();

	while (!tbl_prk.IsEOF())
	{
		// накопление алиментооблагаемой суммы ЗП

		var prew = Number(tbl_prk.getValue("FTABN"));
		var prew_id = Number(tbl_prk.getValue("FTABN_ID"));
		sum_proc=0;

		for (j=0;j<max_offset;++j)
		{
			ssum[j]=0;
			ssum_nlg[j]=0;
		}

		var mn_vip;
		var mn_voz;
		var offset;

		strSQL="SELECT * "
				+"FROM ^"+SVZPFILE
				+" WHERE 1=1"
					+" AND FTABN_ID = "+sqlTo(prew_id)
				+" ORDER BY FLSFID";
		tbl_svzp=OpenTable(strSQL);

		while(!tbl_svzp.IsEOF())
		{
			// поле Fvp=0 если месяц выплаты и если месяц возникн-я равны месяцу файла
			// поле Fvp=1 если месяц выплаты=Fmn, а месяц возникн-я равен месяцу файла
			// поле Fvp=2 если месяц выплаты равен месяцу файла, а месяц возникн-я=Fmn
			var tbl_svzp_sum = Number(tbl_svzp.getValue("FSUM"));

			switch(Number(tbl_svzp.getValue("FVP")))
			{
				case 0:
					mn_vip = new Date(mdat.getVarDate());
					mn_voz = new Date(mdat.getVarDate());
					offset = 1;
				break;
				case 1:
					mn_vip = new Date(tbl_svzp.getValue("FMN"));
					mn_voz = new Date(mdat.getVarDate());
					offset = 0;
				break;
				case 2:
					mn_vip = new Date(mdat.getVarDate());
					mn_voz = new Date(tbl_svzp.getValue("FMN"));
					offset = Math.round(day_difference(mn_vip,mn_voz)/30)+1   //смещение от базового месяца
				break;
				default:
					txt = ru("Ошибка поля FVP таблицы ","Помилка полы FVP таблиці ");
					txt += SVZPFILE;
					writeToLog(txt, "e", mvvopl, mvvprk, mvvlsfid);
					
					tbl_prk.close();
					tbl_svzp.close();
					return;
				break;
			}
			
			strSQL = "SELECT FID, FIS5, FIS1, FIS8"
						+" FROM ^LIC_FLD"
						+" WHERE 1=1"
							+" AND FID = "+sqlTo(Number(tbl_svzp.getValue("FLSFID")))
			var oSn = getSnap(strSQL);
			
			if(!(oSn && !isEmpty(oSn[0])))
			{
				txt = ru("Ссылка на неизвестное поле лицевого счета "
						, "Посилання на невідоме поле особового рахунку ");
				txt += tbl_svzp.getValue("FLSFID")+".";
				writeToLog(txt, "e", mvvopl, mvvprk, mvvlsfid);
			}
			else
			{
				if (offset>=1)
				{
					ssum[offset] = (oSn[1]=="+" ? ssum[offset]+tbl_svzp_sum : ssum[offset]);
					ssum_nlg[offset] = (oSn[2]=="п" ? ssum_nlg[offset]+tbl_svzp_sum : ssum_nlg[offset]);
					ssum_nlg[offset] = (oSn[2]=="з" ? ssum_nlg[offset]+tbl_svzp_sum : ssum_nlg[offset]);
					ssum_nlg[offset] = (oSn[3]=="п" ? ssum_nlg[offset]+tbl_svzp_sum : ssum_nlg[offset]);
					ssum_nlg[offset] = (oSn[3]=="с" ? ssum_nlg[offset]+tbl_svzp_sum : ssum_nlg[offset]);
					//помимо отдельных фондов и подоходного налога вычитаем также ЕСВ
            		ssum_nlg[offset] = (oSn[3]=="5" ? ssum_nlg[offset]+tbl_svzp_sum : ssum_nlg[offset]);
            		ssum_nlg[offset] = (oSn[3]=="6" ? ssum_nlg[offset]+tbl_svzp_sum : ssum_nlg[offset]);
				}
			}
			oSn = null;
			//************
			tbl_svzp.MoveNext();
		}
		tbl_svzp.close();

		while (!tbl_prk.IsEOF() && Number(tbl_prk.getValue("FTABN")) == prew)
		{
			var tbl_prk_proc = Number(tbl_prk.getValue("FPROC"));
			var tbl_prk_sum = Number(tbl_prk.getValue("FSUM"));
			var tbl_prk_sbor = Number(tbl_prk.getValue("FSBOR"));
			var tbl_prk_tabn = Number(tbl_prk.getValue("FTABN"));
			var tbl_prk_tabn_id = Number(tbl_prk.getValue("FTABN_ID"));
			var tbl_prk_wid_wp = Number(tbl_prk.getValue("FWID_WP"));
			
			sum_proc += tbl_prk_proc;
			if (sum_proc > 100)
			{
				txt = ru("Алименты для таб.N", "Аліменти для таб.N");
				txt += tbl_prk_tabn;
				txt += ru(" превышают з/п.", " перевищують з/п.");
				
				writeToLog(txt, "w", mvvopl, mvvprk, mvvlsfid);
			}

			var ii=1;
			while (ii < max_offset)
			{
				mFsum = 0;
				mFsbor = 0;
				if (ssum[ii] - ssum_nlg[ii] > 0)
				{
					sum_proc = 0;
					// перебор приказов на алименты
					// на каждый приказ создается набор записей в соответствии с offset
					
					if (bNeedCalend)
					{
						var bDat = new Date(tbl_prk.getValue("FBDAT"));
						var eDat = new Date(tbl_prk.getValue("FEDAT"));
						var kolDays = oCalend.getCalDays("В|Р", bDat, eDat);
						
						var koef = kolDays / oCalend.getCalDays("В|Р", D1, D2);
						
						mFsum = round((((ssum[ii]-ssum_nlg[ii])*tbl_prk_proc)/100+tbl_prk_sum)*koef ,2);
					}
					else
					{
						mFsum = round(((ssum[ii]-ssum_nlg[ii])*tbl_prk_proc)/100+tbl_prk_sum ,2);
					}
					if (ii==0)
					{
						mFsum = (mFsum<min_zp/2 ? min_zp/2 : mFsum);
					}
					if (tbl_prk_sbor != 0)
					{
						i = 0;
						while (i < sch)
						{
							if (mFsum >= NLG_STSUM[i])
							{
								mFsbor = round(mFsum * NLG_PROC[i], 2) + NLG_NSM[i];
								break;
							}
							else
							{
								i = i + 1;
							}
						}
					}
					else
					{
						mFsbor = 0;
					}

					// *** do replalim  *********************************************
					var v_dat;
					var mFmn,mFvp;

					if (ii > 1)
					{
						v_dat = new Date(mdat.getVarDate());
						v_dat.setMonth(v_dat.getMonth()+ii-1);
						v_dat.setDate(1);
						
						mFmn = v_dat.getVarDate();
						mFvp = 2;
					}
					else
					{
						mFmn = new Date(d00).getVarDate();
						mFvp = 0;
					}
					
					var m = new Object();
					m.FTABN_ID = tbl_prk_tabn_id;
					m.FWID_WP = tbl_prk_wid_wp;
					m.FLSFID = nach_lsfid;
					m.FFLD_NUM = nach_lsnum;
					m.FSUM = mFsum;
					m.FPR = m.FBDY = m.FEDY = m.FDAY =0;
					m.FID_PRK = tbl_prk.getValue("FWID");
					m.FMN = mFmn;
					m.FVP = mFvp;
					m.FAVT = true;
					m.FVID_PRK = mvvprk;
					m.Fproc = tbl_prk_proc;
					m.FSHPZ = tbl_prk.getValue("Fshpz");
					updateTable("^"+SVZPFILE, m, true);

					// контрольная печать

					str_wait = "---"+monthtxt+"---\n";
					str_wait += ru(" Алим.: Т.н.=", " Алім.: Т.н.=")+tbl_prk_tabn;
					str_wait += " ЗП="+(ssum[ii]-ssum_nlg[ii])+" %="+tbl_prk_proc;
					str_wait += ru(" алим.=", "алім.=")+mFsum;
					str_wait += ru(" сбор =", "збір =")+mFsbor;
					str_wait += ru(" Итого =", "всього =")+(mFsum+mFsbor);
					
					WAIT(str_wait);
					//*** enddo replalim  *********************************************
				}
				
				ii = ii+1;
			}
			
			tbl_prk.MoveNext();
		}
	}
	
	tbl_prk.close();
	return;
}