// R_COMPRO - перерасчет за прошлое для базы удержания пенсионного фонда
// При накоплении контрольной суммы по SVZO не учитываются суммы выплат
// произведенных ранее за данный месяц, заносящиеся из NXT со знаком "-"
// передаются ДАТА расчета - для использования нужных временных файлов
//            ДАТА базовая - для того, чтобы знать в каком месяце производим сравнение
//делает перерасчет по полю, которое указано в перечне расчетов
//вызывается после r_pnfpro.

include("get_cnst.js")
include("servis\\date.js")

function r_compro (mdat,vvopl,mvvdpl,mvvcslid,mvvlsfid2,ftabn_id,svzpName)
{ 
    //только для небазового месяца считаем	
    if (differ(mdat, base_month)==0) return;

    var  mffld_num = 0;
    var oSn = getSnap("select Ffld_num from ^lic_fld where fid="+sqlTo(mvvcslid))
    if (oSn!=null){
       mffld_num = oSn[0]; 
    }
 
    CreateTable("SVZP_ALPB", "SVZP_ALL", "*");           

    // достаем цифры к названию файла для базового месяца
    if (base_month.getMonth() < 9)  
       bas_m = String(base_month.getFullYear()) + "0"+String(base_month.getMonth()+1);
    else
       bas_m = String(base_month.getFullYear()) + String(base_month.getMonth()+1);
    __yearb = bas_m;         
    
    var tblOut = "zrp_" + "dlt" + bas_m;
    if (!IsTableEx("zrp_mdb", tblOut)) CreateTableEx("zrp_mdb", tblOut, "dlt", "*")

    if (mdat.getMonth() < 9)  
       __year = String(mdat.getFullYear()) + "0"+String(mdat.getMonth()+1);
    else
      __year = String(mdat.getFullYear()) + String(mdat.getMonth()+1);  
    var bkv = new Date(mdat);
   
    var xfile  = ""+(svzpName?svzpName:"svzp")+__year;
    var xfileb = ""+(svzpName?svzpName:"svzp")+__yearb;
    var xfldt  = "DLT"+__yearb;
    var xfldu  = "DLTU"+__yearb;
    
	var fis_dlt = false;
    if (IsTableEx("ZRP_MDB", "ZRP_DLT"+__yearb)){
    	var tdlt = OpenTable("s", "select * from ^DLT"+__yearb ) 
    	if (!tdlt.IsEmpty()){
           fis_dlt = true;	
    	}
    	tdlt.close()    	
    }    

	var fis_dltu = false;
    if (IsTableEx("ZRP_MDB", "ZRP_DLTU"+__yearb)){
    	var tdltu = OpenTable("s", "select * from ^DLTU"+__yearb ) 
    	if (!tdltu.IsEmpty()){
           fis_dltu = true;	
    	}
    	tdltu.close()    	
    }    

    if (!fis_dlt && !fis_dltu){
    	return
    }    

    D1 = new Date(firstDayMonth(mdat));
    D2 = new Date(lastDayMonth(D1));

    var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+") ":"";
    //создаем временную таблицу, в которую складываем данные из svzp за текущий месяц, из DLT и DLTU
    //по этой общей базе рассчитываем новый пенсионный фонд, сравниваем со старым из SVZP и разницу записываем
    // в SVZP перерасчитываемый, svzP БАЗОВЫЙ и DLt базовый
    if (IsTableEx("ZRP_RES","zrp_"+xfile))
    {
            //выбираем из SVZP записи по расчетному месяцу (только текущие,без записей по перерасчету )    	
            ExecuteSQL("INSERT INTO svzp_alpb(FTABN, FLSFID, "
                      +"FFLD_NUM, FSUM, FBDY, FEDY, "
                      +"FDAY, FIS_DAY, FMN, FVP, FMF, FMES) SELECT "
                      +"FTABN_ID, FLSFID, "
                      +"FFLD_NUM, FSUM, FBDY, FEDY, "
                      +"FDAY, FIS_DAY, FMN, FVP, "
                      +sqlTo(bkv)+" as FMF, "
                      +sqlTo(bkv)+" as FMES "
                      +"FROM ^"+xfile+" "
                      +"WHERE Fvp=0"+sqlTabn);
         if (IsTableEx("ZRP_MDB", "ZRP_DLT"+__yearb)){
            //выбираем из DLT базового месяца суммы по расчетному месяцу          	
            ExecuteSQL("INSERT INTO svzp_alpb(FTABN, FLSFID, "
                      +"FFLD_NUM, FSUM, FBDY, FEDY, "
                      +"FDAY, FIS_DAY, FMN, FVP, FMF, FMES) SELECT "
                      +"FTABN_ID, FLSFID, "
                      +"FFLD_NUM, FSUM, FBDY, FEDY, "
                      +"FDAY, FIS_DAY, FMN, FVP, "
                      +sqlTo(bkv)+" as FMF, "
                      +sqlTo(bkv)+" as FMES "
                      +"FROM ^"+xfldt+" "
                      +"WHERE Fmn="+sqlTo(mdat)+sqlTabn);
         } 
         if (IsTableEx("ZRP_MDB", "ZRP_DLTU"+__yearb)){
            //выбираем из DLTU базового месяца суммы по расчетному месяцу          	
            ExecuteSQL("INSERT INTO svzp_alpb(FTABN, FLSFID, "
                      +"FFLD_NUM, FSUM, FBDY, FEDY, "
                      +"FDAY, FIS_DAY, FMN, FVP, FMF, FMES) SELECT "
                      +"FTABN_ID, FLSFID, "
                      +"FFLD_NUM, FSUM, FBDY, FEDY, "
                      +"FDAY, FIS_DAY, FMN, FVP, "
                      +sqlTo(bkv)+" as FMF, "
                      +sqlTo(bkv)+" as FMES "
                      +"FROM ^"+xfldu+" "
                      +"WHERE Fmn="+sqlTo(mdat)+sqlTabn);
         }
    }else{
       return;
    }              

    SALL_table = OpenTable("s", "select * from SVZP_ALPB order by FTABN,FLSFID");

    if (!SALL_table.IsEmpty())
        SALL_table.MoveFirst();

    WAIT("Шаг 2 - вычисление сводных сумм");

    var pFtabn;
    //удаляем из SVZP перерасчетного служебные записи по перерасчету по базе ПФ за базовый месяц     
    //по идее, то, что мы сами создали    
    strSQL = "delete from ^"+(svzpName?svzpName:"svzp")+__year+" where Flsfid="+sqlTo(mvvcslid)+" and Fvp=1 and Fmn="+sqlTo(base_month)
    ExecuteSQL(strSQL);
    //удаляем из базового месяца записи по перерасчету, которые мы создали    
    strSQL = "delete from ^"+(svzpName?svzpName:"svzp")+__yearb+" where Flsfid="+sqlTo(mvvcslid)+" and Fvp=2 and Fmn="+sqlTo(mdat)
    ExecuteSQL(strSQL);
    //удаляем записи из DLT по месяцу перерасчета, которые мы создали    
    strSQL = "delete from ^dlt"+__yearb+" where Flsfid="+sqlTo(mvvcslid)+" and Fmn="+sqlTo(mdat)
    ExecuteSQL(strSQL);
        
    var pns1000 = get_cnst("pns1000", mdat)
    var sum_ogr = get_cnst("sum_ogr", mdat)

    if (!SALL_table.IsEOF())
    {   
        pFtabn = SALL_table.getValue("Ftabn");
    }
        
    while (!SALL_table.IsEOF())
    {   
            WAIT("Рассчит.таб.№"+pFtabn);    	
            var ssum1 = 0;      
            var ssum3 = 0;
            var ssum5 = 0;
            var ssum8 = 0;

            while (!SALL_table.IsEOF() && SALL_table.getValue("Ftabn")==pFtabn)              
            {    
                var mFsum = Number(SALL_table.getValue("Fsum"));
                var mFlsfid = Number(SALL_table.getValue("Flsfid"));
                
                var fld_mrk  = ""
                var fld_mrk2 = ""
                var fld_mrk3 = ""
                var oS = getSnap("select Fis8, Fis17, Fis9 from ^LIC_FLD where Fid="+sqlTo(mFlsfid))
                if (oS!=null){ 
                    var fld_mrk  = oS[0]
                    var fld_mrk2 = oS[1]
                    var fld_mrk3 = oS[2]

	               ssum1 = (fld_mrk=="+" && fld_mrk3!="б")? ssum1 + mFsum: ssum1
	               ssum3 = (fld_mrk=="*" && fld_mrk3!="б")? ssum3 + mFsum: ssum3
        	       ssum5 = (fld_mrk=="&" && fld_mrk3!="б")? ssum5 + mFsum: ssum5
            	   ssum8 = (fld_mrk=="?" && fld_mrk3!="б")? ssum8 + mFsum: ssum8
                }

                SALL_table.MoveNext();
            }

            var xx=0;
            //не удерживать ПФ 03.02.10 проверить  
			var osn = getSnap("SELECT p.Ftabn_id FROM ^prk_all as p inner join ^prk_notcalc as c on p.Fwid=c.Fwid"
						+" WHERE p.Ftabn_id="+sqlTo(pFtabn)+" and (c.Fnot_pf=" + sqlTrue + ") "
							+" AND p.fbdat<=" + sqlTo(D2) + " AND p.fedat>=" + sqlTo(D1))
			//если нет в приказе, то считаем базу				
            if (osn==null){
               xx = ssum1+ssum3+ssum5+ssum8
               if (xx!=0){  
                  if (pns1000 == 1 && sum_ogr>0) xx = (xx>sum_ogr)? sum_ogr: xx
               }
            }
	
            //найти старую базу удержания ПФ
	        var oxx = 0;            
            var osn = getSnap("select Fsum from ^"+xfile+" where Ftabn_id="+sqlTo(pFtabn)+" and Flsfid="+sqlTo(mvvcslid)+" and Fvp=0")
            if (osn!=null){            
               oxx = Number(osn[0]);
            }     
            
            var razn = round(xx,2)-round(oxx,2);
            
            //запись в DLT
            if (razn!=0){    
              if (IsTableEx("ZRP_MDB", "ZRP_DLT"+__yearb)){
            		var DLT = new Object();
               		DLT.Ftabn_id = pFtabn;
               		DLT.Flsfid = mvvcslid
               		DLT.Ffld_num = mffld_num
               		DLT.Fwid_wp = 0
               		DLT.Fshpz = "0"
               		DLT.Fid_prk = 0;
               		DLT.Fsum = razn;
               		DLT.Fis_day = 0;
               		DLT.Fday = 0;
               		DLT.Fchas = 0;
               		DLT.Fvp = 2
               		DLT.Fmn = new Date(mdat).getVarDate()
               		DLT.Fmrk = " "
               		UpdateTable("^DLT"+__yearb, DLT,true);
              }
               
       		  var DLT = new Object();
              DLT.Ftabn_id = pFtabn;
              DLT.Flsfid = mvvcslid
              DLT.Ffld_num = mffld_num
              DLT.Fwid_wp = 0
              DLT.Fshpz = "0"
              DLT.Fsum = razn;
              DLT.Fis_day = 0;
              DLT.Fday = 0;
              DLT.Fchas = 0;
              DLT.Fvp = 1
              DLT.Fmn = base_month.getVarDate();
              UpdateTable("^"+(svzpName?svzpName:"svzp")+__year, DLT,true);
            }

            if (!SALL_table.IsEOF())
            {   
                pFtabn = SALL_table.getValue("Ftabn");
            }    
    } 

    SALL_table.close();

	if (IsTableEx("zrp_mdb", "zrp_dlt"+__yearb))
	{
		strSQL="INSERT INTO ^"+(svzpName?svzpName:"svzp")+__yearb+ " (ftabn_id,fwid_wp, fshpz, ffld_num, flsfid, fbdy, fedy, fsum"
						+ ", fday, fchas, fis_day, fis_slct, fmn, fvp, fid_prk)"
				+ " SELECT d.ftabn_id, 0 as Fwid_wp, d.fshpz, d.ffld_num, d.flsfid, d.fbdy, d.fedy, d.fsum"
						+ ", d.fday, d.fchas, d.fis_day, d.fis_slct, d.fmn, d.fvp, d.fid_prk"
				+ " FROM (^dlt" + __yearb
				+ " as d INNER JOIN ^lic_fld as l ON l.fid=d.flsfid )"				
				+ " WHERE d.Flsfid="+sqlTo(mvvcslid);
		ExecuteSQL(strSQL);
	}  
}
