// расчет єдиного социального взноса (удержание)
//вариант, когда расчет налога делается на запись штатного расписания, т.к. если разные категории и у них разные
//проценты, то при сложении сумм ЗР по разным категориям абсолютно неясно, как брать ограничение в 15 прож.мин.
//сейчас берем ограничение отдельно. Если понадобится и будет ясно, как брать ограничение вместе, то напишем.
//21.01.11. Добавила выделение единого налога по больничным из соцстраха. Для этого добавляются 2 справочных поля
//для налога по больничным СС и базы (база для проверки суммы налога) в перечне расчетов (ЛС 1 и 2 соответственно).

include("get_const.js")
include("servis\\date.js")
function name_edvn()
{
	return "Розрахунок утримання єдиного соціального внеску|Расчет удержания единого социального взноса";
}

function r_edvn (mdat,vvopl,vvprk,mvvcslid,VVLSFID2,ftabn_id, svzpName)
{
	//константа, сколько месяцев нужно не учитывать будущие суммы в текущем месяце
	//по новому закону отпускные будущие за январь, начисленные в декабре, нельзя перерасчитывать.
	dtbotp = get_cnst ("dtbotp", mdat)

	//декабрь 2010 зададим явно в программе
	//по новому закону отпускные будущие за январь, февраль и т.д. начисленные в декабре, нельзя перерасчитывать.
	mnbotp = new Date(2010,11,1)

	var Prk_table, Lic_table, PSVZP_table, SVZP_table;
	var szTag, szTag1; 

	// достаем цифры к названию файла
	if (mdat.getMonth() < 9)	
		szTag = String(mdat.getFullYear()) +"0"+String(mdat.getMonth()+1);
	else
		szTag = String(mdat.getFullYear())+String(mdat.getMonth()+1);			

	// достаем цифры к названию файла прошлого месяца
	if (mdat.getMonth() <= 9)	
		szTag1 = String(mdat.getFullYear())+"0"+String(mdat.getMonth());
	else
		szTag1 = String(mdat.getFullYear())+String(mdat.getMonth());			
	
	// дата начала
	var D1 = new Date(mdat.getFullYear(),mdat.getMonth(),1); 
	
	// дата конца
//	var DD2 = new Date(mdat.getFullYear(),mdat.getMonth()+1,0).getDate() 
	var D2 = new Date(lastDayMonth(mdat)); 
	
	// нулевая дата
	var NulDate = new Date(3000,0,1); 

	//учитывать ограничение
	var edv1000	= get_cnst("edv1000",mdat);
	var sum_ogr	= get_cnst("sum_ogr",mdat);

	//если есть эта константа ==1, то нужно считать удержание по месяцу начисления (текущие и перерасчеты за прошл.)
	//если =0, то как раньше по месяцу возникновения
	bln_mes_nach = get_cnst("evnach", mdat)
	
	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis8='5' AND fis_slct=" + sqlTrue;
	snap = getSnap(strSQL);
	fld_fndz = false	
	if(null == snap)
	{
		msg = "Hельзя идентиф.поле ЛС: ед.взнос с зарплаты.\n"
			+ "Если есть необх.в расч.ед.взноса с зарплаты,\n"
			+ "поставьте <5> в 8-ю колонку таблицы вхожд-я полей";
		writeToLog(msg,"w",vvopl,vvprk,mvvcslid);
	}
	else
	{
		 fld_fndz = true
		 var nach_lsfiz = snap[0]
		 var nach_lsnuz = snap[1]
	}

	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis8='6' AND fis_slct=" + sqlTrue;
	snap = getSnap(strSQL);
	fld_fndb = false	
	if(null == snap)
	{
		msg = "Hельзя идентиф.поле ЛС: ед.взнос с больн.\n"
			+ "Если есть необх.в расч.ед.взноса с больн.,\n"
			+ "поставьте <6> в 8-ю колонку таблицы вхожд-я полей";
		writeToLog(msg,"w",vvopl,vvprk,mvvcslid);
	}
	else
	{
		 fld_fndb = true
		 var nach_lsfib = snap[0]
		 var nach_lsnub = snap[1]
	}

	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis8='7' AND fis_slct=" + sqlTrue;
	snap = getSnap(strSQL);
	fld_fndt = false	
	if(null == snap)
	{
		msg = "Hельзя идентиф.поле ЛС: ед.взнос с тр.согл.\n"
			+ "Если есть необх.в расч.ед.взноса с тр.согл.,\n"
			+ "поставьте <7> в 8-ю колонку таблицы вхожд-я полей";
		writeToLog(msg,"w",vvopl,vvprk,mvvcslid);
	}
	else
	{
		 fld_fndt = true
		 var nach_lsfit = snap[0]
		 var nach_lsnut = snap[1]
	}

	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis12='5' AND fis_slct=" + sqlTrue;
	snap = getSnap(strSQL);
	fld_fndbz = false	
	if(null == snap)
	{
		msg = "Hельзя идентиф.поле ЛС: база ед.взноса с зарплаты.\n"
			+ "Если есть необх.в расч.базы ед.взноса с зарплаты,\n"
			+ "поставьте <5> в 12-ю колонку таблицы вхожд-я полей";
		writeToLog(msg,"w",vvopl,vvprk,mvvcslid);
	}
	else
	{
		 fld_fndbz = true
		 var nach_lsfbz = snap[0]
		 var nach_lsnbz = snap[1]
	}

	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis12='6' AND fis_slct=" + sqlTrue;
	snap = getSnap(strSQL);
	fld_fndbb = false	
	if(null == snap)
	{
		msg = "Hельзя идентиф.поле ЛС: база ед.взноса с больн.\n"
			+ "Если есть необх.в расч.базы ед.взноса с больн.,\n"
			+ "поставьте <6> в 12-ю колонку таблицы вхожд-я полей";
		writeToLog(msg,"w",vvopl,vvprk,mvvcslid);
	}
	else
	{
		 fld_fndbb = true
		 var nach_lsfbb = snap[0]
		 var nach_lsnbb = snap[1]
	}

	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis12='7' AND fis_slct=" + sqlTrue;
	snap = getSnap(strSQL);
	fld_fndbt = false	
	if(null == snap)
	{
		msg = "Hельзя идентиф.поле ЛС: база ед.взноса с тр.согл.\n"
			+ "Если есть необх.в расч.базы ед.взноса с тр.согл.,\n"
			+ "поставьте <7> в 12-ю колонку таблицы вхожд-я полей";
		writeToLog(msg,"w",vvopl,vvprk,mvvcslid);
	}
	else
	{
		 fld_fndbt = true
		 var nach_lsfbt = snap[0]
		 var nach_lsnbt = snap[1]
	}

	vdpl = 0;	 
	var snap = getSnap("SELECT ffld_num FROM ^lic_fld WHERE fid=" + sqlTo(mvvcslid));
	if(null != snap)
		vdpl = Number(snap[0]);
	 
	vdpl2 = 0;	 
	var snap = getSnap("SELECT ffld_num FROM ^lic_fld WHERE fid=" + sqlTo(VVLSFID2));
	if(null != snap)
		vdpl2 = Number(snap[0]);
	  
	
    //выделение отдельных больничных из фонда несч сл
    //ЕСВ с больн по несч сл
    cesvnsl = get_cnst ("nslesv", mdat)
    //номер поля ЛС для единого взноса с больничных из несч сл.
	nesvnsl= 0;	 
    if (cesvnsl!=0 && cesvnsl!=null){
    	var snap = getSnap("SELECT ffld_num FROM ^lic_fld WHERE fid=" + sqlTo(cesvnsl));
    	if(null != snap)
    		nesvnsl = Number(snap[0]);
    }
    //база ЕСВ с больн по несч сл
	cbaznsl = get_cnst ("nslbaz", mdat)
    //номер поля ЛС для базы единого взноса с больничных из несч сл.
	nbaznsl= 0;	 
    if (cbaznsl!=0 && cbaznsl!=null){	
    	var snap = getSnap("SELECT ffld_num FROM ^lic_fld WHERE fid=" + sqlTo(cbaznsl));
    	if(null != snap)
    		nbaznsl = Number(snap[0]);
    }
    
	var siName = "^"+(svzpName?svzpName:"svzp") + szTag
	// создается временная таблица, потом она будет уничтожена		
	if(IsTable("tmp_SVZP"))
		DropTable("tmp_SVZP");

	CreateTable("tmp_SVZP", "svzpt");

	// создается временная таблица для расчета единого налога	
	DropTable("SVZPEDV");
	CreateTable("SVZPEDV", "VSP");
	ExecuteSQL("ALTER TABLE SVZPEDV ADD Fcod_kzsht "+SqlType("LONG"))	
	ExecuteSQL("ALTER TABLE SVZPEDV ADD Fcod_kzo "+SqlType("LONG"))
	ExecuteSQL("ALTER TABLE SVZPEDV ADD Fproc_edv "+SqlType("CURRENCY"))
	ExecuteSQL("ALTER TABLE SVZPEDV ADD Fkatesv	"+SqlType("INT"))
	ExecuteSQL("ALTER TABLE SVZPEDV ADD Ffot	"+SqlType("TEXT",1))
	ExecuteSQL("ALTER TABLE SVZPEDV ADD Fis30	"+SqlType("TEXT",1))	
	ExecuteSQL("ALTER TABLE SVZPEDV ADD Fis19	"+SqlType("TEXT",1))
	ExecuteSQL("ALTER TABLE SVZPEDV ADD Fis9	"+SqlType("TEXT",1))	
	ExecuteSQL("ALTER TABLE SVZPEDV ADD Fcod_bln "+SqlType("LONG"))   
	ExecuteSQL("ALTER TABLE SVZPEDV ADD Fproc_edb "+SqlType("CURRENCY"))   
	
	var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+")":"";
	ExecuteSQL("INSERT INTO SVZPEDV(Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id) SELECT Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id FROM "+siName+" where 1=1 "+sqlTabn);
	
	var tbnl = OpenTable("s", "select * from ^NALOG_ESV")
	var fis_36 = false;	
	//если есть 36 категория, проверяем,чтобы была сделана настройка на работу в этой 36 категории. Если ее нет, работаем по-старому
	if (tbnl.isField("Fcod_bln")==true){
		var gs = getSnap("select Fcod_bln from ^NALOG_ESV where (Fcod_bln<>0 and not Fcod_bln is null)")
		if (gs!=null){
			fis_36 = true;
		}	
	}
	tbnl.close();

	//для небазового месяца:если переход на новый налог с 2011, то нужно закачать будущие суммы начислений c минусом
	var is_rasch=(differ(base_month,mdat)==0)
	if (!is_rasch && dtbotp!=0)
	{
		var sqlTabnnu = ftabn_id?" and nu.Ftabn_id in ("+ftabn_id+")":"";		
		//будущие суммы с минусом с 2010 года берем только по начислениям
		strSQL =	"INSERT INTO SVZPEDV "
			+ "( ftabn_id,fwid_wp"
			+ ", fshpz"
			+ ", ffld_num"
			+ ", flsfid"
			+ ", fsum"
			+ ", fmn"
			+ ", fvp )"
		+ " SELECT nu.ftabn_id, nu.fwid_wp, nu.fshpz, nu.ffld_num, nu.flsfid, (-nu.fsum) as Fsum"
			+ ",	nu.fmn, 1 AS fvp "
		+ " FROM ^nxt AS nu "
		+ " INNER JOIN ^lic_fld as l ON l.fid=nu.flsfid "		 		
		+ " WHERE l.Fis6='+' and nu.Fmn<="+sqlTo(mnbotp)+" and nu.fmn1=" + sqlTo(D1)+sqlTabnnu;
		ExecuteSQL(strSQL);
	} 
	
	strSQL = "UPDATE SVZPEDV set Fshpz='0' where Fshpz=' ' or Fshpz is null";
	ExecuteSQL(strSQL);
	
	DropTable("TEDNV2")
	//создать врем.таблицу
	//вытянуть в строку зарплату для единого взноса
	strSQL = "CREATE TABLE TEDNV2 (Ftabn_id "+SqlType("DOUBLE")+", fcod_kzo "+SqlType("INTEGER")+", Fwid "+SqlType("COUNTER")+", fsumzp1 "+SqlType("CURRENCY")+", fcod_kzo1 "+SqlType("INTEGER")+", fproc_ed1 "+SqlType("CURRENCY")
				+", fsumotb "+SqlType("CURRENCY")+", fcod_kzot "+SqlType("INTEGER")+", fproc_edot "+SqlType("CURRENCY")		
				+", fsumbl "+SqlType("CURRENCY")+", fcod_kzb "+SqlType("INTEGER")+", fproc_edb "+SqlType("CURRENCY")
				+", fsumbls "+SqlType("CURRENCY")+", fsumbln "+SqlType("CURRENCY")+", fsumblp "+SqlType("CURRENCY")				
				+", fsumtr "+SqlType("CURRENCY")+", fcod_kzt "+SqlType("INTEGER")+", fproc_edt "+SqlType("CURRENCY")
				+", fmn "+SqlType("DATE")+", fvp "+SqlType("INTEGER")
				+")";
	ExecuteSQL(strSQL);

	//проставляем категорию ЗЛ из штатного расписания
	ExecuteSQL("UPDATE SVZPEDV set Fcod_kzsht=(select B.Fcod_kzo from ^work_pers as b WHERE SVZPEDV.FTABN_ID=B.FWID_CL "
				+" AND SVZPEDV.FWID_WP=B.FWID)")
	ExecuteSQL("UPDATE SVZPEDV set Fcod_kzsht=0 where Fcod_kzsht is null")
	 
	ExecuteSQL("UPDATE SVZPEDV set Fcod_kzo=(select B.Fcod_kzo from ^work_pers as b WHERE SVZPEDV.FTABN_ID=B.FWID_CL "
				+" AND SVZPEDV.FWID_WP=B.FWID)")
	ExecuteSQL("UPDATE SVZPEDV set Fcod_kzo=0 where Fcod_kzo is null")

	if (fis_36==false){
		ExecuteSQL("UPDATE SVZPEDV SET Fkatesv=(SELECT MAX(Fkatesv) FROM ^LIC_FLD AS B "
				+" WHERE SVZPEDV.FLSFID=B.FID)");

		ExecuteSQL("UPDATE SVZPEDV set Fcod_kzo=Fkatesv where Fkatesv<>0 and not Fkatesv is null")

		ExecuteSQL("UPDATE SVZPEDV SET Fis30=(SELECT MAX(Fis30) FROM ^LIC_FLD AS B "
				+" WHERE SVZPEDV.FLSFID=B.FID)");
		ExecuteSQL("DELETE FROM SVZPEDV where Fis30<>'+'")				

		ExecuteSQL("UPDATE SVZPEDV SET Fis19=(SELECT MAX(Fis19) FROM ^LIC_FLD AS B "
				+" WHERE SVZPEDV.FLSFID=B.FID)");

		DropTable("TNALESV")
		ExecuteSQL("select * into TNALESV from ^NALOG_ESV where Fbdat<="+sqlTo(mdat)+" and Fedat>="+sqlTo(mdat));

		ExecuteSQL("UPDATE SVZPEDV SET Fproc_edv=(SELECT MAX(Fproc_u) FROM ^TNALESV AS B "
				+" WHERE SVZPEDV.Fcod_kzo=B.Fcod_kzo)");

		ExecuteSQL("UPDATE SVZPEDV SET Ffot=(SELECT Fvidnach FROM ^TNALESV AS B "
				+" WHERE SVZPEDV.Fcod_kzo=B.Fcod_kzo)");
	}else{	
		DropTable("TNALESV");	
		ExecuteSQL("select * into TNALESV from ^NALOG_ESV where Fbdat<="+sqlTo(mdat)+" and Fedat>="+sqlTo(mdat));

		ExecuteSQL("UPDATE SVZPEDV SET Ffot=(SELECT Fvidnach FROM ^TNALESV AS B "
				+" WHERE SVZPEDV.Fcod_kzo=B.Fcod_kzo)");
	
		ExecuteSQL("UPDATE SVZPEDV SET Fproc_edv=(SELECT MAX(Fproc_u) FROM ^TNALESV AS B "
			+" WHERE SVZPEDV.Fcod_kzo=B.Fcod_kzo)");

		//остается для трудовых соглашений
		ExecuteSQL("UPDATE SVZPEDV SET Fis9=(SELECT MAX(Fis9) FROM ^LIC_FLD AS B "
			+" WHERE SVZPEDV.FLSFID=B.FID)");
		ExecuteSQL("UPDATE SVZPEDV SET Ffot='t' where Fis9='т'")
		ExecuteSQL("UPDATE SVZPEDV SET Fcod_kzo=(SELECT MAX(Fcod_kzo) FROM ^TNALESV AS B "
					+" WHERE SVZPEDV.Ffot=B.Fvidnach) where SVZPEDV.Ffot='t'");
		ExecuteSQL("UPDATE SVZPEDV SET Fproc_edv=(SELECT MAX(Fproc_u) FROM ^TNALESV AS B "
			+" WHERE SVZPEDV.Fcod_kzo=B.Fcod_kzo) where SVZPEDV.Ffot='t'");
	
		//заменить выбор процента из лицевых счетов на выбор категории из справочника шкал единого налога   
	  
		ExecuteSQL("UPDATE SVZPEDV SET Fis30=(SELECT MAX(Fis30) FROM ^LIC_FLD AS B "
					+" WHERE SVZPEDV.FLSFID=B.FID)");
		ExecuteSQL("DELETE FROM SVZPEDV where Fis30<>'+'")				

		ExecuteSQL("UPDATE SVZPEDV SET Fis19=(SELECT MAX(Fis19) FROM ^LIC_FLD AS B "
					+" WHERE SVZPEDV.FLSFID=B.FID)");

		ExecuteSQL("UPDATE SVZPEDV SET Ffot='b' where Fis19='b' or Fis19='б' or Fis19='f'")

		ExecuteSQL("UPDATE SVZPEDV SET Fcod_bln=(SELECT MAX(Fcod_bln) FROM ^TNALESV AS B "
					+" WHERE SVZPEDV.FCOD_KZO=B.FCOD_KZO) where SVZPEDV.Ffot='b'");

		ExecuteSQL("UPDATE SVZPEDV SET Fproc_edb=(SELECT MAX(Fproc_u) FROM ^TNALESV AS B "
				+" WHERE SVZPEDV.Fcod_bln=B.Fcod_kzo) where SVZPEDV.Ffot='b'");
	}
	

	//удаляем только служебные перерасчеты за прошлые периоды
	if (bln_mes_nach!=0)
	{
		//ExecuteSQL("update SVZPEDV set Fmn="+sqlTo(d00obj)+", Fvp=0 where Fmn<="+sqlTo(mdat)+" and Fvp=2")
		if (dtbotp!=0)
			ExecuteSQL("delete from SVZPEDV where (Fvp=1 and Fmn>"+sqlTo(mdat)+")")
		else
			ExecuteSQL("delete from SVZPEDV where Fvp=1")
	}
	if (bln_mes_nach==0 || bln_mes_nach==null)
	{
		if (dtbotp!=0)
		{
			//оставляем отпускные будущие с минусом только за 2010 год (перерасчеты за прошлое и служебные записи убираем) 
			ExecuteSQL("delete from SVZPEDV where (Fvp=1 and Fmn>"+sqlTo(mdat)+") or (Fmn<="+sqlTo(mdat)+" and Fvp=2) or (Fmn<"+sqlTo(mdat)+" and Fmn>"+sqlTo(mnbotp)+" and Fvp=1)")
		}
		else
		{
			//убираем отпускные будущие с минусом и перерасчеты за прошлое и служебные записи
			ExecuteSQL("delete from SVZPEDV where Fvp=1 or (Fmn<="+sqlTo(mdat)+" and Fvp=2)")
		}	
	}

	//if (!is_rasch && dtbotp!=0){	 
	//DropTable("XSVZ2")
	//ExecuteSQL("select * into XSVZ2 from SVZPEDV")
	//}

	//УДЕРЖАНИЕ ЕДИНОГО ВЗНОСА
	//если у человека в середине месяца сменится категория ЗЛ и ЗП больше ограничения, то берем ограничение
	//общее. На какю ЗП хватит ограничения, то и умножим

	//будем брать ограничение в рамках кода КЗО. Иначе неясно, в каком порядке брать ограничение (проценты то разные).
	//вытгиваем в одну строку. 
	var ssumzp1 = new Array(30)
	var ssumotb = new Array(30)		
	var ssumtr = new Array(30)
	var ssumbl = new Array(30)
	var ssumbls = new Array(30)
	var ssumbln = new Array(30)	
	var ssumblp = new Array(30)
	var ssumblpr = new Array(30)
	var ssumblps = new Array(30)
	var ssumblpn = new Array(30)	
	var ssumblpp = new Array(30)
	var ssumzppr = new Array(30)
	var ssumtrpr = new Array(30)	
	var zppr1 = new Array(30)
	var trpr = new Array(30)
	var blpr = new Array(30)

	var max_offset = 12 

	var offset;
	var mn_vip, mn_voz;

	PSVZP_table = OpenTable("s","SELECT * FROM SVZPEDV ORDER BY FTABN_ID, Fcod_kzsht, Fmn, Fvp, Flsfid");
	PSVZP_table.MoveFirst();
	while(!PSVZP_table.IsEOF())
	{
		if (PSVZP_table.getValue("Fcod_kzsht")==0 || PSVZP_table.getValue("Fcod_kzsht")==null){
			//все сообщения выводим только в лог
			//alert("При расчете ЕСВ не найдена запись штатного расписания для ТN="+getCodFromID(PSVZP_table.getValue("Ftabn_id")))
			var msg = "При расчете ЕСВ не найдена запись штатного расписания для ТN="+getCodFromID(PSVZP_table.getValue("Ftabn_id"));
			writeToLog(msg,"e",vvopl,vvprk,mvvcslid);
		}
 		var fisadd = true;		
 		var sumzp1 = 0;
 		var sumbl	= 0;
 		var sumtr	= 0;
 		var sumotb	= 0;
 		var sumbls = 0;
 		var sumbln = 0; 		
 		var sumblp = 0;
		var gs = getSnap("select Fwid, Fsumzp1, Fsumbl, Fsumtr, Fsumotb, Fsumbls, Fsumblp, Fsumbln from	TEDNV2 where Ftabn_id="+sqlTo(PSVZP_table.getValue("Ftabn_id"))+" and Fcod_kzo="+sqlTo(PSVZP_table.getValue("Fcod_kzsht"))+" and Fmn="+sqlTo(PSVZP_table.getValue("Fmn"))+" and Fvp="+sqlTo(PSVZP_table.getValue("Fvp")))
		if (gs!=null){
	 		fisadd = false
	 		mFwid	= gs[0] 
				sumzp1 = Number(gs[1]);
				sumbl	= Number(gs[2]);
				sumtr	= Number(gs[3]);
				sumotb = Number(gs[4]);
				sumbls = Number(gs[5])
				sumblp = Number(gs[6])
				sumbln = Number(gs[7])								
		}		
		
		var m = new Object();		
		m.Ftabn_id = Number(PSVZP_table.getValue("Ftabn_id"))
		//m.Fwid_wp	= Number(PSVZP_table.getValue("Fwid_wp"))
		m.Fcod_kzo	= Number(PSVZP_table.getValue("Fcod_kzsht"))		

		if( PSVZP_table.getValue("Ffot")=="z"){
	 		m.Fsumzp1	= sumzp1+Number(PSVZP_table.getValue("Fsum"))
			 m.Fcod_kzo1 = Number(PSVZP_table.getValue("Fcod_kzo"))
			 m.Fproc_ed1 = Number(PSVZP_table.getValue("Fproc_edv"))
		}
		if( PSVZP_table.getValue("Ffot")=="b"){
			 m.Fsumbl = sumbl+Number(PSVZP_table.getValue("Fsum"))
			 if (fis_36==false){			 
				 m.Fcod_kzb	= Number(PSVZP_table.getValue("Fcod_kzo"))
				 m.Fproc_edb = Number(PSVZP_table.getValue("Fproc_edv"))
			 }else{	 
				 m.Fcod_kzb  = Number(PSVZP_table.getValue("Fcod_bln"))          
				 m.Fproc_edb = Number(PSVZP_table.getValue("Fproc_edb"))
			 } 
		}
		if( PSVZP_table.getValue("Ffot")=="t"){
			 m.Fsumtr = sumtr+Number(PSVZP_table.getValue("Fsum"))
			 m.Fcod_kzt	= Number(PSVZP_table.getValue("Fcod_kzo"))
			 m.Fproc_edt = Number(PSVZP_table.getValue("Fproc_edv"))
		}
		if( PSVZP_table.getValue("Fis19")=="b" || PSVZP_table.getValue("Fis19")=="f"){
			 m.Fsumbls = sumbls+Number(PSVZP_table.getValue("Fsum"))
		}
		if(  PSVZP_table.getValue("Fis19")=="f"){
			 m.Fsumbln = sumbln+Number(PSVZP_table.getValue("Fsum"))
		}

		if( PSVZP_table.getValue("Fis19")=="б"){
			 m.Fsumblp = sumblp+Number(PSVZP_table.getValue("Fsum"))
		}
		
		//если переходный период, то прописываем сумму отпускных будущих с минусом, чтобы
		//потом их не учитывать
		if (dtbotp!=0){
			 if( PSVZP_table.getValue("Fis19")=="о" && Number(PSVZP_table.getValue("Fvp"))==1 && Number(PSVZP_table.getValue("Fsum"))<0 && differ(mnbotp,new Date(PSVZP_table.getValue("Fmn")))>=0){	 		
					m.Fsumotb = sumotb+Number(PSVZP_table.getValue("Fsum"))
					m.Fcod_kzot	= Number(PSVZP_table.getValue("Fcod_kzo"))
					m.Fproc_edot = Number(PSVZP_table.getValue("Fproc_edv"))
			 }
		 }		
		m.Fmn = new Date(PSVZP_table.getValue("Fmn"))
		m.Fvp = Number(PSVZP_table.getValue("Fvp"))
		
 		if (fisadd){
 			UpdateTable("TEDNV2", m, true);
 		}else{
 			UpdateTable("TEDNV2", m, false, "Fwid="+sqlTo(mFwid)); 			
 		}		
 
		PSVZP_table.MoveNext();				 
	}
	
	PSVZP_table.close();
	
	ExecuteSQL("DELETE from TEDNV2 where (Fcod_kzo1=0 or (Fproc_ed1=0 or Fproc_ed1 is null)) and (Fcod_kzb=0 or (Fproc_edb=0 or Fproc_edb is null)) and (Fcod_kzt=0 or (Fproc_edt=0 or Fproc_edt is null))")
	//в таблице TENDV прописались суммы отпускных будущих с минусом и а поле с зарплатой. Этим оператором
	//удаляем сумму отпускных из поля ЗП, оставляем только в поле отпускных и паеребиваем дату на текущий
	//месяц, чтобы можно было удалить их при расчете взноса в переходный период.
	if (dtbotp!=0){
			DropTable("TEDNV")
			//ИЗ-ЗА переходного периода оставляем только отпускные с минусом, перебиваем для них дату на текущую,
			//чтобы можно было их отнять от базы и не учитывать при расчете налогов. После перебивки даты нужно сделать
			//суммирование, чтобы на каждый месяц получилась одна строка с ограничением	
			ExecuteSQL("UPDATE TEDNV2 set Fmn="+sqlTo(d00obj)+", Fvp=0, Fsumzp1=0 where Fvp=1 and Fmn<"+sqlTo(mdat)+" and Fsumotb<>0")
			ExecuteSQL("select sum(a.Fsumzp1) as Fsumzp1,sum(a.Fsumotb) as Fsumotb, sum(a.Fsumbl) as Fsumbl,sum(a.Fsumtr) as Fsumtr, sum(a.Fsumbls) as Fsumbls, sum(a.Fsumbln) as Fsumbln, sum(a.Fsumblp) as Fsumblp,"
					+" MAX(a.Fproc_ed1) as Fproc_ed1, MAX(a.Fproc_edt) as Fproc_edt, MAX(a.Fproc_edb) as Fproc_edb, "
					+ "MAX(a.Fcod_kzo1) as Fcod_kzo1, MAX(a.Fcod_kzb) as Fcod_kzb, MAX(a.Fcod_kzt) as Fcod_kzt, "
					+" a.Ftabn_id, a.Fcod_kzo, a.Fmn, a.Fvp into TEDNV from TEDNV2 as a group by a.Ftabn_id, a.Fcod_kzo, a.Fmn, a.Fvp")
	 }else{
			DropTable("TEDNV")
		 ExecuteSQL("select Fsumzp1,Fsumotb, Fsumbl, Fsumtr, Fsumblp, Fsumbls, Fsumbln, Fproc_ed1, Fproc_edt, Fproc_edb, "
					+ " Fcod_kzo1, Fcod_kzb, Fcod_kzt, Ftabn_id, Fcod_kzo, Fmn, Fvp into TEDNV from TEDNV2")
	} 

	PSVZP_table = OpenTable("SELECT * FROM TEDNV as t "
							//исключаем тех сотрудников, у которых есть приказ не удерживать ЕСВ
							+" WHERE not exists(SELECT p.Ftabn_id FROM ^prk_all as p inner join ^prk_notcalc as c on p.Fwid=c.Fwid"
								+" WHERE t.Ftabn_id=p.Ftabn_id and c.Fnot_esv=" + sqlTrue + " AND p.fbdat<=" + sqlTo(D2) + " AND p.fedat>=" + sqlTo(D1) +")"
							+" ORDER BY FTABN_ID, FCOD_KZO, FMN, FVP ");
	if (!PSVZP_table.IsEmpty())
	{
		for (var iii=0; iii<30; iii++)
		{
			 ssumzp1[iii]	= 0
			 ssumotb[iii]	= 0					
			 zppr1[iii]	 = 0
			 ssumtr[iii]	= 0
			 trpr[iii]		= 0
			 ssumbl[iii]	= 0
			 ssumbls[iii]	= 0
			 ssumbln[iii]	= 0			 
			 ssumblp[iii]	= 0
			 ssumblpr[iii] = 0
			 ssumblps[iii] = 0
			 ssumblpn[iii] = 0			 
			 ssumblpp[iii] = 0
			 ssumzppr[iii] = 0
			 ssumtrpr[iii] = 0		 
			 blpr[iii]		= 0
		}	
	
		PSVZP_table.MoveFirst();
		var pFtabn		= Number(PSVZP_table.getValue("Ftabn_id"))
		var pFsht_id	= Number(PSVZP_table.getValue("Fcod_kzo"))
		var pFmn		= new Date(PSVZP_table.getValue("Fmn"))
		var pFvp		= Number(PSVZP_table.getValue("Fvp"))
		var codkzp = Number(PSVZP_table.getValue("Fcod_kzo1"))
		var codkbl = Number(PSVZP_table.getValue("Fcod_kzb"))
		var codktr = Number(PSVZP_table.getValue("Fcod_kzt"))
		while(!PSVZP_table.IsEOF())
		{ 
			while ((!PSVZP_table.IsEOF()) && (Number(PSVZP_table.getValue("Ftabn_id"))==pFtabn) && (Number(PSVZP_table.getValue("Fcod_kzo"))==pFsht_id) && (Number(PSVZP_table.getValue("Fvp"))==pFvp) && differ(new Date(PSVZP_table.getValue("Fmn")),pFmn)==0)
			{
				// * поле Fvp=0 если месяц выплаты и если месяц возникн-я равны месяцу файла
				// * поле Fvp=1 если месяц выплаты=Fmn, а месяц возникн-я равен месяцу файла
				// * поле Fvp=2 если месяц выплаты равен месяцу файла, а месяц возникн-я=Fmn
				// * offset = 0 для пpошлых месяцев, 1 для текущего месяца, 2 - для следующего, и т.д.
				switch (Number(PSVZP_table.getValue("Fvp")))
				{ 
					case 0:
						mn_vip=mdat
						mn_voz=mdat
						offset = 1
						break;
					case 1:
						mn_vip=new Date(PSVZP_table.getValue("Fmn"))
						mn_voz=mdat
						offset = 0
						break;
					case 2:
						mn_vip=mdat
						mn_voz=new Date(PSVZP_table.getValue("Fmn"))
						offset = Math.round(day_difference(mn_vip,mn_voz)/30)+1	//смещение от базового месяца			 
						//если прошлые периоды
						if (bln_mes_nach!=0 &&	differ(new Date(PSVZP_table.getValue("Fmn")),mnbotp)<=0)
							offset	= Math.round(day_difference(mn_vip,mn_voz)/30)	//смещение от базового месяца
						break;
				}
	
				if (offset > 0)
				{
					ssumotb[offset] = ssumotb[offset] + Number(PSVZP_table.getValue("Fsumotb"))	 			 		
					ssumzp1[offset] = ssumzp1[offset] + Number(PSVZP_table.getValue("Fsumzp1"))
					ssumbl[offset] = ssumbl[offset] + Number(PSVZP_table.getValue("Fsumbl"))
					ssumbls[offset] = ssumbls[offset] + Number(PSVZP_table.getValue("Fsumbls"))
					ssumbln[offset] = ssumbln[offset] + Number(PSVZP_table.getValue("Fsumbln"))					
					ssumblp[offset] = ssumblp[offset] + Number(PSVZP_table.getValue("Fsumblp"))
					ssumtr[offset] = ssumtr[offset] + Number(PSVZP_table.getValue("Fsumtr"))
					zppr1[offset]	= Number(PSVZP_table.getValue("Fproc_ed1"))/100
					trpr[offset]	 = Number(PSVZP_table.getValue("Fproc_edt"))/100
					blpr[offset]	 = Number(PSVZP_table.getValue("Fproc_edb"))/100
				}
			 
				if (bln_mes_nach!=0 &&	offset <0)
				{
					offp = -offset
					ssumblpr[offp] = ssumblpr[offp] + Number(PSVZP_table.getValue("Fsumbl"))
					ssumblps[offp] = ssumblps[offp] + Number(PSVZP_table.getValue("Fsumbls"))
					ssumblpn[offp] = ssumblpn[offp] + Number(PSVZP_table.getValue("Fsumbln"))					
					ssumblpp[offp] = ssumblpp[offp] + Number(PSVZP_table.getValue("Fsumblp")) 
					blpr[offp]		= Number(PSVZP_table.getValue("Fproc_edb"))/100
					ssumzppr[offp] = ssumzppr[offp] + Number(PSVZP_table.getValue("Fsumzp1"))
					zppr1[offp]	= Number(PSVZP_table.getValue("Fproc_ed1"))/100		 
					ssumtrpr[offp] = ssumtrpr[offp] + Number(PSVZP_table.getValue("Fsumtr"))
					trpr[offp]	 = Number(PSVZP_table.getValue("Fproc_edt"))/100				
				}
				else
				{
					offp = offset;
				}
				PSVZP_table.MoveNext();
			}
			//в данном случае после добавления Fmn, Fvp	можно убрать цикл и делить сумму по offset. Быстрее будет работать
			//добавила Fmn, Fvp, чтобы правильно для всех баз прописывался код категории и процент. Без этого вообще
			// нельзя понять, что к чему относится.
		
		//ii = 1
		//while (ii <= max_offset){
			ii = offp				 
			xx = ssumzp1[ii]+ssumtr[ii]+ssumbl[ii]
			if (xx!=0)
			{
				ssumotb[ii] = -(ssumotb[ii])
				if (dtbotp!=0)
				{
					//база для расчета налога в переходный период - отнимаем отпускные
					if (edv1000!=0 && xx>sum_ogr)
					{ 
						var sum_ogrt = sum_ogr;	
						 //	если ЗП+отп >огр., то от огр.отнять отп.
						if (ssumzp1[ii]>sum_ogrt)
						{
							ssumzp1[ii]=sum_ogrt-ssumotb[ii]
							if (ssumzp1[ii]<0)
								ssumzp1[ii]=0	 
							ssumtr[ii] =0
							ssumbl[ii] =0
						}
						else
						{
							sum_ogrt = sum_ogrt-ssumzp1[ii] 
							ssumzp1[ii]=ssumzp1[ii]-ssumotb[ii]
							if (ssumtr[ii]>sum_ogrt)
								ssumtr[ii]=sum_ogrt
							sum_ogrt = sum_ogrt-ssumtr[ii] 
							if (ssumbl[ii]>sum_ogrt)
								ssumbl[ii]=sum_ogrt
						}	
					}
					else
					{
						ssumzp1[ii]=ssumzp1[ii]-ssumotb[ii]
						if (ssumzp1[ii]<0)
							ssumzp1[ii]=0						
						//больничные и отпускные не меняются
					}	
				}
				else
				{	
					//база для расчета налога без переходного периода
					//если есть ограничение и общая сумма больше ограничения, то разбиваем
					//в противном случае суммы остаются такими, как собрали выше. 
	 				if (edv1000!=0 && xx>sum_ogr)
	 				{							 
	 					var sum_ogrt = sum_ogr	
	 					if (ssumzp1[ii]+ssumtr[ii]+ssumbl[ii]>sum_ogrt)
	 					{
							//	разбить суммы по ограничению
	 						if (ssumzp1[ii]>sum_ogrt)
	 							ssumzp1[ii]=sum_ogrt
	 						sum_ogrt = sum_ogrt-ssumzp1[ii] 
	 						if (ssumtr[ii]>sum_ogrt)
	 							ssumtr[ii]=sum_ogrt
	 						sum_ogrt = sum_ogrt-ssumtr[ii] 
	 						if (ssumbl[ii]>sum_ogrt)
	 							ssumbl[ii]=sum_ogrt
	 					}
	 				}	
				}	
				if (round(ssumzp1[ii]*zppr1[ii],2)!=0)
				{ 
					var m = new Object();
					m.Ftabn_id = pFtabn
					m.Fsum	= round(ssumzp1[ii]*zppr1[ii],2)
					
					m.Flsfid = nach_lsfiz
					m.Ffld_num = nach_lsnuz
					m.Fproc = zppr1[ii]*100
					m.Fday	= codkzp
					m.Fmn = pFmn.getVarDate()
					m.Fvp = pFvp
					m.Fis_day = 3
					m.Fvid_prk = vvprk
					m.Favt = true;
					UpdateTable((svzpName?"^"+svzpName:"^svzp") + szTag,m,true);					
			
					if (fld_fndbz==true)
					{
						 var m = new Object();
						 m.Ftabn_id = pFtabn
						 m.Fsum	= ssumzp1[ii]
						 m.Flsfid = nach_lsfbz
						 m.Ffld_num = nach_lsnbz
						 m.Fproc = zppr1[ii]*100
						 m.Fday	= codkzp
						 m.Fmn = pFmn.getVarDate()
						 m.Fvp = pFvp
						 m.Fis_day = 3
						 m.Fvid_prk = vvprk
						 m.Favt = true;
						 UpdateTable((svzpName?"^"+svzpName:"^svzp") + szTag,m,true);					
					}
				}
				if (round(ssumbl[ii]*blpr[ii],2)!=0)
				{ 
					var m = new Object();
					m.Ftabn_id = pFtabn
					m.Fsum	= round(ssumbl[ii]*blpr[ii],2)
					m.Flsfid = nach_lsfib
					m.Ffld_num = nach_lsnub
					m.Fproc = blpr[ii]*100
					m.Fday	= codkbl
					m.Fmn = pFmn.getVarDate()
					m.Fvp = pFvp
					m.Fis_day = 3
					m.Fvid_prk = vvprk
					m.Favt = true;
					UpdateTable((svzpName?"^"+svzpName:"^svzp") + szTag,m,true);					

					if (fld_fndbb==true)
					{
						 var m = new Object();
						 m.Ftabn_id = pFtabn
						 m.Fsum	= ssumbl[ii]
						 m.Flsfid = nach_lsfbb
						 m.Ffld_num = nach_lsnbb
						 m.Fproc = blpr[ii]*100
						 m.Fday	= codkbl
						 m.Fmn = pFmn.getVarDate()
						 m.Fvp = pFvp
						 m.Fis_day = 3
						 m.Fvid_prk = vvprk
						 m.Favt = true;
						 UpdateTable((svzpName?"^"+svzpName:"^svzp") + szTag,m,true);					
					}
					
					if (ssumbls[ii]!=0 && ssumblp[ii]!=0)
					{
						//если есть больничный по соцстраху и предпр., то делим пропорцию между предприятием и ним
						var propKoef = ssumblp[ii]/(ssumblp[ii]+ssumbls[ii]);
						if(ssumblp[ii]>=ssumbl[ii])//учитываем сумму ограничения
							propKoef = 1;
						else
						{
							if(ssumblp[ii]<ssumbl[ii] && ssumblp[ii]+ssumbls[ii]>ssumbl[ii])
								propKoef = ssumblp[ii]/ssumbl[ii];
						}
						ssumblp[ii] = round(propKoef*ssumbl[ii],2)            	   
						ssumbls[ii] = ssumbl[ii]-ssumblp[ii]
					}
					if (ssumbls[ii]!=0 && ssumblp[ii]==0)
					{
						//если есть больничный по соцстраху и нет предпр.
						ssumblp[ii] = 0;
						ssumbls[ii] = ssumbl[ii]
					}

					if (ssumbls[ii]==0 && ssumblp[ii]!=0)
					{
						//если нет больничнго по соцстраху 
						ssumblp[ii] = ssumbl[ii];
						ssumbls[ii] = 0;
					}
					
                	var fis_nsle = false; 
                	var fis_nslb = false; 
                	if (ssumbln[ii]!=0 && cesvnsl!=0){
                   		if (cesvnsl!=0){
                      		fis_nsle = true; 
                   		}
                   		if (cbaznsl!=0){
                      		fis_nslb = true; 
                   		}
                	} 
	
    	           //считаем, что больн. из несч.случ. одновр. не м.б. с больн. соцстраха
        	       //считаем, что настройка для больн соцстраха должна быть, если есть настройка для несч случ   
					if (round(ssumbls[ii]*blpr[ii],2)!=0 && (mvvcslid!=0 && mvvcslid!=null))
					{ 
						var m = new Object();
						m.Ftabn_id = pFtabn
						m.Fsum	= round(ssumbls[ii]*blpr[ii],2)
                  		if (fis_nsle==false){						
							m.Flsfid = mvvcslid
							m.Ffld_num = vdpl
						}
						if (fis_nsle==true){
							m.Flsfid = cesvnsl
							m.Ffld_num = nesvnsl
						}
						m.Fproc = blpr[ii]*100
						m.Fday	= codkbl
						m.Fmn = pFmn.getVarDate()
						m.Fvp = pFvp
						m.Fis_day = 3
						m.Fvid_prk = vvprk
						m.Favt = true;
						UpdateTable((svzpName?"^"+svzpName:"^svzp") + szTag,m,true);					

						if (VVLSFID2!=0 && VVLSFID2!=null)
						{							
							var m = new Object();
							m.Ftabn_id = pFtabn
							m.Fsum	= ssumbls[ii]
                     		if (fis_nslb==false){							
								m.Flsfid = VVLSFID2
								m.Ffld_num = vdpl2
							}
                     		if (fis_nslb==true){
								m.Flsfid = cbaznsl
								m.Ffld_num = nbaznsl
                     		}								
							m.Fproc = blpr[ii]*100
							m.Fday	= codkbl
							m.Fmn = pFmn.getVarDate()
							m.Fvp = pFvp
							m.Fis_day = 3
							m.Fvid_prk = vvprk
							m.Favt = true;
							UpdateTable((svzpName?"^"+svzpName:"^svzp") + szTag,m,true);					
						}
					}
				}

				if (round(ssumtr[ii]*trpr[ii],2)!=0)
				{ 
					var m = new Object();
					m.Ftabn_id = pFtabn
					m.Fsum	= round(ssumtr[ii]*trpr[ii],2)
					m.Flsfid = nach_lsfit
					m.Ffld_num = nach_lsnut
					m.Fproc = trpr[ii]*100
					m.Fday	= codktr
					m.Fmn = pFmn.getVarDate()
					m.Fvp = pFvp
					m.Fis_day = 3
					m.Fvid_prk = vvprk
					m.Favt = true;
					UpdateTable((svzpName?"^"+svzpName:"^svzp") + szTag,m,true);					
					
					if (fld_fndbt==true)
					{
						 var m = new Object();
						 m.Ftabn_id = pFtabn
						 m.Fsum	= ssumtr[ii]
						 m.Flsfid = nach_lsfbt
						 m.Ffld_num = nach_lsnbt
						 m.Fproc = trpr[ii]*100
						 m.Fday	= codktr
						 m.Fmn = pFmn.getVarDate()
						 m.Fvp = pFvp
						 m.Fis_day = 3
						 m.Fvid_prk = vvprk
						 m.Favt = true;
						 UpdateTable((svzpName?"^"+svzpName:"^svzp") + szTag,m,true);					
					}
				}
			}
			
			if (round(ssumblpr[ii]*blpr[ii],2)!=0)
			{ 
				var m = new Object();
				m.Ftabn_id = pFtabn
				m.Fsum	= round(ssumblpr[ii]*blpr[ii],2)
				m.Flsfid = nach_lsfib
				m.Ffld_num = nach_lsnub
				m.Fproc = blpr[ii]*100
				m.Fday	= codkbl
				m.Fmn = pFmn.getVarDate()
				m.Fvp = pFvp
				m.Fis_day = 3
				m.Fvid_prk = vvprk
				m.Favt = true;
				UpdateTable((svzpName?"^"+svzpName:"^svzp") + szTag,m,true);					

				if (fld_fndbb==true)
				{
					var m = new Object();
					m.Ftabn_id = pFtabn
					m.Fsum	= ssumblpr[ii]
					m.Flsfid = nach_lsfbb
					m.Ffld_num = nach_lsnbb
					m.Fproc = blpr[ii]*100
					m.Fday	= codkbl
					m.Fmn = pFmn.getVarDate()
					m.Fvp = pFvp
					m.Fis_day = 3
					m.Fvid_prk = vvprk
					m.Favt = true;
					UpdateTable((svzpName?"^"+svzpName:"^svzp") + szTag,m,true);					
				}
				 
				if (ssumblps[ii]!=0 && ssumblpp[ii]!=0)
				{
					//если есть больничный по соцстраху и предпр., то делим пропорцию между предприятием и ним
					var propKoef = ssumblpp[ii]/(ssumblpp[ii]+ssumblps[ii]);
					if(ssumblpp[ii]>=ssumblpr[ii])//учитываем сумму ограничения
						propKoef = 1;
					else
					{
						if(ssumblpp[ii]<ssumblpr[ii] && ssumblpp[ii]+ssumblps[ii]>ssumblpr[ii])
							propKoef = ssumblpp[ii]/ssumblpr[ii];
					}
					ssumblpp[ii] = round(propKoef*ssumblpr[ii],2);            	 
					ssumblps[ii] = ssumblpr[ii]-ssumblpp[ii];
				}
				if (ssumblps[ii]!=0 && ssumblpp[ii]==0)
				{
					//если есть больничный по соцстраху и нет предпр.
					ssumblpp[ii] = 0;
					ssumblps[ii] = ssumblpr[ii]
				}

				if (ssumblps[ii]==0 && ssumblpp[ii]!=0)
				{
					//если нет больничнго по соцстраху 
					ssumblpp[ii] = ssumblpr[ii];
					ssumblps[ii] = 0;
				}
				
		        var fis_nslpe = false; 
         		var fis_nslpb = false; 
         		if (ssumblpn[ii]!=0){
            		if (cesvnsl!=0){
               			fis_nslpe = true; 
            		}
            		if (cbaznsl!=0){
               			fis_nslpe = true; 
            		} 
         		} 
				
				if (round(ssumblps[ii]*blpr[ii],2)!=0 && (mvvcslid!=0 && mvvcslid!=null))
				{ 
					var m = new Object();
					m.Ftabn_id = pFtabn
					m.Fsum	= round(ssumblps[ii]*blpr[ii],2)
                  	if (fis_nslpe==false){                     					
						m.Flsfid = mvvcslid
						m.Ffld_num = vdpl
					}
                  	if (fis_nslpe==true){
						m.Flsfid = cesvnsl
						m.Ffld_num = nesvnsl
                  	}						
					m.Fproc = blpr[ii]*100
					m.Fday	= codkbl
					m.Fmn = pFmn.getVarDate()
					m.Fvp = pFvp
					m.Fis_day = 3
					m.Fvid_prk = vvprk
					m.Favt = true;
					UpdateTable((svzpName?"^"+svzpName:"^svzp") + szTag,m,true);					

					if (VVLSFID2!=0 && VVLSFID2!=null)
					{
						var m = new Object();
						m.Ftabn_id = pFtabn
						m.Fsum	= ssumblps[ii]
                     	if (fis_nslpb==false){						
							m.Flsfid = VVLSFID2
							m.Ffld_num = vdpl2
						}	
                     	if (fis_nslpb==true){
							m.Flsfid = cbaznsl
							m.Ffld_num = nbaznsl
                     	}							
						m.Fproc = blpr[ii]*100
						m.Fday	= codkbl
						m.Fmn = pFmn.getVarDate()
						m.Fvp = pFvp
						m.Fis_day = 3
						m.Fvid_prk = vvprk
						m.Favt = true;
						UpdateTable((svzpName?"^"+svzpName:"^svzp") + szTag,m,true);					
					}
				}
			}
			if (round(ssumzppr[ii]*zppr1[ii],2)!=0)
			{ 
				var m = new Object();
				m.Ftabn_id = pFtabn
				m.Fsum	= round(ssumzppr[ii]*zppr1[ii],2)
				m.Flsfid = nach_lsfiz
				m.Ffld_num = nach_lsnuz
				m.Fproc = zppr1[ii]*100
				m.Fday	= codkzp
				m.Fmn = pFmn.getVarDate()
				m.Fvp = pFvp
				m.Fis_day = 3
				m.Fvid_prk = vvprk
				m.Favt = true;
				UpdateTable((svzpName?"^"+svzpName:"^svzp") + szTag,m,true);					
		 
				if (fld_fndbz==true)
				{
					var m = new Object();
					m.Ftabn_id = pFtabn
					m.Fsum	= ssumzppr[ii]
					m.Flsfid = nach_lsfbz
					m.Ffld_num = nach_lsnbz
					m.Fproc = zppr1[ii]*100
					m.Fday	= codkzp
					m.Fmn = pFmn.getVarDate()
					m.Fvp = pFvp
					m.Fis_day = 3
					m.Fvid_prk = vvprk
					m.Favt = true;
					UpdateTable((svzpName?"^"+svzpName:"^svzp") + szTag,m,true);					
				}
			}
			
			if (round(ssumtrpr[ii]*trpr[ii],2)!=0)
			{ 
				var m = new Object();
				m.Ftabn_id = pFtabn
				m.Fsum	= round(ssumtrpr[ii]*trpr[ii],2)
				m.Flsfid = nach_lsfit
				m.Ffld_num = nach_lsnut
				m.Fproc = trpr[ii]*100
				m.Fday	= codktr
				m.Fmn = pFmn.getVarDate()
				m.Fvp = pFvp
				m.Fis_day = 3
				m.Fvid_prk = vvprk
				m.Favt = true;
				UpdateTable((svzpName?"^"+svzpName:"^svzp") + szTag,m,true);					
				 
				if (fld_fndbt==true)
				{
					var m = new Object();
					m.Ftabn_id = pFtabn
					m.Fsum	= ssumtrpr[ii]
					m.Flsfid = nach_lsfbt
					m.Ffld_num = nach_lsnbt
					m.Fproc = trpr[ii]*100
					m.Fday	= codktr
					m.Fmn = pFmn.getVarDate()
					m.Fvp = pFvp
					m.Fis_day = 3
					m.Fvid_prk = vvprk
					m.Favt = true;
					UpdateTable((svzpName?"^"+svzpName:"^svzp") + szTag,m,true);					
				}
			}
			//ii = ii + 1
		//} // end of	while (ii <= max_offset) 
			for (var iii=0; iii<30; iii++)
			{
				ssumzp1[iii]	 = 0
				ssumotb[iii]	= 0						
				ssumtr[iii]	 = 0
				ssumbl[iii]	 = 0
				ssumblp[iii]	 = 0
         		ssumbln[iii]    = 0				
				ssumbls[iii]	 = 0
				ssumblpr[iii] = 0			
				ssumzppr[iii] = 0
				ssumtrpr[iii] = 0
				ssumblpp[iii]	= 0
         		ssumblpn[iii]  = 0				
				ssumblps[iii]	= 0
				zppr1[iii]	 = 0
				trpr[iii]	 = 0
				blpr[iii]	 = 0
			}	

			if (!PSVZP_table.IsEOF())
			{
				pFtabn		= Number(PSVZP_table.getValue("Ftabn_id"))
				pFsht_id	= Number(PSVZP_table.getValue("Fcod_kzo"))
				pFmn		= new Date(PSVZP_table.getValue("Fmn"))
				pFvp		= Number(PSVZP_table.getValue("Fvp"))
		 		codkzp = Number(PSVZP_table.getValue("Fcod_kzo1"))
				codkbl = Number(PSVZP_table.getValue("Fcod_kzb"))
				codktr = Number(PSVZP_table.getValue("Fcod_kzt"))
			}
		}
	}
	PSVZP_table.close();

 	ExecuteSQL("INSERT INTO " + (svzpName?"^"+svzpName:"^svzp") + szTag + getColumn("tmp_svzp",true) + 
			" SELECT " + getColumn("tmp_svzp",false) + " FROM tmp_svzp");
	
	DropTable("tmp_svzp");
	ExecuteSQL("DELETE FROM " + (svzpName?"^"+svzpName:"^svzp") + szTag + " WHERE (FSUM is NULL OR FSUM=0) AND (FDNKL is NULL or FDNKL=0) " + sqlTabn);
	return;
}