//перенос справочно сумм из отдельных лицевых счетов (первое поле ЛС lsfid) в основные лицевые счета (второе поле ЛС lsfid2, должно быть справочным и в настройках для него нужно отключить сравнение)
//расчет переносит суммы только для расчетного месяца и должен включаться только в отдельных расчетах
//использовать расчет осторожно: вторым полем нельзя передавать поля ЛС, которые расчитываются основным расчетом, т.к. текущий расчет их удалит
function name_movels()
{
	return "Перенесення (довідково) сум з окремих особових рахунків|Перенос (справочно) сумм из отдельных лицевых счетов";
}

function r_movels(month, vopl, vidprk, lsfid, lsfid2, ftabn_id, svzpName)
{
	if(!svzpName)
	{
		var msg = "Этот расчет можно включать только для основных расчетов.";
		writeToLog(msg,"w",vopl, vidprk, lsfid);
		return false;
	}
	//только для базового месяца
	if (differ(month,base_month)!=0)
		return;
	var strTabName = svzpName + getDateTag(month);
	var baseTabName = "svzp" + getDateTag(month);
    
	var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+") ":"";

	// Проверка на существование отдельной таблицы "svzp%LD"
	if(!IsTableEx("zrp_res", "zrp_" + strTabName))
	{ 
		var strPath = getPath("zrp_res");
		CreateTable(strPath + ".zrp_" + strTabName, "svzp", "*");
		return false;
	}
	
	// Проверка на существование таблицы "svzp%LD"
	if(!IsTableEx("zrp_res", "zrp_" + baseTabName))
	{ 
		var strPath = getPath("zrp_res");
		CreateTable(strPath + ".zrp_" + baseTabName, "svzp", "*");
	}
	//сперва удаляем старые справочные поля
	ExecuteSQL("delete from ^" + baseTabName+" where Flsfid="+lsfid2+sqlTabn)
	
	//вставляем справочные поля ЛС в основную таблицу лицевых счетов
	var strSQL  = "insert into ^" + baseTabName
		 			+ "(ftabn_id, fwid_wp, fshpz, fsum, ffld_num, flsfid, fis_day, fday, fchas, fmn, fvp, fid_prk, fvid_prk)"
 				+ " select ftabn_id, fwid_wp, fshpz, fsum"
		 			+ ", " + getLsNum(lsfid2) + " as ffld_num"
		 			+ ", " + sqlTo(lsfid2) + " as flsfid"
		 			+ ", fis_day, fday, fchas, fmn, fvp, 0 as fid_prk"
		 			+ ", " + sqlTo(vidprk)+ " as fvid_prk"
	 			+ " from ^" + strTabName
	 			+ " where NOT (Fvp=1 AND Fmn>=" + sqlTo(month)+")"+" and Flsfid="+lsfid+sqlTabn;
	ExecuteSQL(strSQL);
	
	//скопируем также суммы в таблицу MVLS%LD, чтобы при выполнении основного расчета перенесенные суммы не терялись (вставлять их будет r_sum)
	var mvlsName = "mvls" + getDateTag(month);
	if(!IsTableEx("zrp_res", "zrp_" + mvlsName))
	{ 
		var strPath = getPath("zrp_res");
		CreateTable(strPath + ".zrp_" + mvlsName, "svzp", "*");
	}
	else
		ExecuteSQL("delete from ^" + mvlsName+" where Flsfid="+lsfid2+sqlTabn)
	var strSQL  = "insert into ^" + mvlsName
		 			+ "(ftabn_id, fwid_wp, fshpz, fsum, ffld_num, flsfid, fis_day, fday, fchas, fmn, fvp, fid_prk, fvid_prk)"
 				+ " select ftabn_id, fwid_wp, fshpz, fsum"
		 			+ ", " + getLsNum(lsfid2) + " as ffld_num"
		 			+ ", " + sqlTo(lsfid2) + " as flsfid"
		 			+ ", fis_day, fday, fchas, fmn, fvp, 0 as fid_prk"
		 			+ ", " + sqlTo(vidprk)+ " as fvid_prk"
	 			+ " from ^" + strTabName
	 			+ " where NOT (Fvp=1 AND Fmn>=" + sqlTo(month)+")"+" and Flsfid="+lsfid+sqlTabn;
	ExecuteSQL(strSQL);
}