//расчет предназначен для расчетов итоговых сумм по больничным соцстраха с учетом задолженностей прошлых периодов,
//должен использоваться с отдельным расчетом сумм больничных по соцстраху _blnsoc, расчетом соответствующих удержаний _blnsocuder
//и расчетом выплаченных людям сумм, возращенных соцстрахом _prk5, 
//расчет переделан с _nachi3

include("get_const.js");

function name_nachibln()
{
	return "Окремий розрахунок підсумкових сум за лікарняними|Отдельный расчет итоговых сумм по больничным";
}

function r_nachibln(month, vopl, vidprk, lsfid, lsfid2, ftabn_id, svzpName)
{
	if(!svzpName)
	{
		var ms = "Процедура _nachibln предназначена только для отдельных расчетов итоговых сумм по больничным и не должен включаться в основной расчет зарплаты!"
		writeToLog(msg,"e",vopl,vidprk,lsfid);
		return false;
	}
	var calcNum = svzpName.toLowerCase().replace("svzp","");
	if(isNaN(calcNum) || calcNum=="")
	{
		var ms = "Номер отдельного расчета не является числовым: "+calcNum;
		writeToLog(msg,"e",vopl,vidprk,lsfid);
		return false;
	}
	var nxtTbl = "nxt"+calcNum;
	//----------------------------------------------------------------------------------------------------------
	var is_rasch = 0==differ(base_month, month);
	//----------------------------------------------------------------------------------------------------------
	// достаем цифры к названию файла
	var szTag = (month.getFullYear())+((month.getMonth()< 9)?"0":"") + (month.getMonth()+1);	// дата начала
	var D1 = new Date(month.getFullYear(), month.getMonth(), 1);
	// дата конца
	var D2 = new Date(lastDayMonth(month));
	//D2.setDate(0);   

	var bez_k=get_cnst("bez_kop", month);
	if (bez_k==0)
		bez_kopeek=false;
	else
	{
		bez_k = Math.pow(10,(bez_k-1));
		bez_kopeek = true;
	}  

	var kopuv=get_cnst("kopuv", month);

//   определение полей "начислено"(по месяцам), "всего начислено",
//   "удержано"(по месяцам), "всего удержано", "фактически выдано",
//   "долг за пpошлое", "на будущее"
	var strSQL = "SELECT fid FROM ^lic_fld WHERE fis6="
	var snap = getSnap(strSQL + sqlTo("н"));
	if(null == snap)
	{
		msg=" Обнаружена серьезная ошибка функционирования системы \n"
				+ " Hевозможно идентифицировать поле ЛС: всего начислено \n"
				+ "       Пригласите разработчиков для устранения        ";
		
		writeToLog(msg,"e",vopl, vidprk, lsfid);
		return;
	}
	
	var nach_lsfid = snap[0];
	snap = getSnap(strSQL + sqlTo("у"));
	if(null == snap)
	{
		msg=" Обнаружена серьезная ошибка функционирования системы \n"
				+ " Hевозможно идентифицировать поле ЛС : всего удержано \n"
				+ "       Пригласите разработчиков для устранения        ";
		writeToLog(msg,"e",vopl, vidprk, lsfid);          
		return;
	}

	var uder_lsfid = snap[0];
	var fvid_found=true;
	snap = getSnap(strSQL + sqlTo("ф"));
	if(null == snap)
	{
		msg=" Обнаружена серьезная ошибка функционирования системы \n"
				+ " Hевозможно идентифицировать поле ЛС:фактически выдано\n"
				+ "       Пригласите разработчиков для устранения        ";
		writeToLog(msg,"e",vopl, vidprk, lsfid);          
		return;
	}

	var vidan_lsfid = snap[0];
	var dolg_found=true;
	snap = getSnap(strSQL + sqlTo("з"));
	if(null == snap)
	{
		msg=" Обнаружена серьезная ошибка функционирования системы \n"
				+ " Hевозможно идентифицировать поле ЛС: задолж.за прошл.\n"
				+ "       Пригласите разработчиков для устранения        "
		writeToLog(msg,"e",vopl, vidprk, lsfid);          
		return;
	}

	var dlgPrv_lsfid = snap[0];
	var dlgb_found=true;
	snap = getSnap(strSQL + sqlTo("б"));
	if(null == snap)
	{
		msg=" Обнаружена серьезная ошибка функционирования системы \n"
				+ " Hевозможно идентифицировать поле ЛС:задолж.на будущее\n"
				+ "       Пригласите разработчиков для устранения        "
		writeToLog(msg,"e",vopl, vidprk, lsfid);          
		return;
	}

	var dlgNxt_lsfid = snap[0];
	
//**********************
//закачать из файлов DLG и NXT нужные записи
//**********************
	var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+") ":"";
	
	
	var dlgTable = "dlg"+calcNum+szTag;
	var svzpTable = (svzpName?svzpName:"svzp") + szTag;

	if (!IsTableEx("zrp_mdb", "zrp_" + dlgTable))
	{
//		var strPath = getPath("zrp_mdb");
		CreateTableEx("zrp_mdb","zrp_" + dlgTable, "dlg", "*");
	}   

	if (!IsTableEx("zrp_res", "zrp_" + svzpTable))
	{
	//	var strPath = getPath("zrp_res");
		CreateTableEx("zrp_res","zrp_" + svzpTable, "svzp", "*");
	}      

	if (is_rasch)
	{
		ExecuteSQL("DELETE FROM ^" + dlgTable + " WHERE 1=1 " + sqlTabn);
		if (!IsTableEx("zrp_mdb", "zrp_" + nxtTbl))
			CreateTableEx("zrp_mdb","zrp_" + nxtTbl, "nxt", "*");
		else
		{
//эти суммы боьничных переносятся из основных ЛС
//			//т.к. расчет готовых сумм подключать в отдельные расчеты з/п нельзя, то отдельно переносим суммы будущих периодов
//			strSQL =  "INSERT INTO ^" + svzpTable
//			 			+ "( ftabn_id,fwid_wp"
//			 			+ ", fshpz"
//			 			+ ", ffld_num"
//			 			+ ", flsfid"
//			 			+ ", fbdy"
//			 			+ ", fedy"
//			 			+ ", fsum"
//			 			+ ", fday"
//			 			+ ", fchas"
//			 			+ ", fis_day"
//			 			+ ", fmn"
//			 			+ ", fvp"
//			 			+ ", fid_prk"
//			 			+ ", fvid_prk"
//			 			+ ", fproc)"
//			 		+ " SELECT nu.ftabn_id, "+IIF("l.Fis6='+'","nu.fwid_wp","0")+" as Fwid_wp, nu.fshpz, nu.ffld_num, nu.flsfid, nu.fbdy, nu.fedy, -nu.fsum"
//			 			+ ", nu.fday, nu.fchas, nu.fis_day, nu.fmn, 1 AS fvp, nu.fid_prk AS fid_prk"
//			 			+ ", " + sqlTo(vidprk)+ " as fvid_prk, nu.Fproc"
//			 		+ " FROM (^"+nxtTbl+" AS nu "
//					+ " INNER JOIN ^lic_fld as l ON l.fid=nu.flsfid )"		 		
//			 		+ " WHERE nu.fmn1=" + sqlTo(D1) + (ftabn_id?" and nu.Ftabn_id in ("+ftabn_id+") ":"");
//			ExecuteSQL(strSQL);
		}
	} 

//  закачать записи, содержащие задолженность за прошлые месяцы из
//  файла DLG за предыдущий месяц
    var prevMonth = new Date(month.getFullYear(), month.getMonth()-1, 1);
    var dglPrevTable = "dlg" + calcNum + getDateTag(prevMonth);

	if (IsTableEx("zrp_mdb", "zrp_" + dglPrevTable))
	{
		strSQL = "INSERT INTO ^" + svzpTable + "(ffld_num,flsfid,fsum,ftabn_id,fwid_wp,fday,fchas,fpr,fmn,fvp,fid_prk,fis_day,fshpz,fvid_prk,fbdy,fedy)" 
				 + " SELECT ffld_num,flsfid,fsum,ftabn_id,0 as fwid_wp,0 as fday,0 as fchas,0 as fpr,"+sqlTo(d00obj)+" as fmn,0 as Fvp,0 as fid_prk,0 as fis_day,'' as fshpz,0 as fvid_prk,0 as fbdy,0 as fedy "
				 + " FROM ^" + dglPrevTable + " WHERE 1=1 " + sqlTabn;
		ExecuteSQL(strSQL);     
	}               

//  только для базового месяца
//  удаление записей, созданных в базовом месяце по предварительным
//  начислениям и удержаниям
	if (is_rasch)
	{
		strSQL="UPDATE ^"+nxtTbl+" SET Fmn=" + sqlTo(d00)
							+ ", Fmn1=" + sqlTo(d00)
				+ " WHERE Fmn=" + sqlTo(month) + sqlTabn;
		ExecuteSQL(strSQL);
	}
	else
	{
		msg = "Месяц не базовый - расчет 'Всего начислено' не производится";
		writeToLog(msg,"w",vopl, vidprk, lsfid);
		return;
	} 
	
    var strOffset = IIF("s.fvp=0"
					,1
					,IIF("s.fvp=2 and s.fmn>"+sqlTo(D1)
						,sqlRound(sqlRound(SqlDaysBWDates(sqlTo(D1),"s.fmn"),0) + "/30.0",0)+"+1"
						, 0));

	var sumt_nach = "SUM(" + IIF("l.fis6='+'", sqlRound("s.fsum",2), "0") + ")";
	var sumt_uder = "SUM(" + IIF("l.fis6='-'", sqlRound("s.fsum",2), "0") + ")";
	var ssum_dolg = "SUM(" + IIF("l.fis6='з'", sqlRound("s.fsum",2), "0") + ")";
	//задолженность по ЗП
    var ssum_dlgp = "SUM(" + IIF("l.fis6='п'", sqlRound("s.fsum",2), "0") + ")";
	//var ssum_dolg = "SUM(" + sqlRound("s.fsum",2) + ")";
	var sumt_kvid = sumt_nach +"-"+ sumt_uder +"+"+ ssum_dolg+"+"+ ssum_dlgp;
	//11.12.07 Исправила аналог. r_nachi2, ошибку исправил Олег в Брокарде
	if (bez_kopeek)
	{
		var  _xx_kvid = sumt_kvid;                    		// сумма к выдаче
        //sumt_kvid =sqlRound(sumt_kvid+"/"+bez_k,0)+"*"+bez_k ;// округленная сумма к выдаче
        sumt_kvid = "floor("+"("+sumt_kvid+")"+"/"+bez_k+")"+"*"+bez_k; // округленная сумма к выдаче 
        ssum_dolg = _xx_kvid +"-" + sumt_kvid; 				// копейки
	}
	else
	{
		//как всегда при переносе с 2000-й версии забыли кусок кода
		ssum_dolg = (sumt_kvid < 0?sumt_kvid:0);//оставшаяся сумма долга по таб.N
		//sumt_kvid = (sumt_kvid > 0?sumt_kvid:0);//фактически выдано по таб.N
	}
	//во всего начислено будем подсчитывать кол-во дней и часов по просьбе Линовицы
	var sum1 = IIF("l.fis6='+'", sqlRound("s.fsum",2), "0");
	var sum2 = IIF("l.fis6='+'", sqlRound("s.fsum",2), "1");
	var sum_day = "SUM(s.Fday*"+sum1+"/ABS("+sum2+"))";
	var sum_chas = "SUM(s.Fchas*"+sum1+"/ABS("+sum2+"))";
	//--------------запись сумм в SVZP "всего начислено"
	strSQL = "INSERT INTO ^"+ svzpTable
				+ " (ftabn_id,fwid_wp, ffld_num, flsfid, fsum, fday, fchas)"
			+ " SELECT s.ftabn_id, 0 as fwid_wp"
					+ ", " + IIF(sqlTo(nach_lsfid) + "<>0"
							, "(SELECT l1.ffld_num FROM ^lic_fld AS l1 WHERE l1.fid=" + sqlTo(nach_lsfid)  + ")"
							, 0) + " AS ffld_num" 
					+ ", " + nach_lsfid + " AS flsfid"
					+ ", " + sumt_nach + " AS fsum"
					+ ", " + sum_day + " AS fday"
					+ ", " + sum_chas + " AS fchas"
			+ " FROM ^" + svzpTable + " as s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
			+ " WHERE 1=1 " + sqlTabn
			+ " GROUP BY s.ftabn_id";
	ExecuteSQL(strSQL);          
	//--------------запись сумм в SVZP "всего удержано"
	strSQL = "INSERT INTO ^"+ svzpTable
				+ " (ftabn_id,fwid_wp, ffld_num, flsfid, fsum)"
			+ " SELECT s.ftabn_id,0 as fwid_wp"
					+ ", " + IIF(sqlTo(uder_lsfid) + "<>0"
							, "(SELECT l1.ffld_num FROM ^lic_fld AS l1 WHERE l1.fid=" + sqlTo(uder_lsfid)  + ")"
							, 0) + " AS ffld_num" 
					+ ", " + uder_lsfid + " AS flsfid"
					+ ", " + sumt_uder + " AS fsum"
			+ " FROM ^" + svzpTable + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
			+ " WHERE 1=1 " + sqlTabn
			+ " GROUP BY s.ftabn_id";
	ExecuteSQL(strSQL);          

	//------- запись сумм в SVZP "фактически выдано"
	strSQL = "INSERT INTO ^"+ svzpTable
				+ " (ftabn_id,fwid_wp, ffld_num, flsfid, fsum)"
			+ " SELECT s.ftabn_id, 0 as fwid_wp"
					+ ", " + IIF(sqlTo(vidan_lsfid) + "<>0"
							, "(SELECT l1.ffld_num FROM ^lic_fld AS l1 WHERE l1.fid=" + sqlTo(vidan_lsfid)  + ")"
							, 0) + " AS ffld_num" 
					+ ", " + vidan_lsfid + " AS flsfid"
					+ ", " + IIF(sumt_kvid + "<0", "0", sumt_kvid) + " AS fsum"
			+ " FROM ^" + svzpTable + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
			+ " WHERE 1=1 " + sqlTabn
			+ " GROUP BY s.ftabn_id";
	ExecuteSQL(strSQL);          
	
	//--------запись сумм в SVZP "долг на будущее"
	//11.12.07 Исправила аналог. r_nachi2, ошибку исправил Олег в Брокарде	
	strSQL = "INSERT INTO ^"+ svzpTable
				+ " (ftabn_id,fwid_wp, ffld_num, flsfid, fsum)"
			+ " SELECT s.ftabn_id,0 as fwid_wp"
					+ ", " + IIF(sqlTo(dlgNxt_lsfid) + "<>0"
							, "(SELECT l1.ffld_num FROM ^lic_fld AS l1 WHERE l1.fid=" + sqlTo(dlgNxt_lsfid)  + ")"
							, 0) + " AS ffld_num" 
					+ ", " + dlgNxt_lsfid + " AS flsfid"
					+ ", " + IIF(sumt_kvid + "<0", sumt_kvid, ssum_dolg) + " AS fsum"					
			+ " FROM ^" + svzpTable + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
			+ " WHERE 1=1 " + sqlTabn
			+ " GROUP BY s.ftabn_id";
	ExecuteSQL(strSQL); 
	
	if (is_rasch)
	{
		strSQL = "INSERT INTO ^"+nxtTbl+" (ftabn_id,fwid_wp, flsfid, ffld_num, fshpz, fsum, fis_day, fday, fchas, fmn, fmn1, fid_prk)"
			+ " SELECT s.ftabn_id,s.fwid_wp, s.flsfid, s.ffld_num, s.fshpz, s.fsum, s.fis_day, s.fday, s.fchas"
				+ ", " + sqlTo(month) + " AS fmn"
				+ ", " + IIF("s.fvp=2", "s.fmn", sqlTo(month)) + " AS fmn1"
				+ ", fid_prk"
			+ " FROM ^" + svzpTable + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
			+ " WHERE (" + strOffset + ")>1"
				+ " AND l.fncmp=" + sqlFalse + sqlTabn;
		ExecuteSQL(strSQL);
	}

//	if (is_rasch)
//	{
//		//11.12.07 Исправила аналог. r_nachi2, ошибку исправил Олег в Брокарде		
//		//05.10.07  Будущие суммы должны записываться и в отдельный файл DLG, иначе в след.мес.будут проблемы
//		strSQL = "INSERT INTO ^"+ dlgTable
//				+ " (ftabn_id, ffld_num, flsfid, fsum)"
//			+ " SELECT s.ftabn_id"
//					+ ", " + IIF(sqlTo(dlgPrv_lsfid) + "<>0"
//							, "(SELECT l1.ffld_num FROM ^lic_fld AS l1 WHERE l1.fid=" + sqlTo(dlgPrv_lsfid)  + ")"
//							, 0) + " AS ffld_num" 
//					+ ", " + dlgPrv_lsfid + " AS flsfid"
//					+ ", " + IIF(sumt_kvid + "<0", sumt_kvid, ssum_dolg) + " AS fsum"					
//			+ " FROM ^" + svzpTable + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
//			+ " WHERE 1=1 " + sqlTabn
//			+ " GROUP BY s.ftabn_id";
//		ExecuteSQL(strSQL);          
//	}

    //16.01.08 Забыли перенести из 2000 версии. Выдача ЗП с копейками для уволенных по параметру
    dat_uv = d00obj;
    if (kopuv!=0){
        strSQL = "SELECT Fwid_cl,Fedat,Fvopl,Ftable "
                      + " FROM ^work_pers"
                      + " WHERE FEDAT >= " + sqlTo(D1) + " AND FEDAT <= " + sqlTo(D2)
                      	+ " AND Fis_uv = " + SqlTrue + (ftabn_id?" and Fwid_cl in ("+ftabn_id+") ":"")
                      +" ORDER BY Fwid_cl,Fvopl,Fedat DESC"
        UVOL_table = OpenTable("s", strSQL); 
        if (!UVOL_table.IsEmpty()){
           UVOL_table.MoveFirst();
           while (!UVOL_table.IsEOF()){	
           		dat_uv = new Date(UVOL_table.getValue("Fedat"));
           		pFtabn = UVOL_table.getValue("Fwid_cl")
           		strSQL = "SELECT Fwid_cl,Fbdat,Fvopl,Ftable "
                      + " FROM ^work_pers"
                      + " WHERE Fwid_cl="+sqlTo(pFtabn)+" and FBDAT >" + sqlTo(dat_uv) + " AND FBDAT <= " + sqlTo(D2)
                      + " AND Fis_nazn = " + SqlTrue+" ORDER BY Fvopl,Fbdat"
	       		PRIN_table = OpenTable("s", strSQL); 
           		if (!PRIN_table.IsEmpty()){
              		dat_uv = d00obj;
           		}
           		PRIN_table.close();
           		if (differ(dat_uv,d00obj)!=0){
           			sumkvid = 0           			
           			oSnap0 = getSnap("select Fsum from ^"+svzpTable+" where Flsfid="+sqlTo(vidan_lsfid)+" and Ftabn_id="+sqlTo(pFtabn))
           			if (oSnap0!=null){
           				sumkvid = oSnap0[0]
           			}
           			
           			oSnap = getSnap("select Fsum from ^"+svzpTable+" where Flsfid="+sqlTo(dlgNxt_lsfid)+" and Ftabn_id="+sqlTo(pFtabn))
           			if (oSnap!=null){
           				strSQL = "UPDATE ^"+svzpTable+" set Fsum="+sqlTo(sumkvid+oSnap[0])+" where Ftabn_id="+sqlTo(pFtabn)+" and Flsfid="+sqlTo(vidan_lsfid)
           				ExecuteSQL(strSQL);
           				strSQL = "UPDATE ^"+svzpTable+" set Fsum=0 where Ftabn_id="+sqlTo(pFtabn)+" and Flsfid="+sqlTo(dlgNxt_lsfid)
           				ExecuteSQL(strSQL);
           				strSQL = "UPDATE ^"+dlgTable+" set Fsum=0 where Ftabn_id="+sqlTo(pFtabn)+" and Flsfid="+sqlTo(dlgPrv_lsfid)
           				ExecuteSQL(strSQL);
           			}
           		}
           		UVOL_table.MoveNext();           		
           }		
           
        }
		UVOL_table.close();
    }

	ExecuteSQL("delete from ^" + svzpTable + " where (fsum is null or fsum=0)  and (Fdnkl=0 or Fdnkl is null) " + sqlTabn);
	ExecuteSQL("UPDATE ^" + svzpTable + " set Fwid_wp=0 where fwid_wp is null " + sqlTabn);
	ExecuteSQL("delete from ^" + dlgTable + " where (fsum is null or fsum=0) " + sqlTabn);
}