//перерасчет подоходного налога за год с 2011 года в момент расчета зарплаты
//первое поле ЛС mvvcslid будем использовать как справочное для подоходного налога по соцстраху 
include("servis/zrp.js");
include("get_cnst.js")
include("servis\\date.js")

function r_nlgnall(mdat,vvopl,vvprk,mvvcslid,VVLSFID2,ftabn_id,svzpName)
{
	mdat = new Date(mdat);

    //константа, сколько месяцев нужно не учитывать будущие суммы в текущем месяце
    //по новому закону отпускные будущие за январь, начисленные в декабре, нельзя перерасчитывать.
    dtbotp = get_cnst ("dtbotp", mdat);
	//константа определяющая алгоритм расчета подоходного налога при превышении десяти прожиточных минимумов:
	//	0 - "законный" расчет когда 15 % применяются к 10-и прож.минимумам, а от оставшейся суммы базы подоходного налога отнимаем ЕСВ и находим 17 %
	//	1 - алгоритм на котором настаивет налоговая, нужно отдельно находить сумму ЕСВ, которая относится к 10-и прож.минимумам 
	// 	(приоритет: ЕСВ от ЗП, больничных) и отнимать от каждой базы соответствующий ЕСВ, а затем применять ставку 
	var nlgnal = get_cnst("nlgnal", mdat);
	var fld_fndbz = false;
	var fld_fndbb = false;
	var fld_fndbt = false;
	if(nlgnal)
	{
		strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis12='5' AND fis_slct=" + sqlTrue;
		snap = getSnap(strSQL);	
		if(null != snap)
		{
		    fld_fndbz = true
		    var nach_lsfbz = snap[0]
		    var nach_lsnbz = snap[1]
		}
	
		strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis12='6' AND fis_slct=" + sqlTrue;
		snap = getSnap(strSQL);
		if(null != snap)
		{
		    fld_fndbb = true
		    var nach_lsfbb = snap[0]
		    var nach_lsnbb = snap[1]
		}
	
		strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis12='7' AND fis_slct=" + sqlTrue;
		snap = getSnap(strSQL);
		if(null != snap)
		{
		    fld_fndbt = true
		    var nach_lsfbt = snap[0]
		    var nach_lsnbt = snap[1]
		}
	}

	strSQL = "SELECT DISTINCT Fid,Ffld_num FROM ^LIC_FLD WHERE Fis1='п' and FIS_SLCT="+sqlTrue+" ORDER BY Ffld_num";
	snap = getSnap(strSQL);
	var nach_lsfi1=0;
	var nach_lsnu1=0;
	var fld_found1 = false;
  
	if (snap == null)
	{
			return false;     
	}
	else
	{
			nach_lsfi1 = snap[0];
			nach_lsnu1 = snap[1];
			fld_found1 = true;
	}
	
 	strSQL = "SELECT Fid,Ffld_num FROM ^LIC_FLD WHERE Fis1='s' and FIS_SLCT="+sqlTrue;
	snap = getSnap(strSQL);
	var nach_lsfi2=0;
	var nach_lsnu2=0;
	var fld_found2 = false;
	if (snap != null)
	{
			nach_lsfi2 = snap[0];
			nach_lsnu2 = snap[1];
			fld_found2 = true;
	}
	
  	strSQL = "SELECT Fid,Ffld_num FROM ^LIC_FLD WHERE Fis9='t' and FIS_SLCT="+sqlTrue;
	snap = getSnap(strSQL);
	var nach_lsfim=0;
	var nach_lsnum=0;
	var fld_found3 = false;
  	if (snap != null)
	{
   		nach_lsfim = snap[0];
  		nach_lsnum = snap[1];
  		fld_found3 = true;
  	}

	//декабрь 2010 зададим явно в программе
    //по новому закону отпускные будущие за январь, февраль и т.д. начисленные в декабре, нельзя перерасчитывать.
    mnbotp = new Date(2010,11,1)
   
	// дата начала
	var D1 = new Date(firstDayMonth(mdat)); 
	// дата конца
	var D2 = new Date(lastDayMonth(mdat)); 
  	
    var snap;
	var vdpl2=0; 
    strSQL = "select Ffld_num from ^LIC_FLD where Fid="+sqlTo(VVLSFID2);
    snap = getSnap(strSQL);
    if (snap != null)
		vdpl2 = snap[0];
 
	//вместо массивов создадим и сгрузим все во временную таблицу
	if(IsTable("tmp_nalog"))
		DropTable("tmp_nalog");
	ExecuteSQL("update ^nalog set F_tbl=1 where F_tbl=0 or F_tbl is null");
	//проапдейтим базовый налог и суммы, которые расчитываются по выражению
	var tNal = OpenTable("select * from ^nalog where F_tbl = 1 and Fbdat<="+sqlTo(D2)+" and Fedat>="+sqlTo(D1));
	for(; !tNal.IsEOF(); tNal.MoveNext())
	{
		var m = new Object();
		var toUpdate = false
		if(allt(tNal.getValue("F_stsum_expr")).length>0)
		{
			toUpdate = true;
			var val = constEval(tNal.getValue("F_stsum_expr"), D1);
			if(val == null || val == Infinity)
			{
				msg = "В справочнике ставок подоходного налога некорректное выражение для базовой суммы"+(val == Infinity?" (ошибка деления на ноль)":"")
						+"!\nРасчет подоходного налога не может быть выполнен!";
				return;
			}
			m.F_stsum = val;
		}
		if(allt(tNal.getValue("F_basnl_expr")).length>0)
		{
			toUpdate = true;
			var val = constEval(tNal.getValue("F_basnl_expr"), D1);
			if(val == null || val == "Infinity")
			{
				msg = "В справочнике ставок подоходного налога некорректное выражение для базового налога"+(val == Infinity?" (ошибка деления на ноль)":"")
						+"!\nРасчет подоходного налога не может быть выполнен!";
				return;
			}
			m.F_basnl = val;
		}
		if(toUpdate)
			UpdateTable("^nalog", m, false, "Fwid="+tNal.getValue("Fwid"));
	}
	tNal.close();
	ExecuteSQL("select F_stsum, F_basnl, F_proc/100 as F_proc, Fbdat "
				+" into tmp_nalog "
				+" from ^nalog "
				+" where F_tbl = 1 and Fbdat<="+sqlTo(D2)+" and Fedat>="+sqlTo(D1)
				+" order by Fbdat,F_stsum")
	var snapNLG = getSnap("select COUNT(*) from tmp_nalog");
	if(snapNLG[0]==0)
	{
		msg = "В справочнике ставок подоходного налога не найдено записей соответствующих периоду расчета!\nРасчет подоходного налога не может быть выполнен!";
		return;
	}
    
	var nlgOgr = 10*get_cnst("progmin",mdat);
	//для алгоритма налоговой универсального расчета не будет, исходим из того, что в справочнике ставок будет 2 записи
	var minProc = 15;
	var maxProc = 17;
	if(nlgnal)
	{
		//найдем сумму ограничения для минимальной ставки подоходного налога
		var snap = getSnap("select MAX(F_stsum) as F_stsum, MIN(F_proc) as Fmin_proc, MAX(F_proc) as Fmax_proc from tmp_nalog");
		if(snap)
		{
			nlgOgr = snap[0];
			minProc = snap[1]*100;
			maxProc = snap[2]*100;
		}
		else
		{
			msg = "Ошибка в справочнике ставок подоходного налога!\nРасчет подоходного налога не может быть выполнен!";
			return;
		}
	}
    
	var Nalog_table, Lic_table, Shtat_table, PSVZP_table, SVZP_table;
	var szTag, szTagPrev;
	var gS;
	var svzpTblName;

    za_tek_mes = getPar("CUR_PN");
	// достаем цифры к названию файла
	szTag = getDateTag(mdat);
	// достаем цифры к названию файла прошлого месяца
	szTagPrev = getDateTag(new Date(mdat.getFullYear(),mdat.getMonth()-1,1));

	WAIT(ru("Шаг 2 - вычисление сводных сумм","Крок 2 - обчислення зв_дних сум"));

	var pFtabn;
	svzpTblName = "SVZP_ALL1M";
	
				// дата начала
			var D1 = new Date(firstDayMonth(mdat)); 
			   // дата конца
			   var D2 = new Date(lastDayMonth(mdat)); 

			   // -------- pitan  - сумма на питание, не облагаемая подоходным налогом
			   var pitan   = get_cnst ("min_pit", mdat)
			   //вместо константы proc_s для совместителей будем использовать ту же шкалу ставок подоходного налога, что и для основных сотрудников
			   // сумма социальной льготы
			   soc_lgot = get_cnst ("soclgot" , mdat)
			   // сумма прож.мин.*1.4, окр.до ближ.10 грн.
			   minnal = get_cnst ("minnal" , mdat)
			   // необлаг.процент по страховке за счет предприятия
			   procsl = get_cnst ("procsl", mdat)
			   // необла. сумма на погребение своего сотрудника
			   npogr = get_cnst ("npogr", mdat)
			   // изменениe льгты на детей - 1 c 01.01.05, 0 - пред.периоды
			   izmlg = get_cnst ("izmlg", mdat)
			   // изменениe льгты на буд. периоды
			   izmnx = get_cnst ("izmnx", mdat)

			   //-------------------------------------------------------------------------------------------------------------------
			   //в таблице SVZP расчитаем отдельное поле Foffset
			   // * поле Fvp=0 если месяц выплаты и если месяц возникн-я равны месяцу файла
			   // * поле Fvp=1 если месяц выплаты=Fmn, а месяц возникн-я равен месяцу файла
			   // * поле Fvp=2 если месяц выплаты равен месяцу файла, а месяц возникн-я=Fmn
			   // * offset = 0 для пpошлых месяцев, 1 для текущего месяца, 2 - для следующего, и т.д.
			   var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+") ":"";
			   if(SUBD==DERBY)
				   var strOffset = IIF("fvp=0"
						, 1
						,  IIF("fvp=2"
						,IIF(sqlTo(D1)+">fmn"
							,"-"+sqlRound(sqlRound(SqlDaysBWDates(sqlTo(D1),"fmn"),0) + "/30.0",0)
							,sqlRound(sqlRound(SqlDaysBWDates(sqlTo(D1),"fmn"),0) + "/30.0",0))+"+1"
							, 0));
			   else
				   var strOffset = IIF("fvp=0"
						, 1
						,  IIF("fvp=2"
							, sqlRound(sqlRound(SqlDaysBWDates(sqlTo(D1),"fmn"),0) + "/30.0",0) + "+1"
							, 0));
			   ExecuteSQL("update "+svzpTblName+" set Foffset="+strOffset+" where 1=1 "+sqlTabn);

			   //для служебных записей перебьем foffset на -1, чтобы не путать их с записями отпускных с минусом за будущие периоды
			   if (dtbotp!=0 && dtbotp!=null){ 
				   ExecuteSQL("update "+svzpTblName+" set Foffset=-1 where Fvp=1 and Fmn>"+sqlTo(D1)+" and 1=1 "+sqlTabn);
			   }	
	
			   //* формируем суммы с проверкой входимости в налогооблагаемую сумму
			   //* пpизнак входимости в налогооблагаемую сумму определяется по первой
			   //* колонке (Fis1) таблицы LIC_FLD
	
			   //* сумма общего дохода
			   ssumdox = "SUM("+IIF("l.Fis6='+' OR (L.FIS6 NOT IN ('-','н','у','ф','з','п','б')"
				+" AND L.FIS12 NOT IN ('t','g','*','$','!','#','%','&','r','f','l','h','x','b','p','z','s','n','о'"
				+",'т','с','л','e','y','a','u','1','2','3','4','5','6','7','0','k','x','v','w','8','9'))","s.Fsum", 0)+")"; 
			   //* льготы по акциям
			   ssuml = "SUM("+IIF("l.Fis1='а'","s.Fsum", 0)+")" 
			   //* включение в налогооблагаемую сумму доходов по месту осн. работы и не по месту осн.работы
			   ssumd = "SUM("+IIF("l.Fis9='*'","s.Fsum", 0)+")"
			   //* сумма страховки без учета для льготы
			   ssumsn = "SUM("+IIF("l.Fis9='+'","s.Fsum", 0)+")"
			   //* сумма страховки c учетом для льготы
			   ssumso = "SUM("+IIF("l.Fis9='#'","s.Fsum", 0)+")"
			   //* сумма на погребение
			   ssumpg = "SUM("+IIF("l.Fis9='п'","s.Fsum", 0)+")"
			   //* сумма на мат.пом. осн.
			   ssummp = "SUM("+IIF("l.Fis1='+' and l.Fis9='м'","s.Fsum", 0)+")"
			   //* сумма на мат.пом. совм.
			   ssummps = "SUM("+IIF("l.Fis1='#' and l.Fis9='м'","s.Fsum", 0)+")"
			   //* включение в налогооблагаемую сумму доходов 
			   ssum = "SUM("+IIF("l.Fis1='+' and (l.Fis9 not in ('*', '+', '#', 'п', 'о', 'у', 'т', 'н', 'м', 'б') or l.Fis9 is null)","s.Fsum", 0)+")"
			   //* включение в налогооблагаемую сумму выплат на питание
			   ssum_p = "SUM("+IIF("l.Fis1='p'","s.Fsum", 0)+")"
			   //* исключение из налогооблагаемой суммы задолженности г-ву для ЗК
			   ssum_z = "SUM("+IIF("l.Fis5='г'","s.Fsum", 0)+")"
			   //* включение в налогооблагаемую сумму доходов по совместительству
			   ssum_s = "SUM("+IIF("l.Fis1='#' and (l.Fis9 not in ('т', 'м', 'п', 'б') or l.Fis9 is null)","s.Fsum", 0)+")"
			   var minusTs = get_cnst("minusts",mdat);//константа позволяющая отнимать от базы налогообложения ЕСВ по тр.соглашениям
			   var uderg_nlgts = "SUM("+IIF("l.Fis5='-' and l.Fis8='7'","s.Fsum", 0)+")";//ЕСВ по тр.соглашениям
			   //* удержанные налоги в фонды, за исключением ЕСВ по тр.соглашениям
			   uderg_nlg = "SUM("+IIF("l.Fis5='-' and l.Fis8<>'7'","s.Fsum", 0)+")";
			   //* сумма обучения без учета для льготы
			   ssumon = "SUM("+IIF("l.Fis9='о'","s.Fsum", 0)+")"
			   //* сумма обучения c учетом для льготы
			   ssumoo = "SUM("+IIF("l.Fis9='у'","s.Fsum", 0)+")"
			   //* сумма трудового соглашения
			   ssumtr = "SUM("+IIF("l.Fis1='#' and l.Fis9='т'","s.Fsum", 0)+")"
			   //* необл.суммы для учета льготы 
			   ssum_n = "SUM("+IIF("l.Fis9='н'","s.Fsum", 0)+")"
			   // суммы будущих отпускных c минусом	
			   ssumotb = "SUM("+IIF("l.Fis19='о'","s.Fsum", 0)+")";
			   //база ЕСВ с з/п
			   esvbase_zp = nlgnal && fld_fndbz?"SUM("+IIF("l.Fid="+nach_lsfbz,"s.Fsum", 0)+")":"0";
			   //база ЕСВ с трудовых соглашений
			   esvbase_ts = nlgnal && fld_fndbt?"SUM("+IIF("l.Fid="+nach_lsfbt,"s.Fsum", 0)+")":"0";
			   //база ЕСВ с больничных
			   esvbase_bl = nlgnal && fld_fndbb?"SUM("+IIF("l.Fid="+nach_lsfbb,"s.Fsum", 0)+")":"0";
			   //база ЕСВ с больничных CC (берем не по справочному полю ЛС, а по признаку больн.с/с для персонификации, т.к. для подоходного налога не применяется сумма ограничения)
			   esvbase_soc = "SUM("+IIF("(l.Fis19='b' or l.Fis19='f')","s.Fsum", 0)+")";
			   //база ЕСВ с больничных НСЛ (берем не по справочному полю ЛС, а по признаку больн.с/с для персонификации, т.к. для подоходного налога не применяется сумма ограничения)
			   esvbase_nsl = "SUM("+IIF("l.Fis19='f'","s.Fsum", 0)+")";
			   //база ЕСВ с больничных предприятия (берем не по справочному полю ЛС, а по признаку больн.предпр.для персонификации, т.к. для подоходного налога не применяется сумма ограничения)
			   esvbase_pp = "SUM("+IIF("l.Fis19='б'","s.Fsum", 0)+")";
			   //% ЕСВ с з/п
			   esvproc_zp = nlgnal && fld_fndbz?"MAX("+IIF("l.Fid="+nach_lsfbz,"s.Fproc", 0)+")":"0";
			   //% ЕСВ с трудовых соглашений
			   esvproc_ts = nlgnal && fld_fndbt?"MAX("+IIF("l.Fid="+nach_lsfbt,"s.Fproc", 0)+")":"0";
			   //% ЕСВ с больничных
			   esvproc_bl = nlgnal && fld_fndbb?"MAX("+IIF("l.Fid="+nach_lsfbb,"s.Fproc", 0)+")":"0";
			   //удержание ЕСВ соцстраха
			   uderg_soc = "0";
			   //удержание ЕСВ из больн НСЛ
			   uderg_snsl = "0";
			   //* сумма неденежной выплаты
			   ssumned   = "SUM("+IIF("l.Fis9='б'","s.Fsum", 0)+")"
			   //* сумма неденежной выплаты
			   ssumned15 = "SUM("+IIF("l.Fis9='б'","s.Fsum", 0)+")"
			   //* сумма неденежной выплаты
			   ssumned17 = "SUM("+IIF("l.Fis9='б'","s.Fsum", 0)+")"
			   //* сумма неденежной выплаты
			   ssumnedob = "SUM("+IIF("l.Fis9='б'","s.Fsum", 0)+")"
			   //удержанная сумма подоходного налога 
			   uderg_pnlg = "SUM("+IIF("(l.Fis1='п' and l.Fid<>"+sqlTo(mvvcslid)+") or (l.Fis1='s' and l.Fid<>"+sqlTo(mvvcslid)+")","s.Fsum", 0)+")";			   

			   //для небазового месяца:если переход на новый налог с 2011, то нужно закачать будущие суммы начислений c минусом
			   var is_rasch=(differ(base_month,mdat)==0)
			   var tmpTblot = "TEMP_SUMOTB";
			   if(IsTable(tmpTblot))
				   DropTable(tmpTblot);
	
			   ExecuteSQL("create table "+tmpTblot+"("
					   //поля из SVZP
					   +" Ftabn_id "+sqlType("LONG")
					   //+", Flsfid "+sqlType("INT")
					   +", Fmn "+sqlType("DATE")			
					   +", Fvp "+sqlType("BYTE")
					   +", Foffset "+sqlType("SHORT")
					   //будущие отпускные с минусом			
					   +", Fsumotb "+sqlType("MONEY")+" default 0"
					+")")
	
				if (is_rasch && dtbotp!=0 && dtbotp!=null){
					//для базового месяца NXT закачисваются, для небазового для переходного периода нужно самим дозакачать
					//создади временную таблицу SUMOTB в которую выберем будущие отпускные с минусом
					ExecuteSQL("insert into "+tmpTblot+"(Ftabn_id,Fmn,Fvp,Foffset,Fsumotb)"
							+" select s.Ftabn_id, s.Fmn, s.Fvp, 1 as Foffset, "+ssumotb+" as Fsumotb "
							+"  from "+svzpTblName+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
							+" where s.Fvp=1 and s.Fmn<="+sqlTo(mnbotp)+" and s.Foffset=0 "+sqlTabn
							+" group by s.Ftabn_id, s.Fmn, s.Fvp, s.Foffset");
				}
			   if (!is_rasch && dtbotp!=0 && dtbotp!=null){
				   //будущие суммы с минусом с 2010 года берем только по начислениям
				   strSQL =  "INSERT INTO "+tmpTblot+"(Ftabn_id,Fmn,Fvp,Foffset,Fsumotb)"
				   +" select nu.Ftabn_id, nu.Fmn, 1 as Fvp, 1 as Foffset, SUM("+IIF("l.Fis19='о'","nu.Fsum", 0)+")*(-1) as Fsumotb "
				   +" from (^nxt AS nu INNER JOIN ^lic_fld as l ON l.fid=nu.flsfid ) "			
				   +" WHERE l.Fis6='+' and nu.Fmn<="+sqlTo(mnbotp)+" and nu.fmn1=" + sqlTo(D1) + (ftabn_id?" and nu.Ftabn_id in ("+ftabn_id+") ":"")+" group by nu.Ftabn_id, nu.Fmn";
				   ExecuteSQL(strSQL);
			   } 

			   //создади временную таблицу SUMSVZP в которую будем расчитывать все суммы сгруппированные по Foffset
			   //и все остальные промежуточные и результирующие вычисления  
			   var tmpTbl = "TEMP_SUMSVZP";
			   if(IsTable(tmpTbl))
				   DropTable(tmpTbl);
			   ExecuteSQL("create table "+tmpTbl+"("
			   				//поля из SVZP
			   				+" Ftabn_id "+sqlType("LONG")
			   				//	+", Flsfid "+sqlType("INT")
			   				+", Fvp "+sqlType("BYTE")
			   				+", Foffset "+sqlType("SHORT")
			   				//основные суммы
			   				+", Fssumdox "+sqlType("MONEY")+" default 0"
			   				+", Fssuml "+sqlType("MONEY")+" default 0"
			   				+", Fssumd "+sqlType("MONEY")+" default 0"
			   				+", Fssumsn "+sqlType("MONEY")+" default 0"
			   				+", Fssumso "+sqlType("MONEY")+" default 0"
			   				+", Fssumpg "+sqlType("MONEY")+" default 0"
			   				+", Fssummp "+sqlType("MONEY")+" default 0"
			   				+", Fssummps "+sqlType("MONEY")+" default 0"
			   				+", Fssum "+sqlType("MONEY")+" default 0"
			   				+", Fssum_p "+sqlType("MONEY")+" default 0"
			   				+", Fssum_z "+sqlType("MONEY")+" default 0"
			   				+", Fssum_s "+sqlType("MONEY")+" default 0"
			   				+", Fuderg_nlg "+sqlType("MONEY")+" default 0"
			   				+", Fuderg_nlgts "+sqlType("MONEY")+" default 0"
			   				+", Fuderg_nlg1 "+sqlType("MONEY")+" default 0"
			   				+", Fuderg_nlg2 "+sqlType("MONEY")+" default 0"
			   				+", Fuderg_nlgts1 "+sqlType("MONEY")+" default 0"
			   				+", Fuderg_nlgts2 "+sqlType("MONEY")+" default 0"
			   				+", Fuderg_soc "+sqlType("MONEY")+" default 0"
			   				+", Fuderg_snsl "+sqlType("MONEY")+" default 0"			
			   				+", Fuderg_soc1 "+sqlType("MONEY")+" default 0"
			   				+", Fuderg_soc2 "+sqlType("MONEY")+" default 0"
			   				+", Fesvbase_zp "+sqlType("MONEY")+" default 0"
			   				+", Fesvbase_ts "+sqlType("MONEY")+" default 0"
			   				+", Fesvbase_bl "+sqlType("MONEY")+" default 0"
			   				+", Fesvbase_pp "+sqlType("MONEY")+" default 0"
			   				+", Fesvbase_soc "+sqlType("MONEY")+" default 0"
			   				+", Fesvbase_nsl "+sqlType("MONEY")+" default 0"			
			   				+", F_nal_soc "+sqlType("MONEY")+" default 0"
			   				+", Fisnal_nsl "+sqlType("MONEY")+" default 0"			
			   				+", Fbase_soc1 "+sqlType("MONEY")+" default 0"
			   				+", Fbase_soc2 "+sqlType("MONEY")+" default 0"
			   				+", Fesvproc_zp "+sqlType("MONEY")+" default 0"
			   				+", Fesvproc_ts "+sqlType("MONEY")+" default 0"
			   				+", Fesvproc_bl "+sqlType("MONEY")+" default 0"
			   				+", Fminus_uderg "+sqlType("BIT")+" default "+sqlTrue
			   				+", Fssumon "+sqlType("MONEY")+" default 0"
			   				+", Fssumoo "+sqlType("MONEY")+" default 0"
			   				+", Fssumtr "+sqlType("MONEY")+" default 0"
			   				+", Fssum_n "+sqlType("MONEY")+" default 0"
			   				//в поле Ful_mes записываем признак: налог по полному месяцу
			   				+", Ful_mes "+sqlType("BIT")+" default "+sqlTrue
			   				//сумма льгот
			   				+", Fsum_lg "+sqlType("MONEY")+" default 0"
			   				//суммы страховок
			   				+", Fssum_strn "+sqlType("MONEY")+" default 0"
			   				+", Fssum_stro "+sqlType("MONEY")+" default 0"
			   				//необл.сумма страховки в лицевые счета
			   				+", Fc4sum "+sqlType("MONEY")+" default 0"
			   				//накопленная сумма МАТ.помощи, чтобы определить необлагаемую сумму
			   				+", Fsumallmp "+sqlType("MONEY")+" default 0"
			   				//обл.сумма мат.помощи
			   				+", Fob_mp "+sqlType("MONEY")+" default 0"
			   				//необл.сумма мат.помощи
			   				+", Fneob_mp "+sqlType("MONEY")+" default 0"
			   				//поля для промежуточных вычислений
			   				+", Fxx1 "+sqlType("MONEY")+" default 0"
			   				+", Fxx1s "+sqlType("MONEY")+" default 0"
			   				+", Fozn_pilg "+sqlType("MONEY")+" default 0"
			   				+", Fozn_pilgs "+sqlType("MONEY")+" default 0"
			   				+", Fbpogrosn "+sqlType("BIT")+" default "+sqlFalse
			   				+", F_nal "+sqlType("MONEY")+" default 0"
			   				+", F_nal_s "+sqlType("MONEY")+" default 0"
			   				+", F_nal1 "+sqlType("MONEY")+" default 0"
			   				+", F_nal_s1 "+sqlType("MONEY")+" default 0"
			   				+", F_nal2 "+sqlType("MONEY")+" default 0"
			   				+", F_nal_s2 "+sqlType("MONEY")+" default 0"
			   				//флаг, false - общий случай (льгота 100%); true - % льготы берется из приказа
			   				+", Fis_prik "+sqlType("BIT")+" default "+sqlFalse
			   				//% льготы
			   				+", Fprk_proc "+sqlType("MONEY")+" default 0"
			   				//кол-во детей
			   				+", Fprk_det "+sqlType("MONEY")+" default 0"
			   				//кол-во детей инв
			   				+", Fkol_indet "+sqlType("MONEY")+" default 0"
			   				//% детей инв
			   				+", Fprk_indet "+sqlType("MONEY")+" default 0"
			   				//не увелич.базу на кол.детей
			   				+", Fisuvbaz "+sqlType("BYTE")+" default 0"
			   				//обучение
			   				+", Fssum_obn "+sqlType("MONEY")+" default 0"
			   				+", Fssum_obo "+sqlType("MONEY")+" default 0"
			   				+", Fssum_pog "+sqlType("MONEY")+" default 0"
			   				//налогооблагаемый остаток выплат на питание
			   				+", Fost_na_pit "+sqlType("MONEY")+" default 0"
			   				//налогообл.сумма по осн.работе
			   				+", F_sum_zp "+sqlType("MONEY")+" default 0"
			   				+", F_sum "+sqlType("MONEY")+" default 0"
			   				//налогообл.сумма по совместит.
			   				+", F_sum_s "+sqlType("MONEY")+" default 0"
			   				//сумма льготы
			   				+", Fl_xxx "+sqlType("MONEY")+" default 0"
			   				+", Fl_xxx_s "+sqlType("MONEY")+" default 0"
			   				//облаг.мат.помощь
			   				+", Fobl_mp "+sqlType("MONEY")+" default 0"
			   				//необлаг.мат.помощь
			   				+", Fnobl_mp "+sqlType("MONEY")+" default 0"
			   				//облаг.мат.помощь по совм.
			   				+", Fobl_mps "+sqlType("MONEY")+" default 0"
			   				//	необлаг.мат.помощь по совм.
			   				+", Fnobl_mps "+sqlType("MONEY")+" default 0"
			   				+", Fsumotb "+sqlType("MONEY")+" default 0"
			   				//% подоходного налога, для отображения в лицевых счетах
			   				+", Fproc "+sqlType("MONEY")+" default 0"
			   				//неденежные выплаты
			   				+", Fssumned "+sqlType("MONEY")+" default 0"			
			   				+", Fssumned15 "+sqlType("MONEY")+" default 0"
			   				+", Fssumned17 "+sqlType("MONEY")+" default 0"
			   				+", Fssumnedob "+sqlType("MONEY")+" default 0"
							+", Fuderg_pnlg "+sqlType("MONEY")+" default 0"			   				
			   				+")")
			   				ExecuteSQL("insert into "+tmpTbl+"(Ftabn_id,Fvp,Foffset,Fssumdox,Fssuml,Fssumd,Fssumsn,Fssumso,"
			   						+" Fssumpg,Fssummp,Fssummps,Fssum,Fssum_p,Fssum_z,Fssum_s,Fuderg_nlg,Fuderg_nlgts,Fssumon,Fssumoo,"
			   						+" Fssumtr,Fssum_n, Fsumotb,Fesvbase_zp,Fesvbase_ts,Fesvbase_bl,Fesvbase_soc,Fesvbase_nsl,Fesvbase_pp,"
			   						+" Fuderg_soc,Fuderg_snsl,Fesvproc_zp,Fesvproc_ts,Fesvproc_bl,Fssumned15,Fssumned17,Fssumnedob,Fssumned,Fuderg_pnlg)"
			   						+" select s.Ftabn_id, s.Fvp, s.Foffset,"+ssumdox+" as Fssumdox,"+ssuml+" as Fssuml,"+ssumd+" as Fssumd,"
			   						+ssumsn+" as Fssumsn,"+ssumso+" as Fssumso,"+ssumpg+" as Fssumpg,"+ssummp+" as Fssummp,"+ssummps+" as Fssummps,"
			   						+ssum+" as Fssum,"+ssum_p+" as Fssum_p,"+ssum_z+" as Fssum_z,"+ssum_s+" as Fssum_s,"
			   						+uderg_nlg+" as Fuderg_nlg,"+uderg_nlgts+" as Fuderg_nlgts,"+ssumon+" as Fssumon,"+ssumoo+" as Fssumoo,"+ssumtr+" as Fssumtr,"+ssum_n+" as Fssum_n, 0 as Fsumotb, "
			   						+esvbase_zp+" as Fesvbase_zp,"+esvbase_ts+" as Fesvbase_ts,"+esvbase_bl+" as Fesvbase_bl,"+esvbase_soc+" as Fesvbase_soc,"+esvbase_nsl+" as Fesvbase_nsl,"
			   						+esvbase_pp+" as Fesvbase_pp,"+uderg_soc+" as Fuderg_soc,"+uderg_snsl+" as Fuderg_snsl,"
			   						+esvproc_zp+" as Fesvproc_zp,"+esvproc_ts+" as Fesvproc_ts,"+esvproc_bl+" as Fesvproc_bl,"+ssumned15+" as Fssumned15, "+ssumned17+" as Fssumned17, "+ssumnedob+" as Fssumnedob, "+ssumned+" as Fssumned, "+uderg_pnlg+" as Fuderg_pnlg "
			   						+" from "+svzpTblName+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
			   						+" where s.Foffset>0 "+sqlTabn
			   						+" group by s.Ftabn_id, s.Fvp, s.Foffset");
	
			   	ExecuteSQL("update "+tmpTbl+" set Fuderg_soc=Fuderg_snsl where Fuderg_snsl<>0 and not Fuderg_snsl is null")
			
			   	if(getSnap("select COUNT(*) FROM "+tmpTbl)==0)
			   			return true;
			   		
			   	var sSqlMonth = 'MONTH'
			   	if(SUBD==DERBY)
			   		sSqlMonth = "'MONTH'"
			   	var strFmn = IIF("Foffset>1", sqlDateAdd(sqlTo(mdat),"Foffset-1", sSqlMonth), sqlTo(d00));
			   		
			   	ExecuteSQL("update "+tmpTbl+" set Ful_mes="+sqlFalse
			   				+" where exists(select Fwid from ^work_pers as w where w.Fwid_cl="
			   				+tmpTbl+".Ftabn_id and w.Fbdat<="+sqlTo(D2)+" and w.Fedat>="+sqlTo(D1)+" and w.Fnazn="+sqlTrue
			   		//	по логике налог не по полному месяцу берется если человек принят либо уволен в месяце расчета
			   		//(при наличии галочки "не учит.соц.льготы" в ШР),
			   		//но т.к. на поля Fis_nazn и Fis_uv надеятся на 100% нельзя,
			   		//то используем следующее хитромудрое уловие от Яны Михайловны 
			   				+" and ((w.Fedat<>"+sqlTo(d00)+" and "+sqlMonth("w.Fedat")+"="+sqlTo(mdat.getMonth()+1)+") or "
			   				+"("+sqlDay("w.Fbdat")+"<>1 and "+sqlMonth("w.Fbdat")+"="+sqlTo(mdat.getMonth()+1)+")))");
			   		
			   	ExecuteSQL("update "+tmpTbl+" set Fis_prik="+sqlTrue+" where exists(select Fproc from ^prk_all "
							+" where Fvid_prk="+sqlTo(vvprk)+" and Ftabn_id="+tmpTbl+".Ftabn_id "
								+" and Fbdat<="+sqlTo(D2)+" and Fedat>="+sqlTo(D1)+")");
			   	ExecuteSQL("update "+tmpTbl+" set Fprk_proc=(select MAX(Fproc) from ^prk_all "
							+" where Fvid_prk="+sqlTo(vvprk)+" and Ftabn_id="+tmpTbl+".Ftabn_id "
								+" and Fbdat<="+sqlTo(D2)+" and Fedat>="+sqlTo(D1)+")");
			   	ExecuteSQL("update "+tmpTbl+" set Fprk_proc=0 where Fprk_proc is null");
			   	ExecuteSQL("update "+tmpTbl+" set Fis_prik="+sqlTrue+", Fprk_proc=0 where Ful_mes="+sqlFalse);
			   		//	if (prk_proc==150) ozn_pilg = 2;
			   		//	if (prk_proc==200) ozn_pilg = 3;
			   	ExecuteSQL("update "+tmpTbl+" set Fozn_pilg="+IIF("Fprk_proc=150", 2, IIF("Fprk_proc=200", 3, 0)));
			   		
			   	ExecuteSQL("update "+tmpTbl+" set Fprk_det=(select MAX(Fproc) from ^prk_all "
							+" where Fin_table="+sqlTo("PRK_DET")+" and Ftabn_id="+tmpTbl+".Ftabn_id "
								+" and Fbdat<="+sqlTo(D2)+" and Fedat>="+sqlTo(D1)+")");
			   	ExecuteSQL("update "+tmpTbl+" set Fprk_det=0 where Fprk_det is null");
	
			   	ExecuteSQL("update "+tmpTbl+" set Fprk_indet=(select MAX(Fsum) from ^prk_all "
			   				+" where Fin_table="+sqlTo("PRK_DET")+" and Ftabn_id="+tmpTbl+".Ftabn_id "
			   				+" and Fbdat<="+sqlTo(D2)+" and Fedat>="+sqlTo(D1)+")");
			   	ExecuteSQL("update "+tmpTbl+" set Fprk_indet=0 where Fprk_indet is null");
	
			   	ExecuteSQL("update "+tmpTbl+" set Fkol_indet=(select MAX("+Convert("Fnom_prik","MONEY")+") from ^prk_all "
			   				+" where Fin_table="+sqlTo("PRK_DET")+" and Ftabn_id="+tmpTbl+".Ftabn_id "
			   				+" and Fbdat<="+sqlTo(D2)+" and Fedat>="+sqlTo(D1)+")");
			   	ExecuteSQL("update "+tmpTbl+" set Fkol_indet=0 where Fkol_indet is null");

			   	ExecuteSQL("update "+tmpTbl+" set Fisuvbaz=(select "+IIF(First(IIF("Fis_slct="+sqlTrue,1,0))+"=1",sqlTrue,sqlFalse)+" from ^prk_all "
			   				+" where Fin_table="+sqlTo("PRK_DET")+" and Ftabn_id="+tmpTbl+".Ftabn_id "
			   				+" and Fbdat<="+sqlTo(D2)+" and Fedat>="+sqlTo(D1)+")");
			   	ExecuteSQL("update "+tmpTbl+" set Fisuvbaz=0 where Fisuvbaz is null");
	
			   	//если есть дети, то код льготы ставим 4
			   	ExecuteSQL("update "+tmpTbl+" set Fozn_pilg=4 where Fprk_det>0");

			   	//-------------------------------------------------------------------------------------------------------------------
			   	//расчитываем суммы необлагаемой страховки
			   	//	var sum_lg = (round(ssumdox[ii]*procsl/100,2)>minnal)?minnal:round(ssumdox[ii]*procsl/100,2);
			   	ExecuteSQL("update "+tmpTbl+" set Fsum_lg="+IIF(sqlRound("Fssumdox*"+procsl+"/100",2)+">"+sqlTo(minnal),
									minnal,
									sqlRound("Fssumdox*"+procsl+"/100",2)));
			   	//	var ssum_strn = (ssumsn[ii]-sum_lg>0)?(ssumsn[ii]-sum_lg):0;
			   	//	var ssum_stro = (ssumso[ii]-sum_lg>0)?(ssumso[ii]-sum_lg):0;
			   	ExecuteSQL("update "+tmpTbl+" set Fssum_strn="+IIF("Fssumsn-Fsum_lg>0", "Fssumsn-Fsum_lg", 0)+","+
									" Fssum_stro="+IIF("Fssumso-Fsum_lg>0", "Fssumso-Fsum_lg", 0));
	
			   	if (dtbotp!=0 && dtbotp!=null){	
			   			ExecuteSQL("update "+tmpTbl+" set Fsumotb=(select MAX(Fsumotb) from "+tmpTblot+" where  Ftabn_id="+tmpTbl+".Ftabn_id and Foffset="+tmpTbl+".Foffset)")
			   			ExecuteSQL("update "+tmpTbl+" set Fsumotb=0 where Fsumotb is null")
			   	}		
	
			   	//-------------------------------------------------------------------------------------------------------------------
			   	//результирующая необл.сумма страховки в лицевые счета
			   	//		c4sum=(ssumsn[ii]-ssum_strn)+(ssumso[ii]-ssum_stro);
	   			ExecuteSQL("update "+tmpTbl+" set Fc4sum=Fssumsn-Fssum_strn+Fssumso-Fssum_stro");
		   		//-------------------------------------------------------------------------------------------------------------------
		   		//накопленная сумма МАТ.помощи, чтобы определить необлагаемую сумму
		   		//	начало года расчета мат.помощи 
		   		begy_mdat = new Date(mdat.getFullYear(),0,1)
		   		ExecuteSQL("update "+tmpTbl+" set Fsumallmp=(select SUM(Fsum) from ^prk_fmpl as p where p.Fvd="+sqlTo("MP")
										+" and p.Ftabn_id="+tmpTbl+".Ftabn_id"
										+" and p.Fdat_vp>="+sqlTo(begy_mdat)+" and p.Fdat_vp<"+sqlTo(mdat)+")")
										ExecuteSQL("update "+tmpTbl+" set Fsumallmp=0 where Fsumallmp is null");
 
			   	ExecuteSQL("update "+tmpTbl+" set Fssummp=Fssummp+Fssummps where Fssummp<>0 and Fssummps<>0");
			   	ExecuteSQL("update "+tmpTbl+" set Fssummps=0 where Fssummp<>0 and Fssummps<>0");
			   	ExecuteSQL("update "+tmpTbl+" set Fxx1="+IIF("Fssummp+Fsumallmp-"+minnal+">0", "Fssummp+Fsumallmp-"+minnal, 0)+" where Fssummp<>0");
			   	ExecuteSQL("update "+tmpTbl+" set Fob_mp="+IIF("Fssummp>Fxx1", "Fxx1", "Fssummp")+" where Fssummp<>0");
			   	ExecuteSQL("update "+tmpTbl+" set Fneob_mp="+IIF("Fssummp>Fob_mp", "Fssummp-Fob_mp", 0)+" where Fssummp<>0");
			   	ExecuteSQL("update "+tmpTbl+" set Fxx1s="+IIF("Fssummps+Fsumallmp-"+minnal+">0", "Fssummps+Fsumallmp-"+minnal, 0)+" where Fssummps<>0");
			   	ExecuteSQL("update "+tmpTbl+" set Fob_mp="+IIF("Fssummps>Fxx1s", "Fxx1s", "Fssummps")+" where Fssummps<>0");
			   	ExecuteSQL("update "+tmpTbl+" set Fneob_mp="+IIF("Fssummps>Fob_mp", "Fssummps-Fob_mp", 0)+" where Fssummps<>0");
			   	ExecuteSQL("update "+tmpTbl+" set Fssum_obn="+IIF("Fssumon-"+minnal+">0", "Fssumon-"+minnal, 0)
								+", Fssum_obo="+IIF("Fssumoo-"+minnal+">0", "Fssumoo-"+minnal, 0)
								+", Fssum_pog="+IIF("Fssumpg-"+npogr+">0", "Fssumpg-"+npogr, 0)
								+", Fost_na_pit="+IIF("Fssum_p>0", "Fssumpg", pitan)
								+", F_sum_zp=Fssum+Fost_na_pit-Fssum_z-Fssuml+Fssum_stro"
								+", F_sum=Fssum+Fssumd+Fost_na_pit-Fssum_z-Fssuml-Fuderg_nlg+Fssum_strn+Fssum_stro");
			   	//-------------------------------------------------------------------------------------------------------------------
			   	//пытаемся обойти случай,если по осн.работе нет зарплаты и есть сумма на обучение
			   	ExecuteSQL("update "+tmpTbl+" set Fbpogrosn="+sqlTrue
			   				+", F_sum=F_sum+Fssum_pog+Fssum_obo+Fssum_obn"
			   				+", F_sum_zp=F_sum_zp+Fssum_obo+Fssum_n"
			   				//	забыли добавить условие
			   				+" where F_sum<>0 or (F_sum=0 and Fssum_s=0)");

			   	//вычисление суммы неденежной выплаты для налогообложения
			   	ExecuteSQL("update "+tmpTbl+" set Fssumnedob=F_sum+Fuderg_nlg where Fssumned<>0 and (F_sum+Fuderg_nlg)>0")
			   	ExecuteSQL("update "+tmpTbl+" set Fssumnedob=Fssum_s+Fssumtr where Fssumned<>0 and (F_sum+Fuderg_nlg)<=0")
			   	//	ExecuteSQL("update "+tmpTbl+" set Fssumned15=0, Fssumned17="+sqlRound("Fssumned*"+sqlRound(1/(1-(maxProc/100)),5),2)+"  where Fssumned<>0 and Fssumnedob>"+sqlTo(nlgOgr))
			   	//	ExecuteSQL("update "+tmpTbl+" set Fssumned17=0, Fssumned15="+sqlRound("Fssumned*"+sqlRound(1/(1-(minProc/100)),5),2)+"  where Fssumned<>0 and Fssumnedob<="+sqlTo(nlgOgr)+" and ("+sqlTo(nlgOgr)+"-Fssumnedob)/"+sqlRound(1/(1-(minProc/100)),5)+">=Fssumned")
			   	//	ExecuteSQL("update "+tmpTbl+" set Fssumned15="+sqlRound("(("+sqlTo(nlgOgr)+"-Fssumnedob)/"+sqlRound(1/(1-(minProc/100)),5)+")*"+sqlRound(1/(1-(minProc/100)),5),2)+", Fssumned17="+sqlRound("(Fssumned-(("+sqlTo(nlgOgr)+"-Fssumnedob)/"+sqlRound(1/(1-(minProc/100)),5)+"))*"+sqlRound(1/(1-(maxProc/100)),5),2)+"  where Fssumned<>0 and Fssumnedob<="+sqlTo(nlgOgr)+" and ("+sqlTo(nlgOgr)+"-Fssumnedob)/"+sqlRound(1/(1-(minProc/100)),5)+"<Fssumned")
			   	ExecuteSQL("update "+tmpTbl+" set Fssumned15="+sqlRound(round(1/(1-(minProc/100)),5)+"*"+IIF("Fssumnedob>"+nlgOgr,IIF("Fssumnedob-"+nlgOgr+"<Fssumned","Fssumned-Fssumnedob+"+nlgOgr,0),"Fssumned"),2)+", "
									+"Fssumned17="+sqlRound(round(1/(1-(maxProc/100)),5)+"*"+IIF("Fssumnedob>"+nlgOgr,IIF("Fssumnedob-"+nlgOgr+"<Fssumned","Fssumnedob-"+nlgOgr,"Fssumned"),0),2)
								+" where Fssumned<>0");
	
			   	ExecuteSQL("update "+tmpTbl+" set F_sum=F_sum+(Fssumned15+Fssumned17-Fssumned) where Fbpogrosn="+sqlTrue)
			   	ExecuteSQL("update "+tmpTbl+" set F_sum_zp=F_sum_zp+(Fssumned15+Fssumned17-Fssumned) where Fbpogrosn="+sqlTrue)	


			   	ExecuteSQL("delete from "+tmpTbl+" where (Fssum+Fssumd+Fssum_strn+Fssum_stro+Fssum_pog+Fssum_obo=0) "
								+" and (Fssum_s+Fssumtr=0) and Fssummp=0 and Fssummps=0")
				//-------------------------------------------------------------------------------------------------------------------
				//налогообл.сумма по совместит.
				ExecuteSQL("update "+tmpTbl+" set F_sum_s="+IIF("Fssumtr<>0 or F_sum>0", "Fssum_s+Fssumtr", "Fssum_s-Fuderg_nlg+Fssumtr"));
			   	//если есть по совместительству и по основной и нет по труд.согл., то по совместительству не отнимаем взнос (иначе отнимется 2 раза)
			   	if(nlgnal)
			   			ExecuteSQL("update "+tmpTbl+" set F_sum_s=Fssum_s+Fssumtr, Fminus_uderg="+sqlFalse
			   					+" where F_sum>0 and F_sum_s>0 and Fssumtr=0");
			   	ExecuteSQL("update "+tmpTbl+" set F_sum_s=F_sum_s+Fssum_pog+Fssum_obo+Fssum_obn+Fssum_n where Fbpogrosn="+sqlFalse);
	
			   	ExecuteSQL("update "+tmpTbl+" set F_sum_s=F_sum_s+(Fssumned15+Fssumned17-Fssumned) where Fbpogrosn="+sqlFalse);
	
			   	//-------------------------------------------------------------------------------------------------------------------
			   	//l_xxx - сумма льготы
			   	//по налоговому кодексу minnal умн.не кол-во детей только при льготе 100% и 2 и больше ребенка до 18 лет
			   	//если один мать и несколько детей не инвалидов, то minnal не умнож.на кол-во детей
			   	//если есть и дети простые и инвалиды, то умнож.на количество детей, но проценты на детей разные
			   	//если есть и простые дети и инвалиды, то в приказе на процент льготы ставим 100, а в количестве детей
			   	//указываем, сколько их всего, в т.ч.инвалидов и процент для инвалидов. В этом случае система будет базу
			   	// проверять по общему количеству детей а проценты брать 100 из приказа на льготы- для простых и 150 из приказа на детей для инвалидов	
			   	//если все дети инвалиды, то в приказ не льготы можно ничего не заводить, а в приказе на детей указать одинаковое
			   	//количество всех детей и инвалидов и их процент 
			   	//если одинокая мать с обычными детьми (хочет пользоваться такой льготой), то  в приказе на льготы нужно поставить 150%, а в приказе
			   	//на детей указать общее количество детей, ИНВАЛИДОВ - 0. В этом случае база для льготы не будет умножаться на количество детей
			   	if (izmlg!=2){
			   			ExecuteSQL("update "+tmpTbl+" set Fl_xxx="+IIF("F_sum_zp<="+IIF("Fprk_det=0",minnal,minnal+"*Fprk_det"),
													IIF("Fprk_proc=0 and Fis_prik="+sqlFalse,// значит, положена льгота
														soc_lgot,
														IIF("Fprk_det=0",
															soc_lgot+"*Fprk_proc/100",
															(izmlg==1?
																soc_lgot+"*Fprk_proc/100*Fprk_det":
																soc_lgot+"*Fprk_proc/100*Fprk_det+"+soc_lgot))),
													0)
													+" where F_sum_zp>0");
			   	}else{
			   				//в налоговом колексе меняется база - если 150% и нет детей инвалидов, то база не умножается на количество детей
			   				//если есть льгота на детей по 100%, то только один родитель может базу умн.на кол.детей; другому
			   				//льгота идет только по 1 границе 
			   				ExecuteSQL("update "+tmpTbl+" set Fl_xxx="+IIF("F_sum_zp<="+IIF("Fprk_det=0 or Fisuvbaz<>0",minnal,minnal+"*Fprk_det"),
													IIF("Fprk_det=0 and Fprk_proc=0 and Fis_prik="+sqlFalse,// значит, положена льгота
														soc_lgot,
														IIF("Fprk_det=0",
															soc_lgot+"*Fprk_proc/100",
															(izmlg==1?
																soc_lgot+"*Fprk_proc/100*Fprk_det":
																	(izmlg==2?						
																soc_lgot+"*Fprk_proc/100*(Fprk_det-Fkol_indet)+"+soc_lgot+"*Fprk_indet/100*Fkol_indet":																			
																soc_lgot+"*Fprk_proc/100*Fprk_det+"+soc_lgot)))),
													0)
							+" where F_sum_zp>0");
			   	}	
			   	if(izmnx==1)
			   			ExecuteSQL("update "+tmpTbl+" set Fl_xxx=0 where F_sum_zp>0 and Foffset>1");
		   		ExecuteSQL("update "+tmpTbl+" set Fozn_pilg=1 where F_sum_zp>0 and Fl_xxx="+soc_lgot);
		   		ExecuteSQL("update "+tmpTbl+" set Fozn_pilg=0 where F_sum_zp>0 and Fl_xxx=0");
		   		//-------------------------------------------------------------------------------------------------------------------
		   		//если МП была по осн.работе, то добавляем к обл.сумме по осн.работе
		   		ExecuteSQL("update "+tmpTbl+" set Fobl_mp="+IIF("Fl_xxx=0 and F_sum>0","Fneob_mp+Fob_mp","Fob_mp")+" where Fssummp<>0");
		   		ExecuteSQL("update "+tmpTbl+" set Fnobl_mp=Fneob_mp where Fssummp<>0 and not(Fl_xxx=0 and F_sum>0)");
			   	ExecuteSQL("update "+tmpTbl+" set F_sum=F_sum+Fobl_mp where Fssummp<>0");
	
		         //если ЗП меньше льготы, то будем в общей таблице для показа расчета сумму льготы ставить равной ЗП
		         // если складывать помесячные облагаемые доходы и из них показ?вать среднеариф?м.сумму, то общая сумма
		         //льготы по другому не будет выходить на облагаемую общую сумму
			   	ExecuteSQL("update "+tmpTbl+" set Fl_xxx="+IIF("F_sum-Fl_xxx<0 and F_sum<>0","F_sum","Fl_xxx"));			   	
			   	
			   	ExecuteSQL("update "+tmpTbl+" set F_sum="+IIF("F_sum-Fl_xxx<0",0,"F_sum-Fl_xxx"));
	
			   	if (dtbotp!=0 && dtbotp!=null){	
			   			ExecuteSQL("update "+tmpTbl+" set F_sum="+IIF("F_sum+Fsumotb<0",0,"F_sum+Fsumotb"));
			   	}		
	
			   	ExecuteSQL("update "+tmpTbl+" set Fl_xxx_s="+IIF("Fis_prik="+sqlTrue,
													IIF("Fprk_det=0",
														soc_lgot+"*Fprk_proc/100",
														(izmlg==1?
															soc_lgot+"*Fprk_proc/100*Fprk_det":
														(izmlg==2?
															soc_lgot+"*Fprk_proc/100*(Fprk_det-Fkol_indet)+"+soc_lgot+"*Fprk_indet/100*Fkol_indet":																
															soc_lgot+"*Fprk_proc/100*Fprk_det+"+soc_lgot))),
													0)
													+" where F_sum_s>0");
			   	if(izmnx==1)
			   			ExecuteSQL("update "+tmpTbl+" set Fl_xxx_s=0 where F_sum_s>0 and Foffset>1");
			   				
			   	ExecuteSQL("update "+tmpTbl+" set Fozn_pilgs=1 where F_sum_zp>0 and Fl_xxx_s="+soc_lgot);
			   	ExecuteSQL("update "+tmpTbl+" set Fozn_pilgs=0 where F_sum_zp>0 and Fl_xxx_s=0");
			   	
		         //если ЗП меньше льготы, то будем в общей таблице для показа расчета сумму льготы ставить равной ЗП
		         // если складывать помесячные облагаемые доходы и из них показ?вать среднеариф?м.сумму, то общая сумма
		         //льготы по другому не будет выходить на облагаемую общую сумму
			   	ExecuteSQL("update "+tmpTbl+" set Fl_xxx_s="+IIF("F_sum_s-Fl_xxx_s<0 and F_sum_s<>0","F_sum_s","Fl_xxx_s"));			   	
			   	
			   	ExecuteSQL("update "+tmpTbl+" set F_sum_s="+IIF("F_sum_s-Fl_xxx_s<0", 0, "F_sum_s-Fl_xxx_s")+" where F_sum_zp>0");
			   	//-------------------------------------------------------------------------------------------------------------------
			   	//если МП была по совм., то добавляем к обл.сумме по совм.
			   	ExecuteSQL("update "+tmpTbl+" set Fobl_mps="+IIF("Fl_xxx_s=0 and F_sum_s>0","Fneob_mp+Fob_mp","Fob_mp")+" where Fssummps<>0");
			   	ExecuteSQL("update "+tmpTbl+" set Fnobl_mps=Fneob_mp where Fssummps<>0 and not(Fl_xxx_s=0 and F_sum_s>0)");
			   	ExecuteSQL("update "+tmpTbl+" set F_sum_s=F_sum_s+Fobl_mps where Fssummps<>0");
	
	            //сначала не отнимался при расчете подоходного налога ЕСВ. Поэтому и в сумме удержанных взносов эти ЕСВ
	            //не показываем.   
				if(minusTs==1 || minusTs==2){
					//ЕСВ по трудовым 			   	
				   	ExecuteSQL("update "+tmpTbl+" set F_sum_s=F_sum_s-Fuderg_nlgts where Fssumtr<>0");					
	            }  
				if(minusTs==0 || minusTs==null){				
				   	ExecuteSQL("update "+tmpTbl+" set Fuderg_nlgts=0 where Fssumtr<>0");					
	            }
			   	
			   	if (dtbotp!=0 && dtbotp!=null){
			   			ExecuteSQL("update "+tmpTbl+" set F_sum_s=F_sum_s+Fsumotb where F_sum<=0 and F_sum_s>0 and Fsumotb<0");
			   			ExecuteSQL("update "+tmpTbl+" set F_sum_s=0 where F_sum_s<0");
			   	}	
	return;
}