﻿/*
	eugene 22.03.2012. Расчет процента неявки (точнее явки) из табеля согласно оклада или ЧТС в ШР.
	Может использоваться для расчета разных надбавок, например праздничных, ночных, вечерних, воскресных, сверхурочных, ремонт
	Пример: нужно расчитывать ночные в размере 40%.
	Настройка сводится к следующему:
		1. Добавить в справочник неявок запись "Ночные" с отображением в котроле. 
		   Перейти на вкладку "Дополнительные" и в гриде "% доплаты" добавить запись 
		   с указанием процента и его периода действия. Запомнить полученный код неявки.
		2. Добавить приказ _nvk, указать код неявки из 1-го пункта. Сделать его невидимым.
		3. Добавить расчет.
	Использование:
		В табеле указываем отработанное время по данной надбавке и после расчета зарплаты наслаждаемся результатом.
	
	PS. Ранее для этих целей использовали _nvkp, но он неудобен из-за того, что в каждый приказ надо
		завести человека с указанием процента, и если этого не сделать, то ничего не посчитается,
		хотя бухгалтер вводит время в табеле и потом забывает про приказ.
*/
include("get_cnst.js")
include("servis\\date.js");

function name_nvk()
{
	return ru("Расчет любой надбавки из табеля", "Розрахунок будь-якої надбавки з табелю");
}

function r_nvk(month, vvopl, vidprk, lsfid, lsfid2, ftabn_id, svzpName)
{
	var D1 = firstDay(month);
	var D2 = lastDay(month);
	var ffld_num = 0;
	strSQL = "SELECT FFLD_NUM FROM ^LIC_FLD WHERE FID = "+sqlTo(lsfid)
	var s = getSnap(strSQL);
	if (s != null)
	{
		ffld_num = s[0];
	}

	var szTag,szName,tblOut;
	// достаем цифры к названию файла
	var szTag = month_txt(month);

	szName = "ZRP_STT1"+szTag;
	tiName = "TBL"+szTag;
	siName = "STT1"+szTag;
	var strTabName = (svzpName?svzpName:"svzp") + szTag;

	if(!IsTableEx("zrp_mdb", szName))
	{
		txt = "Не заполнены табеля за "+szTag+" для вида оплаты"+ String(vvopl);
		writeToLog(txt,"w",vvopl,vidprk,lsfid);
		return;
	}

    if(getPar("KOMKOLD")){	
    	svnrTableName = "svnr" + szTag;
    	if(!IsTableEx("zrp_res", "zrp_" + svnrTableName))
    	{
    		//var strPath = getPath("zrp_res");
    		CreateTableEx("zrp_res","zrp_" + svnrTableName, "svzp", "*");
    	}
    }
	
	// Узнаем значение поля FZ13 из справочника допл. и .удер.
	// в котром хранится значение FKOD_NVK из табеля для которого
	// будет выполнятся расчет.
	strSQL= " SELECT P.FZ13, R.FPROC "
			+" FROM ^CL_PRIK P"
				+" INNER JOIN ^CL_NVK N ON P.FZ13 = N.FKOD_NVK"
					+" INNER JOIN ^CL_NVK_PROC R ON N.FWID = R.FWID_NVK"
			+" WHERE P.FVID="+sqlTo(vidprk)
				+ " AND R.FBDAT <= " + sqlTo(D2) + " AND R.FEDAT >= " + sqlTo(D1)
	var oSnap = getSnap(strSQL);
	
	//Защита от непредвиденнных ситуаций.
	var mFkod_nvk = 0;
	var mFproc = 0;
	if (oSnap!=null && oSnap[0]!=null)
	{
		mFkod_nvk = oSnap[0];
		mFproc = oSnap[1];
	}
	else
	{
		var strMessage = "r_nvkp.js Внимание. Для приказа "+vidprk+"\n"
			+" в справочнике доплат и удержаний не проставлено значение "+"\n"
			+" запроса №13 (код неявки в табеле). "+"\n"
			+" Расчет пропущен."
		writeToLog(strMessage,"m",vvopl,vidprk,lsfid);
		return false;

	}
	oSnap = null;

	var tblTabel = getTmpTableName("", true);
	var sqlTabn  = ftabn_id ? " and W.FWID_CL in ("+ftabn_id+") ":"";
	strSQL = "SELECT ST.*"
			+", TBL.FDAY_NVK AS TBL_FDAY_NVK, TBL.FCHASNVK AS TBL_FCHASNVK"
			+", TBL2.FDAY_NVK AS TBL2_FDAY_NVK, TBL2.FCHASNVK AS TBL2_FCHASNVK"
			+", TBL3.FDAY_NVK AS TBL3_FDAY_NVK, TBL3.FCHASNVK as TBL3_FCHASNVK"
			+", TI.FNORMA_D AS INI_FNORMA_D, TI.FNORMA_CH AS INI_FNORMA_CH"
			+", SD.FOKLAD AS SD_FOKLAD"
			+", SD.FSHPZ AS SD_FSHPZ"
			+", V.FPRIZN AS V_FPRIZN"
		+" FROM ^"+siName+" ST"
		+" INNER JOIN ^WORK_PERS W ON ST.FWID_WP=W.FWID"
			+" INNER JOIN ^STRU_DOL SD ON W.FWID_DOL = SD.FWID"
				+" LEFT JOIN ^"+tiName+" TBL ON (ST.FWID_WP=TBL.FWID_WP AND TBL.FBDAT=ST.FBDAT AND TBL.FEDAT=ST.FEDAT AND TBL.FKOD_NVK=1)"
				+" LEFT JOIN ^"+tiName+" TBL2 ON (ST.FWID_WP=TBL2.FWID_WP AND TBL2.FBDAT=ST.FBDAT AND TBL2.FEDAT=ST.FEDAT AND TBL2.FKOD_NVK=2)"
				+" LEFT JOIN ^"+tiName+" TBL3 ON (ST.FWID_WP=TBL3.FWID_WP AND TBL3.FBDAT=ST.FBDAT AND TBL3.FEDAT=ST.FEDAT AND TBL3.FKOD_NVK="+sqlTo(mFkod_nvk)+")"
				+" INNER JOIN ^TBL_INI AS TI ON (TI.FVOPL=W.FVOPL AND TI.FBDAT = "+sqlTo(D1)+")"
				+ " LEFT JOIN ^opl_priz as v on v.Fvopl=w.Fvopl"
		+" WHERE 1=1 "+sqlTabn
	
	var stt = OpenTable(strSQL);

	// Проверяем существует ли у нас таблица "svzp" + szTag, если нет, то создаем ее
	// по шаблону "svzp"
	tblOut = "zrp_" + strTabName
	if(!IsTableEx("zrp_res", tblOut))
	{
		CreateTableEx("zrp_res", tblOut, "svzp", "*");
	}

	var fis_tbl = true;
	if(!IsTableEx("zrp_mdb", "zrp_"+tiName))
	{
		fis_tbl = false;
	}

	var svzp = OpenTable("s","svzp" + szTag);

	if(stt.IsBOF() && stt.IsEOF()) return;

	// Проходим по таблице stt и делаем надбавки
	stt.MoveFirst();
	while(!stt.IsEOF())
	{
		mFnorma_d  = 0;
		mFnorma_ch = 0;
		mFprazd_d  = 0;
		mFprazd_ch = 0;
		mFfact_d   = 0;
		mFfact_ch  = 0;


		// поиск табеля для инициализации
		if (toScrObj(stt.getValue("Fis_tabel"))!= "*"){
			if (fis_tbl)
			{
				// eugene 12.12.2011. Думаю, что правильно норму брать из самого табеля человека
				mFnorma_d = toScrObj(stt.getValue("TBL_FDAY_NVK"))
				mFnorma_ch = toScrObj(stt.getValue("TBL_FCHASNVK"))
				
				//vvs 28.01.2004
				// Фактически отработанное время из табеля
				mFfact_d   = toScrObj(stt.getValue("TBL2_FDAY_NVK"));
				mFfact_ch  = toScrObj(stt.getValue("TBL2_FCHASNVK"));

				// Праздничных дней и часов из табеля
				mFprazd_d  = toScrObj(stt.getValue("TBL3_FDAY_NVK"))
				mFprazd_ch = toScrObj(stt.getValue("TBL3_FCHASNVK"))
			}
		}else{
			mFnorma_d = toScrObj(stt.getValue("INI_FNORMA_D"));
			mFnorma_ch = toScrObj(stt.getValue("INI_FNORMA_CH"));
		}
		
		var isChts = toScrObj(stt.getValue("V_FPRIZN")) == 1 ? false : true;
		
		var prk_dyn = mFprazd_d;
		var prk_chn = mFprazd_ch;
		
		TM_IN_DYN = (prk_chn==0)? true:false

		if (prk_dyn!=0 || prk_chn!=0){
			
			var oklad = toScrObj(stt.getValue("SD_FOKLAD"))
			
			var ssumn=0;
			
			if (isChts)
			{
				ssumn = oklad * prk_chn;
			}
			else
			{
				if (mFnorma_d*mFnorma_ch>0)
				{
					prk_dyn = (prk_dyn==0)? (prk_chn/mFnorma_ch*mFnorma_d): prk_dyn
					ssumn = (oklad * prk_dyn) /mFnorma_d
				}
			}
			csumn = round(ssumn * mFproc/100, 2)

			if (mFnorma_d*mFnorma_ch==0){
				strMsg = "Нормы времени = 0. Проверьте табель для таб.№ "+String(stt.getValue("ftabn"));
				writeToLog(strMsg,"w",vvopl,vidprk,lsfid);
			}

			if (csumn != 0)
			{
				var m = new Object();
				m.FTABN_ID = toScrObj(stt.getValue("FTABN_ID"));
				m.FWID_WP = toScrObj(stt.getValue("FWID_WP"));
				
				m.FSHPZ = toScrObj(stt.getValue("SD_FSHPZ"));
				m.FSUM = csumn;
				m.FFLD_NUM = ffld_num;
				m.FLSFID = lsfid;
				m.FVID_PRK = vidprk;
				m.FDAY = prk_dyn;
				m.FCHAS = prk_chn;
				m.FBDY = D1.getDate();
				m.FEDY = D2.getDate();
				m.FMN = d00;
				m.FVP = 0;
				updateTable("^"+strTabName, m, true);

			    if(getPar("KOMKOLD")){
			    	var m = new Object();
			    	m.FTABN_ID = toScrObj(stt.getValue("FTABN_ID"));
			    	m.FWID_WP = toScrObj(stt.getValue("FWID_WP"));
			    	m.FSUM = csumn;
			    	m.FFLD_NUM = ffld_num;
			    	m.FLSFID = lsfid;
			    	m.FMN = d00;
			    	m.FVP = 0;
			    	updateTable("^"+svnrTableName, m, true);
			    }
			}
		}
		stt.MoveNext();
	}

	stt.close();
	stt = null;

	return;
}
