// автоматическое формирование неявок в табелях
// количество дней и часов берётся со свода по определенным полям ЛС и для определённых неявок
// Настройки вхождения полей ЛС в ту или иную неявку осуществляются в справочнике неявок для табелей
include("servis\\date.js")

var sttTbl
	,tblTbl
	,nFldLic
	,nFvopl
	,bKind
	,mFkod_nvk
	;

function name_nvk2tbl()
{
	return "Формування неявок для табелів із своду|Формирование неявок для табелей со свода";
}

function r_nvk2tbl(rasch_mes, vopl, vvprk, mvvcslid, mvvcslid2, ftabn_id, svzpName)
{
//alert("rasch_mes="+rasch_mes+"\nvopl="+vopl+"\nvvprk="+vvprk+"\nmvvcslid="+mvvcslid+"\nmvvcslid2="+mvvcslid2+"\nftabn_id="+ftabn_id+"\nsvzpName="+svzpName);

	// достаем цифры к названию файла
	var szTag = month_txt(rasch_mes);
	sttTbl = "STT1"+szTag;
	tblTbl = "TBL"+szTag;
	var tblSvzp = getTmpTableName("",true);

	var oBDat = firstDayMonth(rasch_mes);
	var oEDat = lastDayMonth(rasch_mes);

	// Узнаем значение поля FZ13 из справочника допл. и .удер.
	// в котром хранится значение FKOD_NVK из табеля для которого
	// будет выполнятся расчет.
	strSQL= " SELECT FZ13 "
			+" FROM ^CL_PRIK "
			+" WHERE FVID="+sqlTo(vvprk)
	var oSnap = getSnap(strSQL);
	//Защита от непредвиденнных ситуаций.
	mFkod_nvk = 0;
	if (oSnap!=null && oSnap[0]!=null && oSnap[0]!=0)
	{
		mFkod_nvk = oSnap[0];
	}else
	{
		var strMessage = "r_nvk2tbl.js: Для приказа "+vvprk+"\n"
			+" в справочнике доплат и удержаний не проставлено значение\n"
			+" запроса №13 (код неявки в табеле).\n"
			+" Расчет пропущен."
		writeToLog(strMessage,"e",vopl, vvprk, mvvcslid);
		return false;
	}
	oSnap = null;

	//нормы времени
	strSQL = "SELECT *"
			+" FROM ^TBL_INI"
			+" WHERE 1=1"
				+" AND FVOPL="+sqlTo(vopl)
				+" AND FBDAT="+sqlTo(oBDat)
				+" AND FEDAT="+sqlTo(oEDat)
	var sn = getSnap(strSQL);
	if (sn == null)	//если нормы нет
	{
		//добавим норму
		var m = new Object();
		m.FWID = GetUID();
		m.FBDAT = oBDat;
		m.FEDAT = oEDat;
		m.FVOPL = vopl;
		UpdateTable("^TBL_INI",m,true);
	}
	sn = null;

	//заготовки фрагментов запросов
	strInto = " INTO "+tblSvzp

	strInsert = "INSERT INTO "+tblSvzp
				+"("
					+" FDAY"
					+", FCHAS"
					+", Ftabn_id"
					+", FBDAT"
					+", FEDAT"
					+", FWID_WP"
					+", FKIND"
				+")"

	var sqlTabn = ftabn_id ? " and Ftabn_id in ("+ftabn_id+") " : "";

	//по каким полям ЛС надо собирать дни и время
	//и для каких видов оплаты
	strSQL = "SELECT DISTINCT"
				+" FLDLIC"
				+", FVOPL"
				+", FKIND"
			+" FROM ^CL_NVK_LIC LIC"
				+" LEFT JOIN ^CL_NVK NVK ON NVK.FWID=LIC.FWID_NVK"
			+" WHERE 1=1"
				+" AND NVK.FKOD_NVK="+sqlTo(mFkod_nvk)
	var tblLic = OpenTable(strSQL);
	if (!tblLic.IsEmpty())
	{
		var bFirst = true;
		for (tblLic.MoveFirst(); !tblLic.IsEOF(); tblLic.MoveNext())
		{
			nFldLic = toScrObj(tblLic.getValue("FLDLIC"));
			nFvopl = toScrObj(tblLic.getValue("FVOPL"));
			bKind = toScrObj(tblLic.getValue("FKIND"));

			strSelect = "SELECT "
							+" SUM(FDAY) AS FDAY"
							+", SUM(FCHAS) AS FCHAS"
							+", Ftabn_id"
							+", wp.FBDAT as FBDAT"
							+", wp.FEDAT as FEDAT"
							+", wp.FWID as FWID_WP"
							+", "+bKind+" as FKIND"

			var strSQL = (bFirst ? strSelect : strInsert)
						+(bFirst ? strInto : strSelect)
						+" FROM ^"+(svzpName ? svzpName : "svzp")+szTag+" sv"
							+" INNER JOIN ^work_pers wp ON sv.fwid_wp=wp.fwid"
						+" WHERE 1=1"
							+" AND (Fvp=0 or (Fvp=1 and Fmn>="+sqlTo(rasch_mes)+"))"
							+" AND sv.Flsfid="+sqlTo(nFldLic)
							+" AND wp.fvopl="+sqlTo(nFvopl)
							+" AND wp.FBDAT<="+sqlTo(oEDat)
							+" AND wp.FEDAT>="+sqlTo(oBDat)
							//отсекаем вакантные должности
							+" AND wp.Fwid_cl>0"
							+sqlTabn
						+" GROUP BY"
							+" Ftabn_id"
							+", wp.FBDAT"
							+", wp.FEDAT"
							+", wp.FWID"
			ExecuteSQL(strSQL);
			bFirst = false;
		}
	}
	tblLic.Close();
	tblLic = null;

	//скоректируем даты
	strSQL = "UPDATE "+tblSvzp+" SET fbdat=" + sqlTo(oBDat) + " WHERE fbdat<" + sqlTo(oBDat);
	ExecuteSQL(strSQL);
	strSQL = "UPDATE "+tblSvzp+" SET fedat=" + sqlTo(oEDat) + " WHERE fedat>" + sqlTo(oEDat);
	ExecuteSQL(strSQL);

	//выберем всё в новую таблицу с группировкой по человеку и виду включения дней
	var tblSvzpRes = getTmpTableName("",true);
	strSQL = "SELECT "
				+" SUM(FDAY) AS FDAY"
				+", SUM(FCHAS) AS FCHAS"
				+", Ftabn_id"
				+", FBDAT"
				+", FEDAT"
				+", FWID_WP"
				+", FKIND"
			+" INTO "+tblSvzpRes
			+" FROM "+tblSvzp
			+" GROUP BY "
				+" Ftabn_id"
				+", FBDAT"
				+", FEDAT"
				+", FWID_WP"
				+", FKIND"
	ExecuteSQL(strSQL);

	var tblRec = OpenTable("select * from "+tblSvzpRes);
	if (!tblRec.IsEmpty())
	{
		for (tblRec.MoveFirst(); !tblRec.IsEOF(); tblRec.MoveNext())
		{
			makeNvk(toScrObj(tblRec.getValue("ftabn_id"))
					,toScrObj(tblRec.getValue("fwid_wp"))
					,toScrObj(tblRec.getValue("fbdat"))
					,toScrObj(tblRec.getValue("fedat"))
					,toScrObj(tblRec.getValue("fday"))
					,toScrObj(tblRec.getValue("fchas"))
					,toScrObj(tblRec.getValue("fkind"))
					);
		}
	}
	tblRec.Close();
	tblRec = null;

	DropTable(tblSvzp);
	DropTable(tblSvzpRes);
	return true;
}

//процедура создания неявок в табеле
function makeNvk(ftabn_id, fwid_wp, fbdat, fedat, fday, fchas, fkind)
{
	//1. Если табеля нет, то создадим его
	strSQL = "SELECT * FROM ^"+sttTbl
			+" WHERE FWID_WP = "+sqlTo(fwid_wp)
	var sn = getSnap(strSQL);
	if (sn == null)
	{
		var m = new Object();
		m.FTABN_ID = ftabn_id;
		m.FWID_WP = fwid_wp;
		m.FIS_TABEL = "+";
		m.FBDAT = fbdat.getDate();
		m.FEDAT = fedat.getDate();
		UpdateTable("^"+sttTbl,m,true);
	}
	sn = null;

	//2. Неявку формируем по новому в любом случае
	var bAdd = true;
	var m = new Object();
	strSQL = "SELECT FWID FROM ^"+tblTbl
			+" WHERE FWID_WP = "+sqlTo(fwid_wp)
				+" AND FKOD_NVK="+sqlTo(mFkod_nvk)
	var oSnap = getSnap(strSQL);
	if (oSnap != null)
	{
		bAdd = false;
	}

	m.FWID = bAdd ? GetUID() : toScrObj(oSnap[0]);
	m.FWID_WP = fwid_wp;
	m.FBDAT = fbdat.getDate();
	m.FEDAT = fedat.getDate();
	switch (fkind)
	{
		case 1:
			//неявку пишем в рабочие дни
			m.FDAY_NVK = fday;
			m.FCHASNVK = fchas;
		break;
		case 2:
			//иначе пишем в календарные дни
			m.FNORMA_D = fday;
			m.FNORMA_CH = fchas;
		break;
		default:
			//это что-то новенькое
	}
	m.FKOD_NVK = mFkod_nvk;
	m.FIS_NVK = true;
	UpdateTable("^"+tblTbl, m, bAdd);
	
	oSnap = null;
	return true;
}
