//расчет суммовых надбавок зависящих от отработанного времени, время берется из неявок табеля
//аналог _nvks, только сумма определяется по справочнику связей справочников с процентными и суммовыми надбавками
//код неявки должен быть проставлен в соответствующем приказе в перечне доплат/удержаний
//тип приказа должен быть _prk
function name_nvkscl()
{
	return "сумова надбавка з довідника пропорційно часу з неявки в табелі|суммовая надбавка из справочника пропорционально времени из неявки в табеле";
}

function r_nvkscl(month, vopl, vidprk, lsfid, lsfid2, ftabn_id, svzpName)
{
	// достаем цифры к названию файла
	var szTag = getDateTag(month);        
	// дата начала
	var D1 = firstDayMonth(month);
	// дата конца
	var D2 = lastDayMonth(month);

	var szName = "zrp_stt1" + szTag;
	var siName = "^stt1" + szTag;
	var tiName = "^tbl" + szTag;
	var strTabName = (svzpName?svzpName:"svzp") + szTag;
      
	if(!IsTableEx("zrp_mdb", szName))
	{ 
		msg = "Не введены табеля за " + szTag;
		writeToLog(msg,"e",vopl, vidprk, lsfid);
		return false;
	}

// Проверка на существование таблицы "svzp%LD"
	if(!IsTableEx("zrp_res", "zrp_" + strTabName))
	{ 
		var strPath = getPath("zrp_res");
		CreateTableEx("zrp_res", "zrp_" + strTabName, "svzp", "*");
	}

	// Узнаем значение поля FZ13 из справочника допл. и .удер.
	// в котром хранится значение FKOD_NVK из табеля для которого
	// будет выполнятся расчет.
	strSQL= " SELECT FZ13 "
			+" FROM ^CL_PRIK "
			+" WHERE FVID="+sqlTo(vidprk)
	var oSnap = getSnap(strSQL);
	//Защита от непредвиденнных ситуаций.
	var mFkod_nvk = 0;
	if (oSnap!=null && oSnap[0]!=null){
		mFkod_nvk = oSnap[0];
	}else{
		var msg = "Для приказа "+vidprk+" в формировании перечня доплат/удержаний не проставлено значение кода неявки в табеле. Расчет пропущен."
		writeToLog(msg,"e",vopl, vidprk, lsfid);
		return false;

	}
	oSnap = null;
	
	//формируем условие для последующего отбора из расширений ШР
	var tblExtName;
	var extWhere = "";
	var t = OpenTable("select * from ^cl_ext where Fclass="+sqlTo("SHTATEXT")+" and Ftype like 'A%'");
	if(t.rowCount>0)
	{
		include("Objects/DpExtentionBuilder.js");
		var oExt = new DpExtentionBuilder("SHTATEXT");
		if(oExt.exist())
		{
			tblExtName = oExt.getValueTableName();
			for(; !t.IsEOF(); t.MoveNext())
			{
				extWhere += " (cl.Fcl="+String(t.getValue("Ftype")).replace("A","")
						+" and exists (select * from "+tblExtName+" as e where p.Fwid_wp=e.Fmainwid "
							+" and cl.Fcod=e.F"+t.getValue("Flabel")+")) "+(t.bookmark==t.rowCount?"":"or");
			}
		}
	}
	t.close();

	var sqlTabn = ftabn_id?" and p.Ftabn_id in ("+ftabn_id+") ":"";
	var strSQL = "INSERT INTO ^" + strTabName
		 			+ "( ftabn_id,fwid_wp"
		 			+ ", fshpz, fsum"
		 			+ ", ffld_num, flsfid"
		 			+ ", fbdy, fedy"
		 			+ ", fis_day, fday"
		 			+ ", fchas, fmn"
		 			+ ", fvp, fid_prk, fvid_prk)"
				+ " SELECT w.fwid_cl as ftabn_id,p.fwid_wp as fwid_wp, p.fshpz AS fshpz"
				+ ", " + sqlRound(IIF("st.fis_tabel=" +sqlTo("*")
							, 0 
							, IIF("st.fis_tabel=" + sqlTo("+")
								, IIF("tb2.fchasnvk=0"
									, "tb2.fday_nvk/tb.fday_nvk"
									, "tb2.fchasnvk/tb.fchasnvk")
									, 0)
								)+ "*cl.fsum",2)+" AS fsum"
				+ ", " + IIF(sqlTo(lsfid) + "<>0", "(SELECT l.ffld_num FROM ^lic_fld AS l WHERE l.fid=" + sqlTo(lsfid) + ")", 0) + " as ffld_num"
	 			+ ", " + sqlTo(lsfid) + " as flsfid"
				+ ", st.fbdat AS fbdy, st.fedat AS fedy"
				+ ", " + IIF("ti.fnorma_ch<>0", sqlTrue, sqlFalse) + " AS  fis_day"
				+ ", tb2.fday_nvk AS fday"
				+ ", tb2.fchasnvk AS fchas"
	 			+ ", " + sqlTo(d00)+" as fmn, 0 as fvp"
	 			+ ", p.fwid as fid_prk"
				+ ", " + sqlTo(vidprk)+ " as fvid_prk"
				+ " FROM ((((^prk_all AS p LEFT JOIN ^full_pers AS w ON p.fwid_wp=w.fwid)"
					+ " INNER JOIN ^stru_dol AS d ON d.fwid=w.fwid_dol)"
					+ " INNER JOIN ^tbl_ini AS ti ON ti.fvopl=w.fvopl)"
					+ " INNER JOIN ^cl_lnkprkproc AS cl ON cl.fvid_prk=p.fvid_prk)"
					+ " LEFT JOIN " + siName + " AS st ON (p.fwid_wp=st.fwid_wp AND p.fbdat<=" 
								+ toSqlDate(month.getFullYear(), month.getMonth()+1,'st.fedat') 
								+ " AND p.fedat>=" + toSqlDate(month.getFullYear(), month.getMonth()+1,'st.fbdat') + ")"
					+ " LEFT JOIN " + tiName + " AS tb ON (st.fwid_wp=tb.fwid_wp AND tb.fbdat=st.fbdat AND tb.fedat=st.fedat and tb.fkod_nvk=1)"
					+ " LEFT JOIN " + tiName + " AS tb2 ON (st.fwid_wp=tb2.fwid_wp AND tb2.fbdat=st.fbdat AND tb2.fedat=st.fedat and tb2.fkod_nvk = "+sqlTo(mFkod_nvk)+")"
				+ " WHERE p.fvid_prk=" + sqlTo(vidprk)
	    			+ " AND p.fbdat<=" + sqlTo(D2) + " AND p.fedat>=" + sqlTo(D1)
					+ sqlTabn
					+ " AND ti.fbdat=" + sqlTo(D1)
					+ " AND ((cl.fcl="+getPar("CODDOL")+" AND cl.Fcod=w.Fcoddol) OR "
	    					+" (cl.fcl="+getPar("CODKAT")+" AND cl.Fcod=w.Fcodkat) OR "
	    					+" (cl.fcl="+getPar("CODZVAN")+" AND cl.Fcod=w.Fcodzvan)"
	    					+(tblExtName?" OR "+extWhere:"")+" ) ";
	if(vopl < 9000)
		strSQL += " AND w.fvopl=" + sqlTo(vopl); 
	ExecuteSQL(strSQL);
	
	svnrTableName = "svnr" + szTag;
	if(!IsTableEx("zrp_res", "zrp_" + svnrTableName))
	{
		//var strPath = getPath("zrp_res");
		CreateTableEx("zrp_res","zrp_" + svnrTableName, "svzp", "*");
	}

    if(!getPar("KOMKOLD")){
    	return true;
    }
	
	var oSnap = getSnap("SELECT Fuse_rkm FROM ^CL_PRIK WHERE Fvid="+sqlTo(vidprk))
	if(oSnap==null || (oSnap!=null && !oSnap[0]))
	{
		return;
	}
	
	var strSQL = "INSERT INTO ^" + svnrTableName
		+ "( ftabn_id,fwid_wp"
		+ ", fsum"
		+ ", ffld_num, flsfid"
		+ ", fmn, fvp)"
		+ " SELECT w.fwid_cl as ftabn_id,p.fwid_wp as fwid_wp"
		+ ", " + sqlRound(IIF("st.fis_tabel=" +sqlTo("*")
				, 0 
				, IIF("st.fis_tabel=" + sqlTo("+"),1,0)
					)+ "*cl.fsum",2)+" AS fsum"
		+ ", " + IIF(sqlTo(lsfid) + "<>0", "(SELECT l.ffld_num FROM ^lic_fld AS l WHERE l.fid=" + sqlTo(lsfid) + ")", 0) + " as ffld_num"
		+ ", " + sqlTo(lsfid) + " as flsfid"
		+ ", " + sqlTo(d00)+" as fmn, 0 as fvp"
	+ " FROM ((^prk_all AS p LEFT JOIN ^full_pers AS w ON p.fwid_wp=w.fwid)"
	+ " INNER JOIN ^cl_lnkprkproc AS cl ON cl.fvid_prk=p.fvid_prk)"
	+ " LEFT JOIN " + siName + " AS st ON (p.fwid_wp=st.fwid_wp AND p.fbdat<=" 
	+ toSqlDate(month.getFullYear(), month.getMonth()+1,'st.fedat') 
	+ " AND p.fedat>=" + toSqlDate(month.getFullYear(), month.getMonth()+1,'st.fbdat') + ")"
	+ " WHERE p.fvid_prk=" + sqlTo(vidprk)
	+ " AND p.fbdat<=" + sqlTo(D2) + " AND p.fedat>=" + sqlTo(D1)
	+ sqlTabn
	+ " AND ((cl.fcl="+getPar("CODDOL")+" AND cl.Fcod=w.Fcoddol) OR "
			+" (cl.fcl="+getPar("CODKAT")+" AND cl.Fcod=w.Fcodkat) OR "
			+" (cl.fcl="+getPar("CODZVAN")+" AND cl.Fcod=w.Fcodzvan)"
			+(tblExtName?" OR "+extWhere:"")+" ) ";
	if(vopl < 9000)
		strSQL += " AND w.fvopl=" + sqlTo(vopl); 
	ExecuteSQL(strSQL);
	
	return true;
}