/*
Шатохин В.В. 20.04.2004

Расчет отпусков за счет прибыли
Переделан из r_otpkl2.js
Предназначен для расчета отпускных, заводимых одним приказом без деления
на сегменты при переходе из месяца в месяц
Отпускные расчитываются исходя из
суммы статистик 1, 10 (для отп. и для отп. за счет прибыли)
Общая сумма пишется в одно поле ЛС

obj_PRK_B.rmode = "KL"
*/

include("objects\\DpDefVed.js");
include("objects\\DpCl.js");
include("prik\\calculate\\r_otpall.js");
include("prik\\calculate\\r_premblot.js");

// Содержит сервисные процедуры для работы с календрем:
include("objects\\dpCalendar.js");

function name_otpk52()
{
	return "Розрахунок відпускних за рахунок прибутку, які заводяться одним наказом|Расчет отпускных за счет прибыли, заводимых одним приказом";
}

function r_otpk52(rasch_mes, VVOPL, vidprk, lsfid, lsfid2, ftabn_id, svzpName)
{
	var sPrikTbl = "PRK_ALL";

	strSQL = "SELECT FFLD_NUM FROM ^LIC_FLD WHERE FID = "+sqlTo(lsfid)
	var s = getSnap(strSQL);
	if (s != null)
	{
		ffld_num = s[0];
	}

	var DefVed = new DpDefVed();
	var D1,D2;
	var mFtabn,mFdatotp,mFvp,mFmn,db,db1,dt;
	var ssum;

	//установ. даты на начало и конец расчетного месяца
	var data = javaDate2Script(new Date(rasch_mes));
	var D1 = javaDate2Script(firstDay(rasch_mes));
	var D2 = javaDate2Script(lastDay(rasch_mes));
	var szTag = getDateTag(data);

	var sqlTabn = ftabn_id
		? (" AND P.FTABN_ID IN ("+ftabn_id+") ") 
		: "";

	// Берем все приказы, или действующие в месяц расчета, или если
	// дата выплаты попадает в месяц расчета
	strSQL = " SELECT P.*, W.FWID_CL AS FTABN_ID, REL.FCOD AS FTABN, O.* "
			+" FROM ^"+ sPrikTbl +" P "
				+" INNER JOIN ^WORK_PERS AS W ON W.FWID = P.FWID_WP "
				+" INNER JOIN ^PRK_O O ON P.FWID = O.FWID "
				+" INNER JOIN ^CLRELCLCL REL ON REL.FWID_CL = W.FWID_CL "
			+" WHERE P.FVID_PRK = "+sqlTo(vidprk)
				+sqlTabn
				+ " AND ((P.FBDAT <= " + sqlTo(D1) + " AND P.FEDAT >= " + sqlTo(D2) +") "
				+ " OR (P.FBDAT >= " + sqlTo(D1) + " AND P.FBDAT <= " + sqlTo(D2) +") "
				+ " OR (P.FEDAT >= " + sqlTo(D1) + " AND P.FEDAT <= " + sqlTo(D2) +") "
				+ " OR (P.FDAT_PRIK >= "+sqlTo(D1) + " AND P.FDAT_PRIK <= "+sqlTo(D2)+"))"
				+(VVOPL < 9000 ? " AND W.FVOPL = "+sqlTo(VVOPL) : "")
	tbl_PRK_O = OpenTable("s", strSQL);

	if (tbl_PRK_O.IsEmpty())
	{
		tbl_PRK_O.close();
		tbl_PRK_O = null;
		return false;
	}

	var tbl_DTPRKB = OpenTable("s","DTPRKB","dtprkb");
	var tbl_PRK_FMPL = OpenTable("s","PRK_FMPL","fmpl_tn");
	var tbl_WT_LBL_O = OpenTable("s","WT_LBL_O","tabdate");
	var tbl_WT_LBL_B = OpenTable("s","WT_LBL_B","tabdate");
	var tbl_SRED_INI = OpenTable("s","SRED_INI","tabsrdate");
	var tbl_CL_KF = OpenTable("s","CL_KF");
	var tbl_CL_KALEN = OpenTable("s","CL_KALEN","cl_kalen");

	if (!IsTableEx("ZRP_RES","ZRP_"+(svzpName?svzpName:"svzp")+szTag))
	{
		var msg = "Не найдена таблица "+(svzpName?svzpName:"svzp")+szTag;
		writeToLog(msg, "e", VVOPL, vidprk, lsfid);
		return false;
	}

	DefVed.begin("","Расчет отпусков");
	var msg = "Расчет отпусков";
	writeToLog(msg, "m", VVOPL, vidprk, lsfid);

	tbl_SVZP = OpenTable((svzpName?svzpName:"svzp")+szTag);

	var obj_PRK_B = new Object();
	/*
	// Предварительная инициализация obj_PRK_B,
	// не зависящая от конкретного приказа
	obj_PRK_B.vid_sred = 1;
	obj_PRK_B.rmode = "KL";
	obj_PRK_B.plusfmp = true;
	*/
	var oCl = new DpCl("");
	codpers  = getPar("CODPERS");
	oCl.setClcl(codpers);

	for(tbl_PRK_O.MoveFirst(); !tbl_PRK_O.IsEOF(); tbl_PRK_O.MoveNext())
	{
		mFtabn = toScrObj(tbl_PRK_O.getValue("FTABN"));
		mFdatotp = toScrObj(tbl_PRK_O.getValue("FDAT_OTP"));
		mFbdat = javaDate2Script(toScrObj(tbl_PRK_O.getValue("FBDAT")));
		mFedat = javaDate2Script(toScrObj(tbl_PRK_O.getValue("FEDAT")));
		mFkoef = toScrObj(tbl_PRK_O.getValue("FKOEF"));
		mFsht_id = toScrObj(tbl_PRK_O.getValue("FSHT_ID"));
		mFshpz = toScrObj(tbl_PRK_O.getValue("FSHPZ"));
		mFsum = toScrObj(tbl_PRK_O.getValue("FSUM"));
		mFdat_prik = javaDate2Script(toScrObj(tbl_PRK_O.getValue("FDAT_PRIK")));
		mFvopl = toScrObj(tbl_PRK_O.getValue("FVOPL"));
		mFnom_prik = toScrObj(tbl_PRK_O.getValue("FNOM_PRIK"));
		mFcalnum = toScrObj(tbl_PRK_O.getValue("FCALNUM"));

		// Разобъем приказ на сегменты, полностью попадающие в период месяца

		// У нас 2 сценария работы:
		// - если дата выплаты попадает в расчетный месяц,
		//   то расчет ведем по всем сегментам и в SVZP пишем все суммы.
		// - если дата выплаты НЕ попадает в расчетный месяц,
		//   то расчет ведем только по сегменту, попадающему в расчетный м-ц.

		// Нужна также защита от "дурака". Месяц выплаты не может быть больше (позже)
		// даты начала приказа. В противном случае нам суммы "задвоит".
		if(mFdat_prik > mFbdat)
		{
			strMsg = "Внимание, ошибка!"
				+"\n"
				+"\nВ приказе на отпуск для табельного номера "+mFtabn
				+"\n(приказ № "+mFnom_prik+", период с "+StrDat(mFbdat, "DMY")+" по "+StrDat(mFedat, "DMY")+")"
				+"\nмесяц выплаты позже месяца начала приказа."
				+"\n"
				+"\nПриказ пропущен."
			writeToLog(strMsg, "e", VVOPL, vidprk, lsfid);
			continue;
		}

		// Проверка на кол-во дней отпуска. Потребуем, чтобы кол-во дней в приказе
		// совпадало с кол-вом дней от даты начала до даты конца за исключением
		// праздничных дней. Выполнение данного условия необходимо для правильного
		// распределения дней отпуска между месяцами, на которые он (отпуск) приходится.

		oCalend = new dpCalendar();
		oCalend.setCod(mFcalnum);

		nPrazdn = oCalend.getCalDays("П", mFbdat, mFedat);
		nDays = day_difference(mFbdat, mFedat) - nPrazdn;
		if(nDays!=mFsum)
		{
			strMsg = "Внимание, ошибка!"
				+"\n"
				+"\nВ приказе на отпуск для табельного номера "+mFtabn
				+"\n(приказ № "+mFnom_prik+", период с "+StrDat(mFbdat, "DMY")+" по "+StrDat(mFedat, "DMY")+")"
				+"\nколичество оплачиваемых дней по приказу ("+mFsum+")"
				+"\nотличается от количества дней по календарю ("+nDays+")"
				+"\n"
				+"\nПроверьте правильность внесения приказа и календаря"
				+"\nдля вида оплаты "+mFvopl+"."
				+"\n"
				+"\nПриказ пропущен."
			writeToLog(strMsg, "e", VVOPL, vidprk, lsfid);
			continue;
		}

		// Предварительная инициализация obj_PRK_B,
		// зависящая от конкретного приказа

		obj_PRK_B.Ftabn = mFtabn;
		obj_PRK_B.Ftabn_id = toScrObj(tbl_PRK_O.getValue("FTABN_ID"));
		obj_PRK_B.Fsht_id = mFsht_id;
		obj_PRK_B.Fdat_bol = mFdatotp;
		obj_PRK_B.mFkoef_gp = (mFkoef==0 ? 1 : mFkoef)
		oCl.setCod(mFtabn);
		// Флаг того, что месяц выплаты совпадает с месяцем расчета
		var isVypl = (mFdat_prik>=D1)&&(mFdat_prik<=D2);

		// Флаг того, что данный сегмент - последний
		var isLastSeg = false;

		// Кол-во дней, уже "использованных" в предыдущих сегментах
		var nUsedDays = 0;

		// Инициализируем дату начала 1-го из месяцев расчета
		var oDD1 = new Date(mFbdat);
		oDD1.setDate(1);
		var DD1 = new Date(oDD1);

		// Разбиваем отпуск на сегменты
		while(DD1<=mFedat)
		{
			// Дата конца месяца
			oDD2 = new Date(oDD1.getYear(),oDD1.getMonth()+1,0);
			var DD2 = new Date(oDD2);

			// Проверим, чтобы приказ хотя бы частично попадал в полученный месяц
			if(mFbdat <= DD2)
			{
				// Даты начала и конца сегмента приказа в текущем м-це
				sfbdat = DD1 > mFbdat ? DD1 : mFbdat;
				sfedat = DD2 < mFedat ? DD2 : mFedat;

				// Флаг того, что данный сегмент - последний
				isLastSeg = mFedat<=DD2;

				// Найдем количество дней отпуска, приходящихся на полученный сегмент
				// Т.к. для отпуска берутся календарные дни за исключением праздничных,
				// то достанем кол-во праздничных дней, приходящихся на данный период,
				// из календаря.
				nPrazdn = oCalend.getCalDays("П", sfbdat, sfedat);
				nDays = day_difference(sfbdat, sfedat) - nPrazdn;
				nRest = mFsum-nUsedDays;    // кол-во оставшихся дней по приказу

				if(isLastSeg && nDays!=nRest)
				{
					// В последнем сегменте кол-во оставшихся дней по приказу
					// не совпадает с полученным расчетным путем
					// Такого не должно быть никогда, но на всякий случай...
					strMsg = "Внимание, ошибка!"
					  +"\n"
					  +"\nВ приказе на отпуск для табельного номера "+mFtabn
					  +"\n(приказ № "+mFnom_prik+", период с "+StrDat(mFbdat, "DMY")+" по "+StrDat(mFedat, "DMY")+")"
					  +"\nв последнем сегменте (период с "+StrDat(sfbdat, "DMY")+" по "+StrDat(sfedat, "DMY")+")"
					  +"\nколичество оплачиваемых дней по приказу ("+nRest+")"
					  +"\nотличается от количества дней по календарю ("+nDays+")"
					  +"\n"
					  +"\nПроверьте правильность внесения приказа и календаря"
					  +"\nдля вида оплаты "+mFvopl+"."
					writeToLog(strMsg, "e", VVOPL, vidprk, lsfid);

					// Рассчитаем за фактически оставшееся кол-во дней.
					nDays = nRest;
				}

				nUsedDays+=nDays;

				// Если месяц расчета rasch_mes совпадает с месяцем выплаты, то
				// будет расcчитан весь приказ. В противном случае считаем только
				// по сегменту, попадающему в рассчитываемый месяц.
				if(isVypl || (sfbdat>=D1) && (sfbdat<=D2) )
				{
					// проводим расчет...
					obj_PRK_B.Fsum = nDays;

					if ( (sfbdat>=D1)&&(sfbdat<=D2) )
					{
						// Сегмент относится к месяцу расчета
						mFvp = 0;
						mFmn = d00;
					}
					else
					{
						// Сегмент НЕ относится к месяцу расчета
						mFvp = 2;
						db = new Date(sfbdat);
						db = new Date(db.getFullYear(),db.getMonth(),1);
						db = db.getVarDate();
						mFmn = new Date(db);
					}

					// вычислить первое число отпускного месяца
					db = new Date(mFdatotp);
					db = new Date(db.getFullYear(),db.getMonth(),1);

					// Сначала находим сумму из статистики по отпускным
					obj_PRK_B.vid_sred = 1;
					obj_PRK_B.rmode = "KL";
					obj_PRK_B.plusfmp = false;
					Ok = r_otpall(rasch_mes, DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_WT_LBL_B, tbl_WT_LBL_O, tbl_SRED_INI, oCl, null, tbl_CL_KALEN);
					if (Ok)
					{
						ssum = obj_PRK_B.ssum;
					}

					// Теперь находим сумму из статистики по отпускным из прибыли
					obj_PRK_B.vid_sred = 10;
					obj_PRK_B.rmode = "KL";
					obj_PRK_B.plusfmp = true;
					Ok = r_otpall(rasch_mes, DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_WT_LBL_B, tbl_WT_LBL_O, tbl_SRED_INI, oCl, null, tbl_CL_KALEN);
					if (Ok)
					{
						ssump = obj_PRK_B.ssump;
					}

					var m = new Object();

					if ((ssum+ssump)!=0)
					{
						m.FTABN_ID = toScrObj(tbl_PRK_O.getValue("FTABN_ID"));
						m.FFLD_NUM = ffld_num;
						m.FLSFID = lsfid;
						m.FSUM = ssum+ssump;
						m.FWID_WP = toScrObj(tbl_PRK_O.getValue("FWID_WP"));
						m.FSHPZ = mFshpz;
						var gd = new Date(sfbdat);
						gd = gd.getDate();
						m.FBDY = gd;
						m.FDAY = nDays;
						m.FVP = mFvp;
						m.FMN = mFmn;
						m.FIS_DAY = 0;
						m.FID_PRK = toScrObj(tbl_PRK_O.getValue("FWID"));
						m.FVID_PRK = vidprk;
						UpdateTable("^"+(svzpName?svzpName:"svzp")+szTag, m, true);
					}
					m = null;
				}
			} //end of if(mFbdat <= DD2)

			// Начало следующего сегмента
			oDD1 = goDay(oDD2, 1);
			DD1 = new Date(oDD1);
		} //end of while(DD1<=mFedat)
	}//for

	DefVed.end();

	tbl_PRK_O.close(5652);
	tbl_PRK_O = null;
	tbl_SVZP.close(5652);
	tbl_SVZP = null;
	tbl_CL_KALEN.close(5652);
	tbl_CL_KALEN = null;
	tbl_CL_KF.close(5652);
	tbl_CL_KF = null;
	tbl_SRED_INI.close(5652);
	tbl_SRED_INI = null;
	tbl_WT_LBL_B.close(5652);
	tbl_WT_LBL_B = null;
	tbl_WT_LBL_O.close(5652);
	tbl_WT_LBL_O = null;
	tbl_PRK_FMPL.close(5652);
	tbl_PRK_FMPL = null;
	tbl_DTPRKB.close(5652);
	tbl_DTPRKB = null;
	obj_PRK_B = null;
	DefVed = null;

	return true;
}