//Этот расчет соцстраха для того случая, если хотят удерживать фонд не по месяцу возникновения, а по месяцу
//выплаты. В этом случае нужны 2 процедуры - r_pnfp14 и r_pnfp14s. Идут в таком порядке в перечне расчетов одна за другой
//должен быть установлен параметр ssnach в справочнике констант и віключено сравнение для поля соцстраха в перечне полей ЛС
//Сделано так: первый расчет при наличии параметра не рассчитывает соцстрах. Второй расчет перебивает прошлые суммы, как
// текущие, и потом производится расчет фонда по общей сумме из лицевого счета. Будущие суммы, как и раньше, должны учитываться
//отдельно.
//одновременно с использованием этих процедур нужно использовать расчеты фондов r_fndzpd и r_fndss вместо одного r_fndzp
//эти расчеты работают по такому же принципу: первый расчет не считает начисления на зарплату в соцстрах, а второй уже считает
//по такому же параметру.
// к этим же процедурам нужен сбор статистики по параметру bstnach, процедура r_st_otp. Она тоже собирает статистику по больничным
//по месяцу начисления и по месяцу выплаты в зависимости от параметра.
include("get_const.js")
function name_pnfp14s()
{
	return "Утримання пенсійного фонду, фонду зайнятості та профвнесків|Удержание пенсионного фонда, фонда занятости и профвзносов";
}

function r_pnfp14s(month, vopl, vidprk, lsfid, lsfid2, ftabn_id, svzpName)
{
	
    var bln_mes_nach = get_cnst("ssnach", month)
    if (bln_mes_nach ==0) return    
   	
	//*     взять из кл-ра const процент пенс.фонда
	var proc_pns = get_cnst("proc_pns", month)/100;
	//*     взять из кл-ра const процент проф.взносов
	var proc_prf = get_cnst("proc_prf", month)/100;
	//*     взять из кл-ра const процент проф.взносов
	var proc_zan = get_cnst("proc_zan", month)/100;
	//*     взять из кл-ра const границу для 1% пенс.взносов
	var gr_pns = get_cnst("gr_pns", month);
	//*     взять из кл-ра const 1% пенс.взносов
	var proc_pns1 = get_cnst("proc_pns1", month)/100;
	

	//*     взять из кл-ра const процент соцстраха для 0.025%
	var proc_soc1 = get_cnst("proc_soc1", month)/100;
	//*     взять из кл-ра const процент соцстраха для 0.05%
	var proc_soc = get_cnst("proc_soc", month)/100;
	//*     взять из кл-ра const границу для 0.25% фонда соцстраха
	var gr_soc  = get_cnst("gr_soc", month);
	var soc1000 = get_cnst("soc1000", month);

	var prf1000 = get_cnst("prf1000", month);
	var zan1000 = get_cnst("zan1000", month);
	var pns1000 = get_cnst("pns1000", month);
	var sum_ogr = get_cnst("sum_ogr", month);
	if(!sum_ogr)
	{
		msg = ru("Не найдена константа суммы ограничения sum_ogr за",
				"Не знайдено константу граничної суми sum_ogr за")+format(" dd.mm.yyyy",month).toLowerCase();
		writeToLog(msg,"e",vopl,vidprk);
	}
	var za_tek_mes = getPar("CUR_PN");
	//* код поля пенс.фонда
	var cod_pns = get_cnst("cod_pns", month);
	//* код поля соцстраха 
	var cod_soc = get_cnst("cod_soc", month);
	// достаем цифры к названию файла
	
	//28.01.09***********
	//* код поля фонда занятости 
	var cod_zan = get_cnst("cod_zan", month);
	strSQL = "select Ffld_num from ^LIC_FLD where Fid="+sqlTo(cod_zan);
	var tvdpls = getSnap(strSQL);
	if (tvdpls!=null)
		num_zan = tvdpls[0];

	//* код поля базы фонда занятости 0,5% 
	var cod_zb1 = get_cnst("cod_zb1", month);
	strSQL = "select Ffld_num from ^LIC_FLD where Fid="+sqlTo(cod_zb1);
	var tvdpls = getSnap(strSQL);
	if (tvdpls!=null)
		num_zb1 = tvdpls[0];

	//* код поля базы фонда занятости 0,6% 
	var cod_zb2 = get_cnst("cod_zb2", month);
	strSQL = "select Ffld_num from ^LIC_FLD where Fid="+sqlTo(cod_zb2);
	var tvdpls = getSnap(strSQL);
	if (tvdpls!=null)
		num_zb2 = tvdpls[0];

	//*     взять из кл-ра const процент фонда занятости для 0,5%
	var proc_zan1 = get_cnst("proc_zan1", month)/100;
	//**************
	
	//* прожиточный минимум	c 01.01.2007
   var progmin = get_cnst("progmin", month)
   
   //* код поля пенс.фонда справочного после 2007 года
   var cod_p07 = get_cnst("cod_p07", month);
   
   //* код поля пенс.фонда справочного после 2007 года
   var prop_round = get_cnst("prop_round", month);
   if(!prop_round)
   	prop_round = 2;
   
   var vdplp07 = 0;
   strSQL = "select Ffld_num from ^LIC_FLD where Fid="+ sqlTo(cod_p07);
   var tvdplp07 = getSnap(strSQL);
   if (tvdplp07)
      vdplp07 = tvdplp07[0];
   
	
	var szTag = (month.getFullYear())+((month.getMonth()< 9)?"0":"") + (month.getMonth()+1);	
	// достаем цифры из прошлого месяца
	var pervMonth = new Date(month.getFullYear(), month.getMonth()-1, 1);
	var szTagPrev = "" + (pervMonth.getFullYear())+((pervMonth.getMonth()<9)?"0":"") + (pervMonth.getMonth() + 1) ;        
	// дата начала
	var D1 = new Date(month.getFullYear(), month.getMonth(), 1);
	// дата конца
	var D2 = new Date(month.getFullYear(), month.getMonth() + 1, 1);
	D2.setDate(0);   

	var vdplp = 0;
	var vdpls = 0;
	var vdpl2 = 0;
//	var strSQL = "SELECT ffld_num FROM ^lic_fld WHERE fid=";
//	var snap = getSnap(strSQL + sqlTo(cod_pns));
//	if(null != snap)
//		vdplp = snap[0];

//	snap = getSnap(strSQL + sqlTo(cod_soc));
//	if(null != snap)
//		vdpls = snap[0];

//	snap = getSnap(strSQL + sqlTo(lsfid2));
//	if(null != snap)
//		vdpl2 = snap[0];

	strSQL = "select Ffld_num from ^LIC_FLD where Fid="+sqlTo(cod_soc);
	var tvdpls = getSnap(strSQL);
	if (tvdpls!=null)
		vdpls = tvdpls[0];
	
	var fld_found,fld_found1,fld_found2

	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis_slct<>" + sqlFalse
			+ " AND fis1=" + sqlTo("ф");
	snap = getSnap(strSQL);

	var fld_found = false;
	var nach_lsfid = 0;
	var nach_lsnum = 0;
	if(snap != null)
	{
		fld_found = true;
		nach_lsfid = snap[0];
		nach_lsnum = snap[1];
	}
	else
	{ 
		msg = "Hельзя идентиф.поле ЛС: проф. взносы.\n"
			+ "Если есть необх.в расч.профвзносов,\n"
			+ "поставьте букву <ф> в 1-ю колонку таблицы вхожд-я полей";
		writeToLog(msg,"w",vopl, vidprk, lsfid);
	}

	var fld_found1 = false;
	var nach_lsfi1 = 0;
	var nach_lsnu1 = 0;
	
	if (cod_pns!=0)
	{   
		strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis8='п' and fid<>" + sqlTo(cod_pns)+" ORDER BY fid";
		snap = getSnap(strSQL);
		if(null != snap)
		{
			fld_found1 = true;
			nach_lsfi1 = snap[0];
			nach_lsnu1 = snap[1];
		}
		else
		{
			msg = "Hельзя идентиф.поле ЛС: пенс.фонд.\n"
				+ "Если есть необх.в расч.пенс. фонда,\n"
				+ " поставьте букву <п> в 8-ю колонку таблицы вхожд-я полей";
			writeToLog(msg,"w",vopl, vidprk, lsfid);
		} 
	}
	else
	{
		strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis8='п' AND fis_slct=" + sqlTrue+" ORDER BY fid";
		snap = getSnap(strSQL);
		if(null == snap)
		{ 
			msg = "Hельзя идентиф.поле ЛС: пенс.фонд.\n"
				+ "Если есть необх.в расч.пенс. фонда,\n"
				+ "поставьте букву <п> в 8-ю колонку таблицы вхожд-я полей";
			writeToLog(msg,"w",vopl, vidprk, lsfid);
		}
		else
		{
			fld_found1 = true;
			nach_lsfi1 = snap[0];
			nach_lsnu1 = snap[1];
		}
	}

	var fld_found2 = false;
	var nach_lsfi2 = 0;
	var nach_lsnu2 = 0;
	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis1='з' AND fis_slct=" + sqlTrue;
	snap = getSnap(strSQL);
	if(null == snap)
	{
		msg = "Hельзя идентиф.поле ЛС: фонд занятости.\n"
			+ "Если есть необх.в расч.фонда занятости,\n"
			+ "поставьте букву <з> в 1-ю колонку таблицы вхожд-я полей";
		writeToLog(msg,"w",vopl, vidprk, lsfid);
	}
	else
	{
		fld_found2 = true;
		nach_lsfi2 = snap[0];
		nach_lsnu2 = snap[1];
	}
	
	var fld_found3 = false;
	var nach_lsfi3 = 0;
	var nach_lsnu3 = 0;
	
	if (cod_soc!=0)
	{   
		strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis8='с' AND fid<>" + sqlTo(cod_soc);
		snap = getSnap(strSQL);
		if(null != snap)
		{
			fld_found3 = true;
			var nach_lsfi3 = snap[0];
			var nach_lsnu3 = snap[1];
		}
		else
		{
			msg = "Hельзя идентиф.поле ЛС: соцстрах\n"
				+ "Если есть необх.в расч. соцстраха,\n"
				+ "поставьте букву <с> в 1-ю колонку таблицы вхожд-я полей";
			writeToLog(msg,"w",vopl, vidprk, lsfid);
		} 
	}
	else
	{
		strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis8='с' AND fis_slct=" + sqlTrue;
		snap = getSnap(strSQL);
		if (null == snap)
		{
			msg = "Hельзя идентиф.поле ЛС: соцстрах\n"
				+ "Если есть необх.в расч. соцстраха,\n"
				+ "поставьте букву <с> в 1-ю колонку таблицы вхожд-я полей";
			writeToLog(msg,"w",vopl, vidprk, lsfid);
		}
		else
		{
			fld_found3 = true;
			nach_lsfi3 = snap[0];
			nach_lsnu3 = snap[1];
		}
	}

	if (!fld_found && !fld_found1 && !fld_found2 && !fld_found3) 
		return false;
	var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+") ":"";
	var strPrevTabName = (svzpName?svzpName:"svzp") + szTagPrev;
	var strMainTabName = (svzpName?svzpName:"svzp") + szTag;

	if (za_tek_mes)
	{ 
		if(IsTable("tmp_svzp"))
			DropTable("tmp_svzp");

		CreateTable("tmp_svzp", "svzpt");
		strPrevTabName = (svzpName?svzpName:"svzp") + szTag;
		strMainTabName = "tmp_svzp";
	}  

	if(null == getSnap("SELECT COUNT(*) FROM ^" + strPrevTabName + " WHERE 1=1 " + sqlTabn))
		return true;

//т.к. SqlDaysBWDates не возвращает отрицательную разницу между месяцами для DERBY, приходится обрабатывать знак вручную
	if(SUBD==DERBY)
		var strOffset = IIF("s.fvp=0"
						, 1
						,  IIF("s.fvp=2"
						,IIF(sqlTo(D1)+">s.fmn"
							,"-"+sqlRound(sqlRound(SqlDaysBWDates(sqlTo(D1),"s.fmn"),0) + "/30.0",0)
							,sqlRound(sqlRound(SqlDaysBWDates(sqlTo(D1),"s.fmn"),0) + "/30.0",0))+"+1"
//							, sqlRound(sqlRound(SqlDaysBWDates(sqlTo(D1),"s.fmn"),0) + "/30",0) + "+1"
//							, Convert("ABS(" + Convert(SqlDaysBWDates("s.fmn",sqlTo(D1)),"INT") + "/30)","INT") + "+1"
							, 0));
	else
		var strOffset = IIF("s.fvp=0"
						, 1
						,  IIF("s.fvp=2"
							, sqlRound(sqlRound(SqlDaysBWDates(sqlTo(D1),"s.fmn"),0) + "/30.0",0) + "+1"
							, 0));
	
	var ssum1 = "SUM(" + IIF("l.fis8='+' AND (l.fis9<>'б' or l.fis9 is null)", "s.fsum", 0) + ")";
	var ssum2 = "SUM(" + IIF("l.fis8='#' AND (l.fis9<>'б' or l.fis9 is null)", "s.fsum", 0) + ")";
	var ssum3 = "SUM(" + IIF("l.fis8='*' AND (l.fis9<>'б' or l.fis9 is null)", "s.fsum", 0) + ")";
	var ssum4 = "SUM(" + IIF("l.fis8='%' AND (l.fis9<>'б' or l.fis9 is null)", "s.fsum", 0) + ")";
	var ssum5 = "SUM(" + IIF("l.fis8='&' AND (l.fis9<>'б' or l.fis9 is null)", "s.fsum", 0) + ")";
	var ssum6 = "SUM(" + IIF("l.fis8='$' AND (l.fis9<>'б' or l.fis9 is null)", "s.fsum", 0) + ")";
	var ssum8 = "SUM(" + IIF("l.fis8='?' AND (l.fis9<>'б' or l.fis9 is null)", "s.fsum", 0) + ")";
	var ssum7 = "SUM(" + IIF("l.fis17='+' AND (l.fis9<>'б' or l.fis9 is null)", "s.fsum", 0) + ")";
	var ssumbon = "SUM(" + IIF("l.fis9='б'", "s.fsum", 0) + ")";

	//*******собирание времени, отработанного до 13 числа. поле Fday_prop  28.01.09. 
	var vsum1do = "SUM(" + IIF("l.fis8='+' AND (l.fis9<>'б' or l.fis9 is null)", "s.fsumdo", 0) + ")";
	var vsum3do = "SUM(" + IIF("l.fis8='*' AND (l.fis9<>'б' or l.fis9 is null)", "s.fsumdo", 0) + ")";
	var vsum4do = "SUM(" + IIF("l.fis8='%' AND (l.fis9<>'б' or l.fis9 is null)", "s.fsumdo", 0) + ")";
	var vsum6do = "SUM(" + IIF("l.fis8='$' AND (l.fis9<>'б' or l.fis9 is null)", "s.fsumdo", 0) + ")";
	//******************

	//* запоминание суммы профсоюзных взносов, удержанного не по месту осн. работы 
	var ud_profvzn    = "SUM(" + IIF("l.fis8='-'", "s.fsum", 0) + ")";
	var strTempTableName = getTmpTableName();
	var tempTbl = getTmpTableName();

	//*******собирание времени, отработанного до 13 числа. поле Fday_prop  28.01.09.
	/*
	strSQL = " select fvp,ftabn_id,flsfid,fsum, "+ strOffset + " AS offset INTO " + tempTbl 
			+ " FROM ^" + strPrevTabName + " as s "
			+" WHERE " + strOffset + ">=1";
	*/
	//strSQL = " select fvp,ftabn_id,flsfid,fsum,Fwid_wp, "+ strOffset + " AS offset INTO " + tempTbl 
	//		+ " FROM ^" + strPrevTabName + " as s "
	//		+" WHERE " + strOffset + ">=1";
	
   DropTable("ZPVSPS");
   if (!differ(base_month, month)){
      ExecuteSQL("select ftabn_id,fwid_wp,flsfid,ffld_num,fmn,Fvp,Fsum,Fshpz,Fid_prk,Fwid,Fday_prop,Fchas_prop,Fis_day,Fday,Fchas into ZPVSPS FROM ^" + strPrevTabName +" WHERE NOT (Fvp=1 and Fmn>="+sqlTo(month)+")" + sqlTabn);
   }else{
      //небазовый месяц, ничего не считаем
      return 
   }
   strSQL = "UPDATE ZPVSPS set Fvp=0, Fmn="+sqlTo(d00obj)+" where Fvp=2 and Fmn<"+sqlTo(month);
   ExecuteSQL(strSQL);
	
	//strSQL = " select fvp,ftabn_id,flsfid,fsum, fsum as Fsumdo, Fday_prop, Fwid_wp, "+Convert("0","DBL")+" as Fnorma_d, 0 as Fvopl, "+ strOffset + " AS offset INTO " + tempTbl 
	//		+ " FROM ^" + strPrevTabName + " as s "
	//		+" WHERE " + strOffset + ">=1";
	strSQL = " select fvp,ftabn_id,flsfid,fsum, fsum as Fsumdo, Fday_prop, Fwid_wp, "+Convert("0","DBL")+" as Fnorma_d, 0 as Fvopl, "+ strOffset + " AS offset INTO " + tempTbl 
			+ " FROM ZPVSPS as s"
			+" WHERE " + strOffset + ">=1";
	ExecuteSQL(strSQL);

	ExecuteSQL("UPDATE "+ tempTbl+" set Fday_prop=0 where Fday_prop is null")
	
	ExecuteSQL("UPDATE "+ tempTbl+" set Fvopl=(select Fvopl from ^work_pers as w where "+tempTbl+".fwid_wp=w.Fwid) where fwid_wp>0")	

	ExecuteSQL("UPDATE "+ tempTbl+" set Fnorma_d=(select Fnorma_d from ^tbl_ini where "+tempTbl+".Fvopl=^tbl_ini.Fvopl and ^tbl_ini.Fbdat="+sqlTo(month)+") where fwid_wp>0")
	
	ExecuteSQL("UPDATE "+ tempTbl+" set Fsumdo="+sqlRound("Fsum*"+sqlRound("Fday_prop/Fnorma_d",prop_round),2)+" where fwid_wp>0")
/*
	DropTable("ZZZ0")
	strSQL = " select fvp,ftabn_id,flsfid,fsum, fsum as Fsumdo, Fday_prop,Fwid_wp, "+Convert("0","DBL")+" as Fnorma_d, 0 as Fvopl, "+ strOffset + " AS offset INTO ZZZ0 " 
			+ " FROM ^" + strPrevTabName + " as s "
			+" WHERE " + strOffset + ">=1";
	ExecuteSQL(strSQL);

	ExecuteSQL("UPDATE "+ tempTbl+" set Fday_prop=0 where Fday_prop is null")
	
	ExecuteSQL("UPDATE ZZZ0 set Fvopl=(select Fvopl from ^work_pers as w where zzz0.fwid_wp=w.Fwid) where fwid_wp>0")	

	ExecuteSQL("UPDATE ZZZ0 set Fnorma_d=(select Fnorma_d from ^tbl_ini where ZZZ0.Fvopl=^tbl_ini.Fvopl and ^tbl_ini.Fbdat="+sqlTo(month)+") where fwid_wp>0")

	ExecuteSQL("UPDATE zzz0 set Fsumdo="+sqlRound("Fsum*"+sqlRound("Fday_prop/Fnorma_d",prop_round),2)+" where fwid_wp>0")
*/
	//28.01.09 Добавить норму времени для каждого человека во временный файл, чтобы легче рассчитать пропорцию
	/*
	strSQL = "SELECT ftabn_id, fvp,  offset"
				+ ", " + ssum1 + " AS ssum1"
				+ ", " + ssum2 + " AS ssum2"
				+ ", " + ssum3 + " AS ssum3"
				+ ", " + ssum4 + " AS ssum4"
				+ ", " + ssum5 + " AS ssum5"
				+ ", " + ssum6 + " AS ssum6"
				+ ", " + ssum7 + " AS ssum7"
				+ ", " + ssum8 + " AS ssum8"
				+ ", " + ssumbon + " AS ssumbon"
				+ ", " + ud_profvzn + " AS ud_profvzn"
			+ " INTO " + strTempTableName
			+ " FROM " + tempTbl + " AS s INNER JOIN ^lic_fld AS l ON s.flsfid=l.fid"
			+ " GROUP BY ftabn_id, fvp, offset";
			//+ " WHERE " + strOffset + ">=1"
			//+ " GROUP BY ftabn_id, fvp" 
	*/
	strSQL = "SELECT ftabn_id, fvp,  offset"
				+ ", " + ssum1 + " AS ssum1"
				+ ", " + ssum2 + " AS ssum2"
				+ ", " + ssum3 + " AS ssum3"
				+ ", " + ssum4 + " AS ssum4"
				+ ", " + ssum5 + " AS ssum5"
				+ ", " + ssum6 + " AS ssum6"
				+ ", " + ssum7 + " AS ssum7"
				+ ", " + ssum8 + " AS ssum8"
				+ ", " + ssumbon + " AS ssumbon"
				+ ", " + ud_profvzn + " AS ud_profvzn"
				+ ", " + vsum1do + " AS vsum1do"
				+ ", " + vsum3do + " AS vsum3do"
				+ ", " + vsum4do + " AS vsum4do"
				+ ", " + vsum6do + " AS vsum6do"
				//+ ", s.Fnorma_d AS Fnorma_d "				
			+ " INTO " + strTempTableName
			+ " FROM " + tempTbl + " AS s INNER JOIN ^lic_fld AS l ON s.flsfid=l.fid "
			+ " GROUP BY ftabn_id, fvp, offset";
	//*******************************
	ExecuteSQL(strSQL);

	DropTable("ZZZ")
	strSQL = "SELECT ftabn_id, fvp,  offset"
				+ ", " + ssum1 + " AS ssum1"
				+ ", " + ssum2 + " AS ssum2"
				+ ", " + ssum3 + " AS ssum3"
				+ ", " + ssum4 + " AS ssum4"
				+ ", " + ssum5 + " AS ssum5"
				+ ", " + ssum6 + " AS ssum6"
				+ ", " + ssum7 + " AS ssum7"
				+ ", " + ssum8 + " AS ssum8"
				+ ", " + ssumbon + " AS ssumbon"
				+ ", " + ud_profvzn + " AS ud_profvzn"
				+ ", " + vsum1do + " AS vsum1do"
				+ ", " + vsum3do + " AS vsum3do"
				+ ", " + vsum4do + " AS vsum4do"
				+ ", " + vsum6do + " AS vsum6do"
				//+ ", s.Fnorma_d AS Fnorma_d "				
			+ " INTO ZZZ" 
			+ " FROM " + tempTbl + " AS s INNER JOIN ^lic_fld AS l ON s.flsfid=l.fid "
			+ " GROUP BY ftabn_id, fvp, offset";
	ExecuteSQL(strSQL);


	var sSqlMonth = 'MONTH'
	if(SUBD==DERBY)
	 	sSqlMonth = "'MONTH'"
	var strMn = IIF("t.offset>1", sqlDateAdd(sqlTo(month),"t.offset-1", sSqlMonth), sqlTo(d00));
	/*
	if(fld_found2)
	{
		//*******собирание времени, отработанного до 13 числа. Например, поле Fday_prop  28.01.09
		if (cod_zan!=0){
			//02.02.09 Деление по общей базе за месяц
			var xx    = "(t.ssum1 + t.ssum3 + t.ssum4 + t.ssum6)"
			var vxxdo = "((t.ssum1 + t.ssum3 + t.ssum4 + t.ssum6)-(t.vsum1do + t.vsum3do + t.vsum4do + t.vsum6do))* ("+sum_ogr+"/(t.ssum1 + t.ssum3 + t.ssum4 + t.ssum6))"
			var xx1 = IIF("(" + zan1000 + "=1 AND " + sum_ogr + ">0) AND " + xx + ">" + sum_ogr, vxxdo, "(t.ssum1 + t.ssum3 + t.ssum4 + t.ssum6)-(t.vsum1do + t.vsum3do + t.vsum4do + t.vsum6do)");				
			var f_nal = xx1 + "*" + proc_zan;

		}else{
			var xx = "(t.ssum1 + t.ssum3 + t.ssum4 + t.ssum6)"
			var xx1 = IIF("(" + zan1000 + "=1 AND " + sum_ogr + ">0) AND " + xx + ">" + sum_ogr, sum_ogr, xx);
			var f_nal = xx1 + "*" + proc_zan;
		}
	
		strSQL = "INSERT INTO ^"+ strMainTabName 
				+" (ftabn_id,fwid_wp, fsum, flsfid, ffld_num, fmn, fvp, fvid_prk, favt)"
				+" SELECT t.ftabn_id,0 as fwid_wp"
					+ ", " + sqlRound(f_nal,2) + " AS fsum"
					//+ ", " + sqlRound(xx1,2) + " AS fpr"					
					+ ", " + nach_lsfi2 + " AS flsfid"
					+ ", " + nach_lsnu2 + " AS ffld_num"
					+ ", " + strMn + " AS fmn"
					+ ", t.fvp"
					+ ", " + vidprk + " AS fvid_prk"
					+ ", " + sqlTrue + " AS favt"
				+" FROM " + strTempTableName + " AS t "
				+" WHERE " + f_nal + "<>0";
		ExecuteSQL(strSQL);
					
		//*******собирание времени, отработанного после 13 числа. Например, поле Fday_prop  28.01.09
		if (cod_zan!=0){
			//02.02.09 Деление по общей базе за месяц
			var xx    = "(t.ssum1 + t.ssum3 + t.ssum4 + t.ssum6)"
			var vxxdo = "(t.vsum1do + t.vsum3do + t.vsum4do + t.vsum6do)* ("+sum_ogr+"/(t.ssum1 + t.ssum3 + t.ssum4 + t.ssum6))"
			var xx1 = IIF("(" + zan1000 + "=1 AND " + sum_ogr + ">0) AND " + xx + ">" + sum_ogr, vxxdo, "(t.vsum1do + t.vsum3do + t.vsum4do + t.vsum6do)");				
			var f_nal = xx1+ "*" + proc_zan1;
			
			strSQL = "INSERT INTO ^"+ strMainTabName 
				+" (ftabn_id,fwid_wp, fsum, flsfid, ffld_num, fmn, fvp, fvid_prk, favt)"
				+" SELECT t.ftabn_id,0 as fwid_wp"
					+ ", " + sqlRound(f_nal,2) + " AS fsum"
					//+ ", " + sqlRound(xx1,2) + " AS fpr"					
					+ ", " + cod_zan + " AS flsfid"
					+ ", " + num_zan + " AS ffld_num"
					+ ", " + strMn + " AS fmn"
					+ ", t.fvp"
					+ ", " + vidprk + " AS fvid_prk"
					+ ", " + sqlTrue + " AS favt"
				+" FROM " + strTempTableName + " AS t "
				+" WHERE " + f_nal + "<>0";
			ExecuteSQL(strSQL);
		}	

		if (cod_zb1!=0){
			//02.02.09 Деление по общей базе за месяц
			var xx    = "(t.ssum1 + t.ssum3 + t.ssum4 + t.ssum6)"
			var vxxdo = "(t.vsum1do + t.vsum3do + t.vsum4do + t.vsum6do)* ("+sum_ogr+"/(t.ssum1 + t.ssum3 + t.ssum4 + t.ssum6))"
			var xx1 = IIF("(" + zan1000 + "=1 AND " + sum_ogr + ">0) AND " + xx + ">" + sum_ogr, vxxdo, "(t.vsum1do + t.vsum3do + t.vsum4do + t.vsum6do)");				
			var f_nal = xx1+ "*" + proc_zan1;
			
			strSQL = "INSERT INTO ^"+ strMainTabName 
				+" (ftabn_id,fwid_wp, fsum, flsfid, ffld_num, fmn, fvp, fvid_prk, favt)"
				+" SELECT t.ftabn_id,0 as fwid_wp"
					+ ", " + sqlRound(xx1,2) + " AS fsum"
					+ ", " + cod_zb1 + " AS flsfid"
					+ ", " + num_zb1 + " AS ffld_num"
					+ ", " + strMn + " AS fmn"
					+ ", t.fvp"
					+ ", " + vidprk + " AS fvid_prk"
					+ ", " + sqlTrue + " AS favt"
				+" FROM " + strTempTableName + " AS t "
				+" WHERE " + f_nal + "<>0";
			ExecuteSQL(strSQL);
		}	

		if (cod_zb2!=0){
			//02.02.09 Деление по общей базе за месяц
			var xx    = "(t.ssum1 + t.ssum3 + t.ssum4 + t.ssum6)"
			var vxxdo = "((t.ssum1 + t.ssum3 + t.ssum4 + t.ssum6)-(t.vsum1do + t.vsum3do + t.vsum4do + t.vsum6do))* ("+sum_ogr+"/(t.ssum1 + t.ssum3 + t.ssum4 + t.ssum6))"
			var xx1 = IIF("(" + zan1000 + "=1 AND " + sum_ogr + ">0) AND " + xx + ">" + sum_ogr, vxxdo, "(t.ssum1 + t.ssum3 + t.ssum4 + t.ssum6)-(t.vsum1do + t.vsum3do + t.vsum4do + t.vsum6do)");				
			var f_nal = xx1 + "*" + proc_zan;
			
			strSQL = "INSERT INTO ^"+ strMainTabName 
				+" (ftabn_id,fwid_wp, fsum, flsfid, ffld_num, fmn, fvp, fvid_prk, favt)"
				+" SELECT t.ftabn_id,0 as fwid_wp"
					+ ", " + sqlRound(xx1,2) + " AS fsum"
					+ ", " + cod_zb2 + " AS flsfid"
					+ ", " + num_zb2 + " AS ffld_num"
					+ ", " + strMn + " AS fmn"
					+ ", t.fvp"
					+ ", " + vidprk + " AS fvid_prk"
					+ ", " + sqlTrue + " AS favt"
				+" FROM " + strTempTableName + " AS t "
				+" WHERE " + f_nal + "<>0";
			ExecuteSQL(strSQL);
		}
		//****************
		//удаляем записи для приказов позволяющих не удерживать фонд занятости
        /*коды записей штатного могли поменяться, а код приказа - старый
		strSQL = "DELETE FROM ^" + strMainTabName 
					+ " WHERE ftabn_id in "
					+ " (SELECT ftabn_id FROM ^prk_all "
						+ " WHERE ((fbdat<=" + sqlTo(D1) + " AND fedat>=" + sqlTo(D2) +")" 
							+ " OR (fbdat>=" + sqlTo(D1) + " AND fbdat<=" + sqlTo(D2) +")" 
							+ " OR (fedat>=" + sqlTo(D1) + " AND fedat<=" + sqlTo(D2) +"))"
							+ " AND fin_table='PR_PENSZ')";
							
		ExecuteSQL(strSQL);
	}
	
	if(fld_found1)
	{		
		var xx = "(t.ssum1 + t.ssum3 + t.ssum5 + t.ssum8)"
		var xx1 = IIF("(" + pns1000 + "= 1 AND " + sum_ogr + ">0) AND " + sum_ogr + "<" + xx, sum_ogr, xx);
		//var f_nal = xx1 + "*" + IIF("(" + gr_pns + ">0 AND " + gr_pns + ">=" + xx1 + ")", proc_pns1, proc_pns);
		//с 01.01.2007: (сумма<progmin)*1% + ((сумма>progmin)-progmin)*2%
		var f_nal1 = sqlRound(xx1 +"*"+ proc_pns1, 2);
		var f_nal2 = sqlRound("("+ progmin +"*"+ proc_pns1 +")", 2) 
			   +"+"+ sqlRound("(("+ xx1 +"-"+ progmin +")*"+ proc_pns +")", 2);	
		var f_nal = IIF("(" + progmin + ">0 AND " + xx1 + "<=" + progmin + ")", f_nal1, f_nal2);
		strSQL = "INSERT INTO ^"+ strMainTabName 
				+" (ftabn_id,fwid_wp, fsum, flsfid, ffld_num, fmn, fvp, fvid_prk, favt)"
				+" SELECT t.ftabn_id,0 as fwid_wp"
					+ ", " + f_nal + " AS fsum"
					+ ", " + nach_lsfi1 + " AS flsfid"
					+ ", " + nach_lsnu1 + " AS ffld_num"
					+ ", " + strMn + " AS fmn"
					+ ", t.fvp"
					+ ", " + vidprk + " AS fvid_prk"
					+ ", " + sqlTrue + " AS favt"
				+" FROM " + strTempTableName + " AS t"
				+" WHERE " + f_nal + "<>0";
		ExecuteSQL(strSQL);
	
		if (lsfid2 != null)
		{
			//var f_nalb = "(t.ssumbon*" + IIF("(" + gr_pns + ">0 AND t.ssumbon<=" + gr_pns + ")", proc_pns1, proc_pns) + ")";
			var f_nalb1 = sqlRound("t.ssumbon*"+ proc_pns1, 2);
			var f_nalb2 = sqlRound("("+ progmin +"*"+ proc_pns1 +")", 2) 
					+"+"+ sqlRound("((t.ssumbon-"+ progmin +")*"+ proc_pns +")", 2);
			var f_nalb = "(" + IIF("(" + progmin + ">0 AND t.ssumbon<=" + progmin + ")", f_nalb1, f_nalb2) + ")";
			strSQL = "INSERT INTO ^" + strMainTabName + " (ftabn_id,fwid_wp, fsum, flsfid, ffld_num, fmn, fvp, fvid_prk, favt)"
					+ " SELECT t.ftabn_id,0 as fwid_wp"
					+ ", " + f_nalb + " AS fsum"
					+ ", " + lsfid2 + " AS flsfid"
					+ ", " + IIF(sqlTo(lsfid2) + "<>0"
								, "(SELECT l.ffld_num FROM ^lic_fld AS l WHERE l.fid=" + sqlTo(lsfid)  + ")"
								, 0) + " AS ffld_num"
					+ ", " + strMn + " AS fmn"
					+ ", t.fvp"
					+ ", " + vidprk + " AS fvid_prk"
					+ ", " + sqlTrue + " AS favt"
				+ " FROM " + strTempTableName + " AS t";
				+" WHERE " + f_nalb + "<>0";
			ExecuteSQL(strSQL);
		}
		
		if (cod_p07!=0)	
		{            
            var sum1 = sqlRound(xx +"*"+ proc_pns1, 2);
			var sum2 = sqlRound(progmin +"*"+ proc_pns1, 2);
			var sum05 = IIF("("+ progmin +">0 AND "+ xx +"<="+ progmin +")", sum1, sum2);
			
			strSQL = "INSERT INTO ^"+ strMainTabName 
				+" (ftabn_id,fwid_wp, fsum, flsfid, ffld_num, fmn, fvp, fvid_prk, favt)"
				+" SELECT t.ftabn_id,0 as fwid_wp"
					+ ", " + sum05 + " AS fsum"
					+ ", " + cod_p07 + " AS flsfid"
					+ ", " + vdplp07 + " AS ffld_num"
					+ ", " + strMn + " AS fmn"
					+ ", t.fvp"
					+ ", " + vidprk + " AS fvid_prk"
					+ ", " + sqlTrue + " AS favt"
				+" FROM " + strTempTableName + " AS t"
				+" WHERE " + sum05 + "<>0";
			ExecuteSQL(strSQL);
		}
	}
	*/
    if (bln_mes_nach !=0){	
		if(fld_found3)
		{
			var xx = "t.ssum7";
			var xx1 = IIF("(" + soc1000 + "= 1 AND " + sum_ogr + ">0) AND " + sum_ogr + "<" + xx, sum_ogr, xx);
			var f_nal = xx1 + "*" + IIF("(" + gr_soc + ">0 AND " + gr_soc + ">=" + xx1 + ")", proc_soc1, proc_soc);
			if (cod_soc!=0){
				strSQL = "INSERT INTO ^" + strMainTabName + " (ftabn_id,fwid_wp, fsum, flsfid, ffld_num, fmn, fvp, fvid_prk, favt)"
				+ " SELECT t.ftabn_id,0 as fwid_wp"
					+ ", " + sqlRound(f_nal,2) + " AS fsum"
					//забыли учесть при переносе на новую версию соцстрах 0.5%
					//буду надеятся, что это последний глюк в этом расчетё
					+ ", " + IIF("(" + gr_soc + ">0 AND " + gr_soc + ">=" + xx1 + ")",cod_soc,nach_lsfi3) + " AS flsfid"
					+ ", " + IIF("(" + gr_soc + ">0 AND " + gr_soc + ">=" + xx1 + ")",vdpls,nach_lsnu3) + " AS ffld_num"
					+ ", " + strMn + " AS fmn"
					+ ", t.fvp"
					+ ", " + vidprk + " AS fvid_prk"
					+ ", " + sqlTrue + " AS favt"
				+ " FROM " + strTempTableName + " AS t"
				+" WHERE " + f_nal + "<>0";
			}else{
				strSQL = "INSERT INTO ^" + strMainTabName + " (ftabn_id,fwid_wp, fsum, flsfid, ffld_num, fmn, fvp, fvid_prk, favt)"
				+ " SELECT t.ftabn_id,0 as fwid_wp"
					+ ", " + sqlRound(f_nal,2) + " AS fsum"
					//забыли учесть при переносе на новую версию соцстрах 0.5%
					//буду надеятся, что это последний глюк в этом расчетё
					+ ", "+sqlTo(nach_lsfi3) + " AS flsfid"
					+ ", "+sqlTo(nach_lsnu3) + " AS ffld_num"
					+ ", " + strMn + " AS fmn"
					+ ", t.fvp"
					+ ", " + vidprk + " AS fvid_prk"
					+ ", " + sqlTrue + " AS favt"
				+ " FROM " + strTempTableName + " AS t"
				+" WHERE " + f_nal + "<>0";
			}				
			ExecuteSQL(strSQL);
		}	
	}
//добавляем профвзноссы, только если нет приказа не удерживать профзносы на сотрудника
	/*
	if(fld_found)
	{
		//если был sqlRound в INSERT, то неправильно работало		
		var xx =		 "(t.ssum1 + t.ssum2 + t.ssum6 + t.ssum8)"
		var xx1 = IIF("(" + prf1000 + "= 1 AND " + sum_ogr + ">0) AND " + sum_ogr + "<" + xx, sum_ogr, xx);
		var ud_profzv = "(SELECT SUM(t1.ud_profvzn) FROM " + strTempTableName + " AS t1 WHERE t1.ftabn_id=t.ftabn_id)";
		var f_nal = "("+sqlRound(xx1 +"*"+ proc_prf, 2) + ")-(" + IIF("t.offset=1", ud_profzv, 0)+")";		
		//var f_nal = xx1 + "*" + proc_prf + "-" + IIF("t.offset=1", ud_profzv, 0);
		strSQL = "INSERT INTO ^" + strMainTabName + " (ftabn_id,fwid_wp, fsum, flsfid, ffld_num, fmn, fvp, fvid_prk, favt)"
				+ " SELECT t.ftabn_id,0 as fwid_wp"
					//+ ", " + sqlRound(f_nal,2) + " AS fsum"
					+ ", " + f_nal + " AS fsum"					
					+ ", " + nach_lsfid + " AS flsfid"
					+ ", " + nach_lsnum + " AS ffld_num"
					+ ", " + strMn + " AS fmn"
					+ ", t.fvp"
					+ ", " + vidprk + " AS fvid_prk"
					+ ", " + sqlTrue + " AS favt"
					+ " FROM " + strTempTableName + " AS t "
					+ " WHERE " + f_nal + "<>0 AND Ftabn_id NOT IN (SELECT Ftabn_id FROM ^prk_all WHERE Fvid_prk="+sqlTo(vidprk)
						+" AND fbdat<=" + sqlTo(D2) + " AND fedat>=" + sqlTo(D1) +")";
		ExecuteSQL(strSQL);
	}
	*/
	if (za_tek_mes)
	{
		//ExecuteSQL("DELETE FROM tmp_svzp WHERE Fvp=2");
		ExecuteSQL("INSERT INTO ^"+(svzpName?svzpName:"svzp") + szTag + getColumn("tmp_svzp",true) + 
				" SELECT " + getColumn("tmp_svzp",false) + " FROM tmp_svzp");
		
		DropTable("tmp_svzp");
	}
	ExecuteSQL("DELETE FROM ^"+(svzpName?svzpName:"svzp") + szTag + " WHERE (FSUM is NULL OR FSUM=0) and (Fdnkl=0 or Fdnkl is null) " + sqlTabn);
	return true;
}