//расчет суммовых надбавок на доход, зависящие от отработанного времени, 
//если у человека нет неявок он не принят либо уволен в расчетном месяце, влияющих на фактически отработанное время,
//то пропорция берется по норме, т.е. коэффициент 1 (в случаях, когда табель разбит - для каждого табеля ищем свою долю от общего кол-ва дней),
//если же есть неявки (командировки в том числе),
//то анализируем фактическое время: если факт больше нормы, тогда уменьшаем в пропорции фактическое время на время неявок,
//если факт меньше нормы, тогда берем обычную пропорцию фактического времени к норме 
function name_prk2nvk()
{
	return "Сумова надбавка, яка залежить від відпрацьованого часу з урахуванням неявок|Суммовая надбавка, зависящая от отработанного времени с учетом неявок";
}

function r_prk2nvk(month, vopl, vidprk, lsfid, lsfid2, ftabn_id, svzpName)
{
	// достаем цифры к названию файла
	var szTag = (month.getFullYear())+((month.getMonth()< 9)?"0":"") + (month.getMonth()+1);        

	// дата начала
	var D1 = month;
	// дата конца
	var D2 = new Date(month.getFullYear(), month.getMonth() + 1, 1);
	D2.setDate(0);
	var bdat = D1.getDate();
	var edat = D2.getDate();

	var szName = "zrp_stt1" + szTag;
	var siName = "^stt1" + szTag;
	var tiName = "^tbl" + szTag;
	var strTabName = (svzpName?svzpName:"svzp") + szTag;
      
	if(!IsTableEx("zrp_mdb", szName))
	{ 
		msg = "Не введены табеля за " + szTag;
		writeToLog(msg,"e",vopl, vidprk, lsfid);
		return false;
	}

// Проверка на существование таблицы "svzp%LD"
	if(!IsTableEx("zrp_res", "zrp_" + strTabName))
	{ 
		var strPath = getPath("zrp_res");
		CreateTableEx("zrp_res", "zrp_" + strTabName, "svzp", "*");
	}
	//создадим таблицу с временем по всем неявкам, которые нужно вычитать из фактически отработанного времени
	var fld = new Object();
	fld.FWID = "counter";
	fld.FWID_WP = "long";
	fld.FTABN_ID = "long";
	fld.FIS_NVK = "bit";
	fld.FIS_UV = "bit";
	fld.FIS_NAZN = "bit";
	fld.FDAYS = "double";
	fld.FCHAS = "double";
	fld.FBDAT = "byte";
	fld.FEDAT = "byte";
	var ind = new Object();
	ind.FWID_WP = "FWID_WP,FBDAT,FEDAT";
	CreateTable("tmp_time_nvk", fld, ind);
	ExecuteSQL("insert into tmp_time_nvk (fwid_wp,fbdat,fedat) select distinct t.fwid_wp,t.fbdat,t.fedat from "+tiName+" as t inner join ^work_pers as wp on t.Fwid_wp=wp.Fwid "+(ftabn_id?" where wp.Fwid_cl in ("+ftabn_id+") ":""));
	ExecuteSQL("update tmp_time_nvk set Fis_uv=(select Fis_uv from ^work_pers as wp where wp.Fwid=tmp_time_nvk.Fwid_wp)"
				+",Fis_nazn=(select Fis_nazn from ^work_pers as wp where wp.Fwid=tmp_time_nvk.Fwid_wp)")
	ExecuteSQL("update tmp_time_nvk set Fis_nvk="+sqlTrue
			+", Fdays=(select SUM(t.Fday_nvk) from "+tiName+" as t inner join ^cl_nvk as n "
							+" on t.Fkod_nvk=n.Fkod_nvk and ((t.Fis_nvk="+sqlTrue+" and n.Fis_subtract="+sqlTrue+") or (t.Fkod_nvk=7 and t.Fday_nvk>0))"
						+" where tmp_time_nvk.Fwid_wp=t.Fwid_wp and tmp_time_nvk.Fbdat=t.Fbdat and tmp_time_nvk.Fedat=t.Fedat)"
			+", Fchas=(select SUM(t.Fchasnvk) from "+tiName+" as t inner join ^cl_nvk as n "
							+" on t.Fkod_nvk=n.Fkod_nvk and ((t.Fis_nvk="+sqlTrue+" and n.Fis_subtract="+sqlTrue+") or (t.Fkod_nvk=7 and t.Fchasnvk>0))"
						+" where tmp_time_nvk.Fwid_wp=t.Fwid_wp and tmp_time_nvk.Fbdat=t.Fbdat and tmp_time_nvk.Fedat=t.Fedat)"
				+" where exists(select t.Fwid from "+tiName+" as t inner join ^cl_nvk as n "
							+" on t.Fkod_nvk=n.Fkod_nvk and ((t.Fis_nvk="+sqlTrue+" and n.Fis_subtract="+sqlTrue+") or (t.Fkod_nvk=7 and t.Fday_nvk+t.Fchasnvk>0))"
						+" where tmp_time_nvk.Fwid_wp=t.Fwid_wp and tmp_time_nvk.Fbdat=t.Fbdat and tmp_time_nvk.Fedat=t.Fedat)");
	ExecuteSQL("update tmp_time_nvk set Ftabn_id=(select Fwid_cl from ^work_pers as wp where tmp_time_nvk.Fwid_wp=wp.Fwid)");
	DropTable("tmp_nvk_ftabn");
	ExecuteSQL("select distinct Ftabn_id into tmp_nvk_ftabn from tmp_time_nvk where Fis_nvk="+sqlTrue);
	//для разбитых табелей признак неявки проставляем во всех частях табеля
	ExecuteSQL("update tmp_time_nvk set Fis_nvk="+sqlTrue+" where exists(select Ftabn_id from tmp_nvk_ftabn as t where t.Ftabn_id=tmp_time_nvk.Ftabn_id)");
	
	var sqlTabn = ftabn_id?" and p.Ftabn_id in ("+ftabn_id+") ":"";
	var strSQL = "INSERT INTO ^" + strTabName
		 			+ "( ftabn_id,fwid_wp"
		 			+ ", fshpz, fsum"
		 			+ ", ffld_num, flsfid"
		 			+ ", fbdy, fedy"
		 			+ ", fis_day, fday"
		 			+ ", fchas, fmn"
		 			+ ", fvp, fid_prk, fvid_prk)"
				+ " SELECT w.fwid_cl as ftabn_id,p.fwid_wp as fwid_wp, p.fshpz AS fshpz"
				+ ", " + sqlRound(IIF("st.fis_tabel=" +sqlTo("*")
							, 1 
							, IIF("st.fis_tabel=" + sqlTo("+")
								, IIF("tb2.fchasnvk=0"
									, IIF("tn.Fis_nvk="+sqlTrue
										, IIF("tb2.fday_nvk>tb.fday_nvk","(tb2.fday_nvk-tn.Fdays)/tb.fday_nvk","tb2.fday_nvk/tb.fday_nvk")
										, IIF("(tn.Fis_uv="+sqlTrue+" or tn.Fis_nazn="+sqlTrue+") and tb2.fday_nvk<tb.fday_nvk"
											,"tb2.fday_nvk/tb.fday_nvk"
											,IIF("tn.Fbdat="+bdat+" and tn.Fedat="+edat,"1",Convert("(tn.Fedat-tn.Fbdat+1)","DBL")+"/"+edat)))
									, IIF("tn.Fis_nvk="+sqlTrue
										, IIF("tb2.fchasnvk>tb.fchasnvk","(tb2.fchasnvk-tn.Fchas)/tb.fchasnvk","tb2.fchasnvk/tb.fchasnvk")
										, IIF("(tn.Fis_uv="+sqlTrue+" or tn.Fis_nazn="+sqlTrue+") and tb2.fchasnvk<tb.fchasnvk"
											,"tb2.fchasnvk/tb.fchasnvk"
											,IIF("tn.Fbdat="+bdat+" and tn.Fedat="+edat,"1",Convert("(tn.Fedat-tn.Fbdat+1)","DBL")+"/"+edat))))
									, 0)
								)+ "*p.fsum",2)+" AS fsum"
				+ ", " + IIF(sqlTo(lsfid) + "<>0", "(SELECT l.ffld_num FROM ^lic_fld AS l WHERE l.fid=" + sqlTo(lsfid) + ")", 0) + " as ffld_num"
	 			+ ", " + sqlTo(lsfid) + " as flsfid"
				+ ", st.fbdat AS fbdy, st.fedat AS fedy"
				+ ", " + IIF("ti.fnorma_ch<>0", sqlTrue, sqlFalse) + " AS  fis_day"
				+ ", "+IIF("st.fis_tabel=" + sqlTo("+")	, "tb2.fday_nvk", IIF("st.fis_tabel=" + sqlTo("*"),"ti.fvsego_d","0"))+" AS fday"//проставим дни для свода по чернобыльским доплатам
				+ ", 0 AS fchas"
	 			+ ", " + sqlTo(d00)+" as fmn, 0 as fvp"
	 			+ ", p.fwid as fid_prk"
				+ ", " + sqlTo(vidprk)+ " as fvid_prk"
				+ " FROM ((((^prk_all AS p LEFT JOIN ^work_pers AS w ON p.fwid_wp=w.fwid)"
					+ " INNER JOIN ^stru_dol AS d ON d.fwid=w.fwid_dol)"
					+ " INNER JOIN ^tbl_ini AS ti ON ti.fvopl=w.fvopl)"
					+ " LEFT JOIN " + siName + " AS st ON (p.fwid_wp=st.fwid_wp AND p.fbdat<=" 
								+ toSqlDate(month.getFullYear(), month.getMonth()+1,'st.fedat') 
								+ " AND p.fedat>=" + toSqlDate(month.getFullYear(), month.getMonth()+1,'st.fbdat') + ")"
					+ " LEFT JOIN " + tiName + " AS tb ON (st.fwid_wp=tb.fwid_wp AND tb.fbdat=st.fbdat AND tb.fedat=st.fedat and tb.fkod_nvk=1)"
					+ " LEFT JOIN " + tiName + " AS tb2 ON (st.fwid_wp=tb2.fwid_wp AND tb2.fbdat=st.fbdat AND tb2.fedat=st.fedat and tb2.fkod_nvk=2)"
					+ " LEFT JOIN tmp_time_nvk as tn ON st.fwid_wp=tn.Fwid_wp and st.Fbdat=tn.Fbdat and st.Fedat=tn.Fedat)"
				+ " WHERE p.fvid_prk=" + sqlTo(vidprk)
	    			+ " AND p.fbdat<=" + sqlTo(D2) + " AND p.fedat>=" + sqlTo(D1)
					+ sqlTabn
					+ " AND ti.fbdat=" + sqlTo(D1);

	if(vopl < 9000)
	{
		strSQL += " AND w.fvopl=" + sqlTo(vopl); 
	}

	ExecuteSQL(strSQL);

    if(!getPar("KOMKOLD")){
    	return true;
    }
	
	var oSnap = getSnap("SELECT Fuse_rkm FROM ^CL_PRIK WHERE Fvid="+sqlTo(vidprk))
	if(oSnap==null || (oSnap!=null && !oSnap[0]))
	{
		return;
	}
	
	svnrTableName = "svnr" + szTag;
	if(!IsTableEx("zrp_res", "zrp_" + svnrTableName))
	{
		//var strPath = getPath("zrp_res");
		CreateTableEx("zrp_res","zrp_" + svnrTableName, "svzp", "*");
	}
	
	var strSQL = "INSERT INTO ^"+svnrTableName 
		+ "( ftabn_id,fwid_wp"
		+ ", fsum"
		+ ", ffld_num, flsfid"
		+ ", fmn, fvp)"
		+ " SELECT w.fwid_cl as ftabn_id,p.fwid_wp as fwid_wp"
		+ ", " + sqlRound(IIF("st.fis_tabel=" +sqlTo("*")
				, 1 
				, IIF("st.fis_tabel=" + sqlTo("+"),1,0)
					)+ "*p.fsum",2)+" AS fsum"
				+ ", " + IIF(sqlTo(lsfid) + "<>0", "(SELECT l.ffld_num FROM ^lic_fld AS l WHERE l.fid=" + sqlTo(lsfid) + ")", 0) + " as ffld_num"
				+ ", " + sqlTo(lsfid) + " as flsfid"
				+ ", " + sqlTo(d00)+" as fmn, 0 as fvp"
	+ " FROM (^prk_all AS p LEFT JOIN ^work_pers AS w ON p.fwid_wp=w.fwid)"
	+ " LEFT JOIN " + siName + " AS st ON (p.fwid_wp=st.fwid_wp AND p.fbdat<=" 
	+ toSqlDate(month.getFullYear(), month.getMonth()+1,'st.fedat') 
	+ " AND p.fedat>=" + toSqlDate(month.getFullYear(), month.getMonth()+1,'st.fbdat') + ")"
	+ " WHERE p.fvid_prk=" + sqlTo(vidprk)
	+ " AND p.fbdat<=" + sqlTo(D2) + " AND p.fedat>=" + sqlTo(D1)
	+ sqlTabn
	if(vopl < 9000)
	{
		strSQL += " AND w.fvopl=" + sqlTo(vopl); 
	}

	ExecuteSQL(strSQL);
	
	return true;
}