// SEV 18.02.2004
// ksm 12.10.2004 
// Расчет сборов при перечислении.
// включается вместе с r_alim20
// в перечне полей ЛС
// должно быть поле "почтовый сбор" - буква z в 5-й колонке
// с отключенным сравнением - "красное"

include("get_const.js");
include("Objects/DpDefVed.js");
include("transf:Objects/DpTransfer.js");
include("servis/date.js");

function name_sbtr()
{
	return "Розрахунок поштового збору|Расчет почтового сбора";
}

function r_sbtr (mdat, mvvopl, mvvprk, mvvlsfid, mvvdpl, ftabn_id, svzpName)
{
	WAIT(ru("Расчет почтового сбора", "Розрахунок поштового збору"));
	
	var C9000 = 9000;
	var C8999 = 8999;
	var tbl_scale = "SCALE";

	var DefVed = new DpDefVed();
	var strSQL;

	// дата начала
	var D1 = firstDay(mdat);
	
	// дата конца
	var D2 = lastDay(mdat);

	DropTable(tbl_scale);
	strSQL = "SELECT * INTO "+tbl_scale
		+" FROM ^PROC_AL"
		+" WHERE 1=1"
			+ " AND ((FBDAT <= " + sqlTo(D1) + ")"
			+ " AND ((FEDAT >= " + sqlTo(D2) +") OR (FEDAT = " + sqlTo(d00) +")) "
			+ "OR (FBDAT >= " + sqlTo(D1) + " AND FBDAT <= " + sqlTo(D2) +") "
			+ "OR (FEDAT >= " + sqlTo(D1) + " AND FEDAT <= " + sqlTo(D2) +"))"
		+" ORDER BY FBDAT,F_STSUM"
	ExecuteSQL(strSQL);
	
	strSQL = "SELECT FID, FFLD_NUM" 
				+" FROM ^LIC_FLD"
				+" WHERE 1=1"
					+" AND FIS5 = 'а'"
	var oSn = getSnap(strSQL);
	
	if(oSn && !isEmpty(oSn[0]))
	{
		var alim_lsfid = oSn[0];
		var alim_lsnum = oSn[1];
	}
	else
	{
		txt = ru("Обнаружена серьезная ошибка функционирования системы. "
				, "Виявлена серйозна помилка функціонування системи. ");
		txt += ru("Hевозможно идентифицировать поле ЛС: алименты. "
				, "Hеможливо ідентифікувати поле ОР: аліменти. ");
		txt += ru("Расчет алиментов не выполнен."
				, "Розрахунок аліментів не виконано.");
		
		writeToLog(txt, "e", mvvopl, mvvprk, mvvlsfid);				
		return;
	}
	
	strSQL = "SELECT FID, FFLD_NUM" 
			+" FROM ^LIC_FLD"
			+" WHERE 1=1"
				+" AND FIS5 = 'z'"
	var oSn = getSnap(strSQL);
	
	if(oSn && !isEmpty(oSn[0]))
	{
		var nach_lsfid = oSn[0];
		var nach_lsnum = oSn[1];
	}
	else
	{
		txt = ru("Обнаружена серьезная ошибка функционирования системы. "
				, "Виявлена серйозна помилка функціонування системи. ");
		txt += ru("Hевозможно идентифицировать поле ЛС: почтовый сбор. "
				, "Hеможливо ідентифікувати поле ОР: поштовий збір. ");
		txt += ru("Расчет алиментов не выполнен."
				, "Розрахунок аліментів не виконано.");
		
		writeToLog(txt, "e", mvvopl, mvvprk, mvvlsfid);
		return;
	}	

	DropTable("PRK_ALIM");
	
	strSQL = "SELECT *"
			+" INTO PRK_ALIM"
			+" FROM ^PRK_AL"
			+" WHERE 1=1"			
				+" AND FBDAT<="+sqlTo(D2)
				+" AND FEDAT>="+sqlTo(D1)
				+(ftabn_id?" AND FTABN_ID IN("+ftabn_id+")" : "")
	
	if (mvvopl < C9000)
	{
		strSQL += " FVOPL="+sqlTo(mvvopl);
	}
	strSQL += " ORDER BY FTABN";
	ExecuteSQL(strSQL);

	var monthtxt = month_txt(mdat);
	var SVZPFILE = (svzpName?svzpName:"svzp")+monthtxt;

	if(!IsTableEx("ZRP_RES", "ZRP_"+SVZPFILE)){
		CreateTableEx("ZRP_RES","ZRP_"+SVZPFILE,"SVZP","*");
	}

	DropTable("TBLALIM");
	strSQL = "CREATE TABLE TBLALIM"
	+" ("
		+" FTABN_ID "+SqlType("LONG")
		+", FWID_WP "+SqlType("LONG")
		+", FSUM_ALL "+SqlType("MONEY")
		+", FPROC "+SqlType("DOUBLE")
		+", FSUM "+SqlType("MONEY")
		+", FID_PRK "+SqlType("LONG")
		+", FSBTYPE "+SqlType("TEXT", 255)
		+", FPOSTSB "+SqlType("MONEY")
		+", FSHPZ "+SqlType("TEXT", 255)
	+" )"
	ExecuteSQL(strSQL);

	//Вытянем все алименты
	strSQL = "INSERT INTO TBLALIM(FTABN_ID, FWID_WP, FSUM_ALL, FID_PRK, FPOSTSB, FSBTYPE, FPROC, FSUM, FSHPZ)"
			+" SELECT"
				+" S.FTABN_ID,S.FWID_WP"
				+", SUM(S.FSUM) AS FSUM_ALL"
				+", S.FID_PRK"
				+", 0 AS FPOSTSB"
				+", SBCS.FSBTYPE"
				+", SBCS.FPROC"
				+", SBCS.FSUM"
				+", S.FSHPZ"
			+" FROM"
				+" ((^"+SVZPFILE+" S INNER JOIN PRK_ALIM P ON S.FID_PRK = P.FWID)"
					+" INNER JOIN ^"+TBL_TRPLACE+" PLACE ON P.FWIDTR = PLACE.FWID_CL)"
					+" INNER JOIN ^"+TBL_SBCS+" SBCS ON PLACE.FNUMSB = SBCS.FNUM"
			+" WHERE"
				+" S.FLSFID = "+sqlTo(alim_lsfid)
			+" GROUP BY"
				+" S.FTABN_ID,S.FWID_WP"
				+", S.FID_PRK"
				+", SBCS.FSBTYPE"
				+", SBCS.FPROC"
				+", SBCS.FSUM"
				+", S.FSHPZ"
	ExecuteSQL(strSQL);
	
	var opTbl_scale = OpenTable(tbl_scale);
	if(opTbl_scale.IsEmpty())
	{
		//если шкала почтового сбора пустая то удалим строки из расчета по шкале почтового сбора
		ExecuteSQL("DELETE FROM TBLALIM WHERE FSBTYPE = "+sqlTo(SBTYPE_SBSCALE));
		
		//и запишем это в лог 
		txt = ru("Расчет почтового сбора по шкале почт."
					+" сбора не выполнен по причине отсуствия строк в справочнике почтового сбора."
				, "Розрахунок поштового збору зп шкалою пошт."
					+" збору не виконаний по причины выдсутності рядків в довіднику поштового збору.");
		
		writeToLog(txt, "w", mvvopl, mvvprk, mvvlsfid);
	}
	opTbl_scale.close();
	
	var tblAlim = OpenTable("TBLALIM");	
	if(tblAlim.IsEmpty())
	{
		return;
	}
	tblAlim.close();
	
	/*
	проставим в алиментах сумы почтового сбора 
	в зависимости от сберкассы в которую перечислаем
	*/	
	strSQL = "UPDATE TBLALIM "
				+" SET FPOSTSB = "
					+IIF("FSBTYPE = "+sqlTo(SBTYPE_SBSUM), "FSUM" /*сума*/
						,IIF("FSBTYPE = "+sqlTo(SBTYPE_SBPROC), sqlRound("FSUM_ALL*FPROC/100", 2) /*процент*/
							,IIF("FSBTYPE = "+sqlTo(SBTYPE_SBNO), sqlTo(0) /*нет сбора*/
								,IIF("FSBTYPE = "+sqlTo(SBTYPE_SBSCALE), "(SELECT "+sqlRound(sqlRound("FSUM_ALL*S.F_PROC/100+S.F_BASNL", 2)+"*(1+S.F_NDS/100)", 2)+" AS FSUM"
																								+" FROM "+tbl_scale+" S"
																								+" WHERE 1=1"
																									+" AND S.F_STSUM = (SELECT MAX(S2.F_STSUM) FROM "+tbl_scale+" S2 WHERE S2.F_STSUM <= ABS(FSUM_ALL))"																									
																								+")"
								,0))))
	ExecuteSQL(strSQL);
	
	//для тех таб. номеров где есть почтовый сбор
	//запишем в SVZP
	strSQL = "INSERT INTO ^"+SVZPFILE
					+"(FTABN_ID, FWID_WP, FLSFID, FFLD_NUM, FSUM, FPR, FBDY"
					+", FEDY, FID_PRK, FMN, FVP, FDAY, FVID_PRK, FSHPZ)"
				+" SELECT" 
					+" FTABN_ID AS FTABN_ID"
					+", FWID_WP"
					+", "+sqlTo(nach_lsfid)+" AS FLSFID"
					+", "+sqlTo(nach_lsnum)+" AS FFLD_NUM"
					+", "+sqlRound("FPOSTSB", 2)+" AS FSUM"
					+", "+sqlTo(0)+" AS FPR"
					+", "+sqlTo(0)+" AS FBDY"
					+", "+sqlTo(0)+" AS FEDY"
					+", FID_PRK AS FID_PRK"
					+", "+sqlD00+" AS FMN"
					+", "+sqlTo(0)+" AS FVP"
					+", "+sqlTo(0)+" AS FDAY"
					+", "+sqlTo(mvvprk)+" AS FVID_PRK"
					+", FSHPZ"
				+" FROM TBLALIM"
				+" WHERE 1=1"
					+" AND FPOSTSB <> 0"
	ExecuteSQL(strSQL);
		
	return;
}