//расчет выслуги лет переделан с r_sezon1, разница в том, что % расчитываем по справочнику аналитики выслуги лет
//также учитываются переходящие выслуги, т.е. если в течении месяца выслуга достигает другой % надбавки,
//то расчитываем по пропорции: sum*(proc1*days1+proc2*days2)/(days1+days2)/100
//используется с приказом _visl

function name_sezon1v()
{
	return "% надбавка за вислугу років (з довідника аналітики) на декілька доплат|% надбавка за выслугу лет (из справочника аналитики) на несколько доплат";
}

function r_sezon1v(month, vopl, vidprk, lsfid, lsfid2, ftabn_id, svzpName)
{
	// достаем цифры к названию файла
	var szTag = (month.getFullYear())+((month.getMonth()< 9)?"0":"") + (month.getMonth()+1);
	// дата начала
	var D1 = new Date(month.getFullYear(), month.getMonth(), 1);
	// дата конца
	var D2 = new Date(month.getFullYear(), month.getMonth() + 1, 1);
	D2.setDate(0);   

	var strTabName = (svzpName?svzpName:"svzp") + szTag;
	var sqlTabn = ftabn_id?" and p.Ftabn_id in ("+ftabn_id+") ":"";
	//если дата выслуги не указана явно, тогда берем дату приема на работу
	var datvisl = IIF("h.Fvisldat="+sqlTo(d00),"h.Fwrkdat","h.Fvisldat");
	//берем количество полных лет
	//старый алгоритм не точен, т.к. не учитываются високосные дни и поэтому тупо делить на 365 дней нельзя
	//var full_years = Convert(SqlDaysBWDates(datvisl,sqlTo(month))+"/365","INT");
	var full_years = sqlYear(sqlTo(month))+"-"+sqlYear(datvisl)+"-"+IIF(sqlMonth(sqlTo(month))+">"+sqlMonth(datvisl),"0",
				IIF(sqlMonth(sqlTo(month))+"="+sqlMonth(datvisl)+" and "+sqlDay(sqlTo(month))+">="+sqlDay(datvisl),"0","1"));
	//также берем количество полных лет на последний день месяца, чтоб потом расчитать пропорцию для переходящих выслуг
	//var full_yearsend = Convert(SqlDaysBWDates(datvisl,sqlTo(D2))+"/365","INT");
	var full_yearsend = sqlYear(sqlTo(D2))+"-"+sqlYear(datvisl)+"-"+IIF(sqlMonth(sqlTo(D2))+">"+sqlMonth(datvisl),"0",
				IIF(sqlMonth(sqlTo(D2))+"="+sqlMonth(datvisl)+" and "+sqlDay(sqlTo(D2))+">="+sqlDay(datvisl),"0","1"));
	var days_all = D2.getDate();//общее кол-во дней в переходящем месяце, он же расчетный месяц
	var days1 = "("+sqlDay(datvisl)+"-1)";//кол-во дней по первой процентной ставке
	var days2 = "("+days_all+"-"+days1+")";//кол-во дней по второй процентной ставке
	
	var strSQL = "INSERT INTO ^" + strTabName
		 			+ "( ftabn_id"
		 			+ ", fwid_wp"
		 			+ ", fshpz"
		 			+ ", fsum"
		 			+ ", ffld_num"
		 			+ ", flsfid"
		 			+ ", fmn"
		 			+ ", fvp"
		 			+ ", fid_prk"
		 			+ ", fvid_prk"
		 			+ ", fproc)"
				+ " SELECT w.fwid_cl,p.fwid_wp, p.fshpz"
				+ ", " + sqlRound("(SELECT SUM(" 
							+ IIF("s.fvp=0 OR (s.fvp=2 AND ABS(FLOOR(" +SqlDaysBWDates(sqlTo(D1),'s.fmn')+ "/30.0))=0)"
								, "s.fsum"
								, 0) + ")"
						+ " FROM ^" + strTabName + " AS s LEFT JOIN ^lic_fld AS lc ON s.flsfid=lc.fid"
						+ " WHERE lc.fis12='+' AND s.fwid_wp=w.fwid)*"
							+IIF("v.f_proc=ve.f_proc","v.f_proc",
								//ставим проверку на совпадение месяцев при расчете пропорции иначе могут попадать ставки с 1 февраля при расчете января
								IIF(sqlMonth(datvisl)+"-1="+month.getMonth(),"(v.f_proc*"+days1+"+ve.f_proc*"+days2+")/"+days_all,"v.f_proc"))+"/100",2)+" AS fsum"
				+ ", " + IIF(sqlTo(lsfid) + "<>0", "(SELECT l.ffld_num FROM ^lic_fld AS l WHERE l.fid=" + sqlTo(lsfid) + ")", 0) + " as ffld_num"
	 			+ ", " + sqlTo(lsfid) + " as flsfid"
	 			+ ", " + sqlTo(d00)+" as fmn, 0 as fvp"
	 			+ ", p.fwid as fid_prk"
				+ ", " + sqlTo(vidprk)+ " as fvid_prk"
				+ ", ve.f_proc as Fproc"
				+ " FROM ^prk_all AS p LEFT JOIN ^work_pers AS w ON p.fwid_wp=w.fwid"
					+ " LEFT JOIN ^listvisl as v ON p.Fsum=v.Fcl and v.Fbdat<="+sqlTo(month)+" and v.Fedat>="+sqlTo(month)
					+ " LEFT JOIN ^listvisl as ve ON p.Fsum=ve.Fcl and ve.Fbdat<="+sqlTo(month)+" and ve.Fedat>="+sqlTo(month)
					+ " INNER JOIN ^cl_homo as h ON p.Ftabn_id=h.Fwid_cl "
				+ " WHERE p.fvid_prk=" + sqlTo(vidprk)
	    			+ " AND p.fbdat<=" + sqlTo(D2) + " AND p.fedat>=" + sqlTo(D1) + sqlTabn
	    			+ " AND v.F_year=(select MAX(lv.F_year) from ^listvisl as lv where lv.Fcl=v.Fcl"
						+" and lv.Fbdat<="+sqlTo(month)+" and lv.Fedat>="+sqlTo(month)+" and lv.F_year<="+full_years+")"
					+ " AND ve.F_year=(select MAX(lv.F_year) from ^listvisl as lv where lv.Fcl=v.Fcl"
						+" and lv.Fbdat<="+sqlTo(month)+" and lv.Fedat>="+sqlTo(month)+" and lv.F_year<="+full_yearsend+")";

	if(vopl < 9000)
		strSQL += " AND w.fvopl=" + sqlTo(vopl); 
	ExecuteSQL(strSQL);

    if(!getPar("KOMKOLD")){
    	return true;
    }
	
	var oSnap = getSnap("SELECT Fuse_rkm FROM ^CL_PRIK WHERE Fvid="+sqlTo(vidprk))
	if(oSnap==null || (oSnap!=null && !oSnap[0]))
	{
		return;
	}
	
	svnrTableName = "svnr" + szTag;
	if(!IsTableEx("zrp_res", "zrp_" + svnrTableName))
	{
		//var strPath = getPath("zrp_res");
		CreateTableEx("zrp_res","zrp_" + svnrTableName, "svzp", "*");
	}
	
	var strSQL = "INSERT INTO ^"+svnrTableName 
		+ "( ftabn_id"
		+ ", fwid_wp"
		+ ", fsum"

		+ ", ffld_num"
		+ ", flsfid"
		+ ", fmn"
		+ ", fvp)"
		+ " SELECT w.fwid_cl,p.fwid_wp"
				+ ", " + sqlRound("(SELECT SUM(" 
						+ IIF("s.fvp=0 OR (s.fvp=2 AND ABS(FLOOR(" +SqlDaysBWDates(sqlTo(D1),'s.fmn')+ "/30.0))=0)"
							, "s.fsum"
							, 0) + ")"
					+ " FROM ^"+svnrTableName+" AS s LEFT JOIN ^lic_fld AS lc ON s.flsfid=lc.fid"
					+ " WHERE lc.fis12='+' AND s.fwid_wp=w.fwid)*"
						+IIF("v.f_proc=ve.f_proc","v.f_proc",
							//ставим проверку на совпадение месяцев при расчете пропорции иначе могут попадать ставки с 1 февраля при расчете января
							IIF(sqlMonth(datvisl)+"-1="+month.getMonth(),"(v.f_proc*"+days1+"+ve.f_proc*"+days2+")/"+days_all,"v.f_proc"))+"/100",2)+" AS fsum"
							+ ", " + IIF(sqlTo(lsfid) + "<>0", "(SELECT l.ffld_num FROM ^lic_fld AS l WHERE l.fid=" + sqlTo(lsfid) + ")", 0) + " as ffld_num"
							+ ", " + sqlTo(lsfid) + " as flsfid"
							+ ", " + sqlTo(d00)+" as fmn, 0 as fvp"
							+ " FROM ^prk_all AS p LEFT JOIN ^work_pers AS w ON p.fwid_wp=w.fwid"
							+ " LEFT JOIN ^listvisl as v ON p.Fsum=v.Fcl and v.Fbdat<="+sqlTo(month)+" and v.Fedat>="+sqlTo(month)
							+ " LEFT JOIN ^listvisl as ve ON p.Fsum=ve.Fcl and ve.Fbdat<="+sqlTo(month)+" and ve.Fedat>="+sqlTo(month)
							+ " INNER JOIN ^cl_homo as h ON p.Ftabn_id=h.Fwid_cl "
							+ " WHERE p.fvid_prk=" + sqlTo(vidprk)
							+ " AND p.fbdat<=" + sqlTo(D2) + " AND p.fedat>=" + sqlTo(D1) + sqlTabn
							+ " AND v.F_year=(select MAX(lv.F_year) from ^listvisl as lv where lv.Fcl=v.Fcl"
							+" and lv.Fbdat<="+sqlTo(month)+" and lv.Fedat>="+sqlTo(month)+" and lv.F_year<="+full_years+")"
							+ " AND ve.F_year=(select MAX(lv.F_year) from ^listvisl as lv where lv.Fcl=v.Fcl"
							+" and lv.Fbdat<="+sqlTo(month)+" and lv.Fedat>="+sqlTo(month)+" and lv.F_year<="+full_yearsend+")";

	if(vopl < 9000)
		strSQL += " AND w.fvopl=" + sqlTo(vopl); 
	ExecuteSQL(strSQL);
	
	return true;
}