/**
	для всех расчетов функция расчета должна выглядеть так
	r_""(month, vopl, vidprk, lsfid, lsfid2, ftabn_id, svzpName), где
	@param month - месяц расчета
	@param vopl - вид оплаты
	@param vidprk - вид приказа
	@param lsfid - номер лицевого счета
	@param lsfid2 - номер второго лицевого счета
	@param ftabn_id - индентификатор или массив идентификаторов сотрудников (при индивидуальном расчете)
	@param svzpName - имя отдельной таблицы лицевых счетов (при отдельном расчете)
	Имя функции обязательно должно совпадать с именем скрипта!!!	
*/
//Tori 17.10.2010: при отдельных расчетах з/п к SVZP добавляем суффикс с кодом записи из справочника отдельных расчетов и передаем это имя во все расчеты 7-ым параметром
include("servis/date.js");
include("servis/zrp.js");
include("tblforsred.js");
include("sys/udfs.js");
include("Objects/DpAskEx.js");
var nom_blk = 200;
var szTag, time_end;

if (!IsTable("R_ALLO"))
	nom_blk = 200;

var is_rasch=true;
// poln_rasch : Полный расчет ЗП
var poln_rasch = (nom_blk == 200);
// chast_rasch : Частичный расчет ЗП
var chast_rasch = (nom_blk == 201);
var oraCursBeg = 0;
var oraCursEnd = 0;
var ftabn_id,tabn,rasch_mes;
var is_tabn=false;
var is_privat=false;
var stop_on_dt;

function r_all(menuMode, extPar)
{
	/*
	if(!askPwd())
	{
		alert("Неверный пароль.");
		return false;
	}
	*/ 
	if(!menuMode && extPar && extPar.menuMode)
		menuMode = extPar.menuMode;
	if(!menuMode)
		return false;
	if(getAccess("R_ALL")=="R")
	{
		alert(ru("У вас недостатньо прав для виконання цього розрахунку!","У вас недостаточно прав для выполнения этого расчета!"));
		return;
	}
	if(menuMode.indexOf("TABN")!=-1 || (extPar && extPar.ftabn_id))
		is_tabn = true;
	if(menuMode.indexOf("PRIVAT")!=-1)
	{
		is_privat = true;
		if(!getPar("ZRP_PRIVAT_CALCS"))
		{
			alert(ru("Не указан справочник отдельных расчетов ","Не вказаний довідник окремих розрахунків ")+"("+getParItemPath("ZRP_PRIVAT_CALCS",true)+")",1)
			return false;
		}
	}
	first_month=new Date(base_month);
	first_month.setMonth(first_month.getMonth()-12);
	var szTag = getDateTag(base_month);
	var sBaseMonth = tmonth(base_month,"mt")+" "+base_month.getFullYear()
	var msg = "";
	var calcNum = 0;
	var calcName = "";
	
	//для расчета из вне отдельно передаем месяц расчета и табельные номера, по которым нужно выполнить расчет
	if(extPar && extPar.base_month)
	{
		var oSnap = getSnap("SELECT Fwid FROM ^CHNG WHERE Fdate="+sqlTo(extPar.base_month))
		if (oSnap==null)
		{
			m = new Object();
			m.Fwid = GetUID();
			m.Fis_slct = false;
			m.Fdate = extPar.base_month;
			UpdateTable("^CHNG", m, true);
		}
		if(extPar.calcNum)
			calcNum = extPar.calcNum;
		if(extPar.calcName)
			calcName = extPar.calcName;
		tbl_chng = OpenTable("select * from ^CHNG where Fdate="+sqlTo(extPar.base_month));
		stop_on_dt = tbl_chng.IsEOF();
		rasch_mes = new Date(firstDay(tbl_chng.getValue("Fdate")));
		msg = ru("Проводится "+(is_privat?"отдельный ":"")+"расчёт ЗП ","Проводиться "+(is_privat?"окремий ":"")+"розрахунок ЗП ")+(is_privat?"("+calcName+") за ":"за ")+StrDat(extPar.base_month,"DMY")
		if(extPar.ftabn_id)
		{
			ftabn_id = extPar.ftabn_id;
			if(typeOf(ftabn_id)=="object" || typeOf(ftabn_id)=="string")
			{
				if(typeOf(ftabn_id)=="string")
					ftabn_id = ftabn_id.split(",");
				tabn = "";
				for(var i=0; i<ftabn_id.length; i++)
				{
					if(i==0)
						tabn = getCodFromID(ftabn_id[i]);
					else
						tabn += ", "+getCodFromID(ftabn_id[i]);
				}
			}
			else
				tabn = getCodFromID(ftabn_id);
			msg += ru("\nпо следующим табельным номерам: ","\nпо наступним табельним номерам: ")+tabn;
		}
	}
	else
	{
		var oSnap = getSnap("SELECT Fwid FROM ^CHNG WHERE Fdate="+sqlTo(base_month))
		if (oSnap==null)
		{
			if(confirm(ru("В списке отбора месяцев для расчёта з/п отсутствует расчётный месяц: "+sBaseMonth+"г. Добавить расчётный месяц и продолжить расчёт?",
						"В списку відбора місяців для розрахунку з/п відсутній розрахунковий місяць: "+sBaseMonth+"р. Додати розрахунковий місяць і продовжити розрахунок?")))
			{
				m = new Object();
				m.Fwid=GetUID();
				m.Fis_slct=true;
				m.Fdate=base_month.getVarDate();
				UpdateTable("^CHNG", m, true);
			}
			else
				return;
		}
		else
		{
			oSnap = getSnap("SELECT Fwid FROM ^CHNG WHERE Fdate="+sqlTo(base_month)+" AND Fis_slct="+sqlFalse);
			if(oSnap!=null)
			{
				msg = ru("Расчетный месяц: ","Розрахунковий місяць: ")+sBaseMonth
						+ru("г. отключен.\nЗайдите в меню \"Отбор месяцев для расчета\" и включите его.",
							"р. вимкнут. \nЗайдіть в меню \"Вiдбiр мiсяцiв для розрахунку\" і включить його.");
				alert(msg);
				return;
			}
			else
			{
				oSnap = getSnap("SELECT Fwid FROM ^CHNG WHERE Fdate="+sqlTo(base_month)+" AND Fis_slct="+sqlTrue+" AND Fis_fix="+sqlTrue)
				if(oSnap!=null)
				{
					msg = ru("Месяц: ","Місяць: ")+sBaseMonth
						+ru("г. зафиксирован и не может быть рассчитан.\nФиксированные месяца доступны только для перерасчета.",
							"р. зафіксовано і він не може бути розрахован.\nФіксовані місяця доступні тільки для перерахунку.")
					alert(msg);
					return;
				}
			}
		}
		if(is_privat && getPar("ZRP_PRIVAT_CALCS"))
		{
			var oAsk = new DpAskEx();
			oAsk.add("CL","Окремий розрахунок|Отдельный расчет","CALC", 0, getPar("ZRP_PRIVAT_CALCS"));
			oAsk.doAsk();
			if(oAsk.escape)
				return false;
			calcNum = oAsk.get("CALC").getCod();
			calcName = UR(oAsk.get("CALC").getTxt());
		}
		var strSQL = "select * from ^CHNG where Fis_slct="+sqlTrue+" and Fdate>"+sqlTo(first_month)+" order by Fdate";
		tbl_chng=OpenTable("s", strSQL);
		tbl_chng.MoveFirst();
		stop_on_dt = tbl_chng.IsEOF();
		if (!stop_on_dt)
			rasch_mes = new Date(firstDay(tbl_chng.getValue("Fdate")));
		else
			rasch_mes = base_month;
		var oSnap = getSnap("SELECT min(Fdate) FROM ^CHNG WHERE Fis_slct="+sqlTrue)
		if(oSnap!=null)
		{
			if(differ(new Date(oSnap[0]),base_month)!=0)
			{
				msg = ru("Проводится "+(is_privat?"отдельный ":"")+"пересчёт з/п "+(is_privat?"("+calcName+") ":"")+"по отобранным месяцам из периода ",
					"Проводиться "+(is_privat?"окремий ":"")+"перерахунок з/п "+(is_privat?"("+calcName+") ":"")+"по відібраним місяцям з періоду ")+
					StrDat(oSnap[0],"DMY")+ "-" + StrDat(base_month,"DMY") 
			}
			else
			{
				msg = ru("Проводится "+(is_privat?"отдельный ":"")+"расчёт ЗП ","Проводиться "+(is_privat?"окремий ":"")+"розрахунок ЗП ")+(is_privat?"("+calcName+") за ":"за ")+StrDat(base_month,"DMY")
			}
			WAIT(msg);
		}
		//Фиксируем все незафиксированные месяца предществующие месяцу расчета, чтобы умные пользователи не могли случайно расчитать перерасчетные месяцы
		ExecuteSQL("update ^CHNG set Fis_fix="+sqlTrue+" where Fis_fix="+sqlFalse+" and Fdate<"+sqlTo(base_month))
		if(is_tabn)
		{
			var par = new Object();
			var snap = getSnap("SELECT MIN(Fdate), MAX(Fdate) FROM ^chng WHERE Fis_slct="+sqlTrue);
			if(snap)
			{
				par.bdat = firstDayMonth(snap[0]);
				par.edat = lastDayMonth(snap[1]);
			}
			showWindow("e_calcTabn.xml",SW_MODAL,par);
			if(par.escape)
				return;
			ftabn_id = par.ftabn_id;
			if(typeOf(ftabn_id)=="object" || typeOf(ftabn_id)=="string")
			{
				if(typeOf(ftabn_id)=="string")
					ftabn_id = ftabn_id.split(",");
				tabn = "";
				for(var i=0; i<ftabn_id.length; i++)
				{
					if(i==0)
						tabn = getCodFromID(ftabn_id[i]);
					else
						tabn += ", "+getCodFromID(ftabn_id[i]);
				}
			}
			else
				tabn = getCodFromID(ftabn_id);
			msg += ru("\nпо следующим табельным номерам: ","\nпо наступним табельним номерам: ")+tabn;
		}
	
		var msg_ = ru("Вы действительно хотите произвести "+(is_privat?"отдельный ":"")+"расчёт ЗП "+(is_privat?"("+calcName+") ":"")+"за "+sBaseMonth+(is_tabn?" по табельным номерам: "+tabn:"")+"?",
					"Ви дійсно бажаєте провести "+(is_privat?"окремий ":"")+"розрахунок ЗП "+(is_privat?"("+calcName+") ":"")+"за "+sBaseMonth+(is_tabn?" по табельним номерам: "+tabn:"")+"?")
		var tbl = OpenTable("SELECT Fdate FROM ^chng WHERE Fis_slct="+sqlTrue+" AND Fdate<>"+sqlTo(base_month)+" ORDER BY Fdate");
		if(!tbl.IsEmpty())
			msg_+=ru("\nПерерасчетные месяца: ","\nПерерахункові місяця: ");
		var k = 0;
		for(; !tbl.IsEOF(); tbl.MoveNext())
		{
			if(k++==0)
				msg_+=tmonth(new Date(tbl.getValue("Fdate")),"mt")+" "+new Date(tbl.getValue("Fdate")).getFullYear()
			else
				msg_+=","+tmonth(new Date(tbl.getValue("Fdate")),"mt")+" "+new Date(tbl.getValue("Fdate")).getFullYear()
		}
		tbl.close();
		if(!confirm(msg_))
		{
			tbl_chng.close();
			return false;
		}
		if(!confirm(ru("Перед началом "+(is_privat?"отдельного ":"")+"расчета рекомендуется закрыть все окна просмотров. Продолжить "+(is_privat?"отдельный ":"")+"расчет"+(is_privat?"("+calcName+") ":"")+"?",
					"Перед початком "+(is_privat?"окремого ":"")+"розрахунку рекомендовано закрити всі вікна переглядів. Продовжити "+(is_privat?"окремий ":"")+"розрахунок"+(is_privat?"("+calcName+") ":"")+"?")))
		{
			tbl_chng.close();
			return false;
		}
	}
	var snap = getSnap("select count(*) from ^cl_vopl "
					+" where Fis_slct="+sqlTrue+" and Fgroup = "+sqlFalse
						+" and exists(select * from ^link_zrp_calcs as l "
							+" where l.Fwid_vopl=^CL_VOPL.Fwid and l.Fcod="+calcNum+")",false);
	if((!snap || (snap && Number(snap[0])==0)) && calcNum)
	{
		alert(ru("Не найдено ни одного отдельного расчета в перечне расчетов, относящегося к '","Не знайдено жодного окремого розрахунку в переліку розрахунків, що відноситься до '")+calcName+"'",1);			
		return false;
	}
	//проверка за запуск расчета другим пользователем
	//при запуске расчета в таблицу заносится запись с полем флага, 
	//который потом в конце расчета убираем, флаг можно убрать принудительно
	//в начале расчета, если вдруг он был сорван и не прошел до конца
	if (!IsTableEx("ZRP_RES", "ZRP_RUNZRP"))
		CreateTableEx("ZRP_RES","ZRP_RUNZRP","RUNZRP");
	var snap = getSnap("select Fuser,Fdaterun,Fwid,Fdate from ^runzrp where Fisrun="+sqlTrue);
	if(snap!=null)
	{
		msg_ = ru("ВНИМАНИЕ!!! Расчет уже запущен пользователем ","УВАГА!!! Розрахунок вже запущено користувачем ")+snap[0]+" ("+format("dd.mm.yyyy HH:MM",snap[1])+")";
		alert(msg_,1);
		msg_ = ru("Расчет запущен пользователем ","Розрахунок запущено користувачем ")+snap[0]+" ("+format("dd.mm.yyyy HH:MM",snap[1])+")\n"
				+(is_tabn?ru("По табельным номерам: ","По табельним номерам: ")+tabn+"\n":"")
				+ru("Расчетный месяц: ","Розрахунковий місяць: ")+tmonth(new Date(snap[3]),"mt")+" "+new Date(snap[3]).getFullYear()+"\n"
				+ru("Желаете все равно продолжить расчет?","Бажаєте все одно продовжити розрахунок?")
		if(msgBox("ny",msg_)!="y")
		{
			tbl_chng.close();
			return false;
		}
		ExecuteSQL("update ^runzrp set Fisrun="+sqlFalse+" where Fwid="+sqlTo(snap[2]))
	}
	var fwid = GetUID();
	//запишем fwid в пользовательский параметр (чтобы не передавать отдельным параметром в расчеты),
	//который понадобиться для ведения лога в расчетах ЗП 
	WriteParEx("FWID_RUNZRP",fwid)
	//запишем в лог сообщение уже на новый fwid
	writeToLog(msg,"w");
	if(snap!=null)
		writeToLog(msg_,"w");
	ExecuteSQL("insert into ^runzrp(Fwid,Fuser,Fhost,Fdaterun,Fisrun,Fdate) "
			+" values("+sqlTo(fwid)+","+sqlTo(getUserName())+","+sqlTo(getHostName())
				+","+sqlDateTo(new Date())+","+sqlTrue+","+sqlTo((extPar && extPar.base_month?extPar.base_month:base_month))+")");

	//запоминаем время начала расчёта
	var time_beg = new Date().getTime();
	//определяем и кэшируем модульные расчеты
	var arrScripts = lpProxy.getData("MODULECALCS");
	if (arrScripts == null)
	{
		arrScripts = new Array();
		var arrModules = lpProxy.getModules();
		for (var i = 0; i < arrModules.length; i++)
		{
			var calcDir = lpProxy.getModulePath(arrModules[i]) +"/scripts/prik/calculate/";
			if(!isDir(calcDir))
				continue;
			var snapCalcDir = snapDirectory(calcDir);
			for (var j in snapCalcDir)
			{
				var sFile = calcDir + snapCalcDir[j];
				var file = new DpFile(sFile);
				var calc = String(snapCalcDir[j]).toLowerCase();
				if (!file.exists() || calc.indexOf("r_")!=0)
					continue;
				var procName = String(arrModules[i]).toLowerCase()+":"+calc.substring(1,calc.length).replace(".js","");
				arrScripts[procName] = file.getAbsolutePath();
			}
		}
		lpProxy.setData("MODULECALCS", arrScripts);
	}
//предварительный расчет начало ---------------------------
	msg = ru("Предварительный расчет ЗП","Попередній розрахунок ЗП");
	writeToLog(msg,"m");
	tbl_vopl=OpenTable("select * from ^CL_VOPL where Fvopl=0 and Fis_slct="
			+sqlTrue+" and Fgroup = "+SqlFalse
			+" and exists(select * from ^link_zrp_calcs as l where l.Fwid_vopl=^CL_VOPL.Fwid and l.Fcod="+calcNum+")"//отсекаем лишние расчеты
			+" order by FVOPL, FNUM");
	tbl_vopl.MoveFirst();
	k = 1;
	setProgressRange(k, tbl_vopl.rowCount);
	while (!stop_on_dt && !tbl_vopl.IsEOF())
	{
		//tbl_prik.MoveFirst();
		//if (!tbl_prik.Seek ("=", tbl_vopl("Fpr")))
		//проверяем, чтобы месяц расчета попадал в период действия
		if(differ(rasch_mes,new Date(tbl_vopl.getValue("Fbdat")))>=0 && (differ(rasch_mes,new Date(tbl_vopl.getValue("Fedat")))<=0 || tbl_vopl.getValue("Fedat")==null))
			skipvopl=false;
		else
			skipvopl=true
		var oSnap = getSnap("SELECT Fnazv, Fproc FROM ^CL_PRIK WHERE Fvid="+sqlTo(tbl_vopl.getValue("Fpr")))
		if(oSnap==null)
		{
			msg = ru("Не найден приказ: ","Не знайден наказ: ")+tbl_vopl.getValue("Fpr");
			writeToLog(msg,"e");
			skipvopl=true;
		}
		if (!skipvopl)
		{
			var VVNAZV = UR(oSnap[0]);
			var snap = getSnap("SELECT Ffld_num FROM ^LIC_FLD WHERE Fid="
							+sqlTo(tbl_vopl.getValue("Flsfid")))
			//if (tbl_vopl.getValue("Flsfid")!=0 && !tbl_lfld.Seek ("=",tbl_vopl("Flsfid")))
			if (tbl_vopl.getValue("Flsfid")!=0 && snap==null)
			{
				msg = "---"+VVNAZV + ru("---:\n не найдено поле ЛС, fid ","---:\n не знайдено поле ОР, fid ") + tbl_vopl.getValue("Flsfid");
				writeToLog(msg,"w");
				skipvopl =true;
			}
		}
		if (!skipvopl)
		{
			VVOPL   = tbl_vopl.getValue("Fvopl");
			VVDPL=tbl_vopl.getValue("fpr")
/*				if (tbl_vopl.getValue("Flsfid")!=0)
				{
					if(snap!=null)
						VVDPL   = snap[0];
				}
				else
					VVDPL = 0;*/
			VVPRK   = tbl_vopl.getValue("Fpr");
			VVLSFID = tbl_vopl.getValue("Flsfid");
			VVLSFID2 = tbl_vopl.getValue("Flsfid2");
			VVPROC  = "r"+oSnap[1];
			// расчет по данному виду доплат/удержаний
//				var txt_for_ecran= "-- " + szTag + ru(" --  расчет: "," --  розрахунок: ") +VVOPL + "/" +
//					VVDPL+", проц.:"+ VVPROC+
//					ru(", ЛС fid:",", ОР fid:") + VVLSFID+ ru(" вид прик.:"," вид наказу:")+VVPRK
			var txt_for_ecran = format("Mmm yyyy",rasch_mes)+", код "+VVPRK+": "+VVNAZV;
			//WAIT(txt_for_ecran);
			//writeToLog(txt_for_ecran,"m");

			//vvs Динамическое подключение расчетов

			//учитываем модульные расчеты
			if(VVPROC.indexOf(":")==-1)
				var calcFile = rootDirectoryEx()+"scripts//prik//calculate//"+VVPROC+".js";
			else
				var calcFile = arrScripts[VVPROC.replace("r","")];
			if(isFile(calcFile))
			{
				if(VVPROC.indexOf(":")==-1)
					include("prik//calculate//"+VVPROC+".js");
				else
				{
					include(calcFile);
					VVPROC = "r"+VVPROC.substring(VVPROC.indexOf(":")+1,VVPROC.length);
				}
				setProgressPos(k, txt_for_ecran);
				if (eval("typeof("+VVPROC+")")=="function")
				{
					//в случае отдельного расчета передаем 7-ым параметром имя отдельной таблицы лицевых счетов
					trace("prepear calc>>>"+VVPROC+"("+rasch_mes+","+VVOPL+","+VVDPL+","+VVLSFID+","+VVLSFID2+(ftabn_id?","+ftabn_id:",null")+(is_privat?",'SVZP"+calcNum+"'":"")+")");
					//eval(VVPROC+"(rasch_mes,VVOPL,VVDPL,VVLSFID,VVLSFID2"+(ftabn_id?",ftabn_id":",null")+(is_privat?",'SVZP"+calcNum+"'":"")+")");					
					eval(VVPROC+"(rasch_mes,VVOPL,VVDPL,VVLSFID,VVLSFID2"+(ftabn_id?",ftabn_id":",null")+(is_privat?",'SVZP"+calcNum+"'":"")+(is_privat?",calcName":",null")+")");
					trace("eval end prepear calc<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<")
				}
				k++;
				}
			}
			else
			{
				var msg = ru("Отсутствует скрипт для расчета: ","Відсутній скрипт для розрахунку: ")+new DpFile(calcFile).getCanonicalPath();
				writeToLog(msg,"e",VVOPL,VVDPL,VVLSFID);
			}
			tbl_vopl.MoveNext();
		}
		tbl_vopl.close();
		setProgressPos(0);
//предварительный расчет конец ----------------------------
	tbl_vopl=OpenTable("s", "select * from ^CL_VOPL where Fvopl<>0 and Fgroup="
				+sqlFalse+" and Fis_slct="+sqlTrue
				+" and exists(select * from ^link_zrp_calcs as l where l.Fwid_vopl=^CL_VOPL.Fwid and l.Fcod="+calcNum+")"//отсекаем лишние расчеты
				+" order by FVOPL, FNUM");

	var out = new Array();
	var jj = 0;
	var str = "";
	while (!stop_on_dt && differ(rasch_mes,(extPar && extPar.base_month?extPar.base_month:base_month))<=0)
	{
		var szTag=getDateTag(rasch_mes);
		msg = ru("Проводится расчёт ЗП за ","Відбувається розрахунок ЗП за ") + StrDat(rasch_mes,"MY");
		WAIT(msg);
		writeToLog(msg,"w");

		SVZPFILE="svzp"+(is_privat?calcNum:"")+szTag;
		SVZOFILE="svzo"+(is_privat?calcNum:"")+szTag;
		
	    if(getPar("KOMKOLD")){		
	    	SVNRFILE="svnr"+(is_privat?calcNum:"")+szTag;
	    }

		if (!IsTableEx("ZRP_RES", "ZRP_"+SVZPFILE))
			CreateTableEx("ZRP_RES","ZRP_"+SVZPFILE,"SVZP","*");

		if (IsTableEx("ZRP_RES", "ZRP_"+SVZOFILE))
			ren_tbl(SVZOFILE,SVZPFILE);

		//если расчет по табельным номерам, тогда удаляем данные по этим номерам из SVZPFILE в процедуре ren_tbl  
		ren_tbl(SVZPFILE,SVZOFILE,is_tabn);
		//таблицу создаем только если это не расчет по табельным номерам
		if(!is_tabn)
			CreateTableEx("ZRP_RES","ZRP_"+SVZPFILE,"SVZP","*");

		//создать временную таблицу для расчета зарплаты по норме - на каждый месяц новая, сохранять результаты будем в статистике
	    if(getPar("KOMKOLD")){		
	    	DropTableEx("ZRP_RES", "ZRP_"+SVNRFILE)
	    	CreateTableEx("ZRP_RES","ZRP_"+SVNRFILE,"SVZP","*");
	    }
	    
		k = 1;
		setProgressRange(k, tbl_vopl.rowCount);
		tbl_vopl.MoveFirst();
		while (!tbl_vopl.IsEOF())
		{
			var oSnap = getSnap("SELECT Fnazv, Fproc, Fprocb, Fproco FROM ^CL_PRIK WHERE Fvid="
						+sqlTo(tbl_vopl.getValue("Fpr")));
			//if (!tbl_prik.Seek ("=", tbl_vopl("Fpr")))
			//проверяем, чтобы месяц расчета попадал в период действия
			if(differ(rasch_mes,new Date(tbl_vopl.getValue("Fbdat")))>=0 && (differ(rasch_mes,new Date(tbl_vopl.getValue("Fedat")))<=0 || tbl_vopl.getValue("Fedat")==null))
				skipvopl=false;
			else
				skipvopl=true;
			var fnazv = "";
			var fproc = "";
			var fprocb = "";
			var fproco = "";
			if (oSnap==null)
			{
				msg = ru("Не найден приказ: ","Не знайдено наказ: ")+tbl_vopl.getValue("Fpr");
				writeToLog(msg,"w");
				skipvopl=true;
			}
			else
			{
				fnazv = oSnap[0];
				fproc = oSnap[1];
				fprocb = oSnap[2];
				fproco = oSnap[3];
			}
			if (!skipvopl)
			{
				var VVNAZV = UR(fnazv);
				var snap = getSnap("SELECT Ffld_num FROM ^LIC_FLD WHERE Fid="
							+sqlTo(tbl_vopl.getValue("Flsfid")))
				//if (tbl_vopl.getValue("Flsfid")!=0 && !tbl_lfld.Seek ("=",tbl_vopl("Flsfid")))
				if (tbl_vopl.getValue("Flsfid")!=0 && snap==null)
				{
					msg = "---"+VVNAZV + ru("---:\n не найдено поле ЛС, fid ","---:\n не знайдено поле ОР, fid ") + tbl_vopl.getValue("Flsfid");
					writeToLog(msg,"w");
					skipvopl =true;
				}
			}

			if (skipvopl==false)
			{
				VVOPL = tbl_vopl.getValue("Fvopl");
				VVDPL=tbl_vopl.getValue("fpr")
/*					if (tbl_vopl.getValue("Flsfid")!=0)
					{
						if(snap!=null)
							VVDPL   = snap[0];
					}
					else
						VVDPL = 0;*/
				VVPRK = tbl_vopl.getValue("Fpr");
				VVLSFID = tbl_vopl.getValue("Flsfid");
				VVLSFID2 = tbl_vopl.getValue("Flsfid2");
				VBOLN = tbl_vopl.getValue("Fboln");
				VOTP = tbl_vopl.getValue("Fotpusk");
				if (fproc.substr(0,1)==":" && VBOLN==false && VOTP==false)
				{
					var snp = getSnap("SELECT Fproc FROM ^CL_PROC WHERE Flabel = "
								+ sqlToFind(fproc) + " and Fnum="+sqlTo(tbl_vopl.getValue("Fprocnum")));
					//if (!tbl_proc.FindFirst("Flabel = " + sqlToFind(fproc) + " and Fnum="+tbl_vopl.getValue("Fprocnum")))
					if (snp==null)
					{
						msg = "Не найден расчет: " + fproc + "/" + tbl_vopl.getValue("Fprocnum");
						writeToLog(msg,"e");
						skipvopl=true;
					}
					else
					{
						VVPROC  = "r" + snp[0];
					}
				}
				else
				{
					VVPROC  = "r" + fproc;
				}
				//02.03.09 ЕСли есть признак, что участв.в больн, то берем не имя основного расчета, а имя расчета для переноса времени
				//процедура переноса времени работает только для праздничных
				VVPROCB  = "r" + fprocb;			
				if (VBOLN==true){
					VVPROC  = VVPROCB;						
				}		
				VVPROCO  = "r" + fproco;			
				if (VOTP==true){
					VVPROC  = VVPROCO;
				}	
				//******************************************
				if (!skipvopl)
				{
//						var txt_for_ecran= "-- " + szTag + " --  расчет: " +VVOPL + "/" +
//							VVDPL+", проц.:"+ VVPROC+
//							", ЛС fid:" + VVLSFID+ " вид прик.:"+VVPRK;
					var txt_for_ecran = format("Mmm yyyy",rasch_mes)+", код "+VVPRK+": "+VVNAZV;
					//WAIT(txt_for_ecran);
					//writeToLog(txt_for_ecran,"m");
					//расчет по данному виду доплат/удержаний
					//vvs Динамическое подключение расчетов
					var t = new Date().getTime();
					setProgressPos(k, txt_for_ecran);
					
					//учитываем модульные расчеты
					if(VVPROC.indexOf(":")==-1)
						var calcFile = rootDirectoryEx()+"scripts//prik//calculate//"+VVPROC+".js";
					else
						var calcFile = arrScripts[VVPROC.replace("r","")];
					if(isFile(calcFile))
					{
						if(VVPROC.indexOf(":")==-1)
							include("prik//calculate//"+VVPROC+".js");
						else
						{
							include(calcFile);
							VVPROC = "r"+VVPROC.substring(VVPROC.indexOf(":")+1,VVPROC.length);
						}
						if (eval("typeof("+VVPROC+")")=="function")
						{
							//в случае отдельного расчета передаем 7-ым параметром имя отдельной таблицы лицевых счетов
							trace(VVPROC+"("+rasch_mes+","+VVOPL+","+VVDPL+","+VVLSFID+","+VVLSFID2+(ftabn_id?","+ftabn_id:",null")+(is_privat?",'SVZP"+calcNum+"'":"")+")");
							if(SUBD==ORACLE && getPar("CALC_OPEN_CURSORS"))
								oraCursBeg = oraGetOpenCursorsCount(getUserName());
							//eval(VVPROC+"(rasch_mes,VVOPL,VVDPL,VVLSFID,VVLSFID2"+(ftabn_id?",ftabn_id":",null")+(is_privat?",'SVZP"+calcNum+"'":"")+")");
							eval(VVPROC+"(rasch_mes,VVOPL,VVDPL,VVLSFID,VVLSFID2"+(ftabn_id?",ftabn_id":",null")+(is_privat?",'SVZP"+calcNum+"'":"")+(is_privat?",calcName":",null")+")");							
							if(SUBD==ORACLE && getPar("CALC_OPEN_CURSORS"))
								oraCursEnd = oraGetOpenCursorsCount(getUserName());
							trace("eval<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<")
						}
					}
					else
					{
						var msg = ru("Отсутсвует скрипт для расчета: ","Відсутній скрипт для розрахунку: ")+new DpFile(calcFile).getCanonicalPath();
						writeToLog(msg,"e",VVOPL,VVDPL,VVLSFID);
					}
				}
			}
			tbl_vopl.MoveNext();
			if (!skipvopl)
			{
				//формируем информацию о времени выполнении расчетов, которая будет заносится
				//во временную таблицу ZRP_TIME_CALC и параллельно в текстовый файл C:/zrp.txt
				var d = (new Date().getTime() - t)/1000;
				str = str + VVPROC + ":" +String(d) + "; ";
				var outObj = new Object();
				outObj.Fproc_name = VVPROC;
				outObj.Ftime = d;
				outObj.Fdate = rasch_mes;
				if(SUBD==ORACLE && getPar("CALC_OPEN_CURSORS"))
					outObj.Fcursors = oraCursEnd - oraCursBeg;
				out[jj++] = outObj;
			}
			k++;
		}
		setProgressPos(0);
		//в случае если месяц не базовый или базовый, но проводится
		//частичный перерасчет провести переименование файлов
		if (differ(rasch_mes, (extPar && extPar.base_month?extPar.base_month:base_month)))
			ren_tbl(SVZOFILE,SVZPFILE);
		if (differ(rasch_mes,(extPar && extPar.base_month?extPar.base_month:base_month))==0)
			DropTableEx("ZRP_RES","ZRP_"+SVZOFILE);
		tbl_chng.MoveNext();
		stop_on_dt = tbl_chng.IsEOF();
		if (!stop_on_dt)
			rasch_mes=new Date(tbl_chng.getValue("Fdate"));
	}
//lpProxy.writeToFile(str,"C:/zrp.txt","utf-8");
	tbl_vopl.close();
	//вычисляем общее время расчёта зарплаты в минутах
	time_end = (new Date().getTime() - time_beg)/60000;
	if(tbl_chng.isEmpty())
	{
		msg = ru("Не выбран ни один месяц для расчёта ЗП!","Не вибрано жодного місяця для розрахунку ЗП!");
		alert(msg);
		writeToLog(msg,"m");
		tbl_chng.close();
		ExecuteSQL("update ^runzrp set Fisrun="+sqlFalse+", Ftime="+sqlTo(time_end)+" where Fwid="+sqlTo(fwid))
		return false;
	}
	tbl_chng.close();
	if(!(extPar && extPar.base_month))
	{
		//поставить отметку, что окончательный расчёт за base_month уже проводился
		if (rasch_mes.getVarDate()<=base_month.getVarDate() && rasch_mes.getVarDate()>=base_month.getVarDate())
			ExecuteSQL("UPDATE ^CHNG SET FFINAL=1 WHERE FDATE="+sqlTo(base_month.getVarDate()));
	}
//	DropTable("R_ALLO");
//	if(is_rasch)
//		CreateTable("R_ALLO","R_ALLO");

	//создаём таблицу zrp_time_calc и заносим в неё названия и время расчётов
	DropTable("zrp_time_calc");
	ExecuteSQL("create table zrp_time_calc ("
				+"Fwid "+SqlType("COUNTER")
				+",Fproc_name "+SqlType("TEXT")
				+", Ftime "+SqlType("DOUBLE")
				+(SUBD==ORACLE && getPar("CALC_OPEN_CURSORS")?", Fcursors "+SqlType("INT"):"")
				+", Fdate "+SqlType("DATE")+")");
	setProgressRange(1, out.length);
	for(var i=0; i<out.length; i++)
	{
		setProgressPos(i+1, ru("Запись времени расчетов...","Запис часу розрахунку..."));
		UpdateTable("zrp_time_calc", out[i], true)
	}
	setProgressPos(0);
	var outObj = new Object();
	outObj.Fproc_name = "общ.время(мин)"
	outObj.Ftime = time_end;
	if(SUBD==ORACLE && getPar("CALC_OPEN_CURSORS"))
	{
		var cursors = 0
		var snap = getSnap("select SUM(Fcursors) from zrp_time_calc");
		if(snap)
			cursors = snap[0];
	}
	UpdateTable("zrp_time_calc", outObj, true)
	ExecuteSQL("update ^runzrp set Fisrun="+sqlFalse+", Ftime="+sqlTo(time_end)+" where Fwid="+sqlTo(fwid))
	time_end = Math.round(time_end*100)/100;
	msg = ru("Расчет зарплаты завершен\nОбщее время расчета "+time_end+" минут.",
			"Розрахунок зарплати завершено\nЗагальний час розрахунку "+time_end+" хвилин.")
			+(SUBD==ORACLE && getPar("CALC_OPEN_CURSORS")?ru("\nКол-во открытых курсоров: ","\nКількість відкрітих курсорів: ")+cursors:"")
	//выводим сообщение только если запускали расчет из основного меню
	if(!(extPar && extPar.base_month))
		alert(msg);
	writeToLog(msg,"m");
//		if(Number(ReadParEx("SHOW_LOG_ZRP"))!=0)
//		{
	var snap = getSnap("select count(*) from ^logzrp where Fid="+sqlTo(fwid)+" and Ftype="+sqlTo("e"))
	msg = ru("Кол-во ошибок при выполнении расчета: ","Кілкість помилок при виконанні розрахунку: ")+snap[0]+"\n";
	if(snap[0]>0 && confirm(msg+ru("Открыть лог расчета зарплаты?","Відкрити лог розрахунку зарплати?")))
	{
		var par = new Object();
		par.fid = fwid;
		showWindow("l_logzrp.js",SW_NOMODAL,par);
	}
//			WriteParEx("SHOW_LOG_ZRP",0)
//		}

	/*DropTableEx("ZRP_RES","zrp_" + mainTableName);
	//strSQL = "DELETE FROM ^" + mainTableName;
	//ExecuteSQL(strSQL);
	trace("DropTableEx(ZRP_RES, zrp_" + mainTableName +")");
	var bRet = DropTableEx("ZRP_RES","zrp_" + mainTableName);
	alert(bRet)
	browse("DPBASE."+ "zrp_" + mainTableName);
		
	//Открытие перечня расчетов
	strSQL = "SELECT v.flsfid,v.flsfid2, v.fvopl, p.fproc, l.ffld_num, v.fpr, v.fprocnum"
			+ " FROM (^cl_vopl AS v INNER JOIN ^cl_prik AS p ON v.fpr=p.fvid)"
				+ "LEFT JOIN ^lic_fld AS l ON l.fid=v.flsfid"
			+ " WHERE v.fis_slct=" + sqlTrue
				+ " AND v.fgroup=" + sqlFalse
			+ " ORDER BY v.fvopl, v.fnum";
	var tblClVopl = OpenTable("s", strSQL);
	//Непосредственный расчет зарплаты, согласно списка из перечня расчетов
	var str = "";
	for(tblClVopl.MoveFirst(); !tblClVopl.isEOF(); tblClVopl.MoveNext())
	{
		var procName = tblClVopl.getValue("fproc");
		if(procName.substr(0,1) == ":")
		{
			tbl_proc = OpenTable("s","select * from ^cl_proc where Flabel=" + sqlTo(procName)
										+ " and Fnum=" + sqlTo(tblClVopl.getValue("fprocnum")));
			if (tbl_proc.isEmpty())
				alert("Не найден расчет: " + tblClVopl.getValue("Fproc") + "/" + tblClVopl.getValue("Fprocnum"));
			else
				procName = tbl_proc.getValue("fproc");
		}
			
			
		include("prik/calculate/r" + procName + ".js");
		//alert(procName);
		var t = new Date().getTime();
		trace("********************************************************")
		trace("BEGIN PROC - " + procName);
		if(eval("typeof(r" + procName + ")")=="function")
		{
			eval("r" + procName + "(bdat"
									+ ", tblClVopl.getValue('fvopl')"
									+ ", tblClVopl.getValue('fpr')"
									+ ", tblClVopl.getValue('flsfid')"
									+ ", tblClVopl.getValue('flsfid2'))");
		}
		trace("********************************************************")
		var d = (new Date().getTime() - t)/1000;
		str = str + procName + ":" +String(d) + "; ";
		
	}
	
	//lpProxy.writeToFile(str,"C:/zrp.txt","utf-8");
	alert(UR("Розрахунок завершено","Расчет завершен"));*/
	return true;
}

function ren_tbl(old_name,new_name,toDelTabn)
{
	var fl = true;
//	if (!IsTableEx("ZRP_RES", "ZRP_"+new_name))
		if(!CreateTableEx("ZRP_RES","ZRP_"+new_name,"SVZP","*"))
			fl = false;
			
	var strFlds = GetPatternIntersection("svzp", "svzp").toUpperCase();
	// rename "FWID_WP" name before cut "FWID"
	strFlds = strFlds.replace("FWID_WP", "__COL111");
	strFlds = strFlds.replace(/(\s*,FWID)|(FWID\s*,)|(\s*FWID\W)/gi,"");
	// rename "FWID_WP" back
	strFlds = strFlds.replace("__COL111", "FWID_WP");
	
	fl = ExecuteSQL("INSERT INTO ^"+new_name+"("+strFlds
				+") SELECT "+strFlds+" FROM ^"+old_name)
	if(toDelTabn)
	{
		if(ftabn_id)
			ExecuteSQL("delete from ^"+old_name+" where Ftabn_id in ("+ftabn_id+")");
		else
		{
			msg = ru("Не определены табельные номера по которым расчитывать з/п, переменная ftabn_id","Не визначені табельні номера по яким розраховувати з/п, змінна ftabn_id");
			alert(msg);
			writeToLog(msg,"e");
		}
	}
	else
	{
		if(!DropTableEx("ZRP_RES","ZRP_"+old_name))
		{
			msg = ru("Невозможно удалить таблицу "+old_name+" после переименования!","Неможливо видалити таблицю "+old_name+" після переіменування!");
			alert(msg);
			writeToLog(msg,"e");
		}
	}
	return fl;
}

r_all(GetMenuMode())