include("Objects/DpJRegistrator.js");

var tblOut = "TMP_KU_DEBT";		//таблица с результатами
var tblReg = null;				//таблица журнала регистрации
var label  = "KU_DEBT";			//метка
var streetID;					//id улицы
var houseID;					//id дома
var platCod;					//код плательщика
var lot;						//участок
var gek;						//ЖЭК
var rdat1;						//нач. дата расчета
var rdat2;						//кон. дата расчета
var sum = 0;
var period = 0;

function listLoad()
{
	this.xmlGridFile = "r_kudebt.xml";
	this.printLabel = label;	
}

function listTitle()
{
	var sCapt = ru("Отчет по задолженности", "Звіт по заборгованості");
	
	var dat1 = list.objAsk.idat1;
	var dat2 = list.objAsk.idat2;
	var oStreet = list.objAsk.istreet;
	var oHouse = list.objAsk.ihouse;
	if(dat1)
		sCapt += " за "+ StrDat(dat1, "DMY") +" - "+ StrDat(dat2, "DMY");
	if(oStreet!=null && oStreet.getCod()!=0)
		sCapt += ": "+ oStreet.getTxt();
	if(oHouse!=null)
		sCapt += " "+ getHouseNom(oHouse.getFWID());
	return sCapt;
}

function listSrc()
{	
	this.qrySet("From", tblOut, "Order", "Ftt, FSTREET, FHOUSE, FPLAT");
	this.subTie("cl", "str", "FWID", "FSTREET");
	this.subTie("cl_house", "hs", "FWID_CL", "FHOUSE");
	this.subTie("cl_apartment", "apt", "FWID_CL", "FAPMT");
}

function listAsk()
{
	var p = new Object();
	if(extPar)
		p = extPar;
	p.tblName = tblOut;
	p.label = label;
	p.debt = true;
	p.lot = true;	
	showWindow("i_vedku.xml", SW_MODAL, p);
	if (!p.escape)
    {
    	rdat1 = p.idat1;
	    rdat2 = p.idat2;
	    houseID = p.ihouse.getFWID();
	    streetID = p.istreet.getFWID();
	    platCod = p.iplat.getCod();
	    lot = p.ilot.getCod();
	    gek = p.igek.getCod();
	    sum = p.sum;
	    period = p.period;
    }    
	return p;
}

function listMake()
{
	tblReg = hocRegTblName();
	
	var nPr = 1;
	var sPrText = ru("Выполняется расчет...","Виконується розрахунок...");
	setProgressRange(0, 7);
	setProgressPos(nPr++, sPrText);
	
	createOutTable();
	setProgressPos(nPr++, sPrText);
	
	var sWhere = " where 1=1 ";
	if(rdat1!=null && rdat2!=null)
		sWhere += " and (r.FDATE>="+ sqlTo(rdat1) 
				  +" and r.FDATE<="+ sqlTo(rdat2) +")";
	if(streetID!=null)
		sWhere += " and hs.FSTREET="+ streetID;	
	if(houseID!=null)
		sWhere += " and hs.FWID_CL="+ houseID;
	if(platCod)
		sWhere += " and r.FORG="+ platCod;
	if(lot)
		sWhere += " and hs.FLOT="+ lot;
	if(gek)
		sWhere += " and hs.FGEK="+ gek;
	
	var sSQL = "insert into "+ tblOut 
			+" (FPLAT, FID_DOG, FDATE, FSTREET, FHOUSE, FAPMT, FFIO, FAPMTNOM"
				+", FLIVAREA, FLOGAREA, FBALAREA, FPERSKOL, FEXMPTKOL"
				+", FRENT, FHEAT, FCOOL, FHOT, FDRAIN, FGAS, FELECTRIC"
				+", FRENT_PAY, FHEAT_PAY, FCOOL_PAY, FHOT_PAY, FDRAIN_PAY"
				+", FGAS_PAY, FELECTRIC_PAY, FOTHER, FOTHER_PAY, FSUBSERV, FSUBSERV_PAY"				
				+", FHOTVOL, FCOOLVOL, FDRAINVOL, FELECTRICVOL, FGASVOL, FHEATVOL"
				+", FSUB, FDISCOUNT, FSUPPORT, FRECALC, FPENALTY, FSUM, FPLATSUM, FDEBT, FOVERPAY)"
			+" select r.FORG, r.FID_DOG, max(r.FDATE), max(hs.FSTREET)"
				+", max(apt.FHOUSE), max(lic.FAPMT)"
				+", max(cl.FTXT) as FFIO, max(apt.FNOM) as FAPMTNOM"				
				+", max(apt.FLIVAREA), max(apt.FLOGAREA), max(apt.FBALAREA)"
				+", max(lic.FPERSKOL) as FPERSKOL, max(lic.FEXTKOL) as FEXMPTKOL"
				+", sum"+ IIF("r.FISSKU="+ sqlTrue, "r.FRENT", 0) +" as FRENT"
				+", sum"+ IIF("r.FISSKU="+ sqlTrue, "r.FHEAT", 0) +" as FHEAT"
				+", sum"+ IIF("r.FISSKU="+ sqlTrue, "r.FWATER", 0) +" as FCOOL"
				+", sum"+ IIF("r.FISSKU="+ sqlTrue, "r.FHOTWATER", 0) +" as FHOT"
				+", sum"+ IIF("r.FISSKU="+ sqlTrue, "r.FDRAIN", 0) +" as FDRAIN"
				+", sum"+ IIF("r.FISSKU="+ sqlTrue, "r.FGAS", 0) +" as FGAS"
				+", sum"+ IIF("r.FISSKU="+ sqlTrue, "r.FELECTRIC", 0) +" as FELECTRIC"
				+", sum"+ IIF("r.FISSKU="+ sqlFalse, "r.FRENT", 0) +" as FRENT_PAY"
				+", sum"+ IIF("r.FISSKU="+ sqlFalse, "r.FHEAT", 0) +" as FHEAT_PAY"
				+", sum"+ IIF("r.FISSKU="+ sqlFalse, "r.FWATER", 0) +" as FCOOL_PAY"
				+", sum"+ IIF("r.FISSKU="+ sqlFalse, "r.FHOTWATER", 0) +" as FHOT_PAY"
				+", sum"+ IIF("r.FISSKU="+ sqlFalse, "r.FDRAIN", 0) +" as FDRAIN_PAY"
				+", sum"+ IIF("r.FISSKU="+ sqlFalse, "r.FGAS", 0) +" as FGAS_PAY"
				+", sum"+ IIF("r.FISSKU="+ sqlFalse, "r.FELECTRIC", 0) +" as FELECTRIC_PAY"
				+", sum"+ IIF("r.FISSKU="+ sqlTrue, "r.FOTHER", 0) +" as FOTHER"
				+", sum"+ IIF("r.FISSKU="+ sqlFalse, "r.FOTHER", 0) +" as FOTHER_PAY"
				+", sum"+ IIF("r.FISSKU="+ sqlTrue, "r.FSUBSERV", 0) +" as FSUBSERV"
				+", sum"+ IIF("r.FISSKU="+ sqlFalse, "r.FSUBSERV", 0) +" as FSUBSERV_PAY"
				+", sum(r.FHOTVOL), sum(r.FCOOLVOL), sum(r.FDRAINVOL)"
				+", sum(r.FELECTRICVOL), sum(r.FGASVOL), sum(r.FHEATVOL)"
				+", sum(r.FSUB), sum(r.FDISCOUNT), sum(r.FSUPPORT)"
				+", sum(r.FRECALC), sum(r.FPENALTY)"
				+", sum"+ IIF("r.FISSKU="+ sqlTrue, "r.FSUM_SKU", 0) +" as FSUM"
				+", sum"+ IIF("r.FISSKU="+ sqlFalse, "r.FSUM", 0) +" as FPLATSUM"
				+", 0 as FDEBT"
				+", sum"+ IIF("r.FISSKU="+ sqlFalse, "r.FOVERPAY", 0) +" as FOVERPAY"
			+" from "+ tblReg +" as r "
				+" INNER JOIN ^LICSC as lic ON lic.FID_DOG=r.FID_DOG "				
				+" LEFT JOIN ^CL_APARTMENT as apt ON apt.FWID_CL=lic.FAPMT "
				+" INNER JOIN ^CL_HOUSE as hs ON hs.FWID_CL=lic.FHOUSE "				
				+" INNER JOIN ^CLRELCLCL as rel ON rel.FCOD=r.FORG and rel.FCL=0 "
				+" INNER JOIN ^CL as cl ON cl.FWID=rel.FWID_CL "
			+ sWhere
			+" group by r.FID_DOG, r.FORG";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPrText);
	
	//долги
	ExecuteSQL("update "+ tblOut +" set FRENT_DEBT=(FRENT-FRENT_PAY) where FRENT>=FRENT_PAY");
	ExecuteSQL("update "+ tblOut +" set FHEAT_DEBT=(FHEAT-FHEAT_PAY) where FHEAT>=FHEAT_PAY");
	ExecuteSQL("update "+ tblOut +" set FCOOL_DEBT=(FCOOL-FCOOL_PAY) where FCOOL>=FCOOL_PAY");
	ExecuteSQL("update "+ tblOut +" set FHOT_DEBT=(FHOT-FHOT_PAY) where FHOT>=FHOT_PAY");
	ExecuteSQL("update "+ tblOut +" set FDRAIN_DEBT=(FDRAIN-FDRAIN_PAY) where FDRAIN>=FDRAIN_PAY");
	ExecuteSQL("update "+ tblOut +" set FGAS_DEBT=(FGAS-FGAS_PAY) where FGAS>=FGAS_PAY");
	ExecuteSQL("update "+ tblOut +" set FELECTRIC_DEBT=(FELECTRIC-FELECTRIC_PAY) where FELECTRIC>=FELECTRIC_PAY");
	ExecuteSQL("update "+ tblOut +" set FOTHER_DEBT=(FOTHER-FOTHER_PAY) where FOTHER>=FOTHER_PAY");
	ExecuteSQL("update "+ tblOut +" set FSUBSERV_DEBT=(FSUBSERV-FSUBSERV_PAY) where FSUBSERV>=FSUBSERV_PAY");	
	setProgressPos(nPr++, sPrText);	
	
	var skuSum = IIF("r.FISSKU="+ sqlTrue, "r.FSUM_SKU", 0);
	var platSum = IIF("r.FISSKU="+ sqlFalse, "r.FSUM", 0);
	sSQL = "update "+ tblOut
				+" set FBBALANS=(select sum("+ skuSum +"-"+ platSum +")" 
					+" from "+ tblReg +" r "
					+" where r.FID_DOG="+ tblOut +".FID_DOG "
						+" and r.FDATE<"+ sqlTo(rdat1)
					+" group by r.FID_DOG"
					+")"
				+" where exists (select r.FSUM" 
					+" from "+ tblReg +" r "
					+" where r.FID_DOG="+ tblOut +".FID_DOG "
					+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPrText);
	
	ExecuteSQL("update "+ tblOut +" set FBBALANS=0 where FBBALANS is NULL");
	ExecuteSQL("update "+ tblOut +" set FBILLSUM=(FSUM+FSUPPORT)");
	ExecuteSQL("update "+ tblOut +" set FDEBT=(FSUM-FPLATSUM) where FSUM>FPLATSUM");
	//ExecuteSQL("update "+ tblOut +" set FOVERPAY=(FPLATSUM-FSUM) where FPLATSUM>FSUM");
	ExecuteSQL("update "+ tblOut +" set FEBALANS=(FSUM+FBBALANS-FPLATSUM)");
	setProgressPos(nPr++, sPrText);
	
	if(period>0)
	{
		ExecuteSQL("delete from "+ tblOut +" where FEBALANS<=0 or FEBALANS is NULL");
		for(var m=period; m>0; m--)
		{
			var date = goMonth(today, -m);
			date.date = 1;
			if(getPar("HOCDAYDEBT"))
				date.date = getPar("HOCDAYDEBT");
			trace("\n>>> "+ StrDat(date, "DMY"));
			sSQL = "update "+ tblOut
					+" set FPERIOD_DEBT=(select sum("+ skuSum +"-"+ platSum +")" 
						+" from "+ tblReg +" r "
						+" where r.FID_DOG="+ tblOut +".FID_DOG "
							+" and r.FDATE<"+ sqlTo(date)
						+" group by r.FID_DOG"
						+")"
					+" where exists (select r.FSUM" 
						+" from "+ tblReg +" r "
						+" where r.FID_DOG="+ tblOut +".FID_DOG "
						+")";
			ExecuteSQL(sSQL);
			ExecuteSQL("delete from "+ tblOut +" where FPERIOD_DEBT<=0 or FPERIOD_DEBT is NULL");
		}
	}
	
	if(sum!=0)
	{
		ExecuteSQL("delete from "+ tblOut +" where FEBALANS<"+ sum);
	}
		
	//итоги
	sTotalTbl = tblOut +"_TOTALS";
	ExecuteSQL("drop table "+ sTotalTbl, false);
	sSQL = "select 'SUM' as FTT, 0 as FSTREET, 0 as FHOUSE"
				+", sum(FPERSKOL) as FPERSKOL, sum(FEXMPTKOL) as FEXMPTKOL"
				+", sum(FRENT) as FRENT, sum(FHEAT) as FHEAT"
				+", sum(FCOOL) as FCOOL, sum(FHOT) as FHOT"
				+", sum(FDRAIN) as FDRAIN, sum(FGAS) as FGAS"
				+", sum(FELECTRIC) as FELECTRIC, sum(FRENT_PAY) as FRENT_PAY"
				+", sum(FHEAT_PAY) as FHEAT_PAY, sum(FCOOL_PAY) as FCOOL_PAY"
				+", sum(FHOT_PAY) as FHOT_PAY, sum(FDRAIN_PAY) as FDRAIN_PAY"
				+", sum(FGAS_PAY) as FGAS_PAY, sum(FELECTRIC_PAY) as FELECTRIC_PAY"
				+", sum(FOTHER) as FOTHER, sum(FOTHER_PAY) as FOTHER_PAY"
				+", sum(FSUBSERV) as FSUBSERV, sum(FSUBSERV_PAY) as FSUBSERV_PAY"
				+", sum(FHOTVOL) as FHOTVOL, sum(FCOOLVOL) as FCOOLVOL"
				+", sum(FDRAINVOL) as FDRAINVOL, sum(FELECTRICVOL) as FELECTRICVOL"
				+", sum(FGASVOL) as FGASVOL, sum(FHEATVOL) as FHEATVOL"
				+", sum(FSUB) as FSUB, sum(FDISCOUNT) as FDISCOUNT"
				+", sum(FSUPPORT) as FSUPPORT, sum(FRECALC) as FRECALC"
				+", sum(FPENALTY) as FPENALTY, sum(FSUM) as FSUM"
				+", sum(FPLATSUM) as FPLATSUM, sum(FDEBT) as FDEBT"
				+", sum(FBBALANS) as FBBALANS, sum(FEBALANS) as FEBALANS"
				+", sum(FBILLSUM) as FBILLSUM"
				+", sum(FRENT_DEBT) as FRENT_DEBT"
				+", sum(FHEAT_DEBT) as FHEAT_DEBT"
				+", sum(FCOOL_DEBT) as FCOOL_DEBT"
				+", sum(FHOT_DEBT) as FHOT_DEBT"
				+", sum(FDRAIN_DEBT) as FDRAIN_DEBT"
				+", sum(FGAS_DEBT) as FGAS_DEBT"
				+", sum(FELECTRIC_DEBT) as FELECTRIC_DEBT"
				+", sum(FOTHER_DEBT) as FOTHER_DEBT"
				+", sum(FSUBSERV_DEBT) as FSUBSERV_DEBT"
				+", sum(FOVERPAY) as FOVERPAY"
			+" into "+ sTotalTbl +" from "+ tblOut;	
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPrText);
	
	var sFld = "FTT, FSTREET, FHOUSE, FPERSKOL, FEXMPTKOL"
				+", FRENT, FHEAT, FCOOL, FHOT, FDRAIN, FGAS, FELECTRIC"
				+", FRENT_PAY, FHEAT_PAY, FCOOL_PAY, FHOT_PAY"
				+", FDRAIN_PAY, FGAS_PAY, FELECTRIC_PAY, FOTHER, FOTHER_PAY"
				+", FSUBSERV, FSUBSERV_PAY"
				+", FHOTVOL, FCOOLVOL, FDRAINVOL, FELECTRICVOL, FGASVOL, FHEATVOL"
				+", FSUB, FDISCOUNT, FSUPPORT, FRECALC, FPENALTY"
				+", FSUM, FPLATSUM, FDEBT, FBBALANS, FEBALANS, FBILLSUM"
				+", FRENT_DEBT, FHEAT_DEBT, FCOOL_DEBT, FHOT_DEBT, FDRAIN_DEBT"
				+", FGAS_DEBT, FELECTRIC_DEBT, FOTHER_DEBT, FSUBSERV_DEBT, FOVERPAY";
	sSQL = "insert into "+ tblOut +"("+ sFld +") select "+ sFld +" from "+ sTotalTbl;
	ExecuteSQL(sSQL);
	
	ExecuteSQL("update "+ tblOut 
				+" set FSPLITBILL=("
					+"FRENT+FHEAT+FCOOL+FHOT+FDRAIN+FGAS+FELECTRIC+FOTHER+FSUBSERV"
					+")"
				);
	ExecuteSQL("update "+ tblOut 
				+" set FSPLITSUM=("
					+"FRENT_PAY+FHEAT_PAY+FCOOL_PAY+FHOT_PAY+FDRAIN_PAY"
					+"+FGAS_PAY+FELECTRIC_PAY+FOTHER_PAY+FSUBSERV_PAY"
					+"+FOVERPAY)"
				);
	ExecuteSQL("update "+ tblOut 
				+" set FSPLITDEBT=("
					+"FRENT_DEBT+FHEAT_DEBT+FCOOL_DEBT+FHOT_DEBT+FDRAIN_DEBT"
					+"+FGAS_DEBT+FELECTRIC_DEBT+FOTHER_DEBT+FSUBSERV_DEBT"
					+")"
				);
	//ExecuteSQL("update "+ tblOut +" set FOVERPAY="+ IIF("FOVERPAY>FDEBT", "(FOVERPAY-FDEBT)", 0));
	
	setProgressPos(0);
}

function hocRegTblName()
{		
	var sPath = getPath("UJ");
	var sTblName = sPath +".UJ_KU";
	var jID = getPar("HOCPAYREG");	
	if(jID!=null && jID!="")
		sTblName = sPath +".UJ_"+ jID;		
	return sTblName;
}

function createOutTable(sTblName)
{
	if(!sTblName)
		sTblName = tblOut;
	if(!ExecuteSQL("DROP TABLE "+ sTblName, false))
		ExecuteSQL("DELETE FROM "+ sTblName, false)
	var sSql = "CREATE TABLE "+ sTblName 
			+"(FPLAT "+ SqlType("LONG") 	//плательщик: FORG из табл RAS_SKU, он же FCOD табл CLRELCLCL (справочник аналитики 2-го вида)
			+", FID_DOG"+ SqlType("LONG")	//договор: FID_DOG из табл RAS_SKU, он же FID_DOG табл LICSC, он же FWID табл CONTRACT
			+", FAPMT"+ SqlType("LONG")		//квартира: FWID_CL табл CL_APARTMENT, он же FAPMT из табл LICSC. вытягивается по FID_DOG табл RAS_SKU
			+", FHOUSE"+ SqlType("LONG")	//дом: FWID_CL табл CL_HOUSE, он же FHOUSE из табл CL_APARTMENT. вытягивается по FAPMT табл LICSC
			+", FSTREET"+ SqlType("LONG")	//улица: FSTREET из табл CL_HOUSE, он же FWID табл CL (справочник 1-го вида). вытягивается по FHOUSE табл CL_APARTMENT
			+", FLIVAREA"+ SqlType("DOUBLE")//жилая площадь: FLIVAREA из табл CL_APARTMENT
			+", FLOGAREA"+ SqlType("DOUBLE")//площадь лоджий: FLOGAREA из табл CL_APARTMENT
			+", FBALAREA"+ SqlType("DOUBLE")//площадь балконов: FBALAREA из табл CL_APARTMENT
			+", FFIO "+ SqlType("TEXT")		//ФИО плательщика: FTXT табл CL
			+", FAPMTNOM"+ SqlType("TEXT")	//номер квартиры: FNOM табл CL_APARTMENT
			+", FWCOUNTER"+ SqlType("BIT")	//налич.сч.воды
			+", FGCOUNTER"+ SqlType("BIT")	//налич.сч.газа
			+", FPERSKOL"+ SqlType("INT")	//колич. жильцов: FPERSKOL табл LICSC
			+", FEXMPTKOL"+ SqlType("INT")	//колич. льготников: FEXMPTKOL табл LICSC						
			+", FDATE"+ SqlType("DATE")		//дата начисления/оплаты
			+", FDOC"+ SqlType("TEXT")		//метка документа
			+", FNOP"+ SqlType("INT")		//номер операции
			+", FTT"+ SqlType("TEXT")		//тип итога
			+", FSUB"+ SqlType("CURRENCY") +" default 0"		//сумма субсидий
			+", FDISCOUNT"+ SqlType("CURRENCY") +" default 0"	//сумма льгот
			+", FBILLSUM"+ SqlType("CURRENCY") +" default 0"	//общая сумма с уч. льгот и субсидий
			+", FSUPPORT"+ SqlType("CURRENCY") +" default 0"	//адресная помощь
			+", FRECALC"+ SqlType("CURRENCY") +" default 0" 	//перерасчет
			+", FPENALTY"+ SqlType("CURRENCY") +" default 0" 	//пеня			
			+", FSUM"+ SqlType("CURRENCY") +" default 0"		//общая сумма с учетом адресной помощи
			+", FBBALANS"+ SqlType("CURRENCY") +" default 0"	//сальдо на начало
			+", FEBALANS"+ SqlType("CURRENCY") +" default 0"	//сальдо на конец
			+", FPLATSUM"+ SqlType("CURRENCY") +" default 0"	//сумма оплаченная
			+", FSPLITBILL"+ SqlType("CURRENCY") +" default 0"
			+", FSPLITSUM"+ SqlType("CURRENCY") +" default 0"	//сумма оплат с разбивкой 
			+", FSPLITDEBT"+ SqlType("CURRENCY") +" default 0"	//сумма долга с разбивкой 
			+", FOVERPAY"+ SqlType("CURRENCY") +" default 0"	//Переплата
			+", FDEBT"+ SqlType("CURRENCY")	+" default 0"		//долг
			+", FPERIOD_DEBT"+ SqlType("CURRENCY") +" default 0"	//долг за период
			+", FPERIOD_BALANS"+ SqlType("CURRENCY") +" default 0"	//
			+", FWID"+ SqlType("COUNTER") 
			//начисления с учетом льгот. и субсидий
			+", FRENT"+ SqlType("CURRENCY")	+" default 0"		//квартплата
			+", FHEAT"+ SqlType("CURRENCY")	+" default 0"		//отопление
			+", FCOOL"+ SqlType("CURRENCY") +" default 0"		//хол. вода
			+", FHOT"+ SqlType("CURRENCY") +" default 0"		//гор. вода
			+", FDRAIN "+ SqlType("CURRENCY") +" default 0"		//водоотведение
			+", FGAS"+ SqlType("CURRENCY") +" default 0"		//газ (и коню понятно)
			+", FELECTRIC"+ SqlType("CURRENCY") +" default 0"	//электроэнергия
			+", FOTHER "+ SqlType("CURRENCY") +" default 0"		//другое
			+", FSUBSERV "+ SqlType("CURRENCY") +" default 0"	//доп. услуги
			//оплаты
			+", FRENT_PAY"+ SqlType("CURRENCY") +" default 0"	//квартплата
			+", FHEAT_PAY"+ SqlType("CURRENCY") +" default 0"	//отопление
			+", FCOOL_PAY"+ SqlType("CURRENCY") +" default 0"	//хол. вода
			+", FHOT_PAY"+ SqlType("CURRENCY") +" default 0"	//гор. вода
			+", FDRAIN_PAY"+ SqlType("CURRENCY") +" default 0"	//водоотведение
			+", FGAS_PAY"+ SqlType("CURRENCY") +" default 0"	//газ
			+", FELECTRIC_PAY"+ SqlType("CURRENCY") +" default 0"	//электроэнергия
			+", FOTHER_PAY"+ SqlType("CURRENCY") +" default 0"	//другое
			+", FSUBSERV_PAY"+ SqlType("CURRENCY") +" default 0"//доп. услуги
			//объемы
			+", FHOTVOL"+ SqlType("DOUBLE") +" default 0"		//гор.
			+", FCOOLVOL"+ SqlType("DOUBLE") +" default 0" 		//хол.			
			+", FDRAINVOL"+ SqlType("DOUBLE") +" default 0"		//водоотведение			
			+", FHEATVOL"+ SqlType("DOUBLE") +" default 0"		//отопление
			+", FGASVOL"+ SqlType("DOUBLE") +" default 0"	 	//газ		
			+", FELECTRICVOL"+ SqlType("DOUBLE") +" default 0"	//электроэнергия
			//долги
			+", FRENT_DEBT"+ SqlType("CURRENCY") +" default 0"	//квартплата
			+", FHEAT_DEBT"+ SqlType("CURRENCY") +" default 0"	//отопление
			+", FCOOL_DEBT"+ SqlType("CURRENCY") +" default 0"	//хол. вода
			+", FHOT_DEBT"+ SqlType("CURRENCY") +" default 0"	//гор. вода
			+", FDRAIN_DEBT"+ SqlType("CURRENCY") +" default 0"	//водоотведение
			+", FGAS_DEBT"+ SqlType("CURRENCY") +" default 0"	//газ
			+", FELECTRIC_DEBT"+ SqlType("CURRENCY") +" default 0"	//электроэнергия
			+", FOTHER_DEBT"+ SqlType("CURRENCY") +" default 0"	//другое
			+", FSUBSERV_DEBT"+ SqlType("CURRENCY") +" default 0"//доп. услуги
			+")";			
	ExecuteSQL(sSql, false);
}

function getHouseNom(fwid_cl)
{
	var sNom = "";
	if(!fwid_cl)
		fwid_cl = houseID;
	var sSql = "select rel.fcod, h.fnom, h.fwid_cl from ^cl_house h "
				+" inner join ^clrelclcl rel on rel.fwid_cl=h.fwid_cl "
				+" where h.fwid_cl="+ fwid_cl;
	var oHs = getSnap(sSql, false);
	if(oHs!=null && oHs[1]!=null)
		sNom = oHs[1];
	return sNom;	
}

include("sys/DpList.js");