//-----------------------------------------------------------
//         Общая процедура расчета журнала ордера
//
//-----------------------------------------------------------
//' Режимы расчета журнала-ордера:
//'
// 1. OutTable [обязательный] - Выходная таблица
//'    Имя таблицы, в которую заносятся результаты расчета
//' 2. IsVed    [=false]       - Флаг расчета ведомости
//'    false=журнал-ордер, true=ведомость
//' 3. IsVal    [true]     - валютный ж-о
//'             [false]    -  ж-о в гривнях
//' 4. OutVal              - Выходная валюта
//              [=0]  - если IsVal, то в указ.валюте, !IsVal - в нац.валюте
//              [=-1] - в разных валютах с переводом итогов в гривни
//              [>0]  - с переводом в справочную валюту
//' 5. Detail   [=""]          - Детализация корреспондирующих счетов
//'    "u" - в разрезе субсчетов
//'    "t" - в разрезе статей
//'    "1", "2", "3" - в разрезе 1-й, 2-й или 3-й аналитик
//'    Например, Detail="ut1" - детализация по счету/субсчету/статье/ан.1
//' 6. Caption  [формируется]  - Заголовок окна
//'    Если явно не задан формируется исходя из перечисленных выше параметров.

include("sys//DpSQL.js");

function r_order(OutTable, Ved, Val, OutVal, Detail, Caption, dt1, dt2, sc, vl)
{
   
    
   IsVed = Ved!=null && Ved!="ORD";
   IsVal = Val!=null && Val!="GRN";

	setProgressRange(0, 6);
	var nPr = 0;

   if (OutVal==null)
      OutVal = 0;

   var dat1 = dt1;
   var dat2 = dt2;
   // Переменные sch_num, sub_num, sta_num -
   //  счет, субсчет, стать
   var sch_num = sc.getSc();
   var sub_num = sc.getSu();
   var sta_num = sc.getSt();
   var cl1_num = sc.getCl1();
   
   if (IsVal &&  OutVal==0)
      InVal = vl;
   else
      InVal = 0;
   
   var cdat1 = sqlTo(dat1);
   var cdat2 = sqlTo(dat2);

   // Переменная IsValFilter: есть ли условие на входную валюту
   if (IsVal && OutVal==0)
      IsValFilter=true;
   else
      IsValFilter=false;

   // Если установлен - детализация по валютам
   if ( Detail==null)
      Detail = "";

   var isSu, isSt, isCod1, isCod2, isCod3;
   isSu   = false;
   isSt   = false;
   isCod1 = false;
   isCod2 = false;
   isCod3 = false;

   for (var i=0; i<Detail.length; i++){
      if (Detail.substring(i,i+1)=="u") isSu=true;
      if (Detail.substring(i,i+1)=="t") isSt=true;
      if (Detail.substring(i,i+1)=="1") isCod1=true;
      if (Detail.substring(i,i+1)=="2") isCod2=true;
      if (Detail.substring(i,i+1)=="3") isCod3=true;
   }
   // Имена полей прямого счета
   var ScField, SuField, StField;
   // Имена полей корреспондирующих счетов
   var CorrScField, CorrSuField, CorrStField;
   var CorrCod1Field, CorrCod2Field, CorrCod3Field;
   if (IsVed){
      ScField = "fdb_sc";
      SuField = "fdb_su";
      StField = "fdb_st";
      Cl1Field= "fdb_cod1";
      CorrScField = "fcr_sc";
      CorrSuField = "fcr_su";
      CorrStField = "fcr_st";
      CorrCod1Field = "fcr_cod1";
      CorrCod2Field = "fcr_cod2";
      CorrCod3Field = "fcr_cod3";
   }else{
      ScField = "fcr_sc";
      SuField = "fcr_su";
      StField = "fcr_st";
      Cl1Field= "fcr_cod1";
      CorrScField = "fdb_sc";
      CorrSuField = "fdb_su";
      CorrStField = "fdb_st";
      CorrCod1Field = "fdb_cod1";
      CorrCod2Field = "fdb_cod2";
      CorrCod3Field = "fdb_cod3";
   }

   // Список полей
   var FieldsListAs, FieldsList, Fieldslist1;
   FieldsListAs = CorrScField + " AS fsc_corr ";
   if ( isSu)  FieldsListAs = FieldsListAs + ","+ CorrSuField + " AS fsu_corr ";
   if ( !isSu) FieldsListAs = FieldsListAs + "," + emptySu + " AS fsu_corr ";

   if ( isSt)  FieldsListAs = FieldsListAs + ","+ CorrStField + " AS fst_corr ";
   if ( !isSt) FieldsListAs = FieldsListAs + ","+ emptySc + " AS fst_corr ";

   if ( isCod1)  FieldsListAs = FieldsListAs + ","+ CorrCod1Field + " AS fcod1_corr ";
   if ( !isCod1) FieldsListAs = FieldsListAs + ","+ String(0) + " AS fcod1_corr ";

   if ( isCod2)  FieldsListAs = FieldsListAs + ","+ CorrCod2Field + " AS fcod2_corr ";
   if ( !isCod2) FieldsListAs = FieldsListAs + ","+ String(0) + " AS fcod2_corr ";

   if ( isCod3)  FieldsListAs = FieldsListAs + ","+ CorrCod3Field + " AS fcod3_corr ";
   if ( !isCod3) FieldsListAs = FieldsListAs + ","+ String(0) + " AS fcod3_corr ";

   
   FieldsListAs = FieldsListAs
      + ", "+emptySc+" AS fsc_corr1"
      + ", "+emptySu+" AS fsu_corr1"
      + ", "+emptySt+" AS fst_corr1"
      + ", 0 AS fcod1_corr1"
      + ", 0 AS fcod2_corr1"
      + ", 0 AS fcod3_corr1";

    
   FieldsList = "fsc_corr, fsu_corr, fst_corr, fcod1_corr, fcod2_corr, fcod3_corr";
   FieldsList1 = "fsc_corr1, fsu_corr1, fst_corr1, fcod1_corr1, fcod2_corr1, fcod3_corr1";
   FieldInsert = FieldsList+","+FieldsList1;


   // Условие выбора проводок из журнала проводок
   // Включает в себя:
   // - условие на попадение даты в указанный период
   // - условие на исходный счет, субсчет, статью
   // - условие на входную валюту, если задана
   var CondSc, CondVal, CondFlt, Cond, Cond2;
   CondSc ="";
   CondVal="";
   CondFlt ="";
   CondFltNv ="";
   CondFltVl ="";
   CondSc = "(fdate between " + cdat1 + " and " + cdat2 + ")"
		+ " and " + ScField + " = " + String( sch_num );
	
   if(sub_num!=0)
		CondSc += " and " + SuField + " = " + String( sub_num );

   if(sta_num!=0)
		CondSc += " and " + StField + " = " + String( sta_num );

   if(cl1_num!=0)
		CondSc += " and " + Cl1Field + " = " + String( cl1_num );


   if (IsVal)
		CondVal = " and fwrk not in (12, 15)";
   else
		CondVal = " and fwrk<>16";


   //если валютный журнал, то отбираются только проводки по указанной валюте
   if (IsValFilter)
      CondFlt = " and fval = " + String ( InVal );
   else {
      CondFltNv = " and (fval=0 or fval is null)";
      CondFltVl = " and fval <>0";
   }

   if(IsValFilter)
      Cond = CondSc+CondVal+CondFlt;
   else{
      Cond  = CondSc+CondVal+CondFltVl;
      Cond2 = CondSc+CondVal+CondFltNv;
   }


   DropTable("tmp_order_1");
   DropTable("tmp_order_2");
   DropTable("tmp_order_3");
   DropTable("tmp_order_4");
   DropTable("tmp_order_5");
////////////////////////////////  
/*  if(IsTable("tmp_order_1") || IsTable("tmp_order_2") || IsTable("tmp_order_3") || IsTable("tmp_order_4") || IsTable("tmp_order_5"))
  {
				 alert("Невозможно выполнить расчет."
				 +"\nПроверьте, возможно окно с данным расчетом уже открыто,"
				 +"\nили перезапустите систему.");
				gdescape = true;
				CloseWindow();
				return !gdescape;
	}			*/
////////////////////////////////

	
	setProgressPos(++nPr);
	
	//фильтр на организацию
	var orgCond = "";
	if(getPar("BLNBYORG"))
		orgCond = " and Forg0="+CURRENT_ORG;

   // Выбор валютных проводок из журнала проводок
   var strSQL =
      "SELECT "+FieldsListAs
         + ", Fdate, Fsum, Fval, Fvkurs, 0 as Ftot, 0 as Fwid "
      + " INTO tmp_order_5 "
      + " FROM ^schet "
      + " WHERE " + Cond + orgCond;
   
   ExecuteSQL( strSQL );

   // Выбор проводок из журнала закрывающих проводок
   if( op_zakr(dat1, dat2) ){
      if (IsVal)
         ExecuteSQL(
            "INSERT INTO tmp_order_5 ("+FieldInsert+",Fdate, Fsum, Fval, Fvkurs, Ftot)"
               + "SELECT " + FieldsListAs
               + "," + "Fdate"
               + ", Fsum, Fval, Fvkurs"
               + ", 0 as Ftot "
            + "FROM ^schet_zr "
            + "WHERE " + Cond + orgCond
            );
   }

	setProgressPos(++nPr);

   //проводки переводятся по курсу,если невалютный журнал или валютный по всем валютам
   if (!IsVal || (IsVal && OutVal==-1))
   {
      // Перевод валютных проводок в гривни

      if (!IsVal)
	{
         ExecuteSQL(s=
            "SELECT Fsc_corr, Fsu_corr, Fst_corr"
					+ ", Fcod1_corr, Fcod2_corr, Fcod3_corr"
					+ ", Fsc_corr1, Fsu_corr1, Fst_corr1"
					+ ", Fcod1_corr1, Fcod2_corr1, Fcod3_corr1"
					+ ", Fdate"
					+ ", " + sqlRound("tmp_order_5.Fsum*" + IIF("fvkurs<>0", "fvkurs", sqlRate("tmp_order_5","Fval","Fdate")),2)
						+ " AS Fsum"
					+ ", Fval, 0 as Ftot "
				+ " INTO tmp_order_3 "
				+ " FROM tmp_order_5 "
				);
	}
      else
      {
			ExecuteSQL(
				"SELECT Fsc_corr, Fsu_corr, Fst_corr"
					+ ", Fcod1_corr, Fcod2_corr, Fcod3_corr"
					+ ", Fsc_corr1, Fsu_corr1, Fst_corr1"
					+ ", Fcod1_corr1, Fcod2_corr1, Fcod3_corr1"
					+ ", Fdate"
					+ ", tmp_order_5.Fsum*"+sqlRate("tmp_order_5","Fval","Fdate")
						+ " as Fsum"
					+ ", 0 as Fval, 1 as Ftot"
				+ " INTO tmp_order_3"
				+ " FROM tmp_order_5"
				+ " WHERE Fval<>0"
					+ " AND Fvkurs=0"
				);
			/*ExecuteSQL(
				"SELECT Fsc_corr, Fsu_corr, Fst_corr"
					+ ", Fcod1_corr, Fcod2_corr, Fcod3_corr"
					+ ", Fsc_corr1, Fsu_corr1, Fst_corr1"
					+ ", Fcod1_corr1, Fcod2_corr1, Fcod3_corr1"
					+ ", Fdate"
					+ ", tmp_order_5.Fsum*iif(Fval=0, 1, Fvkurs)"
						+ " as Fsum"
					+ ", 0 as Fval, 1 as Ftot"
				+ " INTO tmp_order_3"
				+ " FROM tmp_order_5"
				+ " WHERE Fval=0"
					+ " OR Fvkurs<>0"
				);*/
				ExecuteSQL("INSERT INTO tmp_order_3 ("+FieldInsert+",FDATE,FSUM,FVAL,FTOT)"
				+"SELECT Fsc_corr, Fsu_corr, Fst_corr"
					+ ", Fcod1_corr, Fcod2_corr, Fcod3_corr"
					+ ", Fsc_corr1, Fsu_corr1, Fst_corr1"
					+ ", Fcod1_corr1, Fcod2_corr1, Fcod3_corr1"
					+ ", Fdate"
					+ ", tmp_order_5.Fsum*"+IIF("Fval=0", "1", "Fvkurs")
						+ " as Fsum"
					+ ", 0 as Fval, 1 as Ftot"				
				+ " FROM tmp_order_5"
				+ " WHERE Fval=0"
					+ " OR Fvkurs<>0"
				);
		}
		
      
      // Выбор проводок в нац,валюте из журнала проводок
      if (Cond2!="")
      {
         var strSQL2 =
				"SELECT " + FieldsListAs
					+ ", Fdate, Fsum, Fval, 0 as Ftot " +
            " INTO tmp_order_4 " +
            " FROM ^schet " +
            " WHERE " + Cond2 + orgCond;
         ExecuteSQL( strSQL2 );
      }
      if (IsVal && OutVal==-1)
      {
         if (Cond2!="")
         {
            var strSQL2 = "INSERT INTO tmp_order_4 ("+FieldInsert+",FDATE,FSUM,FVAL,FTOT)"+
               "SELECT "+FieldsListAs + ", Fdate, Fsum, Fval, 1 as Ftot " +
               " FROM ^schet " +
               " WHERE " + Cond2 + orgCond;
            ExecuteSQL( strSQL2 );
         }
      }
	
      
      if( op_zakr(dat1, dat2) )
      {
         ExecuteSQL(
            "INSERT INTO tmp_order_4 ("+FieldInsert+",FDATE,FSUM,FVAL,FTOT)"
            + "SELECT " + FieldsListAs
               + ", Fdate, Fsum, Fval"
               + ", 0 as Ftot "
            + "FROM ^schet_zr "
            + "WHERE " + Cond2 + orgCond
            );
         
         if (IsVal && OutVal==-1)
         {
            ExecuteSQL(
               "INSERT INTO tmp_order_4 "
               + "SELECT " + FieldsListAs
                  + ", Fdate, Fsum, Fval"
                  + ", 1 as Ftot "
               + "FROM ^schet_zr "
               + "WHERE " + Cond2 + orgCond
               );
         }
      }

   }

	
      
	setProgressPos(++nPr);

   if (IsVal && OutVal==0){
      strSQL = " select * INTO tmp_order_1 from tmp_order_5 ";
      ExecuteSQL(strSQL);
   }

   if (IsVal && OutVal==-1)
   {
      strSQL = " select * INTO tmp_order_1 from tmp_order_5 ";
      ExecuteSQL(strSQL);

      strSQL = "INSERT INTO tmp_order_1 (" +FieldInsert+ ", Fdate, Fsum, Fval,Ftot) select " +FieldInsert+ ", Fdate, Fsum, Fval,Ftot from tmp_order_4 ";
      ExecuteSQL(strSQL);

      strSQL = "INSERT INTO tmp_order_1 (" +FieldInsert+ ", Fdate, Fsum, Fval,Ftot) "+
      "select " +FieldInsert+ ", Fdate, Fsum, Fval,Ftot from tmp_order_3 ";
      ExecuteSQL(strSQL);
   }
	

	
   if (!IsVal)
   {
      strSQL = " select * INTO tmp_order_1 from tmp_order_4 ";
      ExecuteSQL(strSQL);

      strSQL = "INSERT INTO tmp_order_1 (" +FieldInsert+ ", Fdate, Fsum, Fval,Ftot)"+ 
              "select " +FieldInsert+ ", Fdate, Fsum, Fval,Ftot from tmp_order_3 ";
      ExecuteSQL(strSQL);
   }

	setProgressPos(++nPr);

   if (!IsVal)
      strSQL=
			"UPDATE tmp_order_1"
			+ " SET Fsc_corr1=Fsc_corr"
				+ ", Fsu_corr1=Fsu_corr"
				+ ", Fst_corr1=Fst_corr"
				+ ", Fcod1_corr1=Fcod1_corr"
				+ ", Fcod2_corr1=Fcod2_corr"
				+ ", Fcod3_corr1=Fcod3_corr"
				+ ", Fval=0";
   else
      strSQL=
			"UPDATE tmp_order_1"
			+ " SET Fsc_corr1=Fsc_corr"
				+ ", Fsu_corr1=Fsu_corr"
				+ ", Fst_corr1=Fst_corr"
				+ ", Fcod1_corr1=Fcod1_corr"
				+ ", Fcod2_corr1=Fcod2_corr"
				+ ", Fcod3_corr1=Fcod3_corr";
   ExecuteSQL(strSQL);

	setProgressPos(++nPr);

   strSQL =
      "SELECT "+ FieldsList1
         + ", Fdate"
         + ", SUM( tmp_order_1.Fsum ) as fsum"
         + ", fval, ftot, 0 as Fwid"
      + " INTO tmp_order_2"
      + " FROM tmp_order_1"
      + " GROUP BY " + FieldsList1 +
         ", fval, fdate, ftot ";

   // Суммирование по ячейкам
   ExecuteSQL( strSQL);

	setProgressPos(++nPr);

   // Таблица с результирующими цифрами
   var ResTable;
   ResTable = "tmp_order_2";

	
   // Подбивка сумм по 2-й аналитике
   if (isCod3)
   {
      strSQL =
         "INSERT INTO " + ResTable+" (Fsc_corr1, Fsu_corr1, Fst_corr1, Fcod1_corr1, Fcod2_corr1, Fcod3_corr1,"
         +" fsum, fval, fdate, fwid) "
         + " SELECT Fsc_corr1, Fsu_corr1, Fst_corr1"
            + ", Fcod1_corr1, Fcod2_corr1, "
            + sqlTo(cl_sup) + " as Fcod3_corr1"
            + ", SUM( A.Fsum ) as fsum"
            + ", fval, fdate"
            + ", 0 as Fwid "
         + " FROM tmp_order_1 A "
         + " WHERE fcod3_corr1 <> 0 "
         + " GROUP BY " +
            "A.Fsc_corr1, A.fsu_corr1, A.fst_corr1, " +
            "A.fcod1_corr1, A.fcod2_corr1, " +
            "A.fval, A.fdate, A.ftot ";
      
      ExecuteSQL( strSQL );
   }


   // Подбивка сумм по 1-й аналитике
   if (isCod2){
      ExecuteSQL(
         "INSERT INTO " + ResTable + " (Fsc_corr1, Fsu_corr1, Fst_corr1, Fcod1_corr1, Fcod2_corr1, Fcod3_corr1,"
         +" fsum, fval, fdate, ftot, fwid) "
         + " SELECT " +
                "Fsc_corr1, Fsu_corr1, Fst_corr1," +
                "Fcod1_corr1, " +
                sqlTo(cl_sup)+" as Fcod2_corr1, " +
                sqlTo(cl_sup)+" as Fcod3_corr1, " +
                "SUM( A.Fsum ) as fsum, " +
                "fval, fdate, ftot, 0 as fwid " +
         "FROM tmp_order_1 A " +
         "WHERE fcod2_corr1 <> 0 " +
         "GROUP BY " +
                "A.Fsc_corr1, A.fsu_corr1, A.fst_corr1, " +
                "A.fcod1_corr1 " +
                "A.fval, A.fdate, A.ftot " );
   }

   // Подбивка сумм по статье
   if (isCod1){
     ExecuteSQL( "INSERT INTO " + ResTable + " (Fsc_corr1, Fsu_corr1, Fst_corr1, Fcod1_corr1, Fcod2_corr1, Fcod3_corr1,"
         +" fsum, fval, fdate, ftot, fwid) " +
            "SELECT " +
                   "Fsc_corr1, " +
                   "Fsu_corr1, " +
                   "Fst_corr1," +
                   sqlTo(cl_sup)+" as Fcod1_corr1, " +
                   sqlTo(cl_sup)+" as Fcod2_corr1, " +
                   sqlTo(cl_sup)+" as Fcod3_corr1, " +
                   "SUM( A.Fsum ) as fsum, " +
                   "fval, fdate, ftot, 0 as fwid " +
            "FROM tmp_order_1 A " +
            "WHERE " +
                   "fcod1_corr1 <> 0 " +
            "GROUP BY " +
                   "A.Fsc_corr1, A.fsu_corr1, A.fst_corr1, " +
                   "A.fval, A.fdate, A.ftot " );
   }

 
   // Подбивка сумм по субсчетам
   if (isSt){
      ExecuteSQL( "INSERT INTO " + ResTable + " (Fsc_corr1, Fsu_corr1, Fst_corr1, Fcod1_corr1, Fcod2_corr1, Fcod3_corr1,"
         +" fsum, fval, fdate, ftot,fwid) " +
             "SELECT " +
                    "Fsc_corr1, " +
                    "Fsu_corr1, " +
                    sql_st_sup+" as Fst_corr1," +
                    sqlTo(cl_sup)+" as Fcod1_corr1, " +
                    sqlTo(cl_sup)+" as Fcod2_corr1, " +
                    sqlTo(cl_sup)+" as Fcod3_corr1, " +
                    "SUM( A.Fsum ) as fsum, " +
                    "fval, fdate, ftot, 0 as fwid " +
             "FROM tmp_order_1 A " +
             "WHERE " +
                    "fst_corr1 <> " + emptySt +
             " GROUP BY " +
                    "A.Fsc_corr1, A.fsu_corr1, " +
                    "A.fval, A.fdate, A.ftot " );
   }

   
		
	
   // Подбивка сумм счетам
   if (isSu){
     ExecuteSQL( "INSERT INTO " + ResTable + " (Fsc_corr1, Fsu_corr1, Fst_corr1, Fcod1_corr1, Fcod2_corr1, Fcod3_corr1,"
         +" fsum, fval, fdate, ftot, fwid) " +
            "SELECT " +
                   "Fsc_corr1, " +
                   sql_su_sup+" as Fsu_corr1, " +
					sql_st_sup+" as Fst_corr1," +
                   sqlTo(cl_sup)+" as Fcod1_corr1, " +
                   sqlTo(cl_sup)+" as Fcod2_corr1, " +
                   sqlTo(cl_sup)+" as Fcod3_corr1, " +
                   "SUM( A.Fsum ) as fsum, " +
                   "fval, fdate, Ftot , 0 as fwid " +
            "FROM tmp_order_1 A " +
            "WHERE " +
                   "fsu_corr1  <> 0 " +
            "GROUP BY " +
                   "A.Fsc_corr1, " +
                   "A.fval, A.fdate, A.ftot ");
   }

  
   
   // Подбивка итоговых сумм по строке
   ExecuteSQL( "INSERT INTO " + ResTable + " (Fsc_corr1, Fsu_corr1, Fst_corr1, Fcod1_corr1, Fcod2_corr1, Fcod3_corr1,"
         +" fsum, fval, fdate, ftot, fwid) " +
     "SELECT " +
            sql_sc_sup+" as Fsc_corr1, " +
            sql_su_sup+" as Fsu_corr1, " +
            sql_st_sup+" as Fst_corr1," +
            sqlTo(cl_sup)+" as Fcod1_corr1, " +
            sqlTo(cl_sup)+" as Fcod2_corr1, " +
            sqlTo(cl_sup)+" as Fcod3_corr1, " +
            "SUM( A.Fsum ) as fsum, " +
            "fval, fdate, ftot , 0 as fwid " +
     "FROM tmp_order_1 A " +
     "WHERE " +
            "Fsc_corr1<>0 " +
     "GROUP BY " +
            "A.fval, A.fdate, A.ftot " );

   oDate = new Date(01/01/3000);
   
  
   if (true)
   {
      // Подбивка итогов по дням
      ExecuteSQL( "INSERT INTO " + ResTable + " (" +FieldsList1+", fsum, Fdate, ftot, fval,fwid) "+
        "SELECT " + FieldsList1 + ", " +
               "SUM( A.fsum ) as fsum,"+sqlMaxDate+" as Fdate, ftot, fval ,0 as fwid " +
        "FROM " + ResTable + " A " +
        "GROUP BY " + FieldsList1 + ", fval, ftot" );
   }

	  
   DropTable(OutTable + "_S");
   DropTable(OutTable + "_R");
   DropTable(OutTable + "_C");

 
   // Выражения идентифицирующие строку и столбец по основной таблице
   var RowIdExpr, ColIdExpr;
   ColIdExpr = SqlConCat(Convert("fsc_corr1","NVARCHAR",10),"'@'",
		Convert("fsu_corr1","NVARCHAR",10),"'@'",
		Convert("fst_corr1","NVARCHAR",10),"'@'",
		Convert("fcod1_corr1","NVARCHAR",10),"'@'",
		Convert("fcod2_corr1","NVARCHAR",10),"'@'",
		Convert("fcod3_corr1","NVARCHAR",10))

   RowIdExpr = SqlConCat(sqlDatToStr("fdate"),"'@'",Convert("ftot","NVARCHAR",15),"'@'",Convert("fval", "NVARCHAR", 15));

   ExecuteSQL(
      "SELECT " + "FSUM as fValue"
         + ", " + ColIdExpr + " as FCOLID"
         + ", " + RowIdExpr + " as FROWID, 0 as Fwid "
      + "INTO " + OutTable + "_S "
      + "FROM " + ResTable
      );

   
   var subSql = IIF("ftot=1",SqlConCat("\'Итого за \'",sqlDatToStr("fDate")),sqlDatToStr("fDate"));
  
	
	ExecuteSQL(
      "SELECT DISTINCT " + RowIdExpr + " as FROWID, "
         + "fDate, Ftot, Fval, "
         + sqlVtxt("tmp_order_2", "Fval")+ " as Fvtxt, "
         + IIF("fDate="+sqlMaxDate, "\'Итого\'", subSql)
         + " as FTXT"
      + " INTO " + OutTable + "_R "
      + "FROM " + ResTable + " "
      + "ORDER BY fdate, ftot, fval"
      );

	ExecuteSQL(
		"ALTER TABLE " + OutTable + "_R"
		+ " ADD fwid "+SqlType("COUNTER")
		);

   ExecuteSQL(
      "SELECT DISTINCT " + ColIdExpr + " as FCOLID, "
         + "fsc_corr1, fsu_corr1, fst_corr1, "
         + "fcod1_corr1, fcod2_corr1, fcod3_corr1 "
      + "INTO " + OutTable + "_C "
      + "FROM " + ResTable + " "
      + "ORDER BY fsc_corr1, fsu_corr1, fst_corr1, fcod1_corr1, fcod2_corr1, fcod3_corr1"
      );
   
   ExecuteSQL(
      "ALTER TABLE " + OutTable + "_C ADD Fwid "+SqlType("COUNTER")
      )

//-      ExecuteSQL("CREATE INDEX RowCol " +
//-         "ON " + OutTable + "_s (FrowId, FcolId)");
	if (SUBD == ORACLE || SUBD == DERBY)
	{
		ExecuteSQL("DROP INDEX RowCol", false);
	}
	createIndex(OutTable,"RowCol","FrowId, FcolId");

	setProgressPos(0);

	return true;
   
}


//Функция, возвращающая сокр.название валюты в SQL-запросах
function sqlVtxt(strTable, strValField)
{
    if(strValField==null) 
		strValField = "fval";	

    var query = "( SELECT "+Convert("^cl_valut.Fnazvs","NVARCHAR")+" FROM ^cl_valut WHERE "+
		strTable + "." + strValField + " = fkod"+" )";
    return IIF(query+" is null",Convert("'ГРН '","NVARCHAR"),query);
}