// расчет реестра ОС 1-й группы, чья остат. стоимость
// достигла 1700 грн. и была перенесена в износ
include("servis/date.js");

function r_os1700(mdate)
{
	// чтобы ExecuteSQL() не выводил свой WAIT()
	var label = "OS1700";

	//  Имя таблицы
	// var tblOut = label+month_txt(list.objAsk.fdat);
	var tblOut = label;

	// 1) Отберем строки по амортизации в расчетном квартале
	//	 для ОС 1-й группы, по к-м в расчетном квартале не
	//	 начислялась амортизация
	var sTmpName1 = tblOut+"_1";
	// удалим рез-ты предыдущего расчета
	if(IsTable(sTmpName1))
		DropTable(sTmpName1);
	var strSQL = "SELECT * INTO "+sTmpName1+" FROM ^RAMORTI "
		+" WHERE FDATKV="+sqlTo(firstkv(mdate))
		+" AND FGROUP=1"
		+" AND FKOMPL=0"
		+" AND FAMORT=0";
	ExecuteSQL(strSQL);
  
	// 2) Отберем строки по амортизации в предыдущем квартале
	//	 для ОС 1-й группы, по к-м начислялась амортизация
	var sTmpName2 = tblOut+"_2";
	// удалим рез-ты предыдущего расчета
	if(IsTable(sTmpName2))
		DropTable(sTmpName2);
	var strSQL = "SELECT * INTO "+sTmpName2+" FROM ^RAMORTI "
		+" WHERE FDATKV="+sqlTo( firstkv( goDay( firstkv(mdate),-3 ) ) )
		+" AND FGROUP=1"
		+" AND FKOMPL=0"
		+" AND FAMORT<>0";
	ExecuteSQL(strSQL);

	// 3) Отберем из sTmpName2 инв.номера 
	var sTmpInvName2 = tblOut+"_inv_2";
	// удалим рез-ты предыдущего расчета
	if(IsTable(sTmpInvName2))
		DropTable(sTmpInvName2);
	var strSQL = "SELECT DISTINCT FINV_NUM"
		+" INTO "+sTmpInvName2
		+" FROM "+sTmpName2
	ExecuteSQL(strSQL);

	// 4) Отберем из OS4 инв.номера, к-е были ликвидированы до firstkv(mdate)
	var sTmpInvOS4 = tblOut+"_inv_OS4";
	// удалим рез-ты предыдущего расчета
	if(IsTable(sTmpInvOS4))
		DropTable(sTmpInvOS4);
	var strSQL = "SELECT DISTINCT FINV_NUM"
		+" INTO "+sTmpInvOS4
		+" FROM ^OS4"
		+" WHERE ^OS4.FDOC_DAT<"+sqlTo(firstkv(mdate))
	ExecuteSQL(strSQL);

	// 5) Отберем из sTmpName1 в tblOut инв.номера, которые
	// есть в sTmpInvName2 или у кого FPRIB>0
	// и которых нет в sTmpInvOS4
	// Таким образом в tblOut окажутся строки по
	// тем ОС, по которым в текущем квартале перестала начисляться
	// амортизация, а также вновь прибывшие с остат. стоимостью < 1700
	// и те, которые уже были в полном износе, но в расчетном
	// квартале были дооценены на сумму < 1700
	// В том числе отберутся и те ОС, которые переводятся из 1-й группы
	var sTmpName3 = tblOut+"_3";

	// удалим рез-ты предыдущего расчета
	if(IsTable(sTmpName3))
		DropTable(sTmpName3);
	strSQL = "SELECT *"
		+" INTO "+sTmpName3
		+" FROM "+sTmpName1
		+" WHERE FINV_NUM IN(SELECT FINV_NUM FROM "+sTmpInvName2+")"
		+" AND FINV_NUM NOT IN(SELECT FINV_NUM FROM "+sTmpInvOS4+")"
		+" OR FPRIB>0";
	ExecuteSQL(strSQL);

	// Теперь проставим группу, которая у данного ОС на firstkv(mdate)
	strSQL = "UPDATE "+sTmpName3
		  +" SET FGROUP=(SELECT FGROUP FROM ^OS0 WHERE "+sTmpName3+".FINV_NUM=^OS0.FINV_NUM"
							+" AND ^OS0.FBDAT<="+sqlTo(firstkv(mdate))+" AND ^OS0.FEDAT>="+sqlTo(firstkv(mdate))+")"
		  +" WHERE EXISTS (SELECT FGROUP FROM ^OS0 WHERE "+sTmpName3+".FINV_NUM=^OS0.FINV_NUM"
							+" AND ^OS0.FBDAT<="+sqlTo(firstkv(mdate))+" AND ^OS0.FEDAT>="+sqlTo(firstkv(mdate))+")";
	ExecuteSQL(strSQL);
  
	//И, наконец, отберем в tblOut только то, что касается 1-й группы
	//удалим рез-ты предыдущего расчета
	if(IsTable(tblOut))
		DropTable(tblOut);
	strSQL = "SELECT *"
		+" INTO "+tblOut
		+" FROM "+sTmpName3
		+" WHERE FGROUP=1";
	ExecuteSQL(strSQL);

	// Теперь надо в поле FBALST проставить стоимость, которая была перенесена
	// в износ. Для тех ОС, у кого была строка в предыдущем квартале по 1-й гр.,
	// мы берем разницу между полями FIZNOS в соседних строках,
	// а для тех, по кому не было - сложнее. Это или приход, или изменение
	// группы. В любом случае в поле FPRIB проставляется остаточная стоимость

	// а) для тех, кто был в 1-й группе в предыд. квартале
	// strSQL = "UPDATE "+tblOut+" AS DST SET DST.FBALST=(SELECT DST.FIZNOS-SRC.FIZNOS FROM "+sTmpName2+" AS SRC "
	//		 	+" WHERE SRC.FINV_NUM=DST.FINV_NUM)"
	//			" WHERE EXISTS (SELECT DST.FIZNOS-SRC.FIZNOS FROM "+sTmpName2+" AS SRC WHERE SRC.FINV_NUM=DST.FINV_NUM)";
	strSQL = "UPDATE "+tblOut+" SET Fbalst = Fiznos-(SELECT Fiznos FROM "
						+sTmpName2+" WHERE Finv_num="+tblOut+".Finv_num) "
	ExecuteSQL(strSQL);

	// б) для тех, кто пришел в 1-ю группу
	strSQL = "UPDATE "+tblOut+" SET FBALST=FBALST+FPRIB-FVIB";
	ExecuteSQL(strSQL);

	// в) обнулим ненужные поля
	strSQL = "UPDATE "+tblOut+" SET FPRIB=0, FVIB=0";
	ExecuteSQL(strSQL);
	return;
}