/*
	Расчет полей сальдо
	11.12.98 - DAE
	04.01.2001 - DAE: перевод на SQL

	параметр resetSum - false: проверка корректности без переустановки сумм
	                    true:  установить расчетные суммы
*/

include("sys\\kursval.js");
include("sys\\dbase.js");
include("TrnNBln.js");

function r_sld(resetSum, nSc)
{
	cVid = new DpSc(list.tbl.getValue("fsc")).getVid(); // вид счета

	makeItog("A2", cVid, resetSum);	
	makeItog("A1", cVid, resetSum);	
	makeItog("ST", cVid, resetSum);	
	makeItog("SU", cVid, resetSum);	
	makeItog("SC", cVid, resetSum);	
}

function makeItog(mode, cVid, resetSum)
{
	var cFields,selFields, cGroup, cWhere, cTrnVid = cVid;
	switch(mode)
	{
	case "SC":
		cGroup = "fsc";
		cFields = "0 as fsu, 0 as fst, 0 as fcl_cod1, 0 as fcl_cod2, 0 as fcl_cod3";
		selFields = "fsu, fst, fcl_cod1, fcl_cod2, fcl_cod3";
		cWhere = "(fsu<>0 AND fst=0 AND fcl_cod1=0)"
			+ " OR (fsu=0 AND fst<>0 AND fcl_cod1=0)"
			+ " OR (fsu=0 AND fst=0 AND fcl_cod1<>0 AND fcl_cod2=0)";
		break;
	case "SU":
		cGroup = "fsc, fsu";
		cFields = "0 as fst, 0 as fcl_cod1, 0 as fcl_cod2, 0 as fcl_cod3";
		selFields = "fst, fcl_cod1, fcl_cod2, fcl_cod3";
		cWhere = "(fst<>0 AND fcl_cod1=0)"
			+ " OR (fst=0 AND fcl_cod1<>0 AND fcl_cod2=0)";
		break;
	case "ST":
		cGroup = "fsc, fsu, fst";
		cFields = "0 as fcl_cod1, 0 as fcl_cod2, 0 as fcl_cod3";
		selFields = "fcl_cod1, fcl_cod2, fcl_cod3";
		cWhere = "fcl_cod1<>0 AND fcl_cod2=0";
		break;
	case "A1":
		cGroup = "fsc, fsu, fst, fcl_cod1";
		cFields = "0 as fcl_cod2, 0 as fcl_cod3";
		selFields = "fcl_cod2, fcl_cod3";
		cWhere = "fcl_cod2<>0 AND fcl_cod3=0";
		if(cVid=="%")
			cTrnVid = "*";
		break;
	case "A2":
		cGroup = "fsc, fsu, fst, fcl_cod1, fcl_cod2";
		cFields = "0 as fcl_cod3";
		selFields = "fcl_cod3";
		cWhere = "fcl_cod3<>0";
		if(cVid=="%")
			cTrnVid = "*";
		break;
	}
	cGroup += ", fdate"

	var fsumd = "SUM("+IIF("fistotal="+sqlTrue,"a.fsumd2", "a.fsumd")+")";
	var fsumk = "SUM("+IIF("fistotal="+sqlTrue,"a.fsumk2", "a.fsumk")+")";
	
	var sumd = ((cTrnVid=="+")? fsumd + "-" + fsumk: 
				((cTrnVid=="-")? "0": 
				((cTrnVid=="*")? IIF(fsumd + ">" + fsumk,
						fsumd + "-" + fsumk , "0"): 
				fsumd)));	
	
	var sumk = ((cTrnVid=="+")? "0": 
				((cTrnVid=="-")? fsumk + "-" + fsumd : 
				((cTrnVid=="*")? IIF(fsumk + ">" + fsumd,
						fsumk + "-" + fsumd , "0"): 
				fsumk)));
	
	DropTable("tmp_edsld_1");
	ExecuteSQL(
		"SELECT " + cGroup + ", fval, fvkurs"
			+ ", " + sumd + " AS fsumd"
			+ "," + cFields
			+ ", " + sumk + " AS fsumk"
		+ " INTO tmp_edsld_1"
                + " FROM tmp_edsld a"
		+ " WHERE " + cWhere	
		+ " GROUP BY " + cGroup + ", fval, fvkurs"
		);
		
	var fsumd = "SUM(a.fsumd)";
	var fsumk = "SUM(a.fsumk)";
	
	var sumd = ((cTrnVid=="+")? fsumd + "-" + fsumk: 
				((cTrnVid=="-")? "0": 
				((cTrnVid=="*")? IIF(fsumd + ">" + fsumk, 
							fsumd + "-" + fsumk , "0"): 
				fsumd)));	
	
	var sumk = ((cTrnVid=="+")? "0": 
				((cTrnVid=="-")? fsumk + "-" + fsumd : 
				((cTrnVid=="*")? IIF(fsumk + ">" + fsumd,
							fsumk + "-" + fsumd , "0"): 
				fsumk)));
	
	DropTable("tmp_edsld_2");
	// Выбор записей по одной валюте
	ExecuteSQL(
		"SELECT " + cGroup 
			+ "," + cFields
			+ ", max(a.fval) as fval"
			+ ", max(a.fvkurs) as fvkurs"
			+ "," + sumd + " AS fsumd"
			+ ", " + sumk + " AS fsumk"
		+ " INTO tmp_edsld_2"
		+ " FROM tmp_edsld_1 a "
		+ " WHERE a.fsumd<>0 OR a.fsumk<>0"
		+ " GROUP BY " + cGroup
		+ " HAVING max(fval)=min(fval)"
			+ " AND max(fvkurs)=min(fvkurs)"
		);
	
	var fsumd = "SUM("
		+ sqlRound(
			IIF("a.fvkurs<>0", "a.fvkurs"
				, IIF("k.fkurs IS NULL", "1", "k.fkurs")
				)+ "*a.fsumd"
			,2)
			+")";
	var fsumk = "SUM("
		+ sqlRound(IIF("a.fvkurs<>0", "a.fvkurs"
			 , IIF("k.fkurs IS NULL", "1", "k.fkurs")
			 ) + "*a.fsumk"
			,2 )
		+")";
	
	var sumd = ((cTrnVid=="+")? fsumd + "-" + fsumk: 
				((cTrnVid=="-")? "0": 
				((cTrnVid=="*")? IIF(fsumd + ">" + fsumk,
						fsumd + "-" + fsumk , "0"): 
				fsumd)));	
	
	var sumk = ((cTrnVid=="+")? "0": 
				((cTrnVid=="-")? fsumk + "-" + fsumd : 
				((cTrnVid=="*")? IIF(fsumk + ">" + fsumd,
						fsumk + "-" + fsumd , "0"): 
				fsumk)));
				
	ExecuteSQL(
		"INSERT INTO tmp_edsld_2(" + cGroup + "," + selFields + ",fval,fvkurs,fsumd,fsumk) "
			+ "SELECT " + cGroup
			+ "," + cFields
			+ ", 0 AS fval"
			+ ", 0 AS fvkurs"
			+ ", " + sumd
					+ " AS fsumd"
			+ ", " + sumk
					+ " AS fsumk"
                + " FROM tmp_edsld_1 a"
			+ " LEFT JOIN ^kursval k"
				+ " ON a.fval = k.fkod"
					+ " AND (a.fdate BETWEEN k.fbdat AND k.fedat)"
		+ " WHERE a.fsumd<>0 OR a.fsumk<>0"
		+ " GROUP BY " + cGroup
		+ " HAVING max(fval)<>min(fval)"
			+ " OR max(fvkurs)<>min(fvkurs)"
	);

	if (SQL)
	{
			var sWhereAB = "tmp_edsld.fsc = b.fsc"
							+ " AND tmp_edsld.fsu = b.fsu "
							+ " AND tmp_edsld.fst = b.fst"
							+ " AND tmp_edsld.fcl_cod1 = b.fcl_cod1"
							+ " AND tmp_edsld.fcl_cod2 = b.fcl_cod2"
							+ " AND tmp_edsld.fcl_cod3 = b.fcl_cod3"
							+ " AND b.fsc IS NOT NULL";
		
			ExecuteSQL(s= 	"UPDATE tmp_edsld"
				+ " SET fsumd2 = (SELECT b.fsumd "
						+ " FROM tmp_edsld_2 b"
						+ " WHERE " + sWhereAB 
						+ ")"
					+ ", fsumk2 = (SELECT b.fsumk "
						+ " FROM tmp_edsld_2 b"
						+ " WHERE " + sWhereAB
						+ ")"
					+ ", fval2 = (SELECT b.fval "
						+ "FROM tmp_edsld_2 b"
						+ " WHERE " + sWhereAB
						 + ")"
					+ ", fvkurs2 = (SELECT b.fvkurs"
						+ " FROM tmp_edsld_2 b"
						+ " WHERE " + sWhereAB
						+ ")"
					+ ", fistotal = " + SqlTrue 
					+ (!resetSum? "": 
						", fsumd = (SELECT b.fsumd "
							+ " FROM tmp_edsld_2 b"
							+ " WHERE " + sWhereAB 
							+ ")"
						+ ", fsumk = (SELECT b.fsumk "
							+ " FROM tmp_edsld_2 b"
							+ " WHERE " + sWhereAB
							+ ")"
						+ ", fval = (SELECT b.fval "
							+ "FROM tmp_edsld_2 b"
							+ " WHERE " + sWhereAB
							 + ")"
						+ ", fvkurs = (SELECT b.fvkurs"
							+ " FROM tmp_edsld_2 b"
							+ " WHERE " + sWhereAB
							+ ")"
						)
				+ " WHERE EXISTS(SELECT b.fsumd "
						+ " FROM tmp_edsld_2 b"
						+ " WHERE " + sWhereAB
						+ ")"
						);

	}
	else
		ExecuteSQL(
		"UPDATE tmp_edsld"
			+ " LEFT JOIN tmp_edsld_2 b"
				+ " ON tmp_edsld.fsc = b.fsc"
					+ " AND tmp_edsld.fsu = b.fsu"
					+ " AND tmp_edsld.fst = b.fst"
					+ " AND tmp_edsld.fcl_cod1 = b.fcl_cod1"
					+ " AND tmp_edsld.fcl_cod2 = b.fcl_cod2"
					+ " AND tmp_edsld.fcl_cod3 = b.fcl_cod3"
			+ " SET tmp_edsld.fsumd2 = b.fsumd"
				+ ", tmp_edsld.fsumk2 = b.fsumk"
				+ ", tmp_edsld.fval2 = b.fval"
				+ ", tmp_edsld.fvkurs2 = b.fvkurs"
				+ (!resetSum? "":
					", tmp_edsld.fsumd = b.fsumd"
					+ ", tmp_edsld.fsumk = b.fsumk"
					+ ", tmp_edsld.fval = b.fval"
					+ ", tmp_edsld.fvkurs = b.fvkurs"
					)
				+ ", tmp_edsld.fistotal = " + SqlTrue
			+ " WHERE b.fsc IS NOT NULL"
		);
	
	ExecuteSQL(
		"INSERT INTO tmp_edsld(fsc, fsu, fst, fcl_cod1, fcl_cod2, fcl_cod3, fdate, fsumd2, fsumk2,fval2,fvkurs2" 
				+ ((!resetSum)? "":
						", fsumd"
						+ ",fsumk"
						+ ",fval"
						+ ",fvkurs"
					)
			+ ", fistotal)"
		+ " SELECT a.fsc, a.fsu, a.fst, a.fcl_cod1, a.fcl_cod2, a.fcl_cod3, a.fdate"
			+ ", a.fsumd AS fsumd2"
			+ ", a.fsumk AS fsumk2"
			+ ", a.fval AS fval2" 
			+ ", a.fvkurs AS fvkurs2" 
				+ ((!resetSum)? "":
						", a.fsumd AS fsumd"
						+ ", a.fsumk AS fsumk"
						+ ", a.fval AS fval"
						+ ", a.fvkurs AS fvkurs"
					)
			+ ", " + SqlTrue + " as fistotal"
                + " FROM tmp_edsld_2 a"
			+ " LEFT JOIN tmp_edsld b"
				+ " ON a.fsc = b.fsc"
					+ " AND a.fsu = b.fsu"
					+ " AND a.fst = b.fst"
					+ " AND a.fcl_cod1 = b.fcl_cod1"
					+ " AND a.fcl_cod2 = b.fcl_cod2"
					+ " AND a.fcl_cod3 = b.fcl_cod3"
		+ " WHERE b.fsc IS NULL"
		);
}



function _r_sld(resetSum)
{
	new _r_sld(resetSum);
}

var _r_sld_date;

function _r_sld(resetSum)
{
	this.resetSum = resetSum==null? false: resetSum;

	this.writeItog = writeItog;
	this.insertItog = insertItog;

	this.tbl = OpenTable("s", "tmp_edsld", "schet_sl");
	if (SQL)
		this.tbl.Index = "FSC,FDATE,FSU,FST,FCL_COD1,FCL_COD2,FCL_COD3";

	var sc, fsc;
	var su, fsu;
	var st, fst;
	var a1, fa1;
	var a2, fa2;
	var a3, fa3;
	this.tbl.MoveLast();
	sc = 0;
	su = 0;
	st = 0;
	a1 = 0;
	a2 = 0;
	a3 = 0;
	
	_r_sld_date  = this.tbl.getValue("fdate");
	
	this.sch_vid = new DpSc(this.tbl.getValue("fsc")).getVid(); // вид счета
	
	this.scSum = new DpSumVal();
	this.suSum = new DpSumVal();
	this.stSum = new DpSumVal();
	this.a1Sum = new DpSumVal();
	this.a2Sum = new DpSumVal();
	//a3Sum = new DpSumVal();

	var isNotItog;
	var sum, sum2;
	
	while( true /*!this.tbl.IsBOF()*/ )
	{
		if(!this.tbl.IsBOF())
		{
			fsumd = this.tbl.getValue("fsumd");
			fsumk = this.tbl.getValue("fsumk");
			fval  = this.tbl.getValue("fval");
			fvkusr = this.tbl.getValue("fvkurs");
			fsc   = this.tbl.getValue("fsc");
			fsu   = this.tbl.getValue("fsu");
			fst   = this.tbl.getValue("fst");
			fa1   = this.tbl.getValue("fcl_cod1");
			fa2   = this.tbl.getValue("fcl_cod2");
			fa3   = this.tbl.getValue("fcl_cod3");
		}
		else
		{
			fsumd = 0;
			fsumk = 0;
			fval  = 0;
			fvkurs = 0;
			fsc   = 0;
			fsu   = 0;
			fst   = 0;
			fa1   = 0;
			fa2   = 0;
			fa3   = 0;
		}
		sum = new DpSumVal(fsumd, fsumk, fval, fvkurs);

		isNotItog = false;
		if(a3!=0)
			if(fsc==sc && fsu==su && fst==st && fa1==a1 && fa2==a2 && fa3!=a3)
				if(fa3==0)
					this.writeItog("a2", fsc, fsu, fst);
				else
					isNotItog = true;
			else
			{
				this.insertItog("a2", sc, su, st, a1, a2);
				continue;
			}
		else if(a2!=0)
			if(fsc==sc && fsu==su && fst==st && fa1==a1 && fa2!=a2)
				if(fa2==0)
					this.writeItog("a1", fsc, fsu, fst);
				else
					isNotItog = true;
			else
			{
				this.insertItog("a1", sc, su, st, a1);
				continue;
			}
		else if(a1!=0)
			if(fsc==sc && fsu==su && fst==st && fa1!=a1)
				if(fa1==0)
					if(fst!=0)
						this.writeItog("st", fsc, fsu, fst);
					else if(fsu!=0)
						this.writeItog("su", fsc, fsu, fst, "st");
					else
						this.writeItog("sc", fsc, fsu, fst, "st");
				else
					isNotItog = true;
			else
			{
				this.insertItog("st", sc, su, st);
				continue;
			}
		else if(st!=0)
			if(fsc==sc && fsu==su && (fst!=st || fa1!=a1))
				if(fst==0)
					this.writeItog("su", fsc, fsu, fst);
				else
					isNotItog = true;
			else
			{
				this.insertItog("su", sc, su);
				continue;
			}
		else if(su!=0)
			if(fsc==sc)
				if(fsu==0 && (fsu!=su || fst!=st || fa1!=a1))
					this.writeItog("sc", fsc, fsu, fst);
				else
					isNotItog = true;
			else
			{
				this.insertItog("sc", sc);
				continue;
			}
		else if(sc==0)
			isNotItog = true;
		else
			break;

		if(isNotItog)
		{
			if(this.tbl.getValue("fistotal"))
			{
				if(fa1)
				{
					this.tbl.Delete();
					this.tbl.MovePrev();
					continue;
				}
				sum.empty();
			}
			
			sum.turn(this.sch_vid=="%"? "*": this.sch_vid);
		
			if(fa3!=0)
			{
				this.a2Sum.add(sum);
				this.a2Sum.turn(this.sch_vid=="%"? "*": this.sch_vid);
			}
			else if(fa2!=0)
			{
				this.a1Sum.add(sum);
				this.a1Sum.turn(this.sch_vid=="%"? "*": this.sch_vid);
			}
			else if(fa1!=0)
			{
				this.stSum.add(sum);
				this.stSum.turn(this.sch_vid);
			}
			else if(fst!=0)
			{
				this.suSum.add(sum);
				this.suSum.turn(this.sch_vid);
			}
			else if(fsu!=0)
			{
				this.scSum.add(sum);
				this.scSum.turn(this.sch_vid);
			}
			if(sum.sumd!=fsumd || sum.sumk!=fsumk || this.tbl.getValue("fistotal"))
			{
				this.tbl.Edit();
				this.tbl.setValue("fsumd", sum.sumd);
				this.tbl.setValue("fsumk", sum.sumk);
				this.tbl.setValue("fistotal", false);
				this.tbl.Update();
			}
		}

		sc = this.tbl.getValue("fsc");
		su = this.tbl.getValue("fsu");
		st = this.tbl.getValue("fst");
		a1 = this.tbl.getValue("fcl_cod1");
		a2 = this.tbl.getValue("fcl_cod2");
		a3 = this.tbl.getValue("fcl_cod3");
		this.tbl.MovePrev();
	}
}

function writeItog(type, fsc, fsu, fst, sumType)
{
	var sum = this[(sumType? sumType: type) + "Sum"];
	
	if(this.sch_vid=="*")
		sum.turn("*");
	
	switch(type)
	{
	case "a2":
		if(this.sch_vid=="%")
			sum.turn("*");
		this.a1Sum.add(sum);
		break;
	case "a1":
		if(this.sch_vid=="%")
			sum.turn("*");
		this.stSum.add(sum);
		break;
	case "st":
		if(fsu!=0)
		{
			this.suSum.add(sum);
			break;
		}
	case "su":
		this.scSum.add(sum);
	}
	
	this.tbl.Edit();
	if(this.resetSum)
	{
		this.tbl.setValue("fsumd", sum.sumd);
		this.tbl.setValue("fsumk", sum.sumk);
		this.tbl.setValue("fval", sum.val);
	}
	this.tbl.setValue("fdate", _r_sld_date);
	this.tbl.setValue("fsumd2", sum.sumd);
	this.tbl.setValue("fsumk2", sum.sumk);
	this.tbl.setValue("fval2", sum.val);
	this.tbl.setValue("fistotal", true);
	this.tbl.setValue("fid_doc", "");
	this.tbl.Update();
	sum.empty();
}

//function insertItog(type, sum, sc, su, st, a1, a2)
function insertItog(type/*, sum*/, sc, su, st, a1, a2)
{
	var sum = this[type + "Sum"];
	var state = getState(this.tbl);
	this.tbl.AddNew();
	this.tbl.setValue("fsc", sc);
	this.tbl.setValue("fsu", su==null? 0: su);
	this.tbl.setValue("fst", st==nul? tbl.getValue("fst") : st);
	this.tbl.setValue("fcl_cod1", a1==null? 0: a1);
	this.tbl.setValue("fcl_cod2", a2==null? 0: a2);
	this.tbl.setValue("fcl_cod3", 0);
	this.tbl.setValue("fdate", _r_sld_date);
	this.tbl.setValue("fwid", GetUID());
/*
	this.tbl("fsumd") = this.resetSum? sum.sumd: 0;
	this.tbl("fsumk") = this.resetSum? sum.sumk: 0;
	this.tbl("fval") = this.resetSum? sum.val: 0;
	this.tbl("fsumd2") = sum.sumd;
	this.tbl("fsumk2") = sum.sumk;
	this.tbl("fval2") = sum.val;
	this.tbl("fistotal") = true;
*/

	this.tbl.Update();
	//sum.empty();
	putState(this.tbl, state);
	// Становимся на только что добавленную запись
	this.tbl.MoveNext();
}

// Объект сумма дебет-кредит в валюте
function DpSumVal(sumd, sumk, val, vkurs)
{
	this.sumd = (sumd==null)? 0: sumd;
	this.sumk = (sumk==null)? 0: sumk;
	this.val = (val==null)? -1: val;
	this.vkurs = vkurs? vkurs: 0;
	this.add = DpSumVal_add;
	this.turn = DpSumVal_turn;
	this.empty = DpSumVal_empty;
}

function DpSumVal_add(sumval)
{
	if(this.val == -1) // пустая сумма
	{
		this.sumd = sumval.sumd;
		this.sumk = sumval.sumk;
		this.val  = sumval.val;
		this.vkurs = sumval.vkurs;
	}
	else if(sumval.val == this.val) // совпадают валюты
	{
		this.sumd += sumval.sumd;
		this.sumk += sumval.sumk;
	}
	else  // разные валюты
	{
		this.sumd = round(_nv2nv("", _r_sld_date, this.val, this.sumd, this.vkurs),2)
			+ round(_nv2nv("", _r_sld_date, sumval.val, sumval.sumd, this.vkurs),2);
		this.sumk = round(_nv2nv("", _r_sld_date, this.val, this.sumk, this.vkurs),2)
			+ round(_nv2nv("", _r_sld_date, sumval.val, sumval.sumk, this.vkurs),2);
		this.val = 0;
	}
}

// Сворачивание
function DpSumVal_turn(vid)
{
	switch(vid)
	{
	case "+":
		this.sumd = this.sumd - this.sumk;
		this.sumk = 0;
		break;
	case "-":
		this.sumk = this.sumk - this.sumd;
		this.sumd = 0;
		break;
	case "*":
		var sdk = this.sumd-this.sumk;
		this.sumd = Math.max(0, sdk);
		this.sumk = Math.max(0, -sdk);
		break;
	}
}

function DpSumVal_empty()
{
	this.sumd = this.sumk = 0;
	this.val = -1;
	this.vkurs = 0;
}