//Сальдовая ведомость по жэку

include("Objects/DpJRegistrator.js");

var jID = getPar("HOCPAYREG");	//журнал реестрации (по умолч. KU)
var tblOut = getTmpTableName();	//таблица с результатами
var tblSku = "RAS_SKU";			//таблица счетов за коммунальные услуги
var tblReg = null;				//таблица журнала регистрации
var label  = "VEDKU";			//метка для печати
var streetID;					//id улицы
var houseID;					//id дома
var lot;						//участок
var gek;						//ЖЭК
var platCod;
var rdat1;						//нач. дата расчета
var rdat2;						//кон. дата расчета

function listLoad()
{
	//this.xmlGridFile = "r_vedku.xml";
	this.printLabel = label;
	this.accDel = null;  	
}

function listDpGrid()
{
	grid.setXMLFile("r_vedku.xml");
	//grid.getColumn("FHOT").setCaption(UR("10й поверх|10й этаж"));
	//grid.getColumn("FGAS").setCaption(UR("Комора|Кладовка"));
	//grid.getColumn("FOTHER").setCaption(UR("Теплове навантаження"));
	grid.build();
}

function listTitle()
{
	var sCapt = ru("Сальдовая ведомость", "Сальдова відомість");
	
	var dat1 = list.objAsk.idat1;
	var dat2 = list.objAsk.idat2;
	var oStreet = list.objAsk.istreet;
	var oHouse = list.objAsk.ihouse;
	
	if(dat1)
		sCapt += " за "+ StrDat(dat1, "DMY") +" - "+ StrDat(dat2, "DMY");
	if(oStreet!=null && oStreet.getCod()!=0)
		sCapt += ": "+ oStreet.getTxt();
	if(oHouse!=null)
		sCapt += " "+ getHouseNom(oHouse.getFWID());
	
	return sCapt;
}

function listSrc()
{	
	this.qrySet("From", tblOut, "Order", "FSTREET, FHOUSE, FPLAT");
	
	//this.clTie("plt", "="+ getPar("CODPLAT") +", FPLAT", "a1");	
	this.subTie("cl", "str", "FWID", "FSTREET");
	this.subTie("cl_house", "hs", "FWID_CL", "FHOUSE");
	this.subTie("cl_apartment", "apt", "FWID_CL", "FAPMT");
	this.subTie("CONTRACT", "contr", "FWID", "FID_DOG");
}

function listAsk()
{
	var p = new Object();
	if(extPar)
		p = extPar;
	p.tblName = tblOut;
	p.label = label;
	p.lot = true;
	showWindow("i_vedku.xml", SW_MODAL, p);
	if (!p.escape)
    {
    	rdat1 = p.idat1;
	    rdat2 = p.idat2;
	    houseID = p.ihouse.getFWID();
	    streetID = p.istreet.getFWID();
	    platCod = p.iplat.getCod();
	    if(p.ilot)
	    	lot = p.ilot.getCod();
	    if(p.igek)
	    	gek = p.igek.getCod();
    }    
	return p;
}

function listMake()
{
	tblReg = hocRegTblName();
	var sSql = "select * from ^"+ tblReg +" where 1<>1";
	if(!lpProxy.getDBManager().testSQL(sSql))
	{
		var sMsg = UR("Не налагоджений журнал реєстрації оплат!"
					+"|Не настроен журнал регистрации оплат!")
		alert(sMsg);
		return false;
	}
	
	var nPr = 1;
	var sPrText = ru("Расчет...","Розрахунок...");
	setProgressRange(0, 7);
	setProgressPos(nPr++, sPrText);
	
	createOutTable();
	setProgressPos(nPr++, sPrText);
		
	var sFldSum = "FSUM";
	var sFldDat = "FDATE";
	var sFldOrg = "FORG";
	
	var tblLic = "LICSC"; 		 //таблица лицевых счетов
	var tblHs = "CL_HOUSE"; 	 //дома
	var tblApt = "CL_APARTMENT"; //квартиры
		
	var sWhere = " where 1=1 ";
	if(rdat1!=null && rdat2!=null)	//отбор за период
		sWhere += " and (sku.FDOC_DAT>="+ sqlTo(rdat1) 
				  +" and sku.FDOC_DAT<="+ sqlTo(rdat2) +")";
	if(streetID!=null)			//отбор по улице
		sWhere += " and hs.FSTREET="+ streetID;	
	if(houseID!=null)			//отбор по дому
		sWhere += " and hs.FWID_CL="+ houseID;
	if(lot)
		sWhere += " and hs.FLOT="+ lot;
	if(gek)
		sWhere += " and hs.FGEK="+ gek;
	if(platCod)					//отбор по плательщику
		sWhere += " and sku.FORG="+ platCod;	
	
	//сбрасываем все счета и оплаты по контрагентам в одну таблицу	
	var tblDept = tblOut +"_DEPT";
	ExecuteSQL("DROP TABLE "+ tblDept, false);
	ExecuteSQL("CREATE TABLE "+ tblDept 
				+"(FPLAT "+ SqlType("INT") 
				+", FID_DOG"+ SqlType("LONG") 
				+", FSUM"+ SqlType("CURRENCY") 
				+", FPLATSUM"+ SqlType("CURRENCY") +")"
				);
	
	var sumSku = IIF("r.FISSKU="+ sqlTrue, "r.FSUM_SKU", 0);
	var sumPlat = IIF("r.FISSKU="+ sqlFalse, "r.FSUM", 0);
	var sSql = "insert into "+ tblDept +"(FPLAT, FID_DOG, FSUM, FPLATSUM)"
				+" select r.FORG, r.FID_DOG, sum"+ sumSku +" as FSUM"
					+", sum"+ sumPlat +" as FPLATSUM"
				+" from ^"+ tblReg +" r "
				+(rdat1!=null? " where r.FDATE<"+ sqlTo(rdat1) : "")
				+" group by r.FORG, r.FID_DOG";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	//показания счетчиков
	var tblCounters = tblOut +"_COUNTERS";
	ExecuteSQL("DROP TABLE "+ tblCounters, false);
	ExecuteSQL("select * into "+ tblCounters
				+" from ^COUNTERS"
				+" where FDATE>="+ sqlTo(rdat1)
					+ (rdat2? " and FDATE<="+ sqlTo(rdat2) : "")
					+ (platCod? " and FORG="+ sqlTo(platCod) : "")
					+ (houseID? " and FHOUSE="+ sqlTo(houseID) : "")
					+" and FDIFFERENCE<>0"
				);
	
	var tblScore = tblOut +"_SCORE";	
	ExecuteSQL("DROP TABLE "+ tblScore, false);
	var sSql = "select FORG as FPLAT, FID_DOG"
					+", max(FDATE) as FDATE"
					+", max(FREGDATE) as FREGDATE"
					+", max("+ IIF("FSERV='HWATER'", "FPREVIOUS", "0") +") as FHOTPREV"
					+", max("+ IIF("FSERV='HWATER'", "FCURRENT", "0") +") as FHOTCUR"
					+", max("+ IIF("FSERV='HWATER'", "FDIFFERENCE", "0") +") as FHOTDIF"
					+", max("+ IIF("FSERV='CWATER'", "FPREVIOUS", "0") +") as FCOOLPREV"
					+", max("+ IIF("FSERV='CWATER'", "FCURRENT", "0") +") as FCOOLCUR"
					+", max("+ IIF("FSERV='CWATER'", "FDIFFERENCE", "0") +") as FCOOLDIF"
					+", max("+ IIF("FSERV='DRAIN' or FSERV='CDRAIN' or FSERV='HDRAIN'", "FPREVIOUS", "0") +") as FDRAINPREV"
					+", max("+ IIF("FSERV='DRAIN' or FSERV='CDRAIN' or FSERV='HDRAIN'", "FCURRENT", "0") +") as FDRAINCUR"
					+", max("+ IIF("FSERV='DRAIN' or FSERV='CDRAIN' or FSERV='HDRAIN'", "FDIFFERENCE", "0") +") as FDRAINDIF"
					+", max("+ IIF("FSERV='HEAT'", "FPREVIOUS", "0") +") as FHEATPREV"
					+", max("+ IIF("FSERV='HEAT'", "FCURRENT", "0") +") as FHEATCUR"
					+", max("+ IIF("FSERV='HEAT'", "FDIFFERENCE", "0") +") as FHEATDIF"
					+", max("+ IIF("FSERV='GAS'", "FPREVIOUS", "0") +") as FGASPREV"
					+", max("+ IIF("FSERV='GAS'", "FCURRENT", "0") +") as FGASCUR"
					+", max("+ IIF("FSERV='GAS'", "FDIFFERENCE", "0") +") as FGASDIF"
					+", max("+ IIF("FSERV='ELECTRIC'", "FPREVIOUS", "0") +") as FELECTRICPREV"
					+", max("+ IIF("FSERV='ELECTRIC'", "FCURRENT", "0") +") as FELECTRICCUR"
					+", max("+ IIF("FSERV='ELECTRIC'", "FDIFFERENCE", "0") +") as FELECTRICDIF"
				+" into "+ tblScore
				+" from "+ tblCounters
				+" group by FORG, FID_DOG";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	/*
	//объемы для квартир без счетчиков
	sSql = "insert into "+ tblScore
			+" (FPLAT, FID_DOG, FDATE, FHOTDIF, FCOOLDIF, FHEATDIF, FGASDIF, FELECTRICDIF) "
			+" select sku.FORG, sku.FID_DOG, sku.FDOC_DAT, sum(sku.FHOTDIF), sum(sku.FCOOLDIF), sum(sku.FHEATDIF), sum(sku.FGASDIF), sum(sku.FELECTRDIF) "
			+" from ^"+ tblSku +" as sku "
				+" left join "+ tblCounters +" c on c.FID_DOG=sku.FID_DOG and c.FORG is NULL"
			+" where sku.FDOC_DAT>="+ sqlTo(rdat1)
				+(rdat2? " and sku.FDOC_DAT<="+ sqlTo(rdat2) : "")
				+(platCod? " and sku.FORG="+ sqlTo(platCod) : "")
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	*/
	/*
	sSql = "delete from "+ tblScore
			+" where FID_DOG in (select sku.FID_DOG from ^"+ tblSku +" as sku "
					+" where sku.FDOC_DAT>=FDATE"
						+(rdat1? " and sku.FDOC_DAT<="+ sqlTo(rdat1) : "")
						+" and sku.FCOUNTER_INIT="+ sqlTrue 
					+")";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "insert into "+ tblScore
			+" (FPLAT, FID_DOG, FDATE, FHOT, FCOOL, FHEAT, FGAS, FELECTRIC) "
			+" select FORG, FID_DOG, FDOC_DAT, FHOT, FCOOL, FHEAT, FGAS, FELECTRIC "
			+" from ^"+ tblSku +" as sku "
			+" where FID_DOG not in (select FID_DOG from "+ tblScore +")"
				+(rdat1? " and sku.FDOC_DAT<="+ sqlTo(rdat1) : "")
				+" and sku.FCOUNTER_INIT="+ sqlTrue				
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	*/
	var sOutFld = "FTT, FSTREET, FHOUSE, FAPMT, FID_DOG, FPLAT"
				+", FLIVAREA, FLOGAREA, FBALAREA, FRENT_BILL"
				+", FRENT, FHEAT, FCOOL, FHOT, FWREMOV, FGAS"
				+", FELECTRIC, FTRASH, FOTHER, FSUBSERV"
				+", FDATE, FSUM, FSUB"
				+", FEXEMPT, FSUPPORT, FPLATSUM, FDEPT"
				+", FDOC, FNOP, FFIO, FAPMTNOM"
				+", FPERSKOL, FEXMPTKOL"
				+", FHOTVOL, FCOOLVOL, FHOTCUR, FCOOLCUR"
				+", FHOTPREV, FCOOLPREV"
				+", FDRAINVOL, FDRAINCUR, FDRAINPREV"
				+", FELECTRICVOL, FELECTRICCUR, FELECTRICPREV"
				+", FGASVOL, FGASCUR, FGASPREV"
				+", FHEATVOL, FHEATCUR, FHEATPREV"
				+", FRECALC, FPENALTY, FRENT_TARIF"
	
	//исходные данные по контрагентам
	var sSql = "INSERT INTO "+ tblOut +" ("+ sOutFld +")" 
				+" SELECT "+ sqlEmpStr +" as FTT, max(hs.FSTREET), max(lic.FHOUSE)"
					+", max(lic.FAPMT), sku.FID_DOG, sku.FORG "
					+", max(apt.FLIVAREA), max(apt.FLOGAREA), max(apt.FBALAREA)"
					//+", sum((apt.FLIVAREA+apt.FLOGAREA*0.5+apt.FBALAREA*0.3)*sku.FRENT) as FRENT_BILL"
					+", sum(sku.FRENTSUM+sku.FRENTEXT+sku.FRENTSUB) as FRENT_BILL"
					+", sum(sku.FRENTSUM) as FRENT"
					+", sum(sku.FHEATSUM) as FHEAT"
					+", sum(sku.FCOOLSUM) as FCOOL"
					+", sum(sku.FHOTSUM) as FHOT"
					+", sum(sku.FWREMOVSUM) as FWREMOV"
					+", sum(sku.FGASSUM) as FGAS"
					+", sum(sku.FELECTRICSUM) as FELECTRIC"
					+", sum(sku.FTRASHSUM) as FTRASH"
					+", sum(sku.FOTHERSUM) as FOTHER"
					+", sum(sku.FSUBSERV) as FSUBSERV"
					+","+ sqlD00//+", sku.FDOC_DAT as FDATE" 
					+", sum(sku.FSUM) as FSUM"
					+", sum(sku.FSUB) as FSUB"
					+", sum(sku.FEXT) as FEXEMPT"
					+", sum(sku.FSUPPORT) as FSUPPORT"
					+", 0"//+", "+ IIF(platSum +" is null", "0", platSum) +" as FPLATSUM"
					+", 0"//+", "+ IIF(dept +" is null", "0", dept) +" as FDEPT"
					+", '' as FDOC, 0 as FNOP"
					+", max(cl.FTXT) as FFIO, max(apt.FNOM)"
					+", max(lic.FPERSKOL) as FPERSKOL" 	//", 0 as FPERSKOL"
					+", max(lic.FEXTKOL) as FEXMPTKOL"	//", 0 as FEXMPTKOL"				
					+", sum(s.FHOTDIF) as FHOTVOL"
					+", "+ IIF("max(s.FCOOLDIF) is NULL", "max(sku.FCOOLDIF)", "sum(s.FCOOLDIF)") +" as FCOOLVOL"
					+", max(s.FHOTCUR) as FHOTCUR"
					+", max(s.FCOOLCUR) as FCOOLCUR"
					+", max(s.FHOTPREV) as FHOTPREV"
					+", max(s.FCOOLPREV) as FCOOLPREV"
					+", "+ IIF("max(s.FDRAINDIF) is NULL", "max(sku.FDRAINDIF)", "sum(s.FDRAINDIF)") +" as FDRAINVOL"
					+", max(s.FDRAINCUR) as FDRAINCUR"
					+", max(s.FDRAINPREV) as FDRAINPREV"				
					+", "+ IIF("max(s.FELECTRICDIF) is NULL", "max(sku.FELECTRDIF)", "sum(s.FELECTRICDIF)") +" as FELECTRICVOL"
					+", max(s.FELECTRICCUR) as FELECTRICCUR"
					+", max(s.FELECTRICPREV) as FELECTRICPREV"
					+", "+ IIF("max(s.FGASDIF) is NULL", "max(sku.FGASDIF)", "sum(s.FGASDIF)") +" as FGASVOL"
					+", max(s.FGASCUR) as FGASCUR"
					+", max(s.FGASPREV) as FGASPREV"
					+", "+ IIF("max(s.FHEATDIF) is NULL", "max(sku.FHEATDIF)", "sum(s.FHEATDIF)") +" as FHEATVOL"
					+", max(s.FHEATCUR) as FHEATCUR"
					+", max(s.FHEATPREV) as FHEATPREV"
					+", max(sku.FRECALC) as FRECALC"
					+", max(sku.FPENALTY) as FPENALTY"
					+", max(sku.FRENT) as FRENT_TARIF" 
				+" FROM ^"+ tblSku +" sku "
					+" INNER JOIN ^CLRELCLCL as rel ON rel.FCOD=sku.FORG and rel.FCL=0 "
					+" INNER JOIN ^CL as cl ON cl.FWID=rel.FWID_CL "
					+" INNER JOIN ^"+ tblLic +" as lic ON lic.FID_DOG=sku.FID_DOG "
					+" LEFT JOIN ^"+ tblApt +" as apt ON apt.FWID_CL=lic.FAPMT "
					+" INNER JOIN ^"+ tblHs +" as hs ON hs.FWID_CL=lic.FHOUSE "
					+" LEFT JOIN ^"+ tblScore +" as s ON s.FID_DOG=sku.FID_DOG "
				+ sWhere
				+ " group by sku.FID_DOG, sku.FORG";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	//ExecuteSQL("update "+ tblOut +" set FRENT_BILL=(FLIVAREA+FLOGAREA*0.5+FBALAREA*0.3)*FRENT_TARIF");
	//setProgressPos(nPr++, sPrText);
	
	var sSql = "update "+ tblOut
				+" set FDEPT=(select sum(d.FSUM-d.FPLATSUM)" 
					+" from "+ tblDept +" d "
					+" where d.FPLAT="+ tblOut +".FPLAT "
						+" and d.FID_DOG="+ tblOut +".FID_DOG"
					+" group by d.FPLAT, d.FID_DOG"
					+")"
				+" where exists (select d.FSUM-d.FPLATSUM" 
					+" from "+ tblDept +" d "
					+" where d.FPLAT="+ tblOut +".FPLAT"
						+" and d.FID_DOG="+ tblOut +".FID_DOG"
					+")";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	var sSql = "update "+ tblOut
				+" set FPLATSUM=(select sum(reg."+ sFldSum +")"
					+" from ^"+ tblReg +" reg "
					+" where reg."+ sFldOrg +"="+ tblOut +".FPLAT "
						+" and reg.FID_DOG="+ tblOut +".FID_DOG "
						+((rdat1!=null && rdat2!=null)? " and reg."+ sFldDat +">="+ sqlTo(rdat1) 
							+" and reg."+ sFldDat +" <="+ sqlTo(rdat2) 
						: " and reg."+ sFldDat +">="+ tblOut +".FDOC_DAT")
					+" group by reg."+ sFldOrg 
					+")"
				+" where exists (select reg."+ sFldSum
					+" from ^"+ tblReg +" reg "
					+" where reg."+ sFldOrg +"="+ tblOut +".FPLAT "
						+" and reg.FID_DOG="+ tblOut +".FID_DOG "
						+((rdat1!=null && rdat2!=null)? " and reg."+ sFldDat +">="+ sqlTo(rdat1) 
							+" and reg."+ sFldDat +" <="+ sqlTo(rdat2) 
						: " and reg."+ sFldDat +">="+ tblOut +".FDOC_DAT")
					+")";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
		
	//итоги
	ExecuteSQL("DROP TABLE "+ tblOut +"_ITOG", false);
	sFromFld = "0 as FAPMT, 0 as FID_DOG, 0 as FPLAT"
				+", sum(FLIVAREA) as FLIVAREA"
				+", sum(FLOGAREA) as FLOGAREA"
				+", sum(FBALAREA) as FBALAREA"
				+", sum(FRENT_BILL) as FRENT_BILL"
				+", sum(FRENT) as FRENT, sum(FHEAT) as FHEAT"
				+", sum(FCOOL) as FCOOL, sum(FHOT) as FHOT"
				+", sum(FWREMOV) as FWREMOV"
				+", sum(FGAS) as FGAS, sum(FELECTRIC) as FELECTRIC"
				+", sum(FTRASH) as FTRASH"
				+", sum(FOTHER) as FOTHER, sum(FSUBSERV) as FSUBSERV"
				+", "+ sqlTo(list.objAsk.rdate) +" as FDATE" 
				+", sum(FSUM) as FSUM, sum(FSUB) as FSUB"
				+", sum(FEXEMPT) as FEXEMPT, sum(FSUPPORT) as FSUPPORT"
				+", sum(FPLATSUM) as FPLATSUM, sum(FDEPT) as FDEPT"
				+", '' as FDOC"
				+", 0 as FNOP"
				+", '' as FFIO, '' as FAPMTNOM"
				+", sum(FPERSKOL) as FPERSKOL, sum(FEXMPTKOL) as FEXMPTKOL"
				+", sum(FHOTVOL) as FHOTVOL, sum(FCOOLVOL) as FCOOLVOL"
				+", 0 as FHOTCUR, 0 as FCOOLCUR"
				+", 0 as FHOTPREV, 0 as FCOOLPREV"
				+", sum(FDRAINVOL) as FDRAINVOL"
				+", 0 as FDRAINCUR, 0 as FDRAINPREV"
				+", sum(FELECTRICVOL) as FELECTRICVOL"
				+", 0 as FELECTRICCUR"
				+", 0 as FELECTRICPREV"
				+", sum(FGASVOL) as FGASVOL"
				+", 0 as FGASPREV"
				+", 0 as FGASCUR"
				+", sum(FHEATVOL) as FHEATVOL"
				+", 0 as FHEATCUR"
				+", 0 as FHEATPREV"
				+", sum(FRECALC) as FRECALC"
				+", sum(FPENALTY) as FPENALTY"
				+", 0 as FRENT_TARIF"
				
	//самая итоговая строка (по жэку)
	sSql = "select 'SUM' as FTT, 0 as FSTREET, 0 as FHOUSE, "+ sFromFld
			+" into "+ tblOut +"_ITOG from "+ tblOut;	
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);	
		
	//по домам 
	sSql = "insert into "+ tblOut +"_ITOG ("+ sOutFld +")"
			+" select 'HS' as FTT, FSTREET, FHOUSE, "+ sFromFld 
			+" from "+ tblOut
			+" group by FSTREET, FHOUSE";
	if(!houseID && !platCod)//если не по одному дому
		ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
				
	sSql = "INSERT INTO "+ tblOut +" ("+ sOutFld +")" 
			+" SELECT "+ sOutFld 
			+" FROM "+ tblOut +"_ITOG";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);	
			
	ExecuteSQL("update "+ tblOut +" set FBILLSUM=FSUM+FSUPPORT");
	setProgressPos(nPr++, sPrText);
	
	//сальдо
	sSql = "UPDATE "+ tblOut 
		+" SET FBBALANS=(FDEPT)"
			+", FEBALANS="+ sqlRound("FDEPT + FSUM - FPLATSUM", getPar("DECISUM"));
	ExecuteSQL(sSql);
	
	
	sSql = "UPDATE "+ tblOut 
		+" SET FCOOLPREV=0 "
		+" WHERE FCOOLPREV>FCOOLCUR";
	ExecuteSQL(sSql);
	
	sSql = "UPDATE "+ tblOut 
		+" SET FHOTPREV=0 "
		+" WHERE FHOTPREV>FHOTCUR";
	ExecuteSQL(sSql);
	
	sSql = "UPDATE "+ tblOut 
		+" SET FDRAINPREV=0 "
		+" WHERE FDRAINPREV>FDRAINCUR";
	ExecuteSQL(sSql);
	
	sSql = "UPDATE "+ tblOut 
		+" SET FHEATPREV=0 "
		+" WHERE FHEATPREV>FHEATCUR";
	ExecuteSQL(sSql);
	
	sSql = "UPDATE "+ tblOut 
		+" SET FGASPREV=0 "
		+" WHERE FGASPREV>FGASCUR";
	ExecuteSQL(sSql);
	
	sSql = "UPDATE "+ tblOut 
		+" SET FELECTRICPREV=0 "
		+" WHERE FELECTRICPREV>FELECTRICCUR";
	ExecuteSQL(sSql);
	
	setProgressPos(0);
}

function createOutTable(sTblName)
{
	if(!sTblName)
		sTblName = tblOut;
	if(!ExecuteSQL("DROP TABLE "+ sTblName, false))
		ExecuteSQL("DELETE FROM "+ sTblName, false)
	var sSql = "CREATE TABLE "+ sTblName 
			+"(FPLAT "+ SqlType("INT") 		//плательщик: FORG из табл RAS_SKU, он же FCOD табл CLRELCLCL (справочник аналитики 2-го вида)
			+", FID_DOG"+ SqlType("LONG")	//договор: FID_DOG из табл RAS_SKU, он же FID_DOG табл LICSC, он же FWID табл CONTRACT
			+", FAPMT"+ SqlType("LONG")		//квартира: FWID_CL табл CL_APARTMENT, он же FAPMT из табл LICSC. вытягивается по FID_DOG табл RAS_SKU
			+", FHOUSE"+ SqlType("LONG")	//дом: FWID_CL табл CL_HOUSE, он же FHOUSE из табл CL_APARTMENT. вытягивается по FAPMT табл LICSC
			+", FSTREET"+ SqlType("LONG")	//улица: FSTREET из табл CL_HOUSE, он же FWID табл CL (справочник 1-го вида). вытягивается по FHOUSE табл CL_APARTMENT
			+", FLIVAREA"+ SqlType("DOUBLE")//жилая площадь: FLIVAREA из табл CL_APARTMENT
			+", FLOGAREA"+ SqlType("DOUBLE")//площадь лоджий: FLOGAREA из табл CL_APARTMENT
			+", FBALAREA"+ SqlType("DOUBLE")//площадь балконов: FBALAREA из табл CL_APARTMENT
			+", FFIO "+ SqlType("TEXT")		//ФИО плательщика: FTXT табл CL
			+", FAPMTNOM"+ SqlType("TEXT")	//номер квартиры: FNOM табл CL_APARTMENT
			+", FWCOUNTER"+ SqlType("BIT")	//налич.сч.воды
			+", FGCOUNTER"+ SqlType("BIT")	//налич.сч.газа
			+", FPERSKOL"+ SqlType("INT")	//колич. жильцов: FPERSKOL табл LICSC
			+", FEXMPTKOL"+ SqlType("INT")	//колич. льготников: FEXMPTKOL табл LICSC						
			+", FDATE"+ SqlType("DATE")		//дата: FDOC_DAT табл RAS_SKU
			+", FDOC"+ SqlType("TEXT")		//метка платежного поручения
			+", FNOP"+ SqlType("INT")		//номер операции платежки
			+", FTT"+ SqlType("TEXT")		//итог			
			+", FSUB"+ SqlType("CURRENCY")	//сумма субсидий
			+", FEXEMPT"+ SqlType("CURRENCY")	//сумма льгот
			+", FBILLSUM"+ SqlType("CURRENCY")	//общая сумма с уч. льгот и субсидий
			+", FSUPPORT"+ SqlType("CURRENCY")	//адресная помощь
			+", FSUM"+ SqlType("CURRENCY")		//общая сумма с учетом адресной помощи
			+", FBBALANS"+ SqlType("CURRENCY")	//сальдо на начало
			+", FEBALANS"+ SqlType("CURRENCY")	//сальдо на конец
			+", FPLATSUM"+ SqlType("CURRENCY")	//сумма оплаченная: FSUM из журнала регистрации по документу PP.
			+", FDEPT"+ SqlType("CURRENCY")		//долг на начало
			//суммы по услугам с учетом льгот. из табл RAS_SKU
			+", FRENT"+ SqlType("CURRENCY")		//квартплата
			+", FRENT_TARIF"+ SqlType("CURRENCY")//квартплата тариф
			+", FRENT_BILL"+ SqlType("CURRENCY")//квартплата начислено			
			+", FHEAT"+ SqlType("CURRENCY")		//отопление
			+", FCOOL"+ SqlType("CURRENCY")		//хол. вода
			+", FHOT"+ SqlType("CURRENCY")		//гор. вода
			+", FGAS"+ SqlType("CURRENCY")		//газ (и коню понятно)
			+", FELECTRIC"+ SqlType("CURRENCY")	//электроэнергия
			+", FWREMOV "+ SqlType("CURRENCY")	//водоотведение
			+", FTRASH"+ SqlType("CURRENCY")	//Вывоз мусора
			+", FOTHER "+ SqlType("CURRENCY")	//Другое
			+", FSUBSERV "+ SqlType("CURRENCY")	//Доп. услуги
			//объемы использ. воды
			+", FHOTVOL"+ SqlType("DOUBLE")	 	//гор.
			+", FCOOLVOL"+ SqlType("DOUBLE") 	//хол.
			+", FHOTCUR"+ SqlType("DOUBLE") 	//
			+", FCOOLCUR"+ SqlType("DOUBLE")	//
			+", FHOTPREV"+ SqlType("DOUBLE") 	//
			+", FCOOLPREV"+ SqlType("DOUBLE")	//
			+", FDRAINVOL"+ SqlType("DOUBLE")	//водоотведение
			+", FDRAINCUR"+ SqlType("DOUBLE")	//
			+", FDRAINPREV"+ SqlType("DOUBLE")	//			
			//
			+", FHEATVOL"+ SqlType("DOUBLE")	//
			+", FHEATCUR"+ SqlType("DOUBLE")	//
			+", FHEATPREV"+ SqlType("DOUBLE")	//
			+", FGASVOL"+ SqlType("DOUBLE")	 	//
			+", FGASCUR"+ SqlType("DOUBLE")	 	//
			+", FGASPREV"+ SqlType("DOUBLE")	//
			+", FELECTRICVOL"+ SqlType("DOUBLE")//
			+", FELECTRICCUR"+ SqlType("DOUBLE")//
			+", FELECTRICPREV"+ SqlType("DOUBLE")//
			//
			+", FRECALC"+ SqlType("CURRENCY") 	//перерасчет
			+", FPENALTY"+ SqlType("CURRENCY") 	//пеня
			+", FWID"+ SqlType("COUNTER")
			+")";			
	ExecuteSQL(sSql, false);
}

function hocRegTblName()
{		
	if(!jID || jID=="")
		jID = getPar("HOCPAYREG");		
	var sPath = getPath("UJ");
	var sTblName = sPath +".UJ_KU";	
	if(jID!=null && jID!="")
		sTblName = sPath +".UJ_"+ jID;		
	return sTblName;
}

function getHouseNom(fwid_cl)
{
	var sNom = "";
	if(!fwid_cl)
		fwid_cl = houseID;
	var sSql = "select rel.fcod, h.fnom, h.fwid_cl from ^cl_house h "
				+" inner join ^clrelclcl rel on rel.fwid_cl=h.fwid_cl "
				+" where h.fwid_cl="+ fwid_cl;
	var oHs = getSnap(sSql, false);
	if(oHs!=null && oHs[1]!=null)
		sNom = oHs[1];
	return sNom;	
}

function getSDat(date)
{	
	if(!date)
	{
		var oSnap = getSnap("select FDATE from "+ tblOut +" order by FDATE", false);
		if(oSnap!=null)
			date = toScriptDate(oSnap[0]);
	}
	var sMonth = tmonth(date, 3);
	var sYear = date.getYear() + 1900;
	return sMonth +" "+ sYear;
}

function getAddr()
{
	var sAddr = "";
	var oSnap = getSnap("select r.FSTREET,r.FHOUSE,cl.FTXT "
					+" from "+ tblOut +" r inner join ^CL cl on cl.FWID=r.Fstreet "
					+" where r.Fhouse<>0", false);
	if(oSnap!=null && oSnap[0]!=0)
		sAddr = oSnap[2] +" "+ getHouseNom(oSnap[1]);

	return sAddr;
}

function getSum(sFld, sWhere)
{
	if(!sFld)
		sFld = "FSUM";
	if(!sWhere)
		sWhere = "FTT='SUM'"
	var oSnap = getSnap("select sum("+ sFld +") from "+ tblOut +" where "+ sWhere);
	if(oSnap && Number(oSnap[0]))
		return round(oSnap[0], getPar("DECISUM"));
	return 0;
}

function listOnPrnList(tv)
{			
	tv.eval.addVar("DATE", getSDat());
	tv.eval.addVar("ADDR", getAddr());
	tv.eval.addVar("BDAT", list.objAsk.idat1);
	tv.eval.addVar("EDAT", list.objAsk.idat2);
	
	var tPrn = OpenTable("s", "select * from "+ tblOut 
				+" where FTT='SUM'");
	var arrFld = getColumn(tblOut).split(",");
	for(var n=0; n<arrFld.length; n++)
	{
		var sFld = arrFld[n];
		tv.eval.addVar(sFld, tPrn.getValue(sFld));
	}
}

function listMenuInit(ds)
{
	ds.AddMenuItem("DEBT", "Боржники|Должники");
	//ds.AddMenuItem("ZRPLIST", "Реєстр утримань із зарплати|Реестр удержаний из зарплаты");
	ds.AddMenuItem("+++", "Експорт у відділ субсидій|Экспорт в отдел субсидий");
		ds.AddMenuItem("TOSUBK", "Квартплата|Квартплата");
		ds.AddMenuItem("TOSUBO", "Опалення|Отопление");
		ds.AddMenuItem("TOSUBH", "Холодна вода|Холодная вода");
		ds.AddMenuItem("TOSUBG", "Гаряча вода|Горячая вода");
		ds.AddMenuItem("TOSUBE", "Електроенергія|Электроэнергия");
		ds.AddMenuItem("", "");
		ds.AddMenuItem("TOSUBALL", "Усі послуги|Все услуги");
	ds.AddMenuItem("---", "Експорт у відділ субсидій|Экспорт в отдел субсидий");
}

function listMenuRun(sID)
{
	if(sID=="DEBT")
	{
		var p = new Object();
		p.tblName = tblOut;
		showWindow("r_vedkud.js", SW_NOMODAL, p);		
	}
	else if(sID=="ZRPLIST")	//rovenki
	{
		var p = new Object();
		p.tblName = tblOut;
		showWindow("r_vedku_zrp.js", SW_NOMODAL, p);		
	}
	else if(sID=="TOSUBE")
	{
		bSubReplace = false;
		var bRet = exportSubE();
		if(bRet)
			browseSubDir();
	}
	else if(sID=="TOSUBG")
	{
		bSubReplace = false;
		var bRet = exportSubG();
		if(bRet)
			browseSubDir();
	}
	else if(sID=="TOSUBH")
	{
		bSubReplace = false;
		var bRet = exportSubH();
		if(bRet)
			browseSubDir();
	}
	else if(sID=="TOSUBK")
	{
		bSubReplace = false;
		var bRet = exportSubK();
		if(bRet)
			browseSubDir();
	}
	else if(sID=="TOSUBO")
	{
		bSubReplace = false;
		var bRet = exportSubO();
		if(bRet)
			browseSubDir();
	}
	else if(sID=="TOSUBALL")
	{
		bSubReplace = false;
		var bRet = exportSubK();
		bRet = bRet && exportSubO();
		bRet = bRet && exportSubH();
		bRet = bRet && exportSubG();
		bRet = bRet && exportSubE();
		if(bRet)
			browseSubDir();
	}
}

var socDepCod = getPar("HOCSOCDEP_COD");
var sSubDir = "";
var sSubName = "";
var sSubDBF = "";
var bSubReplace = false;

function createSubDBF(sType)
{
	if(!sType)
		sType = "";
	sSubDir = allt(getPar("EXPDIR"));
	if(!sSubDir || sSubDir=="")
	{
		sSubDir = BrowseForDir("", UR("Експорт|Экспорт"), UR("Вкажіть шлях для експорту|Укажите путь для экспорта"));
		if(!sSubDir)
			return null;
		setPar("EXPDIR", sSubDir);
	}
	socDepCod = getPar("HOCSOCDEP_COD");
	if(!socDepCod || String(socDepCod).trim()=="")
	{
		socDepCod = input(UR(" Код організації у відділі соц. захисту| Код организации в отделе соц. защиты ")
							, UR("Введіть код організації|Введите код организации")
							, "", 15
							);
		if(socDepCod)
			setPar("HOCSOCDEP_COD", socDepCod);
		else
			socDepCod = "";
	}
	var sDate = format("yymm", list.objAsk.rdate);
	if(allt(socDepCod)!="" && Number(socDepCod)!=0)
		sSubDir += "/"+ socDepCod;
	sSubDir += "/"+ sDate;
	if(!isDir(sSubDir))
		createDirectory(sSubDir);
	var sPath = rootDirectoryEx() +"private_modules/hoc/Source/DBF/";
	if(getSystem()=="VDK")
		sPath = rootDirectoryEx() +"private_modules/vdk/Source/DBF/";
	var sBlank = sPath +"SUB"+ sType +".DBF";
	sSubName = sType + socDepCod +""+ sDate;
	sSubDBF = sSubDir +"/"+ sSubName +".DBF";
	if(isFile(sSubDBF) && !bSubReplace)
	{
		var sMsg = UR("У папці "+ sSubDir +" вже є файли. \nІснуючі файли будуть замінені!\nПродовжити експорт?"
					+"|В папке "+ sSubDir +" уже есть файлы. \nСуществующие файлы будут заменены!\nПродолжить экспорт?"
					);
		if(confirm(sMsg))
			bSubReplace = true;
		else
			return null;
	}
	copyFile(sBlank, sSubDBF);
	var oDBF = lpProxy.getDBManager().getDBFWriter(sSubDBF);
	if(!oDBF)
	{
		var sMsg = UR("Неможливо створити файл "+ sSubDBF +"!\nЯкщо існуючі файли відкиті, необхідно їх закрити і порторити експорт."
					+"|Невозможно создать файл "+ sSubDBF +"!\nЕсли существующие файлы открыты, нужно их закрыть и повторить экспорт."
					);
		alert(sMsg, 1);
		return null;
	}
	oDBF.setCharactersetName("cp866");
	return oDBF;
}

function exportSubK()
{
	var nPr = 1;
	var sPrText = UR("ЕКСПОРТ: Квартплата|ЭКСПОРТ: Квартплата");
	setProgressRange(0, 10);
	setProgressPos(nPr++, sPrText);
	
	var oDBF = createSubDBF("K");
	if(!oDBF)
	{
		setProgressPos(0);
		return false;
	}
	
	var sServ = "RENT";
	var date = list.objAsk.rdate;
	var d1 = firstDay(date);
	var d2 = lastDay(date);
	var dSum = getPar("DECISUM");
	var rowCnt = 0;
	var sumBill = 0;
	var sumNorm1 = 0;
	var sumNorm2 = 0;
	var sumNorm3 = 0;
	
	var tbl = OpenTable("select t.*, l.FDOG_NUM, l.FORG_TXT, l.FSTREET_TXT"
							+", l.FSTREET_COD, l.FHOUSE_NOM, l.FAPT_NOM, l.FROOMKOL"
						+" from "+ tblOut +" t"
						+" inner join ^LISTLICSC l on l.FID_DOG=t.FID_DOG"
						+" order by t.FSTREET, t.FHOUSE, t.FPLAT"
						);
	if(!tbl.isEmpty())
		setProgressRange(0, tbl.recordCount+5);
	setProgressPos(nPr++, sPrText);
	try
	{
		for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
		{
			setProgressPos(nPr++, sPrText);
			var nOrg = tbl.getValue("FPLAT");
			var dogID = tbl.getValue("FID_DOG");
			var houseID = tbl.getValue("FHOUSE");
			var apartID = tbl.getValue("FAPMT");
			var sAddr = tbl.getValue("FSTREET_TXT") +", "+ tbl.getValue("FHOUSE_NOM");
			var tarif = tariffKU(sServ, dogID, date);
			if(!tarif)
				continue;
			
			var sum = Number(tbl.getValue("FRENT"));
			var pers = Number(tbl.getValue("FPERSKOL"));
			var area = Number(tbl.getValue("FLIVAREA"));
			var kk = Number(tbl.getValue("FROOMKOL"));
			var billSum = Number(tbl.getValue("FBILLSUM"));
			var debt = calcDebtKU(nOrg, dogID, date, 0, sServ, true);
			var norm = 0;
			var kol = 0;
			var privKol = 0;
			var privSum = 0;
			var oSnap = getSnap("select s.FNORM, sum(s.FKOL), s.FCENA, sum(s.FSUM), sum(s.FPRIVKOL), sum(s.FPRIVSUM)"
							+" from ^SKU_SERV s"
							+" inner join ^RAS_SKU r on r.FWID=s.FID_DOC"
							+" where r.FID_DOG="+ dogID 
								+" and r.FDOC_DAT>="+ sqlTo(d1) 
								+" and r.FDOC_DAT<="+ sqlTo(d2)
								+" and r.FISRECALC<>"+ sqlTrue
								+" and s.FSERV="+ sqlTo(sServ)
							, false
							);
			if(oSnap)
			{
				norm = Number(oSnap[0]);
				kol = Number(oSnap[1]);
				tarif = Number(oSnap[2]);
				billSum = Number(oSnap[3]);
				privKol = Number(oSnap[4]);
				privSum = Number(oSnap[5]);
			}
			
			var persArea = Number(getOrgVar("NORMAREA1", true, date)); 	//норма площади на одного жильца
			var livArea = Number(getOrgVar("NORMAREA2", true, date)); 	//площадь на семью
			var normArea1 = pers * persArea + livArea;
			if(normArea1>kol)
				normArea1 = kol;
			var normArea2 = pers * persArea;
			if(normArea2>kol)
				normArea2 = kol;
			var normArea3 = pers * (persArea + livArea);
			if(normArea3>kol)
				normArea3 = kol;
			var privArea = 0;
			var gNorm1 = round(tarif*normArea1, dSum);		//начисления в пределах нормы
			var gNorm2 = round(tarif*normArea2, dSum);		//начисления в пределах нормы без прибавки на семью
			var gNorm3 = round(tarif*normArea3, dSum);		//начисления в пределах нормы для удержания собес
			
			var privTxt = "";
			var privPerc = "";
			var privMen = "";
			var privTbl = openPrivilegeTbl(dogID, date, "RENT");
			for(; !privTbl.isEOF(); privTbl.MoveNext())
			{
				privTxt += (privTxt!=""? "," : "") + privTbl.getValue("FCOD");
				privPerc += (privPerc!=""? "," : "") + privTbl.getValue("FPERC");
				privMen += (privMen!=""? "," : "") + privTbl.getValue("FKOL");
				var perc = Number(privTbl.getValue("FPERC"));
				var cnt = Number(privTbl.getValue("FKOL"));
				var isfam = privTbl.getValue("FFAMILYPRIVILEGE")==true;
				var priv = (cnt*persArea + (isfam? livArea : 0)) * perc/100;
				privArea += priv;
				//gNorm1 -= (cnt*persArea + livArea) * tarif * perc/100;
				//gNorm2 -= (cnt*persArea + livArea) * tarif * perc/100;
				//gNorm3 -= (cnt*persArea + livArea) * tarif * perc/100;
			}
			privTbl.close();
			if(!privArea)
				privArea = 0;
			privArea = privArea>area? area : privArea;
			
			gNorm1 = round((normArea1-privArea)*tarif, dSum);
			gNorm2 = round((normArea2-privArea)*tarif, dSum);
			gNorm3 = round((normArea3-privArea)*tarif, dSum);
			
			gNorm1 = round(gNorm1>0? gNorm1 : 0, dSum);
			gNorm2 = round(gNorm2>0? gNorm2 : 0, dSum);
			gNorm3 = round(gNorm3>0? gNorm3 : 0, dSum);
			
			var oRow = new Array(
							toScrObj(socDepCod)								//JEC_NOM 	- Код ЖЕКу
							,toScrObj(tbl.getValue("FDOG_NUM"))				//OS_R 		- Особовий  рахунок 
							,toScrObj(corectDbfTxt(sAddr))					//ADR 		- Адреса
							,toScrObj(tbl.getValue("FSTREET_COD"))			//KODSTREET	- Код вулиці
							,toScrObj(tbl.getValue("FHOUSE_NOM"))			//N_BUD 	- Номер будинку
							,toScrObj(tbl.getValue("FAPT_NOM"))				//N_KV      - Номер квартири
							,toScrObj(corectDbfTxt(tbl.getValue("FFIO")))	//PRIZ      - Прiзвище
							,toScrObj(kk)									//K_K      	- К-ть кiмнат
							,toScrObj(pers)									//K_PR      - Кiлькiсть прописаних
							,toScrObj(area)									//KOR_PL    - Розрахункова площа
							,toScrObj(tarif)								//TARYF_KV  - Тариф на квартплату
							,toScrObj(sum)									//NKVARTLG  - Нарахування по квартплатi
							,toScrObj(debt)									//BKVART    - Борг по квартплатi
							,toScrObj(tbl.getValue("FDOG_NUM"))				//OS_R_OLD	- Старий код особового рахунку
							,toScrObj(privTxt)								//N_PILG    - Назва пiльги
							,toScrObj(privPerc)								//SKYDKA    - Скидка
							,toScrObj(privMen)								//NA_1		- Кiлькiсть людей на яку поширюeться пiльга   
							,""												//UGODA     - Угода
							,toScrObj(gNorm1)								//SUBSYD    - Нарахування по квартплатi в межах санiтарних норм
							,toScrObj(gNorm2)								//ROZDILN   - Нарахування по квартплатi в межах санiтарних норм без додатку на сiм'ю
							,toScrObj(gNorm3)								//NSANKV52  - Нарахування по квартплатi в межах санiтарних норм для утриман.соцзабезу
							);
			oDBF.addRecord(oRow);
			sumBill += sum;
			sumNorm1 += gNorm1;
			sumNorm2 += gNorm2;
			sumNorm3 += gNorm3;
			rowCnt++;
		}
		oDBF.write();
	}
	catch(e)
	{
		alert(UR("Не вдалося виконати експорт!|Не удалось выполнить экспорт!") +"\n"+ e, 2);
		setProgressPos(0);
		tbl.close();
		return false;
	}
	tbl.close();
	setProgressPos(nPr++, sPrText);
	
	try
	{
		var sXLSFile = sSubDir +"/"+ sSubName +".XLS";
		if(isFile(sXLSFile))
		{
			try
			{
				deleteFile(sXLSFile);
			}
			catch(e)
			{
				var sMsg = UR("Неможливо створити протокол "+ sXLSFile +"!\nЯкщо існуючі файли відкиті, необхідно їх закрити і порторити експорт."
							+"|Невозможно создать протокол "+ sXLSFile +"!\nЕсли существующие файлы открыты, нужно их закрыть и повторить экспорт."
							);
				alert(sMsg, 1);
			}
		}
		var wb = lpProxy.createExcelWorkbook();
		var ws = wb.createSheet("DebetPlus");
		ws.setColumnWidth(0, 500);
		ws.setColumnWidth(1, 7000);
		ws.setColumnWidth(2, 15000);
			
		var styleBold = wb.createCellStyle();
		var fontBold = wb.createFont();
		fontBold.setBoldweight(0x2bc);
		styleBold.setFont(fontBold);
		styleBold.setAlignment(1);
		
		var styleGrid = wb.createCellStyle();
		styleGrid.setBorderBottom(1);
		styleGrid.setBorderTop(1);
		styleGrid.setBorderLeft(1);
		styleGrid.setBorderRight(1);
		styleGrid.setAlignment(1);
		styleGrid.setWrapText(true);
		
		var nRow = -1;
		createCell(ws.createRow(++nRow), 1, "ПРОТОКОЛ ПЕРЕДАЧI ЩОМIСЯЧНОI IНФОРМАЦII", styleBold);
		createCell(ws.createRow(++nRow), 1, "про нарахування  квартплати", styleBold);
		createCell(ws.createRow(++nRow), 1, "по "+ getPar("OFIRM") +" за "+ format("Mmm yyyy", date).toLowerCase(), styleBold);
		createCell(ws.createRow(++nRow), 1, "у "+ getPar("HOCSOCDEP_TXT"), styleBold);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Назва носiя бази даних:", styleGrid);
		createCell(ws.getRow(nRow), 2, "магнітна дискета", styleGrid);
		createCell(ws.createRow(++nRow), 1, "Назва файлу бази даних:", styleGrid);
		createCell(ws.getRow(nRow), 2, sSubName, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Дата створення файлу:", styleGrid);
		createCell(ws.getRow(nRow), 2, format("dd.mm.yyyy", today), styleGrid);
		createCell(ws.createRow(++nRow), 1, "Час створення файлу:", styleGrid);
		createCell(ws.getRow(nRow), 2, format("HH:MM:SS", new Date()), styleGrid);
		createCell(ws.createRow(++nRow), 1, "Розмiр файлу в байтах:", styleGrid);
		createCell(ws.getRow(nRow), 2, new DpFile(sSubDBF).length(), styleGrid);
		createCell(ws.createRow(++nRow), 1, "Кiлькiсть записiв у файлi:", styleGrid);
		createCell(ws.getRow(nRow), 2, rowCnt, styleGrid);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "  Iмена полів бази даних", styleGrid);
		createCell(ws.getRow(nRow), 2, "  Опис значення", styleGrid);
		createCell(ws.createRow(++nRow), 1, "JEC_NOM", styleGrid);
		createCell(ws.getRow(nRow), 2, "Номер ЖЕКу", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OS_R_NEW", styleGrid);
		createCell(ws.getRow(nRow), 2, "Особовий  рахунок", styleGrid);
		createCell(ws.createRow(++nRow), 1, "ADR", styleGrid);
		createCell(ws.getRow(nRow), 2, "Адреса", styleGrid);
		createCell(ws.createRow(++nRow), 1, "KODSTREET", styleGrid);
		createCell(ws.getRow(nRow), 2, "Код вулиці", styleGrid);
		createCell(ws.createRow(++nRow), 1, "N_BUD", styleGrid);
		createCell(ws.getRow(nRow), 2, "Номер будинку", styleGrid);
		createCell(ws.createRow(++nRow), 1, "N_KV", styleGrid);
		createCell(ws.getRow(nRow), 2, "Номер квартири", styleGrid);
		createCell(ws.createRow(++nRow), 1, "PRIZ", styleGrid);
		createCell(ws.getRow(nRow), 2, "Прiзвище абонента", styleGrid);
		createCell(ws.createRow(++nRow), 1, "K_K", styleGrid);
		createCell(ws.getRow(nRow), 2, "К-ть кiмнат", styleGrid);
		createCell(ws.createRow(++nRow), 1, "K_PR", styleGrid);
		createCell(ws.getRow(nRow), 2, "Кiлькiсть прописаних", styleGrid);
		createCell(ws.createRow(++nRow), 1, "KOR_PL", styleGrid);
		createCell(ws.getRow(nRow), 2, "Розрахункова площа", styleGrid);
		createCell(ws.createRow(++nRow), 1, "NKVARTLG", styleGrid);
		createCell(ws.getRow(nRow), 2, "Нарахування по квартплатi", styleGrid);
		createCell(ws.createRow(++nRow), 1, "BKVART", styleGrid);
		createCell(ws.getRow(nRow), 2, "Борг по квартплатi", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OS_R", styleGrid);
		createCell(ws.getRow(nRow), 2, "Старий код особового рахунку", styleGrid);
		createCell(ws.createRow(++nRow), 1, "N_PILG", styleGrid);
		createCell(ws.getRow(nRow), 2, "Назва пiльги", styleGrid);
		createCell(ws.createRow(++nRow), 1, "SKYDKA", styleGrid);
		createCell(ws.getRow(nRow), 2, "Скидка", styleGrid);
		createCell(ws.createRow(++nRow), 1, "NA_1", styleGrid);
		createCell(ws.getRow(nRow), 2, "Кiлькiсть людей на яку поширюeться пiльга", styleGrid);
		createCell(ws.createRow(++nRow), 1, "UGODA", styleGrid);
		createCell(ws.getRow(nRow), 2, "Угода", styleGrid);
		createCell(ws.createRow(++nRow), 1, "SUBSYD", styleGrid);
		createCell(ws.getRow(nRow), 2, "Нарахування по квартплатi в межах санiтарних норм", styleGrid);
		createCell(ws.createRow(++nRow), 1, "ROZDILN", styleGrid);
		createCell(ws.getRow(nRow), 2, "Нарахування по квартплатi в межах санiтарних норм без додатку на сiм'ю", styleGrid);
		createCell(ws.createRow(++nRow), 1, "NSANKV52", styleGrid);
		createCell(ws.getRow(nRow), 2, "Нарахування по квартплатi в межах санiтарних норм для утриман.соцзабезу", styleGrid);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Сума по полю NKVARTLG:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumBill, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Сума по полю SUBSYD:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumNorm1, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Сума по полю ROZDILN:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumNorm2, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Сума по полю NSANKV52:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumNorm3, styleGrid);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Директор");
		createCell(ws.createRow(++nRow), 1, "\"___\"_______________");
		createCell(ws.getRow(nRow), 2, "_________________/__________________________/");
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Головний бухгалтер");
		createCell(ws.createRow(++nRow), 1, "\"___\"_______________");
		createCell(ws.getRow(nRow), 2, "_________________/__________________________/");
		
		try
		{
			var os = new DpFileOutputStream(sXLSFile);
			wb.write(os);
			os.close();
		}
		catch(e)
		{
			var sMsg = UR("Неможливо створити протокол "+ sXLSFile +"!\nЯкщо існуючі файли відкиті, необхідно їх закрити і порторити експорт."
						+"|Невозможно создать протокол "+ sXLSFile +"!\nЕсли существующие файлы открыты, нужно их закрыть и повторить экспорт."
						);
			alert(sMsg, 1);
		}
	}
	catch(e)
	{
		alert(UR("Помилка при створенні протоколу!|Ошибка при создании протокола!") +"\n"+ e, 2);
	}
	setProgressPos(0);
	return true;
}

function exportSubO()
{
	var nPr = 1;
	var sPrText = UR("ЕКСПОРТ: Опалення|ЭКСПОРТ: Отопление");
	setProgressRange(0, 10);
	setProgressPos(nPr++, sPrText);
	
	var oDBF = createSubDBF("O");
	if(!oDBF)
	{
		setProgressPos(0);
		return false;
	}
	
	var sServ = "HEAT";
	var date = list.objAsk.rdate;
	var d1 = firstDay(date);
	var d2 = lastDay(date);
	var dSum = getPar("DECISUM");
	var rowCnt = 0;
	var sumBill = 0;
	var sumBill11 = 0;
	var sumBill12 = 0;
	var sumBill13 = 0;
	var sumBill14 = 0;
	var sumBill21 = 0;
	var sumBill22 = 0;
	var sumBill23 = 0;
	var sumBill24 = 0;
	
	var tbl = OpenTable("select t.*, l.FDOG_NUM, l.FORG_TXT, l.FSTREET_TXT"
							+", l.FSTREET_COD, l.FHOUSE_NOM, l.FAPT_NOM, l.FROOMKOL"
							+", l.FAREA, l.FLIVAREA as FLIV"
						+" from "+ tblOut +" t"
						+" inner join ^LISTLICSC l on l.FID_DOG=t.FID_DOG"
						+" order by t.FSTREET, t.FHOUSE, t.FPLAT"
						);
	if(!tbl.isEmpty())
		setProgressRange(0, tbl.recordCount+5);
	setProgressPos(nPr++, sPrText);
	try
	{
		for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
		{
			setProgressPos(nPr++, sPrText);
			var nOrg = tbl.getValue("FPLAT");
			var dogID = tbl.getValue("FID_DOG");
			var houseID = tbl.getValue("FHOUSE");
			var apartID = tbl.getValue("FAPMT");
			var sAddr = tbl.getValue("FSTREET_TXT") +", "+ tbl.getValue("FHOUSE_NOM");
			var tarif = tariffKU(sServ, dogID, date);
			if(!tarif)
				continue;
			
			var sum = Number(tbl.getValue("FHEAT"));
			var pers = Number(tbl.getValue("FPERSKOL"));
			var kk = Number(tbl.getValue("FROOMKOL"));
			var area = Number(tbl.getValue("FLIVAREA"));
			var full = Number(tbl.getValue("FAREA"));
			var debt = calcDebtKU(nOrg, dogID, date, 0, sServ, true);
			var hsCnt = isCounters(dogID, 0, sServ, houseID, date);
			
			var tarif0 = tarif;
			var tarif1 = tarif;
			var tarif2 = tariffKU("OTHER", dogID, date);
			
			var norm = 0;
			var kol = 0;
			var billSum = 0;
			var privKol = 0;
			var privSum = 0;
			var oSnap = getSnap("select s.FNORM, sum(s.FKOL), s.FCENA, sum(s.FSUM), sum(s.FPRIVKOL), sum(s.FPRIVSUM)"
							+" from ^SKU_SERV s"
							+" inner join ^RAS_SKU r on r.FWID=s.FID_DOC"
							+" where r.FID_DOG="+ dogID 
								+" and r.FDOC_DAT>="+ sqlTo(d1) 
								+" and r.FDOC_DAT<="+ sqlTo(d2)
								+" and r.FISRECALC<>"+ sqlTrue
								+" and s.FSERV="+ sqlTo(sServ)
							, false
							);
			if(oSnap)
			{
				norm = Number(oSnap[0]);
				kol = Number(oSnap[1]);
				tarif1 = Number(oSnap[2]);
				billSum = Number(oSnap[3]);
				privKol = Number(oSnap[4]);
				privSum = Number(oSnap[5]);
			}
			tarif = tarif1 + tarif2;
			
			var privArea = 0;
			var privTxt = "";
			var privPerc = "";
			var privMen = "";
			var privTbl = openPrivilegeTbl(dogID, date, "HEAT");
			for(; !privTbl.isEOF(); privTbl.MoveNext())
			{
				privTxt += (privTxt!=""? "," : "") + privTbl.getValue("FCOD");
				privPerc += (privPerc!=""? "," : "") + privTbl.getValue("FPERC");
				privMen += (privMen!=""? "," : "") + privTbl.getValue("FKOL");
				var perc = Number(privTbl.getValue("FPERC"));
				var cnt = Number(privTbl.getValue("FKOL"));
				var isfam = privTbl.getValue("FFAMILYPRIVILEGE")==true;
				var priv = (cnt*persArea + (isfam? livArea : 0)) * perc/100;
				privArea += priv;
			}
			privTbl.close();
			if(!privArea)
				privArea = 0;
			privArea = privArea>area? area : privArea;
			
			var persArea = Number(getOrgVar("NORMAREA1", true, date)); 	//норма площади на одного жильца
			var livArea = Number(getOrgVar("NORMAREA2", true, date)); 	//площадь на семью
			var norm1 = pers * persArea + livArea;
			norm1 = norm1>kol? kol : norm1;
			norm1 = norm1>privArea? norm1 : privArea;
			var norm2 = pers * persArea;
			norm2 = norm2>kol? kol : norm2;
			norm2 = norm2>privArea? norm2 : privArea;
			var norm3 = pers * (persArea + livArea);
			norm3 = norm3>kol? kol : norm3;
			norm3 = norm3>privArea? norm3 : privArea;
			
			var sum = round((area-privArea)*(tarif1 + tarif2), dSum);		//OP_POWNE
			var sum11 = round((area-privArea)*(tarif0 + tarif2), dSum);		//OP_REA
			var sum12 = round((norm1-privArea)*(tarif1 + tarif2), dSum);	//OPAL
			var sum13 = round((norm2-privArea)*(tarif1 + tarif2), dSum);	//OP_NEPOW
			var sum14 = round((norm3-privArea)*(tarif1 + tarif2), dSum);	//OPAL_NEP
			var sum21 = round((area-privArea)*(tarif0), dSum);				//OP_POWNE2
			var sum22 = round((norm1-privArea)*(tarif0), dSum);				//OPAL2
			var sum23 = round((norm2-privArea)*(tarif0), dSum);				//OP_NEPOW2
			var sum24 = round((norm3-privArea)*(tarif0), dSum);				//OPAL_NEP2
			
			var oHs = getSnap("select FTYPE,FWATERSERV"
								+" from ^CL_HOUSE "
								+" where FWID_CL="+ houseID
								, false
								);
			var oApmt = getSnap("select FPROPERTY"
								+" from ^CL_APARTMENT "
								+" where FWID_CL="+ apartID
								, false
								);
				
			var oRow = new Array(
							toScrObj(socDepCod)								//JEC_NOM 	- Код ЖЕКу
							,toScrObj(tbl.getValue("FDOG_NUM"))				//OS_R 		- Особовий  рахунок 
							,toScrObj(corectDbfTxt(sAddr))					//ADR 		- Адреса
							,toScrObj(tbl.getValue("FSTREET_COD"))			//KODSTREET	- Код вулиці
							,toScrObj(tbl.getValue("FHOUSE_NOM"))			//N_BUD 	- Номер будинку
							,toScrObj(tbl.getValue("FAPT_NOM"))				//N_KV      - Номер квартири
							,toScrObj(corectDbfTxt(tbl.getValue("FFIO")))	//PRIZ      - Прiзвище
							,toScrObj(kk==1? 1 : 0)							//ODNOKIM   - Признак однокімнатної квартири (1 або 0)
							,toScrObj(area)									//PLOS      - Опалювальна  площа
							,toScrObj(pers)									//K_PR      - Кiлькiсть прописаних
							,toScrObj(hsCnt)								//LIO_BUD   - Признак будинкового лічильника на опалення  (t або f)
							,toScrObj(tbl.getValue("FDOG_NUM"))				//OS_R_OLD	- Старий код особового рахунку
							,toScrObj(oHs? oHs[0] : 0)						//KP      	- Тип будинку для центрального опалення
							,toScrObj(privTxt)								//N_PILG    - Назва пiльги
							,toScrObj(privPerc)								//SKYDKA    - Скидка
							,toScrObj(privMen)								//NA_1		- Кiлькiсть людей на яку поширюeться пiльга   
							,""												//UGODA     - Угода
							,toScrObj(sum)									//OP_POWNE  - Нарахування по опаленню  на  опалювальну  площу
							,toScrObj(sum11)								//OP_REA    - Нарахування по опаленню на всю площу по фактичному тарифу
							,toScrObj(sum12)								//OPAL      - Нарахування по опаленню в межах санiтарних норм  по нормативному тарифу + приєднане теплове навантаження
							,toScrObj(sum13)								//OP_NEPOW  - Нарахування по опаленню  в межах санiтарних норм без додатку на сiм'ю  по нормативному тарифу + приєднане т.н.
							,toScrObj(sum14)								//OPAL_NEP  - Нарахування по опаленню  в межах санітарних норм для утриманців соцзабезу по нормативному тарифу + приєднане т.н.
							,toScrObj(sum21)								//OP_POWNE2 - Нарахування по опаленню  на всю площу по фактичному тарифу
							,toScrObj(sum22)								//OPAL2     - Нарахування по опаленню  в межах санiтарних норм  по фактичному тарифу
							,toScrObj(sum23)								//OP_NEPOW2 - Нарахування по опаленню  в межах санiтарних норм без додатку на сiм'ю  по фактичному тарифу
							,toScrObj(sum24)								//OPAL_NEP2 - Нарахування по опаленню  в межах санітарних норм для утриманців соцзабезу по фактичному тарифу
							,toScrObj(0)									//OP_POWNE3 - Середньомісячне нарахування на опалення на повну площу
							,toScrObj(0)									//OPAL3     - Середньомісячне нарахування на опалення в межах санiтарних норм
							,toScrObj(0)									//OP_NEPOW3 - Середньомісячне нарахування на опалення в межах санiтарних норм без додатку на сiм'ю
							,toScrObj(0)									//OP_NEP3   - Середньомісячне нарахування на опалення в межах санўтарних норм для утриманцўв соцзабезу
							,toScrObj(tarif)								//TAROP     - Тариф на опалення
							,toScrObj(tarif1)								//TARYF_FK  - Тариф Умовно Змінної Частини Опалення
							,toScrObj(tarif2)								//TARYF_PR  - Тариф Умовно Постійної Частини Опалення
							,toScrObj(debt)									//BORGOP    - Борг по опаленню
							,toScrObj(oApmt? oApmt[0] : 0)					//K_W       - Форма власності  квартири
							);
			oDBF.addRecord(oRow);
			sumBill += sum;
			sumBill11 += sum11;
			sumBill12 += sum12;
			sumBill13 += sum13;
			sumBill14 += sum14;
			sumBill21 += sum21;
			sumBill22 += sum22;
			sumBill23 += sum23;
			sumBill24 += sum24;
			rowCnt++;
		}
		oDBF.write();
	}
	catch(e)
	{
		alert(UR("Не вдалося виконати експорт!|Не удалось выполнить экспорт!") +"\n"+ e, 2);
		setProgressPos(0);
		tbl.close();
		return false;
	}
	tbl.close();
	setProgressPos(nPr++, sPrText);
	
	try
	{
		var sXLSFile = sSubDir +"/"+ sSubName +".XLS";
		if(isFile(sXLSFile))
		{
			try
			{
				deleteFile(sXLSFile);
			}
			catch(e)
			{
				var sMsg = UR("Неможливо створити протокол "+ sXLSFile +"!\nЯкщо існуючі файли відкиті, необхідно їх закрити і порторити експорт."
							+"|Невозможно создать протокол "+ sXLSFile +"!\nЕсли существующие файлы открыты, нужно их закрыть и повторить экспорт."
							);
				alert(sMsg, 1);
			}
		}
		var wb = lpProxy.createExcelWorkbook();
		var ws = wb.createSheet("DebetPlus");
		ws.setColumnWidth(0, 500);
		ws.setColumnWidth(1, 7000);
		ws.setColumnWidth(2, 15000);
			
		var styleBold = wb.createCellStyle();
		var fontBold = wb.createFont();
		fontBold.setBoldweight(0x2bc);
		styleBold.setFont(fontBold);
		styleBold.setAlignment(1);
		
		var styleGrid = wb.createCellStyle();
		styleGrid.setBorderBottom(1);
		styleGrid.setBorderTop(1);
		styleGrid.setBorderLeft(1);
		styleGrid.setBorderRight(1);
		styleGrid.setAlignment(1);
		styleGrid.setWrapText(true);
		
		var nRow = -1;
		createCell(ws.createRow(++nRow), 1, "ПРОТОКОЛ ПЕРЕДАЧI ЩОМIСЯЧНОI IНФОРМАЦII", styleBold);
		createCell(ws.createRow(++nRow), 1, "про нарахування за опалення", styleBold);
		createCell(ws.createRow(++nRow), 1, "по "+ getPar("OFIRM") +" за "+ format("Mmm yyyy", date).toLowerCase(), styleBold);
		createCell(ws.createRow(++nRow), 1, "у "+ getPar("HOCSOCDEP_TXT"), styleBold);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Назва носiя бази даних:", styleGrid);
		createCell(ws.getRow(nRow), 2, "магнітна дискета", styleGrid);
		createCell(ws.createRow(++nRow), 1, "Назва файлу бази даних:", styleGrid);
		createCell(ws.getRow(nRow), 2, sSubName, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Дата створення файлу:", styleGrid);
		createCell(ws.getRow(nRow), 2, format("dd.mm.yyyy", today), styleGrid);
		createCell(ws.createRow(++nRow), 1, "Час створення файлу:", styleGrid);
		createCell(ws.getRow(nRow), 2, format("HH:MM:SS", new Date()), styleGrid);
		createCell(ws.createRow(++nRow), 1, "Розмiр файлу в байтах:", styleGrid);
		createCell(ws.getRow(nRow), 2, new DpFile(sSubDBF).length(), styleGrid);
		createCell(ws.createRow(++nRow), 1, "Кiлькiсть записiв у файлi:", styleGrid);
		createCell(ws.getRow(nRow), 2, rowCnt, styleGrid);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "  Iмена полів бази даних", styleGrid);
		createCell(ws.getRow(nRow), 2, "  Опис значення", styleGrid);
		createCell(ws.createRow(++nRow), 1, "JEC_NOM", styleGrid);
		createCell(ws.getRow(nRow), 2, "Номер ЖЕКу", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OS_R_NEW", styleGrid);
		createCell(ws.getRow(nRow), 2, "Особовий  рахунок", styleGrid);
		createCell(ws.createRow(++nRow), 1, "ADR", styleGrid);
		createCell(ws.getRow(nRow), 2, "Адреса", styleGrid);
		createCell(ws.createRow(++nRow), 1, "KODSTREET", styleGrid);
		createCell(ws.getRow(nRow), 2, "Код вулиці", styleGrid);
		createCell(ws.createRow(++nRow), 1, "N_BUD", styleGrid);
		createCell(ws.getRow(nRow), 2, "Номер будинку", styleGrid);
		createCell(ws.createRow(++nRow), 1, "N_KV", styleGrid);
		createCell(ws.getRow(nRow), 2, "Номер квартири", styleGrid);
		createCell(ws.createRow(++nRow), 1, "PRIZ", styleGrid);
		createCell(ws.getRow(nRow), 2, "Прiзвище абонента", styleGrid);
		createCell(ws.createRow(++nRow), 1, "ODNOKIM", styleGrid);
		createCell(ws.getRow(nRow), 2, "Признак однокімнатної квартири (1 або 0)", styleGrid);
		createCell(ws.createRow(++nRow), 1, "PLOS", styleGrid);
		createCell(ws.getRow(nRow), 2, "Опалювальна  площа", styleGrid);
		createCell(ws.createRow(++nRow), 1, "K_PR", styleGrid);
		createCell(ws.getRow(nRow), 2, "Кiлькiсть прописаних", styleGrid);
		createCell(ws.createRow(++nRow), 1, "LIO_BUD", styleGrid);
		createCell(ws.getRow(nRow), 2, "Признак будинкового лічильника на опалення  (t або f)", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OS_R", styleGrid);
		createCell(ws.getRow(nRow), 2, "Старий код особового рахунку", styleGrid);
		createCell(ws.createRow(++nRow), 1, "KP", styleGrid);
		createCell(ws.getRow(nRow), 2, "Тип будинку для центрального опалення", styleGrid);
		createCell(ws.createRow(++nRow), 1, "N_PILG", styleGrid);
		createCell(ws.getRow(nRow), 2, "Назва пiльги", styleGrid);
		createCell(ws.createRow(++nRow), 1, "SKYDKA", styleGrid);
		createCell(ws.getRow(nRow), 2, "Скидка", styleGrid);
		createCell(ws.createRow(++nRow), 1, "NA_1", styleGrid);
		createCell(ws.getRow(nRow), 2, "Кiлькiсть людей на яку поширюeться пiльга", styleGrid);
		createCell(ws.createRow(++nRow), 1, "UGODA", styleGrid);
		createCell(ws.getRow(nRow), 2, "Угода", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OP_POWNE", styleGrid);
		createCell(ws.getRow(nRow), 2, "Нарахування по опаленню  на  опалювальну  площу", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OP_REA", styleGrid);
		createCell(ws.getRow(nRow), 2, "Нарахування по опаленню  на всю площу по фактичному тарифу", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OPAL", styleGrid);
		createCell(ws.getRow(nRow), 2, "Нарахування по опаленню  в межах санiтарних норм  по нормативному тарифу + приєднане теплове навантаження", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OP_NEPOW", styleGrid);
		createCell(ws.getRow(nRow), 2, "Нарахування по опаленню  в межах санiтарних норм без додатку на сiм'ю  по нормативному тарифу + приєднане т.н.", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OPAL_NEP", styleGrid);
		createCell(ws.getRow(nRow), 2, "Нарахування по опаленню  в межах санітарних норм для утриманців соцзабезу по нормативному тарифу + приєднане т.н.", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OP_POWNE2", styleGrid);
		createCell(ws.getRow(nRow), 2, "Нарахування по опаленню  на всю площу по фактичному тарифу", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OPAL2", styleGrid);
		createCell(ws.getRow(nRow), 2, "Нарахування по опаленню  в межах санiтарних норм  по фактичному тарифу", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OP_NEPOW2", styleGrid);
		createCell(ws.getRow(nRow), 2, "Нарахування по опаленню  в межах санiтарних норм без додатку на сiм'ю  по фактичному тарифу", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OPAL_NEP2", styleGrid);
		createCell(ws.getRow(nRow), 2, "Нарахування по опаленню  в межах санiтарних норм для утриманців соцзабезу по фактичному тарифу", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OP_POWNE3", styleGrid);
		createCell(ws.getRow(nRow), 2, "Середньомісячне нарахування на опалення на повну площу", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OPAL3", styleGrid);
		createCell(ws.getRow(nRow), 2, "Середньомісячне нарахування на опалення в межах санiтарних норм", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OP_NEPOW3", styleGrid);
		createCell(ws.getRow(nRow), 2, "Середньомісячне нарахування на опалення в межах санiтарних норм без додатку на сiм'ю", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OP_NEP3", styleGrid);
		createCell(ws.getRow(nRow), 2, "Середньомісячне нарахування на опалення в межах санўтарних норм для утриманцўв соцзабезу", styleGrid);
		createCell(ws.createRow(++nRow), 1, "TAROP", styleGrid);
		createCell(ws.getRow(nRow), 2, "Тариф на опалення", styleGrid);
		createCell(ws.createRow(++nRow), 1, "TARYF_FK", styleGrid);
		createCell(ws.getRow(nRow), 2, "Тариф Умовно Змінної Частини Опалення", styleGrid);
		createCell(ws.createRow(++nRow), 1, "TARYF_PR", styleGrid);
		createCell(ws.getRow(nRow), 2, "Тариф Умовно Постійної Частини Опалення", styleGrid);
		createCell(ws.createRow(++nRow), 1, "BORGOP", styleGrid);
		createCell(ws.getRow(nRow), 2, "Борг по опаленню", styleGrid);
		createCell(ws.createRow(++nRow), 1, "K_W", styleGrid);
		createCell(ws.getRow(nRow), 2, "Форма власності квартири", styleGrid);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Сума по полю OP_POWNE:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumBill, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Сума по полю OP_REA:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumBill11, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Сума по полю OPAL:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumBill12, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Сума по полю OP_NEPOW:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumBill13, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Сума по полю OPAL_NEP:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumBill14, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Сума по полю OP_POWNE2:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumBill21, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Сума по полю OPAL2:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumBill22, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Сума по полю OP_NEPOW2:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumBill23, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Сума по полю OPAL_NEP2:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumBill24, styleGrid);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Директор");
		createCell(ws.createRow(++nRow), 1, "\"___\"_______________");
		createCell(ws.getRow(nRow), 2, "_________________/__________________________/");
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Головний бухгалтер");
		createCell(ws.createRow(++nRow), 1, "\"___\"_______________");
		createCell(ws.getRow(nRow), 2, "_________________/__________________________/");
		
		try
		{
			var os = new DpFileOutputStream(sXLSFile);
			wb.write(os);
			os.close();
		}
		catch(e)
		{
			var sMsg = UR("Неможливо створити протокол "+ sXLSFile +"!\nЯкщо існуючі файли відкиті, необхідно їх закрити і порторити експорт."
						+"|Невозможно создать протокол "+ sXLSFile +"!\nЕсли существующие файлы открыты, нужно их закрыть и повторить экспорт."
						);
			alert(sMsg, 1);
		}
	}
	catch(e)
	{
		alert(UR("Помилка при створенні протоколу!|Ошибка при создании протокола!") +"\n"+ e, 2);
	}
	
	setProgressPos(0);
	return true;
}

function exportSubH()
{
	var nPr = 1;
	var sPrText = UR("ЕКСПОРТ: Холодна вода|ЭКСПОРТ: Холодная вода");
	setProgressRange(0, 10);
	setProgressPos(nPr++, sPrText);
	
	var oDBF = createSubDBF("H");
	if(!oDBF)
	{
		setProgressPos(0);
		return false;
	}
	
	var sServ = "CWATER";
	var date = list.objAsk.rdate;
	var d1 = firstDay(date);
	var d2 = lastDay(date);
	var dSum = getPar("DECISUM");
	var rowCnt = 0;
	var sumBill = 0;
	var sumNorm = 0;
	var drainBill = 0;
	var drainNorm = 0;
	
	var tbl = OpenTable("select t.*, l.FDOG_NUM, l.FORG_TXT, l.FSTREET_TXT"
							+", l.FSTREET_COD, l.FHOUSE_NOM, l.FAPT_NOM"
						+" from "+ tblOut +" t"
						+" inner join ^LISTLICSC l on l.FID_DOG=t.FID_DOG"
						+" order by t.FSTREET, t.FHOUSE, t.FPLAT"
						);
	if(!tbl.isEmpty())
		setProgressRange(0, tbl.recordCount+5);
	setProgressPos(nPr++, sPrText);
	
	try
	{
		for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
		{
			setProgressPos(nPr++, sPrText);
			var nOrg = tbl.getValue("FPLAT");
			var dogID = tbl.getValue("FID_DOG");
			var houseID = tbl.getValue("FHOUSE");
			var apartID = tbl.getValue("FAPMT");
			var sAddr = tbl.getValue("FSTREET_TXT") +", "+ tbl.getValue("FHOUSE_NOM");
			var tarif = tariffKU(sServ, dogID, date);
			if(!tarif)
				continue;
			
			var sum = Number(tbl.getValue("FCOOL"));
			var pers = Number(tbl.getValue("FPERSKOL"));
			var debt = calcDebtKU(nOrg, dogID, date, 0, sServ, true);
			var norm = 0;
			var kol = 0;
			var oSnap = getSnap("select s.FNORM, sum(s.FKOL), s.FCENA, sum(s.FSUM)"
							+" from ^SKU_SERV s"
							+" inner join ^RAS_SKU r on r.FWID=s.FID_DOC"
							+" where r.FID_DOG="+ dogID 
								+" and r.FDOC_DAT>="+ sqlTo(d1) 
								+" and r.FDOC_DAT<="+ sqlTo(d2)
								+" and r.FISRECALC<>"+ sqlTrue
								+" and s.FSERV="+ sqlTo(sServ)
							, false
							);
			if(oSnap)
			{
				norm = Number(oSnap[0]);
				kol = Number(oSnap[1]);
				tarif = Number(oSnap[2]);
				sum = Number(oSnap[3]);
			}
			
			var drNorm = 0;
			var drKol = 0;
			var drCena = 0;
			var drSum = 0;
			var oSnap = getSnap("select s.FNORM, sum(s.FKOL), sum(s.FCENA), sum(s.FSUM)"
								+" from ^SKU_SERV s"
								+" inner join ^RAS_SKU r on r.FWID=s.FID_DOC"
								+" where r.FID_DOG="+ dogID 
									+" and r.FDOC_DAT>="+ sqlTo(d1) 
									+" and r.FDOC_DAT<="+ sqlTo(d2)
									+" and r.FISRECALC<>"+ sqlTrue
									+" and (s.FSERV='DRAIN' or s.FSERV='CDRAIN')"
								, false
								);
			if(oSnap)
			{
				drNorm = Number(oSnap[0]);
				drKol = Number(oSnap[1]);
				drCena = Number(oSnap[2]);
				drSum = Number(oSnap[3]);
			}
			
			var privTxt = "";
			var privPerc = "";
			var privMen = "";
			var privTbl = openPrivilegeTbl(dogID, date, "CWATER");
			for(; !privTbl.isEOF(); privTbl.MoveNext())
			{
				privTxt += (privTxt!=""? "," : "") + privTbl.getValue("FCOD");
				privPerc += (privPerc!=""? "," : "") + privTbl.getValue("FPERC");
				privMen += (privMen!=""? "," : "") + privTbl.getValue("FKOL");
			}
			privTbl.close();
			
			var gNorm = round(tarif*norm, dSum);
			var cntSnap = getSnap("select FBDAT, FEDAT"
								+" from ^SC_COUNTERS "
								+" where FID_DOG="+ dogID
									+" and FSERV="+ sqlTo(sServ)
									+" and FBDAT<="+ sqlTo(d2)
									+" and FEDAT>="+ sqlTo(d1)
								, false
								);
			
			var oRow = new Array(
							toScrObj(socDepCod)								//JEC_NOM 	- Код ЖЕКу
							,toScrObj(tbl.getValue("FDOG_NUM"))				//OS_R 		- Особовий  рахунок 
							,toScrObj(corectDbfTxt(sAddr))					//ADR 		- Адреса
							,toScrObj(tbl.getValue("FSTREET_COD"))			//KODSTREET	- Код вулиці
							,toScrObj(tbl.getValue("FHOUSE_NOM"))			//N_BUD 	- Номер будинку
							,toScrObj(tbl.getValue("FAPT_NOM"))				//N_KV      - Номер квартири
							,toScrObj(corectDbfTxt(tbl.getValue("FFIO")))	//PRIZ      - Прiзвище
							,toScrObj(pers)									//K_PR      - Кiлькiсть прописаних
							,toScrObj(debt)									//BORG 		- Забргованість абонентів
							,toScrObj(tbl.getValue("FDOG_NUM"))				//OS_R_OLD	- Старий код особового рахунку
							,toScrObj(privTxt)								//N_PILG    - Назва пiльги
							,toScrObj(privPerc)								//SKYDKA    - Скидка
							,toScrObj(privMen)								//NA_1		- Кiлькiсть людей на яку поширюeться пiльга   
							,""												//UGODA     - Угода
							,toScrObj(cntSnap? cntSnap[0] : null)			//DATAV     - Дата встановлення лічильника
							,toScrObj(gNorm)								//OPL_N	 	- Нормативне нарахування
							,toScrObj(sum)									//OPL_L		- Нарахування фактичне
							,toScrObj(drSum)								//VODOVID 	- Фактичне водовідведення 
							,toScrObj(round(drNorm*drCena, dSum))			//VODOVIDN 	- Нормативне водовідведення 
							,toScrObj(cntSnap!=null)						//LICH 		- Наявність квартирного лічильника
							,toScrObj(kol)									//KUB_F 	- 
							,toScrObj(norm)									//KUB_N 	- 
							,toScrObj(kol)									//M3FACT 	- 
							,toScrObj(norm)									//M3SPOG 	- 
							);
			//for(var i=0; i<oRow.length; i++)
			//	trace(i +" - "+ oRow[i])
			oDBF.addRecord(oRow);
			sumBill += sum;
			sumNorm += gNorm;
			drainBill += drSum;
			drainNorm += round(drNorm*drCena, dSum);
			rowCnt++;
		}
		oDBF.write();
	}
	catch(e)
	{
		alert(UR("Не вдалося виконати експорт!|Не удалось выполнить экспорт!") +"\n"+ e, 2);
		setProgressPos(0);
		tbl.close();
		return false;
	}
	
	tbl.close();
	setProgressPos(nPr++, sPrText);
	
	try
	{
		var sXLSFile = sSubDir +"/"+ sSubName +".XLS";
		if(isFile(sXLSFile))
		{
			try
			{
				deleteFile(sXLSFile);
			}
			catch(e)
			{
				var sMsg = UR("Неможливо створити протокол "+ sXLSFile +"!\nЯкщо існуючі файли відкиті, необхідно їх закрити і порторити експорт."
							+"|Невозможно создать протокол "+ sXLSFile +"!\nЕсли существующие файлы открыты, нужно их закрыть и повторить экспорт."
							);
				alert(sMsg, 1);
			}
		}
		var wb = lpProxy.createExcelWorkbook();
		var ws = wb.createSheet("DebetPlus");
		ws.setColumnWidth(0, 500);
		ws.setColumnWidth(1, 7000);
		ws.setColumnWidth(2, 14000);
			
		var styleBold = wb.createCellStyle();
		var fontBold = wb.createFont();
		fontBold.setBoldweight(0x2bc);
		styleBold.setFont(fontBold);
		styleBold.setAlignment(1);
		
		var styleGrid = wb.createCellStyle();
		styleGrid.setBorderBottom(1);
		styleGrid.setBorderTop(1);
		styleGrid.setBorderLeft(1);
		styleGrid.setBorderRight(1);
		styleGrid.setAlignment(1);
		
		var nRow = -1;
		createCell(ws.createRow(++nRow), 1, "ПРОТОКОЛ ПЕРЕДАЧI ЩОМIСЯЧНОI IНФОРМАЦII", styleBold);
		createCell(ws.createRow(++nRow), 1, "про нарахування холодної води", styleBold);
		createCell(ws.createRow(++nRow), 1, "по "+ getPar("OFIRM") +" за "+ format("Mmm yyyy", date).toLowerCase(), styleBold);
		createCell(ws.createRow(++nRow), 1, "у "+ getPar("HOCSOCDEP_TXT"), styleBold);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Назва носiя бази даних:", styleGrid);
		createCell(ws.getRow(nRow), 2, "магнітна дискета", styleGrid);
		createCell(ws.createRow(++nRow), 1, "Назва файлу бази даних:", styleGrid);
		createCell(ws.getRow(nRow), 2, sSubName, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Дата створення файлу:", styleGrid);
		createCell(ws.getRow(nRow), 2, format("dd.mm.yyyy", today), styleGrid);
		createCell(ws.createRow(++nRow), 1, "Час створення файлу:", styleGrid);
		createCell(ws.getRow(nRow), 2, format("HH:MM:SS", new Date()), styleGrid);
		createCell(ws.createRow(++nRow), 1, "Розмiр файлу в байтах:", styleGrid);
		createCell(ws.getRow(nRow), 2, new DpFile(sSubDBF).length(), styleGrid);
		createCell(ws.createRow(++nRow), 1, "Кiлькiсть записiв у файлi:", styleGrid);
		createCell(ws.getRow(nRow), 2, rowCnt, styleGrid);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "  Iмена полів бази даних", styleGrid);
		createCell(ws.getRow(nRow), 2, "  Опис значення", styleGrid);
		createCell(ws.createRow(++nRow), 1, "JEC_NOM", styleGrid);
		createCell(ws.getRow(nRow), 2, "Код ЛКП", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OS_R_NEW", styleGrid);
		createCell(ws.getRow(nRow), 2, "Особовий  рахунок", styleGrid);
		createCell(ws.createRow(++nRow), 1, "ADR", styleGrid);
		createCell(ws.getRow(nRow), 2, "Адреса", styleGrid);
		createCell(ws.createRow(++nRow), 1, "KODSTREET", styleGrid);
		createCell(ws.getRow(nRow), 2, "Код вулиці", styleGrid);
		createCell(ws.createRow(++nRow), 1, "N_BUD", styleGrid);
		createCell(ws.getRow(nRow), 2, "Номер будинку", styleGrid);
		createCell(ws.createRow(++nRow), 1, "N_KV", styleGrid);
		createCell(ws.getRow(nRow), 2, "Номер квартири", styleGrid);
		createCell(ws.createRow(++nRow), 1, "PRIZ", styleGrid);
		createCell(ws.getRow(nRow), 2, "Прiзвище абонента", styleGrid);
		createCell(ws.createRow(++nRow), 1, "K_PR", styleGrid);
		createCell(ws.getRow(nRow), 2, "Кiлькiсть прописаних", styleGrid);
		createCell(ws.createRow(++nRow), 1, "BORG", styleGrid);
		createCell(ws.getRow(nRow), 2, "Забргованість абонентів", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OS_R", styleGrid);
		createCell(ws.getRow(nRow), 2, "Старий код особового рахунку", styleGrid);
		createCell(ws.createRow(++nRow), 1, "N_PILG", styleGrid);
		createCell(ws.getRow(nRow), 2, "Назва пiльги", styleGrid);
		createCell(ws.createRow(++nRow), 1, "SKYDKA", styleGrid);
		createCell(ws.getRow(nRow), 2, "Скидка", styleGrid);
		createCell(ws.createRow(++nRow), 1, "NA_1", styleGrid);
		createCell(ws.getRow(nRow), 2, "Кiлькiсть людей на яку поширюeться пiльга", styleGrid);
		createCell(ws.createRow(++nRow), 1, "UGODA", styleGrid);
		createCell(ws.getRow(nRow), 2, "Угода", styleGrid);
		createCell(ws.createRow(++nRow), 1, "DATAV", styleGrid);
		createCell(ws.getRow(nRow), 2, "Дата встановлення лічильника", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OPL_N", styleGrid);
		createCell(ws.getRow(nRow), 2, "Нормативне нарахування", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OPL_L", styleGrid);
		createCell(ws.getRow(nRow), 2, "Нарахування фактичне ", styleGrid);
		createCell(ws.createRow(++nRow), 1, "VODOVID", styleGrid);
		createCell(ws.getRow(nRow), 2, "Фактичне водовідведення ", styleGrid);
		createCell(ws.createRow(++nRow), 1, "VODOVIDN", styleGrid);
		createCell(ws.getRow(nRow), 2, "Нормативне водовідведення ", styleGrid);
		createCell(ws.createRow(++nRow), 1, "LICH", styleGrid);
		createCell(ws.getRow(nRow), 2, "Наявність квартирного лічильника", styleGrid);
		/*createCell(ws.createRow(++nRow), 1, "KUB_F", styleGrid);
		createCell(ws.getRow(nRow), 2, "", styleGrid);
		createCell(ws.createRow(++nRow), 1, "KUB_N", styleGrid);
		createCell(ws.getRow(nRow), 2, "", styleGrid);
		createCell(ws.createRow(++nRow), 1, "M3FACT", styleGrid);
		createCell(ws.getRow(nRow), 2, "", styleGrid);
		createCell(ws.createRow(++nRow), 1, "M3SPOG", styleGrid);
		createCell(ws.getRow(nRow), 2, "", styleGrid);*/
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Сума по полю OPL_N:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumNorm, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Сума по полю OPL_L:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumBill, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Сума по полю VODOVID:", styleGrid);
		createCell(ws.getRow(nRow), 2, drainBill, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Сума по полю VODOVIDN:", styleGrid);
		createCell(ws.getRow(nRow), 2, drainNorm, styleGrid);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Директор");
		createCell(ws.createRow(++nRow), 1, "\"___\"_______________");
		createCell(ws.getRow(nRow), 2, "_________________/__________________________/");
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Головний бухгалтер");
		createCell(ws.createRow(++nRow), 1, "\"___\"_______________");
		createCell(ws.getRow(nRow), 2, "_________________/__________________________/");
		
		try
		{
			var os = new DpFileOutputStream(sXLSFile);
			wb.write(os);
			os.close();
		}
		catch(e)
		{
			var sMsg = UR("Неможливо створити протокол "+ sXLSFile +"!\nЯкщо існуючі файли відкиті, необхідно їх закрити і порторити експорт."
						+"|Невозможно создать протокол "+ sXLSFile +"!\nЕсли существующие файлы открыты, нужно их закрыть и повторить экспорт."
						);
			alert(sMsg, 1);
		}
	}
	catch(e)
	{
		alert(UR("Помилка при створенні протоколу!|Ошибка при создании протокола!") +"\n"+ e, 2);
	}
	
	setProgressPos(0);
	return true;
}

function exportSubG()
{
	var nPr = 1;
	var sPrText = UR("ЕКСПОРТ: Гаряча вода|ЭКСПОРТ: Горячая вода");
	setProgressRange(0, 10);
	setProgressPos(nPr++, sPrText);
	
	var oDBF = createSubDBF("G");
	if(!oDBF)
	{
		setProgressPos(0);
		return false;
	}
	
	var sServ = "HWATER";
	var date = list.objAsk.rdate;
	var d1 = firstDay(date);
	var d2 = lastDay(date);
	var dSum = getPar("DECISUM");
	var rowCnt = 0;
	var sumBill = 0;
	var sumNorm = 0;
	
	var tbl = OpenTable("select t.*, l.FDOG_NUM, l.FORG_TXT, l.FSTREET_TXT"
							+", l.FSTREET_COD, l.FHOUSE_NOM, l.FAPT_NOM"
						+" from "+ tblOut +" t"
						+" inner join ^LISTLICSC l on l.FID_DOG=t.FID_DOG"
						+" order by t.FSTREET, t.FHOUSE, t.FPLAT"
						);
	if(!tbl.isEmpty())
		setProgressRange(0, tbl.recordCount+5);
	setProgressPos(nPr++, sPrText);
	try
	{
		for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
		{
			setProgressPos(nPr++, sPrText);
			var nOrg = tbl.getValue("FPLAT");
			var dogID = tbl.getValue("FID_DOG");
			var houseID = tbl.getValue("FHOUSE");
			var apartID = tbl.getValue("FAPMT");
			var sAddr = tbl.getValue("FSTREET_TXT") +", "+ tbl.getValue("FHOUSE_NOM");
			var tarif = tariffKU(sServ, dogID, date);
			//if(!tarif)
			//	continue;
			
			var sum = Number(tbl.getValue("FHOT"));
			var pers = Number(tbl.getValue("FPERSKOL"));
			var debt = calcDebtKU(nOrg, dogID, date, 0, sServ, true);
			var norm = 0;
			var kol = 0;
			var oSnap = getSnap("select s.FNORM, sum(s.FKOL)"
							+" from ^SKU_SERV s"
							+" inner join ^RAS_SKU r on r.FWID=s.FID_DOC"
							+" where r.FID_DOG="+ dogID 
								+" and r.FDOC_DAT>="+ sqlTo(d1) 
								+" and r.FDOC_DAT<="+ sqlTo(d2)
								+" and r.FISRECALC<>"+ sqlTrue
								+" and s.FSERV="+ sqlTo(sServ)
							, false
							);
			if(oSnap && Number(oSnap[0]))
				norm = Number(oSnap[0]);
			if(oSnap && Number(oSnap[1]))
				kol = Number(oSnap[1]);
			
			var privTxt = "";
			var privPerc = "";
			var privMen = "";
			var privTbl = openPrivilegeTbl(dogID, date, "HWATER");
			for(; !privTbl.isEOF(); privTbl.MoveNext())
			{
				privTxt += (privTxt!=""? "," : "") + privTbl.getValue("FCOD");
				privPerc += (privPerc!=""? "," : "") + privTbl.getValue("FPERC");
				privMen += (privMen!=""? "," : "") + privTbl.getValue("FKOL");
			}
			privTbl.close();
			
			var hsCnt = isCounters(dogID, 0, sServ, houseID, date);
			var kvCnt = isCounters(dogID, 0, sServ, 0, date);
			var fact = counters(sServ, dogID, date, "D");
			var gPersNorm = pers==0? 0 : round((norm*tarif/pers), dSum);
			var gNorm = round(tarif*norm, dSum);
			
			var oApmt = getSnap("select FPROPERTY"
								+" from ^CL_APARTMENT "
								+" where FWID_CL="+ apartID
								, false
								);
			var oHs = getSnap("select FTYPE,FWATERSERV"
								+" from ^CL_HOUSE "
								+" where FWID_CL="+ houseID
								, false
								);
			var oSnap = getSnap("select FBDAT, FEDAT"
								+" from ^SC_SERV "
								+" where FID_DOG="+ dogID
									+" and FSERV="+ sqlTo(sServ)
									+" and FBDAT<="+ sqlTo(d2)
									+" and FEDAT>="+ sqlTo(d1)
								, false
								);
			var dat1 = firstDay(date);
			var dat2 = lastDay(date);
			if(oSnap)
			{
				if(differ(oSnap[0], dat1)>0)
					dat1 = oSnap[0];
				if(differ(oSnap[1], dat2)<0)
					dat2 = oSnap[1];
			}
			var days = day_difference(dat1, dat2);
			
			var oRow = new Array(
							toScrObj(socDepCod)								//JEC_NOM 	- Код ЖЕКу
							,toScrObj(tbl.getValue("FDOG_NUM"))				//OS_R 		- Особовий  рахунок 
							,toScrObj(corectDbfTxt(sAddr))					//ADR 		- Адреса
							,toScrObj(tbl.getValue("FSTREET_COD"))			//KODSTREET	- Код вулиці
							,toScrObj(tbl.getValue("FHOUSE_NOM"))			//N_BUD 	- Номер будинку
							,toScrObj(tbl.getValue("FAPT_NOM"))				//N_KV      - Номер квартири
							,toScrObj(corectDbfTxt(tbl.getValue("FFIO")))	//PRIZ      - Прiзвище
							,toScrObj(pers)									//K_PR      - Кiлькiсть прописаних
							,toScrObj(tarif==0? 0 : 1)						//G_WODA	- Признак чи є гар.вода
							,toScrObj(hsCnt)								//LIW_BUD	- Признак будинкового лічильника на гар.воду   (t або f)
							,toScrObj(kvCnt)								//LI_W		- Признак квартирного лічильника на гар.воду   (t або f)
							,toScrObj(tbl.getValue("FDOG_NUM"))				//OS_R_OLD	- Старий код особового рахунку
							,toScrObj(privTxt)								//N_PILG    - Назва пiльги
							,toScrObj(privPerc)								//SKYDKA    - Скидка
							,toScrObj(privMen)								//NA_1		- Кiлькiсть людей на яку поширюeться пiльга   
							,""												//UGODA     - Угода по гарячій воді
							,toScrObj(sum)									//WOD_REA	- Реальне нарахування по гарячiй водi
							,toScrObj(gNorm)								//WODA	 	- Гар. вода (норма)
							,0												//LIW_REA 	- Середньомісячне нарахування по гар.воді
							,toScrObj(debt)									//BORGGV 	- Борг по гарячій воді
							,toScrObj(fact)									//GW_FACT 	- Об’єм гарячої води спожиті згідно лічильника
							,toScrObj(gPersNorm)							//NW_FACT 	- Норма гарячої води на одну людину, в грн
							,toScrObj(days)									//GW_ND 	- Кількість днів подачі гарячої води
							,toScrObj(oHs? oHs[1] : 0)						//GW_TB 	- Тип будинку для гарячої води
							,toScrObj(oApmt? oApmt[0] : 0)					//K_W 		- Форма власності квартири
							);
			//for(var i=0; i<oRow.length; i++)
			//	trace(i +" - "+ oRow[i])
			oDBF.addRecord(oRow);
			sumBill += sum;
			sumNorm += gNorm;
			rowCnt++;
		}
		oDBF.write();
	}
	catch(e)
	{
		alert(UR("Не вдалося виконати експорт!|Не удалось выполнить экспорт!") +"\n"+ e, 2);
		setProgressPos(0);
		tbl.close();
		return false;
	}
	tbl.close();
	setProgressPos(nPr++, sPrText);
	
	try
	{
		var sXLSFile = sSubDir +"/"+ sSubName +".XLS";
		if(isFile(sXLSFile))
		{
			try
			{
				deleteFile(sXLSFile);
			}
			catch(e)
			{
				var sMsg = UR("Неможливо створити протокол "+ sXLSFile +"!\nЯкщо існуючі файли відкиті, необхідно їх закрити і порторити експорт."
						+"|Невозможно создать протокол "+ sXLSFile +"!\nЕсли существующие файлы открыты, нужно их закрыть и повторить экспорт."
						);
				alert(sMsg, 1);
			}
		}
		var wb = lpProxy.createExcelWorkbook();
		var ws = wb.createSheet("DebetPlus");
		ws.setColumnWidth(0, 500);
		ws.setColumnWidth(1, 7000);
		ws.setColumnWidth(2, 14000);
			
		var styleBold = wb.createCellStyle();
		var fontBold = wb.createFont();
		fontBold.setBoldweight(0x2bc);
		styleBold.setFont(fontBold);
		styleBold.setAlignment(1);
		
		var styleGrid = wb.createCellStyle();
		styleGrid.setBorderBottom(1);
		styleGrid.setBorderTop(1);
		styleGrid.setBorderLeft(1);
		styleGrid.setBorderRight(1);
		styleGrid.setAlignment(1);
		
		var nRow = -1;
		createCell(ws.createRow(++nRow), 1, "ПРОТОКОЛ ПЕРЕДАЧI ЩОМIСЯЧНОI IНФОРМАЦII", styleBold);
		createCell(ws.createRow(++nRow), 1, "про нарахування за гарячу воду", styleBold);
		createCell(ws.createRow(++nRow), 1, "по "+ getPar("OFIRM") +" за "+ format("Mmm yyyy", date).toLowerCase(), styleBold);
		createCell(ws.createRow(++nRow), 1, "у "+ getPar("HOCSOCDEP_TXT"), styleBold);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Назва носiя бази даних:", styleGrid);
		createCell(ws.getRow(nRow), 2, "магнітна дискета", styleGrid);
		createCell(ws.createRow(++nRow), 1, "Назва файлу бази даних:", styleGrid);
		createCell(ws.getRow(nRow), 2, sSubName, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Дата створення файлу:", styleGrid);
		createCell(ws.getRow(nRow), 2, format("dd.mm.yyyy", today), styleGrid);
		createCell(ws.createRow(++nRow), 1, "Час створення файлу:", styleGrid);
		createCell(ws.getRow(nRow), 2, format("HH:MM:SS", new Date()), styleGrid);
		createCell(ws.createRow(++nRow), 1, "Розмiр файлу в байтах:", styleGrid);
		createCell(ws.getRow(nRow), 2, new DpFile(sSubDBF).length(), styleGrid);
		createCell(ws.createRow(++nRow), 1, "Кiлькiсть записiв у файлi:", styleGrid);
		createCell(ws.getRow(nRow), 2, rowCnt, styleGrid);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "  Iмена полів бази даних", styleGrid);
		createCell(ws.getRow(nRow), 2, "  Опис значення", styleGrid);
		createCell(ws.createRow(++nRow), 1, "JEC_NOM", styleGrid);
		createCell(ws.getRow(nRow), 2, "Номер ЖЕКу", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OS_R_NEW", styleGrid);
		createCell(ws.getRow(nRow), 2, "Особовий  рахунок", styleGrid);
		createCell(ws.createRow(++nRow), 1, "ADR", styleGrid);
		createCell(ws.getRow(nRow), 2, "Адреса", styleGrid);
		createCell(ws.createRow(++nRow), 1, "KODSTREET", styleGrid);
		createCell(ws.getRow(nRow), 2, "Код вулиці", styleGrid);
		createCell(ws.createRow(++nRow), 1, "N_BUD", styleGrid);
		createCell(ws.getRow(nRow), 2, "Номер будинку", styleGrid);
		createCell(ws.createRow(++nRow), 1, "N_KV", styleGrid);
		createCell(ws.getRow(nRow), 2, "Номер квартири", styleGrid);
		createCell(ws.createRow(++nRow), 1, "PRIZ", styleGrid);
		createCell(ws.getRow(nRow), 2, "Прiзвище", styleGrid);
		createCell(ws.createRow(++nRow), 1, "K_PR", styleGrid);
		createCell(ws.getRow(nRow), 2, "Кiлькiсть прописаних", styleGrid);
		createCell(ws.createRow(++nRow), 1, "G_WODA", styleGrid);
		createCell(ws.getRow(nRow), 2, "Признак чи є гар.вода", styleGrid);
		createCell(ws.createRow(++nRow), 1, "LIW_BUD", styleGrid);
		createCell(ws.getRow(nRow), 2, "Признак будинкового лічильника на гар.воду (t або f)", styleGrid);
		createCell(ws.createRow(++nRow), 1, "LI_W", styleGrid);
		createCell(ws.getRow(nRow), 2, "Признак квартирного лічильника на гар.воду (t або f)", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OS_R", styleGrid);
		createCell(ws.getRow(nRow), 2, "Старий код особового рахунку", styleGrid);
		createCell(ws.createRow(++nRow), 1, "N_PILG", styleGrid);
		createCell(ws.getRow(nRow), 2, "Назва пiльги", styleGrid);
		createCell(ws.createRow(++nRow), 1, "SKYDKA", styleGrid);
		createCell(ws.getRow(nRow), 2, "Скидка", styleGrid);
		createCell(ws.createRow(++nRow), 1, "NA_1", styleGrid);
		createCell(ws.getRow(nRow), 2, "Кiлькiсть людей на яку поширюeться пiльга", styleGrid);
		createCell(ws.createRow(++nRow), 1, "UGODA", styleGrid);
		createCell(ws.getRow(nRow), 2, "Угода", styleGrid);
		createCell(ws.createRow(++nRow), 1, "WOD_REA", styleGrid);
		createCell(ws.getRow(nRow), 2, "Реальне нарахування по гарячiй водi", styleGrid);
		createCell(ws.createRow(++nRow), 1, "WODA", styleGrid);
		createCell(ws.getRow(nRow), 2, "Гар. вода (норма)", styleGrid);
		createCell(ws.createRow(++nRow), 1, "LIW_REA", styleGrid);
		createCell(ws.getRow(nRow), 2, "Середньомісячне нарахування по гар.воді", styleGrid);
		createCell(ws.createRow(++nRow), 1, "BORGGV", styleGrid);
		createCell(ws.getRow(nRow), 2, "Борг по гарячій воді", styleGrid);
		createCell(ws.createRow(++nRow), 1, "GW_FACT", styleGrid);
		createCell(ws.getRow(nRow), 2, "Об’єм гарячої води спожиті згідно лічильника", styleGrid);
		createCell(ws.createRow(++nRow), 1, "NW_FACT", styleGrid);
		createCell(ws.getRow(nRow), 2, "Норма гарячої води на одну людину, в грн", styleGrid);
		createCell(ws.createRow(++nRow), 1, "GW_ND", styleGrid);
		createCell(ws.getRow(nRow), 2, "Кількість днів подачі гарячої води", styleGrid);
		createCell(ws.createRow(++nRow), 1, "GW_TB", styleGrid);
		createCell(ws.getRow(nRow), 2, "Тип будинку для гарячої води", styleGrid);
		createCell(ws.createRow(++nRow), 1, "K_W", styleGrid);
		createCell(ws.getRow(nRow), 2, "Форма власності квартири", styleGrid);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Сума по полю WODA:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumNorm, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Сума по полю WOD_REA:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumBill, styleGrid);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Директор");
		createCell(ws.createRow(++nRow), 1, "\"___\"_______________");
		createCell(ws.getRow(nRow), 2, "_________________/__________________________/");
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Головний бухгалтер");
		createCell(ws.createRow(++nRow), 1, "\"___\"_______________");
		createCell(ws.getRow(nRow), 2, "_________________/__________________________/");
		
		try
		{
			var os = new DpFileOutputStream(sXLSFile);
			wb.write(os);
			os.close();
		}
		catch(e)
		{
			var sMsg = UR("Неможливо створити протокол "+ sXLSFile +"!\nЯкщо існуючі файли відкиті, необхідно їх закрити і порторити експорт."
						+"|Невозможно создать протокол "+ sXLSFile +"!\nЕсли существующие файлы открыты, нужно их закрыть и повторить экспорт."
						);
			alert(sMsg, 1);
		}
	}
	catch(e)
	{
		alert(UR("Помилка при створенні протоколу!|Ошибка при создании протокола!") +"\n"+ e, 2);
	}
	
	setProgressPos(0);
	return true;
}

function exportSubE()
{
	var nPr = 1;
	var sPrText = UR("ЕКСПОРТ: Електроенергія|ЭКСПОРТ: Электроэнергия");
	setProgressRange(0, 10);
	setProgressPos(nPr++, sPrText);
	
	var oDBF = createSubDBF("E");
	if(!oDBF)
	{
		setProgressPos(0);
		return false;
	}
	
	var sServ = "ELECTRIC";
	var date = list.objAsk.rdate;
	var d1 = firstDay(date);
	var d2 = lastDay(date);
	var dSum = getPar("DECISUM");
	var rowCnt = 0;
	var sumBill = 0;
	var sumNorm = 0;
	
	var tbl = OpenTable("select t.*, l.FDOG_NUM, l.FORG_TXT, l.FSTREET_TXT"
							+", l.FSTREET_COD, l.FHOUSE_NOM, l.FAPT_NOM"
						+" from "+ tblOut +" t"
						+" inner join ^LISTLICSC l on l.FID_DOG=t.FID_DOG"
						+" order by t.FSTREET, t.FHOUSE, t.FPLAT"
						);
	if(!tbl.isEmpty())
		setProgressRange(0, tbl.recordCount+5);
	setProgressPos(nPr++, sPrText);
	try
	{
		for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
		{
			setProgressPos(nPr++, sPrText);
			var nOrg = tbl.getValue("FPLAT");
			var dogID = tbl.getValue("FID_DOG");
			var sAddr = tbl.getValue("FSTREET_TXT") +", "+ tbl.getValue("FHOUSE_NOM");
			var tarif = tariffKU(sServ, dogID, date);
			if(!tarif)
				continue;
			
			var sum = Number(tbl.getValue("FELECTRIC"));
			var debt = calcDebtKU(nOrg, dogID, date, 0, sServ, true);
			var norm = 0;
			var kol = 0;
			var oSnap = getSnap("select s.FNORM, sum(s.FKOL)"
							+" from ^SKU_SERV s"
							+" inner join ^RAS_SKU r on r.FWID=s.FID_DOC"
							+" where r.FID_DOG="+ dogID 
								+" and r.FDOC_DAT>="+ sqlTo(d1) 
								+" and r.FDOC_DAT<="+ sqlTo(d2)
								+" and r.FISRECALC<>"+ sqlTrue
								+" and s.FSERV="+ sqlTo(sServ)
							, false
							);
			if(oSnap && Number(oSnap[0]))
				norm = Number(oSnap[0]);
			if(oSnap && Number(oSnap[1]))
				kol = Number(oSnap[1]);
				
			var privTxt = "";
			var privPerc = "";
			var privMen = "";
			var privTbl = openPrivilegeTbl(dogID, date, "ELECTRIC");
			for(; !privTbl.isEOF(); privTbl.MoveNext())
			{
				privTxt += (privTxt!=""? "," : "") + privTbl.getValue("FCOD");
				privPerc += (privPerc!=""? "," : "") + privTbl.getValue("FPERC");
				privMen += (privMen!=""? "," : "") + privTbl.getValue("FKOL");
			}
			privTbl.close();
			
			var oRow = new Array(
							toScrObj(socDepCod)								//JEC_NOM 	- Код ЖЕКу
							,toScrObj(tbl.getValue("FDOG_NUM"))				//OS_R 		- Особовий  рахунок 
							,toScrObj(corectDbfTxt(sAddr))					//ADR 		- Адреса
							,toScrObj(tbl.getValue("FSTREET_COD"))			//KODSTREET	- Код вулиці
							,toScrObj(tbl.getValue("FHOUSE_NOM"))			//N_BUD 	- Номер будинку
							,toScrObj(tbl.getValue("FAPT_NOM"))				//N_KV      - Номер квартири
							,toScrObj(corectDbfTxt(tbl.getValue("FFIO")))	//PRIZ      - Прiзвище
							,toScrObj(tbl.getValue("FPERSKOL"))				//K_PR      - Кiлькiсть прописаних
							,toScrObj(tarif)								//TARYF_EL	- Тариф на електрику
							,toScrObj(debt) 								//BELEC - Борг по електроенергiї
							,toScrObj(tbl.getValue("FDOG_NUM"))				//OS_R_OLD	- Старий код особового рахунку
							,toScrObj(privTxt)								//N_PILG    - Назва пiльги
							,toScrObj(privPerc)								//SKYDKA    - Скидка   
							,toScrObj(privMen)								//NA_1		- Кiлькiсть людей на яку поширюeться пiльга
							,toScrObj(sum)									//NELLG     - Нарахування по електроенергii реальне 
							,toScrObj(round(tarif*norm, dSum))				//NNORMAEL  - Нарахування по електроенергii по нормi
							,""												//UGODA    	- Угода
							,toScrObj(kol)		//KVT_F
							,toScrObj(norm)		//KVT_N
							);
			oDBF.addRecord(oRow);
			sumBill += sum;
			sumNorm += round(tarif*norm, dSum);
			rowCnt++;
		}
		oDBF.write();
	}
	catch(e)
	{
		alert(UR("Не вдалося виконати експорт!|Не удалось выполнить экспорт!") +"\n"+ e, 2);
		setProgressPos(0);
		tbl.close();
		return false;
	}
	tbl.close();
	setProgressPos(nPr++, sPrText);
	
	try
	{
		var sXLSFile = sSubDir +"/"+ sSubName +".XLS";
		if(isFile(sXLSFile))
		{
			try
			{
				deleteFile(sXLSFile);
			}
			catch(e)
			{
				var sMsg = UR("Неможливо створити протокол "+ sXLSFile +"!\nЯкщо існуючі файли відкиті, необхідно їх закрити і порторити експорт."
						+"|Невозможно создать протокол "+ sXLSFile +"!\nЕсли существующие файлы открыты, нужно их закрыть и повторить экспорт."
						);
				alert(sMsg, 1);
			}
		}
		var wb = lpProxy.createExcelWorkbook();
		var ws = wb.createSheet("DebetPlus");
		ws.setColumnWidth(0, 500);
		ws.setColumnWidth(1, 7000);
		ws.setColumnWidth(2, 14000);
			
		var styleBold = wb.createCellStyle();
		var fontBold = wb.createFont();
		fontBold.setBoldweight(0x2bc);
		styleBold.setFont(fontBold);
		styleBold.setAlignment(1);
		
		var styleGrid = wb.createCellStyle();
		styleGrid.setBorderBottom(1);
		styleGrid.setBorderTop(1);
		styleGrid.setBorderLeft(1);
		styleGrid.setBorderRight(1);
		styleGrid.setAlignment(1);
		
		var nRow = -1;
		createCell(ws.createRow(++nRow), 1, "ПРОТОКОЛ ПЕРЕДАЧI ЩОМIСЯЧНОI IНФОРМАЦII", styleBold);
		createCell(ws.createRow(++nRow), 1, "про нарахування  електроенергії", styleBold);
		createCell(ws.createRow(++nRow), 1, "по "+ getPar("OFIRM") +" за "+ format("Mmm yyyy", date).toLowerCase(), styleBold);
		createCell(ws.createRow(++nRow), 1, "у "+ getPar("HOCSOCDEP_TXT"), styleBold);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Назва носiя бази даних:", styleGrid);
		createCell(ws.getRow(nRow), 2, "магнітна дискета", styleGrid);
		createCell(ws.createRow(++nRow), 1, "Назва файлу бази даних:", styleGrid);
		createCell(ws.getRow(nRow), 2, sSubName, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Дата створення файлу:", styleGrid);
		createCell(ws.getRow(nRow), 2, format("dd.mm.yyyy", today), styleGrid);
		createCell(ws.createRow(++nRow), 1, "Час створення файлу:", styleGrid);
		createCell(ws.getRow(nRow), 2, format("HH:MM:SS", new Date()), styleGrid);
		createCell(ws.createRow(++nRow), 1, "Розмiр файлу в байтах:", styleGrid);
		createCell(ws.getRow(nRow), 2, new DpFile(sSubDBF).length(), styleGrid);
		createCell(ws.createRow(++nRow), 1, "Кiлькiсть записiв у файлi:", styleGrid);
		createCell(ws.getRow(nRow), 2, rowCnt, styleGrid);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "  Iмена полів бази даних", styleGrid);
		createCell(ws.getRow(nRow), 2, "  Опис значення", styleGrid);
		createCell(ws.createRow(++nRow), 1, "JEC_NOM", styleGrid);
		createCell(ws.getRow(nRow), 2, "Код ЖЕКу", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OS_R_NEW", styleGrid);
		createCell(ws.getRow(nRow), 2, "Особовий  рахунок", styleGrid);
		createCell(ws.createRow(++nRow), 1, "ADR", styleGrid);
		createCell(ws.getRow(nRow), 2, "Адреса", styleGrid);
		createCell(ws.createRow(++nRow), 1, "KODSTREET", styleGrid);
		createCell(ws.getRow(nRow), 2, "Код вулиці", styleGrid);
		createCell(ws.createRow(++nRow), 1, "N_BUD", styleGrid);
		createCell(ws.getRow(nRow), 2, "Номер будинку", styleGrid);
		createCell(ws.createRow(++nRow), 1, "N_KV", styleGrid);
		createCell(ws.getRow(nRow), 2, "Номер квартири", styleGrid);
		createCell(ws.createRow(++nRow), 1, "PRIZ", styleGrid);
		createCell(ws.getRow(nRow), 2, "Прiзвище", styleGrid);
		createCell(ws.createRow(++nRow), 1, "K_PR", styleGrid);
		createCell(ws.getRow(nRow), 2, "Кiлькiсть прописаних", styleGrid);
		createCell(ws.createRow(++nRow), 1, "TARYF_EL", styleGrid);
		createCell(ws.getRow(nRow), 2, "Тариф на електрику", styleGrid);
		createCell(ws.createRow(++nRow), 1, "BELEC", styleGrid);
		createCell(ws.getRow(nRow), 2, "Борг по електроенергiї", styleGrid);
		createCell(ws.createRow(++nRow), 1, "OS_R", styleGrid);
		createCell(ws.getRow(nRow), 2, "Старий код особового рахунку", styleGrid);
		createCell(ws.createRow(++nRow), 1, "N_PILG", styleGrid);
		createCell(ws.getRow(nRow), 2, "Назва пiльги", styleGrid);
		createCell(ws.createRow(++nRow), 1, "SKYDKA", styleGrid);
		createCell(ws.getRow(nRow), 2, "Скидка", styleGrid);
		createCell(ws.createRow(++nRow), 1, "NA_1", styleGrid);
		createCell(ws.getRow(nRow), 2, "Кiлькiсть людей на яку поширюeться пiльга", styleGrid);
		createCell(ws.createRow(++nRow), 1, "NELLG", styleGrid);
		createCell(ws.getRow(nRow), 2, "Нарахування по електроенергii реальне", styleGrid);
		createCell(ws.createRow(++nRow), 1, "NNORMAEL", styleGrid);
		createCell(ws.getRow(nRow), 2, "Нарахування по електроенергii по нормi", styleGrid);
		createCell(ws.createRow(++nRow), 1, "UGODA", styleGrid);
		createCell(ws.getRow(nRow), 2, "Угода", styleGrid);
		//createCell(ws.createRow(++nRow), 1, "KVT_F", styleGrid);
		//createCell(ws.getRow(nRow), 2, "", styleGrid);
		//createCell(ws.createRow(++nRow), 1, "KVT_N", styleGrid);
		//createCell(ws.getRow(nRow), 2, "", styleGrid);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Сума по полю NELLG:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumBill, styleGrid);
		createCell(ws.createRow(++nRow), 1, "Сума по полю NNORMAEL:", styleGrid);
		createCell(ws.getRow(nRow), 2, sumNorm, styleGrid);
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Директор");
		createCell(ws.createRow(++nRow), 1, "\"___\"_______________");
		createCell(ws.getRow(nRow), 2, "_________________/__________________________/");
		ws.createRow(++nRow);
		createCell(ws.createRow(++nRow), 1, "Головний бухгалтер");
		createCell(ws.createRow(++nRow), 1, "\"___\"_______________");
		createCell(ws.getRow(nRow), 2, "_________________/__________________________/");
		
		try
		{
			var os = new DpFileOutputStream(sXLSFile);
			wb.write(os);
			os.close();
		}
		catch(e)
		{
			var sMsg = UR("Неможливо створити протокол "+ sXLSFile +"!\nЯкщо існуючі файли відкиті, необхідно їх закрити і порторити експорт."
						+"|Невозможно создать протокол "+ sXLSFile +"!\nЕсли существующие файлы открыты, нужно их закрыть и повторить экспорт."
						);
			alert(sMsg, 1);
		}
	}
	catch(e)
	{
		alert(UR("Помилка при створенні протоколу!|Ошибка при создании протокола!") +"\n"+ e, 2);
	}
	setProgressPos(0);
	return true;
}

function createCell(oRow, nCol, sTxt, oStyle)
{
	var cell = oRow.createCell(nCol);
	cell.setCellValue(sTxt);
	if(oStyle)
		cell.setCellStyle(oStyle)
	return cell;
}

function browseSubDir()
{
	var sMsg = UR("Експорт виконано: "+ sSubDir +".\nВідкрити папку?|Экспорт выполнен: "+ sSubDir +".\nОткрыть папку?");
	if(confirm(sMsg))
	{
		var sFile = BrowseForFile("*.*", "", sSubDir);
		if(sFile)
			shellOpen(sFile);
	}
}

function skunorm(dogID, sServ, date)
{
	var d1 = firstDay(date);
	var d2 = lastDay(date);
	var oSnap = getSnap("select s.FNORM from ^SKU_SERV s"
						+" inner join ^RAS_SKU r on r.FWID=s.FID_DOC"
						+" where r.FID_DOG="+ dogID 
							+" and r.FDOC_DAT>="+ sqlTo(d1) 
							+" and r.FDOC_DAT<="+ sqlTo(d2)
							+" and r.FISRECALC<>"+ sqlTrue
							+" and s.FSERV="+ sqlTo(sServ)
						, false
						);
	if(oSnap && Number(oSnap[0]))
		return Number(oSnap[0]);
	return 0;
}

function openPrivilegeTbl(dogID, date, serv)
{
	if(!date)
		date = today;
	var d1 = firstDay(date);
	var d2 = lastDay(date);
	var tPriv = OpenTable("select max(p.FKOL) as FKOL, max(r.FCOD) as FCOD"
							+", max(e.FTYPE) as FTYPE, max(e.FPERC) as FPERC"
							+", max(pm.FFAMILYPRIVILEGE) as FFAMILYPRIVILEGE"
						+" from ^CL_EXEMPT e"
						+" inner join ^CLRELCLCL r on r.FWID_CL=e.FWID_CL"
						+" inner join ^SC_PRIV p on p.FID_LG=e.FWID_CL"
						+" inner join ^SC_PRIVMEN pm on pm.FID_PRIV=p.FWID"
						+" inner join ^SC_MEN m on m.FWID=pm.FID_MEN"
						+" where m.FID_DOG="+ dogID
							+" and m.FBDAT<="+ sqlTo(d2)
							+" and m.FEDAT>="+ sqlTo(d1)
							+" and p.FBDAT<="+ sqlTo(d2)
							+" and p.FEDAT>="+ sqlTo(d1)
							+(serv? " and e.F"+serv+"="+sqlTrue : "")
						+" group by pm.FID_PRIV"
						+" order by pm.FID_PRIV"
						);
	return tPriv;
}

include("sys/DpList.js");