//Реестр удержаний из зарплаты
include("Objects/DpCl.js");

var tblOut = getTmpTableName();	//таблица с результатами
var label  = "vedku";			//метка для печати
var oOrg;

function listLoad()
{
	this.xmlGridFile = "r_vedku_zrp.xml";
	this.printLabel = label;
	this.accDel = null;
	
	oOrg = new DpCl("0");
	oOrg.setClcl(getPar("CODPRED"));
	oOrg.linkSmartCtrl(FORG);
	oOrg.setContAssist();
	
	this.filter = filter;
	setButton(BTNFILTER, this, "filter");
}

function listTitle()
{
	var sCapt = UR("Реєстр утримань із зарплати|Реестр удержаний из зарплаты");
	return sCapt;
}

function filter()
{
	list.qryWhere = oOrg.getCod()? " FKODP="+ oOrg.getCod() +" or FTT='SUM'" : "1=1";
	listMake();
	list.tblInit();
}

function listSrc()
{	
	this.qrySet("From", tblOut
				, "Where", (oOrg.getCod()? " FKODP="+ oOrg.getCod() : "1=1")
				, "Order", "Ftt, FSTREET, FHOUSE, FPLAT"
				);
	
	this.subTie("cl_house", "hs", "FWID_CL", "FHOUSE");
	this.subTie("cl_apartment", "apt", "FWID_CL", "FAPMT");
}

function listMake()
{
	var nPr = 1;
	var sPrText = ru("Расчет...","Розрахунок...");
	setProgressRange(0, 7);
	setProgressPos(nPr++, sPrText);
	
	createOutTable();
	setProgressPos(nPr++, sPrText);
	
	var nPlatCL = getPar("CODPLAT");
	var tblExt = getPath("ALL_MDB") +".CL_"+ nPlatCL;	//расширения плательщиков
	var tblSku = extPar.tblName;
	var date = extPar.bdat;
	var sFld = "FTT, FSTREET, FHOUSE, FAPMT, FID_DOG, FPLAT"
			+", FLIVAREA, FLOGAREA, FBALAREA"
			+", FRENT, FHEAT, FCOOL, FHOT, FGAS, FELECTRIC"
			+", FSUM, FSUB, FPLATSUM, FDEPT"
			+", FFIO, FAPMTNOM, FPERSKOL, FEXMPTKOL"
			+", FHOTVOL, FCOOLVOL, FHOTPREV, FCOOLPREV"
			+", FBBALANS, FEBALANS, FTN, FKODP, FDATE";
	var sSql = "INSERT INTO "+ tblOut +" ("+ sFld +") "
			+" SELECT s.FTT, s.FSTREET, s.FHOUSE, s.FAPMT, s.FID_DOG, s.FPLAT"
				+", s.FLIVAREA, s.FLOGAREA, s.FBALAREA"
				+", s.FRENT, s.FHEAT, s.FCOOL, s.FHOT, s.FGAS, s.FELECTRIC"
				+", s.FSUM, s.FSUB, s.FPLATSUM, s.FDEPT"
				+", s.FFIO, s.FAPMTNOM, s.FPERSKOL, s.FEXMPTKOL"
				+", s.FHOTVOL, s.FCOOLVOL, s.FHOTPREV, s.FCOOLPREV"
				+", s.FBBALANS, s.FEBALANS, ext.FTN, ext.FKODP, "+ sqlTo(date)
			+" FROM "+ tblSku +" s "
				+" inner join ^CLRELCLCL c on c.FCOD=s.FPLAT and c.FCL="+ nPlatCL
				+" inner join "+ tblExt +" ext on ext.FMAINWID=c.FWID_CL"
			+" WHERE ext.FTN>0"
				+(oOrg.getCod()? " and ext.FKODP="+ oOrg.getCod() : "");
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	//итоги
	ExecuteSQL("DROP TABLE "+ tblOut +"_ITOG", false);
	sFromFld = "0 as FSTREET, 0 as FHOUSE, "+ sqlTo(date) +" as FDATE"
				+", 0 as FAPMT, 0 as FID_DOG, 0 as FPLAT, 0 as FTN, 0 as FKODP"
				+", sum(FLIVAREA) as FLIVAREA"
				+", sum(FLOGAREA) as FLOGAREA"
				+", sum(FBALAREA) as FBALAREA"
				+", sum(FRENT) as FRENT, sum(FHEAT) as FHEAT"
				+", sum(FCOOL) as FCOOL, sum(FHOT) as FHOT"
				+", sum(FGAS) as FGAS, sum(FELECTRIC) as FELECTRIC"
				+", sum(FSUM) as FSUM, sum(FSUB) as FSUB"
				+", sum(FPLATSUM) as FPLATSUM, sum(FDEPT) as FDEPT"
				+", '' as FFIO, 0 as FAPMTNOM"
				+", 0 as FPERSKOL, 0 as FEXMPTKOL"
				+", sum(FHOTVOL) as FHOTVOL, sum(FCOOLVOL) as FCOOLVOL"
				+", sum(FHOTPREV) as FHOTPREV, sum(FCOOLPREV) as FCOOLPREV"
				+", sum(FBBALANS) as FBBALANS, sum(FEBALANS) as FEBALANS"
	sSql = "select 'SUM' as FTT, "+ sFromFld
			+" into "+ tblOut +"_ITOG from "+ tblOut;	
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);	
					
	sSql = "INSERT INTO "+ tblOut +" ("+ sFld +")" 
			+" SELECT "+ sFld 
			+" FROM "+ tblOut +"_ITOG";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);	
		
	setProgressPos(0);
}

function createOutTable(sTblName)
{
	if(!sTblName)
		sTblName = tblOut;
	if(!ExecuteSQL("DROP TABLE "+ sTblName, false))//если окно открыто, очистим таблицу для нового окна 
		ExecuteSQL("DELETE FROM "+ sTblName, false)
	var sSql = "CREATE TABLE "+ sTblName 
			+"(FPLAT "+ SqlType("INT") 		//плательщик: FORG из табл RAS_SKU, он же FCOD табл CLRELCLCL (справочник аналитики 2-го вида)
			+", FID_DOG"+ SqlType("INT")	//договор: FID_DOG из табл RAS_SKU, он же FID_DOG табл LICSC, он же FWID табл CONTRACT
			+", FAPMT"+ SqlType("INT")		//квартира: FWID_CL табл CL_APARTMENT, он же FAPMT из табл LICSC. вытягивается по FID_DOG табл RAS_SKU
			+", FHOUSE"+ SqlType("INT")		//дом: FWID_CL табл CL_HOUSE, он же FHOUSE из табл CL_APARTMENT. вытягивается по FAPMT табл LICSC
			+", FSTREET"+ SqlType("INT")	//улица: FSTREET из табл CL_HOUSE, он же FWID табл CL (справочник 1-го вида). вытягивается по FHOUSE табл CL_APARTMENT
			+", FLIVAREA"+ SqlType("LONG")	//жилая площадь: FLIVAREA из табл CL_APARTMENT
			+", FLOGAREA"+ SqlType("LONG")	//площадь лоджий: FLOGAREA из табл CL_APARTMENT
			+", FBALAREA"+ SqlType("LONG")	//площадь балконов: FBALAREA из табл CL_APARTMENT
			+", FFIO "+ SqlType("TEXT")		//ФИО плательщика: FTXT табл CL
			+", FTN "+ SqlType("LONG")		//Таб.№
			+", FKODP "+ SqlType("LONG")	//код предприятия
			+", FAPMTNOM"+ SqlType("INT")	//номер квартиры: FNOM табл CL_APARTMENT
			+", FPERSKOL"+ SqlType("INT")	//колич. жильцов: FPERSKOL табл LICSC
			+", FEXMPTKOL"+ SqlType("INT")	//колич. льготников: FEXMPTKOL табл LICSC						
			+", FDATE"+ SqlType("DATE")		//дата: FDOC_DAT табл RAS_SKU
			+", FDOC"+ SqlType("TEXT")		//метка платежного поручения
			+", FNOP"+ SqlType("INT")		//номер операции платежки
			+", FTT"+ SqlType("TEXT")		//итог
			+", FSUM"+ SqlType("CURRENCY")	//общая сумма с уч. льгот и субсидий
			+", FSUB"+ SqlType("CURRENCY")	//сумма субсидий			
			+", FBBALANS"+ SqlType("CURRENCY")	//сальдо на начало
			+", FEBALANS"+ SqlType("CURRENCY")	//сальдо на конец
			+", FPLATSUM"+ SqlType("CURRENCY")	//сумма оплаченная: FSUM из журнала регистрации по документу PP.
			+", FDEPT"+ SqlType("CURRENCY")	//предыдущий долг
			//суммы по услугам с учетом льгот. из табл RAS_SKU
			+", FRENT"+ SqlType("CURRENCY")	//квартплата FRENTSUM
			+", FHEAT"+ SqlType("CURRENCY")	//отопление
			+", FCOOL"+ SqlType("CURRENCY")	//хол. вода
			+", FHOT"+ SqlType("CURRENCY")	//гор. вода
			+", FGAS"+ SqlType("CURRENCY")	//газ (и коню понятно)
			+", FELECTRIC"+ SqlType("CURRENCY")	//электроэнергия
			//объемы использ. воды
			+", FHOTVOL"+ SqlType("DOUBLE")	 //гор.
			+", FCOOLVOL"+ SqlType("DOUBLE") //хол.
			+", FHOTPREV"+ SqlType("DOUBLE") //предыдущие. гор.
			+", FCOOLPREV"+ SqlType("DOUBLE")//предыдущие. хол.
			+")";			
	ExecuteSQL(sSql, false);
}

include("sys/DpList.js");