/*
Расчет выписок к журналам-ордерам и ведомостям
(c) ДЕБЕТ Плюс 2000

Параметр cMode:
 C - кредит
 D - дебет
 Понятно, что первый всегда счет
 U - субсчет
 T - статья
 A - вызов из ordpod (просмотр об.сальд.ведомости по дате)
 Признак валюты - (_WHO.substr(_WHO.length-1,1)=="V")
 
 Выписки к журналам-ордерам - (_WHO.substr(0,1)=="C")
 CD        - с кредита SC       в дебет SC
 CDV
 CUD       - с кредита SC\SU    в дебет SC
 CUDV
 CUTD      - с кредита SC\SU\ST в дебет SC
 CUTDV
 CDU       - с кредита SC       в дебет SC\SU
 CDUV
 CTUD      - с кредита SC\ST\SU в дебет SC
 CTUDV

 Выписки к ведомостям - (_WHO.substr(0,1)=="D")
 CD        - с дебета SC       в кредит SC
 CDV
 CUD       - с дебета SC\SU    в кредит SC
 CUDV
 CUTD      - с дебета SC\SU\ST в кредит SC
 CUTDV
 CDU       - с дебета SC       в кредит SC\SU
 CDUV
 CTUD      - с дебета SC\ST\SU в кредит SC
 CTUDV
*/

include("objects\\DpVal.js");

function r_vpov(cMode, OutTable, cdat1, cdat2, sch_num, sub_num, sta_num, cl1_num, cl2_num, cl3_num, RVl)
{
   var isVal, cGrp;
   var cWhereCond = "";
   var dSc = dSu = dSt = dA1 = dA2 = dA3 = cSc = cSu = cSt = cA1 = cA2 = cA3 = 0;
   var dat;
   var sprval;

   cMode = cMode.toUpperCase();
   if (cMode.substr(cMode.length-1,1)=="V")
   {
      isVal = true;
      cGrp = cMode.substr(0,cMode.length-2)
   }   
   else
   {
      isVal = false;
      cGrp = cMode;
   }   

   sprval = getPar("CODSPRAV");  
   if(sprval==null)
	{
		WAIT(ru("Справочная валюта не указана,принимается как национальная", 
				"Довідкова валюта не визначена,	береться як національна"));
		sprval = "";
	}	
   sprval = new DpVal(sprval).getCod();

//Формирование условия выбора проводок
   cWhereCond = "Fdate BETWEEN "+sqlTo(cdat1)+" AND "+sqlTo(cdat2);

   if (isVal)
   {
      cWhereCond = cWhereCond+" AND Fval="+sqlTo(RVl)+
               " AND (Fwrk NOT IN (254, 12, 15))"
   }           
   else
   {
      cWhereCond = cWhereCond+" AND (Fwrk NOT IN (256, 16))"
   }   


   if (cGrp.substr(0,1)=="C")
   {
   //Журнал-ордер
      cWhereCond = cWhereCond
			+ " AND Fcr_sc = "+sqlTo(sch_num)
			+ (sub_num!=0? sqlw0And("fcr_su=", sub_num) : "")
			+ (sta_num!=0? sqlw0And("fcr_st=", sta_num) : "")
			+ (cl1_num!=0? sqlw0And("Fcr_cod1=", cl1_num) : "")
			+ (cl2_num!=0? sqlw0And("fcr_cod2=", cl2_num) : "")
			+ (cl3_num!=0? sqlw0And("fcr_cod3=", cl3_num) : "");
   }     
   else
   {
   //Ведомость к журналу-ордеру
      cWhereCond += " AND Fdb_sc = "+sqlTo(sch_num);
      if (sub_num && sub_num!=0)
         cWhereCond += " AND Fdb_su = "+sqlTo(sub_num);
      if (sta_num && sta_num!=0)
         cWhereCond += " AND Fdb_st = "+sqlTo(sta_num);
      if (cl1_num && cl1_num!=0)
         cWhereCond += " AND Fdb_cod1 = "+sqlTo(cl1_num);
      if (cl2_num && cl2_num!=0)
         cWhereCond += " AND Fdb_cod2 = "+sqlTo(cl2_num);
      if(cl3_num && cl3_num!=0)
         cWhereCond += " AND Fdb_cod3 = "+sqlTo(cl3_num);
   }
   //фильтр на организацию
	if(getPar("BLNBYORG"))
		cWhereCond += " and Forg0="+CURRENT_ORG;

   //Выборка проводок по сформированному условию
   if (IsTable(OutTable))
      DropTable(OutTable);
   
   CreateTable(OutTable,"CREDDEB","FWID");
   ExecuteSQL("ALTER TABLE " + OutTable + " ADD COLUMN FTTLEVEL " + SqlType("INT")); 
   

   var cSchFlds = GetPatternIntersection("SCHET", "CREDDEB").replace(/(fwid\s*,)|(,\s*fwid\s*$)/gi,"");
  
	if (!isVal)
	{
		var s = "INSERT INTO "+OutTable + "(" + cSchFlds + 
			",fwid_sch,Fsum1,Fsumsprval,Fsum3,Ftt,Ftt1, Ftt2, Ftt3, Ftt4, Ftitog, fttlevel) "
			+ " SELECT " + cSchFlds
				+ ", fwid AS fwid_sch"
				//"*,"+
			+ ", " + sqlRound(Convert("^schet.Fsum*"+sqlRate("^schet","Fval","Fdate",null,"Fvkurs"),"MONEY"),prmDecSum)+" as Fsum1,"+
			 sqlRound(Convert("^schet.Fsum*"+sqlRate("^schet","Fval","Fdate",Number(sprval),"Fvkurs"),"MONEY"),prmDecSum)+" as Fsumsprval,"+
			 sqlRound(Convert("^schet.Fsumspr*"+sqlRate("^schet","Fvalspr","Fdate",null,"Fvkurs"),"MONEY"),prmDecSum)+" as Fsum3,"+
			 " '' AS Ftt, "+
			   " '0' AS Ftt1, '0' AS Ftt2, '0' AS Ftt3, '0' AS Ftt4, '' AS Ftitog, 0 as fttlevel "+
			   " FROM ^schet "+
			   " WHERE "+cWhereCond 
			   
		trace("trace: "+sprval+" "+sqlRate("^schet","Fval","Fdate",Number(sprval),"Fvkurs"));	   
		ExecuteSQL(s
			);

      ExecuteSQL("UPDATE  "+OutTable+
		" set FSUMVAL = Fsum, Fsum = Fsum1,Fsumspr = Fsum3 ");

   }else{
      ExecuteSQL("INSERT INTO "+OutTable+"("+cSchFlds +
			",Ftt,fwid_sch,Fsumsprval,Ftt1, Ftt2, Ftt3, Ftt4, Ftitog, fttlevel) " +
		 " SELECT " + cSchFlds + ", '' AS Ftt"
				+ ", fwid AS fwid_sch"
			 + ", " + sqlRound(Convert("^schet.Fsum*"+sqlRate("^schet","Fval","Fdate",sprval, "Fvkurs"),"MONEY"),prmDecSum)+" as Fsumsprval,"+ 
			" '0' AS Ftt1, '0' AS Ftt2, '0' AS Ftt3, '0' AS Ftt4, '' AS Ftitog, 0 as fttlevel "+
			" FROM ^schet "+
			" WHERE "+cWhereCond);
   }
  

   if (IsTable(OutTable+"z"))
      DropTable(OutTable+"z");
   CreateTable(OutTable+"z","creddeb","*");  
   ExecuteSQL("ALTER TABLE " + OutTable + "z" + " ADD COLUMN FTTLEVEL " + SqlType("INT"));        
      
	if (!isVal)
	{
		ExecuteSQL(s = "INSERT INTO "+OutTable+"z("+cSchFlds+
			",fwid_sch,Fsum1,Fsumsprval,Fsum3,Ftt, Ftt1, Ftt2, Ftt3, Ftt4, Ftitog, fttlevel) " +
			" SELECT " + cSchFlds
				+ ", fwid AS fwid_sch"
			+ "," + sqlRound("^schet_zr.Fsum*"+sqlRate("^schet_zr","Fval","Fdate",null,"Fvkurs"),prmDecSum)+" as Fsum1,"+
			sqlRound("^schet_zr.Fsum*"+sqlRate("^schet_zr","Fval","Fdate",sprval,null,"Fvkurs"),prmDecSum)+" as Fsumsprval,"+
			sqlRound("^schet_zr.Fsumspr*"+sqlRate("^schet_zr","Fvalspr","Fdate",null,"Fvkurs"),prmDecSum)+" as Fsum3,"+
			" '' AS Ftt, "+
			" '0' AS Ftt1, '0' AS Ftt2, '0' AS Ftt3, '0' AS Ftt4, '' AS Ftitog, 0 as fttlevel "+
			" FROM ^schet_zr "+
			" WHERE "+cWhereCond);

		ExecuteSQL("UPDATE  "+OutTable+"z"+
			" set FSUMVAL = Fsum,Fsum = Fsum1,Fsumspr = Fsum3 ");
	}else{
		ExecuteSQL("INSERT INTO "+OutTable+"z("+cSchFlds+
			",fwid_sch,Ftt, Fsumsprval,Ftt1, Ftt2, Ftt3, Ftt4, Ftitog, fttlevel ) " +
			" SELECT " + cSchFlds
				+ ", fwid AS fwid_sch"
				+ ",'' AS Ftt, "+
			sqlRound("^schet_zr.Fsum*"+sqlRate("^schet_zr","Fval","Fdate",sprval, "Fvkurs"),prmDecSum)+" as Fsumsprval,"+
			" '0' AS Ftt1, '0' AS Ftt2, '0' AS Ftt3, '0' AS Ftt4, '' AS Ftitog, 0 as fttlevel "+
			" FROM ^schet_zr "+
			" WHERE "+cWhereCond);
   }

	var sFld = GetPatternIntersection("creddeb","creddeb").replace(/(fwid\s*,)|(\s*fwid\W)/gi,"");
   	sFld = sFld + ", fttlevel";
   	ExecuteSQL("INSERT INTO "+OutTable+"("+sFld + ") " +
      " SELECT " + sFld + " FROM "+OutTable+"z");

   //Разбор строки режима
   var DbCr, cCur, isError, i;
   var isError = false;
   
   var tot = new DpTotals();
   
   for (i=1;i<=cGrp.length;i++)
   {
      cCur = cGrp.substr(i-1,1);
      switch(cCur)
      {
         case "C":
            DbCr = "C";
            tot.AddGroup("fcr_sc", '_', null, "SCC", null);             
            break;
         case "D":
            DbCr = "D";
            tot.AddGroup("fdb_sc", '_', null, "SCD", null);          
            break;
         case "":
            isError = true;
            break;
         case "U":
            if (DbCr=="D")
               tot.AddGroup("fdb_su", '_', null, "SUD", null)              
            else {
               if (DbCr=="C")
                  tot.AddGroup("fcr_su", '_', null, "SUC", null)              
               else
                  isError = true;                  
            }      
            break;               
         case "T":
            if (DbCr=="D")
               tot.AddGroup("fdb_st", '_', null, "STD", null)
            else {
               if (DbCr=="C")
                  tot.AddGroup("fcr_st", '_', null, "STC", null)
               else
                  isError = true;                  
            }      
            break;               
         case "X":
            if (DbCr=="D")
               tot.AddGroup("fdb_cod1", '_', null, "A1D", null)
            else {
               if (DbCr=="C")
                  tot.AddGroup("fcr_cod1", '_', null, "A1C", null)
               else
                  isError = true;                  
            }      
            break;   
         case "A":
            if (DbCr=="D"){
               tot.AddGroup("fdb_cod2", '_', null, "A2D", null);
               tot.AddGroup("fdb_cod3", '_', null, "A3D", null);
            }                  
            else {
               if (DbCr=="C"){
                  tot.AddGroup("fcr_cod2", '_', null, "A2C", null);
                  tot.AddGroup("fcr_cod3", '_', null, "A3C", null);
               }                     
               else
                  isError = true;                  
            }      
            break;   
         default:
            isError = true;
      }//switch
      

      if (isError)
      {
         alert("Ошибочный параметр r_vpov ( "+cMode+" )");
         break;
      }   
   }//for

   tot.AddItog("fsum", "SUM");
   tot.AddItog("fsumspr", "SUM");
   tot.AddItog("fsumsprval", "SUM");         

   //tot.MkTotals("", OutTable, cMode, null, null, null, null);

}