/*
   разбивка на миниальные периоды для OS0B и VN_PEREM
*/

function r_vsp_p(mdat1, mdat2)
{
   //dat1 и dat2 - даты на начало и конец расчетного периода 
   var OutTable, strSQL;
   var table;
   var dat1,dat2,dt1,dt2,d1,d2;
//   var OK = true, OH, OKH;

   dat1 = mdat1;
   dat2 = mdat2;
   d1 = mdat1.getDate();
   d2 = mdat2.getDate();    
   dat1 = mdat1.getVarDate();
   dat2 = mdat2.getVarDate();     

   DropTable("tobos");
   OutTable  = "tobos";

   strSQL = "CREATE TABLE "+OutTable
   			+" (Finv_num "+SqlType("LONG")
   			+", Forig_pric "+SqlType("CURRENCY")
   			+", Fmol "+SqlType("LONG")
   			+", Fpodr "+SqlType("LONG")
   			+", Fpodro "+SqlType("LONG")
   			+", Fsc "+SqlType("LONG")
   			+", Fsu "+SqlType("LONG")
   			+", Fst "+SqlType("LONG")
   			+", Fbdat "+SqlType("DATE")
   			+", Fedat "+SqlType("DATE")
   			+")";
   ExecuteSQL(strSQL, true);

   strSQL = "CREATE INDEX "+OutTable+"  ON  "+OutTable+"  (Finv_num, Fmol, Fpodr, Fsc)";
   ExecuteSQL(strSQL, true);

   table = OpenTable("s",OutTable)

   DropTable("VOS0B")
   strSQL = "SELECT * INTO VOS0B FROM ^OS0B "
            +" WHERE "
            +"( (FBDAT<="+sqlTo(mdat1)+" AND FEDAT>="+sqlTo(mdat2)
            +") OR (FBDAT>="+sqlTo(mdat1)+" AND FBDAT<="+sqlTo(mdat2)
            +") OR (FEDAT>="+sqlTo(mdat1)+" AND FEDAT<="+sqlTo(mdat2)
            +") )"
            +" ORDER BY FINV_NUM";
   ExecuteSQL(strSQL);
   vos0b = OpenTable("s","VOS0B");

   DropTable("TVNP")
   strSQL = "SELECT * INTO TVNP FROM ^VN_PEREM"
            +" WHERE "
            +"( (FBDAT<="+sqlTo(mdat1)+" AND FEDAT>="+sqlTo(mdat2)
            +") OR (FBDAT>="+sqlTo(mdat1)+" AND FBDAT<="+sqlTo(mdat2)
            +") OR (FEDAT>="+sqlTo(mdat1)+" AND FEDAT<="+sqlTo(mdat2)
            +") )"
            +" ORDER BY FINV_NUM, FBDAT, FEDAT";
   ExecuteSQL(strSQL);
   vvnp = OpenTable("s", "TVNP");

   if (!vos0b && !vvnp)
   {
      CloseWindow();
      return;
   }
     
   var m = new Object();
   vvnp.MoveFirst();
   while (!vvnp.IsEOF())
   {
      var D1 = javaDate2Script(vvnp.getValue("Fbdat"));
      var D2 = javaDate2Script(vvnp.getValue("Fedat"));

      strSQL = "SELECT * FROM ^VOS0B"
            +" WHERE Finv_num="+sqlTo(vvnp.getValue("Finv_num"))+" and "
            +"(( Fbdat<>"+sqlTo(d00obj)+" and (FBDAT>="+sqlTo(D1)+" AND FBDAT<="+sqlTo(D2)
            +")) OR (Fedat<>"+sqlTo(d00obj)+" and (FEDAT>="+sqlTo(D1)+" AND FEDAT<="+sqlTo(D2)
            +")) )"
            +" ORDER BY FINV_NUM, FBDAT, FEDAT";
      vvos0b = OpenTable("s",strSQL);

    
      if (vvos0b.IsEmpty())
      {
       // table.AddNew();
       m = new Object();
        m.finv_num = vvnp.getValue("finv_num");
        m.forig_pric = izosdatb(vvnp.getValue("fbdat"),vvnp.getValue("finv_num"),"orig_pric");         
        m.fmol = vvnp.getValue("ftabn");
        m.fpodr = vvnp.getValue("fpodr");                  
        m.fpodro = vvnp.getValue("fpodro");         
        m.fsc = izosdatb(vvnp.getValue("fbdat"),vvnp.getValue("finv_num"),"db_sc");                
        m.fsu = izosdatb(vvnp.getValue("fbdat"),vvnp.getValue("finv_num"),"db_su");                       
        m.fst = izosdatb(vvnp.getValue("fbdat"),vvnp.getValue("finv_num"),"db_st");                       
        m.fbdat = vvnp.getValue("fbdat");       
		m.fedat = vvnp.getValue("fedat");       
        //table.Update();
        UpdateTable(OutTable,m,true)
      }
      else
      {
        vvos0b.MoveFirst();
        while (!vvos0b.IsEOF())
        {

          //1-й случай = внутр.перем.= изм.стоим.
          if (!differ(vvos0b.getValue("FBDAT"),vvnp.getValue("Fbdat")) && !differ(vvos0b.getValue("FEDAT"),vvnp.getValue("Fedat")))
          {
            mbdt1 = vvnp.getValue("FBDAT")
            medt1 = vvnp.getValue("FEDAT");
          }

          //2-й случай = изм.стоим.внутри внутр.перем.
          if ((vvos0b.getValue("FBDAT")>vvnp.getValue("Fbdat") && vvos0b.getValue("FBDAT")<vvnp.getValue("Fedat")) && vvos0b.getValue("FEDAT")<vvnp.getValue("Fedat"))
          {
            mbdt1 = vvos0b.getValue("Fbdat");
            medt1 = vvos0b.getValue("Fedat");          
          }

          //3-й случай = начало изм.стоим внутри внутр.перем., конец >внутр.перем.
          if ((vvos0b.getValue("FBDAT")>vvnp.getValue("Fbdat") && vvos0b.getValue("FBDAT")<vvnp.getValue("Fedat")) && vvos0b.getValue("FEDAT")>vvnp.getValue("Fedat"))
          {
            mbdt1 = vvos0b.getValue("Fbdat");
            medt1 = vvnp.getValue("Fedat");             
          }

          //4-й случай = начало изм.стоим внутри внутр.перем., конец =внутр.перем.
          if ((vvos0b.getValue("FBDAT")>vvnp.getValue("Fbdat") && vvos0b.getValue("FBDAT")<vvnp.getValue("Fedat")) && !differ(vvos0b.getValue("FEDAT"),vvnp.getValue("Fedat")))
          {
            mbdt1 = vvos0b.getValue("Fbdat");
            medt1 = vvos0b.getValue("Fedat");     
          }

          //5-й случай = начало изм.стоим = внутр.перем., конец <внутр.перем.
          if (!differ(vvos0b.getValue("FBDAT"),vvnp.getValue("Fbdat")) && vvos0b.getValue("FEDAT")<vvnp.getValue("Fedat"))
          {
            mbdt1 = vvos0b.getValue("FBDAT")
            medt1 = vvos0b.getValue("FEDAT")    
          }

          //6-й случай = начало изм.стоим = внутр.перем., конец > внутр.перем.
          if (!differ(vvos0b.getValue("FBDAT"),vvnp.getValue("Fbdat")) && vvos0b.getValue("FEDAT")>vvnp.getValue("Fedat"))
          {
            mbdt1 = vvos0b.getValue("FBDAT")
            medt1 = vvnp.getValue("Fedat");    
          }

          //7-й случай = начало изм.стоим < внутр.перем, конец <=внутр.перем.
          if (vvnp.getValue("FBDAT")>vvos0b.getValue("Fbdat") && vvos0b.getValue("FEDAT")<=vvnp.getValue("Fedat"))
          {
             mbdt1 = vvnp.getValue("Fbdat");       
             medt1 = (vvnp.getValue("Fedat")<vvos0b.getValue("Fedat"))?vvnp.getValue("Fedat"):vvos0b.getValue("Fedat");                  
          }    

          //8-й случай = начало изм.стоим. = концу внутр.перем
          if (!differ(vvos0b.getValue("FBDAT"),vvnp.getValue("Fedat")))
          {
             mbdt1 = vvos0b.getValue("Fbdat");       
             medt1 = vvnp.getValue("Fedat");                         
          }    

          //9-й случай = начало внутр.перем = концу изм.стоим.
          if (!differ(vvos0b.getValue("FEDAT"),vvnp.getValue("Fbdat")))
          {
	         mbdt1 = vvnp.getValue("Fbdat");       
             medt1 = vvos0b.getValue("Fedat");                         
          }    

	//         table.AddNew();
		  m = new Object();
          m.finv_num = vvnp.getValue("finv_num");
          m.forig_pric = vvos0b.getValue("forig_pric");         
          m.fmol = vvnp.getValue("ftabn");
          m.fpodr = vvnp.getValue("fpodr");                  
          m.fpodro = vvnp.getValue("fpodro");         
          m.fsc = vvos0b.getValue("fdb_sc");       
          m.fsu = vvos0b.getValue("fdb_su");       
          m.fst = vvos0b.getValue("fdb_st");       
          m.fbdat = mbdt1;
          m.fedat = medt1;
         // table.Update();
         UpdateTable(OutTable,m,true);

          vvos0b.MoveNext();   
        }
      }
      vvnp.MoveNext();   
   }
   
}
   