//расчет описи инв. карточек

//17.05.2001
// Добавили mode
//	"INIT" - формируется таблица без износов
//	"CALC" - проставляет износ для следующих nMaxCount инв. номеров
// ориентируется на поле FDONE, в котором true после того, как 
// рассчитали износ по данному инв. номеру
// После того, как рассчиталась очередная "ПОРЦИЯ", надо
// в MS Access выполнить сжатие базы данных.
// Все это из-за того, что temp.mdb вырастает до 1Gb и Jet "умирает"
// При этом расчитано прядка 2400 инв. карточек.

// теперь имя таблицы передаем снаружи, т.к. после упорядочивания и итогов
// оно отличается

// 21.09.2001 Ускорен расчет
// 24.09.2001 Добавлен поиск
// 25.09.2001 Добавлены счета по Дт и по Кт из OS0
// 25.09.2001 Добавлен счет отнесения затрат из VN_PEREM
// 25.09.2001 Добавлен зав.номер, номер паспорта из OS1 и кол-во из OS0

include("riznos.js");
include("r_balizn.js");
include("firstkv.js");
include("lastkv.js");
include("izosdat.js");
include("izgr_dat.js");
include("oss_dati.js");
include("calc_os.js");
include("norm_am.js");
include("koef_am.js");
include("Objects/DpExtentionBuilder.js");

function r_zakros(mdate, mode, tblOut)
{
	// кол-во строк, рассчитываемых за один проход.
	var nMaxCount=1000;
	var mas = new Array();
	mas[0] = "CH_EXT";
	mas[1] = "CH_EXT1";

	// чтобы ExecuteSQL() не выводил свой WAIT()
	//__noWait = true;

	if(mode=="INIT")
	{
		// удалим рез-ты предыдущего расчета
		//if(IsTable(tblOut))
		//{
			DropTable(tblOut);
		//}
		// создадим новую таблицу
		var strSQL = "CREATE TABLE "+tblOut+"("
			+"FINV_NUM " + SqlType("LONG") + ","
			+"FGROUP " + SqlType("BYTE") + ","
			+"FCOD_RATE " + SqlType("LONG") + ","
			+"FORIG_PRIC " + SqlType("CURRENCY") + ","
			+"FIZNOS " + SqlType("CURRENCY") + ","
			+"FBALST " + SqlType("CURRENCY") + ","
			+"FIZDAT " + SqlType("CURRENCY") + ","
			+"FVIDOS " + SqlType("LONG") + ","
			+"FDAT_POST " + SqlType("DATETIME") + ","
			+"FVVOD_ECSP " + SqlType("DATETIME") + ","
			+"FPODR " + SqlType("LONG") + ","
			+"FTABN " + SqlType("LONG") + ","
			+"FLPU " + SqlType("LONG") + ","
			//25.09.2001
			+"FDB_SC " + SqlType("SHORT") + ","			// Счет Дт
			+"FDB_SU " + SqlType("SHORT") + ","			// Субсчет Дт
			+"FDB_ST " + SqlType("SHORT") + ","			// Ст Дт
			+"FCR_SC " + SqlType("SHORT") + ","			// Счет Кт
			+"FCR_SU " + SqlType("SHORT") + ","			// Субсчет Кт
			+"FCR_ST " + SqlType("SHORT") + ","			// Ст Кт
			+"FSC " + SqlType("SHORT") + ","			// Счет затр.
			+"FSU " + SqlType("SHORT") + ","			// Субсчет затр.
			+"FST " + SqlType("SHORT") + ","			// Ст затр.
			+"FPASPN " + SqlType("TEXT",7) + ","		// номер паспорта
			+"FZAVN " + SqlType("TEXT",7) + ","		// заводской номер
			+"FKOL " + SqlType("CURRENCY") + ","		// количество
			+"FPRIZN " + SqlType("TEXT",8) + ","
			+"FTT " + SqlType("TEXT",3) + ","
			+"FTTLEVEL " + SqlType("BYTE") + ","
			+"FDONE " + SqlType("BIT") + ","
			+"FWID " + SqlType("COUNTER") + ")";
		ExecuteSQL(strSQL);
		//ExecuteSQL("create index FORIG_PRIC on " + tblOut + " (FORIG_PRIC)");
		//ExecuteSQL("create index FGROUP on " + tblOut + " (FGROUP)");
		//ExecuteSQL("create index FINV_NUM on " + tblOut + " (FINV_NUM)");
		WAIT("Отбор ОС");
		if(IsTable(mas[0]))
			DropTable(mas[0]);
		if(IsTable(mas[1]))
			DropTable(mas[1]);
		
		var extBuilder = new DpExtentionBuilder("H","O7");
   		extBuilder.load(true);
   		var sValueTbl = extBuilder.getValueTableName();		
//		var StrSQL1=" SELECT *"
//			+" INTO " + mas[0]
//			+" FROM ^CL_EXT"
//			+" WHERE FLABEL='PRIZN' " //НУЖНО УБРАТЬ SA
//			+" AND FTYPE= 'A109' "
//			
//		ExecuteSQL(StrSQL1);
		StrSQL1="SELECT A.FPRIZN, B.*"
			+" INTO " + mas[1]
			+" FROM " + sValueTbl + " AS A LEFT JOIN ^OS7 AS B" 
			+" ON A.FMAINWID=B.FWID"
		ExecuteSQL(StrSQL1);
		if(IsTable(mas[0]))
		{
			ExecuteSQL("DROP TABLE "+mas[0]);
		}
		StrSQL1="SELECT B.FWID_CL, A.*"
			+" INTO " + mas[0]
			+" FROM " + mas[1] + " AS A LEFT JOIN ^CLRELCLCL  AS B"
			+" ON A.FPRIZN=B.FCOD"
			+" WHERE B.FCL=109"
		ExecuteSQL(StrSQL1);
		if(IsTable(mas[1]))
		{
			ExecuteSQL("DROP TABLE "+mas[1]);
		}
   
		StrSQL1="SELECT B.FTXT, A.*"
			+" INTO  " + mas[1]
			+" FROM " + mas[0] + " AS A LEFT JOIN ^CL AS B"
			+" ON A.FWID_CL=B.FWID"
		ExecuteSQL(StrSQL1);
		// выберем из OS0 инв. номера, перв.стоим., и перв. износ
		// для инв. номеров, имеющихся в наличии на mdate
		strSQL = "INSERT INTO "+tblOut + 
				" (FINV_NUM,FGROUP,FCOD_RATE,FORIG_PRIC,FDB_SC,FDB_SU,FDB_ST,FCR_SC," +
      			"FCR_SU,FCR_ST,FKOL,FBALST,FIZDAT,FIZNOS,FPRIZN,FTT,FDONE)"
				+" SELECT OS0.FINV_NUM, OS0.FGROUP, OS0.FCOD_RATE, OS0.FORIG_PRIC,"
				+" OS0.FDB_SC, OS0.FDB_SU, OS0.FDB_ST, OS0.FCR_SC, OS0.FCR_SU,"
				+" OS0.FCR_ST, OS0.FKOL, OS0.FORIG_PRIC-OS0.FIZNOS AS FBALST,"
				+"OS0.FIZNOS+OS0.FIZM_IZN AS FIZDAT, OS0.FIZNOS AS FIZNOS,"
				+" B.FTXT AS FPRIZN, '  ' AS FTT, 0 AS FDONE"
				+" FROM ^OS0 AS OS0"
					+" LEFT JOIN " + mas[1] + " AS B ON OS0.FINV_NUM=B.FINV_NUM"
				+" WHERE OS0.FBDAT<="+sqlTo(mdate)+" AND OS0.FEDAT>="+sqlTo(mdate);
		ExecuteSQL(strSQL);

		WAIT("Проставление кодов подр. и МОЛ");
		// проставим из VN_PEREM подразделение и МОЛ
		// А также в поле FLPU запишем первые 2 цифры кода подр.
		strSQL = "UPDATE "+tblOut+" SET"
			+" FPODR = (SELECT " + First("V.FPODR",false)
						+" FROM ^VN_PEREM AS V WHERE "+tblOut+".FINV_NUM = V.FINV_NUM"
						+" AND V.FBDAT<="+sqlTo(mdate)+" AND V.FEDAT>="+sqlTo(mdate) + "),"
			+" FTABN = (SELECT " + First("V.FTABN",false)
						+" FROM ^VN_PEREM AS V WHERE "+tblOut+".FINV_NUM = V.FINV_NUM"
						+" AND V.FBDAT<="+sqlTo(mdate)+" AND V.FEDAT>="+sqlTo(mdate) + "),"
			+" FSC = (SELECT " + First("V.FSC",false)
						+" FROM ^VN_PEREM AS V WHERE "+tblOut+".FINV_NUM = V.FINV_NUM"
						+" AND V.FBDAT<="+sqlTo(mdate)+" AND V.FEDAT>="+sqlTo(mdate) + "),"
			+" FSU = (SELECT " + First("V.FSU",false)
						+" FROM ^VN_PEREM AS V WHERE "+tblOut+".FINV_NUM = V.FINV_NUM"
	  					+" AND V.FBDAT<="+sqlTo(mdate)+" AND V.FEDAT>="+sqlTo(mdate) + "),"
	  		+" FST = (SELECT " + First("V.FST",false)
						+" FROM ^VN_PEREM AS V WHERE "+tblOut+".FINV_NUM = V.FINV_NUM"
	  					+" AND V.FBDAT<="+sqlTo(mdate)+" AND V.FEDAT>="+sqlTo(mdate) + "),"
			+" FLPU = (SELECT " + First(Convert("V.FPODR/100","INT"),false)
						+" FROM ^VN_PEREM AS V WHERE "+tblOut+".FINV_NUM = V.FINV_NUM"
      					+" AND V.FBDAT<="+sqlTo(mdate)+" AND V.FEDAT>="+sqlTo(mdate) + ")"
		ExecuteSQL(strSQL);
		WAIT("Проставление кодов УМГ");
		// теперь проставим код УМГ
		// система такая смотрим на первые 2 цифры кода подр:
		// 3 - ЧТГ		(2)
		strSQL = "UPDATE "+tblOut+" SET FLPU = 2 WHERE FLPU = 3";
		ExecuteSQL(strSQL);

		// 10 - Первом.	(360)
		strSQL = "UPDATE "+tblOut+" SET FLPU = 360 WHERE FLPU = 10";
		ExecuteSQL(strSQL);

		// 14 - Крем.	(380)
		strSQL = "UPDATE "+tblOut+" SET FLPU = 380 WHERE FLPU = 14";
		ExecuteSQL(strSQL);

		// 16 - Зол.		(400)
		strSQL = "UPDATE "+tblOut+" SET FLPU = 400 WHERE FLPU = 16";
		ExecuteSQL(strSQL);

		// 18 - Алекс.	(420)
		strSQL = "UPDATE "+tblOut+" SET FLPU = 420 WHERE FLPU = 18";
		ExecuteSQL(strSQL);

		// 22 - Гайс.	(440)
		strSQL = "UPDATE "+tblOut+" SET FLPU = 440 WHERE FLPU = 22";
		ExecuteSQL(strSQL);

		// 26 - Бар		(460)
		strSQL = "UPDATE "+tblOut+" SET FLPU = 460 WHERE FLPU = 26";
		ExecuteSQL(strSQL);
		// проставим код вида ОС, дату акта приемки и ввода в экспл.
		// (достанем из акта приемки)
		strSQL = "UPDATE "+tblOut+" SET"
				+" FVIDOS = (SELECT O.FVIDOS "
						+" FROM ^OS1 AS O WHERE "+tblOut+".FINV_NUM = O.FINV_NUM),"
				+" FDAT_POST = (SELECT O.FDOC_DAT "
						+" FROM ^OS1 AS O WHERE "+tblOut+".FINV_NUM = O.FINV_NUM),"
				+" FVVOD_ECSP = (SELECT O.FVVOD_ECSP "
						+" FROM ^OS1 AS O WHERE "+tblOut+".FINV_NUM = O.FINV_NUM),"
				+" FPASPN = (SELECT O.FPASPN "
						+" FROM ^OS1 AS O WHERE "+tblOut+".FINV_NUM = O.FINV_NUM),"
				+" FZAVN = (SELECT O.FZAVN "
						+" FROM ^OS1 AS O WHERE "+tblOut+".FINV_NUM = O.FINV_NUM)";
		ExecuteSQL(strSQL);
		WAIT("Вычисление остаточной стоимости и износа по произв. ОС");
		// 25.09.2001
		// для тех строк по произв.ОС, у которых есть строки в RAMORTI,
		// проставим ост.стоимость на конец
		// расчетного периода, которую достанем непсредственно из RAMORTI
		//super vv 28.01.02
		// Надо учесть, что в квартале могли быть изменения стоимости
		
		strSQL = "UPDATE "+tblOut+" SET"
				+" FIZDAT = FIZNOS"
				+" WHERE FGROUP=0";
		ExecuteSQL(strSQL);
		
		strSQL = "UPDATE "+tblOut+" SET "
					+" FBALST = (SELECT "+tblOut+".FORIG_PRIC-R.FIZNOS ZR "
							+" FROM ^RAMORTI R WHERE "+tblOut+".FGROUP=R.FGROUP "
							+" AND R.FDATKV="+sqlTo(firstkv(mdate))+" AND "+tblOut+".FINV_NUM=R.FINV_NUM), "
					+" FIZDAT = (SELECT R.FIZNOS FROM ^RAMORTI R WHERE "+tblOut+".FGROUP=R.FGROUP "
							+" AND R.FDATKV="+sqlTo(firstkv(mdate))+" AND "+tblOut+".FINV_NUM=R.FINV_NUM), "
					+" FDONE = (SELECT 1 BL FROM ^RAMORTI R WHERE "+tblOut+".FGROUP=R.FGROUP "
							+" AND R.FDATKV="+sqlTo(firstkv(mdate))+" AND "+tblOut+".FINV_NUM=R.FINV_NUM) "
				+" WHERE FGROUP IN(1,2,3,4,5,11,12,13,14)";
		ExecuteSQL(strSQL);
		// Виправлена помилка з мінусовими балансовими вартостями ( після переведення на нову версію
		//з розділеними податковим і бухгалтерським обліком )
		WAIT("Модифікація первісних вартостей ОЗ");
		// Найсвіжіші первісні вартості візьмемо з таблиці OS0B
		strSQL = "UPDATE "+tblOut+" SET"
			+" FORIG_PRIC = (SELECT B.FORIG_PRIC FROM ^OS0B AS B WHERE "
								+tblOut+".FINV_NUM=B.FINV_NUM"
								+" AND B.FBDAT<="+sqlTo(mdate)+" AND B.FEDAT>="+sqlTo(mdate)+")"
			+" WHERE "+tblOut+".FBALST<0";
		ExecuteSQL(strSQL);

		// Прокалькулюємо тепер нові балансові вартості з урахуванням модифікованих первісних
		strSQL = "UPDATE "+tblOut+" SET"
				+" FBALST = FORIG_PRIC-FIZDAT"
				+" WHERE FBALST<0";
		ExecuteSQL(strSQL);
	}
	else 
		if(mode=="CALC")
		{

			strSQL = "UPDATE "+tblOut+" SET"
				+" FIZDAT = FIZNOS"
				+" WHERE FGROUP=0";
			ExecuteSQL(strSQL);

			strSQL = "UPDATE "+tblOut+" SET "
					+" FBALST = (SELECT "+tblOut+".FORIG_PRIC-R.FIZNOS ZR "
							+" FROM ^RAMORTI R WHERE "+tblOut+".FGROUP=R.FGROUP "
							+" AND R.FDATKV="+sqlTo(firstkv(mdate))+" AND "+tblOut+".FINV_NUM=R.FINV_NUM), "
					+" FIZDAT = (SELECT R.FIZNOS FROM ^RAMORTI R WHERE "+tblOut+".FGROUP=R.FGROUP "
							+" AND R.FDATKV="+sqlTo(firstkv(mdate))+" AND "+tblOut+".FINV_NUM=R.FINV_NUM), "
					+" FDONE = (SELECT 1 BL FROM ^RAMORTI R WHERE "+tblOut+".FGROUP=R.FGROUP "
							+" AND R.FDATKV="+sqlTo(firstkv(mdate))+" AND "+tblOut+".FINV_NUM=R.FINV_NUM) "
				+" WHERE FGROUP IN(1,2,3,4,5,11,12,13,14)";
			ExecuteSQL(strSQL);
			
			// найдем износ на дату
			// для произв. ОС это будет износ на 1-е число квартала,
			// (для прибывших в данном квартале - первонач.износ)
			// для непроизв. ОС - на 1-е число месяца
			// (для прибывших в данном месяце - первонач.износ)
			// откроем таблицу
			tbl = OpenTable("s", "select * from "+tblOut+" where not Finv_num is null and (Fgroup=6 or Fgroup=7)");
			if(tbl.IsBOF() || tbl.IsEOF())
			{
				tbl.Close()
				return;
			}
			var inv=0, group, bal, izn;
   
			WAIT("Вычисление остаточной стоимости и износа  ---------");
			for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
			{
				inv = toScrObj(tbl.getValue("FINV_NUM"));
				WAIT("Инв.н. "+inv);
				izn = riznos(mdate, inv, toScrObj(tbl.getValue("FDAT_POST")));
				bal = toScrObj(tbl.getValue("FORIG_PRIC"))-izn;

				//tbl.Edit();
				var m = new Object();
				m.FBALST = bal;
				m.FIZDAT = izn;
				m.FDONE = true;
				//tbl.Update();
				UpdateTable(tblOut, m, false, "Fwid="+sqlTo(tbl.getValue("Fwid")))
			}
			// сообщим пользователю о том, закончили или нет
			var sMessage;
			if(tbl.IsEOF())
			{
				sMessage = "Расчет завершен.\nРассчитайте итоги";
				alert(sMessage);
			}	
			tbl.Close();
		}
		else
			alert("Неверный режим вызова r_zakros():"+mode);
	//__noWait = false;
	//CLEARWAIT();
	//return;
}