﻿// Шатохин В.В.
// Процедура расчета закрытия счетов по способу DISTR
// 07.02.2003

include("objects\\DpEval.js");

// Константы для поля FKIND
// (переехали из e_zak.htm)
var KIND_SL = 1;	//брать остаток
var KIND_OB = 2;	//брать оборот
var KIND_DB = 4;	//дебетовый
var KIND_CR = 8;	//кредитовый
var KIND_TURN = 16;	//сворачивать
var KIND_NOTURN = 32;	//сворачивать
var KIND_ZDB = 64;	//Закрываемый счет - по Дт
var KIND_ZCR = 128;	//Закрываемый счет - по Кт
var KIND_SUMOB = 4096;	// Брать конкретную сумму пропорционально оборотам
var KIND_SUMSL = 8192;	// Брать конкретную сумму пропорционально остаткам
var KIND_DEFAULT = KIND_SL | KIND_DB | KIND_TURN | KIND_ZCR;


function r_zrdistr(par, dat1, dat2)
{
	var mmFsc     = par.mmFsc;
	var mmFsu     = par.mmFsu;
	var mmFst     = par.mmFst;
	var mmFcl1    = par.mmFcl1;
	var mmFcl2    = par.mmFcl2;
	var mmFcl3    = par.mmFcl3;
	var mmFproc = par.mmFproc;
	var mmFkind = par.mmFkind;
	var mmFnom = par.mmFnom;
	
	//vlad 20.10.2010
	mmFexcl1 = par.mmFexcl1;
	mmFexcl2 = par.mmFexcl2;
	mmFexcl3 = par.mmFexcl3;
	
	//Разберемся с тем, что будем закрывать
	var isSL= mmFkind & KIND_SL | mmFkind & KIND_SUMSL;	//брать сальдо или обороты
	var isSUM = mmFkind & KIND_SUMOB | mmFkind & KIND_SUMSL;	//Распределяем ли конкретную сумму
	var isDB= mmFkind & KIND_DB;    //дебетовые или кредитовые
	var isTurn= mmFkind & KIND_TURN;//сворачивать или не сворачивать
	var isZDB= mmFkind & KIND_ZDB;  //Закр.счет - по Дт или по Кт
	
	// Расчитываем остатки по счету, к-й закрываем
	TrnNBln("3n", "ZRSC_", dat1, dat2, new DpSc(mmFsc,mmFsu,mmFst, mmFcl1, mmFcl2, mmFcl3));

	//vlad 20.10.2010
	//Если в настройке указаны какие-то коды аналитики, которые следует "исключить",
	//то удалим такие строки из таблицы с оборотами и остатками
	if ( !isEmpty(mmFexcl1) || !isEmpty(mmFexcl2) || !isEmpty(mmFexcl3))
	{
		var strSQL = "DELETE "
		+" FROM ZRSC_"
		+" WHERE "
			+" FSC="+sqlTo(mmFsc)
			+ sqlw0And("FSU=", mmFsu)
			+ sqlw0And("FST=", mmFst)
			+ (isEmpty(mmFexcl1) ? "" : (" AND FCL_COD1 IN("+mmFexcl1+")"))
			+ (isEmpty(mmFexcl2) ? "" : (" AND FCL_COD2 IN("+mmFexcl2+")"))
			+ (isEmpty(mmFexcl3) ? "" : (" AND FCL_COD3 IN("+mmFexcl3+")"))
		ExecuteSQL(strSQL);
	}
	
	// Отберем из строк настройки закрытия счетов для способа DISTR все строки,
	// относящиеся к счету, который закрываем, из настройки закрытия счетов
	strSQL = "SELECT *"
			+" FROM ^ZAKRSC_R_DISTR"
			+" where FID_DOC = "+sqlTo(par.mmFwid)
				+" and ((Fbdat<="+sqlTo(dat1)
				+" and Fedat>="+sqlTo(dat2)
				+" ) or (fbdat>="+sqlTo(dat1)
				+" and fbdat<="+sqlTo(dat2)
				+" ) or (fedat>="+sqlTo(dat1)
				+" and fedat<="+sqlTo(dat2)+"))"
	tblZakr = OpenTable("s", strSQL);

	if(tblZakr.IsEmpty())
	{
		//Сюда не должны бы попасть, но на всякий случай...
		tblZakr.close(5652);
		tblZakr = null;
		return;
	}

	// Запомним кол-во строк закрытия
	// (потом надо будет отдельно обрабатывать последнюю строку)
	var nRecCnt = tblZakr.recordCount;
	
	//Создаем таблицу, в к-ю будем помещать рез-ты вычисления выражений 
	//для каждой из строк
	DropTable("ZRVAL");
	if(IsTable("ZRVAL"))
	{
		strMsg = "r_zrdistr.js:"
		+"\nВнимание, ошибка!"
		+"\nНе удалилась т-ца ZRVAL при закрытии счета "+mmFsc+"/"+mmFsu+"/"+mmFst+"/"+mmFcl1+"/"+mmFcl2+"/"+mmFcl3
		+"\nпо способу DISTR"
		+"\nЗакрытие произведено не будет";
		alert(strMsg);
		return;
	}
	
	/*
	var fidType = allt(sqlTID);
	var type = fidType;
	var length = 0;
	var i = fidType.indexOf("(");
	if (i != -1)
	{
		type = fidType.substr(0,i);
		length =fidType.substring(i + 1,fidType.length -1);
	}
	*/
	
	strSQL = "CREATE TABLE ZRVAL("
			+" FWID " + SqlType("LONG")
			+", FVALUE "+SqlType("DOUBLE")
			+")"
	ExecuteSQL(strSQL);

	if (SUBD == ORACLE)
	{
		ExecuteSQL("DROP INDEX FWID",false);
	}
	
	strSQL = "CREATE INDEX FWID ON ZRVAL(FWID)";
	ExecuteSQL(strSQL);
	
	oEval = new DpEval();
	oEval.setTable(tblZakr);
	oEval.addVar("DAT1", dat1);
	oEval.addVar("DAT2", dat2);
	
	tVal = OpenTable("s", "ZRVAL");
	
	// Здесь накопим общую сумму
	var mTValue = 0;
	
	// Теперь пробегаем по всем строкам и вычисляем значение выражения
	// Вычисленные значения помещаем в отдельную таблицу
	if (!tblZakr.IsEmpty())
	{
		tblZakr.MoveFirst();
	}
	
	for(; !tblZakr.IsEOF(); tblZakr.MoveNext())
	{
		oEval.addExpr("RFSC_TO", toScrObj(tblZakr.getValue("FSC_TO")));
		oEval.addExpr("RFSU_TO", toScrObj(tblZakr.getValue("FSU_TO")));
		oEval.addExpr("RFST_TO", toScrObj(tblZakr.getValue("FST_TO")));
		oEval.addExpr("RFCOD1_TO", toScrObj(tblZakr.getValue("FCOD1_TO")));
		oEval.addExpr("RFCOD2_TO", toScrObj(tblZakr.getValue("FCOD2_TO")));
		oEval.addExpr("RFCOD3_TO", toScrObj(tblZakr.getValue("FCOD3_TO")));
		oEval.addExpr("RFCOD1_TYPE", toScrObj(tblZakr.getValue("FCOD1_TYPE")));
		oEval.addExpr("RFCOD2_TYPE", toScrObj(tblZakr.getValue("FCOD2_TYPE")));
		oEval.addExpr("RFCOD3_TYPE", toScrObj(tblZakr.getValue("FCOD3_TYPE")));
		oEval.addExpr("RFBDAT", toScrObj(tblZakr.getValue("FBDAT")));
		oEval.addExpr("RFEDAT", toScrObj(tblZakr.getValue("FEDAT")));
		
		mFexpr = tblZakr.getValue("FEXPR");
		mFwid = tblZakr.getValue("FWID");
		mFvalue = oEval.eval(mFexpr);		
		
		// Проверка типа результата
		if(typeof(mFvalue)!="number")
		{
			strMsg = "r_zrdistr.js:"
			+"\nВнимание, ошибка!"
			+"\nПри закрытии счета "+mmFsc+"/"+mmFsu+"/"+mmFst+"/"+mmFcl1+"/"+mmFcl2+"/"+mmFcl3+" по способу DISTR"
			+"\nвыражение "+mFexpr
			+"\nдало результат "+mFvalue
			+"\nтипа, отличного от числового"
			+"\nСтрока будет пропущена";
			alert(strMsg);
			continue;
		}
		var m = new Object();
		m.FWID = mFwid;
		m.Fvalue = mFvalue;
		UpdateTable("^ZRVAL",m,true);

		// Накапливаем общую сумму
		mTValue += mFvalue;
	}

	if(mTValue==0)
	{
		// нет значения, пропорционально которому разбрасывать
		tVal.close(5652);
		tVal=null;
		return;
	}

	//vlad 16.10.2008
	//Если закрываем конкретную сумму, то надо сначала найти общую сумму для расчета пропорции
	var koefSum = 1;
	var nRestSum = 0;//остаток нераспределенной суммы
	if(isSUM)
	{
		nRestSum = mmFproc;
		strSQL="SELECT "
		+" SUM(FSUM3) AS F3"
		+", SUM(FSUM4) AS F4"
		+", SUM(FSUM5) AS F5"
		+", SUM(FSUM6) AS F6"
		+" FROM ZRSC_"
		var sn = getSnap(strSQL);
		if(sn)
		{
			var mFsum3 = sn[0];
			var mFsum4 = sn[1];
			var mFsum5 = sn[2];
			var mFsum6 = sn[3];
			if(isSL)
			{
				//берем сальдо
				sum_db = mFsum3;
				sum_cr = mFsum4;
			}
			else
			{
				//берем обороты
				sum_db = mFsum5;
				sum_cr = mFsum6;
			}
			
			if(isTurn)
			{
				//сворачиваем
				tmp_sum_db = sum_db;
				sum_db = sum_db-sum_cr;
				sum_cr = sum_cr-tmp_sum_db;
			}
			
			mFsumTotal = isDB ? sum_db : sum_cr;
			//Сумма, которую распределяем, передана нам в mmFproc
			koefSum = mmFproc/mFsumTotal;
			mmFproc = 100;
		}
		else
		{
		
		}
		sn = null;
	}
	//////////////////////////////////////////////////////////
	// Запомним номера справочников аналитики,
	// привязанных к счету, который закрываем
	tcl_schet = OpenTable("s","CL_SCHET","U0");
	// номера спр-ков аналитик счета, к-й закрываем
	//var mCl1=0, mCl2=0, mCl3=0;
	var mCl1=0, mCl2=0, mCl3=0;
	// выберем из плана счетов
   
	var oSnap = getSnap(
		"SELECT Fcl1,Fcl2,Fcl3 FROM ^cl_schet WHERE"
		+ " Fschet=" + sqlTo(mmFsc)
		+ " AND Fsubschet=" + sqlTo(mmFsu)
		+ " AND Fstat=" + sqlTo(mmFst));
	if (oSnap != null)
	{
		mCl1 = oSnap[0];
		mCl2 = oSnap[1];
		mCl3 = oSnap[2];
	}

	// сюда будем писать результаты...
	tz    = OpenTable("s", "SCHET_ZR");
	
	// ...а отсюда брать суммы
	tsc   = OpenTable("s", "ZRSC_");   // счет откуда 
	for(; !tsc.IsEOF(); tsc.MoveNext())
	{

		if(isSL)
		{
			//берем сальдо
			sum_db = tsc.getValue("FSUM3");
			sum_cr = tsc.getValue("FSUM4");
		}
		else
		{
			//берем обороты
			sum_db = tsc.getValue("FSUM5");
			sum_cr = tsc.getValue("FSUM6");
		}

		if(isTurn)
		{
			//сворачиваем
			tmp_sum_db = sum_db;
			sum_db = sum_db-sum_cr;
			sum_cr = sum_cr-tmp_sum_db;
		}
		
		mFsum = isDB ? sum_db : sum_cr;

		// учтем процент
		if(mmFproc!=100)
		{
			mFsum = round(mFsum*mmFproc/100, 2);
		}
		
		// Найдем коэффициент, на который будем умножать значения
		var mKoef = mFsum/mTValue;
		
		mmFsc = toScrObj(tsc.getValue("FSC"));
		mmFsu = toScrObj(tsc.getValue("FSU"));
		mmFst = toScrObj(tsc.getValue("FST"));
		mmFcl1= toScrObj(tsc.getValue("FCL_COD1"));
		mmFcl2= toScrObj(tsc.getValue("FCL_COD2"));
		mmFcl3= toScrObj(tsc.getValue("FCL_COD3"));
		
		// Теперь пробегаем по строкам закрытия и добавляем строки
		nRec = 1;
		// "закрытая" сумма
		mTSumZr = 0;
		
		//fruckt
		//счет на который закрываем теперь определяется текстовыми полями - выражениями
		//обработаем их
		oEval.addVar("HFSC", mmFsc);
		oEval.addVar("HFSU", mmFsu);
		oEval.addVar("HFST", mmFst);
		oEval.addVar("HFCOD1", mmFcl1);
		oEval.addVar("HFCOD2", mmFcl2);
		oEval.addVar("HFCOD3", mmFcl3);
		
		if (!tblZakr.IsEmpty())
		{
			tblZakr.MoveFirst();
		}

		for( ; !tblZakr.IsEOF(); tblZakr.MoveNext())
		{
			//fruckt
			//счет на который закрываем теперь определяется текстовыми полями - выражениями
			//обработаем их
			/*
			toFsc = tblZakr.getValue("Fsc_to");
			toFsu = tblZakr.getValue("Fsu_to");
			toFst = tblZakr.getValue("Fst_to");
			toFcl1 = tblZakr.getValue("Fcod1_to");
			toFcl2 = tblZakr.getValue("Fcod2_to");
			toFcl3 = tblZakr.getValue("Fcod3_to");
			*/
			
			toFsc = oEval.eval(toScrObj(tblZakr.getValue("Fsc_to")))
			toFsu = oEval.eval(toScrObj(tblZakr.getValue("Fsu_to")))
			toFst = oEval.eval(toScrObj(tblZakr.getValue("Fst_to")))
			toFcl1 = oEval.eval(toScrObj(tblZakr.getValue("Fcod1_to")))
			toFcl2 = oEval.eval(toScrObj(tblZakr.getValue("Fcod2_to")))
			toFcl3 = oEval.eval(toScrObj(tblZakr.getValue("Fcod3_to")))
			toFsc = (isEmpty(toFsc) ? 0 : toFsc)
			toFsu = (isEmpty(toFsu) ? 0 : toFsu)
			toFst = (isEmpty(toFst) ? 0 : toFst)
			toFcl1 = (isEmpty(toFcl1) ? 0 : toFcl1)
			toFcl2 = (isEmpty(toFcl2) ? 0 : toFcl2)
			toFcl3 = (isEmpty(toFcl3) ? 0 : toFcl3)
			
			// номера спр-ков аналитик счета, на к-й закрываем
			//var mCl1_to=0, mCl2_to=0, mCl3_to=0;
			var mCl1_to=0, mCl2_to=0, mCl3_to=0;
			oSnap = getSnap(
				"SELECT Fcl1,Fcl2,Fcl3 FROM ^cl_schet WHERE"
				+ " Fschet=" + sqlTo(toFsc)
				+ " AND Fsubschet=" + sqlTo(toFsu)
				+ " AND Fstat=" + sqlTo(toFst));
			if (oSnap != null)
			{
				mCl1_to = oSnap[0];
				mCl2_to = oSnap[1];
				mCl3_to = oSnap[2];
			}
			// номер спр-ка аналитики счета, к-й закрываем, соответствующий
			// номеру спр-ка 1-й аналитики, на к-й закрываем
			//var nCl1=(mCl1_to==mCl1)? 1 :((mCl1_to==mCl2)? 2 :((mCl1_to==mCl3)? 3 : 0 ))
			var nCl1= (mCl1_to==0 ? 0 : (mCl1_to==mCl1 ? 1 : (mCl1_to==mCl2 ? 2 : (mCl1_to==mCl3 ? 3 : 0))))
			
			// номер спр-ка аналитики счета, к-й закрываем, соответствующий
			// номеру спр-ка 2-й аналитики, на к-й закрываем
			//var nCl2=(mCl2_to==mCl1)? 1 :((mCl2_to==mCl2)? 2 :((mCl2_to==mCl3)? 3 : 0 ))
			var nCl2= (mCl2_to==0 ? 0 : (mCl2_to==mCl1 ? 1 : (mCl2_to==mCl2 ? 2 : (mCl2_to==mCl3 ? 3 : 0))))
			
			// номер спр-ка аналитики счета, к-й закрываем, соответствующий
			// номеру спр-ка 1-й аналитики, на к-й закрываем
			//var nCl3=(mCl3_to==mCl1)? 1 :((mCl3_to==mCl2)? 2 :((mCl3_to==mCl3)? 3 : 0 ))
			var nCl3= (mCl3_to==0 ? 0 : (mCl3_to==mCl1 ? 1 : (mCl3_to==mCl2 ? 2 : (mCl3_to==mCl3 ? 3 : 0))))
			
			//////////////////////////////////////////////////////////
			
			// Коды аналитик на счете, куда закрываем. Приоритет отдаем аналитикам,
			// жестко "забитым" в настройке
			toFcl1= (!isEmpty(toFcl1) ? toFcl1 : (nCl1==1 ? mmFcl1 :(nCl1==2 ? mmFcl2 :(nCl1==3 ? mmFcl3 : 0))));
			toFcl2= (!isEmpty(toFcl2) ? toFcl2 : (nCl2==1 ? mmFcl1 :(nCl2==2 ? mmFcl2 :(nCl2==3 ? mmFcl3 : 0))));
			toFcl3= (!isEmpty(toFcl3) ? toFcl3 : (nCl3==1 ? mmFcl1 :(nCl3==2 ? mmFcl2 :(nCl3==3 ? mmFcl3 : 0))));
			
			// Достаем вычисленное значение для данной строки закрытия
			mFwid = tblZakr.getValue("FWID");
			oSnap = getSnap("SELECT Fvalue FROM ^ZRVAL WHERE fwid=" + sqlTo(mFwid));
//-         if(!tVal.Seek("=", mFwid)){
			if (oSnap == null)
			{
				// странно...
				strMsg = "r_zrdistr.js:"
				+"\nВнимание, ошибка!"
				+"\nПри закрытии счета "+mmFsc+"/"+mmFsu+"/"+mmFst+"/"+mmFcl1+"/"+mmFcl2+"/"+mmFcl3+" по способу DISTR"
				+"\nв таблице значений не нашлось значение..."
				+"\nСтрока будет пропущена";
				alert(strMsg);
				continue;
			}
			if(isSUM)
			{
				if(nValRecCnt==nValRec && nRec==nRecCnt)
				{
					//Последняя строка закрытия
					mSumZr = nRestSum;
				}
				else
				{
					mSumZr = round(mFsum*koefSum,2);
				}
			}

			if(nRec==nRecCnt)
			{
				// Последняя строка. Чтобы учесть ошибки округления
				// от общей cуммы сальдо отнимем уже "закрытую" сумму
				mSumZr = mFsum - mTSumZr;
				mTSumZr = 0;
			}
			else
			{
				mFvalue = oSnap[0];
				mSumZr = round(mFvalue*mKoef,2);
				mTSumZr += mSumZr;
			}
			nRec++;

			if (mSumZr!=0)
			{
				strWait = mmFsc+"/"+mmFsu+"/"+mmFst+"/"+mmFcl1+"/"+mmFcl2+"/"+mmFcl3
				+" --> "+toFsc+"/"+toFsu+"/"+toFst+"/"+toFcl1+"/"+toFcl2+"/"+toFcl3
				WAIT(strWait)
				
				var m = new Object();
				m.FWID = GetUID();
				//m.Ftxt = "Закрывающая проводка DISTR сч.-"+mmFsc+"/"+mmFsu+"/"+mmFst+"/"+mmFcl1+"/"+mmFcl2+"/"+mmFcl3+"-";
				//m.Ftxt = "Закрывающая проводка DISTR № "+mmFnom+", mmFproc="+mmFproc+", oSnap[0]="+oSnap[0]+", mKoef("+mKoef+") = mFsum("+mFsum+")/mTValue("+mTValue+")";
				m.Ftxt = "Закрывающая проводка DISTR № "+mmFnom;
				m.Fdb_sc = isZDB ? mmFsc : toFsc;
				m.Fdb_su = isZDB ? mmFsu : toFsu;
				m.Fdb_st = isZDB ? mmFst : toFst;
				m.Fdb_cod1 = isZDB ? mmFcl1 : toFcl1;
				m.Fdb_cod2 = isZDB ? mmFcl2 : toFcl2;
				m.Fdb_cod3 = isZDB ? mmFcl3 : toFcl3;
				m.Fcr_sc = isZDB ? toFsc : mmFsc;
				m.Fcr_su = isZDB ? toFsu : mmFsu;
				m.Fcr_st = isZDB ? toFst : mmFst;
				m.Fcr_cod1 = isZDB ? toFcl1 : mmFcl1;
				m.Fcr_cod2 = isZDB ? toFcl2 : mmFcl2;
				m.Fcr_cod3 = isZDB ? toFcl3 : mmFcl3;
				m.Fsum = mSumZr;
				m.Fdate = dat2;
				m.Fval = 0;
				m.Fvkurs = 0;
				m.Fsumspr = 0;
				m.Fvalspr = 0;
				m.Fdocvid = 'закр.';
				m.Fdocnum = "12345";
				m.Fwrk = 15;
				m.Fuser = 0;
				m.Fvkurs = 0;
				m.Forg0 = Number(CURRENT_ORG);
				UpdateTable("^SCHET_ZR",m,true);
		
				if(isSUM)
				{
					nRestSum = nRestSum - mSumZr
				}
			}
		} //end of for(tblZakr.MoveFirst(); !tblZakr.IsEOF(); tblZakr.MoveNext())
	}
	
	tblZakr.close(5652);
	tblZakr = null;
	tVal.close(5652);
	tVal = null;
	tcl_schet.close(5652);
	tcl_schet = null;
	tz.close(5652);
	tz = null;
	tsc.close(5652);
	tsc = null;
	CLEARWAIT();
}
