﻿/*
	Двойных Яков
	Процедура расчета закрытия счетов по способу TRANSF
	06.06.2007
	"Распределение общей сумы по группе счетов в прпоцентном соотношении используя"
	"один из счетов для перевода сумм"
*/
// Назначение.
/*

*/

include("objects/DpEval.js");

// Константы для поля FKIND
// (переехали из e_zak.htm)
var KIND_SL = 1;			//брать остаток
var KIND_OB = 2;			//брать оборот
var KIND_DB = 4;			//дебетовый
var KIND_CR = 8;			//кредитовый
var KIND_TURN = 16;			//сворачивать
var KIND_NOTURN = 32;		//сворачивать
var KIND_ZDB = 64;			//Закрываемый счет - по Дт
var KIND_ZCR = 128;			//Закрываемый счет - по Кт
var KIND_IGNORE_CL1 = 256;	// по всем аналитикам 1
var KIND_IGNORE_CL2 = 512;	// по всем аналитикам 2
var KIND_IGNORE_CL3 = 1024;	// по всем аналитикам 3
var KIND_ZERO_SL = 2048;	// Закрыть полностью (сальдо после закрытия==0)
var KIND_DEFAULT = KIND_SL | KIND_DB | KIND_TURN | KIND_ZCR;


function r_zrtransf(par, dat1, dat2)
{
	var deciSum = getPar("DECISUM");
	
	//который закрываем
	mmFkind		= par.mmFkind;

	//№ строки настройки
	var mmFnom 	= par.mmFnom;

	//Разберемся с тем, что будем закрывать
	var isDB	= mmFkind & KIND_DB;    //дебетовые или кредитовые

	var sSelect = GetPatternIntersection("ZAKRSC_R_DISTR", "ZAKRSC_R_DISTR");
	if (!isEmpty(par.Fcod1))
	{
		sSelect = sSelect.replace(/FCOD1_TO/gi, String(par.Fcod1)+" AS FCOD1_TO");
	}
	
	// Отберем из настройки закрытия счетов все строки,
	// относящиеся к способу TRANSF и к текущей группе
	var tmpZakr = getTmpTableName("", true);
	strSQL = " SELECT"
				+" "+sSelect
				+", "+Convert(0, "MONEY")+" AS FSUM"
				+", "+Convert(0, "DBL")+" AS FKOEF"
				+", "+Convert(0, "DBL")+" AS FKOEFTO"
			+" INTO"
				+" "+tmpZakr
			+" FROM"
				+" ^ZAKRSC_R_DISTR"
			+" WHERE 1 = 1"
				+" AND FID_DOC = "+sqlTo(par.mmFwid)
	ExecuteSQL(strSQL);
	
	createIndex(tmpZakr, "FSCHET", "FSC,FSU,FST,FCOD1,FCOD2,FCOD3");
	
	var tblZakr = OpenTable(tmpZakr);
	if(tblZakr.IsEmpty())
	{
		//Сюда не должны бы попасть, но на всякий случай...
		tblZakr.Close();
		tblZakr = null;
		DropTable(tmpZakr);
		return;
	}
	
	oEval = new DpEval();
	oEval.setTable(tblZakr);
	oEval.addVar("DAT1", dat1);
	oEval.addVar("DAT2", dat2);

	var tmpProv = getTmpTableName("", true);
	var tmpStor = getTmpTableName("", true);

	//Создадим таблицу с проводками по интересующим нас счетам
	//Сначала выбираем проводки
	strSQL = " CREATE TABLE"
				+" "+tmpProv
				+" ("
				+" FSUM "+SqlType("CURRENCY")
				+", FDB_SC "+SqlType("LONG")
				+", FDB_SU "+SqlType("LONG")
				+", FDB_ST "+SqlType("LONG")
				+", FDB_COD1 "+SqlType("LONG")
				+", FDB_COD2 "+SqlType("LONG")
				+", FDB_COD3 "+SqlType("LONG")
				+", FCR_SC "+SqlType("LONG")
				+", FCR_SU "+SqlType("LONG")
				+", FCR_ST "+SqlType("LONG")
				+", FCR_COD1 "+SqlType("LONG")
				+", FCR_COD2 "+SqlType("LONG")
				+", FCR_COD3 "+SqlType("LONG")
				+", FVAL "+SqlType("LONG")
				+" )"
	ExecuteSQL(strSQL);
	
	var strSelect = " FSUM"
					+", FDB_SC"
					+", FDB_SU"
					+", FDB_ST"
					+", FDB_COD1"
					+", FDB_COD2"
					+", FDB_COD3"
					+", FCR_SC"
					+", FCR_SU"
					+", FCR_ST"
					+", FCR_COD1"
					+", FCR_COD2"
					+", FCR_COD3"
					+", FVAL"

	for (tblZakr.MoveFirst(); !tblZakr.IsEOF(); tblZakr.MoveNext())
	{
		//fruckt
		var sWhere = " AND FDATE BETWEEN "+sqlTo(dat1)+" AND "+sqlTo(dat2);
		if (!isEmpty(toScrObj(tblZakr.getValue("FBDAT"))) || !isEmpty(toScrObj(tblZakr.getValue("FEDAT"))))
		{
			sWhere = "";
			if (!isEmpty(toScrObj(tblZakr.getValue("FBDAT"))))
				sWhere += " AND FDATE >= "+sqlTo(toScrObj(tblZakr.getValue("FBDAT")))
			
			if (!isEmpty(toScrObj(tblZakr.getValue("FEDAT"))))
				sWhere += " AND FDATE <= "+sqlTo(toScrObj(tblZakr.getValue("FEDAT")))
		}

		var toFsc = oEval.eval(toScrObj(tblZakr.getValue("FSC_TO")))
		var toFsu = normalizeResult("number", oEval.eval(toScrObj(tblZakr.getValue("FSU_TO"))));
		var toFst = normalizeResult("number", oEval.eval(toScrObj(tblZakr.getValue("FST_TO"))));
		var toFcl1 = normalizeResult("number", oEval.eval(toScrObj(tblZakr.getValue("FCOD1_TO"))));
		var toFcl2 = normalizeResult("number", oEval.eval(toScrObj(tblZakr.getValue("FCOD2_TO"))));
		var toFcl3 = normalizeResult("number", oEval.eval(toScrObj(tblZakr.getValue("FCOD3_TO"))));
		
		//Сначала выбираем нормальные проводки
		strSQL = " INSERT INTO"
					+" "+tmpProv
					+" ("+strSelect+")"
					+" SELECT"
						+" "+strSelect
					+" FROM"
						+" ^SCHET"
					+" WHERE 1 = 1"
						+" "+sWhere
						+" AND "+(isDB ? "FDB_SC" : "FCR_SC" )+" = "+toFsc
						+" "+sqlw0And((isDB ? "FDB_SU" : "FCR_SU" )+" = ", toFsu)
						+" "+sqlw0And((isDB ? "FDB_ST" : "FCR_ST" )+" = ", toFst)
						+" "+sqlw0And((isDB ? "FDB_COD1" : "FCR_COD1" )+" = ", toFcl1)
						+" "+sqlw0And((isDB ? "FDB_COD2" : "FCR_COD2" )+" = ", toFcl2)
						+" "+sqlw0And((isDB ? "FDB_COD3" : "FCR_COD3" )+" = ", toFcl3)
						+" AND NOT FWRK IN (254, 16)"
		ExecuteSQL(strSQL);

		// Добавим закрывающие проводки
		if (op_zakr())
		{
			strSQL = " INSERT INTO"
						+" "+tmpProv
						+" ("+strSelect+")"
					+" SELECT"
						+" "+strSelect
					+" FROM"
						+" ^SCHET_ZR"
					+" WHERE "
						+" FDATE BETWEEN "+sqlTo(dat1)+" AND "+sqlTo(dat2)
						+" AND "+(isDB ? "FDB_SC" : "FCR_SC" )+" = "+toFsc
						+" "+sqlw0And((isDB ? "FDB_SU" : "FCR_SU" )+" = ", toFsu)
						+" "+sqlw0And((isDB ? "FDB_ST" : "FCR_ST" )+" = ", toFst)
						+" "+sqlw0And((isDB ? "FDB_COD1" : "FCR_COD1" )+" = ", toFcl1)
						+" "+sqlw0And((isDB ? "FDB_COD2" : "FCR_COD2" )+" = ", toFcl2)
						+" "+sqlw0And((isDB ? "FDB_COD3" : "FCR_COD3" )+" = ", toFcl3)
						+" AND NOT FWRK IN (254, 16)"
			ExecuteSQL(strSQL);
		}
		
		var sum = 0;
		
		strSQL = " SELECT"
					+" SUM(FSUM)"
				+" FROM"
					+" "+tmpProv
				+" WHERE 1 = 1"
					+" AND "+(isDB ? "FDB_SC" : "FCR_SC" )+" = "+toFsc
					+" "+sqlw0And((isDB ? "FDB_SU" : "FCR_SU" )+" = ", toFsu)
					+" "+sqlw0And((isDB ? "FDB_ST" : "FCR_ST" )+" = ", toFst)
					+" "+sqlw0And((isDB ? "FDB_COD1" : "FCR_COD1" )+" = ", toFcl1)
					+" "+sqlw0And((isDB ? "FDB_COD2" : "FCR_COD2" )+" = ", toFcl2)
					+" "+sqlw0And((isDB ? "FDB_COD3" : "FCR_COD3" )+" = ", toFcl3)
		var a = getSnap(strSQL);
		if (!isEmpty(a) && !isEmpty(a[0]))
		{
			sum = toScrObj(a[0]);
		}
		
		tblZakr.Edit();
		tblZakr.setValue("FSUM", sum);
		tblZakr.Update();
	}
	
	//выберем все коды аналитики 1
	if (isEmpty(par.Fcod1))
	{
		//fruckt
		//такой ренжим возможен если счета имеют идентичную структуру 
		//на соответствующих уровнях аналитики
		strSQL = " SELECT DISTINCT"
					+" FCL1"
					+", FCL1_TYPE"
				+" FROM"
					+" ^CL_SCHET C INNER JOIN"
					+" ("
						+" SELECT DISTINCT"
							+" "+(isDB ? "FDB_SC" : "FCR_SC")+" AS FSC"
							+", "+(isDB ? "FDB_SU" : "FCR_SU")+" AS FSU"
							+", "+(isDB ? "FDB_ST" : "FCR_ST")+" AS FST"
						+" FROM"
							+" "+tmpProv
					+" ) T ON (C.FSCHET = T.FSC AND C.FSUBSCHET = T.FSU AND C.FSTAT = T.FST)"
				+" WHERE "+SqlCmpTrue
		var tCheckAn1 = OpenTable(strSQL);
		if (tCheckAn1.recordCount == 1)
		{
			strSQL = " SELECT DISTINCT"
						+" "+(isDB ? "FDB_COD1" : "FCR_COD1")+" AS FCOD1"
					+" FROM"
						+" "+tmpProv
					+" WHERE "+SqlCmpTrue
						+" AND "+(isDB ? "FDB_COD1" : "FCR_COD1")+" > 0"
			var tblAn = OpenTable(strSQL);
			if (!tblAn.IsEmpty())
			{
				for (tblAn.MoveFirst(); !tblAn.IsEOF(); tblAn.MoveNext())
				{
					par.Fcod1 = toScrObj(tblAn.getValue("FCOD1"));
					r_zrtransf(par, dat1, dat2);
				}

				tblAn.Close();
				tblAn = null;
				
				tblZakr.Close();
				tblZakr = null;
				
				DropTable(tmpZakr);
				DropTable(tmpProv);
				
				tCheckAn1.Close();
				tCheckAn1 = null;
				
				return true;
			}
			tblAn.Close();
			tblAn = null;
		}
		tCheckAn1.Close();
		tCheckAn1 = null;
	}

	//И расчитаем общюю сумму оборотов
	//Создадим таблицу с общими оборотами по интересующим нас счетам
	strSQL = " SELECT"
				+" SUM(TMP.FSUM) AS FSUM"
				+", TMP.FVAL"
			+" FROM"
				+" "+tmpProv+" AS TMP"
			+" GROUP BY "
				+" TMP.FVAL"
	var sumOb = getSnap(strSQL);
	if (isEmpty(sumOb) || isEmpty(sumOb[0]))
	{
		tblZakr.Close();
		tblZakr = null;
		DropTable(tmpZakr);
		
		return true;
	}
	else
	{
		sumObVal = toScrObj(sumOb[0])
	}
	sumOb = null;
	
	tblZakr.requery();
	for (tblZakr.MoveFirst(); !tblZakr.IsEOF(); tblZakr.MoveNext())
	{
		proc = toScrObj(tblZakr.getValue("FPROC"));
		sum = toScrObj(tblZakr.getValue("FSUM")); 
		if (!isEmpty(sum))
		{
			var koef = (sumObVal * (proc / 100) - sum) / sum;
		}
		else
		{
			var koef = sumObVal * proc / 100;
		}
		
		tblZakr.Edit();
		tblZakr.setValue("FKOEF", koef);
		tblZakr.Update();
	}

	tblZakr.requery();
	strSQL = " SELECT"
				+" SUM(FKOEF * "+IIF("FSUM = 0", "1", "FSUM")+") AS FRESULT"
			+" FROM"
				+" "+tmpZakr
			+" WHERE 1 = 1"
				//fruckt
				//если распределяем отрицательную сумму
				//+" AND FKOEF * FSUM >= 0"
				+" AND FKOEF * ABS(FSUM) >= 0"
	var skoef = toScrObj(getSnap(strSQL)[0]);
	for (tblZakr.MoveFirst(); !tblZakr.IsEOF(); tblZakr.MoveNext())
	{
		koef = toScrObj(tblZakr.getValue("FKOEF"));
		var mFsum = toScrObj(tblZakr.getValue("FSUM"));
		if (isEmpty(mFsum))
		{
			var koefto = koef / skoef;
		}
		else
		{
			var koefto = koef * mFsum / skoef;
		}

		tblZakr.Edit();
		tblZakr.setValue("FKOEFTO", koefto);
		tblZakr.Update();
	}
	
	//fruckt
	//для проверки
	//browse("select * from "+tmpZakr)	
	
	tblZakr.requery();
	for (tblZakr.MoveFirst(); !tblZakr.IsEOF(); tblZakr.MoveNext())
	{
		koef = toScrObj(tblZakr.getValue("FKOEF"));
		var mFsum = toScrObj(tblZakr.getValue("FSUM"));
		
		//fruckt
		//если распределяем отрицательную сумму
		//if (koef * mFsum > 0)
		if (koef * Math.abs(mFsum) > 0)
			continue;
		
		var mmFsc = oEval.eval(toScrObj(tblZakr.getValue("FSC_TO")));
		var mmFsu = normalizeResult("number", oEval.eval(toScrObj(tblZakr.getValue("FSU_TO"))));
		var mmFst = normalizeResult("number", oEval.eval(toScrObj(tblZakr.getValue("FST_TO"))));
		var mmFcl1 = normalizeResult("number", oEval.eval(toScrObj(tblZakr.getValue("FCOD1_TO"))));
		var mmFcl2 = normalizeResult("number", oEval.eval(toScrObj(tblZakr.getValue("FCOD2_TO"))));
		var mmFcl3 = normalizeResult("number", oEval.eval(toScrObj(tblZakr.getValue("FCOD3_TO"))));
		
		DropTable(tmpStor);
		//Создадим таблицу с общими оборотами по интересующему нас счету
		strSQL = " SELECT"
					+" SUM(TMP.FSUM) AS FSUM"
					+", TMP.FDB_SC"
					+", TMP.FDB_SU"
					+", TMP.FDB_ST"
					+", TMP.FDB_COD1"
					+", TMP.FDB_COD2"
					+", TMP.FDB_COD3"
					+", TMP.FCR_SC"
					+", TMP.FCR_SU"
					+", TMP.FCR_ST"
					+", TMP.FCR_COD1"
					+", TMP.FCR_COD2"
					+", TMP.FCR_COD3"
					+", TMP.FVAL"
				+" INTO "
						+" "+tmpStor
				+" FROM"
						+" "+tmpProv+" TMP"
				+" WHERE 1 = 1"
					+" AND "+(isDB ? "TMP.FDB_SC" : "TMP.FCR_SC" )+" = "+mmFsc
					+" "+sqlw0And((isDB ? "TMP.FDB_SU" : "TMP.FCR_SU" )+" = ", mmFsu)
					+" "+sqlw0And((isDB ? "TMP.FDB_ST" : "TMP.FCR_ST" )+" = ", mmFst)
					+" "+sqlw0And((isDB ? "TMP.FDB_COD1" : "TMP.FCR_COD1" )+" = ", mmFcl1)
					+" "+sqlw0And((isDB ? "TMP.FDB_COD2" : "TMP.FCR_COD2" )+" = ", mmFcl2)
					+" "+sqlw0And((isDB ? "TMP.FDB_COD3" : "TMP.FCR_COD3" )+" = ", mmFcl3)
				+" GROUP BY "
					+" TMP.FDB_SC"
					+", TMP.FDB_SU"
					+", TMP.FDB_ST"
					+", TMP.FDB_COD1"
					+", TMP.FDB_COD2"
					+", TMP.FDB_COD3"
					+", TMP.FCR_SC"
					+", TMP.FCR_SU"
					+", TMP.FCR_ST"
					+", TMP.FCR_COD1"
					+", TMP.FCR_COD2"
					+", TMP.FCR_COD3"
					+", TMP.FVAL"
				+" HAVING"
					+" SUM(TMP.FSUM) <> 0"
		ExecuteSQL(strSQL);

		tblStor = OpenTable(tmpStor);
		for (tblStor.MoveFirst(); !tblStor.IsEOF(); tblStor.MoveNext())
		{
			var oSnap = getSnap(
								" SELECT"
									+" FCL1"
									+", FCL2"
									+", FCL3"
								+" FROM"
									+" ^CL_SCHET"
								+" WHERE 1 = 1"
									+" AND FSCHET = "+(isDB ? toScrObj(tblStor.getValue("FDB_SC")) : toScrObj(tblStor.getValue("FCR_SC")))
									+" AND FSUBSCHET = "+(isDB ? toScrObj(tblStor.getValue("FDB_SU")) : toScrObj(tblStor.getValue("FCR_SU")))
									+" AND FSTAT = "+(isDB ? toScrObj(tblStor.getValue("FDB_ST")) : toScrObj(tblStor.getValue("FCR_ST")))
								);	
			if (oSnap != null)
			{
				mCl1 = toScrObj(oSnap[0]);
				mCl2 = toScrObj(oSnap[1]);
				mCl3 = toScrObj(oSnap[2]);
			}
			oSnap = null;
			
			//в зависимости от знака коэфициента проводки будут сторнирующие или наоборот
			//сначала делаем типа сторнирующие
			var m = new Object();
			m.FWID = GetUID();
			m.FTXT = "Закрывающая проводка TRANSF, сторно (№"+String(mmFnom)+")";
			m.FDB_SC = toScrObj(tblStor.getValue("FDB_SC"))
			m.FDB_SU = toScrObj(tblStor.getValue("FDB_SU"))
			m.FDB_ST = toScrObj(tblStor.getValue("FDB_ST"))
			m.FDB_COD1 = toScrObj(tblStor.getValue("FDB_COD1"))
			m.FDB_COD2 = toScrObj(tblStor.getValue("FDB_COD2"))
			m.FDB_COD3 = toScrObj(tblStor.getValue("FDB_COD3"))
			m.FCR_SC = toScrObj(tblStor.getValue("FCR_SC"))
			m.FCR_SU = toScrObj(tblStor.getValue("FCR_SU"))
			m.FCR_ST = toScrObj(tblStor.getValue("FCR_ST"))
			m.FCR_COD1 = toScrObj(tblStor.getValue("FCR_COD1"))
			m.FCR_COD2 = toScrObj(tblStor.getValue("FCR_COD2"))
			m.FCR_COD3 = toScrObj(tblStor.getValue("FCR_COD3"))
			//vlad 13.02.12
			//m.FSUM = round(toScrObj(tblStor.getValue("FSUM")) * koef, getPar("DECISUM"));
			var nRest = -round(toScrObj(tblStor.getValue("FSUM")) * koef, deciSum)
			m.FSUM = -nRest;
			m.FDATE = dat2;
			m.FVAL = toScrObj(tblStor.getValue("FVAL"))
			m.FSUMSPR = 0;
			m.FVALSPR = 0;
			m.FDOCVID = "закр.";
			m.FDOCNUM = "12345";
			m.FWRK = 15;
			m.FUSER = 0;
			
			if (!isEmpty(m.FSUM))
			{
				updateTable("^SCHET_ZR", m, true);
			}
			m = null;
			
			toFcl1 = (isDB ? toScrObj(tblStor.getValue("FDB_COD1")) : toScrObj(tblStor.getValue("FCR_COD1")));
			toFcl2 = (isDB ? toScrObj(tblStor.getValue("FDB_COD2")) : toScrObj(tblStor.getValue("FCR_COD2")));
			toFcl3 = (isDB ? toScrObj(tblStor.getValue("FDB_COD3")) : toScrObj(tblStor.getValue("FCR_COD3")));
			
			//раскидаем данную сумму по остальным счетам
			strSQL = " SELECT"
						+" *"
					+" FROM"
						+" "+tmpZakr
					+" WHERE "+SqlCmpTrue
						//fruckt
						//если распределяем отрицательную сумму
						//+" AND FKOEF * FSUM >= 0"
						+" AND FKOEF * ABS(FSUM) >= 0"
			var tbl4distr = OpenTable(strSQL);

			// Запомним кол-во строк закрытия
			// (потом надо будет отдельно обрабатывать последнюю строку)
			var nRecCnt = tbl4distr.recordCount;
			var nRec = 1;

			for (tbl4distr.MoveFirst(); !tbl4distr.IsEOF(); tbl4distr.MoveNext())
			{
				var koefto = toScrObj(tbl4distr.getValue("FKOEFTO"));
				
				var mmFsc_to = oEval.eval(toScrObj(tbl4distr.getValue("FSC_TO")));
				var mmFsu_to = normalizeResult("number", oEval.eval(toScrObj(tbl4distr.getValue("FSU_TO"))));
				var mmFst_to = normalizeResult("number", oEval.eval(toScrObj(tbl4distr.getValue("FST_TO"))));
				var mmFcl1_to = normalizeResult("number", oEval.eval(toScrObj(tbl4distr.getValue("FCOD1_TO"))));
				var mmFcl2_to = normalizeResult("number", oEval.eval(toScrObj(tbl4distr.getValue("FCOD2_TO"))));
				var mmFcl3_to = normalizeResult("number", oEval.eval(toScrObj(tbl4distr.getValue("FCOD3_TO"))));
				
				//соберем таблицу настройки распределения
				strSQL = " SELECT DISTINCT"
							+" A.FSCHET AS FSC"
							+", A.FSUBSCHET AS FSU"
							+", A.FSTAT AS FST"
							+", A.FCL1"
							+", A.FCL2"
							+", A.FCL3"
							//fruckt
							//этот участок перенесен в цыкл
							//+", "+koefto+"/COUNT(*) AS FKOEFTO"
							+", "+koefto+" AS FKOEFTO"
						+" FROM"
							+" ^CL_SCHET A"
						+" WHERE 1 = 1"
							+" AND A.FSCHET = "+mmFsc_to
							+" "+sqlw0And("A.FSUBSCHET = ", mmFsu_to)
							+" "+sqlw0And("A.FSTAT = ", mmFst_to)
							+" AND ("
								+" SELECT"
									+" COUNT(*)"
								+" FROM"
									+" ^CL_SCHET B"
								+" WHERE "+SqlCmpTrue
									+" AND B.FSCHET = A.FSCHET"
									+(isEmpty(mmFsu_to)
									? " AND "+IIF("A.FSUBSCHET > 0", "B.FSUBSCHET", "A.FSUBSCHET")+" = A.FSUBSCHET"
									: " AND B.FSUBSCHET = A.FSUBSCHET")
									+(isEmpty(mmFst_to)
									? " AND "+IIF("A.FSTAT > 0", "B.FSTAT", "A.FSTAT")+" = A.FSTAT" 
									: " AND B.FSTAT = A.FSTAT")
								+" ) = 1"
				var tblBlck = OpenTable(strSQL);
				var nRecCntBlck = tblBlck.recordCount;
				var nRecBlck = 1;
				
				for (tblBlck.MoveFirst(); !tblBlck.IsEOF(); tblBlck.MoveNext())
				{
					koefto = toScrObj(tblBlck.getValue("FKOEFTO"));
					
					mCl1_to = toScrObj(tblBlck.getValue("FCL1"));
					mCl2_to = toScrObj(tblBlck.getValue("FCL2"));
					mCl3_to = toScrObj(tblBlck.getValue("FCL3"));
				
					// номер спр-ка аналитики счета, к-й закрываем, соответствующий
					// номеру спр-ка 1-й аналитики, на к-й закрываем
					var nCl1 = (isEmpty(mCl1_to) ? 0 : (mCl1_to == mCl1)? 1 :((mCl1_to == mCl2)? 2 :((mCl1_to == mCl3)? 3 : 0)))

					// номер спр-ка аналитики счета, к-й закрываем, соответствующий
					// номеру спр-ка 2-й аналитики, на к-й закрываем
					var nCl2 = (isEmpty(mCl2_to) ? 0 : (mCl2_to == mCl1)? 1 :((mCl2_to == mCl2)? 2 :((mCl2_to == mCl3)? 3 : 0)))

					// номер спр-ка аналитики счета, к-й закрываем, соответствующий
					// номеру спр-ка 1-й аналитики, на к-й закрываем
					var nCl3 = (isEmpty(mCl3_to) ? 0 : (mCl3_to == mCl1)? 1 :((mCl3_to == mCl2)? 2 :((mCl3_to == mCl3)? 3 : 0)))
					//////////////////////////////////////////////////////////
					
					// Коды аналитик на счете, куда закрываем. Приоритет отдаем аналитикам,
					// жестко "забитым" в настройке
					toFcl1 = (!isEmpty(mmFcl1_to) ? mmFcl1_to : (nCl1==1 ? toFcl1 :(nCl1==2 ? toFcl2 :(nCl1==3 ? toFcl3 : 0))));
					toFcl2 = (!isEmpty(mmFcl2_to) ? mmFcl2_to : (nCl2==1 ? toFcl1 :(nCl2==2 ? toFcl2 :(nCl2==3 ? toFcl3 : 0))));
					toFcl3 = (!isEmpty(mmFcl3_to) ? mmFcl3_to : (nCl3==1 ? toFcl1 :(nCl3==2 ? toFcl2 :(nCl3==3 ? toFcl3 : 0))));
			
					var m = new Object();
					m.FWID = GetUID();
					m.FTXT = "Закрывающая проводка TRANSF, черным(№"+String(mmFnom)+")";
					m.FDB_SC = (isDB ? toScrObj(tblBlck.getValue("FSC")) : toScrObj(tblStor.getValue("FDB_SC")))
					m.FDB_SU = (isDB ? toScrObj(tblBlck.getValue("FSU")) : toScrObj(tblStor.getValue("FDB_SU")))
					m.FDB_ST = (isDB ? toScrObj(tblBlck.getValue("FST")) : toScrObj(tblStor.getValue("FDB_ST")))
					m.FDB_COD1 = (isDB ? toFcl1 : toScrObj(tblStor.getValue("FDB_COD1")))
					m.FDB_COD2 = (isDB ? toFcl2 : toScrObj(tblStor.getValue("FDB_COD2")))
					m.FDB_COD3 = (isDB ? toFcl3 : toScrObj(tblStor.getValue("FDB_COD3")))
					m.FCR_SC = (isDB ? toScrObj(tblStor.getValue("FCR_SC")) : toScrObj(tblBlck.getValue("FSC")))
					m.FCR_SU = (isDB ? toScrObj(tblStor.getValue("FCR_SU")) : toScrObj(tblBlck.getValue("FSU")))
					m.FCR_ST = (isDB ? toScrObj(tblStor.getValue("FCR_ST")) : toScrObj(tblBlck.getValue("FST")))
					m.FCR_COD1 = (isDB ? toScrObj(tblStor.getValue("FCR_COD1")) : toFcl1)
					m.FCR_COD2 = (isDB ? toScrObj(tblStor.getValue("FCR_COD2")) : toFcl2)
					m.FCR_COD3 = (isDB ? toScrObj(tblStor.getValue("FCR_COD3")) : toFcl3)
					
					//В последнюю строку запишем всю оставшуюся сумму
					if(nRec == nRecCnt && nRecBlck == nRecCntBlck)
					{
						//для отриц. сумм обычным округлением воспользоваться не можем - округлит
						//не в ту сторону
						m.FSUM = nRest < 0 ? -round(-nRest, deciSum) : round(nRest, deciSum);
					}
					else
					{
						//fruckt
						//этот участок перенесен в цыкл из запроса
						//m.FSUM = round(toScrObj(tblStor.getValue("FSUM")) * (-1) * koef * koefto, deciSum);
						m.FSUM = round(toScrObj(tblStor.getValue("FSUM")) * (-1) * koef * koefto / nRecCntBlck, deciSum);
					}
					//Остаток суммы к распределению
					nRest = nRest - m.FSUM;
					nRecBlck++;
				
					m.FDATE = dat2;
					m.FVAL = toScrObj(tblStor.getValue("FVAL"))
					m.FSUMSPR = 0;
					m.FVALSPR = 0;
					m.FDOCVID = "закр.";
					m.FDOCNUM = "12345";
					m.FWRK = 15;
					m.FUSER = 0;
					
					if (!isEmpty(toScrObj(m.FSUM)))
					{
						updateTable("^SCHET_ZR", m, true);
					}
					m = null;
				}
				tblBlck.Close();
				tblBlck = null;
				
				nRec++;
			}
			tbl4distr.Close();
			tbl4distr = null;
		}
		tblStor.Close();
		tblStor = null;
	}
	tblZakr.Close();
	tblZakr = null;

	DropTable(tmpZakr);
	DropTable(tmpProv);
	DropTable(tmpStor);
	
	CLEARWAIT();
}

function normalizeResult(mode, result)
{
	switch (mode)
	{
		case "number":
			if (typeof(result) == "undefined" || isEmpty(result) || String(result) == "undefined")
			{
				result = 0;
			}
		break;
		default:
		break;
	}
	
	return result;
}