/*
	Двойных Яков
	Процедура расчета закрытия счетов по способу TRANSF
	06.06.2007
	"Распределение общей сумы по группе счетов в прпоцентном соотношении используя"
	"один из счетов для перевода сумм"
*/
// Назначение.
/*

*/

//include("objects\\DpEval.js");

// Константы для поля FKIND
// (переехали из e_zak.htm)
var KIND_SL = 1;	//брать остаток
var KIND_OB = 2;	//брать оборот
var KIND_DB = 4;	//дебетовый
var KIND_CR = 8;	//кредитовый
var KIND_TURN = 16;	//сворачивать
var KIND_NOTURN = 32;	//сворачивать
var KIND_ZDB = 64;	//Закрываемый счет - по Дт
var KIND_ZCR = 128;	//Закрываемый счет - по Кт
var KIND_IGNORE_CL1 = 256;	// по всем аналитикам 1
var KIND_IGNORE_CL2 = 512;	// по всем аналитикам 2
var KIND_IGNORE_CL3 = 1024;	// по всем аналитикам 3
var KIND_ZERO_SL = 2048;	// Закрыть полностью (сальдо после закрытия==0)
var KIND_DEFAULT = KIND_SL | KIND_DB | KIND_TURN | KIND_ZCR;


function r_zrtransf_core(par, dat1, dat2)
{
	//который закрываем
	mmFsc			= par.mmFsc;
	mmFsu			= par.mmFsu;
	mmFst			= par.mmFst;
	mmFcl1		= isEmpty(par.mmFcl1) ? 0 : par.mmFcl1;
	mmFcl2		= isEmpty(par.mmFcl2) ? 0 : par.mmFcl2;
	mmFcl3		= isEmpty(par.mmFcl3) ? 0 : par.mmFcl3;

	mmFexcl1		= par.mmFexcl1;
	mmFexcl2		= par.mmFexcl2;
	mmFexcl3		= par.mmFexcl3;

	//на который закрываем
	mmFsc_to		= par.mmFsc_to;
	mmFsu_to		= par.mmFsu_to;
	mmFst_to		= par.mmFst_to;
	mmFcl1_to	= isEmpty(par.mmFcl1_to) ? 0 : par.mmFcl1_to;
	mmFcl2_to	= isEmpty(par.mmFcl2_to) ? 0 : par.mmFcl2_to;
	mmFcl3_to	= isEmpty(par.mmFcl3_to) ? 0 : par.mmFcl3_to;

	//дополнительно
	mmFgroup		= par.mmFgroup;
	mmFproc		= par.mmFproc;
	mmFkind		= par.mmFkind;

	//Разберемся с тем, что будем закрывать
	//var isSL	= mmFkind & KIND_SL;	//брать сальдо или обороты
	var isDB		= mmFkind & KIND_DB;    //дебетовые или кредитовые
	//var isTurn	= mmFkind & KIND_TURN;//сворачивать или не сворачивать
	//var isZDB	= mmFkind & KIND_ZDB;  //Закр.счет - по Дт или по Кт

	var isIgn1 = mmFkind & KIND_IGNORE_CL1;	// по всем аналитикам 1
	var isIgn2 = mmFkind & KIND_IGNORE_CL2;	// по всем аналитикам 2
	var isIgn3 = mmFkind & KIND_IGNORE_CL3;	// по всем аналитикам 3

	//var isZeroSl = mmFkind & KIND_ZERO_SL;	// Закрыть полностью (сальдо после закрытия==0)

	//теперь найдем коэффициент, ктоорый приведет сумму оборотов по нашему счету
	//в соответствии с установленным процентом от общей суммы по группе

	// Отберем из настройки закрытия счетов все строки,
	// относящиеся к способу TRANSF и к текущей группе
	var tmpZakr = getTmpTableName("", true);
	
	strSQL = " SELECT"
					+" *"
				+" INTO"
					+" "+tmpZakr
				+" FROM"
					+" ^ZAKRSC"
				+" WHERE 1 = 1"
					+" AND FIS_SLCT = "+sqlTrue
					+" AND FSPOSOB = 'TRANSF'"
					+" AND FGROUP=" + mmFgroup
					+" AND ((FBDAT <= "+sqlTo(dat1)+" AND FEDAT >= "+sqlTo(dat2)+")"
					+" OR (FBDAT >= "+sqlTo(dat1)+" AND FBDAT <= "+sqlTo(dat2)+")"
					+" OR (FEDAT >= "+sqlTo(dat1)+" AND FEDAT <= "+sqlTo(dat2)+"))"
	ExecuteSQL(strSQL);

	ExecuteSQL("CREATE INDEX FSCHET ON "+tmpZakr+" (FSC,FSU,FST,FCOD1,FCOD2,FCOD3)");

	var tblZakr = OpenTable("s", tmpZakr);

	if(tblZakr.IsEmpty())
	{
		//Сюда не должны бы попасть, но на всякий случай
		tblZakr.Close(5652);
		tblZakr = null;
		return true;
	}

	var tmpProv = getTmpTableName("", true);
	var tmpSum = getTmpTableName("", true);
	var tmpStor = getTmpTableName("", true);

	//Создадим таблицу с проводками по интересующим нас счетам
	//Сначала выбираем проводки
	var i = 1;
	var strSelect = " S.FSUM"
						+", S.FDB_SC"
						+", S.FDB_SU"
						+", S.FDB_ST"
						+", S.FDB_COD1"
						+", S.FDB_COD2"
						+", S.FDB_COD3"
						+", S.FCR_SC"
						+", S.FCR_SU"
						+", S.FCR_ST"
						+", S.FCR_COD1"
						+", S.FCR_COD2"
						+", S.FCR_COD3"
						+", S.FVAL"

	for (tblZakr.MoveFirst(); !tblZakr.IsEOF(); tblZakr.MoveNext())
	{
		//Сначала выбираем нормальные проводки
		strSQL = (i == 1 ? "" : " INSERT INTO "+tmpProv)
					+" SELECT"
						+" "+strSelect
					+(i == 1 ? " INTO "+tmpProv : "")
					+" FROM"
						+" ^SCHET S"
					+" WHERE "
						+" S.FDATE BETWEEN "+sqlTo(dat1)+" AND "+sqlTo(dat2)
						+" AND "+(isDB ? "S.FDB_SC" : "S.FCR_SC" )+"="+sqlTo(tblZakr.getValue("FSC"))
						+" AND "+(isDB ? "S.FDB_SU" : "S.FCR_SU" )+"="+sqlTo(tblZakr.getValue("FSU"))
						+" AND "+(isDB ? "S.FDB_ST" : "S.FCR_ST" )+"="+sqlTo(tblZakr.getValue("FST"))

//						+(isIgn1 ? "" : (" AND "+(isDB ? "S.FDB_COD1" : "S.FCR_COD1" )+"="+sqlTo(tblZakr("FCOD1"))))
//						+(isIgn2 ? "" : (" AND "+(isDB ? "S.FDB_COD2" : "S.FCR_COD2" )+"="+sqlTo(tblZakr("FCOD1"))))
//						+(isIgn3 ? "" : (" AND "+(isDB ? "S.FDB_COD3" : "S.FCR_COD3" )+"="+sqlTo(tblZakr("FCOD1"))))

						+(isIgn1 ? "" : (" AND "+(isDB ? "S.FDB_COD1" : "S.FCR_COD1" )+"="+sqlTo(mmFcl1_to)))
						+(isIgn2 ? "" : (" AND "+(isDB ? "S.FDB_COD2" : "S.FCR_COD2" )+"="+sqlTo(mmFcl2_to)))
						+(isIgn3 ? "" : (" AND "+(isDB ? "S.FDB_COD3" : "S.FCR_COD3" )+"="+sqlTo(mmFcl3_to)))
						+" AND NOT S.FWRK IN (254, 16)"
		ExecuteSQL(strSQL);

		// Добавим закрывающие проводки
		if (op_zakr())
		{
			strSQL = " INSERT INTO"
							+" "+tmpProv
						+" SELECT"
							+" "+strSelect
						+" FROM"
							+" ^SCHET_ZR S"
						+" WHERE "
							+" S.FDATE BETWEEN "+sqlTo(dat1)+" AND "+sqlTo(dat2)
							+" AND "+(isDB ? "S.FDB_SC" : "S.FCR_SC" )+"="+sqlTo(tblZakr.getValue("FSC"))
							+" AND "+(isDB ? "S.FDB_SU" : "S.FCR_SU" )+"="+sqlTo(tblZakr.getValue("FSU"))
							+" AND "+(isDB ? "S.FDB_ST" : "S.FCR_ST" )+"="+sqlTo(tblZakr.getValue("FST"))

//							+(isIgn1 ? "" : (" AND "+(isDB ? "S.FDB_COD1" : "S.FCR_COD1" )+"="+sqlTo(tblZakr("FCOD1"))))
//							+(isIgn2 ? "" : (" AND "+(isDB ? "S.FDB_COD2" : "S.FCR_COD2" )+"="+sqlTo(tblZakr("FCOD1"))))
//							+(isIgn3 ? "" : (" AND "+(isDB ? "S.FDB_COD3" : "S.FCR_COD3" )+"="+sqlTo(tblZakr("FCOD1"))))

							+(isIgn1 ? "" : (" AND "+(isDB ? "S.FDB_COD1" : "S.FCR_COD1" )+"="+sqlTo(mmFcl1_to)))
							+(isIgn2 ? "" : (" AND "+(isDB ? "S.FDB_COD2" : "S.FCR_COD2" )+"="+sqlTo(mmFcl2_to)))
							+(isIgn3 ? "" : (" AND "+(isDB ? "S.FDB_COD3" : "S.FCR_COD3" )+"="+sqlTo(mmFcl3_to)))
							+" AND NOT S.FWRK IN (254, 16)"
			ExecuteSQL(strSQL);
		}

		i++;
	}

	//Создадим таблицу с общими оборотами по интересующим нас счетам
	strSQL = " SELECT"
					+" SUM(TMP.FSUM) AS FSUM"
					+", "+(isDB ? "TMP.FDB_SC" : "TMP.FCR_SC" )
					+", "+(isDB ? "TMP.FDB_SU" : "TMP.FCR_SU" )
					+", "+(isDB ? "TMP.FDB_ST" : "TMP.FCR_ST" )
					+(isIgn1 ? "" : ","+(isDB ? "TMP.FDB_COD1" : "TMP.FCR_COD1" ))
					+(isIgn2 ? "" : ","+(isDB ? "TMP.FDB_COD2" : "TMP.FCR_COD2" ))
					+(isIgn3 ? "" : ","+(isDB ? "TMP.FDB_COD3" : "TMP.FCR_COD3" ))
					+", TMP.FVAL"
				+" INTO"
					+" "+tmpSum
				+" FROM"
					+" "+tmpProv+" AS TMP"
				+" GROUP BY "
					+" "+(isDB ? "TMP.FDB_SC" : "TMP.FCR_SC" )
					+", "+(isDB ? "TMP.FDB_SU" : "TMP.FCR_SU" )
					+", "+(isDB ? "TMP.FDB_ST" : "TMP.FCR_ST" )
					+(isIgn1 ? "" : ","+(isDB ? "TMP.FDB_COD1" : "TMP.FCR_COD1" ))
					+(isIgn2 ? "" : ","+(isDB ? "TMP.FDB_COD2" : "TMP.FCR_COD2" ))
					+(isIgn3 ? "" : ","+(isDB ? "TMP.FDB_COD3" : "TMP.FCR_COD3" ))
					+", TMP.FVAL"
	ExecuteSQL(strSQL);


	//расчитаем коефициенты
	strSQL = " SELECT"
					+" ZAKR.FPROC"
					+", ZAKR.FSC AS "+(isDB ? "FDB_SC" : "FCR_SC" )
					+", ZAKR.FSU AS "+(isDB ? "FDB_SU" : "FCR_SU" )
					+", ZAKR.FST AS "+(isDB ? "FDB_ST" : "FCR_ST" )
					+(isIgn1 ? "" : ", ZAKR.FCOD1 AS "+(isDB ? "FDB_COD1" : "FCR_COD1" ))
					+(isIgn2 ? "" : ", ZAKR.FCOD2 AS "+(isDB ? "FDB_COD2" : "FCR_COD2" ))
					+(isIgn3 ? "" : ", ZAKR.FCOD3 AS "+(isDB ? "FDB_COD3" : "FCR_COD3" ))
				+" FROM"
					+" "+tmpZakr+" AS ZAKR LEFT JOIN "+tmpSum+" AS TMP ON "
						+" ZAKR.FSC = "+(isDB ? "TMP.FDB_SC" : "TMP.FCR_SC" )
						+" AND ZAKR.FSU = "+(isDB ? "TMP.FDB_SU" : "TMP.FCR_SU" )
						+" AND ZAKR.FST = "+(isDB ? "TMP.FDB_ST" : "TMP.FCR_ST" )
/*
						+(isIgn1 ? "" : " AND ZAKR.FCOD1 = "+(isDB ? "TMP.FDB_COD1" : "TMP.FCR_COD1" ))
						+(isIgn2 ? "" : " AND ZAKR.FCOD2 = "+(isDB ? "TMP.FDB_COD2" : "TMP.FCR_COD2" ))
						+(isIgn3 ? "" : " AND ZAKR.FCOD3 = "+(isDB ? "TMP.FDB_COD3" : "TMP.FCR_COD3" ))
*/

	var tblSum = OpenTable("s", strSQL);

	var tblStor;
	var tbl4Raspr;

	var sc,su,st,cl1,cl2,cl3;

	var tcl_schet = OpenTable("s", "CL_SCHET");
	// номера спр-ков аналитик счета, к-й закрываем
	var mCl1 = 0, mCl2 = 0, mCl3 = 0;

	// номера спр-ков аналитик счета, на к-й закрываем
	var mCl1_to=0, mCl2_to=0, mCl3_to=0;
	var oSnap = getSnap(
			   "SELECT Fcl1,Fcl2,Fcl3 FROM ^cl_schet WHERE"
			   + " Fschet=" + sqlTo(mmFsc_to)
			   + " AND Fsubschet=" + sqlTo(mmFsu_to)
			   + " AND Fstat=" + sqlTo(mmFst_to));
	if (oSnap != null)
	{
		mCl1_to = oSnap[0];
		mCl2_to = oSnap[1];
		mCl3_to = oSnap[2];
	}
	/*
	if(tcl_schet.Seek("=",mmFsc_to, mmFsu_to, mmFst_to))
	{
		mCl1_to = tcl_schet("FCL1");
		mCl2_to = tcl_schet("FCL2");
		mCl3_to = tcl_schet("FCL3");
	}
	*/


	var nCl1, nCl2, nCl3;
	
	//Сумма осталась для распределения
	var sumRaspr = 0;
	var sum4raspr = 0;

	for (tblSum.MoveFirst(); !tblSum.IsEOF(); tblSum.MoveNext())
	{
		sc = isDB ? tblSum.getValue("FDB_SC") : tblSum.getValue("FCR_SC");
		su = isDB ? tblSum.getValue("FDB_SU") : tblSum.getValue("FCR_SU");
		st = isDB ? tblSum.getValue("FDB_ST") : tblSum.getValue("FCR_ST");

		cl1 = (isIgn1 ? 0 : (isDB ? tblSum.getValue("FDB_COD1") : tblSum.getValue("FCR_COD1")))
		cl2 = (isIgn2 ? 0 : (isDB ? tblSum.getValue("FDB_COD2") : tblSum.getValue("FCR_COD2")))
		cl3 = (isIgn3 ? 0 : (isDB ? tblSum.getValue("FDB_COD3") : tblSum.getValue("FCR_COD3")))

		var oSnap = getSnap(
				   "SELECT Fcl1,Fcl2,Fcl3 FROM ^cl_schet WHERE"
				   + " Fschet=" + sqlTo(sc)
				   + " AND Fsubschet=" + sqlTo(su)
				   + " AND Fstat=" + sqlTo(st));
		if (oSnap != null)
		{
			mCl1 = oSnap[0];
			mCl2 = oSnap[1];
			mCl3 = oSnap[2];
		}
		oSnap = null;
		/*
		if(tcl_schet.Seek("=", sc, su, st))
		{
			mCl1 = tcl_schet("FCL1");
			mCl2 = tcl_schet("FCL2");
			mCl3 = tcl_schet("FCL3");
		}
		*/

		// номер спр-ка аналитики счета, к-й закрываем, соответствующий
		// номеру спр-ка 1-й аналитики, на к-й закрываем
		var nCl1 = (mCl1_to == 0 ? 0 : (mCl1_to == mCl1)? 1 :((mCl1_to == mCl2)? 2 :((mCl1_to == mCl3)? 3 : 0)))

		// номер спр-ка аналитики счета, к-й закрываем, соответствующий
		// номеру спр-ка 2-й аналитики, на к-й закрываем
		var nCl2 = (mCl2_to == 0 ? 0 : (mCl2_to == mCl1)? 1 :((mCl2_to == mCl2)? 2 :((mCl2_to == mCl3)? 3 : 0)))

		// номер спр-ка аналитики счета, к-й закрываем, соответствующий
		// номеру спр-ка 1-й аналитики, на к-й закрываем
		var nCl3 = (mCl3_to == 0 ? 0 : (mCl3_to == mCl1)? 1 :((mCl3_to == mCl2)? 2 :((mCl3_to == mCl3)? 3 : 0)))
		//////////////////////////////////////////////////////////

		DropTable(tmpStor);

		//Создадим таблицу с общими оборотами по интересующему нас счету
		strSQL = " SELECT"
					+" SUM(TMP.FSUM) AS FSUM"
					+", TMP.FDB_SC"
					+", TMP.FDB_SU"
					+", TMP.FDB_ST"
					+", TMP.FDB_COD1"
					+", TMP.FDB_COD2"
					+", TMP.FDB_COD3"
					+", TMP.FCR_SC"
					+", TMP.FCR_SU"
					+", TMP.FCR_ST"
					+", TMP.FCR_COD1"
					+", TMP.FCR_COD2"
					+", TMP.FCR_COD3"
					+", TMP.FVAL"
				+" INTO "
						+" "+tmpStor
				+" FROM"
						+" "+tmpProv+" TMP"
				+" WHERE 1 = 1"
					+" AND "+(isDB ? "TMP.FDB_SC = "+sqlTo(tblSum.getValue("FDB_SC")) : "TMP.FCR_SC = "+sqlTo(tblSum.getValue("FCR_SC")))
					+" AND "+(isDB ? "TMP.FDB_SU = "+sqlTo(tblSum.getValue("FDB_SU")) : "TMP.FCR_SU = "+sqlTo(tblSum.getValue("FCR_SU")))
					+" AND "+(isDB ? "TMP.FDB_ST = "+sqlTo(tblSum.getValue("FDB_ST")) : "TMP.FCR_ST = "+sqlTo(tblSum.getValue("FCR_ST")))
/*
					+(isIgn1 ? "" : " AND "+(isDB ? "TMP.FDB_COD1 = "+sqlTo(tblSum.getValue("FDB_COD1")) : "TMP.FCR_COD1 = "+sqlTo(tblSum.getValue("FCR_COD1"))))
					+(isIgn2 ? "" : " AND "+(isDB ? "TMP.FDB_COD2 = "+sqlTo(tblSum.getValue("FDB_COD2")) : "TMP.FCR_COD2 = "+sqlTo(tblSum.getValue("FCR_COD2"))))
					+(isIgn3 ? "" : " AND "+(isDB ? "TMP.FDB_COD3 = "+sqlTo(tblSum.getValue("FDB_COD3")) : "TMP.FCR_COD3 = "+sqlTo(tblSum.getValue("FCR_COD3"))))
*/
				+" GROUP BY "
					+" TMP.FDB_SC"
					+", TMP.FDB_SU"
					+", TMP.FDB_ST"
					+", TMP.FDB_COD1"
					+", TMP.FDB_COD2"
					+", TMP.FDB_COD3"
					+", TMP.FCR_SC"
					+", TMP.FCR_SU"
					+", TMP.FCR_ST"
					+", TMP.FCR_COD1"
					+", TMP.FCR_COD2"
					+", TMP.FCR_COD3"
					+", TMP.FVAL"
				+" HAVING"
					+" SUM(TMP.FSUM) <> 0"
		ExecuteSQL(strSQL);

		tblStor = OpenTable("s", tmpStor);
		if (!tblStor.IsEmpty())
		{
			for (tblStor.MoveFirst(); !tblStor.IsEOF(); tblStor.MoveNext())
			{
				sumRaspr = round(toScrObj(tblStor.getValue("FSUM")), 2);
				sum4raspr = round(toScrObj(tblStor.getValue("FSUM")) * (-1), 2);

				//в зависимости от знака коэфициента проводки будут сторнирующие или наоборот
				//сначала делаем типа сторнирующие
				strSQL = " INSERT INTO"
								+" ^SCHET_ZR"
							+" ("
								+" FWID"
								+", FTXT"
								+", FDB_SC"
								+", FDB_SU"
								+", FDB_ST"
								+", FDB_COD1"
								+", FDB_COD2"
								+", FDB_COD3"
								+", FCR_SC"
								+", FCR_SU"
								+", FCR_ST"
								+", FCR_COD1"
								+", FCR_COD2"
								+", FCR_COD3"
								+", FSUM"
								+", FDATE"
								+", FVAL"
								+", Fsumspr"
								+", Fvalspr"
								+", Fdocvid"
								+", Fdocnum"
								+", Fwrk"
								+", Fuser"
							+" )"
							+" VALUES"
							+" ("
								+" "+sqlTo(GetUID())
								+", 'Закрывающая проводка TRANSF, сторно'"
								+", "+sqlTo(tblStor.getValue("FDB_SC"))
								+", "+sqlTo(tblStor.getValue("FDB_SU"))
								+", "+sqlTo(tblStor.getValue("FDB_ST"))
								+", "+sqlTo(tblStor.getValue("FDB_COD1"))
								+", "+sqlTo(tblStor.getValue("FDB_COD2"))
								+", "+sqlTo(tblStor.getValue("FDB_COD3"))
								+", "+sqlTo(tblStor.getValue("FCR_SC"))
								+", "+sqlTo(tblStor.getValue("FCR_SU"))
								+", "+sqlTo(tblStor.getValue("FCR_ST"))
								+", "+sqlTo(tblStor.getValue("FCR_COD1"))
								+", "+sqlTo(tblStor.getValue("FCR_COD2"))
								+", "+sqlTo(tblStor.getValue("FCR_COD3"))

								+", "+sqlTo(sum4raspr)

								+", "+sqlTo(dat2)
								+", "+sqlTo(tblStor.getValue("FVAL"))
								+", 0"
								+", 0"
								+", 'закр.'"
								+", '12345'"
								+", 15"
								+", 0"
							+" )";
				ExecuteSQL(strSQL);

				strSQL = " SELECT"
								+" ZAKR.FPROC"
								+", ZAKR.FSC AS "+(isDB ? "FDB_SC" : "FCR_SC" )
								+", ZAKR.FSU AS "+(isDB ? "FDB_SU" : "FCR_SU" )
								+", ZAKR.FST AS "+(isDB ? "FDB_ST" : "FCR_ST" )
								+(isIgn1 ? "" : ", ZAKR.FCOD1 AS "+(isDB ? "FDB_COD1" : "FCR_COD1" ))
								+(isIgn2 ? "" : ", ZAKR.FCOD2 AS "+(isDB ? "FDB_COD2" : "FCR_COD2" ))
								+(isIgn3 ? "" : ", ZAKR.FCOD3 AS "+(isDB ? "FDB_COD3" : "FCR_COD3" ))
							+" FROM"
								+" "+tmpZakr+" AS ZAKR LEFT JOIN "+tmpSum+" AS TMP ON "
									+" ZAKR.FSC = "+(isDB ? "TMP.FDB_SC" : "TMP.FCR_SC" )
									+" AND ZAKR.FSU = "+(isDB ? "TMP.FDB_SU" : "TMP.FCR_SU" )
									+" AND ZAKR.FST = "+(isDB ? "TMP.FDB_ST" : "TMP.FCR_ST" )
							+" WHERE 1 = 1"
								+" AND NOT (ZAKR.FSC  = "+(isDB ? tblSum.getValue("FDB_SC") : tblSum.getValue("FCR_SC"))
								+" AND ZAKR.FSU = "+(isDB ? tblSum.getValue("FDB_SU") : tblSum.getValue("FCR_SU"))
								+" AND ZAKR.FST = "+(isDB ? tblSum.getValue("FDB_ST") : tblSum.getValue("FCR_ST"))
								+(isIgn1 ? "" : " AND ZAKR.FCOD1 = "+(isDB ? tblSum.getValue("FDB_COD1") : tblSum.getValue("FCR_COD1")))
								+(isIgn2 ? "" : " AND ZAKR.FCOD2 = "+(isDB ? tblSum.getValue("FDB_COD2") : tblSum.getValue("FCR_COD2")))
								+(isIgn3 ? "" : " AND ZAKR.FCOD3 = "+(isDB ? tblSum.getValue("FDB_COD3") : tblSum.getValue("FCR_COD3")))
								+")"

				tbl4Raspr = OpenTable("s", strSQL);
				
				if (!tbl4Raspr.IsEmpty())
				{
					for (tbl4Raspr.MoveFirst(); !tbl4Raspr.IsEOF(); tbl4Raspr.MoveNext())
					{
						toFcl1 = isIgn1 ? 0 : (isDB ? tbl4Raspr.getValue("FDB_COD1") : tbl4Raspr.getValue("FCR_COD1"));
						toFcl2 = isIgn2 ? 0 : (isDB ? tbl4Raspr.getValue("FDB_COD2") : tbl4Raspr.getValue("FCR_COD2"));
						toFcl3 = isIgn3 ? 0 : (isDB ? tbl4Raspr.getValue("FDB_COD3") : tbl4Raspr.getValue("FCR_COD3"));

						// Коды аналитик на счете, куда закрываем. Приоритет отдаем аналитикам,
						// жестко "забитым" в настройке
						toFcl1 = (mmFcl1_to !=0 ? mmFcl1_to : (nCl1==1 ? toFcl1 :(nCl1==2 ? toFcl2 :(nCl1==3 ? toFcl3 : 0))));
						toFcl2 = (mmFcl2_to !=0 ? mmFcl2_to : (nCl2==1 ? toFcl1 :(nCl2==2 ? toFcl2 :(nCl2==3 ? toFcl3 : 0))));
						toFcl3 = (mmFcl3_to !=0 ? mmFcl3_to : (nCl3==1 ? toFcl1 :(nCl3==2 ? toFcl2 :(nCl3==3 ? toFcl3 : 0))));

						sum4raspr = round(toScrObj((tblStor.getValue("FSUM")) * round(toScrObj(tbl4Raspr.getValue("FPROC")), 2)) / 100, 2);
						sumRaspr -= sum4raspr;

						//а теперь переводим сумму на необходимый счет
						strSQL = " INSERT INTO"
										+" ^SCHET_ZR"
									+" ("
										+" FWID"
										+", FTXT"
										+", FDB_SC"
										+", FDB_SU"
										+", FDB_ST"
										+", FDB_COD1"
										+", FDB_COD2"
										+", FDB_COD3"
										+", FCR_SC"
										+", FCR_SU"
										+", FCR_ST"
										+", FCR_COD1"
										+", FCR_COD2"
										+", FCR_COD3"
										+", FSUM"
										+", FDATE"
										+", FVAL"
										+", Fsumspr"
										+", Fvalspr"
										+", Fdocvid"
										+", Fdocnum"
										+", Fwrk"
										+", Fuser"
									+" )"
									+" VALUES"
									+" ("
										+" "+sqlTo(GetUID())
										+", 'Закрывающая проводка TRANSF, сторно'"
										+", "+(isDB ? tbl4Raspr.getValue("FDB_SC") : tblStor.getValue("FDB_SC"))
										+", "+(isDB ? tbl4Raspr.getValue("FDB_SU") : tblStor.getValue("FDB_SU"))
										+", "+(isDB ? tbl4Raspr.getValue("FDB_ST") : tblStor.getValue("FDB_ST"))
										+", "+(isDB ? sqlTo(toFcl1) : tblStor.getValue("FDB_COD1"))
										+", "+(isDB ? sqlTo(toFcl2) : tblStor.getValue("FDB_COD2"))
										+", "+(isDB ? sqlTo(toFcl3) : tblStor.getValue("FDB_COD3"))
										+", "+(isDB ? tblStor.getValue("FCR_SC") : tbl4Raspr.getValue("FCR_SC"))
										+", "+(isDB ? tblStor.getValue("FCR_SU") : tbl4Raspr.getValue("FCR_SC"))
										+", "+(isDB ? tblStor.getValue("FCR_ST") : tbl4Raspr.getValue("FCR_SC"))
										+", "+(isDB ? tblStor.getValue("FCR_COD1") : sqlTo(toFcl1))
										+", "+(isDB ? tblStor.getValue("FCR_COD2") : sqlTo(toFcl2))
										+", "+(isDB ? tblStor.getValue("FCR_COD3") : sqlTo(toFcl3))
										+", "+sqlTo(sum4raspr)
										+", "+sqlTo(dat2)
										+", "+sqlTo(tblStor.getValue("FVAL"))
										+", 0"
										+", 0"
										+", 'закр.'"
										+", '12345'"
										+", 15"
										+", 0"
									+" )";
						ExecuteSQL(strSQL);
					}
				}

				tbl4Raspr.Close(5652);
				tbl4Raspr = null;
				
				//ложем нужную сумму
				strSQL = " INSERT INTO"
								+" ^SCHET_ZR"
							+" ("
								+" FWID"
								+", FTXT"
								+", FDB_SC"
								+", FDB_SU"
								+", FDB_ST"
								+", FDB_COD1"
								+", FDB_COD2"
								+", FDB_COD3"
								+", FCR_SC"
								+", FCR_SU"
								+", FCR_ST"
								+", FCR_COD1"
								+", FCR_COD2"
								+", FCR_COD3"
								+", FSUM"
								+", FDATE"
								+", FVAL"
								+", Fsumspr"
								+", Fvalspr"
								+", Fdocvid"
								+", Fdocnum"
								+", Fwrk"
								+", Fuser"
							+" )"
							+" VALUES"
							+" ("
								+" "+sqlTo(GetUID())
								+", 'Закрывающая проводка TRANSF, сторно'"
								+", "+sqlTo(tblStor.getValue("FDB_SC"))
								+", "+sqlTo(tblStor.getValue("FDB_SU"))
								+", "+sqlTo(tblStor.getValue("FDB_ST"))
								+", "+sqlTo(tblStor.getValue("FDB_COD1"))
								+", "+sqlTo(tblStor.getValue("FDB_COD2"))
								+", "+sqlTo(tblStor.getValue("FDB_COD3"))
								+", "+sqlTo(tblStor.getValue("FCR_SC"))
								+", "+sqlTo(tblStor.getValue("FCR_SU"))
								+", "+sqlTo(tblStor.getValue("FCR_ST"))
								+", "+sqlTo(tblStor.getValue("FCR_COD1"))
								+", "+sqlTo(tblStor.getValue("FCR_COD2"))
								+", "+sqlTo(tblStor.getValue("FCR_COD3"))

								+", "+sqlTo(sumRaspr)

								+", "+sqlTo(dat2)
								+", "+sqlTo(tblStor.getValue("FVAL"))
								+", 0"
								+", 0"
								+", 'закр.'"
								+", '12345'"
								+", 15"
								+", 0"
							+" )";
				ExecuteSQL(strSQL);

			}
		}

		tblStor.Close(5652);
		tblStor = null;
		
	}

	tblSum.Close(5652);
	tblSum = null;

	tblZakr.Close(5652);
	tblZakr = null;

	DropTable(tmpZakr);
	DropTable(tmpProv);
	DropTable(tmpSum);
	DropTable(tmpStor);

	CLEARWAIT();
}
