// JScript source code
include("sys\\DpList.js");

function listLoad()
{
	with( this )
	{
		title = "Зареєстровані папки документів|Зарегистрированые папки документов";
		//editTask = "e_list.xml";
//		printLabel = "LIST";
		xmlGridFile = "regdocfldr.xml";
		accDel = null;
	}
	getRegFldr(extPar.JID, extPar.type);
}

function getRegFldr(sJID, sType)
{
	// Выборка из файловой структуры информации о зарегистрированных документах
	var b = DropTable("TMP_REGFLDR");
	if (!b) return;
	var sSQL = "CREATE TABLE TMP_REGFLDR (FDOC " + SqlType("TEXT", 200) 
	+ ", FNOP " + SqlType("INT") + ") ";
	ExecuteSQL(sSQL);
	var sSearch = String(sType + sJID).toUpperCase();
	var sFile = getOrgPath() + "settings/journals/register";
	var file = new DpFile(sFile);
	if (!file.exists()) return;
	var docs = file.listFiles();
	for (var i = 0; i < docs.length; i++)
	{
		var docFldr = docs[i];
		if (!docFldr.isDirectory())
			continue;
			
		var sDoc = docFldr.getName();
		var opers = docFldr.listFiles();
		for (var j = 0; j < opers.length; j++)
		{
			var operFldr = opers[j];
			if (!operFldr.isDirectory())
				continue;
				
			var sReg = operFldr.getAbsolutePath() + "/" + sSearch;				
			var regFile = new DpFile(sReg);

			if (regFile.exists() && regFile.isDirectory())
			{
				ExecuteSQL("INSERT INTO TMP_REGFLDR (FDOC, FNOP) VALUES ( "
					+ sqlTo(sDoc) + "," + operFldr.getName() + ")");
			}
		}
	}
}

function listSrc()
{
/*
	var sWhere = " exists (select * from TMP_REGFLDR f where UPPER(f.fdoc) = UPPER(^CL_LNK.FDOC) AND f.FNOP = ^CL_LNK.FNOP )"
	this.qrySet	(
					"From", "^CL_LNK",
					"Where", sWhere,
					"Order", new Array("FDOC, FNOP")					
				);
*/
	var sWhere = " UPPER(f.fdoc) = UPPER(^CL_LNK.FDOC) AND f.FNOP = ^CL_LNK.FNOP "
	this.qrySet	(
//					"Fields", "^CL_LNK.FDOC, ^CL_LNK.FNOP",
					"Fields", " ^CL_LNK.* ",
					"From", " ^CL_LNK , TMP_REGFLDR f",
					"Where", sWhere,
					"Order", new Array("^CL_LNK.FDOC, ^CL_LNK.FNOP")					
				);
}

function listMenuInit()
{
	grid.AddMenuItem("OPENDOCS", "Зареєстровані документи|Зарегистрированные документы");
	grid.AddMenuItem("REJRNL", "Перереєструвати документи|Перерегистрировать документы");
	grid.AddMenuItem("", "");
	grid.AddMenuItem("ADDDOC", "Додати документ|Добавить документ");
	if (this.tbl.isRecord())
		grid.AddMenuItem("SETTINGS", "Налагодження|Настройка");
}

function listMenuRun(ID)
{
	if (ID == "OPENDOCS")
	{
		var par = new Object();
		par.doc = String(this.tbl.getValue("FDOC"));
		par.nop = Number(this.tbl.getValue("FNOP"));
		par.JID = extPar.JID;
		showWindow("l_journal.js", SW_NOMODAL, par);
	}
	else if (ID == "REJRNL")
	{
		var sWhere = " FWID="+ this.tbl.getValue("FWID");
		if(grid.getSelectedCount()>0)
			sWhere = grid.getSqlSelected();
		var tblReg = OpenTable("select * from ^CL_LNK where "+ sWhere);
		for(; !tblReg.isEOF(); tblReg.MoveNext())
		{
			var sDoc = tblReg.getValue("FDOC");
			var nNop = Number(tblReg.getValue("FNOP"));		
			var oDoc = new DpDoc(sDoc, nNop);
			var tblName = oDoc.getTableName();
			if (!tblName) 
				return;	
			var tbl = OpenTable("select FWID from ^"+ tblName 
								+" where FDOC="+ sqlTo(sDoc)
									+(!nNop? "" : " and FNOP="+ Number(nNop))
								);		
			var progress = getProgressMonitor();
			progress.beginTask(UR("Перереєстрація...|Перерегистрация..."), tbl.recordCount);
			for (; !tbl.isEOF(); tbl.moveNext())
			{
				var id = tbl.getValue("FWID");
				if (oDoc.loadByID(id, false, true))
				{
					oDoc.doRegistration();
					oDoc.clear();
				}
				progress.worked(1);
			}
			tbl.close();
			progress.done();
		}
		tblReg.close();
		return;
	}
	
	if (ID == "ADDDOC")
	{
		var pr = new Object();
		pr.isZaval=true;
		pr.ret = new Object();
		pr.ret.fdoc = String(this.tbl.getValue("FDOC"));
		pr.ret.fnop = Number(this.tbl.getValue("FNOP"));
		pr.allSys = true;		
		showWindow("l_cl_lnk.xml",SW_MODAL,pr,"");
		if ( typeof(pr.escape)!="undefined" && !pr.escape)
		{
			var sDoc = pr.ret.fdoc
			var nNop =  pr.ret.fnop;
			include ("Objects/DpJRegistrator.js");
			var oReg =new DpJRegistrator(sDoc, nNop, "US");
			oReg.regTo(extPar.JID, "", false);
			oReg.saveReg();
			var m = new Object();
			m.FDOC= sDoc;
			m.FNOP = nNop;
			updateTable("TMP_REGFLDR", m, true);
			list.tbl.close();
			getRegFldr(extPar.JID, extPar.type);
			list.tbl.requery();
			grid.refresh();
		}
		return;	
	}
	
	if (ID == "SETTINGS")
	{
		if (this.tbl.isRecord())
		{
			var oPar = new Object()
			oPar.doc = String(this.tbl.getValue("FDOC"));
			oPar.nop = Number(this.tbl.getValue("FNOP"));
			showWindow("l_docJournal.xml",SW_NOMODAL, oPar);
		}	
	}
}

function filterMode(s)
{
	return true;		
}