//Для Скорпио: конвертация договоров со справочника 110 в договора работы с контрагентами DOG_CL
include("doc/DpDoc.js");
include("Objects/DpClEx.js");

function convertDog()
{
	if(!confirm("Перед началом перекодировки договоров необходимо выполнить следующие действия:\n" +
			"- ОБЯЗАТЕЛЬНО для DOG_CL создать текстовые расширения длиной 30 символов: RAS1,RAS2,RAS3 и FLDR,FLDRNUM,AFLDR,AFLDRNUM длиной 20 символов\n" +
			"- создать простой справочник аналитики 'Статус договоров' и занести в него следующие данные:\n" +
			"	- 1 Проект\n" +
			"	- 2 Затверджений\n" +
			"	- 3 Розірваний\n" +
			"- в параметрах документов DOG_CL проставьте коды справочников типов и состояний договоров:\n" +
			"Продолжить перекодировку?"))
		return false;
	var fcl = 110;
	var oCl = new DpClEx("com.debet.clcl.cldog",fcl);
	var oDog = new DpDoc("DOG_CL",0);
	var tbl = OpenTable("select Fwid_cl from ^clrelclcl where Fcl="+fcl);
	var step = 0;
	setProgressRange(step, tbl.rowCount);
	for(; !tbl.IsEOF(); tbl.MoveNext())
	{
		setProgressPos(++step, step+"/"+tbl.rowCount);
		oCl.clear();
		oCl.loadByID(tbl.getValue("Fwid_cl"));
		
		oDog.clear();
		oDog.setVar("HDAT",oCl.getVar("HDATE"));
		oDog.setVar("HCOD",String(oCl.getVar("HCOD")));
		oDog.setVar("HVAL",oCl.getVar("HVAL"));
		oDog.setVar("HSUM_DOG",oCl.getVar("HVAL")==0?oCl.getVar("HSUM"):oCl.getVar("HVSUM"));
		oDog.setVar("HORG",oCl.getVar("HORG"));
		oDog.setVar("HTXT",oCl.getVar("HTXT"));
		oDog.setVar("HBDAT",oCl.getVar("HBDAT"));
		oDog.setVar("HEDAT",oCl.getVar("HEDAT"));
		oDog.setVar("HDOG_NUM",oCl.getVar("HTCOD"));
		oDog.setVar("HREM",oCl.getVar("HCOMMENT"));
		oDog.setVar("HTYPE_DOG",oCl.getExt("VID"));
		oDog.setVar("HSTATE_DOG",oCl.getVar("HSTATUS"));
		oDog.setVar("HCLOSE",oCl.getVar("HAFLDR")!="");
		oDog.setVar("HPODR",oCl.getExt("PID"));
		oDog.setVar("HSTATE_DAT",oCl.getVar("HSTATUSDATE"));
		oDog.setVar("HDAT_OPL",d00);
		oDog.setVar("HDAT_VYK",d00);
		oDog.setVar("HDAT_SAL",d00);
		oDog.setVar("HAVANS_DAT",d00);
		oDog.save();
		if(oCl.getExt("RAS1") || oCl.getExt("RAS2") || oCl.getExt("RAS3"))
		{
			oDog.setExt("RAS1",oCl.getExt("RAS1"));
			oDog.setExt("RAS2",oCl.getExt("RAS2"));
			oDog.setExt("RAS3",oCl.getExt("RAS3"));
		}
		oDog.setExt("FLDR",oCl.getVar("HFLDR"));
		oDog.setExt("AFLDR",oCl.getVar("HAFLDR"));
		oDog.setExt("FLDRNUM",oCl.getVar("HFLDRNUM"));
		oDog.setExt("AFLDRNUM",oCl.getVar("HAFLDRNUM"));
		oDog.saveExtToDB();
		//if(step==3) break;
	}
	setProgressPos(0);
	tbl.close();
	alert("Конвертация договоров окончена.");
}

//перекодировка кадровых приказов
function convertCdr()
{
	//prikaz => cdr_prk
	ExecuteSQL("insert into ^cdr_prk (Fwid,Fdoc_num,Fdoc_dat,Fdoc)"
			+" select Fwid,Fnumber,Fbdat,"
				+IIF("Ftype=0",sqlTo("CDR_OTP"),
					IIF("Ftype=2",sqlTo("CDR_IN"),
						IIF("Ftype=3",sqlTo("CDR_OI"),
							IIF("Ftype=4",sqlTo("CDR_OUT"),sqlTo("")))))
			+" from ^prikaz where Ftype in (0,2,3,4)");
	
	//sub_leave => prk_otp
	var t = OpenTable("select l.*,MIN(o.Fbdat) as Fbdat,MAX(o.Fedat) as Fedat "
				+" from ^prikaz as p inner join ^sub_leave as l on p.Fwid=l.Fwid_prk "
				+" inner join ^prk_o as o on l.Ftabn=o.Ftabn and p.Fbdat=o.Fdat_prik and p.Fnumber=o.Fnom_prik "
				+" group by Ftabn,Fwid_prk order by ftabn");
	var step = 0;
	setProgressRange(step, t.rowCount);
	for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
	{
		setProgressPos(++step, "Приказы на отпуск: "+step+"/"+t.rowCount);
		var m = new Object();
		m.Fwid = GetUID();
		m.Fwid_prk = t.getValue("Fwid_prk");
		m.Fcod = t.getValue("Ftabn");
		m.Fbperiod = t.getValue("Fbperiod");
		m.Feperiod = t.getValue("Feperiod");
		m.Fbdat = t.getValue("Fbdat");
		m.Fedat = t.getValue("Fedat");
		m.Fwrkdat = t.getValue("Fwrkdat");
		m.Freason = t.getValue("Freason");
		UpdateTable("^prk_otp",m,true);
	}
	setProgressPos(0);
	t.close();
	//апдейтим Fwid_cl
	ExecuteSQL("update ^prk_otp set Fwid_cl=(select Fwid_cl from ^clrelclcl as r "
					+" where r.Fcl="+getPar("CODPERS")+" and r.Fcod=^prk_otp.Fcod)");
	
	//sub_inout => prk_in,prk_out
	t = OpenTable("select p.Ftype,s.* from ^sub_inout as s inner join ^prikaz as p on s.Fwid_prk=p.Fwid");
	var step = 0;
	setProgressRange(step, t.rowCount);
	for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
	{
		setProgressPos(++step, "Приказы на назначение/увольнение: "+step+"/"+t.rowCount);
		var m = new Object();
		m.Fwid = GetUID();
		m.Fwid_prk = t.getValue("Fwid_prk");
		var snap = getSnap("select Fwid,Fcodpers from ^full_pers as f "
				+" where exists(select Fwid from ^shtat as s where s.Fwid="+t.getValue("Fwid_shtat")
					+" and s.Ftabn=f.Fcodpers and s.Fbdat=f.Fbdat and s.Fedat=f.Fedat)");
		if(snap)
		{
			m.Fwid_wp = snap[0];
			m.Fcod = snap[1];
		}
		if(t.getValue("Ftype")==2)
		{
			m.Freason = t.getValue("Freason");
			m.Fterm = t.getValue("Fterm");
			UpdateTable("^prk_in",m,true);
		}
		if(t.getValue("Ftype")==4)
		{
			m.Freason = t.getValue("Freason");
			m.Freason_st = t.getValue("Freason1");
			UpdateTable("^prk_out",m,true);
		}
	}
	setProgressPos(0);
	t.close();
	//обновляем испытательный срок и основание в work_pers
	ExecuteSQL("update ^work_pers set Fterm=(select Fterm from ^prk_in as p where ^work_pers.Fwid=p.Fwid_wp),"
			+"Freason=(select Freason from ^prk_in as p where ^work_pers.Fwid=p.Fwid_wp)"
			+" where exists(select Fwid_wp from ^prk_in as p where ^work_pers.Fwid=p.Fwid_wp)");
	ExecuteSQL("update ^work_pers set Freason_uv=(select Freason from ^prk_out as p where ^work_pers.Fwid=p.Fwid_wp)"
			+" where exists(select Fwid_wp from ^prk_out as p where ^work_pers.Fwid=p.Fwid_wp)");
	
	//sub_moveto => prk_outin
	var t = OpenTable("select * from ^sub_moveto");
	var step = 0;
	setProgressRange(step, t.rowCount);
	for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
	{
		setProgressPos(++step, "Приказы на перевод: "+step+"/"+t.rowCount);
		var m = new Object();
		m.Fwid = GetUID();
		m.Fwid_prk = t.getValue("Fwid_prk");
		var snap = getSnap("select Fwid,Fcodpers from ^full_pers as f "
				+" where exists(select Fwid from ^shtat as s where s.Fwid="+t.getValue("Fwid_shtat_from")
					+" and s.Ftabn=f.Fcodpers and s.Fbdat=f.Fbdat and s.Fedat=f.Fedat)");
		if(snap)
		{
			m.Fwid_out = snap[0];
			m.Fcod = snap[1];
		}
		snap = getSnap("select Fwid from ^full_pers as f "
				+" where exists(select Fwid from ^shtat as s where s.Fwid="+t.getValue("Fwid_shtat_to")
					+" and s.Ftabn=f.Fcodpers and s.Fbdat=f.Fbdat and s.Fedat=f.Fedat)");
		if(snap)
			m.Fwid_in = snap[0];
		
		m.Freason = t.getValue("Freason");
		UpdateTable("^prk_outin",m,true);
	}
	setProgressPos(0);
	t.close();
	//обновляем основание в work_pers
	ExecuteSQL("update ^work_pers set Freason=(select Freason from ^prk_outin as p where ^work_pers.Fwid=p.Fwid_in)"
			+" where exists(select Fwid_in from ^prk_outin as p where ^work_pers.Fwid=p.Fwid_in)");
	alert("Конвертация кадровых приказов окончена.");
}