include("Objects/DpGrid.js");

var title = "";
var tblName = "";

function listLoad()
{
	if(!extPar || !extPar.tbl)
		return false;
	
	if(typeof(extPar.caption) == "string")
		title = extPar.caption;
	else if(extPar.title)
		title = extPar.title;
	else if (typeof(extPar.tbl) == "string")
		title = extPar.tbl;
	else
		title = extPar.tbl.getSQLQuery();
	
	this.accDel = new Function("return false");
	
	this.save = onSave;
	this.escape = onExit;
	
	this.selectAll = selectAll;
	this.deselectAll = deselectAll;
	
	setButton(BSELECTALL, this, "selectAll");
	setButton(BDESELECTALL, this, "deselectAll");
	
	if(extPar.noSel)
		GRSEL.setVisible(false);
}

function listTitle()
{
	return title;
}

function listSrc()
{	
	if (typeof(extPar.tbl)== "string")
	{
		tblName = extPar.tbl;
		fields = extPar.fields;
		if(fields && fields.toUpperCase().indexOf("FWID")==-1)
			fields += ", FWID";
		this.tbl = OpenTable("m", 
					"select "+ (fields? fields : "*") 
					+" from ^"+ extPar.tbl 
					+(extPar.where? " where "+ extPar.where : "")
					+(extPar.order? " order by "+ extPar.order : "")
				);
	}
	else
	{
		tblName = extPar.tbl.getTableName();
		this.tbl = extPar.tbl;		
	}
}

function listDpGrid()
{	
	var nFld = this.tbl.fieldCount();	
	if(extPar.defCond)
	{
		grid.defCond(extPar.defCond.name, extPar.defCond.expr);	
		grid.color(extPar.defCond.color, extPar.defCond.name);
	}
	with(grid)
	{
		if (extPar.cells)
		{
			for (var i in extPar.cells)
			{
				if (extPar.cells[i].name != "")
				{
					var oCell = extPar.cells[i];
					FieldEx(oCell.name, UR(oCell.text), oCell.width);
				}
			}
		}
		else
		{
			for (var i = 1;i < nFld + 1;i++)
			{
				var fld = this.tbl.getFieldInfo(i);
				if (fld == null)
					continue;
				var sFormat = getGridFormat(fld.getType());
				FieldEx(new String(fld.getName()), new String(fld.getName()), 10, "", sFormat);
			}
		}
	}
	
	gridSaveFormat(false);
	grid.build();
		
	this.gridSel = gridSel;
	this.showInfo = showInfo;
	grid.setSelHandler(this, "gridSel");
	grid.addCheckHandler(this, "showInfo");
	
	list.tbl.MoveFirst();
}

function getGridFormat(sType)
{
	switch(String(sType))
	{
		case "DOUBLE":			
			return "%10.5f";
		default:
			return null;
	}	
}

function listDel()
{
	return false;
}

function selectAll()
{
	var tbl = grid.getTable();
	grid.setSelectedIDs(1, tbl.getRowCount());
	grid.showSelMassage();
	showInfo();
}

function deselectAll()
{
	grid.clearSelected();
	grid.showSelMassage();
	grid.refresh();
	LINFO.setText("");
	showInfo();
}

function gridSel()
{	
	var sMsg = "";
	var rowCount = grid.getSelectedCount();
	if(rowCount==0)
	{
		if(extPar.ret)
		{
			for(var fld in extPar.ret)
			{	   					
				var capt = colCaption(fld);
				if(capt)
					sMsg += capt +" - "+ toScrObj(list.tbl.getValue(fld)) +";  ";			  
			}
			LINFO.setText(sMsg);
		}
		return;
	}
	showInfo();
}

function showInfo(rowID, bCheck)
{
	var rowCount = grid.getSelectedCount();
	if(rowCount>0)
	{
		if(rowID && Number(rowID)==Number(list.tbl.getValue("FWID")))
		{
			if(bCheck)
				rowCount++;
			else
				rowCount--;
		}		
		var sMsg = UR("Виділено рядків: |Выделено записей: ") + rowCount;
		LINFO.setText(sMsg);
	}
}

function colCaption(sFld)
{
	var arrCell = grid.getColumnsArray();
	for(var i=0; i<arrCell.length; i++)
	{
		var capt = arrCell[i].getCaption();
		var fld = String(arrCell[i].getField()).toUpperCase();
		if(fld == sFld.toUpperCase())
			return capt;
	}
}

function onSave()
{
	extPar.escape = false;
	fillRetArr();
	CloseWindow();
}

function onExit()
{
	CloseWindow();
}

function fillRetArr()
{
	extPar.retArray = new Array();
	if(!extPar.ret)
	{
		extPar.ret = new Object();
		var nFld = list.tbl.fieldCount();
		for (var i = 1;i < nFld + 1;i++)
		{
			var fld = list.tbl.getFieldInfo(i);
			if(fld && fld.getName())
			{				
				var sFld = String(fld.getName()).toUpperCase().trim();
				extPar.ret[sFld] = null;
			}
		}
	}
	
	for( var i in extPar.ret )
	{	   					
		extPar.ret[i] = toScrObj(list.tbl.getValue(i));			  
	}
		
	if(grid.selectedCount>0)
	{
		var t = OpenTable(" SELECT * FROM ^"+ tblName +" WHERE "+ grid.sqlSelected());
		var j = 0;
		for(; !t.IsEOF(); t.MoveNext())
		{
			extPar.retArray[j] = new Array();
			for( var i in extPar.ret )
				extPar.retArray[j][i] = toScrObj(t.getValue(i));
			j++;
		}
		t.close();
	}
}

include("sys\\DpList.js");