//сервисные функции для подсистемы кадров
include("sys/udfs.js");

//минимальный табельный номер из строк кадрового приказа
//для более быстрого выполнения функции лучше сразу с идентификатором передавать тип приказа
function getPrkMinTabn(fwid_prk, fdoc)
{
	if(!fwid_prk)
		return 0;
	//если не передан, то определяем тип приказа
	if(!fdoc)
	{
		var snap = getSnap("select Fdoc from ^cdr_prk where Fwid="+fwid_prk);
		if(snap && snap[0])
			fdoc = snap[0];
		else
			return 0;
	}
	var tblName;
	switch(fdoc.toUpperCase())
	{
		case "CDR_IN":
			tblName = "prk_in";
		break;
		case "CDR_OUT":
			tblName = "prk_out";
		break;
		case "CDR_OI":
			tblName = "prk_outin";
		break;
		case "CDR_OTP":
			tblName = "prk_otp";
		break;
		default:
			WAIT(ru("Неизвестный тип кадрового приказа: ","Невідомий тип кадрового наказу: ")+fdoc+"!");
			return 0;
		break;
	}
	var snap = getSnap("select MIN(Fcod) from ^"+tblName+" where Fwid_prk="+fwid_prk);
	if(snap)
		return snap[0];
	else
		return 0;
}

//сохранение кадровых отпускных в зарплате
function saveOptInZrp(fwid_prk, TableName, SubRowsTableName)
{
	if(!TableName)
		TableName = "^prk_otp";
	if(!SubRowsTableName)
		SubRowsTableName = "^otp_type";
	
	var kodnvk = 0;
	//если есть параметр, то пытаемся проставить признак неявки в табеле
	if(getPar("NVK_PRIK"))
	{
		var oSnap = getSnap("select Fkod_nvk from ^cl_nvk where Frblnall='*'");
	    if (oSnap!=null)
	    	kodnvk=Number(oSnap[0])
	    if (kodnvk==0)
	    {
	    	alert(ru("Не найдено ниодной записи, относящейся к отпускным в настройках табелей!",
            		"Не знайдено жодного запису, який би відносився до відпусток в налаштуванні табелів!"));
	    }
	}
	//при наличии удаляем имеющиеся приказы по данному идентификатору
	var t = OpenTable("select * from ^prk_all where Fwid_prik="+fwid_prk);
	var oPrik = new DpPrik("_OTP",0);
	for(; !t.IsEOF(); t.MoveNext())
	{
		//уменьшаем кол-во календарных дней неявки в табеле и удаляем запись из таблицы связей 
		var snap = getSnap("select Ftag,Fnvk,Fbdat from ^lnkprktbl where Fid_prk="+t.getValue("Fwid"));
		if(snap)
		{
			ExecuteSQL("update ^tbl"+snap[0]+" set Fnorma_d=Fnorma_d-"+day_difference(t.getValue("Fbdat"),t.getValue("Fedat"))
					+" where Fwid_wp in (select Fwid from ^work_pers where Fwid_cl="+t.getValue("Ftabn_id")+") and Fkod_nvk="+snap[1]+" and Fbdat="+snap[2]);
			ExecuteSQL("delete from ^lnkprktbl where Fid_prk="+t.getValue("Fwid"));
		}
		oPrik.del(t.getValue("Fwid"));
	}
	t.close();
	
	//определим номер приказа
	var snap = getSnap("select Fdoc_num from ^cdr_prk where Fwid="+fwid_prk);
	if(snap)
		var prk_num = snap[0];
	else
		var prk_num = "";
		
	var t = OpenTable("select * from "+TableName+" where Fwid_prk="+fwid_prk+" order by Fcod");
	for(; !t.IsEOF(); t.MoveNext())
	{
		var ftabn_id = t.getValue("Fwid_cl");
		var calend = t.getValue("Fcalend");
		var oCal = new dpCalendar();
		oCal.setCod(calend);
		var bdat = t.getValue("Fbdat");
		var edat = t.getValue("Fedat");
		var dat_prik = firstDayMonth(t.getValue("Fdat_prik"));
		if(differ(dat_prik,d00)==0)
		{
			alert(ru("Для табельного номера "+t.getValue("Fcod")+" не указан месяц выплаты отпуска!\nПриказ не может быть сохранен в учете заработной платы.",
					"Для табельного номеру "+t.getValue("Fcod")+" не вказано місяць виплати відпустки!\nНаказ не можливо зберегти в обліку заробітньої платні."));
			continue;
		}
		var tPrk = OpenTable("select r.*, n.Fvid_n, n.Fvid_m, n.Fis_comp, n.Fsvyato "
							+" from "+SubRowsTableName+" as r inner join ^nast_otp as n on r.Fwid_type=n.Fwid "
							+" where r.Fid_doc="+t.getValue("Fwid")
							+" order by n.Fis_comp, r.Fwid");
		var d1 = new Date(bdat).getVarDate();
		
		for(; !tPrk.IsEOF(); tPrk.MoveNext())
		{
			var days = Number(tPrk.getValue("Fdays"));
			var fvid_n = Number(tPrk.getValue("Fvid_n"));//код текущего приказа
			var fvid_m = Number(tPrk.getValue("Fvid_m"));//код будущего приказа
			var isPrazn = toScrObj(tPrk.getValue("Fsvyato"));//учитывать праздничные
			var fvid;
			var oPrik;
			var d2 = goDay(d1,days+Number(tPrk.getValue("Fpdays"))-1);
			var is_comp = toScrObj(tPrk.getValue("Fis_comp"));
			if(is_comp)//для компенсации период заводим на первый день отпуска без переходящих приказов
			{
				d1 = firstDayMonth(bdat);
				d2 = firstDayMonth(bdat);
			}
			if(differ(firstDayMonth(d1),firstDayMonth(d2))==0)
			{
				if(differ(dat_prik,firstDayMonth(d1))<0)
					fvid = fvid_m;
				else
					fvid = fvid_n;
				if(!fvid)
					continue;
				oPrik = new DpPrik("_OTP",fvid);
			    oPrik.setVar("FBDAT",d1);
				oPrik.setVar("FEDAT",d2);
				oPrik.setVar("FDAT_OTP",bdat);
				oPrik.setVar("FSUM",days);
				oPrik.setVar("FTABN_ID",ftabn_id);
				var snap = getSnap("select MAX(Fwid),Fshpz from ^full_pers where Fwid_cl="+ftabn_id
						+" and Fbdat<="+sqlTo(d2)+" and Fedat>="+sqlTo(d1)+" group by Fshpz");
				if(!snap)
				{
					alert(ru("Не возможно определить идентификатор штатного расписания и ШПЗ!",
							"Не можливо визначити ідентифікатор штатного розкладу та ШВВ!"));
					continue;
				}
				oPrik.setVar("FWID_WP",snap[0]);
				oPrik.setVar("FVID_PRK",fvid);
				oPrik.setVar("FNOM_PRIK",prk_num);
				//анализируем ситуацию, когда отпуск заносят задним числом и делают перерасчет,
				//в таком случае для приказов относящихся к перерасчетным месяцам, месяц выплаты должен равнятся месяцу приказа, 
				//иначе в списке ЛС в месяце выплаты суммы задвоятся
				if(differ(firstDayMonth(dat_prik),firstDayMonth(d1))>0)
					oPrik.setVar("FDAT_PRIK",firstDayMonth(d1));
				else
					oPrik.setVar("FDAT_PRIK",dat_prik);
				oPrik.setVar("FSHPZ",snap[1]);
				oPrik.setVar("FCALNUM",calend);
				oPrik.setVar("FIN_TABLE",'PRK_O');
				var daysWork = oCal.getCalDays("Р",d1,d2);
				oPrik.setVar("FPROC",daysWork);
				//проставляем FWID родительского приказа
				oPrik.setVar("FWID_PRIK",fwid_prk);
				oPrik.save();
				//проставляем неявки
				if(!is_comp)
				{
					var oldnvk = kodnvk;
					var snap = getSnap("select Fz13 from ^cl_prik where Fvid="+fvid);
					if(snap && snap[0]>0)
						kodnvk = snap[0];
					if (kodnvk!=0)
				    	r_mnvk(oPrik.getVar("FTABN_ID"), oPrik.getVar("FWID_WP"), 0, 0, day_difference(oPrik.getVar("FBDAT"),oPrik.getVar("FEDAT")), 0, kodnvk, oPrik.getVar("FBDAT"), oPrik.getID());
				    kodnvk = oldnvk;
				}
				d1 = goDay(d2,1);
			}
			else//переходящий месяц
			{
				var i = 0;
				var k = 0;//счетчик для защиты от вечного цикла
				while(differ(firstDayMonth(d1),firstDayMonth(d2))<=0)
				{
					var isLastIter = false;
					//для последней итерации берём конечную дату общего периода, в остальных случаях последний день текущего месяца
					if(differ(lastDayMonth(d1),lastDayMonth(d2))==0)
					{
						var lastdat = d2;
						var isLastIter = true;
					}
					else
						var lastdat = lastDayMonth(d1);
					if(differ(dat_prik,firstDayMonth(d1))<0)
						fvid = fvid_m;
					else
						fvid = fvid_n;
					if(!fvid)
						continue;
					oPrik = new DpPrik("_OTP",fvid);
				    oPrik.setVar("FBDAT",d1);
					oPrik.setVar("FEDAT",lastdat);
					oPrik.setVar("FDAT_OTP",bdat);
					var nPrazdn = isPrazn?oCal.getCalDays("П", d1,lastdat):0;
					oPrik.setVar("FSUM",day_difference(d1,lastdat) - nPrazdn);
					oPrik.setVar("FTABN_ID",ftabn_id);
					var snap = getSnap("select MAX(Fwid),Fshpz from ^full_pers where Fwid_cl="+ftabn_id
							+" and Fbdat<="+sqlTo(lastdat)+" and Fedat>="+sqlTo(d1)+" group by Fshpz");
					if(!snap)
					{
						alert(ru("Не возможно определить идентификатор штатного расписания и ШПЗ!",
								"Не можливо визначити ідентифікатор штатного розкладу та ШВВ!"));
						continue;
					}
					oPrik.setVar("FWID_WP",snap[0]);
					oPrik.setVar("FVID_PRK",fvid);
					oPrik.setVar("FNOM_PRIK",prk_num);
					//анализируем ситуацию, когда отпуск заносят задним числом и делают перерасчет,
					//в таком случае для приказов относящихся к перерасчетным месяцам, месяц выплаты должен равнятся месяцу приказа, 
					//иначе в списке ЛС в месяце выплаты суммы задвоятся
					if(differ(firstDayMonth(dat_prik),firstDayMonth(d1))>0)
						oPrik.setVar("FDAT_PRIK",firstDayMonth(d1));
					else
						oPrik.setVar("FDAT_PRIK",dat_prik);
					oPrik.setVar("FSHPZ",snap[1]);
					oPrik.setVar("FCALNUM",calend);
					oPrik.setVar("FIN_TABLE",'PRK_O');
					var daysWork = oCal.getCalDays("Р",d1,lastdat);
					oPrik.setVar("FPROC",daysWork);
					//проставляем FWID родительского приказа
					oPrik.setVar("FWID_PRIK",fwid_prk);
					oPrik.save();
					//проставляем неявки
					var oldnvk = kodnvk;
					var snap = getSnap("select Fz13 from ^cl_prik where Fvid="+fvid);
					if(snap && snap[0]>0)
						kodnvk = snap[0];
					if (kodnvk!=0)
				    	r_mnvk(oPrik.getVar("FTABN_ID"), oPrik.getVar("FWID_WP"), 0, 0, day_difference(oPrik.getVar("FBDAT"),oPrik.getVar("FEDAT")), 0, kodnvk, oPrik.getVar("FBDAT"), oPrik.getID());
				    kodnvk = oldnvk;
					d1 = goDay(lastdat,1);
					if(isLastIter || k++>12)
						break;
				}
			}
		}
		tPrk.close();
	}
	t.close();
}

//кол-во дочерних приказов в зарплате
function getZrpPrkCount(fwid_prk)
{
	var snap = getSnap("select count(*) from ^prk_all where Fwid_prik="+fwid_prk, false);
	if(snap)
		return snap[0];
	else
		return 0;
}

//количество календарных дней отпускных либо компенсации отпуска в кадровых приказах
function getCdrOtpDays(fwid_prk,is_comp)
{
	var snap = getSnap("select SUM(t.Fdays) from ^otp_type as t inner join ^nast_otp as n on t.Fwid_type=n.Fwid where t.Fid_doc in (select Fwid from ^prk_otp where Fwid_prk="+fwid_prk+") and n.Fis_comp="+(is_comp===true?sqlTrue:sqlFalse));
	if(snap)
		return Number(snap[0]);
	else
		return 0;
}

//проверка существования родительского приказа: fwid_prk - идентификатор, tblName - таблица родительского приказа (по умолчанию CDR_PRK)
function isExistsParentPrk(fwid_prk, tblName)
{
	if(!tblName)
		tblName = "CDR_PRK";
	var snap = getSnap("select Fwid from ^"+tblName+" where Fwid="+fwid_prk, false);
	return snap!=null;
}

//переход статьи увольнения с текстовки на справочник
function convertDisStatToCl()
{
	//создаем справочник, если такового нет, если в нем есть записи, то ничего не делаем
	var codCl = getPar("CDRSTATUV");
	var ok = true;
	var snap = getSnap("select Fwid from ^clcl where Fcod="+codCl);
	if(codCl>0 && snap)
	{
		var snap = getSnap("select count(*) from ^clrelclcl where Fcl="+codCl);
		if(snap && snap[0]>0)
			return false;
	}
	else
	{
		include("Objects/DpClNo.js");
		var oN = new DpClNo("ADD", null, "clcl", "Fcod", null, null, null, true);
		codCl = oN.findFree();
		var m = new Object();
		m.FWID	= GetUID();
		m.FCOD = codCl;
		m.FTXT = "Статті звільнення|Статьи увольнения";
		m.FVID = "1";
		m.FSYSTEMS = "ZRP_CDR";
		m.FREL = 0;
		ok = UpdateTable("^clcl", m, true);
		if(ok)
			setPar("CDRSTATUV", codCl);
	}
	if(!ok)
		return false;
	//переносим текстовки статей увольнения в справочник и проставляем коды записей
	var m = new Object();
	m.FWID = "COUNTER";
	m.FTXT = "LONGTEXT";
	CreateTable("tmp_dis_stat", m);
	CreateTable("tmp_dis_stat2", m);
	ExecuteSQL("insert into tmp_dis_stat2 (Ftxt) select distinct Fdis_stat from ^persfile where Fdis_stat is not null and Fdis_stat<>"+SqlEmpStr);
	ExecuteSQL("insert into tmp_dis_stat2 (Ftxt) select distinct Freason_st from ^prk_out where Freason_st is not null and Freason_st<>"+SqlEmpStr);
	ExecuteSQL("insert into tmp_dis_stat (Ftxt) select distinct Ftxt from tmp_dis_stat2");
	var tbl = OpenTable("select * from tmp_dis_stat order by Ftxt");
	include("Objects/DpClEx.js");
	for(; !tbl.IsEOF(); tbl.MoveNext())
	{
		var oCl = new DpClEx("CL1",codCl);
		oCl.setVar("HCOD", tbl.bookmark);
		oCl.setVar("HTXT", tbl.getValue("Ftxt"));
		oCl.save();
	}
	tbl.close();
	ok = ExecuteSQL("update ^persfile set Fdis_statcod=(select MIN(r.Fcod) from ^cl as cl inner join ^clrelclcl as r on cl.Fwid=r.Fwid_cl where r.Fcl="+codCl+" and cl.Ftxt=^persfile.Fdis_stat) "
				+" where exists(select cl.Fwid from ^cl as cl inner join ^clrelclcl as r on cl.Fwid=r.Fwid_cl where r.Fcl="+codCl+" and cl.Ftxt=^persfile.Fdis_stat)");
	if(ok)
		ok = ExecuteSQL("update ^prk_out set Freason_stcod=(select MIN(r.Fcod) from ^cl as cl inner join ^clrelclcl as r on cl.Fwid=r.Fwid_cl where r.Fcl="+codCl+" and cl.Ftxt=^prk_out.Freason_st) "
					+" where exists(select cl.Fwid from ^cl as cl inner join ^clrelclcl as r on cl.Fwid=r.Fwid_cl where r.Fcl="+codCl+" and cl.Ftxt=^prk_out.Freason_st)");
	return ok;			
}

function createDisStatCl()
{
	//создаем справочник, если такового нет, если в нем есть записи, то ничего не делаем
	var codCl = getPar("CDRSTATUV");
	var ok = true;
	var snap = getSnap("select Fwid from ^clcl where Fcod="+codCl);
	if(codCl>0 && snap)
	{
		var snap = getSnap("select count(*) from ^clrelclcl where Fcl="+codCl);
		if(snap && snap[0]>0)
			return false;
	}
	else
	{
		include("Objects/DpClNo.js");
		var oN = new DpClNo("ADD", null, "clcl", "Fcod", null, null, null, true);
		codCl = oN.findFree();
		var m = new Object();
		m.FWID	= GetUID();
		m.FCOD = codCl;
		m.FTXT = "Статті звільнення|Статьи увольнения";
		m.FVID = "1";
		m.FSYSTEMS = "ZRP_CDR";
		m.FREL = 0;
		ok = UpdateTable("^clcl", m, true);
		if(ok)
			setPar("CDRSTATUV", codCl);
	}
	if(!ok)
		return false;
	var fileName = rootDirectoryEx()+"Source/dbftemplate/REASONS_UV.DBF";
	if(!isFile(fileName))
		return false;
	var tbl = OpenTable("f", fileName, "cp1251");
	include("Objects/DpClEx.js");
	for(; !tbl.IsEOF(); tbl.MoveNext())
	{
		var oCl = new DpClEx("CL1",codCl);
		oCl.setVar("HCOD", tbl.bookmark);
		oCl.setVar("HTXT", tbl.getValue("REASONS").indexOf("ст")==0?allt(tbl.getValue("REASONS"))+": "+allt(tbl.getValue("NAME")):allt(tbl.getValue("NAME")));
		oCl.save();
	}
	tbl.close();
	return true;
}

//переход в личных делах города с текстовки на справочник
function convertCityToCl()
{
	//создаем справочник, если такового нет
	var codCl = getPar("CODLOCATE");
	var ok = true;
	if(codCl>0)
	{
		var snap = getSnap("select Fwid from ^clcl where Fcod="+codCl);
		if(!snap)
			return false;
	}
	else
	{
		include("Objects/DpClNo.js");
		var oN = new DpClNo("ADD", null, "clcl", "Fcod", null, null, null, true);
		codCl = oN.findFree();
		var m = new Object();
		m.FWID	= GetUID();
		m.FCOD = codCl;
		m.FTXT = "Населені пункти|Населенные пункты";
		m.FVID = "1";
		m.FREL = getPar("CODAREA");
		ok = UpdateTable("^clcl", m, true);
		if(ok)
			setPar("CODLOCATE", codCl);
	}
	if(!ok)
		return false;
	//переносим данные в справочник
	var m = new Object();
	m.FWID = "COUNTER";
	m.FTXT = "LONGTEXT";
	CreateTable("tmp_city", m);
	ExecuteSQL("insert into tmp_city (Ftxt) select distinct Fcity from ^cl_homo where Fcity is not null and Fcity<>"+SqlEmpStr+" and not exists(select cl.Fwid from ^cl as cl inner join ^clrelclcl as r on cl.Fwid=r.Fwid_cl where r.Fcl="+codCl+" and cl.Ftxt=^cl_homo.Fcity)");
	var tbl = OpenTable("select * from tmp_city order by Ftxt");
	include("Objects/DpClEx.js");
	var snap = getSnap("select MAX(Fcod) from ^clrelclcl where Fcl="+codCl);
	var k = 0;
	if(snap && snap[0]>0)
		k = snap[0];
	for(; !tbl.IsEOF(); tbl.MoveNext())
	{
		var oCl = new DpClEx("CL1",codCl);
		oCl.setVar("HCOD", ++k);
		oCl.setVar("HTXT", tbl.getValue("Ftxt"));
		oCl.save();
	}
	tbl.close();
	ok = ExecuteSQL("update ^persfile set Ftown=(select MIN(r.Fcod) from ^cl as cl inner join ^clrelclcl as r on cl.Fwid=r.Fwid_cl inner join ^cl_homo as h on h.Fcity=cl.Ftxt where r.Fcl="+codCl+" and h.Fwid_cl=^persfile.Fwid_cl) "
				+" where exists(select cl.Fwid from ^cl as cl inner join ^clrelclcl as r on cl.Fwid=r.Fwid_cl inner join ^cl_homo as h on h.Fcity=cl.Ftxt where r.Fcl="+codCl+" and h.Fwid_cl=^persfile.Fwid_cl)");
	return ok;
}

//поиск начала периода, за который берется отпуск
function getBeginPeroidOtp(ftabn_id, dat)
{
	var d = d00;
	//сперва ищем в справочнике даты начала периода для отпусков 
	if(getPar("CDRPERSDAT"))
	{
		var snap = getSnap("select Fdat from ^LISTCLPERSDAT where Fcl="+getPar("CDRPERSDAT")+" and Ftabn_id="+ftabn_id+" and Fdat<="+sqlTo(dat));
		if(snap)
			d = snap[0];
	}
	//если нет в справочнике дат, то определяем по дате приема сотрудника
	if(differ(d,d00)==0)
	{
		snap = getSnap("select Fwrkdat from ^cl_homo where Fwid_cl="+ftabn_id);
		if(snap)
			d = snap[0];
	}
	if(differ(d,d00)==0)
		return d;
	else
		return new Date(new Date(dat).getFullYear(),d.getMonth(),d.getDate()); 
}

function convertPersDocsToCl()
{
	var codCl = getPar("CDRDOCTYPE");
	var ok = true;
	if(codCl>0)
		return false;
	else
	{
		include("Objects/DpClNo.js");
		var oN = new DpClNo("ADD", null, "clcl", "Fcod", null, null, null, true);
		codCl = oN.findFree();
		var m = new Object();
		m.FWID	= GetUID();
		m.FCOD = codCl;
		m.FTXT = "Типи документів співробітників|Типы документов сотрудников";
		m.FVID = "1";
		m.FREL = 0;
		ok = UpdateTable("^clcl", m, true);
		if(ok)
			setPar("CDRDOCTYPE", codCl);
	}
	if(!ok)
		return false;
	//если хоть в одной записи код типа документа уже проставлен, то выходим
	var snap = getSnap("select count(*) from ^CERTIFICATION where Fdoc>0");
	if(snap && snap[0]>0)
		return false;
	var m = new Object();
	m.FWID = "COUNTER";
	m.FTXT = "LONGTEXT";
	CreateTable("tmp_docs", m);
	ExecuteSQL("insert into tmp_docs (Ftxt) select DISTINCT Fname from ^CERTIFICATION where Fname is not null and Fname <> "+SqlEmpStr);
	var tbl = OpenTable("select * from tmp_docs order by Ftxt");
	include("Objects/DpClEx.js");
	for(; !tbl.IsEOF(); tbl.MoveNext())
	{
		var oCl = new DpClEx("CL1",codCl);
		oCl.setVar("HCOD", tbl.bookmark);
		oCl.setVar("HTXT", tbl.getValue("Ftxt"));
		oCl.save();
	}
	tbl.close();
	ok = ExecuteSQL("update ^CERTIFICATION set Fdoc=(select MIN(r.Fcod) from ^cl as cl inner join ^clrelclcl as r on cl.Fwid=r.Fwid_cl where r.Fcl="+codCl+" and cl.Ftxt=^CERTIFICATION.Fname) "
				+" where exists(select r.Fcod from ^cl as cl inner join ^clrelclcl as r on cl.Fwid=r.Fwid_cl where r.Fcl="+codCl+" and cl.Ftxt=^CERTIFICATION.Fname)");
	return ok;
}