include("servis/format.js");

var sTxt = UR("Архівація даних|Архивация данных");
var sBatFile = dumpDir() + "export.bat";		//батник можно создать для MySQL и ORACLE
var sDumpDir = dumpDir();						//путь для сохранения архивов
var sDumpName = "";								//имя архива базы данных
var sDumpFile = "";								//полное имя дампа
var importLog = dumpDir() +"/import.log";
var exportLog = dumpDir() +"/export.log";
var sDumpTbl = "DUMP_REG";
	
//------------ архивация базы данных -----------
function runDBExport(sLogin, sPassword, sBase, sTables, sPath, sDumpName, sBatFile)
{		
	try
	{
		var sServer = lpProxy.getOrgManager().getServer();	
		var toZip = false;
		if(SUBD==MYSQL || SUBD==ORACLE)
			toZip = true;
			
		if(!sLogin)
			sLogin = getDBUserName();
		if(!sPassword || sPassword=="null")
			sPassword = "";
		if(sBase==null || sBase=="null")
			sBase = getPath("ALL_MDB");			
		if(!sPath || sPath=="null")
			sPath = dumpDir();
		if(!sDumpName || sDumpName=="null")
		{
			sDumpName = dumpName(sBase);
			if(SUBD==DERBY)
				sDumpName = dumpName(DpFile(sServer).getName());		
		}
				
		sDumpDir = currentDir(sPath);
		if(!isDir(sDumpDir))
			createDirectory(sDumpDir);	
		sDumpFile = sDumpDir + sDumpName;	
		
		WAIT(sTxt +": "+ sBase);
		trace("\n>>> DUMP: "+ StrDat(new Date(), "DMY") +"  "+ new Date().getHours() +":"+ new Date().getMinutes() +" > "+ sBase +" > "+ sDumpFile +"\n");
			
		exportRegistration(sLogin, sPassword, sBase, sTables, sPath, sDumpName, "");
			
		if(SUBD==MSSQL)
		{
			ExecuteSQL("BACKUP log "+ sBase +" with no_log ");
			ExecuteSQL("DBCC SHRINK DATABASE ("+ sBase +")", false);
			var bRet = ExecuteSQL("BACKUP DATABASE "+ sBase +" TO DISK='"+ sDumpFile +"'");
			if(toZip && bRet)
				runInThread(archToZip);
			return bRet;
		}
		if(SUBD==H2)
		{
			var bRet = ExecuteSQL("BACKUP TO '"+ sDumpFile +"'");			
			return bRet;
		}
		
		if(SUBD==DERBY)
		{
			//var sServer = lpProxy.getOrgManager().getServer();
			//var zipName = DpFile(sServer).getName() +"_"+ format("dd-mm-yyyy_HH-MM", new Date()) +".zip";
			zip(sServer, sDumpFile);
			return true;
		}	
			
		if(SUBD==MYSQL)
		{	
			ExecuteSQL("UNLOCK TABLES");
		}
		
		var ret = null;
		if(sBatFile)
		{		
			var sDump = sPath +"/"+ dumpName(sBase, true);
			createExportBatFile(sBatFile, sLogin, sPassword, sBase, sTables, sDump);
			ret = runFile(sBatFile);
		}
		else
		{
			var sCommand = dumpCmd(sLogin, sPassword, sBase, sTables, sDumpFile);
			ret = runCmd(sCommand);
		}
		
		if(toZip && ret)
		{
			runInThread(archToZip, ret);
		}
		
		return ret;
	}
	catch(e)
	{
		trace("ERROR - runDBExport: "+ e); 
	}
}

function archToZip(oExec)
{
	try
	{
		if(oExec && (SUBD==POSTGRE || SUBD==MYSQL || SUBD==ORACLE))
		{
			//ждём пока MSQL окончательно завершит процесс архивации
			//если архивация не закончилась, DpZip может свалиться
			if(SUBD==POSTGRE)
				oExec.waitFor();
			getExecError(oExec);			
			var t = new Date().getTime();
			while((new Date().getTime()-t)/1000<5)
			{
				//ждём ещё немножко
			}
			//теперь можно крутить в zip
		}
		
		var zipFile = sDumpFile.substring(0, sDumpFile.length-4) + ".zip";
		if(isFile(sDumpFile))
			writeToZip(sDumpFile, zipFile, true);
		if(isFile(zipFile))
		{
			//елси есть zip удаляем dump
			if(deleteFile(sDumpFile))
			{
				sDumpFile = zipFile;
				return zipFile;
			}
		}
	}
	catch(e)
	{
		trace("archToZip: "+ e)
	}
	return null;
}

function getDumpFile()
{
	if(sDumpFile!="")
		return sDumpFile;
	return dumpDir() + dumpName;
}

function createExportBatFile(sBatFile, sLogin, sPassword, sBase, sTables, sDumpFile)
{			
	var sCommand = "title DebetPlusV12: DUMP\r\n";
	sBatFile = String(sBatFile);
	var sLogFile = sBatFile.substring(0, sBatFile.length-4) +".log";
	sCommand += dumpCmd(sLogin, sPassword, sBase, sTables, sDumpFile, sLogFile);
	sCommand += "\r\npause";
	sCommand += "\r\nexit";	
	lpProxy.writeToFile(sCommand, sBatFile, "cp1251");
}

function dumpName(base, isBat)
{	
	//if(!base)
	//	base = getPath("ALL_MDB");
	var sDump = (base? base +"_" : "FULL_");
	if(isBat)
		sDump += "%DATE:~6,4%-%DATE:~3,2%-%DATE:~0,2%_%TIME:~0,2%-%TIME:~3,2%";
	else
		sDump += format("yyyy-mm-dd_HH-MM", new Date());
	
	return sDump +"."+ archExt();
}

function archExt()
{
	if(SUBD==MYSQL)
		return "arh";
	else if(SUBD==POSTGRE)
		return "sql";
	else if(SUBD==MSSQL)
		return "bak";
	else if(SUBD==ORACLE)
		return "dmp";
	else if(SUBD==DERBY || SUBD==H2)
		return "zip";
}

function dumpDir()
{
	return exeDir() +"dump/";
}

function exeDir()
{
	var sDir = Packages.org.eclipse.core.runtime.Platform.getInstallLocation().getURL().getFile();
	sDir = DpFile(sDir).getAbsolutePath() +"/";
	return sDir;
}

function currentDir(sPath)
{
	if(!sPath)
		sPath = dumpDir();
	return sPath +"/"+ format("yyyy-mm-dd", new Date()) +"/";
}

function mySQLPath()
{
	return String(getPar("MYSQL_SERVER_PATH")).trim();
}

function postgreSQLPath()
{
	return String(getPar("POSTGRESQL_PATH")).trim();
}

function mySQLBinPath()
{
	var mySqlPath = mySQLPath();
	if(mySqlPath && !isFile(mySqlPath +"/bin/mysql.exe"))
		mySqlPath = null;
	if(mySqlPath)
	{
		var sDisk = "";
		if(mySqlPath.indexOf(":")!=-1)
		{
			sDisk = mySqlPath.substring(0, mySqlPath.indexOf(":")+2);
			mySqlPath = mySqlPath.substring(mySqlPath.indexOf(":")+2);
		}
		mySqlPath = sDisk +"\\\""+ mySqlPath +"\\bin\\\"";
	}
	return mySqlPath;
}

function dumpCmd(sLogin, sPassword, sBase, sTables, sDumpFile, sLogFile, sServer)
{
	//if(!sBase)
	//	sBase = getPath("ALL_MDB");
	if(!sServer)
		sServer = lpProxy.getOrgManager().getServer();
	var sCommand = "";	
	if(SUBD==MYSQL)
	{
		if(sTables)
			sTables = java.lang.String(sTables).trim().replaceAll(",", " ");
		if(sBase)
			sBase = java.lang.String(sBase).trim().replaceAll(",", " ");
		if(!sServer || sServer=="")
			sServer = "localhost";		
		var mySQLcmd = "mysqldump";
		if(isWin())
		{
			var binPath = mySQLBinPath();
			if(binPath)
				mySQLcmd = binPath + "mysqldump.exe";
		}
			
		sCommand += mySQLcmd
					+(sServer? " --host="+ sServer : "")
					+" --user="+ sLogin 
					+" --password=\""+ sPassword +"\" "
					+" --force "
					+(sBase? " --databases "+ sBase : " --all-databases ") 
					+(sTables? " --tables "+ sTables : "")
					+" > \""+ sDumpFile +"\""					
	}
	else if(SUBD==POSTGRE)
	{		
		var db = lpProxy.getOrgManager().getServer();
		sServer = lpProxy.getOrgManager().getComp();
		if(!sServer || sServer=="")
			sServer = "localhost";
		var pgcmd = "pg_dump";
		if(isWin())
		{
			var pgPath = postgreSQLPath();
			if(pgPath && isDir(pgPath))
			{
				var sDisk = "";
				if(pgPath.indexOf(":")!=-1)
				{
					sDisk = pgPath.substring(0, pgPath.indexOf(":")+2);
					pgPath = pgPath.substring(pgPath.indexOf(":")+2);
				}
				pgPath = sDisk +"\\\""+ pgPath +"\\bin\\\"";
				pgcmd = pgPath + pgcmd;
			}			
		}
		sCommand += pgcmd
					+(sServer? " --host="+ sServer : "")
					+" -Fc "
					+" --create "
					+" --no-owner "
					+" --username="+ sLogin 
					+(sBase? " --schema="+ sBase : "")
					+(sTables? " --table="+ sTables : "")
					+" "+ db +" > \""+ sDumpFile +"\"";
	}
	else if(SUBD==ORACLE)
	{			
		if(!sLogFile)
			sLogFile = sDumpFile.substring(0, sDumpFile.length-4) +".log";
		sCommand += "exp "
				+" USERID="+ sLogin +"/"+ sPassword +"@"+ sServer
				+" FILE="+ sDumpFile
				+" LOG="+ sLogFile
				+(sTables? " TABLES="+ sTables 
					: sBase? " OWNER="+ sBase
						: " FULL=Y"
					)
	}
	return sCommand;
}

function runFile(sFileName)
{
	var bRet = false;
	if(!isFile(sFileName))
	{
		alert(UR("Не знайдено файл |Не найден файл ") + sFileName);
		return false;
	}
	if(isWin())	
		bRet = Packages.java.lang.Runtime.getRuntime().exec("cmd /c start "+ sFileName);
	else
		bRet = runCmd(sFileName);
	return bRet;
}

function runCmd(sCommand)
{
	trace("exec: "+ sCommand);
	var ret = false;
	if(isLinux())
		ret = Packages.java.lang.Runtime.getRuntime().exec(new Array("sh", "-c", sCommand));
	else if(isWin())
		ret = Packages.java.lang.Runtime.getRuntime().exec("cmd /c "+ sCommand);
	return ret;
}

function isLinux()
{
	return getOS()=="linux";
}

function isWin()
{
	return getOS()=="win32";
}

//архивация скриптов
function packJdebet(savePath, zipName, sDir)
{
	if(!sDir)	
		sDir = rootDirectoryEx();
	if(!zipName)
		zipName = DpFile(sDir).getName() +"_"+ format("dd-mm-yyyy_HH-MM", new Date()) +".zip";
	if(!savePath)
		savePath = dumpDir();
	savePath = currentDir(savePath);
	if(!isDir(savePath))
		createDirectory(savePath);
	zipName = savePath +"/"+ zipName;	
	WAIT(sTxt +": "+ DpFile(sDir).getName());
	var bRet = zip(sDir, zipName);
	CLEARWAIT();
	return zipName;
}

//архивация настроек организации
function packOrg(savePath, zipName, sDir)
{
	if(!sDir)
		sDir = getOrgPath();
	if(!zipName)
		zipName = DpFile(sDir).getName() +"_"+ format("dd-mm-yyyy_HH-MM", new Date()) +".zip";
	if(!savePath)
		savePath = dumpDir();
	savePath = currentDir(savePath);
	if(!isDir(savePath))
		createDirectory(savePath);
	zipName = savePath +"/"+ zipName;
	WAIT(sTxt +": "+ DpFile(sDir).getName());
	var bRet = zip(sDir, zipName);
	CLEARWAIT();
	return zipName;
}



//-------- Импорт данных из архива -------
function runDBImport(sLogin, sPassword, sFromBase, sToBase, sTables, sFile, connection)
{
	if(SUBD==DERBY)
		return false;
	
	if(!sFile)
		sFile = askSourceFile();
	if(!sFile)
		return false;
	
	//importRegistration(sLogin, sToBase, sTables, sFile, "");
	var sRegTbl = dumpTblName(sToBase);
	ExecuteSQL("drop table "+ sRegTbl, false);
	
	if(SUBD==MSSQL)
	{
		var sSQL = "RESTORE DATABASE "+ sToBase 
					+" FROM DISK='"+ sFile +"'"					
		if(connection)
			return ExecSQL(connection, sSQL);
		return ExecuteSQL(sSQL);
	}
	
	if(SUBD==MYSQL)
	{
		if(connection)
			ExecSQL(connection, "UNLOCK TABLES");
		else
			ExecuteSQL("UNLOCK TABLES");
	}
	
	var sCommand = impCmd(sLogin, sPassword, sFile, sFromBase, sToBase, sTables);
	return runCmd(sCommand);
}

function askSourceFile()
{
	return askFile("OPEN", "", new Array("*."+ archExt(), "*.*"), "");	
}

function impCmd(sLogin, sPassword, sFile, sFromBase, sToBase, sTables, sServer)
{
	if(!sServer)
		sServer = lpProxy.getOrgManager().getServer();
	if(!sPassword)
		sPassword = "";
	var sCommand = "";
	
	if(SUBD==POSTGRE)
	{		
		var db = lpProxy.getOrgManager().getServer();
		sServer = lpProxy.getOrgManager().getComp();
		if(!sServer || sServer=="")
			sServer = "localhost";
		var pgcmd = "pg_restore";
		if(isWin())
		{
			var pgPath = postgreSQLPath();
			if(pgPath && isDir(pgPath))
			{
				var sDisk = "";
				if(pgPath.indexOf(":")!=-1)
				{
					sDisk = pgPath.substring(0, pgPath.indexOf(":")+2);
					pgPath = pgPath.substring(pgPath.indexOf(":")+2);
				}
				pgPath = sDisk +"\\\""+ pgPath +"\\bin\\\"";
				pgcmd = pgPath + pgcmd;
			}
		}
		sCommand += pgcmd
					+(sServer? " --host="+ sServer : "")
					+" --username="+ sLogin 
					+" --create"
					+" --dbname="+ db
					+(sToBase? " --schema="+ sToBase : "")
					+(sTables? " --table="+ sTables : "")
					+" \""+ sFile +"\"";
	}
	else if(SUBD==MYSQL)
	{
		if(sTables)
			sTables = java.lang.String(sTables).trim().replaceAll(",", " ");			
		if(!sServer || sServer=="")
			sServer = "localhost";
		var mySQLcmd = "mysql";
		if(isWin())
		{
			var binPath = mySQLBinPath();
			if(binPath)
				mySQLcmd = binPath + "mysql.exe";
		}	
		sCommand += mySQLcmd
					+(sServer? " --host="+ sServer : "")
					+" --user="+ sLogin 
					+" --password=\""+ sPassword +"\" "
					+" --default-character-set=utf8 "
					+" --force "
					+(sToBase? " --one-database --database="+ sToBase : "")
					//+(sToBase? sToBase : "")
					+" < \""+ sFile +"\""
	}
	else if(SUBD==ORACLE)
	{
		var sLogFile = sFile.substring(0, sFile.length-4) +".log";
		sCommand += "imp "
				+" USERID="+ sLogin +"/"+ sPassword +"@"+ sServer
				+" FILE="+ sFile
				+" LOG="+ sLogFile
				+(sTables? " TABLES=("+ sTables +")" : "") 
				+(sFromBase? " FROMUSER="+ sFromBase 
					+(sToBase? " TOUSER="+ sToBase : "")
					: " FULL=Y")
	}
	return sCommand;
}



function getExecError(oExec, charset)
{
	var sError = "";
	if(!charset)
		charset = "cp1251";
	try
	{
		var es = oExec.getErrorStream();
		var isr = java.io.InputStreamReader(es, charset);
		var br = java.io.BufferedReader(isr);
		while((str=br.readLine())!=null)
			sError += str +"\r\n";
	}
	catch(e)
	{
		trace("getExecError: "+ e);
	}
	return sError;
}

function saveImportLog(sTxt, sPath, sLogName)
{
	try
	{
		if(!sLogName)
			sLogName = "import.log";
		
		sTxt = "HOST: \t"+ getHostName() 
			+"\r\nUSER: \t"+ getDBUserName() 
			+"\r\n"+ sTxt;
		
		var importLog = dumpDir() + sLogName;
		lpProxy.writeToFile(sTxt, importLog, "cp1251");		
		
		if(!isDir(getOrgPath() +"log"))
			createDirectory(getOrgPath() +"log");
		importLog = getOrgPath() +"log/"+ sLogName;		
		lpProxy.writeToFile(sTxt, importLog, "cp1251");
		
		if(sPath)
		{
			if(!isDir(sPath))
				createDirectory(sPath);
			importLog = sPath +"/"+ sLogName;
			lpProxy.writeToFile(sTxt, importLog, "cp1251");
		}
	}
	catch(e)
	{
		
	}
}

function saveExportLog(sTxt, sPath, sLogName)
{
	try
	{
		if(!sLogName)
			sLogName = "export.log";
		
		sTxt = "HOST: \t"+ getHostName() 
			+"\r\nUSER: \t"+ getDBUserName() 
			+"\r\n"+ sTxt;
			
		var exportLog = dumpDir() + sLogName;
		lpProxy.writeToFile(sTxt, exportLog, "cp1251");
		
		if(!isDir(getOrgPath() +"log"))
			createDirectory(getOrgPath() +"log");
		exportLog = getOrgPath() +"log/"+ sLogName;		
		lpProxy.writeToFile(sTxt, exportLog, "cp1251");
		
		if(sPath)
		{
			if(!isDir(sPath))
				createDirectory(sPath);
			exportLog = sPath +"/"+ sLogName;
			lpProxy.writeToFile(sTxt, exportLog, "cp1251");
		}
	}
	catch(e)
	{
		
	}
}

function openImportLog()
{
	runFile(importLog);
}

function openExportLog()
{
	runFile(exportLog);
}


function saveRegistration(sBase)
{
	var sRegTbl = dumpTblName(sBase);
	ExecuteSQL("drop table "+ sDumpTbl, false);
	ExecuteSQL("select * into "+ sDumpTbl +" from "+ sRegTbl, false);
}

function loadRegistration(sBase)
{
	try
	{
		var sRegTbl = dumpTblName(sBase);
		if(!lpProxy.getDBManager().testSQL("select FDATE from "+ sRegTbl +" where 1<>1"))
			return;
		var sFld = getColumn(sRegTbl);
		var sSQL = "insert into "+ sRegTbl +" ("+ sFld +") "
					+" select "+ sFld +" from "+ sDumpTbl			
		ExecuteSQL(sSQL, false);
	}
	catch(e)
	{
		
	}
}


function exportRegistration(sLogin, sPassword, sBase, sTable, sPath, sArch, sInfo)
{	
	try
	{
		var sTime = format("HH:MM", new Date());
		var sRegTbl = dumpTblName(sBase);
		var sSQL = "insert into "+ sRegTbl
				+"(FDATE,FTIME,FLOGIN,FPASSWORD,FBASE,FTABLE,FPATH,FARCH"
					+",FEXPORT,FMODE,FHOST,FUSER,FINFO)"
				+" values ("+ sqlTo(new Date(), null, true) +","+ sqlTo(sTime)					
					+","+ sqlTo(sLogin) +","+ sqlTo(sPassword)
					+","+ sqlTo(sBase) +","+ sqlTo(sTable) 
					+","+ sqlTo(sPath) +","+ sqlTo(sArch) 
					+","+ sqlTrue +","+ sqlTo("export")
					+","+ sqlTo(getHostName()) +","+ sqlTo(getDBUserName())
					+","+ sqlTo(sInfo)
					+")";
		return ExecuteSQL(sSQL, false);
	}
	catch(e)
	{
		return false;
	}
}

function importRegistration(sLogin, sBase, sTable, sFile, sInfo)
{
	try
	{
		var sPath = DpFile(sFile).getParent();
		var sArch = DpFile(sFile).getName();
		var sTime = format("HH:MM", new Date());
		var sRegTbl = dumpTblName(sBase);
		var sSQL = "insert into "+ sRegTbl
				+"(FDATE,FTIME,FLOGIN,FBASE,FTABLE,FPATH,FARCH"
					+",FEXPORT,FMODE,FHOST,FUSER,FINFO)"
				+" values ("+ sqlTo(new Date(), null, true) 
					+","+ sqlTo(sTime)+","+ sqlTo(sLogin) 
					+","+ sqlTo(sBase) +","+ sqlTo(sTable) 
					+","+ sqlTo(sPath) +","+ sqlTo(sArch) 
					+","+ sqlFalse +","+ sqlTo("import")
					+","+ sqlTo(getHostName()) +","+ sqlTo(getDBUserName())
					+","+ sqlTo(sInfo)
					+")";
		return ExecuteSQL(sSQL, false);
	}
	catch(e)
	{
		return false;
	}
}

function dumpTblName(sBase)
{
	try
	{
		var sAllBaseTxt = UR("усі|все");
		if(sBase)
			sBase = String(sBase).replace(sAllBaseTxt, "").trim();
		if(!sBase || sBase.indexOf(",")!=-1 || sBase.indexOf(" ")!=-1)
			sBase = getPath("ALL_MDB");
		var sTbl = sBase +"."+ sDumpTbl;
		if(SUBD==MSSQL)
			sTbl = sBase +".."+ sDumpTbl;
		if(!lpProxy.getDBManager().testSQL("select FDATE from "+ sTbl +" where 1<>1"))
			createDumpTbl(sTbl);
		return sTbl;
	}
	catch(e)
	{
		
	}
	return sDumpTbl;
}

function createDumpTbl(sTbl)
{
	if(!sTbl)
		sTbl = sDumpTbl;
	if(lpProxy.getDBManager().testSQL("select FDATE from "+ sTbl +" where 1<>1"))
	{
		if(!ExecuteSQL("drop table "+ sTbl, false))
			ExecuteSQL("delete from "+ sTbl, false);
	}
	var sSQL = "create table "+ sTbl
				+"( FDATE "+ SqlType("DATETIME")
				+", FTIME "+ SqlType("TEXT", 15)				
				+", FLOGIN "+ SqlType("TEXT") 
				+", FPASSWORD "+ SqlType("TEXT") 
				+", FBASE "+ SqlType("TEXT")
				+", FTABLE "+ SqlType("TEXT") 
				+", FPATH "+ SqlType("TEXT")
				+", FARCH "+ SqlType("TEXT")			
				+", FEXPORT "+ SqlType("BIT")
				+", FMODE "+ SqlType("TEXT", 15)
				+", FHOST "+ SqlType("TEXT")
				+", FUSER "+ SqlType("TEXT")
				+", FINFO "+ SqlType("TEXT")
				+", FWID "+ SqlType("COUNTER")
				+")";	
	return ExecuteSQL(sSQL, false);
}