include("sys/mask.js");
include("sys/ListApi.js");

var startupTasks = new Array();

include("Objects/DPXMLDomDocument.js");
var oXmlDom = new DpXMLDOMDocument();
var oXMLDoc = null;
var sStartupFile = "";
var ID = 0;

function Load()
{
	var sUserDir = lpProxy.getUserDirectory();
	createDirectory(sUserDir);
	sStartupFile = sUserDir + "startup.xml"; 
	Caption( ru("Автозагрузка", "Автозапуск"));
	grid.setXMLFile("startup.xml");
	this.tbl = getStartupTable();
	grid.setTable(this.tbl);
	grid.build();
	
	this.mnuInit = listMenuInit;
	grid.loadMenuHandler(this, "mnuInit");
	this.mnuHandler = listMenuHandler;
	grid.selectMenuHandler(this, "mnuHandler");

}

function getStartupTable()
{
	
	ID = -1;
	var tbl = createObjectTable();
	var ret = oXmlDom.load(sStartupFile, false);
	if (ret)
	{
		startupTask = new Array();
		oXMLDoc = oXmlDom.getDocumentElement();
		var nodes = oXMLDoc.getElementsByTagName("task");
		for (var i = 0; i < nodes.length; i++)
		{
			ID++;
			startupTask[ID] = nodes[i]; 
			var sTask = nodes[i].getAttribute("command");
			var sType = nodes[i].getAttribute("type");
			var sPar = nodes[i].getAttribute("par");
			tbl.AddNew();
			tbl.setValue("ID", ID);
			tbl.setValue("TYPE", getTypeTxt(sType));
			tbl.setValue("COMMAND", sTask);
			tbl.setValue("PAR", sPar);
			tbl.setValue("XML", nodes[i]);
			tbl.Update();
		}
		
	} 
	else
	{
		oXMLDoc = oXmlDom.createElement("startup");
		oXmlDom.appendChild(oXMLDoc);
	}
	return tbl;
	
}

function getTypeTxt(sType)
{
	var sTxt = sType;
	switch(sType)
	{
		case "l":
			sTxt = UR("документ у вікні програмного комплексу|документ в окне программного комплекса");
			break;
		case "d":
			sTxt = UR("документ в окремому вікні|документ в отдельном окне");
			break;
		case "w":
			sTxt = UR("додумент з забороною багатократного виклику|додумент с запретом многократного вызова");
			break;
		case "e":
			sTxt = UR("виконуємий файл|исполняемый файл");
			break;
		case "s":
			sTxt = UR("системна команда|системная команда");
			break;
		case "f":
			sTxt = UR("папка документів|папка документов");
			break;
		case "r":
			sTxt = UR("скрипт");
			break;			
	}
	return sTxt;
}

function listMenuHandler(mnuID)
{
	var par = new Object();
	par.mode = mnuID;
	if (inList(mnuID, "ADD", "EDIT", "COPY", "VIEW"))
	{
		var xml = null;
		if (mnuID != "ADD")
		{
			xml = this.tbl.getValue("XML");			 
		}
		
		//par.title = "Задача: " + modeName(mnuID);
		par.ret = new Object();
		par.ret.TYPE = xml ? xml.getAttribute("type") : "l";
		par.ret.COMMAND = xml ? xml.getAttribute("command") : "";
		par.ret.PARAM = xml ? xml.getAttribute("par") : "";
		showWindow("e_startup.xml", SW_MODAL, par);
		
		if (!par.escape)
		{
			var xmlTo = xml;
			if (mnuID == "ADD" || mnuID == "COPY")
			{
				xmlTo = oXmlDom.createElement("task");
				oXMLDoc.appendChild(xmlTo);
			}
			
			xmlTo.setAttribute("type", par.ret.TYPE);
			xmlTo.setAttribute("command", par.ret.COMMAND);
			xmlTo.setAttribute("par", par.ret.PARAM);
			oXmlDom.save(sStartupFile);
			this.tbl = getStartupTable();
			grid.setTable(this.tbl);
			grid.refresh();				
		}		
	}
	else if (mnuID == "DEL")
	{
		if("-"==msgBox("c-"
				, ru("Подтвердите удаление записи", "Підтвердіть вилучення запису")
				, ru("Удаление записи", "Вилучення запису"))
			)
		{
			xml = this.tbl.getValue("XML");
			oXMLDoc.removeChild(xml);
			oXmlDom.save(sStartupFile);
			this.tbl = getStartupTable();
			grid.setTable(this.tbl);
			grid.refresh();
		}					
	}
	else if (mnuID == "FROMMENU")
	{
		var xml = getFromMenu();
		if (xml == null) return;
		var xmlTo = oXmlDom.createElement("task");
		oXMLDoc.appendChild(xmlTo);
		xmlTo.setAttribute("type", xml.getAttribute("type"));
		xmlTo.setAttribute("command", xml.getAttribute("command"));
		xmlTo.setAttribute("par", xml.getAttribute("par"));
		oXmlDom.save(sStartupFile);
		this.tbl = getStartupTable();
		grid.setTable(this.tbl);
		grid.refresh();		
	}
	else if (mnuID == "ADDDOC")	
	{
		var par = new Object();
		par.ret = new Object();
		par.zaval = true;
		showWindow("docfdr.xml", SW_MODAL, par)
		if(par.escape)
			return;
	
		var sPar = par.ret.doc +","+ par.ret.nop;	
		var xmlTo = oXmlDom.createElement("task");
		oXMLDoc.appendChild(xmlTo);
		xmlTo.setAttribute("type", "l");
		xmlTo.setAttribute("command", "l_docekz.xml");
		xmlTo.setAttribute("par", sPar);
		oXmlDom.save(sStartupFile);
		this.tbl = getStartupTable();
		grid.setTable(this.tbl);
		grid.refresh();		
	}
	
}

function getFromMenu()
{
	var ret = null;
	var e;
	try
	{
		var mnuTree = lpProxy.getClass().getClassLoader()
			.loadClass("org.debet.DebetApp.custom.DpMenuAsTree").newInstance()
		ret = mnuTree.open();
	}
	catch(e)
	{
		
	}
	
	return ret;
}



function listMenuInit()
{
	grid.AddMenuItem("FROMMENU", "Добавити з меню|Добавить из меню");
	grid.AddMenuItem("ADDDOC", "Добавити папку документів|Добавить папку документов");
	stdMenuInit(grid, this.tbl)
}

function onSave()
{
	
}

include("sys/DpBaseDlg.js");