include("doc\\DpDoc.js");
include("objects/DpObjectSyncronizer.js");

var CONFLICT_LIVE = "LIVE";		//- оставлять конфликты как есть
var CONFLICT_TO = "TO";			//- отдавать предпочтение данным с сервера
var CONFLICT_FROM = "FROM";		//- отдавать предпочтение локальным данным

var progress = null;
var DO_SYNCHRO_IN_THREAD = false;

var COMPARE_LOCAL_ADD = 1;
var COMPARE_REMOTE_ADD = 2;
    
var COMPARE_LOCAL_CHANGES_OK = 3;
var COMPARE_REMOTE_CHANGES_OK = 4;
    
var COMPARE_LOCAL_DEL_OK = 5;
var COMPARE_REMOTE_DEL_OK = 6;
    
var COMPARE_CONFLICT = 7;

var docCash = new Array();
var oSync = new DpObjectSyncronizer();
//-var sClassID;
var Sync_nFolder;

/**
 * @param nFldr - папка (операция)
 * @param oTbl - заполненая таблица с пересечением (клиент/сервер)
 * @param fromSrv - вносятся ли изменения локально
 * @param toSrv - делаются ли изменения на сервере
 * @param onConflict - чего делать с конфликтными записями
 * @param bWithProgress - показывать прогресс
*/
function autoSynchronize(nFldr,sTbl,fromSrv,toSrv,onConflict,bWithProgress)
{
//-	sClassID = sClassID;
	Sync_nFolder = Number(nFldr);
	var oTbl = OpenTable("s",sTbl);
	var batch = createBatch();
	var len = oTbl.getRecordCount();
	startTask(len,bWithProgress);
	for (oTbl.MoveFirst(); !oTbl.isEOF(); oTbl.MoveNext())
	{
		var compareState = parseInt(oTbl.getValue("FCOMPARE"));
		var fclass = oTbl.getValue("FCLASS");
		var nObjID = parseInt(oTbl.getValue("FWID"));
		
		worked(1," ID:" + nObjID + " " + nPos + " / " + len,bWithProgress);
		
		if (isNaN(parseInt(compareState)) || fclass == null || isNaN(nObjID))
			continue;
		var bOk = false;
		if (compareState == COMPARE_LOCAL_ADD || compareState == COMPARE_LOCAL_CHANGES_OK)
		{
			if (!toSrv)
				continue;
			bOk = commitLocal(fclass,nObjID);
		}
		if (compareState == COMPARE_LOCAL_DEL_OK)
		{
			if (!toSrv)
				continue;
			bOk = deleteLocal(fclass,nObjID);
		}
		if (compareState == COMPARE_REMOTE_ADD || compareState == COMPARE_REMOTE_CHANGES_OK)
		{
			if (!fromSrv)
				continue;
			bOk = replaceLocal(fclass,nObjID
				,(compareState == COMPARE_REMOTE_ADD?"ADD":"EDIT"),oTbl.getValue("FRUSER"),oTbl.getValue("FRDATE"));
		}
		if (compareState == COMPARE_REMOTE_DEL_OK)
		{
			if (!fromSrv)
				continue;
			bOk = deleteRemote(fclass,nObjID);
		}
		if (compareState ==	COMPARE_CONFLICT)
		{
			if (onConflict == CONFLICT_LIVE)
				continue;
			if (onConflict == CONFLICT_FROM)
			{
				if (!fromSrv)
					continue;
				if (oTbl.getValue("FRACTION") == "D")
				{
					bOk = deleteRemote(fclass,nObjID)
				}
				else
					bOk = replaceLocal(fclass,nObjID,"EDIT",oTbl.getValue("FRUSER"),oTbl.getValue("FRDATE"));
			}
			if (onConflict == CONFLICT_TO)
			{
				if (!toSrv)
					continue;
				if (oTbl.getValue("FLACTION") == "D")
				{
					bOk = deleteLocal(fclass,nObjID);
				}
				else
					bOk = commitLocal(fclass,nObjID);
			}
		}
		if (bOk)
		{
			oSync.delObjectFromSynchro(fclass,nObjID);
			var sSQL = "DELETE FROM " + sTbl + " WHERE FWID=" + sqlTo(nObjID);
			batch.addBatch(sSQL);
		}
	}
	done(bWithProgress)
	oTbl.close();
	batch.execute(false);
}

function startTask(nLength,bProgress)
{
	nPos = 1;
	if (!bProgress)
		return;
	if (DO_SYNCHRO_IN_THREAD)
	{
		setProgressRangeEx(1,nLength + 1);
	}
	else
	{
		setProgressRange(1,nLength + 1);
	}
}

var nPos = 1;

function worked(nWorked,sText,bProgress)
{
	nPos += nWorked;
	trace("synchro - " + nPos);
	if (!bProgress)
		return;
	if (DO_SYNCHRO_IN_THREAD)
		setProgressPosEx(nPos,UR(sText));
	else
		setProgressPos(nPos,UR(sText));
}

function done(bProgress)
{
	if (!bProgress)
		return;
	if (DO_SYNCHRO_IN_THREAD)
		setProgressPosEx(0,"");
	else
		setProgressPos(0,"");
}

function getClearDoc(sClass)
{
	var Class = String(sClass);
	trace("GCD >>>>>>>>> " + Sync_nFolder);
	if (!docCash[Class])
	{
		var cashDoc = null;
		if (Class.toUpperCase().startsWith("CLS."))
		{
			cashDoc = new DpClEx(sClass.substr(4),Sync_nFolder);
			cashDoc.clear();
			cashDoc.setVar("HCL",Sync_nFolder);
			cashDoc.jObj.setNomCl(Sync_nFolder);
			cashDoc.nCl = Sync_nFolder;
		}
		else
		{
			cashDoc = new DpDoc(Class,Sync_nFolder);
			cashDoc.clear();
			cashDoc.setVar("HOP",Sync_nFolder);
			cashDoc.nNop = Sync_nFolder;
		}
		docCash[Class] = cashDoc;
	}
	var retDoc = docCash[Class];
	retDoc.clear();
	return retDoc;
}

function commitLocal(sClass,nObjID)
{
	trace("synchro - commit local " + sClass + ":" + nObjID);
	var oDoc = getClearDoc(sClass);
	if (oDoc.getJObject().loadFromDB(nObjID) == null)
		return false;
	
	return oDoc.getJObject().storeToXML();	
}

function deleteLocal(sClass,nObjID)
{
	trace("synchro - delete local " + sClass + ":" + nObjID);
	var oDoc = getClearDoc(sClass);
	var ret = oDoc.loadByID(nObjID,true,false);
	if (!ret)
		return false;
	return oDoc.serverDelete(false);
}

function replaceLocal(sClass,nObjID,sMode,sUser,oDate)
{
	var oDoc = getClearDoc(sClass);
	var ret = oDoc.getJObject().loadRemote(nObjID);
	if (!ret)
		return false;
	if (sClass.toUpperCase().startsWith("CLS."))
	{
		oDoc.fillSynchroVars();
		oDoc.setVar("SYNC_DATE",javaDate2Script(oDate,true).getVarDate());
		oDoc.setVar("SYNC_USER",sUser);
		oDoc.toArchive(sMode);
		oDoc.saveExtToDB();
		obj2DB(oDoc.jObj.getObjectID(),oDoc.jObj);
		oDoc.saveRows();
	}
	else
	{
		oDoc.fillSynchroVars();
		oDoc.setVar("SYNC_DATE",javaDate2Script(oDate,true).getVarDate());
		oDoc.setVar("SYNC_USER",sUser);
		oDoc.toArchive(sMode);
		obj2DB(oDoc.jDoc.getObjectID(),oDoc.jDoc);
		oDoc.saveRows();
		oDoc.doRegistration(true);
	}
	return true;
}

function deleteRemote(sClass,nObjID)
{
	var oDoc = getClearDoc(sClass);
	if (oDoc.fromArchive(nObjID) == null)
		return false;
	if (sClass.toUpperCase().startsWith("CLS."))
	{
		oDoc.fillSynchroVars();
		objID = oDoc.jObj.getObjectID();
		oDoc.nCl = oDoc.getVar("HCL");
		delObjFromDB(objID,oDoc.jObj);
//-		oDoc.delExts(objID);
//-		oDoc.delRegistration();
		oDoc.toArchive("DEL");
	}
	else
	{
		oDoc.fillSynchroVars();
		objID = oDoc.jDoc.getObjectID();
		oDoc.nNop = oDoc.jDoc.getVar("HOP");
		delObjFromDB(objID,oDoc.jDoc);
		oDoc.delExts(objID);
		oDoc.delRegistration();
		oDoc.toArchive("DEL");
	}
	return true;
}