function buildPanel()
{
	loadZRPDocsPanel();	
	loadZRPCalcPanel();
	loadZRPSvodPanel();
	loadZRPClPanel();	
}

function loadZRPDocsPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Первинні документи|Первичные документы"));
	var imgFile = lpProxy.getAppPlugLoc() + "icons/zrp.gif";	
	panel.addItem("SHTATRAS", UR("Штатний розклад|Штатное расписание"), imgFile);
	var imgFile = lpProxy.getAppPlugLoc() + "icons/percent.gif";	
	panel.addItem("CLPRIK",   UR("Доплати та утримання|Доплаты и удержания"), imgFile);	
	var imgFile = lpProxy.getAppPlugLoc() + "icons/id_card.gif";
	panel.addItem("CRDV", 	  UR("Особові рахунки|Лицевые счета"), imgFile);
	panel.addItem("TABTIME",  UR("Табелі|Табеля"), true);
		
	this.selZRPHandler = selZRPHandler;
	panel.setSelectHandler(this, "selZRPHandler");
}

function loadZRPCalcPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Розрахунки|Расчеты"));
		
	panel.addItem("CHNG", UR("Вiдбiр мiсяцiв для розрахунку|Отбор месяцев для расчета"), true);	
	panel.addItem("ALL",  UR("Повний розрахунок з/п|Полный расчет з/п"), true);
	panel.addItem("TABN",  UR("Розрахунок з/п по таб.№|Расчет з/п по таб.№"), true);
	panel.addItem("ALLFND", UR("Розрахунок фондів|Расчет фондов"), true);	
		
	this.selZRPHandler = selZRPHandler;
	panel.setSelectHandler(this, "selZRPHandler");
}

function loadZRPSvodPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Зведення|Своды"));
	
	panel.addItem("SVZPLS", UR("Зведення по особових рахунках|Своды по лицевым счетам"), true);
	var imgFile = lpProxy.getAppPlugLoc() + "icons/document_check.gif";	
	panel.addItem("RAZN2B", UR("Рознесення по рахунках|Разноска по счетам"), imgFile);
	var imgFile = lpProxy.getAppPlugLoc() + "icons/net.gif";	
	panel.addItem("RPL", 	UR("Розрахунково-платіжна відомість|Расчетно-платежная ведомость"), imgFile);
	panel.addItem("RDF1", 	UR("Форма 1ДФ|Форма 1ДФ"), true);
		
	this.selZRPHandler = selZRPHandler;
	panel.setSelectHandler(this, "selZRPHandler");
}

function loadZRPClPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Довідники|Справочники"));
	var imgFile = lpProxy.getAppPlugLoc() + "icons/men.gif";	
	panel.addItem("CL3", UR("Персонал|Персонал"), imgFile);
	panel.addItem("CL5", UR("Посади|Должности"), true);	
		
	this.selZRPHandler = selZRPHandler;
	panel.setSelectHandler(this, "selZRPHandler");
}

function selZRPHandler(sID, oPanel)
{
	if (String(lpProxy.getSystem()) != "ZRP")
		lpProxy.getOrgManager().setSys("ZRP", false);
	
	var sDlg = "";
	var par = new Object();
	var sType = SW_NOMODAL;
	switch(sID)
	{
		case "SHTATRAS":
			sDlg = "l_shtatRas.xml";
			break;
			
		case "CLPRIK":
			sDlg = "l_clprik.js";
			break;
		
		case "CRDV":
			sDlg = "l_crdv.xml";
			break;
			
		case "TABTIME":
			sDlg = "l_tabtime.xml";
			break;
			
		case "CHNG":
			sDlg = "l_chng.js";
			break;
			
		case "ALL":
			par.menuMode = "ALL";
			sDlg = "r_all.js";
			break;
		
		case "TABN":
			par.menuMode = "TABN";
			sDlg = "r_all.js";
			break;
			
		case "ALLFND":
			sDlg = "r_allfnd.js";
			break;
			
		case "SVZPLS":
			par.menuMode = "CALC";
			sDlg = "r_svzpls.js";
			break;
		
		case "RAZN2B":
			sDlg = "r_razn2b.js";
			break;
		
		case "RPL":
			par.menuMode = "RPL";
			sDlg = "l_strOrg.xml";
			break;
			
		case "RDF1":
			par.menuMode = "RDF1";
			sDlg = "l_strOrg.xml";
			break;
				
		case "CL3":
			par.Fcl = getPar("CODPERS");
			par.Fvid = 3;
			sDlg = "l_cl.xml";
			break;
		
		case "CL5":
			par.Fcl = getPar("CODDOL");
			par.Fvid = 5;
			sDlg = "l_cl.xml";
			break;					
				
		default:
			return;
	}
	showWindow(sDlg, sType, par);
}