/*
	© 2012 Черкасское представительство ДЕБЕТ Плюс

	Net 05.03.2012
	Протоколирование изменения параметров системы

	Сохранение данных выполняется
		· из общесистемных параметров – org<nn>\orgpar.xml
		· из параметров текущего пользователя – dpsettings\<user>\userpar.xml

	TODO: не добавлять запись в архив, если ничего не изменили
*/

function DpParArchive()
{
	this.archiveTbl = "^PARARCHIVE";
	this.fileOrgPar = lpProxy.orgManager.getOrgPath() + "/orgpar.xml";		// в DpParamStorage.java есть getOrgparFile(), но его зажали сделать public
	this.fileUserPar = getUserDirectory() + "/userpar.xml";

	this.storeParams = DpParArchive_storeParams;
	this.toArchive = DpParArchive_toArchive;
}

function DpParArchive_storeParams(sMode, mFfile, mFdate)
{
	var oXml = lpProxy.openXmlFile(mFfile);
	var oXmlDoc = oXml.getDocumentElement();

	var trans = Packages.javax.xml.transform.TransformerFactory.newInstance().newTransformer();
	var sw = new java.io.StringWriter();
	trans.transform(new Packages.javax.xml.transform.dom.DOMSource(oXml), new Packages.javax.xml.transform.stream.StreamResult(sw));
	var sXml = String(sw.getBuffer());
	sw = null;
	trans = null;

	var m = new Object();
	m.FWID = GetUID();
	m.FMDATE = mFdate;
	m.FMUSER = getUserName();
	m.FMHOST = getHostName();
	m.FSYS = getSystem();
	m.FPARAMS = sMode;

	lpProxy.getDBManager().saveXMLToDB(this.archiveTbl, "FDATA", m.FWID, oXml);
	oXmlDoc = null;
	oXml = null;
	return updateTable(this.archiveTbl, m, false, "", true);
}

function DpParArchive_toArchive(sMode, mFdate)
{
	switch (sMode)
	{
		case "org":
			// тут вроде бы само на диск сохраняет orgpar.xml после каждого изменения
			return this.storeParams(sMode, this.fileOrgPar, mFdate);

		case "user":
			// принудительно сбрасываем на диск параметры юзера
			lpProxy.paramStorage.save();
			return this.storeParams(sMode, this.fileUserPar, mFdate);
	}
}