/*	
	fruckt 24.02.2012 
	Протоколирование редактирования данных таблиц
*/

function DpTblArchive()
{
	this.setList = DpTblArchive_setList;
	this.addTbl = DpTblArchive_addTbl;
	this.getTbl = DpTblArchive_getTbl;
	this.toArchive = DpTblArchive_toArchive;
	this.toXML = DpTblArchive_toXML;
	this.release = DpTblArchive_release;
	this.menuInit = DpTblArchive_menuInit;
	this.menuRun = DpTblArchive_menuRun;
	
	this.list = null;
	this.tbl = null;
	this.tName = new Array();
	this.sAlias = new Array();
	this.fName = new Array();
}

function DpTblArchive_setList(toObject, initTbl)
{
	if (!isEmpty(toObject))
	{
		this.list = toObject;
		
		if (initTbl)
		{
			var tName = !isEmpty(this.list.qryFrom) ? this.list.qryFrom : toScrObj(this.list.tbl.getTableName());
			var sAlias = !isEmpty(this.list.qryAlias) ? this.list.qryAlias : toScrObj(this.list.tbl.getMainAlias());
			this.addTbl(tName, sAlias);
		}
	}
}

function DpTblArchive_addTbl(tbl, alias, idfld)
{
	//имя таблицы для протоколирования
	var i = this.tName.length;
	if (!isEmpty(tbl))
	{
		if (typeof(tbl).toLowerCase() == "string")
		{
			this.tName[i] = tbl.toUpperCase();
		}
		else if (objTypeOf(tbl).toLowerCase() == "dpmtable")
		{
			this.tName[i] = String(tbl.getTableName()).toUpperCase();
		}
	
		//алиас основной таблицы
		if (!isEmpty(alias) && typeof(tbl).toLowerCase() == "string")
		{
			this.sAlias[i] = alias;
		}

		//попробуем выкупить имя основной таблицы по алиасу
		if (!isEmpty(this.tName[i]) && !isEmpty(this.sAlias[i]))
		{
			var reg = new RegExp("(\\^[a-z0-9_]+)\\s+(as)?\\s*"+this.sAlias[i], "gi");
			var a = reg.exec(this.tName[i]);
			if (a && !isEmpty(a) && !isEmpty(a[1]))
			{
				this.tName[i] = String(a[1]).toUpperCase();
			}
		}
		
		//поле таблицы листа для обработки пунктов меню
		if (!isEmpty(idfld))
		{
			this.fName[i] = idfld;
		}
		else
		{
			this.fName[i] = "FWID";
		}
	}
}

function DpTblArchive_getTbl(nID, i)
{
	if (!isEmpty(this.tName[i]) && Number(nID))
	{
		strSQL = " SELECT"
					+" *"
				+" FROM"
					+" ^"+this.tName[i]
				+" WHERE 1 = 1"
					+" AND FWID = "+toScrObj(nID)
		this.tbl = OpenTable(strSQL);
	}
	
	return this.tbl;
}

function DpTblArchive_toArchive(sMode, sSys, nID, tName)
{
	this.release();
	
	var i = 0;
	if (!isEmpty(tName))
	{
		for (var j in this.tName)
		{
			if (this.tName[j] == tName)
			{
				i = j;
				break;
			}
		}
	}
	
	var oXml = this.toXML(nID, i);
	if (isEmpty(oXml))
	{
		return false;
	}
	
	var oDomDoc = oXml.getOwnerDocument();
	if (isEmpty(oDomDoc))
	{
		return false;
	}
	
	oDomDoc.appendChild(oXml);
		
	var m = new Object();
	m.FWID = GetUID();	
	m.FMACTION = sMode.charAt(0);
	m.FMDATE = new Date().getVarDate();
	m.FMUSER = getUserName();
	m.FMHOST = getHostName();
	m.FTBL = this.tName[i];
	m.FSYS = sSys;
	m.FID_ROW = nID;
		
	lpProxy.getDBManager().saveXMLToDB("^TBLARCHIVE", "FDATA", m.FWID, oDomDoc);
	updateTable("^TBLARCHIVE", m, false, "", true);
	
	return true;
}

function DpTblArchive_toXML(nID, i)
{
	if (isEmpty(i))
	{
		i = 0;
	}
	
	var tbl = this.getTbl(nID, i);
	if (!isEmpty(tbl))
	{
		var xmlEl = tbl.toXML();
		return xmlEl;	
	}
	
	return null;
}

function DpTblArchive_release()
{
	if (!isEmpty(this.tbl))
	{
		this.tbl.Close();
		this.tbl = null;
	}
}

function DpTblArchive_menuInit(editAcc)
{
	if (!isEmpty(this.list))
	{
		if ((isEmpty(this.list.oDoc) || getSysName() == "l_cl_lnk")
			&& isEmpty(this.list.oClcl)
			&& !inList(String(getSysName()).toLowerCase(), "l_prov", "r_zakrsc", "vsrazn:r_vsrazn")
			&& (isEditAcc("ADD", editAcc)
				|| isEditAcc("COPY", editAcc)
				|| isEditAcc("EDIT", editAcc)
				|| 	(this.list.accDel != null
					&& this.list.accDel()
					&& filterMode("DEL")
					)
				)
			)	
		{
			this.list.dataSrc.AddMenuItem("","");
			this.list.dataSrc.AddMenuItem("+++",UR("Iсторiя|История"));
			if(!this.list.tbl.IsEmpty())
			{
				for (var i in this.tName)
				{
					this.list.dataSrc.AddMenuItem("ROWARCH"+String(i), UR("Історія запису|История записи")+" в "+this.tName[i]);
				}
			}
			
			for (var i in this.tName)
			{
				this.list.dataSrc.AddMenuItem("TBLARCH"+String(i), UR("Архів таблиці|Архив таблицы")+" "+this.tName[i]);
			}
			
			this.list.dataSrc.AddMenuItem("SYSARCH", UR("Архів списку|Архив списка")+" "+getSysName());
			
			this.list.dataSrc.AddMenuItem("---","");
		} 
	}
}

function DpTblArchive_menuRun(mnuID)
{
	if (!isEmpty(this.list))
	{
		for (var i in this.tName)
		{
			switch (mnuID)
			{
				case "ROWARCH"+String(i):
					var oPar = new Object();
					oPar.nID = toScrObj(this.list.tbl.getValue(this.fName[i]));
					showWindow("l_tblarch.js", SW_NOMODAL, oPar);
					return true;
				break;
				case "TBLARCH"+String(i):
					var oPar = new Object();
					oPar.tName = this.tName[i];
					showWindow("l_tblarch.js", SW_NOMODAL, oPar);
					return true;
				break;
				case "SYSARCH":
					var oPar = new Object();
					oPar.sSys = toScrObj(getSysName());
					showWindow("l_tblarch.js", SW_NOMODAL, oPar);
					return true;
				break;
				default:
				break;
			}
		}
	}
	
	return false;
}