
function setSysPar(sPar, oValue)
{
	return lpProxy.setData(sPar, oValue);
}

function getSysPar(sPar)
{
	return lpProxy.getData(sPar);
}

function setPar(sPar, oValue)
{
	lpProxy.setPar(sPar, oValue);	
}

function getPar(sPar, sys)
{		
	var retPar = null;
	if(isOrgPar(sPar))
		retPar = getOrgPar(sPar);
	if(isSysPar(sPar))
		retPar = getSysPar(sPar);
	if(retPar!=null)
		return retPar;
	if (sys)
		return toScrObj(lpProxy.getPar(sPar, sys));
	
	var ret = toScrObj(lpProxy.getPar(sPar));
	if(sPar.toUpperCase() == "OFFICEDIR" && (ret=="" || ret==null))
	{
		var sDir = getOrgPath() + "externaldocs";
		createDirectory(sDir);
		return sDir;
	}
	return ret;
}

function setObjPar(sPar, obj)
{
	var oValue;
	if (objTypeOf(obj) == "DpSc")
	{
		oValue = String(obj.getSc())
				+ "|" + String(obj.getSu())
				+ "|" + String(obj.getSt())
				+ "|" + String(obj.getCl1())
				+ "|" + String(obj.getCl2())
				+ "|" + String(obj.getCl3())

	}
	lpProxy.setPar(sPar, oValue);
}

function getObjPar(sPar, sys)
{
	var sParVal = getPar(sPar, sys);
	if(sParVal == null)
		return null;

	var aPar = toScrObj(sParVal).split("|");
	include("Objects/DpSc.js");
	var obj = new DpSc();
	obj.set(aPar[0], aPar[1], aPar[2], aPar[3], aPar[4], aPar[5]);
	
	return obj;
}

function isSysPar(sPar)
{
	sPar = String(sPar).toUpperCase();
	return strIn(sPar, "ORGNOM");
}

function isOrgPar(sPar)
{
	var sOrgPar = "OFIRM,OADDRES,OPHONE,OOKPO,OKODNDS,OREGIS"
				   +",ONADMCOD,ONADMTXT,OBOSS,OBUCH,OCASS,ORSC"
				   +",OBANK,OMFO,OBOSSID,OBUCHID,OBOSSPHONE"
				   +",OBUCHPHONE,OCASSPHONE,ORGID,OZIP,OEMAIL,OFAX";	
	return strIn(String(sPar).toUpperCase(), sOrgPar);
}

function getOrgPar(sPar)
{	
	var fcl = getPar("CODMYORG");
	var nOrg = getPar("ORGNOM");
	if(!nOrg || nOrg=="")
		nOrg = "1";
	if(!fcl || fcl=="")
		fcl = "0";
	var sFld = "cl.FWID, cl.FTXT, post.FADDR, post.FPHONE"
			+", post.FCOD_ST, post.FCOD_NDS, post.FREGIS"
			+", post.FNADMCOD, post.FNADMTXT"
			+", post.FBOSS, post.FACCOUNTANT, post.FCAS"
			+", post.FZIP, post.FEMAIL, post.FFAX, post.FCODREGION ";
	var sWhere = " where rel.fcl="+ fcl +" and rel.fcod="+ nOrg;
	var sOrder = " order by fcod"
	var sSql = "select "+ sFld +" from ^CL cl "
				+" inner join ^CLRELCLCL rel on cl.fwid=rel.fwid_cl "
				+" left join ^CL_POST post on cl.fwid=post.fwid_cl ";
	var tCl = getSnap(sSql + sWhere + sOrder, false);
	if(!tCl)
		return null;
	var clID = tCl[0];				
	switch(sPar)
	{
		case "ORGID": 		//id организации			cl.Fwid
    		return clID;
		case "OFIRM": 		//Название организации		cl.FTXT
    		return tCl[1];
    	case "OADDRES":	 	//Адрес						cl_post.FADDR
    		return tCl[2];
    	case "OPHONE": 		//Телефон					cl_post.FPHONE
        	return tCl[3];
    	case "OOKPO": 		//Код ОКПО					cl_post.FCOD_ST
    		return tCl[4];
    	case "OKODNDS": 	//Код НДС					cl_post.FCOD_NDS
    		return tCl[5];
    	case "OREGIS": 		//№ свидет.о рег.плат.НДС	cl_post.FREGIS
   			return tCl[6];
    	 					//Государственный налоговый орган	
    	case "ONADMCOD": 	//код						cl_post.FNADMCOD
    		return tCl[7];
    	case "ONADMTXT": 	//название					cl_post.FNADMTXT
       		return tCl[8];		
    	    
    	case "ORSC": 		//Расчетный счет			cl_orgrs.FRAS_SCH
    	case "OBANK": 		//Название банка			cl_orgrs.FNAZV_BNK
    	case "OMFO": 		//МФО						cl_orgrs.FMFO
    		var tRs	= getSnap("select FWID, FRAS_SCH, FNAZV_BNK, FMFO "
							+" from ^cl_orgrs "
							+" where fwid_cl="+clID+" and FMAIN="+SqlTrue
							, false
							);
    		if(tRs && sPar=="ORSC")
    			return tRs[1];	
    		if(tRs && sPar=="OBANK")
    			return tRs[2];	
    		if(tRs && sPar=="OMFO")
				return tRs[3];	
			break;
		
		case "OBOSS": 		//Директор					cl_orgcp.FFIO
    		var tBoss = getSnap("select ffio from ^cl_orgcp where fwid="+tCl[9], false);
    		if(tBoss!=null)
    			return tBoss[0];
    		break;
    	case "OBOSSID":		//Нал.ном. дирекора			cl_post.FTAXNUM
    		var tBoss = getSnap("select FTAXNUM from ^cl_orgcp where fwid="+tCl[9], false);
    		if(tBoss!=null)
    			return tBoss[0];
    		break;
    	case "OBOSSPHONE":	//Тел.ном. дирекора			cl_post.FPHONE
    		var tBoss = getSnap("select FPHONE from ^cl_orgcp where fwid="+tCl[9], false);
    		if(tBoss!=null)
    			return tBoss[0];
    		break;
    	case "OBUCH": 		//Глав. бух.				cl_orgcp.FFIO
    		var tBuh = getSnap("select ffio from ^cl_orgcp where fwid="+tCl[10], false);
    		if(tBuh!=null)
    			return tBuh[0];
    		break;
    	case "OBUCHID":		//Нал.ном.глав.буха			cl_post.FTAXNUM
			var tBuh = getSnap("select FTAXNUM from ^cl_orgcp where fwid="+tCl[10], false);
    		if(tBuh!=null)
    			return tBuh[0];
    		break;
    	case "OBUCHPHONE":	//Тел.ном.глав.буха			cl_post.FPHONE
			var tBuh = getSnap("select FPHONE from ^cl_orgcp where fwid="+tCl[10], false);
    		if(tBuh!=null)
    			return tBuh[0];
    		break;
    	case "OCASS": 		//Кассир    				cl_orgcp.FFIO
    		var tCas = getSnap("select ffio from ^cl_orgcp where fwid="+tCl[11], false);
    		if(tCas!=null)
    			return tCas[0];
    		break;
    	case "OCASSPHONE":	//Тел.ном. кассира    		cl_orgcp.FPHONE
    		var tCas = getSnap("select FPHONE from ^cl_orgcp where fwid="+tCl[11], false);
    		if(tCas!=null)
    			return tCas[0];
    		break;
    	case "OZIP":
       		return tCl[12];		
    	case "OEMAIL":
       		return tCl[13];		
    	case "OFAX":
       		return tCl[14];		
       	case "CODREGION":
       		return tCl[15];
	}
	return null;
}

function getRegPar(sVid,sPar)
{
	switch(sVid)
	{
		case "":
			sPar = "O_" + sPar;
			break;
		case "-":
			sPar = "PR_" + sPar;
			break;
		case "+":
			sPar = "POK_" + sPar;
			break;
		default:
			return null;
	}
	
	return getPar(sPar);
}

function setRegPar(sVid,sPar,oValue)
{
	switch(sVid)
	{
		case "":
			sPar = "O_" + sPar;
			break;
		case "-":
			sPar = "PR_" + sPar;
			break;
		case "+":
			sPar = "POK_" + sPar;
			break;
		default:
			return;
	}
	setPar(sPar,oValue);
}


/*
   -------------------------------------------------------------------------
                        Parameters API
   -------------------------------------------------------------------------
*/
function WriteParameter
(
szLabel,
szValue,
szObj,
szSubObj,
szSys
)
{
   ///trace("WRITE "+typeOf(szValue)+" = "+szValue)
   if(typeOf(szValue)=="Date")
   {
   	 //var sdf = new java.text.SimpleDataFormat();
   	 //szValue = sdf.format(szValue)
   }
   var sLvl = new Array();
   sLvl[0]= szSys; 
   sLvl[1] = szObj;
   sLvl[2]= szSubObj; 
   return lpProxy.WriteParameter(szLabel,szValue,sLvl);
   //lpProxy.Write(szLabel, szValue, -1, szSys, szObj, szSubObj);
}

function WriteParameterEx
(
szLabel,
szValue,
szObj,
szSubObj,
szSys
)
{
   if(typeof(szLabel)!="string" || typeof(szValue)!="string"){
      alert("Некорректный тип параметра. Должна быть строка.");
      return;
   }
   var sLvl = new Array();
   sLvl[0]= szSys; 
   sLvl[1] = szObj;
   sLvl[2]= szSubObj; 
   return lpProxy.WriteParameter(szLabel,szValue,sLvl);
   //lpProxy.Write(szLabel, szValue, -2, szSys, szObj, szSubObj);
}

function ReadParameter
(
szLabel,
szObj,
szSubObj,
szSys
)
{
	if(typeof(szLabel)!="string"){
		alert("Некорректный тип метки. Должна быть строка.");
		return null;
	}
	var sLvl = new Array();
	sLvl[0]= szSys; 
	sLvl[1] = szObj;
	sLvl[2]= szSubObj; 
	return lpProxy.ReadParameter(szLabel,sLvl);
}

function ReadParameterEx
(
szLabel,
szObj,
szSubObj,
szSys
)
{
	if(typeof(szLabel)!="string"){
		alert("Некорректный тип метки. Должна быть строка.");
		return null;
	}
	var sLvl = new Array();
	sLvl[0]= szSys; 
	sLvl[1] = szObj;
	sLvl[2]= szSubObj; 
	return lpProxy.ReadParameter(szLabel,sLvl);
}

/*
   две следующие функции базируются на предыдущих,
   но автоматом подставляют имя текущей задачи
*/
function WriteParEx
(
szLabel,
szValue
)
{
	var sLvl = new Array();
	sLvl[0]= getSysName();
	sLvl[0] = new java.lang.String(sLvl[0]).replaceAll(":", "_");
	lpProxy.WriteParameter(szLabel,szValue,sLvl);	
}
function ReadParEx
(
szLabel
)
{
	var sLvl = new Array();
	sLvl[0]= getSysName(); 
	sLvl[0] = new java.lang.String(sLvl[0]).replaceAll(":", "_");
	return  lpProxy.ReadParameter(szLabel,sLvl);
}

function getParEx
(
szLabel,
iOrg,
szSys
)
{
	
	
	if (szSys)
	{
		var sLvl = new Array();
		sLvl[0] = "FORG"+iOrg;
		sLvl[1]= szSys; 
		vtRet = lpProxy.ReadParameter(szLabel,sLvl);
	}
		
	if (!vtRet)		
	{
		var sLvl = new Array();
		sLvl[0] = "FORG"+iOrg;		
		vtRet = lpProxy.ReadParameter(szLabel,sLvl);
	}	
	
	if(!vtRet)
	{
		var sLvl = new Array();
		sLvl[0] = "FORG"+iOrg;
		sLvl[1]= getSystem(); 
		vtRet = lpProxy.ReadParameter(szLabel,sLvl);
//		vtRet = lpProxy.Read(szLabel, 1, getSystem(), null, null, iOrg);
	}

   return vtRet;
}