
if (sqlToolkit)
{
	SqlFalse = sqlFalse = String(sqlToolkit.sqlFalse());
	SqlTrue = sqlTrue = String(sqlToolkit.sqlTrue());
	SqlCmpTrue = sqlCmpTrue = String(sqlToolkit.sqlCmpTrue());
	SqlCmpFalse = sqlCmpFalse = String(sqlToolkit.sqlCmpFalse());
	SqlMaxDate = sqlMaxDate = String(sqlToolkit.sqlMaxDate());
	SqlEmpStr = sqlEmpStr = (SUBD==POSTGRE?"''":"' '");
	SqlStr4Like = sqlStr4Like = String(sqlToolkit.sqlStr4Like());


//---------- константы для типов ---------------------
var sqlTSys = "TEXT(3)", sqlTID = "TEXT(12)"
var sqlTDoc = "TEXT(2)", sqlTNop = "LONG", sqlTClc = "LONG" 
var sqlTSc = isBankClSc?"CURRENCY":"INTEGER2";;
var sqlTSu = isBankClSc?"CURRENCY":"INTEGER2";
var sqlTSt = isBankClSc?"CURRENCY":"INTEGER4";

var emptySc = isBankClSc?Convert(0,"MONEY"):Convert(0,"INT");
var emptySu = isBankClSc?Convert(0,"MONEY"):Convert(0,"INT");
var emptySt = isBankClSc?Convert(0,"MONEY"):Convert(0,"INT");

var sql_sc_sup = isBankClSc?Convert(99999,"MONEY"):99999;  // Верхняя граница счета (недосягаемая)
var sql_su_sup = isBankClSc?Convert(99999,"MONEY"):99999;  // Верхняя граница субсчета
var sql_st_sup = isBankClSc?Convert(99999,"MONEY"):99999;  // Верхняя граница статьи

var sqlTCl = "BYTE", sqlTAn = "INTEGER4" 
var sqlTDat = "DATE"
var sqlTSum = "MONEY", sqlTPri = "DOUBLE", sqlTVal = "SHORT", sqlTKol = "DOUBLE"
var sqlTNmk = "TEXT(16)", sqlTEdi = "BYTE" 




// Константы пустых значений полей
var sqlD00 = sqlMaxDate;
var basD00 = "#01/01/3000#"; //для передачи в функции VB
var sqlT00 = sqlEmpStr
var sqlL00 = sqlFalse
var sqlN00 = "0"
}
//---------- функция преобразования дат ---------------------


function sqlDate(dt)
{
   return StrDat(dt, "ACCESS");
}

function StrDat(dt, pformat)
{
 	dt = toScriptDate(dt);
	
	if (!dt || typeof(dt)=="undefined")	  
		dt = d00obj;
	if(!pformat)
		pformat = "DMY";
	pformat = pformat.toUpperCase();
	// когда будет ввод даты с экрана, нужно будет проверить, добавлять ли 1 к месяцу
	// или брать тот месяц, который даст функция getMonth()
	var d = String(dt.getDate());
	if(d.length == 1 )
	 d = "0"+d;
	var m = String(dt.getMonth()+1);
	if(m.length == 1 ) 
		m1 = "0"+m;
	else
		m1 = m;
	   	
	var y = String(dt.getFullYear());
	var yc = String(dt.getFullYear());
	switch(pformat)
	{
		case "ACCESS":
	    	strdt = "#"+m+"/"+d+"/"+y+"#";
	      	return strdt;
	   	case "DMY":
	      	return d+"."+m1+"."+y;
	   	case "MY":
	      	return m1+"/"+y;
	   	case "TD":
		  	return ("0"+m).substr(m.length-1,2)+yc;
   }
}

// Функция для проверки, учитывать ли закрывающие проводки
function op_zakr()
{
   return getPar("szakr");
}

// Функция, возвращающая выражение для перевода валют в SQL-запросах
function sqlRate(strAlias, strValField, strDateField, strVal2Field, strVKursField)
{
	if(strVal2Field)
	{
		return "("
			+ sqlRate(strAlias, strValField, strDateField)
			+ ") / ("
			+ sqlRate(strAlias, strVal2Field, strDateField)
			+ ")"
	}
   
	strAlias = strAlias? strAlias + ".": "";

	if(strDateField==null) strDateField = "fdate";
	if(strValField==null) strValField = "fval";

	var query = "("
				+ " SELECT  max(^kursval.fkurs) FROM ^kursval"
			+ " WHERE "
				+ (typeof(strValField)=="number" ?
				"fkod = " + strValField :
				strAlias + strValField + " = fkod")
				+ " and " + strAlias + strDateField + " between fbdat and fedat"
			+ ")"
			
	var queryExist = "("
				+ " SELECT  ^kursval.fkurs FROM ^kursval"
			+ " WHERE "
				+ (typeof(strValField)=="number" ?
				"fkod = " + strValField :
				strAlias + strValField + " = fkod")
				+ " and " + strAlias + strDateField + " between fbdat and fedat"
			+ ")"

   
	cKurs = "(CASE WHEN EXISTS "+ queryExist+ " THEN "+query+ "ELSE 1 END)";	

	if(strVKursField)
 		cKurs = IIF(strVKursField+"=0", cKurs, strVKursField);

	return cKurs;

}

// Функция, определяющяя, находится ли элемент в списке
function inList(elem)
{
   for(var i=1; i<inList.arguments.length; i++)
      if(elem==inList.arguments[i])
         return true;
   return false;
}
var inlist = inList;

function Switch()
{  
	var argsLength = Switch.arguments.length;
	if (argsLength < 3)
		return null;
	
	var key = toScrObj(Switch.arguments[0]);
	for(var i = 1; i < argsLength - 1; i += 2)
	{
	  	if(key == toScrObj(Switch.arguments[i]))
	  		return toScrObj(Switch.arguments[i+1]);
	}
	if (argsLength%2 == 0)
		return toScrObj(Switch.arguments[argsLength - 1]);
	return null;
}
var ucase = Switch;
function iif()
{
	var argsLength = iif.arguments.length;
	trace(argsLength)
	if (argsLength < 2)
		return null;
	
	for(var i = 0; i < argsLength - 1; i += 2)
	{
	  	if(toScrObj(iif.arguments[i]))
	  		return toScrObj(iif.arguments[i+1]);
	}
	
	if (argsLength%2 == 1)
		return toScrObj(iif.arguments[argsLength - 1]);
	return null;
}

uif = iif;

function choice()
{
   var ar = choice.arguments;
   
   return ar[ar[0]+1];
}

// Функция проверки, находиться ли переданное значение между двумя другими
function Between( value, min, max )
{
   return ( value>=min && value<=max )
}


// Функция округления до произвольного знака
function round(val, dig)
{
	val = Number(val);
	dig = Number(dig);
	if(val>=0)
		val += 0.0000000001;
	else
		val -= 0.0000000001;
	if(dig==null || dig==0)
		return Math.round(val);
	else
		return parseFloat(Math.round(parseFloat(val+"e"+dig))+"e"+(-dig));
}

/********** Функции работы со строками *********************/
String.prototype.left = function String_left(n)
{
   return this.substring(0, n);
}

String.prototype.right = function String_right(n)
{
   return this.substr(this.length-n);
}

String.prototype.startsWith = function String_startsWith(str)
{
	if (str.length  > this.length) return false;
	return this.substr(0,str.length) == str;
}

String.prototype.endsWith = function String_endsWith(str)
{
   if (str.length  > this.length) return false;
   return this.substr(this.length - str.length) == str;
}

String.prototype.trim = function String_trim()
{
   for(var start=0; this.charAt(start)==" "; start++);
   if(start==this.length) return "";
   for(var end=this.length; this.charAt(end-1)==" "; end--);
   return this.substring(start, end);
}

String.prototype.leftTrim = function String_leftTrim()
{
   for(var start=0; this.charAt(start)==" "; start++);
   return this.substr(start);
}

String.prototype.rightTrim = function String_rtrim()
{
   for(var end=this.length; this.charAt(end-1)==" "; end--);
   return this.substring(0, end);
}

String.prototype.cleanSpace = function String_cleanSpace()
{
	return this.trim().replace(/\s+/g, " ")
}

String.prototype.equals = function String_equals(str)
{
	if (typeof str == "undefined")
		return false;
	return this == String(str);
}

String.prototype.equalsIgnoreCase = function String_equals(str)
{
	if (typeof str == "undefined")
		return false;
	return this.toLowerCase() == String(str).toLowerCase();
}

//Дополняет слева строку до длины len символом chr
String.prototype.padl = function padl(nLength, cChar)
{
	if (typeof(cChar) == "undefined")
		cChar = "0";
	var str = String(this);
	var len = str.length;
	var sPrefix = "";
	for(; len<nLength; len++)
		sPrefix += cChar;
	return sPrefix + str;
}

//Дополняет справа строку до длины len символом char
String.prototype.padr = function padr(nLength, cChar)
{
	if (typeof(cChar) == "undefined")
		cChar = "0";
	var str = String(this);
	var len = str.length;
	var sPrefix = "";
	for(; len<nLength; len++)
		sPrefix += cChar;
	return str + sPrefix;
}

/*
Array.prototype.add =  function(el)
{
	this[this.length] = el;
}
*/

/*строка наоборот*/
String.prototype.reverse = function reverse() 
{
    var s = "";
    var i = this.length;
    while (i>0) {
        s += this.substring(i-1,i);
        i--;
    }
    return s;
}

function concatArray()
{
	var ret = new Array();
	
	  for(var i = 0; i < concatArray.arguments.length; i++)
	  {
      	var elem = concatArray.arguments[i];
      	
      	for (var j = 0; j < elem.length; j++)
      		ret[ret.length] = elem[j]; 	 
	  }
	
	
	return ret;	
}


function equals(str1, str2) {return String(str1).equals(str2);}
function equalsIgnoreCase(str1, str2) {return String(str1).equalsIgnoreCase(str2);} 

function left(str, n)    
{
	if (!str) return "";
	if (str.length <= n)
		return str;
	return str.left(n);
}
function right(str, n)   
{
		if (!str) return "";
		if (str.length <= n)
			return str;
		return str.right(n);
}
// SK 22.11.02 12:03:38 
function allt(str) 
{
	if(typeof(str)=="string") return str.trim();
	else if(str==null) return "";
	else if(typeOf(str)=="String") return String(str).trim();
	else return "";
}
function ltrim(str)      {return str.leftTrim();}
function rtirm(str)      {return str.rightTrim();}
function cleanSpace(str) {return str.cleanSpace();}

//---------------------------------------------------------------------------
//сравнение строк без учета пробелов (используется в накладных)
function strcmp(str1,str2){
   var str_1,str__1;
   var str_2,str__2;
   var nRet=0;
   var i=0;
   //убрать пробелы сзади
   for(i = str1.length-1;i>0;i--)
      if(str1.charAt(i)!=" ")break;
   str_1 = str1.substr(0,i+1);
   for(i = str2.length-1;i>0;i--)
      if(str2.charAt(i)!=" ")break;
   str_2 = str2.substr(0,i+1);
   //тоже впереди
   for(i = 0; i<str_1.length;i++)
      if(str_1.charAt(i)!=" ")break;
   str__1 = str_1.substr(i);
   for(i = 0; i<str_2.length;i++)
      if(str_2.charAt(i)!=" ")break;
   str__2 = str_2.substr(i);
   //сравнение
   if(str__1==str__2)nRet=0;
   else if(str__1>str__2)nRet=1;
   else if(str__1<str__2)nRet=-1;
   return nRet;
}
//---------------------------------------------------------------------------
// Функция возвращает текст по номеру справочника и номеру аналитики
function sqlCl(fclcl, fcl, emptyTxt)
{
   // Честная заглушка
   if(typeof(emptyTxt)!="string")
      emptyTxt = "";
   return "iif(" + fcl + "=0," + emptyTxt + ", CStr(" + fcl + ") + '-ая аналитика')";
}

// Функция повторяет данную строку указанное количество раз
function replicate(symb,n)
{
	if(n<1)
		return "";
	var str = String(symb);
	for( i=1;i<n; i++)
	{
		str += symb;
	}
	return str; 
}

function strlen(str)
{
  return String(str).length; 
}
//----------------------------------------------------------------------------
// Функция производит замену символов в cSearchedExp 
// в соответствии с переданными cSearchExp и cReplExp
// например: chrtran("1234","321","ab") возвращает "ba4"
// ("3"->"a","2"->"b","1"->"","4" ни на что не меняется)

function chrtran(cSearchedExp, cSearchExp, cReplExp)
{
  var i;
  var new_str="";
  for (i=0;i<cSearchedExp.length;++i)
  {
    var j=0;
    while (j<cSearchExp.length && cSearchExp.charAt(j)!=cSearchedExp.charAt(i))
      ++j;
      
    if (j<cSearchExp.length)
      new_str+=cReplExp.charAt(j)
    else
      new_str+=cSearchedExp.charAt(i)  
  }
  return new_str;  
}
//----------------------------------------------------------------------------
// Функция производит замену в строке cExp подстроки 
// (начиная с позиции nStartRepl длинной nCharRepl) на cRepl
// например: stuff("1234",2,1,"ab") возвращает "12ab4"

function stuff(cExp,nStartRepl,nCharRepl,cRepl)
{
  var i;
  var new_str="";
  if (nStartRepl>=cExp.length)
  {
    alert("Ошибка при передаче параметров в stuff");
    return false;
  }  
  new_str+=cExp.substr(0,nStartRepl);
  new_str+=cRepl;
  if (nStartRepl+nCharRepl+1>cExp.length)
    return new_str
  else
    return (new_str+cExp.substring(nStartRepl+nCharRepl,cExp.length));
}


//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
// Функция установки формул по умолчанию

function v1DefVal(CurVid,npar)
{
   var mFvar, vdt, vpv, var1, var2, var3, var4;
   if (!CurVid || !npar)
   {
      alert("Передайте в функцию v1DefVal полный список параметров!");
      return false;
   }    
   mFvar = npar.Fvar;
   mF1VALUE=npar.F1value;
   vdt = mFvar.substr(1,1);
   vpv = mFvar.substr(2,1);
   if ((vdt=="D" || vdt=="T") && (vpv=="P" || vpv=="V"))
   {
      mFvar = mFvar.substr(0,3)+"~";
      switch (vpv)
      {
         case "P":
            var1 = JRSPref+"0"+stuff(mFvar, 1, 1, chrtran(vdt,"DT","TD"));
            var2 = JRSPref+"0" + stuff(mFvar, 1, 2, chrtran(vdt+vpv,"DTPV","TDVP"));
            var3 = JRSPref+"0" + mFvar;
            var4 = JRSPref+"0" + stuff(mFvar, 2, 1, chrtran(vpv,"PV","VP"));
            mF1VALUE = "MAX(0,"+JRVPref+"0"+mFvar+
                        "-MAX(0,("+var1+"+"+var2+")-("+
                        var3+"+"+var4+")))";
            break;            
         case "V":
            var4 = JRSPref+"0" + stuff(mFvar, 1, 1, chrtran(vdt,"DT","TD"));
            var3 = JRSPref+"0" + stuff(mFvar, 1, 2, chrtran(vdt+vpv,"DTPV","TDVP"));
            var2 = JRSPref+"0" + mFvar;
            var1 = JRSPref+"0" + stuff(mFvar, 2, 1, chrtran(vpv,"PV","VP"));

            mF1VALUE = "-MIN(-"+JRVPref+"0"+mFvar+","+
                        "MAX(0,("+var1+"+"+var2+")-("+
                         var3+"+"+var4+")))";
            /* По замечанию Клавдии Васильевны
            mF1VALUE = "MIN("+JRVPref+"0"+mFvar+","+
                        "MAX(0,("+var1+"+"+var2+")-("+
                         var3+"+"+var4+")))";
            */
            break;            
      }
   }   
   npar.F1value=mF1VALUE;
   return true;
}

//-Вернуть пустое значение для типа-------------------------------------------
function NullVal(type)
{
   var ret;
   type = (type.substr(0,1)).toUpperCase();
   
   switch (type)
   {
      case 'D':
         ret = d00;
         break;
      case 'N':
         ret = 0;
         break;
      case 'B':
         ret = false;
         break;
      case 'S':
         ret = '';
         break;
      default:
         ret = 0;
         break;
   }
   return ret;
}

function SqlInStr(sPatern,sFindTo)
{
	return String(sqlToolkit.sqlInStr(sPatern, sFindTo));
}

function SqlType(sType,nSize)   
{
	if (!nSize) nSize = 0;
	return String(sqlToolkit.sqlType(sType, nSize));
}

var sqlType = SqlType;

function IIF(sCond,sWhenTrue,sWhenFalse)
{
	return String(sqlToolkit.sqlIIF(sCond, sWhenTrue, sWhenFalse));

}

var sqlIIF = IIF;

function Convert(value, sType, nSize)
{
	if(sqlToolkit == null)
		return value;
	if (!nSize) nSize = 0;
	return String(sqlToolkit.sqlConvert(value, sType, nSize));
}

function sqlUpper(str)
{
	return String(sqlToolkit.sqlUpper(str));
	
}

function First(value, bTop1, type)
{
	if (type != null && type == "BOOL")
		return " min(CONVERT(int,"+value+")) ";
	return " min("+value+") ";
}


function sqlDatToStr(value)
{
	return sqlToolkit.sqlDatToStr(value);
}

function toSqlDate(year, month, day)
{
	return String(sqlToolkit.toSqlDate(year, month, day));
}


//@deprecated
function getColumn(tbl,bScob, alias)
{
	if (typeof(alias) != "string")
		alias = "";
	else
		alias += ".";

	if(!SQL)
		return bScob ? "" : alias + "*";
	var strSql;
	
	var sUser = String(getDBUserName()).toUpperCase();
	var sTemp = lpProxy.getDBTemp(getUserName());
	if(sTemp && sTemp.trim()!="")
		sTemp = String(sTemp).toUpperCase();
	else
		sTemp = sUser;
	
	if(SUBD == MSSQL)
		strSql = "select c.name as name from sysobjects o, syscolumns c where o.id= c.id and o.name = "+sqlTo(tbl);
	else if(SUBD == ORACLE)
	{
		if(sTemp==sUser)
			strSql = "select COLUMN_NAME as NAME from USER_TAB_COLUMNS where TABLE_NAME = "+sqlTo(tbl.toUpperCase());
		else
			strSql = "select COLUMN_NAME as NAME from ALL_TAB_COLUMNS "
					+" where UPPER(OWNER)="+ sqlTo(sTemp) 
						+" and UPPER(TABLE_NAME)="+sqlTo(tbl.toUpperCase());
	}
	
	else if(SUBD == MYSQL)
		strSql = "SHOW COLUMNS FROM "+tbl;
		
    else if (SUBD == DERBY)
    {
    	strSql = "select COLUMNNAME as NAME  " 
    			+ " from sys.systables t, sys.SYSSCHEMAS s, sys.SYSCOLUMNS c " 
    			+ " where s. schemaid = t.schemaid and c.REFERENCEID = t.tableid " 
    			+ " and UPPER(s.schemaname) =  " + sqlTo(sTemp) 
    			+ " and t.tablename = " + sqlTo(String(tbl).toUpperCase())
    }
    else if (SUBD == DB2)
    {

    	strSql = "SELECT COLNAME as NAME  " 
    			+ " FROM sysstat.columns " 
    			+ " where tabschema = " + sqlTo(sTemp) 
    			+ " and tabname = " + sqlTo(String(tbl).toUpperCase())
    }
    else if (SUBD == POSTGRE)
    {
		strSql = "select  COLUMN_NAME as NAME from information_schema.columns" 
				+ " where  TABLE_CATALOG = current_database() " 
				+ " and TABLE_SCHEMA=current_schema() and table_name = " 
				+ sqlTo(String(tbl).toLowerCase());
    	
    }
    else if (SUBD == H2)
    {
		strSql = "select  COLUMN_NAME as NAME from information_schema.columns" 
				+ " where  TABLE_SCHEMA=schema() and table_name = " 
				+ sqlTo(String(tbl).toUpperCase());
    	
    }
    else if (SUBD == HSQLDB)
    {
		strSql = "select  COLUMN_NAME as NAME from information_schema.system_columns" 
				+ " where  TABLE_SCHEM='PUBLIC' and table_name = " 
				+ sqlTo(String(tbl).toUpperCase());
    	
    }
	t = OpenTable("s",strSql)
	if(t.IsBOF() || t.IsEOF())
		return "";
	var sFlds = "";
	t.MoveFirst();
	while(!t.IsEOF())
	{
		sFlds += alias + t.getValue(1).toUpperCase();
		t.MoveNext();
		if(!t.IsEOF())
			sFlds+=",";		
	}
	t.close();
	return bScob?(" ("+sFlds+") ") : ( " " + sFlds + " ");
}


function getColumnsNameArray(tbl)
{
	var arrRet = new Array();
	
	var strSql;
	if(SUBD == MSSQL)
		strSql = "select c.name as name from sysobjects o, syscolumns c where o.id= c.id and o.name = "+sqlTo(tbl);
	else if(SUBD == ORACLE)
		strSql = "select COLUMN_NAME as NAME from USER_TAB_COLUMNS where TABLE_NAME = "+sqlTo(tbl.toUpperCase());
	
	else if(SUBD == MYSQL)
		strSql = "SHOW COLUMNS FROM " + tbl;
		
    else if (SUBD == DERBY)
    {
    	strSql = "select COLUMNNAME as NAME  " 
    			+ " from sys.systables t, sys.SYSSCHEMAS s, sys.SYSCOLUMNS c " 
    			+ " where s. schemaid = t.schemaid and c.REFERENCEID = t.tableid " 
    			+ " and s.schemaname =  " + sqlTo(String(getUserName()).toUpperCase()) 
    			+ " and t.tablename = " + sqlTo(String(tbl).toUpperCase())
    }
	t = OpenTable("s",strSql)
	if(t.IsBOF() || t.IsEOF())
		return arrRet;
	var sFlds = "";
	t.MoveFirst();
	while(!t.IsEOF())
	{
		arrRet[arrRet.length] = String(t.getValue(1).toUpperCase());		
		t.MoveNext();				
	}
	t.close();
	return arrRet;
}



function dropAs(str)
{
	return getOnlyFields (str); //ALEXL 2007.10.07
	
	var n;
	var str1 = str.toUpperCase();
	n = str1.lastIndexOf("AS");
	while(n != -1) // пока в строчке есть AS
	{
		strT = str1.substring(0,n);
		var nz, nb; 
		nz = strT.lastIndexOf(","); //позиция запятой перед AS
		nb = strT.lastIndexOf(")"); //проверка вдруг эта запятая между скобками
		if(nz < nb)
		{
			nb = strT.lastIndexOf("(");
			nz = strT.lastIndexOf("," , nb);	
		}
		//str1 = строка до запятой (включая) + строка после AS 
		str1 = str1.substring(0,nz+1) + str1.substring(n+2,str1.length);
		n = str1.lastIndexOf("AS");
	}
	return str1;
}

//Функция извлекает список полей из строки типа
//	Ffield1 as F1, 12 as F2, a.Ffields2 as F3, 'adsa' as F4,Round(asa, 2) as F5
//На выходе будет F1,F2,F3,F4,F5
function getOnlyFields(fields)
{
	// Удаляем все, что в скобках, включая сами скобки
	// в цикле начиная с самых внутренних скобок
	do 
	{
		prevFields = fields
		fields = fields.replace(/\([^()]*\)/g, "")
	} while (prevFields != fields)
	
	// Удаляем все, что в кавычках, включая кавычки
	fields.replace(/\'[^\']*\'/g, "")
	
	// Удаляем все что между запятой и AS
	fields = fields.replace(/(^|,)[^,]* +as +(\w+) *(?=$|,)/gi, "$1 $2 ")
	// Преобразуем выражения типа a.f1, b.f2 в f1, f2
	fields = fields.replace(/(^|,) *(\w+\.)([A-Za-z0-9_]+) *(?=$|,)/gi, "$1 $3 ")
	return fields;
	
	//Удаляем пробелы слева и справа
	var str = fields.trim();

	//Обрамляем запятыми
	str = "," + str + ",";

	//Заменяем все " на '
	str = str.replace(/"/g, "'");

	//Удаляем +-*/=<>!#$
	str = str.replace(/\+|\-|\*|\/|\=|\>|\<|\!|\#|\$/g, "");

	var stmp = "";
	while (stmp != str)
	{
		stmp = str;
		str = str.replace(/\'/, "#");
		str = str.replace(/\'/, "#");
		str = str.replace(/\#.*\#/, "");
	}

	//Заменяем as на #
	str = str.replace(/\s*as\s*/gi, "#");
	
	//Удаляем символы-разделители
	str = str.replace(/\s*/g, "");

	//Убираем выражения, в которых может содержаться ,
	stmp = "";
	while (stmp != str)
	{
		stmp = str;
		str = str.replace(/\,\w*\(/, ",$");
		str = str.replace(/\)\w*\#/, "$#");
		str = str.replace(/\,\$.*\$\#/, ",");
	}
	
	str = str.replace(/,\w*\.\w*\#/g, ",");
	str = str.replace(/,\w*\#/g, ",");
	str = str.replace(/\#/g, "");
	str = str.replace(/\,\w*\./g, ",");
	
	//Результат
	var strFields = "";
	
	//Теперь str содержит огрызки полей - выделим их
	var strArr = str.split(/\,/);

	//Теперь strArr содержит поля
	for (var i = 0; i < strArr.length; i++)
		if (i != strArr.length - 1)
			strFields += strArr[i] + ",";
		else
			strFields += strArr[i];
	strFields = strFields.substr(1,strFields.length - 2);
	return strFields;
}



function sqlStrIsNotEmp(value)
{
	return sqlToolkit.sqlStrIsNotEmp(value);
}

function sqlStrIsNull(value)
{
	return sqlToolkit.sqlStrIsNull(value);
}

function sqlStrIsNotNull(value)
{
	return sqlToolkit.sqlStrIsNotNull(value);
}

 
function SqlConCat()
{
	var s = new Array()
	for (var i = 0; i < SqlConCat.arguments.length; i++)
	{
		if (SqlConCat.arguments[i] == null)
			s[i] = "null";
		else
			s[i] = String(SqlConCat.arguments[i]);
	}
	return sqlToolkit.sqlConCat(s);
}

function SqlMonth(sFDate)
{
	return sqlToolkit.sqlMonth(sFDate);	
}

function SqlYear(sFDate)
{
	return sqlToolkit.sqlYear(sFDate);
	
}

function SqlDay(sFDate)
{
	return sqlToolkit.sqlDay(sFDate);	
}

function sqlMonth(sFDate)
{
	return SqlMonth(sFDate);
}

function sqlYear(sFDate)
{
	return SqlYear(sFDate);
}

function sqlDay(sFDate)
{
	return SqlDay(sFDate);
}

function SqlLeft(sField,n)
{
	return sqlToolkit.sqlLeft(sField,n);
}

function SqlRight(sField,n)
{
	return sqlToolkit.sqlRight(sField,n);
}

function SqlMid(sField, nBegin, nLength)
{
	if (typeof(nLength) == "undefined")
	{
		//!!!vlad 21.08.2010 
		//Надо переделать.
		//sqlToolkit.sqlMid() принимает в качестве nLength integer,
        //а мы ему отдадим строку.
		nLength = SqlLen(sField);
	}

	return sqlToolkit.sqlMid(sField, nBegin, nLength);
}


function SqlLen(sField)
{
	return sqlToolkit.sqlLen(sField);

}

function SqlTrim(sField)
{
	switch (SUBD)
	{
		case MSSQL:
			return "LTRIM(RTRIM(" + sField + "))";
			break;

		default:
			return "TRIM(" + sField + ")";
			break;
	}
}


//Функция выравнивает текст по правому краю добавляя пробелы слева
function SqlLPAD(sField,n)
{
	return sqlToolkit.sqlLPad(sField, n);
}

function SqlDaysBWDates(sDate1,sDate2)
{
	return sqlToolkit.sqlDaysBWDates(sDate1, sDate2);
}

function sqlUpper(str)
{
	return sqlToolkit.sqlUpper(str);
}


function SqlSpace(n)
{
	return sqlToolkit.sqlSpace(n);
}

function sqlStrIsEmp(value)
{
	if(SUBD == ORACLE)
		return " trim(" + value + ") IS NULL ";
	else if(SUBD == POSTGRE)
		return " (trim(" + value + ") = '' OR " + value + " IS NULL)";
	else
		return " (" + value + " = '' OR " + value + " IS NULL)";
}

function sqlStrIsNotEmp(value)
{
	if(SUBD == ORACLE)
		return " trim(" + value + ") IS NOT NULL ";
	else if(SUBD == POSTGRE)
		return " (trim(" + value + ") <> '' AND " + value + " IS NOT NULL)";
	else
		return " " + value + " <> '' ";
}

function sqlSwitch1()
{
   var ret, retb = "", rete = "", retd = ""
   var ret = "(CASE "
   var sExpr = "WHEN "+sqlSwitch.arguments[0]+" = "
   for( var i=1; i<sqlSwitch.arguments.length-1; i+=2)
   {
     
      var sCase = sExpr + sqlTo(sqlSwitch.arguments[i])
      + " THEN " +sqlTo(UR(sqlSwitch.arguments[i+1]))
       ret = ret + sCase;
      
   }
   if( sqlSwitch.arguments.length % 2 )
      retd = sqlTo("");
   else
      retd = sqlTo(UR(sqlSwitch.arguments[sqlSwitch.arguments.length-1]));
   
   return ret +  " ELSE "+retd+" END ) ";
}

// Округление в SQL
function sqlRound(value, decimal)
{
	if(SQL)
		return sqlToolkit.sqlRound(value, decimal);  // "ROUND("+value+","+decimal+")";
	else
	{
		var n = Math.pow(10,decimal)
		return "int((" + value + ")*" + n + "+0.5)/" + n 
	}
}

function sqlSwitchEx()
{
   /*
   var ret, retb = "", rete = "", retd = ""
   for( var i=1; i<sqlSwitchEx.arguments.length-1; i+=2)
   {
      retb = retb
         + "iif(CBool(" + sqlSwitchEx.arguments[0] + "="
         + sqlTo(sqlSwitchEx.arguments[i]) + ")," 
         + sqlSwitchEx.arguments[i+1] + ","
      rete = rete + ")"
   }
   if( sqlSwitchEx.arguments.length % 2 )
      debug("Ошибочное количество аргументов");
   else
      retd = sqlSwitchEx.arguments[sqlSwitchEx.arguments.length-1]
   ret = retb + retd + rete
   return ret
   */
	if( sqlSwitchEx.arguments.length % 2 )
	{
		debug("Ошибочное количество аргументов");
		return null;
	}

    //Разбирать будем с конца
	var ret = sqlSwitchEx.arguments[sqlSwitchEx.arguments.length-1]

	for( var i=sqlSwitchEx.arguments.length-2; i>0; i-=2)
	{

		ret = IIF(
			sqlSwitchEx.arguments[0] +"="+ sqlTo(sqlSwitchEx.arguments[i-1]) 
			, sqlSwitchEx.arguments[i]
			,ret
		)
	}

	return ret;
}

// Примеры: 
// sqlW0("fmol=", 1)           == "fmol=1"
// sqlW0("fdate<=", d00)       == ""
// sqlW0("fsu=", 1, "fsc=41")  == "fsc=41 and fsu=1"
function sqlW0(condStr, condPar, cond2Add)
{
   if(typeof(cond2Add)=="undefined")
      cond2Add = ""

   if(!isEmpty(condPar))
      return (cond2Add? cond2Add + " and ": "") + condStr + sqlTo(condPar);
   else
      return cond2Add;
}

function sqlMax(x1, x2)
{
	return IIF(x1 + ">" + x2,x1,x2);
}

function sqlMin(x1, x2)
{
	return IIF(x1 + "<" + x2,x1,x2);
}

// сравнение векторов, например
// sqlCmpVectors("<", a1, b1, a2, b2)
// cmp может быть "<", "<=", ">" или ">="
function sqlCmpVectors(cmp, a1, b1, a2, b2, a3, b3, a4, b4)
{
	if(typeof a2=="undefined")
		return a1 + cmp + b1;
	else
		return "((" + a1  + ")" + cmp.replace("=","") + "(" + b1 + ")"
			+ " OR ((" + a1 + ")=(" + b1 + ")"
				+ " AND " + sqlCmpVectors(cmp, a2, b2, a3, b3, a4, b4)
				+ ")"
			+ ")";
}

// сравнение векторов, например
// sqlCmpVectors("<", a1, b1, ">=", a2, b2)
// cmp может быть "<", "<=", ">" или ">="
function sqlCmpVectorsEx(cmp1, a1, b1, cmp2, a2, b2, cmp3, a3, b3, cmp4, a4, b4, cmp5, a5, b5)
{
	if(typeof cmp2=="undefined")
		return a1 + cmp1 + b1;
	else
		return "((" + a1 + ")" + cmp1.replace("=","") + "(" + b1 + ")"
			+ " OR ((" + a1 + ")=(" + b1 + ")"
				+ " AND " + sqlCmpVectorsEx(cmp2, a2, b2, cmp3, a3, b3, cmp4, a4, b4, cmp5, a5, b5)
				+ ")"
			+ ")";
}


// Обновление полей fleftkey, frightkey по технологии nested sets
function updateTreeKeys(sTable, fwid, aOrders, extraPar)
{
	extraPar = extraPar? extraPar: new Object;
	
	var parentField = extraPar.parentField || "fgrpid"; 
	var extraWhere = extraPar.extraWhere || "";
	var extraFrom = extraPar.extraFrom || "";
	var extraSelect = extraPar.extraSelect;
	var fwidField = extraPar.fwidField || "fwid";
	
	// Получим данные с обновляемой записи
	
	var t = OpenTable("SELECT "+(extraSelect?extraSelect:"*")
					+ " FROM " + sTable + extraFrom
					+ " WHERE " + fwidField + "=" + sqlTo(fwid) + extraWhere);
	
	var grpid = Number(t.getValue(parentField));
	
	var fleftkey = Number(t.getValue("fleftkey"));
	var frightkey = Number(t.getValue("frightkey"));
	var fgrpdeep = Number(t.getValue("fgrpdeep"));
	var isNew = (fleftkey==0);
	var nNewGrpDeep = 0;
	
	if (typeof(aOrders) == "string")
	{
		aOrders = aOrders.split(",");
	}
	
	// строим ключ упорядочивания по переданному массиву aOrders
	var sOrder = "";
	var sWhereExpr = "";
	
	var fieldValue = null;
	var fieldExpr = "";

	for(var i in aOrders)
	{
		sField = aOrders[i].trim();	
		
		if (sOrder)
		{
			sOrder += ",";
		}
		
		if (sWhereExpr)
		{
			sWhereExpr += ",";
		}
		var sCmp = "<";
		if (sField.substr(sField.length - 5).toUpperCase()==" DESC")
		{
			sCmp = ">";
			sField = sField.substr(0, sField.length - 5);
		}

        //боремся с длинными строками
        fieldValue = toScrObj(t.getValue(sField));
        fieldExpr = sField;
        
        // Не работает сотрировка по строке в DB2 по полями типа длинный текст
        if (objTypeOf(fieldValue) && SUBD==DB2)
        {
       		fieldExpr = "CHAR(" + sField + ",254)";
        }

		if(sCmp == ">")
		{
			sOrder += fieldExpr + " DESC";
		}
		else
		{
			sOrder += fieldExpr;
		}
		
		//sWhereExpr += "'" + sCmp + "', '" + sField + "', \"" + addslashes(sqlTo(t.getValue(sField))) + "\"";
		sWhereExpr += "'" + sCmp + "', '" + fieldExpr + "', \"" + addslashes(sqlTo(t.getValue(sField))) + "\"";

	}
	sWhere = eval("sqlCmpVectorsEx(" + sWhereExpr + ")");

	// Ищем запись перед которой будет добавлена наша
	var tKey = OpenTable("SELECT "+(extraSelect?extraSelect:"*")
						+ " FROM " + sTable + extraFrom
						+ " WHERE " + parentField + "=" + grpid
							+ extraWhere
							+ " AND " + sWhere
						+ " ORDER BY " + sOrder);
	tKey.MoveLast();
	
	// Определим левый ключ для нашей записи	
	var nNewLeftKey;
	
	if (tKey.IsEmpty())
	{
		var tGroup = OpenTable("SELECT "+(extraSelect?extraSelect:"*")
							+ " FROM " + sTable + extraFrom
							+ " WHERE " + fwidField + "=" + grpid
								+ extraWhere);
		
		if (tGroup.IsEmpty())
		{
			// .. и есть ссылка на родителя, но нет родителя,
			// Ставим левый ключ - 1
			nNewLeftKey = 1;
		}
		else
		{
			// .. и есть родитель, значит наша запись - следующая после родителя
			nNewLeftKey = Number(tGroup.getValue("fleftkey")) + 1;
			// Глубина вложенности на 1 больше чем у родителя
			nNewGrpDeep = Number(tGroup.getValue("fgrpdeep")) + 1;
		}
		tGroup.close();
		tGroup = null;
	}
	else
	{
		// Если предыдущая запись присутсвует, значт наша запись имеет ключ на 1 больше
		nNewLeftKey = Number(tKey.getValue("frightkey")) + 1;
		nNewGrpDeep = Number(tKey.getValue("fgrpdeep"));
	}
	var nNewRightKey = nNewLeftKey + (isNew? 1: frightkey - fleftkey);

	// Если ключ обновлися
	if (nNewLeftKey != fleftkey || nNewGrpDeep != fgrpdeep)
	{
		// Перемещаем позиции, для которых наша запись - предок
		if (!isNew)
		{
			ExecuteSQL(
				"UPDATE " + sTable
				+ " SET fleftkey = fleftkey + " + (nNewLeftKey - fleftkey)
					+ ", frightkey = frightkey + " + (nNewLeftKey - fleftkey)
				+ " WHERE fleftkey > " + fleftkey 
					+ " AND fleftkey < " + frightkey
					+ extraWhere
				);
		}
	
		// Сдвигаем те позиции, которые стоят правее нашей записи
		ExecuteSQL(
			"UPDATE " + sTable
			+ " SET fleftkey=fleftkey + " + (nNewRightKey - nNewLeftKey + 1)
			+ " WHERE fleftkey>=" + nNewLeftKey
				+ extraWhere
			);
		ExecuteSQL(
			"UPDATE " + sTable
			+ " SET frightkey=frightkey + " + (nNewRightKey - nNewLeftKey + 1)
			+ " WHERE frightkey>=" + nNewLeftKey
				+ extraWhere
			);
				
		// Обновляем нашу запись
		ExecuteSQL(
			"UPDATE " + sTable
			+ " SET fleftkey=" + nNewLeftKey
				+ ", frightkey=" + nNewRightKey
				+ ", fgrpdeep=" + nNewGrpDeep
			+ " WHERE " + fwidField + "=" + sqlTo(fwid)
				+ extraWhere
			);
	}
	t.close();
	t = null;
	tKey.close();
	tKey = null;
	
	var ret = new Object();
	ret.leftKey = nNewLeftKey;	
	ret.rightKey = nNewRightKey;
	ret.grpDeep = nNewGrpDeep;
	
	return ret;
}

function buildTreeKeysOnTable(sTable, parentId, parentKey, order, parentField)
{	
	var snapLeft = getSnap("SELECT COUNT(fleftkey) FROM " + sTable);
	var snapRight = getSnap("SELECT COUNT(frightKey) FROM " + sTable);
	if (snapLeft == null || snapRight == null)
	{
		alert("ERROR BUILD TREE KEYS ON TABLE " + sTable + "\nMODIFY TABLE",2);
		return;
	}	
	if (typeof order != "string" || order == "")
		order = "fwid";
	var parentField = parentField || "fgrpid";

	if (SUBD == MSSQL)
	{
		if(sTable.indexOf("^")==0)
			var sFullTbl = getRealTableName(sTable)
		else
			var sFullTbl = getPath("TEMP")+".."+sTable;
		var strSQL = getPath("ALL_MDB") + "..dp_buildtreekeys "+sqlTo(sFullTbl)+", "+sqlTo("FWID")+", "+sqlTo(parentField)+", "+sqlTo(parentId)+", "+sqlTo(order)

		var sn = getSnap(strSQL);
		var retVal;
		if (sn != null && sn[0] != null)
			retVal = sn[0];
		return retVal;
	}
	else
		return buildNestedKeys(sTable, parentId, parentKey, order, parentField);
}


function buildNestedKeys(sTable, parentId, parentKey, order, parentField, deep, oBatch)
{
	var parentField = parentField || "fgrpid";
	
	var toExecute = false;
	
	if (!oBatch)
	{
	//	oBatch = createBatch();
		toExecute = true;
	}

	deep = deep? deep: 0;
	
	var tNested = OpenTable("s", s=
		"SELECT *"
		+ " FROM " + sTable
		//+ " WHERE fgrpid=" + parentId
		+ " WHERE " + parentField + "=" + parentId
		+ " ORDER BY " + order
		);
	
	var curKey = parentKey + 1;
	var leftKey, rightKey;
	
	var m = new Object;
	for (; !tNested.IsEOF(); tNested.MoveNext())
	{
		leftKey = curKey;
		var isgrp = tNested.getValue("fisgrp");
		if (isgrp != null)
			isgrp = toScrObj(toScrObj);
		else
			isgrp = true;

		//if (toScrObj(tNested.getValue("fisgrp")))
		if (isgrp)
		{
			rightKey = buildNestedKeys(sTable, tNested.getValue("fwid"), leftKey, order, parentField, deep+1, oBatch);
		}
		else
		{
			rightKey = leftKey + 1;
		}

		m.fleftkey = leftKey;
		m.frightkey = rightKey;

		var sSQL = "UPDATE " + sTable
			+ " SET fleftkey=" + leftKey
				+ ", frightKey=" + rightKey
				+ ", fgrpdeep=" + deep
			+ " WHERE fwid=" + tNested.getValue("fwid")
		
		ExecuteSQL(sSQL);
		curKey = rightKey + 1;
	}

	if (toExecute)
	{
		//oBatch.execute(true);
	}
	tNested.close();
	return curKey;
}

function sqlDateAdd(date,kol,type)
{
	return sqlToolkit.sqlDateAdd(date,kol,type);	
}

function reIndex(array, startIndex)
{
	if (typeof array != "object")
		return array;
	if (typeof startIndex != "number")
		startIndex = 0;
	var result = new Array();
	for (var i in array)
		result[startIndex++] = array[i];
	return result;
}

function objToArray(obj)
{
	if (typeof obj != "object")
		return null;
	var result = new Array();
	if (typeof obj.length == "undefined")
		for (var i in obj)
			result[result.length] = obj[i];
	else if (typeof obj.length == "number")
		for (var i = 0; i < obj.length; i++)
			result[result.length] = obj[i];
	return result;
}

function StrToDate(value)
{
	value = String(value).trim();
	var split = value.split(".");
	if (split.length != 3)
	{
		split = value.split(",");
		if (split.length != 3)
			return null;
	}
	else
	{
		if(split[0].indexOf("d")>-1 || split[0].indexOf("m")>-1 || split[0].indexOf("y")>-1)
			return null;
	}
	if (split[0].length == 4)
	{
		if (split[1].length == 2 && split[2].length == 2)
			return new Date(Number(split[0]), Number(split[1]) - 1, Number(split[2])).getVarDate();
		return null;
	}
	else if (split[2].length == 4)
	{
		if (split[0].length == 2 && split[1].length == 2)
			return new Date(Number(split[2]), Number(split[1]) - 1, Number(split[0])).getVarDate();
		return null;
	}
	return null;
}

function StrToType(value)
{
	if (typeOf(value).toLowerCase() != "string")
		return null;
	value = allt(value);	
	switch (value)
	{
		case "true":
			value = true;
			break;
		case "false":
			value = false;
			break;
		default:			
			var parse = String(parseFloat(value));
			if (parse == value)
				value = Number(parseFloat(value));
			parse = String(parseInt(value));
			if (parse == value)
				value = Number(parseInt(value));
			else
			{
				var date = StrToDate(value);
				if (date == null || date == "Invalid Date")
					value = String(value);
				else
					value = date;				
			}				
			break;
	}
	return value;
}

function loadAttrToObj(node, obj)
{
	try
	{
		var listAttr = node.getAttributes();
		var result = null;
		if (typeof obj == "object")
			result = obj;
		else
			result = new Object();
		for (var i = 0; i < listAttr.length; i++)
		{
			var name = allt(String(listAttr[i].getName()));
			var value = StrToType(listAttr[i].getValue());
			result[name] = value;
		}
		return result;
	}
	catch(x)
	{
		try
		{
			if (objTypeOf(node) == "Array"
				&& node.length > 0 && objTypeOf(node[0]) == "DpXMLDOMAttribute")
			{
				var result = null;
				if (typeof obj == "object")
					result = obj;
				else
					result = new Object();
				for (var i = 0; i < node.length; i++)
				{
					var name = allt(String(node[i].getName()));
					var value = StrToType(node[i].getValue());
					result[name] = value;
				}
				return result;				
			}
			if (typeof obj == "object")
				return obj;
			else
				return new Object();	
		}
		catch(x)
		{
			if (typeof obj == "object")
				return obj;
			else
				return new Object();
		}
	}	
}

function initObjFromAttr(obj, node, add)
{
	var objAttr = loadAttrToObj(node);
	for (var i in objAttr)
	{
		if (typeof obj[i] != "undefined")
		{
			obj[i] = objAttr[i];
		}
		else if (add === true)
			obj[i] = objAttr[i];
	}
	return obj;
}

function loadObjToAttr(node, obj)
{
	try
	{
		var args = loadObjToAttr.arguments;
		var ban = new Array();
		if (args.length > 2)
			for (var i = 2; i < args.length; i++) 
				ban[args[i]] = i;
		for (var i in obj)
			if (typeof ban[i] == "undefined")
				node.setAttribute(i, obj[i]);
		return true;
	}
	catch(x)
	{
		return false;
	}
	
}

//в таблице SRED_INI (средние по зарплате) вместо FVID_SR и FLD_STOR - поля FLD_STOR1..20 (нужно проставить значения)
function mod_sred_ini()
{
	var test = lpProxy.getDBManager().testSQL("SELECT FLD_STOR1,FLD_STOR20 FROM ^SRED_INI WHERE 1<>1");
	if(!test)
	{
		alert("Кина не будет!\nСначала запустите модификацию структур.", "Модификация SRED_INI");
		return false;		
	}
	var oSnap = getSnap("select FLD_STOR from ^SRED_INI "
		+" where FVID_SR=2 or FVID_SR=3 or FVID_SR=4 or FVID_SR=5 or FVID_SR=6");
	if(oSnap==null)
	{
		alert("SRED_INI не нуждается в модификации", "Модификация SRED_INI");
		return false;
	}

	var nPr = 1;
	var sPr = "Модификация "+ getPath("ZRP_MDB") +".zrp_SRED_INI";
	setProgressRange(0, 5);
	setProgressPos(nPr++, sPr);
	
	var sPoint = ".";
	if (SUBD == MSSQL)
		sPoint  = "..";		
	if (SUBD == HSQLDB)
		sPoint  = "";	
	var sOldTbl = getPath("ZRP_MDB") + sPoint + "ZRP_SRED_INI_OLD";
	
	ExecuteSQL("DROP TABLE "+ sOldTbl, false)
	var sSQL = "select * into "+ sOldTbl +" from ^SRED_INI";
	var bRet = ExecuteSQL(sSQL);
	if(!bRet)
	{
		setProgressPos(0);
		alert("Фигня! Модификации не будет!", "Модификация SRED_INI");
		return false;
	}
	setProgressPos(nPr++, sPr);
	
	ExecuteSQL("delete from ^SRED_INI");
	setProgressPos(nPr++, sPr);
	
	sSQL = "insert into ^SRED_INI (FTABN_ID, FLD_DATE, FTABN"
				+", FOUTID, FLD_DEC, FLD_LEN, FLD_MAX, FLD_NUM"
				+", FLD_STOR1, FLD_STOR2, FLD_STOR3, FLD_STOR4, FLD_STOR5"
				+", FLD_STOR6, FLD_STOR7, FLD_STOR8, FLD_STOR9, FLD_STOR10"
				+", FLD_STOR11, FLD_STOR12, FLD_STOR13, FLD_STOR14, FLD_STOR15"
				+", FLD_STOR16, FLD_STOR17, FLD_STOR18, FLD_STOR19, FLD_STOR20) "
			+" select FTABN_ID, FLD_DATE, max(FTABN), max(FOUTID)"
				+", max(FLD_DEC), max(FLD_LEN), max(FLD_MAX), max(FLD_NUM)"
				+", sum("+ IIF("FVID_SR=1", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=2", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=3", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=4", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=5", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=6", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=7", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=8", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=9", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=10", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=11", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=12", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=13", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=14", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=15", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=16", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=17", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=18", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=19", "FLD_STOR", 0) +")"
				+", sum("+ IIF("FVID_SR=20", "FLD_STOR", 0) +")"				
			+" from "+ sOldTbl
			+" group by FTABN_ID, FLD_DATE"
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);	
	
	setProgressPos(0);
	return true;
}

function refreshDocList()
{
	ExecuteSQL("DELETE FROM ^cl_lnk WHERE fnop = 0");
	addDocsFromModules();
	
	var arrModules = lpProxy.getModules();
	for (var i = 0; i < arrModules.length; i++)
	{
		addDocsFromModules(arrModules[i]);
	}
	
}


function addDocsFromModules(moduleID)
{

	include("doc/DpDoc.js");
	
	var sFile = rootDirectoryEx()+"scripts/docs/";
	
	if (moduleID)
	{
		sFile = lpProxy.getModulePath(moduleID) +"/scripts/docs/";
	}
	
	var file = new DpFile(sFile);
	
	if (!file.exists()) return;
	
	if(file.isDirectory())
	{
		var files = file.listFiles();		
				
		for(i=0; i<files.length; i++)
		{
			var docFile = files[i];
			if(!docFile.isDirectory()
			|| docFile.isHidden())
				continue;
			
			sDocID = String(docFile.getName());
			
			if (moduleID)
			{
				sDocID = moduleID + ":" + sDocID;
			}
			
			var doc = new DpDoc(sDocID, 0);			
			if(doc.isAbstract())
				continue;
				
			var text = String(doc.jDoc.getNameText());			
			if ("" == text)
				text = sDocID;
				
			var m = new Object();			
			if (sDocID.indexOf(".cdr.") != -1)
				continue;
			m.FDOC = sDocID;
			m.FNOP = 0;
			m.FSYS = doc.getSys();
			m.FTXT = UR(text);
			m.FIS_DOG = doc.instanceOf("com.debet.dogovor");
			m.FUSED = true;
			m.FWID = GetUID();
			updateTable("^cl_lnk", m, true);			

		}
	}
	else
		return false;

}

function addslashes(str) 
{
	str=str.replace(/\\/g,'\\\\');
	str=str.replace(/\'/g,'\\\'');
	str=str.replace(/\"/g,'\\"');	
	str=str.replace(/\0/g,'\\0');
	return str;
}

function stripslashes(str) 
{
	str=str.replace(/\\'/g,'\'');
	str=str.replace(/\\"/g,'"');
	str=str.replace(/\\\\/g,'\\');
	str=str.replace(/\\0/g,'\0');
	return str;
}

function str_repeat(str, no)
{
	var ret ="";
	for(var i=0; i<no; i++)
		ret += str;
	return ret;
}

function addStartup(sType, sCommand, sPar)
{
	include("Objects/DPXMLDomDocument.js");
	var sStartupFile = lpProxy.getUserDirectory() + "startup.xml";
	var oXmlDom = new DpXMLDOMDocument();		
	var ret = oXmlDom.load(sStartupFile, false);
	if(ret) 
	{
		oXMLDoc = oXmlDom.getDocumentElement();
	}
	else
	{
		oXMLDoc = oXmlDom.createElement("startup");
		oXmlDom.appendChild(oXMLDoc);
	}	
	var xmlTo = oXmlDom.createElement("task");
	oXMLDoc.appendChild(xmlTo);
		
	xmlTo.setAttribute("type", sType);
	xmlTo.setAttribute("command", sCommand);
	xmlTo.setAttribute("par", sPar? sPar : "");
	
	oXmlDom.save(sStartupFile);
}

function getNazvOS(invNum)
{
	var snap = getSnap("SELECT Ftxt FROM ^OSNAZV WHERE Finv_num="+sqlTo(invNum));
	if(snap!=null)
		return snap[0]
	else
		return "";
}

//переносит зарегистрированные записи из журнала CRM в системную таблицу
function crmTrans()
{
	var oldTbl = getPath("ALL_MDB")+ ".UJ_CRM";
	var sTblName = "CRM_DOCS";
	var tmpTbl = "TMP_CRM_DOCS";
	var sFld = getColumn(oldTbl);	
	ExecuteSQL("drop table "+ tmpTbl, false);
	ExecuteSQL("select * into "+ tmpTbl +" from ^"+ sTblName);
	ExecuteSQL("delete from ^"+ sTblName);
	ExecuteSQL("insert into ^"+ sTblName +" ("+ sFld +") "
				+" select "+ sFld +" from "+ oldTbl);
}

//переносит пользовательские переменные из таблицы VARDOC в XMLи
function userVarsToXML()
{	
	include ("objects/DpXMLDomDocument.js");
	var sTmpTbl = getPath("ALL_MDB") +".VARDOC_OLD";
	if(SUBD==MSSQL)
		sTmpTbl = getPath("ALL_MDB") +"..VARDOC_OLD";
	else if(SUBD==DERBY)
		sTmpTbl = "VARDOC_OLD";
	ExecuteSQL("drop table "+ sTmpTbl, false);
	ExecuteSQL("select * into "+ sTmpTbl +" from ^VARDOC", false);
	
	var tbl = OpenTable("select * from ^VARDOC "
						+" where FDEFA<>"+ sqlTrue
						+" order by FDOC, FNOP");
	
	for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
	{
		var sDoc = tbl.getValue("FDOC");
		var nNop = Number(tbl.getValue("FNOP"));
		var sVar = allt(String(tbl.getValue("FVAR")));		
		var sExpr = tbl.getValue("FEXPR");
		var sType = tbl.getValue("FTYPE");
		var sRem = tbl.getValue("FREM");
		
		var sPath = getOrgPath() +"settings/docvars/"+ String(sDoc).toUpperCase() +"/";
		if(!isDir(sPath))
			createDirectory(sPath);
		var sFile =  sPath + nNop +".xml";
			
		var xmlDom = new DpXMLDOMDocument();
		var root = xmlDom.createElement("uservars");
		var header = null;
		var eVar = null;
		if(isFile(sFile))
		{
			xmlDom.load(sFile);
			root = xmlDom.getDocumentElement();
			header = root.getElementsByTagName("header")[0];
			eVar = header.getElementsByTagName(sVar)[0];
			if(eVar!=null)						
				header.removeChild(eVar);		
		}
		else
		{
			header = xmlDom.createElement("header");
			root.appendChild(header);
		}		
		eVar = xmlDom.createElement(sVar);
		eVar.setText(sRem);
		eVar.setAttribute("expr", sExpr);
		eVar.setAttribute("type", sType);
		header.appendChild(eVar);
		
		if(!isFile(sFile))
			xmlDom.appendChild(root);
		xmlDom.save(sFile);		
	}
	tbl.close();
}

function extentionsToXML()
{	
	include("Objects/DpExtentionBuilder.js");
	include ("objects/DpXMLDomDocument.js");
	
	var sTmpTbl = getPath("ALL_MDB") +".CL_EXT_OLD";
	if(SUBD==MSSQL)
		sTmpTbl = getPath("ALL_MDB") +"..CL_EXT_OLD";
	else if(SUBD==DERBY)
		sTmpTbl = "CL_EXT_OLD";
	ExecuteSQL("drop table "+ sTmpTbl, false);
	ExecuteSQL("select * into "+ sTmpTbl +" from ^CL_EXT", false);
	
//	var oSnap = getSnap("select FLABEL from ^cl_ext where FCLASS<>' ' and FCLASS is not null");
//	if(!oSnap)
//	{
//		include("Objects/DpExtentionDecoder.js");		
//		var oDec = new DpExtentionDecoder();
//		oDec.run();
//		ExecuteSQL("update ^cl_ext set fused="+ sqlTrue);
//	}
			
	var tbl = OpenTable("select * from ^CL_EXT "
						+" where FCLASS<>' ' and FCLASS<>"+sqlEmpStr+" and FCLASS is not null "
						+" order by FCLASS, FSUBCLASS");	
	for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
	{
		var sPath = getOrgPath() +"settings/extentions/";		
		var sClass = java.lang.String(tbl.getValue("FCLASS"));
		var sSubClass = tbl.getValue("FSUBCLASS");
		var extBuilder = new DpExtentionBuilder(sClass, sSubClass);		
		var sFile =  sPath + sClass +".xml";
		var sRowClass = null;
		if(sSubClass==null || sSubClass=="")
			sSubClass = "0"; 
		
		if(sClass.startsWith("H."))
		{
			sClass = sClass.substring(2);
			sPath += "docs/"+ sClass +"/";
			sFile =  sPath + sSubClass +".xml";		
		}
		else if(sClass.startsWith("R."))
		{
			sClass = sClass.substring(2);
			if(sClass.indexOf(".")==-1)
				continue;
			sRowClass = sClass.substring(sClass.indexOf(".")+1);
			sClass = sClass.substring(0, sClass.indexOf("."));
			sPath += "docs/"+ sClass +"/";			
			sFile =  sPath + sSubClass +".xml";	
		}		
		else if(sClass.startsWith("CL."))
		{
			sClass = sClass.substring(3);
			sPath += "cls/";
			sFile =  sPath + sClass +".xml";				
		}
				
		if(!isDir(sPath))
			createDirectory(sPath);
		
		var sVar = tbl.getValue("FLABEL");
		
		var xmlDom = new DpXMLDOMDocument();
		var root = xmlDom.createElement("extentions");
		var main = null;
		var eVar = null;
		if(isFile(sFile))
		{
			xmlDom.load(sFile);
			root = xmlDom.getDocumentElement();
			if(sRowClass)
			{
				var rows = main = root.getElementsByTagName("rows")[0];
				if(!rows)
				{
					rows = xmlDom.createElement("rows");
					root.appendChild(rows);
				}
				main = rows.getElementsByTagName(sRowClass)[0];
				if(!main)
				{
					try
					{
						main = xmlDom.createElement(sRowClass);
					}
					catch(e)
					{
						alert("sClass="+tbl.getValue("FCLASS")+" sSubClass="+tbl.getValue("FSUBCLASS")+" sRowClass="+sRowClass+" FWID="+tbl.getValue("FWID")+"\nERROR: "+e, ICON_ERROR);
						return false;
					}
					rows.appendChild(main);
				}
			}
			else
			{
				main = root.getElementsByTagName("header")[0];
				if(!main)
				{
					main = xmlDom.createElement("header");
					root.appendChild(main);
				}
			}
			
			eVar = main.getElementsByTagName(sVar)[0];
			if(eVar!=null)						
				main.removeChild(eVar);		
		}
		else
		{
			if(sRowClass)
			{
				var rows = xmlDom.createElement("rows");
				root.appendChild(rows);
				try
				{
					main = xmlDom.createElement(sRowClass);
				}
				catch(e)
				{
					alert("sClass="+tbl.getValue("FCLASS")+" sSubClass="+tbl.getValue("FSUBCLASS")+" sRowClass="+sRowClass+" FWID="+tbl.getValue("FWID")+"\nERROR: "+e, ICON_ERROR);
					return false;
				}
				rows.appendChild(main);
			}
			else
			{
				main = xmlDom.createElement("header");
				root.appendChild(main);				
			}			
		}
		
		var def = "";
		var oSnap = getSnap("SELECT F"+ String(sVar) 
					  	+" FROM "+ extBuilder.getValueTableName()
					  	+" WHERE FMAINWID=0 OR FMAINWID IS NULL"
					  , false);
		if (oSnap)
			def = oSnap[0];
			
		try
		{
			eVar = xmlDom.createElement(sVar);
			eVar.setText(tbl.getValue("FTXT"));
			eVar.setAttribute("comment", tbl.getValue("Fcomment"));
			eVar.setAttribute("width", tbl.getValue("Fwidth"));
			eVar.setAttribute("pos", tbl.getValue("Fpos"));
			eVar.setAttribute("used", tbl.getValue("Fused"));
			eVar.setAttribute("ischeck", tbl.getValue("FISCHECK"));
			eVar.setAttribute("type", tbl.getValue("Ftype"));
			eVar.setAttribute("isculc", tbl.getValue("Fisculc"));
			eVar.setAttribute("format", tbl.getValue("Fformat"));
			eVar.setAttribute("isfirstpg", tbl.getValue("Fisfirstpg"));
			eVar.setAttribute("default", def);
			main.appendChild(eVar);
		}
		catch(e)
		{
			alert("sClass="+tbl.getValue("FCLASS")+" sSubClass="+tbl.getValue("FSUBCLASS")+" sVar="+sVar+" FWID="+tbl.getValue("FWID")+"\nERROR: "+e, ICON_ERROR);
			return false;
		}
		
		if(!isFile(sFile))
			xmlDom.appendChild(root);
		xmlDom.save(sFile);		
	}
	tbl.close();
}


var arrDocTbl = new Array();
function getDocTable(sDoc)
{
	if (!sDoc)
		return "";
	key = sDoc.toUpperCase();
	var ret = arrDocTbl[key];
	
	if (ret)
		return ret;
		
	include ("doc/DpDoc.js")
	var oDoc = new DpDoc(sDoc, 0);
	var name = oDoc.getTableName();
	
	arrDocTbl[key] = name;
	
	return name;
}

function getDocCount(sDoc, nNop)
{
	var sDoc = toScrObj(sDoc); 
	var nNop = toScrObj(nNop);
	
	var tblName = getDocTable(sDoc);
	if (!tblName) return 0; 
	
	var sql = "select count(*) as cnt from ^" + tblName + " where fdoc = " + sqlTo(sDoc)
		+ " and fnop = " + 	Number(nNop);
		
	var oSnap = getSnap(sql, true);
	if (oSnap && oSnap[0])
		return oSnap[0];
		
	return 0;		
}


function corectUkrDosStr(str)
{
	var ret = new java.lang.String(str);
	ret =  ret.replaceAll("\u0457", "\u0454") //ї -> є
	ret =  ret.replaceAll("\u0407", "\u0404") //Ї -> Є
	ret =  ret.replaceAll("\u045e", "\u0456") //і
	ret =  ret.replaceAll("\u040e", "\u0406") //І
	ret =  ret.replaceAll("\u2219", "\u0457") //ї
	ret =  ret.replaceAll("\u00B0", "\u0407") //Ї
	
	ret = String(ret);
	return ret;	
}


//добавляет недостающие колонки в таблицы для всех расширений из папки /base/.../settings/extentions
function commitExtentions()
{	
	var sPath = getOrgPath() +"settings/extentions/";
	if(!isDir(sPath))
		return;
	
	var sMsg = UR("ОНОВЛЕННЯ РОЗШИРЕНЬ|ОБНОВЛЕНИЕ РАСШИРЕНИЙ");	
	trace("\n\n<<<<<<<<<<<<<<<< "+ sMsg +" START >>>>>>>>>>>>>>>>>>>\n");	
	WAIT(sMsg);
	
	include("Objects\\DpExtentionBuilder.js");
	
	var file = DpFile(sPath);
	var fileList = file.listFiles()
	var nExtCount = fileList.length;
	if(isDir(sPath +"cls"))
		nExtCount += new DpFile(sPath +"cls").listFiles().length - 1;
	if(isDir(sPath +"docs"))
		nExtCount += new DpFile(sPath +"docs").listFiles().length - 1;
	var nExt = 1;
	for(var n=0; n<fileList.length; n++)
	{
		var file = fileList[n];
		if(!file)
			continue;
		trace("\n"+ n +" > "+ file +" > "+ file.name)
		if(isDir(file))
		{
			if(file.name=="cls")
			{
				var clList = new DpFile(file.path).listFiles();
				for(var nCL=0; nCL<clList.length; nCL++)
				{
					WAIT(sMsg +": "+ (nExt) +"/"+ (nExtCount));
					if(nExt<nExtCount)
						nExt++;
					var clFile = clList[nCL];
					if(!clFile)
						continue;
					var sFileName = clFile.name;
					var sDomen = sFileName.substring(0, sFileName.length()-4);
					trace("\n\nCL > "+ sDomen +" > "+ clFile);
					if(!sDomen)
						continue;
					var extBuilder = new DpExtentionBuilder("CL", sDomen);	
					extBuilder.load(true);
					extBuilder.commitStructure(true);	
				}
			}
			else if(file.name=="docs")
			{
				var docList = DpFile(file.path).listFiles();
				for(var nDoc=0; nDoc<docList.length; nDoc++)
				{
					WAIT(sMsg +": "+ (nExt) +"/"+ (nExtCount));
					if(nExt<nExtCount)
						nExt++;
					var docDir = docList[nDoc];
					if(!docDir || !isDir(docDir))
						continue;
					var sDoc = docDir.name;
					var nopList = DpFile(docDir.path).listFiles();
					for(var nNop=0; nNop<nopList.length; nNop++)
					{
						var nopFile = nopList[nNop];
						var sFileName = nopFile.name;
						var sNop = sFileName.substring(0, sFileName.length()-4);
						trace("\n\n"+ sDoc +" > "+ sNop +" > "+ nopFile);
						//если файл имеет пустое имя, тогда переименуем его под нулевую операцию
						if(sNop == "")
						{
							sNop = "0";
							copyFile(nopFile,nopFile.getCanonicalPath().replace(".xml","0.xml"));
							deleteFile(nopFile);
						}
						var extBuilder = new DpExtentionBuilder("H", sDoc, sNop);	
						extBuilder.load(true);
						extBuilder.commitStructure(true);
						
						var extBuilder = new DpExtentionBuilder("R", sDoc, sNop);	
						extBuilder.load(true);
						extBuilder.commitStructure(true);
					}	
				}
			}
		}
		else
		{
			WAIT(sMsg +": "+ (nExt) +"/"+ (nExtCount));
			if(nExt<nExtCount)
				nExt++;
			var sFileName = file.name;
			var sExtVid = sFileName.substring(0, sFileName.length()-4);
			if(!sExtVid)
				continue;
			trace("\n\n"+ sExtVid +" > "+ file)	
			var extBuilder = new DpExtentionBuilder(sExtVid);
			extBuilder.load(true);
			extBuilder.commitStructure(true);			
		}
	}
	CLEARWAIT();
	trace("\n<<<<<<<<<<<<<<<< "+ sMsg +" END >>>>>>>>>>>>>>>>>>>\n\n");
}

function fillSysCombo(oCtrl, arrFilter)
{
	if(!arrFilter)
		arrFilter = null;
	try
	{
		var orgMngr = lpProxy.getOrgManager();
		var sysList = orgMngr.getSysList();
		for(var i=0; i<sysList.size(); i++)
		{
			var sys = sysList.get(i);			
			if(sys)
			{
				var sLabel = sys.label;
				var sName = sys.name;
				var img = sys.iconFile;
				if(!arrFilter || arrFilter.toString().indexOf(sLabel)==-1)
				{
					if (typeOf(oCtrl) == "DpCombo")
						oCtrl.addItem(sLabel, sName);
					else if (typeOf(oCtrl) == "DpTableCombo")
						oCtrl.addItem(sLabel, sName, img);
				}
			}
		}
		oCtrl.value = orgMngr.getSys();
		//if(sysList.size()<=1)
		//	Disable(oCtrl);
	}
	catch(e)
	{
		trace(e);
	}
}

function selSysCombo(oCtrl)
{
	var sys = oCtrl.value;
	var curSys = lpProxy.getOrgManager().getSys();
	lpProxy.getOrgManager().setSys(sys);
	//oCtrl.value = curSys;
}

//добавить операцию для папки документов
function addOperation(sDoc, nNop, sTxt)
{
	include("Objects/DpOperation.js");
	var operList = new DpOperationList(sDoc);
	//если такая операция уже есть выходим
	if(operList.listOperations()[nNop])
		return true;
	operList.addOperation(nNop);
	if(!sTxt)
		sTxt = nNop;
	operList.listOperations()[nNop].setVar("ref",  "");
	operList.listOperations()[nNop].setVar("txt",  sTxt);
	operList.listOperations()[nNop].setVar("cond", "");
	operList.listOperations()[nNop].setVar("mo",   "");
	operList.listOperations()[nNop].setVar("description", "");
	operList.listOperations()[nNop].save();
	return true;
}

//копировать настройки из папки в папку. Если bNoAsk=true - с заменой
function copyDocSettings(doc, nop, toDoc, toNop, calc, bNoAsk)
{
	var par = new Object();
	par.doc = doc;
	par.nop = nop;
	par.toDoc = toDoc;
	par.toNop = toNop;
	par.calc = calc;
	par.noAsk = bNoAsk;
	showWindow("settings_copy.xml", SW_MODAL, par);
	return par;
}

//с помощью рекурсивной ф-ии getMenuItemPathByElement() возвращает полный путь к меню на текущем языке
//например, getMenuItemPath("l_obsch.js","l","CALC") вернет: Баланс -> Обороты и остатки по счету -> Расчет
function getMenuItemPath(task,type,par)
{
	var arg = task+"_"+type+"_"+(par==null?"":par);
	var attr = sysLang == "RU"?"ru":"ua";
	var itemEl = lpProxy.getMenuManager().getItemElement(arg);
	if(itemEl)
		return getMenuItemPathByElement(itemEl,attr).substr(4);
	else
	{
		var msg = ru("В DpMenu.xml не найден элемент: ","В DpMenu.xml не знайдено елемент: ")+"<item command='"+task+"' par='"+par+"' type='"+type+"'/>";
		trace(msg);
		WAIT(msg);
		return "";
	}
}

function getMenuItemPathByElement(itemElement,language)
{
	var txt = itemElement.getAttribute(language.toLowerCase());
	if(txt=="")
		return "";
	return getMenuItemPathByElement(itemElement.getParentNode(),language)+" -> "+txt;
}

//с помощью рекурсивной ф-ии getParItemPathByElement(par,isFullPathMode) в зависимости от флага isFullPathMode возвращает либо полный путь (включая меню) к параметру par либо путь в syspar.xml
//например, getParItemPath("CODPERS", true) вернет: Настройки -> Параметры системы -> Справочники -> сотрудники
//a, getParItemPath("CODPERS", false) вернет: Параметры системы -> Справочники -> сотрудники
function getParItemPath(par,isFullPathMode)
{
	var itemEl = lpProxy.getParamStorage().getItemElement(par);
	if(itemEl)
	{
		if(!isFullPathMode)
			return getParItemPathByElement(itemEl);
		else
		{
			var parTxt = getParItemPathByElement(itemEl);
			var ind = parTxt.indexOf(" -> ");
			if(ind > 0)
				parTxt = parTxt.substr(ind);
			return getMenuItemPath("EditParams.js","r")+parTxt;
		}
	}
	else
	{
		var msg = ru("В syspar.xml не найден элемент: ","В syspar.xml не знайдено елемент: ")+par;
		trace(msg);
		WAIT(msg);
		return "";
	}
}

function getParItemPathByElement(itemParElement)
{
	var txt = UR(itemParElement.getAttribute("text"));
	if(txt=="")
		return "";
	if(typeOf(itemParElement)==typeOf(itemParElement.getParentNode()))
		return UR(getParItemPathByElement(itemParElement.getParentNode()))+" -> "+txt;
	else
		return txt;
}

//проверяет является ли символ цифрой
function isDigit(ch)
{
	if(ch == null || ch == " ")
		return false;
	return Number(ch)>=0 && Number(ch)<=9;
}

function openExtFile(name, fldr, ID)
{	
	file = new DpFile(name);
	if (!file.exists())
	{
		file = new DpFile(name + ".doc");
	}
	
	if (!file.exists() && fldr && isDir(fldr))
	{
		file = new DpFile( fldr + "/" + name);
		if (!file.exists())
			file = new DpFile( fldr + "/" + name + ".doc");
	}		
	
	if (!file.exists() && getPar("OFFICEDIR") != "")
	{
		file = new DpFile( getPar("OFFICEDIR") + "/" + String(ID) +  "/" + name);
		if (!file.exists())
			file = new DpFile( getPar("OFFICEDIR") + "/" + String(ID) +  "/" + name + ".doc");
	}
	
	
	if (file.exists())	
	{
		try
		{
			if (IS_WEB)
			{
				shellOpen(file.getAbsolutePath());
			}
			else
			{
				var ret = Packages.org.eclipse.swt.program.Program.launch(file);
				if (ret == false && Packages.org.eclipse.core.runtime.Platform.getWS() == "gtk")
				{
					shellOpen(file.getAbsolutePath());
				}
			}
			//java.awt.Desktop.getDesktop().open(file);
		}
		catch(e)
		{
			alert(e, 2);
		}
	}
	else
	{
		alert(ru("Файл ","Файл ") + name + ru(" не найден"," не знайдено"))
	}
}

function updateContract()
{
	trace("\n<<<<<<<<<<<<<<<< updateContract >>>>>>>>>>>>>>>>>>>");
	
	ExecuteSQL("select * into "+ getPath("ALL_MDB") +".CONTRACT_"+ format("yyyy_mm_dd", today) 
				+" from ^CONTRACT", false);
	
	var sSQL = "update ^CONTRACT c set c.FCLOSE=(select d.FCLOSE "
				+" from ^DOG_CL d where d.FID_DOG=c.FWID) "
				+" where exists (select d.FCLOSE "
					+" from ^DOG_CL d where d.FID_DOG=c.FWID)";
	ExecuteSQL(sSQL, false);
	
	sSQL = "update ^CONTRACT c set c.FCLOSE=(select d.FCLOSE "
			+" from ^HOZDOG d where d.FID_DOG=c.FWID)"
			+" where exists (select d.FCLOSE "
				+" from ^HOZDOG d where d.FID_DOG=c.FWID)"
	ExecuteSQL(sSQL, false);
	
	sSQL = "update ^CONTRACT c set c.FCLOSE=(select d.FCLOSE "
			+" from ^HTD d where d.FID_DOG=c.FWID)"
			+" where exists (select d.FCLOSE "
				+" from ^HTD d where d.FID_DOG=c.FWID)"
	ExecuteSQL(sSQL, false);
	
	trace("<<<<<<<<<<<<<<<< updateContract >>>>>>>>>>>>>>>>>>>\n");
}

//простановка групп в справочнике кеквов по коду
//1000	ГРУППА 1
//	1100	подгруппа 1.1
//		1110	подподгруппа 1.1.1
//			1111	дочерний КЕКВ
//			1112	дочерний КЕКВ
//		1120	подподгруппа 1.1.2
//	...
//5000	ГРУППА 5

function make_groups_kekv()
{
	trace("\nmake_groups_kekv")
	
	var cl = getPar("CODKEKV");
	if(!cl)
	{
		alert(UR("Не встановлений код довідника КЕКВів!|Не установлен код справочника КЕКВов!"));
		return false;
	}
	
	var sMsg = UR("Проставляються групи КЕКВів . . .|Проставляются группы КЕКВов . . .");
	var nPos = 1;
	setProgressRange(0, 30);
	setProgressPos(nPos++, sMsg);
	
	var sTmpTbl = "TMP_CL_KEKV";
	ExecuteSQL("drop table "+ sTmpTbl, false);
	var sSQL = "select * into "+ sTmpTbl
				+" from ^CLRELCLCL "
				+" where FCL="+ cl;
	ExecuteSQL(sSQL);	
	ExecuteSQL("alter table "+ sTmpTbl +" add column FWID "+ sqlType("INT"));
	ExecuteSQL("update "+ sTmpTbl +" set FWID=FCOD, FISGRP="+ sqlFalse);
	setProgressPos(nPos++, sMsg);
		
	var tbl = OpenTable("select * from "+ sTmpTbl);	
	for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
	{
		var cod = Number(tbl.getValue("FCOD"));
		trace(cod +" > "+ tbl.recordCount)
		if(cod%10==0)
		{
			var sSQL = "update "+ sTmpTbl
						+" set FISGRP="+ sqlTrue 
						+" where FCOD="+ cod;
			ExecuteSQL(sSQL);
					
			if(cod%100==0)
			{
				if(cod%1000==0)
				{					
					var sSQL = "update "+ sTmpTbl
								+" set FISGRP="+ sqlTrue 
									+", FGRPID="+ cod
								+" where FCOD>"+ cod 
									+" and FCOD<"+ (cod+1000);
					ExecuteSQL(sSQL);
					buildNestedKeys(sTmpTbl, cod, 0, "FCOD, FISGRP");
					continue;
				}
								
				var sSQL = "update "+ sTmpTbl
							+" set FISGRP="+ sqlTrue 
								+", FGRPID="+ cod
							+" where FCOD>"+ cod 
								+" and FCOD<"+ (cod+100);
				ExecuteSQL(sSQL);
				buildNestedKeys(sTmpTbl, cod, 0, "FCOD, FISGRP");
				setProgressPos(nPos++, sMsg);
				continue;
			}
			
			var sSQL = "update "+ sTmpTbl
						+" set FISGRP="+ sqlFalse 
							+", FGRPID="+ cod
						+" where FCOD>"+ cod 
							+" and FCOD<"+ (cod+10);
			ExecuteSQL(sSQL);
			buildNestedKeys(sTmpTbl, cod, 0, "FCOD, FISGRP");
		}
	}
	
	sSQL = "update ^CLRELCLCL rel set rel.FISGRP="+ sqlTrue
				+" where rel.FCOD in ("
					+"select tmp.FGRPID from "+ sTmpTbl +" tmp "
					+")"
			+" where rel.FCL="+ cl
	ExecuteSQL(sSQL);
	setProgressPos(nPos++, sMsg);
	
	sSQL = "update ^CLRELCLCL rel set rel.FGRPID=("
				+"select tmp.FGRPID from "+ sTmpTbl +" tmp "
					+" where tmp.FWID_CL=rel.FWID_CL"
				+")"
			+" where rel.FCL="+ cl
	ExecuteSQL(sSQL);
	setProgressPos(nPos++, sMsg);
	
	sSQL = "update ^CLRELCLCL rel set rel.FLEFTKEY=("
				+"select tmp.FLEFTKEY from "+ sTmpTbl +" tmp "
					+" where tmp.FWID_CL=rel.FWID_CL"
				+")"
			+" where rel.FCL="+ cl
	ExecuteSQL(sSQL);
	setProgressPos(nPos++, sMsg);
	
	sSQL = "update ^CLRELCLCL rel set rel.FRIGHTKEY=("
				+"select tmp.FRIGHTKEY from "+ sTmpTbl +" tmp "
					+" where tmp.FWID_CL=rel.FWID_CL"
				+")"
			+" where rel.FCL="+ cl
	ExecuteSQL(sSQL);
		
	tbl.close();
	setProgressPos(0);
	trace("make_groups_kekv\n");
}

//простановка групп в справочнике КПК по коду
function make_groups_kpk()
{
	trace("\nmake_groups_kpk")
	
	var cl = getPar("CODKPK");
	if(!cl)
	{
		alert(UR("Не встановлений код довідника КПК!|Не установлен код справочника КПК!"));
		return false;
	}
	
	var sMsg = UR("Проставляються групи КПК . . .|Проставляются группы КПК . . .");	
	var nPos = 1;
	setProgressRange(0, 100);
	setProgressPos(nPos++, sMsg);
	
	var sTmpTbl = "TMP_CL_KPK";
	ExecuteSQL("drop table "+ sTmpTbl, false);
	var sSQL = "select * into "+ sTmpTbl
				+" from ^CLRELCLCL "
				+" where FCL="+ cl;
	ExecuteSQL(sSQL);	
	ExecuteSQL("alter table "+ sTmpTbl +" add column FWID "+ sqlType("INT"));
	ExecuteSQL("update "+ sTmpTbl +" set FWID=FCOD, FISGRP="+ sqlFalse);
	setProgressPos(nPos++, sMsg);
		
	var tbl = OpenTable("select * from "+ sTmpTbl);	
	for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
	{
		var cod = Number(tbl.getValue("FCOD"));
		trace(cod +" > "+ tbl.recordCount)
		if(cod%1000==0)
		{
			var sSQL = "update "+ sTmpTbl
						+" set FISGRP="+ sqlTrue 
						+" where FCOD="+ cod;
			ExecuteSQL(sSQL);
					
			if(cod%10000==0)
			{
				if(cod%100000==0)
				{					
					var sSQL = "update "+ sTmpTbl
								+" set FISGRP="+ sqlTrue 
									+", FGRPID="+ cod
								+" where FCOD>"+ cod 
									+" and FCOD<"+ (cod+100000);
					ExecuteSQL(sSQL);
					buildNestedKeys(sTmpTbl, cod, 0, "FCOD, FISGRP");
					continue;
				}
								
				var sSQL = "update "+ sTmpTbl
							+" set FISGRP="+ sqlTrue 
								+", FGRPID="+ cod
							+" where FCOD>"+ cod 
								+" and FCOD<"+ (cod+10000);
				ExecuteSQL(sSQL);
				buildNestedKeys(sTmpTbl, cod, 0, "FCOD, FISGRP");
				setProgressPos(nPos++, sMsg);
				continue;
			}
			
			var sSQL = "update "+ sTmpTbl
						+" set FISGRP="+ sqlFalse 
							+", FGRPID="+ cod
						+" where FCOD>"+ cod 
							+" and FCOD<"+ (cod+1000);
			ExecuteSQL(sSQL);
			buildNestedKeys(sTmpTbl, cod, 0, "FCOD, FISGRP");
		}
	}
	
	sSQL = "update ^CLRELCLCL rel set rel.FISGRP=("
				+"select tmp.FISGRP from "+ sTmpTbl +" tmp "
					+" where tmp.FWID_CL=rel.FWID_CL"
				+")"
			+" where rel.FCL="+ cl
	ExecuteSQL(sSQL);
	setProgressPos(nPos++, sMsg);
	
	sSQL = "update ^CLRELCLCL rel set rel.FGRPID=("
				+"select tmp.FGRPID from "+ sTmpTbl +" tmp "
					+" where tmp.FWID_CL=rel.FWID_CL"
				+")"
			+" where rel.FCL="+ cl
	ExecuteSQL(sSQL);
	setProgressPos(nPos++, sMsg);
	
	sSQL = "update ^CLRELCLCL rel set rel.FLEFTKEY=("
				+"select tmp.FLEFTKEY from "+ sTmpTbl +" tmp "
					+" where tmp.FWID_CL=rel.FWID_CL"
				+")"
			+" where rel.FCL="+ cl
	ExecuteSQL(sSQL);
	setProgressPos(nPos++, sMsg);
	
	sSQL = "update ^CLRELCLCL rel set rel.FRIGHTKEY=("
				+"select tmp.FRIGHTKEY from "+ sTmpTbl +" tmp "
					+" where tmp.FWID_CL=rel.FWID_CL"
				+")"
			+" where rel.FCL="+ cl
	ExecuteSQL(sSQL);
		
	tbl.close();
	setProgressPos(0);
	trace("make_groups_kpk\n");
}

//простановка групп в справочнике ККД по коду
function make_groups_kkd()
{
	trace("\nmake_groups_kkd")
	
	var cl = getPar("CODKKD");
	if(!cl)
	{
		alert(UR("Не встановлений код довідника ККД!|Не установлен код справочника ККД!"));
		return false;
	}
	
	var sMsg = UR("Проставляються групи ККД . . .|Проставляются группы ККД . . .");	
	var nPos = 1;
	setProgressRange(0, 100);
	setProgressPos(nPos++, sMsg);
	
	var sTmpTbl = "TMP_CL_KKD";
	ExecuteSQL("drop table "+ sTmpTbl, false);
	var sSQL = "select * into "+ sTmpTbl
				+" from ^CLRELCLCL "
				+" where FCL="+ cl;
	ExecuteSQL(sSQL);	
	ExecuteSQL("alter table "+ sTmpTbl +" add column FWID "+ sqlType("INT"));
	ExecuteSQL("update "+ sTmpTbl +" set FWID=FCOD, FISGRP="+ sqlFalse);
	setProgressPos(nPos++, sMsg);
		
	var tbl = OpenTable("select * from "+ sTmpTbl);	
	for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
	{
		var cod = Number(tbl.getValue("FCOD"));
		trace(cod +" > "+ tbl.recordCount)
		if(cod%10000==0)
		{
			var sSQL = "update "+ sTmpTbl
						+" set FISGRP="+ sqlTrue 
						+" where FCOD="+ cod;
			ExecuteSQL(sSQL);
			
			if(cod%1000000==0)
			{
				if(cod%10000000==0)
				{
					var sSQL = "update "+ sTmpTbl
								+" set FISGRP="+ sqlTrue 
									+", FGRPID="+ cod
								+" where FCOD>"+ cod 
									+" and FCOD<"+ (cod+10000000);
					ExecuteSQL(sSQL);
					buildNestedKeys(sTmpTbl, cod, 0, "FCOD, FISGRP");
					continue;
				}
								
				var sSQL = "update "+ sTmpTbl
							+" set FISGRP="+ sqlTrue 
								+", FGRPID="+ cod
							+" where FCOD>"+ cod 
								+" and FCOD<"+ (cod+1000000);
				ExecuteSQL(sSQL);
				buildNestedKeys(sTmpTbl, cod, 0, "FCOD, FISGRP");				
				continue;
			}
			
			var sSQL = "update "+ sTmpTbl
						+" set FISGRP="+ sqlFalse 
							+", FGRPID="+ cod
						+" where FCOD>"+ cod 
							+" and FCOD<"+ (cod+10000);
			ExecuteSQL(sSQL);
			buildNestedKeys(sTmpTbl, cod, 0, "FCOD, FISGRP");
			setProgressPos(nPos++, sMsg);
			trace(nPos);
		}
	}
	
	sSQL = "update ^CLRELCLCL rel set rel.FISGRP=("
				+"select tmp.FISGRP from "+ sTmpTbl +" tmp "
					+" where tmp.FWID_CL=rel.FWID_CL"
				+")"
			+" where rel.FCL="+ cl
	ExecuteSQL(sSQL);
	setProgressPos(nPos++, sMsg);
	
	sSQL = "update ^CLRELCLCL rel set rel.FGRPID=("
				+"select tmp.FGRPID from "+ sTmpTbl +" tmp "
					+" where tmp.FWID_CL=rel.FWID_CL"
				+")"
			+" where rel.FCL="+ cl
	ExecuteSQL(sSQL);
	setProgressPos(nPos++, sMsg);
	
	sSQL = "update ^CLRELCLCL rel set rel.FLEFTKEY=("
				+"select tmp.FLEFTKEY from "+ sTmpTbl +" tmp "
					+" where tmp.FWID_CL=rel.FWID_CL"
				+")"
			+" where rel.FCL="+ cl
	ExecuteSQL(sSQL);
	setProgressPos(nPos++, sMsg);
	
	sSQL = "update ^CLRELCLCL rel set rel.FRIGHTKEY=("
				+"select tmp.FRIGHTKEY from "+ sTmpTbl +" tmp "
					+" where tmp.FWID_CL=rel.FWID_CL"
				+")"
			+" where rel.FCL="+ cl
	ExecuteSQL(sSQL);
		
	tbl.close();
	setProgressPos(0);
	trace("make_groups_kkd\n");
}

function loadPrik(par)
{	
	var xmlPrik = new DpXMLDOMDocument();
	sPrikLbl = par.edit;
	var k = sPrikLbl.indexOf(":");//обрабатываем приказы из модулей
	var sPrikLbl = String(k==-1?sPrikLbl:sPrikLbl.substr(k+1)).toUpperCase();
	var moduleName = (k==-1?null:par.edit.substr(0,k).toLowerCase());
	if(moduleName)
		var pathPrikXML = lpProxy.getModulePath(moduleName) + "/scripts/prik/"+ sPrikLbl +"/prik.xml";
	else
		var pathPrikXML = rootDirectory() + "prik/"+ sPrikLbl +"/prik.xml";
	if(moduleName)
		var editXML = lpProxy.getModulePath(moduleName) + "/scripts/prik/"+ sPrikLbl +"/"+par.meFile;
	else
		var editXML = "prik/"+ sPrikLbl +"/"+par.meFile;
	if (xmlPrik.load(pathPrikXML, false))
	{
		var xmlEl = xmlPrik.getDocumentElement();
		var xmlNode = xmlEl.selectSingleNode(par.meFile.substring(0, par.meFile.indexOf(".")));
		loadSettingToObj(par, xmlEl, new Array("global", "form1"));
		if (!spLoad(par, "form1"))
			showWnd(xmlNode, xmlEl, par);
	}
	else
	{
		if (typeof(PREP_SETT) == "undefined")
		{
			PREP_SETT = "";
		}
		showWindow(editXML, "XMLDLG", par, PREP_SETT);
	}
}

function spLoad(par, sID)
{
	sID = String(sID);
	if (typeof par[sID] == "undefined")
		return false;
	if (typeof par[sID].load == "undefined")
		return false;

	var sPrikLbl = par.edit;
	var k = sPrikLbl.indexOf(":");//обрабатываем приказы из модулей
	var sPrikLbl = String(k==-1?sPrikLbl:sPrikLbl.substr(k+1)).toUpperCase();
	var moduleName = (k==-1?null:par.edit.substr(0,k).toLowerCase());
	if(moduleName)
		var editXML = lpProxy.getModulePath(moduleName) + "/scripts/prik/"+ sPrikLbl +"/"+par[sID].load;
	else
		var editXML = "prik/"+ sPrikLbl +"/"+par[sID].load;
	var strLoad = (par[sID].root === true) ? par[sID].load : editXML;
	if (par[sID].execute)
	{
		include(strLoad);
		if (typeof par[sID].params != "undefined")								
			eval(par[sID].execute + "(" + par[sID].params + ")");
		else
			eval(par[sID].execute + "()");
		
		return true;
	}
	var showType = (sID == "list" ? "XMLGRID" : "XMLDLG");
	if (typeof par[sID].type != "undefined")
	{
		if (par[sID].type == "DLG")
			showType = "XMLDLG";
		else if (par[sID].type == "GRID")
			showType = "XMLGRID";		
	}	
	
	if (typeof(PREP_SETT) == "undefined")
	{
		PREP_SETT = "";
	}
	showWindow(strLoad, showType, par, PREP_SETT);
	return true;
}

function showWnd(element, xmlEl, par)
{	
	if (element != null)
	{		
		var file = getDirFile(element.getText());		
		var showType = element.getAttribute("type");
		
		if (showType == "" || showType == "DLG")
		{
			var filePass = (file.dir == null ? par.edit : file.dir) + "/"
							+ (file.file == null ? par.meFile : file.file);
			if (file.file != null && par.meFile != file.file)
			{
				var dD = (par.form1 ? par.form1.dd : null);
				if (dD && dD != "")
				{
					var gd = new DpGetDat(dD);
					if (dD == "dD" && (!gd.dat1 || !gd.dat2))
						return;
					else if (dD == "d" && !gd.dat1)
						return;	
					else if (dD == "D" && !gd.dat2)
						return;					
					par.dat1 = gd.dat1;
					par.dat2 = gd.dat2;
				}
				else
				{
					par.dat1 = base_month;	//par.dat1= firstDayMonth(toScriptDate(gd.dat1));
					par.dat2 = lastDayMonth(new Date());
				}
				par.meFile = file.file;
				par.mode = "ADD";				
				loadSettingToObj(par, xmlEl, new Array("form1"));
			}
			
			if (typeof(PREP_SETT) == "undefined")
			{
				PREP_SETT = "";
			}
			showWindow("prik/" + filePass, "XMLDLG", par, PREP_SETT);
		}
		else if (showType == "GRID")
		{			
			par.edit = (file.dir == null ? par.edit : file.dir);
			
			if (typeof(PREP_SETT) == "undefined")
			{
				PREP_SETT = "";
			}
			showWindow("l_prkekz.xml", "XMLGRID", par, PREP_SETT);
		}
	}
	else
	{
		var sPrikLbl = par.edit;
		var k = sPrikLbl.indexOf(":");//обрабатываем приказы из модулей
		var sPrikLbl = String(k==-1?sPrikLbl:sPrikLbl.substr(k+1)).toUpperCase();
		var moduleName = (k==-1?null:par.edit.substr(0,k).toLowerCase());
		if(moduleName)
			var editXML = lpProxy.getModulePath(moduleName) + "/scripts/prik/"+ sPrikLbl +"/"+par.meFile;
		else
			var editXML = "prik/"+ sPrikLbl +"/"+par.meFile;
		
		if (typeof(PREP_SETT) == "undefined")
		{
			PREP_SETT = "";
		}
		showWindow(editXML, "XMLDLG", par, PREP_SETT);
	}
}

function getDirFile(str)
{
	var result = new Object();
	result.dir = null;
	result.file = null;
	if (str != "")
	{
		var i;
		if (str.indexOf(".") != -1)
		{
			i = str.lastIndexOf("/");
			if (i == -1)
				i = str.lastIndexOf("\\");
			if (i == -1)
				result.file = str;
			else
			{
				result.dir = str.substring(0, i);
				result.file = str.substring(i + 1);
			}
		}
		else
			result.dir = str;
	}
	return result;
}

function loadSettingToObj(toObj, xmlEl, array)
{	
	var xmlNode = xmlEl.selectSingleNode("setting");
	if (xmlNode == null)
		return;
	loadSetting(toObj, xmlNode, array);
	if (typeof toObj.global == "object" && toObj.global.tblname)
	{
			toObj.tblName = toObj.global.tblname;
			toObj.sTableName = toObj.tblName;
			if (toObj.sTableName.indexOf("^") != -1)
				toObj.sTableName = toObj.sTableName.substring(toObj.sTableName.indexOf("^") + 1);
	}
}

function restoreObjectsFromXML(sLBL, oPar)
{
	var skipped = 0;
	var thread = new java.lang.Thread(
			function func()
			{
				var isCL = false;
				var nCL = 0;
				if (sLBL.toUpperCase().startsWith("CLS."))
			    {
			    	sLBL = sLBL.substr(4);
			    	isCL = true;    	
			    }
				else if (sLBL.toUpperCase().startsWith("DOCS."))
				{
					sLBL = sLBL.substr(5);
				}
				
				if( !oPar) oPar = new Object();
				
				var oDoc = null;
				if (isCL)
				{
					include ("Objects/DpClEx.js");
					if (oPar.clnum==null)
						return;
					nCL = Number(oPar.clnum);
					oDoc = new DpClEx(sLBL, nCL);
				}
				else
				{
					include ("doc/DpDoc.js");
					oDoc = new DpDoc(sLBL);
				}
				
			    var file = new DpFile(getOrgPath() + "data/" + oDoc.getDataDir());
				if (!file.exists()) return;
				var files = file.listFiles();
				setProgressRangeEx(1,files.length);
				for (var i = 0; i < files.length; i++)
				{
					oDoc.clear();
					if (isCL)
						oDoc = new DpClEx(sLBL, nCL);
					var bDate = (oPar.bdate?oPar.bdate:(new Date()).getTime());
					var eDate = (oPar.edate?oPar.edate:(new Date()).getTime());
					
					var doc = files[i];
					var sName = String(doc.getName());
					if (sName.right(4) != ".xml") continue;
					var nID = Number(sName.substr(0,sName.length - 4));
					
					if(isNaN(nID)) continue;
					
					//if (nID != 16078)
					//	continue;
					
					var dMod = new Date(doc.lastModified())
				
					if (oPar.bdate && differ(dMod,oPar.bdate)<0)
						continue;
					if (oPar.edate && differ(dMod,oPar.edate)>0)
						continue;
					if (oPar.onlyMissing)
					{
						if (toScrObj(oDoc.getJObject().loadFromDB(nID)))
						{
							trace("skip");
							skipped++;
							continue;
						}
					}
					//_alert("A2");
					var isLoad = oDoc.getJObject().loadFromXML(nID);
					if (toScrObj(isLoad))
					{
						trace("load " + nID);
						//_alert("A3");
						if (false && isCL)
						{
							var oSnap = getSnap("select FWID_CL from ^clrelclcl where fcl = " + nCL + " and fcod = " +  oDoc.getVar("HCOD")
									+ " and fwid_cl <> " + nID);
							if (oSnap && oSnap[0])
							{
								var oSnap2 = getSnap("select count(FCLIENT) from ^rbill where fclient = " + nID);
								//_alert((oSnap2 && oSnap2[0] && oSnap2[0] != 0) + "\n" + oSnap2[0])
								if (oSnap2 && oSnap2[0] && oSnap2[0] != 0)
								//if (nID > Number(oSnap[0]))
								{
									var oDocDel = new DpClEx(sLBL, nCL);
									if(oDocDel.loadByID(oSnap[0], true, true))
									{
										delObjFromDB(oSnap[0],oDocDel.getJObject());
										
									}
								}
								else
									continue;
							}
						}
						//_alert("A4");
						obj2DB(nID, oDoc.getJObject());
						//_alert("A5");
						if (!isCL)
							oDoc.saveRows();
						if (oPar.withReg)
							oDoc.doRegistration();
					}
					else
					{
						trace("error");
					}
					if (i%20 == 0)
						setProgressPosEx(i+1);
					
						
				}	
				setProgressPosEx(0);
				if(skipped>0)
					_alert("Кол-во пропущенных файлов: "+skipped);
			}
	)
	//thread.setPriority(1);
	thread.start();
}

//исправляет латынские символы на кириллические, только те, что взаимозаменяемые и их можно спутать
function reTrans(str)
{
     if(str==null)
     	return "";
     str = String(str);
     if(!isEmpty(str))
     {
          str = str.replace(/a/g,"а");
          str = str.replace(/b/g,"в");
          str = str.replace(/c/g,"с");
          str = str.replace(/e/g,"е");
          str = str.replace(/i/g,"і");
          str = str.replace(/k/g,"к");
          str = str.replace(/o/g,"о");
          str = str.replace(/p/g,"р");
          str = str.replace(/u/g,"и");
          str = str.replace(/x/g,"х");
          str = str.replace(/y/g,"у");
          
          str = str.replace(/A/g,"А");
          str = str.replace(/B/g,"В");
          str = str.replace(/C/g,"С");
          str = str.replace(/E/g,"Е");
          str = str.replace(/I/g,"І");
          str = str.replace(/K/g,"К");
          str = str.replace(/O/g,"О");
          str = str.replace(/P/g,"Р");
          str = str.replace(/U/g,"И");
          str = str.replace(/X/g,"Х");
          str = str.replace(/Y/g,"У");
          
          str = str.replace(/’/g,"'");//для коректной валидации в персонификации нужно заменять апостроф
     }
     return str;
}

//возвращает позицию первого латынского символа в строке, если не найден, то -1
function indexOfLatin(str)
{
	var re = /[a-zA-Z]/i;
	return str.search(re);
}

function fio(mode,str,nootch)
{
	var retval = "";
	str = cleanSpace(str); //удалит лишние пробелы
	var mas = str.split(" ");
	switch (mode.toUpperCase())
	{
		case "F":
			retval = typeof(mas[0]) == "undefined" ? "" : mas[0];
			break;
		case "I":
			retval = typeof(mas[1]) == "undefined" ? "" : mas[1];
			if (nootch==true){
				retval = (typeof(mas[1]) == "undefined" ? "" : mas[1])+" "+(typeof(mas[2]) == "undefined" ? "" : mas[2]);				
			}
			break;
		case "O":
			retval = typeof(mas[2]) == "undefined" ? "" : mas[2];
			if (nootch==true){
				retval =""
			}
			break;
		default:
	}
	return retval;
}

//Дополняет слева строку до длины len символом chr
function padl(nWhat, nLength, cChar)
{
	if (typeof(cChar) == "undefined")
		cChar = "0";
	var str = String(nWhat);
	var len = str.length;
	var sPrefix = "";
	for(; len<nLength; len++)
		sPrefix += cChar;
	return sPrefix + str;
}

//Дополняет справа строку до длины len символом char
function padr(nWhat, nLength, cChar)
{
	if (typeof(cChar) == "undefined")
		cChar = "0";
	var str = String(nWhat);
	var len = str.length;
	var sPrefix = "";
	for(; len<nLength; len++)
		sPrefix += cChar;
	return str + sPrefix;
}

// функция для изменения номерации строк fldName в таблице tblName относящихся к sWhere
// при добавлении, изменении и удалении

// mode - "ADD", "EDIT", "DEL" - режим перенумерации
// tblName - имя таблицы с ^
// fldName - имя поле
// oldVal - старое значение
// newVal - новое значение
// sWhere - если строки надо отфильтровать

//примеры
//reNumFld("ADD", "^TMP", "FNOM_STR", null, 9, null)
//reNumFld("EDIT", "^TMP", "FNOM_STR", 9, 10, null)
//reNumFld("DEL", "^TMP", "FNOM_STR", 10, null, null)
function reNumFld(mode, tblName, fldName, oldVal, newVal, sWhere)
{
	var Validation = true;

	//проверим переданные параметры
	if (typeof(mode) == "undefined" || isEmpty(mode) ||
		 typeof(tblName) == "undefined" || isEmpty(tblName) ||
		 typeof(fldName) == "undefined" || isEmpty(fldName)
		)
	{
		alert("Функции reNumFld в файле "+getSysName()+" переданы не все параметры");
		return false;
	}
	else if (mode == "ADD" && (typeof(newVal) == "undefined" ))
	{
		alert("Функции reNumFld в файле "+getSysName()+" переданы не все параметры добавления");
		return false;
	}
	else if (mode == "EDIT" && (typeof(newVal) == "undefined" || typeof(oldVal) == "undefined")
				)
	{
		alert("Функции reNumFld в файле "+getSysName()+" переданы не все параметры редактирования");
		return false;
	}
	else if (mode == "DEL" && (typeof(oldVal) == "undefined"))
	{
		alert("Функции reNumFld в файле "+getSysName()+" переданы не все параметры удаления");
		return false;
	}

	var strSQL;
	var addWhere = (typeof(sWhere) == "undefined" || isEmpty(sWhere)) ? "" : " AND " + sWhere;
	var tbl;

	switch (mode)
	{
		//при добавлении или редактировании строки
		case "ADD":
		case "EDIT":
			
			//если значение не поменялось
			if(mode == "EDIT" && oldVal == newVal)
			{
				return;
			}

			//проверим занято ли это значение
			strSQL = " SELECT"
							+" COUNT("+fldName+")"
						+" FROM"
							+" "+tblName
						+" WHERE 1 = 1"
							+" AND "+fldName+" = "+newVal
							+addWhere
			var a = getSnap(strSQL);
			//если занято
			if (!isEmpty(a[0]))
			{
				strSQL = " SELECT"
							+" *"
						+" FROM"
							+" "+tblName
						+" WHERE 1 = 1"
							+" AND "+fldName+" >= "+newVal
							+addWhere
						+" ORDER BY "+fldName;
				tbl = OpenTable(strSQL);
				if(!tbl.IsEmpty())
				{
					for( tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
					{
						tbl.Edit();
						tbl.setValue(fldName, ++newVal);
						tbl.Update();
					}
				}
				tbl.close(5652);
				tbl = null;
			}

		break;

		//при удалении
		case "DEL":

			strSQL = " SELECT"
						+" *"
					+" FROM"
						+" "+tblName
					+" WHERE 1 = 1"
						+" AND "+fldName+" >= "+oldVal
						+addWhere
					+" ORDER BY "+fldName;
			tbl = OpenTable(strSQL);

			if(!tbl.IsEmpty())
			{
				for( tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
				{
					tbl.Edit();
					tbl.seValue(fldName,tbl.getValue(fldName)-1);
					tbl.Update();
				}
			}

			tbl.close(5652);
			tbl = null;
		break;
	}

	return true;
}

// ф-ция возвращает информацию из прайса
// mode		пустой возврашает только цену
// ptype		тип прайс-листа
// dat		дата, на которую вернуть данные
// nmk		код номенклатуры
// cenano	номер колонки прайса
// dbkr		Организацию
// mol		МОЛ
function fromprice(mode, ptype, dat, nmk, cenano, dbkr)
{
	include("sub\\mtr.js");

	var fromprice_tblClPrice;
	var fromprice_tblPrice;
	var fromprice_mode;
	var fromprice_ptype;
	var fromprice_dat;

	var retval = 0;
	if(!(fromprice_mode == mode
		&& fromprice_ptype == ptype
		&& fromprice_dat <= dat
		&& fromprice_dat >= dat
		&& fromprice_tblPrice != null))
	{
		// Первый вызов с такими параметрами
		WAIT("Первый вызов с такими параметрами");
		// Запомним параметры вызова для того, чтобы при следующем вызове
		// воспользоваться уже открытыми таблицами
		fromprice_mode = mode;
		fromprice_ptype = ptype;
		fromprice_dat = dat;

		var szPriceFwid = _pName(ptype, dat);
		if(fromprice_tblClPrice==null)
		{
			fromprice_tblClPrice = OpenTable("sn","cl_pri","fwid");
		}
		fromprice_tblPrice = null;

		if(fromprice_tblClPrice!=null)
		{
			var szPrice;
			var isPrice = false;
			strSQL = "SELECT FWID"
						+" FROM "
							+ "^CL_PRI"
						+" WHERE 1 = 1"
							+ " AND FWID = " + sqlTo(szPriceFwid)
			var sn = getSnap(strSQL)
			if (sn && sn[0]!= null)
			{
				isPrice = true;
			}
			if(szPriceFwid == null || !isPrice)
			{
				szPrice = "no";
			}
			else
			{
				szPrice = String(pName(fromprice_tblClPrice.getValue("FCOD"), fromprice_tblClPrice.getValue("FDAT"),szPriceFwid));
				if(!IsTableEx("mtr", "mtr_"+szPrice.substr(1)))
				{
					WAIT("На дату отсутствует прайс-лист");
				}
				else
				{
					/*
						здесь нужна таблица чистовика
					*/
					strSQL = " SELECT"
									+" *"
								+" FROM"
									+" "+szPrice
								+" WHERE 1 = 1"
									+" "+sqlw0And(" FPODR = ", dbkr)
									+" AND FTT = "+sqlTo("NM")
								+" ORDER BY FNMKL, FTT DESC";
					fromprice_tblPrice = OpenTable(strSQL);
				}
			}
		}
	}

	CLEARWAIT();

	if(fromprice_tblPrice != null && !fromprice_tblPrice.IsEmpty() && fromprice_tblPrice.FindFirst(" Fnmkl = "+sqlTo(nmk)))
	{
		retval = fromprice_tblPrice.getValue("Fcena"+(cenano > 0 ? cenano : ""));
	}

	return retval;
}

// функция возвращает максимальное значение поля field из таблицы tblName
// можно задать условие strWhere
function getNextNumber(tblName, field, strWhere)
{
     var strSQL = " SELECT "
                         +" MAX(" + Convert(field, "INT") + ") "
                    +" FROM " + tblName
                    +(!isEmpty(strWhere) ? " WHERE " + strWhere : "");
     var sn = getSnap(strSQL);
     var retval = (sn == null || sn[0] == null ? 1 : Number(sn[0]) + 1);
     sn = null;

     return retval;
}

//преобразовывает в строке первый символ к верхнему регистру
function upperFirstCase(str)
{
	str = String(str);
	if(str.length>1)
	{
		return str[0].toUpperCase()+str.substr(1,str.length);
	}
	else
		return str.toUpperCase();
}

//заменяет в строке некорректные символы, возникшие при конвертации из DOS в WINDOWS.
function correctStrRecodeFromDOS(str)
{
	var ret = new java.lang.String(str);
	ret =  ret.replaceAll("Ў", "I") //Ў -> I
	ret =  ret.replaceAll("ў", "i") //ў -> i
	ret =  ret.replaceAll("°", "Ї") //° -> Ї
	ret = String(ret);
	return ret;
}

//исправляет текстовки во всех справочниках аналитики, после перекодировки из DOS
function correctClTxtRecodeFromDOS()
{
	var t = OpenTable("select * from ^cl where Ftxt like '%Ў%' or Ftxts like '%Ў%' or Ftxt like '%ў%' or Ftxts like '%ў%' or Ftxt like '%°%' or Ftxts like '%°%' ");
	setProgressRange(1, t.rowCount);
	for(; !t.IsEOF(); t.MoveNext())
	{
		setProgressPos(t.bookmark, t.bookmark+"/"+t.rowCount);
		var m = new Object();
		m.Ftxt = correctStrRecodeFromDOS(t.getValue("Ftxt"));
		m.Ftxts = correctStrRecodeFromDOS(t.getValue("Ftxts"));
		UpdateTable("^cl", m, false, "Fwid="+t.getValue("Fwid"));
	}
	setProgressPos(0);
	t.close();
}

function sqlKvart(sDate)
{
	switch (SUBD)
	{
		case MSSQL:
			strSQL = Convert(" CEILING(" + Convert(SqlMonth(sDate), "DBL") + " / 3) ", "INT")
			break;

		default:
			var mon = SqlMonth(sDate);
			strSQL = IIF(mon+" IN (1,2,3)", 1, 
					 IIF(mon+" IN (4,5,6)", 2, 
					 IIF(mon+" IN (7,8,9)", 3, 4)))
			break;
	}
	return strSQL;
}

function sqlKvartMonth(sDate)
{
	switch (SUBD)
	{
		case MSSQL:
			strSQL = Convert(" CEILING(" + Convert(SqlMonth(sDate), "DBL") + " / 3) ", "INT") + " *3 - 2 "
			break;

		default:
			var mon = SqlMonth(sDate);
			strSQL = IIF(mon+" IN (1,2,3)", 1, 
					 IIF(mon+" IN (4,5,6)", 4, 
					 IIF(mon+" IN (7,8,9)", 7, 10)))
			break;
	}
	return strSQL;
}

function sqlDecade(sDate)
{
	var dy = SqlDay(sDate);
	strSQL = IIF(dy+" >= 1 AND "+dy+" <= 10", 1, 
			 IIF(dy+" >= 11 AND "+dy+" <= 20", 2, 
			 IIF(dy+" >= 21 AND "+dy+" <= 31", 3, 0)))
	return strSQL;
}

function sqlDecadeDay(sDate)
{
	var dy = SqlDay(sDate);
	strSQL = IIF(dy+" >= 1 AND "+dy+" <= 10", 1, 
			 IIF(dy+" >= 11 AND "+dy+" <= 20", 11, 
			 IIF(dy+" >= 21 AND "+dy+" <= 31", 21, 0)))
	return strSQL;
}

var npp_npp = 0;
function npp()
{
	return ++npp_npp;
}