
// Расчет оборотов по книге покупок
function bnn_ob(cExpr, dat1, dat2, nop)
{
	tblHnn = OpenTable("s", 
		"SELECT *"
		+ " FROM ^hnn h"	
		+ " WHERE h.fdoc_dat BETWEEN " + sqlTo(dat1) + " AND " + sqlTo(dat2)
		+ sqlw0And("fnop=", nop)
		);
	
	tblTune = OpenTable("s", "tune_bpn", "doc");
	if (SQL)
		tblTune.index = "fdoc,fnop";
	
	var nSum = 0;

	var oEval = new DpEval();
	
	for(; !tblHnn.IsEOF(); tblHnn.MoveNext())
	{
		if(tblTune.Seek("=", tblHnn("fdoc"), tblHnn("fnop")))
		{
			var tHnn1 = OpenTable("m",
				"SELECT *"
				+ " FROM ^hnn"
				+ " WHERE fwid=" + sqlTo(tblHnn("Fwid"))
				);
			tHnn1.ExtTie("H", "NN", tblHnn("fnop"));
			
			oEval.setTable(tHnn1);
			
			oEval.setDoc(tblHnn("fdoc"), tblHnn("fnop"));
			
			oEval.addExpr("DOC_DAT", tblHnn("fdoc_dat"));
			oEval.addExpr("ORG", tblHnn("forg"));
			
			oEval.addExpr("C01", tblTune("F_02"));
			oEval.addExpr("C03", tblTune("F_03"));
			oEval.addExpr("C04", tblTune("F_04"));
			oEval.addExpr("C05", tblTune("F_05"));
			oEval.addExpr("C06", tblTune("F_06"));
			oEval.addExpr("C07", tblTune("F_07"));
			oEval.addExpr("C08", tblTune("F_08"));
			oEval.addExpr("C09", tblTune("F_09"));
			oEval.addExpr("C10", tblTune("F_10"));
			oEval.addExpr("C11", tblTune("F_11"));
			oEval.addExpr("C12", tblTune("F_12"));
			oEval.addExpr("C13", tblTune("F_13"));
			oEval.addExpr("C14", tblTune("F_14"));
			oEval.addExpr("C15", tblTune("F_15"));
			oEval.addExpr("C16", tblTune("F_16"));
			oEval.addExpr("C17", tblTune("F_17"));
			oEval.addExpr("C18", tblTune("F_18"));
			oEval.addExpr("C19", tblTune("F_19"));
			oEval.addExpr("C20", tblTune("F_20"));
			oEval.addExpr("C21", tblTune("F_21"));
			oEval.addExpr("C22", tblTune("F_22"));
			oEval.addExpr("C23", tblTune("F_23"));
			oEval.addExpr("C24", tblTune("F_24"));
			oEval.addExpr("C25", tblTune("F_25"));
			oEval.addExpr("C26", tblTune("F_26"));
			oEval.addExpr("C27", tblTune("F_27"));
			oEval.addExpr("C28", tblTune("F_28"));
			oEval.addExpr("C29", tblTune("F_29"));
			oEval.addExpr("C30", tblTune("F_30"));
			oEval.addExpr("C31", tblTune("F_31"));
			
			nSum += oEval.tEval("n", cExpr);
			
			tHnn1.Close(5652);
		}
	}
	
	tblHnn.Close();

	return nSum;
}

function nk_mtr(cMode, dBDat, dEDat, cNmkl
	, nCena, nPodr, nMol, nSc, nSu, nSt
	, nPost, nPlat)
{
	cMode = cMode.toUpperCase();

	var cWhereType;
	
	if(strIn("~", cMode))
		cWhereType = "("
			+ "frtype=" + sqlTo(RTYPE_RS)
				+ " OR frtype=" + sqlTo(RTYPE_PMR)
			+ ")"
	else
		cWhereType = "frtype=" + sqlTo(RTYPE_RS);
		
	var t = OpenTable("s",
		"SELECT SUM(a.fkol) AS fkol"
			+ ", SUM(a.fkol*a.fcena) AS fsum"
			+ ", SUM(a.fkol*a.fvcena) AS fvsum"
			+ ", SUM(a.fkol*a.fcenapr) AS fsumpr"
		+ " FROM ^anltk a"
			+ " LEFT JOIN ^sch_zag s"
				+ " ON a.fid_doc=s.fwid"
		+ " WHERE " + cWhereType
			+ " AND fdate BETWEEN " + sqlTo(dBDat) + " AND " + sqlTo(dEDat)
			+ sqlwNmk("a.fnmkl", cNmkl)
			+ sqlw0And("a.fcena=", nCena)
			+ sqlw0And("a.fpodr=", nPodr)
			+ sqlw0And("a.fmol=", nMol)
			+ sqlw0And("a.fsc=", nSc)
			+ sqlw0And("a.fsu=", nSu)
			+ sqlw0And("a.fst=", nSt)
			+ sqlw0And("a.fpost=", nPost)
			+ sqlw0And("a.fsc=", nSc)
			+ sqlw0And("s.fdbkr=", nPlat)
		);
	
	if(strIn("$", cMode)) // сумма
	{
		if(strIn("S", cMode)) // в справочных ценах
			return t("fvsum");
		else if(strIn("O", cMode))
			return t("fsumpr");
		else
			return t("fsum");
	}
	else
		return t("fkol")
}

function ob_mtr(cMode, mFlt, dBDat, dEDat, cNmkl
	, nCena, nPodr, nMol, nSc, nSu, nSt, nA1, nA2, nA3
	, nPost, nVal)
{
	include("mtr_ost.js");
	
	var cTblName;

	with(new DpMtrOb())
	{
		date1 = dBDat;
		date2 = dEDat;
		fnmkl = cNmkl;
		fcena = nCena;
		fpodr = nPodr;
		fmol = nMol;
		fsc = nSc;
		fsu = nSu;
		fst = nSt;
		fpost = nPost;
		pattern = "OBR";
		doCalc();
		cTblName = tblName;
	}
	
	var tRes = OpenTable("s",
		" SELECT "
			+ "  SUM(a.fpkolr) AS fpkolr"
			+ ", SUM(a.fpkolv) AS fpkolv"
			+ ", SUM(a.frkolr) AS frkolr"
			+ ", SUM(a.frkolv) AS frkolv"
			+ ", SUM(a.fpsumr) AS fpsumr"
			+ ", SUM(a.fpsumv) AS fpsumv"
			+ ", SUM(a.frsumr) AS frsumr"
			+ ", SUM(a.frsumv) AS frsumv"
			+ ", SUM(a.fvpsumr) AS fvpsumr"
			+ ", SUM(a.fvpsumv) AS fvpsumv"
			+ ", SUM(a.fvrsumr) AS fvrsumr"
			+ ", SUM(a.fvrsumv) AS fvrsumv"
		+ " FROM " + cTblName + " a"
		);
	
	if(strIn("Q", cMode))  // Количество
	{
		if(strIn("+", cMode))
			return tRes("fpkolr");  // Приход
		else if(strIn("#", cMode))
			return tRes("fpkolv");  // Внутренний приход 
		else if(strIn("*", cMode))
			return tRes("fpkolr") + tRes("fpkolv");  // Весь приход
		else if(strIn("-", cMode))
			return tRes("frkolr");  // Расход
		else if(strIn("=", cMode))
			return tRes("frkolv");  // Внутренний расход
		else if(strIn("~", cMode))
			return tRes("frkolr") + tRes("frkolv");  // Весь расход
	}
	else if(strIn("$", cMode) && strIn("U", cMode))  // Сумма по учетным ценам
	{
		if(strIn("+", cMode))
			return tRes("fpsumr");  // Приход
		else if(strIn("#", cMode))
			return tRes("fpsumv");  // Внутренний приход 
		else if(strIn("*", cMode))
			return tRes("fpsumr") + tRes("fpsumv");  // Весь приход
		else if(strIn("-", cMode))
			return tRes("frsumr");  // Расход
		else if(strIn("=", cMode))
			return tRes("frsumv");  // Внутренний расход
		else if(strIn("~", cMode))
			return tRes("frsumr") + tRes("frsumv");  // Весь расход
	}
	else if(strIn("$", cMode) && strIn("S", cMode))  // Сумма по справочным ценам
	{
		if(strIn("+", cMode))
			return tRes("fvpsumr");  // Приход
		else if(strIn("#", cMode))
			return tRes("fvpsumv");  // Внутренний приход 
		else if(strIn("*", cMode))
			return tRes("fvpsumr") + tRes("fpsumv");  // Весь приход
		else if(strIn("-", cMode))
			return tRes("fvrsumr");  // Расход
		else if(strIn("=", cMode))
			return tRes("fvrsumv");  // Внутренний расход
		else if(strIn("~", cMode))
			return tRes("fvrsumr") + tRes("frsumv");  // Весь расход
	}		
}

function ob_mtrf(cMode, dBdate, dEdate)
{
	include("mtr_ost.js");
	
	var oMtrOb = new DpMtrOb();
	
	oMtrOb.date1 = dBDat;
	oMtrOb.date2 = dEDat;

	for(i=3; i<ob_mtrf.arguments.length; i+=2)
	{
		cPar = ob_mtrf.arguments[i].toUpperCase();
		cVal = ob_mtrf.arguments[i+1];
		switch(cPar)
		{
		case "NMK":
			oMtrOb.fnmkl = cVal;
			break;
		case "CENA":
			oMtrOb.fcena = cVal;
			break;
		case "PN1DATE1":
			oMtrOb.pn1_date1 = cVal;
			break;
		case "PN1DATE2":
			oMtrOb.pn1_date2 = cVal;
			break;
		}
	}
	oMtrOb.doCalc();
	oMtrOb.tblName;

	var tRes = OpenTable("s",
		" SELECT "
			+ "  SUM(a.fpkolr) AS fpkolr"
			+ ", SUM(a.fpkolv) AS fpkolv"
			+ ", SUM(a.frkolr) AS frkolr"
			+ ", SUM(a.frkolv) AS frkolv"
			+ ", SUM(a.fpsumr) AS fpsumr"
			+ ", SUM(a.fpsumv) AS fpsumv"
			+ ", SUM(a.frsumr) AS frsumr"
			+ ", SUM(a.frsumv) AS frsumv"
		+ " FROM " + cTblName + " a"
		);
	
	if(strIn("Q", cMode))  // Количество
	{
		if(strIn("+", cMode))
			return tRes("fpkolr");  // Приход
		else if(strIn("#", cMode))
			return tRes("fpkolv");  // Внутренний приход 
		else if(strIn("*", cMode))
			return tRes("fpkolr") + tRes("fpkolv");  // Весь приход
		else if(strIn("-", cMode))
			return tRes("frkolr");  // Расход
		else if(strIn("=", cMode))
			return tRes("frkolv");  // Внутренний расход
		else if(strIn("~", cMode))
			return tRes("frkolr") + tRes("frkolv");  // Весь расход
	}
	else if(strIn("$", cMode) && strIn("U", cMode))  // Сумма по учетным ценам
	{
		if(strIn("+", cMode))
			return tRes("fpsumr");  // Приход
		else if(strIn("#", cMode))
			return tRes("fpsumv");  // Внутренний приход 
		else if(strIn("*", cMode))
			return tRes("fpsumr") + tRes("fpsumv");  // Весь приход
		else if(strIn("-", cMode))
			return tRes("frsumr");  // Расход
		else if(strIn("=", cMode))
			return tRes("frsumv");  // Внутренний расход
		else if(strIn("~", cMode))
			return tRes("frsumr") + tRes("frsumv");  // Весь расход
	}
	else if(strIn("$", cMode) && strIn("S", cMode))  // Сумма по справочным ценам
	{
		if(strIn("+", cMode))
			return tRes("fvpsumr");  // Приход
		else if(strIn("#", cMode))
			return tRes("fvpsumv");  // Внутренний приход 
		else if(strIn("*", cMode))
			return tRes("fvpsumr") + tRes("fpsumv");  // Весь приход
		else if(strIn("-", cMode))
			return tRes("fvrsumr");  // Расход
		else if(strIn("=", cMode))
			return tRes("fvrsumv");  // Внутренний расход
		else if(strIn("~", cMode))
			return tRes("fvrsumr") + tRes("frsumv");  // Весь расход
	}
}

function sl_mtr(cMode, dDate, cNmkl, nCena, nPodr, nMol
		, nSc, nSu, nSt, nA1, nA2, nA3, nPost)
{
	include("mtr_ost.js");
	
	var cTblName;

	with(new DpMtrOb())
	{
		fdate = dDate;
		fnmkl = cNmkl;
		fcena = nCena;
		fpodr = nPodr;
		fmol = nMol;
		fsc = nSc;
		fsu = nSu;
		fst = nSt;
		fpost = nPost;
		doCalc();
		cTblName = tblName;
	}
	
	var tRes = OpenTable("s",
		" SELECT "
			+ "  SUM(a.fost) AS fost"
			+ ", SUM(a.fost1) AS fost1"
			+ ", SUM(a.fostsum) AS fostsum"
			+ ", SUM(a.fostsum1) AS fostsum1"
		+ " FROM " + cTblName + " a"
		);
	
	if(strIn("$", cMode))  // Сумма по учетным ценам
	{
		if(strIn("F", cMode))
			return tRes("fostsum1");  // С учетом счетов-фактур
		else
			return tRes("fostsum");
	}
	else
	{
		if(strIn("F", cMode))
			return tRes("fost1");  // С учетом счетов-фактур
		else
			return tRes("fost");
	}
}

function cenapric(cNCena, cPrice, dDate, cNmkl)
{
	var tPrice = OpenTable("s", 
		"SELECT *"
		+ " FROM " + pName(cPrice, dDate)
		+ " WHERE fnmkl=" + sqlTo(cNmkl)
		);
	
	if(tPrice.isEmpty())
		return 0;

	if(strIn("0", cNCena))
		return tPrice("fcena");
	else if(strIn("1", cNCena))
		return tPrice("fcena1");
	else if(strIn("2", cNCena))
		return tPrice("fcena2");
	else if(strIn("3", cNCena))
		return tPrice("fcena3");
	else if(strIn("4", cNCena))
		return tPrice("fcena4");
	else if(strIn("5", cNCena))
		return tPrice("fcena5");
	else if(strIn("6", cNCena))
		return tPrice("fcena6");
	else if(strIn("7", cNCena))
		return tPrice("fcena7");
	else if(strIn("8", cNCena))
		return tPrice("fcena8");
	else if(strIn("9", cNCena))
		return tPrice("fcena9");
}

// Запись расширений там, где это возможно.         
/* Комментарий передран с ДОС.
*FUNCTION xWrite                                                            *
*   Запись расширений там, где это возможно.                                *
* Записывается одно значение для:текущей записи в справочнике аналитики;    *
*                                текущего документа;                        *
*                                текущей строки документа;                  *
*                                текущей записи в справочнике номенклатуры; *
* MODE - режим записи расширения                                            *
*        "CLCL"     - в справочник аналитики c номером NOP;                 *
*        "CL_NMK"   - в справочник номенклатуры;                            *
*        "HDC"+"??" - в заголовок документа с шаблоном "??" и номером опера-*
*                     ции NOP (где"??"-один из шаблонов "NK","PV","PN"...); *
*        "RDC"+"??" - в строку документа с шаблоном "??" и номером операции *
*                     NOP (где"??"-один из шаблонов "NK","PV","PN"...);     *
* NOP  - номер справочника для справочника аналитики (MODE = "CLCL") или    *
*        номер операции для документа (MODE="HDC"+"??" или MODE="RDC"+"??");*
* LABEL - имя расширения, в которое производим запись;                      *
* ID    - (MODE = "CLCL") код в справочнике аналитики;                      *
*       - (MODE="HDC"+"??") FID документа, в расширение заголовка которого  *
*         записываем значение;                                              *
*       - (MODE="RDC"+"??") FID документа, в расширение строк которого      *
*         записываем значение;                                              *
* VALUE - значение, заносимое в расширение.                                 *
* ***************************************************************************
* ВОЗВРАЩАЕТ КОД ОШИБКИ:                                                    *
* 0  - запись прошла успешно, ошибки отсутствуют;                           *
* 1  - некорректный режим;                                                  *
* 2  - режим не соответствует текущей открытой базе ;
* 11 - некорректный шаблон документа;                                       *
* 21 - некорректный номер операции;                                         *
* 22 - некорректный номер справочника аналитики;                            *
* 31 - некорректное имя расширения;                                         *
* 41 - тип значения несовместим с типом расширения;                         *
* 51 - ошибка записи расширения (расширение не записано)                    *
*****************************************************************************
*/                       
function xwrite(cMode, nPar, cLabel, uValue, uWhere)
{
   var t;

   cMode = cMode.toUpperCase();
   if(cMode=="CLCL")
   {
      t = OpenTable("m",
         "SELECT fwid_cl as fwid"
         + " FROM ^clrelclcl"
         + " WHERE fcl=" + nPar
            + " AND fcod=" + uWhere
         );
      t.ExtTie("CL", nPar);
   }
   else if(cMode=="CL_NMK")
   {
      t = OpenTable("m",
         "SELECT *"
         + " FROM ^cl_nmk"
         + " WHERE fcod=" + sqlTo(uWhere)
         );
      t.ExtTie("CL_NMK");
   }
   else if(cMode.substr(1, 2)=="DC")
   {
      var cHR = cMode.substr(0,1);   //  H или R
      var cDoc = cMode.substr(3,2);
      t = OpenTable("m",
         "SELECT *"
         + " FROM " + docinfo(cHR + "FILE", cDoc)
         + " WHERE fwid=" + sqlTo(uWhere)
         );
      t.ExtTie(cHR, cDoc, nPar);
   }
   else
      return 1;
   if(t.IsEmpty())
      return 51;
   else if(t("#" + cLabel)==null)
      return 31;
   else
      t.setValue("#" + cLabel,uValue);
   
   return 0;
}

function xr1_(cLabel)
{
	var cFwid = this.getVar("RFID_PN");
	
	if(!cFwid)
		return this.getVar("RFNMKL") + " не ведется по приходам";
	
	// Находим строку первого прихода.
	var tAnltk = OpenTable("m", 
		"SELECT *"
		+ " FROM ^anltk"
		+ " WHERE fwid=" + sqlTo(cFwid)
		);
		
	// Находим документ первого прихода
	var tSch_zag = OpenTable("s",
		"SELECT *"
		+ " FROM ^sch_zag"
		+ " WHERE fwid=" + sqlTo(tAnltk("fid_doc"))
		);
	
	// Определяем тип и операцию документа
	var cDoc = tSch_zag("fdoc"),
		nNop = tSch_zag("fnop"),
		dDate = tAnltk("fdate");
		
	tAnltk.ExtTie("R", cDoc, nNop).setDate(dDate);
	
	return tAnltk("#" + cLabel);
}