include("testApi/DpTestCase.js");

var sParPath = new DpFile(getOrgPath()).getParent()+ "/test/";
var tmpTestTbl = "TMP_TESTPAR";
var tblName;
var testStep = 0;
var initFileName = "init.js";
var masEdit = false;

function onLoad()
{
	Caption(ru("Тест", "Тест"), extPar.mode);
	
	tblName = extPar.tbl.getTableName();
	
	FNOM.mask = "####";
	FNOM.value = 1;
	FREPEAT.mask = "######";
	
	setValid(BAUTO, bauto_valid);	
	setWhen(FIGNORE, par_valid);
	if(extPar.testSel!=null && extPar.mode=="EDIT")
	{
		loadMas();
		return;
	}	
	setValid(BONESTEP, bonestep_valid);
	setValid(FNSTEP, fnstep_valid);
	setValid(FNOM, fnom_valid);
	setWhen(FNOM, fnom_valid);
	
	var tTest = getSnap("select FNAME,FPATH from "+ tmpTestTbl, false);
	if(tTest!=null)
		sParPath = tTest[1] +"/"+ tTest[0];
	sParPath = new DpFile(sParPath).getAbsolutePath();	
	if(DIRPAR.value=="")
		DIRPAR.setValue(sParPath);		
	sParPath = new DpFile(DIRPAR.value).getAbsolutePath();	
	DIRPAR.setFilterPath(sParPath);
			
	loadTestPar();
}

function loadTestPar()
{	
	var tbl = extPar.tbl;
	
	FILE.value = "";
	BAUTO.checked = true;
	FIGNORE.value = "";
	FNOM.value = getNextTestNom();
	FINIT.value = "";
	
	fillStepCombo(FNSTEP, getListName());
	BONESTEP.checked = false;
	Disable(FNSTEP);
	
	if(extPar.mode!="EDIT" && extPar.mode!="COPY")
		return;
		
	FILE.value = tbl.getValue("FFILE");
	DIRPAR.value = tbl.getValue("FPATH");
	FIGNORE.value = tbl.getValue("FFIELDS");
	FNOM.value = tbl.getValue("FNOM");
	FREPEAT.value = tbl.getValue("FREPEAT");
	BAUTO.checked = false;
	if(tbl.getValue("FAUTO")==true)
		BAUTO.checked = true;				
		
	var nOneStep = Number(tbl.getValue("FONESTEP"));
	if(nOneStep!=0 && nOneStep!=null)
	{
		BONESTEP.checked = true;
		FNSTEP.setValue(nOneStep);
	}
			
	var sInit = ReadTxtFile(DIRPAR.value+"/"+getInitFileName(), "cp1251");
	if(sInit)
		FINIT.value = sInit;
			
	bonestep_valid();	
	bauto_valid();
	fnom_valid();	
}

function loadMas()
{
	masEdit = true;
	
	Disable(FNOM);
	Disable(BONESTEP);
	Disable(FNSTEP);
	Disable(FINIT);
	Disable(OPTION);
	
	DIRPAR.setFilterPath(extPar.listPath);
	DIRPAR.value = extPar.listPath;
	
	BAUTO.checked = true;	
	setFocus(DIRPAR);
}

function onSave()
{
	if(masEdit)
	{
		masSave(tblName);
		return;
	}
	var m = new Object();
	m.FFILE = FILE.getValue();
	m.FPATH = DIRPAR.getValue();
	m.FNAME = (new DpFile(m.FPATH)).getName();
	m.FAUTO = BAUTO.checked;
	m.FFIELDS = FIGNORE.value;
	m.FREPEAT = FREPEAT.value;
	m.FONESTEP = 0;
	if(BONESTEP.checked)
		m.FONESTEP = new java.lang.Integer(testStep);
	m.FNOM = FNOM.value;
	
	if(extPar.mode!="EDIT")
		m.FWID = GetUID();
	if(!new DpFile(m.FPATH).exists())			
	{
		WAIT(ru("Указан не существующий путь","Вказаний не існуючий шлях"));
		setFocus(DIRPAR);
		return false;
	}
	UpdateTable(tblName, m, extPar.mode!="EDIT");	
	
	saveXmlPar(m);
	saveInitFile();	
}

function masSave(tblName)
{
	var m = new Object();
	var path = DIRPAR.getValue();
	m.FAUTO = BAUTO.checked;
	m.FFIELDS = FIGNORE.value;
	
	var tEdit = OpenTable("m", "select * from "+ tblName 
				+" where "+ extPar.testSel);
	for(tEdit.MoveFirst(); !tEdit.IsEOF(); tEdit.MoveNext())
	{
		var fname = tEdit.getValue("FNAME");
		var newPath = path +"/"+ fname;
		newPath = new DpFile(newPath).getAbsolutePath();
		m.FPATH = newPath;
		
		var fignore = tEdit.getValue("FFIELDS");
		var newIgnore = FIGNORE.value;
		if(newIgnore!=null && newIgnore!="" && fignore!=null && fignore!="")
			newIgnore += ","+ fignore;
		else if(fignore!=null && fignore!="")
			newIgnore = fignore;
		m.FFIELDS = newIgnore;
		m.FFILE = "";
		var sSql = "update "+ tblName 
			+" set FPATH="+ sqlTo(m.FPATH)
				+",FAUTO="+ sqlTo(m.FAUTO)
				+",FFIELDS="+ sqlTo(m.FFIELDS);
		ExecuteSQL(sSql +" where fwid="+ tEdit.getValue("FWID"));
		saveXmlPar(m);				
	}			
}

function saveXmlPar(m)
{
	include ("objects/DpXMLDomDocument.js");	
	var sFile = m.FPATH +"/"+ getParFileName();
	var xmlDom = new DpXMLDOMDocument();
	xmlDom.load(sFile);
	var eTest = xmlDom.getDocumentElement();
		
	saveParam("ignore", m.FFIELDS, eTest, xmlDom);
	saveParam("script", m.FFILE, eTest, xmlDom);
	
	xmlDom.save(sFile);
}

function saveParam(sName, sVal, eTest, xmlDom)
{	
	var ePar = eTest.getElementsByTagName(sName)[0];
	if(ePar!=null)						
		eTest.removeChild(ePar);
	ePar = xmlDom.createElement(sName);	
	ePar.setText(sVal);
	eTest.appendChild(ePar);
}

function bauto_valid()
{
	Disable(FIGNORE);
	if(BAUTO.checked)
		Enable(FIGNORE);
	par_valid();
}

function par_valid()
{
	var sPath = DIRPAR.getValue();
	var file = new DpFile(sPath);
	if(file.exists())
	{
		var sFile = sPath +"/param.txt";
		var sFields = ReadTxtFile(sFile, "cp1251");
		if(sFields!=null && sFields!="" && FIGNORE.value=="")
			FIGNORE.value = sFields;
	}
}

function bonestep_valid()
{	
	testStep = FNSTEP.getValue();
	if(!testStep)
		testStep = 0;
	Disable(FNSTEP);
	if(BONESTEP.checked)
	{
		Enable(FNSTEP);		
	}
	fillStepCombo(FNSTEP, getListName());
	FNSTEP.setValue(testStep);
	fnstep_valid();		
}

function fnstep_valid()
{	
	testStep = FNSTEP.getValue();
	if(!testStep)
		testStep = 0;	 
}

function fnom_valid()
{
	var nom = 1;
	var sName = new DpFile(DIRPAR.value).getName();
	var oTest = getSnap("select FWID, FNOM from "+tblName
				+" where FNAME="+ sqlTo(sName));
	if(oTest!=null)
	{
		nom = oTest[1];
	}
	else
		nom = getNextTestNom();
	if(!FNOM.value || FNOM.value=="" || FNOM.value==0)
	{
		FNOM.value = nom;
	}	
}

function getNextTestNom()
{
	var nom = 1;
	var oSnap = getSnap("select max(FNOM) from "+ tblName);
	if(oSnap)
		nom = Number(oSnap[0])+1;
	return nom;
}

function getInitFileName()
{
	return initFileName;
}

function saveInitFile()
{
	var sFile = DIRPAR.getValue() +"/"+ getInitFileName();
	var sText = FINIT.value;
	lpProxy.writeToFile(sText, sFile, "cp1251");
}

function getList()
{
	return getTestList(getListName());
}

function getListName()
{
	return getTestDir() +"steplist.xml";
}

function getTestDir()
{
	return DIRPAR.getValue() +"/";
}

include("sys/DpBaseDlg.js");