include ("objects/DpXMLDomDocument.js");
include("testApi/tests/TestDialog.js");
include("testApi/DpTestSuite.js");
include("testApi/DpTestCase.js");

var sParPath = new DpFile(getOrgPath()).getParent()+ "/test/";
var tmpListTbl = "TMP_TESTLIST";
var tmpTestTbl = "TMP_TESTPAR";
var tmpResTbl = "TMP_TEST_TBL";
var sListName = sParPath +"/list1.xml";
var initFileName = "init.js";
var testStep = 0;
var bShowMsg = false;
var nKolErr = 0;
var nKolScrErr = 0;
var nKolSqlErr = 0;
var nKolTblErr = 0;
var tList;

function onLoad()
{
	Caption(ru("Тесты", "Тести"));
	lpProxy.closeTest();
		
	var tTest = getSnap("select FNAME,FPATH,FLIST from "+ tmpTestTbl, false);
	if(tTest!=null)
	{
		sParPath = tTest[1];
		sListName = sParPath +"/list1.xml";
		if(tTest[2]!=null && tTest[2]!="")
			sListName = tTest[2];	
	}	
	sParPath = new DpFile(sParPath).getAbsolutePath();
	sListName = new DpFile(sListName).getAbsolutePath();				
	LISTFILE.setValue(sListName);
	
	setValid(LISTFILE, listName_valid);	
			
	setButton(btnLoad, loadMainList);
	setButton(btnRun, runTestList);
	setButton(btnExit, onEscape);
	
	loadMainList();	
}

function runTestList()
{		
	if(BMSG.checked)
		bShowMsg = true;
	
	var nTest = 0;
	var sWhere = "";

	var sTestSel = grid.getSqlSelected();
	if(grid.getSelectedCount()!=0)
		sWhere = " WHERE "+ sTestSel;
	
	CloseWindow();

	ExecuteSQL("DROP TABLE "+ tmpResTbl, false);
	createTestTbl(tmpResTbl);	
	var listTbl = OpenTable("s", "select * from "+tmpListTbl+ sWhere +" order by Fnom");
	for(listTbl.MoveFirst(); !listTbl.isEOF(); listTbl.MoveNext())
	{
		if(lpProxy.isTest() && lpProxy.getTest().isStop())
		{
			listTbl.close();	
			return;
		}
		var nRepeat = listTbl.getValue("FREPEAT");
		if(!nRepeat || Number(nRepeat)==0)
			nRepeat = 1;
		nRepeat = Number(nRepeat);
		for(var n=0; n<nRepeat; n++)	
		{
			trace("\n<<<<<<<<<<<<< REPEAT - "+ (n+1) +"/"+ nRepeat +" >>>>>>>>>>>>>>")			
			if(!runTest(listTbl))
				return;
		}
		nTest++;
	}
	listTbl.close();
		
	showResults(nTest);
}

function showResults(testKol)
{
	if(!testKol)
		testKol = 1;
	
	getItog(testKol);
	
	var par = new Object();
	showWindow("l_testresults.js", SW_NOMODAL, par);
}

function runTest(listTbl)
{	
	var testName = listTbl.getValue("FNAME");
	var sFile = listTbl.getValue("FFILE");
	var sPath = listTbl.getValue("FPATH");
	var sFlds = listTbl.getValue("FFIELDS");
	var bAuto = false;
	if(listTbl.getValue("FAUTO")==true)
		bAuto = true;
	var nStep = Number(listTbl.getValue("FONESTEP"));			
		
	var testClass = null;	
	var isTestDlg = false;	

	var testParDir = new DpFile(sPath);
	var testPath = testParDir.getParent();
	if(!new DpFile(sPath).exists())
		testPath = new DpFile(sListName).getParent();
					
	if(!sFile)
		sFile = "";
	var classFile = new DpFile(sFile);
	if(classFile.exists())
	{		
		sName = classFile.getName();
		sClassFile = sFile.substring(sFile.indexOf("testApi"));		
		sName = sName.substr(0, sName.length()-3);
		include(sClassFile);
		testClass = eval(sName);
	}
	else
	{
		//include("testApi/tests/TestDialog.js");
		testClass = TestDialog;	
		isTestDlg = true;	
	}			
	
	var par = new Object();	
	par.testClass = testClass;	
	par.name = testName;
	par.fields = sFlds;	
	
	var test = lpProxy.createTest(testName, false, testPath);
	test.setTestTitle();
	test.setAuto(bAuto);
	test.setDlgMode(isTestDlg);
	if(nStep!=0)
		test.setOneStep(nStep);	
	if(bShowMsg)
		test.showMsg();

	if(isTestDlg)
	{
		var sys = test.getPar(sPath +"/"+ getParFileName(), "system");
		if(sys)
			setSys(sys);
		
		var initFile = sPath +"/"+ initFileName;
		if((new DpFile(initFile)).exists())
			include(initFile);
		
		if(!lpProxy.isTest())				
			return false;
	}
	
	//showWindow("l_testresults.js", SW_NOMODAL, par);
	par.fnom = listTbl.getValue("FNOM");
	run(par);
		
	lpProxy.closeTest();
	
	return true;
}

function run(oPar)
{
	var tblOut = tmpResTbl +"_"+ getTmpTableName();
	//include("testApi\\DpTestSuite.js");
	var testSuite = new DpTestSuite(oPar.testClass)
	ignoreFields(oPar.fields);
	testSuite.run(oPar.name);
	oPar.testSuite = testSuite;
	oPar.tblOut = tblOut;
	
	getResults(oPar);
	
	var sFld = "ftype, fitog, fname, ftxt, ftid, fnom";
	var sSql = "INSERT INTO "+ tmpResTbl +"("+ sFld +") "
			+" SELECT "+ sFld +" FROM "+ tblOut;	
	ExecuteSQL(sSql);
	ExecuteSQL("DROP TABLE "+ tblOut, false);		
}

function createTestTbl(tblName)
{
	var sSQL = " CREATE TABLE " + tblName + "("
		+ "  fwid " + SqlType("COUNTER")
		+ ", ftype " + SqlType("INT")
		+ ", fitog " + SqlType("INT")
		+ ", fname " + SqlType("TEXT",254)
		+ ", ftxt " + SqlType("MEMO")
		+ ", ftid " + SqlType("INT")
		+ ", fnom " + SqlType("INT")
		+ ") " ;
	ExecuteSQL(sSQL);
}

function getItog(testKol)
{	
	//ExecuteSQL("update "+ tmpResTbl +" set fwid=ftid where ftid<>0");
		
	var m = new Object();
	m.fnom = 0;
	m.ftid = 0;
	m.ftype = 10;
	m.fitog = 2;
	m.fname = ru("Тестов: ","Тестів: ");
	m.ftxt = String(testKol);	
	updateTable(tmpResTbl, m, true);
	
	m = new Object();
	m.fnom = 0;
	m.ftid = 0;
	m.ftype = 11;
	m.fitog = 2;
	m.fname = ru("Ошибок: ","Помилок: ");
	m.ftxt = String(nKolErr);	
	updateTable(tmpResTbl, m, true);
	
	m = new Object();
	m.fnom = 0;
	m.ftid = 0;
	m.ftype = 13;
	//if(nKolScrErr!=0)
	//	m.ftype = 1;
	m.fitog = 2;
	m.fname = ru("  программных: ","  програмних: ");
	m.ftxt = String(nKolScrErr);	
	updateTable(tmpResTbl, m, true);
		
	m = new Object();
	m.fnom = 0;
	m.ftid = 0;
	m.ftype = 14;
	//if(nKolSqlErr!=0)
	//	m.ftype = 2;
	m.fitog = 2;
	m.fname = ru("  в SQL-запросах: ","  у SQL-запросах: ");
	m.ftxt = String(nKolSqlErr);	
	updateTable(tmpResTbl, m, true);
		
	m = new Object();
	m.fnom = 0;
	m.ftid = 0;
	m.ftype = 15;
	m.fitog = 2;
	m.fname = ru("  в таблицах: ","  у таблицях: ");
	m.ftxt = String(nKolTblErr);	
	updateTable(tmpResTbl, m, true);	
}

function getResults(par)
{
	var testSuite = par.testSuite;
	var tblOut = par.tblOut;
	var testName = par.name;
	var testNom = par.fnom;
	
	var testres = testSuite.getTestResult();	
	//DropTable(tblOut);
	createTestTbl(tblOut);	 

	var nRuns = testres.getRuns()
	
	var kolTestScrErr = 0;
	var kolTestSqlErr = 0;
	var kolTestTblErr = 0;	
		
	var debTest = lpProxy.getTest();	
	debTest.getSqlError();
	var arrErr = debTest.getErrors();
	var func = arrErr.keySet().toArray();
	var err = arrErr.values().toArray();	
	var sError;
	var sType;
	
	for (var i = 0; i < func.length; i++)
	{		
		sType = "";
		sError = err[i];
		if(sError.length>250)
			sError = sError.substring(0, 250);
		sFunc = func[i];

		if(sFunc.indexOf(">")!=-1)
			sFunc = sFunc.substring(0, sFunc.indexOf(">")-1);
	
		if(sError.indexOf("JSEngine")!=-1)
		{
			sType = ru("ошибка в скрипте ","помилка у скрипті ");
			//sError = sError.substr(11);
			kolTestScrErr++;
		}
		if(sError.indexOf("DBManager")!=-1)
		{
			//sType = sError.substr(0, 9);
			sType = ru("ошибка в запросе","помилка у запросі");
			//sError = sError.substr(11);
			kolTestSqlErr++;
		}
		if(sError.indexOf("DBTester")!=-1)
		{
			//sType = sError.substr(0, sError.indexOf(":"));
			var sTblName = sError.substring(sError.indexOf(":")+2, sError.indexOf(">"));
			sType = ru("ошибка в таблице ","помилка у таблиці ")+ sTblName;
			sError = sError.substr(sError.indexOf(">")+1);
			if(sError.indexOf("DpFileNotFoundException")!=-1)
			{
				sType = ru("не найден эталон для ","не знайдено еталон для ")+ sTblName;
				sError = sError.substr(sError.indexOf(":")+1);
			}
			kolTestTblErr++;
		}		
		if(sError.indexOf("save")!=-1)
		{
			sType = ru("сохранение","збереження");
			sError = sError.substr(6);
		}
		testres.arrErrors[testres.arrErrors.length] = new DpResultError(sFunc, sType, sError);
	}
	
	var arrErrors = testres.getErrors();
	var testId = GetUID();
	var m = new Object();
	//m.fwid = testId;
	m.fnom = testNom;
	m.ftid = 0;
	m.ftype = 12;	
	m.fitog = 1;
	if(kolTestScrErr!=0 || kolTestSqlErr!=0)
		m.fitog = 3;
	m.fname = String(testName);
	var sComment = String(arrErrors.length);
	if(kolTestScrErr!=0)
		sComment += "       "+ ru("программные: ","програмні: ")+ kolTestScrErr;
	if(kolTestSqlErr!=0)
		sComment += "       SQL: "+ kolTestSqlErr;
	if(kolTestTblErr!=0)
		sComment += "       "+ ru("в таблицах: ","у таблицях: ")+ kolTestTblErr;		
	m.ftxt = sComment;	
	updateTable(tblOut, m, true);
	ExecuteSQL("update "+ tblOut +" set fwid="+ testId);
		
	nKolErr += arrErrors.length;
	nKolScrErr += kolTestScrErr;
	nKolSqlErr += kolTestSqlErr;
	nKolTblErr += kolTestTblErr;
	
	for (var i = 0; i < arrErrors.length; i++)
	{
		var m = new Object();
		m.fnom = testNom;
		m.ftid = testId;
		m.ftype = 3;
		m.fitog = 0;
		m.fname = "  "+ arrErrors[i].sTestClass + " - " + arrErrors[i].sTestFunc;
		sError = arrErrors[i].sMsg;

		if(sError.indexOf("JSEngine")!=-1)
		{
			m.ftype = 1;
			sError = sError.substr(11);
		}
		if(sError.indexOf("DBManager")!=-1)
		{
			m.ftype = 2;
			sError = sError.substr(11);	
		}
		m.ftxt = sError;
		updateTable(tblOut, m, true);
	}
}

function loadGrid()
{	
	grid.DeletePages();
	grid.FieldEx("FNOM","№", 4);
	grid.FieldEx("FNAME","Назва|Название", 15);
	grid.FieldEx("FAUTO","Тест.табл.|Тест.табл.", 8);
	grid.FieldEx("=^FONESTEP==0? '' : ^FONESTEP","Крок №|Шаг №", 8);
	//grid.FieldEx("FFIELDS","Виключити|Исключить", 15);	
	grid.FieldEx("FPATH","Шлях|Путь", 15);	
		
	tList = OpenTable("s", "select * from "+tmpListTbl+" order by Fnom");
	grid.setTable(tList);
	grid.build();
	
	this.listMenuInit = listMenuInit;
	this.listMenuRun = listMenuRun;
	grid.loadMenuHandler(this,"listMenuInit");
	grid.selectMenuHandler(this,"listMenuRun");
}

function listMenuInit(oGrid)
{	
	if(grid.getTable().isEmpty())
	{
		grid.AddMenuItem("ADD", "Додати|Добавить");
		return;
	}	
	if(IsDblClick())
	{
		listMenuRun("EDIT");
		return true;
	}		
	grid.AddMenuItem("RUN", "Запустити|Запустить");
	grid.AddMenuItem("ADD", "Додати|Добавить");
	grid.AddMenuItem("EDIT", "Редагувати|Редактировать");
	grid.AddMenuItem("DEL", "Вилучити|Удалить");
}

function listMenuRun(sMenuID)
{
	var tbl = grid.getTable();
	if(sMenuID=="ADD" || sMenuID=="EDIT" || sMenuID=="COPY")
	{
		var par = new Object();
		par.mode = sMenuID;
		par.tbl = tbl;
		par.fwid = tbl.getRowID();
		var sTestSel = grid.getSqlSelected();
		if(grid.getSelectedCount()>1 && sMenuID=="EDIT")
		{
			par.testSel = sTestSel;
			par.listPath = new DpFile(sListName).getParent();
		}
		showWindow("testApi/e_test.xml", SW_MODAL, par);
		if(par.escape)
			return;
		tbl.requery();
		grid.refresh();		
		saveListXml();
	}
	if(sMenuID=="DEL")
	{
		var nGridPos = grid.getRowSelected();
		ExecuteSQL("delete from "+tmpListTbl+" where "+grid.sqlSelected());		
		tbl.requery();		
		tbl.setAbsolute(nGridPos-1);
		grid.refresh();		
		saveListXml();
	}
	if(sMenuID=="RUN")
	{
		if(BMSG.checked)
			bShowMsg = true;
		var sWhere = " where "+ grid.sqlSelected();		
		CloseWindow();
		ExecuteSQL("DROP TABLE "+ tmpResTbl, false);
		createTestTbl(tmpResTbl);
		var listTbl = OpenTable("s", "select * from "+tmpListTbl
						+ sWhere
						+" order by Fnom");		
		var bRet = runTest(listTbl);
		listTbl.close();
		if(bRet)
			showResults(1);
	}
}

function loadMainList()
{		
	sListName = LISTFILE.value;
	if(!ExecuteSQL("UPDATE "+tmpTestTbl+" SET FLIST="+ sqlTo(sListName), false))
	{
		ExecuteSQL("DROP TABLE "+ tmpTestTbl, false);
		ExecuteSQL("CREATE TABLE "+ tmpTestTbl 
			+" (FNAME "+ SqlType("TEXT", 250)
			+", FPATH "+ SqlType("TEXT", 250)
			+", FLIST "+ SqlType("TEXT", 250) +")", false);
		ExecuteSQL("INSERT INTO "+ tmpTestTbl +" (FNAME, FPATH, FLIST) "
			+" VALUES ("+ sqlTo("") +", "+ sqlTo("") +", "+ sqlTo(sListName) +")", false);
	}
	if(tList)
		tList.close();
	ExecuteSQL("DROP TABLE "+tmpListTbl, false);	
	var sSql = "CREATE TABLE "+ tmpListTbl 
			+" (FFILE "+ SqlType("TEXT", 250)
			+", FPATH "+ SqlType("LONGTEXT")
			+", FNAME "+ SqlType("TEXT", 250)
			+", FAUTO "+ SqlType("BIT")
			+", FFIELDS "+ SqlType("TEXT", 250)			
			+", FONESTEP "+ SqlType("INT")
			+", FREPEAT "+ SqlType("INT")
			+", FNOM "+ SqlType("INT") 
			+", FWID "+ SqlType("COUNTER") +")";	
	ExecuteSQL(sSql, false);
	ExecuteSQL("DELETE FROM "+ tmpListTbl, false);

	var listName = LISTFILE.getValue();		
	var mainList = getTestList(listName);
	if(!mainList)
	{
		loadGrid();
		return;
	}	
	for(var nTest=0; nTest<mainList.length; nTest++)
	{
		oTest = mainList[nTest];
		var sPath = oTest.getAttribute("path");
		var sName = new DpFile(sPath).getName();
		var nOneStep = oTest.getAttribute("step");
		var bAuto = false;
		if(oTest.getAttribute("auto")=="true")
			bAuto = true;		
		var nRept = oTest.getAttribute("repeat");
		if(!nRept)
			nRept = 0;
		
		var eTestPar = loadXmlTest(sPath +"/"+ getParFileName());
		var sFile = getParam(eTestPar, "script");
		if(!sFile)
			sFile = "";
		var sFlds = getParam(eTestPar, "ignore");
		if(!sFlds)
			sFlds = "";					
		sPath = (new DpFile(sPath)).getAbsolutePath();		
		sSql = "INSERT INTO "+ tmpListTbl 
			+" (FFILE,FPATH,FAUTO,FFIELDS,FNAME,FONESTEP,FREPEAT,FNOM,FWID)"
				+" VALUES ("+ sqlTo(sFile) +","+ sqlTo(sPath) 
					+","+ sqlTo(bAuto) +","+ sqlTo(sFlds) 
					+","+ sqlTo(sName) +","+ nOneStep +","+ nRept 
					+","+ (Number(nTest)+1) +", "+ GetUID() +")"
		ExecuteSQL(sSql, false);
	}	
	loadGrid();	
	grid.getTable().requery();
	grid.refresh();		
}

function getParam(eTest, sName)
{
	if(!eTest || !eTest.getElementsByTagName(sName))
		return null;
	var ePar = eTest.getElementsByTagName(sName)[0];
	if(!ePar)
		return null;
	return ePar.getText();	
}

function saveListXml()
{			
	var xmlDom = new DpXMLDOMDocument();
	var xmlList;
	var xmlTest;
	
	var listName = LISTFILE.getValue();		
	var listFile = new DpFile(listName);	
	if(listFile.exists())
		deleteFile(listName);				
	/*
	sParPath = listFile.getParent();
	var fPar = new DpFile(sParPath)
	if(!fPar.isDirectory())
		fPar.mkdirs();
	*/
	xmlList = xmlDom.createElement("List");
	xmlDom.appendChild(xmlList);
	var listTbl = grid.getTable();

	for(listTbl.MoveFirst(); !listTbl.isEOF(); listTbl.MoveNext())
	{
		var sName = listTbl.getValue("FNAME");
		var sPath = listTbl.getValue("FPATH");
		var bAuto = false;
		if(listTbl.getValue("FAUTO")==true)
			bAuto = true;
		var nStep = listTbl.getValue("FONESTEP");
		var nRept = listTbl.getValue("FREPEAT");
		
		xmlTest = xmlDom.createElement(sName);			
		xmlTest.setAttribute("path", String(sPath));
		xmlTest.setAttribute("auto", String(bAuto));
		xmlTest.setAttribute("step", String(nStep));
		xmlTest.setAttribute("repeat", String(nRept));
		
		xmlList.appendChild(xmlTest);		
	}
	xmlDom.save(listFile);
}

function onEscape()
{
	grid.getTable().close();
	lpProxy.closeTest();
	CloseWindow();
}

function listName_valid()
{
	if(LISTFILE.value=="" || !LISTFILE.value)
	{
		WAIT(ru("Введите имя списка","Введіть ім'я списку"));
		setFocus(LISTFILE);
		return false;		
	}
}

function setSys(newSys)
{
	if(String(lpProxy.getOrgManager().getSys())==String(newSys))
		return;
	lpProxy.getOrgManager().setSys(newSys);
	lpProxy.getTest().setTestTitle();
}

function ignoreFields(sFlds)
{
	if(!sFlds)
		return;
	var fName = "";
	var fList = sFlds.split(",");
	for(var i=0; i<fList.length; i++)
	{
		fName = (fList[i]).trim();
		lpProxy.getTest().ignoreField(fName);
	}
}

include("sys/DpBaseDlg.js");