include("testApi/DpTestCase.js");

var sParPath = new DpFile(getOrgPath()).getParent()+ "/test/";
var tmpTestTbl = "TMP_TESTPAR";
var testStep = 1;

function onLoad()
{
	lpProxy.closeTest();
	Caption(ru("Тест: запись","Тест: запис"));
	
	var sListName = sParPath +"/list1.xml"
	var t = getSnap("select FNAME,FPATH,FLIST from "+ tmpTestTbl, false);
	if(t!=null)
	{		
		FNAME.value = t[0];
		sParPath = t[1];
		sListName = t[1] +"/list1.xml";
		if(t[2]!=null && t[2]!="")
			sListName = t[2];
	}		
	
	sParPath = new DpFile(sParPath).getAbsolutePath();	
	sListName = new DpFile(sListName).getAbsolutePath();
	FLIST.value = sListName;
	DIRPAR.value = sParPath;	
	DIRPAR.setFilterPath(sParPath);
	
	setValid(BADD, badd_valid);
	//setValid(BREWRT, brewrt_valid);
	//setValid(FNSTEP, fnstep_valid);
	setValid(FNAME, fname_valid);
	setValid(DIRPAR, fpath_valid);
	//setWhen(FNAME, setContAssist);
	//setContAssist();
	
	BADD.checked = true;
			
	fname_valid();
	fpath_valid();
	//brewrt_valid();	
	badd_valid();		
}

function onSave()
{
	fpath_valid();
	var sPath = DIRPAR.getValue();	
	var file = new DpFile(sPath);
	if(!file.exists() || !file.isDirectory())
		createDirectory(sPath);
	sPath = file.getAbsolutePath();
	var testName = FNAME.value;
	
	DropTable(tmpTestTbl);	
	ExecuteSQL("CREATE TABLE "+ tmpTestTbl 
			+" (FNAME "+ SqlType("TEXT", 250)
			+", FPATH "+ SqlType("TEXT", 250)
			+", FLIST "+ SqlType("TEXT", 250) +")");
	ExecuteSQL("INSERT INTO "+ tmpTestTbl +" (FNAME, FPATH, FLIST) "
			+" VALUES ("+ sqlTo(testName) +", "+ sqlTo(sPath) +", "+ sqlTo(FLIST.value) +")");
	
	var sTestDir = sPath +"/"+ testName;
	if(BREWRT.checked)
		deleteDir(sTestDir);
				
	var test = createTest(testName, true, sPath);
	test.setStep(getMaxStep()+1);
	//if(BREWRT.checked)
	//	test.setStep(testStep, true);
	
	if(BADD.checked)
		saveList();
	
	CloseWindow();
	return false;
}

function saveList()
{
	var testName = FNAME.value;
	var listFile = FLIST.value;
	if(!listFile)
		listFile = DIRPAR.getValue() +"/list.xml"; 
	
	include ("objects/DpXMLDomDocument.js");
	var eTest;
	var xmlList;
	var xmlDom = new DpXMLDOMDocument();
	if((new DpFile(listFile)).exists())
	{
		xmlDom.load(listFile);
		xmlList = xmlDom.getDocumentElement();
		if(xmlList.getElementsByTagName(testName))
			eTest = xmlList.getElementsByTagName(testName)[0];
	}
	else
	{
		xmlList = xmlDom.createElement("List");	
		xmlDom.appendChild(xmlList);	
	}
	if(eTest)
		return;
	
	var sPath = DIRPAR.getValue() +"/"+ testName;
	sPath = new DpFile(sPath).getAbsolutePath();
	eTest = xmlDom.createElement(testName);
	eTest.setAttribute("path", String(sPath));
	eTest.setAttribute("auto", "true");
	eTest.setAttribute("step", "0");		
	xmlList.appendChild(eTest);	
	xmlDom.save(listFile);
}

function fname_valid()
{
	var sName = FNAME.value;
	if(sName=="")
		sName = "test1";
	sName = sName.replace(" ", "_");	
	sName = sName.replace(":", "_");
	FNAME.value = sName;
	//brewrt_valid();
}

function fpath_valid()
{	
	var sPath = DIRPAR.value;
	if(sPath=="")
		sPath = sParPath;	
	DIRPAR.setValue(sPath);
}

function badd_valid()
{
	Disable(FLIST);
	if(BADD.checked)
		Enable(FLIST);	
}

function brewrt_valid()
{	
	testStep = FNSTEP.getValue();
	if(!testStep)
		testStep = 1;
	Disable(FNSTEP);
	if(BREWRT.checked)
	{
		Enable(FNSTEP);		
	}
	fillStepCombo(FNSTEP, getListName());
	FNSTEP.setValue(testStep);
	fnstep_valid();		
}

function fnstep_valid()
{	
	testStep = FNSTEP.getValue();
	if(!testStep)
		testStep = 1;
}

function getList()
{		
	return getTestList(getListName());	
}

function getListName()
{	
	return getTestDir() +"steplist.xml";
}

function getTestDir()
{
	var sPath = DIRPAR.getValue();	
	var sName = FNAME.value;
	return sPath +"/"+ sName +"/";
}

function createTest(sName, bStep, sPath)
{
	if(!sName) 
		sName = "";
	if(!bStep) 
		bStep = false;
	if(!sPath) 
		sPath = "";
	var test = lpProxy.createTest(sName, true, sPath);			
	test.setBStep(bStep);
	
	var sys = lpProxy.getOrgManager().getSys();
	if(sys && sys!="")
		test.getXmlBuilder().saveParam("system", sys);
	
	loadIgnore();
	
	return test;
}

function loadIgnore()
{
	addIgnoreDlg("runTest.xml");
	addIgnoreDlg("writeTest.xml");
	addIgnoreDlg("stopTest.xml");
	
	addIgnoreDlg("getdatr.xml");
	addIgnoreDlg("i_allprk.xml");
	addIgnoreDlg("i_amall.xml");
	addIgnoreDlg("i_amallp.xml");
	addIgnoreDlg("i_amind.xml");
	addIgnoreDlg("i_aminds.xml");
	addIgnoreDlg("i_filter.xml");
	addIgnoreDlg("i_perem.xml");
	addIgnoreDlg("i_pns150.xml");
	addIgnoreDlg("i_trgazdog.xml");
	addIgnoreDlg("e_vssAsk.xml");	
	
	//addIgnoreDlg("l_docekz.xml");	
}

function setContAssist()
{	
	this.fillContAssist = fillContAssist;
	this.contAssistHandler = contAssistHandler;
    FNAME.setContentAssistHandler(this,	"fillContAssist", "contAssistHandler");
}

function contAssistHandler(sName)
{
	FNAME.value = sName;
}

function fillContAssist(ca)
{		
	var sPath = DIRPAR.getValue();
	var testDir = new DpFile(sPath);
	if(!testDir.exists() || !testDir.isDirectory())
		return;
		
	var files = testDir.listFiles();
	for(i=0; i<files.length; i++)
	{
		var testDir = files[i];							
		if(!testDir.isDirectory() || testDir.isHidden())
			continue;		
		var parFile = testDir.getAbsolutePath() +"/param.xml";	
		if(!(new DpFile(parFile)).exists())
			continue;	
		var testName = testDir.getName();		
		ca.addItem(testName, testName);	
	}	
}

include("sys/DpBaseDlg.js");