include("objects\\DpGetDat.js");
include("objects\\DpTVars.js");
include("sys/udfs.js");

var gd, d1, d2, d, de;
var h, tbl, tv;

function onLoad()
{
	Caption(UR("Аналіз обігів|Анализ оборотов"));
	setButton(btnOPG, calcOPG);	//К-т общей прибыльности по годам
	setButton(btnPG, calcPG);	//К-т прибыльности по годам
	setButton(btnRM, calcRM);	//К-т рентабельности помесячно
	setButton(btnRG, calcRG);	//К-т рентабельности по годам
	setButton(btnFN, calcFN);	//К-т финансовой независимости
	setButton(btnAL, calcAL);	//К-т абсолютной ликвидности
	setButton(btnPL, calcPL);	//К-т промежуточной ликвидности
	setButton(btnOL, calcOL);	//Обобщающий к-т ликвидности (к-т покрытия)
	setButton(btnDPK, calcDPK);	//К-т долгосрочного привлечения капитала
}

function init()
{
	// создать объект для запроса дат и , если нужно, счета
	gd = new DpGetDat("dD");
	if(gd.escape)
		return false;
	d1 = new Date(gd.dat1);
	d2 = new Date(gd.dat2);
	//создадим таблицу которую будем выводить в Excel документ
	DropTable("TMP_OPG");
	ExecuteSQL("CREATE TABLE TMP_OPG(Fyear "+SqlType("TEXT")
					+", Fkoef "+SqlType("DOUBLE")
					+", Fpr "+SqlType("MONEY")
					+", Fob "+SqlType("MONEY")+")");
	return true;
}

function showXlsDoc(prnPat, title, h1, h2, h3, h4)//вывод документа
{
	tv = new DpTVars("LIST",prnPat);
	tbl = OpenTable("s","TMP_OPG");
	tv.setRTbl(tbl);
	h = new Object();
	h.FYEAR = h1;
	h.FKOEF = h2;
	h.FPR = h3;
	h.FOB = h4;
	tv.setHTbl(h);
	tv.setVar("text",title);
	tv.print();
	tbl.close();
}

function calcOPG()//obsch_pr.js CVS
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (d<new Date(firstDay(new Date(d2.getFullYear()+1,0,1)))) ; i++)
	{
		obTotal = ob_("K", d, de, 0, 0, 70);
		prTotal = sl_("K", de, 0, 44);// прибыль
		m.Fyear	= String(d.getFullYear());
		if ( obTotal !=0)
			m.Fkoef = (prTotal/obTotal);
		else
			m.Fkoef = 0;
		m.Fpr = prTotal;
		m.Fob = obTotal;
		d = new Date(firstDay(new Date(d.getFullYear()+1,0,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т загальної прибутковості по роках|К-т общей прибыльности по годам",
			"Діапазон|Диапазон", "К-т загальної прибутковості|К-т общей прибыльности",
			"Прибуток|Прибыль", "Сума реалізації|Сумма реализации");
}

function calcPG()//obsch_Zpr.js CVS
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (d<new Date(firstDay(new Date(d2.getFullYear()+1,0,1)))) ; i++)
	{
		obTotal = ob_("K", d, de ,0,0,70);
		prTotal = sl_("K", de, 0, 44) - sl_("D", de, 0, 44);	//прибыль-убыток 
		m.Fyear	= String(d.getFullYear());
		if (obTotal!=0)
			m.Fkoef = (prTotal/obTotal);
		else
			m.Fkoef = 0;
		m.Fpr = prTotal;
		m.Fob = obTotal;
		d = new Date(firstDay(new Date(d.getFullYear()+1,0,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т прибутковості по роках|К-т прибыльности по годам",
			"Діапазон|Диапазон", "К-т прибутковості|К-т прибыльности",
			"Прибуток-збиток|Прибыль-убыток", "Сума реалізації|Сумма реализации");
}

function calcRM()//obsch_Rent.js CVS
{
	if(!init())
		return false;
	d = new Date(firstDay(d1));
	var m = new Object();
	for(var i=1; d<=d2; i++)
	{
		obTotal = ob_("D", d, new Date(lastDay(d)),0,23,0)
			  +ob_("D", d, new Date(lastDay(d)),0,90)
			  +ob_("D", d, new Date(lastDay(d)),0,91)
			  +ob_("D", d, new Date(lastDay(d)),0,92)
			  +ob_("D", d, new Date(lastDay(d)),0,93)
			  +ob_("D", d, new Date(lastDay(d)),0,94);

		slTotal	= ob_("K", d, new Date(lastDay(d)),0,0,79)
				-ob_("D", d, new Date(lastDay(d)),0,79,0) ;	//прибыль-убыток

		m.Fyear	= tmonth(d, "mt")+", "+d.getFullYear();
		if ( obTotal !=0)
			m.Fkoef = (slTotal/obTotal)*100;
		else
			m.Fkoef = 0;
		m.Fpr = slTotal;
		m.Fob = obTotal;
		d = new Date(goMonth(d, 1));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т рентабельності щомісячно|К-т рентабельности помесячно",
			"Діапазон|Диапазон", "К-т рентабельності|К-т рентабельности",
			"Прибуток|Прибыль", "Собівартість|Себестоимость");
}

function calcRG()//ob_reng.js CVS
{
	if(!init())
		return false;
	var d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	var de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (d<new Date(firstDay(new Date(d2.getFullYear()+1,0,1)))) ; i++)
	{
		obTotal = ob_("D", d, de ,0,23,0)
			  +ob_("D", d, de ,0,90)
			  +ob_("D", d, de ,0,91)
			  +ob_("D", d, de ,0,92)
			  +ob_("D", d, de ,0,93)
			  +ob_("D", d, de ,0,94);
		slTotal = sl_("K", de, 0, 44)
					- sl_("D", de, 0, 44);	//прибыль-убыток
		m.Fyear	= String(d.getFullYear());
		if ( obTotal !=0)
			m.Fkoef = (slTotal/obTotal)*100;
		else
			m.Fkoef = 0;
		m.Fpr = slTotal;
		m.Fob = obTotal;
		d = new Date(firstDay(new Date(d.getFullYear()+1,0,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т рентабельності по роках|К-т рентабельности по годам",
			"Діапазон|Диапазон", "К-т рентабельності|К-т рентабельности",
			"Прибуток|Прибыль", "Собівартість|Себестоимость");
}

function calcFN()//obsch_Kav.js CVS
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (de<new Date(lastDay(new Date(d2.getFullYear()+1,11,1)))); i++)
	{
		akTotal = sl_("D",de,0,10,0,0,0,0,0)+sl_("D",de,0,11,0,0,0,0,0)+
					sl_("D",de,0,12,0,0,0,0,0)-sl_("K",de,0,13,0,0,0,0,0)+
					sl_("D",de,0,14,0,0,0,0,0)+sl_("D",de,0,15,0,0,0,0,0)+
					sl_("D",de,0,16,0,0,0,0,0)+sl_("D",de,0,17,0,0,0,0,0)+
					sl_("D",de,0,18,0,0,0,0,0)+sl_("D",de,0,19,0,0,0,0,0)+
					sl_("D",de,0,20,0,0,0,0,0)+sl_("D",de,0,22,0,0,0,0,0)+
					sl_("D",de,0,23,0,0,0,0,0)+sl_("D",de,0,24,0,0,0,0,0)+
					sl_("D",de,0,25,0,0,0,0,0)+sl_("D",de,0,26,0,0,0,0,0)+
					sl_("D",de,0,27,0,0,0,0,0)+sl_("D",de,0,28,0,0,0,0,0)+
					sl_("D",de,0,29,0,0,0,0,0)+sl_("D",de,0,30,0,0,0,0,0)+
					sl_("D",de,0,31,0,0,0,0,0)+sl_("D",de,0,33,0,0,0,0,0)+
					sl_("D",de,0,34,0,0,0,0,0)+sl_("D",de,0,35,0,0,0,0,0)+
					sl_("D",de,0,36,0,0,0,0,0)+sl_("D",de,0,37,0,0,0,0,0)+
					sl_("D",de,0,38,0,0,0,0,0)+sl_("D",de,0,39,0,0,0,0,0)+
					sl_("D",de,0,63,0,0,0,0,0)+sl_("D",de,0,64,0,0,0,0,0)+
					sl_("D",de,0,65,0,0,0,0,0)+sl_("D",de,0,32,0,0,0,0,0)+
					sl_("D",de,0,68,0,0,0,0,0);
		psTotal = sl_("K",de,0,40,0,0,0,0,0)+sl_("K",de,0,42,0,0,0,0,0)+
		          sl_("K",de,0,43,0,0,0,0,0)+sl_("K",de,0,44,0,0,0,0,0)+
		          sl_("K",de,0,45,0,0,0,0,0)+sl_("K",de,0,46,0,0,0,0,0)+
		          sl_("K",de,0,47,0,0,0,0,0)+sl_("K",de,0,48,0,0,0,0,0);
		m.Fyear = String(de.getFullYear());
		if ( akTotal !=0)
			m.Fkoef = (psTotal/akTotal);
		else
			m.Fkoef = 0;
		m.Fpr = akTotal;
		m.Fob = psTotal;
		de = new Date(lastDay(new Date(de.getFullYear()+1,11,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т фінансової незалежності|К-т финансовой независимости",
			"Діапазон|Диапазон", "К-т фін.незалежн.|К-т фин.независ.",
			"Сума активів|Сумма активов", "Власний капітал|Собств.капитал");
}

function calcAL()//obsch_klia.js CVS
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; d<=d2; i++)
	{
		chTotal = sl_("D", new Date(lastDay(d)) ,0,30)+sl_("D", new Date(lastDay(d)) ,0,31)+
                          sl_("D", new Date(lastDay(d)) ,0,32)+sl_("D", new Date(lastDay(d)) ,0,33)+
                          sl_("D", new Date(lastDay(d)) ,0,34)+sl_("D", new Date(lastDay(d)) ,0,35)
		znTotal = sl_("K", new Date(lastDay(d)) ,0,60)+sl_("K", new Date(lastDay(d)), 0,62)+
                          sl_("K", new Date(lastDay(d)) ,0,63)+sl_("K", new Date(lastDay(d)), 0,64)+
                          sl_("K", new Date(lastDay(d)) ,0,65)+sl_("K", new Date(lastDay(d)), 0,66)+
                          sl_("K", new Date(lastDay(d)) ,0,67)+sl_("K", new Date(lastDay(d)), 0,68)
		m.Fyear = tmonth(d, "mt") + ", " + d.getFullYear();
		if ( znTotal !=0)
			m.Fkoef = (chTotal/znTotal);
		else
			m.Fkoef = 0;
		m.Fpr = chTotal;
		m.Fob = znTotal;
		d = new Date(goMonth(d, 1));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т абсолютної ліквідності|К-т абсолютной ликвидности",
			"Діапазон|Диапазон", "К-т абсол.ліквідн.|К-т абсол.ликвидн.",
			"Грош.засоби+пот.фін.інвест.|Ден.ср-ва+тек.фин.инвест.", "Поточні зобов-ня|Текущ.обяз-ва");
}

function calcPL()//obsch_klip.js CVS
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; d<=d2; i++)
	{
		chTotal = sl_("D", new Date(lastDay(d)) ,0,30,0)+sl_("D", new Date(lastDay(d)) ,0,31,0)+
                          sl_("D", new Date(lastDay(d)) ,0,32,0)+sl_("D", new Date(lastDay(d)) ,0,33,0)+
                          sl_("D", new Date(lastDay(d)) ,0,34,0)+sl_("D", new Date(lastDay(d)) ,0,35,0)+
                          sl_("D", new Date(lastDay(d)) ,0,36,0)+sl_("D", new Date(lastDay(d)) ,0,37,0)+
                          sl_("D", new Date(lastDay(d)) ,0,63,0)+sl_("D", new Date(lastDay(d)) ,0,68,0)

		znTotal = sl_("K", new Date(lastDay(d)) ,0,60)+sl_("K", new Date(lastDay(d)), 0,62)+
                          sl_("K", new Date(lastDay(d)) ,0,63)+sl_("K", new Date(lastDay(d)), 0,64)+
                          sl_("K", new Date(lastDay(d)) ,0,65)+sl_("K", new Date(lastDay(d)), 0,66)+
                          sl_("K", new Date(lastDay(d)) ,0,67)+sl_("K", new Date(lastDay(d)), 0,68)

		m.Fyear	= tmonth(d, "mt") + ", " + d.getFullYear();
		if ( znTotal !=0)
			m.Fkoef = (chTotal/znTotal);
		else
			m.Fkoef = 0;
		m.Fpr = chTotal;
		m.Fob = znTotal;
		d = new Date(goMonth(d, 1));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т проміжної ліквідності|К-т промежуточной ликвидности",
			"Діапазон|Диапазон", "К-т проміжн.ліквідн.|К-т промежут.ликвидн.",
			"Грош.засоби+пот.фін.інвест.+дебіт.заборг.|Ден.ср-ва+тек.фин.инвест.+дебит.задолж.",
			"Поточні зобов-ня|Текущ.обяз-ва");
}

function calcOL()//obsch_kliu.js CVS
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; d<=d2; i++)
	{
		chTotal = sl_("D", new Date(lastDay(d)),0,20,0)+sl_("D", new Date(lastDay(d)),0,22,0)+
                          sl_("D", new Date(lastDay(d)),0,23,0)+sl_("D", new Date(lastDay(d)),0,24,0)+
                          sl_("D", new Date(lastDay(d)),0,25,0)+sl_("D", new Date(lastDay(d)),0,26,0)+
                          sl_("D", new Date(lastDay(d)),0,27,0)+sl_("D", new Date(lastDay(d)),0,28,0)+
                          sl_("D", new Date(lastDay(d)),0,29,0)+sl_("D", new Date(lastDay(d)),0,30,0)+
                          sl_("D", new Date(lastDay(d)),0,31,0)+sl_("D", new Date(lastDay(d)),0,33,0)+
                          sl_("D", new Date(lastDay(d)),0,34,0)+sl_("D", new Date(lastDay(d)),0,35,0)+
                          sl_("D", new Date(lastDay(d)),0,36,0)+sl_("D", new Date(lastDay(d)),0,37,0)+
                          sl_("D", new Date(lastDay(d)),0,38,0)+sl_("D", new Date(lastDay(d)),0,39,0)+
                          sl_("D", new Date(lastDay(d)),0,63,0)+sl_("D", new Date(lastDay(d)),0,64,0)+
                          sl_("D", new Date(lastDay(d)),0,65,0)+sl_("D", new Date(lastDay(d)),0,32,0)+
                          sl_("D", new Date(lastDay(d)),0,68,0)

		znTotal = sl_("K", new Date(lastDay(d)) ,0,60)+sl_("K", new Date(lastDay(d)), 0,62)+
                          sl_("K", new Date(lastDay(d)) ,0,63)+sl_("K", new Date(lastDay(d)), 0,64)+
                          sl_("K", new Date(lastDay(d)) ,0,65)+sl_("K", new Date(lastDay(d)), 0,66)+
                          sl_("K", new Date(lastDay(d)) ,0,67)+sl_("K", new Date(lastDay(d)), 0,68)
		m.Fyear	= tmonth(d, "mt") + ", " + d.getFullYear();
		if ( znTotal !=0)
			m.Fkoef = (chTotal/znTotal);
		else
			m.Fkoef = 0;
		m.Fpr = chTotal;
		m.Fob = znTotal;
		d = new Date(goMonth(d, 1));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "Узагальнюючий к-т ліквідності (к-т покриття)|Обобщающий к-т ликвидности (к-т покрытия)",
			"Діапазон|Диапазон", "Узагальн.к-т ліквідн.|Обобщ.к-т ликвидн.",
			"Поточні активи|Текущие активы", "Поточні зобов-ня|Текущ.обяз-ва");
}

function calcDPK()//obsch_Klis.js CVS
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; d<=d2; i++)
	{
		chTotal = sl_("K", new Date(lastDay(d)),0,50)+sl_("K", new Date(lastDay(d)),0,51)+
                          sl_("K", new Date(lastDay(d)),0,52)+sl_("K", new Date(lastDay(d)),0,53)+
                          sl_("K", new Date(lastDay(d)),0,54)+sl_("K", new Date(lastDay(d)),0,55);
		znTotal = sl_("K", new Date(lastDay(d)) ,0,40)+sl_("K", new Date(lastDay(d)), 0,41)+
                          sl_("K", new Date(lastDay(d)) ,0,42)+sl_("K", new Date(lastDay(d)), 0,43)+
                          sl_("K", new Date(lastDay(d)) ,0,44)-sl_("D", new Date(lastDay(d)), 0,44)-
                          sl_("K", new Date(lastDay(d)) ,0,45)-sl_("K", new Date(lastDay(d)), 0,46)+
                          sl_("K", new Date(lastDay(d)) ,0,47)-sl_("D", new Date(lastDay(d)), 0,47)+
                          sl_("K", new Date(lastDay(d)) ,0,48)-sl_("D", new Date(lastDay(d)), 0,48)+
                          sl_("K", new Date(lastDay(d)) ,0,49);
		m.Fyear	= tmonth(d, "mt") + ", " + d.getFullYear();
		if ( znTotal !=0)
			m.Fkoef = (chTotal/znTotal);
		else
			m.Fkoef = 0;
		m.Fpr = chTotal;
		m.Fob = znTotal;
		d = new Date(goMonth(d, 1));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т довгострокового залучення капіталу|К-т долгосрочного привлечения капитала",
			"Діапазон|Диапазон", "К-т довгостр.залуч.капіт.|К-т долгоср.привл.капит.",
			"Довгостр.залуч.засоби|Долгоср.привл.средства", "Власний капітал+забеспеч.+довгостр.зобов-ня|Собств.капитал+обеспеч.+долгоср.обяз-ва");
}
include("sys\\DpBaseDlg.js");