// Ф-ции для работы с документом VD "Ведомость"

//константы
var VDTYPE_PR		= 2;	// (+)	К выплате (начисленная ЗП)
var VDTYPE_NACH	= 4;	// (#)	Начисления, к-е войдут в ЗП текущего м-ца 
var VDTYPE_CASSA	= 5;	// (=)	Текущая касса (выплаты в межрасчетный период) 

// Для калькуляций (dpEval приводит имена ф-ций к нижнему регистру):
vdto = vdTo;

include("servis/date.js");
include("sys/docinfo.js");
include("sys/udfs.js");

function vdfrom(dat, vopl, vidprk, lsfid, fwid_wp, tabn_id, svzpName, calcname)
{	
	var calcnm = allt(calcname).toUpperCase()

	//даты
	var bDat = firstDay(dat);
	var eDat = lastDay(dat);
	var sWhTabn = (typeof(tabn_id) != "undefined" && !isEmpty(tabn_id)
						? " AND FCOD IN(SELECT RL.FCOD"
						+" FROM ^CLRELCLCL RL"
						+" WHERE RL.FCL = "+sqlTo(getPar("CODPERS"))
							+" AND RL.FWID_CL IN("+tabn_id+"))"
						: "");
	//анализируем документы по отдельным расчетам
	var numCalc = 0;
	if(svzpName)
	{
		numCalc = Number(svzpName.toUpperCase().replace("SVZP",""));
		if(isNaN(numCalc))
		{
			msg = ru("Не удалось определить код отедльного расчета!"
					,"Не вдалося визначити код окремого розрахунку!");
			writeToLog(msg, "e", vopl, vidprk, lsfid);
			return;
		}
	}
	include("doc/DpDoc.js");
	var arNop = new Array();//массив номеров операций по нашему расчету numCalc
	var t = OpenTable("select distinct Fnop from ^hvd")
	for(; !t.IsEOF(); t.MoveNext())
	{
		var oDoc = new DpDoc("VD",Number(t.getValue("Fnop")));
		var numPrivatCalc = Number(oDoc.getPar("_privatCalc"));
		if(numCalc == numPrivatCalc)
			arNop[arNop.length] = Number(t.getValue("Fnop"));
	}
	t.close();
    // eugene 04.12.2012 Вязать строки с заголовком нельзя, т.к. используются калькуляции
    // в документах CR, NK записывающие строки ТОЛЬКО в RVD
	//07.12.12 Яна. У дилеров нельзя связывать строки с заголовком, а у Олега для БЦ водоканала
	//без этого условия перестают работать больничные, которые рассчитываются отдельно. Чтобы
	//отсечь наш случай, сделала реакцию на название отдельного расчета больничных в справочнике
	//отдельных расчетов. Сделала, чтобы при обновлении БЦ не посыпались расчеты и не нужно было бы
	//переделывать настройку зарплаты.
	if (calcnm=="ЛІКАРНЯНІ" || calcnm=="ЛIКАРНЯНI" || calcnm=="БОЛЬНИЧНЫЕ"){    
		if(arNop.length>0)
		sWhTabn += " and exists(select * from ^HVD as h where h.Fnop in ("+arNop+") and h.Fwid=^RVD.Fid_doc)";
	}
	//sWhTabn += " AND FCOD > 0 "
	// Удалим "мусор" из ^RVD
	vdCheckDoc();
   
	// Отберем записи из ^RVD за расчетный месяц
	//для текущей кассы и начислений
   strSQL="SELECT * FROM ^RVD"
			+" WHERE 1=1"
				+" AND FDATE >= "+sqlTo(bDat)
				+" AND FDATE <= "+ sqlTo(eDat)
				+" AND FRTYPE IN("+sqlTo(VDTYPE_NACH)+","+sqlTo(VDTYPE_CASSA)+")"
				// При неполном пересчете таб. номера сотрудников нах.в CHNGTN
				+ ( poln_rasch ? "" : " AND FCOD IN( SELECT FTABN FROM ^CHNGTN)" )
				+sWhTabn
			+" ORDER BY"
				+" FCOD"
				+", FLSFID";
	var table = OpenTable(strSQL);
	
   if(table.IsEmpty()) 
	{   
		table.close();
		return;
	}

	var szName, tblOut;
	szName = (svzpName?svzpName:"svzp")+month_txt(dat);
   
   // Проверяем существует ли у нас таблица "svzp" + szName, если нет, то создаем ее
   // по шаблону "svzp"
   tblOut = "ZRP_" + szName
   if(!IsTableEx("ZRP_RES", tblOut)) 
   {
      CreateTableEx("ZRP_RES", tblOut, "SVZP", "*")
   }

   var tbl_lic = OpenTable("SELECT  * FROM ^LIC_FLD WHERE FIS_SLCT = "+sqlTrue)
   if (tbl_lic.IsEmpty())
   { 
		msg = ru("Нет списка полей ЛС. Проверьте настройку"
					,"Список полів ОР пустий. Перевірте налаштування.");
		
		writeToLog(msg, "e", vopl, vidprk, lsfid);
		return;
   }
  
	var fld = Array(999);
	var fld_num = Array(999);
	for(var i = 0; i<999; i++)
	{
		fld[i]=" ";
		fld_num[i]=0;
	}
 
	for( ; !tbl_lic.IsEOF(); tbl_lic.MoveNext())
	{
		if (!isEmpty(tbl_lic.getValue("FID")))
		{
			fld[tbl_lic.getValue("FID")] = tbl_lic.getValue("FIS6");
			fld_num[tbl_lic.getValue("FID")] = tbl_lic.getValue("FFLD_NUM");
		}
	}
   tbl_lic.close();

   var mFsht_id;
   include("Objects/DpShtat.js");
   var oShtat = new DpShtat("" , bDat, eDat);
	// Проходим по таблице table и пишем из нее строки в svzp
	for( ; !table.IsEOF(); table.MoveNext()) 
	{
		// Код записи штатного расписания (нужен только для начислений)
		// Если в штатном расписании нет человека с таким таб.номером, 
		// то оставляем mFsht_id = 0
		mFwid_wp = 0;
		mFtabn_id = 0;
		//if( fld[table.getValue("FLSFID")] == "+")
		if (calcnm=="ЛІКАРНЯНІ" || calcnm=="ЛIКАРНЯНI" || calcnm=="БОЛЬНИЧНЫЕ"){
			if( fld[table.getValue("FLSFID")] == "+")
			{
				oShtat.setEmployeCod(table.getValue("FCOD"));
				oShtat.arrCtrls = new Array();
				oShtat.arrCtrls["fcod"] = new Object(this.value = 0)
				oShtat.arrCtrls["fcod"].value = table.getValue("FCOD");
				if(oShtat.validCod())
				{
					mFwid_wp = oShtat.getFwid();
				}
				else
				{
					msg = ru("Для таб.№"+table.getValue("FCOD")+" нету записи в штатном расписании."
								, "Для таб.№"+table.getValue("FCOD")+" нема запису в штатному розкладі.");
					writeToLog(msg, "w", vopl, vidprk, lsfid);
					continue;
				}
			}
		}else{		
			if( !inList(fld[table.getValue("FLSFID")], "-","н","у","ф","з","п","б") )		
			{
				/*
				oShtat.setEmployeCod(table.getValue("FCOD"));
				oShtat.arrCtrls = new Array();
				oShtat.arrCtrls["fcod"] = new Object(this.value = 0)
				oShtat.arrCtrls["fcod"].value = table.getValue("FCOD");
			
				if(oShtat.validCod())
				{
					mFwid_wp = oShtat.getFwid();
				}
				else
				{
					msg = ru("Для таб.№"+table.getValue("FCOD")+" нет записи в штатном расписании."
							, "Для таб.№"+table.getValue("FCOD")+" нема запису в штатному розкладі.");
					writeToLog(msg, "w", vopl, vidprk, lsfid);
					continue;
				}
				 */
				mFwid_wp = toScrObj(table.getValue("FWID_WP"));
			}
		}
		
		var strSQL = "SELECT FWID_CL"
						+" FROM ^CLRELCLCL"
						+" WHERE 1=1"
							+" AND FCL = " + sqlTo(getPar("CODPERS"))			
							+" AND FCOD = " + sqlTo(table.getValue("FCOD"))			
		var sn = getSnap(strSQL);
		if(sn != null && !isEmpty(sn[0]))
		{
			mFtabn_id = sn[0];
			sn = null;
		}
		else
		{
			//сюда не должны попадать 
			msg = ru("В справочнике персонала не найден таб.№"
					, "В довіднику персоналу не знайдено таб.№")+table.getValue("FCOD");
			writeToLog(msg, "e", vopl, vidprk, lsfid);
			continue;
		}
		
		//Запись в svzp
		var m = {};
		m.FTABN_ID = mFtabn_id;
		m.FWID_WP = mFwid_wp;
		m.FSHPZ = table.getValue("FSHPZ");
		m.FSUM = table.getValue("FSUM");
		m.FFLD_NUM = fld_num[table.getValue("FLSFID")];
		m.FVID_PRK = vidprk;
		m.FLSFID = table.getValue("FLSFID");
		m.FDAY = table.getValue("FDAY");
		m.FCHAS = table.getValue("FHOUR");
		m.FBDY = bDat.getDate();
		m.FEDY = eDat.getDate();
		m.FMN = d00;
		m.FVP = 0;
		m.FID_PRK = table.getValue("FID_DOC");
		updateTable("^"+szName, m, true);
	}
	table.close();
}


function vdCheckDoc(mFtabn)
{
	// Проверяем только строки из документов, отличных от "VD"
	// (ведомость сама удаляет строки)
	strSQL = "SELECT * FROM ^RVD"
				+" WHERE 1=1"
					+" AND FID_DOC IS NOT NULL"
					+" AND FDOC <> "+sqlTo("VD")
					+sqlw0And("FCOD = ", mFtabn)
	var t = OpenTable(strSQL);

	if(t.IsEmpty()) 
	{
		t.Close(5652)
		t = null;
		return true;
	}
	
	for(; !t.IsEOF(); t.MoveNext() ) 
	{
		mFdoc = t.getValue("FDOC");
		
		//если это документ идем дальше 
		if(docinfo("ISDOC", mFdoc)) 
		{
			strSQL = "SELECT FWID" 
						+" FROM "+docinfo("HFILE", mFdoc)
						+" WHERE 1=1"
							+" AND FDOC = "+sqlTo(mFdoc)
							+" AND FWID = "+sqlTo(t.getValue("FID_DOC"))
			var sn = getSnap(strSQL);
			
			if(sn != null && !isEmpty(sn[0]))
			{
				//запись в таблице заголовка имеется 
				//значит идем дальше 
				sn = null;
				continue;
			}
			else
			{
				//если не нашли у строки запись в таблице заголовке то удалим ее
				t.Delete();
			}
		}
	}
 
	t.Close(5652);
	t = null;
	return true;
}

//Олег 
//перенес функцию из Дебета 2000, будет ли она использоватся, не знаю 
function r_vdto(dat, vvopl, mvvdpl, mvvcslid, vvprk, dat_base, svzpName)
{

	if(differ(dat, dat_base) != 0)
	{
		//Если месяц не базовый то выходим
		return;
	}

	// даты 
	var bDat = firstDay(dat);
	var eDat = lastDay(dat);
   
	// Удалим результаты предыдущего расчета
	var strSQL = "DELETE FROM ^RVD"
					+" WHERE 1=1"
						+" AND FRTYPE = '"+sqlTo(VDTYPE_PR)
						+" AND FDATE = "+sqlTo(eDat)
						// При неполном пересчете таб. номера сотрудников нах.в CHNGTN
						+ (poln_rasch ? "" : " AND FCOD IN(SELECT FTABN FROM ^CHNGTN)")
	ExecuteSQL(strSQL);

	var szName, tblOut;
	szName = (svzpName?svzpName:"svzp")+month_txt(dat);
   
   // Проверяем существует ли у нас таблица "svzp" + szName, если нет, то создаем ее
   // по шаблону "svzp"
   tblOut = "ZRP_" + szName
   if(!IsTableEx("ZRP_RES", tblOut)) 
   {
      CreateTableEx("ZRP_RES", tblOut, "SVZP", "*");
   }

	// Отберем из svzp нужные нам записи
	var strSQL = "SELECT * FROM ^"+szName
					+" WHERE 1=1"
						+" AND FLSFID = "+sqlTo(mvvcslid)
						// При неполном пересчете таб. номера сотрудников нах.в CHNGTN
						+ ( poln_rasch ? "" : " AND FTABN IN( SELECT FTABN FROM ^CHNGTN)" )
					+" ORDER BY"
						+" FTABN_ID"
	var tbl = OpenTable(strSQL);
   
	// Добавляем строки в ^RVD
	if(!tbl.IsEmpty())
	{
		for(; !tbl.IsEOF(); tbl.MoveNext())
		{
			var m = {};
				m.FCOD = tbl.getValue("FTABN");
				m.FDATE = eDat;
				m.FRTYPE = VDTYPE_PR;
				m.FSUM = tbl.getValue("FSUM");
				m.FLSFID = tbl.getValue("FLSFID");
				m.FFLD_NUM = tbl.getValue("FFLD_NUM");
				m.FSHPZ = tbl.getValue("FSHPZ");
				m.FDAY = tbl.getValue("FDAY");
			updateTable("^RVD", m, true);
		}
	}
	tbl.Close(5652);
	tbl = null;
}

function vdTo(mFdoc, mFid_doc, mFdate, mFsum, mFtabn, mFrtype, mFlsfid)
{
	// Удалим из ^RVD строку, созданную ранее 
	// (На таб.номер не смотрим, т.к. могли при редактировании его изменить)
	var sn = getSnap("SELECT FWID FROM ^RVD WHERE FDOC = "+sqlTo(mFdoc)+" AND FID_DOC = "+sqlTo(mFid_doc));
	if(sn != null && !isEmpty(sn[0]))
	{
		ExecuteSQL("DELETE FROM ^RVD WHERE FWID = "+sqlTo(sn[0]));
		sn = null;
	}

	//пишем в RVD 
	//Только если сумма не нулевая
	if(mFsum != 0)
	{
		var m = {};
			m.FDOC =  mFdoc;
			m.FID_DOC =  mFid_doc;
			m.FDATE =  mFdate;
			m.FSUM =  mFsum;
			m.FCOD =  mFtabn;
			m.FRTYPE =  mFrtype;
			m.FLSFID =  mFlsfid;
			m.FWID =  GetUID();
		updateTable("^RVD", m, true);
   }
   
   return 0;
}