// JScript source code
include("sys/mask.js");
include("gridedit.js");
include("Objects/DpXMLDomDocument.js")

var tblFields;

function wizardInit()
{
	Caption("Создание справочника аналитики")		
	
}

function wizardPageCreated()
{
	//FCOD.mask = "#####";	
	
	page1.setDescription("")
	page2.setDescription("Имя таблицы, где будет хранится данные по аналитике")

	SYS.value = "COM";

	tblFields = createObjectTable();
	tblFields.setIdFld("FWID");
	
	grid.setTable(tblFields)
	grid._build();
	
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.init = addRecord;

}

function addRecord()
{
	this.initValue("FWID", GetUID());
	this.initValue("FIELD", "");
	this.initValue("TEXT", "");
	this.initValue("DATATYPE", "");
	this.initValue("DBTYPE", "");
	this.initValue("WIDTH", 10);
}

function wizardCanFinish()
{
	if (!String(TABLENAME.value) || TABLENAME.value=="cl_")
	{
		TABLENAME.value = "cl_" + CLTYPE.value;
	}
	
	
	var module = String(MODULE.value);

	if (module!="" && !getModulePath(module))
	{
		alert("Модуль " + module + " не найден");
		return false;
	}
	
	return true;
}

function onFinish()
{
	var module = String(MODULE.value);

	var dir = module? getModulePath(module) + "/": rootDirectoryEx();
	
	
	var tblName = String(TABLENAME.value).toUpperCase();
	var clType = String(CLTYPE.value);
	var name = String(NAME.value)
	var sys = String(SYS.value)
	
	//--------------------------------------------
	// Создание файла dbstru
	var xmlDbStru = new DpXMLDOMDocument();
	
	var tagStru = xmlDbStru.createChild("STRU");
	var tagTables = tagStru.createChild("TABLES");
	
	tagTables.createChild("table", NAME.value
			, {path: "all_mdb",  pattern: tblName, sys: sys, table: tblName}
		)
		
	var tagPatterns = tagStru.createChild("PATTERNS");
	var tagPattern = tagPatterns.createChild(tblName.toUpperCase());
	var tagFields = tagPattern.createChild("FIELDS");
	
	for (tblFields.MoveFirst(); !tblFields.IsEOF(); tblFields.MoveNext())
	{
		var field = "F" + tblFields.getValue("FIELD").toUpperCase(); 
		var tagField = tagFields.createChild(field, tblFields.getValue("TEXT"), {type: tblFields.getValue("DBTYPE")})
	}
	tagFields.createChild("FWID_CL", null, {type: "cid"});
	
	var tagIndexes = tagPattern.createChild("INDEXES");
	tagIndexes.createChild("INDEX", null, {field: "FWID_CL", name:"FWID_CL" });
	
	//alert(dir + "dbstru/" + tblName + ".xml")
	xmlDbStru.save(dir + "dbstru/" + tblName + ".xml")

	// Модификация структур этого файла
	lpProxy.reloadDBStru();
	
	include ("Objects/DpDbMod.js");
	var dbMod =  new DpDbMod();
	
	var TI = new tableModInfo();
	TI.num = 1;
	TI.base = "all_mdb";
	TI.sys = sys;
	TI.table = tblName;
	TI.pattern = tblName;
	TI.fullName = sys + "_" + tblName;
	TI.exists = IsTableEx(TI.base, TI.fullName);
	TI.domod = true;
	TI.reindex = true;
	
	dbMod.dropViews();
	dbMod.modTable(TI);
	dbMod.createViews();
	 
	
	//--------------------------------------------
	// Создание файла class.xml
	var xmlClass = new DpXMLDOMDocument();
	var xmlDpCl = xmlClass.createChild("DpCL", null, {type: clType, name: name, sys: sys});
	
	xmlDpCl.createChild("Parents").createChild("parent", null, {classid: "cls.CL1"});
	
	var xmlHeader = xmlDpCl.createChild("Header");
	for (tblFields.MoveFirst(); !tblFields.IsEOF(); tblFields.MoveNext())
	{
		var varName = "H" + tblFields.getValue("FIELD").toUpperCase(); 
		xmlHeader.createChild("var", tblFields.getValue("TEXT"), {name: varName, datatype: tblFields.getValue("DATATYPE")});
	}
	
	createDirectory(dir + "scripts/cls/" + clType);
	xmlClass.save(dir + "scripts/cls/" + clType + "/class.xml");

	//--------------------------------------------
	// Создание файла list.xml
	var xmlList = new DpXMLDOMDocument();
	var tagList = xmlList.createChild("list");
	var tagGrid = tagList.createChild("grid");
	
	tagGrid.createChild("field", null, {field: "FCOD", text: "Код", width: 6})
	tagGrid.createChild("field", null, {field: "FTXT", text: "Назва|Название", width: 20})
	
	for (tblFields.MoveFirst(); !tblFields.IsEOF(); tblFields.MoveNext())
	{
		tagGrid.createChild("field", null, 
			{field: clType+".F" + tblFields.getValue("FIELD").toUpperCase()
					, text: tblFields.getValue("TEXT")
					, width: Number(tblFields.getValue("WIDTH"))
				}
			);
	}
	xmlList.save(dir + "scripts/cls/" + clType + "/list.xml");
	
	//--------------------------------------------
	// Создание файла list.js
	sListJs = ""
		+ '\nfunction clAfterLoad()'
		+ '\n{'
		+ '\n\tthis.addTies = clAddTies;'
		+ '\n}'
		
		
		+ '\nfunction clAddTies()'
		+ '\n{'
		+ '\n\tthis.subTie("' + tblName + '", "' + clType + '", "FWID_CL", "FWID");'
		+ '\n}'
		;
	lpProxy.writeToFile(sListJs
			,dir + "scripts/cls/" + clType + "/list.js"
			,"cp1251"
			);
	
	//--------------------------------------------
	// Создание файла dbmapping.xml
	var xmlMapping = new DpXMLDOMDocument();
	var tagDpCl = xmlMapping.createChild("DpCL", null, {type: "CLPACK"});
	var tagHeader = tagDpCl.createChild("Header");
	
	var tagTables = tagHeader.createChild("Tables");
	tagTables.createChild("table", null, {name: "CL"});
	tagTables.createChild("table", null, {name: "CLRELCLCL", ID: "FWID_CL"});
	tagTables.createChild("table", null, {name: tblName, ID: "FWID_CL"});
	
	var tagFields = tagHeader.createChild("Fields");
	tagFields.createChild("field", null, {name: "FWID", table: "CL", 'var': "ID"});
	tagFields.createChild("field", null, {name: "FTXT", table: "CL", 'var': "HTXT"});
	
	tagFields.createChild("field", null, {name: "FCOD", table: "CLRELCLCL", 'var': "HCOD"})
	tagFields.createChild("field", null, {name: "FCL", table: "CLRELCLCL", 'var': "HCL"})
	tagFields.createChild("field", null, {name: "FWID_CL", table: "CLRELCLCL", 'var': "ID"})
	
	tagFields.createChild("field", null, {name: "FWID_CL", table: tblName, 'var': "ID"})
	
	for (tblFields.MoveFirst(); !tblFields.IsEOF(); tblFields.MoveNext())
	{
		fieldID = tblFields.getValue("FIELD").toUpperCase()
		tagFields.createChild("field", null, {name: "F" + fieldID, table: tblName, 'var': "H" + fieldID})
	}	
	
	xmlMapping.save(dir + "scripts/cls/" + clType + "/dbmapping.xml");

	//--------------------------------------------
	// Создание файла form.xml
	var xmlForm = new DpXMLDOMDocument();
	tagForm = xmlForm.createChild("Form");
	tagControls = tagForm.createChild("Controls", null, {col: "2"});
	
	tagControls.createChild("Label", null, {text: "Код:"});
	tagControls.createChild("TextField", null, {ID: "FCOD", width: "80"});
	
	tagControls.createChild("Label", null, {text: "Назва:|Название:"});
	tagControls.createChild("TextField", null, {ID: "FTXT", align: "fill"});
	
	for (tblFields.MoveFirst(); !tblFields.IsEOF(); tblFields.MoveNext())
	{
		fieldID = tblFields.getValue("FIELD").toUpperCase()
		tagControls.createChild("Label", null, {text: tblFields.getValue("TEXT")});
		tagControls.createChild("TextField", null, {ID: fieldID, width: "300"});
	}
	tagScript = tagForm.createChild("script", null, {src: "form.js"});
	xmlForm.save(dir + "scripts/cls/" + clType + "/form.xml");
	
	//--------------------------------------------
	// Создание файла form.js
	sFormJs = "";
	
	
	sFormJs += ""
		+ "var ctrlLinker;"
		+ "\nvar objCl = extPar.dpObj;"
		+ "\n"
		+ "\nfunction onLoad()"
		+ "\n{"
		+ '\n\tFCOD.setMask("########");'
		+ '\n'
		+ "\n\tctrlLinker = new DpCtrlLinker(objCl);"
		+ '\n\tctrlLinker.addLink("HCOD", FCOD);'
		+ '\n\tctrlLinker.addLink("HTXT", FTXT);'
		+ '\n'
		
	for (tblFields.MoveFirst(); !tblFields.IsEOF(); tblFields.MoveNext())
	{
		fieldID = tblFields.getValue("FIELD").toUpperCase()
		sFormJs += '\n\tctrlLinker.addLink("H' + fieldID + '", ' + fieldID + ');'
		
		if (tblFields.getValue("DATATYPE") == "number")
		{
			sFormJs += '\n\t' + fieldID + '.mask="' + strRepl("#", Number(tblFields.getValue("WIDTH"))) + '";';
		}
	}
		
	sFormJs += ""
		+ "\n\tctrlLinker.toControls();"
		+ "\n}"
		+ "\n";
	
	sFormJs +=
		"\nfunction onSave()"
		+ "\n{"
		+ '\n\tctrlLinker.toVars();'
		+ "\n}"
		+ "\n";

	sFormJs +=
		'\n'
		+ '\ninclude("sys/DpBaseDlg.js")';
	
	lpProxy.writeToFile(sFormJs
		,dir + "scripts/cls/" + clType + "/form.js"
		,"cp1251"
		);
}